import 'package:json_annotation/json_annotation.dart';
import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';

import 'package:chopper/chopper.dart';
import 'package:chopper/chopper.dart' as chopper;
import 'home.enums.swagger.dart' as enums;
export 'home.enums.swagger.dart';

part 'home.swagger.chopper.dart';
part 'home.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class Home extends ChopperService {
  static Home create([ChopperClient? client]) {
    if (client != null) {
      return _$Home(client);
    }

    final newClient = ChopperClient(
      services: [_$Home()],
      converter: JsonSerializableConverter(), /*baseUrl: YOUR_BASE_URL*/
    );
    return _$Home(newClient);
  }

  ///
  @Post(path: '/address/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      addressBrowsePost({@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/address/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      addressExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/address')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAddressAddressLogic>>
      addressGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/address')
  Future<chopper.Response<WebApiModulesHomeControlsAddressAddress>> addressPost(
      {@Body() required WebApiModulesHomeControlsAddressAddress? body});

  ///
  ///@param id
  @Get(path: '/address/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsAddressAddress>>
      addressIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/address/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsAddressAddress>>
      addressIdPut(
          {@Path('id') required String? id,
          @Body() required WebApiModulesHomeControlsAddressAddress? body});

  ///
  ///@param id
  @Delete(path: '/address/{id}')
  Future<chopper.Response<bool>> addressIdDelete(
      {@Path('id') required String? id});

  ///Get an empty object
  @Get(path: '/address/emptyobject')
  Future<chopper.Response> addressEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/address/emptybrowseobject')
  Future<chopper.Response> addressEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/address/keyfieldnames')
  Future<chopper.Response> addressKeyfieldnamesGet();

  ///
  @Post(path: '/alternativedescription/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      alternativedescriptionBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/alternativedescription/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      alternativedescriptionExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/alternativedescription')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAlternativeDescriptionAlternativeDescriptionLogic>>
      alternativedescriptionGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/alternativedescription')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsAlternativeDescriptionAlternativeDescription>>
      alternativedescriptionPost(
          {@Body()
              required WebApiModulesHomeControlsAlternativeDescriptionAlternativeDescription?
                  body});

  ///
  ///@param id
  @Get(path: '/alternativedescription/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsAlternativeDescriptionAlternativeDescription>>
      alternativedescriptionIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/alternativedescription/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsAlternativeDescriptionAlternativeDescription>>
      alternativedescriptionIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsAlternativeDescriptionAlternativeDescription?
                  body});

  ///
  ///@param id
  @Delete(path: '/alternativedescription/{id}')
  Future<chopper.Response<bool>> alternativedescriptionIdDelete(
      {@Path('id') required String? id});

  ///Get an empty object
  @Get(path: '/alternativedescription/emptyobject')
  Future<chopper.Response> alternativedescriptionEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/alternativedescription/emptybrowseobject')
  Future<chopper.Response> alternativedescriptionEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/alternativedescription/keyfieldnames')
  Future<chopper.Response> alternativedescriptionKeyfieldnamesGet();

  ///
  @Post(path: '/assignbarcodes/assignbarcodes')
  Future<
          chopper.Response<
              WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesResponse>>
      assignbarcodesAssignbarcodesPost(
          {@Body()
              required WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesRequest?
                  body});

  ///
  @Post(path: '/assignbarcodes/additems')
  Future<
          chopper.Response<
              WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsResponse>>
      assignbarcodesAdditemsPost(
          {@Body()
              required WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsRequest?
                  body});

  ///
  @Post(path: '/assignbarcodes/validatepurchaseorder/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      assignbarcodesValidatepurchaseorderBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/assignbarcodes/validatecontract/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      assignbarcodesValidatecontractBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/assignbarcodes/emptyobject')
  Future<chopper.Response> assignbarcodesEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/assignbarcodes/emptybrowseobject')
  Future<chopper.Response> assignbarcodesEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/assignbarcodes/keyfieldnames')
  Future<chopper.Response> assignbarcodesKeyfieldnamesGet();

  ///
  @Post(path: '/availabilityconflicts/validatewarehouse/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      availabilityconflictsValidatewarehouseBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/availabilityconflicts/validateinventorytype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      availabilityconflictsValidateinventorytypeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/availabilityconflicts/validatecategory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      availabilityconflictsValidatecategoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/availabilityconflicts/validatesubcategory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      availabilityconflictsValidatesubcategoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/availabilityconflicts/validateinventory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      availabilityconflictsValidateinventoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/availabilityconflicts/validateorder/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      availabilityconflictsValidateorderBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/availabilityconflicts/validatedeal/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      availabilityconflictsValidatedealBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/availabilityconflicts/emptyobject')
  Future<chopper.Response> availabilityconflictsEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/availabilityconflicts/emptybrowseobject')
  Future<chopper.Response> availabilityconflictsEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/availabilityconflicts/keyfieldnames')
  Future<chopper.Response> availabilityconflictsKeyfieldnamesGet();

  ///
  @Post(path: '/bankaccount/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      bankaccountBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/bankaccount/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      bankaccountExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/bankaccount')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesBillingBankAccountBankAccountLogic>>
      bankaccountGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/bankaccount')
  Future<chopper.Response<WebApiModulesBillingBankAccountBankAccount>>
      bankaccountPost(
          {@Body() required WebApiModulesBillingBankAccountBankAccount? body});

  ///
  ///@param id
  @Get(path: '/bankaccount/{id}')
  Future<chopper.Response<WebApiModulesBillingBankAccountBankAccount>>
      bankaccountIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/bankaccount/{id}')
  Future<chopper.Response<WebApiModulesBillingBankAccountBankAccount>>
      bankaccountIdPut(
          {@Path('id') required String? id,
          @Body() required WebApiModulesBillingBankAccountBankAccount? body});

  ///
  ///@param id
  @Delete(path: '/bankaccount/{id}')
  Future<chopper.Response<bool>> bankaccountIdDelete(
      {@Path('id') required String? id});

  ///Get an empty object
  @Get(path: '/bankaccount/emptyobject')
  Future<chopper.Response> bankaccountEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/bankaccount/emptybrowseobject')
  Future<chopper.Response> bankaccountEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/bankaccount/keyfieldnames')
  Future<chopper.Response> bankaccountKeyfieldnamesGet();

  ///
  @Post(path: '/billing/populate')
  Future<chopper.Response<WebApiModulesBillingBillingPopulateBillingResponse>>
      billingPopulatePost(
          {@Body()
              required WebApiModulesBillingBillingPopulateBillingRequest?
                  body});

  ///
  @Post(path: '/billing/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      billingBrowsePost({@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/billing/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      billingExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Get(path: '/billing/legend')
  Future<chopper.Response<Object>> billingLegendGet();

  ///
  ///@param id
  @Get(path: '/billing/{id}')
  Future<chopper.Response<WebApiModulesBillingBillingBilling>> billingIdGet(
      {@Path('id') required String? id});

  ///
  @Post(path: '/billing/createinvoices')
  Future<chopper.Response<WebApiModulesBillingBillingCreateInvoicesResponse>>
      billingCreateinvoicesPost(
          {@Body()
              required WebApiModulesBillingBillingCreateInvoicesRequest? body});

  ///
  ///@param id
  @Post(path: '/billing/getorderbillingdates/{id}', optionalBody: true)
  Future<
          chopper.Response<
              WebApiModulesBillingBillingGetOrderBillingDatesResponse>>
      billingGetorderbillingdatesIdPost({@Path('id') required String? id});

  ///
  @Post(path: '/billing/createinvoiceestimate')
  Future<
          chopper.Response<
              WebApiModulesBillingBillingCreateInvoiceEstimateResponse>>
      billingCreateinvoiceestimatePost(
          {@Body()
              required WebApiModulesBillingBillingCreateInvoiceEstimateRequest?
                  body});

  ///
  @Post(path: '/billing/validateofficelocation/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      billingValidateofficelocationBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/billing/validatecustomer/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      billingValidatecustomerBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/billing/validatedeal/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      billingValidatedealBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/billing/validatedepartment/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      billingValidatedepartmentBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/billing/validateuser/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      billingValidateuserBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/billing/validateorder/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      billingValidateorderBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/billing/billingmessage/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      billingBillingmessageBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/billing/emptyobject')
  Future<chopper.Response> billingEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/billing/emptybrowseobject')
  Future<chopper.Response> billingEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/billing/keyfieldnames')
  Future<chopper.Response> billingKeyfieldnamesGet();

  ///
  @Post(path: '/billingmessage/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      billingmessageBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/billingmessage/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      billingmessageExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/billingmessage/emptyobject')
  Future<chopper.Response> billingmessageEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/billingmessage/emptybrowseobject')
  Future<chopper.Response> billingmessageEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/billingmessage/keyfieldnames')
  Future<chopper.Response> billingmessageKeyfieldnamesGet();

  ///
  @Post(path: '/billingworksheet/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      billingworksheetBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/billingworksheet/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      billingworksheetExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/billingworksheet')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesBillingBillingWorksheetBillingWorksheetLogic>>
      billingworksheetGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/billingworksheet')
  Future<chopper.Response<WebApiModulesBillingBillingWorksheetBillingWorksheet>>
      billingworksheetPost(
          {@Body()
              required WebApiModulesBillingBillingWorksheetBillingWorksheet?
                  body});

  ///
  ///@param id
  @Get(path: '/billingworksheet/{id}')
  Future<chopper.Response<WebApiModulesBillingBillingWorksheetBillingWorksheet>>
      billingworksheetIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/billingworksheet/{id}')
  Future<chopper.Response<WebApiModulesBillingBillingWorksheetBillingWorksheet>>
      billingworksheetIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesBillingBillingWorksheetBillingWorksheet?
                  body});

  ///
  ///@param id
  @Delete(path: '/billingworksheet/{id}')
  Future<chopper.Response<bool>> billingworksheetIdDelete(
      {@Path('id') required String? id});

  ///
  @Get(path: '/billingworksheet/legend')
  Future<chopper.Response<Object>> billingworksheetLegendGet();

  ///
  ///@param id
  @Post(path: '/billingworksheet/{id}/approve', optionalBody: true)
  Future<
          chopper.Response<
              WebApiModulesBillingInvoiceToggleInvoiceApprovedResponse>>
      billingworksheetIdApprovePost({@Path('id') required String? id});

  ///
  ///@param id
  @Post(path: '/billingworksheet/{id}/unapprove', optionalBody: true)
  Future<
          chopper.Response<
              WebApiModulesBillingInvoiceToggleInvoiceApprovedResponse>>
      billingworksheetIdUnapprovePost({@Path('id') required String? id});

  ///
  @Post(path: '/billingworksheet/getnextusagedates')
  Future<
          chopper.Response<
              WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesResponse>>
      billingworksheetGetnextusagedatesPost(
          {@Body()
              required WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesRequest?
                  body});

  ///
  @Post(path: '/billingworksheet/updatebillingworksheet')
  Future<
          chopper.Response<
              WebApiModulesBillingBillingUpdateBillingWorksheetResponse>>
      billingworksheetUpdatebillingworksheetPost(
          {@Body()
              required WebApiModulesBillingBillingUpdateBillingWorksheetRequest?
                  body});

  ///
  @Post(path: '/billingworksheet/validateorder/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      billingworksheetValidateorderBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/billingworksheet/validatedepartment/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      billingworksheetValidatedepartmentBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/billingworksheet/validateagent/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      billingworksheetValidateagentBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/billingworksheet/validateprojectmanager/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      billingworksheetValidateprojectmanagerBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/billingworksheet/validateoutsidesalesrepresentative/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      billingworksheetValidateoutsidesalesrepresentativeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/billingworksheet/validatepaymentterms/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      billingworksheetValidatepaymenttermsBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/billingworksheet/validatepaymenttype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      billingworksheetValidatepaymenttypeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/billingworksheet/validatecurrency/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      billingworksheetValidatecurrencyBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/billingworksheet/validatetaxoption/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      billingworksheetValidatetaxoptionBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/billingworksheet/emptyobject')
  Future<chopper.Response> billingworksheetEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/billingworksheet/emptybrowseobject')
  Future<chopper.Response> billingworksheetEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/billingworksheet/keyfieldnames')
  Future<chopper.Response> billingworksheetKeyfieldnamesGet();

  ///
  @Post(path: '/checkedinitem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      checkedinitemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/checkedinitem/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      checkedinitemExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/checkedinitem/emptyobject')
  Future<chopper.Response> checkedinitemEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/checkedinitem/emptybrowseobject')
  Future<chopper.Response> checkedinitemEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/checkedinitem/keyfieldnames')
  Future<chopper.Response> checkedinitemKeyfieldnamesGet();

  ///
  @Post(path: '/checkedoutitem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      checkedoutitemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/checkedoutitem/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      checkedoutitemExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/checkedoutitem/emptyobject')
  Future<chopper.Response> checkedoutitemEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/checkedoutitem/emptybrowseobject')
  Future<chopper.Response> checkedoutitemEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/checkedoutitem/keyfieldnames')
  Future<chopper.Response> checkedoutitemKeyfieldnamesGet();

  ///
  ///@param warehouseId
  @Get(path: '/checkin/suspendedsessionsexist')
  Future<chopper.Response<bool>> checkinSuspendedsessionsexistGet(
      {@Query('warehouseId') String? warehouseId});

  ///
  ///@param warehouseId
  @Get(path: '/checkin/transfersuspendedsessionsexist')
  Future<chopper.Response<bool>> checkinTransfersuspendedsessionsexistGet(
      {@Query('warehouseId') String? warehouseId});

  ///
  @Post(path: '/checkin/startcheckincontract')
  Future<chopper.Response<WebApiModulesWarehouseCheckInCheckInContractResponse>>
      checkinStartcheckincontractPost(
          {@Body()
              required WebApiModulesWarehouseCheckInCheckInContractRequest?
                  body});

  ///
  ///@param id
  @Post(path: '/checkin/completecheckincontract/{id}', optionalBody: true)
  Future<chopper.Response<WebApiModulesWarehouseContractContract>>
      checkinCompletecheckincontractIdPost({@Path('id') required String? id});

  ///
  @Post(path: '/checkin/checkinitem')
  Future<chopper.Response<WebApiModulesWarehouseCheckInTCheckInItemResponse>>
      checkinCheckinitemPost(
          {@Body()
              required WebApiModulesWarehouseCheckInCheckInItemRequest? body});

  ///
  @Post(path: '/checkin/cancelcheckinitems')
  Future<
          chopper
              .Response<WebApiModulesWarehouseCheckInCancelCheckInItemResponse>>
      checkinCancelcheckinitemsPost(
          {@Body()
              required WebApiModulesWarehouseCheckInCancelCheckInItemRequest?
                  body});

  ///
  @Post(path: '/checkin/cancelcontract')
  Future<chopper.Response<WebApiLogicTSpStatusResponse>>
      checkinCancelcontractPost(
          {@Body()
              required WebApiModulesWarehouseContractCancelContractRequest?
                  body});

  ///
  @Post(path: '/checkin/validateorder/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      checkinValidateorderBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/checkin/validatedeal/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      checkinValidatedealBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/checkin/validatespecificorder/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      checkinValidatespecificorderBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/checkin/hasquikreceipt')
  Future<chopper.Response<bool>> checkinHasquikreceiptPost(
      {@Body()
          required WebApiModulesWarehouseCheckInHasQuikReceiptRequest? body});

  ///
  @Post(path: '/checkin/checkinquantityitem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      checkinCheckinquantityitemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/checkin/checkinquantityitem/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      checkinCheckinquantityitemExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/checkin/checkinquantityitem/selectall')
  Future<chopper.Response<WebApiModulesWarehouseCheckInTCheckInItemResponse>>
      checkinCheckinquantityitemSelectallPost(
          {@Body()
              required WebApiModulesWarehouseCheckInCheckInItemRequest? body});

  ///
  @Post(path: '/checkin/checkinquantityitem/selectnone')
  Future<
          chopper
              .Response<WebApiModulesWarehouseCheckInCancelCheckInItemResponse>>
      checkinCheckinquantityitemSelectnonePost(
          {@Body()
              required WebApiModulesWarehouseCheckInCancelCheckInItemRequest?
                  body});

  ///
  @Get(path: '/checkin/checkinquantityitem/emptyobject')
  Future<chopper.Response> checkinCheckinquantityitemEmptyobjectGet();

  ///Get an empty object
  @Get(path: '/checkin/emptyobject')
  Future<chopper.Response> checkinEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/checkin/emptybrowseobject')
  Future<chopper.Response> checkinEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/checkin/keyfieldnames')
  Future<chopper.Response> checkinKeyfieldnamesGet();

  ///
  @Post(path: '/checkinexception/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      checkinexceptionBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/checkinexception/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      checkinexceptionExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/checkinexception/emptyobject')
  Future<chopper.Response> checkinexceptionEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/checkinexception/emptybrowseobject')
  Future<chopper.Response> checkinexceptionEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/checkinexception/keyfieldnames')
  Future<chopper.Response> checkinexceptionKeyfieldnamesGet();

  ///
  @Post(path: '/checkinorder/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      checkinorderBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/checkinorder/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      checkinorderExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/checkinorder/emptyobject')
  Future<chopper.Response> checkinorderEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/checkinorder/emptybrowseobject')
  Future<chopper.Response> checkinorderEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/checkinorder/keyfieldnames')
  Future<chopper.Response> checkinorderKeyfieldnamesGet();

  ///
  @Post(path: '/checkinswap/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      checkinswapBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/checkinswap/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      checkinswapExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/checkinswap/emptyobject')
  Future<chopper.Response> checkinswapEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/checkinswap/emptybrowseobject')
  Future<chopper.Response> checkinswapEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/checkinswap/keyfieldnames')
  Future<chopper.Response> checkinswapKeyfieldnamesGet();

  ///
  ///@param warehouseId
  @Get(path: '/checkout/suspendedsessionsexist')
  Future<chopper.Response<bool>> checkoutSuspendedsessionsexistGet(
      {@Query('warehouseId') String? warehouseId});

  ///
  ///@param warehouseId
  @Get(path: '/checkout/transfersuspendedsessionsexist')
  Future<chopper.Response<bool>> checkoutTransfersuspendedsessionsexistGet(
      {@Query('warehouseId') String? warehouseId});

  ///
  ///@param warehouseId
  @Get(path: '/checkout/containersuspendedsessionsexist')
  Future<chopper.Response<bool>> checkoutContainersuspendedsessionsexistGet(
      {@Query('warehouseId') String? warehouseId});

  ///
  ///@param id
  @Get(path: '/checkout/ordermessages/{id}')
  Future<chopper.Response<WebApiModulesAgentOrderOrderMessagesResponse>>
      checkoutOrdermessagesIdGet({@Path('id') required String? id});

  ///
  ///@param OrderId
  ///@param WarehouseId
  @Get(path: '/checkout/stagingtabs')
  Future<chopper.Response<WebApiModulesWarehouseCheckOutStagingTabsResponse>>
      checkoutStagingtabsGet(
          {@Query('OrderId') String? orderId,
          @Query('WarehouseId') String? warehouseId});

  ///
  @Post(path: '/checkout/stageitem')
  Future<chopper.Response<WebApiModulesWarehouseCheckOutStageItemResponse>>
      checkoutStageitemPost(
          {@Body()
              required WebApiModulesWarehouseCheckOutStageItemRequest? body});

  ///
  @Post(path: '/checkout/unstageitem')
  Future<chopper.Response<WebApiModulesWarehouseCheckOutUnstageItemResponse>>
      checkoutUnstageitemPost(
          {@Body()
              required WebApiModulesWarehouseCheckOutUnstageItemRequest? body});

  ///
  @Post(path: '/checkout/checkoutallstaged')
  Future<
          chopper.Response<
              WebApiModulesWarehouseCheckOutCheckOutAllStagedResponse>>
      checkoutCheckoutallstagedPost(
          {@Body()
              required WebApiModulesWarehouseCheckOutCheckOutAllStagedRequest?
                  body});

  ///
  @Post(path: '/checkout/startcheckoutcontract')
  Future<
          chopper.Response<
              WebApiModulesWarehouseCheckOutCreateOutContractResponse>>
      checkoutStartcheckoutcontractPost(
          {@Body()
              required WebApiModulesWarehouseCheckOutCreateOutContractRequest?
                  body});

  ///
  @Post(path: '/checkout/movestageditemtoout')
  Future<chopper.Response<WebApiModulesWarehouseCheckOutMoveStagedItemResponse>>
      checkoutMovestageditemtooutPost(
          {@Body()
              required WebApiModulesWarehouseCheckOutMoveStagedItemRequest?
                  body});

  ///
  @Post(path: '/checkout/moveoutitemtostaged')
  Future<chopper.Response<WebApiModulesWarehouseCheckOutMoveStagedItemResponse>>
      checkoutMoveoutitemtostagedPost(
          {@Body()
              required WebApiModulesWarehouseCheckOutMoveStagedItemRequest?
                  body});

  ///
  ///@param id
  @Post(path: '/checkout/completecheckoutcontract/{id}', optionalBody: true)
  Future<chopper.Response<WebApiModulesWarehouseContractContract>>
      checkoutCompletecheckoutcontractIdPost({@Path('id') required String? id});

  ///
  @Post(path: '/checkout/cancelcontract')
  Future<chopper.Response<WebApiLogicTSpStatusResponse>>
      checkoutCancelcontractPost(
          {@Body()
              required WebApiModulesWarehouseContractCancelContractRequest?
                  body});

  ///
  @Post(path: '/checkout/startsubstitutesession')
  Future<
          chopper.Response<
              WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionResponse>>
      checkoutStartsubstitutesessionPost(
          {@Body()
              required WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionRequest?
                  body});

  ///
  @Post(path: '/checkout/addsubstituteitemtosession')
  Future<
          chopper.Response<
              WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionResponse>>
      checkoutAddsubstituteitemtosessionPost(
          {@Body()
              required WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionRequest?
                  body});

  ///
  @Post(path: '/checkout/applysubstitutesession')
  Future<
          chopper.Response<
              WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionResponse>>
      checkoutApplysubstitutesessionPost(
          {@Body()
              required WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionRequest?
                  body});

  ///
  @Post(path: '/checkout/isvalidstoragecontainer')
  Future<
          chopper.Response<
              WebApiModulesWarehouseCheckOutIsValidStorageContainerResponse>>
      checkoutIsvalidstoragecontainerPost(
          {@Body()
              required WebApiModulesWarehouseCheckOutIsValidStorageContainerRequest?
                  body});

  ///
  @Post(path: '/checkout/storagecontainerstageditems')
  Future<
          chopper.Response<
              WebApiModulesWarehouseCheckOutStorageContainerStagedItemsResponse>>
      checkoutStoragecontainerstageditemsPost(
          {@Body()
              required WebApiModulesWarehouseCheckOutStorageContainerStagedItemsRequest?
                  body});

  ///
  @Post(path: '/checkout/decreaseorderquantity')
  Future<
          chopper.Response<
              WebApiModulesWarehouseCheckOutDecreaseOrderQuantityResponse>>
      checkoutDecreaseorderquantityPost(
          {@Body()
              required WebApiModulesWarehouseCheckOutDecreaseOrderQuantityRequest?
                  body});

  ///
  @Post(path: '/checkout/validateorder/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      checkoutValidateorderBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/checkout/validatetransfer/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      checkoutValidatetransferBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/checkout/validatecontaineritem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      checkoutValidatecontaineritemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/checkout/validatecontainer/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      checkoutValidatecontainerBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/checkout/orderhasstoragecontainer')
  Future<
          chopper.Response<
              WebApiModulesWarehouseCheckOutOrderHasStorageContainerResponse>>
      checkoutOrderhasstoragecontainerPost(
          {@Body()
              required WebApiModulesWarehouseCheckOutOrderHasStorageContainerRequest?
                  body});

  ///
  @Post(path: '/checkout/getpickuplocations')
  Future<
          chopper.Response<
              WebApiModulesWarehouseCheckOutGetPickupLocationsResponse>>
      checkoutGetpickuplocationsPost(
          {@Body()
              required WebApiModulesWarehouseCheckOutGetPickupLocationsRequest?
                  body});

  ///
  @Post(path: '/checkout/updatepickuplocation')
  Future<
          chopper.Response<
              WebApiModulesWarehouseCheckOutUpdatePickupLocationResponse>>
      checkoutUpdatepickuplocationPost(
          {@Body()
              required WebApiModulesWarehouseCheckOutUpdatePickupLocationRequest?
                  body});

  ///
  @Post(path: '/checkout/stageholdingitem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      checkoutStageholdingitemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/checkout/stageholdingitem/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      checkoutStageholdingitemExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/checkout/stageholdingitem/selectall')
  Future<
          chopper.Response<
              WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemResponse>>
      checkoutStageholdingitemSelectallPost(
          {@Body()
              required WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemRequest?
                  body});

  ///
  @Post(path: '/checkout/stageholdingitem/selectnone')
  Future<
          chopper.Response<
              WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemResponse>>
      checkoutStageholdingitemSelectnonePost(
          {@Body()
              required WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemRequest?
                  body});

  ///
  @Get(path: '/checkout/stageholdingitem/emptyobject')
  Future<chopper.Response> checkoutStageholdingitemEmptyobjectGet();

  ///
  @Post(path: '/checkout/stagequantityitem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      checkoutStagequantityitemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/checkout/stagequantityitem/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      checkoutStagequantityitemExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/checkout/stagequantityitem/selectall')
  Future<
          chopper.Response<
              WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemResponse>>
      checkoutStagequantityitemSelectallPost(
          {@Body()
              required WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemRequest?
                  body});

  ///
  @Post(path: '/checkout/stagequantityitem/selectnone')
  Future<
          chopper.Response<
              WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemResponse>>
      checkoutStagequantityitemSelectnonePost(
          {@Body()
              required WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemRequest?
                  body});

  ///
  @Get(path: '/checkout/stagequantityitem/emptyobject')
  Future<chopper.Response> checkoutStagequantityitemEmptyobjectGet();

  ///
  @Post(path: '/checkout/stageserialitem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      checkoutStageserialitemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/checkout/stageserialitem/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      checkoutStageserialitemExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Get(path: '/checkout/stageserialitem/emptyobject')
  Future<chopper.Response> checkoutStageserialitemEmptyobjectGet();

  ///
  @Post(path: '/checkout/stageserialnumber/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      checkoutStageserialnumberBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/checkout/stageserialnumber/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      checkoutStageserialnumberExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param id
  @Put(path: '/checkout/stageserialnumber/{id}')
  Future<chopper.Response<bool>> checkoutStageserialnumberIdPut(
      {@Path('id') required String? id,
      @Body() required WebApiModulesWarehouseCheckOutStageSerialNumber? body});

  ///
  @Post(path: '/checkout/stageserialnumber')
  Future<chopper.Response<WebApiModulesWarehouseCheckOutStageItemResponse>>
      checkoutStageserialnumberPost(
          {@Body()
              required WebApiModulesWarehouseCheckOutStageItemRequest? body});

  ///
  @Post(path: '/checkout/storagecontainers/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      checkoutStoragecontainersBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/checkout/storagecontainers/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      checkoutStoragecontainersExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/checkout/storagecontainers')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerGridLogic>>
      checkoutStoragecontainersGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Get(path: '/checkout/storagecontainers/emptyobject')
  Future<chopper.Response> checkoutStoragecontainersEmptyobjectGet();

  ///
  @Post(path: '/checkout/storagecontaineritems/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      checkoutStoragecontaineritemsBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/checkout/storagecontaineritems/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      checkoutStoragecontaineritemsExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/checkout/storagecontaineritems')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerItemsGridLogic>>
      checkoutStoragecontaineritemsGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Get(path: '/checkout/storagecontaineritems/emptyobject')
  Future<chopper.Response> checkoutStoragecontaineritemsEmptyobjectGet();

  ///Get an empty object
  @Get(path: '/checkout/emptyobject')
  Future<chopper.Response> checkoutEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/checkout/emptybrowseobject')
  Future<chopper.Response> checkoutEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/checkout/keyfieldnames')
  Future<chopper.Response> checkoutKeyfieldnamesGet();

  ///
  @Post(path: '/checkoutpendingitem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      checkoutpendingitemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/checkoutpendingitem/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      checkoutpendingitemExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/checkoutpendingitem/emptyobject')
  Future<chopper.Response> checkoutpendingitemEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/checkoutpendingitem/emptybrowseobject')
  Future<chopper.Response> checkoutpendingitemEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/checkoutpendingitem/keyfieldnames')
  Future<chopper.Response> checkoutpendingitemKeyfieldnamesGet();

  ///
  @Post(path: '/company/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      companyBrowsePost({@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/company/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      companyExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/company')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyCompanyLogic>>
      companyGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  ///@param id
  @Get(path: '/company/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsCompanyCompany>>
      companyIdGet({@Path('id') required String? id});

  ///Get an empty object
  @Get(path: '/company/emptyobject')
  Future<chopper.Response> companyEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/company/emptybrowseobject')
  Future<chopper.Response> companyEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/company/keyfieldnames')
  Future<chopper.Response> companyKeyfieldnamesGet();

  ///
  @Post(path: '/companycontact/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      companycontactBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Get(path: '/companycontact/legend')
  Future<chopper.Response<Object>> companycontactLegendGet();

  ///
  @Post(path: '/companycontact/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      companycontactExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/companycontact')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyContactCompanyContactLogic>>
      companycontactGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/companycontact')
  Future<
          chopper
              .Response<WebApiModulesHomeControlsCompanyContactCompanyContact>>
      companycontactPost(
          {@Body()
              required WebApiModulesHomeControlsCompanyContactCompanyContact?
                  body});

  ///
  ///@param id
  @Get(path: '/companycontact/{id}')
  Future<
          chopper
              .Response<WebApiModulesHomeControlsCompanyContactCompanyContact>>
      companycontactIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/companycontact/{id}')
  Future<
          chopper
              .Response<WebApiModulesHomeControlsCompanyContactCompanyContact>>
      companycontactIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsCompanyContactCompanyContact?
                  body});

  ///
  ///@param id
  @Delete(path: '/companycontact/{id}')
  Future<chopper.Response<bool>> companycontactIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/companycontact/validatecontacttitle/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      companycontactValidatecontacttitleBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/companycontact/validatecontact/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      companycontactValidatecontactBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/companycontact/validatecompany/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      companycontactValidatecompanyBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/companycontact/emptyobject')
  Future<chopper.Response> companycontactEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/companycontact/emptybrowseobject')
  Future<chopper.Response> companycontactEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/companycontact/keyfieldnames')
  Future<chopper.Response> companycontactKeyfieldnamesGet();

  ///
  @Post(path: '/companytaxoption/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      companytaxoptionBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/companytaxoption/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      companytaxoptionExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/companytaxoption')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOptionLogic>>
      companytaxoptionGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/companytaxoption')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOption>>
      companytaxoptionPost(
          {@Body()
              required WebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOption?
                  body});

  ///
  ///@param id
  @Get(path: '/companytaxoption/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOption>>
      companytaxoptionIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/companytaxoption/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOption>>
      companytaxoptionIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOption?
                  body});

  ///
  ///@param id
  @Delete(path: '/companytaxoption/{id}')
  Future<chopper.Response<bool>> companytaxoptionIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/companytaxoption/validatetaxoption/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      companytaxoptionValidatetaxoptionBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/companytaxoption/emptyobject')
  Future<chopper.Response> companytaxoptionEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/companytaxoption/emptybrowseobject')
  Future<chopper.Response> companytaxoptionEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/companytaxoption/keyfieldnames')
  Future<chopper.Response> companytaxoptionKeyfieldnamesGet();

  ///
  @Post(path: '/companytaxresale/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      companytaxresaleBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/companytaxresale/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      companytaxresaleExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/companytaxresale')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResaleLogic>>
      companytaxresaleGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/companytaxresale')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResale>>
      companytaxresalePost(
          {@Body()
              required WebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResale?
                  body});

  ///
  ///@param id
  @Get(path: '/companytaxresale/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResale>>
      companytaxresaleIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/companytaxresale/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResale>>
      companytaxresaleIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResale?
                  body});

  ///
  ///@param id
  @Delete(path: '/companytaxresale/{id}')
  Future<chopper.Response<bool>> companytaxresaleIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/companytaxresale/validatestate/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      companytaxresaleValidatestateBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/companytaxresale/emptyobject')
  Future<chopper.Response> companytaxresaleEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/companytaxresale/emptybrowseobject')
  Future<chopper.Response> companytaxresaleEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/companytaxresale/keyfieldnames')
  Future<chopper.Response> companytaxresaleKeyfieldnamesGet();

  ///
  @Post(path: '/completeqc/completeqcitem')
  Future<
          chopper
              .Response<WebApiModulesInventoryCompleteQcCompleteQcItemResponse>>
      completeqcCompleteqcitemPost(
          {@Body()
              required WebApiModulesInventoryCompleteQcCompleteQcItemRequest?
                  body});

  ///
  @Post(path: '/completeqc/updateqcitem')
  Future<chopper.Response<WebApiModulesInventoryCompleteQcUpdateQcItemResponse>>
      completeqcUpdateqcitemPost(
          {@Body()
              required WebApiModulesInventoryCompleteQcUpdateQcItemRequest?
                  body});

  ///Get an empty object
  @Get(path: '/completeqc/emptyobject')
  Future<chopper.Response> completeqcEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/completeqc/emptybrowseobject')
  Future<chopper.Response> completeqcEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/completeqc/keyfieldnames')
  Future<chopper.Response> completeqcKeyfieldnamesGet();

  ///
  @Post(path: '/contact/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      contactBrowsePost({@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Get(path: '/contact/legend')
  Future<chopper.Response<Object>> contactLegendGet();

  ///
  @Post(path: '/contact/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      contactExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/contact')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAgentContactContactLogic>>
      contactGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/contact')
  Future<chopper.Response<WebApiModulesAgentContactContact>> contactPost(
      {@Body() required WebApiModulesAgentContactContact? body});

  ///
  ///@param id
  @Get(path: '/contact/{id}')
  Future<chopper.Response<WebApiModulesAgentContactContact>> contactIdGet(
      {@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/contact/{id}')
  Future<chopper.Response<WebApiModulesAgentContactContact>> contactIdPut(
      {@Path('id') required String? id,
      @Body() required WebApiModulesAgentContactContact? body});

  ///
  ///@param id
  @Delete(path: '/contact/{id}')
  Future<chopper.Response<bool>> contactIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/contact/validatecontacttitle/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      contactValidatecontacttitleBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/contact/validatecountry/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      contactValidatecountryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/contact/validatedeal/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      contactValidatedealBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/contact/validatelocation/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      contactValidatelocationBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/contact/validatewarehouse/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      contactValidatewarehouseBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/contact/validatewebcatalog/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      contactValidatewebcatalogBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Get(path: '/contact/companycontact/legend')
  Future<chopper.Response<Object>> contactCompanycontactLegendGet();

  ///
  @Post(path: '/contact/validatedepartment/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      contactValidatedepartmentBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get documents.
  ///@param contactid Unique identifier
  @Post(path: '/contact/{contactid}/document/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      contactContactidDocumentBrowsePost(
          {@Path('contactid') required String? contactid,
          @Body() required FwStandardModelsBrowseRequest? body});

  ///Export documents to Excel.
  ///@param contactid Unique identifier
  @Post(path: '/contact/{contactid}/document/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      contactContactidDocumentExportexcelxlsxPost(
          {@Path('contactid') required String? contactid,
          @Body() required FwStandardModelsBrowseRequest? body});

  ///Get documents.
  ///@param contactid Unique identifier
  ///@param DocumentTypeId Unique Identifier [Filter|Sort]
  ///@param Description Document description [Filter|Sort]
  ///@param DateStamp Document last modified data [Filter|Sort]
  ///@param PageNo The page number in the result set starting from 1.  PageNo is required when the PageSize is specified.
  ///@param PageSize Limit result set to the specified amount.
  ///@param Sort A sort expression to use of the form: Field1:asc,Field2:desc
  @Get(path: '/contact/{contactid}/documents')
  Future<
          chopper.Response<
              FwStandardModelsGetResponseFwStandardGridsAppDocumentAppDocumentGetManyResponse>>
      contactContactidDocumentsGet(
          {@Path('contactid') required String? contactid,
          @Query('DocumentTypeId') String? documentTypeId,
          @Query('Description') String? description,
          @Query('DateStamp') String? dateStamp,
          @Query('PageNo') int? pageNo,
          @Query('PageSize') int? pageSize,
          @Query('Sort') String? sort});

  ///Get a document.
  ///@param contactid Unique identifier
  ///@param documentid Unique identifier
  @Get(path: '/contact/{contactid}/document/{documentid}')
  Future<chopper.Response<WebApiModulesAgentContactContactDocument>>
      contactContactidDocumentDocumentidGet(
          {@Path('contactid') required String? contactid,
          @Path('documentid') required String? documentid});

  ///Update a document.
  ///@param contactid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/contact/{contactid}/document/{documentid}')
  Future<chopper.Response<WebApiModulesAgentContactContactDocument>>
      contactContactidDocumentDocumentidPut(
          {@Path('contactid')
              required String? contactid,
          @Path('documentid')
              required String? documentid,
          @Body()
              required WebApiModulesAgentContactContactDocumentPutRequest?
                  body});

  ///Delete a document.
  ///@param contactid Unique identifier
  ///@param documentid Unique identifier
  @Delete(path: '/contact/{contactid}/document/{documentid}')
  Future<chopper.Response<bool>> contactContactidDocumentDocumentidDelete(
      {@Path('contactid') required String? contactid,
      @Path('documentid') required String? documentid});

  ///Create a new document.
  ///@param contactid Unique identifier
  @Post(path: '/contact/{contactid}/document')
  Future<chopper.Response<WebApiModulesAgentContactContactDocument>>
      contactContactidDocumentPost(
          {@Path('contactid')
              required String? contactid,
          @Body()
              required WebApiModulesAgentContactContactDocumentPostRequest?
                  body});

  ///Get thumbnails for any images attached to the document.
  ///@param contactid Unique identifier
  ///@param documentid Unique identifier
  ///@param pageno The page number of the result set, starting from page 1.
  ///@param pagesize The number of records per page of the result set.
  @Get(path: '/contact/{contactid}/document/{documentid}/thumbnails')
  Future<
          chopper.Response<
              FwStandardGridsAppDocumentGetDocumentThumbnailsResponse>>
      contactContactidDocumentDocumentidThumbnailsGet(
          {@Path('contactid') required String? contactid,
          @Path('documentid') required String? documentid,
          @Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize});

  ///Get a fullsize image.
  ///@param contactid Unique identifier
  ///@param documentid Unique identifier
  ///@param imageid Unique identifier
  @Get(path: '/contact/{contactid}/document/{documentid}/image/{imageid}')
  Future<chopper.Response<FwStandardGridsAppDocumentGetDocumentImageResponse>>
      contactContactidDocumentDocumentidImageImageidGet(
          {@Path('contactid') required String? contactid,
          @Path('documentid') required String? documentid,
          @Path('imageid') required String? imageid});

  ///Delete an attached image.
  ///@param contactid Unique identifier
  ///@param documentid Unique identifier
  ///@param imageid Unique identifier
  @Delete(path: '/contact/{contactid}/document/{documentid}/image/{imageid}')
  Future<chopper.Response<bool>>
      contactContactidDocumentDocumentidImageImageidDelete(
          {@Path('contactid') required String? contactid,
          @Path('documentid') required String? documentid,
          @Path('imageid') required String? imageid});

  ///Attach an image from a dataurl.
  ///@param contactid Unique identifier
  ///@param documentid Unique identifier
  @Post(path: '/contact/{contactid}/document/{documentid}/image')
  Future<chopper.Response<bool>> contactContactidDocumentDocumentidImagePost(
      {@Path('contactid')
          required String? contactid,
      @Path('documentid')
          required String? documentid,
      @Body()
          required FwStandardGridsAppDocumentPostDocumentImageRequest? body});

  ///Attach an image from a form submission.
  ///@param contactid Unique identifier
  ///@param documentid Unique identifier
  @Post(path: '/contact/{contactid}/document/{documentid}/imageformupload')
  Future<chopper.Response<bool>>
      contactContactidDocumentDocumentidImageformuploadPost(
          {@Path('contactid') required String? contactid,
          @Path('documentid') required String? documentid});

  ///Get the attached file.
  ///@param contactid Unique identifier
  ///@param documentid Unique identifier
  @Get(path: '/contact/{contactid}/document/{documentid}/file')
  Future<chopper.Response> contactContactidDocumentDocumentidFileGet(
      {@Path('contactid') required String? contactid,
      @Path('documentid') required String? documentid});

  ///Update the attached file from a dataurl.
  ///@param contactid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/contact/{contactid}/document/{documentid}/file')
  Future<chopper.Response<bool>> contactContactidDocumentDocumentidFilePut(
      {@Path('contactid') required String? contactid,
      @Path('documentid') required String? documentid,
      @Body() required FwStandardGridsAppDocumentPutDocumentFileRequest? body});

  ///Delete attached file.
  ///@param contactid Unique identifier
  ///@param documentid Unique identifier
  @Delete(path: '/contact/{contactid}/document/{documentid}/file')
  Future<chopper.Response<bool>> contactContactidDocumentDocumentidFileDelete(
      {@Path('contactid') required String? contactid,
      @Path('documentid') required String? documentid});

  ///Update attached file from a form submission.
  ///@param contactid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/contact/{contactid}/document/{documentid}/fileformupload')
  Future<chopper.Response<bool>>
      contactContactidDocumentDocumentidFileformuploadPut(
          {@Path('contactid') required String? contactid,
          @Path('documentid') required String? documentid});

  ///
  ///@param contactid
  @Get(path: '/contact/{contactid}/document/emptyobject')
  Future<chopper.Response> contactContactidDocumentEmptyobjectGet(
      {@Path('contactid') required String? contactid});

  ///Get an empty object
  @Get(path: '/contact/emptyobject')
  Future<chopper.Response> contactEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/contact/emptybrowseobject')
  Future<chopper.Response> contactEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/contact/keyfieldnames')
  Future<chopper.Response> contactKeyfieldnamesGet();

  ///
  @Post(path: '/contactnote/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      contactnoteBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/contactnote/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      contactnoteExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/contactnote')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContactNoteContactNoteLogic>>
      contactnoteGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/contactnote')
  Future<chopper.Response<WebApiModulesHomeControlsContactNoteContactNote>>
      contactnotePost(
          {@Body()
              required WebApiModulesHomeControlsContactNoteContactNote? body});

  ///
  ///@param id
  @Get(path: '/contactnote/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsContactNoteContactNote>>
      contactnoteIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/contactnote/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsContactNoteContactNote>>
      contactnoteIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsContactNoteContactNote? body});

  ///
  ///@param id
  @Delete(path: '/contactnote/{id}')
  Future<chopper.Response<bool>> contactnoteIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/contactnote/validatenotesby/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      contactnoteValidatenotesbyBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/contactnote/emptyobject')
  Future<chopper.Response> contactnoteEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/contactnote/emptybrowseobject')
  Future<chopper.Response> contactnoteEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/contactnote/keyfieldnames')
  Future<chopper.Response> contactnoteKeyfieldnamesGet();

  ///
  @Post(path: '/container/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      containerBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/container/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      containerExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/container')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesContainersContainerContainerLogic>>
      containerGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  ///@param id
  @Get(path: '/container/{id}')
  Future<chopper.Response<WebApiModulesContainersContainerContainer>>
      containerIdGet({@Path('id') required String? id});

  ///Get an empty object
  @Get(path: '/container/emptyobject')
  Future<chopper.Response> containerEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/container/emptybrowseobject')
  Future<chopper.Response> containerEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/container/keyfieldnames')
  Future<chopper.Response> containerKeyfieldnamesGet();

  ///
  @Post(path: '/containeritem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      containeritemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Get(path: '/containeritem/legend')
  Future<chopper.Response<Object>> containeritemLegendGet();

  ///
  @Post(path: '/containeritem/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      containeritemExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param id
  @Get(path: '/containeritem/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsContainerItemContainerItem>>
      containeritemIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/containeritem/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsContainerItemContainerItem>>
      containeritemIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsContainerItemContainerItem?
                  body});

  ///
  @Post(path: '/containeritem')
  Future<chopper.Response<WebApiModulesHomeControlsContainerItemContainerItem>>
      containeritemPost(
          {@Body()
              required WebApiModulesHomeControlsContainerItemContainerItem?
                  body});

  ///
  @Post(path: '/containeritem/instantiatecontainer')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsContainerItemInstantiateContainerItemResponse>>
      containeritemInstantiatecontainerPost(
          {@Body()
              required WebApiModulesHomeControlsContainerItemInstantiateContainerRequest?
                  body});

  ///
  @Post(path: '/containeritem/emptycontainer')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsContainerItemEmptyContainerItemResponse>>
      containeritemEmptycontainerPost(
          {@Body()
              required WebApiModulesHomeControlsContainerItemEmptyContainerRequest?
                  body});

  ///
  @Post(path: '/containeritem/removefromcontainer')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsContainerItemRemoveFromContainerResponse>>
      containeritemRemovefromcontainerPost(
          {@Body()
              required WebApiModulesHomeControlsContainerItemRemoveFromContainerRequest?
                  body});

  ///
  @Post(path: '/containeritem/cancelfillcontainer')
  Future<chopper.Response<WebApiLogicTSpStatusResponse>>
      containeritemCancelfillcontainerPost(
          {@Body()
              required WebApiModulesWarehouseContractCancelContractRequest?
                  body});

  ///Get an empty object
  @Get(path: '/containeritem/emptyobject')
  Future<chopper.Response> containeritemEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/containeritem/emptybrowseobject')
  Future<chopper.Response> containeritemEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/containeritem/keyfieldnames')
  Future<chopper.Response> containeritemKeyfieldnamesGet();

  ///
  @Post(path: '/containerstatus/validatecontaineritem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      containerstatusValidatecontaineritemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/containerstatus/validatecategory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      containerstatusValidatecategoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/containerstatus/validatesubcategory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      containerstatusValidatesubcategoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/containerstatus/validatewarehouse/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      containerstatusValidatewarehouseBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/containerstatus/validateinventorytype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      containerstatusValidateinventorytypeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/containerstatus/emptyobject')
  Future<chopper.Response> containerstatusEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/containerstatus/emptybrowseobject')
  Future<chopper.Response> containerstatusEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/containerstatus/keyfieldnames')
  Future<chopper.Response> containerstatusKeyfieldnamesGet();

  ///
  @Post(path: '/containerwarehouse/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      containerwarehouseBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/containerwarehouse/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      containerwarehouseExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/containerwarehouse')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContainerWarehouseContainerWarehouseLogic>>
      containerwarehouseGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/containerwarehouse')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsContainerWarehouseContainerWarehouse>>
      containerwarehousePost(
          {@Body()
              required WebApiModulesHomeControlsContainerWarehouseContainerWarehouse?
                  body});

  ///
  ///@param id
  @Get(path: '/containerwarehouse/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsContainerWarehouseContainerWarehouse>>
      containerwarehouseIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/containerwarehouse/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsContainerWarehouseContainerWarehouse>>
      containerwarehouseIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsContainerWarehouseContainerWarehouse?
                  body});

  ///Get an empty object
  @Get(path: '/containerwarehouse/emptyobject')
  Future<chopper.Response> containerwarehouseEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/containerwarehouse/emptybrowseobject')
  Future<chopper.Response> containerwarehouseEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/containerwarehouse/keyfieldnames')
  Future<chopper.Response> containerwarehouseKeyfieldnamesGet();

  ///
  @Post(path: '/contract/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      contractBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Get(path: '/contract/legend')
  Future<chopper.Response<Object>> contractLegendGet();

  ///
  @Post(path: '/contract/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      contractExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/contract')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesWarehouseContractContractLogic>>
      contractGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/contract')
  Future<chopper.Response<WebApiModulesWarehouseContractContract>> contractPost(
      {@Body() required WebApiModulesWarehouseContractContract? body});

  ///
  ///@param id
  @Get(path: '/contract/{id}')
  Future<chopper.Response<WebApiModulesWarehouseContractContract>>
      contractIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/contract/{id}')
  Future<chopper.Response<WebApiModulesWarehouseContractContract>>
      contractIdPut(
          {@Path('id') required String? id,
          @Body() required WebApiModulesWarehouseContractContract? body});

  ///
  ///@param id
  @Delete(path: '/contract/{id}')
  Future<chopper.Response<bool>> contractIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/contract/voidcontract')
  Future<chopper.Response<WebApiLogicTSpStatusResponse>>
      contractVoidcontractPost(
          {@Body()
              required WebApiModulesWarehouseContractVoidContractRequest?
                  body});

  ///
  @Post(path: '/contract/hasquikreceipt')
  Future<chopper.Response<bool>> contractHasquikreceiptPost(
      {@Body()
          required WebApiModulesWarehouseContractHasQuikReceiptRequest? body});

  ///Get Contract Details
  ///@param contractid Unique Id
  @Get(path: '/contract/{contractid}/contractdetails')
  Future<chopper.Response<WebApiModulesWarehouseContractContractDetailResponse>>
      contractContractidContractdetailsGet(
          {@Path('contractid') required String? contractid});

  ///
  @Post(path: '/contract/validatedeliverycarrier/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      contractValidatedeliverycarrierBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/contract/validateshipvia/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      contractValidateshipviaBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/contract/validatedeliverytocountry/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      contractValidatedeliverytocountryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get documents.
  ///@param contractid Unique identifier
  @Post(path: '/contract/{contractid}/document/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      contractContractidDocumentBrowsePost(
          {@Path('contractid') required String? contractid,
          @Body() required FwStandardModelsBrowseRequest? body});

  ///Export documents to Excel.
  ///@param contractid Unique identifier
  @Post(path: '/contract/{contractid}/document/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      contractContractidDocumentExportexcelxlsxPost(
          {@Path('contractid') required String? contractid,
          @Body() required FwStandardModelsBrowseRequest? body});

  ///Get documents.
  ///@param contractid Unique identifier
  ///@param DocumentTypeId Unique Identifier [Filter|Sort]
  ///@param Description Document description [Filter|Sort]
  ///@param DateStamp Document last modified data [Filter|Sort]
  ///@param PageNo The page number in the result set starting from 1.  PageNo is required when the PageSize is specified.
  ///@param PageSize Limit result set to the specified amount.
  ///@param Sort A sort expression to use of the form: Field1:asc,Field2:desc
  @Get(path: '/contract/{contractid}/documents')
  Future<
          chopper.Response<
              FwStandardModelsGetResponseFwStandardGridsAppDocumentAppDocumentGetManyResponse>>
      contractContractidDocumentsGet(
          {@Path('contractid') required String? contractid,
          @Query('DocumentTypeId') String? documentTypeId,
          @Query('Description') String? description,
          @Query('DateStamp') String? dateStamp,
          @Query('PageNo') int? pageNo,
          @Query('PageSize') int? pageSize,
          @Query('Sort') String? sort});

  ///Get a document.
  ///@param contractid Unique identifier
  ///@param documentid Unique identifier
  @Get(path: '/contract/{contractid}/document/{documentid}')
  Future<chopper.Response<WebApiModulesWarehouseContractContractDocument>>
      contractContractidDocumentDocumentidGet(
          {@Path('contractid') required String? contractid,
          @Path('documentid') required String? documentid});

  ///Update a document.
  ///@param contractid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/contract/{contractid}/document/{documentid}')
  Future<chopper.Response<WebApiModulesWarehouseContractContractDocument>>
      contractContractidDocumentDocumentidPut(
          {@Path('contractid')
              required String? contractid,
          @Path('documentid')
              required String? documentid,
          @Body()
              required WebApiModulesWarehouseContractContractDocumentPutRequest?
                  body});

  ///Delete a document.
  ///@param contractid Unique identifier
  ///@param documentid Unique identifier
  @Delete(path: '/contract/{contractid}/document/{documentid}')
  Future<chopper.Response<bool>> contractContractidDocumentDocumentidDelete(
      {@Path('contractid') required String? contractid,
      @Path('documentid') required String? documentid});

  ///Create a new document.
  ///@param contractid Unique identifier
  @Post(path: '/contract/{contractid}/document')
  Future<chopper.Response<WebApiModulesWarehouseContractContractDocument>>
      contractContractidDocumentPost(
          {@Path('contractid')
              required String? contractid,
          @Body()
              required WebApiModulesWarehouseContractContractDocumentPostRequest?
                  body});

  ///Get thumbnails for any images attached to the document.
  ///@param contractid Unique identifier
  ///@param documentid Unique identifier
  ///@param pageno The page number of the result set, starting from page 1.
  ///@param pagesize The number of records per page of the result set.
  @Get(path: '/contract/{contractid}/document/{documentid}/thumbnails')
  Future<
          chopper.Response<
              FwStandardGridsAppDocumentGetDocumentThumbnailsResponse>>
      contractContractidDocumentDocumentidThumbnailsGet(
          {@Path('contractid') required String? contractid,
          @Path('documentid') required String? documentid,
          @Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize});

  ///Get a fullsize image.
  ///@param contractid Unique identifier
  ///@param documentid Unique identifier
  ///@param imageid Unique identifier
  @Get(path: '/contract/{contractid}/document/{documentid}/image/{imageid}')
  Future<chopper.Response<FwStandardGridsAppDocumentGetDocumentImageResponse>>
      contractContractidDocumentDocumentidImageImageidGet(
          {@Path('contractid') required String? contractid,
          @Path('documentid') required String? documentid,
          @Path('imageid') required String? imageid});

  ///Delete an attached image.
  ///@param contractid Unique identifier
  ///@param documentid Unique identifier
  ///@param imageid Unique identifier
  @Delete(path: '/contract/{contractid}/document/{documentid}/image/{imageid}')
  Future<chopper.Response<bool>>
      contractContractidDocumentDocumentidImageImageidDelete(
          {@Path('contractid') required String? contractid,
          @Path('documentid') required String? documentid,
          @Path('imageid') required String? imageid});

  ///Attach an image from a dataurl.
  ///@param contractid Unique identifier
  ///@param documentid Unique identifier
  @Post(path: '/contract/{contractid}/document/{documentid}/image')
  Future<chopper.Response<bool>> contractContractidDocumentDocumentidImagePost(
      {@Path('contractid')
          required String? contractid,
      @Path('documentid')
          required String? documentid,
      @Body()
          required FwStandardGridsAppDocumentPostDocumentImageRequest? body});

  ///Attach an image from a form submission.
  ///@param contractid Unique identifier
  ///@param documentid Unique identifier
  @Post(path: '/contract/{contractid}/document/{documentid}/imageformupload')
  Future<chopper.Response<bool>>
      contractContractidDocumentDocumentidImageformuploadPost(
          {@Path('contractid') required String? contractid,
          @Path('documentid') required String? documentid});

  ///Get the attached file.
  ///@param contractid Unique identifier
  ///@param documentid Unique identifier
  @Get(path: '/contract/{contractid}/document/{documentid}/file')
  Future<chopper.Response> contractContractidDocumentDocumentidFileGet(
      {@Path('contractid') required String? contractid,
      @Path('documentid') required String? documentid});

  ///Update the attached file from a dataurl.
  ///@param contractid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/contract/{contractid}/document/{documentid}/file')
  Future<chopper.Response<bool>> contractContractidDocumentDocumentidFilePut(
      {@Path('contractid') required String? contractid,
      @Path('documentid') required String? documentid,
      @Body() required FwStandardGridsAppDocumentPutDocumentFileRequest? body});

  ///Delete attached file.
  ///@param contractid Unique identifier
  ///@param documentid Unique identifier
  @Delete(path: '/contract/{contractid}/document/{documentid}/file')
  Future<chopper.Response<bool>> contractContractidDocumentDocumentidFileDelete(
      {@Path('contractid') required String? contractid,
      @Path('documentid') required String? documentid});

  ///Update attached file from a form submission.
  ///@param contractid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/contract/{contractid}/document/{documentid}/fileformupload')
  Future<chopper.Response<bool>>
      contractContractidDocumentDocumentidFileformuploadPut(
          {@Path('contractid') required String? contractid,
          @Path('documentid') required String? documentid});

  ///
  ///@param contractid
  @Get(path: '/contract/{contractid}/document/emptyobject')
  Future<chopper.Response> contractContractidDocumentEmptyobjectGet(
      {@Path('contractid') required String? contractid});

  ///Get an empty object
  @Get(path: '/contract/emptyobject')
  Future<chopper.Response> contractEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/contract/emptybrowseobject')
  Future<chopper.Response> contractEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/contract/keyfieldnames')
  Future<chopper.Response> contractKeyfieldnamesGet();

  ///
  @Post(path: '/contractitemdetail/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      contractitemdetailBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Get(path: '/contractitemdetail/legend')
  Future<chopper.Response<Object>> contractitemdetailLegendGet();

  ///
  @Post(path: '/contractitemdetail/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      contractitemdetailExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/contractitemdetail/voiditems')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsContractItemDetailVoidItemsResponse>>
      contractitemdetailVoiditemsPost(
          {@Body()
              required WebApiModulesHomeControlsContractItemDetailVoidItemsRequest?
                  body});

  ///Get an empty object
  @Get(path: '/contractitemdetail/emptyobject')
  Future<chopper.Response> contractitemdetailEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/contractitemdetail/emptybrowseobject')
  Future<chopper.Response> contractitemdetailEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/contractitemdetail/keyfieldnames')
  Future<chopper.Response> contractitemdetailKeyfieldnamesGet();

  ///
  @Post(path: '/contractitemsummary/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      contractitemsummaryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/contractitemsummary/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      contractitemsummaryExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/contractitemsummary/emptyobject')
  Future<chopper.Response> contractitemsummaryEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/contractitemsummary/emptybrowseobject')
  Future<chopper.Response> contractitemsummaryEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/contractitemsummary/keyfieldnames')
  Future<chopper.Response> contractitemsummaryKeyfieldnamesGet();

  ///Get documents.
  ///@param customerid Unique identifier
  @Post(path: '/customer/{customerid}/document/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      customerCustomeridDocumentBrowsePost(
          {@Path('customerid') required String? customerid,
          @Body() required FwStandardModelsBrowseRequest? body});

  ///Export documents to Excel.
  ///@param customerid Unique identifier
  @Post(path: '/customer/{customerid}/document/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      customerCustomeridDocumentExportexcelxlsxPost(
          {@Path('customerid') required String? customerid,
          @Body() required FwStandardModelsBrowseRequest? body});

  ///Get documents.
  ///@param customerid Unique identifier
  ///@param DocumentTypeId Unique Identifier [Filter|Sort]
  ///@param Description Document description [Filter|Sort]
  ///@param DateStamp Document last modified data [Filter|Sort]
  ///@param PageNo The page number in the result set starting from 1.  PageNo is required when the PageSize is specified.
  ///@param PageSize Limit result set to the specified amount.
  ///@param Sort A sort expression to use of the form: Field1:asc,Field2:desc
  @Get(path: '/customer/{customerid}/documents')
  Future<
          chopper.Response<
              FwStandardModelsGetResponseFwStandardGridsAppDocumentAppDocumentGetManyResponse>>
      customerCustomeridDocumentsGet(
          {@Path('customerid') required String? customerid,
          @Query('DocumentTypeId') String? documentTypeId,
          @Query('Description') String? description,
          @Query('DateStamp') String? dateStamp,
          @Query('PageNo') int? pageNo,
          @Query('PageSize') int? pageSize,
          @Query('Sort') String? sort});

  ///Get a document.
  ///@param customerid Unique identifier
  ///@param documentid Unique identifier
  @Get(path: '/customer/{customerid}/document/{documentid}')
  Future<chopper.Response<WebApiModulesAgentCustomerCustomerDocument>>
      customerCustomeridDocumentDocumentidGet(
          {@Path('customerid') required String? customerid,
          @Path('documentid') required String? documentid});

  ///Update a document.
  ///@param customerid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/customer/{customerid}/document/{documentid}')
  Future<chopper.Response<WebApiModulesAgentCustomerCustomerDocument>>
      customerCustomeridDocumentDocumentidPut(
          {@Path('customerid')
              required String? customerid,
          @Path('documentid')
              required String? documentid,
          @Body()
              required WebApiModulesAgentCustomerCustomerDocumentPutRequest?
                  body});

  ///Delete a document.
  ///@param customerid Unique identifier
  ///@param documentid Unique identifier
  @Delete(path: '/customer/{customerid}/document/{documentid}')
  Future<chopper.Response<bool>> customerCustomeridDocumentDocumentidDelete(
      {@Path('customerid') required String? customerid,
      @Path('documentid') required String? documentid});

  ///Create a new document.
  ///@param customerid Unique identifier
  @Post(path: '/customer/{customerid}/document')
  Future<chopper.Response<WebApiModulesAgentCustomerCustomerDocument>>
      customerCustomeridDocumentPost(
          {@Path('customerid')
              required String? customerid,
          @Body()
              required WebApiModulesAgentCustomerCustomerDocumentPostRequest?
                  body});

  ///Get thumbnails for any images attached to the document.
  ///@param customerid Unique identifier
  ///@param documentid Unique identifier
  ///@param pageno The page number of the result set, starting from page 1.
  ///@param pagesize The number of records per page of the result set.
  @Get(path: '/customer/{customerid}/document/{documentid}/thumbnails')
  Future<
          chopper.Response<
              FwStandardGridsAppDocumentGetDocumentThumbnailsResponse>>
      customerCustomeridDocumentDocumentidThumbnailsGet(
          {@Path('customerid') required String? customerid,
          @Path('documentid') required String? documentid,
          @Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize});

  ///Get a fullsize image.
  ///@param customerid Unique identifier
  ///@param documentid Unique identifier
  ///@param imageid Unique identifier
  @Get(path: '/customer/{customerid}/document/{documentid}/image/{imageid}')
  Future<chopper.Response<FwStandardGridsAppDocumentGetDocumentImageResponse>>
      customerCustomeridDocumentDocumentidImageImageidGet(
          {@Path('customerid') required String? customerid,
          @Path('documentid') required String? documentid,
          @Path('imageid') required String? imageid});

  ///Delete an attached image.
  ///@param customerid Unique identifier
  ///@param documentid Unique identifier
  ///@param imageid Unique identifier
  @Delete(path: '/customer/{customerid}/document/{documentid}/image/{imageid}')
  Future<chopper.Response<bool>>
      customerCustomeridDocumentDocumentidImageImageidDelete(
          {@Path('customerid') required String? customerid,
          @Path('documentid') required String? documentid,
          @Path('imageid') required String? imageid});

  ///Attach an image from a dataurl.
  ///@param customerid Unique identifier
  ///@param documentid Unique identifier
  @Post(path: '/customer/{customerid}/document/{documentid}/image')
  Future<chopper.Response<bool>> customerCustomeridDocumentDocumentidImagePost(
      {@Path('customerid')
          required String? customerid,
      @Path('documentid')
          required String? documentid,
      @Body()
          required FwStandardGridsAppDocumentPostDocumentImageRequest? body});

  ///Attach an image from a form submission.
  ///@param customerid Unique identifier
  ///@param documentid Unique identifier
  @Post(path: '/customer/{customerid}/document/{documentid}/imageformupload')
  Future<chopper.Response<bool>>
      customerCustomeridDocumentDocumentidImageformuploadPost(
          {@Path('customerid') required String? customerid,
          @Path('documentid') required String? documentid});

  ///Get the attached file.
  ///@param customerid Unique identifier
  ///@param documentid Unique identifier
  @Get(path: '/customer/{customerid}/document/{documentid}/file')
  Future<chopper.Response> customerCustomeridDocumentDocumentidFileGet(
      {@Path('customerid') required String? customerid,
      @Path('documentid') required String? documentid});

  ///Update the attached file from a dataurl.
  ///@param customerid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/customer/{customerid}/document/{documentid}/file')
  Future<chopper.Response<bool>> customerCustomeridDocumentDocumentidFilePut(
      {@Path('customerid') required String? customerid,
      @Path('documentid') required String? documentid,
      @Body() required FwStandardGridsAppDocumentPutDocumentFileRequest? body});

  ///Delete attached file.
  ///@param customerid Unique identifier
  ///@param documentid Unique identifier
  @Delete(path: '/customer/{customerid}/document/{documentid}/file')
  Future<chopper.Response<bool>> customerCustomeridDocumentDocumentidFileDelete(
      {@Path('customerid') required String? customerid,
      @Path('documentid') required String? documentid});

  ///Update attached file from a form submission.
  ///@param customerid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/customer/{customerid}/document/{documentid}/fileformupload')
  Future<chopper.Response<bool>>
      customerCustomeridDocumentDocumentidFileformuploadPut(
          {@Path('customerid') required String? customerid,
          @Path('documentid') required String? documentid});

  ///
  ///@param customerid
  @Get(path: '/customer/{customerid}/document/emptyobject')
  Future<chopper.Response> customerCustomeridDocumentEmptyobjectGet(
      {@Path('customerid') required String? customerid});

  ///
  @Post(path: '/customer/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      customerBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/customer/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      customerExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/customer')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAgentCustomerCustomerLogic>>
      customerGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/customer')
  Future<chopper.Response<WebApiModulesAgentCustomerCustomer>> customerPost(
      {@Body() required WebApiModulesAgentCustomerCustomer? body});

  ///
  ///@param id
  @Get(path: '/customer/{id}')
  Future<chopper.Response<WebApiModulesAgentCustomerCustomer>> customerIdGet(
      {@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/customer/{id}')
  Future<chopper.Response<WebApiModulesAgentCustomerCustomer>> customerIdPut(
      {@Path('id') required String? id,
      @Body() required WebApiModulesAgentCustomerCustomer? body});

  ///
  ///@param id
  @Delete(path: '/customer/{id}')
  Future<chopper.Response<bool>> customerIdDelete(
      {@Path('id') required String? id});

  ///
  ///@param LocationId Filter Expression
  ///@param Location Filter Expression
  ///@param PageNo The page number in the result set starting from 1.  PageNo is required when the PageSize is specified.
  ///@param PageSize Limit result set to the specified amount.
  ///@param Sort A sort expression to use of the form: Field1:asc,Field2:desc
  @Get(path: '/customer/lookup/officelocations')
  Future<
          chopper.Response<
              FwStandardModelsGetResponseWebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModel>>
      customerLookupOfficelocationsGet(
          {@Query('LocationId') String? locationId,
          @Query('Location') String? location,
          @Query('PageNo') int? pageNo,
          @Query('PageSize') int? pageSize,
          @Query('Sort') String? sort});

  ///
  @Post(path: '/customer/validatelocation/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      customerValidatelocationBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/customer/validatedepartment/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      customerValidatedepartmentBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/customer/validatecustomertype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      customerValidatecustomertypeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/customer/validatecustomercategory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      customerValidatecustomercategoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/customer/validatecountry/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      customerValidatecountryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/customer/validatecustomerstatus/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      customerValidatecustomerstatusBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/customer/validateparentcustomer/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      customerValidateparentcustomerBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/customer/validatepaymentterms/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      customerValidatepaymenttermsBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/customer/validatecreditstatus/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      customerValidatecreditstatusBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/customer/validateinsurancecompany/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      customerValidateinsurancecompanyBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/customer/validatetaxstateofincorporation/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      customerValidatetaxstateofincorporationBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/customer/emptyobject')
  Future<chopper.Response> customerEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/customer/emptybrowseobject')
  Future<chopper.Response> customerEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/customer/keyfieldnames')
  Future<chopper.Response> customerKeyfieldnamesGet();

  ///
  @Post(path: '/customercredit/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      customercreditBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/customercredit/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      customercreditExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/customercredit/emptyobject')
  Future<chopper.Response> customercreditEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/customercredit/emptybrowseobject')
  Future<chopper.Response> customercreditEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/customercredit/keyfieldnames')
  Future<chopper.Response> customercreditKeyfieldnamesGet();

  ///
  @Post(path: '/customernote/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      customernoteBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/customernote/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      customernoteExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/customernote')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCustomerNoteCustomerNoteLogic>>
      customernoteGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/customernote')
  Future<chopper.Response<WebApiModulesHomeControlsCustomerNoteCustomerNote>>
      customernotePost(
          {@Body()
              required WebApiModulesHomeControlsCustomerNoteCustomerNote?
                  body});

  ///
  ///@param id
  @Get(path: '/customernote/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsCustomerNoteCustomerNote>>
      customernoteIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/customernote/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsCustomerNoteCustomerNote>>
      customernoteIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsCustomerNoteCustomerNote?
                  body});

  ///
  ///@param id
  @Delete(path: '/customernote/{id}')
  Future<chopper.Response<bool>> customernoteIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/customernote/validatenotesby/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      customernoteValidatenotesbyBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/customernote/emptyobject')
  Future<chopper.Response> customernoteEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/customernote/emptybrowseobject')
  Future<chopper.Response> customernoteEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/customernote/keyfieldnames')
  Future<chopper.Response> customernoteKeyfieldnamesGet();

  ///Get documents.
  ///@param dealid Unique identifier
  @Post(path: '/deal/{dealid}/document/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      dealDealidDocumentBrowsePost(
          {@Path('dealid') required String? dealid,
          @Body() required FwStandardModelsBrowseRequest? body});

  ///Export documents to Excel.
  ///@param dealid Unique identifier
  @Post(path: '/deal/{dealid}/document/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      dealDealidDocumentExportexcelxlsxPost(
          {@Path('dealid') required String? dealid,
          @Body() required FwStandardModelsBrowseRequest? body});

  ///Get documents.
  ///@param dealid Unique identifier
  ///@param DocumentTypeId Unique Identifier [Filter|Sort]
  ///@param Description Document description [Filter|Sort]
  ///@param DateStamp Document last modified data [Filter|Sort]
  ///@param PageNo The page number in the result set starting from 1.  PageNo is required when the PageSize is specified.
  ///@param PageSize Limit result set to the specified amount.
  ///@param Sort A sort expression to use of the form: Field1:asc,Field2:desc
  @Get(path: '/deal/{dealid}/documents')
  Future<
          chopper.Response<
              FwStandardModelsGetResponseFwStandardGridsAppDocumentAppDocumentGetManyResponse>>
      dealDealidDocumentsGet(
          {@Path('dealid') required String? dealid,
          @Query('DocumentTypeId') String? documentTypeId,
          @Query('Description') String? description,
          @Query('DateStamp') String? dateStamp,
          @Query('PageNo') int? pageNo,
          @Query('PageSize') int? pageSize,
          @Query('Sort') String? sort});

  ///Get a document.
  ///@param dealid Unique identifier
  ///@param documentid Unique identifier
  @Get(path: '/deal/{dealid}/document/{documentid}')
  Future<chopper.Response<WebApiModulesAgentDealDealDocument>>
      dealDealidDocumentDocumentidGet(
          {@Path('dealid') required String? dealid,
          @Path('documentid') required String? documentid});

  ///Update a document.
  ///@param dealid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/deal/{dealid}/document/{documentid}')
  Future<chopper.Response<WebApiModulesAgentDealDealDocument>>
      dealDealidDocumentDocumentidPut(
          {@Path('dealid') required String? dealid,
          @Path('documentid') required String? documentid,
          @Body() required WebApiModulesAgentDealDealDocumentPutRequest? body});

  ///Delete a document.
  ///@param dealid Unique identifier
  ///@param documentid Unique identifier
  @Delete(path: '/deal/{dealid}/document/{documentid}')
  Future<chopper.Response<bool>> dealDealidDocumentDocumentidDelete(
      {@Path('dealid') required String? dealid,
      @Path('documentid') required String? documentid});

  ///Create a new document.
  ///@param dealid Unique identifier
  @Post(path: '/deal/{dealid}/document')
  Future<chopper.Response<WebApiModulesAgentDealDealDocument>>
      dealDealidDocumentPost(
          {@Path('dealid')
              required String? dealid,
          @Body()
              required WebApiModulesAgentDealDealDocumentPostRequest? body});

  ///Get thumbnails for any images attached to the document.
  ///@param dealid Unique identifier
  ///@param documentid Unique identifier
  ///@param pageno The page number of the result set, starting from page 1.
  ///@param pagesize The number of records per page of the result set.
  @Get(path: '/deal/{dealid}/document/{documentid}/thumbnails')
  Future<
          chopper.Response<
              FwStandardGridsAppDocumentGetDocumentThumbnailsResponse>>
      dealDealidDocumentDocumentidThumbnailsGet(
          {@Path('dealid') required String? dealid,
          @Path('documentid') required String? documentid,
          @Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize});

  ///Get a fullsize image.
  ///@param dealid Unique identifier
  ///@param documentid Unique identifier
  ///@param imageid Unique identifier
  @Get(path: '/deal/{dealid}/document/{documentid}/image/{imageid}')
  Future<chopper.Response<FwStandardGridsAppDocumentGetDocumentImageResponse>>
      dealDealidDocumentDocumentidImageImageidGet(
          {@Path('dealid') required String? dealid,
          @Path('documentid') required String? documentid,
          @Path('imageid') required String? imageid});

  ///Delete an attached image.
  ///@param dealid Unique identifier
  ///@param documentid Unique identifier
  ///@param imageid Unique identifier
  @Delete(path: '/deal/{dealid}/document/{documentid}/image/{imageid}')
  Future<chopper.Response<bool>> dealDealidDocumentDocumentidImageImageidDelete(
      {@Path('dealid') required String? dealid,
      @Path('documentid') required String? documentid,
      @Path('imageid') required String? imageid});

  ///Attach an image from a dataurl.
  ///@param dealid Unique identifier
  ///@param documentid Unique identifier
  @Post(path: '/deal/{dealid}/document/{documentid}/image')
  Future<chopper.Response<bool>> dealDealidDocumentDocumentidImagePost(
      {@Path('dealid')
          required String? dealid,
      @Path('documentid')
          required String? documentid,
      @Body()
          required FwStandardGridsAppDocumentPostDocumentImageRequest? body});

  ///Attach an image from a form submission.
  ///@param dealid Unique identifier
  ///@param documentid Unique identifier
  @Post(path: '/deal/{dealid}/document/{documentid}/imageformupload')
  Future<chopper.Response<bool>>
      dealDealidDocumentDocumentidImageformuploadPost(
          {@Path('dealid') required String? dealid,
          @Path('documentid') required String? documentid});

  ///Get the attached file.
  ///@param dealid Unique identifier
  ///@param documentid Unique identifier
  @Get(path: '/deal/{dealid}/document/{documentid}/file')
  Future<chopper.Response> dealDealidDocumentDocumentidFileGet(
      {@Path('dealid') required String? dealid,
      @Path('documentid') required String? documentid});

  ///Update the attached file from a dataurl.
  ///@param dealid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/deal/{dealid}/document/{documentid}/file')
  Future<chopper.Response<bool>> dealDealidDocumentDocumentidFilePut(
      {@Path('dealid') required String? dealid,
      @Path('documentid') required String? documentid,
      @Body() required FwStandardGridsAppDocumentPutDocumentFileRequest? body});

  ///Delete attached file.
  ///@param dealid Unique identifier
  ///@param documentid Unique identifier
  @Delete(path: '/deal/{dealid}/document/{documentid}/file')
  Future<chopper.Response<bool>> dealDealidDocumentDocumentidFileDelete(
      {@Path('dealid') required String? dealid,
      @Path('documentid') required String? documentid});

  ///Update attached file from a form submission.
  ///@param dealid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/deal/{dealid}/document/{documentid}/fileformupload')
  Future<chopper.Response<bool>> dealDealidDocumentDocumentidFileformuploadPut(
      {@Path('dealid') required String? dealid,
      @Path('documentid') required String? documentid});

  ///
  ///@param dealid
  @Get(path: '/deal/{dealid}/document/emptyobject')
  Future<chopper.Response> dealDealidDocumentEmptyobjectGet(
      {@Path('dealid') required String? dealid});

  ///
  @Post(path: '/deal/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>> dealBrowsePost(
      {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/deal/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      dealExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/deal')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAgentDealDealLogic>>
      dealGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/deal')
  Future<chopper.Response<WebApiModulesAgentDealDeal>> dealPost(
      {@Body() required WebApiModulesAgentDealDeal? body});

  ///
  ///@param id
  @Get(path: '/deal/{id}')
  Future<chopper.Response<WebApiModulesAgentDealDeal>> dealIdGet(
      {@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/deal/{id}')
  Future<chopper.Response<WebApiModulesAgentDealDeal>> dealIdPut(
      {@Path('id') required String? id,
      @Body() required WebApiModulesAgentDealDeal? body});

  ///
  ///@param id
  @Delete(path: '/deal/{id}')
  Future<chopper.Response<bool>> dealIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/deal/many')
  Future<
          chopper.Response<
              List<
                  MicrosoftAspNetCoreMvcActionResultWebApiModulesAgentDealDealLogic>>>
      dealManyPost({@Body() required List<WebApiModulesAgentDealDeal>? body});

  ///
  @Post(path: '/deal/validatecustomer/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      dealValidatecustomerBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/deal/validateofficelocation/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      dealValidateofficelocationBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/deal/validatedepartment/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      dealValidatedepartmentBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/deal/validatedealtype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      dealValidatedealtypeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/deal/validatedealclassification/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      dealValidatedealclassificationBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/deal/validateproductiontype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      dealValidateproductiontypeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/deal/validatecsr/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      dealValidatecsrBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/deal/validateagent/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      dealValidateagentBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/deal/validateprojectmanager/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      dealValidateprojectmanagerBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/deal/validatecountry/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      dealValidatecountryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/deal/validatedealstatus/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      dealValidatedealstatusBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/deal/validatebillingcycle/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      dealValidatebillingcycleBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/deal/validatepaymenttype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      dealValidatepaymenttypeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/deal/validatepaymentterms/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      dealValidatepaymenttermsBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/deal/validateorderrate/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      dealValidateorderrateBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/deal/validatesalesrepresentative/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      dealValidatesalesrepresentativeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/deal/validatecreditstatus/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      dealValidatecreditstatusBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/deal/validateinsurancecompany/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      dealValidateinsurancecompanyBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/deal/validateshipcountry/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      dealValidateshipcountryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param id
  @Post(path: '/deal/{id}/copycontactsfromcustomer', optionalBody: true)
  Future<
          chopper
              .Response<WebApiModulesAgentDealCopyContactsFromCustomerResponse>>
      dealIdCopycontactsfromcustomerPost({@Path('id') required String? id});

  ///Get an empty object
  @Get(path: '/deal/emptyobject')
  Future<chopper.Response> dealEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/deal/emptybrowseobject')
  Future<chopper.Response> dealEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/deal/keyfieldnames')
  Future<chopper.Response> dealKeyfieldnamesGet();

  ///
  @Post(path: '/dealcredit/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      dealcreditBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/dealcredit/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      dealcreditExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/dealcredit/refund')
  Future<
          chopper.Response<
              WebApiModulesPluginsProcessCreditCardProcessCreditCardPaymentResponse>>
      dealcreditRefundPost(
          {@Body()
              required WebApiModulesBillingReceiptCreditCardRefundRequest?
                  body});

  ///Get an empty object
  @Get(path: '/dealcredit/emptyobject')
  Future<chopper.Response> dealcreditEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/dealcredit/emptybrowseobject')
  Future<chopper.Response> dealcreditEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/dealcredit/keyfieldnames')
  Future<chopper.Response> dealcreditKeyfieldnamesGet();

  ///
  @Post(path: '/dealnote/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      dealnoteBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/dealnote/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      dealnoteExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/dealnote')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealNoteDealNoteLogic>>
      dealnoteGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/dealnote')
  Future<chopper.Response<WebApiModulesHomeControlsDealNoteDealNote>>
      dealnotePost(
          {@Body() required WebApiModulesHomeControlsDealNoteDealNote? body});

  ///
  ///@param id
  @Get(path: '/dealnote/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsDealNoteDealNote>>
      dealnoteIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/dealnote/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsDealNoteDealNote>>
      dealnoteIdPut(
          {@Path('id') required String? id,
          @Body() required WebApiModulesHomeControlsDealNoteDealNote? body});

  ///
  ///@param id
  @Delete(path: '/dealnote/{id}')
  Future<chopper.Response<bool>> dealnoteIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/dealnote/validatenotesby/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      dealnoteValidatenotesbyBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/dealnote/emptyobject')
  Future<chopper.Response> dealnoteEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/dealnote/emptybrowseobject')
  Future<chopper.Response> dealnoteEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/dealnote/keyfieldnames')
  Future<chopper.Response> dealnoteKeyfieldnamesGet();

  ///
  @Post(path: '/dealshipper/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      dealshipperBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/dealshipper/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      dealshipperExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/dealshipper')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealShipperDealShipperLogic>>
      dealshipperGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/dealshipper')
  Future<chopper.Response<WebApiModulesHomeControlsDealShipperDealShipper>>
      dealshipperPost(
          {@Body()
              required WebApiModulesHomeControlsDealShipperDealShipper? body});

  ///
  ///@param id
  @Get(path: '/dealshipper/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsDealShipperDealShipper>>
      dealshipperIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/dealshipper/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsDealShipperDealShipper>>
      dealshipperIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsDealShipperDealShipper? body});

  ///
  ///@param id
  @Delete(path: '/dealshipper/{id}')
  Future<chopper.Response<bool>> dealshipperIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/dealshipper/validatecarrier/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      dealshipperValidatecarrierBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/dealshipper/validateshipvia/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      dealshipperValidateshipviaBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/dealshipper/emptyobject')
  Future<chopper.Response> dealshipperEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/dealshipper/emptybrowseobject')
  Future<chopper.Response> dealshipperEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/dealshipper/keyfieldnames')
  Future<chopper.Response> dealshipperKeyfieldnamesGet();

  ///
  @Post(path: '/delivery/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      deliveryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/delivery/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      deliveryExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/delivery')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDeliveryDeliveryLogic>>
      deliveryGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/delivery')
  Future<chopper.Response<WebApiModulesHomeControlsDeliveryDelivery>>
      deliveryPost(
          {@Body() required WebApiModulesHomeControlsDeliveryDelivery? body});

  ///
  ///@param id
  @Get(path: '/delivery/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsDeliveryDelivery>>
      deliveryIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/delivery/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsDeliveryDelivery>>
      deliveryIdPut(
          {@Path('id') required String? id,
          @Body() required WebApiModulesHomeControlsDeliveryDelivery? body});

  ///
  ///@param id
  @Delete(path: '/delivery/{id}')
  Future<chopper.Response<bool>> deliveryIdDelete(
      {@Path('id') required String? id});

  ///Get an empty object
  @Get(path: '/delivery/emptyobject')
  Future<chopper.Response> deliveryEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/delivery/emptybrowseobject')
  Future<chopper.Response> deliveryEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/delivery/keyfieldnames')
  Future<chopper.Response> deliveryKeyfieldnamesGet();

  ///
  @Post(path: '/depositpayment/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      depositpaymentBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/depositpayment/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      depositpaymentExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/depositpayment')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepositPaymentDepositPaymentLogic>>
      depositpaymentGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  ///@param id
  @Get(path: '/depositpayment/{id}')
  Future<
          chopper
              .Response<WebApiModulesHomeControlsDepositPaymentDepositPayment>>
      depositpaymentIdGet({@Path('id') required String? id});

  ///Get an empty object
  @Get(path: '/depositpayment/emptyobject')
  Future<chopper.Response> depositpaymentEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/depositpayment/emptybrowseobject')
  Future<chopper.Response> depositpaymentEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/depositpayment/keyfieldnames')
  Future<chopper.Response> depositpaymentKeyfieldnamesGet();

  ///
  @Get(path: '/depreciation/legend')
  Future<chopper.Response<Object>> depreciationLegendGet();

  ///
  @Post(path: '/depreciation/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      depreciationBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/depreciation/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      depreciationExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/depreciation')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepreciationDepreciationLogic>>
      depreciationGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/depreciation')
  Future<chopper.Response<WebApiModulesHomeControlsDepreciationDepreciation>>
      depreciationPost(
          {@Body()
              required WebApiModulesHomeControlsDepreciationDepreciation?
                  body});

  ///
  ///@param id
  @Get(path: '/depreciation/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsDepreciationDepreciation>>
      depreciationIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/depreciation/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsDepreciationDepreciation>>
      depreciationIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsDepreciationDepreciation?
                  body});

  ///Get an empty object
  @Get(path: '/depreciation/emptyobject')
  Future<chopper.Response> depreciationEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/depreciation/emptybrowseobject')
  Future<chopper.Response> depreciationEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/depreciation/keyfieldnames')
  Future<chopper.Response> depreciationKeyfieldnamesGet();

  ///
  @Post(path: '/emptycontainer/validatecontaineritem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      emptycontainerValidatecontaineritemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/emptycontainer/emptyobject')
  Future<chopper.Response> emptycontainerEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/emptycontainer/emptybrowseobject')
  Future<chopper.Response> emptycontainerEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/emptycontainer/keyfieldnames')
  Future<chopper.Response> emptycontainerKeyfieldnamesGet();

  ///
  ///@param warehouseId
  @Get(path: '/exchange/suspendedsessionsexist')
  Future<chopper.Response<bool>> exchangeSuspendedsessionsexistGet(
      {@Query('warehouseId') String? warehouseId});

  ///
  @Post(path: '/exchange/exchangeitemin')
  Future<chopper.Response<WebApiModulesWarehouseExchangeExchangeItemInResponse>>
      exchangeExchangeiteminPost(
          {@Body()
              required WebApiModulesWarehouseExchangeExchangeItemRequest?
                  body});

  ///
  @Post(path: '/exchange/exchangeitemout')
  Future<
          chopper
              .Response<WebApiModulesWarehouseExchangeExchangeItemOutResponse>>
      exchangeExchangeitemoutPost(
          {@Body()
              required WebApiModulesWarehouseExchangeExchangeItemRequest?
                  body});

  ///
  @Post(path: '/exchange/startexchangecontract')
  Future<
          chopper
              .Response<WebApiModulesWarehouseExchangeExchangeContractResponse>>
      exchangeStartexchangecontractPost(
          {@Body()
              required WebApiModulesWarehouseExchangeExchangeContractRequest?
                  body});

  ///
  ///@param id
  @Post(path: '/exchange/completeexchangecontract/{id}', optionalBody: true)
  Future<chopper.Response<WebApiModulesWarehouseContractContract>>
      exchangeCompleteexchangecontractIdPost({@Path('id') required String? id});

  ///
  @Post(path: '/exchange/cancelcontract')
  Future<chopper.Response<WebApiLogicTSpStatusResponse>>
      exchangeCancelcontractPost(
          {@Body()
              required WebApiModulesWarehouseContractCancelContractRequest?
                  body});

  ///
  @Post(path: '/exchange/validatedeal/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      exchangeValidatedealBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/exchange/validateorder/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      exchangeValidateorderBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/exchange/emptyobject')
  Future<chopper.Response> exchangeEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/exchange/emptybrowseobject')
  Future<chopper.Response> exchangeEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/exchange/keyfieldnames')
  Future<chopper.Response> exchangeKeyfieldnamesGet();

  ///
  @Post(path: '/exchangeitem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      exchangeitemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/exchangeitem/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      exchangeitemExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Get(path: '/exchangeitem/legend')
  Future<chopper.Response<Object>> exchangeitemLegendGet();

  ///Get an empty object
  @Get(path: '/exchangeitem/emptyobject')
  Future<chopper.Response> exchangeitemEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/exchangeitem/emptybrowseobject')
  Future<chopper.Response> exchangeitemEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/exchangeitem/keyfieldnames')
  Future<chopper.Response> exchangeitemKeyfieldnamesGet();

  ///Get an empty object
  @Get(path: '/fillcontainer/emptyobject')
  Future<chopper.Response> fillcontainerEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/fillcontainer/emptybrowseobject')
  Future<chopper.Response> fillcontainerEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/fillcontainer/keyfieldnames')
  Future<chopper.Response> fillcontainerKeyfieldnamesGet();

  ///
  @Post(path: '/generalitem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      generalitemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/generalitem/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      generalitemExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/generalitem/sort')
  Future<chopper.Response<WebApiLogicSortItemsResponse>> generalitemSortPost(
      {@Body()
          required WebApiModulesHomeControlsGeneralItemSortGeneralItemRequest?
              body});

  ///Get an empty object
  @Get(path: '/generalitem/emptyobject')
  Future<chopper.Response> generalitemEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/generalitem/emptybrowseobject')
  Future<chopper.Response> generalitemEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/generalitem/keyfieldnames')
  Future<chopper.Response> generalitemKeyfieldnamesGet();

  ///
  @Post(path: '/gldistribution/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      gldistributionBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/gldistribution/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      gldistributionExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/gldistribution/refresh')
  Future<
          chopper.Response<
              WebApiModulesUtilitiesGLDistributionRefreshGLHistoryResponse>>
      gldistributionRefreshPost(
          {@Body()
              required WebApiModulesUtilitiesGLDistributionRefreshGLHistoryRequest?
                  body});

  ///Get an empty object
  @Get(path: '/gldistribution/emptyobject')
  Future<chopper.Response> gldistributionEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/gldistribution/emptybrowseobject')
  Future<chopper.Response> gldistributionEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/gldistribution/keyfieldnames')
  Future<chopper.Response> gldistributionKeyfieldnamesGet();

  ///
  @Post(path: '/glmanual/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      glmanualBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/glmanual/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      glmanualExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/glmanual')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsGlManualGlManualLogic>>
      glmanualGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/glmanual')
  Future<chopper.Response<WebApiModulesHomeControlsGlManualGlManual>>
      glmanualPost(
          {@Body() required WebApiModulesHomeControlsGlManualGlManual? body});

  ///
  ///@param id
  @Get(path: '/glmanual/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsGlManualGlManual>>
      glmanualIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/glmanual/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsGlManualGlManual>>
      glmanualIdPut(
          {@Path('id') required String? id,
          @Body() required WebApiModulesHomeControlsGlManualGlManual? body});

  ///
  ///@param id
  @Delete(path: '/glmanual/{id}')
  Future<chopper.Response<bool>> glmanualIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/glmanual/debitglaccount/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      glmanualDebitglaccountBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/glmanual/creditglaccount/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      glmanualCreditglaccountBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/glmanual/emptyobject')
  Future<chopper.Response> glmanualEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/glmanual/emptybrowseobject')
  Future<chopper.Response> glmanualEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/glmanual/keyfieldnames')
  Future<chopper.Response> glmanualKeyfieldnamesGet();

  ///
  @Post(path: '/inventoryattributevalue/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      inventoryattributevalueBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/inventoryattributevalue/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      inventoryattributevalueExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/inventoryattributevalue')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValueLogic>>
      inventoryattributevalueGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/inventoryattributevalue')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValue>>
      inventoryattributevaluePost(
          {@Body()
              required WebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValue?
                  body});

  ///
  ///@param id
  @Get(path: '/inventoryattributevalue/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValue>>
      inventoryattributevalueIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/inventoryattributevalue/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValue>>
      inventoryattributevalueIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValue?
                  body});

  ///
  ///@param id
  @Delete(path: '/inventoryattributevalue/{id}')
  Future<chopper.Response<bool>> inventoryattributevalueIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/inventoryattributevalue/validateattribute/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      inventoryattributevalueValidateattributeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/inventoryattributevalue/validateattributevalue/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      inventoryattributevalueValidateattributevalueBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/inventoryattributevalue/emptyobject')
  Future<chopper.Response> inventoryattributevalueEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/inventoryattributevalue/emptybrowseobject')
  Future<chopper.Response> inventoryattributevalueEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/inventoryattributevalue/keyfieldnames')
  Future<chopper.Response> inventoryattributevalueKeyfieldnamesGet();

  ///
  @Post(path: '/inventoryavailability/getinventoryavailability')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailability>>
      inventoryavailabilityGetinventoryavailabilityPost(
          {@Body()
              required WebApiModulesHomeControlsInventoryAvailabilityAvailabilityInventoryWarehouseRequest?
                  body});

  ///
  @Post(path: '/inventoryavailability/calendarandscheduledata')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarAndScheduleResponse>>
      inventoryavailabilityCalendarandscheduledataPost(
          {@Body()
              required WebApiModulesHomeControlsInventoryAvailabilityAvailabilityCalendarAndScheduleRequest?
                  body});

  ///
  @Post(path: '/inventoryavailability/conflicts')
  Future<
          chopper.Response<
              List<
                  WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictResponseItem>>>
      inventoryavailabilityConflictsPost(
          {@Body()
              required WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictRequest?
                  body});

  ///Get an empty object
  @Get(path: '/inventoryavailability/emptyobject')
  Future<chopper.Response> inventoryavailabilityEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/inventoryavailability/emptybrowseobject')
  Future<chopper.Response> inventoryavailabilityEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/inventoryavailability/keyfieldnames')
  Future<chopper.Response> inventoryavailabilityKeyfieldnamesGet();

  ///
  @Post(path: '/inventorycolor/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      inventorycolorBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/inventorycolor/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      inventorycolorExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/inventorycolor')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryColorInventoryColorLogic>>
      inventorycolorGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/inventorycolor')
  Future<
          chopper
              .Response<WebApiModulesHomeControlsInventoryColorInventoryColor>>
      inventorycolorPost(
          {@Body()
              required WebApiModulesHomeControlsInventoryColorInventoryColor?
                  body});

  ///
  ///@param id
  @Get(path: '/inventorycolor/{id}')
  Future<
          chopper
              .Response<WebApiModulesHomeControlsInventoryColorInventoryColor>>
      inventorycolorIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/inventorycolor/{id}')
  Future<
          chopper
              .Response<WebApiModulesHomeControlsInventoryColorInventoryColor>>
      inventorycolorIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsInventoryColorInventoryColor?
                  body});

  ///
  ///@param id
  @Delete(path: '/inventorycolor/{id}')
  Future<chopper.Response<bool>> inventorycolorIdDelete(
      {@Path('id') required String? id});

  ///Get an empty object
  @Get(path: '/inventorycolor/emptyobject')
  Future<chopper.Response> inventorycolorEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/inventorycolor/emptybrowseobject')
  Future<chopper.Response> inventorycolorEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/inventorycolor/keyfieldnames')
  Future<chopper.Response> inventorycolorKeyfieldnamesGet();

  ///
  @Post(path: '/inventorycompatible/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      inventorycompatibleBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/inventorycompatible/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      inventorycompatibleExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/inventorycompatible')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompatibleInventoryCompatibleLogic>>
      inventorycompatibleGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/inventorycompatible')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryCompatibleInventoryCompatible>>
      inventorycompatiblePost(
          {@Body()
              required WebApiModulesHomeControlsInventoryCompatibleInventoryCompatible?
                  body});

  ///
  ///@param id
  @Get(path: '/inventorycompatible/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryCompatibleInventoryCompatible>>
      inventorycompatibleIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/inventorycompatible/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryCompatibleInventoryCompatible>>
      inventorycompatibleIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsInventoryCompatibleInventoryCompatible?
                  body});

  ///
  ///@param id
  @Delete(path: '/inventorycompatible/{id}')
  Future<chopper.Response<bool>> inventorycompatibleIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(
      path: '/inventorycompatible/validatecompatiblewithinventoryrental/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      inventorycompatibleValidatecompatiblewithinventoryrentalBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(
      path: '/inventorycompatible/validatecompatiblewithinventorysales/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      inventorycompatibleValidatecompatiblewithinventorysalesBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/inventorycompatible/emptyobject')
  Future<chopper.Response> inventorycompatibleEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/inventorycompatible/emptybrowseobject')
  Future<chopper.Response> inventorycompatibleEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/inventorycompatible/keyfieldnames')
  Future<chopper.Response> inventorycompatibleKeyfieldnamesGet();

  ///
  @Post(path: '/inventorycompletekit/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      inventorycompletekitBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/inventorycompletekit/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      inventorycompletekitExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/inventorycompletekit')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKitLogic>>
      inventorycompletekitGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  ///@param id
  @Get(path: '/inventorycompletekit/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKit>>
      inventorycompletekitIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Post(path: '/inventorycompletekit/createcomplete/{id}', optionalBody: true)
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryCompleteKitCreateCompleteResponse>>
      inventorycompletekitCreatecompleteIdPost(
          {@Path('id') required String? id});

  ///Get an empty object
  @Get(path: '/inventorycompletekit/emptyobject')
  Future<chopper.Response> inventorycompletekitEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/inventorycompletekit/emptybrowseobject')
  Future<chopper.Response> inventorycompletekitEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/inventorycompletekit/keyfieldnames')
  Future<chopper.Response> inventorycompletekitKeyfieldnamesGet();

  ///
  @Post(path: '/inventoryconsignor/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      inventoryconsignorBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/inventoryconsignor/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      inventoryconsignorExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/inventoryconsignor')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryConsignorInventoryConsignorLogic>>
      inventoryconsignorGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  ///@param id
  @Get(path: '/inventoryconsignor/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryConsignorInventoryConsignor>>
      inventoryconsignorIdGet({@Path('id') required String? id});

  ///Get an empty object
  @Get(path: '/inventoryconsignor/emptyobject')
  Future<chopper.Response> inventoryconsignorEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/inventoryconsignor/emptybrowseobject')
  Future<chopper.Response> inventoryconsignorEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/inventoryconsignor/keyfieldnames')
  Future<chopper.Response> inventoryconsignorKeyfieldnamesGet();

  ///
  @Post(path: '/inventorycontaineritem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      inventorycontaineritemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/inventorycontaineritem/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      inventorycontaineritemExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/inventorycontaineritem')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryContainerItemInventoryContainerItemLogic>>
      inventorycontaineritemGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/inventorycontaineritem')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryContainerItemInventoryContainerItem>>
      inventorycontaineritemPost(
          {@Body()
              required WebApiModulesHomeControlsInventoryContainerItemInventoryContainerItem?
                  body});

  ///
  ///@param id
  @Get(path: '/inventorycontaineritem/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryContainerItemInventoryContainerItem>>
      inventorycontaineritemIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/inventorycontaineritem/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryContainerItemInventoryContainerItem>>
      inventorycontaineritemIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsInventoryContainerItemInventoryContainerItem?
                  body});

  ///
  ///@param id
  @Delete(path: '/inventorycontaineritem/{id}')
  Future<chopper.Response<bool>> inventorycontaineritemIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/inventorycontaineritem/sort')
  Future<
      chopper.Response<
          WebApiLogicSortItemsResponse>> inventorycontaineritemSortPost(
      {@Body()
          required WebApiModulesHomeControlsInventoryContainerItemSortContainerItemsRequest?
              body});

  ///Get an empty object
  @Get(path: '/inventorycontaineritem/emptyobject')
  Future<chopper.Response> inventorycontaineritemEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/inventorycontaineritem/emptybrowseobject')
  Future<chopper.Response> inventorycontaineritemEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/inventorycontaineritem/keyfieldnames')
  Future<chopper.Response> inventorycontaineritemKeyfieldnamesGet();

  ///
  @Post(path: '/inventorylocationtax/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      inventorylocationtaxBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/inventorylocationtax/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      inventorylocationtaxExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/inventorylocationtax')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTaxLogic>>
      inventorylocationtaxGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/inventorylocationtax')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTax>>
      inventorylocationtaxPost(
          {@Body()
              required WebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTax?
                  body});

  ///
  ///@param id
  @Get(path: '/inventorylocationtax/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTax>>
      inventorylocationtaxIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/inventorylocationtax/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTax>>
      inventorylocationtaxIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTax?
                  body});

  ///
  ///@param id
  @Delete(path: '/inventorylocationtax/{id}')
  Future<chopper.Response<bool>> inventorylocationtaxIdDelete(
      {@Path('id') required String? id});

  ///Get an empty object
  @Get(path: '/inventorylocationtax/emptyobject')
  Future<chopper.Response> inventorylocationtaxEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/inventorylocationtax/emptybrowseobject')
  Future<chopper.Response> inventorylocationtaxEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/inventorylocationtax/keyfieldnames')
  Future<chopper.Response> inventorylocationtaxKeyfieldnamesGet();

  ///
  @Post(path: '/inventorymaterial/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      inventorymaterialBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/inventorymaterial/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      inventorymaterialExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/inventorymaterial')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryMaterialInventoryMaterialLogic>>
      inventorymaterialGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/inventorymaterial')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryMaterialInventoryMaterial>>
      inventorymaterialPost(
          {@Body()
              required WebApiModulesHomeControlsInventoryMaterialInventoryMaterial?
                  body});

  ///
  ///@param id
  @Get(path: '/inventorymaterial/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryMaterialInventoryMaterial>>
      inventorymaterialIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/inventorymaterial/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryMaterialInventoryMaterial>>
      inventorymaterialIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsInventoryMaterialInventoryMaterial?
                  body});

  ///
  ///@param id
  @Delete(path: '/inventorymaterial/{id}')
  Future<chopper.Response<bool>> inventorymaterialIdDelete(
      {@Path('id') required String? id});

  ///Get an empty object
  @Get(path: '/inventorymaterial/emptyobject')
  Future<chopper.Response> inventorymaterialEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/inventorymaterial/emptybrowseobject')
  Future<chopper.Response> inventorymaterialEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/inventorymaterial/keyfieldnames')
  Future<chopper.Response> inventorymaterialKeyfieldnamesGet();

  ///
  @Post(path: '/inventorypackageinventory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      inventorypackageinventoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/inventorypackageinventory/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      inventorypackageinventoryExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Get(path: '/inventorypackageinventory/legend')
  Future<chopper.Response<Object>> inventorypackageinventoryLegendGet();

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/inventorypackageinventory')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventoryLogic>>
      inventorypackageinventoryGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/inventorypackageinventory')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventory>>
      inventorypackageinventoryPost(
          {@Body()
              required WebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventory?
                  body});

  ///
  ///@param id
  @Get(path: '/inventorypackageinventory/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventory>>
      inventorypackageinventoryIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/inventorypackageinventory/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventory>>
      inventorypackageinventoryIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventory?
                  body});

  ///
  ///@param id
  @Delete(path: '/inventorypackageinventory/{id}')
  Future<chopper.Response<bool>> inventorypackageinventoryIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/inventorypackageinventory/sort')
  Future<
      chopper.Response<
          WebApiLogicSortItemsResponse>> inventorypackageinventorySortPost(
      {@Body()
          required WebApiModulesHomeControlsInventoryPackageInventorySortInventoryPackageInventorysRequest?
              body});

  ///Get an empty object
  @Get(path: '/inventorypackageinventory/emptyobject')
  Future<chopper.Response> inventorypackageinventoryEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/inventorypackageinventory/emptybrowseobject')
  Future<chopper.Response> inventorypackageinventoryEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/inventorypackageinventory/keyfieldnames')
  Future<chopper.Response> inventorypackageinventoryKeyfieldnamesGet();

  ///
  @Post(path: '/inventoryprep/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      inventoryprepBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/inventoryprep/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      inventoryprepExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/inventoryprep')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPrepInventoryPrepLogic>>
      inventoryprepGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/inventoryprep')
  Future<chopper.Response<WebApiModulesHomeControlsInventoryPrepInventoryPrep>>
      inventoryprepPost(
          {@Body()
              required WebApiModulesHomeControlsInventoryPrepInventoryPrep?
                  body});

  ///
  ///@param id
  @Get(path: '/inventoryprep/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsInventoryPrepInventoryPrep>>
      inventoryprepIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/inventoryprep/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsInventoryPrepInventoryPrep>>
      inventoryprepIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsInventoryPrepInventoryPrep?
                  body});

  ///
  ///@param id
  @Delete(path: '/inventoryprep/{id}')
  Future<chopper.Response<bool>> inventoryprepIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/inventoryprep/validatepreprate/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      inventoryprepValidatepreprateBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/inventoryprep/emptyobject')
  Future<chopper.Response> inventoryprepEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/inventoryprep/emptybrowseobject')
  Future<chopper.Response> inventoryprepEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/inventoryprep/keyfieldnames')
  Future<chopper.Response> inventoryprepKeyfieldnamesGet();

  ///
  @Post(path: '/inventorypurchaseitem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      inventorypurchaseitemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/inventorypurchaseitem/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      inventorypurchaseitemExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/inventorypurchaseitem')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItemLogic>>
      inventorypurchaseitemGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  ///@param id
  @Get(path: '/inventorypurchaseitem/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItem>>
      inventorypurchaseitemIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/inventorypurchaseitem/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItem>>
      inventorypurchaseitemIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItem?
                  body});

  ///Get an empty object
  @Get(path: '/inventorypurchaseitem/emptyobject')
  Future<chopper.Response> inventorypurchaseitemEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/inventorypurchaseitem/emptybrowseobject')
  Future<chopper.Response> inventorypurchaseitemEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/inventorypurchaseitem/keyfieldnames')
  Future<chopper.Response> inventorypurchaseitemKeyfieldnamesGet();

  ///
  @Post(path: '/inventorysearch/search')
  Future<
      chopper.Response<
          FwStandardSqlServerFwJsonDataTable>> inventorysearchSearchPost(
      {@Body()
          required WebApiModulesHomeControlsInventorySearchInventorySearchRequest?
              body});

  ///
  @Post(path: '/inventorysearch/accessories')
  Future<
      chopper.Response<
          FwStandardSqlServerFwJsonDataTable>> inventorysearchAccessoriesPost(
      {@Body()
          required WebApiModulesHomeControlsInventorySearchInventorySearchAccessoriesRequest?
              body});

  ///
  @Post(path: '/inventorysearch')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventorySearchInventorySearch>>
      inventorysearchPost(
          {@Body()
              required WebApiModulesHomeControlsInventorySearchInventorySearch?
                  body});

  ///
  ///@param sessionId
  @Get(path: '/inventorysearch/gettotal/{sessionid}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventorySearchInventorySearchGetTotalResponse>>
      inventorysearchGettotalSessionidGet(
          {@Path('sessionId') required String? sessionId});

  ///
  @Post(path: '/inventorysearch/addtoorder')
  Future<chopper.Response<bool>> inventorysearchAddtoorderPost(
      {@Body()
          required WebApiModulesHomeControlsInventorySearchInventorySearchAddToOrderRequest?
              body});

  ///
  @Post(path: '/inventorysearch/addtopackage')
  Future<chopper.Response<bool>> inventorysearchAddtopackagePost(
      {@Body()
          required WebApiModulesHomeControlsInventorySearchInventorySearchAddToCompleteKitContainerRequest?
              body});

  ///
  @Post(path: '/inventorysearch/savenote')
  Future<chopper.Response<bool>> inventorysearchSavenotePost(
      {@Body()
          required WebApiModulesHomeControlsInventorySearchInventorySearchSaveNoteRequest?
              body});

  ///Get an empty object
  @Get(path: '/inventorysearch/emptyobject')
  Future<chopper.Response> inventorysearchEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/inventorysearch/emptybrowseobject')
  Future<chopper.Response> inventorysearchEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/inventorysearch/keyfieldnames')
  Future<chopper.Response> inventorysearchKeyfieldnamesGet();

  ///
  @Post(path: '/inventorysearchpreview/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      inventorysearchpreviewBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/inventorysearchpreview')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventorySearchPreviewInventorySearchPreview>>
      inventorysearchpreviewPost(
          {@Body()
              required WebApiModulesHomeControlsInventorySearchPreviewInventorySearchPreview?
                  body});

  ///
  ///@param id
  @Put(path: '/inventorysearchpreview/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventorySearchPreviewInventorySearchPreview>>
      inventorysearchpreviewIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsInventorySearchPreviewInventorySearchPreview?
                  body});

  ///
  ///@param id
  @Delete(path: '/inventorysearchpreview/{id}')
  Future<chopper.Response<bool>> inventorysearchpreviewIdDelete(
      {@Path('id') required String? id});

  ///Get an empty object
  @Get(path: '/inventorysearchpreview/emptyobject')
  Future<chopper.Response> inventorysearchpreviewEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/inventorysearchpreview/emptybrowseobject')
  Future<chopper.Response> inventorysearchpreviewEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/inventorysearchpreview/keyfieldnames')
  Future<chopper.Response> inventorysearchpreviewKeyfieldnamesGet();

  ///
  @Post(path: '/inventorysubstitute/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      inventorysubstituteBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/inventorysubstitute/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      inventorysubstituteExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/inventorysubstitute')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventorySubstituteInventorySubstituteLogic>>
      inventorysubstituteGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/inventorysubstitute')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventorySubstituteInventorySubstitute>>
      inventorysubstitutePost(
          {@Body()
              required WebApiModulesHomeControlsInventorySubstituteInventorySubstitute?
                  body});

  ///
  ///@param id
  @Get(path: '/inventorysubstitute/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventorySubstituteInventorySubstitute>>
      inventorysubstituteIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/inventorysubstitute/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventorySubstituteInventorySubstitute>>
      inventorysubstituteIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsInventorySubstituteInventorySubstitute?
                  body});

  ///
  ///@param id
  @Delete(path: '/inventorysubstitute/{id}')
  Future<chopper.Response<bool>> inventorysubstituteIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/inventorysubstitute/validatesubstituteinventoryrental/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      inventorysubstituteValidatesubstituteinventoryrentalBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/inventorysubstitute/validatesubstituteinventorysales/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      inventorysubstituteValidatesubstituteinventorysalesBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/inventorysubstitute/validatesubstituteinventoryparts/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      inventorysubstituteValidatesubstituteinventorypartsBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/inventorysubstitute/emptyobject')
  Future<chopper.Response> inventorysubstituteEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/inventorysubstitute/emptybrowseobject')
  Future<chopper.Response> inventorysubstituteEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/inventorysubstitute/keyfieldnames')
  Future<chopper.Response> inventorysubstituteKeyfieldnamesGet();

  ///
  @Post(path: '/inventorysummaryout/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      inventorysummaryoutBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/inventorysummaryout/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      inventorysummaryoutExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Get(path: '/inventorysummaryout/legend')
  Future<chopper.Response<Object>> inventorysummaryoutLegendGet();

  ///Get an empty object
  @Get(path: '/inventorysummaryout/emptyobject')
  Future<chopper.Response> inventorysummaryoutEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/inventorysummaryout/emptybrowseobject')
  Future<chopper.Response> inventorysummaryoutEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/inventorysummaryout/keyfieldnames')
  Future<chopper.Response> inventorysummaryoutKeyfieldnamesGet();

  ///
  @Post(path: '/inventorysummaryphysicalinventory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      inventorysummaryphysicalinventoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/inventorysummaryphysicalinventory/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      inventorysummaryphysicalinventoryExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/inventorysummaryphysicalinventory/emptyobject')
  Future<chopper.Response> inventorysummaryphysicalinventoryEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/inventorysummaryphysicalinventory/emptybrowseobject')
  Future<chopper.Response>
      inventorysummaryphysicalinventoryEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/inventorysummaryphysicalinventory/keyfieldnames')
  Future<chopper.Response> inventorysummaryphysicalinventoryKeyfieldnamesGet();

  ///
  @Post(path: '/inventorysummaryretiredhistory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      inventorysummaryretiredhistoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/inventorysummaryretiredhistory/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      inventorysummaryretiredhistoryExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/inventorysummaryretiredhistory/emptyobject')
  Future<chopper.Response> inventorysummaryretiredhistoryEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/inventorysummaryretiredhistory/emptybrowseobject')
  Future<chopper.Response> inventorysummaryretiredhistoryEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/inventorysummaryretiredhistory/keyfieldnames')
  Future<chopper.Response> inventorysummaryretiredhistoryKeyfieldnamesGet();

  ///
  @Post(path: '/inventoryvendor/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      inventoryvendorBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/inventoryvendor/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      inventoryvendorExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/inventoryvendor')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryVendorInventoryVendorLogic>>
      inventoryvendorGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/inventoryvendor')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryVendorInventoryVendor>>
      inventoryvendorPost(
          {@Body()
              required WebApiModulesHomeControlsInventoryVendorInventoryVendor?
                  body});

  ///
  ///@param id
  @Get(path: '/inventoryvendor/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryVendorInventoryVendor>>
      inventoryvendorIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/inventoryvendor/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryVendorInventoryVendor>>
      inventoryvendorIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsInventoryVendorInventoryVendor?
                  body});

  ///
  ///@param id
  @Delete(path: '/inventoryvendor/{id}')
  Future<chopper.Response<bool>> inventoryvendorIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/inventoryvendor/validatevendor/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      inventoryvendorValidatevendorBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/inventoryvendor/emptyobject')
  Future<chopper.Response> inventoryvendorEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/inventoryvendor/emptybrowseobject')
  Future<chopper.Response> inventoryvendorEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/inventoryvendor/keyfieldnames')
  Future<chopper.Response> inventoryvendorKeyfieldnamesGet();

  ///
  @Post(path: '/inventorywarehouse/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      inventorywarehouseBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/inventorywarehouse/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      inventorywarehouseExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/inventorywarehouse')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogic>>
      inventorywarehouseGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/inventorywarehouse')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryWarehouseInventoryWarehouse>>
      inventorywarehousePost(
          {@Body()
              required WebApiModulesHomeControlsInventoryWarehouseInventoryWarehouse?
                  body});

  ///
  ///@param id
  @Get(path: '/inventorywarehouse/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryWarehouseInventoryWarehouse>>
      inventorywarehouseIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/inventorywarehouse/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryWarehouseInventoryWarehouse>>
      inventorywarehouseIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsInventoryWarehouseInventoryWarehouse?
                  body});

  ///
  ///@param id
  @Delete(path: '/inventorywarehouse/{id}')
  Future<chopper.Response<bool>> inventorywarehouseIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/inventorywarehouse/many')
  Future<
          chopper.Response<
              List<
                  MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogic>>>
      inventorywarehouseManyPost(
          {@Body()
              required List<
                      WebApiModulesHomeControlsInventoryWarehouseInventoryWarehouse>?
                  body});

  ///Get an empty object
  @Get(path: '/inventorywarehouse/emptyobject')
  Future<chopper.Response> inventorywarehouseEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/inventorywarehouse/emptybrowseobject')
  Future<chopper.Response> inventorywarehouseEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/inventorywarehouse/keyfieldnames')
  Future<chopper.Response> inventorywarehouseKeyfieldnamesGet();

  ///
  @Post(path: '/inventorywarehousespecific/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      inventorywarehousespecificBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/inventorywarehousespecific/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      inventorywarehousespecificExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/inventorywarehousespecific')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecificLogic>>
      inventorywarehousespecificGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/inventorywarehousespecific')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecific>>
      inventorywarehousespecificPost(
          {@Body()
              required WebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecific?
                  body});

  ///
  ///@param id
  @Get(path: '/inventorywarehousespecific/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecific>>
      inventorywarehousespecificIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/inventorywarehousespecific/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecific>>
      inventorywarehousespecificIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecific?
                  body});

  ///
  ///@param id
  @Delete(path: '/inventorywarehousespecific/{id}')
  Future<chopper.Response<bool>> inventorywarehousespecificIdDelete(
      {@Path('id') required String? id});

  ///Get an empty object
  @Get(path: '/inventorywarehousespecific/emptyobject')
  Future<chopper.Response> inventorywarehousespecificEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/inventorywarehousespecific/emptybrowseobject')
  Future<chopper.Response> inventorywarehousespecificEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/inventorywarehousespecific/keyfieldnames')
  Future<chopper.Response> inventorywarehousespecificKeyfieldnamesGet();

  ///
  @Post(path: '/invoice/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      invoiceBrowsePost({@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Get(path: '/invoice/legend')
  Future<chopper.Response<Object>> invoiceLegendGet();

  ///
  @Post(path: '/invoice/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      invoiceExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/invoice')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesBillingInvoiceInvoiceLogic>>
      invoiceGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/invoice')
  Future<chopper.Response<WebApiModulesBillingInvoiceInvoice>> invoicePost(
      {@Body() required WebApiModulesBillingInvoiceInvoice? body});

  ///
  ///@param id
  @Get(path: '/invoice/{id}')
  Future<chopper.Response<WebApiModulesBillingInvoiceInvoice>> invoiceIdGet(
      {@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/invoice/{id}')
  Future<chopper.Response<WebApiModulesBillingInvoiceInvoice>> invoiceIdPut(
      {@Path('id') required String? id,
      @Body() required WebApiModulesBillingInvoiceInvoice? body});

  ///
  ///@param id
  @Delete(path: '/invoice/{id}')
  Future<chopper.Response<bool>> invoiceIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/invoice/many')
  Future<
          chopper.Response<
              List<
                  MicrosoftAspNetCoreMvcActionResultWebApiModulesBillingInvoiceInvoiceLogic>>>
      invoiceManyPost(
          {@Body() required List<WebApiModulesBillingInvoiceInvoice>? body});

  ///
  ///@param id
  @Post(path: '/invoice/{id}/void', optionalBody: true)
  Future<chopper.Response<WebApiModulesBillingInvoiceInvoice>>
      invoiceIdVoidPost({@Path('id') required String? id});

  ///
  @Post(path: '/invoice/creditinvoice')
  Future<chopper.Response<WebApiModulesBillingInvoiceCreditInvoiceReponse>>
      invoiceCreditinvoicePost(
          {@Body()
              required WebApiModulesBillingInvoiceCreditInvoiceRequest? body});

  ///
  ///@param id
  @Post(path: '/invoice/{id}/approve', optionalBody: true)
  Future<
          chopper.Response<
              WebApiModulesBillingInvoiceToggleInvoiceApprovedResponse>>
      invoiceIdApprovePost({@Path('id') required String? id});

  ///
  ///@param id
  @Post(path: '/invoice/{id}/unapprove', optionalBody: true)
  Future<
          chopper.Response<
              WebApiModulesBillingInvoiceToggleInvoiceApprovedResponse>>
      invoiceIdUnapprovePost({@Path('id') required String? id});

  ///
  @Post(path: '/invoice/validatedepartment/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      invoiceValidatedepartmentBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/invoice/validatedeal/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      invoiceValidatedealBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/invoice/validateagent/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      invoiceValidateagentBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/invoice/validateprojectmanager/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      invoiceValidateprojectmanagerBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/invoice/validateoutsidesalesrepresentative/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      invoiceValidateoutsidesalesrepresentativeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/invoice/validatepaymentterms/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      invoiceValidatepaymenttermsBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/invoice/validatepaymenttype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      invoiceValidatepaymenttypeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/invoice/validatecurrency/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      invoiceValidatecurrencyBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/invoice/validatetaxoption/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      invoiceValidatetaxoptionBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/invoice/gldistribution/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      invoiceGldistributionBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/invoice/emptyobject')
  Future<chopper.Response> invoiceEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/invoice/emptybrowseobject')
  Future<chopper.Response> invoiceEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/invoice/keyfieldnames')
  Future<chopper.Response> invoiceKeyfieldnamesGet();

  ///
  @Post(path: '/invoicebatch/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      invoicebatchBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/invoicebatch/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      invoicebatchExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/invoicebatch/emptyobject')
  Future<chopper.Response> invoicebatchEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/invoicebatch/emptybrowseobject')
  Future<chopper.Response> invoicebatchEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/invoicebatch/keyfieldnames')
  Future<chopper.Response> invoicebatchKeyfieldnamesGet();

  ///
  @Post(path: '/invoicecontact/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      invoicecontactBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/invoicecontact/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      invoicecontactExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/invoicecontact/emptyobject')
  Future<chopper.Response> invoicecontactEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/invoicecontact/emptybrowseobject')
  Future<chopper.Response> invoicecontactEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/invoicecontact/keyfieldnames')
  Future<chopper.Response> invoicecontactKeyfieldnamesGet();

  ///
  @Post(path: '/invoicecreationbatch/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      invoicecreationbatchBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/invoicecreationbatch/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      invoicecreationbatchExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/invoicecreationbatch')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatchLogic>>
      invoicecreationbatchGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  ///@param id
  @Get(path: '/invoicecreationbatch/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatch>>
      invoicecreationbatchIdGet({@Path('id') required String? id});

  ///Get an empty object
  @Get(path: '/invoicecreationbatch/emptyobject')
  Future<chopper.Response> invoicecreationbatchEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/invoicecreationbatch/emptybrowseobject')
  Future<chopper.Response> invoicecreationbatchEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/invoicecreationbatch/keyfieldnames')
  Future<chopper.Response> invoicecreationbatchKeyfieldnamesGet();

  ///
  @Post(path: '/invoiceitem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      invoiceitemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/invoiceitem/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      invoiceitemExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/invoiceitem')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceItemInvoiceItemLogic>>
      invoiceitemGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/invoiceitem')
  Future<chopper.Response<WebApiModulesHomeControlsInvoiceItemInvoiceItem>>
      invoiceitemPost(
          {@Body()
              required WebApiModulesHomeControlsInvoiceItemInvoiceItem? body});

  ///
  ///@param id
  @Get(path: '/invoiceitem/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsInvoiceItemInvoiceItem>>
      invoiceitemIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/invoiceitem/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsInvoiceItemInvoiceItem>>
      invoiceitemIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsInvoiceItemInvoiceItem? body});

  ///
  ///@param id
  @Delete(path: '/invoiceitem/{id}')
  Future<chopper.Response<bool>> invoiceitemIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/invoiceitem/validateinventory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      invoiceitemValidateinventoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/invoiceitem/validateitem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      invoiceitemValidateitemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/invoiceitem/emptyobject')
  Future<chopper.Response> invoiceitemEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/invoiceitem/emptybrowseobject')
  Future<chopper.Response> invoiceitemEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/invoiceitem/keyfieldnames')
  Future<chopper.Response> invoiceitemKeyfieldnamesGet();

  ///
  @Post(path: '/invoicenote/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      invoicenoteBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/invoicenote/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      invoicenoteExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/invoicenote')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceNoteInvoiceNoteLogic>>
      invoicenoteGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/invoicenote')
  Future<chopper.Response<WebApiModulesHomeControlsInvoiceNoteInvoiceNote>>
      invoicenotePost(
          {@Body()
              required WebApiModulesHomeControlsInvoiceNoteInvoiceNote? body});

  ///
  ///@param id
  @Get(path: '/invoicenote/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsInvoiceNoteInvoiceNote>>
      invoicenoteIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/invoicenote/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsInvoiceNoteInvoiceNote>>
      invoicenoteIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsInvoiceNoteInvoiceNote? body});

  ///
  ///@param id
  @Delete(path: '/invoicenote/{id}')
  Future<chopper.Response<bool>> invoicenoteIdDelete(
      {@Path('id') required String? id});

  ///Get an empty object
  @Get(path: '/invoicenote/emptyobject')
  Future<chopper.Response> invoicenoteEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/invoicenote/emptybrowseobject')
  Future<chopper.Response> invoicenoteEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/invoicenote/keyfieldnames')
  Future<chopper.Response> invoicenoteKeyfieldnamesGet();

  ///
  @Post(path: '/invoiceorder/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      invoiceorderBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/invoiceorder/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      invoiceorderExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/invoiceorder/emptyobject')
  Future<chopper.Response> invoiceorderEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/invoiceorder/emptybrowseobject')
  Future<chopper.Response> invoiceorderEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/invoiceorder/keyfieldnames')
  Future<chopper.Response> invoiceorderKeyfieldnamesGet();

  ///
  @Post(path: '/invoicereceipt/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      invoicereceiptBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/invoicereceipt/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      invoicereceiptExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/invoicereceipt')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceReceiptInvoiceReceiptLogic>>
      invoicereceiptGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/invoicereceipt')
  Future<
          chopper
              .Response<WebApiModulesHomeControlsInvoiceReceiptInvoiceReceipt>>
      invoicereceiptPost(
          {@Body()
              required WebApiModulesHomeControlsInvoiceReceiptInvoiceReceipt?
                  body});

  ///
  ///@param id
  @Get(path: '/invoicereceipt/{id}')
  Future<
          chopper
              .Response<WebApiModulesHomeControlsInvoiceReceiptInvoiceReceipt>>
      invoicereceiptIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/invoicereceipt/{id}')
  Future<
          chopper
              .Response<WebApiModulesHomeControlsInvoiceReceiptInvoiceReceipt>>
      invoicereceiptIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsInvoiceReceiptInvoiceReceipt?
                  body});

  ///
  ///@param id
  @Delete(path: '/invoicereceipt/{id}')
  Future<chopper.Response<bool>> invoicereceiptIdDelete(
      {@Path('id') required String? id});

  ///Get an empty object
  @Get(path: '/invoicereceipt/emptyobject')
  Future<chopper.Response> invoicereceiptEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/invoicereceipt/emptybrowseobject')
  Future<chopper.Response> invoicereceiptEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/invoicereceipt/keyfieldnames')
  Future<chopper.Response> invoicereceiptKeyfieldnamesGet();

  ///
  @Post(path: '/invoicerevenue/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      invoicerevenueBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/invoicerevenue/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      invoicerevenueExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/invoicerevenue/emptyobject')
  Future<chopper.Response> invoicerevenueEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/invoicerevenue/emptybrowseobject')
  Future<chopper.Response> invoicerevenueEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/invoicerevenue/keyfieldnames')
  Future<chopper.Response> invoicerevenueKeyfieldnamesGet();

  ///
  @Post(path: '/invoicestatushistory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      invoicestatushistoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/invoicestatushistory/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      invoicestatushistoryExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/invoicestatushistory/emptyobject')
  Future<chopper.Response> invoicestatushistoryEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/invoicestatushistory/emptybrowseobject')
  Future<chopper.Response> invoicestatushistoryEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/invoicestatushistory/keyfieldnames')
  Future<chopper.Response> invoicestatushistoryKeyfieldnamesGet();

  ///
  @Post(path: '/invoicestatusitem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      invoicestatusitemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/invoicestatusitem/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      invoicestatusitemExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/invoicestatusitem/emptyobject')
  Future<chopper.Response> invoicestatusitemEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/invoicestatusitem/emptybrowseobject')
  Future<chopper.Response> invoicestatusitemEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/invoicestatusitem/keyfieldnames')
  Future<chopper.Response> invoicestatusitemKeyfieldnamesGet();

  ///
  @Post(path: '/invoicestatusitemdetail/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      invoicestatusitemdetailBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/invoicestatusitemdetail/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      invoicestatusitemdetailExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/invoicestatusitemdetail/emptyobject')
  Future<chopper.Response> invoicestatusitemdetailEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/invoicestatusitemdetail/emptybrowseobject')
  Future<chopper.Response> invoicestatusitemdetailEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/invoicestatusitemdetail/keyfieldnames')
  Future<chopper.Response> invoicestatusitemdetailKeyfieldnamesGet();

  ///Get documents.
  ///@param itemid Unique identifier
  @Post(path: '/item/{itemid}/document/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      itemItemidDocumentBrowsePost(
          {@Path('itemid') required String? itemid,
          @Body() required FwStandardModelsBrowseRequest? body});

  ///Export documents to Excel.
  ///@param itemid Unique identifier
  @Post(path: '/item/{itemid}/document/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      itemItemidDocumentExportexcelxlsxPost(
          {@Path('itemid') required String? itemid,
          @Body() required FwStandardModelsBrowseRequest? body});

  ///Get documents.
  ///@param itemid Unique identifier
  ///@param DocumentTypeId Unique Identifier [Filter|Sort]
  ///@param Description Document description [Filter|Sort]
  ///@param DateStamp Document last modified data [Filter|Sort]
  ///@param PageNo The page number in the result set starting from 1.  PageNo is required when the PageSize is specified.
  ///@param PageSize Limit result set to the specified amount.
  ///@param Sort A sort expression to use of the form: Field1:asc,Field2:desc
  @Get(path: '/item/{itemid}/documents')
  Future<
          chopper.Response<
              FwStandardModelsGetResponseFwStandardGridsAppDocumentAppDocumentGetManyResponse>>
      itemItemidDocumentsGet(
          {@Path('itemid') required String? itemid,
          @Query('DocumentTypeId') String? documentTypeId,
          @Query('Description') String? description,
          @Query('DateStamp') String? dateStamp,
          @Query('PageNo') int? pageNo,
          @Query('PageSize') int? pageSize,
          @Query('Sort') String? sort});

  ///Get a document.
  ///@param itemid Unique identifier
  ///@param documentid Unique identifier
  @Get(path: '/item/{itemid}/document/{documentid}')
  Future<chopper.Response<WebApiModulesInventoryAssetAssetDocument>>
      itemItemidDocumentDocumentidGet(
          {@Path('itemid') required String? itemid,
          @Path('documentid') required String? documentid});

  ///Update a document.
  ///@param itemid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/item/{itemid}/document/{documentid}')
  Future<chopper.Response<WebApiModulesInventoryAssetAssetDocument>>
      itemItemidDocumentDocumentidPut(
          {@Path('itemid')
              required String? itemid,
          @Path('documentid')
              required String? documentid,
          @Body()
              required WebApiModulesInventoryAssetAssetDocumentPutRequest?
                  body});

  ///Delete a document.
  ///@param itemid Unique identifier
  ///@param documentid Unique identifier
  @Delete(path: '/item/{itemid}/document/{documentid}')
  Future<chopper.Response<bool>> itemItemidDocumentDocumentidDelete(
      {@Path('itemid') required String? itemid,
      @Path('documentid') required String? documentid});

  ///Create a new document.
  ///@param itemid Unique identifier
  @Post(path: '/item/{itemid}/document')
  Future<chopper.Response<WebApiModulesInventoryAssetAssetDocument>>
      itemItemidDocumentPost(
          {@Path('itemid')
              required String? itemid,
          @Body()
              required WebApiModulesInventoryAssetAssetDocumentPostRequest?
                  body});

  ///Get thumbnails for any images attached to the document.
  ///@param itemid Unique identifier
  ///@param documentid Unique identifier
  ///@param pageno The page number of the result set, starting from page 1.
  ///@param pagesize The number of records per page of the result set.
  @Get(path: '/item/{itemid}/document/{documentid}/thumbnails')
  Future<
          chopper.Response<
              FwStandardGridsAppDocumentGetDocumentThumbnailsResponse>>
      itemItemidDocumentDocumentidThumbnailsGet(
          {@Path('itemid') required String? itemid,
          @Path('documentid') required String? documentid,
          @Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize});

  ///Get a fullsize image.
  ///@param itemid Unique identifier
  ///@param documentid Unique identifier
  ///@param imageid Unique identifier
  @Get(path: '/item/{itemid}/document/{documentid}/image/{imageid}')
  Future<chopper.Response<FwStandardGridsAppDocumentGetDocumentImageResponse>>
      itemItemidDocumentDocumentidImageImageidGet(
          {@Path('itemid') required String? itemid,
          @Path('documentid') required String? documentid,
          @Path('imageid') required String? imageid});

  ///Delete an attached image.
  ///@param itemid Unique identifier
  ///@param documentid Unique identifier
  ///@param imageid Unique identifier
  @Delete(path: '/item/{itemid}/document/{documentid}/image/{imageid}')
  Future<chopper.Response<bool>> itemItemidDocumentDocumentidImageImageidDelete(
      {@Path('itemid') required String? itemid,
      @Path('documentid') required String? documentid,
      @Path('imageid') required String? imageid});

  ///Attach an image from a dataurl.
  ///@param itemid Unique identifier
  ///@param documentid Unique identifier
  @Post(path: '/item/{itemid}/document/{documentid}/image')
  Future<chopper.Response<bool>> itemItemidDocumentDocumentidImagePost(
      {@Path('itemid')
          required String? itemid,
      @Path('documentid')
          required String? documentid,
      @Body()
          required FwStandardGridsAppDocumentPostDocumentImageRequest? body});

  ///Attach an image from a form submission.
  ///@param itemid Unique identifier
  ///@param documentid Unique identifier
  @Post(path: '/item/{itemid}/document/{documentid}/imageformupload')
  Future<chopper.Response<bool>>
      itemItemidDocumentDocumentidImageformuploadPost(
          {@Path('itemid') required String? itemid,
          @Path('documentid') required String? documentid});

  ///Get the attached file.
  ///@param itemid Unique identifier
  ///@param documentid Unique identifier
  @Get(path: '/item/{itemid}/document/{documentid}/file')
  Future<chopper.Response> itemItemidDocumentDocumentidFileGet(
      {@Path('itemid') required String? itemid,
      @Path('documentid') required String? documentid});

  ///Update the attached file from a dataurl.
  ///@param itemid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/item/{itemid}/document/{documentid}/file')
  Future<chopper.Response<bool>> itemItemidDocumentDocumentidFilePut(
      {@Path('itemid') required String? itemid,
      @Path('documentid') required String? documentid,
      @Body() required FwStandardGridsAppDocumentPutDocumentFileRequest? body});

  ///Delete attached file.
  ///@param itemid Unique identifier
  ///@param documentid Unique identifier
  @Delete(path: '/item/{itemid}/document/{documentid}/file')
  Future<chopper.Response<bool>> itemItemidDocumentDocumentidFileDelete(
      {@Path('itemid') required String? itemid,
      @Path('documentid') required String? documentid});

  ///Update attached file from a form submission.
  ///@param itemid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/item/{itemid}/document/{documentid}/fileformupload')
  Future<chopper.Response<bool>> itemItemidDocumentDocumentidFileformuploadPut(
      {@Path('itemid') required String? itemid,
      @Path('documentid') required String? documentid});

  ///
  ///@param itemid
  @Get(path: '/item/{itemid}/document/emptyobject')
  Future<chopper.Response> itemItemidDocumentEmptyobjectGet(
      {@Path('itemid') required String? itemid});

  ///
  @Post(path: '/item/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>> itemBrowsePost(
      {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Get(path: '/item/legend')
  Future<chopper.Response<Object>> itemLegendGet();

  ///
  @Post(path: '/item/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      itemExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Query for Assets
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/item')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesInventoryAssetItemLogic>>
      itemGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/item')
  Future<chopper.Response<WebApiModulesInventoryAssetItem>> itemPost(
      {@Body() required WebApiModulesInventoryAssetItem? body});

  ///
  ///@param id
  @Get(path: '/item/{id}')
  Future<chopper.Response<WebApiModulesInventoryAssetItem>> itemIdGet(
      {@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/item/{id}')
  Future<chopper.Response<WebApiModulesInventoryAssetItem>> itemIdPut(
      {@Path('id') required String? id,
      @Body() required WebApiModulesInventoryAssetItem? body});

  ///
  ///@param barCode
  @Get(path: '/item/bybarcode')
  Future<chopper.Response<WebApiModulesInventoryAssetItemByBarCodeResponse>>
      itemBybarcodeGet({@Query('barCode') String? barCode});

  ///
  @Post(path: '/item/validatecondition/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      itemValidateconditionBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/item/validateinspectionvendor/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      itemValidateinspectionvendorBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/item/validatemanufacturer/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      itemValidatemanufacturerBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/item/validatecountryoforigin/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      itemValidatecountryoforiginBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/item/emptyobject')
  Future<chopper.Response> itemEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/item/emptybrowseobject')
  Future<chopper.Response> itemEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/item/keyfieldnames')
  Future<chopper.Response> itemKeyfieldnamesGet();

  ///
  @Post(path: '/itemattributevalue/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      itemattributevalueBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/itemattributevalue/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      itemattributevalueExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/itemattributevalue')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemAttributeValueItemAttributeValueLogic>>
      itemattributevalueGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/itemattributevalue')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsItemAttributeValueItemAttributeValue>>
      itemattributevaluePost(
          {@Body()
              required WebApiModulesHomeControlsItemAttributeValueItemAttributeValue?
                  body});

  ///
  ///@param id
  @Get(path: '/itemattributevalue/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsItemAttributeValueItemAttributeValue>>
      itemattributevalueIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/itemattributevalue/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsItemAttributeValueItemAttributeValue>>
      itemattributevalueIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsItemAttributeValueItemAttributeValue?
                  body});

  ///
  ///@param id
  @Delete(path: '/itemattributevalue/{id}')
  Future<chopper.Response<bool>> itemattributevalueIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/itemattributevalue/validateattribute/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      itemattributevalueValidateattributeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/itemattributevalue/validateattributevalue/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      itemattributevalueValidateattributevalueBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/itemattributevalue/emptyobject')
  Future<chopper.Response> itemattributevalueEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/itemattributevalue/emptybrowseobject')
  Future<chopper.Response> itemattributevalueEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/itemattributevalue/keyfieldnames')
  Future<chopper.Response> itemattributevalueKeyfieldnamesGet();

  ///
  @Post(path: '/itemqc/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>> itemqcBrowsePost(
      {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/itemqc/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      itemqcExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/itemqc')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemQcItemQcLogic>>
      itemqcGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/itemqc')
  Future<chopper.Response<WebApiModulesHomeControlsItemQcItemQc>> itemqcPost(
      {@Body() required WebApiModulesHomeControlsItemQcItemQc? body});

  ///
  ///@param id
  @Get(path: '/itemqc/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsItemQcItemQc>> itemqcIdGet(
      {@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/itemqc/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsItemQcItemQc>> itemqcIdPut(
      {@Path('id') required String? id,
      @Body() required WebApiModulesHomeControlsItemQcItemQc? body});

  ///Get an empty object
  @Get(path: '/itemqc/emptyobject')
  Future<chopper.Response> itemqcEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/itemqc/emptybrowseobject')
  Future<chopper.Response> itemqcEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/itemqc/keyfieldnames')
  Future<chopper.Response> itemqcKeyfieldnamesGet();

  ///
  @Post(path: '/lossanddamage/startsession')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionResponse>>
      lossanddamageStartsessionPost(
          {@Body()
              required WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionRequest?
                  body});

  ///
  @Post(path: '/lossanddamage/updateitem')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemResponse>>
      lossanddamageUpdateitemPost(
          {@Body()
              required WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemRequest?
                  body});

  ///
  @Post(path: '/lossanddamage/selectall')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemResponse>>
      lossanddamageSelectallPost(
          {@Body()
              required WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemRequest?
                  body});

  ///
  @Post(path: '/lossanddamage/selectnone')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemResponse>>
      lossanddamageSelectnonePost(
          {@Body()
              required WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemRequest?
                  body});

  ///
  @Post(path: '/lossanddamage/completesession')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionResponse>>
      lossanddamageCompletesessionPost(
          {@Body()
              required WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionRequest?
                  body});

  ///
  @Post(path: '/lossanddamage/retire')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemResponse>>
      lossanddamageRetirePost(
          {@Body()
              required WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemRequest?
                  body});

  ///Get an empty object
  @Get(path: '/lossanddamage/emptyobject')
  Future<chopper.Response> lossanddamageEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/lossanddamage/emptybrowseobject')
  Future<chopper.Response> lossanddamageEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/lossanddamage/keyfieldnames')
  Future<chopper.Response> lossanddamageKeyfieldnamesGet();

  ///
  @Post(path: '/lossanddamageitem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      lossanddamageitemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/lossanddamageitem/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      lossanddamageitemExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/lossanddamageitem/emptyobject')
  Future<chopper.Response> lossanddamageitemEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/lossanddamageitem/emptybrowseobject')
  Future<chopper.Response> lossanddamageitemEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/lossanddamageitem/keyfieldnames')
  Future<chopper.Response> lossanddamageitemKeyfieldnamesGet();

  ///
  @Post(path: '/manifest/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      manifestBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Get(path: '/manifest/legend')
  Future<chopper.Response<Object>> manifestLegendGet();

  ///
  @Post(path: '/manifest/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      manifestExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/manifest')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsManifestManifestLogic>>
      manifestGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/manifest')
  Future<chopper.Response<WebApiModulesHomeControlsManifestManifest>>
      manifestPost(
          {@Body() required WebApiModulesHomeControlsManifestManifest? body});

  ///
  ///@param id
  @Get(path: '/manifest/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsManifestManifest>>
      manifestIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/manifest/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsManifestManifest>>
      manifestIdPut(
          {@Path('id') required String? id,
          @Body() required WebApiModulesHomeControlsManifestManifest? body});

  ///
  ///@param id
  @Delete(path: '/manifest/{id}')
  Future<chopper.Response<bool>> manifestIdDelete(
      {@Path('id') required String? id});

  ///Get an empty object
  @Get(path: '/manifest/emptyobject')
  Future<chopper.Response> manifestEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/manifest/emptybrowseobject')
  Future<chopper.Response> manifestEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/manifest/keyfieldnames')
  Future<chopper.Response> manifestKeyfieldnamesGet();

  ///
  ///@param orderid
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/order/{orderid}/items')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderItemOrderItemLogic>>
      orderOrderidItemsGet(
          {@Path('orderid') required String? orderid,
          @Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Get(path: '/order/item/emptyobject')
  Future<chopper.Response> orderItemEmptyobjectGet();

  ///
  @Post(path: '/order/manifest/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderManifestBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/manifest/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      orderManifestExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Get(path: '/order/manifest/emptyobject')
  Future<chopper.Response> orderManifestEmptyobjectGet();

  ///Get documents.
  ///@param orderid Unique identifier
  @Post(path: '/order/{orderid}/document/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderOrderidDocumentBrowsePost(
          {@Path('orderid') required String? orderid,
          @Body() required FwStandardModelsBrowseRequest? body});

  ///Export documents to Excel.
  ///@param orderid Unique identifier
  @Post(path: '/order/{orderid}/document/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      orderOrderidDocumentExportexcelxlsxPost(
          {@Path('orderid') required String? orderid,
          @Body() required FwStandardModelsBrowseRequest? body});

  ///Get documents.
  ///@param orderid Unique identifier
  ///@param DocumentTypeId Unique Identifier [Filter|Sort]
  ///@param Description Document description [Filter|Sort]
  ///@param DateStamp Document last modified data [Filter|Sort]
  ///@param PageNo The page number in the result set starting from 1.  PageNo is required when the PageSize is specified.
  ///@param PageSize Limit result set to the specified amount.
  ///@param Sort A sort expression to use of the form: Field1:asc,Field2:desc
  @Get(path: '/order/{orderid}/documents')
  Future<
          chopper.Response<
              FwStandardModelsGetResponseFwStandardGridsAppDocumentAppDocumentGetManyResponse>>
      orderOrderidDocumentsGet(
          {@Path('orderid') required String? orderid,
          @Query('DocumentTypeId') String? documentTypeId,
          @Query('Description') String? description,
          @Query('DateStamp') String? dateStamp,
          @Query('PageNo') int? pageNo,
          @Query('PageSize') int? pageSize,
          @Query('Sort') String? sort});

  ///Get a document.
  ///@param orderid Unique identifier
  ///@param documentid Unique identifier
  @Get(path: '/order/{orderid}/document/{documentid}')
  Future<chopper.Response<WebApiModulesAgentOrderOrderDocument>>
      orderOrderidDocumentDocumentidGet(
          {@Path('orderid') required String? orderid,
          @Path('documentid') required String? documentid});

  ///Update a document.
  ///@param orderid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/order/{orderid}/document/{documentid}')
  Future<chopper.Response<WebApiModulesAgentOrderOrderDocument>>
      orderOrderidDocumentDocumentidPut(
          {@Path('orderid')
              required String? orderid,
          @Path('documentid')
              required String? documentid,
          @Body()
              required WebApiModulesAgentOrderOrderDocumentPutRequest? body});

  ///Delete a document.
  ///@param orderid Unique identifier
  ///@param documentid Unique identifier
  @Delete(path: '/order/{orderid}/document/{documentid}')
  Future<chopper.Response<bool>> orderOrderidDocumentDocumentidDelete(
      {@Path('orderid') required String? orderid,
      @Path('documentid') required String? documentid});

  ///Create a new document.
  ///@param orderid Unique identifier
  @Post(path: '/order/{orderid}/document')
  Future<chopper.Response<WebApiModulesAgentOrderOrderDocument>>
      orderOrderidDocumentPost(
          {@Path('orderid')
              required String? orderid,
          @Body()
              required WebApiModulesAgentOrderOrderDocumentPostRequest? body});

  ///Get thumbnails for any images attached to the document.
  ///@param orderid Unique identifier
  ///@param documentid Unique identifier
  ///@param pageno The page number of the result set, starting from page 1.
  ///@param pagesize The number of records per page of the result set.
  @Get(path: '/order/{orderid}/document/{documentid}/thumbnails')
  Future<
          chopper.Response<
              FwStandardGridsAppDocumentGetDocumentThumbnailsResponse>>
      orderOrderidDocumentDocumentidThumbnailsGet(
          {@Path('orderid') required String? orderid,
          @Path('documentid') required String? documentid,
          @Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize});

  ///Get a fullsize image.
  ///@param orderid Unique identifier
  ///@param documentid Unique identifier
  ///@param imageid Unique identifier
  @Get(path: '/order/{orderid}/document/{documentid}/image/{imageid}')
  Future<chopper.Response<FwStandardGridsAppDocumentGetDocumentImageResponse>>
      orderOrderidDocumentDocumentidImageImageidGet(
          {@Path('orderid') required String? orderid,
          @Path('documentid') required String? documentid,
          @Path('imageid') required String? imageid});

  ///Delete an attached image.
  ///@param orderid Unique identifier
  ///@param documentid Unique identifier
  ///@param imageid Unique identifier
  @Delete(path: '/order/{orderid}/document/{documentid}/image/{imageid}')
  Future<chopper.Response<bool>>
      orderOrderidDocumentDocumentidImageImageidDelete(
          {@Path('orderid') required String? orderid,
          @Path('documentid') required String? documentid,
          @Path('imageid') required String? imageid});

  ///Attach an image from a dataurl.
  ///@param orderid Unique identifier
  ///@param documentid Unique identifier
  @Post(path: '/order/{orderid}/document/{documentid}/image')
  Future<chopper.Response<bool>> orderOrderidDocumentDocumentidImagePost(
      {@Path('orderid')
          required String? orderid,
      @Path('documentid')
          required String? documentid,
      @Body()
          required FwStandardGridsAppDocumentPostDocumentImageRequest? body});

  ///Attach an image from a form submission.
  ///@param orderid Unique identifier
  ///@param documentid Unique identifier
  @Post(path: '/order/{orderid}/document/{documentid}/imageformupload')
  Future<chopper.Response<bool>>
      orderOrderidDocumentDocumentidImageformuploadPost(
          {@Path('orderid') required String? orderid,
          @Path('documentid') required String? documentid});

  ///Get the attached file.
  ///@param orderid Unique identifier
  ///@param documentid Unique identifier
  @Get(path: '/order/{orderid}/document/{documentid}/file')
  Future<chopper.Response> orderOrderidDocumentDocumentidFileGet(
      {@Path('orderid') required String? orderid,
      @Path('documentid') required String? documentid});

  ///Update the attached file from a dataurl.
  ///@param orderid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/order/{orderid}/document/{documentid}/file')
  Future<chopper.Response<bool>> orderOrderidDocumentDocumentidFilePut(
      {@Path('orderid') required String? orderid,
      @Path('documentid') required String? documentid,
      @Body() required FwStandardGridsAppDocumentPutDocumentFileRequest? body});

  ///Delete attached file.
  ///@param orderid Unique identifier
  ///@param documentid Unique identifier
  @Delete(path: '/order/{orderid}/document/{documentid}/file')
  Future<chopper.Response<bool>> orderOrderidDocumentDocumentidFileDelete(
      {@Path('orderid') required String? orderid,
      @Path('documentid') required String? documentid});

  ///Update attached file from a form submission.
  ///@param orderid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/order/{orderid}/document/{documentid}/fileformupload')
  Future<chopper.Response<bool>>
      orderOrderidDocumentDocumentidFileformuploadPut(
          {@Path('orderid') required String? orderid,
          @Path('documentid') required String? documentid});

  ///
  ///@param orderid
  @Get(path: '/order/{orderid}/document/emptyobject')
  Future<chopper.Response> orderOrderidDocumentEmptyobjectGet(
      {@Path('orderid') required String? orderid});

  ///
  @Post(path: '/order/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>> orderBrowsePost(
      {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get Order Details
  ///@param orderid Unique Id
  @Get(path: '/order/{orderid}/orderdetails')
  Future<chopper.Response<WebApiModulesAgentOrderGetOrderResponse>>
      orderOrderidOrderdetailsGet({@Path('orderid') required String? orderid});

  ///
  @Get(path: '/order/legend')
  Future<chopper.Response<Object>> orderLegendGet();

  ///
  @Post(path: '/order/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      orderExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/copytemplate')
  Future<chopper.Response<WebApiModulesAgentOrderCopyTemplateResponse>>
      orderCopytemplatePost(
          {@Body() required WebApiModulesAgentOrderCopyTemplateRequest? body});

  ///
  ///@param id
  @Post(path: '/order/{id}/copytoquote')
  Future<chopper.Response<WebApiModulesAgentOrderCopyQuoteOrderResponse>>
      orderIdCopytoquotePost(
          {@Path('id') required String? id,
          @Body() required WebApiModulesAgentOrderCopyQuoteOrderRequest? body});

  ///
  ///@param id
  @Post(path: '/order/{id}/copytoorder')
  Future<chopper.Response<WebApiModulesAgentOrderCopyQuoteOrderResponse>>
      orderIdCopytoorderPost(
          {@Path('id') required String? id,
          @Body() required WebApiModulesAgentOrderCopyQuoteOrderRequest? body});

  ///
  @Post(path: '/order/copyorderitems')
  Future<chopper.Response<WebApiModulesAgentOrderCopyOrderItemsResponse>>
      orderCopyorderitemsPost(
          {@Body()
              required WebApiModulesAgentOrderCopyOrderItemsRequest? body});

  ///
  ///@param id
  @Post(path: '/order/cancel/{id}', optionalBody: true)
  Future<chopper.Response<WebApiModulesAgentOrderOrder>> orderCancelIdPost(
      {@Path('id') required String? id});

  ///
  ///@param id
  @Post(path: '/order/uncancel/{id}', optionalBody: true)
  Future<chopper.Response<WebApiModulesAgentOrderOrder>> orderUncancelIdPost(
      {@Path('id') required String? id});

  ///
  ///@param id
  @Post(path: '/order/createsnapshot/{id}', optionalBody: true)
  Future<chopper.Response<WebApiModulesAgentOrderOrder>>
      orderCreatesnapshotIdPost({@Path('id') required String? id});

  ///
  ///@param id
  @Post(path: '/order/onhold/{id}', optionalBody: true)
  Future<
          chopper.Response<
              WebApiModulesHomeControlsDealOrderDealOrderRecordOrderOnHoldResponse>>
      orderOnholdIdPost({@Path('id') required String? id});

  ///
  @Post(path: '/order/applybottomlinedaysperweek')
  Future<chopper.Response<bool>> orderApplybottomlinedaysperweekPost(
      {@Body() required WebApiApplyBottomLineDaysPerWeekRequest? body});

  ///
  @Post(path: '/order/applybottomlinediscountpercent')
  Future<chopper.Response<bool>> orderApplybottomlinediscountpercentPost(
      {@Body() required WebApiApplyBottomLineDiscountPercentRequest? body});

  ///
  @Post(path: '/order/applybottomlinetotal')
  Future<chopper.Response<bool>> orderApplybottomlinetotalPost(
      {@Body() required WebApiApplyBottomLineTotalRequest? body});

  ///
  @Post(path: '/order/startcreatepoworksheetsession')
  Future<
          chopper.Response<
              WebApiModulesAgentOrderCreatePoWorksheetSessionResponse>>
      orderStartcreatepoworksheetsessionPost(
          {@Body()
              required WebApiModulesAgentOrderCreatePoWorksheetSessionRequest?
                  body});

  ///
  @Post(path: '/order/startmodifypoworksheetsession')
  Future<
          chopper.Response<
              WebApiModulesAgentOrderModifyPoWorksheetSessionResponse>>
      orderStartmodifypoworksheetsessionPost(
          {@Body()
              required WebApiModulesAgentOrderModifyPoWorksheetSessionRequest?
                  body});

  ///
  ///@param sessionId
  @Put(path: '/order/updatepoworksheetsession/{sessionid}')
  Future<
          chopper.Response<
              WebApiModulesAgentOrderUpdatePoWorksheetSessionResponse>>
      orderUpdatepoworksheetsessionSessionidPut(
          {@Path('sessionId')
              required String? sessionId,
          @Body()
              required WebApiModulesAgentOrderUpdatePoWorksheetSessionRequest?
                  body});

  ///
  ///@param sessionId
  @Get(path: '/order/poworksheetsessiontotals/{sessionid}')
  Future<
          chopper.Response<
              WebApiModulesAgentOrderPoWorksheetSessionTotalsResponse>>
      orderPoworksheetsessiontotalsSessionidGet(
          {@Path('sessionId') required String? sessionId});

  ///
  @Post(path: '/order/getcustomrates')
  Future<chopper.Response<WebApiModulesAgentOrderGetCustomRatesResponse>>
      orderGetcustomratesPost(
          {@Body()
              required WebApiModulesAgentOrderGetCustomRatesRequest? body});

  ///
  @Post(path: '/order/completepoworksheetsession')
  Future<
          chopper.Response<
              WebApiModulesAgentOrderCompletePoWorksheetSessionResponse>>
      orderCompletepoworksheetsessionPost(
          {@Body()
              required WebApiModulesAgentOrderCompletePoWorksheetSessionRequest?
                  body});

  ///
  ///@param id
  @Post(path: '/order/changeofficelocation/{id}')
  Future<
          chopper.Response<
              WebApiModulesAgentOrderChangeOrderOfficeLocationResponse>>
      orderChangeofficelocationIdPost(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesAgentOrderChangeOrderOfficeLocationRequest?
                  body});

  ///
  ///@param id
  @Get(path: '/order/{id}/messages')
  Future<chopper.Response<WebApiModulesAgentOrderOrderMessagesResponse>>
      orderIdMessagesGet({@Path('id') required String? id});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/order')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAgentOrderOrderLogic>>
      orderGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/order')
  Future<chopper.Response<WebApiModulesAgentOrderOrder>> orderPost(
      {@Body() required WebApiModulesAgentOrderOrder? body});

  ///
  ///@param id
  @Get(path: '/order/{id}')
  Future<chopper.Response<WebApiModulesAgentOrderOrder>> orderIdGet(
      {@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/order/{id}')
  Future<chopper.Response<WebApiModulesAgentOrderOrder>> orderIdPut(
      {@Path('id') required String? id,
      @Body() required WebApiModulesAgentOrderOrder? body});

  ///
  @Post(path: '/order/validatedepartment/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidatedepartmentBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/validatedeal/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidatedealBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/validateratetype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidateratetypeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/validateordertype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidateordertypeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/validateagent/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidateagentBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/validateprojectmanager/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidateprojectmanagerBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/validateoutsidesalesrepresentative/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidateoutsidesalesrepresentativeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/validatemarkettype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidatemarkettypeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/validatemarketsegment/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidatemarketsegmentBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/validateordergroup/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidateordergroupBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/validatemarketsegmentjob/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidatemarketsegmentjobBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/validatecoverletter/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidatecoverletterBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/validatetermsconditions/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidatetermsconditionsBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/validatebillingcycle/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidatebillingcycleBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/validatepaymentterms/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidatepaymenttermsBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/validatepaymenttype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidatepaymenttypeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/validatecurrency/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidatecurrencyBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/validatetaxoption/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidatetaxoptionBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/validatediscountreason/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidatediscountreasonBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/validateissuedtocountry/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidateissuedtocountryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/validateoutdeliverycarrier/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidateoutdeliverycarrierBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/validateoutdeliveryshipvia/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidateoutdeliveryshipviaBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/validateindeliverycarrier/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidateindeliverycarrierBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/validateindeliveryshipvia/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidateindeliveryshipviaBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/validateoutdeliverytocountry/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidateoutdeliverytocountryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/validateindeliverytocountry/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidateindeliverytocountryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/validateofficelocation/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidateofficelocationBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/validatewarehouse/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidatewarehouseBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/validatebilltocountry/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidatebilltocountryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param departmentid
  ///@param locationid
  @Get(path: '/order/department/{departmentid}/location/{locationid}')
  Future<
          chopper.Response<
              WebApiModulesSettingsDepartmentLocationDepartmentLocation>>
      orderDepartmentDepartmentidLocationLocationidGet(
          {@Path('departmentid') required String? departmentid,
          @Path('locationid') required String? locationid});

  ///
  ///@param ordertypeid
  @Get(path: '/order/ordertype/{ordertypeid}')
  Future<chopper.Response<WebApiModulesSettingsOrderSettingsOrderTypeOrderType>>
      orderOrdertypeOrdertypeidGet(
          {@Path('ordertypeid') required String? ordertypeid});

  ///
  @Post(path: '/order/ordertypelocation/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderOrdertypelocationBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/order/validateorderlocation/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderValidateorderlocationBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Load the info for the 'Process Deposit' screen where the PinPadCode and PaymentAmount is collected from the user before making the call to Add a Credit Card Depleting Deposit
  ///@param id
  @Get(path: '/order/receipt/processcreditcardinfo/{id}')
  Future<
          chopper.Response<
              WebApiModulesPluginsProcessCreditCardProcessCreditCardInfo>>
      orderReceiptProcesscreditcardinfoIdGet({@Path('id') required String? id});

  ///Add Credit Card Depleting Deposit
  @Post(path: '/order/receipt/creditcarddepletingdeposit')
  Future<
          chopper.Response<
              WebApiModulesPluginsProcessCreditCardProcessCreditCardPaymentResponse>>
      orderReceiptCreditcarddepletingdepositPost(
          {@Body()
              required WebApiModulesBillingReceiptCreditCardDepletingDepositRequest?
                  body});

  ///Get an empty object
  @Get(path: '/order/emptyobject')
  Future<chopper.Response> orderEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/order/emptybrowseobject')
  Future<chopper.Response> orderEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/order/keyfieldnames')
  Future<chopper.Response> orderKeyfieldnamesGet();

  ///
  @Post(path: '/orderbillingschedule/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderbillingscheduleBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Get(path: '/orderbillingschedule/legend')
  Future<chopper.Response<Object>> orderbillingscheduleLegendGet();

  ///
  @Post(path: '/orderbillingschedule/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      orderbillingscheduleExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/orderbillingschedule/emptyobject')
  Future<chopper.Response> orderbillingscheduleEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/orderbillingschedule/emptybrowseobject')
  Future<chopper.Response> orderbillingscheduleEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/orderbillingschedule/keyfieldnames')
  Future<chopper.Response> orderbillingscheduleKeyfieldnamesGet();

  ///
  @Post(path: '/ordercontact/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      ordercontactBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/ordercontact/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      ordercontactExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/ordercontact')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderContactOrderContactLogic>>
      ordercontactGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/ordercontact')
  Future<chopper.Response<WebApiModulesHomeControlsOrderContactOrderContact>>
      ordercontactPost(
          {@Body()
              required WebApiModulesHomeControlsOrderContactOrderContact?
                  body});

  ///
  ///@param id
  @Put(path: '/ordercontact')
  Future<chopper.Response<WebApiModulesHomeControlsOrderContactOrderContact>>
      ordercontactPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsOrderContactOrderContact?
                  body});

  ///
  ///@param id
  @Get(path: '/ordercontact/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsOrderContactOrderContact>>
      ordercontactIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/ordercontact/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsOrderContactOrderContact>>
      ordercontactIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsOrderContactOrderContact?
                  body});

  ///
  ///@param id
  @Delete(path: '/ordercontact/{id}')
  Future<chopper.Response<bool>> ordercontactIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/ordercontact/validatecontact/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      ordercontactValidatecontactBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/ordercontact/validatecontacttitle/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      ordercontactValidatecontacttitleBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/ordercontact/emptyobject')
  Future<chopper.Response> ordercontactEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/ordercontact/emptybrowseobject')
  Future<chopper.Response> ordercontactEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/ordercontact/keyfieldnames')
  Future<chopper.Response> ordercontactKeyfieldnamesGet();

  ///
  @Post(path: '/orderdates/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderdatesBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/orderdates/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      orderdatesExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/orderdates/emptyobject')
  Future<chopper.Response> orderdatesEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/orderdates/emptybrowseobject')
  Future<chopper.Response> orderdatesEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/orderdates/keyfieldnames')
  Future<chopper.Response> orderdatesKeyfieldnamesGet();

  ///
  @Post(path: '/orderitem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderitemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/orderitem/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      orderitemExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param id
  @Get(path: '/orderitem/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsOrderItemOrderItem>>
      orderitemIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/orderitem/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsOrderItemOrderItem>>
      orderitemIdPut(
          {@Path('id') required String? id,
          @Body() required WebApiModulesHomeControlsOrderItemOrderItem? body});

  ///
  ///@param id
  @Delete(path: '/orderitem/{id}')
  Future<chopper.Response<bool>> orderitemIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/orderitem')
  Future<chopper.Response<WebApiModulesHomeControlsOrderItemOrderItem>>
      orderitemPost(
          {@Body() required WebApiModulesHomeControlsOrderItemOrderItem? body});

  ///
  @Post(path: '/orderitem/many')
  Future<
          chopper.Response<
              List<
                  MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsOrderItemOrderItemLogic>>>
      orderitemManyPost(
          {@Body()
              required List<WebApiModulesHomeControlsOrderItemOrderItem>?
                  body});

  ///
  @Post(path: '/orderitem/insertheaders')
  Future<chopper.Response<WebApiLogicTSpStatusResponse>>
      orderitemInsertheadersPost(
          {@Body()
              required List<WebApiModulesHomeControlsOrderItemOrderItem>?
                  body});

  ///
  @Post(path: '/orderitem/inserttexts')
  Future<chopper.Response<WebApiLogicTSpStatusResponse>>
      orderitemInserttextsPost(
          {@Body()
              required List<WebApiModulesHomeControlsOrderItemOrderItem>?
                  body});

  ///
  @Post(path: '/orderitem/insertsubtotals')
  Future<chopper.Response<WebApiLogicTSpStatusResponse>>
      orderitemInsertsubtotalsPost(
          {@Body()
              required List<WebApiModulesHomeControlsOrderItemOrderItem>?
                  body});

  ///
  @Post(path: '/orderitem/insertlineitem')
  Future<chopper.Response<WebApiLogicTSpStatusResponse>>
      orderitemInsertlineitemPost(
          {@Body()
              required WebApiModulesHomeControlsOrderItemInsertLineItemRequest?
                  body});

  ///
  @Post(path: '/orderitem/insertoption')
  Future<chopper.Response<WebApiLogicTSpStatusResponse>>
      orderitemInsertoptionPost(
          {@Body()
              required WebApiModulesHomeControlsOrderItemInsertOptionRequest?
                  body});

  ///
  @Post(path: '/orderitem/splitlineitem')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsOrderItemSplitOrderItemResponse>>
      orderitemSplitlineitemPost(
          {@Body()
              required WebApiModulesHomeControlsOrderItemSplitOrderItemRequest?
                  body});

  ///
  ///@param RateType
  ///@param RecType
  ///@param FromDate
  ///@param ToDate
  ///@param BillingFromDate
  ///@param BillingToDate
  ///@param Quantity
  ///@param UnitCost
  ///@param Rate
  ///@param Rate2
  ///@param Rate3
  ///@param Rate4
  ///@param Rate5
  ///@param DaysPerWeek
  ///@param DiscountPercent
  ///@param UnitType
  ///@param Hours
  ///@param HoursOvertime
  ///@param HoursDoubletime
  @Get(path: '/orderitem/calculateextended')
  Future<chopper.Response> orderitemCalculateextendedGet(
      {@Query('RateType') String? rateType,
      @Query('RecType') String? recType,
      @Query('FromDate') String? fromDate,
      @Query('ToDate') String? toDate,
      @Query('BillingFromDate') String? billingFromDate,
      @Query('BillingToDate') String? billingToDate,
      @Query('Quantity') num? quantity,
      @Query('UnitCost') num? unitCost,
      @Query('Rate') num? rate,
      @Query('Rate2') num? rate2,
      @Query('Rate3') num? rate3,
      @Query('Rate4') num? rate4,
      @Query('Rate5') num? rate5,
      @Query('DaysPerWeek') num? daysPerWeek,
      @Query('DiscountPercent') num? discountPercent,
      @Query('UnitType') String? unitType,
      @Query('Hours') num? hours,
      @Query('HoursOvertime') num? hoursOvertime,
      @Query('HoursDoubletime') num? hoursDoubletime});

  ///
  ///@param RateType
  ///@param RecType
  ///@param FromDate
  ///@param ToDate
  ///@param BillingFromDate
  ///@param BillingToDate
  ///@param Quantity
  ///@param Rate
  ///@param Rate2
  ///@param Rate3
  ///@param Rate4
  ///@param Rate5
  ///@param DaysPerWeek
  ///@param DiscountPercent
  ///@param UnitDiscountAmount
  ///@param UnitExtended
  ///@param WeeklyDiscountAmount
  ///@param WeeklyExtended
  ///@param MonthlyDiscountAmount
  ///@param MonthlyExtended
  ///@param PeriodDiscountAmount
  ///@param PeriodExtended
  ///@param UnitType
  ///@param Hours
  ///@param HoursOvertime
  ///@param HoursDoubletime
  @Get(path: '/orderitem/calculatediscountpercent')
  Future<chopper.Response> orderitemCalculatediscountpercentGet(
      {@Query('RateType') String? rateType,
      @Query('RecType') String? recType,
      @Query('FromDate') String? fromDate,
      @Query('ToDate') String? toDate,
      @Query('BillingFromDate') String? billingFromDate,
      @Query('BillingToDate') String? billingToDate,
      @Query('Quantity') num? quantity,
      @Query('Rate') num? rate,
      @Query('Rate2') num? rate2,
      @Query('Rate3') num? rate3,
      @Query('Rate4') num? rate4,
      @Query('Rate5') num? rate5,
      @Query('DaysPerWeek') num? daysPerWeek,
      @Query('DiscountPercent') num? discountPercent,
      @Query('UnitDiscountAmount') num? unitDiscountAmount,
      @Query('UnitExtended') num? unitExtended,
      @Query('WeeklyDiscountAmount') num? weeklyDiscountAmount,
      @Query('WeeklyExtended') num? weeklyExtended,
      @Query('MonthlyDiscountAmount') num? monthlyDiscountAmount,
      @Query('MonthlyExtended') num? monthlyExtended,
      @Query('PeriodDiscountAmount') num? periodDiscountAmount,
      @Query('PeriodExtended') num? periodExtended,
      @Query('UnitType') String? unitType,
      @Query('Hours') num? hours,
      @Query('HoursOvertime') num? hoursOvertime,
      @Query('HoursDoubletime') num? hoursDoubletime});

  ///
  ///@param FieldToCalculate
  ///@param MarkupPercent
  ///@param MarginPercent
  ///@param Price
  ///@param Cost
  @Get(path: '/orderitem/calculatemarkupmargin')
  Future<chopper.Response> orderitemCalculatemarkupmarginGet(
      {@Query('FieldToCalculate') String? fieldToCalculate,
      @Query('MarkupPercent') num? markupPercent,
      @Query('MarginPercent') num? marginPercent,
      @Query('Price') num? price,
      @Query('Cost') num? cost});

  ///
  @Post(path: '/orderitem/sort')
  Future<chopper.Response<WebApiLogicSortItemsResponse>> orderitemSortPost(
      {@Body()
          required WebApiModulesHomeControlsOrderItemSortOrderItemsRequest?
              body});

  ///
  ///@param id
  @Post(path: '/orderitem/cancelmanualsort/{id}', optionalBody: true)
  Future<chopper.Response<WebApiLogicTSpStatusResponse>>
      orderitemCancelmanualsortIdPost({@Path('id') required String? id});

  ///
  @Post(path: '/orderitem/validatebarcode/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderitemValidatebarcodeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/orderitem/validateicoderental/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderitemValidateicoderentalBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/orderitem/validateicodesales/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderitemValidateicodesalesBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/orderitem/validateicodemisc/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderitemValidateicodemiscBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/orderitem/validateicodelabor/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderitemValidateicodelaborBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/orderitem/validateicodeparts/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderitemValidateicodepartsBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/orderitem/validateunit/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderitemValidateunitBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/orderitem/validatewarehouse/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderitemValidatewarehouseBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/orderitem/validateicodetransfer/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderitemValidateicodetransferBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/orderitem/emptyobject')
  Future<chopper.Response> orderitemEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/orderitem/emptybrowseobject')
  Future<chopper.Response> orderitemEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/orderitem/keyfieldnames')
  Future<chopper.Response> orderitemKeyfieldnamesGet();

  ///
  @Post(path: '/ordernote/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      ordernoteBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/ordernote/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      ordernoteExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/ordernote')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderNoteOrderNoteLogic>>
      ordernoteGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/ordernote')
  Future<chopper.Response<WebApiModulesHomeControlsOrderNoteOrderNote>>
      ordernotePost(
          {@Body() required WebApiModulesHomeControlsOrderNoteOrderNote? body});

  ///
  ///@param id
  @Get(path: '/ordernote/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsOrderNoteOrderNote>>
      ordernoteIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/ordernote/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsOrderNoteOrderNote>>
      ordernoteIdPut(
          {@Path('id') required String? id,
          @Body() required WebApiModulesHomeControlsOrderNoteOrderNote? body});

  ///
  ///@param id
  @Delete(path: '/ordernote/{id}')
  Future<chopper.Response<bool>> ordernoteIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/ordernote/validateuser/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      ordernoteValidateuserBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/ordernote/emptyobject')
  Future<chopper.Response> ordernoteEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/ordernote/emptybrowseobject')
  Future<chopper.Response> ordernoteEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/ordernote/keyfieldnames')
  Future<chopper.Response> ordernoteKeyfieldnamesGet();

  ///
  @Post(path: '/ordersnapshot/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      ordersnapshotBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/ordersnapshot/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      ordersnapshotExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/ordersnapshot/emptyobject')
  Future<chopper.Response> ordersnapshotEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/ordersnapshot/emptybrowseobject')
  Future<chopper.Response> ordersnapshotEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/ordersnapshot/keyfieldnames')
  Future<chopper.Response> ordersnapshotKeyfieldnamesGet();

  ///
  @Post(path: '/orderstatus/storagecontainers/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderstatusStoragecontainersBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/orderstatus/storagecontainers/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      orderstatusStoragecontainersExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/orderstatus/storagecontainers')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerGridLogic>>
      orderstatusStoragecontainersGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Get(path: '/orderstatus/orderstatus/containers/emptyobject')
  Future<chopper.Response> orderstatusOrderstatusContainersEmptyobjectGet();

  ///
  @Post(path: '/orderstatus/storagecontaineritems/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderstatusStoragecontaineritemsBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/orderstatus/storagecontaineritems/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      orderstatusStoragecontaineritemsExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/orderstatus/storagecontaineritems')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerItemsGridLogic>>
      orderstatusStoragecontaineritemsGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Get(path: '/orderstatus/orderstatus/storagecontaineritems/emptyobject')
  Future<chopper.Response>
      orderstatusOrderstatusStoragecontaineritemsEmptyobjectGet();

  ///
  @Post(path: '/orderstatus/validateorder/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderstatusValidateorderBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/orderstatus/validateinventorytype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderstatusValidateinventorytypeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/orderstatus/validatecategory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderstatusValidatecategoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/orderstatus/validatesubcategory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderstatusValidatesubcategoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/orderstatus/validateicode/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderstatusValidateicodeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/orderstatus/validatewarehouse/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderstatusValidatewarehouseBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/orderstatus/emptyobject')
  Future<chopper.Response> orderstatusEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/orderstatus/emptybrowseobject')
  Future<chopper.Response> orderstatusEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/orderstatus/keyfieldnames')
  Future<chopper.Response> orderstatusKeyfieldnamesGet();

  ///
  @Post(path: '/orderstatusdetail/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderstatusdetailBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/orderstatusdetail/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      orderstatusdetailExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/orderstatusdetail/emptyobject')
  Future<chopper.Response> orderstatusdetailEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/orderstatusdetail/emptybrowseobject')
  Future<chopper.Response> orderstatusdetailEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/orderstatusdetail/keyfieldnames')
  Future<chopper.Response> orderstatusdetailKeyfieldnamesGet();

  ///
  @Post(path: '/orderstatushistory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderstatushistoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/orderstatushistory/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      orderstatushistoryExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/orderstatushistory')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistoryLogic>>
      orderstatushistoryGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  ///@param id
  @Get(path: '/orderstatushistory/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistory>>
      orderstatushistoryIdGet({@Path('id') required String? id});

  ///Get an empty object
  @Get(path: '/orderstatushistory/emptyobject')
  Future<chopper.Response> orderstatushistoryEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/orderstatushistory/emptybrowseobject')
  Future<chopper.Response> orderstatushistoryEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/orderstatushistory/keyfieldnames')
  Future<chopper.Response> orderstatushistoryKeyfieldnamesGet();

  ///
  @Post(path: '/orderstatussummary/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      orderstatussummaryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/orderstatussummary/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      orderstatussummaryExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param orderId
  ///@param orderItemId
  @Get(path: '/orderstatussummary')
  Future<
          chopper.Response<
              List<
                  WebApiModulesHomeControlsOrderStatusSummaryOrderStatusSummary>>>
      orderstatussummaryGet(
          {@Query('orderId') String? orderId,
          @Query('orderItemId') String? orderItemId});

  ///Get an empty object
  @Get(path: '/orderstatussummary/emptyobject')
  Future<chopper.Response> orderstatussummaryEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/orderstatussummary/emptybrowseobject')
  Future<chopper.Response> orderstatussummaryEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/orderstatussummary/keyfieldnames')
  Future<chopper.Response> orderstatussummaryKeyfieldnamesGet();

  ///
  ///@param id
  @Get(path: '/ordersummary/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsOrderSummaryOrderSummary>>
      ordersummaryIdGet({@Path('id') required String? id});

  ///Get an empty object
  @Get(path: '/ordersummary/emptyobject')
  Future<chopper.Response> ordersummaryEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/ordersummary/emptybrowseobject')
  Future<chopper.Response> ordersummaryEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/ordersummary/keyfieldnames')
  Future<chopper.Response> ordersummaryKeyfieldnamesGet();

  ///Get documents.
  ///@param inventoryid Unique identifier
  @Post(path: '/partsinventory/{inventoryid}/document/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      partsinventoryInventoryidDocumentBrowsePost(
          {@Path('inventoryid') required String? inventoryid,
          @Body() required FwStandardModelsBrowseRequest? body});

  ///Export documents to Excel.
  ///@param inventoryid Unique identifier
  @Post(path: '/partsinventory/{inventoryid}/document/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      partsinventoryInventoryidDocumentExportexcelxlsxPost(
          {@Path('inventoryid') required String? inventoryid,
          @Body() required FwStandardModelsBrowseRequest? body});

  ///Get documents.
  ///@param inventoryid Unique identifier
  ///@param DocumentTypeId Unique Identifier [Filter|Sort]
  ///@param Description Document description [Filter|Sort]
  ///@param DateStamp Document last modified data [Filter|Sort]
  ///@param PageNo The page number in the result set starting from 1.  PageNo is required when the PageSize is specified.
  ///@param PageSize Limit result set to the specified amount.
  ///@param Sort A sort expression to use of the form: Field1:asc,Field2:desc
  @Get(path: '/partsinventory/{inventoryid}/documents')
  Future<
          chopper.Response<
              FwStandardModelsGetResponseFwStandardGridsAppDocumentAppDocumentGetManyResponse>>
      partsinventoryInventoryidDocumentsGet(
          {@Path('inventoryid') required String? inventoryid,
          @Query('DocumentTypeId') String? documentTypeId,
          @Query('Description') String? description,
          @Query('DateStamp') String? dateStamp,
          @Query('PageNo') int? pageNo,
          @Query('PageSize') int? pageSize,
          @Query('Sort') String? sort});

  ///Get a document.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  @Get(path: '/partsinventory/{inventoryid}/document/{documentid}')
  Future<
          chopper.Response<
              WebApiModulesInventoryPartsInventoryPartsInventoryDocument>>
      partsinventoryInventoryidDocumentDocumentidGet(
          {@Path('inventoryid') required String? inventoryid,
          @Path('documentid') required String? documentid});

  ///Update a document.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/partsinventory/{inventoryid}/document/{documentid}')
  Future<
          chopper.Response<
              WebApiModulesInventoryPartsInventoryPartsInventoryDocument>>
      partsinventoryInventoryidDocumentDocumentidPut(
          {@Path('inventoryid')
              required String? inventoryid,
          @Path('documentid')
              required String? documentid,
          @Body()
              required WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPutRequest?
                  body});

  ///Delete a document.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  @Delete(path: '/partsinventory/{inventoryid}/document/{documentid}')
  Future<chopper.Response<bool>>
      partsinventoryInventoryidDocumentDocumentidDelete(
          {@Path('inventoryid') required String? inventoryid,
          @Path('documentid') required String? documentid});

  ///Create a new document.
  ///@param inventoryid Unique identifier
  @Post(path: '/partsinventory/{inventoryid}/document')
  Future<
          chopper.Response<
              WebApiModulesInventoryPartsInventoryPartsInventoryDocument>>
      partsinventoryInventoryidDocumentPost(
          {@Path('inventoryid')
              required String? inventoryid,
          @Body()
              required WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPostRequest?
                  body});

  ///Get thumbnails for any images attached to the document.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  ///@param pageno The page number of the result set, starting from page 1.
  ///@param pagesize The number of records per page of the result set.
  @Get(path: '/partsinventory/{inventoryid}/document/{documentid}/thumbnails')
  Future<
          chopper.Response<
              FwStandardGridsAppDocumentGetDocumentThumbnailsResponse>>
      partsinventoryInventoryidDocumentDocumentidThumbnailsGet(
          {@Path('inventoryid') required String? inventoryid,
          @Path('documentid') required String? documentid,
          @Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize});

  ///Get a fullsize image.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  ///@param imageid Unique identifier
  @Get(
      path:
          '/partsinventory/{inventoryid}/document/{documentid}/image/{imageid}')
  Future<chopper.Response<FwStandardGridsAppDocumentGetDocumentImageResponse>>
      partsinventoryInventoryidDocumentDocumentidImageImageidGet(
          {@Path('inventoryid') required String? inventoryid,
          @Path('documentid') required String? documentid,
          @Path('imageid') required String? imageid});

  ///Delete an attached image.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  ///@param imageid Unique identifier
  @Delete(
      path:
          '/partsinventory/{inventoryid}/document/{documentid}/image/{imageid}')
  Future<chopper.Response<bool>>
      partsinventoryInventoryidDocumentDocumentidImageImageidDelete(
          {@Path('inventoryid') required String? inventoryid,
          @Path('documentid') required String? documentid,
          @Path('imageid') required String? imageid});

  ///Attach an image from a dataurl.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  @Post(path: '/partsinventory/{inventoryid}/document/{documentid}/image')
  Future<chopper.Response<bool>>
      partsinventoryInventoryidDocumentDocumentidImagePost(
          {@Path('inventoryid')
              required String? inventoryid,
          @Path('documentid')
              required String? documentid,
          @Body()
              required FwStandardGridsAppDocumentPostDocumentImageRequest?
                  body});

  ///Attach an image from a form submission.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  @Post(
      path:
          '/partsinventory/{inventoryid}/document/{documentid}/imageformupload')
  Future<chopper.Response<bool>>
      partsinventoryInventoryidDocumentDocumentidImageformuploadPost(
          {@Path('inventoryid') required String? inventoryid,
          @Path('documentid') required String? documentid});

  ///Get the attached file.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  @Get(path: '/partsinventory/{inventoryid}/document/{documentid}/file')
  Future<chopper.Response> partsinventoryInventoryidDocumentDocumentidFileGet(
      {@Path('inventoryid') required String? inventoryid,
      @Path('documentid') required String? documentid});

  ///Update the attached file from a dataurl.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/partsinventory/{inventoryid}/document/{documentid}/file')
  Future<chopper.Response<bool>>
      partsinventoryInventoryidDocumentDocumentidFilePut(
          {@Path('inventoryid')
              required String? inventoryid,
          @Path('documentid')
              required String? documentid,
          @Body()
              required FwStandardGridsAppDocumentPutDocumentFileRequest? body});

  ///Delete attached file.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  @Delete(path: '/partsinventory/{inventoryid}/document/{documentid}/file')
  Future<chopper.Response<bool>>
      partsinventoryInventoryidDocumentDocumentidFileDelete(
          {@Path('inventoryid') required String? inventoryid,
          @Path('documentid') required String? documentid});

  ///Update attached file from a form submission.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  @Put(
      path:
          '/partsinventory/{inventoryid}/document/{documentid}/fileformupload')
  Future<chopper.Response<bool>>
      partsinventoryInventoryidDocumentDocumentidFileformuploadPut(
          {@Path('inventoryid') required String? inventoryid,
          @Path('documentid') required String? documentid});

  ///
  ///@param partsinventoryid
  @Get(path: '/partsinventory/{partsinventoryid}/document/emptyobject')
  Future<chopper.Response> partsinventoryPartsinventoryidDocumentEmptyobjectGet(
      {@Path('partsinventoryid') required String? partsinventoryid});

  ///
  @Post(path: '/partsinventory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      partsinventoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Get(path: '/partsinventory/legend')
  Future<chopper.Response<Object>> partsinventoryLegendGet();

  ///
  @Get(path: '/partsinventory/availabilitylegend')
  Future<chopper.Response<Object>> partsinventoryAvailabilitylegendGet();

  ///
  @Post(path: '/partsinventory/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      partsinventoryExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/partsinventory')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesInventoryPartsInventoryPartsInventoryLogic>>
      partsinventoryGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/partsinventory')
  Future<chopper.Response<WebApiModulesInventoryPartsInventoryPartsInventory>>
      partsinventoryPost(
          {@Body()
              required WebApiModulesInventoryPartsInventoryPartsInventory?
                  body});

  ///
  ///@param id
  @Get(path: '/partsinventory/{id}')
  Future<chopper.Response<WebApiModulesInventoryPartsInventoryPartsInventory>>
      partsinventoryIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/partsinventory/{id}')
  Future<chopper.Response<WebApiModulesInventoryPartsInventoryPartsInventory>>
      partsinventoryIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesInventoryPartsInventoryPartsInventory?
                  body});

  ///
  ///@param id
  @Delete(path: '/partsinventory/{id}')
  Future<chopper.Response<bool>> partsinventoryIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/partsinventory/validateinventorytype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      partsinventoryValidateinventorytypeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/partsinventory/validatecategory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      partsinventoryValidatecategoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/partsinventory/validatesubcategory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      partsinventoryValidatesubcategoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/partsinventory/validateunit/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      partsinventoryValidateunitBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/partsinventory/validaterank/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      partsinventoryValidaterankBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/partsinventory/validatemanufacturer/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      partsinventoryValidatemanufacturerBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/partsinventory/validateassetaccount/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      partsinventoryValidateassetaccountBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/partsinventory/validateincomeaccount/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      partsinventoryValidateincomeaccountBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/partsinventory/validatecostofgoodssoldexpenseaccount/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      partsinventoryValidatecostofgoodssoldexpenseaccountBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/partsinventory/validateprofitandloss/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      partsinventoryValidateprofitandlossBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/partsinventory/validatewarehouse/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      partsinventoryValidatewarehouseBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/partsinventory/validatecountryoforigin/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      partsinventoryValidatecountryoforiginBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/partsinventory/copy')
  Future<chopper.Response<WebApiModulesInventoryPartsInventoryPartsInventory>>
      partsinventoryCopyPost(
          {@Body()
              required WebApiModulesInventoryInventoryCopyInventoryRequest?
                  body});

  ///Get an empty object
  @Get(path: '/partsinventory/emptyobject')
  Future<chopper.Response> partsinventoryEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/partsinventory/emptybrowseobject')
  Future<chopper.Response> partsinventoryEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/partsinventory/keyfieldnames')
  Future<chopper.Response> partsinventoryKeyfieldnamesGet();

  ///
  @Post(path: '/payment/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      paymentBrowsePost({@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/payment/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      paymentExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Get(path: '/payment/legend')
  Future<chopper.Response<Object>> paymentLegendGet();

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/payment')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesBillingPaymentPaymentLogic>>
      paymentGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/payment')
  Future<chopper.Response<WebApiModulesBillingPaymentPayment>> paymentPost(
      {@Body() required WebApiModulesBillingPaymentPayment? body});

  ///
  ///@param id
  @Get(path: '/payment/{id}')
  Future<chopper.Response<WebApiModulesBillingPaymentPayment>> paymentIdGet(
      {@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/payment/{id}')
  Future<chopper.Response<WebApiModulesBillingPaymentPayment>> paymentIdPut(
      {@Path('id') required String? id,
      @Body() required WebApiModulesBillingPaymentPayment? body});

  ///
  ///@param id
  @Delete(path: '/payment/{id}')
  Future<chopper.Response<bool>> paymentIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/payment/validatepaymenttype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      paymentValidatepaymenttypeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/payment/gldistribution/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      paymentGldistributionBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/payment/emptyobject')
  Future<chopper.Response> paymentEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/payment/emptybrowseobject')
  Future<chopper.Response> paymentEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/payment/keyfieldnames')
  Future<chopper.Response> paymentKeyfieldnamesGet();

  ///
  @Post(path: '/paymentvendorinvoice/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      paymentvendorinvoiceBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/paymentvendorinvoice/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      paymentvendorinvoiceExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/paymentvendorinvoice/emptyobject')
  Future<chopper.Response> paymentvendorinvoiceEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/paymentvendorinvoice/emptybrowseobject')
  Future<chopper.Response> paymentvendorinvoiceEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/paymentvendorinvoice/keyfieldnames')
  Future<chopper.Response> paymentvendorinvoiceKeyfieldnamesGet();

  ///
  @Post(path: '/personalevent/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      personaleventBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/personalevent/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      personaleventExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/personalevent')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPersonalEventPersonalEventLogic>>
      personaleventGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/personalevent')
  Future<chopper.Response<WebApiModulesHomeControlsPersonalEventPersonalEvent>>
      personaleventPost(
          {@Body()
              required WebApiModulesHomeControlsPersonalEventPersonalEvent?
                  body});

  ///
  ///@param id
  @Get(path: '/personalevent/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsPersonalEventPersonalEvent>>
      personaleventIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/personalevent/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsPersonalEventPersonalEvent>>
      personaleventIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsPersonalEventPersonalEvent?
                  body});

  ///
  ///@param id
  @Delete(path: '/personalevent/{id}')
  Future<chopper.Response<bool>> personaleventIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/personalevent/validatecontactevent/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      personaleventValidatecontacteventBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/personalevent/emptyobject')
  Future<chopper.Response> personaleventEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/personalevent/emptybrowseobject')
  Future<chopper.Response> personaleventEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/personalevent/keyfieldnames')
  Future<chopper.Response> personaleventKeyfieldnamesGet();

  ///
  @Post(path: '/physicalinventory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      physicalinventoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Get(path: '/physicalinventory/legend')
  Future<chopper.Response<Object>> physicalinventoryLegendGet();

  ///
  @Post(path: '/physicalinventory/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      physicalinventoryExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/physicalinventory')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryLogic>>
      physicalinventoryGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/physicalinventory')
  Future<
          chopper.Response<
              WebApiModulesInventoryPhysicalInventoryPhysicalInventory>>
      physicalinventoryPost(
          {@Body()
              required WebApiModulesInventoryPhysicalInventoryPhysicalInventory?
                  body});

  ///
  ///@param id
  @Get(path: '/physicalinventory/{id}')
  Future<
          chopper.Response<
              WebApiModulesInventoryPhysicalInventoryPhysicalInventory>>
      physicalinventoryIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/physicalinventory/{id}')
  Future<
          chopper.Response<
              WebApiModulesInventoryPhysicalInventoryPhysicalInventory>>
      physicalinventoryIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesInventoryPhysicalInventoryPhysicalInventory?
                  body});

  ///
  @Post(path: '/physicalinventory/void')
  Future<
          chopper.Response<
              WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidResponse>>
      physicalinventoryVoidPost(
          {@Body()
              required WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidRequest?
                  body});

  ///
  @Post(path: '/physicalinventory/updateicodes')
  Future<
          chopper.Response<
              WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesResponse>>
      physicalinventoryUpdateicodesPost(
          {@Body()
              required WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesRequest?
                  body});

  ///
  @Post(path: '/physicalinventory/prescan')
  Future<
          chopper.Response<
              WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanResponse>>
      physicalinventoryPrescanPost(
          {@Body()
              required WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanRequest?
                  body});

  ///
  @Post(path: '/physicalinventory/initiate')
  Future<
          chopper.Response<
              WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateResponse>>
      physicalinventoryInitiatePost(
          {@Body()
              required WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateRequest?
                  body});

  ///
  ///@param id
  ///@param stepname
  @Post(
      path: '/physicalinventory/{id}/updatestep/{stepname}', optionalBody: true)
  Future<
          chopper.Response<
              WebApiModulesInventoryPhysicalInventoryPhysicalInventory>>
      physicalinventoryIdUpdatestepStepnamePost(
          {@Path('id') required String? id,
          @Path('stepname') required String? stepname});

  ///
  @Post(path: '/physicalinventory/countitem')
  Future<
          chopper.Response<
              WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemResponse>>
      physicalinventoryCountitemPost(
          {@Body()
              required WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemRequest?
                  body});

  ///
  @Post(path: '/physicalinventory/replacecounts')
  Future<
          chopper.Response<
              WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsResponse>>
      physicalinventoryReplacecountsPost(
          {@Body()
              required WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsRequest?
                  body});

  ///
  @Post(path: '/physicalinventory/getphysicalcounts')
  Future<
          chopper.Response<
              WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusResponse>>
      physicalinventoryGetphysicalcountsPost(
          {@Body()
              required WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusRequest?
                  body});

  ///
  @Post(path: '/physicalinventory/approve')
  Future<
          chopper.Response<
              WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveResponse>>
      physicalinventoryApprovePost(
          {@Body()
              required WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveRequest?
                  body});

  ///
  @Post(path: '/physicalinventory/close')
  Future<
          chopper.Response<
              WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseResponse>>
      physicalinventoryClosePost(
          {@Body()
              required WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseRequest?
                  body});

  ///
  @Post(path: '/physicalinventory/validateconsignor/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      physicalinventoryValidateconsignorBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/physicalinventory/validateinventorytype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      physicalinventoryValidateinventorytypeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/physicalinventory/validatecategory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      physicalinventoryValidatecategoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/physicalinventory/validatesubcategory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      physicalinventoryValidatesubcategoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/physicalinventory/validateicode/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      physicalinventoryValidateicodeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/physicalinventory/uncountserialitem')
  Future<
          chopper.Response<
              WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemResponse>>
      physicalinventoryUncountserialitemPost(
          {@Body()
              required WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemRequest?
                  body});

  ///
  @Post(path: '/physicalinventory/countquantity/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      physicalinventoryCountquantityBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/physicalinventory/countquantity/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      physicalinventoryCountquantityExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/physicalinventory/countquantity')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantityLogic>>
      physicalinventoryCountquantityGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/physicalinventory/serialcounted/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      physicalinventorySerialcountedBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/physicalinventory/serialcounted/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      physicalinventorySerialcountedExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/physicalinventory/countserial/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      physicalinventoryCountserialBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/physicalinventory/countserial/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      physicalinventoryCountserialExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/physicalinventory/countserial')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerialLogic>>
      physicalinventoryCountserialGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/physicalinventory/exceptions/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      physicalinventoryExceptionsBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/physicalinventory/exceptions/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      physicalinventoryExceptionsExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/physicalinventory/exceptions')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptionsLogic>>
      physicalinventoryExceptionsGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/physicalinventory/itemsadded/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      physicalinventoryItemsaddedBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/physicalinventory/itemsadded/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      physicalinventoryItemsaddedExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/physicalinventory/itemsadded')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAddedLogic>>
      physicalinventoryItemsaddedGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  ///@param id
  @Put(path: '/physicalinventory/itemsadded/{id}')
  Future<
          chopper.Response<
              WebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAdded>>
      physicalinventoryItemsaddedIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAdded?
                  body});

  ///
  @Post(path: '/physicalinventory/itemsadded/approvepurchasecost')
  Future<
          chopper.Response<
              WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostResponse>>
      physicalinventoryItemsaddedApprovepurchasecostPost(
          {@Body()
              required WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostRequest?
                  body});

  ///
  @Post(path: '/physicalinventory/itemsadded/newpurchasecost')
  Future<
          chopper.Response<
              WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostResponse>>
      physicalinventoryItemsaddedNewpurchasecostPost(
          {@Body()
              required WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostRequest?
                  body});

  ///
  @Post(path: '/physicalinventory/recount/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      physicalinventoryRecountBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/physicalinventory/recount/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      physicalinventoryRecountExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/physicalinventory/recount')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountLogic>>
      physicalinventoryRecountGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Put(path: '/physicalinventory/recount/update')
  Future<chopper.Response<bool>> physicalinventoryRecountUpdatePut(
      {@Body()
          required WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequest?
              body});

  ///Get an empty object
  @Get(path: '/physicalinventory/emptyobject')
  Future<chopper.Response> physicalinventoryEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/physicalinventory/emptybrowseobject')
  Future<chopper.Response> physicalinventoryEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/physicalinventory/keyfieldnames')
  Future<chopper.Response> physicalinventoryKeyfieldnamesGet();

  ///
  @Post(path: '/physicalinventorycycleinventory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      physicalinventorycycleinventoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/physicalinventorycycleinventory/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      physicalinventorycycleinventoryExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/physicalinventorycycleinventory')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventoryLogic>>
      physicalinventorycycleinventoryGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/physicalinventorycycleinventory')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventory>>
      physicalinventorycycleinventoryPost(
          {@Body()
              required WebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventory?
                  body});

  ///
  ///@param id
  @Get(path: '/physicalinventorycycleinventory/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventory>>
      physicalinventorycycleinventoryIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/physicalinventorycycleinventory/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventory>>
      physicalinventorycycleinventoryIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventory?
                  body});

  ///
  ///@param id
  @Delete(path: '/physicalinventorycycleinventory/{id}')
  Future<chopper.Response<bool>> physicalinventorycycleinventoryIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/physicalinventorycycleinventory/validateinventory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      physicalinventorycycleinventoryValidateinventoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/physicalinventorycycleinventory/validateicoderental/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      physicalinventorycycleinventoryValidateicoderentalBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/physicalinventorycycleinventory/validateicodesales/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      physicalinventorycycleinventoryValidateicodesalesBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/physicalinventorycycleinventory/validateicodeparts/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      physicalinventorycycleinventoryValidateicodepartsBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/physicalinventorycycleinventory/emptyobject')
  Future<chopper.Response> physicalinventorycycleinventoryEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/physicalinventorycycleinventory/emptybrowseobject')
  Future<chopper.Response>
      physicalinventorycycleinventoryEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/physicalinventorycycleinventory/keyfieldnames')
  Future<chopper.Response> physicalinventorycycleinventoryKeyfieldnamesGet();

  ///
  @Post(path: '/physicalinventoryinventory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      physicalinventoryinventoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/physicalinventoryinventory/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      physicalinventoryinventoryExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/physicalinventoryinventory')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventoryLogic>>
      physicalinventoryinventoryGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/physicalinventoryinventory')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventory>>
      physicalinventoryinventoryPost(
          {@Body()
              required WebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventory?
                  body});

  ///
  ///@param id
  @Get(path: '/physicalinventoryinventory/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventory>>
      physicalinventoryinventoryIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/physicalinventoryinventory/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventory>>
      physicalinventoryinventoryIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventory?
                  body});

  ///
  ///@param id
  @Delete(path: '/physicalinventoryinventory/{id}')
  Future<chopper.Response<bool>> physicalinventoryinventoryIdDelete(
      {@Path('id') required String? id});

  ///Get an empty object
  @Get(path: '/physicalinventoryinventory/emptyobject')
  Future<chopper.Response> physicalinventoryinventoryEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/physicalinventoryinventory/emptybrowseobject')
  Future<chopper.Response> physicalinventoryinventoryEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/physicalinventoryinventory/keyfieldnames')
  Future<chopper.Response> physicalinventoryinventoryKeyfieldnamesGet();

  ///
  @Post(path: '/picklist/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      picklistBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/picklist/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      picklistExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/picklist')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesWarehousePickListPickListLogic>>
      picklistGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/picklist')
  Future<chopper.Response<WebApiModulesWarehousePickListPickList>> picklistPost(
      {@Body() required WebApiModulesWarehousePickListPickList? body});

  ///
  ///@param id
  @Get(path: '/picklist/{id}')
  Future<chopper.Response<WebApiModulesWarehousePickListPickList>>
      picklistIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/picklist/{id}')
  Future<chopper.Response<WebApiModulesWarehousePickListPickList>>
      picklistIdPut(
          {@Path('id') required String? id,
          @Body() required WebApiModulesWarehousePickListPickList? body});

  ///
  ///@param id
  @Delete(path: '/picklist/{id}')
  Future<chopper.Response<bool>> picklistIdDelete(
      {@Path('id') required String? id});

  ///Get an empty object
  @Get(path: '/picklist/emptyobject')
  Future<chopper.Response> picklistEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/picklist/emptybrowseobject')
  Future<chopper.Response> picklistEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/picklist/keyfieldnames')
  Future<chopper.Response> picklistKeyfieldnamesGet();

  ///
  @Post(path: '/picklistitem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      picklistitemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/picklistitem/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      picklistitemExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/picklistitem')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPickListItemPickListItemLogic>>
      picklistitemGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/picklistitem')
  Future<chopper.Response<WebApiModulesHomeControlsPickListItemPickListItem>>
      picklistitemPost(
          {@Body()
              required WebApiModulesHomeControlsPickListItemPickListItem?
                  body});

  ///
  ///@param id
  @Get(path: '/picklistitem/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsPickListItemPickListItem>>
      picklistitemIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/picklistitem/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsPickListItemPickListItem>>
      picklistitemIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsPickListItemPickListItem?
                  body});

  ///
  ///@param id
  @Delete(path: '/picklistitem/{id}')
  Future<chopper.Response<bool>> picklistitemIdDelete(
      {@Path('id') required String? id});

  ///Get an empty object
  @Get(path: '/picklistitem/emptyobject')
  Future<chopper.Response> picklistitemEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/picklistitem/emptybrowseobject')
  Future<chopper.Response> picklistitemEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/picklistitem/keyfieldnames')
  Future<chopper.Response> picklistitemKeyfieldnamesGet();

  ///
  @Post(path: '/picklistutilityitem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      picklistutilityitemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/picklistutilityitem/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      picklistutilityitemExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/picklistutilityitem')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsPickListUtilityItemPickListUtilityItem>>
      picklistutilityitemPost(
          {@Body()
              required WebApiModulesHomeControlsPickListUtilityItemPickListUtilityItem?
                  body});

  ///
  ///@param id
  @Put(path: '/picklistutilityitem/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsPickListUtilityItemPickListUtilityItem>>
      picklistutilityitemIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsPickListUtilityItemPickListUtilityItem?
                  body});

  ///
  @Post(path: '/picklistutilityitem/selectall')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      picklistutilityitemSelectallPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/picklistutilityitem/selectnone')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      picklistutilityitemSelectnonePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/picklistutilityitem/startsession')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsPickListUtilityItemStartSessionResponse>>
      picklistutilityitemStartsessionPost(
          {@Body()
              required WebApiModulesHomeControlsPickListUtilityItemStartSessionRequest?
                  body});

  ///
  @Post(path: '/picklistutilityitem/applypicklistsessionitems')
  Future<chopper.Response<WebApiLogicTSpStatusResponse>>
      picklistutilityitemApplypicklistsessionitemsPost(
          {@Body()
              required WebApiModulesHomeControlsPickListUtilityItemApplyPickListSessionItemsRequest?
                  body});

  ///
  @Post(path: '/picklistutilityitem/completepicklistsession')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsPickListUtilityItemCompleteSessionResponse>>
      picklistutilityitemCompletepicklistsessionPost(
          {@Body()
              required WebApiModulesHomeControlsPickListUtilityItemCompleteSessionRequest?
                  body});

  ///
  @Post(path: '/picklistutilityitem/createpicklist')
  Future<chopper.Response<WebApiModulesWarehousePickListPickList>>
      picklistutilityitemCreatepicklistPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/picklistutilityitem/emptyobject')
  Future<chopper.Response> picklistutilityitemEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/picklistutilityitem/emptybrowseobject')
  Future<chopper.Response> picklistutilityitemEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/picklistutilityitem/keyfieldnames')
  Future<chopper.Response> picklistutilityitemKeyfieldnamesGet();

  ///
  @Post(path: '/pricing/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      pricingBrowsePost({@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/pricing/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      pricingExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param inventoryid
  ///@param warehouseid
  ///@param currencyid
  @Get(path: '/pricing/{inventoryid}/{warehouseid}/{currencyid}')
  Future<chopper.Response<List<WebApiModulesHomeControlsPricingPricing>>>
      pricingInventoryidWarehouseidCurrencyidGet(
          {@Path('inventoryid') required String? inventoryid,
          @Path('warehouseid') required String? warehouseid,
          @Path('currencyid') required String? currencyid});

  ///
  ///@param inventoryid
  ///@param warehouseid
  @Get(path: '/pricing/{inventoryid}/{warehouseid}')
  Future<chopper.Response<List<WebApiModulesHomeControlsPricingPricing>>>
      pricingInventoryidWarehouseidGet(
          {@Path('inventoryid') required String? inventoryid,
          @Path('warehouseid') required String? warehouseid});

  ///
  ///@param inventoryId
  @Get(path: '/pricing/{inventoryid}')
  Future<chopper.Response<List<WebApiModulesHomeControlsPricingPricing>>>
      pricingInventoryidGet(
          {@Path('inventoryId') required String? inventoryId});

  ///
  @Post(path: '/pricing/many')
  Future<
          chopper.Response<
              List<
                  MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsPricingPricingLogic>>>
      pricingManyPost(
          {@Body()
              required List<WebApiModulesHomeControlsPricingPricing>? body});

  ///Get an empty object
  @Get(path: '/pricing/emptyobject')
  Future<chopper.Response> pricingEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/pricing/emptybrowseobject')
  Future<chopper.Response> pricingEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/pricing/keyfieldnames')
  Future<chopper.Response> pricingKeyfieldnamesGet();

  ///Get documents.
  ///@param projectid Unique identifier
  @Post(path: '/project/{projectid}/document/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      projectProjectidDocumentBrowsePost(
          {@Path('projectid') required String? projectid,
          @Body() required FwStandardModelsBrowseRequest? body});

  ///Export documents to Excel.
  ///@param projectid Unique identifier
  @Post(path: '/project/{projectid}/document/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      projectProjectidDocumentExportexcelxlsxPost(
          {@Path('projectid') required String? projectid,
          @Body() required FwStandardModelsBrowseRequest? body});

  ///Get documents.
  ///@param projectid Unique identifier
  ///@param DocumentTypeId Unique Identifier [Filter|Sort]
  ///@param Description Document description [Filter|Sort]
  ///@param DateStamp Document last modified data [Filter|Sort]
  ///@param PageNo The page number in the result set starting from 1.  PageNo is required when the PageSize is specified.
  ///@param PageSize Limit result set to the specified amount.
  ///@param Sort A sort expression to use of the form: Field1:asc,Field2:desc
  @Get(path: '/project/{projectid}/documents')
  Future<
          chopper.Response<
              FwStandardModelsGetResponseFwStandardGridsAppDocumentAppDocumentGetManyResponse>>
      projectProjectidDocumentsGet(
          {@Path('projectid') required String? projectid,
          @Query('DocumentTypeId') String? documentTypeId,
          @Query('Description') String? description,
          @Query('DateStamp') String? dateStamp,
          @Query('PageNo') int? pageNo,
          @Query('PageSize') int? pageSize,
          @Query('Sort') String? sort});

  ///Get a document.
  ///@param projectid Unique identifier
  ///@param documentid Unique identifier
  @Get(path: '/project/{projectid}/document/{documentid}')
  Future<chopper.Response<WebApiModulesAgentProjectProjectDocument>>
      projectProjectidDocumentDocumentidGet(
          {@Path('projectid') required String? projectid,
          @Path('documentid') required String? documentid});

  ///Update a document.
  ///@param projectid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/project/{projectid}/document/{documentid}')
  Future<chopper.Response<WebApiModulesAgentProjectProjectDocument>>
      projectProjectidDocumentDocumentidPut(
          {@Path('projectid')
              required String? projectid,
          @Path('documentid')
              required String? documentid,
          @Body()
              required WebApiModulesAgentProjectProjectDocumentPutRequest?
                  body});

  ///Delete a document.
  ///@param projectid Unique identifier
  ///@param documentid Unique identifier
  @Delete(path: '/project/{projectid}/document/{documentid}')
  Future<chopper.Response<bool>> projectProjectidDocumentDocumentidDelete(
      {@Path('projectid') required String? projectid,
      @Path('documentid') required String? documentid});

  ///Create a new document.
  ///@param projectid Unique identifier
  @Post(path: '/project/{projectid}/document')
  Future<chopper.Response<WebApiModulesAgentProjectProjectDocument>>
      projectProjectidDocumentPost(
          {@Path('projectid')
              required String? projectid,
          @Body()
              required WebApiModulesAgentProjectProjectDocumentPostRequest?
                  body});

  ///Get thumbnails for any images attached to the document.
  ///@param projectid Unique identifier
  ///@param documentid Unique identifier
  ///@param pageno The page number of the result set, starting from page 1.
  ///@param pagesize The number of records per page of the result set.
  @Get(path: '/project/{projectid}/document/{documentid}/thumbnails')
  Future<
          chopper.Response<
              FwStandardGridsAppDocumentGetDocumentThumbnailsResponse>>
      projectProjectidDocumentDocumentidThumbnailsGet(
          {@Path('projectid') required String? projectid,
          @Path('documentid') required String? documentid,
          @Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize});

  ///Get a fullsize image.
  ///@param projectid Unique identifier
  ///@param documentid Unique identifier
  ///@param imageid Unique identifier
  @Get(path: '/project/{projectid}/document/{documentid}/image/{imageid}')
  Future<chopper.Response<FwStandardGridsAppDocumentGetDocumentImageResponse>>
      projectProjectidDocumentDocumentidImageImageidGet(
          {@Path('projectid') required String? projectid,
          @Path('documentid') required String? documentid,
          @Path('imageid') required String? imageid});

  ///Delete an attached image.
  ///@param projectid Unique identifier
  ///@param documentid Unique identifier
  ///@param imageid Unique identifier
  @Delete(path: '/project/{projectid}/document/{documentid}/image/{imageid}')
  Future<chopper.Response<bool>>
      projectProjectidDocumentDocumentidImageImageidDelete(
          {@Path('projectid') required String? projectid,
          @Path('documentid') required String? documentid,
          @Path('imageid') required String? imageid});

  ///Attach an image from a dataurl.
  ///@param projectid Unique identifier
  ///@param documentid Unique identifier
  @Post(path: '/project/{projectid}/document/{documentid}/image')
  Future<chopper.Response<bool>> projectProjectidDocumentDocumentidImagePost(
      {@Path('projectid')
          required String? projectid,
      @Path('documentid')
          required String? documentid,
      @Body()
          required FwStandardGridsAppDocumentPostDocumentImageRequest? body});

  ///Attach an image from a form submission.
  ///@param projectid Unique identifier
  ///@param documentid Unique identifier
  @Post(path: '/project/{projectid}/document/{documentid}/imageformupload')
  Future<chopper.Response<bool>>
      projectProjectidDocumentDocumentidImageformuploadPost(
          {@Path('projectid') required String? projectid,
          @Path('documentid') required String? documentid});

  ///Get the attached file.
  ///@param projectid Unique identifier
  ///@param documentid Unique identifier
  @Get(path: '/project/{projectid}/document/{documentid}/file')
  Future<chopper.Response> projectProjectidDocumentDocumentidFileGet(
      {@Path('projectid') required String? projectid,
      @Path('documentid') required String? documentid});

  ///Update the attached file from a dataurl.
  ///@param projectid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/project/{projectid}/document/{documentid}/file')
  Future<chopper.Response<bool>> projectProjectidDocumentDocumentidFilePut(
      {@Path('projectid') required String? projectid,
      @Path('documentid') required String? documentid,
      @Body() required FwStandardGridsAppDocumentPutDocumentFileRequest? body});

  ///Delete attached file.
  ///@param projectid Unique identifier
  ///@param documentid Unique identifier
  @Delete(path: '/project/{projectid}/document/{documentid}/file')
  Future<chopper.Response<bool>> projectProjectidDocumentDocumentidFileDelete(
      {@Path('projectid') required String? projectid,
      @Path('documentid') required String? documentid});

  ///Update attached file from a form submission.
  ///@param projectid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/project/{projectid}/document/{documentid}/fileformupload')
  Future<chopper.Response<bool>>
      projectProjectidDocumentDocumentidFileformuploadPut(
          {@Path('projectid') required String? projectid,
          @Path('documentid') required String? documentid});

  ///
  ///@param projectid
  @Get(path: '/project/{projectid}/document/emptyobject')
  Future<chopper.Response> projectProjectidDocumentEmptyobjectGet(
      {@Path('projectid') required String? projectid});

  ///
  @Post(path: '/project/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      projectBrowsePost({@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/project/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      projectExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/project')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAgentProjectProjectLogic>>
      projectGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/project')
  Future<chopper.Response<WebApiModulesAgentProjectProject>> projectPost(
      {@Body() required WebApiModulesAgentProjectProject? body});

  ///
  ///@param id
  @Get(path: '/project/{id}')
  Future<chopper.Response<WebApiModulesAgentProjectProject>> projectIdGet(
      {@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/project/{id}')
  Future<chopper.Response<WebApiModulesAgentProjectProject>> projectIdPut(
      {@Path('id') required String? id,
      @Body() required WebApiModulesAgentProjectProject? body});

  ///
  ///@param id
  @Delete(path: '/project/{id}')
  Future<chopper.Response<bool>> projectIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/project/createquote')
  Future<
          chopper.Response<
              WebApiModulesAgentProjectCreateQuoteFromProjectResponse>>
      projectCreatequotePost(
          {@Body()
              required WebApiModulesAgentProjectCreateQuoteFromProjectRequest?
                  body});

  ///
  @Post(path: '/project/validatedeal/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      projectValidatedealBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/project/validatedepartment/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      projectValidatedepartmentBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/project/validateagent/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      projectValidateagentBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/project/validateprojectmanager/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      projectValidateprojectmanagerBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/project/validatesalesrepresentative/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      projectValidatesalesrepresentativeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/project/emptyobject')
  Future<chopper.Response> projectEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/project/emptybrowseobject')
  Future<chopper.Response> projectEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/project/keyfieldnames')
  Future<chopper.Response> projectKeyfieldnamesGet();

  ///
  @Post(path: '/projectcontact/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      projectcontactBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/projectcontact/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      projectcontactExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/projectcontact')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectContactProjectContactLogic>>
      projectcontactGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/projectcontact')
  Future<
          chopper
              .Response<WebApiModulesHomeControlsProjectContactProjectContact>>
      projectcontactPost(
          {@Body()
              required WebApiModulesHomeControlsProjectContactProjectContact?
                  body});

  ///
  ///@param id
  @Get(path: '/projectcontact/{id}')
  Future<
          chopper
              .Response<WebApiModulesHomeControlsProjectContactProjectContact>>
      projectcontactIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/projectcontact/{id}')
  Future<
          chopper
              .Response<WebApiModulesHomeControlsProjectContactProjectContact>>
      projectcontactIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsProjectContactProjectContact?
                  body});

  ///
  ///@param id
  @Delete(path: '/projectcontact/{id}')
  Future<chopper.Response<bool>> projectcontactIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/projectcontact/validatecontact/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      projectcontactValidatecontactBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/projectcontact/validatecontacttitle/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      projectcontactValidatecontacttitleBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/projectcontact/emptyobject')
  Future<chopper.Response> projectcontactEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/projectcontact/emptybrowseobject')
  Future<chopper.Response> projectcontactEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/projectcontact/keyfieldnames')
  Future<chopper.Response> projectcontactKeyfieldnamesGet();

  ///
  @Post(path: '/projectnote/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      projectnoteBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/projectnote/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      projectnoteExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/projectnote')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectNoteProjectNoteLogic>>
      projectnoteGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/projectnote')
  Future<chopper.Response<WebApiModulesHomeControlsProjectNoteProjectNote>>
      projectnotePost(
          {@Body()
              required WebApiModulesHomeControlsProjectNoteProjectNote? body});

  ///
  ///@param id
  @Get(path: '/projectnote/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsProjectNoteProjectNote>>
      projectnoteIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/projectnote/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsProjectNoteProjectNote>>
      projectnoteIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsProjectNoteProjectNote? body});

  ///
  ///@param id
  @Delete(path: '/projectnote/{id}')
  Future<chopper.Response<bool>> projectnoteIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/projectnote/validateuser/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      projectnoteValidateuserBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/projectnote/emptyobject')
  Future<chopper.Response> projectnoteEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/projectnote/emptybrowseobject')
  Future<chopper.Response> projectnoteEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/projectnote/keyfieldnames')
  Future<chopper.Response> projectnoteKeyfieldnamesGet();

  ///Get documents.
  ///@param purchaseorderid Unique identifier
  @Post(path: '/purchaseorder/{purchaseorderid}/document/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      purchaseorderPurchaseorderidDocumentBrowsePost(
          {@Path('purchaseorderid') required String? purchaseorderid,
          @Body() required FwStandardModelsBrowseRequest? body});

  ///Export documents to Excel.
  ///@param purchaseorderid Unique identifier
  @Post(path: '/purchaseorder/{purchaseorderid}/document/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      purchaseorderPurchaseorderidDocumentExportexcelxlsxPost(
          {@Path('purchaseorderid') required String? purchaseorderid,
          @Body() required FwStandardModelsBrowseRequest? body});

  ///Get documents.
  ///@param purchaseorderid Unique identifier
  ///@param DocumentTypeId Unique Identifier [Filter|Sort]
  ///@param Description Document description [Filter|Sort]
  ///@param DateStamp Document last modified data [Filter|Sort]
  ///@param PageNo The page number in the result set starting from 1.  PageNo is required when the PageSize is specified.
  ///@param PageSize Limit result set to the specified amount.
  ///@param Sort A sort expression to use of the form: Field1:asc,Field2:desc
  @Get(path: '/purchaseorder/{purchaseorderid}/documents')
  Future<
          chopper.Response<
              FwStandardModelsGetResponseFwStandardGridsAppDocumentAppDocumentGetManyResponse>>
      purchaseorderPurchaseorderidDocumentsGet(
          {@Path('purchaseorderid') required String? purchaseorderid,
          @Query('DocumentTypeId') String? documentTypeId,
          @Query('Description') String? description,
          @Query('DateStamp') String? dateStamp,
          @Query('PageNo') int? pageNo,
          @Query('PageSize') int? pageSize,
          @Query('Sort') String? sort});

  ///Get a document.
  ///@param purchaseorderid Unique identifier
  ///@param documentid Unique identifier
  @Get(path: '/purchaseorder/{purchaseorderid}/document/{documentid}')
  Future<chopper.Response<WebApiModulesAgentPurchaseOrderPurchaseOrderDocument>>
      purchaseorderPurchaseorderidDocumentDocumentidGet(
          {@Path('purchaseorderid') required String? purchaseorderid,
          @Path('documentid') required String? documentid});

  ///Update a document.
  ///@param purchaseorderid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/purchaseorder/{purchaseorderid}/document/{documentid}')
  Future<chopper.Response<WebApiModulesAgentPurchaseOrderPurchaseOrderDocument>>
      purchaseorderPurchaseorderidDocumentDocumentidPut(
          {@Path('purchaseorderid')
              required String? purchaseorderid,
          @Path('documentid')
              required String? documentid,
          @Body()
              required WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPutRequest?
                  body});

  ///Delete a document.
  ///@param purchaseorderid Unique identifier
  ///@param documentid Unique identifier
  @Delete(path: '/purchaseorder/{purchaseorderid}/document/{documentid}')
  Future<chopper.Response<bool>>
      purchaseorderPurchaseorderidDocumentDocumentidDelete(
          {@Path('purchaseorderid') required String? purchaseorderid,
          @Path('documentid') required String? documentid});

  ///Create a new document.
  ///@param purchaseorderid Unique identifier
  @Post(path: '/purchaseorder/{purchaseorderid}/document')
  Future<chopper.Response<WebApiModulesAgentPurchaseOrderPurchaseOrderDocument>>
      purchaseorderPurchaseorderidDocumentPost(
          {@Path('purchaseorderid')
              required String? purchaseorderid,
          @Body()
              required WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPostRequest?
                  body});

  ///Get thumbnails for any images attached to the document.
  ///@param purchaseorderid Unique identifier
  ///@param documentid Unique identifier
  ///@param pageno The page number of the result set, starting from page 1.
  ///@param pagesize The number of records per page of the result set.
  @Get(
      path: '/purchaseorder/{purchaseorderid}/document/{documentid}/thumbnails')
  Future<
          chopper.Response<
              FwStandardGridsAppDocumentGetDocumentThumbnailsResponse>>
      purchaseorderPurchaseorderidDocumentDocumentidThumbnailsGet(
          {@Path('purchaseorderid') required String? purchaseorderid,
          @Path('documentid') required String? documentid,
          @Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize});

  ///Get a fullsize image.
  ///@param purchaseorderid Unique identifier
  ///@param documentid Unique identifier
  ///@param imageid Unique identifier
  @Get(
      path:
          '/purchaseorder/{purchaseorderid}/document/{documentid}/image/{imageid}')
  Future<chopper.Response<FwStandardGridsAppDocumentGetDocumentImageResponse>>
      purchaseorderPurchaseorderidDocumentDocumentidImageImageidGet(
          {@Path('purchaseorderid') required String? purchaseorderid,
          @Path('documentid') required String? documentid,
          @Path('imageid') required String? imageid});

  ///Delete an attached image.
  ///@param purchaseorderid Unique identifier
  ///@param documentid Unique identifier
  ///@param imageid Unique identifier
  @Delete(
      path:
          '/purchaseorder/{purchaseorderid}/document/{documentid}/image/{imageid}')
  Future<chopper.Response<bool>>
      purchaseorderPurchaseorderidDocumentDocumentidImageImageidDelete(
          {@Path('purchaseorderid') required String? purchaseorderid,
          @Path('documentid') required String? documentid,
          @Path('imageid') required String? imageid});

  ///Attach an image from a dataurl.
  ///@param purchaseorderid Unique identifier
  ///@param documentid Unique identifier
  @Post(path: '/purchaseorder/{purchaseorderid}/document/{documentid}/image')
  Future<chopper.Response<bool>>
      purchaseorderPurchaseorderidDocumentDocumentidImagePost(
          {@Path('purchaseorderid')
              required String? purchaseorderid,
          @Path('documentid')
              required String? documentid,
          @Body()
              required FwStandardGridsAppDocumentPostDocumentImageRequest?
                  body});

  ///Attach an image from a form submission.
  ///@param purchaseorderid Unique identifier
  ///@param documentid Unique identifier
  @Post(
      path:
          '/purchaseorder/{purchaseorderid}/document/{documentid}/imageformupload')
  Future<chopper.Response<bool>>
      purchaseorderPurchaseorderidDocumentDocumentidImageformuploadPost(
          {@Path('purchaseorderid') required String? purchaseorderid,
          @Path('documentid') required String? documentid});

  ///Get the attached file.
  ///@param purchaseorderid Unique identifier
  ///@param documentid Unique identifier
  @Get(path: '/purchaseorder/{purchaseorderid}/document/{documentid}/file')
  Future<chopper.Response>
      purchaseorderPurchaseorderidDocumentDocumentidFileGet(
          {@Path('purchaseorderid') required String? purchaseorderid,
          @Path('documentid') required String? documentid});

  ///Update the attached file from a dataurl.
  ///@param purchaseorderid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/purchaseorder/{purchaseorderid}/document/{documentid}/file')
  Future<chopper.Response<bool>>
      purchaseorderPurchaseorderidDocumentDocumentidFilePut(
          {@Path('purchaseorderid')
              required String? purchaseorderid,
          @Path('documentid')
              required String? documentid,
          @Body()
              required FwStandardGridsAppDocumentPutDocumentFileRequest? body});

  ///Delete attached file.
  ///@param purchaseorderid Unique identifier
  ///@param documentid Unique identifier
  @Delete(path: '/purchaseorder/{purchaseorderid}/document/{documentid}/file')
  Future<chopper.Response<bool>>
      purchaseorderPurchaseorderidDocumentDocumentidFileDelete(
          {@Path('purchaseorderid') required String? purchaseorderid,
          @Path('documentid') required String? documentid});

  ///Update attached file from a form submission.
  ///@param purchaseorderid Unique identifier
  ///@param documentid Unique identifier
  @Put(
      path:
          '/purchaseorder/{purchaseorderid}/document/{documentid}/fileformupload')
  Future<chopper.Response<bool>>
      purchaseorderPurchaseorderidDocumentDocumentidFileformuploadPut(
          {@Path('purchaseorderid') required String? purchaseorderid,
          @Path('documentid') required String? documentid});

  ///
  ///@param purchaseorderid
  @Get(path: '/purchaseorder/{purchaseorderid}/document/emptyobject')
  Future<chopper.Response> purchaseorderPurchaseorderidDocumentEmptyobjectGet(
      {@Path('purchaseorderid') required String? purchaseorderid});

  ///
  @Post(path: '/purchaseorder/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      purchaseorderBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get Purchase Order details
  ///@param purchaseorderid Unique Id
  @Get(path: '/purchaseorder/{purchaseorderid}/purchaseorderdetails')
  Future<
          chopper.Response<
              WebApiModulesAgentPurchaseOrderGetPurchaseOrderResponse>>
      purchaseorderPurchaseorderidPurchaseorderdetailsGet(
          {@Path('purchaseorderid') required String? purchaseorderid});

  ///
  @Get(path: '/purchaseorder/legend')
  Future<chopper.Response<Object>> purchaseorderLegendGet();

  ///
  @Post(path: '/purchaseorder/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      purchaseorderExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/purchaseorder')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAgentPurchaseOrderPurchaseOrderLogic>>
      purchaseorderGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/purchaseorder')
  Future<chopper.Response<WebApiModulesAgentPurchaseOrderPurchaseOrder>>
      purchaseorderPost(
          {@Body()
              required WebApiModulesAgentPurchaseOrderPurchaseOrder? body});

  ///
  ///@param id
  @Get(path: '/purchaseorder/{id}')
  Future<chopper.Response<WebApiModulesAgentPurchaseOrderPurchaseOrder>>
      purchaseorderIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/purchaseorder/{id}')
  Future<chopper.Response<WebApiModulesAgentPurchaseOrderPurchaseOrder>>
      purchaseorderIdPut(
          {@Path('id') required String? id,
          @Body() required WebApiModulesAgentPurchaseOrderPurchaseOrder? body});

  ///
  @Post(path: '/purchaseorder/applybottomlinedaysperweek')
  Future<chopper.Response<bool>> purchaseorderApplybottomlinedaysperweekPost(
      {@Body() required WebApiApplyBottomLineDaysPerWeekRequest? body});

  ///
  @Post(path: '/purchaseorder/applybottomlinediscountpercent')
  Future<chopper.Response<bool>>
      purchaseorderApplybottomlinediscountpercentPost(
          {@Body() required WebApiApplyBottomLineDiscountPercentRequest? body});

  ///
  @Post(path: '/purchaseorder/applybottomlinetotal')
  Future<chopper.Response<bool>> purchaseorderApplybottomlinetotalPost(
      {@Body() required WebApiApplyBottomLineTotalRequest? body});

  ///
  ///@param id
  @Post(path: '/purchaseorder/void/{id}', optionalBody: true)
  Future<chopper.Response<WebApiModulesAgentPurchaseOrderPurchaseOrder>>
      purchaseorderVoidIdPost({@Path('id') required String? id});

  ///
  ///@param id
  @Post(path: '/purchaseorder/toggleclose/{id}', optionalBody: true)
  Future<chopper.Response<WebApiModulesAgentPurchaseOrderPurchaseOrder>>
      purchaseorderTogglecloseIdPost({@Path('id') required String? id});

  ///
  ///@param PurchaseOrderId
  @Get(path: '/purchaseorder/nextvendorinvoicedefaultdates/{purchaseorderid}')
  Future<
          chopper.Response<
              WebApiModulesAgentPurchaseOrderNextVendorInvoiceDefaultDatesResponse>>
      purchaseorderNextvendorinvoicedefaultdatesPurchaseorderidGet(
          {@Path('PurchaseOrderId') required String? purchaseOrderId});

  ///
  @Post(path: '/purchaseorder/copy')
  Future<
          chopper.Response<
              WebApiModulesAgentPurchaseOrderCopyPurchaseOrderResponse>>
      purchaseorderCopyPost(
          {@Body()
              required WebApiModulesAgentPurchaseOrderCopyPurchaseOrderRequest?
                  body});

  ///
  @Post(path: '/purchaseorder/confirmdropship')
  Future<
          chopper
              .Response<WebApiModulesAgentPurchaseOrderConfirmDropShipResponse>>
      purchaseorderConfirmdropshipPost(
          {@Body()
              required WebApiModulesAgentPurchaseOrderConfirmDropShipRequest?
                  body});

  ///
  @Post(path: '/purchaseorder/confirmvendorretrieve')
  Future<
          chopper.Response<
              WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveResponse>>
      purchaseorderConfirmvendorretrievePost(
          {@Body()
              required WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveRequest?
                  body});

  ///
  @Post(path: '/purchaseorder/validatevendor/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      purchaseorderValidatevendorBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/purchaseorder/validatedepartment/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      purchaseorderValidatedepartmentBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/purchaseorder/validaterate/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      purchaseorderValidaterateBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/purchaseorder/validatepotype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      purchaseorderValidatepotypeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/purchaseorder/validateagent/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      purchaseorderValidateagentBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/purchaseorder/validateprojectmanager/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      purchaseorderValidateprojectmanagerBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/purchaseorder/validatebillingcycle/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      purchaseorderValidatebillingcycleBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/purchaseorder/validatecurrency/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      purchaseorderValidatecurrencyBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/purchaseorder/validatetaxoption/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      purchaseorderValidatetaxoptionBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param id
  @Get(path: '/purchaseorder/officelocation/{id}')
  Future<
          chopper.Response<
              WebApiModulesSettingsOfficeLocationSettingsOfficeLocationOfficeLocation>>
      purchaseorderOfficelocationIdGet({@Path('id') required String? id});

  ///
  @Post(path: '/purchaseorder/validatereceivedeliverycarrier/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      purchaseorderValidatereceivedeliverycarrierBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/purchaseorder/validatereceivedeliveryshipvia/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      purchaseorderValidatereceivedeliveryshipviaBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/purchaseorder/validatereturndeliverycarrier/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      purchaseorderValidatereturndeliverycarrierBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/purchaseorder/validatereturndeliveryshipvia/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      purchaseorderValidatereturndeliveryshipviaBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/purchaseorder/emptyobject')
  Future<chopper.Response> purchaseorderEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/purchaseorder/emptybrowseobject')
  Future<chopper.Response> purchaseorderEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/purchaseorder/keyfieldnames')
  Future<chopper.Response> purchaseorderKeyfieldnamesGet();

  ///
  @Post(path: '/purchaseorderitemvendorinvoicestatus/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      purchaseorderitemvendorinvoicestatusBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/purchaseorderitemvendorinvoicestatus/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      purchaseorderitemvendorinvoicestatusExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/purchaseorderitemvendorinvoicestatus/emptyobject')
  Future<chopper.Response> purchaseorderitemvendorinvoicestatusEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/purchaseorderitemvendorinvoicestatus/emptybrowseobject')
  Future<chopper.Response>
      purchaseorderitemvendorinvoicestatusEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/purchaseorderitemvendorinvoicestatus/keyfieldnames')
  Future<chopper.Response>
      purchaseorderitemvendorinvoicestatusKeyfieldnamesGet();

  ///
  @Post(path: '/purchaseorderreceivebarcode/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      purchaseorderreceivebarcodeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/purchaseorderreceivebarcode/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      purchaseorderreceivebarcodeExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/purchaseorderreceivebarcode')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCodeLogic>>
      purchaseorderreceivebarcodeGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/purchaseorderreceivebarcode')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCode>>
      purchaseorderreceivebarcodePost(
          {@Body()
              required WebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCode?
                  body});

  ///
  ///@param id
  @Get(path: '/purchaseorderreceivebarcode/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCode>>
      purchaseorderreceivebarcodeIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/purchaseorderreceivebarcode/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCode>>
      purchaseorderreceivebarcodeIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCode?
                  body});

  ///
  ///@param id
  @Delete(path: '/purchaseorderreceivebarcode/{id}')
  Future<chopper.Response<bool>> purchaseorderreceivebarcodeIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/purchaseorderreceivebarcode/validateinspectionvendor/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      purchaseorderreceivebarcodeValidateinspectionvendorBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/purchaseorderreceivebarcode/emptyobject')
  Future<chopper.Response> purchaseorderreceivebarcodeEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/purchaseorderreceivebarcode/emptybrowseobject')
  Future<chopper.Response> purchaseorderreceivebarcodeEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/purchaseorderreceivebarcode/keyfieldnames')
  Future<chopper.Response> purchaseorderreceivebarcodeKeyfieldnamesGet();

  ///
  @Post(path: '/purchaseorderreceiveitem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      purchaseorderreceiveitemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/purchaseorderreceiveitem/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      purchaseorderreceiveitemExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/purchaseorderreceiveitem/emptyobject')
  Future<chopper.Response> purchaseorderreceiveitemEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/purchaseorderreceiveitem/emptybrowseobject')
  Future<chopper.Response> purchaseorderreceiveitemEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/purchaseorderreceiveitem/keyfieldnames')
  Future<chopper.Response> purchaseorderreceiveitemKeyfieldnamesGet();

  ///
  @Post(path: '/purchaseorderreturnbarcode/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      purchaseorderreturnbarcodeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/purchaseorderreturnbarcode/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      purchaseorderreturnbarcodeExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/purchaseorderreturnbarcode')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCodeLogic>>
      purchaseorderreturnbarcodeGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  ///@param id
  @Get(path: '/purchaseorderreturnbarcode/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCode>>
      purchaseorderreturnbarcodeIdGet({@Path('id') required String? id});

  ///Get an empty object
  @Get(path: '/purchaseorderreturnbarcode/emptyobject')
  Future<chopper.Response> purchaseorderreturnbarcodeEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/purchaseorderreturnbarcode/emptybrowseobject')
  Future<chopper.Response> purchaseorderreturnbarcodeEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/purchaseorderreturnbarcode/keyfieldnames')
  Future<chopper.Response> purchaseorderreturnbarcodeKeyfieldnamesGet();

  ///
  @Post(path: '/purchaseorderreturnitem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      purchaseorderreturnitemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/purchaseorderreturnitem/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      purchaseorderreturnitemExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/purchaseorderreturnitem/emptyobject')
  Future<chopper.Response> purchaseorderreturnitemEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/purchaseorderreturnitem/emptybrowseobject')
  Future<chopper.Response> purchaseorderreturnitemEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/purchaseorderreturnitem/keyfieldnames')
  Future<chopper.Response> purchaseorderreturnitemKeyfieldnamesGet();

  ///
  @Post(path: '/purchaseorderstatus/validatewarehouse/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      purchaseorderstatusValidatewarehouseBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/purchaseorderstatus/validatepurchaseorder/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      purchaseorderstatusValidatepurchaseorderBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/purchaseorderstatus/validateinventorytype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      purchaseorderstatusValidateinventorytypeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/purchaseorderstatus/validatecategory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      purchaseorderstatusValidatecategoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/purchaseorderstatus/validatesubcategory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      purchaseorderstatusValidatesubcategoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/purchaseorderstatus/validateicode/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      purchaseorderstatusValidateicodeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/purchaseorderstatus/emptyobject')
  Future<chopper.Response> purchaseorderstatusEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/purchaseorderstatus/emptybrowseobject')
  Future<chopper.Response> purchaseorderstatusEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/purchaseorderstatus/keyfieldnames')
  Future<chopper.Response> purchaseorderstatusKeyfieldnamesGet();

  ///
  @Post(path: '/purchasevendor/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      purchasevendorBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/purchasevendor/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      purchasevendorExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/purchasevendor/emptyobject')
  Future<chopper.Response> purchasevendorEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/purchasevendor/emptybrowseobject')
  Future<chopper.Response> purchasevendorEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/purchasevendor/keyfieldnames')
  Future<chopper.Response> purchasevendorKeyfieldnamesGet();

  ///
  @Post(path: '/purchasevendorinvoiceitem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      purchasevendorinvoiceitemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/purchasevendorinvoiceitem/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      purchasevendorinvoiceitemExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/purchasevendorinvoiceitem')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItemLogic>>
      purchasevendorinvoiceitemGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  ///@param id
  @Get(path: '/purchasevendorinvoiceitem/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItem>>
      purchasevendorinvoiceitemIdGet({@Path('id') required String? id});

  ///Get an empty object
  @Get(path: '/purchasevendorinvoiceitem/emptyobject')
  Future<chopper.Response> purchasevendorinvoiceitemEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/purchasevendorinvoiceitem/emptybrowseobject')
  Future<chopper.Response> purchasevendorinvoiceitemEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/purchasevendorinvoiceitem/keyfieldnames')
  Future<chopper.Response> purchasevendorinvoiceitemKeyfieldnamesGet();

  ///
  @Post(path: '/quikreceipt/quikreceiptstart')
  Future<
          chopper.Response<
              WebApiModulesWarehouseQuikReceiptQuikReceiptSessionResponse>>
      quikreceiptQuikreceiptstartPost(
          {@Body()
              required WebApiModulesWarehouseQuikReceiptQuikReceiptSessionRequest?
                  body});

  ///
  @Post(path: '/quikreceipt/quikreceiptitem')
  Future<
          chopper.Response<
              WebApiModulesWarehouseQuikReceiptQuikReceiptItemResponse>>
      quikreceiptQuikreceiptitemPost(
          {@Body()
              required WebApiModulesWarehouseQuikReceiptQuikReceiptItemRequest?
                  body});

  ///
  @Post(path: '/quikreceipt/quikreceiptsuspendedsessions')
  Future<
          chopper.Response<
              WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionsResponse>>
      quikreceiptQuikreceiptsuspendedsessionsPost(
          {@Body()
              required WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRequest?
                  body});

  ///
  @Post(path: '/quikreceipt/quikreceiptitemsave')
  Future<
          chopper.Response<
              WebApiModulesWarehouseQuikReceiptQuikReceiptSaveResponse>>
      quikreceiptQuikreceiptitemsavePost(
          {@Body()
              required WebApiModulesWarehouseQuikReceiptQuikReceiptSaveRequest?
                  body});

  ///
  @Post(path: '/quikreceipt/quikreceiptsignaturesave')
  Future<
          chopper.Response<
              WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveResponse>>
      quikreceiptQuikreceiptsignaturesavePost(
          {@Body()
              required WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveRequest?
                  body});

  ///
  @Post(path: '/quikreceipt/quikreceiptgrid/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quikreceiptQuikreceiptgridBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quikreceipt/quikreceiptgrid/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      quikreceiptQuikreceiptgridExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/quikreceipt/quikreceiptgrid')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesWarehouseQuikReceiptQuikReceiptGridLogic>>
      quikreceiptQuikreceiptgridGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Get(path: '/quikreceipt/quikreceipt/quikreceiptgrid/emptyobject')
  Future<chopper.Response>
      quikreceiptQuikreceiptQuikreceiptgridEmptyobjectGet();

  ///
  @Post(path: '/quikreceipt/quikreceiptitemsgrid/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quikreceiptQuikreceiptitemsgridBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quikreceipt/quikreceiptitemsgrid/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      quikreceiptQuikreceiptitemsgridExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Get(path: '/quikreceipt/quikreceipt/quikreceiptitemsgrid/emptyobject')
  Future<chopper.Response>
      quikreceiptQuikreceiptQuikreceiptitemsgridEmptyobjectGet();

  ///Get an empty object
  @Get(path: '/quikreceipt/emptyobject')
  Future<chopper.Response> quikreceiptEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/quikreceipt/emptybrowseobject')
  Future<chopper.Response> quikreceiptEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/quikreceipt/keyfieldnames')
  Future<chopper.Response> quikreceiptKeyfieldnamesGet();

  ///Get an empty object
  @Get(path: '/quiksearch/emptyobject')
  Future<chopper.Response> quiksearchEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/quiksearch/emptybrowseobject')
  Future<chopper.Response> quiksearchEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/quiksearch/keyfieldnames')
  Future<chopper.Response> quiksearchKeyfieldnamesGet();

  ///Get documents.
  ///@param quoteid Unique identifier
  @Post(path: '/quote/{quoteid}/document/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteQuoteidDocumentBrowsePost(
          {@Path('quoteid') required String? quoteid,
          @Body() required FwStandardModelsBrowseRequest? body});

  ///Export documents to Excel.
  ///@param quoteid Unique identifier
  @Post(path: '/quote/{quoteid}/document/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      quoteQuoteidDocumentExportexcelxlsxPost(
          {@Path('quoteid') required String? quoteid,
          @Body() required FwStandardModelsBrowseRequest? body});

  ///Get documents.
  ///@param quoteid Unique identifier
  ///@param DocumentTypeId Unique Identifier [Filter|Sort]
  ///@param Description Document description [Filter|Sort]
  ///@param DateStamp Document last modified data [Filter|Sort]
  ///@param PageNo The page number in the result set starting from 1.  PageNo is required when the PageSize is specified.
  ///@param PageSize Limit result set to the specified amount.
  ///@param Sort A sort expression to use of the form: Field1:asc,Field2:desc
  @Get(path: '/quote/{quoteid}/documents')
  Future<
          chopper.Response<
              FwStandardModelsGetResponseFwStandardGridsAppDocumentAppDocumentGetManyResponse>>
      quoteQuoteidDocumentsGet(
          {@Path('quoteid') required String? quoteid,
          @Query('DocumentTypeId') String? documentTypeId,
          @Query('Description') String? description,
          @Query('DateStamp') String? dateStamp,
          @Query('PageNo') int? pageNo,
          @Query('PageSize') int? pageSize,
          @Query('Sort') String? sort});

  ///Get a document.
  ///@param quoteid Unique identifier
  ///@param documentid Unique identifier
  @Get(path: '/quote/{quoteid}/document/{documentid}')
  Future<chopper.Response<WebApiModulesAgentQuoteQuoteDocument>>
      quoteQuoteidDocumentDocumentidGet(
          {@Path('quoteid') required String? quoteid,
          @Path('documentid') required String? documentid});

  ///Update a document.
  ///@param quoteid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/quote/{quoteid}/document/{documentid}')
  Future<chopper.Response<WebApiModulesAgentQuoteQuoteDocument>>
      quoteQuoteidDocumentDocumentidPut(
          {@Path('quoteid')
              required String? quoteid,
          @Path('documentid')
              required String? documentid,
          @Body()
              required WebApiModulesAgentQuoteQuoteDocumentPutRequest? body});

  ///Delete a document.
  ///@param quoteid Unique identifier
  ///@param documentid Unique identifier
  @Delete(path: '/quote/{quoteid}/document/{documentid}')
  Future<chopper.Response<bool>> quoteQuoteidDocumentDocumentidDelete(
      {@Path('quoteid') required String? quoteid,
      @Path('documentid') required String? documentid});

  ///Create a new document.
  ///@param quoteid Unique identifier
  @Post(path: '/quote/{quoteid}/document')
  Future<chopper.Response<WebApiModulesAgentQuoteQuoteDocument>>
      quoteQuoteidDocumentPost(
          {@Path('quoteid')
              required String? quoteid,
          @Body()
              required WebApiModulesAgentQuoteQuoteDocumentPostRequest? body});

  ///Get thumbnails for any images attached to the document.
  ///@param quoteid Unique identifier
  ///@param documentid Unique identifier
  ///@param pageno The page number of the result set, starting from page 1.
  ///@param pagesize The number of records per page of the result set.
  @Get(path: '/quote/{quoteid}/document/{documentid}/thumbnails')
  Future<
          chopper.Response<
              FwStandardGridsAppDocumentGetDocumentThumbnailsResponse>>
      quoteQuoteidDocumentDocumentidThumbnailsGet(
          {@Path('quoteid') required String? quoteid,
          @Path('documentid') required String? documentid,
          @Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize});

  ///Get a fullsize image.
  ///@param quoteid Unique identifier
  ///@param documentid Unique identifier
  ///@param imageid Unique identifier
  @Get(path: '/quote/{quoteid}/document/{documentid}/image/{imageid}')
  Future<chopper.Response<FwStandardGridsAppDocumentGetDocumentImageResponse>>
      quoteQuoteidDocumentDocumentidImageImageidGet(
          {@Path('quoteid') required String? quoteid,
          @Path('documentid') required String? documentid,
          @Path('imageid') required String? imageid});

  ///Delete an attached image.
  ///@param quoteid Unique identifier
  ///@param documentid Unique identifier
  ///@param imageid Unique identifier
  @Delete(path: '/quote/{quoteid}/document/{documentid}/image/{imageid}')
  Future<chopper.Response<bool>>
      quoteQuoteidDocumentDocumentidImageImageidDelete(
          {@Path('quoteid') required String? quoteid,
          @Path('documentid') required String? documentid,
          @Path('imageid') required String? imageid});

  ///Attach an image from a dataurl.
  ///@param quoteid Unique identifier
  ///@param documentid Unique identifier
  @Post(path: '/quote/{quoteid}/document/{documentid}/image')
  Future<chopper.Response<bool>> quoteQuoteidDocumentDocumentidImagePost(
      {@Path('quoteid')
          required String? quoteid,
      @Path('documentid')
          required String? documentid,
      @Body()
          required FwStandardGridsAppDocumentPostDocumentImageRequest? body});

  ///Attach an image from a form submission.
  ///@param quoteid Unique identifier
  ///@param documentid Unique identifier
  @Post(path: '/quote/{quoteid}/document/{documentid}/imageformupload')
  Future<chopper.Response<bool>>
      quoteQuoteidDocumentDocumentidImageformuploadPost(
          {@Path('quoteid') required String? quoteid,
          @Path('documentid') required String? documentid});

  ///Get the attached file.
  ///@param quoteid Unique identifier
  ///@param documentid Unique identifier
  @Get(path: '/quote/{quoteid}/document/{documentid}/file')
  Future<chopper.Response> quoteQuoteidDocumentDocumentidFileGet(
      {@Path('quoteid') required String? quoteid,
      @Path('documentid') required String? documentid});

  ///Update the attached file from a dataurl.
  ///@param quoteid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/quote/{quoteid}/document/{documentid}/file')
  Future<chopper.Response<bool>> quoteQuoteidDocumentDocumentidFilePut(
      {@Path('quoteid') required String? quoteid,
      @Path('documentid') required String? documentid,
      @Body() required FwStandardGridsAppDocumentPutDocumentFileRequest? body});

  ///Delete attached file.
  ///@param quoteid Unique identifier
  ///@param documentid Unique identifier
  @Delete(path: '/quote/{quoteid}/document/{documentid}/file')
  Future<chopper.Response<bool>> quoteQuoteidDocumentDocumentidFileDelete(
      {@Path('quoteid') required String? quoteid,
      @Path('documentid') required String? documentid});

  ///Update attached file from a form submission.
  ///@param quoteid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/quote/{quoteid}/document/{documentid}/fileformupload')
  Future<chopper.Response<bool>>
      quoteQuoteidDocumentDocumentidFileformuploadPut(
          {@Path('quoteid') required String? quoteid,
          @Path('documentid') required String? documentid});

  ///
  ///@param quoteid
  @Get(path: '/quote/{quoteid}/document/emptyobject')
  Future<chopper.Response> quoteQuoteidDocumentEmptyobjectGet(
      {@Path('quoteid') required String? quoteid});

  ///
  @Post(path: '/quote/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>> quoteBrowsePost(
      {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Get(path: '/quote/legend')
  Future<chopper.Response<Object>> quoteLegendGet();

  ///
  @Post(path: '/quote/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      quoteExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param id
  @Post(path: '/quote/{id}/copytoquote')
  Future<chopper.Response<WebApiModulesAgentOrderCopyQuoteOrderResponse>>
      quoteIdCopytoquotePost(
          {@Path('id') required String? id,
          @Body() required WebApiModulesAgentOrderCopyQuoteOrderRequest? body});

  ///
  ///@param id
  @Post(path: '/quote/{id}/copytoorder')
  Future<chopper.Response<WebApiModulesAgentOrderCopyQuoteOrderResponse>>
      quoteIdCopytoorderPost(
          {@Path('id') required String? id,
          @Body() required WebApiModulesAgentOrderCopyQuoteOrderRequest? body});

  ///
  @Post(path: '/quote/createorder')
  Future<chopper.Response<WebApiModulesAgentOrderQuoteToOrderResponse>>
      quoteCreateorderPost(
          {@Body() required WebApiModulesAgentOrderQuoteToOrderRequest? body});

  ///
  @Post(path: '/quote/getcustomrates')
  Future<chopper.Response<WebApiModulesAgentOrderGetCustomRatesResponse>>
      quoteGetcustomratesPost(
          {@Body()
              required WebApiModulesAgentOrderGetCustomRatesRequest? body});

  ///
  ///@param id
  @Post(path: '/quote/reserve/{id}', optionalBody: true)
  Future<chopper.Response<WebApiModulesAgentOrderReserveUnreserveQuoteResponse>>
      quoteReserveIdPost({@Path('id') required String? id});

  ///
  ///@param id
  @Post(path: '/quote/createnewversion/{id}', optionalBody: true)
  Future<chopper.Response<WebApiModulesAgentOrderQuoteNewVersionResponse>>
      quoteCreatenewversionIdPost({@Path('id') required String? id});

  ///
  ///@param id
  @Post(path: '/quote/makequoteactive/{id}', optionalBody: true)
  Future<chopper.Response<WebApiLogicTSpStatusResponse>>
      quoteMakequoteactiveIdPost({@Path('id') required String? id});

  ///
  ///@param id
  @Post(path: '/quote/cancel/{id}', optionalBody: true)
  Future<chopper.Response<WebApiModulesAgentOrderCancelUncancelQuoteResponse>>
      quoteCancelIdPost({@Path('id') required String? id});

  ///
  ///@param id
  @Post(path: '/quote/uncancel/{id}', optionalBody: true)
  Future<chopper.Response<WebApiModulesAgentOrderCancelUncancelQuoteResponse>>
      quoteUncancelIdPost({@Path('id') required String? id});

  ///
  @Post(path: '/quote/applybottomlinedaysperweek')
  Future<chopper.Response<bool>> quoteApplybottomlinedaysperweekPost(
      {@Body() required WebApiApplyBottomLineDaysPerWeekRequest? body});

  ///
  @Post(path: '/quote/applybottomlinediscountpercent')
  Future<chopper.Response<bool>> quoteApplybottomlinediscountpercentPost(
      {@Body() required WebApiApplyBottomLineDiscountPercentRequest? body});

  ///
  @Post(path: '/quote/applybottomlinetotal')
  Future<chopper.Response<bool>> quoteApplybottomlinetotalPost(
      {@Body() required WebApiApplyBottomLineTotalRequest? body});

  ///
  ///@param id
  @Post(path: '/quote/changeofficelocation/{id}')
  Future<
          chopper.Response<
              WebApiModulesAgentOrderChangeOrderOfficeLocationResponse>>
      quoteChangeofficelocationIdPost(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesAgentOrderChangeOrderOfficeLocationRequest?
                  body});

  ///
  ///@param id
  @Get(path: '/quote/{id}/messages')
  Future<chopper.Response<WebApiModulesAgentOrderOrderMessagesResponse>>
      quoteIdMessagesGet({@Path('id') required String? id});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/quote')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAgentQuoteQuoteLogic>>
      quoteGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/quote')
  Future<chopper.Response<WebApiModulesAgentQuoteQuote>> quotePost(
      {@Body() required WebApiModulesAgentQuoteQuote? body});

  ///
  ///@param id
  @Get(path: '/quote/{id}')
  Future<chopper.Response<WebApiModulesAgentQuoteQuote>> quoteIdGet(
      {@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/quote/{id}')
  Future<chopper.Response<WebApiModulesAgentQuoteQuote>> quoteIdPut(
      {@Path('id') required String? id,
      @Body() required WebApiModulesAgentQuoteQuote? body});

  ///
  ///@param id
  @Post(path: '/quote/submit/{id}', optionalBody: true)
  Future<chopper.Response<WebApiModulesAgentQuoteQuote>> quoteSubmitIdPost(
      {@Path('id') required String? id});

  ///
  ///@param id
  @Post(path: '/quote/activatequoterequest/{id}', optionalBody: true)
  Future<chopper.Response<WebApiModulesAgentQuoteQuote>>
      quoteActivatequoterequestIdPost({@Path('id') required String? id});

  ///
  @Post(path: '/quote/validatedepartment/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidatedepartmentBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quote/validatedeal/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidatedealBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quote/validateratetype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidateratetypeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quote/validateordertype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidateordertypeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quote/validateagent/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidateagentBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quote/validateprojectmanager/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidateprojectmanagerBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quote/validateoutsidesalesrepresentative/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidateoutsidesalesrepresentativeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quote/validatemarkettype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidatemarkettypeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quote/validatemarketsegment/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidatemarketsegmentBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quote/validatemarketsegmentjob/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidatemarketsegmentjobBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quote/validateordergroup/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidateordergroupBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quote/validatecoverletter/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidatecoverletterBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quote/validatetermsconditions/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidatetermsconditionsBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quote/validatebillingcycle/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidatebillingcycleBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quote/validatepaymentterms/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidatepaymenttermsBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quote/validatepaymenttype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidatepaymenttypeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quote/validatecurrency/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidatecurrencyBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quote/validatetaxoption/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidatetaxoptionBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quote/validatediscountreason/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidatediscountreasonBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quote/validateissuedtocountry/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidateissuedtocountryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quote/validateoutdeliverycarrier/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidateoutdeliverycarrierBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quote/validateoutdeliveryshipvia/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidateoutdeliveryshipviaBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quote/validateindeliverycarrier/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidateindeliverycarrierBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quote/validateindeliveryshipvia/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidateindeliveryshipviaBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quote/validateoutdeliverytocountry/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidateoutdeliverytocountryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quote/validateindeliverytocountry/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidateindeliverytocountryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quote/validateofficelocation/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidateofficelocationBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quote/validatewarehouse/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidatewarehouseBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quote/validatebilltocountry/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidatebilltocountryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param departmentid
  ///@param locationid
  @Get(path: '/quote/department/{departmentid}/location/{locationid}')
  Future<
          chopper.Response<
              WebApiModulesSettingsDepartmentLocationDepartmentLocation>>
      quoteDepartmentDepartmentidLocationLocationidGet(
          {@Path('departmentid') required String? departmentid,
          @Path('locationid') required String? locationid});

  ///
  ///@param ordertypeid
  @Get(path: '/quote/ordertype/{ordertypeid}')
  Future<chopper.Response<WebApiModulesSettingsOrderSettingsOrderTypeOrderType>>
      quoteOrdertypeOrdertypeidGet(
          {@Path('ordertypeid') required String? ordertypeid});

  ///
  @Post(path: '/quote/ordertypelocation/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteOrdertypelocationBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/quote/validateorderlocation/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      quoteValidateorderlocationBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/quote/emptyobject')
  Future<chopper.Response> quoteEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/quote/emptybrowseobject')
  Future<chopper.Response> quoteEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/quote/keyfieldnames')
  Future<chopper.Response> quoteKeyfieldnamesGet();

  ///
  @Post(path: '/rateitem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      rateitemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/rateitem/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      rateitemExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/rateitem/emptyobject')
  Future<chopper.Response> rateitemEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/rateitem/emptybrowseobject')
  Future<chopper.Response> rateitemEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/rateitem/keyfieldnames')
  Future<chopper.Response> rateitemKeyfieldnamesGet();

  ///
  @Post(path: '/receipt/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      receiptBrowsePost({@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Get(path: '/receipt/legend')
  Future<chopper.Response<Object>> receiptLegendGet();

  ///
  @Post(path: '/receipt/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      receiptExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/receipt')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesBillingReceiptReceiptLogic>>
      receiptGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/receipt')
  Future<chopper.Response<WebApiModulesBillingReceiptReceipt>> receiptPost(
      {@Body() required WebApiModulesBillingReceiptReceipt? body});

  ///
  ///@param id
  @Get(path: '/receipt/{id}')
  Future<chopper.Response<WebApiModulesBillingReceiptReceipt>> receiptIdGet(
      {@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/receipt/{id}')
  Future<chopper.Response<WebApiModulesBillingReceiptReceipt>> receiptIdPut(
      {@Path('id') required String? id,
      @Body() required WebApiModulesBillingReceiptReceipt? body});

  ///
  ///@param id
  @Delete(path: '/receipt/{id}')
  Future<chopper.Response<bool>> receiptIdDelete(
      {@Path('id') required String? id});

  ///
  ///@param id
  @Delete(path: '/receipt/overridedelete/{id}')
  Future<chopper.Response<bool>> receiptOverridedeleteIdDelete(
      {@Path('id') required String? id});

  ///
  ///@param CustomerId
  ///@param DealId
  ///@param OfficeLocationId
  @Get(path: '/receipt/remainingdepositamounts')
  Future<
          chopper.Response<
              WebApiModulesBillingReceiptRemainingDepositAmountsResponse>>
      receiptRemainingdepositamountsGet(
          {@Query('CustomerId') String? customerId,
          @Query('DealId') String? dealId,
          @Query('OfficeLocationId') String? officeLocationId});

  ///
  @Post(path: '/receipt/validatedealdeposit/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      receiptValidatedealdepositBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/receipt/validatecustomerdeposit/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      receiptValidatecustomerdepositBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/receipt/validateappliedby/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      receiptValidateappliedbyBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/receipt/validatepaymenttype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      receiptValidatepaymenttypeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/receipt/gldistribution/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      receiptGldistributionBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/receipt/adddepletingdeposit')
  Future<chopper.Response<WebApiModulesBillingReceiptReceipt>>
      receiptAdddepletingdepositPost(
          {@Body()
              required WebApiModulesBillingReceiptAddDepletingDepositRequest?
                  body});

  ///
  @Post(path: '/receipt/creditcarddepletingdeposit')
  Future<
          chopper.Response<
              WebApiModulesPluginsProcessCreditCardProcessCreditCardPaymentResponse>>
      receiptCreditcarddepletingdepositPost(
          {@Body()
              required WebApiModulesBillingReceiptCreditCardDepletingDepositRequest?
                  body});

  ///Get an empty object
  @Get(path: '/receipt/emptyobject')
  Future<chopper.Response> receiptEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/receipt/emptybrowseobject')
  Future<chopper.Response> receiptEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/receipt/keyfieldnames')
  Future<chopper.Response> receiptKeyfieldnamesGet();

  ///
  @Post(path: '/receiptcredit/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      receiptcreditBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/receiptcredit/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      receiptcreditExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/receiptcredit/emptyobject')
  Future<chopper.Response> receiptcreditEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/receiptcredit/emptybrowseobject')
  Future<chopper.Response> receiptcreditEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/receiptcredit/keyfieldnames')
  Future<chopper.Response> receiptcreditKeyfieldnamesGet();

  ///
  @Post(path: '/receiptinvoice/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      receiptinvoiceBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/receiptinvoice/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      receiptinvoiceExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/receiptinvoice/emptyobject')
  Future<chopper.Response> receiptinvoiceEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/receiptinvoice/emptybrowseobject')
  Future<chopper.Response> receiptinvoiceEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/receiptinvoice/keyfieldnames')
  Future<chopper.Response> receiptinvoiceKeyfieldnamesGet();

  ///
  ///@param warehouseId
  @Get(path: '/receivefromvendor/suspendedsessionsexist')
  Future<chopper.Response<bool>> receivefromvendorSuspendedsessionsexistGet(
      {@Query('warehouseId') String? warehouseId});

  ///
  @Post(path: '/receivefromvendor/startsession')
  Future<
          chopper
              .Response<WebApiModulesAgentPurchaseOrderReceiveContractResponse>>
      receivefromvendorStartsessionPost(
          {@Body()
              required WebApiModulesAgentPurchaseOrderReceiveContractRequest?
                  body});

  ///
  @Post(path: '/receivefromvendor/receiveitems')
  Future<chopper.Response<WebApiModulesAgentPurchaseOrderReceiveItemResponse>>
      receivefromvendorReceiveitemsPost(
          {@Body()
              required WebApiModulesAgentPurchaseOrderReceiveItemRequest?
                  body});

  ///
  @Post(path: '/receivefromvendor/selectall')
  Future<
          chopper.Response<
              WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemResponse>>
      receivefromvendorSelectallPost(
          {@Body()
              required WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemRequest?
                  body});

  ///
  @Post(path: '/receivefromvendor/selectnone')
  Future<
          chopper.Response<
              WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemResponse>>
      receivefromvendorSelectnonePost(
          {@Body()
              required WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemRequest?
                  body});

  ///
  ///@param id
  @Post(path: '/receivefromvendor/completecontract/{id}')
  Future<chopper.Response<List<WebApiModulesWarehouseContractContract>>>
      receivefromvendorCompletecontractIdPost(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesAgentPurchaseOrderCompleteReceiveContractRequest?
                  body});

  ///
  @Post(path: '/receivefromvendor/cancelcontract')
  Future<chopper.Response<WebApiLogicTSpStatusResponse>>
      receivefromvendorCancelcontractPost(
          {@Body()
              required WebApiModulesWarehouseContractCancelContractRequest?
                  body});

  ///
  @Post(path: '/receivefromvendor/validatepurchaseorder/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      receivefromvendorValidatepurchaseorderBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/receivefromvendor/emptyobject')
  Future<chopper.Response> receivefromvendorEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/receivefromvendor/emptybrowseobject')
  Future<chopper.Response> receivefromvendorEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/receivefromvendor/keyfieldnames')
  Future<chopper.Response> receivefromvendorKeyfieldnamesGet();

  ///
  @Post(path: '/removefromcontainer/validatecontaineritem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      removefromcontainerValidatecontaineritemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/removefromcontainer/validateitem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      removefromcontainerValidateitemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/removefromcontainer/validateinventory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      removefromcontainerValidateinventoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/removefromcontainer/emptyobject')
  Future<chopper.Response> removefromcontainerEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/removefromcontainer/emptybrowseobject')
  Future<chopper.Response> removefromcontainerEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/removefromcontainer/keyfieldnames')
  Future<chopper.Response> removefromcontainerKeyfieldnamesGet();

  ///Get documents.
  ///@param inventoryid Unique identifier
  @Post(path: '/rentalinventory/{inventoryid}/document/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      rentalinventoryInventoryidDocumentBrowsePost(
          {@Path('inventoryid') required String? inventoryid,
          @Body() required FwStandardModelsBrowseRequest? body});

  ///Export documents to Excel.
  ///@param inventoryid Unique identifier
  @Post(path: '/rentalinventory/{inventoryid}/document/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      rentalinventoryInventoryidDocumentExportexcelxlsxPost(
          {@Path('inventoryid') required String? inventoryid,
          @Body() required FwStandardModelsBrowseRequest? body});

  ///Get documents.
  ///@param inventoryid Unique identifier
  ///@param DocumentTypeId Unique Identifier [Filter|Sort]
  ///@param Description Document description [Filter|Sort]
  ///@param DateStamp Document last modified data [Filter|Sort]
  ///@param PageNo The page number in the result set starting from 1.  PageNo is required when the PageSize is specified.
  ///@param PageSize Limit result set to the specified amount.
  ///@param Sort A sort expression to use of the form: Field1:asc,Field2:desc
  @Get(path: '/rentalinventory/{inventoryid}/documents')
  Future<
          chopper.Response<
              FwStandardModelsGetResponseFwStandardGridsAppDocumentAppDocumentGetManyResponse>>
      rentalinventoryInventoryidDocumentsGet(
          {@Path('inventoryid') required String? inventoryid,
          @Query('DocumentTypeId') String? documentTypeId,
          @Query('Description') String? description,
          @Query('DateStamp') String? dateStamp,
          @Query('PageNo') int? pageNo,
          @Query('PageSize') int? pageSize,
          @Query('Sort') String? sort});

  ///Get a document.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  @Get(path: '/rentalinventory/{inventoryid}/document/{documentid}')
  Future<
          chopper.Response<
              WebApiModulesInventoryRentalInventoryRentalInventoryDocument>>
      rentalinventoryInventoryidDocumentDocumentidGet(
          {@Path('inventoryid') required String? inventoryid,
          @Path('documentid') required String? documentid});

  ///Update a document.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/rentalinventory/{inventoryid}/document/{documentid}')
  Future<
          chopper.Response<
              WebApiModulesInventoryRentalInventoryRentalInventoryDocument>>
      rentalinventoryInventoryidDocumentDocumentidPut(
          {@Path('inventoryid')
              required String? inventoryid,
          @Path('documentid')
              required String? documentid,
          @Body()
              required WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPutRequest?
                  body});

  ///Delete a document.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  @Delete(path: '/rentalinventory/{inventoryid}/document/{documentid}')
  Future<chopper.Response<bool>>
      rentalinventoryInventoryidDocumentDocumentidDelete(
          {@Path('inventoryid') required String? inventoryid,
          @Path('documentid') required String? documentid});

  ///Create a new document.
  ///@param inventoryid Unique identifier
  @Post(path: '/rentalinventory/{inventoryid}/document')
  Future<
          chopper.Response<
              WebApiModulesInventoryRentalInventoryRentalInventoryDocument>>
      rentalinventoryInventoryidDocumentPost(
          {@Path('inventoryid')
              required String? inventoryid,
          @Body()
              required WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPostRequest?
                  body});

  ///Get thumbnails for any images attached to the document.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  ///@param pageno The page number of the result set, starting from page 1.
  ///@param pagesize The number of records per page of the result set.
  @Get(path: '/rentalinventory/{inventoryid}/document/{documentid}/thumbnails')
  Future<
          chopper.Response<
              FwStandardGridsAppDocumentGetDocumentThumbnailsResponse>>
      rentalinventoryInventoryidDocumentDocumentidThumbnailsGet(
          {@Path('inventoryid') required String? inventoryid,
          @Path('documentid') required String? documentid,
          @Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize});

  ///Get a fullsize image.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  ///@param imageid Unique identifier
  @Get(
      path:
          '/rentalinventory/{inventoryid}/document/{documentid}/image/{imageid}')
  Future<chopper.Response<FwStandardGridsAppDocumentGetDocumentImageResponse>>
      rentalinventoryInventoryidDocumentDocumentidImageImageidGet(
          {@Path('inventoryid') required String? inventoryid,
          @Path('documentid') required String? documentid,
          @Path('imageid') required String? imageid});

  ///Delete an attached image.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  ///@param imageid Unique identifier
  @Delete(
      path:
          '/rentalinventory/{inventoryid}/document/{documentid}/image/{imageid}')
  Future<chopper.Response<bool>>
      rentalinventoryInventoryidDocumentDocumentidImageImageidDelete(
          {@Path('inventoryid') required String? inventoryid,
          @Path('documentid') required String? documentid,
          @Path('imageid') required String? imageid});

  ///Attach an image from a dataurl.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  @Post(path: '/rentalinventory/{inventoryid}/document/{documentid}/image')
  Future<chopper.Response<bool>>
      rentalinventoryInventoryidDocumentDocumentidImagePost(
          {@Path('inventoryid')
              required String? inventoryid,
          @Path('documentid')
              required String? documentid,
          @Body()
              required FwStandardGridsAppDocumentPostDocumentImageRequest?
                  body});

  ///Attach an image from a form submission.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  @Post(
      path:
          '/rentalinventory/{inventoryid}/document/{documentid}/imageformupload')
  Future<chopper.Response<bool>>
      rentalinventoryInventoryidDocumentDocumentidImageformuploadPost(
          {@Path('inventoryid') required String? inventoryid,
          @Path('documentid') required String? documentid});

  ///Get the attached file.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  @Get(path: '/rentalinventory/{inventoryid}/document/{documentid}/file')
  Future<chopper.Response> rentalinventoryInventoryidDocumentDocumentidFileGet(
      {@Path('inventoryid') required String? inventoryid,
      @Path('documentid') required String? documentid});

  ///Update the attached file from a dataurl.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/rentalinventory/{inventoryid}/document/{documentid}/file')
  Future<chopper.Response<bool>>
      rentalinventoryInventoryidDocumentDocumentidFilePut(
          {@Path('inventoryid')
              required String? inventoryid,
          @Path('documentid')
              required String? documentid,
          @Body()
              required FwStandardGridsAppDocumentPutDocumentFileRequest? body});

  ///Delete attached file.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  @Delete(path: '/rentalinventory/{inventoryid}/document/{documentid}/file')
  Future<chopper.Response<bool>>
      rentalinventoryInventoryidDocumentDocumentidFileDelete(
          {@Path('inventoryid') required String? inventoryid,
          @Path('documentid') required String? documentid});

  ///Update attached file from a form submission.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  @Put(
      path:
          '/rentalinventory/{inventoryid}/document/{documentid}/fileformupload')
  Future<chopper.Response<bool>>
      rentalinventoryInventoryidDocumentDocumentidFileformuploadPut(
          {@Path('inventoryid') required String? inventoryid,
          @Path('documentid') required String? documentid});

  ///
  ///@param rentalinventoryid
  @Get(path: '/rentalinventory/{rentalinventoryid}/document/emptyobject')
  Future<chopper.Response>
      rentalinventoryRentalinventoryidDocumentEmptyobjectGet(
          {@Path('rentalinventoryid') required String? rentalinventoryid});

  ///
  @Post(path: '/rentalinventory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      rentalinventoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Get(path: '/rentalinventory/legend')
  Future<chopper.Response<Object>> rentalinventoryLegendGet();

  ///
  @Get(path: '/rentalinventory/availabilitylegend')
  Future<chopper.Response<Object>> rentalinventoryAvailabilitylegendGet();

  ///
  @Post(path: '/rentalinventory/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      rentalinventoryExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/rentalinventory')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesInventoryRentalInventoryRentalInventoryLogic>>
      rentalinventoryGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/rentalinventory')
  Future<chopper.Response<WebApiModulesInventoryRentalInventoryRentalInventory>>
      rentalinventoryPost(
          {@Body()
              required WebApiModulesInventoryRentalInventoryRentalInventory?
                  body});

  ///
  ///@param id
  @Get(path: '/rentalinventory/{id}')
  Future<chopper.Response<WebApiModulesInventoryRentalInventoryRentalInventory>>
      rentalinventoryIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/rentalinventory/{id}')
  Future<chopper.Response<WebApiModulesInventoryRentalInventoryRentalInventory>>
      rentalinventoryIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesInventoryRentalInventoryRentalInventory?
                  body});

  ///
  ///@param id
  @Delete(path: '/rentalinventory/{id}')
  Future<chopper.Response<bool>> rentalinventoryIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/rentalinventory/qcrequiredallwarehouses')
  Future<
          chopper.Response<
              WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesResponse>>
      rentalinventoryQcrequiredallwarehousesPost(
          {@Body()
              required WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesRequest?
                  body});

  ///
  @Post(path: '/rentalinventory/warehousespecificpackage')
  Future<
          chopper.Response<
              WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageResponse>>
      rentalinventoryWarehousespecificpackagePost(
          {@Body()
              required WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageRequest?
                  body});

  ///Get Rental Inventory Details
  ///@param inventoryid Unique Id
  @Get(path: '/rentalinventory/{inventoryid}/rentalinventorydetails')
  Future<
          chopper.Response<
              WebApiModulesInventoryRentalInventoryRentalInventoryDetailResponse>>
      rentalinventoryInventoryidRentalinventorydetailsGet(
          {@Path('inventoryid') required String? inventoryid});

  ///
  @Post(path: '/rentalinventory/validateinventorytype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      rentalinventoryValidateinventorytypeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/rentalinventory/validatecategory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      rentalinventoryValidatecategoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/rentalinventory/validatesubcategory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      rentalinventoryValidatesubcategoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/rentalinventory/validateunit/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      rentalinventoryValidateunitBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/rentalinventory/validaterank/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      rentalinventoryValidaterankBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/rentalinventory/validatemanufacturer/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      rentalinventoryValidatemanufacturerBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/rentalinventory/validateassetaccount/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      rentalinventoryValidateassetaccountBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/rentalinventory/validateincomeaccount/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      rentalinventoryValidateincomeaccountBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/rentalinventory/validatesubincomeaccount/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      rentalinventoryValidatesubincomeaccountBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/rentalinventory/validateconsignmentincomeaccount/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      rentalinventoryValidateconsignmentincomeaccountBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/rentalinventory/validateequipmentsaleincomeaccount/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      rentalinventoryValidateequipmentsaleincomeaccountBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/rentalinventory/validateldincomeaccount/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      rentalinventoryValidateldincomeaccountBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/rentalinventory/validatecostofgoodssoldexpenseaccount/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      rentalinventoryValidatecostofgoodssoldexpenseaccountBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/rentalinventory/validatecostofgoodsrentedexpenseaccount/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      rentalinventoryValidatecostofgoodsrentedexpenseaccountBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/rentalinventory/validateprofitandlosscategory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      rentalinventoryValidateprofitandlosscategoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/rentalinventory/validatecountryoforigin/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      rentalinventoryValidatecountryoforiginBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/rentalinventory/validatewarehouse/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      rentalinventoryValidatewarehouseBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/rentalinventory/copy')
  Future<chopper.Response<WebApiModulesInventoryRentalInventoryRentalInventory>>
      rentalinventoryCopyPost(
          {@Body()
              required WebApiModulesInventoryInventoryCopyInventoryRequest?
                  body});

  ///Get an empty object
  @Get(path: '/rentalinventory/emptyobject')
  Future<chopper.Response> rentalinventoryEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/rentalinventory/emptybrowseobject')
  Future<chopper.Response> rentalinventoryEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/rentalinventory/keyfieldnames')
  Future<chopper.Response> rentalinventoryKeyfieldnamesGet();

  ///Get documents.
  ///@param repairid Unique identifier
  @Post(path: '/repair/{repairid}/document/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      repairRepairidDocumentBrowsePost(
          {@Path('repairid') required String? repairid,
          @Body() required FwStandardModelsBrowseRequest? body});

  ///Export documents to Excel.
  ///@param repairid Unique identifier
  @Post(path: '/repair/{repairid}/document/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      repairRepairidDocumentExportexcelxlsxPost(
          {@Path('repairid') required String? repairid,
          @Body() required FwStandardModelsBrowseRequest? body});

  ///Get documents.
  ///@param repairid Unique identifier
  ///@param DocumentTypeId Unique Identifier [Filter|Sort]
  ///@param Description Document description [Filter|Sort]
  ///@param DateStamp Document last modified data [Filter|Sort]
  ///@param PageNo The page number in the result set starting from 1.  PageNo is required when the PageSize is specified.
  ///@param PageSize Limit result set to the specified amount.
  ///@param Sort A sort expression to use of the form: Field1:asc,Field2:desc
  @Get(path: '/repair/{repairid}/documents')
  Future<
          chopper.Response<
              FwStandardModelsGetResponseFwStandardGridsAppDocumentAppDocumentGetManyResponse>>
      repairRepairidDocumentsGet(
          {@Path('repairid') required String? repairid,
          @Query('DocumentTypeId') String? documentTypeId,
          @Query('Description') String? description,
          @Query('DateStamp') String? dateStamp,
          @Query('PageNo') int? pageNo,
          @Query('PageSize') int? pageSize,
          @Query('Sort') String? sort});

  ///Get a document.
  ///@param repairid Unique identifier
  ///@param documentid Unique identifier
  @Get(path: '/repair/{repairid}/document/{documentid}')
  Future<chopper.Response<WebApiModulesInventoryRepairRepairDocument>>
      repairRepairidDocumentDocumentidGet(
          {@Path('repairid') required String? repairid,
          @Path('documentid') required String? documentid});

  ///Update a document.
  ///@param repairid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/repair/{repairid}/document/{documentid}')
  Future<chopper.Response<WebApiModulesInventoryRepairRepairDocument>>
      repairRepairidDocumentDocumentidPut(
          {@Path('repairid')
              required String? repairid,
          @Path('documentid')
              required String? documentid,
          @Body()
              required WebApiModulesInventoryRepairRepairDocumentPutRequest?
                  body});

  ///Delete a document.
  ///@param repairid Unique identifier
  ///@param documentid Unique identifier
  @Delete(path: '/repair/{repairid}/document/{documentid}')
  Future<chopper.Response<bool>> repairRepairidDocumentDocumentidDelete(
      {@Path('repairid') required String? repairid,
      @Path('documentid') required String? documentid});

  ///Create a new document.
  ///@param repairid Unique identifier
  @Post(path: '/repair/{repairid}/document')
  Future<chopper.Response<WebApiModulesInventoryRepairRepairDocument>>
      repairRepairidDocumentPost(
          {@Path('repairid')
              required String? repairid,
          @Body()
              required WebApiModulesInventoryRepairRepairDocumentPostRequest?
                  body});

  ///Get thumbnails for any images attached to the document.
  ///@param repairid Unique identifier
  ///@param documentid Unique identifier
  ///@param pageno The page number of the result set, starting from page 1.
  ///@param pagesize The number of records per page of the result set.
  @Get(path: '/repair/{repairid}/document/{documentid}/thumbnails')
  Future<
          chopper.Response<
              FwStandardGridsAppDocumentGetDocumentThumbnailsResponse>>
      repairRepairidDocumentDocumentidThumbnailsGet(
          {@Path('repairid') required String? repairid,
          @Path('documentid') required String? documentid,
          @Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize});

  ///Get a fullsize image.
  ///@param repairid Unique identifier
  ///@param documentid Unique identifier
  ///@param imageid Unique identifier
  @Get(path: '/repair/{repairid}/document/{documentid}/image/{imageid}')
  Future<chopper.Response<FwStandardGridsAppDocumentGetDocumentImageResponse>>
      repairRepairidDocumentDocumentidImageImageidGet(
          {@Path('repairid') required String? repairid,
          @Path('documentid') required String? documentid,
          @Path('imageid') required String? imageid});

  ///Delete an attached image.
  ///@param repairid Unique identifier
  ///@param documentid Unique identifier
  ///@param imageid Unique identifier
  @Delete(path: '/repair/{repairid}/document/{documentid}/image/{imageid}')
  Future<chopper.Response<bool>>
      repairRepairidDocumentDocumentidImageImageidDelete(
          {@Path('repairid') required String? repairid,
          @Path('documentid') required String? documentid,
          @Path('imageid') required String? imageid});

  ///Attach an image from a dataurl.
  ///@param repairid Unique identifier
  ///@param documentid Unique identifier
  @Post(path: '/repair/{repairid}/document/{documentid}/image')
  Future<chopper.Response<bool>> repairRepairidDocumentDocumentidImagePost(
      {@Path('repairid')
          required String? repairid,
      @Path('documentid')
          required String? documentid,
      @Body()
          required FwStandardGridsAppDocumentPostDocumentImageRequest? body});

  ///Attach an image from a form submission.
  ///@param repairid Unique identifier
  ///@param documentid Unique identifier
  @Post(path: '/repair/{repairid}/document/{documentid}/imageformupload')
  Future<chopper.Response<bool>>
      repairRepairidDocumentDocumentidImageformuploadPost(
          {@Path('repairid') required String? repairid,
          @Path('documentid') required String? documentid});

  ///Get the attached file.
  ///@param repairid Unique identifier
  ///@param documentid Unique identifier
  @Get(path: '/repair/{repairid}/document/{documentid}/file')
  Future<chopper.Response> repairRepairidDocumentDocumentidFileGet(
      {@Path('repairid') required String? repairid,
      @Path('documentid') required String? documentid});

  ///Update the attached file from a dataurl.
  ///@param repairid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/repair/{repairid}/document/{documentid}/file')
  Future<chopper.Response<bool>> repairRepairidDocumentDocumentidFilePut(
      {@Path('repairid') required String? repairid,
      @Path('documentid') required String? documentid,
      @Body() required FwStandardGridsAppDocumentPutDocumentFileRequest? body});

  ///Delete attached file.
  ///@param repairid Unique identifier
  ///@param documentid Unique identifier
  @Delete(path: '/repair/{repairid}/document/{documentid}/file')
  Future<chopper.Response<bool>> repairRepairidDocumentDocumentidFileDelete(
      {@Path('repairid') required String? repairid,
      @Path('documentid') required String? documentid});

  ///Update attached file from a form submission.
  ///@param repairid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/repair/{repairid}/document/{documentid}/fileformupload')
  Future<chopper.Response<bool>>
      repairRepairidDocumentDocumentidFileformuploadPut(
          {@Path('repairid') required String? repairid,
          @Path('documentid') required String? documentid});

  ///
  ///@param repairid
  @Get(path: '/repair/{repairid}/document/emptyobject')
  Future<chopper.Response> repairRepairidDocumentEmptyobjectGet(
      {@Path('repairid') required String? repairid});

  ///
  @Post(path: '/repair/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>> repairBrowsePost(
      {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/repair/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      repairExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/repair')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesInventoryRepairRepairLogic>>
      repairGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/repair')
  Future<chopper.Response<WebApiModulesInventoryRepairRepair>> repairPost(
      {@Body() required WebApiModulesInventoryRepairRepair? body});

  ///
  ///@param id
  @Get(path: '/repair/{id}')
  Future<chopper.Response<WebApiModulesInventoryRepairRepair>> repairIdGet(
      {@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/repair/{id}')
  Future<chopper.Response<WebApiModulesInventoryRepairRepair>> repairIdPut(
      {@Path('id') required String? id,
      @Body() required WebApiModulesInventoryRepairRepair? body});

  ///
  ///@param id
  @Delete(path: '/repair/{id}')
  Future<chopper.Response<bool>> repairIdDelete(
      {@Path('id') required String? id});

  ///
  ///@param id
  @Post(path: '/repair/estimate/{id}', optionalBody: true)
  Future<
          chopper.Response<
              WebApiModulesInventoryRepairToggleRepairEstimateResponse>>
      repairEstimateIdPost({@Path('id') required String? id});

  ///
  ///@param id
  @Post(path: '/repair/complete/{id}', optionalBody: true)
  Future<
          chopper.Response<
              WebApiModulesInventoryRepairToggleRepairCompleteResponse>>
      repairCompleteIdPost({@Path('id') required String? id});

  ///
  ///@param id
  ///@param quantity
  @Post(path: '/repair/releaseitems/{id}/{quantity}', optionalBody: true)
  Future<
          chopper
              .Response<WebApiModulesInventoryRepairRepairReleaseItemsResponse>>
      repairReleaseitemsIdQuantityPost(
          {@Path('id') required String? id,
          @Path('quantity') required int? quantity});

  ///
  ///@param id
  @Post(path: '/repair/void/{id}', optionalBody: true)
  Future<chopper.Response<WebApiModulesInventoryRepairVoidRepairResponse>>
      repairVoidIdPost({@Path('id') required String? id});

  ///
  ///@param id
  @Post(path: '/repair/{id}/createserviceorder', optionalBody: true)
  Future<
          chopper.Response<
              WebApiModulesHomeControlsServiceOrderItemCreateServiceOrderFromRepairResponse>>
      repairIdCreateserviceorderPost({@Path('id') required String? id});

  ///
  ///@param id
  @Post(path: '/repair/{id}/createlossanddamageorder', optionalBody: true)
  Future<
          chopper.Response<
              WebApiModulesHomeControlsLossAndDamageCreateLossAndDamageOrderFromRepairResponse>>
      repairIdCreatelossanddamageorderPost({@Path('id') required String? id});

  ///
  @Post(path: '/repair/validateitem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      repairValidateitemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/repair/validaterentalinventory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      repairValidaterentalinventoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/repair/validatesalesinventory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      repairValidatesalesinventoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/repair/validatedepartment/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      repairValidatedepartmentBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/repair/validatedamageorder/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      repairValidatedamageorderBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/repair/validaterepairitemstatus/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      repairValidaterepairitemstatusBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/repair/validateofficelocation/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      repairValidateofficelocationBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/repair/validatewarehouselocation/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      repairValidatewarehouselocationBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/repair/validatecurrency/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      repairValidatecurrencyBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/repair/validatetaxoption/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      repairValidatetaxoptionBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/repair/inventorystatus')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatusLogic>>
      repairInventorystatusGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///Get an empty object
  @Get(path: '/repair/emptyobject')
  Future<chopper.Response> repairEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/repair/emptybrowseobject')
  Future<chopper.Response> repairEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/repair/keyfieldnames')
  Future<chopper.Response> repairKeyfieldnamesGet();

  ///
  @Post(path: '/repaircost/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      repaircostBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/repaircost/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      repaircostExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/repaircost')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairCostRepairCostLogic>>
      repaircostGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/repaircost')
  Future<chopper.Response<WebApiModulesHomeControlsRepairCostRepairCost>>
      repaircostPost(
          {@Body()
              required WebApiModulesHomeControlsRepairCostRepairCost? body});

  ///
  ///@param id
  @Get(path: '/repaircost/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsRepairCostRepairCost>>
      repaircostIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/repaircost/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsRepairCostRepairCost>>
      repaircostIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsRepairCostRepairCost? body});

  ///
  ///@param id
  @Delete(path: '/repaircost/{id}')
  Future<chopper.Response<bool>> repaircostIdDelete(
      {@Path('id') required String? id});

  ///
  ///@param Quantity
  ///@param Rate
  ///@param DiscountAmount
  @Get(path: '/repaircost/calculateextended')
  Future<chopper.Response> repaircostCalculateextendedGet(
      {@Query('Quantity') num? quantity,
      @Query('Rate') num? rate,
      @Query('DiscountAmount') num? discountAmount});

  ///
  @Post(path: '/repaircost/validaterate/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      repaircostValidaterateBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/repaircost/emptyobject')
  Future<chopper.Response> repaircostEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/repaircost/emptybrowseobject')
  Future<chopper.Response> repaircostEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/repaircost/keyfieldnames')
  Future<chopper.Response> repaircostKeyfieldnamesGet();

  ///
  @Post(path: '/repairpart/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      repairpartBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/repairpart/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      repairpartExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/repairpart')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairPartRepairPartLogic>>
      repairpartGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/repairpart')
  Future<chopper.Response<WebApiModulesHomeControlsRepairPartRepairPart>>
      repairpartPost(
          {@Body()
              required WebApiModulesHomeControlsRepairPartRepairPart? body});

  ///
  ///@param id
  @Get(path: '/repairpart/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsRepairPartRepairPart>>
      repairpartIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/repairpart/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsRepairPartRepairPart>>
      repairpartIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsRepairPartRepairPart? body});

  ///
  ///@param id
  @Delete(path: '/repairpart/{id}')
  Future<chopper.Response<bool>> repairpartIdDelete(
      {@Path('id') required String? id});

  ///
  ///@param Quantity
  ///@param Rate
  ///@param DiscountAmount
  @Get(path: '/repairpart/calculateextended')
  Future<chopper.Response> repairpartCalculateextendedGet(
      {@Query('Quantity') num? quantity,
      @Query('Rate') num? rate,
      @Query('DiscountAmount') num? discountAmount});

  ///
  @Post(path: '/repairpart/validateinventory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      repairpartValidateinventoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/repairpart/validatewarehouse/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      repairpartValidatewarehouseBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/repairpart/emptyobject')
  Future<chopper.Response> repairpartEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/repairpart/emptybrowseobject')
  Future<chopper.Response> repairpartEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/repairpart/keyfieldnames')
  Future<chopper.Response> repairpartKeyfieldnamesGet();

  ///
  @Post(path: '/repairrelease/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      repairreleaseBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/repairrelease/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      repairreleaseExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/repairrelease')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairReleaseRepairReleaseLogic>>
      repairreleaseGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  ///@param id
  @Get(path: '/repairrelease/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsRepairReleaseRepairRelease>>
      repairreleaseIdGet({@Path('id') required String? id});

  ///Get an empty object
  @Get(path: '/repairrelease/emptyobject')
  Future<chopper.Response> repairreleaseEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/repairrelease/emptybrowseobject')
  Future<chopper.Response> repairreleaseEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/repairrelease/keyfieldnames')
  Future<chopper.Response> repairreleaseKeyfieldnamesGet();

  ///
  @Post(path: '/retired/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      retiredBrowsePost({@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/retired/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      retiredExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/retired')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesInventoryRetiredRetiredLogic>>
      retiredGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  ///@param id
  @Get(path: '/retired/{id}')
  Future<chopper.Response<WebApiModulesInventoryRetiredRetired>> retiredIdGet(
      {@Path('id') required String? id});

  ///
  @Post(path: '/retired/gldistribution/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      retiredGldistributionBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/retired/emptyobject')
  Future<chopper.Response> retiredEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/retired/emptybrowseobject')
  Future<chopper.Response> retiredEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/retired/keyfieldnames')
  Future<chopper.Response> retiredKeyfieldnamesGet();

  ///
  ///@param warehouseId
  @Get(path: '/returntovendor/suspendedsessionsexist')
  Future<chopper.Response<bool>> returntovendorSuspendedsessionsexistGet(
      {@Query('warehouseId') String? warehouseId});

  ///
  @Post(path: '/returntovendor/startsession')
  Future<
          chopper
              .Response<WebApiModulesAgentPurchaseOrderReturnContractResponse>>
      returntovendorStartsessionPost(
          {@Body()
              required WebApiModulesAgentPurchaseOrderReturnContractRequest?
                  body});

  ///
  @Post(path: '/returntovendor/returnitems')
  Future<chopper.Response<WebApiModulesAgentPurchaseOrderReturnItemResponse>>
      returntovendorReturnitemsPost(
          {@Body()
              required WebApiModulesAgentPurchaseOrderReturnItemRequest? body});

  ///
  @Post(path: '/returntovendor/selectall')
  Future<
          chopper.Response<
              WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemResponse>>
      returntovendorSelectallPost(
          {@Body()
              required WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemRequest?
                  body});

  ///
  @Post(path: '/returntovendor/selectnone')
  Future<
          chopper.Response<
              WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemResponse>>
      returntovendorSelectnonePost(
          {@Body()
              required WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemRequest?
                  body});

  ///
  ///@param id
  @Post(path: '/returntovendor/completecontract/{id}', optionalBody: true)
  Future<chopper.Response<WebApiModulesWarehouseContractContract>>
      returntovendorCompletecontractIdPost({@Path('id') required String? id});

  ///
  @Post(path: '/returntovendor/cancelcontract')
  Future<chopper.Response<WebApiLogicTSpStatusResponse>>
      returntovendorCancelcontractPost(
          {@Body()
              required WebApiModulesWarehouseContractCancelContractRequest?
                  body});

  ///
  @Post(path: '/returntovendor/validatepurchaseorder/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      returntovendorValidatepurchaseorderBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/returntovendor/emptyobject')
  Future<chopper.Response> returntovendorEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/returntovendor/emptybrowseobject')
  Future<chopper.Response> returntovendorEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/returntovendor/keyfieldnames')
  Future<chopper.Response> returntovendorKeyfieldnamesGet();

  ///Get documents.
  ///@param inventoryid Unique identifier
  @Post(path: '/salesinventory/{inventoryid}/document/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      salesinventoryInventoryidDocumentBrowsePost(
          {@Path('inventoryid') required String? inventoryid,
          @Body() required FwStandardModelsBrowseRequest? body});

  ///Export documents to Excel.
  ///@param inventoryid Unique identifier
  @Post(path: '/salesinventory/{inventoryid}/document/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      salesinventoryInventoryidDocumentExportexcelxlsxPost(
          {@Path('inventoryid') required String? inventoryid,
          @Body() required FwStandardModelsBrowseRequest? body});

  ///Get documents.
  ///@param inventoryid Unique identifier
  ///@param DocumentTypeId Unique Identifier [Filter|Sort]
  ///@param Description Document description [Filter|Sort]
  ///@param DateStamp Document last modified data [Filter|Sort]
  ///@param PageNo The page number in the result set starting from 1.  PageNo is required when the PageSize is specified.
  ///@param PageSize Limit result set to the specified amount.
  ///@param Sort A sort expression to use of the form: Field1:asc,Field2:desc
  @Get(path: '/salesinventory/{inventoryid}/documents')
  Future<
          chopper.Response<
              FwStandardModelsGetResponseFwStandardGridsAppDocumentAppDocumentGetManyResponse>>
      salesinventoryInventoryidDocumentsGet(
          {@Path('inventoryid') required String? inventoryid,
          @Query('DocumentTypeId') String? documentTypeId,
          @Query('Description') String? description,
          @Query('DateStamp') String? dateStamp,
          @Query('PageNo') int? pageNo,
          @Query('PageSize') int? pageSize,
          @Query('Sort') String? sort});

  ///Get a document.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  @Get(path: '/salesinventory/{inventoryid}/document/{documentid}')
  Future<
          chopper.Response<
              WebApiModulesInventorySalesInventorySalesInventoryDocument>>
      salesinventoryInventoryidDocumentDocumentidGet(
          {@Path('inventoryid') required String? inventoryid,
          @Path('documentid') required String? documentid});

  ///Update a document.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/salesinventory/{inventoryid}/document/{documentid}')
  Future<
          chopper.Response<
              WebApiModulesInventorySalesInventorySalesInventoryDocument>>
      salesinventoryInventoryidDocumentDocumentidPut(
          {@Path('inventoryid')
              required String? inventoryid,
          @Path('documentid')
              required String? documentid,
          @Body()
              required WebApiModulesInventorySalesInventorySalesInventoryDocumentPutRequest?
                  body});

  ///Delete a document.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  @Delete(path: '/salesinventory/{inventoryid}/document/{documentid}')
  Future<chopper.Response<bool>>
      salesinventoryInventoryidDocumentDocumentidDelete(
          {@Path('inventoryid') required String? inventoryid,
          @Path('documentid') required String? documentid});

  ///Create a new document.
  ///@param inventoryid Unique identifier
  @Post(path: '/salesinventory/{inventoryid}/document')
  Future<
          chopper.Response<
              WebApiModulesInventorySalesInventorySalesInventoryDocument>>
      salesinventoryInventoryidDocumentPost(
          {@Path('inventoryid')
              required String? inventoryid,
          @Body()
              required WebApiModulesInventorySalesInventorySalesInventoryDocumentPostRequest?
                  body});

  ///Get thumbnails for any images attached to the document.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  ///@param pageno The page number of the result set, starting from page 1.
  ///@param pagesize The number of records per page of the result set.
  @Get(path: '/salesinventory/{inventoryid}/document/{documentid}/thumbnails')
  Future<
          chopper.Response<
              FwStandardGridsAppDocumentGetDocumentThumbnailsResponse>>
      salesinventoryInventoryidDocumentDocumentidThumbnailsGet(
          {@Path('inventoryid') required String? inventoryid,
          @Path('documentid') required String? documentid,
          @Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize});

  ///Get a fullsize image.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  ///@param imageid Unique identifier
  @Get(
      path:
          '/salesinventory/{inventoryid}/document/{documentid}/image/{imageid}')
  Future<chopper.Response<FwStandardGridsAppDocumentGetDocumentImageResponse>>
      salesinventoryInventoryidDocumentDocumentidImageImageidGet(
          {@Path('inventoryid') required String? inventoryid,
          @Path('documentid') required String? documentid,
          @Path('imageid') required String? imageid});

  ///Delete an attached image.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  ///@param imageid Unique identifier
  @Delete(
      path:
          '/salesinventory/{inventoryid}/document/{documentid}/image/{imageid}')
  Future<chopper.Response<bool>>
      salesinventoryInventoryidDocumentDocumentidImageImageidDelete(
          {@Path('inventoryid') required String? inventoryid,
          @Path('documentid') required String? documentid,
          @Path('imageid') required String? imageid});

  ///Attach an image from a dataurl.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  @Post(path: '/salesinventory/{inventoryid}/document/{documentid}/image')
  Future<chopper.Response<bool>>
      salesinventoryInventoryidDocumentDocumentidImagePost(
          {@Path('inventoryid')
              required String? inventoryid,
          @Path('documentid')
              required String? documentid,
          @Body()
              required FwStandardGridsAppDocumentPostDocumentImageRequest?
                  body});

  ///Attach an image from a form submission.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  @Post(
      path:
          '/salesinventory/{inventoryid}/document/{documentid}/imageformupload')
  Future<chopper.Response<bool>>
      salesinventoryInventoryidDocumentDocumentidImageformuploadPost(
          {@Path('inventoryid') required String? inventoryid,
          @Path('documentid') required String? documentid});

  ///Get the attached file.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  @Get(path: '/salesinventory/{inventoryid}/document/{documentid}/file')
  Future<chopper.Response> salesinventoryInventoryidDocumentDocumentidFileGet(
      {@Path('inventoryid') required String? inventoryid,
      @Path('documentid') required String? documentid});

  ///Update the attached file from a dataurl.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/salesinventory/{inventoryid}/document/{documentid}/file')
  Future<chopper.Response<bool>>
      salesinventoryInventoryidDocumentDocumentidFilePut(
          {@Path('inventoryid')
              required String? inventoryid,
          @Path('documentid')
              required String? documentid,
          @Body()
              required FwStandardGridsAppDocumentPutDocumentFileRequest? body});

  ///Delete attached file.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  @Delete(path: '/salesinventory/{inventoryid}/document/{documentid}/file')
  Future<chopper.Response<bool>>
      salesinventoryInventoryidDocumentDocumentidFileDelete(
          {@Path('inventoryid') required String? inventoryid,
          @Path('documentid') required String? documentid});

  ///Update attached file from a form submission.
  ///@param inventoryid Unique identifier
  ///@param documentid Unique identifier
  @Put(
      path:
          '/salesinventory/{inventoryid}/document/{documentid}/fileformupload')
  Future<chopper.Response<bool>>
      salesinventoryInventoryidDocumentDocumentidFileformuploadPut(
          {@Path('inventoryid') required String? inventoryid,
          @Path('documentid') required String? documentid});

  ///
  ///@param salesinventoryid
  @Get(path: '/salesinventory/{salesinventoryid}/document/emptyobject')
  Future<chopper.Response> salesinventorySalesinventoryidDocumentEmptyobjectGet(
      {@Path('salesinventoryid') required String? salesinventoryid});

  ///
  @Post(path: '/salesinventory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      salesinventoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Get(path: '/salesinventory/legend')
  Future<chopper.Response<Object>> salesinventoryLegendGet();

  ///
  @Get(path: '/salesinventory/availabilitylegend')
  Future<chopper.Response<Object>> salesinventoryAvailabilitylegendGet();

  ///
  @Post(path: '/salesinventory/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      salesinventoryExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/salesinventory')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesInventorySalesInventorySalesInventoryLogic>>
      salesinventoryGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/salesinventory')
  Future<chopper.Response<WebApiModulesInventorySalesInventorySalesInventory>>
      salesinventoryPost(
          {@Body()
              required WebApiModulesInventorySalesInventorySalesInventory?
                  body});

  ///
  ///@param id
  @Get(path: '/salesinventory/{id}')
  Future<chopper.Response<WebApiModulesInventorySalesInventorySalesInventory>>
      salesinventoryIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/salesinventory/{id}')
  Future<chopper.Response<WebApiModulesInventorySalesInventorySalesInventory>>
      salesinventoryIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesInventorySalesInventorySalesInventory?
                  body});

  ///
  ///@param id
  @Delete(path: '/salesinventory/{id}')
  Future<chopper.Response<bool>> salesinventoryIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/salesinventory/validateinventorytype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      salesinventoryValidateinventorytypeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/salesinventory/validatecategoryid/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      salesinventoryValidatecategoryidBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/salesinventory/validatesubcategory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      salesinventoryValidatesubcategoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/salesinventory/validateunit/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      salesinventoryValidateunitBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/salesinventory/validaterank/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      salesinventoryValidaterankBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/salesinventory/validatecountryoforigin/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      salesinventoryValidatecountryoforiginBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/salesinventory/validateprofitandlosscategory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      salesinventoryValidateprofitandlosscategoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/salesinventory/validateassetaccount/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      salesinventoryValidateassetaccountBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/salesinventory/validateincomeaccount/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      salesinventoryValidateincomeaccountBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/salesinventory/validatesubincomeaccount/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      salesinventoryValidatesubincomeaccountBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/salesinventory/validatecostofgoodssoldexpenseaccount/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      salesinventoryValidatecostofgoodssoldexpenseaccountBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/salesinventory/validatewarehouse/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      salesinventoryValidatewarehouseBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/salesinventory/validatemanufacturer/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      salesinventoryValidatemanufacturerBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/salesinventory/copy')
  Future<chopper.Response<WebApiModulesInventorySalesInventorySalesInventory>>
      salesinventoryCopyPost(
          {@Body()
              required WebApiModulesInventoryInventoryCopyInventoryRequest?
                  body});

  ///Get an empty object
  @Get(path: '/salesinventory/emptyobject')
  Future<chopper.Response> salesinventoryEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/salesinventory/emptybrowseobject')
  Future<chopper.Response> salesinventoryEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/salesinventory/keyfieldnames')
  Future<chopper.Response> salesinventoryKeyfieldnamesGet();

  ///
  @Post(path: '/serviceorderitem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      serviceorderitemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/serviceorderitem/startsession')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionResponse>>
      serviceorderitemStartsessionPost(
          {@Body()
              required WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionRequest?
                  body});

  ///
  @Post(path: '/serviceorderitem')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsServiceOrderItemServiceOrderItem>>
      serviceorderitemPost(
          {@Body()
              required WebApiModulesHomeControlsServiceOrderItemServiceOrderItem?
                  body});

  ///
  ///@param id
  @Put(path: '/serviceorderitem/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsServiceOrderItemServiceOrderItem>>
      serviceorderitemIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsServiceOrderItemServiceOrderItem?
                  body});

  ///
  @Post(path: '/serviceorderitem/completesession')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionResponse>>
      serviceorderitemCompletesessionPost(
          {@Body()
              required WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionRequest?
                  body});

  ///
  @Post(path: '/serviceorderitem/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      serviceorderitemExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/serviceorderitem/emptyobject')
  Future<chopper.Response> serviceorderitemEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/serviceorderitem/emptybrowseobject')
  Future<chopper.Response> serviceorderitemEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/serviceorderitem/keyfieldnames')
  Future<chopper.Response> serviceorderitemKeyfieldnamesGet();

  ///
  @Post(path: '/stageditem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      stageditemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/stageditem/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      stageditemExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/stageditem/emptyobject')
  Future<chopper.Response> stageditemEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/stageditem/emptybrowseobject')
  Future<chopper.Response> stageditemEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/stageditem/keyfieldnames')
  Future<chopper.Response> stageditemKeyfieldnamesGet();

  ///
  @Post(path: '/subpurchaseorderitem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      subpurchaseorderitemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/subpurchaseorderitem/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      subpurchaseorderitemExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param id
  @Get(path: '/subpurchaseorderitem/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItem>>
      subpurchaseorderitemIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/subpurchaseorderitem/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItem>>
      subpurchaseorderitemIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItem?
                  body});

  ///
  ///@param id
  @Delete(path: '/subpurchaseorderitem/{id}')
  Future<chopper.Response<bool>> subpurchaseorderitemIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/subpurchaseorderitem')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItem>>
      subpurchaseorderitemPost(
          {@Body()
              required WebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItem?
                  body});

  ///
  @Post(path: '/subpurchaseorderitem/many')
  Future<
          chopper.Response<
              List<
                  MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItemLogic>>>
      subpurchaseorderitemManyPost(
          {@Body()
              required List<
                      WebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItem>?
                  body});

  ///
  @Post(path: '/subpurchaseorderitem/selectall')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemResponse>>
      subpurchaseorderitemSelectallPost(
          {@Body()
              required WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemRequest?
                  body});

  ///
  @Post(path: '/subpurchaseorderitem/selectnone')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemResponse>>
      subpurchaseorderitemSelectnonePost(
          {@Body()
              required WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemRequest?
                  body});

  ///Get an empty object
  @Get(path: '/subpurchaseorderitem/emptyobject')
  Future<chopper.Response> subpurchaseorderitemEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/subpurchaseorderitem/emptybrowseobject')
  Future<chopper.Response> subpurchaseorderitemEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/subpurchaseorderitem/keyfieldnames')
  Future<chopper.Response> subpurchaseorderitemKeyfieldnamesGet();

  ///
  ///@param id
  @Get(path: '/suspendedsession/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsSuspendedSessionSuspendedSession>>
      suspendedsessionIdGet({@Path('id') required String? id});

  ///
  @Post(path: '/suspendedsession/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      suspendedsessionBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/suspendedsession/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      suspendedsessionExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/suspendedsession/emptyobject')
  Future<chopper.Response> suspendedsessionEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/suspendedsession/emptybrowseobject')
  Future<chopper.Response> suspendedsessionEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/suspendedsession/keyfieldnames')
  Future<chopper.Response> suspendedsessionKeyfieldnamesGet();

  ///
  @Post(path: '/taxable/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      taxableBrowsePost({@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/taxable/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      taxableExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param masterid
  ///@param locationid
  @Get(path: '/taxable/{masterid}/{locationid}')
  Future<chopper.Response<List<WebApiModulesHomeControlsTaxableTaxable>>>
      taxableMasteridLocationidGet(
          {@Path('masterid') required String? masterid,
          @Path('locationid') required String? locationid});

  ///
  ///@param masterid
  @Get(path: '/taxable/{masterid}')
  Future<chopper.Response<List<WebApiModulesHomeControlsTaxableTaxable>>>
      taxableMasteridGet({@Path('masterid') required String? masterid});

  ///Get an empty object
  @Get(path: '/taxable/emptyobject')
  Future<chopper.Response> taxableEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/taxable/emptybrowseobject')
  Future<chopper.Response> taxableEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/taxable/keyfieldnames')
  Future<chopper.Response> taxableKeyfieldnamesGet();

  ///
  ///@param warehouseId
  @Get(path: '/transferin/suspendedsessionsexist')
  Future<chopper.Response<bool>> transferinSuspendedsessionsexistGet(
      {@Query('warehouseId') String? warehouseId});

  ///
  @Post(path: '/transferin/startcheckincontract')
  Future<chopper.Response<WebApiModulesWarehouseCheckInCheckInContractResponse>>
      transferinStartcheckincontractPost(
          {@Body()
              required WebApiModulesWarehouseCheckInCheckInContractRequest?
                  body});

  ///
  ///@param id
  @Post(path: '/transferin/completecheckincontract/{id}', optionalBody: true)
  Future<chopper.Response<WebApiModulesWarehouseContractContract>>
      transferinCompletecheckincontractIdPost(
          {@Path('id') required String? id});

  ///
  @Post(path: '/transferin/checkinitem')
  Future<chopper.Response<WebApiModulesWarehouseCheckInTCheckInItemResponse>>
      transferinCheckinitemPost(
          {@Body()
              required WebApiModulesWarehouseCheckInCheckInItemRequest? body});

  ///
  @Post(path: '/transferin/cancelcontract')
  Future<chopper.Response<WebApiLogicTSpStatusResponse>>
      transferinCancelcontractPost(
          {@Body()
              required WebApiModulesWarehouseContractCancelContractRequest?
                  body});

  ///
  @Post(path: '/transferin/validatetransfer/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      transferinValidatetransferBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/transferin/emptyobject')
  Future<chopper.Response> transferinEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/transferin/emptybrowseobject')
  Future<chopper.Response> transferinEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/transferin/keyfieldnames')
  Future<chopper.Response> transferinKeyfieldnamesGet();

  ///
  @Post(path: '/transfermanifest/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      transfermanifestBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Get(path: '/transfermanifest/legend')
  Future<chopper.Response<Object>> transfermanifestLegendGet();

  ///
  @Post(path: '/transfermanifest/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      transfermanifestExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/transfermanifest')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsManifestManifestLogic>>
      transfermanifestGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/transfermanifest')
  Future<chopper.Response<WebApiModulesHomeControlsManifestManifest>>
      transfermanifestPost(
          {@Body() required WebApiModulesHomeControlsManifestManifest? body});

  ///
  ///@param id
  @Get(path: '/transfermanifest/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsManifestManifest>>
      transfermanifestIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/transfermanifest/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsManifestManifest>>
      transfermanifestIdPut(
          {@Path('id') required String? id,
          @Body() required WebApiModulesHomeControlsManifestManifest? body});

  ///
  ///@param id
  @Delete(path: '/transfermanifest/{id}')
  Future<chopper.Response<bool>> transfermanifestIdDelete(
      {@Path('id') required String? id});

  ///Get an empty object
  @Get(path: '/transfermanifest/emptyobject')
  Future<chopper.Response> transfermanifestEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/transfermanifest/emptybrowseobject')
  Future<chopper.Response> transfermanifestEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/transfermanifest/keyfieldnames')
  Future<chopper.Response> transfermanifestKeyfieldnamesGet();

  ///
  @Post(path: '/transferorder/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      transferorderBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/transferorder/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      transferorderExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param id
  @Post(path: '/transferorder/confirm/{id}', optionalBody: true)
  Future<chopper.Response<WebApiModulesTransfersTransferOrderTransferOrder>>
      transferorderConfirmIdPost({@Path('id') required String? id});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/transferorder')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesTransfersTransferOrderTransferOrderLogic>>
      transferorderGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/transferorder')
  Future<chopper.Response<WebApiModulesTransfersTransferOrderTransferOrder>>
      transferorderPost(
          {@Body()
              required WebApiModulesTransfersTransferOrderTransferOrder? body});

  ///
  ///@param id
  @Get(path: '/transferorder/{id}')
  Future<chopper.Response<WebApiModulesTransfersTransferOrderTransferOrder>>
      transferorderIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/transferorder/{id}')
  Future<chopper.Response<WebApiModulesTransfersTransferOrderTransferOrder>>
      transferorderIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesTransfersTransferOrderTransferOrder? body});

  ///
  ///@param id
  @Post(path: '/transferorder/cancel/{id}', optionalBody: true)
  Future<chopper.Response<WebApiModulesTransfersTransferOrderTransferOrder>>
      transferorderCancelIdPost({@Path('id') required String? id});

  ///
  ///@param id
  @Post(path: '/transferorder/uncancel/{id}', optionalBody: true)
  Future<chopper.Response<WebApiModulesTransfersTransferOrderTransferOrder>>
      transferorderUncancelIdPost({@Path('id') required String? id});

  ///
  @Post(path: '/transferorder/validatedepartment/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      transferorderValidatedepartmentBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/transferorder/validatefromwarehouse/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      transferorderValidatefromwarehouseBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/transferorder/validatetowarehouse/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      transferorderValidatetowarehouseBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/transferorder/validateagent/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      transferorderValidateagentBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/transferorder/validateoutdeliverycarrier/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      transferorderValidateoutdeliverycarrierBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/transferorder/validateoutdeliveryshipvia/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      transferorderValidateoutdeliveryshipviaBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/transferorder/validateoutdeliverytocountry/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      transferorderValidateoutdeliverytocountryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/transferorder/validatesendto/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      transferorderValidatesendtoBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/transferorder/emptyobject')
  Future<chopper.Response> transferorderEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/transferorder/emptybrowseobject')
  Future<chopper.Response> transferorderEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/transferorder/keyfieldnames')
  Future<chopper.Response> transferorderKeyfieldnamesGet();

  ///
  @Post(path: '/transferout/validatetransfer/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      transferoutValidatetransferBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/transferout/emptyobject')
  Future<chopper.Response> transferoutEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/transferout/emptybrowseobject')
  Future<chopper.Response> transferoutEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/transferout/keyfieldnames')
  Future<chopper.Response> transferoutKeyfieldnamesGet();

  ///
  @Post(path: '/transferreceipt/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      transferreceiptBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Get(path: '/transferreceipt/legend')
  Future<chopper.Response<Object>> transferreceiptLegendGet();

  ///
  @Post(path: '/transferreceipt/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      transferreceiptExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/transferreceipt')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsManifestManifestLogic>>
      transferreceiptGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/transferreceipt')
  Future<chopper.Response<WebApiModulesHomeControlsManifestManifest>>
      transferreceiptPost(
          {@Body() required WebApiModulesWarehouseContractContract? body});

  ///
  ///@param id
  @Get(path: '/transferreceipt/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsManifestManifest>>
      transferreceiptIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/transferreceipt/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsManifestManifest>>
      transferreceiptIdPut(
          {@Path('id') required String? id,
          @Body() required WebApiModulesHomeControlsManifestManifest? body});

  ///
  ///@param id
  @Delete(path: '/transferreceipt/{id}')
  Future<chopper.Response<bool>> transferreceiptIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/transferreceipt/voidcontract')
  Future<chopper.Response<WebApiLogicTSpStatusResponse>>
      transferreceiptVoidcontractPost(
          {@Body()
              required WebApiModulesWarehouseContractVoidContractRequest?
                  body});

  ///Get an empty object
  @Get(path: '/transferreceipt/emptyobject')
  Future<chopper.Response> transferreceiptEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/transferreceipt/emptybrowseobject')
  Future<chopper.Response> transferreceiptEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/transferreceipt/keyfieldnames')
  Future<chopper.Response> transferreceiptKeyfieldnamesGet();

  ///
  @Post(path: '/transferstatus/validatetransfer/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      transferstatusValidatetransferBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/transferstatus/validateinventorytype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      transferstatusValidateinventorytypeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/transferstatus/validatecategory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      transferstatusValidatecategoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/transferstatus/validatesubcategory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      transferstatusValidatesubcategoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/transferstatus/validateicode/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      transferstatusValidateicodeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/transferstatus/validatewarehouse/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      transferstatusValidatewarehouseBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/transferstatus/emptyobject')
  Future<chopper.Response> transferstatusEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/transferstatus/emptybrowseobject')
  Future<chopper.Response> transferstatusEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/transferstatus/keyfieldnames')
  Future<chopper.Response> transferstatusKeyfieldnamesGet();

  ///Get documents.
  ///@param vendorid Unique identifier
  @Post(path: '/vendor/{vendorid}/document/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      vendorVendoridDocumentBrowsePost(
          {@Path('vendorid') required String? vendorid,
          @Body() required FwStandardModelsBrowseRequest? body});

  ///Export documents to Excel.
  ///@param vendorid Unique identifier
  @Post(path: '/vendor/{vendorid}/document/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      vendorVendoridDocumentExportexcelxlsxPost(
          {@Path('vendorid') required String? vendorid,
          @Body() required FwStandardModelsBrowseRequest? body});

  ///Get documents.
  ///@param vendorid Unique identifier
  ///@param DocumentTypeId Unique Identifier [Filter|Sort]
  ///@param Description Document description [Filter|Sort]
  ///@param DateStamp Document last modified data [Filter|Sort]
  ///@param PageNo The page number in the result set starting from 1.  PageNo is required when the PageSize is specified.
  ///@param PageSize Limit result set to the specified amount.
  ///@param Sort A sort expression to use of the form: Field1:asc,Field2:desc
  @Get(path: '/vendor/{vendorid}/documents')
  Future<
          chopper.Response<
              FwStandardModelsGetResponseFwStandardGridsAppDocumentAppDocumentGetManyResponse>>
      vendorVendoridDocumentsGet(
          {@Path('vendorid') required String? vendorid,
          @Query('DocumentTypeId') String? documentTypeId,
          @Query('Description') String? description,
          @Query('DateStamp') String? dateStamp,
          @Query('PageNo') int? pageNo,
          @Query('PageSize') int? pageSize,
          @Query('Sort') String? sort});

  ///Get a document.
  ///@param vendorid Unique identifier
  ///@param documentid Unique identifier
  @Get(path: '/vendor/{vendorid}/document/{documentid}')
  Future<chopper.Response<WebApiModulesAgentVendorVendorDocument>>
      vendorVendoridDocumentDocumentidGet(
          {@Path('vendorid') required String? vendorid,
          @Path('documentid') required String? documentid});

  ///Update a document.
  ///@param vendorid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/vendor/{vendorid}/document/{documentid}')
  Future<chopper.Response<WebApiModulesAgentVendorVendorDocument>>
      vendorVendoridDocumentDocumentidPut(
          {@Path('vendorid')
              required String? vendorid,
          @Path('documentid')
              required String? documentid,
          @Body()
              required WebApiModulesAgentVendorVendorDocumentPutRequest? body});

  ///Delete a document.
  ///@param vendorid Unique identifier
  ///@param documentid Unique identifier
  @Delete(path: '/vendor/{vendorid}/document/{documentid}')
  Future<chopper.Response<bool>> vendorVendoridDocumentDocumentidDelete(
      {@Path('vendorid') required String? vendorid,
      @Path('documentid') required String? documentid});

  ///Create a new document.
  ///@param vendorid Unique identifier
  @Post(path: '/vendor/{vendorid}/document')
  Future<chopper.Response<WebApiModulesAgentVendorVendorDocument>>
      vendorVendoridDocumentPost(
          {@Path('vendorid')
              required String? vendorid,
          @Body()
              required WebApiModulesAgentVendorVendorDocumentPostRequest?
                  body});

  ///Get thumbnails for any images attached to the document.
  ///@param vendorid Unique identifier
  ///@param documentid Unique identifier
  ///@param pageno The page number of the result set, starting from page 1.
  ///@param pagesize The number of records per page of the result set.
  @Get(path: '/vendor/{vendorid}/document/{documentid}/thumbnails')
  Future<
          chopper.Response<
              FwStandardGridsAppDocumentGetDocumentThumbnailsResponse>>
      vendorVendoridDocumentDocumentidThumbnailsGet(
          {@Path('vendorid') required String? vendorid,
          @Path('documentid') required String? documentid,
          @Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize});

  ///Get a fullsize image.
  ///@param vendorid Unique identifier
  ///@param documentid Unique identifier
  ///@param imageid Unique identifier
  @Get(path: '/vendor/{vendorid}/document/{documentid}/image/{imageid}')
  Future<chopper.Response<FwStandardGridsAppDocumentGetDocumentImageResponse>>
      vendorVendoridDocumentDocumentidImageImageidGet(
          {@Path('vendorid') required String? vendorid,
          @Path('documentid') required String? documentid,
          @Path('imageid') required String? imageid});

  ///Delete an attached image.
  ///@param vendorid Unique identifier
  ///@param documentid Unique identifier
  ///@param imageid Unique identifier
  @Delete(path: '/vendor/{vendorid}/document/{documentid}/image/{imageid}')
  Future<chopper.Response<bool>>
      vendorVendoridDocumentDocumentidImageImageidDelete(
          {@Path('vendorid') required String? vendorid,
          @Path('documentid') required String? documentid,
          @Path('imageid') required String? imageid});

  ///Attach an image from a dataurl.
  ///@param vendorid Unique identifier
  ///@param documentid Unique identifier
  @Post(path: '/vendor/{vendorid}/document/{documentid}/image')
  Future<chopper.Response<bool>> vendorVendoridDocumentDocumentidImagePost(
      {@Path('vendorid')
          required String? vendorid,
      @Path('documentid')
          required String? documentid,
      @Body()
          required FwStandardGridsAppDocumentPostDocumentImageRequest? body});

  ///Attach an image from a form submission.
  ///@param vendorid Unique identifier
  ///@param documentid Unique identifier
  @Post(path: '/vendor/{vendorid}/document/{documentid}/imageformupload')
  Future<chopper.Response<bool>>
      vendorVendoridDocumentDocumentidImageformuploadPost(
          {@Path('vendorid') required String? vendorid,
          @Path('documentid') required String? documentid});

  ///Get the attached file.
  ///@param vendorid Unique identifier
  ///@param documentid Unique identifier
  @Get(path: '/vendor/{vendorid}/document/{documentid}/file')
  Future<chopper.Response> vendorVendoridDocumentDocumentidFileGet(
      {@Path('vendorid') required String? vendorid,
      @Path('documentid') required String? documentid});

  ///Update the attached file from a dataurl.
  ///@param vendorid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/vendor/{vendorid}/document/{documentid}/file')
  Future<chopper.Response<bool>> vendorVendoridDocumentDocumentidFilePut(
      {@Path('vendorid') required String? vendorid,
      @Path('documentid') required String? documentid,
      @Body() required FwStandardGridsAppDocumentPutDocumentFileRequest? body});

  ///Delete attached file.
  ///@param vendorid Unique identifier
  ///@param documentid Unique identifier
  @Delete(path: '/vendor/{vendorid}/document/{documentid}/file')
  Future<chopper.Response<bool>> vendorVendoridDocumentDocumentidFileDelete(
      {@Path('vendorid') required String? vendorid,
      @Path('documentid') required String? documentid});

  ///Update attached file from a form submission.
  ///@param vendorid Unique identifier
  ///@param documentid Unique identifier
  @Put(path: '/vendor/{vendorid}/document/{documentid}/fileformupload')
  Future<chopper.Response<bool>>
      vendorVendoridDocumentDocumentidFileformuploadPut(
          {@Path('vendorid') required String? vendorid,
          @Path('documentid') required String? documentid});

  ///
  ///@param vendorid
  @Get(path: '/vendor/{vendorid}/document/emptyobject')
  Future<chopper.Response> vendorVendoridDocumentEmptyobjectGet(
      {@Path('vendorid') required String? vendorid});

  ///
  @Post(path: '/vendor/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>> vendorBrowsePost(
      {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/vendor/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      vendorExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/vendor')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesAgentVendorVendorLogic>>
      vendorGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/vendor')
  Future<chopper.Response<WebApiModulesAgentVendorVendor>> vendorPost(
      {@Body() required WebApiModulesAgentVendorVendor? body});

  ///
  ///@param id
  @Get(path: '/vendor/{id}')
  Future<chopper.Response<WebApiModulesAgentVendorVendor>> vendorIdGet(
      {@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/vendor/{id}')
  Future<chopper.Response<WebApiModulesAgentVendorVendor>> vendorIdPut(
      {@Path('id') required String? id,
      @Body() required WebApiModulesAgentVendorVendor? body});

  ///
  ///@param id
  @Delete(path: '/vendor/{id}')
  Future<chopper.Response<bool>> vendorIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/vendor/validateofficelocation/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      vendorValidateofficelocationBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/vendor/validatevendorclass/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      vendorValidatevendorclassBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/vendor/validatecustomer/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      vendorValidatecustomerBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/vendor/validatecountry/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      vendorValidatecountryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/vendor/validaterate/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      vendorValidaterateBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/vendor/validatebillingcycle/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      vendorValidatebillingcycleBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/vendor/validatepaymentterms/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      vendorValidatepaymenttermsBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/vendor/validateorganizationtype/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      vendorValidateorganizationtypeBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/vendor/validatepoclass/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      vendorValidatepoclassBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/vendor/validatecurrency/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      vendorValidatecurrencyBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/vendor/validateremitcountry/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      vendorValidateremitcountryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/vendor/emptyobject')
  Future<chopper.Response> vendorEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/vendor/emptybrowseobject')
  Future<chopper.Response> vendorEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/vendor/keyfieldnames')
  Future<chopper.Response> vendorKeyfieldnamesGet();

  ///
  @Get(path: '/vendorinvoice/legend')
  Future<chopper.Response<Object>> vendorinvoiceLegendGet();

  ///
  @Post(path: '/vendorinvoice/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      vendorinvoiceBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/vendorinvoice/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      vendorinvoiceExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/vendorinvoice')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesBillingVendorInvoiceVendorInvoiceLogic>>
      vendorinvoiceGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/vendorinvoice')
  Future<chopper.Response<WebApiModulesBillingVendorInvoiceVendorInvoice>>
      vendorinvoicePost(
          {@Body()
              required WebApiModulesBillingVendorInvoiceVendorInvoice? body});

  ///
  ///@param id
  @Get(path: '/vendorinvoice/{id}')
  Future<chopper.Response<WebApiModulesBillingVendorInvoiceVendorInvoice>>
      vendorinvoiceIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/vendorinvoice/{id}')
  Future<chopper.Response<WebApiModulesBillingVendorInvoiceVendorInvoice>>
      vendorinvoiceIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesBillingVendorInvoiceVendorInvoice? body});

  ///
  ///@param id
  @Delete(path: '/vendorinvoice/{id}')
  Future<chopper.Response<bool>> vendorinvoiceIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/vendorinvoice/toggleapproved')
  Future<
          chopper.Response<
              WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedResponse>>
      vendorinvoiceToggleapprovedPost(
          {@Body()
              required WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedRequest?
                  body});

  ///
  @Post(path: '/vendorinvoice/validatetaxoption/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      vendorinvoiceValidatetaxoptionBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/vendorinvoice/gldistribution/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      vendorinvoiceGldistributionBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/vendorinvoice/emptyobject')
  Future<chopper.Response> vendorinvoiceEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/vendorinvoice/emptybrowseobject')
  Future<chopper.Response> vendorinvoiceEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/vendorinvoice/keyfieldnames')
  Future<chopper.Response> vendorinvoiceKeyfieldnamesGet();

  ///
  @Post(path: '/vendorinvoiceexportbatch/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      vendorinvoiceexportbatchBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/vendorinvoiceexportbatch/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      vendorinvoiceexportbatchExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/vendorinvoiceexportbatch/emptyobject')
  Future<chopper.Response> vendorinvoiceexportbatchEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/vendorinvoiceexportbatch/emptybrowseobject')
  Future<chopper.Response> vendorinvoiceexportbatchEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/vendorinvoiceexportbatch/keyfieldnames')
  Future<chopper.Response> vendorinvoiceexportbatchKeyfieldnamesGet();

  ///
  @Post(path: '/vendorinvoiceitem/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      vendorinvoiceitemBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/vendorinvoiceitem/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      vendorinvoiceitemExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/vendorinvoiceitem')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItemLogic>>
      vendorinvoiceitemGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/vendorinvoiceitem')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItem>>
      vendorinvoiceitemPost(
          {@Body()
              required WebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItem?
                  body});

  ///
  ///@param id
  @Get(path: '/vendorinvoiceitem/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItem>>
      vendorinvoiceitemIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/vendorinvoiceitem/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItem>>
      vendorinvoiceitemIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItem?
                  body});

  ///
  ///@param id
  @Delete(path: '/vendorinvoiceitem/{id}')
  Future<chopper.Response<bool>> vendorinvoiceitemIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/vendorinvoiceitem/validateglaccount/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      vendorinvoiceitemValidateglaccountBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/vendorinvoiceitem/validateinventory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      vendorinvoiceitemValidateinventoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/vendorinvoiceitem/emptyobject')
  Future<chopper.Response> vendorinvoiceitemEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/vendorinvoiceitem/emptybrowseobject')
  Future<chopper.Response> vendorinvoiceitemEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/vendorinvoiceitem/keyfieldnames')
  Future<chopper.Response> vendorinvoiceitemKeyfieldnamesGet();

  ///
  @Post(path: '/vendorinvoiceitemcorrespondingdealinvoices/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      vendorinvoiceitemcorrespondingdealinvoicesBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/vendorinvoiceitemcorrespondingdealinvoices/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      vendorinvoiceitemcorrespondingdealinvoicesExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/vendorinvoiceitemcorrespondingdealinvoices/emptyobject')
  Future<chopper.Response>
      vendorinvoiceitemcorrespondingdealinvoicesEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/vendorinvoiceitemcorrespondingdealinvoices/emptybrowseobject')
  Future<chopper.Response>
      vendorinvoiceitemcorrespondingdealinvoicesEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/vendorinvoiceitemcorrespondingdealinvoices/keyfieldnames')
  Future<chopper.Response>
      vendorinvoiceitemcorrespondingdealinvoicesKeyfieldnamesGet();

  ///
  @Post(path: '/vendorinvoicenote/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      vendorinvoicenoteBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/vendorinvoicenote/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      vendorinvoicenoteExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/vendorinvoicenote')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNoteLogic>>
      vendorinvoicenoteGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/vendorinvoicenote')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNote>>
      vendorinvoicenotePost(
          {@Body()
              required WebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNote?
                  body});

  ///
  ///@param id
  @Get(path: '/vendorinvoicenote/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNote>>
      vendorinvoicenoteIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/vendorinvoicenote/{id}')
  Future<
          chopper.Response<
              WebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNote>>
      vendorinvoicenoteIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNote?
                  body});

  ///
  ///@param id
  @Delete(path: '/vendorinvoicenote/{id}')
  Future<chopper.Response<bool>> vendorinvoicenoteIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/vendorinvoicenote/validateuser/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      vendorinvoicenoteValidateuserBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/vendorinvoicenote/emptyobject')
  Future<chopper.Response> vendorinvoicenoteEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/vendorinvoicenote/emptybrowseobject')
  Future<chopper.Response> vendorinvoicenoteEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/vendorinvoicenote/keyfieldnames')
  Future<chopper.Response> vendorinvoicenoteKeyfieldnamesGet();

  ///
  @Post(path: '/vendorinvoicepayment/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      vendorinvoicepaymentBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/vendorinvoicepayment/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      vendorinvoicepaymentExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/vendorinvoicepayment/emptyobject')
  Future<chopper.Response> vendorinvoicepaymentEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/vendorinvoicepayment/emptybrowseobject')
  Future<chopper.Response> vendorinvoicepaymentEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/vendorinvoicepayment/keyfieldnames')
  Future<chopper.Response> vendorinvoicepaymentKeyfieldnamesGet();

  ///
  @Post(path: '/vendorinvoicestatushistory/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      vendorinvoicestatushistoryBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/vendorinvoicestatushistory/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      vendorinvoicestatushistoryExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/vendorinvoicestatushistory/emptyobject')
  Future<chopper.Response> vendorinvoicestatushistoryEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/vendorinvoicestatushistory/emptybrowseobject')
  Future<chopper.Response> vendorinvoicestatushistoryEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/vendorinvoicestatushistory/keyfieldnames')
  Future<chopper.Response> vendorinvoicestatushistoryKeyfieldnamesGet();

  ///
  @Post(path: '/vendornote/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      vendornoteBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  @Post(path: '/vendornote/exportexcelxlsx')
  Future<
          chopper.Response<
              FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult>>
      vendornoteExportexcelxlsxPost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///
  ///@param pageno
  ///@param pagesize
  ///@param sort
  ///@param filter
  @Get(path: '/vendornote')
  Future<
          chopper.Response<
              FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorNoteVendorNoteLogic>>
      vendornoteGet(
          {@Query('pageno') int? pageno,
          @Query('pagesize') int? pagesize,
          @Query('sort') String? sort,
          @Query('filter') List<FwStandardModelsFwQueryFilter>? filter});

  ///
  @Post(path: '/vendornote')
  Future<chopper.Response<WebApiModulesHomeControlsVendorNoteVendorNote>>
      vendornotePost(
          {@Body()
              required WebApiModulesHomeControlsVendorNoteVendorNote? body});

  ///
  ///@param id
  @Get(path: '/vendornote/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsVendorNoteVendorNote>>
      vendornoteIdGet({@Path('id') required String? id});

  ///
  ///@param id
  @Put(path: '/vendornote/{id}')
  Future<chopper.Response<WebApiModulesHomeControlsVendorNoteVendorNote>>
      vendornoteIdPut(
          {@Path('id')
              required String? id,
          @Body()
              required WebApiModulesHomeControlsVendorNoteVendorNote? body});

  ///
  ///@param id
  @Delete(path: '/vendornote/{id}')
  Future<chopper.Response<bool>> vendornoteIdDelete(
      {@Path('id') required String? id});

  ///
  @Post(path: '/vendornote/validatenotesby/browse')
  Future<chopper.Response<FwStandardSqlServerFwJsonDataTable>>
      vendornoteValidatenotesbyBrowsePost(
          {@Body() required FwStandardModelsBrowseRequest? body});

  ///Get an empty object
  @Get(path: '/vendornote/emptyobject')
  Future<chopper.Response> vendornoteEmptyobjectGet();

  ///Get an empty browse object
  @Get(path: '/vendornote/emptybrowseobject')
  Future<chopper.Response> vendornoteEmptybrowseobjectGet();

  ///Get an array of primary key field names
  @Get(path: '/vendornote/keyfieldnames')
  Future<chopper.Response> vendornoteKeyfieldnamesGet();
}

final Map<Type, Object Function(Map<String, dynamic>)> HomeJsonDecoderMappings =
    {
  FwCoreApiSwashbuckleBadRequestResponse:
      FwCoreApiSwashbuckleBadRequestResponse.fromJsonFactory,
  FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult:
      FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
          .fromJsonFactory,
  FwStandardBusinessLogicFwBusinessLogicFieldDefinition:
      FwStandardBusinessLogicFwBusinessLogicFieldDefinition.fromJsonFactory,
  FwStandardDataFwCustomValue: FwStandardDataFwCustomValue.fromJsonFactory,
  FwStandardDataFwDefaultAttribute:
      FwStandardDataFwDefaultAttribute.fromJsonFactory,
  FwStandardGridsAppDocumentAppDocumentGetManyResponse:
      FwStandardGridsAppDocumentAppDocumentGetManyResponse.fromJsonFactory,
  FwStandardGridsAppDocumentDocumentImage:
      FwStandardGridsAppDocumentDocumentImage.fromJsonFactory,
  FwStandardGridsAppDocumentGetDocumentImageResponse:
      FwStandardGridsAppDocumentGetDocumentImageResponse.fromJsonFactory,
  FwStandardGridsAppDocumentGetDocumentThumbnailsResponse:
      FwStandardGridsAppDocumentGetDocumentThumbnailsResponse.fromJsonFactory,
  FwStandardGridsAppDocumentPostDocumentImageRequest:
      FwStandardGridsAppDocumentPostDocumentImageRequest.fromJsonFactory,
  FwStandardGridsAppDocumentPutDocumentFileRequest:
      FwStandardGridsAppDocumentPutDocumentFileRequest.fromJsonFactory,
  FwStandardModelsBrowseRequest: FwStandardModelsBrowseRequest.fromJsonFactory,
  FwStandardModelsCheckBoxListItem:
      FwStandardModelsCheckBoxListItem.fromJsonFactory,
  FwStandardModelsFwApiException:
      FwStandardModelsFwApiException.fromJsonFactory,
  FwStandardModelsFwQueryFilter: FwStandardModelsFwQueryFilter.fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesAgentContactContactLogic:
      FwStandardModelsFwQueryResponseWebApiModulesAgentContactContactLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesAgentCustomerCustomerLogic:
      FwStandardModelsFwQueryResponseWebApiModulesAgentCustomerCustomerLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesAgentDealDealLogic:
      FwStandardModelsFwQueryResponseWebApiModulesAgentDealDealLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesAgentOrderOrderLogic:
      FwStandardModelsFwQueryResponseWebApiModulesAgentOrderOrderLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesAgentProjectProjectLogic:
      FwStandardModelsFwQueryResponseWebApiModulesAgentProjectProjectLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesAgentPurchaseOrderPurchaseOrderLogic:
      FwStandardModelsFwQueryResponseWebApiModulesAgentPurchaseOrderPurchaseOrderLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesAgentQuoteQuoteLogic:
      FwStandardModelsFwQueryResponseWebApiModulesAgentQuoteQuoteLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesAgentVendorVendorLogic:
      FwStandardModelsFwQueryResponseWebApiModulesAgentVendorVendorLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesBillingBankAccountBankAccountLogic:
      FwStandardModelsFwQueryResponseWebApiModulesBillingBankAccountBankAccountLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesBillingBillingWorksheetBillingWorksheetLogic:
      FwStandardModelsFwQueryResponseWebApiModulesBillingBillingWorksheetBillingWorksheetLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesBillingInvoiceInvoiceLogic:
      FwStandardModelsFwQueryResponseWebApiModulesBillingInvoiceInvoiceLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesBillingPaymentPaymentLogic:
      FwStandardModelsFwQueryResponseWebApiModulesBillingPaymentPaymentLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesBillingReceiptReceiptLogic:
      FwStandardModelsFwQueryResponseWebApiModulesBillingReceiptReceiptLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesBillingVendorInvoiceVendorInvoiceLogic:
      FwStandardModelsFwQueryResponseWebApiModulesBillingVendorInvoiceVendorInvoiceLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesContainersContainerContainerLogic:
      FwStandardModelsFwQueryResponseWebApiModulesContainersContainerContainerLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAddressAddressLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAddressAddressLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAlternativeDescriptionAlternativeDescriptionLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAlternativeDescriptionAlternativeDescriptionLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyCompanyLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyCompanyLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyContactCompanyContactLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyContactCompanyContactLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOptionLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOptionLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResaleLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResaleLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContactNoteContactNoteLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContactNoteContactNoteLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContainerWarehouseContainerWarehouseLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContainerWarehouseContainerWarehouseLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCustomerNoteCustomerNoteLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCustomerNoteCustomerNoteLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealNoteDealNoteLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealNoteDealNoteLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealShipperDealShipperLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealShipperDealShipperLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDeliveryDeliveryLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDeliveryDeliveryLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepositPaymentDepositPaymentLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepositPaymentDepositPaymentLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepreciationDepreciationLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepreciationDepreciationLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsGlManualGlManualLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsGlManualGlManualLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValueLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValueLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryColorInventoryColorLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryColorInventoryColorLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompatibleInventoryCompatibleLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompatibleInventoryCompatibleLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKitLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKitLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryConsignorInventoryConsignorLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryConsignorInventoryConsignorLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryContainerItemInventoryContainerItemLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryContainerItemInventoryContainerItemLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTaxLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTaxLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryMaterialInventoryMaterialLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryMaterialInventoryMaterialLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventoryLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventoryLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPrepInventoryPrepLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPrepInventoryPrepLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItemLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItemLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventorySubstituteInventorySubstituteLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventorySubstituteInventorySubstituteLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryVendorInventoryVendorLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryVendorInventoryVendorLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecificLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecificLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatchLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatchLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceItemInvoiceItemLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceItemInvoiceItemLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceNoteInvoiceNoteLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceNoteInvoiceNoteLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceReceiptInvoiceReceiptLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceReceiptInvoiceReceiptLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemAttributeValueItemAttributeValueLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemAttributeValueItemAttributeValueLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemQcItemQcLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemQcItemQcLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsManifestManifestLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsManifestManifestLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderContactOrderContactLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderContactOrderContactLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderItemOrderItemLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderItemOrderItemLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderNoteOrderNoteLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderNoteOrderNoteLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistoryLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistoryLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPersonalEventPersonalEventLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPersonalEventPersonalEventLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventoryLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventoryLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventoryLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventoryLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPickListItemPickListItemLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPickListItemPickListItemLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectContactProjectContactLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectContactProjectContactLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectNoteProjectNoteLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectNoteProjectNoteLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCodeLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCodeLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCodeLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCodeLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItemLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItemLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairCostRepairCostLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairCostRepairCostLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairPartRepairPartLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairPartRepairPartLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairReleaseRepairReleaseLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairReleaseRepairReleaseLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItemLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItemLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNoteLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNoteLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorNoteVendorNoteLogic:
      FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorNoteVendorNoteLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesInventoryAssetItemLogic:
      FwStandardModelsFwQueryResponseWebApiModulesInventoryAssetItemLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesInventoryPartsInventoryPartsInventoryLogic:
      FwStandardModelsFwQueryResponseWebApiModulesInventoryPartsInventoryPartsInventoryLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantityLogic:
      FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantityLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerialLogic:
      FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerialLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptionsLogic:
      FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptionsLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAddedLogic:
      FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAddedLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryLogic:
      FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountLogic:
      FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesInventoryRentalInventoryRentalInventoryLogic:
      FwStandardModelsFwQueryResponseWebApiModulesInventoryRentalInventoryRentalInventoryLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesInventoryRepairRepairLogic:
      FwStandardModelsFwQueryResponseWebApiModulesInventoryRepairRepairLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesInventoryRetiredRetiredLogic:
      FwStandardModelsFwQueryResponseWebApiModulesInventoryRetiredRetiredLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesInventorySalesInventorySalesInventoryLogic:
      FwStandardModelsFwQueryResponseWebApiModulesInventorySalesInventorySalesInventoryLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatusLogic:
      FwStandardModelsFwQueryResponseWebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatusLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesTransfersTransferOrderTransferOrderLogic:
      FwStandardModelsFwQueryResponseWebApiModulesTransfersTransferOrderTransferOrderLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerGridLogic:
      FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerGridLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerItemsGridLogic:
      FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerItemsGridLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesWarehouseContractContractLogic:
      FwStandardModelsFwQueryResponseWebApiModulesWarehouseContractContractLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerGridLogic:
      FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerGridLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerItemsGridLogic:
      FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerItemsGridLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesWarehousePickListPickListLogic:
      FwStandardModelsFwQueryResponseWebApiModulesWarehousePickListPickListLogic
          .fromJsonFactory,
  FwStandardModelsFwQueryResponseWebApiModulesWarehouseQuikReceiptQuikReceiptGridLogic:
      FwStandardModelsFwQueryResponseWebApiModulesWarehouseQuikReceiptQuikReceiptGridLogic
          .fromJsonFactory,
  FwStandardModelsGetResponseFwStandardGridsAppDocumentAppDocumentGetManyResponse:
      FwStandardModelsGetResponseFwStandardGridsAppDocumentAppDocumentGetManyResponse
          .fromJsonFactory,
  FwStandardModelsGetResponseWebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModel:
      FwStandardModelsGetResponseWebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModel
          .fromJsonFactory,
  FwStandardModelsSelectedCheckBoxListItem:
      FwStandardModelsSelectedCheckBoxListItem.fromJsonFactory,
  FwStandardSqlServerFwDateTime: FwStandardSqlServerFwDateTime.fromJsonFactory,
  FwStandardSqlServerFwJsonDataTable:
      FwStandardSqlServerFwJsonDataTable.fromJsonFactory,
  FwStandardSqlServerFwJsonDataTableColumn:
      FwStandardSqlServerFwJsonDataTableColumn.fromJsonFactory,
  MicrosoftAspNetCoreMvcActionResult:
      MicrosoftAspNetCoreMvcActionResult.fromJsonFactory,
  MicrosoftAspNetCoreMvcActionResultWebApiModulesAgentDealDealLogic:
      MicrosoftAspNetCoreMvcActionResultWebApiModulesAgentDealDealLogic
          .fromJsonFactory,
  MicrosoftAspNetCoreMvcActionResultWebApiModulesBillingInvoiceInvoiceLogic:
      MicrosoftAspNetCoreMvcActionResultWebApiModulesBillingInvoiceInvoiceLogic
          .fromJsonFactory,
  MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogic:
      MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogic
          .fromJsonFactory,
  MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsOrderItemOrderItemLogic:
      MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsOrderItemOrderItemLogic
          .fromJsonFactory,
  MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsPricingPricingLogic:
      MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsPricingPricingLogic
          .fromJsonFactory,
  MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItemLogic:
      MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItemLogic
          .fromJsonFactory,
  WebApiApplyBottomLineDaysPerWeekRequest:
      WebApiApplyBottomLineDaysPerWeekRequest.fromJsonFactory,
  WebApiApplyBottomLineDiscountPercentRequest:
      WebApiApplyBottomLineDiscountPercentRequest.fromJsonFactory,
  WebApiApplyBottomLineTotalRequest:
      WebApiApplyBottomLineTotalRequest.fromJsonFactory,
  WebApiLogicSortItemsResponse: WebApiLogicSortItemsResponse.fromJsonFactory,
  WebApiLogicTSpStatusResponse: WebApiLogicTSpStatusResponse.fromJsonFactory,
  WebApiModulesAgentContactContact:
      WebApiModulesAgentContactContact.fromJsonFactory,
  WebApiModulesAgentContactContactDocument:
      WebApiModulesAgentContactContactDocument.fromJsonFactory,
  WebApiModulesAgentContactContactDocumentPostRequest:
      WebApiModulesAgentContactContactDocumentPostRequest.fromJsonFactory,
  WebApiModulesAgentContactContactDocumentPutRequest:
      WebApiModulesAgentContactContactDocumentPutRequest.fromJsonFactory,
  WebApiModulesAgentCustomerCustomer:
      WebApiModulesAgentCustomerCustomer.fromJsonFactory,
  WebApiModulesAgentCustomerCustomerDocument:
      WebApiModulesAgentCustomerCustomerDocument.fromJsonFactory,
  WebApiModulesAgentCustomerCustomerDocumentPostRequest:
      WebApiModulesAgentCustomerCustomerDocumentPostRequest.fromJsonFactory,
  WebApiModulesAgentCustomerCustomerDocumentPutRequest:
      WebApiModulesAgentCustomerCustomerDocumentPutRequest.fromJsonFactory,
  WebApiModulesAgentDealCopyContactsFromCustomerResponse:
      WebApiModulesAgentDealCopyContactsFromCustomerResponse.fromJsonFactory,
  WebApiModulesAgentDealDeal: WebApiModulesAgentDealDeal.fromJsonFactory,
  WebApiModulesAgentDealDealDocument:
      WebApiModulesAgentDealDealDocument.fromJsonFactory,
  WebApiModulesAgentDealDealDocumentPostRequest:
      WebApiModulesAgentDealDealDocumentPostRequest.fromJsonFactory,
  WebApiModulesAgentDealDealDocumentPutRequest:
      WebApiModulesAgentDealDealDocumentPutRequest.fromJsonFactory,
  WebApiModulesAgentOrderCancelUncancelQuoteResponse:
      WebApiModulesAgentOrderCancelUncancelQuoteResponse.fromJsonFactory,
  WebApiModulesAgentOrderChangeOrderOfficeLocationRequest:
      WebApiModulesAgentOrderChangeOrderOfficeLocationRequest.fromJsonFactory,
  WebApiModulesAgentOrderChangeOrderOfficeLocationResponse:
      WebApiModulesAgentOrderChangeOrderOfficeLocationResponse.fromJsonFactory,
  WebApiModulesAgentOrderCompletePoWorksheetSessionRequest:
      WebApiModulesAgentOrderCompletePoWorksheetSessionRequest.fromJsonFactory,
  WebApiModulesAgentOrderCompletePoWorksheetSessionResponse:
      WebApiModulesAgentOrderCompletePoWorksheetSessionResponse.fromJsonFactory,
  WebApiModulesAgentOrderCopyOrderItemsRequest:
      WebApiModulesAgentOrderCopyOrderItemsRequest.fromJsonFactory,
  WebApiModulesAgentOrderCopyOrderItemsResponse:
      WebApiModulesAgentOrderCopyOrderItemsResponse.fromJsonFactory,
  WebApiModulesAgentOrderCopyQuoteOrderRequest:
      WebApiModulesAgentOrderCopyQuoteOrderRequest.fromJsonFactory,
  WebApiModulesAgentOrderCopyQuoteOrderResponse:
      WebApiModulesAgentOrderCopyQuoteOrderResponse.fromJsonFactory,
  WebApiModulesAgentOrderCopyTemplateRequest:
      WebApiModulesAgentOrderCopyTemplateRequest.fromJsonFactory,
  WebApiModulesAgentOrderCopyTemplateResponse:
      WebApiModulesAgentOrderCopyTemplateResponse.fromJsonFactory,
  WebApiModulesAgentOrderCreatePoWorksheetSessionRequest:
      WebApiModulesAgentOrderCreatePoWorksheetSessionRequest.fromJsonFactory,
  WebApiModulesAgentOrderCreatePoWorksheetSessionResponse:
      WebApiModulesAgentOrderCreatePoWorksheetSessionResponse.fromJsonFactory,
  WebApiModulesAgentOrderCustomRates:
      WebApiModulesAgentOrderCustomRates.fromJsonFactory,
  WebApiModulesAgentOrderGetCustomRatesRequest:
      WebApiModulesAgentOrderGetCustomRatesRequest.fromJsonFactory,
  WebApiModulesAgentOrderGetCustomRatesResponse:
      WebApiModulesAgentOrderGetCustomRatesResponse.fromJsonFactory,
  WebApiModulesAgentOrderGetOrderResponse:
      WebApiModulesAgentOrderGetOrderResponse.fromJsonFactory,
  WebApiModulesAgentOrderModifyPoWorksheetSessionRequest:
      WebApiModulesAgentOrderModifyPoWorksheetSessionRequest.fromJsonFactory,
  WebApiModulesAgentOrderModifyPoWorksheetSessionResponse:
      WebApiModulesAgentOrderModifyPoWorksheetSessionResponse.fromJsonFactory,
  WebApiModulesAgentOrderOrder: WebApiModulesAgentOrderOrder.fromJsonFactory,
  WebApiModulesAgentOrderOrderBase:
      WebApiModulesAgentOrderOrderBase.fromJsonFactory,
  WebApiModulesAgentOrderOrderDocument:
      WebApiModulesAgentOrderOrderDocument.fromJsonFactory,
  WebApiModulesAgentOrderOrderDocumentPostRequest:
      WebApiModulesAgentOrderOrderDocumentPostRequest.fromJsonFactory,
  WebApiModulesAgentOrderOrderDocumentPutRequest:
      WebApiModulesAgentOrderOrderDocumentPutRequest.fromJsonFactory,
  WebApiModulesAgentOrderOrderMessage:
      WebApiModulesAgentOrderOrderMessage.fromJsonFactory,
  WebApiModulesAgentOrderOrderMessagesResponse:
      WebApiModulesAgentOrderOrderMessagesResponse.fromJsonFactory,
  WebApiModulesAgentOrderPoWorksheetSessionTotalsResponse:
      WebApiModulesAgentOrderPoWorksheetSessionTotalsResponse.fromJsonFactory,
  WebApiModulesAgentOrderQuoteNewVersionResponse:
      WebApiModulesAgentOrderQuoteNewVersionResponse.fromJsonFactory,
  WebApiModulesAgentOrderQuoteToOrderRequest:
      WebApiModulesAgentOrderQuoteToOrderRequest.fromJsonFactory,
  WebApiModulesAgentOrderQuoteToOrderResponse:
      WebApiModulesAgentOrderQuoteToOrderResponse.fromJsonFactory,
  WebApiModulesAgentOrderReserveUnreserveQuoteResponse:
      WebApiModulesAgentOrderReserveUnreserveQuoteResponse.fromJsonFactory,
  WebApiModulesAgentOrderUpdatePoWorksheetSessionRequest:
      WebApiModulesAgentOrderUpdatePoWorksheetSessionRequest.fromJsonFactory,
  WebApiModulesAgentOrderUpdatePoWorksheetSessionResponse:
      WebApiModulesAgentOrderUpdatePoWorksheetSessionResponse.fromJsonFactory,
  WebApiModulesAgentProjectCreateQuoteFromProjectRequest:
      WebApiModulesAgentProjectCreateQuoteFromProjectRequest.fromJsonFactory,
  WebApiModulesAgentProjectCreateQuoteFromProjectResponse:
      WebApiModulesAgentProjectCreateQuoteFromProjectResponse.fromJsonFactory,
  WebApiModulesAgentProjectProject:
      WebApiModulesAgentProjectProject.fromJsonFactory,
  WebApiModulesAgentProjectProjectDocument:
      WebApiModulesAgentProjectProjectDocument.fromJsonFactory,
  WebApiModulesAgentProjectProjectDocumentPostRequest:
      WebApiModulesAgentProjectProjectDocumentPostRequest.fromJsonFactory,
  WebApiModulesAgentProjectProjectDocumentPutRequest:
      WebApiModulesAgentProjectProjectDocumentPutRequest.fromJsonFactory,
  WebApiModulesAgentPurchaseOrderCompleteReceiveContractRequest:
      WebApiModulesAgentPurchaseOrderCompleteReceiveContractRequest
          .fromJsonFactory,
  WebApiModulesAgentPurchaseOrderConfirmDropShipRequest:
      WebApiModulesAgentPurchaseOrderConfirmDropShipRequest.fromJsonFactory,
  WebApiModulesAgentPurchaseOrderConfirmDropShipResponse:
      WebApiModulesAgentPurchaseOrderConfirmDropShipResponse.fromJsonFactory,
  WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveRequest:
      WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveRequest
          .fromJsonFactory,
  WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveResponse:
      WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveResponse
          .fromJsonFactory,
  WebApiModulesAgentPurchaseOrderCopyPurchaseOrderRequest:
      WebApiModulesAgentPurchaseOrderCopyPurchaseOrderRequest.fromJsonFactory,
  WebApiModulesAgentPurchaseOrderCopyPurchaseOrderResponse:
      WebApiModulesAgentPurchaseOrderCopyPurchaseOrderResponse.fromJsonFactory,
  WebApiModulesAgentPurchaseOrderGetPurchaseOrderResponse:
      WebApiModulesAgentPurchaseOrderGetPurchaseOrderResponse.fromJsonFactory,
  WebApiModulesAgentPurchaseOrderNextVendorInvoiceDefaultDatesResponse:
      WebApiModulesAgentPurchaseOrderNextVendorInvoiceDefaultDatesResponse
          .fromJsonFactory,
  WebApiModulesAgentPurchaseOrderPurchaseOrder:
      WebApiModulesAgentPurchaseOrderPurchaseOrder.fromJsonFactory,
  WebApiModulesAgentPurchaseOrderPurchaseOrderDocument:
      WebApiModulesAgentPurchaseOrderPurchaseOrderDocument.fromJsonFactory,
  WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPostRequest:
      WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPostRequest
          .fromJsonFactory,
  WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPutRequest:
      WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPutRequest
          .fromJsonFactory,
  WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesRequest:
      WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesRequest
          .fromJsonFactory,
  WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesResponse:
      WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesResponse
          .fromJsonFactory,
  WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsRequest:
      WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsRequest
          .fromJsonFactory,
  WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsResponse:
      WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsResponse
          .fromJsonFactory,
  WebApiModulesAgentPurchaseOrderReceiveContractRequest:
      WebApiModulesAgentPurchaseOrderReceiveContractRequest.fromJsonFactory,
  WebApiModulesAgentPurchaseOrderReceiveContractResponse:
      WebApiModulesAgentPurchaseOrderReceiveContractResponse.fromJsonFactory,
  WebApiModulesAgentPurchaseOrderReceiveItemRequest:
      WebApiModulesAgentPurchaseOrderReceiveItemRequest.fromJsonFactory,
  WebApiModulesAgentPurchaseOrderReceiveItemResponse:
      WebApiModulesAgentPurchaseOrderReceiveItemResponse.fromJsonFactory,
  WebApiModulesAgentPurchaseOrderReturnContractRequest:
      WebApiModulesAgentPurchaseOrderReturnContractRequest.fromJsonFactory,
  WebApiModulesAgentPurchaseOrderReturnContractResponse:
      WebApiModulesAgentPurchaseOrderReturnContractResponse.fromJsonFactory,
  WebApiModulesAgentPurchaseOrderReturnItemRequest:
      WebApiModulesAgentPurchaseOrderReturnItemRequest.fromJsonFactory,
  WebApiModulesAgentPurchaseOrderReturnItemResponse:
      WebApiModulesAgentPurchaseOrderReturnItemResponse.fromJsonFactory,
  WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemRequest:
      WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemRequest
          .fromJsonFactory,
  WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemResponse:
      WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemResponse
          .fromJsonFactory,
  WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemRequest:
      WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemRequest
          .fromJsonFactory,
  WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemResponse:
      WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemResponse
          .fromJsonFactory,
  WebApiModulesAgentQuoteQuote: WebApiModulesAgentQuoteQuote.fromJsonFactory,
  WebApiModulesAgentQuoteQuoteDocument:
      WebApiModulesAgentQuoteQuoteDocument.fromJsonFactory,
  WebApiModulesAgentQuoteQuoteDocumentPostRequest:
      WebApiModulesAgentQuoteQuoteDocumentPostRequest.fromJsonFactory,
  WebApiModulesAgentQuoteQuoteDocumentPutRequest:
      WebApiModulesAgentQuoteQuoteDocumentPutRequest.fromJsonFactory,
  WebApiModulesAgentVendorVendor:
      WebApiModulesAgentVendorVendor.fromJsonFactory,
  WebApiModulesAgentVendorVendorDocument:
      WebApiModulesAgentVendorVendorDocument.fromJsonFactory,
  WebApiModulesAgentVendorVendorDocumentPostRequest:
      WebApiModulesAgentVendorVendorDocumentPostRequest.fromJsonFactory,
  WebApiModulesAgentVendorVendorDocumentPutRequest:
      WebApiModulesAgentVendorVendorDocumentPutRequest.fromJsonFactory,
  WebApiModulesBillingBankAccountBankAccount:
      WebApiModulesBillingBankAccountBankAccount.fromJsonFactory,
  WebApiModulesBillingBillingBilling:
      WebApiModulesBillingBillingBilling.fromJsonFactory,
  WebApiModulesBillingBillingCreateInvoiceEstimateRequest:
      WebApiModulesBillingBillingCreateInvoiceEstimateRequest.fromJsonFactory,
  WebApiModulesBillingBillingCreateInvoiceEstimateResponse:
      WebApiModulesBillingBillingCreateInvoiceEstimateResponse.fromJsonFactory,
  WebApiModulesBillingBillingCreateInvoicesRequest:
      WebApiModulesBillingBillingCreateInvoicesRequest.fromJsonFactory,
  WebApiModulesBillingBillingCreateInvoicesResponse:
      WebApiModulesBillingBillingCreateInvoicesResponse.fromJsonFactory,
  WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesRequest:
      WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesRequest
          .fromJsonFactory,
  WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesResponse:
      WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesResponse
          .fromJsonFactory,
  WebApiModulesBillingBillingGetOrderBillingDatesResponse:
      WebApiModulesBillingBillingGetOrderBillingDatesResponse.fromJsonFactory,
  WebApiModulesBillingBillingPopulateBillingRequest:
      WebApiModulesBillingBillingPopulateBillingRequest.fromJsonFactory,
  WebApiModulesBillingBillingPopulateBillingResponse:
      WebApiModulesBillingBillingPopulateBillingResponse.fromJsonFactory,
  WebApiModulesBillingBillingUpdateBillingWorksheetRequest:
      WebApiModulesBillingBillingUpdateBillingWorksheetRequest.fromJsonFactory,
  WebApiModulesBillingBillingUpdateBillingWorksheetResponse:
      WebApiModulesBillingBillingUpdateBillingWorksheetResponse.fromJsonFactory,
  WebApiModulesBillingBillingWorksheetBillingWorksheet:
      WebApiModulesBillingBillingWorksheetBillingWorksheet.fromJsonFactory,
  WebApiModulesBillingInvoiceCreditInvoiceReponse:
      WebApiModulesBillingInvoiceCreditInvoiceReponse.fromJsonFactory,
  WebApiModulesBillingInvoiceCreditInvoiceRequest:
      WebApiModulesBillingInvoiceCreditInvoiceRequest.fromJsonFactory,
  WebApiModulesBillingInvoiceInvoice:
      WebApiModulesBillingInvoiceInvoice.fromJsonFactory,
  WebApiModulesBillingInvoiceToggleInvoiceApprovedResponse:
      WebApiModulesBillingInvoiceToggleInvoiceApprovedResponse.fromJsonFactory,
  WebApiModulesBillingPaymentPayment:
      WebApiModulesBillingPaymentPayment.fromJsonFactory,
  WebApiModulesBillingPaymentPaymentVendorInvoice:
      WebApiModulesBillingPaymentPaymentVendorInvoice.fromJsonFactory,
  WebApiModulesBillingReceiptAddDepletingDepositRequest:
      WebApiModulesBillingReceiptAddDepletingDepositRequest.fromJsonFactory,
  WebApiModulesBillingReceiptCreditCardDepletingDepositRequest:
      WebApiModulesBillingReceiptCreditCardDepletingDepositRequest
          .fromJsonFactory,
  WebApiModulesBillingReceiptCreditCardRefundRequest:
      WebApiModulesBillingReceiptCreditCardRefundRequest.fromJsonFactory,
  WebApiModulesBillingReceiptReceipt:
      WebApiModulesBillingReceiptReceipt.fromJsonFactory,
  WebApiModulesBillingReceiptReceiptCredit:
      WebApiModulesBillingReceiptReceiptCredit.fromJsonFactory,
  WebApiModulesBillingReceiptReceiptInvoice:
      WebApiModulesBillingReceiptReceiptInvoice.fromJsonFactory,
  WebApiModulesBillingReceiptRemainingDepositAmountsResponse:
      WebApiModulesBillingReceiptRemainingDepositAmountsResponse
          .fromJsonFactory,
  WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedRequest:
      WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedRequest
          .fromJsonFactory,
  WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedResponse:
      WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedResponse
          .fromJsonFactory,
  WebApiModulesBillingVendorInvoiceVendorInvoice:
      WebApiModulesBillingVendorInvoiceVendorInvoice.fromJsonFactory,
  WebApiModulesContainersContainerContainer:
      WebApiModulesContainersContainerContainer.fromJsonFactory,
  WebApiModulesHomeControlsAddressAddress:
      WebApiModulesHomeControlsAddressAddress.fromJsonFactory,
  WebApiModulesHomeControlsAlternativeDescriptionAlternativeDescription:
      WebApiModulesHomeControlsAlternativeDescriptionAlternativeDescription
          .fromJsonFactory,
  WebApiModulesHomeControlsCompanyCompany:
      WebApiModulesHomeControlsCompanyCompany.fromJsonFactory,
  WebApiModulesHomeControlsCompanyContactCompanyContact:
      WebApiModulesHomeControlsCompanyContactCompanyContact.fromJsonFactory,
  WebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOption:
      WebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOption.fromJsonFactory,
  WebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResale:
      WebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResale.fromJsonFactory,
  WebApiModulesHomeControlsContactNoteContactNote:
      WebApiModulesHomeControlsContactNoteContactNote.fromJsonFactory,
  WebApiModulesHomeControlsContainerItemContainerItem:
      WebApiModulesHomeControlsContainerItemContainerItem.fromJsonFactory,
  WebApiModulesHomeControlsContainerItemEmptyContainerItemResponse:
      WebApiModulesHomeControlsContainerItemEmptyContainerItemResponse
          .fromJsonFactory,
  WebApiModulesHomeControlsContainerItemEmptyContainerRequest:
      WebApiModulesHomeControlsContainerItemEmptyContainerRequest
          .fromJsonFactory,
  WebApiModulesHomeControlsContainerItemInstantiateContainerItemResponse:
      WebApiModulesHomeControlsContainerItemInstantiateContainerItemResponse
          .fromJsonFactory,
  WebApiModulesHomeControlsContainerItemInstantiateContainerRequest:
      WebApiModulesHomeControlsContainerItemInstantiateContainerRequest
          .fromJsonFactory,
  WebApiModulesHomeControlsContainerItemRemoveFromContainerRequest:
      WebApiModulesHomeControlsContainerItemRemoveFromContainerRequest
          .fromJsonFactory,
  WebApiModulesHomeControlsContainerItemRemoveFromContainerResponse:
      WebApiModulesHomeControlsContainerItemRemoveFromContainerResponse
          .fromJsonFactory,
  WebApiModulesHomeControlsContainerWarehouseContainerWarehouse:
      WebApiModulesHomeControlsContainerWarehouseContainerWarehouse
          .fromJsonFactory,
  WebApiModulesHomeControlsContractItemDetailContractItem:
      WebApiModulesHomeControlsContractItemDetailContractItem.fromJsonFactory,
  WebApiModulesHomeControlsContractItemDetailContractItemDetail:
      WebApiModulesHomeControlsContractItemDetailContractItemDetail
          .fromJsonFactory,
  WebApiModulesHomeControlsContractItemDetailVoidItemsRequest:
      WebApiModulesHomeControlsContractItemDetailVoidItemsRequest
          .fromJsonFactory,
  WebApiModulesHomeControlsContractItemDetailVoidItemsResponse:
      WebApiModulesHomeControlsContractItemDetailVoidItemsResponse
          .fromJsonFactory,
  WebApiModulesHomeControlsCustomerNoteCustomerNote:
      WebApiModulesHomeControlsCustomerNoteCustomerNote.fromJsonFactory,
  WebApiModulesHomeControlsDealNoteDealNote:
      WebApiModulesHomeControlsDealNoteDealNote.fromJsonFactory,
  WebApiModulesHomeControlsDealOrderDealOrderRecordOrderOnHoldResponse:
      WebApiModulesHomeControlsDealOrderDealOrderRecordOrderOnHoldResponse
          .fromJsonFactory,
  WebApiModulesHomeControlsDealShipperDealShipper:
      WebApiModulesHomeControlsDealShipperDealShipper.fromJsonFactory,
  WebApiModulesHomeControlsDeliveryDelivery:
      WebApiModulesHomeControlsDeliveryDelivery.fromJsonFactory,
  WebApiModulesHomeControlsDepositPaymentDepositPayment:
      WebApiModulesHomeControlsDepositPaymentDepositPayment.fromJsonFactory,
  WebApiModulesHomeControlsDepreciationDepreciation:
      WebApiModulesHomeControlsDepreciationDepreciation.fromJsonFactory,
  WebApiModulesHomeControlsGeneralItemSortGeneralItemRequest:
      WebApiModulesHomeControlsGeneralItemSortGeneralItemRequest
          .fromJsonFactory,
  WebApiModulesHomeControlsGlManualGlManual:
      WebApiModulesHomeControlsGlManualGlManual.fromJsonFactory,
  WebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValue:
      WebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValue
          .fromJsonFactory,
  WebApiModulesHomeControlsInventoryAvailabilityAvailabilityCalendarAndScheduleRequest:
      WebApiModulesHomeControlsInventoryAvailabilityAvailabilityCalendarAndScheduleRequest
          .fromJsonFactory,
  WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictRequest:
      WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictRequest
          .fromJsonFactory,
  WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictResponseItem:
      WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictResponseItem
          .fromJsonFactory,
  WebApiModulesHomeControlsInventoryAvailabilityAvailabilityInventoryWarehouseRequest:
      WebApiModulesHomeControlsInventoryAvailabilityAvailabilityInventoryWarehouseRequest
          .fromJsonFactory,
  WebApiModulesHomeControlsInventoryAvailabilityAvailabilityOtherWarehouse:
      WebApiModulesHomeControlsInventoryAvailabilityAvailabilityOtherWarehouse
          .fromJsonFactory,
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarAndScheduleResponse:
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarAndScheduleResponse
          .fromJsonFactory,
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarDate:
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarDate
          .fromJsonFactory,
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarEvent:
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarEvent
          .fromJsonFactory,
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleEvent:
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleEvent
          .fromJsonFactory,
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleResource:
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleResource
          .fromJsonFactory,
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouse:
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouse
          .fromJsonFactory,
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailability:
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailability
          .fromJsonFactory,
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityDateTime:
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityDateTime
          .fromJsonFactory,
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity:
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity
          .fromJsonFactory,
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityReservation:
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityReservation
          .fromJsonFactory,
  WebApiModulesHomeControlsInventoryAvailabilityTPackageAccessory:
      WebApiModulesHomeControlsInventoryAvailabilityTPackageAccessory
          .fromJsonFactory,
  WebApiModulesHomeControlsInventoryColorInventoryColor:
      WebApiModulesHomeControlsInventoryColorInventoryColor.fromJsonFactory,
  WebApiModulesHomeControlsInventoryCompatibleInventoryCompatible:
      WebApiModulesHomeControlsInventoryCompatibleInventoryCompatible
          .fromJsonFactory,
  WebApiModulesHomeControlsInventoryCompleteKitCreateCompleteResponse:
      WebApiModulesHomeControlsInventoryCompleteKitCreateCompleteResponse
          .fromJsonFactory,
  WebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKit:
      WebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKit
          .fromJsonFactory,
  WebApiModulesHomeControlsInventoryConsignorInventoryConsignor:
      WebApiModulesHomeControlsInventoryConsignorInventoryConsignor
          .fromJsonFactory,
  WebApiModulesHomeControlsInventoryContainerItemInventoryContainerItem:
      WebApiModulesHomeControlsInventoryContainerItemInventoryContainerItem
          .fromJsonFactory,
  WebApiModulesHomeControlsInventoryContainerItemSortContainerItemsRequest:
      WebApiModulesHomeControlsInventoryContainerItemSortContainerItemsRequest
          .fromJsonFactory,
  WebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTax:
      WebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTax
          .fromJsonFactory,
  WebApiModulesHomeControlsInventoryMaterialInventoryMaterial:
      WebApiModulesHomeControlsInventoryMaterialInventoryMaterial
          .fromJsonFactory,
  WebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventory:
      WebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventory
          .fromJsonFactory,
  WebApiModulesHomeControlsInventoryPackageInventorySortInventoryPackageInventorysRequest:
      WebApiModulesHomeControlsInventoryPackageInventorySortInventoryPackageInventorysRequest
          .fromJsonFactory,
  WebApiModulesHomeControlsInventoryPrepInventoryPrep:
      WebApiModulesHomeControlsInventoryPrepInventoryPrep.fromJsonFactory,
  WebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItem:
      WebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItem
          .fromJsonFactory,
  WebApiModulesHomeControlsInventorySearchInventorySearch:
      WebApiModulesHomeControlsInventorySearchInventorySearch.fromJsonFactory,
  WebApiModulesHomeControlsInventorySearchInventorySearchAccessoriesRequest:
      WebApiModulesHomeControlsInventorySearchInventorySearchAccessoriesRequest
          .fromJsonFactory,
  WebApiModulesHomeControlsInventorySearchInventorySearchAddToCompleteKitContainerRequest:
      WebApiModulesHomeControlsInventorySearchInventorySearchAddToCompleteKitContainerRequest
          .fromJsonFactory,
  WebApiModulesHomeControlsInventorySearchInventorySearchAddToOrderRequest:
      WebApiModulesHomeControlsInventorySearchInventorySearchAddToOrderRequest
          .fromJsonFactory,
  WebApiModulesHomeControlsInventorySearchInventorySearchGetTotalResponse:
      WebApiModulesHomeControlsInventorySearchInventorySearchGetTotalResponse
          .fromJsonFactory,
  WebApiModulesHomeControlsInventorySearchInventorySearchRequest:
      WebApiModulesHomeControlsInventorySearchInventorySearchRequest
          .fromJsonFactory,
  WebApiModulesHomeControlsInventorySearchInventorySearchSaveNoteRequest:
      WebApiModulesHomeControlsInventorySearchInventorySearchSaveNoteRequest
          .fromJsonFactory,
  WebApiModulesHomeControlsInventorySearchPreviewInventorySearchPreview:
      WebApiModulesHomeControlsInventorySearchPreviewInventorySearchPreview
          .fromJsonFactory,
  WebApiModulesHomeControlsInventorySubstituteInventorySubstitute:
      WebApiModulesHomeControlsInventorySubstituteInventorySubstitute
          .fromJsonFactory,
  WebApiModulesHomeControlsInventoryVendorInventoryVendor:
      WebApiModulesHomeControlsInventoryVendorInventoryVendor.fromJsonFactory,
  WebApiModulesHomeControlsInventoryWarehouseInventoryWarehouse:
      WebApiModulesHomeControlsInventoryWarehouseInventoryWarehouse
          .fromJsonFactory,
  WebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecific:
      WebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecific
          .fromJsonFactory,
  WebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatch:
      WebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatch
          .fromJsonFactory,
  WebApiModulesHomeControlsInvoiceItemInvoiceItem:
      WebApiModulesHomeControlsInvoiceItemInvoiceItem.fromJsonFactory,
  WebApiModulesHomeControlsInvoiceNoteInvoiceNote:
      WebApiModulesHomeControlsInvoiceNoteInvoiceNote.fromJsonFactory,
  WebApiModulesHomeControlsInvoiceReceiptInvoiceReceipt:
      WebApiModulesHomeControlsInvoiceReceiptInvoiceReceipt.fromJsonFactory,
  WebApiModulesHomeControlsItemAttributeValueItemAttributeValue:
      WebApiModulesHomeControlsItemAttributeValueItemAttributeValue
          .fromJsonFactory,
  WebApiModulesHomeControlsItemQcItemQc:
      WebApiModulesHomeControlsItemQcItemQc.fromJsonFactory,
  WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionRequest:
      WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionRequest
          .fromJsonFactory,
  WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionResponse:
      WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionResponse
          .fromJsonFactory,
  WebApiModulesHomeControlsLossAndDamageCreateLossAndDamageOrderFromRepairResponse:
      WebApiModulesHomeControlsLossAndDamageCreateLossAndDamageOrderFromRepairResponse
          .fromJsonFactory,
  WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemRequest:
      WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemRequest
          .fromJsonFactory,
  WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemResponse:
      WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemResponse
          .fromJsonFactory,
  WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemRequest:
      WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemRequest
          .fromJsonFactory,
  WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemResponse:
      WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemResponse
          .fromJsonFactory,
  WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionRequest:
      WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionRequest
          .fromJsonFactory,
  WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionResponse:
      WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionResponse
          .fromJsonFactory,
  WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemRequest:
      WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemRequest
          .fromJsonFactory,
  WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemResponse:
      WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemResponse
          .fromJsonFactory,
  WebApiModulesHomeControlsManifestManifest:
      WebApiModulesHomeControlsManifestManifest.fromJsonFactory,
  WebApiModulesHomeControlsOrderContactOrderContact:
      WebApiModulesHomeControlsOrderContactOrderContact.fromJsonFactory,
  WebApiModulesHomeControlsOrderDatesOrderDates:
      WebApiModulesHomeControlsOrderDatesOrderDates.fromJsonFactory,
  WebApiModulesHomeControlsOrderItemCompleteKitOption:
      WebApiModulesHomeControlsOrderItemCompleteKitOption.fromJsonFactory,
  WebApiModulesHomeControlsOrderItemInsertLineItemRequest:
      WebApiModulesHomeControlsOrderItemInsertLineItemRequest.fromJsonFactory,
  WebApiModulesHomeControlsOrderItemInsertOptionRequest:
      WebApiModulesHomeControlsOrderItemInsertOptionRequest.fromJsonFactory,
  WebApiModulesHomeControlsOrderItemOrderItem:
      WebApiModulesHomeControlsOrderItemOrderItem.fromJsonFactory,
  WebApiModulesHomeControlsOrderItemSortOrderItemsRequest:
      WebApiModulesHomeControlsOrderItemSortOrderItemsRequest.fromJsonFactory,
  WebApiModulesHomeControlsOrderItemSplitOrderItemRequest:
      WebApiModulesHomeControlsOrderItemSplitOrderItemRequest.fromJsonFactory,
  WebApiModulesHomeControlsOrderItemSplitOrderItemResponse:
      WebApiModulesHomeControlsOrderItemSplitOrderItemResponse.fromJsonFactory,
  WebApiModulesHomeControlsOrderNoteOrderNote:
      WebApiModulesHomeControlsOrderNoteOrderNote.fromJsonFactory,
  WebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistory:
      WebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistory
          .fromJsonFactory,
  WebApiModulesHomeControlsOrderStatusSummaryOrderStatusSummary:
      WebApiModulesHomeControlsOrderStatusSummaryOrderStatusSummary
          .fromJsonFactory,
  WebApiModulesHomeControlsOrderSummaryOrderSummary:
      WebApiModulesHomeControlsOrderSummaryOrderSummary.fromJsonFactory,
  WebApiModulesHomeControlsPersonalEventPersonalEvent:
      WebApiModulesHomeControlsPersonalEventPersonalEvent.fromJsonFactory,
  WebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventory:
      WebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventory
          .fromJsonFactory,
  WebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventory:
      WebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventory
          .fromJsonFactory,
  WebApiModulesHomeControlsPickListItemPickListItem:
      WebApiModulesHomeControlsPickListItemPickListItem.fromJsonFactory,
  WebApiModulesHomeControlsPickListUtilityItemApplyPickListSessionItemsRequest:
      WebApiModulesHomeControlsPickListUtilityItemApplyPickListSessionItemsRequest
          .fromJsonFactory,
  WebApiModulesHomeControlsPickListUtilityItemCompleteSessionRequest:
      WebApiModulesHomeControlsPickListUtilityItemCompleteSessionRequest
          .fromJsonFactory,
  WebApiModulesHomeControlsPickListUtilityItemCompleteSessionResponse:
      WebApiModulesHomeControlsPickListUtilityItemCompleteSessionResponse
          .fromJsonFactory,
  WebApiModulesHomeControlsPickListUtilityItemPickListUtilityItem:
      WebApiModulesHomeControlsPickListUtilityItemPickListUtilityItem
          .fromJsonFactory,
  WebApiModulesHomeControlsPickListUtilityItemStartSessionRequest:
      WebApiModulesHomeControlsPickListUtilityItemStartSessionRequest
          .fromJsonFactory,
  WebApiModulesHomeControlsPickListUtilityItemStartSessionResponse:
      WebApiModulesHomeControlsPickListUtilityItemStartSessionResponse
          .fromJsonFactory,
  WebApiModulesHomeControlsPricingPricing:
      WebApiModulesHomeControlsPricingPricing.fromJsonFactory,
  WebApiModulesHomeControlsProjectContactProjectContact:
      WebApiModulesHomeControlsProjectContactProjectContact.fromJsonFactory,
  WebApiModulesHomeControlsProjectNoteProjectNote:
      WebApiModulesHomeControlsProjectNoteProjectNote.fromJsonFactory,
  WebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCode:
      WebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCode
          .fromJsonFactory,
  WebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCode:
      WebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCode
          .fromJsonFactory,
  WebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItem:
      WebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItem
          .fromJsonFactory,
  WebApiModulesHomeControlsRepairCostRepairCost:
      WebApiModulesHomeControlsRepairCostRepairCost.fromJsonFactory,
  WebApiModulesHomeControlsRepairPartRepairPart:
      WebApiModulesHomeControlsRepairPartRepairPart.fromJsonFactory,
  WebApiModulesHomeControlsRepairReleaseRepairRelease:
      WebApiModulesHomeControlsRepairReleaseRepairRelease.fromJsonFactory,
  WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionRequest:
      WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionRequest
          .fromJsonFactory,
  WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionResponse:
      WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionResponse
          .fromJsonFactory,
  WebApiModulesHomeControlsServiceOrderItemCreateServiceOrderFromRepairResponse:
      WebApiModulesHomeControlsServiceOrderItemCreateServiceOrderFromRepairResponse
          .fromJsonFactory,
  WebApiModulesHomeControlsServiceOrderItemServiceOrderItem:
      WebApiModulesHomeControlsServiceOrderItemServiceOrderItem.fromJsonFactory,
  WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionRequest:
      WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionRequest
          .fromJsonFactory,
  WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionResponse:
      WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionResponse
          .fromJsonFactory,
  WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemRequest:
      WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemRequest
          .fromJsonFactory,
  WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemResponse:
      WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemResponse
          .fromJsonFactory,
  WebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItem:
      WebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItem
          .fromJsonFactory,
  WebApiModulesHomeControlsSuspendedSessionSuspendedSession:
      WebApiModulesHomeControlsSuspendedSessionSuspendedSession.fromJsonFactory,
  WebApiModulesHomeControlsTaxableTaxable:
      WebApiModulesHomeControlsTaxableTaxable.fromJsonFactory,
  WebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItem:
      WebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItem
          .fromJsonFactory,
  WebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNote:
      WebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNote
          .fromJsonFactory,
  WebApiModulesHomeControlsVendorNoteVendorNote:
      WebApiModulesHomeControlsVendorNoteVendorNote.fromJsonFactory,
  WebApiModulesInventoryAssetAssetDocument:
      WebApiModulesInventoryAssetAssetDocument.fromJsonFactory,
  WebApiModulesInventoryAssetAssetDocumentPostRequest:
      WebApiModulesInventoryAssetAssetDocumentPostRequest.fromJsonFactory,
  WebApiModulesInventoryAssetAssetDocumentPutRequest:
      WebApiModulesInventoryAssetAssetDocumentPutRequest.fromJsonFactory,
  WebApiModulesInventoryAssetItem:
      WebApiModulesInventoryAssetItem.fromJsonFactory,
  WebApiModulesInventoryAssetItemByBarCodeResponse:
      WebApiModulesInventoryAssetItemByBarCodeResponse.fromJsonFactory,
  WebApiModulesInventoryCompleteQcCompleteQcItemRequest:
      WebApiModulesInventoryCompleteQcCompleteQcItemRequest.fromJsonFactory,
  WebApiModulesInventoryCompleteQcCompleteQcItemResponse:
      WebApiModulesInventoryCompleteQcCompleteQcItemResponse.fromJsonFactory,
  WebApiModulesInventoryCompleteQcUpdateQcItemRequest:
      WebApiModulesInventoryCompleteQcUpdateQcItemRequest.fromJsonFactory,
  WebApiModulesInventoryCompleteQcUpdateQcItemResponse:
      WebApiModulesInventoryCompleteQcUpdateQcItemResponse.fromJsonFactory,
  WebApiModulesInventoryInventoryCopyInventoryRequest:
      WebApiModulesInventoryInventoryCopyInventoryRequest.fromJsonFactory,
  WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageRequest:
      WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageRequest
          .fromJsonFactory,
  WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageResponse:
      WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageResponse
          .fromJsonFactory,
  WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesRequest:
      WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesRequest
          .fromJsonFactory,
  WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesResponse:
      WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesResponse
          .fromJsonFactory,
  WebApiModulesInventoryPartsInventoryPartsInventory:
      WebApiModulesInventoryPartsInventoryPartsInventory.fromJsonFactory,
  WebApiModulesInventoryPartsInventoryPartsInventoryDocument:
      WebApiModulesInventoryPartsInventoryPartsInventoryDocument
          .fromJsonFactory,
  WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPostRequest:
      WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPostRequest
          .fromJsonFactory,
  WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPutRequest:
      WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPutRequest
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventory:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventory.fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostRequest:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostRequest
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostResponse:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostResponse
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveRequest:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveRequest
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveResponse:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveResponse
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseRequest:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseRequest
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseResponse:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseResponse
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemRequest:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemRequest
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemResponse:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemResponse
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantity:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantity
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerial:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerial
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptions:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptions
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateRequest:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateRequest
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateResponse:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateResponse
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAdded:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAdded
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostRequest:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostRequest
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostResponse:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostResponse
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanRequest:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanRequest
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanResponse:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanResponse
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecount:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecount
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequest:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequest
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequestModel:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequestModel
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsRequest:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsRequest
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsResponse:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsResponse
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusRequest:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusRequest
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusResponse:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusResponse
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemRequest:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemRequest
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemResponse:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemResponse
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesRequest:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesRequest
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesResponse:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesResponse
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidRequest:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidRequest
          .fromJsonFactory,
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidResponse:
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidResponse
          .fromJsonFactory,
  WebApiModulesInventoryRentalInventoryRentalInventory:
      WebApiModulesInventoryRentalInventoryRentalInventory.fromJsonFactory,
  WebApiModulesInventoryRentalInventoryRentalInventoryDetailResponse:
      WebApiModulesInventoryRentalInventoryRentalInventoryDetailResponse
          .fromJsonFactory,
  WebApiModulesInventoryRentalInventoryRentalInventoryDocument:
      WebApiModulesInventoryRentalInventoryRentalInventoryDocument
          .fromJsonFactory,
  WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPostRequest:
      WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPostRequest
          .fromJsonFactory,
  WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPutRequest:
      WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPutRequest
          .fromJsonFactory,
  WebApiModulesInventoryRepairRepair:
      WebApiModulesInventoryRepairRepair.fromJsonFactory,
  WebApiModulesInventoryRepairRepairDocument:
      WebApiModulesInventoryRepairRepairDocument.fromJsonFactory,
  WebApiModulesInventoryRepairRepairDocumentPostRequest:
      WebApiModulesInventoryRepairRepairDocumentPostRequest.fromJsonFactory,
  WebApiModulesInventoryRepairRepairDocumentPutRequest:
      WebApiModulesInventoryRepairRepairDocumentPutRequest.fromJsonFactory,
  WebApiModulesInventoryRepairRepairReleaseItemsResponse:
      WebApiModulesInventoryRepairRepairReleaseItemsResponse.fromJsonFactory,
  WebApiModulesInventoryRepairToggleRepairCompleteResponse:
      WebApiModulesInventoryRepairToggleRepairCompleteResponse.fromJsonFactory,
  WebApiModulesInventoryRepairToggleRepairEstimateResponse:
      WebApiModulesInventoryRepairToggleRepairEstimateResponse.fromJsonFactory,
  WebApiModulesInventoryRepairVoidRepairResponse:
      WebApiModulesInventoryRepairVoidRepairResponse.fromJsonFactory,
  WebApiModulesInventoryRetiredRetired:
      WebApiModulesInventoryRetiredRetired.fromJsonFactory,
  WebApiModulesInventorySalesInventorySalesInventory:
      WebApiModulesInventorySalesInventorySalesInventory.fromJsonFactory,
  WebApiModulesInventorySalesInventorySalesInventoryDocument:
      WebApiModulesInventorySalesInventorySalesInventoryDocument
          .fromJsonFactory,
  WebApiModulesInventorySalesInventorySalesInventoryDocumentPostRequest:
      WebApiModulesInventorySalesInventorySalesInventoryDocumentPostRequest
          .fromJsonFactory,
  WebApiModulesInventorySalesInventorySalesInventoryDocumentPutRequest:
      WebApiModulesInventorySalesInventorySalesInventoryDocumentPutRequest
          .fromJsonFactory,
  WebApiModulesPluginsProcessCreditCardProcessCreditCardInfo:
      WebApiModulesPluginsProcessCreditCardProcessCreditCardInfo
          .fromJsonFactory,
  WebApiModulesPluginsProcessCreditCardProcessCreditCardPaymentResponse:
      WebApiModulesPluginsProcessCreditCardProcessCreditCardPaymentResponse
          .fromJsonFactory,
  WebApiModulesSettingsDepartmentLocationDepartmentLocation:
      WebApiModulesSettingsDepartmentLocationDepartmentLocation.fromJsonFactory,
  WebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatus:
      WebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatus
          .fromJsonFactory,
  WebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModel:
      WebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModel
          .fromJsonFactory,
  WebApiModulesSettingsOfficeLocationSettingsOfficeLocationOfficeLocation:
      WebApiModulesSettingsOfficeLocationSettingsOfficeLocationOfficeLocation
          .fromJsonFactory,
  WebApiModulesSettingsOrderSettingsOrderTypeOrderType:
      WebApiModulesSettingsOrderSettingsOrderTypeOrderType.fromJsonFactory,
  WebApiModulesTransfersTransferOrderTransferOrder:
      WebApiModulesTransfersTransferOrderTransferOrder.fromJsonFactory,
  WebApiModulesUtilitiesGLDistributionRefreshGLHistoryRequest:
      WebApiModulesUtilitiesGLDistributionRefreshGLHistoryRequest
          .fromJsonFactory,
  WebApiModulesUtilitiesGLDistributionRefreshGLHistoryResponse:
      WebApiModulesUtilitiesGLDistributionRefreshGLHistoryResponse
          .fromJsonFactory,
  WebApiModulesWarehouseCheckInCancelCheckInItemRequest:
      WebApiModulesWarehouseCheckInCancelCheckInItemRequest.fromJsonFactory,
  WebApiModulesWarehouseCheckInCancelCheckInItemResponse:
      WebApiModulesWarehouseCheckInCancelCheckInItemResponse.fromJsonFactory,
  WebApiModulesWarehouseCheckInCheckInContractRequest:
      WebApiModulesWarehouseCheckInCheckInContractRequest.fromJsonFactory,
  WebApiModulesWarehouseCheckInCheckInContractResponse:
      WebApiModulesWarehouseCheckInCheckInContractResponse.fromJsonFactory,
  WebApiModulesWarehouseCheckInCheckInItemRequest:
      WebApiModulesWarehouseCheckInCheckInItemRequest.fromJsonFactory,
  WebApiModulesWarehouseCheckInHasQuikReceiptRequest:
      WebApiModulesWarehouseCheckInHasQuikReceiptRequest.fromJsonFactory,
  WebApiModulesWarehouseCheckInOrderInventoryStatusCheckIn:
      WebApiModulesWarehouseCheckInOrderInventoryStatusCheckIn.fromJsonFactory,
  WebApiModulesWarehouseCheckInTCheckInItemResponse:
      WebApiModulesWarehouseCheckInTCheckInItemResponse.fromJsonFactory,
  WebApiModulesWarehouseCheckOutCheckOutAllStagedRequest:
      WebApiModulesWarehouseCheckOutCheckOutAllStagedRequest.fromJsonFactory,
  WebApiModulesWarehouseCheckOutCheckOutAllStagedResponse:
      WebApiModulesWarehouseCheckOutCheckOutAllStagedResponse.fromJsonFactory,
  WebApiModulesWarehouseCheckOutCreateOutContractRequest:
      WebApiModulesWarehouseCheckOutCreateOutContractRequest.fromJsonFactory,
  WebApiModulesWarehouseCheckOutCreateOutContractResponse:
      WebApiModulesWarehouseCheckOutCreateOutContractResponse.fromJsonFactory,
  WebApiModulesWarehouseCheckOutDecreaseOrderQuantityRequest:
      WebApiModulesWarehouseCheckOutDecreaseOrderQuantityRequest
          .fromJsonFactory,
  WebApiModulesWarehouseCheckOutDecreaseOrderQuantityResponse:
      WebApiModulesWarehouseCheckOutDecreaseOrderQuantityResponse
          .fromJsonFactory,
  WebApiModulesWarehouseCheckOutGetPickupLocationsRequest:
      WebApiModulesWarehouseCheckOutGetPickupLocationsRequest.fromJsonFactory,
  WebApiModulesWarehouseCheckOutGetPickupLocationsResponse:
      WebApiModulesWarehouseCheckOutGetPickupLocationsResponse.fromJsonFactory,
  WebApiModulesWarehouseCheckOutIsValidStorageContainerRequest:
      WebApiModulesWarehouseCheckOutIsValidStorageContainerRequest
          .fromJsonFactory,
  WebApiModulesWarehouseCheckOutIsValidStorageContainerResponse:
      WebApiModulesWarehouseCheckOutIsValidStorageContainerResponse
          .fromJsonFactory,
  WebApiModulesWarehouseCheckOutMoveStagedItemRequest:
      WebApiModulesWarehouseCheckOutMoveStagedItemRequest.fromJsonFactory,
  WebApiModulesWarehouseCheckOutMoveStagedItemResponse:
      WebApiModulesWarehouseCheckOutMoveStagedItemResponse.fromJsonFactory,
  WebApiModulesWarehouseCheckOutOrderHasStorageContainerRequest:
      WebApiModulesWarehouseCheckOutOrderHasStorageContainerRequest
          .fromJsonFactory,
  WebApiModulesWarehouseCheckOutOrderHasStorageContainerResponse:
      WebApiModulesWarehouseCheckOutOrderHasStorageContainerResponse
          .fromJsonFactory,
  WebApiModulesWarehouseCheckOutOrderInventoryStatusCheckOut:
      WebApiModulesWarehouseCheckOutOrderInventoryStatusCheckOut
          .fromJsonFactory,
  WebApiModulesWarehouseCheckOutPickupLocation:
      WebApiModulesWarehouseCheckOutPickupLocation.fromJsonFactory,
  WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemRequest:
      WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemRequest
          .fromJsonFactory,
  WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemResponse:
      WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemResponse
          .fromJsonFactory,
  WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemRequest:
      WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemRequest
          .fromJsonFactory,
  WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemResponse:
      WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemResponse
          .fromJsonFactory,
  WebApiModulesWarehouseCheckOutStageItemRequest:
      WebApiModulesWarehouseCheckOutStageItemRequest.fromJsonFactory,
  WebApiModulesWarehouseCheckOutStageItemResponse:
      WebApiModulesWarehouseCheckOutStageItemResponse.fromJsonFactory,
  WebApiModulesWarehouseCheckOutStageSerialNumber:
      WebApiModulesWarehouseCheckOutStageSerialNumber.fromJsonFactory,
  WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionRequest:
      WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionRequest
          .fromJsonFactory,
  WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionResponse:
      WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionResponse
          .fromJsonFactory,
  WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionRequest:
      WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionRequest
          .fromJsonFactory,
  WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionResponse:
      WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionResponse
          .fromJsonFactory,
  WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionRequest:
      WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionRequest
          .fromJsonFactory,
  WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionResponse:
      WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionResponse
          .fromJsonFactory,
  WebApiModulesWarehouseCheckOutStagingTabsResponse:
      WebApiModulesWarehouseCheckOutStagingTabsResponse.fromJsonFactory,
  WebApiModulesWarehouseCheckOutStorageContainerGrid:
      WebApiModulesWarehouseCheckOutStorageContainerGrid.fromJsonFactory,
  WebApiModulesWarehouseCheckOutStorageContainerItemsGrid:
      WebApiModulesWarehouseCheckOutStorageContainerItemsGrid.fromJsonFactory,
  WebApiModulesWarehouseCheckOutStorageContainerStagedItemModel:
      WebApiModulesWarehouseCheckOutStorageContainerStagedItemModel
          .fromJsonFactory,
  WebApiModulesWarehouseCheckOutStorageContainerStagedItemsRequest:
      WebApiModulesWarehouseCheckOutStorageContainerStagedItemsRequest
          .fromJsonFactory,
  WebApiModulesWarehouseCheckOutStorageContainerStagedItemsResponse:
      WebApiModulesWarehouseCheckOutStorageContainerStagedItemsResponse
          .fromJsonFactory,
  WebApiModulesWarehouseCheckOutUnstageItemRequest:
      WebApiModulesWarehouseCheckOutUnstageItemRequest.fromJsonFactory,
  WebApiModulesWarehouseCheckOutUnstageItemResponse:
      WebApiModulesWarehouseCheckOutUnstageItemResponse.fromJsonFactory,
  WebApiModulesWarehouseCheckOutUpdatePickupLocationRequest:
      WebApiModulesWarehouseCheckOutUpdatePickupLocationRequest.fromJsonFactory,
  WebApiModulesWarehouseCheckOutUpdatePickupLocationResponse:
      WebApiModulesWarehouseCheckOutUpdatePickupLocationResponse
          .fromJsonFactory,
  WebApiModulesWarehouseContractCancelContractRequest:
      WebApiModulesWarehouseContractCancelContractRequest.fromJsonFactory,
  WebApiModulesWarehouseContractContract:
      WebApiModulesWarehouseContractContract.fromJsonFactory,
  WebApiModulesWarehouseContractContractDetailResponse:
      WebApiModulesWarehouseContractContractDetailResponse.fromJsonFactory,
  WebApiModulesWarehouseContractContractDocument:
      WebApiModulesWarehouseContractContractDocument.fromJsonFactory,
  WebApiModulesWarehouseContractContractDocumentPostRequest:
      WebApiModulesWarehouseContractContractDocumentPostRequest.fromJsonFactory,
  WebApiModulesWarehouseContractContractDocumentPutRequest:
      WebApiModulesWarehouseContractContractDocumentPutRequest.fromJsonFactory,
  WebApiModulesWarehouseContractHasQuikReceiptRequest:
      WebApiModulesWarehouseContractHasQuikReceiptRequest.fromJsonFactory,
  WebApiModulesWarehouseContractVoidContractRequest:
      WebApiModulesWarehouseContractVoidContractRequest.fromJsonFactory,
  WebApiModulesWarehouseExchangeExchangeContractRequest:
      WebApiModulesWarehouseExchangeExchangeContractRequest.fromJsonFactory,
  WebApiModulesWarehouseExchangeExchangeContractResponse:
      WebApiModulesWarehouseExchangeExchangeContractResponse.fromJsonFactory,
  WebApiModulesWarehouseExchangeExchangeItemInResponse:
      WebApiModulesWarehouseExchangeExchangeItemInResponse.fromJsonFactory,
  WebApiModulesWarehouseExchangeExchangeItemOutResponse:
      WebApiModulesWarehouseExchangeExchangeItemOutResponse.fromJsonFactory,
  WebApiModulesWarehouseExchangeExchangeItemRequest:
      WebApiModulesWarehouseExchangeExchangeItemRequest.fromJsonFactory,
  WebApiModulesWarehouseExchangeExchangeItemStatus:
      WebApiModulesWarehouseExchangeExchangeItemStatus.fromJsonFactory,
  WebApiModulesWarehouseOrderStatusStorageContainerGrid:
      WebApiModulesWarehouseOrderStatusStorageContainerGrid.fromJsonFactory,
  WebApiModulesWarehouseOrderStatusStorageContainerItemsGrid:
      WebApiModulesWarehouseOrderStatusStorageContainerItemsGrid
          .fromJsonFactory,
  WebApiModulesWarehousePickListPickList:
      WebApiModulesWarehousePickListPickList.fromJsonFactory,
  WebApiModulesWarehouseQuikReceiptQuikReceiptGrid:
      WebApiModulesWarehouseQuikReceiptQuikReceiptGrid.fromJsonFactory,
  WebApiModulesWarehouseQuikReceiptQuikReceiptItemRecord:
      WebApiModulesWarehouseQuikReceiptQuikReceiptItemRecord.fromJsonFactory,
  WebApiModulesWarehouseQuikReceiptQuikReceiptItemRequest:
      WebApiModulesWarehouseQuikReceiptQuikReceiptItemRequest.fromJsonFactory,
  WebApiModulesWarehouseQuikReceiptQuikReceiptItemResponse:
      WebApiModulesWarehouseQuikReceiptQuikReceiptItemResponse.fromJsonFactory,
  WebApiModulesWarehouseQuikReceiptQuikReceiptSaveRequest:
      WebApiModulesWarehouseQuikReceiptQuikReceiptSaveRequest.fromJsonFactory,
  WebApiModulesWarehouseQuikReceiptQuikReceiptSaveResponse:
      WebApiModulesWarehouseQuikReceiptQuikReceiptSaveResponse.fromJsonFactory,
  WebApiModulesWarehouseQuikReceiptQuikReceiptSessionRequest:
      WebApiModulesWarehouseQuikReceiptQuikReceiptSessionRequest
          .fromJsonFactory,
  WebApiModulesWarehouseQuikReceiptQuikReceiptSessionResponse:
      WebApiModulesWarehouseQuikReceiptQuikReceiptSessionResponse
          .fromJsonFactory,
  WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveRequest:
      WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveRequest
          .fromJsonFactory,
  WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveResponse:
      WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveResponse
          .fromJsonFactory,
  WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRecord:
      WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRecord
          .fromJsonFactory,
  WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRequest:
      WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRequest
          .fromJsonFactory,
  WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionsResponse:
      WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionsResponse
          .fromJsonFactory,
};

@JsonSerializable(explicitToJson: true)
class FwCoreApiSwashbuckleBadRequestResponse {
  FwCoreApiSwashbuckleBadRequestResponse();

  factory FwCoreApiSwashbuckleBadRequestResponse.fromJson(
          Map<String, dynamic> json) =>
      _$FwCoreApiSwashbuckleBadRequestResponseFromJson(json);

  static const fromJsonFactory =
      _$FwCoreApiSwashbuckleBadRequestResponseFromJson;
  static const toJsonFactory = _$FwCoreApiSwashbuckleBadRequestResponseToJson;
  Map<String, dynamic> toJson() =>
      _$FwCoreApiSwashbuckleBadRequestResponseToJson(this);
}

@JsonSerializable(explicitToJson: true)
class FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult {
  FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult({
    this.downloadUrl,
  });

  factory FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult.fromJson(
          Map<String, dynamic> json) =>
      _$FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResultFromJson(
          json);

  @JsonKey(name: 'downloadUrl')
  final String? downloadUrl;
  static const fromJsonFactory =
      _$FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResultFromJson;
  static const toJsonFactory =
      _$FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResultToJson;
  Map<String, dynamic> toJson() =>
      _$FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResultToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult &&
            (identical(other.downloadUrl, downloadUrl) ||
                const DeepCollectionEquality()
                    .equals(other.downloadUrl, downloadUrl)));
  }
}

extension $FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResultExtension
    on FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult {
  FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult
      copyWith({String? downloadUrl}) {
    return FwCoreControllersFwDataControllerDoExportExcelXlsxExportFileAsyncResult(
        downloadUrl: downloadUrl ?? this.downloadUrl);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardBusinessLogicFwBusinessLogicFieldDefinition {
  FwStandardBusinessLogicFwBusinessLogicFieldDefinition({
    this.name,
    this.dataType,
  });

  factory FwStandardBusinessLogicFwBusinessLogicFieldDefinition.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardBusinessLogicFwBusinessLogicFieldDefinitionFromJson(json);

  @JsonKey(name: 'Name')
  final String? name;
  @JsonKey(
      name: 'DataType',
      toJson: fwStandardSqlServerFwDataTypesToJson,
      fromJson: fwStandardSqlServerFwDataTypesFromJson)
  final enums.FwStandardSqlServerFwDataTypes? dataType;
  static const fromJsonFactory =
      _$FwStandardBusinessLogicFwBusinessLogicFieldDefinitionFromJson;
  static const toJsonFactory =
      _$FwStandardBusinessLogicFwBusinessLogicFieldDefinitionToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardBusinessLogicFwBusinessLogicFieldDefinitionToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardBusinessLogicFwBusinessLogicFieldDefinition &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.dataType, dataType) ||
                const DeepCollectionEquality()
                    .equals(other.dataType, dataType)));
  }
}

extension $FwStandardBusinessLogicFwBusinessLogicFieldDefinitionExtension
    on FwStandardBusinessLogicFwBusinessLogicFieldDefinition {
  FwStandardBusinessLogicFwBusinessLogicFieldDefinition copyWith(
      {String? name, enums.FwStandardSqlServerFwDataTypes? dataType}) {
    return FwStandardBusinessLogicFwBusinessLogicFieldDefinition(
        name: name ?? this.name, dataType: dataType ?? this.dataType);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardDataFwCustomValue {
  FwStandardDataFwCustomValue({
    this.fieldName,
    this.fieldValue,
    this.fieldType,
  });

  factory FwStandardDataFwCustomValue.fromJson(Map<String, dynamic> json) =>
      _$FwStandardDataFwCustomValueFromJson(json);

  @JsonKey(name: 'FieldName')
  final String? fieldName;
  @JsonKey(name: 'FieldValue')
  final String? fieldValue;
  @JsonKey(name: 'FieldType')
  final String? fieldType;
  static const fromJsonFactory = _$FwStandardDataFwCustomValueFromJson;
  static const toJsonFactory = _$FwStandardDataFwCustomValueToJson;
  Map<String, dynamic> toJson() => _$FwStandardDataFwCustomValueToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardDataFwCustomValue &&
            (identical(other.fieldName, fieldName) ||
                const DeepCollectionEquality()
                    .equals(other.fieldName, fieldName)) &&
            (identical(other.fieldValue, fieldValue) ||
                const DeepCollectionEquality()
                    .equals(other.fieldValue, fieldValue)) &&
            (identical(other.fieldType, fieldType) ||
                const DeepCollectionEquality()
                    .equals(other.fieldType, fieldType)));
  }
}

extension $FwStandardDataFwCustomValueExtension on FwStandardDataFwCustomValue {
  FwStandardDataFwCustomValue copyWith(
      {String? fieldName, String? fieldValue, String? fieldType}) {
    return FwStandardDataFwCustomValue(
        fieldName: fieldName ?? this.fieldName,
        fieldValue: fieldValue ?? this.fieldValue,
        fieldType: fieldType ?? this.fieldType);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardDataFwDefaultAttribute {
  FwStandardDataFwDefaultAttribute({
    this.fieldName,
    this.attributeName,
    this.defaultValue,
  });

  factory FwStandardDataFwDefaultAttribute.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardDataFwDefaultAttributeFromJson(json);

  @JsonKey(name: 'FieldName')
  final String? fieldName;
  @JsonKey(name: 'AttributeName')
  final String? attributeName;
  @JsonKey(name: 'DefaultValue')
  final String? defaultValue;
  static const fromJsonFactory = _$FwStandardDataFwDefaultAttributeFromJson;
  static const toJsonFactory = _$FwStandardDataFwDefaultAttributeToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardDataFwDefaultAttributeToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardDataFwDefaultAttribute &&
            (identical(other.fieldName, fieldName) ||
                const DeepCollectionEquality()
                    .equals(other.fieldName, fieldName)) &&
            (identical(other.attributeName, attributeName) ||
                const DeepCollectionEquality()
                    .equals(other.attributeName, attributeName)) &&
            (identical(other.defaultValue, defaultValue) ||
                const DeepCollectionEquality()
                    .equals(other.defaultValue, defaultValue)));
  }
}

extension $FwStandardDataFwDefaultAttributeExtension
    on FwStandardDataFwDefaultAttribute {
  FwStandardDataFwDefaultAttribute copyWith(
      {String? fieldName, String? attributeName, String? defaultValue}) {
    return FwStandardDataFwDefaultAttribute(
        fieldName: fieldName ?? this.fieldName,
        attributeName: attributeName ?? this.attributeName,
        defaultValue: defaultValue ?? this.defaultValue);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardGridsAppDocumentAppDocumentGetManyResponse {
  FwStandardGridsAppDocumentAppDocumentGetManyResponse({
    this.documentId,
    this.documentTypeId,
    this.documentType,
    this.description,
    this.hasImages,
    this.hasFile,
    this.inactive,
    this.dateStamp,
  });

  factory FwStandardGridsAppDocumentAppDocumentGetManyResponse.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardGridsAppDocumentAppDocumentGetManyResponseFromJson(json);

  @JsonKey(name: 'DocumentId')
  final String? documentId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'DocumentType')
  final String? documentType;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'HasImages')
  final bool? hasImages;
  @JsonKey(name: 'HasFile')
  final bool? hasFile;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  static const fromJsonFactory =
      _$FwStandardGridsAppDocumentAppDocumentGetManyResponseFromJson;
  static const toJsonFactory =
      _$FwStandardGridsAppDocumentAppDocumentGetManyResponseToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardGridsAppDocumentAppDocumentGetManyResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardGridsAppDocumentAppDocumentGetManyResponse &&
            (identical(other.documentId, documentId) ||
                const DeepCollectionEquality()
                    .equals(other.documentId, documentId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.documentType, documentType) ||
                const DeepCollectionEquality()
                    .equals(other.documentType, documentType)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.hasImages, hasImages) ||
                const DeepCollectionEquality()
                    .equals(other.hasImages, hasImages)) &&
            (identical(other.hasFile, hasFile) ||
                const DeepCollectionEquality()
                    .equals(other.hasFile, hasFile)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)));
  }
}

extension $FwStandardGridsAppDocumentAppDocumentGetManyResponseExtension
    on FwStandardGridsAppDocumentAppDocumentGetManyResponse {
  FwStandardGridsAppDocumentAppDocumentGetManyResponse copyWith(
      {String? documentId,
      String? documentTypeId,
      String? documentType,
      String? description,
      bool? hasImages,
      bool? hasFile,
      bool? inactive,
      String? dateStamp}) {
    return FwStandardGridsAppDocumentAppDocumentGetManyResponse(
        documentId: documentId ?? this.documentId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        documentType: documentType ?? this.documentType,
        description: description ?? this.description,
        hasImages: hasImages ?? this.hasImages,
        hasFile: hasFile ?? this.hasFile,
        inactive: inactive ?? this.inactive,
        dateStamp: dateStamp ?? this.dateStamp);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardGridsAppDocumentDocumentImage {
  FwStandardGridsAppDocumentDocumentImage({
    this.imageId,
    this.description,
    this.imageNumber,
    this.dataUrl,
  });

  factory FwStandardGridsAppDocumentDocumentImage.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardGridsAppDocumentDocumentImageFromJson(json);

  @JsonKey(name: 'ImageId')
  final String? imageId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'ImageNumber')
  final String? imageNumber;
  @JsonKey(name: 'DataUrl')
  final String? dataUrl;
  static const fromJsonFactory =
      _$FwStandardGridsAppDocumentDocumentImageFromJson;
  static const toJsonFactory = _$FwStandardGridsAppDocumentDocumentImageToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardGridsAppDocumentDocumentImageToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardGridsAppDocumentDocumentImage &&
            (identical(other.imageId, imageId) ||
                const DeepCollectionEquality()
                    .equals(other.imageId, imageId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.imageNumber, imageNumber) ||
                const DeepCollectionEquality()
                    .equals(other.imageNumber, imageNumber)) &&
            (identical(other.dataUrl, dataUrl) ||
                const DeepCollectionEquality().equals(other.dataUrl, dataUrl)));
  }
}

extension $FwStandardGridsAppDocumentDocumentImageExtension
    on FwStandardGridsAppDocumentDocumentImage {
  FwStandardGridsAppDocumentDocumentImage copyWith(
      {String? imageId,
      String? description,
      String? imageNumber,
      String? dataUrl}) {
    return FwStandardGridsAppDocumentDocumentImage(
        imageId: imageId ?? this.imageId,
        description: description ?? this.description,
        imageNumber: imageNumber ?? this.imageNumber,
        dataUrl: dataUrl ?? this.dataUrl);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardGridsAppDocumentGetDocumentImageResponse {
  FwStandardGridsAppDocumentGetDocumentImageResponse({
    this.image,
  });

  factory FwStandardGridsAppDocumentGetDocumentImageResponse.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardGridsAppDocumentGetDocumentImageResponseFromJson(json);

  @JsonKey(name: 'Image')
  final FwStandardGridsAppDocumentDocumentImage? image;
  static const fromJsonFactory =
      _$FwStandardGridsAppDocumentGetDocumentImageResponseFromJson;
  static const toJsonFactory =
      _$FwStandardGridsAppDocumentGetDocumentImageResponseToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardGridsAppDocumentGetDocumentImageResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardGridsAppDocumentGetDocumentImageResponse &&
            (identical(other.image, image) ||
                const DeepCollectionEquality().equals(other.image, image)));
  }
}

extension $FwStandardGridsAppDocumentGetDocumentImageResponseExtension
    on FwStandardGridsAppDocumentGetDocumentImageResponse {
  FwStandardGridsAppDocumentGetDocumentImageResponse copyWith(
      {FwStandardGridsAppDocumentDocumentImage? image}) {
    return FwStandardGridsAppDocumentGetDocumentImageResponse(
        image: image ?? this.image);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardGridsAppDocumentGetDocumentThumbnailsResponse {
  FwStandardGridsAppDocumentGetDocumentThumbnailsResponse({
    this.thumbnails,
  });

  factory FwStandardGridsAppDocumentGetDocumentThumbnailsResponse.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardGridsAppDocumentGetDocumentThumbnailsResponseFromJson(json);

  @JsonKey(
      name: 'Thumbnails',
      defaultValue: <FwStandardGridsAppDocumentDocumentImage>[])
  final List<FwStandardGridsAppDocumentDocumentImage>? thumbnails;
  static const fromJsonFactory =
      _$FwStandardGridsAppDocumentGetDocumentThumbnailsResponseFromJson;
  static const toJsonFactory =
      _$FwStandardGridsAppDocumentGetDocumentThumbnailsResponseToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardGridsAppDocumentGetDocumentThumbnailsResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardGridsAppDocumentGetDocumentThumbnailsResponse &&
            (identical(other.thumbnails, thumbnails) ||
                const DeepCollectionEquality()
                    .equals(other.thumbnails, thumbnails)));
  }
}

extension $FwStandardGridsAppDocumentGetDocumentThumbnailsResponseExtension
    on FwStandardGridsAppDocumentGetDocumentThumbnailsResponse {
  FwStandardGridsAppDocumentGetDocumentThumbnailsResponse copyWith(
      {List<FwStandardGridsAppDocumentDocumentImage>? thumbnails}) {
    return FwStandardGridsAppDocumentGetDocumentThumbnailsResponse(
        thumbnails: thumbnails ?? this.thumbnails);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardGridsAppDocumentPostDocumentImageRequest {
  FwStandardGridsAppDocumentPostDocumentImageRequest({
    this.dataUrl,
    this.fileExtension,
  });

  factory FwStandardGridsAppDocumentPostDocumentImageRequest.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardGridsAppDocumentPostDocumentImageRequestFromJson(json);

  @JsonKey(name: 'DataUrl')
  final String? dataUrl;
  @JsonKey(name: 'FileExtension')
  final String? fileExtension;
  static const fromJsonFactory =
      _$FwStandardGridsAppDocumentPostDocumentImageRequestFromJson;
  static const toJsonFactory =
      _$FwStandardGridsAppDocumentPostDocumentImageRequestToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardGridsAppDocumentPostDocumentImageRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardGridsAppDocumentPostDocumentImageRequest &&
            (identical(other.dataUrl, dataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.dataUrl, dataUrl)) &&
            (identical(other.fileExtension, fileExtension) ||
                const DeepCollectionEquality()
                    .equals(other.fileExtension, fileExtension)));
  }
}

extension $FwStandardGridsAppDocumentPostDocumentImageRequestExtension
    on FwStandardGridsAppDocumentPostDocumentImageRequest {
  FwStandardGridsAppDocumentPostDocumentImageRequest copyWith(
      {String? dataUrl, String? fileExtension}) {
    return FwStandardGridsAppDocumentPostDocumentImageRequest(
        dataUrl: dataUrl ?? this.dataUrl,
        fileExtension: fileExtension ?? this.fileExtension);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardGridsAppDocumentPutDocumentFileRequest {
  FwStandardGridsAppDocumentPutDocumentFileRequest({
    this.dataUrl,
    this.fileExtension,
  });

  factory FwStandardGridsAppDocumentPutDocumentFileRequest.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardGridsAppDocumentPutDocumentFileRequestFromJson(json);

  @JsonKey(name: 'DataUrl')
  final String? dataUrl;
  @JsonKey(name: 'FileExtension')
  final String? fileExtension;
  static const fromJsonFactory =
      _$FwStandardGridsAppDocumentPutDocumentFileRequestFromJson;
  static const toJsonFactory =
      _$FwStandardGridsAppDocumentPutDocumentFileRequestToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardGridsAppDocumentPutDocumentFileRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardGridsAppDocumentPutDocumentFileRequest &&
            (identical(other.dataUrl, dataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.dataUrl, dataUrl)) &&
            (identical(other.fileExtension, fileExtension) ||
                const DeepCollectionEquality()
                    .equals(other.fileExtension, fileExtension)));
  }
}

extension $FwStandardGridsAppDocumentPutDocumentFileRequestExtension
    on FwStandardGridsAppDocumentPutDocumentFileRequest {
  FwStandardGridsAppDocumentPutDocumentFileRequest copyWith(
      {String? dataUrl, String? fileExtension}) {
    return FwStandardGridsAppDocumentPutDocumentFileRequest(
        dataUrl: dataUrl ?? this.dataUrl,
        fileExtension: fileExtension ?? this.fileExtension);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsBrowseRequest {
  FwStandardModelsBrowseRequest({
    this.miscfields,
    this.module,
    this.options,
    this.orderby,
    this.orderbydirection,
    this.top,
    this.pageno,
    this.pagesize,
    this.searchfieldoperators,
    this.searchfields,
    this.searchfieldvalues,
    this.searchfieldtypes,
    this.searchseparators,
    this.searchcondition,
    this.searchconjunctions,
    this.uniqueids,
    this.boundids,
    this.filterfields,
    this.activeview,
    this.emptyobject,
    this.forexcel,
    this.excelfields,
    this.totalfields,
    this.activeviewfields,
  });

  factory FwStandardModelsBrowseRequest.fromJson(Map<String, dynamic> json) =>
      _$FwStandardModelsBrowseRequestFromJson(json);

  @JsonKey(name: 'miscfields')
  final dynamic? miscfields;
  @JsonKey(name: 'module')
  final String? module;
  @JsonKey(name: 'options')
  final dynamic? options;
  @JsonKey(name: 'orderby')
  final String? orderby;
  @JsonKey(name: 'orderbydirection')
  final String? orderbydirection;
  @JsonKey(name: 'top')
  final int? top;
  @JsonKey(name: 'pageno')
  final int? pageno;
  @JsonKey(name: 'pagesize')
  final int? pagesize;
  @JsonKey(name: 'searchfieldoperators', defaultValue: <String>[])
  final List<String>? searchfieldoperators;
  @JsonKey(name: 'searchfields', defaultValue: <String>[])
  final List<String>? searchfields;
  @JsonKey(name: 'searchfieldvalues', defaultValue: <String>[])
  final List<String>? searchfieldvalues;
  @JsonKey(name: 'searchfieldtypes', defaultValue: <String>[])
  final List<String>? searchfieldtypes;
  @JsonKey(name: 'searchseparators', defaultValue: <String>[])
  final List<String>? searchseparators;
  @JsonKey(name: 'searchcondition', defaultValue: <String>[])
  final List<String>? searchcondition;
  @JsonKey(name: 'searchconjunctions', defaultValue: <String>[])
  final List<String>? searchconjunctions;
  @JsonKey(name: 'uniqueids')
  final dynamic? uniqueids;
  @JsonKey(name: 'boundids')
  final dynamic? boundids;
  @JsonKey(name: 'filterfields')
  final Object? filterfields;
  @JsonKey(name: 'activeview')
  final String? activeview;
  @JsonKey(name: 'emptyobject')
  final bool? emptyobject;
  @JsonKey(name: 'forexcel')
  final bool? forexcel;
  @JsonKey(
      name: 'excelfields', defaultValue: <FwStandardModelsCheckBoxListItem>[])
  final List<FwStandardModelsCheckBoxListItem>? excelfields;
  @JsonKey(name: 'totalfields', defaultValue: <String>[])
  final List<String>? totalfields;
  @JsonKey(name: 'activeviewfields')
  final Object? activeviewfields;
  static const fromJsonFactory = _$FwStandardModelsBrowseRequestFromJson;
  static const toJsonFactory = _$FwStandardModelsBrowseRequestToJson;
  Map<String, dynamic> toJson() => _$FwStandardModelsBrowseRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsBrowseRequest &&
            (identical(other.miscfields, miscfields) ||
                const DeepCollectionEquality()
                    .equals(other.miscfields, miscfields)) &&
            (identical(other.module, module) ||
                const DeepCollectionEquality().equals(other.module, module)) &&
            (identical(other.options, options) ||
                const DeepCollectionEquality()
                    .equals(other.options, options)) &&
            (identical(other.orderby, orderby) ||
                const DeepCollectionEquality()
                    .equals(other.orderby, orderby)) &&
            (identical(other.orderbydirection, orderbydirection) ||
                const DeepCollectionEquality()
                    .equals(other.orderbydirection, orderbydirection)) &&
            (identical(other.top, top) ||
                const DeepCollectionEquality().equals(other.top, top)) &&
            (identical(other.pageno, pageno) ||
                const DeepCollectionEquality().equals(other.pageno, pageno)) &&
            (identical(other.pagesize, pagesize) ||
                const DeepCollectionEquality()
                    .equals(other.pagesize, pagesize)) &&
            (identical(other.searchfieldoperators, searchfieldoperators) ||
                const DeepCollectionEquality().equals(
                    other.searchfieldoperators, searchfieldoperators)) &&
            (identical(other.searchfields, searchfields) ||
                const DeepCollectionEquality()
                    .equals(other.searchfields, searchfields)) &&
            (identical(other.searchfieldvalues, searchfieldvalues) ||
                const DeepCollectionEquality()
                    .equals(other.searchfieldvalues, searchfieldvalues)) &&
            (identical(other.searchfieldtypes, searchfieldtypes) ||
                const DeepCollectionEquality()
                    .equals(other.searchfieldtypes, searchfieldtypes)) &&
            (identical(other.searchseparators, searchseparators) ||
                const DeepCollectionEquality()
                    .equals(other.searchseparators, searchseparators)) &&
            (identical(other.searchcondition, searchcondition) ||
                const DeepCollectionEquality()
                    .equals(other.searchcondition, searchcondition)) &&
            (identical(other.searchconjunctions, searchconjunctions) ||
                const DeepCollectionEquality()
                    .equals(other.searchconjunctions, searchconjunctions)) &&
            (identical(other.uniqueids, uniqueids) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueids, uniqueids)) &&
            (identical(other.boundids, boundids) ||
                const DeepCollectionEquality()
                    .equals(other.boundids, boundids)) &&
            (identical(other.filterfields, filterfields) ||
                const DeepCollectionEquality()
                    .equals(other.filterfields, filterfields)) &&
            (identical(other.activeview, activeview) ||
                const DeepCollectionEquality()
                    .equals(other.activeview, activeview)) &&
            (identical(other.emptyobject, emptyobject) ||
                const DeepCollectionEquality()
                    .equals(other.emptyobject, emptyobject)) &&
            (identical(other.forexcel, forexcel) ||
                const DeepCollectionEquality()
                    .equals(other.forexcel, forexcel)) &&
            (identical(other.excelfields, excelfields) ||
                const DeepCollectionEquality()
                    .equals(other.excelfields, excelfields)) &&
            (identical(other.totalfields, totalfields) ||
                const DeepCollectionEquality()
                    .equals(other.totalfields, totalfields)) &&
            (identical(other.activeviewfields, activeviewfields) || const DeepCollectionEquality().equals(other.activeviewfields, activeviewfields)));
  }
}

extension $FwStandardModelsBrowseRequestExtension
    on FwStandardModelsBrowseRequest {
  FwStandardModelsBrowseRequest copyWith(
      {dynamic? miscfields,
      String? module,
      dynamic? options,
      String? orderby,
      String? orderbydirection,
      int? top,
      int? pageno,
      int? pagesize,
      List<String>? searchfieldoperators,
      List<String>? searchfields,
      List<String>? searchfieldvalues,
      List<String>? searchfieldtypes,
      List<String>? searchseparators,
      List<String>? searchcondition,
      List<String>? searchconjunctions,
      dynamic? uniqueids,
      dynamic? boundids,
      Object? filterfields,
      String? activeview,
      bool? emptyobject,
      bool? forexcel,
      List<FwStandardModelsCheckBoxListItem>? excelfields,
      List<String>? totalfields,
      Object? activeviewfields}) {
    return FwStandardModelsBrowseRequest(
        miscfields: miscfields ?? this.miscfields,
        module: module ?? this.module,
        options: options ?? this.options,
        orderby: orderby ?? this.orderby,
        orderbydirection: orderbydirection ?? this.orderbydirection,
        top: top ?? this.top,
        pageno: pageno ?? this.pageno,
        pagesize: pagesize ?? this.pagesize,
        searchfieldoperators: searchfieldoperators ?? this.searchfieldoperators,
        searchfields: searchfields ?? this.searchfields,
        searchfieldvalues: searchfieldvalues ?? this.searchfieldvalues,
        searchfieldtypes: searchfieldtypes ?? this.searchfieldtypes,
        searchseparators: searchseparators ?? this.searchseparators,
        searchcondition: searchcondition ?? this.searchcondition,
        searchconjunctions: searchconjunctions ?? this.searchconjunctions,
        uniqueids: uniqueids ?? this.uniqueids,
        boundids: boundids ?? this.boundids,
        filterfields: filterfields ?? this.filterfields,
        activeview: activeview ?? this.activeview,
        emptyobject: emptyobject ?? this.emptyobject,
        forexcel: forexcel ?? this.forexcel,
        excelfields: excelfields ?? this.excelfields,
        totalfields: totalfields ?? this.totalfields,
        activeviewfields: activeviewfields ?? this.activeviewfields);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsCheckBoxListItem {
  FwStandardModelsCheckBoxListItem({
    this.value,
    this.text,
    this.selected,
  });

  factory FwStandardModelsCheckBoxListItem.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsCheckBoxListItemFromJson(json);

  @JsonKey(name: 'value')
  final String? value;
  @JsonKey(name: 'text')
  final String? text;
  @JsonKey(name: 'selected')
  final bool? selected;
  static const fromJsonFactory = _$FwStandardModelsCheckBoxListItemFromJson;
  static const toJsonFactory = _$FwStandardModelsCheckBoxListItemToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsCheckBoxListItemToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsCheckBoxListItem &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)) &&
            (identical(other.text, text) ||
                const DeepCollectionEquality().equals(other.text, text)) &&
            (identical(other.selected, selected) ||
                const DeepCollectionEquality()
                    .equals(other.selected, selected)));
  }
}

extension $FwStandardModelsCheckBoxListItemExtension
    on FwStandardModelsCheckBoxListItem {
  FwStandardModelsCheckBoxListItem copyWith(
      {String? value, String? text, bool? selected}) {
    return FwStandardModelsCheckBoxListItem(
        value: value ?? this.value,
        text: text ?? this.text,
        selected: selected ?? this.selected);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwApiException {
  FwStandardModelsFwApiException({
    this.statusCode,
    this.message,
    this.stackTrace,
  });

  factory FwStandardModelsFwApiException.fromJson(Map<String, dynamic> json) =>
      _$FwStandardModelsFwApiExceptionFromJson(json);

  @JsonKey(name: 'StatusCode')
  final int? statusCode;
  @JsonKey(name: 'Message')
  final String? message;
  @JsonKey(name: 'StackTrace')
  final String? stackTrace;
  static const fromJsonFactory = _$FwStandardModelsFwApiExceptionFromJson;
  static const toJsonFactory = _$FwStandardModelsFwApiExceptionToJson;
  Map<String, dynamic> toJson() => _$FwStandardModelsFwApiExceptionToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwApiException &&
            (identical(other.statusCode, statusCode) ||
                const DeepCollectionEquality()
                    .equals(other.statusCode, statusCode)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.stackTrace, stackTrace) ||
                const DeepCollectionEquality()
                    .equals(other.stackTrace, stackTrace)));
  }
}

extension $FwStandardModelsFwApiExceptionExtension
    on FwStandardModelsFwApiException {
  FwStandardModelsFwApiException copyWith(
      {int? statusCode, String? message, String? stackTrace}) {
    return FwStandardModelsFwApiException(
        statusCode: statusCode ?? this.statusCode,
        message: message ?? this.message,
        stackTrace: stackTrace ?? this.stackTrace);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryFilter {
  FwStandardModelsFwQueryFilter({
    this.field,
    this.op,
    this.value,
  });

  factory FwStandardModelsFwQueryFilter.fromJson(Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryFilterFromJson(json);

  @JsonKey(name: 'Field')
  final String? field;
  @JsonKey(name: 'Op')
  final String? op;
  @JsonKey(name: 'Value')
  final String? value;
  static const fromJsonFactory = _$FwStandardModelsFwQueryFilterFromJson;
  static const toJsonFactory = _$FwStandardModelsFwQueryFilterToJson;
  Map<String, dynamic> toJson() => _$FwStandardModelsFwQueryFilterToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryFilter &&
            (identical(other.field, field) ||
                const DeepCollectionEquality().equals(other.field, field)) &&
            (identical(other.op, op) ||
                const DeepCollectionEquality().equals(other.op, op)) &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)));
  }
}

extension $FwStandardModelsFwQueryFilterExtension
    on FwStandardModelsFwQueryFilter {
  FwStandardModelsFwQueryFilter copyWith(
      {String? field, String? op, String? value}) {
    return FwStandardModelsFwQueryFilter(
        field: field ?? this.field,
        op: op ?? this.op,
        value: value ?? this.value);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesAgentContactContactLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAgentContactContactLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesAgentContactContactLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentContactContactLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <WebApiModulesAgentContactContact>[])
  final List<WebApiModulesAgentContactContact>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentContactContactLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentContactContactLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentContactContactLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesAgentContactContactLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesAgentContactContactLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesAgentContactContactLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAgentContactContactLogic copyWith(
      {List<WebApiModulesAgentContactContact>? items,
      int? pageNo,
      int? pageSize,
      int? totalItems,
      String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAgentContactContactLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesAgentCustomerCustomerLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAgentCustomerCustomerLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesAgentCustomerCustomerLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentCustomerCustomerLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <WebApiModulesAgentCustomerCustomer>[])
  final List<WebApiModulesAgentCustomerCustomer>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentCustomerCustomerLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentCustomerCustomerLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentCustomerCustomerLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesAgentCustomerCustomerLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesAgentCustomerCustomerLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesAgentCustomerCustomerLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAgentCustomerCustomerLogic
      copyWith(
          {List<WebApiModulesAgentCustomerCustomer>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAgentCustomerCustomerLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesAgentDealDealLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAgentDealDealLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesAgentDealDealLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentDealDealLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <WebApiModulesAgentDealDeal>[])
  final List<WebApiModulesAgentDealDeal>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentDealDealLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentDealDealLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentDealDealLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesAgentDealDealLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesAgentDealDealLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesAgentDealDealLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAgentDealDealLogic copyWith(
      {List<WebApiModulesAgentDealDeal>? items,
      int? pageNo,
      int? pageSize,
      int? totalItems,
      String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAgentDealDealLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesAgentOrderOrderLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAgentOrderOrderLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesAgentOrderOrderLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentOrderOrderLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <WebApiModulesAgentOrderOrder>[])
  final List<WebApiModulesAgentOrderOrder>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentOrderOrderLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentOrderOrderLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentOrderOrderLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesAgentOrderOrderLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesAgentOrderOrderLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesAgentOrderOrderLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAgentOrderOrderLogic copyWith(
      {List<WebApiModulesAgentOrderOrder>? items,
      int? pageNo,
      int? pageSize,
      int? totalItems,
      String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAgentOrderOrderLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesAgentProjectProjectLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAgentProjectProjectLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesAgentProjectProjectLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentProjectProjectLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <WebApiModulesAgentProjectProject>[])
  final List<WebApiModulesAgentProjectProject>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentProjectProjectLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentProjectProjectLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentProjectProjectLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesAgentProjectProjectLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesAgentProjectProjectLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesAgentProjectProjectLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAgentProjectProjectLogic copyWith(
      {List<WebApiModulesAgentProjectProject>? items,
      int? pageNo,
      int? pageSize,
      int? totalItems,
      String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAgentProjectProjectLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesAgentPurchaseOrderPurchaseOrderLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAgentPurchaseOrderPurchaseOrderLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesAgentPurchaseOrderPurchaseOrderLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentPurchaseOrderPurchaseOrderLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesAgentPurchaseOrderPurchaseOrder>[])
  final List<WebApiModulesAgentPurchaseOrderPurchaseOrder>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentPurchaseOrderPurchaseOrderLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentPurchaseOrderPurchaseOrderLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentPurchaseOrderPurchaseOrderLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesAgentPurchaseOrderPurchaseOrderLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesAgentPurchaseOrderPurchaseOrderLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesAgentPurchaseOrderPurchaseOrderLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAgentPurchaseOrderPurchaseOrderLogic
      copyWith(
          {List<WebApiModulesAgentPurchaseOrderPurchaseOrder>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAgentPurchaseOrderPurchaseOrderLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesAgentQuoteQuoteLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAgentQuoteQuoteLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesAgentQuoteQuoteLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentQuoteQuoteLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <WebApiModulesAgentQuoteQuote>[])
  final List<WebApiModulesAgentQuoteQuote>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentQuoteQuoteLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentQuoteQuoteLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentQuoteQuoteLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesAgentQuoteQuoteLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesAgentQuoteQuoteLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesAgentQuoteQuoteLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAgentQuoteQuoteLogic copyWith(
      {List<WebApiModulesAgentQuoteQuote>? items,
      int? pageNo,
      int? pageSize,
      int? totalItems,
      String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAgentQuoteQuoteLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesAgentVendorVendorLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAgentVendorVendorLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesAgentVendorVendorLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentVendorVendorLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <WebApiModulesAgentVendorVendor>[])
  final List<WebApiModulesAgentVendorVendor>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentVendorVendorLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentVendorVendorLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesAgentVendorVendorLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesAgentVendorVendorLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesAgentVendorVendorLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesAgentVendorVendorLogic {
  FwStandardModelsFwQueryResponseWebApiModulesAgentVendorVendorLogic copyWith(
      {List<WebApiModulesAgentVendorVendor>? items,
      int? pageNo,
      int? pageSize,
      int? totalItems,
      String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesAgentVendorVendorLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesBillingBankAccountBankAccountLogic {
  FwStandardModelsFwQueryResponseWebApiModulesBillingBankAccountBankAccountLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesBillingBankAccountBankAccountLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesBillingBankAccountBankAccountLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesBillingBankAccountBankAccount>[])
  final List<WebApiModulesBillingBankAccountBankAccount>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesBillingBankAccountBankAccountLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesBillingBankAccountBankAccountLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesBillingBankAccountBankAccountLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesBillingBankAccountBankAccountLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesBillingBankAccountBankAccountLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesBillingBankAccountBankAccountLogic {
  FwStandardModelsFwQueryResponseWebApiModulesBillingBankAccountBankAccountLogic
      copyWith(
          {List<WebApiModulesBillingBankAccountBankAccount>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesBillingBankAccountBankAccountLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesBillingBillingWorksheetBillingWorksheetLogic {
  FwStandardModelsFwQueryResponseWebApiModulesBillingBillingWorksheetBillingWorksheetLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesBillingBillingWorksheetBillingWorksheetLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesBillingBillingWorksheetBillingWorksheetLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesBillingBillingWorksheetBillingWorksheet>[])
  final List<WebApiModulesBillingBillingWorksheetBillingWorksheet>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesBillingBillingWorksheetBillingWorksheetLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesBillingBillingWorksheetBillingWorksheetLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesBillingBillingWorksheetBillingWorksheetLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesBillingBillingWorksheetBillingWorksheetLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesBillingBillingWorksheetBillingWorksheetLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesBillingBillingWorksheetBillingWorksheetLogic {
  FwStandardModelsFwQueryResponseWebApiModulesBillingBillingWorksheetBillingWorksheetLogic
      copyWith(
          {List<WebApiModulesBillingBillingWorksheetBillingWorksheet>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesBillingBillingWorksheetBillingWorksheetLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesBillingInvoiceInvoiceLogic {
  FwStandardModelsFwQueryResponseWebApiModulesBillingInvoiceInvoiceLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesBillingInvoiceInvoiceLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesBillingInvoiceInvoiceLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <WebApiModulesBillingInvoiceInvoice>[])
  final List<WebApiModulesBillingInvoiceInvoice>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesBillingInvoiceInvoiceLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesBillingInvoiceInvoiceLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesBillingInvoiceInvoiceLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesBillingInvoiceInvoiceLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesBillingInvoiceInvoiceLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesBillingInvoiceInvoiceLogic {
  FwStandardModelsFwQueryResponseWebApiModulesBillingInvoiceInvoiceLogic
      copyWith(
          {List<WebApiModulesBillingInvoiceInvoice>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesBillingInvoiceInvoiceLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesBillingPaymentPaymentLogic {
  FwStandardModelsFwQueryResponseWebApiModulesBillingPaymentPaymentLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesBillingPaymentPaymentLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesBillingPaymentPaymentLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <WebApiModulesBillingPaymentPayment>[])
  final List<WebApiModulesBillingPaymentPayment>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesBillingPaymentPaymentLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesBillingPaymentPaymentLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesBillingPaymentPaymentLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesBillingPaymentPaymentLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesBillingPaymentPaymentLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesBillingPaymentPaymentLogic {
  FwStandardModelsFwQueryResponseWebApiModulesBillingPaymentPaymentLogic
      copyWith(
          {List<WebApiModulesBillingPaymentPayment>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesBillingPaymentPaymentLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesBillingReceiptReceiptLogic {
  FwStandardModelsFwQueryResponseWebApiModulesBillingReceiptReceiptLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesBillingReceiptReceiptLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesBillingReceiptReceiptLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <WebApiModulesBillingReceiptReceipt>[])
  final List<WebApiModulesBillingReceiptReceipt>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesBillingReceiptReceiptLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesBillingReceiptReceiptLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesBillingReceiptReceiptLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesBillingReceiptReceiptLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesBillingReceiptReceiptLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesBillingReceiptReceiptLogic {
  FwStandardModelsFwQueryResponseWebApiModulesBillingReceiptReceiptLogic
      copyWith(
          {List<WebApiModulesBillingReceiptReceipt>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesBillingReceiptReceiptLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesBillingVendorInvoiceVendorInvoiceLogic {
  FwStandardModelsFwQueryResponseWebApiModulesBillingVendorInvoiceVendorInvoiceLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesBillingVendorInvoiceVendorInvoiceLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesBillingVendorInvoiceVendorInvoiceLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesBillingVendorInvoiceVendorInvoice>[])
  final List<WebApiModulesBillingVendorInvoiceVendorInvoice>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesBillingVendorInvoiceVendorInvoiceLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesBillingVendorInvoiceVendorInvoiceLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesBillingVendorInvoiceVendorInvoiceLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesBillingVendorInvoiceVendorInvoiceLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesBillingVendorInvoiceVendorInvoiceLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesBillingVendorInvoiceVendorInvoiceLogic {
  FwStandardModelsFwQueryResponseWebApiModulesBillingVendorInvoiceVendorInvoiceLogic
      copyWith(
          {List<WebApiModulesBillingVendorInvoiceVendorInvoice>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesBillingVendorInvoiceVendorInvoiceLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesContainersContainerContainerLogic {
  FwStandardModelsFwQueryResponseWebApiModulesContainersContainerContainerLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesContainersContainerContainerLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesContainersContainerContainerLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesContainersContainerContainer>[])
  final List<WebApiModulesContainersContainerContainer>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesContainersContainerContainerLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesContainersContainerContainerLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesContainersContainerContainerLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesContainersContainerContainerLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesContainersContainerContainerLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesContainersContainerContainerLogic {
  FwStandardModelsFwQueryResponseWebApiModulesContainersContainerContainerLogic
      copyWith(
          {List<WebApiModulesContainersContainerContainer>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesContainersContainerContainerLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAddressAddressLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAddressAddressLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAddressAddressLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAddressAddressLogicFromJson(
          json);

  @JsonKey(
      name: 'Items', defaultValue: <WebApiModulesHomeControlsAddressAddress>[])
  final List<WebApiModulesHomeControlsAddressAddress>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAddressAddressLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAddressAddressLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAddressAddressLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAddressAddressLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAddressAddressLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAddressAddressLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAddressAddressLogic
      copyWith(
          {List<WebApiModulesHomeControlsAddressAddress>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAddressAddressLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAlternativeDescriptionAlternativeDescriptionLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAlternativeDescriptionAlternativeDescriptionLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAlternativeDescriptionAlternativeDescriptionLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAlternativeDescriptionAlternativeDescriptionLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesHomeControlsAlternativeDescriptionAlternativeDescription>[])
  final List<
          WebApiModulesHomeControlsAlternativeDescriptionAlternativeDescription>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAlternativeDescriptionAlternativeDescriptionLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAlternativeDescriptionAlternativeDescriptionLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAlternativeDescriptionAlternativeDescriptionLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAlternativeDescriptionAlternativeDescriptionLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAlternativeDescriptionAlternativeDescriptionLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAlternativeDescriptionAlternativeDescriptionLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAlternativeDescriptionAlternativeDescriptionLogic
      copyWith(
          {List<WebApiModulesHomeControlsAlternativeDescriptionAlternativeDescription>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsAlternativeDescriptionAlternativeDescriptionLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyCompanyLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyCompanyLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyCompanyLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyCompanyLogicFromJson(
          json);

  @JsonKey(
      name: 'Items', defaultValue: <WebApiModulesHomeControlsCompanyCompany>[])
  final List<WebApiModulesHomeControlsCompanyCompany>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyCompanyLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyCompanyLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyCompanyLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyCompanyLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyCompanyLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyCompanyLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyCompanyLogic
      copyWith(
          {List<WebApiModulesHomeControlsCompanyCompany>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyCompanyLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyContactCompanyContactLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyContactCompanyContactLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyContactCompanyContactLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyContactCompanyContactLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsCompanyContactCompanyContact>[])
  final List<WebApiModulesHomeControlsCompanyContactCompanyContact>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyContactCompanyContactLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyContactCompanyContactLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyContactCompanyContactLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyContactCompanyContactLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyContactCompanyContactLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyContactCompanyContactLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyContactCompanyContactLogic
      copyWith(
          {List<WebApiModulesHomeControlsCompanyContactCompanyContact>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyContactCompanyContactLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOptionLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOptionLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOptionLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOptionLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOption>[])
  final List<WebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOption>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOptionLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOptionLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOptionLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOptionLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOptionLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOptionLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOptionLogic
      copyWith(
          {List<WebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOption>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOptionLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResaleLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResaleLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResaleLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResaleLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResale>[])
  final List<WebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResale>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResaleLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResaleLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResaleLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResaleLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResaleLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResaleLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResaleLogic
      copyWith(
          {List<WebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResale>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResaleLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContactNoteContactNoteLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContactNoteContactNoteLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContactNoteContactNoteLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContactNoteContactNoteLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsContactNoteContactNote>[])
  final List<WebApiModulesHomeControlsContactNoteContactNote>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContactNoteContactNoteLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContactNoteContactNoteLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContactNoteContactNoteLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContactNoteContactNoteLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContactNoteContactNoteLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContactNoteContactNoteLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContactNoteContactNoteLogic
      copyWith(
          {List<WebApiModulesHomeControlsContactNoteContactNote>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContactNoteContactNoteLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContainerWarehouseContainerWarehouseLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContainerWarehouseContainerWarehouseLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContainerWarehouseContainerWarehouseLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContainerWarehouseContainerWarehouseLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesHomeControlsContainerWarehouseContainerWarehouse>[])
  final List<WebApiModulesHomeControlsContainerWarehouseContainerWarehouse>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContainerWarehouseContainerWarehouseLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContainerWarehouseContainerWarehouseLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContainerWarehouseContainerWarehouseLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContainerWarehouseContainerWarehouseLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContainerWarehouseContainerWarehouseLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContainerWarehouseContainerWarehouseLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContainerWarehouseContainerWarehouseLogic
      copyWith(
          {List<WebApiModulesHomeControlsContainerWarehouseContainerWarehouse>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsContainerWarehouseContainerWarehouseLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCustomerNoteCustomerNoteLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCustomerNoteCustomerNoteLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCustomerNoteCustomerNoteLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCustomerNoteCustomerNoteLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsCustomerNoteCustomerNote>[])
  final List<WebApiModulesHomeControlsCustomerNoteCustomerNote>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCustomerNoteCustomerNoteLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCustomerNoteCustomerNoteLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCustomerNoteCustomerNoteLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCustomerNoteCustomerNoteLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCustomerNoteCustomerNoteLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCustomerNoteCustomerNoteLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCustomerNoteCustomerNoteLogic
      copyWith(
          {List<WebApiModulesHomeControlsCustomerNoteCustomerNote>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsCustomerNoteCustomerNoteLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealNoteDealNoteLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealNoteDealNoteLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealNoteDealNoteLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealNoteDealNoteLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsDealNoteDealNote>[])
  final List<WebApiModulesHomeControlsDealNoteDealNote>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealNoteDealNoteLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealNoteDealNoteLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealNoteDealNoteLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealNoteDealNoteLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealNoteDealNoteLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealNoteDealNoteLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealNoteDealNoteLogic
      copyWith(
          {List<WebApiModulesHomeControlsDealNoteDealNote>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealNoteDealNoteLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealShipperDealShipperLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealShipperDealShipperLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealShipperDealShipperLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealShipperDealShipperLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsDealShipperDealShipper>[])
  final List<WebApiModulesHomeControlsDealShipperDealShipper>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealShipperDealShipperLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealShipperDealShipperLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealShipperDealShipperLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealShipperDealShipperLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealShipperDealShipperLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealShipperDealShipperLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealShipperDealShipperLogic
      copyWith(
          {List<WebApiModulesHomeControlsDealShipperDealShipper>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDealShipperDealShipperLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDeliveryDeliveryLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDeliveryDeliveryLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDeliveryDeliveryLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDeliveryDeliveryLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsDeliveryDelivery>[])
  final List<WebApiModulesHomeControlsDeliveryDelivery>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDeliveryDeliveryLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDeliveryDeliveryLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDeliveryDeliveryLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDeliveryDeliveryLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDeliveryDeliveryLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDeliveryDeliveryLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDeliveryDeliveryLogic
      copyWith(
          {List<WebApiModulesHomeControlsDeliveryDelivery>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDeliveryDeliveryLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepositPaymentDepositPaymentLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepositPaymentDepositPaymentLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepositPaymentDepositPaymentLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepositPaymentDepositPaymentLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsDepositPaymentDepositPayment>[])
  final List<WebApiModulesHomeControlsDepositPaymentDepositPayment>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepositPaymentDepositPaymentLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepositPaymentDepositPaymentLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepositPaymentDepositPaymentLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepositPaymentDepositPaymentLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepositPaymentDepositPaymentLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepositPaymentDepositPaymentLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepositPaymentDepositPaymentLogic
      copyWith(
          {List<WebApiModulesHomeControlsDepositPaymentDepositPayment>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepositPaymentDepositPaymentLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepreciationDepreciationLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepreciationDepreciationLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepreciationDepreciationLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepreciationDepreciationLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsDepreciationDepreciation>[])
  final List<WebApiModulesHomeControlsDepreciationDepreciation>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepreciationDepreciationLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepreciationDepreciationLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepreciationDepreciationLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepreciationDepreciationLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepreciationDepreciationLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepreciationDepreciationLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepreciationDepreciationLogic
      copyWith(
          {List<WebApiModulesHomeControlsDepreciationDepreciation>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsDepreciationDepreciationLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsGlManualGlManualLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsGlManualGlManualLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsGlManualGlManualLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsGlManualGlManualLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsGlManualGlManual>[])
  final List<WebApiModulesHomeControlsGlManualGlManual>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsGlManualGlManualLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsGlManualGlManualLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsGlManualGlManualLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsGlManualGlManualLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsGlManualGlManualLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsGlManualGlManualLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsGlManualGlManualLogic
      copyWith(
          {List<WebApiModulesHomeControlsGlManualGlManual>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsGlManualGlManualLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValueLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValueLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValueLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValueLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValue>[])
  final List<
          WebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValue>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValueLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValueLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValueLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValueLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValueLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValueLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValueLogic
      copyWith(
          {List<WebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValue>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValueLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryColorInventoryColorLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryColorInventoryColorLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryColorInventoryColorLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryColorInventoryColorLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsInventoryColorInventoryColor>[])
  final List<WebApiModulesHomeControlsInventoryColorInventoryColor>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryColorInventoryColorLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryColorInventoryColorLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryColorInventoryColorLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryColorInventoryColorLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryColorInventoryColorLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryColorInventoryColorLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryColorInventoryColorLogic
      copyWith(
          {List<WebApiModulesHomeControlsInventoryColorInventoryColor>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryColorInventoryColorLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompatibleInventoryCompatibleLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompatibleInventoryCompatibleLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompatibleInventoryCompatibleLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompatibleInventoryCompatibleLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesHomeControlsInventoryCompatibleInventoryCompatible>[])
  final List<WebApiModulesHomeControlsInventoryCompatibleInventoryCompatible>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompatibleInventoryCompatibleLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompatibleInventoryCompatibleLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompatibleInventoryCompatibleLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompatibleInventoryCompatibleLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompatibleInventoryCompatibleLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompatibleInventoryCompatibleLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompatibleInventoryCompatibleLogic
      copyWith(
          {List<WebApiModulesHomeControlsInventoryCompatibleInventoryCompatible>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompatibleInventoryCompatibleLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKitLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKitLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKitLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKitLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKit>[])
  final List<WebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKit>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKitLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKitLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKitLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKitLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKitLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKitLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKitLogic
      copyWith(
          {List<WebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKit>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKitLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryConsignorInventoryConsignorLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryConsignorInventoryConsignorLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryConsignorInventoryConsignorLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryConsignorInventoryConsignorLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesHomeControlsInventoryConsignorInventoryConsignor>[])
  final List<WebApiModulesHomeControlsInventoryConsignorInventoryConsignor>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryConsignorInventoryConsignorLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryConsignorInventoryConsignorLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryConsignorInventoryConsignorLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryConsignorInventoryConsignorLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryConsignorInventoryConsignorLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryConsignorInventoryConsignorLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryConsignorInventoryConsignorLogic
      copyWith(
          {List<WebApiModulesHomeControlsInventoryConsignorInventoryConsignor>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryConsignorInventoryConsignorLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryContainerItemInventoryContainerItemLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryContainerItemInventoryContainerItemLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryContainerItemInventoryContainerItemLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryContainerItemInventoryContainerItemLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesHomeControlsInventoryContainerItemInventoryContainerItem>[])
  final List<
          WebApiModulesHomeControlsInventoryContainerItemInventoryContainerItem>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryContainerItemInventoryContainerItemLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryContainerItemInventoryContainerItemLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryContainerItemInventoryContainerItemLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryContainerItemInventoryContainerItemLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryContainerItemInventoryContainerItemLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryContainerItemInventoryContainerItemLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryContainerItemInventoryContainerItemLogic
      copyWith(
          {List<WebApiModulesHomeControlsInventoryContainerItemInventoryContainerItem>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryContainerItemInventoryContainerItemLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTaxLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTaxLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTaxLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTaxLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTax>[])
  final List<WebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTax>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTaxLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTaxLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTaxLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTaxLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTaxLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTaxLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTaxLogic
      copyWith(
          {List<WebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTax>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTaxLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryMaterialInventoryMaterialLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryMaterialInventoryMaterialLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryMaterialInventoryMaterialLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryMaterialInventoryMaterialLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesHomeControlsInventoryMaterialInventoryMaterial>[])
  final List<WebApiModulesHomeControlsInventoryMaterialInventoryMaterial>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryMaterialInventoryMaterialLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryMaterialInventoryMaterialLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryMaterialInventoryMaterialLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryMaterialInventoryMaterialLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryMaterialInventoryMaterialLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryMaterialInventoryMaterialLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryMaterialInventoryMaterialLogic
      copyWith(
          {List<WebApiModulesHomeControlsInventoryMaterialInventoryMaterial>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryMaterialInventoryMaterialLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventoryLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventoryLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventoryLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventoryLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventory>[])
  final List<
          WebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventory>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventoryLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventoryLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventoryLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventoryLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventoryLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventoryLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventoryLogic
      copyWith(
          {List<WebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventory>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventoryLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPrepInventoryPrepLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPrepInventoryPrepLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPrepInventoryPrepLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPrepInventoryPrepLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsInventoryPrepInventoryPrep>[])
  final List<WebApiModulesHomeControlsInventoryPrepInventoryPrep>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPrepInventoryPrepLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPrepInventoryPrepLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPrepInventoryPrepLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPrepInventoryPrepLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPrepInventoryPrepLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPrepInventoryPrepLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPrepInventoryPrepLogic
      copyWith(
          {List<WebApiModulesHomeControlsInventoryPrepInventoryPrep>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPrepInventoryPrepLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItemLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItemLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItemLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItemLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItem>[])
  final List<
          WebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItem>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItemLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItemLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItemLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItemLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItemLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItemLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItemLogic
      copyWith(
          {List<WebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItem>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItemLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventorySubstituteInventorySubstituteLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventorySubstituteInventorySubstituteLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventorySubstituteInventorySubstituteLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventorySubstituteInventorySubstituteLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesHomeControlsInventorySubstituteInventorySubstitute>[])
  final List<WebApiModulesHomeControlsInventorySubstituteInventorySubstitute>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventorySubstituteInventorySubstituteLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventorySubstituteInventorySubstituteLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventorySubstituteInventorySubstituteLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventorySubstituteInventorySubstituteLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventorySubstituteInventorySubstituteLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventorySubstituteInventorySubstituteLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventorySubstituteInventorySubstituteLogic
      copyWith(
          {List<WebApiModulesHomeControlsInventorySubstituteInventorySubstitute>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventorySubstituteInventorySubstituteLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryVendorInventoryVendorLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryVendorInventoryVendorLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryVendorInventoryVendorLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryVendorInventoryVendorLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsInventoryVendorInventoryVendor>[])
  final List<WebApiModulesHomeControlsInventoryVendorInventoryVendor>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryVendorInventoryVendorLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryVendorInventoryVendorLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryVendorInventoryVendorLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryVendorInventoryVendorLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryVendorInventoryVendorLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryVendorInventoryVendorLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryVendorInventoryVendorLogic
      copyWith(
          {List<WebApiModulesHomeControlsInventoryVendorInventoryVendor>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryVendorInventoryVendorLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesHomeControlsInventoryWarehouseInventoryWarehouse>[])
  final List<WebApiModulesHomeControlsInventoryWarehouseInventoryWarehouse>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogic
      copyWith(
          {List<WebApiModulesHomeControlsInventoryWarehouseInventoryWarehouse>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecificLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecificLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecificLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecificLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecific>[])
  final List<
          WebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecific>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecificLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecificLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecificLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecificLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecificLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecificLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecificLogic
      copyWith(
          {List<WebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecific>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecificLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatchLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatchLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatchLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatchLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatch>[])
  final List<WebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatch>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatchLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatchLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatchLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatchLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatchLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatchLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatchLogic
      copyWith(
          {List<WebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatch>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatchLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceItemInvoiceItemLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceItemInvoiceItemLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceItemInvoiceItemLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceItemInvoiceItemLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsInvoiceItemInvoiceItem>[])
  final List<WebApiModulesHomeControlsInvoiceItemInvoiceItem>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceItemInvoiceItemLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceItemInvoiceItemLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceItemInvoiceItemLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceItemInvoiceItemLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceItemInvoiceItemLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceItemInvoiceItemLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceItemInvoiceItemLogic
      copyWith(
          {List<WebApiModulesHomeControlsInvoiceItemInvoiceItem>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceItemInvoiceItemLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceNoteInvoiceNoteLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceNoteInvoiceNoteLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceNoteInvoiceNoteLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceNoteInvoiceNoteLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsInvoiceNoteInvoiceNote>[])
  final List<WebApiModulesHomeControlsInvoiceNoteInvoiceNote>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceNoteInvoiceNoteLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceNoteInvoiceNoteLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceNoteInvoiceNoteLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceNoteInvoiceNoteLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceNoteInvoiceNoteLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceNoteInvoiceNoteLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceNoteInvoiceNoteLogic
      copyWith(
          {List<WebApiModulesHomeControlsInvoiceNoteInvoiceNote>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceNoteInvoiceNoteLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceReceiptInvoiceReceiptLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceReceiptInvoiceReceiptLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceReceiptInvoiceReceiptLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceReceiptInvoiceReceiptLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsInvoiceReceiptInvoiceReceipt>[])
  final List<WebApiModulesHomeControlsInvoiceReceiptInvoiceReceipt>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceReceiptInvoiceReceiptLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceReceiptInvoiceReceiptLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceReceiptInvoiceReceiptLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceReceiptInvoiceReceiptLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceReceiptInvoiceReceiptLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceReceiptInvoiceReceiptLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceReceiptInvoiceReceiptLogic
      copyWith(
          {List<WebApiModulesHomeControlsInvoiceReceiptInvoiceReceipt>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsInvoiceReceiptInvoiceReceiptLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemAttributeValueItemAttributeValueLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemAttributeValueItemAttributeValueLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemAttributeValueItemAttributeValueLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemAttributeValueItemAttributeValueLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesHomeControlsItemAttributeValueItemAttributeValue>[])
  final List<WebApiModulesHomeControlsItemAttributeValueItemAttributeValue>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemAttributeValueItemAttributeValueLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemAttributeValueItemAttributeValueLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemAttributeValueItemAttributeValueLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemAttributeValueItemAttributeValueLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemAttributeValueItemAttributeValueLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemAttributeValueItemAttributeValueLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemAttributeValueItemAttributeValueLogic
      copyWith(
          {List<WebApiModulesHomeControlsItemAttributeValueItemAttributeValue>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemAttributeValueItemAttributeValueLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemQcItemQcLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemQcItemQcLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemQcItemQcLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemQcItemQcLogicFromJson(
          json);

  @JsonKey(
      name: 'Items', defaultValue: <WebApiModulesHomeControlsItemQcItemQc>[])
  final List<WebApiModulesHomeControlsItemQcItemQc>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemQcItemQcLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemQcItemQcLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemQcItemQcLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemQcItemQcLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemQcItemQcLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemQcItemQcLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemQcItemQcLogic
      copyWith(
          {List<WebApiModulesHomeControlsItemQcItemQc>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsItemQcItemQcLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsManifestManifestLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsManifestManifestLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsManifestManifestLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsManifestManifestLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsManifestManifest>[])
  final List<WebApiModulesHomeControlsManifestManifest>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsManifestManifestLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsManifestManifestLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsManifestManifestLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsManifestManifestLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsManifestManifestLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsManifestManifestLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsManifestManifestLogic
      copyWith(
          {List<WebApiModulesHomeControlsManifestManifest>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsManifestManifestLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderContactOrderContactLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderContactOrderContactLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderContactOrderContactLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderContactOrderContactLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsOrderContactOrderContact>[])
  final List<WebApiModulesHomeControlsOrderContactOrderContact>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderContactOrderContactLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderContactOrderContactLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderContactOrderContactLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderContactOrderContactLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderContactOrderContactLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderContactOrderContactLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderContactOrderContactLogic
      copyWith(
          {List<WebApiModulesHomeControlsOrderContactOrderContact>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderContactOrderContactLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderItemOrderItemLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderItemOrderItemLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderItemOrderItemLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderItemOrderItemLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsOrderItemOrderItem>[])
  final List<WebApiModulesHomeControlsOrderItemOrderItem>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderItemOrderItemLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderItemOrderItemLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderItemOrderItemLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderItemOrderItemLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderItemOrderItemLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderItemOrderItemLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderItemOrderItemLogic
      copyWith(
          {List<WebApiModulesHomeControlsOrderItemOrderItem>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderItemOrderItemLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderNoteOrderNoteLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderNoteOrderNoteLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderNoteOrderNoteLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderNoteOrderNoteLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsOrderNoteOrderNote>[])
  final List<WebApiModulesHomeControlsOrderNoteOrderNote>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderNoteOrderNoteLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderNoteOrderNoteLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderNoteOrderNoteLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderNoteOrderNoteLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderNoteOrderNoteLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderNoteOrderNoteLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderNoteOrderNoteLogic
      copyWith(
          {List<WebApiModulesHomeControlsOrderNoteOrderNote>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderNoteOrderNoteLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistoryLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistoryLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistoryLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistoryLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistory>[])
  final List<WebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistory>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistoryLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistoryLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistoryLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistoryLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistoryLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistoryLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistoryLogic
      copyWith(
          {List<WebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistory>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistoryLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPersonalEventPersonalEventLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPersonalEventPersonalEventLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPersonalEventPersonalEventLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPersonalEventPersonalEventLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsPersonalEventPersonalEvent>[])
  final List<WebApiModulesHomeControlsPersonalEventPersonalEvent>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPersonalEventPersonalEventLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPersonalEventPersonalEventLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPersonalEventPersonalEventLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPersonalEventPersonalEventLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPersonalEventPersonalEventLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPersonalEventPersonalEventLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPersonalEventPersonalEventLogic
      copyWith(
          {List<WebApiModulesHomeControlsPersonalEventPersonalEvent>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPersonalEventPersonalEventLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventoryLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventoryLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventoryLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventoryLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventory>[])
  final List<
          WebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventory>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventoryLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventoryLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventoryLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventoryLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventoryLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventoryLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventoryLogic
      copyWith(
          {List<WebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventory>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventoryLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventoryLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventoryLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventoryLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventoryLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventory>[])
  final List<
          WebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventory>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventoryLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventoryLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventoryLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventoryLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventoryLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventoryLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventoryLogic
      copyWith(
          {List<WebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventory>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventoryLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPickListItemPickListItemLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPickListItemPickListItemLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPickListItemPickListItemLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPickListItemPickListItemLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsPickListItemPickListItem>[])
  final List<WebApiModulesHomeControlsPickListItemPickListItem>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPickListItemPickListItemLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPickListItemPickListItemLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPickListItemPickListItemLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPickListItemPickListItemLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPickListItemPickListItemLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPickListItemPickListItemLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPickListItemPickListItemLogic
      copyWith(
          {List<WebApiModulesHomeControlsPickListItemPickListItem>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPickListItemPickListItemLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectContactProjectContactLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectContactProjectContactLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectContactProjectContactLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectContactProjectContactLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsProjectContactProjectContact>[])
  final List<WebApiModulesHomeControlsProjectContactProjectContact>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectContactProjectContactLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectContactProjectContactLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectContactProjectContactLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectContactProjectContactLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectContactProjectContactLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectContactProjectContactLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectContactProjectContactLogic
      copyWith(
          {List<WebApiModulesHomeControlsProjectContactProjectContact>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectContactProjectContactLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectNoteProjectNoteLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectNoteProjectNoteLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectNoteProjectNoteLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectNoteProjectNoteLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsProjectNoteProjectNote>[])
  final List<WebApiModulesHomeControlsProjectNoteProjectNote>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectNoteProjectNoteLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectNoteProjectNoteLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectNoteProjectNoteLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectNoteProjectNoteLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectNoteProjectNoteLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectNoteProjectNoteLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectNoteProjectNoteLogic
      copyWith(
          {List<WebApiModulesHomeControlsProjectNoteProjectNote>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsProjectNoteProjectNoteLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCodeLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCodeLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCodeLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCodeLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCode>[])
  final List<
          WebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCode>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCodeLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCodeLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCodeLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCodeLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCodeLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCodeLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCodeLogic
      copyWith(
          {List<WebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCode>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCodeLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCodeLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCodeLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCodeLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCodeLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCode>[])
  final List<
          WebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCode>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCodeLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCodeLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCodeLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCodeLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCodeLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCodeLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCodeLogic
      copyWith(
          {List<WebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCode>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCodeLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItemLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItemLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItemLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItemLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItem>[])
  final List<
          WebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItem>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItemLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItemLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItemLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItemLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItemLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItemLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItemLogic
      copyWith(
          {List<WebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItem>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItemLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairCostRepairCostLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairCostRepairCostLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairCostRepairCostLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairCostRepairCostLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsRepairCostRepairCost>[])
  final List<WebApiModulesHomeControlsRepairCostRepairCost>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairCostRepairCostLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairCostRepairCostLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairCostRepairCostLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairCostRepairCostLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairCostRepairCostLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairCostRepairCostLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairCostRepairCostLogic
      copyWith(
          {List<WebApiModulesHomeControlsRepairCostRepairCost>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairCostRepairCostLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairPartRepairPartLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairPartRepairPartLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairPartRepairPartLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairPartRepairPartLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsRepairPartRepairPart>[])
  final List<WebApiModulesHomeControlsRepairPartRepairPart>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairPartRepairPartLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairPartRepairPartLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairPartRepairPartLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairPartRepairPartLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairPartRepairPartLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairPartRepairPartLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairPartRepairPartLogic
      copyWith(
          {List<WebApiModulesHomeControlsRepairPartRepairPart>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairPartRepairPartLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairReleaseRepairReleaseLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairReleaseRepairReleaseLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairReleaseRepairReleaseLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairReleaseRepairReleaseLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsRepairReleaseRepairRelease>[])
  final List<WebApiModulesHomeControlsRepairReleaseRepairRelease>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairReleaseRepairReleaseLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairReleaseRepairReleaseLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairReleaseRepairReleaseLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairReleaseRepairReleaseLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairReleaseRepairReleaseLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairReleaseRepairReleaseLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairReleaseRepairReleaseLogic
      copyWith(
          {List<WebApiModulesHomeControlsRepairReleaseRepairRelease>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsRepairReleaseRepairReleaseLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItemLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItemLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItemLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItemLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItem>[])
  final List<WebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItem>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItemLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItemLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItemLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItemLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItemLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItemLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItemLogic
      copyWith(
          {List<WebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItem>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItemLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNoteLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNoteLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNoteLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNoteLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNote>[])
  final List<WebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNote>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNoteLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNoteLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNoteLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNoteLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNoteLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNoteLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNoteLogic
      copyWith(
          {List<WebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNote>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNoteLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorNoteVendorNoteLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorNoteVendorNoteLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorNoteVendorNoteLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorNoteVendorNoteLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsVendorNoteVendorNote>[])
  final List<WebApiModulesHomeControlsVendorNoteVendorNote>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorNoteVendorNoteLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorNoteVendorNoteLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorNoteVendorNoteLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorNoteVendorNoteLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorNoteVendorNoteLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorNoteVendorNoteLogic {
  FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorNoteVendorNoteLogic
      copyWith(
          {List<WebApiModulesHomeControlsVendorNoteVendorNote>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesHomeControlsVendorNoteVendorNoteLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesInventoryAssetItemLogic {
  FwStandardModelsFwQueryResponseWebApiModulesInventoryAssetItemLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesInventoryAssetItemLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryAssetItemLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <WebApiModulesInventoryAssetItem>[])
  final List<WebApiModulesInventoryAssetItem>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryAssetItemLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryAssetItemLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryAssetItemLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesInventoryAssetItemLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesInventoryAssetItemLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesInventoryAssetItemLogic {
  FwStandardModelsFwQueryResponseWebApiModulesInventoryAssetItemLogic copyWith(
      {List<WebApiModulesInventoryAssetItem>? items,
      int? pageNo,
      int? pageSize,
      int? totalItems,
      String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesInventoryAssetItemLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesInventoryPartsInventoryPartsInventoryLogic {
  FwStandardModelsFwQueryResponseWebApiModulesInventoryPartsInventoryPartsInventoryLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesInventoryPartsInventoryPartsInventoryLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryPartsInventoryPartsInventoryLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesInventoryPartsInventoryPartsInventory>[])
  final List<WebApiModulesInventoryPartsInventoryPartsInventory>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryPartsInventoryPartsInventoryLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryPartsInventoryPartsInventoryLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryPartsInventoryPartsInventoryLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesInventoryPartsInventoryPartsInventoryLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesInventoryPartsInventoryPartsInventoryLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesInventoryPartsInventoryPartsInventoryLogic {
  FwStandardModelsFwQueryResponseWebApiModulesInventoryPartsInventoryPartsInventoryLogic
      copyWith(
          {List<WebApiModulesInventoryPartsInventoryPartsInventory>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesInventoryPartsInventoryPartsInventoryLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantityLogic {
  FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantityLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantityLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantityLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantity>[])
  final List<
          WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantity>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantityLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantityLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantityLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantityLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantityLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantityLogic {
  FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantityLogic
      copyWith(
          {List<WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantity>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantityLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerialLogic {
  FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerialLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerialLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerialLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerial>[])
  final List<
          WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerial>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerialLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerialLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerialLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerialLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerialLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerialLogic {
  FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerialLogic
      copyWith(
          {List<WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerial>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerialLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptionsLogic {
  FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptionsLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptionsLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptionsLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptions>[])
  final List<
          WebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptions>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptionsLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptionsLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptionsLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptionsLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptionsLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptionsLogic {
  FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptionsLogic
      copyWith(
          {List<WebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptions>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptionsLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAddedLogic {
  FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAddedLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAddedLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAddedLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAdded>[])
  final List<
          WebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAdded>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAddedLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAddedLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAddedLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAddedLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAddedLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAddedLogic {
  FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAddedLogic
      copyWith(
          {List<WebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAdded>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAddedLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryLogic {
  FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesInventoryPhysicalInventoryPhysicalInventory>[])
  final List<WebApiModulesInventoryPhysicalInventoryPhysicalInventory>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryLogic {
  FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryLogic
      copyWith(
          {List<WebApiModulesInventoryPhysicalInventoryPhysicalInventory>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountLogic {
  FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecount>[])
  final List<WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecount>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountLogic {
  FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountLogic
      copyWith(
          {List<WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecount>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesInventoryRentalInventoryRentalInventoryLogic {
  FwStandardModelsFwQueryResponseWebApiModulesInventoryRentalInventoryRentalInventoryLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesInventoryRentalInventoryRentalInventoryLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryRentalInventoryRentalInventoryLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesInventoryRentalInventoryRentalInventory>[])
  final List<WebApiModulesInventoryRentalInventoryRentalInventory>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryRentalInventoryRentalInventoryLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryRentalInventoryRentalInventoryLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryRentalInventoryRentalInventoryLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesInventoryRentalInventoryRentalInventoryLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesInventoryRentalInventoryRentalInventoryLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesInventoryRentalInventoryRentalInventoryLogic {
  FwStandardModelsFwQueryResponseWebApiModulesInventoryRentalInventoryRentalInventoryLogic
      copyWith(
          {List<WebApiModulesInventoryRentalInventoryRentalInventory>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesInventoryRentalInventoryRentalInventoryLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesInventoryRepairRepairLogic {
  FwStandardModelsFwQueryResponseWebApiModulesInventoryRepairRepairLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesInventoryRepairRepairLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryRepairRepairLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <WebApiModulesInventoryRepairRepair>[])
  final List<WebApiModulesInventoryRepairRepair>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryRepairRepairLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryRepairRepairLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryRepairRepairLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesInventoryRepairRepairLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesInventoryRepairRepairLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesInventoryRepairRepairLogic {
  FwStandardModelsFwQueryResponseWebApiModulesInventoryRepairRepairLogic
      copyWith(
          {List<WebApiModulesInventoryRepairRepair>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesInventoryRepairRepairLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesInventoryRetiredRetiredLogic {
  FwStandardModelsFwQueryResponseWebApiModulesInventoryRetiredRetiredLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesInventoryRetiredRetiredLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryRetiredRetiredLogicFromJson(
          json);

  @JsonKey(
      name: 'Items', defaultValue: <WebApiModulesInventoryRetiredRetired>[])
  final List<WebApiModulesInventoryRetiredRetired>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryRetiredRetiredLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryRetiredRetiredLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesInventoryRetiredRetiredLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesInventoryRetiredRetiredLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesInventoryRetiredRetiredLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesInventoryRetiredRetiredLogic {
  FwStandardModelsFwQueryResponseWebApiModulesInventoryRetiredRetiredLogic
      copyWith(
          {List<WebApiModulesInventoryRetiredRetired>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesInventoryRetiredRetiredLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesInventorySalesInventorySalesInventoryLogic {
  FwStandardModelsFwQueryResponseWebApiModulesInventorySalesInventorySalesInventoryLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesInventorySalesInventorySalesInventoryLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesInventorySalesInventorySalesInventoryLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesInventorySalesInventorySalesInventory>[])
  final List<WebApiModulesInventorySalesInventorySalesInventory>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesInventorySalesInventorySalesInventoryLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesInventorySalesInventorySalesInventoryLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesInventorySalesInventorySalesInventoryLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesInventorySalesInventorySalesInventoryLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesInventorySalesInventorySalesInventoryLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesInventorySalesInventorySalesInventoryLogic {
  FwStandardModelsFwQueryResponseWebApiModulesInventorySalesInventorySalesInventoryLogic
      copyWith(
          {List<WebApiModulesInventorySalesInventorySalesInventory>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesInventorySalesInventorySalesInventoryLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatusLogic {
  FwStandardModelsFwQueryResponseWebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatusLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatusLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatusLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatus>[])
  final List<
          WebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatus>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatusLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatusLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatusLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatusLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatusLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatusLogic {
  FwStandardModelsFwQueryResponseWebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatusLogic
      copyWith(
          {List<WebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatus>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatusLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesTransfersTransferOrderTransferOrderLogic {
  FwStandardModelsFwQueryResponseWebApiModulesTransfersTransferOrderTransferOrderLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesTransfersTransferOrderTransferOrderLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesTransfersTransferOrderTransferOrderLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesTransfersTransferOrderTransferOrder>[])
  final List<WebApiModulesTransfersTransferOrderTransferOrder>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesTransfersTransferOrderTransferOrderLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesTransfersTransferOrderTransferOrderLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesTransfersTransferOrderTransferOrderLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesTransfersTransferOrderTransferOrderLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesTransfersTransferOrderTransferOrderLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesTransfersTransferOrderTransferOrderLogic {
  FwStandardModelsFwQueryResponseWebApiModulesTransfersTransferOrderTransferOrderLogic
      copyWith(
          {List<WebApiModulesTransfersTransferOrderTransferOrder>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesTransfersTransferOrderTransferOrderLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerGridLogic {
  FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerGridLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerGridLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerGridLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesWarehouseCheckOutStorageContainerGrid>[])
  final List<WebApiModulesWarehouseCheckOutStorageContainerGrid>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerGridLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerGridLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerGridLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerGridLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerGridLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerGridLogic {
  FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerGridLogic
      copyWith(
          {List<WebApiModulesWarehouseCheckOutStorageContainerGrid>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerGridLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerItemsGridLogic {
  FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerItemsGridLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerItemsGridLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerItemsGridLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesWarehouseCheckOutStorageContainerItemsGrid>[])
  final List<WebApiModulesWarehouseCheckOutStorageContainerItemsGrid>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerItemsGridLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerItemsGridLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerItemsGridLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerItemsGridLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerItemsGridLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerItemsGridLogic {
  FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerItemsGridLogic
      copyWith(
          {List<WebApiModulesWarehouseCheckOutStorageContainerItemsGrid>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesWarehouseCheckOutStorageContainerItemsGridLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesWarehouseContractContractLogic {
  FwStandardModelsFwQueryResponseWebApiModulesWarehouseContractContractLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesWarehouseContractContractLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesWarehouseContractContractLogicFromJson(
          json);

  @JsonKey(
      name: 'Items', defaultValue: <WebApiModulesWarehouseContractContract>[])
  final List<WebApiModulesWarehouseContractContract>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesWarehouseContractContractLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesWarehouseContractContractLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesWarehouseContractContractLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesWarehouseContractContractLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesWarehouseContractContractLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesWarehouseContractContractLogic {
  FwStandardModelsFwQueryResponseWebApiModulesWarehouseContractContractLogic
      copyWith(
          {List<WebApiModulesWarehouseContractContract>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesWarehouseContractContractLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerGridLogic {
  FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerGridLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerGridLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerGridLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesWarehouseOrderStatusStorageContainerGrid>[])
  final List<WebApiModulesWarehouseOrderStatusStorageContainerGrid>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerGridLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerGridLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerGridLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerGridLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerGridLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerGridLogic {
  FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerGridLogic
      copyWith(
          {List<WebApiModulesWarehouseOrderStatusStorageContainerGrid>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerGridLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerItemsGridLogic {
  FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerItemsGridLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerItemsGridLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerItemsGridLogicFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesWarehouseOrderStatusStorageContainerItemsGrid>[])
  final List<WebApiModulesWarehouseOrderStatusStorageContainerItemsGrid>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerItemsGridLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerItemsGridLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerItemsGridLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerItemsGridLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerItemsGridLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerItemsGridLogic {
  FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerItemsGridLogic
      copyWith(
          {List<WebApiModulesWarehouseOrderStatusStorageContainerItemsGrid>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesWarehouseOrderStatusStorageContainerItemsGridLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesWarehousePickListPickListLogic {
  FwStandardModelsFwQueryResponseWebApiModulesWarehousePickListPickListLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesWarehousePickListPickListLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesWarehousePickListPickListLogicFromJson(
          json);

  @JsonKey(
      name: 'Items', defaultValue: <WebApiModulesWarehousePickListPickList>[])
  final List<WebApiModulesWarehousePickListPickList>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesWarehousePickListPickListLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesWarehousePickListPickListLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesWarehousePickListPickListLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesWarehousePickListPickListLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesWarehousePickListPickListLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesWarehousePickListPickListLogic {
  FwStandardModelsFwQueryResponseWebApiModulesWarehousePickListPickListLogic
      copyWith(
          {List<WebApiModulesWarehousePickListPickList>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesWarehousePickListPickListLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsFwQueryResponseWebApiModulesWarehouseQuikReceiptQuikReceiptGridLogic {
  FwStandardModelsFwQueryResponseWebApiModulesWarehouseQuikReceiptQuikReceiptGridLogic({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalItems,
    this.sort,
  });

  factory FwStandardModelsFwQueryResponseWebApiModulesWarehouseQuikReceiptQuikReceiptGridLogic.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsFwQueryResponseWebApiModulesWarehouseQuikReceiptQuikReceiptGridLogicFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesWarehouseQuikReceiptQuikReceiptGrid>[])
  final List<WebApiModulesWarehouseQuikReceiptQuikReceiptGrid>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalItems')
  final int? totalItems;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesWarehouseQuikReceiptQuikReceiptGridLogicFromJson;
  static const toJsonFactory =
      _$FwStandardModelsFwQueryResponseWebApiModulesWarehouseQuikReceiptQuikReceiptGridLogicToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsFwQueryResponseWebApiModulesWarehouseQuikReceiptQuikReceiptGridLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsFwQueryResponseWebApiModulesWarehouseQuikReceiptQuikReceiptGridLogic &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalItems, totalItems) ||
                const DeepCollectionEquality()
                    .equals(other.totalItems, totalItems)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsFwQueryResponseWebApiModulesWarehouseQuikReceiptQuikReceiptGridLogicExtension
    on FwStandardModelsFwQueryResponseWebApiModulesWarehouseQuikReceiptQuikReceiptGridLogic {
  FwStandardModelsFwQueryResponseWebApiModulesWarehouseQuikReceiptQuikReceiptGridLogic
      copyWith(
          {List<WebApiModulesWarehouseQuikReceiptQuikReceiptGrid>? items,
          int? pageNo,
          int? pageSize,
          int? totalItems,
          String? sort}) {
    return FwStandardModelsFwQueryResponseWebApiModulesWarehouseQuikReceiptQuikReceiptGridLogic(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalItems: totalItems ?? this.totalItems,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsGetResponseFwStandardGridsAppDocumentAppDocumentGetManyResponse {
  FwStandardModelsGetResponseFwStandardGridsAppDocumentAppDocumentGetManyResponse({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalRows,
    this.sort,
  });

  factory FwStandardModelsGetResponseFwStandardGridsAppDocumentAppDocumentGetManyResponse.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsGetResponseFwStandardGridsAppDocumentAppDocumentGetManyResponseFromJson(
          json);

  @JsonKey(
      name: 'Items',
      defaultValue: <FwStandardGridsAppDocumentAppDocumentGetManyResponse>[])
  final List<FwStandardGridsAppDocumentAppDocumentGetManyResponse>? items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalRows')
  final int? totalRows;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsGetResponseFwStandardGridsAppDocumentAppDocumentGetManyResponseFromJson;
  static const toJsonFactory =
      _$FwStandardModelsGetResponseFwStandardGridsAppDocumentAppDocumentGetManyResponseToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsGetResponseFwStandardGridsAppDocumentAppDocumentGetManyResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsGetResponseFwStandardGridsAppDocumentAppDocumentGetManyResponse &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalRows, totalRows) ||
                const DeepCollectionEquality()
                    .equals(other.totalRows, totalRows)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsGetResponseFwStandardGridsAppDocumentAppDocumentGetManyResponseExtension
    on FwStandardModelsGetResponseFwStandardGridsAppDocumentAppDocumentGetManyResponse {
  FwStandardModelsGetResponseFwStandardGridsAppDocumentAppDocumentGetManyResponse
      copyWith(
          {List<FwStandardGridsAppDocumentAppDocumentGetManyResponse>? items,
          int? pageNo,
          int? pageSize,
          int? totalRows,
          String? sort}) {
    return FwStandardModelsGetResponseFwStandardGridsAppDocumentAppDocumentGetManyResponse(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalRows: totalRows ?? this.totalRows,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsGetResponseWebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModel {
  FwStandardModelsGetResponseWebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModel({
    this.items,
    this.pageNo,
    this.pageSize,
    this.totalRows,
    this.sort,
  });

  factory FwStandardModelsGetResponseWebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModel.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsGetResponseWebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModelFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModel>[])
  final List<
          WebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModel>?
      items;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalRows')
  final int? totalRows;
  @JsonKey(name: 'Sort')
  final String? sort;
  static const fromJsonFactory =
      _$FwStandardModelsGetResponseWebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModelFromJson;
  static const toJsonFactory =
      _$FwStandardModelsGetResponseWebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModelToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsGetResponseWebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModelToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsGetResponseWebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModel &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalRows, totalRows) ||
                const DeepCollectionEquality()
                    .equals(other.totalRows, totalRows)) &&
            (identical(other.sort, sort) ||
                const DeepCollectionEquality().equals(other.sort, sort)));
  }
}

extension $FwStandardModelsGetResponseWebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModelExtension
    on FwStandardModelsGetResponseWebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModel {
  FwStandardModelsGetResponseWebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModel
      copyWith(
          {List<WebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModel>?
              items,
          int? pageNo,
          int? pageSize,
          int? totalRows,
          String? sort}) {
    return FwStandardModelsGetResponseWebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModel(
        items: items ?? this.items,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalRows: totalRows ?? this.totalRows,
        sort: sort ?? this.sort);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardModelsSelectedCheckBoxListItem {
  FwStandardModelsSelectedCheckBoxListItem({
    this.value,
  });

  factory FwStandardModelsSelectedCheckBoxListItem.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardModelsSelectedCheckBoxListItemFromJson(json);

  @JsonKey(name: 'value')
  final String? value;
  static const fromJsonFactory =
      _$FwStandardModelsSelectedCheckBoxListItemFromJson;
  static const toJsonFactory = _$FwStandardModelsSelectedCheckBoxListItemToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardModelsSelectedCheckBoxListItemToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardModelsSelectedCheckBoxListItem &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)));
  }
}

extension $FwStandardModelsSelectedCheckBoxListItemExtension
    on FwStandardModelsSelectedCheckBoxListItem {
  FwStandardModelsSelectedCheckBoxListItem copyWith({String? value}) {
    return FwStandardModelsSelectedCheckBoxListItem(value: value ?? this.value);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardSqlServerFwDateTime {
  FwStandardSqlServerFwDateTime({
    this.val,
  });

  factory FwStandardSqlServerFwDateTime.fromJson(Map<String, dynamic> json) =>
      _$FwStandardSqlServerFwDateTimeFromJson(json);

  @JsonKey(name: 'Val')
  final String? val;
  static const fromJsonFactory = _$FwStandardSqlServerFwDateTimeFromJson;
  static const toJsonFactory = _$FwStandardSqlServerFwDateTimeToJson;
  Map<String, dynamic> toJson() => _$FwStandardSqlServerFwDateTimeToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardSqlServerFwDateTime &&
            (identical(other.val, val) ||
                const DeepCollectionEquality().equals(other.val, val)));
  }
}

extension $FwStandardSqlServerFwDateTimeExtension
    on FwStandardSqlServerFwDateTime {
  FwStandardSqlServerFwDateTime copyWith({String? val}) {
    return FwStandardSqlServerFwDateTime(val: val ?? this.val);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardSqlServerFwJsonDataTable {
  FwStandardSqlServerFwJsonDataTable({
    this.columnIndex,
    this.totals,
    this.columns,
    this.rows,
    this.pageNo,
    this.pageSize,
    this.totalPages,
    this.totalRows,
    this.dateFields,
    this.columnNameByIndex,
  });

  factory FwStandardSqlServerFwJsonDataTable.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardSqlServerFwJsonDataTableFromJson(json);

  @JsonKey(name: 'ColumnIndex')
  final Object? columnIndex;
  @JsonKey(name: 'Totals')
  final Object? totals;
  @JsonKey(
      name: 'Columns',
      defaultValue: <FwStandardSqlServerFwJsonDataTableColumn>[])
  final List<FwStandardSqlServerFwJsonDataTableColumn>? columns;
  @JsonKey(name: 'Rows', defaultValue: <List<Object>>[])
  final List<List<Object>>? rows;
  @JsonKey(name: 'PageNo')
  final int? pageNo;
  @JsonKey(name: 'PageSize')
  final int? pageSize;
  @JsonKey(name: 'TotalPages')
  final int? totalPages;
  @JsonKey(name: 'TotalRows')
  final int? totalRows;
  @JsonKey(name: 'DateFields', defaultValue: <String>[])
  final List<String>? dateFields;
  @JsonKey(name: 'ColumnNameByIndex')
  final Object? columnNameByIndex;
  static const fromJsonFactory = _$FwStandardSqlServerFwJsonDataTableFromJson;
  static const toJsonFactory = _$FwStandardSqlServerFwJsonDataTableToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardSqlServerFwJsonDataTableToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardSqlServerFwJsonDataTable &&
            (identical(other.columnIndex, columnIndex) ||
                const DeepCollectionEquality()
                    .equals(other.columnIndex, columnIndex)) &&
            (identical(other.totals, totals) ||
                const DeepCollectionEquality().equals(other.totals, totals)) &&
            (identical(other.columns, columns) ||
                const DeepCollectionEquality()
                    .equals(other.columns, columns)) &&
            (identical(other.rows, rows) ||
                const DeepCollectionEquality().equals(other.rows, rows)) &&
            (identical(other.pageNo, pageNo) ||
                const DeepCollectionEquality().equals(other.pageNo, pageNo)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.totalPages, totalPages) ||
                const DeepCollectionEquality()
                    .equals(other.totalPages, totalPages)) &&
            (identical(other.totalRows, totalRows) ||
                const DeepCollectionEquality()
                    .equals(other.totalRows, totalRows)) &&
            (identical(other.dateFields, dateFields) ||
                const DeepCollectionEquality()
                    .equals(other.dateFields, dateFields)) &&
            (identical(other.columnNameByIndex, columnNameByIndex) ||
                const DeepCollectionEquality()
                    .equals(other.columnNameByIndex, columnNameByIndex)));
  }
}

extension $FwStandardSqlServerFwJsonDataTableExtension
    on FwStandardSqlServerFwJsonDataTable {
  FwStandardSqlServerFwJsonDataTable copyWith(
      {Object? columnIndex,
      Object? totals,
      List<FwStandardSqlServerFwJsonDataTableColumn>? columns,
      List<List<Object>>? rows,
      int? pageNo,
      int? pageSize,
      int? totalPages,
      int? totalRows,
      List<String>? dateFields,
      Object? columnNameByIndex}) {
    return FwStandardSqlServerFwJsonDataTable(
        columnIndex: columnIndex ?? this.columnIndex,
        totals: totals ?? this.totals,
        columns: columns ?? this.columns,
        rows: rows ?? this.rows,
        pageNo: pageNo ?? this.pageNo,
        pageSize: pageSize ?? this.pageSize,
        totalPages: totalPages ?? this.totalPages,
        totalRows: totalRows ?? this.totalRows,
        dateFields: dateFields ?? this.dateFields,
        columnNameByIndex: columnNameByIndex ?? this.columnNameByIndex);
  }
}

@JsonSerializable(explicitToJson: true)
class FwStandardSqlServerFwJsonDataTableColumn {
  FwStandardSqlServerFwJsonDataTableColumn({
    this.name,
    this.dataField,
    this.dataType,
    this.isUniqueId,
    this.isVisible,
  });

  factory FwStandardSqlServerFwJsonDataTableColumn.fromJson(
          Map<String, dynamic> json) =>
      _$FwStandardSqlServerFwJsonDataTableColumnFromJson(json);

  @JsonKey(name: 'Name')
  final String? name;
  @JsonKey(name: 'DataField')
  final String? dataField;
  @JsonKey(
      name: 'DataType',
      toJson: fwStandardSqlServerFwDataTypesToJson,
      fromJson: fwStandardSqlServerFwDataTypesFromJson)
  final enums.FwStandardSqlServerFwDataTypes? dataType;
  @JsonKey(name: 'IsUniqueId')
  final bool? isUniqueId;
  @JsonKey(name: 'IsVisible')
  final bool? isVisible;
  static const fromJsonFactory =
      _$FwStandardSqlServerFwJsonDataTableColumnFromJson;
  static const toJsonFactory = _$FwStandardSqlServerFwJsonDataTableColumnToJson;
  Map<String, dynamic> toJson() =>
      _$FwStandardSqlServerFwJsonDataTableColumnToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is FwStandardSqlServerFwJsonDataTableColumn &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.dataField, dataField) ||
                const DeepCollectionEquality()
                    .equals(other.dataField, dataField)) &&
            (identical(other.dataType, dataType) ||
                const DeepCollectionEquality()
                    .equals(other.dataType, dataType)) &&
            (identical(other.isUniqueId, isUniqueId) ||
                const DeepCollectionEquality()
                    .equals(other.isUniqueId, isUniqueId)) &&
            (identical(other.isVisible, isVisible) ||
                const DeepCollectionEquality()
                    .equals(other.isVisible, isVisible)));
  }
}

extension $FwStandardSqlServerFwJsonDataTableColumnExtension
    on FwStandardSqlServerFwJsonDataTableColumn {
  FwStandardSqlServerFwJsonDataTableColumn copyWith(
      {String? name,
      String? dataField,
      enums.FwStandardSqlServerFwDataTypes? dataType,
      bool? isUniqueId,
      bool? isVisible}) {
    return FwStandardSqlServerFwJsonDataTableColumn(
        name: name ?? this.name,
        dataField: dataField ?? this.dataField,
        dataType: dataType ?? this.dataType,
        isUniqueId: isUniqueId ?? this.isUniqueId,
        isVisible: isVisible ?? this.isVisible);
  }
}

@JsonSerializable(explicitToJson: true)
class MicrosoftAspNetCoreMvcActionResult {
  MicrosoftAspNetCoreMvcActionResult();

  factory MicrosoftAspNetCoreMvcActionResult.fromJson(
          Map<String, dynamic> json) =>
      _$MicrosoftAspNetCoreMvcActionResultFromJson(json);

  static const fromJsonFactory = _$MicrosoftAspNetCoreMvcActionResultFromJson;
  static const toJsonFactory = _$MicrosoftAspNetCoreMvcActionResultToJson;
  Map<String, dynamic> toJson() =>
      _$MicrosoftAspNetCoreMvcActionResultToJson(this);
}

@JsonSerializable(explicitToJson: true)
class MicrosoftAspNetCoreMvcActionResultWebApiModulesAgentDealDealLogic {
  MicrosoftAspNetCoreMvcActionResultWebApiModulesAgentDealDealLogic({
    this.result,
    this.value,
  });

  factory MicrosoftAspNetCoreMvcActionResultWebApiModulesAgentDealDealLogic.fromJson(
          Map<String, dynamic> json) =>
      _$MicrosoftAspNetCoreMvcActionResultWebApiModulesAgentDealDealLogicFromJson(
          json);

  @JsonKey(name: 'Result')
  final MicrosoftAspNetCoreMvcActionResult? result;
  @JsonKey(name: 'Value')
  final WebApiModulesAgentDealDeal? value;
  static const fromJsonFactory =
      _$MicrosoftAspNetCoreMvcActionResultWebApiModulesAgentDealDealLogicFromJson;
  static const toJsonFactory =
      _$MicrosoftAspNetCoreMvcActionResultWebApiModulesAgentDealDealLogicToJson;
  Map<String, dynamic> toJson() =>
      _$MicrosoftAspNetCoreMvcActionResultWebApiModulesAgentDealDealLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is MicrosoftAspNetCoreMvcActionResultWebApiModulesAgentDealDealLogic &&
            (identical(other.result, result) ||
                const DeepCollectionEquality().equals(other.result, result)) &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)));
  }
}

extension $MicrosoftAspNetCoreMvcActionResultWebApiModulesAgentDealDealLogicExtension
    on MicrosoftAspNetCoreMvcActionResultWebApiModulesAgentDealDealLogic {
  MicrosoftAspNetCoreMvcActionResultWebApiModulesAgentDealDealLogic copyWith(
      {MicrosoftAspNetCoreMvcActionResult? result,
      WebApiModulesAgentDealDeal? value}) {
    return MicrosoftAspNetCoreMvcActionResultWebApiModulesAgentDealDealLogic(
        result: result ?? this.result, value: value ?? this.value);
  }
}

@JsonSerializable(explicitToJson: true)
class MicrosoftAspNetCoreMvcActionResultWebApiModulesBillingInvoiceInvoiceLogic {
  MicrosoftAspNetCoreMvcActionResultWebApiModulesBillingInvoiceInvoiceLogic({
    this.result,
    this.value,
  });

  factory MicrosoftAspNetCoreMvcActionResultWebApiModulesBillingInvoiceInvoiceLogic.fromJson(
          Map<String, dynamic> json) =>
      _$MicrosoftAspNetCoreMvcActionResultWebApiModulesBillingInvoiceInvoiceLogicFromJson(
          json);

  @JsonKey(name: 'Result')
  final MicrosoftAspNetCoreMvcActionResult? result;
  @JsonKey(name: 'Value')
  final WebApiModulesBillingInvoiceInvoice? value;
  static const fromJsonFactory =
      _$MicrosoftAspNetCoreMvcActionResultWebApiModulesBillingInvoiceInvoiceLogicFromJson;
  static const toJsonFactory =
      _$MicrosoftAspNetCoreMvcActionResultWebApiModulesBillingInvoiceInvoiceLogicToJson;
  Map<String, dynamic> toJson() =>
      _$MicrosoftAspNetCoreMvcActionResultWebApiModulesBillingInvoiceInvoiceLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is MicrosoftAspNetCoreMvcActionResultWebApiModulesBillingInvoiceInvoiceLogic &&
            (identical(other.result, result) ||
                const DeepCollectionEquality().equals(other.result, result)) &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)));
  }
}

extension $MicrosoftAspNetCoreMvcActionResultWebApiModulesBillingInvoiceInvoiceLogicExtension
    on MicrosoftAspNetCoreMvcActionResultWebApiModulesBillingInvoiceInvoiceLogic {
  MicrosoftAspNetCoreMvcActionResultWebApiModulesBillingInvoiceInvoiceLogic
      copyWith(
          {MicrosoftAspNetCoreMvcActionResult? result,
          WebApiModulesBillingInvoiceInvoice? value}) {
    return MicrosoftAspNetCoreMvcActionResultWebApiModulesBillingInvoiceInvoiceLogic(
        result: result ?? this.result, value: value ?? this.value);
  }
}

@JsonSerializable(explicitToJson: true)
class MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogic {
  MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogic({
    this.result,
    this.value,
  });

  factory MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogic.fromJson(
          Map<String, dynamic> json) =>
      _$MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogicFromJson(
          json);

  @JsonKey(name: 'Result')
  final MicrosoftAspNetCoreMvcActionResult? result;
  @JsonKey(name: 'Value')
  final WebApiModulesHomeControlsInventoryWarehouseInventoryWarehouse? value;
  static const fromJsonFactory =
      _$MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogicFromJson;
  static const toJsonFactory =
      _$MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogicToJson;
  Map<String, dynamic> toJson() =>
      _$MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogic &&
            (identical(other.result, result) ||
                const DeepCollectionEquality().equals(other.result, result)) &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)));
  }
}

extension $MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogicExtension
    on MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogic {
  MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogic
      copyWith(
          {MicrosoftAspNetCoreMvcActionResult? result,
          WebApiModulesHomeControlsInventoryWarehouseInventoryWarehouse?
              value}) {
    return MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseLogic(
        result: result ?? this.result, value: value ?? this.value);
  }
}

@JsonSerializable(explicitToJson: true)
class MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsOrderItemOrderItemLogic {
  MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsOrderItemOrderItemLogic({
    this.result,
    this.value,
  });

  factory MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsOrderItemOrderItemLogic.fromJson(
          Map<String, dynamic> json) =>
      _$MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsOrderItemOrderItemLogicFromJson(
          json);

  @JsonKey(name: 'Result')
  final MicrosoftAspNetCoreMvcActionResult? result;
  @JsonKey(name: 'Value')
  final WebApiModulesHomeControlsOrderItemOrderItem? value;
  static const fromJsonFactory =
      _$MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsOrderItemOrderItemLogicFromJson;
  static const toJsonFactory =
      _$MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsOrderItemOrderItemLogicToJson;
  Map<String, dynamic> toJson() =>
      _$MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsOrderItemOrderItemLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsOrderItemOrderItemLogic &&
            (identical(other.result, result) ||
                const DeepCollectionEquality().equals(other.result, result)) &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)));
  }
}

extension $MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsOrderItemOrderItemLogicExtension
    on MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsOrderItemOrderItemLogic {
  MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsOrderItemOrderItemLogic
      copyWith(
          {MicrosoftAspNetCoreMvcActionResult? result,
          WebApiModulesHomeControlsOrderItemOrderItem? value}) {
    return MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsOrderItemOrderItemLogic(
        result: result ?? this.result, value: value ?? this.value);
  }
}

@JsonSerializable(explicitToJson: true)
class MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsPricingPricingLogic {
  MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsPricingPricingLogic({
    this.result,
    this.value,
  });

  factory MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsPricingPricingLogic.fromJson(
          Map<String, dynamic> json) =>
      _$MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsPricingPricingLogicFromJson(
          json);

  @JsonKey(name: 'Result')
  final MicrosoftAspNetCoreMvcActionResult? result;
  @JsonKey(name: 'Value')
  final WebApiModulesHomeControlsPricingPricing? value;
  static const fromJsonFactory =
      _$MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsPricingPricingLogicFromJson;
  static const toJsonFactory =
      _$MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsPricingPricingLogicToJson;
  Map<String, dynamic> toJson() =>
      _$MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsPricingPricingLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsPricingPricingLogic &&
            (identical(other.result, result) ||
                const DeepCollectionEquality().equals(other.result, result)) &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)));
  }
}

extension $MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsPricingPricingLogicExtension
    on MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsPricingPricingLogic {
  MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsPricingPricingLogic
      copyWith(
          {MicrosoftAspNetCoreMvcActionResult? result,
          WebApiModulesHomeControlsPricingPricing? value}) {
    return MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsPricingPricingLogic(
        result: result ?? this.result, value: value ?? this.value);
  }
}

@JsonSerializable(explicitToJson: true)
class MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItemLogic {
  MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItemLogic({
    this.result,
    this.value,
  });

  factory MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItemLogic.fromJson(
          Map<String, dynamic> json) =>
      _$MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItemLogicFromJson(
          json);

  @JsonKey(name: 'Result')
  final MicrosoftAspNetCoreMvcActionResult? result;
  @JsonKey(name: 'Value')
  final WebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItem?
      value;
  static const fromJsonFactory =
      _$MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItemLogicFromJson;
  static const toJsonFactory =
      _$MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItemLogicToJson;
  Map<String, dynamic> toJson() =>
      _$MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItemLogicToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItemLogic &&
            (identical(other.result, result) ||
                const DeepCollectionEquality().equals(other.result, result)) &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)));
  }
}

extension $MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItemLogicExtension
    on MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItemLogic {
  MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItemLogic
      copyWith(
          {MicrosoftAspNetCoreMvcActionResult? result,
          WebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItem?
              value}) {
    return MicrosoftAspNetCoreMvcActionResultWebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItemLogic(
        result: result ?? this.result, value: value ?? this.value);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiApplyBottomLineDaysPerWeekRequest {
  WebApiApplyBottomLineDaysPerWeekRequest({
    this.orderId,
    this.purchaseOrderId,
    this.recType,
    this.subs,
    this.daysPerWeek,
  });

  factory WebApiApplyBottomLineDaysPerWeekRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiApplyBottomLineDaysPerWeekRequestFromJson(json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'RecType')
  final String? recType;
  @JsonKey(name: 'Subs')
  final bool? subs;
  @JsonKey(name: 'DaysPerWeek')
  final double? daysPerWeek;
  static const fromJsonFactory =
      _$WebApiApplyBottomLineDaysPerWeekRequestFromJson;
  static const toJsonFactory = _$WebApiApplyBottomLineDaysPerWeekRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiApplyBottomLineDaysPerWeekRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiApplyBottomLineDaysPerWeekRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.recType, recType) ||
                const DeepCollectionEquality()
                    .equals(other.recType, recType)) &&
            (identical(other.subs, subs) ||
                const DeepCollectionEquality().equals(other.subs, subs)) &&
            (identical(other.daysPerWeek, daysPerWeek) ||
                const DeepCollectionEquality()
                    .equals(other.daysPerWeek, daysPerWeek)));
  }
}

extension $WebApiApplyBottomLineDaysPerWeekRequestExtension
    on WebApiApplyBottomLineDaysPerWeekRequest {
  WebApiApplyBottomLineDaysPerWeekRequest copyWith(
      {String? orderId,
      String? purchaseOrderId,
      String? recType,
      bool? subs,
      double? daysPerWeek}) {
    return WebApiApplyBottomLineDaysPerWeekRequest(
        orderId: orderId ?? this.orderId,
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        recType: recType ?? this.recType,
        subs: subs ?? this.subs,
        daysPerWeek: daysPerWeek ?? this.daysPerWeek);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiApplyBottomLineDiscountPercentRequest {
  WebApiApplyBottomLineDiscountPercentRequest({
    this.orderId,
    this.purchaseOrderId,
    this.recType,
    this.subs,
    this.discountPercent,
  });

  factory WebApiApplyBottomLineDiscountPercentRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiApplyBottomLineDiscountPercentRequestFromJson(json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'RecType')
  final String? recType;
  @JsonKey(name: 'Subs')
  final bool? subs;
  @JsonKey(name: 'DiscountPercent')
  final double? discountPercent;
  static const fromJsonFactory =
      _$WebApiApplyBottomLineDiscountPercentRequestFromJson;
  static const toJsonFactory =
      _$WebApiApplyBottomLineDiscountPercentRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiApplyBottomLineDiscountPercentRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiApplyBottomLineDiscountPercentRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.recType, recType) ||
                const DeepCollectionEquality()
                    .equals(other.recType, recType)) &&
            (identical(other.subs, subs) ||
                const DeepCollectionEquality().equals(other.subs, subs)) &&
            (identical(other.discountPercent, discountPercent) ||
                const DeepCollectionEquality()
                    .equals(other.discountPercent, discountPercent)));
  }
}

extension $WebApiApplyBottomLineDiscountPercentRequestExtension
    on WebApiApplyBottomLineDiscountPercentRequest {
  WebApiApplyBottomLineDiscountPercentRequest copyWith(
      {String? orderId,
      String? purchaseOrderId,
      String? recType,
      bool? subs,
      double? discountPercent}) {
    return WebApiApplyBottomLineDiscountPercentRequest(
        orderId: orderId ?? this.orderId,
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        recType: recType ?? this.recType,
        subs: subs ?? this.subs,
        discountPercent: discountPercent ?? this.discountPercent);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiApplyBottomLineTotalRequest {
  WebApiApplyBottomLineTotalRequest({
    this.orderId,
    this.purchaseOrderId,
    this.recType,
    this.subs,
    this.totalType,
    this.total,
    this.includeTaxInTotal,
  });

  factory WebApiApplyBottomLineTotalRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiApplyBottomLineTotalRequestFromJson(json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'RecType')
  final String? recType;
  @JsonKey(name: 'Subs')
  final bool? subs;
  @JsonKey(name: 'TotalType')
  final String? totalType;
  @JsonKey(name: 'Total')
  final double? total;
  @JsonKey(name: 'IncludeTaxInTotal')
  final bool? includeTaxInTotal;
  static const fromJsonFactory = _$WebApiApplyBottomLineTotalRequestFromJson;
  static const toJsonFactory = _$WebApiApplyBottomLineTotalRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiApplyBottomLineTotalRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiApplyBottomLineTotalRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.recType, recType) ||
                const DeepCollectionEquality()
                    .equals(other.recType, recType)) &&
            (identical(other.subs, subs) ||
                const DeepCollectionEquality().equals(other.subs, subs)) &&
            (identical(other.totalType, totalType) ||
                const DeepCollectionEquality()
                    .equals(other.totalType, totalType)) &&
            (identical(other.total, total) ||
                const DeepCollectionEquality().equals(other.total, total)) &&
            (identical(other.includeTaxInTotal, includeTaxInTotal) ||
                const DeepCollectionEquality()
                    .equals(other.includeTaxInTotal, includeTaxInTotal)));
  }
}

extension $WebApiApplyBottomLineTotalRequestExtension
    on WebApiApplyBottomLineTotalRequest {
  WebApiApplyBottomLineTotalRequest copyWith(
      {String? orderId,
      String? purchaseOrderId,
      String? recType,
      bool? subs,
      String? totalType,
      double? total,
      bool? includeTaxInTotal}) {
    return WebApiApplyBottomLineTotalRequest(
        orderId: orderId ?? this.orderId,
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        recType: recType ?? this.recType,
        subs: subs ?? this.subs,
        totalType: totalType ?? this.totalType,
        total: total ?? this.total,
        includeTaxInTotal: includeTaxInTotal ?? this.includeTaxInTotal);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiLogicSortItemsResponse {
  WebApiLogicSortItemsResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiLogicSortItemsResponse.fromJson(Map<String, dynamic> json) =>
      _$WebApiLogicSortItemsResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory = _$WebApiLogicSortItemsResponseFromJson;
  static const toJsonFactory = _$WebApiLogicSortItemsResponseToJson;
  Map<String, dynamic> toJson() => _$WebApiLogicSortItemsResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiLogicSortItemsResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiLogicSortItemsResponseExtension
    on WebApiLogicSortItemsResponse {
  WebApiLogicSortItemsResponse copyWith(
      {int? status, bool? success, String? msg}) {
    return WebApiLogicSortItemsResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiLogicTSpStatusResponse {
  WebApiLogicTSpStatusResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiLogicTSpStatusResponse.fromJson(Map<String, dynamic> json) =>
      _$WebApiLogicTSpStatusResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory = _$WebApiLogicTSpStatusResponseFromJson;
  static const toJsonFactory = _$WebApiLogicTSpStatusResponseToJson;
  Map<String, dynamic> toJson() => _$WebApiLogicTSpStatusResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiLogicTSpStatusResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiLogicTSpStatusResponseExtension
    on WebApiLogicTSpStatusResponse {
  WebApiLogicTSpStatusResponse copyWith(
      {int? status, bool? success, String? msg}) {
    return WebApiLogicTSpStatusResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentContactContact {
  WebApiModulesAgentContactContact({
    this.contactId,
    this.activeDate,
    this.address1,
    this.address2,
    this.barcode,
    this.city,
    this.contactRecordType,
    this.contactRecordTypeColor,
    this.contactTitleId,
    this.contactTitle,
    this.country,
    this.countryId,
    this.dateStamp,
    this.directExtension,
    this.directPhone,
    this.email,
    this.fax,
    this.faxExtension,
    this.firstName,
    this.firstNameColor,
    this.homePhone,
    this.inactive,
    this.inactiveDate,
    this.info,
    this.inputDate,
    this.modifiedDate,
    this.lastName,
    this.middleInitial,
    this.mobilePhone,
    this.nameFirstMiddleLast,
    this.officeExtension,
    this.officePhone,
    this.pager,
    this.pagerPin,
    this.person,
    this.salutation,
    this.website,
    this.webStatus,
    this.zipCode,
    this.state,
    this.sourceId,
    this.userId,
    this.password,
    this.changePasswordAtNextLogin,
    this.expirePassword,
    this.expireDays,
    this.passwordLastUpdated,
    this.webUserId,
    this.webUserContactId,
    this.webUserUserId,
    this.webAccess,
    this.lockAccount,
    this.defaultDealId,
    this.defaultDeal,
    this.webCatalogId,
    this.webCatalog,
    this.locationId,
    this.location,
    this.warehouseId,
    this.warehouse,
    this.webQuoteRequest,
    this.departmentId,
    this.department,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAgentContactContact.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentContactContactFromJson(json);

  @JsonKey(name: 'ContactId')
  final String? contactId;
  @JsonKey(name: 'ActiveDate')
  final String? activeDate;
  @JsonKey(name: 'Address1')
  final String? address1;
  @JsonKey(name: 'Address2')
  final String? address2;
  @JsonKey(name: 'Barcode')
  final String? barcode;
  @JsonKey(name: 'City')
  final String? city;
  @JsonKey(name: 'ContactRecordType')
  final String? contactRecordType;
  @JsonKey(name: 'ContactRecordTypeColor')
  final String? contactRecordTypeColor;
  @JsonKey(name: 'ContactTitleId')
  final String? contactTitleId;
  @JsonKey(name: 'ContactTitle')
  final String? contactTitle;
  @JsonKey(name: 'Country')
  final String? country;
  @JsonKey(name: 'CountryId')
  final String? countryId;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'DirectExtension')
  final String? directExtension;
  @JsonKey(name: 'DirectPhone')
  final String? directPhone;
  @JsonKey(name: 'Email')
  final String? email;
  @JsonKey(name: 'Fax')
  final String? fax;
  @JsonKey(name: 'FaxExtension')
  final String? faxExtension;
  @JsonKey(name: 'FirstName')
  final String? firstName;
  @JsonKey(name: 'FirstNameColor')
  final String? firstNameColor;
  @JsonKey(name: 'HomePhone')
  final String? homePhone;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'InactiveDate')
  final String? inactiveDate;
  @JsonKey(name: 'Info')
  final String? info;
  @JsonKey(name: 'InputDate')
  final String? inputDate;
  @JsonKey(name: 'ModifiedDate')
  final String? modifiedDate;
  @JsonKey(name: 'LastName')
  final String? lastName;
  @JsonKey(name: 'MiddleInitial')
  final String? middleInitial;
  @JsonKey(name: 'MobilePhone')
  final String? mobilePhone;
  @JsonKey(name: 'NameFirstMiddleLast')
  final String? nameFirstMiddleLast;
  @JsonKey(name: 'OfficeExtension')
  final String? officeExtension;
  @JsonKey(name: 'OfficePhone')
  final String? officePhone;
  @JsonKey(name: 'Pager')
  final String? pager;
  @JsonKey(name: 'PagerPin')
  final String? pagerPin;
  @JsonKey(name: 'Person')
  final String? person;
  @JsonKey(name: 'Salutation')
  final String? salutation;
  @JsonKey(name: 'Website')
  final String? website;
  @JsonKey(name: 'WebStatus')
  final String? webStatus;
  @JsonKey(name: 'ZipCode')
  final String? zipCode;
  @JsonKey(name: 'State')
  final String? state;
  @JsonKey(name: 'SourceId')
  final String? sourceId;
  @JsonKey(name: 'UserId')
  final String? userId;
  @JsonKey(name: 'Password')
  final String? password;
  @JsonKey(name: 'ChangePasswordAtNextLogin')
  final bool? changePasswordAtNextLogin;
  @JsonKey(name: 'ExpirePassword')
  final bool? expirePassword;
  @JsonKey(name: 'ExpireDays')
  final int? expireDays;
  @JsonKey(name: 'PasswordLastUpdated')
  final String? passwordLastUpdated;
  @JsonKey(name: 'WebUserId')
  final String? webUserId;
  @JsonKey(name: 'WebUserContactId')
  final String? webUserContactId;
  @JsonKey(name: 'WebUserUserId')
  final String? webUserUserId;
  @JsonKey(name: 'WebAccess')
  final bool? webAccess;
  @JsonKey(name: 'LockAccount')
  final bool? lockAccount;
  @JsonKey(name: 'DefaultDealId')
  final String? defaultDealId;
  @JsonKey(name: 'DefaultDeal')
  final String? defaultDeal;
  @JsonKey(name: 'WebCatalogId')
  final String? webCatalogId;
  @JsonKey(name: 'WebCatalog')
  final String? webCatalog;
  @JsonKey(name: 'LocationId')
  final String? locationId;
  @JsonKey(name: 'Location')
  final String? location;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'WebQuoteRequest')
  final bool? webQuoteRequest;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'Department')
  final String? department;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory = _$WebApiModulesAgentContactContactFromJson;
  static const toJsonFactory = _$WebApiModulesAgentContactContactToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentContactContactToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentContactContact &&
            (identical(other.contactId, contactId) ||
                const DeepCollectionEquality()
                    .equals(other.contactId, contactId)) &&
            (identical(other.activeDate, activeDate) ||
                const DeepCollectionEquality()
                    .equals(other.activeDate, activeDate)) &&
            (identical(other.address1, address1) ||
                const DeepCollectionEquality()
                    .equals(other.address1, address1)) &&
            (identical(other.address2, address2) ||
                const DeepCollectionEquality()
                    .equals(other.address2, address2)) &&
            (identical(other.barcode, barcode) ||
                const DeepCollectionEquality()
                    .equals(other.barcode, barcode)) &&
            (identical(other.city, city) ||
                const DeepCollectionEquality().equals(other.city, city)) &&
            (identical(other.contactRecordType, contactRecordType) ||
                const DeepCollectionEquality()
                    .equals(other.contactRecordType, contactRecordType)) &&
            (identical(other.contactRecordTypeColor, contactRecordTypeColor) ||
                const DeepCollectionEquality().equals(
                    other.contactRecordTypeColor, contactRecordTypeColor)) &&
            (identical(other.contactTitleId, contactTitleId) ||
                const DeepCollectionEquality()
                    .equals(other.contactTitleId, contactTitleId)) &&
            (identical(other.contactTitle, contactTitle) ||
                const DeepCollectionEquality()
                    .equals(other.contactTitle, contactTitle)) &&
            (identical(other.country, country) ||
                const DeepCollectionEquality()
                    .equals(other.country, country)) &&
            (identical(other.countryId, countryId) ||
                const DeepCollectionEquality()
                    .equals(other.countryId, countryId)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.directExtension, directExtension) ||
                const DeepCollectionEquality()
                    .equals(other.directExtension, directExtension)) &&
            (identical(other.directPhone, directPhone) ||
                const DeepCollectionEquality()
                    .equals(other.directPhone, directPhone)) &&
            (identical(other.email, email) ||
                const DeepCollectionEquality().equals(other.email, email)) &&
            (identical(other.fax, fax) ||
                const DeepCollectionEquality().equals(other.fax, fax)) &&
            (identical(other.faxExtension, faxExtension) ||
                const DeepCollectionEquality()
                    .equals(other.faxExtension, faxExtension)) &&
            (identical(other.firstName, firstName) ||
                const DeepCollectionEquality()
                    .equals(other.firstName, firstName)) &&
            (identical(other.firstNameColor, firstNameColor) ||
                const DeepCollectionEquality()
                    .equals(other.firstNameColor, firstNameColor)) &&
            (identical(other.homePhone, homePhone) ||
                const DeepCollectionEquality()
                    .equals(other.homePhone, homePhone)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.inactiveDate, inactiveDate) ||
                const DeepCollectionEquality()
                    .equals(other.inactiveDate, inactiveDate)) &&
            (identical(other.info, info) || const DeepCollectionEquality().equals(other.info, info)) &&
            (identical(other.inputDate, inputDate) || const DeepCollectionEquality().equals(other.inputDate, inputDate)) &&
            (identical(other.modifiedDate, modifiedDate) || const DeepCollectionEquality().equals(other.modifiedDate, modifiedDate)) &&
            (identical(other.lastName, lastName) || const DeepCollectionEquality().equals(other.lastName, lastName)) &&
            (identical(other.middleInitial, middleInitial) || const DeepCollectionEquality().equals(other.middleInitial, middleInitial)) &&
            (identical(other.mobilePhone, mobilePhone) || const DeepCollectionEquality().equals(other.mobilePhone, mobilePhone)) &&
            (identical(other.nameFirstMiddleLast, nameFirstMiddleLast) || const DeepCollectionEquality().equals(other.nameFirstMiddleLast, nameFirstMiddleLast)) &&
            (identical(other.officeExtension, officeExtension) || const DeepCollectionEquality().equals(other.officeExtension, officeExtension)) &&
            (identical(other.officePhone, officePhone) || const DeepCollectionEquality().equals(other.officePhone, officePhone)) &&
            (identical(other.pager, pager) || const DeepCollectionEquality().equals(other.pager, pager)) &&
            (identical(other.pagerPin, pagerPin) || const DeepCollectionEquality().equals(other.pagerPin, pagerPin)) &&
            (identical(other.person, person) || const DeepCollectionEquality().equals(other.person, person)) &&
            (identical(other.salutation, salutation) || const DeepCollectionEquality().equals(other.salutation, salutation)) &&
            (identical(other.website, website) || const DeepCollectionEquality().equals(other.website, website)) &&
            (identical(other.webStatus, webStatus) || const DeepCollectionEquality().equals(other.webStatus, webStatus)) &&
            (identical(other.zipCode, zipCode) || const DeepCollectionEquality().equals(other.zipCode, zipCode)) &&
            (identical(other.state, state) || const DeepCollectionEquality().equals(other.state, state)) &&
            (identical(other.sourceId, sourceId) || const DeepCollectionEquality().equals(other.sourceId, sourceId)) &&
            (identical(other.userId, userId) || const DeepCollectionEquality().equals(other.userId, userId)) &&
            (identical(other.password, password) || const DeepCollectionEquality().equals(other.password, password)) &&
            (identical(other.changePasswordAtNextLogin, changePasswordAtNextLogin) || const DeepCollectionEquality().equals(other.changePasswordAtNextLogin, changePasswordAtNextLogin)) &&
            (identical(other.expirePassword, expirePassword) || const DeepCollectionEquality().equals(other.expirePassword, expirePassword)) &&
            (identical(other.expireDays, expireDays) || const DeepCollectionEquality().equals(other.expireDays, expireDays)) &&
            (identical(other.passwordLastUpdated, passwordLastUpdated) || const DeepCollectionEquality().equals(other.passwordLastUpdated, passwordLastUpdated)) &&
            (identical(other.webUserId, webUserId) || const DeepCollectionEquality().equals(other.webUserId, webUserId)) &&
            (identical(other.webUserContactId, webUserContactId) || const DeepCollectionEquality().equals(other.webUserContactId, webUserContactId)) &&
            (identical(other.webUserUserId, webUserUserId) || const DeepCollectionEquality().equals(other.webUserUserId, webUserUserId)) &&
            (identical(other.webAccess, webAccess) || const DeepCollectionEquality().equals(other.webAccess, webAccess)) &&
            (identical(other.lockAccount, lockAccount) || const DeepCollectionEquality().equals(other.lockAccount, lockAccount)) &&
            (identical(other.defaultDealId, defaultDealId) || const DeepCollectionEquality().equals(other.defaultDealId, defaultDealId)) &&
            (identical(other.defaultDeal, defaultDeal) || const DeepCollectionEquality().equals(other.defaultDeal, defaultDeal)) &&
            (identical(other.webCatalogId, webCatalogId) || const DeepCollectionEquality().equals(other.webCatalogId, webCatalogId)) &&
            (identical(other.webCatalog, webCatalog) || const DeepCollectionEquality().equals(other.webCatalog, webCatalog)) &&
            (identical(other.locationId, locationId) || const DeepCollectionEquality().equals(other.locationId, locationId)) &&
            (identical(other.location, location) || const DeepCollectionEquality().equals(other.location, location)) &&
            (identical(other.warehouseId, warehouseId) || const DeepCollectionEquality().equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouse, warehouse) || const DeepCollectionEquality().equals(other.warehouse, warehouse)) &&
            (identical(other.webQuoteRequest, webQuoteRequest) || const DeepCollectionEquality().equals(other.webQuoteRequest, webQuoteRequest)) &&
            (identical(other.departmentId, departmentId) || const DeepCollectionEquality().equals(other.departmentId, departmentId)) &&
            (identical(other.department, department) || const DeepCollectionEquality().equals(other.department, department)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesAgentContactContactExtension
    on WebApiModulesAgentContactContact {
  WebApiModulesAgentContactContact copyWith(
      {String? contactId,
      String? activeDate,
      String? address1,
      String? address2,
      String? barcode,
      String? city,
      String? contactRecordType,
      String? contactRecordTypeColor,
      String? contactTitleId,
      String? contactTitle,
      String? country,
      String? countryId,
      String? dateStamp,
      String? directExtension,
      String? directPhone,
      String? email,
      String? fax,
      String? faxExtension,
      String? firstName,
      String? firstNameColor,
      String? homePhone,
      bool? inactive,
      String? inactiveDate,
      String? info,
      String? inputDate,
      String? modifiedDate,
      String? lastName,
      String? middleInitial,
      String? mobilePhone,
      String? nameFirstMiddleLast,
      String? officeExtension,
      String? officePhone,
      String? pager,
      String? pagerPin,
      String? person,
      String? salutation,
      String? website,
      String? webStatus,
      String? zipCode,
      String? state,
      String? sourceId,
      String? userId,
      String? password,
      bool? changePasswordAtNextLogin,
      bool? expirePassword,
      int? expireDays,
      String? passwordLastUpdated,
      String? webUserId,
      String? webUserContactId,
      String? webUserUserId,
      bool? webAccess,
      bool? lockAccount,
      String? defaultDealId,
      String? defaultDeal,
      String? webCatalogId,
      String? webCatalog,
      String? locationId,
      String? location,
      String? warehouseId,
      String? warehouse,
      bool? webQuoteRequest,
      String? departmentId,
      String? department,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAgentContactContact(
        contactId: contactId ?? this.contactId,
        activeDate: activeDate ?? this.activeDate,
        address1: address1 ?? this.address1,
        address2: address2 ?? this.address2,
        barcode: barcode ?? this.barcode,
        city: city ?? this.city,
        contactRecordType: contactRecordType ?? this.contactRecordType,
        contactRecordTypeColor:
            contactRecordTypeColor ?? this.contactRecordTypeColor,
        contactTitleId: contactTitleId ?? this.contactTitleId,
        contactTitle: contactTitle ?? this.contactTitle,
        country: country ?? this.country,
        countryId: countryId ?? this.countryId,
        dateStamp: dateStamp ?? this.dateStamp,
        directExtension: directExtension ?? this.directExtension,
        directPhone: directPhone ?? this.directPhone,
        email: email ?? this.email,
        fax: fax ?? this.fax,
        faxExtension: faxExtension ?? this.faxExtension,
        firstName: firstName ?? this.firstName,
        firstNameColor: firstNameColor ?? this.firstNameColor,
        homePhone: homePhone ?? this.homePhone,
        inactive: inactive ?? this.inactive,
        inactiveDate: inactiveDate ?? this.inactiveDate,
        info: info ?? this.info,
        inputDate: inputDate ?? this.inputDate,
        modifiedDate: modifiedDate ?? this.modifiedDate,
        lastName: lastName ?? this.lastName,
        middleInitial: middleInitial ?? this.middleInitial,
        mobilePhone: mobilePhone ?? this.mobilePhone,
        nameFirstMiddleLast: nameFirstMiddleLast ?? this.nameFirstMiddleLast,
        officeExtension: officeExtension ?? this.officeExtension,
        officePhone: officePhone ?? this.officePhone,
        pager: pager ?? this.pager,
        pagerPin: pagerPin ?? this.pagerPin,
        person: person ?? this.person,
        salutation: salutation ?? this.salutation,
        website: website ?? this.website,
        webStatus: webStatus ?? this.webStatus,
        zipCode: zipCode ?? this.zipCode,
        state: state ?? this.state,
        sourceId: sourceId ?? this.sourceId,
        userId: userId ?? this.userId,
        password: password ?? this.password,
        changePasswordAtNextLogin:
            changePasswordAtNextLogin ?? this.changePasswordAtNextLogin,
        expirePassword: expirePassword ?? this.expirePassword,
        expireDays: expireDays ?? this.expireDays,
        passwordLastUpdated: passwordLastUpdated ?? this.passwordLastUpdated,
        webUserId: webUserId ?? this.webUserId,
        webUserContactId: webUserContactId ?? this.webUserContactId,
        webUserUserId: webUserUserId ?? this.webUserUserId,
        webAccess: webAccess ?? this.webAccess,
        lockAccount: lockAccount ?? this.lockAccount,
        defaultDealId: defaultDealId ?? this.defaultDealId,
        defaultDeal: defaultDeal ?? this.defaultDeal,
        webCatalogId: webCatalogId ?? this.webCatalogId,
        webCatalog: webCatalog ?? this.webCatalog,
        locationId: locationId ?? this.locationId,
        location: location ?? this.location,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouse: warehouse ?? this.warehouse,
        webQuoteRequest: webQuoteRequest ?? this.webQuoteRequest,
        departmentId: departmentId ?? this.departmentId,
        department: department ?? this.department,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentContactContactDocument {
  WebApiModulesAgentContactContactDocument({
    this.contactId,
    this.copying,
    this.documentId,
    this.documentTypeId,
    this.uniqueId1,
    this.uniqueId2,
    this.uniqueId1Int,
    this.description,
    this.inputByUsersId,
    this.attachDate,
    this.attachTime,
    this.attachToEmail,
    this.inactive,
    this.dateStamp,
    this.extension,
    this.documentType,
    this.inputBy,
    this.hasImage,
    this.hasFile,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAgentContactContactDocument.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentContactContactDocumentFromJson(json);

  @JsonKey(name: 'ContactId')
  final String? contactId;
  @JsonKey(name: 'copying')
  final bool? copying;
  @JsonKey(name: 'DocumentId')
  final String? documentId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'UniqueId1')
  final String? uniqueId1;
  @JsonKey(name: 'UniqueId2')
  final String? uniqueId2;
  @JsonKey(name: 'UniqueId1Int')
  final int? uniqueId1Int;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'InputByUsersId')
  final String? inputByUsersId;
  @JsonKey(name: 'AttachDate')
  final String? attachDate;
  @JsonKey(name: 'AttachTime')
  final String? attachTime;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'Extension')
  final String? extension;
  @JsonKey(name: 'DocumentType')
  final String? documentType;
  @JsonKey(name: 'InputBy')
  final String? inputBy;
  @JsonKey(name: 'HasImage')
  final bool? hasImage;
  @JsonKey(name: 'HasFile')
  final bool? hasFile;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesAgentContactContactDocumentFromJson;
  static const toJsonFactory = _$WebApiModulesAgentContactContactDocumentToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentContactContactDocumentToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentContactContactDocument &&
            (identical(other.contactId, contactId) ||
                const DeepCollectionEquality()
                    .equals(other.contactId, contactId)) &&
            (identical(other.copying, copying) ||
                const DeepCollectionEquality()
                    .equals(other.copying, copying)) &&
            (identical(other.documentId, documentId) ||
                const DeepCollectionEquality()
                    .equals(other.documentId, documentId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.uniqueId1, uniqueId1) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1, uniqueId1)) &&
            (identical(other.uniqueId2, uniqueId2) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId2, uniqueId2)) &&
            (identical(other.uniqueId1Int, uniqueId1Int) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1Int, uniqueId1Int)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.inputByUsersId, inputByUsersId) ||
                const DeepCollectionEquality()
                    .equals(other.inputByUsersId, inputByUsersId)) &&
            (identical(other.attachDate, attachDate) ||
                const DeepCollectionEquality()
                    .equals(other.attachDate, attachDate)) &&
            (identical(other.attachTime, attachTime) ||
                const DeepCollectionEquality()
                    .equals(other.attachTime, attachTime)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.extension, extension) ||
                const DeepCollectionEquality()
                    .equals(other.extension, extension)) &&
            (identical(other.documentType, documentType) ||
                const DeepCollectionEquality()
                    .equals(other.documentType, documentType)) &&
            (identical(other.inputBy, inputBy) ||
                const DeepCollectionEquality()
                    .equals(other.inputBy, inputBy)) &&
            (identical(other.hasImage, hasImage) ||
                const DeepCollectionEquality()
                    .equals(other.hasImage, hasImage)) &&
            (identical(other.hasFile, hasFile) ||
                const DeepCollectionEquality()
                    .equals(other.hasFile, hasFile)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality().equals(other.filePath, filePath)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesAgentContactContactDocumentExtension
    on WebApiModulesAgentContactContactDocument {
  WebApiModulesAgentContactContactDocument copyWith(
      {String? contactId,
      bool? copying,
      String? documentId,
      String? documentTypeId,
      String? uniqueId1,
      String? uniqueId2,
      int? uniqueId1Int,
      String? description,
      String? inputByUsersId,
      String? attachDate,
      String? attachTime,
      bool? attachToEmail,
      bool? inactive,
      String? dateStamp,
      String? extension,
      String? documentType,
      String? inputBy,
      bool? hasImage,
      bool? hasFile,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAgentContactContactDocument(
        contactId: contactId ?? this.contactId,
        copying: copying ?? this.copying,
        documentId: documentId ?? this.documentId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        uniqueId1: uniqueId1 ?? this.uniqueId1,
        uniqueId2: uniqueId2 ?? this.uniqueId2,
        uniqueId1Int: uniqueId1Int ?? this.uniqueId1Int,
        description: description ?? this.description,
        inputByUsersId: inputByUsersId ?? this.inputByUsersId,
        attachDate: attachDate ?? this.attachDate,
        attachTime: attachTime ?? this.attachTime,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        dateStamp: dateStamp ?? this.dateStamp,
        extension: extension ?? this.extension,
        documentType: documentType ?? this.documentType,
        inputBy: inputBy ?? this.inputBy,
        hasImage: hasImage ?? this.hasImage,
        hasFile: hasFile ?? this.hasFile,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentContactContactDocumentPostRequest {
  WebApiModulesAgentContactContactDocumentPostRequest({
    this.contactId,
    this.documentTypeId,
    this.description,
    this.attachToEmail,
    this.inactive,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
  });

  factory WebApiModulesAgentContactContactDocumentPostRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentContactContactDocumentPostRequestFromJson(json);

  @JsonKey(name: 'ContactId')
  final String? contactId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  static const fromJsonFactory =
      _$WebApiModulesAgentContactContactDocumentPostRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentContactContactDocumentPostRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentContactContactDocumentPostRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentContactContactDocumentPostRequest &&
            (identical(other.contactId, contactId) ||
                const DeepCollectionEquality()
                    .equals(other.contactId, contactId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)));
  }
}

extension $WebApiModulesAgentContactContactDocumentPostRequestExtension
    on WebApiModulesAgentContactContactDocumentPostRequest {
  WebApiModulesAgentContactContactDocumentPostRequest copyWith(
      {String? contactId,
      String? documentTypeId,
      String? description,
      bool? attachToEmail,
      bool? inactive,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath}) {
    return WebApiModulesAgentContactContactDocumentPostRequest(
        contactId: contactId ?? this.contactId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        description: description ?? this.description,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentContactContactDocumentPutRequest {
  WebApiModulesAgentContactContactDocumentPutRequest({
    this.contactId,
    this.documentId,
    this.documentTypeId,
    this.description,
    this.attachToEmail,
    this.inactive,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
  });

  factory WebApiModulesAgentContactContactDocumentPutRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentContactContactDocumentPutRequestFromJson(json);

  @JsonKey(name: 'ContactId')
  final String? contactId;
  @JsonKey(name: 'DocumentId')
  final String? documentId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  static const fromJsonFactory =
      _$WebApiModulesAgentContactContactDocumentPutRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentContactContactDocumentPutRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentContactContactDocumentPutRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentContactContactDocumentPutRequest &&
            (identical(other.contactId, contactId) ||
                const DeepCollectionEquality()
                    .equals(other.contactId, contactId)) &&
            (identical(other.documentId, documentId) ||
                const DeepCollectionEquality()
                    .equals(other.documentId, documentId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)));
  }
}

extension $WebApiModulesAgentContactContactDocumentPutRequestExtension
    on WebApiModulesAgentContactContactDocumentPutRequest {
  WebApiModulesAgentContactContactDocumentPutRequest copyWith(
      {String? contactId,
      String? documentId,
      String? documentTypeId,
      String? description,
      bool? attachToEmail,
      bool? inactive,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath}) {
    return WebApiModulesAgentContactContactDocumentPutRequest(
        contactId: contactId ?? this.contactId,
        documentId: documentId ?? this.documentId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        description: description ?? this.description,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentCustomerCustomer {
  WebApiModulesAgentCustomerCustomer({
    this.customerId,
    this.customerNumber,
    this.officeLocationId,
    this.officeLocation,
    this.departmentId,
    this.department,
    this.customerTypeId,
    this.customerType,
    this.customerCategoryId,
    this.customerCategory,
    this.customer,
    this.address1,
    this.address2,
    this.city,
    this.state,
    this.countryId,
    this.country,
    this.zipCode,
    this.parentCustomerId,
    this.parentCustomer,
    this.phone,
    this.fax,
    this.phoneTollFree,
    this.otherPhone,
    this.webAddress,
    this.customerStatusId,
    this.customerStatus,
    this.statusAsOf,
    this.termsAndConditionsOnFile,
    this.billingAddressType,
    this.billToAttention1,
    this.billToAttention2,
    this.billToAddress1,
    this.billToAddress2,
    this.billToCity,
    this.billToState,
    this.billToCountryId,
    this.billToCountry,
    this.billToZipCode,
    this.paymentTermsId,
    this.paymentTerms,
    this.vehicleRentalAgreementComplete,
    this.useDiscountTemplate,
    this.discountTemplateId,
    this.discountTemplate,
    this.creditStatusId,
    this.creditStatus,
    this.creditStatusThroughDate,
    this.creditApplicationOnFile,
    this.creditUnlimited,
    this.creditLimit,
    this.creditBalance,
    this.creditAvailable,
    this.creditResponsiblePartyOnFile,
    this.creditResponsibleParty,
    this.tradeReferencesVerified,
    this.tradeReferencesVerifiedBy,
    this.tradeReferencesVerifiedOn,
    this.creditCardTypeId,
    this.creditCardType,
    this.creditCardLimit,
    this.creditCardNo,
    this.creditCardCode,
    this.creditCardExpirationMonth,
    this.creditCardExpirationYear,
    this.creditCardName,
    this.creditCardAuthorizationOnFile,
    this.insuranceCertificationOnFile,
    this.insuranceCertificationValidThrough,
    this.insuranceCoverageLiability,
    this.insuranceCoverageLiabilityDeductible,
    this.insuranceCoveragePropertyValue,
    this.insuranceCoveragePropertyValueDeductible,
    this.insuranceCompanyId,
    this.insuranceCompany,
    this.insuranceAgent,
    this.insuranceCompanyAddress1,
    this.insuranceCompanyAddress2,
    this.insuranceCompanyCity,
    this.insuranceCompanyState,
    this.insuranceCompanyZipCode,
    this.insuranceCompanyCountryId,
    this.insuranceCompanyCountry,
    this.insuranceCompanyPhone,
    this.insuranceCompanyFax,
    this.vehicleInsuranceCertficationOnFile,
    this.taxable,
    this.taxStateOfIncorporationId,
    this.taxStateOfIncorporation,
    this.taxFederalNo,
    this.nonTaxableYear,
    this.nonTaxableCertificateNo,
    this.nonTaxableCertificateValidThrough,
    this.nonTaxableCertificateOnFile,
    this.disableQuoteOrderActivity,
    this.disableRental,
    this.disableSales,
    this.disableFacilities,
    this.disableTransportation,
    this.disableLabor,
    this.disableMisc,
    this.disableRentalSale,
    this.disableSubRental,
    this.disableSubSale,
    this.disableSubLabor,
    this.disableSubMisc,
    this.splitRental,
    this.splitRentalTaxCustomer,
    this.ownedEquipmentSplitRentalPerecent,
    this.subRentalEquipmentSplitRentalPerecent,
    this.rebateRental,
    this.ownedEquipmentRebateRentalPerecent,
    this.subRentalEquipmentRebateRentalPerecent,
    this.splitRentalLogoFileName,
    this.splitRentalLogoWidth,
    this.splitRentalLogoHeight,
    this.shippingAddressType,
    this.shipAttention,
    this.shipAddress1,
    this.shipAddress2,
    this.shipCity,
    this.shipState,
    this.shipCountryId,
    this.shipCountry,
    this.shipZipCode,
    this.email,
    this.multipleCurrencies,
    this.currencyId,
    this.currencyCode,
    this.currencySymbol,
    this.securityDepositAmount,
    this.inactive,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAgentCustomerCustomer.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentCustomerCustomerFromJson(json);

  @JsonKey(name: 'CustomerId')
  final String? customerId;
  @JsonKey(name: 'CustomerNumber')
  final String? customerNumber;
  @JsonKey(name: 'OfficeLocationId')
  final String? officeLocationId;
  @JsonKey(name: 'OfficeLocation')
  final String? officeLocation;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'Department')
  final String? department;
  @JsonKey(name: 'CustomerTypeId')
  final String? customerTypeId;
  @JsonKey(name: 'CustomerType')
  final String? customerType;
  @JsonKey(name: 'CustomerCategoryId')
  final String? customerCategoryId;
  @JsonKey(name: 'CustomerCategory')
  final String? customerCategory;
  @JsonKey(name: 'Customer')
  final String? customer;
  @JsonKey(name: 'Address1')
  final String? address1;
  @JsonKey(name: 'Address2')
  final String? address2;
  @JsonKey(name: 'City')
  final String? city;
  @JsonKey(name: 'State')
  final String? state;
  @JsonKey(name: 'CountryId')
  final String? countryId;
  @JsonKey(name: 'Country')
  final String? country;
  @JsonKey(name: 'ZipCode')
  final String? zipCode;
  @JsonKey(name: 'ParentCustomerId')
  final String? parentCustomerId;
  @JsonKey(name: 'ParentCustomer')
  final String? parentCustomer;
  @JsonKey(name: 'Phone')
  final String? phone;
  @JsonKey(name: 'Fax')
  final String? fax;
  @JsonKey(name: 'PhoneTollFree')
  final String? phoneTollFree;
  @JsonKey(name: 'OtherPhone')
  final String? otherPhone;
  @JsonKey(name: 'WebAddress')
  final String? webAddress;
  @JsonKey(name: 'CustomerStatusId')
  final String? customerStatusId;
  @JsonKey(name: 'CustomerStatus')
  final String? customerStatus;
  @JsonKey(name: 'StatusAsOf')
  final String? statusAsOf;
  @JsonKey(name: 'TermsAndConditionsOnFile')
  final bool? termsAndConditionsOnFile;
  @JsonKey(name: 'BillingAddressType')
  final String? billingAddressType;
  @JsonKey(name: 'BillToAttention1')
  final String? billToAttention1;
  @JsonKey(name: 'BillToAttention2')
  final String? billToAttention2;
  @JsonKey(name: 'BillToAddress1')
  final String? billToAddress1;
  @JsonKey(name: 'BillToAddress2')
  final String? billToAddress2;
  @JsonKey(name: 'BillToCity')
  final String? billToCity;
  @JsonKey(name: 'BillToState')
  final String? billToState;
  @JsonKey(name: 'BillToCountryId')
  final String? billToCountryId;
  @JsonKey(name: 'BillToCountry')
  final String? billToCountry;
  @JsonKey(name: 'BillToZipCode')
  final String? billToZipCode;
  @JsonKey(name: 'PaymentTermsId')
  final String? paymentTermsId;
  @JsonKey(name: 'PaymentTerms')
  final String? paymentTerms;
  @JsonKey(name: 'VehicleRentalAgreementComplete')
  final bool? vehicleRentalAgreementComplete;
  @JsonKey(name: 'UseDiscountTemplate')
  final bool? useDiscountTemplate;
  @JsonKey(name: 'DiscountTemplateId')
  final String? discountTemplateId;
  @JsonKey(name: 'DiscountTemplate')
  final String? discountTemplate;
  @JsonKey(name: 'CreditStatusId')
  final String? creditStatusId;
  @JsonKey(name: 'CreditStatus')
  final String? creditStatus;
  @JsonKey(name: 'CreditStatusThroughDate')
  final String? creditStatusThroughDate;
  @JsonKey(name: 'CreditApplicationOnFile')
  final bool? creditApplicationOnFile;
  @JsonKey(name: 'CreditUnlimited')
  final bool? creditUnlimited;
  @JsonKey(name: 'CreditLimit')
  final int? creditLimit;
  @JsonKey(name: 'CreditBalance')
  final int? creditBalance;
  @JsonKey(name: 'CreditAvailable')
  final int? creditAvailable;
  @JsonKey(name: 'CreditResponsiblePartyOnFile')
  final bool? creditResponsiblePartyOnFile;
  @JsonKey(name: 'CreditResponsibleParty')
  final String? creditResponsibleParty;
  @JsonKey(name: 'TradeReferencesVerified')
  final bool? tradeReferencesVerified;
  @JsonKey(name: 'TradeReferencesVerifiedBy')
  final String? tradeReferencesVerifiedBy;
  @JsonKey(name: 'TradeReferencesVerifiedOn')
  final String? tradeReferencesVerifiedOn;
  @JsonKey(name: 'CreditCardTypeId')
  final String? creditCardTypeId;
  @JsonKey(name: 'CreditCardType')
  final String? creditCardType;
  @JsonKey(name: 'CreditCardLimit')
  final int? creditCardLimit;
  @JsonKey(name: 'CreditCardNo')
  final String? creditCardNo;
  @JsonKey(name: 'CreditCardCode')
  final String? creditCardCode;
  @JsonKey(name: 'CreditCardExpirationMonth')
  final int? creditCardExpirationMonth;
  @JsonKey(name: 'CreditCardExpirationYear')
  final int? creditCardExpirationYear;
  @JsonKey(name: 'CreditCardName')
  final String? creditCardName;
  @JsonKey(name: 'CreditCardAuthorizationOnFile')
  final bool? creditCardAuthorizationOnFile;
  @JsonKey(name: 'InsuranceCertificationOnFile')
  final bool? insuranceCertificationOnFile;
  @JsonKey(name: 'InsuranceCertificationValidThrough')
  final String? insuranceCertificationValidThrough;
  @JsonKey(name: 'InsuranceCoverageLiability')
  final int? insuranceCoverageLiability;
  @JsonKey(name: 'InsuranceCoverageLiabilityDeductible')
  final int? insuranceCoverageLiabilityDeductible;
  @JsonKey(name: 'InsuranceCoveragePropertyValue')
  final int? insuranceCoveragePropertyValue;
  @JsonKey(name: 'InsuranceCoveragePropertyValueDeductible')
  final int? insuranceCoveragePropertyValueDeductible;
  @JsonKey(name: 'InsuranceCompanyId')
  final String? insuranceCompanyId;
  @JsonKey(name: 'InsuranceCompany')
  final String? insuranceCompany;
  @JsonKey(name: 'InsuranceAgent')
  final String? insuranceAgent;
  @JsonKey(name: 'InsuranceCompanyAddress1')
  final String? insuranceCompanyAddress1;
  @JsonKey(name: 'InsuranceCompanyAddress2')
  final String? insuranceCompanyAddress2;
  @JsonKey(name: 'InsuranceCompanyCity')
  final String? insuranceCompanyCity;
  @JsonKey(name: 'InsuranceCompanyState')
  final String? insuranceCompanyState;
  @JsonKey(name: 'InsuranceCompanyZipCode')
  final String? insuranceCompanyZipCode;
  @JsonKey(name: 'InsuranceCompanyCountryId')
  final String? insuranceCompanyCountryId;
  @JsonKey(name: 'InsuranceCompanyCountry')
  final String? insuranceCompanyCountry;
  @JsonKey(name: 'InsuranceCompanyPhone')
  final String? insuranceCompanyPhone;
  @JsonKey(name: 'InsuranceCompanyFax')
  final String? insuranceCompanyFax;
  @JsonKey(name: 'VehicleInsuranceCertficationOnFile')
  final bool? vehicleInsuranceCertficationOnFile;
  @JsonKey(name: 'Taxable')
  final bool? taxable;
  @JsonKey(name: 'TaxStateOfIncorporationId')
  final String? taxStateOfIncorporationId;
  @JsonKey(name: 'TaxStateOfIncorporation')
  final String? taxStateOfIncorporation;
  @JsonKey(name: 'TaxFederalNo')
  final String? taxFederalNo;
  @JsonKey(name: 'NonTaxableYear')
  final int? nonTaxableYear;
  @JsonKey(name: 'NonTaxableCertificateNo')
  final String? nonTaxableCertificateNo;
  @JsonKey(name: 'NonTaxableCertificateValidThrough')
  final String? nonTaxableCertificateValidThrough;
  @JsonKey(name: 'NonTaxableCertificateOnFile')
  final bool? nonTaxableCertificateOnFile;
  @JsonKey(name: 'DisableQuoteOrderActivity')
  final bool? disableQuoteOrderActivity;
  @JsonKey(name: 'DisableRental')
  final bool? disableRental;
  @JsonKey(name: 'DisableSales')
  final bool? disableSales;
  @JsonKey(name: 'DisableFacilities')
  final bool? disableFacilities;
  @JsonKey(name: 'DisableTransportation')
  final bool? disableTransportation;
  @JsonKey(name: 'DisableLabor')
  final bool? disableLabor;
  @JsonKey(name: 'DisableMisc')
  final bool? disableMisc;
  @JsonKey(name: 'DisableRentalSale')
  final bool? disableRentalSale;
  @JsonKey(name: 'DisableSubRental')
  final bool? disableSubRental;
  @JsonKey(name: 'DisableSubSale')
  final bool? disableSubSale;
  @JsonKey(name: 'DisableSubLabor')
  final bool? disableSubLabor;
  @JsonKey(name: 'DisableSubMisc')
  final bool? disableSubMisc;
  @JsonKey(name: 'SplitRental')
  final bool? splitRental;
  @JsonKey(name: 'SplitRentalTaxCustomer')
  final bool? splitRentalTaxCustomer;
  @JsonKey(name: 'OwnedEquipmentSplitRentalPerecent')
  final int? ownedEquipmentSplitRentalPerecent;
  @JsonKey(name: 'SubRentalEquipmentSplitRentalPerecent')
  final int? subRentalEquipmentSplitRentalPerecent;
  @JsonKey(name: 'RebateRental')
  final bool? rebateRental;
  @JsonKey(name: 'OwnedEquipmentRebateRentalPerecent')
  final int? ownedEquipmentRebateRentalPerecent;
  @JsonKey(name: 'SubRentalEquipmentRebateRentalPerecent')
  final int? subRentalEquipmentRebateRentalPerecent;
  @JsonKey(name: 'SplitRentalLogoFileName')
  final String? splitRentalLogoFileName;
  @JsonKey(name: 'SplitRentalLogoWidth')
  final int? splitRentalLogoWidth;
  @JsonKey(name: 'SplitRentalLogoHeight')
  final int? splitRentalLogoHeight;
  @JsonKey(name: 'ShippingAddressType')
  final String? shippingAddressType;
  @JsonKey(name: 'ShipAttention')
  final String? shipAttention;
  @JsonKey(name: 'ShipAddress1')
  final String? shipAddress1;
  @JsonKey(name: 'ShipAddress2')
  final String? shipAddress2;
  @JsonKey(name: 'ShipCity')
  final String? shipCity;
  @JsonKey(name: 'ShipState')
  final String? shipState;
  @JsonKey(name: 'ShipCountryId')
  final String? shipCountryId;
  @JsonKey(name: 'ShipCountry')
  final String? shipCountry;
  @JsonKey(name: 'ShipZipCode')
  final String? shipZipCode;
  @JsonKey(name: 'Email')
  final String? email;
  @JsonKey(name: 'MultipleCurrencies')
  final bool? multipleCurrencies;
  @JsonKey(name: 'CurrencyId')
  final String? currencyId;
  @JsonKey(name: 'CurrencyCode')
  final String? currencyCode;
  @JsonKey(name: 'CurrencySymbol')
  final String? currencySymbol;
  @JsonKey(name: 'SecurityDepositAmount')
  final double? securityDepositAmount;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory = _$WebApiModulesAgentCustomerCustomerFromJson;
  static const toJsonFactory = _$WebApiModulesAgentCustomerCustomerToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentCustomerCustomerToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentCustomerCustomer &&
            (identical(other.customerId, customerId) ||
                const DeepCollectionEquality()
                    .equals(other.customerId, customerId)) &&
            (identical(other.customerNumber, customerNumber) ||
                const DeepCollectionEquality()
                    .equals(other.customerNumber, customerNumber)) &&
            (identical(other.officeLocationId, officeLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocationId, officeLocationId)) &&
            (identical(other.officeLocation, officeLocation) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocation, officeLocation)) &&
            (identical(other.departmentId, departmentId) ||
                const DeepCollectionEquality()
                    .equals(other.departmentId, departmentId)) &&
            (identical(other.department, department) ||
                const DeepCollectionEquality()
                    .equals(other.department, department)) &&
            (identical(other.customerTypeId, customerTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.customerTypeId, customerTypeId)) &&
            (identical(other.customerType, customerType) ||
                const DeepCollectionEquality()
                    .equals(other.customerType, customerType)) &&
            (identical(other.customerCategoryId, customerCategoryId) ||
                const DeepCollectionEquality()
                    .equals(other.customerCategoryId, customerCategoryId)) &&
            (identical(other.customerCategory, customerCategory) ||
                const DeepCollectionEquality()
                    .equals(other.customerCategory, customerCategory)) &&
            (identical(other.customer, customer) ||
                const DeepCollectionEquality()
                    .equals(other.customer, customer)) &&
            (identical(other.address1, address1) ||
                const DeepCollectionEquality()
                    .equals(other.address1, address1)) &&
            (identical(other.address2, address2) ||
                const DeepCollectionEquality()
                    .equals(other.address2, address2)) &&
            (identical(other.city, city) ||
                const DeepCollectionEquality().equals(other.city, city)) &&
            (identical(other.state, state) ||
                const DeepCollectionEquality().equals(other.state, state)) &&
            (identical(other.countryId, countryId) ||
                const DeepCollectionEquality()
                    .equals(other.countryId, countryId)) &&
            (identical(other.country, country) ||
                const DeepCollectionEquality()
                    .equals(other.country, country)) &&
            (identical(other.zipCode, zipCode) ||
                const DeepCollectionEquality()
                    .equals(other.zipCode, zipCode)) &&
            (identical(other.parentCustomerId, parentCustomerId) ||
                const DeepCollectionEquality()
                    .equals(other.parentCustomerId, parentCustomerId)) &&
            (identical(other.parentCustomer, parentCustomer) ||
                const DeepCollectionEquality()
                    .equals(other.parentCustomer, parentCustomer)) &&
            (identical(other.phone, phone) ||
                const DeepCollectionEquality().equals(other.phone, phone)) &&
            (identical(other.fax, fax) ||
                const DeepCollectionEquality().equals(other.fax, fax)) &&
            (identical(other.phoneTollFree, phoneTollFree) ||
                const DeepCollectionEquality()
                    .equals(other.phoneTollFree, phoneTollFree)) &&
            (identical(other.otherPhone, otherPhone) ||
                const DeepCollectionEquality().equals(other.otherPhone, otherPhone)) &&
            (identical(other.webAddress, webAddress) || const DeepCollectionEquality().equals(other.webAddress, webAddress)) &&
            (identical(other.customerStatusId, customerStatusId) || const DeepCollectionEquality().equals(other.customerStatusId, customerStatusId)) &&
            (identical(other.customerStatus, customerStatus) || const DeepCollectionEquality().equals(other.customerStatus, customerStatus)) &&
            (identical(other.statusAsOf, statusAsOf) || const DeepCollectionEquality().equals(other.statusAsOf, statusAsOf)) &&
            (identical(other.termsAndConditionsOnFile, termsAndConditionsOnFile) || const DeepCollectionEquality().equals(other.termsAndConditionsOnFile, termsAndConditionsOnFile)) &&
            (identical(other.billingAddressType, billingAddressType) || const DeepCollectionEquality().equals(other.billingAddressType, billingAddressType)) &&
            (identical(other.billToAttention1, billToAttention1) || const DeepCollectionEquality().equals(other.billToAttention1, billToAttention1)) &&
            (identical(other.billToAttention2, billToAttention2) || const DeepCollectionEquality().equals(other.billToAttention2, billToAttention2)) &&
            (identical(other.billToAddress1, billToAddress1) || const DeepCollectionEquality().equals(other.billToAddress1, billToAddress1)) &&
            (identical(other.billToAddress2, billToAddress2) || const DeepCollectionEquality().equals(other.billToAddress2, billToAddress2)) &&
            (identical(other.billToCity, billToCity) || const DeepCollectionEquality().equals(other.billToCity, billToCity)) &&
            (identical(other.billToState, billToState) || const DeepCollectionEquality().equals(other.billToState, billToState)) &&
            (identical(other.billToCountryId, billToCountryId) || const DeepCollectionEquality().equals(other.billToCountryId, billToCountryId)) &&
            (identical(other.billToCountry, billToCountry) || const DeepCollectionEquality().equals(other.billToCountry, billToCountry)) &&
            (identical(other.billToZipCode, billToZipCode) || const DeepCollectionEquality().equals(other.billToZipCode, billToZipCode)) &&
            (identical(other.paymentTermsId, paymentTermsId) || const DeepCollectionEquality().equals(other.paymentTermsId, paymentTermsId)) &&
            (identical(other.paymentTerms, paymentTerms) || const DeepCollectionEquality().equals(other.paymentTerms, paymentTerms)) &&
            (identical(other.vehicleRentalAgreementComplete, vehicleRentalAgreementComplete) || const DeepCollectionEquality().equals(other.vehicleRentalAgreementComplete, vehicleRentalAgreementComplete)) &&
            (identical(other.useDiscountTemplate, useDiscountTemplate) || const DeepCollectionEquality().equals(other.useDiscountTemplate, useDiscountTemplate)) &&
            (identical(other.discountTemplateId, discountTemplateId) || const DeepCollectionEquality().equals(other.discountTemplateId, discountTemplateId)) &&
            (identical(other.discountTemplate, discountTemplate) || const DeepCollectionEquality().equals(other.discountTemplate, discountTemplate)) &&
            (identical(other.creditStatusId, creditStatusId) || const DeepCollectionEquality().equals(other.creditStatusId, creditStatusId)) &&
            (identical(other.creditStatus, creditStatus) || const DeepCollectionEquality().equals(other.creditStatus, creditStatus)) &&
            (identical(other.creditStatusThroughDate, creditStatusThroughDate) || const DeepCollectionEquality().equals(other.creditStatusThroughDate, creditStatusThroughDate)) &&
            (identical(other.creditApplicationOnFile, creditApplicationOnFile) || const DeepCollectionEquality().equals(other.creditApplicationOnFile, creditApplicationOnFile)) &&
            (identical(other.creditUnlimited, creditUnlimited) || const DeepCollectionEquality().equals(other.creditUnlimited, creditUnlimited)) &&
            (identical(other.creditLimit, creditLimit) || const DeepCollectionEquality().equals(other.creditLimit, creditLimit)) &&
            (identical(other.creditBalance, creditBalance) || const DeepCollectionEquality().equals(other.creditBalance, creditBalance)) &&
            (identical(other.creditAvailable, creditAvailable) || const DeepCollectionEquality().equals(other.creditAvailable, creditAvailable)) &&
            (identical(other.creditResponsiblePartyOnFile, creditResponsiblePartyOnFile) || const DeepCollectionEquality().equals(other.creditResponsiblePartyOnFile, creditResponsiblePartyOnFile)) &&
            (identical(other.creditResponsibleParty, creditResponsibleParty) || const DeepCollectionEquality().equals(other.creditResponsibleParty, creditResponsibleParty)) &&
            (identical(other.tradeReferencesVerified, tradeReferencesVerified) || const DeepCollectionEquality().equals(other.tradeReferencesVerified, tradeReferencesVerified)) &&
            (identical(other.tradeReferencesVerifiedBy, tradeReferencesVerifiedBy) || const DeepCollectionEquality().equals(other.tradeReferencesVerifiedBy, tradeReferencesVerifiedBy)) &&
            (identical(other.tradeReferencesVerifiedOn, tradeReferencesVerifiedOn) || const DeepCollectionEquality().equals(other.tradeReferencesVerifiedOn, tradeReferencesVerifiedOn)) &&
            (identical(other.creditCardTypeId, creditCardTypeId) || const DeepCollectionEquality().equals(other.creditCardTypeId, creditCardTypeId)) &&
            (identical(other.creditCardType, creditCardType) || const DeepCollectionEquality().equals(other.creditCardType, creditCardType)) &&
            (identical(other.creditCardLimit, creditCardLimit) || const DeepCollectionEquality().equals(other.creditCardLimit, creditCardLimit)) &&
            (identical(other.creditCardNo, creditCardNo) || const DeepCollectionEquality().equals(other.creditCardNo, creditCardNo)) &&
            (identical(other.creditCardCode, creditCardCode) || const DeepCollectionEquality().equals(other.creditCardCode, creditCardCode)) &&
            (identical(other.creditCardExpirationMonth, creditCardExpirationMonth) || const DeepCollectionEquality().equals(other.creditCardExpirationMonth, creditCardExpirationMonth)) &&
            (identical(other.creditCardExpirationYear, creditCardExpirationYear) || const DeepCollectionEquality().equals(other.creditCardExpirationYear, creditCardExpirationYear)) &&
            (identical(other.creditCardName, creditCardName) || const DeepCollectionEquality().equals(other.creditCardName, creditCardName)) &&
            (identical(other.creditCardAuthorizationOnFile, creditCardAuthorizationOnFile) || const DeepCollectionEquality().equals(other.creditCardAuthorizationOnFile, creditCardAuthorizationOnFile)) &&
            (identical(other.insuranceCertificationOnFile, insuranceCertificationOnFile) || const DeepCollectionEquality().equals(other.insuranceCertificationOnFile, insuranceCertificationOnFile)) &&
            (identical(other.insuranceCertificationValidThrough, insuranceCertificationValidThrough) || const DeepCollectionEquality().equals(other.insuranceCertificationValidThrough, insuranceCertificationValidThrough)) &&
            (identical(other.insuranceCoverageLiability, insuranceCoverageLiability) || const DeepCollectionEquality().equals(other.insuranceCoverageLiability, insuranceCoverageLiability)) &&
            (identical(other.insuranceCoverageLiabilityDeductible, insuranceCoverageLiabilityDeductible) || const DeepCollectionEquality().equals(other.insuranceCoverageLiabilityDeductible, insuranceCoverageLiabilityDeductible)) &&
            (identical(other.insuranceCoveragePropertyValue, insuranceCoveragePropertyValue) || const DeepCollectionEquality().equals(other.insuranceCoveragePropertyValue, insuranceCoveragePropertyValue)) &&
            (identical(other.insuranceCoveragePropertyValueDeductible, insuranceCoveragePropertyValueDeductible) || const DeepCollectionEquality().equals(other.insuranceCoveragePropertyValueDeductible, insuranceCoveragePropertyValueDeductible)) &&
            (identical(other.insuranceCompanyId, insuranceCompanyId) || const DeepCollectionEquality().equals(other.insuranceCompanyId, insuranceCompanyId)) &&
            (identical(other.insuranceCompany, insuranceCompany) || const DeepCollectionEquality().equals(other.insuranceCompany, insuranceCompany)) &&
            (identical(other.insuranceAgent, insuranceAgent) || const DeepCollectionEquality().equals(other.insuranceAgent, insuranceAgent)) &&
            (identical(other.insuranceCompanyAddress1, insuranceCompanyAddress1) || const DeepCollectionEquality().equals(other.insuranceCompanyAddress1, insuranceCompanyAddress1)) &&
            (identical(other.insuranceCompanyAddress2, insuranceCompanyAddress2) || const DeepCollectionEquality().equals(other.insuranceCompanyAddress2, insuranceCompanyAddress2)) &&
            (identical(other.insuranceCompanyCity, insuranceCompanyCity) || const DeepCollectionEquality().equals(other.insuranceCompanyCity, insuranceCompanyCity)) &&
            (identical(other.insuranceCompanyState, insuranceCompanyState) || const DeepCollectionEquality().equals(other.insuranceCompanyState, insuranceCompanyState)) &&
            (identical(other.insuranceCompanyZipCode, insuranceCompanyZipCode) || const DeepCollectionEquality().equals(other.insuranceCompanyZipCode, insuranceCompanyZipCode)) &&
            (identical(other.insuranceCompanyCountryId, insuranceCompanyCountryId) || const DeepCollectionEquality().equals(other.insuranceCompanyCountryId, insuranceCompanyCountryId)) &&
            (identical(other.insuranceCompanyCountry, insuranceCompanyCountry) || const DeepCollectionEquality().equals(other.insuranceCompanyCountry, insuranceCompanyCountry)) &&
            (identical(other.insuranceCompanyPhone, insuranceCompanyPhone) || const DeepCollectionEquality().equals(other.insuranceCompanyPhone, insuranceCompanyPhone)) &&
            (identical(other.insuranceCompanyFax, insuranceCompanyFax) || const DeepCollectionEquality().equals(other.insuranceCompanyFax, insuranceCompanyFax)) &&
            (identical(other.vehicleInsuranceCertficationOnFile, vehicleInsuranceCertficationOnFile) || const DeepCollectionEquality().equals(other.vehicleInsuranceCertficationOnFile, vehicleInsuranceCertficationOnFile)) &&
            (identical(other.taxable, taxable) || const DeepCollectionEquality().equals(other.taxable, taxable)) &&
            (identical(other.taxStateOfIncorporationId, taxStateOfIncorporationId) || const DeepCollectionEquality().equals(other.taxStateOfIncorporationId, taxStateOfIncorporationId)) &&
            (identical(other.taxStateOfIncorporation, taxStateOfIncorporation) || const DeepCollectionEquality().equals(other.taxStateOfIncorporation, taxStateOfIncorporation)) &&
            (identical(other.taxFederalNo, taxFederalNo) || const DeepCollectionEquality().equals(other.taxFederalNo, taxFederalNo)) &&
            (identical(other.nonTaxableYear, nonTaxableYear) || const DeepCollectionEquality().equals(other.nonTaxableYear, nonTaxableYear)) &&
            (identical(other.nonTaxableCertificateNo, nonTaxableCertificateNo) || const DeepCollectionEquality().equals(other.nonTaxableCertificateNo, nonTaxableCertificateNo)) &&
            (identical(other.nonTaxableCertificateValidThrough, nonTaxableCertificateValidThrough) || const DeepCollectionEquality().equals(other.nonTaxableCertificateValidThrough, nonTaxableCertificateValidThrough)) &&
            (identical(other.nonTaxableCertificateOnFile, nonTaxableCertificateOnFile) || const DeepCollectionEquality().equals(other.nonTaxableCertificateOnFile, nonTaxableCertificateOnFile)) &&
            (identical(other.disableQuoteOrderActivity, disableQuoteOrderActivity) || const DeepCollectionEquality().equals(other.disableQuoteOrderActivity, disableQuoteOrderActivity)) &&
            (identical(other.disableRental, disableRental) || const DeepCollectionEquality().equals(other.disableRental, disableRental)) &&
            (identical(other.disableSales, disableSales) || const DeepCollectionEquality().equals(other.disableSales, disableSales)) &&
            (identical(other.disableFacilities, disableFacilities) || const DeepCollectionEquality().equals(other.disableFacilities, disableFacilities)) &&
            (identical(other.disableTransportation, disableTransportation) || const DeepCollectionEquality().equals(other.disableTransportation, disableTransportation)) &&
            (identical(other.disableLabor, disableLabor) || const DeepCollectionEquality().equals(other.disableLabor, disableLabor)) &&
            (identical(other.disableMisc, disableMisc) || const DeepCollectionEquality().equals(other.disableMisc, disableMisc)) &&
            (identical(other.disableRentalSale, disableRentalSale) || const DeepCollectionEquality().equals(other.disableRentalSale, disableRentalSale)) &&
            (identical(other.disableSubRental, disableSubRental) || const DeepCollectionEquality().equals(other.disableSubRental, disableSubRental)) &&
            (identical(other.disableSubSale, disableSubSale) || const DeepCollectionEquality().equals(other.disableSubSale, disableSubSale)) &&
            (identical(other.disableSubLabor, disableSubLabor) || const DeepCollectionEquality().equals(other.disableSubLabor, disableSubLabor)) &&
            (identical(other.disableSubMisc, disableSubMisc) || const DeepCollectionEquality().equals(other.disableSubMisc, disableSubMisc)) &&
            (identical(other.splitRental, splitRental) || const DeepCollectionEquality().equals(other.splitRental, splitRental)) &&
            (identical(other.splitRentalTaxCustomer, splitRentalTaxCustomer) || const DeepCollectionEquality().equals(other.splitRentalTaxCustomer, splitRentalTaxCustomer)) &&
            (identical(other.ownedEquipmentSplitRentalPerecent, ownedEquipmentSplitRentalPerecent) || const DeepCollectionEquality().equals(other.ownedEquipmentSplitRentalPerecent, ownedEquipmentSplitRentalPerecent)) &&
            (identical(other.subRentalEquipmentSplitRentalPerecent, subRentalEquipmentSplitRentalPerecent) || const DeepCollectionEquality().equals(other.subRentalEquipmentSplitRentalPerecent, subRentalEquipmentSplitRentalPerecent)) &&
            (identical(other.rebateRental, rebateRental) || const DeepCollectionEquality().equals(other.rebateRental, rebateRental)) &&
            (identical(other.ownedEquipmentRebateRentalPerecent, ownedEquipmentRebateRentalPerecent) || const DeepCollectionEquality().equals(other.ownedEquipmentRebateRentalPerecent, ownedEquipmentRebateRentalPerecent)) &&
            (identical(other.subRentalEquipmentRebateRentalPerecent, subRentalEquipmentRebateRentalPerecent) || const DeepCollectionEquality().equals(other.subRentalEquipmentRebateRentalPerecent, subRentalEquipmentRebateRentalPerecent)) &&
            (identical(other.splitRentalLogoFileName, splitRentalLogoFileName) || const DeepCollectionEquality().equals(other.splitRentalLogoFileName, splitRentalLogoFileName)) &&
            (identical(other.splitRentalLogoWidth, splitRentalLogoWidth) || const DeepCollectionEquality().equals(other.splitRentalLogoWidth, splitRentalLogoWidth)) &&
            (identical(other.splitRentalLogoHeight, splitRentalLogoHeight) || const DeepCollectionEquality().equals(other.splitRentalLogoHeight, splitRentalLogoHeight)) &&
            (identical(other.shippingAddressType, shippingAddressType) || const DeepCollectionEquality().equals(other.shippingAddressType, shippingAddressType)) &&
            (identical(other.shipAttention, shipAttention) || const DeepCollectionEquality().equals(other.shipAttention, shipAttention)) &&
            (identical(other.shipAddress1, shipAddress1) || const DeepCollectionEquality().equals(other.shipAddress1, shipAddress1)) &&
            (identical(other.shipAddress2, shipAddress2) || const DeepCollectionEquality().equals(other.shipAddress2, shipAddress2)) &&
            (identical(other.shipCity, shipCity) || const DeepCollectionEquality().equals(other.shipCity, shipCity)) &&
            (identical(other.shipState, shipState) || const DeepCollectionEquality().equals(other.shipState, shipState)) &&
            (identical(other.shipCountryId, shipCountryId) || const DeepCollectionEquality().equals(other.shipCountryId, shipCountryId)) &&
            (identical(other.shipCountry, shipCountry) || const DeepCollectionEquality().equals(other.shipCountry, shipCountry)) &&
            (identical(other.shipZipCode, shipZipCode) || const DeepCollectionEquality().equals(other.shipZipCode, shipZipCode)) &&
            (identical(other.email, email) || const DeepCollectionEquality().equals(other.email, email)) &&
            (identical(other.multipleCurrencies, multipleCurrencies) || const DeepCollectionEquality().equals(other.multipleCurrencies, multipleCurrencies)) &&
            (identical(other.currencyId, currencyId) || const DeepCollectionEquality().equals(other.currencyId, currencyId)) &&
            (identical(other.currencyCode, currencyCode) || const DeepCollectionEquality().equals(other.currencyCode, currencyCode)) &&
            (identical(other.currencySymbol, currencySymbol) || const DeepCollectionEquality().equals(other.currencySymbol, currencySymbol)) &&
            (identical(other.securityDepositAmount, securityDepositAmount) || const DeepCollectionEquality().equals(other.securityDepositAmount, securityDepositAmount)) &&
            (identical(other.inactive, inactive) || const DeepCollectionEquality().equals(other.inactive, inactive)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesAgentCustomerCustomerExtension
    on WebApiModulesAgentCustomerCustomer {
  WebApiModulesAgentCustomerCustomer copyWith(
      {String? customerId,
      String? customerNumber,
      String? officeLocationId,
      String? officeLocation,
      String? departmentId,
      String? department,
      String? customerTypeId,
      String? customerType,
      String? customerCategoryId,
      String? customerCategory,
      String? customer,
      String? address1,
      String? address2,
      String? city,
      String? state,
      String? countryId,
      String? country,
      String? zipCode,
      String? parentCustomerId,
      String? parentCustomer,
      String? phone,
      String? fax,
      String? phoneTollFree,
      String? otherPhone,
      String? webAddress,
      String? customerStatusId,
      String? customerStatus,
      String? statusAsOf,
      bool? termsAndConditionsOnFile,
      String? billingAddressType,
      String? billToAttention1,
      String? billToAttention2,
      String? billToAddress1,
      String? billToAddress2,
      String? billToCity,
      String? billToState,
      String? billToCountryId,
      String? billToCountry,
      String? billToZipCode,
      String? paymentTermsId,
      String? paymentTerms,
      bool? vehicleRentalAgreementComplete,
      bool? useDiscountTemplate,
      String? discountTemplateId,
      String? discountTemplate,
      String? creditStatusId,
      String? creditStatus,
      String? creditStatusThroughDate,
      bool? creditApplicationOnFile,
      bool? creditUnlimited,
      int? creditLimit,
      int? creditBalance,
      int? creditAvailable,
      bool? creditResponsiblePartyOnFile,
      String? creditResponsibleParty,
      bool? tradeReferencesVerified,
      String? tradeReferencesVerifiedBy,
      String? tradeReferencesVerifiedOn,
      String? creditCardTypeId,
      String? creditCardType,
      int? creditCardLimit,
      String? creditCardNo,
      String? creditCardCode,
      int? creditCardExpirationMonth,
      int? creditCardExpirationYear,
      String? creditCardName,
      bool? creditCardAuthorizationOnFile,
      bool? insuranceCertificationOnFile,
      String? insuranceCertificationValidThrough,
      int? insuranceCoverageLiability,
      int? insuranceCoverageLiabilityDeductible,
      int? insuranceCoveragePropertyValue,
      int? insuranceCoveragePropertyValueDeductible,
      String? insuranceCompanyId,
      String? insuranceCompany,
      String? insuranceAgent,
      String? insuranceCompanyAddress1,
      String? insuranceCompanyAddress2,
      String? insuranceCompanyCity,
      String? insuranceCompanyState,
      String? insuranceCompanyZipCode,
      String? insuranceCompanyCountryId,
      String? insuranceCompanyCountry,
      String? insuranceCompanyPhone,
      String? insuranceCompanyFax,
      bool? vehicleInsuranceCertficationOnFile,
      bool? taxable,
      String? taxStateOfIncorporationId,
      String? taxStateOfIncorporation,
      String? taxFederalNo,
      int? nonTaxableYear,
      String? nonTaxableCertificateNo,
      String? nonTaxableCertificateValidThrough,
      bool? nonTaxableCertificateOnFile,
      bool? disableQuoteOrderActivity,
      bool? disableRental,
      bool? disableSales,
      bool? disableFacilities,
      bool? disableTransportation,
      bool? disableLabor,
      bool? disableMisc,
      bool? disableRentalSale,
      bool? disableSubRental,
      bool? disableSubSale,
      bool? disableSubLabor,
      bool? disableSubMisc,
      bool? splitRental,
      bool? splitRentalTaxCustomer,
      int? ownedEquipmentSplitRentalPerecent,
      int? subRentalEquipmentSplitRentalPerecent,
      bool? rebateRental,
      int? ownedEquipmentRebateRentalPerecent,
      int? subRentalEquipmentRebateRentalPerecent,
      String? splitRentalLogoFileName,
      int? splitRentalLogoWidth,
      int? splitRentalLogoHeight,
      String? shippingAddressType,
      String? shipAttention,
      String? shipAddress1,
      String? shipAddress2,
      String? shipCity,
      String? shipState,
      String? shipCountryId,
      String? shipCountry,
      String? shipZipCode,
      String? email,
      bool? multipleCurrencies,
      String? currencyId,
      String? currencyCode,
      String? currencySymbol,
      double? securityDepositAmount,
      bool? inactive,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAgentCustomerCustomer(
        customerId: customerId ?? this.customerId,
        customerNumber: customerNumber ?? this.customerNumber,
        officeLocationId: officeLocationId ?? this.officeLocationId,
        officeLocation: officeLocation ?? this.officeLocation,
        departmentId: departmentId ?? this.departmentId,
        department: department ?? this.department,
        customerTypeId: customerTypeId ?? this.customerTypeId,
        customerType: customerType ?? this.customerType,
        customerCategoryId: customerCategoryId ?? this.customerCategoryId,
        customerCategory: customerCategory ?? this.customerCategory,
        customer: customer ?? this.customer,
        address1: address1 ?? this.address1,
        address2: address2 ?? this.address2,
        city: city ?? this.city,
        state: state ?? this.state,
        countryId: countryId ?? this.countryId,
        country: country ?? this.country,
        zipCode: zipCode ?? this.zipCode,
        parentCustomerId: parentCustomerId ?? this.parentCustomerId,
        parentCustomer: parentCustomer ?? this.parentCustomer,
        phone: phone ?? this.phone,
        fax: fax ?? this.fax,
        phoneTollFree: phoneTollFree ?? this.phoneTollFree,
        otherPhone: otherPhone ?? this.otherPhone,
        webAddress: webAddress ?? this.webAddress,
        customerStatusId: customerStatusId ?? this.customerStatusId,
        customerStatus: customerStatus ?? this.customerStatus,
        statusAsOf: statusAsOf ?? this.statusAsOf,
        termsAndConditionsOnFile:
            termsAndConditionsOnFile ?? this.termsAndConditionsOnFile,
        billingAddressType: billingAddressType ?? this.billingAddressType,
        billToAttention1: billToAttention1 ?? this.billToAttention1,
        billToAttention2: billToAttention2 ?? this.billToAttention2,
        billToAddress1: billToAddress1 ?? this.billToAddress1,
        billToAddress2: billToAddress2 ?? this.billToAddress2,
        billToCity: billToCity ?? this.billToCity,
        billToState: billToState ?? this.billToState,
        billToCountryId: billToCountryId ?? this.billToCountryId,
        billToCountry: billToCountry ?? this.billToCountry,
        billToZipCode: billToZipCode ?? this.billToZipCode,
        paymentTermsId: paymentTermsId ?? this.paymentTermsId,
        paymentTerms: paymentTerms ?? this.paymentTerms,
        vehicleRentalAgreementComplete: vehicleRentalAgreementComplete ??
            this.vehicleRentalAgreementComplete,
        useDiscountTemplate: useDiscountTemplate ?? this.useDiscountTemplate,
        discountTemplateId: discountTemplateId ?? this.discountTemplateId,
        discountTemplate: discountTemplate ?? this.discountTemplate,
        creditStatusId: creditStatusId ?? this.creditStatusId,
        creditStatus: creditStatus ?? this.creditStatus,
        creditStatusThroughDate:
            creditStatusThroughDate ?? this.creditStatusThroughDate,
        creditApplicationOnFile:
            creditApplicationOnFile ?? this.creditApplicationOnFile,
        creditUnlimited: creditUnlimited ?? this.creditUnlimited,
        creditLimit: creditLimit ?? this.creditLimit,
        creditBalance: creditBalance ?? this.creditBalance,
        creditAvailable: creditAvailable ?? this.creditAvailable,
        creditResponsiblePartyOnFile:
            creditResponsiblePartyOnFile ?? this.creditResponsiblePartyOnFile,
        creditResponsibleParty:
            creditResponsibleParty ?? this.creditResponsibleParty,
        tradeReferencesVerified:
            tradeReferencesVerified ?? this.tradeReferencesVerified,
        tradeReferencesVerifiedBy:
            tradeReferencesVerifiedBy ?? this.tradeReferencesVerifiedBy,
        tradeReferencesVerifiedOn:
            tradeReferencesVerifiedOn ?? this.tradeReferencesVerifiedOn,
        creditCardTypeId: creditCardTypeId ?? this.creditCardTypeId,
        creditCardType: creditCardType ?? this.creditCardType,
        creditCardLimit: creditCardLimit ?? this.creditCardLimit,
        creditCardNo: creditCardNo ?? this.creditCardNo,
        creditCardCode: creditCardCode ?? this.creditCardCode,
        creditCardExpirationMonth:
            creditCardExpirationMonth ?? this.creditCardExpirationMonth,
        creditCardExpirationYear:
            creditCardExpirationYear ?? this.creditCardExpirationYear,
        creditCardName: creditCardName ?? this.creditCardName,
        creditCardAuthorizationOnFile:
            creditCardAuthorizationOnFile ?? this.creditCardAuthorizationOnFile,
        insuranceCertificationOnFile:
            insuranceCertificationOnFile ?? this.insuranceCertificationOnFile,
        insuranceCertificationValidThrough: insuranceCertificationValidThrough ??
            this.insuranceCertificationValidThrough,
        insuranceCoverageLiability:
            insuranceCoverageLiability ?? this.insuranceCoverageLiability,
        insuranceCoverageLiabilityDeductible: insuranceCoverageLiabilityDeductible ??
            this.insuranceCoverageLiabilityDeductible,
        insuranceCoveragePropertyValue: insuranceCoveragePropertyValue ??
            this.insuranceCoveragePropertyValue,
        insuranceCoveragePropertyValueDeductible:
            insuranceCoveragePropertyValueDeductible ??
                this.insuranceCoveragePropertyValueDeductible,
        insuranceCompanyId: insuranceCompanyId ?? this.insuranceCompanyId,
        insuranceCompany: insuranceCompany ?? this.insuranceCompany,
        insuranceAgent: insuranceAgent ?? this.insuranceAgent,
        insuranceCompanyAddress1:
            insuranceCompanyAddress1 ?? this.insuranceCompanyAddress1,
        insuranceCompanyAddress2:
            insuranceCompanyAddress2 ?? this.insuranceCompanyAddress2,
        insuranceCompanyCity: insuranceCompanyCity ?? this.insuranceCompanyCity,
        insuranceCompanyState:
            insuranceCompanyState ?? this.insuranceCompanyState,
        insuranceCompanyZipCode:
            insuranceCompanyZipCode ?? this.insuranceCompanyZipCode,
        insuranceCompanyCountryId:
            insuranceCompanyCountryId ?? this.insuranceCompanyCountryId,
        insuranceCompanyCountry:
            insuranceCompanyCountry ?? this.insuranceCompanyCountry,
        insuranceCompanyPhone:
            insuranceCompanyPhone ?? this.insuranceCompanyPhone,
        insuranceCompanyFax: insuranceCompanyFax ?? this.insuranceCompanyFax,
        vehicleInsuranceCertficationOnFile: vehicleInsuranceCertficationOnFile ??
            this.vehicleInsuranceCertficationOnFile,
        taxable: taxable ?? this.taxable,
        taxStateOfIncorporationId:
            taxStateOfIncorporationId ?? this.taxStateOfIncorporationId,
        taxStateOfIncorporation:
            taxStateOfIncorporation ?? this.taxStateOfIncorporation,
        taxFederalNo: taxFederalNo ?? this.taxFederalNo,
        nonTaxableYear: nonTaxableYear ?? this.nonTaxableYear,
        nonTaxableCertificateNo:
            nonTaxableCertificateNo ?? this.nonTaxableCertificateNo,
        nonTaxableCertificateValidThrough: nonTaxableCertificateValidThrough ??
            this.nonTaxableCertificateValidThrough,
        nonTaxableCertificateOnFile:
            nonTaxableCertificateOnFile ?? this.nonTaxableCertificateOnFile,
        disableQuoteOrderActivity:
            disableQuoteOrderActivity ?? this.disableQuoteOrderActivity,
        disableRental: disableRental ?? this.disableRental,
        disableSales: disableSales ?? this.disableSales,
        disableFacilities: disableFacilities ?? this.disableFacilities,
        disableTransportation:
            disableTransportation ?? this.disableTransportation,
        disableLabor: disableLabor ?? this.disableLabor,
        disableMisc: disableMisc ?? this.disableMisc,
        disableRentalSale: disableRentalSale ?? this.disableRentalSale,
        disableSubRental: disableSubRental ?? this.disableSubRental,
        disableSubSale: disableSubSale ?? this.disableSubSale,
        disableSubLabor: disableSubLabor ?? this.disableSubLabor,
        disableSubMisc: disableSubMisc ?? this.disableSubMisc,
        splitRental: splitRental ?? this.splitRental,
        splitRentalTaxCustomer:
            splitRentalTaxCustomer ?? this.splitRentalTaxCustomer,
        ownedEquipmentSplitRentalPerecent: ownedEquipmentSplitRentalPerecent ??
            this.ownedEquipmentSplitRentalPerecent,
        subRentalEquipmentSplitRentalPerecent: subRentalEquipmentSplitRentalPerecent ?? this.subRentalEquipmentSplitRentalPerecent,
        rebateRental: rebateRental ?? this.rebateRental,
        ownedEquipmentRebateRentalPerecent: ownedEquipmentRebateRentalPerecent ?? this.ownedEquipmentRebateRentalPerecent,
        subRentalEquipmentRebateRentalPerecent: subRentalEquipmentRebateRentalPerecent ?? this.subRentalEquipmentRebateRentalPerecent,
        splitRentalLogoFileName: splitRentalLogoFileName ?? this.splitRentalLogoFileName,
        splitRentalLogoWidth: splitRentalLogoWidth ?? this.splitRentalLogoWidth,
        splitRentalLogoHeight: splitRentalLogoHeight ?? this.splitRentalLogoHeight,
        shippingAddressType: shippingAddressType ?? this.shippingAddressType,
        shipAttention: shipAttention ?? this.shipAttention,
        shipAddress1: shipAddress1 ?? this.shipAddress1,
        shipAddress2: shipAddress2 ?? this.shipAddress2,
        shipCity: shipCity ?? this.shipCity,
        shipState: shipState ?? this.shipState,
        shipCountryId: shipCountryId ?? this.shipCountryId,
        shipCountry: shipCountry ?? this.shipCountry,
        shipZipCode: shipZipCode ?? this.shipZipCode,
        email: email ?? this.email,
        multipleCurrencies: multipleCurrencies ?? this.multipleCurrencies,
        currencyId: currencyId ?? this.currencyId,
        currencyCode: currencyCode ?? this.currencyCode,
        currencySymbol: currencySymbol ?? this.currencySymbol,
        securityDepositAmount: securityDepositAmount ?? this.securityDepositAmount,
        inactive: inactive ?? this.inactive,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes: defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentCustomerCustomerDocument {
  WebApiModulesAgentCustomerCustomerDocument({
    this.customerId,
    this.copying,
    this.documentId,
    this.documentTypeId,
    this.uniqueId1,
    this.uniqueId2,
    this.uniqueId1Int,
    this.description,
    this.inputByUsersId,
    this.attachDate,
    this.attachTime,
    this.attachToEmail,
    this.inactive,
    this.dateStamp,
    this.extension,
    this.documentType,
    this.inputBy,
    this.hasImage,
    this.hasFile,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAgentCustomerCustomerDocument.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentCustomerCustomerDocumentFromJson(json);

  @JsonKey(name: 'CustomerId')
  final String? customerId;
  @JsonKey(name: 'copying')
  final bool? copying;
  @JsonKey(name: 'DocumentId')
  final String? documentId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'UniqueId1')
  final String? uniqueId1;
  @JsonKey(name: 'UniqueId2')
  final String? uniqueId2;
  @JsonKey(name: 'UniqueId1Int')
  final int? uniqueId1Int;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'InputByUsersId')
  final String? inputByUsersId;
  @JsonKey(name: 'AttachDate')
  final String? attachDate;
  @JsonKey(name: 'AttachTime')
  final String? attachTime;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'Extension')
  final String? extension;
  @JsonKey(name: 'DocumentType')
  final String? documentType;
  @JsonKey(name: 'InputBy')
  final String? inputBy;
  @JsonKey(name: 'HasImage')
  final bool? hasImage;
  @JsonKey(name: 'HasFile')
  final bool? hasFile;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesAgentCustomerCustomerDocumentFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentCustomerCustomerDocumentToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentCustomerCustomerDocumentToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentCustomerCustomerDocument &&
            (identical(other.customerId, customerId) ||
                const DeepCollectionEquality()
                    .equals(other.customerId, customerId)) &&
            (identical(other.copying, copying) ||
                const DeepCollectionEquality()
                    .equals(other.copying, copying)) &&
            (identical(other.documentId, documentId) ||
                const DeepCollectionEquality()
                    .equals(other.documentId, documentId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.uniqueId1, uniqueId1) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1, uniqueId1)) &&
            (identical(other.uniqueId2, uniqueId2) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId2, uniqueId2)) &&
            (identical(other.uniqueId1Int, uniqueId1Int) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1Int, uniqueId1Int)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.inputByUsersId, inputByUsersId) ||
                const DeepCollectionEquality()
                    .equals(other.inputByUsersId, inputByUsersId)) &&
            (identical(other.attachDate, attachDate) ||
                const DeepCollectionEquality()
                    .equals(other.attachDate, attachDate)) &&
            (identical(other.attachTime, attachTime) ||
                const DeepCollectionEquality()
                    .equals(other.attachTime, attachTime)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.extension, extension) ||
                const DeepCollectionEquality()
                    .equals(other.extension, extension)) &&
            (identical(other.documentType, documentType) ||
                const DeepCollectionEquality()
                    .equals(other.documentType, documentType)) &&
            (identical(other.inputBy, inputBy) ||
                const DeepCollectionEquality()
                    .equals(other.inputBy, inputBy)) &&
            (identical(other.hasImage, hasImage) ||
                const DeepCollectionEquality()
                    .equals(other.hasImage, hasImage)) &&
            (identical(other.hasFile, hasFile) ||
                const DeepCollectionEquality()
                    .equals(other.hasFile, hasFile)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality().equals(other.filePath, filePath)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesAgentCustomerCustomerDocumentExtension
    on WebApiModulesAgentCustomerCustomerDocument {
  WebApiModulesAgentCustomerCustomerDocument copyWith(
      {String? customerId,
      bool? copying,
      String? documentId,
      String? documentTypeId,
      String? uniqueId1,
      String? uniqueId2,
      int? uniqueId1Int,
      String? description,
      String? inputByUsersId,
      String? attachDate,
      String? attachTime,
      bool? attachToEmail,
      bool? inactive,
      String? dateStamp,
      String? extension,
      String? documentType,
      String? inputBy,
      bool? hasImage,
      bool? hasFile,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAgentCustomerCustomerDocument(
        customerId: customerId ?? this.customerId,
        copying: copying ?? this.copying,
        documentId: documentId ?? this.documentId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        uniqueId1: uniqueId1 ?? this.uniqueId1,
        uniqueId2: uniqueId2 ?? this.uniqueId2,
        uniqueId1Int: uniqueId1Int ?? this.uniqueId1Int,
        description: description ?? this.description,
        inputByUsersId: inputByUsersId ?? this.inputByUsersId,
        attachDate: attachDate ?? this.attachDate,
        attachTime: attachTime ?? this.attachTime,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        dateStamp: dateStamp ?? this.dateStamp,
        extension: extension ?? this.extension,
        documentType: documentType ?? this.documentType,
        inputBy: inputBy ?? this.inputBy,
        hasImage: hasImage ?? this.hasImage,
        hasFile: hasFile ?? this.hasFile,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentCustomerCustomerDocumentPostRequest {
  WebApiModulesAgentCustomerCustomerDocumentPostRequest({
    this.customerId,
    this.documentTypeId,
    this.description,
    this.attachToEmail,
    this.inactive,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
  });

  factory WebApiModulesAgentCustomerCustomerDocumentPostRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentCustomerCustomerDocumentPostRequestFromJson(json);

  @JsonKey(name: 'CustomerId')
  final String? customerId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  static const fromJsonFactory =
      _$WebApiModulesAgentCustomerCustomerDocumentPostRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentCustomerCustomerDocumentPostRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentCustomerCustomerDocumentPostRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentCustomerCustomerDocumentPostRequest &&
            (identical(other.customerId, customerId) ||
                const DeepCollectionEquality()
                    .equals(other.customerId, customerId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)));
  }
}

extension $WebApiModulesAgentCustomerCustomerDocumentPostRequestExtension
    on WebApiModulesAgentCustomerCustomerDocumentPostRequest {
  WebApiModulesAgentCustomerCustomerDocumentPostRequest copyWith(
      {String? customerId,
      String? documentTypeId,
      String? description,
      bool? attachToEmail,
      bool? inactive,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath}) {
    return WebApiModulesAgentCustomerCustomerDocumentPostRequest(
        customerId: customerId ?? this.customerId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        description: description ?? this.description,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentCustomerCustomerDocumentPutRequest {
  WebApiModulesAgentCustomerCustomerDocumentPutRequest({
    this.customerId,
    this.documentId,
    this.documentTypeId,
    this.description,
    this.attachToEmail,
    this.inactive,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
  });

  factory WebApiModulesAgentCustomerCustomerDocumentPutRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentCustomerCustomerDocumentPutRequestFromJson(json);

  @JsonKey(name: 'CustomerId')
  final String? customerId;
  @JsonKey(name: 'DocumentId')
  final String? documentId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  static const fromJsonFactory =
      _$WebApiModulesAgentCustomerCustomerDocumentPutRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentCustomerCustomerDocumentPutRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentCustomerCustomerDocumentPutRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentCustomerCustomerDocumentPutRequest &&
            (identical(other.customerId, customerId) ||
                const DeepCollectionEquality()
                    .equals(other.customerId, customerId)) &&
            (identical(other.documentId, documentId) ||
                const DeepCollectionEquality()
                    .equals(other.documentId, documentId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)));
  }
}

extension $WebApiModulesAgentCustomerCustomerDocumentPutRequestExtension
    on WebApiModulesAgentCustomerCustomerDocumentPutRequest {
  WebApiModulesAgentCustomerCustomerDocumentPutRequest copyWith(
      {String? customerId,
      String? documentId,
      String? documentTypeId,
      String? description,
      bool? attachToEmail,
      bool? inactive,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath}) {
    return WebApiModulesAgentCustomerCustomerDocumentPutRequest(
        customerId: customerId ?? this.customerId,
        documentId: documentId ?? this.documentId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        description: description ?? this.description,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentDealCopyContactsFromCustomerResponse {
  WebApiModulesAgentDealCopyContactsFromCustomerResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesAgentDealCopyContactsFromCustomerResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentDealCopyContactsFromCustomerResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesAgentDealCopyContactsFromCustomerResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentDealCopyContactsFromCustomerResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentDealCopyContactsFromCustomerResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentDealCopyContactsFromCustomerResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesAgentDealCopyContactsFromCustomerResponseExtension
    on WebApiModulesAgentDealCopyContactsFromCustomerResponse {
  WebApiModulesAgentDealCopyContactsFromCustomerResponse copyWith(
      {int? status, bool? success, String? msg}) {
    return WebApiModulesAgentDealCopyContactsFromCustomerResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentDealDeal {
  WebApiModulesAgentDealDeal({
    this.dealId,
    this.deal,
    this.dealNumber,
    this.customerId,
    this.customer,
    this.customerNumber,
    this.officeLocationId,
    this.officeLocation,
    this.dealTypeId,
    this.dealType,
    this.address1,
    this.address2,
    this.city,
    this.state,
    this.zipCode,
    this.countryId,
    this.country,
    this.phone,
    this.phoneTollFree,
    this.fax,
    this.phoneOther,
    this.departmentId,
    this.department,
    this.csrId,
    this.csr,
    this.defaultAgentId,
    this.defaultAgent,
    this.defaultProjectManagerId,
    this.defaultProjectManager,
    this.dealClassificationId,
    this.dealClassification,
    this.productionTypeId,
    this.productionType,
    this.dealStatusId,
    this.dealStatus,
    this.statusAsOf,
    this.expectedWrapDate,
    this.billingCycleId,
    this.billingCycle,
    this.paymentTermsId,
    this.paymentTerms,
    this.paymentTypeId,
    this.paymentType,
    this.defaultRate,
    this.multipleCurrencies,
    this.currencyId,
    this.currencyCode,
    this.currencySymbol,
    this.useCustomerDiscount,
    this.customerDiscountTemplateId,
    this.useDiscountTemplate,
    this.discountTemplateId,
    this.discountTemplate,
    this.rentalDaysPerWeek,
    this.rentalDiscountPercent,
    this.salesDiscountPercent,
    this.facilitiesDaysPerWeek,
    this.facilitiesDiscountPercent,
    this.outsideSalesRepresentativeId,
    this.outsideSalesRepresentative,
    this.commissionRate,
    this.commissionIncludesVendorItems,
    this.poRequired,
    this.poType,
    this.billToAddressType,
    this.billToAttention1,
    this.billToAttention2,
    this.billToAddress1,
    this.billToAddress2,
    this.billToCity,
    this.billToState,
    this.billToCountryId,
    this.billToCountry,
    this.billToZipCode,
    this.assessFinanceCharge,
    this.allowBillingScheduleOverride,
    this.allowRebateCreditInvoices,
    this.useCustomerCredit,
    this.creditStatusId,
    this.creditStatus,
    this.creditStatusThrough,
    this.creditApplicationOnFile,
    this.unlimitedCredit,
    this.creditLimit,
    this.creditBalance,
    this.creditAvailable,
    this.customerCreditLimit,
    this.customerCreditBalance,
    this.customerCreditAvailable,
    this.creditResponsiblePartyOnFile,
    this.creditResponsibleParty,
    this.tradeReferencesVerified,
    this.tradeReferencesVerifiedBy,
    this.tradeReferencesVerifiedOn,
    this.creditCardTypeId,
    this.creditCardType,
    this.creditCardLimit,
    this.creditCardNumber,
    this.creditCardCode,
    this.creditCardName,
    this.creditCardExpirationMonth,
    this.creditCardExpirationYear,
    this.creditCardAuthorizationFormOnFile,
    this.depletingDepositThresholdAmount,
    this.depletingDepositThresholdPercent,
    this.depletingDepositTotal,
    this.depletingDepositApplied,
    this.depletingDepositRemaining,
    this.useCustomerInsurance,
    this.insuranceCertification,
    this.insuranceCertificationValidThrough,
    this.insuranceCoverageLiability,
    this.insuranceCoverageLiabilityDeductible,
    this.insuranceCoverageProperty,
    this.insuranceCoveragePropertyDeductible,
    this.securityDepositAmount,
    this.insuranceCompanyId,
    this.insuranceCompany,
    this.insuranceCompanyAgent,
    this.insuranceCompanyAddress1,
    this.insuranceCompanyAddress2,
    this.insuranceCompanyCity,
    this.insuranceCompanyState,
    this.insuranceCompanyZipCode,
    this.insuranceCompanyCountryId,
    this.insuranceCompanyCountry,
    this.insuranceCompanyPhone,
    this.insuranceCompanyFax,
    this.vehicleInsuranceCertification,
    this.useCustomerTax,
    this.taxable,
    this.taxStateOfIncorporationId,
    this.taxStateOfIncorporation,
    this.taxFederalNo,
    this.nonTaxableYear,
    this.nonTaxableCertificateNo,
    this.nonTaxableCertificateValidThrough,
    this.nonTaxableCertificateOnFile,
    this.disableQuoteOrderActivity,
    this.disableRental,
    this.disableSales,
    this.disableFacilities,
    this.disableTransportation,
    this.disableLabor,
    this.disableMisc,
    this.disableRentalSale,
    this.disableSubRental,
    this.disableSubSale,
    this.disableSubLabor,
    this.disableSubMisc,
    this.defaultOutgoingDeliveryType,
    this.defaultIncomingDeliveryType,
    this.shippingAddressType,
    this.shipAttention,
    this.shipAddress1,
    this.shipAddress2,
    this.shipCity,
    this.shipState,
    this.shipCountryId,
    this.shipCountry,
    this.shipZipCode,
    this.rebateRental,
    this.rebateCustomerId,
    this.rebateCustomer,
    this.ownedEquipmentRebateRentalPerecent,
    this.subRentalEquipmentRebateRentalPerecent,
    this.enableWebQuoteRequest,
    this.email,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAgentDealDeal.fromJson(Map<String, dynamic> json) =>
      _$WebApiModulesAgentDealDealFromJson(json);

  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'Deal')
  final String? deal;
  @JsonKey(name: 'DealNumber')
  final String? dealNumber;
  @JsonKey(name: 'CustomerId')
  final String? customerId;
  @JsonKey(name: 'Customer')
  final String? customer;
  @JsonKey(name: 'CustomerNumber')
  final String? customerNumber;
  @JsonKey(name: 'OfficeLocationId')
  final String? officeLocationId;
  @JsonKey(name: 'OfficeLocation')
  final String? officeLocation;
  @JsonKey(name: 'DealTypeId')
  final String? dealTypeId;
  @JsonKey(name: 'DealType')
  final String? dealType;
  @JsonKey(name: 'Address1')
  final String? address1;
  @JsonKey(name: 'Address2')
  final String? address2;
  @JsonKey(name: 'City')
  final String? city;
  @JsonKey(name: 'State')
  final String? state;
  @JsonKey(name: 'ZipCode')
  final String? zipCode;
  @JsonKey(name: 'CountryId')
  final String? countryId;
  @JsonKey(name: 'Country')
  final String? country;
  @JsonKey(name: 'Phone')
  final String? phone;
  @JsonKey(name: 'PhoneTollFree')
  final String? phoneTollFree;
  @JsonKey(name: 'Fax')
  final String? fax;
  @JsonKey(name: 'PhoneOther')
  final String? phoneOther;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'Department')
  final String? department;
  @JsonKey(name: 'CsrId')
  final String? csrId;
  @JsonKey(name: 'Csr')
  final String? csr;
  @JsonKey(name: 'DefaultAgentId')
  final String? defaultAgentId;
  @JsonKey(name: 'DefaultAgent')
  final String? defaultAgent;
  @JsonKey(name: 'DefaultProjectManagerId')
  final String? defaultProjectManagerId;
  @JsonKey(name: 'DefaultProjectManager')
  final String? defaultProjectManager;
  @JsonKey(name: 'DealClassificationId')
  final String? dealClassificationId;
  @JsonKey(name: 'DealClassification')
  final String? dealClassification;
  @JsonKey(name: 'ProductionTypeId')
  final String? productionTypeId;
  @JsonKey(name: 'ProductionType')
  final String? productionType;
  @JsonKey(name: 'DealStatusId')
  final String? dealStatusId;
  @JsonKey(name: 'DealStatus')
  final String? dealStatus;
  @JsonKey(name: 'StatusAsOf')
  final String? statusAsOf;
  @JsonKey(name: 'ExpectedWrapDate')
  final String? expectedWrapDate;
  @JsonKey(name: 'BillingCycleId')
  final String? billingCycleId;
  @JsonKey(name: 'BillingCycle')
  final String? billingCycle;
  @JsonKey(name: 'PaymentTermsId')
  final String? paymentTermsId;
  @JsonKey(name: 'PaymentTerms')
  final String? paymentTerms;
  @JsonKey(name: 'PaymentTypeId')
  final String? paymentTypeId;
  @JsonKey(name: 'PaymentType')
  final String? paymentType;
  @JsonKey(name: 'DefaultRate')
  final String? defaultRate;
  @JsonKey(name: 'MultipleCurrencies')
  final bool? multipleCurrencies;
  @JsonKey(name: 'CurrencyId')
  final String? currencyId;
  @JsonKey(name: 'CurrencyCode')
  final String? currencyCode;
  @JsonKey(name: 'CurrencySymbol')
  final String? currencySymbol;
  @JsonKey(name: 'UseCustomerDiscount')
  final bool? useCustomerDiscount;
  @JsonKey(name: 'CustomerDiscountTemplateId')
  final String? customerDiscountTemplateId;
  @JsonKey(name: 'UseDiscountTemplate')
  final bool? useDiscountTemplate;
  @JsonKey(name: 'DiscountTemplateId')
  final String? discountTemplateId;
  @JsonKey(name: 'DiscountTemplate')
  final String? discountTemplate;
  @JsonKey(name: 'RentalDaysPerWeek')
  final double? rentalDaysPerWeek;
  @JsonKey(name: 'RentalDiscountPercent')
  final double? rentalDiscountPercent;
  @JsonKey(name: 'SalesDiscountPercent')
  final double? salesDiscountPercent;
  @JsonKey(name: 'FacilitiesDaysPerWeek')
  final double? facilitiesDaysPerWeek;
  @JsonKey(name: 'FacilitiesDiscountPercent')
  final double? facilitiesDiscountPercent;
  @JsonKey(name: 'OutsideSalesRepresentativeId')
  final String? outsideSalesRepresentativeId;
  @JsonKey(name: 'OutsideSalesRepresentative')
  final String? outsideSalesRepresentative;
  @JsonKey(name: 'CommissionRate')
  final double? commissionRate;
  @JsonKey(name: 'CommissionIncludesVendorItems')
  final bool? commissionIncludesVendorItems;
  @JsonKey(name: 'PoRequired')
  final bool? poRequired;
  @JsonKey(name: 'PoType')
  final String? poType;
  @JsonKey(name: 'BillToAddressType')
  final String? billToAddressType;
  @JsonKey(name: 'BillToAttention1')
  final String? billToAttention1;
  @JsonKey(name: 'BillToAttention2')
  final String? billToAttention2;
  @JsonKey(name: 'BillToAddress1')
  final String? billToAddress1;
  @JsonKey(name: 'BillToAddress2')
  final String? billToAddress2;
  @JsonKey(name: 'BillToCity')
  final String? billToCity;
  @JsonKey(name: 'BillToState')
  final String? billToState;
  @JsonKey(name: 'BillToCountryId')
  final String? billToCountryId;
  @JsonKey(name: 'BillToCountry')
  final String? billToCountry;
  @JsonKey(name: 'BillToZipCode')
  final String? billToZipCode;
  @JsonKey(name: 'AssessFinanceCharge')
  final bool? assessFinanceCharge;
  @JsonKey(name: 'AllowBillingScheduleOverride')
  final bool? allowBillingScheduleOverride;
  @JsonKey(name: 'AllowRebateCreditInvoices')
  final bool? allowRebateCreditInvoices;
  @JsonKey(name: 'UseCustomerCredit')
  final bool? useCustomerCredit;
  @JsonKey(name: 'CreditStatusId')
  final String? creditStatusId;
  @JsonKey(name: 'CreditStatus')
  final String? creditStatus;
  @JsonKey(name: 'CreditStatusThrough')
  final String? creditStatusThrough;
  @JsonKey(name: 'CreditApplicationOnFile')
  final bool? creditApplicationOnFile;
  @JsonKey(name: 'UnlimitedCredit')
  final bool? unlimitedCredit;
  @JsonKey(name: 'CreditLimit')
  final int? creditLimit;
  @JsonKey(name: 'CreditBalance')
  final int? creditBalance;
  @JsonKey(name: 'CreditAvailable')
  final int? creditAvailable;
  @JsonKey(name: 'CustomerCreditLimit')
  final int? customerCreditLimit;
  @JsonKey(name: 'CustomerCreditBalance')
  final int? customerCreditBalance;
  @JsonKey(name: 'CustomerCreditAvailable')
  final int? customerCreditAvailable;
  @JsonKey(name: 'CreditResponsiblePartyOnFile')
  final bool? creditResponsiblePartyOnFile;
  @JsonKey(name: 'CreditResponsibleParty')
  final String? creditResponsibleParty;
  @JsonKey(name: 'TradeReferencesVerified')
  final bool? tradeReferencesVerified;
  @JsonKey(name: 'TradeReferencesVerifiedBy')
  final String? tradeReferencesVerifiedBy;
  @JsonKey(name: 'TradeReferencesVerifiedOn')
  final String? tradeReferencesVerifiedOn;
  @JsonKey(name: 'CreditCardTypeId')
  final String? creditCardTypeId;
  @JsonKey(name: 'CreditCardType')
  final String? creditCardType;
  @JsonKey(name: 'CreditCardLimit')
  final int? creditCardLimit;
  @JsonKey(name: 'CreditCardNumber')
  final String? creditCardNumber;
  @JsonKey(name: 'CreditCardCode')
  final String? creditCardCode;
  @JsonKey(name: 'CreditCardName')
  final String? creditCardName;
  @JsonKey(name: 'CreditCardExpirationMonth')
  final int? creditCardExpirationMonth;
  @JsonKey(name: 'CreditCardExpirationYear')
  final int? creditCardExpirationYear;
  @JsonKey(name: 'CreditCardAuthorizationFormOnFile')
  final bool? creditCardAuthorizationFormOnFile;
  @JsonKey(name: 'DepletingDepositThresholdAmount')
  final double? depletingDepositThresholdAmount;
  @JsonKey(name: 'DepletingDepositThresholdPercent')
  final int? depletingDepositThresholdPercent;
  @JsonKey(name: 'DepletingDepositTotal')
  final double? depletingDepositTotal;
  @JsonKey(name: 'DepletingDepositApplied')
  final double? depletingDepositApplied;
  @JsonKey(name: 'DepletingDepositRemaining')
  final double? depletingDepositRemaining;
  @JsonKey(name: 'UseCustomerInsurance')
  final bool? useCustomerInsurance;
  @JsonKey(name: 'InsuranceCertification')
  final bool? insuranceCertification;
  @JsonKey(name: 'InsuranceCertificationValidThrough')
  final String? insuranceCertificationValidThrough;
  @JsonKey(name: 'InsuranceCoverageLiability')
  final int? insuranceCoverageLiability;
  @JsonKey(name: 'InsuranceCoverageLiabilityDeductible')
  final int? insuranceCoverageLiabilityDeductible;
  @JsonKey(name: 'InsuranceCoverageProperty')
  final int? insuranceCoverageProperty;
  @JsonKey(name: 'InsuranceCoveragePropertyDeductible')
  final int? insuranceCoveragePropertyDeductible;
  @JsonKey(name: 'SecurityDepositAmount')
  final double? securityDepositAmount;
  @JsonKey(name: 'InsuranceCompanyId')
  final String? insuranceCompanyId;
  @JsonKey(name: 'InsuranceCompany')
  final String? insuranceCompany;
  @JsonKey(name: 'InsuranceCompanyAgent')
  final String? insuranceCompanyAgent;
  @JsonKey(name: 'InsuranceCompanyAddress1')
  final String? insuranceCompanyAddress1;
  @JsonKey(name: 'InsuranceCompanyAddress2')
  final String? insuranceCompanyAddress2;
  @JsonKey(name: 'InsuranceCompanyCity')
  final String? insuranceCompanyCity;
  @JsonKey(name: 'InsuranceCompanyState')
  final String? insuranceCompanyState;
  @JsonKey(name: 'InsuranceCompanyZipCode')
  final String? insuranceCompanyZipCode;
  @JsonKey(name: 'InsuranceCompanyCountryId')
  final String? insuranceCompanyCountryId;
  @JsonKey(name: 'InsuranceCompanyCountry')
  final String? insuranceCompanyCountry;
  @JsonKey(name: 'InsuranceCompanyPhone')
  final String? insuranceCompanyPhone;
  @JsonKey(name: 'InsuranceCompanyFax')
  final String? insuranceCompanyFax;
  @JsonKey(name: 'VehicleInsuranceCertification')
  final bool? vehicleInsuranceCertification;
  @JsonKey(name: 'UseCustomerTax')
  final bool? useCustomerTax;
  @JsonKey(name: 'Taxable')
  final bool? taxable;
  @JsonKey(name: 'TaxStateOfIncorporationId')
  final String? taxStateOfIncorporationId;
  @JsonKey(name: 'TaxStateOfIncorporation')
  final String? taxStateOfIncorporation;
  @JsonKey(name: 'TaxFederalNo')
  final String? taxFederalNo;
  @JsonKey(name: 'NonTaxableYear')
  final int? nonTaxableYear;
  @JsonKey(name: 'NonTaxableCertificateNo')
  final String? nonTaxableCertificateNo;
  @JsonKey(name: 'NonTaxableCertificateValidThrough')
  final String? nonTaxableCertificateValidThrough;
  @JsonKey(name: 'NonTaxableCertificateOnFile')
  final bool? nonTaxableCertificateOnFile;
  @JsonKey(name: 'DisableQuoteOrderActivity')
  final bool? disableQuoteOrderActivity;
  @JsonKey(name: 'DisableRental')
  final bool? disableRental;
  @JsonKey(name: 'DisableSales')
  final bool? disableSales;
  @JsonKey(name: 'DisableFacilities')
  final bool? disableFacilities;
  @JsonKey(name: 'DisableTransportation')
  final bool? disableTransportation;
  @JsonKey(name: 'DisableLabor')
  final bool? disableLabor;
  @JsonKey(name: 'DisableMisc')
  final bool? disableMisc;
  @JsonKey(name: 'DisableRentalSale')
  final bool? disableRentalSale;
  @JsonKey(name: 'DisableSubRental')
  final bool? disableSubRental;
  @JsonKey(name: 'DisableSubSale')
  final bool? disableSubSale;
  @JsonKey(name: 'DisableSubLabor')
  final bool? disableSubLabor;
  @JsonKey(name: 'DisableSubMisc')
  final bool? disableSubMisc;
  @JsonKey(name: 'DefaultOutgoingDeliveryType')
  final String? defaultOutgoingDeliveryType;
  @JsonKey(name: 'DefaultIncomingDeliveryType')
  final String? defaultIncomingDeliveryType;
  @JsonKey(name: 'ShippingAddressType')
  final String? shippingAddressType;
  @JsonKey(name: 'ShipAttention')
  final String? shipAttention;
  @JsonKey(name: 'ShipAddress1')
  final String? shipAddress1;
  @JsonKey(name: 'ShipAddress2')
  final String? shipAddress2;
  @JsonKey(name: 'ShipCity')
  final String? shipCity;
  @JsonKey(name: 'ShipState')
  final String? shipState;
  @JsonKey(name: 'ShipCountryId')
  final String? shipCountryId;
  @JsonKey(name: 'ShipCountry')
  final String? shipCountry;
  @JsonKey(name: 'ShipZipCode')
  final String? shipZipCode;
  @JsonKey(name: 'RebateRental')
  final bool? rebateRental;
  @JsonKey(name: 'RebateCustomerId')
  final String? rebateCustomerId;
  @JsonKey(name: 'RebateCustomer')
  final String? rebateCustomer;
  @JsonKey(name: 'OwnedEquipmentRebateRentalPerecent')
  final int? ownedEquipmentRebateRentalPerecent;
  @JsonKey(name: 'SubRentalEquipmentRebateRentalPerecent')
  final int? subRentalEquipmentRebateRentalPerecent;
  @JsonKey(name: 'EnableWebQuoteRequest')
  final bool? enableWebQuoteRequest;
  @JsonKey(name: 'Email')
  final String? email;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory = _$WebApiModulesAgentDealDealFromJson;
  static const toJsonFactory = _$WebApiModulesAgentDealDealToJson;
  Map<String, dynamic> toJson() => _$WebApiModulesAgentDealDealToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentDealDeal &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.deal, deal) ||
                const DeepCollectionEquality().equals(other.deal, deal)) &&
            (identical(other.dealNumber, dealNumber) ||
                const DeepCollectionEquality()
                    .equals(other.dealNumber, dealNumber)) &&
            (identical(other.customerId, customerId) ||
                const DeepCollectionEquality()
                    .equals(other.customerId, customerId)) &&
            (identical(other.customer, customer) ||
                const DeepCollectionEquality()
                    .equals(other.customer, customer)) &&
            (identical(other.customerNumber, customerNumber) ||
                const DeepCollectionEquality()
                    .equals(other.customerNumber, customerNumber)) &&
            (identical(other.officeLocationId, officeLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocationId, officeLocationId)) &&
            (identical(other.officeLocation, officeLocation) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocation, officeLocation)) &&
            (identical(other.dealTypeId, dealTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.dealTypeId, dealTypeId)) &&
            (identical(other.dealType, dealType) ||
                const DeepCollectionEquality()
                    .equals(other.dealType, dealType)) &&
            (identical(other.address1, address1) ||
                const DeepCollectionEquality()
                    .equals(other.address1, address1)) &&
            (identical(other.address2, address2) ||
                const DeepCollectionEquality()
                    .equals(other.address2, address2)) &&
            (identical(other.city, city) ||
                const DeepCollectionEquality().equals(other.city, city)) &&
            (identical(other.state, state) ||
                const DeepCollectionEquality().equals(other.state, state)) &&
            (identical(other.zipCode, zipCode) ||
                const DeepCollectionEquality()
                    .equals(other.zipCode, zipCode)) &&
            (identical(other.countryId, countryId) ||
                const DeepCollectionEquality()
                    .equals(other.countryId, countryId)) &&
            (identical(other.country, country) ||
                const DeepCollectionEquality()
                    .equals(other.country, country)) &&
            (identical(other.phone, phone) ||
                const DeepCollectionEquality().equals(other.phone, phone)) &&
            (identical(other.phoneTollFree, phoneTollFree) ||
                const DeepCollectionEquality()
                    .equals(other.phoneTollFree, phoneTollFree)) &&
            (identical(other.fax, fax) ||
                const DeepCollectionEquality().equals(other.fax, fax)) &&
            (identical(other.phoneOther, phoneOther) ||
                const DeepCollectionEquality()
                    .equals(other.phoneOther, phoneOther)) &&
            (identical(other.departmentId, departmentId) ||
                const DeepCollectionEquality()
                    .equals(other.departmentId, departmentId)) &&
            (identical(other.department, department) ||
                const DeepCollectionEquality()
                    .equals(other.department, department)) &&
            (identical(other.csrId, csrId) ||
                const DeepCollectionEquality().equals(other.csrId, csrId)) &&
            (identical(other.csr, csr) ||
                const DeepCollectionEquality().equals(other.csr, csr)) &&
            (identical(other.defaultAgentId, defaultAgentId) ||
                const DeepCollectionEquality().equals(other.defaultAgentId, defaultAgentId)) &&
            (identical(other.defaultAgent, defaultAgent) || const DeepCollectionEquality().equals(other.defaultAgent, defaultAgent)) &&
            (identical(other.defaultProjectManagerId, defaultProjectManagerId) || const DeepCollectionEquality().equals(other.defaultProjectManagerId, defaultProjectManagerId)) &&
            (identical(other.defaultProjectManager, defaultProjectManager) || const DeepCollectionEquality().equals(other.defaultProjectManager, defaultProjectManager)) &&
            (identical(other.dealClassificationId, dealClassificationId) || const DeepCollectionEquality().equals(other.dealClassificationId, dealClassificationId)) &&
            (identical(other.dealClassification, dealClassification) || const DeepCollectionEquality().equals(other.dealClassification, dealClassification)) &&
            (identical(other.productionTypeId, productionTypeId) || const DeepCollectionEquality().equals(other.productionTypeId, productionTypeId)) &&
            (identical(other.productionType, productionType) || const DeepCollectionEquality().equals(other.productionType, productionType)) &&
            (identical(other.dealStatusId, dealStatusId) || const DeepCollectionEquality().equals(other.dealStatusId, dealStatusId)) &&
            (identical(other.dealStatus, dealStatus) || const DeepCollectionEquality().equals(other.dealStatus, dealStatus)) &&
            (identical(other.statusAsOf, statusAsOf) || const DeepCollectionEquality().equals(other.statusAsOf, statusAsOf)) &&
            (identical(other.expectedWrapDate, expectedWrapDate) || const DeepCollectionEquality().equals(other.expectedWrapDate, expectedWrapDate)) &&
            (identical(other.billingCycleId, billingCycleId) || const DeepCollectionEquality().equals(other.billingCycleId, billingCycleId)) &&
            (identical(other.billingCycle, billingCycle) || const DeepCollectionEquality().equals(other.billingCycle, billingCycle)) &&
            (identical(other.paymentTermsId, paymentTermsId) || const DeepCollectionEquality().equals(other.paymentTermsId, paymentTermsId)) &&
            (identical(other.paymentTerms, paymentTerms) || const DeepCollectionEquality().equals(other.paymentTerms, paymentTerms)) &&
            (identical(other.paymentTypeId, paymentTypeId) || const DeepCollectionEquality().equals(other.paymentTypeId, paymentTypeId)) &&
            (identical(other.paymentType, paymentType) || const DeepCollectionEquality().equals(other.paymentType, paymentType)) &&
            (identical(other.defaultRate, defaultRate) || const DeepCollectionEquality().equals(other.defaultRate, defaultRate)) &&
            (identical(other.multipleCurrencies, multipleCurrencies) || const DeepCollectionEquality().equals(other.multipleCurrencies, multipleCurrencies)) &&
            (identical(other.currencyId, currencyId) || const DeepCollectionEquality().equals(other.currencyId, currencyId)) &&
            (identical(other.currencyCode, currencyCode) || const DeepCollectionEquality().equals(other.currencyCode, currencyCode)) &&
            (identical(other.currencySymbol, currencySymbol) || const DeepCollectionEquality().equals(other.currencySymbol, currencySymbol)) &&
            (identical(other.useCustomerDiscount, useCustomerDiscount) || const DeepCollectionEquality().equals(other.useCustomerDiscount, useCustomerDiscount)) &&
            (identical(other.customerDiscountTemplateId, customerDiscountTemplateId) || const DeepCollectionEquality().equals(other.customerDiscountTemplateId, customerDiscountTemplateId)) &&
            (identical(other.useDiscountTemplate, useDiscountTemplate) || const DeepCollectionEquality().equals(other.useDiscountTemplate, useDiscountTemplate)) &&
            (identical(other.discountTemplateId, discountTemplateId) || const DeepCollectionEquality().equals(other.discountTemplateId, discountTemplateId)) &&
            (identical(other.discountTemplate, discountTemplate) || const DeepCollectionEquality().equals(other.discountTemplate, discountTemplate)) &&
            (identical(other.rentalDaysPerWeek, rentalDaysPerWeek) || const DeepCollectionEquality().equals(other.rentalDaysPerWeek, rentalDaysPerWeek)) &&
            (identical(other.rentalDiscountPercent, rentalDiscountPercent) || const DeepCollectionEquality().equals(other.rentalDiscountPercent, rentalDiscountPercent)) &&
            (identical(other.salesDiscountPercent, salesDiscountPercent) || const DeepCollectionEquality().equals(other.salesDiscountPercent, salesDiscountPercent)) &&
            (identical(other.facilitiesDaysPerWeek, facilitiesDaysPerWeek) || const DeepCollectionEquality().equals(other.facilitiesDaysPerWeek, facilitiesDaysPerWeek)) &&
            (identical(other.facilitiesDiscountPercent, facilitiesDiscountPercent) || const DeepCollectionEquality().equals(other.facilitiesDiscountPercent, facilitiesDiscountPercent)) &&
            (identical(other.outsideSalesRepresentativeId, outsideSalesRepresentativeId) || const DeepCollectionEquality().equals(other.outsideSalesRepresentativeId, outsideSalesRepresentativeId)) &&
            (identical(other.outsideSalesRepresentative, outsideSalesRepresentative) || const DeepCollectionEquality().equals(other.outsideSalesRepresentative, outsideSalesRepresentative)) &&
            (identical(other.commissionRate, commissionRate) || const DeepCollectionEquality().equals(other.commissionRate, commissionRate)) &&
            (identical(other.commissionIncludesVendorItems, commissionIncludesVendorItems) || const DeepCollectionEquality().equals(other.commissionIncludesVendorItems, commissionIncludesVendorItems)) &&
            (identical(other.poRequired, poRequired) || const DeepCollectionEquality().equals(other.poRequired, poRequired)) &&
            (identical(other.poType, poType) || const DeepCollectionEquality().equals(other.poType, poType)) &&
            (identical(other.billToAddressType, billToAddressType) || const DeepCollectionEquality().equals(other.billToAddressType, billToAddressType)) &&
            (identical(other.billToAttention1, billToAttention1) || const DeepCollectionEquality().equals(other.billToAttention1, billToAttention1)) &&
            (identical(other.billToAttention2, billToAttention2) || const DeepCollectionEquality().equals(other.billToAttention2, billToAttention2)) &&
            (identical(other.billToAddress1, billToAddress1) || const DeepCollectionEquality().equals(other.billToAddress1, billToAddress1)) &&
            (identical(other.billToAddress2, billToAddress2) || const DeepCollectionEquality().equals(other.billToAddress2, billToAddress2)) &&
            (identical(other.billToCity, billToCity) || const DeepCollectionEquality().equals(other.billToCity, billToCity)) &&
            (identical(other.billToState, billToState) || const DeepCollectionEquality().equals(other.billToState, billToState)) &&
            (identical(other.billToCountryId, billToCountryId) || const DeepCollectionEquality().equals(other.billToCountryId, billToCountryId)) &&
            (identical(other.billToCountry, billToCountry) || const DeepCollectionEquality().equals(other.billToCountry, billToCountry)) &&
            (identical(other.billToZipCode, billToZipCode) || const DeepCollectionEquality().equals(other.billToZipCode, billToZipCode)) &&
            (identical(other.assessFinanceCharge, assessFinanceCharge) || const DeepCollectionEquality().equals(other.assessFinanceCharge, assessFinanceCharge)) &&
            (identical(other.allowBillingScheduleOverride, allowBillingScheduleOverride) || const DeepCollectionEquality().equals(other.allowBillingScheduleOverride, allowBillingScheduleOverride)) &&
            (identical(other.allowRebateCreditInvoices, allowRebateCreditInvoices) || const DeepCollectionEquality().equals(other.allowRebateCreditInvoices, allowRebateCreditInvoices)) &&
            (identical(other.useCustomerCredit, useCustomerCredit) || const DeepCollectionEquality().equals(other.useCustomerCredit, useCustomerCredit)) &&
            (identical(other.creditStatusId, creditStatusId) || const DeepCollectionEquality().equals(other.creditStatusId, creditStatusId)) &&
            (identical(other.creditStatus, creditStatus) || const DeepCollectionEquality().equals(other.creditStatus, creditStatus)) &&
            (identical(other.creditStatusThrough, creditStatusThrough) || const DeepCollectionEquality().equals(other.creditStatusThrough, creditStatusThrough)) &&
            (identical(other.creditApplicationOnFile, creditApplicationOnFile) || const DeepCollectionEquality().equals(other.creditApplicationOnFile, creditApplicationOnFile)) &&
            (identical(other.unlimitedCredit, unlimitedCredit) || const DeepCollectionEquality().equals(other.unlimitedCredit, unlimitedCredit)) &&
            (identical(other.creditLimit, creditLimit) || const DeepCollectionEquality().equals(other.creditLimit, creditLimit)) &&
            (identical(other.creditBalance, creditBalance) || const DeepCollectionEquality().equals(other.creditBalance, creditBalance)) &&
            (identical(other.creditAvailable, creditAvailable) || const DeepCollectionEquality().equals(other.creditAvailable, creditAvailable)) &&
            (identical(other.customerCreditLimit, customerCreditLimit) || const DeepCollectionEquality().equals(other.customerCreditLimit, customerCreditLimit)) &&
            (identical(other.customerCreditBalance, customerCreditBalance) || const DeepCollectionEquality().equals(other.customerCreditBalance, customerCreditBalance)) &&
            (identical(other.customerCreditAvailable, customerCreditAvailable) || const DeepCollectionEquality().equals(other.customerCreditAvailable, customerCreditAvailable)) &&
            (identical(other.creditResponsiblePartyOnFile, creditResponsiblePartyOnFile) || const DeepCollectionEquality().equals(other.creditResponsiblePartyOnFile, creditResponsiblePartyOnFile)) &&
            (identical(other.creditResponsibleParty, creditResponsibleParty) || const DeepCollectionEquality().equals(other.creditResponsibleParty, creditResponsibleParty)) &&
            (identical(other.tradeReferencesVerified, tradeReferencesVerified) || const DeepCollectionEquality().equals(other.tradeReferencesVerified, tradeReferencesVerified)) &&
            (identical(other.tradeReferencesVerifiedBy, tradeReferencesVerifiedBy) || const DeepCollectionEquality().equals(other.tradeReferencesVerifiedBy, tradeReferencesVerifiedBy)) &&
            (identical(other.tradeReferencesVerifiedOn, tradeReferencesVerifiedOn) || const DeepCollectionEquality().equals(other.tradeReferencesVerifiedOn, tradeReferencesVerifiedOn)) &&
            (identical(other.creditCardTypeId, creditCardTypeId) || const DeepCollectionEquality().equals(other.creditCardTypeId, creditCardTypeId)) &&
            (identical(other.creditCardType, creditCardType) || const DeepCollectionEquality().equals(other.creditCardType, creditCardType)) &&
            (identical(other.creditCardLimit, creditCardLimit) || const DeepCollectionEquality().equals(other.creditCardLimit, creditCardLimit)) &&
            (identical(other.creditCardNumber, creditCardNumber) || const DeepCollectionEquality().equals(other.creditCardNumber, creditCardNumber)) &&
            (identical(other.creditCardCode, creditCardCode) || const DeepCollectionEquality().equals(other.creditCardCode, creditCardCode)) &&
            (identical(other.creditCardName, creditCardName) || const DeepCollectionEquality().equals(other.creditCardName, creditCardName)) &&
            (identical(other.creditCardExpirationMonth, creditCardExpirationMonth) || const DeepCollectionEquality().equals(other.creditCardExpirationMonth, creditCardExpirationMonth)) &&
            (identical(other.creditCardExpirationYear, creditCardExpirationYear) || const DeepCollectionEquality().equals(other.creditCardExpirationYear, creditCardExpirationYear)) &&
            (identical(other.creditCardAuthorizationFormOnFile, creditCardAuthorizationFormOnFile) || const DeepCollectionEquality().equals(other.creditCardAuthorizationFormOnFile, creditCardAuthorizationFormOnFile)) &&
            (identical(other.depletingDepositThresholdAmount, depletingDepositThresholdAmount) || const DeepCollectionEquality().equals(other.depletingDepositThresholdAmount, depletingDepositThresholdAmount)) &&
            (identical(other.depletingDepositThresholdPercent, depletingDepositThresholdPercent) || const DeepCollectionEquality().equals(other.depletingDepositThresholdPercent, depletingDepositThresholdPercent)) &&
            (identical(other.depletingDepositTotal, depletingDepositTotal) || const DeepCollectionEquality().equals(other.depletingDepositTotal, depletingDepositTotal)) &&
            (identical(other.depletingDepositApplied, depletingDepositApplied) || const DeepCollectionEquality().equals(other.depletingDepositApplied, depletingDepositApplied)) &&
            (identical(other.depletingDepositRemaining, depletingDepositRemaining) || const DeepCollectionEquality().equals(other.depletingDepositRemaining, depletingDepositRemaining)) &&
            (identical(other.useCustomerInsurance, useCustomerInsurance) || const DeepCollectionEquality().equals(other.useCustomerInsurance, useCustomerInsurance)) &&
            (identical(other.insuranceCertification, insuranceCertification) || const DeepCollectionEquality().equals(other.insuranceCertification, insuranceCertification)) &&
            (identical(other.insuranceCertificationValidThrough, insuranceCertificationValidThrough) || const DeepCollectionEquality().equals(other.insuranceCertificationValidThrough, insuranceCertificationValidThrough)) &&
            (identical(other.insuranceCoverageLiability, insuranceCoverageLiability) || const DeepCollectionEquality().equals(other.insuranceCoverageLiability, insuranceCoverageLiability)) &&
            (identical(other.insuranceCoverageLiabilityDeductible, insuranceCoverageLiabilityDeductible) || const DeepCollectionEquality().equals(other.insuranceCoverageLiabilityDeductible, insuranceCoverageLiabilityDeductible)) &&
            (identical(other.insuranceCoverageProperty, insuranceCoverageProperty) || const DeepCollectionEquality().equals(other.insuranceCoverageProperty, insuranceCoverageProperty)) &&
            (identical(other.insuranceCoveragePropertyDeductible, insuranceCoveragePropertyDeductible) || const DeepCollectionEquality().equals(other.insuranceCoveragePropertyDeductible, insuranceCoveragePropertyDeductible)) &&
            (identical(other.securityDepositAmount, securityDepositAmount) || const DeepCollectionEquality().equals(other.securityDepositAmount, securityDepositAmount)) &&
            (identical(other.insuranceCompanyId, insuranceCompanyId) || const DeepCollectionEquality().equals(other.insuranceCompanyId, insuranceCompanyId)) &&
            (identical(other.insuranceCompany, insuranceCompany) || const DeepCollectionEquality().equals(other.insuranceCompany, insuranceCompany)) &&
            (identical(other.insuranceCompanyAgent, insuranceCompanyAgent) || const DeepCollectionEquality().equals(other.insuranceCompanyAgent, insuranceCompanyAgent)) &&
            (identical(other.insuranceCompanyAddress1, insuranceCompanyAddress1) || const DeepCollectionEquality().equals(other.insuranceCompanyAddress1, insuranceCompanyAddress1)) &&
            (identical(other.insuranceCompanyAddress2, insuranceCompanyAddress2) || const DeepCollectionEquality().equals(other.insuranceCompanyAddress2, insuranceCompanyAddress2)) &&
            (identical(other.insuranceCompanyCity, insuranceCompanyCity) || const DeepCollectionEquality().equals(other.insuranceCompanyCity, insuranceCompanyCity)) &&
            (identical(other.insuranceCompanyState, insuranceCompanyState) || const DeepCollectionEquality().equals(other.insuranceCompanyState, insuranceCompanyState)) &&
            (identical(other.insuranceCompanyZipCode, insuranceCompanyZipCode) || const DeepCollectionEquality().equals(other.insuranceCompanyZipCode, insuranceCompanyZipCode)) &&
            (identical(other.insuranceCompanyCountryId, insuranceCompanyCountryId) || const DeepCollectionEquality().equals(other.insuranceCompanyCountryId, insuranceCompanyCountryId)) &&
            (identical(other.insuranceCompanyCountry, insuranceCompanyCountry) || const DeepCollectionEquality().equals(other.insuranceCompanyCountry, insuranceCompanyCountry)) &&
            (identical(other.insuranceCompanyPhone, insuranceCompanyPhone) || const DeepCollectionEquality().equals(other.insuranceCompanyPhone, insuranceCompanyPhone)) &&
            (identical(other.insuranceCompanyFax, insuranceCompanyFax) || const DeepCollectionEquality().equals(other.insuranceCompanyFax, insuranceCompanyFax)) &&
            (identical(other.vehicleInsuranceCertification, vehicleInsuranceCertification) || const DeepCollectionEquality().equals(other.vehicleInsuranceCertification, vehicleInsuranceCertification)) &&
            (identical(other.useCustomerTax, useCustomerTax) || const DeepCollectionEquality().equals(other.useCustomerTax, useCustomerTax)) &&
            (identical(other.taxable, taxable) || const DeepCollectionEquality().equals(other.taxable, taxable)) &&
            (identical(other.taxStateOfIncorporationId, taxStateOfIncorporationId) || const DeepCollectionEquality().equals(other.taxStateOfIncorporationId, taxStateOfIncorporationId)) &&
            (identical(other.taxStateOfIncorporation, taxStateOfIncorporation) || const DeepCollectionEquality().equals(other.taxStateOfIncorporation, taxStateOfIncorporation)) &&
            (identical(other.taxFederalNo, taxFederalNo) || const DeepCollectionEquality().equals(other.taxFederalNo, taxFederalNo)) &&
            (identical(other.nonTaxableYear, nonTaxableYear) || const DeepCollectionEquality().equals(other.nonTaxableYear, nonTaxableYear)) &&
            (identical(other.nonTaxableCertificateNo, nonTaxableCertificateNo) || const DeepCollectionEquality().equals(other.nonTaxableCertificateNo, nonTaxableCertificateNo)) &&
            (identical(other.nonTaxableCertificateValidThrough, nonTaxableCertificateValidThrough) || const DeepCollectionEquality().equals(other.nonTaxableCertificateValidThrough, nonTaxableCertificateValidThrough)) &&
            (identical(other.nonTaxableCertificateOnFile, nonTaxableCertificateOnFile) || const DeepCollectionEquality().equals(other.nonTaxableCertificateOnFile, nonTaxableCertificateOnFile)) &&
            (identical(other.disableQuoteOrderActivity, disableQuoteOrderActivity) || const DeepCollectionEquality().equals(other.disableQuoteOrderActivity, disableQuoteOrderActivity)) &&
            (identical(other.disableRental, disableRental) || const DeepCollectionEquality().equals(other.disableRental, disableRental)) &&
            (identical(other.disableSales, disableSales) || const DeepCollectionEquality().equals(other.disableSales, disableSales)) &&
            (identical(other.disableFacilities, disableFacilities) || const DeepCollectionEquality().equals(other.disableFacilities, disableFacilities)) &&
            (identical(other.disableTransportation, disableTransportation) || const DeepCollectionEquality().equals(other.disableTransportation, disableTransportation)) &&
            (identical(other.disableLabor, disableLabor) || const DeepCollectionEquality().equals(other.disableLabor, disableLabor)) &&
            (identical(other.disableMisc, disableMisc) || const DeepCollectionEquality().equals(other.disableMisc, disableMisc)) &&
            (identical(other.disableRentalSale, disableRentalSale) || const DeepCollectionEquality().equals(other.disableRentalSale, disableRentalSale)) &&
            (identical(other.disableSubRental, disableSubRental) || const DeepCollectionEquality().equals(other.disableSubRental, disableSubRental)) &&
            (identical(other.disableSubSale, disableSubSale) || const DeepCollectionEquality().equals(other.disableSubSale, disableSubSale)) &&
            (identical(other.disableSubLabor, disableSubLabor) || const DeepCollectionEquality().equals(other.disableSubLabor, disableSubLabor)) &&
            (identical(other.disableSubMisc, disableSubMisc) || const DeepCollectionEquality().equals(other.disableSubMisc, disableSubMisc)) &&
            (identical(other.defaultOutgoingDeliveryType, defaultOutgoingDeliveryType) || const DeepCollectionEquality().equals(other.defaultOutgoingDeliveryType, defaultOutgoingDeliveryType)) &&
            (identical(other.defaultIncomingDeliveryType, defaultIncomingDeliveryType) || const DeepCollectionEquality().equals(other.defaultIncomingDeliveryType, defaultIncomingDeliveryType)) &&
            (identical(other.shippingAddressType, shippingAddressType) || const DeepCollectionEquality().equals(other.shippingAddressType, shippingAddressType)) &&
            (identical(other.shipAttention, shipAttention) || const DeepCollectionEquality().equals(other.shipAttention, shipAttention)) &&
            (identical(other.shipAddress1, shipAddress1) || const DeepCollectionEquality().equals(other.shipAddress1, shipAddress1)) &&
            (identical(other.shipAddress2, shipAddress2) || const DeepCollectionEquality().equals(other.shipAddress2, shipAddress2)) &&
            (identical(other.shipCity, shipCity) || const DeepCollectionEquality().equals(other.shipCity, shipCity)) &&
            (identical(other.shipState, shipState) || const DeepCollectionEquality().equals(other.shipState, shipState)) &&
            (identical(other.shipCountryId, shipCountryId) || const DeepCollectionEquality().equals(other.shipCountryId, shipCountryId)) &&
            (identical(other.shipCountry, shipCountry) || const DeepCollectionEquality().equals(other.shipCountry, shipCountry)) &&
            (identical(other.shipZipCode, shipZipCode) || const DeepCollectionEquality().equals(other.shipZipCode, shipZipCode)) &&
            (identical(other.rebateRental, rebateRental) || const DeepCollectionEquality().equals(other.rebateRental, rebateRental)) &&
            (identical(other.rebateCustomerId, rebateCustomerId) || const DeepCollectionEquality().equals(other.rebateCustomerId, rebateCustomerId)) &&
            (identical(other.rebateCustomer, rebateCustomer) || const DeepCollectionEquality().equals(other.rebateCustomer, rebateCustomer)) &&
            (identical(other.ownedEquipmentRebateRentalPerecent, ownedEquipmentRebateRentalPerecent) || const DeepCollectionEquality().equals(other.ownedEquipmentRebateRentalPerecent, ownedEquipmentRebateRentalPerecent)) &&
            (identical(other.subRentalEquipmentRebateRentalPerecent, subRentalEquipmentRebateRentalPerecent) || const DeepCollectionEquality().equals(other.subRentalEquipmentRebateRentalPerecent, subRentalEquipmentRebateRentalPerecent)) &&
            (identical(other.enableWebQuoteRequest, enableWebQuoteRequest) || const DeepCollectionEquality().equals(other.enableWebQuoteRequest, enableWebQuoteRequest)) &&
            (identical(other.email, email) || const DeepCollectionEquality().equals(other.email, email)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesAgentDealDealExtension on WebApiModulesAgentDealDeal {
  WebApiModulesAgentDealDeal copyWith(
      {String? dealId,
      String? deal,
      String? dealNumber,
      String? customerId,
      String? customer,
      String? customerNumber,
      String? officeLocationId,
      String? officeLocation,
      String? dealTypeId,
      String? dealType,
      String? address1,
      String? address2,
      String? city,
      String? state,
      String? zipCode,
      String? countryId,
      String? country,
      String? phone,
      String? phoneTollFree,
      String? fax,
      String? phoneOther,
      String? departmentId,
      String? department,
      String? csrId,
      String? csr,
      String? defaultAgentId,
      String? defaultAgent,
      String? defaultProjectManagerId,
      String? defaultProjectManager,
      String? dealClassificationId,
      String? dealClassification,
      String? productionTypeId,
      String? productionType,
      String? dealStatusId,
      String? dealStatus,
      String? statusAsOf,
      String? expectedWrapDate,
      String? billingCycleId,
      String? billingCycle,
      String? paymentTermsId,
      String? paymentTerms,
      String? paymentTypeId,
      String? paymentType,
      String? defaultRate,
      bool? multipleCurrencies,
      String? currencyId,
      String? currencyCode,
      String? currencySymbol,
      bool? useCustomerDiscount,
      String? customerDiscountTemplateId,
      bool? useDiscountTemplate,
      String? discountTemplateId,
      String? discountTemplate,
      double? rentalDaysPerWeek,
      double? rentalDiscountPercent,
      double? salesDiscountPercent,
      double? facilitiesDaysPerWeek,
      double? facilitiesDiscountPercent,
      String? outsideSalesRepresentativeId,
      String? outsideSalesRepresentative,
      double? commissionRate,
      bool? commissionIncludesVendorItems,
      bool? poRequired,
      String? poType,
      String? billToAddressType,
      String? billToAttention1,
      String? billToAttention2,
      String? billToAddress1,
      String? billToAddress2,
      String? billToCity,
      String? billToState,
      String? billToCountryId,
      String? billToCountry,
      String? billToZipCode,
      bool? assessFinanceCharge,
      bool? allowBillingScheduleOverride,
      bool? allowRebateCreditInvoices,
      bool? useCustomerCredit,
      String? creditStatusId,
      String? creditStatus,
      String? creditStatusThrough,
      bool? creditApplicationOnFile,
      bool? unlimitedCredit,
      int? creditLimit,
      int? creditBalance,
      int? creditAvailable,
      int? customerCreditLimit,
      int? customerCreditBalance,
      int? customerCreditAvailable,
      bool? creditResponsiblePartyOnFile,
      String? creditResponsibleParty,
      bool? tradeReferencesVerified,
      String? tradeReferencesVerifiedBy,
      String? tradeReferencesVerifiedOn,
      String? creditCardTypeId,
      String? creditCardType,
      int? creditCardLimit,
      String? creditCardNumber,
      String? creditCardCode,
      String? creditCardName,
      int? creditCardExpirationMonth,
      int? creditCardExpirationYear,
      bool? creditCardAuthorizationFormOnFile,
      double? depletingDepositThresholdAmount,
      int? depletingDepositThresholdPercent,
      double? depletingDepositTotal,
      double? depletingDepositApplied,
      double? depletingDepositRemaining,
      bool? useCustomerInsurance,
      bool? insuranceCertification,
      String? insuranceCertificationValidThrough,
      int? insuranceCoverageLiability,
      int? insuranceCoverageLiabilityDeductible,
      int? insuranceCoverageProperty,
      int? insuranceCoveragePropertyDeductible,
      double? securityDepositAmount,
      String? insuranceCompanyId,
      String? insuranceCompany,
      String? insuranceCompanyAgent,
      String? insuranceCompanyAddress1,
      String? insuranceCompanyAddress2,
      String? insuranceCompanyCity,
      String? insuranceCompanyState,
      String? insuranceCompanyZipCode,
      String? insuranceCompanyCountryId,
      String? insuranceCompanyCountry,
      String? insuranceCompanyPhone,
      String? insuranceCompanyFax,
      bool? vehicleInsuranceCertification,
      bool? useCustomerTax,
      bool? taxable,
      String? taxStateOfIncorporationId,
      String? taxStateOfIncorporation,
      String? taxFederalNo,
      int? nonTaxableYear,
      String? nonTaxableCertificateNo,
      String? nonTaxableCertificateValidThrough,
      bool? nonTaxableCertificateOnFile,
      bool? disableQuoteOrderActivity,
      bool? disableRental,
      bool? disableSales,
      bool? disableFacilities,
      bool? disableTransportation,
      bool? disableLabor,
      bool? disableMisc,
      bool? disableRentalSale,
      bool? disableSubRental,
      bool? disableSubSale,
      bool? disableSubLabor,
      bool? disableSubMisc,
      String? defaultOutgoingDeliveryType,
      String? defaultIncomingDeliveryType,
      String? shippingAddressType,
      String? shipAttention,
      String? shipAddress1,
      String? shipAddress2,
      String? shipCity,
      String? shipState,
      String? shipCountryId,
      String? shipCountry,
      String? shipZipCode,
      bool? rebateRental,
      String? rebateCustomerId,
      String? rebateCustomer,
      int? ownedEquipmentRebateRentalPerecent,
      int? subRentalEquipmentRebateRentalPerecent,
      bool? enableWebQuoteRequest,
      String? email,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAgentDealDeal(
        dealId: dealId ?? this.dealId,
        deal: deal ?? this.deal,
        dealNumber: dealNumber ?? this.dealNumber,
        customerId: customerId ?? this.customerId,
        customer: customer ?? this.customer,
        customerNumber: customerNumber ?? this.customerNumber,
        officeLocationId: officeLocationId ?? this.officeLocationId,
        officeLocation: officeLocation ?? this.officeLocation,
        dealTypeId: dealTypeId ?? this.dealTypeId,
        dealType: dealType ?? this.dealType,
        address1: address1 ?? this.address1,
        address2: address2 ?? this.address2,
        city: city ?? this.city,
        state: state ?? this.state,
        zipCode: zipCode ?? this.zipCode,
        countryId: countryId ?? this.countryId,
        country: country ?? this.country,
        phone: phone ?? this.phone,
        phoneTollFree: phoneTollFree ?? this.phoneTollFree,
        fax: fax ?? this.fax,
        phoneOther: phoneOther ?? this.phoneOther,
        departmentId: departmentId ?? this.departmentId,
        department: department ?? this.department,
        csrId: csrId ?? this.csrId,
        csr: csr ?? this.csr,
        defaultAgentId: defaultAgentId ?? this.defaultAgentId,
        defaultAgent: defaultAgent ?? this.defaultAgent,
        defaultProjectManagerId:
            defaultProjectManagerId ?? this.defaultProjectManagerId,
        defaultProjectManager:
            defaultProjectManager ?? this.defaultProjectManager,
        dealClassificationId: dealClassificationId ?? this.dealClassificationId,
        dealClassification: dealClassification ?? this.dealClassification,
        productionTypeId: productionTypeId ?? this.productionTypeId,
        productionType: productionType ?? this.productionType,
        dealStatusId: dealStatusId ?? this.dealStatusId,
        dealStatus: dealStatus ?? this.dealStatus,
        statusAsOf: statusAsOf ?? this.statusAsOf,
        expectedWrapDate: expectedWrapDate ?? this.expectedWrapDate,
        billingCycleId: billingCycleId ?? this.billingCycleId,
        billingCycle: billingCycle ?? this.billingCycle,
        paymentTermsId: paymentTermsId ?? this.paymentTermsId,
        paymentTerms: paymentTerms ?? this.paymentTerms,
        paymentTypeId: paymentTypeId ?? this.paymentTypeId,
        paymentType: paymentType ?? this.paymentType,
        defaultRate: defaultRate ?? this.defaultRate,
        multipleCurrencies: multipleCurrencies ?? this.multipleCurrencies,
        currencyId: currencyId ?? this.currencyId,
        currencyCode: currencyCode ?? this.currencyCode,
        currencySymbol: currencySymbol ?? this.currencySymbol,
        useCustomerDiscount: useCustomerDiscount ?? this.useCustomerDiscount,
        customerDiscountTemplateId:
            customerDiscountTemplateId ?? this.customerDiscountTemplateId,
        useDiscountTemplate: useDiscountTemplate ?? this.useDiscountTemplate,
        discountTemplateId: discountTemplateId ?? this.discountTemplateId,
        discountTemplate: discountTemplate ?? this.discountTemplate,
        rentalDaysPerWeek: rentalDaysPerWeek ?? this.rentalDaysPerWeek,
        rentalDiscountPercent:
            rentalDiscountPercent ?? this.rentalDiscountPercent,
        salesDiscountPercent: salesDiscountPercent ?? this.salesDiscountPercent,
        facilitiesDaysPerWeek:
            facilitiesDaysPerWeek ?? this.facilitiesDaysPerWeek,
        facilitiesDiscountPercent:
            facilitiesDiscountPercent ?? this.facilitiesDiscountPercent,
        outsideSalesRepresentativeId:
            outsideSalesRepresentativeId ?? this.outsideSalesRepresentativeId,
        outsideSalesRepresentative:
            outsideSalesRepresentative ?? this.outsideSalesRepresentative,
        commissionRate: commissionRate ?? this.commissionRate,
        commissionIncludesVendorItems:
            commissionIncludesVendorItems ?? this.commissionIncludesVendorItems,
        poRequired: poRequired ?? this.poRequired,
        poType: poType ?? this.poType,
        billToAddressType: billToAddressType ?? this.billToAddressType,
        billToAttention1: billToAttention1 ?? this.billToAttention1,
        billToAttention2: billToAttention2 ?? this.billToAttention2,
        billToAddress1: billToAddress1 ?? this.billToAddress1,
        billToAddress2: billToAddress2 ?? this.billToAddress2,
        billToCity: billToCity ?? this.billToCity,
        billToState: billToState ?? this.billToState,
        billToCountryId: billToCountryId ?? this.billToCountryId,
        billToCountry: billToCountry ?? this.billToCountry,
        billToZipCode: billToZipCode ?? this.billToZipCode,
        assessFinanceCharge: assessFinanceCharge ?? this.assessFinanceCharge,
        allowBillingScheduleOverride:
            allowBillingScheduleOverride ?? this.allowBillingScheduleOverride,
        allowRebateCreditInvoices:
            allowRebateCreditInvoices ?? this.allowRebateCreditInvoices,
        useCustomerCredit: useCustomerCredit ?? this.useCustomerCredit,
        creditStatusId: creditStatusId ?? this.creditStatusId,
        creditStatus: creditStatus ?? this.creditStatus,
        creditStatusThrough: creditStatusThrough ?? this.creditStatusThrough,
        creditApplicationOnFile:
            creditApplicationOnFile ?? this.creditApplicationOnFile,
        unlimitedCredit: unlimitedCredit ?? this.unlimitedCredit,
        creditLimit: creditLimit ?? this.creditLimit,
        creditBalance: creditBalance ?? this.creditBalance,
        creditAvailable: creditAvailable ?? this.creditAvailable,
        customerCreditLimit: customerCreditLimit ?? this.customerCreditLimit,
        customerCreditBalance:
            customerCreditBalance ?? this.customerCreditBalance,
        customerCreditAvailable:
            customerCreditAvailable ?? this.customerCreditAvailable,
        creditResponsiblePartyOnFile:
            creditResponsiblePartyOnFile ?? this.creditResponsiblePartyOnFile,
        creditResponsibleParty:
            creditResponsibleParty ?? this.creditResponsibleParty,
        tradeReferencesVerified:
            tradeReferencesVerified ?? this.tradeReferencesVerified,
        tradeReferencesVerifiedBy:
            tradeReferencesVerifiedBy ?? this.tradeReferencesVerifiedBy,
        tradeReferencesVerifiedOn:
            tradeReferencesVerifiedOn ?? this.tradeReferencesVerifiedOn,
        creditCardTypeId: creditCardTypeId ?? this.creditCardTypeId,
        creditCardType: creditCardType ?? this.creditCardType,
        creditCardLimit: creditCardLimit ?? this.creditCardLimit,
        creditCardNumber: creditCardNumber ?? this.creditCardNumber,
        creditCardCode: creditCardCode ?? this.creditCardCode,
        creditCardName: creditCardName ?? this.creditCardName,
        creditCardExpirationMonth:
            creditCardExpirationMonth ?? this.creditCardExpirationMonth,
        creditCardExpirationYear:
            creditCardExpirationYear ?? this.creditCardExpirationYear,
        creditCardAuthorizationFormOnFile: creditCardAuthorizationFormOnFile ??
            this.creditCardAuthorizationFormOnFile,
        depletingDepositThresholdAmount: depletingDepositThresholdAmount ??
            this.depletingDepositThresholdAmount,
        depletingDepositThresholdPercent: depletingDepositThresholdPercent ??
            this.depletingDepositThresholdPercent,
        depletingDepositTotal:
            depletingDepositTotal ?? this.depletingDepositTotal,
        depletingDepositApplied:
            depletingDepositApplied ?? this.depletingDepositApplied,
        depletingDepositRemaining:
            depletingDepositRemaining ?? this.depletingDepositRemaining,
        useCustomerInsurance: useCustomerInsurance ?? this.useCustomerInsurance,
        insuranceCertification:
            insuranceCertification ?? this.insuranceCertification,
        insuranceCertificationValidThrough: insuranceCertificationValidThrough ??
            this.insuranceCertificationValidThrough,
        insuranceCoverageLiability:
            insuranceCoverageLiability ?? this.insuranceCoverageLiability,
        insuranceCoverageLiabilityDeductible: insuranceCoverageLiabilityDeductible ??
            this.insuranceCoverageLiabilityDeductible,
        insuranceCoverageProperty:
            insuranceCoverageProperty ?? this.insuranceCoverageProperty,
        insuranceCoveragePropertyDeductible: insuranceCoveragePropertyDeductible ??
            this.insuranceCoveragePropertyDeductible,
        securityDepositAmount:
            securityDepositAmount ?? this.securityDepositAmount,
        insuranceCompanyId: insuranceCompanyId ?? this.insuranceCompanyId,
        insuranceCompany: insuranceCompany ?? this.insuranceCompany,
        insuranceCompanyAgent:
            insuranceCompanyAgent ?? this.insuranceCompanyAgent,
        insuranceCompanyAddress1:
            insuranceCompanyAddress1 ?? this.insuranceCompanyAddress1,
        insuranceCompanyAddress2:
            insuranceCompanyAddress2 ?? this.insuranceCompanyAddress2,
        insuranceCompanyCity: insuranceCompanyCity ?? this.insuranceCompanyCity,
        insuranceCompanyState:
            insuranceCompanyState ?? this.insuranceCompanyState,
        insuranceCompanyZipCode:
            insuranceCompanyZipCode ?? this.insuranceCompanyZipCode,
        insuranceCompanyCountryId:
            insuranceCompanyCountryId ?? this.insuranceCompanyCountryId,
        insuranceCompanyCountry:
            insuranceCompanyCountry ?? this.insuranceCompanyCountry,
        insuranceCompanyPhone:
            insuranceCompanyPhone ?? this.insuranceCompanyPhone,
        insuranceCompanyFax: insuranceCompanyFax ?? this.insuranceCompanyFax,
        vehicleInsuranceCertification:
            vehicleInsuranceCertification ?? this.vehicleInsuranceCertification,
        useCustomerTax: useCustomerTax ?? this.useCustomerTax,
        taxable: taxable ?? this.taxable,
        taxStateOfIncorporationId:
            taxStateOfIncorporationId ?? this.taxStateOfIncorporationId,
        taxStateOfIncorporation:
            taxStateOfIncorporation ?? this.taxStateOfIncorporation,
        taxFederalNo: taxFederalNo ?? this.taxFederalNo,
        nonTaxableYear: nonTaxableYear ?? this.nonTaxableYear,
        nonTaxableCertificateNo:
            nonTaxableCertificateNo ?? this.nonTaxableCertificateNo,
        nonTaxableCertificateValidThrough: nonTaxableCertificateValidThrough ??
            this.nonTaxableCertificateValidThrough,
        nonTaxableCertificateOnFile:
            nonTaxableCertificateOnFile ?? this.nonTaxableCertificateOnFile,
        disableQuoteOrderActivity: disableQuoteOrderActivity ?? this.disableQuoteOrderActivity,
        disableRental: disableRental ?? this.disableRental,
        disableSales: disableSales ?? this.disableSales,
        disableFacilities: disableFacilities ?? this.disableFacilities,
        disableTransportation: disableTransportation ?? this.disableTransportation,
        disableLabor: disableLabor ?? this.disableLabor,
        disableMisc: disableMisc ?? this.disableMisc,
        disableRentalSale: disableRentalSale ?? this.disableRentalSale,
        disableSubRental: disableSubRental ?? this.disableSubRental,
        disableSubSale: disableSubSale ?? this.disableSubSale,
        disableSubLabor: disableSubLabor ?? this.disableSubLabor,
        disableSubMisc: disableSubMisc ?? this.disableSubMisc,
        defaultOutgoingDeliveryType: defaultOutgoingDeliveryType ?? this.defaultOutgoingDeliveryType,
        defaultIncomingDeliveryType: defaultIncomingDeliveryType ?? this.defaultIncomingDeliveryType,
        shippingAddressType: shippingAddressType ?? this.shippingAddressType,
        shipAttention: shipAttention ?? this.shipAttention,
        shipAddress1: shipAddress1 ?? this.shipAddress1,
        shipAddress2: shipAddress2 ?? this.shipAddress2,
        shipCity: shipCity ?? this.shipCity,
        shipState: shipState ?? this.shipState,
        shipCountryId: shipCountryId ?? this.shipCountryId,
        shipCountry: shipCountry ?? this.shipCountry,
        shipZipCode: shipZipCode ?? this.shipZipCode,
        rebateRental: rebateRental ?? this.rebateRental,
        rebateCustomerId: rebateCustomerId ?? this.rebateCustomerId,
        rebateCustomer: rebateCustomer ?? this.rebateCustomer,
        ownedEquipmentRebateRentalPerecent: ownedEquipmentRebateRentalPerecent ?? this.ownedEquipmentRebateRentalPerecent,
        subRentalEquipmentRebateRentalPerecent: subRentalEquipmentRebateRentalPerecent ?? this.subRentalEquipmentRebateRentalPerecent,
        enableWebQuoteRequest: enableWebQuoteRequest ?? this.enableWebQuoteRequest,
        email: email ?? this.email,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes: defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentDealDealDocument {
  WebApiModulesAgentDealDealDocument({
    this.dealId,
    this.copying,
    this.documentId,
    this.documentTypeId,
    this.uniqueId1,
    this.uniqueId2,
    this.uniqueId1Int,
    this.description,
    this.inputByUsersId,
    this.attachDate,
    this.attachTime,
    this.attachToEmail,
    this.inactive,
    this.dateStamp,
    this.extension,
    this.documentType,
    this.inputBy,
    this.hasImage,
    this.hasFile,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAgentDealDealDocument.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentDealDealDocumentFromJson(json);

  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'copying')
  final bool? copying;
  @JsonKey(name: 'DocumentId')
  final String? documentId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'UniqueId1')
  final String? uniqueId1;
  @JsonKey(name: 'UniqueId2')
  final String? uniqueId2;
  @JsonKey(name: 'UniqueId1Int')
  final int? uniqueId1Int;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'InputByUsersId')
  final String? inputByUsersId;
  @JsonKey(name: 'AttachDate')
  final String? attachDate;
  @JsonKey(name: 'AttachTime')
  final String? attachTime;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'Extension')
  final String? extension;
  @JsonKey(name: 'DocumentType')
  final String? documentType;
  @JsonKey(name: 'InputBy')
  final String? inputBy;
  @JsonKey(name: 'HasImage')
  final bool? hasImage;
  @JsonKey(name: 'HasFile')
  final bool? hasFile;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory = _$WebApiModulesAgentDealDealDocumentFromJson;
  static const toJsonFactory = _$WebApiModulesAgentDealDealDocumentToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentDealDealDocumentToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentDealDealDocument &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.copying, copying) ||
                const DeepCollectionEquality()
                    .equals(other.copying, copying)) &&
            (identical(other.documentId, documentId) ||
                const DeepCollectionEquality()
                    .equals(other.documentId, documentId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.uniqueId1, uniqueId1) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1, uniqueId1)) &&
            (identical(other.uniqueId2, uniqueId2) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId2, uniqueId2)) &&
            (identical(other.uniqueId1Int, uniqueId1Int) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1Int, uniqueId1Int)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.inputByUsersId, inputByUsersId) ||
                const DeepCollectionEquality()
                    .equals(other.inputByUsersId, inputByUsersId)) &&
            (identical(other.attachDate, attachDate) ||
                const DeepCollectionEquality()
                    .equals(other.attachDate, attachDate)) &&
            (identical(other.attachTime, attachTime) ||
                const DeepCollectionEquality()
                    .equals(other.attachTime, attachTime)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.extension, extension) ||
                const DeepCollectionEquality()
                    .equals(other.extension, extension)) &&
            (identical(other.documentType, documentType) ||
                const DeepCollectionEquality()
                    .equals(other.documentType, documentType)) &&
            (identical(other.inputBy, inputBy) ||
                const DeepCollectionEquality()
                    .equals(other.inputBy, inputBy)) &&
            (identical(other.hasImage, hasImage) ||
                const DeepCollectionEquality()
                    .equals(other.hasImage, hasImage)) &&
            (identical(other.hasFile, hasFile) ||
                const DeepCollectionEquality()
                    .equals(other.hasFile, hasFile)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesAgentDealDealDocumentExtension
    on WebApiModulesAgentDealDealDocument {
  WebApiModulesAgentDealDealDocument copyWith(
      {String? dealId,
      bool? copying,
      String? documentId,
      String? documentTypeId,
      String? uniqueId1,
      String? uniqueId2,
      int? uniqueId1Int,
      String? description,
      String? inputByUsersId,
      String? attachDate,
      String? attachTime,
      bool? attachToEmail,
      bool? inactive,
      String? dateStamp,
      String? extension,
      String? documentType,
      String? inputBy,
      bool? hasImage,
      bool? hasFile,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAgentDealDealDocument(
        dealId: dealId ?? this.dealId,
        copying: copying ?? this.copying,
        documentId: documentId ?? this.documentId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        uniqueId1: uniqueId1 ?? this.uniqueId1,
        uniqueId2: uniqueId2 ?? this.uniqueId2,
        uniqueId1Int: uniqueId1Int ?? this.uniqueId1Int,
        description: description ?? this.description,
        inputByUsersId: inputByUsersId ?? this.inputByUsersId,
        attachDate: attachDate ?? this.attachDate,
        attachTime: attachTime ?? this.attachTime,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        dateStamp: dateStamp ?? this.dateStamp,
        extension: extension ?? this.extension,
        documentType: documentType ?? this.documentType,
        inputBy: inputBy ?? this.inputBy,
        hasImage: hasImage ?? this.hasImage,
        hasFile: hasFile ?? this.hasFile,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentDealDealDocumentPostRequest {
  WebApiModulesAgentDealDealDocumentPostRequest({
    this.dealId,
    this.documentTypeId,
    this.description,
    this.attachToEmail,
    this.inactive,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
  });

  factory WebApiModulesAgentDealDealDocumentPostRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentDealDealDocumentPostRequestFromJson(json);

  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  static const fromJsonFactory =
      _$WebApiModulesAgentDealDealDocumentPostRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentDealDealDocumentPostRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentDealDealDocumentPostRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentDealDealDocumentPostRequest &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)));
  }
}

extension $WebApiModulesAgentDealDealDocumentPostRequestExtension
    on WebApiModulesAgentDealDealDocumentPostRequest {
  WebApiModulesAgentDealDealDocumentPostRequest copyWith(
      {String? dealId,
      String? documentTypeId,
      String? description,
      bool? attachToEmail,
      bool? inactive,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath}) {
    return WebApiModulesAgentDealDealDocumentPostRequest(
        dealId: dealId ?? this.dealId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        description: description ?? this.description,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentDealDealDocumentPutRequest {
  WebApiModulesAgentDealDealDocumentPutRequest({
    this.dealId,
    this.documentId,
    this.documentTypeId,
    this.description,
    this.attachToEmail,
    this.inactive,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
  });

  factory WebApiModulesAgentDealDealDocumentPutRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentDealDealDocumentPutRequestFromJson(json);

  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'DocumentId')
  final String? documentId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  static const fromJsonFactory =
      _$WebApiModulesAgentDealDealDocumentPutRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentDealDealDocumentPutRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentDealDealDocumentPutRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentDealDealDocumentPutRequest &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.documentId, documentId) ||
                const DeepCollectionEquality()
                    .equals(other.documentId, documentId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)));
  }
}

extension $WebApiModulesAgentDealDealDocumentPutRequestExtension
    on WebApiModulesAgentDealDealDocumentPutRequest {
  WebApiModulesAgentDealDealDocumentPutRequest copyWith(
      {String? dealId,
      String? documentId,
      String? documentTypeId,
      String? description,
      bool? attachToEmail,
      bool? inactive,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath}) {
    return WebApiModulesAgentDealDealDocumentPutRequest(
        dealId: dealId ?? this.dealId,
        documentId: documentId ?? this.documentId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        description: description ?? this.description,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderCancelUncancelQuoteResponse {
  WebApiModulesAgentOrderCancelUncancelQuoteResponse({
    this.status,
    this.success,
    this.msg,
    this.quote,
  });

  factory WebApiModulesAgentOrderCancelUncancelQuoteResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderCancelUncancelQuoteResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'Quote')
  final WebApiModulesAgentQuoteQuote? quote;
  static const fromJsonFactory =
      _$WebApiModulesAgentOrderCancelUncancelQuoteResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentOrderCancelUncancelQuoteResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderCancelUncancelQuoteResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderCancelUncancelQuoteResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.quote, quote) ||
                const DeepCollectionEquality().equals(other.quote, quote)));
  }
}

extension $WebApiModulesAgentOrderCancelUncancelQuoteResponseExtension
    on WebApiModulesAgentOrderCancelUncancelQuoteResponse {
  WebApiModulesAgentOrderCancelUncancelQuoteResponse copyWith(
      {int? status,
      bool? success,
      String? msg,
      WebApiModulesAgentQuoteQuote? quote}) {
    return WebApiModulesAgentOrderCancelUncancelQuoteResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        quote: quote ?? this.quote);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderChangeOrderOfficeLocationRequest {
  WebApiModulesAgentOrderChangeOrderOfficeLocationRequest({
    this.officeLocationId,
    this.warehouseId,
  });

  factory WebApiModulesAgentOrderChangeOrderOfficeLocationRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderChangeOrderOfficeLocationRequestFromJson(json);

  @JsonKey(name: 'OfficeLocationId')
  final String? officeLocationId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  static const fromJsonFactory =
      _$WebApiModulesAgentOrderChangeOrderOfficeLocationRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentOrderChangeOrderOfficeLocationRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderChangeOrderOfficeLocationRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderChangeOrderOfficeLocationRequest &&
            (identical(other.officeLocationId, officeLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocationId, officeLocationId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)));
  }
}

extension $WebApiModulesAgentOrderChangeOrderOfficeLocationRequestExtension
    on WebApiModulesAgentOrderChangeOrderOfficeLocationRequest {
  WebApiModulesAgentOrderChangeOrderOfficeLocationRequest copyWith(
      {String? officeLocationId, String? warehouseId}) {
    return WebApiModulesAgentOrderChangeOrderOfficeLocationRequest(
        officeLocationId: officeLocationId ?? this.officeLocationId,
        warehouseId: warehouseId ?? this.warehouseId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderChangeOrderOfficeLocationResponse {
  WebApiModulesAgentOrderChangeOrderOfficeLocationResponse({
    this.status,
    this.success,
    this.msg,
    this.quoteOrOrder,
  });

  factory WebApiModulesAgentOrderChangeOrderOfficeLocationResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderChangeOrderOfficeLocationResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'quoteOrOrder')
  final WebApiModulesAgentOrderOrderBase? quoteOrOrder;
  static const fromJsonFactory =
      _$WebApiModulesAgentOrderChangeOrderOfficeLocationResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentOrderChangeOrderOfficeLocationResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderChangeOrderOfficeLocationResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderChangeOrderOfficeLocationResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.quoteOrOrder, quoteOrOrder) ||
                const DeepCollectionEquality()
                    .equals(other.quoteOrOrder, quoteOrOrder)));
  }
}

extension $WebApiModulesAgentOrderChangeOrderOfficeLocationResponseExtension
    on WebApiModulesAgentOrderChangeOrderOfficeLocationResponse {
  WebApiModulesAgentOrderChangeOrderOfficeLocationResponse copyWith(
      {int? status,
      bool? success,
      String? msg,
      WebApiModulesAgentOrderOrderBase? quoteOrOrder}) {
    return WebApiModulesAgentOrderChangeOrderOfficeLocationResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        quoteOrOrder: quoteOrOrder ?? this.quoteOrOrder);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderCompletePoWorksheetSessionRequest {
  WebApiModulesAgentOrderCompletePoWorksheetSessionRequest({
    this.sessionId,
  });

  factory WebApiModulesAgentOrderCompletePoWorksheetSessionRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderCompletePoWorksheetSessionRequestFromJson(json);

  @JsonKey(name: 'SessionId')
  final String? sessionId;
  static const fromJsonFactory =
      _$WebApiModulesAgentOrderCompletePoWorksheetSessionRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentOrderCompletePoWorksheetSessionRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderCompletePoWorksheetSessionRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderCompletePoWorksheetSessionRequest &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)));
  }
}

extension $WebApiModulesAgentOrderCompletePoWorksheetSessionRequestExtension
    on WebApiModulesAgentOrderCompletePoWorksheetSessionRequest {
  WebApiModulesAgentOrderCompletePoWorksheetSessionRequest copyWith(
      {String? sessionId}) {
    return WebApiModulesAgentOrderCompletePoWorksheetSessionRequest(
        sessionId: sessionId ?? this.sessionId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderCompletePoWorksheetSessionResponse {
  WebApiModulesAgentOrderCompletePoWorksheetSessionResponse({
    this.purchaseOrderId,
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesAgentOrderCompletePoWorksheetSessionResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderCompletePoWorksheetSessionResponseFromJson(json);

  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesAgentOrderCompletePoWorksheetSessionResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentOrderCompletePoWorksheetSessionResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderCompletePoWorksheetSessionResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderCompletePoWorksheetSessionResponse &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesAgentOrderCompletePoWorksheetSessionResponseExtension
    on WebApiModulesAgentOrderCompletePoWorksheetSessionResponse {
  WebApiModulesAgentOrderCompletePoWorksheetSessionResponse copyWith(
      {String? purchaseOrderId, int? status, bool? success, String? msg}) {
    return WebApiModulesAgentOrderCompletePoWorksheetSessionResponse(
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderCopyOrderItemsRequest {
  WebApiModulesAgentOrderCopyOrderItemsRequest({
    this.orderId,
    this.orderItemIds,
  });

  factory WebApiModulesAgentOrderCopyOrderItemsRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderCopyOrderItemsRequestFromJson(json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderItemIds', defaultValue: <String>[])
  final List<String>? orderItemIds;
  static const fromJsonFactory =
      _$WebApiModulesAgentOrderCopyOrderItemsRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentOrderCopyOrderItemsRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderCopyOrderItemsRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderCopyOrderItemsRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderItemIds, orderItemIds) ||
                const DeepCollectionEquality()
                    .equals(other.orderItemIds, orderItemIds)));
  }
}

extension $WebApiModulesAgentOrderCopyOrderItemsRequestExtension
    on WebApiModulesAgentOrderCopyOrderItemsRequest {
  WebApiModulesAgentOrderCopyOrderItemsRequest copyWith(
      {String? orderId, List<String>? orderItemIds}) {
    return WebApiModulesAgentOrderCopyOrderItemsRequest(
        orderId: orderId ?? this.orderId,
        orderItemIds: orderItemIds ?? this.orderItemIds);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderCopyOrderItemsResponse {
  WebApiModulesAgentOrderCopyOrderItemsResponse({
    this.status,
    this.success,
    this.msg,
    this.orderItemIds,
  });

  factory WebApiModulesAgentOrderCopyOrderItemsResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderCopyOrderItemsResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'OrderItemIds', defaultValue: <String>[])
  final List<String>? orderItemIds;
  static const fromJsonFactory =
      _$WebApiModulesAgentOrderCopyOrderItemsResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentOrderCopyOrderItemsResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderCopyOrderItemsResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderCopyOrderItemsResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.orderItemIds, orderItemIds) ||
                const DeepCollectionEquality()
                    .equals(other.orderItemIds, orderItemIds)));
  }
}

extension $WebApiModulesAgentOrderCopyOrderItemsResponseExtension
    on WebApiModulesAgentOrderCopyOrderItemsResponse {
  WebApiModulesAgentOrderCopyOrderItemsResponse copyWith(
      {int? status, bool? success, String? msg, List<String>? orderItemIds}) {
    return WebApiModulesAgentOrderCopyOrderItemsResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        orderItemIds: orderItemIds ?? this.orderItemIds);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderCopyQuoteOrderRequest {
  WebApiModulesAgentOrderCopyQuoteOrderRequest({
    this.copyToType,
    this.locationId,
    this.warehouseId,
  });

  factory WebApiModulesAgentOrderCopyQuoteOrderRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderCopyQuoteOrderRequestFromJson(json);

  @JsonKey(name: 'CopyToType')
  final String? copyToType;
  @JsonKey(name: 'LocationId')
  final String? locationId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  static const fromJsonFactory =
      _$WebApiModulesAgentOrderCopyQuoteOrderRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentOrderCopyQuoteOrderRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderCopyQuoteOrderRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderCopyQuoteOrderRequest &&
            (identical(other.copyToType, copyToType) ||
                const DeepCollectionEquality()
                    .equals(other.copyToType, copyToType)) &&
            (identical(other.locationId, locationId) ||
                const DeepCollectionEquality()
                    .equals(other.locationId, locationId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)));
  }
}

extension $WebApiModulesAgentOrderCopyQuoteOrderRequestExtension
    on WebApiModulesAgentOrderCopyQuoteOrderRequest {
  WebApiModulesAgentOrderCopyQuoteOrderRequest copyWith(
      {String? copyToType, String? locationId, String? warehouseId}) {
    return WebApiModulesAgentOrderCopyQuoteOrderRequest(
        copyToType: copyToType ?? this.copyToType,
        locationId: locationId ?? this.locationId,
        warehouseId: warehouseId ?? this.warehouseId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderCopyQuoteOrderResponse {
  WebApiModulesAgentOrderCopyQuoteOrderResponse({
    this.status,
    this.success,
    this.msg,
    this.copy,
  });

  factory WebApiModulesAgentOrderCopyQuoteOrderResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderCopyQuoteOrderResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'Copy')
  final WebApiModulesAgentOrderOrderBase? copy;
  static const fromJsonFactory =
      _$WebApiModulesAgentOrderCopyQuoteOrderResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentOrderCopyQuoteOrderResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderCopyQuoteOrderResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderCopyQuoteOrderResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.copy, copy) ||
                const DeepCollectionEquality().equals(other.copy, copy)));
  }
}

extension $WebApiModulesAgentOrderCopyQuoteOrderResponseExtension
    on WebApiModulesAgentOrderCopyQuoteOrderResponse {
  WebApiModulesAgentOrderCopyQuoteOrderResponse copyWith(
      {int? status,
      bool? success,
      String? msg,
      WebApiModulesAgentOrderOrderBase? copy}) {
    return WebApiModulesAgentOrderCopyQuoteOrderResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        copy: copy ?? this.copy);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderCopyTemplateRequest {
  WebApiModulesAgentOrderCopyTemplateRequest({
    this.templateIds,
    this.orderId,
    this.recType,
  });

  factory WebApiModulesAgentOrderCopyTemplateRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderCopyTemplateRequestFromJson(json);

  @JsonKey(name: 'TemplateIds', defaultValue: <String>[])
  final List<String>? templateIds;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'RecType')
  final String? recType;
  static const fromJsonFactory =
      _$WebApiModulesAgentOrderCopyTemplateRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentOrderCopyTemplateRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderCopyTemplateRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderCopyTemplateRequest &&
            (identical(other.templateIds, templateIds) ||
                const DeepCollectionEquality()
                    .equals(other.templateIds, templateIds)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.recType, recType) ||
                const DeepCollectionEquality().equals(other.recType, recType)));
  }
}

extension $WebApiModulesAgentOrderCopyTemplateRequestExtension
    on WebApiModulesAgentOrderCopyTemplateRequest {
  WebApiModulesAgentOrderCopyTemplateRequest copyWith(
      {List<String>? templateIds, String? orderId, String? recType}) {
    return WebApiModulesAgentOrderCopyTemplateRequest(
        templateIds: templateIds ?? this.templateIds,
        orderId: orderId ?? this.orderId,
        recType: recType ?? this.recType);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderCopyTemplateResponse {
  WebApiModulesAgentOrderCopyTemplateResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesAgentOrderCopyTemplateResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderCopyTemplateResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesAgentOrderCopyTemplateResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentOrderCopyTemplateResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderCopyTemplateResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderCopyTemplateResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesAgentOrderCopyTemplateResponseExtension
    on WebApiModulesAgentOrderCopyTemplateResponse {
  WebApiModulesAgentOrderCopyTemplateResponse copyWith(
      {int? status, bool? success, String? msg}) {
    return WebApiModulesAgentOrderCopyTemplateResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderCreatePoWorksheetSessionRequest {
  WebApiModulesAgentOrderCreatePoWorksheetSessionRequest({
    this.orderId,
    this.recType,
    this.vendorId,
    this.contactId,
    this.rateType,
    this.currencyId,
    this.billingCycleId,
    this.requiredDate,
    this.requiredTime,
    this.fromDate,
    this.toDate,
    this.deliveryId,
    this.adjustContractDates,
  });

  factory WebApiModulesAgentOrderCreatePoWorksheetSessionRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderCreatePoWorksheetSessionRequestFromJson(json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'RecType')
  final String? recType;
  @JsonKey(name: 'VendorId')
  final String? vendorId;
  @JsonKey(name: 'ContactId')
  final String? contactId;
  @JsonKey(name: 'RateType')
  final String? rateType;
  @JsonKey(name: 'CurrencyId')
  final String? currencyId;
  @JsonKey(name: 'BillingCycleId')
  final String? billingCycleId;
  @JsonKey(name: 'RequiredDate')
  final DateTime? requiredDate;
  @JsonKey(name: 'RequiredTime')
  final String? requiredTime;
  @JsonKey(name: 'FromDate')
  final DateTime? fromDate;
  @JsonKey(name: 'ToDate')
  final DateTime? toDate;
  @JsonKey(name: 'DeliveryId')
  final String? deliveryId;
  @JsonKey(name: 'AdjustContractDates')
  final bool? adjustContractDates;
  static const fromJsonFactory =
      _$WebApiModulesAgentOrderCreatePoWorksheetSessionRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentOrderCreatePoWorksheetSessionRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderCreatePoWorksheetSessionRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderCreatePoWorksheetSessionRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.recType, recType) ||
                const DeepCollectionEquality()
                    .equals(other.recType, recType)) &&
            (identical(other.vendorId, vendorId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorId, vendorId)) &&
            (identical(other.contactId, contactId) ||
                const DeepCollectionEquality()
                    .equals(other.contactId, contactId)) &&
            (identical(other.rateType, rateType) ||
                const DeepCollectionEquality()
                    .equals(other.rateType, rateType)) &&
            (identical(other.currencyId, currencyId) ||
                const DeepCollectionEquality()
                    .equals(other.currencyId, currencyId)) &&
            (identical(other.billingCycleId, billingCycleId) ||
                const DeepCollectionEquality()
                    .equals(other.billingCycleId, billingCycleId)) &&
            (identical(other.requiredDate, requiredDate) ||
                const DeepCollectionEquality()
                    .equals(other.requiredDate, requiredDate)) &&
            (identical(other.requiredTime, requiredTime) ||
                const DeepCollectionEquality()
                    .equals(other.requiredTime, requiredTime)) &&
            (identical(other.fromDate, fromDate) ||
                const DeepCollectionEquality()
                    .equals(other.fromDate, fromDate)) &&
            (identical(other.toDate, toDate) ||
                const DeepCollectionEquality().equals(other.toDate, toDate)) &&
            (identical(other.deliveryId, deliveryId) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryId, deliveryId)) &&
            (identical(other.adjustContractDates, adjustContractDates) ||
                const DeepCollectionEquality()
                    .equals(other.adjustContractDates, adjustContractDates)));
  }
}

extension $WebApiModulesAgentOrderCreatePoWorksheetSessionRequestExtension
    on WebApiModulesAgentOrderCreatePoWorksheetSessionRequest {
  WebApiModulesAgentOrderCreatePoWorksheetSessionRequest copyWith(
      {String? orderId,
      String? recType,
      String? vendorId,
      String? contactId,
      String? rateType,
      String? currencyId,
      String? billingCycleId,
      DateTime? requiredDate,
      String? requiredTime,
      DateTime? fromDate,
      DateTime? toDate,
      String? deliveryId,
      bool? adjustContractDates}) {
    return WebApiModulesAgentOrderCreatePoWorksheetSessionRequest(
        orderId: orderId ?? this.orderId,
        recType: recType ?? this.recType,
        vendorId: vendorId ?? this.vendorId,
        contactId: contactId ?? this.contactId,
        rateType: rateType ?? this.rateType,
        currencyId: currencyId ?? this.currencyId,
        billingCycleId: billingCycleId ?? this.billingCycleId,
        requiredDate: requiredDate ?? this.requiredDate,
        requiredTime: requiredTime ?? this.requiredTime,
        fromDate: fromDate ?? this.fromDate,
        toDate: toDate ?? this.toDate,
        deliveryId: deliveryId ?? this.deliveryId,
        adjustContractDates: adjustContractDates ?? this.adjustContractDates);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderCreatePoWorksheetSessionResponse {
  WebApiModulesAgentOrderCreatePoWorksheetSessionResponse({
    this.sessionId,
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesAgentOrderCreatePoWorksheetSessionResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderCreatePoWorksheetSessionResponseFromJson(json);

  @JsonKey(name: 'SessionId')
  final String? sessionId;
  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesAgentOrderCreatePoWorksheetSessionResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentOrderCreatePoWorksheetSessionResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderCreatePoWorksheetSessionResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderCreatePoWorksheetSessionResponse &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesAgentOrderCreatePoWorksheetSessionResponseExtension
    on WebApiModulesAgentOrderCreatePoWorksheetSessionResponse {
  WebApiModulesAgentOrderCreatePoWorksheetSessionResponse copyWith(
      {String? sessionId, int? status, bool? success, String? msg}) {
    return WebApiModulesAgentOrderCreatePoWorksheetSessionResponse(
        sessionId: sessionId ?? this.sessionId,
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderCustomRates {
  WebApiModulesAgentOrderCustomRates({
    this.dailyRate,
    this.weeklyRate,
    this.week2Rate,
    this.week3Rate,
    this.week4Rate,
    this.week5Rate,
    this.monthlyRate,
  });

  factory WebApiModulesAgentOrderCustomRates.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderCustomRatesFromJson(json);

  @JsonKey(name: 'DailyRate')
  final double? dailyRate;
  @JsonKey(name: 'WeeklyRate')
  final double? weeklyRate;
  @JsonKey(name: 'Week2Rate')
  final double? week2Rate;
  @JsonKey(name: 'Week3Rate')
  final double? week3Rate;
  @JsonKey(name: 'Week4Rate')
  final double? week4Rate;
  @JsonKey(name: 'Week5Rate')
  final double? week5Rate;
  @JsonKey(name: 'MonthlyRate')
  final double? monthlyRate;
  static const fromJsonFactory = _$WebApiModulesAgentOrderCustomRatesFromJson;
  static const toJsonFactory = _$WebApiModulesAgentOrderCustomRatesToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderCustomRatesToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderCustomRates &&
            (identical(other.dailyRate, dailyRate) ||
                const DeepCollectionEquality()
                    .equals(other.dailyRate, dailyRate)) &&
            (identical(other.weeklyRate, weeklyRate) ||
                const DeepCollectionEquality()
                    .equals(other.weeklyRate, weeklyRate)) &&
            (identical(other.week2Rate, week2Rate) ||
                const DeepCollectionEquality()
                    .equals(other.week2Rate, week2Rate)) &&
            (identical(other.week3Rate, week3Rate) ||
                const DeepCollectionEquality()
                    .equals(other.week3Rate, week3Rate)) &&
            (identical(other.week4Rate, week4Rate) ||
                const DeepCollectionEquality()
                    .equals(other.week4Rate, week4Rate)) &&
            (identical(other.week5Rate, week5Rate) ||
                const DeepCollectionEquality()
                    .equals(other.week5Rate, week5Rate)) &&
            (identical(other.monthlyRate, monthlyRate) ||
                const DeepCollectionEquality()
                    .equals(other.monthlyRate, monthlyRate)));
  }
}

extension $WebApiModulesAgentOrderCustomRatesExtension
    on WebApiModulesAgentOrderCustomRates {
  WebApiModulesAgentOrderCustomRates copyWith(
      {double? dailyRate,
      double? weeklyRate,
      double? week2Rate,
      double? week3Rate,
      double? week4Rate,
      double? week5Rate,
      double? monthlyRate}) {
    return WebApiModulesAgentOrderCustomRates(
        dailyRate: dailyRate ?? this.dailyRate,
        weeklyRate: weeklyRate ?? this.weeklyRate,
        week2Rate: week2Rate ?? this.week2Rate,
        week3Rate: week3Rate ?? this.week3Rate,
        week4Rate: week4Rate ?? this.week4Rate,
        week5Rate: week5Rate ?? this.week5Rate,
        monthlyRate: monthlyRate ?? this.monthlyRate);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderGetCustomRatesRequest {
  WebApiModulesAgentOrderGetCustomRatesRequest({
    this.orderId,
    this.inventoryId,
    this.recType,
  });

  factory WebApiModulesAgentOrderGetCustomRatesRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderGetCustomRatesRequestFromJson(json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'RecType')
  final String? recType;
  static const fromJsonFactory =
      _$WebApiModulesAgentOrderGetCustomRatesRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentOrderGetCustomRatesRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderGetCustomRatesRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderGetCustomRatesRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.recType, recType) ||
                const DeepCollectionEquality().equals(other.recType, recType)));
  }
}

extension $WebApiModulesAgentOrderGetCustomRatesRequestExtension
    on WebApiModulesAgentOrderGetCustomRatesRequest {
  WebApiModulesAgentOrderGetCustomRatesRequest copyWith(
      {String? orderId, String? inventoryId, String? recType}) {
    return WebApiModulesAgentOrderGetCustomRatesRequest(
        orderId: orderId ?? this.orderId,
        inventoryId: inventoryId ?? this.inventoryId,
        recType: recType ?? this.recType);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderGetCustomRatesResponse {
  WebApiModulesAgentOrderGetCustomRatesResponse({
    this.status,
    this.success,
    this.msg,
    this.hasDiscount,
    this.applyDiscountToCustomRate,
    this.customRates,
    this.daysPerWeek,
    this.discountPercent,
    this.markupPercent,
    this.marginPercent,
  });

  factory WebApiModulesAgentOrderGetCustomRatesResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderGetCustomRatesResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'HasDiscount')
  final bool? hasDiscount;
  @JsonKey(name: 'ApplyDiscountToCustomRate')
  final bool? applyDiscountToCustomRate;
  @JsonKey(name: 'CustomRates')
  final WebApiModulesAgentOrderCustomRates? customRates;
  @JsonKey(name: 'DaysPerWeek')
  final double? daysPerWeek;
  @JsonKey(name: 'DiscountPercent')
  final double? discountPercent;
  @JsonKey(name: 'MarkupPercent')
  final double? markupPercent;
  @JsonKey(name: 'MarginPercent')
  final double? marginPercent;
  static const fromJsonFactory =
      _$WebApiModulesAgentOrderGetCustomRatesResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentOrderGetCustomRatesResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderGetCustomRatesResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderGetCustomRatesResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.hasDiscount, hasDiscount) ||
                const DeepCollectionEquality()
                    .equals(other.hasDiscount, hasDiscount)) &&
            (identical(other.applyDiscountToCustomRate,
                    applyDiscountToCustomRate) ||
                const DeepCollectionEquality().equals(
                    other.applyDiscountToCustomRate,
                    applyDiscountToCustomRate)) &&
            (identical(other.customRates, customRates) ||
                const DeepCollectionEquality()
                    .equals(other.customRates, customRates)) &&
            (identical(other.daysPerWeek, daysPerWeek) ||
                const DeepCollectionEquality()
                    .equals(other.daysPerWeek, daysPerWeek)) &&
            (identical(other.discountPercent, discountPercent) ||
                const DeepCollectionEquality()
                    .equals(other.discountPercent, discountPercent)) &&
            (identical(other.markupPercent, markupPercent) ||
                const DeepCollectionEquality()
                    .equals(other.markupPercent, markupPercent)) &&
            (identical(other.marginPercent, marginPercent) ||
                const DeepCollectionEquality()
                    .equals(other.marginPercent, marginPercent)));
  }
}

extension $WebApiModulesAgentOrderGetCustomRatesResponseExtension
    on WebApiModulesAgentOrderGetCustomRatesResponse {
  WebApiModulesAgentOrderGetCustomRatesResponse copyWith(
      {int? status,
      bool? success,
      String? msg,
      bool? hasDiscount,
      bool? applyDiscountToCustomRate,
      WebApiModulesAgentOrderCustomRates? customRates,
      double? daysPerWeek,
      double? discountPercent,
      double? markupPercent,
      double? marginPercent}) {
    return WebApiModulesAgentOrderGetCustomRatesResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        hasDiscount: hasDiscount ?? this.hasDiscount,
        applyDiscountToCustomRate:
            applyDiscountToCustomRate ?? this.applyDiscountToCustomRate,
        customRates: customRates ?? this.customRates,
        daysPerWeek: daysPerWeek ?? this.daysPerWeek,
        discountPercent: discountPercent ?? this.discountPercent,
        markupPercent: markupPercent ?? this.markupPercent,
        marginPercent: marginPercent ?? this.marginPercent);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderGetOrderResponse {
  WebApiModulesAgentOrderGetOrderResponse({
    this.orderId,
    this.orderNumber,
    this.orderDate,
    this.sourceQuoteId,
    this.sourceQuoteNumber,
    this.description,
    this.officeLocationId,
    this.officeLocation,
    this.warehouseId,
    this.warehouse,
    this.warehouseCode,
    this.departmentId,
    this.department,
    this.customerId,
    this.customer,
    this.customerNumber,
    this.dealId,
    this.deal,
    this.dealNumber,
    this.rateType,
    this.rateTypeDisplay,
    this.agentId,
    this.agent,
    this.projectManagerId,
    this.projectManager,
    this.rental,
    this.sales,
    this.miscellaneous,
    this.labor,
    this.facilities,
    this.transportation,
    this.rentalSale,
    this.lossAndDamage,
    this.repair,
    this.hasRentalItem,
    this.hasSalesItem,
    this.hasMiscellaneousItem,
    this.hasLaborItem,
    this.hasFacilitiesItem,
    this.hasLossAndDamageItem,
    this.hasRentalSaleItem,
    this.hasRepair,
    this.activityDatesAndTimes,
    this.pickDate,
    this.pickTime,
    this.estimatedStartDate,
    this.estimatedStartTime,
    this.estimatedStopDate,
    this.estimatedStopTime,
    this.pickUpDate,
    this.pickUpTime,
    this.prepDate,
    this.prepTime,
    this.loadInDate,
    this.loadInTime,
    this.strikeDate,
    this.strikeTime,
    this.testDate,
    this.testTime,
    this.orderTypeId,
    this.orderType,
    this.orderTypeCombineActivityTabs,
    this.flatPo,
    this.pendingPo,
    this.poNumber,
    this.poAmount,
    this.location,
    this.orderLocationId,
    this.orderLocation,
    this.referenceNumber,
    this.total,
    this.status,
    this.statusDate,
    this.poApprovalStatusId,
    this.lockBillingDates,
    this.specifyBillingDatesByType,
    this.rentalBillingStartDate,
    this.rentalBillingEndDate,
    this.laborBillingStartDate,
    this.laborBillingEndDate,
    this.miscellaneousBillingStartDate,
    this.miscellaneousBillingEndDate,
    this.facilitiesBillingStartDate,
    this.facilitiesBillingEndDate,
    this.vehicleBillingStartDate,
    this.vehicleBillingEndDate,
    this.delayBillingSearchUntil,
    this.includePrepFeesInRentalRate,
    this.billingStartDate,
    this.billingEndDate,
    this.billingWeeks,
    this.billingMonths,
    this.determineQuantitiesToBillBasedOn,
    this.billingCycleId,
    this.billingCycle,
    this.billingCycleType,
    this.paymentTermsId,
    this.paymentTerms,
    this.paymentTypeId,
    this.paymentType,
    this.currencyId,
    this.updateAllRatesToNewCurrency,
    this.confirmUpdateAllRatesToNewCurrency,
    this.currencyCode,
    this.currency,
    this.currencySymbol,
    this.taxOptionId,
    this.taxOption,
    this.tax1Name,
    this.tax2Name,
    this.taxId,
    this.rentalTaxRate1,
    this.salesTaxRate1,
    this.laborTaxRate1,
    this.rentalTaxRate2,
    this.salesTaxRate2,
    this.laborTaxRate2,
    this.noCharge,
    this.noChargeReason,
    this.printIssuedToAddressFrom,
    this.issuedToName,
    this.issuedToAttention,
    this.issuedToAttention2,
    this.issuedToAddress1,
    this.issuedToAddress2,
    this.issuedToCity,
    this.issuedToState,
    this.issuedToZipCode,
    this.issuedToCountryId,
    this.issuedToCountry,
    this.billToAddressDifferentFromIssuedToAddress,
    this.billToAddressId,
    this.billToName,
    this.billToAttention,
    this.billToAttention2,
    this.billToAddress1,
    this.billToAddress2,
    this.billToCity,
    this.billToState,
    this.billToZipCode,
    this.billToCountryId,
    this.billToCountry,
    this.discountReasonId,
    this.discountReason,
    this.requireContactConfirmation,
    this.includeInBillingAnalysis,
    this.hiatusDiscountFrom,
    this.roundTripRentals,
    this.inGroup,
    this.groupNumber,
    this.groupColor,
    this.groupOrderBy,
    this.coverLetterId,
    this.coverLetter,
    this.termsConditionsId,
    this.termsConditions,
    this.outsideSalesRepresentativeId,
    this.outsideSalesRepresentative,
    this.marketTypeId,
    this.marketType,
    this.marketSegmentId,
    this.marketSegment,
    this.marketSegmentJobId,
    this.marketSegmentJob,
    this.outDeliveryId,
    this.outDeliveryDeliveryType,
    this.outDeliveryRequiredDate,
    this.outDeliveryRequiredTime,
    this.outDeliveryTargetShipDate,
    this.outDeliveryTargetShipTime,
    this.outDeliveryDirection,
    this.outDeliveryAddressType,
    this.outDeliveryFromLocation,
    this.outDeliveryFromContact,
    this.outDeliveryFromContactPhone,
    this.outDeliveryFromAlternateContact,
    this.outDeliveryFromAlternateContactPhone,
    this.outDeliveryFromAttention,
    this.outDeliveryFromAddress1,
    this.outDeliveryFromAdd2ress,
    this.outDeliveryFromCity,
    this.outDeliveryFromState,
    this.outDeliveryFromZipCode,
    this.outDeliveryFromCountry,
    this.outDeliveryFromCountryId,
    this.outDeliveryFromCrossStreets,
    this.outDeliveryToLocation,
    this.outDeliveryToContact,
    this.outDeliveryToContactPhone,
    this.outDeliveryToAlternateContact,
    this.outDeliveryToAlternateContactPhone,
    this.outDeliveryToAttention,
    this.outDeliveryToAddress1,
    this.outDeliveryToAddress2,
    this.outDeliveryToCity,
    this.outDeliveryToState,
    this.outDeliveryToZipCode,
    this.outDeliveryToCountryId,
    this.outDeliveryToCountry,
    this.outDeliveryToContactFax,
    this.outDeliveryToCrossStreets,
    this.outDeliveryDeliveryNotes,
    this.outDeliveryCarrierId,
    this.outDeliveryCarrier,
    this.outDeliveryCarrierAccount,
    this.outDeliveryShipViaId,
    this.outDeliveryShipVia,
    this.outDeliveryInvoiceId,
    this.outDeliveryVendorInvoiceId,
    this.outDeliveryEstimatedFreight,
    this.outDeliveryFreightInvoiceAmount,
    this.outDeliveryChargeType,
    this.outDeliveryFreightTrackingNumber,
    this.outDeliveryFreightTrackingUrl,
    this.outDeliveryPackageCode,
    this.outDeliveryBillPoFreightOnOrder,
    this.outDeliveryOnlineOrderNumber,
    this.outDeliveryToVenue,
    this.outDeliveryToVenueId,
    this.outDeliveryToWarehouse,
    this.outDeliveryToWarehouseId,
    this.outDeliveryDateStamp,
    this.inDeliveryId,
    this.inDeliveryDeliveryType,
    this.inDeliveryRequiredDate,
    this.inDeliveryRequiredTime,
    this.inDeliveryTargetShipDate,
    this.inDeliveryTargetShipTime,
    this.inDeliveryDirection,
    this.inDeliveryAddressType,
    this.inDeliveryFromLocation,
    this.inDeliveryFromContact,
    this.inDeliveryFromContactPhone,
    this.inDeliveryFromAlternateContact,
    this.inDeliveryFromAlternateContactPhone,
    this.inDeliveryFromAttention,
    this.inDeliveryFromAddress1,
    this.inDeliveryFromAdd2ress,
    this.inDeliveryFromCity,
    this.inDeliveryFromState,
    this.inDeliveryFromZipCode,
    this.inDeliveryFromCountry,
    this.inDeliveryFromCountryId,
    this.inDeliveryFromCrossStreets,
    this.inDeliveryToLocation,
    this.inDeliveryToContact,
    this.inDeliveryToContactPhone,
    this.inDeliveryToAlternateContact,
    this.inDeliveryToAlternateContactPhone,
    this.inDeliveryToAttention,
    this.inDeliveryToAddress1,
    this.inDeliveryToAddress2,
    this.inDeliveryToCity,
    this.inDeliveryToState,
    this.inDeliveryToZipCode,
    this.inDeliveryToCountryId,
    this.inDeliveryToCountry,
    this.inDeliveryToContactFax,
    this.inDeliveryToCrossStreets,
    this.inDeliveryDeliveryNotes,
    this.inDeliveryCarrierId,
    this.inDeliveryCarrier,
    this.inDeliveryCarrierAccount,
    this.inDeliveryShipViaId,
    this.inDeliveryShipVia,
    this.inDeliveryInvoiceId,
    this.inDeliveryVendorInvoiceId,
    this.inDeliveryEstimatedFreight,
    this.inDeliveryFreightInvoiceAmount,
    this.inDeliveryChargeType,
    this.inDeliveryFreightTrackingNumber,
    this.inDeliveryFreightTrackingUrl,
    this.inDeliveryPackageCode,
    this.inDeliveryBillPoFreightOnOrder,
    this.inDeliveryOnlineOrderNumber,
    this.inDeliveryOnlineOrderStatus,
    this.inDeliveryToVenue,
    this.inDeliveryToVenueId,
    this.inDeliveryToWarehouse,
    this.inDeliveryToWarehouseId,
    this.inDeliveryDateStamp,
    this.rentalDaysPerWeek,
    this.rentalDiscountPercent,
    this.weeklyRentalTotal,
    this.monthlyRentalTotal,
    this.periodRentalTotal,
    this.weeklyRentalTotalIncludesTax,
    this.monthlyRentalTotalIncludesTax,
    this.periodRentalTotalIncludesTax,
    this.billLockedTotal,
    this.salesDiscountPercent,
    this.salesTotal,
    this.salesTotalIncludesTax,
    this.partsDiscountPercent,
    this.partsTotal,
    this.partsTotalIncludesTax,
    this.spaceDaysPerWeek,
    this.spaceDiscountPercent,
    this.spaceSplitPercent,
    this.weeklySpaceTotal,
    this.monthlySpaceTotal,
    this.periodSpaceTotal,
    this.weeklySpaceTotalIncludesTax,
    this.monthlySpaceTotalIncludesTax,
    this.periodSpaceTotalIncludesTax,
    this.vehicleDaysPerWeek,
    this.vehicleDiscountPercent,
    this.weeklyVehicleTotal,
    this.monthlyVehicleTotal,
    this.periodVehicleTotal,
    this.weeklyVehicleTotalIncludesTax,
    this.monthlyVehicleTotalIncludesTax,
    this.periodVehicleTotalIncludesTax,
    this.miscDiscountPercent,
    this.weeklyMiscTotal,
    this.monthlyMiscTotal,
    this.periodMiscTotal,
    this.weeklyMiscTotalIncludesTax,
    this.monthlyMiscTotalIncludesTax,
    this.periodMiscTotalIncludesTax,
    this.laborDiscountPercent,
    this.weeklyLaborTotal,
    this.monthlyLaborTotal,
    this.periodLaborTotal,
    this.weeklyLaborTotalIncludesTax,
    this.monthlyLaborTotalIncludesTax,
    this.periodLaborTotalIncludesTax,
    this.rentalSaleDiscountPercent,
    this.rentalSaleTotal,
    this.rentalSaleTotalIncludesTax,
    this.lossAndDamageDiscountPercent,
    this.lossAndDamageTotal,
    this.lossAndDamageTotalIncludesTax,
    this.combinedDaysPerWeek,
    this.combinedDiscountPercent,
    this.weeklyCombinedTotal,
    this.monthlyCombinedTotal,
    this.periodCombinedTotal,
    this.weeklyCombinedTotalIncludesTax,
    this.monthlyCombinedTotalIncludesTax,
    this.periodCombinedTotalIncludesTax,
    this.disableEditingRentalRate,
    this.disableEditingSalesRate,
    this.disableEditingMiscellaneousRate,
    this.disableEditingLaborRate,
    this.disableEditingRentalSaleRate,
    this.disableEditingLossAndDamageRate,
    this.rentalExtendedTotal,
    this.salesExtendedTotal,
    this.laborExtendedTotal,
    this.miscellaneousExtendedTotal,
    this.rentalSaleExtendedTotal,
    this.lossAndDamageExtendedTotal,
    this.hasNotes,
    this.hasDocuments,
    this.hasEmailHistory,
    this.hasContacts,
    this.hasSubPurchaseOrders,
    this.hasPickLists,
    this.hasContracts,
    this.hasSuspendedContracts,
    this.hasMultiOrderContracts,
    this.hasInvoices,
    this.hasBillingWorksheets,
    this.hasMultiOrderInvoices,
    this.totalReplacementCost,
    this.presentationLayerId,
    this.presentationLayer,
    this.isManualSort,
    this.quoteOrderTitle,
    this.unassignedSubs,
    this.nonTaxable,
    this.enableProjects,
    this.projectId,
    this.projectNumber,
    this.project,
    this.projectDrawingsId,
    this.projectDrawings,
    this.projectItemsOrderedId,
    this.projectItemsOrdered,
    this.projectDropShipId,
    this.projectDropShip,
    this.projectAsBuildId,
    this.projectAsBuild,
    this.projectCommissioningId,
    this.projectCommissioning,
    this.projectDepositId,
    this.projectDeposit,
    this.inputByUserId,
    this.modifiedByUserId,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.items,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAgentOrderGetOrderResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderGetOrderResponseFromJson(json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderNumber')
  final String? orderNumber;
  @JsonKey(name: 'OrderDate')
  final String? orderDate;
  @JsonKey(name: 'SourceQuoteId')
  final String? sourceQuoteId;
  @JsonKey(name: 'SourceQuoteNumber')
  final String? sourceQuoteNumber;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'OfficeLocationId')
  final String? officeLocationId;
  @JsonKey(name: 'OfficeLocation')
  final String? officeLocation;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'Department')
  final String? department;
  @JsonKey(name: 'CustomerId')
  final String? customerId;
  @JsonKey(name: 'Customer')
  final String? customer;
  @JsonKey(name: 'CustomerNumber')
  final String? customerNumber;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'Deal')
  final String? deal;
  @JsonKey(name: 'DealNumber')
  final String? dealNumber;
  @JsonKey(name: 'RateType')
  final String? rateType;
  @JsonKey(name: 'RateTypeDisplay')
  final String? rateTypeDisplay;
  @JsonKey(name: 'AgentId')
  final String? agentId;
  @JsonKey(name: 'Agent')
  final String? agent;
  @JsonKey(name: 'ProjectManagerId')
  final String? projectManagerId;
  @JsonKey(name: 'ProjectManager')
  final String? projectManager;
  @JsonKey(name: 'Rental')
  final bool? rental;
  @JsonKey(name: 'Sales')
  final bool? sales;
  @JsonKey(name: 'Miscellaneous')
  final bool? miscellaneous;
  @JsonKey(name: 'Labor')
  final bool? labor;
  @JsonKey(name: 'Facilities')
  final bool? facilities;
  @JsonKey(name: 'Transportation')
  final bool? transportation;
  @JsonKey(name: 'RentalSale')
  final bool? rentalSale;
  @JsonKey(name: 'LossAndDamage')
  final bool? lossAndDamage;
  @JsonKey(name: 'Repair')
  final bool? repair;
  @JsonKey(name: 'HasRentalItem')
  final bool? hasRentalItem;
  @JsonKey(name: 'HasSalesItem')
  final bool? hasSalesItem;
  @JsonKey(name: 'HasMiscellaneousItem')
  final bool? hasMiscellaneousItem;
  @JsonKey(name: 'HasLaborItem')
  final bool? hasLaborItem;
  @JsonKey(name: 'HasFacilitiesItem')
  final bool? hasFacilitiesItem;
  @JsonKey(name: 'HasLossAndDamageItem')
  final bool? hasLossAndDamageItem;
  @JsonKey(name: 'HasRentalSaleItem')
  final bool? hasRentalSaleItem;
  @JsonKey(name: 'HasRepair')
  final bool? hasRepair;
  @JsonKey(
      name: 'ActivityDatesAndTimes',
      defaultValue: <WebApiModulesHomeControlsOrderDatesOrderDates>[])
  final List<WebApiModulesHomeControlsOrderDatesOrderDates>?
      activityDatesAndTimes;
  @JsonKey(name: 'PickDate')
  final String? pickDate;
  @JsonKey(name: 'PickTime')
  final String? pickTime;
  @JsonKey(name: 'EstimatedStartDate')
  final String? estimatedStartDate;
  @JsonKey(name: 'EstimatedStartTime')
  final String? estimatedStartTime;
  @JsonKey(name: 'EstimatedStopDate')
  final String? estimatedStopDate;
  @JsonKey(name: 'EstimatedStopTime')
  final String? estimatedStopTime;
  @JsonKey(name: 'PickUpDate')
  final String? pickUpDate;
  @JsonKey(name: 'PickUpTime')
  final String? pickUpTime;
  @JsonKey(name: 'PrepDate')
  final String? prepDate;
  @JsonKey(name: 'PrepTime')
  final String? prepTime;
  @JsonKey(name: 'LoadInDate')
  final String? loadInDate;
  @JsonKey(name: 'LoadInTime')
  final String? loadInTime;
  @JsonKey(name: 'StrikeDate')
  final String? strikeDate;
  @JsonKey(name: 'StrikeTime')
  final String? strikeTime;
  @JsonKey(name: 'TestDate')
  final String? testDate;
  @JsonKey(name: 'TestTime')
  final String? testTime;
  @JsonKey(name: 'OrderTypeId')
  final String? orderTypeId;
  @JsonKey(name: 'OrderType')
  final String? orderType;
  @JsonKey(name: 'OrderTypeCombineActivityTabs')
  final bool? orderTypeCombineActivityTabs;
  @JsonKey(name: 'FlatPo')
  final bool? flatPo;
  @JsonKey(name: 'PendingPo')
  final bool? pendingPo;
  @JsonKey(name: 'PoNumber')
  final String? poNumber;
  @JsonKey(name: 'PoAmount')
  final double? poAmount;
  @JsonKey(name: 'Location')
  final String? location;
  @JsonKey(name: 'OrderLocationId')
  final String? orderLocationId;
  @JsonKey(name: 'OrderLocation')
  final String? orderLocation;
  @JsonKey(name: 'ReferenceNumber')
  final String? referenceNumber;
  @JsonKey(name: 'Total')
  final double? total;
  @JsonKey(name: 'Status')
  final String? status;
  @JsonKey(name: 'StatusDate')
  final String? statusDate;
  @JsonKey(name: 'PoApprovalStatusId')
  final String? poApprovalStatusId;
  @JsonKey(name: 'LockBillingDates')
  final bool? lockBillingDates;
  @JsonKey(name: 'SpecifyBillingDatesByType')
  final bool? specifyBillingDatesByType;
  @JsonKey(name: 'RentalBillingStartDate')
  final String? rentalBillingStartDate;
  @JsonKey(name: 'RentalBillingEndDate')
  final String? rentalBillingEndDate;
  @JsonKey(name: 'LaborBillingStartDate')
  final String? laborBillingStartDate;
  @JsonKey(name: 'LaborBillingEndDate')
  final String? laborBillingEndDate;
  @JsonKey(name: 'MiscellaneousBillingStartDate')
  final String? miscellaneousBillingStartDate;
  @JsonKey(name: 'MiscellaneousBillingEndDate')
  final String? miscellaneousBillingEndDate;
  @JsonKey(name: 'FacilitiesBillingStartDate')
  final String? facilitiesBillingStartDate;
  @JsonKey(name: 'FacilitiesBillingEndDate')
  final String? facilitiesBillingEndDate;
  @JsonKey(name: 'VehicleBillingStartDate')
  final String? vehicleBillingStartDate;
  @JsonKey(name: 'VehicleBillingEndDate')
  final String? vehicleBillingEndDate;
  @JsonKey(name: 'DelayBillingSearchUntil')
  final String? delayBillingSearchUntil;
  @JsonKey(name: 'IncludePrepFeesInRentalRate')
  final bool? includePrepFeesInRentalRate;
  @JsonKey(name: 'BillingStartDate')
  final String? billingStartDate;
  @JsonKey(name: 'BillingEndDate')
  final String? billingEndDate;
  @JsonKey(name: 'BillingWeeks')
  final double? billingWeeks;
  @JsonKey(name: 'BillingMonths')
  final double? billingMonths;
  @JsonKey(name: 'DetermineQuantitiesToBillBasedOn')
  final String? determineQuantitiesToBillBasedOn;
  @JsonKey(name: 'BillingCycleId')
  final String? billingCycleId;
  @JsonKey(name: 'BillingCycle')
  final String? billingCycle;
  @JsonKey(name: 'BillingCycleType')
  final String? billingCycleType;
  @JsonKey(name: 'PaymentTermsId')
  final String? paymentTermsId;
  @JsonKey(name: 'PaymentTerms')
  final String? paymentTerms;
  @JsonKey(name: 'PaymentTypeId')
  final String? paymentTypeId;
  @JsonKey(name: 'PaymentType')
  final String? paymentType;
  @JsonKey(name: 'CurrencyId')
  final String? currencyId;
  @JsonKey(name: 'UpdateAllRatesToNewCurrency')
  final bool? updateAllRatesToNewCurrency;
  @JsonKey(name: 'ConfirmUpdateAllRatesToNewCurrency')
  final String? confirmUpdateAllRatesToNewCurrency;
  @JsonKey(name: 'CurrencyCode')
  final String? currencyCode;
  @JsonKey(name: 'Currency')
  final String? currency;
  @JsonKey(name: 'CurrencySymbol')
  final String? currencySymbol;
  @JsonKey(name: 'TaxOptionId')
  final String? taxOptionId;
  @JsonKey(name: 'TaxOption')
  final String? taxOption;
  @JsonKey(name: 'Tax1Name')
  final String? tax1Name;
  @JsonKey(name: 'Tax2Name')
  final String? tax2Name;
  @JsonKey(name: 'TaxId')
  final String? taxId;
  @JsonKey(name: 'RentalTaxRate1')
  final double? rentalTaxRate1;
  @JsonKey(name: 'SalesTaxRate1')
  final double? salesTaxRate1;
  @JsonKey(name: 'LaborTaxRate1')
  final double? laborTaxRate1;
  @JsonKey(name: 'RentalTaxRate2')
  final double? rentalTaxRate2;
  @JsonKey(name: 'SalesTaxRate2')
  final double? salesTaxRate2;
  @JsonKey(name: 'LaborTaxRate2')
  final double? laborTaxRate2;
  @JsonKey(name: 'NoCharge')
  final bool? noCharge;
  @JsonKey(name: 'NoChargeReason')
  final String? noChargeReason;
  @JsonKey(name: 'PrintIssuedToAddressFrom')
  final String? printIssuedToAddressFrom;
  @JsonKey(name: 'IssuedToName')
  final String? issuedToName;
  @JsonKey(name: 'IssuedToAttention')
  final String? issuedToAttention;
  @JsonKey(name: 'IssuedToAttention2')
  final String? issuedToAttention2;
  @JsonKey(name: 'IssuedToAddress1')
  final String? issuedToAddress1;
  @JsonKey(name: 'IssuedToAddress2')
  final String? issuedToAddress2;
  @JsonKey(name: 'IssuedToCity')
  final String? issuedToCity;
  @JsonKey(name: 'IssuedToState')
  final String? issuedToState;
  @JsonKey(name: 'IssuedToZipCode')
  final String? issuedToZipCode;
  @JsonKey(name: 'IssuedToCountryId')
  final String? issuedToCountryId;
  @JsonKey(name: 'IssuedToCountry')
  final String? issuedToCountry;
  @JsonKey(name: 'BillToAddressDifferentFromIssuedToAddress')
  final bool? billToAddressDifferentFromIssuedToAddress;
  @JsonKey(name: 'BillToAddressId')
  final String? billToAddressId;
  @JsonKey(name: 'BillToName')
  final String? billToName;
  @JsonKey(name: 'BillToAttention')
  final String? billToAttention;
  @JsonKey(name: 'BillToAttention2')
  final String? billToAttention2;
  @JsonKey(name: 'BillToAddress1')
  final String? billToAddress1;
  @JsonKey(name: 'BillToAddress2')
  final String? billToAddress2;
  @JsonKey(name: 'BillToCity')
  final String? billToCity;
  @JsonKey(name: 'BillToState')
  final String? billToState;
  @JsonKey(name: 'BillToZipCode')
  final String? billToZipCode;
  @JsonKey(name: 'BillToCountryId')
  final String? billToCountryId;
  @JsonKey(name: 'BillToCountry')
  final String? billToCountry;
  @JsonKey(name: 'DiscountReasonId')
  final String? discountReasonId;
  @JsonKey(name: 'DiscountReason')
  final String? discountReason;
  @JsonKey(name: 'RequireContactConfirmation')
  final bool? requireContactConfirmation;
  @JsonKey(name: 'IncludeInBillingAnalysis')
  final bool? includeInBillingAnalysis;
  @JsonKey(name: 'HiatusDiscountFrom')
  final String? hiatusDiscountFrom;
  @JsonKey(name: 'RoundTripRentals')
  final bool? roundTripRentals;
  @JsonKey(name: 'InGroup')
  final bool? inGroup;
  @JsonKey(name: 'GroupNumber')
  final int? groupNumber;
  @JsonKey(name: 'GroupColor')
  final int? groupColor;
  @JsonKey(name: 'GroupOrderBy')
  final double? groupOrderBy;
  @JsonKey(name: 'CoverLetterId')
  final String? coverLetterId;
  @JsonKey(name: 'CoverLetter')
  final String? coverLetter;
  @JsonKey(name: 'TermsConditionsId')
  final String? termsConditionsId;
  @JsonKey(name: 'TermsConditions')
  final String? termsConditions;
  @JsonKey(name: 'OutsideSalesRepresentativeId')
  final String? outsideSalesRepresentativeId;
  @JsonKey(name: 'OutsideSalesRepresentative')
  final String? outsideSalesRepresentative;
  @JsonKey(name: 'MarketTypeId')
  final String? marketTypeId;
  @JsonKey(name: 'MarketType')
  final String? marketType;
  @JsonKey(name: 'MarketSegmentId')
  final String? marketSegmentId;
  @JsonKey(name: 'MarketSegment')
  final String? marketSegment;
  @JsonKey(name: 'MarketSegmentJobId')
  final String? marketSegmentJobId;
  @JsonKey(name: 'MarketSegmentJob')
  final String? marketSegmentJob;
  @JsonKey(name: 'OutDeliveryId')
  final String? outDeliveryId;
  @JsonKey(name: 'OutDeliveryDeliveryType')
  final String? outDeliveryDeliveryType;
  @JsonKey(name: 'OutDeliveryRequiredDate')
  final String? outDeliveryRequiredDate;
  @JsonKey(name: 'OutDeliveryRequiredTime')
  final String? outDeliveryRequiredTime;
  @JsonKey(name: 'OutDeliveryTargetShipDate')
  final String? outDeliveryTargetShipDate;
  @JsonKey(name: 'OutDeliveryTargetShipTime')
  final String? outDeliveryTargetShipTime;
  @JsonKey(name: 'OutDeliveryDirection')
  final String? outDeliveryDirection;
  @JsonKey(name: 'OutDeliveryAddressType')
  final String? outDeliveryAddressType;
  @JsonKey(name: 'OutDeliveryFromLocation')
  final String? outDeliveryFromLocation;
  @JsonKey(name: 'OutDeliveryFromContact')
  final String? outDeliveryFromContact;
  @JsonKey(name: 'OutDeliveryFromContactPhone')
  final String? outDeliveryFromContactPhone;
  @JsonKey(name: 'OutDeliveryFromAlternateContact')
  final String? outDeliveryFromAlternateContact;
  @JsonKey(name: 'OutDeliveryFromAlternateContactPhone')
  final String? outDeliveryFromAlternateContactPhone;
  @JsonKey(name: 'OutDeliveryFromAttention')
  final String? outDeliveryFromAttention;
  @JsonKey(name: 'OutDeliveryFromAddress1')
  final String? outDeliveryFromAddress1;
  @JsonKey(name: 'OutDeliveryFromAdd2ress')
  final String? outDeliveryFromAdd2ress;
  @JsonKey(name: 'OutDeliveryFromCity')
  final String? outDeliveryFromCity;
  @JsonKey(name: 'OutDeliveryFromState')
  final String? outDeliveryFromState;
  @JsonKey(name: 'OutDeliveryFromZipCode')
  final String? outDeliveryFromZipCode;
  @JsonKey(name: 'OutDeliveryFromCountry')
  final String? outDeliveryFromCountry;
  @JsonKey(name: 'OutDeliveryFromCountryId')
  final String? outDeliveryFromCountryId;
  @JsonKey(name: 'OutDeliveryFromCrossStreets')
  final String? outDeliveryFromCrossStreets;
  @JsonKey(name: 'OutDeliveryToLocation')
  final String? outDeliveryToLocation;
  @JsonKey(name: 'OutDeliveryToContact')
  final String? outDeliveryToContact;
  @JsonKey(name: 'OutDeliveryToContactPhone')
  final String? outDeliveryToContactPhone;
  @JsonKey(name: 'OutDeliveryToAlternateContact')
  final String? outDeliveryToAlternateContact;
  @JsonKey(name: 'OutDeliveryToAlternateContactPhone')
  final String? outDeliveryToAlternateContactPhone;
  @JsonKey(name: 'OutDeliveryToAttention')
  final String? outDeliveryToAttention;
  @JsonKey(name: 'OutDeliveryToAddress1')
  final String? outDeliveryToAddress1;
  @JsonKey(name: 'OutDeliveryToAddress2')
  final String? outDeliveryToAddress2;
  @JsonKey(name: 'OutDeliveryToCity')
  final String? outDeliveryToCity;
  @JsonKey(name: 'OutDeliveryToState')
  final String? outDeliveryToState;
  @JsonKey(name: 'OutDeliveryToZipCode')
  final String? outDeliveryToZipCode;
  @JsonKey(name: 'OutDeliveryToCountryId')
  final String? outDeliveryToCountryId;
  @JsonKey(name: 'OutDeliveryToCountry')
  final String? outDeliveryToCountry;
  @JsonKey(name: 'OutDeliveryToContactFax')
  final String? outDeliveryToContactFax;
  @JsonKey(name: 'OutDeliveryToCrossStreets')
  final String? outDeliveryToCrossStreets;
  @JsonKey(name: 'OutDeliveryDeliveryNotes')
  final String? outDeliveryDeliveryNotes;
  @JsonKey(name: 'OutDeliveryCarrierId')
  final String? outDeliveryCarrierId;
  @JsonKey(name: 'OutDeliveryCarrier')
  final String? outDeliveryCarrier;
  @JsonKey(name: 'OutDeliveryCarrierAccount')
  final String? outDeliveryCarrierAccount;
  @JsonKey(name: 'OutDeliveryShipViaId')
  final String? outDeliveryShipViaId;
  @JsonKey(name: 'OutDeliveryShipVia')
  final String? outDeliveryShipVia;
  @JsonKey(name: 'OutDeliveryInvoiceId')
  final String? outDeliveryInvoiceId;
  @JsonKey(name: 'OutDeliveryVendorInvoiceId')
  final String? outDeliveryVendorInvoiceId;
  @JsonKey(name: 'OutDeliveryEstimatedFreight')
  final double? outDeliveryEstimatedFreight;
  @JsonKey(name: 'OutDeliveryFreightInvoiceAmount')
  final double? outDeliveryFreightInvoiceAmount;
  @JsonKey(name: 'OutDeliveryChargeType')
  final String? outDeliveryChargeType;
  @JsonKey(name: 'OutDeliveryFreightTrackingNumber')
  final String? outDeliveryFreightTrackingNumber;
  @JsonKey(name: 'OutDeliveryFreightTrackingUrl')
  final String? outDeliveryFreightTrackingUrl;
  @JsonKey(name: 'OutDeliveryPackageCode')
  final String? outDeliveryPackageCode;
  @JsonKey(name: 'OutDeliveryBillPoFreightOnOrder')
  final bool? outDeliveryBillPoFreightOnOrder;
  @JsonKey(name: 'OutDeliveryOnlineOrderNumber')
  final String? outDeliveryOnlineOrderNumber;
  @JsonKey(name: 'OutDeliveryToVenue')
  final String? outDeliveryToVenue;
  @JsonKey(name: 'OutDeliveryToVenueId')
  final String? outDeliveryToVenueId;
  @JsonKey(name: 'OutDeliveryToWarehouse')
  final String? outDeliveryToWarehouse;
  @JsonKey(name: 'OutDeliveryToWarehouseId')
  final String? outDeliveryToWarehouseId;
  @JsonKey(name: 'OutDeliveryDateStamp')
  final String? outDeliveryDateStamp;
  @JsonKey(name: 'InDeliveryId')
  final String? inDeliveryId;
  @JsonKey(name: 'InDeliveryDeliveryType')
  final String? inDeliveryDeliveryType;
  @JsonKey(name: 'InDeliveryRequiredDate')
  final String? inDeliveryRequiredDate;
  @JsonKey(name: 'InDeliveryRequiredTime')
  final String? inDeliveryRequiredTime;
  @JsonKey(name: 'InDeliveryTargetShipDate')
  final String? inDeliveryTargetShipDate;
  @JsonKey(name: 'InDeliveryTargetShipTime')
  final String? inDeliveryTargetShipTime;
  @JsonKey(name: 'InDeliveryDirection')
  final String? inDeliveryDirection;
  @JsonKey(name: 'InDeliveryAddressType')
  final String? inDeliveryAddressType;
  @JsonKey(name: 'InDeliveryFromLocation')
  final String? inDeliveryFromLocation;
  @JsonKey(name: 'InDeliveryFromContact')
  final String? inDeliveryFromContact;
  @JsonKey(name: 'InDeliveryFromContactPhone')
  final String? inDeliveryFromContactPhone;
  @JsonKey(name: 'InDeliveryFromAlternateContact')
  final String? inDeliveryFromAlternateContact;
  @JsonKey(name: 'InDeliveryFromAlternateContactPhone')
  final String? inDeliveryFromAlternateContactPhone;
  @JsonKey(name: 'InDeliveryFromAttention')
  final String? inDeliveryFromAttention;
  @JsonKey(name: 'InDeliveryFromAddress1')
  final String? inDeliveryFromAddress1;
  @JsonKey(name: 'InDeliveryFromAdd2ress')
  final String? inDeliveryFromAdd2ress;
  @JsonKey(name: 'InDeliveryFromCity')
  final String? inDeliveryFromCity;
  @JsonKey(name: 'InDeliveryFromState')
  final String? inDeliveryFromState;
  @JsonKey(name: 'InDeliveryFromZipCode')
  final String? inDeliveryFromZipCode;
  @JsonKey(name: 'InDeliveryFromCountry')
  final String? inDeliveryFromCountry;
  @JsonKey(name: 'InDeliveryFromCountryId')
  final String? inDeliveryFromCountryId;
  @JsonKey(name: 'InDeliveryFromCrossStreets')
  final String? inDeliveryFromCrossStreets;
  @JsonKey(name: 'InDeliveryToLocation')
  final String? inDeliveryToLocation;
  @JsonKey(name: 'InDeliveryToContact')
  final String? inDeliveryToContact;
  @JsonKey(name: 'InDeliveryToContactPhone')
  final String? inDeliveryToContactPhone;
  @JsonKey(name: 'InDeliveryToAlternateContact')
  final String? inDeliveryToAlternateContact;
  @JsonKey(name: 'InDeliveryToAlternateContactPhone')
  final String? inDeliveryToAlternateContactPhone;
  @JsonKey(name: 'InDeliveryToAttention')
  final String? inDeliveryToAttention;
  @JsonKey(name: 'InDeliveryToAddress1')
  final String? inDeliveryToAddress1;
  @JsonKey(name: 'InDeliveryToAddress2')
  final String? inDeliveryToAddress2;
  @JsonKey(name: 'InDeliveryToCity')
  final String? inDeliveryToCity;
  @JsonKey(name: 'InDeliveryToState')
  final String? inDeliveryToState;
  @JsonKey(name: 'InDeliveryToZipCode')
  final String? inDeliveryToZipCode;
  @JsonKey(name: 'InDeliveryToCountryId')
  final String? inDeliveryToCountryId;
  @JsonKey(name: 'InDeliveryToCountry')
  final String? inDeliveryToCountry;
  @JsonKey(name: 'InDeliveryToContactFax')
  final String? inDeliveryToContactFax;
  @JsonKey(name: 'InDeliveryToCrossStreets')
  final String? inDeliveryToCrossStreets;
  @JsonKey(name: 'InDeliveryDeliveryNotes')
  final String? inDeliveryDeliveryNotes;
  @JsonKey(name: 'InDeliveryCarrierId')
  final String? inDeliveryCarrierId;
  @JsonKey(name: 'InDeliveryCarrier')
  final String? inDeliveryCarrier;
  @JsonKey(name: 'InDeliveryCarrierAccount')
  final String? inDeliveryCarrierAccount;
  @JsonKey(name: 'InDeliveryShipViaId')
  final String? inDeliveryShipViaId;
  @JsonKey(name: 'InDeliveryShipVia')
  final String? inDeliveryShipVia;
  @JsonKey(name: 'InDeliveryInvoiceId')
  final String? inDeliveryInvoiceId;
  @JsonKey(name: 'InDeliveryVendorInvoiceId')
  final String? inDeliveryVendorInvoiceId;
  @JsonKey(name: 'InDeliveryEstimatedFreight')
  final double? inDeliveryEstimatedFreight;
  @JsonKey(name: 'InDeliveryFreightInvoiceAmount')
  final double? inDeliveryFreightInvoiceAmount;
  @JsonKey(name: 'InDeliveryChargeType')
  final String? inDeliveryChargeType;
  @JsonKey(name: 'InDeliveryFreightTrackingNumber')
  final String? inDeliveryFreightTrackingNumber;
  @JsonKey(name: 'InDeliveryFreightTrackingUrl')
  final String? inDeliveryFreightTrackingUrl;
  @JsonKey(name: 'InDeliveryPackageCode')
  final String? inDeliveryPackageCode;
  @JsonKey(name: 'InDeliveryBillPoFreightOnOrder')
  final bool? inDeliveryBillPoFreightOnOrder;
  @JsonKey(name: 'InDeliveryOnlineOrderNumber')
  final String? inDeliveryOnlineOrderNumber;
  @JsonKey(name: 'InDeliveryOnlineOrderStatus')
  final String? inDeliveryOnlineOrderStatus;
  @JsonKey(name: 'InDeliveryToVenue')
  final String? inDeliveryToVenue;
  @JsonKey(name: 'InDeliveryToVenueId')
  final String? inDeliveryToVenueId;
  @JsonKey(name: 'InDeliveryToWarehouse')
  final String? inDeliveryToWarehouse;
  @JsonKey(name: 'InDeliveryToWarehouseId')
  final String? inDeliveryToWarehouseId;
  @JsonKey(name: 'InDeliveryDateStamp')
  final String? inDeliveryDateStamp;
  @JsonKey(name: 'RentalDaysPerWeek')
  final double? rentalDaysPerWeek;
  @JsonKey(name: 'RentalDiscountPercent')
  final double? rentalDiscountPercent;
  @JsonKey(name: 'WeeklyRentalTotal')
  final double? weeklyRentalTotal;
  @JsonKey(name: 'MonthlyRentalTotal')
  final double? monthlyRentalTotal;
  @JsonKey(name: 'PeriodRentalTotal')
  final double? periodRentalTotal;
  @JsonKey(name: 'WeeklyRentalTotalIncludesTax')
  final bool? weeklyRentalTotalIncludesTax;
  @JsonKey(name: 'MonthlyRentalTotalIncludesTax')
  final bool? monthlyRentalTotalIncludesTax;
  @JsonKey(name: 'PeriodRentalTotalIncludesTax')
  final bool? periodRentalTotalIncludesTax;
  @JsonKey(name: 'BillLockedTotal')
  final bool? billLockedTotal;
  @JsonKey(name: 'SalesDiscountPercent')
  final double? salesDiscountPercent;
  @JsonKey(name: 'SalesTotal')
  final double? salesTotal;
  @JsonKey(name: 'SalesTotalIncludesTax')
  final bool? salesTotalIncludesTax;
  @JsonKey(name: 'PartsDiscountPercent')
  final double? partsDiscountPercent;
  @JsonKey(name: 'PartsTotal')
  final double? partsTotal;
  @JsonKey(name: 'PartsTotalIncludesTax')
  final bool? partsTotalIncludesTax;
  @JsonKey(name: 'SpaceDaysPerWeek')
  final double? spaceDaysPerWeek;
  @JsonKey(name: 'SpaceDiscountPercent')
  final double? spaceDiscountPercent;
  @JsonKey(name: 'SpaceSplitPercent')
  final double? spaceSplitPercent;
  @JsonKey(name: 'WeeklySpaceTotal')
  final double? weeklySpaceTotal;
  @JsonKey(name: 'MonthlySpaceTotal')
  final double? monthlySpaceTotal;
  @JsonKey(name: 'PeriodSpaceTotal')
  final double? periodSpaceTotal;
  @JsonKey(name: 'WeeklySpaceTotalIncludesTax')
  final bool? weeklySpaceTotalIncludesTax;
  @JsonKey(name: 'MonthlySpaceTotalIncludesTax')
  final bool? monthlySpaceTotalIncludesTax;
  @JsonKey(name: 'PeriodSpaceTotalIncludesTax')
  final bool? periodSpaceTotalIncludesTax;
  @JsonKey(name: 'VehicleDaysPerWeek')
  final double? vehicleDaysPerWeek;
  @JsonKey(name: 'VehicleDiscountPercent')
  final double? vehicleDiscountPercent;
  @JsonKey(name: 'WeeklyVehicleTotal')
  final double? weeklyVehicleTotal;
  @JsonKey(name: 'MonthlyVehicleTotal')
  final double? monthlyVehicleTotal;
  @JsonKey(name: 'PeriodVehicleTotal')
  final double? periodVehicleTotal;
  @JsonKey(name: 'WeeklyVehicleTotalIncludesTax')
  final bool? weeklyVehicleTotalIncludesTax;
  @JsonKey(name: 'MonthlyVehicleTotalIncludesTax')
  final bool? monthlyVehicleTotalIncludesTax;
  @JsonKey(name: 'PeriodVehicleTotalIncludesTax')
  final bool? periodVehicleTotalIncludesTax;
  @JsonKey(name: 'MiscDiscountPercent')
  final double? miscDiscountPercent;
  @JsonKey(name: 'WeeklyMiscTotal')
  final double? weeklyMiscTotal;
  @JsonKey(name: 'MonthlyMiscTotal')
  final double? monthlyMiscTotal;
  @JsonKey(name: 'PeriodMiscTotal')
  final double? periodMiscTotal;
  @JsonKey(name: 'WeeklyMiscTotalIncludesTax')
  final bool? weeklyMiscTotalIncludesTax;
  @JsonKey(name: 'MonthlyMiscTotalIncludesTax')
  final bool? monthlyMiscTotalIncludesTax;
  @JsonKey(name: 'PeriodMiscTotalIncludesTax')
  final bool? periodMiscTotalIncludesTax;
  @JsonKey(name: 'LaborDiscountPercent')
  final double? laborDiscountPercent;
  @JsonKey(name: 'WeeklyLaborTotal')
  final double? weeklyLaborTotal;
  @JsonKey(name: 'MonthlyLaborTotal')
  final double? monthlyLaborTotal;
  @JsonKey(name: 'PeriodLaborTotal')
  final double? periodLaborTotal;
  @JsonKey(name: 'WeeklyLaborTotalIncludesTax')
  final bool? weeklyLaborTotalIncludesTax;
  @JsonKey(name: 'MonthlyLaborTotalIncludesTax')
  final bool? monthlyLaborTotalIncludesTax;
  @JsonKey(name: 'PeriodLaborTotalIncludesTax')
  final bool? periodLaborTotalIncludesTax;
  @JsonKey(name: 'RentalSaleDiscountPercent')
  final double? rentalSaleDiscountPercent;
  @JsonKey(name: 'RentalSaleTotal')
  final double? rentalSaleTotal;
  @JsonKey(name: 'RentalSaleTotalIncludesTax')
  final bool? rentalSaleTotalIncludesTax;
  @JsonKey(name: 'LossAndDamageDiscountPercent')
  final double? lossAndDamageDiscountPercent;
  @JsonKey(name: 'LossAndDamageTotal')
  final double? lossAndDamageTotal;
  @JsonKey(name: 'LossAndDamageTotalIncludesTax')
  final bool? lossAndDamageTotalIncludesTax;
  @JsonKey(name: 'CombinedDaysPerWeek')
  final double? combinedDaysPerWeek;
  @JsonKey(name: 'CombinedDiscountPercent')
  final double? combinedDiscountPercent;
  @JsonKey(name: 'WeeklyCombinedTotal')
  final double? weeklyCombinedTotal;
  @JsonKey(name: 'MonthlyCombinedTotal')
  final double? monthlyCombinedTotal;
  @JsonKey(name: 'PeriodCombinedTotal')
  final double? periodCombinedTotal;
  @JsonKey(name: 'WeeklyCombinedTotalIncludesTax')
  final bool? weeklyCombinedTotalIncludesTax;
  @JsonKey(name: 'MonthlyCombinedTotalIncludesTax')
  final bool? monthlyCombinedTotalIncludesTax;
  @JsonKey(name: 'PeriodCombinedTotalIncludesTax')
  final bool? periodCombinedTotalIncludesTax;
  @JsonKey(name: 'DisableEditingRentalRate')
  final bool? disableEditingRentalRate;
  @JsonKey(name: 'DisableEditingSalesRate')
  final bool? disableEditingSalesRate;
  @JsonKey(name: 'DisableEditingMiscellaneousRate')
  final bool? disableEditingMiscellaneousRate;
  @JsonKey(name: 'DisableEditingLaborRate')
  final bool? disableEditingLaborRate;
  @JsonKey(name: 'DisableEditingRentalSaleRate')
  final bool? disableEditingRentalSaleRate;
  @JsonKey(name: 'DisableEditingLossAndDamageRate')
  final bool? disableEditingLossAndDamageRate;
  @JsonKey(name: 'RentalExtendedTotal')
  final double? rentalExtendedTotal;
  @JsonKey(name: 'SalesExtendedTotal')
  final double? salesExtendedTotal;
  @JsonKey(name: 'LaborExtendedTotal')
  final double? laborExtendedTotal;
  @JsonKey(name: 'MiscellaneousExtendedTotal')
  final double? miscellaneousExtendedTotal;
  @JsonKey(name: 'RentalSaleExtendedTotal')
  final double? rentalSaleExtendedTotal;
  @JsonKey(name: 'LossAndDamageExtendedTotal')
  final double? lossAndDamageExtendedTotal;
  @JsonKey(name: 'HasNotes')
  final bool? hasNotes;
  @JsonKey(name: 'HasDocuments')
  final bool? hasDocuments;
  @JsonKey(name: 'HasEmailHistory')
  final bool? hasEmailHistory;
  @JsonKey(name: 'HasContacts')
  final bool? hasContacts;
  @JsonKey(name: 'HasSubPurchaseOrders')
  final bool? hasSubPurchaseOrders;
  @JsonKey(name: 'HasPickLists')
  final bool? hasPickLists;
  @JsonKey(name: 'HasContracts')
  final bool? hasContracts;
  @JsonKey(name: 'HasSuspendedContracts')
  final bool? hasSuspendedContracts;
  @JsonKey(name: 'HasMultiOrderContracts')
  final bool? hasMultiOrderContracts;
  @JsonKey(name: 'HasInvoices')
  final bool? hasInvoices;
  @JsonKey(name: 'HasBillingWorksheets')
  final bool? hasBillingWorksheets;
  @JsonKey(name: 'HasMultiOrderInvoices')
  final bool? hasMultiOrderInvoices;
  @JsonKey(name: 'TotalReplacementCost')
  final double? totalReplacementCost;
  @JsonKey(name: 'PresentationLayerId')
  final String? presentationLayerId;
  @JsonKey(name: 'PresentationLayer')
  final String? presentationLayer;
  @JsonKey(name: 'IsManualSort')
  final bool? isManualSort;
  @JsonKey(name: 'QuoteOrderTitle')
  final String? quoteOrderTitle;
  @JsonKey(name: 'UnassignedSubs')
  final bool? unassignedSubs;
  @JsonKey(name: 'NonTaxable')
  final bool? nonTaxable;
  @JsonKey(name: 'EnableProjects')
  final bool? enableProjects;
  @JsonKey(name: 'ProjectId')
  final String? projectId;
  @JsonKey(name: 'ProjectNumber')
  final String? projectNumber;
  @JsonKey(name: 'Project')
  final String? project;
  @JsonKey(name: 'ProjectDrawingsId')
  final String? projectDrawingsId;
  @JsonKey(name: 'ProjectDrawings')
  final String? projectDrawings;
  @JsonKey(name: 'ProjectItemsOrderedId')
  final String? projectItemsOrderedId;
  @JsonKey(name: 'ProjectItemsOrdered')
  final String? projectItemsOrdered;
  @JsonKey(name: 'ProjectDropShipId')
  final String? projectDropShipId;
  @JsonKey(name: 'ProjectDropShip')
  final String? projectDropShip;
  @JsonKey(name: 'ProjectAsBuildId')
  final String? projectAsBuildId;
  @JsonKey(name: 'ProjectAsBuild')
  final String? projectAsBuild;
  @JsonKey(name: 'ProjectCommissioningId')
  final String? projectCommissioningId;
  @JsonKey(name: 'ProjectCommissioning')
  final String? projectCommissioning;
  @JsonKey(name: 'ProjectDepositId')
  final String? projectDepositId;
  @JsonKey(name: 'ProjectDeposit')
  final String? projectDeposit;
  @JsonKey(name: 'InputByUserId')
  final String? inputByUserId;
  @JsonKey(name: 'ModifiedByUserId')
  final String? modifiedByUserId;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsOrderItemOrderItem>[])
  final List<WebApiModulesHomeControlsOrderItemOrderItem>? items;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesAgentOrderGetOrderResponseFromJson;
  static const toJsonFactory = _$WebApiModulesAgentOrderGetOrderResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderGetOrderResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderGetOrderResponse &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderNumber, orderNumber) ||
                const DeepCollectionEquality()
                    .equals(other.orderNumber, orderNumber)) &&
            (identical(other.orderDate, orderDate) ||
                const DeepCollectionEquality()
                    .equals(other.orderDate, orderDate)) &&
            (identical(other.sourceQuoteId, sourceQuoteId) ||
                const DeepCollectionEquality()
                    .equals(other.sourceQuoteId, sourceQuoteId)) &&
            (identical(other.sourceQuoteNumber, sourceQuoteNumber) ||
                const DeepCollectionEquality()
                    .equals(other.sourceQuoteNumber, sourceQuoteNumber)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.officeLocationId, officeLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocationId, officeLocationId)) &&
            (identical(other.officeLocation, officeLocation) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocation, officeLocation)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouse, warehouse) ||
                const DeepCollectionEquality()
                    .equals(other.warehouse, warehouse)) &&
            (identical(other.warehouseCode, warehouseCode) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.departmentId, departmentId) ||
                const DeepCollectionEquality()
                    .equals(other.departmentId, departmentId)) &&
            (identical(other.department, department) ||
                const DeepCollectionEquality()
                    .equals(other.department, department)) &&
            (identical(other.customerId, customerId) ||
                const DeepCollectionEquality()
                    .equals(other.customerId, customerId)) &&
            (identical(other.customer, customer) ||
                const DeepCollectionEquality()
                    .equals(other.customer, customer)) &&
            (identical(other.customerNumber, customerNumber) ||
                const DeepCollectionEquality()
                    .equals(other.customerNumber, customerNumber)) &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.deal, deal) ||
                const DeepCollectionEquality().equals(other.deal, deal)) &&
            (identical(other.dealNumber, dealNumber) ||
                const DeepCollectionEquality()
                    .equals(other.dealNumber, dealNumber)) &&
            (identical(other.rateType, rateType) ||
                const DeepCollectionEquality()
                    .equals(other.rateType, rateType)) &&
            (identical(other.rateTypeDisplay, rateTypeDisplay) ||
                const DeepCollectionEquality()
                    .equals(other.rateTypeDisplay, rateTypeDisplay)) &&
            (identical(other.agentId, agentId) ||
                const DeepCollectionEquality()
                    .equals(other.agentId, agentId)) &&
            (identical(other.agent, agent) ||
                const DeepCollectionEquality().equals(other.agent, agent)) &&
            (identical(other.projectManagerId, projectManagerId) || const DeepCollectionEquality().equals(other.projectManagerId, projectManagerId)) &&
            (identical(other.projectManager, projectManager) || const DeepCollectionEquality().equals(other.projectManager, projectManager)) &&
            (identical(other.rental, rental) || const DeepCollectionEquality().equals(other.rental, rental)) &&
            (identical(other.sales, sales) || const DeepCollectionEquality().equals(other.sales, sales)) &&
            (identical(other.miscellaneous, miscellaneous) || const DeepCollectionEquality().equals(other.miscellaneous, miscellaneous)) &&
            (identical(other.labor, labor) || const DeepCollectionEquality().equals(other.labor, labor)) &&
            (identical(other.facilities, facilities) || const DeepCollectionEquality().equals(other.facilities, facilities)) &&
            (identical(other.transportation, transportation) || const DeepCollectionEquality().equals(other.transportation, transportation)) &&
            (identical(other.rentalSale, rentalSale) || const DeepCollectionEquality().equals(other.rentalSale, rentalSale)) &&
            (identical(other.lossAndDamage, lossAndDamage) || const DeepCollectionEquality().equals(other.lossAndDamage, lossAndDamage)) &&
            (identical(other.repair, repair) || const DeepCollectionEquality().equals(other.repair, repair)) &&
            (identical(other.hasRentalItem, hasRentalItem) || const DeepCollectionEquality().equals(other.hasRentalItem, hasRentalItem)) &&
            (identical(other.hasSalesItem, hasSalesItem) || const DeepCollectionEquality().equals(other.hasSalesItem, hasSalesItem)) &&
            (identical(other.hasMiscellaneousItem, hasMiscellaneousItem) || const DeepCollectionEquality().equals(other.hasMiscellaneousItem, hasMiscellaneousItem)) &&
            (identical(other.hasLaborItem, hasLaborItem) || const DeepCollectionEquality().equals(other.hasLaborItem, hasLaborItem)) &&
            (identical(other.hasFacilitiesItem, hasFacilitiesItem) || const DeepCollectionEquality().equals(other.hasFacilitiesItem, hasFacilitiesItem)) &&
            (identical(other.hasLossAndDamageItem, hasLossAndDamageItem) || const DeepCollectionEquality().equals(other.hasLossAndDamageItem, hasLossAndDamageItem)) &&
            (identical(other.hasRentalSaleItem, hasRentalSaleItem) || const DeepCollectionEquality().equals(other.hasRentalSaleItem, hasRentalSaleItem)) &&
            (identical(other.hasRepair, hasRepair) || const DeepCollectionEquality().equals(other.hasRepair, hasRepair)) &&
            (identical(other.activityDatesAndTimes, activityDatesAndTimes) || const DeepCollectionEquality().equals(other.activityDatesAndTimes, activityDatesAndTimes)) &&
            (identical(other.pickDate, pickDate) || const DeepCollectionEquality().equals(other.pickDate, pickDate)) &&
            (identical(other.pickTime, pickTime) || const DeepCollectionEquality().equals(other.pickTime, pickTime)) &&
            (identical(other.estimatedStartDate, estimatedStartDate) || const DeepCollectionEquality().equals(other.estimatedStartDate, estimatedStartDate)) &&
            (identical(other.estimatedStartTime, estimatedStartTime) || const DeepCollectionEquality().equals(other.estimatedStartTime, estimatedStartTime)) &&
            (identical(other.estimatedStopDate, estimatedStopDate) || const DeepCollectionEquality().equals(other.estimatedStopDate, estimatedStopDate)) &&
            (identical(other.estimatedStopTime, estimatedStopTime) || const DeepCollectionEquality().equals(other.estimatedStopTime, estimatedStopTime)) &&
            (identical(other.pickUpDate, pickUpDate) || const DeepCollectionEquality().equals(other.pickUpDate, pickUpDate)) &&
            (identical(other.pickUpTime, pickUpTime) || const DeepCollectionEquality().equals(other.pickUpTime, pickUpTime)) &&
            (identical(other.prepDate, prepDate) || const DeepCollectionEquality().equals(other.prepDate, prepDate)) &&
            (identical(other.prepTime, prepTime) || const DeepCollectionEquality().equals(other.prepTime, prepTime)) &&
            (identical(other.loadInDate, loadInDate) || const DeepCollectionEquality().equals(other.loadInDate, loadInDate)) &&
            (identical(other.loadInTime, loadInTime) || const DeepCollectionEquality().equals(other.loadInTime, loadInTime)) &&
            (identical(other.strikeDate, strikeDate) || const DeepCollectionEquality().equals(other.strikeDate, strikeDate)) &&
            (identical(other.strikeTime, strikeTime) || const DeepCollectionEquality().equals(other.strikeTime, strikeTime)) &&
            (identical(other.testDate, testDate) || const DeepCollectionEquality().equals(other.testDate, testDate)) &&
            (identical(other.testTime, testTime) || const DeepCollectionEquality().equals(other.testTime, testTime)) &&
            (identical(other.orderTypeId, orderTypeId) || const DeepCollectionEquality().equals(other.orderTypeId, orderTypeId)) &&
            (identical(other.orderType, orderType) || const DeepCollectionEquality().equals(other.orderType, orderType)) &&
            (identical(other.orderTypeCombineActivityTabs, orderTypeCombineActivityTabs) || const DeepCollectionEquality().equals(other.orderTypeCombineActivityTabs, orderTypeCombineActivityTabs)) &&
            (identical(other.flatPo, flatPo) || const DeepCollectionEquality().equals(other.flatPo, flatPo)) &&
            (identical(other.pendingPo, pendingPo) || const DeepCollectionEquality().equals(other.pendingPo, pendingPo)) &&
            (identical(other.poNumber, poNumber) || const DeepCollectionEquality().equals(other.poNumber, poNumber)) &&
            (identical(other.poAmount, poAmount) || const DeepCollectionEquality().equals(other.poAmount, poAmount)) &&
            (identical(other.location, location) || const DeepCollectionEquality().equals(other.location, location)) &&
            (identical(other.orderLocationId, orderLocationId) || const DeepCollectionEquality().equals(other.orderLocationId, orderLocationId)) &&
            (identical(other.orderLocation, orderLocation) || const DeepCollectionEquality().equals(other.orderLocation, orderLocation)) &&
            (identical(other.referenceNumber, referenceNumber) || const DeepCollectionEquality().equals(other.referenceNumber, referenceNumber)) &&
            (identical(other.total, total) || const DeepCollectionEquality().equals(other.total, total)) &&
            (identical(other.status, status) || const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.statusDate, statusDate) || const DeepCollectionEquality().equals(other.statusDate, statusDate)) &&
            (identical(other.poApprovalStatusId, poApprovalStatusId) || const DeepCollectionEquality().equals(other.poApprovalStatusId, poApprovalStatusId)) &&
            (identical(other.lockBillingDates, lockBillingDates) || const DeepCollectionEquality().equals(other.lockBillingDates, lockBillingDates)) &&
            (identical(other.specifyBillingDatesByType, specifyBillingDatesByType) || const DeepCollectionEquality().equals(other.specifyBillingDatesByType, specifyBillingDatesByType)) &&
            (identical(other.rentalBillingStartDate, rentalBillingStartDate) || const DeepCollectionEquality().equals(other.rentalBillingStartDate, rentalBillingStartDate)) &&
            (identical(other.rentalBillingEndDate, rentalBillingEndDate) || const DeepCollectionEquality().equals(other.rentalBillingEndDate, rentalBillingEndDate)) &&
            (identical(other.laborBillingStartDate, laborBillingStartDate) || const DeepCollectionEquality().equals(other.laborBillingStartDate, laborBillingStartDate)) &&
            (identical(other.laborBillingEndDate, laborBillingEndDate) || const DeepCollectionEquality().equals(other.laborBillingEndDate, laborBillingEndDate)) &&
            (identical(other.miscellaneousBillingStartDate, miscellaneousBillingStartDate) || const DeepCollectionEquality().equals(other.miscellaneousBillingStartDate, miscellaneousBillingStartDate)) &&
            (identical(other.miscellaneousBillingEndDate, miscellaneousBillingEndDate) || const DeepCollectionEquality().equals(other.miscellaneousBillingEndDate, miscellaneousBillingEndDate)) &&
            (identical(other.facilitiesBillingStartDate, facilitiesBillingStartDate) || const DeepCollectionEquality().equals(other.facilitiesBillingStartDate, facilitiesBillingStartDate)) &&
            (identical(other.facilitiesBillingEndDate, facilitiesBillingEndDate) || const DeepCollectionEquality().equals(other.facilitiesBillingEndDate, facilitiesBillingEndDate)) &&
            (identical(other.vehicleBillingStartDate, vehicleBillingStartDate) || const DeepCollectionEquality().equals(other.vehicleBillingStartDate, vehicleBillingStartDate)) &&
            (identical(other.vehicleBillingEndDate, vehicleBillingEndDate) || const DeepCollectionEquality().equals(other.vehicleBillingEndDate, vehicleBillingEndDate)) &&
            (identical(other.delayBillingSearchUntil, delayBillingSearchUntil) || const DeepCollectionEquality().equals(other.delayBillingSearchUntil, delayBillingSearchUntil)) &&
            (identical(other.includePrepFeesInRentalRate, includePrepFeesInRentalRate) || const DeepCollectionEquality().equals(other.includePrepFeesInRentalRate, includePrepFeesInRentalRate)) &&
            (identical(other.billingStartDate, billingStartDate) || const DeepCollectionEquality().equals(other.billingStartDate, billingStartDate)) &&
            (identical(other.billingEndDate, billingEndDate) || const DeepCollectionEquality().equals(other.billingEndDate, billingEndDate)) &&
            (identical(other.billingWeeks, billingWeeks) || const DeepCollectionEquality().equals(other.billingWeeks, billingWeeks)) &&
            (identical(other.billingMonths, billingMonths) || const DeepCollectionEquality().equals(other.billingMonths, billingMonths)) &&
            (identical(other.determineQuantitiesToBillBasedOn, determineQuantitiesToBillBasedOn) || const DeepCollectionEquality().equals(other.determineQuantitiesToBillBasedOn, determineQuantitiesToBillBasedOn)) &&
            (identical(other.billingCycleId, billingCycleId) || const DeepCollectionEquality().equals(other.billingCycleId, billingCycleId)) &&
            (identical(other.billingCycle, billingCycle) || const DeepCollectionEquality().equals(other.billingCycle, billingCycle)) &&
            (identical(other.billingCycleType, billingCycleType) || const DeepCollectionEquality().equals(other.billingCycleType, billingCycleType)) &&
            (identical(other.paymentTermsId, paymentTermsId) || const DeepCollectionEquality().equals(other.paymentTermsId, paymentTermsId)) &&
            (identical(other.paymentTerms, paymentTerms) || const DeepCollectionEquality().equals(other.paymentTerms, paymentTerms)) &&
            (identical(other.paymentTypeId, paymentTypeId) || const DeepCollectionEquality().equals(other.paymentTypeId, paymentTypeId)) &&
            (identical(other.paymentType, paymentType) || const DeepCollectionEquality().equals(other.paymentType, paymentType)) &&
            (identical(other.currencyId, currencyId) || const DeepCollectionEquality().equals(other.currencyId, currencyId)) &&
            (identical(other.updateAllRatesToNewCurrency, updateAllRatesToNewCurrency) || const DeepCollectionEquality().equals(other.updateAllRatesToNewCurrency, updateAllRatesToNewCurrency)) &&
            (identical(other.confirmUpdateAllRatesToNewCurrency, confirmUpdateAllRatesToNewCurrency) || const DeepCollectionEquality().equals(other.confirmUpdateAllRatesToNewCurrency, confirmUpdateAllRatesToNewCurrency)) &&
            (identical(other.currencyCode, currencyCode) || const DeepCollectionEquality().equals(other.currencyCode, currencyCode)) &&
            (identical(other.currency, currency) || const DeepCollectionEquality().equals(other.currency, currency)) &&
            (identical(other.currencySymbol, currencySymbol) || const DeepCollectionEquality().equals(other.currencySymbol, currencySymbol)) &&
            (identical(other.taxOptionId, taxOptionId) || const DeepCollectionEquality().equals(other.taxOptionId, taxOptionId)) &&
            (identical(other.taxOption, taxOption) || const DeepCollectionEquality().equals(other.taxOption, taxOption)) &&
            (identical(other.tax1Name, tax1Name) || const DeepCollectionEquality().equals(other.tax1Name, tax1Name)) &&
            (identical(other.tax2Name, tax2Name) || const DeepCollectionEquality().equals(other.tax2Name, tax2Name)) &&
            (identical(other.taxId, taxId) || const DeepCollectionEquality().equals(other.taxId, taxId)) &&
            (identical(other.rentalTaxRate1, rentalTaxRate1) || const DeepCollectionEquality().equals(other.rentalTaxRate1, rentalTaxRate1)) &&
            (identical(other.salesTaxRate1, salesTaxRate1) || const DeepCollectionEquality().equals(other.salesTaxRate1, salesTaxRate1)) &&
            (identical(other.laborTaxRate1, laborTaxRate1) || const DeepCollectionEquality().equals(other.laborTaxRate1, laborTaxRate1)) &&
            (identical(other.rentalTaxRate2, rentalTaxRate2) || const DeepCollectionEquality().equals(other.rentalTaxRate2, rentalTaxRate2)) &&
            (identical(other.salesTaxRate2, salesTaxRate2) || const DeepCollectionEquality().equals(other.salesTaxRate2, salesTaxRate2)) &&
            (identical(other.laborTaxRate2, laborTaxRate2) || const DeepCollectionEquality().equals(other.laborTaxRate2, laborTaxRate2)) &&
            (identical(other.noCharge, noCharge) || const DeepCollectionEquality().equals(other.noCharge, noCharge)) &&
            (identical(other.noChargeReason, noChargeReason) || const DeepCollectionEquality().equals(other.noChargeReason, noChargeReason)) &&
            (identical(other.printIssuedToAddressFrom, printIssuedToAddressFrom) || const DeepCollectionEquality().equals(other.printIssuedToAddressFrom, printIssuedToAddressFrom)) &&
            (identical(other.issuedToName, issuedToName) || const DeepCollectionEquality().equals(other.issuedToName, issuedToName)) &&
            (identical(other.issuedToAttention, issuedToAttention) || const DeepCollectionEquality().equals(other.issuedToAttention, issuedToAttention)) &&
            (identical(other.issuedToAttention2, issuedToAttention2) || const DeepCollectionEquality().equals(other.issuedToAttention2, issuedToAttention2)) &&
            (identical(other.issuedToAddress1, issuedToAddress1) || const DeepCollectionEquality().equals(other.issuedToAddress1, issuedToAddress1)) &&
            (identical(other.issuedToAddress2, issuedToAddress2) || const DeepCollectionEquality().equals(other.issuedToAddress2, issuedToAddress2)) &&
            (identical(other.issuedToCity, issuedToCity) || const DeepCollectionEquality().equals(other.issuedToCity, issuedToCity)) &&
            (identical(other.issuedToState, issuedToState) || const DeepCollectionEquality().equals(other.issuedToState, issuedToState)) &&
            (identical(other.issuedToZipCode, issuedToZipCode) || const DeepCollectionEquality().equals(other.issuedToZipCode, issuedToZipCode)) &&
            (identical(other.issuedToCountryId, issuedToCountryId) || const DeepCollectionEquality().equals(other.issuedToCountryId, issuedToCountryId)) &&
            (identical(other.issuedToCountry, issuedToCountry) || const DeepCollectionEquality().equals(other.issuedToCountry, issuedToCountry)) &&
            (identical(other.billToAddressDifferentFromIssuedToAddress, billToAddressDifferentFromIssuedToAddress) || const DeepCollectionEquality().equals(other.billToAddressDifferentFromIssuedToAddress, billToAddressDifferentFromIssuedToAddress)) &&
            (identical(other.billToAddressId, billToAddressId) || const DeepCollectionEquality().equals(other.billToAddressId, billToAddressId)) &&
            (identical(other.billToName, billToName) || const DeepCollectionEquality().equals(other.billToName, billToName)) &&
            (identical(other.billToAttention, billToAttention) || const DeepCollectionEquality().equals(other.billToAttention, billToAttention)) &&
            (identical(other.billToAttention2, billToAttention2) || const DeepCollectionEquality().equals(other.billToAttention2, billToAttention2)) &&
            (identical(other.billToAddress1, billToAddress1) || const DeepCollectionEquality().equals(other.billToAddress1, billToAddress1)) &&
            (identical(other.billToAddress2, billToAddress2) || const DeepCollectionEquality().equals(other.billToAddress2, billToAddress2)) &&
            (identical(other.billToCity, billToCity) || const DeepCollectionEquality().equals(other.billToCity, billToCity)) &&
            (identical(other.billToState, billToState) || const DeepCollectionEquality().equals(other.billToState, billToState)) &&
            (identical(other.billToZipCode, billToZipCode) || const DeepCollectionEquality().equals(other.billToZipCode, billToZipCode)) &&
            (identical(other.billToCountryId, billToCountryId) || const DeepCollectionEquality().equals(other.billToCountryId, billToCountryId)) &&
            (identical(other.billToCountry, billToCountry) || const DeepCollectionEquality().equals(other.billToCountry, billToCountry)) &&
            (identical(other.discountReasonId, discountReasonId) || const DeepCollectionEquality().equals(other.discountReasonId, discountReasonId)) &&
            (identical(other.discountReason, discountReason) || const DeepCollectionEquality().equals(other.discountReason, discountReason)) &&
            (identical(other.requireContactConfirmation, requireContactConfirmation) || const DeepCollectionEquality().equals(other.requireContactConfirmation, requireContactConfirmation)) &&
            (identical(other.includeInBillingAnalysis, includeInBillingAnalysis) || const DeepCollectionEquality().equals(other.includeInBillingAnalysis, includeInBillingAnalysis)) &&
            (identical(other.hiatusDiscountFrom, hiatusDiscountFrom) || const DeepCollectionEquality().equals(other.hiatusDiscountFrom, hiatusDiscountFrom)) &&
            (identical(other.roundTripRentals, roundTripRentals) || const DeepCollectionEquality().equals(other.roundTripRentals, roundTripRentals)) &&
            (identical(other.inGroup, inGroup) || const DeepCollectionEquality().equals(other.inGroup, inGroup)) &&
            (identical(other.groupNumber, groupNumber) || const DeepCollectionEquality().equals(other.groupNumber, groupNumber)) &&
            (identical(other.groupColor, groupColor) || const DeepCollectionEquality().equals(other.groupColor, groupColor)) &&
            (identical(other.groupOrderBy, groupOrderBy) || const DeepCollectionEquality().equals(other.groupOrderBy, groupOrderBy)) &&
            (identical(other.coverLetterId, coverLetterId) || const DeepCollectionEquality().equals(other.coverLetterId, coverLetterId)) &&
            (identical(other.coverLetter, coverLetter) || const DeepCollectionEquality().equals(other.coverLetter, coverLetter)) &&
            (identical(other.termsConditionsId, termsConditionsId) || const DeepCollectionEquality().equals(other.termsConditionsId, termsConditionsId)) &&
            (identical(other.termsConditions, termsConditions) || const DeepCollectionEquality().equals(other.termsConditions, termsConditions)) &&
            (identical(other.outsideSalesRepresentativeId, outsideSalesRepresentativeId) || const DeepCollectionEquality().equals(other.outsideSalesRepresentativeId, outsideSalesRepresentativeId)) &&
            (identical(other.outsideSalesRepresentative, outsideSalesRepresentative) || const DeepCollectionEquality().equals(other.outsideSalesRepresentative, outsideSalesRepresentative)) &&
            (identical(other.marketTypeId, marketTypeId) || const DeepCollectionEquality().equals(other.marketTypeId, marketTypeId)) &&
            (identical(other.marketType, marketType) || const DeepCollectionEquality().equals(other.marketType, marketType)) &&
            (identical(other.marketSegmentId, marketSegmentId) || const DeepCollectionEquality().equals(other.marketSegmentId, marketSegmentId)) &&
            (identical(other.marketSegment, marketSegment) || const DeepCollectionEquality().equals(other.marketSegment, marketSegment)) &&
            (identical(other.marketSegmentJobId, marketSegmentJobId) || const DeepCollectionEquality().equals(other.marketSegmentJobId, marketSegmentJobId)) &&
            (identical(other.marketSegmentJob, marketSegmentJob) || const DeepCollectionEquality().equals(other.marketSegmentJob, marketSegmentJob)) &&
            (identical(other.outDeliveryId, outDeliveryId) || const DeepCollectionEquality().equals(other.outDeliveryId, outDeliveryId)) &&
            (identical(other.outDeliveryDeliveryType, outDeliveryDeliveryType) || const DeepCollectionEquality().equals(other.outDeliveryDeliveryType, outDeliveryDeliveryType)) &&
            (identical(other.outDeliveryRequiredDate, outDeliveryRequiredDate) || const DeepCollectionEquality().equals(other.outDeliveryRequiredDate, outDeliveryRequiredDate)) &&
            (identical(other.outDeliveryRequiredTime, outDeliveryRequiredTime) || const DeepCollectionEquality().equals(other.outDeliveryRequiredTime, outDeliveryRequiredTime)) &&
            (identical(other.outDeliveryTargetShipDate, outDeliveryTargetShipDate) || const DeepCollectionEquality().equals(other.outDeliveryTargetShipDate, outDeliveryTargetShipDate)) &&
            (identical(other.outDeliveryTargetShipTime, outDeliveryTargetShipTime) || const DeepCollectionEquality().equals(other.outDeliveryTargetShipTime, outDeliveryTargetShipTime)) &&
            (identical(other.outDeliveryDirection, outDeliveryDirection) || const DeepCollectionEquality().equals(other.outDeliveryDirection, outDeliveryDirection)) &&
            (identical(other.outDeliveryAddressType, outDeliveryAddressType) || const DeepCollectionEquality().equals(other.outDeliveryAddressType, outDeliveryAddressType)) &&
            (identical(other.outDeliveryFromLocation, outDeliveryFromLocation) || const DeepCollectionEquality().equals(other.outDeliveryFromLocation, outDeliveryFromLocation)) &&
            (identical(other.outDeliveryFromContact, outDeliveryFromContact) || const DeepCollectionEquality().equals(other.outDeliveryFromContact, outDeliveryFromContact)) &&
            (identical(other.outDeliveryFromContactPhone, outDeliveryFromContactPhone) || const DeepCollectionEquality().equals(other.outDeliveryFromContactPhone, outDeliveryFromContactPhone)) &&
            (identical(other.outDeliveryFromAlternateContact, outDeliveryFromAlternateContact) || const DeepCollectionEquality().equals(other.outDeliveryFromAlternateContact, outDeliveryFromAlternateContact)) &&
            (identical(other.outDeliveryFromAlternateContactPhone, outDeliveryFromAlternateContactPhone) || const DeepCollectionEquality().equals(other.outDeliveryFromAlternateContactPhone, outDeliveryFromAlternateContactPhone)) &&
            (identical(other.outDeliveryFromAttention, outDeliveryFromAttention) || const DeepCollectionEquality().equals(other.outDeliveryFromAttention, outDeliveryFromAttention)) &&
            (identical(other.outDeliveryFromAddress1, outDeliveryFromAddress1) || const DeepCollectionEquality().equals(other.outDeliveryFromAddress1, outDeliveryFromAddress1)) &&
            (identical(other.outDeliveryFromAdd2ress, outDeliveryFromAdd2ress) || const DeepCollectionEquality().equals(other.outDeliveryFromAdd2ress, outDeliveryFromAdd2ress)) &&
            (identical(other.outDeliveryFromCity, outDeliveryFromCity) || const DeepCollectionEquality().equals(other.outDeliveryFromCity, outDeliveryFromCity)) &&
            (identical(other.outDeliveryFromState, outDeliveryFromState) || const DeepCollectionEquality().equals(other.outDeliveryFromState, outDeliveryFromState)) &&
            (identical(other.outDeliveryFromZipCode, outDeliveryFromZipCode) || const DeepCollectionEquality().equals(other.outDeliveryFromZipCode, outDeliveryFromZipCode)) &&
            (identical(other.outDeliveryFromCountry, outDeliveryFromCountry) || const DeepCollectionEquality().equals(other.outDeliveryFromCountry, outDeliveryFromCountry)) &&
            (identical(other.outDeliveryFromCountryId, outDeliveryFromCountryId) || const DeepCollectionEquality().equals(other.outDeliveryFromCountryId, outDeliveryFromCountryId)) &&
            (identical(other.outDeliveryFromCrossStreets, outDeliveryFromCrossStreets) || const DeepCollectionEquality().equals(other.outDeliveryFromCrossStreets, outDeliveryFromCrossStreets)) &&
            (identical(other.outDeliveryToLocation, outDeliveryToLocation) || const DeepCollectionEquality().equals(other.outDeliveryToLocation, outDeliveryToLocation)) &&
            (identical(other.outDeliveryToContact, outDeliveryToContact) || const DeepCollectionEquality().equals(other.outDeliveryToContact, outDeliveryToContact)) &&
            (identical(other.outDeliveryToContactPhone, outDeliveryToContactPhone) || const DeepCollectionEquality().equals(other.outDeliveryToContactPhone, outDeliveryToContactPhone)) &&
            (identical(other.outDeliveryToAlternateContact, outDeliveryToAlternateContact) || const DeepCollectionEquality().equals(other.outDeliveryToAlternateContact, outDeliveryToAlternateContact)) &&
            (identical(other.outDeliveryToAlternateContactPhone, outDeliveryToAlternateContactPhone) || const DeepCollectionEquality().equals(other.outDeliveryToAlternateContactPhone, outDeliveryToAlternateContactPhone)) &&
            (identical(other.outDeliveryToAttention, outDeliveryToAttention) || const DeepCollectionEquality().equals(other.outDeliveryToAttention, outDeliveryToAttention)) &&
            (identical(other.outDeliveryToAddress1, outDeliveryToAddress1) || const DeepCollectionEquality().equals(other.outDeliveryToAddress1, outDeliveryToAddress1)) &&
            (identical(other.outDeliveryToAddress2, outDeliveryToAddress2) || const DeepCollectionEquality().equals(other.outDeliveryToAddress2, outDeliveryToAddress2)) &&
            (identical(other.outDeliveryToCity, outDeliveryToCity) || const DeepCollectionEquality().equals(other.outDeliveryToCity, outDeliveryToCity)) &&
            (identical(other.outDeliveryToState, outDeliveryToState) || const DeepCollectionEquality().equals(other.outDeliveryToState, outDeliveryToState)) &&
            (identical(other.outDeliveryToZipCode, outDeliveryToZipCode) || const DeepCollectionEquality().equals(other.outDeliveryToZipCode, outDeliveryToZipCode)) &&
            (identical(other.outDeliveryToCountryId, outDeliveryToCountryId) || const DeepCollectionEquality().equals(other.outDeliveryToCountryId, outDeliveryToCountryId)) &&
            (identical(other.outDeliveryToCountry, outDeliveryToCountry) || const DeepCollectionEquality().equals(other.outDeliveryToCountry, outDeliveryToCountry)) &&
            (identical(other.outDeliveryToContactFax, outDeliveryToContactFax) || const DeepCollectionEquality().equals(other.outDeliveryToContactFax, outDeliveryToContactFax)) &&
            (identical(other.outDeliveryToCrossStreets, outDeliveryToCrossStreets) || const DeepCollectionEquality().equals(other.outDeliveryToCrossStreets, outDeliveryToCrossStreets)) &&
            (identical(other.outDeliveryDeliveryNotes, outDeliveryDeliveryNotes) || const DeepCollectionEquality().equals(other.outDeliveryDeliveryNotes, outDeliveryDeliveryNotes)) &&
            (identical(other.outDeliveryCarrierId, outDeliveryCarrierId) || const DeepCollectionEquality().equals(other.outDeliveryCarrierId, outDeliveryCarrierId)) &&
            (identical(other.outDeliveryCarrier, outDeliveryCarrier) || const DeepCollectionEquality().equals(other.outDeliveryCarrier, outDeliveryCarrier)) &&
            (identical(other.outDeliveryCarrierAccount, outDeliveryCarrierAccount) || const DeepCollectionEquality().equals(other.outDeliveryCarrierAccount, outDeliveryCarrierAccount)) &&
            (identical(other.outDeliveryShipViaId, outDeliveryShipViaId) || const DeepCollectionEquality().equals(other.outDeliveryShipViaId, outDeliveryShipViaId)) &&
            (identical(other.outDeliveryShipVia, outDeliveryShipVia) || const DeepCollectionEquality().equals(other.outDeliveryShipVia, outDeliveryShipVia)) &&
            (identical(other.outDeliveryInvoiceId, outDeliveryInvoiceId) || const DeepCollectionEquality().equals(other.outDeliveryInvoiceId, outDeliveryInvoiceId)) &&
            (identical(other.outDeliveryVendorInvoiceId, outDeliveryVendorInvoiceId) || const DeepCollectionEquality().equals(other.outDeliveryVendorInvoiceId, outDeliveryVendorInvoiceId)) &&
            (identical(other.outDeliveryEstimatedFreight, outDeliveryEstimatedFreight) || const DeepCollectionEquality().equals(other.outDeliveryEstimatedFreight, outDeliveryEstimatedFreight)) &&
            (identical(other.outDeliveryFreightInvoiceAmount, outDeliveryFreightInvoiceAmount) || const DeepCollectionEquality().equals(other.outDeliveryFreightInvoiceAmount, outDeliveryFreightInvoiceAmount)) &&
            (identical(other.outDeliveryChargeType, outDeliveryChargeType) || const DeepCollectionEquality().equals(other.outDeliveryChargeType, outDeliveryChargeType)) &&
            (identical(other.outDeliveryFreightTrackingNumber, outDeliveryFreightTrackingNumber) || const DeepCollectionEquality().equals(other.outDeliveryFreightTrackingNumber, outDeliveryFreightTrackingNumber)) &&
            (identical(other.outDeliveryFreightTrackingUrl, outDeliveryFreightTrackingUrl) || const DeepCollectionEquality().equals(other.outDeliveryFreightTrackingUrl, outDeliveryFreightTrackingUrl)) &&
            (identical(other.outDeliveryPackageCode, outDeliveryPackageCode) || const DeepCollectionEquality().equals(other.outDeliveryPackageCode, outDeliveryPackageCode)) &&
            (identical(other.outDeliveryBillPoFreightOnOrder, outDeliveryBillPoFreightOnOrder) || const DeepCollectionEquality().equals(other.outDeliveryBillPoFreightOnOrder, outDeliveryBillPoFreightOnOrder)) &&
            (identical(other.outDeliveryOnlineOrderNumber, outDeliveryOnlineOrderNumber) || const DeepCollectionEquality().equals(other.outDeliveryOnlineOrderNumber, outDeliveryOnlineOrderNumber)) &&
            (identical(other.outDeliveryToVenue, outDeliveryToVenue) || const DeepCollectionEquality().equals(other.outDeliveryToVenue, outDeliveryToVenue)) &&
            (identical(other.outDeliveryToVenueId, outDeliveryToVenueId) || const DeepCollectionEquality().equals(other.outDeliveryToVenueId, outDeliveryToVenueId)) &&
            (identical(other.outDeliveryToWarehouse, outDeliveryToWarehouse) || const DeepCollectionEquality().equals(other.outDeliveryToWarehouse, outDeliveryToWarehouse)) &&
            (identical(other.outDeliveryToWarehouseId, outDeliveryToWarehouseId) || const DeepCollectionEquality().equals(other.outDeliveryToWarehouseId, outDeliveryToWarehouseId)) &&
            (identical(other.outDeliveryDateStamp, outDeliveryDateStamp) || const DeepCollectionEquality().equals(other.outDeliveryDateStamp, outDeliveryDateStamp)) &&
            (identical(other.inDeliveryId, inDeliveryId) || const DeepCollectionEquality().equals(other.inDeliveryId, inDeliveryId)) &&
            (identical(other.inDeliveryDeliveryType, inDeliveryDeliveryType) || const DeepCollectionEquality().equals(other.inDeliveryDeliveryType, inDeliveryDeliveryType)) &&
            (identical(other.inDeliveryRequiredDate, inDeliveryRequiredDate) || const DeepCollectionEquality().equals(other.inDeliveryRequiredDate, inDeliveryRequiredDate)) &&
            (identical(other.inDeliveryRequiredTime, inDeliveryRequiredTime) || const DeepCollectionEquality().equals(other.inDeliveryRequiredTime, inDeliveryRequiredTime)) &&
            (identical(other.inDeliveryTargetShipDate, inDeliveryTargetShipDate) || const DeepCollectionEquality().equals(other.inDeliveryTargetShipDate, inDeliveryTargetShipDate)) &&
            (identical(other.inDeliveryTargetShipTime, inDeliveryTargetShipTime) || const DeepCollectionEquality().equals(other.inDeliveryTargetShipTime, inDeliveryTargetShipTime)) &&
            (identical(other.inDeliveryDirection, inDeliveryDirection) || const DeepCollectionEquality().equals(other.inDeliveryDirection, inDeliveryDirection)) &&
            (identical(other.inDeliveryAddressType, inDeliveryAddressType) || const DeepCollectionEquality().equals(other.inDeliveryAddressType, inDeliveryAddressType)) &&
            (identical(other.inDeliveryFromLocation, inDeliveryFromLocation) || const DeepCollectionEquality().equals(other.inDeliveryFromLocation, inDeliveryFromLocation)) &&
            (identical(other.inDeliveryFromContact, inDeliveryFromContact) || const DeepCollectionEquality().equals(other.inDeliveryFromContact, inDeliveryFromContact)) &&
            (identical(other.inDeliveryFromContactPhone, inDeliveryFromContactPhone) || const DeepCollectionEquality().equals(other.inDeliveryFromContactPhone, inDeliveryFromContactPhone)) &&
            (identical(other.inDeliveryFromAlternateContact, inDeliveryFromAlternateContact) || const DeepCollectionEquality().equals(other.inDeliveryFromAlternateContact, inDeliveryFromAlternateContact)) &&
            (identical(other.inDeliveryFromAlternateContactPhone, inDeliveryFromAlternateContactPhone) || const DeepCollectionEquality().equals(other.inDeliveryFromAlternateContactPhone, inDeliveryFromAlternateContactPhone)) &&
            (identical(other.inDeliveryFromAttention, inDeliveryFromAttention) || const DeepCollectionEquality().equals(other.inDeliveryFromAttention, inDeliveryFromAttention)) &&
            (identical(other.inDeliveryFromAddress1, inDeliveryFromAddress1) || const DeepCollectionEquality().equals(other.inDeliveryFromAddress1, inDeliveryFromAddress1)) &&
            (identical(other.inDeliveryFromAdd2ress, inDeliveryFromAdd2ress) || const DeepCollectionEquality().equals(other.inDeliveryFromAdd2ress, inDeliveryFromAdd2ress)) &&
            (identical(other.inDeliveryFromCity, inDeliveryFromCity) || const DeepCollectionEquality().equals(other.inDeliveryFromCity, inDeliveryFromCity)) &&
            (identical(other.inDeliveryFromState, inDeliveryFromState) || const DeepCollectionEquality().equals(other.inDeliveryFromState, inDeliveryFromState)) &&
            (identical(other.inDeliveryFromZipCode, inDeliveryFromZipCode) || const DeepCollectionEquality().equals(other.inDeliveryFromZipCode, inDeliveryFromZipCode)) &&
            (identical(other.inDeliveryFromCountry, inDeliveryFromCountry) || const DeepCollectionEquality().equals(other.inDeliveryFromCountry, inDeliveryFromCountry)) &&
            (identical(other.inDeliveryFromCountryId, inDeliveryFromCountryId) || const DeepCollectionEquality().equals(other.inDeliveryFromCountryId, inDeliveryFromCountryId)) &&
            (identical(other.inDeliveryFromCrossStreets, inDeliveryFromCrossStreets) || const DeepCollectionEquality().equals(other.inDeliveryFromCrossStreets, inDeliveryFromCrossStreets)) &&
            (identical(other.inDeliveryToLocation, inDeliveryToLocation) || const DeepCollectionEquality().equals(other.inDeliveryToLocation, inDeliveryToLocation)) &&
            (identical(other.inDeliveryToContact, inDeliveryToContact) || const DeepCollectionEquality().equals(other.inDeliveryToContact, inDeliveryToContact)) &&
            (identical(other.inDeliveryToContactPhone, inDeliveryToContactPhone) || const DeepCollectionEquality().equals(other.inDeliveryToContactPhone, inDeliveryToContactPhone)) &&
            (identical(other.inDeliveryToAlternateContact, inDeliveryToAlternateContact) || const DeepCollectionEquality().equals(other.inDeliveryToAlternateContact, inDeliveryToAlternateContact)) &&
            (identical(other.inDeliveryToAlternateContactPhone, inDeliveryToAlternateContactPhone) || const DeepCollectionEquality().equals(other.inDeliveryToAlternateContactPhone, inDeliveryToAlternateContactPhone)) &&
            (identical(other.inDeliveryToAttention, inDeliveryToAttention) || const DeepCollectionEquality().equals(other.inDeliveryToAttention, inDeliveryToAttention)) &&
            (identical(other.inDeliveryToAddress1, inDeliveryToAddress1) || const DeepCollectionEquality().equals(other.inDeliveryToAddress1, inDeliveryToAddress1)) &&
            (identical(other.inDeliveryToAddress2, inDeliveryToAddress2) || const DeepCollectionEquality().equals(other.inDeliveryToAddress2, inDeliveryToAddress2)) &&
            (identical(other.inDeliveryToCity, inDeliveryToCity) || const DeepCollectionEquality().equals(other.inDeliveryToCity, inDeliveryToCity)) &&
            (identical(other.inDeliveryToState, inDeliveryToState) || const DeepCollectionEquality().equals(other.inDeliveryToState, inDeliveryToState)) &&
            (identical(other.inDeliveryToZipCode, inDeliveryToZipCode) || const DeepCollectionEquality().equals(other.inDeliveryToZipCode, inDeliveryToZipCode)) &&
            (identical(other.inDeliveryToCountryId, inDeliveryToCountryId) || const DeepCollectionEquality().equals(other.inDeliveryToCountryId, inDeliveryToCountryId)) &&
            (identical(other.inDeliveryToCountry, inDeliveryToCountry) || const DeepCollectionEquality().equals(other.inDeliveryToCountry, inDeliveryToCountry)) &&
            (identical(other.inDeliveryToContactFax, inDeliveryToContactFax) || const DeepCollectionEquality().equals(other.inDeliveryToContactFax, inDeliveryToContactFax)) &&
            (identical(other.inDeliveryToCrossStreets, inDeliveryToCrossStreets) || const DeepCollectionEquality().equals(other.inDeliveryToCrossStreets, inDeliveryToCrossStreets)) &&
            (identical(other.inDeliveryDeliveryNotes, inDeliveryDeliveryNotes) || const DeepCollectionEquality().equals(other.inDeliveryDeliveryNotes, inDeliveryDeliveryNotes)) &&
            (identical(other.inDeliveryCarrierId, inDeliveryCarrierId) || const DeepCollectionEquality().equals(other.inDeliveryCarrierId, inDeliveryCarrierId)) &&
            (identical(other.inDeliveryCarrier, inDeliveryCarrier) || const DeepCollectionEquality().equals(other.inDeliveryCarrier, inDeliveryCarrier)) &&
            (identical(other.inDeliveryCarrierAccount, inDeliveryCarrierAccount) || const DeepCollectionEquality().equals(other.inDeliveryCarrierAccount, inDeliveryCarrierAccount)) &&
            (identical(other.inDeliveryShipViaId, inDeliveryShipViaId) || const DeepCollectionEquality().equals(other.inDeliveryShipViaId, inDeliveryShipViaId)) &&
            (identical(other.inDeliveryShipVia, inDeliveryShipVia) || const DeepCollectionEquality().equals(other.inDeliveryShipVia, inDeliveryShipVia)) &&
            (identical(other.inDeliveryInvoiceId, inDeliveryInvoiceId) || const DeepCollectionEquality().equals(other.inDeliveryInvoiceId, inDeliveryInvoiceId)) &&
            (identical(other.inDeliveryVendorInvoiceId, inDeliveryVendorInvoiceId) || const DeepCollectionEquality().equals(other.inDeliveryVendorInvoiceId, inDeliveryVendorInvoiceId)) &&
            (identical(other.inDeliveryEstimatedFreight, inDeliveryEstimatedFreight) || const DeepCollectionEquality().equals(other.inDeliveryEstimatedFreight, inDeliveryEstimatedFreight)) &&
            (identical(other.inDeliveryFreightInvoiceAmount, inDeliveryFreightInvoiceAmount) || const DeepCollectionEquality().equals(other.inDeliveryFreightInvoiceAmount, inDeliveryFreightInvoiceAmount)) &&
            (identical(other.inDeliveryChargeType, inDeliveryChargeType) || const DeepCollectionEquality().equals(other.inDeliveryChargeType, inDeliveryChargeType)) &&
            (identical(other.inDeliveryFreightTrackingNumber, inDeliveryFreightTrackingNumber) || const DeepCollectionEquality().equals(other.inDeliveryFreightTrackingNumber, inDeliveryFreightTrackingNumber)) &&
            (identical(other.inDeliveryFreightTrackingUrl, inDeliveryFreightTrackingUrl) || const DeepCollectionEquality().equals(other.inDeliveryFreightTrackingUrl, inDeliveryFreightTrackingUrl)) &&
            (identical(other.inDeliveryPackageCode, inDeliveryPackageCode) || const DeepCollectionEquality().equals(other.inDeliveryPackageCode, inDeliveryPackageCode)) &&
            (identical(other.inDeliveryBillPoFreightOnOrder, inDeliveryBillPoFreightOnOrder) || const DeepCollectionEquality().equals(other.inDeliveryBillPoFreightOnOrder, inDeliveryBillPoFreightOnOrder)) &&
            (identical(other.inDeliveryOnlineOrderNumber, inDeliveryOnlineOrderNumber) || const DeepCollectionEquality().equals(other.inDeliveryOnlineOrderNumber, inDeliveryOnlineOrderNumber)) &&
            (identical(other.inDeliveryOnlineOrderStatus, inDeliveryOnlineOrderStatus) || const DeepCollectionEquality().equals(other.inDeliveryOnlineOrderStatus, inDeliveryOnlineOrderStatus)) &&
            (identical(other.inDeliveryToVenue, inDeliveryToVenue) || const DeepCollectionEquality().equals(other.inDeliveryToVenue, inDeliveryToVenue)) &&
            (identical(other.inDeliveryToVenueId, inDeliveryToVenueId) || const DeepCollectionEquality().equals(other.inDeliveryToVenueId, inDeliveryToVenueId)) &&
            (identical(other.inDeliveryToWarehouse, inDeliveryToWarehouse) || const DeepCollectionEquality().equals(other.inDeliveryToWarehouse, inDeliveryToWarehouse)) &&
            (identical(other.inDeliveryToWarehouseId, inDeliveryToWarehouseId) || const DeepCollectionEquality().equals(other.inDeliveryToWarehouseId, inDeliveryToWarehouseId)) &&
            (identical(other.inDeliveryDateStamp, inDeliveryDateStamp) || const DeepCollectionEquality().equals(other.inDeliveryDateStamp, inDeliveryDateStamp)) &&
            (identical(other.rentalDaysPerWeek, rentalDaysPerWeek) || const DeepCollectionEquality().equals(other.rentalDaysPerWeek, rentalDaysPerWeek)) &&
            (identical(other.rentalDiscountPercent, rentalDiscountPercent) || const DeepCollectionEquality().equals(other.rentalDiscountPercent, rentalDiscountPercent)) &&
            (identical(other.weeklyRentalTotal, weeklyRentalTotal) || const DeepCollectionEquality().equals(other.weeklyRentalTotal, weeklyRentalTotal)) &&
            (identical(other.monthlyRentalTotal, monthlyRentalTotal) || const DeepCollectionEquality().equals(other.monthlyRentalTotal, monthlyRentalTotal)) &&
            (identical(other.periodRentalTotal, periodRentalTotal) || const DeepCollectionEquality().equals(other.periodRentalTotal, periodRentalTotal)) &&
            (identical(other.weeklyRentalTotalIncludesTax, weeklyRentalTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklyRentalTotalIncludesTax, weeklyRentalTotalIncludesTax)) &&
            (identical(other.monthlyRentalTotalIncludesTax, monthlyRentalTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlyRentalTotalIncludesTax, monthlyRentalTotalIncludesTax)) &&
            (identical(other.periodRentalTotalIncludesTax, periodRentalTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodRentalTotalIncludesTax, periodRentalTotalIncludesTax)) &&
            (identical(other.billLockedTotal, billLockedTotal) || const DeepCollectionEquality().equals(other.billLockedTotal, billLockedTotal)) &&
            (identical(other.salesDiscountPercent, salesDiscountPercent) || const DeepCollectionEquality().equals(other.salesDiscountPercent, salesDiscountPercent)) &&
            (identical(other.salesTotal, salesTotal) || const DeepCollectionEquality().equals(other.salesTotal, salesTotal)) &&
            (identical(other.salesTotalIncludesTax, salesTotalIncludesTax) || const DeepCollectionEquality().equals(other.salesTotalIncludesTax, salesTotalIncludesTax)) &&
            (identical(other.partsDiscountPercent, partsDiscountPercent) || const DeepCollectionEquality().equals(other.partsDiscountPercent, partsDiscountPercent)) &&
            (identical(other.partsTotal, partsTotal) || const DeepCollectionEquality().equals(other.partsTotal, partsTotal)) &&
            (identical(other.partsTotalIncludesTax, partsTotalIncludesTax) || const DeepCollectionEquality().equals(other.partsTotalIncludesTax, partsTotalIncludesTax)) &&
            (identical(other.spaceDaysPerWeek, spaceDaysPerWeek) || const DeepCollectionEquality().equals(other.spaceDaysPerWeek, spaceDaysPerWeek)) &&
            (identical(other.spaceDiscountPercent, spaceDiscountPercent) || const DeepCollectionEquality().equals(other.spaceDiscountPercent, spaceDiscountPercent)) &&
            (identical(other.spaceSplitPercent, spaceSplitPercent) || const DeepCollectionEquality().equals(other.spaceSplitPercent, spaceSplitPercent)) &&
            (identical(other.weeklySpaceTotal, weeklySpaceTotal) || const DeepCollectionEquality().equals(other.weeklySpaceTotal, weeklySpaceTotal)) &&
            (identical(other.monthlySpaceTotal, monthlySpaceTotal) || const DeepCollectionEquality().equals(other.monthlySpaceTotal, monthlySpaceTotal)) &&
            (identical(other.periodSpaceTotal, periodSpaceTotal) || const DeepCollectionEquality().equals(other.periodSpaceTotal, periodSpaceTotal)) &&
            (identical(other.weeklySpaceTotalIncludesTax, weeklySpaceTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklySpaceTotalIncludesTax, weeklySpaceTotalIncludesTax)) &&
            (identical(other.monthlySpaceTotalIncludesTax, monthlySpaceTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlySpaceTotalIncludesTax, monthlySpaceTotalIncludesTax)) &&
            (identical(other.periodSpaceTotalIncludesTax, periodSpaceTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodSpaceTotalIncludesTax, periodSpaceTotalIncludesTax)) &&
            (identical(other.vehicleDaysPerWeek, vehicleDaysPerWeek) || const DeepCollectionEquality().equals(other.vehicleDaysPerWeek, vehicleDaysPerWeek)) &&
            (identical(other.vehicleDiscountPercent, vehicleDiscountPercent) || const DeepCollectionEquality().equals(other.vehicleDiscountPercent, vehicleDiscountPercent)) &&
            (identical(other.weeklyVehicleTotal, weeklyVehicleTotal) || const DeepCollectionEquality().equals(other.weeklyVehicleTotal, weeklyVehicleTotal)) &&
            (identical(other.monthlyVehicleTotal, monthlyVehicleTotal) || const DeepCollectionEquality().equals(other.monthlyVehicleTotal, monthlyVehicleTotal)) &&
            (identical(other.periodVehicleTotal, periodVehicleTotal) || const DeepCollectionEquality().equals(other.periodVehicleTotal, periodVehicleTotal)) &&
            (identical(other.weeklyVehicleTotalIncludesTax, weeklyVehicleTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklyVehicleTotalIncludesTax, weeklyVehicleTotalIncludesTax)) &&
            (identical(other.monthlyVehicleTotalIncludesTax, monthlyVehicleTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlyVehicleTotalIncludesTax, monthlyVehicleTotalIncludesTax)) &&
            (identical(other.periodVehicleTotalIncludesTax, periodVehicleTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodVehicleTotalIncludesTax, periodVehicleTotalIncludesTax)) &&
            (identical(other.miscDiscountPercent, miscDiscountPercent) || const DeepCollectionEquality().equals(other.miscDiscountPercent, miscDiscountPercent)) &&
            (identical(other.weeklyMiscTotal, weeklyMiscTotal) || const DeepCollectionEquality().equals(other.weeklyMiscTotal, weeklyMiscTotal)) &&
            (identical(other.monthlyMiscTotal, monthlyMiscTotal) || const DeepCollectionEquality().equals(other.monthlyMiscTotal, monthlyMiscTotal)) &&
            (identical(other.periodMiscTotal, periodMiscTotal) || const DeepCollectionEquality().equals(other.periodMiscTotal, periodMiscTotal)) &&
            (identical(other.weeklyMiscTotalIncludesTax, weeklyMiscTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklyMiscTotalIncludesTax, weeklyMiscTotalIncludesTax)) &&
            (identical(other.monthlyMiscTotalIncludesTax, monthlyMiscTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlyMiscTotalIncludesTax, monthlyMiscTotalIncludesTax)) &&
            (identical(other.periodMiscTotalIncludesTax, periodMiscTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodMiscTotalIncludesTax, periodMiscTotalIncludesTax)) &&
            (identical(other.laborDiscountPercent, laborDiscountPercent) || const DeepCollectionEquality().equals(other.laborDiscountPercent, laborDiscountPercent)) &&
            (identical(other.weeklyLaborTotal, weeklyLaborTotal) || const DeepCollectionEquality().equals(other.weeklyLaborTotal, weeklyLaborTotal)) &&
            (identical(other.monthlyLaborTotal, monthlyLaborTotal) || const DeepCollectionEquality().equals(other.monthlyLaborTotal, monthlyLaborTotal)) &&
            (identical(other.periodLaborTotal, periodLaborTotal) || const DeepCollectionEquality().equals(other.periodLaborTotal, periodLaborTotal)) &&
            (identical(other.weeklyLaborTotalIncludesTax, weeklyLaborTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklyLaborTotalIncludesTax, weeklyLaborTotalIncludesTax)) &&
            (identical(other.monthlyLaborTotalIncludesTax, monthlyLaborTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlyLaborTotalIncludesTax, monthlyLaborTotalIncludesTax)) &&
            (identical(other.periodLaborTotalIncludesTax, periodLaborTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodLaborTotalIncludesTax, periodLaborTotalIncludesTax)) &&
            (identical(other.rentalSaleDiscountPercent, rentalSaleDiscountPercent) || const DeepCollectionEquality().equals(other.rentalSaleDiscountPercent, rentalSaleDiscountPercent)) &&
            (identical(other.rentalSaleTotal, rentalSaleTotal) || const DeepCollectionEquality().equals(other.rentalSaleTotal, rentalSaleTotal)) &&
            (identical(other.rentalSaleTotalIncludesTax, rentalSaleTotalIncludesTax) || const DeepCollectionEquality().equals(other.rentalSaleTotalIncludesTax, rentalSaleTotalIncludesTax)) &&
            (identical(other.lossAndDamageDiscountPercent, lossAndDamageDiscountPercent) || const DeepCollectionEquality().equals(other.lossAndDamageDiscountPercent, lossAndDamageDiscountPercent)) &&
            (identical(other.lossAndDamageTotal, lossAndDamageTotal) || const DeepCollectionEquality().equals(other.lossAndDamageTotal, lossAndDamageTotal)) &&
            (identical(other.lossAndDamageTotalIncludesTax, lossAndDamageTotalIncludesTax) || const DeepCollectionEquality().equals(other.lossAndDamageTotalIncludesTax, lossAndDamageTotalIncludesTax)) &&
            (identical(other.combinedDaysPerWeek, combinedDaysPerWeek) || const DeepCollectionEquality().equals(other.combinedDaysPerWeek, combinedDaysPerWeek)) &&
            (identical(other.combinedDiscountPercent, combinedDiscountPercent) || const DeepCollectionEquality().equals(other.combinedDiscountPercent, combinedDiscountPercent)) &&
            (identical(other.weeklyCombinedTotal, weeklyCombinedTotal) || const DeepCollectionEquality().equals(other.weeklyCombinedTotal, weeklyCombinedTotal)) &&
            (identical(other.monthlyCombinedTotal, monthlyCombinedTotal) || const DeepCollectionEquality().equals(other.monthlyCombinedTotal, monthlyCombinedTotal)) &&
            (identical(other.periodCombinedTotal, periodCombinedTotal) || const DeepCollectionEquality().equals(other.periodCombinedTotal, periodCombinedTotal)) &&
            (identical(other.weeklyCombinedTotalIncludesTax, weeklyCombinedTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklyCombinedTotalIncludesTax, weeklyCombinedTotalIncludesTax)) &&
            (identical(other.monthlyCombinedTotalIncludesTax, monthlyCombinedTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlyCombinedTotalIncludesTax, monthlyCombinedTotalIncludesTax)) &&
            (identical(other.periodCombinedTotalIncludesTax, periodCombinedTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodCombinedTotalIncludesTax, periodCombinedTotalIncludesTax)) &&
            (identical(other.disableEditingRentalRate, disableEditingRentalRate) || const DeepCollectionEquality().equals(other.disableEditingRentalRate, disableEditingRentalRate)) &&
            (identical(other.disableEditingSalesRate, disableEditingSalesRate) || const DeepCollectionEquality().equals(other.disableEditingSalesRate, disableEditingSalesRate)) &&
            (identical(other.disableEditingMiscellaneousRate, disableEditingMiscellaneousRate) || const DeepCollectionEquality().equals(other.disableEditingMiscellaneousRate, disableEditingMiscellaneousRate)) &&
            (identical(other.disableEditingLaborRate, disableEditingLaborRate) || const DeepCollectionEquality().equals(other.disableEditingLaborRate, disableEditingLaborRate)) &&
            (identical(other.disableEditingRentalSaleRate, disableEditingRentalSaleRate) || const DeepCollectionEquality().equals(other.disableEditingRentalSaleRate, disableEditingRentalSaleRate)) &&
            (identical(other.disableEditingLossAndDamageRate, disableEditingLossAndDamageRate) || const DeepCollectionEquality().equals(other.disableEditingLossAndDamageRate, disableEditingLossAndDamageRate)) &&
            (identical(other.rentalExtendedTotal, rentalExtendedTotal) || const DeepCollectionEquality().equals(other.rentalExtendedTotal, rentalExtendedTotal)) &&
            (identical(other.salesExtendedTotal, salesExtendedTotal) || const DeepCollectionEquality().equals(other.salesExtendedTotal, salesExtendedTotal)) &&
            (identical(other.laborExtendedTotal, laborExtendedTotal) || const DeepCollectionEquality().equals(other.laborExtendedTotal, laborExtendedTotal)) &&
            (identical(other.miscellaneousExtendedTotal, miscellaneousExtendedTotal) || const DeepCollectionEquality().equals(other.miscellaneousExtendedTotal, miscellaneousExtendedTotal)) &&
            (identical(other.rentalSaleExtendedTotal, rentalSaleExtendedTotal) || const DeepCollectionEquality().equals(other.rentalSaleExtendedTotal, rentalSaleExtendedTotal)) &&
            (identical(other.lossAndDamageExtendedTotal, lossAndDamageExtendedTotal) || const DeepCollectionEquality().equals(other.lossAndDamageExtendedTotal, lossAndDamageExtendedTotal)) &&
            (identical(other.hasNotes, hasNotes) || const DeepCollectionEquality().equals(other.hasNotes, hasNotes)) &&
            (identical(other.hasDocuments, hasDocuments) || const DeepCollectionEquality().equals(other.hasDocuments, hasDocuments)) &&
            (identical(other.hasEmailHistory, hasEmailHistory) || const DeepCollectionEquality().equals(other.hasEmailHistory, hasEmailHistory)) &&
            (identical(other.hasContacts, hasContacts) || const DeepCollectionEquality().equals(other.hasContacts, hasContacts)) &&
            (identical(other.hasSubPurchaseOrders, hasSubPurchaseOrders) || const DeepCollectionEquality().equals(other.hasSubPurchaseOrders, hasSubPurchaseOrders)) &&
            (identical(other.hasPickLists, hasPickLists) || const DeepCollectionEquality().equals(other.hasPickLists, hasPickLists)) &&
            (identical(other.hasContracts, hasContracts) || const DeepCollectionEquality().equals(other.hasContracts, hasContracts)) &&
            (identical(other.hasSuspendedContracts, hasSuspendedContracts) || const DeepCollectionEquality().equals(other.hasSuspendedContracts, hasSuspendedContracts)) &&
            (identical(other.hasMultiOrderContracts, hasMultiOrderContracts) || const DeepCollectionEquality().equals(other.hasMultiOrderContracts, hasMultiOrderContracts)) &&
            (identical(other.hasInvoices, hasInvoices) || const DeepCollectionEquality().equals(other.hasInvoices, hasInvoices)) &&
            (identical(other.hasBillingWorksheets, hasBillingWorksheets) || const DeepCollectionEquality().equals(other.hasBillingWorksheets, hasBillingWorksheets)) &&
            (identical(other.hasMultiOrderInvoices, hasMultiOrderInvoices) || const DeepCollectionEquality().equals(other.hasMultiOrderInvoices, hasMultiOrderInvoices)) &&
            (identical(other.totalReplacementCost, totalReplacementCost) || const DeepCollectionEquality().equals(other.totalReplacementCost, totalReplacementCost)) &&
            (identical(other.presentationLayerId, presentationLayerId) || const DeepCollectionEquality().equals(other.presentationLayerId, presentationLayerId)) &&
            (identical(other.presentationLayer, presentationLayer) || const DeepCollectionEquality().equals(other.presentationLayer, presentationLayer)) &&
            (identical(other.isManualSort, isManualSort) || const DeepCollectionEquality().equals(other.isManualSort, isManualSort)) &&
            (identical(other.quoteOrderTitle, quoteOrderTitle) || const DeepCollectionEquality().equals(other.quoteOrderTitle, quoteOrderTitle)) &&
            (identical(other.unassignedSubs, unassignedSubs) || const DeepCollectionEquality().equals(other.unassignedSubs, unassignedSubs)) &&
            (identical(other.nonTaxable, nonTaxable) || const DeepCollectionEquality().equals(other.nonTaxable, nonTaxable)) &&
            (identical(other.enableProjects, enableProjects) || const DeepCollectionEquality().equals(other.enableProjects, enableProjects)) &&
            (identical(other.projectId, projectId) || const DeepCollectionEquality().equals(other.projectId, projectId)) &&
            (identical(other.projectNumber, projectNumber) || const DeepCollectionEquality().equals(other.projectNumber, projectNumber)) &&
            (identical(other.project, project) || const DeepCollectionEquality().equals(other.project, project)) &&
            (identical(other.projectDrawingsId, projectDrawingsId) || const DeepCollectionEquality().equals(other.projectDrawingsId, projectDrawingsId)) &&
            (identical(other.projectDrawings, projectDrawings) || const DeepCollectionEquality().equals(other.projectDrawings, projectDrawings)) &&
            (identical(other.projectItemsOrderedId, projectItemsOrderedId) || const DeepCollectionEquality().equals(other.projectItemsOrderedId, projectItemsOrderedId)) &&
            (identical(other.projectItemsOrdered, projectItemsOrdered) || const DeepCollectionEquality().equals(other.projectItemsOrdered, projectItemsOrdered)) &&
            (identical(other.projectDropShipId, projectDropShipId) || const DeepCollectionEquality().equals(other.projectDropShipId, projectDropShipId)) &&
            (identical(other.projectDropShip, projectDropShip) || const DeepCollectionEquality().equals(other.projectDropShip, projectDropShip)) &&
            (identical(other.projectAsBuildId, projectAsBuildId) || const DeepCollectionEquality().equals(other.projectAsBuildId, projectAsBuildId)) &&
            (identical(other.projectAsBuild, projectAsBuild) || const DeepCollectionEquality().equals(other.projectAsBuild, projectAsBuild)) &&
            (identical(other.projectCommissioningId, projectCommissioningId) || const DeepCollectionEquality().equals(other.projectCommissioningId, projectCommissioningId)) &&
            (identical(other.projectCommissioning, projectCommissioning) || const DeepCollectionEquality().equals(other.projectCommissioning, projectCommissioning)) &&
            (identical(other.projectDepositId, projectDepositId) || const DeepCollectionEquality().equals(other.projectDepositId, projectDepositId)) &&
            (identical(other.projectDeposit, projectDeposit) || const DeepCollectionEquality().equals(other.projectDeposit, projectDeposit)) &&
            (identical(other.inputByUserId, inputByUserId) || const DeepCollectionEquality().equals(other.inputByUserId, inputByUserId)) &&
            (identical(other.modifiedByUserId, modifiedByUserId) || const DeepCollectionEquality().equals(other.modifiedByUserId, modifiedByUserId)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.items, items) || const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesAgentOrderGetOrderResponseExtension
    on WebApiModulesAgentOrderGetOrderResponse {
  WebApiModulesAgentOrderGetOrderResponse copyWith(
      {String? orderId,
      String? orderNumber,
      String? orderDate,
      String? sourceQuoteId,
      String? sourceQuoteNumber,
      String? description,
      String? officeLocationId,
      String? officeLocation,
      String? warehouseId,
      String? warehouse,
      String? warehouseCode,
      String? departmentId,
      String? department,
      String? customerId,
      String? customer,
      String? customerNumber,
      String? dealId,
      String? deal,
      String? dealNumber,
      String? rateType,
      String? rateTypeDisplay,
      String? agentId,
      String? agent,
      String? projectManagerId,
      String? projectManager,
      bool? rental,
      bool? sales,
      bool? miscellaneous,
      bool? labor,
      bool? facilities,
      bool? transportation,
      bool? rentalSale,
      bool? lossAndDamage,
      bool? repair,
      bool? hasRentalItem,
      bool? hasSalesItem,
      bool? hasMiscellaneousItem,
      bool? hasLaborItem,
      bool? hasFacilitiesItem,
      bool? hasLossAndDamageItem,
      bool? hasRentalSaleItem,
      bool? hasRepair,
      List<WebApiModulesHomeControlsOrderDatesOrderDates>?
          activityDatesAndTimes,
      String? pickDate,
      String? pickTime,
      String? estimatedStartDate,
      String? estimatedStartTime,
      String? estimatedStopDate,
      String? estimatedStopTime,
      String? pickUpDate,
      String? pickUpTime,
      String? prepDate,
      String? prepTime,
      String? loadInDate,
      String? loadInTime,
      String? strikeDate,
      String? strikeTime,
      String? testDate,
      String? testTime,
      String? orderTypeId,
      String? orderType,
      bool? orderTypeCombineActivityTabs,
      bool? flatPo,
      bool? pendingPo,
      String? poNumber,
      double? poAmount,
      String? location,
      String? orderLocationId,
      String? orderLocation,
      String? referenceNumber,
      double? total,
      String? status,
      String? statusDate,
      String? poApprovalStatusId,
      bool? lockBillingDates,
      bool? specifyBillingDatesByType,
      String? rentalBillingStartDate,
      String? rentalBillingEndDate,
      String? laborBillingStartDate,
      String? laborBillingEndDate,
      String? miscellaneousBillingStartDate,
      String? miscellaneousBillingEndDate,
      String? facilitiesBillingStartDate,
      String? facilitiesBillingEndDate,
      String? vehicleBillingStartDate,
      String? vehicleBillingEndDate,
      String? delayBillingSearchUntil,
      bool? includePrepFeesInRentalRate,
      String? billingStartDate,
      String? billingEndDate,
      double? billingWeeks,
      double? billingMonths,
      String? determineQuantitiesToBillBasedOn,
      String? billingCycleId,
      String? billingCycle,
      String? billingCycleType,
      String? paymentTermsId,
      String? paymentTerms,
      String? paymentTypeId,
      String? paymentType,
      String? currencyId,
      bool? updateAllRatesToNewCurrency,
      String? confirmUpdateAllRatesToNewCurrency,
      String? currencyCode,
      String? currency,
      String? currencySymbol,
      String? taxOptionId,
      String? taxOption,
      String? tax1Name,
      String? tax2Name,
      String? taxId,
      double? rentalTaxRate1,
      double? salesTaxRate1,
      double? laborTaxRate1,
      double? rentalTaxRate2,
      double? salesTaxRate2,
      double? laborTaxRate2,
      bool? noCharge,
      String? noChargeReason,
      String? printIssuedToAddressFrom,
      String? issuedToName,
      String? issuedToAttention,
      String? issuedToAttention2,
      String? issuedToAddress1,
      String? issuedToAddress2,
      String? issuedToCity,
      String? issuedToState,
      String? issuedToZipCode,
      String? issuedToCountryId,
      String? issuedToCountry,
      bool? billToAddressDifferentFromIssuedToAddress,
      String? billToAddressId,
      String? billToName,
      String? billToAttention,
      String? billToAttention2,
      String? billToAddress1,
      String? billToAddress2,
      String? billToCity,
      String? billToState,
      String? billToZipCode,
      String? billToCountryId,
      String? billToCountry,
      String? discountReasonId,
      String? discountReason,
      bool? requireContactConfirmation,
      bool? includeInBillingAnalysis,
      String? hiatusDiscountFrom,
      bool? roundTripRentals,
      bool? inGroup,
      int? groupNumber,
      int? groupColor,
      double? groupOrderBy,
      String? coverLetterId,
      String? coverLetter,
      String? termsConditionsId,
      String? termsConditions,
      String? outsideSalesRepresentativeId,
      String? outsideSalesRepresentative,
      String? marketTypeId,
      String? marketType,
      String? marketSegmentId,
      String? marketSegment,
      String? marketSegmentJobId,
      String? marketSegmentJob,
      String? outDeliveryId,
      String? outDeliveryDeliveryType,
      String? outDeliveryRequiredDate,
      String? outDeliveryRequiredTime,
      String? outDeliveryTargetShipDate,
      String? outDeliveryTargetShipTime,
      String? outDeliveryDirection,
      String? outDeliveryAddressType,
      String? outDeliveryFromLocation,
      String? outDeliveryFromContact,
      String? outDeliveryFromContactPhone,
      String? outDeliveryFromAlternateContact,
      String? outDeliveryFromAlternateContactPhone,
      String? outDeliveryFromAttention,
      String? outDeliveryFromAddress1,
      String? outDeliveryFromAdd2ress,
      String? outDeliveryFromCity,
      String? outDeliveryFromState,
      String? outDeliveryFromZipCode,
      String? outDeliveryFromCountry,
      String? outDeliveryFromCountryId,
      String? outDeliveryFromCrossStreets,
      String? outDeliveryToLocation,
      String? outDeliveryToContact,
      String? outDeliveryToContactPhone,
      String? outDeliveryToAlternateContact,
      String? outDeliveryToAlternateContactPhone,
      String? outDeliveryToAttention,
      String? outDeliveryToAddress1,
      String? outDeliveryToAddress2,
      String? outDeliveryToCity,
      String? outDeliveryToState,
      String? outDeliveryToZipCode,
      String? outDeliveryToCountryId,
      String? outDeliveryToCountry,
      String? outDeliveryToContactFax,
      String? outDeliveryToCrossStreets,
      String? outDeliveryDeliveryNotes,
      String? outDeliveryCarrierId,
      String? outDeliveryCarrier,
      String? outDeliveryCarrierAccount,
      String? outDeliveryShipViaId,
      String? outDeliveryShipVia,
      String? outDeliveryInvoiceId,
      String? outDeliveryVendorInvoiceId,
      double? outDeliveryEstimatedFreight,
      double? outDeliveryFreightInvoiceAmount,
      String? outDeliveryChargeType,
      String? outDeliveryFreightTrackingNumber,
      String? outDeliveryFreightTrackingUrl,
      String? outDeliveryPackageCode,
      bool? outDeliveryBillPoFreightOnOrder,
      String? outDeliveryOnlineOrderNumber,
      String? outDeliveryToVenue,
      String? outDeliveryToVenueId,
      String? outDeliveryToWarehouse,
      String? outDeliveryToWarehouseId,
      String? outDeliveryDateStamp,
      String? inDeliveryId,
      String? inDeliveryDeliveryType,
      String? inDeliveryRequiredDate,
      String? inDeliveryRequiredTime,
      String? inDeliveryTargetShipDate,
      String? inDeliveryTargetShipTime,
      String? inDeliveryDirection,
      String? inDeliveryAddressType,
      String? inDeliveryFromLocation,
      String? inDeliveryFromContact,
      String? inDeliveryFromContactPhone,
      String? inDeliveryFromAlternateContact,
      String? inDeliveryFromAlternateContactPhone,
      String? inDeliveryFromAttention,
      String? inDeliveryFromAddress1,
      String? inDeliveryFromAdd2ress,
      String? inDeliveryFromCity,
      String? inDeliveryFromState,
      String? inDeliveryFromZipCode,
      String? inDeliveryFromCountry,
      String? inDeliveryFromCountryId,
      String? inDeliveryFromCrossStreets,
      String? inDeliveryToLocation,
      String? inDeliveryToContact,
      String? inDeliveryToContactPhone,
      String? inDeliveryToAlternateContact,
      String? inDeliveryToAlternateContactPhone,
      String? inDeliveryToAttention,
      String? inDeliveryToAddress1,
      String? inDeliveryToAddress2,
      String? inDeliveryToCity,
      String? inDeliveryToState,
      String? inDeliveryToZipCode,
      String? inDeliveryToCountryId,
      String? inDeliveryToCountry,
      String? inDeliveryToContactFax,
      String? inDeliveryToCrossStreets,
      String? inDeliveryDeliveryNotes,
      String? inDeliveryCarrierId,
      String? inDeliveryCarrier,
      String? inDeliveryCarrierAccount,
      String? inDeliveryShipViaId,
      String? inDeliveryShipVia,
      String? inDeliveryInvoiceId,
      String? inDeliveryVendorInvoiceId,
      double? inDeliveryEstimatedFreight,
      double? inDeliveryFreightInvoiceAmount,
      String? inDeliveryChargeType,
      String? inDeliveryFreightTrackingNumber,
      String? inDeliveryFreightTrackingUrl,
      String? inDeliveryPackageCode,
      bool? inDeliveryBillPoFreightOnOrder,
      String? inDeliveryOnlineOrderNumber,
      String? inDeliveryOnlineOrderStatus,
      String? inDeliveryToVenue,
      String? inDeliveryToVenueId,
      String? inDeliveryToWarehouse,
      String? inDeliveryToWarehouseId,
      String? inDeliveryDateStamp,
      double? rentalDaysPerWeek,
      double? rentalDiscountPercent,
      double? weeklyRentalTotal,
      double? monthlyRentalTotal,
      double? periodRentalTotal,
      bool? weeklyRentalTotalIncludesTax,
      bool? monthlyRentalTotalIncludesTax,
      bool? periodRentalTotalIncludesTax,
      bool? billLockedTotal,
      double? salesDiscountPercent,
      double? salesTotal,
      bool? salesTotalIncludesTax,
      double? partsDiscountPercent,
      double? partsTotal,
      bool? partsTotalIncludesTax,
      double? spaceDaysPerWeek,
      double? spaceDiscountPercent,
      double? spaceSplitPercent,
      double? weeklySpaceTotal,
      double? monthlySpaceTotal,
      double? periodSpaceTotal,
      bool? weeklySpaceTotalIncludesTax,
      bool? monthlySpaceTotalIncludesTax,
      bool? periodSpaceTotalIncludesTax,
      double? vehicleDaysPerWeek,
      double? vehicleDiscountPercent,
      double? weeklyVehicleTotal,
      double? monthlyVehicleTotal,
      double? periodVehicleTotal,
      bool? weeklyVehicleTotalIncludesTax,
      bool? monthlyVehicleTotalIncludesTax,
      bool? periodVehicleTotalIncludesTax,
      double? miscDiscountPercent,
      double? weeklyMiscTotal,
      double? monthlyMiscTotal,
      double? periodMiscTotal,
      bool? weeklyMiscTotalIncludesTax,
      bool? monthlyMiscTotalIncludesTax,
      bool? periodMiscTotalIncludesTax,
      double? laborDiscountPercent,
      double? weeklyLaborTotal,
      double? monthlyLaborTotal,
      double? periodLaborTotal,
      bool? weeklyLaborTotalIncludesTax,
      bool? monthlyLaborTotalIncludesTax,
      bool? periodLaborTotalIncludesTax,
      double? rentalSaleDiscountPercent,
      double? rentalSaleTotal,
      bool? rentalSaleTotalIncludesTax,
      double? lossAndDamageDiscountPercent,
      double? lossAndDamageTotal,
      bool? lossAndDamageTotalIncludesTax,
      double? combinedDaysPerWeek,
      double? combinedDiscountPercent,
      double? weeklyCombinedTotal,
      double? monthlyCombinedTotal,
      double? periodCombinedTotal,
      bool? weeklyCombinedTotalIncludesTax,
      bool? monthlyCombinedTotalIncludesTax,
      bool? periodCombinedTotalIncludesTax,
      bool? disableEditingRentalRate,
      bool? disableEditingSalesRate,
      bool? disableEditingMiscellaneousRate,
      bool? disableEditingLaborRate,
      bool? disableEditingRentalSaleRate,
      bool? disableEditingLossAndDamageRate,
      double? rentalExtendedTotal,
      double? salesExtendedTotal,
      double? laborExtendedTotal,
      double? miscellaneousExtendedTotal,
      double? rentalSaleExtendedTotal,
      double? lossAndDamageExtendedTotal,
      bool? hasNotes,
      bool? hasDocuments,
      bool? hasEmailHistory,
      bool? hasContacts,
      bool? hasSubPurchaseOrders,
      bool? hasPickLists,
      bool? hasContracts,
      bool? hasSuspendedContracts,
      bool? hasMultiOrderContracts,
      bool? hasInvoices,
      bool? hasBillingWorksheets,
      bool? hasMultiOrderInvoices,
      double? totalReplacementCost,
      String? presentationLayerId,
      String? presentationLayer,
      bool? isManualSort,
      String? quoteOrderTitle,
      bool? unassignedSubs,
      bool? nonTaxable,
      bool? enableProjects,
      String? projectId,
      String? projectNumber,
      String? project,
      String? projectDrawingsId,
      String? projectDrawings,
      String? projectItemsOrderedId,
      String? projectItemsOrdered,
      String? projectDropShipId,
      String? projectDropShip,
      String? projectAsBuildId,
      String? projectAsBuild,
      String? projectCommissioningId,
      String? projectCommissioning,
      String? projectDepositId,
      String? projectDeposit,
      String? inputByUserId,
      String? modifiedByUserId,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<WebApiModulesHomeControlsOrderItemOrderItem>? items,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAgentOrderGetOrderResponse(
        orderId: orderId ?? this.orderId,
        orderNumber: orderNumber ?? this.orderNumber,
        orderDate: orderDate ?? this.orderDate,
        sourceQuoteId: sourceQuoteId ?? this.sourceQuoteId,
        sourceQuoteNumber: sourceQuoteNumber ?? this.sourceQuoteNumber,
        description: description ?? this.description,
        officeLocationId: officeLocationId ?? this.officeLocationId,
        officeLocation: officeLocation ?? this.officeLocation,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouse: warehouse ?? this.warehouse,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        departmentId: departmentId ?? this.departmentId,
        department: department ?? this.department,
        customerId: customerId ?? this.customerId,
        customer: customer ?? this.customer,
        customerNumber: customerNumber ?? this.customerNumber,
        dealId: dealId ?? this.dealId,
        deal: deal ?? this.deal,
        dealNumber: dealNumber ?? this.dealNumber,
        rateType: rateType ?? this.rateType,
        rateTypeDisplay: rateTypeDisplay ?? this.rateTypeDisplay,
        agentId: agentId ?? this.agentId,
        agent: agent ?? this.agent,
        projectManagerId: projectManagerId ?? this.projectManagerId,
        projectManager: projectManager ?? this.projectManager,
        rental: rental ?? this.rental,
        sales: sales ?? this.sales,
        miscellaneous: miscellaneous ?? this.miscellaneous,
        labor: labor ?? this.labor,
        facilities: facilities ?? this.facilities,
        transportation: transportation ?? this.transportation,
        rentalSale: rentalSale ?? this.rentalSale,
        lossAndDamage: lossAndDamage ?? this.lossAndDamage,
        repair: repair ?? this.repair,
        hasRentalItem: hasRentalItem ?? this.hasRentalItem,
        hasSalesItem: hasSalesItem ?? this.hasSalesItem,
        hasMiscellaneousItem: hasMiscellaneousItem ?? this.hasMiscellaneousItem,
        hasLaborItem: hasLaborItem ?? this.hasLaborItem,
        hasFacilitiesItem: hasFacilitiesItem ?? this.hasFacilitiesItem,
        hasLossAndDamageItem: hasLossAndDamageItem ?? this.hasLossAndDamageItem,
        hasRentalSaleItem: hasRentalSaleItem ?? this.hasRentalSaleItem,
        hasRepair: hasRepair ?? this.hasRepair,
        activityDatesAndTimes:
            activityDatesAndTimes ?? this.activityDatesAndTimes,
        pickDate: pickDate ?? this.pickDate,
        pickTime: pickTime ?? this.pickTime,
        estimatedStartDate: estimatedStartDate ?? this.estimatedStartDate,
        estimatedStartTime: estimatedStartTime ?? this.estimatedStartTime,
        estimatedStopDate: estimatedStopDate ?? this.estimatedStopDate,
        estimatedStopTime: estimatedStopTime ?? this.estimatedStopTime,
        pickUpDate: pickUpDate ?? this.pickUpDate,
        pickUpTime: pickUpTime ?? this.pickUpTime,
        prepDate: prepDate ?? this.prepDate,
        prepTime: prepTime ?? this.prepTime,
        loadInDate: loadInDate ?? this.loadInDate,
        loadInTime: loadInTime ?? this.loadInTime,
        strikeDate: strikeDate ?? this.strikeDate,
        strikeTime: strikeTime ?? this.strikeTime,
        testDate: testDate ?? this.testDate,
        testTime: testTime ?? this.testTime,
        orderTypeId: orderTypeId ?? this.orderTypeId,
        orderType: orderType ?? this.orderType,
        orderTypeCombineActivityTabs:
            orderTypeCombineActivityTabs ?? this.orderTypeCombineActivityTabs,
        flatPo: flatPo ?? this.flatPo,
        pendingPo: pendingPo ?? this.pendingPo,
        poNumber: poNumber ?? this.poNumber,
        poAmount: poAmount ?? this.poAmount,
        location: location ?? this.location,
        orderLocationId: orderLocationId ?? this.orderLocationId,
        orderLocation: orderLocation ?? this.orderLocation,
        referenceNumber: referenceNumber ?? this.referenceNumber,
        total: total ?? this.total,
        status: status ?? this.status,
        statusDate: statusDate ?? this.statusDate,
        poApprovalStatusId: poApprovalStatusId ?? this.poApprovalStatusId,
        lockBillingDates: lockBillingDates ?? this.lockBillingDates,
        specifyBillingDatesByType:
            specifyBillingDatesByType ?? this.specifyBillingDatesByType,
        rentalBillingStartDate:
            rentalBillingStartDate ?? this.rentalBillingStartDate,
        rentalBillingEndDate: rentalBillingEndDate ?? this.rentalBillingEndDate,
        laborBillingStartDate:
            laborBillingStartDate ?? this.laborBillingStartDate,
        laborBillingEndDate: laborBillingEndDate ?? this.laborBillingEndDate,
        miscellaneousBillingStartDate:
            miscellaneousBillingStartDate ?? this.miscellaneousBillingStartDate,
        miscellaneousBillingEndDate:
            miscellaneousBillingEndDate ?? this.miscellaneousBillingEndDate,
        facilitiesBillingStartDate:
            facilitiesBillingStartDate ?? this.facilitiesBillingStartDate,
        facilitiesBillingEndDate:
            facilitiesBillingEndDate ?? this.facilitiesBillingEndDate,
        vehicleBillingStartDate:
            vehicleBillingStartDate ?? this.vehicleBillingStartDate,
        vehicleBillingEndDate:
            vehicleBillingEndDate ?? this.vehicleBillingEndDate,
        delayBillingSearchUntil:
            delayBillingSearchUntil ?? this.delayBillingSearchUntil,
        includePrepFeesInRentalRate:
            includePrepFeesInRentalRate ?? this.includePrepFeesInRentalRate,
        billingStartDate: billingStartDate ?? this.billingStartDate,
        billingEndDate: billingEndDate ?? this.billingEndDate,
        billingWeeks: billingWeeks ?? this.billingWeeks,
        billingMonths: billingMonths ?? this.billingMonths,
        determineQuantitiesToBillBasedOn: determineQuantitiesToBillBasedOn ??
            this.determineQuantitiesToBillBasedOn,
        billingCycleId: billingCycleId ?? this.billingCycleId,
        billingCycle: billingCycle ?? this.billingCycle,
        billingCycleType: billingCycleType ?? this.billingCycleType,
        paymentTermsId: paymentTermsId ?? this.paymentTermsId,
        paymentTerms: paymentTerms ?? this.paymentTerms,
        paymentTypeId: paymentTypeId ?? this.paymentTypeId,
        paymentType: paymentType ?? this.paymentType,
        currencyId: currencyId ?? this.currencyId,
        updateAllRatesToNewCurrency:
            updateAllRatesToNewCurrency ?? this.updateAllRatesToNewCurrency,
        confirmUpdateAllRatesToNewCurrency: confirmUpdateAllRatesToNewCurrency ??
            this.confirmUpdateAllRatesToNewCurrency,
        currencyCode: currencyCode ?? this.currencyCode,
        currency: currency ?? this.currency,
        currencySymbol: currencySymbol ?? this.currencySymbol,
        taxOptionId: taxOptionId ?? this.taxOptionId,
        taxOption: taxOption ?? this.taxOption,
        tax1Name: tax1Name ?? this.tax1Name,
        tax2Name: tax2Name ?? this.tax2Name,
        taxId: taxId ?? this.taxId,
        rentalTaxRate1: rentalTaxRate1 ?? this.rentalTaxRate1,
        salesTaxRate1: salesTaxRate1 ?? this.salesTaxRate1,
        laborTaxRate1: laborTaxRate1 ?? this.laborTaxRate1,
        rentalTaxRate2: rentalTaxRate2 ?? this.rentalTaxRate2,
        salesTaxRate2: salesTaxRate2 ?? this.salesTaxRate2,
        laborTaxRate2: laborTaxRate2 ?? this.laborTaxRate2,
        noCharge: noCharge ?? this.noCharge,
        noChargeReason: noChargeReason ?? this.noChargeReason,
        printIssuedToAddressFrom:
            printIssuedToAddressFrom ?? this.printIssuedToAddressFrom,
        issuedToName: issuedToName ?? this.issuedToName,
        issuedToAttention: issuedToAttention ?? this.issuedToAttention,
        issuedToAttention2: issuedToAttention2 ?? this.issuedToAttention2,
        issuedToAddress1: issuedToAddress1 ?? this.issuedToAddress1,
        issuedToAddress2: issuedToAddress2 ?? this.issuedToAddress2,
        issuedToCity: issuedToCity ?? this.issuedToCity,
        issuedToState: issuedToState ?? this.issuedToState,
        issuedToZipCode: issuedToZipCode ?? this.issuedToZipCode,
        issuedToCountryId: issuedToCountryId ?? this.issuedToCountryId,
        issuedToCountry: issuedToCountry ?? this.issuedToCountry,
        billToAddressDifferentFromIssuedToAddress:
            billToAddressDifferentFromIssuedToAddress ??
                this.billToAddressDifferentFromIssuedToAddress,
        billToAddressId: billToAddressId ?? this.billToAddressId,
        billToName: billToName ?? this.billToName,
        billToAttention: billToAttention ?? this.billToAttention,
        billToAttention2: billToAttention2 ?? this.billToAttention2,
        billToAddress1: billToAddress1 ?? this.billToAddress1,
        billToAddress2: billToAddress2 ?? this.billToAddress2,
        billToCity: billToCity ?? this.billToCity,
        billToState: billToState ?? this.billToState,
        billToZipCode: billToZipCode ?? this.billToZipCode,
        billToCountryId: billToCountryId ?? this.billToCountryId,
        billToCountry: billToCountry ?? this.billToCountry,
        discountReasonId: discountReasonId ?? this.discountReasonId,
        discountReason: discountReason ?? this.discountReason,
        requireContactConfirmation:
            requireContactConfirmation ?? this.requireContactConfirmation,
        includeInBillingAnalysis:
            includeInBillingAnalysis ?? this.includeInBillingAnalysis,
        hiatusDiscountFrom: hiatusDiscountFrom ?? this.hiatusDiscountFrom,
        roundTripRentals: roundTripRentals ?? this.roundTripRentals,
        inGroup: inGroup ?? this.inGroup,
        groupNumber: groupNumber ?? this.groupNumber,
        groupColor: groupColor ?? this.groupColor,
        groupOrderBy: groupOrderBy ?? this.groupOrderBy,
        coverLetterId: coverLetterId ?? this.coverLetterId,
        coverLetter: coverLetter ?? this.coverLetter,
        termsConditionsId: termsConditionsId ?? this.termsConditionsId,
        termsConditions: termsConditions ?? this.termsConditions,
        outsideSalesRepresentativeId:
            outsideSalesRepresentativeId ?? this.outsideSalesRepresentativeId,
        outsideSalesRepresentative:
            outsideSalesRepresentative ?? this.outsideSalesRepresentative,
        marketTypeId: marketTypeId ?? this.marketTypeId,
        marketType: marketType ?? this.marketType,
        marketSegmentId: marketSegmentId ?? this.marketSegmentId,
        marketSegment: marketSegment ?? this.marketSegment,
        marketSegmentJobId: marketSegmentJobId ?? this.marketSegmentJobId,
        marketSegmentJob: marketSegmentJob ?? this.marketSegmentJob,
        outDeliveryId: outDeliveryId ?? this.outDeliveryId,
        outDeliveryDeliveryType:
            outDeliveryDeliveryType ?? this.outDeliveryDeliveryType,
        outDeliveryRequiredDate:
            outDeliveryRequiredDate ?? this.outDeliveryRequiredDate,
        outDeliveryRequiredTime:
            outDeliveryRequiredTime ?? this.outDeliveryRequiredTime,
        outDeliveryTargetShipDate:
            outDeliveryTargetShipDate ?? this.outDeliveryTargetShipDate,
        outDeliveryTargetShipTime:
            outDeliveryTargetShipTime ?? this.outDeliveryTargetShipTime,
        outDeliveryDirection: outDeliveryDirection ?? this.outDeliveryDirection,
        outDeliveryAddressType:
            outDeliveryAddressType ?? this.outDeliveryAddressType,
        outDeliveryFromLocation:
            outDeliveryFromLocation ?? this.outDeliveryFromLocation,
        outDeliveryFromContact:
            outDeliveryFromContact ?? this.outDeliveryFromContact,
        outDeliveryFromContactPhone:
            outDeliveryFromContactPhone ?? this.outDeliveryFromContactPhone,
        outDeliveryFromAlternateContact: outDeliveryFromAlternateContact ??
            this.outDeliveryFromAlternateContact,
        outDeliveryFromAlternateContactPhone: outDeliveryFromAlternateContactPhone ??
            this.outDeliveryFromAlternateContactPhone,
        outDeliveryFromAttention:
            outDeliveryFromAttention ?? this.outDeliveryFromAttention,
        outDeliveryFromAddress1:
            outDeliveryFromAddress1 ?? this.outDeliveryFromAddress1,
        outDeliveryFromAdd2ress:
            outDeliveryFromAdd2ress ?? this.outDeliveryFromAdd2ress,
        outDeliveryFromCity: outDeliveryFromCity ?? this.outDeliveryFromCity,
        outDeliveryFromState: outDeliveryFromState ?? this.outDeliveryFromState,
        outDeliveryFromZipCode:
            outDeliveryFromZipCode ?? this.outDeliveryFromZipCode,
        outDeliveryFromCountry:
            outDeliveryFromCountry ?? this.outDeliveryFromCountry,
        outDeliveryFromCountryId:
            outDeliveryFromCountryId ?? this.outDeliveryFromCountryId,
        outDeliveryFromCrossStreets:
            outDeliveryFromCrossStreets ?? this.outDeliveryFromCrossStreets,
        outDeliveryToLocation:
            outDeliveryToLocation ?? this.outDeliveryToLocation,
        outDeliveryToContact: outDeliveryToContact ?? this.outDeliveryToContact,
        outDeliveryToContactPhone:
            outDeliveryToContactPhone ?? this.outDeliveryToContactPhone,
        outDeliveryToAlternateContact:
            outDeliveryToAlternateContact ?? this.outDeliveryToAlternateContact,
        outDeliveryToAlternateContactPhone:
            outDeliveryToAlternateContactPhone ?? this.outDeliveryToAlternateContactPhone,
        outDeliveryToAttention: outDeliveryToAttention ?? this.outDeliveryToAttention,
        outDeliveryToAddress1: outDeliveryToAddress1 ?? this.outDeliveryToAddress1,
        outDeliveryToAddress2: outDeliveryToAddress2 ?? this.outDeliveryToAddress2,
        outDeliveryToCity: outDeliveryToCity ?? this.outDeliveryToCity,
        outDeliveryToState: outDeliveryToState ?? this.outDeliveryToState,
        outDeliveryToZipCode: outDeliveryToZipCode ?? this.outDeliveryToZipCode,
        outDeliveryToCountryId: outDeliveryToCountryId ?? this.outDeliveryToCountryId,
        outDeliveryToCountry: outDeliveryToCountry ?? this.outDeliveryToCountry,
        outDeliveryToContactFax: outDeliveryToContactFax ?? this.outDeliveryToContactFax,
        outDeliveryToCrossStreets: outDeliveryToCrossStreets ?? this.outDeliveryToCrossStreets,
        outDeliveryDeliveryNotes: outDeliveryDeliveryNotes ?? this.outDeliveryDeliveryNotes,
        outDeliveryCarrierId: outDeliveryCarrierId ?? this.outDeliveryCarrierId,
        outDeliveryCarrier: outDeliveryCarrier ?? this.outDeliveryCarrier,
        outDeliveryCarrierAccount: outDeliveryCarrierAccount ?? this.outDeliveryCarrierAccount,
        outDeliveryShipViaId: outDeliveryShipViaId ?? this.outDeliveryShipViaId,
        outDeliveryShipVia: outDeliveryShipVia ?? this.outDeliveryShipVia,
        outDeliveryInvoiceId: outDeliveryInvoiceId ?? this.outDeliveryInvoiceId,
        outDeliveryVendorInvoiceId: outDeliveryVendorInvoiceId ?? this.outDeliveryVendorInvoiceId,
        outDeliveryEstimatedFreight: outDeliveryEstimatedFreight ?? this.outDeliveryEstimatedFreight,
        outDeliveryFreightInvoiceAmount: outDeliveryFreightInvoiceAmount ?? this.outDeliveryFreightInvoiceAmount,
        outDeliveryChargeType: outDeliveryChargeType ?? this.outDeliveryChargeType,
        outDeliveryFreightTrackingNumber: outDeliveryFreightTrackingNumber ?? this.outDeliveryFreightTrackingNumber,
        outDeliveryFreightTrackingUrl: outDeliveryFreightTrackingUrl ?? this.outDeliveryFreightTrackingUrl,
        outDeliveryPackageCode: outDeliveryPackageCode ?? this.outDeliveryPackageCode,
        outDeliveryBillPoFreightOnOrder: outDeliveryBillPoFreightOnOrder ?? this.outDeliveryBillPoFreightOnOrder,
        outDeliveryOnlineOrderNumber: outDeliveryOnlineOrderNumber ?? this.outDeliveryOnlineOrderNumber,
        outDeliveryToVenue: outDeliveryToVenue ?? this.outDeliveryToVenue,
        outDeliveryToVenueId: outDeliveryToVenueId ?? this.outDeliveryToVenueId,
        outDeliveryToWarehouse: outDeliveryToWarehouse ?? this.outDeliveryToWarehouse,
        outDeliveryToWarehouseId: outDeliveryToWarehouseId ?? this.outDeliveryToWarehouseId,
        outDeliveryDateStamp: outDeliveryDateStamp ?? this.outDeliveryDateStamp,
        inDeliveryId: inDeliveryId ?? this.inDeliveryId,
        inDeliveryDeliveryType: inDeliveryDeliveryType ?? this.inDeliveryDeliveryType,
        inDeliveryRequiredDate: inDeliveryRequiredDate ?? this.inDeliveryRequiredDate,
        inDeliveryRequiredTime: inDeliveryRequiredTime ?? this.inDeliveryRequiredTime,
        inDeliveryTargetShipDate: inDeliveryTargetShipDate ?? this.inDeliveryTargetShipDate,
        inDeliveryTargetShipTime: inDeliveryTargetShipTime ?? this.inDeliveryTargetShipTime,
        inDeliveryDirection: inDeliveryDirection ?? this.inDeliveryDirection,
        inDeliveryAddressType: inDeliveryAddressType ?? this.inDeliveryAddressType,
        inDeliveryFromLocation: inDeliveryFromLocation ?? this.inDeliveryFromLocation,
        inDeliveryFromContact: inDeliveryFromContact ?? this.inDeliveryFromContact,
        inDeliveryFromContactPhone: inDeliveryFromContactPhone ?? this.inDeliveryFromContactPhone,
        inDeliveryFromAlternateContact: inDeliveryFromAlternateContact ?? this.inDeliveryFromAlternateContact,
        inDeliveryFromAlternateContactPhone: inDeliveryFromAlternateContactPhone ?? this.inDeliveryFromAlternateContactPhone,
        inDeliveryFromAttention: inDeliveryFromAttention ?? this.inDeliveryFromAttention,
        inDeliveryFromAddress1: inDeliveryFromAddress1 ?? this.inDeliveryFromAddress1,
        inDeliveryFromAdd2ress: inDeliveryFromAdd2ress ?? this.inDeliveryFromAdd2ress,
        inDeliveryFromCity: inDeliveryFromCity ?? this.inDeliveryFromCity,
        inDeliveryFromState: inDeliveryFromState ?? this.inDeliveryFromState,
        inDeliveryFromZipCode: inDeliveryFromZipCode ?? this.inDeliveryFromZipCode,
        inDeliveryFromCountry: inDeliveryFromCountry ?? this.inDeliveryFromCountry,
        inDeliveryFromCountryId: inDeliveryFromCountryId ?? this.inDeliveryFromCountryId,
        inDeliveryFromCrossStreets: inDeliveryFromCrossStreets ?? this.inDeliveryFromCrossStreets,
        inDeliveryToLocation: inDeliveryToLocation ?? this.inDeliveryToLocation,
        inDeliveryToContact: inDeliveryToContact ?? this.inDeliveryToContact,
        inDeliveryToContactPhone: inDeliveryToContactPhone ?? this.inDeliveryToContactPhone,
        inDeliveryToAlternateContact: inDeliveryToAlternateContact ?? this.inDeliveryToAlternateContact,
        inDeliveryToAlternateContactPhone: inDeliveryToAlternateContactPhone ?? this.inDeliveryToAlternateContactPhone,
        inDeliveryToAttention: inDeliveryToAttention ?? this.inDeliveryToAttention,
        inDeliveryToAddress1: inDeliveryToAddress1 ?? this.inDeliveryToAddress1,
        inDeliveryToAddress2: inDeliveryToAddress2 ?? this.inDeliveryToAddress2,
        inDeliveryToCity: inDeliveryToCity ?? this.inDeliveryToCity,
        inDeliveryToState: inDeliveryToState ?? this.inDeliveryToState,
        inDeliveryToZipCode: inDeliveryToZipCode ?? this.inDeliveryToZipCode,
        inDeliveryToCountryId: inDeliveryToCountryId ?? this.inDeliveryToCountryId,
        inDeliveryToCountry: inDeliveryToCountry ?? this.inDeliveryToCountry,
        inDeliveryToContactFax: inDeliveryToContactFax ?? this.inDeliveryToContactFax,
        inDeliveryToCrossStreets: inDeliveryToCrossStreets ?? this.inDeliveryToCrossStreets,
        inDeliveryDeliveryNotes: inDeliveryDeliveryNotes ?? this.inDeliveryDeliveryNotes,
        inDeliveryCarrierId: inDeliveryCarrierId ?? this.inDeliveryCarrierId,
        inDeliveryCarrier: inDeliveryCarrier ?? this.inDeliveryCarrier,
        inDeliveryCarrierAccount: inDeliveryCarrierAccount ?? this.inDeliveryCarrierAccount,
        inDeliveryShipViaId: inDeliveryShipViaId ?? this.inDeliveryShipViaId,
        inDeliveryShipVia: inDeliveryShipVia ?? this.inDeliveryShipVia,
        inDeliveryInvoiceId: inDeliveryInvoiceId ?? this.inDeliveryInvoiceId,
        inDeliveryVendorInvoiceId: inDeliveryVendorInvoiceId ?? this.inDeliveryVendorInvoiceId,
        inDeliveryEstimatedFreight: inDeliveryEstimatedFreight ?? this.inDeliveryEstimatedFreight,
        inDeliveryFreightInvoiceAmount: inDeliveryFreightInvoiceAmount ?? this.inDeliveryFreightInvoiceAmount,
        inDeliveryChargeType: inDeliveryChargeType ?? this.inDeliveryChargeType,
        inDeliveryFreightTrackingNumber: inDeliveryFreightTrackingNumber ?? this.inDeliveryFreightTrackingNumber,
        inDeliveryFreightTrackingUrl: inDeliveryFreightTrackingUrl ?? this.inDeliveryFreightTrackingUrl,
        inDeliveryPackageCode: inDeliveryPackageCode ?? this.inDeliveryPackageCode,
        inDeliveryBillPoFreightOnOrder: inDeliveryBillPoFreightOnOrder ?? this.inDeliveryBillPoFreightOnOrder,
        inDeliveryOnlineOrderNumber: inDeliveryOnlineOrderNumber ?? this.inDeliveryOnlineOrderNumber,
        inDeliveryOnlineOrderStatus: inDeliveryOnlineOrderStatus ?? this.inDeliveryOnlineOrderStatus,
        inDeliveryToVenue: inDeliveryToVenue ?? this.inDeliveryToVenue,
        inDeliveryToVenueId: inDeliveryToVenueId ?? this.inDeliveryToVenueId,
        inDeliveryToWarehouse: inDeliveryToWarehouse ?? this.inDeliveryToWarehouse,
        inDeliveryToWarehouseId: inDeliveryToWarehouseId ?? this.inDeliveryToWarehouseId,
        inDeliveryDateStamp: inDeliveryDateStamp ?? this.inDeliveryDateStamp,
        rentalDaysPerWeek: rentalDaysPerWeek ?? this.rentalDaysPerWeek,
        rentalDiscountPercent: rentalDiscountPercent ?? this.rentalDiscountPercent,
        weeklyRentalTotal: weeklyRentalTotal ?? this.weeklyRentalTotal,
        monthlyRentalTotal: monthlyRentalTotal ?? this.monthlyRentalTotal,
        periodRentalTotal: periodRentalTotal ?? this.periodRentalTotal,
        weeklyRentalTotalIncludesTax: weeklyRentalTotalIncludesTax ?? this.weeklyRentalTotalIncludesTax,
        monthlyRentalTotalIncludesTax: monthlyRentalTotalIncludesTax ?? this.monthlyRentalTotalIncludesTax,
        periodRentalTotalIncludesTax: periodRentalTotalIncludesTax ?? this.periodRentalTotalIncludesTax,
        billLockedTotal: billLockedTotal ?? this.billLockedTotal,
        salesDiscountPercent: salesDiscountPercent ?? this.salesDiscountPercent,
        salesTotal: salesTotal ?? this.salesTotal,
        salesTotalIncludesTax: salesTotalIncludesTax ?? this.salesTotalIncludesTax,
        partsDiscountPercent: partsDiscountPercent ?? this.partsDiscountPercent,
        partsTotal: partsTotal ?? this.partsTotal,
        partsTotalIncludesTax: partsTotalIncludesTax ?? this.partsTotalIncludesTax,
        spaceDaysPerWeek: spaceDaysPerWeek ?? this.spaceDaysPerWeek,
        spaceDiscountPercent: spaceDiscountPercent ?? this.spaceDiscountPercent,
        spaceSplitPercent: spaceSplitPercent ?? this.spaceSplitPercent,
        weeklySpaceTotal: weeklySpaceTotal ?? this.weeklySpaceTotal,
        monthlySpaceTotal: monthlySpaceTotal ?? this.monthlySpaceTotal,
        periodSpaceTotal: periodSpaceTotal ?? this.periodSpaceTotal,
        weeklySpaceTotalIncludesTax: weeklySpaceTotalIncludesTax ?? this.weeklySpaceTotalIncludesTax,
        monthlySpaceTotalIncludesTax: monthlySpaceTotalIncludesTax ?? this.monthlySpaceTotalIncludesTax,
        periodSpaceTotalIncludesTax: periodSpaceTotalIncludesTax ?? this.periodSpaceTotalIncludesTax,
        vehicleDaysPerWeek: vehicleDaysPerWeek ?? this.vehicleDaysPerWeek,
        vehicleDiscountPercent: vehicleDiscountPercent ?? this.vehicleDiscountPercent,
        weeklyVehicleTotal: weeklyVehicleTotal ?? this.weeklyVehicleTotal,
        monthlyVehicleTotal: monthlyVehicleTotal ?? this.monthlyVehicleTotal,
        periodVehicleTotal: periodVehicleTotal ?? this.periodVehicleTotal,
        weeklyVehicleTotalIncludesTax: weeklyVehicleTotalIncludesTax ?? this.weeklyVehicleTotalIncludesTax,
        monthlyVehicleTotalIncludesTax: monthlyVehicleTotalIncludesTax ?? this.monthlyVehicleTotalIncludesTax,
        periodVehicleTotalIncludesTax: periodVehicleTotalIncludesTax ?? this.periodVehicleTotalIncludesTax,
        miscDiscountPercent: miscDiscountPercent ?? this.miscDiscountPercent,
        weeklyMiscTotal: weeklyMiscTotal ?? this.weeklyMiscTotal,
        monthlyMiscTotal: monthlyMiscTotal ?? this.monthlyMiscTotal,
        periodMiscTotal: periodMiscTotal ?? this.periodMiscTotal,
        weeklyMiscTotalIncludesTax: weeklyMiscTotalIncludesTax ?? this.weeklyMiscTotalIncludesTax,
        monthlyMiscTotalIncludesTax: monthlyMiscTotalIncludesTax ?? this.monthlyMiscTotalIncludesTax,
        periodMiscTotalIncludesTax: periodMiscTotalIncludesTax ?? this.periodMiscTotalIncludesTax,
        laborDiscountPercent: laborDiscountPercent ?? this.laborDiscountPercent,
        weeklyLaborTotal: weeklyLaborTotal ?? this.weeklyLaborTotal,
        monthlyLaborTotal: monthlyLaborTotal ?? this.monthlyLaborTotal,
        periodLaborTotal: periodLaborTotal ?? this.periodLaborTotal,
        weeklyLaborTotalIncludesTax: weeklyLaborTotalIncludesTax ?? this.weeklyLaborTotalIncludesTax,
        monthlyLaborTotalIncludesTax: monthlyLaborTotalIncludesTax ?? this.monthlyLaborTotalIncludesTax,
        periodLaborTotalIncludesTax: periodLaborTotalIncludesTax ?? this.periodLaborTotalIncludesTax,
        rentalSaleDiscountPercent: rentalSaleDiscountPercent ?? this.rentalSaleDiscountPercent,
        rentalSaleTotal: rentalSaleTotal ?? this.rentalSaleTotal,
        rentalSaleTotalIncludesTax: rentalSaleTotalIncludesTax ?? this.rentalSaleTotalIncludesTax,
        lossAndDamageDiscountPercent: lossAndDamageDiscountPercent ?? this.lossAndDamageDiscountPercent,
        lossAndDamageTotal: lossAndDamageTotal ?? this.lossAndDamageTotal,
        lossAndDamageTotalIncludesTax: lossAndDamageTotalIncludesTax ?? this.lossAndDamageTotalIncludesTax,
        combinedDaysPerWeek: combinedDaysPerWeek ?? this.combinedDaysPerWeek,
        combinedDiscountPercent: combinedDiscountPercent ?? this.combinedDiscountPercent,
        weeklyCombinedTotal: weeklyCombinedTotal ?? this.weeklyCombinedTotal,
        monthlyCombinedTotal: monthlyCombinedTotal ?? this.monthlyCombinedTotal,
        periodCombinedTotal: periodCombinedTotal ?? this.periodCombinedTotal,
        weeklyCombinedTotalIncludesTax: weeklyCombinedTotalIncludesTax ?? this.weeklyCombinedTotalIncludesTax,
        monthlyCombinedTotalIncludesTax: monthlyCombinedTotalIncludesTax ?? this.monthlyCombinedTotalIncludesTax,
        periodCombinedTotalIncludesTax: periodCombinedTotalIncludesTax ?? this.periodCombinedTotalIncludesTax,
        disableEditingRentalRate: disableEditingRentalRate ?? this.disableEditingRentalRate,
        disableEditingSalesRate: disableEditingSalesRate ?? this.disableEditingSalesRate,
        disableEditingMiscellaneousRate: disableEditingMiscellaneousRate ?? this.disableEditingMiscellaneousRate,
        disableEditingLaborRate: disableEditingLaborRate ?? this.disableEditingLaborRate,
        disableEditingRentalSaleRate: disableEditingRentalSaleRate ?? this.disableEditingRentalSaleRate,
        disableEditingLossAndDamageRate: disableEditingLossAndDamageRate ?? this.disableEditingLossAndDamageRate,
        rentalExtendedTotal: rentalExtendedTotal ?? this.rentalExtendedTotal,
        salesExtendedTotal: salesExtendedTotal ?? this.salesExtendedTotal,
        laborExtendedTotal: laborExtendedTotal ?? this.laborExtendedTotal,
        miscellaneousExtendedTotal: miscellaneousExtendedTotal ?? this.miscellaneousExtendedTotal,
        rentalSaleExtendedTotal: rentalSaleExtendedTotal ?? this.rentalSaleExtendedTotal,
        lossAndDamageExtendedTotal: lossAndDamageExtendedTotal ?? this.lossAndDamageExtendedTotal,
        hasNotes: hasNotes ?? this.hasNotes,
        hasDocuments: hasDocuments ?? this.hasDocuments,
        hasEmailHistory: hasEmailHistory ?? this.hasEmailHistory,
        hasContacts: hasContacts ?? this.hasContacts,
        hasSubPurchaseOrders: hasSubPurchaseOrders ?? this.hasSubPurchaseOrders,
        hasPickLists: hasPickLists ?? this.hasPickLists,
        hasContracts: hasContracts ?? this.hasContracts,
        hasSuspendedContracts: hasSuspendedContracts ?? this.hasSuspendedContracts,
        hasMultiOrderContracts: hasMultiOrderContracts ?? this.hasMultiOrderContracts,
        hasInvoices: hasInvoices ?? this.hasInvoices,
        hasBillingWorksheets: hasBillingWorksheets ?? this.hasBillingWorksheets,
        hasMultiOrderInvoices: hasMultiOrderInvoices ?? this.hasMultiOrderInvoices,
        totalReplacementCost: totalReplacementCost ?? this.totalReplacementCost,
        presentationLayerId: presentationLayerId ?? this.presentationLayerId,
        presentationLayer: presentationLayer ?? this.presentationLayer,
        isManualSort: isManualSort ?? this.isManualSort,
        quoteOrderTitle: quoteOrderTitle ?? this.quoteOrderTitle,
        unassignedSubs: unassignedSubs ?? this.unassignedSubs,
        nonTaxable: nonTaxable ?? this.nonTaxable,
        enableProjects: enableProjects ?? this.enableProjects,
        projectId: projectId ?? this.projectId,
        projectNumber: projectNumber ?? this.projectNumber,
        project: project ?? this.project,
        projectDrawingsId: projectDrawingsId ?? this.projectDrawingsId,
        projectDrawings: projectDrawings ?? this.projectDrawings,
        projectItemsOrderedId: projectItemsOrderedId ?? this.projectItemsOrderedId,
        projectItemsOrdered: projectItemsOrdered ?? this.projectItemsOrdered,
        projectDropShipId: projectDropShipId ?? this.projectDropShipId,
        projectDropShip: projectDropShip ?? this.projectDropShip,
        projectAsBuildId: projectAsBuildId ?? this.projectAsBuildId,
        projectAsBuild: projectAsBuild ?? this.projectAsBuild,
        projectCommissioningId: projectCommissioningId ?? this.projectCommissioningId,
        projectCommissioning: projectCommissioning ?? this.projectCommissioning,
        projectDepositId: projectDepositId ?? this.projectDepositId,
        projectDeposit: projectDeposit ?? this.projectDeposit,
        inputByUserId: inputByUserId ?? this.inputByUserId,
        modifiedByUserId: modifiedByUserId ?? this.modifiedByUserId,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        items: items ?? this.items,
        custom: custom ?? this.custom,
        defaultFieldAttributes: defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderModifyPoWorksheetSessionRequest {
  WebApiModulesAgentOrderModifyPoWorksheetSessionRequest({
    this.orderId,
    this.purchaseOrderId,
    this.recType,
  });

  factory WebApiModulesAgentOrderModifyPoWorksheetSessionRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderModifyPoWorksheetSessionRequestFromJson(json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'RecType')
  final String? recType;
  static const fromJsonFactory =
      _$WebApiModulesAgentOrderModifyPoWorksheetSessionRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentOrderModifyPoWorksheetSessionRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderModifyPoWorksheetSessionRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderModifyPoWorksheetSessionRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.recType, recType) ||
                const DeepCollectionEquality().equals(other.recType, recType)));
  }
}

extension $WebApiModulesAgentOrderModifyPoWorksheetSessionRequestExtension
    on WebApiModulesAgentOrderModifyPoWorksheetSessionRequest {
  WebApiModulesAgentOrderModifyPoWorksheetSessionRequest copyWith(
      {String? orderId, String? purchaseOrderId, String? recType}) {
    return WebApiModulesAgentOrderModifyPoWorksheetSessionRequest(
        orderId: orderId ?? this.orderId,
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        recType: recType ?? this.recType);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderModifyPoWorksheetSessionResponse {
  WebApiModulesAgentOrderModifyPoWorksheetSessionResponse({
    this.sessionId,
    this.vendorId,
    this.vendor,
    this.contactId,
    this.contact,
    this.rateType,
    this.billingCycleId,
    this.billingCycle,
    this.requiredDate,
    this.requiredTime,
    this.fromDate,
    this.toDate,
    this.deliveryId,
    this.adjustContractDates,
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesAgentOrderModifyPoWorksheetSessionResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderModifyPoWorksheetSessionResponseFromJson(json);

  @JsonKey(name: 'SessionId')
  final String? sessionId;
  @JsonKey(name: 'VendorId')
  final String? vendorId;
  @JsonKey(name: 'Vendor')
  final String? vendor;
  @JsonKey(name: 'ContactId')
  final String? contactId;
  @JsonKey(name: 'Contact')
  final String? contact;
  @JsonKey(name: 'RateType')
  final String? rateType;
  @JsonKey(name: 'BillingCycleId')
  final String? billingCycleId;
  @JsonKey(name: 'BillingCycle')
  final String? billingCycle;
  @JsonKey(name: 'RequiredDate')
  final DateTime? requiredDate;
  @JsonKey(name: 'RequiredTime')
  final String? requiredTime;
  @JsonKey(name: 'FromDate')
  final DateTime? fromDate;
  @JsonKey(name: 'ToDate')
  final DateTime? toDate;
  @JsonKey(name: 'DeliveryId')
  final String? deliveryId;
  @JsonKey(name: 'AdjustContractDates')
  final bool? adjustContractDates;
  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesAgentOrderModifyPoWorksheetSessionResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentOrderModifyPoWorksheetSessionResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderModifyPoWorksheetSessionResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderModifyPoWorksheetSessionResponse &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)) &&
            (identical(other.vendorId, vendorId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorId, vendorId)) &&
            (identical(other.vendor, vendor) ||
                const DeepCollectionEquality().equals(other.vendor, vendor)) &&
            (identical(other.contactId, contactId) ||
                const DeepCollectionEquality()
                    .equals(other.contactId, contactId)) &&
            (identical(other.contact, contact) ||
                const DeepCollectionEquality()
                    .equals(other.contact, contact)) &&
            (identical(other.rateType, rateType) ||
                const DeepCollectionEquality()
                    .equals(other.rateType, rateType)) &&
            (identical(other.billingCycleId, billingCycleId) ||
                const DeepCollectionEquality()
                    .equals(other.billingCycleId, billingCycleId)) &&
            (identical(other.billingCycle, billingCycle) ||
                const DeepCollectionEquality()
                    .equals(other.billingCycle, billingCycle)) &&
            (identical(other.requiredDate, requiredDate) ||
                const DeepCollectionEquality()
                    .equals(other.requiredDate, requiredDate)) &&
            (identical(other.requiredTime, requiredTime) ||
                const DeepCollectionEquality()
                    .equals(other.requiredTime, requiredTime)) &&
            (identical(other.fromDate, fromDate) ||
                const DeepCollectionEquality()
                    .equals(other.fromDate, fromDate)) &&
            (identical(other.toDate, toDate) ||
                const DeepCollectionEquality().equals(other.toDate, toDate)) &&
            (identical(other.deliveryId, deliveryId) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryId, deliveryId)) &&
            (identical(other.adjustContractDates, adjustContractDates) ||
                const DeepCollectionEquality()
                    .equals(other.adjustContractDates, adjustContractDates)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesAgentOrderModifyPoWorksheetSessionResponseExtension
    on WebApiModulesAgentOrderModifyPoWorksheetSessionResponse {
  WebApiModulesAgentOrderModifyPoWorksheetSessionResponse copyWith(
      {String? sessionId,
      String? vendorId,
      String? vendor,
      String? contactId,
      String? contact,
      String? rateType,
      String? billingCycleId,
      String? billingCycle,
      DateTime? requiredDate,
      String? requiredTime,
      DateTime? fromDate,
      DateTime? toDate,
      String? deliveryId,
      bool? adjustContractDates,
      int? status,
      bool? success,
      String? msg}) {
    return WebApiModulesAgentOrderModifyPoWorksheetSessionResponse(
        sessionId: sessionId ?? this.sessionId,
        vendorId: vendorId ?? this.vendorId,
        vendor: vendor ?? this.vendor,
        contactId: contactId ?? this.contactId,
        contact: contact ?? this.contact,
        rateType: rateType ?? this.rateType,
        billingCycleId: billingCycleId ?? this.billingCycleId,
        billingCycle: billingCycle ?? this.billingCycle,
        requiredDate: requiredDate ?? this.requiredDate,
        requiredTime: requiredTime ?? this.requiredTime,
        fromDate: fromDate ?? this.fromDate,
        toDate: toDate ?? this.toDate,
        deliveryId: deliveryId ?? this.deliveryId,
        adjustContractDates: adjustContractDates ?? this.adjustContractDates,
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderOrder {
  WebApiModulesAgentOrderOrder({
    this.orderId,
    this.orderNumber,
    this.orderDate,
    this.sourceQuoteId,
    this.sourceQuoteNumber,
    this.description,
    this.officeLocationId,
    this.officeLocation,
    this.warehouseId,
    this.warehouse,
    this.warehouseCode,
    this.departmentId,
    this.department,
    this.customerId,
    this.customer,
    this.customerNumber,
    this.dealId,
    this.deal,
    this.dealNumber,
    this.rateType,
    this.rateTypeDisplay,
    this.agentId,
    this.agent,
    this.projectManagerId,
    this.projectManager,
    this.rental,
    this.sales,
    this.miscellaneous,
    this.labor,
    this.facilities,
    this.transportation,
    this.rentalSale,
    this.lossAndDamage,
    this.repair,
    this.hasRentalItem,
    this.hasSalesItem,
    this.hasMiscellaneousItem,
    this.hasLaborItem,
    this.hasFacilitiesItem,
    this.hasLossAndDamageItem,
    this.hasRentalSaleItem,
    this.hasRepair,
    this.activityDatesAndTimes,
    this.pickDate,
    this.pickTime,
    this.estimatedStartDate,
    this.estimatedStartTime,
    this.estimatedStopDate,
    this.estimatedStopTime,
    this.pickUpDate,
    this.pickUpTime,
    this.prepDate,
    this.prepTime,
    this.loadInDate,
    this.loadInTime,
    this.strikeDate,
    this.strikeTime,
    this.testDate,
    this.testTime,
    this.orderTypeId,
    this.orderType,
    this.orderTypeCombineActivityTabs,
    this.flatPo,
    this.pendingPo,
    this.poNumber,
    this.poAmount,
    this.location,
    this.orderLocationId,
    this.orderLocation,
    this.referenceNumber,
    this.total,
    this.status,
    this.statusDate,
    this.poApprovalStatusId,
    this.lockBillingDates,
    this.specifyBillingDatesByType,
    this.rentalBillingStartDate,
    this.rentalBillingEndDate,
    this.laborBillingStartDate,
    this.laborBillingEndDate,
    this.miscellaneousBillingStartDate,
    this.miscellaneousBillingEndDate,
    this.facilitiesBillingStartDate,
    this.facilitiesBillingEndDate,
    this.vehicleBillingStartDate,
    this.vehicleBillingEndDate,
    this.delayBillingSearchUntil,
    this.includePrepFeesInRentalRate,
    this.billingStartDate,
    this.billingEndDate,
    this.billingWeeks,
    this.billingMonths,
    this.determineQuantitiesToBillBasedOn,
    this.billingCycleId,
    this.billingCycle,
    this.billingCycleType,
    this.paymentTermsId,
    this.paymentTerms,
    this.paymentTypeId,
    this.paymentType,
    this.currencyId,
    this.updateAllRatesToNewCurrency,
    this.confirmUpdateAllRatesToNewCurrency,
    this.currencyCode,
    this.currency,
    this.currencySymbol,
    this.taxOptionId,
    this.taxOption,
    this.tax1Name,
    this.tax2Name,
    this.taxId,
    this.rentalTaxRate1,
    this.salesTaxRate1,
    this.laborTaxRate1,
    this.rentalTaxRate2,
    this.salesTaxRate2,
    this.laborTaxRate2,
    this.noCharge,
    this.noChargeReason,
    this.printIssuedToAddressFrom,
    this.issuedToName,
    this.issuedToAttention,
    this.issuedToAttention2,
    this.issuedToAddress1,
    this.issuedToAddress2,
    this.issuedToCity,
    this.issuedToState,
    this.issuedToZipCode,
    this.issuedToCountryId,
    this.issuedToCountry,
    this.billToAddressDifferentFromIssuedToAddress,
    this.billToAddressId,
    this.billToName,
    this.billToAttention,
    this.billToAttention2,
    this.billToAddress1,
    this.billToAddress2,
    this.billToCity,
    this.billToState,
    this.billToZipCode,
    this.billToCountryId,
    this.billToCountry,
    this.discountReasonId,
    this.discountReason,
    this.requireContactConfirmation,
    this.includeInBillingAnalysis,
    this.hiatusDiscountFrom,
    this.roundTripRentals,
    this.inGroup,
    this.groupNumber,
    this.groupColor,
    this.groupOrderBy,
    this.coverLetterId,
    this.coverLetter,
    this.termsConditionsId,
    this.termsConditions,
    this.outsideSalesRepresentativeId,
    this.outsideSalesRepresentative,
    this.marketTypeId,
    this.marketType,
    this.marketSegmentId,
    this.marketSegment,
    this.marketSegmentJobId,
    this.marketSegmentJob,
    this.outDeliveryId,
    this.outDeliveryDeliveryType,
    this.outDeliveryRequiredDate,
    this.outDeliveryRequiredTime,
    this.outDeliveryTargetShipDate,
    this.outDeliveryTargetShipTime,
    this.outDeliveryDirection,
    this.outDeliveryAddressType,
    this.outDeliveryFromLocation,
    this.outDeliveryFromContact,
    this.outDeliveryFromContactPhone,
    this.outDeliveryFromAlternateContact,
    this.outDeliveryFromAlternateContactPhone,
    this.outDeliveryFromAttention,
    this.outDeliveryFromAddress1,
    this.outDeliveryFromAdd2ress,
    this.outDeliveryFromCity,
    this.outDeliveryFromState,
    this.outDeliveryFromZipCode,
    this.outDeliveryFromCountry,
    this.outDeliveryFromCountryId,
    this.outDeliveryFromCrossStreets,
    this.outDeliveryToLocation,
    this.outDeliveryToContact,
    this.outDeliveryToContactPhone,
    this.outDeliveryToAlternateContact,
    this.outDeliveryToAlternateContactPhone,
    this.outDeliveryToAttention,
    this.outDeliveryToAddress1,
    this.outDeliveryToAddress2,
    this.outDeliveryToCity,
    this.outDeliveryToState,
    this.outDeliveryToZipCode,
    this.outDeliveryToCountryId,
    this.outDeliveryToCountry,
    this.outDeliveryToContactFax,
    this.outDeliveryToCrossStreets,
    this.outDeliveryDeliveryNotes,
    this.outDeliveryCarrierId,
    this.outDeliveryCarrier,
    this.outDeliveryCarrierAccount,
    this.outDeliveryShipViaId,
    this.outDeliveryShipVia,
    this.outDeliveryInvoiceId,
    this.outDeliveryVendorInvoiceId,
    this.outDeliveryEstimatedFreight,
    this.outDeliveryFreightInvoiceAmount,
    this.outDeliveryChargeType,
    this.outDeliveryFreightTrackingNumber,
    this.outDeliveryFreightTrackingUrl,
    this.outDeliveryPackageCode,
    this.outDeliveryBillPoFreightOnOrder,
    this.outDeliveryOnlineOrderNumber,
    this.outDeliveryToVenue,
    this.outDeliveryToVenueId,
    this.outDeliveryToWarehouse,
    this.outDeliveryToWarehouseId,
    this.outDeliveryDateStamp,
    this.inDeliveryId,
    this.inDeliveryDeliveryType,
    this.inDeliveryRequiredDate,
    this.inDeliveryRequiredTime,
    this.inDeliveryTargetShipDate,
    this.inDeliveryTargetShipTime,
    this.inDeliveryDirection,
    this.inDeliveryAddressType,
    this.inDeliveryFromLocation,
    this.inDeliveryFromContact,
    this.inDeliveryFromContactPhone,
    this.inDeliveryFromAlternateContact,
    this.inDeliveryFromAlternateContactPhone,
    this.inDeliveryFromAttention,
    this.inDeliveryFromAddress1,
    this.inDeliveryFromAdd2ress,
    this.inDeliveryFromCity,
    this.inDeliveryFromState,
    this.inDeliveryFromZipCode,
    this.inDeliveryFromCountry,
    this.inDeliveryFromCountryId,
    this.inDeliveryFromCrossStreets,
    this.inDeliveryToLocation,
    this.inDeliveryToContact,
    this.inDeliveryToContactPhone,
    this.inDeliveryToAlternateContact,
    this.inDeliveryToAlternateContactPhone,
    this.inDeliveryToAttention,
    this.inDeliveryToAddress1,
    this.inDeliveryToAddress2,
    this.inDeliveryToCity,
    this.inDeliveryToState,
    this.inDeliveryToZipCode,
    this.inDeliveryToCountryId,
    this.inDeliveryToCountry,
    this.inDeliveryToContactFax,
    this.inDeliveryToCrossStreets,
    this.inDeliveryDeliveryNotes,
    this.inDeliveryCarrierId,
    this.inDeliveryCarrier,
    this.inDeliveryCarrierAccount,
    this.inDeliveryShipViaId,
    this.inDeliveryShipVia,
    this.inDeliveryInvoiceId,
    this.inDeliveryVendorInvoiceId,
    this.inDeliveryEstimatedFreight,
    this.inDeliveryFreightInvoiceAmount,
    this.inDeliveryChargeType,
    this.inDeliveryFreightTrackingNumber,
    this.inDeliveryFreightTrackingUrl,
    this.inDeliveryPackageCode,
    this.inDeliveryBillPoFreightOnOrder,
    this.inDeliveryOnlineOrderNumber,
    this.inDeliveryOnlineOrderStatus,
    this.inDeliveryToVenue,
    this.inDeliveryToVenueId,
    this.inDeliveryToWarehouse,
    this.inDeliveryToWarehouseId,
    this.inDeliveryDateStamp,
    this.rentalDaysPerWeek,
    this.rentalDiscountPercent,
    this.weeklyRentalTotal,
    this.monthlyRentalTotal,
    this.periodRentalTotal,
    this.weeklyRentalTotalIncludesTax,
    this.monthlyRentalTotalIncludesTax,
    this.periodRentalTotalIncludesTax,
    this.billLockedTotal,
    this.salesDiscountPercent,
    this.salesTotal,
    this.salesTotalIncludesTax,
    this.partsDiscountPercent,
    this.partsTotal,
    this.partsTotalIncludesTax,
    this.spaceDaysPerWeek,
    this.spaceDiscountPercent,
    this.spaceSplitPercent,
    this.weeklySpaceTotal,
    this.monthlySpaceTotal,
    this.periodSpaceTotal,
    this.weeklySpaceTotalIncludesTax,
    this.monthlySpaceTotalIncludesTax,
    this.periodSpaceTotalIncludesTax,
    this.vehicleDaysPerWeek,
    this.vehicleDiscountPercent,
    this.weeklyVehicleTotal,
    this.monthlyVehicleTotal,
    this.periodVehicleTotal,
    this.weeklyVehicleTotalIncludesTax,
    this.monthlyVehicleTotalIncludesTax,
    this.periodVehicleTotalIncludesTax,
    this.miscDiscountPercent,
    this.weeklyMiscTotal,
    this.monthlyMiscTotal,
    this.periodMiscTotal,
    this.weeklyMiscTotalIncludesTax,
    this.monthlyMiscTotalIncludesTax,
    this.periodMiscTotalIncludesTax,
    this.laborDiscountPercent,
    this.weeklyLaborTotal,
    this.monthlyLaborTotal,
    this.periodLaborTotal,
    this.weeklyLaborTotalIncludesTax,
    this.monthlyLaborTotalIncludesTax,
    this.periodLaborTotalIncludesTax,
    this.rentalSaleDiscountPercent,
    this.rentalSaleTotal,
    this.rentalSaleTotalIncludesTax,
    this.lossAndDamageDiscountPercent,
    this.lossAndDamageTotal,
    this.lossAndDamageTotalIncludesTax,
    this.combinedDaysPerWeek,
    this.combinedDiscountPercent,
    this.weeklyCombinedTotal,
    this.monthlyCombinedTotal,
    this.periodCombinedTotal,
    this.weeklyCombinedTotalIncludesTax,
    this.monthlyCombinedTotalIncludesTax,
    this.periodCombinedTotalIncludesTax,
    this.disableEditingRentalRate,
    this.disableEditingSalesRate,
    this.disableEditingMiscellaneousRate,
    this.disableEditingLaborRate,
    this.disableEditingRentalSaleRate,
    this.disableEditingLossAndDamageRate,
    this.rentalExtendedTotal,
    this.salesExtendedTotal,
    this.laborExtendedTotal,
    this.miscellaneousExtendedTotal,
    this.rentalSaleExtendedTotal,
    this.lossAndDamageExtendedTotal,
    this.hasNotes,
    this.hasDocuments,
    this.hasEmailHistory,
    this.hasContacts,
    this.hasSubPurchaseOrders,
    this.hasPickLists,
    this.hasContracts,
    this.hasSuspendedContracts,
    this.hasMultiOrderContracts,
    this.hasInvoices,
    this.hasBillingWorksheets,
    this.hasMultiOrderInvoices,
    this.totalReplacementCost,
    this.presentationLayerId,
    this.presentationLayer,
    this.isManualSort,
    this.quoteOrderTitle,
    this.unassignedSubs,
    this.nonTaxable,
    this.enableProjects,
    this.projectId,
    this.projectNumber,
    this.project,
    this.projectDrawingsId,
    this.projectDrawings,
    this.projectItemsOrderedId,
    this.projectItemsOrdered,
    this.projectDropShipId,
    this.projectDropShip,
    this.projectAsBuildId,
    this.projectAsBuild,
    this.projectCommissioningId,
    this.projectCommissioning,
    this.projectDepositId,
    this.projectDeposit,
    this.inputByUserId,
    this.modifiedByUserId,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAgentOrderOrder.fromJson(Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderOrderFromJson(json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderNumber')
  final String? orderNumber;
  @JsonKey(name: 'OrderDate')
  final String? orderDate;
  @JsonKey(name: 'SourceQuoteId')
  final String? sourceQuoteId;
  @JsonKey(name: 'SourceQuoteNumber')
  final String? sourceQuoteNumber;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'OfficeLocationId')
  final String? officeLocationId;
  @JsonKey(name: 'OfficeLocation')
  final String? officeLocation;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'Department')
  final String? department;
  @JsonKey(name: 'CustomerId')
  final String? customerId;
  @JsonKey(name: 'Customer')
  final String? customer;
  @JsonKey(name: 'CustomerNumber')
  final String? customerNumber;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'Deal')
  final String? deal;
  @JsonKey(name: 'DealNumber')
  final String? dealNumber;
  @JsonKey(name: 'RateType')
  final String? rateType;
  @JsonKey(name: 'RateTypeDisplay')
  final String? rateTypeDisplay;
  @JsonKey(name: 'AgentId')
  final String? agentId;
  @JsonKey(name: 'Agent')
  final String? agent;
  @JsonKey(name: 'ProjectManagerId')
  final String? projectManagerId;
  @JsonKey(name: 'ProjectManager')
  final String? projectManager;
  @JsonKey(name: 'Rental')
  final bool? rental;
  @JsonKey(name: 'Sales')
  final bool? sales;
  @JsonKey(name: 'Miscellaneous')
  final bool? miscellaneous;
  @JsonKey(name: 'Labor')
  final bool? labor;
  @JsonKey(name: 'Facilities')
  final bool? facilities;
  @JsonKey(name: 'Transportation')
  final bool? transportation;
  @JsonKey(name: 'RentalSale')
  final bool? rentalSale;
  @JsonKey(name: 'LossAndDamage')
  final bool? lossAndDamage;
  @JsonKey(name: 'Repair')
  final bool? repair;
  @JsonKey(name: 'HasRentalItem')
  final bool? hasRentalItem;
  @JsonKey(name: 'HasSalesItem')
  final bool? hasSalesItem;
  @JsonKey(name: 'HasMiscellaneousItem')
  final bool? hasMiscellaneousItem;
  @JsonKey(name: 'HasLaborItem')
  final bool? hasLaborItem;
  @JsonKey(name: 'HasFacilitiesItem')
  final bool? hasFacilitiesItem;
  @JsonKey(name: 'HasLossAndDamageItem')
  final bool? hasLossAndDamageItem;
  @JsonKey(name: 'HasRentalSaleItem')
  final bool? hasRentalSaleItem;
  @JsonKey(name: 'HasRepair')
  final bool? hasRepair;
  @JsonKey(
      name: 'ActivityDatesAndTimes',
      defaultValue: <WebApiModulesHomeControlsOrderDatesOrderDates>[])
  final List<WebApiModulesHomeControlsOrderDatesOrderDates>?
      activityDatesAndTimes;
  @JsonKey(name: 'PickDate')
  final String? pickDate;
  @JsonKey(name: 'PickTime')
  final String? pickTime;
  @JsonKey(name: 'EstimatedStartDate')
  final String? estimatedStartDate;
  @JsonKey(name: 'EstimatedStartTime')
  final String? estimatedStartTime;
  @JsonKey(name: 'EstimatedStopDate')
  final String? estimatedStopDate;
  @JsonKey(name: 'EstimatedStopTime')
  final String? estimatedStopTime;
  @JsonKey(name: 'PickUpDate')
  final String? pickUpDate;
  @JsonKey(name: 'PickUpTime')
  final String? pickUpTime;
  @JsonKey(name: 'PrepDate')
  final String? prepDate;
  @JsonKey(name: 'PrepTime')
  final String? prepTime;
  @JsonKey(name: 'LoadInDate')
  final String? loadInDate;
  @JsonKey(name: 'LoadInTime')
  final String? loadInTime;
  @JsonKey(name: 'StrikeDate')
  final String? strikeDate;
  @JsonKey(name: 'StrikeTime')
  final String? strikeTime;
  @JsonKey(name: 'TestDate')
  final String? testDate;
  @JsonKey(name: 'TestTime')
  final String? testTime;
  @JsonKey(name: 'OrderTypeId')
  final String? orderTypeId;
  @JsonKey(name: 'OrderType')
  final String? orderType;
  @JsonKey(name: 'OrderTypeCombineActivityTabs')
  final bool? orderTypeCombineActivityTabs;
  @JsonKey(name: 'FlatPo')
  final bool? flatPo;
  @JsonKey(name: 'PendingPo')
  final bool? pendingPo;
  @JsonKey(name: 'PoNumber')
  final String? poNumber;
  @JsonKey(name: 'PoAmount')
  final double? poAmount;
  @JsonKey(name: 'Location')
  final String? location;
  @JsonKey(name: 'OrderLocationId')
  final String? orderLocationId;
  @JsonKey(name: 'OrderLocation')
  final String? orderLocation;
  @JsonKey(name: 'ReferenceNumber')
  final String? referenceNumber;
  @JsonKey(name: 'Total')
  final double? total;
  @JsonKey(name: 'Status')
  final String? status;
  @JsonKey(name: 'StatusDate')
  final String? statusDate;
  @JsonKey(name: 'PoApprovalStatusId')
  final String? poApprovalStatusId;
  @JsonKey(name: 'LockBillingDates')
  final bool? lockBillingDates;
  @JsonKey(name: 'SpecifyBillingDatesByType')
  final bool? specifyBillingDatesByType;
  @JsonKey(name: 'RentalBillingStartDate')
  final String? rentalBillingStartDate;
  @JsonKey(name: 'RentalBillingEndDate')
  final String? rentalBillingEndDate;
  @JsonKey(name: 'LaborBillingStartDate')
  final String? laborBillingStartDate;
  @JsonKey(name: 'LaborBillingEndDate')
  final String? laborBillingEndDate;
  @JsonKey(name: 'MiscellaneousBillingStartDate')
  final String? miscellaneousBillingStartDate;
  @JsonKey(name: 'MiscellaneousBillingEndDate')
  final String? miscellaneousBillingEndDate;
  @JsonKey(name: 'FacilitiesBillingStartDate')
  final String? facilitiesBillingStartDate;
  @JsonKey(name: 'FacilitiesBillingEndDate')
  final String? facilitiesBillingEndDate;
  @JsonKey(name: 'VehicleBillingStartDate')
  final String? vehicleBillingStartDate;
  @JsonKey(name: 'VehicleBillingEndDate')
  final String? vehicleBillingEndDate;
  @JsonKey(name: 'DelayBillingSearchUntil')
  final String? delayBillingSearchUntil;
  @JsonKey(name: 'IncludePrepFeesInRentalRate')
  final bool? includePrepFeesInRentalRate;
  @JsonKey(name: 'BillingStartDate')
  final String? billingStartDate;
  @JsonKey(name: 'BillingEndDate')
  final String? billingEndDate;
  @JsonKey(name: 'BillingWeeks')
  final double? billingWeeks;
  @JsonKey(name: 'BillingMonths')
  final double? billingMonths;
  @JsonKey(name: 'DetermineQuantitiesToBillBasedOn')
  final String? determineQuantitiesToBillBasedOn;
  @JsonKey(name: 'BillingCycleId')
  final String? billingCycleId;
  @JsonKey(name: 'BillingCycle')
  final String? billingCycle;
  @JsonKey(name: 'BillingCycleType')
  final String? billingCycleType;
  @JsonKey(name: 'PaymentTermsId')
  final String? paymentTermsId;
  @JsonKey(name: 'PaymentTerms')
  final String? paymentTerms;
  @JsonKey(name: 'PaymentTypeId')
  final String? paymentTypeId;
  @JsonKey(name: 'PaymentType')
  final String? paymentType;
  @JsonKey(name: 'CurrencyId')
  final String? currencyId;
  @JsonKey(name: 'UpdateAllRatesToNewCurrency')
  final bool? updateAllRatesToNewCurrency;
  @JsonKey(name: 'ConfirmUpdateAllRatesToNewCurrency')
  final String? confirmUpdateAllRatesToNewCurrency;
  @JsonKey(name: 'CurrencyCode')
  final String? currencyCode;
  @JsonKey(name: 'Currency')
  final String? currency;
  @JsonKey(name: 'CurrencySymbol')
  final String? currencySymbol;
  @JsonKey(name: 'TaxOptionId')
  final String? taxOptionId;
  @JsonKey(name: 'TaxOption')
  final String? taxOption;
  @JsonKey(name: 'Tax1Name')
  final String? tax1Name;
  @JsonKey(name: 'Tax2Name')
  final String? tax2Name;
  @JsonKey(name: 'TaxId')
  final String? taxId;
  @JsonKey(name: 'RentalTaxRate1')
  final double? rentalTaxRate1;
  @JsonKey(name: 'SalesTaxRate1')
  final double? salesTaxRate1;
  @JsonKey(name: 'LaborTaxRate1')
  final double? laborTaxRate1;
  @JsonKey(name: 'RentalTaxRate2')
  final double? rentalTaxRate2;
  @JsonKey(name: 'SalesTaxRate2')
  final double? salesTaxRate2;
  @JsonKey(name: 'LaborTaxRate2')
  final double? laborTaxRate2;
  @JsonKey(name: 'NoCharge')
  final bool? noCharge;
  @JsonKey(name: 'NoChargeReason')
  final String? noChargeReason;
  @JsonKey(name: 'PrintIssuedToAddressFrom')
  final String? printIssuedToAddressFrom;
  @JsonKey(name: 'IssuedToName')
  final String? issuedToName;
  @JsonKey(name: 'IssuedToAttention')
  final String? issuedToAttention;
  @JsonKey(name: 'IssuedToAttention2')
  final String? issuedToAttention2;
  @JsonKey(name: 'IssuedToAddress1')
  final String? issuedToAddress1;
  @JsonKey(name: 'IssuedToAddress2')
  final String? issuedToAddress2;
  @JsonKey(name: 'IssuedToCity')
  final String? issuedToCity;
  @JsonKey(name: 'IssuedToState')
  final String? issuedToState;
  @JsonKey(name: 'IssuedToZipCode')
  final String? issuedToZipCode;
  @JsonKey(name: 'IssuedToCountryId')
  final String? issuedToCountryId;
  @JsonKey(name: 'IssuedToCountry')
  final String? issuedToCountry;
  @JsonKey(name: 'BillToAddressDifferentFromIssuedToAddress')
  final bool? billToAddressDifferentFromIssuedToAddress;
  @JsonKey(name: 'BillToAddressId')
  final String? billToAddressId;
  @JsonKey(name: 'BillToName')
  final String? billToName;
  @JsonKey(name: 'BillToAttention')
  final String? billToAttention;
  @JsonKey(name: 'BillToAttention2')
  final String? billToAttention2;
  @JsonKey(name: 'BillToAddress1')
  final String? billToAddress1;
  @JsonKey(name: 'BillToAddress2')
  final String? billToAddress2;
  @JsonKey(name: 'BillToCity')
  final String? billToCity;
  @JsonKey(name: 'BillToState')
  final String? billToState;
  @JsonKey(name: 'BillToZipCode')
  final String? billToZipCode;
  @JsonKey(name: 'BillToCountryId')
  final String? billToCountryId;
  @JsonKey(name: 'BillToCountry')
  final String? billToCountry;
  @JsonKey(name: 'DiscountReasonId')
  final String? discountReasonId;
  @JsonKey(name: 'DiscountReason')
  final String? discountReason;
  @JsonKey(name: 'RequireContactConfirmation')
  final bool? requireContactConfirmation;
  @JsonKey(name: 'IncludeInBillingAnalysis')
  final bool? includeInBillingAnalysis;
  @JsonKey(name: 'HiatusDiscountFrom')
  final String? hiatusDiscountFrom;
  @JsonKey(name: 'RoundTripRentals')
  final bool? roundTripRentals;
  @JsonKey(name: 'InGroup')
  final bool? inGroup;
  @JsonKey(name: 'GroupNumber')
  final int? groupNumber;
  @JsonKey(name: 'GroupColor')
  final int? groupColor;
  @JsonKey(name: 'GroupOrderBy')
  final double? groupOrderBy;
  @JsonKey(name: 'CoverLetterId')
  final String? coverLetterId;
  @JsonKey(name: 'CoverLetter')
  final String? coverLetter;
  @JsonKey(name: 'TermsConditionsId')
  final String? termsConditionsId;
  @JsonKey(name: 'TermsConditions')
  final String? termsConditions;
  @JsonKey(name: 'OutsideSalesRepresentativeId')
  final String? outsideSalesRepresentativeId;
  @JsonKey(name: 'OutsideSalesRepresentative')
  final String? outsideSalesRepresentative;
  @JsonKey(name: 'MarketTypeId')
  final String? marketTypeId;
  @JsonKey(name: 'MarketType')
  final String? marketType;
  @JsonKey(name: 'MarketSegmentId')
  final String? marketSegmentId;
  @JsonKey(name: 'MarketSegment')
  final String? marketSegment;
  @JsonKey(name: 'MarketSegmentJobId')
  final String? marketSegmentJobId;
  @JsonKey(name: 'MarketSegmentJob')
  final String? marketSegmentJob;
  @JsonKey(name: 'OutDeliveryId')
  final String? outDeliveryId;
  @JsonKey(name: 'OutDeliveryDeliveryType')
  final String? outDeliveryDeliveryType;
  @JsonKey(name: 'OutDeliveryRequiredDate')
  final String? outDeliveryRequiredDate;
  @JsonKey(name: 'OutDeliveryRequiredTime')
  final String? outDeliveryRequiredTime;
  @JsonKey(name: 'OutDeliveryTargetShipDate')
  final String? outDeliveryTargetShipDate;
  @JsonKey(name: 'OutDeliveryTargetShipTime')
  final String? outDeliveryTargetShipTime;
  @JsonKey(name: 'OutDeliveryDirection')
  final String? outDeliveryDirection;
  @JsonKey(name: 'OutDeliveryAddressType')
  final String? outDeliveryAddressType;
  @JsonKey(name: 'OutDeliveryFromLocation')
  final String? outDeliveryFromLocation;
  @JsonKey(name: 'OutDeliveryFromContact')
  final String? outDeliveryFromContact;
  @JsonKey(name: 'OutDeliveryFromContactPhone')
  final String? outDeliveryFromContactPhone;
  @JsonKey(name: 'OutDeliveryFromAlternateContact')
  final String? outDeliveryFromAlternateContact;
  @JsonKey(name: 'OutDeliveryFromAlternateContactPhone')
  final String? outDeliveryFromAlternateContactPhone;
  @JsonKey(name: 'OutDeliveryFromAttention')
  final String? outDeliveryFromAttention;
  @JsonKey(name: 'OutDeliveryFromAddress1')
  final String? outDeliveryFromAddress1;
  @JsonKey(name: 'OutDeliveryFromAdd2ress')
  final String? outDeliveryFromAdd2ress;
  @JsonKey(name: 'OutDeliveryFromCity')
  final String? outDeliveryFromCity;
  @JsonKey(name: 'OutDeliveryFromState')
  final String? outDeliveryFromState;
  @JsonKey(name: 'OutDeliveryFromZipCode')
  final String? outDeliveryFromZipCode;
  @JsonKey(name: 'OutDeliveryFromCountry')
  final String? outDeliveryFromCountry;
  @JsonKey(name: 'OutDeliveryFromCountryId')
  final String? outDeliveryFromCountryId;
  @JsonKey(name: 'OutDeliveryFromCrossStreets')
  final String? outDeliveryFromCrossStreets;
  @JsonKey(name: 'OutDeliveryToLocation')
  final String? outDeliveryToLocation;
  @JsonKey(name: 'OutDeliveryToContact')
  final String? outDeliveryToContact;
  @JsonKey(name: 'OutDeliveryToContactPhone')
  final String? outDeliveryToContactPhone;
  @JsonKey(name: 'OutDeliveryToAlternateContact')
  final String? outDeliveryToAlternateContact;
  @JsonKey(name: 'OutDeliveryToAlternateContactPhone')
  final String? outDeliveryToAlternateContactPhone;
  @JsonKey(name: 'OutDeliveryToAttention')
  final String? outDeliveryToAttention;
  @JsonKey(name: 'OutDeliveryToAddress1')
  final String? outDeliveryToAddress1;
  @JsonKey(name: 'OutDeliveryToAddress2')
  final String? outDeliveryToAddress2;
  @JsonKey(name: 'OutDeliveryToCity')
  final String? outDeliveryToCity;
  @JsonKey(name: 'OutDeliveryToState')
  final String? outDeliveryToState;
  @JsonKey(name: 'OutDeliveryToZipCode')
  final String? outDeliveryToZipCode;
  @JsonKey(name: 'OutDeliveryToCountryId')
  final String? outDeliveryToCountryId;
  @JsonKey(name: 'OutDeliveryToCountry')
  final String? outDeliveryToCountry;
  @JsonKey(name: 'OutDeliveryToContactFax')
  final String? outDeliveryToContactFax;
  @JsonKey(name: 'OutDeliveryToCrossStreets')
  final String? outDeliveryToCrossStreets;
  @JsonKey(name: 'OutDeliveryDeliveryNotes')
  final String? outDeliveryDeliveryNotes;
  @JsonKey(name: 'OutDeliveryCarrierId')
  final String? outDeliveryCarrierId;
  @JsonKey(name: 'OutDeliveryCarrier')
  final String? outDeliveryCarrier;
  @JsonKey(name: 'OutDeliveryCarrierAccount')
  final String? outDeliveryCarrierAccount;
  @JsonKey(name: 'OutDeliveryShipViaId')
  final String? outDeliveryShipViaId;
  @JsonKey(name: 'OutDeliveryShipVia')
  final String? outDeliveryShipVia;
  @JsonKey(name: 'OutDeliveryInvoiceId')
  final String? outDeliveryInvoiceId;
  @JsonKey(name: 'OutDeliveryVendorInvoiceId')
  final String? outDeliveryVendorInvoiceId;
  @JsonKey(name: 'OutDeliveryEstimatedFreight')
  final double? outDeliveryEstimatedFreight;
  @JsonKey(name: 'OutDeliveryFreightInvoiceAmount')
  final double? outDeliveryFreightInvoiceAmount;
  @JsonKey(name: 'OutDeliveryChargeType')
  final String? outDeliveryChargeType;
  @JsonKey(name: 'OutDeliveryFreightTrackingNumber')
  final String? outDeliveryFreightTrackingNumber;
  @JsonKey(name: 'OutDeliveryFreightTrackingUrl')
  final String? outDeliveryFreightTrackingUrl;
  @JsonKey(name: 'OutDeliveryPackageCode')
  final String? outDeliveryPackageCode;
  @JsonKey(name: 'OutDeliveryBillPoFreightOnOrder')
  final bool? outDeliveryBillPoFreightOnOrder;
  @JsonKey(name: 'OutDeliveryOnlineOrderNumber')
  final String? outDeliveryOnlineOrderNumber;
  @JsonKey(name: 'OutDeliveryToVenue')
  final String? outDeliveryToVenue;
  @JsonKey(name: 'OutDeliveryToVenueId')
  final String? outDeliveryToVenueId;
  @JsonKey(name: 'OutDeliveryToWarehouse')
  final String? outDeliveryToWarehouse;
  @JsonKey(name: 'OutDeliveryToWarehouseId')
  final String? outDeliveryToWarehouseId;
  @JsonKey(name: 'OutDeliveryDateStamp')
  final String? outDeliveryDateStamp;
  @JsonKey(name: 'InDeliveryId')
  final String? inDeliveryId;
  @JsonKey(name: 'InDeliveryDeliveryType')
  final String? inDeliveryDeliveryType;
  @JsonKey(name: 'InDeliveryRequiredDate')
  final String? inDeliveryRequiredDate;
  @JsonKey(name: 'InDeliveryRequiredTime')
  final String? inDeliveryRequiredTime;
  @JsonKey(name: 'InDeliveryTargetShipDate')
  final String? inDeliveryTargetShipDate;
  @JsonKey(name: 'InDeliveryTargetShipTime')
  final String? inDeliveryTargetShipTime;
  @JsonKey(name: 'InDeliveryDirection')
  final String? inDeliveryDirection;
  @JsonKey(name: 'InDeliveryAddressType')
  final String? inDeliveryAddressType;
  @JsonKey(name: 'InDeliveryFromLocation')
  final String? inDeliveryFromLocation;
  @JsonKey(name: 'InDeliveryFromContact')
  final String? inDeliveryFromContact;
  @JsonKey(name: 'InDeliveryFromContactPhone')
  final String? inDeliveryFromContactPhone;
  @JsonKey(name: 'InDeliveryFromAlternateContact')
  final String? inDeliveryFromAlternateContact;
  @JsonKey(name: 'InDeliveryFromAlternateContactPhone')
  final String? inDeliveryFromAlternateContactPhone;
  @JsonKey(name: 'InDeliveryFromAttention')
  final String? inDeliveryFromAttention;
  @JsonKey(name: 'InDeliveryFromAddress1')
  final String? inDeliveryFromAddress1;
  @JsonKey(name: 'InDeliveryFromAdd2ress')
  final String? inDeliveryFromAdd2ress;
  @JsonKey(name: 'InDeliveryFromCity')
  final String? inDeliveryFromCity;
  @JsonKey(name: 'InDeliveryFromState')
  final String? inDeliveryFromState;
  @JsonKey(name: 'InDeliveryFromZipCode')
  final String? inDeliveryFromZipCode;
  @JsonKey(name: 'InDeliveryFromCountry')
  final String? inDeliveryFromCountry;
  @JsonKey(name: 'InDeliveryFromCountryId')
  final String? inDeliveryFromCountryId;
  @JsonKey(name: 'InDeliveryFromCrossStreets')
  final String? inDeliveryFromCrossStreets;
  @JsonKey(name: 'InDeliveryToLocation')
  final String? inDeliveryToLocation;
  @JsonKey(name: 'InDeliveryToContact')
  final String? inDeliveryToContact;
  @JsonKey(name: 'InDeliveryToContactPhone')
  final String? inDeliveryToContactPhone;
  @JsonKey(name: 'InDeliveryToAlternateContact')
  final String? inDeliveryToAlternateContact;
  @JsonKey(name: 'InDeliveryToAlternateContactPhone')
  final String? inDeliveryToAlternateContactPhone;
  @JsonKey(name: 'InDeliveryToAttention')
  final String? inDeliveryToAttention;
  @JsonKey(name: 'InDeliveryToAddress1')
  final String? inDeliveryToAddress1;
  @JsonKey(name: 'InDeliveryToAddress2')
  final String? inDeliveryToAddress2;
  @JsonKey(name: 'InDeliveryToCity')
  final String? inDeliveryToCity;
  @JsonKey(name: 'InDeliveryToState')
  final String? inDeliveryToState;
  @JsonKey(name: 'InDeliveryToZipCode')
  final String? inDeliveryToZipCode;
  @JsonKey(name: 'InDeliveryToCountryId')
  final String? inDeliveryToCountryId;
  @JsonKey(name: 'InDeliveryToCountry')
  final String? inDeliveryToCountry;
  @JsonKey(name: 'InDeliveryToContactFax')
  final String? inDeliveryToContactFax;
  @JsonKey(name: 'InDeliveryToCrossStreets')
  final String? inDeliveryToCrossStreets;
  @JsonKey(name: 'InDeliveryDeliveryNotes')
  final String? inDeliveryDeliveryNotes;
  @JsonKey(name: 'InDeliveryCarrierId')
  final String? inDeliveryCarrierId;
  @JsonKey(name: 'InDeliveryCarrier')
  final String? inDeliveryCarrier;
  @JsonKey(name: 'InDeliveryCarrierAccount')
  final String? inDeliveryCarrierAccount;
  @JsonKey(name: 'InDeliveryShipViaId')
  final String? inDeliveryShipViaId;
  @JsonKey(name: 'InDeliveryShipVia')
  final String? inDeliveryShipVia;
  @JsonKey(name: 'InDeliveryInvoiceId')
  final String? inDeliveryInvoiceId;
  @JsonKey(name: 'InDeliveryVendorInvoiceId')
  final String? inDeliveryVendorInvoiceId;
  @JsonKey(name: 'InDeliveryEstimatedFreight')
  final double? inDeliveryEstimatedFreight;
  @JsonKey(name: 'InDeliveryFreightInvoiceAmount')
  final double? inDeliveryFreightInvoiceAmount;
  @JsonKey(name: 'InDeliveryChargeType')
  final String? inDeliveryChargeType;
  @JsonKey(name: 'InDeliveryFreightTrackingNumber')
  final String? inDeliveryFreightTrackingNumber;
  @JsonKey(name: 'InDeliveryFreightTrackingUrl')
  final String? inDeliveryFreightTrackingUrl;
  @JsonKey(name: 'InDeliveryPackageCode')
  final String? inDeliveryPackageCode;
  @JsonKey(name: 'InDeliveryBillPoFreightOnOrder')
  final bool? inDeliveryBillPoFreightOnOrder;
  @JsonKey(name: 'InDeliveryOnlineOrderNumber')
  final String? inDeliveryOnlineOrderNumber;
  @JsonKey(name: 'InDeliveryOnlineOrderStatus')
  final String? inDeliveryOnlineOrderStatus;
  @JsonKey(name: 'InDeliveryToVenue')
  final String? inDeliveryToVenue;
  @JsonKey(name: 'InDeliveryToVenueId')
  final String? inDeliveryToVenueId;
  @JsonKey(name: 'InDeliveryToWarehouse')
  final String? inDeliveryToWarehouse;
  @JsonKey(name: 'InDeliveryToWarehouseId')
  final String? inDeliveryToWarehouseId;
  @JsonKey(name: 'InDeliveryDateStamp')
  final String? inDeliveryDateStamp;
  @JsonKey(name: 'RentalDaysPerWeek')
  final double? rentalDaysPerWeek;
  @JsonKey(name: 'RentalDiscountPercent')
  final double? rentalDiscountPercent;
  @JsonKey(name: 'WeeklyRentalTotal')
  final double? weeklyRentalTotal;
  @JsonKey(name: 'MonthlyRentalTotal')
  final double? monthlyRentalTotal;
  @JsonKey(name: 'PeriodRentalTotal')
  final double? periodRentalTotal;
  @JsonKey(name: 'WeeklyRentalTotalIncludesTax')
  final bool? weeklyRentalTotalIncludesTax;
  @JsonKey(name: 'MonthlyRentalTotalIncludesTax')
  final bool? monthlyRentalTotalIncludesTax;
  @JsonKey(name: 'PeriodRentalTotalIncludesTax')
  final bool? periodRentalTotalIncludesTax;
  @JsonKey(name: 'BillLockedTotal')
  final bool? billLockedTotal;
  @JsonKey(name: 'SalesDiscountPercent')
  final double? salesDiscountPercent;
  @JsonKey(name: 'SalesTotal')
  final double? salesTotal;
  @JsonKey(name: 'SalesTotalIncludesTax')
  final bool? salesTotalIncludesTax;
  @JsonKey(name: 'PartsDiscountPercent')
  final double? partsDiscountPercent;
  @JsonKey(name: 'PartsTotal')
  final double? partsTotal;
  @JsonKey(name: 'PartsTotalIncludesTax')
  final bool? partsTotalIncludesTax;
  @JsonKey(name: 'SpaceDaysPerWeek')
  final double? spaceDaysPerWeek;
  @JsonKey(name: 'SpaceDiscountPercent')
  final double? spaceDiscountPercent;
  @JsonKey(name: 'SpaceSplitPercent')
  final double? spaceSplitPercent;
  @JsonKey(name: 'WeeklySpaceTotal')
  final double? weeklySpaceTotal;
  @JsonKey(name: 'MonthlySpaceTotal')
  final double? monthlySpaceTotal;
  @JsonKey(name: 'PeriodSpaceTotal')
  final double? periodSpaceTotal;
  @JsonKey(name: 'WeeklySpaceTotalIncludesTax')
  final bool? weeklySpaceTotalIncludesTax;
  @JsonKey(name: 'MonthlySpaceTotalIncludesTax')
  final bool? monthlySpaceTotalIncludesTax;
  @JsonKey(name: 'PeriodSpaceTotalIncludesTax')
  final bool? periodSpaceTotalIncludesTax;
  @JsonKey(name: 'VehicleDaysPerWeek')
  final double? vehicleDaysPerWeek;
  @JsonKey(name: 'VehicleDiscountPercent')
  final double? vehicleDiscountPercent;
  @JsonKey(name: 'WeeklyVehicleTotal')
  final double? weeklyVehicleTotal;
  @JsonKey(name: 'MonthlyVehicleTotal')
  final double? monthlyVehicleTotal;
  @JsonKey(name: 'PeriodVehicleTotal')
  final double? periodVehicleTotal;
  @JsonKey(name: 'WeeklyVehicleTotalIncludesTax')
  final bool? weeklyVehicleTotalIncludesTax;
  @JsonKey(name: 'MonthlyVehicleTotalIncludesTax')
  final bool? monthlyVehicleTotalIncludesTax;
  @JsonKey(name: 'PeriodVehicleTotalIncludesTax')
  final bool? periodVehicleTotalIncludesTax;
  @JsonKey(name: 'MiscDiscountPercent')
  final double? miscDiscountPercent;
  @JsonKey(name: 'WeeklyMiscTotal')
  final double? weeklyMiscTotal;
  @JsonKey(name: 'MonthlyMiscTotal')
  final double? monthlyMiscTotal;
  @JsonKey(name: 'PeriodMiscTotal')
  final double? periodMiscTotal;
  @JsonKey(name: 'WeeklyMiscTotalIncludesTax')
  final bool? weeklyMiscTotalIncludesTax;
  @JsonKey(name: 'MonthlyMiscTotalIncludesTax')
  final bool? monthlyMiscTotalIncludesTax;
  @JsonKey(name: 'PeriodMiscTotalIncludesTax')
  final bool? periodMiscTotalIncludesTax;
  @JsonKey(name: 'LaborDiscountPercent')
  final double? laborDiscountPercent;
  @JsonKey(name: 'WeeklyLaborTotal')
  final double? weeklyLaborTotal;
  @JsonKey(name: 'MonthlyLaborTotal')
  final double? monthlyLaborTotal;
  @JsonKey(name: 'PeriodLaborTotal')
  final double? periodLaborTotal;
  @JsonKey(name: 'WeeklyLaborTotalIncludesTax')
  final bool? weeklyLaborTotalIncludesTax;
  @JsonKey(name: 'MonthlyLaborTotalIncludesTax')
  final bool? monthlyLaborTotalIncludesTax;
  @JsonKey(name: 'PeriodLaborTotalIncludesTax')
  final bool? periodLaborTotalIncludesTax;
  @JsonKey(name: 'RentalSaleDiscountPercent')
  final double? rentalSaleDiscountPercent;
  @JsonKey(name: 'RentalSaleTotal')
  final double? rentalSaleTotal;
  @JsonKey(name: 'RentalSaleTotalIncludesTax')
  final bool? rentalSaleTotalIncludesTax;
  @JsonKey(name: 'LossAndDamageDiscountPercent')
  final double? lossAndDamageDiscountPercent;
  @JsonKey(name: 'LossAndDamageTotal')
  final double? lossAndDamageTotal;
  @JsonKey(name: 'LossAndDamageTotalIncludesTax')
  final bool? lossAndDamageTotalIncludesTax;
  @JsonKey(name: 'CombinedDaysPerWeek')
  final double? combinedDaysPerWeek;
  @JsonKey(name: 'CombinedDiscountPercent')
  final double? combinedDiscountPercent;
  @JsonKey(name: 'WeeklyCombinedTotal')
  final double? weeklyCombinedTotal;
  @JsonKey(name: 'MonthlyCombinedTotal')
  final double? monthlyCombinedTotal;
  @JsonKey(name: 'PeriodCombinedTotal')
  final double? periodCombinedTotal;
  @JsonKey(name: 'WeeklyCombinedTotalIncludesTax')
  final bool? weeklyCombinedTotalIncludesTax;
  @JsonKey(name: 'MonthlyCombinedTotalIncludesTax')
  final bool? monthlyCombinedTotalIncludesTax;
  @JsonKey(name: 'PeriodCombinedTotalIncludesTax')
  final bool? periodCombinedTotalIncludesTax;
  @JsonKey(name: 'DisableEditingRentalRate')
  final bool? disableEditingRentalRate;
  @JsonKey(name: 'DisableEditingSalesRate')
  final bool? disableEditingSalesRate;
  @JsonKey(name: 'DisableEditingMiscellaneousRate')
  final bool? disableEditingMiscellaneousRate;
  @JsonKey(name: 'DisableEditingLaborRate')
  final bool? disableEditingLaborRate;
  @JsonKey(name: 'DisableEditingRentalSaleRate')
  final bool? disableEditingRentalSaleRate;
  @JsonKey(name: 'DisableEditingLossAndDamageRate')
  final bool? disableEditingLossAndDamageRate;
  @JsonKey(name: 'RentalExtendedTotal')
  final double? rentalExtendedTotal;
  @JsonKey(name: 'SalesExtendedTotal')
  final double? salesExtendedTotal;
  @JsonKey(name: 'LaborExtendedTotal')
  final double? laborExtendedTotal;
  @JsonKey(name: 'MiscellaneousExtendedTotal')
  final double? miscellaneousExtendedTotal;
  @JsonKey(name: 'RentalSaleExtendedTotal')
  final double? rentalSaleExtendedTotal;
  @JsonKey(name: 'LossAndDamageExtendedTotal')
  final double? lossAndDamageExtendedTotal;
  @JsonKey(name: 'HasNotes')
  final bool? hasNotes;
  @JsonKey(name: 'HasDocuments')
  final bool? hasDocuments;
  @JsonKey(name: 'HasEmailHistory')
  final bool? hasEmailHistory;
  @JsonKey(name: 'HasContacts')
  final bool? hasContacts;
  @JsonKey(name: 'HasSubPurchaseOrders')
  final bool? hasSubPurchaseOrders;
  @JsonKey(name: 'HasPickLists')
  final bool? hasPickLists;
  @JsonKey(name: 'HasContracts')
  final bool? hasContracts;
  @JsonKey(name: 'HasSuspendedContracts')
  final bool? hasSuspendedContracts;
  @JsonKey(name: 'HasMultiOrderContracts')
  final bool? hasMultiOrderContracts;
  @JsonKey(name: 'HasInvoices')
  final bool? hasInvoices;
  @JsonKey(name: 'HasBillingWorksheets')
  final bool? hasBillingWorksheets;
  @JsonKey(name: 'HasMultiOrderInvoices')
  final bool? hasMultiOrderInvoices;
  @JsonKey(name: 'TotalReplacementCost')
  final double? totalReplacementCost;
  @JsonKey(name: 'PresentationLayerId')
  final String? presentationLayerId;
  @JsonKey(name: 'PresentationLayer')
  final String? presentationLayer;
  @JsonKey(name: 'IsManualSort')
  final bool? isManualSort;
  @JsonKey(name: 'QuoteOrderTitle')
  final String? quoteOrderTitle;
  @JsonKey(name: 'UnassignedSubs')
  final bool? unassignedSubs;
  @JsonKey(name: 'NonTaxable')
  final bool? nonTaxable;
  @JsonKey(name: 'EnableProjects')
  final bool? enableProjects;
  @JsonKey(name: 'ProjectId')
  final String? projectId;
  @JsonKey(name: 'ProjectNumber')
  final String? projectNumber;
  @JsonKey(name: 'Project')
  final String? project;
  @JsonKey(name: 'ProjectDrawingsId')
  final String? projectDrawingsId;
  @JsonKey(name: 'ProjectDrawings')
  final String? projectDrawings;
  @JsonKey(name: 'ProjectItemsOrderedId')
  final String? projectItemsOrderedId;
  @JsonKey(name: 'ProjectItemsOrdered')
  final String? projectItemsOrdered;
  @JsonKey(name: 'ProjectDropShipId')
  final String? projectDropShipId;
  @JsonKey(name: 'ProjectDropShip')
  final String? projectDropShip;
  @JsonKey(name: 'ProjectAsBuildId')
  final String? projectAsBuildId;
  @JsonKey(name: 'ProjectAsBuild')
  final String? projectAsBuild;
  @JsonKey(name: 'ProjectCommissioningId')
  final String? projectCommissioningId;
  @JsonKey(name: 'ProjectCommissioning')
  final String? projectCommissioning;
  @JsonKey(name: 'ProjectDepositId')
  final String? projectDepositId;
  @JsonKey(name: 'ProjectDeposit')
  final String? projectDeposit;
  @JsonKey(name: 'InputByUserId')
  final String? inputByUserId;
  @JsonKey(name: 'ModifiedByUserId')
  final String? modifiedByUserId;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory = _$WebApiModulesAgentOrderOrderFromJson;
  static const toJsonFactory = _$WebApiModulesAgentOrderOrderToJson;
  Map<String, dynamic> toJson() => _$WebApiModulesAgentOrderOrderToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderOrder &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderNumber, orderNumber) ||
                const DeepCollectionEquality()
                    .equals(other.orderNumber, orderNumber)) &&
            (identical(other.orderDate, orderDate) ||
                const DeepCollectionEquality()
                    .equals(other.orderDate, orderDate)) &&
            (identical(other.sourceQuoteId, sourceQuoteId) ||
                const DeepCollectionEquality()
                    .equals(other.sourceQuoteId, sourceQuoteId)) &&
            (identical(other.sourceQuoteNumber, sourceQuoteNumber) ||
                const DeepCollectionEquality()
                    .equals(other.sourceQuoteNumber, sourceQuoteNumber)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.officeLocationId, officeLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocationId, officeLocationId)) &&
            (identical(other.officeLocation, officeLocation) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocation, officeLocation)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouse, warehouse) ||
                const DeepCollectionEquality()
                    .equals(other.warehouse, warehouse)) &&
            (identical(other.warehouseCode, warehouseCode) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.departmentId, departmentId) ||
                const DeepCollectionEquality()
                    .equals(other.departmentId, departmentId)) &&
            (identical(other.department, department) ||
                const DeepCollectionEquality()
                    .equals(other.department, department)) &&
            (identical(other.customerId, customerId) ||
                const DeepCollectionEquality()
                    .equals(other.customerId, customerId)) &&
            (identical(other.customer, customer) ||
                const DeepCollectionEquality()
                    .equals(other.customer, customer)) &&
            (identical(other.customerNumber, customerNumber) ||
                const DeepCollectionEquality()
                    .equals(other.customerNumber, customerNumber)) &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.deal, deal) ||
                const DeepCollectionEquality().equals(other.deal, deal)) &&
            (identical(other.dealNumber, dealNumber) ||
                const DeepCollectionEquality()
                    .equals(other.dealNumber, dealNumber)) &&
            (identical(other.rateType, rateType) ||
                const DeepCollectionEquality()
                    .equals(other.rateType, rateType)) &&
            (identical(other.rateTypeDisplay, rateTypeDisplay) ||
                const DeepCollectionEquality()
                    .equals(other.rateTypeDisplay, rateTypeDisplay)) &&
            (identical(other.agentId, agentId) ||
                const DeepCollectionEquality()
                    .equals(other.agentId, agentId)) &&
            (identical(other.agent, agent) ||
                const DeepCollectionEquality().equals(other.agent, agent)) &&
            (identical(other.projectManagerId, projectManagerId) || const DeepCollectionEquality().equals(other.projectManagerId, projectManagerId)) &&
            (identical(other.projectManager, projectManager) || const DeepCollectionEquality().equals(other.projectManager, projectManager)) &&
            (identical(other.rental, rental) || const DeepCollectionEquality().equals(other.rental, rental)) &&
            (identical(other.sales, sales) || const DeepCollectionEquality().equals(other.sales, sales)) &&
            (identical(other.miscellaneous, miscellaneous) || const DeepCollectionEquality().equals(other.miscellaneous, miscellaneous)) &&
            (identical(other.labor, labor) || const DeepCollectionEquality().equals(other.labor, labor)) &&
            (identical(other.facilities, facilities) || const DeepCollectionEquality().equals(other.facilities, facilities)) &&
            (identical(other.transportation, transportation) || const DeepCollectionEquality().equals(other.transportation, transportation)) &&
            (identical(other.rentalSale, rentalSale) || const DeepCollectionEquality().equals(other.rentalSale, rentalSale)) &&
            (identical(other.lossAndDamage, lossAndDamage) || const DeepCollectionEquality().equals(other.lossAndDamage, lossAndDamage)) &&
            (identical(other.repair, repair) || const DeepCollectionEquality().equals(other.repair, repair)) &&
            (identical(other.hasRentalItem, hasRentalItem) || const DeepCollectionEquality().equals(other.hasRentalItem, hasRentalItem)) &&
            (identical(other.hasSalesItem, hasSalesItem) || const DeepCollectionEquality().equals(other.hasSalesItem, hasSalesItem)) &&
            (identical(other.hasMiscellaneousItem, hasMiscellaneousItem) || const DeepCollectionEquality().equals(other.hasMiscellaneousItem, hasMiscellaneousItem)) &&
            (identical(other.hasLaborItem, hasLaborItem) || const DeepCollectionEquality().equals(other.hasLaborItem, hasLaborItem)) &&
            (identical(other.hasFacilitiesItem, hasFacilitiesItem) || const DeepCollectionEquality().equals(other.hasFacilitiesItem, hasFacilitiesItem)) &&
            (identical(other.hasLossAndDamageItem, hasLossAndDamageItem) || const DeepCollectionEquality().equals(other.hasLossAndDamageItem, hasLossAndDamageItem)) &&
            (identical(other.hasRentalSaleItem, hasRentalSaleItem) || const DeepCollectionEquality().equals(other.hasRentalSaleItem, hasRentalSaleItem)) &&
            (identical(other.hasRepair, hasRepair) || const DeepCollectionEquality().equals(other.hasRepair, hasRepair)) &&
            (identical(other.activityDatesAndTimes, activityDatesAndTimes) || const DeepCollectionEquality().equals(other.activityDatesAndTimes, activityDatesAndTimes)) &&
            (identical(other.pickDate, pickDate) || const DeepCollectionEquality().equals(other.pickDate, pickDate)) &&
            (identical(other.pickTime, pickTime) || const DeepCollectionEquality().equals(other.pickTime, pickTime)) &&
            (identical(other.estimatedStartDate, estimatedStartDate) || const DeepCollectionEquality().equals(other.estimatedStartDate, estimatedStartDate)) &&
            (identical(other.estimatedStartTime, estimatedStartTime) || const DeepCollectionEquality().equals(other.estimatedStartTime, estimatedStartTime)) &&
            (identical(other.estimatedStopDate, estimatedStopDate) || const DeepCollectionEquality().equals(other.estimatedStopDate, estimatedStopDate)) &&
            (identical(other.estimatedStopTime, estimatedStopTime) || const DeepCollectionEquality().equals(other.estimatedStopTime, estimatedStopTime)) &&
            (identical(other.pickUpDate, pickUpDate) || const DeepCollectionEquality().equals(other.pickUpDate, pickUpDate)) &&
            (identical(other.pickUpTime, pickUpTime) || const DeepCollectionEquality().equals(other.pickUpTime, pickUpTime)) &&
            (identical(other.prepDate, prepDate) || const DeepCollectionEquality().equals(other.prepDate, prepDate)) &&
            (identical(other.prepTime, prepTime) || const DeepCollectionEquality().equals(other.prepTime, prepTime)) &&
            (identical(other.loadInDate, loadInDate) || const DeepCollectionEquality().equals(other.loadInDate, loadInDate)) &&
            (identical(other.loadInTime, loadInTime) || const DeepCollectionEquality().equals(other.loadInTime, loadInTime)) &&
            (identical(other.strikeDate, strikeDate) || const DeepCollectionEquality().equals(other.strikeDate, strikeDate)) &&
            (identical(other.strikeTime, strikeTime) || const DeepCollectionEquality().equals(other.strikeTime, strikeTime)) &&
            (identical(other.testDate, testDate) || const DeepCollectionEquality().equals(other.testDate, testDate)) &&
            (identical(other.testTime, testTime) || const DeepCollectionEquality().equals(other.testTime, testTime)) &&
            (identical(other.orderTypeId, orderTypeId) || const DeepCollectionEquality().equals(other.orderTypeId, orderTypeId)) &&
            (identical(other.orderType, orderType) || const DeepCollectionEquality().equals(other.orderType, orderType)) &&
            (identical(other.orderTypeCombineActivityTabs, orderTypeCombineActivityTabs) || const DeepCollectionEquality().equals(other.orderTypeCombineActivityTabs, orderTypeCombineActivityTabs)) &&
            (identical(other.flatPo, flatPo) || const DeepCollectionEquality().equals(other.flatPo, flatPo)) &&
            (identical(other.pendingPo, pendingPo) || const DeepCollectionEquality().equals(other.pendingPo, pendingPo)) &&
            (identical(other.poNumber, poNumber) || const DeepCollectionEquality().equals(other.poNumber, poNumber)) &&
            (identical(other.poAmount, poAmount) || const DeepCollectionEquality().equals(other.poAmount, poAmount)) &&
            (identical(other.location, location) || const DeepCollectionEquality().equals(other.location, location)) &&
            (identical(other.orderLocationId, orderLocationId) || const DeepCollectionEquality().equals(other.orderLocationId, orderLocationId)) &&
            (identical(other.orderLocation, orderLocation) || const DeepCollectionEquality().equals(other.orderLocation, orderLocation)) &&
            (identical(other.referenceNumber, referenceNumber) || const DeepCollectionEquality().equals(other.referenceNumber, referenceNumber)) &&
            (identical(other.total, total) || const DeepCollectionEquality().equals(other.total, total)) &&
            (identical(other.status, status) || const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.statusDate, statusDate) || const DeepCollectionEquality().equals(other.statusDate, statusDate)) &&
            (identical(other.poApprovalStatusId, poApprovalStatusId) || const DeepCollectionEquality().equals(other.poApprovalStatusId, poApprovalStatusId)) &&
            (identical(other.lockBillingDates, lockBillingDates) || const DeepCollectionEquality().equals(other.lockBillingDates, lockBillingDates)) &&
            (identical(other.specifyBillingDatesByType, specifyBillingDatesByType) || const DeepCollectionEquality().equals(other.specifyBillingDatesByType, specifyBillingDatesByType)) &&
            (identical(other.rentalBillingStartDate, rentalBillingStartDate) || const DeepCollectionEquality().equals(other.rentalBillingStartDate, rentalBillingStartDate)) &&
            (identical(other.rentalBillingEndDate, rentalBillingEndDate) || const DeepCollectionEquality().equals(other.rentalBillingEndDate, rentalBillingEndDate)) &&
            (identical(other.laborBillingStartDate, laborBillingStartDate) || const DeepCollectionEquality().equals(other.laborBillingStartDate, laborBillingStartDate)) &&
            (identical(other.laborBillingEndDate, laborBillingEndDate) || const DeepCollectionEquality().equals(other.laborBillingEndDate, laborBillingEndDate)) &&
            (identical(other.miscellaneousBillingStartDate, miscellaneousBillingStartDate) || const DeepCollectionEquality().equals(other.miscellaneousBillingStartDate, miscellaneousBillingStartDate)) &&
            (identical(other.miscellaneousBillingEndDate, miscellaneousBillingEndDate) || const DeepCollectionEquality().equals(other.miscellaneousBillingEndDate, miscellaneousBillingEndDate)) &&
            (identical(other.facilitiesBillingStartDate, facilitiesBillingStartDate) || const DeepCollectionEquality().equals(other.facilitiesBillingStartDate, facilitiesBillingStartDate)) &&
            (identical(other.facilitiesBillingEndDate, facilitiesBillingEndDate) || const DeepCollectionEquality().equals(other.facilitiesBillingEndDate, facilitiesBillingEndDate)) &&
            (identical(other.vehicleBillingStartDate, vehicleBillingStartDate) || const DeepCollectionEquality().equals(other.vehicleBillingStartDate, vehicleBillingStartDate)) &&
            (identical(other.vehicleBillingEndDate, vehicleBillingEndDate) || const DeepCollectionEquality().equals(other.vehicleBillingEndDate, vehicleBillingEndDate)) &&
            (identical(other.delayBillingSearchUntil, delayBillingSearchUntil) || const DeepCollectionEquality().equals(other.delayBillingSearchUntil, delayBillingSearchUntil)) &&
            (identical(other.includePrepFeesInRentalRate, includePrepFeesInRentalRate) || const DeepCollectionEquality().equals(other.includePrepFeesInRentalRate, includePrepFeesInRentalRate)) &&
            (identical(other.billingStartDate, billingStartDate) || const DeepCollectionEquality().equals(other.billingStartDate, billingStartDate)) &&
            (identical(other.billingEndDate, billingEndDate) || const DeepCollectionEquality().equals(other.billingEndDate, billingEndDate)) &&
            (identical(other.billingWeeks, billingWeeks) || const DeepCollectionEquality().equals(other.billingWeeks, billingWeeks)) &&
            (identical(other.billingMonths, billingMonths) || const DeepCollectionEquality().equals(other.billingMonths, billingMonths)) &&
            (identical(other.determineQuantitiesToBillBasedOn, determineQuantitiesToBillBasedOn) || const DeepCollectionEquality().equals(other.determineQuantitiesToBillBasedOn, determineQuantitiesToBillBasedOn)) &&
            (identical(other.billingCycleId, billingCycleId) || const DeepCollectionEquality().equals(other.billingCycleId, billingCycleId)) &&
            (identical(other.billingCycle, billingCycle) || const DeepCollectionEquality().equals(other.billingCycle, billingCycle)) &&
            (identical(other.billingCycleType, billingCycleType) || const DeepCollectionEquality().equals(other.billingCycleType, billingCycleType)) &&
            (identical(other.paymentTermsId, paymentTermsId) || const DeepCollectionEquality().equals(other.paymentTermsId, paymentTermsId)) &&
            (identical(other.paymentTerms, paymentTerms) || const DeepCollectionEquality().equals(other.paymentTerms, paymentTerms)) &&
            (identical(other.paymentTypeId, paymentTypeId) || const DeepCollectionEquality().equals(other.paymentTypeId, paymentTypeId)) &&
            (identical(other.paymentType, paymentType) || const DeepCollectionEquality().equals(other.paymentType, paymentType)) &&
            (identical(other.currencyId, currencyId) || const DeepCollectionEquality().equals(other.currencyId, currencyId)) &&
            (identical(other.updateAllRatesToNewCurrency, updateAllRatesToNewCurrency) || const DeepCollectionEquality().equals(other.updateAllRatesToNewCurrency, updateAllRatesToNewCurrency)) &&
            (identical(other.confirmUpdateAllRatesToNewCurrency, confirmUpdateAllRatesToNewCurrency) || const DeepCollectionEquality().equals(other.confirmUpdateAllRatesToNewCurrency, confirmUpdateAllRatesToNewCurrency)) &&
            (identical(other.currencyCode, currencyCode) || const DeepCollectionEquality().equals(other.currencyCode, currencyCode)) &&
            (identical(other.currency, currency) || const DeepCollectionEquality().equals(other.currency, currency)) &&
            (identical(other.currencySymbol, currencySymbol) || const DeepCollectionEquality().equals(other.currencySymbol, currencySymbol)) &&
            (identical(other.taxOptionId, taxOptionId) || const DeepCollectionEquality().equals(other.taxOptionId, taxOptionId)) &&
            (identical(other.taxOption, taxOption) || const DeepCollectionEquality().equals(other.taxOption, taxOption)) &&
            (identical(other.tax1Name, tax1Name) || const DeepCollectionEquality().equals(other.tax1Name, tax1Name)) &&
            (identical(other.tax2Name, tax2Name) || const DeepCollectionEquality().equals(other.tax2Name, tax2Name)) &&
            (identical(other.taxId, taxId) || const DeepCollectionEquality().equals(other.taxId, taxId)) &&
            (identical(other.rentalTaxRate1, rentalTaxRate1) || const DeepCollectionEquality().equals(other.rentalTaxRate1, rentalTaxRate1)) &&
            (identical(other.salesTaxRate1, salesTaxRate1) || const DeepCollectionEquality().equals(other.salesTaxRate1, salesTaxRate1)) &&
            (identical(other.laborTaxRate1, laborTaxRate1) || const DeepCollectionEquality().equals(other.laborTaxRate1, laborTaxRate1)) &&
            (identical(other.rentalTaxRate2, rentalTaxRate2) || const DeepCollectionEquality().equals(other.rentalTaxRate2, rentalTaxRate2)) &&
            (identical(other.salesTaxRate2, salesTaxRate2) || const DeepCollectionEquality().equals(other.salesTaxRate2, salesTaxRate2)) &&
            (identical(other.laborTaxRate2, laborTaxRate2) || const DeepCollectionEquality().equals(other.laborTaxRate2, laborTaxRate2)) &&
            (identical(other.noCharge, noCharge) || const DeepCollectionEquality().equals(other.noCharge, noCharge)) &&
            (identical(other.noChargeReason, noChargeReason) || const DeepCollectionEquality().equals(other.noChargeReason, noChargeReason)) &&
            (identical(other.printIssuedToAddressFrom, printIssuedToAddressFrom) || const DeepCollectionEquality().equals(other.printIssuedToAddressFrom, printIssuedToAddressFrom)) &&
            (identical(other.issuedToName, issuedToName) || const DeepCollectionEquality().equals(other.issuedToName, issuedToName)) &&
            (identical(other.issuedToAttention, issuedToAttention) || const DeepCollectionEquality().equals(other.issuedToAttention, issuedToAttention)) &&
            (identical(other.issuedToAttention2, issuedToAttention2) || const DeepCollectionEquality().equals(other.issuedToAttention2, issuedToAttention2)) &&
            (identical(other.issuedToAddress1, issuedToAddress1) || const DeepCollectionEquality().equals(other.issuedToAddress1, issuedToAddress1)) &&
            (identical(other.issuedToAddress2, issuedToAddress2) || const DeepCollectionEquality().equals(other.issuedToAddress2, issuedToAddress2)) &&
            (identical(other.issuedToCity, issuedToCity) || const DeepCollectionEquality().equals(other.issuedToCity, issuedToCity)) &&
            (identical(other.issuedToState, issuedToState) || const DeepCollectionEquality().equals(other.issuedToState, issuedToState)) &&
            (identical(other.issuedToZipCode, issuedToZipCode) || const DeepCollectionEquality().equals(other.issuedToZipCode, issuedToZipCode)) &&
            (identical(other.issuedToCountryId, issuedToCountryId) || const DeepCollectionEquality().equals(other.issuedToCountryId, issuedToCountryId)) &&
            (identical(other.issuedToCountry, issuedToCountry) || const DeepCollectionEquality().equals(other.issuedToCountry, issuedToCountry)) &&
            (identical(other.billToAddressDifferentFromIssuedToAddress, billToAddressDifferentFromIssuedToAddress) || const DeepCollectionEquality().equals(other.billToAddressDifferentFromIssuedToAddress, billToAddressDifferentFromIssuedToAddress)) &&
            (identical(other.billToAddressId, billToAddressId) || const DeepCollectionEquality().equals(other.billToAddressId, billToAddressId)) &&
            (identical(other.billToName, billToName) || const DeepCollectionEquality().equals(other.billToName, billToName)) &&
            (identical(other.billToAttention, billToAttention) || const DeepCollectionEquality().equals(other.billToAttention, billToAttention)) &&
            (identical(other.billToAttention2, billToAttention2) || const DeepCollectionEquality().equals(other.billToAttention2, billToAttention2)) &&
            (identical(other.billToAddress1, billToAddress1) || const DeepCollectionEquality().equals(other.billToAddress1, billToAddress1)) &&
            (identical(other.billToAddress2, billToAddress2) || const DeepCollectionEquality().equals(other.billToAddress2, billToAddress2)) &&
            (identical(other.billToCity, billToCity) || const DeepCollectionEquality().equals(other.billToCity, billToCity)) &&
            (identical(other.billToState, billToState) || const DeepCollectionEquality().equals(other.billToState, billToState)) &&
            (identical(other.billToZipCode, billToZipCode) || const DeepCollectionEquality().equals(other.billToZipCode, billToZipCode)) &&
            (identical(other.billToCountryId, billToCountryId) || const DeepCollectionEquality().equals(other.billToCountryId, billToCountryId)) &&
            (identical(other.billToCountry, billToCountry) || const DeepCollectionEquality().equals(other.billToCountry, billToCountry)) &&
            (identical(other.discountReasonId, discountReasonId) || const DeepCollectionEquality().equals(other.discountReasonId, discountReasonId)) &&
            (identical(other.discountReason, discountReason) || const DeepCollectionEquality().equals(other.discountReason, discountReason)) &&
            (identical(other.requireContactConfirmation, requireContactConfirmation) || const DeepCollectionEquality().equals(other.requireContactConfirmation, requireContactConfirmation)) &&
            (identical(other.includeInBillingAnalysis, includeInBillingAnalysis) || const DeepCollectionEquality().equals(other.includeInBillingAnalysis, includeInBillingAnalysis)) &&
            (identical(other.hiatusDiscountFrom, hiatusDiscountFrom) || const DeepCollectionEquality().equals(other.hiatusDiscountFrom, hiatusDiscountFrom)) &&
            (identical(other.roundTripRentals, roundTripRentals) || const DeepCollectionEquality().equals(other.roundTripRentals, roundTripRentals)) &&
            (identical(other.inGroup, inGroup) || const DeepCollectionEquality().equals(other.inGroup, inGroup)) &&
            (identical(other.groupNumber, groupNumber) || const DeepCollectionEquality().equals(other.groupNumber, groupNumber)) &&
            (identical(other.groupColor, groupColor) || const DeepCollectionEquality().equals(other.groupColor, groupColor)) &&
            (identical(other.groupOrderBy, groupOrderBy) || const DeepCollectionEquality().equals(other.groupOrderBy, groupOrderBy)) &&
            (identical(other.coverLetterId, coverLetterId) || const DeepCollectionEquality().equals(other.coverLetterId, coverLetterId)) &&
            (identical(other.coverLetter, coverLetter) || const DeepCollectionEquality().equals(other.coverLetter, coverLetter)) &&
            (identical(other.termsConditionsId, termsConditionsId) || const DeepCollectionEquality().equals(other.termsConditionsId, termsConditionsId)) &&
            (identical(other.termsConditions, termsConditions) || const DeepCollectionEquality().equals(other.termsConditions, termsConditions)) &&
            (identical(other.outsideSalesRepresentativeId, outsideSalesRepresentativeId) || const DeepCollectionEquality().equals(other.outsideSalesRepresentativeId, outsideSalesRepresentativeId)) &&
            (identical(other.outsideSalesRepresentative, outsideSalesRepresentative) || const DeepCollectionEquality().equals(other.outsideSalesRepresentative, outsideSalesRepresentative)) &&
            (identical(other.marketTypeId, marketTypeId) || const DeepCollectionEquality().equals(other.marketTypeId, marketTypeId)) &&
            (identical(other.marketType, marketType) || const DeepCollectionEquality().equals(other.marketType, marketType)) &&
            (identical(other.marketSegmentId, marketSegmentId) || const DeepCollectionEquality().equals(other.marketSegmentId, marketSegmentId)) &&
            (identical(other.marketSegment, marketSegment) || const DeepCollectionEquality().equals(other.marketSegment, marketSegment)) &&
            (identical(other.marketSegmentJobId, marketSegmentJobId) || const DeepCollectionEquality().equals(other.marketSegmentJobId, marketSegmentJobId)) &&
            (identical(other.marketSegmentJob, marketSegmentJob) || const DeepCollectionEquality().equals(other.marketSegmentJob, marketSegmentJob)) &&
            (identical(other.outDeliveryId, outDeliveryId) || const DeepCollectionEquality().equals(other.outDeliveryId, outDeliveryId)) &&
            (identical(other.outDeliveryDeliveryType, outDeliveryDeliveryType) || const DeepCollectionEquality().equals(other.outDeliveryDeliveryType, outDeliveryDeliveryType)) &&
            (identical(other.outDeliveryRequiredDate, outDeliveryRequiredDate) || const DeepCollectionEquality().equals(other.outDeliveryRequiredDate, outDeliveryRequiredDate)) &&
            (identical(other.outDeliveryRequiredTime, outDeliveryRequiredTime) || const DeepCollectionEquality().equals(other.outDeliveryRequiredTime, outDeliveryRequiredTime)) &&
            (identical(other.outDeliveryTargetShipDate, outDeliveryTargetShipDate) || const DeepCollectionEquality().equals(other.outDeliveryTargetShipDate, outDeliveryTargetShipDate)) &&
            (identical(other.outDeliveryTargetShipTime, outDeliveryTargetShipTime) || const DeepCollectionEquality().equals(other.outDeliveryTargetShipTime, outDeliveryTargetShipTime)) &&
            (identical(other.outDeliveryDirection, outDeliveryDirection) || const DeepCollectionEquality().equals(other.outDeliveryDirection, outDeliveryDirection)) &&
            (identical(other.outDeliveryAddressType, outDeliveryAddressType) || const DeepCollectionEquality().equals(other.outDeliveryAddressType, outDeliveryAddressType)) &&
            (identical(other.outDeliveryFromLocation, outDeliveryFromLocation) || const DeepCollectionEquality().equals(other.outDeliveryFromLocation, outDeliveryFromLocation)) &&
            (identical(other.outDeliveryFromContact, outDeliveryFromContact) || const DeepCollectionEquality().equals(other.outDeliveryFromContact, outDeliveryFromContact)) &&
            (identical(other.outDeliveryFromContactPhone, outDeliveryFromContactPhone) || const DeepCollectionEquality().equals(other.outDeliveryFromContactPhone, outDeliveryFromContactPhone)) &&
            (identical(other.outDeliveryFromAlternateContact, outDeliveryFromAlternateContact) || const DeepCollectionEquality().equals(other.outDeliveryFromAlternateContact, outDeliveryFromAlternateContact)) &&
            (identical(other.outDeliveryFromAlternateContactPhone, outDeliveryFromAlternateContactPhone) || const DeepCollectionEquality().equals(other.outDeliveryFromAlternateContactPhone, outDeliveryFromAlternateContactPhone)) &&
            (identical(other.outDeliveryFromAttention, outDeliveryFromAttention) || const DeepCollectionEquality().equals(other.outDeliveryFromAttention, outDeliveryFromAttention)) &&
            (identical(other.outDeliveryFromAddress1, outDeliveryFromAddress1) || const DeepCollectionEquality().equals(other.outDeliveryFromAddress1, outDeliveryFromAddress1)) &&
            (identical(other.outDeliveryFromAdd2ress, outDeliveryFromAdd2ress) || const DeepCollectionEquality().equals(other.outDeliveryFromAdd2ress, outDeliveryFromAdd2ress)) &&
            (identical(other.outDeliveryFromCity, outDeliveryFromCity) || const DeepCollectionEquality().equals(other.outDeliveryFromCity, outDeliveryFromCity)) &&
            (identical(other.outDeliveryFromState, outDeliveryFromState) || const DeepCollectionEquality().equals(other.outDeliveryFromState, outDeliveryFromState)) &&
            (identical(other.outDeliveryFromZipCode, outDeliveryFromZipCode) || const DeepCollectionEquality().equals(other.outDeliveryFromZipCode, outDeliveryFromZipCode)) &&
            (identical(other.outDeliveryFromCountry, outDeliveryFromCountry) || const DeepCollectionEquality().equals(other.outDeliveryFromCountry, outDeliveryFromCountry)) &&
            (identical(other.outDeliveryFromCountryId, outDeliveryFromCountryId) || const DeepCollectionEquality().equals(other.outDeliveryFromCountryId, outDeliveryFromCountryId)) &&
            (identical(other.outDeliveryFromCrossStreets, outDeliveryFromCrossStreets) || const DeepCollectionEquality().equals(other.outDeliveryFromCrossStreets, outDeliveryFromCrossStreets)) &&
            (identical(other.outDeliveryToLocation, outDeliveryToLocation) || const DeepCollectionEquality().equals(other.outDeliveryToLocation, outDeliveryToLocation)) &&
            (identical(other.outDeliveryToContact, outDeliveryToContact) || const DeepCollectionEquality().equals(other.outDeliveryToContact, outDeliveryToContact)) &&
            (identical(other.outDeliveryToContactPhone, outDeliveryToContactPhone) || const DeepCollectionEquality().equals(other.outDeliveryToContactPhone, outDeliveryToContactPhone)) &&
            (identical(other.outDeliveryToAlternateContact, outDeliveryToAlternateContact) || const DeepCollectionEquality().equals(other.outDeliveryToAlternateContact, outDeliveryToAlternateContact)) &&
            (identical(other.outDeliveryToAlternateContactPhone, outDeliveryToAlternateContactPhone) || const DeepCollectionEquality().equals(other.outDeliveryToAlternateContactPhone, outDeliveryToAlternateContactPhone)) &&
            (identical(other.outDeliveryToAttention, outDeliveryToAttention) || const DeepCollectionEquality().equals(other.outDeliveryToAttention, outDeliveryToAttention)) &&
            (identical(other.outDeliveryToAddress1, outDeliveryToAddress1) || const DeepCollectionEquality().equals(other.outDeliveryToAddress1, outDeliveryToAddress1)) &&
            (identical(other.outDeliveryToAddress2, outDeliveryToAddress2) || const DeepCollectionEquality().equals(other.outDeliveryToAddress2, outDeliveryToAddress2)) &&
            (identical(other.outDeliveryToCity, outDeliveryToCity) || const DeepCollectionEquality().equals(other.outDeliveryToCity, outDeliveryToCity)) &&
            (identical(other.outDeliveryToState, outDeliveryToState) || const DeepCollectionEquality().equals(other.outDeliveryToState, outDeliveryToState)) &&
            (identical(other.outDeliveryToZipCode, outDeliveryToZipCode) || const DeepCollectionEquality().equals(other.outDeliveryToZipCode, outDeliveryToZipCode)) &&
            (identical(other.outDeliveryToCountryId, outDeliveryToCountryId) || const DeepCollectionEquality().equals(other.outDeliveryToCountryId, outDeliveryToCountryId)) &&
            (identical(other.outDeliveryToCountry, outDeliveryToCountry) || const DeepCollectionEquality().equals(other.outDeliveryToCountry, outDeliveryToCountry)) &&
            (identical(other.outDeliveryToContactFax, outDeliveryToContactFax) || const DeepCollectionEquality().equals(other.outDeliveryToContactFax, outDeliveryToContactFax)) &&
            (identical(other.outDeliveryToCrossStreets, outDeliveryToCrossStreets) || const DeepCollectionEquality().equals(other.outDeliveryToCrossStreets, outDeliveryToCrossStreets)) &&
            (identical(other.outDeliveryDeliveryNotes, outDeliveryDeliveryNotes) || const DeepCollectionEquality().equals(other.outDeliveryDeliveryNotes, outDeliveryDeliveryNotes)) &&
            (identical(other.outDeliveryCarrierId, outDeliveryCarrierId) || const DeepCollectionEquality().equals(other.outDeliveryCarrierId, outDeliveryCarrierId)) &&
            (identical(other.outDeliveryCarrier, outDeliveryCarrier) || const DeepCollectionEquality().equals(other.outDeliveryCarrier, outDeliveryCarrier)) &&
            (identical(other.outDeliveryCarrierAccount, outDeliveryCarrierAccount) || const DeepCollectionEquality().equals(other.outDeliveryCarrierAccount, outDeliveryCarrierAccount)) &&
            (identical(other.outDeliveryShipViaId, outDeliveryShipViaId) || const DeepCollectionEquality().equals(other.outDeliveryShipViaId, outDeliveryShipViaId)) &&
            (identical(other.outDeliveryShipVia, outDeliveryShipVia) || const DeepCollectionEquality().equals(other.outDeliveryShipVia, outDeliveryShipVia)) &&
            (identical(other.outDeliveryInvoiceId, outDeliveryInvoiceId) || const DeepCollectionEquality().equals(other.outDeliveryInvoiceId, outDeliveryInvoiceId)) &&
            (identical(other.outDeliveryVendorInvoiceId, outDeliveryVendorInvoiceId) || const DeepCollectionEquality().equals(other.outDeliveryVendorInvoiceId, outDeliveryVendorInvoiceId)) &&
            (identical(other.outDeliveryEstimatedFreight, outDeliveryEstimatedFreight) || const DeepCollectionEquality().equals(other.outDeliveryEstimatedFreight, outDeliveryEstimatedFreight)) &&
            (identical(other.outDeliveryFreightInvoiceAmount, outDeliveryFreightInvoiceAmount) || const DeepCollectionEquality().equals(other.outDeliveryFreightInvoiceAmount, outDeliveryFreightInvoiceAmount)) &&
            (identical(other.outDeliveryChargeType, outDeliveryChargeType) || const DeepCollectionEquality().equals(other.outDeliveryChargeType, outDeliveryChargeType)) &&
            (identical(other.outDeliveryFreightTrackingNumber, outDeliveryFreightTrackingNumber) || const DeepCollectionEquality().equals(other.outDeliveryFreightTrackingNumber, outDeliveryFreightTrackingNumber)) &&
            (identical(other.outDeliveryFreightTrackingUrl, outDeliveryFreightTrackingUrl) || const DeepCollectionEquality().equals(other.outDeliveryFreightTrackingUrl, outDeliveryFreightTrackingUrl)) &&
            (identical(other.outDeliveryPackageCode, outDeliveryPackageCode) || const DeepCollectionEquality().equals(other.outDeliveryPackageCode, outDeliveryPackageCode)) &&
            (identical(other.outDeliveryBillPoFreightOnOrder, outDeliveryBillPoFreightOnOrder) || const DeepCollectionEquality().equals(other.outDeliveryBillPoFreightOnOrder, outDeliveryBillPoFreightOnOrder)) &&
            (identical(other.outDeliveryOnlineOrderNumber, outDeliveryOnlineOrderNumber) || const DeepCollectionEquality().equals(other.outDeliveryOnlineOrderNumber, outDeliveryOnlineOrderNumber)) &&
            (identical(other.outDeliveryToVenue, outDeliveryToVenue) || const DeepCollectionEquality().equals(other.outDeliveryToVenue, outDeliveryToVenue)) &&
            (identical(other.outDeliveryToVenueId, outDeliveryToVenueId) || const DeepCollectionEquality().equals(other.outDeliveryToVenueId, outDeliveryToVenueId)) &&
            (identical(other.outDeliveryToWarehouse, outDeliveryToWarehouse) || const DeepCollectionEquality().equals(other.outDeliveryToWarehouse, outDeliveryToWarehouse)) &&
            (identical(other.outDeliveryToWarehouseId, outDeliveryToWarehouseId) || const DeepCollectionEquality().equals(other.outDeliveryToWarehouseId, outDeliveryToWarehouseId)) &&
            (identical(other.outDeliveryDateStamp, outDeliveryDateStamp) || const DeepCollectionEquality().equals(other.outDeliveryDateStamp, outDeliveryDateStamp)) &&
            (identical(other.inDeliveryId, inDeliveryId) || const DeepCollectionEquality().equals(other.inDeliveryId, inDeliveryId)) &&
            (identical(other.inDeliveryDeliveryType, inDeliveryDeliveryType) || const DeepCollectionEquality().equals(other.inDeliveryDeliveryType, inDeliveryDeliveryType)) &&
            (identical(other.inDeliveryRequiredDate, inDeliveryRequiredDate) || const DeepCollectionEquality().equals(other.inDeliveryRequiredDate, inDeliveryRequiredDate)) &&
            (identical(other.inDeliveryRequiredTime, inDeliveryRequiredTime) || const DeepCollectionEquality().equals(other.inDeliveryRequiredTime, inDeliveryRequiredTime)) &&
            (identical(other.inDeliveryTargetShipDate, inDeliveryTargetShipDate) || const DeepCollectionEquality().equals(other.inDeliveryTargetShipDate, inDeliveryTargetShipDate)) &&
            (identical(other.inDeliveryTargetShipTime, inDeliveryTargetShipTime) || const DeepCollectionEquality().equals(other.inDeliveryTargetShipTime, inDeliveryTargetShipTime)) &&
            (identical(other.inDeliveryDirection, inDeliveryDirection) || const DeepCollectionEquality().equals(other.inDeliveryDirection, inDeliveryDirection)) &&
            (identical(other.inDeliveryAddressType, inDeliveryAddressType) || const DeepCollectionEquality().equals(other.inDeliveryAddressType, inDeliveryAddressType)) &&
            (identical(other.inDeliveryFromLocation, inDeliveryFromLocation) || const DeepCollectionEquality().equals(other.inDeliveryFromLocation, inDeliveryFromLocation)) &&
            (identical(other.inDeliveryFromContact, inDeliveryFromContact) || const DeepCollectionEquality().equals(other.inDeliveryFromContact, inDeliveryFromContact)) &&
            (identical(other.inDeliveryFromContactPhone, inDeliveryFromContactPhone) || const DeepCollectionEquality().equals(other.inDeliveryFromContactPhone, inDeliveryFromContactPhone)) &&
            (identical(other.inDeliveryFromAlternateContact, inDeliveryFromAlternateContact) || const DeepCollectionEquality().equals(other.inDeliveryFromAlternateContact, inDeliveryFromAlternateContact)) &&
            (identical(other.inDeliveryFromAlternateContactPhone, inDeliveryFromAlternateContactPhone) || const DeepCollectionEquality().equals(other.inDeliveryFromAlternateContactPhone, inDeliveryFromAlternateContactPhone)) &&
            (identical(other.inDeliveryFromAttention, inDeliveryFromAttention) || const DeepCollectionEquality().equals(other.inDeliveryFromAttention, inDeliveryFromAttention)) &&
            (identical(other.inDeliveryFromAddress1, inDeliveryFromAddress1) || const DeepCollectionEquality().equals(other.inDeliveryFromAddress1, inDeliveryFromAddress1)) &&
            (identical(other.inDeliveryFromAdd2ress, inDeliveryFromAdd2ress) || const DeepCollectionEquality().equals(other.inDeliveryFromAdd2ress, inDeliveryFromAdd2ress)) &&
            (identical(other.inDeliveryFromCity, inDeliveryFromCity) || const DeepCollectionEquality().equals(other.inDeliveryFromCity, inDeliveryFromCity)) &&
            (identical(other.inDeliveryFromState, inDeliveryFromState) || const DeepCollectionEquality().equals(other.inDeliveryFromState, inDeliveryFromState)) &&
            (identical(other.inDeliveryFromZipCode, inDeliveryFromZipCode) || const DeepCollectionEquality().equals(other.inDeliveryFromZipCode, inDeliveryFromZipCode)) &&
            (identical(other.inDeliveryFromCountry, inDeliveryFromCountry) || const DeepCollectionEquality().equals(other.inDeliveryFromCountry, inDeliveryFromCountry)) &&
            (identical(other.inDeliveryFromCountryId, inDeliveryFromCountryId) || const DeepCollectionEquality().equals(other.inDeliveryFromCountryId, inDeliveryFromCountryId)) &&
            (identical(other.inDeliveryFromCrossStreets, inDeliveryFromCrossStreets) || const DeepCollectionEquality().equals(other.inDeliveryFromCrossStreets, inDeliveryFromCrossStreets)) &&
            (identical(other.inDeliveryToLocation, inDeliveryToLocation) || const DeepCollectionEquality().equals(other.inDeliveryToLocation, inDeliveryToLocation)) &&
            (identical(other.inDeliveryToContact, inDeliveryToContact) || const DeepCollectionEquality().equals(other.inDeliveryToContact, inDeliveryToContact)) &&
            (identical(other.inDeliveryToContactPhone, inDeliveryToContactPhone) || const DeepCollectionEquality().equals(other.inDeliveryToContactPhone, inDeliveryToContactPhone)) &&
            (identical(other.inDeliveryToAlternateContact, inDeliveryToAlternateContact) || const DeepCollectionEquality().equals(other.inDeliveryToAlternateContact, inDeliveryToAlternateContact)) &&
            (identical(other.inDeliveryToAlternateContactPhone, inDeliveryToAlternateContactPhone) || const DeepCollectionEquality().equals(other.inDeliveryToAlternateContactPhone, inDeliveryToAlternateContactPhone)) &&
            (identical(other.inDeliveryToAttention, inDeliveryToAttention) || const DeepCollectionEquality().equals(other.inDeliveryToAttention, inDeliveryToAttention)) &&
            (identical(other.inDeliveryToAddress1, inDeliveryToAddress1) || const DeepCollectionEquality().equals(other.inDeliveryToAddress1, inDeliveryToAddress1)) &&
            (identical(other.inDeliveryToAddress2, inDeliveryToAddress2) || const DeepCollectionEquality().equals(other.inDeliveryToAddress2, inDeliveryToAddress2)) &&
            (identical(other.inDeliveryToCity, inDeliveryToCity) || const DeepCollectionEquality().equals(other.inDeliveryToCity, inDeliveryToCity)) &&
            (identical(other.inDeliveryToState, inDeliveryToState) || const DeepCollectionEquality().equals(other.inDeliveryToState, inDeliveryToState)) &&
            (identical(other.inDeliveryToZipCode, inDeliveryToZipCode) || const DeepCollectionEquality().equals(other.inDeliveryToZipCode, inDeliveryToZipCode)) &&
            (identical(other.inDeliveryToCountryId, inDeliveryToCountryId) || const DeepCollectionEquality().equals(other.inDeliveryToCountryId, inDeliveryToCountryId)) &&
            (identical(other.inDeliveryToCountry, inDeliveryToCountry) || const DeepCollectionEquality().equals(other.inDeliveryToCountry, inDeliveryToCountry)) &&
            (identical(other.inDeliveryToContactFax, inDeliveryToContactFax) || const DeepCollectionEquality().equals(other.inDeliveryToContactFax, inDeliveryToContactFax)) &&
            (identical(other.inDeliveryToCrossStreets, inDeliveryToCrossStreets) || const DeepCollectionEquality().equals(other.inDeliveryToCrossStreets, inDeliveryToCrossStreets)) &&
            (identical(other.inDeliveryDeliveryNotes, inDeliveryDeliveryNotes) || const DeepCollectionEquality().equals(other.inDeliveryDeliveryNotes, inDeliveryDeliveryNotes)) &&
            (identical(other.inDeliveryCarrierId, inDeliveryCarrierId) || const DeepCollectionEquality().equals(other.inDeliveryCarrierId, inDeliveryCarrierId)) &&
            (identical(other.inDeliveryCarrier, inDeliveryCarrier) || const DeepCollectionEquality().equals(other.inDeliveryCarrier, inDeliveryCarrier)) &&
            (identical(other.inDeliveryCarrierAccount, inDeliveryCarrierAccount) || const DeepCollectionEquality().equals(other.inDeliveryCarrierAccount, inDeliveryCarrierAccount)) &&
            (identical(other.inDeliveryShipViaId, inDeliveryShipViaId) || const DeepCollectionEquality().equals(other.inDeliveryShipViaId, inDeliveryShipViaId)) &&
            (identical(other.inDeliveryShipVia, inDeliveryShipVia) || const DeepCollectionEquality().equals(other.inDeliveryShipVia, inDeliveryShipVia)) &&
            (identical(other.inDeliveryInvoiceId, inDeliveryInvoiceId) || const DeepCollectionEquality().equals(other.inDeliveryInvoiceId, inDeliveryInvoiceId)) &&
            (identical(other.inDeliveryVendorInvoiceId, inDeliveryVendorInvoiceId) || const DeepCollectionEquality().equals(other.inDeliveryVendorInvoiceId, inDeliveryVendorInvoiceId)) &&
            (identical(other.inDeliveryEstimatedFreight, inDeliveryEstimatedFreight) || const DeepCollectionEquality().equals(other.inDeliveryEstimatedFreight, inDeliveryEstimatedFreight)) &&
            (identical(other.inDeliveryFreightInvoiceAmount, inDeliveryFreightInvoiceAmount) || const DeepCollectionEquality().equals(other.inDeliveryFreightInvoiceAmount, inDeliveryFreightInvoiceAmount)) &&
            (identical(other.inDeliveryChargeType, inDeliveryChargeType) || const DeepCollectionEquality().equals(other.inDeliveryChargeType, inDeliveryChargeType)) &&
            (identical(other.inDeliveryFreightTrackingNumber, inDeliveryFreightTrackingNumber) || const DeepCollectionEquality().equals(other.inDeliveryFreightTrackingNumber, inDeliveryFreightTrackingNumber)) &&
            (identical(other.inDeliveryFreightTrackingUrl, inDeliveryFreightTrackingUrl) || const DeepCollectionEquality().equals(other.inDeliveryFreightTrackingUrl, inDeliveryFreightTrackingUrl)) &&
            (identical(other.inDeliveryPackageCode, inDeliveryPackageCode) || const DeepCollectionEquality().equals(other.inDeliveryPackageCode, inDeliveryPackageCode)) &&
            (identical(other.inDeliveryBillPoFreightOnOrder, inDeliveryBillPoFreightOnOrder) || const DeepCollectionEquality().equals(other.inDeliveryBillPoFreightOnOrder, inDeliveryBillPoFreightOnOrder)) &&
            (identical(other.inDeliveryOnlineOrderNumber, inDeliveryOnlineOrderNumber) || const DeepCollectionEquality().equals(other.inDeliveryOnlineOrderNumber, inDeliveryOnlineOrderNumber)) &&
            (identical(other.inDeliveryOnlineOrderStatus, inDeliveryOnlineOrderStatus) || const DeepCollectionEquality().equals(other.inDeliveryOnlineOrderStatus, inDeliveryOnlineOrderStatus)) &&
            (identical(other.inDeliveryToVenue, inDeliveryToVenue) || const DeepCollectionEquality().equals(other.inDeliveryToVenue, inDeliveryToVenue)) &&
            (identical(other.inDeliveryToVenueId, inDeliveryToVenueId) || const DeepCollectionEquality().equals(other.inDeliveryToVenueId, inDeliveryToVenueId)) &&
            (identical(other.inDeliveryToWarehouse, inDeliveryToWarehouse) || const DeepCollectionEquality().equals(other.inDeliveryToWarehouse, inDeliveryToWarehouse)) &&
            (identical(other.inDeliveryToWarehouseId, inDeliveryToWarehouseId) || const DeepCollectionEquality().equals(other.inDeliveryToWarehouseId, inDeliveryToWarehouseId)) &&
            (identical(other.inDeliveryDateStamp, inDeliveryDateStamp) || const DeepCollectionEquality().equals(other.inDeliveryDateStamp, inDeliveryDateStamp)) &&
            (identical(other.rentalDaysPerWeek, rentalDaysPerWeek) || const DeepCollectionEquality().equals(other.rentalDaysPerWeek, rentalDaysPerWeek)) &&
            (identical(other.rentalDiscountPercent, rentalDiscountPercent) || const DeepCollectionEquality().equals(other.rentalDiscountPercent, rentalDiscountPercent)) &&
            (identical(other.weeklyRentalTotal, weeklyRentalTotal) || const DeepCollectionEquality().equals(other.weeklyRentalTotal, weeklyRentalTotal)) &&
            (identical(other.monthlyRentalTotal, monthlyRentalTotal) || const DeepCollectionEquality().equals(other.monthlyRentalTotal, monthlyRentalTotal)) &&
            (identical(other.periodRentalTotal, periodRentalTotal) || const DeepCollectionEquality().equals(other.periodRentalTotal, periodRentalTotal)) &&
            (identical(other.weeklyRentalTotalIncludesTax, weeklyRentalTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklyRentalTotalIncludesTax, weeklyRentalTotalIncludesTax)) &&
            (identical(other.monthlyRentalTotalIncludesTax, monthlyRentalTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlyRentalTotalIncludesTax, monthlyRentalTotalIncludesTax)) &&
            (identical(other.periodRentalTotalIncludesTax, periodRentalTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodRentalTotalIncludesTax, periodRentalTotalIncludesTax)) &&
            (identical(other.billLockedTotal, billLockedTotal) || const DeepCollectionEquality().equals(other.billLockedTotal, billLockedTotal)) &&
            (identical(other.salesDiscountPercent, salesDiscountPercent) || const DeepCollectionEquality().equals(other.salesDiscountPercent, salesDiscountPercent)) &&
            (identical(other.salesTotal, salesTotal) || const DeepCollectionEquality().equals(other.salesTotal, salesTotal)) &&
            (identical(other.salesTotalIncludesTax, salesTotalIncludesTax) || const DeepCollectionEquality().equals(other.salesTotalIncludesTax, salesTotalIncludesTax)) &&
            (identical(other.partsDiscountPercent, partsDiscountPercent) || const DeepCollectionEquality().equals(other.partsDiscountPercent, partsDiscountPercent)) &&
            (identical(other.partsTotal, partsTotal) || const DeepCollectionEquality().equals(other.partsTotal, partsTotal)) &&
            (identical(other.partsTotalIncludesTax, partsTotalIncludesTax) || const DeepCollectionEquality().equals(other.partsTotalIncludesTax, partsTotalIncludesTax)) &&
            (identical(other.spaceDaysPerWeek, spaceDaysPerWeek) || const DeepCollectionEquality().equals(other.spaceDaysPerWeek, spaceDaysPerWeek)) &&
            (identical(other.spaceDiscountPercent, spaceDiscountPercent) || const DeepCollectionEquality().equals(other.spaceDiscountPercent, spaceDiscountPercent)) &&
            (identical(other.spaceSplitPercent, spaceSplitPercent) || const DeepCollectionEquality().equals(other.spaceSplitPercent, spaceSplitPercent)) &&
            (identical(other.weeklySpaceTotal, weeklySpaceTotal) || const DeepCollectionEquality().equals(other.weeklySpaceTotal, weeklySpaceTotal)) &&
            (identical(other.monthlySpaceTotal, monthlySpaceTotal) || const DeepCollectionEquality().equals(other.monthlySpaceTotal, monthlySpaceTotal)) &&
            (identical(other.periodSpaceTotal, periodSpaceTotal) || const DeepCollectionEquality().equals(other.periodSpaceTotal, periodSpaceTotal)) &&
            (identical(other.weeklySpaceTotalIncludesTax, weeklySpaceTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklySpaceTotalIncludesTax, weeklySpaceTotalIncludesTax)) &&
            (identical(other.monthlySpaceTotalIncludesTax, monthlySpaceTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlySpaceTotalIncludesTax, monthlySpaceTotalIncludesTax)) &&
            (identical(other.periodSpaceTotalIncludesTax, periodSpaceTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodSpaceTotalIncludesTax, periodSpaceTotalIncludesTax)) &&
            (identical(other.vehicleDaysPerWeek, vehicleDaysPerWeek) || const DeepCollectionEquality().equals(other.vehicleDaysPerWeek, vehicleDaysPerWeek)) &&
            (identical(other.vehicleDiscountPercent, vehicleDiscountPercent) || const DeepCollectionEquality().equals(other.vehicleDiscountPercent, vehicleDiscountPercent)) &&
            (identical(other.weeklyVehicleTotal, weeklyVehicleTotal) || const DeepCollectionEquality().equals(other.weeklyVehicleTotal, weeklyVehicleTotal)) &&
            (identical(other.monthlyVehicleTotal, monthlyVehicleTotal) || const DeepCollectionEquality().equals(other.monthlyVehicleTotal, monthlyVehicleTotal)) &&
            (identical(other.periodVehicleTotal, periodVehicleTotal) || const DeepCollectionEquality().equals(other.periodVehicleTotal, periodVehicleTotal)) &&
            (identical(other.weeklyVehicleTotalIncludesTax, weeklyVehicleTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklyVehicleTotalIncludesTax, weeklyVehicleTotalIncludesTax)) &&
            (identical(other.monthlyVehicleTotalIncludesTax, monthlyVehicleTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlyVehicleTotalIncludesTax, monthlyVehicleTotalIncludesTax)) &&
            (identical(other.periodVehicleTotalIncludesTax, periodVehicleTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodVehicleTotalIncludesTax, periodVehicleTotalIncludesTax)) &&
            (identical(other.miscDiscountPercent, miscDiscountPercent) || const DeepCollectionEquality().equals(other.miscDiscountPercent, miscDiscountPercent)) &&
            (identical(other.weeklyMiscTotal, weeklyMiscTotal) || const DeepCollectionEquality().equals(other.weeklyMiscTotal, weeklyMiscTotal)) &&
            (identical(other.monthlyMiscTotal, monthlyMiscTotal) || const DeepCollectionEquality().equals(other.monthlyMiscTotal, monthlyMiscTotal)) &&
            (identical(other.periodMiscTotal, periodMiscTotal) || const DeepCollectionEquality().equals(other.periodMiscTotal, periodMiscTotal)) &&
            (identical(other.weeklyMiscTotalIncludesTax, weeklyMiscTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklyMiscTotalIncludesTax, weeklyMiscTotalIncludesTax)) &&
            (identical(other.monthlyMiscTotalIncludesTax, monthlyMiscTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlyMiscTotalIncludesTax, monthlyMiscTotalIncludesTax)) &&
            (identical(other.periodMiscTotalIncludesTax, periodMiscTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodMiscTotalIncludesTax, periodMiscTotalIncludesTax)) &&
            (identical(other.laborDiscountPercent, laborDiscountPercent) || const DeepCollectionEquality().equals(other.laborDiscountPercent, laborDiscountPercent)) &&
            (identical(other.weeklyLaborTotal, weeklyLaborTotal) || const DeepCollectionEquality().equals(other.weeklyLaborTotal, weeklyLaborTotal)) &&
            (identical(other.monthlyLaborTotal, monthlyLaborTotal) || const DeepCollectionEquality().equals(other.monthlyLaborTotal, monthlyLaborTotal)) &&
            (identical(other.periodLaborTotal, periodLaborTotal) || const DeepCollectionEquality().equals(other.periodLaborTotal, periodLaborTotal)) &&
            (identical(other.weeklyLaborTotalIncludesTax, weeklyLaborTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklyLaborTotalIncludesTax, weeklyLaborTotalIncludesTax)) &&
            (identical(other.monthlyLaborTotalIncludesTax, monthlyLaborTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlyLaborTotalIncludesTax, monthlyLaborTotalIncludesTax)) &&
            (identical(other.periodLaborTotalIncludesTax, periodLaborTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodLaborTotalIncludesTax, periodLaborTotalIncludesTax)) &&
            (identical(other.rentalSaleDiscountPercent, rentalSaleDiscountPercent) || const DeepCollectionEquality().equals(other.rentalSaleDiscountPercent, rentalSaleDiscountPercent)) &&
            (identical(other.rentalSaleTotal, rentalSaleTotal) || const DeepCollectionEquality().equals(other.rentalSaleTotal, rentalSaleTotal)) &&
            (identical(other.rentalSaleTotalIncludesTax, rentalSaleTotalIncludesTax) || const DeepCollectionEquality().equals(other.rentalSaleTotalIncludesTax, rentalSaleTotalIncludesTax)) &&
            (identical(other.lossAndDamageDiscountPercent, lossAndDamageDiscountPercent) || const DeepCollectionEquality().equals(other.lossAndDamageDiscountPercent, lossAndDamageDiscountPercent)) &&
            (identical(other.lossAndDamageTotal, lossAndDamageTotal) || const DeepCollectionEquality().equals(other.lossAndDamageTotal, lossAndDamageTotal)) &&
            (identical(other.lossAndDamageTotalIncludesTax, lossAndDamageTotalIncludesTax) || const DeepCollectionEquality().equals(other.lossAndDamageTotalIncludesTax, lossAndDamageTotalIncludesTax)) &&
            (identical(other.combinedDaysPerWeek, combinedDaysPerWeek) || const DeepCollectionEquality().equals(other.combinedDaysPerWeek, combinedDaysPerWeek)) &&
            (identical(other.combinedDiscountPercent, combinedDiscountPercent) || const DeepCollectionEquality().equals(other.combinedDiscountPercent, combinedDiscountPercent)) &&
            (identical(other.weeklyCombinedTotal, weeklyCombinedTotal) || const DeepCollectionEquality().equals(other.weeklyCombinedTotal, weeklyCombinedTotal)) &&
            (identical(other.monthlyCombinedTotal, monthlyCombinedTotal) || const DeepCollectionEquality().equals(other.monthlyCombinedTotal, monthlyCombinedTotal)) &&
            (identical(other.periodCombinedTotal, periodCombinedTotal) || const DeepCollectionEquality().equals(other.periodCombinedTotal, periodCombinedTotal)) &&
            (identical(other.weeklyCombinedTotalIncludesTax, weeklyCombinedTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklyCombinedTotalIncludesTax, weeklyCombinedTotalIncludesTax)) &&
            (identical(other.monthlyCombinedTotalIncludesTax, monthlyCombinedTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlyCombinedTotalIncludesTax, monthlyCombinedTotalIncludesTax)) &&
            (identical(other.periodCombinedTotalIncludesTax, periodCombinedTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodCombinedTotalIncludesTax, periodCombinedTotalIncludesTax)) &&
            (identical(other.disableEditingRentalRate, disableEditingRentalRate) || const DeepCollectionEquality().equals(other.disableEditingRentalRate, disableEditingRentalRate)) &&
            (identical(other.disableEditingSalesRate, disableEditingSalesRate) || const DeepCollectionEquality().equals(other.disableEditingSalesRate, disableEditingSalesRate)) &&
            (identical(other.disableEditingMiscellaneousRate, disableEditingMiscellaneousRate) || const DeepCollectionEquality().equals(other.disableEditingMiscellaneousRate, disableEditingMiscellaneousRate)) &&
            (identical(other.disableEditingLaborRate, disableEditingLaborRate) || const DeepCollectionEquality().equals(other.disableEditingLaborRate, disableEditingLaborRate)) &&
            (identical(other.disableEditingRentalSaleRate, disableEditingRentalSaleRate) || const DeepCollectionEquality().equals(other.disableEditingRentalSaleRate, disableEditingRentalSaleRate)) &&
            (identical(other.disableEditingLossAndDamageRate, disableEditingLossAndDamageRate) || const DeepCollectionEquality().equals(other.disableEditingLossAndDamageRate, disableEditingLossAndDamageRate)) &&
            (identical(other.rentalExtendedTotal, rentalExtendedTotal) || const DeepCollectionEquality().equals(other.rentalExtendedTotal, rentalExtendedTotal)) &&
            (identical(other.salesExtendedTotal, salesExtendedTotal) || const DeepCollectionEquality().equals(other.salesExtendedTotal, salesExtendedTotal)) &&
            (identical(other.laborExtendedTotal, laborExtendedTotal) || const DeepCollectionEquality().equals(other.laborExtendedTotal, laborExtendedTotal)) &&
            (identical(other.miscellaneousExtendedTotal, miscellaneousExtendedTotal) || const DeepCollectionEquality().equals(other.miscellaneousExtendedTotal, miscellaneousExtendedTotal)) &&
            (identical(other.rentalSaleExtendedTotal, rentalSaleExtendedTotal) || const DeepCollectionEquality().equals(other.rentalSaleExtendedTotal, rentalSaleExtendedTotal)) &&
            (identical(other.lossAndDamageExtendedTotal, lossAndDamageExtendedTotal) || const DeepCollectionEquality().equals(other.lossAndDamageExtendedTotal, lossAndDamageExtendedTotal)) &&
            (identical(other.hasNotes, hasNotes) || const DeepCollectionEquality().equals(other.hasNotes, hasNotes)) &&
            (identical(other.hasDocuments, hasDocuments) || const DeepCollectionEquality().equals(other.hasDocuments, hasDocuments)) &&
            (identical(other.hasEmailHistory, hasEmailHistory) || const DeepCollectionEquality().equals(other.hasEmailHistory, hasEmailHistory)) &&
            (identical(other.hasContacts, hasContacts) || const DeepCollectionEquality().equals(other.hasContacts, hasContacts)) &&
            (identical(other.hasSubPurchaseOrders, hasSubPurchaseOrders) || const DeepCollectionEquality().equals(other.hasSubPurchaseOrders, hasSubPurchaseOrders)) &&
            (identical(other.hasPickLists, hasPickLists) || const DeepCollectionEquality().equals(other.hasPickLists, hasPickLists)) &&
            (identical(other.hasContracts, hasContracts) || const DeepCollectionEquality().equals(other.hasContracts, hasContracts)) &&
            (identical(other.hasSuspendedContracts, hasSuspendedContracts) || const DeepCollectionEquality().equals(other.hasSuspendedContracts, hasSuspendedContracts)) &&
            (identical(other.hasMultiOrderContracts, hasMultiOrderContracts) || const DeepCollectionEquality().equals(other.hasMultiOrderContracts, hasMultiOrderContracts)) &&
            (identical(other.hasInvoices, hasInvoices) || const DeepCollectionEquality().equals(other.hasInvoices, hasInvoices)) &&
            (identical(other.hasBillingWorksheets, hasBillingWorksheets) || const DeepCollectionEquality().equals(other.hasBillingWorksheets, hasBillingWorksheets)) &&
            (identical(other.hasMultiOrderInvoices, hasMultiOrderInvoices) || const DeepCollectionEquality().equals(other.hasMultiOrderInvoices, hasMultiOrderInvoices)) &&
            (identical(other.totalReplacementCost, totalReplacementCost) || const DeepCollectionEquality().equals(other.totalReplacementCost, totalReplacementCost)) &&
            (identical(other.presentationLayerId, presentationLayerId) || const DeepCollectionEquality().equals(other.presentationLayerId, presentationLayerId)) &&
            (identical(other.presentationLayer, presentationLayer) || const DeepCollectionEquality().equals(other.presentationLayer, presentationLayer)) &&
            (identical(other.isManualSort, isManualSort) || const DeepCollectionEquality().equals(other.isManualSort, isManualSort)) &&
            (identical(other.quoteOrderTitle, quoteOrderTitle) || const DeepCollectionEquality().equals(other.quoteOrderTitle, quoteOrderTitle)) &&
            (identical(other.unassignedSubs, unassignedSubs) || const DeepCollectionEquality().equals(other.unassignedSubs, unassignedSubs)) &&
            (identical(other.nonTaxable, nonTaxable) || const DeepCollectionEquality().equals(other.nonTaxable, nonTaxable)) &&
            (identical(other.enableProjects, enableProjects) || const DeepCollectionEquality().equals(other.enableProjects, enableProjects)) &&
            (identical(other.projectId, projectId) || const DeepCollectionEquality().equals(other.projectId, projectId)) &&
            (identical(other.projectNumber, projectNumber) || const DeepCollectionEquality().equals(other.projectNumber, projectNumber)) &&
            (identical(other.project, project) || const DeepCollectionEquality().equals(other.project, project)) &&
            (identical(other.projectDrawingsId, projectDrawingsId) || const DeepCollectionEquality().equals(other.projectDrawingsId, projectDrawingsId)) &&
            (identical(other.projectDrawings, projectDrawings) || const DeepCollectionEquality().equals(other.projectDrawings, projectDrawings)) &&
            (identical(other.projectItemsOrderedId, projectItemsOrderedId) || const DeepCollectionEquality().equals(other.projectItemsOrderedId, projectItemsOrderedId)) &&
            (identical(other.projectItemsOrdered, projectItemsOrdered) || const DeepCollectionEquality().equals(other.projectItemsOrdered, projectItemsOrdered)) &&
            (identical(other.projectDropShipId, projectDropShipId) || const DeepCollectionEquality().equals(other.projectDropShipId, projectDropShipId)) &&
            (identical(other.projectDropShip, projectDropShip) || const DeepCollectionEquality().equals(other.projectDropShip, projectDropShip)) &&
            (identical(other.projectAsBuildId, projectAsBuildId) || const DeepCollectionEquality().equals(other.projectAsBuildId, projectAsBuildId)) &&
            (identical(other.projectAsBuild, projectAsBuild) || const DeepCollectionEquality().equals(other.projectAsBuild, projectAsBuild)) &&
            (identical(other.projectCommissioningId, projectCommissioningId) || const DeepCollectionEquality().equals(other.projectCommissioningId, projectCommissioningId)) &&
            (identical(other.projectCommissioning, projectCommissioning) || const DeepCollectionEquality().equals(other.projectCommissioning, projectCommissioning)) &&
            (identical(other.projectDepositId, projectDepositId) || const DeepCollectionEquality().equals(other.projectDepositId, projectDepositId)) &&
            (identical(other.projectDeposit, projectDeposit) || const DeepCollectionEquality().equals(other.projectDeposit, projectDeposit)) &&
            (identical(other.inputByUserId, inputByUserId) || const DeepCollectionEquality().equals(other.inputByUserId, inputByUserId)) &&
            (identical(other.modifiedByUserId, modifiedByUserId) || const DeepCollectionEquality().equals(other.modifiedByUserId, modifiedByUserId)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesAgentOrderOrderExtension
    on WebApiModulesAgentOrderOrder {
  WebApiModulesAgentOrderOrder copyWith(
      {String? orderId,
      String? orderNumber,
      String? orderDate,
      String? sourceQuoteId,
      String? sourceQuoteNumber,
      String? description,
      String? officeLocationId,
      String? officeLocation,
      String? warehouseId,
      String? warehouse,
      String? warehouseCode,
      String? departmentId,
      String? department,
      String? customerId,
      String? customer,
      String? customerNumber,
      String? dealId,
      String? deal,
      String? dealNumber,
      String? rateType,
      String? rateTypeDisplay,
      String? agentId,
      String? agent,
      String? projectManagerId,
      String? projectManager,
      bool? rental,
      bool? sales,
      bool? miscellaneous,
      bool? labor,
      bool? facilities,
      bool? transportation,
      bool? rentalSale,
      bool? lossAndDamage,
      bool? repair,
      bool? hasRentalItem,
      bool? hasSalesItem,
      bool? hasMiscellaneousItem,
      bool? hasLaborItem,
      bool? hasFacilitiesItem,
      bool? hasLossAndDamageItem,
      bool? hasRentalSaleItem,
      bool? hasRepair,
      List<WebApiModulesHomeControlsOrderDatesOrderDates>?
          activityDatesAndTimes,
      String? pickDate,
      String? pickTime,
      String? estimatedStartDate,
      String? estimatedStartTime,
      String? estimatedStopDate,
      String? estimatedStopTime,
      String? pickUpDate,
      String? pickUpTime,
      String? prepDate,
      String? prepTime,
      String? loadInDate,
      String? loadInTime,
      String? strikeDate,
      String? strikeTime,
      String? testDate,
      String? testTime,
      String? orderTypeId,
      String? orderType,
      bool? orderTypeCombineActivityTabs,
      bool? flatPo,
      bool? pendingPo,
      String? poNumber,
      double? poAmount,
      String? location,
      String? orderLocationId,
      String? orderLocation,
      String? referenceNumber,
      double? total,
      String? status,
      String? statusDate,
      String? poApprovalStatusId,
      bool? lockBillingDates,
      bool? specifyBillingDatesByType,
      String? rentalBillingStartDate,
      String? rentalBillingEndDate,
      String? laborBillingStartDate,
      String? laborBillingEndDate,
      String? miscellaneousBillingStartDate,
      String? miscellaneousBillingEndDate,
      String? facilitiesBillingStartDate,
      String? facilitiesBillingEndDate,
      String? vehicleBillingStartDate,
      String? vehicleBillingEndDate,
      String? delayBillingSearchUntil,
      bool? includePrepFeesInRentalRate,
      String? billingStartDate,
      String? billingEndDate,
      double? billingWeeks,
      double? billingMonths,
      String? determineQuantitiesToBillBasedOn,
      String? billingCycleId,
      String? billingCycle,
      String? billingCycleType,
      String? paymentTermsId,
      String? paymentTerms,
      String? paymentTypeId,
      String? paymentType,
      String? currencyId,
      bool? updateAllRatesToNewCurrency,
      String? confirmUpdateAllRatesToNewCurrency,
      String? currencyCode,
      String? currency,
      String? currencySymbol,
      String? taxOptionId,
      String? taxOption,
      String? tax1Name,
      String? tax2Name,
      String? taxId,
      double? rentalTaxRate1,
      double? salesTaxRate1,
      double? laborTaxRate1,
      double? rentalTaxRate2,
      double? salesTaxRate2,
      double? laborTaxRate2,
      bool? noCharge,
      String? noChargeReason,
      String? printIssuedToAddressFrom,
      String? issuedToName,
      String? issuedToAttention,
      String? issuedToAttention2,
      String? issuedToAddress1,
      String? issuedToAddress2,
      String? issuedToCity,
      String? issuedToState,
      String? issuedToZipCode,
      String? issuedToCountryId,
      String? issuedToCountry,
      bool? billToAddressDifferentFromIssuedToAddress,
      String? billToAddressId,
      String? billToName,
      String? billToAttention,
      String? billToAttention2,
      String? billToAddress1,
      String? billToAddress2,
      String? billToCity,
      String? billToState,
      String? billToZipCode,
      String? billToCountryId,
      String? billToCountry,
      String? discountReasonId,
      String? discountReason,
      bool? requireContactConfirmation,
      bool? includeInBillingAnalysis,
      String? hiatusDiscountFrom,
      bool? roundTripRentals,
      bool? inGroup,
      int? groupNumber,
      int? groupColor,
      double? groupOrderBy,
      String? coverLetterId,
      String? coverLetter,
      String? termsConditionsId,
      String? termsConditions,
      String? outsideSalesRepresentativeId,
      String? outsideSalesRepresentative,
      String? marketTypeId,
      String? marketType,
      String? marketSegmentId,
      String? marketSegment,
      String? marketSegmentJobId,
      String? marketSegmentJob,
      String? outDeliveryId,
      String? outDeliveryDeliveryType,
      String? outDeliveryRequiredDate,
      String? outDeliveryRequiredTime,
      String? outDeliveryTargetShipDate,
      String? outDeliveryTargetShipTime,
      String? outDeliveryDirection,
      String? outDeliveryAddressType,
      String? outDeliveryFromLocation,
      String? outDeliveryFromContact,
      String? outDeliveryFromContactPhone,
      String? outDeliveryFromAlternateContact,
      String? outDeliveryFromAlternateContactPhone,
      String? outDeliveryFromAttention,
      String? outDeliveryFromAddress1,
      String? outDeliveryFromAdd2ress,
      String? outDeliveryFromCity,
      String? outDeliveryFromState,
      String? outDeliveryFromZipCode,
      String? outDeliveryFromCountry,
      String? outDeliveryFromCountryId,
      String? outDeliveryFromCrossStreets,
      String? outDeliveryToLocation,
      String? outDeliveryToContact,
      String? outDeliveryToContactPhone,
      String? outDeliveryToAlternateContact,
      String? outDeliveryToAlternateContactPhone,
      String? outDeliveryToAttention,
      String? outDeliveryToAddress1,
      String? outDeliveryToAddress2,
      String? outDeliveryToCity,
      String? outDeliveryToState,
      String? outDeliveryToZipCode,
      String? outDeliveryToCountryId,
      String? outDeliveryToCountry,
      String? outDeliveryToContactFax,
      String? outDeliveryToCrossStreets,
      String? outDeliveryDeliveryNotes,
      String? outDeliveryCarrierId,
      String? outDeliveryCarrier,
      String? outDeliveryCarrierAccount,
      String? outDeliveryShipViaId,
      String? outDeliveryShipVia,
      String? outDeliveryInvoiceId,
      String? outDeliveryVendorInvoiceId,
      double? outDeliveryEstimatedFreight,
      double? outDeliveryFreightInvoiceAmount,
      String? outDeliveryChargeType,
      String? outDeliveryFreightTrackingNumber,
      String? outDeliveryFreightTrackingUrl,
      String? outDeliveryPackageCode,
      bool? outDeliveryBillPoFreightOnOrder,
      String? outDeliveryOnlineOrderNumber,
      String? outDeliveryToVenue,
      String? outDeliveryToVenueId,
      String? outDeliveryToWarehouse,
      String? outDeliveryToWarehouseId,
      String? outDeliveryDateStamp,
      String? inDeliveryId,
      String? inDeliveryDeliveryType,
      String? inDeliveryRequiredDate,
      String? inDeliveryRequiredTime,
      String? inDeliveryTargetShipDate,
      String? inDeliveryTargetShipTime,
      String? inDeliveryDirection,
      String? inDeliveryAddressType,
      String? inDeliveryFromLocation,
      String? inDeliveryFromContact,
      String? inDeliveryFromContactPhone,
      String? inDeliveryFromAlternateContact,
      String? inDeliveryFromAlternateContactPhone,
      String? inDeliveryFromAttention,
      String? inDeliveryFromAddress1,
      String? inDeliveryFromAdd2ress,
      String? inDeliveryFromCity,
      String? inDeliveryFromState,
      String? inDeliveryFromZipCode,
      String? inDeliveryFromCountry,
      String? inDeliveryFromCountryId,
      String? inDeliveryFromCrossStreets,
      String? inDeliveryToLocation,
      String? inDeliveryToContact,
      String? inDeliveryToContactPhone,
      String? inDeliveryToAlternateContact,
      String? inDeliveryToAlternateContactPhone,
      String? inDeliveryToAttention,
      String? inDeliveryToAddress1,
      String? inDeliveryToAddress2,
      String? inDeliveryToCity,
      String? inDeliveryToState,
      String? inDeliveryToZipCode,
      String? inDeliveryToCountryId,
      String? inDeliveryToCountry,
      String? inDeliveryToContactFax,
      String? inDeliveryToCrossStreets,
      String? inDeliveryDeliveryNotes,
      String? inDeliveryCarrierId,
      String? inDeliveryCarrier,
      String? inDeliveryCarrierAccount,
      String? inDeliveryShipViaId,
      String? inDeliveryShipVia,
      String? inDeliveryInvoiceId,
      String? inDeliveryVendorInvoiceId,
      double? inDeliveryEstimatedFreight,
      double? inDeliveryFreightInvoiceAmount,
      String? inDeliveryChargeType,
      String? inDeliveryFreightTrackingNumber,
      String? inDeliveryFreightTrackingUrl,
      String? inDeliveryPackageCode,
      bool? inDeliveryBillPoFreightOnOrder,
      String? inDeliveryOnlineOrderNumber,
      String? inDeliveryOnlineOrderStatus,
      String? inDeliveryToVenue,
      String? inDeliveryToVenueId,
      String? inDeliveryToWarehouse,
      String? inDeliveryToWarehouseId,
      String? inDeliveryDateStamp,
      double? rentalDaysPerWeek,
      double? rentalDiscountPercent,
      double? weeklyRentalTotal,
      double? monthlyRentalTotal,
      double? periodRentalTotal,
      bool? weeklyRentalTotalIncludesTax,
      bool? monthlyRentalTotalIncludesTax,
      bool? periodRentalTotalIncludesTax,
      bool? billLockedTotal,
      double? salesDiscountPercent,
      double? salesTotal,
      bool? salesTotalIncludesTax,
      double? partsDiscountPercent,
      double? partsTotal,
      bool? partsTotalIncludesTax,
      double? spaceDaysPerWeek,
      double? spaceDiscountPercent,
      double? spaceSplitPercent,
      double? weeklySpaceTotal,
      double? monthlySpaceTotal,
      double? periodSpaceTotal,
      bool? weeklySpaceTotalIncludesTax,
      bool? monthlySpaceTotalIncludesTax,
      bool? periodSpaceTotalIncludesTax,
      double? vehicleDaysPerWeek,
      double? vehicleDiscountPercent,
      double? weeklyVehicleTotal,
      double? monthlyVehicleTotal,
      double? periodVehicleTotal,
      bool? weeklyVehicleTotalIncludesTax,
      bool? monthlyVehicleTotalIncludesTax,
      bool? periodVehicleTotalIncludesTax,
      double? miscDiscountPercent,
      double? weeklyMiscTotal,
      double? monthlyMiscTotal,
      double? periodMiscTotal,
      bool? weeklyMiscTotalIncludesTax,
      bool? monthlyMiscTotalIncludesTax,
      bool? periodMiscTotalIncludesTax,
      double? laborDiscountPercent,
      double? weeklyLaborTotal,
      double? monthlyLaborTotal,
      double? periodLaborTotal,
      bool? weeklyLaborTotalIncludesTax,
      bool? monthlyLaborTotalIncludesTax,
      bool? periodLaborTotalIncludesTax,
      double? rentalSaleDiscountPercent,
      double? rentalSaleTotal,
      bool? rentalSaleTotalIncludesTax,
      double? lossAndDamageDiscountPercent,
      double? lossAndDamageTotal,
      bool? lossAndDamageTotalIncludesTax,
      double? combinedDaysPerWeek,
      double? combinedDiscountPercent,
      double? weeklyCombinedTotal,
      double? monthlyCombinedTotal,
      double? periodCombinedTotal,
      bool? weeklyCombinedTotalIncludesTax,
      bool? monthlyCombinedTotalIncludesTax,
      bool? periodCombinedTotalIncludesTax,
      bool? disableEditingRentalRate,
      bool? disableEditingSalesRate,
      bool? disableEditingMiscellaneousRate,
      bool? disableEditingLaborRate,
      bool? disableEditingRentalSaleRate,
      bool? disableEditingLossAndDamageRate,
      double? rentalExtendedTotal,
      double? salesExtendedTotal,
      double? laborExtendedTotal,
      double? miscellaneousExtendedTotal,
      double? rentalSaleExtendedTotal,
      double? lossAndDamageExtendedTotal,
      bool? hasNotes,
      bool? hasDocuments,
      bool? hasEmailHistory,
      bool? hasContacts,
      bool? hasSubPurchaseOrders,
      bool? hasPickLists,
      bool? hasContracts,
      bool? hasSuspendedContracts,
      bool? hasMultiOrderContracts,
      bool? hasInvoices,
      bool? hasBillingWorksheets,
      bool? hasMultiOrderInvoices,
      double? totalReplacementCost,
      String? presentationLayerId,
      String? presentationLayer,
      bool? isManualSort,
      String? quoteOrderTitle,
      bool? unassignedSubs,
      bool? nonTaxable,
      bool? enableProjects,
      String? projectId,
      String? projectNumber,
      String? project,
      String? projectDrawingsId,
      String? projectDrawings,
      String? projectItemsOrderedId,
      String? projectItemsOrdered,
      String? projectDropShipId,
      String? projectDropShip,
      String? projectAsBuildId,
      String? projectAsBuild,
      String? projectCommissioningId,
      String? projectCommissioning,
      String? projectDepositId,
      String? projectDeposit,
      String? inputByUserId,
      String? modifiedByUserId,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAgentOrderOrder(
        orderId: orderId ?? this.orderId,
        orderNumber: orderNumber ?? this.orderNumber,
        orderDate: orderDate ?? this.orderDate,
        sourceQuoteId: sourceQuoteId ?? this.sourceQuoteId,
        sourceQuoteNumber: sourceQuoteNumber ?? this.sourceQuoteNumber,
        description: description ?? this.description,
        officeLocationId: officeLocationId ?? this.officeLocationId,
        officeLocation: officeLocation ?? this.officeLocation,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouse: warehouse ?? this.warehouse,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        departmentId: departmentId ?? this.departmentId,
        department: department ?? this.department,
        customerId: customerId ?? this.customerId,
        customer: customer ?? this.customer,
        customerNumber: customerNumber ?? this.customerNumber,
        dealId: dealId ?? this.dealId,
        deal: deal ?? this.deal,
        dealNumber: dealNumber ?? this.dealNumber,
        rateType: rateType ?? this.rateType,
        rateTypeDisplay: rateTypeDisplay ?? this.rateTypeDisplay,
        agentId: agentId ?? this.agentId,
        agent: agent ?? this.agent,
        projectManagerId: projectManagerId ?? this.projectManagerId,
        projectManager: projectManager ?? this.projectManager,
        rental: rental ?? this.rental,
        sales: sales ?? this.sales,
        miscellaneous: miscellaneous ?? this.miscellaneous,
        labor: labor ?? this.labor,
        facilities: facilities ?? this.facilities,
        transportation: transportation ?? this.transportation,
        rentalSale: rentalSale ?? this.rentalSale,
        lossAndDamage: lossAndDamage ?? this.lossAndDamage,
        repair: repair ?? this.repair,
        hasRentalItem: hasRentalItem ?? this.hasRentalItem,
        hasSalesItem: hasSalesItem ?? this.hasSalesItem,
        hasMiscellaneousItem: hasMiscellaneousItem ?? this.hasMiscellaneousItem,
        hasLaborItem: hasLaborItem ?? this.hasLaborItem,
        hasFacilitiesItem: hasFacilitiesItem ?? this.hasFacilitiesItem,
        hasLossAndDamageItem: hasLossAndDamageItem ?? this.hasLossAndDamageItem,
        hasRentalSaleItem: hasRentalSaleItem ?? this.hasRentalSaleItem,
        hasRepair: hasRepair ?? this.hasRepair,
        activityDatesAndTimes:
            activityDatesAndTimes ?? this.activityDatesAndTimes,
        pickDate: pickDate ?? this.pickDate,
        pickTime: pickTime ?? this.pickTime,
        estimatedStartDate: estimatedStartDate ?? this.estimatedStartDate,
        estimatedStartTime: estimatedStartTime ?? this.estimatedStartTime,
        estimatedStopDate: estimatedStopDate ?? this.estimatedStopDate,
        estimatedStopTime: estimatedStopTime ?? this.estimatedStopTime,
        pickUpDate: pickUpDate ?? this.pickUpDate,
        pickUpTime: pickUpTime ?? this.pickUpTime,
        prepDate: prepDate ?? this.prepDate,
        prepTime: prepTime ?? this.prepTime,
        loadInDate: loadInDate ?? this.loadInDate,
        loadInTime: loadInTime ?? this.loadInTime,
        strikeDate: strikeDate ?? this.strikeDate,
        strikeTime: strikeTime ?? this.strikeTime,
        testDate: testDate ?? this.testDate,
        testTime: testTime ?? this.testTime,
        orderTypeId: orderTypeId ?? this.orderTypeId,
        orderType: orderType ?? this.orderType,
        orderTypeCombineActivityTabs:
            orderTypeCombineActivityTabs ?? this.orderTypeCombineActivityTabs,
        flatPo: flatPo ?? this.flatPo,
        pendingPo: pendingPo ?? this.pendingPo,
        poNumber: poNumber ?? this.poNumber,
        poAmount: poAmount ?? this.poAmount,
        location: location ?? this.location,
        orderLocationId: orderLocationId ?? this.orderLocationId,
        orderLocation: orderLocation ?? this.orderLocation,
        referenceNumber: referenceNumber ?? this.referenceNumber,
        total: total ?? this.total,
        status: status ?? this.status,
        statusDate: statusDate ?? this.statusDate,
        poApprovalStatusId: poApprovalStatusId ?? this.poApprovalStatusId,
        lockBillingDates: lockBillingDates ?? this.lockBillingDates,
        specifyBillingDatesByType:
            specifyBillingDatesByType ?? this.specifyBillingDatesByType,
        rentalBillingStartDate:
            rentalBillingStartDate ?? this.rentalBillingStartDate,
        rentalBillingEndDate: rentalBillingEndDate ?? this.rentalBillingEndDate,
        laborBillingStartDate:
            laborBillingStartDate ?? this.laborBillingStartDate,
        laborBillingEndDate: laborBillingEndDate ?? this.laborBillingEndDate,
        miscellaneousBillingStartDate:
            miscellaneousBillingStartDate ?? this.miscellaneousBillingStartDate,
        miscellaneousBillingEndDate:
            miscellaneousBillingEndDate ?? this.miscellaneousBillingEndDate,
        facilitiesBillingStartDate:
            facilitiesBillingStartDate ?? this.facilitiesBillingStartDate,
        facilitiesBillingEndDate:
            facilitiesBillingEndDate ?? this.facilitiesBillingEndDate,
        vehicleBillingStartDate:
            vehicleBillingStartDate ?? this.vehicleBillingStartDate,
        vehicleBillingEndDate:
            vehicleBillingEndDate ?? this.vehicleBillingEndDate,
        delayBillingSearchUntil:
            delayBillingSearchUntil ?? this.delayBillingSearchUntil,
        includePrepFeesInRentalRate:
            includePrepFeesInRentalRate ?? this.includePrepFeesInRentalRate,
        billingStartDate: billingStartDate ?? this.billingStartDate,
        billingEndDate: billingEndDate ?? this.billingEndDate,
        billingWeeks: billingWeeks ?? this.billingWeeks,
        billingMonths: billingMonths ?? this.billingMonths,
        determineQuantitiesToBillBasedOn: determineQuantitiesToBillBasedOn ??
            this.determineQuantitiesToBillBasedOn,
        billingCycleId: billingCycleId ?? this.billingCycleId,
        billingCycle: billingCycle ?? this.billingCycle,
        billingCycleType: billingCycleType ?? this.billingCycleType,
        paymentTermsId: paymentTermsId ?? this.paymentTermsId,
        paymentTerms: paymentTerms ?? this.paymentTerms,
        paymentTypeId: paymentTypeId ?? this.paymentTypeId,
        paymentType: paymentType ?? this.paymentType,
        currencyId: currencyId ?? this.currencyId,
        updateAllRatesToNewCurrency:
            updateAllRatesToNewCurrency ?? this.updateAllRatesToNewCurrency,
        confirmUpdateAllRatesToNewCurrency: confirmUpdateAllRatesToNewCurrency ??
            this.confirmUpdateAllRatesToNewCurrency,
        currencyCode: currencyCode ?? this.currencyCode,
        currency: currency ?? this.currency,
        currencySymbol: currencySymbol ?? this.currencySymbol,
        taxOptionId: taxOptionId ?? this.taxOptionId,
        taxOption: taxOption ?? this.taxOption,
        tax1Name: tax1Name ?? this.tax1Name,
        tax2Name: tax2Name ?? this.tax2Name,
        taxId: taxId ?? this.taxId,
        rentalTaxRate1: rentalTaxRate1 ?? this.rentalTaxRate1,
        salesTaxRate1: salesTaxRate1 ?? this.salesTaxRate1,
        laborTaxRate1: laborTaxRate1 ?? this.laborTaxRate1,
        rentalTaxRate2: rentalTaxRate2 ?? this.rentalTaxRate2,
        salesTaxRate2: salesTaxRate2 ?? this.salesTaxRate2,
        laborTaxRate2: laborTaxRate2 ?? this.laborTaxRate2,
        noCharge: noCharge ?? this.noCharge,
        noChargeReason: noChargeReason ?? this.noChargeReason,
        printIssuedToAddressFrom:
            printIssuedToAddressFrom ?? this.printIssuedToAddressFrom,
        issuedToName: issuedToName ?? this.issuedToName,
        issuedToAttention: issuedToAttention ?? this.issuedToAttention,
        issuedToAttention2: issuedToAttention2 ?? this.issuedToAttention2,
        issuedToAddress1: issuedToAddress1 ?? this.issuedToAddress1,
        issuedToAddress2: issuedToAddress2 ?? this.issuedToAddress2,
        issuedToCity: issuedToCity ?? this.issuedToCity,
        issuedToState: issuedToState ?? this.issuedToState,
        issuedToZipCode: issuedToZipCode ?? this.issuedToZipCode,
        issuedToCountryId: issuedToCountryId ?? this.issuedToCountryId,
        issuedToCountry: issuedToCountry ?? this.issuedToCountry,
        billToAddressDifferentFromIssuedToAddress:
            billToAddressDifferentFromIssuedToAddress ??
                this.billToAddressDifferentFromIssuedToAddress,
        billToAddressId: billToAddressId ?? this.billToAddressId,
        billToName: billToName ?? this.billToName,
        billToAttention: billToAttention ?? this.billToAttention,
        billToAttention2: billToAttention2 ?? this.billToAttention2,
        billToAddress1: billToAddress1 ?? this.billToAddress1,
        billToAddress2: billToAddress2 ?? this.billToAddress2,
        billToCity: billToCity ?? this.billToCity,
        billToState: billToState ?? this.billToState,
        billToZipCode: billToZipCode ?? this.billToZipCode,
        billToCountryId: billToCountryId ?? this.billToCountryId,
        billToCountry: billToCountry ?? this.billToCountry,
        discountReasonId: discountReasonId ?? this.discountReasonId,
        discountReason: discountReason ?? this.discountReason,
        requireContactConfirmation:
            requireContactConfirmation ?? this.requireContactConfirmation,
        includeInBillingAnalysis:
            includeInBillingAnalysis ?? this.includeInBillingAnalysis,
        hiatusDiscountFrom: hiatusDiscountFrom ?? this.hiatusDiscountFrom,
        roundTripRentals: roundTripRentals ?? this.roundTripRentals,
        inGroup: inGroup ?? this.inGroup,
        groupNumber: groupNumber ?? this.groupNumber,
        groupColor: groupColor ?? this.groupColor,
        groupOrderBy: groupOrderBy ?? this.groupOrderBy,
        coverLetterId: coverLetterId ?? this.coverLetterId,
        coverLetter: coverLetter ?? this.coverLetter,
        termsConditionsId: termsConditionsId ?? this.termsConditionsId,
        termsConditions: termsConditions ?? this.termsConditions,
        outsideSalesRepresentativeId:
            outsideSalesRepresentativeId ?? this.outsideSalesRepresentativeId,
        outsideSalesRepresentative:
            outsideSalesRepresentative ?? this.outsideSalesRepresentative,
        marketTypeId: marketTypeId ?? this.marketTypeId,
        marketType: marketType ?? this.marketType,
        marketSegmentId: marketSegmentId ?? this.marketSegmentId,
        marketSegment: marketSegment ?? this.marketSegment,
        marketSegmentJobId: marketSegmentJobId ?? this.marketSegmentJobId,
        marketSegmentJob: marketSegmentJob ?? this.marketSegmentJob,
        outDeliveryId: outDeliveryId ?? this.outDeliveryId,
        outDeliveryDeliveryType:
            outDeliveryDeliveryType ?? this.outDeliveryDeliveryType,
        outDeliveryRequiredDate:
            outDeliveryRequiredDate ?? this.outDeliveryRequiredDate,
        outDeliveryRequiredTime:
            outDeliveryRequiredTime ?? this.outDeliveryRequiredTime,
        outDeliveryTargetShipDate:
            outDeliveryTargetShipDate ?? this.outDeliveryTargetShipDate,
        outDeliveryTargetShipTime:
            outDeliveryTargetShipTime ?? this.outDeliveryTargetShipTime,
        outDeliveryDirection: outDeliveryDirection ?? this.outDeliveryDirection,
        outDeliveryAddressType:
            outDeliveryAddressType ?? this.outDeliveryAddressType,
        outDeliveryFromLocation:
            outDeliveryFromLocation ?? this.outDeliveryFromLocation,
        outDeliveryFromContact:
            outDeliveryFromContact ?? this.outDeliveryFromContact,
        outDeliveryFromContactPhone:
            outDeliveryFromContactPhone ?? this.outDeliveryFromContactPhone,
        outDeliveryFromAlternateContact: outDeliveryFromAlternateContact ??
            this.outDeliveryFromAlternateContact,
        outDeliveryFromAlternateContactPhone: outDeliveryFromAlternateContactPhone ??
            this.outDeliveryFromAlternateContactPhone,
        outDeliveryFromAttention:
            outDeliveryFromAttention ?? this.outDeliveryFromAttention,
        outDeliveryFromAddress1:
            outDeliveryFromAddress1 ?? this.outDeliveryFromAddress1,
        outDeliveryFromAdd2ress:
            outDeliveryFromAdd2ress ?? this.outDeliveryFromAdd2ress,
        outDeliveryFromCity: outDeliveryFromCity ?? this.outDeliveryFromCity,
        outDeliveryFromState: outDeliveryFromState ?? this.outDeliveryFromState,
        outDeliveryFromZipCode:
            outDeliveryFromZipCode ?? this.outDeliveryFromZipCode,
        outDeliveryFromCountry:
            outDeliveryFromCountry ?? this.outDeliveryFromCountry,
        outDeliveryFromCountryId:
            outDeliveryFromCountryId ?? this.outDeliveryFromCountryId,
        outDeliveryFromCrossStreets:
            outDeliveryFromCrossStreets ?? this.outDeliveryFromCrossStreets,
        outDeliveryToLocation:
            outDeliveryToLocation ?? this.outDeliveryToLocation,
        outDeliveryToContact: outDeliveryToContact ?? this.outDeliveryToContact,
        outDeliveryToContactPhone:
            outDeliveryToContactPhone ?? this.outDeliveryToContactPhone,
        outDeliveryToAlternateContact:
            outDeliveryToAlternateContact ?? this.outDeliveryToAlternateContact,
        outDeliveryToAlternateContactPhone:
            outDeliveryToAlternateContactPhone ?? this.outDeliveryToAlternateContactPhone,
        outDeliveryToAttention: outDeliveryToAttention ?? this.outDeliveryToAttention,
        outDeliveryToAddress1: outDeliveryToAddress1 ?? this.outDeliveryToAddress1,
        outDeliveryToAddress2: outDeliveryToAddress2 ?? this.outDeliveryToAddress2,
        outDeliveryToCity: outDeliveryToCity ?? this.outDeliveryToCity,
        outDeliveryToState: outDeliveryToState ?? this.outDeliveryToState,
        outDeliveryToZipCode: outDeliveryToZipCode ?? this.outDeliveryToZipCode,
        outDeliveryToCountryId: outDeliveryToCountryId ?? this.outDeliveryToCountryId,
        outDeliveryToCountry: outDeliveryToCountry ?? this.outDeliveryToCountry,
        outDeliveryToContactFax: outDeliveryToContactFax ?? this.outDeliveryToContactFax,
        outDeliveryToCrossStreets: outDeliveryToCrossStreets ?? this.outDeliveryToCrossStreets,
        outDeliveryDeliveryNotes: outDeliveryDeliveryNotes ?? this.outDeliveryDeliveryNotes,
        outDeliveryCarrierId: outDeliveryCarrierId ?? this.outDeliveryCarrierId,
        outDeliveryCarrier: outDeliveryCarrier ?? this.outDeliveryCarrier,
        outDeliveryCarrierAccount: outDeliveryCarrierAccount ?? this.outDeliveryCarrierAccount,
        outDeliveryShipViaId: outDeliveryShipViaId ?? this.outDeliveryShipViaId,
        outDeliveryShipVia: outDeliveryShipVia ?? this.outDeliveryShipVia,
        outDeliveryInvoiceId: outDeliveryInvoiceId ?? this.outDeliveryInvoiceId,
        outDeliveryVendorInvoiceId: outDeliveryVendorInvoiceId ?? this.outDeliveryVendorInvoiceId,
        outDeliveryEstimatedFreight: outDeliveryEstimatedFreight ?? this.outDeliveryEstimatedFreight,
        outDeliveryFreightInvoiceAmount: outDeliveryFreightInvoiceAmount ?? this.outDeliveryFreightInvoiceAmount,
        outDeliveryChargeType: outDeliveryChargeType ?? this.outDeliveryChargeType,
        outDeliveryFreightTrackingNumber: outDeliveryFreightTrackingNumber ?? this.outDeliveryFreightTrackingNumber,
        outDeliveryFreightTrackingUrl: outDeliveryFreightTrackingUrl ?? this.outDeliveryFreightTrackingUrl,
        outDeliveryPackageCode: outDeliveryPackageCode ?? this.outDeliveryPackageCode,
        outDeliveryBillPoFreightOnOrder: outDeliveryBillPoFreightOnOrder ?? this.outDeliveryBillPoFreightOnOrder,
        outDeliveryOnlineOrderNumber: outDeliveryOnlineOrderNumber ?? this.outDeliveryOnlineOrderNumber,
        outDeliveryToVenue: outDeliveryToVenue ?? this.outDeliveryToVenue,
        outDeliveryToVenueId: outDeliveryToVenueId ?? this.outDeliveryToVenueId,
        outDeliveryToWarehouse: outDeliveryToWarehouse ?? this.outDeliveryToWarehouse,
        outDeliveryToWarehouseId: outDeliveryToWarehouseId ?? this.outDeliveryToWarehouseId,
        outDeliveryDateStamp: outDeliveryDateStamp ?? this.outDeliveryDateStamp,
        inDeliveryId: inDeliveryId ?? this.inDeliveryId,
        inDeliveryDeliveryType: inDeliveryDeliveryType ?? this.inDeliveryDeliveryType,
        inDeliveryRequiredDate: inDeliveryRequiredDate ?? this.inDeliveryRequiredDate,
        inDeliveryRequiredTime: inDeliveryRequiredTime ?? this.inDeliveryRequiredTime,
        inDeliveryTargetShipDate: inDeliveryTargetShipDate ?? this.inDeliveryTargetShipDate,
        inDeliveryTargetShipTime: inDeliveryTargetShipTime ?? this.inDeliveryTargetShipTime,
        inDeliveryDirection: inDeliveryDirection ?? this.inDeliveryDirection,
        inDeliveryAddressType: inDeliveryAddressType ?? this.inDeliveryAddressType,
        inDeliveryFromLocation: inDeliveryFromLocation ?? this.inDeliveryFromLocation,
        inDeliveryFromContact: inDeliveryFromContact ?? this.inDeliveryFromContact,
        inDeliveryFromContactPhone: inDeliveryFromContactPhone ?? this.inDeliveryFromContactPhone,
        inDeliveryFromAlternateContact: inDeliveryFromAlternateContact ?? this.inDeliveryFromAlternateContact,
        inDeliveryFromAlternateContactPhone: inDeliveryFromAlternateContactPhone ?? this.inDeliveryFromAlternateContactPhone,
        inDeliveryFromAttention: inDeliveryFromAttention ?? this.inDeliveryFromAttention,
        inDeliveryFromAddress1: inDeliveryFromAddress1 ?? this.inDeliveryFromAddress1,
        inDeliveryFromAdd2ress: inDeliveryFromAdd2ress ?? this.inDeliveryFromAdd2ress,
        inDeliveryFromCity: inDeliveryFromCity ?? this.inDeliveryFromCity,
        inDeliveryFromState: inDeliveryFromState ?? this.inDeliveryFromState,
        inDeliveryFromZipCode: inDeliveryFromZipCode ?? this.inDeliveryFromZipCode,
        inDeliveryFromCountry: inDeliveryFromCountry ?? this.inDeliveryFromCountry,
        inDeliveryFromCountryId: inDeliveryFromCountryId ?? this.inDeliveryFromCountryId,
        inDeliveryFromCrossStreets: inDeliveryFromCrossStreets ?? this.inDeliveryFromCrossStreets,
        inDeliveryToLocation: inDeliveryToLocation ?? this.inDeliveryToLocation,
        inDeliveryToContact: inDeliveryToContact ?? this.inDeliveryToContact,
        inDeliveryToContactPhone: inDeliveryToContactPhone ?? this.inDeliveryToContactPhone,
        inDeliveryToAlternateContact: inDeliveryToAlternateContact ?? this.inDeliveryToAlternateContact,
        inDeliveryToAlternateContactPhone: inDeliveryToAlternateContactPhone ?? this.inDeliveryToAlternateContactPhone,
        inDeliveryToAttention: inDeliveryToAttention ?? this.inDeliveryToAttention,
        inDeliveryToAddress1: inDeliveryToAddress1 ?? this.inDeliveryToAddress1,
        inDeliveryToAddress2: inDeliveryToAddress2 ?? this.inDeliveryToAddress2,
        inDeliveryToCity: inDeliveryToCity ?? this.inDeliveryToCity,
        inDeliveryToState: inDeliveryToState ?? this.inDeliveryToState,
        inDeliveryToZipCode: inDeliveryToZipCode ?? this.inDeliveryToZipCode,
        inDeliveryToCountryId: inDeliveryToCountryId ?? this.inDeliveryToCountryId,
        inDeliveryToCountry: inDeliveryToCountry ?? this.inDeliveryToCountry,
        inDeliveryToContactFax: inDeliveryToContactFax ?? this.inDeliveryToContactFax,
        inDeliveryToCrossStreets: inDeliveryToCrossStreets ?? this.inDeliveryToCrossStreets,
        inDeliveryDeliveryNotes: inDeliveryDeliveryNotes ?? this.inDeliveryDeliveryNotes,
        inDeliveryCarrierId: inDeliveryCarrierId ?? this.inDeliveryCarrierId,
        inDeliveryCarrier: inDeliveryCarrier ?? this.inDeliveryCarrier,
        inDeliveryCarrierAccount: inDeliveryCarrierAccount ?? this.inDeliveryCarrierAccount,
        inDeliveryShipViaId: inDeliveryShipViaId ?? this.inDeliveryShipViaId,
        inDeliveryShipVia: inDeliveryShipVia ?? this.inDeliveryShipVia,
        inDeliveryInvoiceId: inDeliveryInvoiceId ?? this.inDeliveryInvoiceId,
        inDeliveryVendorInvoiceId: inDeliveryVendorInvoiceId ?? this.inDeliveryVendorInvoiceId,
        inDeliveryEstimatedFreight: inDeliveryEstimatedFreight ?? this.inDeliveryEstimatedFreight,
        inDeliveryFreightInvoiceAmount: inDeliveryFreightInvoiceAmount ?? this.inDeliveryFreightInvoiceAmount,
        inDeliveryChargeType: inDeliveryChargeType ?? this.inDeliveryChargeType,
        inDeliveryFreightTrackingNumber: inDeliveryFreightTrackingNumber ?? this.inDeliveryFreightTrackingNumber,
        inDeliveryFreightTrackingUrl: inDeliveryFreightTrackingUrl ?? this.inDeliveryFreightTrackingUrl,
        inDeliveryPackageCode: inDeliveryPackageCode ?? this.inDeliveryPackageCode,
        inDeliveryBillPoFreightOnOrder: inDeliveryBillPoFreightOnOrder ?? this.inDeliveryBillPoFreightOnOrder,
        inDeliveryOnlineOrderNumber: inDeliveryOnlineOrderNumber ?? this.inDeliveryOnlineOrderNumber,
        inDeliveryOnlineOrderStatus: inDeliveryOnlineOrderStatus ?? this.inDeliveryOnlineOrderStatus,
        inDeliveryToVenue: inDeliveryToVenue ?? this.inDeliveryToVenue,
        inDeliveryToVenueId: inDeliveryToVenueId ?? this.inDeliveryToVenueId,
        inDeliveryToWarehouse: inDeliveryToWarehouse ?? this.inDeliveryToWarehouse,
        inDeliveryToWarehouseId: inDeliveryToWarehouseId ?? this.inDeliveryToWarehouseId,
        inDeliveryDateStamp: inDeliveryDateStamp ?? this.inDeliveryDateStamp,
        rentalDaysPerWeek: rentalDaysPerWeek ?? this.rentalDaysPerWeek,
        rentalDiscountPercent: rentalDiscountPercent ?? this.rentalDiscountPercent,
        weeklyRentalTotal: weeklyRentalTotal ?? this.weeklyRentalTotal,
        monthlyRentalTotal: monthlyRentalTotal ?? this.monthlyRentalTotal,
        periodRentalTotal: periodRentalTotal ?? this.periodRentalTotal,
        weeklyRentalTotalIncludesTax: weeklyRentalTotalIncludesTax ?? this.weeklyRentalTotalIncludesTax,
        monthlyRentalTotalIncludesTax: monthlyRentalTotalIncludesTax ?? this.monthlyRentalTotalIncludesTax,
        periodRentalTotalIncludesTax: periodRentalTotalIncludesTax ?? this.periodRentalTotalIncludesTax,
        billLockedTotal: billLockedTotal ?? this.billLockedTotal,
        salesDiscountPercent: salesDiscountPercent ?? this.salesDiscountPercent,
        salesTotal: salesTotal ?? this.salesTotal,
        salesTotalIncludesTax: salesTotalIncludesTax ?? this.salesTotalIncludesTax,
        partsDiscountPercent: partsDiscountPercent ?? this.partsDiscountPercent,
        partsTotal: partsTotal ?? this.partsTotal,
        partsTotalIncludesTax: partsTotalIncludesTax ?? this.partsTotalIncludesTax,
        spaceDaysPerWeek: spaceDaysPerWeek ?? this.spaceDaysPerWeek,
        spaceDiscountPercent: spaceDiscountPercent ?? this.spaceDiscountPercent,
        spaceSplitPercent: spaceSplitPercent ?? this.spaceSplitPercent,
        weeklySpaceTotal: weeklySpaceTotal ?? this.weeklySpaceTotal,
        monthlySpaceTotal: monthlySpaceTotal ?? this.monthlySpaceTotal,
        periodSpaceTotal: periodSpaceTotal ?? this.periodSpaceTotal,
        weeklySpaceTotalIncludesTax: weeklySpaceTotalIncludesTax ?? this.weeklySpaceTotalIncludesTax,
        monthlySpaceTotalIncludesTax: monthlySpaceTotalIncludesTax ?? this.monthlySpaceTotalIncludesTax,
        periodSpaceTotalIncludesTax: periodSpaceTotalIncludesTax ?? this.periodSpaceTotalIncludesTax,
        vehicleDaysPerWeek: vehicleDaysPerWeek ?? this.vehicleDaysPerWeek,
        vehicleDiscountPercent: vehicleDiscountPercent ?? this.vehicleDiscountPercent,
        weeklyVehicleTotal: weeklyVehicleTotal ?? this.weeklyVehicleTotal,
        monthlyVehicleTotal: monthlyVehicleTotal ?? this.monthlyVehicleTotal,
        periodVehicleTotal: periodVehicleTotal ?? this.periodVehicleTotal,
        weeklyVehicleTotalIncludesTax: weeklyVehicleTotalIncludesTax ?? this.weeklyVehicleTotalIncludesTax,
        monthlyVehicleTotalIncludesTax: monthlyVehicleTotalIncludesTax ?? this.monthlyVehicleTotalIncludesTax,
        periodVehicleTotalIncludesTax: periodVehicleTotalIncludesTax ?? this.periodVehicleTotalIncludesTax,
        miscDiscountPercent: miscDiscountPercent ?? this.miscDiscountPercent,
        weeklyMiscTotal: weeklyMiscTotal ?? this.weeklyMiscTotal,
        monthlyMiscTotal: monthlyMiscTotal ?? this.monthlyMiscTotal,
        periodMiscTotal: periodMiscTotal ?? this.periodMiscTotal,
        weeklyMiscTotalIncludesTax: weeklyMiscTotalIncludesTax ?? this.weeklyMiscTotalIncludesTax,
        monthlyMiscTotalIncludesTax: monthlyMiscTotalIncludesTax ?? this.monthlyMiscTotalIncludesTax,
        periodMiscTotalIncludesTax: periodMiscTotalIncludesTax ?? this.periodMiscTotalIncludesTax,
        laborDiscountPercent: laborDiscountPercent ?? this.laborDiscountPercent,
        weeklyLaborTotal: weeklyLaborTotal ?? this.weeklyLaborTotal,
        monthlyLaborTotal: monthlyLaborTotal ?? this.monthlyLaborTotal,
        periodLaborTotal: periodLaborTotal ?? this.periodLaborTotal,
        weeklyLaborTotalIncludesTax: weeklyLaborTotalIncludesTax ?? this.weeklyLaborTotalIncludesTax,
        monthlyLaborTotalIncludesTax: monthlyLaborTotalIncludesTax ?? this.monthlyLaborTotalIncludesTax,
        periodLaborTotalIncludesTax: periodLaborTotalIncludesTax ?? this.periodLaborTotalIncludesTax,
        rentalSaleDiscountPercent: rentalSaleDiscountPercent ?? this.rentalSaleDiscountPercent,
        rentalSaleTotal: rentalSaleTotal ?? this.rentalSaleTotal,
        rentalSaleTotalIncludesTax: rentalSaleTotalIncludesTax ?? this.rentalSaleTotalIncludesTax,
        lossAndDamageDiscountPercent: lossAndDamageDiscountPercent ?? this.lossAndDamageDiscountPercent,
        lossAndDamageTotal: lossAndDamageTotal ?? this.lossAndDamageTotal,
        lossAndDamageTotalIncludesTax: lossAndDamageTotalIncludesTax ?? this.lossAndDamageTotalIncludesTax,
        combinedDaysPerWeek: combinedDaysPerWeek ?? this.combinedDaysPerWeek,
        combinedDiscountPercent: combinedDiscountPercent ?? this.combinedDiscountPercent,
        weeklyCombinedTotal: weeklyCombinedTotal ?? this.weeklyCombinedTotal,
        monthlyCombinedTotal: monthlyCombinedTotal ?? this.monthlyCombinedTotal,
        periodCombinedTotal: periodCombinedTotal ?? this.periodCombinedTotal,
        weeklyCombinedTotalIncludesTax: weeklyCombinedTotalIncludesTax ?? this.weeklyCombinedTotalIncludesTax,
        monthlyCombinedTotalIncludesTax: monthlyCombinedTotalIncludesTax ?? this.monthlyCombinedTotalIncludesTax,
        periodCombinedTotalIncludesTax: periodCombinedTotalIncludesTax ?? this.periodCombinedTotalIncludesTax,
        disableEditingRentalRate: disableEditingRentalRate ?? this.disableEditingRentalRate,
        disableEditingSalesRate: disableEditingSalesRate ?? this.disableEditingSalesRate,
        disableEditingMiscellaneousRate: disableEditingMiscellaneousRate ?? this.disableEditingMiscellaneousRate,
        disableEditingLaborRate: disableEditingLaborRate ?? this.disableEditingLaborRate,
        disableEditingRentalSaleRate: disableEditingRentalSaleRate ?? this.disableEditingRentalSaleRate,
        disableEditingLossAndDamageRate: disableEditingLossAndDamageRate ?? this.disableEditingLossAndDamageRate,
        rentalExtendedTotal: rentalExtendedTotal ?? this.rentalExtendedTotal,
        salesExtendedTotal: salesExtendedTotal ?? this.salesExtendedTotal,
        laborExtendedTotal: laborExtendedTotal ?? this.laborExtendedTotal,
        miscellaneousExtendedTotal: miscellaneousExtendedTotal ?? this.miscellaneousExtendedTotal,
        rentalSaleExtendedTotal: rentalSaleExtendedTotal ?? this.rentalSaleExtendedTotal,
        lossAndDamageExtendedTotal: lossAndDamageExtendedTotal ?? this.lossAndDamageExtendedTotal,
        hasNotes: hasNotes ?? this.hasNotes,
        hasDocuments: hasDocuments ?? this.hasDocuments,
        hasEmailHistory: hasEmailHistory ?? this.hasEmailHistory,
        hasContacts: hasContacts ?? this.hasContacts,
        hasSubPurchaseOrders: hasSubPurchaseOrders ?? this.hasSubPurchaseOrders,
        hasPickLists: hasPickLists ?? this.hasPickLists,
        hasContracts: hasContracts ?? this.hasContracts,
        hasSuspendedContracts: hasSuspendedContracts ?? this.hasSuspendedContracts,
        hasMultiOrderContracts: hasMultiOrderContracts ?? this.hasMultiOrderContracts,
        hasInvoices: hasInvoices ?? this.hasInvoices,
        hasBillingWorksheets: hasBillingWorksheets ?? this.hasBillingWorksheets,
        hasMultiOrderInvoices: hasMultiOrderInvoices ?? this.hasMultiOrderInvoices,
        totalReplacementCost: totalReplacementCost ?? this.totalReplacementCost,
        presentationLayerId: presentationLayerId ?? this.presentationLayerId,
        presentationLayer: presentationLayer ?? this.presentationLayer,
        isManualSort: isManualSort ?? this.isManualSort,
        quoteOrderTitle: quoteOrderTitle ?? this.quoteOrderTitle,
        unassignedSubs: unassignedSubs ?? this.unassignedSubs,
        nonTaxable: nonTaxable ?? this.nonTaxable,
        enableProjects: enableProjects ?? this.enableProjects,
        projectId: projectId ?? this.projectId,
        projectNumber: projectNumber ?? this.projectNumber,
        project: project ?? this.project,
        projectDrawingsId: projectDrawingsId ?? this.projectDrawingsId,
        projectDrawings: projectDrawings ?? this.projectDrawings,
        projectItemsOrderedId: projectItemsOrderedId ?? this.projectItemsOrderedId,
        projectItemsOrdered: projectItemsOrdered ?? this.projectItemsOrdered,
        projectDropShipId: projectDropShipId ?? this.projectDropShipId,
        projectDropShip: projectDropShip ?? this.projectDropShip,
        projectAsBuildId: projectAsBuildId ?? this.projectAsBuildId,
        projectAsBuild: projectAsBuild ?? this.projectAsBuild,
        projectCommissioningId: projectCommissioningId ?? this.projectCommissioningId,
        projectCommissioning: projectCommissioning ?? this.projectCommissioning,
        projectDepositId: projectDepositId ?? this.projectDepositId,
        projectDeposit: projectDeposit ?? this.projectDeposit,
        inputByUserId: inputByUserId ?? this.inputByUserId,
        modifiedByUserId: modifiedByUserId ?? this.modifiedByUserId,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes: defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderOrderBase {
  WebApiModulesAgentOrderOrderBase({
    this.description,
    this.officeLocationId,
    this.officeLocation,
    this.warehouseId,
    this.warehouse,
    this.warehouseCode,
    this.departmentId,
    this.department,
    this.customerId,
    this.customer,
    this.customerNumber,
    this.dealId,
    this.deal,
    this.dealNumber,
    this.rateType,
    this.rateTypeDisplay,
    this.agentId,
    this.agent,
    this.projectManagerId,
    this.projectManager,
    this.rental,
    this.sales,
    this.miscellaneous,
    this.labor,
    this.facilities,
    this.transportation,
    this.rentalSale,
    this.lossAndDamage,
    this.repair,
    this.hasRentalItem,
    this.hasSalesItem,
    this.hasMiscellaneousItem,
    this.hasLaborItem,
    this.hasFacilitiesItem,
    this.hasLossAndDamageItem,
    this.hasRentalSaleItem,
    this.hasRepair,
    this.activityDatesAndTimes,
    this.pickDate,
    this.pickTime,
    this.estimatedStartDate,
    this.estimatedStartTime,
    this.estimatedStopDate,
    this.estimatedStopTime,
    this.pickUpDate,
    this.pickUpTime,
    this.prepDate,
    this.prepTime,
    this.loadInDate,
    this.loadInTime,
    this.strikeDate,
    this.strikeTime,
    this.testDate,
    this.testTime,
    this.orderTypeId,
    this.orderType,
    this.orderTypeCombineActivityTabs,
    this.flatPo,
    this.pendingPo,
    this.poNumber,
    this.poAmount,
    this.location,
    this.orderLocationId,
    this.orderLocation,
    this.referenceNumber,
    this.total,
    this.status,
    this.statusDate,
    this.poApprovalStatusId,
    this.lockBillingDates,
    this.specifyBillingDatesByType,
    this.rentalBillingStartDate,
    this.rentalBillingEndDate,
    this.laborBillingStartDate,
    this.laborBillingEndDate,
    this.miscellaneousBillingStartDate,
    this.miscellaneousBillingEndDate,
    this.facilitiesBillingStartDate,
    this.facilitiesBillingEndDate,
    this.vehicleBillingStartDate,
    this.vehicleBillingEndDate,
    this.delayBillingSearchUntil,
    this.includePrepFeesInRentalRate,
    this.billingStartDate,
    this.billingEndDate,
    this.billingWeeks,
    this.billingMonths,
    this.determineQuantitiesToBillBasedOn,
    this.billingCycleId,
    this.billingCycle,
    this.billingCycleType,
    this.paymentTermsId,
    this.paymentTerms,
    this.paymentTypeId,
    this.paymentType,
    this.currencyId,
    this.updateAllRatesToNewCurrency,
    this.confirmUpdateAllRatesToNewCurrency,
    this.currencyCode,
    this.currency,
    this.currencySymbol,
    this.taxOptionId,
    this.taxOption,
    this.tax1Name,
    this.tax2Name,
    this.taxId,
    this.rentalTaxRate1,
    this.salesTaxRate1,
    this.laborTaxRate1,
    this.rentalTaxRate2,
    this.salesTaxRate2,
    this.laborTaxRate2,
    this.noCharge,
    this.noChargeReason,
    this.printIssuedToAddressFrom,
    this.issuedToName,
    this.issuedToAttention,
    this.issuedToAttention2,
    this.issuedToAddress1,
    this.issuedToAddress2,
    this.issuedToCity,
    this.issuedToState,
    this.issuedToZipCode,
    this.issuedToCountryId,
    this.issuedToCountry,
    this.billToAddressDifferentFromIssuedToAddress,
    this.billToAddressId,
    this.billToName,
    this.billToAttention,
    this.billToAttention2,
    this.billToAddress1,
    this.billToAddress2,
    this.billToCity,
    this.billToState,
    this.billToZipCode,
    this.billToCountryId,
    this.billToCountry,
    this.discountReasonId,
    this.discountReason,
    this.requireContactConfirmation,
    this.includeInBillingAnalysis,
    this.hiatusDiscountFrom,
    this.roundTripRentals,
    this.inGroup,
    this.groupNumber,
    this.groupColor,
    this.groupOrderBy,
    this.coverLetterId,
    this.coverLetter,
    this.termsConditionsId,
    this.termsConditions,
    this.outsideSalesRepresentativeId,
    this.outsideSalesRepresentative,
    this.marketTypeId,
    this.marketType,
    this.marketSegmentId,
    this.marketSegment,
    this.marketSegmentJobId,
    this.marketSegmentJob,
    this.outDeliveryId,
    this.outDeliveryDeliveryType,
    this.outDeliveryRequiredDate,
    this.outDeliveryRequiredTime,
    this.outDeliveryTargetShipDate,
    this.outDeliveryTargetShipTime,
    this.outDeliveryDirection,
    this.outDeliveryAddressType,
    this.outDeliveryFromLocation,
    this.outDeliveryFromContact,
    this.outDeliveryFromContactPhone,
    this.outDeliveryFromAlternateContact,
    this.outDeliveryFromAlternateContactPhone,
    this.outDeliveryFromAttention,
    this.outDeliveryFromAddress1,
    this.outDeliveryFromAdd2ress,
    this.outDeliveryFromCity,
    this.outDeliveryFromState,
    this.outDeliveryFromZipCode,
    this.outDeliveryFromCountry,
    this.outDeliveryFromCountryId,
    this.outDeliveryFromCrossStreets,
    this.outDeliveryToLocation,
    this.outDeliveryToContact,
    this.outDeliveryToContactPhone,
    this.outDeliveryToAlternateContact,
    this.outDeliveryToAlternateContactPhone,
    this.outDeliveryToAttention,
    this.outDeliveryToAddress1,
    this.outDeliveryToAddress2,
    this.outDeliveryToCity,
    this.outDeliveryToState,
    this.outDeliveryToZipCode,
    this.outDeliveryToCountryId,
    this.outDeliveryToCountry,
    this.outDeliveryToContactFax,
    this.outDeliveryToCrossStreets,
    this.outDeliveryDeliveryNotes,
    this.outDeliveryCarrierId,
    this.outDeliveryCarrier,
    this.outDeliveryCarrierAccount,
    this.outDeliveryShipViaId,
    this.outDeliveryShipVia,
    this.outDeliveryInvoiceId,
    this.outDeliveryVendorInvoiceId,
    this.outDeliveryEstimatedFreight,
    this.outDeliveryFreightInvoiceAmount,
    this.outDeliveryChargeType,
    this.outDeliveryFreightTrackingNumber,
    this.outDeliveryFreightTrackingUrl,
    this.outDeliveryPackageCode,
    this.outDeliveryBillPoFreightOnOrder,
    this.outDeliveryOnlineOrderNumber,
    this.outDeliveryToVenue,
    this.outDeliveryToVenueId,
    this.outDeliveryToWarehouse,
    this.outDeliveryToWarehouseId,
    this.outDeliveryDateStamp,
    this.inDeliveryId,
    this.inDeliveryDeliveryType,
    this.inDeliveryRequiredDate,
    this.inDeliveryRequiredTime,
    this.inDeliveryTargetShipDate,
    this.inDeliveryTargetShipTime,
    this.inDeliveryDirection,
    this.inDeliveryAddressType,
    this.inDeliveryFromLocation,
    this.inDeliveryFromContact,
    this.inDeliveryFromContactPhone,
    this.inDeliveryFromAlternateContact,
    this.inDeliveryFromAlternateContactPhone,
    this.inDeliveryFromAttention,
    this.inDeliveryFromAddress1,
    this.inDeliveryFromAdd2ress,
    this.inDeliveryFromCity,
    this.inDeliveryFromState,
    this.inDeliveryFromZipCode,
    this.inDeliveryFromCountry,
    this.inDeliveryFromCountryId,
    this.inDeliveryFromCrossStreets,
    this.inDeliveryToLocation,
    this.inDeliveryToContact,
    this.inDeliveryToContactPhone,
    this.inDeliveryToAlternateContact,
    this.inDeliveryToAlternateContactPhone,
    this.inDeliveryToAttention,
    this.inDeliveryToAddress1,
    this.inDeliveryToAddress2,
    this.inDeliveryToCity,
    this.inDeliveryToState,
    this.inDeliveryToZipCode,
    this.inDeliveryToCountryId,
    this.inDeliveryToCountry,
    this.inDeliveryToContactFax,
    this.inDeliveryToCrossStreets,
    this.inDeliveryDeliveryNotes,
    this.inDeliveryCarrierId,
    this.inDeliveryCarrier,
    this.inDeliveryCarrierAccount,
    this.inDeliveryShipViaId,
    this.inDeliveryShipVia,
    this.inDeliveryInvoiceId,
    this.inDeliveryVendorInvoiceId,
    this.inDeliveryEstimatedFreight,
    this.inDeliveryFreightInvoiceAmount,
    this.inDeliveryChargeType,
    this.inDeliveryFreightTrackingNumber,
    this.inDeliveryFreightTrackingUrl,
    this.inDeliveryPackageCode,
    this.inDeliveryBillPoFreightOnOrder,
    this.inDeliveryOnlineOrderNumber,
    this.inDeliveryOnlineOrderStatus,
    this.inDeliveryToVenue,
    this.inDeliveryToVenueId,
    this.inDeliveryToWarehouse,
    this.inDeliveryToWarehouseId,
    this.inDeliveryDateStamp,
    this.rentalDaysPerWeek,
    this.rentalDiscountPercent,
    this.weeklyRentalTotal,
    this.monthlyRentalTotal,
    this.periodRentalTotal,
    this.weeklyRentalTotalIncludesTax,
    this.monthlyRentalTotalIncludesTax,
    this.periodRentalTotalIncludesTax,
    this.billLockedTotal,
    this.salesDiscountPercent,
    this.salesTotal,
    this.salesTotalIncludesTax,
    this.partsDiscountPercent,
    this.partsTotal,
    this.partsTotalIncludesTax,
    this.spaceDaysPerWeek,
    this.spaceDiscountPercent,
    this.spaceSplitPercent,
    this.weeklySpaceTotal,
    this.monthlySpaceTotal,
    this.periodSpaceTotal,
    this.weeklySpaceTotalIncludesTax,
    this.monthlySpaceTotalIncludesTax,
    this.periodSpaceTotalIncludesTax,
    this.vehicleDaysPerWeek,
    this.vehicleDiscountPercent,
    this.weeklyVehicleTotal,
    this.monthlyVehicleTotal,
    this.periodVehicleTotal,
    this.weeklyVehicleTotalIncludesTax,
    this.monthlyVehicleTotalIncludesTax,
    this.periodVehicleTotalIncludesTax,
    this.miscDiscountPercent,
    this.weeklyMiscTotal,
    this.monthlyMiscTotal,
    this.periodMiscTotal,
    this.weeklyMiscTotalIncludesTax,
    this.monthlyMiscTotalIncludesTax,
    this.periodMiscTotalIncludesTax,
    this.laborDiscountPercent,
    this.weeklyLaborTotal,
    this.monthlyLaborTotal,
    this.periodLaborTotal,
    this.weeklyLaborTotalIncludesTax,
    this.monthlyLaborTotalIncludesTax,
    this.periodLaborTotalIncludesTax,
    this.rentalSaleDiscountPercent,
    this.rentalSaleTotal,
    this.rentalSaleTotalIncludesTax,
    this.lossAndDamageDiscountPercent,
    this.lossAndDamageTotal,
    this.lossAndDamageTotalIncludesTax,
    this.combinedDaysPerWeek,
    this.combinedDiscountPercent,
    this.weeklyCombinedTotal,
    this.monthlyCombinedTotal,
    this.periodCombinedTotal,
    this.weeklyCombinedTotalIncludesTax,
    this.monthlyCombinedTotalIncludesTax,
    this.periodCombinedTotalIncludesTax,
    this.disableEditingRentalRate,
    this.disableEditingSalesRate,
    this.disableEditingMiscellaneousRate,
    this.disableEditingLaborRate,
    this.disableEditingRentalSaleRate,
    this.disableEditingLossAndDamageRate,
    this.rentalExtendedTotal,
    this.salesExtendedTotal,
    this.laborExtendedTotal,
    this.miscellaneousExtendedTotal,
    this.rentalSaleExtendedTotal,
    this.lossAndDamageExtendedTotal,
    this.hasNotes,
    this.hasDocuments,
    this.hasEmailHistory,
    this.hasContacts,
    this.hasSubPurchaseOrders,
    this.hasPickLists,
    this.hasContracts,
    this.hasSuspendedContracts,
    this.hasMultiOrderContracts,
    this.hasInvoices,
    this.hasBillingWorksheets,
    this.hasMultiOrderInvoices,
    this.totalReplacementCost,
    this.presentationLayerId,
    this.presentationLayer,
    this.isManualSort,
    this.quoteOrderTitle,
    this.unassignedSubs,
    this.nonTaxable,
    this.enableProjects,
    this.projectId,
    this.projectNumber,
    this.project,
    this.projectDrawingsId,
    this.projectDrawings,
    this.projectItemsOrderedId,
    this.projectItemsOrdered,
    this.projectDropShipId,
    this.projectDropShip,
    this.projectAsBuildId,
    this.projectAsBuild,
    this.projectCommissioningId,
    this.projectCommissioning,
    this.projectDepositId,
    this.projectDeposit,
    this.inputByUserId,
    this.modifiedByUserId,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAgentOrderOrderBase.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderOrderBaseFromJson(json);

  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'OfficeLocationId')
  final String? officeLocationId;
  @JsonKey(name: 'OfficeLocation')
  final String? officeLocation;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'Department')
  final String? department;
  @JsonKey(name: 'CustomerId')
  final String? customerId;
  @JsonKey(name: 'Customer')
  final String? customer;
  @JsonKey(name: 'CustomerNumber')
  final String? customerNumber;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'Deal')
  final String? deal;
  @JsonKey(name: 'DealNumber')
  final String? dealNumber;
  @JsonKey(name: 'RateType')
  final String? rateType;
  @JsonKey(name: 'RateTypeDisplay')
  final String? rateTypeDisplay;
  @JsonKey(name: 'AgentId')
  final String? agentId;
  @JsonKey(name: 'Agent')
  final String? agent;
  @JsonKey(name: 'ProjectManagerId')
  final String? projectManagerId;
  @JsonKey(name: 'ProjectManager')
  final String? projectManager;
  @JsonKey(name: 'Rental')
  final bool? rental;
  @JsonKey(name: 'Sales')
  final bool? sales;
  @JsonKey(name: 'Miscellaneous')
  final bool? miscellaneous;
  @JsonKey(name: 'Labor')
  final bool? labor;
  @JsonKey(name: 'Facilities')
  final bool? facilities;
  @JsonKey(name: 'Transportation')
  final bool? transportation;
  @JsonKey(name: 'RentalSale')
  final bool? rentalSale;
  @JsonKey(name: 'LossAndDamage')
  final bool? lossAndDamage;
  @JsonKey(name: 'Repair')
  final bool? repair;
  @JsonKey(name: 'HasRentalItem')
  final bool? hasRentalItem;
  @JsonKey(name: 'HasSalesItem')
  final bool? hasSalesItem;
  @JsonKey(name: 'HasMiscellaneousItem')
  final bool? hasMiscellaneousItem;
  @JsonKey(name: 'HasLaborItem')
  final bool? hasLaborItem;
  @JsonKey(name: 'HasFacilitiesItem')
  final bool? hasFacilitiesItem;
  @JsonKey(name: 'HasLossAndDamageItem')
  final bool? hasLossAndDamageItem;
  @JsonKey(name: 'HasRentalSaleItem')
  final bool? hasRentalSaleItem;
  @JsonKey(name: 'HasRepair')
  final bool? hasRepair;
  @JsonKey(
      name: 'ActivityDatesAndTimes',
      defaultValue: <WebApiModulesHomeControlsOrderDatesOrderDates>[])
  final List<WebApiModulesHomeControlsOrderDatesOrderDates>?
      activityDatesAndTimes;
  @JsonKey(name: 'PickDate')
  final String? pickDate;
  @JsonKey(name: 'PickTime')
  final String? pickTime;
  @JsonKey(name: 'EstimatedStartDate')
  final String? estimatedStartDate;
  @JsonKey(name: 'EstimatedStartTime')
  final String? estimatedStartTime;
  @JsonKey(name: 'EstimatedStopDate')
  final String? estimatedStopDate;
  @JsonKey(name: 'EstimatedStopTime')
  final String? estimatedStopTime;
  @JsonKey(name: 'PickUpDate')
  final String? pickUpDate;
  @JsonKey(name: 'PickUpTime')
  final String? pickUpTime;
  @JsonKey(name: 'PrepDate')
  final String? prepDate;
  @JsonKey(name: 'PrepTime')
  final String? prepTime;
  @JsonKey(name: 'LoadInDate')
  final String? loadInDate;
  @JsonKey(name: 'LoadInTime')
  final String? loadInTime;
  @JsonKey(name: 'StrikeDate')
  final String? strikeDate;
  @JsonKey(name: 'StrikeTime')
  final String? strikeTime;
  @JsonKey(name: 'TestDate')
  final String? testDate;
  @JsonKey(name: 'TestTime')
  final String? testTime;
  @JsonKey(name: 'OrderTypeId')
  final String? orderTypeId;
  @JsonKey(name: 'OrderType')
  final String? orderType;
  @JsonKey(name: 'OrderTypeCombineActivityTabs')
  final bool? orderTypeCombineActivityTabs;
  @JsonKey(name: 'FlatPo')
  final bool? flatPo;
  @JsonKey(name: 'PendingPo')
  final bool? pendingPo;
  @JsonKey(name: 'PoNumber')
  final String? poNumber;
  @JsonKey(name: 'PoAmount')
  final double? poAmount;
  @JsonKey(name: 'Location')
  final String? location;
  @JsonKey(name: 'OrderLocationId')
  final String? orderLocationId;
  @JsonKey(name: 'OrderLocation')
  final String? orderLocation;
  @JsonKey(name: 'ReferenceNumber')
  final String? referenceNumber;
  @JsonKey(name: 'Total')
  final double? total;
  @JsonKey(name: 'Status')
  final String? status;
  @JsonKey(name: 'StatusDate')
  final String? statusDate;
  @JsonKey(name: 'PoApprovalStatusId')
  final String? poApprovalStatusId;
  @JsonKey(name: 'LockBillingDates')
  final bool? lockBillingDates;
  @JsonKey(name: 'SpecifyBillingDatesByType')
  final bool? specifyBillingDatesByType;
  @JsonKey(name: 'RentalBillingStartDate')
  final String? rentalBillingStartDate;
  @JsonKey(name: 'RentalBillingEndDate')
  final String? rentalBillingEndDate;
  @JsonKey(name: 'LaborBillingStartDate')
  final String? laborBillingStartDate;
  @JsonKey(name: 'LaborBillingEndDate')
  final String? laborBillingEndDate;
  @JsonKey(name: 'MiscellaneousBillingStartDate')
  final String? miscellaneousBillingStartDate;
  @JsonKey(name: 'MiscellaneousBillingEndDate')
  final String? miscellaneousBillingEndDate;
  @JsonKey(name: 'FacilitiesBillingStartDate')
  final String? facilitiesBillingStartDate;
  @JsonKey(name: 'FacilitiesBillingEndDate')
  final String? facilitiesBillingEndDate;
  @JsonKey(name: 'VehicleBillingStartDate')
  final String? vehicleBillingStartDate;
  @JsonKey(name: 'VehicleBillingEndDate')
  final String? vehicleBillingEndDate;
  @JsonKey(name: 'DelayBillingSearchUntil')
  final String? delayBillingSearchUntil;
  @JsonKey(name: 'IncludePrepFeesInRentalRate')
  final bool? includePrepFeesInRentalRate;
  @JsonKey(name: 'BillingStartDate')
  final String? billingStartDate;
  @JsonKey(name: 'BillingEndDate')
  final String? billingEndDate;
  @JsonKey(name: 'BillingWeeks')
  final double? billingWeeks;
  @JsonKey(name: 'BillingMonths')
  final double? billingMonths;
  @JsonKey(name: 'DetermineQuantitiesToBillBasedOn')
  final String? determineQuantitiesToBillBasedOn;
  @JsonKey(name: 'BillingCycleId')
  final String? billingCycleId;
  @JsonKey(name: 'BillingCycle')
  final String? billingCycle;
  @JsonKey(name: 'BillingCycleType')
  final String? billingCycleType;
  @JsonKey(name: 'PaymentTermsId')
  final String? paymentTermsId;
  @JsonKey(name: 'PaymentTerms')
  final String? paymentTerms;
  @JsonKey(name: 'PaymentTypeId')
  final String? paymentTypeId;
  @JsonKey(name: 'PaymentType')
  final String? paymentType;
  @JsonKey(name: 'CurrencyId')
  final String? currencyId;
  @JsonKey(name: 'UpdateAllRatesToNewCurrency')
  final bool? updateAllRatesToNewCurrency;
  @JsonKey(name: 'ConfirmUpdateAllRatesToNewCurrency')
  final String? confirmUpdateAllRatesToNewCurrency;
  @JsonKey(name: 'CurrencyCode')
  final String? currencyCode;
  @JsonKey(name: 'Currency')
  final String? currency;
  @JsonKey(name: 'CurrencySymbol')
  final String? currencySymbol;
  @JsonKey(name: 'TaxOptionId')
  final String? taxOptionId;
  @JsonKey(name: 'TaxOption')
  final String? taxOption;
  @JsonKey(name: 'Tax1Name')
  final String? tax1Name;
  @JsonKey(name: 'Tax2Name')
  final String? tax2Name;
  @JsonKey(name: 'TaxId')
  final String? taxId;
  @JsonKey(name: 'RentalTaxRate1')
  final double? rentalTaxRate1;
  @JsonKey(name: 'SalesTaxRate1')
  final double? salesTaxRate1;
  @JsonKey(name: 'LaborTaxRate1')
  final double? laborTaxRate1;
  @JsonKey(name: 'RentalTaxRate2')
  final double? rentalTaxRate2;
  @JsonKey(name: 'SalesTaxRate2')
  final double? salesTaxRate2;
  @JsonKey(name: 'LaborTaxRate2')
  final double? laborTaxRate2;
  @JsonKey(name: 'NoCharge')
  final bool? noCharge;
  @JsonKey(name: 'NoChargeReason')
  final String? noChargeReason;
  @JsonKey(name: 'PrintIssuedToAddressFrom')
  final String? printIssuedToAddressFrom;
  @JsonKey(name: 'IssuedToName')
  final String? issuedToName;
  @JsonKey(name: 'IssuedToAttention')
  final String? issuedToAttention;
  @JsonKey(name: 'IssuedToAttention2')
  final String? issuedToAttention2;
  @JsonKey(name: 'IssuedToAddress1')
  final String? issuedToAddress1;
  @JsonKey(name: 'IssuedToAddress2')
  final String? issuedToAddress2;
  @JsonKey(name: 'IssuedToCity')
  final String? issuedToCity;
  @JsonKey(name: 'IssuedToState')
  final String? issuedToState;
  @JsonKey(name: 'IssuedToZipCode')
  final String? issuedToZipCode;
  @JsonKey(name: 'IssuedToCountryId')
  final String? issuedToCountryId;
  @JsonKey(name: 'IssuedToCountry')
  final String? issuedToCountry;
  @JsonKey(name: 'BillToAddressDifferentFromIssuedToAddress')
  final bool? billToAddressDifferentFromIssuedToAddress;
  @JsonKey(name: 'BillToAddressId')
  final String? billToAddressId;
  @JsonKey(name: 'BillToName')
  final String? billToName;
  @JsonKey(name: 'BillToAttention')
  final String? billToAttention;
  @JsonKey(name: 'BillToAttention2')
  final String? billToAttention2;
  @JsonKey(name: 'BillToAddress1')
  final String? billToAddress1;
  @JsonKey(name: 'BillToAddress2')
  final String? billToAddress2;
  @JsonKey(name: 'BillToCity')
  final String? billToCity;
  @JsonKey(name: 'BillToState')
  final String? billToState;
  @JsonKey(name: 'BillToZipCode')
  final String? billToZipCode;
  @JsonKey(name: 'BillToCountryId')
  final String? billToCountryId;
  @JsonKey(name: 'BillToCountry')
  final String? billToCountry;
  @JsonKey(name: 'DiscountReasonId')
  final String? discountReasonId;
  @JsonKey(name: 'DiscountReason')
  final String? discountReason;
  @JsonKey(name: 'RequireContactConfirmation')
  final bool? requireContactConfirmation;
  @JsonKey(name: 'IncludeInBillingAnalysis')
  final bool? includeInBillingAnalysis;
  @JsonKey(name: 'HiatusDiscountFrom')
  final String? hiatusDiscountFrom;
  @JsonKey(name: 'RoundTripRentals')
  final bool? roundTripRentals;
  @JsonKey(name: 'InGroup')
  final bool? inGroup;
  @JsonKey(name: 'GroupNumber')
  final int? groupNumber;
  @JsonKey(name: 'GroupColor')
  final int? groupColor;
  @JsonKey(name: 'GroupOrderBy')
  final double? groupOrderBy;
  @JsonKey(name: 'CoverLetterId')
  final String? coverLetterId;
  @JsonKey(name: 'CoverLetter')
  final String? coverLetter;
  @JsonKey(name: 'TermsConditionsId')
  final String? termsConditionsId;
  @JsonKey(name: 'TermsConditions')
  final String? termsConditions;
  @JsonKey(name: 'OutsideSalesRepresentativeId')
  final String? outsideSalesRepresentativeId;
  @JsonKey(name: 'OutsideSalesRepresentative')
  final String? outsideSalesRepresentative;
  @JsonKey(name: 'MarketTypeId')
  final String? marketTypeId;
  @JsonKey(name: 'MarketType')
  final String? marketType;
  @JsonKey(name: 'MarketSegmentId')
  final String? marketSegmentId;
  @JsonKey(name: 'MarketSegment')
  final String? marketSegment;
  @JsonKey(name: 'MarketSegmentJobId')
  final String? marketSegmentJobId;
  @JsonKey(name: 'MarketSegmentJob')
  final String? marketSegmentJob;
  @JsonKey(name: 'OutDeliveryId')
  final String? outDeliveryId;
  @JsonKey(name: 'OutDeliveryDeliveryType')
  final String? outDeliveryDeliveryType;
  @JsonKey(name: 'OutDeliveryRequiredDate')
  final String? outDeliveryRequiredDate;
  @JsonKey(name: 'OutDeliveryRequiredTime')
  final String? outDeliveryRequiredTime;
  @JsonKey(name: 'OutDeliveryTargetShipDate')
  final String? outDeliveryTargetShipDate;
  @JsonKey(name: 'OutDeliveryTargetShipTime')
  final String? outDeliveryTargetShipTime;
  @JsonKey(name: 'OutDeliveryDirection')
  final String? outDeliveryDirection;
  @JsonKey(name: 'OutDeliveryAddressType')
  final String? outDeliveryAddressType;
  @JsonKey(name: 'OutDeliveryFromLocation')
  final String? outDeliveryFromLocation;
  @JsonKey(name: 'OutDeliveryFromContact')
  final String? outDeliveryFromContact;
  @JsonKey(name: 'OutDeliveryFromContactPhone')
  final String? outDeliveryFromContactPhone;
  @JsonKey(name: 'OutDeliveryFromAlternateContact')
  final String? outDeliveryFromAlternateContact;
  @JsonKey(name: 'OutDeliveryFromAlternateContactPhone')
  final String? outDeliveryFromAlternateContactPhone;
  @JsonKey(name: 'OutDeliveryFromAttention')
  final String? outDeliveryFromAttention;
  @JsonKey(name: 'OutDeliveryFromAddress1')
  final String? outDeliveryFromAddress1;
  @JsonKey(name: 'OutDeliveryFromAdd2ress')
  final String? outDeliveryFromAdd2ress;
  @JsonKey(name: 'OutDeliveryFromCity')
  final String? outDeliveryFromCity;
  @JsonKey(name: 'OutDeliveryFromState')
  final String? outDeliveryFromState;
  @JsonKey(name: 'OutDeliveryFromZipCode')
  final String? outDeliveryFromZipCode;
  @JsonKey(name: 'OutDeliveryFromCountry')
  final String? outDeliveryFromCountry;
  @JsonKey(name: 'OutDeliveryFromCountryId')
  final String? outDeliveryFromCountryId;
  @JsonKey(name: 'OutDeliveryFromCrossStreets')
  final String? outDeliveryFromCrossStreets;
  @JsonKey(name: 'OutDeliveryToLocation')
  final String? outDeliveryToLocation;
  @JsonKey(name: 'OutDeliveryToContact')
  final String? outDeliveryToContact;
  @JsonKey(name: 'OutDeliveryToContactPhone')
  final String? outDeliveryToContactPhone;
  @JsonKey(name: 'OutDeliveryToAlternateContact')
  final String? outDeliveryToAlternateContact;
  @JsonKey(name: 'OutDeliveryToAlternateContactPhone')
  final String? outDeliveryToAlternateContactPhone;
  @JsonKey(name: 'OutDeliveryToAttention')
  final String? outDeliveryToAttention;
  @JsonKey(name: 'OutDeliveryToAddress1')
  final String? outDeliveryToAddress1;
  @JsonKey(name: 'OutDeliveryToAddress2')
  final String? outDeliveryToAddress2;
  @JsonKey(name: 'OutDeliveryToCity')
  final String? outDeliveryToCity;
  @JsonKey(name: 'OutDeliveryToState')
  final String? outDeliveryToState;
  @JsonKey(name: 'OutDeliveryToZipCode')
  final String? outDeliveryToZipCode;
  @JsonKey(name: 'OutDeliveryToCountryId')
  final String? outDeliveryToCountryId;
  @JsonKey(name: 'OutDeliveryToCountry')
  final String? outDeliveryToCountry;
  @JsonKey(name: 'OutDeliveryToContactFax')
  final String? outDeliveryToContactFax;
  @JsonKey(name: 'OutDeliveryToCrossStreets')
  final String? outDeliveryToCrossStreets;
  @JsonKey(name: 'OutDeliveryDeliveryNotes')
  final String? outDeliveryDeliveryNotes;
  @JsonKey(name: 'OutDeliveryCarrierId')
  final String? outDeliveryCarrierId;
  @JsonKey(name: 'OutDeliveryCarrier')
  final String? outDeliveryCarrier;
  @JsonKey(name: 'OutDeliveryCarrierAccount')
  final String? outDeliveryCarrierAccount;
  @JsonKey(name: 'OutDeliveryShipViaId')
  final String? outDeliveryShipViaId;
  @JsonKey(name: 'OutDeliveryShipVia')
  final String? outDeliveryShipVia;
  @JsonKey(name: 'OutDeliveryInvoiceId')
  final String? outDeliveryInvoiceId;
  @JsonKey(name: 'OutDeliveryVendorInvoiceId')
  final String? outDeliveryVendorInvoiceId;
  @JsonKey(name: 'OutDeliveryEstimatedFreight')
  final double? outDeliveryEstimatedFreight;
  @JsonKey(name: 'OutDeliveryFreightInvoiceAmount')
  final double? outDeliveryFreightInvoiceAmount;
  @JsonKey(name: 'OutDeliveryChargeType')
  final String? outDeliveryChargeType;
  @JsonKey(name: 'OutDeliveryFreightTrackingNumber')
  final String? outDeliveryFreightTrackingNumber;
  @JsonKey(name: 'OutDeliveryFreightTrackingUrl')
  final String? outDeliveryFreightTrackingUrl;
  @JsonKey(name: 'OutDeliveryPackageCode')
  final String? outDeliveryPackageCode;
  @JsonKey(name: 'OutDeliveryBillPoFreightOnOrder')
  final bool? outDeliveryBillPoFreightOnOrder;
  @JsonKey(name: 'OutDeliveryOnlineOrderNumber')
  final String? outDeliveryOnlineOrderNumber;
  @JsonKey(name: 'OutDeliveryToVenue')
  final String? outDeliveryToVenue;
  @JsonKey(name: 'OutDeliveryToVenueId')
  final String? outDeliveryToVenueId;
  @JsonKey(name: 'OutDeliveryToWarehouse')
  final String? outDeliveryToWarehouse;
  @JsonKey(name: 'OutDeliveryToWarehouseId')
  final String? outDeliveryToWarehouseId;
  @JsonKey(name: 'OutDeliveryDateStamp')
  final String? outDeliveryDateStamp;
  @JsonKey(name: 'InDeliveryId')
  final String? inDeliveryId;
  @JsonKey(name: 'InDeliveryDeliveryType')
  final String? inDeliveryDeliveryType;
  @JsonKey(name: 'InDeliveryRequiredDate')
  final String? inDeliveryRequiredDate;
  @JsonKey(name: 'InDeliveryRequiredTime')
  final String? inDeliveryRequiredTime;
  @JsonKey(name: 'InDeliveryTargetShipDate')
  final String? inDeliveryTargetShipDate;
  @JsonKey(name: 'InDeliveryTargetShipTime')
  final String? inDeliveryTargetShipTime;
  @JsonKey(name: 'InDeliveryDirection')
  final String? inDeliveryDirection;
  @JsonKey(name: 'InDeliveryAddressType')
  final String? inDeliveryAddressType;
  @JsonKey(name: 'InDeliveryFromLocation')
  final String? inDeliveryFromLocation;
  @JsonKey(name: 'InDeliveryFromContact')
  final String? inDeliveryFromContact;
  @JsonKey(name: 'InDeliveryFromContactPhone')
  final String? inDeliveryFromContactPhone;
  @JsonKey(name: 'InDeliveryFromAlternateContact')
  final String? inDeliveryFromAlternateContact;
  @JsonKey(name: 'InDeliveryFromAlternateContactPhone')
  final String? inDeliveryFromAlternateContactPhone;
  @JsonKey(name: 'InDeliveryFromAttention')
  final String? inDeliveryFromAttention;
  @JsonKey(name: 'InDeliveryFromAddress1')
  final String? inDeliveryFromAddress1;
  @JsonKey(name: 'InDeliveryFromAdd2ress')
  final String? inDeliveryFromAdd2ress;
  @JsonKey(name: 'InDeliveryFromCity')
  final String? inDeliveryFromCity;
  @JsonKey(name: 'InDeliveryFromState')
  final String? inDeliveryFromState;
  @JsonKey(name: 'InDeliveryFromZipCode')
  final String? inDeliveryFromZipCode;
  @JsonKey(name: 'InDeliveryFromCountry')
  final String? inDeliveryFromCountry;
  @JsonKey(name: 'InDeliveryFromCountryId')
  final String? inDeliveryFromCountryId;
  @JsonKey(name: 'InDeliveryFromCrossStreets')
  final String? inDeliveryFromCrossStreets;
  @JsonKey(name: 'InDeliveryToLocation')
  final String? inDeliveryToLocation;
  @JsonKey(name: 'InDeliveryToContact')
  final String? inDeliveryToContact;
  @JsonKey(name: 'InDeliveryToContactPhone')
  final String? inDeliveryToContactPhone;
  @JsonKey(name: 'InDeliveryToAlternateContact')
  final String? inDeliveryToAlternateContact;
  @JsonKey(name: 'InDeliveryToAlternateContactPhone')
  final String? inDeliveryToAlternateContactPhone;
  @JsonKey(name: 'InDeliveryToAttention')
  final String? inDeliveryToAttention;
  @JsonKey(name: 'InDeliveryToAddress1')
  final String? inDeliveryToAddress1;
  @JsonKey(name: 'InDeliveryToAddress2')
  final String? inDeliveryToAddress2;
  @JsonKey(name: 'InDeliveryToCity')
  final String? inDeliveryToCity;
  @JsonKey(name: 'InDeliveryToState')
  final String? inDeliveryToState;
  @JsonKey(name: 'InDeliveryToZipCode')
  final String? inDeliveryToZipCode;
  @JsonKey(name: 'InDeliveryToCountryId')
  final String? inDeliveryToCountryId;
  @JsonKey(name: 'InDeliveryToCountry')
  final String? inDeliveryToCountry;
  @JsonKey(name: 'InDeliveryToContactFax')
  final String? inDeliveryToContactFax;
  @JsonKey(name: 'InDeliveryToCrossStreets')
  final String? inDeliveryToCrossStreets;
  @JsonKey(name: 'InDeliveryDeliveryNotes')
  final String? inDeliveryDeliveryNotes;
  @JsonKey(name: 'InDeliveryCarrierId')
  final String? inDeliveryCarrierId;
  @JsonKey(name: 'InDeliveryCarrier')
  final String? inDeliveryCarrier;
  @JsonKey(name: 'InDeliveryCarrierAccount')
  final String? inDeliveryCarrierAccount;
  @JsonKey(name: 'InDeliveryShipViaId')
  final String? inDeliveryShipViaId;
  @JsonKey(name: 'InDeliveryShipVia')
  final String? inDeliveryShipVia;
  @JsonKey(name: 'InDeliveryInvoiceId')
  final String? inDeliveryInvoiceId;
  @JsonKey(name: 'InDeliveryVendorInvoiceId')
  final String? inDeliveryVendorInvoiceId;
  @JsonKey(name: 'InDeliveryEstimatedFreight')
  final double? inDeliveryEstimatedFreight;
  @JsonKey(name: 'InDeliveryFreightInvoiceAmount')
  final double? inDeliveryFreightInvoiceAmount;
  @JsonKey(name: 'InDeliveryChargeType')
  final String? inDeliveryChargeType;
  @JsonKey(name: 'InDeliveryFreightTrackingNumber')
  final String? inDeliveryFreightTrackingNumber;
  @JsonKey(name: 'InDeliveryFreightTrackingUrl')
  final String? inDeliveryFreightTrackingUrl;
  @JsonKey(name: 'InDeliveryPackageCode')
  final String? inDeliveryPackageCode;
  @JsonKey(name: 'InDeliveryBillPoFreightOnOrder')
  final bool? inDeliveryBillPoFreightOnOrder;
  @JsonKey(name: 'InDeliveryOnlineOrderNumber')
  final String? inDeliveryOnlineOrderNumber;
  @JsonKey(name: 'InDeliveryOnlineOrderStatus')
  final String? inDeliveryOnlineOrderStatus;
  @JsonKey(name: 'InDeliveryToVenue')
  final String? inDeliveryToVenue;
  @JsonKey(name: 'InDeliveryToVenueId')
  final String? inDeliveryToVenueId;
  @JsonKey(name: 'InDeliveryToWarehouse')
  final String? inDeliveryToWarehouse;
  @JsonKey(name: 'InDeliveryToWarehouseId')
  final String? inDeliveryToWarehouseId;
  @JsonKey(name: 'InDeliveryDateStamp')
  final String? inDeliveryDateStamp;
  @JsonKey(name: 'RentalDaysPerWeek')
  final double? rentalDaysPerWeek;
  @JsonKey(name: 'RentalDiscountPercent')
  final double? rentalDiscountPercent;
  @JsonKey(name: 'WeeklyRentalTotal')
  final double? weeklyRentalTotal;
  @JsonKey(name: 'MonthlyRentalTotal')
  final double? monthlyRentalTotal;
  @JsonKey(name: 'PeriodRentalTotal')
  final double? periodRentalTotal;
  @JsonKey(name: 'WeeklyRentalTotalIncludesTax')
  final bool? weeklyRentalTotalIncludesTax;
  @JsonKey(name: 'MonthlyRentalTotalIncludesTax')
  final bool? monthlyRentalTotalIncludesTax;
  @JsonKey(name: 'PeriodRentalTotalIncludesTax')
  final bool? periodRentalTotalIncludesTax;
  @JsonKey(name: 'BillLockedTotal')
  final bool? billLockedTotal;
  @JsonKey(name: 'SalesDiscountPercent')
  final double? salesDiscountPercent;
  @JsonKey(name: 'SalesTotal')
  final double? salesTotal;
  @JsonKey(name: 'SalesTotalIncludesTax')
  final bool? salesTotalIncludesTax;
  @JsonKey(name: 'PartsDiscountPercent')
  final double? partsDiscountPercent;
  @JsonKey(name: 'PartsTotal')
  final double? partsTotal;
  @JsonKey(name: 'PartsTotalIncludesTax')
  final bool? partsTotalIncludesTax;
  @JsonKey(name: 'SpaceDaysPerWeek')
  final double? spaceDaysPerWeek;
  @JsonKey(name: 'SpaceDiscountPercent')
  final double? spaceDiscountPercent;
  @JsonKey(name: 'SpaceSplitPercent')
  final double? spaceSplitPercent;
  @JsonKey(name: 'WeeklySpaceTotal')
  final double? weeklySpaceTotal;
  @JsonKey(name: 'MonthlySpaceTotal')
  final double? monthlySpaceTotal;
  @JsonKey(name: 'PeriodSpaceTotal')
  final double? periodSpaceTotal;
  @JsonKey(name: 'WeeklySpaceTotalIncludesTax')
  final bool? weeklySpaceTotalIncludesTax;
  @JsonKey(name: 'MonthlySpaceTotalIncludesTax')
  final bool? monthlySpaceTotalIncludesTax;
  @JsonKey(name: 'PeriodSpaceTotalIncludesTax')
  final bool? periodSpaceTotalIncludesTax;
  @JsonKey(name: 'VehicleDaysPerWeek')
  final double? vehicleDaysPerWeek;
  @JsonKey(name: 'VehicleDiscountPercent')
  final double? vehicleDiscountPercent;
  @JsonKey(name: 'WeeklyVehicleTotal')
  final double? weeklyVehicleTotal;
  @JsonKey(name: 'MonthlyVehicleTotal')
  final double? monthlyVehicleTotal;
  @JsonKey(name: 'PeriodVehicleTotal')
  final double? periodVehicleTotal;
  @JsonKey(name: 'WeeklyVehicleTotalIncludesTax')
  final bool? weeklyVehicleTotalIncludesTax;
  @JsonKey(name: 'MonthlyVehicleTotalIncludesTax')
  final bool? monthlyVehicleTotalIncludesTax;
  @JsonKey(name: 'PeriodVehicleTotalIncludesTax')
  final bool? periodVehicleTotalIncludesTax;
  @JsonKey(name: 'MiscDiscountPercent')
  final double? miscDiscountPercent;
  @JsonKey(name: 'WeeklyMiscTotal')
  final double? weeklyMiscTotal;
  @JsonKey(name: 'MonthlyMiscTotal')
  final double? monthlyMiscTotal;
  @JsonKey(name: 'PeriodMiscTotal')
  final double? periodMiscTotal;
  @JsonKey(name: 'WeeklyMiscTotalIncludesTax')
  final bool? weeklyMiscTotalIncludesTax;
  @JsonKey(name: 'MonthlyMiscTotalIncludesTax')
  final bool? monthlyMiscTotalIncludesTax;
  @JsonKey(name: 'PeriodMiscTotalIncludesTax')
  final bool? periodMiscTotalIncludesTax;
  @JsonKey(name: 'LaborDiscountPercent')
  final double? laborDiscountPercent;
  @JsonKey(name: 'WeeklyLaborTotal')
  final double? weeklyLaborTotal;
  @JsonKey(name: 'MonthlyLaborTotal')
  final double? monthlyLaborTotal;
  @JsonKey(name: 'PeriodLaborTotal')
  final double? periodLaborTotal;
  @JsonKey(name: 'WeeklyLaborTotalIncludesTax')
  final bool? weeklyLaborTotalIncludesTax;
  @JsonKey(name: 'MonthlyLaborTotalIncludesTax')
  final bool? monthlyLaborTotalIncludesTax;
  @JsonKey(name: 'PeriodLaborTotalIncludesTax')
  final bool? periodLaborTotalIncludesTax;
  @JsonKey(name: 'RentalSaleDiscountPercent')
  final double? rentalSaleDiscountPercent;
  @JsonKey(name: 'RentalSaleTotal')
  final double? rentalSaleTotal;
  @JsonKey(name: 'RentalSaleTotalIncludesTax')
  final bool? rentalSaleTotalIncludesTax;
  @JsonKey(name: 'LossAndDamageDiscountPercent')
  final double? lossAndDamageDiscountPercent;
  @JsonKey(name: 'LossAndDamageTotal')
  final double? lossAndDamageTotal;
  @JsonKey(name: 'LossAndDamageTotalIncludesTax')
  final bool? lossAndDamageTotalIncludesTax;
  @JsonKey(name: 'CombinedDaysPerWeek')
  final double? combinedDaysPerWeek;
  @JsonKey(name: 'CombinedDiscountPercent')
  final double? combinedDiscountPercent;
  @JsonKey(name: 'WeeklyCombinedTotal')
  final double? weeklyCombinedTotal;
  @JsonKey(name: 'MonthlyCombinedTotal')
  final double? monthlyCombinedTotal;
  @JsonKey(name: 'PeriodCombinedTotal')
  final double? periodCombinedTotal;
  @JsonKey(name: 'WeeklyCombinedTotalIncludesTax')
  final bool? weeklyCombinedTotalIncludesTax;
  @JsonKey(name: 'MonthlyCombinedTotalIncludesTax')
  final bool? monthlyCombinedTotalIncludesTax;
  @JsonKey(name: 'PeriodCombinedTotalIncludesTax')
  final bool? periodCombinedTotalIncludesTax;
  @JsonKey(name: 'DisableEditingRentalRate')
  final bool? disableEditingRentalRate;
  @JsonKey(name: 'DisableEditingSalesRate')
  final bool? disableEditingSalesRate;
  @JsonKey(name: 'DisableEditingMiscellaneousRate')
  final bool? disableEditingMiscellaneousRate;
  @JsonKey(name: 'DisableEditingLaborRate')
  final bool? disableEditingLaborRate;
  @JsonKey(name: 'DisableEditingRentalSaleRate')
  final bool? disableEditingRentalSaleRate;
  @JsonKey(name: 'DisableEditingLossAndDamageRate')
  final bool? disableEditingLossAndDamageRate;
  @JsonKey(name: 'RentalExtendedTotal')
  final double? rentalExtendedTotal;
  @JsonKey(name: 'SalesExtendedTotal')
  final double? salesExtendedTotal;
  @JsonKey(name: 'LaborExtendedTotal')
  final double? laborExtendedTotal;
  @JsonKey(name: 'MiscellaneousExtendedTotal')
  final double? miscellaneousExtendedTotal;
  @JsonKey(name: 'RentalSaleExtendedTotal')
  final double? rentalSaleExtendedTotal;
  @JsonKey(name: 'LossAndDamageExtendedTotal')
  final double? lossAndDamageExtendedTotal;
  @JsonKey(name: 'HasNotes')
  final bool? hasNotes;
  @JsonKey(name: 'HasDocuments')
  final bool? hasDocuments;
  @JsonKey(name: 'HasEmailHistory')
  final bool? hasEmailHistory;
  @JsonKey(name: 'HasContacts')
  final bool? hasContacts;
  @JsonKey(name: 'HasSubPurchaseOrders')
  final bool? hasSubPurchaseOrders;
  @JsonKey(name: 'HasPickLists')
  final bool? hasPickLists;
  @JsonKey(name: 'HasContracts')
  final bool? hasContracts;
  @JsonKey(name: 'HasSuspendedContracts')
  final bool? hasSuspendedContracts;
  @JsonKey(name: 'HasMultiOrderContracts')
  final bool? hasMultiOrderContracts;
  @JsonKey(name: 'HasInvoices')
  final bool? hasInvoices;
  @JsonKey(name: 'HasBillingWorksheets')
  final bool? hasBillingWorksheets;
  @JsonKey(name: 'HasMultiOrderInvoices')
  final bool? hasMultiOrderInvoices;
  @JsonKey(name: 'TotalReplacementCost')
  final double? totalReplacementCost;
  @JsonKey(name: 'PresentationLayerId')
  final String? presentationLayerId;
  @JsonKey(name: 'PresentationLayer')
  final String? presentationLayer;
  @JsonKey(name: 'IsManualSort')
  final bool? isManualSort;
  @JsonKey(name: 'QuoteOrderTitle')
  final String? quoteOrderTitle;
  @JsonKey(name: 'UnassignedSubs')
  final bool? unassignedSubs;
  @JsonKey(name: 'NonTaxable')
  final bool? nonTaxable;
  @JsonKey(name: 'EnableProjects')
  final bool? enableProjects;
  @JsonKey(name: 'ProjectId')
  final String? projectId;
  @JsonKey(name: 'ProjectNumber')
  final String? projectNumber;
  @JsonKey(name: 'Project')
  final String? project;
  @JsonKey(name: 'ProjectDrawingsId')
  final String? projectDrawingsId;
  @JsonKey(name: 'ProjectDrawings')
  final String? projectDrawings;
  @JsonKey(name: 'ProjectItemsOrderedId')
  final String? projectItemsOrderedId;
  @JsonKey(name: 'ProjectItemsOrdered')
  final String? projectItemsOrdered;
  @JsonKey(name: 'ProjectDropShipId')
  final String? projectDropShipId;
  @JsonKey(name: 'ProjectDropShip')
  final String? projectDropShip;
  @JsonKey(name: 'ProjectAsBuildId')
  final String? projectAsBuildId;
  @JsonKey(name: 'ProjectAsBuild')
  final String? projectAsBuild;
  @JsonKey(name: 'ProjectCommissioningId')
  final String? projectCommissioningId;
  @JsonKey(name: 'ProjectCommissioning')
  final String? projectCommissioning;
  @JsonKey(name: 'ProjectDepositId')
  final String? projectDepositId;
  @JsonKey(name: 'ProjectDeposit')
  final String? projectDeposit;
  @JsonKey(name: 'InputByUserId')
  final String? inputByUserId;
  @JsonKey(name: 'ModifiedByUserId')
  final String? modifiedByUserId;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory = _$WebApiModulesAgentOrderOrderBaseFromJson;
  static const toJsonFactory = _$WebApiModulesAgentOrderOrderBaseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderOrderBaseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderOrderBase &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.officeLocationId, officeLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocationId, officeLocationId)) &&
            (identical(other.officeLocation, officeLocation) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocation, officeLocation)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouse, warehouse) ||
                const DeepCollectionEquality()
                    .equals(other.warehouse, warehouse)) &&
            (identical(other.warehouseCode, warehouseCode) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.departmentId, departmentId) ||
                const DeepCollectionEquality()
                    .equals(other.departmentId, departmentId)) &&
            (identical(other.department, department) ||
                const DeepCollectionEquality()
                    .equals(other.department, department)) &&
            (identical(other.customerId, customerId) ||
                const DeepCollectionEquality()
                    .equals(other.customerId, customerId)) &&
            (identical(other.customer, customer) ||
                const DeepCollectionEquality()
                    .equals(other.customer, customer)) &&
            (identical(other.customerNumber, customerNumber) ||
                const DeepCollectionEquality()
                    .equals(other.customerNumber, customerNumber)) &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.deal, deal) ||
                const DeepCollectionEquality().equals(other.deal, deal)) &&
            (identical(other.dealNumber, dealNumber) ||
                const DeepCollectionEquality()
                    .equals(other.dealNumber, dealNumber)) &&
            (identical(other.rateType, rateType) ||
                const DeepCollectionEquality()
                    .equals(other.rateType, rateType)) &&
            (identical(other.rateTypeDisplay, rateTypeDisplay) ||
                const DeepCollectionEquality()
                    .equals(other.rateTypeDisplay, rateTypeDisplay)) &&
            (identical(other.agentId, agentId) ||
                const DeepCollectionEquality()
                    .equals(other.agentId, agentId)) &&
            (identical(other.agent, agent) ||
                const DeepCollectionEquality().equals(other.agent, agent)) &&
            (identical(other.projectManagerId, projectManagerId) ||
                const DeepCollectionEquality()
                    .equals(other.projectManagerId, projectManagerId)) &&
            (identical(other.projectManager, projectManager) ||
                const DeepCollectionEquality()
                    .equals(other.projectManager, projectManager)) &&
            (identical(other.rental, rental) ||
                const DeepCollectionEquality().equals(other.rental, rental)) &&
            (identical(other.sales, sales) ||
                const DeepCollectionEquality().equals(other.sales, sales)) &&
            (identical(other.miscellaneous, miscellaneous) ||
                const DeepCollectionEquality()
                    .equals(other.miscellaneous, miscellaneous)) &&
            (identical(other.labor, labor) ||
                const DeepCollectionEquality().equals(other.labor, labor)) &&
            (identical(other.facilities, facilities) ||
                const DeepCollectionEquality().equals(other.facilities, facilities)) &&
            (identical(other.transportation, transportation) || const DeepCollectionEquality().equals(other.transportation, transportation)) &&
            (identical(other.rentalSale, rentalSale) || const DeepCollectionEquality().equals(other.rentalSale, rentalSale)) &&
            (identical(other.lossAndDamage, lossAndDamage) || const DeepCollectionEquality().equals(other.lossAndDamage, lossAndDamage)) &&
            (identical(other.repair, repair) || const DeepCollectionEquality().equals(other.repair, repair)) &&
            (identical(other.hasRentalItem, hasRentalItem) || const DeepCollectionEquality().equals(other.hasRentalItem, hasRentalItem)) &&
            (identical(other.hasSalesItem, hasSalesItem) || const DeepCollectionEquality().equals(other.hasSalesItem, hasSalesItem)) &&
            (identical(other.hasMiscellaneousItem, hasMiscellaneousItem) || const DeepCollectionEquality().equals(other.hasMiscellaneousItem, hasMiscellaneousItem)) &&
            (identical(other.hasLaborItem, hasLaborItem) || const DeepCollectionEquality().equals(other.hasLaborItem, hasLaborItem)) &&
            (identical(other.hasFacilitiesItem, hasFacilitiesItem) || const DeepCollectionEquality().equals(other.hasFacilitiesItem, hasFacilitiesItem)) &&
            (identical(other.hasLossAndDamageItem, hasLossAndDamageItem) || const DeepCollectionEquality().equals(other.hasLossAndDamageItem, hasLossAndDamageItem)) &&
            (identical(other.hasRentalSaleItem, hasRentalSaleItem) || const DeepCollectionEquality().equals(other.hasRentalSaleItem, hasRentalSaleItem)) &&
            (identical(other.hasRepair, hasRepair) || const DeepCollectionEquality().equals(other.hasRepair, hasRepair)) &&
            (identical(other.activityDatesAndTimes, activityDatesAndTimes) || const DeepCollectionEquality().equals(other.activityDatesAndTimes, activityDatesAndTimes)) &&
            (identical(other.pickDate, pickDate) || const DeepCollectionEquality().equals(other.pickDate, pickDate)) &&
            (identical(other.pickTime, pickTime) || const DeepCollectionEquality().equals(other.pickTime, pickTime)) &&
            (identical(other.estimatedStartDate, estimatedStartDate) || const DeepCollectionEquality().equals(other.estimatedStartDate, estimatedStartDate)) &&
            (identical(other.estimatedStartTime, estimatedStartTime) || const DeepCollectionEquality().equals(other.estimatedStartTime, estimatedStartTime)) &&
            (identical(other.estimatedStopDate, estimatedStopDate) || const DeepCollectionEquality().equals(other.estimatedStopDate, estimatedStopDate)) &&
            (identical(other.estimatedStopTime, estimatedStopTime) || const DeepCollectionEquality().equals(other.estimatedStopTime, estimatedStopTime)) &&
            (identical(other.pickUpDate, pickUpDate) || const DeepCollectionEquality().equals(other.pickUpDate, pickUpDate)) &&
            (identical(other.pickUpTime, pickUpTime) || const DeepCollectionEquality().equals(other.pickUpTime, pickUpTime)) &&
            (identical(other.prepDate, prepDate) || const DeepCollectionEquality().equals(other.prepDate, prepDate)) &&
            (identical(other.prepTime, prepTime) || const DeepCollectionEquality().equals(other.prepTime, prepTime)) &&
            (identical(other.loadInDate, loadInDate) || const DeepCollectionEquality().equals(other.loadInDate, loadInDate)) &&
            (identical(other.loadInTime, loadInTime) || const DeepCollectionEquality().equals(other.loadInTime, loadInTime)) &&
            (identical(other.strikeDate, strikeDate) || const DeepCollectionEquality().equals(other.strikeDate, strikeDate)) &&
            (identical(other.strikeTime, strikeTime) || const DeepCollectionEquality().equals(other.strikeTime, strikeTime)) &&
            (identical(other.testDate, testDate) || const DeepCollectionEquality().equals(other.testDate, testDate)) &&
            (identical(other.testTime, testTime) || const DeepCollectionEquality().equals(other.testTime, testTime)) &&
            (identical(other.orderTypeId, orderTypeId) || const DeepCollectionEquality().equals(other.orderTypeId, orderTypeId)) &&
            (identical(other.orderType, orderType) || const DeepCollectionEquality().equals(other.orderType, orderType)) &&
            (identical(other.orderTypeCombineActivityTabs, orderTypeCombineActivityTabs) || const DeepCollectionEquality().equals(other.orderTypeCombineActivityTabs, orderTypeCombineActivityTabs)) &&
            (identical(other.flatPo, flatPo) || const DeepCollectionEquality().equals(other.flatPo, flatPo)) &&
            (identical(other.pendingPo, pendingPo) || const DeepCollectionEquality().equals(other.pendingPo, pendingPo)) &&
            (identical(other.poNumber, poNumber) || const DeepCollectionEquality().equals(other.poNumber, poNumber)) &&
            (identical(other.poAmount, poAmount) || const DeepCollectionEquality().equals(other.poAmount, poAmount)) &&
            (identical(other.location, location) || const DeepCollectionEquality().equals(other.location, location)) &&
            (identical(other.orderLocationId, orderLocationId) || const DeepCollectionEquality().equals(other.orderLocationId, orderLocationId)) &&
            (identical(other.orderLocation, orderLocation) || const DeepCollectionEquality().equals(other.orderLocation, orderLocation)) &&
            (identical(other.referenceNumber, referenceNumber) || const DeepCollectionEquality().equals(other.referenceNumber, referenceNumber)) &&
            (identical(other.total, total) || const DeepCollectionEquality().equals(other.total, total)) &&
            (identical(other.status, status) || const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.statusDate, statusDate) || const DeepCollectionEquality().equals(other.statusDate, statusDate)) &&
            (identical(other.poApprovalStatusId, poApprovalStatusId) || const DeepCollectionEquality().equals(other.poApprovalStatusId, poApprovalStatusId)) &&
            (identical(other.lockBillingDates, lockBillingDates) || const DeepCollectionEquality().equals(other.lockBillingDates, lockBillingDates)) &&
            (identical(other.specifyBillingDatesByType, specifyBillingDatesByType) || const DeepCollectionEquality().equals(other.specifyBillingDatesByType, specifyBillingDatesByType)) &&
            (identical(other.rentalBillingStartDate, rentalBillingStartDate) || const DeepCollectionEquality().equals(other.rentalBillingStartDate, rentalBillingStartDate)) &&
            (identical(other.rentalBillingEndDate, rentalBillingEndDate) || const DeepCollectionEquality().equals(other.rentalBillingEndDate, rentalBillingEndDate)) &&
            (identical(other.laborBillingStartDate, laborBillingStartDate) || const DeepCollectionEquality().equals(other.laborBillingStartDate, laborBillingStartDate)) &&
            (identical(other.laborBillingEndDate, laborBillingEndDate) || const DeepCollectionEquality().equals(other.laborBillingEndDate, laborBillingEndDate)) &&
            (identical(other.miscellaneousBillingStartDate, miscellaneousBillingStartDate) || const DeepCollectionEquality().equals(other.miscellaneousBillingStartDate, miscellaneousBillingStartDate)) &&
            (identical(other.miscellaneousBillingEndDate, miscellaneousBillingEndDate) || const DeepCollectionEquality().equals(other.miscellaneousBillingEndDate, miscellaneousBillingEndDate)) &&
            (identical(other.facilitiesBillingStartDate, facilitiesBillingStartDate) || const DeepCollectionEquality().equals(other.facilitiesBillingStartDate, facilitiesBillingStartDate)) &&
            (identical(other.facilitiesBillingEndDate, facilitiesBillingEndDate) || const DeepCollectionEquality().equals(other.facilitiesBillingEndDate, facilitiesBillingEndDate)) &&
            (identical(other.vehicleBillingStartDate, vehicleBillingStartDate) || const DeepCollectionEquality().equals(other.vehicleBillingStartDate, vehicleBillingStartDate)) &&
            (identical(other.vehicleBillingEndDate, vehicleBillingEndDate) || const DeepCollectionEquality().equals(other.vehicleBillingEndDate, vehicleBillingEndDate)) &&
            (identical(other.delayBillingSearchUntil, delayBillingSearchUntil) || const DeepCollectionEquality().equals(other.delayBillingSearchUntil, delayBillingSearchUntil)) &&
            (identical(other.includePrepFeesInRentalRate, includePrepFeesInRentalRate) || const DeepCollectionEquality().equals(other.includePrepFeesInRentalRate, includePrepFeesInRentalRate)) &&
            (identical(other.billingStartDate, billingStartDate) || const DeepCollectionEquality().equals(other.billingStartDate, billingStartDate)) &&
            (identical(other.billingEndDate, billingEndDate) || const DeepCollectionEquality().equals(other.billingEndDate, billingEndDate)) &&
            (identical(other.billingWeeks, billingWeeks) || const DeepCollectionEquality().equals(other.billingWeeks, billingWeeks)) &&
            (identical(other.billingMonths, billingMonths) || const DeepCollectionEquality().equals(other.billingMonths, billingMonths)) &&
            (identical(other.determineQuantitiesToBillBasedOn, determineQuantitiesToBillBasedOn) || const DeepCollectionEquality().equals(other.determineQuantitiesToBillBasedOn, determineQuantitiesToBillBasedOn)) &&
            (identical(other.billingCycleId, billingCycleId) || const DeepCollectionEquality().equals(other.billingCycleId, billingCycleId)) &&
            (identical(other.billingCycle, billingCycle) || const DeepCollectionEquality().equals(other.billingCycle, billingCycle)) &&
            (identical(other.billingCycleType, billingCycleType) || const DeepCollectionEquality().equals(other.billingCycleType, billingCycleType)) &&
            (identical(other.paymentTermsId, paymentTermsId) || const DeepCollectionEquality().equals(other.paymentTermsId, paymentTermsId)) &&
            (identical(other.paymentTerms, paymentTerms) || const DeepCollectionEquality().equals(other.paymentTerms, paymentTerms)) &&
            (identical(other.paymentTypeId, paymentTypeId) || const DeepCollectionEquality().equals(other.paymentTypeId, paymentTypeId)) &&
            (identical(other.paymentType, paymentType) || const DeepCollectionEquality().equals(other.paymentType, paymentType)) &&
            (identical(other.currencyId, currencyId) || const DeepCollectionEquality().equals(other.currencyId, currencyId)) &&
            (identical(other.updateAllRatesToNewCurrency, updateAllRatesToNewCurrency) || const DeepCollectionEquality().equals(other.updateAllRatesToNewCurrency, updateAllRatesToNewCurrency)) &&
            (identical(other.confirmUpdateAllRatesToNewCurrency, confirmUpdateAllRatesToNewCurrency) || const DeepCollectionEquality().equals(other.confirmUpdateAllRatesToNewCurrency, confirmUpdateAllRatesToNewCurrency)) &&
            (identical(other.currencyCode, currencyCode) || const DeepCollectionEquality().equals(other.currencyCode, currencyCode)) &&
            (identical(other.currency, currency) || const DeepCollectionEquality().equals(other.currency, currency)) &&
            (identical(other.currencySymbol, currencySymbol) || const DeepCollectionEquality().equals(other.currencySymbol, currencySymbol)) &&
            (identical(other.taxOptionId, taxOptionId) || const DeepCollectionEquality().equals(other.taxOptionId, taxOptionId)) &&
            (identical(other.taxOption, taxOption) || const DeepCollectionEquality().equals(other.taxOption, taxOption)) &&
            (identical(other.tax1Name, tax1Name) || const DeepCollectionEquality().equals(other.tax1Name, tax1Name)) &&
            (identical(other.tax2Name, tax2Name) || const DeepCollectionEquality().equals(other.tax2Name, tax2Name)) &&
            (identical(other.taxId, taxId) || const DeepCollectionEquality().equals(other.taxId, taxId)) &&
            (identical(other.rentalTaxRate1, rentalTaxRate1) || const DeepCollectionEquality().equals(other.rentalTaxRate1, rentalTaxRate1)) &&
            (identical(other.salesTaxRate1, salesTaxRate1) || const DeepCollectionEquality().equals(other.salesTaxRate1, salesTaxRate1)) &&
            (identical(other.laborTaxRate1, laborTaxRate1) || const DeepCollectionEquality().equals(other.laborTaxRate1, laborTaxRate1)) &&
            (identical(other.rentalTaxRate2, rentalTaxRate2) || const DeepCollectionEquality().equals(other.rentalTaxRate2, rentalTaxRate2)) &&
            (identical(other.salesTaxRate2, salesTaxRate2) || const DeepCollectionEquality().equals(other.salesTaxRate2, salesTaxRate2)) &&
            (identical(other.laborTaxRate2, laborTaxRate2) || const DeepCollectionEquality().equals(other.laborTaxRate2, laborTaxRate2)) &&
            (identical(other.noCharge, noCharge) || const DeepCollectionEquality().equals(other.noCharge, noCharge)) &&
            (identical(other.noChargeReason, noChargeReason) || const DeepCollectionEquality().equals(other.noChargeReason, noChargeReason)) &&
            (identical(other.printIssuedToAddressFrom, printIssuedToAddressFrom) || const DeepCollectionEquality().equals(other.printIssuedToAddressFrom, printIssuedToAddressFrom)) &&
            (identical(other.issuedToName, issuedToName) || const DeepCollectionEquality().equals(other.issuedToName, issuedToName)) &&
            (identical(other.issuedToAttention, issuedToAttention) || const DeepCollectionEquality().equals(other.issuedToAttention, issuedToAttention)) &&
            (identical(other.issuedToAttention2, issuedToAttention2) || const DeepCollectionEquality().equals(other.issuedToAttention2, issuedToAttention2)) &&
            (identical(other.issuedToAddress1, issuedToAddress1) || const DeepCollectionEquality().equals(other.issuedToAddress1, issuedToAddress1)) &&
            (identical(other.issuedToAddress2, issuedToAddress2) || const DeepCollectionEquality().equals(other.issuedToAddress2, issuedToAddress2)) &&
            (identical(other.issuedToCity, issuedToCity) || const DeepCollectionEquality().equals(other.issuedToCity, issuedToCity)) &&
            (identical(other.issuedToState, issuedToState) || const DeepCollectionEquality().equals(other.issuedToState, issuedToState)) &&
            (identical(other.issuedToZipCode, issuedToZipCode) || const DeepCollectionEquality().equals(other.issuedToZipCode, issuedToZipCode)) &&
            (identical(other.issuedToCountryId, issuedToCountryId) || const DeepCollectionEquality().equals(other.issuedToCountryId, issuedToCountryId)) &&
            (identical(other.issuedToCountry, issuedToCountry) || const DeepCollectionEquality().equals(other.issuedToCountry, issuedToCountry)) &&
            (identical(other.billToAddressDifferentFromIssuedToAddress, billToAddressDifferentFromIssuedToAddress) || const DeepCollectionEquality().equals(other.billToAddressDifferentFromIssuedToAddress, billToAddressDifferentFromIssuedToAddress)) &&
            (identical(other.billToAddressId, billToAddressId) || const DeepCollectionEquality().equals(other.billToAddressId, billToAddressId)) &&
            (identical(other.billToName, billToName) || const DeepCollectionEquality().equals(other.billToName, billToName)) &&
            (identical(other.billToAttention, billToAttention) || const DeepCollectionEquality().equals(other.billToAttention, billToAttention)) &&
            (identical(other.billToAttention2, billToAttention2) || const DeepCollectionEquality().equals(other.billToAttention2, billToAttention2)) &&
            (identical(other.billToAddress1, billToAddress1) || const DeepCollectionEquality().equals(other.billToAddress1, billToAddress1)) &&
            (identical(other.billToAddress2, billToAddress2) || const DeepCollectionEquality().equals(other.billToAddress2, billToAddress2)) &&
            (identical(other.billToCity, billToCity) || const DeepCollectionEquality().equals(other.billToCity, billToCity)) &&
            (identical(other.billToState, billToState) || const DeepCollectionEquality().equals(other.billToState, billToState)) &&
            (identical(other.billToZipCode, billToZipCode) || const DeepCollectionEquality().equals(other.billToZipCode, billToZipCode)) &&
            (identical(other.billToCountryId, billToCountryId) || const DeepCollectionEquality().equals(other.billToCountryId, billToCountryId)) &&
            (identical(other.billToCountry, billToCountry) || const DeepCollectionEquality().equals(other.billToCountry, billToCountry)) &&
            (identical(other.discountReasonId, discountReasonId) || const DeepCollectionEquality().equals(other.discountReasonId, discountReasonId)) &&
            (identical(other.discountReason, discountReason) || const DeepCollectionEquality().equals(other.discountReason, discountReason)) &&
            (identical(other.requireContactConfirmation, requireContactConfirmation) || const DeepCollectionEquality().equals(other.requireContactConfirmation, requireContactConfirmation)) &&
            (identical(other.includeInBillingAnalysis, includeInBillingAnalysis) || const DeepCollectionEquality().equals(other.includeInBillingAnalysis, includeInBillingAnalysis)) &&
            (identical(other.hiatusDiscountFrom, hiatusDiscountFrom) || const DeepCollectionEquality().equals(other.hiatusDiscountFrom, hiatusDiscountFrom)) &&
            (identical(other.roundTripRentals, roundTripRentals) || const DeepCollectionEquality().equals(other.roundTripRentals, roundTripRentals)) &&
            (identical(other.inGroup, inGroup) || const DeepCollectionEquality().equals(other.inGroup, inGroup)) &&
            (identical(other.groupNumber, groupNumber) || const DeepCollectionEquality().equals(other.groupNumber, groupNumber)) &&
            (identical(other.groupColor, groupColor) || const DeepCollectionEquality().equals(other.groupColor, groupColor)) &&
            (identical(other.groupOrderBy, groupOrderBy) || const DeepCollectionEquality().equals(other.groupOrderBy, groupOrderBy)) &&
            (identical(other.coverLetterId, coverLetterId) || const DeepCollectionEquality().equals(other.coverLetterId, coverLetterId)) &&
            (identical(other.coverLetter, coverLetter) || const DeepCollectionEquality().equals(other.coverLetter, coverLetter)) &&
            (identical(other.termsConditionsId, termsConditionsId) || const DeepCollectionEquality().equals(other.termsConditionsId, termsConditionsId)) &&
            (identical(other.termsConditions, termsConditions) || const DeepCollectionEquality().equals(other.termsConditions, termsConditions)) &&
            (identical(other.outsideSalesRepresentativeId, outsideSalesRepresentativeId) || const DeepCollectionEquality().equals(other.outsideSalesRepresentativeId, outsideSalesRepresentativeId)) &&
            (identical(other.outsideSalesRepresentative, outsideSalesRepresentative) || const DeepCollectionEquality().equals(other.outsideSalesRepresentative, outsideSalesRepresentative)) &&
            (identical(other.marketTypeId, marketTypeId) || const DeepCollectionEquality().equals(other.marketTypeId, marketTypeId)) &&
            (identical(other.marketType, marketType) || const DeepCollectionEquality().equals(other.marketType, marketType)) &&
            (identical(other.marketSegmentId, marketSegmentId) || const DeepCollectionEquality().equals(other.marketSegmentId, marketSegmentId)) &&
            (identical(other.marketSegment, marketSegment) || const DeepCollectionEquality().equals(other.marketSegment, marketSegment)) &&
            (identical(other.marketSegmentJobId, marketSegmentJobId) || const DeepCollectionEquality().equals(other.marketSegmentJobId, marketSegmentJobId)) &&
            (identical(other.marketSegmentJob, marketSegmentJob) || const DeepCollectionEquality().equals(other.marketSegmentJob, marketSegmentJob)) &&
            (identical(other.outDeliveryId, outDeliveryId) || const DeepCollectionEquality().equals(other.outDeliveryId, outDeliveryId)) &&
            (identical(other.outDeliveryDeliveryType, outDeliveryDeliveryType) || const DeepCollectionEquality().equals(other.outDeliveryDeliveryType, outDeliveryDeliveryType)) &&
            (identical(other.outDeliveryRequiredDate, outDeliveryRequiredDate) || const DeepCollectionEquality().equals(other.outDeliveryRequiredDate, outDeliveryRequiredDate)) &&
            (identical(other.outDeliveryRequiredTime, outDeliveryRequiredTime) || const DeepCollectionEquality().equals(other.outDeliveryRequiredTime, outDeliveryRequiredTime)) &&
            (identical(other.outDeliveryTargetShipDate, outDeliveryTargetShipDate) || const DeepCollectionEquality().equals(other.outDeliveryTargetShipDate, outDeliveryTargetShipDate)) &&
            (identical(other.outDeliveryTargetShipTime, outDeliveryTargetShipTime) || const DeepCollectionEquality().equals(other.outDeliveryTargetShipTime, outDeliveryTargetShipTime)) &&
            (identical(other.outDeliveryDirection, outDeliveryDirection) || const DeepCollectionEquality().equals(other.outDeliveryDirection, outDeliveryDirection)) &&
            (identical(other.outDeliveryAddressType, outDeliveryAddressType) || const DeepCollectionEquality().equals(other.outDeliveryAddressType, outDeliveryAddressType)) &&
            (identical(other.outDeliveryFromLocation, outDeliveryFromLocation) || const DeepCollectionEquality().equals(other.outDeliveryFromLocation, outDeliveryFromLocation)) &&
            (identical(other.outDeliveryFromContact, outDeliveryFromContact) || const DeepCollectionEquality().equals(other.outDeliveryFromContact, outDeliveryFromContact)) &&
            (identical(other.outDeliveryFromContactPhone, outDeliveryFromContactPhone) || const DeepCollectionEquality().equals(other.outDeliveryFromContactPhone, outDeliveryFromContactPhone)) &&
            (identical(other.outDeliveryFromAlternateContact, outDeliveryFromAlternateContact) || const DeepCollectionEquality().equals(other.outDeliveryFromAlternateContact, outDeliveryFromAlternateContact)) &&
            (identical(other.outDeliveryFromAlternateContactPhone, outDeliveryFromAlternateContactPhone) || const DeepCollectionEquality().equals(other.outDeliveryFromAlternateContactPhone, outDeliveryFromAlternateContactPhone)) &&
            (identical(other.outDeliveryFromAttention, outDeliveryFromAttention) || const DeepCollectionEquality().equals(other.outDeliveryFromAttention, outDeliveryFromAttention)) &&
            (identical(other.outDeliveryFromAddress1, outDeliveryFromAddress1) || const DeepCollectionEquality().equals(other.outDeliveryFromAddress1, outDeliveryFromAddress1)) &&
            (identical(other.outDeliveryFromAdd2ress, outDeliveryFromAdd2ress) || const DeepCollectionEquality().equals(other.outDeliveryFromAdd2ress, outDeliveryFromAdd2ress)) &&
            (identical(other.outDeliveryFromCity, outDeliveryFromCity) || const DeepCollectionEquality().equals(other.outDeliveryFromCity, outDeliveryFromCity)) &&
            (identical(other.outDeliveryFromState, outDeliveryFromState) || const DeepCollectionEquality().equals(other.outDeliveryFromState, outDeliveryFromState)) &&
            (identical(other.outDeliveryFromZipCode, outDeliveryFromZipCode) || const DeepCollectionEquality().equals(other.outDeliveryFromZipCode, outDeliveryFromZipCode)) &&
            (identical(other.outDeliveryFromCountry, outDeliveryFromCountry) || const DeepCollectionEquality().equals(other.outDeliveryFromCountry, outDeliveryFromCountry)) &&
            (identical(other.outDeliveryFromCountryId, outDeliveryFromCountryId) || const DeepCollectionEquality().equals(other.outDeliveryFromCountryId, outDeliveryFromCountryId)) &&
            (identical(other.outDeliveryFromCrossStreets, outDeliveryFromCrossStreets) || const DeepCollectionEquality().equals(other.outDeliveryFromCrossStreets, outDeliveryFromCrossStreets)) &&
            (identical(other.outDeliveryToLocation, outDeliveryToLocation) || const DeepCollectionEquality().equals(other.outDeliveryToLocation, outDeliveryToLocation)) &&
            (identical(other.outDeliveryToContact, outDeliveryToContact) || const DeepCollectionEquality().equals(other.outDeliveryToContact, outDeliveryToContact)) &&
            (identical(other.outDeliveryToContactPhone, outDeliveryToContactPhone) || const DeepCollectionEquality().equals(other.outDeliveryToContactPhone, outDeliveryToContactPhone)) &&
            (identical(other.outDeliveryToAlternateContact, outDeliveryToAlternateContact) || const DeepCollectionEquality().equals(other.outDeliveryToAlternateContact, outDeliveryToAlternateContact)) &&
            (identical(other.outDeliveryToAlternateContactPhone, outDeliveryToAlternateContactPhone) || const DeepCollectionEquality().equals(other.outDeliveryToAlternateContactPhone, outDeliveryToAlternateContactPhone)) &&
            (identical(other.outDeliveryToAttention, outDeliveryToAttention) || const DeepCollectionEquality().equals(other.outDeliveryToAttention, outDeliveryToAttention)) &&
            (identical(other.outDeliveryToAddress1, outDeliveryToAddress1) || const DeepCollectionEquality().equals(other.outDeliveryToAddress1, outDeliveryToAddress1)) &&
            (identical(other.outDeliveryToAddress2, outDeliveryToAddress2) || const DeepCollectionEquality().equals(other.outDeliveryToAddress2, outDeliveryToAddress2)) &&
            (identical(other.outDeliveryToCity, outDeliveryToCity) || const DeepCollectionEquality().equals(other.outDeliveryToCity, outDeliveryToCity)) &&
            (identical(other.outDeliveryToState, outDeliveryToState) || const DeepCollectionEquality().equals(other.outDeliveryToState, outDeliveryToState)) &&
            (identical(other.outDeliveryToZipCode, outDeliveryToZipCode) || const DeepCollectionEquality().equals(other.outDeliveryToZipCode, outDeliveryToZipCode)) &&
            (identical(other.outDeliveryToCountryId, outDeliveryToCountryId) || const DeepCollectionEquality().equals(other.outDeliveryToCountryId, outDeliveryToCountryId)) &&
            (identical(other.outDeliveryToCountry, outDeliveryToCountry) || const DeepCollectionEquality().equals(other.outDeliveryToCountry, outDeliveryToCountry)) &&
            (identical(other.outDeliveryToContactFax, outDeliveryToContactFax) || const DeepCollectionEquality().equals(other.outDeliveryToContactFax, outDeliveryToContactFax)) &&
            (identical(other.outDeliveryToCrossStreets, outDeliveryToCrossStreets) || const DeepCollectionEquality().equals(other.outDeliveryToCrossStreets, outDeliveryToCrossStreets)) &&
            (identical(other.outDeliveryDeliveryNotes, outDeliveryDeliveryNotes) || const DeepCollectionEquality().equals(other.outDeliveryDeliveryNotes, outDeliveryDeliveryNotes)) &&
            (identical(other.outDeliveryCarrierId, outDeliveryCarrierId) || const DeepCollectionEquality().equals(other.outDeliveryCarrierId, outDeliveryCarrierId)) &&
            (identical(other.outDeliveryCarrier, outDeliveryCarrier) || const DeepCollectionEquality().equals(other.outDeliveryCarrier, outDeliveryCarrier)) &&
            (identical(other.outDeliveryCarrierAccount, outDeliveryCarrierAccount) || const DeepCollectionEquality().equals(other.outDeliveryCarrierAccount, outDeliveryCarrierAccount)) &&
            (identical(other.outDeliveryShipViaId, outDeliveryShipViaId) || const DeepCollectionEquality().equals(other.outDeliveryShipViaId, outDeliveryShipViaId)) &&
            (identical(other.outDeliveryShipVia, outDeliveryShipVia) || const DeepCollectionEquality().equals(other.outDeliveryShipVia, outDeliveryShipVia)) &&
            (identical(other.outDeliveryInvoiceId, outDeliveryInvoiceId) || const DeepCollectionEquality().equals(other.outDeliveryInvoiceId, outDeliveryInvoiceId)) &&
            (identical(other.outDeliveryVendorInvoiceId, outDeliveryVendorInvoiceId) || const DeepCollectionEquality().equals(other.outDeliveryVendorInvoiceId, outDeliveryVendorInvoiceId)) &&
            (identical(other.outDeliveryEstimatedFreight, outDeliveryEstimatedFreight) || const DeepCollectionEquality().equals(other.outDeliveryEstimatedFreight, outDeliveryEstimatedFreight)) &&
            (identical(other.outDeliveryFreightInvoiceAmount, outDeliveryFreightInvoiceAmount) || const DeepCollectionEquality().equals(other.outDeliveryFreightInvoiceAmount, outDeliveryFreightInvoiceAmount)) &&
            (identical(other.outDeliveryChargeType, outDeliveryChargeType) || const DeepCollectionEquality().equals(other.outDeliveryChargeType, outDeliveryChargeType)) &&
            (identical(other.outDeliveryFreightTrackingNumber, outDeliveryFreightTrackingNumber) || const DeepCollectionEquality().equals(other.outDeliveryFreightTrackingNumber, outDeliveryFreightTrackingNumber)) &&
            (identical(other.outDeliveryFreightTrackingUrl, outDeliveryFreightTrackingUrl) || const DeepCollectionEquality().equals(other.outDeliveryFreightTrackingUrl, outDeliveryFreightTrackingUrl)) &&
            (identical(other.outDeliveryPackageCode, outDeliveryPackageCode) || const DeepCollectionEquality().equals(other.outDeliveryPackageCode, outDeliveryPackageCode)) &&
            (identical(other.outDeliveryBillPoFreightOnOrder, outDeliveryBillPoFreightOnOrder) || const DeepCollectionEquality().equals(other.outDeliveryBillPoFreightOnOrder, outDeliveryBillPoFreightOnOrder)) &&
            (identical(other.outDeliveryOnlineOrderNumber, outDeliveryOnlineOrderNumber) || const DeepCollectionEquality().equals(other.outDeliveryOnlineOrderNumber, outDeliveryOnlineOrderNumber)) &&
            (identical(other.outDeliveryToVenue, outDeliveryToVenue) || const DeepCollectionEquality().equals(other.outDeliveryToVenue, outDeliveryToVenue)) &&
            (identical(other.outDeliveryToVenueId, outDeliveryToVenueId) || const DeepCollectionEquality().equals(other.outDeliveryToVenueId, outDeliveryToVenueId)) &&
            (identical(other.outDeliveryToWarehouse, outDeliveryToWarehouse) || const DeepCollectionEquality().equals(other.outDeliveryToWarehouse, outDeliveryToWarehouse)) &&
            (identical(other.outDeliveryToWarehouseId, outDeliveryToWarehouseId) || const DeepCollectionEquality().equals(other.outDeliveryToWarehouseId, outDeliveryToWarehouseId)) &&
            (identical(other.outDeliveryDateStamp, outDeliveryDateStamp) || const DeepCollectionEquality().equals(other.outDeliveryDateStamp, outDeliveryDateStamp)) &&
            (identical(other.inDeliveryId, inDeliveryId) || const DeepCollectionEquality().equals(other.inDeliveryId, inDeliveryId)) &&
            (identical(other.inDeliveryDeliveryType, inDeliveryDeliveryType) || const DeepCollectionEquality().equals(other.inDeliveryDeliveryType, inDeliveryDeliveryType)) &&
            (identical(other.inDeliveryRequiredDate, inDeliveryRequiredDate) || const DeepCollectionEquality().equals(other.inDeliveryRequiredDate, inDeliveryRequiredDate)) &&
            (identical(other.inDeliveryRequiredTime, inDeliveryRequiredTime) || const DeepCollectionEquality().equals(other.inDeliveryRequiredTime, inDeliveryRequiredTime)) &&
            (identical(other.inDeliveryTargetShipDate, inDeliveryTargetShipDate) || const DeepCollectionEquality().equals(other.inDeliveryTargetShipDate, inDeliveryTargetShipDate)) &&
            (identical(other.inDeliveryTargetShipTime, inDeliveryTargetShipTime) || const DeepCollectionEquality().equals(other.inDeliveryTargetShipTime, inDeliveryTargetShipTime)) &&
            (identical(other.inDeliveryDirection, inDeliveryDirection) || const DeepCollectionEquality().equals(other.inDeliveryDirection, inDeliveryDirection)) &&
            (identical(other.inDeliveryAddressType, inDeliveryAddressType) || const DeepCollectionEquality().equals(other.inDeliveryAddressType, inDeliveryAddressType)) &&
            (identical(other.inDeliveryFromLocation, inDeliveryFromLocation) || const DeepCollectionEquality().equals(other.inDeliveryFromLocation, inDeliveryFromLocation)) &&
            (identical(other.inDeliveryFromContact, inDeliveryFromContact) || const DeepCollectionEquality().equals(other.inDeliveryFromContact, inDeliveryFromContact)) &&
            (identical(other.inDeliveryFromContactPhone, inDeliveryFromContactPhone) || const DeepCollectionEquality().equals(other.inDeliveryFromContactPhone, inDeliveryFromContactPhone)) &&
            (identical(other.inDeliveryFromAlternateContact, inDeliveryFromAlternateContact) || const DeepCollectionEquality().equals(other.inDeliveryFromAlternateContact, inDeliveryFromAlternateContact)) &&
            (identical(other.inDeliveryFromAlternateContactPhone, inDeliveryFromAlternateContactPhone) || const DeepCollectionEquality().equals(other.inDeliveryFromAlternateContactPhone, inDeliveryFromAlternateContactPhone)) &&
            (identical(other.inDeliveryFromAttention, inDeliveryFromAttention) || const DeepCollectionEquality().equals(other.inDeliveryFromAttention, inDeliveryFromAttention)) &&
            (identical(other.inDeliveryFromAddress1, inDeliveryFromAddress1) || const DeepCollectionEquality().equals(other.inDeliveryFromAddress1, inDeliveryFromAddress1)) &&
            (identical(other.inDeliveryFromAdd2ress, inDeliveryFromAdd2ress) || const DeepCollectionEquality().equals(other.inDeliveryFromAdd2ress, inDeliveryFromAdd2ress)) &&
            (identical(other.inDeliveryFromCity, inDeliveryFromCity) || const DeepCollectionEquality().equals(other.inDeliveryFromCity, inDeliveryFromCity)) &&
            (identical(other.inDeliveryFromState, inDeliveryFromState) || const DeepCollectionEquality().equals(other.inDeliveryFromState, inDeliveryFromState)) &&
            (identical(other.inDeliveryFromZipCode, inDeliveryFromZipCode) || const DeepCollectionEquality().equals(other.inDeliveryFromZipCode, inDeliveryFromZipCode)) &&
            (identical(other.inDeliveryFromCountry, inDeliveryFromCountry) || const DeepCollectionEquality().equals(other.inDeliveryFromCountry, inDeliveryFromCountry)) &&
            (identical(other.inDeliveryFromCountryId, inDeliveryFromCountryId) || const DeepCollectionEquality().equals(other.inDeliveryFromCountryId, inDeliveryFromCountryId)) &&
            (identical(other.inDeliveryFromCrossStreets, inDeliveryFromCrossStreets) || const DeepCollectionEquality().equals(other.inDeliveryFromCrossStreets, inDeliveryFromCrossStreets)) &&
            (identical(other.inDeliveryToLocation, inDeliveryToLocation) || const DeepCollectionEquality().equals(other.inDeliveryToLocation, inDeliveryToLocation)) &&
            (identical(other.inDeliveryToContact, inDeliveryToContact) || const DeepCollectionEquality().equals(other.inDeliveryToContact, inDeliveryToContact)) &&
            (identical(other.inDeliveryToContactPhone, inDeliveryToContactPhone) || const DeepCollectionEquality().equals(other.inDeliveryToContactPhone, inDeliveryToContactPhone)) &&
            (identical(other.inDeliveryToAlternateContact, inDeliveryToAlternateContact) || const DeepCollectionEquality().equals(other.inDeliveryToAlternateContact, inDeliveryToAlternateContact)) &&
            (identical(other.inDeliveryToAlternateContactPhone, inDeliveryToAlternateContactPhone) || const DeepCollectionEquality().equals(other.inDeliveryToAlternateContactPhone, inDeliveryToAlternateContactPhone)) &&
            (identical(other.inDeliveryToAttention, inDeliveryToAttention) || const DeepCollectionEquality().equals(other.inDeliveryToAttention, inDeliveryToAttention)) &&
            (identical(other.inDeliveryToAddress1, inDeliveryToAddress1) || const DeepCollectionEquality().equals(other.inDeliveryToAddress1, inDeliveryToAddress1)) &&
            (identical(other.inDeliveryToAddress2, inDeliveryToAddress2) || const DeepCollectionEquality().equals(other.inDeliveryToAddress2, inDeliveryToAddress2)) &&
            (identical(other.inDeliveryToCity, inDeliveryToCity) || const DeepCollectionEquality().equals(other.inDeliveryToCity, inDeliveryToCity)) &&
            (identical(other.inDeliveryToState, inDeliveryToState) || const DeepCollectionEquality().equals(other.inDeliveryToState, inDeliveryToState)) &&
            (identical(other.inDeliveryToZipCode, inDeliveryToZipCode) || const DeepCollectionEquality().equals(other.inDeliveryToZipCode, inDeliveryToZipCode)) &&
            (identical(other.inDeliveryToCountryId, inDeliveryToCountryId) || const DeepCollectionEquality().equals(other.inDeliveryToCountryId, inDeliveryToCountryId)) &&
            (identical(other.inDeliveryToCountry, inDeliveryToCountry) || const DeepCollectionEquality().equals(other.inDeliveryToCountry, inDeliveryToCountry)) &&
            (identical(other.inDeliveryToContactFax, inDeliveryToContactFax) || const DeepCollectionEquality().equals(other.inDeliveryToContactFax, inDeliveryToContactFax)) &&
            (identical(other.inDeliveryToCrossStreets, inDeliveryToCrossStreets) || const DeepCollectionEquality().equals(other.inDeliveryToCrossStreets, inDeliveryToCrossStreets)) &&
            (identical(other.inDeliveryDeliveryNotes, inDeliveryDeliveryNotes) || const DeepCollectionEquality().equals(other.inDeliveryDeliveryNotes, inDeliveryDeliveryNotes)) &&
            (identical(other.inDeliveryCarrierId, inDeliveryCarrierId) || const DeepCollectionEquality().equals(other.inDeliveryCarrierId, inDeliveryCarrierId)) &&
            (identical(other.inDeliveryCarrier, inDeliveryCarrier) || const DeepCollectionEquality().equals(other.inDeliveryCarrier, inDeliveryCarrier)) &&
            (identical(other.inDeliveryCarrierAccount, inDeliveryCarrierAccount) || const DeepCollectionEquality().equals(other.inDeliveryCarrierAccount, inDeliveryCarrierAccount)) &&
            (identical(other.inDeliveryShipViaId, inDeliveryShipViaId) || const DeepCollectionEquality().equals(other.inDeliveryShipViaId, inDeliveryShipViaId)) &&
            (identical(other.inDeliveryShipVia, inDeliveryShipVia) || const DeepCollectionEquality().equals(other.inDeliveryShipVia, inDeliveryShipVia)) &&
            (identical(other.inDeliveryInvoiceId, inDeliveryInvoiceId) || const DeepCollectionEquality().equals(other.inDeliveryInvoiceId, inDeliveryInvoiceId)) &&
            (identical(other.inDeliveryVendorInvoiceId, inDeliveryVendorInvoiceId) || const DeepCollectionEquality().equals(other.inDeliveryVendorInvoiceId, inDeliveryVendorInvoiceId)) &&
            (identical(other.inDeliveryEstimatedFreight, inDeliveryEstimatedFreight) || const DeepCollectionEquality().equals(other.inDeliveryEstimatedFreight, inDeliveryEstimatedFreight)) &&
            (identical(other.inDeliveryFreightInvoiceAmount, inDeliveryFreightInvoiceAmount) || const DeepCollectionEquality().equals(other.inDeliveryFreightInvoiceAmount, inDeliveryFreightInvoiceAmount)) &&
            (identical(other.inDeliveryChargeType, inDeliveryChargeType) || const DeepCollectionEquality().equals(other.inDeliveryChargeType, inDeliveryChargeType)) &&
            (identical(other.inDeliveryFreightTrackingNumber, inDeliveryFreightTrackingNumber) || const DeepCollectionEquality().equals(other.inDeliveryFreightTrackingNumber, inDeliveryFreightTrackingNumber)) &&
            (identical(other.inDeliveryFreightTrackingUrl, inDeliveryFreightTrackingUrl) || const DeepCollectionEquality().equals(other.inDeliveryFreightTrackingUrl, inDeliveryFreightTrackingUrl)) &&
            (identical(other.inDeliveryPackageCode, inDeliveryPackageCode) || const DeepCollectionEquality().equals(other.inDeliveryPackageCode, inDeliveryPackageCode)) &&
            (identical(other.inDeliveryBillPoFreightOnOrder, inDeliveryBillPoFreightOnOrder) || const DeepCollectionEquality().equals(other.inDeliveryBillPoFreightOnOrder, inDeliveryBillPoFreightOnOrder)) &&
            (identical(other.inDeliveryOnlineOrderNumber, inDeliveryOnlineOrderNumber) || const DeepCollectionEquality().equals(other.inDeliveryOnlineOrderNumber, inDeliveryOnlineOrderNumber)) &&
            (identical(other.inDeliveryOnlineOrderStatus, inDeliveryOnlineOrderStatus) || const DeepCollectionEquality().equals(other.inDeliveryOnlineOrderStatus, inDeliveryOnlineOrderStatus)) &&
            (identical(other.inDeliveryToVenue, inDeliveryToVenue) || const DeepCollectionEquality().equals(other.inDeliveryToVenue, inDeliveryToVenue)) &&
            (identical(other.inDeliveryToVenueId, inDeliveryToVenueId) || const DeepCollectionEquality().equals(other.inDeliveryToVenueId, inDeliveryToVenueId)) &&
            (identical(other.inDeliveryToWarehouse, inDeliveryToWarehouse) || const DeepCollectionEquality().equals(other.inDeliveryToWarehouse, inDeliveryToWarehouse)) &&
            (identical(other.inDeliveryToWarehouseId, inDeliveryToWarehouseId) || const DeepCollectionEquality().equals(other.inDeliveryToWarehouseId, inDeliveryToWarehouseId)) &&
            (identical(other.inDeliveryDateStamp, inDeliveryDateStamp) || const DeepCollectionEquality().equals(other.inDeliveryDateStamp, inDeliveryDateStamp)) &&
            (identical(other.rentalDaysPerWeek, rentalDaysPerWeek) || const DeepCollectionEquality().equals(other.rentalDaysPerWeek, rentalDaysPerWeek)) &&
            (identical(other.rentalDiscountPercent, rentalDiscountPercent) || const DeepCollectionEquality().equals(other.rentalDiscountPercent, rentalDiscountPercent)) &&
            (identical(other.weeklyRentalTotal, weeklyRentalTotal) || const DeepCollectionEquality().equals(other.weeklyRentalTotal, weeklyRentalTotal)) &&
            (identical(other.monthlyRentalTotal, monthlyRentalTotal) || const DeepCollectionEquality().equals(other.monthlyRentalTotal, monthlyRentalTotal)) &&
            (identical(other.periodRentalTotal, periodRentalTotal) || const DeepCollectionEquality().equals(other.periodRentalTotal, periodRentalTotal)) &&
            (identical(other.weeklyRentalTotalIncludesTax, weeklyRentalTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklyRentalTotalIncludesTax, weeklyRentalTotalIncludesTax)) &&
            (identical(other.monthlyRentalTotalIncludesTax, monthlyRentalTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlyRentalTotalIncludesTax, monthlyRentalTotalIncludesTax)) &&
            (identical(other.periodRentalTotalIncludesTax, periodRentalTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodRentalTotalIncludesTax, periodRentalTotalIncludesTax)) &&
            (identical(other.billLockedTotal, billLockedTotal) || const DeepCollectionEquality().equals(other.billLockedTotal, billLockedTotal)) &&
            (identical(other.salesDiscountPercent, salesDiscountPercent) || const DeepCollectionEquality().equals(other.salesDiscountPercent, salesDiscountPercent)) &&
            (identical(other.salesTotal, salesTotal) || const DeepCollectionEquality().equals(other.salesTotal, salesTotal)) &&
            (identical(other.salesTotalIncludesTax, salesTotalIncludesTax) || const DeepCollectionEquality().equals(other.salesTotalIncludesTax, salesTotalIncludesTax)) &&
            (identical(other.partsDiscountPercent, partsDiscountPercent) || const DeepCollectionEquality().equals(other.partsDiscountPercent, partsDiscountPercent)) &&
            (identical(other.partsTotal, partsTotal) || const DeepCollectionEquality().equals(other.partsTotal, partsTotal)) &&
            (identical(other.partsTotalIncludesTax, partsTotalIncludesTax) || const DeepCollectionEquality().equals(other.partsTotalIncludesTax, partsTotalIncludesTax)) &&
            (identical(other.spaceDaysPerWeek, spaceDaysPerWeek) || const DeepCollectionEquality().equals(other.spaceDaysPerWeek, spaceDaysPerWeek)) &&
            (identical(other.spaceDiscountPercent, spaceDiscountPercent) || const DeepCollectionEquality().equals(other.spaceDiscountPercent, spaceDiscountPercent)) &&
            (identical(other.spaceSplitPercent, spaceSplitPercent) || const DeepCollectionEquality().equals(other.spaceSplitPercent, spaceSplitPercent)) &&
            (identical(other.weeklySpaceTotal, weeklySpaceTotal) || const DeepCollectionEquality().equals(other.weeklySpaceTotal, weeklySpaceTotal)) &&
            (identical(other.monthlySpaceTotal, monthlySpaceTotal) || const DeepCollectionEquality().equals(other.monthlySpaceTotal, monthlySpaceTotal)) &&
            (identical(other.periodSpaceTotal, periodSpaceTotal) || const DeepCollectionEquality().equals(other.periodSpaceTotal, periodSpaceTotal)) &&
            (identical(other.weeklySpaceTotalIncludesTax, weeklySpaceTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklySpaceTotalIncludesTax, weeklySpaceTotalIncludesTax)) &&
            (identical(other.monthlySpaceTotalIncludesTax, monthlySpaceTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlySpaceTotalIncludesTax, monthlySpaceTotalIncludesTax)) &&
            (identical(other.periodSpaceTotalIncludesTax, periodSpaceTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodSpaceTotalIncludesTax, periodSpaceTotalIncludesTax)) &&
            (identical(other.vehicleDaysPerWeek, vehicleDaysPerWeek) || const DeepCollectionEquality().equals(other.vehicleDaysPerWeek, vehicleDaysPerWeek)) &&
            (identical(other.vehicleDiscountPercent, vehicleDiscountPercent) || const DeepCollectionEquality().equals(other.vehicleDiscountPercent, vehicleDiscountPercent)) &&
            (identical(other.weeklyVehicleTotal, weeklyVehicleTotal) || const DeepCollectionEquality().equals(other.weeklyVehicleTotal, weeklyVehicleTotal)) &&
            (identical(other.monthlyVehicleTotal, monthlyVehicleTotal) || const DeepCollectionEquality().equals(other.monthlyVehicleTotal, monthlyVehicleTotal)) &&
            (identical(other.periodVehicleTotal, periodVehicleTotal) || const DeepCollectionEquality().equals(other.periodVehicleTotal, periodVehicleTotal)) &&
            (identical(other.weeklyVehicleTotalIncludesTax, weeklyVehicleTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklyVehicleTotalIncludesTax, weeklyVehicleTotalIncludesTax)) &&
            (identical(other.monthlyVehicleTotalIncludesTax, monthlyVehicleTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlyVehicleTotalIncludesTax, monthlyVehicleTotalIncludesTax)) &&
            (identical(other.periodVehicleTotalIncludesTax, periodVehicleTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodVehicleTotalIncludesTax, periodVehicleTotalIncludesTax)) &&
            (identical(other.miscDiscountPercent, miscDiscountPercent) || const DeepCollectionEquality().equals(other.miscDiscountPercent, miscDiscountPercent)) &&
            (identical(other.weeklyMiscTotal, weeklyMiscTotal) || const DeepCollectionEquality().equals(other.weeklyMiscTotal, weeklyMiscTotal)) &&
            (identical(other.monthlyMiscTotal, monthlyMiscTotal) || const DeepCollectionEquality().equals(other.monthlyMiscTotal, monthlyMiscTotal)) &&
            (identical(other.periodMiscTotal, periodMiscTotal) || const DeepCollectionEquality().equals(other.periodMiscTotal, periodMiscTotal)) &&
            (identical(other.weeklyMiscTotalIncludesTax, weeklyMiscTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklyMiscTotalIncludesTax, weeklyMiscTotalIncludesTax)) &&
            (identical(other.monthlyMiscTotalIncludesTax, monthlyMiscTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlyMiscTotalIncludesTax, monthlyMiscTotalIncludesTax)) &&
            (identical(other.periodMiscTotalIncludesTax, periodMiscTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodMiscTotalIncludesTax, periodMiscTotalIncludesTax)) &&
            (identical(other.laborDiscountPercent, laborDiscountPercent) || const DeepCollectionEquality().equals(other.laborDiscountPercent, laborDiscountPercent)) &&
            (identical(other.weeklyLaborTotal, weeklyLaborTotal) || const DeepCollectionEquality().equals(other.weeklyLaborTotal, weeklyLaborTotal)) &&
            (identical(other.monthlyLaborTotal, monthlyLaborTotal) || const DeepCollectionEquality().equals(other.monthlyLaborTotal, monthlyLaborTotal)) &&
            (identical(other.periodLaborTotal, periodLaborTotal) || const DeepCollectionEquality().equals(other.periodLaborTotal, periodLaborTotal)) &&
            (identical(other.weeklyLaborTotalIncludesTax, weeklyLaborTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklyLaborTotalIncludesTax, weeklyLaborTotalIncludesTax)) &&
            (identical(other.monthlyLaborTotalIncludesTax, monthlyLaborTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlyLaborTotalIncludesTax, monthlyLaborTotalIncludesTax)) &&
            (identical(other.periodLaborTotalIncludesTax, periodLaborTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodLaborTotalIncludesTax, periodLaborTotalIncludesTax)) &&
            (identical(other.rentalSaleDiscountPercent, rentalSaleDiscountPercent) || const DeepCollectionEquality().equals(other.rentalSaleDiscountPercent, rentalSaleDiscountPercent)) &&
            (identical(other.rentalSaleTotal, rentalSaleTotal) || const DeepCollectionEquality().equals(other.rentalSaleTotal, rentalSaleTotal)) &&
            (identical(other.rentalSaleTotalIncludesTax, rentalSaleTotalIncludesTax) || const DeepCollectionEquality().equals(other.rentalSaleTotalIncludesTax, rentalSaleTotalIncludesTax)) &&
            (identical(other.lossAndDamageDiscountPercent, lossAndDamageDiscountPercent) || const DeepCollectionEquality().equals(other.lossAndDamageDiscountPercent, lossAndDamageDiscountPercent)) &&
            (identical(other.lossAndDamageTotal, lossAndDamageTotal) || const DeepCollectionEquality().equals(other.lossAndDamageTotal, lossAndDamageTotal)) &&
            (identical(other.lossAndDamageTotalIncludesTax, lossAndDamageTotalIncludesTax) || const DeepCollectionEquality().equals(other.lossAndDamageTotalIncludesTax, lossAndDamageTotalIncludesTax)) &&
            (identical(other.combinedDaysPerWeek, combinedDaysPerWeek) || const DeepCollectionEquality().equals(other.combinedDaysPerWeek, combinedDaysPerWeek)) &&
            (identical(other.combinedDiscountPercent, combinedDiscountPercent) || const DeepCollectionEquality().equals(other.combinedDiscountPercent, combinedDiscountPercent)) &&
            (identical(other.weeklyCombinedTotal, weeklyCombinedTotal) || const DeepCollectionEquality().equals(other.weeklyCombinedTotal, weeklyCombinedTotal)) &&
            (identical(other.monthlyCombinedTotal, monthlyCombinedTotal) || const DeepCollectionEquality().equals(other.monthlyCombinedTotal, monthlyCombinedTotal)) &&
            (identical(other.periodCombinedTotal, periodCombinedTotal) || const DeepCollectionEquality().equals(other.periodCombinedTotal, periodCombinedTotal)) &&
            (identical(other.weeklyCombinedTotalIncludesTax, weeklyCombinedTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklyCombinedTotalIncludesTax, weeklyCombinedTotalIncludesTax)) &&
            (identical(other.monthlyCombinedTotalIncludesTax, monthlyCombinedTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlyCombinedTotalIncludesTax, monthlyCombinedTotalIncludesTax)) &&
            (identical(other.periodCombinedTotalIncludesTax, periodCombinedTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodCombinedTotalIncludesTax, periodCombinedTotalIncludesTax)) &&
            (identical(other.disableEditingRentalRate, disableEditingRentalRate) || const DeepCollectionEquality().equals(other.disableEditingRentalRate, disableEditingRentalRate)) &&
            (identical(other.disableEditingSalesRate, disableEditingSalesRate) || const DeepCollectionEquality().equals(other.disableEditingSalesRate, disableEditingSalesRate)) &&
            (identical(other.disableEditingMiscellaneousRate, disableEditingMiscellaneousRate) || const DeepCollectionEquality().equals(other.disableEditingMiscellaneousRate, disableEditingMiscellaneousRate)) &&
            (identical(other.disableEditingLaborRate, disableEditingLaborRate) || const DeepCollectionEquality().equals(other.disableEditingLaborRate, disableEditingLaborRate)) &&
            (identical(other.disableEditingRentalSaleRate, disableEditingRentalSaleRate) || const DeepCollectionEquality().equals(other.disableEditingRentalSaleRate, disableEditingRentalSaleRate)) &&
            (identical(other.disableEditingLossAndDamageRate, disableEditingLossAndDamageRate) || const DeepCollectionEquality().equals(other.disableEditingLossAndDamageRate, disableEditingLossAndDamageRate)) &&
            (identical(other.rentalExtendedTotal, rentalExtendedTotal) || const DeepCollectionEquality().equals(other.rentalExtendedTotal, rentalExtendedTotal)) &&
            (identical(other.salesExtendedTotal, salesExtendedTotal) || const DeepCollectionEquality().equals(other.salesExtendedTotal, salesExtendedTotal)) &&
            (identical(other.laborExtendedTotal, laborExtendedTotal) || const DeepCollectionEquality().equals(other.laborExtendedTotal, laborExtendedTotal)) &&
            (identical(other.miscellaneousExtendedTotal, miscellaneousExtendedTotal) || const DeepCollectionEquality().equals(other.miscellaneousExtendedTotal, miscellaneousExtendedTotal)) &&
            (identical(other.rentalSaleExtendedTotal, rentalSaleExtendedTotal) || const DeepCollectionEquality().equals(other.rentalSaleExtendedTotal, rentalSaleExtendedTotal)) &&
            (identical(other.lossAndDamageExtendedTotal, lossAndDamageExtendedTotal) || const DeepCollectionEquality().equals(other.lossAndDamageExtendedTotal, lossAndDamageExtendedTotal)) &&
            (identical(other.hasNotes, hasNotes) || const DeepCollectionEquality().equals(other.hasNotes, hasNotes)) &&
            (identical(other.hasDocuments, hasDocuments) || const DeepCollectionEquality().equals(other.hasDocuments, hasDocuments)) &&
            (identical(other.hasEmailHistory, hasEmailHistory) || const DeepCollectionEquality().equals(other.hasEmailHistory, hasEmailHistory)) &&
            (identical(other.hasContacts, hasContacts) || const DeepCollectionEquality().equals(other.hasContacts, hasContacts)) &&
            (identical(other.hasSubPurchaseOrders, hasSubPurchaseOrders) || const DeepCollectionEquality().equals(other.hasSubPurchaseOrders, hasSubPurchaseOrders)) &&
            (identical(other.hasPickLists, hasPickLists) || const DeepCollectionEquality().equals(other.hasPickLists, hasPickLists)) &&
            (identical(other.hasContracts, hasContracts) || const DeepCollectionEquality().equals(other.hasContracts, hasContracts)) &&
            (identical(other.hasSuspendedContracts, hasSuspendedContracts) || const DeepCollectionEquality().equals(other.hasSuspendedContracts, hasSuspendedContracts)) &&
            (identical(other.hasMultiOrderContracts, hasMultiOrderContracts) || const DeepCollectionEquality().equals(other.hasMultiOrderContracts, hasMultiOrderContracts)) &&
            (identical(other.hasInvoices, hasInvoices) || const DeepCollectionEquality().equals(other.hasInvoices, hasInvoices)) &&
            (identical(other.hasBillingWorksheets, hasBillingWorksheets) || const DeepCollectionEquality().equals(other.hasBillingWorksheets, hasBillingWorksheets)) &&
            (identical(other.hasMultiOrderInvoices, hasMultiOrderInvoices) || const DeepCollectionEquality().equals(other.hasMultiOrderInvoices, hasMultiOrderInvoices)) &&
            (identical(other.totalReplacementCost, totalReplacementCost) || const DeepCollectionEquality().equals(other.totalReplacementCost, totalReplacementCost)) &&
            (identical(other.presentationLayerId, presentationLayerId) || const DeepCollectionEquality().equals(other.presentationLayerId, presentationLayerId)) &&
            (identical(other.presentationLayer, presentationLayer) || const DeepCollectionEquality().equals(other.presentationLayer, presentationLayer)) &&
            (identical(other.isManualSort, isManualSort) || const DeepCollectionEquality().equals(other.isManualSort, isManualSort)) &&
            (identical(other.quoteOrderTitle, quoteOrderTitle) || const DeepCollectionEquality().equals(other.quoteOrderTitle, quoteOrderTitle)) &&
            (identical(other.unassignedSubs, unassignedSubs) || const DeepCollectionEquality().equals(other.unassignedSubs, unassignedSubs)) &&
            (identical(other.nonTaxable, nonTaxable) || const DeepCollectionEquality().equals(other.nonTaxable, nonTaxable)) &&
            (identical(other.enableProjects, enableProjects) || const DeepCollectionEquality().equals(other.enableProjects, enableProjects)) &&
            (identical(other.projectId, projectId) || const DeepCollectionEquality().equals(other.projectId, projectId)) &&
            (identical(other.projectNumber, projectNumber) || const DeepCollectionEquality().equals(other.projectNumber, projectNumber)) &&
            (identical(other.project, project) || const DeepCollectionEquality().equals(other.project, project)) &&
            (identical(other.projectDrawingsId, projectDrawingsId) || const DeepCollectionEquality().equals(other.projectDrawingsId, projectDrawingsId)) &&
            (identical(other.projectDrawings, projectDrawings) || const DeepCollectionEquality().equals(other.projectDrawings, projectDrawings)) &&
            (identical(other.projectItemsOrderedId, projectItemsOrderedId) || const DeepCollectionEquality().equals(other.projectItemsOrderedId, projectItemsOrderedId)) &&
            (identical(other.projectItemsOrdered, projectItemsOrdered) || const DeepCollectionEquality().equals(other.projectItemsOrdered, projectItemsOrdered)) &&
            (identical(other.projectDropShipId, projectDropShipId) || const DeepCollectionEquality().equals(other.projectDropShipId, projectDropShipId)) &&
            (identical(other.projectDropShip, projectDropShip) || const DeepCollectionEquality().equals(other.projectDropShip, projectDropShip)) &&
            (identical(other.projectAsBuildId, projectAsBuildId) || const DeepCollectionEquality().equals(other.projectAsBuildId, projectAsBuildId)) &&
            (identical(other.projectAsBuild, projectAsBuild) || const DeepCollectionEquality().equals(other.projectAsBuild, projectAsBuild)) &&
            (identical(other.projectCommissioningId, projectCommissioningId) || const DeepCollectionEquality().equals(other.projectCommissioningId, projectCommissioningId)) &&
            (identical(other.projectCommissioning, projectCommissioning) || const DeepCollectionEquality().equals(other.projectCommissioning, projectCommissioning)) &&
            (identical(other.projectDepositId, projectDepositId) || const DeepCollectionEquality().equals(other.projectDepositId, projectDepositId)) &&
            (identical(other.projectDeposit, projectDeposit) || const DeepCollectionEquality().equals(other.projectDeposit, projectDeposit)) &&
            (identical(other.inputByUserId, inputByUserId) || const DeepCollectionEquality().equals(other.inputByUserId, inputByUserId)) &&
            (identical(other.modifiedByUserId, modifiedByUserId) || const DeepCollectionEquality().equals(other.modifiedByUserId, modifiedByUserId)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesAgentOrderOrderBaseExtension
    on WebApiModulesAgentOrderOrderBase {
  WebApiModulesAgentOrderOrderBase copyWith(
      {String? description,
      String? officeLocationId,
      String? officeLocation,
      String? warehouseId,
      String? warehouse,
      String? warehouseCode,
      String? departmentId,
      String? department,
      String? customerId,
      String? customer,
      String? customerNumber,
      String? dealId,
      String? deal,
      String? dealNumber,
      String? rateType,
      String? rateTypeDisplay,
      String? agentId,
      String? agent,
      String? projectManagerId,
      String? projectManager,
      bool? rental,
      bool? sales,
      bool? miscellaneous,
      bool? labor,
      bool? facilities,
      bool? transportation,
      bool? rentalSale,
      bool? lossAndDamage,
      bool? repair,
      bool? hasRentalItem,
      bool? hasSalesItem,
      bool? hasMiscellaneousItem,
      bool? hasLaborItem,
      bool? hasFacilitiesItem,
      bool? hasLossAndDamageItem,
      bool? hasRentalSaleItem,
      bool? hasRepair,
      List<WebApiModulesHomeControlsOrderDatesOrderDates>?
          activityDatesAndTimes,
      String? pickDate,
      String? pickTime,
      String? estimatedStartDate,
      String? estimatedStartTime,
      String? estimatedStopDate,
      String? estimatedStopTime,
      String? pickUpDate,
      String? pickUpTime,
      String? prepDate,
      String? prepTime,
      String? loadInDate,
      String? loadInTime,
      String? strikeDate,
      String? strikeTime,
      String? testDate,
      String? testTime,
      String? orderTypeId,
      String? orderType,
      bool? orderTypeCombineActivityTabs,
      bool? flatPo,
      bool? pendingPo,
      String? poNumber,
      double? poAmount,
      String? location,
      String? orderLocationId,
      String? orderLocation,
      String? referenceNumber,
      double? total,
      String? status,
      String? statusDate,
      String? poApprovalStatusId,
      bool? lockBillingDates,
      bool? specifyBillingDatesByType,
      String? rentalBillingStartDate,
      String? rentalBillingEndDate,
      String? laborBillingStartDate,
      String? laborBillingEndDate,
      String? miscellaneousBillingStartDate,
      String? miscellaneousBillingEndDate,
      String? facilitiesBillingStartDate,
      String? facilitiesBillingEndDate,
      String? vehicleBillingStartDate,
      String? vehicleBillingEndDate,
      String? delayBillingSearchUntil,
      bool? includePrepFeesInRentalRate,
      String? billingStartDate,
      String? billingEndDate,
      double? billingWeeks,
      double? billingMonths,
      String? determineQuantitiesToBillBasedOn,
      String? billingCycleId,
      String? billingCycle,
      String? billingCycleType,
      String? paymentTermsId,
      String? paymentTerms,
      String? paymentTypeId,
      String? paymentType,
      String? currencyId,
      bool? updateAllRatesToNewCurrency,
      String? confirmUpdateAllRatesToNewCurrency,
      String? currencyCode,
      String? currency,
      String? currencySymbol,
      String? taxOptionId,
      String? taxOption,
      String? tax1Name,
      String? tax2Name,
      String? taxId,
      double? rentalTaxRate1,
      double? salesTaxRate1,
      double? laborTaxRate1,
      double? rentalTaxRate2,
      double? salesTaxRate2,
      double? laborTaxRate2,
      bool? noCharge,
      String? noChargeReason,
      String? printIssuedToAddressFrom,
      String? issuedToName,
      String? issuedToAttention,
      String? issuedToAttention2,
      String? issuedToAddress1,
      String? issuedToAddress2,
      String? issuedToCity,
      String? issuedToState,
      String? issuedToZipCode,
      String? issuedToCountryId,
      String? issuedToCountry,
      bool? billToAddressDifferentFromIssuedToAddress,
      String? billToAddressId,
      String? billToName,
      String? billToAttention,
      String? billToAttention2,
      String? billToAddress1,
      String? billToAddress2,
      String? billToCity,
      String? billToState,
      String? billToZipCode,
      String? billToCountryId,
      String? billToCountry,
      String? discountReasonId,
      String? discountReason,
      bool? requireContactConfirmation,
      bool? includeInBillingAnalysis,
      String? hiatusDiscountFrom,
      bool? roundTripRentals,
      bool? inGroup,
      int? groupNumber,
      int? groupColor,
      double? groupOrderBy,
      String? coverLetterId,
      String? coverLetter,
      String? termsConditionsId,
      String? termsConditions,
      String? outsideSalesRepresentativeId,
      String? outsideSalesRepresentative,
      String? marketTypeId,
      String? marketType,
      String? marketSegmentId,
      String? marketSegment,
      String? marketSegmentJobId,
      String? marketSegmentJob,
      String? outDeliveryId,
      String? outDeliveryDeliveryType,
      String? outDeliveryRequiredDate,
      String? outDeliveryRequiredTime,
      String? outDeliveryTargetShipDate,
      String? outDeliveryTargetShipTime,
      String? outDeliveryDirection,
      String? outDeliveryAddressType,
      String? outDeliveryFromLocation,
      String? outDeliveryFromContact,
      String? outDeliveryFromContactPhone,
      String? outDeliveryFromAlternateContact,
      String? outDeliveryFromAlternateContactPhone,
      String? outDeliveryFromAttention,
      String? outDeliveryFromAddress1,
      String? outDeliveryFromAdd2ress,
      String? outDeliveryFromCity,
      String? outDeliveryFromState,
      String? outDeliveryFromZipCode,
      String? outDeliveryFromCountry,
      String? outDeliveryFromCountryId,
      String? outDeliveryFromCrossStreets,
      String? outDeliveryToLocation,
      String? outDeliveryToContact,
      String? outDeliveryToContactPhone,
      String? outDeliveryToAlternateContact,
      String? outDeliveryToAlternateContactPhone,
      String? outDeliveryToAttention,
      String? outDeliveryToAddress1,
      String? outDeliveryToAddress2,
      String? outDeliveryToCity,
      String? outDeliveryToState,
      String? outDeliveryToZipCode,
      String? outDeliveryToCountryId,
      String? outDeliveryToCountry,
      String? outDeliveryToContactFax,
      String? outDeliveryToCrossStreets,
      String? outDeliveryDeliveryNotes,
      String? outDeliveryCarrierId,
      String? outDeliveryCarrier,
      String? outDeliveryCarrierAccount,
      String? outDeliveryShipViaId,
      String? outDeliveryShipVia,
      String? outDeliveryInvoiceId,
      String? outDeliveryVendorInvoiceId,
      double? outDeliveryEstimatedFreight,
      double? outDeliveryFreightInvoiceAmount,
      String? outDeliveryChargeType,
      String? outDeliveryFreightTrackingNumber,
      String? outDeliveryFreightTrackingUrl,
      String? outDeliveryPackageCode,
      bool? outDeliveryBillPoFreightOnOrder,
      String? outDeliveryOnlineOrderNumber,
      String? outDeliveryToVenue,
      String? outDeliveryToVenueId,
      String? outDeliveryToWarehouse,
      String? outDeliveryToWarehouseId,
      String? outDeliveryDateStamp,
      String? inDeliveryId,
      String? inDeliveryDeliveryType,
      String? inDeliveryRequiredDate,
      String? inDeliveryRequiredTime,
      String? inDeliveryTargetShipDate,
      String? inDeliveryTargetShipTime,
      String? inDeliveryDirection,
      String? inDeliveryAddressType,
      String? inDeliveryFromLocation,
      String? inDeliveryFromContact,
      String? inDeliveryFromContactPhone,
      String? inDeliveryFromAlternateContact,
      String? inDeliveryFromAlternateContactPhone,
      String? inDeliveryFromAttention,
      String? inDeliveryFromAddress1,
      String? inDeliveryFromAdd2ress,
      String? inDeliveryFromCity,
      String? inDeliveryFromState,
      String? inDeliveryFromZipCode,
      String? inDeliveryFromCountry,
      String? inDeliveryFromCountryId,
      String? inDeliveryFromCrossStreets,
      String? inDeliveryToLocation,
      String? inDeliveryToContact,
      String? inDeliveryToContactPhone,
      String? inDeliveryToAlternateContact,
      String? inDeliveryToAlternateContactPhone,
      String? inDeliveryToAttention,
      String? inDeliveryToAddress1,
      String? inDeliveryToAddress2,
      String? inDeliveryToCity,
      String? inDeliveryToState,
      String? inDeliveryToZipCode,
      String? inDeliveryToCountryId,
      String? inDeliveryToCountry,
      String? inDeliveryToContactFax,
      String? inDeliveryToCrossStreets,
      String? inDeliveryDeliveryNotes,
      String? inDeliveryCarrierId,
      String? inDeliveryCarrier,
      String? inDeliveryCarrierAccount,
      String? inDeliveryShipViaId,
      String? inDeliveryShipVia,
      String? inDeliveryInvoiceId,
      String? inDeliveryVendorInvoiceId,
      double? inDeliveryEstimatedFreight,
      double? inDeliveryFreightInvoiceAmount,
      String? inDeliveryChargeType,
      String? inDeliveryFreightTrackingNumber,
      String? inDeliveryFreightTrackingUrl,
      String? inDeliveryPackageCode,
      bool? inDeliveryBillPoFreightOnOrder,
      String? inDeliveryOnlineOrderNumber,
      String? inDeliveryOnlineOrderStatus,
      String? inDeliveryToVenue,
      String? inDeliveryToVenueId,
      String? inDeliveryToWarehouse,
      String? inDeliveryToWarehouseId,
      String? inDeliveryDateStamp,
      double? rentalDaysPerWeek,
      double? rentalDiscountPercent,
      double? weeklyRentalTotal,
      double? monthlyRentalTotal,
      double? periodRentalTotal,
      bool? weeklyRentalTotalIncludesTax,
      bool? monthlyRentalTotalIncludesTax,
      bool? periodRentalTotalIncludesTax,
      bool? billLockedTotal,
      double? salesDiscountPercent,
      double? salesTotal,
      bool? salesTotalIncludesTax,
      double? partsDiscountPercent,
      double? partsTotal,
      bool? partsTotalIncludesTax,
      double? spaceDaysPerWeek,
      double? spaceDiscountPercent,
      double? spaceSplitPercent,
      double? weeklySpaceTotal,
      double? monthlySpaceTotal,
      double? periodSpaceTotal,
      bool? weeklySpaceTotalIncludesTax,
      bool? monthlySpaceTotalIncludesTax,
      bool? periodSpaceTotalIncludesTax,
      double? vehicleDaysPerWeek,
      double? vehicleDiscountPercent,
      double? weeklyVehicleTotal,
      double? monthlyVehicleTotal,
      double? periodVehicleTotal,
      bool? weeklyVehicleTotalIncludesTax,
      bool? monthlyVehicleTotalIncludesTax,
      bool? periodVehicleTotalIncludesTax,
      double? miscDiscountPercent,
      double? weeklyMiscTotal,
      double? monthlyMiscTotal,
      double? periodMiscTotal,
      bool? weeklyMiscTotalIncludesTax,
      bool? monthlyMiscTotalIncludesTax,
      bool? periodMiscTotalIncludesTax,
      double? laborDiscountPercent,
      double? weeklyLaborTotal,
      double? monthlyLaborTotal,
      double? periodLaborTotal,
      bool? weeklyLaborTotalIncludesTax,
      bool? monthlyLaborTotalIncludesTax,
      bool? periodLaborTotalIncludesTax,
      double? rentalSaleDiscountPercent,
      double? rentalSaleTotal,
      bool? rentalSaleTotalIncludesTax,
      double? lossAndDamageDiscountPercent,
      double? lossAndDamageTotal,
      bool? lossAndDamageTotalIncludesTax,
      double? combinedDaysPerWeek,
      double? combinedDiscountPercent,
      double? weeklyCombinedTotal,
      double? monthlyCombinedTotal,
      double? periodCombinedTotal,
      bool? weeklyCombinedTotalIncludesTax,
      bool? monthlyCombinedTotalIncludesTax,
      bool? periodCombinedTotalIncludesTax,
      bool? disableEditingRentalRate,
      bool? disableEditingSalesRate,
      bool? disableEditingMiscellaneousRate,
      bool? disableEditingLaborRate,
      bool? disableEditingRentalSaleRate,
      bool? disableEditingLossAndDamageRate,
      double? rentalExtendedTotal,
      double? salesExtendedTotal,
      double? laborExtendedTotal,
      double? miscellaneousExtendedTotal,
      double? rentalSaleExtendedTotal,
      double? lossAndDamageExtendedTotal,
      bool? hasNotes,
      bool? hasDocuments,
      bool? hasEmailHistory,
      bool? hasContacts,
      bool? hasSubPurchaseOrders,
      bool? hasPickLists,
      bool? hasContracts,
      bool? hasSuspendedContracts,
      bool? hasMultiOrderContracts,
      bool? hasInvoices,
      bool? hasBillingWorksheets,
      bool? hasMultiOrderInvoices,
      double? totalReplacementCost,
      String? presentationLayerId,
      String? presentationLayer,
      bool? isManualSort,
      String? quoteOrderTitle,
      bool? unassignedSubs,
      bool? nonTaxable,
      bool? enableProjects,
      String? projectId,
      String? projectNumber,
      String? project,
      String? projectDrawingsId,
      String? projectDrawings,
      String? projectItemsOrderedId,
      String? projectItemsOrdered,
      String? projectDropShipId,
      String? projectDropShip,
      String? projectAsBuildId,
      String? projectAsBuild,
      String? projectCommissioningId,
      String? projectCommissioning,
      String? projectDepositId,
      String? projectDeposit,
      String? inputByUserId,
      String? modifiedByUserId,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAgentOrderOrderBase(
        description: description ?? this.description,
        officeLocationId: officeLocationId ?? this.officeLocationId,
        officeLocation: officeLocation ?? this.officeLocation,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouse: warehouse ?? this.warehouse,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        departmentId: departmentId ?? this.departmentId,
        department: department ?? this.department,
        customerId: customerId ?? this.customerId,
        customer: customer ?? this.customer,
        customerNumber: customerNumber ?? this.customerNumber,
        dealId: dealId ?? this.dealId,
        deal: deal ?? this.deal,
        dealNumber: dealNumber ?? this.dealNumber,
        rateType: rateType ?? this.rateType,
        rateTypeDisplay: rateTypeDisplay ?? this.rateTypeDisplay,
        agentId: agentId ?? this.agentId,
        agent: agent ?? this.agent,
        projectManagerId: projectManagerId ?? this.projectManagerId,
        projectManager: projectManager ?? this.projectManager,
        rental: rental ?? this.rental,
        sales: sales ?? this.sales,
        miscellaneous: miscellaneous ?? this.miscellaneous,
        labor: labor ?? this.labor,
        facilities: facilities ?? this.facilities,
        transportation: transportation ?? this.transportation,
        rentalSale: rentalSale ?? this.rentalSale,
        lossAndDamage: lossAndDamage ?? this.lossAndDamage,
        repair: repair ?? this.repair,
        hasRentalItem: hasRentalItem ?? this.hasRentalItem,
        hasSalesItem: hasSalesItem ?? this.hasSalesItem,
        hasMiscellaneousItem: hasMiscellaneousItem ?? this.hasMiscellaneousItem,
        hasLaborItem: hasLaborItem ?? this.hasLaborItem,
        hasFacilitiesItem: hasFacilitiesItem ?? this.hasFacilitiesItem,
        hasLossAndDamageItem: hasLossAndDamageItem ?? this.hasLossAndDamageItem,
        hasRentalSaleItem: hasRentalSaleItem ?? this.hasRentalSaleItem,
        hasRepair: hasRepair ?? this.hasRepair,
        activityDatesAndTimes:
            activityDatesAndTimes ?? this.activityDatesAndTimes,
        pickDate: pickDate ?? this.pickDate,
        pickTime: pickTime ?? this.pickTime,
        estimatedStartDate: estimatedStartDate ?? this.estimatedStartDate,
        estimatedStartTime: estimatedStartTime ?? this.estimatedStartTime,
        estimatedStopDate: estimatedStopDate ?? this.estimatedStopDate,
        estimatedStopTime: estimatedStopTime ?? this.estimatedStopTime,
        pickUpDate: pickUpDate ?? this.pickUpDate,
        pickUpTime: pickUpTime ?? this.pickUpTime,
        prepDate: prepDate ?? this.prepDate,
        prepTime: prepTime ?? this.prepTime,
        loadInDate: loadInDate ?? this.loadInDate,
        loadInTime: loadInTime ?? this.loadInTime,
        strikeDate: strikeDate ?? this.strikeDate,
        strikeTime: strikeTime ?? this.strikeTime,
        testDate: testDate ?? this.testDate,
        testTime: testTime ?? this.testTime,
        orderTypeId: orderTypeId ?? this.orderTypeId,
        orderType: orderType ?? this.orderType,
        orderTypeCombineActivityTabs:
            orderTypeCombineActivityTabs ?? this.orderTypeCombineActivityTabs,
        flatPo: flatPo ?? this.flatPo,
        pendingPo: pendingPo ?? this.pendingPo,
        poNumber: poNumber ?? this.poNumber,
        poAmount: poAmount ?? this.poAmount,
        location: location ?? this.location,
        orderLocationId: orderLocationId ?? this.orderLocationId,
        orderLocation: orderLocation ?? this.orderLocation,
        referenceNumber: referenceNumber ?? this.referenceNumber,
        total: total ?? this.total,
        status: status ?? this.status,
        statusDate: statusDate ?? this.statusDate,
        poApprovalStatusId: poApprovalStatusId ?? this.poApprovalStatusId,
        lockBillingDates: lockBillingDates ?? this.lockBillingDates,
        specifyBillingDatesByType:
            specifyBillingDatesByType ?? this.specifyBillingDatesByType,
        rentalBillingStartDate:
            rentalBillingStartDate ?? this.rentalBillingStartDate,
        rentalBillingEndDate: rentalBillingEndDate ?? this.rentalBillingEndDate,
        laborBillingStartDate:
            laborBillingStartDate ?? this.laborBillingStartDate,
        laborBillingEndDate: laborBillingEndDate ?? this.laborBillingEndDate,
        miscellaneousBillingStartDate:
            miscellaneousBillingStartDate ?? this.miscellaneousBillingStartDate,
        miscellaneousBillingEndDate:
            miscellaneousBillingEndDate ?? this.miscellaneousBillingEndDate,
        facilitiesBillingStartDate:
            facilitiesBillingStartDate ?? this.facilitiesBillingStartDate,
        facilitiesBillingEndDate:
            facilitiesBillingEndDate ?? this.facilitiesBillingEndDate,
        vehicleBillingStartDate:
            vehicleBillingStartDate ?? this.vehicleBillingStartDate,
        vehicleBillingEndDate:
            vehicleBillingEndDate ?? this.vehicleBillingEndDate,
        delayBillingSearchUntil:
            delayBillingSearchUntil ?? this.delayBillingSearchUntil,
        includePrepFeesInRentalRate:
            includePrepFeesInRentalRate ?? this.includePrepFeesInRentalRate,
        billingStartDate: billingStartDate ?? this.billingStartDate,
        billingEndDate: billingEndDate ?? this.billingEndDate,
        billingWeeks: billingWeeks ?? this.billingWeeks,
        billingMonths: billingMonths ?? this.billingMonths,
        determineQuantitiesToBillBasedOn: determineQuantitiesToBillBasedOn ??
            this.determineQuantitiesToBillBasedOn,
        billingCycleId: billingCycleId ?? this.billingCycleId,
        billingCycle: billingCycle ?? this.billingCycle,
        billingCycleType: billingCycleType ?? this.billingCycleType,
        paymentTermsId: paymentTermsId ?? this.paymentTermsId,
        paymentTerms: paymentTerms ?? this.paymentTerms,
        paymentTypeId: paymentTypeId ?? this.paymentTypeId,
        paymentType: paymentType ?? this.paymentType,
        currencyId: currencyId ?? this.currencyId,
        updateAllRatesToNewCurrency:
            updateAllRatesToNewCurrency ?? this.updateAllRatesToNewCurrency,
        confirmUpdateAllRatesToNewCurrency: confirmUpdateAllRatesToNewCurrency ??
            this.confirmUpdateAllRatesToNewCurrency,
        currencyCode: currencyCode ?? this.currencyCode,
        currency: currency ?? this.currency,
        currencySymbol: currencySymbol ?? this.currencySymbol,
        taxOptionId: taxOptionId ?? this.taxOptionId,
        taxOption: taxOption ?? this.taxOption,
        tax1Name: tax1Name ?? this.tax1Name,
        tax2Name: tax2Name ?? this.tax2Name,
        taxId: taxId ?? this.taxId,
        rentalTaxRate1: rentalTaxRate1 ?? this.rentalTaxRate1,
        salesTaxRate1: salesTaxRate1 ?? this.salesTaxRate1,
        laborTaxRate1: laborTaxRate1 ?? this.laborTaxRate1,
        rentalTaxRate2: rentalTaxRate2 ?? this.rentalTaxRate2,
        salesTaxRate2: salesTaxRate2 ?? this.salesTaxRate2,
        laborTaxRate2: laborTaxRate2 ?? this.laborTaxRate2,
        noCharge: noCharge ?? this.noCharge,
        noChargeReason: noChargeReason ?? this.noChargeReason,
        printIssuedToAddressFrom:
            printIssuedToAddressFrom ?? this.printIssuedToAddressFrom,
        issuedToName: issuedToName ?? this.issuedToName,
        issuedToAttention: issuedToAttention ?? this.issuedToAttention,
        issuedToAttention2: issuedToAttention2 ?? this.issuedToAttention2,
        issuedToAddress1: issuedToAddress1 ?? this.issuedToAddress1,
        issuedToAddress2: issuedToAddress2 ?? this.issuedToAddress2,
        issuedToCity: issuedToCity ?? this.issuedToCity,
        issuedToState: issuedToState ?? this.issuedToState,
        issuedToZipCode: issuedToZipCode ?? this.issuedToZipCode,
        issuedToCountryId: issuedToCountryId ?? this.issuedToCountryId,
        issuedToCountry: issuedToCountry ?? this.issuedToCountry,
        billToAddressDifferentFromIssuedToAddress:
            billToAddressDifferentFromIssuedToAddress ??
                this.billToAddressDifferentFromIssuedToAddress,
        billToAddressId: billToAddressId ?? this.billToAddressId,
        billToName: billToName ?? this.billToName,
        billToAttention: billToAttention ?? this.billToAttention,
        billToAttention2: billToAttention2 ?? this.billToAttention2,
        billToAddress1: billToAddress1 ?? this.billToAddress1,
        billToAddress2: billToAddress2 ?? this.billToAddress2,
        billToCity: billToCity ?? this.billToCity,
        billToState: billToState ?? this.billToState,
        billToZipCode: billToZipCode ?? this.billToZipCode,
        billToCountryId: billToCountryId ?? this.billToCountryId,
        billToCountry: billToCountry ?? this.billToCountry,
        discountReasonId: discountReasonId ?? this.discountReasonId,
        discountReason: discountReason ?? this.discountReason,
        requireContactConfirmation:
            requireContactConfirmation ?? this.requireContactConfirmation,
        includeInBillingAnalysis:
            includeInBillingAnalysis ?? this.includeInBillingAnalysis,
        hiatusDiscountFrom: hiatusDiscountFrom ?? this.hiatusDiscountFrom,
        roundTripRentals: roundTripRentals ?? this.roundTripRentals,
        inGroup: inGroup ?? this.inGroup,
        groupNumber: groupNumber ?? this.groupNumber,
        groupColor: groupColor ?? this.groupColor,
        groupOrderBy: groupOrderBy ?? this.groupOrderBy,
        coverLetterId: coverLetterId ?? this.coverLetterId,
        coverLetter: coverLetter ?? this.coverLetter,
        termsConditionsId: termsConditionsId ?? this.termsConditionsId,
        termsConditions: termsConditions ?? this.termsConditions,
        outsideSalesRepresentativeId:
            outsideSalesRepresentativeId ?? this.outsideSalesRepresentativeId,
        outsideSalesRepresentative:
            outsideSalesRepresentative ?? this.outsideSalesRepresentative,
        marketTypeId: marketTypeId ?? this.marketTypeId,
        marketType: marketType ?? this.marketType,
        marketSegmentId: marketSegmentId ?? this.marketSegmentId,
        marketSegment: marketSegment ?? this.marketSegment,
        marketSegmentJobId: marketSegmentJobId ?? this.marketSegmentJobId,
        marketSegmentJob: marketSegmentJob ?? this.marketSegmentJob,
        outDeliveryId: outDeliveryId ?? this.outDeliveryId,
        outDeliveryDeliveryType:
            outDeliveryDeliveryType ?? this.outDeliveryDeliveryType,
        outDeliveryRequiredDate:
            outDeliveryRequiredDate ?? this.outDeliveryRequiredDate,
        outDeliveryRequiredTime:
            outDeliveryRequiredTime ?? this.outDeliveryRequiredTime,
        outDeliveryTargetShipDate:
            outDeliveryTargetShipDate ?? this.outDeliveryTargetShipDate,
        outDeliveryTargetShipTime:
            outDeliveryTargetShipTime ?? this.outDeliveryTargetShipTime,
        outDeliveryDirection: outDeliveryDirection ?? this.outDeliveryDirection,
        outDeliveryAddressType:
            outDeliveryAddressType ?? this.outDeliveryAddressType,
        outDeliveryFromLocation:
            outDeliveryFromLocation ?? this.outDeliveryFromLocation,
        outDeliveryFromContact:
            outDeliveryFromContact ?? this.outDeliveryFromContact,
        outDeliveryFromContactPhone:
            outDeliveryFromContactPhone ?? this.outDeliveryFromContactPhone,
        outDeliveryFromAlternateContact: outDeliveryFromAlternateContact ??
            this.outDeliveryFromAlternateContact,
        outDeliveryFromAlternateContactPhone: outDeliveryFromAlternateContactPhone ??
            this.outDeliveryFromAlternateContactPhone,
        outDeliveryFromAttention:
            outDeliveryFromAttention ?? this.outDeliveryFromAttention,
        outDeliveryFromAddress1:
            outDeliveryFromAddress1 ?? this.outDeliveryFromAddress1,
        outDeliveryFromAdd2ress:
            outDeliveryFromAdd2ress ?? this.outDeliveryFromAdd2ress,
        outDeliveryFromCity: outDeliveryFromCity ?? this.outDeliveryFromCity,
        outDeliveryFromState: outDeliveryFromState ?? this.outDeliveryFromState,
        outDeliveryFromZipCode:
            outDeliveryFromZipCode ?? this.outDeliveryFromZipCode,
        outDeliveryFromCountry:
            outDeliveryFromCountry ?? this.outDeliveryFromCountry,
        outDeliveryFromCountryId:
            outDeliveryFromCountryId ?? this.outDeliveryFromCountryId,
        outDeliveryFromCrossStreets:
            outDeliveryFromCrossStreets ?? this.outDeliveryFromCrossStreets,
        outDeliveryToLocation:
            outDeliveryToLocation ?? this.outDeliveryToLocation,
        outDeliveryToContact: outDeliveryToContact ?? this.outDeliveryToContact,
        outDeliveryToContactPhone:
            outDeliveryToContactPhone ?? this.outDeliveryToContactPhone,
        outDeliveryToAlternateContact:
            outDeliveryToAlternateContact ?? this.outDeliveryToAlternateContact,
        outDeliveryToAlternateContactPhone:
            outDeliveryToAlternateContactPhone ?? this.outDeliveryToAlternateContactPhone,
        outDeliveryToAttention: outDeliveryToAttention ?? this.outDeliveryToAttention,
        outDeliveryToAddress1: outDeliveryToAddress1 ?? this.outDeliveryToAddress1,
        outDeliveryToAddress2: outDeliveryToAddress2 ?? this.outDeliveryToAddress2,
        outDeliveryToCity: outDeliveryToCity ?? this.outDeliveryToCity,
        outDeliveryToState: outDeliveryToState ?? this.outDeliveryToState,
        outDeliveryToZipCode: outDeliveryToZipCode ?? this.outDeliveryToZipCode,
        outDeliveryToCountryId: outDeliveryToCountryId ?? this.outDeliveryToCountryId,
        outDeliveryToCountry: outDeliveryToCountry ?? this.outDeliveryToCountry,
        outDeliveryToContactFax: outDeliveryToContactFax ?? this.outDeliveryToContactFax,
        outDeliveryToCrossStreets: outDeliveryToCrossStreets ?? this.outDeliveryToCrossStreets,
        outDeliveryDeliveryNotes: outDeliveryDeliveryNotes ?? this.outDeliveryDeliveryNotes,
        outDeliveryCarrierId: outDeliveryCarrierId ?? this.outDeliveryCarrierId,
        outDeliveryCarrier: outDeliveryCarrier ?? this.outDeliveryCarrier,
        outDeliveryCarrierAccount: outDeliveryCarrierAccount ?? this.outDeliveryCarrierAccount,
        outDeliveryShipViaId: outDeliveryShipViaId ?? this.outDeliveryShipViaId,
        outDeliveryShipVia: outDeliveryShipVia ?? this.outDeliveryShipVia,
        outDeliveryInvoiceId: outDeliveryInvoiceId ?? this.outDeliveryInvoiceId,
        outDeliveryVendorInvoiceId: outDeliveryVendorInvoiceId ?? this.outDeliveryVendorInvoiceId,
        outDeliveryEstimatedFreight: outDeliveryEstimatedFreight ?? this.outDeliveryEstimatedFreight,
        outDeliveryFreightInvoiceAmount: outDeliveryFreightInvoiceAmount ?? this.outDeliveryFreightInvoiceAmount,
        outDeliveryChargeType: outDeliveryChargeType ?? this.outDeliveryChargeType,
        outDeliveryFreightTrackingNumber: outDeliveryFreightTrackingNumber ?? this.outDeliveryFreightTrackingNumber,
        outDeliveryFreightTrackingUrl: outDeliveryFreightTrackingUrl ?? this.outDeliveryFreightTrackingUrl,
        outDeliveryPackageCode: outDeliveryPackageCode ?? this.outDeliveryPackageCode,
        outDeliveryBillPoFreightOnOrder: outDeliveryBillPoFreightOnOrder ?? this.outDeliveryBillPoFreightOnOrder,
        outDeliveryOnlineOrderNumber: outDeliveryOnlineOrderNumber ?? this.outDeliveryOnlineOrderNumber,
        outDeliveryToVenue: outDeliveryToVenue ?? this.outDeliveryToVenue,
        outDeliveryToVenueId: outDeliveryToVenueId ?? this.outDeliveryToVenueId,
        outDeliveryToWarehouse: outDeliveryToWarehouse ?? this.outDeliveryToWarehouse,
        outDeliveryToWarehouseId: outDeliveryToWarehouseId ?? this.outDeliveryToWarehouseId,
        outDeliveryDateStamp: outDeliveryDateStamp ?? this.outDeliveryDateStamp,
        inDeliveryId: inDeliveryId ?? this.inDeliveryId,
        inDeliveryDeliveryType: inDeliveryDeliveryType ?? this.inDeliveryDeliveryType,
        inDeliveryRequiredDate: inDeliveryRequiredDate ?? this.inDeliveryRequiredDate,
        inDeliveryRequiredTime: inDeliveryRequiredTime ?? this.inDeliveryRequiredTime,
        inDeliveryTargetShipDate: inDeliveryTargetShipDate ?? this.inDeliveryTargetShipDate,
        inDeliveryTargetShipTime: inDeliveryTargetShipTime ?? this.inDeliveryTargetShipTime,
        inDeliveryDirection: inDeliveryDirection ?? this.inDeliveryDirection,
        inDeliveryAddressType: inDeliveryAddressType ?? this.inDeliveryAddressType,
        inDeliveryFromLocation: inDeliveryFromLocation ?? this.inDeliveryFromLocation,
        inDeliveryFromContact: inDeliveryFromContact ?? this.inDeliveryFromContact,
        inDeliveryFromContactPhone: inDeliveryFromContactPhone ?? this.inDeliveryFromContactPhone,
        inDeliveryFromAlternateContact: inDeliveryFromAlternateContact ?? this.inDeliveryFromAlternateContact,
        inDeliveryFromAlternateContactPhone: inDeliveryFromAlternateContactPhone ?? this.inDeliveryFromAlternateContactPhone,
        inDeliveryFromAttention: inDeliveryFromAttention ?? this.inDeliveryFromAttention,
        inDeliveryFromAddress1: inDeliveryFromAddress1 ?? this.inDeliveryFromAddress1,
        inDeliveryFromAdd2ress: inDeliveryFromAdd2ress ?? this.inDeliveryFromAdd2ress,
        inDeliveryFromCity: inDeliveryFromCity ?? this.inDeliveryFromCity,
        inDeliveryFromState: inDeliveryFromState ?? this.inDeliveryFromState,
        inDeliveryFromZipCode: inDeliveryFromZipCode ?? this.inDeliveryFromZipCode,
        inDeliveryFromCountry: inDeliveryFromCountry ?? this.inDeliveryFromCountry,
        inDeliveryFromCountryId: inDeliveryFromCountryId ?? this.inDeliveryFromCountryId,
        inDeliveryFromCrossStreets: inDeliveryFromCrossStreets ?? this.inDeliveryFromCrossStreets,
        inDeliveryToLocation: inDeliveryToLocation ?? this.inDeliveryToLocation,
        inDeliveryToContact: inDeliveryToContact ?? this.inDeliveryToContact,
        inDeliveryToContactPhone: inDeliveryToContactPhone ?? this.inDeliveryToContactPhone,
        inDeliveryToAlternateContact: inDeliveryToAlternateContact ?? this.inDeliveryToAlternateContact,
        inDeliveryToAlternateContactPhone: inDeliveryToAlternateContactPhone ?? this.inDeliveryToAlternateContactPhone,
        inDeliveryToAttention: inDeliveryToAttention ?? this.inDeliveryToAttention,
        inDeliveryToAddress1: inDeliveryToAddress1 ?? this.inDeliveryToAddress1,
        inDeliveryToAddress2: inDeliveryToAddress2 ?? this.inDeliveryToAddress2,
        inDeliveryToCity: inDeliveryToCity ?? this.inDeliveryToCity,
        inDeliveryToState: inDeliveryToState ?? this.inDeliveryToState,
        inDeliveryToZipCode: inDeliveryToZipCode ?? this.inDeliveryToZipCode,
        inDeliveryToCountryId: inDeliveryToCountryId ?? this.inDeliveryToCountryId,
        inDeliveryToCountry: inDeliveryToCountry ?? this.inDeliveryToCountry,
        inDeliveryToContactFax: inDeliveryToContactFax ?? this.inDeliveryToContactFax,
        inDeliveryToCrossStreets: inDeliveryToCrossStreets ?? this.inDeliveryToCrossStreets,
        inDeliveryDeliveryNotes: inDeliveryDeliveryNotes ?? this.inDeliveryDeliveryNotes,
        inDeliveryCarrierId: inDeliveryCarrierId ?? this.inDeliveryCarrierId,
        inDeliveryCarrier: inDeliveryCarrier ?? this.inDeliveryCarrier,
        inDeliveryCarrierAccount: inDeliveryCarrierAccount ?? this.inDeliveryCarrierAccount,
        inDeliveryShipViaId: inDeliveryShipViaId ?? this.inDeliveryShipViaId,
        inDeliveryShipVia: inDeliveryShipVia ?? this.inDeliveryShipVia,
        inDeliveryInvoiceId: inDeliveryInvoiceId ?? this.inDeliveryInvoiceId,
        inDeliveryVendorInvoiceId: inDeliveryVendorInvoiceId ?? this.inDeliveryVendorInvoiceId,
        inDeliveryEstimatedFreight: inDeliveryEstimatedFreight ?? this.inDeliveryEstimatedFreight,
        inDeliveryFreightInvoiceAmount: inDeliveryFreightInvoiceAmount ?? this.inDeliveryFreightInvoiceAmount,
        inDeliveryChargeType: inDeliveryChargeType ?? this.inDeliveryChargeType,
        inDeliveryFreightTrackingNumber: inDeliveryFreightTrackingNumber ?? this.inDeliveryFreightTrackingNumber,
        inDeliveryFreightTrackingUrl: inDeliveryFreightTrackingUrl ?? this.inDeliveryFreightTrackingUrl,
        inDeliveryPackageCode: inDeliveryPackageCode ?? this.inDeliveryPackageCode,
        inDeliveryBillPoFreightOnOrder: inDeliveryBillPoFreightOnOrder ?? this.inDeliveryBillPoFreightOnOrder,
        inDeliveryOnlineOrderNumber: inDeliveryOnlineOrderNumber ?? this.inDeliveryOnlineOrderNumber,
        inDeliveryOnlineOrderStatus: inDeliveryOnlineOrderStatus ?? this.inDeliveryOnlineOrderStatus,
        inDeliveryToVenue: inDeliveryToVenue ?? this.inDeliveryToVenue,
        inDeliveryToVenueId: inDeliveryToVenueId ?? this.inDeliveryToVenueId,
        inDeliveryToWarehouse: inDeliveryToWarehouse ?? this.inDeliveryToWarehouse,
        inDeliveryToWarehouseId: inDeliveryToWarehouseId ?? this.inDeliveryToWarehouseId,
        inDeliveryDateStamp: inDeliveryDateStamp ?? this.inDeliveryDateStamp,
        rentalDaysPerWeek: rentalDaysPerWeek ?? this.rentalDaysPerWeek,
        rentalDiscountPercent: rentalDiscountPercent ?? this.rentalDiscountPercent,
        weeklyRentalTotal: weeklyRentalTotal ?? this.weeklyRentalTotal,
        monthlyRentalTotal: monthlyRentalTotal ?? this.monthlyRentalTotal,
        periodRentalTotal: periodRentalTotal ?? this.periodRentalTotal,
        weeklyRentalTotalIncludesTax: weeklyRentalTotalIncludesTax ?? this.weeklyRentalTotalIncludesTax,
        monthlyRentalTotalIncludesTax: monthlyRentalTotalIncludesTax ?? this.monthlyRentalTotalIncludesTax,
        periodRentalTotalIncludesTax: periodRentalTotalIncludesTax ?? this.periodRentalTotalIncludesTax,
        billLockedTotal: billLockedTotal ?? this.billLockedTotal,
        salesDiscountPercent: salesDiscountPercent ?? this.salesDiscountPercent,
        salesTotal: salesTotal ?? this.salesTotal,
        salesTotalIncludesTax: salesTotalIncludesTax ?? this.salesTotalIncludesTax,
        partsDiscountPercent: partsDiscountPercent ?? this.partsDiscountPercent,
        partsTotal: partsTotal ?? this.partsTotal,
        partsTotalIncludesTax: partsTotalIncludesTax ?? this.partsTotalIncludesTax,
        spaceDaysPerWeek: spaceDaysPerWeek ?? this.spaceDaysPerWeek,
        spaceDiscountPercent: spaceDiscountPercent ?? this.spaceDiscountPercent,
        spaceSplitPercent: spaceSplitPercent ?? this.spaceSplitPercent,
        weeklySpaceTotal: weeklySpaceTotal ?? this.weeklySpaceTotal,
        monthlySpaceTotal: monthlySpaceTotal ?? this.monthlySpaceTotal,
        periodSpaceTotal: periodSpaceTotal ?? this.periodSpaceTotal,
        weeklySpaceTotalIncludesTax: weeklySpaceTotalIncludesTax ?? this.weeklySpaceTotalIncludesTax,
        monthlySpaceTotalIncludesTax: monthlySpaceTotalIncludesTax ?? this.monthlySpaceTotalIncludesTax,
        periodSpaceTotalIncludesTax: periodSpaceTotalIncludesTax ?? this.periodSpaceTotalIncludesTax,
        vehicleDaysPerWeek: vehicleDaysPerWeek ?? this.vehicleDaysPerWeek,
        vehicleDiscountPercent: vehicleDiscountPercent ?? this.vehicleDiscountPercent,
        weeklyVehicleTotal: weeklyVehicleTotal ?? this.weeklyVehicleTotal,
        monthlyVehicleTotal: monthlyVehicleTotal ?? this.monthlyVehicleTotal,
        periodVehicleTotal: periodVehicleTotal ?? this.periodVehicleTotal,
        weeklyVehicleTotalIncludesTax: weeklyVehicleTotalIncludesTax ?? this.weeklyVehicleTotalIncludesTax,
        monthlyVehicleTotalIncludesTax: monthlyVehicleTotalIncludesTax ?? this.monthlyVehicleTotalIncludesTax,
        periodVehicleTotalIncludesTax: periodVehicleTotalIncludesTax ?? this.periodVehicleTotalIncludesTax,
        miscDiscountPercent: miscDiscountPercent ?? this.miscDiscountPercent,
        weeklyMiscTotal: weeklyMiscTotal ?? this.weeklyMiscTotal,
        monthlyMiscTotal: monthlyMiscTotal ?? this.monthlyMiscTotal,
        periodMiscTotal: periodMiscTotal ?? this.periodMiscTotal,
        weeklyMiscTotalIncludesTax: weeklyMiscTotalIncludesTax ?? this.weeklyMiscTotalIncludesTax,
        monthlyMiscTotalIncludesTax: monthlyMiscTotalIncludesTax ?? this.monthlyMiscTotalIncludesTax,
        periodMiscTotalIncludesTax: periodMiscTotalIncludesTax ?? this.periodMiscTotalIncludesTax,
        laborDiscountPercent: laborDiscountPercent ?? this.laborDiscountPercent,
        weeklyLaborTotal: weeklyLaborTotal ?? this.weeklyLaborTotal,
        monthlyLaborTotal: monthlyLaborTotal ?? this.monthlyLaborTotal,
        periodLaborTotal: periodLaborTotal ?? this.periodLaborTotal,
        weeklyLaborTotalIncludesTax: weeklyLaborTotalIncludesTax ?? this.weeklyLaborTotalIncludesTax,
        monthlyLaborTotalIncludesTax: monthlyLaborTotalIncludesTax ?? this.monthlyLaborTotalIncludesTax,
        periodLaborTotalIncludesTax: periodLaborTotalIncludesTax ?? this.periodLaborTotalIncludesTax,
        rentalSaleDiscountPercent: rentalSaleDiscountPercent ?? this.rentalSaleDiscountPercent,
        rentalSaleTotal: rentalSaleTotal ?? this.rentalSaleTotal,
        rentalSaleTotalIncludesTax: rentalSaleTotalIncludesTax ?? this.rentalSaleTotalIncludesTax,
        lossAndDamageDiscountPercent: lossAndDamageDiscountPercent ?? this.lossAndDamageDiscountPercent,
        lossAndDamageTotal: lossAndDamageTotal ?? this.lossAndDamageTotal,
        lossAndDamageTotalIncludesTax: lossAndDamageTotalIncludesTax ?? this.lossAndDamageTotalIncludesTax,
        combinedDaysPerWeek: combinedDaysPerWeek ?? this.combinedDaysPerWeek,
        combinedDiscountPercent: combinedDiscountPercent ?? this.combinedDiscountPercent,
        weeklyCombinedTotal: weeklyCombinedTotal ?? this.weeklyCombinedTotal,
        monthlyCombinedTotal: monthlyCombinedTotal ?? this.monthlyCombinedTotal,
        periodCombinedTotal: periodCombinedTotal ?? this.periodCombinedTotal,
        weeklyCombinedTotalIncludesTax: weeklyCombinedTotalIncludesTax ?? this.weeklyCombinedTotalIncludesTax,
        monthlyCombinedTotalIncludesTax: monthlyCombinedTotalIncludesTax ?? this.monthlyCombinedTotalIncludesTax,
        periodCombinedTotalIncludesTax: periodCombinedTotalIncludesTax ?? this.periodCombinedTotalIncludesTax,
        disableEditingRentalRate: disableEditingRentalRate ?? this.disableEditingRentalRate,
        disableEditingSalesRate: disableEditingSalesRate ?? this.disableEditingSalesRate,
        disableEditingMiscellaneousRate: disableEditingMiscellaneousRate ?? this.disableEditingMiscellaneousRate,
        disableEditingLaborRate: disableEditingLaborRate ?? this.disableEditingLaborRate,
        disableEditingRentalSaleRate: disableEditingRentalSaleRate ?? this.disableEditingRentalSaleRate,
        disableEditingLossAndDamageRate: disableEditingLossAndDamageRate ?? this.disableEditingLossAndDamageRate,
        rentalExtendedTotal: rentalExtendedTotal ?? this.rentalExtendedTotal,
        salesExtendedTotal: salesExtendedTotal ?? this.salesExtendedTotal,
        laborExtendedTotal: laborExtendedTotal ?? this.laborExtendedTotal,
        miscellaneousExtendedTotal: miscellaneousExtendedTotal ?? this.miscellaneousExtendedTotal,
        rentalSaleExtendedTotal: rentalSaleExtendedTotal ?? this.rentalSaleExtendedTotal,
        lossAndDamageExtendedTotal: lossAndDamageExtendedTotal ?? this.lossAndDamageExtendedTotal,
        hasNotes: hasNotes ?? this.hasNotes,
        hasDocuments: hasDocuments ?? this.hasDocuments,
        hasEmailHistory: hasEmailHistory ?? this.hasEmailHistory,
        hasContacts: hasContacts ?? this.hasContacts,
        hasSubPurchaseOrders: hasSubPurchaseOrders ?? this.hasSubPurchaseOrders,
        hasPickLists: hasPickLists ?? this.hasPickLists,
        hasContracts: hasContracts ?? this.hasContracts,
        hasSuspendedContracts: hasSuspendedContracts ?? this.hasSuspendedContracts,
        hasMultiOrderContracts: hasMultiOrderContracts ?? this.hasMultiOrderContracts,
        hasInvoices: hasInvoices ?? this.hasInvoices,
        hasBillingWorksheets: hasBillingWorksheets ?? this.hasBillingWorksheets,
        hasMultiOrderInvoices: hasMultiOrderInvoices ?? this.hasMultiOrderInvoices,
        totalReplacementCost: totalReplacementCost ?? this.totalReplacementCost,
        presentationLayerId: presentationLayerId ?? this.presentationLayerId,
        presentationLayer: presentationLayer ?? this.presentationLayer,
        isManualSort: isManualSort ?? this.isManualSort,
        quoteOrderTitle: quoteOrderTitle ?? this.quoteOrderTitle,
        unassignedSubs: unassignedSubs ?? this.unassignedSubs,
        nonTaxable: nonTaxable ?? this.nonTaxable,
        enableProjects: enableProjects ?? this.enableProjects,
        projectId: projectId ?? this.projectId,
        projectNumber: projectNumber ?? this.projectNumber,
        project: project ?? this.project,
        projectDrawingsId: projectDrawingsId ?? this.projectDrawingsId,
        projectDrawings: projectDrawings ?? this.projectDrawings,
        projectItemsOrderedId: projectItemsOrderedId ?? this.projectItemsOrderedId,
        projectItemsOrdered: projectItemsOrdered ?? this.projectItemsOrdered,
        projectDropShipId: projectDropShipId ?? this.projectDropShipId,
        projectDropShip: projectDropShip ?? this.projectDropShip,
        projectAsBuildId: projectAsBuildId ?? this.projectAsBuildId,
        projectAsBuild: projectAsBuild ?? this.projectAsBuild,
        projectCommissioningId: projectCommissioningId ?? this.projectCommissioningId,
        projectCommissioning: projectCommissioning ?? this.projectCommissioning,
        projectDepositId: projectDepositId ?? this.projectDepositId,
        projectDeposit: projectDeposit ?? this.projectDeposit,
        inputByUserId: inputByUserId ?? this.inputByUserId,
        modifiedByUserId: modifiedByUserId ?? this.modifiedByUserId,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes: defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderOrderDocument {
  WebApiModulesAgentOrderOrderDocument({
    this.orderId,
    this.copying,
    this.documentId,
    this.documentTypeId,
    this.uniqueId1,
    this.uniqueId2,
    this.uniqueId1Int,
    this.description,
    this.inputByUsersId,
    this.attachDate,
    this.attachTime,
    this.attachToEmail,
    this.inactive,
    this.dateStamp,
    this.extension,
    this.documentType,
    this.inputBy,
    this.hasImage,
    this.hasFile,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAgentOrderOrderDocument.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderOrderDocumentFromJson(json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'copying')
  final bool? copying;
  @JsonKey(name: 'DocumentId')
  final String? documentId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'UniqueId1')
  final String? uniqueId1;
  @JsonKey(name: 'UniqueId2')
  final String? uniqueId2;
  @JsonKey(name: 'UniqueId1Int')
  final int? uniqueId1Int;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'InputByUsersId')
  final String? inputByUsersId;
  @JsonKey(name: 'AttachDate')
  final String? attachDate;
  @JsonKey(name: 'AttachTime')
  final String? attachTime;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'Extension')
  final String? extension;
  @JsonKey(name: 'DocumentType')
  final String? documentType;
  @JsonKey(name: 'InputBy')
  final String? inputBy;
  @JsonKey(name: 'HasImage')
  final bool? hasImage;
  @JsonKey(name: 'HasFile')
  final bool? hasFile;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory = _$WebApiModulesAgentOrderOrderDocumentFromJson;
  static const toJsonFactory = _$WebApiModulesAgentOrderOrderDocumentToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderOrderDocumentToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderOrderDocument &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.copying, copying) ||
                const DeepCollectionEquality()
                    .equals(other.copying, copying)) &&
            (identical(other.documentId, documentId) ||
                const DeepCollectionEquality()
                    .equals(other.documentId, documentId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.uniqueId1, uniqueId1) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1, uniqueId1)) &&
            (identical(other.uniqueId2, uniqueId2) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId2, uniqueId2)) &&
            (identical(other.uniqueId1Int, uniqueId1Int) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1Int, uniqueId1Int)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.inputByUsersId, inputByUsersId) ||
                const DeepCollectionEquality()
                    .equals(other.inputByUsersId, inputByUsersId)) &&
            (identical(other.attachDate, attachDate) ||
                const DeepCollectionEquality()
                    .equals(other.attachDate, attachDate)) &&
            (identical(other.attachTime, attachTime) ||
                const DeepCollectionEquality()
                    .equals(other.attachTime, attachTime)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.extension, extension) ||
                const DeepCollectionEquality()
                    .equals(other.extension, extension)) &&
            (identical(other.documentType, documentType) ||
                const DeepCollectionEquality()
                    .equals(other.documentType, documentType)) &&
            (identical(other.inputBy, inputBy) ||
                const DeepCollectionEquality()
                    .equals(other.inputBy, inputBy)) &&
            (identical(other.hasImage, hasImage) ||
                const DeepCollectionEquality()
                    .equals(other.hasImage, hasImage)) &&
            (identical(other.hasFile, hasFile) ||
                const DeepCollectionEquality()
                    .equals(other.hasFile, hasFile)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality().equals(other.filePath, filePath)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesAgentOrderOrderDocumentExtension
    on WebApiModulesAgentOrderOrderDocument {
  WebApiModulesAgentOrderOrderDocument copyWith(
      {String? orderId,
      bool? copying,
      String? documentId,
      String? documentTypeId,
      String? uniqueId1,
      String? uniqueId2,
      int? uniqueId1Int,
      String? description,
      String? inputByUsersId,
      String? attachDate,
      String? attachTime,
      bool? attachToEmail,
      bool? inactive,
      String? dateStamp,
      String? extension,
      String? documentType,
      String? inputBy,
      bool? hasImage,
      bool? hasFile,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAgentOrderOrderDocument(
        orderId: orderId ?? this.orderId,
        copying: copying ?? this.copying,
        documentId: documentId ?? this.documentId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        uniqueId1: uniqueId1 ?? this.uniqueId1,
        uniqueId2: uniqueId2 ?? this.uniqueId2,
        uniqueId1Int: uniqueId1Int ?? this.uniqueId1Int,
        description: description ?? this.description,
        inputByUsersId: inputByUsersId ?? this.inputByUsersId,
        attachDate: attachDate ?? this.attachDate,
        attachTime: attachTime ?? this.attachTime,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        dateStamp: dateStamp ?? this.dateStamp,
        extension: extension ?? this.extension,
        documentType: documentType ?? this.documentType,
        inputBy: inputBy ?? this.inputBy,
        hasImage: hasImage ?? this.hasImage,
        hasFile: hasFile ?? this.hasFile,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderOrderDocumentPostRequest {
  WebApiModulesAgentOrderOrderDocumentPostRequest({
    this.orderId,
    this.documentTypeId,
    this.description,
    this.attachToEmail,
    this.inactive,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
  });

  factory WebApiModulesAgentOrderOrderDocumentPostRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderOrderDocumentPostRequestFromJson(json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  static const fromJsonFactory =
      _$WebApiModulesAgentOrderOrderDocumentPostRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentOrderOrderDocumentPostRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderOrderDocumentPostRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderOrderDocumentPostRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)));
  }
}

extension $WebApiModulesAgentOrderOrderDocumentPostRequestExtension
    on WebApiModulesAgentOrderOrderDocumentPostRequest {
  WebApiModulesAgentOrderOrderDocumentPostRequest copyWith(
      {String? orderId,
      String? documentTypeId,
      String? description,
      bool? attachToEmail,
      bool? inactive,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath}) {
    return WebApiModulesAgentOrderOrderDocumentPostRequest(
        orderId: orderId ?? this.orderId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        description: description ?? this.description,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderOrderDocumentPutRequest {
  WebApiModulesAgentOrderOrderDocumentPutRequest({
    this.orderId,
    this.documentId,
    this.documentTypeId,
    this.description,
    this.attachToEmail,
    this.inactive,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
  });

  factory WebApiModulesAgentOrderOrderDocumentPutRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderOrderDocumentPutRequestFromJson(json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'DocumentId')
  final String? documentId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  static const fromJsonFactory =
      _$WebApiModulesAgentOrderOrderDocumentPutRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentOrderOrderDocumentPutRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderOrderDocumentPutRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderOrderDocumentPutRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.documentId, documentId) ||
                const DeepCollectionEquality()
                    .equals(other.documentId, documentId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)));
  }
}

extension $WebApiModulesAgentOrderOrderDocumentPutRequestExtension
    on WebApiModulesAgentOrderOrderDocumentPutRequest {
  WebApiModulesAgentOrderOrderDocumentPutRequest copyWith(
      {String? orderId,
      String? documentId,
      String? documentTypeId,
      String? description,
      bool? attachToEmail,
      bool? inactive,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath}) {
    return WebApiModulesAgentOrderOrderDocumentPutRequest(
        orderId: orderId ?? this.orderId,
        documentId: documentId ?? this.documentId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        description: description ?? this.description,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderOrderMessage {
  WebApiModulesAgentOrderOrderMessage({
    this.message,
    this.preventCheckOut,
  });

  factory WebApiModulesAgentOrderOrderMessage.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderOrderMessageFromJson(json);

  @JsonKey(name: 'Message')
  final String? message;
  @JsonKey(name: 'PreventCheckOut')
  final bool? preventCheckOut;
  static const fromJsonFactory = _$WebApiModulesAgentOrderOrderMessageFromJson;
  static const toJsonFactory = _$WebApiModulesAgentOrderOrderMessageToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderOrderMessageToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderOrderMessage &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.preventCheckOut, preventCheckOut) ||
                const DeepCollectionEquality()
                    .equals(other.preventCheckOut, preventCheckOut)));
  }
}

extension $WebApiModulesAgentOrderOrderMessageExtension
    on WebApiModulesAgentOrderOrderMessage {
  WebApiModulesAgentOrderOrderMessage copyWith(
      {String? message, bool? preventCheckOut}) {
    return WebApiModulesAgentOrderOrderMessage(
        message: message ?? this.message,
        preventCheckOut: preventCheckOut ?? this.preventCheckOut);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderOrderMessagesResponse {
  WebApiModulesAgentOrderOrderMessagesResponse({
    this.messages,
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesAgentOrderOrderMessagesResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderOrderMessagesResponseFromJson(json);

  @JsonKey(
      name: 'Messages', defaultValue: <WebApiModulesAgentOrderOrderMessage>[])
  final List<WebApiModulesAgentOrderOrderMessage>? messages;
  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesAgentOrderOrderMessagesResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentOrderOrderMessagesResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderOrderMessagesResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderOrderMessagesResponse &&
            (identical(other.messages, messages) ||
                const DeepCollectionEquality()
                    .equals(other.messages, messages)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesAgentOrderOrderMessagesResponseExtension
    on WebApiModulesAgentOrderOrderMessagesResponse {
  WebApiModulesAgentOrderOrderMessagesResponse copyWith(
      {List<WebApiModulesAgentOrderOrderMessage>? messages,
      int? status,
      bool? success,
      String? msg}) {
    return WebApiModulesAgentOrderOrderMessagesResponse(
        messages: messages ?? this.messages,
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderPoWorksheetSessionTotalsResponse {
  WebApiModulesAgentOrderPoWorksheetSessionTotalsResponse({
    this.grossTotal,
    this.discount,
    this.subTotal,
    this.tax,
    this.total,
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesAgentOrderPoWorksheetSessionTotalsResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderPoWorksheetSessionTotalsResponseFromJson(json);

  @JsonKey(name: 'GrossTotal')
  final double? grossTotal;
  @JsonKey(name: 'Discount')
  final double? discount;
  @JsonKey(name: 'SubTotal')
  final double? subTotal;
  @JsonKey(name: 'Tax')
  final double? tax;
  @JsonKey(name: 'Total')
  final double? total;
  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesAgentOrderPoWorksheetSessionTotalsResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentOrderPoWorksheetSessionTotalsResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderPoWorksheetSessionTotalsResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderPoWorksheetSessionTotalsResponse &&
            (identical(other.grossTotal, grossTotal) ||
                const DeepCollectionEquality()
                    .equals(other.grossTotal, grossTotal)) &&
            (identical(other.discount, discount) ||
                const DeepCollectionEquality()
                    .equals(other.discount, discount)) &&
            (identical(other.subTotal, subTotal) ||
                const DeepCollectionEquality()
                    .equals(other.subTotal, subTotal)) &&
            (identical(other.tax, tax) ||
                const DeepCollectionEquality().equals(other.tax, tax)) &&
            (identical(other.total, total) ||
                const DeepCollectionEquality().equals(other.total, total)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesAgentOrderPoWorksheetSessionTotalsResponseExtension
    on WebApiModulesAgentOrderPoWorksheetSessionTotalsResponse {
  WebApiModulesAgentOrderPoWorksheetSessionTotalsResponse copyWith(
      {double? grossTotal,
      double? discount,
      double? subTotal,
      double? tax,
      double? total,
      int? status,
      bool? success,
      String? msg}) {
    return WebApiModulesAgentOrderPoWorksheetSessionTotalsResponse(
        grossTotal: grossTotal ?? this.grossTotal,
        discount: discount ?? this.discount,
        subTotal: subTotal ?? this.subTotal,
        tax: tax ?? this.tax,
        total: total ?? this.total,
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderQuoteNewVersionResponse {
  WebApiModulesAgentOrderQuoteNewVersionResponse({
    this.status,
    this.success,
    this.msg,
    this.newVersion,
  });

  factory WebApiModulesAgentOrderQuoteNewVersionResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderQuoteNewVersionResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'NewVersion')
  final WebApiModulesAgentQuoteQuote? newVersion;
  static const fromJsonFactory =
      _$WebApiModulesAgentOrderQuoteNewVersionResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentOrderQuoteNewVersionResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderQuoteNewVersionResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderQuoteNewVersionResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.newVersion, newVersion) ||
                const DeepCollectionEquality()
                    .equals(other.newVersion, newVersion)));
  }
}

extension $WebApiModulesAgentOrderQuoteNewVersionResponseExtension
    on WebApiModulesAgentOrderQuoteNewVersionResponse {
  WebApiModulesAgentOrderQuoteNewVersionResponse copyWith(
      {int? status,
      bool? success,
      String? msg,
      WebApiModulesAgentQuoteQuote? newVersion}) {
    return WebApiModulesAgentOrderQuoteNewVersionResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        newVersion: newVersion ?? this.newVersion);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderQuoteToOrderRequest {
  WebApiModulesAgentOrderQuoteToOrderRequest({
    this.quoteId,
    this.locationId,
    this.warehouseId,
  });

  factory WebApiModulesAgentOrderQuoteToOrderRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderQuoteToOrderRequestFromJson(json);

  @JsonKey(name: 'QuoteId')
  final String? quoteId;
  @JsonKey(name: 'LocationId')
  final String? locationId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  static const fromJsonFactory =
      _$WebApiModulesAgentOrderQuoteToOrderRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentOrderQuoteToOrderRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderQuoteToOrderRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderQuoteToOrderRequest &&
            (identical(other.quoteId, quoteId) ||
                const DeepCollectionEquality()
                    .equals(other.quoteId, quoteId)) &&
            (identical(other.locationId, locationId) ||
                const DeepCollectionEquality()
                    .equals(other.locationId, locationId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)));
  }
}

extension $WebApiModulesAgentOrderQuoteToOrderRequestExtension
    on WebApiModulesAgentOrderQuoteToOrderRequest {
  WebApiModulesAgentOrderQuoteToOrderRequest copyWith(
      {String? quoteId, String? locationId, String? warehouseId}) {
    return WebApiModulesAgentOrderQuoteToOrderRequest(
        quoteId: quoteId ?? this.quoteId,
        locationId: locationId ?? this.locationId,
        warehouseId: warehouseId ?? this.warehouseId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderQuoteToOrderResponse {
  WebApiModulesAgentOrderQuoteToOrderResponse({
    this.status,
    this.success,
    this.msg,
    this.order,
  });

  factory WebApiModulesAgentOrderQuoteToOrderResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderQuoteToOrderResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'Order')
  final WebApiModulesAgentOrderOrder? order;
  static const fromJsonFactory =
      _$WebApiModulesAgentOrderQuoteToOrderResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentOrderQuoteToOrderResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderQuoteToOrderResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderQuoteToOrderResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.order, order) ||
                const DeepCollectionEquality().equals(other.order, order)));
  }
}

extension $WebApiModulesAgentOrderQuoteToOrderResponseExtension
    on WebApiModulesAgentOrderQuoteToOrderResponse {
  WebApiModulesAgentOrderQuoteToOrderResponse copyWith(
      {int? status,
      bool? success,
      String? msg,
      WebApiModulesAgentOrderOrder? order}) {
    return WebApiModulesAgentOrderQuoteToOrderResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        order: order ?? this.order);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderReserveUnreserveQuoteResponse {
  WebApiModulesAgentOrderReserveUnreserveQuoteResponse({
    this.status,
    this.success,
    this.msg,
    this.quote,
  });

  factory WebApiModulesAgentOrderReserveUnreserveQuoteResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderReserveUnreserveQuoteResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'Quote')
  final WebApiModulesAgentQuoteQuote? quote;
  static const fromJsonFactory =
      _$WebApiModulesAgentOrderReserveUnreserveQuoteResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentOrderReserveUnreserveQuoteResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderReserveUnreserveQuoteResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderReserveUnreserveQuoteResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.quote, quote) ||
                const DeepCollectionEquality().equals(other.quote, quote)));
  }
}

extension $WebApiModulesAgentOrderReserveUnreserveQuoteResponseExtension
    on WebApiModulesAgentOrderReserveUnreserveQuoteResponse {
  WebApiModulesAgentOrderReserveUnreserveQuoteResponse copyWith(
      {int? status,
      bool? success,
      String? msg,
      WebApiModulesAgentQuoteQuote? quote}) {
    return WebApiModulesAgentOrderReserveUnreserveQuoteResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        quote: quote ?? this.quote);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderUpdatePoWorksheetSessionRequest {
  WebApiModulesAgentOrderUpdatePoWorksheetSessionRequest({
    this.recType,
    this.vendorId,
    this.contactId,
    this.rateType,
    this.currencyId,
    this.billingCycleId,
    this.requiredDate,
    this.requiredTime,
    this.fromDate,
    this.toDate,
    this.deliveryId,
    this.adjustContractDates,
  });

  factory WebApiModulesAgentOrderUpdatePoWorksheetSessionRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderUpdatePoWorksheetSessionRequestFromJson(json);

  @JsonKey(name: 'RecType')
  final String? recType;
  @JsonKey(name: 'VendorId')
  final String? vendorId;
  @JsonKey(name: 'ContactId')
  final String? contactId;
  @JsonKey(name: 'RateType')
  final String? rateType;
  @JsonKey(name: 'CurrencyId')
  final String? currencyId;
  @JsonKey(name: 'BillingCycleId')
  final String? billingCycleId;
  @JsonKey(name: 'RequiredDate')
  final DateTime? requiredDate;
  @JsonKey(name: 'RequiredTime')
  final String? requiredTime;
  @JsonKey(name: 'FromDate')
  final DateTime? fromDate;
  @JsonKey(name: 'ToDate')
  final DateTime? toDate;
  @JsonKey(name: 'DeliveryId')
  final String? deliveryId;
  @JsonKey(name: 'AdjustContractDates')
  final bool? adjustContractDates;
  static const fromJsonFactory =
      _$WebApiModulesAgentOrderUpdatePoWorksheetSessionRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentOrderUpdatePoWorksheetSessionRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderUpdatePoWorksheetSessionRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderUpdatePoWorksheetSessionRequest &&
            (identical(other.recType, recType) ||
                const DeepCollectionEquality()
                    .equals(other.recType, recType)) &&
            (identical(other.vendorId, vendorId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorId, vendorId)) &&
            (identical(other.contactId, contactId) ||
                const DeepCollectionEquality()
                    .equals(other.contactId, contactId)) &&
            (identical(other.rateType, rateType) ||
                const DeepCollectionEquality()
                    .equals(other.rateType, rateType)) &&
            (identical(other.currencyId, currencyId) ||
                const DeepCollectionEquality()
                    .equals(other.currencyId, currencyId)) &&
            (identical(other.billingCycleId, billingCycleId) ||
                const DeepCollectionEquality()
                    .equals(other.billingCycleId, billingCycleId)) &&
            (identical(other.requiredDate, requiredDate) ||
                const DeepCollectionEquality()
                    .equals(other.requiredDate, requiredDate)) &&
            (identical(other.requiredTime, requiredTime) ||
                const DeepCollectionEquality()
                    .equals(other.requiredTime, requiredTime)) &&
            (identical(other.fromDate, fromDate) ||
                const DeepCollectionEquality()
                    .equals(other.fromDate, fromDate)) &&
            (identical(other.toDate, toDate) ||
                const DeepCollectionEquality().equals(other.toDate, toDate)) &&
            (identical(other.deliveryId, deliveryId) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryId, deliveryId)) &&
            (identical(other.adjustContractDates, adjustContractDates) ||
                const DeepCollectionEquality()
                    .equals(other.adjustContractDates, adjustContractDates)));
  }
}

extension $WebApiModulesAgentOrderUpdatePoWorksheetSessionRequestExtension
    on WebApiModulesAgentOrderUpdatePoWorksheetSessionRequest {
  WebApiModulesAgentOrderUpdatePoWorksheetSessionRequest copyWith(
      {String? recType,
      String? vendorId,
      String? contactId,
      String? rateType,
      String? currencyId,
      String? billingCycleId,
      DateTime? requiredDate,
      String? requiredTime,
      DateTime? fromDate,
      DateTime? toDate,
      String? deliveryId,
      bool? adjustContractDates}) {
    return WebApiModulesAgentOrderUpdatePoWorksheetSessionRequest(
        recType: recType ?? this.recType,
        vendorId: vendorId ?? this.vendorId,
        contactId: contactId ?? this.contactId,
        rateType: rateType ?? this.rateType,
        currencyId: currencyId ?? this.currencyId,
        billingCycleId: billingCycleId ?? this.billingCycleId,
        requiredDate: requiredDate ?? this.requiredDate,
        requiredTime: requiredTime ?? this.requiredTime,
        fromDate: fromDate ?? this.fromDate,
        toDate: toDate ?? this.toDate,
        deliveryId: deliveryId ?? this.deliveryId,
        adjustContractDates: adjustContractDates ?? this.adjustContractDates);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentOrderUpdatePoWorksheetSessionResponse {
  WebApiModulesAgentOrderUpdatePoWorksheetSessionResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesAgentOrderUpdatePoWorksheetSessionResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentOrderUpdatePoWorksheetSessionResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesAgentOrderUpdatePoWorksheetSessionResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentOrderUpdatePoWorksheetSessionResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentOrderUpdatePoWorksheetSessionResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentOrderUpdatePoWorksheetSessionResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesAgentOrderUpdatePoWorksheetSessionResponseExtension
    on WebApiModulesAgentOrderUpdatePoWorksheetSessionResponse {
  WebApiModulesAgentOrderUpdatePoWorksheetSessionResponse copyWith(
      {int? status, bool? success, String? msg}) {
    return WebApiModulesAgentOrderUpdatePoWorksheetSessionResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentProjectCreateQuoteFromProjectRequest {
  WebApiModulesAgentProjectCreateQuoteFromProjectRequest({
    this.projectId,
    this.officeLocationId,
  });

  factory WebApiModulesAgentProjectCreateQuoteFromProjectRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentProjectCreateQuoteFromProjectRequestFromJson(json);

  @JsonKey(name: 'ProjectId')
  final String? projectId;
  @JsonKey(name: 'OfficeLocationId')
  final String? officeLocationId;
  static const fromJsonFactory =
      _$WebApiModulesAgentProjectCreateQuoteFromProjectRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentProjectCreateQuoteFromProjectRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentProjectCreateQuoteFromProjectRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentProjectCreateQuoteFromProjectRequest &&
            (identical(other.projectId, projectId) ||
                const DeepCollectionEquality()
                    .equals(other.projectId, projectId)) &&
            (identical(other.officeLocationId, officeLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocationId, officeLocationId)));
  }
}

extension $WebApiModulesAgentProjectCreateQuoteFromProjectRequestExtension
    on WebApiModulesAgentProjectCreateQuoteFromProjectRequest {
  WebApiModulesAgentProjectCreateQuoteFromProjectRequest copyWith(
      {String? projectId, String? officeLocationId}) {
    return WebApiModulesAgentProjectCreateQuoteFromProjectRequest(
        projectId: projectId ?? this.projectId,
        officeLocationId: officeLocationId ?? this.officeLocationId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentProjectCreateQuoteFromProjectResponse {
  WebApiModulesAgentProjectCreateQuoteFromProjectResponse({
    this.status,
    this.success,
    this.msg,
    this.quoteId,
  });

  factory WebApiModulesAgentProjectCreateQuoteFromProjectResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentProjectCreateQuoteFromProjectResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'QuoteId')
  final String? quoteId;
  static const fromJsonFactory =
      _$WebApiModulesAgentProjectCreateQuoteFromProjectResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentProjectCreateQuoteFromProjectResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentProjectCreateQuoteFromProjectResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentProjectCreateQuoteFromProjectResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.quoteId, quoteId) ||
                const DeepCollectionEquality().equals(other.quoteId, quoteId)));
  }
}

extension $WebApiModulesAgentProjectCreateQuoteFromProjectResponseExtension
    on WebApiModulesAgentProjectCreateQuoteFromProjectResponse {
  WebApiModulesAgentProjectCreateQuoteFromProjectResponse copyWith(
      {int? status, bool? success, String? msg, String? quoteId}) {
    return WebApiModulesAgentProjectCreateQuoteFromProjectResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        quoteId: quoteId ?? this.quoteId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentProjectProject {
  WebApiModulesAgentProjectProject({
    this.projectId,
    this.projectNumber,
    this.project,
    this.officeLocationId,
    this.officeLocation,
    this.warehouseId,
    this.warehouse,
    this.departmentId,
    this.department,
    this.dealId,
    this.deal,
    this.status,
    this.statusDate,
    this.projectManagerId,
    this.projectManager,
    this.agentId,
    this.agent,
    this.primaryContact,
    this.requestedBy,
    this.outsideSalesRepresentativeId,
    this.outsideSalesRepresentative,
    this.projectDescription,
    this.rental,
    this.sales,
    this.facilities,
    this.labor,
    this.miscellaneous,
    this.transportation,
    this.pickDate,
    this.pickTime,
    this.estimatedStartDate,
    this.estimatedStartTime,
    this.estimatedStopDate,
    this.estimatedStopTime,
    this.ccPrimaryApproverWhenEmailingBackupApprover,
    this.inactive,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAgentProjectProject.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentProjectProjectFromJson(json);

  @JsonKey(name: 'ProjectId')
  final String? projectId;
  @JsonKey(name: 'ProjectNumber')
  final String? projectNumber;
  @JsonKey(name: 'Project')
  final String? project;
  @JsonKey(name: 'OfficeLocationId')
  final String? officeLocationId;
  @JsonKey(name: 'OfficeLocation')
  final String? officeLocation;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'Department')
  final String? department;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'Deal')
  final String? deal;
  @JsonKey(name: 'Status')
  final String? status;
  @JsonKey(name: 'StatusDate')
  final String? statusDate;
  @JsonKey(name: 'ProjectManagerId')
  final String? projectManagerId;
  @JsonKey(name: 'ProjectManager')
  final String? projectManager;
  @JsonKey(name: 'AgentId')
  final String? agentId;
  @JsonKey(name: 'Agent')
  final String? agent;
  @JsonKey(name: 'PrimaryContact')
  final String? primaryContact;
  @JsonKey(name: 'RequestedBy')
  final String? requestedBy;
  @JsonKey(name: 'OutsideSalesRepresentativeId')
  final String? outsideSalesRepresentativeId;
  @JsonKey(name: 'OutsideSalesRepresentative')
  final String? outsideSalesRepresentative;
  @JsonKey(name: 'ProjectDescription')
  final String? projectDescription;
  @JsonKey(name: 'Rental')
  final bool? rental;
  @JsonKey(name: 'Sales')
  final bool? sales;
  @JsonKey(name: 'Facilities')
  final bool? facilities;
  @JsonKey(name: 'Labor')
  final bool? labor;
  @JsonKey(name: 'Miscellaneous')
  final bool? miscellaneous;
  @JsonKey(name: 'Transportation')
  final bool? transportation;
  @JsonKey(name: 'PickDate')
  final String? pickDate;
  @JsonKey(name: 'PickTime')
  final String? pickTime;
  @JsonKey(name: 'EstimatedStartDate')
  final String? estimatedStartDate;
  @JsonKey(name: 'EstimatedStartTime')
  final String? estimatedStartTime;
  @JsonKey(name: 'EstimatedStopDate')
  final String? estimatedStopDate;
  @JsonKey(name: 'EstimatedStopTime')
  final String? estimatedStopTime;
  @JsonKey(name: 'CcPrimaryApproverWhenEmailingBackupApprover')
  final bool? ccPrimaryApproverWhenEmailingBackupApprover;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory = _$WebApiModulesAgentProjectProjectFromJson;
  static const toJsonFactory = _$WebApiModulesAgentProjectProjectToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentProjectProjectToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentProjectProject &&
            (identical(other.projectId, projectId) ||
                const DeepCollectionEquality()
                    .equals(other.projectId, projectId)) &&
            (identical(other.projectNumber, projectNumber) ||
                const DeepCollectionEquality()
                    .equals(other.projectNumber, projectNumber)) &&
            (identical(other.project, project) ||
                const DeepCollectionEquality()
                    .equals(other.project, project)) &&
            (identical(other.officeLocationId, officeLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocationId, officeLocationId)) &&
            (identical(other.officeLocation, officeLocation) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocation, officeLocation)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouse, warehouse) ||
                const DeepCollectionEquality()
                    .equals(other.warehouse, warehouse)) &&
            (identical(other.departmentId, departmentId) ||
                const DeepCollectionEquality()
                    .equals(other.departmentId, departmentId)) &&
            (identical(other.department, department) ||
                const DeepCollectionEquality()
                    .equals(other.department, department)) &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.deal, deal) ||
                const DeepCollectionEquality().equals(other.deal, deal)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.statusDate, statusDate) ||
                const DeepCollectionEquality()
                    .equals(other.statusDate, statusDate)) &&
            (identical(other.projectManagerId, projectManagerId) ||
                const DeepCollectionEquality()
                    .equals(other.projectManagerId, projectManagerId)) &&
            (identical(other.projectManager, projectManager) ||
                const DeepCollectionEquality()
                    .equals(other.projectManager, projectManager)) &&
            (identical(other.agentId, agentId) ||
                const DeepCollectionEquality()
                    .equals(other.agentId, agentId)) &&
            (identical(other.agent, agent) ||
                const DeepCollectionEquality().equals(other.agent, agent)) &&
            (identical(other.primaryContact, primaryContact) ||
                const DeepCollectionEquality()
                    .equals(other.primaryContact, primaryContact)) &&
            (identical(other.requestedBy, requestedBy) ||
                const DeepCollectionEquality()
                    .equals(other.requestedBy, requestedBy)) &&
            (identical(other.outsideSalesRepresentativeId, outsideSalesRepresentativeId) ||
                const DeepCollectionEquality().equals(
                    other.outsideSalesRepresentativeId,
                    outsideSalesRepresentativeId)) &&
            (identical(other.outsideSalesRepresentative, outsideSalesRepresentative) ||
                const DeepCollectionEquality().equals(
                    other.outsideSalesRepresentative,
                    outsideSalesRepresentative)) &&
            (identical(other.projectDescription, projectDescription) ||
                const DeepCollectionEquality()
                    .equals(other.projectDescription, projectDescription)) &&
            (identical(other.rental, rental) || const DeepCollectionEquality().equals(other.rental, rental)) &&
            (identical(other.sales, sales) || const DeepCollectionEquality().equals(other.sales, sales)) &&
            (identical(other.facilities, facilities) || const DeepCollectionEquality().equals(other.facilities, facilities)) &&
            (identical(other.labor, labor) || const DeepCollectionEquality().equals(other.labor, labor)) &&
            (identical(other.miscellaneous, miscellaneous) || const DeepCollectionEquality().equals(other.miscellaneous, miscellaneous)) &&
            (identical(other.transportation, transportation) || const DeepCollectionEquality().equals(other.transportation, transportation)) &&
            (identical(other.pickDate, pickDate) || const DeepCollectionEquality().equals(other.pickDate, pickDate)) &&
            (identical(other.pickTime, pickTime) || const DeepCollectionEquality().equals(other.pickTime, pickTime)) &&
            (identical(other.estimatedStartDate, estimatedStartDate) || const DeepCollectionEquality().equals(other.estimatedStartDate, estimatedStartDate)) &&
            (identical(other.estimatedStartTime, estimatedStartTime) || const DeepCollectionEquality().equals(other.estimatedStartTime, estimatedStartTime)) &&
            (identical(other.estimatedStopDate, estimatedStopDate) || const DeepCollectionEquality().equals(other.estimatedStopDate, estimatedStopDate)) &&
            (identical(other.estimatedStopTime, estimatedStopTime) || const DeepCollectionEquality().equals(other.estimatedStopTime, estimatedStopTime)) &&
            (identical(other.ccPrimaryApproverWhenEmailingBackupApprover, ccPrimaryApproverWhenEmailingBackupApprover) || const DeepCollectionEquality().equals(other.ccPrimaryApproverWhenEmailingBackupApprover, ccPrimaryApproverWhenEmailingBackupApprover)) &&
            (identical(other.inactive, inactive) || const DeepCollectionEquality().equals(other.inactive, inactive)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesAgentProjectProjectExtension
    on WebApiModulesAgentProjectProject {
  WebApiModulesAgentProjectProject copyWith(
      {String? projectId,
      String? projectNumber,
      String? project,
      String? officeLocationId,
      String? officeLocation,
      String? warehouseId,
      String? warehouse,
      String? departmentId,
      String? department,
      String? dealId,
      String? deal,
      String? status,
      String? statusDate,
      String? projectManagerId,
      String? projectManager,
      String? agentId,
      String? agent,
      String? primaryContact,
      String? requestedBy,
      String? outsideSalesRepresentativeId,
      String? outsideSalesRepresentative,
      String? projectDescription,
      bool? rental,
      bool? sales,
      bool? facilities,
      bool? labor,
      bool? miscellaneous,
      bool? transportation,
      String? pickDate,
      String? pickTime,
      String? estimatedStartDate,
      String? estimatedStartTime,
      String? estimatedStopDate,
      String? estimatedStopTime,
      bool? ccPrimaryApproverWhenEmailingBackupApprover,
      bool? inactive,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAgentProjectProject(
        projectId: projectId ?? this.projectId,
        projectNumber: projectNumber ?? this.projectNumber,
        project: project ?? this.project,
        officeLocationId: officeLocationId ?? this.officeLocationId,
        officeLocation: officeLocation ?? this.officeLocation,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouse: warehouse ?? this.warehouse,
        departmentId: departmentId ?? this.departmentId,
        department: department ?? this.department,
        dealId: dealId ?? this.dealId,
        deal: deal ?? this.deal,
        status: status ?? this.status,
        statusDate: statusDate ?? this.statusDate,
        projectManagerId: projectManagerId ?? this.projectManagerId,
        projectManager: projectManager ?? this.projectManager,
        agentId: agentId ?? this.agentId,
        agent: agent ?? this.agent,
        primaryContact: primaryContact ?? this.primaryContact,
        requestedBy: requestedBy ?? this.requestedBy,
        outsideSalesRepresentativeId:
            outsideSalesRepresentativeId ?? this.outsideSalesRepresentativeId,
        outsideSalesRepresentative:
            outsideSalesRepresentative ?? this.outsideSalesRepresentative,
        projectDescription: projectDescription ?? this.projectDescription,
        rental: rental ?? this.rental,
        sales: sales ?? this.sales,
        facilities: facilities ?? this.facilities,
        labor: labor ?? this.labor,
        miscellaneous: miscellaneous ?? this.miscellaneous,
        transportation: transportation ?? this.transportation,
        pickDate: pickDate ?? this.pickDate,
        pickTime: pickTime ?? this.pickTime,
        estimatedStartDate: estimatedStartDate ?? this.estimatedStartDate,
        estimatedStartTime: estimatedStartTime ?? this.estimatedStartTime,
        estimatedStopDate: estimatedStopDate ?? this.estimatedStopDate,
        estimatedStopTime: estimatedStopTime ?? this.estimatedStopTime,
        ccPrimaryApproverWhenEmailingBackupApprover:
            ccPrimaryApproverWhenEmailingBackupApprover ??
                this.ccPrimaryApproverWhenEmailingBackupApprover,
        inactive: inactive ?? this.inactive,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentProjectProjectDocument {
  WebApiModulesAgentProjectProjectDocument({
    this.projectId,
    this.copying,
    this.documentId,
    this.documentTypeId,
    this.uniqueId1,
    this.uniqueId2,
    this.uniqueId1Int,
    this.description,
    this.inputByUsersId,
    this.attachDate,
    this.attachTime,
    this.attachToEmail,
    this.inactive,
    this.dateStamp,
    this.extension,
    this.documentType,
    this.inputBy,
    this.hasImage,
    this.hasFile,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAgentProjectProjectDocument.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentProjectProjectDocumentFromJson(json);

  @JsonKey(name: 'ProjectId')
  final String? projectId;
  @JsonKey(name: 'copying')
  final bool? copying;
  @JsonKey(name: 'DocumentId')
  final String? documentId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'UniqueId1')
  final String? uniqueId1;
  @JsonKey(name: 'UniqueId2')
  final String? uniqueId2;
  @JsonKey(name: 'UniqueId1Int')
  final int? uniqueId1Int;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'InputByUsersId')
  final String? inputByUsersId;
  @JsonKey(name: 'AttachDate')
  final String? attachDate;
  @JsonKey(name: 'AttachTime')
  final String? attachTime;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'Extension')
  final String? extension;
  @JsonKey(name: 'DocumentType')
  final String? documentType;
  @JsonKey(name: 'InputBy')
  final String? inputBy;
  @JsonKey(name: 'HasImage')
  final bool? hasImage;
  @JsonKey(name: 'HasFile')
  final bool? hasFile;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesAgentProjectProjectDocumentFromJson;
  static const toJsonFactory = _$WebApiModulesAgentProjectProjectDocumentToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentProjectProjectDocumentToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentProjectProjectDocument &&
            (identical(other.projectId, projectId) ||
                const DeepCollectionEquality()
                    .equals(other.projectId, projectId)) &&
            (identical(other.copying, copying) ||
                const DeepCollectionEquality()
                    .equals(other.copying, copying)) &&
            (identical(other.documentId, documentId) ||
                const DeepCollectionEquality()
                    .equals(other.documentId, documentId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.uniqueId1, uniqueId1) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1, uniqueId1)) &&
            (identical(other.uniqueId2, uniqueId2) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId2, uniqueId2)) &&
            (identical(other.uniqueId1Int, uniqueId1Int) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1Int, uniqueId1Int)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.inputByUsersId, inputByUsersId) ||
                const DeepCollectionEquality()
                    .equals(other.inputByUsersId, inputByUsersId)) &&
            (identical(other.attachDate, attachDate) ||
                const DeepCollectionEquality()
                    .equals(other.attachDate, attachDate)) &&
            (identical(other.attachTime, attachTime) ||
                const DeepCollectionEquality()
                    .equals(other.attachTime, attachTime)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.extension, extension) ||
                const DeepCollectionEquality()
                    .equals(other.extension, extension)) &&
            (identical(other.documentType, documentType) ||
                const DeepCollectionEquality()
                    .equals(other.documentType, documentType)) &&
            (identical(other.inputBy, inputBy) ||
                const DeepCollectionEquality()
                    .equals(other.inputBy, inputBy)) &&
            (identical(other.hasImage, hasImage) ||
                const DeepCollectionEquality()
                    .equals(other.hasImage, hasImage)) &&
            (identical(other.hasFile, hasFile) ||
                const DeepCollectionEquality()
                    .equals(other.hasFile, hasFile)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality().equals(other.filePath, filePath)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesAgentProjectProjectDocumentExtension
    on WebApiModulesAgentProjectProjectDocument {
  WebApiModulesAgentProjectProjectDocument copyWith(
      {String? projectId,
      bool? copying,
      String? documentId,
      String? documentTypeId,
      String? uniqueId1,
      String? uniqueId2,
      int? uniqueId1Int,
      String? description,
      String? inputByUsersId,
      String? attachDate,
      String? attachTime,
      bool? attachToEmail,
      bool? inactive,
      String? dateStamp,
      String? extension,
      String? documentType,
      String? inputBy,
      bool? hasImage,
      bool? hasFile,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAgentProjectProjectDocument(
        projectId: projectId ?? this.projectId,
        copying: copying ?? this.copying,
        documentId: documentId ?? this.documentId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        uniqueId1: uniqueId1 ?? this.uniqueId1,
        uniqueId2: uniqueId2 ?? this.uniqueId2,
        uniqueId1Int: uniqueId1Int ?? this.uniqueId1Int,
        description: description ?? this.description,
        inputByUsersId: inputByUsersId ?? this.inputByUsersId,
        attachDate: attachDate ?? this.attachDate,
        attachTime: attachTime ?? this.attachTime,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        dateStamp: dateStamp ?? this.dateStamp,
        extension: extension ?? this.extension,
        documentType: documentType ?? this.documentType,
        inputBy: inputBy ?? this.inputBy,
        hasImage: hasImage ?? this.hasImage,
        hasFile: hasFile ?? this.hasFile,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentProjectProjectDocumentPostRequest {
  WebApiModulesAgentProjectProjectDocumentPostRequest({
    this.projectId,
    this.documentTypeId,
    this.description,
    this.attachToEmail,
    this.inactive,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
  });

  factory WebApiModulesAgentProjectProjectDocumentPostRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentProjectProjectDocumentPostRequestFromJson(json);

  @JsonKey(name: 'ProjectId')
  final String? projectId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  static const fromJsonFactory =
      _$WebApiModulesAgentProjectProjectDocumentPostRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentProjectProjectDocumentPostRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentProjectProjectDocumentPostRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentProjectProjectDocumentPostRequest &&
            (identical(other.projectId, projectId) ||
                const DeepCollectionEquality()
                    .equals(other.projectId, projectId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)));
  }
}

extension $WebApiModulesAgentProjectProjectDocumentPostRequestExtension
    on WebApiModulesAgentProjectProjectDocumentPostRequest {
  WebApiModulesAgentProjectProjectDocumentPostRequest copyWith(
      {String? projectId,
      String? documentTypeId,
      String? description,
      bool? attachToEmail,
      bool? inactive,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath}) {
    return WebApiModulesAgentProjectProjectDocumentPostRequest(
        projectId: projectId ?? this.projectId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        description: description ?? this.description,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentProjectProjectDocumentPutRequest {
  WebApiModulesAgentProjectProjectDocumentPutRequest({
    this.projectId,
    this.documentId,
    this.documentTypeId,
    this.description,
    this.attachToEmail,
    this.inactive,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
  });

  factory WebApiModulesAgentProjectProjectDocumentPutRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentProjectProjectDocumentPutRequestFromJson(json);

  @JsonKey(name: 'ProjectId')
  final String? projectId;
  @JsonKey(name: 'DocumentId')
  final String? documentId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  static const fromJsonFactory =
      _$WebApiModulesAgentProjectProjectDocumentPutRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentProjectProjectDocumentPutRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentProjectProjectDocumentPutRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentProjectProjectDocumentPutRequest &&
            (identical(other.projectId, projectId) ||
                const DeepCollectionEquality()
                    .equals(other.projectId, projectId)) &&
            (identical(other.documentId, documentId) ||
                const DeepCollectionEquality()
                    .equals(other.documentId, documentId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)));
  }
}

extension $WebApiModulesAgentProjectProjectDocumentPutRequestExtension
    on WebApiModulesAgentProjectProjectDocumentPutRequest {
  WebApiModulesAgentProjectProjectDocumentPutRequest copyWith(
      {String? projectId,
      String? documentId,
      String? documentTypeId,
      String? description,
      bool? attachToEmail,
      bool? inactive,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath}) {
    return WebApiModulesAgentProjectProjectDocumentPutRequest(
        projectId: projectId ?? this.projectId,
        documentId: documentId ?? this.documentId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        description: description ?? this.description,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentPurchaseOrderCompleteReceiveContractRequest {
  WebApiModulesAgentPurchaseOrderCompleteReceiveContractRequest({
    this.createOutContracts,
  });

  factory WebApiModulesAgentPurchaseOrderCompleteReceiveContractRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentPurchaseOrderCompleteReceiveContractRequestFromJson(
          json);

  @JsonKey(name: 'CreateOutContracts')
  final bool? createOutContracts;
  static const fromJsonFactory =
      _$WebApiModulesAgentPurchaseOrderCompleteReceiveContractRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentPurchaseOrderCompleteReceiveContractRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentPurchaseOrderCompleteReceiveContractRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentPurchaseOrderCompleteReceiveContractRequest &&
            (identical(other.createOutContracts, createOutContracts) ||
                const DeepCollectionEquality()
                    .equals(other.createOutContracts, createOutContracts)));
  }
}

extension $WebApiModulesAgentPurchaseOrderCompleteReceiveContractRequestExtension
    on WebApiModulesAgentPurchaseOrderCompleteReceiveContractRequest {
  WebApiModulesAgentPurchaseOrderCompleteReceiveContractRequest copyWith(
      {bool? createOutContracts}) {
    return WebApiModulesAgentPurchaseOrderCompleteReceiveContractRequest(
        createOutContracts: createOutContracts ?? this.createOutContracts);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentPurchaseOrderConfirmDropShipRequest {
  WebApiModulesAgentPurchaseOrderConfirmDropShipRequest({
    this.purchaseOrderId,
    this.deliveryId,
  });

  factory WebApiModulesAgentPurchaseOrderConfirmDropShipRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentPurchaseOrderConfirmDropShipRequestFromJson(json);

  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'DeliveryId')
  final String? deliveryId;
  static const fromJsonFactory =
      _$WebApiModulesAgentPurchaseOrderConfirmDropShipRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentPurchaseOrderConfirmDropShipRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentPurchaseOrderConfirmDropShipRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentPurchaseOrderConfirmDropShipRequest &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.deliveryId, deliveryId) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryId, deliveryId)));
  }
}

extension $WebApiModulesAgentPurchaseOrderConfirmDropShipRequestExtension
    on WebApiModulesAgentPurchaseOrderConfirmDropShipRequest {
  WebApiModulesAgentPurchaseOrderConfirmDropShipRequest copyWith(
      {String? purchaseOrderId, String? deliveryId}) {
    return WebApiModulesAgentPurchaseOrderConfirmDropShipRequest(
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        deliveryId: deliveryId ?? this.deliveryId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentPurchaseOrderConfirmDropShipResponse {
  WebApiModulesAgentPurchaseOrderConfirmDropShipResponse({
    this.receiveContractIds,
    this.outContractIds,
    this.status,
    this.success,
    this.msg,
    this.contracts,
  });

  factory WebApiModulesAgentPurchaseOrderConfirmDropShipResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentPurchaseOrderConfirmDropShipResponseFromJson(json);

  @JsonKey(name: 'ReceiveContractIds')
  final String? receiveContractIds;
  @JsonKey(name: 'OutContractIds')
  final String? outContractIds;
  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(
      name: 'Contracts',
      defaultValue: <WebApiModulesWarehouseContractContract>[])
  final List<WebApiModulesWarehouseContractContract>? contracts;
  static const fromJsonFactory =
      _$WebApiModulesAgentPurchaseOrderConfirmDropShipResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentPurchaseOrderConfirmDropShipResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentPurchaseOrderConfirmDropShipResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentPurchaseOrderConfirmDropShipResponse &&
            (identical(other.receiveContractIds, receiveContractIds) ||
                const DeepCollectionEquality()
                    .equals(other.receiveContractIds, receiveContractIds)) &&
            (identical(other.outContractIds, outContractIds) ||
                const DeepCollectionEquality()
                    .equals(other.outContractIds, outContractIds)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.contracts, contracts) ||
                const DeepCollectionEquality()
                    .equals(other.contracts, contracts)));
  }
}

extension $WebApiModulesAgentPurchaseOrderConfirmDropShipResponseExtension
    on WebApiModulesAgentPurchaseOrderConfirmDropShipResponse {
  WebApiModulesAgentPurchaseOrderConfirmDropShipResponse copyWith(
      {String? receiveContractIds,
      String? outContractIds,
      int? status,
      bool? success,
      String? msg,
      List<WebApiModulesWarehouseContractContract>? contracts}) {
    return WebApiModulesAgentPurchaseOrderConfirmDropShipResponse(
        receiveContractIds: receiveContractIds ?? this.receiveContractIds,
        outContractIds: outContractIds ?? this.outContractIds,
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        contracts: contracts ?? this.contracts);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveRequest {
  WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveRequest({
    this.purchaseOrderId,
    this.deliveryId,
  });

  factory WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveRequestFromJson(
          json);

  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'DeliveryId')
  final String? deliveryId;
  static const fromJsonFactory =
      _$WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveRequest &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.deliveryId, deliveryId) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryId, deliveryId)));
  }
}

extension $WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveRequestExtension
    on WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveRequest {
  WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveRequest copyWith(
      {String? purchaseOrderId, String? deliveryId}) {
    return WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveRequest(
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        deliveryId: deliveryId ?? this.deliveryId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveResponse {
  WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveResponse({
    this.returnContractIds,
    this.inContractIds,
    this.status,
    this.success,
    this.msg,
    this.contracts,
  });

  factory WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveResponseFromJson(
          json);

  @JsonKey(name: 'ReturnContractIds')
  final String? returnContractIds;
  @JsonKey(name: 'InContractIds')
  final String? inContractIds;
  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(
      name: 'Contracts',
      defaultValue: <WebApiModulesWarehouseContractContract>[])
  final List<WebApiModulesWarehouseContractContract>? contracts;
  static const fromJsonFactory =
      _$WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveResponse &&
            (identical(other.returnContractIds, returnContractIds) ||
                const DeepCollectionEquality()
                    .equals(other.returnContractIds, returnContractIds)) &&
            (identical(other.inContractIds, inContractIds) ||
                const DeepCollectionEquality()
                    .equals(other.inContractIds, inContractIds)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.contracts, contracts) ||
                const DeepCollectionEquality()
                    .equals(other.contracts, contracts)));
  }
}

extension $WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveResponseExtension
    on WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveResponse {
  WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveResponse copyWith(
      {String? returnContractIds,
      String? inContractIds,
      int? status,
      bool? success,
      String? msg,
      List<WebApiModulesWarehouseContractContract>? contracts}) {
    return WebApiModulesAgentPurchaseOrderConfirmVendorRetrieveResponse(
        returnContractIds: returnContractIds ?? this.returnContractIds,
        inContractIds: inContractIds ?? this.inContractIds,
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        contracts: contracts ?? this.contracts);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentPurchaseOrderCopyPurchaseOrderRequest {
  WebApiModulesAgentPurchaseOrderCopyPurchaseOrderRequest({
    this.purchaseOrderId,
    this.locationId,
    this.warehouseId,
  });

  factory WebApiModulesAgentPurchaseOrderCopyPurchaseOrderRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentPurchaseOrderCopyPurchaseOrderRequestFromJson(json);

  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'LocationId')
  final String? locationId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  static const fromJsonFactory =
      _$WebApiModulesAgentPurchaseOrderCopyPurchaseOrderRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentPurchaseOrderCopyPurchaseOrderRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentPurchaseOrderCopyPurchaseOrderRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentPurchaseOrderCopyPurchaseOrderRequest &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.locationId, locationId) ||
                const DeepCollectionEquality()
                    .equals(other.locationId, locationId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)));
  }
}

extension $WebApiModulesAgentPurchaseOrderCopyPurchaseOrderRequestExtension
    on WebApiModulesAgentPurchaseOrderCopyPurchaseOrderRequest {
  WebApiModulesAgentPurchaseOrderCopyPurchaseOrderRequest copyWith(
      {String? purchaseOrderId, String? locationId, String? warehouseId}) {
    return WebApiModulesAgentPurchaseOrderCopyPurchaseOrderRequest(
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        locationId: locationId ?? this.locationId,
        warehouseId: warehouseId ?? this.warehouseId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentPurchaseOrderCopyPurchaseOrderResponse {
  WebApiModulesAgentPurchaseOrderCopyPurchaseOrderResponse({
    this.status,
    this.success,
    this.msg,
    this.purchaseOrder,
  });

  factory WebApiModulesAgentPurchaseOrderCopyPurchaseOrderResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentPurchaseOrderCopyPurchaseOrderResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'PurchaseOrder')
  final WebApiModulesAgentPurchaseOrderPurchaseOrder? purchaseOrder;
  static const fromJsonFactory =
      _$WebApiModulesAgentPurchaseOrderCopyPurchaseOrderResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentPurchaseOrderCopyPurchaseOrderResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentPurchaseOrderCopyPurchaseOrderResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentPurchaseOrderCopyPurchaseOrderResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.purchaseOrder, purchaseOrder) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrder, purchaseOrder)));
  }
}

extension $WebApiModulesAgentPurchaseOrderCopyPurchaseOrderResponseExtension
    on WebApiModulesAgentPurchaseOrderCopyPurchaseOrderResponse {
  WebApiModulesAgentPurchaseOrderCopyPurchaseOrderResponse copyWith(
      {int? status,
      bool? success,
      String? msg,
      WebApiModulesAgentPurchaseOrderPurchaseOrder? purchaseOrder}) {
    return WebApiModulesAgentPurchaseOrderCopyPurchaseOrderResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        purchaseOrder: purchaseOrder ?? this.purchaseOrder);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentPurchaseOrderGetPurchaseOrderResponse {
  WebApiModulesAgentPurchaseOrderGetPurchaseOrderResponse({
    this.purchaseOrderId,
    this.purchaseOrderNumber,
    this.description,
    this.purchaseOrderDate,
    this.requisitionNumber,
    this.requisitionDate,
    this.vendorId,
    this.vendor,
    this.agentId,
    this.agent,
    this.status,
    this.statusDate,
    this.referenceNumber,
    this.needsApproval,
    this.approvedByUserId,
    this.departmentId,
    this.department,
    this.officeLocationId,
    this.officeLocation,
    this.warehouseId,
    this.warehouse,
    this.warehouseCode,
    this.quantityHolding,
    this.quantityToBarCode,
    this.rental,
    this.sales,
    this.parts,
    this.labor,
    this.miscellaneous,
    this.vehicle,
    this.subRent,
    this.subSale,
    this.subLabor,
    this.subMiscellaneous,
    this.subVehicle,
    this.repair,
    this.consignment,
    this.consignorAgreementId,
    this.consignorAgreementNumber,
    this.orderId,
    this.orderNumber,
    this.dealNumber,
    this.dealId,
    this.deal,
    this.rateType,
    this.departmentLocationRequiresApproval,
    this.total,
    this.poTypeId,
    this.poType,
    this.poClassificationId,
    this.poClassification,
    this.activityDatesAndTimes,
    this.estimatedStartDate,
    this.estimatedStartTime,
    this.estimatedStopDate,
    this.estimatedStopTime,
    this.billingStartDate,
    this.billingEndDate,
    this.billingWeeks,
    this.billingMonths,
    this.invoicedAmount,
    this.projectManagerId,
    this.projectManager,
    this.receiveDeliveryId,
    this.receiveDeliveryDeliveryType,
    this.receiveDeliveryRequiredDate,
    this.receiveDeliveryRequiredTime,
    this.receiveDeliveryTargetShipDate,
    this.receiveDeliveryTargetShipTime,
    this.receiveDeliveryDirection,
    this.receiveDeliveryAddressType,
    this.receiveDeliveryFromLocation,
    this.receiveDeliveryFromContact,
    this.receiveDeliveryFromContactPhone,
    this.receiveDeliveryFromAlternateContact,
    this.receiveDeliveryFromAlternateContactPhone,
    this.receiveDeliveryFromAttention,
    this.receiveDeliveryFromAddress1,
    this.receiveDeliveryFromAdd2ress,
    this.receiveDeliveryFromCity,
    this.receiveDeliveryFromState,
    this.receiveDeliveryFromZipCode,
    this.receiveDeliveryFromCountry,
    this.receiveDeliveryFromCountryId,
    this.receiveDeliveryFromCrossStreets,
    this.receiveDeliveryToLocation,
    this.receiveDeliveryToVenue,
    this.receiveDeliveryToVenueId,
    this.receiveDeliveryToWarehouse,
    this.receiveDeliveryToWarehouseId,
    this.receiveDeliveryToContact,
    this.receiveDeliveryToContactPhone,
    this.receiveDeliveryToAlternateContact,
    this.receiveDeliveryToAlternateContactPhone,
    this.receiveDeliveryToAttention,
    this.receiveDeliveryToAddress1,
    this.receiveDeliveryToAddress2,
    this.receiveDeliveryToCity,
    this.receiveDeliveryToState,
    this.receiveDeliveryToZipCode,
    this.receiveDeliveryToCountryId,
    this.receiveDeliveryToCountry,
    this.receiveDeliveryToContactFax,
    this.receiveDeliveryToCrossStreets,
    this.receiveDeliveryDeliveryNotes,
    this.receiveDeliveryCarrierId,
    this.receiveDeliveryCarrier,
    this.receiveDeliveryCarrierAccount,
    this.receiveDeliveryShipViaId,
    this.receiveDeliveryShipVia,
    this.receiveDeliveryInvoiceId,
    this.receiveDeliveryVendorInvoiceId,
    this.receiveDeliveryEstimatedFreight,
    this.receiveDeliveryFreightInvoiceAmount,
    this.receiveDeliveryChargeType,
    this.receiveDeliveryFreightTrackingNumber,
    this.receiveDeliveryFreightTrackingUrl,
    this.receiveDeliveryDropShip,
    this.receiveDeliveryPackageCode,
    this.receiveDeliveryBillPoFreightOnOrder,
    this.receiveDeliveryOnlineOrderNumber,
    this.receiveDeliveryOnlineOrderStatus,
    this.receiveDeliveryDateStamp,
    this.returnDeliveryId,
    this.returnDeliveryDeliveryType,
    this.returnDeliveryRequiredDate,
    this.returnDeliveryRequiredTime,
    this.returnDeliveryTargetShipDate,
    this.returnDeliveryTargetShipTime,
    this.returnDeliveryDirection,
    this.returnDeliveryAddressType,
    this.returnDeliveryFromLocation,
    this.returnDeliveryFromContact,
    this.returnDeliveryFromContactPhone,
    this.returnDeliveryFromAlternateContact,
    this.returnDeliveryFromAlternateContactPhone,
    this.returnDeliveryFromAttention,
    this.returnDeliveryFromAddress1,
    this.returnDeliveryFromAdd2ress,
    this.returnDeliveryFromCity,
    this.returnDeliveryFromState,
    this.returnDeliveryFromZipCode,
    this.returnDeliveryFromCountry,
    this.returnDeliveryFromCountryId,
    this.returnDeliveryFromCrossStreets,
    this.returnDeliveryToLocation,
    this.returnDeliveryToVenue,
    this.returnDeliveryToVenueId,
    this.returnDeliveryToWarehouse,
    this.returnDeliveryToWarehouseId,
    this.returnDeliveryToContact,
    this.returnDeliveryToContactPhone,
    this.returnDeliveryToAlternateContact,
    this.returnDeliveryToAlternateContactPhone,
    this.returnDeliveryToAttention,
    this.returnDeliveryToAddress1,
    this.returnDeliveryToAddress2,
    this.returnDeliveryToCity,
    this.returnDeliveryToState,
    this.returnDeliveryToZipCode,
    this.returnDeliveryToCountryId,
    this.returnDeliveryToCountry,
    this.returnDeliveryToContactFax,
    this.returnDeliveryToCrossStreets,
    this.returnDeliveryDeliveryNotes,
    this.returnDeliveryCarrierId,
    this.returnDeliveryCarrier,
    this.returnDeliveryCarrierAccount,
    this.returnDeliveryShipViaId,
    this.returnDeliveryShipVia,
    this.returnDeliveryInvoiceId,
    this.returnDeliveryVendorInvoiceId,
    this.returnDeliveryEstimatedFreight,
    this.returnDeliveryFreightInvoiceAmount,
    this.returnDeliveryChargeType,
    this.returnDeliveryFreightTrackingNumber,
    this.returnDeliveryFreightTrackingUrl,
    this.returnDeliveryVendorRetrieve,
    this.returnDeliveryPackageCode,
    this.returnDeliveryBillPoFreightOnOrder,
    this.returnDeliveryOnlineOrderNumber,
    this.returnDeliveryOnlineOrderStatus,
    this.returnDeliveryDateStamp,
    this.enableProjects,
    this.projectId,
    this.projectNumber,
    this.project,
    this.projectDrawingsId,
    this.projectDrawings,
    this.projectItemsOrderedId,
    this.projectItemsOrdered,
    this.projectDropShipId,
    this.projectDropShip,
    this.projectAsBuildId,
    this.projectAsBuild,
    this.projectCommissioningId,
    this.projectCommissioning,
    this.projectDepositId,
    this.projectDeposit,
    this.location,
    this.currencyId,
    this.updateAllRatesToNewCurrency,
    this.confirmUpdateAllRatesToNewCurrency,
    this.currencyCode,
    this.currency,
    this.currencySymbol,
    this.billingCycleId,
    this.billingCycle,
    this.remitToAttention1,
    this.remitToAttention2,
    this.remitToAddress1,
    this.remitToAddress2,
    this.remitToCity,
    this.remitToState,
    this.remitToCountryId,
    this.remitToCountry,
    this.remitToZipCode,
    this.remitToEmail,
    this.remitToPhone,
    this.paymentTypeId,
    this.paymentType,
    this.paymentTermsId,
    this.paymentTerms,
    this.paymentTermsDueInDays,
    this.taxOptionId,
    this.taxOption,
    this.taxId,
    this.tax1Name,
    this.tax2Name,
    this.rentalTaxRate1,
    this.salesTaxRate1,
    this.laborTaxRate1,
    this.rentalTaxRate2,
    this.salesTaxRate2,
    this.laborTaxRate2,
    this.hasRentalItem,
    this.hasSalesItem,
    this.hasMiscellaneousItem,
    this.hasLaborItem,
    this.hasFacilitiesItem,
    this.hasLossAndDamageItem,
    this.hasRentalSaleItem,
    this.hasPartsItem,
    this.rentalDiscountPercent,
    this.rentalTotal,
    this.rentalTotalIncludesTax,
    this.salesDiscountPercent,
    this.salesTotal,
    this.salesTotalIncludesTax,
    this.partsDiscountPercent,
    this.partsTotal,
    this.partsTotalIncludesTax,
    this.vehicleDiscountPercent,
    this.vehicleTotal,
    this.vehicleTotalIncludesTax,
    this.miscDiscountPercent,
    this.miscTotal,
    this.miscTotalIncludesTax,
    this.laborDiscountPercent,
    this.laborTotal,
    this.laborTotalIncludesTax,
    this.subRentalDaysPerWeek,
    this.subRentalDiscountPercent,
    this.weeklySubRentalTotal,
    this.monthlySubRentalTotal,
    this.periodSubRentalTotal,
    this.weeklySubRentalTotalIncludesTax,
    this.monthlySubRentalTotalIncludesTax,
    this.periodSubRentalTotalIncludesTax,
    this.subSalesDiscountPercent,
    this.subSalesTotal,
    this.subSalesTotalIncludesTax,
    this.subVehicleDaysPerWeek,
    this.subvehicleDiscountPercent,
    this.weeklySubVehicleTotal,
    this.monthlySubVehicleTotal,
    this.periodSubVehicleTotal,
    this.weeklySubVehicleTotalIncludesTax,
    this.monthlySubVehicleTotalIncludesTax,
    this.periodSubVehicleTotalIncludesTax,
    this.subMiscDiscountPercent,
    this.weeklySubMiscTotal,
    this.monthlySubMiscTotal,
    this.periodSubMiscTotal,
    this.weeklySubMiscTotalIncludesTax,
    this.monthlySubMiscTotalIncludesTax,
    this.periodSubMiscTotalIncludesTax,
    this.subLaborDiscountPercent,
    this.weeklySubLaborTotal,
    this.monthlySubLaborTotal,
    this.periodSubLaborTotal,
    this.weeklySubLaborTotalIncludesTax,
    this.monthlySubLaborTotalIncludesTax,
    this.periodSubLaborTotalIncludesTax,
    this.miscellaneousIsComplete,
    this.subMiscellaneousIsComplete,
    this.laborIsComplete,
    this.subLaborIsComplete,
    this.currencyColor,
    this.statusColor,
    this.purchaseOrderNumberColor,
    this.vendorColor,
    this.descriptionColor,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.items,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAgentPurchaseOrderGetPurchaseOrderResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentPurchaseOrderGetPurchaseOrderResponseFromJson(json);

  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'PurchaseOrderNumber')
  final String? purchaseOrderNumber;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'PurchaseOrderDate')
  final String? purchaseOrderDate;
  @JsonKey(name: 'RequisitionNumber')
  final String? requisitionNumber;
  @JsonKey(name: 'RequisitionDate')
  final String? requisitionDate;
  @JsonKey(name: 'VendorId')
  final String? vendorId;
  @JsonKey(name: 'Vendor')
  final String? vendor;
  @JsonKey(name: 'AgentId')
  final String? agentId;
  @JsonKey(name: 'Agent')
  final String? agent;
  @JsonKey(name: 'Status')
  final String? status;
  @JsonKey(name: 'StatusDate')
  final String? statusDate;
  @JsonKey(name: 'ReferenceNumber')
  final String? referenceNumber;
  @JsonKey(name: 'NeedsApproval')
  final bool? needsApproval;
  @JsonKey(name: 'ApprovedByUserId')
  final String? approvedByUserId;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'Department')
  final String? department;
  @JsonKey(name: 'OfficeLocationId')
  final String? officeLocationId;
  @JsonKey(name: 'OfficeLocation')
  final String? officeLocation;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'QuantityHolding')
  final int? quantityHolding;
  @JsonKey(name: 'QuantityToBarCode')
  final int? quantityToBarCode;
  @JsonKey(name: 'Rental')
  final bool? rental;
  @JsonKey(name: 'Sales')
  final bool? sales;
  @JsonKey(name: 'Parts')
  final bool? parts;
  @JsonKey(name: 'Labor')
  final bool? labor;
  @JsonKey(name: 'Miscellaneous')
  final bool? miscellaneous;
  @JsonKey(name: 'Vehicle')
  final bool? vehicle;
  @JsonKey(name: 'SubRent')
  final bool? subRent;
  @JsonKey(name: 'SubSale')
  final bool? subSale;
  @JsonKey(name: 'SubLabor')
  final bool? subLabor;
  @JsonKey(name: 'SubMiscellaneous')
  final bool? subMiscellaneous;
  @JsonKey(name: 'SubVehicle')
  final bool? subVehicle;
  @JsonKey(name: 'Repair')
  final bool? repair;
  @JsonKey(name: 'Consignment')
  final bool? consignment;
  @JsonKey(name: 'ConsignorAgreementId')
  final String? consignorAgreementId;
  @JsonKey(name: 'ConsignorAgreementNumber')
  final String? consignorAgreementNumber;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderNumber')
  final String? orderNumber;
  @JsonKey(name: 'DealNumber')
  final String? dealNumber;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'Deal')
  final String? deal;
  @JsonKey(name: 'RateType')
  final String? rateType;
  @JsonKey(name: 'DepartmentLocationRequiresApproval')
  final bool? departmentLocationRequiresApproval;
  @JsonKey(name: 'Total')
  final double? total;
  @JsonKey(name: 'PoTypeId')
  final String? poTypeId;
  @JsonKey(name: 'PoType')
  final String? poType;
  @JsonKey(name: 'PoClassificationId')
  final String? poClassificationId;
  @JsonKey(name: 'PoClassification')
  final String? poClassification;
  @JsonKey(
      name: 'ActivityDatesAndTimes',
      defaultValue: <WebApiModulesHomeControlsOrderDatesOrderDates>[])
  final List<WebApiModulesHomeControlsOrderDatesOrderDates>?
      activityDatesAndTimes;
  @JsonKey(name: 'EstimatedStartDate')
  final String? estimatedStartDate;
  @JsonKey(name: 'EstimatedStartTime')
  final String? estimatedStartTime;
  @JsonKey(name: 'EstimatedStopDate')
  final String? estimatedStopDate;
  @JsonKey(name: 'EstimatedStopTime')
  final String? estimatedStopTime;
  @JsonKey(name: 'BillingStartDate')
  final String? billingStartDate;
  @JsonKey(name: 'BillingEndDate')
  final String? billingEndDate;
  @JsonKey(name: 'BillingWeeks')
  final double? billingWeeks;
  @JsonKey(name: 'BillingMonths')
  final double? billingMonths;
  @JsonKey(name: 'InvoicedAmount')
  final double? invoicedAmount;
  @JsonKey(name: 'ProjectManagerId')
  final String? projectManagerId;
  @JsonKey(name: 'ProjectManager')
  final String? projectManager;
  @JsonKey(name: 'ReceiveDeliveryId')
  final String? receiveDeliveryId;
  @JsonKey(name: 'ReceiveDeliveryDeliveryType')
  final String? receiveDeliveryDeliveryType;
  @JsonKey(name: 'ReceiveDeliveryRequiredDate')
  final String? receiveDeliveryRequiredDate;
  @JsonKey(name: 'ReceiveDeliveryRequiredTime')
  final String? receiveDeliveryRequiredTime;
  @JsonKey(name: 'ReceiveDeliveryTargetShipDate')
  final String? receiveDeliveryTargetShipDate;
  @JsonKey(name: 'ReceiveDeliveryTargetShipTime')
  final String? receiveDeliveryTargetShipTime;
  @JsonKey(name: 'ReceiveDeliveryDirection')
  final String? receiveDeliveryDirection;
  @JsonKey(name: 'ReceiveDeliveryAddressType')
  final String? receiveDeliveryAddressType;
  @JsonKey(name: 'ReceiveDeliveryFromLocation')
  final String? receiveDeliveryFromLocation;
  @JsonKey(name: 'ReceiveDeliveryFromContact')
  final String? receiveDeliveryFromContact;
  @JsonKey(name: 'ReceiveDeliveryFromContactPhone')
  final String? receiveDeliveryFromContactPhone;
  @JsonKey(name: 'ReceiveDeliveryFromAlternateContact')
  final String? receiveDeliveryFromAlternateContact;
  @JsonKey(name: 'ReceiveDeliveryFromAlternateContactPhone')
  final String? receiveDeliveryFromAlternateContactPhone;
  @JsonKey(name: 'ReceiveDeliveryFromAttention')
  final String? receiveDeliveryFromAttention;
  @JsonKey(name: 'ReceiveDeliveryFromAddress1')
  final String? receiveDeliveryFromAddress1;
  @JsonKey(name: 'ReceiveDeliveryFromAdd2ress')
  final String? receiveDeliveryFromAdd2ress;
  @JsonKey(name: 'ReceiveDeliveryFromCity')
  final String? receiveDeliveryFromCity;
  @JsonKey(name: 'ReceiveDeliveryFromState')
  final String? receiveDeliveryFromState;
  @JsonKey(name: 'ReceiveDeliveryFromZipCode')
  final String? receiveDeliveryFromZipCode;
  @JsonKey(name: 'ReceiveDeliveryFromCountry')
  final String? receiveDeliveryFromCountry;
  @JsonKey(name: 'ReceiveDeliveryFromCountryId')
  final String? receiveDeliveryFromCountryId;
  @JsonKey(name: 'ReceiveDeliveryFromCrossStreets')
  final String? receiveDeliveryFromCrossStreets;
  @JsonKey(name: 'ReceiveDeliveryToLocation')
  final String? receiveDeliveryToLocation;
  @JsonKey(name: 'ReceiveDeliveryToVenue')
  final String? receiveDeliveryToVenue;
  @JsonKey(name: 'ReceiveDeliveryToVenueId')
  final String? receiveDeliveryToVenueId;
  @JsonKey(name: 'ReceiveDeliveryToWarehouse')
  final String? receiveDeliveryToWarehouse;
  @JsonKey(name: 'ReceiveDeliveryToWarehouseId')
  final String? receiveDeliveryToWarehouseId;
  @JsonKey(name: 'ReceiveDeliveryToContact')
  final String? receiveDeliveryToContact;
  @JsonKey(name: 'ReceiveDeliveryToContactPhone')
  final String? receiveDeliveryToContactPhone;
  @JsonKey(name: 'ReceiveDeliveryToAlternateContact')
  final String? receiveDeliveryToAlternateContact;
  @JsonKey(name: 'ReceiveDeliveryToAlternateContactPhone')
  final String? receiveDeliveryToAlternateContactPhone;
  @JsonKey(name: 'ReceiveDeliveryToAttention')
  final String? receiveDeliveryToAttention;
  @JsonKey(name: 'ReceiveDeliveryToAddress1')
  final String? receiveDeliveryToAddress1;
  @JsonKey(name: 'ReceiveDeliveryToAddress2')
  final String? receiveDeliveryToAddress2;
  @JsonKey(name: 'ReceiveDeliveryToCity')
  final String? receiveDeliveryToCity;
  @JsonKey(name: 'ReceiveDeliveryToState')
  final String? receiveDeliveryToState;
  @JsonKey(name: 'ReceiveDeliveryToZipCode')
  final String? receiveDeliveryToZipCode;
  @JsonKey(name: 'ReceiveDeliveryToCountryId')
  final String? receiveDeliveryToCountryId;
  @JsonKey(name: 'ReceiveDeliveryToCountry')
  final String? receiveDeliveryToCountry;
  @JsonKey(name: 'ReceiveDeliveryToContactFax')
  final String? receiveDeliveryToContactFax;
  @JsonKey(name: 'ReceiveDeliveryToCrossStreets')
  final String? receiveDeliveryToCrossStreets;
  @JsonKey(name: 'ReceiveDeliveryDeliveryNotes')
  final String? receiveDeliveryDeliveryNotes;
  @JsonKey(name: 'ReceiveDeliveryCarrierId')
  final String? receiveDeliveryCarrierId;
  @JsonKey(name: 'ReceiveDeliveryCarrier')
  final String? receiveDeliveryCarrier;
  @JsonKey(name: 'ReceiveDeliveryCarrierAccount')
  final String? receiveDeliveryCarrierAccount;
  @JsonKey(name: 'ReceiveDeliveryShipViaId')
  final String? receiveDeliveryShipViaId;
  @JsonKey(name: 'ReceiveDeliveryShipVia')
  final String? receiveDeliveryShipVia;
  @JsonKey(name: 'ReceiveDeliveryInvoiceId')
  final String? receiveDeliveryInvoiceId;
  @JsonKey(name: 'ReceiveDeliveryVendorInvoiceId')
  final String? receiveDeliveryVendorInvoiceId;
  @JsonKey(name: 'ReceiveDeliveryEstimatedFreight')
  final double? receiveDeliveryEstimatedFreight;
  @JsonKey(name: 'ReceiveDeliveryFreightInvoiceAmount')
  final double? receiveDeliveryFreightInvoiceAmount;
  @JsonKey(name: 'ReceiveDeliveryChargeType')
  final String? receiveDeliveryChargeType;
  @JsonKey(name: 'ReceiveDeliveryFreightTrackingNumber')
  final String? receiveDeliveryFreightTrackingNumber;
  @JsonKey(name: 'ReceiveDeliveryFreightTrackingUrl')
  final String? receiveDeliveryFreightTrackingUrl;
  @JsonKey(name: 'ReceiveDeliveryDropShip')
  final bool? receiveDeliveryDropShip;
  @JsonKey(name: 'ReceiveDeliveryPackageCode')
  final String? receiveDeliveryPackageCode;
  @JsonKey(name: 'ReceiveDeliveryBillPoFreightOnOrder')
  final bool? receiveDeliveryBillPoFreightOnOrder;
  @JsonKey(name: 'ReceiveDeliveryOnlineOrderNumber')
  final String? receiveDeliveryOnlineOrderNumber;
  @JsonKey(name: 'ReceiveDeliveryOnlineOrderStatus')
  final String? receiveDeliveryOnlineOrderStatus;
  @JsonKey(name: 'ReceiveDeliveryDateStamp')
  final String? receiveDeliveryDateStamp;
  @JsonKey(name: 'ReturnDeliveryId')
  final String? returnDeliveryId;
  @JsonKey(name: 'ReturnDeliveryDeliveryType')
  final String? returnDeliveryDeliveryType;
  @JsonKey(name: 'ReturnDeliveryRequiredDate')
  final String? returnDeliveryRequiredDate;
  @JsonKey(name: 'ReturnDeliveryRequiredTime')
  final String? returnDeliveryRequiredTime;
  @JsonKey(name: 'ReturnDeliveryTargetShipDate')
  final String? returnDeliveryTargetShipDate;
  @JsonKey(name: 'ReturnDeliveryTargetShipTime')
  final String? returnDeliveryTargetShipTime;
  @JsonKey(name: 'ReturnDeliveryDirection')
  final String? returnDeliveryDirection;
  @JsonKey(name: 'ReturnDeliveryAddressType')
  final String? returnDeliveryAddressType;
  @JsonKey(name: 'ReturnDeliveryFromLocation')
  final String? returnDeliveryFromLocation;
  @JsonKey(name: 'ReturnDeliveryFromContact')
  final String? returnDeliveryFromContact;
  @JsonKey(name: 'ReturnDeliveryFromContactPhone')
  final String? returnDeliveryFromContactPhone;
  @JsonKey(name: 'ReturnDeliveryFromAlternateContact')
  final String? returnDeliveryFromAlternateContact;
  @JsonKey(name: 'ReturnDeliveryFromAlternateContactPhone')
  final String? returnDeliveryFromAlternateContactPhone;
  @JsonKey(name: 'ReturnDeliveryFromAttention')
  final String? returnDeliveryFromAttention;
  @JsonKey(name: 'ReturnDeliveryFromAddress1')
  final String? returnDeliveryFromAddress1;
  @JsonKey(name: 'ReturnDeliveryFromAdd2ress')
  final String? returnDeliveryFromAdd2ress;
  @JsonKey(name: 'ReturnDeliveryFromCity')
  final String? returnDeliveryFromCity;
  @JsonKey(name: 'ReturnDeliveryFromState')
  final String? returnDeliveryFromState;
  @JsonKey(name: 'ReturnDeliveryFromZipCode')
  final String? returnDeliveryFromZipCode;
  @JsonKey(name: 'ReturnDeliveryFromCountry')
  final String? returnDeliveryFromCountry;
  @JsonKey(name: 'ReturnDeliveryFromCountryId')
  final String? returnDeliveryFromCountryId;
  @JsonKey(name: 'ReturnDeliveryFromCrossStreets')
  final String? returnDeliveryFromCrossStreets;
  @JsonKey(name: 'ReturnDeliveryToLocation')
  final String? returnDeliveryToLocation;
  @JsonKey(name: 'ReturnDeliveryToVenue')
  final String? returnDeliveryToVenue;
  @JsonKey(name: 'ReturnDeliveryToVenueId')
  final String? returnDeliveryToVenueId;
  @JsonKey(name: 'ReturnDeliveryToWarehouse')
  final String? returnDeliveryToWarehouse;
  @JsonKey(name: 'ReturnDeliveryToWarehouseId')
  final String? returnDeliveryToWarehouseId;
  @JsonKey(name: 'ReturnDeliveryToContact')
  final String? returnDeliveryToContact;
  @JsonKey(name: 'ReturnDeliveryToContactPhone')
  final String? returnDeliveryToContactPhone;
  @JsonKey(name: 'ReturnDeliveryToAlternateContact')
  final String? returnDeliveryToAlternateContact;
  @JsonKey(name: 'ReturnDeliveryToAlternateContactPhone')
  final String? returnDeliveryToAlternateContactPhone;
  @JsonKey(name: 'ReturnDeliveryToAttention')
  final String? returnDeliveryToAttention;
  @JsonKey(name: 'ReturnDeliveryToAddress1')
  final String? returnDeliveryToAddress1;
  @JsonKey(name: 'ReturnDeliveryToAddress2')
  final String? returnDeliveryToAddress2;
  @JsonKey(name: 'ReturnDeliveryToCity')
  final String? returnDeliveryToCity;
  @JsonKey(name: 'ReturnDeliveryToState')
  final String? returnDeliveryToState;
  @JsonKey(name: 'ReturnDeliveryToZipCode')
  final String? returnDeliveryToZipCode;
  @JsonKey(name: 'ReturnDeliveryToCountryId')
  final String? returnDeliveryToCountryId;
  @JsonKey(name: 'ReturnDeliveryToCountry')
  final String? returnDeliveryToCountry;
  @JsonKey(name: 'ReturnDeliveryToContactFax')
  final String? returnDeliveryToContactFax;
  @JsonKey(name: 'ReturnDeliveryToCrossStreets')
  final String? returnDeliveryToCrossStreets;
  @JsonKey(name: 'ReturnDeliveryDeliveryNotes')
  final String? returnDeliveryDeliveryNotes;
  @JsonKey(name: 'ReturnDeliveryCarrierId')
  final String? returnDeliveryCarrierId;
  @JsonKey(name: 'ReturnDeliveryCarrier')
  final String? returnDeliveryCarrier;
  @JsonKey(name: 'ReturnDeliveryCarrierAccount')
  final String? returnDeliveryCarrierAccount;
  @JsonKey(name: 'ReturnDeliveryShipViaId')
  final String? returnDeliveryShipViaId;
  @JsonKey(name: 'ReturnDeliveryShipVia')
  final String? returnDeliveryShipVia;
  @JsonKey(name: 'ReturnDeliveryInvoiceId')
  final String? returnDeliveryInvoiceId;
  @JsonKey(name: 'ReturnDeliveryVendorInvoiceId')
  final String? returnDeliveryVendorInvoiceId;
  @JsonKey(name: 'ReturnDeliveryEstimatedFreight')
  final double? returnDeliveryEstimatedFreight;
  @JsonKey(name: 'ReturnDeliveryFreightInvoiceAmount')
  final double? returnDeliveryFreightInvoiceAmount;
  @JsonKey(name: 'ReturnDeliveryChargeType')
  final String? returnDeliveryChargeType;
  @JsonKey(name: 'ReturnDeliveryFreightTrackingNumber')
  final String? returnDeliveryFreightTrackingNumber;
  @JsonKey(name: 'ReturnDeliveryFreightTrackingUrl')
  final String? returnDeliveryFreightTrackingUrl;
  @JsonKey(name: 'ReturnDeliveryVendorRetrieve')
  final bool? returnDeliveryVendorRetrieve;
  @JsonKey(name: 'ReturnDeliveryPackageCode')
  final String? returnDeliveryPackageCode;
  @JsonKey(name: 'ReturnDeliveryBillPoFreightOnOrder')
  final bool? returnDeliveryBillPoFreightOnOrder;
  @JsonKey(name: 'ReturnDeliveryOnlineOrderNumber')
  final String? returnDeliveryOnlineOrderNumber;
  @JsonKey(name: 'ReturnDeliveryOnlineOrderStatus')
  final String? returnDeliveryOnlineOrderStatus;
  @JsonKey(name: 'ReturnDeliveryDateStamp')
  final String? returnDeliveryDateStamp;
  @JsonKey(name: 'EnableProjects')
  final bool? enableProjects;
  @JsonKey(name: 'ProjectId')
  final String? projectId;
  @JsonKey(name: 'ProjectNumber')
  final String? projectNumber;
  @JsonKey(name: 'Project')
  final String? project;
  @JsonKey(name: 'ProjectDrawingsId')
  final String? projectDrawingsId;
  @JsonKey(name: 'ProjectDrawings')
  final String? projectDrawings;
  @JsonKey(name: 'ProjectItemsOrderedId')
  final String? projectItemsOrderedId;
  @JsonKey(name: 'ProjectItemsOrdered')
  final String? projectItemsOrdered;
  @JsonKey(name: 'ProjectDropShipId')
  final String? projectDropShipId;
  @JsonKey(name: 'ProjectDropShip')
  final String? projectDropShip;
  @JsonKey(name: 'ProjectAsBuildId')
  final String? projectAsBuildId;
  @JsonKey(name: 'ProjectAsBuild')
  final String? projectAsBuild;
  @JsonKey(name: 'ProjectCommissioningId')
  final String? projectCommissioningId;
  @JsonKey(name: 'ProjectCommissioning')
  final String? projectCommissioning;
  @JsonKey(name: 'ProjectDepositId')
  final String? projectDepositId;
  @JsonKey(name: 'ProjectDeposit')
  final String? projectDeposit;
  @JsonKey(name: 'Location')
  final String? location;
  @JsonKey(name: 'CurrencyId')
  final String? currencyId;
  @JsonKey(name: 'UpdateAllRatesToNewCurrency')
  final bool? updateAllRatesToNewCurrency;
  @JsonKey(name: 'ConfirmUpdateAllRatesToNewCurrency')
  final String? confirmUpdateAllRatesToNewCurrency;
  @JsonKey(name: 'CurrencyCode')
  final String? currencyCode;
  @JsonKey(name: 'Currency')
  final String? currency;
  @JsonKey(name: 'CurrencySymbol')
  final String? currencySymbol;
  @JsonKey(name: 'BillingCycleId')
  final String? billingCycleId;
  @JsonKey(name: 'BillingCycle')
  final String? billingCycle;
  @JsonKey(name: 'RemitToAttention1')
  final String? remitToAttention1;
  @JsonKey(name: 'RemitToAttention2')
  final String? remitToAttention2;
  @JsonKey(name: 'RemitToAddress1')
  final String? remitToAddress1;
  @JsonKey(name: 'RemitToAddress2')
  final String? remitToAddress2;
  @JsonKey(name: 'RemitToCity')
  final String? remitToCity;
  @JsonKey(name: 'RemitToState')
  final String? remitToState;
  @JsonKey(name: 'RemitToCountryId')
  final String? remitToCountryId;
  @JsonKey(name: 'RemitToCountry')
  final String? remitToCountry;
  @JsonKey(name: 'RemitToZipCode')
  final String? remitToZipCode;
  @JsonKey(name: 'RemitToEmail')
  final String? remitToEmail;
  @JsonKey(name: 'RemitToPhone')
  final String? remitToPhone;
  @JsonKey(name: 'PaymentTypeId')
  final String? paymentTypeId;
  @JsonKey(name: 'PaymentType')
  final String? paymentType;
  @JsonKey(name: 'PaymentTermsId')
  final String? paymentTermsId;
  @JsonKey(name: 'PaymentTerms')
  final String? paymentTerms;
  @JsonKey(name: 'PaymentTermsDueInDays')
  final int? paymentTermsDueInDays;
  @JsonKey(name: 'TaxOptionId')
  final String? taxOptionId;
  @JsonKey(name: 'TaxOption')
  final String? taxOption;
  @JsonKey(name: 'TaxId')
  final String? taxId;
  @JsonKey(name: 'Tax1Name')
  final String? tax1Name;
  @JsonKey(name: 'Tax2Name')
  final String? tax2Name;
  @JsonKey(name: 'RentalTaxRate1')
  final double? rentalTaxRate1;
  @JsonKey(name: 'SalesTaxRate1')
  final double? salesTaxRate1;
  @JsonKey(name: 'LaborTaxRate1')
  final double? laborTaxRate1;
  @JsonKey(name: 'RentalTaxRate2')
  final double? rentalTaxRate2;
  @JsonKey(name: 'SalesTaxRate2')
  final double? salesTaxRate2;
  @JsonKey(name: 'LaborTaxRate2')
  final double? laborTaxRate2;
  @JsonKey(name: 'HasRentalItem')
  final bool? hasRentalItem;
  @JsonKey(name: 'HasSalesItem')
  final bool? hasSalesItem;
  @JsonKey(name: 'HasMiscellaneousItem')
  final bool? hasMiscellaneousItem;
  @JsonKey(name: 'HasLaborItem')
  final bool? hasLaborItem;
  @JsonKey(name: 'HasFacilitiesItem')
  final bool? hasFacilitiesItem;
  @JsonKey(name: 'HasLossAndDamageItem')
  final bool? hasLossAndDamageItem;
  @JsonKey(name: 'HasRentalSaleItem')
  final bool? hasRentalSaleItem;
  @JsonKey(name: 'HasPartsItem')
  final bool? hasPartsItem;
  @JsonKey(name: 'RentalDiscountPercent')
  final double? rentalDiscountPercent;
  @JsonKey(name: 'RentalTotal')
  final double? rentalTotal;
  @JsonKey(name: 'RentalTotalIncludesTax')
  final bool? rentalTotalIncludesTax;
  @JsonKey(name: 'SalesDiscountPercent')
  final double? salesDiscountPercent;
  @JsonKey(name: 'SalesTotal')
  final double? salesTotal;
  @JsonKey(name: 'SalesTotalIncludesTax')
  final bool? salesTotalIncludesTax;
  @JsonKey(name: 'PartsDiscountPercent')
  final double? partsDiscountPercent;
  @JsonKey(name: 'PartsTotal')
  final double? partsTotal;
  @JsonKey(name: 'PartsTotalIncludesTax')
  final bool? partsTotalIncludesTax;
  @JsonKey(name: 'VehicleDiscountPercent')
  final double? vehicleDiscountPercent;
  @JsonKey(name: 'VehicleTotal')
  final double? vehicleTotal;
  @JsonKey(name: 'VehicleTotalIncludesTax')
  final bool? vehicleTotalIncludesTax;
  @JsonKey(name: 'MiscDiscountPercent')
  final double? miscDiscountPercent;
  @JsonKey(name: 'MiscTotal')
  final double? miscTotal;
  @JsonKey(name: 'MiscTotalIncludesTax')
  final bool? miscTotalIncludesTax;
  @JsonKey(name: 'LaborDiscountPercent')
  final double? laborDiscountPercent;
  @JsonKey(name: 'LaborTotal')
  final double? laborTotal;
  @JsonKey(name: 'LaborTotalIncludesTax')
  final bool? laborTotalIncludesTax;
  @JsonKey(name: 'SubRentalDaysPerWeek')
  final double? subRentalDaysPerWeek;
  @JsonKey(name: 'SubRentalDiscountPercent')
  final double? subRentalDiscountPercent;
  @JsonKey(name: 'WeeklySubRentalTotal')
  final double? weeklySubRentalTotal;
  @JsonKey(name: 'MonthlySubRentalTotal')
  final double? monthlySubRentalTotal;
  @JsonKey(name: 'PeriodSubRentalTotal')
  final double? periodSubRentalTotal;
  @JsonKey(name: 'WeeklySubRentalTotalIncludesTax')
  final bool? weeklySubRentalTotalIncludesTax;
  @JsonKey(name: 'MonthlySubRentalTotalIncludesTax')
  final bool? monthlySubRentalTotalIncludesTax;
  @JsonKey(name: 'PeriodSubRentalTotalIncludesTax')
  final bool? periodSubRentalTotalIncludesTax;
  @JsonKey(name: 'SubSalesDiscountPercent')
  final double? subSalesDiscountPercent;
  @JsonKey(name: 'SubSalesTotal')
  final double? subSalesTotal;
  @JsonKey(name: 'SubSalesTotalIncludesTax')
  final bool? subSalesTotalIncludesTax;
  @JsonKey(name: 'SubVehicleDaysPerWeek')
  final double? subVehicleDaysPerWeek;
  @JsonKey(name: 'SubvehicleDiscountPercent')
  final double? subvehicleDiscountPercent;
  @JsonKey(name: 'WeeklySubVehicleTotal')
  final double? weeklySubVehicleTotal;
  @JsonKey(name: 'MonthlySubVehicleTotal')
  final double? monthlySubVehicleTotal;
  @JsonKey(name: 'PeriodSubVehicleTotal')
  final double? periodSubVehicleTotal;
  @JsonKey(name: 'WeeklySubVehicleTotalIncludesTax')
  final bool? weeklySubVehicleTotalIncludesTax;
  @JsonKey(name: 'MonthlySubVehicleTotalIncludesTax')
  final bool? monthlySubVehicleTotalIncludesTax;
  @JsonKey(name: 'PeriodSubVehicleTotalIncludesTax')
  final bool? periodSubVehicleTotalIncludesTax;
  @JsonKey(name: 'SubMiscDiscountPercent')
  final double? subMiscDiscountPercent;
  @JsonKey(name: 'WeeklySubMiscTotal')
  final double? weeklySubMiscTotal;
  @JsonKey(name: 'MonthlySubMiscTotal')
  final double? monthlySubMiscTotal;
  @JsonKey(name: 'PeriodSubMiscTotal')
  final double? periodSubMiscTotal;
  @JsonKey(name: 'WeeklySubMiscTotalIncludesTax')
  final bool? weeklySubMiscTotalIncludesTax;
  @JsonKey(name: 'MonthlySubMiscTotalIncludesTax')
  final bool? monthlySubMiscTotalIncludesTax;
  @JsonKey(name: 'PeriodSubMiscTotalIncludesTax')
  final bool? periodSubMiscTotalIncludesTax;
  @JsonKey(name: 'SubLaborDiscountPercent')
  final double? subLaborDiscountPercent;
  @JsonKey(name: 'WeeklySubLaborTotal')
  final double? weeklySubLaborTotal;
  @JsonKey(name: 'MonthlySubLaborTotal')
  final double? monthlySubLaborTotal;
  @JsonKey(name: 'PeriodSubLaborTotal')
  final double? periodSubLaborTotal;
  @JsonKey(name: 'WeeklySubLaborTotalIncludesTax')
  final bool? weeklySubLaborTotalIncludesTax;
  @JsonKey(name: 'MonthlySubLaborTotalIncludesTax')
  final bool? monthlySubLaborTotalIncludesTax;
  @JsonKey(name: 'PeriodSubLaborTotalIncludesTax')
  final bool? periodSubLaborTotalIncludesTax;
  @JsonKey(name: 'MiscellaneousIsComplete')
  final bool? miscellaneousIsComplete;
  @JsonKey(name: 'SubMiscellaneousIsComplete')
  final bool? subMiscellaneousIsComplete;
  @JsonKey(name: 'LaborIsComplete')
  final bool? laborIsComplete;
  @JsonKey(name: 'SubLaborIsComplete')
  final bool? subLaborIsComplete;
  @JsonKey(name: 'CurrencyColor')
  final String? currencyColor;
  @JsonKey(name: 'StatusColor')
  final String? statusColor;
  @JsonKey(name: 'PurchaseOrderNumberColor')
  final String? purchaseOrderNumberColor;
  @JsonKey(name: 'VendorColor')
  final String? vendorColor;
  @JsonKey(name: 'DescriptionColor')
  final String? descriptionColor;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsOrderItemOrderItem>[])
  final List<WebApiModulesHomeControlsOrderItemOrderItem>? items;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesAgentPurchaseOrderGetPurchaseOrderResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentPurchaseOrderGetPurchaseOrderResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentPurchaseOrderGetPurchaseOrderResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentPurchaseOrderGetPurchaseOrderResponse &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.purchaseOrderNumber, purchaseOrderNumber) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderNumber, purchaseOrderNumber)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.purchaseOrderDate, purchaseOrderDate) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderDate, purchaseOrderDate)) &&
            (identical(other.requisitionNumber, requisitionNumber) ||
                const DeepCollectionEquality()
                    .equals(other.requisitionNumber, requisitionNumber)) &&
            (identical(other.requisitionDate, requisitionDate) ||
                const DeepCollectionEquality()
                    .equals(other.requisitionDate, requisitionDate)) &&
            (identical(other.vendorId, vendorId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorId, vendorId)) &&
            (identical(other.vendor, vendor) ||
                const DeepCollectionEquality().equals(other.vendor, vendor)) &&
            (identical(other.agentId, agentId) ||
                const DeepCollectionEquality()
                    .equals(other.agentId, agentId)) &&
            (identical(other.agent, agent) ||
                const DeepCollectionEquality().equals(other.agent, agent)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.statusDate, statusDate) ||
                const DeepCollectionEquality()
                    .equals(other.statusDate, statusDate)) &&
            (identical(other.referenceNumber, referenceNumber) ||
                const DeepCollectionEquality()
                    .equals(other.referenceNumber, referenceNumber)) &&
            (identical(other.needsApproval, needsApproval) ||
                const DeepCollectionEquality()
                    .equals(other.needsApproval, needsApproval)) &&
            (identical(other.approvedByUserId, approvedByUserId) ||
                const DeepCollectionEquality()
                    .equals(other.approvedByUserId, approvedByUserId)) &&
            (identical(other.departmentId, departmentId) ||
                const DeepCollectionEquality()
                    .equals(other.departmentId, departmentId)) &&
            (identical(other.department, department) ||
                const DeepCollectionEquality()
                    .equals(other.department, department)) &&
            (identical(other.officeLocationId, officeLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocationId, officeLocationId)) &&
            (identical(other.officeLocation, officeLocation) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocation, officeLocation)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouse, warehouse) ||
                const DeepCollectionEquality()
                    .equals(other.warehouse, warehouse)) &&
            (identical(other.warehouseCode, warehouseCode) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.quantityHolding, quantityHolding) ||
                const DeepCollectionEquality()
                    .equals(other.quantityHolding, quantityHolding)) &&
            (identical(other.quantityToBarCode, quantityToBarCode) || const DeepCollectionEquality().equals(other.quantityToBarCode, quantityToBarCode)) &&
            (identical(other.rental, rental) || const DeepCollectionEquality().equals(other.rental, rental)) &&
            (identical(other.sales, sales) || const DeepCollectionEquality().equals(other.sales, sales)) &&
            (identical(other.parts, parts) || const DeepCollectionEquality().equals(other.parts, parts)) &&
            (identical(other.labor, labor) || const DeepCollectionEquality().equals(other.labor, labor)) &&
            (identical(other.miscellaneous, miscellaneous) || const DeepCollectionEquality().equals(other.miscellaneous, miscellaneous)) &&
            (identical(other.vehicle, vehicle) || const DeepCollectionEquality().equals(other.vehicle, vehicle)) &&
            (identical(other.subRent, subRent) || const DeepCollectionEquality().equals(other.subRent, subRent)) &&
            (identical(other.subSale, subSale) || const DeepCollectionEquality().equals(other.subSale, subSale)) &&
            (identical(other.subLabor, subLabor) || const DeepCollectionEquality().equals(other.subLabor, subLabor)) &&
            (identical(other.subMiscellaneous, subMiscellaneous) || const DeepCollectionEquality().equals(other.subMiscellaneous, subMiscellaneous)) &&
            (identical(other.subVehicle, subVehicle) || const DeepCollectionEquality().equals(other.subVehicle, subVehicle)) &&
            (identical(other.repair, repair) || const DeepCollectionEquality().equals(other.repair, repair)) &&
            (identical(other.consignment, consignment) || const DeepCollectionEquality().equals(other.consignment, consignment)) &&
            (identical(other.consignorAgreementId, consignorAgreementId) || const DeepCollectionEquality().equals(other.consignorAgreementId, consignorAgreementId)) &&
            (identical(other.consignorAgreementNumber, consignorAgreementNumber) || const DeepCollectionEquality().equals(other.consignorAgreementNumber, consignorAgreementNumber)) &&
            (identical(other.orderId, orderId) || const DeepCollectionEquality().equals(other.orderId, orderId)) &&
            (identical(other.orderNumber, orderNumber) || const DeepCollectionEquality().equals(other.orderNumber, orderNumber)) &&
            (identical(other.dealNumber, dealNumber) || const DeepCollectionEquality().equals(other.dealNumber, dealNumber)) &&
            (identical(other.dealId, dealId) || const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.deal, deal) || const DeepCollectionEquality().equals(other.deal, deal)) &&
            (identical(other.rateType, rateType) || const DeepCollectionEquality().equals(other.rateType, rateType)) &&
            (identical(other.departmentLocationRequiresApproval, departmentLocationRequiresApproval) || const DeepCollectionEquality().equals(other.departmentLocationRequiresApproval, departmentLocationRequiresApproval)) &&
            (identical(other.total, total) || const DeepCollectionEquality().equals(other.total, total)) &&
            (identical(other.poTypeId, poTypeId) || const DeepCollectionEquality().equals(other.poTypeId, poTypeId)) &&
            (identical(other.poType, poType) || const DeepCollectionEquality().equals(other.poType, poType)) &&
            (identical(other.poClassificationId, poClassificationId) || const DeepCollectionEquality().equals(other.poClassificationId, poClassificationId)) &&
            (identical(other.poClassification, poClassification) || const DeepCollectionEquality().equals(other.poClassification, poClassification)) &&
            (identical(other.activityDatesAndTimes, activityDatesAndTimes) || const DeepCollectionEquality().equals(other.activityDatesAndTimes, activityDatesAndTimes)) &&
            (identical(other.estimatedStartDate, estimatedStartDate) || const DeepCollectionEquality().equals(other.estimatedStartDate, estimatedStartDate)) &&
            (identical(other.estimatedStartTime, estimatedStartTime) || const DeepCollectionEquality().equals(other.estimatedStartTime, estimatedStartTime)) &&
            (identical(other.estimatedStopDate, estimatedStopDate) || const DeepCollectionEquality().equals(other.estimatedStopDate, estimatedStopDate)) &&
            (identical(other.estimatedStopTime, estimatedStopTime) || const DeepCollectionEquality().equals(other.estimatedStopTime, estimatedStopTime)) &&
            (identical(other.billingStartDate, billingStartDate) || const DeepCollectionEquality().equals(other.billingStartDate, billingStartDate)) &&
            (identical(other.billingEndDate, billingEndDate) || const DeepCollectionEquality().equals(other.billingEndDate, billingEndDate)) &&
            (identical(other.billingWeeks, billingWeeks) || const DeepCollectionEquality().equals(other.billingWeeks, billingWeeks)) &&
            (identical(other.billingMonths, billingMonths) || const DeepCollectionEquality().equals(other.billingMonths, billingMonths)) &&
            (identical(other.invoicedAmount, invoicedAmount) || const DeepCollectionEquality().equals(other.invoicedAmount, invoicedAmount)) &&
            (identical(other.projectManagerId, projectManagerId) || const DeepCollectionEquality().equals(other.projectManagerId, projectManagerId)) &&
            (identical(other.projectManager, projectManager) || const DeepCollectionEquality().equals(other.projectManager, projectManager)) &&
            (identical(other.receiveDeliveryId, receiveDeliveryId) || const DeepCollectionEquality().equals(other.receiveDeliveryId, receiveDeliveryId)) &&
            (identical(other.receiveDeliveryDeliveryType, receiveDeliveryDeliveryType) || const DeepCollectionEquality().equals(other.receiveDeliveryDeliveryType, receiveDeliveryDeliveryType)) &&
            (identical(other.receiveDeliveryRequiredDate, receiveDeliveryRequiredDate) || const DeepCollectionEquality().equals(other.receiveDeliveryRequiredDate, receiveDeliveryRequiredDate)) &&
            (identical(other.receiveDeliveryRequiredTime, receiveDeliveryRequiredTime) || const DeepCollectionEquality().equals(other.receiveDeliveryRequiredTime, receiveDeliveryRequiredTime)) &&
            (identical(other.receiveDeliveryTargetShipDate, receiveDeliveryTargetShipDate) || const DeepCollectionEquality().equals(other.receiveDeliveryTargetShipDate, receiveDeliveryTargetShipDate)) &&
            (identical(other.receiveDeliveryTargetShipTime, receiveDeliveryTargetShipTime) || const DeepCollectionEquality().equals(other.receiveDeliveryTargetShipTime, receiveDeliveryTargetShipTime)) &&
            (identical(other.receiveDeliveryDirection, receiveDeliveryDirection) || const DeepCollectionEquality().equals(other.receiveDeliveryDirection, receiveDeliveryDirection)) &&
            (identical(other.receiveDeliveryAddressType, receiveDeliveryAddressType) || const DeepCollectionEquality().equals(other.receiveDeliveryAddressType, receiveDeliveryAddressType)) &&
            (identical(other.receiveDeliveryFromLocation, receiveDeliveryFromLocation) || const DeepCollectionEquality().equals(other.receiveDeliveryFromLocation, receiveDeliveryFromLocation)) &&
            (identical(other.receiveDeliveryFromContact, receiveDeliveryFromContact) || const DeepCollectionEquality().equals(other.receiveDeliveryFromContact, receiveDeliveryFromContact)) &&
            (identical(other.receiveDeliveryFromContactPhone, receiveDeliveryFromContactPhone) || const DeepCollectionEquality().equals(other.receiveDeliveryFromContactPhone, receiveDeliveryFromContactPhone)) &&
            (identical(other.receiveDeliveryFromAlternateContact, receiveDeliveryFromAlternateContact) || const DeepCollectionEquality().equals(other.receiveDeliveryFromAlternateContact, receiveDeliveryFromAlternateContact)) &&
            (identical(other.receiveDeliveryFromAlternateContactPhone, receiveDeliveryFromAlternateContactPhone) || const DeepCollectionEquality().equals(other.receiveDeliveryFromAlternateContactPhone, receiveDeliveryFromAlternateContactPhone)) &&
            (identical(other.receiveDeliveryFromAttention, receiveDeliveryFromAttention) || const DeepCollectionEquality().equals(other.receiveDeliveryFromAttention, receiveDeliveryFromAttention)) &&
            (identical(other.receiveDeliveryFromAddress1, receiveDeliveryFromAddress1) || const DeepCollectionEquality().equals(other.receiveDeliveryFromAddress1, receiveDeliveryFromAddress1)) &&
            (identical(other.receiveDeliveryFromAdd2ress, receiveDeliveryFromAdd2ress) || const DeepCollectionEquality().equals(other.receiveDeliveryFromAdd2ress, receiveDeliveryFromAdd2ress)) &&
            (identical(other.receiveDeliveryFromCity, receiveDeliveryFromCity) || const DeepCollectionEquality().equals(other.receiveDeliveryFromCity, receiveDeliveryFromCity)) &&
            (identical(other.receiveDeliveryFromState, receiveDeliveryFromState) || const DeepCollectionEquality().equals(other.receiveDeliveryFromState, receiveDeliveryFromState)) &&
            (identical(other.receiveDeliveryFromZipCode, receiveDeliveryFromZipCode) || const DeepCollectionEquality().equals(other.receiveDeliveryFromZipCode, receiveDeliveryFromZipCode)) &&
            (identical(other.receiveDeliveryFromCountry, receiveDeliveryFromCountry) || const DeepCollectionEquality().equals(other.receiveDeliveryFromCountry, receiveDeliveryFromCountry)) &&
            (identical(other.receiveDeliveryFromCountryId, receiveDeliveryFromCountryId) || const DeepCollectionEquality().equals(other.receiveDeliveryFromCountryId, receiveDeliveryFromCountryId)) &&
            (identical(other.receiveDeliveryFromCrossStreets, receiveDeliveryFromCrossStreets) || const DeepCollectionEquality().equals(other.receiveDeliveryFromCrossStreets, receiveDeliveryFromCrossStreets)) &&
            (identical(other.receiveDeliveryToLocation, receiveDeliveryToLocation) || const DeepCollectionEquality().equals(other.receiveDeliveryToLocation, receiveDeliveryToLocation)) &&
            (identical(other.receiveDeliveryToVenue, receiveDeliveryToVenue) || const DeepCollectionEquality().equals(other.receiveDeliveryToVenue, receiveDeliveryToVenue)) &&
            (identical(other.receiveDeliveryToVenueId, receiveDeliveryToVenueId) || const DeepCollectionEquality().equals(other.receiveDeliveryToVenueId, receiveDeliveryToVenueId)) &&
            (identical(other.receiveDeliveryToWarehouse, receiveDeliveryToWarehouse) || const DeepCollectionEquality().equals(other.receiveDeliveryToWarehouse, receiveDeliveryToWarehouse)) &&
            (identical(other.receiveDeliveryToWarehouseId, receiveDeliveryToWarehouseId) || const DeepCollectionEquality().equals(other.receiveDeliveryToWarehouseId, receiveDeliveryToWarehouseId)) &&
            (identical(other.receiveDeliveryToContact, receiveDeliveryToContact) || const DeepCollectionEquality().equals(other.receiveDeliveryToContact, receiveDeliveryToContact)) &&
            (identical(other.receiveDeliveryToContactPhone, receiveDeliveryToContactPhone) || const DeepCollectionEquality().equals(other.receiveDeliveryToContactPhone, receiveDeliveryToContactPhone)) &&
            (identical(other.receiveDeliveryToAlternateContact, receiveDeliveryToAlternateContact) || const DeepCollectionEquality().equals(other.receiveDeliveryToAlternateContact, receiveDeliveryToAlternateContact)) &&
            (identical(other.receiveDeliveryToAlternateContactPhone, receiveDeliveryToAlternateContactPhone) || const DeepCollectionEquality().equals(other.receiveDeliveryToAlternateContactPhone, receiveDeliveryToAlternateContactPhone)) &&
            (identical(other.receiveDeliveryToAttention, receiveDeliveryToAttention) || const DeepCollectionEquality().equals(other.receiveDeliveryToAttention, receiveDeliveryToAttention)) &&
            (identical(other.receiveDeliveryToAddress1, receiveDeliveryToAddress1) || const DeepCollectionEquality().equals(other.receiveDeliveryToAddress1, receiveDeliveryToAddress1)) &&
            (identical(other.receiveDeliveryToAddress2, receiveDeliveryToAddress2) || const DeepCollectionEquality().equals(other.receiveDeliveryToAddress2, receiveDeliveryToAddress2)) &&
            (identical(other.receiveDeliveryToCity, receiveDeliveryToCity) || const DeepCollectionEquality().equals(other.receiveDeliveryToCity, receiveDeliveryToCity)) &&
            (identical(other.receiveDeliveryToState, receiveDeliveryToState) || const DeepCollectionEquality().equals(other.receiveDeliveryToState, receiveDeliveryToState)) &&
            (identical(other.receiveDeliveryToZipCode, receiveDeliveryToZipCode) || const DeepCollectionEquality().equals(other.receiveDeliveryToZipCode, receiveDeliveryToZipCode)) &&
            (identical(other.receiveDeliveryToCountryId, receiveDeliveryToCountryId) || const DeepCollectionEquality().equals(other.receiveDeliveryToCountryId, receiveDeliveryToCountryId)) &&
            (identical(other.receiveDeliveryToCountry, receiveDeliveryToCountry) || const DeepCollectionEquality().equals(other.receiveDeliveryToCountry, receiveDeliveryToCountry)) &&
            (identical(other.receiveDeliveryToContactFax, receiveDeliveryToContactFax) || const DeepCollectionEquality().equals(other.receiveDeliveryToContactFax, receiveDeliveryToContactFax)) &&
            (identical(other.receiveDeliveryToCrossStreets, receiveDeliveryToCrossStreets) || const DeepCollectionEquality().equals(other.receiveDeliveryToCrossStreets, receiveDeliveryToCrossStreets)) &&
            (identical(other.receiveDeliveryDeliveryNotes, receiveDeliveryDeliveryNotes) || const DeepCollectionEquality().equals(other.receiveDeliveryDeliveryNotes, receiveDeliveryDeliveryNotes)) &&
            (identical(other.receiveDeliveryCarrierId, receiveDeliveryCarrierId) || const DeepCollectionEquality().equals(other.receiveDeliveryCarrierId, receiveDeliveryCarrierId)) &&
            (identical(other.receiveDeliveryCarrier, receiveDeliveryCarrier) || const DeepCollectionEquality().equals(other.receiveDeliveryCarrier, receiveDeliveryCarrier)) &&
            (identical(other.receiveDeliveryCarrierAccount, receiveDeliveryCarrierAccount) || const DeepCollectionEquality().equals(other.receiveDeliveryCarrierAccount, receiveDeliveryCarrierAccount)) &&
            (identical(other.receiveDeliveryShipViaId, receiveDeliveryShipViaId) || const DeepCollectionEquality().equals(other.receiveDeliveryShipViaId, receiveDeliveryShipViaId)) &&
            (identical(other.receiveDeliveryShipVia, receiveDeliveryShipVia) || const DeepCollectionEquality().equals(other.receiveDeliveryShipVia, receiveDeliveryShipVia)) &&
            (identical(other.receiveDeliveryInvoiceId, receiveDeliveryInvoiceId) || const DeepCollectionEquality().equals(other.receiveDeliveryInvoiceId, receiveDeliveryInvoiceId)) &&
            (identical(other.receiveDeliveryVendorInvoiceId, receiveDeliveryVendorInvoiceId) || const DeepCollectionEquality().equals(other.receiveDeliveryVendorInvoiceId, receiveDeliveryVendorInvoiceId)) &&
            (identical(other.receiveDeliveryEstimatedFreight, receiveDeliveryEstimatedFreight) || const DeepCollectionEquality().equals(other.receiveDeliveryEstimatedFreight, receiveDeliveryEstimatedFreight)) &&
            (identical(other.receiveDeliveryFreightInvoiceAmount, receiveDeliveryFreightInvoiceAmount) || const DeepCollectionEquality().equals(other.receiveDeliveryFreightInvoiceAmount, receiveDeliveryFreightInvoiceAmount)) &&
            (identical(other.receiveDeliveryChargeType, receiveDeliveryChargeType) || const DeepCollectionEquality().equals(other.receiveDeliveryChargeType, receiveDeliveryChargeType)) &&
            (identical(other.receiveDeliveryFreightTrackingNumber, receiveDeliveryFreightTrackingNumber) || const DeepCollectionEquality().equals(other.receiveDeliveryFreightTrackingNumber, receiveDeliveryFreightTrackingNumber)) &&
            (identical(other.receiveDeliveryFreightTrackingUrl, receiveDeliveryFreightTrackingUrl) || const DeepCollectionEquality().equals(other.receiveDeliveryFreightTrackingUrl, receiveDeliveryFreightTrackingUrl)) &&
            (identical(other.receiveDeliveryDropShip, receiveDeliveryDropShip) || const DeepCollectionEquality().equals(other.receiveDeliveryDropShip, receiveDeliveryDropShip)) &&
            (identical(other.receiveDeliveryPackageCode, receiveDeliveryPackageCode) || const DeepCollectionEquality().equals(other.receiveDeliveryPackageCode, receiveDeliveryPackageCode)) &&
            (identical(other.receiveDeliveryBillPoFreightOnOrder, receiveDeliveryBillPoFreightOnOrder) || const DeepCollectionEquality().equals(other.receiveDeliveryBillPoFreightOnOrder, receiveDeliveryBillPoFreightOnOrder)) &&
            (identical(other.receiveDeliveryOnlineOrderNumber, receiveDeliveryOnlineOrderNumber) || const DeepCollectionEquality().equals(other.receiveDeliveryOnlineOrderNumber, receiveDeliveryOnlineOrderNumber)) &&
            (identical(other.receiveDeliveryOnlineOrderStatus, receiveDeliveryOnlineOrderStatus) || const DeepCollectionEquality().equals(other.receiveDeliveryOnlineOrderStatus, receiveDeliveryOnlineOrderStatus)) &&
            (identical(other.receiveDeliveryDateStamp, receiveDeliveryDateStamp) || const DeepCollectionEquality().equals(other.receiveDeliveryDateStamp, receiveDeliveryDateStamp)) &&
            (identical(other.returnDeliveryId, returnDeliveryId) || const DeepCollectionEquality().equals(other.returnDeliveryId, returnDeliveryId)) &&
            (identical(other.returnDeliveryDeliveryType, returnDeliveryDeliveryType) || const DeepCollectionEquality().equals(other.returnDeliveryDeliveryType, returnDeliveryDeliveryType)) &&
            (identical(other.returnDeliveryRequiredDate, returnDeliveryRequiredDate) || const DeepCollectionEquality().equals(other.returnDeliveryRequiredDate, returnDeliveryRequiredDate)) &&
            (identical(other.returnDeliveryRequiredTime, returnDeliveryRequiredTime) || const DeepCollectionEquality().equals(other.returnDeliveryRequiredTime, returnDeliveryRequiredTime)) &&
            (identical(other.returnDeliveryTargetShipDate, returnDeliveryTargetShipDate) || const DeepCollectionEquality().equals(other.returnDeliveryTargetShipDate, returnDeliveryTargetShipDate)) &&
            (identical(other.returnDeliveryTargetShipTime, returnDeliveryTargetShipTime) || const DeepCollectionEquality().equals(other.returnDeliveryTargetShipTime, returnDeliveryTargetShipTime)) &&
            (identical(other.returnDeliveryDirection, returnDeliveryDirection) || const DeepCollectionEquality().equals(other.returnDeliveryDirection, returnDeliveryDirection)) &&
            (identical(other.returnDeliveryAddressType, returnDeliveryAddressType) || const DeepCollectionEquality().equals(other.returnDeliveryAddressType, returnDeliveryAddressType)) &&
            (identical(other.returnDeliveryFromLocation, returnDeliveryFromLocation) || const DeepCollectionEquality().equals(other.returnDeliveryFromLocation, returnDeliveryFromLocation)) &&
            (identical(other.returnDeliveryFromContact, returnDeliveryFromContact) || const DeepCollectionEquality().equals(other.returnDeliveryFromContact, returnDeliveryFromContact)) &&
            (identical(other.returnDeliveryFromContactPhone, returnDeliveryFromContactPhone) || const DeepCollectionEquality().equals(other.returnDeliveryFromContactPhone, returnDeliveryFromContactPhone)) &&
            (identical(other.returnDeliveryFromAlternateContact, returnDeliveryFromAlternateContact) || const DeepCollectionEquality().equals(other.returnDeliveryFromAlternateContact, returnDeliveryFromAlternateContact)) &&
            (identical(other.returnDeliveryFromAlternateContactPhone, returnDeliveryFromAlternateContactPhone) || const DeepCollectionEquality().equals(other.returnDeliveryFromAlternateContactPhone, returnDeliveryFromAlternateContactPhone)) &&
            (identical(other.returnDeliveryFromAttention, returnDeliveryFromAttention) || const DeepCollectionEquality().equals(other.returnDeliveryFromAttention, returnDeliveryFromAttention)) &&
            (identical(other.returnDeliveryFromAddress1, returnDeliveryFromAddress1) || const DeepCollectionEquality().equals(other.returnDeliveryFromAddress1, returnDeliveryFromAddress1)) &&
            (identical(other.returnDeliveryFromAdd2ress, returnDeliveryFromAdd2ress) || const DeepCollectionEquality().equals(other.returnDeliveryFromAdd2ress, returnDeliveryFromAdd2ress)) &&
            (identical(other.returnDeliveryFromCity, returnDeliveryFromCity) || const DeepCollectionEquality().equals(other.returnDeliveryFromCity, returnDeliveryFromCity)) &&
            (identical(other.returnDeliveryFromState, returnDeliveryFromState) || const DeepCollectionEquality().equals(other.returnDeliveryFromState, returnDeliveryFromState)) &&
            (identical(other.returnDeliveryFromZipCode, returnDeliveryFromZipCode) || const DeepCollectionEquality().equals(other.returnDeliveryFromZipCode, returnDeliveryFromZipCode)) &&
            (identical(other.returnDeliveryFromCountry, returnDeliveryFromCountry) || const DeepCollectionEquality().equals(other.returnDeliveryFromCountry, returnDeliveryFromCountry)) &&
            (identical(other.returnDeliveryFromCountryId, returnDeliveryFromCountryId) || const DeepCollectionEquality().equals(other.returnDeliveryFromCountryId, returnDeliveryFromCountryId)) &&
            (identical(other.returnDeliveryFromCrossStreets, returnDeliveryFromCrossStreets) || const DeepCollectionEquality().equals(other.returnDeliveryFromCrossStreets, returnDeliveryFromCrossStreets)) &&
            (identical(other.returnDeliveryToLocation, returnDeliveryToLocation) || const DeepCollectionEquality().equals(other.returnDeliveryToLocation, returnDeliveryToLocation)) &&
            (identical(other.returnDeliveryToVenue, returnDeliveryToVenue) || const DeepCollectionEquality().equals(other.returnDeliveryToVenue, returnDeliveryToVenue)) &&
            (identical(other.returnDeliveryToVenueId, returnDeliveryToVenueId) || const DeepCollectionEquality().equals(other.returnDeliveryToVenueId, returnDeliveryToVenueId)) &&
            (identical(other.returnDeliveryToWarehouse, returnDeliveryToWarehouse) || const DeepCollectionEquality().equals(other.returnDeliveryToWarehouse, returnDeliveryToWarehouse)) &&
            (identical(other.returnDeliveryToWarehouseId, returnDeliveryToWarehouseId) || const DeepCollectionEquality().equals(other.returnDeliveryToWarehouseId, returnDeliveryToWarehouseId)) &&
            (identical(other.returnDeliveryToContact, returnDeliveryToContact) || const DeepCollectionEquality().equals(other.returnDeliveryToContact, returnDeliveryToContact)) &&
            (identical(other.returnDeliveryToContactPhone, returnDeliveryToContactPhone) || const DeepCollectionEquality().equals(other.returnDeliveryToContactPhone, returnDeliveryToContactPhone)) &&
            (identical(other.returnDeliveryToAlternateContact, returnDeliveryToAlternateContact) || const DeepCollectionEquality().equals(other.returnDeliveryToAlternateContact, returnDeliveryToAlternateContact)) &&
            (identical(other.returnDeliveryToAlternateContactPhone, returnDeliveryToAlternateContactPhone) || const DeepCollectionEquality().equals(other.returnDeliveryToAlternateContactPhone, returnDeliveryToAlternateContactPhone)) &&
            (identical(other.returnDeliveryToAttention, returnDeliveryToAttention) || const DeepCollectionEquality().equals(other.returnDeliveryToAttention, returnDeliveryToAttention)) &&
            (identical(other.returnDeliveryToAddress1, returnDeliveryToAddress1) || const DeepCollectionEquality().equals(other.returnDeliveryToAddress1, returnDeliveryToAddress1)) &&
            (identical(other.returnDeliveryToAddress2, returnDeliveryToAddress2) || const DeepCollectionEquality().equals(other.returnDeliveryToAddress2, returnDeliveryToAddress2)) &&
            (identical(other.returnDeliveryToCity, returnDeliveryToCity) || const DeepCollectionEquality().equals(other.returnDeliveryToCity, returnDeliveryToCity)) &&
            (identical(other.returnDeliveryToState, returnDeliveryToState) || const DeepCollectionEquality().equals(other.returnDeliveryToState, returnDeliveryToState)) &&
            (identical(other.returnDeliveryToZipCode, returnDeliveryToZipCode) || const DeepCollectionEquality().equals(other.returnDeliveryToZipCode, returnDeliveryToZipCode)) &&
            (identical(other.returnDeliveryToCountryId, returnDeliveryToCountryId) || const DeepCollectionEquality().equals(other.returnDeliveryToCountryId, returnDeliveryToCountryId)) &&
            (identical(other.returnDeliveryToCountry, returnDeliveryToCountry) || const DeepCollectionEquality().equals(other.returnDeliveryToCountry, returnDeliveryToCountry)) &&
            (identical(other.returnDeliveryToContactFax, returnDeliveryToContactFax) || const DeepCollectionEquality().equals(other.returnDeliveryToContactFax, returnDeliveryToContactFax)) &&
            (identical(other.returnDeliveryToCrossStreets, returnDeliveryToCrossStreets) || const DeepCollectionEquality().equals(other.returnDeliveryToCrossStreets, returnDeliveryToCrossStreets)) &&
            (identical(other.returnDeliveryDeliveryNotes, returnDeliveryDeliveryNotes) || const DeepCollectionEquality().equals(other.returnDeliveryDeliveryNotes, returnDeliveryDeliveryNotes)) &&
            (identical(other.returnDeliveryCarrierId, returnDeliveryCarrierId) || const DeepCollectionEquality().equals(other.returnDeliveryCarrierId, returnDeliveryCarrierId)) &&
            (identical(other.returnDeliveryCarrier, returnDeliveryCarrier) || const DeepCollectionEquality().equals(other.returnDeliveryCarrier, returnDeliveryCarrier)) &&
            (identical(other.returnDeliveryCarrierAccount, returnDeliveryCarrierAccount) || const DeepCollectionEquality().equals(other.returnDeliveryCarrierAccount, returnDeliveryCarrierAccount)) &&
            (identical(other.returnDeliveryShipViaId, returnDeliveryShipViaId) || const DeepCollectionEquality().equals(other.returnDeliveryShipViaId, returnDeliveryShipViaId)) &&
            (identical(other.returnDeliveryShipVia, returnDeliveryShipVia) || const DeepCollectionEquality().equals(other.returnDeliveryShipVia, returnDeliveryShipVia)) &&
            (identical(other.returnDeliveryInvoiceId, returnDeliveryInvoiceId) || const DeepCollectionEquality().equals(other.returnDeliveryInvoiceId, returnDeliveryInvoiceId)) &&
            (identical(other.returnDeliveryVendorInvoiceId, returnDeliveryVendorInvoiceId) || const DeepCollectionEquality().equals(other.returnDeliveryVendorInvoiceId, returnDeliveryVendorInvoiceId)) &&
            (identical(other.returnDeliveryEstimatedFreight, returnDeliveryEstimatedFreight) || const DeepCollectionEquality().equals(other.returnDeliveryEstimatedFreight, returnDeliveryEstimatedFreight)) &&
            (identical(other.returnDeliveryFreightInvoiceAmount, returnDeliveryFreightInvoiceAmount) || const DeepCollectionEquality().equals(other.returnDeliveryFreightInvoiceAmount, returnDeliveryFreightInvoiceAmount)) &&
            (identical(other.returnDeliveryChargeType, returnDeliveryChargeType) || const DeepCollectionEquality().equals(other.returnDeliveryChargeType, returnDeliveryChargeType)) &&
            (identical(other.returnDeliveryFreightTrackingNumber, returnDeliveryFreightTrackingNumber) || const DeepCollectionEquality().equals(other.returnDeliveryFreightTrackingNumber, returnDeliveryFreightTrackingNumber)) &&
            (identical(other.returnDeliveryFreightTrackingUrl, returnDeliveryFreightTrackingUrl) || const DeepCollectionEquality().equals(other.returnDeliveryFreightTrackingUrl, returnDeliveryFreightTrackingUrl)) &&
            (identical(other.returnDeliveryVendorRetrieve, returnDeliveryVendorRetrieve) || const DeepCollectionEquality().equals(other.returnDeliveryVendorRetrieve, returnDeliveryVendorRetrieve)) &&
            (identical(other.returnDeliveryPackageCode, returnDeliveryPackageCode) || const DeepCollectionEquality().equals(other.returnDeliveryPackageCode, returnDeliveryPackageCode)) &&
            (identical(other.returnDeliveryBillPoFreightOnOrder, returnDeliveryBillPoFreightOnOrder) || const DeepCollectionEquality().equals(other.returnDeliveryBillPoFreightOnOrder, returnDeliveryBillPoFreightOnOrder)) &&
            (identical(other.returnDeliveryOnlineOrderNumber, returnDeliveryOnlineOrderNumber) || const DeepCollectionEquality().equals(other.returnDeliveryOnlineOrderNumber, returnDeliveryOnlineOrderNumber)) &&
            (identical(other.returnDeliveryOnlineOrderStatus, returnDeliveryOnlineOrderStatus) || const DeepCollectionEquality().equals(other.returnDeliveryOnlineOrderStatus, returnDeliveryOnlineOrderStatus)) &&
            (identical(other.returnDeliveryDateStamp, returnDeliveryDateStamp) || const DeepCollectionEquality().equals(other.returnDeliveryDateStamp, returnDeliveryDateStamp)) &&
            (identical(other.enableProjects, enableProjects) || const DeepCollectionEquality().equals(other.enableProjects, enableProjects)) &&
            (identical(other.projectId, projectId) || const DeepCollectionEquality().equals(other.projectId, projectId)) &&
            (identical(other.projectNumber, projectNumber) || const DeepCollectionEquality().equals(other.projectNumber, projectNumber)) &&
            (identical(other.project, project) || const DeepCollectionEquality().equals(other.project, project)) &&
            (identical(other.projectDrawingsId, projectDrawingsId) || const DeepCollectionEquality().equals(other.projectDrawingsId, projectDrawingsId)) &&
            (identical(other.projectDrawings, projectDrawings) || const DeepCollectionEquality().equals(other.projectDrawings, projectDrawings)) &&
            (identical(other.projectItemsOrderedId, projectItemsOrderedId) || const DeepCollectionEquality().equals(other.projectItemsOrderedId, projectItemsOrderedId)) &&
            (identical(other.projectItemsOrdered, projectItemsOrdered) || const DeepCollectionEquality().equals(other.projectItemsOrdered, projectItemsOrdered)) &&
            (identical(other.projectDropShipId, projectDropShipId) || const DeepCollectionEquality().equals(other.projectDropShipId, projectDropShipId)) &&
            (identical(other.projectDropShip, projectDropShip) || const DeepCollectionEquality().equals(other.projectDropShip, projectDropShip)) &&
            (identical(other.projectAsBuildId, projectAsBuildId) || const DeepCollectionEquality().equals(other.projectAsBuildId, projectAsBuildId)) &&
            (identical(other.projectAsBuild, projectAsBuild) || const DeepCollectionEquality().equals(other.projectAsBuild, projectAsBuild)) &&
            (identical(other.projectCommissioningId, projectCommissioningId) || const DeepCollectionEquality().equals(other.projectCommissioningId, projectCommissioningId)) &&
            (identical(other.projectCommissioning, projectCommissioning) || const DeepCollectionEquality().equals(other.projectCommissioning, projectCommissioning)) &&
            (identical(other.projectDepositId, projectDepositId) || const DeepCollectionEquality().equals(other.projectDepositId, projectDepositId)) &&
            (identical(other.projectDeposit, projectDeposit) || const DeepCollectionEquality().equals(other.projectDeposit, projectDeposit)) &&
            (identical(other.location, location) || const DeepCollectionEquality().equals(other.location, location)) &&
            (identical(other.currencyId, currencyId) || const DeepCollectionEquality().equals(other.currencyId, currencyId)) &&
            (identical(other.updateAllRatesToNewCurrency, updateAllRatesToNewCurrency) || const DeepCollectionEquality().equals(other.updateAllRatesToNewCurrency, updateAllRatesToNewCurrency)) &&
            (identical(other.confirmUpdateAllRatesToNewCurrency, confirmUpdateAllRatesToNewCurrency) || const DeepCollectionEquality().equals(other.confirmUpdateAllRatesToNewCurrency, confirmUpdateAllRatesToNewCurrency)) &&
            (identical(other.currencyCode, currencyCode) || const DeepCollectionEquality().equals(other.currencyCode, currencyCode)) &&
            (identical(other.currency, currency) || const DeepCollectionEquality().equals(other.currency, currency)) &&
            (identical(other.currencySymbol, currencySymbol) || const DeepCollectionEquality().equals(other.currencySymbol, currencySymbol)) &&
            (identical(other.billingCycleId, billingCycleId) || const DeepCollectionEquality().equals(other.billingCycleId, billingCycleId)) &&
            (identical(other.billingCycle, billingCycle) || const DeepCollectionEquality().equals(other.billingCycle, billingCycle)) &&
            (identical(other.remitToAttention1, remitToAttention1) || const DeepCollectionEquality().equals(other.remitToAttention1, remitToAttention1)) &&
            (identical(other.remitToAttention2, remitToAttention2) || const DeepCollectionEquality().equals(other.remitToAttention2, remitToAttention2)) &&
            (identical(other.remitToAddress1, remitToAddress1) || const DeepCollectionEquality().equals(other.remitToAddress1, remitToAddress1)) &&
            (identical(other.remitToAddress2, remitToAddress2) || const DeepCollectionEquality().equals(other.remitToAddress2, remitToAddress2)) &&
            (identical(other.remitToCity, remitToCity) || const DeepCollectionEquality().equals(other.remitToCity, remitToCity)) &&
            (identical(other.remitToState, remitToState) || const DeepCollectionEquality().equals(other.remitToState, remitToState)) &&
            (identical(other.remitToCountryId, remitToCountryId) || const DeepCollectionEquality().equals(other.remitToCountryId, remitToCountryId)) &&
            (identical(other.remitToCountry, remitToCountry) || const DeepCollectionEquality().equals(other.remitToCountry, remitToCountry)) &&
            (identical(other.remitToZipCode, remitToZipCode) || const DeepCollectionEquality().equals(other.remitToZipCode, remitToZipCode)) &&
            (identical(other.remitToEmail, remitToEmail) || const DeepCollectionEquality().equals(other.remitToEmail, remitToEmail)) &&
            (identical(other.remitToPhone, remitToPhone) || const DeepCollectionEquality().equals(other.remitToPhone, remitToPhone)) &&
            (identical(other.paymentTypeId, paymentTypeId) || const DeepCollectionEquality().equals(other.paymentTypeId, paymentTypeId)) &&
            (identical(other.paymentType, paymentType) || const DeepCollectionEquality().equals(other.paymentType, paymentType)) &&
            (identical(other.paymentTermsId, paymentTermsId) || const DeepCollectionEquality().equals(other.paymentTermsId, paymentTermsId)) &&
            (identical(other.paymentTerms, paymentTerms) || const DeepCollectionEquality().equals(other.paymentTerms, paymentTerms)) &&
            (identical(other.paymentTermsDueInDays, paymentTermsDueInDays) || const DeepCollectionEquality().equals(other.paymentTermsDueInDays, paymentTermsDueInDays)) &&
            (identical(other.taxOptionId, taxOptionId) || const DeepCollectionEquality().equals(other.taxOptionId, taxOptionId)) &&
            (identical(other.taxOption, taxOption) || const DeepCollectionEquality().equals(other.taxOption, taxOption)) &&
            (identical(other.taxId, taxId) || const DeepCollectionEquality().equals(other.taxId, taxId)) &&
            (identical(other.tax1Name, tax1Name) || const DeepCollectionEquality().equals(other.tax1Name, tax1Name)) &&
            (identical(other.tax2Name, tax2Name) || const DeepCollectionEquality().equals(other.tax2Name, tax2Name)) &&
            (identical(other.rentalTaxRate1, rentalTaxRate1) || const DeepCollectionEquality().equals(other.rentalTaxRate1, rentalTaxRate1)) &&
            (identical(other.salesTaxRate1, salesTaxRate1) || const DeepCollectionEquality().equals(other.salesTaxRate1, salesTaxRate1)) &&
            (identical(other.laborTaxRate1, laborTaxRate1) || const DeepCollectionEquality().equals(other.laborTaxRate1, laborTaxRate1)) &&
            (identical(other.rentalTaxRate2, rentalTaxRate2) || const DeepCollectionEquality().equals(other.rentalTaxRate2, rentalTaxRate2)) &&
            (identical(other.salesTaxRate2, salesTaxRate2) || const DeepCollectionEquality().equals(other.salesTaxRate2, salesTaxRate2)) &&
            (identical(other.laborTaxRate2, laborTaxRate2) || const DeepCollectionEquality().equals(other.laborTaxRate2, laborTaxRate2)) &&
            (identical(other.hasRentalItem, hasRentalItem) || const DeepCollectionEquality().equals(other.hasRentalItem, hasRentalItem)) &&
            (identical(other.hasSalesItem, hasSalesItem) || const DeepCollectionEquality().equals(other.hasSalesItem, hasSalesItem)) &&
            (identical(other.hasMiscellaneousItem, hasMiscellaneousItem) || const DeepCollectionEquality().equals(other.hasMiscellaneousItem, hasMiscellaneousItem)) &&
            (identical(other.hasLaborItem, hasLaborItem) || const DeepCollectionEquality().equals(other.hasLaborItem, hasLaborItem)) &&
            (identical(other.hasFacilitiesItem, hasFacilitiesItem) || const DeepCollectionEquality().equals(other.hasFacilitiesItem, hasFacilitiesItem)) &&
            (identical(other.hasLossAndDamageItem, hasLossAndDamageItem) || const DeepCollectionEquality().equals(other.hasLossAndDamageItem, hasLossAndDamageItem)) &&
            (identical(other.hasRentalSaleItem, hasRentalSaleItem) || const DeepCollectionEquality().equals(other.hasRentalSaleItem, hasRentalSaleItem)) &&
            (identical(other.hasPartsItem, hasPartsItem) || const DeepCollectionEquality().equals(other.hasPartsItem, hasPartsItem)) &&
            (identical(other.rentalDiscountPercent, rentalDiscountPercent) || const DeepCollectionEquality().equals(other.rentalDiscountPercent, rentalDiscountPercent)) &&
            (identical(other.rentalTotal, rentalTotal) || const DeepCollectionEquality().equals(other.rentalTotal, rentalTotal)) &&
            (identical(other.rentalTotalIncludesTax, rentalTotalIncludesTax) || const DeepCollectionEquality().equals(other.rentalTotalIncludesTax, rentalTotalIncludesTax)) &&
            (identical(other.salesDiscountPercent, salesDiscountPercent) || const DeepCollectionEquality().equals(other.salesDiscountPercent, salesDiscountPercent)) &&
            (identical(other.salesTotal, salesTotal) || const DeepCollectionEquality().equals(other.salesTotal, salesTotal)) &&
            (identical(other.salesTotalIncludesTax, salesTotalIncludesTax) || const DeepCollectionEquality().equals(other.salesTotalIncludesTax, salesTotalIncludesTax)) &&
            (identical(other.partsDiscountPercent, partsDiscountPercent) || const DeepCollectionEquality().equals(other.partsDiscountPercent, partsDiscountPercent)) &&
            (identical(other.partsTotal, partsTotal) || const DeepCollectionEquality().equals(other.partsTotal, partsTotal)) &&
            (identical(other.partsTotalIncludesTax, partsTotalIncludesTax) || const DeepCollectionEquality().equals(other.partsTotalIncludesTax, partsTotalIncludesTax)) &&
            (identical(other.vehicleDiscountPercent, vehicleDiscountPercent) || const DeepCollectionEquality().equals(other.vehicleDiscountPercent, vehicleDiscountPercent)) &&
            (identical(other.vehicleTotal, vehicleTotal) || const DeepCollectionEquality().equals(other.vehicleTotal, vehicleTotal)) &&
            (identical(other.vehicleTotalIncludesTax, vehicleTotalIncludesTax) || const DeepCollectionEquality().equals(other.vehicleTotalIncludesTax, vehicleTotalIncludesTax)) &&
            (identical(other.miscDiscountPercent, miscDiscountPercent) || const DeepCollectionEquality().equals(other.miscDiscountPercent, miscDiscountPercent)) &&
            (identical(other.miscTotal, miscTotal) || const DeepCollectionEquality().equals(other.miscTotal, miscTotal)) &&
            (identical(other.miscTotalIncludesTax, miscTotalIncludesTax) || const DeepCollectionEquality().equals(other.miscTotalIncludesTax, miscTotalIncludesTax)) &&
            (identical(other.laborDiscountPercent, laborDiscountPercent) || const DeepCollectionEquality().equals(other.laborDiscountPercent, laborDiscountPercent)) &&
            (identical(other.laborTotal, laborTotal) || const DeepCollectionEquality().equals(other.laborTotal, laborTotal)) &&
            (identical(other.laborTotalIncludesTax, laborTotalIncludesTax) || const DeepCollectionEquality().equals(other.laborTotalIncludesTax, laborTotalIncludesTax)) &&
            (identical(other.subRentalDaysPerWeek, subRentalDaysPerWeek) || const DeepCollectionEquality().equals(other.subRentalDaysPerWeek, subRentalDaysPerWeek)) &&
            (identical(other.subRentalDiscountPercent, subRentalDiscountPercent) || const DeepCollectionEquality().equals(other.subRentalDiscountPercent, subRentalDiscountPercent)) &&
            (identical(other.weeklySubRentalTotal, weeklySubRentalTotal) || const DeepCollectionEquality().equals(other.weeklySubRentalTotal, weeklySubRentalTotal)) &&
            (identical(other.monthlySubRentalTotal, monthlySubRentalTotal) || const DeepCollectionEquality().equals(other.monthlySubRentalTotal, monthlySubRentalTotal)) &&
            (identical(other.periodSubRentalTotal, periodSubRentalTotal) || const DeepCollectionEquality().equals(other.periodSubRentalTotal, periodSubRentalTotal)) &&
            (identical(other.weeklySubRentalTotalIncludesTax, weeklySubRentalTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklySubRentalTotalIncludesTax, weeklySubRentalTotalIncludesTax)) &&
            (identical(other.monthlySubRentalTotalIncludesTax, monthlySubRentalTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlySubRentalTotalIncludesTax, monthlySubRentalTotalIncludesTax)) &&
            (identical(other.periodSubRentalTotalIncludesTax, periodSubRentalTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodSubRentalTotalIncludesTax, periodSubRentalTotalIncludesTax)) &&
            (identical(other.subSalesDiscountPercent, subSalesDiscountPercent) || const DeepCollectionEquality().equals(other.subSalesDiscountPercent, subSalesDiscountPercent)) &&
            (identical(other.subSalesTotal, subSalesTotal) || const DeepCollectionEquality().equals(other.subSalesTotal, subSalesTotal)) &&
            (identical(other.subSalesTotalIncludesTax, subSalesTotalIncludesTax) || const DeepCollectionEquality().equals(other.subSalesTotalIncludesTax, subSalesTotalIncludesTax)) &&
            (identical(other.subVehicleDaysPerWeek, subVehicleDaysPerWeek) || const DeepCollectionEquality().equals(other.subVehicleDaysPerWeek, subVehicleDaysPerWeek)) &&
            (identical(other.subvehicleDiscountPercent, subvehicleDiscountPercent) || const DeepCollectionEquality().equals(other.subvehicleDiscountPercent, subvehicleDiscountPercent)) &&
            (identical(other.weeklySubVehicleTotal, weeklySubVehicleTotal) || const DeepCollectionEquality().equals(other.weeklySubVehicleTotal, weeklySubVehicleTotal)) &&
            (identical(other.monthlySubVehicleTotal, monthlySubVehicleTotal) || const DeepCollectionEquality().equals(other.monthlySubVehicleTotal, monthlySubVehicleTotal)) &&
            (identical(other.periodSubVehicleTotal, periodSubVehicleTotal) || const DeepCollectionEquality().equals(other.periodSubVehicleTotal, periodSubVehicleTotal)) &&
            (identical(other.weeklySubVehicleTotalIncludesTax, weeklySubVehicleTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklySubVehicleTotalIncludesTax, weeklySubVehicleTotalIncludesTax)) &&
            (identical(other.monthlySubVehicleTotalIncludesTax, monthlySubVehicleTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlySubVehicleTotalIncludesTax, monthlySubVehicleTotalIncludesTax)) &&
            (identical(other.periodSubVehicleTotalIncludesTax, periodSubVehicleTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodSubVehicleTotalIncludesTax, periodSubVehicleTotalIncludesTax)) &&
            (identical(other.subMiscDiscountPercent, subMiscDiscountPercent) || const DeepCollectionEquality().equals(other.subMiscDiscountPercent, subMiscDiscountPercent)) &&
            (identical(other.weeklySubMiscTotal, weeklySubMiscTotal) || const DeepCollectionEquality().equals(other.weeklySubMiscTotal, weeklySubMiscTotal)) &&
            (identical(other.monthlySubMiscTotal, monthlySubMiscTotal) || const DeepCollectionEquality().equals(other.monthlySubMiscTotal, monthlySubMiscTotal)) &&
            (identical(other.periodSubMiscTotal, periodSubMiscTotal) || const DeepCollectionEquality().equals(other.periodSubMiscTotal, periodSubMiscTotal)) &&
            (identical(other.weeklySubMiscTotalIncludesTax, weeklySubMiscTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklySubMiscTotalIncludesTax, weeklySubMiscTotalIncludesTax)) &&
            (identical(other.monthlySubMiscTotalIncludesTax, monthlySubMiscTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlySubMiscTotalIncludesTax, monthlySubMiscTotalIncludesTax)) &&
            (identical(other.periodSubMiscTotalIncludesTax, periodSubMiscTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodSubMiscTotalIncludesTax, periodSubMiscTotalIncludesTax)) &&
            (identical(other.subLaborDiscountPercent, subLaborDiscountPercent) || const DeepCollectionEquality().equals(other.subLaborDiscountPercent, subLaborDiscountPercent)) &&
            (identical(other.weeklySubLaborTotal, weeklySubLaborTotal) || const DeepCollectionEquality().equals(other.weeklySubLaborTotal, weeklySubLaborTotal)) &&
            (identical(other.monthlySubLaborTotal, monthlySubLaborTotal) || const DeepCollectionEquality().equals(other.monthlySubLaborTotal, monthlySubLaborTotal)) &&
            (identical(other.periodSubLaborTotal, periodSubLaborTotal) || const DeepCollectionEquality().equals(other.periodSubLaborTotal, periodSubLaborTotal)) &&
            (identical(other.weeklySubLaborTotalIncludesTax, weeklySubLaborTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklySubLaborTotalIncludesTax, weeklySubLaborTotalIncludesTax)) &&
            (identical(other.monthlySubLaborTotalIncludesTax, monthlySubLaborTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlySubLaborTotalIncludesTax, monthlySubLaborTotalIncludesTax)) &&
            (identical(other.periodSubLaborTotalIncludesTax, periodSubLaborTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodSubLaborTotalIncludesTax, periodSubLaborTotalIncludesTax)) &&
            (identical(other.miscellaneousIsComplete, miscellaneousIsComplete) || const DeepCollectionEquality().equals(other.miscellaneousIsComplete, miscellaneousIsComplete)) &&
            (identical(other.subMiscellaneousIsComplete, subMiscellaneousIsComplete) || const DeepCollectionEquality().equals(other.subMiscellaneousIsComplete, subMiscellaneousIsComplete)) &&
            (identical(other.laborIsComplete, laborIsComplete) || const DeepCollectionEquality().equals(other.laborIsComplete, laborIsComplete)) &&
            (identical(other.subLaborIsComplete, subLaborIsComplete) || const DeepCollectionEquality().equals(other.subLaborIsComplete, subLaborIsComplete)) &&
            (identical(other.currencyColor, currencyColor) || const DeepCollectionEquality().equals(other.currencyColor, currencyColor)) &&
            (identical(other.statusColor, statusColor) || const DeepCollectionEquality().equals(other.statusColor, statusColor)) &&
            (identical(other.purchaseOrderNumberColor, purchaseOrderNumberColor) || const DeepCollectionEquality().equals(other.purchaseOrderNumberColor, purchaseOrderNumberColor)) &&
            (identical(other.vendorColor, vendorColor) || const DeepCollectionEquality().equals(other.vendorColor, vendorColor)) &&
            (identical(other.descriptionColor, descriptionColor) || const DeepCollectionEquality().equals(other.descriptionColor, descriptionColor)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.items, items) || const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesAgentPurchaseOrderGetPurchaseOrderResponseExtension
    on WebApiModulesAgentPurchaseOrderGetPurchaseOrderResponse {
  WebApiModulesAgentPurchaseOrderGetPurchaseOrderResponse copyWith(
      {String? purchaseOrderId,
      String? purchaseOrderNumber,
      String? description,
      String? purchaseOrderDate,
      String? requisitionNumber,
      String? requisitionDate,
      String? vendorId,
      String? vendor,
      String? agentId,
      String? agent,
      String? status,
      String? statusDate,
      String? referenceNumber,
      bool? needsApproval,
      String? approvedByUserId,
      String? departmentId,
      String? department,
      String? officeLocationId,
      String? officeLocation,
      String? warehouseId,
      String? warehouse,
      String? warehouseCode,
      int? quantityHolding,
      int? quantityToBarCode,
      bool? rental,
      bool? sales,
      bool? parts,
      bool? labor,
      bool? miscellaneous,
      bool? vehicle,
      bool? subRent,
      bool? subSale,
      bool? subLabor,
      bool? subMiscellaneous,
      bool? subVehicle,
      bool? repair,
      bool? consignment,
      String? consignorAgreementId,
      String? consignorAgreementNumber,
      String? orderId,
      String? orderNumber,
      String? dealNumber,
      String? dealId,
      String? deal,
      String? rateType,
      bool? departmentLocationRequiresApproval,
      double? total,
      String? poTypeId,
      String? poType,
      String? poClassificationId,
      String? poClassification,
      List<WebApiModulesHomeControlsOrderDatesOrderDates>?
          activityDatesAndTimes,
      String? estimatedStartDate,
      String? estimatedStartTime,
      String? estimatedStopDate,
      String? estimatedStopTime,
      String? billingStartDate,
      String? billingEndDate,
      double? billingWeeks,
      double? billingMonths,
      double? invoicedAmount,
      String? projectManagerId,
      String? projectManager,
      String? receiveDeliveryId,
      String? receiveDeliveryDeliveryType,
      String? receiveDeliveryRequiredDate,
      String? receiveDeliveryRequiredTime,
      String? receiveDeliveryTargetShipDate,
      String? receiveDeliveryTargetShipTime,
      String? receiveDeliveryDirection,
      String? receiveDeliveryAddressType,
      String? receiveDeliveryFromLocation,
      String? receiveDeliveryFromContact,
      String? receiveDeliveryFromContactPhone,
      String? receiveDeliveryFromAlternateContact,
      String? receiveDeliveryFromAlternateContactPhone,
      String? receiveDeliveryFromAttention,
      String? receiveDeliveryFromAddress1,
      String? receiveDeliveryFromAdd2ress,
      String? receiveDeliveryFromCity,
      String? receiveDeliveryFromState,
      String? receiveDeliveryFromZipCode,
      String? receiveDeliveryFromCountry,
      String? receiveDeliveryFromCountryId,
      String? receiveDeliveryFromCrossStreets,
      String? receiveDeliveryToLocation,
      String? receiveDeliveryToVenue,
      String? receiveDeliveryToVenueId,
      String? receiveDeliveryToWarehouse,
      String? receiveDeliveryToWarehouseId,
      String? receiveDeliveryToContact,
      String? receiveDeliveryToContactPhone,
      String? receiveDeliveryToAlternateContact,
      String? receiveDeliveryToAlternateContactPhone,
      String? receiveDeliveryToAttention,
      String? receiveDeliveryToAddress1,
      String? receiveDeliveryToAddress2,
      String? receiveDeliveryToCity,
      String? receiveDeliveryToState,
      String? receiveDeliveryToZipCode,
      String? receiveDeliveryToCountryId,
      String? receiveDeliveryToCountry,
      String? receiveDeliveryToContactFax,
      String? receiveDeliveryToCrossStreets,
      String? receiveDeliveryDeliveryNotes,
      String? receiveDeliveryCarrierId,
      String? receiveDeliveryCarrier,
      String? receiveDeliveryCarrierAccount,
      String? receiveDeliveryShipViaId,
      String? receiveDeliveryShipVia,
      String? receiveDeliveryInvoiceId,
      String? receiveDeliveryVendorInvoiceId,
      double? receiveDeliveryEstimatedFreight,
      double? receiveDeliveryFreightInvoiceAmount,
      String? receiveDeliveryChargeType,
      String? receiveDeliveryFreightTrackingNumber,
      String? receiveDeliveryFreightTrackingUrl,
      bool? receiveDeliveryDropShip,
      String? receiveDeliveryPackageCode,
      bool? receiveDeliveryBillPoFreightOnOrder,
      String? receiveDeliveryOnlineOrderNumber,
      String? receiveDeliveryOnlineOrderStatus,
      String? receiveDeliveryDateStamp,
      String? returnDeliveryId,
      String? returnDeliveryDeliveryType,
      String? returnDeliveryRequiredDate,
      String? returnDeliveryRequiredTime,
      String? returnDeliveryTargetShipDate,
      String? returnDeliveryTargetShipTime,
      String? returnDeliveryDirection,
      String? returnDeliveryAddressType,
      String? returnDeliveryFromLocation,
      String? returnDeliveryFromContact,
      String? returnDeliveryFromContactPhone,
      String? returnDeliveryFromAlternateContact,
      String? returnDeliveryFromAlternateContactPhone,
      String? returnDeliveryFromAttention,
      String? returnDeliveryFromAddress1,
      String? returnDeliveryFromAdd2ress,
      String? returnDeliveryFromCity,
      String? returnDeliveryFromState,
      String? returnDeliveryFromZipCode,
      String? returnDeliveryFromCountry,
      String? returnDeliveryFromCountryId,
      String? returnDeliveryFromCrossStreets,
      String? returnDeliveryToLocation,
      String? returnDeliveryToVenue,
      String? returnDeliveryToVenueId,
      String? returnDeliveryToWarehouse,
      String? returnDeliveryToWarehouseId,
      String? returnDeliveryToContact,
      String? returnDeliveryToContactPhone,
      String? returnDeliveryToAlternateContact,
      String? returnDeliveryToAlternateContactPhone,
      String? returnDeliveryToAttention,
      String? returnDeliveryToAddress1,
      String? returnDeliveryToAddress2,
      String? returnDeliveryToCity,
      String? returnDeliveryToState,
      String? returnDeliveryToZipCode,
      String? returnDeliveryToCountryId,
      String? returnDeliveryToCountry,
      String? returnDeliveryToContactFax,
      String? returnDeliveryToCrossStreets,
      String? returnDeliveryDeliveryNotes,
      String? returnDeliveryCarrierId,
      String? returnDeliveryCarrier,
      String? returnDeliveryCarrierAccount,
      String? returnDeliveryShipViaId,
      String? returnDeliveryShipVia,
      String? returnDeliveryInvoiceId,
      String? returnDeliveryVendorInvoiceId,
      double? returnDeliveryEstimatedFreight,
      double? returnDeliveryFreightInvoiceAmount,
      String? returnDeliveryChargeType,
      String? returnDeliveryFreightTrackingNumber,
      String? returnDeliveryFreightTrackingUrl,
      bool? returnDeliveryVendorRetrieve,
      String? returnDeliveryPackageCode,
      bool? returnDeliveryBillPoFreightOnOrder,
      String? returnDeliveryOnlineOrderNumber,
      String? returnDeliveryOnlineOrderStatus,
      String? returnDeliveryDateStamp,
      bool? enableProjects,
      String? projectId,
      String? projectNumber,
      String? project,
      String? projectDrawingsId,
      String? projectDrawings,
      String? projectItemsOrderedId,
      String? projectItemsOrdered,
      String? projectDropShipId,
      String? projectDropShip,
      String? projectAsBuildId,
      String? projectAsBuild,
      String? projectCommissioningId,
      String? projectCommissioning,
      String? projectDepositId,
      String? projectDeposit,
      String? location,
      String? currencyId,
      bool? updateAllRatesToNewCurrency,
      String? confirmUpdateAllRatesToNewCurrency,
      String? currencyCode,
      String? currency,
      String? currencySymbol,
      String? billingCycleId,
      String? billingCycle,
      String? remitToAttention1,
      String? remitToAttention2,
      String? remitToAddress1,
      String? remitToAddress2,
      String? remitToCity,
      String? remitToState,
      String? remitToCountryId,
      String? remitToCountry,
      String? remitToZipCode,
      String? remitToEmail,
      String? remitToPhone,
      String? paymentTypeId,
      String? paymentType,
      String? paymentTermsId,
      String? paymentTerms,
      int? paymentTermsDueInDays,
      String? taxOptionId,
      String? taxOption,
      String? taxId,
      String? tax1Name,
      String? tax2Name,
      double? rentalTaxRate1,
      double? salesTaxRate1,
      double? laborTaxRate1,
      double? rentalTaxRate2,
      double? salesTaxRate2,
      double? laborTaxRate2,
      bool? hasRentalItem,
      bool? hasSalesItem,
      bool? hasMiscellaneousItem,
      bool? hasLaborItem,
      bool? hasFacilitiesItem,
      bool? hasLossAndDamageItem,
      bool? hasRentalSaleItem,
      bool? hasPartsItem,
      double? rentalDiscountPercent,
      double? rentalTotal,
      bool? rentalTotalIncludesTax,
      double? salesDiscountPercent,
      double? salesTotal,
      bool? salesTotalIncludesTax,
      double? partsDiscountPercent,
      double? partsTotal,
      bool? partsTotalIncludesTax,
      double? vehicleDiscountPercent,
      double? vehicleTotal,
      bool? vehicleTotalIncludesTax,
      double? miscDiscountPercent,
      double? miscTotal,
      bool? miscTotalIncludesTax,
      double? laborDiscountPercent,
      double? laborTotal,
      bool? laborTotalIncludesTax,
      double? subRentalDaysPerWeek,
      double? subRentalDiscountPercent,
      double? weeklySubRentalTotal,
      double? monthlySubRentalTotal,
      double? periodSubRentalTotal,
      bool? weeklySubRentalTotalIncludesTax,
      bool? monthlySubRentalTotalIncludesTax,
      bool? periodSubRentalTotalIncludesTax,
      double? subSalesDiscountPercent,
      double? subSalesTotal,
      bool? subSalesTotalIncludesTax,
      double? subVehicleDaysPerWeek,
      double? subvehicleDiscountPercent,
      double? weeklySubVehicleTotal,
      double? monthlySubVehicleTotal,
      double? periodSubVehicleTotal,
      bool? weeklySubVehicleTotalIncludesTax,
      bool? monthlySubVehicleTotalIncludesTax,
      bool? periodSubVehicleTotalIncludesTax,
      double? subMiscDiscountPercent,
      double? weeklySubMiscTotal,
      double? monthlySubMiscTotal,
      double? periodSubMiscTotal,
      bool? weeklySubMiscTotalIncludesTax,
      bool? monthlySubMiscTotalIncludesTax,
      bool? periodSubMiscTotalIncludesTax,
      double? subLaborDiscountPercent,
      double? weeklySubLaborTotal,
      double? monthlySubLaborTotal,
      double? periodSubLaborTotal,
      bool? weeklySubLaborTotalIncludesTax,
      bool? monthlySubLaborTotalIncludesTax,
      bool? periodSubLaborTotalIncludesTax,
      bool? miscellaneousIsComplete,
      bool? subMiscellaneousIsComplete,
      bool? laborIsComplete,
      bool? subLaborIsComplete,
      String? currencyColor,
      String? statusColor,
      String? purchaseOrderNumberColor,
      String? vendorColor,
      String? descriptionColor,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<WebApiModulesHomeControlsOrderItemOrderItem>? items,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAgentPurchaseOrderGetPurchaseOrderResponse(
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        purchaseOrderNumber: purchaseOrderNumber ?? this.purchaseOrderNumber,
        description: description ?? this.description,
        purchaseOrderDate: purchaseOrderDate ?? this.purchaseOrderDate,
        requisitionNumber: requisitionNumber ?? this.requisitionNumber,
        requisitionDate: requisitionDate ?? this.requisitionDate,
        vendorId: vendorId ?? this.vendorId,
        vendor: vendor ?? this.vendor,
        agentId: agentId ?? this.agentId,
        agent: agent ?? this.agent,
        status: status ?? this.status,
        statusDate: statusDate ?? this.statusDate,
        referenceNumber: referenceNumber ?? this.referenceNumber,
        needsApproval: needsApproval ?? this.needsApproval,
        approvedByUserId: approvedByUserId ?? this.approvedByUserId,
        departmentId: departmentId ?? this.departmentId,
        department: department ?? this.department,
        officeLocationId: officeLocationId ?? this.officeLocationId,
        officeLocation: officeLocation ?? this.officeLocation,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouse: warehouse ?? this.warehouse,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        quantityHolding: quantityHolding ?? this.quantityHolding,
        quantityToBarCode: quantityToBarCode ?? this.quantityToBarCode,
        rental: rental ?? this.rental,
        sales: sales ?? this.sales,
        parts: parts ?? this.parts,
        labor: labor ?? this.labor,
        miscellaneous: miscellaneous ?? this.miscellaneous,
        vehicle: vehicle ?? this.vehicle,
        subRent: subRent ?? this.subRent,
        subSale: subSale ?? this.subSale,
        subLabor: subLabor ?? this.subLabor,
        subMiscellaneous: subMiscellaneous ?? this.subMiscellaneous,
        subVehicle: subVehicle ?? this.subVehicle,
        repair: repair ?? this.repair,
        consignment: consignment ?? this.consignment,
        consignorAgreementId: consignorAgreementId ?? this.consignorAgreementId,
        consignorAgreementNumber:
            consignorAgreementNumber ?? this.consignorAgreementNumber,
        orderId: orderId ?? this.orderId,
        orderNumber: orderNumber ?? this.orderNumber,
        dealNumber: dealNumber ?? this.dealNumber,
        dealId: dealId ?? this.dealId,
        deal: deal ?? this.deal,
        rateType: rateType ?? this.rateType,
        departmentLocationRequiresApproval: departmentLocationRequiresApproval ??
            this.departmentLocationRequiresApproval,
        total: total ?? this.total,
        poTypeId: poTypeId ?? this.poTypeId,
        poType: poType ?? this.poType,
        poClassificationId: poClassificationId ?? this.poClassificationId,
        poClassification: poClassification ?? this.poClassification,
        activityDatesAndTimes:
            activityDatesAndTimes ?? this.activityDatesAndTimes,
        estimatedStartDate: estimatedStartDate ?? this.estimatedStartDate,
        estimatedStartTime: estimatedStartTime ?? this.estimatedStartTime,
        estimatedStopDate: estimatedStopDate ?? this.estimatedStopDate,
        estimatedStopTime: estimatedStopTime ?? this.estimatedStopTime,
        billingStartDate: billingStartDate ?? this.billingStartDate,
        billingEndDate: billingEndDate ?? this.billingEndDate,
        billingWeeks: billingWeeks ?? this.billingWeeks,
        billingMonths: billingMonths ?? this.billingMonths,
        invoicedAmount: invoicedAmount ?? this.invoicedAmount,
        projectManagerId: projectManagerId ?? this.projectManagerId,
        projectManager: projectManager ?? this.projectManager,
        receiveDeliveryId: receiveDeliveryId ?? this.receiveDeliveryId,
        receiveDeliveryDeliveryType:
            receiveDeliveryDeliveryType ?? this.receiveDeliveryDeliveryType,
        receiveDeliveryRequiredDate:
            receiveDeliveryRequiredDate ?? this.receiveDeliveryRequiredDate,
        receiveDeliveryRequiredTime:
            receiveDeliveryRequiredTime ?? this.receiveDeliveryRequiredTime,
        receiveDeliveryTargetShipDate:
            receiveDeliveryTargetShipDate ?? this.receiveDeliveryTargetShipDate,
        receiveDeliveryTargetShipTime:
            receiveDeliveryTargetShipTime ?? this.receiveDeliveryTargetShipTime,
        receiveDeliveryDirection:
            receiveDeliveryDirection ?? this.receiveDeliveryDirection,
        receiveDeliveryAddressType:
            receiveDeliveryAddressType ?? this.receiveDeliveryAddressType,
        receiveDeliveryFromLocation:
            receiveDeliveryFromLocation ?? this.receiveDeliveryFromLocation,
        receiveDeliveryFromContact:
            receiveDeliveryFromContact ?? this.receiveDeliveryFromContact,
        receiveDeliveryFromContactPhone: receiveDeliveryFromContactPhone ??
            this.receiveDeliveryFromContactPhone,
        receiveDeliveryFromAlternateContact: receiveDeliveryFromAlternateContact ??
            this.receiveDeliveryFromAlternateContact,
        receiveDeliveryFromAlternateContactPhone:
            receiveDeliveryFromAlternateContactPhone ??
                this.receiveDeliveryFromAlternateContactPhone,
        receiveDeliveryFromAttention:
            receiveDeliveryFromAttention ?? this.receiveDeliveryFromAttention,
        receiveDeliveryFromAddress1:
            receiveDeliveryFromAddress1 ?? this.receiveDeliveryFromAddress1,
        receiveDeliveryFromAdd2ress:
            receiveDeliveryFromAdd2ress ?? this.receiveDeliveryFromAdd2ress,
        receiveDeliveryFromCity:
            receiveDeliveryFromCity ?? this.receiveDeliveryFromCity,
        receiveDeliveryFromState:
            receiveDeliveryFromState ?? this.receiveDeliveryFromState,
        receiveDeliveryFromZipCode:
            receiveDeliveryFromZipCode ?? this.receiveDeliveryFromZipCode,
        receiveDeliveryFromCountry:
            receiveDeliveryFromCountry ?? this.receiveDeliveryFromCountry,
        receiveDeliveryFromCountryId:
            receiveDeliveryFromCountryId ?? this.receiveDeliveryFromCountryId,
        receiveDeliveryFromCrossStreets: receiveDeliveryFromCrossStreets ??
            this.receiveDeliveryFromCrossStreets,
        receiveDeliveryToLocation:
            receiveDeliveryToLocation ?? this.receiveDeliveryToLocation,
        receiveDeliveryToVenue:
            receiveDeliveryToVenue ?? this.receiveDeliveryToVenue,
        receiveDeliveryToVenueId:
            receiveDeliveryToVenueId ?? this.receiveDeliveryToVenueId,
        receiveDeliveryToWarehouse:
            receiveDeliveryToWarehouse ?? this.receiveDeliveryToWarehouse,
        receiveDeliveryToWarehouseId:
            receiveDeliveryToWarehouseId ?? this.receiveDeliveryToWarehouseId,
        receiveDeliveryToContact:
            receiveDeliveryToContact ?? this.receiveDeliveryToContact,
        receiveDeliveryToContactPhone:
            receiveDeliveryToContactPhone ?? this.receiveDeliveryToContactPhone,
        receiveDeliveryToAlternateContact: receiveDeliveryToAlternateContact ??
            this.receiveDeliveryToAlternateContact,
        receiveDeliveryToAlternateContactPhone: receiveDeliveryToAlternateContactPhone ??
            this.receiveDeliveryToAlternateContactPhone,
        receiveDeliveryToAttention:
            receiveDeliveryToAttention ?? this.receiveDeliveryToAttention,
        receiveDeliveryToAddress1:
            receiveDeliveryToAddress1 ?? this.receiveDeliveryToAddress1,
        receiveDeliveryToAddress2: receiveDeliveryToAddress2 ?? this.receiveDeliveryToAddress2,
        receiveDeliveryToCity: receiveDeliveryToCity ?? this.receiveDeliveryToCity,
        receiveDeliveryToState: receiveDeliveryToState ?? this.receiveDeliveryToState,
        receiveDeliveryToZipCode: receiveDeliveryToZipCode ?? this.receiveDeliveryToZipCode,
        receiveDeliveryToCountryId: receiveDeliveryToCountryId ?? this.receiveDeliveryToCountryId,
        receiveDeliveryToCountry: receiveDeliveryToCountry ?? this.receiveDeliveryToCountry,
        receiveDeliveryToContactFax: receiveDeliveryToContactFax ?? this.receiveDeliveryToContactFax,
        receiveDeliveryToCrossStreets: receiveDeliveryToCrossStreets ?? this.receiveDeliveryToCrossStreets,
        receiveDeliveryDeliveryNotes: receiveDeliveryDeliveryNotes ?? this.receiveDeliveryDeliveryNotes,
        receiveDeliveryCarrierId: receiveDeliveryCarrierId ?? this.receiveDeliveryCarrierId,
        receiveDeliveryCarrier: receiveDeliveryCarrier ?? this.receiveDeliveryCarrier,
        receiveDeliveryCarrierAccount: receiveDeliveryCarrierAccount ?? this.receiveDeliveryCarrierAccount,
        receiveDeliveryShipViaId: receiveDeliveryShipViaId ?? this.receiveDeliveryShipViaId,
        receiveDeliveryShipVia: receiveDeliveryShipVia ?? this.receiveDeliveryShipVia,
        receiveDeliveryInvoiceId: receiveDeliveryInvoiceId ?? this.receiveDeliveryInvoiceId,
        receiveDeliveryVendorInvoiceId: receiveDeliveryVendorInvoiceId ?? this.receiveDeliveryVendorInvoiceId,
        receiveDeliveryEstimatedFreight: receiveDeliveryEstimatedFreight ?? this.receiveDeliveryEstimatedFreight,
        receiveDeliveryFreightInvoiceAmount: receiveDeliveryFreightInvoiceAmount ?? this.receiveDeliveryFreightInvoiceAmount,
        receiveDeliveryChargeType: receiveDeliveryChargeType ?? this.receiveDeliveryChargeType,
        receiveDeliveryFreightTrackingNumber: receiveDeliveryFreightTrackingNumber ?? this.receiveDeliveryFreightTrackingNumber,
        receiveDeliveryFreightTrackingUrl: receiveDeliveryFreightTrackingUrl ?? this.receiveDeliveryFreightTrackingUrl,
        receiveDeliveryDropShip: receiveDeliveryDropShip ?? this.receiveDeliveryDropShip,
        receiveDeliveryPackageCode: receiveDeliveryPackageCode ?? this.receiveDeliveryPackageCode,
        receiveDeliveryBillPoFreightOnOrder: receiveDeliveryBillPoFreightOnOrder ?? this.receiveDeliveryBillPoFreightOnOrder,
        receiveDeliveryOnlineOrderNumber: receiveDeliveryOnlineOrderNumber ?? this.receiveDeliveryOnlineOrderNumber,
        receiveDeliveryOnlineOrderStatus: receiveDeliveryOnlineOrderStatus ?? this.receiveDeliveryOnlineOrderStatus,
        receiveDeliveryDateStamp: receiveDeliveryDateStamp ?? this.receiveDeliveryDateStamp,
        returnDeliveryId: returnDeliveryId ?? this.returnDeliveryId,
        returnDeliveryDeliveryType: returnDeliveryDeliveryType ?? this.returnDeliveryDeliveryType,
        returnDeliveryRequiredDate: returnDeliveryRequiredDate ?? this.returnDeliveryRequiredDate,
        returnDeliveryRequiredTime: returnDeliveryRequiredTime ?? this.returnDeliveryRequiredTime,
        returnDeliveryTargetShipDate: returnDeliveryTargetShipDate ?? this.returnDeliveryTargetShipDate,
        returnDeliveryTargetShipTime: returnDeliveryTargetShipTime ?? this.returnDeliveryTargetShipTime,
        returnDeliveryDirection: returnDeliveryDirection ?? this.returnDeliveryDirection,
        returnDeliveryAddressType: returnDeliveryAddressType ?? this.returnDeliveryAddressType,
        returnDeliveryFromLocation: returnDeliveryFromLocation ?? this.returnDeliveryFromLocation,
        returnDeliveryFromContact: returnDeliveryFromContact ?? this.returnDeliveryFromContact,
        returnDeliveryFromContactPhone: returnDeliveryFromContactPhone ?? this.returnDeliveryFromContactPhone,
        returnDeliveryFromAlternateContact: returnDeliveryFromAlternateContact ?? this.returnDeliveryFromAlternateContact,
        returnDeliveryFromAlternateContactPhone: returnDeliveryFromAlternateContactPhone ?? this.returnDeliveryFromAlternateContactPhone,
        returnDeliveryFromAttention: returnDeliveryFromAttention ?? this.returnDeliveryFromAttention,
        returnDeliveryFromAddress1: returnDeliveryFromAddress1 ?? this.returnDeliveryFromAddress1,
        returnDeliveryFromAdd2ress: returnDeliveryFromAdd2ress ?? this.returnDeliveryFromAdd2ress,
        returnDeliveryFromCity: returnDeliveryFromCity ?? this.returnDeliveryFromCity,
        returnDeliveryFromState: returnDeliveryFromState ?? this.returnDeliveryFromState,
        returnDeliveryFromZipCode: returnDeliveryFromZipCode ?? this.returnDeliveryFromZipCode,
        returnDeliveryFromCountry: returnDeliveryFromCountry ?? this.returnDeliveryFromCountry,
        returnDeliveryFromCountryId: returnDeliveryFromCountryId ?? this.returnDeliveryFromCountryId,
        returnDeliveryFromCrossStreets: returnDeliveryFromCrossStreets ?? this.returnDeliveryFromCrossStreets,
        returnDeliveryToLocation: returnDeliveryToLocation ?? this.returnDeliveryToLocation,
        returnDeliveryToVenue: returnDeliveryToVenue ?? this.returnDeliveryToVenue,
        returnDeliveryToVenueId: returnDeliveryToVenueId ?? this.returnDeliveryToVenueId,
        returnDeliveryToWarehouse: returnDeliveryToWarehouse ?? this.returnDeliveryToWarehouse,
        returnDeliveryToWarehouseId: returnDeliveryToWarehouseId ?? this.returnDeliveryToWarehouseId,
        returnDeliveryToContact: returnDeliveryToContact ?? this.returnDeliveryToContact,
        returnDeliveryToContactPhone: returnDeliveryToContactPhone ?? this.returnDeliveryToContactPhone,
        returnDeliveryToAlternateContact: returnDeliveryToAlternateContact ?? this.returnDeliveryToAlternateContact,
        returnDeliveryToAlternateContactPhone: returnDeliveryToAlternateContactPhone ?? this.returnDeliveryToAlternateContactPhone,
        returnDeliveryToAttention: returnDeliveryToAttention ?? this.returnDeliveryToAttention,
        returnDeliveryToAddress1: returnDeliveryToAddress1 ?? this.returnDeliveryToAddress1,
        returnDeliveryToAddress2: returnDeliveryToAddress2 ?? this.returnDeliveryToAddress2,
        returnDeliveryToCity: returnDeliveryToCity ?? this.returnDeliveryToCity,
        returnDeliveryToState: returnDeliveryToState ?? this.returnDeliveryToState,
        returnDeliveryToZipCode: returnDeliveryToZipCode ?? this.returnDeliveryToZipCode,
        returnDeliveryToCountryId: returnDeliveryToCountryId ?? this.returnDeliveryToCountryId,
        returnDeliveryToCountry: returnDeliveryToCountry ?? this.returnDeliveryToCountry,
        returnDeliveryToContactFax: returnDeliveryToContactFax ?? this.returnDeliveryToContactFax,
        returnDeliveryToCrossStreets: returnDeliveryToCrossStreets ?? this.returnDeliveryToCrossStreets,
        returnDeliveryDeliveryNotes: returnDeliveryDeliveryNotes ?? this.returnDeliveryDeliveryNotes,
        returnDeliveryCarrierId: returnDeliveryCarrierId ?? this.returnDeliveryCarrierId,
        returnDeliveryCarrier: returnDeliveryCarrier ?? this.returnDeliveryCarrier,
        returnDeliveryCarrierAccount: returnDeliveryCarrierAccount ?? this.returnDeliveryCarrierAccount,
        returnDeliveryShipViaId: returnDeliveryShipViaId ?? this.returnDeliveryShipViaId,
        returnDeliveryShipVia: returnDeliveryShipVia ?? this.returnDeliveryShipVia,
        returnDeliveryInvoiceId: returnDeliveryInvoiceId ?? this.returnDeliveryInvoiceId,
        returnDeliveryVendorInvoiceId: returnDeliveryVendorInvoiceId ?? this.returnDeliveryVendorInvoiceId,
        returnDeliveryEstimatedFreight: returnDeliveryEstimatedFreight ?? this.returnDeliveryEstimatedFreight,
        returnDeliveryFreightInvoiceAmount: returnDeliveryFreightInvoiceAmount ?? this.returnDeliveryFreightInvoiceAmount,
        returnDeliveryChargeType: returnDeliveryChargeType ?? this.returnDeliveryChargeType,
        returnDeliveryFreightTrackingNumber: returnDeliveryFreightTrackingNumber ?? this.returnDeliveryFreightTrackingNumber,
        returnDeliveryFreightTrackingUrl: returnDeliveryFreightTrackingUrl ?? this.returnDeliveryFreightTrackingUrl,
        returnDeliveryVendorRetrieve: returnDeliveryVendorRetrieve ?? this.returnDeliveryVendorRetrieve,
        returnDeliveryPackageCode: returnDeliveryPackageCode ?? this.returnDeliveryPackageCode,
        returnDeliveryBillPoFreightOnOrder: returnDeliveryBillPoFreightOnOrder ?? this.returnDeliveryBillPoFreightOnOrder,
        returnDeliveryOnlineOrderNumber: returnDeliveryOnlineOrderNumber ?? this.returnDeliveryOnlineOrderNumber,
        returnDeliveryOnlineOrderStatus: returnDeliveryOnlineOrderStatus ?? this.returnDeliveryOnlineOrderStatus,
        returnDeliveryDateStamp: returnDeliveryDateStamp ?? this.returnDeliveryDateStamp,
        enableProjects: enableProjects ?? this.enableProjects,
        projectId: projectId ?? this.projectId,
        projectNumber: projectNumber ?? this.projectNumber,
        project: project ?? this.project,
        projectDrawingsId: projectDrawingsId ?? this.projectDrawingsId,
        projectDrawings: projectDrawings ?? this.projectDrawings,
        projectItemsOrderedId: projectItemsOrderedId ?? this.projectItemsOrderedId,
        projectItemsOrdered: projectItemsOrdered ?? this.projectItemsOrdered,
        projectDropShipId: projectDropShipId ?? this.projectDropShipId,
        projectDropShip: projectDropShip ?? this.projectDropShip,
        projectAsBuildId: projectAsBuildId ?? this.projectAsBuildId,
        projectAsBuild: projectAsBuild ?? this.projectAsBuild,
        projectCommissioningId: projectCommissioningId ?? this.projectCommissioningId,
        projectCommissioning: projectCommissioning ?? this.projectCommissioning,
        projectDepositId: projectDepositId ?? this.projectDepositId,
        projectDeposit: projectDeposit ?? this.projectDeposit,
        location: location ?? this.location,
        currencyId: currencyId ?? this.currencyId,
        updateAllRatesToNewCurrency: updateAllRatesToNewCurrency ?? this.updateAllRatesToNewCurrency,
        confirmUpdateAllRatesToNewCurrency: confirmUpdateAllRatesToNewCurrency ?? this.confirmUpdateAllRatesToNewCurrency,
        currencyCode: currencyCode ?? this.currencyCode,
        currency: currency ?? this.currency,
        currencySymbol: currencySymbol ?? this.currencySymbol,
        billingCycleId: billingCycleId ?? this.billingCycleId,
        billingCycle: billingCycle ?? this.billingCycle,
        remitToAttention1: remitToAttention1 ?? this.remitToAttention1,
        remitToAttention2: remitToAttention2 ?? this.remitToAttention2,
        remitToAddress1: remitToAddress1 ?? this.remitToAddress1,
        remitToAddress2: remitToAddress2 ?? this.remitToAddress2,
        remitToCity: remitToCity ?? this.remitToCity,
        remitToState: remitToState ?? this.remitToState,
        remitToCountryId: remitToCountryId ?? this.remitToCountryId,
        remitToCountry: remitToCountry ?? this.remitToCountry,
        remitToZipCode: remitToZipCode ?? this.remitToZipCode,
        remitToEmail: remitToEmail ?? this.remitToEmail,
        remitToPhone: remitToPhone ?? this.remitToPhone,
        paymentTypeId: paymentTypeId ?? this.paymentTypeId,
        paymentType: paymentType ?? this.paymentType,
        paymentTermsId: paymentTermsId ?? this.paymentTermsId,
        paymentTerms: paymentTerms ?? this.paymentTerms,
        paymentTermsDueInDays: paymentTermsDueInDays ?? this.paymentTermsDueInDays,
        taxOptionId: taxOptionId ?? this.taxOptionId,
        taxOption: taxOption ?? this.taxOption,
        taxId: taxId ?? this.taxId,
        tax1Name: tax1Name ?? this.tax1Name,
        tax2Name: tax2Name ?? this.tax2Name,
        rentalTaxRate1: rentalTaxRate1 ?? this.rentalTaxRate1,
        salesTaxRate1: salesTaxRate1 ?? this.salesTaxRate1,
        laborTaxRate1: laborTaxRate1 ?? this.laborTaxRate1,
        rentalTaxRate2: rentalTaxRate2 ?? this.rentalTaxRate2,
        salesTaxRate2: salesTaxRate2 ?? this.salesTaxRate2,
        laborTaxRate2: laborTaxRate2 ?? this.laborTaxRate2,
        hasRentalItem: hasRentalItem ?? this.hasRentalItem,
        hasSalesItem: hasSalesItem ?? this.hasSalesItem,
        hasMiscellaneousItem: hasMiscellaneousItem ?? this.hasMiscellaneousItem,
        hasLaborItem: hasLaborItem ?? this.hasLaborItem,
        hasFacilitiesItem: hasFacilitiesItem ?? this.hasFacilitiesItem,
        hasLossAndDamageItem: hasLossAndDamageItem ?? this.hasLossAndDamageItem,
        hasRentalSaleItem: hasRentalSaleItem ?? this.hasRentalSaleItem,
        hasPartsItem: hasPartsItem ?? this.hasPartsItem,
        rentalDiscountPercent: rentalDiscountPercent ?? this.rentalDiscountPercent,
        rentalTotal: rentalTotal ?? this.rentalTotal,
        rentalTotalIncludesTax: rentalTotalIncludesTax ?? this.rentalTotalIncludesTax,
        salesDiscountPercent: salesDiscountPercent ?? this.salesDiscountPercent,
        salesTotal: salesTotal ?? this.salesTotal,
        salesTotalIncludesTax: salesTotalIncludesTax ?? this.salesTotalIncludesTax,
        partsDiscountPercent: partsDiscountPercent ?? this.partsDiscountPercent,
        partsTotal: partsTotal ?? this.partsTotal,
        partsTotalIncludesTax: partsTotalIncludesTax ?? this.partsTotalIncludesTax,
        vehicleDiscountPercent: vehicleDiscountPercent ?? this.vehicleDiscountPercent,
        vehicleTotal: vehicleTotal ?? this.vehicleTotal,
        vehicleTotalIncludesTax: vehicleTotalIncludesTax ?? this.vehicleTotalIncludesTax,
        miscDiscountPercent: miscDiscountPercent ?? this.miscDiscountPercent,
        miscTotal: miscTotal ?? this.miscTotal,
        miscTotalIncludesTax: miscTotalIncludesTax ?? this.miscTotalIncludesTax,
        laborDiscountPercent: laborDiscountPercent ?? this.laborDiscountPercent,
        laborTotal: laborTotal ?? this.laborTotal,
        laborTotalIncludesTax: laborTotalIncludesTax ?? this.laborTotalIncludesTax,
        subRentalDaysPerWeek: subRentalDaysPerWeek ?? this.subRentalDaysPerWeek,
        subRentalDiscountPercent: subRentalDiscountPercent ?? this.subRentalDiscountPercent,
        weeklySubRentalTotal: weeklySubRentalTotal ?? this.weeklySubRentalTotal,
        monthlySubRentalTotal: monthlySubRentalTotal ?? this.monthlySubRentalTotal,
        periodSubRentalTotal: periodSubRentalTotal ?? this.periodSubRentalTotal,
        weeklySubRentalTotalIncludesTax: weeklySubRentalTotalIncludesTax ?? this.weeklySubRentalTotalIncludesTax,
        monthlySubRentalTotalIncludesTax: monthlySubRentalTotalIncludesTax ?? this.monthlySubRentalTotalIncludesTax,
        periodSubRentalTotalIncludesTax: periodSubRentalTotalIncludesTax ?? this.periodSubRentalTotalIncludesTax,
        subSalesDiscountPercent: subSalesDiscountPercent ?? this.subSalesDiscountPercent,
        subSalesTotal: subSalesTotal ?? this.subSalesTotal,
        subSalesTotalIncludesTax: subSalesTotalIncludesTax ?? this.subSalesTotalIncludesTax,
        subVehicleDaysPerWeek: subVehicleDaysPerWeek ?? this.subVehicleDaysPerWeek,
        subvehicleDiscountPercent: subvehicleDiscountPercent ?? this.subvehicleDiscountPercent,
        weeklySubVehicleTotal: weeklySubVehicleTotal ?? this.weeklySubVehicleTotal,
        monthlySubVehicleTotal: monthlySubVehicleTotal ?? this.monthlySubVehicleTotal,
        periodSubVehicleTotal: periodSubVehicleTotal ?? this.periodSubVehicleTotal,
        weeklySubVehicleTotalIncludesTax: weeklySubVehicleTotalIncludesTax ?? this.weeklySubVehicleTotalIncludesTax,
        monthlySubVehicleTotalIncludesTax: monthlySubVehicleTotalIncludesTax ?? this.monthlySubVehicleTotalIncludesTax,
        periodSubVehicleTotalIncludesTax: periodSubVehicleTotalIncludesTax ?? this.periodSubVehicleTotalIncludesTax,
        subMiscDiscountPercent: subMiscDiscountPercent ?? this.subMiscDiscountPercent,
        weeklySubMiscTotal: weeklySubMiscTotal ?? this.weeklySubMiscTotal,
        monthlySubMiscTotal: monthlySubMiscTotal ?? this.monthlySubMiscTotal,
        periodSubMiscTotal: periodSubMiscTotal ?? this.periodSubMiscTotal,
        weeklySubMiscTotalIncludesTax: weeklySubMiscTotalIncludesTax ?? this.weeklySubMiscTotalIncludesTax,
        monthlySubMiscTotalIncludesTax: monthlySubMiscTotalIncludesTax ?? this.monthlySubMiscTotalIncludesTax,
        periodSubMiscTotalIncludesTax: periodSubMiscTotalIncludesTax ?? this.periodSubMiscTotalIncludesTax,
        subLaborDiscountPercent: subLaborDiscountPercent ?? this.subLaborDiscountPercent,
        weeklySubLaborTotal: weeklySubLaborTotal ?? this.weeklySubLaborTotal,
        monthlySubLaborTotal: monthlySubLaborTotal ?? this.monthlySubLaborTotal,
        periodSubLaborTotal: periodSubLaborTotal ?? this.periodSubLaborTotal,
        weeklySubLaborTotalIncludesTax: weeklySubLaborTotalIncludesTax ?? this.weeklySubLaborTotalIncludesTax,
        monthlySubLaborTotalIncludesTax: monthlySubLaborTotalIncludesTax ?? this.monthlySubLaborTotalIncludesTax,
        periodSubLaborTotalIncludesTax: periodSubLaborTotalIncludesTax ?? this.periodSubLaborTotalIncludesTax,
        miscellaneousIsComplete: miscellaneousIsComplete ?? this.miscellaneousIsComplete,
        subMiscellaneousIsComplete: subMiscellaneousIsComplete ?? this.subMiscellaneousIsComplete,
        laborIsComplete: laborIsComplete ?? this.laborIsComplete,
        subLaborIsComplete: subLaborIsComplete ?? this.subLaborIsComplete,
        currencyColor: currencyColor ?? this.currencyColor,
        statusColor: statusColor ?? this.statusColor,
        purchaseOrderNumberColor: purchaseOrderNumberColor ?? this.purchaseOrderNumberColor,
        vendorColor: vendorColor ?? this.vendorColor,
        descriptionColor: descriptionColor ?? this.descriptionColor,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        items: items ?? this.items,
        custom: custom ?? this.custom,
        defaultFieldAttributes: defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentPurchaseOrderNextVendorInvoiceDefaultDatesResponse {
  WebApiModulesAgentPurchaseOrderNextVendorInvoiceDefaultDatesResponse({
    this.status,
    this.success,
    this.msg,
    this.billingStartDate,
    this.billingEndDate,
  });

  factory WebApiModulesAgentPurchaseOrderNextVendorInvoiceDefaultDatesResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentPurchaseOrderNextVendorInvoiceDefaultDatesResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'BillingStartDate')
  final DateTime? billingStartDate;
  @JsonKey(name: 'BillingEndDate')
  final DateTime? billingEndDate;
  static const fromJsonFactory =
      _$WebApiModulesAgentPurchaseOrderNextVendorInvoiceDefaultDatesResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentPurchaseOrderNextVendorInvoiceDefaultDatesResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentPurchaseOrderNextVendorInvoiceDefaultDatesResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentPurchaseOrderNextVendorInvoiceDefaultDatesResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.billingStartDate, billingStartDate) ||
                const DeepCollectionEquality()
                    .equals(other.billingStartDate, billingStartDate)) &&
            (identical(other.billingEndDate, billingEndDate) ||
                const DeepCollectionEquality()
                    .equals(other.billingEndDate, billingEndDate)));
  }
}

extension $WebApiModulesAgentPurchaseOrderNextVendorInvoiceDefaultDatesResponseExtension
    on WebApiModulesAgentPurchaseOrderNextVendorInvoiceDefaultDatesResponse {
  WebApiModulesAgentPurchaseOrderNextVendorInvoiceDefaultDatesResponse copyWith(
      {int? status,
      bool? success,
      String? msg,
      DateTime? billingStartDate,
      DateTime? billingEndDate}) {
    return WebApiModulesAgentPurchaseOrderNextVendorInvoiceDefaultDatesResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        billingStartDate: billingStartDate ?? this.billingStartDate,
        billingEndDate: billingEndDate ?? this.billingEndDate);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentPurchaseOrderPurchaseOrder {
  WebApiModulesAgentPurchaseOrderPurchaseOrder({
    this.purchaseOrderId,
    this.purchaseOrderNumber,
    this.description,
    this.purchaseOrderDate,
    this.requisitionNumber,
    this.requisitionDate,
    this.vendorId,
    this.vendor,
    this.agentId,
    this.agent,
    this.status,
    this.statusDate,
    this.referenceNumber,
    this.needsApproval,
    this.approvedByUserId,
    this.departmentId,
    this.department,
    this.officeLocationId,
    this.officeLocation,
    this.warehouseId,
    this.warehouse,
    this.warehouseCode,
    this.quantityHolding,
    this.quantityToBarCode,
    this.rental,
    this.sales,
    this.parts,
    this.labor,
    this.miscellaneous,
    this.vehicle,
    this.subRent,
    this.subSale,
    this.subLabor,
    this.subMiscellaneous,
    this.subVehicle,
    this.repair,
    this.consignment,
    this.consignorAgreementId,
    this.consignorAgreementNumber,
    this.orderId,
    this.orderNumber,
    this.dealNumber,
    this.dealId,
    this.deal,
    this.rateType,
    this.departmentLocationRequiresApproval,
    this.total,
    this.poTypeId,
    this.poType,
    this.poClassificationId,
    this.poClassification,
    this.activityDatesAndTimes,
    this.estimatedStartDate,
    this.estimatedStartTime,
    this.estimatedStopDate,
    this.estimatedStopTime,
    this.billingStartDate,
    this.billingEndDate,
    this.billingWeeks,
    this.billingMonths,
    this.invoicedAmount,
    this.projectManagerId,
    this.projectManager,
    this.receiveDeliveryId,
    this.receiveDeliveryDeliveryType,
    this.receiveDeliveryRequiredDate,
    this.receiveDeliveryRequiredTime,
    this.receiveDeliveryTargetShipDate,
    this.receiveDeliveryTargetShipTime,
    this.receiveDeliveryDirection,
    this.receiveDeliveryAddressType,
    this.receiveDeliveryFromLocation,
    this.receiveDeliveryFromContact,
    this.receiveDeliveryFromContactPhone,
    this.receiveDeliveryFromAlternateContact,
    this.receiveDeliveryFromAlternateContactPhone,
    this.receiveDeliveryFromAttention,
    this.receiveDeliveryFromAddress1,
    this.receiveDeliveryFromAdd2ress,
    this.receiveDeliveryFromCity,
    this.receiveDeliveryFromState,
    this.receiveDeliveryFromZipCode,
    this.receiveDeliveryFromCountry,
    this.receiveDeliveryFromCountryId,
    this.receiveDeliveryFromCrossStreets,
    this.receiveDeliveryToLocation,
    this.receiveDeliveryToVenue,
    this.receiveDeliveryToVenueId,
    this.receiveDeliveryToWarehouse,
    this.receiveDeliveryToWarehouseId,
    this.receiveDeliveryToContact,
    this.receiveDeliveryToContactPhone,
    this.receiveDeliveryToAlternateContact,
    this.receiveDeliveryToAlternateContactPhone,
    this.receiveDeliveryToAttention,
    this.receiveDeliveryToAddress1,
    this.receiveDeliveryToAddress2,
    this.receiveDeliveryToCity,
    this.receiveDeliveryToState,
    this.receiveDeliveryToZipCode,
    this.receiveDeliveryToCountryId,
    this.receiveDeliveryToCountry,
    this.receiveDeliveryToContactFax,
    this.receiveDeliveryToCrossStreets,
    this.receiveDeliveryDeliveryNotes,
    this.receiveDeliveryCarrierId,
    this.receiveDeliveryCarrier,
    this.receiveDeliveryCarrierAccount,
    this.receiveDeliveryShipViaId,
    this.receiveDeliveryShipVia,
    this.receiveDeliveryInvoiceId,
    this.receiveDeliveryVendorInvoiceId,
    this.receiveDeliveryEstimatedFreight,
    this.receiveDeliveryFreightInvoiceAmount,
    this.receiveDeliveryChargeType,
    this.receiveDeliveryFreightTrackingNumber,
    this.receiveDeliveryFreightTrackingUrl,
    this.receiveDeliveryDropShip,
    this.receiveDeliveryPackageCode,
    this.receiveDeliveryBillPoFreightOnOrder,
    this.receiveDeliveryOnlineOrderNumber,
    this.receiveDeliveryOnlineOrderStatus,
    this.receiveDeliveryDateStamp,
    this.returnDeliveryId,
    this.returnDeliveryDeliveryType,
    this.returnDeliveryRequiredDate,
    this.returnDeliveryRequiredTime,
    this.returnDeliveryTargetShipDate,
    this.returnDeliveryTargetShipTime,
    this.returnDeliveryDirection,
    this.returnDeliveryAddressType,
    this.returnDeliveryFromLocation,
    this.returnDeliveryFromContact,
    this.returnDeliveryFromContactPhone,
    this.returnDeliveryFromAlternateContact,
    this.returnDeliveryFromAlternateContactPhone,
    this.returnDeliveryFromAttention,
    this.returnDeliveryFromAddress1,
    this.returnDeliveryFromAdd2ress,
    this.returnDeliveryFromCity,
    this.returnDeliveryFromState,
    this.returnDeliveryFromZipCode,
    this.returnDeliveryFromCountry,
    this.returnDeliveryFromCountryId,
    this.returnDeliveryFromCrossStreets,
    this.returnDeliveryToLocation,
    this.returnDeliveryToVenue,
    this.returnDeliveryToVenueId,
    this.returnDeliveryToWarehouse,
    this.returnDeliveryToWarehouseId,
    this.returnDeliveryToContact,
    this.returnDeliveryToContactPhone,
    this.returnDeliveryToAlternateContact,
    this.returnDeliveryToAlternateContactPhone,
    this.returnDeliveryToAttention,
    this.returnDeliveryToAddress1,
    this.returnDeliveryToAddress2,
    this.returnDeliveryToCity,
    this.returnDeliveryToState,
    this.returnDeliveryToZipCode,
    this.returnDeliveryToCountryId,
    this.returnDeliveryToCountry,
    this.returnDeliveryToContactFax,
    this.returnDeliveryToCrossStreets,
    this.returnDeliveryDeliveryNotes,
    this.returnDeliveryCarrierId,
    this.returnDeliveryCarrier,
    this.returnDeliveryCarrierAccount,
    this.returnDeliveryShipViaId,
    this.returnDeliveryShipVia,
    this.returnDeliveryInvoiceId,
    this.returnDeliveryVendorInvoiceId,
    this.returnDeliveryEstimatedFreight,
    this.returnDeliveryFreightInvoiceAmount,
    this.returnDeliveryChargeType,
    this.returnDeliveryFreightTrackingNumber,
    this.returnDeliveryFreightTrackingUrl,
    this.returnDeliveryVendorRetrieve,
    this.returnDeliveryPackageCode,
    this.returnDeliveryBillPoFreightOnOrder,
    this.returnDeliveryOnlineOrderNumber,
    this.returnDeliveryOnlineOrderStatus,
    this.returnDeliveryDateStamp,
    this.enableProjects,
    this.projectId,
    this.projectNumber,
    this.project,
    this.projectDrawingsId,
    this.projectDrawings,
    this.projectItemsOrderedId,
    this.projectItemsOrdered,
    this.projectDropShipId,
    this.projectDropShip,
    this.projectAsBuildId,
    this.projectAsBuild,
    this.projectCommissioningId,
    this.projectCommissioning,
    this.projectDepositId,
    this.projectDeposit,
    this.location,
    this.currencyId,
    this.updateAllRatesToNewCurrency,
    this.confirmUpdateAllRatesToNewCurrency,
    this.currencyCode,
    this.currency,
    this.currencySymbol,
    this.billingCycleId,
    this.billingCycle,
    this.remitToAttention1,
    this.remitToAttention2,
    this.remitToAddress1,
    this.remitToAddress2,
    this.remitToCity,
    this.remitToState,
    this.remitToCountryId,
    this.remitToCountry,
    this.remitToZipCode,
    this.remitToEmail,
    this.remitToPhone,
    this.paymentTypeId,
    this.paymentType,
    this.paymentTermsId,
    this.paymentTerms,
    this.paymentTermsDueInDays,
    this.taxOptionId,
    this.taxOption,
    this.taxId,
    this.tax1Name,
    this.tax2Name,
    this.rentalTaxRate1,
    this.salesTaxRate1,
    this.laborTaxRate1,
    this.rentalTaxRate2,
    this.salesTaxRate2,
    this.laborTaxRate2,
    this.hasRentalItem,
    this.hasSalesItem,
    this.hasMiscellaneousItem,
    this.hasLaborItem,
    this.hasFacilitiesItem,
    this.hasLossAndDamageItem,
    this.hasRentalSaleItem,
    this.hasPartsItem,
    this.rentalDiscountPercent,
    this.rentalTotal,
    this.rentalTotalIncludesTax,
    this.salesDiscountPercent,
    this.salesTotal,
    this.salesTotalIncludesTax,
    this.partsDiscountPercent,
    this.partsTotal,
    this.partsTotalIncludesTax,
    this.vehicleDiscountPercent,
    this.vehicleTotal,
    this.vehicleTotalIncludesTax,
    this.miscDiscountPercent,
    this.miscTotal,
    this.miscTotalIncludesTax,
    this.laborDiscountPercent,
    this.laborTotal,
    this.laborTotalIncludesTax,
    this.subRentalDaysPerWeek,
    this.subRentalDiscountPercent,
    this.weeklySubRentalTotal,
    this.monthlySubRentalTotal,
    this.periodSubRentalTotal,
    this.weeklySubRentalTotalIncludesTax,
    this.monthlySubRentalTotalIncludesTax,
    this.periodSubRentalTotalIncludesTax,
    this.subSalesDiscountPercent,
    this.subSalesTotal,
    this.subSalesTotalIncludesTax,
    this.subVehicleDaysPerWeek,
    this.subvehicleDiscountPercent,
    this.weeklySubVehicleTotal,
    this.monthlySubVehicleTotal,
    this.periodSubVehicleTotal,
    this.weeklySubVehicleTotalIncludesTax,
    this.monthlySubVehicleTotalIncludesTax,
    this.periodSubVehicleTotalIncludesTax,
    this.subMiscDiscountPercent,
    this.weeklySubMiscTotal,
    this.monthlySubMiscTotal,
    this.periodSubMiscTotal,
    this.weeklySubMiscTotalIncludesTax,
    this.monthlySubMiscTotalIncludesTax,
    this.periodSubMiscTotalIncludesTax,
    this.subLaborDiscountPercent,
    this.weeklySubLaborTotal,
    this.monthlySubLaborTotal,
    this.periodSubLaborTotal,
    this.weeklySubLaborTotalIncludesTax,
    this.monthlySubLaborTotalIncludesTax,
    this.periodSubLaborTotalIncludesTax,
    this.miscellaneousIsComplete,
    this.subMiscellaneousIsComplete,
    this.laborIsComplete,
    this.subLaborIsComplete,
    this.currencyColor,
    this.statusColor,
    this.purchaseOrderNumberColor,
    this.vendorColor,
    this.descriptionColor,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAgentPurchaseOrderPurchaseOrder.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderFromJson(json);

  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'PurchaseOrderNumber')
  final String? purchaseOrderNumber;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'PurchaseOrderDate')
  final String? purchaseOrderDate;
  @JsonKey(name: 'RequisitionNumber')
  final String? requisitionNumber;
  @JsonKey(name: 'RequisitionDate')
  final String? requisitionDate;
  @JsonKey(name: 'VendorId')
  final String? vendorId;
  @JsonKey(name: 'Vendor')
  final String? vendor;
  @JsonKey(name: 'AgentId')
  final String? agentId;
  @JsonKey(name: 'Agent')
  final String? agent;
  @JsonKey(name: 'Status')
  final String? status;
  @JsonKey(name: 'StatusDate')
  final String? statusDate;
  @JsonKey(name: 'ReferenceNumber')
  final String? referenceNumber;
  @JsonKey(name: 'NeedsApproval')
  final bool? needsApproval;
  @JsonKey(name: 'ApprovedByUserId')
  final String? approvedByUserId;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'Department')
  final String? department;
  @JsonKey(name: 'OfficeLocationId')
  final String? officeLocationId;
  @JsonKey(name: 'OfficeLocation')
  final String? officeLocation;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'QuantityHolding')
  final int? quantityHolding;
  @JsonKey(name: 'QuantityToBarCode')
  final int? quantityToBarCode;
  @JsonKey(name: 'Rental')
  final bool? rental;
  @JsonKey(name: 'Sales')
  final bool? sales;
  @JsonKey(name: 'Parts')
  final bool? parts;
  @JsonKey(name: 'Labor')
  final bool? labor;
  @JsonKey(name: 'Miscellaneous')
  final bool? miscellaneous;
  @JsonKey(name: 'Vehicle')
  final bool? vehicle;
  @JsonKey(name: 'SubRent')
  final bool? subRent;
  @JsonKey(name: 'SubSale')
  final bool? subSale;
  @JsonKey(name: 'SubLabor')
  final bool? subLabor;
  @JsonKey(name: 'SubMiscellaneous')
  final bool? subMiscellaneous;
  @JsonKey(name: 'SubVehicle')
  final bool? subVehicle;
  @JsonKey(name: 'Repair')
  final bool? repair;
  @JsonKey(name: 'Consignment')
  final bool? consignment;
  @JsonKey(name: 'ConsignorAgreementId')
  final String? consignorAgreementId;
  @JsonKey(name: 'ConsignorAgreementNumber')
  final String? consignorAgreementNumber;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderNumber')
  final String? orderNumber;
  @JsonKey(name: 'DealNumber')
  final String? dealNumber;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'Deal')
  final String? deal;
  @JsonKey(name: 'RateType')
  final String? rateType;
  @JsonKey(name: 'DepartmentLocationRequiresApproval')
  final bool? departmentLocationRequiresApproval;
  @JsonKey(name: 'Total')
  final double? total;
  @JsonKey(name: 'PoTypeId')
  final String? poTypeId;
  @JsonKey(name: 'PoType')
  final String? poType;
  @JsonKey(name: 'PoClassificationId')
  final String? poClassificationId;
  @JsonKey(name: 'PoClassification')
  final String? poClassification;
  @JsonKey(
      name: 'ActivityDatesAndTimes',
      defaultValue: <WebApiModulesHomeControlsOrderDatesOrderDates>[])
  final List<WebApiModulesHomeControlsOrderDatesOrderDates>?
      activityDatesAndTimes;
  @JsonKey(name: 'EstimatedStartDate')
  final String? estimatedStartDate;
  @JsonKey(name: 'EstimatedStartTime')
  final String? estimatedStartTime;
  @JsonKey(name: 'EstimatedStopDate')
  final String? estimatedStopDate;
  @JsonKey(name: 'EstimatedStopTime')
  final String? estimatedStopTime;
  @JsonKey(name: 'BillingStartDate')
  final String? billingStartDate;
  @JsonKey(name: 'BillingEndDate')
  final String? billingEndDate;
  @JsonKey(name: 'BillingWeeks')
  final double? billingWeeks;
  @JsonKey(name: 'BillingMonths')
  final double? billingMonths;
  @JsonKey(name: 'InvoicedAmount')
  final double? invoicedAmount;
  @JsonKey(name: 'ProjectManagerId')
  final String? projectManagerId;
  @JsonKey(name: 'ProjectManager')
  final String? projectManager;
  @JsonKey(name: 'ReceiveDeliveryId')
  final String? receiveDeliveryId;
  @JsonKey(name: 'ReceiveDeliveryDeliveryType')
  final String? receiveDeliveryDeliveryType;
  @JsonKey(name: 'ReceiveDeliveryRequiredDate')
  final String? receiveDeliveryRequiredDate;
  @JsonKey(name: 'ReceiveDeliveryRequiredTime')
  final String? receiveDeliveryRequiredTime;
  @JsonKey(name: 'ReceiveDeliveryTargetShipDate')
  final String? receiveDeliveryTargetShipDate;
  @JsonKey(name: 'ReceiveDeliveryTargetShipTime')
  final String? receiveDeliveryTargetShipTime;
  @JsonKey(name: 'ReceiveDeliveryDirection')
  final String? receiveDeliveryDirection;
  @JsonKey(name: 'ReceiveDeliveryAddressType')
  final String? receiveDeliveryAddressType;
  @JsonKey(name: 'ReceiveDeliveryFromLocation')
  final String? receiveDeliveryFromLocation;
  @JsonKey(name: 'ReceiveDeliveryFromContact')
  final String? receiveDeliveryFromContact;
  @JsonKey(name: 'ReceiveDeliveryFromContactPhone')
  final String? receiveDeliveryFromContactPhone;
  @JsonKey(name: 'ReceiveDeliveryFromAlternateContact')
  final String? receiveDeliveryFromAlternateContact;
  @JsonKey(name: 'ReceiveDeliveryFromAlternateContactPhone')
  final String? receiveDeliveryFromAlternateContactPhone;
  @JsonKey(name: 'ReceiveDeliveryFromAttention')
  final String? receiveDeliveryFromAttention;
  @JsonKey(name: 'ReceiveDeliveryFromAddress1')
  final String? receiveDeliveryFromAddress1;
  @JsonKey(name: 'ReceiveDeliveryFromAdd2ress')
  final String? receiveDeliveryFromAdd2ress;
  @JsonKey(name: 'ReceiveDeliveryFromCity')
  final String? receiveDeliveryFromCity;
  @JsonKey(name: 'ReceiveDeliveryFromState')
  final String? receiveDeliveryFromState;
  @JsonKey(name: 'ReceiveDeliveryFromZipCode')
  final String? receiveDeliveryFromZipCode;
  @JsonKey(name: 'ReceiveDeliveryFromCountry')
  final String? receiveDeliveryFromCountry;
  @JsonKey(name: 'ReceiveDeliveryFromCountryId')
  final String? receiveDeliveryFromCountryId;
  @JsonKey(name: 'ReceiveDeliveryFromCrossStreets')
  final String? receiveDeliveryFromCrossStreets;
  @JsonKey(name: 'ReceiveDeliveryToLocation')
  final String? receiveDeliveryToLocation;
  @JsonKey(name: 'ReceiveDeliveryToVenue')
  final String? receiveDeliveryToVenue;
  @JsonKey(name: 'ReceiveDeliveryToVenueId')
  final String? receiveDeliveryToVenueId;
  @JsonKey(name: 'ReceiveDeliveryToWarehouse')
  final String? receiveDeliveryToWarehouse;
  @JsonKey(name: 'ReceiveDeliveryToWarehouseId')
  final String? receiveDeliveryToWarehouseId;
  @JsonKey(name: 'ReceiveDeliveryToContact')
  final String? receiveDeliveryToContact;
  @JsonKey(name: 'ReceiveDeliveryToContactPhone')
  final String? receiveDeliveryToContactPhone;
  @JsonKey(name: 'ReceiveDeliveryToAlternateContact')
  final String? receiveDeliveryToAlternateContact;
  @JsonKey(name: 'ReceiveDeliveryToAlternateContactPhone')
  final String? receiveDeliveryToAlternateContactPhone;
  @JsonKey(name: 'ReceiveDeliveryToAttention')
  final String? receiveDeliveryToAttention;
  @JsonKey(name: 'ReceiveDeliveryToAddress1')
  final String? receiveDeliveryToAddress1;
  @JsonKey(name: 'ReceiveDeliveryToAddress2')
  final String? receiveDeliveryToAddress2;
  @JsonKey(name: 'ReceiveDeliveryToCity')
  final String? receiveDeliveryToCity;
  @JsonKey(name: 'ReceiveDeliveryToState')
  final String? receiveDeliveryToState;
  @JsonKey(name: 'ReceiveDeliveryToZipCode')
  final String? receiveDeliveryToZipCode;
  @JsonKey(name: 'ReceiveDeliveryToCountryId')
  final String? receiveDeliveryToCountryId;
  @JsonKey(name: 'ReceiveDeliveryToCountry')
  final String? receiveDeliveryToCountry;
  @JsonKey(name: 'ReceiveDeliveryToContactFax')
  final String? receiveDeliveryToContactFax;
  @JsonKey(name: 'ReceiveDeliveryToCrossStreets')
  final String? receiveDeliveryToCrossStreets;
  @JsonKey(name: 'ReceiveDeliveryDeliveryNotes')
  final String? receiveDeliveryDeliveryNotes;
  @JsonKey(name: 'ReceiveDeliveryCarrierId')
  final String? receiveDeliveryCarrierId;
  @JsonKey(name: 'ReceiveDeliveryCarrier')
  final String? receiveDeliveryCarrier;
  @JsonKey(name: 'ReceiveDeliveryCarrierAccount')
  final String? receiveDeliveryCarrierAccount;
  @JsonKey(name: 'ReceiveDeliveryShipViaId')
  final String? receiveDeliveryShipViaId;
  @JsonKey(name: 'ReceiveDeliveryShipVia')
  final String? receiveDeliveryShipVia;
  @JsonKey(name: 'ReceiveDeliveryInvoiceId')
  final String? receiveDeliveryInvoiceId;
  @JsonKey(name: 'ReceiveDeliveryVendorInvoiceId')
  final String? receiveDeliveryVendorInvoiceId;
  @JsonKey(name: 'ReceiveDeliveryEstimatedFreight')
  final double? receiveDeliveryEstimatedFreight;
  @JsonKey(name: 'ReceiveDeliveryFreightInvoiceAmount')
  final double? receiveDeliveryFreightInvoiceAmount;
  @JsonKey(name: 'ReceiveDeliveryChargeType')
  final String? receiveDeliveryChargeType;
  @JsonKey(name: 'ReceiveDeliveryFreightTrackingNumber')
  final String? receiveDeliveryFreightTrackingNumber;
  @JsonKey(name: 'ReceiveDeliveryFreightTrackingUrl')
  final String? receiveDeliveryFreightTrackingUrl;
  @JsonKey(name: 'ReceiveDeliveryDropShip')
  final bool? receiveDeliveryDropShip;
  @JsonKey(name: 'ReceiveDeliveryPackageCode')
  final String? receiveDeliveryPackageCode;
  @JsonKey(name: 'ReceiveDeliveryBillPoFreightOnOrder')
  final bool? receiveDeliveryBillPoFreightOnOrder;
  @JsonKey(name: 'ReceiveDeliveryOnlineOrderNumber')
  final String? receiveDeliveryOnlineOrderNumber;
  @JsonKey(name: 'ReceiveDeliveryOnlineOrderStatus')
  final String? receiveDeliveryOnlineOrderStatus;
  @JsonKey(name: 'ReceiveDeliveryDateStamp')
  final String? receiveDeliveryDateStamp;
  @JsonKey(name: 'ReturnDeliveryId')
  final String? returnDeliveryId;
  @JsonKey(name: 'ReturnDeliveryDeliveryType')
  final String? returnDeliveryDeliveryType;
  @JsonKey(name: 'ReturnDeliveryRequiredDate')
  final String? returnDeliveryRequiredDate;
  @JsonKey(name: 'ReturnDeliveryRequiredTime')
  final String? returnDeliveryRequiredTime;
  @JsonKey(name: 'ReturnDeliveryTargetShipDate')
  final String? returnDeliveryTargetShipDate;
  @JsonKey(name: 'ReturnDeliveryTargetShipTime')
  final String? returnDeliveryTargetShipTime;
  @JsonKey(name: 'ReturnDeliveryDirection')
  final String? returnDeliveryDirection;
  @JsonKey(name: 'ReturnDeliveryAddressType')
  final String? returnDeliveryAddressType;
  @JsonKey(name: 'ReturnDeliveryFromLocation')
  final String? returnDeliveryFromLocation;
  @JsonKey(name: 'ReturnDeliveryFromContact')
  final String? returnDeliveryFromContact;
  @JsonKey(name: 'ReturnDeliveryFromContactPhone')
  final String? returnDeliveryFromContactPhone;
  @JsonKey(name: 'ReturnDeliveryFromAlternateContact')
  final String? returnDeliveryFromAlternateContact;
  @JsonKey(name: 'ReturnDeliveryFromAlternateContactPhone')
  final String? returnDeliveryFromAlternateContactPhone;
  @JsonKey(name: 'ReturnDeliveryFromAttention')
  final String? returnDeliveryFromAttention;
  @JsonKey(name: 'ReturnDeliveryFromAddress1')
  final String? returnDeliveryFromAddress1;
  @JsonKey(name: 'ReturnDeliveryFromAdd2ress')
  final String? returnDeliveryFromAdd2ress;
  @JsonKey(name: 'ReturnDeliveryFromCity')
  final String? returnDeliveryFromCity;
  @JsonKey(name: 'ReturnDeliveryFromState')
  final String? returnDeliveryFromState;
  @JsonKey(name: 'ReturnDeliveryFromZipCode')
  final String? returnDeliveryFromZipCode;
  @JsonKey(name: 'ReturnDeliveryFromCountry')
  final String? returnDeliveryFromCountry;
  @JsonKey(name: 'ReturnDeliveryFromCountryId')
  final String? returnDeliveryFromCountryId;
  @JsonKey(name: 'ReturnDeliveryFromCrossStreets')
  final String? returnDeliveryFromCrossStreets;
  @JsonKey(name: 'ReturnDeliveryToLocation')
  final String? returnDeliveryToLocation;
  @JsonKey(name: 'ReturnDeliveryToVenue')
  final String? returnDeliveryToVenue;
  @JsonKey(name: 'ReturnDeliveryToVenueId')
  final String? returnDeliveryToVenueId;
  @JsonKey(name: 'ReturnDeliveryToWarehouse')
  final String? returnDeliveryToWarehouse;
  @JsonKey(name: 'ReturnDeliveryToWarehouseId')
  final String? returnDeliveryToWarehouseId;
  @JsonKey(name: 'ReturnDeliveryToContact')
  final String? returnDeliveryToContact;
  @JsonKey(name: 'ReturnDeliveryToContactPhone')
  final String? returnDeliveryToContactPhone;
  @JsonKey(name: 'ReturnDeliveryToAlternateContact')
  final String? returnDeliveryToAlternateContact;
  @JsonKey(name: 'ReturnDeliveryToAlternateContactPhone')
  final String? returnDeliveryToAlternateContactPhone;
  @JsonKey(name: 'ReturnDeliveryToAttention')
  final String? returnDeliveryToAttention;
  @JsonKey(name: 'ReturnDeliveryToAddress1')
  final String? returnDeliveryToAddress1;
  @JsonKey(name: 'ReturnDeliveryToAddress2')
  final String? returnDeliveryToAddress2;
  @JsonKey(name: 'ReturnDeliveryToCity')
  final String? returnDeliveryToCity;
  @JsonKey(name: 'ReturnDeliveryToState')
  final String? returnDeliveryToState;
  @JsonKey(name: 'ReturnDeliveryToZipCode')
  final String? returnDeliveryToZipCode;
  @JsonKey(name: 'ReturnDeliveryToCountryId')
  final String? returnDeliveryToCountryId;
  @JsonKey(name: 'ReturnDeliveryToCountry')
  final String? returnDeliveryToCountry;
  @JsonKey(name: 'ReturnDeliveryToContactFax')
  final String? returnDeliveryToContactFax;
  @JsonKey(name: 'ReturnDeliveryToCrossStreets')
  final String? returnDeliveryToCrossStreets;
  @JsonKey(name: 'ReturnDeliveryDeliveryNotes')
  final String? returnDeliveryDeliveryNotes;
  @JsonKey(name: 'ReturnDeliveryCarrierId')
  final String? returnDeliveryCarrierId;
  @JsonKey(name: 'ReturnDeliveryCarrier')
  final String? returnDeliveryCarrier;
  @JsonKey(name: 'ReturnDeliveryCarrierAccount')
  final String? returnDeliveryCarrierAccount;
  @JsonKey(name: 'ReturnDeliveryShipViaId')
  final String? returnDeliveryShipViaId;
  @JsonKey(name: 'ReturnDeliveryShipVia')
  final String? returnDeliveryShipVia;
  @JsonKey(name: 'ReturnDeliveryInvoiceId')
  final String? returnDeliveryInvoiceId;
  @JsonKey(name: 'ReturnDeliveryVendorInvoiceId')
  final String? returnDeliveryVendorInvoiceId;
  @JsonKey(name: 'ReturnDeliveryEstimatedFreight')
  final double? returnDeliveryEstimatedFreight;
  @JsonKey(name: 'ReturnDeliveryFreightInvoiceAmount')
  final double? returnDeliveryFreightInvoiceAmount;
  @JsonKey(name: 'ReturnDeliveryChargeType')
  final String? returnDeliveryChargeType;
  @JsonKey(name: 'ReturnDeliveryFreightTrackingNumber')
  final String? returnDeliveryFreightTrackingNumber;
  @JsonKey(name: 'ReturnDeliveryFreightTrackingUrl')
  final String? returnDeliveryFreightTrackingUrl;
  @JsonKey(name: 'ReturnDeliveryVendorRetrieve')
  final bool? returnDeliveryVendorRetrieve;
  @JsonKey(name: 'ReturnDeliveryPackageCode')
  final String? returnDeliveryPackageCode;
  @JsonKey(name: 'ReturnDeliveryBillPoFreightOnOrder')
  final bool? returnDeliveryBillPoFreightOnOrder;
  @JsonKey(name: 'ReturnDeliveryOnlineOrderNumber')
  final String? returnDeliveryOnlineOrderNumber;
  @JsonKey(name: 'ReturnDeliveryOnlineOrderStatus')
  final String? returnDeliveryOnlineOrderStatus;
  @JsonKey(name: 'ReturnDeliveryDateStamp')
  final String? returnDeliveryDateStamp;
  @JsonKey(name: 'EnableProjects')
  final bool? enableProjects;
  @JsonKey(name: 'ProjectId')
  final String? projectId;
  @JsonKey(name: 'ProjectNumber')
  final String? projectNumber;
  @JsonKey(name: 'Project')
  final String? project;
  @JsonKey(name: 'ProjectDrawingsId')
  final String? projectDrawingsId;
  @JsonKey(name: 'ProjectDrawings')
  final String? projectDrawings;
  @JsonKey(name: 'ProjectItemsOrderedId')
  final String? projectItemsOrderedId;
  @JsonKey(name: 'ProjectItemsOrdered')
  final String? projectItemsOrdered;
  @JsonKey(name: 'ProjectDropShipId')
  final String? projectDropShipId;
  @JsonKey(name: 'ProjectDropShip')
  final String? projectDropShip;
  @JsonKey(name: 'ProjectAsBuildId')
  final String? projectAsBuildId;
  @JsonKey(name: 'ProjectAsBuild')
  final String? projectAsBuild;
  @JsonKey(name: 'ProjectCommissioningId')
  final String? projectCommissioningId;
  @JsonKey(name: 'ProjectCommissioning')
  final String? projectCommissioning;
  @JsonKey(name: 'ProjectDepositId')
  final String? projectDepositId;
  @JsonKey(name: 'ProjectDeposit')
  final String? projectDeposit;
  @JsonKey(name: 'Location')
  final String? location;
  @JsonKey(name: 'CurrencyId')
  final String? currencyId;
  @JsonKey(name: 'UpdateAllRatesToNewCurrency')
  final bool? updateAllRatesToNewCurrency;
  @JsonKey(name: 'ConfirmUpdateAllRatesToNewCurrency')
  final String? confirmUpdateAllRatesToNewCurrency;
  @JsonKey(name: 'CurrencyCode')
  final String? currencyCode;
  @JsonKey(name: 'Currency')
  final String? currency;
  @JsonKey(name: 'CurrencySymbol')
  final String? currencySymbol;
  @JsonKey(name: 'BillingCycleId')
  final String? billingCycleId;
  @JsonKey(name: 'BillingCycle')
  final String? billingCycle;
  @JsonKey(name: 'RemitToAttention1')
  final String? remitToAttention1;
  @JsonKey(name: 'RemitToAttention2')
  final String? remitToAttention2;
  @JsonKey(name: 'RemitToAddress1')
  final String? remitToAddress1;
  @JsonKey(name: 'RemitToAddress2')
  final String? remitToAddress2;
  @JsonKey(name: 'RemitToCity')
  final String? remitToCity;
  @JsonKey(name: 'RemitToState')
  final String? remitToState;
  @JsonKey(name: 'RemitToCountryId')
  final String? remitToCountryId;
  @JsonKey(name: 'RemitToCountry')
  final String? remitToCountry;
  @JsonKey(name: 'RemitToZipCode')
  final String? remitToZipCode;
  @JsonKey(name: 'RemitToEmail')
  final String? remitToEmail;
  @JsonKey(name: 'RemitToPhone')
  final String? remitToPhone;
  @JsonKey(name: 'PaymentTypeId')
  final String? paymentTypeId;
  @JsonKey(name: 'PaymentType')
  final String? paymentType;
  @JsonKey(name: 'PaymentTermsId')
  final String? paymentTermsId;
  @JsonKey(name: 'PaymentTerms')
  final String? paymentTerms;
  @JsonKey(name: 'PaymentTermsDueInDays')
  final int? paymentTermsDueInDays;
  @JsonKey(name: 'TaxOptionId')
  final String? taxOptionId;
  @JsonKey(name: 'TaxOption')
  final String? taxOption;
  @JsonKey(name: 'TaxId')
  final String? taxId;
  @JsonKey(name: 'Tax1Name')
  final String? tax1Name;
  @JsonKey(name: 'Tax2Name')
  final String? tax2Name;
  @JsonKey(name: 'RentalTaxRate1')
  final double? rentalTaxRate1;
  @JsonKey(name: 'SalesTaxRate1')
  final double? salesTaxRate1;
  @JsonKey(name: 'LaborTaxRate1')
  final double? laborTaxRate1;
  @JsonKey(name: 'RentalTaxRate2')
  final double? rentalTaxRate2;
  @JsonKey(name: 'SalesTaxRate2')
  final double? salesTaxRate2;
  @JsonKey(name: 'LaborTaxRate2')
  final double? laborTaxRate2;
  @JsonKey(name: 'HasRentalItem')
  final bool? hasRentalItem;
  @JsonKey(name: 'HasSalesItem')
  final bool? hasSalesItem;
  @JsonKey(name: 'HasMiscellaneousItem')
  final bool? hasMiscellaneousItem;
  @JsonKey(name: 'HasLaborItem')
  final bool? hasLaborItem;
  @JsonKey(name: 'HasFacilitiesItem')
  final bool? hasFacilitiesItem;
  @JsonKey(name: 'HasLossAndDamageItem')
  final bool? hasLossAndDamageItem;
  @JsonKey(name: 'HasRentalSaleItem')
  final bool? hasRentalSaleItem;
  @JsonKey(name: 'HasPartsItem')
  final bool? hasPartsItem;
  @JsonKey(name: 'RentalDiscountPercent')
  final double? rentalDiscountPercent;
  @JsonKey(name: 'RentalTotal')
  final double? rentalTotal;
  @JsonKey(name: 'RentalTotalIncludesTax')
  final bool? rentalTotalIncludesTax;
  @JsonKey(name: 'SalesDiscountPercent')
  final double? salesDiscountPercent;
  @JsonKey(name: 'SalesTotal')
  final double? salesTotal;
  @JsonKey(name: 'SalesTotalIncludesTax')
  final bool? salesTotalIncludesTax;
  @JsonKey(name: 'PartsDiscountPercent')
  final double? partsDiscountPercent;
  @JsonKey(name: 'PartsTotal')
  final double? partsTotal;
  @JsonKey(name: 'PartsTotalIncludesTax')
  final bool? partsTotalIncludesTax;
  @JsonKey(name: 'VehicleDiscountPercent')
  final double? vehicleDiscountPercent;
  @JsonKey(name: 'VehicleTotal')
  final double? vehicleTotal;
  @JsonKey(name: 'VehicleTotalIncludesTax')
  final bool? vehicleTotalIncludesTax;
  @JsonKey(name: 'MiscDiscountPercent')
  final double? miscDiscountPercent;
  @JsonKey(name: 'MiscTotal')
  final double? miscTotal;
  @JsonKey(name: 'MiscTotalIncludesTax')
  final bool? miscTotalIncludesTax;
  @JsonKey(name: 'LaborDiscountPercent')
  final double? laborDiscountPercent;
  @JsonKey(name: 'LaborTotal')
  final double? laborTotal;
  @JsonKey(name: 'LaborTotalIncludesTax')
  final bool? laborTotalIncludesTax;
  @JsonKey(name: 'SubRentalDaysPerWeek')
  final double? subRentalDaysPerWeek;
  @JsonKey(name: 'SubRentalDiscountPercent')
  final double? subRentalDiscountPercent;
  @JsonKey(name: 'WeeklySubRentalTotal')
  final double? weeklySubRentalTotal;
  @JsonKey(name: 'MonthlySubRentalTotal')
  final double? monthlySubRentalTotal;
  @JsonKey(name: 'PeriodSubRentalTotal')
  final double? periodSubRentalTotal;
  @JsonKey(name: 'WeeklySubRentalTotalIncludesTax')
  final bool? weeklySubRentalTotalIncludesTax;
  @JsonKey(name: 'MonthlySubRentalTotalIncludesTax')
  final bool? monthlySubRentalTotalIncludesTax;
  @JsonKey(name: 'PeriodSubRentalTotalIncludesTax')
  final bool? periodSubRentalTotalIncludesTax;
  @JsonKey(name: 'SubSalesDiscountPercent')
  final double? subSalesDiscountPercent;
  @JsonKey(name: 'SubSalesTotal')
  final double? subSalesTotal;
  @JsonKey(name: 'SubSalesTotalIncludesTax')
  final bool? subSalesTotalIncludesTax;
  @JsonKey(name: 'SubVehicleDaysPerWeek')
  final double? subVehicleDaysPerWeek;
  @JsonKey(name: 'SubvehicleDiscountPercent')
  final double? subvehicleDiscountPercent;
  @JsonKey(name: 'WeeklySubVehicleTotal')
  final double? weeklySubVehicleTotal;
  @JsonKey(name: 'MonthlySubVehicleTotal')
  final double? monthlySubVehicleTotal;
  @JsonKey(name: 'PeriodSubVehicleTotal')
  final double? periodSubVehicleTotal;
  @JsonKey(name: 'WeeklySubVehicleTotalIncludesTax')
  final bool? weeklySubVehicleTotalIncludesTax;
  @JsonKey(name: 'MonthlySubVehicleTotalIncludesTax')
  final bool? monthlySubVehicleTotalIncludesTax;
  @JsonKey(name: 'PeriodSubVehicleTotalIncludesTax')
  final bool? periodSubVehicleTotalIncludesTax;
  @JsonKey(name: 'SubMiscDiscountPercent')
  final double? subMiscDiscountPercent;
  @JsonKey(name: 'WeeklySubMiscTotal')
  final double? weeklySubMiscTotal;
  @JsonKey(name: 'MonthlySubMiscTotal')
  final double? monthlySubMiscTotal;
  @JsonKey(name: 'PeriodSubMiscTotal')
  final double? periodSubMiscTotal;
  @JsonKey(name: 'WeeklySubMiscTotalIncludesTax')
  final bool? weeklySubMiscTotalIncludesTax;
  @JsonKey(name: 'MonthlySubMiscTotalIncludesTax')
  final bool? monthlySubMiscTotalIncludesTax;
  @JsonKey(name: 'PeriodSubMiscTotalIncludesTax')
  final bool? periodSubMiscTotalIncludesTax;
  @JsonKey(name: 'SubLaborDiscountPercent')
  final double? subLaborDiscountPercent;
  @JsonKey(name: 'WeeklySubLaborTotal')
  final double? weeklySubLaborTotal;
  @JsonKey(name: 'MonthlySubLaborTotal')
  final double? monthlySubLaborTotal;
  @JsonKey(name: 'PeriodSubLaborTotal')
  final double? periodSubLaborTotal;
  @JsonKey(name: 'WeeklySubLaborTotalIncludesTax')
  final bool? weeklySubLaborTotalIncludesTax;
  @JsonKey(name: 'MonthlySubLaborTotalIncludesTax')
  final bool? monthlySubLaborTotalIncludesTax;
  @JsonKey(name: 'PeriodSubLaborTotalIncludesTax')
  final bool? periodSubLaborTotalIncludesTax;
  @JsonKey(name: 'MiscellaneousIsComplete')
  final bool? miscellaneousIsComplete;
  @JsonKey(name: 'SubMiscellaneousIsComplete')
  final bool? subMiscellaneousIsComplete;
  @JsonKey(name: 'LaborIsComplete')
  final bool? laborIsComplete;
  @JsonKey(name: 'SubLaborIsComplete')
  final bool? subLaborIsComplete;
  @JsonKey(name: 'CurrencyColor')
  final String? currencyColor;
  @JsonKey(name: 'StatusColor')
  final String? statusColor;
  @JsonKey(name: 'PurchaseOrderNumberColor')
  final String? purchaseOrderNumberColor;
  @JsonKey(name: 'VendorColor')
  final String? vendorColor;
  @JsonKey(name: 'DescriptionColor')
  final String? descriptionColor;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentPurchaseOrderPurchaseOrder &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.purchaseOrderNumber, purchaseOrderNumber) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderNumber, purchaseOrderNumber)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.purchaseOrderDate, purchaseOrderDate) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderDate, purchaseOrderDate)) &&
            (identical(other.requisitionNumber, requisitionNumber) ||
                const DeepCollectionEquality()
                    .equals(other.requisitionNumber, requisitionNumber)) &&
            (identical(other.requisitionDate, requisitionDate) ||
                const DeepCollectionEquality()
                    .equals(other.requisitionDate, requisitionDate)) &&
            (identical(other.vendorId, vendorId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorId, vendorId)) &&
            (identical(other.vendor, vendor) ||
                const DeepCollectionEquality().equals(other.vendor, vendor)) &&
            (identical(other.agentId, agentId) ||
                const DeepCollectionEquality()
                    .equals(other.agentId, agentId)) &&
            (identical(other.agent, agent) ||
                const DeepCollectionEquality().equals(other.agent, agent)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.statusDate, statusDate) ||
                const DeepCollectionEquality()
                    .equals(other.statusDate, statusDate)) &&
            (identical(other.referenceNumber, referenceNumber) ||
                const DeepCollectionEquality()
                    .equals(other.referenceNumber, referenceNumber)) &&
            (identical(other.needsApproval, needsApproval) ||
                const DeepCollectionEquality()
                    .equals(other.needsApproval, needsApproval)) &&
            (identical(other.approvedByUserId, approvedByUserId) ||
                const DeepCollectionEquality()
                    .equals(other.approvedByUserId, approvedByUserId)) &&
            (identical(other.departmentId, departmentId) ||
                const DeepCollectionEquality()
                    .equals(other.departmentId, departmentId)) &&
            (identical(other.department, department) ||
                const DeepCollectionEquality()
                    .equals(other.department, department)) &&
            (identical(other.officeLocationId, officeLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocationId, officeLocationId)) &&
            (identical(other.officeLocation, officeLocation) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocation, officeLocation)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouse, warehouse) ||
                const DeepCollectionEquality()
                    .equals(other.warehouse, warehouse)) &&
            (identical(other.warehouseCode, warehouseCode) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.quantityHolding, quantityHolding) ||
                const DeepCollectionEquality()
                    .equals(other.quantityHolding, quantityHolding)) &&
            (identical(other.quantityToBarCode, quantityToBarCode) || const DeepCollectionEquality().equals(other.quantityToBarCode, quantityToBarCode)) &&
            (identical(other.rental, rental) || const DeepCollectionEquality().equals(other.rental, rental)) &&
            (identical(other.sales, sales) || const DeepCollectionEquality().equals(other.sales, sales)) &&
            (identical(other.parts, parts) || const DeepCollectionEquality().equals(other.parts, parts)) &&
            (identical(other.labor, labor) || const DeepCollectionEquality().equals(other.labor, labor)) &&
            (identical(other.miscellaneous, miscellaneous) || const DeepCollectionEquality().equals(other.miscellaneous, miscellaneous)) &&
            (identical(other.vehicle, vehicle) || const DeepCollectionEquality().equals(other.vehicle, vehicle)) &&
            (identical(other.subRent, subRent) || const DeepCollectionEquality().equals(other.subRent, subRent)) &&
            (identical(other.subSale, subSale) || const DeepCollectionEquality().equals(other.subSale, subSale)) &&
            (identical(other.subLabor, subLabor) || const DeepCollectionEquality().equals(other.subLabor, subLabor)) &&
            (identical(other.subMiscellaneous, subMiscellaneous) || const DeepCollectionEquality().equals(other.subMiscellaneous, subMiscellaneous)) &&
            (identical(other.subVehicle, subVehicle) || const DeepCollectionEquality().equals(other.subVehicle, subVehicle)) &&
            (identical(other.repair, repair) || const DeepCollectionEquality().equals(other.repair, repair)) &&
            (identical(other.consignment, consignment) || const DeepCollectionEquality().equals(other.consignment, consignment)) &&
            (identical(other.consignorAgreementId, consignorAgreementId) || const DeepCollectionEquality().equals(other.consignorAgreementId, consignorAgreementId)) &&
            (identical(other.consignorAgreementNumber, consignorAgreementNumber) || const DeepCollectionEquality().equals(other.consignorAgreementNumber, consignorAgreementNumber)) &&
            (identical(other.orderId, orderId) || const DeepCollectionEquality().equals(other.orderId, orderId)) &&
            (identical(other.orderNumber, orderNumber) || const DeepCollectionEquality().equals(other.orderNumber, orderNumber)) &&
            (identical(other.dealNumber, dealNumber) || const DeepCollectionEquality().equals(other.dealNumber, dealNumber)) &&
            (identical(other.dealId, dealId) || const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.deal, deal) || const DeepCollectionEquality().equals(other.deal, deal)) &&
            (identical(other.rateType, rateType) || const DeepCollectionEquality().equals(other.rateType, rateType)) &&
            (identical(other.departmentLocationRequiresApproval, departmentLocationRequiresApproval) || const DeepCollectionEquality().equals(other.departmentLocationRequiresApproval, departmentLocationRequiresApproval)) &&
            (identical(other.total, total) || const DeepCollectionEquality().equals(other.total, total)) &&
            (identical(other.poTypeId, poTypeId) || const DeepCollectionEquality().equals(other.poTypeId, poTypeId)) &&
            (identical(other.poType, poType) || const DeepCollectionEquality().equals(other.poType, poType)) &&
            (identical(other.poClassificationId, poClassificationId) || const DeepCollectionEquality().equals(other.poClassificationId, poClassificationId)) &&
            (identical(other.poClassification, poClassification) || const DeepCollectionEquality().equals(other.poClassification, poClassification)) &&
            (identical(other.activityDatesAndTimes, activityDatesAndTimes) || const DeepCollectionEquality().equals(other.activityDatesAndTimes, activityDatesAndTimes)) &&
            (identical(other.estimatedStartDate, estimatedStartDate) || const DeepCollectionEquality().equals(other.estimatedStartDate, estimatedStartDate)) &&
            (identical(other.estimatedStartTime, estimatedStartTime) || const DeepCollectionEquality().equals(other.estimatedStartTime, estimatedStartTime)) &&
            (identical(other.estimatedStopDate, estimatedStopDate) || const DeepCollectionEquality().equals(other.estimatedStopDate, estimatedStopDate)) &&
            (identical(other.estimatedStopTime, estimatedStopTime) || const DeepCollectionEquality().equals(other.estimatedStopTime, estimatedStopTime)) &&
            (identical(other.billingStartDate, billingStartDate) || const DeepCollectionEquality().equals(other.billingStartDate, billingStartDate)) &&
            (identical(other.billingEndDate, billingEndDate) || const DeepCollectionEquality().equals(other.billingEndDate, billingEndDate)) &&
            (identical(other.billingWeeks, billingWeeks) || const DeepCollectionEquality().equals(other.billingWeeks, billingWeeks)) &&
            (identical(other.billingMonths, billingMonths) || const DeepCollectionEquality().equals(other.billingMonths, billingMonths)) &&
            (identical(other.invoicedAmount, invoicedAmount) || const DeepCollectionEquality().equals(other.invoicedAmount, invoicedAmount)) &&
            (identical(other.projectManagerId, projectManagerId) || const DeepCollectionEquality().equals(other.projectManagerId, projectManagerId)) &&
            (identical(other.projectManager, projectManager) || const DeepCollectionEquality().equals(other.projectManager, projectManager)) &&
            (identical(other.receiveDeliveryId, receiveDeliveryId) || const DeepCollectionEquality().equals(other.receiveDeliveryId, receiveDeliveryId)) &&
            (identical(other.receiveDeliveryDeliveryType, receiveDeliveryDeliveryType) || const DeepCollectionEquality().equals(other.receiveDeliveryDeliveryType, receiveDeliveryDeliveryType)) &&
            (identical(other.receiveDeliveryRequiredDate, receiveDeliveryRequiredDate) || const DeepCollectionEquality().equals(other.receiveDeliveryRequiredDate, receiveDeliveryRequiredDate)) &&
            (identical(other.receiveDeliveryRequiredTime, receiveDeliveryRequiredTime) || const DeepCollectionEquality().equals(other.receiveDeliveryRequiredTime, receiveDeliveryRequiredTime)) &&
            (identical(other.receiveDeliveryTargetShipDate, receiveDeliveryTargetShipDate) || const DeepCollectionEquality().equals(other.receiveDeliveryTargetShipDate, receiveDeliveryTargetShipDate)) &&
            (identical(other.receiveDeliveryTargetShipTime, receiveDeliveryTargetShipTime) || const DeepCollectionEquality().equals(other.receiveDeliveryTargetShipTime, receiveDeliveryTargetShipTime)) &&
            (identical(other.receiveDeliveryDirection, receiveDeliveryDirection) || const DeepCollectionEquality().equals(other.receiveDeliveryDirection, receiveDeliveryDirection)) &&
            (identical(other.receiveDeliveryAddressType, receiveDeliveryAddressType) || const DeepCollectionEquality().equals(other.receiveDeliveryAddressType, receiveDeliveryAddressType)) &&
            (identical(other.receiveDeliveryFromLocation, receiveDeliveryFromLocation) || const DeepCollectionEquality().equals(other.receiveDeliveryFromLocation, receiveDeliveryFromLocation)) &&
            (identical(other.receiveDeliveryFromContact, receiveDeliveryFromContact) || const DeepCollectionEquality().equals(other.receiveDeliveryFromContact, receiveDeliveryFromContact)) &&
            (identical(other.receiveDeliveryFromContactPhone, receiveDeliveryFromContactPhone) || const DeepCollectionEquality().equals(other.receiveDeliveryFromContactPhone, receiveDeliveryFromContactPhone)) &&
            (identical(other.receiveDeliveryFromAlternateContact, receiveDeliveryFromAlternateContact) || const DeepCollectionEquality().equals(other.receiveDeliveryFromAlternateContact, receiveDeliveryFromAlternateContact)) &&
            (identical(other.receiveDeliveryFromAlternateContactPhone, receiveDeliveryFromAlternateContactPhone) || const DeepCollectionEquality().equals(other.receiveDeliveryFromAlternateContactPhone, receiveDeliveryFromAlternateContactPhone)) &&
            (identical(other.receiveDeliveryFromAttention, receiveDeliveryFromAttention) || const DeepCollectionEquality().equals(other.receiveDeliveryFromAttention, receiveDeliveryFromAttention)) &&
            (identical(other.receiveDeliveryFromAddress1, receiveDeliveryFromAddress1) || const DeepCollectionEquality().equals(other.receiveDeliveryFromAddress1, receiveDeliveryFromAddress1)) &&
            (identical(other.receiveDeliveryFromAdd2ress, receiveDeliveryFromAdd2ress) || const DeepCollectionEquality().equals(other.receiveDeliveryFromAdd2ress, receiveDeliveryFromAdd2ress)) &&
            (identical(other.receiveDeliveryFromCity, receiveDeliveryFromCity) || const DeepCollectionEquality().equals(other.receiveDeliveryFromCity, receiveDeliveryFromCity)) &&
            (identical(other.receiveDeliveryFromState, receiveDeliveryFromState) || const DeepCollectionEquality().equals(other.receiveDeliveryFromState, receiveDeliveryFromState)) &&
            (identical(other.receiveDeliveryFromZipCode, receiveDeliveryFromZipCode) || const DeepCollectionEquality().equals(other.receiveDeliveryFromZipCode, receiveDeliveryFromZipCode)) &&
            (identical(other.receiveDeliveryFromCountry, receiveDeliveryFromCountry) || const DeepCollectionEquality().equals(other.receiveDeliveryFromCountry, receiveDeliveryFromCountry)) &&
            (identical(other.receiveDeliveryFromCountryId, receiveDeliveryFromCountryId) || const DeepCollectionEquality().equals(other.receiveDeliveryFromCountryId, receiveDeliveryFromCountryId)) &&
            (identical(other.receiveDeliveryFromCrossStreets, receiveDeliveryFromCrossStreets) || const DeepCollectionEquality().equals(other.receiveDeliveryFromCrossStreets, receiveDeliveryFromCrossStreets)) &&
            (identical(other.receiveDeliveryToLocation, receiveDeliveryToLocation) || const DeepCollectionEquality().equals(other.receiveDeliveryToLocation, receiveDeliveryToLocation)) &&
            (identical(other.receiveDeliveryToVenue, receiveDeliveryToVenue) || const DeepCollectionEquality().equals(other.receiveDeliveryToVenue, receiveDeliveryToVenue)) &&
            (identical(other.receiveDeliveryToVenueId, receiveDeliveryToVenueId) || const DeepCollectionEquality().equals(other.receiveDeliveryToVenueId, receiveDeliveryToVenueId)) &&
            (identical(other.receiveDeliveryToWarehouse, receiveDeliveryToWarehouse) || const DeepCollectionEquality().equals(other.receiveDeliveryToWarehouse, receiveDeliveryToWarehouse)) &&
            (identical(other.receiveDeliveryToWarehouseId, receiveDeliveryToWarehouseId) || const DeepCollectionEquality().equals(other.receiveDeliveryToWarehouseId, receiveDeliveryToWarehouseId)) &&
            (identical(other.receiveDeliveryToContact, receiveDeliveryToContact) || const DeepCollectionEquality().equals(other.receiveDeliveryToContact, receiveDeliveryToContact)) &&
            (identical(other.receiveDeliveryToContactPhone, receiveDeliveryToContactPhone) || const DeepCollectionEquality().equals(other.receiveDeliveryToContactPhone, receiveDeliveryToContactPhone)) &&
            (identical(other.receiveDeliveryToAlternateContact, receiveDeliveryToAlternateContact) || const DeepCollectionEquality().equals(other.receiveDeliveryToAlternateContact, receiveDeliveryToAlternateContact)) &&
            (identical(other.receiveDeliveryToAlternateContactPhone, receiveDeliveryToAlternateContactPhone) || const DeepCollectionEquality().equals(other.receiveDeliveryToAlternateContactPhone, receiveDeliveryToAlternateContactPhone)) &&
            (identical(other.receiveDeliveryToAttention, receiveDeliveryToAttention) || const DeepCollectionEquality().equals(other.receiveDeliveryToAttention, receiveDeliveryToAttention)) &&
            (identical(other.receiveDeliveryToAddress1, receiveDeliveryToAddress1) || const DeepCollectionEquality().equals(other.receiveDeliveryToAddress1, receiveDeliveryToAddress1)) &&
            (identical(other.receiveDeliveryToAddress2, receiveDeliveryToAddress2) || const DeepCollectionEquality().equals(other.receiveDeliveryToAddress2, receiveDeliveryToAddress2)) &&
            (identical(other.receiveDeliveryToCity, receiveDeliveryToCity) || const DeepCollectionEquality().equals(other.receiveDeliveryToCity, receiveDeliveryToCity)) &&
            (identical(other.receiveDeliveryToState, receiveDeliveryToState) || const DeepCollectionEquality().equals(other.receiveDeliveryToState, receiveDeliveryToState)) &&
            (identical(other.receiveDeliveryToZipCode, receiveDeliveryToZipCode) || const DeepCollectionEquality().equals(other.receiveDeliveryToZipCode, receiveDeliveryToZipCode)) &&
            (identical(other.receiveDeliveryToCountryId, receiveDeliveryToCountryId) || const DeepCollectionEquality().equals(other.receiveDeliveryToCountryId, receiveDeliveryToCountryId)) &&
            (identical(other.receiveDeliveryToCountry, receiveDeliveryToCountry) || const DeepCollectionEquality().equals(other.receiveDeliveryToCountry, receiveDeliveryToCountry)) &&
            (identical(other.receiveDeliveryToContactFax, receiveDeliveryToContactFax) || const DeepCollectionEquality().equals(other.receiveDeliveryToContactFax, receiveDeliveryToContactFax)) &&
            (identical(other.receiveDeliveryToCrossStreets, receiveDeliveryToCrossStreets) || const DeepCollectionEquality().equals(other.receiveDeliveryToCrossStreets, receiveDeliveryToCrossStreets)) &&
            (identical(other.receiveDeliveryDeliveryNotes, receiveDeliveryDeliveryNotes) || const DeepCollectionEquality().equals(other.receiveDeliveryDeliveryNotes, receiveDeliveryDeliveryNotes)) &&
            (identical(other.receiveDeliveryCarrierId, receiveDeliveryCarrierId) || const DeepCollectionEquality().equals(other.receiveDeliveryCarrierId, receiveDeliveryCarrierId)) &&
            (identical(other.receiveDeliveryCarrier, receiveDeliveryCarrier) || const DeepCollectionEquality().equals(other.receiveDeliveryCarrier, receiveDeliveryCarrier)) &&
            (identical(other.receiveDeliveryCarrierAccount, receiveDeliveryCarrierAccount) || const DeepCollectionEquality().equals(other.receiveDeliveryCarrierAccount, receiveDeliveryCarrierAccount)) &&
            (identical(other.receiveDeliveryShipViaId, receiveDeliveryShipViaId) || const DeepCollectionEquality().equals(other.receiveDeliveryShipViaId, receiveDeliveryShipViaId)) &&
            (identical(other.receiveDeliveryShipVia, receiveDeliveryShipVia) || const DeepCollectionEquality().equals(other.receiveDeliveryShipVia, receiveDeliveryShipVia)) &&
            (identical(other.receiveDeliveryInvoiceId, receiveDeliveryInvoiceId) || const DeepCollectionEquality().equals(other.receiveDeliveryInvoiceId, receiveDeliveryInvoiceId)) &&
            (identical(other.receiveDeliveryVendorInvoiceId, receiveDeliveryVendorInvoiceId) || const DeepCollectionEquality().equals(other.receiveDeliveryVendorInvoiceId, receiveDeliveryVendorInvoiceId)) &&
            (identical(other.receiveDeliveryEstimatedFreight, receiveDeliveryEstimatedFreight) || const DeepCollectionEquality().equals(other.receiveDeliveryEstimatedFreight, receiveDeliveryEstimatedFreight)) &&
            (identical(other.receiveDeliveryFreightInvoiceAmount, receiveDeliveryFreightInvoiceAmount) || const DeepCollectionEquality().equals(other.receiveDeliveryFreightInvoiceAmount, receiveDeliveryFreightInvoiceAmount)) &&
            (identical(other.receiveDeliveryChargeType, receiveDeliveryChargeType) || const DeepCollectionEquality().equals(other.receiveDeliveryChargeType, receiveDeliveryChargeType)) &&
            (identical(other.receiveDeliveryFreightTrackingNumber, receiveDeliveryFreightTrackingNumber) || const DeepCollectionEquality().equals(other.receiveDeliveryFreightTrackingNumber, receiveDeliveryFreightTrackingNumber)) &&
            (identical(other.receiveDeliveryFreightTrackingUrl, receiveDeliveryFreightTrackingUrl) || const DeepCollectionEquality().equals(other.receiveDeliveryFreightTrackingUrl, receiveDeliveryFreightTrackingUrl)) &&
            (identical(other.receiveDeliveryDropShip, receiveDeliveryDropShip) || const DeepCollectionEquality().equals(other.receiveDeliveryDropShip, receiveDeliveryDropShip)) &&
            (identical(other.receiveDeliveryPackageCode, receiveDeliveryPackageCode) || const DeepCollectionEquality().equals(other.receiveDeliveryPackageCode, receiveDeliveryPackageCode)) &&
            (identical(other.receiveDeliveryBillPoFreightOnOrder, receiveDeliveryBillPoFreightOnOrder) || const DeepCollectionEquality().equals(other.receiveDeliveryBillPoFreightOnOrder, receiveDeliveryBillPoFreightOnOrder)) &&
            (identical(other.receiveDeliveryOnlineOrderNumber, receiveDeliveryOnlineOrderNumber) || const DeepCollectionEquality().equals(other.receiveDeliveryOnlineOrderNumber, receiveDeliveryOnlineOrderNumber)) &&
            (identical(other.receiveDeliveryOnlineOrderStatus, receiveDeliveryOnlineOrderStatus) || const DeepCollectionEquality().equals(other.receiveDeliveryOnlineOrderStatus, receiveDeliveryOnlineOrderStatus)) &&
            (identical(other.receiveDeliveryDateStamp, receiveDeliveryDateStamp) || const DeepCollectionEquality().equals(other.receiveDeliveryDateStamp, receiveDeliveryDateStamp)) &&
            (identical(other.returnDeliveryId, returnDeliveryId) || const DeepCollectionEquality().equals(other.returnDeliveryId, returnDeliveryId)) &&
            (identical(other.returnDeliveryDeliveryType, returnDeliveryDeliveryType) || const DeepCollectionEquality().equals(other.returnDeliveryDeliveryType, returnDeliveryDeliveryType)) &&
            (identical(other.returnDeliveryRequiredDate, returnDeliveryRequiredDate) || const DeepCollectionEquality().equals(other.returnDeliveryRequiredDate, returnDeliveryRequiredDate)) &&
            (identical(other.returnDeliveryRequiredTime, returnDeliveryRequiredTime) || const DeepCollectionEquality().equals(other.returnDeliveryRequiredTime, returnDeliveryRequiredTime)) &&
            (identical(other.returnDeliveryTargetShipDate, returnDeliveryTargetShipDate) || const DeepCollectionEquality().equals(other.returnDeliveryTargetShipDate, returnDeliveryTargetShipDate)) &&
            (identical(other.returnDeliveryTargetShipTime, returnDeliveryTargetShipTime) || const DeepCollectionEquality().equals(other.returnDeliveryTargetShipTime, returnDeliveryTargetShipTime)) &&
            (identical(other.returnDeliveryDirection, returnDeliveryDirection) || const DeepCollectionEquality().equals(other.returnDeliveryDirection, returnDeliveryDirection)) &&
            (identical(other.returnDeliveryAddressType, returnDeliveryAddressType) || const DeepCollectionEquality().equals(other.returnDeliveryAddressType, returnDeliveryAddressType)) &&
            (identical(other.returnDeliveryFromLocation, returnDeliveryFromLocation) || const DeepCollectionEquality().equals(other.returnDeliveryFromLocation, returnDeliveryFromLocation)) &&
            (identical(other.returnDeliveryFromContact, returnDeliveryFromContact) || const DeepCollectionEquality().equals(other.returnDeliveryFromContact, returnDeliveryFromContact)) &&
            (identical(other.returnDeliveryFromContactPhone, returnDeliveryFromContactPhone) || const DeepCollectionEquality().equals(other.returnDeliveryFromContactPhone, returnDeliveryFromContactPhone)) &&
            (identical(other.returnDeliveryFromAlternateContact, returnDeliveryFromAlternateContact) || const DeepCollectionEquality().equals(other.returnDeliveryFromAlternateContact, returnDeliveryFromAlternateContact)) &&
            (identical(other.returnDeliveryFromAlternateContactPhone, returnDeliveryFromAlternateContactPhone) || const DeepCollectionEquality().equals(other.returnDeliveryFromAlternateContactPhone, returnDeliveryFromAlternateContactPhone)) &&
            (identical(other.returnDeliveryFromAttention, returnDeliveryFromAttention) || const DeepCollectionEquality().equals(other.returnDeliveryFromAttention, returnDeliveryFromAttention)) &&
            (identical(other.returnDeliveryFromAddress1, returnDeliveryFromAddress1) || const DeepCollectionEquality().equals(other.returnDeliveryFromAddress1, returnDeliveryFromAddress1)) &&
            (identical(other.returnDeliveryFromAdd2ress, returnDeliveryFromAdd2ress) || const DeepCollectionEquality().equals(other.returnDeliveryFromAdd2ress, returnDeliveryFromAdd2ress)) &&
            (identical(other.returnDeliveryFromCity, returnDeliveryFromCity) || const DeepCollectionEquality().equals(other.returnDeliveryFromCity, returnDeliveryFromCity)) &&
            (identical(other.returnDeliveryFromState, returnDeliveryFromState) || const DeepCollectionEquality().equals(other.returnDeliveryFromState, returnDeliveryFromState)) &&
            (identical(other.returnDeliveryFromZipCode, returnDeliveryFromZipCode) || const DeepCollectionEquality().equals(other.returnDeliveryFromZipCode, returnDeliveryFromZipCode)) &&
            (identical(other.returnDeliveryFromCountry, returnDeliveryFromCountry) || const DeepCollectionEquality().equals(other.returnDeliveryFromCountry, returnDeliveryFromCountry)) &&
            (identical(other.returnDeliveryFromCountryId, returnDeliveryFromCountryId) || const DeepCollectionEquality().equals(other.returnDeliveryFromCountryId, returnDeliveryFromCountryId)) &&
            (identical(other.returnDeliveryFromCrossStreets, returnDeliveryFromCrossStreets) || const DeepCollectionEquality().equals(other.returnDeliveryFromCrossStreets, returnDeliveryFromCrossStreets)) &&
            (identical(other.returnDeliveryToLocation, returnDeliveryToLocation) || const DeepCollectionEquality().equals(other.returnDeliveryToLocation, returnDeliveryToLocation)) &&
            (identical(other.returnDeliveryToVenue, returnDeliveryToVenue) || const DeepCollectionEquality().equals(other.returnDeliveryToVenue, returnDeliveryToVenue)) &&
            (identical(other.returnDeliveryToVenueId, returnDeliveryToVenueId) || const DeepCollectionEquality().equals(other.returnDeliveryToVenueId, returnDeliveryToVenueId)) &&
            (identical(other.returnDeliveryToWarehouse, returnDeliveryToWarehouse) || const DeepCollectionEquality().equals(other.returnDeliveryToWarehouse, returnDeliveryToWarehouse)) &&
            (identical(other.returnDeliveryToWarehouseId, returnDeliveryToWarehouseId) || const DeepCollectionEquality().equals(other.returnDeliveryToWarehouseId, returnDeliveryToWarehouseId)) &&
            (identical(other.returnDeliveryToContact, returnDeliveryToContact) || const DeepCollectionEquality().equals(other.returnDeliveryToContact, returnDeliveryToContact)) &&
            (identical(other.returnDeliveryToContactPhone, returnDeliveryToContactPhone) || const DeepCollectionEquality().equals(other.returnDeliveryToContactPhone, returnDeliveryToContactPhone)) &&
            (identical(other.returnDeliveryToAlternateContact, returnDeliveryToAlternateContact) || const DeepCollectionEquality().equals(other.returnDeliveryToAlternateContact, returnDeliveryToAlternateContact)) &&
            (identical(other.returnDeliveryToAlternateContactPhone, returnDeliveryToAlternateContactPhone) || const DeepCollectionEquality().equals(other.returnDeliveryToAlternateContactPhone, returnDeliveryToAlternateContactPhone)) &&
            (identical(other.returnDeliveryToAttention, returnDeliveryToAttention) || const DeepCollectionEquality().equals(other.returnDeliveryToAttention, returnDeliveryToAttention)) &&
            (identical(other.returnDeliveryToAddress1, returnDeliveryToAddress1) || const DeepCollectionEquality().equals(other.returnDeliveryToAddress1, returnDeliveryToAddress1)) &&
            (identical(other.returnDeliveryToAddress2, returnDeliveryToAddress2) || const DeepCollectionEquality().equals(other.returnDeliveryToAddress2, returnDeliveryToAddress2)) &&
            (identical(other.returnDeliveryToCity, returnDeliveryToCity) || const DeepCollectionEquality().equals(other.returnDeliveryToCity, returnDeliveryToCity)) &&
            (identical(other.returnDeliveryToState, returnDeliveryToState) || const DeepCollectionEquality().equals(other.returnDeliveryToState, returnDeliveryToState)) &&
            (identical(other.returnDeliveryToZipCode, returnDeliveryToZipCode) || const DeepCollectionEquality().equals(other.returnDeliveryToZipCode, returnDeliveryToZipCode)) &&
            (identical(other.returnDeliveryToCountryId, returnDeliveryToCountryId) || const DeepCollectionEquality().equals(other.returnDeliveryToCountryId, returnDeliveryToCountryId)) &&
            (identical(other.returnDeliveryToCountry, returnDeliveryToCountry) || const DeepCollectionEquality().equals(other.returnDeliveryToCountry, returnDeliveryToCountry)) &&
            (identical(other.returnDeliveryToContactFax, returnDeliveryToContactFax) || const DeepCollectionEquality().equals(other.returnDeliveryToContactFax, returnDeliveryToContactFax)) &&
            (identical(other.returnDeliveryToCrossStreets, returnDeliveryToCrossStreets) || const DeepCollectionEquality().equals(other.returnDeliveryToCrossStreets, returnDeliveryToCrossStreets)) &&
            (identical(other.returnDeliveryDeliveryNotes, returnDeliveryDeliveryNotes) || const DeepCollectionEquality().equals(other.returnDeliveryDeliveryNotes, returnDeliveryDeliveryNotes)) &&
            (identical(other.returnDeliveryCarrierId, returnDeliveryCarrierId) || const DeepCollectionEquality().equals(other.returnDeliveryCarrierId, returnDeliveryCarrierId)) &&
            (identical(other.returnDeliveryCarrier, returnDeliveryCarrier) || const DeepCollectionEquality().equals(other.returnDeliveryCarrier, returnDeliveryCarrier)) &&
            (identical(other.returnDeliveryCarrierAccount, returnDeliveryCarrierAccount) || const DeepCollectionEquality().equals(other.returnDeliveryCarrierAccount, returnDeliveryCarrierAccount)) &&
            (identical(other.returnDeliveryShipViaId, returnDeliveryShipViaId) || const DeepCollectionEquality().equals(other.returnDeliveryShipViaId, returnDeliveryShipViaId)) &&
            (identical(other.returnDeliveryShipVia, returnDeliveryShipVia) || const DeepCollectionEquality().equals(other.returnDeliveryShipVia, returnDeliveryShipVia)) &&
            (identical(other.returnDeliveryInvoiceId, returnDeliveryInvoiceId) || const DeepCollectionEquality().equals(other.returnDeliveryInvoiceId, returnDeliveryInvoiceId)) &&
            (identical(other.returnDeliveryVendorInvoiceId, returnDeliveryVendorInvoiceId) || const DeepCollectionEquality().equals(other.returnDeliveryVendorInvoiceId, returnDeliveryVendorInvoiceId)) &&
            (identical(other.returnDeliveryEstimatedFreight, returnDeliveryEstimatedFreight) || const DeepCollectionEquality().equals(other.returnDeliveryEstimatedFreight, returnDeliveryEstimatedFreight)) &&
            (identical(other.returnDeliveryFreightInvoiceAmount, returnDeliveryFreightInvoiceAmount) || const DeepCollectionEquality().equals(other.returnDeliveryFreightInvoiceAmount, returnDeliveryFreightInvoiceAmount)) &&
            (identical(other.returnDeliveryChargeType, returnDeliveryChargeType) || const DeepCollectionEquality().equals(other.returnDeliveryChargeType, returnDeliveryChargeType)) &&
            (identical(other.returnDeliveryFreightTrackingNumber, returnDeliveryFreightTrackingNumber) || const DeepCollectionEquality().equals(other.returnDeliveryFreightTrackingNumber, returnDeliveryFreightTrackingNumber)) &&
            (identical(other.returnDeliveryFreightTrackingUrl, returnDeliveryFreightTrackingUrl) || const DeepCollectionEquality().equals(other.returnDeliveryFreightTrackingUrl, returnDeliveryFreightTrackingUrl)) &&
            (identical(other.returnDeliveryVendorRetrieve, returnDeliveryVendorRetrieve) || const DeepCollectionEquality().equals(other.returnDeliveryVendorRetrieve, returnDeliveryVendorRetrieve)) &&
            (identical(other.returnDeliveryPackageCode, returnDeliveryPackageCode) || const DeepCollectionEquality().equals(other.returnDeliveryPackageCode, returnDeliveryPackageCode)) &&
            (identical(other.returnDeliveryBillPoFreightOnOrder, returnDeliveryBillPoFreightOnOrder) || const DeepCollectionEquality().equals(other.returnDeliveryBillPoFreightOnOrder, returnDeliveryBillPoFreightOnOrder)) &&
            (identical(other.returnDeliveryOnlineOrderNumber, returnDeliveryOnlineOrderNumber) || const DeepCollectionEquality().equals(other.returnDeliveryOnlineOrderNumber, returnDeliveryOnlineOrderNumber)) &&
            (identical(other.returnDeliveryOnlineOrderStatus, returnDeliveryOnlineOrderStatus) || const DeepCollectionEquality().equals(other.returnDeliveryOnlineOrderStatus, returnDeliveryOnlineOrderStatus)) &&
            (identical(other.returnDeliveryDateStamp, returnDeliveryDateStamp) || const DeepCollectionEquality().equals(other.returnDeliveryDateStamp, returnDeliveryDateStamp)) &&
            (identical(other.enableProjects, enableProjects) || const DeepCollectionEquality().equals(other.enableProjects, enableProjects)) &&
            (identical(other.projectId, projectId) || const DeepCollectionEquality().equals(other.projectId, projectId)) &&
            (identical(other.projectNumber, projectNumber) || const DeepCollectionEquality().equals(other.projectNumber, projectNumber)) &&
            (identical(other.project, project) || const DeepCollectionEquality().equals(other.project, project)) &&
            (identical(other.projectDrawingsId, projectDrawingsId) || const DeepCollectionEquality().equals(other.projectDrawingsId, projectDrawingsId)) &&
            (identical(other.projectDrawings, projectDrawings) || const DeepCollectionEquality().equals(other.projectDrawings, projectDrawings)) &&
            (identical(other.projectItemsOrderedId, projectItemsOrderedId) || const DeepCollectionEquality().equals(other.projectItemsOrderedId, projectItemsOrderedId)) &&
            (identical(other.projectItemsOrdered, projectItemsOrdered) || const DeepCollectionEquality().equals(other.projectItemsOrdered, projectItemsOrdered)) &&
            (identical(other.projectDropShipId, projectDropShipId) || const DeepCollectionEquality().equals(other.projectDropShipId, projectDropShipId)) &&
            (identical(other.projectDropShip, projectDropShip) || const DeepCollectionEquality().equals(other.projectDropShip, projectDropShip)) &&
            (identical(other.projectAsBuildId, projectAsBuildId) || const DeepCollectionEquality().equals(other.projectAsBuildId, projectAsBuildId)) &&
            (identical(other.projectAsBuild, projectAsBuild) || const DeepCollectionEquality().equals(other.projectAsBuild, projectAsBuild)) &&
            (identical(other.projectCommissioningId, projectCommissioningId) || const DeepCollectionEquality().equals(other.projectCommissioningId, projectCommissioningId)) &&
            (identical(other.projectCommissioning, projectCommissioning) || const DeepCollectionEquality().equals(other.projectCommissioning, projectCommissioning)) &&
            (identical(other.projectDepositId, projectDepositId) || const DeepCollectionEquality().equals(other.projectDepositId, projectDepositId)) &&
            (identical(other.projectDeposit, projectDeposit) || const DeepCollectionEquality().equals(other.projectDeposit, projectDeposit)) &&
            (identical(other.location, location) || const DeepCollectionEquality().equals(other.location, location)) &&
            (identical(other.currencyId, currencyId) || const DeepCollectionEquality().equals(other.currencyId, currencyId)) &&
            (identical(other.updateAllRatesToNewCurrency, updateAllRatesToNewCurrency) || const DeepCollectionEquality().equals(other.updateAllRatesToNewCurrency, updateAllRatesToNewCurrency)) &&
            (identical(other.confirmUpdateAllRatesToNewCurrency, confirmUpdateAllRatesToNewCurrency) || const DeepCollectionEquality().equals(other.confirmUpdateAllRatesToNewCurrency, confirmUpdateAllRatesToNewCurrency)) &&
            (identical(other.currencyCode, currencyCode) || const DeepCollectionEquality().equals(other.currencyCode, currencyCode)) &&
            (identical(other.currency, currency) || const DeepCollectionEquality().equals(other.currency, currency)) &&
            (identical(other.currencySymbol, currencySymbol) || const DeepCollectionEquality().equals(other.currencySymbol, currencySymbol)) &&
            (identical(other.billingCycleId, billingCycleId) || const DeepCollectionEquality().equals(other.billingCycleId, billingCycleId)) &&
            (identical(other.billingCycle, billingCycle) || const DeepCollectionEquality().equals(other.billingCycle, billingCycle)) &&
            (identical(other.remitToAttention1, remitToAttention1) || const DeepCollectionEquality().equals(other.remitToAttention1, remitToAttention1)) &&
            (identical(other.remitToAttention2, remitToAttention2) || const DeepCollectionEquality().equals(other.remitToAttention2, remitToAttention2)) &&
            (identical(other.remitToAddress1, remitToAddress1) || const DeepCollectionEquality().equals(other.remitToAddress1, remitToAddress1)) &&
            (identical(other.remitToAddress2, remitToAddress2) || const DeepCollectionEquality().equals(other.remitToAddress2, remitToAddress2)) &&
            (identical(other.remitToCity, remitToCity) || const DeepCollectionEquality().equals(other.remitToCity, remitToCity)) &&
            (identical(other.remitToState, remitToState) || const DeepCollectionEquality().equals(other.remitToState, remitToState)) &&
            (identical(other.remitToCountryId, remitToCountryId) || const DeepCollectionEquality().equals(other.remitToCountryId, remitToCountryId)) &&
            (identical(other.remitToCountry, remitToCountry) || const DeepCollectionEquality().equals(other.remitToCountry, remitToCountry)) &&
            (identical(other.remitToZipCode, remitToZipCode) || const DeepCollectionEquality().equals(other.remitToZipCode, remitToZipCode)) &&
            (identical(other.remitToEmail, remitToEmail) || const DeepCollectionEquality().equals(other.remitToEmail, remitToEmail)) &&
            (identical(other.remitToPhone, remitToPhone) || const DeepCollectionEquality().equals(other.remitToPhone, remitToPhone)) &&
            (identical(other.paymentTypeId, paymentTypeId) || const DeepCollectionEquality().equals(other.paymentTypeId, paymentTypeId)) &&
            (identical(other.paymentType, paymentType) || const DeepCollectionEquality().equals(other.paymentType, paymentType)) &&
            (identical(other.paymentTermsId, paymentTermsId) || const DeepCollectionEquality().equals(other.paymentTermsId, paymentTermsId)) &&
            (identical(other.paymentTerms, paymentTerms) || const DeepCollectionEquality().equals(other.paymentTerms, paymentTerms)) &&
            (identical(other.paymentTermsDueInDays, paymentTermsDueInDays) || const DeepCollectionEquality().equals(other.paymentTermsDueInDays, paymentTermsDueInDays)) &&
            (identical(other.taxOptionId, taxOptionId) || const DeepCollectionEquality().equals(other.taxOptionId, taxOptionId)) &&
            (identical(other.taxOption, taxOption) || const DeepCollectionEquality().equals(other.taxOption, taxOption)) &&
            (identical(other.taxId, taxId) || const DeepCollectionEquality().equals(other.taxId, taxId)) &&
            (identical(other.tax1Name, tax1Name) || const DeepCollectionEquality().equals(other.tax1Name, tax1Name)) &&
            (identical(other.tax2Name, tax2Name) || const DeepCollectionEquality().equals(other.tax2Name, tax2Name)) &&
            (identical(other.rentalTaxRate1, rentalTaxRate1) || const DeepCollectionEquality().equals(other.rentalTaxRate1, rentalTaxRate1)) &&
            (identical(other.salesTaxRate1, salesTaxRate1) || const DeepCollectionEquality().equals(other.salesTaxRate1, salesTaxRate1)) &&
            (identical(other.laborTaxRate1, laborTaxRate1) || const DeepCollectionEquality().equals(other.laborTaxRate1, laborTaxRate1)) &&
            (identical(other.rentalTaxRate2, rentalTaxRate2) || const DeepCollectionEquality().equals(other.rentalTaxRate2, rentalTaxRate2)) &&
            (identical(other.salesTaxRate2, salesTaxRate2) || const DeepCollectionEquality().equals(other.salesTaxRate2, salesTaxRate2)) &&
            (identical(other.laborTaxRate2, laborTaxRate2) || const DeepCollectionEquality().equals(other.laborTaxRate2, laborTaxRate2)) &&
            (identical(other.hasRentalItem, hasRentalItem) || const DeepCollectionEquality().equals(other.hasRentalItem, hasRentalItem)) &&
            (identical(other.hasSalesItem, hasSalesItem) || const DeepCollectionEquality().equals(other.hasSalesItem, hasSalesItem)) &&
            (identical(other.hasMiscellaneousItem, hasMiscellaneousItem) || const DeepCollectionEquality().equals(other.hasMiscellaneousItem, hasMiscellaneousItem)) &&
            (identical(other.hasLaborItem, hasLaborItem) || const DeepCollectionEquality().equals(other.hasLaborItem, hasLaborItem)) &&
            (identical(other.hasFacilitiesItem, hasFacilitiesItem) || const DeepCollectionEquality().equals(other.hasFacilitiesItem, hasFacilitiesItem)) &&
            (identical(other.hasLossAndDamageItem, hasLossAndDamageItem) || const DeepCollectionEquality().equals(other.hasLossAndDamageItem, hasLossAndDamageItem)) &&
            (identical(other.hasRentalSaleItem, hasRentalSaleItem) || const DeepCollectionEquality().equals(other.hasRentalSaleItem, hasRentalSaleItem)) &&
            (identical(other.hasPartsItem, hasPartsItem) || const DeepCollectionEquality().equals(other.hasPartsItem, hasPartsItem)) &&
            (identical(other.rentalDiscountPercent, rentalDiscountPercent) || const DeepCollectionEquality().equals(other.rentalDiscountPercent, rentalDiscountPercent)) &&
            (identical(other.rentalTotal, rentalTotal) || const DeepCollectionEquality().equals(other.rentalTotal, rentalTotal)) &&
            (identical(other.rentalTotalIncludesTax, rentalTotalIncludesTax) || const DeepCollectionEquality().equals(other.rentalTotalIncludesTax, rentalTotalIncludesTax)) &&
            (identical(other.salesDiscountPercent, salesDiscountPercent) || const DeepCollectionEquality().equals(other.salesDiscountPercent, salesDiscountPercent)) &&
            (identical(other.salesTotal, salesTotal) || const DeepCollectionEquality().equals(other.salesTotal, salesTotal)) &&
            (identical(other.salesTotalIncludesTax, salesTotalIncludesTax) || const DeepCollectionEquality().equals(other.salesTotalIncludesTax, salesTotalIncludesTax)) &&
            (identical(other.partsDiscountPercent, partsDiscountPercent) || const DeepCollectionEquality().equals(other.partsDiscountPercent, partsDiscountPercent)) &&
            (identical(other.partsTotal, partsTotal) || const DeepCollectionEquality().equals(other.partsTotal, partsTotal)) &&
            (identical(other.partsTotalIncludesTax, partsTotalIncludesTax) || const DeepCollectionEquality().equals(other.partsTotalIncludesTax, partsTotalIncludesTax)) &&
            (identical(other.vehicleDiscountPercent, vehicleDiscountPercent) || const DeepCollectionEquality().equals(other.vehicleDiscountPercent, vehicleDiscountPercent)) &&
            (identical(other.vehicleTotal, vehicleTotal) || const DeepCollectionEquality().equals(other.vehicleTotal, vehicleTotal)) &&
            (identical(other.vehicleTotalIncludesTax, vehicleTotalIncludesTax) || const DeepCollectionEquality().equals(other.vehicleTotalIncludesTax, vehicleTotalIncludesTax)) &&
            (identical(other.miscDiscountPercent, miscDiscountPercent) || const DeepCollectionEquality().equals(other.miscDiscountPercent, miscDiscountPercent)) &&
            (identical(other.miscTotal, miscTotal) || const DeepCollectionEquality().equals(other.miscTotal, miscTotal)) &&
            (identical(other.miscTotalIncludesTax, miscTotalIncludesTax) || const DeepCollectionEquality().equals(other.miscTotalIncludesTax, miscTotalIncludesTax)) &&
            (identical(other.laborDiscountPercent, laborDiscountPercent) || const DeepCollectionEquality().equals(other.laborDiscountPercent, laborDiscountPercent)) &&
            (identical(other.laborTotal, laborTotal) || const DeepCollectionEquality().equals(other.laborTotal, laborTotal)) &&
            (identical(other.laborTotalIncludesTax, laborTotalIncludesTax) || const DeepCollectionEquality().equals(other.laborTotalIncludesTax, laborTotalIncludesTax)) &&
            (identical(other.subRentalDaysPerWeek, subRentalDaysPerWeek) || const DeepCollectionEquality().equals(other.subRentalDaysPerWeek, subRentalDaysPerWeek)) &&
            (identical(other.subRentalDiscountPercent, subRentalDiscountPercent) || const DeepCollectionEquality().equals(other.subRentalDiscountPercent, subRentalDiscountPercent)) &&
            (identical(other.weeklySubRentalTotal, weeklySubRentalTotal) || const DeepCollectionEquality().equals(other.weeklySubRentalTotal, weeklySubRentalTotal)) &&
            (identical(other.monthlySubRentalTotal, monthlySubRentalTotal) || const DeepCollectionEquality().equals(other.monthlySubRentalTotal, monthlySubRentalTotal)) &&
            (identical(other.periodSubRentalTotal, periodSubRentalTotal) || const DeepCollectionEquality().equals(other.periodSubRentalTotal, periodSubRentalTotal)) &&
            (identical(other.weeklySubRentalTotalIncludesTax, weeklySubRentalTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklySubRentalTotalIncludesTax, weeklySubRentalTotalIncludesTax)) &&
            (identical(other.monthlySubRentalTotalIncludesTax, monthlySubRentalTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlySubRentalTotalIncludesTax, monthlySubRentalTotalIncludesTax)) &&
            (identical(other.periodSubRentalTotalIncludesTax, periodSubRentalTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodSubRentalTotalIncludesTax, periodSubRentalTotalIncludesTax)) &&
            (identical(other.subSalesDiscountPercent, subSalesDiscountPercent) || const DeepCollectionEquality().equals(other.subSalesDiscountPercent, subSalesDiscountPercent)) &&
            (identical(other.subSalesTotal, subSalesTotal) || const DeepCollectionEquality().equals(other.subSalesTotal, subSalesTotal)) &&
            (identical(other.subSalesTotalIncludesTax, subSalesTotalIncludesTax) || const DeepCollectionEquality().equals(other.subSalesTotalIncludesTax, subSalesTotalIncludesTax)) &&
            (identical(other.subVehicleDaysPerWeek, subVehicleDaysPerWeek) || const DeepCollectionEquality().equals(other.subVehicleDaysPerWeek, subVehicleDaysPerWeek)) &&
            (identical(other.subvehicleDiscountPercent, subvehicleDiscountPercent) || const DeepCollectionEquality().equals(other.subvehicleDiscountPercent, subvehicleDiscountPercent)) &&
            (identical(other.weeklySubVehicleTotal, weeklySubVehicleTotal) || const DeepCollectionEquality().equals(other.weeklySubVehicleTotal, weeklySubVehicleTotal)) &&
            (identical(other.monthlySubVehicleTotal, monthlySubVehicleTotal) || const DeepCollectionEquality().equals(other.monthlySubVehicleTotal, monthlySubVehicleTotal)) &&
            (identical(other.periodSubVehicleTotal, periodSubVehicleTotal) || const DeepCollectionEquality().equals(other.periodSubVehicleTotal, periodSubVehicleTotal)) &&
            (identical(other.weeklySubVehicleTotalIncludesTax, weeklySubVehicleTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklySubVehicleTotalIncludesTax, weeklySubVehicleTotalIncludesTax)) &&
            (identical(other.monthlySubVehicleTotalIncludesTax, monthlySubVehicleTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlySubVehicleTotalIncludesTax, monthlySubVehicleTotalIncludesTax)) &&
            (identical(other.periodSubVehicleTotalIncludesTax, periodSubVehicleTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodSubVehicleTotalIncludesTax, periodSubVehicleTotalIncludesTax)) &&
            (identical(other.subMiscDiscountPercent, subMiscDiscountPercent) || const DeepCollectionEquality().equals(other.subMiscDiscountPercent, subMiscDiscountPercent)) &&
            (identical(other.weeklySubMiscTotal, weeklySubMiscTotal) || const DeepCollectionEquality().equals(other.weeklySubMiscTotal, weeklySubMiscTotal)) &&
            (identical(other.monthlySubMiscTotal, monthlySubMiscTotal) || const DeepCollectionEquality().equals(other.monthlySubMiscTotal, monthlySubMiscTotal)) &&
            (identical(other.periodSubMiscTotal, periodSubMiscTotal) || const DeepCollectionEquality().equals(other.periodSubMiscTotal, periodSubMiscTotal)) &&
            (identical(other.weeklySubMiscTotalIncludesTax, weeklySubMiscTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklySubMiscTotalIncludesTax, weeklySubMiscTotalIncludesTax)) &&
            (identical(other.monthlySubMiscTotalIncludesTax, monthlySubMiscTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlySubMiscTotalIncludesTax, monthlySubMiscTotalIncludesTax)) &&
            (identical(other.periodSubMiscTotalIncludesTax, periodSubMiscTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodSubMiscTotalIncludesTax, periodSubMiscTotalIncludesTax)) &&
            (identical(other.subLaborDiscountPercent, subLaborDiscountPercent) || const DeepCollectionEquality().equals(other.subLaborDiscountPercent, subLaborDiscountPercent)) &&
            (identical(other.weeklySubLaborTotal, weeklySubLaborTotal) || const DeepCollectionEquality().equals(other.weeklySubLaborTotal, weeklySubLaborTotal)) &&
            (identical(other.monthlySubLaborTotal, monthlySubLaborTotal) || const DeepCollectionEquality().equals(other.monthlySubLaborTotal, monthlySubLaborTotal)) &&
            (identical(other.periodSubLaborTotal, periodSubLaborTotal) || const DeepCollectionEquality().equals(other.periodSubLaborTotal, periodSubLaborTotal)) &&
            (identical(other.weeklySubLaborTotalIncludesTax, weeklySubLaborTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklySubLaborTotalIncludesTax, weeklySubLaborTotalIncludesTax)) &&
            (identical(other.monthlySubLaborTotalIncludesTax, monthlySubLaborTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlySubLaborTotalIncludesTax, monthlySubLaborTotalIncludesTax)) &&
            (identical(other.periodSubLaborTotalIncludesTax, periodSubLaborTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodSubLaborTotalIncludesTax, periodSubLaborTotalIncludesTax)) &&
            (identical(other.miscellaneousIsComplete, miscellaneousIsComplete) || const DeepCollectionEquality().equals(other.miscellaneousIsComplete, miscellaneousIsComplete)) &&
            (identical(other.subMiscellaneousIsComplete, subMiscellaneousIsComplete) || const DeepCollectionEquality().equals(other.subMiscellaneousIsComplete, subMiscellaneousIsComplete)) &&
            (identical(other.laborIsComplete, laborIsComplete) || const DeepCollectionEquality().equals(other.laborIsComplete, laborIsComplete)) &&
            (identical(other.subLaborIsComplete, subLaborIsComplete) || const DeepCollectionEquality().equals(other.subLaborIsComplete, subLaborIsComplete)) &&
            (identical(other.currencyColor, currencyColor) || const DeepCollectionEquality().equals(other.currencyColor, currencyColor)) &&
            (identical(other.statusColor, statusColor) || const DeepCollectionEquality().equals(other.statusColor, statusColor)) &&
            (identical(other.purchaseOrderNumberColor, purchaseOrderNumberColor) || const DeepCollectionEquality().equals(other.purchaseOrderNumberColor, purchaseOrderNumberColor)) &&
            (identical(other.vendorColor, vendorColor) || const DeepCollectionEquality().equals(other.vendorColor, vendorColor)) &&
            (identical(other.descriptionColor, descriptionColor) || const DeepCollectionEquality().equals(other.descriptionColor, descriptionColor)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesAgentPurchaseOrderPurchaseOrderExtension
    on WebApiModulesAgentPurchaseOrderPurchaseOrder {
  WebApiModulesAgentPurchaseOrderPurchaseOrder copyWith(
      {String? purchaseOrderId,
      String? purchaseOrderNumber,
      String? description,
      String? purchaseOrderDate,
      String? requisitionNumber,
      String? requisitionDate,
      String? vendorId,
      String? vendor,
      String? agentId,
      String? agent,
      String? status,
      String? statusDate,
      String? referenceNumber,
      bool? needsApproval,
      String? approvedByUserId,
      String? departmentId,
      String? department,
      String? officeLocationId,
      String? officeLocation,
      String? warehouseId,
      String? warehouse,
      String? warehouseCode,
      int? quantityHolding,
      int? quantityToBarCode,
      bool? rental,
      bool? sales,
      bool? parts,
      bool? labor,
      bool? miscellaneous,
      bool? vehicle,
      bool? subRent,
      bool? subSale,
      bool? subLabor,
      bool? subMiscellaneous,
      bool? subVehicle,
      bool? repair,
      bool? consignment,
      String? consignorAgreementId,
      String? consignorAgreementNumber,
      String? orderId,
      String? orderNumber,
      String? dealNumber,
      String? dealId,
      String? deal,
      String? rateType,
      bool? departmentLocationRequiresApproval,
      double? total,
      String? poTypeId,
      String? poType,
      String? poClassificationId,
      String? poClassification,
      List<WebApiModulesHomeControlsOrderDatesOrderDates>?
          activityDatesAndTimes,
      String? estimatedStartDate,
      String? estimatedStartTime,
      String? estimatedStopDate,
      String? estimatedStopTime,
      String? billingStartDate,
      String? billingEndDate,
      double? billingWeeks,
      double? billingMonths,
      double? invoicedAmount,
      String? projectManagerId,
      String? projectManager,
      String? receiveDeliveryId,
      String? receiveDeliveryDeliveryType,
      String? receiveDeliveryRequiredDate,
      String? receiveDeliveryRequiredTime,
      String? receiveDeliveryTargetShipDate,
      String? receiveDeliveryTargetShipTime,
      String? receiveDeliveryDirection,
      String? receiveDeliveryAddressType,
      String? receiveDeliveryFromLocation,
      String? receiveDeliveryFromContact,
      String? receiveDeliveryFromContactPhone,
      String? receiveDeliveryFromAlternateContact,
      String? receiveDeliveryFromAlternateContactPhone,
      String? receiveDeliveryFromAttention,
      String? receiveDeliveryFromAddress1,
      String? receiveDeliveryFromAdd2ress,
      String? receiveDeliveryFromCity,
      String? receiveDeliveryFromState,
      String? receiveDeliveryFromZipCode,
      String? receiveDeliveryFromCountry,
      String? receiveDeliveryFromCountryId,
      String? receiveDeliveryFromCrossStreets,
      String? receiveDeliveryToLocation,
      String? receiveDeliveryToVenue,
      String? receiveDeliveryToVenueId,
      String? receiveDeliveryToWarehouse,
      String? receiveDeliveryToWarehouseId,
      String? receiveDeliveryToContact,
      String? receiveDeliveryToContactPhone,
      String? receiveDeliveryToAlternateContact,
      String? receiveDeliveryToAlternateContactPhone,
      String? receiveDeliveryToAttention,
      String? receiveDeliveryToAddress1,
      String? receiveDeliveryToAddress2,
      String? receiveDeliveryToCity,
      String? receiveDeliveryToState,
      String? receiveDeliveryToZipCode,
      String? receiveDeliveryToCountryId,
      String? receiveDeliveryToCountry,
      String? receiveDeliveryToContactFax,
      String? receiveDeliveryToCrossStreets,
      String? receiveDeliveryDeliveryNotes,
      String? receiveDeliveryCarrierId,
      String? receiveDeliveryCarrier,
      String? receiveDeliveryCarrierAccount,
      String? receiveDeliveryShipViaId,
      String? receiveDeliveryShipVia,
      String? receiveDeliveryInvoiceId,
      String? receiveDeliveryVendorInvoiceId,
      double? receiveDeliveryEstimatedFreight,
      double? receiveDeliveryFreightInvoiceAmount,
      String? receiveDeliveryChargeType,
      String? receiveDeliveryFreightTrackingNumber,
      String? receiveDeliveryFreightTrackingUrl,
      bool? receiveDeliveryDropShip,
      String? receiveDeliveryPackageCode,
      bool? receiveDeliveryBillPoFreightOnOrder,
      String? receiveDeliveryOnlineOrderNumber,
      String? receiveDeliveryOnlineOrderStatus,
      String? receiveDeliveryDateStamp,
      String? returnDeliveryId,
      String? returnDeliveryDeliveryType,
      String? returnDeliveryRequiredDate,
      String? returnDeliveryRequiredTime,
      String? returnDeliveryTargetShipDate,
      String? returnDeliveryTargetShipTime,
      String? returnDeliveryDirection,
      String? returnDeliveryAddressType,
      String? returnDeliveryFromLocation,
      String? returnDeliveryFromContact,
      String? returnDeliveryFromContactPhone,
      String? returnDeliveryFromAlternateContact,
      String? returnDeliveryFromAlternateContactPhone,
      String? returnDeliveryFromAttention,
      String? returnDeliveryFromAddress1,
      String? returnDeliveryFromAdd2ress,
      String? returnDeliveryFromCity,
      String? returnDeliveryFromState,
      String? returnDeliveryFromZipCode,
      String? returnDeliveryFromCountry,
      String? returnDeliveryFromCountryId,
      String? returnDeliveryFromCrossStreets,
      String? returnDeliveryToLocation,
      String? returnDeliveryToVenue,
      String? returnDeliveryToVenueId,
      String? returnDeliveryToWarehouse,
      String? returnDeliveryToWarehouseId,
      String? returnDeliveryToContact,
      String? returnDeliveryToContactPhone,
      String? returnDeliveryToAlternateContact,
      String? returnDeliveryToAlternateContactPhone,
      String? returnDeliveryToAttention,
      String? returnDeliveryToAddress1,
      String? returnDeliveryToAddress2,
      String? returnDeliveryToCity,
      String? returnDeliveryToState,
      String? returnDeliveryToZipCode,
      String? returnDeliveryToCountryId,
      String? returnDeliveryToCountry,
      String? returnDeliveryToContactFax,
      String? returnDeliveryToCrossStreets,
      String? returnDeliveryDeliveryNotes,
      String? returnDeliveryCarrierId,
      String? returnDeliveryCarrier,
      String? returnDeliveryCarrierAccount,
      String? returnDeliveryShipViaId,
      String? returnDeliveryShipVia,
      String? returnDeliveryInvoiceId,
      String? returnDeliveryVendorInvoiceId,
      double? returnDeliveryEstimatedFreight,
      double? returnDeliveryFreightInvoiceAmount,
      String? returnDeliveryChargeType,
      String? returnDeliveryFreightTrackingNumber,
      String? returnDeliveryFreightTrackingUrl,
      bool? returnDeliveryVendorRetrieve,
      String? returnDeliveryPackageCode,
      bool? returnDeliveryBillPoFreightOnOrder,
      String? returnDeliveryOnlineOrderNumber,
      String? returnDeliveryOnlineOrderStatus,
      String? returnDeliveryDateStamp,
      bool? enableProjects,
      String? projectId,
      String? projectNumber,
      String? project,
      String? projectDrawingsId,
      String? projectDrawings,
      String? projectItemsOrderedId,
      String? projectItemsOrdered,
      String? projectDropShipId,
      String? projectDropShip,
      String? projectAsBuildId,
      String? projectAsBuild,
      String? projectCommissioningId,
      String? projectCommissioning,
      String? projectDepositId,
      String? projectDeposit,
      String? location,
      String? currencyId,
      bool? updateAllRatesToNewCurrency,
      String? confirmUpdateAllRatesToNewCurrency,
      String? currencyCode,
      String? currency,
      String? currencySymbol,
      String? billingCycleId,
      String? billingCycle,
      String? remitToAttention1,
      String? remitToAttention2,
      String? remitToAddress1,
      String? remitToAddress2,
      String? remitToCity,
      String? remitToState,
      String? remitToCountryId,
      String? remitToCountry,
      String? remitToZipCode,
      String? remitToEmail,
      String? remitToPhone,
      String? paymentTypeId,
      String? paymentType,
      String? paymentTermsId,
      String? paymentTerms,
      int? paymentTermsDueInDays,
      String? taxOptionId,
      String? taxOption,
      String? taxId,
      String? tax1Name,
      String? tax2Name,
      double? rentalTaxRate1,
      double? salesTaxRate1,
      double? laborTaxRate1,
      double? rentalTaxRate2,
      double? salesTaxRate2,
      double? laborTaxRate2,
      bool? hasRentalItem,
      bool? hasSalesItem,
      bool? hasMiscellaneousItem,
      bool? hasLaborItem,
      bool? hasFacilitiesItem,
      bool? hasLossAndDamageItem,
      bool? hasRentalSaleItem,
      bool? hasPartsItem,
      double? rentalDiscountPercent,
      double? rentalTotal,
      bool? rentalTotalIncludesTax,
      double? salesDiscountPercent,
      double? salesTotal,
      bool? salesTotalIncludesTax,
      double? partsDiscountPercent,
      double? partsTotal,
      bool? partsTotalIncludesTax,
      double? vehicleDiscountPercent,
      double? vehicleTotal,
      bool? vehicleTotalIncludesTax,
      double? miscDiscountPercent,
      double? miscTotal,
      bool? miscTotalIncludesTax,
      double? laborDiscountPercent,
      double? laborTotal,
      bool? laborTotalIncludesTax,
      double? subRentalDaysPerWeek,
      double? subRentalDiscountPercent,
      double? weeklySubRentalTotal,
      double? monthlySubRentalTotal,
      double? periodSubRentalTotal,
      bool? weeklySubRentalTotalIncludesTax,
      bool? monthlySubRentalTotalIncludesTax,
      bool? periodSubRentalTotalIncludesTax,
      double? subSalesDiscountPercent,
      double? subSalesTotal,
      bool? subSalesTotalIncludesTax,
      double? subVehicleDaysPerWeek,
      double? subvehicleDiscountPercent,
      double? weeklySubVehicleTotal,
      double? monthlySubVehicleTotal,
      double? periodSubVehicleTotal,
      bool? weeklySubVehicleTotalIncludesTax,
      bool? monthlySubVehicleTotalIncludesTax,
      bool? periodSubVehicleTotalIncludesTax,
      double? subMiscDiscountPercent,
      double? weeklySubMiscTotal,
      double? monthlySubMiscTotal,
      double? periodSubMiscTotal,
      bool? weeklySubMiscTotalIncludesTax,
      bool? monthlySubMiscTotalIncludesTax,
      bool? periodSubMiscTotalIncludesTax,
      double? subLaborDiscountPercent,
      double? weeklySubLaborTotal,
      double? monthlySubLaborTotal,
      double? periodSubLaborTotal,
      bool? weeklySubLaborTotalIncludesTax,
      bool? monthlySubLaborTotalIncludesTax,
      bool? periodSubLaborTotalIncludesTax,
      bool? miscellaneousIsComplete,
      bool? subMiscellaneousIsComplete,
      bool? laborIsComplete,
      bool? subLaborIsComplete,
      String? currencyColor,
      String? statusColor,
      String? purchaseOrderNumberColor,
      String? vendorColor,
      String? descriptionColor,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAgentPurchaseOrderPurchaseOrder(
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        purchaseOrderNumber: purchaseOrderNumber ?? this.purchaseOrderNumber,
        description: description ?? this.description,
        purchaseOrderDate: purchaseOrderDate ?? this.purchaseOrderDate,
        requisitionNumber: requisitionNumber ?? this.requisitionNumber,
        requisitionDate: requisitionDate ?? this.requisitionDate,
        vendorId: vendorId ?? this.vendorId,
        vendor: vendor ?? this.vendor,
        agentId: agentId ?? this.agentId,
        agent: agent ?? this.agent,
        status: status ?? this.status,
        statusDate: statusDate ?? this.statusDate,
        referenceNumber: referenceNumber ?? this.referenceNumber,
        needsApproval: needsApproval ?? this.needsApproval,
        approvedByUserId: approvedByUserId ?? this.approvedByUserId,
        departmentId: departmentId ?? this.departmentId,
        department: department ?? this.department,
        officeLocationId: officeLocationId ?? this.officeLocationId,
        officeLocation: officeLocation ?? this.officeLocation,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouse: warehouse ?? this.warehouse,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        quantityHolding: quantityHolding ?? this.quantityHolding,
        quantityToBarCode: quantityToBarCode ?? this.quantityToBarCode,
        rental: rental ?? this.rental,
        sales: sales ?? this.sales,
        parts: parts ?? this.parts,
        labor: labor ?? this.labor,
        miscellaneous: miscellaneous ?? this.miscellaneous,
        vehicle: vehicle ?? this.vehicle,
        subRent: subRent ?? this.subRent,
        subSale: subSale ?? this.subSale,
        subLabor: subLabor ?? this.subLabor,
        subMiscellaneous: subMiscellaneous ?? this.subMiscellaneous,
        subVehicle: subVehicle ?? this.subVehicle,
        repair: repair ?? this.repair,
        consignment: consignment ?? this.consignment,
        consignorAgreementId: consignorAgreementId ?? this.consignorAgreementId,
        consignorAgreementNumber:
            consignorAgreementNumber ?? this.consignorAgreementNumber,
        orderId: orderId ?? this.orderId,
        orderNumber: orderNumber ?? this.orderNumber,
        dealNumber: dealNumber ?? this.dealNumber,
        dealId: dealId ?? this.dealId,
        deal: deal ?? this.deal,
        rateType: rateType ?? this.rateType,
        departmentLocationRequiresApproval: departmentLocationRequiresApproval ??
            this.departmentLocationRequiresApproval,
        total: total ?? this.total,
        poTypeId: poTypeId ?? this.poTypeId,
        poType: poType ?? this.poType,
        poClassificationId: poClassificationId ?? this.poClassificationId,
        poClassification: poClassification ?? this.poClassification,
        activityDatesAndTimes:
            activityDatesAndTimes ?? this.activityDatesAndTimes,
        estimatedStartDate: estimatedStartDate ?? this.estimatedStartDate,
        estimatedStartTime: estimatedStartTime ?? this.estimatedStartTime,
        estimatedStopDate: estimatedStopDate ?? this.estimatedStopDate,
        estimatedStopTime: estimatedStopTime ?? this.estimatedStopTime,
        billingStartDate: billingStartDate ?? this.billingStartDate,
        billingEndDate: billingEndDate ?? this.billingEndDate,
        billingWeeks: billingWeeks ?? this.billingWeeks,
        billingMonths: billingMonths ?? this.billingMonths,
        invoicedAmount: invoicedAmount ?? this.invoicedAmount,
        projectManagerId: projectManagerId ?? this.projectManagerId,
        projectManager: projectManager ?? this.projectManager,
        receiveDeliveryId: receiveDeliveryId ?? this.receiveDeliveryId,
        receiveDeliveryDeliveryType:
            receiveDeliveryDeliveryType ?? this.receiveDeliveryDeliveryType,
        receiveDeliveryRequiredDate:
            receiveDeliveryRequiredDate ?? this.receiveDeliveryRequiredDate,
        receiveDeliveryRequiredTime:
            receiveDeliveryRequiredTime ?? this.receiveDeliveryRequiredTime,
        receiveDeliveryTargetShipDate:
            receiveDeliveryTargetShipDate ?? this.receiveDeliveryTargetShipDate,
        receiveDeliveryTargetShipTime:
            receiveDeliveryTargetShipTime ?? this.receiveDeliveryTargetShipTime,
        receiveDeliveryDirection:
            receiveDeliveryDirection ?? this.receiveDeliveryDirection,
        receiveDeliveryAddressType:
            receiveDeliveryAddressType ?? this.receiveDeliveryAddressType,
        receiveDeliveryFromLocation:
            receiveDeliveryFromLocation ?? this.receiveDeliveryFromLocation,
        receiveDeliveryFromContact:
            receiveDeliveryFromContact ?? this.receiveDeliveryFromContact,
        receiveDeliveryFromContactPhone: receiveDeliveryFromContactPhone ??
            this.receiveDeliveryFromContactPhone,
        receiveDeliveryFromAlternateContact: receiveDeliveryFromAlternateContact ??
            this.receiveDeliveryFromAlternateContact,
        receiveDeliveryFromAlternateContactPhone:
            receiveDeliveryFromAlternateContactPhone ??
                this.receiveDeliveryFromAlternateContactPhone,
        receiveDeliveryFromAttention:
            receiveDeliveryFromAttention ?? this.receiveDeliveryFromAttention,
        receiveDeliveryFromAddress1:
            receiveDeliveryFromAddress1 ?? this.receiveDeliveryFromAddress1,
        receiveDeliveryFromAdd2ress:
            receiveDeliveryFromAdd2ress ?? this.receiveDeliveryFromAdd2ress,
        receiveDeliveryFromCity:
            receiveDeliveryFromCity ?? this.receiveDeliveryFromCity,
        receiveDeliveryFromState:
            receiveDeliveryFromState ?? this.receiveDeliveryFromState,
        receiveDeliveryFromZipCode:
            receiveDeliveryFromZipCode ?? this.receiveDeliveryFromZipCode,
        receiveDeliveryFromCountry:
            receiveDeliveryFromCountry ?? this.receiveDeliveryFromCountry,
        receiveDeliveryFromCountryId:
            receiveDeliveryFromCountryId ?? this.receiveDeliveryFromCountryId,
        receiveDeliveryFromCrossStreets: receiveDeliveryFromCrossStreets ??
            this.receiveDeliveryFromCrossStreets,
        receiveDeliveryToLocation:
            receiveDeliveryToLocation ?? this.receiveDeliveryToLocation,
        receiveDeliveryToVenue:
            receiveDeliveryToVenue ?? this.receiveDeliveryToVenue,
        receiveDeliveryToVenueId:
            receiveDeliveryToVenueId ?? this.receiveDeliveryToVenueId,
        receiveDeliveryToWarehouse:
            receiveDeliveryToWarehouse ?? this.receiveDeliveryToWarehouse,
        receiveDeliveryToWarehouseId:
            receiveDeliveryToWarehouseId ?? this.receiveDeliveryToWarehouseId,
        receiveDeliveryToContact:
            receiveDeliveryToContact ?? this.receiveDeliveryToContact,
        receiveDeliveryToContactPhone:
            receiveDeliveryToContactPhone ?? this.receiveDeliveryToContactPhone,
        receiveDeliveryToAlternateContact: receiveDeliveryToAlternateContact ??
            this.receiveDeliveryToAlternateContact,
        receiveDeliveryToAlternateContactPhone: receiveDeliveryToAlternateContactPhone ??
            this.receiveDeliveryToAlternateContactPhone,
        receiveDeliveryToAttention:
            receiveDeliveryToAttention ?? this.receiveDeliveryToAttention,
        receiveDeliveryToAddress1:
            receiveDeliveryToAddress1 ?? this.receiveDeliveryToAddress1,
        receiveDeliveryToAddress2: receiveDeliveryToAddress2 ?? this.receiveDeliveryToAddress2,
        receiveDeliveryToCity: receiveDeliveryToCity ?? this.receiveDeliveryToCity,
        receiveDeliveryToState: receiveDeliveryToState ?? this.receiveDeliveryToState,
        receiveDeliveryToZipCode: receiveDeliveryToZipCode ?? this.receiveDeliveryToZipCode,
        receiveDeliveryToCountryId: receiveDeliveryToCountryId ?? this.receiveDeliveryToCountryId,
        receiveDeliveryToCountry: receiveDeliveryToCountry ?? this.receiveDeliveryToCountry,
        receiveDeliveryToContactFax: receiveDeliveryToContactFax ?? this.receiveDeliveryToContactFax,
        receiveDeliveryToCrossStreets: receiveDeliveryToCrossStreets ?? this.receiveDeliveryToCrossStreets,
        receiveDeliveryDeliveryNotes: receiveDeliveryDeliveryNotes ?? this.receiveDeliveryDeliveryNotes,
        receiveDeliveryCarrierId: receiveDeliveryCarrierId ?? this.receiveDeliveryCarrierId,
        receiveDeliveryCarrier: receiveDeliveryCarrier ?? this.receiveDeliveryCarrier,
        receiveDeliveryCarrierAccount: receiveDeliveryCarrierAccount ?? this.receiveDeliveryCarrierAccount,
        receiveDeliveryShipViaId: receiveDeliveryShipViaId ?? this.receiveDeliveryShipViaId,
        receiveDeliveryShipVia: receiveDeliveryShipVia ?? this.receiveDeliveryShipVia,
        receiveDeliveryInvoiceId: receiveDeliveryInvoiceId ?? this.receiveDeliveryInvoiceId,
        receiveDeliveryVendorInvoiceId: receiveDeliveryVendorInvoiceId ?? this.receiveDeliveryVendorInvoiceId,
        receiveDeliveryEstimatedFreight: receiveDeliveryEstimatedFreight ?? this.receiveDeliveryEstimatedFreight,
        receiveDeliveryFreightInvoiceAmount: receiveDeliveryFreightInvoiceAmount ?? this.receiveDeliveryFreightInvoiceAmount,
        receiveDeliveryChargeType: receiveDeliveryChargeType ?? this.receiveDeliveryChargeType,
        receiveDeliveryFreightTrackingNumber: receiveDeliveryFreightTrackingNumber ?? this.receiveDeliveryFreightTrackingNumber,
        receiveDeliveryFreightTrackingUrl: receiveDeliveryFreightTrackingUrl ?? this.receiveDeliveryFreightTrackingUrl,
        receiveDeliveryDropShip: receiveDeliveryDropShip ?? this.receiveDeliveryDropShip,
        receiveDeliveryPackageCode: receiveDeliveryPackageCode ?? this.receiveDeliveryPackageCode,
        receiveDeliveryBillPoFreightOnOrder: receiveDeliveryBillPoFreightOnOrder ?? this.receiveDeliveryBillPoFreightOnOrder,
        receiveDeliveryOnlineOrderNumber: receiveDeliveryOnlineOrderNumber ?? this.receiveDeliveryOnlineOrderNumber,
        receiveDeliveryOnlineOrderStatus: receiveDeliveryOnlineOrderStatus ?? this.receiveDeliveryOnlineOrderStatus,
        receiveDeliveryDateStamp: receiveDeliveryDateStamp ?? this.receiveDeliveryDateStamp,
        returnDeliveryId: returnDeliveryId ?? this.returnDeliveryId,
        returnDeliveryDeliveryType: returnDeliveryDeliveryType ?? this.returnDeliveryDeliveryType,
        returnDeliveryRequiredDate: returnDeliveryRequiredDate ?? this.returnDeliveryRequiredDate,
        returnDeliveryRequiredTime: returnDeliveryRequiredTime ?? this.returnDeliveryRequiredTime,
        returnDeliveryTargetShipDate: returnDeliveryTargetShipDate ?? this.returnDeliveryTargetShipDate,
        returnDeliveryTargetShipTime: returnDeliveryTargetShipTime ?? this.returnDeliveryTargetShipTime,
        returnDeliveryDirection: returnDeliveryDirection ?? this.returnDeliveryDirection,
        returnDeliveryAddressType: returnDeliveryAddressType ?? this.returnDeliveryAddressType,
        returnDeliveryFromLocation: returnDeliveryFromLocation ?? this.returnDeliveryFromLocation,
        returnDeliveryFromContact: returnDeliveryFromContact ?? this.returnDeliveryFromContact,
        returnDeliveryFromContactPhone: returnDeliveryFromContactPhone ?? this.returnDeliveryFromContactPhone,
        returnDeliveryFromAlternateContact: returnDeliveryFromAlternateContact ?? this.returnDeliveryFromAlternateContact,
        returnDeliveryFromAlternateContactPhone: returnDeliveryFromAlternateContactPhone ?? this.returnDeliveryFromAlternateContactPhone,
        returnDeliveryFromAttention: returnDeliveryFromAttention ?? this.returnDeliveryFromAttention,
        returnDeliveryFromAddress1: returnDeliveryFromAddress1 ?? this.returnDeliveryFromAddress1,
        returnDeliveryFromAdd2ress: returnDeliveryFromAdd2ress ?? this.returnDeliveryFromAdd2ress,
        returnDeliveryFromCity: returnDeliveryFromCity ?? this.returnDeliveryFromCity,
        returnDeliveryFromState: returnDeliveryFromState ?? this.returnDeliveryFromState,
        returnDeliveryFromZipCode: returnDeliveryFromZipCode ?? this.returnDeliveryFromZipCode,
        returnDeliveryFromCountry: returnDeliveryFromCountry ?? this.returnDeliveryFromCountry,
        returnDeliveryFromCountryId: returnDeliveryFromCountryId ?? this.returnDeliveryFromCountryId,
        returnDeliveryFromCrossStreets: returnDeliveryFromCrossStreets ?? this.returnDeliveryFromCrossStreets,
        returnDeliveryToLocation: returnDeliveryToLocation ?? this.returnDeliveryToLocation,
        returnDeliveryToVenue: returnDeliveryToVenue ?? this.returnDeliveryToVenue,
        returnDeliveryToVenueId: returnDeliveryToVenueId ?? this.returnDeliveryToVenueId,
        returnDeliveryToWarehouse: returnDeliveryToWarehouse ?? this.returnDeliveryToWarehouse,
        returnDeliveryToWarehouseId: returnDeliveryToWarehouseId ?? this.returnDeliveryToWarehouseId,
        returnDeliveryToContact: returnDeliveryToContact ?? this.returnDeliveryToContact,
        returnDeliveryToContactPhone: returnDeliveryToContactPhone ?? this.returnDeliveryToContactPhone,
        returnDeliveryToAlternateContact: returnDeliveryToAlternateContact ?? this.returnDeliveryToAlternateContact,
        returnDeliveryToAlternateContactPhone: returnDeliveryToAlternateContactPhone ?? this.returnDeliveryToAlternateContactPhone,
        returnDeliveryToAttention: returnDeliveryToAttention ?? this.returnDeliveryToAttention,
        returnDeliveryToAddress1: returnDeliveryToAddress1 ?? this.returnDeliveryToAddress1,
        returnDeliveryToAddress2: returnDeliveryToAddress2 ?? this.returnDeliveryToAddress2,
        returnDeliveryToCity: returnDeliveryToCity ?? this.returnDeliveryToCity,
        returnDeliveryToState: returnDeliveryToState ?? this.returnDeliveryToState,
        returnDeliveryToZipCode: returnDeliveryToZipCode ?? this.returnDeliveryToZipCode,
        returnDeliveryToCountryId: returnDeliveryToCountryId ?? this.returnDeliveryToCountryId,
        returnDeliveryToCountry: returnDeliveryToCountry ?? this.returnDeliveryToCountry,
        returnDeliveryToContactFax: returnDeliveryToContactFax ?? this.returnDeliveryToContactFax,
        returnDeliveryToCrossStreets: returnDeliveryToCrossStreets ?? this.returnDeliveryToCrossStreets,
        returnDeliveryDeliveryNotes: returnDeliveryDeliveryNotes ?? this.returnDeliveryDeliveryNotes,
        returnDeliveryCarrierId: returnDeliveryCarrierId ?? this.returnDeliveryCarrierId,
        returnDeliveryCarrier: returnDeliveryCarrier ?? this.returnDeliveryCarrier,
        returnDeliveryCarrierAccount: returnDeliveryCarrierAccount ?? this.returnDeliveryCarrierAccount,
        returnDeliveryShipViaId: returnDeliveryShipViaId ?? this.returnDeliveryShipViaId,
        returnDeliveryShipVia: returnDeliveryShipVia ?? this.returnDeliveryShipVia,
        returnDeliveryInvoiceId: returnDeliveryInvoiceId ?? this.returnDeliveryInvoiceId,
        returnDeliveryVendorInvoiceId: returnDeliveryVendorInvoiceId ?? this.returnDeliveryVendorInvoiceId,
        returnDeliveryEstimatedFreight: returnDeliveryEstimatedFreight ?? this.returnDeliveryEstimatedFreight,
        returnDeliveryFreightInvoiceAmount: returnDeliveryFreightInvoiceAmount ?? this.returnDeliveryFreightInvoiceAmount,
        returnDeliveryChargeType: returnDeliveryChargeType ?? this.returnDeliveryChargeType,
        returnDeliveryFreightTrackingNumber: returnDeliveryFreightTrackingNumber ?? this.returnDeliveryFreightTrackingNumber,
        returnDeliveryFreightTrackingUrl: returnDeliveryFreightTrackingUrl ?? this.returnDeliveryFreightTrackingUrl,
        returnDeliveryVendorRetrieve: returnDeliveryVendorRetrieve ?? this.returnDeliveryVendorRetrieve,
        returnDeliveryPackageCode: returnDeliveryPackageCode ?? this.returnDeliveryPackageCode,
        returnDeliveryBillPoFreightOnOrder: returnDeliveryBillPoFreightOnOrder ?? this.returnDeliveryBillPoFreightOnOrder,
        returnDeliveryOnlineOrderNumber: returnDeliveryOnlineOrderNumber ?? this.returnDeliveryOnlineOrderNumber,
        returnDeliveryOnlineOrderStatus: returnDeliveryOnlineOrderStatus ?? this.returnDeliveryOnlineOrderStatus,
        returnDeliveryDateStamp: returnDeliveryDateStamp ?? this.returnDeliveryDateStamp,
        enableProjects: enableProjects ?? this.enableProjects,
        projectId: projectId ?? this.projectId,
        projectNumber: projectNumber ?? this.projectNumber,
        project: project ?? this.project,
        projectDrawingsId: projectDrawingsId ?? this.projectDrawingsId,
        projectDrawings: projectDrawings ?? this.projectDrawings,
        projectItemsOrderedId: projectItemsOrderedId ?? this.projectItemsOrderedId,
        projectItemsOrdered: projectItemsOrdered ?? this.projectItemsOrdered,
        projectDropShipId: projectDropShipId ?? this.projectDropShipId,
        projectDropShip: projectDropShip ?? this.projectDropShip,
        projectAsBuildId: projectAsBuildId ?? this.projectAsBuildId,
        projectAsBuild: projectAsBuild ?? this.projectAsBuild,
        projectCommissioningId: projectCommissioningId ?? this.projectCommissioningId,
        projectCommissioning: projectCommissioning ?? this.projectCommissioning,
        projectDepositId: projectDepositId ?? this.projectDepositId,
        projectDeposit: projectDeposit ?? this.projectDeposit,
        location: location ?? this.location,
        currencyId: currencyId ?? this.currencyId,
        updateAllRatesToNewCurrency: updateAllRatesToNewCurrency ?? this.updateAllRatesToNewCurrency,
        confirmUpdateAllRatesToNewCurrency: confirmUpdateAllRatesToNewCurrency ?? this.confirmUpdateAllRatesToNewCurrency,
        currencyCode: currencyCode ?? this.currencyCode,
        currency: currency ?? this.currency,
        currencySymbol: currencySymbol ?? this.currencySymbol,
        billingCycleId: billingCycleId ?? this.billingCycleId,
        billingCycle: billingCycle ?? this.billingCycle,
        remitToAttention1: remitToAttention1 ?? this.remitToAttention1,
        remitToAttention2: remitToAttention2 ?? this.remitToAttention2,
        remitToAddress1: remitToAddress1 ?? this.remitToAddress1,
        remitToAddress2: remitToAddress2 ?? this.remitToAddress2,
        remitToCity: remitToCity ?? this.remitToCity,
        remitToState: remitToState ?? this.remitToState,
        remitToCountryId: remitToCountryId ?? this.remitToCountryId,
        remitToCountry: remitToCountry ?? this.remitToCountry,
        remitToZipCode: remitToZipCode ?? this.remitToZipCode,
        remitToEmail: remitToEmail ?? this.remitToEmail,
        remitToPhone: remitToPhone ?? this.remitToPhone,
        paymentTypeId: paymentTypeId ?? this.paymentTypeId,
        paymentType: paymentType ?? this.paymentType,
        paymentTermsId: paymentTermsId ?? this.paymentTermsId,
        paymentTerms: paymentTerms ?? this.paymentTerms,
        paymentTermsDueInDays: paymentTermsDueInDays ?? this.paymentTermsDueInDays,
        taxOptionId: taxOptionId ?? this.taxOptionId,
        taxOption: taxOption ?? this.taxOption,
        taxId: taxId ?? this.taxId,
        tax1Name: tax1Name ?? this.tax1Name,
        tax2Name: tax2Name ?? this.tax2Name,
        rentalTaxRate1: rentalTaxRate1 ?? this.rentalTaxRate1,
        salesTaxRate1: salesTaxRate1 ?? this.salesTaxRate1,
        laborTaxRate1: laborTaxRate1 ?? this.laborTaxRate1,
        rentalTaxRate2: rentalTaxRate2 ?? this.rentalTaxRate2,
        salesTaxRate2: salesTaxRate2 ?? this.salesTaxRate2,
        laborTaxRate2: laborTaxRate2 ?? this.laborTaxRate2,
        hasRentalItem: hasRentalItem ?? this.hasRentalItem,
        hasSalesItem: hasSalesItem ?? this.hasSalesItem,
        hasMiscellaneousItem: hasMiscellaneousItem ?? this.hasMiscellaneousItem,
        hasLaborItem: hasLaborItem ?? this.hasLaborItem,
        hasFacilitiesItem: hasFacilitiesItem ?? this.hasFacilitiesItem,
        hasLossAndDamageItem: hasLossAndDamageItem ?? this.hasLossAndDamageItem,
        hasRentalSaleItem: hasRentalSaleItem ?? this.hasRentalSaleItem,
        hasPartsItem: hasPartsItem ?? this.hasPartsItem,
        rentalDiscountPercent: rentalDiscountPercent ?? this.rentalDiscountPercent,
        rentalTotal: rentalTotal ?? this.rentalTotal,
        rentalTotalIncludesTax: rentalTotalIncludesTax ?? this.rentalTotalIncludesTax,
        salesDiscountPercent: salesDiscountPercent ?? this.salesDiscountPercent,
        salesTotal: salesTotal ?? this.salesTotal,
        salesTotalIncludesTax: salesTotalIncludesTax ?? this.salesTotalIncludesTax,
        partsDiscountPercent: partsDiscountPercent ?? this.partsDiscountPercent,
        partsTotal: partsTotal ?? this.partsTotal,
        partsTotalIncludesTax: partsTotalIncludesTax ?? this.partsTotalIncludesTax,
        vehicleDiscountPercent: vehicleDiscountPercent ?? this.vehicleDiscountPercent,
        vehicleTotal: vehicleTotal ?? this.vehicleTotal,
        vehicleTotalIncludesTax: vehicleTotalIncludesTax ?? this.vehicleTotalIncludesTax,
        miscDiscountPercent: miscDiscountPercent ?? this.miscDiscountPercent,
        miscTotal: miscTotal ?? this.miscTotal,
        miscTotalIncludesTax: miscTotalIncludesTax ?? this.miscTotalIncludesTax,
        laborDiscountPercent: laborDiscountPercent ?? this.laborDiscountPercent,
        laborTotal: laborTotal ?? this.laborTotal,
        laborTotalIncludesTax: laborTotalIncludesTax ?? this.laborTotalIncludesTax,
        subRentalDaysPerWeek: subRentalDaysPerWeek ?? this.subRentalDaysPerWeek,
        subRentalDiscountPercent: subRentalDiscountPercent ?? this.subRentalDiscountPercent,
        weeklySubRentalTotal: weeklySubRentalTotal ?? this.weeklySubRentalTotal,
        monthlySubRentalTotal: monthlySubRentalTotal ?? this.monthlySubRentalTotal,
        periodSubRentalTotal: periodSubRentalTotal ?? this.periodSubRentalTotal,
        weeklySubRentalTotalIncludesTax: weeklySubRentalTotalIncludesTax ?? this.weeklySubRentalTotalIncludesTax,
        monthlySubRentalTotalIncludesTax: monthlySubRentalTotalIncludesTax ?? this.monthlySubRentalTotalIncludesTax,
        periodSubRentalTotalIncludesTax: periodSubRentalTotalIncludesTax ?? this.periodSubRentalTotalIncludesTax,
        subSalesDiscountPercent: subSalesDiscountPercent ?? this.subSalesDiscountPercent,
        subSalesTotal: subSalesTotal ?? this.subSalesTotal,
        subSalesTotalIncludesTax: subSalesTotalIncludesTax ?? this.subSalesTotalIncludesTax,
        subVehicleDaysPerWeek: subVehicleDaysPerWeek ?? this.subVehicleDaysPerWeek,
        subvehicleDiscountPercent: subvehicleDiscountPercent ?? this.subvehicleDiscountPercent,
        weeklySubVehicleTotal: weeklySubVehicleTotal ?? this.weeklySubVehicleTotal,
        monthlySubVehicleTotal: monthlySubVehicleTotal ?? this.monthlySubVehicleTotal,
        periodSubVehicleTotal: periodSubVehicleTotal ?? this.periodSubVehicleTotal,
        weeklySubVehicleTotalIncludesTax: weeklySubVehicleTotalIncludesTax ?? this.weeklySubVehicleTotalIncludesTax,
        monthlySubVehicleTotalIncludesTax: monthlySubVehicleTotalIncludesTax ?? this.monthlySubVehicleTotalIncludesTax,
        periodSubVehicleTotalIncludesTax: periodSubVehicleTotalIncludesTax ?? this.periodSubVehicleTotalIncludesTax,
        subMiscDiscountPercent: subMiscDiscountPercent ?? this.subMiscDiscountPercent,
        weeklySubMiscTotal: weeklySubMiscTotal ?? this.weeklySubMiscTotal,
        monthlySubMiscTotal: monthlySubMiscTotal ?? this.monthlySubMiscTotal,
        periodSubMiscTotal: periodSubMiscTotal ?? this.periodSubMiscTotal,
        weeklySubMiscTotalIncludesTax: weeklySubMiscTotalIncludesTax ?? this.weeklySubMiscTotalIncludesTax,
        monthlySubMiscTotalIncludesTax: monthlySubMiscTotalIncludesTax ?? this.monthlySubMiscTotalIncludesTax,
        periodSubMiscTotalIncludesTax: periodSubMiscTotalIncludesTax ?? this.periodSubMiscTotalIncludesTax,
        subLaborDiscountPercent: subLaborDiscountPercent ?? this.subLaborDiscountPercent,
        weeklySubLaborTotal: weeklySubLaborTotal ?? this.weeklySubLaborTotal,
        monthlySubLaborTotal: monthlySubLaborTotal ?? this.monthlySubLaborTotal,
        periodSubLaborTotal: periodSubLaborTotal ?? this.periodSubLaborTotal,
        weeklySubLaborTotalIncludesTax: weeklySubLaborTotalIncludesTax ?? this.weeklySubLaborTotalIncludesTax,
        monthlySubLaborTotalIncludesTax: monthlySubLaborTotalIncludesTax ?? this.monthlySubLaborTotalIncludesTax,
        periodSubLaborTotalIncludesTax: periodSubLaborTotalIncludesTax ?? this.periodSubLaborTotalIncludesTax,
        miscellaneousIsComplete: miscellaneousIsComplete ?? this.miscellaneousIsComplete,
        subMiscellaneousIsComplete: subMiscellaneousIsComplete ?? this.subMiscellaneousIsComplete,
        laborIsComplete: laborIsComplete ?? this.laborIsComplete,
        subLaborIsComplete: subLaborIsComplete ?? this.subLaborIsComplete,
        currencyColor: currencyColor ?? this.currencyColor,
        statusColor: statusColor ?? this.statusColor,
        purchaseOrderNumberColor: purchaseOrderNumberColor ?? this.purchaseOrderNumberColor,
        vendorColor: vendorColor ?? this.vendorColor,
        descriptionColor: descriptionColor ?? this.descriptionColor,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes: defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentPurchaseOrderPurchaseOrderDocument {
  WebApiModulesAgentPurchaseOrderPurchaseOrderDocument({
    this.purchaseOrderId,
    this.copying,
    this.documentId,
    this.documentTypeId,
    this.uniqueId1,
    this.uniqueId2,
    this.uniqueId1Int,
    this.description,
    this.inputByUsersId,
    this.attachDate,
    this.attachTime,
    this.attachToEmail,
    this.inactive,
    this.dateStamp,
    this.extension,
    this.documentType,
    this.inputBy,
    this.hasImage,
    this.hasFile,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAgentPurchaseOrderPurchaseOrderDocument.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentFromJson(json);

  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'copying')
  final bool? copying;
  @JsonKey(name: 'DocumentId')
  final String? documentId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'UniqueId1')
  final String? uniqueId1;
  @JsonKey(name: 'UniqueId2')
  final String? uniqueId2;
  @JsonKey(name: 'UniqueId1Int')
  final int? uniqueId1Int;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'InputByUsersId')
  final String? inputByUsersId;
  @JsonKey(name: 'AttachDate')
  final String? attachDate;
  @JsonKey(name: 'AttachTime')
  final String? attachTime;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'Extension')
  final String? extension;
  @JsonKey(name: 'DocumentType')
  final String? documentType;
  @JsonKey(name: 'InputBy')
  final String? inputBy;
  @JsonKey(name: 'HasImage')
  final bool? hasImage;
  @JsonKey(name: 'HasFile')
  final bool? hasFile;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentPurchaseOrderPurchaseOrderDocument &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.copying, copying) ||
                const DeepCollectionEquality()
                    .equals(other.copying, copying)) &&
            (identical(other.documentId, documentId) ||
                const DeepCollectionEquality()
                    .equals(other.documentId, documentId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.uniqueId1, uniqueId1) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1, uniqueId1)) &&
            (identical(other.uniqueId2, uniqueId2) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId2, uniqueId2)) &&
            (identical(other.uniqueId1Int, uniqueId1Int) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1Int, uniqueId1Int)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.inputByUsersId, inputByUsersId) ||
                const DeepCollectionEquality()
                    .equals(other.inputByUsersId, inputByUsersId)) &&
            (identical(other.attachDate, attachDate) ||
                const DeepCollectionEquality()
                    .equals(other.attachDate, attachDate)) &&
            (identical(other.attachTime, attachTime) ||
                const DeepCollectionEquality()
                    .equals(other.attachTime, attachTime)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.extension, extension) ||
                const DeepCollectionEquality()
                    .equals(other.extension, extension)) &&
            (identical(other.documentType, documentType) ||
                const DeepCollectionEquality()
                    .equals(other.documentType, documentType)) &&
            (identical(other.inputBy, inputBy) ||
                const DeepCollectionEquality()
                    .equals(other.inputBy, inputBy)) &&
            (identical(other.hasImage, hasImage) ||
                const DeepCollectionEquality()
                    .equals(other.hasImage, hasImage)) &&
            (identical(other.hasFile, hasFile) ||
                const DeepCollectionEquality()
                    .equals(other.hasFile, hasFile)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality().equals(other.filePath, filePath)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentExtension
    on WebApiModulesAgentPurchaseOrderPurchaseOrderDocument {
  WebApiModulesAgentPurchaseOrderPurchaseOrderDocument copyWith(
      {String? purchaseOrderId,
      bool? copying,
      String? documentId,
      String? documentTypeId,
      String? uniqueId1,
      String? uniqueId2,
      int? uniqueId1Int,
      String? description,
      String? inputByUsersId,
      String? attachDate,
      String? attachTime,
      bool? attachToEmail,
      bool? inactive,
      String? dateStamp,
      String? extension,
      String? documentType,
      String? inputBy,
      bool? hasImage,
      bool? hasFile,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAgentPurchaseOrderPurchaseOrderDocument(
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        copying: copying ?? this.copying,
        documentId: documentId ?? this.documentId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        uniqueId1: uniqueId1 ?? this.uniqueId1,
        uniqueId2: uniqueId2 ?? this.uniqueId2,
        uniqueId1Int: uniqueId1Int ?? this.uniqueId1Int,
        description: description ?? this.description,
        inputByUsersId: inputByUsersId ?? this.inputByUsersId,
        attachDate: attachDate ?? this.attachDate,
        attachTime: attachTime ?? this.attachTime,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        dateStamp: dateStamp ?? this.dateStamp,
        extension: extension ?? this.extension,
        documentType: documentType ?? this.documentType,
        inputBy: inputBy ?? this.inputBy,
        hasImage: hasImage ?? this.hasImage,
        hasFile: hasFile ?? this.hasFile,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPostRequest {
  WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPostRequest({
    this.purchaseOrderId,
    this.documentTypeId,
    this.description,
    this.attachToEmail,
    this.inactive,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
  });

  factory WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPostRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPostRequestFromJson(
          json);

  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  static const fromJsonFactory =
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPostRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPostRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPostRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPostRequest &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)));
  }
}

extension $WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPostRequestExtension
    on WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPostRequest {
  WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPostRequest copyWith(
      {String? purchaseOrderId,
      String? documentTypeId,
      String? description,
      bool? attachToEmail,
      bool? inactive,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath}) {
    return WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPostRequest(
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        description: description ?? this.description,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPutRequest {
  WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPutRequest({
    this.purchaseOrderId,
    this.documentId,
    this.documentTypeId,
    this.description,
    this.attachToEmail,
    this.inactive,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
  });

  factory WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPutRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPutRequestFromJson(
          json);

  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'DocumentId')
  final String? documentId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  static const fromJsonFactory =
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPutRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPutRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPutRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPutRequest &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.documentId, documentId) ||
                const DeepCollectionEquality()
                    .equals(other.documentId, documentId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)));
  }
}

extension $WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPutRequestExtension
    on WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPutRequest {
  WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPutRequest copyWith(
      {String? purchaseOrderId,
      String? documentId,
      String? documentTypeId,
      String? description,
      bool? attachToEmail,
      bool? inactive,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath}) {
    return WebApiModulesAgentPurchaseOrderPurchaseOrderDocumentPutRequest(
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        documentId: documentId ?? this.documentId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        description: description ?? this.description,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesRequest {
  WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesRequest({
    this.purchaseOrderId,
    this.contractId,
    this.warehouseId,
  });

  factory WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesRequestFromJson(
          json);

  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'ContractId')
  final String? contractId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  static const fromJsonFactory =
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesRequest &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)));
  }
}

extension $WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesRequestExtension
    on WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesRequest {
  WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesRequest
      copyWith(
          {String? purchaseOrderId, String? contractId, String? warehouseId}) {
    return WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesRequest(
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        contractId: contractId ?? this.contractId,
        warehouseId: warehouseId ?? this.warehouseId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesResponse {
  WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesResponseExtension
    on WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesResponse {
  WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesResponse
      copyWith({int? status, bool? success, String? msg}) {
    return WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveAssignBarCodesResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsRequest {
  WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsRequest({
    this.purchaseOrderId,
    this.contractId,
    this.warehouseId,
  });

  factory WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsRequestFromJson(
          json);

  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'ContractId')
  final String? contractId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  static const fromJsonFactory =
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsRequest &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)));
  }
}

extension $WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsRequestExtension
    on WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsRequest {
  WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsRequest
      copyWith(
          {String? purchaseOrderId, String? contractId, String? warehouseId}) {
    return WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsRequest(
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        contractId: contractId ?? this.contractId,
        warehouseId: warehouseId ?? this.warehouseId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsResponse {
  WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsResponse({
    this.itemsAdded,
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsResponseFromJson(
          json);

  @JsonKey(name: 'ItemsAdded')
  final int? itemsAdded;
  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsResponse &&
            (identical(other.itemsAdded, itemsAdded) ||
                const DeepCollectionEquality()
                    .equals(other.itemsAdded, itemsAdded)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsResponseExtension
    on WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsResponse {
  WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsResponse
      copyWith({int? itemsAdded, int? status, bool? success, String? msg}) {
    return WebApiModulesAgentPurchaseOrderPurchaseOrderReceiveBarCodeAddItemsResponse(
        itemsAdded: itemsAdded ?? this.itemsAdded,
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentPurchaseOrderReceiveContractRequest {
  WebApiModulesAgentPurchaseOrderReceiveContractRequest({
    this.purchaseOrderId,
    this.warehouseId,
  });

  factory WebApiModulesAgentPurchaseOrderReceiveContractRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentPurchaseOrderReceiveContractRequestFromJson(json);

  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  static const fromJsonFactory =
      _$WebApiModulesAgentPurchaseOrderReceiveContractRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentPurchaseOrderReceiveContractRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentPurchaseOrderReceiveContractRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentPurchaseOrderReceiveContractRequest &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)));
  }
}

extension $WebApiModulesAgentPurchaseOrderReceiveContractRequestExtension
    on WebApiModulesAgentPurchaseOrderReceiveContractRequest {
  WebApiModulesAgentPurchaseOrderReceiveContractRequest copyWith(
      {String? purchaseOrderId, String? warehouseId}) {
    return WebApiModulesAgentPurchaseOrderReceiveContractRequest(
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        warehouseId: warehouseId ?? this.warehouseId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentPurchaseOrderReceiveContractResponse {
  WebApiModulesAgentPurchaseOrderReceiveContractResponse({
    this.contractId,
  });

  factory WebApiModulesAgentPurchaseOrderReceiveContractResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentPurchaseOrderReceiveContractResponseFromJson(json);

  @JsonKey(name: 'ContractId')
  final String? contractId;
  static const fromJsonFactory =
      _$WebApiModulesAgentPurchaseOrderReceiveContractResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentPurchaseOrderReceiveContractResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentPurchaseOrderReceiveContractResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentPurchaseOrderReceiveContractResponse &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)));
  }
}

extension $WebApiModulesAgentPurchaseOrderReceiveContractResponseExtension
    on WebApiModulesAgentPurchaseOrderReceiveContractResponse {
  WebApiModulesAgentPurchaseOrderReceiveContractResponse copyWith(
      {String? contractId}) {
    return WebApiModulesAgentPurchaseOrderReceiveContractResponse(
        contractId: contractId ?? this.contractId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentPurchaseOrderReceiveItemRequest {
  WebApiModulesAgentPurchaseOrderReceiveItemRequest({
    this.contractId,
    this.purchaseOrderId,
    this.purchaseOrderItemId,
    this.quantity,
  });

  factory WebApiModulesAgentPurchaseOrderReceiveItemRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentPurchaseOrderReceiveItemRequestFromJson(json);

  @JsonKey(name: 'ContractId')
  final String? contractId;
  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'PurchaseOrderItemId')
  final String? purchaseOrderItemId;
  @JsonKey(name: 'Quantity')
  final int? quantity;
  static const fromJsonFactory =
      _$WebApiModulesAgentPurchaseOrderReceiveItemRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentPurchaseOrderReceiveItemRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentPurchaseOrderReceiveItemRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentPurchaseOrderReceiveItemRequest &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)) &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.purchaseOrderItemId, purchaseOrderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderItemId, purchaseOrderItemId)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)));
  }
}

extension $WebApiModulesAgentPurchaseOrderReceiveItemRequestExtension
    on WebApiModulesAgentPurchaseOrderReceiveItemRequest {
  WebApiModulesAgentPurchaseOrderReceiveItemRequest copyWith(
      {String? contractId,
      String? purchaseOrderId,
      String? purchaseOrderItemId,
      int? quantity}) {
    return WebApiModulesAgentPurchaseOrderReceiveItemRequest(
        contractId: contractId ?? this.contractId,
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        purchaseOrderItemId: purchaseOrderItemId ?? this.purchaseOrderItemId,
        quantity: quantity ?? this.quantity);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentPurchaseOrderReceiveItemResponse {
  WebApiModulesAgentPurchaseOrderReceiveItemResponse({
    this.contractId,
    this.purchaseOrderId,
    this.purchaseOrderItemId,
    this.quantity,
    this.quantityOrdered,
    this.quantityReceived,
    this.quantityNeedBarCode,
    this.quantityColor,
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesAgentPurchaseOrderReceiveItemResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentPurchaseOrderReceiveItemResponseFromJson(json);

  @JsonKey(name: 'ContractId')
  final String? contractId;
  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'PurchaseOrderItemId')
  final String? purchaseOrderItemId;
  @JsonKey(name: 'Quantity')
  final int? quantity;
  @JsonKey(name: 'QuantityOrdered')
  final double? quantityOrdered;
  @JsonKey(name: 'QuantityReceived')
  final double? quantityReceived;
  @JsonKey(name: 'QuantityNeedBarCode')
  final double? quantityNeedBarCode;
  @JsonKey(name: 'QuantityColor')
  final String? quantityColor;
  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesAgentPurchaseOrderReceiveItemResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentPurchaseOrderReceiveItemResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentPurchaseOrderReceiveItemResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentPurchaseOrderReceiveItemResponse &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)) &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.purchaseOrderItemId, purchaseOrderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderItemId, purchaseOrderItemId)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)) &&
            (identical(other.quantityOrdered, quantityOrdered) ||
                const DeepCollectionEquality()
                    .equals(other.quantityOrdered, quantityOrdered)) &&
            (identical(other.quantityReceived, quantityReceived) ||
                const DeepCollectionEquality()
                    .equals(other.quantityReceived, quantityReceived)) &&
            (identical(other.quantityNeedBarCode, quantityNeedBarCode) ||
                const DeepCollectionEquality()
                    .equals(other.quantityNeedBarCode, quantityNeedBarCode)) &&
            (identical(other.quantityColor, quantityColor) ||
                const DeepCollectionEquality()
                    .equals(other.quantityColor, quantityColor)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesAgentPurchaseOrderReceiveItemResponseExtension
    on WebApiModulesAgentPurchaseOrderReceiveItemResponse {
  WebApiModulesAgentPurchaseOrderReceiveItemResponse copyWith(
      {String? contractId,
      String? purchaseOrderId,
      String? purchaseOrderItemId,
      int? quantity,
      double? quantityOrdered,
      double? quantityReceived,
      double? quantityNeedBarCode,
      String? quantityColor,
      int? status,
      bool? success,
      String? msg}) {
    return WebApiModulesAgentPurchaseOrderReceiveItemResponse(
        contractId: contractId ?? this.contractId,
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        purchaseOrderItemId: purchaseOrderItemId ?? this.purchaseOrderItemId,
        quantity: quantity ?? this.quantity,
        quantityOrdered: quantityOrdered ?? this.quantityOrdered,
        quantityReceived: quantityReceived ?? this.quantityReceived,
        quantityNeedBarCode: quantityNeedBarCode ?? this.quantityNeedBarCode,
        quantityColor: quantityColor ?? this.quantityColor,
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentPurchaseOrderReturnContractRequest {
  WebApiModulesAgentPurchaseOrderReturnContractRequest({
    this.purchaseOrderId,
    this.warehouseId,
  });

  factory WebApiModulesAgentPurchaseOrderReturnContractRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentPurchaseOrderReturnContractRequestFromJson(json);

  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  static const fromJsonFactory =
      _$WebApiModulesAgentPurchaseOrderReturnContractRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentPurchaseOrderReturnContractRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentPurchaseOrderReturnContractRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentPurchaseOrderReturnContractRequest &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)));
  }
}

extension $WebApiModulesAgentPurchaseOrderReturnContractRequestExtension
    on WebApiModulesAgentPurchaseOrderReturnContractRequest {
  WebApiModulesAgentPurchaseOrderReturnContractRequest copyWith(
      {String? purchaseOrderId, String? warehouseId}) {
    return WebApiModulesAgentPurchaseOrderReturnContractRequest(
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        warehouseId: warehouseId ?? this.warehouseId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentPurchaseOrderReturnContractResponse {
  WebApiModulesAgentPurchaseOrderReturnContractResponse({
    this.contractId,
  });

  factory WebApiModulesAgentPurchaseOrderReturnContractResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentPurchaseOrderReturnContractResponseFromJson(json);

  @JsonKey(name: 'ContractId')
  final String? contractId;
  static const fromJsonFactory =
      _$WebApiModulesAgentPurchaseOrderReturnContractResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentPurchaseOrderReturnContractResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentPurchaseOrderReturnContractResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentPurchaseOrderReturnContractResponse &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)));
  }
}

extension $WebApiModulesAgentPurchaseOrderReturnContractResponseExtension
    on WebApiModulesAgentPurchaseOrderReturnContractResponse {
  WebApiModulesAgentPurchaseOrderReturnContractResponse copyWith(
      {String? contractId}) {
    return WebApiModulesAgentPurchaseOrderReturnContractResponse(
        contractId: contractId ?? this.contractId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentPurchaseOrderReturnItemRequest {
  WebApiModulesAgentPurchaseOrderReturnItemRequest({
    this.contractId,
    this.purchaseOrderId,
    this.purchaseOrderItemId,
    this.quantity,
    this.barCode,
  });

  factory WebApiModulesAgentPurchaseOrderReturnItemRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentPurchaseOrderReturnItemRequestFromJson(json);

  @JsonKey(name: 'ContractId')
  final String? contractId;
  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'PurchaseOrderItemId')
  final String? purchaseOrderItemId;
  @JsonKey(name: 'Quantity')
  final int? quantity;
  @JsonKey(name: 'BarCode')
  final String? barCode;
  static const fromJsonFactory =
      _$WebApiModulesAgentPurchaseOrderReturnItemRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentPurchaseOrderReturnItemRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentPurchaseOrderReturnItemRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentPurchaseOrderReturnItemRequest &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)) &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.purchaseOrderItemId, purchaseOrderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderItemId, purchaseOrderItemId)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)) &&
            (identical(other.barCode, barCode) ||
                const DeepCollectionEquality().equals(other.barCode, barCode)));
  }
}

extension $WebApiModulesAgentPurchaseOrderReturnItemRequestExtension
    on WebApiModulesAgentPurchaseOrderReturnItemRequest {
  WebApiModulesAgentPurchaseOrderReturnItemRequest copyWith(
      {String? contractId,
      String? purchaseOrderId,
      String? purchaseOrderItemId,
      int? quantity,
      String? barCode}) {
    return WebApiModulesAgentPurchaseOrderReturnItemRequest(
        contractId: contractId ?? this.contractId,
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        purchaseOrderItemId: purchaseOrderItemId ?? this.purchaseOrderItemId,
        quantity: quantity ?? this.quantity,
        barCode: barCode ?? this.barCode);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentPurchaseOrderReturnItemResponse {
  WebApiModulesAgentPurchaseOrderReturnItemResponse({
    this.contractId,
    this.purchaseOrderId,
    this.purchaseOrderItemId,
    this.quantity,
    this.quantityOrdered,
    this.quantityReceived,
    this.quantityReturned,
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesAgentPurchaseOrderReturnItemResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentPurchaseOrderReturnItemResponseFromJson(json);

  @JsonKey(name: 'ContractId')
  final String? contractId;
  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'PurchaseOrderItemId')
  final String? purchaseOrderItemId;
  @JsonKey(name: 'Quantity')
  final int? quantity;
  @JsonKey(name: 'QuantityOrdered')
  final double? quantityOrdered;
  @JsonKey(name: 'QuantityReceived')
  final double? quantityReceived;
  @JsonKey(name: 'QuantityReturned')
  final double? quantityReturned;
  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesAgentPurchaseOrderReturnItemResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentPurchaseOrderReturnItemResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentPurchaseOrderReturnItemResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentPurchaseOrderReturnItemResponse &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)) &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.purchaseOrderItemId, purchaseOrderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderItemId, purchaseOrderItemId)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)) &&
            (identical(other.quantityOrdered, quantityOrdered) ||
                const DeepCollectionEquality()
                    .equals(other.quantityOrdered, quantityOrdered)) &&
            (identical(other.quantityReceived, quantityReceived) ||
                const DeepCollectionEquality()
                    .equals(other.quantityReceived, quantityReceived)) &&
            (identical(other.quantityReturned, quantityReturned) ||
                const DeepCollectionEquality()
                    .equals(other.quantityReturned, quantityReturned)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesAgentPurchaseOrderReturnItemResponseExtension
    on WebApiModulesAgentPurchaseOrderReturnItemResponse {
  WebApiModulesAgentPurchaseOrderReturnItemResponse copyWith(
      {String? contractId,
      String? purchaseOrderId,
      String? purchaseOrderItemId,
      int? quantity,
      double? quantityOrdered,
      double? quantityReceived,
      double? quantityReturned,
      int? status,
      bool? success,
      String? msg}) {
    return WebApiModulesAgentPurchaseOrderReturnItemResponse(
        contractId: contractId ?? this.contractId,
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        purchaseOrderItemId: purchaseOrderItemId ?? this.purchaseOrderItemId,
        quantity: quantity ?? this.quantity,
        quantityOrdered: quantityOrdered ?? this.quantityOrdered,
        quantityReceived: quantityReceived ?? this.quantityReceived,
        quantityReturned: quantityReturned ?? this.quantityReturned,
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemRequest {
  WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemRequest({
    this.contractId,
    this.purchaseOrderId,
    this.warehouseId,
  });

  factory WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemRequestFromJson(
          json);

  @JsonKey(name: 'ContractId')
  final String? contractId;
  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  static const fromJsonFactory =
      _$WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemRequest &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)) &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)));
  }
}

extension $WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemRequestExtension
    on WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemRequest {
  WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemRequest copyWith(
      {String? contractId, String? purchaseOrderId, String? warehouseId}) {
    return WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemRequest(
        contractId: contractId ?? this.contractId,
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        warehouseId: warehouseId ?? this.warehouseId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemResponse {
  WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemResponseExtension
    on WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemResponse {
  WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemResponse copyWith(
      {int? status, bool? success, String? msg}) {
    return WebApiModulesAgentPurchaseOrderSelectAllNoneReceiveItemResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemRequest {
  WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemRequest({
    this.contractId,
    this.purchaseOrderId,
    this.warehouseId,
  });

  factory WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemRequestFromJson(
          json);

  @JsonKey(name: 'ContractId')
  final String? contractId;
  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  static const fromJsonFactory =
      _$WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemRequest &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)) &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)));
  }
}

extension $WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemRequestExtension
    on WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemRequest {
  WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemRequest copyWith(
      {String? contractId, String? purchaseOrderId, String? warehouseId}) {
    return WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemRequest(
        contractId: contractId ?? this.contractId,
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        warehouseId: warehouseId ?? this.warehouseId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemResponse {
  WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemResponseExtension
    on WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemResponse {
  WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemResponse copyWith(
      {int? status, bool? success, String? msg}) {
    return WebApiModulesAgentPurchaseOrderSelectAllNoneReturnItemResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentQuoteQuote {
  WebApiModulesAgentQuoteQuote({
    this.quoteId,
    this.quoteNumber,
    this.quoteDate,
    this.versionNumber,
    this.convertedToOrderId,
    this.convertedToOrderNumber,
    this.description,
    this.officeLocationId,
    this.officeLocation,
    this.warehouseId,
    this.warehouse,
    this.warehouseCode,
    this.departmentId,
    this.department,
    this.customerId,
    this.customer,
    this.customerNumber,
    this.dealId,
    this.deal,
    this.dealNumber,
    this.rateType,
    this.rateTypeDisplay,
    this.agentId,
    this.agent,
    this.projectManagerId,
    this.projectManager,
    this.rental,
    this.sales,
    this.miscellaneous,
    this.labor,
    this.facilities,
    this.transportation,
    this.rentalSale,
    this.lossAndDamage,
    this.repair,
    this.hasRentalItem,
    this.hasSalesItem,
    this.hasMiscellaneousItem,
    this.hasLaborItem,
    this.hasFacilitiesItem,
    this.hasLossAndDamageItem,
    this.hasRentalSaleItem,
    this.hasRepair,
    this.activityDatesAndTimes,
    this.pickDate,
    this.pickTime,
    this.estimatedStartDate,
    this.estimatedStartTime,
    this.estimatedStopDate,
    this.estimatedStopTime,
    this.pickUpDate,
    this.pickUpTime,
    this.prepDate,
    this.prepTime,
    this.loadInDate,
    this.loadInTime,
    this.strikeDate,
    this.strikeTime,
    this.testDate,
    this.testTime,
    this.orderTypeId,
    this.orderType,
    this.orderTypeCombineActivityTabs,
    this.flatPo,
    this.pendingPo,
    this.poNumber,
    this.poAmount,
    this.location,
    this.orderLocationId,
    this.orderLocation,
    this.referenceNumber,
    this.total,
    this.status,
    this.statusDate,
    this.poApprovalStatusId,
    this.lockBillingDates,
    this.specifyBillingDatesByType,
    this.rentalBillingStartDate,
    this.rentalBillingEndDate,
    this.laborBillingStartDate,
    this.laborBillingEndDate,
    this.miscellaneousBillingStartDate,
    this.miscellaneousBillingEndDate,
    this.facilitiesBillingStartDate,
    this.facilitiesBillingEndDate,
    this.vehicleBillingStartDate,
    this.vehicleBillingEndDate,
    this.delayBillingSearchUntil,
    this.includePrepFeesInRentalRate,
    this.billingStartDate,
    this.billingEndDate,
    this.billingWeeks,
    this.billingMonths,
    this.determineQuantitiesToBillBasedOn,
    this.billingCycleId,
    this.billingCycle,
    this.billingCycleType,
    this.paymentTermsId,
    this.paymentTerms,
    this.paymentTypeId,
    this.paymentType,
    this.currencyId,
    this.updateAllRatesToNewCurrency,
    this.confirmUpdateAllRatesToNewCurrency,
    this.currencyCode,
    this.currency,
    this.currencySymbol,
    this.taxOptionId,
    this.taxOption,
    this.tax1Name,
    this.tax2Name,
    this.taxId,
    this.rentalTaxRate1,
    this.salesTaxRate1,
    this.laborTaxRate1,
    this.rentalTaxRate2,
    this.salesTaxRate2,
    this.laborTaxRate2,
    this.noCharge,
    this.noChargeReason,
    this.printIssuedToAddressFrom,
    this.issuedToName,
    this.issuedToAttention,
    this.issuedToAttention2,
    this.issuedToAddress1,
    this.issuedToAddress2,
    this.issuedToCity,
    this.issuedToState,
    this.issuedToZipCode,
    this.issuedToCountryId,
    this.issuedToCountry,
    this.billToAddressDifferentFromIssuedToAddress,
    this.billToAddressId,
    this.billToName,
    this.billToAttention,
    this.billToAttention2,
    this.billToAddress1,
    this.billToAddress2,
    this.billToCity,
    this.billToState,
    this.billToZipCode,
    this.billToCountryId,
    this.billToCountry,
    this.discountReasonId,
    this.discountReason,
    this.requireContactConfirmation,
    this.includeInBillingAnalysis,
    this.hiatusDiscountFrom,
    this.roundTripRentals,
    this.inGroup,
    this.groupNumber,
    this.groupColor,
    this.groupOrderBy,
    this.coverLetterId,
    this.coverLetter,
    this.termsConditionsId,
    this.termsConditions,
    this.outsideSalesRepresentativeId,
    this.outsideSalesRepresentative,
    this.marketTypeId,
    this.marketType,
    this.marketSegmentId,
    this.marketSegment,
    this.marketSegmentJobId,
    this.marketSegmentJob,
    this.outDeliveryId,
    this.outDeliveryDeliveryType,
    this.outDeliveryRequiredDate,
    this.outDeliveryRequiredTime,
    this.outDeliveryTargetShipDate,
    this.outDeliveryTargetShipTime,
    this.outDeliveryDirection,
    this.outDeliveryAddressType,
    this.outDeliveryFromLocation,
    this.outDeliveryFromContact,
    this.outDeliveryFromContactPhone,
    this.outDeliveryFromAlternateContact,
    this.outDeliveryFromAlternateContactPhone,
    this.outDeliveryFromAttention,
    this.outDeliveryFromAddress1,
    this.outDeliveryFromAdd2ress,
    this.outDeliveryFromCity,
    this.outDeliveryFromState,
    this.outDeliveryFromZipCode,
    this.outDeliveryFromCountry,
    this.outDeliveryFromCountryId,
    this.outDeliveryFromCrossStreets,
    this.outDeliveryToLocation,
    this.outDeliveryToContact,
    this.outDeliveryToContactPhone,
    this.outDeliveryToAlternateContact,
    this.outDeliveryToAlternateContactPhone,
    this.outDeliveryToAttention,
    this.outDeliveryToAddress1,
    this.outDeliveryToAddress2,
    this.outDeliveryToCity,
    this.outDeliveryToState,
    this.outDeliveryToZipCode,
    this.outDeliveryToCountryId,
    this.outDeliveryToCountry,
    this.outDeliveryToContactFax,
    this.outDeliveryToCrossStreets,
    this.outDeliveryDeliveryNotes,
    this.outDeliveryCarrierId,
    this.outDeliveryCarrier,
    this.outDeliveryCarrierAccount,
    this.outDeliveryShipViaId,
    this.outDeliveryShipVia,
    this.outDeliveryInvoiceId,
    this.outDeliveryVendorInvoiceId,
    this.outDeliveryEstimatedFreight,
    this.outDeliveryFreightInvoiceAmount,
    this.outDeliveryChargeType,
    this.outDeliveryFreightTrackingNumber,
    this.outDeliveryFreightTrackingUrl,
    this.outDeliveryPackageCode,
    this.outDeliveryBillPoFreightOnOrder,
    this.outDeliveryOnlineOrderNumber,
    this.outDeliveryToVenue,
    this.outDeliveryToVenueId,
    this.outDeliveryToWarehouse,
    this.outDeliveryToWarehouseId,
    this.outDeliveryDateStamp,
    this.inDeliveryId,
    this.inDeliveryDeliveryType,
    this.inDeliveryRequiredDate,
    this.inDeliveryRequiredTime,
    this.inDeliveryTargetShipDate,
    this.inDeliveryTargetShipTime,
    this.inDeliveryDirection,
    this.inDeliveryAddressType,
    this.inDeliveryFromLocation,
    this.inDeliveryFromContact,
    this.inDeliveryFromContactPhone,
    this.inDeliveryFromAlternateContact,
    this.inDeliveryFromAlternateContactPhone,
    this.inDeliveryFromAttention,
    this.inDeliveryFromAddress1,
    this.inDeliveryFromAdd2ress,
    this.inDeliveryFromCity,
    this.inDeliveryFromState,
    this.inDeliveryFromZipCode,
    this.inDeliveryFromCountry,
    this.inDeliveryFromCountryId,
    this.inDeliveryFromCrossStreets,
    this.inDeliveryToLocation,
    this.inDeliveryToContact,
    this.inDeliveryToContactPhone,
    this.inDeliveryToAlternateContact,
    this.inDeliveryToAlternateContactPhone,
    this.inDeliveryToAttention,
    this.inDeliveryToAddress1,
    this.inDeliveryToAddress2,
    this.inDeliveryToCity,
    this.inDeliveryToState,
    this.inDeliveryToZipCode,
    this.inDeliveryToCountryId,
    this.inDeliveryToCountry,
    this.inDeliveryToContactFax,
    this.inDeliveryToCrossStreets,
    this.inDeliveryDeliveryNotes,
    this.inDeliveryCarrierId,
    this.inDeliveryCarrier,
    this.inDeliveryCarrierAccount,
    this.inDeliveryShipViaId,
    this.inDeliveryShipVia,
    this.inDeliveryInvoiceId,
    this.inDeliveryVendorInvoiceId,
    this.inDeliveryEstimatedFreight,
    this.inDeliveryFreightInvoiceAmount,
    this.inDeliveryChargeType,
    this.inDeliveryFreightTrackingNumber,
    this.inDeliveryFreightTrackingUrl,
    this.inDeliveryPackageCode,
    this.inDeliveryBillPoFreightOnOrder,
    this.inDeliveryOnlineOrderNumber,
    this.inDeliveryOnlineOrderStatus,
    this.inDeliveryToVenue,
    this.inDeliveryToVenueId,
    this.inDeliveryToWarehouse,
    this.inDeliveryToWarehouseId,
    this.inDeliveryDateStamp,
    this.rentalDaysPerWeek,
    this.rentalDiscountPercent,
    this.weeklyRentalTotal,
    this.monthlyRentalTotal,
    this.periodRentalTotal,
    this.weeklyRentalTotalIncludesTax,
    this.monthlyRentalTotalIncludesTax,
    this.periodRentalTotalIncludesTax,
    this.billLockedTotal,
    this.salesDiscountPercent,
    this.salesTotal,
    this.salesTotalIncludesTax,
    this.partsDiscountPercent,
    this.partsTotal,
    this.partsTotalIncludesTax,
    this.spaceDaysPerWeek,
    this.spaceDiscountPercent,
    this.spaceSplitPercent,
    this.weeklySpaceTotal,
    this.monthlySpaceTotal,
    this.periodSpaceTotal,
    this.weeklySpaceTotalIncludesTax,
    this.monthlySpaceTotalIncludesTax,
    this.periodSpaceTotalIncludesTax,
    this.vehicleDaysPerWeek,
    this.vehicleDiscountPercent,
    this.weeklyVehicleTotal,
    this.monthlyVehicleTotal,
    this.periodVehicleTotal,
    this.weeklyVehicleTotalIncludesTax,
    this.monthlyVehicleTotalIncludesTax,
    this.periodVehicleTotalIncludesTax,
    this.miscDiscountPercent,
    this.weeklyMiscTotal,
    this.monthlyMiscTotal,
    this.periodMiscTotal,
    this.weeklyMiscTotalIncludesTax,
    this.monthlyMiscTotalIncludesTax,
    this.periodMiscTotalIncludesTax,
    this.laborDiscountPercent,
    this.weeklyLaborTotal,
    this.monthlyLaborTotal,
    this.periodLaborTotal,
    this.weeklyLaborTotalIncludesTax,
    this.monthlyLaborTotalIncludesTax,
    this.periodLaborTotalIncludesTax,
    this.rentalSaleDiscountPercent,
    this.rentalSaleTotal,
    this.rentalSaleTotalIncludesTax,
    this.lossAndDamageDiscountPercent,
    this.lossAndDamageTotal,
    this.lossAndDamageTotalIncludesTax,
    this.combinedDaysPerWeek,
    this.combinedDiscountPercent,
    this.weeklyCombinedTotal,
    this.monthlyCombinedTotal,
    this.periodCombinedTotal,
    this.weeklyCombinedTotalIncludesTax,
    this.monthlyCombinedTotalIncludesTax,
    this.periodCombinedTotalIncludesTax,
    this.disableEditingRentalRate,
    this.disableEditingSalesRate,
    this.disableEditingMiscellaneousRate,
    this.disableEditingLaborRate,
    this.disableEditingRentalSaleRate,
    this.disableEditingLossAndDamageRate,
    this.rentalExtendedTotal,
    this.salesExtendedTotal,
    this.laborExtendedTotal,
    this.miscellaneousExtendedTotal,
    this.rentalSaleExtendedTotal,
    this.lossAndDamageExtendedTotal,
    this.hasNotes,
    this.hasDocuments,
    this.hasEmailHistory,
    this.hasContacts,
    this.hasSubPurchaseOrders,
    this.hasPickLists,
    this.hasContracts,
    this.hasSuspendedContracts,
    this.hasMultiOrderContracts,
    this.hasInvoices,
    this.hasBillingWorksheets,
    this.hasMultiOrderInvoices,
    this.totalReplacementCost,
    this.presentationLayerId,
    this.presentationLayer,
    this.isManualSort,
    this.quoteOrderTitle,
    this.unassignedSubs,
    this.nonTaxable,
    this.enableProjects,
    this.projectId,
    this.projectNumber,
    this.project,
    this.projectDrawingsId,
    this.projectDrawings,
    this.projectItemsOrderedId,
    this.projectItemsOrdered,
    this.projectDropShipId,
    this.projectDropShip,
    this.projectAsBuildId,
    this.projectAsBuild,
    this.projectCommissioningId,
    this.projectCommissioning,
    this.projectDepositId,
    this.projectDeposit,
    this.inputByUserId,
    this.modifiedByUserId,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAgentQuoteQuote.fromJson(Map<String, dynamic> json) =>
      _$WebApiModulesAgentQuoteQuoteFromJson(json);

  @JsonKey(name: 'QuoteId')
  final String? quoteId;
  @JsonKey(name: 'QuoteNumber')
  final String? quoteNumber;
  @JsonKey(name: 'QuoteDate')
  final String? quoteDate;
  @JsonKey(name: 'VersionNumber')
  final int? versionNumber;
  @JsonKey(name: 'ConvertedToOrderId')
  final String? convertedToOrderId;
  @JsonKey(name: 'ConvertedToOrderNumber')
  final String? convertedToOrderNumber;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'OfficeLocationId')
  final String? officeLocationId;
  @JsonKey(name: 'OfficeLocation')
  final String? officeLocation;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'Department')
  final String? department;
  @JsonKey(name: 'CustomerId')
  final String? customerId;
  @JsonKey(name: 'Customer')
  final String? customer;
  @JsonKey(name: 'CustomerNumber')
  final String? customerNumber;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'Deal')
  final String? deal;
  @JsonKey(name: 'DealNumber')
  final String? dealNumber;
  @JsonKey(name: 'RateType')
  final String? rateType;
  @JsonKey(name: 'RateTypeDisplay')
  final String? rateTypeDisplay;
  @JsonKey(name: 'AgentId')
  final String? agentId;
  @JsonKey(name: 'Agent')
  final String? agent;
  @JsonKey(name: 'ProjectManagerId')
  final String? projectManagerId;
  @JsonKey(name: 'ProjectManager')
  final String? projectManager;
  @JsonKey(name: 'Rental')
  final bool? rental;
  @JsonKey(name: 'Sales')
  final bool? sales;
  @JsonKey(name: 'Miscellaneous')
  final bool? miscellaneous;
  @JsonKey(name: 'Labor')
  final bool? labor;
  @JsonKey(name: 'Facilities')
  final bool? facilities;
  @JsonKey(name: 'Transportation')
  final bool? transportation;
  @JsonKey(name: 'RentalSale')
  final bool? rentalSale;
  @JsonKey(name: 'LossAndDamage')
  final bool? lossAndDamage;
  @JsonKey(name: 'Repair')
  final bool? repair;
  @JsonKey(name: 'HasRentalItem')
  final bool? hasRentalItem;
  @JsonKey(name: 'HasSalesItem')
  final bool? hasSalesItem;
  @JsonKey(name: 'HasMiscellaneousItem')
  final bool? hasMiscellaneousItem;
  @JsonKey(name: 'HasLaborItem')
  final bool? hasLaborItem;
  @JsonKey(name: 'HasFacilitiesItem')
  final bool? hasFacilitiesItem;
  @JsonKey(name: 'HasLossAndDamageItem')
  final bool? hasLossAndDamageItem;
  @JsonKey(name: 'HasRentalSaleItem')
  final bool? hasRentalSaleItem;
  @JsonKey(name: 'HasRepair')
  final bool? hasRepair;
  @JsonKey(
      name: 'ActivityDatesAndTimes',
      defaultValue: <WebApiModulesHomeControlsOrderDatesOrderDates>[])
  final List<WebApiModulesHomeControlsOrderDatesOrderDates>?
      activityDatesAndTimes;
  @JsonKey(name: 'PickDate')
  final String? pickDate;
  @JsonKey(name: 'PickTime')
  final String? pickTime;
  @JsonKey(name: 'EstimatedStartDate')
  final String? estimatedStartDate;
  @JsonKey(name: 'EstimatedStartTime')
  final String? estimatedStartTime;
  @JsonKey(name: 'EstimatedStopDate')
  final String? estimatedStopDate;
  @JsonKey(name: 'EstimatedStopTime')
  final String? estimatedStopTime;
  @JsonKey(name: 'PickUpDate')
  final String? pickUpDate;
  @JsonKey(name: 'PickUpTime')
  final String? pickUpTime;
  @JsonKey(name: 'PrepDate')
  final String? prepDate;
  @JsonKey(name: 'PrepTime')
  final String? prepTime;
  @JsonKey(name: 'LoadInDate')
  final String? loadInDate;
  @JsonKey(name: 'LoadInTime')
  final String? loadInTime;
  @JsonKey(name: 'StrikeDate')
  final String? strikeDate;
  @JsonKey(name: 'StrikeTime')
  final String? strikeTime;
  @JsonKey(name: 'TestDate')
  final String? testDate;
  @JsonKey(name: 'TestTime')
  final String? testTime;
  @JsonKey(name: 'OrderTypeId')
  final String? orderTypeId;
  @JsonKey(name: 'OrderType')
  final String? orderType;
  @JsonKey(name: 'OrderTypeCombineActivityTabs')
  final bool? orderTypeCombineActivityTabs;
  @JsonKey(name: 'FlatPo')
  final bool? flatPo;
  @JsonKey(name: 'PendingPo')
  final bool? pendingPo;
  @JsonKey(name: 'PoNumber')
  final String? poNumber;
  @JsonKey(name: 'PoAmount')
  final double? poAmount;
  @JsonKey(name: 'Location')
  final String? location;
  @JsonKey(name: 'OrderLocationId')
  final String? orderLocationId;
  @JsonKey(name: 'OrderLocation')
  final String? orderLocation;
  @JsonKey(name: 'ReferenceNumber')
  final String? referenceNumber;
  @JsonKey(name: 'Total')
  final double? total;
  @JsonKey(name: 'Status')
  final String? status;
  @JsonKey(name: 'StatusDate')
  final String? statusDate;
  @JsonKey(name: 'PoApprovalStatusId')
  final String? poApprovalStatusId;
  @JsonKey(name: 'LockBillingDates')
  final bool? lockBillingDates;
  @JsonKey(name: 'SpecifyBillingDatesByType')
  final bool? specifyBillingDatesByType;
  @JsonKey(name: 'RentalBillingStartDate')
  final String? rentalBillingStartDate;
  @JsonKey(name: 'RentalBillingEndDate')
  final String? rentalBillingEndDate;
  @JsonKey(name: 'LaborBillingStartDate')
  final String? laborBillingStartDate;
  @JsonKey(name: 'LaborBillingEndDate')
  final String? laborBillingEndDate;
  @JsonKey(name: 'MiscellaneousBillingStartDate')
  final String? miscellaneousBillingStartDate;
  @JsonKey(name: 'MiscellaneousBillingEndDate')
  final String? miscellaneousBillingEndDate;
  @JsonKey(name: 'FacilitiesBillingStartDate')
  final String? facilitiesBillingStartDate;
  @JsonKey(name: 'FacilitiesBillingEndDate')
  final String? facilitiesBillingEndDate;
  @JsonKey(name: 'VehicleBillingStartDate')
  final String? vehicleBillingStartDate;
  @JsonKey(name: 'VehicleBillingEndDate')
  final String? vehicleBillingEndDate;
  @JsonKey(name: 'DelayBillingSearchUntil')
  final String? delayBillingSearchUntil;
  @JsonKey(name: 'IncludePrepFeesInRentalRate')
  final bool? includePrepFeesInRentalRate;
  @JsonKey(name: 'BillingStartDate')
  final String? billingStartDate;
  @JsonKey(name: 'BillingEndDate')
  final String? billingEndDate;
  @JsonKey(name: 'BillingWeeks')
  final double? billingWeeks;
  @JsonKey(name: 'BillingMonths')
  final double? billingMonths;
  @JsonKey(name: 'DetermineQuantitiesToBillBasedOn')
  final String? determineQuantitiesToBillBasedOn;
  @JsonKey(name: 'BillingCycleId')
  final String? billingCycleId;
  @JsonKey(name: 'BillingCycle')
  final String? billingCycle;
  @JsonKey(name: 'BillingCycleType')
  final String? billingCycleType;
  @JsonKey(name: 'PaymentTermsId')
  final String? paymentTermsId;
  @JsonKey(name: 'PaymentTerms')
  final String? paymentTerms;
  @JsonKey(name: 'PaymentTypeId')
  final String? paymentTypeId;
  @JsonKey(name: 'PaymentType')
  final String? paymentType;
  @JsonKey(name: 'CurrencyId')
  final String? currencyId;
  @JsonKey(name: 'UpdateAllRatesToNewCurrency')
  final bool? updateAllRatesToNewCurrency;
  @JsonKey(name: 'ConfirmUpdateAllRatesToNewCurrency')
  final String? confirmUpdateAllRatesToNewCurrency;
  @JsonKey(name: 'CurrencyCode')
  final String? currencyCode;
  @JsonKey(name: 'Currency')
  final String? currency;
  @JsonKey(name: 'CurrencySymbol')
  final String? currencySymbol;
  @JsonKey(name: 'TaxOptionId')
  final String? taxOptionId;
  @JsonKey(name: 'TaxOption')
  final String? taxOption;
  @JsonKey(name: 'Tax1Name')
  final String? tax1Name;
  @JsonKey(name: 'Tax2Name')
  final String? tax2Name;
  @JsonKey(name: 'TaxId')
  final String? taxId;
  @JsonKey(name: 'RentalTaxRate1')
  final double? rentalTaxRate1;
  @JsonKey(name: 'SalesTaxRate1')
  final double? salesTaxRate1;
  @JsonKey(name: 'LaborTaxRate1')
  final double? laborTaxRate1;
  @JsonKey(name: 'RentalTaxRate2')
  final double? rentalTaxRate2;
  @JsonKey(name: 'SalesTaxRate2')
  final double? salesTaxRate2;
  @JsonKey(name: 'LaborTaxRate2')
  final double? laborTaxRate2;
  @JsonKey(name: 'NoCharge')
  final bool? noCharge;
  @JsonKey(name: 'NoChargeReason')
  final String? noChargeReason;
  @JsonKey(name: 'PrintIssuedToAddressFrom')
  final String? printIssuedToAddressFrom;
  @JsonKey(name: 'IssuedToName')
  final String? issuedToName;
  @JsonKey(name: 'IssuedToAttention')
  final String? issuedToAttention;
  @JsonKey(name: 'IssuedToAttention2')
  final String? issuedToAttention2;
  @JsonKey(name: 'IssuedToAddress1')
  final String? issuedToAddress1;
  @JsonKey(name: 'IssuedToAddress2')
  final String? issuedToAddress2;
  @JsonKey(name: 'IssuedToCity')
  final String? issuedToCity;
  @JsonKey(name: 'IssuedToState')
  final String? issuedToState;
  @JsonKey(name: 'IssuedToZipCode')
  final String? issuedToZipCode;
  @JsonKey(name: 'IssuedToCountryId')
  final String? issuedToCountryId;
  @JsonKey(name: 'IssuedToCountry')
  final String? issuedToCountry;
  @JsonKey(name: 'BillToAddressDifferentFromIssuedToAddress')
  final bool? billToAddressDifferentFromIssuedToAddress;
  @JsonKey(name: 'BillToAddressId')
  final String? billToAddressId;
  @JsonKey(name: 'BillToName')
  final String? billToName;
  @JsonKey(name: 'BillToAttention')
  final String? billToAttention;
  @JsonKey(name: 'BillToAttention2')
  final String? billToAttention2;
  @JsonKey(name: 'BillToAddress1')
  final String? billToAddress1;
  @JsonKey(name: 'BillToAddress2')
  final String? billToAddress2;
  @JsonKey(name: 'BillToCity')
  final String? billToCity;
  @JsonKey(name: 'BillToState')
  final String? billToState;
  @JsonKey(name: 'BillToZipCode')
  final String? billToZipCode;
  @JsonKey(name: 'BillToCountryId')
  final String? billToCountryId;
  @JsonKey(name: 'BillToCountry')
  final String? billToCountry;
  @JsonKey(name: 'DiscountReasonId')
  final String? discountReasonId;
  @JsonKey(name: 'DiscountReason')
  final String? discountReason;
  @JsonKey(name: 'RequireContactConfirmation')
  final bool? requireContactConfirmation;
  @JsonKey(name: 'IncludeInBillingAnalysis')
  final bool? includeInBillingAnalysis;
  @JsonKey(name: 'HiatusDiscountFrom')
  final String? hiatusDiscountFrom;
  @JsonKey(name: 'RoundTripRentals')
  final bool? roundTripRentals;
  @JsonKey(name: 'InGroup')
  final bool? inGroup;
  @JsonKey(name: 'GroupNumber')
  final int? groupNumber;
  @JsonKey(name: 'GroupColor')
  final int? groupColor;
  @JsonKey(name: 'GroupOrderBy')
  final double? groupOrderBy;
  @JsonKey(name: 'CoverLetterId')
  final String? coverLetterId;
  @JsonKey(name: 'CoverLetter')
  final String? coverLetter;
  @JsonKey(name: 'TermsConditionsId')
  final String? termsConditionsId;
  @JsonKey(name: 'TermsConditions')
  final String? termsConditions;
  @JsonKey(name: 'OutsideSalesRepresentativeId')
  final String? outsideSalesRepresentativeId;
  @JsonKey(name: 'OutsideSalesRepresentative')
  final String? outsideSalesRepresentative;
  @JsonKey(name: 'MarketTypeId')
  final String? marketTypeId;
  @JsonKey(name: 'MarketType')
  final String? marketType;
  @JsonKey(name: 'MarketSegmentId')
  final String? marketSegmentId;
  @JsonKey(name: 'MarketSegment')
  final String? marketSegment;
  @JsonKey(name: 'MarketSegmentJobId')
  final String? marketSegmentJobId;
  @JsonKey(name: 'MarketSegmentJob')
  final String? marketSegmentJob;
  @JsonKey(name: 'OutDeliveryId')
  final String? outDeliveryId;
  @JsonKey(name: 'OutDeliveryDeliveryType')
  final String? outDeliveryDeliveryType;
  @JsonKey(name: 'OutDeliveryRequiredDate')
  final String? outDeliveryRequiredDate;
  @JsonKey(name: 'OutDeliveryRequiredTime')
  final String? outDeliveryRequiredTime;
  @JsonKey(name: 'OutDeliveryTargetShipDate')
  final String? outDeliveryTargetShipDate;
  @JsonKey(name: 'OutDeliveryTargetShipTime')
  final String? outDeliveryTargetShipTime;
  @JsonKey(name: 'OutDeliveryDirection')
  final String? outDeliveryDirection;
  @JsonKey(name: 'OutDeliveryAddressType')
  final String? outDeliveryAddressType;
  @JsonKey(name: 'OutDeliveryFromLocation')
  final String? outDeliveryFromLocation;
  @JsonKey(name: 'OutDeliveryFromContact')
  final String? outDeliveryFromContact;
  @JsonKey(name: 'OutDeliveryFromContactPhone')
  final String? outDeliveryFromContactPhone;
  @JsonKey(name: 'OutDeliveryFromAlternateContact')
  final String? outDeliveryFromAlternateContact;
  @JsonKey(name: 'OutDeliveryFromAlternateContactPhone')
  final String? outDeliveryFromAlternateContactPhone;
  @JsonKey(name: 'OutDeliveryFromAttention')
  final String? outDeliveryFromAttention;
  @JsonKey(name: 'OutDeliveryFromAddress1')
  final String? outDeliveryFromAddress1;
  @JsonKey(name: 'OutDeliveryFromAdd2ress')
  final String? outDeliveryFromAdd2ress;
  @JsonKey(name: 'OutDeliveryFromCity')
  final String? outDeliveryFromCity;
  @JsonKey(name: 'OutDeliveryFromState')
  final String? outDeliveryFromState;
  @JsonKey(name: 'OutDeliveryFromZipCode')
  final String? outDeliveryFromZipCode;
  @JsonKey(name: 'OutDeliveryFromCountry')
  final String? outDeliveryFromCountry;
  @JsonKey(name: 'OutDeliveryFromCountryId')
  final String? outDeliveryFromCountryId;
  @JsonKey(name: 'OutDeliveryFromCrossStreets')
  final String? outDeliveryFromCrossStreets;
  @JsonKey(name: 'OutDeliveryToLocation')
  final String? outDeliveryToLocation;
  @JsonKey(name: 'OutDeliveryToContact')
  final String? outDeliveryToContact;
  @JsonKey(name: 'OutDeliveryToContactPhone')
  final String? outDeliveryToContactPhone;
  @JsonKey(name: 'OutDeliveryToAlternateContact')
  final String? outDeliveryToAlternateContact;
  @JsonKey(name: 'OutDeliveryToAlternateContactPhone')
  final String? outDeliveryToAlternateContactPhone;
  @JsonKey(name: 'OutDeliveryToAttention')
  final String? outDeliveryToAttention;
  @JsonKey(name: 'OutDeliveryToAddress1')
  final String? outDeliveryToAddress1;
  @JsonKey(name: 'OutDeliveryToAddress2')
  final String? outDeliveryToAddress2;
  @JsonKey(name: 'OutDeliveryToCity')
  final String? outDeliveryToCity;
  @JsonKey(name: 'OutDeliveryToState')
  final String? outDeliveryToState;
  @JsonKey(name: 'OutDeliveryToZipCode')
  final String? outDeliveryToZipCode;
  @JsonKey(name: 'OutDeliveryToCountryId')
  final String? outDeliveryToCountryId;
  @JsonKey(name: 'OutDeliveryToCountry')
  final String? outDeliveryToCountry;
  @JsonKey(name: 'OutDeliveryToContactFax')
  final String? outDeliveryToContactFax;
  @JsonKey(name: 'OutDeliveryToCrossStreets')
  final String? outDeliveryToCrossStreets;
  @JsonKey(name: 'OutDeliveryDeliveryNotes')
  final String? outDeliveryDeliveryNotes;
  @JsonKey(name: 'OutDeliveryCarrierId')
  final String? outDeliveryCarrierId;
  @JsonKey(name: 'OutDeliveryCarrier')
  final String? outDeliveryCarrier;
  @JsonKey(name: 'OutDeliveryCarrierAccount')
  final String? outDeliveryCarrierAccount;
  @JsonKey(name: 'OutDeliveryShipViaId')
  final String? outDeliveryShipViaId;
  @JsonKey(name: 'OutDeliveryShipVia')
  final String? outDeliveryShipVia;
  @JsonKey(name: 'OutDeliveryInvoiceId')
  final String? outDeliveryInvoiceId;
  @JsonKey(name: 'OutDeliveryVendorInvoiceId')
  final String? outDeliveryVendorInvoiceId;
  @JsonKey(name: 'OutDeliveryEstimatedFreight')
  final double? outDeliveryEstimatedFreight;
  @JsonKey(name: 'OutDeliveryFreightInvoiceAmount')
  final double? outDeliveryFreightInvoiceAmount;
  @JsonKey(name: 'OutDeliveryChargeType')
  final String? outDeliveryChargeType;
  @JsonKey(name: 'OutDeliveryFreightTrackingNumber')
  final String? outDeliveryFreightTrackingNumber;
  @JsonKey(name: 'OutDeliveryFreightTrackingUrl')
  final String? outDeliveryFreightTrackingUrl;
  @JsonKey(name: 'OutDeliveryPackageCode')
  final String? outDeliveryPackageCode;
  @JsonKey(name: 'OutDeliveryBillPoFreightOnOrder')
  final bool? outDeliveryBillPoFreightOnOrder;
  @JsonKey(name: 'OutDeliveryOnlineOrderNumber')
  final String? outDeliveryOnlineOrderNumber;
  @JsonKey(name: 'OutDeliveryToVenue')
  final String? outDeliveryToVenue;
  @JsonKey(name: 'OutDeliveryToVenueId')
  final String? outDeliveryToVenueId;
  @JsonKey(name: 'OutDeliveryToWarehouse')
  final String? outDeliveryToWarehouse;
  @JsonKey(name: 'OutDeliveryToWarehouseId')
  final String? outDeliveryToWarehouseId;
  @JsonKey(name: 'OutDeliveryDateStamp')
  final String? outDeliveryDateStamp;
  @JsonKey(name: 'InDeliveryId')
  final String? inDeliveryId;
  @JsonKey(name: 'InDeliveryDeliveryType')
  final String? inDeliveryDeliveryType;
  @JsonKey(name: 'InDeliveryRequiredDate')
  final String? inDeliveryRequiredDate;
  @JsonKey(name: 'InDeliveryRequiredTime')
  final String? inDeliveryRequiredTime;
  @JsonKey(name: 'InDeliveryTargetShipDate')
  final String? inDeliveryTargetShipDate;
  @JsonKey(name: 'InDeliveryTargetShipTime')
  final String? inDeliveryTargetShipTime;
  @JsonKey(name: 'InDeliveryDirection')
  final String? inDeliveryDirection;
  @JsonKey(name: 'InDeliveryAddressType')
  final String? inDeliveryAddressType;
  @JsonKey(name: 'InDeliveryFromLocation')
  final String? inDeliveryFromLocation;
  @JsonKey(name: 'InDeliveryFromContact')
  final String? inDeliveryFromContact;
  @JsonKey(name: 'InDeliveryFromContactPhone')
  final String? inDeliveryFromContactPhone;
  @JsonKey(name: 'InDeliveryFromAlternateContact')
  final String? inDeliveryFromAlternateContact;
  @JsonKey(name: 'InDeliveryFromAlternateContactPhone')
  final String? inDeliveryFromAlternateContactPhone;
  @JsonKey(name: 'InDeliveryFromAttention')
  final String? inDeliveryFromAttention;
  @JsonKey(name: 'InDeliveryFromAddress1')
  final String? inDeliveryFromAddress1;
  @JsonKey(name: 'InDeliveryFromAdd2ress')
  final String? inDeliveryFromAdd2ress;
  @JsonKey(name: 'InDeliveryFromCity')
  final String? inDeliveryFromCity;
  @JsonKey(name: 'InDeliveryFromState')
  final String? inDeliveryFromState;
  @JsonKey(name: 'InDeliveryFromZipCode')
  final String? inDeliveryFromZipCode;
  @JsonKey(name: 'InDeliveryFromCountry')
  final String? inDeliveryFromCountry;
  @JsonKey(name: 'InDeliveryFromCountryId')
  final String? inDeliveryFromCountryId;
  @JsonKey(name: 'InDeliveryFromCrossStreets')
  final String? inDeliveryFromCrossStreets;
  @JsonKey(name: 'InDeliveryToLocation')
  final String? inDeliveryToLocation;
  @JsonKey(name: 'InDeliveryToContact')
  final String? inDeliveryToContact;
  @JsonKey(name: 'InDeliveryToContactPhone')
  final String? inDeliveryToContactPhone;
  @JsonKey(name: 'InDeliveryToAlternateContact')
  final String? inDeliveryToAlternateContact;
  @JsonKey(name: 'InDeliveryToAlternateContactPhone')
  final String? inDeliveryToAlternateContactPhone;
  @JsonKey(name: 'InDeliveryToAttention')
  final String? inDeliveryToAttention;
  @JsonKey(name: 'InDeliveryToAddress1')
  final String? inDeliveryToAddress1;
  @JsonKey(name: 'InDeliveryToAddress2')
  final String? inDeliveryToAddress2;
  @JsonKey(name: 'InDeliveryToCity')
  final String? inDeliveryToCity;
  @JsonKey(name: 'InDeliveryToState')
  final String? inDeliveryToState;
  @JsonKey(name: 'InDeliveryToZipCode')
  final String? inDeliveryToZipCode;
  @JsonKey(name: 'InDeliveryToCountryId')
  final String? inDeliveryToCountryId;
  @JsonKey(name: 'InDeliveryToCountry')
  final String? inDeliveryToCountry;
  @JsonKey(name: 'InDeliveryToContactFax')
  final String? inDeliveryToContactFax;
  @JsonKey(name: 'InDeliveryToCrossStreets')
  final String? inDeliveryToCrossStreets;
  @JsonKey(name: 'InDeliveryDeliveryNotes')
  final String? inDeliveryDeliveryNotes;
  @JsonKey(name: 'InDeliveryCarrierId')
  final String? inDeliveryCarrierId;
  @JsonKey(name: 'InDeliveryCarrier')
  final String? inDeliveryCarrier;
  @JsonKey(name: 'InDeliveryCarrierAccount')
  final String? inDeliveryCarrierAccount;
  @JsonKey(name: 'InDeliveryShipViaId')
  final String? inDeliveryShipViaId;
  @JsonKey(name: 'InDeliveryShipVia')
  final String? inDeliveryShipVia;
  @JsonKey(name: 'InDeliveryInvoiceId')
  final String? inDeliveryInvoiceId;
  @JsonKey(name: 'InDeliveryVendorInvoiceId')
  final String? inDeliveryVendorInvoiceId;
  @JsonKey(name: 'InDeliveryEstimatedFreight')
  final double? inDeliveryEstimatedFreight;
  @JsonKey(name: 'InDeliveryFreightInvoiceAmount')
  final double? inDeliveryFreightInvoiceAmount;
  @JsonKey(name: 'InDeliveryChargeType')
  final String? inDeliveryChargeType;
  @JsonKey(name: 'InDeliveryFreightTrackingNumber')
  final String? inDeliveryFreightTrackingNumber;
  @JsonKey(name: 'InDeliveryFreightTrackingUrl')
  final String? inDeliveryFreightTrackingUrl;
  @JsonKey(name: 'InDeliveryPackageCode')
  final String? inDeliveryPackageCode;
  @JsonKey(name: 'InDeliveryBillPoFreightOnOrder')
  final bool? inDeliveryBillPoFreightOnOrder;
  @JsonKey(name: 'InDeliveryOnlineOrderNumber')
  final String? inDeliveryOnlineOrderNumber;
  @JsonKey(name: 'InDeliveryOnlineOrderStatus')
  final String? inDeliveryOnlineOrderStatus;
  @JsonKey(name: 'InDeliveryToVenue')
  final String? inDeliveryToVenue;
  @JsonKey(name: 'InDeliveryToVenueId')
  final String? inDeliveryToVenueId;
  @JsonKey(name: 'InDeliveryToWarehouse')
  final String? inDeliveryToWarehouse;
  @JsonKey(name: 'InDeliveryToWarehouseId')
  final String? inDeliveryToWarehouseId;
  @JsonKey(name: 'InDeliveryDateStamp')
  final String? inDeliveryDateStamp;
  @JsonKey(name: 'RentalDaysPerWeek')
  final double? rentalDaysPerWeek;
  @JsonKey(name: 'RentalDiscountPercent')
  final double? rentalDiscountPercent;
  @JsonKey(name: 'WeeklyRentalTotal')
  final double? weeklyRentalTotal;
  @JsonKey(name: 'MonthlyRentalTotal')
  final double? monthlyRentalTotal;
  @JsonKey(name: 'PeriodRentalTotal')
  final double? periodRentalTotal;
  @JsonKey(name: 'WeeklyRentalTotalIncludesTax')
  final bool? weeklyRentalTotalIncludesTax;
  @JsonKey(name: 'MonthlyRentalTotalIncludesTax')
  final bool? monthlyRentalTotalIncludesTax;
  @JsonKey(name: 'PeriodRentalTotalIncludesTax')
  final bool? periodRentalTotalIncludesTax;
  @JsonKey(name: 'BillLockedTotal')
  final bool? billLockedTotal;
  @JsonKey(name: 'SalesDiscountPercent')
  final double? salesDiscountPercent;
  @JsonKey(name: 'SalesTotal')
  final double? salesTotal;
  @JsonKey(name: 'SalesTotalIncludesTax')
  final bool? salesTotalIncludesTax;
  @JsonKey(name: 'PartsDiscountPercent')
  final double? partsDiscountPercent;
  @JsonKey(name: 'PartsTotal')
  final double? partsTotal;
  @JsonKey(name: 'PartsTotalIncludesTax')
  final bool? partsTotalIncludesTax;
  @JsonKey(name: 'SpaceDaysPerWeek')
  final double? spaceDaysPerWeek;
  @JsonKey(name: 'SpaceDiscountPercent')
  final double? spaceDiscountPercent;
  @JsonKey(name: 'SpaceSplitPercent')
  final double? spaceSplitPercent;
  @JsonKey(name: 'WeeklySpaceTotal')
  final double? weeklySpaceTotal;
  @JsonKey(name: 'MonthlySpaceTotal')
  final double? monthlySpaceTotal;
  @JsonKey(name: 'PeriodSpaceTotal')
  final double? periodSpaceTotal;
  @JsonKey(name: 'WeeklySpaceTotalIncludesTax')
  final bool? weeklySpaceTotalIncludesTax;
  @JsonKey(name: 'MonthlySpaceTotalIncludesTax')
  final bool? monthlySpaceTotalIncludesTax;
  @JsonKey(name: 'PeriodSpaceTotalIncludesTax')
  final bool? periodSpaceTotalIncludesTax;
  @JsonKey(name: 'VehicleDaysPerWeek')
  final double? vehicleDaysPerWeek;
  @JsonKey(name: 'VehicleDiscountPercent')
  final double? vehicleDiscountPercent;
  @JsonKey(name: 'WeeklyVehicleTotal')
  final double? weeklyVehicleTotal;
  @JsonKey(name: 'MonthlyVehicleTotal')
  final double? monthlyVehicleTotal;
  @JsonKey(name: 'PeriodVehicleTotal')
  final double? periodVehicleTotal;
  @JsonKey(name: 'WeeklyVehicleTotalIncludesTax')
  final bool? weeklyVehicleTotalIncludesTax;
  @JsonKey(name: 'MonthlyVehicleTotalIncludesTax')
  final bool? monthlyVehicleTotalIncludesTax;
  @JsonKey(name: 'PeriodVehicleTotalIncludesTax')
  final bool? periodVehicleTotalIncludesTax;
  @JsonKey(name: 'MiscDiscountPercent')
  final double? miscDiscountPercent;
  @JsonKey(name: 'WeeklyMiscTotal')
  final double? weeklyMiscTotal;
  @JsonKey(name: 'MonthlyMiscTotal')
  final double? monthlyMiscTotal;
  @JsonKey(name: 'PeriodMiscTotal')
  final double? periodMiscTotal;
  @JsonKey(name: 'WeeklyMiscTotalIncludesTax')
  final bool? weeklyMiscTotalIncludesTax;
  @JsonKey(name: 'MonthlyMiscTotalIncludesTax')
  final bool? monthlyMiscTotalIncludesTax;
  @JsonKey(name: 'PeriodMiscTotalIncludesTax')
  final bool? periodMiscTotalIncludesTax;
  @JsonKey(name: 'LaborDiscountPercent')
  final double? laborDiscountPercent;
  @JsonKey(name: 'WeeklyLaborTotal')
  final double? weeklyLaborTotal;
  @JsonKey(name: 'MonthlyLaborTotal')
  final double? monthlyLaborTotal;
  @JsonKey(name: 'PeriodLaborTotal')
  final double? periodLaborTotal;
  @JsonKey(name: 'WeeklyLaborTotalIncludesTax')
  final bool? weeklyLaborTotalIncludesTax;
  @JsonKey(name: 'MonthlyLaborTotalIncludesTax')
  final bool? monthlyLaborTotalIncludesTax;
  @JsonKey(name: 'PeriodLaborTotalIncludesTax')
  final bool? periodLaborTotalIncludesTax;
  @JsonKey(name: 'RentalSaleDiscountPercent')
  final double? rentalSaleDiscountPercent;
  @JsonKey(name: 'RentalSaleTotal')
  final double? rentalSaleTotal;
  @JsonKey(name: 'RentalSaleTotalIncludesTax')
  final bool? rentalSaleTotalIncludesTax;
  @JsonKey(name: 'LossAndDamageDiscountPercent')
  final double? lossAndDamageDiscountPercent;
  @JsonKey(name: 'LossAndDamageTotal')
  final double? lossAndDamageTotal;
  @JsonKey(name: 'LossAndDamageTotalIncludesTax')
  final bool? lossAndDamageTotalIncludesTax;
  @JsonKey(name: 'CombinedDaysPerWeek')
  final double? combinedDaysPerWeek;
  @JsonKey(name: 'CombinedDiscountPercent')
  final double? combinedDiscountPercent;
  @JsonKey(name: 'WeeklyCombinedTotal')
  final double? weeklyCombinedTotal;
  @JsonKey(name: 'MonthlyCombinedTotal')
  final double? monthlyCombinedTotal;
  @JsonKey(name: 'PeriodCombinedTotal')
  final double? periodCombinedTotal;
  @JsonKey(name: 'WeeklyCombinedTotalIncludesTax')
  final bool? weeklyCombinedTotalIncludesTax;
  @JsonKey(name: 'MonthlyCombinedTotalIncludesTax')
  final bool? monthlyCombinedTotalIncludesTax;
  @JsonKey(name: 'PeriodCombinedTotalIncludesTax')
  final bool? periodCombinedTotalIncludesTax;
  @JsonKey(name: 'DisableEditingRentalRate')
  final bool? disableEditingRentalRate;
  @JsonKey(name: 'DisableEditingSalesRate')
  final bool? disableEditingSalesRate;
  @JsonKey(name: 'DisableEditingMiscellaneousRate')
  final bool? disableEditingMiscellaneousRate;
  @JsonKey(name: 'DisableEditingLaborRate')
  final bool? disableEditingLaborRate;
  @JsonKey(name: 'DisableEditingRentalSaleRate')
  final bool? disableEditingRentalSaleRate;
  @JsonKey(name: 'DisableEditingLossAndDamageRate')
  final bool? disableEditingLossAndDamageRate;
  @JsonKey(name: 'RentalExtendedTotal')
  final double? rentalExtendedTotal;
  @JsonKey(name: 'SalesExtendedTotal')
  final double? salesExtendedTotal;
  @JsonKey(name: 'LaborExtendedTotal')
  final double? laborExtendedTotal;
  @JsonKey(name: 'MiscellaneousExtendedTotal')
  final double? miscellaneousExtendedTotal;
  @JsonKey(name: 'RentalSaleExtendedTotal')
  final double? rentalSaleExtendedTotal;
  @JsonKey(name: 'LossAndDamageExtendedTotal')
  final double? lossAndDamageExtendedTotal;
  @JsonKey(name: 'HasNotes')
  final bool? hasNotes;
  @JsonKey(name: 'HasDocuments')
  final bool? hasDocuments;
  @JsonKey(name: 'HasEmailHistory')
  final bool? hasEmailHistory;
  @JsonKey(name: 'HasContacts')
  final bool? hasContacts;
  @JsonKey(name: 'HasSubPurchaseOrders')
  final bool? hasSubPurchaseOrders;
  @JsonKey(name: 'HasPickLists')
  final bool? hasPickLists;
  @JsonKey(name: 'HasContracts')
  final bool? hasContracts;
  @JsonKey(name: 'HasSuspendedContracts')
  final bool? hasSuspendedContracts;
  @JsonKey(name: 'HasMultiOrderContracts')
  final bool? hasMultiOrderContracts;
  @JsonKey(name: 'HasInvoices')
  final bool? hasInvoices;
  @JsonKey(name: 'HasBillingWorksheets')
  final bool? hasBillingWorksheets;
  @JsonKey(name: 'HasMultiOrderInvoices')
  final bool? hasMultiOrderInvoices;
  @JsonKey(name: 'TotalReplacementCost')
  final double? totalReplacementCost;
  @JsonKey(name: 'PresentationLayerId')
  final String? presentationLayerId;
  @JsonKey(name: 'PresentationLayer')
  final String? presentationLayer;
  @JsonKey(name: 'IsManualSort')
  final bool? isManualSort;
  @JsonKey(name: 'QuoteOrderTitle')
  final String? quoteOrderTitle;
  @JsonKey(name: 'UnassignedSubs')
  final bool? unassignedSubs;
  @JsonKey(name: 'NonTaxable')
  final bool? nonTaxable;
  @JsonKey(name: 'EnableProjects')
  final bool? enableProjects;
  @JsonKey(name: 'ProjectId')
  final String? projectId;
  @JsonKey(name: 'ProjectNumber')
  final String? projectNumber;
  @JsonKey(name: 'Project')
  final String? project;
  @JsonKey(name: 'ProjectDrawingsId')
  final String? projectDrawingsId;
  @JsonKey(name: 'ProjectDrawings')
  final String? projectDrawings;
  @JsonKey(name: 'ProjectItemsOrderedId')
  final String? projectItemsOrderedId;
  @JsonKey(name: 'ProjectItemsOrdered')
  final String? projectItemsOrdered;
  @JsonKey(name: 'ProjectDropShipId')
  final String? projectDropShipId;
  @JsonKey(name: 'ProjectDropShip')
  final String? projectDropShip;
  @JsonKey(name: 'ProjectAsBuildId')
  final String? projectAsBuildId;
  @JsonKey(name: 'ProjectAsBuild')
  final String? projectAsBuild;
  @JsonKey(name: 'ProjectCommissioningId')
  final String? projectCommissioningId;
  @JsonKey(name: 'ProjectCommissioning')
  final String? projectCommissioning;
  @JsonKey(name: 'ProjectDepositId')
  final String? projectDepositId;
  @JsonKey(name: 'ProjectDeposit')
  final String? projectDeposit;
  @JsonKey(name: 'InputByUserId')
  final String? inputByUserId;
  @JsonKey(name: 'ModifiedByUserId')
  final String? modifiedByUserId;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory = _$WebApiModulesAgentQuoteQuoteFromJson;
  static const toJsonFactory = _$WebApiModulesAgentQuoteQuoteToJson;
  Map<String, dynamic> toJson() => _$WebApiModulesAgentQuoteQuoteToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentQuoteQuote &&
            (identical(other.quoteId, quoteId) ||
                const DeepCollectionEquality()
                    .equals(other.quoteId, quoteId)) &&
            (identical(other.quoteNumber, quoteNumber) ||
                const DeepCollectionEquality()
                    .equals(other.quoteNumber, quoteNumber)) &&
            (identical(other.quoteDate, quoteDate) ||
                const DeepCollectionEquality()
                    .equals(other.quoteDate, quoteDate)) &&
            (identical(other.versionNumber, versionNumber) ||
                const DeepCollectionEquality()
                    .equals(other.versionNumber, versionNumber)) &&
            (identical(other.convertedToOrderId, convertedToOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.convertedToOrderId, convertedToOrderId)) &&
            (identical(other.convertedToOrderNumber, convertedToOrderNumber) ||
                const DeepCollectionEquality().equals(
                    other.convertedToOrderNumber, convertedToOrderNumber)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.officeLocationId, officeLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocationId, officeLocationId)) &&
            (identical(other.officeLocation, officeLocation) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocation, officeLocation)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouse, warehouse) ||
                const DeepCollectionEquality()
                    .equals(other.warehouse, warehouse)) &&
            (identical(other.warehouseCode, warehouseCode) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.departmentId, departmentId) ||
                const DeepCollectionEquality()
                    .equals(other.departmentId, departmentId)) &&
            (identical(other.department, department) ||
                const DeepCollectionEquality()
                    .equals(other.department, department)) &&
            (identical(other.customerId, customerId) ||
                const DeepCollectionEquality()
                    .equals(other.customerId, customerId)) &&
            (identical(other.customer, customer) ||
                const DeepCollectionEquality()
                    .equals(other.customer, customer)) &&
            (identical(other.customerNumber, customerNumber) ||
                const DeepCollectionEquality()
                    .equals(other.customerNumber, customerNumber)) &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.deal, deal) ||
                const DeepCollectionEquality().equals(other.deal, deal)) &&
            (identical(other.dealNumber, dealNumber) ||
                const DeepCollectionEquality()
                    .equals(other.dealNumber, dealNumber)) &&
            (identical(other.rateType, rateType) ||
                const DeepCollectionEquality()
                    .equals(other.rateType, rateType)) &&
            (identical(other.rateTypeDisplay, rateTypeDisplay) ||
                const DeepCollectionEquality()
                    .equals(other.rateTypeDisplay, rateTypeDisplay)) &&
            (identical(other.agentId, agentId) ||
                const DeepCollectionEquality().equals(other.agentId, agentId)) &&
            (identical(other.agent, agent) || const DeepCollectionEquality().equals(other.agent, agent)) &&
            (identical(other.projectManagerId, projectManagerId) || const DeepCollectionEquality().equals(other.projectManagerId, projectManagerId)) &&
            (identical(other.projectManager, projectManager) || const DeepCollectionEquality().equals(other.projectManager, projectManager)) &&
            (identical(other.rental, rental) || const DeepCollectionEquality().equals(other.rental, rental)) &&
            (identical(other.sales, sales) || const DeepCollectionEquality().equals(other.sales, sales)) &&
            (identical(other.miscellaneous, miscellaneous) || const DeepCollectionEquality().equals(other.miscellaneous, miscellaneous)) &&
            (identical(other.labor, labor) || const DeepCollectionEquality().equals(other.labor, labor)) &&
            (identical(other.facilities, facilities) || const DeepCollectionEquality().equals(other.facilities, facilities)) &&
            (identical(other.transportation, transportation) || const DeepCollectionEquality().equals(other.transportation, transportation)) &&
            (identical(other.rentalSale, rentalSale) || const DeepCollectionEquality().equals(other.rentalSale, rentalSale)) &&
            (identical(other.lossAndDamage, lossAndDamage) || const DeepCollectionEquality().equals(other.lossAndDamage, lossAndDamage)) &&
            (identical(other.repair, repair) || const DeepCollectionEquality().equals(other.repair, repair)) &&
            (identical(other.hasRentalItem, hasRentalItem) || const DeepCollectionEquality().equals(other.hasRentalItem, hasRentalItem)) &&
            (identical(other.hasSalesItem, hasSalesItem) || const DeepCollectionEquality().equals(other.hasSalesItem, hasSalesItem)) &&
            (identical(other.hasMiscellaneousItem, hasMiscellaneousItem) || const DeepCollectionEquality().equals(other.hasMiscellaneousItem, hasMiscellaneousItem)) &&
            (identical(other.hasLaborItem, hasLaborItem) || const DeepCollectionEquality().equals(other.hasLaborItem, hasLaborItem)) &&
            (identical(other.hasFacilitiesItem, hasFacilitiesItem) || const DeepCollectionEquality().equals(other.hasFacilitiesItem, hasFacilitiesItem)) &&
            (identical(other.hasLossAndDamageItem, hasLossAndDamageItem) || const DeepCollectionEquality().equals(other.hasLossAndDamageItem, hasLossAndDamageItem)) &&
            (identical(other.hasRentalSaleItem, hasRentalSaleItem) || const DeepCollectionEquality().equals(other.hasRentalSaleItem, hasRentalSaleItem)) &&
            (identical(other.hasRepair, hasRepair) || const DeepCollectionEquality().equals(other.hasRepair, hasRepair)) &&
            (identical(other.activityDatesAndTimes, activityDatesAndTimes) || const DeepCollectionEquality().equals(other.activityDatesAndTimes, activityDatesAndTimes)) &&
            (identical(other.pickDate, pickDate) || const DeepCollectionEquality().equals(other.pickDate, pickDate)) &&
            (identical(other.pickTime, pickTime) || const DeepCollectionEquality().equals(other.pickTime, pickTime)) &&
            (identical(other.estimatedStartDate, estimatedStartDate) || const DeepCollectionEquality().equals(other.estimatedStartDate, estimatedStartDate)) &&
            (identical(other.estimatedStartTime, estimatedStartTime) || const DeepCollectionEquality().equals(other.estimatedStartTime, estimatedStartTime)) &&
            (identical(other.estimatedStopDate, estimatedStopDate) || const DeepCollectionEquality().equals(other.estimatedStopDate, estimatedStopDate)) &&
            (identical(other.estimatedStopTime, estimatedStopTime) || const DeepCollectionEquality().equals(other.estimatedStopTime, estimatedStopTime)) &&
            (identical(other.pickUpDate, pickUpDate) || const DeepCollectionEquality().equals(other.pickUpDate, pickUpDate)) &&
            (identical(other.pickUpTime, pickUpTime) || const DeepCollectionEquality().equals(other.pickUpTime, pickUpTime)) &&
            (identical(other.prepDate, prepDate) || const DeepCollectionEquality().equals(other.prepDate, prepDate)) &&
            (identical(other.prepTime, prepTime) || const DeepCollectionEquality().equals(other.prepTime, prepTime)) &&
            (identical(other.loadInDate, loadInDate) || const DeepCollectionEquality().equals(other.loadInDate, loadInDate)) &&
            (identical(other.loadInTime, loadInTime) || const DeepCollectionEquality().equals(other.loadInTime, loadInTime)) &&
            (identical(other.strikeDate, strikeDate) || const DeepCollectionEquality().equals(other.strikeDate, strikeDate)) &&
            (identical(other.strikeTime, strikeTime) || const DeepCollectionEquality().equals(other.strikeTime, strikeTime)) &&
            (identical(other.testDate, testDate) || const DeepCollectionEquality().equals(other.testDate, testDate)) &&
            (identical(other.testTime, testTime) || const DeepCollectionEquality().equals(other.testTime, testTime)) &&
            (identical(other.orderTypeId, orderTypeId) || const DeepCollectionEquality().equals(other.orderTypeId, orderTypeId)) &&
            (identical(other.orderType, orderType) || const DeepCollectionEquality().equals(other.orderType, orderType)) &&
            (identical(other.orderTypeCombineActivityTabs, orderTypeCombineActivityTabs) || const DeepCollectionEquality().equals(other.orderTypeCombineActivityTabs, orderTypeCombineActivityTabs)) &&
            (identical(other.flatPo, flatPo) || const DeepCollectionEquality().equals(other.flatPo, flatPo)) &&
            (identical(other.pendingPo, pendingPo) || const DeepCollectionEquality().equals(other.pendingPo, pendingPo)) &&
            (identical(other.poNumber, poNumber) || const DeepCollectionEquality().equals(other.poNumber, poNumber)) &&
            (identical(other.poAmount, poAmount) || const DeepCollectionEquality().equals(other.poAmount, poAmount)) &&
            (identical(other.location, location) || const DeepCollectionEquality().equals(other.location, location)) &&
            (identical(other.orderLocationId, orderLocationId) || const DeepCollectionEquality().equals(other.orderLocationId, orderLocationId)) &&
            (identical(other.orderLocation, orderLocation) || const DeepCollectionEquality().equals(other.orderLocation, orderLocation)) &&
            (identical(other.referenceNumber, referenceNumber) || const DeepCollectionEquality().equals(other.referenceNumber, referenceNumber)) &&
            (identical(other.total, total) || const DeepCollectionEquality().equals(other.total, total)) &&
            (identical(other.status, status) || const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.statusDate, statusDate) || const DeepCollectionEquality().equals(other.statusDate, statusDate)) &&
            (identical(other.poApprovalStatusId, poApprovalStatusId) || const DeepCollectionEquality().equals(other.poApprovalStatusId, poApprovalStatusId)) &&
            (identical(other.lockBillingDates, lockBillingDates) || const DeepCollectionEquality().equals(other.lockBillingDates, lockBillingDates)) &&
            (identical(other.specifyBillingDatesByType, specifyBillingDatesByType) || const DeepCollectionEquality().equals(other.specifyBillingDatesByType, specifyBillingDatesByType)) &&
            (identical(other.rentalBillingStartDate, rentalBillingStartDate) || const DeepCollectionEquality().equals(other.rentalBillingStartDate, rentalBillingStartDate)) &&
            (identical(other.rentalBillingEndDate, rentalBillingEndDate) || const DeepCollectionEquality().equals(other.rentalBillingEndDate, rentalBillingEndDate)) &&
            (identical(other.laborBillingStartDate, laborBillingStartDate) || const DeepCollectionEquality().equals(other.laborBillingStartDate, laborBillingStartDate)) &&
            (identical(other.laborBillingEndDate, laborBillingEndDate) || const DeepCollectionEquality().equals(other.laborBillingEndDate, laborBillingEndDate)) &&
            (identical(other.miscellaneousBillingStartDate, miscellaneousBillingStartDate) || const DeepCollectionEquality().equals(other.miscellaneousBillingStartDate, miscellaneousBillingStartDate)) &&
            (identical(other.miscellaneousBillingEndDate, miscellaneousBillingEndDate) || const DeepCollectionEquality().equals(other.miscellaneousBillingEndDate, miscellaneousBillingEndDate)) &&
            (identical(other.facilitiesBillingStartDate, facilitiesBillingStartDate) || const DeepCollectionEquality().equals(other.facilitiesBillingStartDate, facilitiesBillingStartDate)) &&
            (identical(other.facilitiesBillingEndDate, facilitiesBillingEndDate) || const DeepCollectionEquality().equals(other.facilitiesBillingEndDate, facilitiesBillingEndDate)) &&
            (identical(other.vehicleBillingStartDate, vehicleBillingStartDate) || const DeepCollectionEquality().equals(other.vehicleBillingStartDate, vehicleBillingStartDate)) &&
            (identical(other.vehicleBillingEndDate, vehicleBillingEndDate) || const DeepCollectionEquality().equals(other.vehicleBillingEndDate, vehicleBillingEndDate)) &&
            (identical(other.delayBillingSearchUntil, delayBillingSearchUntil) || const DeepCollectionEquality().equals(other.delayBillingSearchUntil, delayBillingSearchUntil)) &&
            (identical(other.includePrepFeesInRentalRate, includePrepFeesInRentalRate) || const DeepCollectionEquality().equals(other.includePrepFeesInRentalRate, includePrepFeesInRentalRate)) &&
            (identical(other.billingStartDate, billingStartDate) || const DeepCollectionEquality().equals(other.billingStartDate, billingStartDate)) &&
            (identical(other.billingEndDate, billingEndDate) || const DeepCollectionEquality().equals(other.billingEndDate, billingEndDate)) &&
            (identical(other.billingWeeks, billingWeeks) || const DeepCollectionEquality().equals(other.billingWeeks, billingWeeks)) &&
            (identical(other.billingMonths, billingMonths) || const DeepCollectionEquality().equals(other.billingMonths, billingMonths)) &&
            (identical(other.determineQuantitiesToBillBasedOn, determineQuantitiesToBillBasedOn) || const DeepCollectionEquality().equals(other.determineQuantitiesToBillBasedOn, determineQuantitiesToBillBasedOn)) &&
            (identical(other.billingCycleId, billingCycleId) || const DeepCollectionEquality().equals(other.billingCycleId, billingCycleId)) &&
            (identical(other.billingCycle, billingCycle) || const DeepCollectionEquality().equals(other.billingCycle, billingCycle)) &&
            (identical(other.billingCycleType, billingCycleType) || const DeepCollectionEquality().equals(other.billingCycleType, billingCycleType)) &&
            (identical(other.paymentTermsId, paymentTermsId) || const DeepCollectionEquality().equals(other.paymentTermsId, paymentTermsId)) &&
            (identical(other.paymentTerms, paymentTerms) || const DeepCollectionEquality().equals(other.paymentTerms, paymentTerms)) &&
            (identical(other.paymentTypeId, paymentTypeId) || const DeepCollectionEquality().equals(other.paymentTypeId, paymentTypeId)) &&
            (identical(other.paymentType, paymentType) || const DeepCollectionEquality().equals(other.paymentType, paymentType)) &&
            (identical(other.currencyId, currencyId) || const DeepCollectionEquality().equals(other.currencyId, currencyId)) &&
            (identical(other.updateAllRatesToNewCurrency, updateAllRatesToNewCurrency) || const DeepCollectionEquality().equals(other.updateAllRatesToNewCurrency, updateAllRatesToNewCurrency)) &&
            (identical(other.confirmUpdateAllRatesToNewCurrency, confirmUpdateAllRatesToNewCurrency) || const DeepCollectionEquality().equals(other.confirmUpdateAllRatesToNewCurrency, confirmUpdateAllRatesToNewCurrency)) &&
            (identical(other.currencyCode, currencyCode) || const DeepCollectionEquality().equals(other.currencyCode, currencyCode)) &&
            (identical(other.currency, currency) || const DeepCollectionEquality().equals(other.currency, currency)) &&
            (identical(other.currencySymbol, currencySymbol) || const DeepCollectionEquality().equals(other.currencySymbol, currencySymbol)) &&
            (identical(other.taxOptionId, taxOptionId) || const DeepCollectionEquality().equals(other.taxOptionId, taxOptionId)) &&
            (identical(other.taxOption, taxOption) || const DeepCollectionEquality().equals(other.taxOption, taxOption)) &&
            (identical(other.tax1Name, tax1Name) || const DeepCollectionEquality().equals(other.tax1Name, tax1Name)) &&
            (identical(other.tax2Name, tax2Name) || const DeepCollectionEquality().equals(other.tax2Name, tax2Name)) &&
            (identical(other.taxId, taxId) || const DeepCollectionEquality().equals(other.taxId, taxId)) &&
            (identical(other.rentalTaxRate1, rentalTaxRate1) || const DeepCollectionEquality().equals(other.rentalTaxRate1, rentalTaxRate1)) &&
            (identical(other.salesTaxRate1, salesTaxRate1) || const DeepCollectionEquality().equals(other.salesTaxRate1, salesTaxRate1)) &&
            (identical(other.laborTaxRate1, laborTaxRate1) || const DeepCollectionEquality().equals(other.laborTaxRate1, laborTaxRate1)) &&
            (identical(other.rentalTaxRate2, rentalTaxRate2) || const DeepCollectionEquality().equals(other.rentalTaxRate2, rentalTaxRate2)) &&
            (identical(other.salesTaxRate2, salesTaxRate2) || const DeepCollectionEquality().equals(other.salesTaxRate2, salesTaxRate2)) &&
            (identical(other.laborTaxRate2, laborTaxRate2) || const DeepCollectionEquality().equals(other.laborTaxRate2, laborTaxRate2)) &&
            (identical(other.noCharge, noCharge) || const DeepCollectionEquality().equals(other.noCharge, noCharge)) &&
            (identical(other.noChargeReason, noChargeReason) || const DeepCollectionEquality().equals(other.noChargeReason, noChargeReason)) &&
            (identical(other.printIssuedToAddressFrom, printIssuedToAddressFrom) || const DeepCollectionEquality().equals(other.printIssuedToAddressFrom, printIssuedToAddressFrom)) &&
            (identical(other.issuedToName, issuedToName) || const DeepCollectionEquality().equals(other.issuedToName, issuedToName)) &&
            (identical(other.issuedToAttention, issuedToAttention) || const DeepCollectionEquality().equals(other.issuedToAttention, issuedToAttention)) &&
            (identical(other.issuedToAttention2, issuedToAttention2) || const DeepCollectionEquality().equals(other.issuedToAttention2, issuedToAttention2)) &&
            (identical(other.issuedToAddress1, issuedToAddress1) || const DeepCollectionEquality().equals(other.issuedToAddress1, issuedToAddress1)) &&
            (identical(other.issuedToAddress2, issuedToAddress2) || const DeepCollectionEquality().equals(other.issuedToAddress2, issuedToAddress2)) &&
            (identical(other.issuedToCity, issuedToCity) || const DeepCollectionEquality().equals(other.issuedToCity, issuedToCity)) &&
            (identical(other.issuedToState, issuedToState) || const DeepCollectionEquality().equals(other.issuedToState, issuedToState)) &&
            (identical(other.issuedToZipCode, issuedToZipCode) || const DeepCollectionEquality().equals(other.issuedToZipCode, issuedToZipCode)) &&
            (identical(other.issuedToCountryId, issuedToCountryId) || const DeepCollectionEquality().equals(other.issuedToCountryId, issuedToCountryId)) &&
            (identical(other.issuedToCountry, issuedToCountry) || const DeepCollectionEquality().equals(other.issuedToCountry, issuedToCountry)) &&
            (identical(other.billToAddressDifferentFromIssuedToAddress, billToAddressDifferentFromIssuedToAddress) || const DeepCollectionEquality().equals(other.billToAddressDifferentFromIssuedToAddress, billToAddressDifferentFromIssuedToAddress)) &&
            (identical(other.billToAddressId, billToAddressId) || const DeepCollectionEquality().equals(other.billToAddressId, billToAddressId)) &&
            (identical(other.billToName, billToName) || const DeepCollectionEquality().equals(other.billToName, billToName)) &&
            (identical(other.billToAttention, billToAttention) || const DeepCollectionEquality().equals(other.billToAttention, billToAttention)) &&
            (identical(other.billToAttention2, billToAttention2) || const DeepCollectionEquality().equals(other.billToAttention2, billToAttention2)) &&
            (identical(other.billToAddress1, billToAddress1) || const DeepCollectionEquality().equals(other.billToAddress1, billToAddress1)) &&
            (identical(other.billToAddress2, billToAddress2) || const DeepCollectionEquality().equals(other.billToAddress2, billToAddress2)) &&
            (identical(other.billToCity, billToCity) || const DeepCollectionEquality().equals(other.billToCity, billToCity)) &&
            (identical(other.billToState, billToState) || const DeepCollectionEquality().equals(other.billToState, billToState)) &&
            (identical(other.billToZipCode, billToZipCode) || const DeepCollectionEquality().equals(other.billToZipCode, billToZipCode)) &&
            (identical(other.billToCountryId, billToCountryId) || const DeepCollectionEquality().equals(other.billToCountryId, billToCountryId)) &&
            (identical(other.billToCountry, billToCountry) || const DeepCollectionEquality().equals(other.billToCountry, billToCountry)) &&
            (identical(other.discountReasonId, discountReasonId) || const DeepCollectionEquality().equals(other.discountReasonId, discountReasonId)) &&
            (identical(other.discountReason, discountReason) || const DeepCollectionEquality().equals(other.discountReason, discountReason)) &&
            (identical(other.requireContactConfirmation, requireContactConfirmation) || const DeepCollectionEquality().equals(other.requireContactConfirmation, requireContactConfirmation)) &&
            (identical(other.includeInBillingAnalysis, includeInBillingAnalysis) || const DeepCollectionEquality().equals(other.includeInBillingAnalysis, includeInBillingAnalysis)) &&
            (identical(other.hiatusDiscountFrom, hiatusDiscountFrom) || const DeepCollectionEquality().equals(other.hiatusDiscountFrom, hiatusDiscountFrom)) &&
            (identical(other.roundTripRentals, roundTripRentals) || const DeepCollectionEquality().equals(other.roundTripRentals, roundTripRentals)) &&
            (identical(other.inGroup, inGroup) || const DeepCollectionEquality().equals(other.inGroup, inGroup)) &&
            (identical(other.groupNumber, groupNumber) || const DeepCollectionEquality().equals(other.groupNumber, groupNumber)) &&
            (identical(other.groupColor, groupColor) || const DeepCollectionEquality().equals(other.groupColor, groupColor)) &&
            (identical(other.groupOrderBy, groupOrderBy) || const DeepCollectionEquality().equals(other.groupOrderBy, groupOrderBy)) &&
            (identical(other.coverLetterId, coverLetterId) || const DeepCollectionEquality().equals(other.coverLetterId, coverLetterId)) &&
            (identical(other.coverLetter, coverLetter) || const DeepCollectionEquality().equals(other.coverLetter, coverLetter)) &&
            (identical(other.termsConditionsId, termsConditionsId) || const DeepCollectionEquality().equals(other.termsConditionsId, termsConditionsId)) &&
            (identical(other.termsConditions, termsConditions) || const DeepCollectionEquality().equals(other.termsConditions, termsConditions)) &&
            (identical(other.outsideSalesRepresentativeId, outsideSalesRepresentativeId) || const DeepCollectionEquality().equals(other.outsideSalesRepresentativeId, outsideSalesRepresentativeId)) &&
            (identical(other.outsideSalesRepresentative, outsideSalesRepresentative) || const DeepCollectionEquality().equals(other.outsideSalesRepresentative, outsideSalesRepresentative)) &&
            (identical(other.marketTypeId, marketTypeId) || const DeepCollectionEquality().equals(other.marketTypeId, marketTypeId)) &&
            (identical(other.marketType, marketType) || const DeepCollectionEquality().equals(other.marketType, marketType)) &&
            (identical(other.marketSegmentId, marketSegmentId) || const DeepCollectionEquality().equals(other.marketSegmentId, marketSegmentId)) &&
            (identical(other.marketSegment, marketSegment) || const DeepCollectionEquality().equals(other.marketSegment, marketSegment)) &&
            (identical(other.marketSegmentJobId, marketSegmentJobId) || const DeepCollectionEquality().equals(other.marketSegmentJobId, marketSegmentJobId)) &&
            (identical(other.marketSegmentJob, marketSegmentJob) || const DeepCollectionEquality().equals(other.marketSegmentJob, marketSegmentJob)) &&
            (identical(other.outDeliveryId, outDeliveryId) || const DeepCollectionEquality().equals(other.outDeliveryId, outDeliveryId)) &&
            (identical(other.outDeliveryDeliveryType, outDeliveryDeliveryType) || const DeepCollectionEquality().equals(other.outDeliveryDeliveryType, outDeliveryDeliveryType)) &&
            (identical(other.outDeliveryRequiredDate, outDeliveryRequiredDate) || const DeepCollectionEquality().equals(other.outDeliveryRequiredDate, outDeliveryRequiredDate)) &&
            (identical(other.outDeliveryRequiredTime, outDeliveryRequiredTime) || const DeepCollectionEquality().equals(other.outDeliveryRequiredTime, outDeliveryRequiredTime)) &&
            (identical(other.outDeliveryTargetShipDate, outDeliveryTargetShipDate) || const DeepCollectionEquality().equals(other.outDeliveryTargetShipDate, outDeliveryTargetShipDate)) &&
            (identical(other.outDeliveryTargetShipTime, outDeliveryTargetShipTime) || const DeepCollectionEquality().equals(other.outDeliveryTargetShipTime, outDeliveryTargetShipTime)) &&
            (identical(other.outDeliveryDirection, outDeliveryDirection) || const DeepCollectionEquality().equals(other.outDeliveryDirection, outDeliveryDirection)) &&
            (identical(other.outDeliveryAddressType, outDeliveryAddressType) || const DeepCollectionEquality().equals(other.outDeliveryAddressType, outDeliveryAddressType)) &&
            (identical(other.outDeliveryFromLocation, outDeliveryFromLocation) || const DeepCollectionEquality().equals(other.outDeliveryFromLocation, outDeliveryFromLocation)) &&
            (identical(other.outDeliveryFromContact, outDeliveryFromContact) || const DeepCollectionEquality().equals(other.outDeliveryFromContact, outDeliveryFromContact)) &&
            (identical(other.outDeliveryFromContactPhone, outDeliveryFromContactPhone) || const DeepCollectionEquality().equals(other.outDeliveryFromContactPhone, outDeliveryFromContactPhone)) &&
            (identical(other.outDeliveryFromAlternateContact, outDeliveryFromAlternateContact) || const DeepCollectionEquality().equals(other.outDeliveryFromAlternateContact, outDeliveryFromAlternateContact)) &&
            (identical(other.outDeliveryFromAlternateContactPhone, outDeliveryFromAlternateContactPhone) || const DeepCollectionEquality().equals(other.outDeliveryFromAlternateContactPhone, outDeliveryFromAlternateContactPhone)) &&
            (identical(other.outDeliveryFromAttention, outDeliveryFromAttention) || const DeepCollectionEquality().equals(other.outDeliveryFromAttention, outDeliveryFromAttention)) &&
            (identical(other.outDeliveryFromAddress1, outDeliveryFromAddress1) || const DeepCollectionEquality().equals(other.outDeliveryFromAddress1, outDeliveryFromAddress1)) &&
            (identical(other.outDeliveryFromAdd2ress, outDeliveryFromAdd2ress) || const DeepCollectionEquality().equals(other.outDeliveryFromAdd2ress, outDeliveryFromAdd2ress)) &&
            (identical(other.outDeliveryFromCity, outDeliveryFromCity) || const DeepCollectionEquality().equals(other.outDeliveryFromCity, outDeliveryFromCity)) &&
            (identical(other.outDeliveryFromState, outDeliveryFromState) || const DeepCollectionEquality().equals(other.outDeliveryFromState, outDeliveryFromState)) &&
            (identical(other.outDeliveryFromZipCode, outDeliveryFromZipCode) || const DeepCollectionEquality().equals(other.outDeliveryFromZipCode, outDeliveryFromZipCode)) &&
            (identical(other.outDeliveryFromCountry, outDeliveryFromCountry) || const DeepCollectionEquality().equals(other.outDeliveryFromCountry, outDeliveryFromCountry)) &&
            (identical(other.outDeliveryFromCountryId, outDeliveryFromCountryId) || const DeepCollectionEquality().equals(other.outDeliveryFromCountryId, outDeliveryFromCountryId)) &&
            (identical(other.outDeliveryFromCrossStreets, outDeliveryFromCrossStreets) || const DeepCollectionEquality().equals(other.outDeliveryFromCrossStreets, outDeliveryFromCrossStreets)) &&
            (identical(other.outDeliveryToLocation, outDeliveryToLocation) || const DeepCollectionEquality().equals(other.outDeliveryToLocation, outDeliveryToLocation)) &&
            (identical(other.outDeliveryToContact, outDeliveryToContact) || const DeepCollectionEquality().equals(other.outDeliveryToContact, outDeliveryToContact)) &&
            (identical(other.outDeliveryToContactPhone, outDeliveryToContactPhone) || const DeepCollectionEquality().equals(other.outDeliveryToContactPhone, outDeliveryToContactPhone)) &&
            (identical(other.outDeliveryToAlternateContact, outDeliveryToAlternateContact) || const DeepCollectionEquality().equals(other.outDeliveryToAlternateContact, outDeliveryToAlternateContact)) &&
            (identical(other.outDeliveryToAlternateContactPhone, outDeliveryToAlternateContactPhone) || const DeepCollectionEquality().equals(other.outDeliveryToAlternateContactPhone, outDeliveryToAlternateContactPhone)) &&
            (identical(other.outDeliveryToAttention, outDeliveryToAttention) || const DeepCollectionEquality().equals(other.outDeliveryToAttention, outDeliveryToAttention)) &&
            (identical(other.outDeliveryToAddress1, outDeliveryToAddress1) || const DeepCollectionEquality().equals(other.outDeliveryToAddress1, outDeliveryToAddress1)) &&
            (identical(other.outDeliveryToAddress2, outDeliveryToAddress2) || const DeepCollectionEquality().equals(other.outDeliveryToAddress2, outDeliveryToAddress2)) &&
            (identical(other.outDeliveryToCity, outDeliveryToCity) || const DeepCollectionEquality().equals(other.outDeliveryToCity, outDeliveryToCity)) &&
            (identical(other.outDeliveryToState, outDeliveryToState) || const DeepCollectionEquality().equals(other.outDeliveryToState, outDeliveryToState)) &&
            (identical(other.outDeliveryToZipCode, outDeliveryToZipCode) || const DeepCollectionEquality().equals(other.outDeliveryToZipCode, outDeliveryToZipCode)) &&
            (identical(other.outDeliveryToCountryId, outDeliveryToCountryId) || const DeepCollectionEquality().equals(other.outDeliveryToCountryId, outDeliveryToCountryId)) &&
            (identical(other.outDeliveryToCountry, outDeliveryToCountry) || const DeepCollectionEquality().equals(other.outDeliveryToCountry, outDeliveryToCountry)) &&
            (identical(other.outDeliveryToContactFax, outDeliveryToContactFax) || const DeepCollectionEquality().equals(other.outDeliveryToContactFax, outDeliveryToContactFax)) &&
            (identical(other.outDeliveryToCrossStreets, outDeliveryToCrossStreets) || const DeepCollectionEquality().equals(other.outDeliveryToCrossStreets, outDeliveryToCrossStreets)) &&
            (identical(other.outDeliveryDeliveryNotes, outDeliveryDeliveryNotes) || const DeepCollectionEquality().equals(other.outDeliveryDeliveryNotes, outDeliveryDeliveryNotes)) &&
            (identical(other.outDeliveryCarrierId, outDeliveryCarrierId) || const DeepCollectionEquality().equals(other.outDeliveryCarrierId, outDeliveryCarrierId)) &&
            (identical(other.outDeliveryCarrier, outDeliveryCarrier) || const DeepCollectionEquality().equals(other.outDeliveryCarrier, outDeliveryCarrier)) &&
            (identical(other.outDeliveryCarrierAccount, outDeliveryCarrierAccount) || const DeepCollectionEquality().equals(other.outDeliveryCarrierAccount, outDeliveryCarrierAccount)) &&
            (identical(other.outDeliveryShipViaId, outDeliveryShipViaId) || const DeepCollectionEquality().equals(other.outDeliveryShipViaId, outDeliveryShipViaId)) &&
            (identical(other.outDeliveryShipVia, outDeliveryShipVia) || const DeepCollectionEquality().equals(other.outDeliveryShipVia, outDeliveryShipVia)) &&
            (identical(other.outDeliveryInvoiceId, outDeliveryInvoiceId) || const DeepCollectionEquality().equals(other.outDeliveryInvoiceId, outDeliveryInvoiceId)) &&
            (identical(other.outDeliveryVendorInvoiceId, outDeliveryVendorInvoiceId) || const DeepCollectionEquality().equals(other.outDeliveryVendorInvoiceId, outDeliveryVendorInvoiceId)) &&
            (identical(other.outDeliveryEstimatedFreight, outDeliveryEstimatedFreight) || const DeepCollectionEquality().equals(other.outDeliveryEstimatedFreight, outDeliveryEstimatedFreight)) &&
            (identical(other.outDeliveryFreightInvoiceAmount, outDeliveryFreightInvoiceAmount) || const DeepCollectionEquality().equals(other.outDeliveryFreightInvoiceAmount, outDeliveryFreightInvoiceAmount)) &&
            (identical(other.outDeliveryChargeType, outDeliveryChargeType) || const DeepCollectionEquality().equals(other.outDeliveryChargeType, outDeliveryChargeType)) &&
            (identical(other.outDeliveryFreightTrackingNumber, outDeliveryFreightTrackingNumber) || const DeepCollectionEquality().equals(other.outDeliveryFreightTrackingNumber, outDeliveryFreightTrackingNumber)) &&
            (identical(other.outDeliveryFreightTrackingUrl, outDeliveryFreightTrackingUrl) || const DeepCollectionEquality().equals(other.outDeliveryFreightTrackingUrl, outDeliveryFreightTrackingUrl)) &&
            (identical(other.outDeliveryPackageCode, outDeliveryPackageCode) || const DeepCollectionEquality().equals(other.outDeliveryPackageCode, outDeliveryPackageCode)) &&
            (identical(other.outDeliveryBillPoFreightOnOrder, outDeliveryBillPoFreightOnOrder) || const DeepCollectionEquality().equals(other.outDeliveryBillPoFreightOnOrder, outDeliveryBillPoFreightOnOrder)) &&
            (identical(other.outDeliveryOnlineOrderNumber, outDeliveryOnlineOrderNumber) || const DeepCollectionEquality().equals(other.outDeliveryOnlineOrderNumber, outDeliveryOnlineOrderNumber)) &&
            (identical(other.outDeliveryToVenue, outDeliveryToVenue) || const DeepCollectionEquality().equals(other.outDeliveryToVenue, outDeliveryToVenue)) &&
            (identical(other.outDeliveryToVenueId, outDeliveryToVenueId) || const DeepCollectionEquality().equals(other.outDeliveryToVenueId, outDeliveryToVenueId)) &&
            (identical(other.outDeliveryToWarehouse, outDeliveryToWarehouse) || const DeepCollectionEquality().equals(other.outDeliveryToWarehouse, outDeliveryToWarehouse)) &&
            (identical(other.outDeliveryToWarehouseId, outDeliveryToWarehouseId) || const DeepCollectionEquality().equals(other.outDeliveryToWarehouseId, outDeliveryToWarehouseId)) &&
            (identical(other.outDeliveryDateStamp, outDeliveryDateStamp) || const DeepCollectionEquality().equals(other.outDeliveryDateStamp, outDeliveryDateStamp)) &&
            (identical(other.inDeliveryId, inDeliveryId) || const DeepCollectionEquality().equals(other.inDeliveryId, inDeliveryId)) &&
            (identical(other.inDeliveryDeliveryType, inDeliveryDeliveryType) || const DeepCollectionEquality().equals(other.inDeliveryDeliveryType, inDeliveryDeliveryType)) &&
            (identical(other.inDeliveryRequiredDate, inDeliveryRequiredDate) || const DeepCollectionEquality().equals(other.inDeliveryRequiredDate, inDeliveryRequiredDate)) &&
            (identical(other.inDeliveryRequiredTime, inDeliveryRequiredTime) || const DeepCollectionEquality().equals(other.inDeliveryRequiredTime, inDeliveryRequiredTime)) &&
            (identical(other.inDeliveryTargetShipDate, inDeliveryTargetShipDate) || const DeepCollectionEquality().equals(other.inDeliveryTargetShipDate, inDeliveryTargetShipDate)) &&
            (identical(other.inDeliveryTargetShipTime, inDeliveryTargetShipTime) || const DeepCollectionEquality().equals(other.inDeliveryTargetShipTime, inDeliveryTargetShipTime)) &&
            (identical(other.inDeliveryDirection, inDeliveryDirection) || const DeepCollectionEquality().equals(other.inDeliveryDirection, inDeliveryDirection)) &&
            (identical(other.inDeliveryAddressType, inDeliveryAddressType) || const DeepCollectionEquality().equals(other.inDeliveryAddressType, inDeliveryAddressType)) &&
            (identical(other.inDeliveryFromLocation, inDeliveryFromLocation) || const DeepCollectionEquality().equals(other.inDeliveryFromLocation, inDeliveryFromLocation)) &&
            (identical(other.inDeliveryFromContact, inDeliveryFromContact) || const DeepCollectionEquality().equals(other.inDeliveryFromContact, inDeliveryFromContact)) &&
            (identical(other.inDeliveryFromContactPhone, inDeliveryFromContactPhone) || const DeepCollectionEquality().equals(other.inDeliveryFromContactPhone, inDeliveryFromContactPhone)) &&
            (identical(other.inDeliveryFromAlternateContact, inDeliveryFromAlternateContact) || const DeepCollectionEquality().equals(other.inDeliveryFromAlternateContact, inDeliveryFromAlternateContact)) &&
            (identical(other.inDeliveryFromAlternateContactPhone, inDeliveryFromAlternateContactPhone) || const DeepCollectionEquality().equals(other.inDeliveryFromAlternateContactPhone, inDeliveryFromAlternateContactPhone)) &&
            (identical(other.inDeliveryFromAttention, inDeliveryFromAttention) || const DeepCollectionEquality().equals(other.inDeliveryFromAttention, inDeliveryFromAttention)) &&
            (identical(other.inDeliveryFromAddress1, inDeliveryFromAddress1) || const DeepCollectionEquality().equals(other.inDeliveryFromAddress1, inDeliveryFromAddress1)) &&
            (identical(other.inDeliveryFromAdd2ress, inDeliveryFromAdd2ress) || const DeepCollectionEquality().equals(other.inDeliveryFromAdd2ress, inDeliveryFromAdd2ress)) &&
            (identical(other.inDeliveryFromCity, inDeliveryFromCity) || const DeepCollectionEquality().equals(other.inDeliveryFromCity, inDeliveryFromCity)) &&
            (identical(other.inDeliveryFromState, inDeliveryFromState) || const DeepCollectionEquality().equals(other.inDeliveryFromState, inDeliveryFromState)) &&
            (identical(other.inDeliveryFromZipCode, inDeliveryFromZipCode) || const DeepCollectionEquality().equals(other.inDeliveryFromZipCode, inDeliveryFromZipCode)) &&
            (identical(other.inDeliveryFromCountry, inDeliveryFromCountry) || const DeepCollectionEquality().equals(other.inDeliveryFromCountry, inDeliveryFromCountry)) &&
            (identical(other.inDeliveryFromCountryId, inDeliveryFromCountryId) || const DeepCollectionEquality().equals(other.inDeliveryFromCountryId, inDeliveryFromCountryId)) &&
            (identical(other.inDeliveryFromCrossStreets, inDeliveryFromCrossStreets) || const DeepCollectionEquality().equals(other.inDeliveryFromCrossStreets, inDeliveryFromCrossStreets)) &&
            (identical(other.inDeliveryToLocation, inDeliveryToLocation) || const DeepCollectionEquality().equals(other.inDeliveryToLocation, inDeliveryToLocation)) &&
            (identical(other.inDeliveryToContact, inDeliveryToContact) || const DeepCollectionEquality().equals(other.inDeliveryToContact, inDeliveryToContact)) &&
            (identical(other.inDeliveryToContactPhone, inDeliveryToContactPhone) || const DeepCollectionEquality().equals(other.inDeliveryToContactPhone, inDeliveryToContactPhone)) &&
            (identical(other.inDeliveryToAlternateContact, inDeliveryToAlternateContact) || const DeepCollectionEquality().equals(other.inDeliveryToAlternateContact, inDeliveryToAlternateContact)) &&
            (identical(other.inDeliveryToAlternateContactPhone, inDeliveryToAlternateContactPhone) || const DeepCollectionEquality().equals(other.inDeliveryToAlternateContactPhone, inDeliveryToAlternateContactPhone)) &&
            (identical(other.inDeliveryToAttention, inDeliveryToAttention) || const DeepCollectionEquality().equals(other.inDeliveryToAttention, inDeliveryToAttention)) &&
            (identical(other.inDeliveryToAddress1, inDeliveryToAddress1) || const DeepCollectionEquality().equals(other.inDeliveryToAddress1, inDeliveryToAddress1)) &&
            (identical(other.inDeliveryToAddress2, inDeliveryToAddress2) || const DeepCollectionEquality().equals(other.inDeliveryToAddress2, inDeliveryToAddress2)) &&
            (identical(other.inDeliveryToCity, inDeliveryToCity) || const DeepCollectionEquality().equals(other.inDeliveryToCity, inDeliveryToCity)) &&
            (identical(other.inDeliveryToState, inDeliveryToState) || const DeepCollectionEquality().equals(other.inDeliveryToState, inDeliveryToState)) &&
            (identical(other.inDeliveryToZipCode, inDeliveryToZipCode) || const DeepCollectionEquality().equals(other.inDeliveryToZipCode, inDeliveryToZipCode)) &&
            (identical(other.inDeliveryToCountryId, inDeliveryToCountryId) || const DeepCollectionEquality().equals(other.inDeliveryToCountryId, inDeliveryToCountryId)) &&
            (identical(other.inDeliveryToCountry, inDeliveryToCountry) || const DeepCollectionEquality().equals(other.inDeliveryToCountry, inDeliveryToCountry)) &&
            (identical(other.inDeliveryToContactFax, inDeliveryToContactFax) || const DeepCollectionEquality().equals(other.inDeliveryToContactFax, inDeliveryToContactFax)) &&
            (identical(other.inDeliveryToCrossStreets, inDeliveryToCrossStreets) || const DeepCollectionEquality().equals(other.inDeliveryToCrossStreets, inDeliveryToCrossStreets)) &&
            (identical(other.inDeliveryDeliveryNotes, inDeliveryDeliveryNotes) || const DeepCollectionEquality().equals(other.inDeliveryDeliveryNotes, inDeliveryDeliveryNotes)) &&
            (identical(other.inDeliveryCarrierId, inDeliveryCarrierId) || const DeepCollectionEquality().equals(other.inDeliveryCarrierId, inDeliveryCarrierId)) &&
            (identical(other.inDeliveryCarrier, inDeliveryCarrier) || const DeepCollectionEquality().equals(other.inDeliveryCarrier, inDeliveryCarrier)) &&
            (identical(other.inDeliveryCarrierAccount, inDeliveryCarrierAccount) || const DeepCollectionEquality().equals(other.inDeliveryCarrierAccount, inDeliveryCarrierAccount)) &&
            (identical(other.inDeliveryShipViaId, inDeliveryShipViaId) || const DeepCollectionEquality().equals(other.inDeliveryShipViaId, inDeliveryShipViaId)) &&
            (identical(other.inDeliveryShipVia, inDeliveryShipVia) || const DeepCollectionEquality().equals(other.inDeliveryShipVia, inDeliveryShipVia)) &&
            (identical(other.inDeliveryInvoiceId, inDeliveryInvoiceId) || const DeepCollectionEquality().equals(other.inDeliveryInvoiceId, inDeliveryInvoiceId)) &&
            (identical(other.inDeliveryVendorInvoiceId, inDeliveryVendorInvoiceId) || const DeepCollectionEquality().equals(other.inDeliveryVendorInvoiceId, inDeliveryVendorInvoiceId)) &&
            (identical(other.inDeliveryEstimatedFreight, inDeliveryEstimatedFreight) || const DeepCollectionEquality().equals(other.inDeliveryEstimatedFreight, inDeliveryEstimatedFreight)) &&
            (identical(other.inDeliveryFreightInvoiceAmount, inDeliveryFreightInvoiceAmount) || const DeepCollectionEquality().equals(other.inDeliveryFreightInvoiceAmount, inDeliveryFreightInvoiceAmount)) &&
            (identical(other.inDeliveryChargeType, inDeliveryChargeType) || const DeepCollectionEquality().equals(other.inDeliveryChargeType, inDeliveryChargeType)) &&
            (identical(other.inDeliveryFreightTrackingNumber, inDeliveryFreightTrackingNumber) || const DeepCollectionEquality().equals(other.inDeliveryFreightTrackingNumber, inDeliveryFreightTrackingNumber)) &&
            (identical(other.inDeliveryFreightTrackingUrl, inDeliveryFreightTrackingUrl) || const DeepCollectionEquality().equals(other.inDeliveryFreightTrackingUrl, inDeliveryFreightTrackingUrl)) &&
            (identical(other.inDeliveryPackageCode, inDeliveryPackageCode) || const DeepCollectionEquality().equals(other.inDeliveryPackageCode, inDeliveryPackageCode)) &&
            (identical(other.inDeliveryBillPoFreightOnOrder, inDeliveryBillPoFreightOnOrder) || const DeepCollectionEquality().equals(other.inDeliveryBillPoFreightOnOrder, inDeliveryBillPoFreightOnOrder)) &&
            (identical(other.inDeliveryOnlineOrderNumber, inDeliveryOnlineOrderNumber) || const DeepCollectionEquality().equals(other.inDeliveryOnlineOrderNumber, inDeliveryOnlineOrderNumber)) &&
            (identical(other.inDeliveryOnlineOrderStatus, inDeliveryOnlineOrderStatus) || const DeepCollectionEquality().equals(other.inDeliveryOnlineOrderStatus, inDeliveryOnlineOrderStatus)) &&
            (identical(other.inDeliveryToVenue, inDeliveryToVenue) || const DeepCollectionEquality().equals(other.inDeliveryToVenue, inDeliveryToVenue)) &&
            (identical(other.inDeliveryToVenueId, inDeliveryToVenueId) || const DeepCollectionEquality().equals(other.inDeliveryToVenueId, inDeliveryToVenueId)) &&
            (identical(other.inDeliveryToWarehouse, inDeliveryToWarehouse) || const DeepCollectionEquality().equals(other.inDeliveryToWarehouse, inDeliveryToWarehouse)) &&
            (identical(other.inDeliveryToWarehouseId, inDeliveryToWarehouseId) || const DeepCollectionEquality().equals(other.inDeliveryToWarehouseId, inDeliveryToWarehouseId)) &&
            (identical(other.inDeliveryDateStamp, inDeliveryDateStamp) || const DeepCollectionEquality().equals(other.inDeliveryDateStamp, inDeliveryDateStamp)) &&
            (identical(other.rentalDaysPerWeek, rentalDaysPerWeek) || const DeepCollectionEquality().equals(other.rentalDaysPerWeek, rentalDaysPerWeek)) &&
            (identical(other.rentalDiscountPercent, rentalDiscountPercent) || const DeepCollectionEquality().equals(other.rentalDiscountPercent, rentalDiscountPercent)) &&
            (identical(other.weeklyRentalTotal, weeklyRentalTotal) || const DeepCollectionEquality().equals(other.weeklyRentalTotal, weeklyRentalTotal)) &&
            (identical(other.monthlyRentalTotal, monthlyRentalTotal) || const DeepCollectionEquality().equals(other.monthlyRentalTotal, monthlyRentalTotal)) &&
            (identical(other.periodRentalTotal, periodRentalTotal) || const DeepCollectionEquality().equals(other.periodRentalTotal, periodRentalTotal)) &&
            (identical(other.weeklyRentalTotalIncludesTax, weeklyRentalTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklyRentalTotalIncludesTax, weeklyRentalTotalIncludesTax)) &&
            (identical(other.monthlyRentalTotalIncludesTax, monthlyRentalTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlyRentalTotalIncludesTax, monthlyRentalTotalIncludesTax)) &&
            (identical(other.periodRentalTotalIncludesTax, periodRentalTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodRentalTotalIncludesTax, periodRentalTotalIncludesTax)) &&
            (identical(other.billLockedTotal, billLockedTotal) || const DeepCollectionEquality().equals(other.billLockedTotal, billLockedTotal)) &&
            (identical(other.salesDiscountPercent, salesDiscountPercent) || const DeepCollectionEquality().equals(other.salesDiscountPercent, salesDiscountPercent)) &&
            (identical(other.salesTotal, salesTotal) || const DeepCollectionEquality().equals(other.salesTotal, salesTotal)) &&
            (identical(other.salesTotalIncludesTax, salesTotalIncludesTax) || const DeepCollectionEquality().equals(other.salesTotalIncludesTax, salesTotalIncludesTax)) &&
            (identical(other.partsDiscountPercent, partsDiscountPercent) || const DeepCollectionEquality().equals(other.partsDiscountPercent, partsDiscountPercent)) &&
            (identical(other.partsTotal, partsTotal) || const DeepCollectionEquality().equals(other.partsTotal, partsTotal)) &&
            (identical(other.partsTotalIncludesTax, partsTotalIncludesTax) || const DeepCollectionEquality().equals(other.partsTotalIncludesTax, partsTotalIncludesTax)) &&
            (identical(other.spaceDaysPerWeek, spaceDaysPerWeek) || const DeepCollectionEquality().equals(other.spaceDaysPerWeek, spaceDaysPerWeek)) &&
            (identical(other.spaceDiscountPercent, spaceDiscountPercent) || const DeepCollectionEquality().equals(other.spaceDiscountPercent, spaceDiscountPercent)) &&
            (identical(other.spaceSplitPercent, spaceSplitPercent) || const DeepCollectionEquality().equals(other.spaceSplitPercent, spaceSplitPercent)) &&
            (identical(other.weeklySpaceTotal, weeklySpaceTotal) || const DeepCollectionEquality().equals(other.weeklySpaceTotal, weeklySpaceTotal)) &&
            (identical(other.monthlySpaceTotal, monthlySpaceTotal) || const DeepCollectionEquality().equals(other.monthlySpaceTotal, monthlySpaceTotal)) &&
            (identical(other.periodSpaceTotal, periodSpaceTotal) || const DeepCollectionEquality().equals(other.periodSpaceTotal, periodSpaceTotal)) &&
            (identical(other.weeklySpaceTotalIncludesTax, weeklySpaceTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklySpaceTotalIncludesTax, weeklySpaceTotalIncludesTax)) &&
            (identical(other.monthlySpaceTotalIncludesTax, monthlySpaceTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlySpaceTotalIncludesTax, monthlySpaceTotalIncludesTax)) &&
            (identical(other.periodSpaceTotalIncludesTax, periodSpaceTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodSpaceTotalIncludesTax, periodSpaceTotalIncludesTax)) &&
            (identical(other.vehicleDaysPerWeek, vehicleDaysPerWeek) || const DeepCollectionEquality().equals(other.vehicleDaysPerWeek, vehicleDaysPerWeek)) &&
            (identical(other.vehicleDiscountPercent, vehicleDiscountPercent) || const DeepCollectionEquality().equals(other.vehicleDiscountPercent, vehicleDiscountPercent)) &&
            (identical(other.weeklyVehicleTotal, weeklyVehicleTotal) || const DeepCollectionEquality().equals(other.weeklyVehicleTotal, weeklyVehicleTotal)) &&
            (identical(other.monthlyVehicleTotal, monthlyVehicleTotal) || const DeepCollectionEquality().equals(other.monthlyVehicleTotal, monthlyVehicleTotal)) &&
            (identical(other.periodVehicleTotal, periodVehicleTotal) || const DeepCollectionEquality().equals(other.periodVehicleTotal, periodVehicleTotal)) &&
            (identical(other.weeklyVehicleTotalIncludesTax, weeklyVehicleTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklyVehicleTotalIncludesTax, weeklyVehicleTotalIncludesTax)) &&
            (identical(other.monthlyVehicleTotalIncludesTax, monthlyVehicleTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlyVehicleTotalIncludesTax, monthlyVehicleTotalIncludesTax)) &&
            (identical(other.periodVehicleTotalIncludesTax, periodVehicleTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodVehicleTotalIncludesTax, periodVehicleTotalIncludesTax)) &&
            (identical(other.miscDiscountPercent, miscDiscountPercent) || const DeepCollectionEquality().equals(other.miscDiscountPercent, miscDiscountPercent)) &&
            (identical(other.weeklyMiscTotal, weeklyMiscTotal) || const DeepCollectionEquality().equals(other.weeklyMiscTotal, weeklyMiscTotal)) &&
            (identical(other.monthlyMiscTotal, monthlyMiscTotal) || const DeepCollectionEquality().equals(other.monthlyMiscTotal, monthlyMiscTotal)) &&
            (identical(other.periodMiscTotal, periodMiscTotal) || const DeepCollectionEquality().equals(other.periodMiscTotal, periodMiscTotal)) &&
            (identical(other.weeklyMiscTotalIncludesTax, weeklyMiscTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklyMiscTotalIncludesTax, weeklyMiscTotalIncludesTax)) &&
            (identical(other.monthlyMiscTotalIncludesTax, monthlyMiscTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlyMiscTotalIncludesTax, monthlyMiscTotalIncludesTax)) &&
            (identical(other.periodMiscTotalIncludesTax, periodMiscTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodMiscTotalIncludesTax, periodMiscTotalIncludesTax)) &&
            (identical(other.laborDiscountPercent, laborDiscountPercent) || const DeepCollectionEquality().equals(other.laborDiscountPercent, laborDiscountPercent)) &&
            (identical(other.weeklyLaborTotal, weeklyLaborTotal) || const DeepCollectionEquality().equals(other.weeklyLaborTotal, weeklyLaborTotal)) &&
            (identical(other.monthlyLaborTotal, monthlyLaborTotal) || const DeepCollectionEquality().equals(other.monthlyLaborTotal, monthlyLaborTotal)) &&
            (identical(other.periodLaborTotal, periodLaborTotal) || const DeepCollectionEquality().equals(other.periodLaborTotal, periodLaborTotal)) &&
            (identical(other.weeklyLaborTotalIncludesTax, weeklyLaborTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklyLaborTotalIncludesTax, weeklyLaborTotalIncludesTax)) &&
            (identical(other.monthlyLaborTotalIncludesTax, monthlyLaborTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlyLaborTotalIncludesTax, monthlyLaborTotalIncludesTax)) &&
            (identical(other.periodLaborTotalIncludesTax, periodLaborTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodLaborTotalIncludesTax, periodLaborTotalIncludesTax)) &&
            (identical(other.rentalSaleDiscountPercent, rentalSaleDiscountPercent) || const DeepCollectionEquality().equals(other.rentalSaleDiscountPercent, rentalSaleDiscountPercent)) &&
            (identical(other.rentalSaleTotal, rentalSaleTotal) || const DeepCollectionEquality().equals(other.rentalSaleTotal, rentalSaleTotal)) &&
            (identical(other.rentalSaleTotalIncludesTax, rentalSaleTotalIncludesTax) || const DeepCollectionEquality().equals(other.rentalSaleTotalIncludesTax, rentalSaleTotalIncludesTax)) &&
            (identical(other.lossAndDamageDiscountPercent, lossAndDamageDiscountPercent) || const DeepCollectionEquality().equals(other.lossAndDamageDiscountPercent, lossAndDamageDiscountPercent)) &&
            (identical(other.lossAndDamageTotal, lossAndDamageTotal) || const DeepCollectionEquality().equals(other.lossAndDamageTotal, lossAndDamageTotal)) &&
            (identical(other.lossAndDamageTotalIncludesTax, lossAndDamageTotalIncludesTax) || const DeepCollectionEquality().equals(other.lossAndDamageTotalIncludesTax, lossAndDamageTotalIncludesTax)) &&
            (identical(other.combinedDaysPerWeek, combinedDaysPerWeek) || const DeepCollectionEquality().equals(other.combinedDaysPerWeek, combinedDaysPerWeek)) &&
            (identical(other.combinedDiscountPercent, combinedDiscountPercent) || const DeepCollectionEquality().equals(other.combinedDiscountPercent, combinedDiscountPercent)) &&
            (identical(other.weeklyCombinedTotal, weeklyCombinedTotal) || const DeepCollectionEquality().equals(other.weeklyCombinedTotal, weeklyCombinedTotal)) &&
            (identical(other.monthlyCombinedTotal, monthlyCombinedTotal) || const DeepCollectionEquality().equals(other.monthlyCombinedTotal, monthlyCombinedTotal)) &&
            (identical(other.periodCombinedTotal, periodCombinedTotal) || const DeepCollectionEquality().equals(other.periodCombinedTotal, periodCombinedTotal)) &&
            (identical(other.weeklyCombinedTotalIncludesTax, weeklyCombinedTotalIncludesTax) || const DeepCollectionEquality().equals(other.weeklyCombinedTotalIncludesTax, weeklyCombinedTotalIncludesTax)) &&
            (identical(other.monthlyCombinedTotalIncludesTax, monthlyCombinedTotalIncludesTax) || const DeepCollectionEquality().equals(other.monthlyCombinedTotalIncludesTax, monthlyCombinedTotalIncludesTax)) &&
            (identical(other.periodCombinedTotalIncludesTax, periodCombinedTotalIncludesTax) || const DeepCollectionEquality().equals(other.periodCombinedTotalIncludesTax, periodCombinedTotalIncludesTax)) &&
            (identical(other.disableEditingRentalRate, disableEditingRentalRate) || const DeepCollectionEquality().equals(other.disableEditingRentalRate, disableEditingRentalRate)) &&
            (identical(other.disableEditingSalesRate, disableEditingSalesRate) || const DeepCollectionEquality().equals(other.disableEditingSalesRate, disableEditingSalesRate)) &&
            (identical(other.disableEditingMiscellaneousRate, disableEditingMiscellaneousRate) || const DeepCollectionEquality().equals(other.disableEditingMiscellaneousRate, disableEditingMiscellaneousRate)) &&
            (identical(other.disableEditingLaborRate, disableEditingLaborRate) || const DeepCollectionEquality().equals(other.disableEditingLaborRate, disableEditingLaborRate)) &&
            (identical(other.disableEditingRentalSaleRate, disableEditingRentalSaleRate) || const DeepCollectionEquality().equals(other.disableEditingRentalSaleRate, disableEditingRentalSaleRate)) &&
            (identical(other.disableEditingLossAndDamageRate, disableEditingLossAndDamageRate) || const DeepCollectionEquality().equals(other.disableEditingLossAndDamageRate, disableEditingLossAndDamageRate)) &&
            (identical(other.rentalExtendedTotal, rentalExtendedTotal) || const DeepCollectionEquality().equals(other.rentalExtendedTotal, rentalExtendedTotal)) &&
            (identical(other.salesExtendedTotal, salesExtendedTotal) || const DeepCollectionEquality().equals(other.salesExtendedTotal, salesExtendedTotal)) &&
            (identical(other.laborExtendedTotal, laborExtendedTotal) || const DeepCollectionEquality().equals(other.laborExtendedTotal, laborExtendedTotal)) &&
            (identical(other.miscellaneousExtendedTotal, miscellaneousExtendedTotal) || const DeepCollectionEquality().equals(other.miscellaneousExtendedTotal, miscellaneousExtendedTotal)) &&
            (identical(other.rentalSaleExtendedTotal, rentalSaleExtendedTotal) || const DeepCollectionEquality().equals(other.rentalSaleExtendedTotal, rentalSaleExtendedTotal)) &&
            (identical(other.lossAndDamageExtendedTotal, lossAndDamageExtendedTotal) || const DeepCollectionEquality().equals(other.lossAndDamageExtendedTotal, lossAndDamageExtendedTotal)) &&
            (identical(other.hasNotes, hasNotes) || const DeepCollectionEquality().equals(other.hasNotes, hasNotes)) &&
            (identical(other.hasDocuments, hasDocuments) || const DeepCollectionEquality().equals(other.hasDocuments, hasDocuments)) &&
            (identical(other.hasEmailHistory, hasEmailHistory) || const DeepCollectionEquality().equals(other.hasEmailHistory, hasEmailHistory)) &&
            (identical(other.hasContacts, hasContacts) || const DeepCollectionEquality().equals(other.hasContacts, hasContacts)) &&
            (identical(other.hasSubPurchaseOrders, hasSubPurchaseOrders) || const DeepCollectionEquality().equals(other.hasSubPurchaseOrders, hasSubPurchaseOrders)) &&
            (identical(other.hasPickLists, hasPickLists) || const DeepCollectionEquality().equals(other.hasPickLists, hasPickLists)) &&
            (identical(other.hasContracts, hasContracts) || const DeepCollectionEquality().equals(other.hasContracts, hasContracts)) &&
            (identical(other.hasSuspendedContracts, hasSuspendedContracts) || const DeepCollectionEquality().equals(other.hasSuspendedContracts, hasSuspendedContracts)) &&
            (identical(other.hasMultiOrderContracts, hasMultiOrderContracts) || const DeepCollectionEquality().equals(other.hasMultiOrderContracts, hasMultiOrderContracts)) &&
            (identical(other.hasInvoices, hasInvoices) || const DeepCollectionEquality().equals(other.hasInvoices, hasInvoices)) &&
            (identical(other.hasBillingWorksheets, hasBillingWorksheets) || const DeepCollectionEquality().equals(other.hasBillingWorksheets, hasBillingWorksheets)) &&
            (identical(other.hasMultiOrderInvoices, hasMultiOrderInvoices) || const DeepCollectionEquality().equals(other.hasMultiOrderInvoices, hasMultiOrderInvoices)) &&
            (identical(other.totalReplacementCost, totalReplacementCost) || const DeepCollectionEquality().equals(other.totalReplacementCost, totalReplacementCost)) &&
            (identical(other.presentationLayerId, presentationLayerId) || const DeepCollectionEquality().equals(other.presentationLayerId, presentationLayerId)) &&
            (identical(other.presentationLayer, presentationLayer) || const DeepCollectionEquality().equals(other.presentationLayer, presentationLayer)) &&
            (identical(other.isManualSort, isManualSort) || const DeepCollectionEquality().equals(other.isManualSort, isManualSort)) &&
            (identical(other.quoteOrderTitle, quoteOrderTitle) || const DeepCollectionEquality().equals(other.quoteOrderTitle, quoteOrderTitle)) &&
            (identical(other.unassignedSubs, unassignedSubs) || const DeepCollectionEquality().equals(other.unassignedSubs, unassignedSubs)) &&
            (identical(other.nonTaxable, nonTaxable) || const DeepCollectionEquality().equals(other.nonTaxable, nonTaxable)) &&
            (identical(other.enableProjects, enableProjects) || const DeepCollectionEquality().equals(other.enableProjects, enableProjects)) &&
            (identical(other.projectId, projectId) || const DeepCollectionEquality().equals(other.projectId, projectId)) &&
            (identical(other.projectNumber, projectNumber) || const DeepCollectionEquality().equals(other.projectNumber, projectNumber)) &&
            (identical(other.project, project) || const DeepCollectionEquality().equals(other.project, project)) &&
            (identical(other.projectDrawingsId, projectDrawingsId) || const DeepCollectionEquality().equals(other.projectDrawingsId, projectDrawingsId)) &&
            (identical(other.projectDrawings, projectDrawings) || const DeepCollectionEquality().equals(other.projectDrawings, projectDrawings)) &&
            (identical(other.projectItemsOrderedId, projectItemsOrderedId) || const DeepCollectionEquality().equals(other.projectItemsOrderedId, projectItemsOrderedId)) &&
            (identical(other.projectItemsOrdered, projectItemsOrdered) || const DeepCollectionEquality().equals(other.projectItemsOrdered, projectItemsOrdered)) &&
            (identical(other.projectDropShipId, projectDropShipId) || const DeepCollectionEquality().equals(other.projectDropShipId, projectDropShipId)) &&
            (identical(other.projectDropShip, projectDropShip) || const DeepCollectionEquality().equals(other.projectDropShip, projectDropShip)) &&
            (identical(other.projectAsBuildId, projectAsBuildId) || const DeepCollectionEquality().equals(other.projectAsBuildId, projectAsBuildId)) &&
            (identical(other.projectAsBuild, projectAsBuild) || const DeepCollectionEquality().equals(other.projectAsBuild, projectAsBuild)) &&
            (identical(other.projectCommissioningId, projectCommissioningId) || const DeepCollectionEquality().equals(other.projectCommissioningId, projectCommissioningId)) &&
            (identical(other.projectCommissioning, projectCommissioning) || const DeepCollectionEquality().equals(other.projectCommissioning, projectCommissioning)) &&
            (identical(other.projectDepositId, projectDepositId) || const DeepCollectionEquality().equals(other.projectDepositId, projectDepositId)) &&
            (identical(other.projectDeposit, projectDeposit) || const DeepCollectionEquality().equals(other.projectDeposit, projectDeposit)) &&
            (identical(other.inputByUserId, inputByUserId) || const DeepCollectionEquality().equals(other.inputByUserId, inputByUserId)) &&
            (identical(other.modifiedByUserId, modifiedByUserId) || const DeepCollectionEquality().equals(other.modifiedByUserId, modifiedByUserId)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesAgentQuoteQuoteExtension
    on WebApiModulesAgentQuoteQuote {
  WebApiModulesAgentQuoteQuote copyWith(
      {String? quoteId,
      String? quoteNumber,
      String? quoteDate,
      int? versionNumber,
      String? convertedToOrderId,
      String? convertedToOrderNumber,
      String? description,
      String? officeLocationId,
      String? officeLocation,
      String? warehouseId,
      String? warehouse,
      String? warehouseCode,
      String? departmentId,
      String? department,
      String? customerId,
      String? customer,
      String? customerNumber,
      String? dealId,
      String? deal,
      String? dealNumber,
      String? rateType,
      String? rateTypeDisplay,
      String? agentId,
      String? agent,
      String? projectManagerId,
      String? projectManager,
      bool? rental,
      bool? sales,
      bool? miscellaneous,
      bool? labor,
      bool? facilities,
      bool? transportation,
      bool? rentalSale,
      bool? lossAndDamage,
      bool? repair,
      bool? hasRentalItem,
      bool? hasSalesItem,
      bool? hasMiscellaneousItem,
      bool? hasLaborItem,
      bool? hasFacilitiesItem,
      bool? hasLossAndDamageItem,
      bool? hasRentalSaleItem,
      bool? hasRepair,
      List<WebApiModulesHomeControlsOrderDatesOrderDates>?
          activityDatesAndTimes,
      String? pickDate,
      String? pickTime,
      String? estimatedStartDate,
      String? estimatedStartTime,
      String? estimatedStopDate,
      String? estimatedStopTime,
      String? pickUpDate,
      String? pickUpTime,
      String? prepDate,
      String? prepTime,
      String? loadInDate,
      String? loadInTime,
      String? strikeDate,
      String? strikeTime,
      String? testDate,
      String? testTime,
      String? orderTypeId,
      String? orderType,
      bool? orderTypeCombineActivityTabs,
      bool? flatPo,
      bool? pendingPo,
      String? poNumber,
      double? poAmount,
      String? location,
      String? orderLocationId,
      String? orderLocation,
      String? referenceNumber,
      double? total,
      String? status,
      String? statusDate,
      String? poApprovalStatusId,
      bool? lockBillingDates,
      bool? specifyBillingDatesByType,
      String? rentalBillingStartDate,
      String? rentalBillingEndDate,
      String? laborBillingStartDate,
      String? laborBillingEndDate,
      String? miscellaneousBillingStartDate,
      String? miscellaneousBillingEndDate,
      String? facilitiesBillingStartDate,
      String? facilitiesBillingEndDate,
      String? vehicleBillingStartDate,
      String? vehicleBillingEndDate,
      String? delayBillingSearchUntil,
      bool? includePrepFeesInRentalRate,
      String? billingStartDate,
      String? billingEndDate,
      double? billingWeeks,
      double? billingMonths,
      String? determineQuantitiesToBillBasedOn,
      String? billingCycleId,
      String? billingCycle,
      String? billingCycleType,
      String? paymentTermsId,
      String? paymentTerms,
      String? paymentTypeId,
      String? paymentType,
      String? currencyId,
      bool? updateAllRatesToNewCurrency,
      String? confirmUpdateAllRatesToNewCurrency,
      String? currencyCode,
      String? currency,
      String? currencySymbol,
      String? taxOptionId,
      String? taxOption,
      String? tax1Name,
      String? tax2Name,
      String? taxId,
      double? rentalTaxRate1,
      double? salesTaxRate1,
      double? laborTaxRate1,
      double? rentalTaxRate2,
      double? salesTaxRate2,
      double? laborTaxRate2,
      bool? noCharge,
      String? noChargeReason,
      String? printIssuedToAddressFrom,
      String? issuedToName,
      String? issuedToAttention,
      String? issuedToAttention2,
      String? issuedToAddress1,
      String? issuedToAddress2,
      String? issuedToCity,
      String? issuedToState,
      String? issuedToZipCode,
      String? issuedToCountryId,
      String? issuedToCountry,
      bool? billToAddressDifferentFromIssuedToAddress,
      String? billToAddressId,
      String? billToName,
      String? billToAttention,
      String? billToAttention2,
      String? billToAddress1,
      String? billToAddress2,
      String? billToCity,
      String? billToState,
      String? billToZipCode,
      String? billToCountryId,
      String? billToCountry,
      String? discountReasonId,
      String? discountReason,
      bool? requireContactConfirmation,
      bool? includeInBillingAnalysis,
      String? hiatusDiscountFrom,
      bool? roundTripRentals,
      bool? inGroup,
      int? groupNumber,
      int? groupColor,
      double? groupOrderBy,
      String? coverLetterId,
      String? coverLetter,
      String? termsConditionsId,
      String? termsConditions,
      String? outsideSalesRepresentativeId,
      String? outsideSalesRepresentative,
      String? marketTypeId,
      String? marketType,
      String? marketSegmentId,
      String? marketSegment,
      String? marketSegmentJobId,
      String? marketSegmentJob,
      String? outDeliveryId,
      String? outDeliveryDeliveryType,
      String? outDeliveryRequiredDate,
      String? outDeliveryRequiredTime,
      String? outDeliveryTargetShipDate,
      String? outDeliveryTargetShipTime,
      String? outDeliveryDirection,
      String? outDeliveryAddressType,
      String? outDeliveryFromLocation,
      String? outDeliveryFromContact,
      String? outDeliveryFromContactPhone,
      String? outDeliveryFromAlternateContact,
      String? outDeliveryFromAlternateContactPhone,
      String? outDeliveryFromAttention,
      String? outDeliveryFromAddress1,
      String? outDeliveryFromAdd2ress,
      String? outDeliveryFromCity,
      String? outDeliveryFromState,
      String? outDeliveryFromZipCode,
      String? outDeliveryFromCountry,
      String? outDeliveryFromCountryId,
      String? outDeliveryFromCrossStreets,
      String? outDeliveryToLocation,
      String? outDeliveryToContact,
      String? outDeliveryToContactPhone,
      String? outDeliveryToAlternateContact,
      String? outDeliveryToAlternateContactPhone,
      String? outDeliveryToAttention,
      String? outDeliveryToAddress1,
      String? outDeliveryToAddress2,
      String? outDeliveryToCity,
      String? outDeliveryToState,
      String? outDeliveryToZipCode,
      String? outDeliveryToCountryId,
      String? outDeliveryToCountry,
      String? outDeliveryToContactFax,
      String? outDeliveryToCrossStreets,
      String? outDeliveryDeliveryNotes,
      String? outDeliveryCarrierId,
      String? outDeliveryCarrier,
      String? outDeliveryCarrierAccount,
      String? outDeliveryShipViaId,
      String? outDeliveryShipVia,
      String? outDeliveryInvoiceId,
      String? outDeliveryVendorInvoiceId,
      double? outDeliveryEstimatedFreight,
      double? outDeliveryFreightInvoiceAmount,
      String? outDeliveryChargeType,
      String? outDeliveryFreightTrackingNumber,
      String? outDeliveryFreightTrackingUrl,
      String? outDeliveryPackageCode,
      bool? outDeliveryBillPoFreightOnOrder,
      String? outDeliveryOnlineOrderNumber,
      String? outDeliveryToVenue,
      String? outDeliveryToVenueId,
      String? outDeliveryToWarehouse,
      String? outDeliveryToWarehouseId,
      String? outDeliveryDateStamp,
      String? inDeliveryId,
      String? inDeliveryDeliveryType,
      String? inDeliveryRequiredDate,
      String? inDeliveryRequiredTime,
      String? inDeliveryTargetShipDate,
      String? inDeliveryTargetShipTime,
      String? inDeliveryDirection,
      String? inDeliveryAddressType,
      String? inDeliveryFromLocation,
      String? inDeliveryFromContact,
      String? inDeliveryFromContactPhone,
      String? inDeliveryFromAlternateContact,
      String? inDeliveryFromAlternateContactPhone,
      String? inDeliveryFromAttention,
      String? inDeliveryFromAddress1,
      String? inDeliveryFromAdd2ress,
      String? inDeliveryFromCity,
      String? inDeliveryFromState,
      String? inDeliveryFromZipCode,
      String? inDeliveryFromCountry,
      String? inDeliveryFromCountryId,
      String? inDeliveryFromCrossStreets,
      String? inDeliveryToLocation,
      String? inDeliveryToContact,
      String? inDeliveryToContactPhone,
      String? inDeliveryToAlternateContact,
      String? inDeliveryToAlternateContactPhone,
      String? inDeliveryToAttention,
      String? inDeliveryToAddress1,
      String? inDeliveryToAddress2,
      String? inDeliveryToCity,
      String? inDeliveryToState,
      String? inDeliveryToZipCode,
      String? inDeliveryToCountryId,
      String? inDeliveryToCountry,
      String? inDeliveryToContactFax,
      String? inDeliveryToCrossStreets,
      String? inDeliveryDeliveryNotes,
      String? inDeliveryCarrierId,
      String? inDeliveryCarrier,
      String? inDeliveryCarrierAccount,
      String? inDeliveryShipViaId,
      String? inDeliveryShipVia,
      String? inDeliveryInvoiceId,
      String? inDeliveryVendorInvoiceId,
      double? inDeliveryEstimatedFreight,
      double? inDeliveryFreightInvoiceAmount,
      String? inDeliveryChargeType,
      String? inDeliveryFreightTrackingNumber,
      String? inDeliveryFreightTrackingUrl,
      String? inDeliveryPackageCode,
      bool? inDeliveryBillPoFreightOnOrder,
      String? inDeliveryOnlineOrderNumber,
      String? inDeliveryOnlineOrderStatus,
      String? inDeliveryToVenue,
      String? inDeliveryToVenueId,
      String? inDeliveryToWarehouse,
      String? inDeliveryToWarehouseId,
      String? inDeliveryDateStamp,
      double? rentalDaysPerWeek,
      double? rentalDiscountPercent,
      double? weeklyRentalTotal,
      double? monthlyRentalTotal,
      double? periodRentalTotal,
      bool? weeklyRentalTotalIncludesTax,
      bool? monthlyRentalTotalIncludesTax,
      bool? periodRentalTotalIncludesTax,
      bool? billLockedTotal,
      double? salesDiscountPercent,
      double? salesTotal,
      bool? salesTotalIncludesTax,
      double? partsDiscountPercent,
      double? partsTotal,
      bool? partsTotalIncludesTax,
      double? spaceDaysPerWeek,
      double? spaceDiscountPercent,
      double? spaceSplitPercent,
      double? weeklySpaceTotal,
      double? monthlySpaceTotal,
      double? periodSpaceTotal,
      bool? weeklySpaceTotalIncludesTax,
      bool? monthlySpaceTotalIncludesTax,
      bool? periodSpaceTotalIncludesTax,
      double? vehicleDaysPerWeek,
      double? vehicleDiscountPercent,
      double? weeklyVehicleTotal,
      double? monthlyVehicleTotal,
      double? periodVehicleTotal,
      bool? weeklyVehicleTotalIncludesTax,
      bool? monthlyVehicleTotalIncludesTax,
      bool? periodVehicleTotalIncludesTax,
      double? miscDiscountPercent,
      double? weeklyMiscTotal,
      double? monthlyMiscTotal,
      double? periodMiscTotal,
      bool? weeklyMiscTotalIncludesTax,
      bool? monthlyMiscTotalIncludesTax,
      bool? periodMiscTotalIncludesTax,
      double? laborDiscountPercent,
      double? weeklyLaborTotal,
      double? monthlyLaborTotal,
      double? periodLaborTotal,
      bool? weeklyLaborTotalIncludesTax,
      bool? monthlyLaborTotalIncludesTax,
      bool? periodLaborTotalIncludesTax,
      double? rentalSaleDiscountPercent,
      double? rentalSaleTotal,
      bool? rentalSaleTotalIncludesTax,
      double? lossAndDamageDiscountPercent,
      double? lossAndDamageTotal,
      bool? lossAndDamageTotalIncludesTax,
      double? combinedDaysPerWeek,
      double? combinedDiscountPercent,
      double? weeklyCombinedTotal,
      double? monthlyCombinedTotal,
      double? periodCombinedTotal,
      bool? weeklyCombinedTotalIncludesTax,
      bool? monthlyCombinedTotalIncludesTax,
      bool? periodCombinedTotalIncludesTax,
      bool? disableEditingRentalRate,
      bool? disableEditingSalesRate,
      bool? disableEditingMiscellaneousRate,
      bool? disableEditingLaborRate,
      bool? disableEditingRentalSaleRate,
      bool? disableEditingLossAndDamageRate,
      double? rentalExtendedTotal,
      double? salesExtendedTotal,
      double? laborExtendedTotal,
      double? miscellaneousExtendedTotal,
      double? rentalSaleExtendedTotal,
      double? lossAndDamageExtendedTotal,
      bool? hasNotes,
      bool? hasDocuments,
      bool? hasEmailHistory,
      bool? hasContacts,
      bool? hasSubPurchaseOrders,
      bool? hasPickLists,
      bool? hasContracts,
      bool? hasSuspendedContracts,
      bool? hasMultiOrderContracts,
      bool? hasInvoices,
      bool? hasBillingWorksheets,
      bool? hasMultiOrderInvoices,
      double? totalReplacementCost,
      String? presentationLayerId,
      String? presentationLayer,
      bool? isManualSort,
      String? quoteOrderTitle,
      bool? unassignedSubs,
      bool? nonTaxable,
      bool? enableProjects,
      String? projectId,
      String? projectNumber,
      String? project,
      String? projectDrawingsId,
      String? projectDrawings,
      String? projectItemsOrderedId,
      String? projectItemsOrdered,
      String? projectDropShipId,
      String? projectDropShip,
      String? projectAsBuildId,
      String? projectAsBuild,
      String? projectCommissioningId,
      String? projectCommissioning,
      String? projectDepositId,
      String? projectDeposit,
      String? inputByUserId,
      String? modifiedByUserId,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAgentQuoteQuote(
        quoteId: quoteId ?? this.quoteId,
        quoteNumber: quoteNumber ?? this.quoteNumber,
        quoteDate: quoteDate ?? this.quoteDate,
        versionNumber: versionNumber ?? this.versionNumber,
        convertedToOrderId: convertedToOrderId ?? this.convertedToOrderId,
        convertedToOrderNumber:
            convertedToOrderNumber ?? this.convertedToOrderNumber,
        description: description ?? this.description,
        officeLocationId: officeLocationId ?? this.officeLocationId,
        officeLocation: officeLocation ?? this.officeLocation,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouse: warehouse ?? this.warehouse,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        departmentId: departmentId ?? this.departmentId,
        department: department ?? this.department,
        customerId: customerId ?? this.customerId,
        customer: customer ?? this.customer,
        customerNumber: customerNumber ?? this.customerNumber,
        dealId: dealId ?? this.dealId,
        deal: deal ?? this.deal,
        dealNumber: dealNumber ?? this.dealNumber,
        rateType: rateType ?? this.rateType,
        rateTypeDisplay: rateTypeDisplay ?? this.rateTypeDisplay,
        agentId: agentId ?? this.agentId,
        agent: agent ?? this.agent,
        projectManagerId: projectManagerId ?? this.projectManagerId,
        projectManager: projectManager ?? this.projectManager,
        rental: rental ?? this.rental,
        sales: sales ?? this.sales,
        miscellaneous: miscellaneous ?? this.miscellaneous,
        labor: labor ?? this.labor,
        facilities: facilities ?? this.facilities,
        transportation: transportation ?? this.transportation,
        rentalSale: rentalSale ?? this.rentalSale,
        lossAndDamage: lossAndDamage ?? this.lossAndDamage,
        repair: repair ?? this.repair,
        hasRentalItem: hasRentalItem ?? this.hasRentalItem,
        hasSalesItem: hasSalesItem ?? this.hasSalesItem,
        hasMiscellaneousItem: hasMiscellaneousItem ?? this.hasMiscellaneousItem,
        hasLaborItem: hasLaborItem ?? this.hasLaborItem,
        hasFacilitiesItem: hasFacilitiesItem ?? this.hasFacilitiesItem,
        hasLossAndDamageItem: hasLossAndDamageItem ?? this.hasLossAndDamageItem,
        hasRentalSaleItem: hasRentalSaleItem ?? this.hasRentalSaleItem,
        hasRepair: hasRepair ?? this.hasRepair,
        activityDatesAndTimes:
            activityDatesAndTimes ?? this.activityDatesAndTimes,
        pickDate: pickDate ?? this.pickDate,
        pickTime: pickTime ?? this.pickTime,
        estimatedStartDate: estimatedStartDate ?? this.estimatedStartDate,
        estimatedStartTime: estimatedStartTime ?? this.estimatedStartTime,
        estimatedStopDate: estimatedStopDate ?? this.estimatedStopDate,
        estimatedStopTime: estimatedStopTime ?? this.estimatedStopTime,
        pickUpDate: pickUpDate ?? this.pickUpDate,
        pickUpTime: pickUpTime ?? this.pickUpTime,
        prepDate: prepDate ?? this.prepDate,
        prepTime: prepTime ?? this.prepTime,
        loadInDate: loadInDate ?? this.loadInDate,
        loadInTime: loadInTime ?? this.loadInTime,
        strikeDate: strikeDate ?? this.strikeDate,
        strikeTime: strikeTime ?? this.strikeTime,
        testDate: testDate ?? this.testDate,
        testTime: testTime ?? this.testTime,
        orderTypeId: orderTypeId ?? this.orderTypeId,
        orderType: orderType ?? this.orderType,
        orderTypeCombineActivityTabs:
            orderTypeCombineActivityTabs ?? this.orderTypeCombineActivityTabs,
        flatPo: flatPo ?? this.flatPo,
        pendingPo: pendingPo ?? this.pendingPo,
        poNumber: poNumber ?? this.poNumber,
        poAmount: poAmount ?? this.poAmount,
        location: location ?? this.location,
        orderLocationId: orderLocationId ?? this.orderLocationId,
        orderLocation: orderLocation ?? this.orderLocation,
        referenceNumber: referenceNumber ?? this.referenceNumber,
        total: total ?? this.total,
        status: status ?? this.status,
        statusDate: statusDate ?? this.statusDate,
        poApprovalStatusId: poApprovalStatusId ?? this.poApprovalStatusId,
        lockBillingDates: lockBillingDates ?? this.lockBillingDates,
        specifyBillingDatesByType:
            specifyBillingDatesByType ?? this.specifyBillingDatesByType,
        rentalBillingStartDate:
            rentalBillingStartDate ?? this.rentalBillingStartDate,
        rentalBillingEndDate: rentalBillingEndDate ?? this.rentalBillingEndDate,
        laborBillingStartDate:
            laborBillingStartDate ?? this.laborBillingStartDate,
        laborBillingEndDate: laborBillingEndDate ?? this.laborBillingEndDate,
        miscellaneousBillingStartDate:
            miscellaneousBillingStartDate ?? this.miscellaneousBillingStartDate,
        miscellaneousBillingEndDate:
            miscellaneousBillingEndDate ?? this.miscellaneousBillingEndDate,
        facilitiesBillingStartDate:
            facilitiesBillingStartDate ?? this.facilitiesBillingStartDate,
        facilitiesBillingEndDate:
            facilitiesBillingEndDate ?? this.facilitiesBillingEndDate,
        vehicleBillingStartDate:
            vehicleBillingStartDate ?? this.vehicleBillingStartDate,
        vehicleBillingEndDate:
            vehicleBillingEndDate ?? this.vehicleBillingEndDate,
        delayBillingSearchUntil:
            delayBillingSearchUntil ?? this.delayBillingSearchUntil,
        includePrepFeesInRentalRate:
            includePrepFeesInRentalRate ?? this.includePrepFeesInRentalRate,
        billingStartDate: billingStartDate ?? this.billingStartDate,
        billingEndDate: billingEndDate ?? this.billingEndDate,
        billingWeeks: billingWeeks ?? this.billingWeeks,
        billingMonths: billingMonths ?? this.billingMonths,
        determineQuantitiesToBillBasedOn: determineQuantitiesToBillBasedOn ??
            this.determineQuantitiesToBillBasedOn,
        billingCycleId: billingCycleId ?? this.billingCycleId,
        billingCycle: billingCycle ?? this.billingCycle,
        billingCycleType: billingCycleType ?? this.billingCycleType,
        paymentTermsId: paymentTermsId ?? this.paymentTermsId,
        paymentTerms: paymentTerms ?? this.paymentTerms,
        paymentTypeId: paymentTypeId ?? this.paymentTypeId,
        paymentType: paymentType ?? this.paymentType,
        currencyId: currencyId ?? this.currencyId,
        updateAllRatesToNewCurrency:
            updateAllRatesToNewCurrency ?? this.updateAllRatesToNewCurrency,
        confirmUpdateAllRatesToNewCurrency: confirmUpdateAllRatesToNewCurrency ??
            this.confirmUpdateAllRatesToNewCurrency,
        currencyCode: currencyCode ?? this.currencyCode,
        currency: currency ?? this.currency,
        currencySymbol: currencySymbol ?? this.currencySymbol,
        taxOptionId: taxOptionId ?? this.taxOptionId,
        taxOption: taxOption ?? this.taxOption,
        tax1Name: tax1Name ?? this.tax1Name,
        tax2Name: tax2Name ?? this.tax2Name,
        taxId: taxId ?? this.taxId,
        rentalTaxRate1: rentalTaxRate1 ?? this.rentalTaxRate1,
        salesTaxRate1: salesTaxRate1 ?? this.salesTaxRate1,
        laborTaxRate1: laborTaxRate1 ?? this.laborTaxRate1,
        rentalTaxRate2: rentalTaxRate2 ?? this.rentalTaxRate2,
        salesTaxRate2: salesTaxRate2 ?? this.salesTaxRate2,
        laborTaxRate2: laborTaxRate2 ?? this.laborTaxRate2,
        noCharge: noCharge ?? this.noCharge,
        noChargeReason: noChargeReason ?? this.noChargeReason,
        printIssuedToAddressFrom:
            printIssuedToAddressFrom ?? this.printIssuedToAddressFrom,
        issuedToName: issuedToName ?? this.issuedToName,
        issuedToAttention: issuedToAttention ?? this.issuedToAttention,
        issuedToAttention2: issuedToAttention2 ?? this.issuedToAttention2,
        issuedToAddress1: issuedToAddress1 ?? this.issuedToAddress1,
        issuedToAddress2: issuedToAddress2 ?? this.issuedToAddress2,
        issuedToCity: issuedToCity ?? this.issuedToCity,
        issuedToState: issuedToState ?? this.issuedToState,
        issuedToZipCode: issuedToZipCode ?? this.issuedToZipCode,
        issuedToCountryId: issuedToCountryId ?? this.issuedToCountryId,
        issuedToCountry: issuedToCountry ?? this.issuedToCountry,
        billToAddressDifferentFromIssuedToAddress: billToAddressDifferentFromIssuedToAddress ??
            this.billToAddressDifferentFromIssuedToAddress,
        billToAddressId: billToAddressId ?? this.billToAddressId,
        billToName: billToName ?? this.billToName,
        billToAttention: billToAttention ?? this.billToAttention,
        billToAttention2: billToAttention2 ?? this.billToAttention2,
        billToAddress1: billToAddress1 ?? this.billToAddress1,
        billToAddress2: billToAddress2 ?? this.billToAddress2,
        billToCity: billToCity ?? this.billToCity,
        billToState: billToState ?? this.billToState,
        billToZipCode: billToZipCode ?? this.billToZipCode,
        billToCountryId: billToCountryId ?? this.billToCountryId,
        billToCountry: billToCountry ?? this.billToCountry,
        discountReasonId: discountReasonId ?? this.discountReasonId,
        discountReason: discountReason ?? this.discountReason,
        requireContactConfirmation:
            requireContactConfirmation ?? this.requireContactConfirmation,
        includeInBillingAnalysis:
            includeInBillingAnalysis ?? this.includeInBillingAnalysis,
        hiatusDiscountFrom: hiatusDiscountFrom ?? this.hiatusDiscountFrom,
        roundTripRentals: roundTripRentals ?? this.roundTripRentals,
        inGroup: inGroup ?? this.inGroup,
        groupNumber: groupNumber ?? this.groupNumber,
        groupColor: groupColor ?? this.groupColor,
        groupOrderBy: groupOrderBy ?? this.groupOrderBy,
        coverLetterId: coverLetterId ?? this.coverLetterId,
        coverLetter: coverLetter ?? this.coverLetter,
        termsConditionsId: termsConditionsId ?? this.termsConditionsId,
        termsConditions: termsConditions ?? this.termsConditions,
        outsideSalesRepresentativeId:
            outsideSalesRepresentativeId ?? this.outsideSalesRepresentativeId,
        outsideSalesRepresentative:
            outsideSalesRepresentative ?? this.outsideSalesRepresentative,
        marketTypeId: marketTypeId ?? this.marketTypeId,
        marketType: marketType ?? this.marketType,
        marketSegmentId: marketSegmentId ?? this.marketSegmentId,
        marketSegment: marketSegment ?? this.marketSegment,
        marketSegmentJobId: marketSegmentJobId ?? this.marketSegmentJobId,
        marketSegmentJob: marketSegmentJob ?? this.marketSegmentJob,
        outDeliveryId: outDeliveryId ?? this.outDeliveryId,
        outDeliveryDeliveryType:
            outDeliveryDeliveryType ?? this.outDeliveryDeliveryType,
        outDeliveryRequiredDate:
            outDeliveryRequiredDate ?? this.outDeliveryRequiredDate,
        outDeliveryRequiredTime:
            outDeliveryRequiredTime ?? this.outDeliveryRequiredTime,
        outDeliveryTargetShipDate:
            outDeliveryTargetShipDate ?? this.outDeliveryTargetShipDate,
        outDeliveryTargetShipTime:
            outDeliveryTargetShipTime ?? this.outDeliveryTargetShipTime,
        outDeliveryDirection: outDeliveryDirection ?? this.outDeliveryDirection,
        outDeliveryAddressType:
            outDeliveryAddressType ?? this.outDeliveryAddressType,
        outDeliveryFromLocation:
            outDeliveryFromLocation ?? this.outDeliveryFromLocation,
        outDeliveryFromContact:
            outDeliveryFromContact ?? this.outDeliveryFromContact,
        outDeliveryFromContactPhone:
            outDeliveryFromContactPhone ?? this.outDeliveryFromContactPhone,
        outDeliveryFromAlternateContact: outDeliveryFromAlternateContact ??
            this.outDeliveryFromAlternateContact,
        outDeliveryFromAlternateContactPhone: outDeliveryFromAlternateContactPhone ??
            this.outDeliveryFromAlternateContactPhone,
        outDeliveryFromAttention:
            outDeliveryFromAttention ?? this.outDeliveryFromAttention,
        outDeliveryFromAddress1:
            outDeliveryFromAddress1 ?? this.outDeliveryFromAddress1,
        outDeliveryFromAdd2ress:
            outDeliveryFromAdd2ress ?? this.outDeliveryFromAdd2ress,
        outDeliveryFromCity: outDeliveryFromCity ?? this.outDeliveryFromCity,
        outDeliveryFromState: outDeliveryFromState ?? this.outDeliveryFromState,
        outDeliveryFromZipCode:
            outDeliveryFromZipCode ?? this.outDeliveryFromZipCode,
        outDeliveryFromCountry:
            outDeliveryFromCountry ?? this.outDeliveryFromCountry,
        outDeliveryFromCountryId:
            outDeliveryFromCountryId ?? this.outDeliveryFromCountryId,
        outDeliveryFromCrossStreets:
            outDeliveryFromCrossStreets ?? this.outDeliveryFromCrossStreets,
        outDeliveryToLocation:
            outDeliveryToLocation ?? this.outDeliveryToLocation,
        outDeliveryToContact: outDeliveryToContact ?? this.outDeliveryToContact,
        outDeliveryToContactPhone:
            outDeliveryToContactPhone ?? this.outDeliveryToContactPhone,
        outDeliveryToAlternateContact:
            outDeliveryToAlternateContact ?? this.outDeliveryToAlternateContact,
        outDeliveryToAlternateContactPhone:
            outDeliveryToAlternateContactPhone ?? this.outDeliveryToAlternateContactPhone,
        outDeliveryToAttention: outDeliveryToAttention ?? this.outDeliveryToAttention,
        outDeliveryToAddress1: outDeliveryToAddress1 ?? this.outDeliveryToAddress1,
        outDeliveryToAddress2: outDeliveryToAddress2 ?? this.outDeliveryToAddress2,
        outDeliveryToCity: outDeliveryToCity ?? this.outDeliveryToCity,
        outDeliveryToState: outDeliveryToState ?? this.outDeliveryToState,
        outDeliveryToZipCode: outDeliveryToZipCode ?? this.outDeliveryToZipCode,
        outDeliveryToCountryId: outDeliveryToCountryId ?? this.outDeliveryToCountryId,
        outDeliveryToCountry: outDeliveryToCountry ?? this.outDeliveryToCountry,
        outDeliveryToContactFax: outDeliveryToContactFax ?? this.outDeliveryToContactFax,
        outDeliveryToCrossStreets: outDeliveryToCrossStreets ?? this.outDeliveryToCrossStreets,
        outDeliveryDeliveryNotes: outDeliveryDeliveryNotes ?? this.outDeliveryDeliveryNotes,
        outDeliveryCarrierId: outDeliveryCarrierId ?? this.outDeliveryCarrierId,
        outDeliveryCarrier: outDeliveryCarrier ?? this.outDeliveryCarrier,
        outDeliveryCarrierAccount: outDeliveryCarrierAccount ?? this.outDeliveryCarrierAccount,
        outDeliveryShipViaId: outDeliveryShipViaId ?? this.outDeliveryShipViaId,
        outDeliveryShipVia: outDeliveryShipVia ?? this.outDeliveryShipVia,
        outDeliveryInvoiceId: outDeliveryInvoiceId ?? this.outDeliveryInvoiceId,
        outDeliveryVendorInvoiceId: outDeliveryVendorInvoiceId ?? this.outDeliveryVendorInvoiceId,
        outDeliveryEstimatedFreight: outDeliveryEstimatedFreight ?? this.outDeliveryEstimatedFreight,
        outDeliveryFreightInvoiceAmount: outDeliveryFreightInvoiceAmount ?? this.outDeliveryFreightInvoiceAmount,
        outDeliveryChargeType: outDeliveryChargeType ?? this.outDeliveryChargeType,
        outDeliveryFreightTrackingNumber: outDeliveryFreightTrackingNumber ?? this.outDeliveryFreightTrackingNumber,
        outDeliveryFreightTrackingUrl: outDeliveryFreightTrackingUrl ?? this.outDeliveryFreightTrackingUrl,
        outDeliveryPackageCode: outDeliveryPackageCode ?? this.outDeliveryPackageCode,
        outDeliveryBillPoFreightOnOrder: outDeliveryBillPoFreightOnOrder ?? this.outDeliveryBillPoFreightOnOrder,
        outDeliveryOnlineOrderNumber: outDeliveryOnlineOrderNumber ?? this.outDeliveryOnlineOrderNumber,
        outDeliveryToVenue: outDeliveryToVenue ?? this.outDeliveryToVenue,
        outDeliveryToVenueId: outDeliveryToVenueId ?? this.outDeliveryToVenueId,
        outDeliveryToWarehouse: outDeliveryToWarehouse ?? this.outDeliveryToWarehouse,
        outDeliveryToWarehouseId: outDeliveryToWarehouseId ?? this.outDeliveryToWarehouseId,
        outDeliveryDateStamp: outDeliveryDateStamp ?? this.outDeliveryDateStamp,
        inDeliveryId: inDeliveryId ?? this.inDeliveryId,
        inDeliveryDeliveryType: inDeliveryDeliveryType ?? this.inDeliveryDeliveryType,
        inDeliveryRequiredDate: inDeliveryRequiredDate ?? this.inDeliveryRequiredDate,
        inDeliveryRequiredTime: inDeliveryRequiredTime ?? this.inDeliveryRequiredTime,
        inDeliveryTargetShipDate: inDeliveryTargetShipDate ?? this.inDeliveryTargetShipDate,
        inDeliveryTargetShipTime: inDeliveryTargetShipTime ?? this.inDeliveryTargetShipTime,
        inDeliveryDirection: inDeliveryDirection ?? this.inDeliveryDirection,
        inDeliveryAddressType: inDeliveryAddressType ?? this.inDeliveryAddressType,
        inDeliveryFromLocation: inDeliveryFromLocation ?? this.inDeliveryFromLocation,
        inDeliveryFromContact: inDeliveryFromContact ?? this.inDeliveryFromContact,
        inDeliveryFromContactPhone: inDeliveryFromContactPhone ?? this.inDeliveryFromContactPhone,
        inDeliveryFromAlternateContact: inDeliveryFromAlternateContact ?? this.inDeliveryFromAlternateContact,
        inDeliveryFromAlternateContactPhone: inDeliveryFromAlternateContactPhone ?? this.inDeliveryFromAlternateContactPhone,
        inDeliveryFromAttention: inDeliveryFromAttention ?? this.inDeliveryFromAttention,
        inDeliveryFromAddress1: inDeliveryFromAddress1 ?? this.inDeliveryFromAddress1,
        inDeliveryFromAdd2ress: inDeliveryFromAdd2ress ?? this.inDeliveryFromAdd2ress,
        inDeliveryFromCity: inDeliveryFromCity ?? this.inDeliveryFromCity,
        inDeliveryFromState: inDeliveryFromState ?? this.inDeliveryFromState,
        inDeliveryFromZipCode: inDeliveryFromZipCode ?? this.inDeliveryFromZipCode,
        inDeliveryFromCountry: inDeliveryFromCountry ?? this.inDeliveryFromCountry,
        inDeliveryFromCountryId: inDeliveryFromCountryId ?? this.inDeliveryFromCountryId,
        inDeliveryFromCrossStreets: inDeliveryFromCrossStreets ?? this.inDeliveryFromCrossStreets,
        inDeliveryToLocation: inDeliveryToLocation ?? this.inDeliveryToLocation,
        inDeliveryToContact: inDeliveryToContact ?? this.inDeliveryToContact,
        inDeliveryToContactPhone: inDeliveryToContactPhone ?? this.inDeliveryToContactPhone,
        inDeliveryToAlternateContact: inDeliveryToAlternateContact ?? this.inDeliveryToAlternateContact,
        inDeliveryToAlternateContactPhone: inDeliveryToAlternateContactPhone ?? this.inDeliveryToAlternateContactPhone,
        inDeliveryToAttention: inDeliveryToAttention ?? this.inDeliveryToAttention,
        inDeliveryToAddress1: inDeliveryToAddress1 ?? this.inDeliveryToAddress1,
        inDeliveryToAddress2: inDeliveryToAddress2 ?? this.inDeliveryToAddress2,
        inDeliveryToCity: inDeliveryToCity ?? this.inDeliveryToCity,
        inDeliveryToState: inDeliveryToState ?? this.inDeliveryToState,
        inDeliveryToZipCode: inDeliveryToZipCode ?? this.inDeliveryToZipCode,
        inDeliveryToCountryId: inDeliveryToCountryId ?? this.inDeliveryToCountryId,
        inDeliveryToCountry: inDeliveryToCountry ?? this.inDeliveryToCountry,
        inDeliveryToContactFax: inDeliveryToContactFax ?? this.inDeliveryToContactFax,
        inDeliveryToCrossStreets: inDeliveryToCrossStreets ?? this.inDeliveryToCrossStreets,
        inDeliveryDeliveryNotes: inDeliveryDeliveryNotes ?? this.inDeliveryDeliveryNotes,
        inDeliveryCarrierId: inDeliveryCarrierId ?? this.inDeliveryCarrierId,
        inDeliveryCarrier: inDeliveryCarrier ?? this.inDeliveryCarrier,
        inDeliveryCarrierAccount: inDeliveryCarrierAccount ?? this.inDeliveryCarrierAccount,
        inDeliveryShipViaId: inDeliveryShipViaId ?? this.inDeliveryShipViaId,
        inDeliveryShipVia: inDeliveryShipVia ?? this.inDeliveryShipVia,
        inDeliveryInvoiceId: inDeliveryInvoiceId ?? this.inDeliveryInvoiceId,
        inDeliveryVendorInvoiceId: inDeliveryVendorInvoiceId ?? this.inDeliveryVendorInvoiceId,
        inDeliveryEstimatedFreight: inDeliveryEstimatedFreight ?? this.inDeliveryEstimatedFreight,
        inDeliveryFreightInvoiceAmount: inDeliveryFreightInvoiceAmount ?? this.inDeliveryFreightInvoiceAmount,
        inDeliveryChargeType: inDeliveryChargeType ?? this.inDeliveryChargeType,
        inDeliveryFreightTrackingNumber: inDeliveryFreightTrackingNumber ?? this.inDeliveryFreightTrackingNumber,
        inDeliveryFreightTrackingUrl: inDeliveryFreightTrackingUrl ?? this.inDeliveryFreightTrackingUrl,
        inDeliveryPackageCode: inDeliveryPackageCode ?? this.inDeliveryPackageCode,
        inDeliveryBillPoFreightOnOrder: inDeliveryBillPoFreightOnOrder ?? this.inDeliveryBillPoFreightOnOrder,
        inDeliveryOnlineOrderNumber: inDeliveryOnlineOrderNumber ?? this.inDeliveryOnlineOrderNumber,
        inDeliveryOnlineOrderStatus: inDeliveryOnlineOrderStatus ?? this.inDeliveryOnlineOrderStatus,
        inDeliveryToVenue: inDeliveryToVenue ?? this.inDeliveryToVenue,
        inDeliveryToVenueId: inDeliveryToVenueId ?? this.inDeliveryToVenueId,
        inDeliveryToWarehouse: inDeliveryToWarehouse ?? this.inDeliveryToWarehouse,
        inDeliveryToWarehouseId: inDeliveryToWarehouseId ?? this.inDeliveryToWarehouseId,
        inDeliveryDateStamp: inDeliveryDateStamp ?? this.inDeliveryDateStamp,
        rentalDaysPerWeek: rentalDaysPerWeek ?? this.rentalDaysPerWeek,
        rentalDiscountPercent: rentalDiscountPercent ?? this.rentalDiscountPercent,
        weeklyRentalTotal: weeklyRentalTotal ?? this.weeklyRentalTotal,
        monthlyRentalTotal: monthlyRentalTotal ?? this.monthlyRentalTotal,
        periodRentalTotal: periodRentalTotal ?? this.periodRentalTotal,
        weeklyRentalTotalIncludesTax: weeklyRentalTotalIncludesTax ?? this.weeklyRentalTotalIncludesTax,
        monthlyRentalTotalIncludesTax: monthlyRentalTotalIncludesTax ?? this.monthlyRentalTotalIncludesTax,
        periodRentalTotalIncludesTax: periodRentalTotalIncludesTax ?? this.periodRentalTotalIncludesTax,
        billLockedTotal: billLockedTotal ?? this.billLockedTotal,
        salesDiscountPercent: salesDiscountPercent ?? this.salesDiscountPercent,
        salesTotal: salesTotal ?? this.salesTotal,
        salesTotalIncludesTax: salesTotalIncludesTax ?? this.salesTotalIncludesTax,
        partsDiscountPercent: partsDiscountPercent ?? this.partsDiscountPercent,
        partsTotal: partsTotal ?? this.partsTotal,
        partsTotalIncludesTax: partsTotalIncludesTax ?? this.partsTotalIncludesTax,
        spaceDaysPerWeek: spaceDaysPerWeek ?? this.spaceDaysPerWeek,
        spaceDiscountPercent: spaceDiscountPercent ?? this.spaceDiscountPercent,
        spaceSplitPercent: spaceSplitPercent ?? this.spaceSplitPercent,
        weeklySpaceTotal: weeklySpaceTotal ?? this.weeklySpaceTotal,
        monthlySpaceTotal: monthlySpaceTotal ?? this.monthlySpaceTotal,
        periodSpaceTotal: periodSpaceTotal ?? this.periodSpaceTotal,
        weeklySpaceTotalIncludesTax: weeklySpaceTotalIncludesTax ?? this.weeklySpaceTotalIncludesTax,
        monthlySpaceTotalIncludesTax: monthlySpaceTotalIncludesTax ?? this.monthlySpaceTotalIncludesTax,
        periodSpaceTotalIncludesTax: periodSpaceTotalIncludesTax ?? this.periodSpaceTotalIncludesTax,
        vehicleDaysPerWeek: vehicleDaysPerWeek ?? this.vehicleDaysPerWeek,
        vehicleDiscountPercent: vehicleDiscountPercent ?? this.vehicleDiscountPercent,
        weeklyVehicleTotal: weeklyVehicleTotal ?? this.weeklyVehicleTotal,
        monthlyVehicleTotal: monthlyVehicleTotal ?? this.monthlyVehicleTotal,
        periodVehicleTotal: periodVehicleTotal ?? this.periodVehicleTotal,
        weeklyVehicleTotalIncludesTax: weeklyVehicleTotalIncludesTax ?? this.weeklyVehicleTotalIncludesTax,
        monthlyVehicleTotalIncludesTax: monthlyVehicleTotalIncludesTax ?? this.monthlyVehicleTotalIncludesTax,
        periodVehicleTotalIncludesTax: periodVehicleTotalIncludesTax ?? this.periodVehicleTotalIncludesTax,
        miscDiscountPercent: miscDiscountPercent ?? this.miscDiscountPercent,
        weeklyMiscTotal: weeklyMiscTotal ?? this.weeklyMiscTotal,
        monthlyMiscTotal: monthlyMiscTotal ?? this.monthlyMiscTotal,
        periodMiscTotal: periodMiscTotal ?? this.periodMiscTotal,
        weeklyMiscTotalIncludesTax: weeklyMiscTotalIncludesTax ?? this.weeklyMiscTotalIncludesTax,
        monthlyMiscTotalIncludesTax: monthlyMiscTotalIncludesTax ?? this.monthlyMiscTotalIncludesTax,
        periodMiscTotalIncludesTax: periodMiscTotalIncludesTax ?? this.periodMiscTotalIncludesTax,
        laborDiscountPercent: laborDiscountPercent ?? this.laborDiscountPercent,
        weeklyLaborTotal: weeklyLaborTotal ?? this.weeklyLaborTotal,
        monthlyLaborTotal: monthlyLaborTotal ?? this.monthlyLaborTotal,
        periodLaborTotal: periodLaborTotal ?? this.periodLaborTotal,
        weeklyLaborTotalIncludesTax: weeklyLaborTotalIncludesTax ?? this.weeklyLaborTotalIncludesTax,
        monthlyLaborTotalIncludesTax: monthlyLaborTotalIncludesTax ?? this.monthlyLaborTotalIncludesTax,
        periodLaborTotalIncludesTax: periodLaborTotalIncludesTax ?? this.periodLaborTotalIncludesTax,
        rentalSaleDiscountPercent: rentalSaleDiscountPercent ?? this.rentalSaleDiscountPercent,
        rentalSaleTotal: rentalSaleTotal ?? this.rentalSaleTotal,
        rentalSaleTotalIncludesTax: rentalSaleTotalIncludesTax ?? this.rentalSaleTotalIncludesTax,
        lossAndDamageDiscountPercent: lossAndDamageDiscountPercent ?? this.lossAndDamageDiscountPercent,
        lossAndDamageTotal: lossAndDamageTotal ?? this.lossAndDamageTotal,
        lossAndDamageTotalIncludesTax: lossAndDamageTotalIncludesTax ?? this.lossAndDamageTotalIncludesTax,
        combinedDaysPerWeek: combinedDaysPerWeek ?? this.combinedDaysPerWeek,
        combinedDiscountPercent: combinedDiscountPercent ?? this.combinedDiscountPercent,
        weeklyCombinedTotal: weeklyCombinedTotal ?? this.weeklyCombinedTotal,
        monthlyCombinedTotal: monthlyCombinedTotal ?? this.monthlyCombinedTotal,
        periodCombinedTotal: periodCombinedTotal ?? this.periodCombinedTotal,
        weeklyCombinedTotalIncludesTax: weeklyCombinedTotalIncludesTax ?? this.weeklyCombinedTotalIncludesTax,
        monthlyCombinedTotalIncludesTax: monthlyCombinedTotalIncludesTax ?? this.monthlyCombinedTotalIncludesTax,
        periodCombinedTotalIncludesTax: periodCombinedTotalIncludesTax ?? this.periodCombinedTotalIncludesTax,
        disableEditingRentalRate: disableEditingRentalRate ?? this.disableEditingRentalRate,
        disableEditingSalesRate: disableEditingSalesRate ?? this.disableEditingSalesRate,
        disableEditingMiscellaneousRate: disableEditingMiscellaneousRate ?? this.disableEditingMiscellaneousRate,
        disableEditingLaborRate: disableEditingLaborRate ?? this.disableEditingLaborRate,
        disableEditingRentalSaleRate: disableEditingRentalSaleRate ?? this.disableEditingRentalSaleRate,
        disableEditingLossAndDamageRate: disableEditingLossAndDamageRate ?? this.disableEditingLossAndDamageRate,
        rentalExtendedTotal: rentalExtendedTotal ?? this.rentalExtendedTotal,
        salesExtendedTotal: salesExtendedTotal ?? this.salesExtendedTotal,
        laborExtendedTotal: laborExtendedTotal ?? this.laborExtendedTotal,
        miscellaneousExtendedTotal: miscellaneousExtendedTotal ?? this.miscellaneousExtendedTotal,
        rentalSaleExtendedTotal: rentalSaleExtendedTotal ?? this.rentalSaleExtendedTotal,
        lossAndDamageExtendedTotal: lossAndDamageExtendedTotal ?? this.lossAndDamageExtendedTotal,
        hasNotes: hasNotes ?? this.hasNotes,
        hasDocuments: hasDocuments ?? this.hasDocuments,
        hasEmailHistory: hasEmailHistory ?? this.hasEmailHistory,
        hasContacts: hasContacts ?? this.hasContacts,
        hasSubPurchaseOrders: hasSubPurchaseOrders ?? this.hasSubPurchaseOrders,
        hasPickLists: hasPickLists ?? this.hasPickLists,
        hasContracts: hasContracts ?? this.hasContracts,
        hasSuspendedContracts: hasSuspendedContracts ?? this.hasSuspendedContracts,
        hasMultiOrderContracts: hasMultiOrderContracts ?? this.hasMultiOrderContracts,
        hasInvoices: hasInvoices ?? this.hasInvoices,
        hasBillingWorksheets: hasBillingWorksheets ?? this.hasBillingWorksheets,
        hasMultiOrderInvoices: hasMultiOrderInvoices ?? this.hasMultiOrderInvoices,
        totalReplacementCost: totalReplacementCost ?? this.totalReplacementCost,
        presentationLayerId: presentationLayerId ?? this.presentationLayerId,
        presentationLayer: presentationLayer ?? this.presentationLayer,
        isManualSort: isManualSort ?? this.isManualSort,
        quoteOrderTitle: quoteOrderTitle ?? this.quoteOrderTitle,
        unassignedSubs: unassignedSubs ?? this.unassignedSubs,
        nonTaxable: nonTaxable ?? this.nonTaxable,
        enableProjects: enableProjects ?? this.enableProjects,
        projectId: projectId ?? this.projectId,
        projectNumber: projectNumber ?? this.projectNumber,
        project: project ?? this.project,
        projectDrawingsId: projectDrawingsId ?? this.projectDrawingsId,
        projectDrawings: projectDrawings ?? this.projectDrawings,
        projectItemsOrderedId: projectItemsOrderedId ?? this.projectItemsOrderedId,
        projectItemsOrdered: projectItemsOrdered ?? this.projectItemsOrdered,
        projectDropShipId: projectDropShipId ?? this.projectDropShipId,
        projectDropShip: projectDropShip ?? this.projectDropShip,
        projectAsBuildId: projectAsBuildId ?? this.projectAsBuildId,
        projectAsBuild: projectAsBuild ?? this.projectAsBuild,
        projectCommissioningId: projectCommissioningId ?? this.projectCommissioningId,
        projectCommissioning: projectCommissioning ?? this.projectCommissioning,
        projectDepositId: projectDepositId ?? this.projectDepositId,
        projectDeposit: projectDeposit ?? this.projectDeposit,
        inputByUserId: inputByUserId ?? this.inputByUserId,
        modifiedByUserId: modifiedByUserId ?? this.modifiedByUserId,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes: defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentQuoteQuoteDocument {
  WebApiModulesAgentQuoteQuoteDocument({
    this.quoteId,
    this.copying,
    this.documentId,
    this.documentTypeId,
    this.uniqueId1,
    this.uniqueId2,
    this.uniqueId1Int,
    this.description,
    this.inputByUsersId,
    this.attachDate,
    this.attachTime,
    this.attachToEmail,
    this.inactive,
    this.dateStamp,
    this.extension,
    this.documentType,
    this.inputBy,
    this.hasImage,
    this.hasFile,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAgentQuoteQuoteDocument.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentQuoteQuoteDocumentFromJson(json);

  @JsonKey(name: 'QuoteId')
  final String? quoteId;
  @JsonKey(name: 'copying')
  final bool? copying;
  @JsonKey(name: 'DocumentId')
  final String? documentId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'UniqueId1')
  final String? uniqueId1;
  @JsonKey(name: 'UniqueId2')
  final String? uniqueId2;
  @JsonKey(name: 'UniqueId1Int')
  final int? uniqueId1Int;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'InputByUsersId')
  final String? inputByUsersId;
  @JsonKey(name: 'AttachDate')
  final String? attachDate;
  @JsonKey(name: 'AttachTime')
  final String? attachTime;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'Extension')
  final String? extension;
  @JsonKey(name: 'DocumentType')
  final String? documentType;
  @JsonKey(name: 'InputBy')
  final String? inputBy;
  @JsonKey(name: 'HasImage')
  final bool? hasImage;
  @JsonKey(name: 'HasFile')
  final bool? hasFile;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory = _$WebApiModulesAgentQuoteQuoteDocumentFromJson;
  static const toJsonFactory = _$WebApiModulesAgentQuoteQuoteDocumentToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentQuoteQuoteDocumentToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentQuoteQuoteDocument &&
            (identical(other.quoteId, quoteId) ||
                const DeepCollectionEquality()
                    .equals(other.quoteId, quoteId)) &&
            (identical(other.copying, copying) ||
                const DeepCollectionEquality()
                    .equals(other.copying, copying)) &&
            (identical(other.documentId, documentId) ||
                const DeepCollectionEquality()
                    .equals(other.documentId, documentId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.uniqueId1, uniqueId1) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1, uniqueId1)) &&
            (identical(other.uniqueId2, uniqueId2) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId2, uniqueId2)) &&
            (identical(other.uniqueId1Int, uniqueId1Int) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1Int, uniqueId1Int)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.inputByUsersId, inputByUsersId) ||
                const DeepCollectionEquality()
                    .equals(other.inputByUsersId, inputByUsersId)) &&
            (identical(other.attachDate, attachDate) ||
                const DeepCollectionEquality()
                    .equals(other.attachDate, attachDate)) &&
            (identical(other.attachTime, attachTime) ||
                const DeepCollectionEquality()
                    .equals(other.attachTime, attachTime)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.extension, extension) ||
                const DeepCollectionEquality()
                    .equals(other.extension, extension)) &&
            (identical(other.documentType, documentType) ||
                const DeepCollectionEquality()
                    .equals(other.documentType, documentType)) &&
            (identical(other.inputBy, inputBy) ||
                const DeepCollectionEquality()
                    .equals(other.inputBy, inputBy)) &&
            (identical(other.hasImage, hasImage) ||
                const DeepCollectionEquality()
                    .equals(other.hasImage, hasImage)) &&
            (identical(other.hasFile, hasFile) ||
                const DeepCollectionEquality()
                    .equals(other.hasFile, hasFile)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality().equals(other.filePath, filePath)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesAgentQuoteQuoteDocumentExtension
    on WebApiModulesAgentQuoteQuoteDocument {
  WebApiModulesAgentQuoteQuoteDocument copyWith(
      {String? quoteId,
      bool? copying,
      String? documentId,
      String? documentTypeId,
      String? uniqueId1,
      String? uniqueId2,
      int? uniqueId1Int,
      String? description,
      String? inputByUsersId,
      String? attachDate,
      String? attachTime,
      bool? attachToEmail,
      bool? inactive,
      String? dateStamp,
      String? extension,
      String? documentType,
      String? inputBy,
      bool? hasImage,
      bool? hasFile,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAgentQuoteQuoteDocument(
        quoteId: quoteId ?? this.quoteId,
        copying: copying ?? this.copying,
        documentId: documentId ?? this.documentId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        uniqueId1: uniqueId1 ?? this.uniqueId1,
        uniqueId2: uniqueId2 ?? this.uniqueId2,
        uniqueId1Int: uniqueId1Int ?? this.uniqueId1Int,
        description: description ?? this.description,
        inputByUsersId: inputByUsersId ?? this.inputByUsersId,
        attachDate: attachDate ?? this.attachDate,
        attachTime: attachTime ?? this.attachTime,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        dateStamp: dateStamp ?? this.dateStamp,
        extension: extension ?? this.extension,
        documentType: documentType ?? this.documentType,
        inputBy: inputBy ?? this.inputBy,
        hasImage: hasImage ?? this.hasImage,
        hasFile: hasFile ?? this.hasFile,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentQuoteQuoteDocumentPostRequest {
  WebApiModulesAgentQuoteQuoteDocumentPostRequest({
    this.quoteId,
    this.documentTypeId,
    this.description,
    this.attachToEmail,
    this.inactive,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
  });

  factory WebApiModulesAgentQuoteQuoteDocumentPostRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentQuoteQuoteDocumentPostRequestFromJson(json);

  @JsonKey(name: 'QuoteId')
  final String? quoteId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  static const fromJsonFactory =
      _$WebApiModulesAgentQuoteQuoteDocumentPostRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentQuoteQuoteDocumentPostRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentQuoteQuoteDocumentPostRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentQuoteQuoteDocumentPostRequest &&
            (identical(other.quoteId, quoteId) ||
                const DeepCollectionEquality()
                    .equals(other.quoteId, quoteId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)));
  }
}

extension $WebApiModulesAgentQuoteQuoteDocumentPostRequestExtension
    on WebApiModulesAgentQuoteQuoteDocumentPostRequest {
  WebApiModulesAgentQuoteQuoteDocumentPostRequest copyWith(
      {String? quoteId,
      String? documentTypeId,
      String? description,
      bool? attachToEmail,
      bool? inactive,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath}) {
    return WebApiModulesAgentQuoteQuoteDocumentPostRequest(
        quoteId: quoteId ?? this.quoteId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        description: description ?? this.description,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentQuoteQuoteDocumentPutRequest {
  WebApiModulesAgentQuoteQuoteDocumentPutRequest({
    this.quoteId,
    this.documentId,
    this.documentTypeId,
    this.description,
    this.attachToEmail,
    this.inactive,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
  });

  factory WebApiModulesAgentQuoteQuoteDocumentPutRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentQuoteQuoteDocumentPutRequestFromJson(json);

  @JsonKey(name: 'QuoteId')
  final String? quoteId;
  @JsonKey(name: 'DocumentId')
  final String? documentId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  static const fromJsonFactory =
      _$WebApiModulesAgentQuoteQuoteDocumentPutRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentQuoteQuoteDocumentPutRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentQuoteQuoteDocumentPutRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentQuoteQuoteDocumentPutRequest &&
            (identical(other.quoteId, quoteId) ||
                const DeepCollectionEquality()
                    .equals(other.quoteId, quoteId)) &&
            (identical(other.documentId, documentId) ||
                const DeepCollectionEquality()
                    .equals(other.documentId, documentId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)));
  }
}

extension $WebApiModulesAgentQuoteQuoteDocumentPutRequestExtension
    on WebApiModulesAgentQuoteQuoteDocumentPutRequest {
  WebApiModulesAgentQuoteQuoteDocumentPutRequest copyWith(
      {String? quoteId,
      String? documentId,
      String? documentTypeId,
      String? description,
      bool? attachToEmail,
      bool? inactive,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath}) {
    return WebApiModulesAgentQuoteQuoteDocumentPutRequest(
        quoteId: quoteId ?? this.quoteId,
        documentId: documentId ?? this.documentId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        description: description ?? this.description,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentVendorVendor {
  WebApiModulesAgentVendorVendor({
    this.vendorId,
    this.vendorNameType,
    this.vendorNumber,
    this.federalIdNumber,
    this.officeLocationId,
    this.officeLocation,
    this.vendor,
    this.salutation,
    this.firstName,
    this.middleInitial,
    this.lastName,
    this.vendorDisplayName,
    this.address1,
    this.address2,
    this.city,
    this.state,
    this.countryId,
    this.country,
    this.zipCode,
    this.vendorClassId,
    this.vendorClass,
    this.phone,
    this.fax,
    this.phoneTollFree,
    this.otherPhone,
    this.webAddress,
    this.email,
    this.activeDate,
    this.inactiveDate,
    this.subRent,
    this.subSales,
    this.subMisc,
    this.subLabor,
    this.subVehicle,
    this.repair,
    this.rentalInventory,
    this.salesPartsInventory,
    this.manufacturer,
    this.freight,
    this.insurance,
    this.consignment,
    this.defaultSubRentDaysPerWeek,
    this.defaultSubRentDiscountPercent,
    this.defaultSubSaleDiscountPercent,
    this.defaultRate,
    this.billingCycleId,
    this.billingCycle,
    this.paymentTermsId,
    this.paymentTerms,
    this.accountNumber,
    this.defaultPoClassificationId,
    this.defaultPoClassification,
    this.organizationTypeId,
    this.organizationType,
    this.multipleCurrencies,
    this.defaultCurrencyId,
    this.defaultCurrencyCode,
    this.defaultCurrency,
    this.defaultCurrencySymbol,
    this.remitAttention1,
    this.remitAttention2,
    this.remitAddress1,
    this.remitAddress2,
    this.remitCity,
    this.remitState,
    this.remitCountryId,
    this.remitCountry,
    this.remitZipCode,
    this.remitPayeeNo,
    this.externalId,
    this.automaticallyAdjustContractDates,
    this.shippingTrackingLink,
    this.defaultOutgoingDeliveryType,
    this.defaultIncomingDeliveryType,
    this.customerId,
    this.customer,
    this.inputDate,
    this.lastModifiedDate,
    this.primaryContactId,
    this.primaryContact,
    this.primaryContactPhone,
    this.primaryContactExtension,
    this.inactive,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAgentVendorVendor.fromJson(Map<String, dynamic> json) =>
      _$WebApiModulesAgentVendorVendorFromJson(json);

  @JsonKey(name: 'VendorId')
  final String? vendorId;
  @JsonKey(name: 'VendorNameType')
  final String? vendorNameType;
  @JsonKey(name: 'VendorNumber')
  final String? vendorNumber;
  @JsonKey(name: 'FederalIdNumber')
  final String? federalIdNumber;
  @JsonKey(name: 'OfficeLocationId')
  final String? officeLocationId;
  @JsonKey(name: 'OfficeLocation')
  final String? officeLocation;
  @JsonKey(name: 'Vendor')
  final String? vendor;
  @JsonKey(name: 'Salutation')
  final String? salutation;
  @JsonKey(name: 'FirstName')
  final String? firstName;
  @JsonKey(name: 'MiddleInitial')
  final String? middleInitial;
  @JsonKey(name: 'LastName')
  final String? lastName;
  @JsonKey(name: 'VendorDisplayName')
  final String? vendorDisplayName;
  @JsonKey(name: 'Address1')
  final String? address1;
  @JsonKey(name: 'Address2')
  final String? address2;
  @JsonKey(name: 'City')
  final String? city;
  @JsonKey(name: 'State')
  final String? state;
  @JsonKey(name: 'CountryId')
  final String? countryId;
  @JsonKey(name: 'Country')
  final String? country;
  @JsonKey(name: 'ZipCode')
  final String? zipCode;
  @JsonKey(name: 'VendorClassId')
  final String? vendorClassId;
  @JsonKey(name: 'VendorClass')
  final String? vendorClass;
  @JsonKey(name: 'Phone')
  final String? phone;
  @JsonKey(name: 'Fax')
  final String? fax;
  @JsonKey(name: 'PhoneTollFree')
  final String? phoneTollFree;
  @JsonKey(name: 'OtherPhone')
  final String? otherPhone;
  @JsonKey(name: 'WebAddress')
  final String? webAddress;
  @JsonKey(name: 'Email')
  final String? email;
  @JsonKey(name: 'ActiveDate')
  final String? activeDate;
  @JsonKey(name: 'InactiveDate')
  final String? inactiveDate;
  @JsonKey(name: 'SubRent')
  final bool? subRent;
  @JsonKey(name: 'SubSales')
  final bool? subSales;
  @JsonKey(name: 'SubMisc')
  final bool? subMisc;
  @JsonKey(name: 'SubLabor')
  final bool? subLabor;
  @JsonKey(name: 'SubVehicle')
  final bool? subVehicle;
  @JsonKey(name: 'Repair')
  final bool? repair;
  @JsonKey(name: 'RentalInventory')
  final bool? rentalInventory;
  @JsonKey(name: 'SalesPartsInventory')
  final bool? salesPartsInventory;
  @JsonKey(name: 'Manufacturer')
  final bool? manufacturer;
  @JsonKey(name: 'Freight')
  final bool? freight;
  @JsonKey(name: 'Insurance')
  final bool? insurance;
  @JsonKey(name: 'Consignment')
  final bool? consignment;
  @JsonKey(name: 'DefaultSubRentDaysPerWeek')
  final double? defaultSubRentDaysPerWeek;
  @JsonKey(name: 'DefaultSubRentDiscountPercent')
  final double? defaultSubRentDiscountPercent;
  @JsonKey(name: 'DefaultSubSaleDiscountPercent')
  final double? defaultSubSaleDiscountPercent;
  @JsonKey(name: 'DefaultRate')
  final String? defaultRate;
  @JsonKey(name: 'BillingCycleId')
  final String? billingCycleId;
  @JsonKey(name: 'BillingCycle')
  final String? billingCycle;
  @JsonKey(name: 'PaymentTermsId')
  final String? paymentTermsId;
  @JsonKey(name: 'PaymentTerms')
  final String? paymentTerms;
  @JsonKey(name: 'AccountNumber')
  final String? accountNumber;
  @JsonKey(name: 'DefaultPoClassificationId')
  final String? defaultPoClassificationId;
  @JsonKey(name: 'DefaultPoClassification')
  final String? defaultPoClassification;
  @JsonKey(name: 'OrganizationTypeId')
  final String? organizationTypeId;
  @JsonKey(name: 'OrganizationType')
  final String? organizationType;
  @JsonKey(name: 'MultipleCurrencies')
  final bool? multipleCurrencies;
  @JsonKey(name: 'DefaultCurrencyId')
  final String? defaultCurrencyId;
  @JsonKey(name: 'DefaultCurrencyCode')
  final String? defaultCurrencyCode;
  @JsonKey(name: 'DefaultCurrency')
  final String? defaultCurrency;
  @JsonKey(name: 'DefaultCurrencySymbol')
  final String? defaultCurrencySymbol;
  @JsonKey(name: 'RemitAttention1')
  final String? remitAttention1;
  @JsonKey(name: 'RemitAttention2')
  final String? remitAttention2;
  @JsonKey(name: 'RemitAddress1')
  final String? remitAddress1;
  @JsonKey(name: 'RemitAddress2')
  final String? remitAddress2;
  @JsonKey(name: 'RemitCity')
  final String? remitCity;
  @JsonKey(name: 'RemitState')
  final String? remitState;
  @JsonKey(name: 'RemitCountryId')
  final String? remitCountryId;
  @JsonKey(name: 'RemitCountry')
  final String? remitCountry;
  @JsonKey(name: 'RemitZipCode')
  final String? remitZipCode;
  @JsonKey(name: 'RemitPayeeNo')
  final String? remitPayeeNo;
  @JsonKey(name: 'ExternalId')
  final String? externalId;
  @JsonKey(name: 'AutomaticallyAdjustContractDates')
  final bool? automaticallyAdjustContractDates;
  @JsonKey(name: 'ShippingTrackingLink')
  final String? shippingTrackingLink;
  @JsonKey(name: 'DefaultOutgoingDeliveryType')
  final String? defaultOutgoingDeliveryType;
  @JsonKey(name: 'DefaultIncomingDeliveryType')
  final String? defaultIncomingDeliveryType;
  @JsonKey(name: 'CustomerId')
  final String? customerId;
  @JsonKey(name: 'Customer')
  final String? customer;
  @JsonKey(name: 'InputDate')
  final String? inputDate;
  @JsonKey(name: 'LastModifiedDate')
  final String? lastModifiedDate;
  @JsonKey(name: 'PrimaryContactId')
  final String? primaryContactId;
  @JsonKey(name: 'PrimaryContact')
  final String? primaryContact;
  @JsonKey(name: 'PrimaryContactPhone')
  final String? primaryContactPhone;
  @JsonKey(name: 'PrimaryContactExtension')
  final String? primaryContactExtension;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory = _$WebApiModulesAgentVendorVendorFromJson;
  static const toJsonFactory = _$WebApiModulesAgentVendorVendorToJson;
  Map<String, dynamic> toJson() => _$WebApiModulesAgentVendorVendorToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentVendorVendor &&
            (identical(other.vendorId, vendorId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorId, vendorId)) &&
            (identical(other.vendorNameType, vendorNameType) ||
                const DeepCollectionEquality()
                    .equals(other.vendorNameType, vendorNameType)) &&
            (identical(other.vendorNumber, vendorNumber) ||
                const DeepCollectionEquality()
                    .equals(other.vendorNumber, vendorNumber)) &&
            (identical(other.federalIdNumber, federalIdNumber) ||
                const DeepCollectionEquality()
                    .equals(other.federalIdNumber, federalIdNumber)) &&
            (identical(other.officeLocationId, officeLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocationId, officeLocationId)) &&
            (identical(other.officeLocation, officeLocation) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocation, officeLocation)) &&
            (identical(other.vendor, vendor) ||
                const DeepCollectionEquality().equals(other.vendor, vendor)) &&
            (identical(other.salutation, salutation) ||
                const DeepCollectionEquality()
                    .equals(other.salutation, salutation)) &&
            (identical(other.firstName, firstName) ||
                const DeepCollectionEquality()
                    .equals(other.firstName, firstName)) &&
            (identical(other.middleInitial, middleInitial) ||
                const DeepCollectionEquality()
                    .equals(other.middleInitial, middleInitial)) &&
            (identical(other.lastName, lastName) ||
                const DeepCollectionEquality()
                    .equals(other.lastName, lastName)) &&
            (identical(other.vendorDisplayName, vendorDisplayName) ||
                const DeepCollectionEquality()
                    .equals(other.vendorDisplayName, vendorDisplayName)) &&
            (identical(other.address1, address1) ||
                const DeepCollectionEquality()
                    .equals(other.address1, address1)) &&
            (identical(other.address2, address2) ||
                const DeepCollectionEquality()
                    .equals(other.address2, address2)) &&
            (identical(other.city, city) ||
                const DeepCollectionEquality().equals(other.city, city)) &&
            (identical(other.state, state) ||
                const DeepCollectionEquality().equals(other.state, state)) &&
            (identical(other.countryId, countryId) ||
                const DeepCollectionEquality()
                    .equals(other.countryId, countryId)) &&
            (identical(other.country, country) ||
                const DeepCollectionEquality()
                    .equals(other.country, country)) &&
            (identical(other.zipCode, zipCode) ||
                const DeepCollectionEquality()
                    .equals(other.zipCode, zipCode)) &&
            (identical(other.vendorClassId, vendorClassId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorClassId, vendorClassId)) &&
            (identical(other.vendorClass, vendorClass) ||
                const DeepCollectionEquality()
                    .equals(other.vendorClass, vendorClass)) &&
            (identical(other.phone, phone) ||
                const DeepCollectionEquality().equals(other.phone, phone)) &&
            (identical(other.fax, fax) ||
                const DeepCollectionEquality().equals(other.fax, fax)) &&
            (identical(other.phoneTollFree, phoneTollFree) ||
                const DeepCollectionEquality()
                    .equals(other.phoneTollFree, phoneTollFree)) &&
            (identical(other.otherPhone, otherPhone) || const DeepCollectionEquality().equals(other.otherPhone, otherPhone)) &&
            (identical(other.webAddress, webAddress) || const DeepCollectionEquality().equals(other.webAddress, webAddress)) &&
            (identical(other.email, email) || const DeepCollectionEquality().equals(other.email, email)) &&
            (identical(other.activeDate, activeDate) || const DeepCollectionEquality().equals(other.activeDate, activeDate)) &&
            (identical(other.inactiveDate, inactiveDate) || const DeepCollectionEquality().equals(other.inactiveDate, inactiveDate)) &&
            (identical(other.subRent, subRent) || const DeepCollectionEquality().equals(other.subRent, subRent)) &&
            (identical(other.subSales, subSales) || const DeepCollectionEquality().equals(other.subSales, subSales)) &&
            (identical(other.subMisc, subMisc) || const DeepCollectionEquality().equals(other.subMisc, subMisc)) &&
            (identical(other.subLabor, subLabor) || const DeepCollectionEquality().equals(other.subLabor, subLabor)) &&
            (identical(other.subVehicle, subVehicle) || const DeepCollectionEquality().equals(other.subVehicle, subVehicle)) &&
            (identical(other.repair, repair) || const DeepCollectionEquality().equals(other.repair, repair)) &&
            (identical(other.rentalInventory, rentalInventory) || const DeepCollectionEquality().equals(other.rentalInventory, rentalInventory)) &&
            (identical(other.salesPartsInventory, salesPartsInventory) || const DeepCollectionEquality().equals(other.salesPartsInventory, salesPartsInventory)) &&
            (identical(other.manufacturer, manufacturer) || const DeepCollectionEquality().equals(other.manufacturer, manufacturer)) &&
            (identical(other.freight, freight) || const DeepCollectionEquality().equals(other.freight, freight)) &&
            (identical(other.insurance, insurance) || const DeepCollectionEquality().equals(other.insurance, insurance)) &&
            (identical(other.consignment, consignment) || const DeepCollectionEquality().equals(other.consignment, consignment)) &&
            (identical(other.defaultSubRentDaysPerWeek, defaultSubRentDaysPerWeek) || const DeepCollectionEquality().equals(other.defaultSubRentDaysPerWeek, defaultSubRentDaysPerWeek)) &&
            (identical(other.defaultSubRentDiscountPercent, defaultSubRentDiscountPercent) || const DeepCollectionEquality().equals(other.defaultSubRentDiscountPercent, defaultSubRentDiscountPercent)) &&
            (identical(other.defaultSubSaleDiscountPercent, defaultSubSaleDiscountPercent) || const DeepCollectionEquality().equals(other.defaultSubSaleDiscountPercent, defaultSubSaleDiscountPercent)) &&
            (identical(other.defaultRate, defaultRate) || const DeepCollectionEquality().equals(other.defaultRate, defaultRate)) &&
            (identical(other.billingCycleId, billingCycleId) || const DeepCollectionEquality().equals(other.billingCycleId, billingCycleId)) &&
            (identical(other.billingCycle, billingCycle) || const DeepCollectionEquality().equals(other.billingCycle, billingCycle)) &&
            (identical(other.paymentTermsId, paymentTermsId) || const DeepCollectionEquality().equals(other.paymentTermsId, paymentTermsId)) &&
            (identical(other.paymentTerms, paymentTerms) || const DeepCollectionEquality().equals(other.paymentTerms, paymentTerms)) &&
            (identical(other.accountNumber, accountNumber) || const DeepCollectionEquality().equals(other.accountNumber, accountNumber)) &&
            (identical(other.defaultPoClassificationId, defaultPoClassificationId) || const DeepCollectionEquality().equals(other.defaultPoClassificationId, defaultPoClassificationId)) &&
            (identical(other.defaultPoClassification, defaultPoClassification) || const DeepCollectionEquality().equals(other.defaultPoClassification, defaultPoClassification)) &&
            (identical(other.organizationTypeId, organizationTypeId) || const DeepCollectionEquality().equals(other.organizationTypeId, organizationTypeId)) &&
            (identical(other.organizationType, organizationType) || const DeepCollectionEquality().equals(other.organizationType, organizationType)) &&
            (identical(other.multipleCurrencies, multipleCurrencies) || const DeepCollectionEquality().equals(other.multipleCurrencies, multipleCurrencies)) &&
            (identical(other.defaultCurrencyId, defaultCurrencyId) || const DeepCollectionEquality().equals(other.defaultCurrencyId, defaultCurrencyId)) &&
            (identical(other.defaultCurrencyCode, defaultCurrencyCode) || const DeepCollectionEquality().equals(other.defaultCurrencyCode, defaultCurrencyCode)) &&
            (identical(other.defaultCurrency, defaultCurrency) || const DeepCollectionEquality().equals(other.defaultCurrency, defaultCurrency)) &&
            (identical(other.defaultCurrencySymbol, defaultCurrencySymbol) || const DeepCollectionEquality().equals(other.defaultCurrencySymbol, defaultCurrencySymbol)) &&
            (identical(other.remitAttention1, remitAttention1) || const DeepCollectionEquality().equals(other.remitAttention1, remitAttention1)) &&
            (identical(other.remitAttention2, remitAttention2) || const DeepCollectionEquality().equals(other.remitAttention2, remitAttention2)) &&
            (identical(other.remitAddress1, remitAddress1) || const DeepCollectionEquality().equals(other.remitAddress1, remitAddress1)) &&
            (identical(other.remitAddress2, remitAddress2) || const DeepCollectionEquality().equals(other.remitAddress2, remitAddress2)) &&
            (identical(other.remitCity, remitCity) || const DeepCollectionEquality().equals(other.remitCity, remitCity)) &&
            (identical(other.remitState, remitState) || const DeepCollectionEquality().equals(other.remitState, remitState)) &&
            (identical(other.remitCountryId, remitCountryId) || const DeepCollectionEquality().equals(other.remitCountryId, remitCountryId)) &&
            (identical(other.remitCountry, remitCountry) || const DeepCollectionEquality().equals(other.remitCountry, remitCountry)) &&
            (identical(other.remitZipCode, remitZipCode) || const DeepCollectionEquality().equals(other.remitZipCode, remitZipCode)) &&
            (identical(other.remitPayeeNo, remitPayeeNo) || const DeepCollectionEquality().equals(other.remitPayeeNo, remitPayeeNo)) &&
            (identical(other.externalId, externalId) || const DeepCollectionEquality().equals(other.externalId, externalId)) &&
            (identical(other.automaticallyAdjustContractDates, automaticallyAdjustContractDates) || const DeepCollectionEquality().equals(other.automaticallyAdjustContractDates, automaticallyAdjustContractDates)) &&
            (identical(other.shippingTrackingLink, shippingTrackingLink) || const DeepCollectionEquality().equals(other.shippingTrackingLink, shippingTrackingLink)) &&
            (identical(other.defaultOutgoingDeliveryType, defaultOutgoingDeliveryType) || const DeepCollectionEquality().equals(other.defaultOutgoingDeliveryType, defaultOutgoingDeliveryType)) &&
            (identical(other.defaultIncomingDeliveryType, defaultIncomingDeliveryType) || const DeepCollectionEquality().equals(other.defaultIncomingDeliveryType, defaultIncomingDeliveryType)) &&
            (identical(other.customerId, customerId) || const DeepCollectionEquality().equals(other.customerId, customerId)) &&
            (identical(other.customer, customer) || const DeepCollectionEquality().equals(other.customer, customer)) &&
            (identical(other.inputDate, inputDate) || const DeepCollectionEquality().equals(other.inputDate, inputDate)) &&
            (identical(other.lastModifiedDate, lastModifiedDate) || const DeepCollectionEquality().equals(other.lastModifiedDate, lastModifiedDate)) &&
            (identical(other.primaryContactId, primaryContactId) || const DeepCollectionEquality().equals(other.primaryContactId, primaryContactId)) &&
            (identical(other.primaryContact, primaryContact) || const DeepCollectionEquality().equals(other.primaryContact, primaryContact)) &&
            (identical(other.primaryContactPhone, primaryContactPhone) || const DeepCollectionEquality().equals(other.primaryContactPhone, primaryContactPhone)) &&
            (identical(other.primaryContactExtension, primaryContactExtension) || const DeepCollectionEquality().equals(other.primaryContactExtension, primaryContactExtension)) &&
            (identical(other.inactive, inactive) || const DeepCollectionEquality().equals(other.inactive, inactive)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesAgentVendorVendorExtension
    on WebApiModulesAgentVendorVendor {
  WebApiModulesAgentVendorVendor copyWith(
      {String? vendorId,
      String? vendorNameType,
      String? vendorNumber,
      String? federalIdNumber,
      String? officeLocationId,
      String? officeLocation,
      String? vendor,
      String? salutation,
      String? firstName,
      String? middleInitial,
      String? lastName,
      String? vendorDisplayName,
      String? address1,
      String? address2,
      String? city,
      String? state,
      String? countryId,
      String? country,
      String? zipCode,
      String? vendorClassId,
      String? vendorClass,
      String? phone,
      String? fax,
      String? phoneTollFree,
      String? otherPhone,
      String? webAddress,
      String? email,
      String? activeDate,
      String? inactiveDate,
      bool? subRent,
      bool? subSales,
      bool? subMisc,
      bool? subLabor,
      bool? subVehicle,
      bool? repair,
      bool? rentalInventory,
      bool? salesPartsInventory,
      bool? manufacturer,
      bool? freight,
      bool? insurance,
      bool? consignment,
      double? defaultSubRentDaysPerWeek,
      double? defaultSubRentDiscountPercent,
      double? defaultSubSaleDiscountPercent,
      String? defaultRate,
      String? billingCycleId,
      String? billingCycle,
      String? paymentTermsId,
      String? paymentTerms,
      String? accountNumber,
      String? defaultPoClassificationId,
      String? defaultPoClassification,
      String? organizationTypeId,
      String? organizationType,
      bool? multipleCurrencies,
      String? defaultCurrencyId,
      String? defaultCurrencyCode,
      String? defaultCurrency,
      String? defaultCurrencySymbol,
      String? remitAttention1,
      String? remitAttention2,
      String? remitAddress1,
      String? remitAddress2,
      String? remitCity,
      String? remitState,
      String? remitCountryId,
      String? remitCountry,
      String? remitZipCode,
      String? remitPayeeNo,
      String? externalId,
      bool? automaticallyAdjustContractDates,
      String? shippingTrackingLink,
      String? defaultOutgoingDeliveryType,
      String? defaultIncomingDeliveryType,
      String? customerId,
      String? customer,
      String? inputDate,
      String? lastModifiedDate,
      String? primaryContactId,
      String? primaryContact,
      String? primaryContactPhone,
      String? primaryContactExtension,
      bool? inactive,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAgentVendorVendor(
        vendorId: vendorId ?? this.vendorId,
        vendorNameType: vendorNameType ?? this.vendorNameType,
        vendorNumber: vendorNumber ?? this.vendorNumber,
        federalIdNumber: federalIdNumber ?? this.federalIdNumber,
        officeLocationId: officeLocationId ?? this.officeLocationId,
        officeLocation: officeLocation ?? this.officeLocation,
        vendor: vendor ?? this.vendor,
        salutation: salutation ?? this.salutation,
        firstName: firstName ?? this.firstName,
        middleInitial: middleInitial ?? this.middleInitial,
        lastName: lastName ?? this.lastName,
        vendorDisplayName: vendorDisplayName ?? this.vendorDisplayName,
        address1: address1 ?? this.address1,
        address2: address2 ?? this.address2,
        city: city ?? this.city,
        state: state ?? this.state,
        countryId: countryId ?? this.countryId,
        country: country ?? this.country,
        zipCode: zipCode ?? this.zipCode,
        vendorClassId: vendorClassId ?? this.vendorClassId,
        vendorClass: vendorClass ?? this.vendorClass,
        phone: phone ?? this.phone,
        fax: fax ?? this.fax,
        phoneTollFree: phoneTollFree ?? this.phoneTollFree,
        otherPhone: otherPhone ?? this.otherPhone,
        webAddress: webAddress ?? this.webAddress,
        email: email ?? this.email,
        activeDate: activeDate ?? this.activeDate,
        inactiveDate: inactiveDate ?? this.inactiveDate,
        subRent: subRent ?? this.subRent,
        subSales: subSales ?? this.subSales,
        subMisc: subMisc ?? this.subMisc,
        subLabor: subLabor ?? this.subLabor,
        subVehicle: subVehicle ?? this.subVehicle,
        repair: repair ?? this.repair,
        rentalInventory: rentalInventory ?? this.rentalInventory,
        salesPartsInventory: salesPartsInventory ?? this.salesPartsInventory,
        manufacturer: manufacturer ?? this.manufacturer,
        freight: freight ?? this.freight,
        insurance: insurance ?? this.insurance,
        consignment: consignment ?? this.consignment,
        defaultSubRentDaysPerWeek:
            defaultSubRentDaysPerWeek ?? this.defaultSubRentDaysPerWeek,
        defaultSubRentDiscountPercent:
            defaultSubRentDiscountPercent ?? this.defaultSubRentDiscountPercent,
        defaultSubSaleDiscountPercent:
            defaultSubSaleDiscountPercent ?? this.defaultSubSaleDiscountPercent,
        defaultRate: defaultRate ?? this.defaultRate,
        billingCycleId: billingCycleId ?? this.billingCycleId,
        billingCycle: billingCycle ?? this.billingCycle,
        paymentTermsId: paymentTermsId ?? this.paymentTermsId,
        paymentTerms: paymentTerms ?? this.paymentTerms,
        accountNumber: accountNumber ?? this.accountNumber,
        defaultPoClassificationId:
            defaultPoClassificationId ?? this.defaultPoClassificationId,
        defaultPoClassification:
            defaultPoClassification ?? this.defaultPoClassification,
        organizationTypeId: organizationTypeId ?? this.organizationTypeId,
        organizationType: organizationType ?? this.organizationType,
        multipleCurrencies: multipleCurrencies ?? this.multipleCurrencies,
        defaultCurrencyId: defaultCurrencyId ?? this.defaultCurrencyId,
        defaultCurrencyCode: defaultCurrencyCode ?? this.defaultCurrencyCode,
        defaultCurrency: defaultCurrency ?? this.defaultCurrency,
        defaultCurrencySymbol:
            defaultCurrencySymbol ?? this.defaultCurrencySymbol,
        remitAttention1: remitAttention1 ?? this.remitAttention1,
        remitAttention2: remitAttention2 ?? this.remitAttention2,
        remitAddress1: remitAddress1 ?? this.remitAddress1,
        remitAddress2: remitAddress2 ?? this.remitAddress2,
        remitCity: remitCity ?? this.remitCity,
        remitState: remitState ?? this.remitState,
        remitCountryId: remitCountryId ?? this.remitCountryId,
        remitCountry: remitCountry ?? this.remitCountry,
        remitZipCode: remitZipCode ?? this.remitZipCode,
        remitPayeeNo: remitPayeeNo ?? this.remitPayeeNo,
        externalId: externalId ?? this.externalId,
        automaticallyAdjustContractDates: automaticallyAdjustContractDates ??
            this.automaticallyAdjustContractDates,
        shippingTrackingLink: shippingTrackingLink ?? this.shippingTrackingLink,
        defaultOutgoingDeliveryType:
            defaultOutgoingDeliveryType ?? this.defaultOutgoingDeliveryType,
        defaultIncomingDeliveryType:
            defaultIncomingDeliveryType ?? this.defaultIncomingDeliveryType,
        customerId: customerId ?? this.customerId,
        customer: customer ?? this.customer,
        inputDate: inputDate ?? this.inputDate,
        lastModifiedDate: lastModifiedDate ?? this.lastModifiedDate,
        primaryContactId: primaryContactId ?? this.primaryContactId,
        primaryContact: primaryContact ?? this.primaryContact,
        primaryContactPhone: primaryContactPhone ?? this.primaryContactPhone,
        primaryContactExtension:
            primaryContactExtension ?? this.primaryContactExtension,
        inactive: inactive ?? this.inactive,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentVendorVendorDocument {
  WebApiModulesAgentVendorVendorDocument({
    this.vendorId,
    this.copying,
    this.documentId,
    this.documentTypeId,
    this.uniqueId1,
    this.uniqueId2,
    this.uniqueId1Int,
    this.description,
    this.inputByUsersId,
    this.attachDate,
    this.attachTime,
    this.attachToEmail,
    this.inactive,
    this.dateStamp,
    this.extension,
    this.documentType,
    this.inputBy,
    this.hasImage,
    this.hasFile,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesAgentVendorVendorDocument.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentVendorVendorDocumentFromJson(json);

  @JsonKey(name: 'VendorId')
  final String? vendorId;
  @JsonKey(name: 'copying')
  final bool? copying;
  @JsonKey(name: 'DocumentId')
  final String? documentId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'UniqueId1')
  final String? uniqueId1;
  @JsonKey(name: 'UniqueId2')
  final String? uniqueId2;
  @JsonKey(name: 'UniqueId1Int')
  final int? uniqueId1Int;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'InputByUsersId')
  final String? inputByUsersId;
  @JsonKey(name: 'AttachDate')
  final String? attachDate;
  @JsonKey(name: 'AttachTime')
  final String? attachTime;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'Extension')
  final String? extension;
  @JsonKey(name: 'DocumentType')
  final String? documentType;
  @JsonKey(name: 'InputBy')
  final String? inputBy;
  @JsonKey(name: 'HasImage')
  final bool? hasImage;
  @JsonKey(name: 'HasFile')
  final bool? hasFile;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesAgentVendorVendorDocumentFromJson;
  static const toJsonFactory = _$WebApiModulesAgentVendorVendorDocumentToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentVendorVendorDocumentToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentVendorVendorDocument &&
            (identical(other.vendorId, vendorId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorId, vendorId)) &&
            (identical(other.copying, copying) ||
                const DeepCollectionEquality()
                    .equals(other.copying, copying)) &&
            (identical(other.documentId, documentId) ||
                const DeepCollectionEquality()
                    .equals(other.documentId, documentId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.uniqueId1, uniqueId1) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1, uniqueId1)) &&
            (identical(other.uniqueId2, uniqueId2) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId2, uniqueId2)) &&
            (identical(other.uniqueId1Int, uniqueId1Int) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1Int, uniqueId1Int)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.inputByUsersId, inputByUsersId) ||
                const DeepCollectionEquality()
                    .equals(other.inputByUsersId, inputByUsersId)) &&
            (identical(other.attachDate, attachDate) ||
                const DeepCollectionEquality()
                    .equals(other.attachDate, attachDate)) &&
            (identical(other.attachTime, attachTime) ||
                const DeepCollectionEquality()
                    .equals(other.attachTime, attachTime)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.extension, extension) ||
                const DeepCollectionEquality()
                    .equals(other.extension, extension)) &&
            (identical(other.documentType, documentType) ||
                const DeepCollectionEquality()
                    .equals(other.documentType, documentType)) &&
            (identical(other.inputBy, inputBy) ||
                const DeepCollectionEquality()
                    .equals(other.inputBy, inputBy)) &&
            (identical(other.hasImage, hasImage) ||
                const DeepCollectionEquality()
                    .equals(other.hasImage, hasImage)) &&
            (identical(other.hasFile, hasFile) ||
                const DeepCollectionEquality()
                    .equals(other.hasFile, hasFile)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality().equals(other.filePath, filePath)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesAgentVendorVendorDocumentExtension
    on WebApiModulesAgentVendorVendorDocument {
  WebApiModulesAgentVendorVendorDocument copyWith(
      {String? vendorId,
      bool? copying,
      String? documentId,
      String? documentTypeId,
      String? uniqueId1,
      String? uniqueId2,
      int? uniqueId1Int,
      String? description,
      String? inputByUsersId,
      String? attachDate,
      String? attachTime,
      bool? attachToEmail,
      bool? inactive,
      String? dateStamp,
      String? extension,
      String? documentType,
      String? inputBy,
      bool? hasImage,
      bool? hasFile,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesAgentVendorVendorDocument(
        vendorId: vendorId ?? this.vendorId,
        copying: copying ?? this.copying,
        documentId: documentId ?? this.documentId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        uniqueId1: uniqueId1 ?? this.uniqueId1,
        uniqueId2: uniqueId2 ?? this.uniqueId2,
        uniqueId1Int: uniqueId1Int ?? this.uniqueId1Int,
        description: description ?? this.description,
        inputByUsersId: inputByUsersId ?? this.inputByUsersId,
        attachDate: attachDate ?? this.attachDate,
        attachTime: attachTime ?? this.attachTime,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        dateStamp: dateStamp ?? this.dateStamp,
        extension: extension ?? this.extension,
        documentType: documentType ?? this.documentType,
        inputBy: inputBy ?? this.inputBy,
        hasImage: hasImage ?? this.hasImage,
        hasFile: hasFile ?? this.hasFile,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentVendorVendorDocumentPostRequest {
  WebApiModulesAgentVendorVendorDocumentPostRequest({
    this.vendorId,
    this.documentTypeId,
    this.description,
    this.attachToEmail,
    this.inactive,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
  });

  factory WebApiModulesAgentVendorVendorDocumentPostRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentVendorVendorDocumentPostRequestFromJson(json);

  @JsonKey(name: 'VendorId')
  final String? vendorId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  static const fromJsonFactory =
      _$WebApiModulesAgentVendorVendorDocumentPostRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentVendorVendorDocumentPostRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentVendorVendorDocumentPostRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentVendorVendorDocumentPostRequest &&
            (identical(other.vendorId, vendorId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorId, vendorId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)));
  }
}

extension $WebApiModulesAgentVendorVendorDocumentPostRequestExtension
    on WebApiModulesAgentVendorVendorDocumentPostRequest {
  WebApiModulesAgentVendorVendorDocumentPostRequest copyWith(
      {String? vendorId,
      String? documentTypeId,
      String? description,
      bool? attachToEmail,
      bool? inactive,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath}) {
    return WebApiModulesAgentVendorVendorDocumentPostRequest(
        vendorId: vendorId ?? this.vendorId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        description: description ?? this.description,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesAgentVendorVendorDocumentPutRequest {
  WebApiModulesAgentVendorVendorDocumentPutRequest({
    this.vendorId,
    this.documentId,
    this.documentTypeId,
    this.description,
    this.attachToEmail,
    this.inactive,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
  });

  factory WebApiModulesAgentVendorVendorDocumentPutRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesAgentVendorVendorDocumentPutRequestFromJson(json);

  @JsonKey(name: 'VendorId')
  final String? vendorId;
  @JsonKey(name: 'DocumentId')
  final String? documentId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  static const fromJsonFactory =
      _$WebApiModulesAgentVendorVendorDocumentPutRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesAgentVendorVendorDocumentPutRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesAgentVendorVendorDocumentPutRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesAgentVendorVendorDocumentPutRequest &&
            (identical(other.vendorId, vendorId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorId, vendorId)) &&
            (identical(other.documentId, documentId) ||
                const DeepCollectionEquality()
                    .equals(other.documentId, documentId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)));
  }
}

extension $WebApiModulesAgentVendorVendorDocumentPutRequestExtension
    on WebApiModulesAgentVendorVendorDocumentPutRequest {
  WebApiModulesAgentVendorVendorDocumentPutRequest copyWith(
      {String? vendorId,
      String? documentId,
      String? documentTypeId,
      String? description,
      bool? attachToEmail,
      bool? inactive,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath}) {
    return WebApiModulesAgentVendorVendorDocumentPutRequest(
        vendorId: vendorId ?? this.vendorId,
        documentId: documentId ?? this.documentId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        description: description ?? this.description,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingBankAccountBankAccount {
  WebApiModulesBillingBankAccountBankAccount({
    this.bankAccountId,
    this.accountName,
    this.checkNumber,
    this.officeLocationId,
    this.location,
    this.currencyId,
    this.currency,
    this.currencyCode,
    this.currencySymbol,
    this.inactive,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesBillingBankAccountBankAccount.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingBankAccountBankAccountFromJson(json);

  @JsonKey(name: 'BankAccountId')
  final int? bankAccountId;
  @JsonKey(name: 'AccountName')
  final String? accountName;
  @JsonKey(name: 'CheckNumber')
  final String? checkNumber;
  @JsonKey(name: 'OfficeLocationId')
  final String? officeLocationId;
  @JsonKey(name: 'Location')
  final String? location;
  @JsonKey(name: 'CurrencyId')
  final String? currencyId;
  @JsonKey(name: 'Currency')
  final String? currency;
  @JsonKey(name: 'CurrencyCode')
  final String? currencyCode;
  @JsonKey(name: 'CurrencySymbol')
  final String? currencySymbol;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesBillingBankAccountBankAccountFromJson;
  static const toJsonFactory =
      _$WebApiModulesBillingBankAccountBankAccountToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingBankAccountBankAccountToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingBankAccountBankAccount &&
            (identical(other.bankAccountId, bankAccountId) ||
                const DeepCollectionEquality()
                    .equals(other.bankAccountId, bankAccountId)) &&
            (identical(other.accountName, accountName) ||
                const DeepCollectionEquality()
                    .equals(other.accountName, accountName)) &&
            (identical(other.checkNumber, checkNumber) ||
                const DeepCollectionEquality()
                    .equals(other.checkNumber, checkNumber)) &&
            (identical(other.officeLocationId, officeLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocationId, officeLocationId)) &&
            (identical(other.location, location) ||
                const DeepCollectionEquality()
                    .equals(other.location, location)) &&
            (identical(other.currencyId, currencyId) ||
                const DeepCollectionEquality()
                    .equals(other.currencyId, currencyId)) &&
            (identical(other.currency, currency) ||
                const DeepCollectionEquality()
                    .equals(other.currency, currency)) &&
            (identical(other.currencyCode, currencyCode) ||
                const DeepCollectionEquality()
                    .equals(other.currencyCode, currencyCode)) &&
            (identical(other.currencySymbol, currencySymbol) ||
                const DeepCollectionEquality()
                    .equals(other.currencySymbol, currencySymbol)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesBillingBankAccountBankAccountExtension
    on WebApiModulesBillingBankAccountBankAccount {
  WebApiModulesBillingBankAccountBankAccount copyWith(
      {int? bankAccountId,
      String? accountName,
      String? checkNumber,
      String? officeLocationId,
      String? location,
      String? currencyId,
      String? currency,
      String? currencyCode,
      String? currencySymbol,
      bool? inactive,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesBillingBankAccountBankAccount(
        bankAccountId: bankAccountId ?? this.bankAccountId,
        accountName: accountName ?? this.accountName,
        checkNumber: checkNumber ?? this.checkNumber,
        officeLocationId: officeLocationId ?? this.officeLocationId,
        location: location ?? this.location,
        currencyId: currencyId ?? this.currencyId,
        currency: currency ?? this.currency,
        currencyCode: currencyCode ?? this.currencyCode,
        currencySymbol: currencySymbol ?? this.currencySymbol,
        inactive: inactive ?? this.inactive,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingBillingBilling {
  WebApiModulesBillingBillingBilling({
    this.sessionId,
    this.billingId,
    this.customerId,
    this.customer,
    this.dealId,
    this.deal,
    this.flatPoId,
    this.flatPoBillingScheduleId,
    this.supplementalPoId,
    this.departmentId,
    this.department,
    this.orderId,
    this.orderNumber,
    this.orderDate,
    this.orderDescription,
    this.status,
    this.orderTypeId,
    this.orderTypeType,
    this.orderType,
    this.billingCycleId,
    this.billingCycle,
    this.billingCycleType,
    this.officeLocationId,
    this.billingStartDate,
    this.billingStopDate,
    this.billAsOfDate,
    this.isNoCharge,
    this.isRepair,
    this.isFlatPo,
    this.pendingPo,
    this.poNumber,
    this.poAmount,
    this.billingPeriodStartDate,
    this.billingPeriodEndDate,
    this.validchargeno,
    this.orbitsapchgmajor,
    this.orbitsapchgsub,
    this.orbitsapchgdetail,
    this.orbitsapchgdeal,
    this.orbitsapchgset,
    this.billingNotes,
    this.recType,
    this.worksheetId,
    this.billingCycleEvent,
    this.billingCycleEventOrder,
    this.inGroup,
    this.groupNumber,
    this.groupColor,
    this.doNotInvoice,
    this.agentId,
    this.agent,
    this.episodeNumber,
    this.isFinalLossAndDamage,
    this.billingTotal,
    this.hasRecurring,
    this.contractId,
    this.referenceNumber,
    this.billedHiatus,
    this.missingCrewBreakTime,
    this.missingCrewWorkTime,
    this.currencyId,
    this.currencyCode,
    this.currencySymbol,
    this.officeLocationDefaultCurrencyId,
    this.projectManagerId,
    this.projectManager,
    this.outsideSalesRepresentativeId,
    this.outsideSalesRepresentative,
    this.orderNumberColor,
    this.descriptionColor,
    this.billingStopDateColor,
    this.orderDateColor,
    this.purchaseOrderNumberColor,
    this.totalColor,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesBillingBillingBilling.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingBillingBillingFromJson(json);

  @JsonKey(name: 'SessionId')
  final String? sessionId;
  @JsonKey(name: 'BillingId')
  final int? billingId;
  @JsonKey(name: 'CustomerId')
  final String? customerId;
  @JsonKey(name: 'Customer')
  final String? customer;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'Deal')
  final String? deal;
  @JsonKey(name: 'FlatPoId')
  final String? flatPoId;
  @JsonKey(name: 'FlatPoBillingScheduleId')
  final String? flatPoBillingScheduleId;
  @JsonKey(name: 'SupplementalPoId')
  final String? supplementalPoId;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'Department')
  final String? department;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderNumber')
  final String? orderNumber;
  @JsonKey(name: 'OrderDate')
  final String? orderDate;
  @JsonKey(name: 'OrderDescription')
  final String? orderDescription;
  @JsonKey(name: 'Status')
  final String? status;
  @JsonKey(name: 'OrderTypeId')
  final String? orderTypeId;
  @JsonKey(name: 'OrderTypeType')
  final String? orderTypeType;
  @JsonKey(name: 'OrderType')
  final String? orderType;
  @JsonKey(name: 'BillingCycleId')
  final String? billingCycleId;
  @JsonKey(name: 'BillingCycle')
  final String? billingCycle;
  @JsonKey(name: 'BillingCycleType')
  final String? billingCycleType;
  @JsonKey(name: 'OfficeLocationId')
  final String? officeLocationId;
  @JsonKey(name: 'BillingStartDate')
  final String? billingStartDate;
  @JsonKey(name: 'BillingStopDate')
  final String? billingStopDate;
  @JsonKey(name: 'BillAsOfDate')
  final String? billAsOfDate;
  @JsonKey(name: 'IsNoCharge')
  final bool? isNoCharge;
  @JsonKey(name: 'IsRepair')
  final bool? isRepair;
  @JsonKey(name: 'IsFlatPo')
  final bool? isFlatPo;
  @JsonKey(name: 'PendingPo')
  final bool? pendingPo;
  @JsonKey(name: 'PoNumber')
  final String? poNumber;
  @JsonKey(name: 'PoAmount')
  final double? poAmount;
  @JsonKey(name: 'BillingPeriodStartDate')
  final String? billingPeriodStartDate;
  @JsonKey(name: 'BillingPeriodEndDate')
  final String? billingPeriodEndDate;
  @JsonKey(name: 'Validchargeno')
  final bool? validchargeno;
  @JsonKey(name: 'Orbitsapchgmajor')
  final String? orbitsapchgmajor;
  @JsonKey(name: 'Orbitsapchgsub')
  final String? orbitsapchgsub;
  @JsonKey(name: 'Orbitsapchgdetail')
  final String? orbitsapchgdetail;
  @JsonKey(name: 'Orbitsapchgdeal')
  final String? orbitsapchgdeal;
  @JsonKey(name: 'Orbitsapchgset')
  final String? orbitsapchgset;
  @JsonKey(name: 'BillingNotes')
  final bool? billingNotes;
  @JsonKey(name: 'RecType')
  final String? recType;
  @JsonKey(name: 'WorksheetId')
  final String? worksheetId;
  @JsonKey(name: 'BillingCycleEvent')
  final String? billingCycleEvent;
  @JsonKey(name: 'BillingCycleEventOrder')
  final int? billingCycleEventOrder;
  @JsonKey(name: 'InGroup')
  final bool? inGroup;
  @JsonKey(name: 'GroupNumber')
  final int? groupNumber;
  @JsonKey(name: 'GroupColor')
  final int? groupColor;
  @JsonKey(name: 'DoNotInvoice')
  final bool? doNotInvoice;
  @JsonKey(name: 'AgentId')
  final String? agentId;
  @JsonKey(name: 'Agent')
  final String? agent;
  @JsonKey(name: 'EpisodeNumber')
  final int? episodeNumber;
  @JsonKey(name: 'IsFinalLossAndDamage')
  final bool? isFinalLossAndDamage;
  @JsonKey(name: 'BillingTotal')
  final double? billingTotal;
  @JsonKey(name: 'HasRecurring')
  final bool? hasRecurring;
  @JsonKey(name: 'ContractId')
  final String? contractId;
  @JsonKey(name: 'ReferenceNumber')
  final String? referenceNumber;
  @JsonKey(name: 'BilledHiatus')
  final bool? billedHiatus;
  @JsonKey(name: 'MissingCrewBreakTime')
  final bool? missingCrewBreakTime;
  @JsonKey(name: 'MissingCrewWorkTime')
  final bool? missingCrewWorkTime;
  @JsonKey(name: 'CurrencyId')
  final String? currencyId;
  @JsonKey(name: 'CurrencyCode')
  final String? currencyCode;
  @JsonKey(name: 'CurrencySymbol')
  final String? currencySymbol;
  @JsonKey(name: 'OfficeLocationDefaultCurrencyId')
  final String? officeLocationDefaultCurrencyId;
  @JsonKey(name: 'ProjectManagerId')
  final String? projectManagerId;
  @JsonKey(name: 'ProjectManager')
  final String? projectManager;
  @JsonKey(name: 'OutsideSalesRepresentativeId')
  final String? outsideSalesRepresentativeId;
  @JsonKey(name: 'OutsideSalesRepresentative')
  final String? outsideSalesRepresentative;
  @JsonKey(name: 'OrderNumberColor')
  final String? orderNumberColor;
  @JsonKey(name: 'DescriptionColor')
  final String? descriptionColor;
  @JsonKey(name: 'BillingStopDateColor')
  final String? billingStopDateColor;
  @JsonKey(name: 'OrderDateColor')
  final String? orderDateColor;
  @JsonKey(name: 'PurchaseOrderNumberColor')
  final String? purchaseOrderNumberColor;
  @JsonKey(name: 'TotalColor')
  final String? totalColor;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory = _$WebApiModulesBillingBillingBillingFromJson;
  static const toJsonFactory = _$WebApiModulesBillingBillingBillingToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingBillingBillingToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingBillingBilling &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)) &&
            (identical(other.billingId, billingId) ||
                const DeepCollectionEquality()
                    .equals(other.billingId, billingId)) &&
            (identical(other.customerId, customerId) ||
                const DeepCollectionEquality()
                    .equals(other.customerId, customerId)) &&
            (identical(other.customer, customer) ||
                const DeepCollectionEquality()
                    .equals(other.customer, customer)) &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.deal, deal) ||
                const DeepCollectionEquality().equals(other.deal, deal)) &&
            (identical(other.flatPoId, flatPoId) ||
                const DeepCollectionEquality()
                    .equals(other.flatPoId, flatPoId)) &&
            (identical(other.flatPoBillingScheduleId, flatPoBillingScheduleId) ||
                const DeepCollectionEquality().equals(
                    other.flatPoBillingScheduleId, flatPoBillingScheduleId)) &&
            (identical(other.supplementalPoId, supplementalPoId) ||
                const DeepCollectionEquality()
                    .equals(other.supplementalPoId, supplementalPoId)) &&
            (identical(other.departmentId, departmentId) ||
                const DeepCollectionEquality()
                    .equals(other.departmentId, departmentId)) &&
            (identical(other.department, department) ||
                const DeepCollectionEquality()
                    .equals(other.department, department)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderNumber, orderNumber) ||
                const DeepCollectionEquality()
                    .equals(other.orderNumber, orderNumber)) &&
            (identical(other.orderDate, orderDate) ||
                const DeepCollectionEquality()
                    .equals(other.orderDate, orderDate)) &&
            (identical(other.orderDescription, orderDescription) ||
                const DeepCollectionEquality()
                    .equals(other.orderDescription, orderDescription)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.orderTypeId, orderTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.orderTypeId, orderTypeId)) &&
            (identical(other.orderTypeType, orderTypeType) ||
                const DeepCollectionEquality()
                    .equals(other.orderTypeType, orderTypeType)) &&
            (identical(other.orderType, orderType) ||
                const DeepCollectionEquality()
                    .equals(other.orderType, orderType)) &&
            (identical(other.billingCycleId, billingCycleId) || const DeepCollectionEquality().equals(other.billingCycleId, billingCycleId)) &&
            (identical(other.billingCycle, billingCycle) || const DeepCollectionEquality().equals(other.billingCycle, billingCycle)) &&
            (identical(other.billingCycleType, billingCycleType) || const DeepCollectionEquality().equals(other.billingCycleType, billingCycleType)) &&
            (identical(other.officeLocationId, officeLocationId) || const DeepCollectionEquality().equals(other.officeLocationId, officeLocationId)) &&
            (identical(other.billingStartDate, billingStartDate) || const DeepCollectionEquality().equals(other.billingStartDate, billingStartDate)) &&
            (identical(other.billingStopDate, billingStopDate) || const DeepCollectionEquality().equals(other.billingStopDate, billingStopDate)) &&
            (identical(other.billAsOfDate, billAsOfDate) || const DeepCollectionEquality().equals(other.billAsOfDate, billAsOfDate)) &&
            (identical(other.isNoCharge, isNoCharge) || const DeepCollectionEquality().equals(other.isNoCharge, isNoCharge)) &&
            (identical(other.isRepair, isRepair) || const DeepCollectionEquality().equals(other.isRepair, isRepair)) &&
            (identical(other.isFlatPo, isFlatPo) || const DeepCollectionEquality().equals(other.isFlatPo, isFlatPo)) &&
            (identical(other.pendingPo, pendingPo) || const DeepCollectionEquality().equals(other.pendingPo, pendingPo)) &&
            (identical(other.poNumber, poNumber) || const DeepCollectionEquality().equals(other.poNumber, poNumber)) &&
            (identical(other.poAmount, poAmount) || const DeepCollectionEquality().equals(other.poAmount, poAmount)) &&
            (identical(other.billingPeriodStartDate, billingPeriodStartDate) || const DeepCollectionEquality().equals(other.billingPeriodStartDate, billingPeriodStartDate)) &&
            (identical(other.billingPeriodEndDate, billingPeriodEndDate) || const DeepCollectionEquality().equals(other.billingPeriodEndDate, billingPeriodEndDate)) &&
            (identical(other.validchargeno, validchargeno) || const DeepCollectionEquality().equals(other.validchargeno, validchargeno)) &&
            (identical(other.orbitsapchgmajor, orbitsapchgmajor) || const DeepCollectionEquality().equals(other.orbitsapchgmajor, orbitsapchgmajor)) &&
            (identical(other.orbitsapchgsub, orbitsapchgsub) || const DeepCollectionEquality().equals(other.orbitsapchgsub, orbitsapchgsub)) &&
            (identical(other.orbitsapchgdetail, orbitsapchgdetail) || const DeepCollectionEquality().equals(other.orbitsapchgdetail, orbitsapchgdetail)) &&
            (identical(other.orbitsapchgdeal, orbitsapchgdeal) || const DeepCollectionEquality().equals(other.orbitsapchgdeal, orbitsapchgdeal)) &&
            (identical(other.orbitsapchgset, orbitsapchgset) || const DeepCollectionEquality().equals(other.orbitsapchgset, orbitsapchgset)) &&
            (identical(other.billingNotes, billingNotes) || const DeepCollectionEquality().equals(other.billingNotes, billingNotes)) &&
            (identical(other.recType, recType) || const DeepCollectionEquality().equals(other.recType, recType)) &&
            (identical(other.worksheetId, worksheetId) || const DeepCollectionEquality().equals(other.worksheetId, worksheetId)) &&
            (identical(other.billingCycleEvent, billingCycleEvent) || const DeepCollectionEquality().equals(other.billingCycleEvent, billingCycleEvent)) &&
            (identical(other.billingCycleEventOrder, billingCycleEventOrder) || const DeepCollectionEquality().equals(other.billingCycleEventOrder, billingCycleEventOrder)) &&
            (identical(other.inGroup, inGroup) || const DeepCollectionEquality().equals(other.inGroup, inGroup)) &&
            (identical(other.groupNumber, groupNumber) || const DeepCollectionEquality().equals(other.groupNumber, groupNumber)) &&
            (identical(other.groupColor, groupColor) || const DeepCollectionEquality().equals(other.groupColor, groupColor)) &&
            (identical(other.doNotInvoice, doNotInvoice) || const DeepCollectionEquality().equals(other.doNotInvoice, doNotInvoice)) &&
            (identical(other.agentId, agentId) || const DeepCollectionEquality().equals(other.agentId, agentId)) &&
            (identical(other.agent, agent) || const DeepCollectionEquality().equals(other.agent, agent)) &&
            (identical(other.episodeNumber, episodeNumber) || const DeepCollectionEquality().equals(other.episodeNumber, episodeNumber)) &&
            (identical(other.isFinalLossAndDamage, isFinalLossAndDamage) || const DeepCollectionEquality().equals(other.isFinalLossAndDamage, isFinalLossAndDamage)) &&
            (identical(other.billingTotal, billingTotal) || const DeepCollectionEquality().equals(other.billingTotal, billingTotal)) &&
            (identical(other.hasRecurring, hasRecurring) || const DeepCollectionEquality().equals(other.hasRecurring, hasRecurring)) &&
            (identical(other.contractId, contractId) || const DeepCollectionEquality().equals(other.contractId, contractId)) &&
            (identical(other.referenceNumber, referenceNumber) || const DeepCollectionEquality().equals(other.referenceNumber, referenceNumber)) &&
            (identical(other.billedHiatus, billedHiatus) || const DeepCollectionEquality().equals(other.billedHiatus, billedHiatus)) &&
            (identical(other.missingCrewBreakTime, missingCrewBreakTime) || const DeepCollectionEquality().equals(other.missingCrewBreakTime, missingCrewBreakTime)) &&
            (identical(other.missingCrewWorkTime, missingCrewWorkTime) || const DeepCollectionEquality().equals(other.missingCrewWorkTime, missingCrewWorkTime)) &&
            (identical(other.currencyId, currencyId) || const DeepCollectionEquality().equals(other.currencyId, currencyId)) &&
            (identical(other.currencyCode, currencyCode) || const DeepCollectionEquality().equals(other.currencyCode, currencyCode)) &&
            (identical(other.currencySymbol, currencySymbol) || const DeepCollectionEquality().equals(other.currencySymbol, currencySymbol)) &&
            (identical(other.officeLocationDefaultCurrencyId, officeLocationDefaultCurrencyId) || const DeepCollectionEquality().equals(other.officeLocationDefaultCurrencyId, officeLocationDefaultCurrencyId)) &&
            (identical(other.projectManagerId, projectManagerId) || const DeepCollectionEquality().equals(other.projectManagerId, projectManagerId)) &&
            (identical(other.projectManager, projectManager) || const DeepCollectionEquality().equals(other.projectManager, projectManager)) &&
            (identical(other.outsideSalesRepresentativeId, outsideSalesRepresentativeId) || const DeepCollectionEquality().equals(other.outsideSalesRepresentativeId, outsideSalesRepresentativeId)) &&
            (identical(other.outsideSalesRepresentative, outsideSalesRepresentative) || const DeepCollectionEquality().equals(other.outsideSalesRepresentative, outsideSalesRepresentative)) &&
            (identical(other.orderNumberColor, orderNumberColor) || const DeepCollectionEquality().equals(other.orderNumberColor, orderNumberColor)) &&
            (identical(other.descriptionColor, descriptionColor) || const DeepCollectionEquality().equals(other.descriptionColor, descriptionColor)) &&
            (identical(other.billingStopDateColor, billingStopDateColor) || const DeepCollectionEquality().equals(other.billingStopDateColor, billingStopDateColor)) &&
            (identical(other.orderDateColor, orderDateColor) || const DeepCollectionEquality().equals(other.orderDateColor, orderDateColor)) &&
            (identical(other.purchaseOrderNumberColor, purchaseOrderNumberColor) || const DeepCollectionEquality().equals(other.purchaseOrderNumberColor, purchaseOrderNumberColor)) &&
            (identical(other.totalColor, totalColor) || const DeepCollectionEquality().equals(other.totalColor, totalColor)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesBillingBillingBillingExtension
    on WebApiModulesBillingBillingBilling {
  WebApiModulesBillingBillingBilling copyWith(
      {String? sessionId,
      int? billingId,
      String? customerId,
      String? customer,
      String? dealId,
      String? deal,
      String? flatPoId,
      String? flatPoBillingScheduleId,
      String? supplementalPoId,
      String? departmentId,
      String? department,
      String? orderId,
      String? orderNumber,
      String? orderDate,
      String? orderDescription,
      String? status,
      String? orderTypeId,
      String? orderTypeType,
      String? orderType,
      String? billingCycleId,
      String? billingCycle,
      String? billingCycleType,
      String? officeLocationId,
      String? billingStartDate,
      String? billingStopDate,
      String? billAsOfDate,
      bool? isNoCharge,
      bool? isRepair,
      bool? isFlatPo,
      bool? pendingPo,
      String? poNumber,
      double? poAmount,
      String? billingPeriodStartDate,
      String? billingPeriodEndDate,
      bool? validchargeno,
      String? orbitsapchgmajor,
      String? orbitsapchgsub,
      String? orbitsapchgdetail,
      String? orbitsapchgdeal,
      String? orbitsapchgset,
      bool? billingNotes,
      String? recType,
      String? worksheetId,
      String? billingCycleEvent,
      int? billingCycleEventOrder,
      bool? inGroup,
      int? groupNumber,
      int? groupColor,
      bool? doNotInvoice,
      String? agentId,
      String? agent,
      int? episodeNumber,
      bool? isFinalLossAndDamage,
      double? billingTotal,
      bool? hasRecurring,
      String? contractId,
      String? referenceNumber,
      bool? billedHiatus,
      bool? missingCrewBreakTime,
      bool? missingCrewWorkTime,
      String? currencyId,
      String? currencyCode,
      String? currencySymbol,
      String? officeLocationDefaultCurrencyId,
      String? projectManagerId,
      String? projectManager,
      String? outsideSalesRepresentativeId,
      String? outsideSalesRepresentative,
      String? orderNumberColor,
      String? descriptionColor,
      String? billingStopDateColor,
      String? orderDateColor,
      String? purchaseOrderNumberColor,
      String? totalColor,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesBillingBillingBilling(
        sessionId: sessionId ?? this.sessionId,
        billingId: billingId ?? this.billingId,
        customerId: customerId ?? this.customerId,
        customer: customer ?? this.customer,
        dealId: dealId ?? this.dealId,
        deal: deal ?? this.deal,
        flatPoId: flatPoId ?? this.flatPoId,
        flatPoBillingScheduleId:
            flatPoBillingScheduleId ?? this.flatPoBillingScheduleId,
        supplementalPoId: supplementalPoId ?? this.supplementalPoId,
        departmentId: departmentId ?? this.departmentId,
        department: department ?? this.department,
        orderId: orderId ?? this.orderId,
        orderNumber: orderNumber ?? this.orderNumber,
        orderDate: orderDate ?? this.orderDate,
        orderDescription: orderDescription ?? this.orderDescription,
        status: status ?? this.status,
        orderTypeId: orderTypeId ?? this.orderTypeId,
        orderTypeType: orderTypeType ?? this.orderTypeType,
        orderType: orderType ?? this.orderType,
        billingCycleId: billingCycleId ?? this.billingCycleId,
        billingCycle: billingCycle ?? this.billingCycle,
        billingCycleType: billingCycleType ?? this.billingCycleType,
        officeLocationId: officeLocationId ?? this.officeLocationId,
        billingStartDate: billingStartDate ?? this.billingStartDate,
        billingStopDate: billingStopDate ?? this.billingStopDate,
        billAsOfDate: billAsOfDate ?? this.billAsOfDate,
        isNoCharge: isNoCharge ?? this.isNoCharge,
        isRepair: isRepair ?? this.isRepair,
        isFlatPo: isFlatPo ?? this.isFlatPo,
        pendingPo: pendingPo ?? this.pendingPo,
        poNumber: poNumber ?? this.poNumber,
        poAmount: poAmount ?? this.poAmount,
        billingPeriodStartDate:
            billingPeriodStartDate ?? this.billingPeriodStartDate,
        billingPeriodEndDate: billingPeriodEndDate ?? this.billingPeriodEndDate,
        validchargeno: validchargeno ?? this.validchargeno,
        orbitsapchgmajor: orbitsapchgmajor ?? this.orbitsapchgmajor,
        orbitsapchgsub: orbitsapchgsub ?? this.orbitsapchgsub,
        orbitsapchgdetail: orbitsapchgdetail ?? this.orbitsapchgdetail,
        orbitsapchgdeal: orbitsapchgdeal ?? this.orbitsapchgdeal,
        orbitsapchgset: orbitsapchgset ?? this.orbitsapchgset,
        billingNotes: billingNotes ?? this.billingNotes,
        recType: recType ?? this.recType,
        worksheetId: worksheetId ?? this.worksheetId,
        billingCycleEvent: billingCycleEvent ?? this.billingCycleEvent,
        billingCycleEventOrder:
            billingCycleEventOrder ?? this.billingCycleEventOrder,
        inGroup: inGroup ?? this.inGroup,
        groupNumber: groupNumber ?? this.groupNumber,
        groupColor: groupColor ?? this.groupColor,
        doNotInvoice: doNotInvoice ?? this.doNotInvoice,
        agentId: agentId ?? this.agentId,
        agent: agent ?? this.agent,
        episodeNumber: episodeNumber ?? this.episodeNumber,
        isFinalLossAndDamage: isFinalLossAndDamage ?? this.isFinalLossAndDamage,
        billingTotal: billingTotal ?? this.billingTotal,
        hasRecurring: hasRecurring ?? this.hasRecurring,
        contractId: contractId ?? this.contractId,
        referenceNumber: referenceNumber ?? this.referenceNumber,
        billedHiatus: billedHiatus ?? this.billedHiatus,
        missingCrewBreakTime: missingCrewBreakTime ?? this.missingCrewBreakTime,
        missingCrewWorkTime: missingCrewWorkTime ?? this.missingCrewWorkTime,
        currencyId: currencyId ?? this.currencyId,
        currencyCode: currencyCode ?? this.currencyCode,
        currencySymbol: currencySymbol ?? this.currencySymbol,
        officeLocationDefaultCurrencyId: officeLocationDefaultCurrencyId ??
            this.officeLocationDefaultCurrencyId,
        projectManagerId: projectManagerId ?? this.projectManagerId,
        projectManager: projectManager ?? this.projectManager,
        outsideSalesRepresentativeId:
            outsideSalesRepresentativeId ?? this.outsideSalesRepresentativeId,
        outsideSalesRepresentative:
            outsideSalesRepresentative ?? this.outsideSalesRepresentative,
        orderNumberColor: orderNumberColor ?? this.orderNumberColor,
        descriptionColor: descriptionColor ?? this.descriptionColor,
        billingStopDateColor: billingStopDateColor ?? this.billingStopDateColor,
        orderDateColor: orderDateColor ?? this.orderDateColor,
        purchaseOrderNumberColor:
            purchaseOrderNumberColor ?? this.purchaseOrderNumberColor,
        totalColor: totalColor ?? this.totalColor,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingBillingCreateInvoiceEstimateRequest {
  WebApiModulesBillingBillingCreateInvoiceEstimateRequest({
    this.orderId,
    this.periodStart,
    this.periodEnd,
    this.includeNotYetOut,
  });

  factory WebApiModulesBillingBillingCreateInvoiceEstimateRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingBillingCreateInvoiceEstimateRequestFromJson(json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'PeriodStart')
  final DateTime? periodStart;
  @JsonKey(name: 'PeriodEnd')
  final DateTime? periodEnd;
  @JsonKey(name: 'IncludeNotYetOut')
  final bool? includeNotYetOut;
  static const fromJsonFactory =
      _$WebApiModulesBillingBillingCreateInvoiceEstimateRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesBillingBillingCreateInvoiceEstimateRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingBillingCreateInvoiceEstimateRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingBillingCreateInvoiceEstimateRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.periodStart, periodStart) ||
                const DeepCollectionEquality()
                    .equals(other.periodStart, periodStart)) &&
            (identical(other.periodEnd, periodEnd) ||
                const DeepCollectionEquality()
                    .equals(other.periodEnd, periodEnd)) &&
            (identical(other.includeNotYetOut, includeNotYetOut) ||
                const DeepCollectionEquality()
                    .equals(other.includeNotYetOut, includeNotYetOut)));
  }
}

extension $WebApiModulesBillingBillingCreateInvoiceEstimateRequestExtension
    on WebApiModulesBillingBillingCreateInvoiceEstimateRequest {
  WebApiModulesBillingBillingCreateInvoiceEstimateRequest copyWith(
      {String? orderId,
      DateTime? periodStart,
      DateTime? periodEnd,
      bool? includeNotYetOut}) {
    return WebApiModulesBillingBillingCreateInvoiceEstimateRequest(
        orderId: orderId ?? this.orderId,
        periodStart: periodStart ?? this.periodStart,
        periodEnd: periodEnd ?? this.periodEnd,
        includeNotYetOut: includeNotYetOut ?? this.includeNotYetOut);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingBillingCreateInvoiceEstimateResponse {
  WebApiModulesBillingBillingCreateInvoiceEstimateResponse({
    this.status,
    this.success,
    this.msg,
    this.invoiceId,
  });

  factory WebApiModulesBillingBillingCreateInvoiceEstimateResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingBillingCreateInvoiceEstimateResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'InvoiceId')
  final String? invoiceId;
  static const fromJsonFactory =
      _$WebApiModulesBillingBillingCreateInvoiceEstimateResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesBillingBillingCreateInvoiceEstimateResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingBillingCreateInvoiceEstimateResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingBillingCreateInvoiceEstimateResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.invoiceId, invoiceId) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceId, invoiceId)));
  }
}

extension $WebApiModulesBillingBillingCreateInvoiceEstimateResponseExtension
    on WebApiModulesBillingBillingCreateInvoiceEstimateResponse {
  WebApiModulesBillingBillingCreateInvoiceEstimateResponse copyWith(
      {int? status, bool? success, String? msg, String? invoiceId}) {
    return WebApiModulesBillingBillingCreateInvoiceEstimateResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        invoiceId: invoiceId ?? this.invoiceId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingBillingCreateInvoicesRequest {
  WebApiModulesBillingBillingCreateInvoicesRequest({
    this.sessionId,
    this.billingIds,
  });

  factory WebApiModulesBillingBillingCreateInvoicesRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingBillingCreateInvoicesRequestFromJson(json);

  @JsonKey(name: 'SessionId')
  final String? sessionId;
  @JsonKey(name: 'BillingIds', defaultValue: <String>[])
  final List<String>? billingIds;
  static const fromJsonFactory =
      _$WebApiModulesBillingBillingCreateInvoicesRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesBillingBillingCreateInvoicesRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingBillingCreateInvoicesRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingBillingCreateInvoicesRequest &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)) &&
            (identical(other.billingIds, billingIds) ||
                const DeepCollectionEquality()
                    .equals(other.billingIds, billingIds)));
  }
}

extension $WebApiModulesBillingBillingCreateInvoicesRequestExtension
    on WebApiModulesBillingBillingCreateInvoicesRequest {
  WebApiModulesBillingBillingCreateInvoicesRequest copyWith(
      {String? sessionId, List<String>? billingIds}) {
    return WebApiModulesBillingBillingCreateInvoicesRequest(
        sessionId: sessionId ?? this.sessionId,
        billingIds: billingIds ?? this.billingIds);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingBillingCreateInvoicesResponse {
  WebApiModulesBillingBillingCreateInvoicesResponse({
    this.status,
    this.success,
    this.msg,
    this.invoiceCreationBatchId,
  });

  factory WebApiModulesBillingBillingCreateInvoicesResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingBillingCreateInvoicesResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'InvoiceCreationBatchId')
  final String? invoiceCreationBatchId;
  static const fromJsonFactory =
      _$WebApiModulesBillingBillingCreateInvoicesResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesBillingBillingCreateInvoicesResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingBillingCreateInvoicesResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingBillingCreateInvoicesResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.invoiceCreationBatchId, invoiceCreationBatchId) ||
                const DeepCollectionEquality().equals(
                    other.invoiceCreationBatchId, invoiceCreationBatchId)));
  }
}

extension $WebApiModulesBillingBillingCreateInvoicesResponseExtension
    on WebApiModulesBillingBillingCreateInvoicesResponse {
  WebApiModulesBillingBillingCreateInvoicesResponse copyWith(
      {int? status,
      bool? success,
      String? msg,
      String? invoiceCreationBatchId}) {
    return WebApiModulesBillingBillingCreateInvoicesResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        invoiceCreationBatchId:
            invoiceCreationBatchId ?? this.invoiceCreationBatchId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesRequest {
  WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesRequest({
    this.orderId,
  });

  factory WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesRequestFromJson(
          json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  static const fromJsonFactory =
      _$WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality().equals(other.orderId, orderId)));
  }
}

extension $WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesRequestExtension
    on WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesRequest {
  WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesRequest copyWith(
      {String? orderId}) {
    return WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesRequest(
        orderId: orderId ?? this.orderId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesResponse {
  WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesResponse({
    this.status,
    this.success,
    this.msg,
    this.fromDate,
    this.toDate,
  });

  factory WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'FromDate')
  final DateTime? fromDate;
  @JsonKey(name: 'ToDate')
  final DateTime? toDate;
  static const fromJsonFactory =
      _$WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.fromDate, fromDate) ||
                const DeepCollectionEquality()
                    .equals(other.fromDate, fromDate)) &&
            (identical(other.toDate, toDate) ||
                const DeepCollectionEquality().equals(other.toDate, toDate)));
  }
}

extension $WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesResponseExtension
    on WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesResponse {
  WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesResponse copyWith(
      {int? status,
      bool? success,
      String? msg,
      DateTime? fromDate,
      DateTime? toDate}) {
    return WebApiModulesBillingBillingGetNextBillingWorksheetUsageDatesResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        fromDate: fromDate ?? this.fromDate,
        toDate: toDate ?? this.toDate);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingBillingGetOrderBillingDatesResponse {
  WebApiModulesBillingBillingGetOrderBillingDatesResponse({
    this.status,
    this.success,
    this.msg,
    this.periodStart,
    this.periodEnd,
  });

  factory WebApiModulesBillingBillingGetOrderBillingDatesResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingBillingGetOrderBillingDatesResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'PeriodStart')
  final DateTime? periodStart;
  @JsonKey(name: 'PeriodEnd')
  final DateTime? periodEnd;
  static const fromJsonFactory =
      _$WebApiModulesBillingBillingGetOrderBillingDatesResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesBillingBillingGetOrderBillingDatesResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingBillingGetOrderBillingDatesResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingBillingGetOrderBillingDatesResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.periodStart, periodStart) ||
                const DeepCollectionEquality()
                    .equals(other.periodStart, periodStart)) &&
            (identical(other.periodEnd, periodEnd) ||
                const DeepCollectionEquality()
                    .equals(other.periodEnd, periodEnd)));
  }
}

extension $WebApiModulesBillingBillingGetOrderBillingDatesResponseExtension
    on WebApiModulesBillingBillingGetOrderBillingDatesResponse {
  WebApiModulesBillingBillingGetOrderBillingDatesResponse copyWith(
      {int? status,
      bool? success,
      String? msg,
      DateTime? periodStart,
      DateTime? periodEnd}) {
    return WebApiModulesBillingBillingGetOrderBillingDatesResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        periodStart: periodStart ?? this.periodStart,
        periodEnd: periodEnd ?? this.periodEnd);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingBillingPopulateBillingRequest {
  WebApiModulesBillingBillingPopulateBillingRequest({
    this.billAsOfDate,
    this.officeLocationId,
    this.customerId,
    this.dealId,
    this.departmentId,
    this.agentId,
    this.orderId,
    this.showOrdersWithPendingPO,
    this.billIfComplete,
    this.combinePeriods,
  });

  factory WebApiModulesBillingBillingPopulateBillingRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingBillingPopulateBillingRequestFromJson(json);

  @JsonKey(name: 'BillAsOfDate')
  final DateTime? billAsOfDate;
  @JsonKey(name: 'OfficeLocationId')
  final String? officeLocationId;
  @JsonKey(name: 'CustomerId')
  final String? customerId;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'AgentId')
  final String? agentId;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'ShowOrdersWithPendingPO')
  final bool? showOrdersWithPendingPO;
  @JsonKey(name: 'BillIfComplete')
  final bool? billIfComplete;
  @JsonKey(name: 'CombinePeriods')
  final bool? combinePeriods;
  static const fromJsonFactory =
      _$WebApiModulesBillingBillingPopulateBillingRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesBillingBillingPopulateBillingRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingBillingPopulateBillingRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingBillingPopulateBillingRequest &&
            (identical(other.billAsOfDate, billAsOfDate) ||
                const DeepCollectionEquality()
                    .equals(other.billAsOfDate, billAsOfDate)) &&
            (identical(other.officeLocationId, officeLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocationId, officeLocationId)) &&
            (identical(other.customerId, customerId) ||
                const DeepCollectionEquality()
                    .equals(other.customerId, customerId)) &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.departmentId, departmentId) ||
                const DeepCollectionEquality()
                    .equals(other.departmentId, departmentId)) &&
            (identical(other.agentId, agentId) ||
                const DeepCollectionEquality()
                    .equals(other.agentId, agentId)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(
                    other.showOrdersWithPendingPO, showOrdersWithPendingPO) ||
                const DeepCollectionEquality().equals(
                    other.showOrdersWithPendingPO, showOrdersWithPendingPO)) &&
            (identical(other.billIfComplete, billIfComplete) ||
                const DeepCollectionEquality()
                    .equals(other.billIfComplete, billIfComplete)) &&
            (identical(other.combinePeriods, combinePeriods) ||
                const DeepCollectionEquality()
                    .equals(other.combinePeriods, combinePeriods)));
  }
}

extension $WebApiModulesBillingBillingPopulateBillingRequestExtension
    on WebApiModulesBillingBillingPopulateBillingRequest {
  WebApiModulesBillingBillingPopulateBillingRequest copyWith(
      {DateTime? billAsOfDate,
      String? officeLocationId,
      String? customerId,
      String? dealId,
      String? departmentId,
      String? agentId,
      String? orderId,
      bool? showOrdersWithPendingPO,
      bool? billIfComplete,
      bool? combinePeriods}) {
    return WebApiModulesBillingBillingPopulateBillingRequest(
        billAsOfDate: billAsOfDate ?? this.billAsOfDate,
        officeLocationId: officeLocationId ?? this.officeLocationId,
        customerId: customerId ?? this.customerId,
        dealId: dealId ?? this.dealId,
        departmentId: departmentId ?? this.departmentId,
        agentId: agentId ?? this.agentId,
        orderId: orderId ?? this.orderId,
        showOrdersWithPendingPO:
            showOrdersWithPendingPO ?? this.showOrdersWithPendingPO,
        billIfComplete: billIfComplete ?? this.billIfComplete,
        combinePeriods: combinePeriods ?? this.combinePeriods);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingBillingPopulateBillingResponse {
  WebApiModulesBillingBillingPopulateBillingResponse({
    this.status,
    this.success,
    this.msg,
    this.sessionId,
    this.billingMessages,
  });

  factory WebApiModulesBillingBillingPopulateBillingResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingBillingPopulateBillingResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'SessionId')
  final String? sessionId;
  @JsonKey(name: 'BillingMessages')
  final int? billingMessages;
  static const fromJsonFactory =
      _$WebApiModulesBillingBillingPopulateBillingResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesBillingBillingPopulateBillingResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingBillingPopulateBillingResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingBillingPopulateBillingResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)) &&
            (identical(other.billingMessages, billingMessages) ||
                const DeepCollectionEquality()
                    .equals(other.billingMessages, billingMessages)));
  }
}

extension $WebApiModulesBillingBillingPopulateBillingResponseExtension
    on WebApiModulesBillingBillingPopulateBillingResponse {
  WebApiModulesBillingBillingPopulateBillingResponse copyWith(
      {int? status,
      bool? success,
      String? msg,
      String? sessionId,
      int? billingMessages}) {
    return WebApiModulesBillingBillingPopulateBillingResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        sessionId: sessionId ?? this.sessionId,
        billingMessages: billingMessages ?? this.billingMessages);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingBillingUpdateBillingWorksheetRequest {
  WebApiModulesBillingBillingUpdateBillingWorksheetRequest({
    this.status,
    this.success,
    this.msg,
    this.invoiceId,
    this.orderId,
  });

  factory WebApiModulesBillingBillingUpdateBillingWorksheetRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingBillingUpdateBillingWorksheetRequestFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'InvoiceId')
  final String? invoiceId;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  static const fromJsonFactory =
      _$WebApiModulesBillingBillingUpdateBillingWorksheetRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesBillingBillingUpdateBillingWorksheetRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingBillingUpdateBillingWorksheetRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingBillingUpdateBillingWorksheetRequest &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.invoiceId, invoiceId) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceId, invoiceId)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality().equals(other.orderId, orderId)));
  }
}

extension $WebApiModulesBillingBillingUpdateBillingWorksheetRequestExtension
    on WebApiModulesBillingBillingUpdateBillingWorksheetRequest {
  WebApiModulesBillingBillingUpdateBillingWorksheetRequest copyWith(
      {int? status,
      bool? success,
      String? msg,
      String? invoiceId,
      String? orderId}) {
    return WebApiModulesBillingBillingUpdateBillingWorksheetRequest(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        invoiceId: invoiceId ?? this.invoiceId,
        orderId: orderId ?? this.orderId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingBillingUpdateBillingWorksheetResponse {
  WebApiModulesBillingBillingUpdateBillingWorksheetResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesBillingBillingUpdateBillingWorksheetResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingBillingUpdateBillingWorksheetResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesBillingBillingUpdateBillingWorksheetResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesBillingBillingUpdateBillingWorksheetResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingBillingUpdateBillingWorksheetResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingBillingUpdateBillingWorksheetResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesBillingBillingUpdateBillingWorksheetResponseExtension
    on WebApiModulesBillingBillingUpdateBillingWorksheetResponse {
  WebApiModulesBillingBillingUpdateBillingWorksheetResponse copyWith(
      {int? status, bool? success, String? msg}) {
    return WebApiModulesBillingBillingUpdateBillingWorksheetResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingBillingWorksheetBillingWorksheet {
  WebApiModulesBillingBillingWorksheetBillingWorksheet({
    this.billingWorksheetId,
    this.worksheetNumber,
    this.worksheetDate,
    this.billingStartDate,
    this.billingEndDate,
    this.orderInvoiceId,
    this.orderId,
    this.orderNumber,
    this.orderDescription,
    this.orderDate,
    this.worksheetDescription,
    this.customerId,
    this.dealId,
    this.deal,
    this.dealNumber,
    this.departmentId,
    this.department,
    this.taxId,
    this.taxOptionId,
    this.taxOption,
    this.tax1Name,
    this.tax2Name,
    this.rentalTaxRate1,
    this.salesTaxRate1,
    this.laborTaxRate1,
    this.rentalTaxRate2,
    this.salesTaxRate2,
    this.laborTaxRate2,
    this.purchaseOrderNumber,
    this.status,
    this.statusDate,
    this.isNoCharge,
    this.isAdjusted,
    this.isBilledHiatus,
    this.hasLockedTotal,
    this.isAlteredDates,
    this.officeLocationId,
    this.officeLocation,
    this.inputByUserId,
    this.flatPoId,
    this.orderType,
    this.rateType,
    this.rateTypeDisplay,
    this.resultingInvoiceTotal,
    this.referenceNumber,
    this.agentId,
    this.agent,
    this.currencyId,
    this.currencyCode,
    this.officeLocationDefaultCurrencyId,
    this.outsideSalesRepresentativeId,
    this.usageStartDate,
    this.usageEndDate,
    this.resultingInvoiceNumber,
    this.resultingInvoiceId,
    this.rentalTotal,
    this.salesTotal,
    this.facilitiesTotal,
    this.worksheetGrossTotal,
    this.worksheetDiscountTotal,
    this.worksheetSubTotal,
    this.worksheetTax1,
    this.worksheetTax2,
    this.worksheetTax,
    this.worksheetTotal,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesBillingBillingWorksheetBillingWorksheet.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingBillingWorksheetBillingWorksheetFromJson(json);

  @JsonKey(name: 'BillingWorksheetId')
  final String? billingWorksheetId;
  @JsonKey(name: 'WorksheetNumber')
  final String? worksheetNumber;
  @JsonKey(name: 'WorksheetDate')
  final String? worksheetDate;
  @JsonKey(name: 'BillingStartDate')
  final String? billingStartDate;
  @JsonKey(name: 'BillingEndDate')
  final String? billingEndDate;
  @JsonKey(name: 'OrderInvoiceId')
  final String? orderInvoiceId;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderNumber')
  final String? orderNumber;
  @JsonKey(name: 'OrderDescription')
  final String? orderDescription;
  @JsonKey(name: 'OrderDate')
  final String? orderDate;
  @JsonKey(name: 'WorksheetDescription')
  final String? worksheetDescription;
  @JsonKey(name: 'CustomerId')
  final String? customerId;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'Deal')
  final String? deal;
  @JsonKey(name: 'DealNumber')
  final String? dealNumber;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'Department')
  final String? department;
  @JsonKey(name: 'TaxId')
  final String? taxId;
  @JsonKey(name: 'TaxOptionId')
  final String? taxOptionId;
  @JsonKey(name: 'TaxOption')
  final String? taxOption;
  @JsonKey(name: 'Tax1Name')
  final String? tax1Name;
  @JsonKey(name: 'Tax2Name')
  final String? tax2Name;
  @JsonKey(name: 'RentalTaxRate1')
  final double? rentalTaxRate1;
  @JsonKey(name: 'SalesTaxRate1')
  final double? salesTaxRate1;
  @JsonKey(name: 'LaborTaxRate1')
  final double? laborTaxRate1;
  @JsonKey(name: 'RentalTaxRate2')
  final double? rentalTaxRate2;
  @JsonKey(name: 'SalesTaxRate2')
  final double? salesTaxRate2;
  @JsonKey(name: 'LaborTaxRate2')
  final double? laborTaxRate2;
  @JsonKey(name: 'PurchaseOrderNumber')
  final String? purchaseOrderNumber;
  @JsonKey(name: 'Status')
  final String? status;
  @JsonKey(name: 'StatusDate')
  final String? statusDate;
  @JsonKey(name: 'IsNoCharge')
  final bool? isNoCharge;
  @JsonKey(name: 'IsAdjusted')
  final bool? isAdjusted;
  @JsonKey(name: 'IsBilledHiatus')
  final bool? isBilledHiatus;
  @JsonKey(name: 'HasLockedTotal')
  final bool? hasLockedTotal;
  @JsonKey(name: 'IsAlteredDates')
  final bool? isAlteredDates;
  @JsonKey(name: 'OfficeLocationId')
  final String? officeLocationId;
  @JsonKey(name: 'OfficeLocation')
  final String? officeLocation;
  @JsonKey(name: 'InputByUserId')
  final String? inputByUserId;
  @JsonKey(name: 'FlatPoId')
  final String? flatPoId;
  @JsonKey(name: 'OrderType')
  final String? orderType;
  @JsonKey(name: 'RateType')
  final String? rateType;
  @JsonKey(name: 'RateTypeDisplay')
  final String? rateTypeDisplay;
  @JsonKey(name: 'ResultingInvoiceTotal')
  final double? resultingInvoiceTotal;
  @JsonKey(name: 'ReferenceNumber')
  final String? referenceNumber;
  @JsonKey(name: 'AgentId')
  final String? agentId;
  @JsonKey(name: 'Agent')
  final String? agent;
  @JsonKey(name: 'CurrencyId')
  final String? currencyId;
  @JsonKey(name: 'CurrencyCode')
  final String? currencyCode;
  @JsonKey(name: 'OfficeLocationDefaultCurrencyId')
  final String? officeLocationDefaultCurrencyId;
  @JsonKey(name: 'OutsideSalesRepresentativeId')
  final String? outsideSalesRepresentativeId;
  @JsonKey(name: 'UsageStartDate')
  final String? usageStartDate;
  @JsonKey(name: 'UsageEndDate')
  final String? usageEndDate;
  @JsonKey(name: 'ResultingInvoiceNumber')
  final String? resultingInvoiceNumber;
  @JsonKey(name: 'ResultingInvoiceId')
  final String? resultingInvoiceId;
  @JsonKey(name: 'RentalTotal')
  final double? rentalTotal;
  @JsonKey(name: 'SalesTotal')
  final double? salesTotal;
  @JsonKey(name: 'FacilitiesTotal')
  final double? facilitiesTotal;
  @JsonKey(name: 'WorksheetGrossTotal')
  final double? worksheetGrossTotal;
  @JsonKey(name: 'WorksheetDiscountTotal')
  final double? worksheetDiscountTotal;
  @JsonKey(name: 'WorksheetSubTotal')
  final double? worksheetSubTotal;
  @JsonKey(name: 'WorksheetTax1')
  final double? worksheetTax1;
  @JsonKey(name: 'WorksheetTax2')
  final double? worksheetTax2;
  @JsonKey(name: 'WorksheetTax')
  final double? worksheetTax;
  @JsonKey(name: 'WorksheetTotal')
  final double? worksheetTotal;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesBillingBillingWorksheetBillingWorksheetFromJson;
  static const toJsonFactory =
      _$WebApiModulesBillingBillingWorksheetBillingWorksheetToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingBillingWorksheetBillingWorksheetToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingBillingWorksheetBillingWorksheet &&
            (identical(other.billingWorksheetId, billingWorksheetId) ||
                const DeepCollectionEquality()
                    .equals(other.billingWorksheetId, billingWorksheetId)) &&
            (identical(other.worksheetNumber, worksheetNumber) ||
                const DeepCollectionEquality()
                    .equals(other.worksheetNumber, worksheetNumber)) &&
            (identical(other.worksheetDate, worksheetDate) ||
                const DeepCollectionEquality()
                    .equals(other.worksheetDate, worksheetDate)) &&
            (identical(other.billingStartDate, billingStartDate) ||
                const DeepCollectionEquality()
                    .equals(other.billingStartDate, billingStartDate)) &&
            (identical(other.billingEndDate, billingEndDate) ||
                const DeepCollectionEquality()
                    .equals(other.billingEndDate, billingEndDate)) &&
            (identical(other.orderInvoiceId, orderInvoiceId) ||
                const DeepCollectionEquality()
                    .equals(other.orderInvoiceId, orderInvoiceId)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderNumber, orderNumber) ||
                const DeepCollectionEquality()
                    .equals(other.orderNumber, orderNumber)) &&
            (identical(other.orderDescription, orderDescription) ||
                const DeepCollectionEquality()
                    .equals(other.orderDescription, orderDescription)) &&
            (identical(other.orderDate, orderDate) ||
                const DeepCollectionEquality()
                    .equals(other.orderDate, orderDate)) &&
            (identical(other.worksheetDescription, worksheetDescription) ||
                const DeepCollectionEquality().equals(
                    other.worksheetDescription, worksheetDescription)) &&
            (identical(other.customerId, customerId) ||
                const DeepCollectionEquality()
                    .equals(other.customerId, customerId)) &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.deal, deal) ||
                const DeepCollectionEquality().equals(other.deal, deal)) &&
            (identical(other.dealNumber, dealNumber) ||
                const DeepCollectionEquality()
                    .equals(other.dealNumber, dealNumber)) &&
            (identical(other.departmentId, departmentId) ||
                const DeepCollectionEquality()
                    .equals(other.departmentId, departmentId)) &&
            (identical(other.department, department) ||
                const DeepCollectionEquality()
                    .equals(other.department, department)) &&
            (identical(other.taxId, taxId) ||
                const DeepCollectionEquality().equals(other.taxId, taxId)) &&
            (identical(other.taxOptionId, taxOptionId) ||
                const DeepCollectionEquality()
                    .equals(other.taxOptionId, taxOptionId)) &&
            (identical(other.taxOption, taxOption) ||
                const DeepCollectionEquality()
                    .equals(other.taxOption, taxOption)) &&
            (identical(other.tax1Name, tax1Name) ||
                const DeepCollectionEquality()
                    .equals(other.tax1Name, tax1Name)) &&
            (identical(other.tax2Name, tax2Name) ||
                const DeepCollectionEquality()
                    .equals(other.tax2Name, tax2Name)) &&
            (identical(other.rentalTaxRate1, rentalTaxRate1) ||
                const DeepCollectionEquality()
                    .equals(other.rentalTaxRate1, rentalTaxRate1)) &&
            (identical(other.salesTaxRate1, salesTaxRate1) || const DeepCollectionEquality().equals(other.salesTaxRate1, salesTaxRate1)) &&
            (identical(other.laborTaxRate1, laborTaxRate1) || const DeepCollectionEquality().equals(other.laborTaxRate1, laborTaxRate1)) &&
            (identical(other.rentalTaxRate2, rentalTaxRate2) || const DeepCollectionEquality().equals(other.rentalTaxRate2, rentalTaxRate2)) &&
            (identical(other.salesTaxRate2, salesTaxRate2) || const DeepCollectionEquality().equals(other.salesTaxRate2, salesTaxRate2)) &&
            (identical(other.laborTaxRate2, laborTaxRate2) || const DeepCollectionEquality().equals(other.laborTaxRate2, laborTaxRate2)) &&
            (identical(other.purchaseOrderNumber, purchaseOrderNumber) || const DeepCollectionEquality().equals(other.purchaseOrderNumber, purchaseOrderNumber)) &&
            (identical(other.status, status) || const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.statusDate, statusDate) || const DeepCollectionEquality().equals(other.statusDate, statusDate)) &&
            (identical(other.isNoCharge, isNoCharge) || const DeepCollectionEquality().equals(other.isNoCharge, isNoCharge)) &&
            (identical(other.isAdjusted, isAdjusted) || const DeepCollectionEquality().equals(other.isAdjusted, isAdjusted)) &&
            (identical(other.isBilledHiatus, isBilledHiatus) || const DeepCollectionEquality().equals(other.isBilledHiatus, isBilledHiatus)) &&
            (identical(other.hasLockedTotal, hasLockedTotal) || const DeepCollectionEquality().equals(other.hasLockedTotal, hasLockedTotal)) &&
            (identical(other.isAlteredDates, isAlteredDates) || const DeepCollectionEquality().equals(other.isAlteredDates, isAlteredDates)) &&
            (identical(other.officeLocationId, officeLocationId) || const DeepCollectionEquality().equals(other.officeLocationId, officeLocationId)) &&
            (identical(other.officeLocation, officeLocation) || const DeepCollectionEquality().equals(other.officeLocation, officeLocation)) &&
            (identical(other.inputByUserId, inputByUserId) || const DeepCollectionEquality().equals(other.inputByUserId, inputByUserId)) &&
            (identical(other.flatPoId, flatPoId) || const DeepCollectionEquality().equals(other.flatPoId, flatPoId)) &&
            (identical(other.orderType, orderType) || const DeepCollectionEquality().equals(other.orderType, orderType)) &&
            (identical(other.rateType, rateType) || const DeepCollectionEquality().equals(other.rateType, rateType)) &&
            (identical(other.rateTypeDisplay, rateTypeDisplay) || const DeepCollectionEquality().equals(other.rateTypeDisplay, rateTypeDisplay)) &&
            (identical(other.resultingInvoiceTotal, resultingInvoiceTotal) || const DeepCollectionEquality().equals(other.resultingInvoiceTotal, resultingInvoiceTotal)) &&
            (identical(other.referenceNumber, referenceNumber) || const DeepCollectionEquality().equals(other.referenceNumber, referenceNumber)) &&
            (identical(other.agentId, agentId) || const DeepCollectionEquality().equals(other.agentId, agentId)) &&
            (identical(other.agent, agent) || const DeepCollectionEquality().equals(other.agent, agent)) &&
            (identical(other.currencyId, currencyId) || const DeepCollectionEquality().equals(other.currencyId, currencyId)) &&
            (identical(other.currencyCode, currencyCode) || const DeepCollectionEquality().equals(other.currencyCode, currencyCode)) &&
            (identical(other.officeLocationDefaultCurrencyId, officeLocationDefaultCurrencyId) || const DeepCollectionEquality().equals(other.officeLocationDefaultCurrencyId, officeLocationDefaultCurrencyId)) &&
            (identical(other.outsideSalesRepresentativeId, outsideSalesRepresentativeId) || const DeepCollectionEquality().equals(other.outsideSalesRepresentativeId, outsideSalesRepresentativeId)) &&
            (identical(other.usageStartDate, usageStartDate) || const DeepCollectionEquality().equals(other.usageStartDate, usageStartDate)) &&
            (identical(other.usageEndDate, usageEndDate) || const DeepCollectionEquality().equals(other.usageEndDate, usageEndDate)) &&
            (identical(other.resultingInvoiceNumber, resultingInvoiceNumber) || const DeepCollectionEquality().equals(other.resultingInvoiceNumber, resultingInvoiceNumber)) &&
            (identical(other.resultingInvoiceId, resultingInvoiceId) || const DeepCollectionEquality().equals(other.resultingInvoiceId, resultingInvoiceId)) &&
            (identical(other.rentalTotal, rentalTotal) || const DeepCollectionEquality().equals(other.rentalTotal, rentalTotal)) &&
            (identical(other.salesTotal, salesTotal) || const DeepCollectionEquality().equals(other.salesTotal, salesTotal)) &&
            (identical(other.facilitiesTotal, facilitiesTotal) || const DeepCollectionEquality().equals(other.facilitiesTotal, facilitiesTotal)) &&
            (identical(other.worksheetGrossTotal, worksheetGrossTotal) || const DeepCollectionEquality().equals(other.worksheetGrossTotal, worksheetGrossTotal)) &&
            (identical(other.worksheetDiscountTotal, worksheetDiscountTotal) || const DeepCollectionEquality().equals(other.worksheetDiscountTotal, worksheetDiscountTotal)) &&
            (identical(other.worksheetSubTotal, worksheetSubTotal) || const DeepCollectionEquality().equals(other.worksheetSubTotal, worksheetSubTotal)) &&
            (identical(other.worksheetTax1, worksheetTax1) || const DeepCollectionEquality().equals(other.worksheetTax1, worksheetTax1)) &&
            (identical(other.worksheetTax2, worksheetTax2) || const DeepCollectionEquality().equals(other.worksheetTax2, worksheetTax2)) &&
            (identical(other.worksheetTax, worksheetTax) || const DeepCollectionEquality().equals(other.worksheetTax, worksheetTax)) &&
            (identical(other.worksheetTotal, worksheetTotal) || const DeepCollectionEquality().equals(other.worksheetTotal, worksheetTotal)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesBillingBillingWorksheetBillingWorksheetExtension
    on WebApiModulesBillingBillingWorksheetBillingWorksheet {
  WebApiModulesBillingBillingWorksheetBillingWorksheet copyWith(
      {String? billingWorksheetId,
      String? worksheetNumber,
      String? worksheetDate,
      String? billingStartDate,
      String? billingEndDate,
      String? orderInvoiceId,
      String? orderId,
      String? orderNumber,
      String? orderDescription,
      String? orderDate,
      String? worksheetDescription,
      String? customerId,
      String? dealId,
      String? deal,
      String? dealNumber,
      String? departmentId,
      String? department,
      String? taxId,
      String? taxOptionId,
      String? taxOption,
      String? tax1Name,
      String? tax2Name,
      double? rentalTaxRate1,
      double? salesTaxRate1,
      double? laborTaxRate1,
      double? rentalTaxRate2,
      double? salesTaxRate2,
      double? laborTaxRate2,
      String? purchaseOrderNumber,
      String? status,
      String? statusDate,
      bool? isNoCharge,
      bool? isAdjusted,
      bool? isBilledHiatus,
      bool? hasLockedTotal,
      bool? isAlteredDates,
      String? officeLocationId,
      String? officeLocation,
      String? inputByUserId,
      String? flatPoId,
      String? orderType,
      String? rateType,
      String? rateTypeDisplay,
      double? resultingInvoiceTotal,
      String? referenceNumber,
      String? agentId,
      String? agent,
      String? currencyId,
      String? currencyCode,
      String? officeLocationDefaultCurrencyId,
      String? outsideSalesRepresentativeId,
      String? usageStartDate,
      String? usageEndDate,
      String? resultingInvoiceNumber,
      String? resultingInvoiceId,
      double? rentalTotal,
      double? salesTotal,
      double? facilitiesTotal,
      double? worksheetGrossTotal,
      double? worksheetDiscountTotal,
      double? worksheetSubTotal,
      double? worksheetTax1,
      double? worksheetTax2,
      double? worksheetTax,
      double? worksheetTotal,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesBillingBillingWorksheetBillingWorksheet(
        billingWorksheetId: billingWorksheetId ?? this.billingWorksheetId,
        worksheetNumber: worksheetNumber ?? this.worksheetNumber,
        worksheetDate: worksheetDate ?? this.worksheetDate,
        billingStartDate: billingStartDate ?? this.billingStartDate,
        billingEndDate: billingEndDate ?? this.billingEndDate,
        orderInvoiceId: orderInvoiceId ?? this.orderInvoiceId,
        orderId: orderId ?? this.orderId,
        orderNumber: orderNumber ?? this.orderNumber,
        orderDescription: orderDescription ?? this.orderDescription,
        orderDate: orderDate ?? this.orderDate,
        worksheetDescription: worksheetDescription ?? this.worksheetDescription,
        customerId: customerId ?? this.customerId,
        dealId: dealId ?? this.dealId,
        deal: deal ?? this.deal,
        dealNumber: dealNumber ?? this.dealNumber,
        departmentId: departmentId ?? this.departmentId,
        department: department ?? this.department,
        taxId: taxId ?? this.taxId,
        taxOptionId: taxOptionId ?? this.taxOptionId,
        taxOption: taxOption ?? this.taxOption,
        tax1Name: tax1Name ?? this.tax1Name,
        tax2Name: tax2Name ?? this.tax2Name,
        rentalTaxRate1: rentalTaxRate1 ?? this.rentalTaxRate1,
        salesTaxRate1: salesTaxRate1 ?? this.salesTaxRate1,
        laborTaxRate1: laborTaxRate1 ?? this.laborTaxRate1,
        rentalTaxRate2: rentalTaxRate2 ?? this.rentalTaxRate2,
        salesTaxRate2: salesTaxRate2 ?? this.salesTaxRate2,
        laborTaxRate2: laborTaxRate2 ?? this.laborTaxRate2,
        purchaseOrderNumber: purchaseOrderNumber ?? this.purchaseOrderNumber,
        status: status ?? this.status,
        statusDate: statusDate ?? this.statusDate,
        isNoCharge: isNoCharge ?? this.isNoCharge,
        isAdjusted: isAdjusted ?? this.isAdjusted,
        isBilledHiatus: isBilledHiatus ?? this.isBilledHiatus,
        hasLockedTotal: hasLockedTotal ?? this.hasLockedTotal,
        isAlteredDates: isAlteredDates ?? this.isAlteredDates,
        officeLocationId: officeLocationId ?? this.officeLocationId,
        officeLocation: officeLocation ?? this.officeLocation,
        inputByUserId: inputByUserId ?? this.inputByUserId,
        flatPoId: flatPoId ?? this.flatPoId,
        orderType: orderType ?? this.orderType,
        rateType: rateType ?? this.rateType,
        rateTypeDisplay: rateTypeDisplay ?? this.rateTypeDisplay,
        resultingInvoiceTotal:
            resultingInvoiceTotal ?? this.resultingInvoiceTotal,
        referenceNumber: referenceNumber ?? this.referenceNumber,
        agentId: agentId ?? this.agentId,
        agent: agent ?? this.agent,
        currencyId: currencyId ?? this.currencyId,
        currencyCode: currencyCode ?? this.currencyCode,
        officeLocationDefaultCurrencyId: officeLocationDefaultCurrencyId ??
            this.officeLocationDefaultCurrencyId,
        outsideSalesRepresentativeId:
            outsideSalesRepresentativeId ?? this.outsideSalesRepresentativeId,
        usageStartDate: usageStartDate ?? this.usageStartDate,
        usageEndDate: usageEndDate ?? this.usageEndDate,
        resultingInvoiceNumber:
            resultingInvoiceNumber ?? this.resultingInvoiceNumber,
        resultingInvoiceId: resultingInvoiceId ?? this.resultingInvoiceId,
        rentalTotal: rentalTotal ?? this.rentalTotal,
        salesTotal: salesTotal ?? this.salesTotal,
        facilitiesTotal: facilitiesTotal ?? this.facilitiesTotal,
        worksheetGrossTotal: worksheetGrossTotal ?? this.worksheetGrossTotal,
        worksheetDiscountTotal:
            worksheetDiscountTotal ?? this.worksheetDiscountTotal,
        worksheetSubTotal: worksheetSubTotal ?? this.worksheetSubTotal,
        worksheetTax1: worksheetTax1 ?? this.worksheetTax1,
        worksheetTax2: worksheetTax2 ?? this.worksheetTax2,
        worksheetTax: worksheetTax ?? this.worksheetTax,
        worksheetTotal: worksheetTotal ?? this.worksheetTotal,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingInvoiceCreditInvoiceReponse {
  WebApiModulesBillingInvoiceCreditInvoiceReponse({
    this.status,
    this.success,
    this.msg,
    this.creditId,
    this.credit,
  });

  factory WebApiModulesBillingInvoiceCreditInvoiceReponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingInvoiceCreditInvoiceReponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'CreditId')
  final String? creditId;
  @JsonKey(name: 'credit')
  final WebApiModulesBillingInvoiceInvoice? credit;
  static const fromJsonFactory =
      _$WebApiModulesBillingInvoiceCreditInvoiceReponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesBillingInvoiceCreditInvoiceReponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingInvoiceCreditInvoiceReponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingInvoiceCreditInvoiceReponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.creditId, creditId) ||
                const DeepCollectionEquality()
                    .equals(other.creditId, creditId)) &&
            (identical(other.credit, credit) ||
                const DeepCollectionEquality().equals(other.credit, credit)));
  }
}

extension $WebApiModulesBillingInvoiceCreditInvoiceReponseExtension
    on WebApiModulesBillingInvoiceCreditInvoiceReponse {
  WebApiModulesBillingInvoiceCreditInvoiceReponse copyWith(
      {int? status,
      bool? success,
      String? msg,
      String? creditId,
      WebApiModulesBillingInvoiceInvoice? credit}) {
    return WebApiModulesBillingInvoiceCreditInvoiceReponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        creditId: creditId ?? this.creditId,
        credit: credit ?? this.credit);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingInvoiceCreditInvoiceRequest {
  WebApiModulesBillingInvoiceCreditInvoiceRequest({
    this.invoiceId,
    this.percent,
    this.amount,
    this.allocate,
    this.usageDays,
    this.notes,
    this.taxOnly,
    this.creditFromDate,
    this.creditToDate,
    this.creditMethod,
    this.adjustCost,
  });

  factory WebApiModulesBillingInvoiceCreditInvoiceRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingInvoiceCreditInvoiceRequestFromJson(json);

  @JsonKey(name: 'InvoiceId')
  final String? invoiceId;
  @JsonKey(name: 'Percent')
  final double? percent;
  @JsonKey(name: 'Amount')
  final double? amount;
  @JsonKey(name: 'Allocate')
  final bool? allocate;
  @JsonKey(name: 'UsageDays')
  final double? usageDays;
  @JsonKey(name: 'Notes')
  final String? notes;
  @JsonKey(name: 'TaxOnly')
  final bool? taxOnly;
  @JsonKey(name: 'CreditFromDate')
  final DateTime? creditFromDate;
  @JsonKey(name: 'CreditToDate')
  final DateTime? creditToDate;
  @JsonKey(name: 'CreditMethod')
  final String? creditMethod;
  @JsonKey(name: 'AdjustCost')
  final bool? adjustCost;
  static const fromJsonFactory =
      _$WebApiModulesBillingInvoiceCreditInvoiceRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesBillingInvoiceCreditInvoiceRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingInvoiceCreditInvoiceRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingInvoiceCreditInvoiceRequest &&
            (identical(other.invoiceId, invoiceId) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceId, invoiceId)) &&
            (identical(other.percent, percent) ||
                const DeepCollectionEquality()
                    .equals(other.percent, percent)) &&
            (identical(other.amount, amount) ||
                const DeepCollectionEquality().equals(other.amount, amount)) &&
            (identical(other.allocate, allocate) ||
                const DeepCollectionEquality()
                    .equals(other.allocate, allocate)) &&
            (identical(other.usageDays, usageDays) ||
                const DeepCollectionEquality()
                    .equals(other.usageDays, usageDays)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.taxOnly, taxOnly) ||
                const DeepCollectionEquality()
                    .equals(other.taxOnly, taxOnly)) &&
            (identical(other.creditFromDate, creditFromDate) ||
                const DeepCollectionEquality()
                    .equals(other.creditFromDate, creditFromDate)) &&
            (identical(other.creditToDate, creditToDate) ||
                const DeepCollectionEquality()
                    .equals(other.creditToDate, creditToDate)) &&
            (identical(other.creditMethod, creditMethod) ||
                const DeepCollectionEquality()
                    .equals(other.creditMethod, creditMethod)) &&
            (identical(other.adjustCost, adjustCost) ||
                const DeepCollectionEquality()
                    .equals(other.adjustCost, adjustCost)));
  }
}

extension $WebApiModulesBillingInvoiceCreditInvoiceRequestExtension
    on WebApiModulesBillingInvoiceCreditInvoiceRequest {
  WebApiModulesBillingInvoiceCreditInvoiceRequest copyWith(
      {String? invoiceId,
      double? percent,
      double? amount,
      bool? allocate,
      double? usageDays,
      String? notes,
      bool? taxOnly,
      DateTime? creditFromDate,
      DateTime? creditToDate,
      String? creditMethod,
      bool? adjustCost}) {
    return WebApiModulesBillingInvoiceCreditInvoiceRequest(
        invoiceId: invoiceId ?? this.invoiceId,
        percent: percent ?? this.percent,
        amount: amount ?? this.amount,
        allocate: allocate ?? this.allocate,
        usageDays: usageDays ?? this.usageDays,
        notes: notes ?? this.notes,
        taxOnly: taxOnly ?? this.taxOnly,
        creditFromDate: creditFromDate ?? this.creditFromDate,
        creditToDate: creditToDate ?? this.creditToDate,
        creditMethod: creditMethod ?? this.creditMethod,
        adjustCost: adjustCost ?? this.adjustCost);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingInvoiceInvoice {
  WebApiModulesBillingInvoiceInvoice({
    this.invoiceId,
    this.invoiceNumber,
    this.invoiceDate,
    this.invoiceDueDate,
    this.invoiceType,
    this.billingStartDate,
    this.billingEndDate,
    this.usageStartDate,
    this.usageEndDate,
    this.orderId,
    this.orderNumber,
    this.orderDescription,
    this.orderDate,
    this.orderLocation,
    this.invoiceDescription,
    this.creditingInvoiceId,
    this.creditingInvoiceNumber,
    this.customerId,
    this.customer,
    this.customerTypeId,
    this.customerType,
    this.dealId,
    this.deal,
    this.dealNumber,
    this.dealTypeId,
    this.departmentId,
    this.department,
    this.purchaseOrderNumber,
    this.workAuthorizationNumber,
    this.status,
    this.statusDate,
    this.isNoCharge,
    this.isAdjusted,
    this.isBilledHiatus,
    this.episodeNumber,
    this.hasLockedTotal,
    this.isAlteredDates,
    this.officeLocationId,
    this.officeLocation,
    this.invoiceCreationBatchId,
    this.invoiceCreationBatchNumber,
    this.invoiceGroupNumber,
    this.rentalSale,
    this.lossAndDamage,
    this.repair,
    this.inputByUserId,
    this.flatPoId,
    this.orderType,
    this.rebateCustomerId,
    this.orbitsapchgmajor,
    this.orbitsapchgsub,
    this.orbitsapchgdetail,
    this.orbitsapchgdeal,
    this.orbitsapchgset,
    this.excludeFromFlatPo,
    this.isSplitRental,
    this.isRebateRental,
    this.invoiceListTotal,
    this.invoiceGrossTotal,
    this.invoiceDiscountTotal,
    this.invoiceDaysPerWeekDiscountTotal,
    this.referenceNumber,
    this.agentId,
    this.agent,
    this.projectManagerId,
    this.projectManager,
    this.billToAddressId,
    this.billToName,
    this.billToAttention1,
    this.billToAttention2,
    this.billToAddress1,
    this.billToAddress2,
    this.billToCity,
    this.billToState,
    this.billToZipCode,
    this.billToCountryId,
    this.billToCountry,
    this.invoiceClass,
    this.printNotes,
    this.paymentTermsId,
    this.paymentTerms,
    this.paymentTypeId,
    this.paymentType,
    this.taxId,
    this.taxOptionId,
    this.taxOption,
    this.tax1Name,
    this.tax2Name,
    this.rentalTaxRate1,
    this.salesTaxRate1,
    this.laborTaxRate1,
    this.rentalTaxRate2,
    this.salesTaxRate2,
    this.laborTaxRate2,
    this.taxItemCode,
    this.taxVendor,
    this.taxCountry,
    this.chargeBatchId,
    this.chargeBatchNumber,
    this.quikPayDiscount,
    this.quikPayRentalTotal,
    this.quikPayTotal,
    this.receivedTotal,
    this.rateType,
    this.consignmentRevenue,
    this.isNonBillable,
    this.currencyId,
    this.currencyCode,
    this.currencySymbol,
    this.officeLocationDefaultCurrencyId,
    this.divisionId,
    this.outsideSalesRepresentativeId,
    this.outsideSalesRepresentative,
    this.exportTaxAsLineItem,
    this.invoiceNumberColor,
    this.statusColor,
    this.orderNumberColor,
    this.purchaseOrderNumberColor,
    this.dealColor,
    this.billingStartDateColor,
    this.invoiceTotalColor,
    this.descriptionColor,
    this.hasRentalItem,
    this.hasMeterItem,
    this.hasSalesItem,
    this.hasLaborItem,
    this.hasMiscellaneousItem,
    this.hasFacilityItem,
    this.hasTransportationItem,
    this.hasRentalSaleItem,
    this.hasLossAndDamageItem,
    this.rentalTotal,
    this.salesTotal,
    this.facilitiesTotal,
    this.miscellaneousTotal,
    this.laborTotal,
    this.partsTotal,
    this.assetSaleTotal,
    this.invoiceSubTotal,
    this.invoiceTax1,
    this.invoiceTax2,
    this.invoiceTax,
    this.invoiceTotal,
    this.isStandAloneInvoice,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesBillingInvoiceInvoice.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingInvoiceInvoiceFromJson(json);

  @JsonKey(name: 'InvoiceId')
  final String? invoiceId;
  @JsonKey(name: 'InvoiceNumber')
  final String? invoiceNumber;
  @JsonKey(name: 'InvoiceDate')
  final String? invoiceDate;
  @JsonKey(name: 'InvoiceDueDate')
  final String? invoiceDueDate;
  @JsonKey(name: 'InvoiceType')
  final String? invoiceType;
  @JsonKey(name: 'BillingStartDate')
  final String? billingStartDate;
  @JsonKey(name: 'BillingEndDate')
  final String? billingEndDate;
  @JsonKey(name: 'UsageStartDate')
  final String? usageStartDate;
  @JsonKey(name: 'UsageEndDate')
  final String? usageEndDate;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderNumber')
  final String? orderNumber;
  @JsonKey(name: 'OrderDescription')
  final String? orderDescription;
  @JsonKey(name: 'OrderDate')
  final String? orderDate;
  @JsonKey(name: 'OrderLocation')
  final String? orderLocation;
  @JsonKey(name: 'InvoiceDescription')
  final String? invoiceDescription;
  @JsonKey(name: 'CreditingInvoiceId')
  final String? creditingInvoiceId;
  @JsonKey(name: 'CreditingInvoiceNumber')
  final String? creditingInvoiceNumber;
  @JsonKey(name: 'CustomerId')
  final String? customerId;
  @JsonKey(name: 'Customer')
  final String? customer;
  @JsonKey(name: 'CustomerTypeId')
  final String? customerTypeId;
  @JsonKey(name: 'CustomerType')
  final String? customerType;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'Deal')
  final String? deal;
  @JsonKey(name: 'DealNumber')
  final String? dealNumber;
  @JsonKey(name: 'DealTypeId')
  final String? dealTypeId;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'Department')
  final String? department;
  @JsonKey(name: 'PurchaseOrderNumber')
  final String? purchaseOrderNumber;
  @JsonKey(name: 'WorkAuthorizationNumber')
  final String? workAuthorizationNumber;
  @JsonKey(name: 'Status')
  final String? status;
  @JsonKey(name: 'StatusDate')
  final String? statusDate;
  @JsonKey(name: 'IsNoCharge')
  final bool? isNoCharge;
  @JsonKey(name: 'IsAdjusted')
  final bool? isAdjusted;
  @JsonKey(name: 'IsBilledHiatus')
  final bool? isBilledHiatus;
  @JsonKey(name: 'EpisodeNumber')
  final int? episodeNumber;
  @JsonKey(name: 'HasLockedTotal')
  final bool? hasLockedTotal;
  @JsonKey(name: 'IsAlteredDates')
  final bool? isAlteredDates;
  @JsonKey(name: 'OfficeLocationId')
  final String? officeLocationId;
  @JsonKey(name: 'OfficeLocation')
  final String? officeLocation;
  @JsonKey(name: 'InvoiceCreationBatchId')
  final String? invoiceCreationBatchId;
  @JsonKey(name: 'InvoiceCreationBatchNumber')
  final int? invoiceCreationBatchNumber;
  @JsonKey(name: 'InvoiceGroupNumber')
  final String? invoiceGroupNumber;
  @JsonKey(name: 'RentalSale')
  final bool? rentalSale;
  @JsonKey(name: 'LossAndDamage')
  final bool? lossAndDamage;
  @JsonKey(name: 'Repair')
  final bool? repair;
  @JsonKey(name: 'InputByUserId')
  final String? inputByUserId;
  @JsonKey(name: 'FlatPoId')
  final String? flatPoId;
  @JsonKey(name: 'OrderType')
  final String? orderType;
  @JsonKey(name: 'RebateCustomerId')
  final String? rebateCustomerId;
  @JsonKey(name: 'Orbitsapchgmajor')
  final String? orbitsapchgmajor;
  @JsonKey(name: 'Orbitsapchgsub')
  final String? orbitsapchgsub;
  @JsonKey(name: 'Orbitsapchgdetail')
  final String? orbitsapchgdetail;
  @JsonKey(name: 'Orbitsapchgdeal')
  final String? orbitsapchgdeal;
  @JsonKey(name: 'Orbitsapchgset')
  final String? orbitsapchgset;
  @JsonKey(name: 'ExcludeFromFlatPo')
  final bool? excludeFromFlatPo;
  @JsonKey(name: 'IsSplitRental')
  final bool? isSplitRental;
  @JsonKey(name: 'IsRebateRental')
  final bool? isRebateRental;
  @JsonKey(name: 'InvoiceListTotal')
  final double? invoiceListTotal;
  @JsonKey(name: 'InvoiceGrossTotal')
  final double? invoiceGrossTotal;
  @JsonKey(name: 'InvoiceDiscountTotal')
  final double? invoiceDiscountTotal;
  @JsonKey(name: 'InvoiceDaysPerWeekDiscountTotal')
  final double? invoiceDaysPerWeekDiscountTotal;
  @JsonKey(name: 'ReferenceNumber')
  final String? referenceNumber;
  @JsonKey(name: 'AgentId')
  final String? agentId;
  @JsonKey(name: 'Agent')
  final String? agent;
  @JsonKey(name: 'ProjectManagerId')
  final String? projectManagerId;
  @JsonKey(name: 'ProjectManager')
  final String? projectManager;
  @JsonKey(name: 'BillToAddressId')
  final String? billToAddressId;
  @JsonKey(name: 'BillToName')
  final String? billToName;
  @JsonKey(name: 'BillToAttention1')
  final String? billToAttention1;
  @JsonKey(name: 'BillToAttention2')
  final String? billToAttention2;
  @JsonKey(name: 'BillToAddress1')
  final String? billToAddress1;
  @JsonKey(name: 'BillToAddress2')
  final String? billToAddress2;
  @JsonKey(name: 'BillToCity')
  final String? billToCity;
  @JsonKey(name: 'BillToState')
  final String? billToState;
  @JsonKey(name: 'BillToZipCode')
  final String? billToZipCode;
  @JsonKey(name: 'BillToCountryId')
  final String? billToCountryId;
  @JsonKey(name: 'BillToCountry')
  final String? billToCountry;
  @JsonKey(name: 'InvoiceClass')
  final String? invoiceClass;
  @JsonKey(name: 'PrintNotes')
  final String? printNotes;
  @JsonKey(name: 'PaymentTermsId')
  final String? paymentTermsId;
  @JsonKey(name: 'PaymentTerms')
  final String? paymentTerms;
  @JsonKey(name: 'PaymentTypeId')
  final String? paymentTypeId;
  @JsonKey(name: 'PaymentType')
  final String? paymentType;
  @JsonKey(name: 'TaxId')
  final String? taxId;
  @JsonKey(name: 'TaxOptionId')
  final String? taxOptionId;
  @JsonKey(name: 'TaxOption')
  final String? taxOption;
  @JsonKey(name: 'Tax1Name')
  final String? tax1Name;
  @JsonKey(name: 'Tax2Name')
  final String? tax2Name;
  @JsonKey(name: 'RentalTaxRate1')
  final double? rentalTaxRate1;
  @JsonKey(name: 'SalesTaxRate1')
  final double? salesTaxRate1;
  @JsonKey(name: 'LaborTaxRate1')
  final double? laborTaxRate1;
  @JsonKey(name: 'RentalTaxRate2')
  final double? rentalTaxRate2;
  @JsonKey(name: 'SalesTaxRate2')
  final double? salesTaxRate2;
  @JsonKey(name: 'LaborTaxRate2')
  final double? laborTaxRate2;
  @JsonKey(name: 'TaxItemCode')
  final String? taxItemCode;
  @JsonKey(name: 'TaxVendor')
  final String? taxVendor;
  @JsonKey(name: 'TaxCountry')
  final String? taxCountry;
  @JsonKey(name: 'ChargeBatchId')
  final String? chargeBatchId;
  @JsonKey(name: 'ChargeBatchNumber')
  final String? chargeBatchNumber;
  @JsonKey(name: 'QuikPayDiscount')
  final bool? quikPayDiscount;
  @JsonKey(name: 'QuikPayRentalTotal')
  final double? quikPayRentalTotal;
  @JsonKey(name: 'QuikPayTotal')
  final double? quikPayTotal;
  @JsonKey(name: 'ReceivedTotal')
  final double? receivedTotal;
  @JsonKey(name: 'RateType')
  final String? rateType;
  @JsonKey(name: 'ConsignmentRevenue')
  final double? consignmentRevenue;
  @JsonKey(name: 'IsNonBillable')
  final bool? isNonBillable;
  @JsonKey(name: 'CurrencyId')
  final String? currencyId;
  @JsonKey(name: 'CurrencyCode')
  final String? currencyCode;
  @JsonKey(name: 'CurrencySymbol')
  final String? currencySymbol;
  @JsonKey(name: 'OfficeLocationDefaultCurrencyId')
  final String? officeLocationDefaultCurrencyId;
  @JsonKey(name: 'DivisionId')
  final String? divisionId;
  @JsonKey(name: 'OutsideSalesRepresentativeId')
  final String? outsideSalesRepresentativeId;
  @JsonKey(name: 'OutsideSalesRepresentative')
  final String? outsideSalesRepresentative;
  @JsonKey(name: 'ExportTaxAsLineItem')
  final bool? exportTaxAsLineItem;
  @JsonKey(name: 'InvoiceNumberColor')
  final String? invoiceNumberColor;
  @JsonKey(name: 'StatusColor')
  final String? statusColor;
  @JsonKey(name: 'OrderNumberColor')
  final String? orderNumberColor;
  @JsonKey(name: 'PurchaseOrderNumberColor')
  final String? purchaseOrderNumberColor;
  @JsonKey(name: 'DealColor')
  final String? dealColor;
  @JsonKey(name: 'BillingStartDateColor')
  final String? billingStartDateColor;
  @JsonKey(name: 'InvoiceTotalColor')
  final String? invoiceTotalColor;
  @JsonKey(name: 'DescriptionColor')
  final String? descriptionColor;
  @JsonKey(name: 'HasRentalItem')
  final bool? hasRentalItem;
  @JsonKey(name: 'HasMeterItem')
  final bool? hasMeterItem;
  @JsonKey(name: 'HasSalesItem')
  final bool? hasSalesItem;
  @JsonKey(name: 'HasLaborItem')
  final bool? hasLaborItem;
  @JsonKey(name: 'HasMiscellaneousItem')
  final bool? hasMiscellaneousItem;
  @JsonKey(name: 'HasFacilityItem')
  final bool? hasFacilityItem;
  @JsonKey(name: 'HasTransportationItem')
  final bool? hasTransportationItem;
  @JsonKey(name: 'HasRentalSaleItem')
  final bool? hasRentalSaleItem;
  @JsonKey(name: 'HasLossAndDamageItem')
  final bool? hasLossAndDamageItem;
  @JsonKey(name: 'RentalTotal')
  final double? rentalTotal;
  @JsonKey(name: 'SalesTotal')
  final double? salesTotal;
  @JsonKey(name: 'FacilitiesTotal')
  final double? facilitiesTotal;
  @JsonKey(name: 'MiscellaneousTotal')
  final double? miscellaneousTotal;
  @JsonKey(name: 'LaborTotal')
  final double? laborTotal;
  @JsonKey(name: 'PartsTotal')
  final double? partsTotal;
  @JsonKey(name: 'AssetSaleTotal')
  final double? assetSaleTotal;
  @JsonKey(name: 'InvoiceSubTotal')
  final double? invoiceSubTotal;
  @JsonKey(name: 'InvoiceTax1')
  final double? invoiceTax1;
  @JsonKey(name: 'InvoiceTax2')
  final double? invoiceTax2;
  @JsonKey(name: 'InvoiceTax')
  final double? invoiceTax;
  @JsonKey(name: 'InvoiceTotal')
  final double? invoiceTotal;
  @JsonKey(name: 'IsStandAloneInvoice')
  final bool? isStandAloneInvoice;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory = _$WebApiModulesBillingInvoiceInvoiceFromJson;
  static const toJsonFactory = _$WebApiModulesBillingInvoiceInvoiceToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingInvoiceInvoiceToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingInvoiceInvoice &&
            (identical(other.invoiceId, invoiceId) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceId, invoiceId)) &&
            (identical(other.invoiceNumber, invoiceNumber) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceNumber, invoiceNumber)) &&
            (identical(other.invoiceDate, invoiceDate) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceDate, invoiceDate)) &&
            (identical(other.invoiceDueDate, invoiceDueDate) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceDueDate, invoiceDueDate)) &&
            (identical(other.invoiceType, invoiceType) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceType, invoiceType)) &&
            (identical(other.billingStartDate, billingStartDate) ||
                const DeepCollectionEquality()
                    .equals(other.billingStartDate, billingStartDate)) &&
            (identical(other.billingEndDate, billingEndDate) ||
                const DeepCollectionEquality()
                    .equals(other.billingEndDate, billingEndDate)) &&
            (identical(other.usageStartDate, usageStartDate) ||
                const DeepCollectionEquality()
                    .equals(other.usageStartDate, usageStartDate)) &&
            (identical(other.usageEndDate, usageEndDate) ||
                const DeepCollectionEquality()
                    .equals(other.usageEndDate, usageEndDate)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderNumber, orderNumber) ||
                const DeepCollectionEquality()
                    .equals(other.orderNumber, orderNumber)) &&
            (identical(other.orderDescription, orderDescription) ||
                const DeepCollectionEquality()
                    .equals(other.orderDescription, orderDescription)) &&
            (identical(other.orderDate, orderDate) ||
                const DeepCollectionEquality()
                    .equals(other.orderDate, orderDate)) &&
            (identical(other.orderLocation, orderLocation) ||
                const DeepCollectionEquality()
                    .equals(other.orderLocation, orderLocation)) &&
            (identical(other.invoiceDescription, invoiceDescription) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceDescription, invoiceDescription)) &&
            (identical(other.creditingInvoiceId, creditingInvoiceId) ||
                const DeepCollectionEquality()
                    .equals(other.creditingInvoiceId, creditingInvoiceId)) &&
            (identical(other.creditingInvoiceNumber, creditingInvoiceNumber) ||
                const DeepCollectionEquality().equals(
                    other.creditingInvoiceNumber, creditingInvoiceNumber)) &&
            (identical(other.customerId, customerId) ||
                const DeepCollectionEquality()
                    .equals(other.customerId, customerId)) &&
            (identical(other.customer, customer) ||
                const DeepCollectionEquality()
                    .equals(other.customer, customer)) &&
            (identical(other.customerTypeId, customerTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.customerTypeId, customerTypeId)) &&
            (identical(other.customerType, customerType) ||
                const DeepCollectionEquality()
                    .equals(other.customerType, customerType)) &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.deal, deal) || const DeepCollectionEquality().equals(other.deal, deal)) &&
            (identical(other.dealNumber, dealNumber) || const DeepCollectionEquality().equals(other.dealNumber, dealNumber)) &&
            (identical(other.dealTypeId, dealTypeId) || const DeepCollectionEquality().equals(other.dealTypeId, dealTypeId)) &&
            (identical(other.departmentId, departmentId) || const DeepCollectionEquality().equals(other.departmentId, departmentId)) &&
            (identical(other.department, department) || const DeepCollectionEquality().equals(other.department, department)) &&
            (identical(other.purchaseOrderNumber, purchaseOrderNumber) || const DeepCollectionEquality().equals(other.purchaseOrderNumber, purchaseOrderNumber)) &&
            (identical(other.workAuthorizationNumber, workAuthorizationNumber) || const DeepCollectionEquality().equals(other.workAuthorizationNumber, workAuthorizationNumber)) &&
            (identical(other.status, status) || const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.statusDate, statusDate) || const DeepCollectionEquality().equals(other.statusDate, statusDate)) &&
            (identical(other.isNoCharge, isNoCharge) || const DeepCollectionEquality().equals(other.isNoCharge, isNoCharge)) &&
            (identical(other.isAdjusted, isAdjusted) || const DeepCollectionEquality().equals(other.isAdjusted, isAdjusted)) &&
            (identical(other.isBilledHiatus, isBilledHiatus) || const DeepCollectionEquality().equals(other.isBilledHiatus, isBilledHiatus)) &&
            (identical(other.episodeNumber, episodeNumber) || const DeepCollectionEquality().equals(other.episodeNumber, episodeNumber)) &&
            (identical(other.hasLockedTotal, hasLockedTotal) || const DeepCollectionEquality().equals(other.hasLockedTotal, hasLockedTotal)) &&
            (identical(other.isAlteredDates, isAlteredDates) || const DeepCollectionEquality().equals(other.isAlteredDates, isAlteredDates)) &&
            (identical(other.officeLocationId, officeLocationId) || const DeepCollectionEquality().equals(other.officeLocationId, officeLocationId)) &&
            (identical(other.officeLocation, officeLocation) || const DeepCollectionEquality().equals(other.officeLocation, officeLocation)) &&
            (identical(other.invoiceCreationBatchId, invoiceCreationBatchId) || const DeepCollectionEquality().equals(other.invoiceCreationBatchId, invoiceCreationBatchId)) &&
            (identical(other.invoiceCreationBatchNumber, invoiceCreationBatchNumber) || const DeepCollectionEquality().equals(other.invoiceCreationBatchNumber, invoiceCreationBatchNumber)) &&
            (identical(other.invoiceGroupNumber, invoiceGroupNumber) || const DeepCollectionEquality().equals(other.invoiceGroupNumber, invoiceGroupNumber)) &&
            (identical(other.rentalSale, rentalSale) || const DeepCollectionEquality().equals(other.rentalSale, rentalSale)) &&
            (identical(other.lossAndDamage, lossAndDamage) || const DeepCollectionEquality().equals(other.lossAndDamage, lossAndDamage)) &&
            (identical(other.repair, repair) || const DeepCollectionEquality().equals(other.repair, repair)) &&
            (identical(other.inputByUserId, inputByUserId) || const DeepCollectionEquality().equals(other.inputByUserId, inputByUserId)) &&
            (identical(other.flatPoId, flatPoId) || const DeepCollectionEquality().equals(other.flatPoId, flatPoId)) &&
            (identical(other.orderType, orderType) || const DeepCollectionEquality().equals(other.orderType, orderType)) &&
            (identical(other.rebateCustomerId, rebateCustomerId) || const DeepCollectionEquality().equals(other.rebateCustomerId, rebateCustomerId)) &&
            (identical(other.orbitsapchgmajor, orbitsapchgmajor) || const DeepCollectionEquality().equals(other.orbitsapchgmajor, orbitsapchgmajor)) &&
            (identical(other.orbitsapchgsub, orbitsapchgsub) || const DeepCollectionEquality().equals(other.orbitsapchgsub, orbitsapchgsub)) &&
            (identical(other.orbitsapchgdetail, orbitsapchgdetail) || const DeepCollectionEquality().equals(other.orbitsapchgdetail, orbitsapchgdetail)) &&
            (identical(other.orbitsapchgdeal, orbitsapchgdeal) || const DeepCollectionEquality().equals(other.orbitsapchgdeal, orbitsapchgdeal)) &&
            (identical(other.orbitsapchgset, orbitsapchgset) || const DeepCollectionEquality().equals(other.orbitsapchgset, orbitsapchgset)) &&
            (identical(other.excludeFromFlatPo, excludeFromFlatPo) || const DeepCollectionEquality().equals(other.excludeFromFlatPo, excludeFromFlatPo)) &&
            (identical(other.isSplitRental, isSplitRental) || const DeepCollectionEquality().equals(other.isSplitRental, isSplitRental)) &&
            (identical(other.isRebateRental, isRebateRental) || const DeepCollectionEquality().equals(other.isRebateRental, isRebateRental)) &&
            (identical(other.invoiceListTotal, invoiceListTotal) || const DeepCollectionEquality().equals(other.invoiceListTotal, invoiceListTotal)) &&
            (identical(other.invoiceGrossTotal, invoiceGrossTotal) || const DeepCollectionEquality().equals(other.invoiceGrossTotal, invoiceGrossTotal)) &&
            (identical(other.invoiceDiscountTotal, invoiceDiscountTotal) || const DeepCollectionEquality().equals(other.invoiceDiscountTotal, invoiceDiscountTotal)) &&
            (identical(other.invoiceDaysPerWeekDiscountTotal, invoiceDaysPerWeekDiscountTotal) || const DeepCollectionEquality().equals(other.invoiceDaysPerWeekDiscountTotal, invoiceDaysPerWeekDiscountTotal)) &&
            (identical(other.referenceNumber, referenceNumber) || const DeepCollectionEquality().equals(other.referenceNumber, referenceNumber)) &&
            (identical(other.agentId, agentId) || const DeepCollectionEquality().equals(other.agentId, agentId)) &&
            (identical(other.agent, agent) || const DeepCollectionEquality().equals(other.agent, agent)) &&
            (identical(other.projectManagerId, projectManagerId) || const DeepCollectionEquality().equals(other.projectManagerId, projectManagerId)) &&
            (identical(other.projectManager, projectManager) || const DeepCollectionEquality().equals(other.projectManager, projectManager)) &&
            (identical(other.billToAddressId, billToAddressId) || const DeepCollectionEquality().equals(other.billToAddressId, billToAddressId)) &&
            (identical(other.billToName, billToName) || const DeepCollectionEquality().equals(other.billToName, billToName)) &&
            (identical(other.billToAttention1, billToAttention1) || const DeepCollectionEquality().equals(other.billToAttention1, billToAttention1)) &&
            (identical(other.billToAttention2, billToAttention2) || const DeepCollectionEquality().equals(other.billToAttention2, billToAttention2)) &&
            (identical(other.billToAddress1, billToAddress1) || const DeepCollectionEquality().equals(other.billToAddress1, billToAddress1)) &&
            (identical(other.billToAddress2, billToAddress2) || const DeepCollectionEquality().equals(other.billToAddress2, billToAddress2)) &&
            (identical(other.billToCity, billToCity) || const DeepCollectionEquality().equals(other.billToCity, billToCity)) &&
            (identical(other.billToState, billToState) || const DeepCollectionEquality().equals(other.billToState, billToState)) &&
            (identical(other.billToZipCode, billToZipCode) || const DeepCollectionEquality().equals(other.billToZipCode, billToZipCode)) &&
            (identical(other.billToCountryId, billToCountryId) || const DeepCollectionEquality().equals(other.billToCountryId, billToCountryId)) &&
            (identical(other.billToCountry, billToCountry) || const DeepCollectionEquality().equals(other.billToCountry, billToCountry)) &&
            (identical(other.invoiceClass, invoiceClass) || const DeepCollectionEquality().equals(other.invoiceClass, invoiceClass)) &&
            (identical(other.printNotes, printNotes) || const DeepCollectionEquality().equals(other.printNotes, printNotes)) &&
            (identical(other.paymentTermsId, paymentTermsId) || const DeepCollectionEquality().equals(other.paymentTermsId, paymentTermsId)) &&
            (identical(other.paymentTerms, paymentTerms) || const DeepCollectionEquality().equals(other.paymentTerms, paymentTerms)) &&
            (identical(other.paymentTypeId, paymentTypeId) || const DeepCollectionEquality().equals(other.paymentTypeId, paymentTypeId)) &&
            (identical(other.paymentType, paymentType) || const DeepCollectionEquality().equals(other.paymentType, paymentType)) &&
            (identical(other.taxId, taxId) || const DeepCollectionEquality().equals(other.taxId, taxId)) &&
            (identical(other.taxOptionId, taxOptionId) || const DeepCollectionEquality().equals(other.taxOptionId, taxOptionId)) &&
            (identical(other.taxOption, taxOption) || const DeepCollectionEquality().equals(other.taxOption, taxOption)) &&
            (identical(other.tax1Name, tax1Name) || const DeepCollectionEquality().equals(other.tax1Name, tax1Name)) &&
            (identical(other.tax2Name, tax2Name) || const DeepCollectionEquality().equals(other.tax2Name, tax2Name)) &&
            (identical(other.rentalTaxRate1, rentalTaxRate1) || const DeepCollectionEquality().equals(other.rentalTaxRate1, rentalTaxRate1)) &&
            (identical(other.salesTaxRate1, salesTaxRate1) || const DeepCollectionEquality().equals(other.salesTaxRate1, salesTaxRate1)) &&
            (identical(other.laborTaxRate1, laborTaxRate1) || const DeepCollectionEquality().equals(other.laborTaxRate1, laborTaxRate1)) &&
            (identical(other.rentalTaxRate2, rentalTaxRate2) || const DeepCollectionEquality().equals(other.rentalTaxRate2, rentalTaxRate2)) &&
            (identical(other.salesTaxRate2, salesTaxRate2) || const DeepCollectionEquality().equals(other.salesTaxRate2, salesTaxRate2)) &&
            (identical(other.laborTaxRate2, laborTaxRate2) || const DeepCollectionEquality().equals(other.laborTaxRate2, laborTaxRate2)) &&
            (identical(other.taxItemCode, taxItemCode) || const DeepCollectionEquality().equals(other.taxItemCode, taxItemCode)) &&
            (identical(other.taxVendor, taxVendor) || const DeepCollectionEquality().equals(other.taxVendor, taxVendor)) &&
            (identical(other.taxCountry, taxCountry) || const DeepCollectionEquality().equals(other.taxCountry, taxCountry)) &&
            (identical(other.chargeBatchId, chargeBatchId) || const DeepCollectionEquality().equals(other.chargeBatchId, chargeBatchId)) &&
            (identical(other.chargeBatchNumber, chargeBatchNumber) || const DeepCollectionEquality().equals(other.chargeBatchNumber, chargeBatchNumber)) &&
            (identical(other.quikPayDiscount, quikPayDiscount) || const DeepCollectionEquality().equals(other.quikPayDiscount, quikPayDiscount)) &&
            (identical(other.quikPayRentalTotal, quikPayRentalTotal) || const DeepCollectionEquality().equals(other.quikPayRentalTotal, quikPayRentalTotal)) &&
            (identical(other.quikPayTotal, quikPayTotal) || const DeepCollectionEquality().equals(other.quikPayTotal, quikPayTotal)) &&
            (identical(other.receivedTotal, receivedTotal) || const DeepCollectionEquality().equals(other.receivedTotal, receivedTotal)) &&
            (identical(other.rateType, rateType) || const DeepCollectionEquality().equals(other.rateType, rateType)) &&
            (identical(other.consignmentRevenue, consignmentRevenue) || const DeepCollectionEquality().equals(other.consignmentRevenue, consignmentRevenue)) &&
            (identical(other.isNonBillable, isNonBillable) || const DeepCollectionEquality().equals(other.isNonBillable, isNonBillable)) &&
            (identical(other.currencyId, currencyId) || const DeepCollectionEquality().equals(other.currencyId, currencyId)) &&
            (identical(other.currencyCode, currencyCode) || const DeepCollectionEquality().equals(other.currencyCode, currencyCode)) &&
            (identical(other.currencySymbol, currencySymbol) || const DeepCollectionEquality().equals(other.currencySymbol, currencySymbol)) &&
            (identical(other.officeLocationDefaultCurrencyId, officeLocationDefaultCurrencyId) || const DeepCollectionEquality().equals(other.officeLocationDefaultCurrencyId, officeLocationDefaultCurrencyId)) &&
            (identical(other.divisionId, divisionId) || const DeepCollectionEquality().equals(other.divisionId, divisionId)) &&
            (identical(other.outsideSalesRepresentativeId, outsideSalesRepresentativeId) || const DeepCollectionEquality().equals(other.outsideSalesRepresentativeId, outsideSalesRepresentativeId)) &&
            (identical(other.outsideSalesRepresentative, outsideSalesRepresentative) || const DeepCollectionEquality().equals(other.outsideSalesRepresentative, outsideSalesRepresentative)) &&
            (identical(other.exportTaxAsLineItem, exportTaxAsLineItem) || const DeepCollectionEquality().equals(other.exportTaxAsLineItem, exportTaxAsLineItem)) &&
            (identical(other.invoiceNumberColor, invoiceNumberColor) || const DeepCollectionEquality().equals(other.invoiceNumberColor, invoiceNumberColor)) &&
            (identical(other.statusColor, statusColor) || const DeepCollectionEquality().equals(other.statusColor, statusColor)) &&
            (identical(other.orderNumberColor, orderNumberColor) || const DeepCollectionEquality().equals(other.orderNumberColor, orderNumberColor)) &&
            (identical(other.purchaseOrderNumberColor, purchaseOrderNumberColor) || const DeepCollectionEquality().equals(other.purchaseOrderNumberColor, purchaseOrderNumberColor)) &&
            (identical(other.dealColor, dealColor) || const DeepCollectionEquality().equals(other.dealColor, dealColor)) &&
            (identical(other.billingStartDateColor, billingStartDateColor) || const DeepCollectionEquality().equals(other.billingStartDateColor, billingStartDateColor)) &&
            (identical(other.invoiceTotalColor, invoiceTotalColor) || const DeepCollectionEquality().equals(other.invoiceTotalColor, invoiceTotalColor)) &&
            (identical(other.descriptionColor, descriptionColor) || const DeepCollectionEquality().equals(other.descriptionColor, descriptionColor)) &&
            (identical(other.hasRentalItem, hasRentalItem) || const DeepCollectionEquality().equals(other.hasRentalItem, hasRentalItem)) &&
            (identical(other.hasMeterItem, hasMeterItem) || const DeepCollectionEquality().equals(other.hasMeterItem, hasMeterItem)) &&
            (identical(other.hasSalesItem, hasSalesItem) || const DeepCollectionEquality().equals(other.hasSalesItem, hasSalesItem)) &&
            (identical(other.hasLaborItem, hasLaborItem) || const DeepCollectionEquality().equals(other.hasLaborItem, hasLaborItem)) &&
            (identical(other.hasMiscellaneousItem, hasMiscellaneousItem) || const DeepCollectionEquality().equals(other.hasMiscellaneousItem, hasMiscellaneousItem)) &&
            (identical(other.hasFacilityItem, hasFacilityItem) || const DeepCollectionEquality().equals(other.hasFacilityItem, hasFacilityItem)) &&
            (identical(other.hasTransportationItem, hasTransportationItem) || const DeepCollectionEquality().equals(other.hasTransportationItem, hasTransportationItem)) &&
            (identical(other.hasRentalSaleItem, hasRentalSaleItem) || const DeepCollectionEquality().equals(other.hasRentalSaleItem, hasRentalSaleItem)) &&
            (identical(other.hasLossAndDamageItem, hasLossAndDamageItem) || const DeepCollectionEquality().equals(other.hasLossAndDamageItem, hasLossAndDamageItem)) &&
            (identical(other.rentalTotal, rentalTotal) || const DeepCollectionEquality().equals(other.rentalTotal, rentalTotal)) &&
            (identical(other.salesTotal, salesTotal) || const DeepCollectionEquality().equals(other.salesTotal, salesTotal)) &&
            (identical(other.facilitiesTotal, facilitiesTotal) || const DeepCollectionEquality().equals(other.facilitiesTotal, facilitiesTotal)) &&
            (identical(other.miscellaneousTotal, miscellaneousTotal) || const DeepCollectionEquality().equals(other.miscellaneousTotal, miscellaneousTotal)) &&
            (identical(other.laborTotal, laborTotal) || const DeepCollectionEquality().equals(other.laborTotal, laborTotal)) &&
            (identical(other.partsTotal, partsTotal) || const DeepCollectionEquality().equals(other.partsTotal, partsTotal)) &&
            (identical(other.assetSaleTotal, assetSaleTotal) || const DeepCollectionEquality().equals(other.assetSaleTotal, assetSaleTotal)) &&
            (identical(other.invoiceSubTotal, invoiceSubTotal) || const DeepCollectionEquality().equals(other.invoiceSubTotal, invoiceSubTotal)) &&
            (identical(other.invoiceTax1, invoiceTax1) || const DeepCollectionEquality().equals(other.invoiceTax1, invoiceTax1)) &&
            (identical(other.invoiceTax2, invoiceTax2) || const DeepCollectionEquality().equals(other.invoiceTax2, invoiceTax2)) &&
            (identical(other.invoiceTax, invoiceTax) || const DeepCollectionEquality().equals(other.invoiceTax, invoiceTax)) &&
            (identical(other.invoiceTotal, invoiceTotal) || const DeepCollectionEquality().equals(other.invoiceTotal, invoiceTotal)) &&
            (identical(other.isStandAloneInvoice, isStandAloneInvoice) || const DeepCollectionEquality().equals(other.isStandAloneInvoice, isStandAloneInvoice)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesBillingInvoiceInvoiceExtension
    on WebApiModulesBillingInvoiceInvoice {
  WebApiModulesBillingInvoiceInvoice copyWith(
      {String? invoiceId,
      String? invoiceNumber,
      String? invoiceDate,
      String? invoiceDueDate,
      String? invoiceType,
      String? billingStartDate,
      String? billingEndDate,
      String? usageStartDate,
      String? usageEndDate,
      String? orderId,
      String? orderNumber,
      String? orderDescription,
      String? orderDate,
      String? orderLocation,
      String? invoiceDescription,
      String? creditingInvoiceId,
      String? creditingInvoiceNumber,
      String? customerId,
      String? customer,
      String? customerTypeId,
      String? customerType,
      String? dealId,
      String? deal,
      String? dealNumber,
      String? dealTypeId,
      String? departmentId,
      String? department,
      String? purchaseOrderNumber,
      String? workAuthorizationNumber,
      String? status,
      String? statusDate,
      bool? isNoCharge,
      bool? isAdjusted,
      bool? isBilledHiatus,
      int? episodeNumber,
      bool? hasLockedTotal,
      bool? isAlteredDates,
      String? officeLocationId,
      String? officeLocation,
      String? invoiceCreationBatchId,
      int? invoiceCreationBatchNumber,
      String? invoiceGroupNumber,
      bool? rentalSale,
      bool? lossAndDamage,
      bool? repair,
      String? inputByUserId,
      String? flatPoId,
      String? orderType,
      String? rebateCustomerId,
      String? orbitsapchgmajor,
      String? orbitsapchgsub,
      String? orbitsapchgdetail,
      String? orbitsapchgdeal,
      String? orbitsapchgset,
      bool? excludeFromFlatPo,
      bool? isSplitRental,
      bool? isRebateRental,
      double? invoiceListTotal,
      double? invoiceGrossTotal,
      double? invoiceDiscountTotal,
      double? invoiceDaysPerWeekDiscountTotal,
      String? referenceNumber,
      String? agentId,
      String? agent,
      String? projectManagerId,
      String? projectManager,
      String? billToAddressId,
      String? billToName,
      String? billToAttention1,
      String? billToAttention2,
      String? billToAddress1,
      String? billToAddress2,
      String? billToCity,
      String? billToState,
      String? billToZipCode,
      String? billToCountryId,
      String? billToCountry,
      String? invoiceClass,
      String? printNotes,
      String? paymentTermsId,
      String? paymentTerms,
      String? paymentTypeId,
      String? paymentType,
      String? taxId,
      String? taxOptionId,
      String? taxOption,
      String? tax1Name,
      String? tax2Name,
      double? rentalTaxRate1,
      double? salesTaxRate1,
      double? laborTaxRate1,
      double? rentalTaxRate2,
      double? salesTaxRate2,
      double? laborTaxRate2,
      String? taxItemCode,
      String? taxVendor,
      String? taxCountry,
      String? chargeBatchId,
      String? chargeBatchNumber,
      bool? quikPayDiscount,
      double? quikPayRentalTotal,
      double? quikPayTotal,
      double? receivedTotal,
      String? rateType,
      double? consignmentRevenue,
      bool? isNonBillable,
      String? currencyId,
      String? currencyCode,
      String? currencySymbol,
      String? officeLocationDefaultCurrencyId,
      String? divisionId,
      String? outsideSalesRepresentativeId,
      String? outsideSalesRepresentative,
      bool? exportTaxAsLineItem,
      String? invoiceNumberColor,
      String? statusColor,
      String? orderNumberColor,
      String? purchaseOrderNumberColor,
      String? dealColor,
      String? billingStartDateColor,
      String? invoiceTotalColor,
      String? descriptionColor,
      bool? hasRentalItem,
      bool? hasMeterItem,
      bool? hasSalesItem,
      bool? hasLaborItem,
      bool? hasMiscellaneousItem,
      bool? hasFacilityItem,
      bool? hasTransportationItem,
      bool? hasRentalSaleItem,
      bool? hasLossAndDamageItem,
      double? rentalTotal,
      double? salesTotal,
      double? facilitiesTotal,
      double? miscellaneousTotal,
      double? laborTotal,
      double? partsTotal,
      double? assetSaleTotal,
      double? invoiceSubTotal,
      double? invoiceTax1,
      double? invoiceTax2,
      double? invoiceTax,
      double? invoiceTotal,
      bool? isStandAloneInvoice,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesBillingInvoiceInvoice(
        invoiceId: invoiceId ?? this.invoiceId,
        invoiceNumber: invoiceNumber ?? this.invoiceNumber,
        invoiceDate: invoiceDate ?? this.invoiceDate,
        invoiceDueDate: invoiceDueDate ?? this.invoiceDueDate,
        invoiceType: invoiceType ?? this.invoiceType,
        billingStartDate: billingStartDate ?? this.billingStartDate,
        billingEndDate: billingEndDate ?? this.billingEndDate,
        usageStartDate: usageStartDate ?? this.usageStartDate,
        usageEndDate: usageEndDate ?? this.usageEndDate,
        orderId: orderId ?? this.orderId,
        orderNumber: orderNumber ?? this.orderNumber,
        orderDescription: orderDescription ?? this.orderDescription,
        orderDate: orderDate ?? this.orderDate,
        orderLocation: orderLocation ?? this.orderLocation,
        invoiceDescription: invoiceDescription ?? this.invoiceDescription,
        creditingInvoiceId: creditingInvoiceId ?? this.creditingInvoiceId,
        creditingInvoiceNumber:
            creditingInvoiceNumber ?? this.creditingInvoiceNumber,
        customerId: customerId ?? this.customerId,
        customer: customer ?? this.customer,
        customerTypeId: customerTypeId ?? this.customerTypeId,
        customerType: customerType ?? this.customerType,
        dealId: dealId ?? this.dealId,
        deal: deal ?? this.deal,
        dealNumber: dealNumber ?? this.dealNumber,
        dealTypeId: dealTypeId ?? this.dealTypeId,
        departmentId: departmentId ?? this.departmentId,
        department: department ?? this.department,
        purchaseOrderNumber: purchaseOrderNumber ?? this.purchaseOrderNumber,
        workAuthorizationNumber:
            workAuthorizationNumber ?? this.workAuthorizationNumber,
        status: status ?? this.status,
        statusDate: statusDate ?? this.statusDate,
        isNoCharge: isNoCharge ?? this.isNoCharge,
        isAdjusted: isAdjusted ?? this.isAdjusted,
        isBilledHiatus: isBilledHiatus ?? this.isBilledHiatus,
        episodeNumber: episodeNumber ?? this.episodeNumber,
        hasLockedTotal: hasLockedTotal ?? this.hasLockedTotal,
        isAlteredDates: isAlteredDates ?? this.isAlteredDates,
        officeLocationId: officeLocationId ?? this.officeLocationId,
        officeLocation: officeLocation ?? this.officeLocation,
        invoiceCreationBatchId:
            invoiceCreationBatchId ?? this.invoiceCreationBatchId,
        invoiceCreationBatchNumber:
            invoiceCreationBatchNumber ?? this.invoiceCreationBatchNumber,
        invoiceGroupNumber: invoiceGroupNumber ?? this.invoiceGroupNumber,
        rentalSale: rentalSale ?? this.rentalSale,
        lossAndDamage: lossAndDamage ?? this.lossAndDamage,
        repair: repair ?? this.repair,
        inputByUserId: inputByUserId ?? this.inputByUserId,
        flatPoId: flatPoId ?? this.flatPoId,
        orderType: orderType ?? this.orderType,
        rebateCustomerId: rebateCustomerId ?? this.rebateCustomerId,
        orbitsapchgmajor: orbitsapchgmajor ?? this.orbitsapchgmajor,
        orbitsapchgsub: orbitsapchgsub ?? this.orbitsapchgsub,
        orbitsapchgdetail: orbitsapchgdetail ?? this.orbitsapchgdetail,
        orbitsapchgdeal: orbitsapchgdeal ?? this.orbitsapchgdeal,
        orbitsapchgset: orbitsapchgset ?? this.orbitsapchgset,
        excludeFromFlatPo: excludeFromFlatPo ?? this.excludeFromFlatPo,
        isSplitRental: isSplitRental ?? this.isSplitRental,
        isRebateRental: isRebateRental ?? this.isRebateRental,
        invoiceListTotal: invoiceListTotal ?? this.invoiceListTotal,
        invoiceGrossTotal: invoiceGrossTotal ?? this.invoiceGrossTotal,
        invoiceDiscountTotal: invoiceDiscountTotal ?? this.invoiceDiscountTotal,
        invoiceDaysPerWeekDiscountTotal: invoiceDaysPerWeekDiscountTotal ??
            this.invoiceDaysPerWeekDiscountTotal,
        referenceNumber: referenceNumber ?? this.referenceNumber,
        agentId: agentId ?? this.agentId,
        agent: agent ?? this.agent,
        projectManagerId: projectManagerId ?? this.projectManagerId,
        projectManager: projectManager ?? this.projectManager,
        billToAddressId: billToAddressId ?? this.billToAddressId,
        billToName: billToName ?? this.billToName,
        billToAttention1: billToAttention1 ?? this.billToAttention1,
        billToAttention2: billToAttention2 ?? this.billToAttention2,
        billToAddress1: billToAddress1 ?? this.billToAddress1,
        billToAddress2: billToAddress2 ?? this.billToAddress2,
        billToCity: billToCity ?? this.billToCity,
        billToState: billToState ?? this.billToState,
        billToZipCode: billToZipCode ?? this.billToZipCode,
        billToCountryId: billToCountryId ?? this.billToCountryId,
        billToCountry: billToCountry ?? this.billToCountry,
        invoiceClass: invoiceClass ?? this.invoiceClass,
        printNotes: printNotes ?? this.printNotes,
        paymentTermsId: paymentTermsId ?? this.paymentTermsId,
        paymentTerms: paymentTerms ?? this.paymentTerms,
        paymentTypeId: paymentTypeId ?? this.paymentTypeId,
        paymentType: paymentType ?? this.paymentType,
        taxId: taxId ?? this.taxId,
        taxOptionId: taxOptionId ?? this.taxOptionId,
        taxOption: taxOption ?? this.taxOption,
        tax1Name: tax1Name ?? this.tax1Name,
        tax2Name: tax2Name ?? this.tax2Name,
        rentalTaxRate1: rentalTaxRate1 ?? this.rentalTaxRate1,
        salesTaxRate1: salesTaxRate1 ?? this.salesTaxRate1,
        laborTaxRate1: laborTaxRate1 ?? this.laborTaxRate1,
        rentalTaxRate2: rentalTaxRate2 ?? this.rentalTaxRate2,
        salesTaxRate2: salesTaxRate2 ?? this.salesTaxRate2,
        laborTaxRate2: laborTaxRate2 ?? this.laborTaxRate2,
        taxItemCode: taxItemCode ?? this.taxItemCode,
        taxVendor: taxVendor ?? this.taxVendor,
        taxCountry: taxCountry ?? this.taxCountry,
        chargeBatchId: chargeBatchId ?? this.chargeBatchId,
        chargeBatchNumber: chargeBatchNumber ?? this.chargeBatchNumber,
        quikPayDiscount: quikPayDiscount ?? this.quikPayDiscount,
        quikPayRentalTotal: quikPayRentalTotal ?? this.quikPayRentalTotal,
        quikPayTotal: quikPayTotal ?? this.quikPayTotal,
        receivedTotal: receivedTotal ?? this.receivedTotal,
        rateType: rateType ?? this.rateType,
        consignmentRevenue: consignmentRevenue ?? this.consignmentRevenue,
        isNonBillable: isNonBillable ?? this.isNonBillable,
        currencyId: currencyId ?? this.currencyId,
        currencyCode: currencyCode ?? this.currencyCode,
        currencySymbol: currencySymbol ?? this.currencySymbol,
        officeLocationDefaultCurrencyId: officeLocationDefaultCurrencyId ??
            this.officeLocationDefaultCurrencyId,
        divisionId: divisionId ?? this.divisionId,
        outsideSalesRepresentativeId:
            outsideSalesRepresentativeId ?? this.outsideSalesRepresentativeId,
        outsideSalesRepresentative:
            outsideSalesRepresentative ?? this.outsideSalesRepresentative,
        exportTaxAsLineItem: exportTaxAsLineItem ?? this.exportTaxAsLineItem,
        invoiceNumberColor: invoiceNumberColor ?? this.invoiceNumberColor,
        statusColor: statusColor ?? this.statusColor,
        orderNumberColor: orderNumberColor ?? this.orderNumberColor,
        purchaseOrderNumberColor:
            purchaseOrderNumberColor ?? this.purchaseOrderNumberColor,
        dealColor: dealColor ?? this.dealColor,
        billingStartDateColor:
            billingStartDateColor ?? this.billingStartDateColor,
        invoiceTotalColor: invoiceTotalColor ?? this.invoiceTotalColor,
        descriptionColor: descriptionColor ?? this.descriptionColor,
        hasRentalItem: hasRentalItem ?? this.hasRentalItem,
        hasMeterItem: hasMeterItem ?? this.hasMeterItem,
        hasSalesItem: hasSalesItem ?? this.hasSalesItem,
        hasLaborItem: hasLaborItem ?? this.hasLaborItem,
        hasMiscellaneousItem: hasMiscellaneousItem ?? this.hasMiscellaneousItem,
        hasFacilityItem: hasFacilityItem ?? this.hasFacilityItem,
        hasTransportationItem:
            hasTransportationItem ?? this.hasTransportationItem,
        hasRentalSaleItem: hasRentalSaleItem ?? this.hasRentalSaleItem,
        hasLossAndDamageItem: hasLossAndDamageItem ?? this.hasLossAndDamageItem,
        rentalTotal: rentalTotal ?? this.rentalTotal,
        salesTotal: salesTotal ?? this.salesTotal,
        facilitiesTotal: facilitiesTotal ?? this.facilitiesTotal,
        miscellaneousTotal: miscellaneousTotal ?? this.miscellaneousTotal,
        laborTotal: laborTotal ?? this.laborTotal,
        partsTotal: partsTotal ?? this.partsTotal,
        assetSaleTotal: assetSaleTotal ?? this.assetSaleTotal,
        invoiceSubTotal: invoiceSubTotal ?? this.invoiceSubTotal,
        invoiceTax1: invoiceTax1 ?? this.invoiceTax1,
        invoiceTax2: invoiceTax2 ?? this.invoiceTax2,
        invoiceTax: invoiceTax ?? this.invoiceTax,
        invoiceTotal: invoiceTotal ?? this.invoiceTotal,
        isStandAloneInvoice: isStandAloneInvoice ?? this.isStandAloneInvoice,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingInvoiceToggleInvoiceApprovedResponse {
  WebApiModulesBillingInvoiceToggleInvoiceApprovedResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesBillingInvoiceToggleInvoiceApprovedResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingInvoiceToggleInvoiceApprovedResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesBillingInvoiceToggleInvoiceApprovedResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesBillingInvoiceToggleInvoiceApprovedResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingInvoiceToggleInvoiceApprovedResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingInvoiceToggleInvoiceApprovedResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesBillingInvoiceToggleInvoiceApprovedResponseExtension
    on WebApiModulesBillingInvoiceToggleInvoiceApprovedResponse {
  WebApiModulesBillingInvoiceToggleInvoiceApprovedResponse copyWith(
      {int? status, bool? success, String? msg}) {
    return WebApiModulesBillingInvoiceToggleInvoiceApprovedResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingPaymentPayment {
  WebApiModulesBillingPaymentPayment({
    this.paymentId,
    this.paymentDate,
    this.locationId,
    this.departmentId,
    this.locationCode,
    this.location,
    this.vendorId,
    this.vendor,
    this.paymentTypeId,
    this.paymentType,
    this.bankAccountId,
    this.accountName,
    this.officeLocationDefaultCurrencyId,
    this.currencyId,
    this.currency,
    this.currencyCode,
    this.currencySymbol,
    this.checkNumber,
    this.paymentDocumentNumber,
    this.paymentAmount,
    this.appliedById,
    this.appliedBy,
    this.modifiedById,
    this.modifiedBy,
    this.paymentMemo,
    this.recType,
    this.chargeBatchId,
    this.chargeBatchNumber,
    this.vendorInvoiceDataList,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesBillingPaymentPayment.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingPaymentPaymentFromJson(json);

  @JsonKey(name: 'PaymentId')
  final String? paymentId;
  @JsonKey(name: 'PaymentDate')
  final String? paymentDate;
  @JsonKey(name: 'LocationId')
  final String? locationId;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'LocationCode')
  final String? locationCode;
  @JsonKey(name: 'Location')
  final String? location;
  @JsonKey(name: 'VendorId')
  final String? vendorId;
  @JsonKey(name: 'Vendor')
  final String? vendor;
  @JsonKey(name: 'PaymentTypeId')
  final String? paymentTypeId;
  @JsonKey(name: 'PaymentType')
  final String? paymentType;
  @JsonKey(name: 'BankAccountId')
  final int? bankAccountId;
  @JsonKey(name: 'AccountName')
  final String? accountName;
  @JsonKey(name: 'OfficeLocationDefaultCurrencyId')
  final String? officeLocationDefaultCurrencyId;
  @JsonKey(name: 'CurrencyId')
  final String? currencyId;
  @JsonKey(name: 'Currency')
  final String? currency;
  @JsonKey(name: 'CurrencyCode')
  final String? currencyCode;
  @JsonKey(name: 'CurrencySymbol')
  final String? currencySymbol;
  @JsonKey(name: 'CheckNumber')
  final String? checkNumber;
  @JsonKey(name: 'PaymentDocumentNumber')
  final String? paymentDocumentNumber;
  @JsonKey(name: 'PaymentAmount')
  final double? paymentAmount;
  @JsonKey(name: 'AppliedById')
  final String? appliedById;
  @JsonKey(name: 'AppliedBy')
  final String? appliedBy;
  @JsonKey(name: 'ModifiedById')
  final String? modifiedById;
  @JsonKey(name: 'ModifiedBy')
  final String? modifiedBy;
  @JsonKey(name: 'PaymentMemo')
  final String? paymentMemo;
  @JsonKey(name: 'RecType')
  final String? recType;
  @JsonKey(name: 'ChargeBatchId')
  final String? chargeBatchId;
  @JsonKey(name: 'ChargeBatchNumber')
  final String? chargeBatchNumber;
  @JsonKey(
      name: 'VendorInvoiceDataList',
      defaultValue: <WebApiModulesBillingPaymentPaymentVendorInvoice>[])
  final List<WebApiModulesBillingPaymentPaymentVendorInvoice>?
      vendorInvoiceDataList;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory = _$WebApiModulesBillingPaymentPaymentFromJson;
  static const toJsonFactory = _$WebApiModulesBillingPaymentPaymentToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingPaymentPaymentToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingPaymentPayment &&
            (identical(other.paymentId, paymentId) ||
                const DeepCollectionEquality()
                    .equals(other.paymentId, paymentId)) &&
            (identical(other.paymentDate, paymentDate) ||
                const DeepCollectionEquality()
                    .equals(other.paymentDate, paymentDate)) &&
            (identical(other.locationId, locationId) ||
                const DeepCollectionEquality()
                    .equals(other.locationId, locationId)) &&
            (identical(other.departmentId, departmentId) ||
                const DeepCollectionEquality()
                    .equals(other.departmentId, departmentId)) &&
            (identical(other.locationCode, locationCode) ||
                const DeepCollectionEquality()
                    .equals(other.locationCode, locationCode)) &&
            (identical(other.location, location) ||
                const DeepCollectionEquality()
                    .equals(other.location, location)) &&
            (identical(other.vendorId, vendorId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorId, vendorId)) &&
            (identical(other.vendor, vendor) ||
                const DeepCollectionEquality().equals(other.vendor, vendor)) &&
            (identical(other.paymentTypeId, paymentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.paymentTypeId, paymentTypeId)) &&
            (identical(other.paymentType, paymentType) ||
                const DeepCollectionEquality()
                    .equals(other.paymentType, paymentType)) &&
            (identical(other.bankAccountId, bankAccountId) ||
                const DeepCollectionEquality()
                    .equals(other.bankAccountId, bankAccountId)) &&
            (identical(other.accountName, accountName) ||
                const DeepCollectionEquality()
                    .equals(other.accountName, accountName)) &&
            (identical(other.officeLocationDefaultCurrencyId, officeLocationDefaultCurrencyId) ||
                const DeepCollectionEquality().equals(
                    other.officeLocationDefaultCurrencyId,
                    officeLocationDefaultCurrencyId)) &&
            (identical(other.currencyId, currencyId) ||
                const DeepCollectionEquality()
                    .equals(other.currencyId, currencyId)) &&
            (identical(other.currency, currency) ||
                const DeepCollectionEquality()
                    .equals(other.currency, currency)) &&
            (identical(other.currencyCode, currencyCode) ||
                const DeepCollectionEquality()
                    .equals(other.currencyCode, currencyCode)) &&
            (identical(other.currencySymbol, currencySymbol) ||
                const DeepCollectionEquality()
                    .equals(other.currencySymbol, currencySymbol)) &&
            (identical(other.checkNumber, checkNumber) ||
                const DeepCollectionEquality()
                    .equals(other.checkNumber, checkNumber)) &&
            (identical(other.paymentDocumentNumber, paymentDocumentNumber) ||
                const DeepCollectionEquality().equals(
                    other.paymentDocumentNumber, paymentDocumentNumber)) &&
            (identical(other.paymentAmount, paymentAmount) ||
                const DeepCollectionEquality()
                    .equals(other.paymentAmount, paymentAmount)) &&
            (identical(other.appliedById, appliedById) || const DeepCollectionEquality().equals(other.appliedById, appliedById)) &&
            (identical(other.appliedBy, appliedBy) || const DeepCollectionEquality().equals(other.appliedBy, appliedBy)) &&
            (identical(other.modifiedById, modifiedById) || const DeepCollectionEquality().equals(other.modifiedById, modifiedById)) &&
            (identical(other.modifiedBy, modifiedBy) || const DeepCollectionEquality().equals(other.modifiedBy, modifiedBy)) &&
            (identical(other.paymentMemo, paymentMemo) || const DeepCollectionEquality().equals(other.paymentMemo, paymentMemo)) &&
            (identical(other.recType, recType) || const DeepCollectionEquality().equals(other.recType, recType)) &&
            (identical(other.chargeBatchId, chargeBatchId) || const DeepCollectionEquality().equals(other.chargeBatchId, chargeBatchId)) &&
            (identical(other.chargeBatchNumber, chargeBatchNumber) || const DeepCollectionEquality().equals(other.chargeBatchNumber, chargeBatchNumber)) &&
            (identical(other.vendorInvoiceDataList, vendorInvoiceDataList) || const DeepCollectionEquality().equals(other.vendorInvoiceDataList, vendorInvoiceDataList)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesBillingPaymentPaymentExtension
    on WebApiModulesBillingPaymentPayment {
  WebApiModulesBillingPaymentPayment copyWith(
      {String? paymentId,
      String? paymentDate,
      String? locationId,
      String? departmentId,
      String? locationCode,
      String? location,
      String? vendorId,
      String? vendor,
      String? paymentTypeId,
      String? paymentType,
      int? bankAccountId,
      String? accountName,
      String? officeLocationDefaultCurrencyId,
      String? currencyId,
      String? currency,
      String? currencyCode,
      String? currencySymbol,
      String? checkNumber,
      String? paymentDocumentNumber,
      double? paymentAmount,
      String? appliedById,
      String? appliedBy,
      String? modifiedById,
      String? modifiedBy,
      String? paymentMemo,
      String? recType,
      String? chargeBatchId,
      String? chargeBatchNumber,
      List<WebApiModulesBillingPaymentPaymentVendorInvoice>?
          vendorInvoiceDataList,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesBillingPaymentPayment(
        paymentId: paymentId ?? this.paymentId,
        paymentDate: paymentDate ?? this.paymentDate,
        locationId: locationId ?? this.locationId,
        departmentId: departmentId ?? this.departmentId,
        locationCode: locationCode ?? this.locationCode,
        location: location ?? this.location,
        vendorId: vendorId ?? this.vendorId,
        vendor: vendor ?? this.vendor,
        paymentTypeId: paymentTypeId ?? this.paymentTypeId,
        paymentType: paymentType ?? this.paymentType,
        bankAccountId: bankAccountId ?? this.bankAccountId,
        accountName: accountName ?? this.accountName,
        officeLocationDefaultCurrencyId: officeLocationDefaultCurrencyId ??
            this.officeLocationDefaultCurrencyId,
        currencyId: currencyId ?? this.currencyId,
        currency: currency ?? this.currency,
        currencyCode: currencyCode ?? this.currencyCode,
        currencySymbol: currencySymbol ?? this.currencySymbol,
        checkNumber: checkNumber ?? this.checkNumber,
        paymentDocumentNumber:
            paymentDocumentNumber ?? this.paymentDocumentNumber,
        paymentAmount: paymentAmount ?? this.paymentAmount,
        appliedById: appliedById ?? this.appliedById,
        appliedBy: appliedBy ?? this.appliedBy,
        modifiedById: modifiedById ?? this.modifiedById,
        modifiedBy: modifiedBy ?? this.modifiedBy,
        paymentMemo: paymentMemo ?? this.paymentMemo,
        recType: recType ?? this.recType,
        chargeBatchId: chargeBatchId ?? this.chargeBatchId,
        chargeBatchNumber: chargeBatchNumber ?? this.chargeBatchNumber,
        vendorInvoiceDataList:
            vendorInvoiceDataList ?? this.vendorInvoiceDataList,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingPaymentPaymentVendorInvoice {
  WebApiModulesBillingPaymentPaymentVendorInvoice({
    this.vendorInvoicePaymentId,
    this.vendorInvoiceId,
    this.amount,
  });

  factory WebApiModulesBillingPaymentPaymentVendorInvoice.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingPaymentPaymentVendorInvoiceFromJson(json);

  @JsonKey(name: 'VendorInvoicePaymentId')
  final String? vendorInvoicePaymentId;
  @JsonKey(name: 'VendorInvoiceId')
  final String? vendorInvoiceId;
  @JsonKey(name: 'Amount')
  final double? amount;
  static const fromJsonFactory =
      _$WebApiModulesBillingPaymentPaymentVendorInvoiceFromJson;
  static const toJsonFactory =
      _$WebApiModulesBillingPaymentPaymentVendorInvoiceToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingPaymentPaymentVendorInvoiceToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingPaymentPaymentVendorInvoice &&
            (identical(other.vendorInvoicePaymentId, vendorInvoicePaymentId) ||
                const DeepCollectionEquality().equals(
                    other.vendorInvoicePaymentId, vendorInvoicePaymentId)) &&
            (identical(other.vendorInvoiceId, vendorInvoiceId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorInvoiceId, vendorInvoiceId)) &&
            (identical(other.amount, amount) ||
                const DeepCollectionEquality().equals(other.amount, amount)));
  }
}

extension $WebApiModulesBillingPaymentPaymentVendorInvoiceExtension
    on WebApiModulesBillingPaymentPaymentVendorInvoice {
  WebApiModulesBillingPaymentPaymentVendorInvoice copyWith(
      {String? vendorInvoicePaymentId,
      String? vendorInvoiceId,
      double? amount}) {
    return WebApiModulesBillingPaymentPaymentVendorInvoice(
        vendorInvoicePaymentId:
            vendorInvoicePaymentId ?? this.vendorInvoicePaymentId,
        vendorInvoiceId: vendorInvoiceId ?? this.vendorInvoiceId,
        amount: amount ?? this.amount);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingReceiptAddDepletingDepositRequest {
  WebApiModulesBillingReceiptAddDepletingDepositRequest({
    this.orderId,
    this.dealId,
    this.paymentTypeId,
    this.paymentAmount,
    this.receiptDate,
    this.locationId,
    this.currencyId,
    this.checkNumber,
    this.paymentMemo,
  });

  factory WebApiModulesBillingReceiptAddDepletingDepositRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingReceiptAddDepletingDepositRequestFromJson(json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'PaymentTypeId')
  final String? paymentTypeId;
  @JsonKey(name: 'PaymentAmount')
  final double? paymentAmount;
  @JsonKey(name: 'ReceiptDate')
  final DateTime? receiptDate;
  @JsonKey(name: 'LocationId')
  final String? locationId;
  @JsonKey(name: 'CurrencyId')
  final String? currencyId;
  @JsonKey(name: 'CheckNumber')
  final String? checkNumber;
  @JsonKey(name: 'PaymentMemo')
  final String? paymentMemo;
  static const fromJsonFactory =
      _$WebApiModulesBillingReceiptAddDepletingDepositRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesBillingReceiptAddDepletingDepositRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingReceiptAddDepletingDepositRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingReceiptAddDepletingDepositRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.paymentTypeId, paymentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.paymentTypeId, paymentTypeId)) &&
            (identical(other.paymentAmount, paymentAmount) ||
                const DeepCollectionEquality()
                    .equals(other.paymentAmount, paymentAmount)) &&
            (identical(other.receiptDate, receiptDate) ||
                const DeepCollectionEquality()
                    .equals(other.receiptDate, receiptDate)) &&
            (identical(other.locationId, locationId) ||
                const DeepCollectionEquality()
                    .equals(other.locationId, locationId)) &&
            (identical(other.currencyId, currencyId) ||
                const DeepCollectionEquality()
                    .equals(other.currencyId, currencyId)) &&
            (identical(other.checkNumber, checkNumber) ||
                const DeepCollectionEquality()
                    .equals(other.checkNumber, checkNumber)) &&
            (identical(other.paymentMemo, paymentMemo) ||
                const DeepCollectionEquality()
                    .equals(other.paymentMemo, paymentMemo)));
  }
}

extension $WebApiModulesBillingReceiptAddDepletingDepositRequestExtension
    on WebApiModulesBillingReceiptAddDepletingDepositRequest {
  WebApiModulesBillingReceiptAddDepletingDepositRequest copyWith(
      {String? orderId,
      String? dealId,
      String? paymentTypeId,
      double? paymentAmount,
      DateTime? receiptDate,
      String? locationId,
      String? currencyId,
      String? checkNumber,
      String? paymentMemo}) {
    return WebApiModulesBillingReceiptAddDepletingDepositRequest(
        orderId: orderId ?? this.orderId,
        dealId: dealId ?? this.dealId,
        paymentTypeId: paymentTypeId ?? this.paymentTypeId,
        paymentAmount: paymentAmount ?? this.paymentAmount,
        receiptDate: receiptDate ?? this.receiptDate,
        locationId: locationId ?? this.locationId,
        currencyId: currencyId ?? this.currencyId,
        checkNumber: checkNumber ?? this.checkNumber,
        paymentMemo: paymentMemo ?? this.paymentMemo);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingReceiptCreditCardDepletingDepositRequest {
  WebApiModulesBillingReceiptCreditCardDepletingDepositRequest({
    this.orderId,
    this.amountToPay,
    this.pINPadCode,
    this.dealNumber,
  });

  factory WebApiModulesBillingReceiptCreditCardDepletingDepositRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingReceiptCreditCardDepletingDepositRequestFromJson(
          json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'AmountToPay')
  final double? amountToPay;
  @JsonKey(name: 'PINPad_Code')
  final String? pINPadCode;
  @JsonKey(name: 'DealNumber')
  final String? dealNumber;
  static const fromJsonFactory =
      _$WebApiModulesBillingReceiptCreditCardDepletingDepositRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesBillingReceiptCreditCardDepletingDepositRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingReceiptCreditCardDepletingDepositRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingReceiptCreditCardDepletingDepositRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.amountToPay, amountToPay) ||
                const DeepCollectionEquality()
                    .equals(other.amountToPay, amountToPay)) &&
            (identical(other.pINPadCode, pINPadCode) ||
                const DeepCollectionEquality()
                    .equals(other.pINPadCode, pINPadCode)) &&
            (identical(other.dealNumber, dealNumber) ||
                const DeepCollectionEquality()
                    .equals(other.dealNumber, dealNumber)));
  }
}

extension $WebApiModulesBillingReceiptCreditCardDepletingDepositRequestExtension
    on WebApiModulesBillingReceiptCreditCardDepletingDepositRequest {
  WebApiModulesBillingReceiptCreditCardDepletingDepositRequest copyWith(
      {String? orderId,
      double? amountToPay,
      String? pINPadCode,
      String? dealNumber}) {
    return WebApiModulesBillingReceiptCreditCardDepletingDepositRequest(
        orderId: orderId ?? this.orderId,
        amountToPay: amountToPay ?? this.amountToPay,
        pINPadCode: pINPadCode ?? this.pINPadCode,
        dealNumber: dealNumber ?? this.dealNumber);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingReceiptCreditCardRefundRequest {
  WebApiModulesBillingReceiptCreditCardRefundRequest({
    this.receiptId,
    this.pINPadCode,
    this.refundAmount,
  });

  factory WebApiModulesBillingReceiptCreditCardRefundRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingReceiptCreditCardRefundRequestFromJson(json);

  @JsonKey(name: 'ReceiptId')
  final String? receiptId;
  @JsonKey(name: 'PINPad_Code')
  final String? pINPadCode;
  @JsonKey(name: 'RefundAmount')
  final double? refundAmount;
  static const fromJsonFactory =
      _$WebApiModulesBillingReceiptCreditCardRefundRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesBillingReceiptCreditCardRefundRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingReceiptCreditCardRefundRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingReceiptCreditCardRefundRequest &&
            (identical(other.receiptId, receiptId) ||
                const DeepCollectionEquality()
                    .equals(other.receiptId, receiptId)) &&
            (identical(other.pINPadCode, pINPadCode) ||
                const DeepCollectionEquality()
                    .equals(other.pINPadCode, pINPadCode)) &&
            (identical(other.refundAmount, refundAmount) ||
                const DeepCollectionEquality()
                    .equals(other.refundAmount, refundAmount)));
  }
}

extension $WebApiModulesBillingReceiptCreditCardRefundRequestExtension
    on WebApiModulesBillingReceiptCreditCardRefundRequest {
  WebApiModulesBillingReceiptCreditCardRefundRequest copyWith(
      {String? receiptId, String? pINPadCode, double? refundAmount}) {
    return WebApiModulesBillingReceiptCreditCardRefundRequest(
        receiptId: receiptId ?? this.receiptId,
        pINPadCode: pINPadCode ?? this.pINPadCode,
        refundAmount: refundAmount ?? this.refundAmount);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingReceiptReceipt {
  WebApiModulesBillingReceiptReceipt({
    this.receiptId,
    this.receiptDate,
    this.locationId,
    this.locationCode,
    this.location,
    this.customerId,
    this.customer,
    this.dealId,
    this.deal,
    this.paymentBy,
    this.customerDeal,
    this.paymentTypeId,
    this.paymentType,
    this.paymentTypeType,
    this.paymentTypeExportPaymentMethod,
    this.checkNumber,
    this.paymentAmount,
    this.appliedById,
    this.appliedBy,
    this.modifiedById,
    this.modifiedBy,
    this.paymentMemo,
    this.recType,
    this.chargeBatchId,
    this.chargeBatchNumber,
    this.currencyId,
    this.currencyCode,
    this.currencySymbol,
    this.officeLocationDefaultCurrencyId,
    this.overPaymentId,
    this.invoiceDataList,
    this.creditDataList,
    this.createOverpayment,
    this.createDepletingDeposit,
    this.dealDepositId,
    this.dealDepositCheckNumber,
    this.customerDepositId,
    this.customerDepositCheckNumber,
    this.orderId,
    this.orderDescription,
    this.authorizationCode,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesBillingReceiptReceipt.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingReceiptReceiptFromJson(json);

  @JsonKey(name: 'ReceiptId')
  final String? receiptId;
  @JsonKey(name: 'ReceiptDate')
  final String? receiptDate;
  @JsonKey(name: 'LocationId')
  final String? locationId;
  @JsonKey(name: 'LocationCode')
  final String? locationCode;
  @JsonKey(name: 'Location')
  final String? location;
  @JsonKey(name: 'CustomerId')
  final String? customerId;
  @JsonKey(name: 'Customer')
  final String? customer;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'Deal')
  final String? deal;
  @JsonKey(name: 'PaymentBy')
  final String? paymentBy;
  @JsonKey(name: 'CustomerDeal')
  final String? customerDeal;
  @JsonKey(name: 'PaymentTypeId')
  final String? paymentTypeId;
  @JsonKey(name: 'PaymentType')
  final String? paymentType;
  @JsonKey(name: 'PaymentTypeType')
  final String? paymentTypeType;
  @JsonKey(name: 'PaymentTypeExportPaymentMethod')
  final String? paymentTypeExportPaymentMethod;
  @JsonKey(name: 'CheckNumber')
  final String? checkNumber;
  @JsonKey(name: 'PaymentAmount')
  final double? paymentAmount;
  @JsonKey(name: 'AppliedById')
  final String? appliedById;
  @JsonKey(name: 'AppliedBy')
  final String? appliedBy;
  @JsonKey(name: 'ModifiedById')
  final String? modifiedById;
  @JsonKey(name: 'ModifiedBy')
  final String? modifiedBy;
  @JsonKey(name: 'PaymentMemo')
  final String? paymentMemo;
  @JsonKey(name: 'RecType')
  final String? recType;
  @JsonKey(name: 'ChargeBatchId')
  final String? chargeBatchId;
  @JsonKey(name: 'ChargeBatchNumber')
  final String? chargeBatchNumber;
  @JsonKey(name: 'CurrencyId')
  final String? currencyId;
  @JsonKey(name: 'CurrencyCode')
  final String? currencyCode;
  @JsonKey(name: 'CurrencySymbol')
  final String? currencySymbol;
  @JsonKey(name: 'OfficeLocationDefaultCurrencyId')
  final String? officeLocationDefaultCurrencyId;
  @JsonKey(name: 'OverPaymentId')
  final String? overPaymentId;
  @JsonKey(
      name: 'InvoiceDataList',
      defaultValue: <WebApiModulesBillingReceiptReceiptInvoice>[])
  final List<WebApiModulesBillingReceiptReceiptInvoice>? invoiceDataList;
  @JsonKey(
      name: 'CreditDataList',
      defaultValue: <WebApiModulesBillingReceiptReceiptCredit>[])
  final List<WebApiModulesBillingReceiptReceiptCredit>? creditDataList;
  @JsonKey(name: 'CreateOverpayment')
  final bool? createOverpayment;
  @JsonKey(name: 'CreateDepletingDeposit')
  final bool? createDepletingDeposit;
  @JsonKey(name: 'DealDepositId')
  final String? dealDepositId;
  @JsonKey(name: 'DealDepositCheckNumber')
  final String? dealDepositCheckNumber;
  @JsonKey(name: 'CustomerDepositId')
  final String? customerDepositId;
  @JsonKey(name: 'CustomerDepositCheckNumber')
  final String? customerDepositCheckNumber;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderDescription')
  final String? orderDescription;
  @JsonKey(name: 'AuthorizationCode')
  final String? authorizationCode;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory = _$WebApiModulesBillingReceiptReceiptFromJson;
  static const toJsonFactory = _$WebApiModulesBillingReceiptReceiptToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingReceiptReceiptToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingReceiptReceipt &&
            (identical(other.receiptId, receiptId) ||
                const DeepCollectionEquality()
                    .equals(other.receiptId, receiptId)) &&
            (identical(other.receiptDate, receiptDate) ||
                const DeepCollectionEquality()
                    .equals(other.receiptDate, receiptDate)) &&
            (identical(other.locationId, locationId) ||
                const DeepCollectionEquality()
                    .equals(other.locationId, locationId)) &&
            (identical(other.locationCode, locationCode) ||
                const DeepCollectionEquality()
                    .equals(other.locationCode, locationCode)) &&
            (identical(other.location, location) ||
                const DeepCollectionEquality()
                    .equals(other.location, location)) &&
            (identical(other.customerId, customerId) ||
                const DeepCollectionEquality()
                    .equals(other.customerId, customerId)) &&
            (identical(other.customer, customer) ||
                const DeepCollectionEquality()
                    .equals(other.customer, customer)) &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.deal, deal) ||
                const DeepCollectionEquality().equals(other.deal, deal)) &&
            (identical(other.paymentBy, paymentBy) ||
                const DeepCollectionEquality()
                    .equals(other.paymentBy, paymentBy)) &&
            (identical(other.customerDeal, customerDeal) ||
                const DeepCollectionEquality()
                    .equals(other.customerDeal, customerDeal)) &&
            (identical(other.paymentTypeId, paymentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.paymentTypeId, paymentTypeId)) &&
            (identical(other.paymentType, paymentType) ||
                const DeepCollectionEquality()
                    .equals(other.paymentType, paymentType)) &&
            (identical(other.paymentTypeType, paymentTypeType) ||
                const DeepCollectionEquality()
                    .equals(other.paymentTypeType, paymentTypeType)) &&
            (identical(other.paymentTypeExportPaymentMethod, paymentTypeExportPaymentMethod) ||
                const DeepCollectionEquality().equals(
                    other.paymentTypeExportPaymentMethod,
                    paymentTypeExportPaymentMethod)) &&
            (identical(other.checkNumber, checkNumber) ||
                const DeepCollectionEquality()
                    .equals(other.checkNumber, checkNumber)) &&
            (identical(other.paymentAmount, paymentAmount) ||
                const DeepCollectionEquality()
                    .equals(other.paymentAmount, paymentAmount)) &&
            (identical(other.appliedById, appliedById) ||
                const DeepCollectionEquality()
                    .equals(other.appliedById, appliedById)) &&
            (identical(other.appliedBy, appliedBy) ||
                const DeepCollectionEquality()
                    .equals(other.appliedBy, appliedBy)) &&
            (identical(other.modifiedById, modifiedById) ||
                const DeepCollectionEquality()
                    .equals(other.modifiedById, modifiedById)) &&
            (identical(other.modifiedBy, modifiedBy) ||
                const DeepCollectionEquality()
                    .equals(other.modifiedBy, modifiedBy)) &&
            (identical(other.paymentMemo, paymentMemo) || const DeepCollectionEquality().equals(other.paymentMemo, paymentMemo)) &&
            (identical(other.recType, recType) || const DeepCollectionEquality().equals(other.recType, recType)) &&
            (identical(other.chargeBatchId, chargeBatchId) || const DeepCollectionEquality().equals(other.chargeBatchId, chargeBatchId)) &&
            (identical(other.chargeBatchNumber, chargeBatchNumber) || const DeepCollectionEquality().equals(other.chargeBatchNumber, chargeBatchNumber)) &&
            (identical(other.currencyId, currencyId) || const DeepCollectionEquality().equals(other.currencyId, currencyId)) &&
            (identical(other.currencyCode, currencyCode) || const DeepCollectionEquality().equals(other.currencyCode, currencyCode)) &&
            (identical(other.currencySymbol, currencySymbol) || const DeepCollectionEquality().equals(other.currencySymbol, currencySymbol)) &&
            (identical(other.officeLocationDefaultCurrencyId, officeLocationDefaultCurrencyId) || const DeepCollectionEquality().equals(other.officeLocationDefaultCurrencyId, officeLocationDefaultCurrencyId)) &&
            (identical(other.overPaymentId, overPaymentId) || const DeepCollectionEquality().equals(other.overPaymentId, overPaymentId)) &&
            (identical(other.invoiceDataList, invoiceDataList) || const DeepCollectionEquality().equals(other.invoiceDataList, invoiceDataList)) &&
            (identical(other.creditDataList, creditDataList) || const DeepCollectionEquality().equals(other.creditDataList, creditDataList)) &&
            (identical(other.createOverpayment, createOverpayment) || const DeepCollectionEquality().equals(other.createOverpayment, createOverpayment)) &&
            (identical(other.createDepletingDeposit, createDepletingDeposit) || const DeepCollectionEquality().equals(other.createDepletingDeposit, createDepletingDeposit)) &&
            (identical(other.dealDepositId, dealDepositId) || const DeepCollectionEquality().equals(other.dealDepositId, dealDepositId)) &&
            (identical(other.dealDepositCheckNumber, dealDepositCheckNumber) || const DeepCollectionEquality().equals(other.dealDepositCheckNumber, dealDepositCheckNumber)) &&
            (identical(other.customerDepositId, customerDepositId) || const DeepCollectionEquality().equals(other.customerDepositId, customerDepositId)) &&
            (identical(other.customerDepositCheckNumber, customerDepositCheckNumber) || const DeepCollectionEquality().equals(other.customerDepositCheckNumber, customerDepositCheckNumber)) &&
            (identical(other.orderId, orderId) || const DeepCollectionEquality().equals(other.orderId, orderId)) &&
            (identical(other.orderDescription, orderDescription) || const DeepCollectionEquality().equals(other.orderDescription, orderDescription)) &&
            (identical(other.authorizationCode, authorizationCode) || const DeepCollectionEquality().equals(other.authorizationCode, authorizationCode)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesBillingReceiptReceiptExtension
    on WebApiModulesBillingReceiptReceipt {
  WebApiModulesBillingReceiptReceipt copyWith(
      {String? receiptId,
      String? receiptDate,
      String? locationId,
      String? locationCode,
      String? location,
      String? customerId,
      String? customer,
      String? dealId,
      String? deal,
      String? paymentBy,
      String? customerDeal,
      String? paymentTypeId,
      String? paymentType,
      String? paymentTypeType,
      String? paymentTypeExportPaymentMethod,
      String? checkNumber,
      double? paymentAmount,
      String? appliedById,
      String? appliedBy,
      String? modifiedById,
      String? modifiedBy,
      String? paymentMemo,
      String? recType,
      String? chargeBatchId,
      String? chargeBatchNumber,
      String? currencyId,
      String? currencyCode,
      String? currencySymbol,
      String? officeLocationDefaultCurrencyId,
      String? overPaymentId,
      List<WebApiModulesBillingReceiptReceiptInvoice>? invoiceDataList,
      List<WebApiModulesBillingReceiptReceiptCredit>? creditDataList,
      bool? createOverpayment,
      bool? createDepletingDeposit,
      String? dealDepositId,
      String? dealDepositCheckNumber,
      String? customerDepositId,
      String? customerDepositCheckNumber,
      String? orderId,
      String? orderDescription,
      String? authorizationCode,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesBillingReceiptReceipt(
        receiptId: receiptId ?? this.receiptId,
        receiptDate: receiptDate ?? this.receiptDate,
        locationId: locationId ?? this.locationId,
        locationCode: locationCode ?? this.locationCode,
        location: location ?? this.location,
        customerId: customerId ?? this.customerId,
        customer: customer ?? this.customer,
        dealId: dealId ?? this.dealId,
        deal: deal ?? this.deal,
        paymentBy: paymentBy ?? this.paymentBy,
        customerDeal: customerDeal ?? this.customerDeal,
        paymentTypeId: paymentTypeId ?? this.paymentTypeId,
        paymentType: paymentType ?? this.paymentType,
        paymentTypeType: paymentTypeType ?? this.paymentTypeType,
        paymentTypeExportPaymentMethod: paymentTypeExportPaymentMethod ??
            this.paymentTypeExportPaymentMethod,
        checkNumber: checkNumber ?? this.checkNumber,
        paymentAmount: paymentAmount ?? this.paymentAmount,
        appliedById: appliedById ?? this.appliedById,
        appliedBy: appliedBy ?? this.appliedBy,
        modifiedById: modifiedById ?? this.modifiedById,
        modifiedBy: modifiedBy ?? this.modifiedBy,
        paymentMemo: paymentMemo ?? this.paymentMemo,
        recType: recType ?? this.recType,
        chargeBatchId: chargeBatchId ?? this.chargeBatchId,
        chargeBatchNumber: chargeBatchNumber ?? this.chargeBatchNumber,
        currencyId: currencyId ?? this.currencyId,
        currencyCode: currencyCode ?? this.currencyCode,
        currencySymbol: currencySymbol ?? this.currencySymbol,
        officeLocationDefaultCurrencyId: officeLocationDefaultCurrencyId ??
            this.officeLocationDefaultCurrencyId,
        overPaymentId: overPaymentId ?? this.overPaymentId,
        invoiceDataList: invoiceDataList ?? this.invoiceDataList,
        creditDataList: creditDataList ?? this.creditDataList,
        createOverpayment: createOverpayment ?? this.createOverpayment,
        createDepletingDeposit:
            createDepletingDeposit ?? this.createDepletingDeposit,
        dealDepositId: dealDepositId ?? this.dealDepositId,
        dealDepositCheckNumber:
            dealDepositCheckNumber ?? this.dealDepositCheckNumber,
        customerDepositId: customerDepositId ?? this.customerDepositId,
        customerDepositCheckNumber:
            customerDepositCheckNumber ?? this.customerDepositCheckNumber,
        orderId: orderId ?? this.orderId,
        orderDescription: orderDescription ?? this.orderDescription,
        authorizationCode: authorizationCode ?? this.authorizationCode,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingReceiptReceiptCredit {
  WebApiModulesBillingReceiptReceiptCredit({
    this.creditReceiptId,
    this.creditId,
    this.amount,
  });

  factory WebApiModulesBillingReceiptReceiptCredit.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingReceiptReceiptCreditFromJson(json);

  @JsonKey(name: 'CreditReceiptId')
  final String? creditReceiptId;
  @JsonKey(name: 'CreditId')
  final String? creditId;
  @JsonKey(name: 'Amount')
  final double? amount;
  static const fromJsonFactory =
      _$WebApiModulesBillingReceiptReceiptCreditFromJson;
  static const toJsonFactory = _$WebApiModulesBillingReceiptReceiptCreditToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingReceiptReceiptCreditToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingReceiptReceiptCredit &&
            (identical(other.creditReceiptId, creditReceiptId) ||
                const DeepCollectionEquality()
                    .equals(other.creditReceiptId, creditReceiptId)) &&
            (identical(other.creditId, creditId) ||
                const DeepCollectionEquality()
                    .equals(other.creditId, creditId)) &&
            (identical(other.amount, amount) ||
                const DeepCollectionEquality().equals(other.amount, amount)));
  }
}

extension $WebApiModulesBillingReceiptReceiptCreditExtension
    on WebApiModulesBillingReceiptReceiptCredit {
  WebApiModulesBillingReceiptReceiptCredit copyWith(
      {String? creditReceiptId, String? creditId, double? amount}) {
    return WebApiModulesBillingReceiptReceiptCredit(
        creditReceiptId: creditReceiptId ?? this.creditReceiptId,
        creditId: creditId ?? this.creditId,
        amount: amount ?? this.amount);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingReceiptReceiptInvoice {
  WebApiModulesBillingReceiptReceiptInvoice({
    this.invoiceReceiptId,
    this.invoiceId,
    this.amount,
  });

  factory WebApiModulesBillingReceiptReceiptInvoice.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingReceiptReceiptInvoiceFromJson(json);

  @JsonKey(name: 'InvoiceReceiptId')
  final String? invoiceReceiptId;
  @JsonKey(name: 'InvoiceId')
  final String? invoiceId;
  @JsonKey(name: 'Amount')
  final double? amount;
  static const fromJsonFactory =
      _$WebApiModulesBillingReceiptReceiptInvoiceFromJson;
  static const toJsonFactory =
      _$WebApiModulesBillingReceiptReceiptInvoiceToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingReceiptReceiptInvoiceToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingReceiptReceiptInvoice &&
            (identical(other.invoiceReceiptId, invoiceReceiptId) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceReceiptId, invoiceReceiptId)) &&
            (identical(other.invoiceId, invoiceId) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceId, invoiceId)) &&
            (identical(other.amount, amount) ||
                const DeepCollectionEquality().equals(other.amount, amount)));
  }
}

extension $WebApiModulesBillingReceiptReceiptInvoiceExtension
    on WebApiModulesBillingReceiptReceiptInvoice {
  WebApiModulesBillingReceiptReceiptInvoice copyWith(
      {String? invoiceReceiptId, String? invoiceId, double? amount}) {
    return WebApiModulesBillingReceiptReceiptInvoice(
        invoiceReceiptId: invoiceReceiptId ?? this.invoiceReceiptId,
        invoiceId: invoiceId ?? this.invoiceId,
        amount: amount ?? this.amount);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingReceiptRemainingDepositAmountsResponse {
  WebApiModulesBillingReceiptRemainingDepositAmountsResponse({
    this.depletingDeposits,
    this.depletingDepositsFormatted,
    this.creditMemos,
    this.creditMemosFormatted,
    this.overpayments,
    this.overpaymentsFormatted,
  });

  factory WebApiModulesBillingReceiptRemainingDepositAmountsResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingReceiptRemainingDepositAmountsResponseFromJson(
          json);

  @JsonKey(name: 'DepletingDeposits')
  final double? depletingDeposits;
  @JsonKey(name: 'DepletingDepositsFormatted')
  final String? depletingDepositsFormatted;
  @JsonKey(name: 'CreditMemos')
  final double? creditMemos;
  @JsonKey(name: 'CreditMemosFormatted')
  final String? creditMemosFormatted;
  @JsonKey(name: 'Overpayments')
  final double? overpayments;
  @JsonKey(name: 'OverpaymentsFormatted')
  final String? overpaymentsFormatted;
  static const fromJsonFactory =
      _$WebApiModulesBillingReceiptRemainingDepositAmountsResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesBillingReceiptRemainingDepositAmountsResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingReceiptRemainingDepositAmountsResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingReceiptRemainingDepositAmountsResponse &&
            (identical(other.depletingDeposits, depletingDeposits) ||
                const DeepCollectionEquality()
                    .equals(other.depletingDeposits, depletingDeposits)) &&
            (identical(other.depletingDepositsFormatted,
                    depletingDepositsFormatted) ||
                const DeepCollectionEquality().equals(
                    other.depletingDepositsFormatted,
                    depletingDepositsFormatted)) &&
            (identical(other.creditMemos, creditMemos) ||
                const DeepCollectionEquality()
                    .equals(other.creditMemos, creditMemos)) &&
            (identical(other.creditMemosFormatted, creditMemosFormatted) ||
                const DeepCollectionEquality().equals(
                    other.creditMemosFormatted, creditMemosFormatted)) &&
            (identical(other.overpayments, overpayments) ||
                const DeepCollectionEquality()
                    .equals(other.overpayments, overpayments)) &&
            (identical(other.overpaymentsFormatted, overpaymentsFormatted) ||
                const DeepCollectionEquality().equals(
                    other.overpaymentsFormatted, overpaymentsFormatted)));
  }
}

extension $WebApiModulesBillingReceiptRemainingDepositAmountsResponseExtension
    on WebApiModulesBillingReceiptRemainingDepositAmountsResponse {
  WebApiModulesBillingReceiptRemainingDepositAmountsResponse copyWith(
      {double? depletingDeposits,
      String? depletingDepositsFormatted,
      double? creditMemos,
      String? creditMemosFormatted,
      double? overpayments,
      String? overpaymentsFormatted}) {
    return WebApiModulesBillingReceiptRemainingDepositAmountsResponse(
        depletingDeposits: depletingDeposits ?? this.depletingDeposits,
        depletingDepositsFormatted:
            depletingDepositsFormatted ?? this.depletingDepositsFormatted,
        creditMemos: creditMemos ?? this.creditMemos,
        creditMemosFormatted: creditMemosFormatted ?? this.creditMemosFormatted,
        overpayments: overpayments ?? this.overpayments,
        overpaymentsFormatted:
            overpaymentsFormatted ?? this.overpaymentsFormatted);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedRequest {
  WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedRequest({
    this.vendorInvoiceId,
    this.pushChangesToPurchaseOrder,
  });

  factory WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedRequestFromJson(
          json);

  @JsonKey(name: 'VendorInvoiceId')
  final String? vendorInvoiceId;
  @JsonKey(name: 'PushChangesToPurchaseOrder')
  final bool? pushChangesToPurchaseOrder;
  static const fromJsonFactory =
      _$WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedRequest &&
            (identical(other.vendorInvoiceId, vendorInvoiceId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorInvoiceId, vendorInvoiceId)) &&
            (identical(other.pushChangesToPurchaseOrder,
                    pushChangesToPurchaseOrder) ||
                const DeepCollectionEquality().equals(
                    other.pushChangesToPurchaseOrder,
                    pushChangesToPurchaseOrder)));
  }
}

extension $WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedRequestExtension
    on WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedRequest {
  WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedRequest copyWith(
      {String? vendorInvoiceId, bool? pushChangesToPurchaseOrder}) {
    return WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedRequest(
        vendorInvoiceId: vendorInvoiceId ?? this.vendorInvoiceId,
        pushChangesToPurchaseOrder:
            pushChangesToPurchaseOrder ?? this.pushChangesToPurchaseOrder);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedResponse {
  WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedResponse({
    this.status,
    this.success,
    this.msg,
    this.promptToUpdatePurchaseOrder,
  });

  factory WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'PromptToUpdatePurchaseOrder')
  final bool? promptToUpdatePurchaseOrder;
  static const fromJsonFactory =
      _$WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.promptToUpdatePurchaseOrder,
                    promptToUpdatePurchaseOrder) ||
                const DeepCollectionEquality().equals(
                    other.promptToUpdatePurchaseOrder,
                    promptToUpdatePurchaseOrder)));
  }
}

extension $WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedResponseExtension
    on WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedResponse {
  WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedResponse copyWith(
      {int? status,
      bool? success,
      String? msg,
      bool? promptToUpdatePurchaseOrder}) {
    return WebApiModulesBillingVendorInvoiceToggleVendorInvoiceApprovedResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        promptToUpdatePurchaseOrder:
            promptToUpdatePurchaseOrder ?? this.promptToUpdatePurchaseOrder);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesBillingVendorInvoiceVendorInvoice {
  WebApiModulesBillingVendorInvoiceVendorInvoice({
    this.vendorInvoiceId,
    this.purchaseOrderId,
    this.purchaseOrderNumber,
    this.purchaseOrderDescription,
    this.requistionNumber,
    this.vendor,
    this.vendorNumber,
    this.vendorId,
    this.invoiceBatchId,
    this.inputDate,
    this.invoiceNumber,
    this.invoiceDate,
    this.invoiceDueDate,
    this.billingStartDate,
    this.billingEndDate,
    this.status,
    this.statusDate,
    this.departmentId,
    this.department,
    this.orderNumber,
    this.orderDescription,
    this.purchaseOrderDealId,
    this.purchaseOrderDealNumber,
    this.purchaseOrderDeal,
    this.purchaseOrderDealNumberDeal,
    this.purchaseOrderDate,
    this.purchaseOrderEstimatedStopDate,
    this.purchaseOrderEstimatedStartDate,
    this.purchaseOrderBillingCycleId,
    this.purchaseOrderBillingCycle,
    this.purchaseOrderPaymentTermsId,
    this.purchaseOrderPaymentTerms,
    this.approvedDate,
    this.locationId,
    this.location,
    this.warehouseId,
    this.warehouse,
    this.invoiceTotal,
    this.billToAddress1,
    this.billToAddress2,
    this.billToCity,
    this.billToState,
    this.billToZipCode,
    this.billToCountry,
    this.vendorPhone,
    this.vendorFax,
    this.invoiceClass,
    this.printNotes,
    this.paymentTermsId,
    this.paymentTerms,
    this.taxId,
    this.rentalTaxRate1,
    this.salesTaxRate1,
    this.laborTaxRate1,
    this.rentalTaxRate2,
    this.salesTaxRate2,
    this.laborTaxRate2,
    this.taxOptionId,
    this.taxOption,
    this.tax1Name,
    this.tax2Name,
    this.taxItemCode,
    this.notes,
    this.billedHiatus,
    this.invoiceType,
    this.agentId,
    this.projectManagerId,
    this.currencyId,
    this.currencyCode,
    this.currencySymbol,
    this.officeLocationDefaultCurrencyId,
    this.dealBilledExtended,
    this.credit,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesBillingVendorInvoiceVendorInvoice.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesBillingVendorInvoiceVendorInvoiceFromJson(json);

  @JsonKey(name: 'VendorInvoiceId')
  final String? vendorInvoiceId;
  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'PurchaseOrderNumber')
  final String? purchaseOrderNumber;
  @JsonKey(name: 'PurchaseOrderDescription')
  final String? purchaseOrderDescription;
  @JsonKey(name: 'RequistionNumber')
  final String? requistionNumber;
  @JsonKey(name: 'Vendor')
  final String? vendor;
  @JsonKey(name: 'VendorNumber')
  final String? vendorNumber;
  @JsonKey(name: 'VendorId')
  final String? vendorId;
  @JsonKey(name: 'InvoiceBatchId')
  final String? invoiceBatchId;
  @JsonKey(name: 'InputDate')
  final String? inputDate;
  @JsonKey(name: 'InvoiceNumber')
  final String? invoiceNumber;
  @JsonKey(name: 'InvoiceDate')
  final String? invoiceDate;
  @JsonKey(name: 'InvoiceDueDate')
  final String? invoiceDueDate;
  @JsonKey(name: 'BillingStartDate')
  final String? billingStartDate;
  @JsonKey(name: 'BillingEndDate')
  final String? billingEndDate;
  @JsonKey(name: 'Status')
  final String? status;
  @JsonKey(name: 'StatusDate')
  final String? statusDate;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'Department')
  final String? department;
  @JsonKey(name: 'OrderNumber')
  final String? orderNumber;
  @JsonKey(name: 'OrderDescription')
  final String? orderDescription;
  @JsonKey(name: 'PurchaseOrderDealId')
  final String? purchaseOrderDealId;
  @JsonKey(name: 'PurchaseOrderDealNumber')
  final String? purchaseOrderDealNumber;
  @JsonKey(name: 'PurchaseOrderDeal')
  final String? purchaseOrderDeal;
  @JsonKey(name: 'PurchaseOrderDealNumberDeal')
  final String? purchaseOrderDealNumberDeal;
  @JsonKey(name: 'PurchaseOrderDate')
  final String? purchaseOrderDate;
  @JsonKey(name: 'PurchaseOrderEstimatedStopDate')
  final String? purchaseOrderEstimatedStopDate;
  @JsonKey(name: 'PurchaseOrderEstimatedStartDate')
  final String? purchaseOrderEstimatedStartDate;
  @JsonKey(name: 'PurchaseOrderBillingCycleId')
  final String? purchaseOrderBillingCycleId;
  @JsonKey(name: 'PurchaseOrderBillingCycle')
  final String? purchaseOrderBillingCycle;
  @JsonKey(name: 'PurchaseOrderPaymentTermsId')
  final String? purchaseOrderPaymentTermsId;
  @JsonKey(name: 'PurchaseOrderPaymentTerms')
  final String? purchaseOrderPaymentTerms;
  @JsonKey(name: 'ApprovedDate')
  final String? approvedDate;
  @JsonKey(name: 'LocationId')
  final String? locationId;
  @JsonKey(name: 'Location')
  final String? location;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'InvoiceTotal')
  final double? invoiceTotal;
  @JsonKey(name: 'BillToAddress1')
  final String? billToAddress1;
  @JsonKey(name: 'BillToAddress2')
  final String? billToAddress2;
  @JsonKey(name: 'BillToCity')
  final String? billToCity;
  @JsonKey(name: 'BillToState')
  final String? billToState;
  @JsonKey(name: 'BillToZipCode')
  final String? billToZipCode;
  @JsonKey(name: 'BillToCountry')
  final String? billToCountry;
  @JsonKey(name: 'VendorPhone')
  final String? vendorPhone;
  @JsonKey(name: 'VendorFax')
  final String? vendorFax;
  @JsonKey(name: 'InvoiceClass')
  final bool? invoiceClass;
  @JsonKey(name: 'PrintNotes')
  final bool? printNotes;
  @JsonKey(name: 'PaymentTermsId')
  final String? paymentTermsId;
  @JsonKey(name: 'PaymentTerms')
  final String? paymentTerms;
  @JsonKey(name: 'TaxId')
  final String? taxId;
  @JsonKey(name: 'RentalTaxRate1')
  final double? rentalTaxRate1;
  @JsonKey(name: 'SalesTaxRate1')
  final double? salesTaxRate1;
  @JsonKey(name: 'LaborTaxRate1')
  final double? laborTaxRate1;
  @JsonKey(name: 'RentalTaxRate2')
  final double? rentalTaxRate2;
  @JsonKey(name: 'SalesTaxRate2')
  final double? salesTaxRate2;
  @JsonKey(name: 'LaborTaxRate2')
  final double? laborTaxRate2;
  @JsonKey(name: 'TaxOptionId')
  final String? taxOptionId;
  @JsonKey(name: 'TaxOption')
  final String? taxOption;
  @JsonKey(name: 'Tax1Name')
  final String? tax1Name;
  @JsonKey(name: 'Tax2Name')
  final String? tax2Name;
  @JsonKey(name: 'TaxItemCode')
  final String? taxItemCode;
  @JsonKey(name: 'Notes')
  final String? notes;
  @JsonKey(name: 'BilledHiatus')
  final bool? billedHiatus;
  @JsonKey(name: 'InvoiceType')
  final String? invoiceType;
  @JsonKey(name: 'AgentId')
  final String? agentId;
  @JsonKey(name: 'ProjectManagerId')
  final String? projectManagerId;
  @JsonKey(name: 'CurrencyId')
  final String? currencyId;
  @JsonKey(name: 'CurrencyCode')
  final String? currencyCode;
  @JsonKey(name: 'CurrencySymbol')
  final String? currencySymbol;
  @JsonKey(name: 'OfficeLocationDefaultCurrencyId')
  final String? officeLocationDefaultCurrencyId;
  @JsonKey(name: 'DealBilledExtended')
  final double? dealBilledExtended;
  @JsonKey(name: 'Credit')
  final double? credit;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesBillingVendorInvoiceVendorInvoiceFromJson;
  static const toJsonFactory =
      _$WebApiModulesBillingVendorInvoiceVendorInvoiceToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesBillingVendorInvoiceVendorInvoiceToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesBillingVendorInvoiceVendorInvoice &&
            (identical(other.vendorInvoiceId, vendorInvoiceId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorInvoiceId, vendorInvoiceId)) &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.purchaseOrderNumber, purchaseOrderNumber) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderNumber, purchaseOrderNumber)) &&
            (identical(other.purchaseOrderDescription, purchaseOrderDescription) ||
                const DeepCollectionEquality().equals(
                    other.purchaseOrderDescription,
                    purchaseOrderDescription)) &&
            (identical(other.requistionNumber, requistionNumber) ||
                const DeepCollectionEquality()
                    .equals(other.requistionNumber, requistionNumber)) &&
            (identical(other.vendor, vendor) ||
                const DeepCollectionEquality().equals(other.vendor, vendor)) &&
            (identical(other.vendorNumber, vendorNumber) ||
                const DeepCollectionEquality()
                    .equals(other.vendorNumber, vendorNumber)) &&
            (identical(other.vendorId, vendorId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorId, vendorId)) &&
            (identical(other.invoiceBatchId, invoiceBatchId) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceBatchId, invoiceBatchId)) &&
            (identical(other.inputDate, inputDate) ||
                const DeepCollectionEquality()
                    .equals(other.inputDate, inputDate)) &&
            (identical(other.invoiceNumber, invoiceNumber) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceNumber, invoiceNumber)) &&
            (identical(other.invoiceDate, invoiceDate) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceDate, invoiceDate)) &&
            (identical(other.invoiceDueDate, invoiceDueDate) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceDueDate, invoiceDueDate)) &&
            (identical(other.billingStartDate, billingStartDate) ||
                const DeepCollectionEquality()
                    .equals(other.billingStartDate, billingStartDate)) &&
            (identical(other.billingEndDate, billingEndDate) ||
                const DeepCollectionEquality()
                    .equals(other.billingEndDate, billingEndDate)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.statusDate, statusDate) ||
                const DeepCollectionEquality()
                    .equals(other.statusDate, statusDate)) &&
            (identical(other.departmentId, departmentId) ||
                const DeepCollectionEquality().equals(other.departmentId, departmentId)) &&
            (identical(other.department, department) || const DeepCollectionEquality().equals(other.department, department)) &&
            (identical(other.orderNumber, orderNumber) || const DeepCollectionEquality().equals(other.orderNumber, orderNumber)) &&
            (identical(other.orderDescription, orderDescription) || const DeepCollectionEquality().equals(other.orderDescription, orderDescription)) &&
            (identical(other.purchaseOrderDealId, purchaseOrderDealId) || const DeepCollectionEquality().equals(other.purchaseOrderDealId, purchaseOrderDealId)) &&
            (identical(other.purchaseOrderDealNumber, purchaseOrderDealNumber) || const DeepCollectionEquality().equals(other.purchaseOrderDealNumber, purchaseOrderDealNumber)) &&
            (identical(other.purchaseOrderDeal, purchaseOrderDeal) || const DeepCollectionEquality().equals(other.purchaseOrderDeal, purchaseOrderDeal)) &&
            (identical(other.purchaseOrderDealNumberDeal, purchaseOrderDealNumberDeal) || const DeepCollectionEquality().equals(other.purchaseOrderDealNumberDeal, purchaseOrderDealNumberDeal)) &&
            (identical(other.purchaseOrderDate, purchaseOrderDate) || const DeepCollectionEquality().equals(other.purchaseOrderDate, purchaseOrderDate)) &&
            (identical(other.purchaseOrderEstimatedStopDate, purchaseOrderEstimatedStopDate) || const DeepCollectionEquality().equals(other.purchaseOrderEstimatedStopDate, purchaseOrderEstimatedStopDate)) &&
            (identical(other.purchaseOrderEstimatedStartDate, purchaseOrderEstimatedStartDate) || const DeepCollectionEquality().equals(other.purchaseOrderEstimatedStartDate, purchaseOrderEstimatedStartDate)) &&
            (identical(other.purchaseOrderBillingCycleId, purchaseOrderBillingCycleId) || const DeepCollectionEquality().equals(other.purchaseOrderBillingCycleId, purchaseOrderBillingCycleId)) &&
            (identical(other.purchaseOrderBillingCycle, purchaseOrderBillingCycle) || const DeepCollectionEquality().equals(other.purchaseOrderBillingCycle, purchaseOrderBillingCycle)) &&
            (identical(other.purchaseOrderPaymentTermsId, purchaseOrderPaymentTermsId) || const DeepCollectionEquality().equals(other.purchaseOrderPaymentTermsId, purchaseOrderPaymentTermsId)) &&
            (identical(other.purchaseOrderPaymentTerms, purchaseOrderPaymentTerms) || const DeepCollectionEquality().equals(other.purchaseOrderPaymentTerms, purchaseOrderPaymentTerms)) &&
            (identical(other.approvedDate, approvedDate) || const DeepCollectionEquality().equals(other.approvedDate, approvedDate)) &&
            (identical(other.locationId, locationId) || const DeepCollectionEquality().equals(other.locationId, locationId)) &&
            (identical(other.location, location) || const DeepCollectionEquality().equals(other.location, location)) &&
            (identical(other.warehouseId, warehouseId) || const DeepCollectionEquality().equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouse, warehouse) || const DeepCollectionEquality().equals(other.warehouse, warehouse)) &&
            (identical(other.invoiceTotal, invoiceTotal) || const DeepCollectionEquality().equals(other.invoiceTotal, invoiceTotal)) &&
            (identical(other.billToAddress1, billToAddress1) || const DeepCollectionEquality().equals(other.billToAddress1, billToAddress1)) &&
            (identical(other.billToAddress2, billToAddress2) || const DeepCollectionEquality().equals(other.billToAddress2, billToAddress2)) &&
            (identical(other.billToCity, billToCity) || const DeepCollectionEquality().equals(other.billToCity, billToCity)) &&
            (identical(other.billToState, billToState) || const DeepCollectionEquality().equals(other.billToState, billToState)) &&
            (identical(other.billToZipCode, billToZipCode) || const DeepCollectionEquality().equals(other.billToZipCode, billToZipCode)) &&
            (identical(other.billToCountry, billToCountry) || const DeepCollectionEquality().equals(other.billToCountry, billToCountry)) &&
            (identical(other.vendorPhone, vendorPhone) || const DeepCollectionEquality().equals(other.vendorPhone, vendorPhone)) &&
            (identical(other.vendorFax, vendorFax) || const DeepCollectionEquality().equals(other.vendorFax, vendorFax)) &&
            (identical(other.invoiceClass, invoiceClass) || const DeepCollectionEquality().equals(other.invoiceClass, invoiceClass)) &&
            (identical(other.printNotes, printNotes) || const DeepCollectionEquality().equals(other.printNotes, printNotes)) &&
            (identical(other.paymentTermsId, paymentTermsId) || const DeepCollectionEquality().equals(other.paymentTermsId, paymentTermsId)) &&
            (identical(other.paymentTerms, paymentTerms) || const DeepCollectionEquality().equals(other.paymentTerms, paymentTerms)) &&
            (identical(other.taxId, taxId) || const DeepCollectionEquality().equals(other.taxId, taxId)) &&
            (identical(other.rentalTaxRate1, rentalTaxRate1) || const DeepCollectionEquality().equals(other.rentalTaxRate1, rentalTaxRate1)) &&
            (identical(other.salesTaxRate1, salesTaxRate1) || const DeepCollectionEquality().equals(other.salesTaxRate1, salesTaxRate1)) &&
            (identical(other.laborTaxRate1, laborTaxRate1) || const DeepCollectionEquality().equals(other.laborTaxRate1, laborTaxRate1)) &&
            (identical(other.rentalTaxRate2, rentalTaxRate2) || const DeepCollectionEquality().equals(other.rentalTaxRate2, rentalTaxRate2)) &&
            (identical(other.salesTaxRate2, salesTaxRate2) || const DeepCollectionEquality().equals(other.salesTaxRate2, salesTaxRate2)) &&
            (identical(other.laborTaxRate2, laborTaxRate2) || const DeepCollectionEquality().equals(other.laborTaxRate2, laborTaxRate2)) &&
            (identical(other.taxOptionId, taxOptionId) || const DeepCollectionEquality().equals(other.taxOptionId, taxOptionId)) &&
            (identical(other.taxOption, taxOption) || const DeepCollectionEquality().equals(other.taxOption, taxOption)) &&
            (identical(other.tax1Name, tax1Name) || const DeepCollectionEquality().equals(other.tax1Name, tax1Name)) &&
            (identical(other.tax2Name, tax2Name) || const DeepCollectionEquality().equals(other.tax2Name, tax2Name)) &&
            (identical(other.taxItemCode, taxItemCode) || const DeepCollectionEquality().equals(other.taxItemCode, taxItemCode)) &&
            (identical(other.notes, notes) || const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.billedHiatus, billedHiatus) || const DeepCollectionEquality().equals(other.billedHiatus, billedHiatus)) &&
            (identical(other.invoiceType, invoiceType) || const DeepCollectionEquality().equals(other.invoiceType, invoiceType)) &&
            (identical(other.agentId, agentId) || const DeepCollectionEquality().equals(other.agentId, agentId)) &&
            (identical(other.projectManagerId, projectManagerId) || const DeepCollectionEquality().equals(other.projectManagerId, projectManagerId)) &&
            (identical(other.currencyId, currencyId) || const DeepCollectionEquality().equals(other.currencyId, currencyId)) &&
            (identical(other.currencyCode, currencyCode) || const DeepCollectionEquality().equals(other.currencyCode, currencyCode)) &&
            (identical(other.currencySymbol, currencySymbol) || const DeepCollectionEquality().equals(other.currencySymbol, currencySymbol)) &&
            (identical(other.officeLocationDefaultCurrencyId, officeLocationDefaultCurrencyId) || const DeepCollectionEquality().equals(other.officeLocationDefaultCurrencyId, officeLocationDefaultCurrencyId)) &&
            (identical(other.dealBilledExtended, dealBilledExtended) || const DeepCollectionEquality().equals(other.dealBilledExtended, dealBilledExtended)) &&
            (identical(other.credit, credit) || const DeepCollectionEquality().equals(other.credit, credit)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesBillingVendorInvoiceVendorInvoiceExtension
    on WebApiModulesBillingVendorInvoiceVendorInvoice {
  WebApiModulesBillingVendorInvoiceVendorInvoice copyWith(
      {String? vendorInvoiceId,
      String? purchaseOrderId,
      String? purchaseOrderNumber,
      String? purchaseOrderDescription,
      String? requistionNumber,
      String? vendor,
      String? vendorNumber,
      String? vendorId,
      String? invoiceBatchId,
      String? inputDate,
      String? invoiceNumber,
      String? invoiceDate,
      String? invoiceDueDate,
      String? billingStartDate,
      String? billingEndDate,
      String? status,
      String? statusDate,
      String? departmentId,
      String? department,
      String? orderNumber,
      String? orderDescription,
      String? purchaseOrderDealId,
      String? purchaseOrderDealNumber,
      String? purchaseOrderDeal,
      String? purchaseOrderDealNumberDeal,
      String? purchaseOrderDate,
      String? purchaseOrderEstimatedStopDate,
      String? purchaseOrderEstimatedStartDate,
      String? purchaseOrderBillingCycleId,
      String? purchaseOrderBillingCycle,
      String? purchaseOrderPaymentTermsId,
      String? purchaseOrderPaymentTerms,
      String? approvedDate,
      String? locationId,
      String? location,
      String? warehouseId,
      String? warehouse,
      double? invoiceTotal,
      String? billToAddress1,
      String? billToAddress2,
      String? billToCity,
      String? billToState,
      String? billToZipCode,
      String? billToCountry,
      String? vendorPhone,
      String? vendorFax,
      bool? invoiceClass,
      bool? printNotes,
      String? paymentTermsId,
      String? paymentTerms,
      String? taxId,
      double? rentalTaxRate1,
      double? salesTaxRate1,
      double? laborTaxRate1,
      double? rentalTaxRate2,
      double? salesTaxRate2,
      double? laborTaxRate2,
      String? taxOptionId,
      String? taxOption,
      String? tax1Name,
      String? tax2Name,
      String? taxItemCode,
      String? notes,
      bool? billedHiatus,
      String? invoiceType,
      String? agentId,
      String? projectManagerId,
      String? currencyId,
      String? currencyCode,
      String? currencySymbol,
      String? officeLocationDefaultCurrencyId,
      double? dealBilledExtended,
      double? credit,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesBillingVendorInvoiceVendorInvoice(
        vendorInvoiceId: vendorInvoiceId ?? this.vendorInvoiceId,
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        purchaseOrderNumber: purchaseOrderNumber ?? this.purchaseOrderNumber,
        purchaseOrderDescription:
            purchaseOrderDescription ?? this.purchaseOrderDescription,
        requistionNumber: requistionNumber ?? this.requistionNumber,
        vendor: vendor ?? this.vendor,
        vendorNumber: vendorNumber ?? this.vendorNumber,
        vendorId: vendorId ?? this.vendorId,
        invoiceBatchId: invoiceBatchId ?? this.invoiceBatchId,
        inputDate: inputDate ?? this.inputDate,
        invoiceNumber: invoiceNumber ?? this.invoiceNumber,
        invoiceDate: invoiceDate ?? this.invoiceDate,
        invoiceDueDate: invoiceDueDate ?? this.invoiceDueDate,
        billingStartDate: billingStartDate ?? this.billingStartDate,
        billingEndDate: billingEndDate ?? this.billingEndDate,
        status: status ?? this.status,
        statusDate: statusDate ?? this.statusDate,
        departmentId: departmentId ?? this.departmentId,
        department: department ?? this.department,
        orderNumber: orderNumber ?? this.orderNumber,
        orderDescription: orderDescription ?? this.orderDescription,
        purchaseOrderDealId: purchaseOrderDealId ?? this.purchaseOrderDealId,
        purchaseOrderDealNumber:
            purchaseOrderDealNumber ?? this.purchaseOrderDealNumber,
        purchaseOrderDeal: purchaseOrderDeal ?? this.purchaseOrderDeal,
        purchaseOrderDealNumberDeal:
            purchaseOrderDealNumberDeal ?? this.purchaseOrderDealNumberDeal,
        purchaseOrderDate: purchaseOrderDate ?? this.purchaseOrderDate,
        purchaseOrderEstimatedStopDate: purchaseOrderEstimatedStopDate ??
            this.purchaseOrderEstimatedStopDate,
        purchaseOrderEstimatedStartDate: purchaseOrderEstimatedStartDate ??
            this.purchaseOrderEstimatedStartDate,
        purchaseOrderBillingCycleId:
            purchaseOrderBillingCycleId ?? this.purchaseOrderBillingCycleId,
        purchaseOrderBillingCycle:
            purchaseOrderBillingCycle ?? this.purchaseOrderBillingCycle,
        purchaseOrderPaymentTermsId:
            purchaseOrderPaymentTermsId ?? this.purchaseOrderPaymentTermsId,
        purchaseOrderPaymentTerms:
            purchaseOrderPaymentTerms ?? this.purchaseOrderPaymentTerms,
        approvedDate: approvedDate ?? this.approvedDate,
        locationId: locationId ?? this.locationId,
        location: location ?? this.location,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouse: warehouse ?? this.warehouse,
        invoiceTotal: invoiceTotal ?? this.invoiceTotal,
        billToAddress1: billToAddress1 ?? this.billToAddress1,
        billToAddress2: billToAddress2 ?? this.billToAddress2,
        billToCity: billToCity ?? this.billToCity,
        billToState: billToState ?? this.billToState,
        billToZipCode: billToZipCode ?? this.billToZipCode,
        billToCountry: billToCountry ?? this.billToCountry,
        vendorPhone: vendorPhone ?? this.vendorPhone,
        vendorFax: vendorFax ?? this.vendorFax,
        invoiceClass: invoiceClass ?? this.invoiceClass,
        printNotes: printNotes ?? this.printNotes,
        paymentTermsId: paymentTermsId ?? this.paymentTermsId,
        paymentTerms: paymentTerms ?? this.paymentTerms,
        taxId: taxId ?? this.taxId,
        rentalTaxRate1: rentalTaxRate1 ?? this.rentalTaxRate1,
        salesTaxRate1: salesTaxRate1 ?? this.salesTaxRate1,
        laborTaxRate1: laborTaxRate1 ?? this.laborTaxRate1,
        rentalTaxRate2: rentalTaxRate2 ?? this.rentalTaxRate2,
        salesTaxRate2: salesTaxRate2 ?? this.salesTaxRate2,
        laborTaxRate2: laborTaxRate2 ?? this.laborTaxRate2,
        taxOptionId: taxOptionId ?? this.taxOptionId,
        taxOption: taxOption ?? this.taxOption,
        tax1Name: tax1Name ?? this.tax1Name,
        tax2Name: tax2Name ?? this.tax2Name,
        taxItemCode: taxItemCode ?? this.taxItemCode,
        notes: notes ?? this.notes,
        billedHiatus: billedHiatus ?? this.billedHiatus,
        invoiceType: invoiceType ?? this.invoiceType,
        agentId: agentId ?? this.agentId,
        projectManagerId: projectManagerId ?? this.projectManagerId,
        currencyId: currencyId ?? this.currencyId,
        currencyCode: currencyCode ?? this.currencyCode,
        currencySymbol: currencySymbol ?? this.currencySymbol,
        officeLocationDefaultCurrencyId: officeLocationDefaultCurrencyId ??
            this.officeLocationDefaultCurrencyId,
        dealBilledExtended: dealBilledExtended ?? this.dealBilledExtended,
        credit: credit ?? this.credit,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesContainersContainerContainer {
  WebApiModulesContainersContainerContainer({
    this.containerId,
    this.description,
    this.rental,
    this.iCode,
    this.scannableInventoryId,
    this.scannableICode,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesContainersContainerContainer.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesContainersContainerContainerFromJson(json);

  @JsonKey(name: 'ContainerId')
  final String? containerId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'Rental')
  final bool? rental;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'ScannableInventoryId')
  final String? scannableInventoryId;
  @JsonKey(name: 'ScannableICode')
  final String? scannableICode;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesContainersContainerContainerFromJson;
  static const toJsonFactory =
      _$WebApiModulesContainersContainerContainerToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesContainersContainerContainerToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesContainersContainerContainer &&
            (identical(other.containerId, containerId) ||
                const DeepCollectionEquality()
                    .equals(other.containerId, containerId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.rental, rental) ||
                const DeepCollectionEquality().equals(other.rental, rental)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.scannableInventoryId, scannableInventoryId) ||
                const DeepCollectionEquality().equals(
                    other.scannableInventoryId, scannableInventoryId)) &&
            (identical(other.scannableICode, scannableICode) ||
                const DeepCollectionEquality()
                    .equals(other.scannableICode, scannableICode)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesContainersContainerContainerExtension
    on WebApiModulesContainersContainerContainer {
  WebApiModulesContainersContainerContainer copyWith(
      {String? containerId,
      String? description,
      bool? rental,
      String? iCode,
      String? scannableInventoryId,
      String? scannableICode,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesContainersContainerContainer(
        containerId: containerId ?? this.containerId,
        description: description ?? this.description,
        rental: rental ?? this.rental,
        iCode: iCode ?? this.iCode,
        scannableInventoryId: scannableInventoryId ?? this.scannableInventoryId,
        scannableICode: scannableICode ?? this.scannableICode,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsAddressAddress {
  WebApiModulesHomeControlsAddressAddress({
    this.addressId,
    this.name,
    this.attention,
    this.attention2,
    this.address1,
    this.address2,
    this.city,
    this.state,
    this.countryId,
    this.country,
    this.zipCode,
    this.phone,
    this.fax,
    this.phoneTollFree,
    this.phoneOther,
    this.uniqueId1,
    this.uniqueId2,
    this.uniqueId3,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsAddressAddress.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsAddressAddressFromJson(json);

  @JsonKey(name: 'AddressId')
  final String? addressId;
  @JsonKey(name: 'Name')
  final String? name;
  @JsonKey(name: 'Attention')
  final String? attention;
  @JsonKey(name: 'Attention2')
  final String? attention2;
  @JsonKey(name: 'Address1')
  final String? address1;
  @JsonKey(name: 'Address2')
  final String? address2;
  @JsonKey(name: 'City')
  final String? city;
  @JsonKey(name: 'State')
  final String? state;
  @JsonKey(name: 'CountryId')
  final String? countryId;
  @JsonKey(name: 'Country')
  final String? country;
  @JsonKey(name: 'ZipCode')
  final String? zipCode;
  @JsonKey(name: 'Phone')
  final String? phone;
  @JsonKey(name: 'Fax')
  final String? fax;
  @JsonKey(name: 'PhoneTollFree')
  final String? phoneTollFree;
  @JsonKey(name: 'PhoneOther')
  final String? phoneOther;
  @JsonKey(name: 'UniqueId1')
  final String? uniqueId1;
  @JsonKey(name: 'UniqueId2')
  final String? uniqueId2;
  @JsonKey(name: 'UniqueId3')
  final String? uniqueId3;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsAddressAddressFromJson;
  static const toJsonFactory = _$WebApiModulesHomeControlsAddressAddressToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsAddressAddressToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsAddressAddress &&
            (identical(other.addressId, addressId) ||
                const DeepCollectionEquality()
                    .equals(other.addressId, addressId)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.attention, attention) ||
                const DeepCollectionEquality()
                    .equals(other.attention, attention)) &&
            (identical(other.attention2, attention2) ||
                const DeepCollectionEquality()
                    .equals(other.attention2, attention2)) &&
            (identical(other.address1, address1) ||
                const DeepCollectionEquality()
                    .equals(other.address1, address1)) &&
            (identical(other.address2, address2) ||
                const DeepCollectionEquality()
                    .equals(other.address2, address2)) &&
            (identical(other.city, city) ||
                const DeepCollectionEquality().equals(other.city, city)) &&
            (identical(other.state, state) ||
                const DeepCollectionEquality().equals(other.state, state)) &&
            (identical(other.countryId, countryId) ||
                const DeepCollectionEquality()
                    .equals(other.countryId, countryId)) &&
            (identical(other.country, country) ||
                const DeepCollectionEquality()
                    .equals(other.country, country)) &&
            (identical(other.zipCode, zipCode) ||
                const DeepCollectionEquality()
                    .equals(other.zipCode, zipCode)) &&
            (identical(other.phone, phone) ||
                const DeepCollectionEquality().equals(other.phone, phone)) &&
            (identical(other.fax, fax) ||
                const DeepCollectionEquality().equals(other.fax, fax)) &&
            (identical(other.phoneTollFree, phoneTollFree) ||
                const DeepCollectionEquality()
                    .equals(other.phoneTollFree, phoneTollFree)) &&
            (identical(other.phoneOther, phoneOther) ||
                const DeepCollectionEquality()
                    .equals(other.phoneOther, phoneOther)) &&
            (identical(other.uniqueId1, uniqueId1) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1, uniqueId1)) &&
            (identical(other.uniqueId2, uniqueId2) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId2, uniqueId2)) &&
            (identical(other.uniqueId3, uniqueId3) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId3, uniqueId3)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsAddressAddressExtension
    on WebApiModulesHomeControlsAddressAddress {
  WebApiModulesHomeControlsAddressAddress copyWith(
      {String? addressId,
      String? name,
      String? attention,
      String? attention2,
      String? address1,
      String? address2,
      String? city,
      String? state,
      String? countryId,
      String? country,
      String? zipCode,
      String? phone,
      String? fax,
      String? phoneTollFree,
      String? phoneOther,
      String? uniqueId1,
      String? uniqueId2,
      String? uniqueId3,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsAddressAddress(
        addressId: addressId ?? this.addressId,
        name: name ?? this.name,
        attention: attention ?? this.attention,
        attention2: attention2 ?? this.attention2,
        address1: address1 ?? this.address1,
        address2: address2 ?? this.address2,
        city: city ?? this.city,
        state: state ?? this.state,
        countryId: countryId ?? this.countryId,
        country: country ?? this.country,
        zipCode: zipCode ?? this.zipCode,
        phone: phone ?? this.phone,
        fax: fax ?? this.fax,
        phoneTollFree: phoneTollFree ?? this.phoneTollFree,
        phoneOther: phoneOther ?? this.phoneOther,
        uniqueId1: uniqueId1 ?? this.uniqueId1,
        uniqueId2: uniqueId2 ?? this.uniqueId2,
        uniqueId3: uniqueId3 ?? this.uniqueId3,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsAlternativeDescriptionAlternativeDescription {
  WebApiModulesHomeControlsAlternativeDescriptionAlternativeDescription({
    this.alternativeDescriptionId,
    this.internalChar,
    this.inventoryId,
    this.iCode,
    this.description,
    this.aka,
    this.allowedOnInvoice,
    this.isPrimary,
    this.inactive,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsAlternativeDescriptionAlternativeDescription.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsAlternativeDescriptionAlternativeDescriptionFromJson(
          json);

  @JsonKey(name: 'AlternativeDescriptionId')
  final int? alternativeDescriptionId;
  @JsonKey(name: 'InternalChar')
  final bool? internalChar;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AKA')
  final String? aka;
  @JsonKey(name: 'AllowedOnInvoice')
  final bool? allowedOnInvoice;
  @JsonKey(name: 'IsPrimary')
  final bool? isPrimary;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsAlternativeDescriptionAlternativeDescriptionFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsAlternativeDescriptionAlternativeDescriptionToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsAlternativeDescriptionAlternativeDescriptionToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsAlternativeDescriptionAlternativeDescription &&
            (identical(
                    other.alternativeDescriptionId, alternativeDescriptionId) ||
                const DeepCollectionEquality().equals(
                    other.alternativeDescriptionId,
                    alternativeDescriptionId)) &&
            (identical(other.internalChar, internalChar) ||
                const DeepCollectionEquality()
                    .equals(other.internalChar, internalChar)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.aka, aka) ||
                const DeepCollectionEquality().equals(other.aka, aka)) &&
            (identical(other.allowedOnInvoice, allowedOnInvoice) ||
                const DeepCollectionEquality()
                    .equals(other.allowedOnInvoice, allowedOnInvoice)) &&
            (identical(other.isPrimary, isPrimary) ||
                const DeepCollectionEquality()
                    .equals(other.isPrimary, isPrimary)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsAlternativeDescriptionAlternativeDescriptionExtension
    on WebApiModulesHomeControlsAlternativeDescriptionAlternativeDescription {
  WebApiModulesHomeControlsAlternativeDescriptionAlternativeDescription
      copyWith(
          {int? alternativeDescriptionId,
          bool? internalChar,
          String? inventoryId,
          String? iCode,
          String? description,
          String? aka,
          bool? allowedOnInvoice,
          bool? isPrimary,
          bool? inactive,
          String? recordTitle,
          List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
          List<FwStandardDataFwCustomValue>? custom,
          List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsAlternativeDescriptionAlternativeDescription(
        alternativeDescriptionId:
            alternativeDescriptionId ?? this.alternativeDescriptionId,
        internalChar: internalChar ?? this.internalChar,
        inventoryId: inventoryId ?? this.inventoryId,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        aka: aka ?? this.aka,
        allowedOnInvoice: allowedOnInvoice ?? this.allowedOnInvoice,
        isPrimary: isPrimary ?? this.isPrimary,
        inactive: inactive ?? this.inactive,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsCompanyCompany {
  WebApiModulesHomeControlsCompanyCompany({
    this.companyId,
    this.companyNumber,
    this.company,
    this.companyType,
    this.companyTypeColor,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsCompanyCompany.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsCompanyCompanyFromJson(json);

  @JsonKey(name: 'CompanyId')
  final String? companyId;
  @JsonKey(name: 'CompanyNumber')
  final String? companyNumber;
  @JsonKey(name: 'Company')
  final String? company;
  @JsonKey(name: 'CompanyType')
  final String? companyType;
  @JsonKey(name: 'CompanyTypeColor')
  final String? companyTypeColor;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsCompanyCompanyFromJson;
  static const toJsonFactory = _$WebApiModulesHomeControlsCompanyCompanyToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsCompanyCompanyToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsCompanyCompany &&
            (identical(other.companyId, companyId) ||
                const DeepCollectionEquality()
                    .equals(other.companyId, companyId)) &&
            (identical(other.companyNumber, companyNumber) ||
                const DeepCollectionEquality()
                    .equals(other.companyNumber, companyNumber)) &&
            (identical(other.company, company) ||
                const DeepCollectionEquality()
                    .equals(other.company, company)) &&
            (identical(other.companyType, companyType) ||
                const DeepCollectionEquality()
                    .equals(other.companyType, companyType)) &&
            (identical(other.companyTypeColor, companyTypeColor) ||
                const DeepCollectionEquality()
                    .equals(other.companyTypeColor, companyTypeColor)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsCompanyCompanyExtension
    on WebApiModulesHomeControlsCompanyCompany {
  WebApiModulesHomeControlsCompanyCompany copyWith(
      {String? companyId,
      String? companyNumber,
      String? company,
      String? companyType,
      String? companyTypeColor,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsCompanyCompany(
        companyId: companyId ?? this.companyId,
        companyNumber: companyNumber ?? this.companyNumber,
        company: company ?? this.company,
        companyType: companyType ?? this.companyType,
        companyTypeColor: companyTypeColor ?? this.companyTypeColor,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsCompanyContactCompanyContact {
  WebApiModulesHomeControlsCompanyContactCompanyContact({
    this.companyContactId,
    this.companyId,
    this.company,
    this.companyType,
    this.companyTypeColor,
    this.contactId,
    this.salutation,
    this.nameFirstMiddleLast,
    this.person,
    this.lastName,
    this.firstName,
    this.middleInitial,
    this.jobTitle,
    this.contactTitleId,
    this.contactTitle,
    this.isPrimary,
    this.activeDate,
    this.inactiveDate,
    this.authorized,
    this.orderNotify,
    this.officePhone,
    this.officeExtension,
    this.fax,
    this.faxExtension,
    this.email,
    this.directPhone,
    this.directExtension,
    this.pager,
    this.pagerPin,
    this.printable,
    this.mobilePhone,
    this.inactive,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsCompanyContactCompanyContact.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsCompanyContactCompanyContactFromJson(json);

  @JsonKey(name: 'CompanyContactId')
  final String? companyContactId;
  @JsonKey(name: 'CompanyId')
  final String? companyId;
  @JsonKey(name: 'Company')
  final String? company;
  @JsonKey(name: 'CompanyType')
  final String? companyType;
  @JsonKey(name: 'CompanyTypeColor')
  final String? companyTypeColor;
  @JsonKey(name: 'ContactId')
  final String? contactId;
  @JsonKey(name: 'Salutation')
  final String? salutation;
  @JsonKey(name: 'NameFirstMiddleLast')
  final String? nameFirstMiddleLast;
  @JsonKey(name: 'Person')
  final String? person;
  @JsonKey(name: 'LastName')
  final String? lastName;
  @JsonKey(name: 'FirstName')
  final String? firstName;
  @JsonKey(name: 'MiddleInitial')
  final String? middleInitial;
  @JsonKey(name: 'JobTitle')
  final String? jobTitle;
  @JsonKey(name: 'ContactTitleId')
  final String? contactTitleId;
  @JsonKey(name: 'ContactTitle')
  final String? contactTitle;
  @JsonKey(name: 'IsPrimary')
  final bool? isPrimary;
  @JsonKey(name: 'ActiveDate')
  final String? activeDate;
  @JsonKey(name: 'InactiveDate')
  final String? inactiveDate;
  @JsonKey(name: 'Authorized')
  final bool? authorized;
  @JsonKey(name: 'OrderNotify')
  final bool? orderNotify;
  @JsonKey(name: 'OfficePhone')
  final String? officePhone;
  @JsonKey(name: 'OfficeExtension')
  final String? officeExtension;
  @JsonKey(name: 'Fax')
  final String? fax;
  @JsonKey(name: 'FaxExtension')
  final String? faxExtension;
  @JsonKey(name: 'Email')
  final String? email;
  @JsonKey(name: 'DirectPhone')
  final String? directPhone;
  @JsonKey(name: 'DirectExtension')
  final String? directExtension;
  @JsonKey(name: 'Pager')
  final String? pager;
  @JsonKey(name: 'PagerPin')
  final String? pagerPin;
  @JsonKey(name: 'Printable')
  final bool? printable;
  @JsonKey(name: 'MobilePhone')
  final String? mobilePhone;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsCompanyContactCompanyContactFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsCompanyContactCompanyContactToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsCompanyContactCompanyContactToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsCompanyContactCompanyContact &&
            (identical(other.companyContactId, companyContactId) ||
                const DeepCollectionEquality()
                    .equals(other.companyContactId, companyContactId)) &&
            (identical(other.companyId, companyId) ||
                const DeepCollectionEquality()
                    .equals(other.companyId, companyId)) &&
            (identical(other.company, company) ||
                const DeepCollectionEquality()
                    .equals(other.company, company)) &&
            (identical(other.companyType, companyType) ||
                const DeepCollectionEquality()
                    .equals(other.companyType, companyType)) &&
            (identical(other.companyTypeColor, companyTypeColor) ||
                const DeepCollectionEquality()
                    .equals(other.companyTypeColor, companyTypeColor)) &&
            (identical(other.contactId, contactId) ||
                const DeepCollectionEquality()
                    .equals(other.contactId, contactId)) &&
            (identical(other.salutation, salutation) ||
                const DeepCollectionEquality()
                    .equals(other.salutation, salutation)) &&
            (identical(other.nameFirstMiddleLast, nameFirstMiddleLast) ||
                const DeepCollectionEquality()
                    .equals(other.nameFirstMiddleLast, nameFirstMiddleLast)) &&
            (identical(other.person, person) ||
                const DeepCollectionEquality().equals(other.person, person)) &&
            (identical(other.lastName, lastName) ||
                const DeepCollectionEquality()
                    .equals(other.lastName, lastName)) &&
            (identical(other.firstName, firstName) ||
                const DeepCollectionEquality()
                    .equals(other.firstName, firstName)) &&
            (identical(other.middleInitial, middleInitial) ||
                const DeepCollectionEquality()
                    .equals(other.middleInitial, middleInitial)) &&
            (identical(other.jobTitle, jobTitle) ||
                const DeepCollectionEquality()
                    .equals(other.jobTitle, jobTitle)) &&
            (identical(other.contactTitleId, contactTitleId) ||
                const DeepCollectionEquality()
                    .equals(other.contactTitleId, contactTitleId)) &&
            (identical(other.contactTitle, contactTitle) ||
                const DeepCollectionEquality()
                    .equals(other.contactTitle, contactTitle)) &&
            (identical(other.isPrimary, isPrimary) ||
                const DeepCollectionEquality()
                    .equals(other.isPrimary, isPrimary)) &&
            (identical(other.activeDate, activeDate) ||
                const DeepCollectionEquality()
                    .equals(other.activeDate, activeDate)) &&
            (identical(other.inactiveDate, inactiveDate) ||
                const DeepCollectionEquality()
                    .equals(other.inactiveDate, inactiveDate)) &&
            (identical(other.authorized, authorized) ||
                const DeepCollectionEquality()
                    .equals(other.authorized, authorized)) &&
            (identical(other.orderNotify, orderNotify) ||
                const DeepCollectionEquality()
                    .equals(other.orderNotify, orderNotify)) &&
            (identical(other.officePhone, officePhone) ||
                const DeepCollectionEquality()
                    .equals(other.officePhone, officePhone)) &&
            (identical(other.officeExtension, officeExtension) ||
                const DeepCollectionEquality()
                    .equals(other.officeExtension, officeExtension)) &&
            (identical(other.fax, fax) || const DeepCollectionEquality().equals(other.fax, fax)) &&
            (identical(other.faxExtension, faxExtension) || const DeepCollectionEquality().equals(other.faxExtension, faxExtension)) &&
            (identical(other.email, email) || const DeepCollectionEquality().equals(other.email, email)) &&
            (identical(other.directPhone, directPhone) || const DeepCollectionEquality().equals(other.directPhone, directPhone)) &&
            (identical(other.directExtension, directExtension) || const DeepCollectionEquality().equals(other.directExtension, directExtension)) &&
            (identical(other.pager, pager) || const DeepCollectionEquality().equals(other.pager, pager)) &&
            (identical(other.pagerPin, pagerPin) || const DeepCollectionEquality().equals(other.pagerPin, pagerPin)) &&
            (identical(other.printable, printable) || const DeepCollectionEquality().equals(other.printable, printable)) &&
            (identical(other.mobilePhone, mobilePhone) || const DeepCollectionEquality().equals(other.mobilePhone, mobilePhone)) &&
            (identical(other.inactive, inactive) || const DeepCollectionEquality().equals(other.inactive, inactive)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsCompanyContactCompanyContactExtension
    on WebApiModulesHomeControlsCompanyContactCompanyContact {
  WebApiModulesHomeControlsCompanyContactCompanyContact copyWith(
      {String? companyContactId,
      String? companyId,
      String? company,
      String? companyType,
      String? companyTypeColor,
      String? contactId,
      String? salutation,
      String? nameFirstMiddleLast,
      String? person,
      String? lastName,
      String? firstName,
      String? middleInitial,
      String? jobTitle,
      String? contactTitleId,
      String? contactTitle,
      bool? isPrimary,
      String? activeDate,
      String? inactiveDate,
      bool? authorized,
      bool? orderNotify,
      String? officePhone,
      String? officeExtension,
      String? fax,
      String? faxExtension,
      String? email,
      String? directPhone,
      String? directExtension,
      String? pager,
      String? pagerPin,
      bool? printable,
      String? mobilePhone,
      bool? inactive,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsCompanyContactCompanyContact(
        companyContactId: companyContactId ?? this.companyContactId,
        companyId: companyId ?? this.companyId,
        company: company ?? this.company,
        companyType: companyType ?? this.companyType,
        companyTypeColor: companyTypeColor ?? this.companyTypeColor,
        contactId: contactId ?? this.contactId,
        salutation: salutation ?? this.salutation,
        nameFirstMiddleLast: nameFirstMiddleLast ?? this.nameFirstMiddleLast,
        person: person ?? this.person,
        lastName: lastName ?? this.lastName,
        firstName: firstName ?? this.firstName,
        middleInitial: middleInitial ?? this.middleInitial,
        jobTitle: jobTitle ?? this.jobTitle,
        contactTitleId: contactTitleId ?? this.contactTitleId,
        contactTitle: contactTitle ?? this.contactTitle,
        isPrimary: isPrimary ?? this.isPrimary,
        activeDate: activeDate ?? this.activeDate,
        inactiveDate: inactiveDate ?? this.inactiveDate,
        authorized: authorized ?? this.authorized,
        orderNotify: orderNotify ?? this.orderNotify,
        officePhone: officePhone ?? this.officePhone,
        officeExtension: officeExtension ?? this.officeExtension,
        fax: fax ?? this.fax,
        faxExtension: faxExtension ?? this.faxExtension,
        email: email ?? this.email,
        directPhone: directPhone ?? this.directPhone,
        directExtension: directExtension ?? this.directExtension,
        pager: pager ?? this.pager,
        pagerPin: pagerPin ?? this.pagerPin,
        printable: printable ?? this.printable,
        mobilePhone: mobilePhone ?? this.mobilePhone,
        inactive: inactive ?? this.inactive,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOption {
  WebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOption({
    this.id,
    this.internalChar,
    this.companyId,
    this.locationId,
    this.location,
    this.taxOptionId,
    this.taxOption,
    this.taxCountry,
    this.taxRule,
    this.rentalTaxRate1,
    this.rentalTaxRate2,
    this.rentalExempt,
    this.rentalTaxDisplay,
    this.salesTaxRate1,
    this.salesTaxRate2,
    this.salesExempt,
    this.salesTaxDisplay,
    this.laborTaxRate1,
    this.laborTaxRate2,
    this.laborExempt,
    this.laborTaxDisplay,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOption.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOptionFromJson(json);

  @JsonKey(name: 'Id')
  final int? id;
  @JsonKey(name: 'InternalChar')
  final String? internalChar;
  @JsonKey(name: 'CompanyId')
  final String? companyId;
  @JsonKey(name: 'LocationId')
  final String? locationId;
  @JsonKey(name: 'Location')
  final String? location;
  @JsonKey(name: 'TaxOptionId')
  final String? taxOptionId;
  @JsonKey(name: 'TaxOption')
  final String? taxOption;
  @JsonKey(name: 'TaxCountry')
  final String? taxCountry;
  @JsonKey(name: 'TaxRule')
  final String? taxRule;
  @JsonKey(name: 'RentalTaxRate1')
  final double? rentalTaxRate1;
  @JsonKey(name: 'RentalTaxRate2')
  final double? rentalTaxRate2;
  @JsonKey(name: 'RentalExempt')
  final bool? rentalExempt;
  @JsonKey(name: 'RentalTaxDisplay')
  final String? rentalTaxDisplay;
  @JsonKey(name: 'SalesTaxRate1')
  final double? salesTaxRate1;
  @JsonKey(name: 'SalesTaxRate2')
  final double? salesTaxRate2;
  @JsonKey(name: 'SalesExempt')
  final bool? salesExempt;
  @JsonKey(name: 'SalesTaxDisplay')
  final String? salesTaxDisplay;
  @JsonKey(name: 'LaborTaxRate1')
  final double? laborTaxRate1;
  @JsonKey(name: 'LaborTaxRate2')
  final double? laborTaxRate2;
  @JsonKey(name: 'LaborExempt')
  final bool? laborExempt;
  @JsonKey(name: 'LaborTaxDisplay')
  final String? laborTaxDisplay;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOptionFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOptionToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOptionToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOption &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.internalChar, internalChar) ||
                const DeepCollectionEquality()
                    .equals(other.internalChar, internalChar)) &&
            (identical(other.companyId, companyId) ||
                const DeepCollectionEquality()
                    .equals(other.companyId, companyId)) &&
            (identical(other.locationId, locationId) ||
                const DeepCollectionEquality()
                    .equals(other.locationId, locationId)) &&
            (identical(other.location, location) ||
                const DeepCollectionEquality()
                    .equals(other.location, location)) &&
            (identical(other.taxOptionId, taxOptionId) ||
                const DeepCollectionEquality()
                    .equals(other.taxOptionId, taxOptionId)) &&
            (identical(other.taxOption, taxOption) ||
                const DeepCollectionEquality()
                    .equals(other.taxOption, taxOption)) &&
            (identical(other.taxCountry, taxCountry) ||
                const DeepCollectionEquality()
                    .equals(other.taxCountry, taxCountry)) &&
            (identical(other.taxRule, taxRule) ||
                const DeepCollectionEquality()
                    .equals(other.taxRule, taxRule)) &&
            (identical(other.rentalTaxRate1, rentalTaxRate1) ||
                const DeepCollectionEquality()
                    .equals(other.rentalTaxRate1, rentalTaxRate1)) &&
            (identical(other.rentalTaxRate2, rentalTaxRate2) ||
                const DeepCollectionEquality()
                    .equals(other.rentalTaxRate2, rentalTaxRate2)) &&
            (identical(other.rentalExempt, rentalExempt) ||
                const DeepCollectionEquality()
                    .equals(other.rentalExempt, rentalExempt)) &&
            (identical(other.rentalTaxDisplay, rentalTaxDisplay) ||
                const DeepCollectionEquality()
                    .equals(other.rentalTaxDisplay, rentalTaxDisplay)) &&
            (identical(other.salesTaxRate1, salesTaxRate1) ||
                const DeepCollectionEquality()
                    .equals(other.salesTaxRate1, salesTaxRate1)) &&
            (identical(other.salesTaxRate2, salesTaxRate2) ||
                const DeepCollectionEquality()
                    .equals(other.salesTaxRate2, salesTaxRate2)) &&
            (identical(other.salesExempt, salesExempt) ||
                const DeepCollectionEquality()
                    .equals(other.salesExempt, salesExempt)) &&
            (identical(other.salesTaxDisplay, salesTaxDisplay) ||
                const DeepCollectionEquality()
                    .equals(other.salesTaxDisplay, salesTaxDisplay)) &&
            (identical(other.laborTaxRate1, laborTaxRate1) ||
                const DeepCollectionEquality()
                    .equals(other.laborTaxRate1, laborTaxRate1)) &&
            (identical(other.laborTaxRate2, laborTaxRate2) ||
                const DeepCollectionEquality()
                    .equals(other.laborTaxRate2, laborTaxRate2)) &&
            (identical(other.laborExempt, laborExempt) ||
                const DeepCollectionEquality()
                    .equals(other.laborExempt, laborExempt)) &&
            (identical(other.laborTaxDisplay, laborTaxDisplay) ||
                const DeepCollectionEquality()
                    .equals(other.laborTaxDisplay, laborTaxDisplay)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOptionExtension
    on WebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOption {
  WebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOption copyWith(
      {int? id,
      String? internalChar,
      String? companyId,
      String? locationId,
      String? location,
      String? taxOptionId,
      String? taxOption,
      String? taxCountry,
      String? taxRule,
      double? rentalTaxRate1,
      double? rentalTaxRate2,
      bool? rentalExempt,
      String? rentalTaxDisplay,
      double? salesTaxRate1,
      double? salesTaxRate2,
      bool? salesExempt,
      String? salesTaxDisplay,
      double? laborTaxRate1,
      double? laborTaxRate2,
      bool? laborExempt,
      String? laborTaxDisplay,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsCompanyTaxOptionCompanyTaxOption(
        id: id ?? this.id,
        internalChar: internalChar ?? this.internalChar,
        companyId: companyId ?? this.companyId,
        locationId: locationId ?? this.locationId,
        location: location ?? this.location,
        taxOptionId: taxOptionId ?? this.taxOptionId,
        taxOption: taxOption ?? this.taxOption,
        taxCountry: taxCountry ?? this.taxCountry,
        taxRule: taxRule ?? this.taxRule,
        rentalTaxRate1: rentalTaxRate1 ?? this.rentalTaxRate1,
        rentalTaxRate2: rentalTaxRate2 ?? this.rentalTaxRate2,
        rentalExempt: rentalExempt ?? this.rentalExempt,
        rentalTaxDisplay: rentalTaxDisplay ?? this.rentalTaxDisplay,
        salesTaxRate1: salesTaxRate1 ?? this.salesTaxRate1,
        salesTaxRate2: salesTaxRate2 ?? this.salesTaxRate2,
        salesExempt: salesExempt ?? this.salesExempt,
        salesTaxDisplay: salesTaxDisplay ?? this.salesTaxDisplay,
        laborTaxRate1: laborTaxRate1 ?? this.laborTaxRate1,
        laborTaxRate2: laborTaxRate2 ?? this.laborTaxRate2,
        laborExempt: laborExempt ?? this.laborExempt,
        laborTaxDisplay: laborTaxDisplay ?? this.laborTaxDisplay,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResale {
  WebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResale({
    this.companyTaxResaleId,
    this.companyId,
    this.stateId,
    this.stateCode,
    this.resaleNumber,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResale.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResaleFromJson(json);

  @JsonKey(name: 'CompanyTaxResaleId')
  final String? companyTaxResaleId;
  @JsonKey(name: 'CompanyId')
  final String? companyId;
  @JsonKey(name: 'StateId')
  final String? stateId;
  @JsonKey(name: 'StateCode')
  final String? stateCode;
  @JsonKey(name: 'ResaleNumber')
  final String? resaleNumber;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResaleFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResaleToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResaleToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResale &&
            (identical(other.companyTaxResaleId, companyTaxResaleId) ||
                const DeepCollectionEquality()
                    .equals(other.companyTaxResaleId, companyTaxResaleId)) &&
            (identical(other.companyId, companyId) ||
                const DeepCollectionEquality()
                    .equals(other.companyId, companyId)) &&
            (identical(other.stateId, stateId) ||
                const DeepCollectionEquality()
                    .equals(other.stateId, stateId)) &&
            (identical(other.stateCode, stateCode) ||
                const DeepCollectionEquality()
                    .equals(other.stateCode, stateCode)) &&
            (identical(other.resaleNumber, resaleNumber) ||
                const DeepCollectionEquality()
                    .equals(other.resaleNumber, resaleNumber)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResaleExtension
    on WebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResale {
  WebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResale copyWith(
      {String? companyTaxResaleId,
      String? companyId,
      String? stateId,
      String? stateCode,
      String? resaleNumber,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsCompanyTaxResaleCompanyTaxResale(
        companyTaxResaleId: companyTaxResaleId ?? this.companyTaxResaleId,
        companyId: companyId ?? this.companyId,
        stateId: stateId ?? this.stateId,
        stateCode: stateCode ?? this.stateCode,
        resaleNumber: resaleNumber ?? this.resaleNumber,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsContactNoteContactNote {
  WebApiModulesHomeControlsContactNoteContactNote({
    this.contactNoteId,
    this.contactId,
    this.companyId,
    this.companyContactId,
    this.noteDate,
    this.notesById,
    this.notesBy,
    this.description,
    this.notes,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsContactNoteContactNote.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsContactNoteContactNoteFromJson(json);

  @JsonKey(name: 'ContactNoteId')
  final String? contactNoteId;
  @JsonKey(name: 'ContactId')
  final String? contactId;
  @JsonKey(name: 'CompanyId')
  final String? companyId;
  @JsonKey(name: 'CompanyContactId')
  final String? companyContactId;
  @JsonKey(name: 'NoteDate')
  final String? noteDate;
  @JsonKey(name: 'NotesById')
  final String? notesById;
  @JsonKey(name: 'NotesBy')
  final String? notesBy;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'Notes')
  final String? notes;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsContactNoteContactNoteFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsContactNoteContactNoteToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsContactNoteContactNoteToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsContactNoteContactNote &&
            (identical(other.contactNoteId, contactNoteId) ||
                const DeepCollectionEquality()
                    .equals(other.contactNoteId, contactNoteId)) &&
            (identical(other.contactId, contactId) ||
                const DeepCollectionEquality()
                    .equals(other.contactId, contactId)) &&
            (identical(other.companyId, companyId) ||
                const DeepCollectionEquality()
                    .equals(other.companyId, companyId)) &&
            (identical(other.companyContactId, companyContactId) ||
                const DeepCollectionEquality()
                    .equals(other.companyContactId, companyContactId)) &&
            (identical(other.noteDate, noteDate) ||
                const DeepCollectionEquality()
                    .equals(other.noteDate, noteDate)) &&
            (identical(other.notesById, notesById) ||
                const DeepCollectionEquality()
                    .equals(other.notesById, notesById)) &&
            (identical(other.notesBy, notesBy) ||
                const DeepCollectionEquality()
                    .equals(other.notesBy, notesBy)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsContactNoteContactNoteExtension
    on WebApiModulesHomeControlsContactNoteContactNote {
  WebApiModulesHomeControlsContactNoteContactNote copyWith(
      {String? contactNoteId,
      String? contactId,
      String? companyId,
      String? companyContactId,
      String? noteDate,
      String? notesById,
      String? notesBy,
      String? description,
      String? notes,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsContactNoteContactNote(
        contactNoteId: contactNoteId ?? this.contactNoteId,
        contactId: contactId ?? this.contactId,
        companyId: companyId ?? this.companyId,
        companyContactId: companyContactId ?? this.companyContactId,
        noteDate: noteDate ?? this.noteDate,
        notesById: notesById ?? this.notesById,
        notesBy: notesBy ?? this.notesBy,
        description: description ?? this.description,
        notes: notes ?? this.notes,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsContainerItemContainerItem {
  WebApiModulesHomeControlsContainerItemContainerItem({
    this.itemId,
    this.containerItemId,
    this.inventoryId,
    this.warehouseId,
    this.iCode,
    this.description,
    this.itemDescription,
    this.trackedBy,
    this.availableFor,
    this.availableForDisplay,
    this.unitValue,
    this.replacementCost,
    this.classification,
    this.isContainer,
    this.containerId,
    this.containerInventoryId,
    this.containerICode,
    this.containerDescription,
    this.containerPackingListBehavior,
    this.containerStatus,
    this.containerStatusColor,
    this.containerStatusDate,
    this.fixedAsset,
    this.rank,
    this.statusType,
    this.statusDate,
    this.inventoryStatus,
    this.inventoryStatusId,
    this.color,
    this.textColor,
    this.barCode,
    this.barCodeForScanning,
    this.serialNumber,
    this.rfId,
    this.oldBarCode,
    this.oldSerialNumber,
    this.oldRfid,
    this.manufacturerPartNumber,
    this.manufactureDate,
    this.trackedByCode,
    this.availOwnershipSort,
    this.isNegativeInventory,
    this.inspectionNo,
    this.inspectionVendorId,
    this.inspectionVendor,
    this.manufacturerModelNumber,
    this.purchaseId,
    this.aisleLocation,
    this.shelfLocation,
    this.spaceId,
    this.buildingRoom,
    this.itemNotes,
    this.physicalId,
    this.physicalItemId,
    this.physicalDate,
    this.physicalBy,
    this.warehouse,
    this.warehouseCode,
    this.dealId,
    this.orderId,
    this.orderNumber,
    this.orderDescription,
    this.currentLocation,
    this.inventoryTypeId,
    this.inventoryType,
    this.inventoryTypeOrderBy,
    this.categoryId,
    this.category,
    this.categoryOrderBy,
    this.subCategoryId,
    this.subCategory,
    this.subCategoryOrderBy,
    this.ownership,
    this.purchaseVendorId,
    this.purchaseVendor,
    this.outsidePurchaseOrderNumber,
    this.purchasePoId,
    this.purchaseDate,
    this.receiveDate,
    this.receiveContractDate,
    this.purchasePoNumber,
    this.purchaseCost,
    this.invoiceCost,
    this.purchaseInvoiceNumber,
    this.purchaseInvoiceDate,
    this.purchaseCurrencyId,
    this.purchaseCurrencyCode,
    this.purchaseCurrency,
    this.purchaseCurrencySymbol,
    this.warehouseCurrencyId,
    this.warehouseCurrencyCode,
    this.warehouseCurrency,
    this.warehouseCurrencySymbol,
    this.purchaseCurrencyExchangeRate,
    this.unitCost,
    this.unitCostWithTax,
    this.unitCostCurrencyConverted,
    this.unitCostWithTaxCurrencyConverted,
    this.originalEquipmentCost,
    this.depreciation,
    this.bookValue,
    this.salvageValue,
    this.consignorId,
    this.consignor,
    this.consignorAgreementId,
    this.consignorAgreementNumber,
    this.manufacturerId,
    this.manufacturer,
    this.originalShowId,
    this.originalShow,
    this.conditionId,
    this.condition,
    this.surfaceId,
    this.surface,
    this.wallTypeId,
    this.wallType,
    this.openingId,
    this.opening,
    this.responsiblePersonId,
    this.responsiblePerson,
    this.buyerId,
    this.buyer,
    this.receiptNumber,
    this.depreciationMonths,
    this.repairId,
    this.repairNumber,
    this.qcRequired,
    this.widthFt,
    this.widthIn,
    this.heightFt,
    this.heightIn,
    this.lengthFt,
    this.lengthIn,
    this.currentMeter,
    this.trackAssetUsage,
    this.trackLampUsage,
    this.trackStrikes,
    this.trackCandles,
    this.assetHours,
    this.lampCount,
    this.lampHours1,
    this.lampHours2,
    this.lampHours3,
    this.lampHours4,
    this.strikes,
    this.footCandles,
    this.minimumFootCandles,
    this.softwareVersion,
    this.softwareEffectiveDate,
    this.pattern,
    this.gender,
    this.label,
    this.material,
    this.period,
    this.cleaningFeeAmount,
    this.wardrobeSize,
    this.wardrobePieceCount,
    this.inventoryTypeIsProps,
    this.inventoryTypeIsWardrobe,
    this.orderLocationId,
    this.containerNumber,
    this.isWardrobe,
    this.isProps,
    this.dailyRate,
    this.weeklyRate,
    this.monthlyRate,
    this.location,
    this.retiredReason,
    this.warrantyExpiration,
    this.warrantyPeriod,
    this.countryOfOriginId,
    this.countryOfOrigin,
    this.shelfLifeExpirationDate,
    this.currentDealId,
    this.currentDeal,
    this.currentCustomerId,
    this.currentCustomer,
    this.currentOrderId,
    this.currentOrderNumber,
    this.currentOrderType,
    this.currentOrderDescription,
    this.currentOrderDate,
    this.currentOrderPickDate,
    this.currentOrderFromDate,
    this.currentOrderToDate,
    this.currentOrderAgent,
    this.lotNumber,
    this.lastOrderId,
    this.lastOrderNumber,
    this.lastOrderDescription,
    this.lastDealId,
    this.lastDeal,
    this.lastDealNumber,
    this.lastOutContractId,
    this.lastOutContractNumber,
    this.lastOutContractDate,
    this.lastOutUserId,
    this.lastOutUserName,
    this.lastInContractId,
    this.lastInContractNumber,
    this.lastInContractDate,
    this.lastInUserId,
    this.lastInUserName,
    this.depreciationStartDate,
    this.depreciationWarehouseId,
    this.depreciationWarehouse,
    this.depreciationWarehouseCode,
    this.inactive,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsContainerItemContainerItem.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsContainerItemContainerItemFromJson(json);

  @JsonKey(name: 'ItemId')
  final String? itemId;
  @JsonKey(name: 'ContainerItemId')
  final String? containerItemId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'ItemDescription')
  final String? itemDescription;
  @JsonKey(name: 'TrackedBy')
  final String? trackedBy;
  @JsonKey(name: 'AvailableFor')
  final String? availableFor;
  @JsonKey(name: 'AvailableForDisplay')
  final String? availableForDisplay;
  @JsonKey(name: 'UnitValue')
  final double? unitValue;
  @JsonKey(name: 'ReplacementCost')
  final double? replacementCost;
  @JsonKey(name: 'Classification')
  final String? classification;
  @JsonKey(name: 'IsContainer')
  final bool? isContainer;
  @JsonKey(name: 'ContainerId')
  final String? containerId;
  @JsonKey(name: 'ContainerInventoryId')
  final String? containerInventoryId;
  @JsonKey(name: 'ContainerICode')
  final String? containerICode;
  @JsonKey(name: 'ContainerDescription')
  final String? containerDescription;
  @JsonKey(name: 'ContainerPackingListBehavior')
  final String? containerPackingListBehavior;
  @JsonKey(name: 'ContainerStatus')
  final String? containerStatus;
  @JsonKey(name: 'ContainerStatusColor')
  final String? containerStatusColor;
  @JsonKey(name: 'ContainerStatusDate')
  final String? containerStatusDate;
  @JsonKey(name: 'FixedAsset')
  final bool? fixedAsset;
  @JsonKey(name: 'Rank')
  final String? rank;
  @JsonKey(name: 'StatusType')
  final String? statusType;
  @JsonKey(name: 'StatusDate')
  final String? statusDate;
  @JsonKey(name: 'InventoryStatus')
  final String? inventoryStatus;
  @JsonKey(name: 'InventoryStatusId')
  final String? inventoryStatusId;
  @JsonKey(name: 'Color')
  final String? color;
  @JsonKey(name: 'TextColor')
  final String? textColor;
  @JsonKey(name: 'BarCode')
  final String? barCode;
  @JsonKey(name: 'BarCodeForScanning')
  final String? barCodeForScanning;
  @JsonKey(name: 'SerialNumber')
  final String? serialNumber;
  @JsonKey(name: 'RfId')
  final String? rfId;
  @JsonKey(name: 'OldBarCode')
  final String? oldBarCode;
  @JsonKey(name: 'OldSerialNumber')
  final String? oldSerialNumber;
  @JsonKey(name: 'OldRfid')
  final String? oldRfid;
  @JsonKey(name: 'ManufacturerPartNumber')
  final String? manufacturerPartNumber;
  @JsonKey(name: 'ManufactureDate')
  final String? manufactureDate;
  @JsonKey(name: 'TrackedByCode')
  final String? trackedByCode;
  @JsonKey(name: 'AvailOwnershipSort')
  final int? availOwnershipSort;
  @JsonKey(name: 'IsNegativeInventory')
  final bool? isNegativeInventory;
  @JsonKey(name: 'InspectionNo')
  final String? inspectionNo;
  @JsonKey(name: 'InspectionVendorId')
  final String? inspectionVendorId;
  @JsonKey(name: 'InspectionVendor')
  final String? inspectionVendor;
  @JsonKey(name: 'ManufacturerModelNumber')
  final String? manufacturerModelNumber;
  @JsonKey(name: 'PurchaseId')
  final String? purchaseId;
  @JsonKey(name: 'AisleLocation')
  final String? aisleLocation;
  @JsonKey(name: 'ShelfLocation')
  final String? shelfLocation;
  @JsonKey(name: 'SpaceId')
  final String? spaceId;
  @JsonKey(name: 'BuildingRoom')
  final String? buildingRoom;
  @JsonKey(name: 'ItemNotes')
  final String? itemNotes;
  @JsonKey(name: 'PhysicalId')
  final String? physicalId;
  @JsonKey(name: 'PhysicalItemId')
  final int? physicalItemId;
  @JsonKey(name: 'PhysicalDate')
  final String? physicalDate;
  @JsonKey(name: 'PhysicalBy')
  final String? physicalBy;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderNumber')
  final String? orderNumber;
  @JsonKey(name: 'OrderDescription')
  final String? orderDescription;
  @JsonKey(name: 'CurrentLocation')
  final String? currentLocation;
  @JsonKey(name: 'InventoryTypeId')
  final String? inventoryTypeId;
  @JsonKey(name: 'InventoryType')
  final String? inventoryType;
  @JsonKey(name: 'InventoryTypeOrderBy')
  final int? inventoryTypeOrderBy;
  @JsonKey(name: 'CategoryId')
  final String? categoryId;
  @JsonKey(name: 'Category')
  final String? category;
  @JsonKey(name: 'CategoryOrderBy')
  final double? categoryOrderBy;
  @JsonKey(name: 'SubCategoryId')
  final String? subCategoryId;
  @JsonKey(name: 'SubCategory')
  final String? subCategory;
  @JsonKey(name: 'SubCategoryOrderBy')
  final double? subCategoryOrderBy;
  @JsonKey(name: 'Ownership')
  final String? ownership;
  @JsonKey(name: 'PurchaseVendorId')
  final String? purchaseVendorId;
  @JsonKey(name: 'PurchaseVendor')
  final String? purchaseVendor;
  @JsonKey(name: 'OutsidePurchaseOrderNumber')
  final String? outsidePurchaseOrderNumber;
  @JsonKey(name: 'PurchasePoId')
  final String? purchasePoId;
  @JsonKey(name: 'PurchaseDate')
  final String? purchaseDate;
  @JsonKey(name: 'ReceiveDate')
  final String? receiveDate;
  @JsonKey(name: 'ReceiveContractDate')
  final String? receiveContractDate;
  @JsonKey(name: 'PurchasePoNumber')
  final String? purchasePoNumber;
  @JsonKey(name: 'PurchaseCost')
  final double? purchaseCost;
  @JsonKey(name: 'InvoiceCost')
  final double? invoiceCost;
  @JsonKey(name: 'PurchaseInvoiceNumber')
  final String? purchaseInvoiceNumber;
  @JsonKey(name: 'PurchaseInvoiceDate')
  final String? purchaseInvoiceDate;
  @JsonKey(name: 'PurchaseCurrencyId')
  final String? purchaseCurrencyId;
  @JsonKey(name: 'PurchaseCurrencyCode')
  final String? purchaseCurrencyCode;
  @JsonKey(name: 'PurchaseCurrency')
  final String? purchaseCurrency;
  @JsonKey(name: 'PurchaseCurrencySymbol')
  final String? purchaseCurrencySymbol;
  @JsonKey(name: 'WarehouseCurrencyId')
  final String? warehouseCurrencyId;
  @JsonKey(name: 'WarehouseCurrencyCode')
  final String? warehouseCurrencyCode;
  @JsonKey(name: 'WarehouseCurrency')
  final String? warehouseCurrency;
  @JsonKey(name: 'WarehouseCurrencySymbol')
  final String? warehouseCurrencySymbol;
  @JsonKey(name: 'PurchaseCurrencyExchangeRate')
  final double? purchaseCurrencyExchangeRate;
  @JsonKey(name: 'UnitCost')
  final double? unitCost;
  @JsonKey(name: 'UnitCostWithTax')
  final double? unitCostWithTax;
  @JsonKey(name: 'UnitCostCurrencyConverted')
  final double? unitCostCurrencyConverted;
  @JsonKey(name: 'UnitCostWithTaxCurrencyConverted')
  final double? unitCostWithTaxCurrencyConverted;
  @JsonKey(name: 'OriginalEquipmentCost')
  final double? originalEquipmentCost;
  @JsonKey(name: 'Depreciation')
  final double? depreciation;
  @JsonKey(name: 'BookValue')
  final double? bookValue;
  @JsonKey(name: 'SalvageValue')
  final double? salvageValue;
  @JsonKey(name: 'ConsignorId')
  final String? consignorId;
  @JsonKey(name: 'Consignor')
  final String? consignor;
  @JsonKey(name: 'ConsignorAgreementId')
  final String? consignorAgreementId;
  @JsonKey(name: 'ConsignorAgreementNumber')
  final String? consignorAgreementNumber;
  @JsonKey(name: 'ManufacturerId')
  final String? manufacturerId;
  @JsonKey(name: 'Manufacturer')
  final String? manufacturer;
  @JsonKey(name: 'OriginalShowId')
  final String? originalShowId;
  @JsonKey(name: 'OriginalShow')
  final String? originalShow;
  @JsonKey(name: 'ConditionId')
  final String? conditionId;
  @JsonKey(name: 'Condition')
  final String? condition;
  @JsonKey(name: 'SurfaceId')
  final String? surfaceId;
  @JsonKey(name: 'Surface')
  final String? surface;
  @JsonKey(name: 'WallTypeId')
  final String? wallTypeId;
  @JsonKey(name: 'WallType')
  final String? wallType;
  @JsonKey(name: 'OpeningId')
  final String? openingId;
  @JsonKey(name: 'Opening')
  final String? opening;
  @JsonKey(name: 'ResponsiblePersonId')
  final String? responsiblePersonId;
  @JsonKey(name: 'ResponsiblePerson')
  final String? responsiblePerson;
  @JsonKey(name: 'BuyerId')
  final String? buyerId;
  @JsonKey(name: 'Buyer')
  final String? buyer;
  @JsonKey(name: 'ReceiptNumber')
  final String? receiptNumber;
  @JsonKey(name: 'DepreciationMonths')
  final int? depreciationMonths;
  @JsonKey(name: 'RepairId')
  final String? repairId;
  @JsonKey(name: 'RepairNumber')
  final String? repairNumber;
  @JsonKey(name: 'QcRequired')
  final bool? qcRequired;
  @JsonKey(name: 'WidthFt')
  final int? widthFt;
  @JsonKey(name: 'WidthIn')
  final int? widthIn;
  @JsonKey(name: 'HeightFt')
  final int? heightFt;
  @JsonKey(name: 'HeightIn')
  final int? heightIn;
  @JsonKey(name: 'LengthFt')
  final int? lengthFt;
  @JsonKey(name: 'LengthIn')
  final int? lengthIn;
  @JsonKey(name: 'CurrentMeter')
  final double? currentMeter;
  @JsonKey(name: 'TrackAssetUsage')
  final bool? trackAssetUsage;
  @JsonKey(name: 'TrackLampUsage')
  final bool? trackLampUsage;
  @JsonKey(name: 'TrackStrikes')
  final bool? trackStrikes;
  @JsonKey(name: 'TrackCandles')
  final bool? trackCandles;
  @JsonKey(name: 'AssetHours')
  final int? assetHours;
  @JsonKey(name: 'LampCount')
  final int? lampCount;
  @JsonKey(name: 'LampHours1')
  final int? lampHours1;
  @JsonKey(name: 'LampHours2')
  final int? lampHours2;
  @JsonKey(name: 'LampHours3')
  final int? lampHours3;
  @JsonKey(name: 'LampHours4')
  final int? lampHours4;
  @JsonKey(name: 'Strikes')
  final int? strikes;
  @JsonKey(name: 'FootCandles')
  final int? footCandles;
  @JsonKey(name: 'MinimumFootCandles')
  final int? minimumFootCandles;
  @JsonKey(name: 'SoftwareVersion')
  final String? softwareVersion;
  @JsonKey(name: 'SoftwareEffectiveDate')
  final String? softwareEffectiveDate;
  @JsonKey(name: 'Pattern')
  final String? pattern;
  @JsonKey(name: 'Gender')
  final String? gender;
  @JsonKey(name: 'Label')
  final String? label;
  @JsonKey(name: 'Material')
  final String? material;
  @JsonKey(name: 'Period')
  final String? period;
  @JsonKey(name: 'CleaningFeeAmount')
  final double? cleaningFeeAmount;
  @JsonKey(name: 'WardrobeSize')
  final String? wardrobeSize;
  @JsonKey(name: 'WardrobePieceCount')
  final int? wardrobePieceCount;
  @JsonKey(name: 'InventoryTypeIsProps')
  final bool? inventoryTypeIsProps;
  @JsonKey(name: 'InventoryTypeIsWardrobe')
  final bool? inventoryTypeIsWardrobe;
  @JsonKey(name: 'OrderLocationId')
  final String? orderLocationId;
  @JsonKey(name: 'ContainerNumber')
  final String? containerNumber;
  @JsonKey(name: 'IsWardrobe')
  final bool? isWardrobe;
  @JsonKey(name: 'IsProps')
  final bool? isProps;
  @JsonKey(name: 'DailyRate')
  final double? dailyRate;
  @JsonKey(name: 'WeeklyRate')
  final double? weeklyRate;
  @JsonKey(name: 'MonthlyRate')
  final double? monthlyRate;
  @JsonKey(name: 'Location')
  final String? location;
  @JsonKey(name: 'RetiredReason')
  final String? retiredReason;
  @JsonKey(name: 'WarrantyExpiration')
  final String? warrantyExpiration;
  @JsonKey(name: 'WarrantyPeriod')
  final int? warrantyPeriod;
  @JsonKey(name: 'CountryOfOriginId')
  final String? countryOfOriginId;
  @JsonKey(name: 'CountryOfOrigin')
  final String? countryOfOrigin;
  @JsonKey(name: 'ShelfLifeExpirationDate')
  final String? shelfLifeExpirationDate;
  @JsonKey(name: 'CurrentDealId')
  final String? currentDealId;
  @JsonKey(name: 'CurrentDeal')
  final String? currentDeal;
  @JsonKey(name: 'CurrentCustomerId')
  final String? currentCustomerId;
  @JsonKey(name: 'CurrentCustomer')
  final String? currentCustomer;
  @JsonKey(name: 'CurrentOrderId')
  final String? currentOrderId;
  @JsonKey(name: 'CurrentOrderNumber')
  final String? currentOrderNumber;
  @JsonKey(name: 'CurrentOrderType')
  final String? currentOrderType;
  @JsonKey(name: 'CurrentOrderDescription')
  final String? currentOrderDescription;
  @JsonKey(name: 'CurrentOrderDate')
  final String? currentOrderDate;
  @JsonKey(name: 'CurrentOrderPickDate')
  final String? currentOrderPickDate;
  @JsonKey(name: 'CurrentOrderFromDate')
  final String? currentOrderFromDate;
  @JsonKey(name: 'CurrentOrderToDate')
  final String? currentOrderToDate;
  @JsonKey(name: 'CurrentOrderAgent')
  final String? currentOrderAgent;
  @JsonKey(name: 'LotNumber')
  final String? lotNumber;
  @JsonKey(name: 'LastOrderId')
  final String? lastOrderId;
  @JsonKey(name: 'LastOrderNumber')
  final String? lastOrderNumber;
  @JsonKey(name: 'LastOrderDescription')
  final String? lastOrderDescription;
  @JsonKey(name: 'LastDealId')
  final String? lastDealId;
  @JsonKey(name: 'LastDeal')
  final String? lastDeal;
  @JsonKey(name: 'LastDealNumber')
  final String? lastDealNumber;
  @JsonKey(name: 'LastOutContractId')
  final String? lastOutContractId;
  @JsonKey(name: 'LastOutContractNumber')
  final String? lastOutContractNumber;
  @JsonKey(name: 'LastOutContractDate')
  final String? lastOutContractDate;
  @JsonKey(name: 'LastOutUserId')
  final String? lastOutUserId;
  @JsonKey(name: 'LastOutUserName')
  final String? lastOutUserName;
  @JsonKey(name: 'LastInContractId')
  final String? lastInContractId;
  @JsonKey(name: 'LastInContractNumber')
  final String? lastInContractNumber;
  @JsonKey(name: 'LastInContractDate')
  final String? lastInContractDate;
  @JsonKey(name: 'LastInUserId')
  final String? lastInUserId;
  @JsonKey(name: 'LastInUserName')
  final String? lastInUserName;
  @JsonKey(name: 'DepreciationStartDate')
  final String? depreciationStartDate;
  @JsonKey(name: 'DepreciationWarehouseId')
  final String? depreciationWarehouseId;
  @JsonKey(name: 'DepreciationWarehouse')
  final String? depreciationWarehouse;
  @JsonKey(name: 'DepreciationWarehouseCode')
  final String? depreciationWarehouseCode;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsContainerItemContainerItemFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsContainerItemContainerItemToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsContainerItemContainerItemToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsContainerItemContainerItem &&
            (identical(other.itemId, itemId) ||
                const DeepCollectionEquality().equals(other.itemId, itemId)) &&
            (identical(other.containerItemId, containerItemId) ||
                const DeepCollectionEquality()
                    .equals(other.containerItemId, containerItemId)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.itemDescription, itemDescription) ||
                const DeepCollectionEquality()
                    .equals(other.itemDescription, itemDescription)) &&
            (identical(other.trackedBy, trackedBy) ||
                const DeepCollectionEquality()
                    .equals(other.trackedBy, trackedBy)) &&
            (identical(other.availableFor, availableFor) ||
                const DeepCollectionEquality()
                    .equals(other.availableFor, availableFor)) &&
            (identical(other.availableForDisplay, availableForDisplay) ||
                const DeepCollectionEquality()
                    .equals(other.availableForDisplay, availableForDisplay)) &&
            (identical(other.unitValue, unitValue) ||
                const DeepCollectionEquality()
                    .equals(other.unitValue, unitValue)) &&
            (identical(other.replacementCost, replacementCost) ||
                const DeepCollectionEquality()
                    .equals(other.replacementCost, replacementCost)) &&
            (identical(other.classification, classification) ||
                const DeepCollectionEquality()
                    .equals(other.classification, classification)) &&
            (identical(other.isContainer, isContainer) ||
                const DeepCollectionEquality()
                    .equals(other.isContainer, isContainer)) &&
            (identical(other.containerId, containerId) ||
                const DeepCollectionEquality()
                    .equals(other.containerId, containerId)) &&
            (identical(other.containerInventoryId, containerInventoryId) ||
                const DeepCollectionEquality().equals(
                    other.containerInventoryId, containerInventoryId)) &&
            (identical(other.containerICode, containerICode) ||
                const DeepCollectionEquality()
                    .equals(other.containerICode, containerICode)) &&
            (identical(other.containerDescription, containerDescription) ||
                const DeepCollectionEquality().equals(
                    other.containerDescription, containerDescription)) &&
            (identical(other.containerPackingListBehavior, containerPackingListBehavior) ||
                const DeepCollectionEquality().equals(
                    other.containerPackingListBehavior,
                    containerPackingListBehavior)) &&
            (identical(other.containerStatus, containerStatus) ||
                const DeepCollectionEquality()
                    .equals(other.containerStatus, containerStatus)) &&
            (identical(other.containerStatusColor, containerStatusColor) ||
                const DeepCollectionEquality().equals(
                    other.containerStatusColor, containerStatusColor)) &&
            (identical(other.containerStatusDate, containerStatusDate) || const DeepCollectionEquality().equals(other.containerStatusDate, containerStatusDate)) &&
            (identical(other.fixedAsset, fixedAsset) || const DeepCollectionEquality().equals(other.fixedAsset, fixedAsset)) &&
            (identical(other.rank, rank) || const DeepCollectionEquality().equals(other.rank, rank)) &&
            (identical(other.statusType, statusType) || const DeepCollectionEquality().equals(other.statusType, statusType)) &&
            (identical(other.statusDate, statusDate) || const DeepCollectionEquality().equals(other.statusDate, statusDate)) &&
            (identical(other.inventoryStatus, inventoryStatus) || const DeepCollectionEquality().equals(other.inventoryStatus, inventoryStatus)) &&
            (identical(other.inventoryStatusId, inventoryStatusId) || const DeepCollectionEquality().equals(other.inventoryStatusId, inventoryStatusId)) &&
            (identical(other.color, color) || const DeepCollectionEquality().equals(other.color, color)) &&
            (identical(other.textColor, textColor) || const DeepCollectionEquality().equals(other.textColor, textColor)) &&
            (identical(other.barCode, barCode) || const DeepCollectionEquality().equals(other.barCode, barCode)) &&
            (identical(other.barCodeForScanning, barCodeForScanning) || const DeepCollectionEquality().equals(other.barCodeForScanning, barCodeForScanning)) &&
            (identical(other.serialNumber, serialNumber) || const DeepCollectionEquality().equals(other.serialNumber, serialNumber)) &&
            (identical(other.rfId, rfId) || const DeepCollectionEquality().equals(other.rfId, rfId)) &&
            (identical(other.oldBarCode, oldBarCode) || const DeepCollectionEquality().equals(other.oldBarCode, oldBarCode)) &&
            (identical(other.oldSerialNumber, oldSerialNumber) || const DeepCollectionEquality().equals(other.oldSerialNumber, oldSerialNumber)) &&
            (identical(other.oldRfid, oldRfid) || const DeepCollectionEquality().equals(other.oldRfid, oldRfid)) &&
            (identical(other.manufacturerPartNumber, manufacturerPartNumber) || const DeepCollectionEquality().equals(other.manufacturerPartNumber, manufacturerPartNumber)) &&
            (identical(other.manufactureDate, manufactureDate) || const DeepCollectionEquality().equals(other.manufactureDate, manufactureDate)) &&
            (identical(other.trackedByCode, trackedByCode) || const DeepCollectionEquality().equals(other.trackedByCode, trackedByCode)) &&
            (identical(other.availOwnershipSort, availOwnershipSort) || const DeepCollectionEquality().equals(other.availOwnershipSort, availOwnershipSort)) &&
            (identical(other.isNegativeInventory, isNegativeInventory) || const DeepCollectionEquality().equals(other.isNegativeInventory, isNegativeInventory)) &&
            (identical(other.inspectionNo, inspectionNo) || const DeepCollectionEquality().equals(other.inspectionNo, inspectionNo)) &&
            (identical(other.inspectionVendorId, inspectionVendorId) || const DeepCollectionEquality().equals(other.inspectionVendorId, inspectionVendorId)) &&
            (identical(other.inspectionVendor, inspectionVendor) || const DeepCollectionEquality().equals(other.inspectionVendor, inspectionVendor)) &&
            (identical(other.manufacturerModelNumber, manufacturerModelNumber) || const DeepCollectionEquality().equals(other.manufacturerModelNumber, manufacturerModelNumber)) &&
            (identical(other.purchaseId, purchaseId) || const DeepCollectionEquality().equals(other.purchaseId, purchaseId)) &&
            (identical(other.aisleLocation, aisleLocation) || const DeepCollectionEquality().equals(other.aisleLocation, aisleLocation)) &&
            (identical(other.shelfLocation, shelfLocation) || const DeepCollectionEquality().equals(other.shelfLocation, shelfLocation)) &&
            (identical(other.spaceId, spaceId) || const DeepCollectionEquality().equals(other.spaceId, spaceId)) &&
            (identical(other.buildingRoom, buildingRoom) || const DeepCollectionEquality().equals(other.buildingRoom, buildingRoom)) &&
            (identical(other.itemNotes, itemNotes) || const DeepCollectionEquality().equals(other.itemNotes, itemNotes)) &&
            (identical(other.physicalId, physicalId) || const DeepCollectionEquality().equals(other.physicalId, physicalId)) &&
            (identical(other.physicalItemId, physicalItemId) || const DeepCollectionEquality().equals(other.physicalItemId, physicalItemId)) &&
            (identical(other.physicalDate, physicalDate) || const DeepCollectionEquality().equals(other.physicalDate, physicalDate)) &&
            (identical(other.physicalBy, physicalBy) || const DeepCollectionEquality().equals(other.physicalBy, physicalBy)) &&
            (identical(other.warehouse, warehouse) || const DeepCollectionEquality().equals(other.warehouse, warehouse)) &&
            (identical(other.warehouseCode, warehouseCode) || const DeepCollectionEquality().equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.dealId, dealId) || const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.orderId, orderId) || const DeepCollectionEquality().equals(other.orderId, orderId)) &&
            (identical(other.orderNumber, orderNumber) || const DeepCollectionEquality().equals(other.orderNumber, orderNumber)) &&
            (identical(other.orderDescription, orderDescription) || const DeepCollectionEquality().equals(other.orderDescription, orderDescription)) &&
            (identical(other.currentLocation, currentLocation) || const DeepCollectionEquality().equals(other.currentLocation, currentLocation)) &&
            (identical(other.inventoryTypeId, inventoryTypeId) || const DeepCollectionEquality().equals(other.inventoryTypeId, inventoryTypeId)) &&
            (identical(other.inventoryType, inventoryType) || const DeepCollectionEquality().equals(other.inventoryType, inventoryType)) &&
            (identical(other.inventoryTypeOrderBy, inventoryTypeOrderBy) || const DeepCollectionEquality().equals(other.inventoryTypeOrderBy, inventoryTypeOrderBy)) &&
            (identical(other.categoryId, categoryId) || const DeepCollectionEquality().equals(other.categoryId, categoryId)) &&
            (identical(other.category, category) || const DeepCollectionEquality().equals(other.category, category)) &&
            (identical(other.categoryOrderBy, categoryOrderBy) || const DeepCollectionEquality().equals(other.categoryOrderBy, categoryOrderBy)) &&
            (identical(other.subCategoryId, subCategoryId) || const DeepCollectionEquality().equals(other.subCategoryId, subCategoryId)) &&
            (identical(other.subCategory, subCategory) || const DeepCollectionEquality().equals(other.subCategory, subCategory)) &&
            (identical(other.subCategoryOrderBy, subCategoryOrderBy) || const DeepCollectionEquality().equals(other.subCategoryOrderBy, subCategoryOrderBy)) &&
            (identical(other.ownership, ownership) || const DeepCollectionEquality().equals(other.ownership, ownership)) &&
            (identical(other.purchaseVendorId, purchaseVendorId) || const DeepCollectionEquality().equals(other.purchaseVendorId, purchaseVendorId)) &&
            (identical(other.purchaseVendor, purchaseVendor) || const DeepCollectionEquality().equals(other.purchaseVendor, purchaseVendor)) &&
            (identical(other.outsidePurchaseOrderNumber, outsidePurchaseOrderNumber) || const DeepCollectionEquality().equals(other.outsidePurchaseOrderNumber, outsidePurchaseOrderNumber)) &&
            (identical(other.purchasePoId, purchasePoId) || const DeepCollectionEquality().equals(other.purchasePoId, purchasePoId)) &&
            (identical(other.purchaseDate, purchaseDate) || const DeepCollectionEquality().equals(other.purchaseDate, purchaseDate)) &&
            (identical(other.receiveDate, receiveDate) || const DeepCollectionEquality().equals(other.receiveDate, receiveDate)) &&
            (identical(other.receiveContractDate, receiveContractDate) || const DeepCollectionEquality().equals(other.receiveContractDate, receiveContractDate)) &&
            (identical(other.purchasePoNumber, purchasePoNumber) || const DeepCollectionEquality().equals(other.purchasePoNumber, purchasePoNumber)) &&
            (identical(other.purchaseCost, purchaseCost) || const DeepCollectionEquality().equals(other.purchaseCost, purchaseCost)) &&
            (identical(other.invoiceCost, invoiceCost) || const DeepCollectionEquality().equals(other.invoiceCost, invoiceCost)) &&
            (identical(other.purchaseInvoiceNumber, purchaseInvoiceNumber) || const DeepCollectionEquality().equals(other.purchaseInvoiceNumber, purchaseInvoiceNumber)) &&
            (identical(other.purchaseInvoiceDate, purchaseInvoiceDate) || const DeepCollectionEquality().equals(other.purchaseInvoiceDate, purchaseInvoiceDate)) &&
            (identical(other.purchaseCurrencyId, purchaseCurrencyId) || const DeepCollectionEquality().equals(other.purchaseCurrencyId, purchaseCurrencyId)) &&
            (identical(other.purchaseCurrencyCode, purchaseCurrencyCode) || const DeepCollectionEquality().equals(other.purchaseCurrencyCode, purchaseCurrencyCode)) &&
            (identical(other.purchaseCurrency, purchaseCurrency) || const DeepCollectionEquality().equals(other.purchaseCurrency, purchaseCurrency)) &&
            (identical(other.purchaseCurrencySymbol, purchaseCurrencySymbol) || const DeepCollectionEquality().equals(other.purchaseCurrencySymbol, purchaseCurrencySymbol)) &&
            (identical(other.warehouseCurrencyId, warehouseCurrencyId) || const DeepCollectionEquality().equals(other.warehouseCurrencyId, warehouseCurrencyId)) &&
            (identical(other.warehouseCurrencyCode, warehouseCurrencyCode) || const DeepCollectionEquality().equals(other.warehouseCurrencyCode, warehouseCurrencyCode)) &&
            (identical(other.warehouseCurrency, warehouseCurrency) || const DeepCollectionEquality().equals(other.warehouseCurrency, warehouseCurrency)) &&
            (identical(other.warehouseCurrencySymbol, warehouseCurrencySymbol) || const DeepCollectionEquality().equals(other.warehouseCurrencySymbol, warehouseCurrencySymbol)) &&
            (identical(other.purchaseCurrencyExchangeRate, purchaseCurrencyExchangeRate) || const DeepCollectionEquality().equals(other.purchaseCurrencyExchangeRate, purchaseCurrencyExchangeRate)) &&
            (identical(other.unitCost, unitCost) || const DeepCollectionEquality().equals(other.unitCost, unitCost)) &&
            (identical(other.unitCostWithTax, unitCostWithTax) || const DeepCollectionEquality().equals(other.unitCostWithTax, unitCostWithTax)) &&
            (identical(other.unitCostCurrencyConverted, unitCostCurrencyConverted) || const DeepCollectionEquality().equals(other.unitCostCurrencyConverted, unitCostCurrencyConverted)) &&
            (identical(other.unitCostWithTaxCurrencyConverted, unitCostWithTaxCurrencyConverted) || const DeepCollectionEquality().equals(other.unitCostWithTaxCurrencyConverted, unitCostWithTaxCurrencyConverted)) &&
            (identical(other.originalEquipmentCost, originalEquipmentCost) || const DeepCollectionEquality().equals(other.originalEquipmentCost, originalEquipmentCost)) &&
            (identical(other.depreciation, depreciation) || const DeepCollectionEquality().equals(other.depreciation, depreciation)) &&
            (identical(other.bookValue, bookValue) || const DeepCollectionEquality().equals(other.bookValue, bookValue)) &&
            (identical(other.salvageValue, salvageValue) || const DeepCollectionEquality().equals(other.salvageValue, salvageValue)) &&
            (identical(other.consignorId, consignorId) || const DeepCollectionEquality().equals(other.consignorId, consignorId)) &&
            (identical(other.consignor, consignor) || const DeepCollectionEquality().equals(other.consignor, consignor)) &&
            (identical(other.consignorAgreementId, consignorAgreementId) || const DeepCollectionEquality().equals(other.consignorAgreementId, consignorAgreementId)) &&
            (identical(other.consignorAgreementNumber, consignorAgreementNumber) || const DeepCollectionEquality().equals(other.consignorAgreementNumber, consignorAgreementNumber)) &&
            (identical(other.manufacturerId, manufacturerId) || const DeepCollectionEquality().equals(other.manufacturerId, manufacturerId)) &&
            (identical(other.manufacturer, manufacturer) || const DeepCollectionEquality().equals(other.manufacturer, manufacturer)) &&
            (identical(other.originalShowId, originalShowId) || const DeepCollectionEquality().equals(other.originalShowId, originalShowId)) &&
            (identical(other.originalShow, originalShow) || const DeepCollectionEquality().equals(other.originalShow, originalShow)) &&
            (identical(other.conditionId, conditionId) || const DeepCollectionEquality().equals(other.conditionId, conditionId)) &&
            (identical(other.condition, condition) || const DeepCollectionEquality().equals(other.condition, condition)) &&
            (identical(other.surfaceId, surfaceId) || const DeepCollectionEquality().equals(other.surfaceId, surfaceId)) &&
            (identical(other.surface, surface) || const DeepCollectionEquality().equals(other.surface, surface)) &&
            (identical(other.wallTypeId, wallTypeId) || const DeepCollectionEquality().equals(other.wallTypeId, wallTypeId)) &&
            (identical(other.wallType, wallType) || const DeepCollectionEquality().equals(other.wallType, wallType)) &&
            (identical(other.openingId, openingId) || const DeepCollectionEquality().equals(other.openingId, openingId)) &&
            (identical(other.opening, opening) || const DeepCollectionEquality().equals(other.opening, opening)) &&
            (identical(other.responsiblePersonId, responsiblePersonId) || const DeepCollectionEquality().equals(other.responsiblePersonId, responsiblePersonId)) &&
            (identical(other.responsiblePerson, responsiblePerson) || const DeepCollectionEquality().equals(other.responsiblePerson, responsiblePerson)) &&
            (identical(other.buyerId, buyerId) || const DeepCollectionEquality().equals(other.buyerId, buyerId)) &&
            (identical(other.buyer, buyer) || const DeepCollectionEquality().equals(other.buyer, buyer)) &&
            (identical(other.receiptNumber, receiptNumber) || const DeepCollectionEquality().equals(other.receiptNumber, receiptNumber)) &&
            (identical(other.depreciationMonths, depreciationMonths) || const DeepCollectionEquality().equals(other.depreciationMonths, depreciationMonths)) &&
            (identical(other.repairId, repairId) || const DeepCollectionEquality().equals(other.repairId, repairId)) &&
            (identical(other.repairNumber, repairNumber) || const DeepCollectionEquality().equals(other.repairNumber, repairNumber)) &&
            (identical(other.qcRequired, qcRequired) || const DeepCollectionEquality().equals(other.qcRequired, qcRequired)) &&
            (identical(other.widthFt, widthFt) || const DeepCollectionEquality().equals(other.widthFt, widthFt)) &&
            (identical(other.widthIn, widthIn) || const DeepCollectionEquality().equals(other.widthIn, widthIn)) &&
            (identical(other.heightFt, heightFt) || const DeepCollectionEquality().equals(other.heightFt, heightFt)) &&
            (identical(other.heightIn, heightIn) || const DeepCollectionEquality().equals(other.heightIn, heightIn)) &&
            (identical(other.lengthFt, lengthFt) || const DeepCollectionEquality().equals(other.lengthFt, lengthFt)) &&
            (identical(other.lengthIn, lengthIn) || const DeepCollectionEquality().equals(other.lengthIn, lengthIn)) &&
            (identical(other.currentMeter, currentMeter) || const DeepCollectionEquality().equals(other.currentMeter, currentMeter)) &&
            (identical(other.trackAssetUsage, trackAssetUsage) || const DeepCollectionEquality().equals(other.trackAssetUsage, trackAssetUsage)) &&
            (identical(other.trackLampUsage, trackLampUsage) || const DeepCollectionEquality().equals(other.trackLampUsage, trackLampUsage)) &&
            (identical(other.trackStrikes, trackStrikes) || const DeepCollectionEquality().equals(other.trackStrikes, trackStrikes)) &&
            (identical(other.trackCandles, trackCandles) || const DeepCollectionEquality().equals(other.trackCandles, trackCandles)) &&
            (identical(other.assetHours, assetHours) || const DeepCollectionEquality().equals(other.assetHours, assetHours)) &&
            (identical(other.lampCount, lampCount) || const DeepCollectionEquality().equals(other.lampCount, lampCount)) &&
            (identical(other.lampHours1, lampHours1) || const DeepCollectionEquality().equals(other.lampHours1, lampHours1)) &&
            (identical(other.lampHours2, lampHours2) || const DeepCollectionEquality().equals(other.lampHours2, lampHours2)) &&
            (identical(other.lampHours3, lampHours3) || const DeepCollectionEquality().equals(other.lampHours3, lampHours3)) &&
            (identical(other.lampHours4, lampHours4) || const DeepCollectionEquality().equals(other.lampHours4, lampHours4)) &&
            (identical(other.strikes, strikes) || const DeepCollectionEquality().equals(other.strikes, strikes)) &&
            (identical(other.footCandles, footCandles) || const DeepCollectionEquality().equals(other.footCandles, footCandles)) &&
            (identical(other.minimumFootCandles, minimumFootCandles) || const DeepCollectionEquality().equals(other.minimumFootCandles, minimumFootCandles)) &&
            (identical(other.softwareVersion, softwareVersion) || const DeepCollectionEquality().equals(other.softwareVersion, softwareVersion)) &&
            (identical(other.softwareEffectiveDate, softwareEffectiveDate) || const DeepCollectionEquality().equals(other.softwareEffectiveDate, softwareEffectiveDate)) &&
            (identical(other.pattern, pattern) || const DeepCollectionEquality().equals(other.pattern, pattern)) &&
            (identical(other.gender, gender) || const DeepCollectionEquality().equals(other.gender, gender)) &&
            (identical(other.label, label) || const DeepCollectionEquality().equals(other.label, label)) &&
            (identical(other.material, material) || const DeepCollectionEquality().equals(other.material, material)) &&
            (identical(other.period, period) || const DeepCollectionEquality().equals(other.period, period)) &&
            (identical(other.cleaningFeeAmount, cleaningFeeAmount) || const DeepCollectionEquality().equals(other.cleaningFeeAmount, cleaningFeeAmount)) &&
            (identical(other.wardrobeSize, wardrobeSize) || const DeepCollectionEquality().equals(other.wardrobeSize, wardrobeSize)) &&
            (identical(other.wardrobePieceCount, wardrobePieceCount) || const DeepCollectionEquality().equals(other.wardrobePieceCount, wardrobePieceCount)) &&
            (identical(other.inventoryTypeIsProps, inventoryTypeIsProps) || const DeepCollectionEquality().equals(other.inventoryTypeIsProps, inventoryTypeIsProps)) &&
            (identical(other.inventoryTypeIsWardrobe, inventoryTypeIsWardrobe) || const DeepCollectionEquality().equals(other.inventoryTypeIsWardrobe, inventoryTypeIsWardrobe)) &&
            (identical(other.orderLocationId, orderLocationId) || const DeepCollectionEquality().equals(other.orderLocationId, orderLocationId)) &&
            (identical(other.containerNumber, containerNumber) || const DeepCollectionEquality().equals(other.containerNumber, containerNumber)) &&
            (identical(other.isWardrobe, isWardrobe) || const DeepCollectionEquality().equals(other.isWardrobe, isWardrobe)) &&
            (identical(other.isProps, isProps) || const DeepCollectionEquality().equals(other.isProps, isProps)) &&
            (identical(other.dailyRate, dailyRate) || const DeepCollectionEquality().equals(other.dailyRate, dailyRate)) &&
            (identical(other.weeklyRate, weeklyRate) || const DeepCollectionEquality().equals(other.weeklyRate, weeklyRate)) &&
            (identical(other.monthlyRate, monthlyRate) || const DeepCollectionEquality().equals(other.monthlyRate, monthlyRate)) &&
            (identical(other.location, location) || const DeepCollectionEquality().equals(other.location, location)) &&
            (identical(other.retiredReason, retiredReason) || const DeepCollectionEquality().equals(other.retiredReason, retiredReason)) &&
            (identical(other.warrantyExpiration, warrantyExpiration) || const DeepCollectionEquality().equals(other.warrantyExpiration, warrantyExpiration)) &&
            (identical(other.warrantyPeriod, warrantyPeriod) || const DeepCollectionEquality().equals(other.warrantyPeriod, warrantyPeriod)) &&
            (identical(other.countryOfOriginId, countryOfOriginId) || const DeepCollectionEquality().equals(other.countryOfOriginId, countryOfOriginId)) &&
            (identical(other.countryOfOrigin, countryOfOrigin) || const DeepCollectionEquality().equals(other.countryOfOrigin, countryOfOrigin)) &&
            (identical(other.shelfLifeExpirationDate, shelfLifeExpirationDate) || const DeepCollectionEquality().equals(other.shelfLifeExpirationDate, shelfLifeExpirationDate)) &&
            (identical(other.currentDealId, currentDealId) || const DeepCollectionEquality().equals(other.currentDealId, currentDealId)) &&
            (identical(other.currentDeal, currentDeal) || const DeepCollectionEquality().equals(other.currentDeal, currentDeal)) &&
            (identical(other.currentCustomerId, currentCustomerId) || const DeepCollectionEquality().equals(other.currentCustomerId, currentCustomerId)) &&
            (identical(other.currentCustomer, currentCustomer) || const DeepCollectionEquality().equals(other.currentCustomer, currentCustomer)) &&
            (identical(other.currentOrderId, currentOrderId) || const DeepCollectionEquality().equals(other.currentOrderId, currentOrderId)) &&
            (identical(other.currentOrderNumber, currentOrderNumber) || const DeepCollectionEquality().equals(other.currentOrderNumber, currentOrderNumber)) &&
            (identical(other.currentOrderType, currentOrderType) || const DeepCollectionEquality().equals(other.currentOrderType, currentOrderType)) &&
            (identical(other.currentOrderDescription, currentOrderDescription) || const DeepCollectionEquality().equals(other.currentOrderDescription, currentOrderDescription)) &&
            (identical(other.currentOrderDate, currentOrderDate) || const DeepCollectionEquality().equals(other.currentOrderDate, currentOrderDate)) &&
            (identical(other.currentOrderPickDate, currentOrderPickDate) || const DeepCollectionEquality().equals(other.currentOrderPickDate, currentOrderPickDate)) &&
            (identical(other.currentOrderFromDate, currentOrderFromDate) || const DeepCollectionEquality().equals(other.currentOrderFromDate, currentOrderFromDate)) &&
            (identical(other.currentOrderToDate, currentOrderToDate) || const DeepCollectionEquality().equals(other.currentOrderToDate, currentOrderToDate)) &&
            (identical(other.currentOrderAgent, currentOrderAgent) || const DeepCollectionEquality().equals(other.currentOrderAgent, currentOrderAgent)) &&
            (identical(other.lotNumber, lotNumber) || const DeepCollectionEquality().equals(other.lotNumber, lotNumber)) &&
            (identical(other.lastOrderId, lastOrderId) || const DeepCollectionEquality().equals(other.lastOrderId, lastOrderId)) &&
            (identical(other.lastOrderNumber, lastOrderNumber) || const DeepCollectionEquality().equals(other.lastOrderNumber, lastOrderNumber)) &&
            (identical(other.lastOrderDescription, lastOrderDescription) || const DeepCollectionEquality().equals(other.lastOrderDescription, lastOrderDescription)) &&
            (identical(other.lastDealId, lastDealId) || const DeepCollectionEquality().equals(other.lastDealId, lastDealId)) &&
            (identical(other.lastDeal, lastDeal) || const DeepCollectionEquality().equals(other.lastDeal, lastDeal)) &&
            (identical(other.lastDealNumber, lastDealNumber) || const DeepCollectionEquality().equals(other.lastDealNumber, lastDealNumber)) &&
            (identical(other.lastOutContractId, lastOutContractId) || const DeepCollectionEquality().equals(other.lastOutContractId, lastOutContractId)) &&
            (identical(other.lastOutContractNumber, lastOutContractNumber) || const DeepCollectionEquality().equals(other.lastOutContractNumber, lastOutContractNumber)) &&
            (identical(other.lastOutContractDate, lastOutContractDate) || const DeepCollectionEquality().equals(other.lastOutContractDate, lastOutContractDate)) &&
            (identical(other.lastOutUserId, lastOutUserId) || const DeepCollectionEquality().equals(other.lastOutUserId, lastOutUserId)) &&
            (identical(other.lastOutUserName, lastOutUserName) || const DeepCollectionEquality().equals(other.lastOutUserName, lastOutUserName)) &&
            (identical(other.lastInContractId, lastInContractId) || const DeepCollectionEquality().equals(other.lastInContractId, lastInContractId)) &&
            (identical(other.lastInContractNumber, lastInContractNumber) || const DeepCollectionEquality().equals(other.lastInContractNumber, lastInContractNumber)) &&
            (identical(other.lastInContractDate, lastInContractDate) || const DeepCollectionEquality().equals(other.lastInContractDate, lastInContractDate)) &&
            (identical(other.lastInUserId, lastInUserId) || const DeepCollectionEquality().equals(other.lastInUserId, lastInUserId)) &&
            (identical(other.lastInUserName, lastInUserName) || const DeepCollectionEquality().equals(other.lastInUserName, lastInUserName)) &&
            (identical(other.depreciationStartDate, depreciationStartDate) || const DeepCollectionEquality().equals(other.depreciationStartDate, depreciationStartDate)) &&
            (identical(other.depreciationWarehouseId, depreciationWarehouseId) || const DeepCollectionEquality().equals(other.depreciationWarehouseId, depreciationWarehouseId)) &&
            (identical(other.depreciationWarehouse, depreciationWarehouse) || const DeepCollectionEquality().equals(other.depreciationWarehouse, depreciationWarehouse)) &&
            (identical(other.depreciationWarehouseCode, depreciationWarehouseCode) || const DeepCollectionEquality().equals(other.depreciationWarehouseCode, depreciationWarehouseCode)) &&
            (identical(other.inactive, inactive) || const DeepCollectionEquality().equals(other.inactive, inactive)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsContainerItemContainerItemExtension
    on WebApiModulesHomeControlsContainerItemContainerItem {
  WebApiModulesHomeControlsContainerItemContainerItem copyWith(
      {String? itemId,
      String? containerItemId,
      String? inventoryId,
      String? warehouseId,
      String? iCode,
      String? description,
      String? itemDescription,
      String? trackedBy,
      String? availableFor,
      String? availableForDisplay,
      double? unitValue,
      double? replacementCost,
      String? classification,
      bool? isContainer,
      String? containerId,
      String? containerInventoryId,
      String? containerICode,
      String? containerDescription,
      String? containerPackingListBehavior,
      String? containerStatus,
      String? containerStatusColor,
      String? containerStatusDate,
      bool? fixedAsset,
      String? rank,
      String? statusType,
      String? statusDate,
      String? inventoryStatus,
      String? inventoryStatusId,
      String? color,
      String? textColor,
      String? barCode,
      String? barCodeForScanning,
      String? serialNumber,
      String? rfId,
      String? oldBarCode,
      String? oldSerialNumber,
      String? oldRfid,
      String? manufacturerPartNumber,
      String? manufactureDate,
      String? trackedByCode,
      int? availOwnershipSort,
      bool? isNegativeInventory,
      String? inspectionNo,
      String? inspectionVendorId,
      String? inspectionVendor,
      String? manufacturerModelNumber,
      String? purchaseId,
      String? aisleLocation,
      String? shelfLocation,
      String? spaceId,
      String? buildingRoom,
      String? itemNotes,
      String? physicalId,
      int? physicalItemId,
      String? physicalDate,
      String? physicalBy,
      String? warehouse,
      String? warehouseCode,
      String? dealId,
      String? orderId,
      String? orderNumber,
      String? orderDescription,
      String? currentLocation,
      String? inventoryTypeId,
      String? inventoryType,
      int? inventoryTypeOrderBy,
      String? categoryId,
      String? category,
      double? categoryOrderBy,
      String? subCategoryId,
      String? subCategory,
      double? subCategoryOrderBy,
      String? ownership,
      String? purchaseVendorId,
      String? purchaseVendor,
      String? outsidePurchaseOrderNumber,
      String? purchasePoId,
      String? purchaseDate,
      String? receiveDate,
      String? receiveContractDate,
      String? purchasePoNumber,
      double? purchaseCost,
      double? invoiceCost,
      String? purchaseInvoiceNumber,
      String? purchaseInvoiceDate,
      String? purchaseCurrencyId,
      String? purchaseCurrencyCode,
      String? purchaseCurrency,
      String? purchaseCurrencySymbol,
      String? warehouseCurrencyId,
      String? warehouseCurrencyCode,
      String? warehouseCurrency,
      String? warehouseCurrencySymbol,
      double? purchaseCurrencyExchangeRate,
      double? unitCost,
      double? unitCostWithTax,
      double? unitCostCurrencyConverted,
      double? unitCostWithTaxCurrencyConverted,
      double? originalEquipmentCost,
      double? depreciation,
      double? bookValue,
      double? salvageValue,
      String? consignorId,
      String? consignor,
      String? consignorAgreementId,
      String? consignorAgreementNumber,
      String? manufacturerId,
      String? manufacturer,
      String? originalShowId,
      String? originalShow,
      String? conditionId,
      String? condition,
      String? surfaceId,
      String? surface,
      String? wallTypeId,
      String? wallType,
      String? openingId,
      String? opening,
      String? responsiblePersonId,
      String? responsiblePerson,
      String? buyerId,
      String? buyer,
      String? receiptNumber,
      int? depreciationMonths,
      String? repairId,
      String? repairNumber,
      bool? qcRequired,
      int? widthFt,
      int? widthIn,
      int? heightFt,
      int? heightIn,
      int? lengthFt,
      int? lengthIn,
      double? currentMeter,
      bool? trackAssetUsage,
      bool? trackLampUsage,
      bool? trackStrikes,
      bool? trackCandles,
      int? assetHours,
      int? lampCount,
      int? lampHours1,
      int? lampHours2,
      int? lampHours3,
      int? lampHours4,
      int? strikes,
      int? footCandles,
      int? minimumFootCandles,
      String? softwareVersion,
      String? softwareEffectiveDate,
      String? pattern,
      String? gender,
      String? label,
      String? material,
      String? period,
      double? cleaningFeeAmount,
      String? wardrobeSize,
      int? wardrobePieceCount,
      bool? inventoryTypeIsProps,
      bool? inventoryTypeIsWardrobe,
      String? orderLocationId,
      String? containerNumber,
      bool? isWardrobe,
      bool? isProps,
      double? dailyRate,
      double? weeklyRate,
      double? monthlyRate,
      String? location,
      String? retiredReason,
      String? warrantyExpiration,
      int? warrantyPeriod,
      String? countryOfOriginId,
      String? countryOfOrigin,
      String? shelfLifeExpirationDate,
      String? currentDealId,
      String? currentDeal,
      String? currentCustomerId,
      String? currentCustomer,
      String? currentOrderId,
      String? currentOrderNumber,
      String? currentOrderType,
      String? currentOrderDescription,
      String? currentOrderDate,
      String? currentOrderPickDate,
      String? currentOrderFromDate,
      String? currentOrderToDate,
      String? currentOrderAgent,
      String? lotNumber,
      String? lastOrderId,
      String? lastOrderNumber,
      String? lastOrderDescription,
      String? lastDealId,
      String? lastDeal,
      String? lastDealNumber,
      String? lastOutContractId,
      String? lastOutContractNumber,
      String? lastOutContractDate,
      String? lastOutUserId,
      String? lastOutUserName,
      String? lastInContractId,
      String? lastInContractNumber,
      String? lastInContractDate,
      String? lastInUserId,
      String? lastInUserName,
      String? depreciationStartDate,
      String? depreciationWarehouseId,
      String? depreciationWarehouse,
      String? depreciationWarehouseCode,
      bool? inactive,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsContainerItemContainerItem(
        itemId: itemId ?? this.itemId,
        containerItemId: containerItemId ?? this.containerItemId,
        inventoryId: inventoryId ?? this.inventoryId,
        warehouseId: warehouseId ?? this.warehouseId,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        itemDescription: itemDescription ?? this.itemDescription,
        trackedBy: trackedBy ?? this.trackedBy,
        availableFor: availableFor ?? this.availableFor,
        availableForDisplay: availableForDisplay ?? this.availableForDisplay,
        unitValue: unitValue ?? this.unitValue,
        replacementCost: replacementCost ?? this.replacementCost,
        classification: classification ?? this.classification,
        isContainer: isContainer ?? this.isContainer,
        containerId: containerId ?? this.containerId,
        containerInventoryId: containerInventoryId ?? this.containerInventoryId,
        containerICode: containerICode ?? this.containerICode,
        containerDescription: containerDescription ?? this.containerDescription,
        containerPackingListBehavior:
            containerPackingListBehavior ?? this.containerPackingListBehavior,
        containerStatus: containerStatus ?? this.containerStatus,
        containerStatusColor: containerStatusColor ?? this.containerStatusColor,
        containerStatusDate: containerStatusDate ?? this.containerStatusDate,
        fixedAsset: fixedAsset ?? this.fixedAsset,
        rank: rank ?? this.rank,
        statusType: statusType ?? this.statusType,
        statusDate: statusDate ?? this.statusDate,
        inventoryStatus: inventoryStatus ?? this.inventoryStatus,
        inventoryStatusId: inventoryStatusId ?? this.inventoryStatusId,
        color: color ?? this.color,
        textColor: textColor ?? this.textColor,
        barCode: barCode ?? this.barCode,
        barCodeForScanning: barCodeForScanning ?? this.barCodeForScanning,
        serialNumber: serialNumber ?? this.serialNumber,
        rfId: rfId ?? this.rfId,
        oldBarCode: oldBarCode ?? this.oldBarCode,
        oldSerialNumber: oldSerialNumber ?? this.oldSerialNumber,
        oldRfid: oldRfid ?? this.oldRfid,
        manufacturerPartNumber:
            manufacturerPartNumber ?? this.manufacturerPartNumber,
        manufactureDate: manufactureDate ?? this.manufactureDate,
        trackedByCode: trackedByCode ?? this.trackedByCode,
        availOwnershipSort: availOwnershipSort ?? this.availOwnershipSort,
        isNegativeInventory: isNegativeInventory ?? this.isNegativeInventory,
        inspectionNo: inspectionNo ?? this.inspectionNo,
        inspectionVendorId: inspectionVendorId ?? this.inspectionVendorId,
        inspectionVendor: inspectionVendor ?? this.inspectionVendor,
        manufacturerModelNumber:
            manufacturerModelNumber ?? this.manufacturerModelNumber,
        purchaseId: purchaseId ?? this.purchaseId,
        aisleLocation: aisleLocation ?? this.aisleLocation,
        shelfLocation: shelfLocation ?? this.shelfLocation,
        spaceId: spaceId ?? this.spaceId,
        buildingRoom: buildingRoom ?? this.buildingRoom,
        itemNotes: itemNotes ?? this.itemNotes,
        physicalId: physicalId ?? this.physicalId,
        physicalItemId: physicalItemId ?? this.physicalItemId,
        physicalDate: physicalDate ?? this.physicalDate,
        physicalBy: physicalBy ?? this.physicalBy,
        warehouse: warehouse ?? this.warehouse,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        dealId: dealId ?? this.dealId,
        orderId: orderId ?? this.orderId,
        orderNumber: orderNumber ?? this.orderNumber,
        orderDescription: orderDescription ?? this.orderDescription,
        currentLocation: currentLocation ?? this.currentLocation,
        inventoryTypeId: inventoryTypeId ?? this.inventoryTypeId,
        inventoryType: inventoryType ?? this.inventoryType,
        inventoryTypeOrderBy: inventoryTypeOrderBy ?? this.inventoryTypeOrderBy,
        categoryId: categoryId ?? this.categoryId,
        category: category ?? this.category,
        categoryOrderBy: categoryOrderBy ?? this.categoryOrderBy,
        subCategoryId: subCategoryId ?? this.subCategoryId,
        subCategory: subCategory ?? this.subCategory,
        subCategoryOrderBy: subCategoryOrderBy ?? this.subCategoryOrderBy,
        ownership: ownership ?? this.ownership,
        purchaseVendorId: purchaseVendorId ?? this.purchaseVendorId,
        purchaseVendor: purchaseVendor ?? this.purchaseVendor,
        outsidePurchaseOrderNumber:
            outsidePurchaseOrderNumber ?? this.outsidePurchaseOrderNumber,
        purchasePoId: purchasePoId ?? this.purchasePoId,
        purchaseDate: purchaseDate ?? this.purchaseDate,
        receiveDate: receiveDate ?? this.receiveDate,
        receiveContractDate: receiveContractDate ?? this.receiveContractDate,
        purchasePoNumber: purchasePoNumber ?? this.purchasePoNumber,
        purchaseCost: purchaseCost ?? this.purchaseCost,
        invoiceCost: invoiceCost ?? this.invoiceCost,
        purchaseInvoiceNumber:
            purchaseInvoiceNumber ?? this.purchaseInvoiceNumber,
        purchaseInvoiceDate: purchaseInvoiceDate ?? this.purchaseInvoiceDate,
        purchaseCurrencyId: purchaseCurrencyId ?? this.purchaseCurrencyId,
        purchaseCurrencyCode: purchaseCurrencyCode ?? this.purchaseCurrencyCode,
        purchaseCurrency: purchaseCurrency ?? this.purchaseCurrency,
        purchaseCurrencySymbol:
            purchaseCurrencySymbol ?? this.purchaseCurrencySymbol,
        warehouseCurrencyId: warehouseCurrencyId ?? this.warehouseCurrencyId,
        warehouseCurrencyCode:
            warehouseCurrencyCode ?? this.warehouseCurrencyCode,
        warehouseCurrency: warehouseCurrency ?? this.warehouseCurrency,
        warehouseCurrencySymbol:
            warehouseCurrencySymbol ?? this.warehouseCurrencySymbol,
        purchaseCurrencyExchangeRate:
            purchaseCurrencyExchangeRate ?? this.purchaseCurrencyExchangeRate,
        unitCost: unitCost ?? this.unitCost,
        unitCostWithTax: unitCostWithTax ?? this.unitCostWithTax,
        unitCostCurrencyConverted:
            unitCostCurrencyConverted ?? this.unitCostCurrencyConverted,
        unitCostWithTaxCurrencyConverted: unitCostWithTaxCurrencyConverted ??
            this.unitCostWithTaxCurrencyConverted,
        originalEquipmentCost:
            originalEquipmentCost ?? this.originalEquipmentCost,
        depreciation: depreciation ?? this.depreciation,
        bookValue: bookValue ?? this.bookValue,
        salvageValue: salvageValue ?? this.salvageValue,
        consignorId: consignorId ?? this.consignorId,
        consignor: consignor ?? this.consignor,
        consignorAgreementId: consignorAgreementId ?? this.consignorAgreementId,
        consignorAgreementNumber:
            consignorAgreementNumber ?? this.consignorAgreementNumber,
        manufacturerId: manufacturerId ?? this.manufacturerId,
        manufacturer: manufacturer ?? this.manufacturer,
        originalShowId: originalShowId ?? this.originalShowId,
        originalShow: originalShow ?? this.originalShow,
        conditionId: conditionId ?? this.conditionId,
        condition: condition ?? this.condition,
        surfaceId: surfaceId ?? this.surfaceId,
        surface: surface ?? this.surface,
        wallTypeId: wallTypeId ?? this.wallTypeId,
        wallType: wallType ?? this.wallType,
        openingId: openingId ?? this.openingId,
        opening: opening ?? this.opening,
        responsiblePersonId: responsiblePersonId ?? this.responsiblePersonId,
        responsiblePerson: responsiblePerson ?? this.responsiblePerson,
        buyerId: buyerId ?? this.buyerId,
        buyer: buyer ?? this.buyer,
        receiptNumber: receiptNumber ?? this.receiptNumber,
        depreciationMonths: depreciationMonths ?? this.depreciationMonths,
        repairId: repairId ?? this.repairId,
        repairNumber: repairNumber ?? this.repairNumber,
        qcRequired: qcRequired ?? this.qcRequired,
        widthFt: widthFt ?? this.widthFt,
        widthIn: widthIn ?? this.widthIn,
        heightFt: heightFt ?? this.heightFt,
        heightIn: heightIn ?? this.heightIn,
        lengthFt: lengthFt ?? this.lengthFt,
        lengthIn: lengthIn ?? this.lengthIn,
        currentMeter: currentMeter ?? this.currentMeter,
        trackAssetUsage: trackAssetUsage ?? this.trackAssetUsage,
        trackLampUsage: trackLampUsage ?? this.trackLampUsage,
        trackStrikes: trackStrikes ?? this.trackStrikes,
        trackCandles: trackCandles ?? this.trackCandles,
        assetHours: assetHours ?? this.assetHours,
        lampCount: lampCount ?? this.lampCount,
        lampHours1: lampHours1 ?? this.lampHours1,
        lampHours2: lampHours2 ?? this.lampHours2,
        lampHours3: lampHours3 ?? this.lampHours3,
        lampHours4: lampHours4 ?? this.lampHours4,
        strikes: strikes ?? this.strikes,
        footCandles: footCandles ?? this.footCandles,
        minimumFootCandles: minimumFootCandles ?? this.minimumFootCandles,
        softwareVersion: softwareVersion ?? this.softwareVersion,
        softwareEffectiveDate:
            softwareEffectiveDate ?? this.softwareEffectiveDate,
        pattern: pattern ?? this.pattern,
        gender: gender ?? this.gender,
        label: label ?? this.label,
        material: material ?? this.material,
        period: period ?? this.period,
        cleaningFeeAmount: cleaningFeeAmount ?? this.cleaningFeeAmount,
        wardrobeSize: wardrobeSize ?? this.wardrobeSize,
        wardrobePieceCount: wardrobePieceCount ?? this.wardrobePieceCount,
        inventoryTypeIsProps: inventoryTypeIsProps ?? this.inventoryTypeIsProps,
        inventoryTypeIsWardrobe:
            inventoryTypeIsWardrobe ?? this.inventoryTypeIsWardrobe,
        orderLocationId: orderLocationId ?? this.orderLocationId,
        containerNumber: containerNumber ?? this.containerNumber,
        isWardrobe: isWardrobe ?? this.isWardrobe,
        isProps: isProps ?? this.isProps,
        dailyRate: dailyRate ?? this.dailyRate,
        weeklyRate: weeklyRate ?? this.weeklyRate,
        monthlyRate: monthlyRate ?? this.monthlyRate,
        location: location ?? this.location,
        retiredReason: retiredReason ?? this.retiredReason,
        warrantyExpiration: warrantyExpiration ?? this.warrantyExpiration,
        warrantyPeriod: warrantyPeriod ?? this.warrantyPeriod,
        countryOfOriginId: countryOfOriginId ?? this.countryOfOriginId,
        countryOfOrigin: countryOfOrigin ?? this.countryOfOrigin,
        shelfLifeExpirationDate:
            shelfLifeExpirationDate ?? this.shelfLifeExpirationDate,
        currentDealId: currentDealId ?? this.currentDealId,
        currentDeal: currentDeal ?? this.currentDeal,
        currentCustomerId: currentCustomerId ?? this.currentCustomerId,
        currentCustomer: currentCustomer ?? this.currentCustomer,
        currentOrderId: currentOrderId ?? this.currentOrderId,
        currentOrderNumber: currentOrderNumber ?? this.currentOrderNumber,
        currentOrderType: currentOrderType ?? this.currentOrderType,
        currentOrderDescription:
            currentOrderDescription ?? this.currentOrderDescription,
        currentOrderDate: currentOrderDate ?? this.currentOrderDate,
        currentOrderPickDate: currentOrderPickDate ?? this.currentOrderPickDate,
        currentOrderFromDate: currentOrderFromDate ?? this.currentOrderFromDate,
        currentOrderToDate: currentOrderToDate ?? this.currentOrderToDate,
        currentOrderAgent: currentOrderAgent ?? this.currentOrderAgent,
        lotNumber: lotNumber ?? this.lotNumber,
        lastOrderId: lastOrderId ?? this.lastOrderId,
        lastOrderNumber: lastOrderNumber ?? this.lastOrderNumber,
        lastOrderDescription: lastOrderDescription ?? this.lastOrderDescription,
        lastDealId: lastDealId ?? this.lastDealId,
        lastDeal: lastDeal ?? this.lastDeal,
        lastDealNumber: lastDealNumber ?? this.lastDealNumber,
        lastOutContractId: lastOutContractId ?? this.lastOutContractId,
        lastOutContractNumber:
            lastOutContractNumber ?? this.lastOutContractNumber,
        lastOutContractDate: lastOutContractDate ?? this.lastOutContractDate,
        lastOutUserId: lastOutUserId ?? this.lastOutUserId,
        lastOutUserName: lastOutUserName ?? this.lastOutUserName,
        lastInContractId: lastInContractId ?? this.lastInContractId,
        lastInContractNumber: lastInContractNumber ?? this.lastInContractNumber,
        lastInContractDate: lastInContractDate ?? this.lastInContractDate,
        lastInUserId: lastInUserId ?? this.lastInUserId,
        lastInUserName: lastInUserName ?? this.lastInUserName,
        depreciationStartDate:
            depreciationStartDate ?? this.depreciationStartDate,
        depreciationWarehouseId:
            depreciationWarehouseId ?? this.depreciationWarehouseId,
        depreciationWarehouse:
            depreciationWarehouse ?? this.depreciationWarehouse,
        depreciationWarehouseCode:
            depreciationWarehouseCode ?? this.depreciationWarehouseCode,
        inactive: inactive ?? this.inactive,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsContainerItemEmptyContainerItemResponse {
  WebApiModulesHomeControlsContainerItemEmptyContainerItemResponse({
    this.inContractId,
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesHomeControlsContainerItemEmptyContainerItemResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsContainerItemEmptyContainerItemResponseFromJson(
          json);

  @JsonKey(name: 'InContractId')
  final String? inContractId;
  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsContainerItemEmptyContainerItemResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsContainerItemEmptyContainerItemResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsContainerItemEmptyContainerItemResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsContainerItemEmptyContainerItemResponse &&
            (identical(other.inContractId, inContractId) ||
                const DeepCollectionEquality()
                    .equals(other.inContractId, inContractId)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesHomeControlsContainerItemEmptyContainerItemResponseExtension
    on WebApiModulesHomeControlsContainerItemEmptyContainerItemResponse {
  WebApiModulesHomeControlsContainerItemEmptyContainerItemResponse copyWith(
      {String? inContractId, int? status, bool? success, String? msg}) {
    return WebApiModulesHomeControlsContainerItemEmptyContainerItemResponse(
        inContractId: inContractId ?? this.inContractId,
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsContainerItemEmptyContainerRequest {
  WebApiModulesHomeControlsContainerItemEmptyContainerRequest({
    this.itemId,
    this.warehouseId,
    this.deleteAll,
  });

  factory WebApiModulesHomeControlsContainerItemEmptyContainerRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsContainerItemEmptyContainerRequestFromJson(
          json);

  @JsonKey(name: 'ItemId')
  final String? itemId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'DeleteAll')
  final String? deleteAll;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsContainerItemEmptyContainerRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsContainerItemEmptyContainerRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsContainerItemEmptyContainerRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsContainerItemEmptyContainerRequest &&
            (identical(other.itemId, itemId) ||
                const DeepCollectionEquality().equals(other.itemId, itemId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.deleteAll, deleteAll) ||
                const DeepCollectionEquality()
                    .equals(other.deleteAll, deleteAll)));
  }
}

extension $WebApiModulesHomeControlsContainerItemEmptyContainerRequestExtension
    on WebApiModulesHomeControlsContainerItemEmptyContainerRequest {
  WebApiModulesHomeControlsContainerItemEmptyContainerRequest copyWith(
      {String? itemId, String? warehouseId, String? deleteAll}) {
    return WebApiModulesHomeControlsContainerItemEmptyContainerRequest(
        itemId: itemId ?? this.itemId,
        warehouseId: warehouseId ?? this.warehouseId,
        deleteAll: deleteAll ?? this.deleteAll);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsContainerItemInstantiateContainerItemResponse {
  WebApiModulesHomeControlsContainerItemInstantiateContainerItemResponse({
    this.containerItemId,
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesHomeControlsContainerItemInstantiateContainerItemResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsContainerItemInstantiateContainerItemResponseFromJson(
          json);

  @JsonKey(name: 'ContainerItemId')
  final String? containerItemId;
  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsContainerItemInstantiateContainerItemResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsContainerItemInstantiateContainerItemResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsContainerItemInstantiateContainerItemResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsContainerItemInstantiateContainerItemResponse &&
            (identical(other.containerItemId, containerItemId) ||
                const DeepCollectionEquality()
                    .equals(other.containerItemId, containerItemId)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesHomeControlsContainerItemInstantiateContainerItemResponseExtension
    on WebApiModulesHomeControlsContainerItemInstantiateContainerItemResponse {
  WebApiModulesHomeControlsContainerItemInstantiateContainerItemResponse
      copyWith(
          {String? containerItemId, int? status, bool? success, String? msg}) {
    return WebApiModulesHomeControlsContainerItemInstantiateContainerItemResponse(
        containerItemId: containerItemId ?? this.containerItemId,
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsContainerItemInstantiateContainerRequest {
  WebApiModulesHomeControlsContainerItemInstantiateContainerRequest({
    this.containerId,
    this.itemId,
    this.warehouseId,
  });

  factory WebApiModulesHomeControlsContainerItemInstantiateContainerRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsContainerItemInstantiateContainerRequestFromJson(
          json);

  @JsonKey(name: 'ContainerId')
  final String? containerId;
  @JsonKey(name: 'ItemId')
  final String? itemId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsContainerItemInstantiateContainerRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsContainerItemInstantiateContainerRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsContainerItemInstantiateContainerRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsContainerItemInstantiateContainerRequest &&
            (identical(other.containerId, containerId) ||
                const DeepCollectionEquality()
                    .equals(other.containerId, containerId)) &&
            (identical(other.itemId, itemId) ||
                const DeepCollectionEquality().equals(other.itemId, itemId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)));
  }
}

extension $WebApiModulesHomeControlsContainerItemInstantiateContainerRequestExtension
    on WebApiModulesHomeControlsContainerItemInstantiateContainerRequest {
  WebApiModulesHomeControlsContainerItemInstantiateContainerRequest copyWith(
      {String? containerId, String? itemId, String? warehouseId}) {
    return WebApiModulesHomeControlsContainerItemInstantiateContainerRequest(
        containerId: containerId ?? this.containerId,
        itemId: itemId ?? this.itemId,
        warehouseId: warehouseId ?? this.warehouseId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsContainerItemRemoveFromContainerRequest {
  WebApiModulesHomeControlsContainerItemRemoveFromContainerRequest({
    this.containerItemId,
    this.itemId,
    this.inventoryId,
    this.warehouseId,
    this.consignorId,
    this.consignorAgreementId,
    this.quantity,
  });

  factory WebApiModulesHomeControlsContainerItemRemoveFromContainerRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsContainerItemRemoveFromContainerRequestFromJson(
          json);

  @JsonKey(name: 'ContainerItemId')
  final String? containerItemId;
  @JsonKey(name: 'ItemId')
  final String? itemId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'ConsignorId')
  final String? consignorId;
  @JsonKey(name: 'ConsignorAgreementId')
  final String? consignorAgreementId;
  @JsonKey(name: 'Quantity')
  final double? quantity;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsContainerItemRemoveFromContainerRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsContainerItemRemoveFromContainerRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsContainerItemRemoveFromContainerRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsContainerItemRemoveFromContainerRequest &&
            (identical(other.containerItemId, containerItemId) ||
                const DeepCollectionEquality()
                    .equals(other.containerItemId, containerItemId)) &&
            (identical(other.itemId, itemId) ||
                const DeepCollectionEquality().equals(other.itemId, itemId)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.consignorId, consignorId) ||
                const DeepCollectionEquality()
                    .equals(other.consignorId, consignorId)) &&
            (identical(other.consignorAgreementId, consignorAgreementId) ||
                const DeepCollectionEquality().equals(
                    other.consignorAgreementId, consignorAgreementId)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)));
  }
}

extension $WebApiModulesHomeControlsContainerItemRemoveFromContainerRequestExtension
    on WebApiModulesHomeControlsContainerItemRemoveFromContainerRequest {
  WebApiModulesHomeControlsContainerItemRemoveFromContainerRequest copyWith(
      {String? containerItemId,
      String? itemId,
      String? inventoryId,
      String? warehouseId,
      String? consignorId,
      String? consignorAgreementId,
      double? quantity}) {
    return WebApiModulesHomeControlsContainerItemRemoveFromContainerRequest(
        containerItemId: containerItemId ?? this.containerItemId,
        itemId: itemId ?? this.itemId,
        inventoryId: inventoryId ?? this.inventoryId,
        warehouseId: warehouseId ?? this.warehouseId,
        consignorId: consignorId ?? this.consignorId,
        consignorAgreementId: consignorAgreementId ?? this.consignorAgreementId,
        quantity: quantity ?? this.quantity);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsContainerItemRemoveFromContainerResponse {
  WebApiModulesHomeControlsContainerItemRemoveFromContainerResponse({
    this.outputContractId,
    this.quantityRemoved,
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesHomeControlsContainerItemRemoveFromContainerResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsContainerItemRemoveFromContainerResponseFromJson(
          json);

  @JsonKey(name: 'OutputContractId')
  final String? outputContractId;
  @JsonKey(name: 'QuantityRemoved')
  final double? quantityRemoved;
  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsContainerItemRemoveFromContainerResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsContainerItemRemoveFromContainerResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsContainerItemRemoveFromContainerResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsContainerItemRemoveFromContainerResponse &&
            (identical(other.outputContractId, outputContractId) ||
                const DeepCollectionEquality()
                    .equals(other.outputContractId, outputContractId)) &&
            (identical(other.quantityRemoved, quantityRemoved) ||
                const DeepCollectionEquality()
                    .equals(other.quantityRemoved, quantityRemoved)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesHomeControlsContainerItemRemoveFromContainerResponseExtension
    on WebApiModulesHomeControlsContainerItemRemoveFromContainerResponse {
  WebApiModulesHomeControlsContainerItemRemoveFromContainerResponse copyWith(
      {String? outputContractId,
      double? quantityRemoved,
      int? status,
      bool? success,
      String? msg}) {
    return WebApiModulesHomeControlsContainerItemRemoveFromContainerResponse(
        outputContractId: outputContractId ?? this.outputContractId,
        quantityRemoved: quantityRemoved ?? this.quantityRemoved,
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsContainerWarehouseContainerWarehouse {
  WebApiModulesHomeControlsContainerWarehouseContainerWarehouse({
    this.inventoryId,
    this.warehouseId,
    this.warehouseCode,
    this.warehouse,
    this.dailyRate,
    this.weeklyRate,
    this.monthlyRate,
    this.quantity,
    this.quantityReady,
    this.quantityIncomplete,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsContainerWarehouseContainerWarehouse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsContainerWarehouseContainerWarehouseFromJson(
          json);

  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'DailyRate')
  final double? dailyRate;
  @JsonKey(name: 'WeeklyRate')
  final double? weeklyRate;
  @JsonKey(name: 'MonthlyRate')
  final double? monthlyRate;
  @JsonKey(name: 'Quantity')
  final int? quantity;
  @JsonKey(name: 'QuantityReady')
  final int? quantityReady;
  @JsonKey(name: 'QuantityIncomplete')
  final int? quantityIncomplete;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsContainerWarehouseContainerWarehouseFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsContainerWarehouseContainerWarehouseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsContainerWarehouseContainerWarehouseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsContainerWarehouseContainerWarehouse &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouseCode, warehouseCode) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.warehouse, warehouse) ||
                const DeepCollectionEquality()
                    .equals(other.warehouse, warehouse)) &&
            (identical(other.dailyRate, dailyRate) ||
                const DeepCollectionEquality()
                    .equals(other.dailyRate, dailyRate)) &&
            (identical(other.weeklyRate, weeklyRate) ||
                const DeepCollectionEquality()
                    .equals(other.weeklyRate, weeklyRate)) &&
            (identical(other.monthlyRate, monthlyRate) ||
                const DeepCollectionEquality()
                    .equals(other.monthlyRate, monthlyRate)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)) &&
            (identical(other.quantityReady, quantityReady) ||
                const DeepCollectionEquality()
                    .equals(other.quantityReady, quantityReady)) &&
            (identical(other.quantityIncomplete, quantityIncomplete) ||
                const DeepCollectionEquality()
                    .equals(other.quantityIncomplete, quantityIncomplete)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsContainerWarehouseContainerWarehouseExtension
    on WebApiModulesHomeControlsContainerWarehouseContainerWarehouse {
  WebApiModulesHomeControlsContainerWarehouseContainerWarehouse copyWith(
      {String? inventoryId,
      String? warehouseId,
      String? warehouseCode,
      String? warehouse,
      double? dailyRate,
      double? weeklyRate,
      double? monthlyRate,
      int? quantity,
      int? quantityReady,
      int? quantityIncomplete,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsContainerWarehouseContainerWarehouse(
        inventoryId: inventoryId ?? this.inventoryId,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        warehouse: warehouse ?? this.warehouse,
        dailyRate: dailyRate ?? this.dailyRate,
        weeklyRate: weeklyRate ?? this.weeklyRate,
        monthlyRate: monthlyRate ?? this.monthlyRate,
        quantity: quantity ?? this.quantity,
        quantityReady: quantityReady ?? this.quantityReady,
        quantityIncomplete: quantityIncomplete ?? this.quantityIncomplete,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsContractItemDetailContractItem {
  WebApiModulesHomeControlsContractItemDetailContractItem({
    this.orderId,
    this.orderItemId,
    this.vendorId,
    this.barCode,
    this.quantity,
  });

  factory WebApiModulesHomeControlsContractItemDetailContractItem.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsContractItemDetailContractItemFromJson(json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderItemId')
  final String? orderItemId;
  @JsonKey(name: 'VendorId')
  final String? vendorId;
  @JsonKey(name: 'BarCode')
  final String? barCode;
  @JsonKey(name: 'Quantity')
  final int? quantity;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsContractItemDetailContractItemFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsContractItemDetailContractItemToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsContractItemDetailContractItemToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsContractItemDetailContractItem &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderItemId, orderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.orderItemId, orderItemId)) &&
            (identical(other.vendorId, vendorId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorId, vendorId)) &&
            (identical(other.barCode, barCode) ||
                const DeepCollectionEquality()
                    .equals(other.barCode, barCode)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)));
  }
}

extension $WebApiModulesHomeControlsContractItemDetailContractItemExtension
    on WebApiModulesHomeControlsContractItemDetailContractItem {
  WebApiModulesHomeControlsContractItemDetailContractItem copyWith(
      {String? orderId,
      String? orderItemId,
      String? vendorId,
      String? barCode,
      int? quantity}) {
    return WebApiModulesHomeControlsContractItemDetailContractItem(
        orderId: orderId ?? this.orderId,
        orderItemId: orderItemId ?? this.orderItemId,
        vendorId: vendorId ?? this.vendorId,
        barCode: barCode ?? this.barCode,
        quantity: quantity ?? this.quantity);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsContractItemDetailContractItemDetail {
  WebApiModulesHomeControlsContractItemDetailContractItemDetail({
    this.contractId,
    this.orderId,
    this.orderItemId,
    this.orderNumber,
    this.orderDescription,
    this.iCode,
    this.iCodeDisplay,
    this.iCodeColor,
    this.description,
    this.descriptionColor,
    this.quantity,
    this.barCode,
    this.manufacturerPartNumber,
    this.trackedBy,
    this.categoryId,
    this.vendorId,
    this.vendor,
    this.vendorColor,
    this.inventoryId,
    this.warehouseId,
    this.warehouseCode,
    this.warehouse,
    this.primaryOrderItemId,
    this.itemClass,
    this.itemOrder,
    this.orderBy,
    this.notes,
    this.orderType,
    this.recType,
    this.recTypeDisplay,
    this.optionColor,
    this.usersId,
    this.userName,
    this.transactionDateTime,
    this.parentId,
    this.accessoryRatio,
    this.nestedOrderItemId,
    this.containerItemId,
    this.containerBarCode,
    this.isConsignment,
    this.consignorId,
    this.consignorAgreementId,
    this.isVoid,
    this.nestingLevel,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsContractItemDetailContractItemDetail.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsContractItemDetailContractItemDetailFromJson(
          json);

  @JsonKey(name: 'ContractId')
  final String? contractId;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderItemId')
  final String? orderItemId;
  @JsonKey(name: 'OrderNumber')
  final String? orderNumber;
  @JsonKey(name: 'OrderDescription')
  final String? orderDescription;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'ICodeDisplay')
  final String? iCodeDisplay;
  @JsonKey(name: 'ICodeColor')
  final String? iCodeColor;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'DescriptionColor')
  final String? descriptionColor;
  @JsonKey(name: 'Quantity')
  final double? quantity;
  @JsonKey(name: 'BarCode')
  final String? barCode;
  @JsonKey(name: 'ManufacturerPartNumber')
  final String? manufacturerPartNumber;
  @JsonKey(name: 'TrackedBy')
  final String? trackedBy;
  @JsonKey(name: 'CategoryId')
  final String? categoryId;
  @JsonKey(name: 'VendorId')
  final String? vendorId;
  @JsonKey(name: 'Vendor')
  final String? vendor;
  @JsonKey(name: 'VendorColor')
  final String? vendorColor;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'PrimaryOrderItemId')
  final String? primaryOrderItemId;
  @JsonKey(name: 'ItemClass')
  final String? itemClass;
  @JsonKey(name: 'ItemOrder')
  final String? itemOrder;
  @JsonKey(name: 'OrderBy')
  final String? orderBy;
  @JsonKey(name: 'Notes')
  final String? notes;
  @JsonKey(name: 'OrderType')
  final String? orderType;
  @JsonKey(name: 'RecType')
  final String? recType;
  @JsonKey(name: 'RecTypeDisplay')
  final String? recTypeDisplay;
  @JsonKey(name: 'OptionColor')
  final String? optionColor;
  @JsonKey(name: 'UsersId')
  final String? usersId;
  @JsonKey(name: 'UserName')
  final String? userName;
  @JsonKey(name: 'TransactionDateTime')
  final String? transactionDateTime;
  @JsonKey(name: 'ParentId')
  final String? parentId;
  @JsonKey(name: 'AccessoryRatio')
  final double? accessoryRatio;
  @JsonKey(name: 'NestedOrderItemId')
  final String? nestedOrderItemId;
  @JsonKey(name: 'ContainerItemId')
  final String? containerItemId;
  @JsonKey(name: 'ContainerBarCode')
  final String? containerBarCode;
  @JsonKey(name: 'IsConsignment')
  final bool? isConsignment;
  @JsonKey(name: 'ConsignorId')
  final String? consignorId;
  @JsonKey(name: 'ConsignorAgreementId')
  final String? consignorAgreementId;
  @JsonKey(name: 'IsVoid')
  final bool? isVoid;
  @JsonKey(name: 'NestingLevel')
  final int? nestingLevel;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsContractItemDetailContractItemDetailFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsContractItemDetailContractItemDetailToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsContractItemDetailContractItemDetailToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsContractItemDetailContractItemDetail &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderItemId, orderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.orderItemId, orderItemId)) &&
            (identical(other.orderNumber, orderNumber) ||
                const DeepCollectionEquality()
                    .equals(other.orderNumber, orderNumber)) &&
            (identical(other.orderDescription, orderDescription) ||
                const DeepCollectionEquality()
                    .equals(other.orderDescription, orderDescription)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.iCodeDisplay, iCodeDisplay) ||
                const DeepCollectionEquality()
                    .equals(other.iCodeDisplay, iCodeDisplay)) &&
            (identical(other.iCodeColor, iCodeColor) ||
                const DeepCollectionEquality()
                    .equals(other.iCodeColor, iCodeColor)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.descriptionColor, descriptionColor) ||
                const DeepCollectionEquality()
                    .equals(other.descriptionColor, descriptionColor)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)) &&
            (identical(other.barCode, barCode) ||
                const DeepCollectionEquality()
                    .equals(other.barCode, barCode)) &&
            (identical(other.manufacturerPartNumber, manufacturerPartNumber) ||
                const DeepCollectionEquality().equals(
                    other.manufacturerPartNumber, manufacturerPartNumber)) &&
            (identical(other.trackedBy, trackedBy) ||
                const DeepCollectionEquality()
                    .equals(other.trackedBy, trackedBy)) &&
            (identical(other.categoryId, categoryId) ||
                const DeepCollectionEquality()
                    .equals(other.categoryId, categoryId)) &&
            (identical(other.vendorId, vendorId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorId, vendorId)) &&
            (identical(other.vendor, vendor) || const DeepCollectionEquality().equals(other.vendor, vendor)) &&
            (identical(other.vendorColor, vendorColor) || const DeepCollectionEquality().equals(other.vendorColor, vendorColor)) &&
            (identical(other.inventoryId, inventoryId) || const DeepCollectionEquality().equals(other.inventoryId, inventoryId)) &&
            (identical(other.warehouseId, warehouseId) || const DeepCollectionEquality().equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouseCode, warehouseCode) || const DeepCollectionEquality().equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.warehouse, warehouse) || const DeepCollectionEquality().equals(other.warehouse, warehouse)) &&
            (identical(other.primaryOrderItemId, primaryOrderItemId) || const DeepCollectionEquality().equals(other.primaryOrderItemId, primaryOrderItemId)) &&
            (identical(other.itemClass, itemClass) || const DeepCollectionEquality().equals(other.itemClass, itemClass)) &&
            (identical(other.itemOrder, itemOrder) || const DeepCollectionEquality().equals(other.itemOrder, itemOrder)) &&
            (identical(other.orderBy, orderBy) || const DeepCollectionEquality().equals(other.orderBy, orderBy)) &&
            (identical(other.notes, notes) || const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.orderType, orderType) || const DeepCollectionEquality().equals(other.orderType, orderType)) &&
            (identical(other.recType, recType) || const DeepCollectionEquality().equals(other.recType, recType)) &&
            (identical(other.recTypeDisplay, recTypeDisplay) || const DeepCollectionEquality().equals(other.recTypeDisplay, recTypeDisplay)) &&
            (identical(other.optionColor, optionColor) || const DeepCollectionEquality().equals(other.optionColor, optionColor)) &&
            (identical(other.usersId, usersId) || const DeepCollectionEquality().equals(other.usersId, usersId)) &&
            (identical(other.userName, userName) || const DeepCollectionEquality().equals(other.userName, userName)) &&
            (identical(other.transactionDateTime, transactionDateTime) || const DeepCollectionEquality().equals(other.transactionDateTime, transactionDateTime)) &&
            (identical(other.parentId, parentId) || const DeepCollectionEquality().equals(other.parentId, parentId)) &&
            (identical(other.accessoryRatio, accessoryRatio) || const DeepCollectionEquality().equals(other.accessoryRatio, accessoryRatio)) &&
            (identical(other.nestedOrderItemId, nestedOrderItemId) || const DeepCollectionEquality().equals(other.nestedOrderItemId, nestedOrderItemId)) &&
            (identical(other.containerItemId, containerItemId) || const DeepCollectionEquality().equals(other.containerItemId, containerItemId)) &&
            (identical(other.containerBarCode, containerBarCode) || const DeepCollectionEquality().equals(other.containerBarCode, containerBarCode)) &&
            (identical(other.isConsignment, isConsignment) || const DeepCollectionEquality().equals(other.isConsignment, isConsignment)) &&
            (identical(other.consignorId, consignorId) || const DeepCollectionEquality().equals(other.consignorId, consignorId)) &&
            (identical(other.consignorAgreementId, consignorAgreementId) || const DeepCollectionEquality().equals(other.consignorAgreementId, consignorAgreementId)) &&
            (identical(other.isVoid, isVoid) || const DeepCollectionEquality().equals(other.isVoid, isVoid)) &&
            (identical(other.nestingLevel, nestingLevel) || const DeepCollectionEquality().equals(other.nestingLevel, nestingLevel)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsContractItemDetailContractItemDetailExtension
    on WebApiModulesHomeControlsContractItemDetailContractItemDetail {
  WebApiModulesHomeControlsContractItemDetailContractItemDetail copyWith(
      {String? contractId,
      String? orderId,
      String? orderItemId,
      String? orderNumber,
      String? orderDescription,
      String? iCode,
      String? iCodeDisplay,
      String? iCodeColor,
      String? description,
      String? descriptionColor,
      double? quantity,
      String? barCode,
      String? manufacturerPartNumber,
      String? trackedBy,
      String? categoryId,
      String? vendorId,
      String? vendor,
      String? vendorColor,
      String? inventoryId,
      String? warehouseId,
      String? warehouseCode,
      String? warehouse,
      String? primaryOrderItemId,
      String? itemClass,
      String? itemOrder,
      String? orderBy,
      String? notes,
      String? orderType,
      String? recType,
      String? recTypeDisplay,
      String? optionColor,
      String? usersId,
      String? userName,
      String? transactionDateTime,
      String? parentId,
      double? accessoryRatio,
      String? nestedOrderItemId,
      String? containerItemId,
      String? containerBarCode,
      bool? isConsignment,
      String? consignorId,
      String? consignorAgreementId,
      bool? isVoid,
      int? nestingLevel,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsContractItemDetailContractItemDetail(
        contractId: contractId ?? this.contractId,
        orderId: orderId ?? this.orderId,
        orderItemId: orderItemId ?? this.orderItemId,
        orderNumber: orderNumber ?? this.orderNumber,
        orderDescription: orderDescription ?? this.orderDescription,
        iCode: iCode ?? this.iCode,
        iCodeDisplay: iCodeDisplay ?? this.iCodeDisplay,
        iCodeColor: iCodeColor ?? this.iCodeColor,
        description: description ?? this.description,
        descriptionColor: descriptionColor ?? this.descriptionColor,
        quantity: quantity ?? this.quantity,
        barCode: barCode ?? this.barCode,
        manufacturerPartNumber:
            manufacturerPartNumber ?? this.manufacturerPartNumber,
        trackedBy: trackedBy ?? this.trackedBy,
        categoryId: categoryId ?? this.categoryId,
        vendorId: vendorId ?? this.vendorId,
        vendor: vendor ?? this.vendor,
        vendorColor: vendorColor ?? this.vendorColor,
        inventoryId: inventoryId ?? this.inventoryId,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        warehouse: warehouse ?? this.warehouse,
        primaryOrderItemId: primaryOrderItemId ?? this.primaryOrderItemId,
        itemClass: itemClass ?? this.itemClass,
        itemOrder: itemOrder ?? this.itemOrder,
        orderBy: orderBy ?? this.orderBy,
        notes: notes ?? this.notes,
        orderType: orderType ?? this.orderType,
        recType: recType ?? this.recType,
        recTypeDisplay: recTypeDisplay ?? this.recTypeDisplay,
        optionColor: optionColor ?? this.optionColor,
        usersId: usersId ?? this.usersId,
        userName: userName ?? this.userName,
        transactionDateTime: transactionDateTime ?? this.transactionDateTime,
        parentId: parentId ?? this.parentId,
        accessoryRatio: accessoryRatio ?? this.accessoryRatio,
        nestedOrderItemId: nestedOrderItemId ?? this.nestedOrderItemId,
        containerItemId: containerItemId ?? this.containerItemId,
        containerBarCode: containerBarCode ?? this.containerBarCode,
        isConsignment: isConsignment ?? this.isConsignment,
        consignorId: consignorId ?? this.consignorId,
        consignorAgreementId: consignorAgreementId ?? this.consignorAgreementId,
        isVoid: isVoid ?? this.isVoid,
        nestingLevel: nestingLevel ?? this.nestingLevel,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsContractItemDetailVoidItemsRequest {
  WebApiModulesHomeControlsContractItemDetailVoidItemsRequest({
    this.contractId,
    this.items,
    this.reason,
    this.returnToInventory,
  });

  factory WebApiModulesHomeControlsContractItemDetailVoidItemsRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsContractItemDetailVoidItemsRequestFromJson(
          json);

  @JsonKey(name: 'ContractId')
  final String? contractId;
  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsContractItemDetailContractItem>[])
  final List<WebApiModulesHomeControlsContractItemDetailContractItem>? items;
  @JsonKey(name: 'Reason')
  final String? reason;
  @JsonKey(name: 'ReturnToInventory')
  final bool? returnToInventory;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsContractItemDetailVoidItemsRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsContractItemDetailVoidItemsRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsContractItemDetailVoidItemsRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsContractItemDetailVoidItemsRequest &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)) &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.reason, reason) ||
                const DeepCollectionEquality().equals(other.reason, reason)) &&
            (identical(other.returnToInventory, returnToInventory) ||
                const DeepCollectionEquality()
                    .equals(other.returnToInventory, returnToInventory)));
  }
}

extension $WebApiModulesHomeControlsContractItemDetailVoidItemsRequestExtension
    on WebApiModulesHomeControlsContractItemDetailVoidItemsRequest {
  WebApiModulesHomeControlsContractItemDetailVoidItemsRequest copyWith(
      {String? contractId,
      List<WebApiModulesHomeControlsContractItemDetailContractItem>? items,
      String? reason,
      bool? returnToInventory}) {
    return WebApiModulesHomeControlsContractItemDetailVoidItemsRequest(
        contractId: contractId ?? this.contractId,
        items: items ?? this.items,
        reason: reason ?? this.reason,
        returnToInventory: returnToInventory ?? this.returnToInventory);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsContractItemDetailVoidItemsResponse {
  WebApiModulesHomeControlsContractItemDetailVoidItemsResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesHomeControlsContractItemDetailVoidItemsResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsContractItemDetailVoidItemsResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsContractItemDetailVoidItemsResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsContractItemDetailVoidItemsResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsContractItemDetailVoidItemsResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsContractItemDetailVoidItemsResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesHomeControlsContractItemDetailVoidItemsResponseExtension
    on WebApiModulesHomeControlsContractItemDetailVoidItemsResponse {
  WebApiModulesHomeControlsContractItemDetailVoidItemsResponse copyWith(
      {int? status, bool? success, String? msg}) {
    return WebApiModulesHomeControlsContractItemDetailVoidItemsResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsCustomerNoteCustomerNote {
  WebApiModulesHomeControlsCustomerNoteCustomerNote({
    this.customerNoteId,
    this.customerId,
    this.noteDate,
    this.notesById,
    this.notesBy,
    this.description,
    this.notes,
    this.notify,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsCustomerNoteCustomerNote.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsCustomerNoteCustomerNoteFromJson(json);

  @JsonKey(name: 'CustomerNoteId')
  final String? customerNoteId;
  @JsonKey(name: 'CustomerId')
  final String? customerId;
  @JsonKey(name: 'NoteDate')
  final String? noteDate;
  @JsonKey(name: 'NotesById')
  final String? notesById;
  @JsonKey(name: 'NotesBy')
  final String? notesBy;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'Notes')
  final String? notes;
  @JsonKey(name: 'Notify')
  final bool? notify;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsCustomerNoteCustomerNoteFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsCustomerNoteCustomerNoteToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsCustomerNoteCustomerNoteToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsCustomerNoteCustomerNote &&
            (identical(other.customerNoteId, customerNoteId) ||
                const DeepCollectionEquality()
                    .equals(other.customerNoteId, customerNoteId)) &&
            (identical(other.customerId, customerId) ||
                const DeepCollectionEquality()
                    .equals(other.customerId, customerId)) &&
            (identical(other.noteDate, noteDate) ||
                const DeepCollectionEquality()
                    .equals(other.noteDate, noteDate)) &&
            (identical(other.notesById, notesById) ||
                const DeepCollectionEquality()
                    .equals(other.notesById, notesById)) &&
            (identical(other.notesBy, notesBy) ||
                const DeepCollectionEquality()
                    .equals(other.notesBy, notesBy)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.notify, notify) ||
                const DeepCollectionEquality().equals(other.notify, notify)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsCustomerNoteCustomerNoteExtension
    on WebApiModulesHomeControlsCustomerNoteCustomerNote {
  WebApiModulesHomeControlsCustomerNoteCustomerNote copyWith(
      {String? customerNoteId,
      String? customerId,
      String? noteDate,
      String? notesById,
      String? notesBy,
      String? description,
      String? notes,
      bool? notify,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsCustomerNoteCustomerNote(
        customerNoteId: customerNoteId ?? this.customerNoteId,
        customerId: customerId ?? this.customerId,
        noteDate: noteDate ?? this.noteDate,
        notesById: notesById ?? this.notesById,
        notesBy: notesBy ?? this.notesBy,
        description: description ?? this.description,
        notes: notes ?? this.notes,
        notify: notify ?? this.notify,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsDealNoteDealNote {
  WebApiModulesHomeControlsDealNoteDealNote({
    this.dealNoteId,
    this.dealId,
    this.noteDate,
    this.notesById,
    this.notesBy,
    this.description,
    this.notes,
    this.notify,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsDealNoteDealNote.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsDealNoteDealNoteFromJson(json);

  @JsonKey(name: 'DealNoteId')
  final String? dealNoteId;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'NoteDate')
  final String? noteDate;
  @JsonKey(name: 'NotesById')
  final String? notesById;
  @JsonKey(name: 'NotesBy')
  final String? notesBy;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'Notes')
  final String? notes;
  @JsonKey(name: 'Notify')
  final bool? notify;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsDealNoteDealNoteFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsDealNoteDealNoteToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsDealNoteDealNoteToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsDealNoteDealNote &&
            (identical(other.dealNoteId, dealNoteId) ||
                const DeepCollectionEquality()
                    .equals(other.dealNoteId, dealNoteId)) &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.noteDate, noteDate) ||
                const DeepCollectionEquality()
                    .equals(other.noteDate, noteDate)) &&
            (identical(other.notesById, notesById) ||
                const DeepCollectionEquality()
                    .equals(other.notesById, notesById)) &&
            (identical(other.notesBy, notesBy) ||
                const DeepCollectionEquality()
                    .equals(other.notesBy, notesBy)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.notify, notify) ||
                const DeepCollectionEquality().equals(other.notify, notify)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsDealNoteDealNoteExtension
    on WebApiModulesHomeControlsDealNoteDealNote {
  WebApiModulesHomeControlsDealNoteDealNote copyWith(
      {String? dealNoteId,
      String? dealId,
      String? noteDate,
      String? notesById,
      String? notesBy,
      String? description,
      String? notes,
      bool? notify,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsDealNoteDealNote(
        dealNoteId: dealNoteId ?? this.dealNoteId,
        dealId: dealId ?? this.dealId,
        noteDate: noteDate ?? this.noteDate,
        notesById: notesById ?? this.notesById,
        notesBy: notesBy ?? this.notesBy,
        description: description ?? this.description,
        notes: notes ?? this.notes,
        notify: notify ?? this.notify,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsDealOrderDealOrderRecordOrderOnHoldResponse {
  WebApiModulesHomeControlsDealOrderDealOrderRecordOrderOnHoldResponse({
    this.status,
    this.success,
    this.msg,
    this.order,
  });

  factory WebApiModulesHomeControlsDealOrderDealOrderRecordOrderOnHoldResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsDealOrderDealOrderRecordOrderOnHoldResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'order')
  final WebApiModulesAgentOrderOrder? order;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsDealOrderDealOrderRecordOrderOnHoldResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsDealOrderDealOrderRecordOrderOnHoldResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsDealOrderDealOrderRecordOrderOnHoldResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsDealOrderDealOrderRecordOrderOnHoldResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.order, order) ||
                const DeepCollectionEquality().equals(other.order, order)));
  }
}

extension $WebApiModulesHomeControlsDealOrderDealOrderRecordOrderOnHoldResponseExtension
    on WebApiModulesHomeControlsDealOrderDealOrderRecordOrderOnHoldResponse {
  WebApiModulesHomeControlsDealOrderDealOrderRecordOrderOnHoldResponse copyWith(
      {int? status,
      bool? success,
      String? msg,
      WebApiModulesAgentOrderOrder? order}) {
    return WebApiModulesHomeControlsDealOrderDealOrderRecordOrderOnHoldResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        order: order ?? this.order);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsDealShipperDealShipper {
  WebApiModulesHomeControlsDealShipperDealShipper({
    this.dealShipperId,
    this.dealId,
    this.vendorId,
    this.carrierId,
    this.carrier,
    this.shipperAcct,
    this.isPrimary,
    this.shipViaId,
    this.shipVia,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsDealShipperDealShipper.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsDealShipperDealShipperFromJson(json);

  @JsonKey(name: 'DealShipperId')
  final String? dealShipperId;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'VendorId')
  final String? vendorId;
  @JsonKey(name: 'CarrierId')
  final String? carrierId;
  @JsonKey(name: 'Carrier')
  final String? carrier;
  @JsonKey(name: 'ShipperAcct')
  final String? shipperAcct;
  @JsonKey(name: 'IsPrimary')
  final bool? isPrimary;
  @JsonKey(name: 'ShipViaId')
  final String? shipViaId;
  @JsonKey(name: 'ShipVia')
  final String? shipVia;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsDealShipperDealShipperFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsDealShipperDealShipperToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsDealShipperDealShipperToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsDealShipperDealShipper &&
            (identical(other.dealShipperId, dealShipperId) ||
                const DeepCollectionEquality()
                    .equals(other.dealShipperId, dealShipperId)) &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.vendorId, vendorId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorId, vendorId)) &&
            (identical(other.carrierId, carrierId) ||
                const DeepCollectionEquality()
                    .equals(other.carrierId, carrierId)) &&
            (identical(other.carrier, carrier) ||
                const DeepCollectionEquality()
                    .equals(other.carrier, carrier)) &&
            (identical(other.shipperAcct, shipperAcct) ||
                const DeepCollectionEquality()
                    .equals(other.shipperAcct, shipperAcct)) &&
            (identical(other.isPrimary, isPrimary) ||
                const DeepCollectionEquality()
                    .equals(other.isPrimary, isPrimary)) &&
            (identical(other.shipViaId, shipViaId) ||
                const DeepCollectionEquality()
                    .equals(other.shipViaId, shipViaId)) &&
            (identical(other.shipVia, shipVia) ||
                const DeepCollectionEquality()
                    .equals(other.shipVia, shipVia)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsDealShipperDealShipperExtension
    on WebApiModulesHomeControlsDealShipperDealShipper {
  WebApiModulesHomeControlsDealShipperDealShipper copyWith(
      {String? dealShipperId,
      String? dealId,
      String? vendorId,
      String? carrierId,
      String? carrier,
      String? shipperAcct,
      bool? isPrimary,
      String? shipViaId,
      String? shipVia,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsDealShipperDealShipper(
        dealShipperId: dealShipperId ?? this.dealShipperId,
        dealId: dealId ?? this.dealId,
        vendorId: vendorId ?? this.vendorId,
        carrierId: carrierId ?? this.carrierId,
        carrier: carrier ?? this.carrier,
        shipperAcct: shipperAcct ?? this.shipperAcct,
        isPrimary: isPrimary ?? this.isPrimary,
        shipViaId: shipViaId ?? this.shipViaId,
        shipVia: shipVia ?? this.shipVia,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsDeliveryDelivery {
  WebApiModulesHomeControlsDeliveryDelivery({
    this.deliveryId,
    this.orderId,
    this.deliveryType,
    this.requiredDate,
    this.requiredTime,
    this.targetShipDate,
    this.targetShipTime,
    this.direction,
    this.addressType,
    this.fromLocation,
    this.fromContact,
    this.fromContactPhone,
    this.fromAlternateContact,
    this.fromAlternateContactPhone,
    this.fromAttention,
    this.fromAddress1,
    this.fromAdd2ress,
    this.fromCity,
    this.fromState,
    this.fromZipCode,
    this.fromCountry,
    this.fromCountryId,
    this.fromCrossStreets,
    this.toLocation,
    this.toContact,
    this.toContactPhone,
    this.toAlternateContact,
    this.toAlternateContactPhone,
    this.toAttention,
    this.toAddress1,
    this.toAddress2,
    this.toCity,
    this.toState,
    this.toZipCode,
    this.toCountryId,
    this.toCountry,
    this.toContactFax,
    this.toCrossStreets,
    this.deliveryNotes,
    this.carrierId,
    this.carrier,
    this.carrierAccount,
    this.shipViaId,
    this.shipVia,
    this.invoiceId,
    this.vendorInvoiceId,
    this.estimatedFreight,
    this.freightInvoiceAmount,
    this.chargeType,
    this.freightTrackingNumber,
    this.dropShip,
    this.packageCode,
    this.billPoFreightOnOrder,
    this.onlineOrderNumber,
    this.onlineOrderStatus,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsDeliveryDelivery.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsDeliveryDeliveryFromJson(json);

  @JsonKey(name: 'DeliveryId')
  final String? deliveryId;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'DeliveryType')
  final String? deliveryType;
  @JsonKey(name: 'RequiredDate')
  final String? requiredDate;
  @JsonKey(name: 'RequiredTime')
  final String? requiredTime;
  @JsonKey(name: 'TargetShipDate')
  final String? targetShipDate;
  @JsonKey(name: 'TargetShipTime')
  final String? targetShipTime;
  @JsonKey(name: 'Direction')
  final String? direction;
  @JsonKey(name: 'AddressType')
  final String? addressType;
  @JsonKey(name: 'FromLocation')
  final String? fromLocation;
  @JsonKey(name: 'FromContact')
  final String? fromContact;
  @JsonKey(name: 'FromContactPhone')
  final String? fromContactPhone;
  @JsonKey(name: 'FromAlternateContact')
  final String? fromAlternateContact;
  @JsonKey(name: 'FromAlternateContactPhone')
  final String? fromAlternateContactPhone;
  @JsonKey(name: 'FromAttention')
  final String? fromAttention;
  @JsonKey(name: 'FromAddress1')
  final String? fromAddress1;
  @JsonKey(name: 'FromAdd2ress')
  final String? fromAdd2ress;
  @JsonKey(name: 'FromCity')
  final String? fromCity;
  @JsonKey(name: 'FromState')
  final String? fromState;
  @JsonKey(name: 'FromZipCode')
  final String? fromZipCode;
  @JsonKey(name: 'FromCountry')
  final String? fromCountry;
  @JsonKey(name: 'FromCountryId')
  final String? fromCountryId;
  @JsonKey(name: 'FromCrossStreets')
  final String? fromCrossStreets;
  @JsonKey(name: 'ToLocation')
  final String? toLocation;
  @JsonKey(name: 'ToContact')
  final String? toContact;
  @JsonKey(name: 'ToContactPhone')
  final String? toContactPhone;
  @JsonKey(name: 'ToAlternateContact')
  final String? toAlternateContact;
  @JsonKey(name: 'ToAlternateContactPhone')
  final String? toAlternateContactPhone;
  @JsonKey(name: 'ToAttention')
  final String? toAttention;
  @JsonKey(name: 'ToAddress1')
  final String? toAddress1;
  @JsonKey(name: 'ToAddress2')
  final String? toAddress2;
  @JsonKey(name: 'ToCity')
  final String? toCity;
  @JsonKey(name: 'ToState')
  final String? toState;
  @JsonKey(name: 'ToZipCode')
  final String? toZipCode;
  @JsonKey(name: 'ToCountryId')
  final String? toCountryId;
  @JsonKey(name: 'ToCountry')
  final String? toCountry;
  @JsonKey(name: 'ToContactFax')
  final String? toContactFax;
  @JsonKey(name: 'ToCrossStreets')
  final String? toCrossStreets;
  @JsonKey(name: 'DeliveryNotes')
  final String? deliveryNotes;
  @JsonKey(name: 'CarrierId')
  final String? carrierId;
  @JsonKey(name: 'Carrier')
  final String? carrier;
  @JsonKey(name: 'CarrierAccount')
  final String? carrierAccount;
  @JsonKey(name: 'ShipViaId')
  final String? shipViaId;
  @JsonKey(name: 'ShipVia')
  final String? shipVia;
  @JsonKey(name: 'InvoiceId')
  final String? invoiceId;
  @JsonKey(name: 'VendorInvoiceId')
  final String? vendorInvoiceId;
  @JsonKey(name: 'EstimatedFreight')
  final double? estimatedFreight;
  @JsonKey(name: 'FreightInvoiceAmount')
  final double? freightInvoiceAmount;
  @JsonKey(name: 'ChargeType')
  final String? chargeType;
  @JsonKey(name: 'FreightTrackingNumber')
  final String? freightTrackingNumber;
  @JsonKey(name: 'DropShip')
  final bool? dropShip;
  @JsonKey(name: 'PackageCode')
  final String? packageCode;
  @JsonKey(name: 'BillPoFreightOnOrder')
  final bool? billPoFreightOnOrder;
  @JsonKey(name: 'OnlineOrderNumber')
  final String? onlineOrderNumber;
  @JsonKey(name: 'OnlineOrderStatus')
  final String? onlineOrderStatus;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsDeliveryDeliveryFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsDeliveryDeliveryToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsDeliveryDeliveryToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsDeliveryDelivery &&
            (identical(other.deliveryId, deliveryId) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryId, deliveryId)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.deliveryType, deliveryType) ||
                const DeepCollectionEquality()
                    .equals(other.deliveryType, deliveryType)) &&
            (identical(other.requiredDate, requiredDate) ||
                const DeepCollectionEquality()
                    .equals(other.requiredDate, requiredDate)) &&
            (identical(other.requiredTime, requiredTime) ||
                const DeepCollectionEquality()
                    .equals(other.requiredTime, requiredTime)) &&
            (identical(other.targetShipDate, targetShipDate) ||
                const DeepCollectionEquality()
                    .equals(other.targetShipDate, targetShipDate)) &&
            (identical(other.targetShipTime, targetShipTime) ||
                const DeepCollectionEquality()
                    .equals(other.targetShipTime, targetShipTime)) &&
            (identical(other.direction, direction) ||
                const DeepCollectionEquality()
                    .equals(other.direction, direction)) &&
            (identical(other.addressType, addressType) ||
                const DeepCollectionEquality()
                    .equals(other.addressType, addressType)) &&
            (identical(other.fromLocation, fromLocation) ||
                const DeepCollectionEquality()
                    .equals(other.fromLocation, fromLocation)) &&
            (identical(other.fromContact, fromContact) ||
                const DeepCollectionEquality()
                    .equals(other.fromContact, fromContact)) &&
            (identical(other.fromContactPhone, fromContactPhone) ||
                const DeepCollectionEquality()
                    .equals(other.fromContactPhone, fromContactPhone)) &&
            (identical(other.fromAlternateContact, fromAlternateContact) ||
                const DeepCollectionEquality().equals(
                    other.fromAlternateContact, fromAlternateContact)) &&
            (identical(other.fromAlternateContactPhone, fromAlternateContactPhone) ||
                const DeepCollectionEquality().equals(
                    other.fromAlternateContactPhone,
                    fromAlternateContactPhone)) &&
            (identical(other.fromAttention, fromAttention) ||
                const DeepCollectionEquality()
                    .equals(other.fromAttention, fromAttention)) &&
            (identical(other.fromAddress1, fromAddress1) ||
                const DeepCollectionEquality()
                    .equals(other.fromAddress1, fromAddress1)) &&
            (identical(other.fromAdd2ress, fromAdd2ress) ||
                const DeepCollectionEquality()
                    .equals(other.fromAdd2ress, fromAdd2ress)) &&
            (identical(other.fromCity, fromCity) ||
                const DeepCollectionEquality()
                    .equals(other.fromCity, fromCity)) &&
            (identical(other.fromState, fromState) ||
                const DeepCollectionEquality()
                    .equals(other.fromState, fromState)) &&
            (identical(other.fromZipCode, fromZipCode) ||
                const DeepCollectionEquality()
                    .equals(other.fromZipCode, fromZipCode)) &&
            (identical(other.fromCountry, fromCountry) || const DeepCollectionEquality().equals(other.fromCountry, fromCountry)) &&
            (identical(other.fromCountryId, fromCountryId) || const DeepCollectionEquality().equals(other.fromCountryId, fromCountryId)) &&
            (identical(other.fromCrossStreets, fromCrossStreets) || const DeepCollectionEquality().equals(other.fromCrossStreets, fromCrossStreets)) &&
            (identical(other.toLocation, toLocation) || const DeepCollectionEquality().equals(other.toLocation, toLocation)) &&
            (identical(other.toContact, toContact) || const DeepCollectionEquality().equals(other.toContact, toContact)) &&
            (identical(other.toContactPhone, toContactPhone) || const DeepCollectionEquality().equals(other.toContactPhone, toContactPhone)) &&
            (identical(other.toAlternateContact, toAlternateContact) || const DeepCollectionEquality().equals(other.toAlternateContact, toAlternateContact)) &&
            (identical(other.toAlternateContactPhone, toAlternateContactPhone) || const DeepCollectionEquality().equals(other.toAlternateContactPhone, toAlternateContactPhone)) &&
            (identical(other.toAttention, toAttention) || const DeepCollectionEquality().equals(other.toAttention, toAttention)) &&
            (identical(other.toAddress1, toAddress1) || const DeepCollectionEquality().equals(other.toAddress1, toAddress1)) &&
            (identical(other.toAddress2, toAddress2) || const DeepCollectionEquality().equals(other.toAddress2, toAddress2)) &&
            (identical(other.toCity, toCity) || const DeepCollectionEquality().equals(other.toCity, toCity)) &&
            (identical(other.toState, toState) || const DeepCollectionEquality().equals(other.toState, toState)) &&
            (identical(other.toZipCode, toZipCode) || const DeepCollectionEquality().equals(other.toZipCode, toZipCode)) &&
            (identical(other.toCountryId, toCountryId) || const DeepCollectionEquality().equals(other.toCountryId, toCountryId)) &&
            (identical(other.toCountry, toCountry) || const DeepCollectionEquality().equals(other.toCountry, toCountry)) &&
            (identical(other.toContactFax, toContactFax) || const DeepCollectionEquality().equals(other.toContactFax, toContactFax)) &&
            (identical(other.toCrossStreets, toCrossStreets) || const DeepCollectionEquality().equals(other.toCrossStreets, toCrossStreets)) &&
            (identical(other.deliveryNotes, deliveryNotes) || const DeepCollectionEquality().equals(other.deliveryNotes, deliveryNotes)) &&
            (identical(other.carrierId, carrierId) || const DeepCollectionEquality().equals(other.carrierId, carrierId)) &&
            (identical(other.carrier, carrier) || const DeepCollectionEquality().equals(other.carrier, carrier)) &&
            (identical(other.carrierAccount, carrierAccount) || const DeepCollectionEquality().equals(other.carrierAccount, carrierAccount)) &&
            (identical(other.shipViaId, shipViaId) || const DeepCollectionEquality().equals(other.shipViaId, shipViaId)) &&
            (identical(other.shipVia, shipVia) || const DeepCollectionEquality().equals(other.shipVia, shipVia)) &&
            (identical(other.invoiceId, invoiceId) || const DeepCollectionEquality().equals(other.invoiceId, invoiceId)) &&
            (identical(other.vendorInvoiceId, vendorInvoiceId) || const DeepCollectionEquality().equals(other.vendorInvoiceId, vendorInvoiceId)) &&
            (identical(other.estimatedFreight, estimatedFreight) || const DeepCollectionEquality().equals(other.estimatedFreight, estimatedFreight)) &&
            (identical(other.freightInvoiceAmount, freightInvoiceAmount) || const DeepCollectionEquality().equals(other.freightInvoiceAmount, freightInvoiceAmount)) &&
            (identical(other.chargeType, chargeType) || const DeepCollectionEquality().equals(other.chargeType, chargeType)) &&
            (identical(other.freightTrackingNumber, freightTrackingNumber) || const DeepCollectionEquality().equals(other.freightTrackingNumber, freightTrackingNumber)) &&
            (identical(other.dropShip, dropShip) || const DeepCollectionEquality().equals(other.dropShip, dropShip)) &&
            (identical(other.packageCode, packageCode) || const DeepCollectionEquality().equals(other.packageCode, packageCode)) &&
            (identical(other.billPoFreightOnOrder, billPoFreightOnOrder) || const DeepCollectionEquality().equals(other.billPoFreightOnOrder, billPoFreightOnOrder)) &&
            (identical(other.onlineOrderNumber, onlineOrderNumber) || const DeepCollectionEquality().equals(other.onlineOrderNumber, onlineOrderNumber)) &&
            (identical(other.onlineOrderStatus, onlineOrderStatus) || const DeepCollectionEquality().equals(other.onlineOrderStatus, onlineOrderStatus)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsDeliveryDeliveryExtension
    on WebApiModulesHomeControlsDeliveryDelivery {
  WebApiModulesHomeControlsDeliveryDelivery copyWith(
      {String? deliveryId,
      String? orderId,
      String? deliveryType,
      String? requiredDate,
      String? requiredTime,
      String? targetShipDate,
      String? targetShipTime,
      String? direction,
      String? addressType,
      String? fromLocation,
      String? fromContact,
      String? fromContactPhone,
      String? fromAlternateContact,
      String? fromAlternateContactPhone,
      String? fromAttention,
      String? fromAddress1,
      String? fromAdd2ress,
      String? fromCity,
      String? fromState,
      String? fromZipCode,
      String? fromCountry,
      String? fromCountryId,
      String? fromCrossStreets,
      String? toLocation,
      String? toContact,
      String? toContactPhone,
      String? toAlternateContact,
      String? toAlternateContactPhone,
      String? toAttention,
      String? toAddress1,
      String? toAddress2,
      String? toCity,
      String? toState,
      String? toZipCode,
      String? toCountryId,
      String? toCountry,
      String? toContactFax,
      String? toCrossStreets,
      String? deliveryNotes,
      String? carrierId,
      String? carrier,
      String? carrierAccount,
      String? shipViaId,
      String? shipVia,
      String? invoiceId,
      String? vendorInvoiceId,
      double? estimatedFreight,
      double? freightInvoiceAmount,
      String? chargeType,
      String? freightTrackingNumber,
      bool? dropShip,
      String? packageCode,
      bool? billPoFreightOnOrder,
      String? onlineOrderNumber,
      String? onlineOrderStatus,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsDeliveryDelivery(
        deliveryId: deliveryId ?? this.deliveryId,
        orderId: orderId ?? this.orderId,
        deliveryType: deliveryType ?? this.deliveryType,
        requiredDate: requiredDate ?? this.requiredDate,
        requiredTime: requiredTime ?? this.requiredTime,
        targetShipDate: targetShipDate ?? this.targetShipDate,
        targetShipTime: targetShipTime ?? this.targetShipTime,
        direction: direction ?? this.direction,
        addressType: addressType ?? this.addressType,
        fromLocation: fromLocation ?? this.fromLocation,
        fromContact: fromContact ?? this.fromContact,
        fromContactPhone: fromContactPhone ?? this.fromContactPhone,
        fromAlternateContact: fromAlternateContact ?? this.fromAlternateContact,
        fromAlternateContactPhone:
            fromAlternateContactPhone ?? this.fromAlternateContactPhone,
        fromAttention: fromAttention ?? this.fromAttention,
        fromAddress1: fromAddress1 ?? this.fromAddress1,
        fromAdd2ress: fromAdd2ress ?? this.fromAdd2ress,
        fromCity: fromCity ?? this.fromCity,
        fromState: fromState ?? this.fromState,
        fromZipCode: fromZipCode ?? this.fromZipCode,
        fromCountry: fromCountry ?? this.fromCountry,
        fromCountryId: fromCountryId ?? this.fromCountryId,
        fromCrossStreets: fromCrossStreets ?? this.fromCrossStreets,
        toLocation: toLocation ?? this.toLocation,
        toContact: toContact ?? this.toContact,
        toContactPhone: toContactPhone ?? this.toContactPhone,
        toAlternateContact: toAlternateContact ?? this.toAlternateContact,
        toAlternateContactPhone:
            toAlternateContactPhone ?? this.toAlternateContactPhone,
        toAttention: toAttention ?? this.toAttention,
        toAddress1: toAddress1 ?? this.toAddress1,
        toAddress2: toAddress2 ?? this.toAddress2,
        toCity: toCity ?? this.toCity,
        toState: toState ?? this.toState,
        toZipCode: toZipCode ?? this.toZipCode,
        toCountryId: toCountryId ?? this.toCountryId,
        toCountry: toCountry ?? this.toCountry,
        toContactFax: toContactFax ?? this.toContactFax,
        toCrossStreets: toCrossStreets ?? this.toCrossStreets,
        deliveryNotes: deliveryNotes ?? this.deliveryNotes,
        carrierId: carrierId ?? this.carrierId,
        carrier: carrier ?? this.carrier,
        carrierAccount: carrierAccount ?? this.carrierAccount,
        shipViaId: shipViaId ?? this.shipViaId,
        shipVia: shipVia ?? this.shipVia,
        invoiceId: invoiceId ?? this.invoiceId,
        vendorInvoiceId: vendorInvoiceId ?? this.vendorInvoiceId,
        estimatedFreight: estimatedFreight ?? this.estimatedFreight,
        freightInvoiceAmount: freightInvoiceAmount ?? this.freightInvoiceAmount,
        chargeType: chargeType ?? this.chargeType,
        freightTrackingNumber:
            freightTrackingNumber ?? this.freightTrackingNumber,
        dropShip: dropShip ?? this.dropShip,
        packageCode: packageCode ?? this.packageCode,
        billPoFreightOnOrder: billPoFreightOnOrder ?? this.billPoFreightOnOrder,
        onlineOrderNumber: onlineOrderNumber ?? this.onlineOrderNumber,
        onlineOrderStatus: onlineOrderStatus ?? this.onlineOrderStatus,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsDepositPaymentDepositPayment {
  WebApiModulesHomeControlsDepositPaymentDepositPayment({
    this.id,
    this.depositId,
    this.paymentId,
    this.applied,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsDepositPaymentDepositPayment.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsDepositPaymentDepositPaymentFromJson(json);

  @JsonKey(name: 'Id')
  final int? id;
  @JsonKey(name: 'DepositId')
  final String? depositId;
  @JsonKey(name: 'PaymentId')
  final String? paymentId;
  @JsonKey(name: 'Applied')
  final double? applied;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsDepositPaymentDepositPaymentFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsDepositPaymentDepositPaymentToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsDepositPaymentDepositPaymentToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsDepositPaymentDepositPayment &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.depositId, depositId) ||
                const DeepCollectionEquality()
                    .equals(other.depositId, depositId)) &&
            (identical(other.paymentId, paymentId) ||
                const DeepCollectionEquality()
                    .equals(other.paymentId, paymentId)) &&
            (identical(other.applied, applied) ||
                const DeepCollectionEquality()
                    .equals(other.applied, applied)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsDepositPaymentDepositPaymentExtension
    on WebApiModulesHomeControlsDepositPaymentDepositPayment {
  WebApiModulesHomeControlsDepositPaymentDepositPayment copyWith(
      {int? id,
      String? depositId,
      String? paymentId,
      double? applied,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsDepositPaymentDepositPayment(
        id: id ?? this.id,
        depositId: depositId ?? this.depositId,
        paymentId: paymentId ?? this.paymentId,
        applied: applied ?? this.applied,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsDepreciationDepreciation {
  WebApiModulesHomeControlsDepreciationDepreciation({
    this.depreciationId,
    this.depreciationDate,
    this.purchaseId,
    this.warehouseId,
    this.warehouse,
    this.warehouseCode,
    this.purchaseDate,
    this.receiveDate,
    this.purchaseWarehouseId,
    this.purchaseWarehouseCode,
    this.purchaseWarehouse,
    this.debitGlAccountId,
    this.debitGlAccountNo,
    this.debitGlAccountDescription,
    this.creditGlAccountId,
    this.creditGlAccountNo,
    this.creditGlAccountDescription,
    this.depreciationQuantity,
    this.unitDepreciationAmount,
    this.depreciationExtended,
    this.isAdjustment,
    this.depreciationExtendedColor,
    this.currencyId,
    this.currency,
    this.currencyCode,
    this.currencySymbol,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsDepreciationDepreciation.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsDepreciationDepreciationFromJson(json);

  @JsonKey(name: 'DepreciationId')
  final int? depreciationId;
  @JsonKey(name: 'DepreciationDate')
  final String? depreciationDate;
  @JsonKey(name: 'PurchaseId')
  final String? purchaseId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'PurchaseDate')
  final String? purchaseDate;
  @JsonKey(name: 'ReceiveDate')
  final String? receiveDate;
  @JsonKey(name: 'PurchaseWarehouseId')
  final String? purchaseWarehouseId;
  @JsonKey(name: 'PurchaseWarehouseCode')
  final String? purchaseWarehouseCode;
  @JsonKey(name: 'PurchaseWarehouse')
  final String? purchaseWarehouse;
  @JsonKey(name: 'DebitGlAccountId')
  final String? debitGlAccountId;
  @JsonKey(name: 'DebitGlAccountNo')
  final String? debitGlAccountNo;
  @JsonKey(name: 'DebitGlAccountDescription')
  final String? debitGlAccountDescription;
  @JsonKey(name: 'CreditGlAccountId')
  final String? creditGlAccountId;
  @JsonKey(name: 'CreditGlAccountNo')
  final String? creditGlAccountNo;
  @JsonKey(name: 'CreditGlAccountDescription')
  final String? creditGlAccountDescription;
  @JsonKey(name: 'DepreciationQuantity')
  final int? depreciationQuantity;
  @JsonKey(name: 'UnitDepreciationAmount')
  final double? unitDepreciationAmount;
  @JsonKey(name: 'DepreciationExtended')
  final double? depreciationExtended;
  @JsonKey(name: 'IsAdjustment')
  final bool? isAdjustment;
  @JsonKey(name: 'DepreciationExtendedColor')
  final String? depreciationExtendedColor;
  @JsonKey(name: 'CurrencyId')
  final String? currencyId;
  @JsonKey(name: 'Currency')
  final String? currency;
  @JsonKey(name: 'CurrencyCode')
  final String? currencyCode;
  @JsonKey(name: 'CurrencySymbol')
  final String? currencySymbol;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsDepreciationDepreciationFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsDepreciationDepreciationToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsDepreciationDepreciationToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsDepreciationDepreciation &&
            (identical(other.depreciationId, depreciationId) ||
                const DeepCollectionEquality()
                    .equals(other.depreciationId, depreciationId)) &&
            (identical(other.depreciationDate, depreciationDate) ||
                const DeepCollectionEquality()
                    .equals(other.depreciationDate, depreciationDate)) &&
            (identical(other.purchaseId, purchaseId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseId, purchaseId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouse, warehouse) ||
                const DeepCollectionEquality()
                    .equals(other.warehouse, warehouse)) &&
            (identical(other.warehouseCode, warehouseCode) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.purchaseDate, purchaseDate) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseDate, purchaseDate)) &&
            (identical(other.receiveDate, receiveDate) ||
                const DeepCollectionEquality()
                    .equals(other.receiveDate, receiveDate)) &&
            (identical(other.purchaseWarehouseId, purchaseWarehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseWarehouseId, purchaseWarehouseId)) &&
            (identical(other.purchaseWarehouseCode, purchaseWarehouseCode) ||
                const DeepCollectionEquality().equals(
                    other.purchaseWarehouseCode, purchaseWarehouseCode)) &&
            (identical(other.purchaseWarehouse, purchaseWarehouse) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseWarehouse, purchaseWarehouse)) &&
            (identical(other.debitGlAccountId, debitGlAccountId) ||
                const DeepCollectionEquality()
                    .equals(other.debitGlAccountId, debitGlAccountId)) &&
            (identical(other.debitGlAccountNo, debitGlAccountNo) ||
                const DeepCollectionEquality()
                    .equals(other.debitGlAccountNo, debitGlAccountNo)) &&
            (identical(other.debitGlAccountDescription, debitGlAccountDescription) ||
                const DeepCollectionEquality().equals(
                    other.debitGlAccountDescription,
                    debitGlAccountDescription)) &&
            (identical(other.creditGlAccountId, creditGlAccountId) ||
                const DeepCollectionEquality()
                    .equals(other.creditGlAccountId, creditGlAccountId)) &&
            (identical(other.creditGlAccountNo, creditGlAccountNo) ||
                const DeepCollectionEquality()
                    .equals(other.creditGlAccountNo, creditGlAccountNo)) &&
            (identical(other.creditGlAccountDescription, creditGlAccountDescription) ||
                const DeepCollectionEquality().equals(
                    other.creditGlAccountDescription,
                    creditGlAccountDescription)) &&
            (identical(other.depreciationQuantity, depreciationQuantity) ||
                const DeepCollectionEquality().equals(
                    other.depreciationQuantity, depreciationQuantity)) &&
            (identical(other.unitDepreciationAmount, unitDepreciationAmount) ||
                const DeepCollectionEquality().equals(
                    other.unitDepreciationAmount, unitDepreciationAmount)) &&
            (identical(other.depreciationExtended, depreciationExtended) || const DeepCollectionEquality().equals(other.depreciationExtended, depreciationExtended)) &&
            (identical(other.isAdjustment, isAdjustment) || const DeepCollectionEquality().equals(other.isAdjustment, isAdjustment)) &&
            (identical(other.depreciationExtendedColor, depreciationExtendedColor) || const DeepCollectionEquality().equals(other.depreciationExtendedColor, depreciationExtendedColor)) &&
            (identical(other.currencyId, currencyId) || const DeepCollectionEquality().equals(other.currencyId, currencyId)) &&
            (identical(other.currency, currency) || const DeepCollectionEquality().equals(other.currency, currency)) &&
            (identical(other.currencyCode, currencyCode) || const DeepCollectionEquality().equals(other.currencyCode, currencyCode)) &&
            (identical(other.currencySymbol, currencySymbol) || const DeepCollectionEquality().equals(other.currencySymbol, currencySymbol)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsDepreciationDepreciationExtension
    on WebApiModulesHomeControlsDepreciationDepreciation {
  WebApiModulesHomeControlsDepreciationDepreciation copyWith(
      {int? depreciationId,
      String? depreciationDate,
      String? purchaseId,
      String? warehouseId,
      String? warehouse,
      String? warehouseCode,
      String? purchaseDate,
      String? receiveDate,
      String? purchaseWarehouseId,
      String? purchaseWarehouseCode,
      String? purchaseWarehouse,
      String? debitGlAccountId,
      String? debitGlAccountNo,
      String? debitGlAccountDescription,
      String? creditGlAccountId,
      String? creditGlAccountNo,
      String? creditGlAccountDescription,
      int? depreciationQuantity,
      double? unitDepreciationAmount,
      double? depreciationExtended,
      bool? isAdjustment,
      String? depreciationExtendedColor,
      String? currencyId,
      String? currency,
      String? currencyCode,
      String? currencySymbol,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsDepreciationDepreciation(
        depreciationId: depreciationId ?? this.depreciationId,
        depreciationDate: depreciationDate ?? this.depreciationDate,
        purchaseId: purchaseId ?? this.purchaseId,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouse: warehouse ?? this.warehouse,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        purchaseDate: purchaseDate ?? this.purchaseDate,
        receiveDate: receiveDate ?? this.receiveDate,
        purchaseWarehouseId: purchaseWarehouseId ?? this.purchaseWarehouseId,
        purchaseWarehouseCode:
            purchaseWarehouseCode ?? this.purchaseWarehouseCode,
        purchaseWarehouse: purchaseWarehouse ?? this.purchaseWarehouse,
        debitGlAccountId: debitGlAccountId ?? this.debitGlAccountId,
        debitGlAccountNo: debitGlAccountNo ?? this.debitGlAccountNo,
        debitGlAccountDescription:
            debitGlAccountDescription ?? this.debitGlAccountDescription,
        creditGlAccountId: creditGlAccountId ?? this.creditGlAccountId,
        creditGlAccountNo: creditGlAccountNo ?? this.creditGlAccountNo,
        creditGlAccountDescription:
            creditGlAccountDescription ?? this.creditGlAccountDescription,
        depreciationQuantity: depreciationQuantity ?? this.depreciationQuantity,
        unitDepreciationAmount:
            unitDepreciationAmount ?? this.unitDepreciationAmount,
        depreciationExtended: depreciationExtended ?? this.depreciationExtended,
        isAdjustment: isAdjustment ?? this.isAdjustment,
        depreciationExtendedColor:
            depreciationExtendedColor ?? this.depreciationExtendedColor,
        currencyId: currencyId ?? this.currencyId,
        currency: currency ?? this.currency,
        currencyCode: currencyCode ?? this.currencyCode,
        currencySymbol: currencySymbol ?? this.currencySymbol,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsGeneralItemSortGeneralItemRequest {
  WebApiModulesHomeControlsGeneralItemSortGeneralItemRequest({
    this.startAtIndex,
    this.itemIds,
  });

  factory WebApiModulesHomeControlsGeneralItemSortGeneralItemRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsGeneralItemSortGeneralItemRequestFromJson(
          json);

  @JsonKey(name: 'StartAtIndex')
  final int? startAtIndex;
  @JsonKey(name: 'ItemIds', defaultValue: <String>[])
  final List<String>? itemIds;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsGeneralItemSortGeneralItemRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsGeneralItemSortGeneralItemRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsGeneralItemSortGeneralItemRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsGeneralItemSortGeneralItemRequest &&
            (identical(other.startAtIndex, startAtIndex) ||
                const DeepCollectionEquality()
                    .equals(other.startAtIndex, startAtIndex)) &&
            (identical(other.itemIds, itemIds) ||
                const DeepCollectionEquality().equals(other.itemIds, itemIds)));
  }
}

extension $WebApiModulesHomeControlsGeneralItemSortGeneralItemRequestExtension
    on WebApiModulesHomeControlsGeneralItemSortGeneralItemRequest {
  WebApiModulesHomeControlsGeneralItemSortGeneralItemRequest copyWith(
      {int? startAtIndex, List<String>? itemIds}) {
    return WebApiModulesHomeControlsGeneralItemSortGeneralItemRequest(
        startAtIndex: startAtIndex ?? this.startAtIndex,
        itemIds: itemIds ?? this.itemIds);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsGlManualGlManual {
  WebApiModulesHomeControlsGlManualGlManual({
    this.id,
    this.internalChar,
    this.officeLocationId,
    this.officeLocation,
    this.invoiceId,
    this.receiptId,
    this.vendorInvoiceId,
    this.paymentId,
    this.glDate,
    this.debitGlAccountId,
    this.debitGlAccountNumber,
    this.debitGlAccountDescription,
    this.creditGlAccountId,
    this.creditGlAccountNumber,
    this.creditGlAccountDescription,
    this.amount,
    this.groupHeading,
    this.currencyId,
    this.currencyCode,
    this.currency,
    this.currencySymbol,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsGlManualGlManual.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsGlManualGlManualFromJson(json);

  @JsonKey(name: 'Id')
  final int? id;
  @JsonKey(name: 'InternalChar')
  final String? internalChar;
  @JsonKey(name: 'OfficeLocationId')
  final String? officeLocationId;
  @JsonKey(name: 'OfficeLocation')
  final String? officeLocation;
  @JsonKey(name: 'InvoiceId')
  final String? invoiceId;
  @JsonKey(name: 'ReceiptId')
  final String? receiptId;
  @JsonKey(name: 'VendorInvoiceId')
  final String? vendorInvoiceId;
  @JsonKey(name: 'PaymentId')
  final String? paymentId;
  @JsonKey(name: 'GlDate')
  final String? glDate;
  @JsonKey(name: 'DebitGlAccountId')
  final String? debitGlAccountId;
  @JsonKey(name: 'DebitGlAccountNumber')
  final String? debitGlAccountNumber;
  @JsonKey(name: 'DebitGlAccountDescription')
  final String? debitGlAccountDescription;
  @JsonKey(name: 'CreditGlAccountId')
  final String? creditGlAccountId;
  @JsonKey(name: 'CreditGlAccountNumber')
  final String? creditGlAccountNumber;
  @JsonKey(name: 'CreditGlAccountDescription')
  final String? creditGlAccountDescription;
  @JsonKey(name: 'Amount')
  final double? amount;
  @JsonKey(name: 'GroupHeading')
  final String? groupHeading;
  @JsonKey(name: 'CurrencyId')
  final String? currencyId;
  @JsonKey(name: 'CurrencyCode')
  final String? currencyCode;
  @JsonKey(name: 'Currency')
  final String? currency;
  @JsonKey(name: 'CurrencySymbol')
  final String? currencySymbol;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsGlManualGlManualFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsGlManualGlManualToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsGlManualGlManualToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsGlManualGlManual &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.internalChar, internalChar) ||
                const DeepCollectionEquality()
                    .equals(other.internalChar, internalChar)) &&
            (identical(other.officeLocationId, officeLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocationId, officeLocationId)) &&
            (identical(other.officeLocation, officeLocation) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocation, officeLocation)) &&
            (identical(other.invoiceId, invoiceId) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceId, invoiceId)) &&
            (identical(other.receiptId, receiptId) ||
                const DeepCollectionEquality()
                    .equals(other.receiptId, receiptId)) &&
            (identical(other.vendorInvoiceId, vendorInvoiceId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorInvoiceId, vendorInvoiceId)) &&
            (identical(other.paymentId, paymentId) ||
                const DeepCollectionEquality()
                    .equals(other.paymentId, paymentId)) &&
            (identical(other.glDate, glDate) ||
                const DeepCollectionEquality().equals(other.glDate, glDate)) &&
            (identical(other.debitGlAccountId, debitGlAccountId) ||
                const DeepCollectionEquality()
                    .equals(other.debitGlAccountId, debitGlAccountId)) &&
            (identical(other.debitGlAccountNumber, debitGlAccountNumber) ||
                const DeepCollectionEquality().equals(
                    other.debitGlAccountNumber, debitGlAccountNumber)) &&
            (identical(other.debitGlAccountDescription, debitGlAccountDescription) ||
                const DeepCollectionEquality().equals(
                    other.debitGlAccountDescription,
                    debitGlAccountDescription)) &&
            (identical(other.creditGlAccountId, creditGlAccountId) ||
                const DeepCollectionEquality()
                    .equals(other.creditGlAccountId, creditGlAccountId)) &&
            (identical(other.creditGlAccountNumber, creditGlAccountNumber) ||
                const DeepCollectionEquality().equals(
                    other.creditGlAccountNumber, creditGlAccountNumber)) &&
            (identical(other.creditGlAccountDescription, creditGlAccountDescription) ||
                const DeepCollectionEquality().equals(
                    other.creditGlAccountDescription,
                    creditGlAccountDescription)) &&
            (identical(other.amount, amount) ||
                const DeepCollectionEquality().equals(other.amount, amount)) &&
            (identical(other.groupHeading, groupHeading) ||
                const DeepCollectionEquality()
                    .equals(other.groupHeading, groupHeading)) &&
            (identical(other.currencyId, currencyId) ||
                const DeepCollectionEquality()
                    .equals(other.currencyId, currencyId)) &&
            (identical(other.currencyCode, currencyCode) ||
                const DeepCollectionEquality()
                    .equals(other.currencyCode, currencyCode)) &&
            (identical(other.currency, currency) ||
                const DeepCollectionEquality().equals(other.currency, currency)) &&
            (identical(other.currencySymbol, currencySymbol) || const DeepCollectionEquality().equals(other.currencySymbol, currencySymbol)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsGlManualGlManualExtension
    on WebApiModulesHomeControlsGlManualGlManual {
  WebApiModulesHomeControlsGlManualGlManual copyWith(
      {int? id,
      String? internalChar,
      String? officeLocationId,
      String? officeLocation,
      String? invoiceId,
      String? receiptId,
      String? vendorInvoiceId,
      String? paymentId,
      String? glDate,
      String? debitGlAccountId,
      String? debitGlAccountNumber,
      String? debitGlAccountDescription,
      String? creditGlAccountId,
      String? creditGlAccountNumber,
      String? creditGlAccountDescription,
      double? amount,
      String? groupHeading,
      String? currencyId,
      String? currencyCode,
      String? currency,
      String? currencySymbol,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsGlManualGlManual(
        id: id ?? this.id,
        internalChar: internalChar ?? this.internalChar,
        officeLocationId: officeLocationId ?? this.officeLocationId,
        officeLocation: officeLocation ?? this.officeLocation,
        invoiceId: invoiceId ?? this.invoiceId,
        receiptId: receiptId ?? this.receiptId,
        vendorInvoiceId: vendorInvoiceId ?? this.vendorInvoiceId,
        paymentId: paymentId ?? this.paymentId,
        glDate: glDate ?? this.glDate,
        debitGlAccountId: debitGlAccountId ?? this.debitGlAccountId,
        debitGlAccountNumber: debitGlAccountNumber ?? this.debitGlAccountNumber,
        debitGlAccountDescription:
            debitGlAccountDescription ?? this.debitGlAccountDescription,
        creditGlAccountId: creditGlAccountId ?? this.creditGlAccountId,
        creditGlAccountNumber:
            creditGlAccountNumber ?? this.creditGlAccountNumber,
        creditGlAccountDescription:
            creditGlAccountDescription ?? this.creditGlAccountDescription,
        amount: amount ?? this.amount,
        groupHeading: groupHeading ?? this.groupHeading,
        currencyId: currencyId ?? this.currencyId,
        currencyCode: currencyCode ?? this.currencyCode,
        currency: currency ?? this.currency,
        currencySymbol: currencySymbol ?? this.currencySymbol,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValue {
  WebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValue({
    this.inventoryAttributeValueId,
    this.attributeId,
    this.inventoryId,
    this.attribute,
    this.attributeValueId,
    this.attributeValue,
    this.numericValue,
    this.numericOnly,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValue.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValueFromJson(
          json);

  @JsonKey(name: 'InventoryAttributeValueId')
  final String? inventoryAttributeValueId;
  @JsonKey(name: 'AttributeId')
  final String? attributeId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'Attribute')
  final String? attribute;
  @JsonKey(name: 'AttributeValueId')
  final String? attributeValueId;
  @JsonKey(name: 'AttributeValue')
  final String? attributeValue;
  @JsonKey(name: 'NumericValue')
  final double? numericValue;
  @JsonKey(name: 'NumericOnly')
  final bool? numericOnly;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValueFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValueToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValueToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValue &&
            (identical(other.inventoryAttributeValueId, inventoryAttributeValueId) ||
                const DeepCollectionEquality().equals(
                    other.inventoryAttributeValueId,
                    inventoryAttributeValueId)) &&
            (identical(other.attributeId, attributeId) ||
                const DeepCollectionEquality()
                    .equals(other.attributeId, attributeId)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.attribute, attribute) ||
                const DeepCollectionEquality()
                    .equals(other.attribute, attribute)) &&
            (identical(other.attributeValueId, attributeValueId) ||
                const DeepCollectionEquality()
                    .equals(other.attributeValueId, attributeValueId)) &&
            (identical(other.attributeValue, attributeValue) ||
                const DeepCollectionEquality()
                    .equals(other.attributeValue, attributeValue)) &&
            (identical(other.numericValue, numericValue) ||
                const DeepCollectionEquality()
                    .equals(other.numericValue, numericValue)) &&
            (identical(other.numericOnly, numericOnly) ||
                const DeepCollectionEquality()
                    .equals(other.numericOnly, numericOnly)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValueExtension
    on WebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValue {
  WebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValue
      copyWith(
          {String? inventoryAttributeValueId,
          String? attributeId,
          String? inventoryId,
          String? attribute,
          String? attributeValueId,
          String? attributeValue,
          double? numericValue,
          bool? numericOnly,
          String? dateStamp,
          String? recordTitle,
          List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
          List<FwStandardDataFwCustomValue>? custom,
          List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsInventoryAttributeValueInventoryAttributeValue(
        inventoryAttributeValueId:
            inventoryAttributeValueId ?? this.inventoryAttributeValueId,
        attributeId: attributeId ?? this.attributeId,
        inventoryId: inventoryId ?? this.inventoryId,
        attribute: attribute ?? this.attribute,
        attributeValueId: attributeValueId ?? this.attributeValueId,
        attributeValue: attributeValue ?? this.attributeValue,
        numericValue: numericValue ?? this.numericValue,
        numericOnly: numericOnly ?? this.numericOnly,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryAvailabilityAvailabilityCalendarAndScheduleRequest {
  WebApiModulesHomeControlsInventoryAvailabilityAvailabilityCalendarAndScheduleRequest({
    this.inventoryId,
    this.warehouseId,
    this.regionId,
    this.fromDate,
    this.toDate,
    this.includeHours,
    this.yearView,
    this.sortReservationsBy,
  });

  factory WebApiModulesHomeControlsInventoryAvailabilityAvailabilityCalendarAndScheduleRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryAvailabilityAvailabilityCalendarAndScheduleRequestFromJson(
          json);

  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'WarehouseId', defaultValue: <String>[])
  final List<String>? warehouseId;
  @JsonKey(name: 'RegionId')
  final String? regionId;
  @JsonKey(name: 'FromDate')
  final DateTime? fromDate;
  @JsonKey(name: 'ToDate')
  final DateTime? toDate;
  @JsonKey(name: 'IncludeHours')
  final bool? includeHours;
  @JsonKey(name: 'YearView')
  final bool? yearView;
  @JsonKey(name: 'SortReservationsBy')
  final String? sortReservationsBy;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityAvailabilityCalendarAndScheduleRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityAvailabilityCalendarAndScheduleRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryAvailabilityAvailabilityCalendarAndScheduleRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryAvailabilityAvailabilityCalendarAndScheduleRequest &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.regionId, regionId) ||
                const DeepCollectionEquality()
                    .equals(other.regionId, regionId)) &&
            (identical(other.fromDate, fromDate) ||
                const DeepCollectionEquality()
                    .equals(other.fromDate, fromDate)) &&
            (identical(other.toDate, toDate) ||
                const DeepCollectionEquality().equals(other.toDate, toDate)) &&
            (identical(other.includeHours, includeHours) ||
                const DeepCollectionEquality()
                    .equals(other.includeHours, includeHours)) &&
            (identical(other.yearView, yearView) ||
                const DeepCollectionEquality()
                    .equals(other.yearView, yearView)) &&
            (identical(other.sortReservationsBy, sortReservationsBy) ||
                const DeepCollectionEquality()
                    .equals(other.sortReservationsBy, sortReservationsBy)));
  }
}

extension $WebApiModulesHomeControlsInventoryAvailabilityAvailabilityCalendarAndScheduleRequestExtension
    on WebApiModulesHomeControlsInventoryAvailabilityAvailabilityCalendarAndScheduleRequest {
  WebApiModulesHomeControlsInventoryAvailabilityAvailabilityCalendarAndScheduleRequest
      copyWith(
          {String? inventoryId,
          List<String>? warehouseId,
          String? regionId,
          DateTime? fromDate,
          DateTime? toDate,
          bool? includeHours,
          bool? yearView,
          String? sortReservationsBy}) {
    return WebApiModulesHomeControlsInventoryAvailabilityAvailabilityCalendarAndScheduleRequest(
        inventoryId: inventoryId ?? this.inventoryId,
        warehouseId: warehouseId ?? this.warehouseId,
        regionId: regionId ?? this.regionId,
        fromDate: fromDate ?? this.fromDate,
        toDate: toDate ?? this.toDate,
        includeHours: includeHours ?? this.includeHours,
        yearView: yearView ?? this.yearView,
        sortReservationsBy: sortReservationsBy ?? this.sortReservationsBy);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictRequest {
  WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictRequest({
    this.toDate,
    this.availableFor,
    this.conflictType,
    this.warehouseId,
    this.inventoryTypeId,
    this.categoryId,
    this.subCategoryId,
    this.inventoryId,
    this.description,
    this.orderId,
    this.dealId,
    this.ranks,
    this.showRegionAvailability,
    this.showOtherWarehouseAvailability,
    this.otherWarehouseIds,
  });

  factory WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictRequestFromJson(
          json);

  @JsonKey(name: 'ToDate')
  final DateTime? toDate;
  @JsonKey(name: 'AvailableFor')
  final String? availableFor;
  @JsonKey(name: 'ConflictType')
  final String? conflictType;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'InventoryTypeId')
  final String? inventoryTypeId;
  @JsonKey(name: 'CategoryId')
  final String? categoryId;
  @JsonKey(name: 'SubCategoryId')
  final String? subCategoryId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(
      name: 'Ranks', defaultValue: <FwStandardModelsSelectedCheckBoxListItem>[])
  final List<FwStandardModelsSelectedCheckBoxListItem>? ranks;
  @JsonKey(name: 'ShowRegionAvailability')
  final bool? showRegionAvailability;
  @JsonKey(name: 'ShowOtherWarehouseAvailability')
  final bool? showOtherWarehouseAvailability;
  @JsonKey(name: 'OtherWarehouseIds')
  final String? otherWarehouseIds;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictRequest &&
            (identical(other.toDate, toDate) ||
                const DeepCollectionEquality().equals(other.toDate, toDate)) &&
            (identical(other.availableFor, availableFor) ||
                const DeepCollectionEquality()
                    .equals(other.availableFor, availableFor)) &&
            (identical(other.conflictType, conflictType) ||
                const DeepCollectionEquality()
                    .equals(other.conflictType, conflictType)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.inventoryTypeId, inventoryTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryTypeId, inventoryTypeId)) &&
            (identical(other.categoryId, categoryId) ||
                const DeepCollectionEquality()
                    .equals(other.categoryId, categoryId)) &&
            (identical(other.subCategoryId, subCategoryId) ||
                const DeepCollectionEquality()
                    .equals(other.subCategoryId, subCategoryId)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.ranks, ranks) ||
                const DeepCollectionEquality().equals(other.ranks, ranks)) &&
            (identical(other.showRegionAvailability, showRegionAvailability) ||
                const DeepCollectionEquality().equals(
                    other.showRegionAvailability, showRegionAvailability)) &&
            (identical(other.showOtherWarehouseAvailability,
                    showOtherWarehouseAvailability) ||
                const DeepCollectionEquality().equals(
                    other.showOtherWarehouseAvailability,
                    showOtherWarehouseAvailability)) &&
            (identical(other.otherWarehouseIds, otherWarehouseIds) ||
                const DeepCollectionEquality()
                    .equals(other.otherWarehouseIds, otherWarehouseIds)));
  }
}

extension $WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictRequestExtension
    on WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictRequest {
  WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictRequest
      copyWith(
          {DateTime? toDate,
          String? availableFor,
          String? conflictType,
          String? warehouseId,
          String? inventoryTypeId,
          String? categoryId,
          String? subCategoryId,
          String? inventoryId,
          String? description,
          String? orderId,
          String? dealId,
          List<FwStandardModelsSelectedCheckBoxListItem>? ranks,
          bool? showRegionAvailability,
          bool? showOtherWarehouseAvailability,
          String? otherWarehouseIds}) {
    return WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictRequest(
        toDate: toDate ?? this.toDate,
        availableFor: availableFor ?? this.availableFor,
        conflictType: conflictType ?? this.conflictType,
        warehouseId: warehouseId ?? this.warehouseId,
        inventoryTypeId: inventoryTypeId ?? this.inventoryTypeId,
        categoryId: categoryId ?? this.categoryId,
        subCategoryId: subCategoryId ?? this.subCategoryId,
        inventoryId: inventoryId ?? this.inventoryId,
        description: description ?? this.description,
        orderId: orderId ?? this.orderId,
        dealId: dealId ?? this.dealId,
        ranks: ranks ?? this.ranks,
        showRegionAvailability:
            showRegionAvailability ?? this.showRegionAvailability,
        showOtherWarehouseAvailability: showOtherWarehouseAvailability ??
            this.showOtherWarehouseAvailability,
        otherWarehouseIds: otherWarehouseIds ?? this.otherWarehouseIds);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictResponseItem {
  WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictResponseItem({
    this.warehouse,
    this.warehouseCode,
    this.inventoryTypeId,
    this.inventoryType,
    this.categoryId,
    this.category,
    this.subCategoryId,
    this.subCategory,
    this.inventoryId,
    this.iCode,
    this.itemDescription,
    this.orderId,
    this.orderType,
    this.orderTypeDescription,
    this.orderNumber,
    this.orderDescription,
    this.dealId,
    this.deal,
    this.quantityReserved,
    this.quantitySub,
    this.quantityAvailable,
    this.availabilityState,
    this.quantityAvailableRegion,
    this.availabilityStateRegion,
    this.otherWarehouses,
    this.quantityLate,
    this.quantityIn,
    this.quantityQc,
    this.quantityInRepair,
    this.fromDateTime,
    this.toDateTime,
    this.fromDateTimeString,
    this.toDateTimeString,
  });

  factory WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictResponseItem.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictResponseItemFromJson(
          json);

  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'InventoryTypeId')
  final String? inventoryTypeId;
  @JsonKey(name: 'InventoryType')
  final String? inventoryType;
  @JsonKey(name: 'CategoryId')
  final String? categoryId;
  @JsonKey(name: 'Category')
  final String? category;
  @JsonKey(name: 'SubCategoryId')
  final String? subCategoryId;
  @JsonKey(name: 'SubCategory')
  final String? subCategory;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'ItemDescription')
  final String? itemDescription;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderType')
  final String? orderType;
  @JsonKey(name: 'OrderTypeDescription')
  final String? orderTypeDescription;
  @JsonKey(name: 'OrderNumber')
  final String? orderNumber;
  @JsonKey(name: 'OrderDescription')
  final String? orderDescription;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'Deal')
  final String? deal;
  @JsonKey(name: 'QuantityReserved')
  final double? quantityReserved;
  @JsonKey(name: 'QuantitySub')
  final double? quantitySub;
  @JsonKey(name: 'QuantityAvailable')
  final double? quantityAvailable;
  @JsonKey(name: 'AvailabilityState')
  final String? availabilityState;
  @JsonKey(name: 'QuantityAvailableRegion')
  final double? quantityAvailableRegion;
  @JsonKey(name: 'AvailabilityStateRegion')
  final String? availabilityStateRegion;
  @JsonKey(name: 'OtherWarehouses', defaultValue: <
      WebApiModulesHomeControlsInventoryAvailabilityAvailabilityOtherWarehouse>[])
  final List<
          WebApiModulesHomeControlsInventoryAvailabilityAvailabilityOtherWarehouse>?
      otherWarehouses;
  @JsonKey(name: 'QuantityLate')
  final double? quantityLate;
  @JsonKey(name: 'QuantityIn')
  final double? quantityIn;
  @JsonKey(name: 'QuantityQc')
  final double? quantityQc;
  @JsonKey(name: 'QuantityInRepair')
  final double? quantityInRepair;
  @JsonKey(name: 'FromDateTime')
  final DateTime? fromDateTime;
  @JsonKey(name: 'ToDateTime')
  final DateTime? toDateTime;
  @JsonKey(name: 'FromDateTimeString')
  final String? fromDateTimeString;
  @JsonKey(name: 'ToDateTimeString')
  final String? toDateTimeString;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictResponseItemFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictResponseItemToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictResponseItemToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictResponseItem &&
            (identical(other.warehouse, warehouse) ||
                const DeepCollectionEquality()
                    .equals(other.warehouse, warehouse)) &&
            (identical(other.warehouseCode, warehouseCode) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.inventoryTypeId, inventoryTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryTypeId, inventoryTypeId)) &&
            (identical(other.inventoryType, inventoryType) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryType, inventoryType)) &&
            (identical(other.categoryId, categoryId) ||
                const DeepCollectionEquality()
                    .equals(other.categoryId, categoryId)) &&
            (identical(other.category, category) ||
                const DeepCollectionEquality()
                    .equals(other.category, category)) &&
            (identical(other.subCategoryId, subCategoryId) ||
                const DeepCollectionEquality()
                    .equals(other.subCategoryId, subCategoryId)) &&
            (identical(other.subCategory, subCategory) ||
                const DeepCollectionEquality()
                    .equals(other.subCategory, subCategory)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.itemDescription, itemDescription) ||
                const DeepCollectionEquality()
                    .equals(other.itemDescription, itemDescription)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderType, orderType) ||
                const DeepCollectionEquality()
                    .equals(other.orderType, orderType)) &&
            (identical(other.orderTypeDescription, orderTypeDescription) ||
                const DeepCollectionEquality().equals(
                    other.orderTypeDescription, orderTypeDescription)) &&
            (identical(other.orderNumber, orderNumber) ||
                const DeepCollectionEquality()
                    .equals(other.orderNumber, orderNumber)) &&
            (identical(other.orderDescription, orderDescription) ||
                const DeepCollectionEquality()
                    .equals(other.orderDescription, orderDescription)) &&
            (identical(other.dealId, dealId) || const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.deal, deal) || const DeepCollectionEquality().equals(other.deal, deal)) &&
            (identical(other.quantityReserved, quantityReserved) || const DeepCollectionEquality().equals(other.quantityReserved, quantityReserved)) &&
            (identical(other.quantitySub, quantitySub) || const DeepCollectionEquality().equals(other.quantitySub, quantitySub)) &&
            (identical(other.quantityAvailable, quantityAvailable) || const DeepCollectionEquality().equals(other.quantityAvailable, quantityAvailable)) &&
            (identical(other.availabilityState, availabilityState) || const DeepCollectionEquality().equals(other.availabilityState, availabilityState)) &&
            (identical(other.quantityAvailableRegion, quantityAvailableRegion) || const DeepCollectionEquality().equals(other.quantityAvailableRegion, quantityAvailableRegion)) &&
            (identical(other.availabilityStateRegion, availabilityStateRegion) || const DeepCollectionEquality().equals(other.availabilityStateRegion, availabilityStateRegion)) &&
            (identical(other.otherWarehouses, otherWarehouses) || const DeepCollectionEquality().equals(other.otherWarehouses, otherWarehouses)) &&
            (identical(other.quantityLate, quantityLate) || const DeepCollectionEquality().equals(other.quantityLate, quantityLate)) &&
            (identical(other.quantityIn, quantityIn) || const DeepCollectionEquality().equals(other.quantityIn, quantityIn)) &&
            (identical(other.quantityQc, quantityQc) || const DeepCollectionEquality().equals(other.quantityQc, quantityQc)) &&
            (identical(other.quantityInRepair, quantityInRepair) || const DeepCollectionEquality().equals(other.quantityInRepair, quantityInRepair)) &&
            (identical(other.fromDateTime, fromDateTime) || const DeepCollectionEquality().equals(other.fromDateTime, fromDateTime)) &&
            (identical(other.toDateTime, toDateTime) || const DeepCollectionEquality().equals(other.toDateTime, toDateTime)) &&
            (identical(other.fromDateTimeString, fromDateTimeString) || const DeepCollectionEquality().equals(other.fromDateTimeString, fromDateTimeString)) &&
            (identical(other.toDateTimeString, toDateTimeString) || const DeepCollectionEquality().equals(other.toDateTimeString, toDateTimeString)));
  }
}

extension $WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictResponseItemExtension
    on WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictResponseItem {
  WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictResponseItem
      copyWith(
          {String? warehouse,
          String? warehouseCode,
          String? inventoryTypeId,
          String? inventoryType,
          String? categoryId,
          String? category,
          String? subCategoryId,
          String? subCategory,
          String? inventoryId,
          String? iCode,
          String? itemDescription,
          String? orderId,
          String? orderType,
          String? orderTypeDescription,
          String? orderNumber,
          String? orderDescription,
          String? dealId,
          String? deal,
          double? quantityReserved,
          double? quantitySub,
          double? quantityAvailable,
          String? availabilityState,
          double? quantityAvailableRegion,
          String? availabilityStateRegion,
          List<WebApiModulesHomeControlsInventoryAvailabilityAvailabilityOtherWarehouse>?
              otherWarehouses,
          double? quantityLate,
          double? quantityIn,
          double? quantityQc,
          double? quantityInRepair,
          DateTime? fromDateTime,
          DateTime? toDateTime,
          String? fromDateTimeString,
          String? toDateTimeString}) {
    return WebApiModulesHomeControlsInventoryAvailabilityAvailabilityConflictResponseItem(
        warehouse: warehouse ?? this.warehouse,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        inventoryTypeId: inventoryTypeId ?? this.inventoryTypeId,
        inventoryType: inventoryType ?? this.inventoryType,
        categoryId: categoryId ?? this.categoryId,
        category: category ?? this.category,
        subCategoryId: subCategoryId ?? this.subCategoryId,
        subCategory: subCategory ?? this.subCategory,
        inventoryId: inventoryId ?? this.inventoryId,
        iCode: iCode ?? this.iCode,
        itemDescription: itemDescription ?? this.itemDescription,
        orderId: orderId ?? this.orderId,
        orderType: orderType ?? this.orderType,
        orderTypeDescription: orderTypeDescription ?? this.orderTypeDescription,
        orderNumber: orderNumber ?? this.orderNumber,
        orderDescription: orderDescription ?? this.orderDescription,
        dealId: dealId ?? this.dealId,
        deal: deal ?? this.deal,
        quantityReserved: quantityReserved ?? this.quantityReserved,
        quantitySub: quantitySub ?? this.quantitySub,
        quantityAvailable: quantityAvailable ?? this.quantityAvailable,
        availabilityState: availabilityState ?? this.availabilityState,
        quantityAvailableRegion:
            quantityAvailableRegion ?? this.quantityAvailableRegion,
        availabilityStateRegion:
            availabilityStateRegion ?? this.availabilityStateRegion,
        otherWarehouses: otherWarehouses ?? this.otherWarehouses,
        quantityLate: quantityLate ?? this.quantityLate,
        quantityIn: quantityIn ?? this.quantityIn,
        quantityQc: quantityQc ?? this.quantityQc,
        quantityInRepair: quantityInRepair ?? this.quantityInRepair,
        fromDateTime: fromDateTime ?? this.fromDateTime,
        toDateTime: toDateTime ?? this.toDateTime,
        fromDateTimeString: fromDateTimeString ?? this.fromDateTimeString,
        toDateTimeString: toDateTimeString ?? this.toDateTimeString);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryAvailabilityAvailabilityInventoryWarehouseRequest {
  WebApiModulesHomeControlsInventoryAvailabilityAvailabilityInventoryWarehouseRequest({
    this.inventoryId,
    this.warehouseId,
    this.fromDate,
    this.toDate,
    this.refreshIfNeeded,
  });

  factory WebApiModulesHomeControlsInventoryAvailabilityAvailabilityInventoryWarehouseRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryAvailabilityAvailabilityInventoryWarehouseRequestFromJson(
          json);

  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'FromDate')
  final DateTime? fromDate;
  @JsonKey(name: 'ToDate')
  final DateTime? toDate;
  @JsonKey(name: 'RefreshIfNeeded')
  final bool? refreshIfNeeded;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityAvailabilityInventoryWarehouseRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityAvailabilityInventoryWarehouseRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryAvailabilityAvailabilityInventoryWarehouseRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryAvailabilityAvailabilityInventoryWarehouseRequest &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.fromDate, fromDate) ||
                const DeepCollectionEquality()
                    .equals(other.fromDate, fromDate)) &&
            (identical(other.toDate, toDate) ||
                const DeepCollectionEquality().equals(other.toDate, toDate)) &&
            (identical(other.refreshIfNeeded, refreshIfNeeded) ||
                const DeepCollectionEquality()
                    .equals(other.refreshIfNeeded, refreshIfNeeded)));
  }
}

extension $WebApiModulesHomeControlsInventoryAvailabilityAvailabilityInventoryWarehouseRequestExtension
    on WebApiModulesHomeControlsInventoryAvailabilityAvailabilityInventoryWarehouseRequest {
  WebApiModulesHomeControlsInventoryAvailabilityAvailabilityInventoryWarehouseRequest
      copyWith(
          {String? inventoryId,
          String? warehouseId,
          DateTime? fromDate,
          DateTime? toDate,
          bool? refreshIfNeeded}) {
    return WebApiModulesHomeControlsInventoryAvailabilityAvailabilityInventoryWarehouseRequest(
        inventoryId: inventoryId ?? this.inventoryId,
        warehouseId: warehouseId ?? this.warehouseId,
        fromDate: fromDate ?? this.fromDate,
        toDate: toDate ?? this.toDate,
        refreshIfNeeded: refreshIfNeeded ?? this.refreshIfNeeded);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryAvailabilityAvailabilityOtherWarehouse {
  WebApiModulesHomeControlsInventoryAvailabilityAvailabilityOtherWarehouse({
    this.warehouseId,
    this.warehouseCode,
    this.quantityAvailable,
    this.availabilityState,
  });

  factory WebApiModulesHomeControlsInventoryAvailabilityAvailabilityOtherWarehouse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryAvailabilityAvailabilityOtherWarehouseFromJson(
          json);

  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'QuantityAvailable')
  final double? quantityAvailable;
  @JsonKey(name: 'AvailabilityState')
  final String? availabilityState;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityAvailabilityOtherWarehouseFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityAvailabilityOtherWarehouseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryAvailabilityAvailabilityOtherWarehouseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryAvailabilityAvailabilityOtherWarehouse &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouseCode, warehouseCode) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.quantityAvailable, quantityAvailable) ||
                const DeepCollectionEquality()
                    .equals(other.quantityAvailable, quantityAvailable)) &&
            (identical(other.availabilityState, availabilityState) ||
                const DeepCollectionEquality()
                    .equals(other.availabilityState, availabilityState)));
  }
}

extension $WebApiModulesHomeControlsInventoryAvailabilityAvailabilityOtherWarehouseExtension
    on WebApiModulesHomeControlsInventoryAvailabilityAvailabilityOtherWarehouse {
  WebApiModulesHomeControlsInventoryAvailabilityAvailabilityOtherWarehouse
      copyWith(
          {String? warehouseId,
          String? warehouseCode,
          double? quantityAvailable,
          String? availabilityState}) {
    return WebApiModulesHomeControlsInventoryAvailabilityAvailabilityOtherWarehouse(
        warehouseId: warehouseId ?? this.warehouseId,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        quantityAvailable: quantityAvailable ?? this.quantityAvailable,
        availabilityState: availabilityState ?? this.availabilityState);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarAndScheduleResponse {
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarAndScheduleResponse({
    this.inventoryData,
    this.dates,
    this.inventoryAvailabilityCalendarEvents,
    this.inventoryAvailabilityScheduleResources,
    this.inventoryAvailabilityScheduleEvents,
  });

  factory WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarAndScheduleResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarAndScheduleResponseFromJson(
          json);

  @JsonKey(name: 'InventoryData')
  final WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailability?
      inventoryData;
  @JsonKey(name: 'Dates', defaultValue: <
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarDate>[])
  final List<
          WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarDate>?
      dates;
  @JsonKey(name: 'InventoryAvailabilityCalendarEvents', defaultValue: <
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarEvent>[])
  final List<
          WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarEvent>?
      inventoryAvailabilityCalendarEvents;
  @JsonKey(name: 'InventoryAvailabilityScheduleResources', defaultValue: <
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleResource>[])
  final List<
          WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleResource>?
      inventoryAvailabilityScheduleResources;
  @JsonKey(name: 'InventoryAvailabilityScheduleEvents', defaultValue: <
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleEvent>[])
  final List<
          WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleEvent>?
      inventoryAvailabilityScheduleEvents;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarAndScheduleResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarAndScheduleResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarAndScheduleResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarAndScheduleResponse &&
            (identical(other.inventoryData, inventoryData) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryData, inventoryData)) &&
            (identical(other.dates, dates) ||
                const DeepCollectionEquality().equals(other.dates, dates)) &&
            (identical(other.inventoryAvailabilityCalendarEvents,
                    inventoryAvailabilityCalendarEvents) ||
                const DeepCollectionEquality().equals(
                    other.inventoryAvailabilityCalendarEvents,
                    inventoryAvailabilityCalendarEvents)) &&
            (identical(other.inventoryAvailabilityScheduleResources,
                    inventoryAvailabilityScheduleResources) ||
                const DeepCollectionEquality().equals(
                    other.inventoryAvailabilityScheduleResources,
                    inventoryAvailabilityScheduleResources)) &&
            (identical(other.inventoryAvailabilityScheduleEvents,
                    inventoryAvailabilityScheduleEvents) ||
                const DeepCollectionEquality().equals(
                    other.inventoryAvailabilityScheduleEvents,
                    inventoryAvailabilityScheduleEvents)));
  }
}

extension $WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarAndScheduleResponseExtension
    on WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarAndScheduleResponse {
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarAndScheduleResponse copyWith(
      {WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailability?
          inventoryData,
      List<WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarDate>?
          dates,
      List<WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarEvent>?
          inventoryAvailabilityCalendarEvents,
      List<WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleResource>?
          inventoryAvailabilityScheduleResources,
      List<WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleEvent>?
          inventoryAvailabilityScheduleEvents}) {
    return WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarAndScheduleResponse(
        inventoryData: inventoryData ?? this.inventoryData,
        dates: dates ?? this.dates,
        inventoryAvailabilityCalendarEvents:
            inventoryAvailabilityCalendarEvents ??
                this.inventoryAvailabilityCalendarEvents,
        inventoryAvailabilityScheduleResources:
            inventoryAvailabilityScheduleResources ??
                this.inventoryAvailabilityScheduleResources,
        inventoryAvailabilityScheduleEvents:
            inventoryAvailabilityScheduleEvents ??
                this.inventoryAvailabilityScheduleEvents);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarDate {
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarDate({
    this.theDate,
    this.reservations,
  });

  factory WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarDate.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarDateFromJson(
          json);

  @JsonKey(name: 'TheDate')
  final DateTime? theDate;
  @JsonKey(name: 'Reservations', defaultValue: <
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityReservation>[])
  final List<
          WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityReservation>?
      reservations;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarDateFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarDateToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarDateToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarDate &&
            (identical(other.theDate, theDate) ||
                const DeepCollectionEquality()
                    .equals(other.theDate, theDate)) &&
            (identical(other.reservations, reservations) ||
                const DeepCollectionEquality()
                    .equals(other.reservations, reservations)));
  }
}

extension $WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarDateExtension
    on WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarDate {
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarDate
      copyWith(
          {DateTime? theDate,
          List<WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityReservation>?
              reservations}) {
    return WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarDate(
        theDate: theDate ?? this.theDate,
        reservations: reservations ?? this.reservations);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarEvent {
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarEvent({
    this.inventoryId,
    this.warehouseId,
    this.start,
    this.end,
    this.text,
    this.backColor,
    this.textColor,
    this.id,
    this.resource,
  });

  factory WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarEvent.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarEventFromJson(
          json);

  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'start')
  final String? start;
  @JsonKey(name: 'end')
  final String? end;
  @JsonKey(name: 'text')
  final String? text;
  @JsonKey(name: 'backColor')
  final String? backColor;
  @JsonKey(name: 'textColor')
  final String? textColor;
  @JsonKey(name: 'id')
  final String? id;
  @JsonKey(name: 'resource')
  final String? resource;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarEventFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarEventToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarEventToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarEvent &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.start, start) ||
                const DeepCollectionEquality().equals(other.start, start)) &&
            (identical(other.end, end) ||
                const DeepCollectionEquality().equals(other.end, end)) &&
            (identical(other.text, text) ||
                const DeepCollectionEquality().equals(other.text, text)) &&
            (identical(other.backColor, backColor) ||
                const DeepCollectionEquality()
                    .equals(other.backColor, backColor)) &&
            (identical(other.textColor, textColor) ||
                const DeepCollectionEquality()
                    .equals(other.textColor, textColor)) &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.resource, resource) ||
                const DeepCollectionEquality()
                    .equals(other.resource, resource)));
  }
}

extension $WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarEventExtension
    on WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarEvent {
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarEvent
      copyWith(
          {String? inventoryId,
          String? warehouseId,
          String? start,
          String? end,
          String? text,
          String? backColor,
          String? textColor,
          String? id,
          String? resource}) {
    return WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityCalendarEvent(
        inventoryId: inventoryId ?? this.inventoryId,
        warehouseId: warehouseId ?? this.warehouseId,
        start: start ?? this.start,
        end: end ?? this.end,
        text: text ?? this.text,
        backColor: backColor ?? this.backColor,
        textColor: textColor ?? this.textColor,
        id: id ?? this.id,
        resource: resource ?? this.resource);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleEvent {
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleEvent({
    this.inventoryId,
    this.warehouseId,
    this.start,
    this.end,
    this.startdisplay,
    this.enddisplay,
    this.text,
    this.total,
    this.backColor,
    this.barColor,
    this.textColor,
    this.id,
    this.resource,
    this.orderId,
    this.orderNumber,
    this.orderType,
    this.orderStatus,
    this.orderDescription,
    this.deal,
    this.subPoNumber,
    this.subPoVendor,
    this.contractId,
    this.isWarehouseTotal,
    this.isGrandTotal,
  });

  factory WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleEvent.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleEventFromJson(
          json);

  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'start')
  final String? start;
  @JsonKey(name: 'end')
  final String? end;
  @JsonKey(name: 'startdisplay')
  final String? startdisplay;
  @JsonKey(name: 'enddisplay')
  final String? enddisplay;
  @JsonKey(name: 'text')
  final String? text;
  @JsonKey(name: 'total')
  final String? total;
  @JsonKey(name: 'backColor')
  final String? backColor;
  @JsonKey(name: 'barColor')
  final String? barColor;
  @JsonKey(name: 'textColor')
  final String? textColor;
  @JsonKey(name: 'id')
  final String? id;
  @JsonKey(name: 'resource')
  final String? resource;
  @JsonKey(name: 'orderId')
  final String? orderId;
  @JsonKey(name: 'orderNumber')
  final String? orderNumber;
  @JsonKey(name: 'orderType')
  final String? orderType;
  @JsonKey(name: 'orderStatus')
  final String? orderStatus;
  @JsonKey(name: 'orderDescription')
  final String? orderDescription;
  @JsonKey(name: 'deal')
  final String? deal;
  @JsonKey(name: 'subPoNumber')
  final String? subPoNumber;
  @JsonKey(name: 'subPoVendor')
  final String? subPoVendor;
  @JsonKey(name: 'contractId')
  final String? contractId;
  @JsonKey(name: 'isWarehouseTotal')
  final bool? isWarehouseTotal;
  @JsonKey(name: 'isGrandTotal')
  final bool? isGrandTotal;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleEventFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleEventToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleEventToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleEvent &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.start, start) ||
                const DeepCollectionEquality().equals(other.start, start)) &&
            (identical(other.end, end) ||
                const DeepCollectionEquality().equals(other.end, end)) &&
            (identical(other.startdisplay, startdisplay) ||
                const DeepCollectionEquality()
                    .equals(other.startdisplay, startdisplay)) &&
            (identical(other.enddisplay, enddisplay) ||
                const DeepCollectionEquality()
                    .equals(other.enddisplay, enddisplay)) &&
            (identical(other.text, text) ||
                const DeepCollectionEquality().equals(other.text, text)) &&
            (identical(other.total, total) ||
                const DeepCollectionEquality().equals(other.total, total)) &&
            (identical(other.backColor, backColor) ||
                const DeepCollectionEquality()
                    .equals(other.backColor, backColor)) &&
            (identical(other.barColor, barColor) ||
                const DeepCollectionEquality()
                    .equals(other.barColor, barColor)) &&
            (identical(other.textColor, textColor) ||
                const DeepCollectionEquality()
                    .equals(other.textColor, textColor)) &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.resource, resource) ||
                const DeepCollectionEquality()
                    .equals(other.resource, resource)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderNumber, orderNumber) ||
                const DeepCollectionEquality()
                    .equals(other.orderNumber, orderNumber)) &&
            (identical(other.orderType, orderType) ||
                const DeepCollectionEquality()
                    .equals(other.orderType, orderType)) &&
            (identical(other.orderStatus, orderStatus) ||
                const DeepCollectionEquality()
                    .equals(other.orderStatus, orderStatus)) &&
            (identical(other.orderDescription, orderDescription) ||
                const DeepCollectionEquality()
                    .equals(other.orderDescription, orderDescription)) &&
            (identical(other.deal, deal) ||
                const DeepCollectionEquality().equals(other.deal, deal)) &&
            (identical(other.subPoNumber, subPoNumber) || const DeepCollectionEquality().equals(other.subPoNumber, subPoNumber)) &&
            (identical(other.subPoVendor, subPoVendor) || const DeepCollectionEquality().equals(other.subPoVendor, subPoVendor)) &&
            (identical(other.contractId, contractId) || const DeepCollectionEquality().equals(other.contractId, contractId)) &&
            (identical(other.isWarehouseTotal, isWarehouseTotal) || const DeepCollectionEquality().equals(other.isWarehouseTotal, isWarehouseTotal)) &&
            (identical(other.isGrandTotal, isGrandTotal) || const DeepCollectionEquality().equals(other.isGrandTotal, isGrandTotal)));
  }
}

extension $WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleEventExtension
    on WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleEvent {
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleEvent
      copyWith(
          {String? inventoryId,
          String? warehouseId,
          String? start,
          String? end,
          String? startdisplay,
          String? enddisplay,
          String? text,
          String? total,
          String? backColor,
          String? barColor,
          String? textColor,
          String? id,
          String? resource,
          String? orderId,
          String? orderNumber,
          String? orderType,
          String? orderStatus,
          String? orderDescription,
          String? deal,
          String? subPoNumber,
          String? subPoVendor,
          String? contractId,
          bool? isWarehouseTotal,
          bool? isGrandTotal}) {
    return WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleEvent(
        inventoryId: inventoryId ?? this.inventoryId,
        warehouseId: warehouseId ?? this.warehouseId,
        start: start ?? this.start,
        end: end ?? this.end,
        startdisplay: startdisplay ?? this.startdisplay,
        enddisplay: enddisplay ?? this.enddisplay,
        text: text ?? this.text,
        total: total ?? this.total,
        backColor: backColor ?? this.backColor,
        barColor: barColor ?? this.barColor,
        textColor: textColor ?? this.textColor,
        id: id ?? this.id,
        resource: resource ?? this.resource,
        orderId: orderId ?? this.orderId,
        orderNumber: orderNumber ?? this.orderNumber,
        orderType: orderType ?? this.orderType,
        orderStatus: orderStatus ?? this.orderStatus,
        orderDescription: orderDescription ?? this.orderDescription,
        deal: deal ?? this.deal,
        subPoNumber: subPoNumber ?? this.subPoNumber,
        subPoVendor: subPoVendor ?? this.subPoVendor,
        contractId: contractId ?? this.contractId,
        isWarehouseTotal: isWarehouseTotal ?? this.isWarehouseTotal,
        isGrandTotal: isGrandTotal ?? this.isGrandTotal);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleResource {
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleResource({
    this.name,
    this.id,
    this.backColor,
  });

  factory WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleResource.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleResourceFromJson(
          json);

  @JsonKey(name: 'name')
  final String? name;
  @JsonKey(name: 'id')
  final String? id;
  @JsonKey(name: 'backColor')
  final String? backColor;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleResourceFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleResourceToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleResourceToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleResource &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.backColor, backColor) ||
                const DeepCollectionEquality()
                    .equals(other.backColor, backColor)));
  }
}

extension $WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleResourceExtension
    on WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleResource {
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleResource
      copyWith({String? name, String? id, String? backColor}) {
    return WebApiModulesHomeControlsInventoryAvailabilityTInventoryAvailabilityScheduleResource(
        name: name ?? this.name,
        id: id ?? this.id,
        backColor: backColor ?? this.backColor);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouse {
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouse({
    this.inventoryTypeId,
    this.inventoryType,
    this.categoryId,
    this.category,
    this.subCategoryId,
    this.subCategory,
    this.inventoryId,
    this.warehouseId,
    this.regionId,
    this.availableFor,
    this.iCode,
    this.description,
    this.warehouseCode,
    this.warehouse,
    this.classification,
    this.hourlyAvailability,
    this.noAvailabilityCheck,
    this.lowAvailabilityPercent,
    this.lowAvailabilityQuantity,
    this.dailyRate,
    this.weeklyRate,
    this.week2Rate,
    this.week3Rate,
    this.week4Rate,
    this.monthlyRate,
    this.accessories,
    this.combinedKey,
  });

  factory WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseFromJson(
          json);

  @JsonKey(name: 'InventoryTypeId')
  final String? inventoryTypeId;
  @JsonKey(name: 'InventoryType')
  final String? inventoryType;
  @JsonKey(name: 'CategoryId')
  final String? categoryId;
  @JsonKey(name: 'Category')
  final String? category;
  @JsonKey(name: 'SubCategoryId')
  final String? subCategoryId;
  @JsonKey(name: 'SubCategory')
  final String? subCategory;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'RegionId')
  final String? regionId;
  @JsonKey(name: 'AvailableFor')
  final String? availableFor;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'Classification')
  final String? classification;
  @JsonKey(name: 'HourlyAvailability')
  final bool? hourlyAvailability;
  @JsonKey(name: 'NoAvailabilityCheck')
  final bool? noAvailabilityCheck;
  @JsonKey(name: 'LowAvailabilityPercent')
  final int? lowAvailabilityPercent;
  @JsonKey(name: 'LowAvailabilityQuantity')
  final int? lowAvailabilityQuantity;
  @JsonKey(name: 'DailyRate')
  final String? dailyRate;
  @JsonKey(name: 'WeeklyRate')
  final String? weeklyRate;
  @JsonKey(name: 'Week2Rate')
  final String? week2Rate;
  @JsonKey(name: 'Week3Rate')
  final String? week3Rate;
  @JsonKey(name: 'Week4Rate')
  final String? week4Rate;
  @JsonKey(name: 'MonthlyRate')
  final String? monthlyRate;
  @JsonKey(name: 'Accessories', defaultValue: <
      WebApiModulesHomeControlsInventoryAvailabilityTPackageAccessory>[])
  final List<WebApiModulesHomeControlsInventoryAvailabilityTPackageAccessory>?
      accessories;
  @JsonKey(name: 'CombinedKey')
  final String? combinedKey;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouse &&
            (identical(other.inventoryTypeId, inventoryTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryTypeId, inventoryTypeId)) &&
            (identical(other.inventoryType, inventoryType) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryType, inventoryType)) &&
            (identical(other.categoryId, categoryId) ||
                const DeepCollectionEquality()
                    .equals(other.categoryId, categoryId)) &&
            (identical(other.category, category) ||
                const DeepCollectionEquality()
                    .equals(other.category, category)) &&
            (identical(other.subCategoryId, subCategoryId) ||
                const DeepCollectionEquality()
                    .equals(other.subCategoryId, subCategoryId)) &&
            (identical(other.subCategory, subCategory) ||
                const DeepCollectionEquality()
                    .equals(other.subCategory, subCategory)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.regionId, regionId) ||
                const DeepCollectionEquality()
                    .equals(other.regionId, regionId)) &&
            (identical(other.availableFor, availableFor) ||
                const DeepCollectionEquality()
                    .equals(other.availableFor, availableFor)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.warehouseCode, warehouseCode) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.warehouse, warehouse) ||
                const DeepCollectionEquality()
                    .equals(other.warehouse, warehouse)) &&
            (identical(other.classification, classification) ||
                const DeepCollectionEquality()
                    .equals(other.classification, classification)) &&
            (identical(other.hourlyAvailability, hourlyAvailability) ||
                const DeepCollectionEquality()
                    .equals(other.hourlyAvailability, hourlyAvailability)) &&
            (identical(other.noAvailabilityCheck, noAvailabilityCheck) ||
                const DeepCollectionEquality().equals(other.noAvailabilityCheck, noAvailabilityCheck)) &&
            (identical(other.lowAvailabilityPercent, lowAvailabilityPercent) || const DeepCollectionEquality().equals(other.lowAvailabilityPercent, lowAvailabilityPercent)) &&
            (identical(other.lowAvailabilityQuantity, lowAvailabilityQuantity) || const DeepCollectionEquality().equals(other.lowAvailabilityQuantity, lowAvailabilityQuantity)) &&
            (identical(other.dailyRate, dailyRate) || const DeepCollectionEquality().equals(other.dailyRate, dailyRate)) &&
            (identical(other.weeklyRate, weeklyRate) || const DeepCollectionEquality().equals(other.weeklyRate, weeklyRate)) &&
            (identical(other.week2Rate, week2Rate) || const DeepCollectionEquality().equals(other.week2Rate, week2Rate)) &&
            (identical(other.week3Rate, week3Rate) || const DeepCollectionEquality().equals(other.week3Rate, week3Rate)) &&
            (identical(other.week4Rate, week4Rate) || const DeepCollectionEquality().equals(other.week4Rate, week4Rate)) &&
            (identical(other.monthlyRate, monthlyRate) || const DeepCollectionEquality().equals(other.monthlyRate, monthlyRate)) &&
            (identical(other.accessories, accessories) || const DeepCollectionEquality().equals(other.accessories, accessories)) &&
            (identical(other.combinedKey, combinedKey) || const DeepCollectionEquality().equals(other.combinedKey, combinedKey)));
  }
}

extension $WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseExtension
    on WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouse {
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouse copyWith(
      {String? inventoryTypeId,
      String? inventoryType,
      String? categoryId,
      String? category,
      String? subCategoryId,
      String? subCategory,
      String? inventoryId,
      String? warehouseId,
      String? regionId,
      String? availableFor,
      String? iCode,
      String? description,
      String? warehouseCode,
      String? warehouse,
      String? classification,
      bool? hourlyAvailability,
      bool? noAvailabilityCheck,
      int? lowAvailabilityPercent,
      int? lowAvailabilityQuantity,
      String? dailyRate,
      String? weeklyRate,
      String? week2Rate,
      String? week3Rate,
      String? week4Rate,
      String? monthlyRate,
      List<WebApiModulesHomeControlsInventoryAvailabilityTPackageAccessory>?
          accessories,
      String? combinedKey}) {
    return WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouse(
        inventoryTypeId: inventoryTypeId ?? this.inventoryTypeId,
        inventoryType: inventoryType ?? this.inventoryType,
        categoryId: categoryId ?? this.categoryId,
        category: category ?? this.category,
        subCategoryId: subCategoryId ?? this.subCategoryId,
        subCategory: subCategory ?? this.subCategory,
        inventoryId: inventoryId ?? this.inventoryId,
        warehouseId: warehouseId ?? this.warehouseId,
        regionId: regionId ?? this.regionId,
        availableFor: availableFor ?? this.availableFor,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        warehouse: warehouse ?? this.warehouse,
        classification: classification ?? this.classification,
        hourlyAvailability: hourlyAvailability ?? this.hourlyAvailability,
        noAvailabilityCheck: noAvailabilityCheck ?? this.noAvailabilityCheck,
        lowAvailabilityPercent:
            lowAvailabilityPercent ?? this.lowAvailabilityPercent,
        lowAvailabilityQuantity:
            lowAvailabilityQuantity ?? this.lowAvailabilityQuantity,
        dailyRate: dailyRate ?? this.dailyRate,
        weeklyRate: weeklyRate ?? this.weeklyRate,
        week2Rate: week2Rate ?? this.week2Rate,
        week3Rate: week3Rate ?? this.week3Rate,
        week4Rate: week4Rate ?? this.week4Rate,
        monthlyRate: monthlyRate ?? this.monthlyRate,
        accessories: accessories ?? this.accessories,
        combinedKey: combinedKey ?? this.combinedKey);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailability {
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailability({
    this.total,
    this.$in,
    this.staged,
    this.out,
    this.inRepair,
    this.inTransit,
    this.inContainer,
    this.onTruck,
    this.qcRequired,
    this.late,
    this.inventoryWarehouse,
    this.calculatedDateTime,
    this.availDataFromDateTime,
    this.availDataToDateTime,
    this.enableQcDelay,
    this.qcDelayDays,
    this.qcToDateTime,
    this.reservations,
    this.availabilityDatesAndTimes,
    this.hasPositiveConflict,
    this.hasNegativeConflict,
  });

  factory WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailability.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityFromJson(
          json);

  @JsonKey(name: 'Total')
  final WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
      total;
  @JsonKey(name: 'In')
  final WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
      $in;
  @JsonKey(name: 'Staged')
  final WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
      staged;
  @JsonKey(name: 'Out')
  final WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
      out;
  @JsonKey(name: 'InRepair')
  final WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
      inRepair;
  @JsonKey(name: 'InTransit')
  final WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
      inTransit;
  @JsonKey(name: 'InContainer')
  final WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
      inContainer;
  @JsonKey(name: 'OnTruck')
  final WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
      onTruck;
  @JsonKey(name: 'QcRequired')
  final WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
      qcRequired;
  @JsonKey(name: 'Late')
  final WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
      late;
  @JsonKey(name: 'InventoryWarehouse')
  final WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouse?
      inventoryWarehouse;
  @JsonKey(name: 'CalculatedDateTime')
  final DateTime? calculatedDateTime;
  @JsonKey(name: 'AvailDataFromDateTime')
  final DateTime? availDataFromDateTime;
  @JsonKey(name: 'AvailDataToDateTime')
  final DateTime? availDataToDateTime;
  @JsonKey(name: 'EnableQcDelay')
  final bool? enableQcDelay;
  @JsonKey(name: 'QcDelayDays')
  final int? qcDelayDays;
  @JsonKey(name: 'QcToDateTime')
  final DateTime? qcToDateTime;
  @JsonKey(name: 'Reservations', defaultValue: <
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityReservation>[])
  final List<
          WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityReservation>?
      reservations;
  @JsonKey(name: 'AvailabilityDatesAndTimes')
  final Object? availabilityDatesAndTimes;
  @JsonKey(name: 'HasPositiveConflict')
  final bool? hasPositiveConflict;
  @JsonKey(name: 'HasNegativeConflict')
  final bool? hasNegativeConflict;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailability &&
            (identical(other.total, total) ||
                const DeepCollectionEquality().equals(other.total, total)) &&
            (identical(other.$in, $in) ||
                const DeepCollectionEquality().equals(other.$in, $in)) &&
            (identical(other.staged, staged) ||
                const DeepCollectionEquality().equals(other.staged, staged)) &&
            (identical(other.out, out) ||
                const DeepCollectionEquality().equals(other.out, out)) &&
            (identical(other.inRepair, inRepair) ||
                const DeepCollectionEquality()
                    .equals(other.inRepair, inRepair)) &&
            (identical(other.inTransit, inTransit) ||
                const DeepCollectionEquality()
                    .equals(other.inTransit, inTransit)) &&
            (identical(other.inContainer, inContainer) ||
                const DeepCollectionEquality()
                    .equals(other.inContainer, inContainer)) &&
            (identical(other.onTruck, onTruck) ||
                const DeepCollectionEquality()
                    .equals(other.onTruck, onTruck)) &&
            (identical(other.qcRequired, qcRequired) ||
                const DeepCollectionEquality()
                    .equals(other.qcRequired, qcRequired)) &&
            (identical(other.late, late) ||
                const DeepCollectionEquality().equals(other.late, late)) &&
            (identical(other.inventoryWarehouse, inventoryWarehouse) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryWarehouse, inventoryWarehouse)) &&
            (identical(other.calculatedDateTime, calculatedDateTime) ||
                const DeepCollectionEquality()
                    .equals(other.calculatedDateTime, calculatedDateTime)) &&
            (identical(other.availDataFromDateTime, availDataFromDateTime) ||
                const DeepCollectionEquality().equals(
                    other.availDataFromDateTime, availDataFromDateTime)) &&
            (identical(other.availDataToDateTime, availDataToDateTime) ||
                const DeepCollectionEquality()
                    .equals(other.availDataToDateTime, availDataToDateTime)) &&
            (identical(other.enableQcDelay, enableQcDelay) ||
                const DeepCollectionEquality()
                    .equals(other.enableQcDelay, enableQcDelay)) &&
            (identical(other.qcDelayDays, qcDelayDays) ||
                const DeepCollectionEquality()
                    .equals(other.qcDelayDays, qcDelayDays)) &&
            (identical(other.qcToDateTime, qcToDateTime) ||
                const DeepCollectionEquality()
                    .equals(other.qcToDateTime, qcToDateTime)) &&
            (identical(other.reservations, reservations) ||
                const DeepCollectionEquality()
                    .equals(other.reservations, reservations)) &&
            (identical(other.availabilityDatesAndTimes, availabilityDatesAndTimes) || const DeepCollectionEquality().equals(other.availabilityDatesAndTimes, availabilityDatesAndTimes)) &&
            (identical(other.hasPositiveConflict, hasPositiveConflict) || const DeepCollectionEquality().equals(other.hasPositiveConflict, hasPositiveConflict)) &&
            (identical(other.hasNegativeConflict, hasNegativeConflict) || const DeepCollectionEquality().equals(other.hasNegativeConflict, hasNegativeConflict)));
  }
}

extension $WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityExtension
    on WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailability {
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailability copyWith(
      {WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
          total,
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
          $in,
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
          staged,
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
          out,
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
          inRepair,
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
          inTransit,
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
          inContainer,
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
          onTruck,
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
          qcRequired,
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
          late,
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouse?
          inventoryWarehouse,
      DateTime? calculatedDateTime,
      DateTime? availDataFromDateTime,
      DateTime? availDataToDateTime,
      bool? enableQcDelay,
      int? qcDelayDays,
      DateTime? qcToDateTime,
      List<WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityReservation>?
          reservations,
      Object? availabilityDatesAndTimes,
      bool? hasPositiveConflict,
      bool? hasNegativeConflict}) {
    return WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailability(
        total: total ?? this.total,
        $in: $in ?? this.$in,
        staged: staged ?? this.staged,
        out: out ?? this.out,
        inRepair: inRepair ?? this.inRepair,
        inTransit: inTransit ?? this.inTransit,
        inContainer: inContainer ?? this.inContainer,
        onTruck: onTruck ?? this.onTruck,
        qcRequired: qcRequired ?? this.qcRequired,
        late: late ?? this.late,
        inventoryWarehouse: inventoryWarehouse ?? this.inventoryWarehouse,
        calculatedDateTime: calculatedDateTime ?? this.calculatedDateTime,
        availDataFromDateTime:
            availDataFromDateTime ?? this.availDataFromDateTime,
        availDataToDateTime: availDataToDateTime ?? this.availDataToDateTime,
        enableQcDelay: enableQcDelay ?? this.enableQcDelay,
        qcDelayDays: qcDelayDays ?? this.qcDelayDays,
        qcToDateTime: qcToDateTime ?? this.qcToDateTime,
        reservations: reservations ?? this.reservations,
        availabilityDatesAndTimes:
            availabilityDatesAndTimes ?? this.availabilityDatesAndTimes,
        hasPositiveConflict: hasPositiveConflict ?? this.hasPositiveConflict,
        hasNegativeConflict: hasNegativeConflict ?? this.hasNegativeConflict);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityDateTime {
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityDateTime({
    this.availabilityDateTime,
    this.available,
    this.reserved,
    this.returning,
    this.becomingAvailable,
  });

  factory WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityDateTime.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityDateTimeFromJson(
          json);

  @JsonKey(name: 'AvailabilityDateTime')
  final DateTime? availabilityDateTime;
  @JsonKey(name: 'Available')
  final WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
      available;
  @JsonKey(name: 'Reserved')
  final WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
      reserved;
  @JsonKey(name: 'Returning')
  final WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
      returning;
  @JsonKey(name: 'BecomingAvailable')
  final WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
      becomingAvailable;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityDateTimeFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityDateTimeToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityDateTimeToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityDateTime &&
            (identical(other.availabilityDateTime, availabilityDateTime) ||
                const DeepCollectionEquality().equals(
                    other.availabilityDateTime, availabilityDateTime)) &&
            (identical(other.available, available) ||
                const DeepCollectionEquality()
                    .equals(other.available, available)) &&
            (identical(other.reserved, reserved) ||
                const DeepCollectionEquality()
                    .equals(other.reserved, reserved)) &&
            (identical(other.returning, returning) ||
                const DeepCollectionEquality()
                    .equals(other.returning, returning)) &&
            (identical(other.becomingAvailable, becomingAvailable) ||
                const DeepCollectionEquality()
                    .equals(other.becomingAvailable, becomingAvailable)));
  }
}

extension $WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityDateTimeExtension
    on WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityDateTime {
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityDateTime copyWith(
      {DateTime? availabilityDateTime,
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
          available,
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
          reserved,
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
          returning,
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
          becomingAvailable}) {
    return WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityDateTime(
        availabilityDateTime: availabilityDateTime ?? this.availabilityDateTime,
        available: available ?? this.available,
        reserved: reserved ?? this.reserved,
        returning: returning ?? this.returning,
        becomingAvailable: becomingAvailable ?? this.becomingAvailable);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity {
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity({
    this.owned,
    this.subbed,
    this.consigned,
    this.ownedAndConsigned,
    this.total,
  });

  factory WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantityFromJson(
          json);

  @JsonKey(name: 'Owned')
  final double? owned;
  @JsonKey(name: 'Subbed')
  final double? subbed;
  @JsonKey(name: 'Consigned')
  final double? consigned;
  @JsonKey(name: 'OwnedAndConsigned')
  final double? ownedAndConsigned;
  @JsonKey(name: 'Total')
  final double? total;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantityFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantityToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantityToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity &&
            (identical(other.owned, owned) ||
                const DeepCollectionEquality().equals(other.owned, owned)) &&
            (identical(other.subbed, subbed) ||
                const DeepCollectionEquality().equals(other.subbed, subbed)) &&
            (identical(other.consigned, consigned) ||
                const DeepCollectionEquality()
                    .equals(other.consigned, consigned)) &&
            (identical(other.ownedAndConsigned, ownedAndConsigned) ||
                const DeepCollectionEquality()
                    .equals(other.ownedAndConsigned, ownedAndConsigned)) &&
            (identical(other.total, total) ||
                const DeepCollectionEquality().equals(other.total, total)));
  }
}

extension $WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantityExtension
    on WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity {
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity
      copyWith(
          {double? owned,
          double? subbed,
          double? consigned,
          double? ownedAndConsigned,
          double? total}) {
    return WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity(
        owned: owned ?? this.owned,
        subbed: subbed ?? this.subbed,
        consigned: consigned ?? this.consigned,
        ownedAndConsigned: ownedAndConsigned ?? this.ownedAndConsigned,
        total: total ?? this.total);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityReservation {
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityReservation({
    this.quantityReserved,
    this.quantityStaged,
    this.quantityOut,
    this.quantityIn,
    this.quantityInRepair,
    this.quantityLate,
    this.inventoryId,
    this.warehouseId,
    this.warehouseCode,
    this.warehouse,
    this.returnToWarehouseId,
    this.returnToWarehouseCode,
    this.returnToWarehouse,
    this.orderId,
    this.orderItemId,
    this.recType,
    this.orderType,
    this.orderTypeDescription,
    this.orderNumber,
    this.orderDescription,
    this.orderStatus,
    this.departmentId,
    this.department,
    this.dealId,
    this.deal,
    this.fromDateTime,
    this.fromDateTimeDisplay,
    this.toDateTime,
    this.toDateTimeDisplay,
    this.roundTripRental,
    this.late,
    this.lateButReturning,
    this.qcRequired,
    this.enableQcDelay,
    this.qcDelayDays,
    this.qcDelayExcludeWeekend,
    this.qcDelayExcludeHoliday,
    this.qcDelayIndefinite,
    this.qcDelayFromDateTime,
    this.qcDelayToDateTime,
    this.qcQuantity,
    this.containerBarCode,
    this.availableWhileInContainer,
    this.contractId,
    this.quantityOrdered,
    this.quantitySub,
    this.quantityConsigned,
    this.isPositiveConflict,
    this.isNegativeConflict,
    this.subPurchaseOrderId,
    this.subPurchaseOrderNumber,
    this.subPurchaseOrderDescription,
    this.subPurchaseOrderVendor,
  });

  factory WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityReservation.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityReservationFromJson(
          json);

  @JsonKey(name: 'QuantityReserved')
  final WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
      quantityReserved;
  @JsonKey(name: 'QuantityStaged')
  final WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
      quantityStaged;
  @JsonKey(name: 'QuantityOut')
  final WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
      quantityOut;
  @JsonKey(name: 'QuantityIn')
  final WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
      quantityIn;
  @JsonKey(name: 'QuantityInRepair')
  final WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
      quantityInRepair;
  @JsonKey(name: 'QuantityLate')
  final WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
      quantityLate;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'ReturnToWarehouseId')
  final String? returnToWarehouseId;
  @JsonKey(name: 'ReturnToWarehouseCode')
  final String? returnToWarehouseCode;
  @JsonKey(name: 'ReturnToWarehouse')
  final String? returnToWarehouse;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderItemId')
  final String? orderItemId;
  @JsonKey(name: 'RecType')
  final String? recType;
  @JsonKey(name: 'OrderType')
  final String? orderType;
  @JsonKey(name: 'OrderTypeDescription')
  final String? orderTypeDescription;
  @JsonKey(name: 'OrderNumber')
  final String? orderNumber;
  @JsonKey(name: 'OrderDescription')
  final String? orderDescription;
  @JsonKey(name: 'OrderStatus')
  final String? orderStatus;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'Department')
  final String? department;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'Deal')
  final String? deal;
  @JsonKey(name: 'FromDateTime')
  final DateTime? fromDateTime;
  @JsonKey(name: 'FromDateTimeDisplay')
  final String? fromDateTimeDisplay;
  @JsonKey(name: 'ToDateTime')
  final DateTime? toDateTime;
  @JsonKey(name: 'ToDateTimeDisplay')
  final String? toDateTimeDisplay;
  @JsonKey(name: 'RoundTripRental')
  final bool? roundTripRental;
  @JsonKey(name: 'Late')
  final bool? late;
  @JsonKey(name: 'LateButReturning')
  final bool? lateButReturning;
  @JsonKey(name: 'QcRequired')
  final bool? qcRequired;
  @JsonKey(name: 'EnableQcDelay')
  final bool? enableQcDelay;
  @JsonKey(name: 'QcDelayDays')
  final int? qcDelayDays;
  @JsonKey(name: 'QcDelayExcludeWeekend')
  final bool? qcDelayExcludeWeekend;
  @JsonKey(name: 'QcDelayExcludeHoliday')
  final bool? qcDelayExcludeHoliday;
  @JsonKey(name: 'QcDelayIndefinite')
  final bool? qcDelayIndefinite;
  @JsonKey(name: 'QcDelayFromDateTime')
  final DateTime? qcDelayFromDateTime;
  @JsonKey(name: 'QcDelayToDateTime')
  final DateTime? qcDelayToDateTime;
  @JsonKey(name: 'QcQuantity')
  final double? qcQuantity;
  @JsonKey(name: 'ContainerBarCode')
  final String? containerBarCode;
  @JsonKey(name: 'AvailableWhileInContainer')
  final bool? availableWhileInContainer;
  @JsonKey(name: 'ContractId')
  final String? contractId;
  @JsonKey(name: 'QuantityOrdered')
  final double? quantityOrdered;
  @JsonKey(name: 'QuantitySub')
  final double? quantitySub;
  @JsonKey(name: 'QuantityConsigned')
  final double? quantityConsigned;
  @JsonKey(name: 'IsPositiveConflict')
  final bool? isPositiveConflict;
  @JsonKey(name: 'IsNegativeConflict')
  final bool? isNegativeConflict;
  @JsonKey(name: 'SubPurchaseOrderId')
  final String? subPurchaseOrderId;
  @JsonKey(name: 'SubPurchaseOrderNumber')
  final String? subPurchaseOrderNumber;
  @JsonKey(name: 'SubPurchaseOrderDescription')
  final String? subPurchaseOrderDescription;
  @JsonKey(name: 'SubPurchaseOrderVendor')
  final String? subPurchaseOrderVendor;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityReservationFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityReservationToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityReservationToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityReservation &&
            (identical(other.quantityReserved, quantityReserved) ||
                const DeepCollectionEquality()
                    .equals(other.quantityReserved, quantityReserved)) &&
            (identical(other.quantityStaged, quantityStaged) ||
                const DeepCollectionEquality()
                    .equals(other.quantityStaged, quantityStaged)) &&
            (identical(other.quantityOut, quantityOut) ||
                const DeepCollectionEquality()
                    .equals(other.quantityOut, quantityOut)) &&
            (identical(other.quantityIn, quantityIn) ||
                const DeepCollectionEquality()
                    .equals(other.quantityIn, quantityIn)) &&
            (identical(other.quantityInRepair, quantityInRepair) ||
                const DeepCollectionEquality()
                    .equals(other.quantityInRepair, quantityInRepair)) &&
            (identical(other.quantityLate, quantityLate) ||
                const DeepCollectionEquality()
                    .equals(other.quantityLate, quantityLate)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouseCode, warehouseCode) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.warehouse, warehouse) ||
                const DeepCollectionEquality()
                    .equals(other.warehouse, warehouse)) &&
            (identical(other.returnToWarehouseId, returnToWarehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.returnToWarehouseId, returnToWarehouseId)) &&
            (identical(other.returnToWarehouseCode, returnToWarehouseCode) ||
                const DeepCollectionEquality().equals(
                    other.returnToWarehouseCode, returnToWarehouseCode)) &&
            (identical(other.returnToWarehouse, returnToWarehouse) ||
                const DeepCollectionEquality()
                    .equals(other.returnToWarehouse, returnToWarehouse)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderItemId, orderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.orderItemId, orderItemId)) &&
            (identical(other.recType, recType) ||
                const DeepCollectionEquality().equals(other.recType, recType)) &&
            (identical(other.orderType, orderType) || const DeepCollectionEquality().equals(other.orderType, orderType)) &&
            (identical(other.orderTypeDescription, orderTypeDescription) || const DeepCollectionEquality().equals(other.orderTypeDescription, orderTypeDescription)) &&
            (identical(other.orderNumber, orderNumber) || const DeepCollectionEquality().equals(other.orderNumber, orderNumber)) &&
            (identical(other.orderDescription, orderDescription) || const DeepCollectionEquality().equals(other.orderDescription, orderDescription)) &&
            (identical(other.orderStatus, orderStatus) || const DeepCollectionEquality().equals(other.orderStatus, orderStatus)) &&
            (identical(other.departmentId, departmentId) || const DeepCollectionEquality().equals(other.departmentId, departmentId)) &&
            (identical(other.department, department) || const DeepCollectionEquality().equals(other.department, department)) &&
            (identical(other.dealId, dealId) || const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.deal, deal) || const DeepCollectionEquality().equals(other.deal, deal)) &&
            (identical(other.fromDateTime, fromDateTime) || const DeepCollectionEquality().equals(other.fromDateTime, fromDateTime)) &&
            (identical(other.fromDateTimeDisplay, fromDateTimeDisplay) || const DeepCollectionEquality().equals(other.fromDateTimeDisplay, fromDateTimeDisplay)) &&
            (identical(other.toDateTime, toDateTime) || const DeepCollectionEquality().equals(other.toDateTime, toDateTime)) &&
            (identical(other.toDateTimeDisplay, toDateTimeDisplay) || const DeepCollectionEquality().equals(other.toDateTimeDisplay, toDateTimeDisplay)) &&
            (identical(other.roundTripRental, roundTripRental) || const DeepCollectionEquality().equals(other.roundTripRental, roundTripRental)) &&
            (identical(other.late, late) || const DeepCollectionEquality().equals(other.late, late)) &&
            (identical(other.lateButReturning, lateButReturning) || const DeepCollectionEquality().equals(other.lateButReturning, lateButReturning)) &&
            (identical(other.qcRequired, qcRequired) || const DeepCollectionEquality().equals(other.qcRequired, qcRequired)) &&
            (identical(other.enableQcDelay, enableQcDelay) || const DeepCollectionEquality().equals(other.enableQcDelay, enableQcDelay)) &&
            (identical(other.qcDelayDays, qcDelayDays) || const DeepCollectionEquality().equals(other.qcDelayDays, qcDelayDays)) &&
            (identical(other.qcDelayExcludeWeekend, qcDelayExcludeWeekend) || const DeepCollectionEquality().equals(other.qcDelayExcludeWeekend, qcDelayExcludeWeekend)) &&
            (identical(other.qcDelayExcludeHoliday, qcDelayExcludeHoliday) || const DeepCollectionEquality().equals(other.qcDelayExcludeHoliday, qcDelayExcludeHoliday)) &&
            (identical(other.qcDelayIndefinite, qcDelayIndefinite) || const DeepCollectionEquality().equals(other.qcDelayIndefinite, qcDelayIndefinite)) &&
            (identical(other.qcDelayFromDateTime, qcDelayFromDateTime) || const DeepCollectionEquality().equals(other.qcDelayFromDateTime, qcDelayFromDateTime)) &&
            (identical(other.qcDelayToDateTime, qcDelayToDateTime) || const DeepCollectionEquality().equals(other.qcDelayToDateTime, qcDelayToDateTime)) &&
            (identical(other.qcQuantity, qcQuantity) || const DeepCollectionEquality().equals(other.qcQuantity, qcQuantity)) &&
            (identical(other.containerBarCode, containerBarCode) || const DeepCollectionEquality().equals(other.containerBarCode, containerBarCode)) &&
            (identical(other.availableWhileInContainer, availableWhileInContainer) || const DeepCollectionEquality().equals(other.availableWhileInContainer, availableWhileInContainer)) &&
            (identical(other.contractId, contractId) || const DeepCollectionEquality().equals(other.contractId, contractId)) &&
            (identical(other.quantityOrdered, quantityOrdered) || const DeepCollectionEquality().equals(other.quantityOrdered, quantityOrdered)) &&
            (identical(other.quantitySub, quantitySub) || const DeepCollectionEquality().equals(other.quantitySub, quantitySub)) &&
            (identical(other.quantityConsigned, quantityConsigned) || const DeepCollectionEquality().equals(other.quantityConsigned, quantityConsigned)) &&
            (identical(other.isPositiveConflict, isPositiveConflict) || const DeepCollectionEquality().equals(other.isPositiveConflict, isPositiveConflict)) &&
            (identical(other.isNegativeConflict, isNegativeConflict) || const DeepCollectionEquality().equals(other.isNegativeConflict, isNegativeConflict)) &&
            (identical(other.subPurchaseOrderId, subPurchaseOrderId) || const DeepCollectionEquality().equals(other.subPurchaseOrderId, subPurchaseOrderId)) &&
            (identical(other.subPurchaseOrderNumber, subPurchaseOrderNumber) || const DeepCollectionEquality().equals(other.subPurchaseOrderNumber, subPurchaseOrderNumber)) &&
            (identical(other.subPurchaseOrderDescription, subPurchaseOrderDescription) || const DeepCollectionEquality().equals(other.subPurchaseOrderDescription, subPurchaseOrderDescription)) &&
            (identical(other.subPurchaseOrderVendor, subPurchaseOrderVendor) || const DeepCollectionEquality().equals(other.subPurchaseOrderVendor, subPurchaseOrderVendor)));
  }
}

extension $WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityReservationExtension
    on WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityReservation {
  WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityReservation copyWith(
      {WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
          quantityReserved,
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
          quantityStaged,
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
          quantityOut,
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
          quantityIn,
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
          quantityInRepair,
      WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityQuantity?
          quantityLate,
      String? inventoryId,
      String? warehouseId,
      String? warehouseCode,
      String? warehouse,
      String? returnToWarehouseId,
      String? returnToWarehouseCode,
      String? returnToWarehouse,
      String? orderId,
      String? orderItemId,
      String? recType,
      String? orderType,
      String? orderTypeDescription,
      String? orderNumber,
      String? orderDescription,
      String? orderStatus,
      String? departmentId,
      String? department,
      String? dealId,
      String? deal,
      DateTime? fromDateTime,
      String? fromDateTimeDisplay,
      DateTime? toDateTime,
      String? toDateTimeDisplay,
      bool? roundTripRental,
      bool? late,
      bool? lateButReturning,
      bool? qcRequired,
      bool? enableQcDelay,
      int? qcDelayDays,
      bool? qcDelayExcludeWeekend,
      bool? qcDelayExcludeHoliday,
      bool? qcDelayIndefinite,
      DateTime? qcDelayFromDateTime,
      DateTime? qcDelayToDateTime,
      double? qcQuantity,
      String? containerBarCode,
      bool? availableWhileInContainer,
      String? contractId,
      double? quantityOrdered,
      double? quantitySub,
      double? quantityConsigned,
      bool? isPositiveConflict,
      bool? isNegativeConflict,
      String? subPurchaseOrderId,
      String? subPurchaseOrderNumber,
      String? subPurchaseOrderDescription,
      String? subPurchaseOrderVendor}) {
    return WebApiModulesHomeControlsInventoryAvailabilityTInventoryWarehouseAvailabilityReservation(
        quantityReserved: quantityReserved ?? this.quantityReserved,
        quantityStaged: quantityStaged ?? this.quantityStaged,
        quantityOut: quantityOut ?? this.quantityOut,
        quantityIn: quantityIn ?? this.quantityIn,
        quantityInRepair: quantityInRepair ?? this.quantityInRepair,
        quantityLate: quantityLate ?? this.quantityLate,
        inventoryId: inventoryId ?? this.inventoryId,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        warehouse: warehouse ?? this.warehouse,
        returnToWarehouseId: returnToWarehouseId ?? this.returnToWarehouseId,
        returnToWarehouseCode:
            returnToWarehouseCode ?? this.returnToWarehouseCode,
        returnToWarehouse: returnToWarehouse ?? this.returnToWarehouse,
        orderId: orderId ?? this.orderId,
        orderItemId: orderItemId ?? this.orderItemId,
        recType: recType ?? this.recType,
        orderType: orderType ?? this.orderType,
        orderTypeDescription: orderTypeDescription ?? this.orderTypeDescription,
        orderNumber: orderNumber ?? this.orderNumber,
        orderDescription: orderDescription ?? this.orderDescription,
        orderStatus: orderStatus ?? this.orderStatus,
        departmentId: departmentId ?? this.departmentId,
        department: department ?? this.department,
        dealId: dealId ?? this.dealId,
        deal: deal ?? this.deal,
        fromDateTime: fromDateTime ?? this.fromDateTime,
        fromDateTimeDisplay: fromDateTimeDisplay ?? this.fromDateTimeDisplay,
        toDateTime: toDateTime ?? this.toDateTime,
        toDateTimeDisplay: toDateTimeDisplay ?? this.toDateTimeDisplay,
        roundTripRental: roundTripRental ?? this.roundTripRental,
        late: late ?? this.late,
        lateButReturning: lateButReturning ?? this.lateButReturning,
        qcRequired: qcRequired ?? this.qcRequired,
        enableQcDelay: enableQcDelay ?? this.enableQcDelay,
        qcDelayDays: qcDelayDays ?? this.qcDelayDays,
        qcDelayExcludeWeekend:
            qcDelayExcludeWeekend ?? this.qcDelayExcludeWeekend,
        qcDelayExcludeHoliday:
            qcDelayExcludeHoliday ?? this.qcDelayExcludeHoliday,
        qcDelayIndefinite: qcDelayIndefinite ?? this.qcDelayIndefinite,
        qcDelayFromDateTime: qcDelayFromDateTime ?? this.qcDelayFromDateTime,
        qcDelayToDateTime: qcDelayToDateTime ?? this.qcDelayToDateTime,
        qcQuantity: qcQuantity ?? this.qcQuantity,
        containerBarCode: containerBarCode ?? this.containerBarCode,
        availableWhileInContainer:
            availableWhileInContainer ?? this.availableWhileInContainer,
        contractId: contractId ?? this.contractId,
        quantityOrdered: quantityOrdered ?? this.quantityOrdered,
        quantitySub: quantitySub ?? this.quantitySub,
        quantityConsigned: quantityConsigned ?? this.quantityConsigned,
        isPositiveConflict: isPositiveConflict ?? this.isPositiveConflict,
        isNegativeConflict: isNegativeConflict ?? this.isNegativeConflict,
        subPurchaseOrderId: subPurchaseOrderId ?? this.subPurchaseOrderId,
        subPurchaseOrderNumber:
            subPurchaseOrderNumber ?? this.subPurchaseOrderNumber,
        subPurchaseOrderDescription:
            subPurchaseOrderDescription ?? this.subPurchaseOrderDescription,
        subPurchaseOrderVendor:
            subPurchaseOrderVendor ?? this.subPurchaseOrderVendor);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryAvailabilityTPackageAccessory {
  WebApiModulesHomeControlsInventoryAvailabilityTPackageAccessory({
    this.inventoryId,
    this.defaultQuantity,
  });

  factory WebApiModulesHomeControlsInventoryAvailabilityTPackageAccessory.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryAvailabilityTPackageAccessoryFromJson(
          json);

  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'DefaultQuantity')
  final double? defaultQuantity;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityTPackageAccessoryFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryAvailabilityTPackageAccessoryToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryAvailabilityTPackageAccessoryToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryAvailabilityTPackageAccessory &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.defaultQuantity, defaultQuantity) ||
                const DeepCollectionEquality()
                    .equals(other.defaultQuantity, defaultQuantity)));
  }
}

extension $WebApiModulesHomeControlsInventoryAvailabilityTPackageAccessoryExtension
    on WebApiModulesHomeControlsInventoryAvailabilityTPackageAccessory {
  WebApiModulesHomeControlsInventoryAvailabilityTPackageAccessory copyWith(
      {String? inventoryId, double? defaultQuantity}) {
    return WebApiModulesHomeControlsInventoryAvailabilityTPackageAccessory(
        inventoryId: inventoryId ?? this.inventoryId,
        defaultQuantity: defaultQuantity ?? this.defaultQuantity);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryColorInventoryColor {
  WebApiModulesHomeControlsInventoryColorInventoryColor({
    this.inventoryColorId,
    this.inventoryId,
    this.colorId,
    this.color,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsInventoryColorInventoryColor.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryColorInventoryColorFromJson(json);

  @JsonKey(name: 'InventoryColorId')
  final String? inventoryColorId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'ColorId')
  final String? colorId;
  @JsonKey(name: 'Color')
  final String? color;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryColorInventoryColorFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryColorInventoryColorToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryColorInventoryColorToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryColorInventoryColor &&
            (identical(other.inventoryColorId, inventoryColorId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryColorId, inventoryColorId)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.colorId, colorId) ||
                const DeepCollectionEquality()
                    .equals(other.colorId, colorId)) &&
            (identical(other.color, color) ||
                const DeepCollectionEquality().equals(other.color, color)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsInventoryColorInventoryColorExtension
    on WebApiModulesHomeControlsInventoryColorInventoryColor {
  WebApiModulesHomeControlsInventoryColorInventoryColor copyWith(
      {String? inventoryColorId,
      String? inventoryId,
      String? colorId,
      String? color,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsInventoryColorInventoryColor(
        inventoryColorId: inventoryColorId ?? this.inventoryColorId,
        inventoryId: inventoryId ?? this.inventoryId,
        colorId: colorId ?? this.colorId,
        color: color ?? this.color,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryCompatibleInventoryCompatible {
  WebApiModulesHomeControlsInventoryCompatibleInventoryCompatible({
    this.inventoryCompatibleId,
    this.inventoryId,
    this.iCode,
    this.description,
    this.compatibleWithInventoryId,
    this.compatibleWithICode,
    this.compatibleWithDescription,
    this.compatibleWithClassification,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsInventoryCompatibleInventoryCompatible.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryCompatibleInventoryCompatibleFromJson(
          json);

  @JsonKey(name: 'InventoryCompatibleId')
  final String? inventoryCompatibleId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'CompatibleWithInventoryId')
  final String? compatibleWithInventoryId;
  @JsonKey(name: 'CompatibleWithICode')
  final String? compatibleWithICode;
  @JsonKey(name: 'CompatibleWithDescription')
  final String? compatibleWithDescription;
  @JsonKey(name: 'CompatibleWithClassification')
  final String? compatibleWithClassification;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryCompatibleInventoryCompatibleFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryCompatibleInventoryCompatibleToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryCompatibleInventoryCompatibleToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryCompatibleInventoryCompatible &&
            (identical(other.inventoryCompatibleId, inventoryCompatibleId) ||
                const DeepCollectionEquality().equals(
                    other.inventoryCompatibleId, inventoryCompatibleId)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.compatibleWithInventoryId, compatibleWithInventoryId) ||
                const DeepCollectionEquality().equals(
                    other.compatibleWithInventoryId,
                    compatibleWithInventoryId)) &&
            (identical(other.compatibleWithICode, compatibleWithICode) ||
                const DeepCollectionEquality()
                    .equals(other.compatibleWithICode, compatibleWithICode)) &&
            (identical(other.compatibleWithDescription, compatibleWithDescription) ||
                const DeepCollectionEquality().equals(
                    other.compatibleWithDescription,
                    compatibleWithDescription)) &&
            (identical(other.compatibleWithClassification, compatibleWithClassification) ||
                const DeepCollectionEquality().equals(
                    other.compatibleWithClassification,
                    compatibleWithClassification)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsInventoryCompatibleInventoryCompatibleExtension
    on WebApiModulesHomeControlsInventoryCompatibleInventoryCompatible {
  WebApiModulesHomeControlsInventoryCompatibleInventoryCompatible copyWith(
      {String? inventoryCompatibleId,
      String? inventoryId,
      String? iCode,
      String? description,
      String? compatibleWithInventoryId,
      String? compatibleWithICode,
      String? compatibleWithDescription,
      String? compatibleWithClassification,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsInventoryCompatibleInventoryCompatible(
        inventoryCompatibleId:
            inventoryCompatibleId ?? this.inventoryCompatibleId,
        inventoryId: inventoryId ?? this.inventoryId,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        compatibleWithInventoryId:
            compatibleWithInventoryId ?? this.compatibleWithInventoryId,
        compatibleWithICode: compatibleWithICode ?? this.compatibleWithICode,
        compatibleWithDescription:
            compatibleWithDescription ?? this.compatibleWithDescription,
        compatibleWithClassification:
            compatibleWithClassification ?? this.compatibleWithClassification,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryCompleteKitCreateCompleteResponse {
  WebApiModulesHomeControlsInventoryCompleteKitCreateCompleteResponse({
    this.packageId,
  });

  factory WebApiModulesHomeControlsInventoryCompleteKitCreateCompleteResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryCompleteKitCreateCompleteResponseFromJson(
          json);

  @JsonKey(name: 'PackageId')
  final String? packageId;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryCompleteKitCreateCompleteResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryCompleteKitCreateCompleteResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryCompleteKitCreateCompleteResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryCompleteKitCreateCompleteResponse &&
            (identical(other.packageId, packageId) ||
                const DeepCollectionEquality()
                    .equals(other.packageId, packageId)));
  }
}

extension $WebApiModulesHomeControlsInventoryCompleteKitCreateCompleteResponseExtension
    on WebApiModulesHomeControlsInventoryCompleteKitCreateCompleteResponse {
  WebApiModulesHomeControlsInventoryCompleteKitCreateCompleteResponse copyWith(
      {String? packageId}) {
    return WebApiModulesHomeControlsInventoryCompleteKitCreateCompleteResponse(
        packageId: packageId ?? this.packageId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKit {
  WebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKit({
    this.inventoryId,
    this.packageId,
    this.iCode,
    this.description,
    this.itemClass,
    this.inventoryTypeId,
    this.inventoryType,
    this.categoryId,
    this.category,
    this.subCategoryId,
    this.subCategory,
    this.warehouseId,
    this.warehouse,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKit.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKitFromJson(
          json);

  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'PackageId')
  final String? packageId;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'ItemClass')
  final String? itemClass;
  @JsonKey(name: 'InventoryTypeId')
  final String? inventoryTypeId;
  @JsonKey(name: 'InventoryType')
  final String? inventoryType;
  @JsonKey(name: 'CategoryId')
  final String? categoryId;
  @JsonKey(name: 'Category')
  final String? category;
  @JsonKey(name: 'SubCategoryId')
  final String? subCategoryId;
  @JsonKey(name: 'SubCategory')
  final String? subCategory;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKitFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKitToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKitToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKit &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.packageId, packageId) ||
                const DeepCollectionEquality()
                    .equals(other.packageId, packageId)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.itemClass, itemClass) ||
                const DeepCollectionEquality()
                    .equals(other.itemClass, itemClass)) &&
            (identical(other.inventoryTypeId, inventoryTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryTypeId, inventoryTypeId)) &&
            (identical(other.inventoryType, inventoryType) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryType, inventoryType)) &&
            (identical(other.categoryId, categoryId) ||
                const DeepCollectionEquality()
                    .equals(other.categoryId, categoryId)) &&
            (identical(other.category, category) ||
                const DeepCollectionEquality()
                    .equals(other.category, category)) &&
            (identical(other.subCategoryId, subCategoryId) ||
                const DeepCollectionEquality()
                    .equals(other.subCategoryId, subCategoryId)) &&
            (identical(other.subCategory, subCategory) ||
                const DeepCollectionEquality()
                    .equals(other.subCategory, subCategory)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouse, warehouse) ||
                const DeepCollectionEquality()
                    .equals(other.warehouse, warehouse)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKitExtension
    on WebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKit {
  WebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKit copyWith(
      {String? inventoryId,
      String? packageId,
      String? iCode,
      String? description,
      String? itemClass,
      String? inventoryTypeId,
      String? inventoryType,
      String? categoryId,
      String? category,
      String? subCategoryId,
      String? subCategory,
      String? warehouseId,
      String? warehouse,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsInventoryCompleteKitInventoryCompleteKit(
        inventoryId: inventoryId ?? this.inventoryId,
        packageId: packageId ?? this.packageId,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        itemClass: itemClass ?? this.itemClass,
        inventoryTypeId: inventoryTypeId ?? this.inventoryTypeId,
        inventoryType: inventoryType ?? this.inventoryType,
        categoryId: categoryId ?? this.categoryId,
        category: category ?? this.category,
        subCategoryId: subCategoryId ?? this.subCategoryId,
        subCategory: subCategory ?? this.subCategory,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouse: warehouse ?? this.warehouse,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryConsignorInventoryConsignor {
  WebApiModulesHomeControlsInventoryConsignorInventoryConsignor({
    this.consignorId,
    this.consignorAgreementId,
    this.consignor,
    this.agreementNumber,
    this.agreementDescription,
    this.inventoryId,
    this.iCode,
    this.description,
    this.trackedBy,
    this.treatConsignedQtyAsOwned,
    this.qtyConsigned,
    this.consignorPercent,
    this.housePercent,
    this.flatRate,
    this.flatRateAmount,
    this.itemId,
    this.barCode,
    this.serialNumber,
    this.inventoryStatusId,
    this.inventoryStatus,
    this.inventoryStatusType,
    this.warehouseId,
    this.warehouse,
    this.warehouseCode,
    this.textColor,
    this.color,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsInventoryConsignorInventoryConsignor.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryConsignorInventoryConsignorFromJson(
          json);

  @JsonKey(name: 'ConsignorId')
  final String? consignorId;
  @JsonKey(name: 'ConsignorAgreementId')
  final String? consignorAgreementId;
  @JsonKey(name: 'Consignor')
  final String? consignor;
  @JsonKey(name: 'AgreementNumber')
  final String? agreementNumber;
  @JsonKey(name: 'AgreementDescription')
  final String? agreementDescription;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'TrackedBy')
  final String? trackedBy;
  @JsonKey(name: 'TreatConsignedQtyAsOwned')
  final bool? treatConsignedQtyAsOwned;
  @JsonKey(name: 'QtyConsigned')
  final int? qtyConsigned;
  @JsonKey(name: 'ConsignorPercent')
  final int? consignorPercent;
  @JsonKey(name: 'HousePercent')
  final int? housePercent;
  @JsonKey(name: 'FlatRate')
  final bool? flatRate;
  @JsonKey(name: 'FlatRateAmount')
  final double? flatRateAmount;
  @JsonKey(name: 'ItemId')
  final String? itemId;
  @JsonKey(name: 'BarCode')
  final String? barCode;
  @JsonKey(name: 'SerialNumber')
  final String? serialNumber;
  @JsonKey(name: 'InventoryStatusId')
  final String? inventoryStatusId;
  @JsonKey(name: 'InventoryStatus')
  final String? inventoryStatus;
  @JsonKey(name: 'InventoryStatusType')
  final String? inventoryStatusType;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'TextColor')
  final String? textColor;
  @JsonKey(name: 'Color')
  final int? color;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryConsignorInventoryConsignorFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryConsignorInventoryConsignorToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryConsignorInventoryConsignorToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryConsignorInventoryConsignor &&
            (identical(other.consignorId, consignorId) ||
                const DeepCollectionEquality()
                    .equals(other.consignorId, consignorId)) &&
            (identical(other.consignorAgreementId, consignorAgreementId) ||
                const DeepCollectionEquality().equals(
                    other.consignorAgreementId, consignorAgreementId)) &&
            (identical(other.consignor, consignor) ||
                const DeepCollectionEquality()
                    .equals(other.consignor, consignor)) &&
            (identical(other.agreementNumber, agreementNumber) ||
                const DeepCollectionEquality()
                    .equals(other.agreementNumber, agreementNumber)) &&
            (identical(other.agreementDescription, agreementDescription) ||
                const DeepCollectionEquality().equals(
                    other.agreementDescription, agreementDescription)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.trackedBy, trackedBy) ||
                const DeepCollectionEquality()
                    .equals(other.trackedBy, trackedBy)) &&
            (identical(other.treatConsignedQtyAsOwned, treatConsignedQtyAsOwned) ||
                const DeepCollectionEquality().equals(
                    other.treatConsignedQtyAsOwned,
                    treatConsignedQtyAsOwned)) &&
            (identical(other.qtyConsigned, qtyConsigned) ||
                const DeepCollectionEquality()
                    .equals(other.qtyConsigned, qtyConsigned)) &&
            (identical(other.consignorPercent, consignorPercent) ||
                const DeepCollectionEquality()
                    .equals(other.consignorPercent, consignorPercent)) &&
            (identical(other.housePercent, housePercent) ||
                const DeepCollectionEquality()
                    .equals(other.housePercent, housePercent)) &&
            (identical(other.flatRate, flatRate) ||
                const DeepCollectionEquality()
                    .equals(other.flatRate, flatRate)) &&
            (identical(other.flatRateAmount, flatRateAmount) ||
                const DeepCollectionEquality()
                    .equals(other.flatRateAmount, flatRateAmount)) &&
            (identical(other.itemId, itemId) || const DeepCollectionEquality().equals(other.itemId, itemId)) &&
            (identical(other.barCode, barCode) || const DeepCollectionEquality().equals(other.barCode, barCode)) &&
            (identical(other.serialNumber, serialNumber) || const DeepCollectionEquality().equals(other.serialNumber, serialNumber)) &&
            (identical(other.inventoryStatusId, inventoryStatusId) || const DeepCollectionEquality().equals(other.inventoryStatusId, inventoryStatusId)) &&
            (identical(other.inventoryStatus, inventoryStatus) || const DeepCollectionEquality().equals(other.inventoryStatus, inventoryStatus)) &&
            (identical(other.inventoryStatusType, inventoryStatusType) || const DeepCollectionEquality().equals(other.inventoryStatusType, inventoryStatusType)) &&
            (identical(other.warehouseId, warehouseId) || const DeepCollectionEquality().equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouse, warehouse) || const DeepCollectionEquality().equals(other.warehouse, warehouse)) &&
            (identical(other.warehouseCode, warehouseCode) || const DeepCollectionEquality().equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.textColor, textColor) || const DeepCollectionEquality().equals(other.textColor, textColor)) &&
            (identical(other.color, color) || const DeepCollectionEquality().equals(other.color, color)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsInventoryConsignorInventoryConsignorExtension
    on WebApiModulesHomeControlsInventoryConsignorInventoryConsignor {
  WebApiModulesHomeControlsInventoryConsignorInventoryConsignor copyWith(
      {String? consignorId,
      String? consignorAgreementId,
      String? consignor,
      String? agreementNumber,
      String? agreementDescription,
      String? inventoryId,
      String? iCode,
      String? description,
      String? trackedBy,
      bool? treatConsignedQtyAsOwned,
      int? qtyConsigned,
      int? consignorPercent,
      int? housePercent,
      bool? flatRate,
      double? flatRateAmount,
      String? itemId,
      String? barCode,
      String? serialNumber,
      String? inventoryStatusId,
      String? inventoryStatus,
      String? inventoryStatusType,
      String? warehouseId,
      String? warehouse,
      String? warehouseCode,
      String? textColor,
      int? color,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsInventoryConsignorInventoryConsignor(
        consignorId: consignorId ?? this.consignorId,
        consignorAgreementId: consignorAgreementId ?? this.consignorAgreementId,
        consignor: consignor ?? this.consignor,
        agreementNumber: agreementNumber ?? this.agreementNumber,
        agreementDescription: agreementDescription ?? this.agreementDescription,
        inventoryId: inventoryId ?? this.inventoryId,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        trackedBy: trackedBy ?? this.trackedBy,
        treatConsignedQtyAsOwned:
            treatConsignedQtyAsOwned ?? this.treatConsignedQtyAsOwned,
        qtyConsigned: qtyConsigned ?? this.qtyConsigned,
        consignorPercent: consignorPercent ?? this.consignorPercent,
        housePercent: housePercent ?? this.housePercent,
        flatRate: flatRate ?? this.flatRate,
        flatRateAmount: flatRateAmount ?? this.flatRateAmount,
        itemId: itemId ?? this.itemId,
        barCode: barCode ?? this.barCode,
        serialNumber: serialNumber ?? this.serialNumber,
        inventoryStatusId: inventoryStatusId ?? this.inventoryStatusId,
        inventoryStatus: inventoryStatus ?? this.inventoryStatus,
        inventoryStatusType: inventoryStatusType ?? this.inventoryStatusType,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouse: warehouse ?? this.warehouse,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        textColor: textColor ?? this.textColor,
        color: color ?? this.color,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryContainerItemInventoryContainerItem {
  WebApiModulesHomeControlsInventoryContainerItemInventoryContainerItem({
    this.containerItemId,
    this.packageId,
    this.containerId,
    this.rowNumber,
    this.iCode,
    this.description,
    this.trackedBy,
    this.quantityOrdered,
    this.price,
    this.notes,
    this.inventoryId,
    this.recType,
    this.ident,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsInventoryContainerItemInventoryContainerItem.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryContainerItemInventoryContainerItemFromJson(
          json);

  @JsonKey(name: 'ContainerItemId')
  final String? containerItemId;
  @JsonKey(name: 'PackageId')
  final String? packageId;
  @JsonKey(name: 'ContainerId')
  final String? containerId;
  @JsonKey(name: 'RowNumber')
  final int? rowNumber;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'TrackedBy')
  final String? trackedBy;
  @JsonKey(name: 'QuantityOrdered')
  final double? quantityOrdered;
  @JsonKey(name: 'Price')
  final double? price;
  @JsonKey(name: 'Notes')
  final String? notes;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'RecType')
  final String? recType;
  @JsonKey(name: 'Ident')
  final int? ident;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryContainerItemInventoryContainerItemFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryContainerItemInventoryContainerItemToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryContainerItemInventoryContainerItemToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryContainerItemInventoryContainerItem &&
            (identical(other.containerItemId, containerItemId) ||
                const DeepCollectionEquality()
                    .equals(other.containerItemId, containerItemId)) &&
            (identical(other.packageId, packageId) ||
                const DeepCollectionEquality()
                    .equals(other.packageId, packageId)) &&
            (identical(other.containerId, containerId) ||
                const DeepCollectionEquality()
                    .equals(other.containerId, containerId)) &&
            (identical(other.rowNumber, rowNumber) ||
                const DeepCollectionEquality()
                    .equals(other.rowNumber, rowNumber)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.trackedBy, trackedBy) ||
                const DeepCollectionEquality()
                    .equals(other.trackedBy, trackedBy)) &&
            (identical(other.quantityOrdered, quantityOrdered) ||
                const DeepCollectionEquality()
                    .equals(other.quantityOrdered, quantityOrdered)) &&
            (identical(other.price, price) ||
                const DeepCollectionEquality().equals(other.price, price)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.recType, recType) ||
                const DeepCollectionEquality()
                    .equals(other.recType, recType)) &&
            (identical(other.ident, ident) ||
                const DeepCollectionEquality().equals(other.ident, ident)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsInventoryContainerItemInventoryContainerItemExtension
    on WebApiModulesHomeControlsInventoryContainerItemInventoryContainerItem {
  WebApiModulesHomeControlsInventoryContainerItemInventoryContainerItem
      copyWith(
          {String? containerItemId,
          String? packageId,
          String? containerId,
          int? rowNumber,
          String? iCode,
          String? description,
          String? trackedBy,
          double? quantityOrdered,
          double? price,
          String? notes,
          String? inventoryId,
          String? recType,
          int? ident,
          String? dateStamp,
          String? recordTitle,
          List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
          List<FwStandardDataFwCustomValue>? custom,
          List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsInventoryContainerItemInventoryContainerItem(
        containerItemId: containerItemId ?? this.containerItemId,
        packageId: packageId ?? this.packageId,
        containerId: containerId ?? this.containerId,
        rowNumber: rowNumber ?? this.rowNumber,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        trackedBy: trackedBy ?? this.trackedBy,
        quantityOrdered: quantityOrdered ?? this.quantityOrdered,
        price: price ?? this.price,
        notes: notes ?? this.notes,
        inventoryId: inventoryId ?? this.inventoryId,
        recType: recType ?? this.recType,
        ident: ident ?? this.ident,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryContainerItemSortContainerItemsRequest {
  WebApiModulesHomeControlsInventoryContainerItemSortContainerItemsRequest({
    this.startAtIndex,
    this.containerItemIds,
  });

  factory WebApiModulesHomeControlsInventoryContainerItemSortContainerItemsRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryContainerItemSortContainerItemsRequestFromJson(
          json);

  @JsonKey(name: 'StartAtIndex')
  final int? startAtIndex;
  @JsonKey(name: 'ContainerItemIds', defaultValue: <String>[])
  final List<String>? containerItemIds;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryContainerItemSortContainerItemsRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryContainerItemSortContainerItemsRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryContainerItemSortContainerItemsRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryContainerItemSortContainerItemsRequest &&
            (identical(other.startAtIndex, startAtIndex) ||
                const DeepCollectionEquality()
                    .equals(other.startAtIndex, startAtIndex)) &&
            (identical(other.containerItemIds, containerItemIds) ||
                const DeepCollectionEquality()
                    .equals(other.containerItemIds, containerItemIds)));
  }
}

extension $WebApiModulesHomeControlsInventoryContainerItemSortContainerItemsRequestExtension
    on WebApiModulesHomeControlsInventoryContainerItemSortContainerItemsRequest {
  WebApiModulesHomeControlsInventoryContainerItemSortContainerItemsRequest
      copyWith({int? startAtIndex, List<String>? containerItemIds}) {
    return WebApiModulesHomeControlsInventoryContainerItemSortContainerItemsRequest(
        startAtIndex: startAtIndex ?? this.startAtIndex,
        containerItemIds: containerItemIds ?? this.containerItemIds);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTax {
  WebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTax({
    this.inventoryId,
    this.id,
    this.internalChar,
    this.locationId,
    this.location,
    this.taxable,
    this.modByUsersId,
    this.modByUser,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTax.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTaxFromJson(
          json);

  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'Id')
  final int? id;
  @JsonKey(name: 'InternalChar')
  final String? internalChar;
  @JsonKey(name: 'LocationId')
  final String? locationId;
  @JsonKey(name: 'Location')
  final String? location;
  @JsonKey(name: 'Taxable')
  final bool? taxable;
  @JsonKey(name: 'ModByUsersId')
  final String? modByUsersId;
  @JsonKey(name: 'ModByUser')
  final String? modByUser;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTaxFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTaxToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTaxToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTax &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.internalChar, internalChar) ||
                const DeepCollectionEquality()
                    .equals(other.internalChar, internalChar)) &&
            (identical(other.locationId, locationId) ||
                const DeepCollectionEquality()
                    .equals(other.locationId, locationId)) &&
            (identical(other.location, location) ||
                const DeepCollectionEquality()
                    .equals(other.location, location)) &&
            (identical(other.taxable, taxable) ||
                const DeepCollectionEquality()
                    .equals(other.taxable, taxable)) &&
            (identical(other.modByUsersId, modByUsersId) ||
                const DeepCollectionEquality()
                    .equals(other.modByUsersId, modByUsersId)) &&
            (identical(other.modByUser, modByUser) ||
                const DeepCollectionEquality()
                    .equals(other.modByUser, modByUser)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTaxExtension
    on WebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTax {
  WebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTax copyWith(
      {String? inventoryId,
      int? id,
      String? internalChar,
      String? locationId,
      String? location,
      bool? taxable,
      String? modByUsersId,
      String? modByUser,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsInventoryLocationTaxInventoryLocationTax(
        inventoryId: inventoryId ?? this.inventoryId,
        id: id ?? this.id,
        internalChar: internalChar ?? this.internalChar,
        locationId: locationId ?? this.locationId,
        location: location ?? this.location,
        taxable: taxable ?? this.taxable,
        modByUsersId: modByUsersId ?? this.modByUsersId,
        modByUser: modByUser ?? this.modByUser,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryMaterialInventoryMaterial {
  WebApiModulesHomeControlsInventoryMaterialInventoryMaterial({
    this.inventoryMaterialId,
    this.inventoryId,
    this.materialId,
    this.description,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsInventoryMaterialInventoryMaterial.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryMaterialInventoryMaterialFromJson(
          json);

  @JsonKey(name: 'InventoryMaterialId')
  final String? inventoryMaterialId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'MaterialId')
  final String? materialId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryMaterialInventoryMaterialFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryMaterialInventoryMaterialToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryMaterialInventoryMaterialToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryMaterialInventoryMaterial &&
            (identical(other.inventoryMaterialId, inventoryMaterialId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryMaterialId, inventoryMaterialId)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.materialId, materialId) ||
                const DeepCollectionEquality()
                    .equals(other.materialId, materialId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsInventoryMaterialInventoryMaterialExtension
    on WebApiModulesHomeControlsInventoryMaterialInventoryMaterial {
  WebApiModulesHomeControlsInventoryMaterialInventoryMaterial copyWith(
      {String? inventoryMaterialId,
      String? inventoryId,
      String? materialId,
      String? description,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsInventoryMaterialInventoryMaterial(
        inventoryMaterialId: inventoryMaterialId ?? this.inventoryMaterialId,
        inventoryId: inventoryId ?? this.inventoryId,
        materialId: materialId ?? this.materialId,
        description: description ?? this.description,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventory {
  WebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventory({
    this.deletingWarehouseSpecific,
    this.inventoryPackageInventoryId,
    this.packageId,
    this.inventoryId,
    this.iCode,
    this.iCodeColor,
    this.lineColor,
    this.description,
    this.isPrimary,
    this.defaultQuantity,
    this.isOption,
    this.charge,
    this.isRequired,
    this.optionColor,
    this.itemClass,
    this.itemTrackedBy,
    this.availFor,
    this.availFrom,
    this.categoryOrderBy,
    this.orderBy,
    this.itemColor,
    this.isNestedComplete,
    this.inactive,
    this.warehouseId,
    this.parentId,
    this.packageItemClass,
    this.itemNonDiscountable,
    this.primaryInventoryId,
    this.unitId,
    this.dailyRate,
    this.weeklyRate,
    this.monthlyRate,
    this.price,
    this.retail,
    this.currencyId,
    this.currencyCode,
    this.currencySymbol,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventory.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventoryFromJson(
          json);

  @JsonKey(name: 'deletingWarehouseSpecific')
  final bool? deletingWarehouseSpecific;
  @JsonKey(name: 'InventoryPackageInventoryId')
  final String? inventoryPackageInventoryId;
  @JsonKey(name: 'PackageId')
  final String? packageId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'ICodeColor')
  final String? iCodeColor;
  @JsonKey(name: 'LineColor')
  final String? lineColor;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'IsPrimary')
  final bool? isPrimary;
  @JsonKey(name: 'DefaultQuantity')
  final double? defaultQuantity;
  @JsonKey(name: 'IsOption')
  final bool? isOption;
  @JsonKey(name: 'Charge')
  final bool? charge;
  @JsonKey(name: 'IsRequired')
  final bool? isRequired;
  @JsonKey(name: 'OptionColor')
  final String? optionColor;
  @JsonKey(name: 'ItemClass')
  final String? itemClass;
  @JsonKey(name: 'ItemTrackedBy')
  final String? itemTrackedBy;
  @JsonKey(name: 'AvailFor')
  final String? availFor;
  @JsonKey(name: 'AvailFrom')
  final String? availFrom;
  @JsonKey(name: 'CategoryOrderBy')
  final double? categoryOrderBy;
  @JsonKey(name: 'OrderBy')
  final int? orderBy;
  @JsonKey(name: 'ItemColor')
  final int? itemColor;
  @JsonKey(name: 'IsNestedComplete')
  final bool? isNestedComplete;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'ParentId')
  final String? parentId;
  @JsonKey(name: 'PackageItemClass')
  final String? packageItemClass;
  @JsonKey(name: 'ItemNonDiscountable')
  final bool? itemNonDiscountable;
  @JsonKey(name: 'PrimaryInventoryId')
  final String? primaryInventoryId;
  @JsonKey(name: 'UnitId')
  final String? unitId;
  @JsonKey(name: 'DailyRate')
  final double? dailyRate;
  @JsonKey(name: 'WeeklyRate')
  final double? weeklyRate;
  @JsonKey(name: 'MonthlyRate')
  final double? monthlyRate;
  @JsonKey(name: 'Price')
  final double? price;
  @JsonKey(name: 'Retail')
  final double? retail;
  @JsonKey(name: 'CurrencyId')
  final String? currencyId;
  @JsonKey(name: 'CurrencyCode')
  final String? currencyCode;
  @JsonKey(name: 'CurrencySymbol')
  final String? currencySymbol;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventoryFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventoryToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventoryToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventory &&
            (identical(other.deletingWarehouseSpecific, deletingWarehouseSpecific) ||
                const DeepCollectionEquality().equals(
                    other.deletingWarehouseSpecific,
                    deletingWarehouseSpecific)) &&
            (identical(other.inventoryPackageInventoryId, inventoryPackageInventoryId) ||
                const DeepCollectionEquality().equals(
                    other.inventoryPackageInventoryId,
                    inventoryPackageInventoryId)) &&
            (identical(other.packageId, packageId) ||
                const DeepCollectionEquality()
                    .equals(other.packageId, packageId)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.iCodeColor, iCodeColor) ||
                const DeepCollectionEquality()
                    .equals(other.iCodeColor, iCodeColor)) &&
            (identical(other.lineColor, lineColor) ||
                const DeepCollectionEquality()
                    .equals(other.lineColor, lineColor)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.isPrimary, isPrimary) ||
                const DeepCollectionEquality()
                    .equals(other.isPrimary, isPrimary)) &&
            (identical(other.defaultQuantity, defaultQuantity) ||
                const DeepCollectionEquality()
                    .equals(other.defaultQuantity, defaultQuantity)) &&
            (identical(other.isOption, isOption) ||
                const DeepCollectionEquality()
                    .equals(other.isOption, isOption)) &&
            (identical(other.charge, charge) || const DeepCollectionEquality().equals(other.charge, charge)) &&
            (identical(other.isRequired, isRequired) || const DeepCollectionEquality().equals(other.isRequired, isRequired)) &&
            (identical(other.optionColor, optionColor) || const DeepCollectionEquality().equals(other.optionColor, optionColor)) &&
            (identical(other.itemClass, itemClass) || const DeepCollectionEquality().equals(other.itemClass, itemClass)) &&
            (identical(other.itemTrackedBy, itemTrackedBy) || const DeepCollectionEquality().equals(other.itemTrackedBy, itemTrackedBy)) &&
            (identical(other.availFor, availFor) || const DeepCollectionEquality().equals(other.availFor, availFor)) &&
            (identical(other.availFrom, availFrom) || const DeepCollectionEquality().equals(other.availFrom, availFrom)) &&
            (identical(other.categoryOrderBy, categoryOrderBy) || const DeepCollectionEquality().equals(other.categoryOrderBy, categoryOrderBy)) &&
            (identical(other.orderBy, orderBy) || const DeepCollectionEquality().equals(other.orderBy, orderBy)) &&
            (identical(other.itemColor, itemColor) || const DeepCollectionEquality().equals(other.itemColor, itemColor)) &&
            (identical(other.isNestedComplete, isNestedComplete) || const DeepCollectionEquality().equals(other.isNestedComplete, isNestedComplete)) &&
            (identical(other.inactive, inactive) || const DeepCollectionEquality().equals(other.inactive, inactive)) &&
            (identical(other.warehouseId, warehouseId) || const DeepCollectionEquality().equals(other.warehouseId, warehouseId)) &&
            (identical(other.parentId, parentId) || const DeepCollectionEquality().equals(other.parentId, parentId)) &&
            (identical(other.packageItemClass, packageItemClass) || const DeepCollectionEquality().equals(other.packageItemClass, packageItemClass)) &&
            (identical(other.itemNonDiscountable, itemNonDiscountable) || const DeepCollectionEquality().equals(other.itemNonDiscountable, itemNonDiscountable)) &&
            (identical(other.primaryInventoryId, primaryInventoryId) || const DeepCollectionEquality().equals(other.primaryInventoryId, primaryInventoryId)) &&
            (identical(other.unitId, unitId) || const DeepCollectionEquality().equals(other.unitId, unitId)) &&
            (identical(other.dailyRate, dailyRate) || const DeepCollectionEquality().equals(other.dailyRate, dailyRate)) &&
            (identical(other.weeklyRate, weeklyRate) || const DeepCollectionEquality().equals(other.weeklyRate, weeklyRate)) &&
            (identical(other.monthlyRate, monthlyRate) || const DeepCollectionEquality().equals(other.monthlyRate, monthlyRate)) &&
            (identical(other.price, price) || const DeepCollectionEquality().equals(other.price, price)) &&
            (identical(other.retail, retail) || const DeepCollectionEquality().equals(other.retail, retail)) &&
            (identical(other.currencyId, currencyId) || const DeepCollectionEquality().equals(other.currencyId, currencyId)) &&
            (identical(other.currencyCode, currencyCode) || const DeepCollectionEquality().equals(other.currencyCode, currencyCode)) &&
            (identical(other.currencySymbol, currencySymbol) || const DeepCollectionEquality().equals(other.currencySymbol, currencySymbol)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventoryExtension
    on WebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventory {
  WebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventory
      copyWith(
          {bool? deletingWarehouseSpecific,
          String? inventoryPackageInventoryId,
          String? packageId,
          String? inventoryId,
          String? iCode,
          String? iCodeColor,
          String? lineColor,
          String? description,
          bool? isPrimary,
          double? defaultQuantity,
          bool? isOption,
          bool? charge,
          bool? isRequired,
          String? optionColor,
          String? itemClass,
          String? itemTrackedBy,
          String? availFor,
          String? availFrom,
          double? categoryOrderBy,
          int? orderBy,
          int? itemColor,
          bool? isNestedComplete,
          bool? inactive,
          String? warehouseId,
          String? parentId,
          String? packageItemClass,
          bool? itemNonDiscountable,
          String? primaryInventoryId,
          String? unitId,
          double? dailyRate,
          double? weeklyRate,
          double? monthlyRate,
          double? price,
          double? retail,
          String? currencyId,
          String? currencyCode,
          String? currencySymbol,
          String? dateStamp,
          String? recordTitle,
          List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
          List<FwStandardDataFwCustomValue>? custom,
          List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsInventoryPackageInventoryInventoryPackageInventory(
        deletingWarehouseSpecific:
            deletingWarehouseSpecific ?? this.deletingWarehouseSpecific,
        inventoryPackageInventoryId:
            inventoryPackageInventoryId ?? this.inventoryPackageInventoryId,
        packageId: packageId ?? this.packageId,
        inventoryId: inventoryId ?? this.inventoryId,
        iCode: iCode ?? this.iCode,
        iCodeColor: iCodeColor ?? this.iCodeColor,
        lineColor: lineColor ?? this.lineColor,
        description: description ?? this.description,
        isPrimary: isPrimary ?? this.isPrimary,
        defaultQuantity: defaultQuantity ?? this.defaultQuantity,
        isOption: isOption ?? this.isOption,
        charge: charge ?? this.charge,
        isRequired: isRequired ?? this.isRequired,
        optionColor: optionColor ?? this.optionColor,
        itemClass: itemClass ?? this.itemClass,
        itemTrackedBy: itemTrackedBy ?? this.itemTrackedBy,
        availFor: availFor ?? this.availFor,
        availFrom: availFrom ?? this.availFrom,
        categoryOrderBy: categoryOrderBy ?? this.categoryOrderBy,
        orderBy: orderBy ?? this.orderBy,
        itemColor: itemColor ?? this.itemColor,
        isNestedComplete: isNestedComplete ?? this.isNestedComplete,
        inactive: inactive ?? this.inactive,
        warehouseId: warehouseId ?? this.warehouseId,
        parentId: parentId ?? this.parentId,
        packageItemClass: packageItemClass ?? this.packageItemClass,
        itemNonDiscountable: itemNonDiscountable ?? this.itemNonDiscountable,
        primaryInventoryId: primaryInventoryId ?? this.primaryInventoryId,
        unitId: unitId ?? this.unitId,
        dailyRate: dailyRate ?? this.dailyRate,
        weeklyRate: weeklyRate ?? this.weeklyRate,
        monthlyRate: monthlyRate ?? this.monthlyRate,
        price: price ?? this.price,
        retail: retail ?? this.retail,
        currencyId: currencyId ?? this.currencyId,
        currencyCode: currencyCode ?? this.currencyCode,
        currencySymbol: currencySymbol ?? this.currencySymbol,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryPackageInventorySortInventoryPackageInventorysRequest {
  WebApiModulesHomeControlsInventoryPackageInventorySortInventoryPackageInventorysRequest({
    this.startAtIndex,
    this.inventoryPackageInventoryIds,
  });

  factory WebApiModulesHomeControlsInventoryPackageInventorySortInventoryPackageInventorysRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryPackageInventorySortInventoryPackageInventorysRequestFromJson(
          json);

  @JsonKey(name: 'StartAtIndex')
  final int? startAtIndex;
  @JsonKey(name: 'InventoryPackageInventoryIds', defaultValue: <String>[])
  final List<String>? inventoryPackageInventoryIds;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryPackageInventorySortInventoryPackageInventorysRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryPackageInventorySortInventoryPackageInventorysRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryPackageInventorySortInventoryPackageInventorysRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryPackageInventorySortInventoryPackageInventorysRequest &&
            (identical(other.startAtIndex, startAtIndex) ||
                const DeepCollectionEquality()
                    .equals(other.startAtIndex, startAtIndex)) &&
            (identical(other.inventoryPackageInventoryIds,
                    inventoryPackageInventoryIds) ||
                const DeepCollectionEquality().equals(
                    other.inventoryPackageInventoryIds,
                    inventoryPackageInventoryIds)));
  }
}

extension $WebApiModulesHomeControlsInventoryPackageInventorySortInventoryPackageInventorysRequestExtension
    on WebApiModulesHomeControlsInventoryPackageInventorySortInventoryPackageInventorysRequest {
  WebApiModulesHomeControlsInventoryPackageInventorySortInventoryPackageInventorysRequest
      copyWith(
          {int? startAtIndex, List<String>? inventoryPackageInventoryIds}) {
    return WebApiModulesHomeControlsInventoryPackageInventorySortInventoryPackageInventorysRequest(
        startAtIndex: startAtIndex ?? this.startAtIndex,
        inventoryPackageInventoryIds:
            inventoryPackageInventoryIds ?? this.inventoryPackageInventoryIds);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryPrepInventoryPrep {
  WebApiModulesHomeControlsInventoryPrepInventoryPrep({
    this.inventoryPrepId,
    this.inventoryId,
    this.iCode,
    this.description,
    this.prepRateId,
    this.prepICode,
    this.prepDescription,
    this.prepUnit,
    this.prepUnitType,
    this.isDefault,
    this.prepRate,
    this.prepTime,
    this.prepExtended,
    this.qtyOrdered,
    this.price,
    this.orderId,
    this.masteritemId,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsInventoryPrepInventoryPrep.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryPrepInventoryPrepFromJson(json);

  @JsonKey(name: 'InventoryPrepId')
  final String? inventoryPrepId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'PrepRateId')
  final String? prepRateId;
  @JsonKey(name: 'PrepICode')
  final String? prepICode;
  @JsonKey(name: 'PrepDescription')
  final String? prepDescription;
  @JsonKey(name: 'PrepUnit')
  final String? prepUnit;
  @JsonKey(name: 'PrepUnitType')
  final String? prepUnitType;
  @JsonKey(name: 'IsDefault')
  final bool? isDefault;
  @JsonKey(name: 'PrepRate')
  final double? prepRate;
  @JsonKey(name: 'PrepTime')
  final String? prepTime;
  @JsonKey(name: 'PrepExtended')
  final double? prepExtended;
  @JsonKey(name: 'QtyOrdered')
  final double? qtyOrdered;
  @JsonKey(name: 'Price')
  final double? price;
  @JsonKey(name: 'OrderId')
  final bool? orderId;
  @JsonKey(name: 'MasteritemId')
  final bool? masteritemId;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryPrepInventoryPrepFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryPrepInventoryPrepToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryPrepInventoryPrepToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryPrepInventoryPrep &&
            (identical(other.inventoryPrepId, inventoryPrepId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryPrepId, inventoryPrepId)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.prepRateId, prepRateId) ||
                const DeepCollectionEquality()
                    .equals(other.prepRateId, prepRateId)) &&
            (identical(other.prepICode, prepICode) ||
                const DeepCollectionEquality()
                    .equals(other.prepICode, prepICode)) &&
            (identical(other.prepDescription, prepDescription) ||
                const DeepCollectionEquality()
                    .equals(other.prepDescription, prepDescription)) &&
            (identical(other.prepUnit, prepUnit) ||
                const DeepCollectionEquality()
                    .equals(other.prepUnit, prepUnit)) &&
            (identical(other.prepUnitType, prepUnitType) ||
                const DeepCollectionEquality()
                    .equals(other.prepUnitType, prepUnitType)) &&
            (identical(other.isDefault, isDefault) ||
                const DeepCollectionEquality()
                    .equals(other.isDefault, isDefault)) &&
            (identical(other.prepRate, prepRate) ||
                const DeepCollectionEquality()
                    .equals(other.prepRate, prepRate)) &&
            (identical(other.prepTime, prepTime) ||
                const DeepCollectionEquality()
                    .equals(other.prepTime, prepTime)) &&
            (identical(other.prepExtended, prepExtended) ||
                const DeepCollectionEquality()
                    .equals(other.prepExtended, prepExtended)) &&
            (identical(other.qtyOrdered, qtyOrdered) ||
                const DeepCollectionEquality()
                    .equals(other.qtyOrdered, qtyOrdered)) &&
            (identical(other.price, price) ||
                const DeepCollectionEquality().equals(other.price, price)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.masteritemId, masteritemId) ||
                const DeepCollectionEquality()
                    .equals(other.masteritemId, masteritemId)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsInventoryPrepInventoryPrepExtension
    on WebApiModulesHomeControlsInventoryPrepInventoryPrep {
  WebApiModulesHomeControlsInventoryPrepInventoryPrep copyWith(
      {String? inventoryPrepId,
      String? inventoryId,
      String? iCode,
      String? description,
      String? prepRateId,
      String? prepICode,
      String? prepDescription,
      String? prepUnit,
      String? prepUnitType,
      bool? isDefault,
      double? prepRate,
      String? prepTime,
      double? prepExtended,
      double? qtyOrdered,
      double? price,
      bool? orderId,
      bool? masteritemId,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsInventoryPrepInventoryPrep(
        inventoryPrepId: inventoryPrepId ?? this.inventoryPrepId,
        inventoryId: inventoryId ?? this.inventoryId,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        prepRateId: prepRateId ?? this.prepRateId,
        prepICode: prepICode ?? this.prepICode,
        prepDescription: prepDescription ?? this.prepDescription,
        prepUnit: prepUnit ?? this.prepUnit,
        prepUnitType: prepUnitType ?? this.prepUnitType,
        isDefault: isDefault ?? this.isDefault,
        prepRate: prepRate ?? this.prepRate,
        prepTime: prepTime ?? this.prepTime,
        prepExtended: prepExtended ?? this.prepExtended,
        qtyOrdered: qtyOrdered ?? this.qtyOrdered,
        price: price ?? this.price,
        orderId: orderId ?? this.orderId,
        masteritemId: masteritemId ?? this.masteritemId,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItem {
  WebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItem({
    this.inventoryPurchaseItemId,
    this.sessionId,
    this.barCode,
    this.manufactureDate,
    this.printQuantity,
    this.serialNumber,
    this.rfId,
    this.serialNumberIsMixedCase,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItem.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItemFromJson(
          json);

  @JsonKey(name: 'InventoryPurchaseItemId')
  final int? inventoryPurchaseItemId;
  @JsonKey(name: 'SessionId')
  final String? sessionId;
  @JsonKey(name: 'BarCode')
  final String? barCode;
  @JsonKey(name: 'ManufactureDate')
  final String? manufactureDate;
  @JsonKey(name: 'PrintQuantity')
  final int? printQuantity;
  @JsonKey(name: 'SerialNumber')
  final String? serialNumber;
  @JsonKey(name: 'RfId')
  final String? rfId;
  @JsonKey(name: 'SerialNumberIsMixedCase')
  final bool? serialNumberIsMixedCase;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItemFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItemToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItemToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItem &&
            (identical(other.inventoryPurchaseItemId, inventoryPurchaseItemId) ||
                const DeepCollectionEquality().equals(
                    other.inventoryPurchaseItemId, inventoryPurchaseItemId)) &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)) &&
            (identical(other.barCode, barCode) ||
                const DeepCollectionEquality()
                    .equals(other.barCode, barCode)) &&
            (identical(other.manufactureDate, manufactureDate) ||
                const DeepCollectionEquality()
                    .equals(other.manufactureDate, manufactureDate)) &&
            (identical(other.printQuantity, printQuantity) ||
                const DeepCollectionEquality()
                    .equals(other.printQuantity, printQuantity)) &&
            (identical(other.serialNumber, serialNumber) ||
                const DeepCollectionEquality()
                    .equals(other.serialNumber, serialNumber)) &&
            (identical(other.rfId, rfId) ||
                const DeepCollectionEquality().equals(other.rfId, rfId)) &&
            (identical(
                    other.serialNumberIsMixedCase, serialNumberIsMixedCase) ||
                const DeepCollectionEquality().equals(
                    other.serialNumberIsMixedCase, serialNumberIsMixedCase)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItemExtension
    on WebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItem {
  WebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItem copyWith(
      {int? inventoryPurchaseItemId,
      String? sessionId,
      String? barCode,
      String? manufactureDate,
      int? printQuantity,
      String? serialNumber,
      String? rfId,
      bool? serialNumberIsMixedCase,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsInventoryPurchaseItemInventoryPurchaseItem(
        inventoryPurchaseItemId:
            inventoryPurchaseItemId ?? this.inventoryPurchaseItemId,
        sessionId: sessionId ?? this.sessionId,
        barCode: barCode ?? this.barCode,
        manufactureDate: manufactureDate ?? this.manufactureDate,
        printQuantity: printQuantity ?? this.printQuantity,
        serialNumber: serialNumber ?? this.serialNumber,
        rfId: rfId ?? this.rfId,
        serialNumberIsMixedCase:
            serialNumberIsMixedCase ?? this.serialNumberIsMixedCase,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventorySearchInventorySearch {
  WebApiModulesHomeControlsInventorySearchInventorySearch({
    this.sessionId,
    this.inventoryId,
    this.warehouseId,
    this.id,
    this.lineage,
    this.packageItemId,
    this.quantity,
    this.fromDate,
    this.toDate,
    this.quantityAvailable,
    this.conflictDate,
    this.availabilityState,
    this.quantityAvailableRegion,
    this.conflictDateRegion,
    this.availabilityStateRegion,
    this.quantityAvailableAllWarehouses,
    this.conflictDateAllWarehouses,
    this.availabilityStateAllWarehouses,
    this.totalQuantityInSession,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsInventorySearchInventorySearch.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventorySearchInventorySearchFromJson(json);

  @JsonKey(name: 'SessionId')
  final String? sessionId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'Id')
  final int? id;
  @JsonKey(name: 'Lineage')
  final String? lineage;
  @JsonKey(name: 'PackageItemId')
  final String? packageItemId;
  @JsonKey(name: 'Quantity')
  final double? quantity;
  @JsonKey(name: 'FromDate')
  final DateTime? fromDate;
  @JsonKey(name: 'ToDate')
  final DateTime? toDate;
  @JsonKey(name: 'QuantityAvailable')
  final double? quantityAvailable;
  @JsonKey(name: 'ConflictDate')
  final DateTime? conflictDate;
  @JsonKey(name: 'AvailabilityState')
  final String? availabilityState;
  @JsonKey(name: 'QuantityAvailableRegion')
  final double? quantityAvailableRegion;
  @JsonKey(name: 'ConflictDateRegion')
  final DateTime? conflictDateRegion;
  @JsonKey(name: 'AvailabilityStateRegion')
  final String? availabilityStateRegion;
  @JsonKey(name: 'QuantityAvailableAllWarehouses')
  final double? quantityAvailableAllWarehouses;
  @JsonKey(name: 'ConflictDateAllWarehouses')
  final DateTime? conflictDateAllWarehouses;
  @JsonKey(name: 'AvailabilityStateAllWarehouses')
  final String? availabilityStateAllWarehouses;
  @JsonKey(name: 'TotalQuantityInSession')
  final double? totalQuantityInSession;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventorySearchInventorySearchFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventorySearchInventorySearchToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventorySearchInventorySearchToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventorySearchInventorySearch &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.lineage, lineage) ||
                const DeepCollectionEquality()
                    .equals(other.lineage, lineage)) &&
            (identical(other.packageItemId, packageItemId) ||
                const DeepCollectionEquality()
                    .equals(other.packageItemId, packageItemId)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)) &&
            (identical(other.fromDate, fromDate) ||
                const DeepCollectionEquality()
                    .equals(other.fromDate, fromDate)) &&
            (identical(other.toDate, toDate) ||
                const DeepCollectionEquality().equals(other.toDate, toDate)) &&
            (identical(other.quantityAvailable, quantityAvailable) ||
                const DeepCollectionEquality()
                    .equals(other.quantityAvailable, quantityAvailable)) &&
            (identical(other.conflictDate, conflictDate) ||
                const DeepCollectionEquality()
                    .equals(other.conflictDate, conflictDate)) &&
            (identical(other.availabilityState, availabilityState) ||
                const DeepCollectionEquality()
                    .equals(other.availabilityState, availabilityState)) &&
            (identical(other.quantityAvailableRegion, quantityAvailableRegion) ||
                const DeepCollectionEquality().equals(
                    other.quantityAvailableRegion, quantityAvailableRegion)) &&
            (identical(other.conflictDateRegion, conflictDateRegion) ||
                const DeepCollectionEquality()
                    .equals(other.conflictDateRegion, conflictDateRegion)) &&
            (identical(other.availabilityStateRegion, availabilityStateRegion) ||
                const DeepCollectionEquality().equals(
                    other.availabilityStateRegion, availabilityStateRegion)) &&
            (identical(other.quantityAvailableAllWarehouses, quantityAvailableAllWarehouses) ||
                const DeepCollectionEquality().equals(
                    other.quantityAvailableAllWarehouses,
                    quantityAvailableAllWarehouses)) &&
            (identical(other.conflictDateAllWarehouses, conflictDateAllWarehouses) ||
                const DeepCollectionEquality().equals(
                    other.conflictDateAllWarehouses,
                    conflictDateAllWarehouses)) &&
            (identical(other.availabilityStateAllWarehouses, availabilityStateAllWarehouses) ||
                const DeepCollectionEquality().equals(
                    other.availabilityStateAllWarehouses, availabilityStateAllWarehouses)) &&
            (identical(other.totalQuantityInSession, totalQuantityInSession) || const DeepCollectionEquality().equals(other.totalQuantityInSession, totalQuantityInSession)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsInventorySearchInventorySearchExtension
    on WebApiModulesHomeControlsInventorySearchInventorySearch {
  WebApiModulesHomeControlsInventorySearchInventorySearch copyWith(
      {String? sessionId,
      String? inventoryId,
      String? warehouseId,
      int? id,
      String? lineage,
      String? packageItemId,
      double? quantity,
      DateTime? fromDate,
      DateTime? toDate,
      double? quantityAvailable,
      DateTime? conflictDate,
      String? availabilityState,
      double? quantityAvailableRegion,
      DateTime? conflictDateRegion,
      String? availabilityStateRegion,
      double? quantityAvailableAllWarehouses,
      DateTime? conflictDateAllWarehouses,
      String? availabilityStateAllWarehouses,
      double? totalQuantityInSession,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsInventorySearchInventorySearch(
        sessionId: sessionId ?? this.sessionId,
        inventoryId: inventoryId ?? this.inventoryId,
        warehouseId: warehouseId ?? this.warehouseId,
        id: id ?? this.id,
        lineage: lineage ?? this.lineage,
        packageItemId: packageItemId ?? this.packageItemId,
        quantity: quantity ?? this.quantity,
        fromDate: fromDate ?? this.fromDate,
        toDate: toDate ?? this.toDate,
        quantityAvailable: quantityAvailable ?? this.quantityAvailable,
        conflictDate: conflictDate ?? this.conflictDate,
        availabilityState: availabilityState ?? this.availabilityState,
        quantityAvailableRegion:
            quantityAvailableRegion ?? this.quantityAvailableRegion,
        conflictDateRegion: conflictDateRegion ?? this.conflictDateRegion,
        availabilityStateRegion:
            availabilityStateRegion ?? this.availabilityStateRegion,
        quantityAvailableAllWarehouses: quantityAvailableAllWarehouses ??
            this.quantityAvailableAllWarehouses,
        conflictDateAllWarehouses:
            conflictDateAllWarehouses ?? this.conflictDateAllWarehouses,
        availabilityStateAllWarehouses: availabilityStateAllWarehouses ??
            this.availabilityStateAllWarehouses,
        totalQuantityInSession:
            totalQuantityInSession ?? this.totalQuantityInSession,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventorySearchInventorySearchAccessoriesRequest {
  WebApiModulesHomeControlsInventorySearchInventorySearchAccessoriesRequest({
    this.sessionId,
    this.orderId,
    this.lineage,
    this.warehouseId,
    this.showAvailability,
    this.fromDate,
    this.fromTime,
    this.toDate,
    this.toTime,
    this.showImages,
  });

  factory WebApiModulesHomeControlsInventorySearchInventorySearchAccessoriesRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventorySearchInventorySearchAccessoriesRequestFromJson(
          json);

  @JsonKey(name: 'SessionId')
  final String? sessionId;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'Lineage')
  final String? lineage;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'ShowAvailability')
  final bool? showAvailability;
  @JsonKey(name: 'FromDate')
  final DateTime? fromDate;
  @JsonKey(name: 'FromTime')
  final String? fromTime;
  @JsonKey(name: 'ToDate')
  final DateTime? toDate;
  @JsonKey(name: 'ToTime')
  final String? toTime;
  @JsonKey(name: 'ShowImages')
  final bool? showImages;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventorySearchInventorySearchAccessoriesRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventorySearchInventorySearchAccessoriesRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventorySearchInventorySearchAccessoriesRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventorySearchInventorySearchAccessoriesRequest &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.lineage, lineage) ||
                const DeepCollectionEquality()
                    .equals(other.lineage, lineage)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.showAvailability, showAvailability) ||
                const DeepCollectionEquality()
                    .equals(other.showAvailability, showAvailability)) &&
            (identical(other.fromDate, fromDate) ||
                const DeepCollectionEquality()
                    .equals(other.fromDate, fromDate)) &&
            (identical(other.fromTime, fromTime) ||
                const DeepCollectionEquality()
                    .equals(other.fromTime, fromTime)) &&
            (identical(other.toDate, toDate) ||
                const DeepCollectionEquality().equals(other.toDate, toDate)) &&
            (identical(other.toTime, toTime) ||
                const DeepCollectionEquality().equals(other.toTime, toTime)) &&
            (identical(other.showImages, showImages) ||
                const DeepCollectionEquality()
                    .equals(other.showImages, showImages)));
  }
}

extension $WebApiModulesHomeControlsInventorySearchInventorySearchAccessoriesRequestExtension
    on WebApiModulesHomeControlsInventorySearchInventorySearchAccessoriesRequest {
  WebApiModulesHomeControlsInventorySearchInventorySearchAccessoriesRequest
      copyWith(
          {String? sessionId,
          String? orderId,
          String? lineage,
          String? warehouseId,
          bool? showAvailability,
          DateTime? fromDate,
          String? fromTime,
          DateTime? toDate,
          String? toTime,
          bool? showImages}) {
    return WebApiModulesHomeControlsInventorySearchInventorySearchAccessoriesRequest(
        sessionId: sessionId ?? this.sessionId,
        orderId: orderId ?? this.orderId,
        lineage: lineage ?? this.lineage,
        warehouseId: warehouseId ?? this.warehouseId,
        showAvailability: showAvailability ?? this.showAvailability,
        fromDate: fromDate ?? this.fromDate,
        fromTime: fromTime ?? this.fromTime,
        toDate: toDate ?? this.toDate,
        toTime: toTime ?? this.toTime,
        showImages: showImages ?? this.showImages);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventorySearchInventorySearchAddToCompleteKitContainerRequest {
  WebApiModulesHomeControlsInventorySearchInventorySearchAddToCompleteKitContainerRequest({
    this.inventoryId,
    this.sessionId,
  });

  factory WebApiModulesHomeControlsInventorySearchInventorySearchAddToCompleteKitContainerRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventorySearchInventorySearchAddToCompleteKitContainerRequestFromJson(
          json);

  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'SessionId')
  final String? sessionId;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventorySearchInventorySearchAddToCompleteKitContainerRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventorySearchInventorySearchAddToCompleteKitContainerRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventorySearchInventorySearchAddToCompleteKitContainerRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventorySearchInventorySearchAddToCompleteKitContainerRequest &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)));
  }
}

extension $WebApiModulesHomeControlsInventorySearchInventorySearchAddToCompleteKitContainerRequestExtension
    on WebApiModulesHomeControlsInventorySearchInventorySearchAddToCompleteKitContainerRequest {
  WebApiModulesHomeControlsInventorySearchInventorySearchAddToCompleteKitContainerRequest
      copyWith({String? inventoryId, String? sessionId}) {
    return WebApiModulesHomeControlsInventorySearchInventorySearchAddToCompleteKitContainerRequest(
        inventoryId: inventoryId ?? this.inventoryId,
        sessionId: sessionId ?? this.sessionId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventorySearchInventorySearchAddToOrderRequest {
  WebApiModulesHomeControlsInventorySearchInventorySearchAddToOrderRequest({
    this.orderId,
    this.insertAtIndex,
    this.sessionId,
  });

  factory WebApiModulesHomeControlsInventorySearchInventorySearchAddToOrderRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventorySearchInventorySearchAddToOrderRequestFromJson(
          json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'InsertAtIndex')
  final int? insertAtIndex;
  @JsonKey(name: 'SessionId')
  final String? sessionId;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventorySearchInventorySearchAddToOrderRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventorySearchInventorySearchAddToOrderRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventorySearchInventorySearchAddToOrderRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventorySearchInventorySearchAddToOrderRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.insertAtIndex, insertAtIndex) ||
                const DeepCollectionEquality()
                    .equals(other.insertAtIndex, insertAtIndex)) &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)));
  }
}

extension $WebApiModulesHomeControlsInventorySearchInventorySearchAddToOrderRequestExtension
    on WebApiModulesHomeControlsInventorySearchInventorySearchAddToOrderRequest {
  WebApiModulesHomeControlsInventorySearchInventorySearchAddToOrderRequest
      copyWith({String? orderId, int? insertAtIndex, String? sessionId}) {
    return WebApiModulesHomeControlsInventorySearchInventorySearchAddToOrderRequest(
        orderId: orderId ?? this.orderId,
        insertAtIndex: insertAtIndex ?? this.insertAtIndex,
        sessionId: sessionId ?? this.sessionId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventorySearchInventorySearchGetTotalResponse {
  WebApiModulesHomeControlsInventorySearchInventorySearchGetTotalResponse({
    this.status,
    this.success,
    this.msg,
    this.totalQuantityInSession,
  });

  factory WebApiModulesHomeControlsInventorySearchInventorySearchGetTotalResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventorySearchInventorySearchGetTotalResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'TotalQuantityInSession')
  final double? totalQuantityInSession;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventorySearchInventorySearchGetTotalResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventorySearchInventorySearchGetTotalResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventorySearchInventorySearchGetTotalResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventorySearchInventorySearchGetTotalResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.totalQuantityInSession, totalQuantityInSession) ||
                const DeepCollectionEquality().equals(
                    other.totalQuantityInSession, totalQuantityInSession)));
  }
}

extension $WebApiModulesHomeControlsInventorySearchInventorySearchGetTotalResponseExtension
    on WebApiModulesHomeControlsInventorySearchInventorySearchGetTotalResponse {
  WebApiModulesHomeControlsInventorySearchInventorySearchGetTotalResponse
      copyWith(
          {int? status,
          bool? success,
          String? msg,
          double? totalQuantityInSession}) {
    return WebApiModulesHomeControlsInventorySearchInventorySearchGetTotalResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        totalQuantityInSession:
            totalQuantityInSession ?? this.totalQuantityInSession);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventorySearchInventorySearchRequest {
  WebApiModulesHomeControlsInventorySearchInventorySearchRequest({
    this.sessionId,
    this.orderId,
    this.availableFor,
    this.warehouseId,
    this.currencyId,
    this.inventoryTypeId,
    this.categoryId,
    this.subCategoryId,
    this.classification,
    this.searchText,
    this.attributeId,
    this.attributeValueId,
    this.attributeValueRange,
    this.showAvailability,
    this.fromDate,
    this.fromTime,
    this.toDate,
    this.toTime,
    this.showImages,
    this.hideInventoryWithZeroQuantity,
    this.sortBy,
  });

  factory WebApiModulesHomeControlsInventorySearchInventorySearchRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventorySearchInventorySearchRequestFromJson(
          json);

  @JsonKey(name: 'SessionId')
  final String? sessionId;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'AvailableFor')
  final String? availableFor;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'CurrencyId')
  final String? currencyId;
  @JsonKey(name: 'InventoryTypeId')
  final String? inventoryTypeId;
  @JsonKey(name: 'CategoryId')
  final String? categoryId;
  @JsonKey(name: 'SubCategoryId')
  final String? subCategoryId;
  @JsonKey(name: 'Classification')
  final String? classification;
  @JsonKey(name: 'SearchText')
  final String? searchText;
  @JsonKey(name: 'AttributeId')
  final String? attributeId;
  @JsonKey(name: 'AttributeValueId')
  final String? attributeValueId;
  @JsonKey(name: 'AttributeValueRange')
  final String? attributeValueRange;
  @JsonKey(name: 'ShowAvailability')
  final bool? showAvailability;
  @JsonKey(name: 'FromDate')
  final DateTime? fromDate;
  @JsonKey(name: 'FromTime')
  final String? fromTime;
  @JsonKey(name: 'ToDate')
  final DateTime? toDate;
  @JsonKey(name: 'ToTime')
  final String? toTime;
  @JsonKey(name: 'ShowImages')
  final bool? showImages;
  @JsonKey(name: 'HideInventoryWithZeroQuantity')
  final bool? hideInventoryWithZeroQuantity;
  @JsonKey(name: 'SortBy')
  final String? sortBy;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventorySearchInventorySearchRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventorySearchInventorySearchRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventorySearchInventorySearchRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventorySearchInventorySearchRequest &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.availableFor, availableFor) ||
                const DeepCollectionEquality()
                    .equals(other.availableFor, availableFor)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.currencyId, currencyId) ||
                const DeepCollectionEquality()
                    .equals(other.currencyId, currencyId)) &&
            (identical(other.inventoryTypeId, inventoryTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryTypeId, inventoryTypeId)) &&
            (identical(other.categoryId, categoryId) ||
                const DeepCollectionEquality()
                    .equals(other.categoryId, categoryId)) &&
            (identical(other.subCategoryId, subCategoryId) ||
                const DeepCollectionEquality()
                    .equals(other.subCategoryId, subCategoryId)) &&
            (identical(other.classification, classification) ||
                const DeepCollectionEquality()
                    .equals(other.classification, classification)) &&
            (identical(other.searchText, searchText) ||
                const DeepCollectionEquality()
                    .equals(other.searchText, searchText)) &&
            (identical(other.attributeId, attributeId) ||
                const DeepCollectionEquality()
                    .equals(other.attributeId, attributeId)) &&
            (identical(other.attributeValueId, attributeValueId) ||
                const DeepCollectionEquality()
                    .equals(other.attributeValueId, attributeValueId)) &&
            (identical(other.attributeValueRange, attributeValueRange) ||
                const DeepCollectionEquality()
                    .equals(other.attributeValueRange, attributeValueRange)) &&
            (identical(other.showAvailability, showAvailability) ||
                const DeepCollectionEquality()
                    .equals(other.showAvailability, showAvailability)) &&
            (identical(other.fromDate, fromDate) ||
                const DeepCollectionEquality()
                    .equals(other.fromDate, fromDate)) &&
            (identical(other.fromTime, fromTime) ||
                const DeepCollectionEquality()
                    .equals(other.fromTime, fromTime)) &&
            (identical(other.toDate, toDate) || const DeepCollectionEquality().equals(other.toDate, toDate)) &&
            (identical(other.toTime, toTime) || const DeepCollectionEquality().equals(other.toTime, toTime)) &&
            (identical(other.showImages, showImages) || const DeepCollectionEquality().equals(other.showImages, showImages)) &&
            (identical(other.hideInventoryWithZeroQuantity, hideInventoryWithZeroQuantity) || const DeepCollectionEquality().equals(other.hideInventoryWithZeroQuantity, hideInventoryWithZeroQuantity)) &&
            (identical(other.sortBy, sortBy) || const DeepCollectionEquality().equals(other.sortBy, sortBy)));
  }
}

extension $WebApiModulesHomeControlsInventorySearchInventorySearchRequestExtension
    on WebApiModulesHomeControlsInventorySearchInventorySearchRequest {
  WebApiModulesHomeControlsInventorySearchInventorySearchRequest copyWith(
      {String? sessionId,
      String? orderId,
      String? availableFor,
      String? warehouseId,
      String? currencyId,
      String? inventoryTypeId,
      String? categoryId,
      String? subCategoryId,
      String? classification,
      String? searchText,
      String? attributeId,
      String? attributeValueId,
      String? attributeValueRange,
      bool? showAvailability,
      DateTime? fromDate,
      String? fromTime,
      DateTime? toDate,
      String? toTime,
      bool? showImages,
      bool? hideInventoryWithZeroQuantity,
      String? sortBy}) {
    return WebApiModulesHomeControlsInventorySearchInventorySearchRequest(
        sessionId: sessionId ?? this.sessionId,
        orderId: orderId ?? this.orderId,
        availableFor: availableFor ?? this.availableFor,
        warehouseId: warehouseId ?? this.warehouseId,
        currencyId: currencyId ?? this.currencyId,
        inventoryTypeId: inventoryTypeId ?? this.inventoryTypeId,
        categoryId: categoryId ?? this.categoryId,
        subCategoryId: subCategoryId ?? this.subCategoryId,
        classification: classification ?? this.classification,
        searchText: searchText ?? this.searchText,
        attributeId: attributeId ?? this.attributeId,
        attributeValueId: attributeValueId ?? this.attributeValueId,
        attributeValueRange: attributeValueRange ?? this.attributeValueRange,
        showAvailability: showAvailability ?? this.showAvailability,
        fromDate: fromDate ?? this.fromDate,
        fromTime: fromTime ?? this.fromTime,
        toDate: toDate ?? this.toDate,
        toTime: toTime ?? this.toTime,
        showImages: showImages ?? this.showImages,
        hideInventoryWithZeroQuantity:
            hideInventoryWithZeroQuantity ?? this.hideInventoryWithZeroQuantity,
        sortBy: sortBy ?? this.sortBy);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventorySearchInventorySearchSaveNoteRequest {
  WebApiModulesHomeControlsInventorySearchInventorySearchSaveNoteRequest({
    this.sessionId,
    this.quikSearchId,
    this.note,
  });

  factory WebApiModulesHomeControlsInventorySearchInventorySearchSaveNoteRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventorySearchInventorySearchSaveNoteRequestFromJson(
          json);

  @JsonKey(name: 'SessionId')
  final String? sessionId;
  @JsonKey(name: 'QuikSearchId')
  final int? quikSearchId;
  @JsonKey(name: 'Note')
  final String? note;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventorySearchInventorySearchSaveNoteRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventorySearchInventorySearchSaveNoteRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventorySearchInventorySearchSaveNoteRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventorySearchInventorySearchSaveNoteRequest &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)) &&
            (identical(other.quikSearchId, quikSearchId) ||
                const DeepCollectionEquality()
                    .equals(other.quikSearchId, quikSearchId)) &&
            (identical(other.note, note) ||
                const DeepCollectionEquality().equals(other.note, note)));
  }
}

extension $WebApiModulesHomeControlsInventorySearchInventorySearchSaveNoteRequestExtension
    on WebApiModulesHomeControlsInventorySearchInventorySearchSaveNoteRequest {
  WebApiModulesHomeControlsInventorySearchInventorySearchSaveNoteRequest
      copyWith({String? sessionId, int? quikSearchId, String? note}) {
    return WebApiModulesHomeControlsInventorySearchInventorySearchSaveNoteRequest(
        sessionId: sessionId ?? this.sessionId,
        quikSearchId: quikSearchId ?? this.quikSearchId,
        note: note ?? this.note);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventorySearchPreviewInventorySearchPreview {
  WebApiModulesHomeControlsInventorySearchPreviewInventorySearchPreview({
    this.id,
    this.sessionId,
    this.parentId,
    this.grandParentId,
    this.inventoryId,
    this.warehouseId,
    this.quantity,
    this.note,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsInventorySearchPreviewInventorySearchPreview.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventorySearchPreviewInventorySearchPreviewFromJson(
          json);

  @JsonKey(name: 'Id')
  final String? id;
  @JsonKey(name: 'SessionId')
  final String? sessionId;
  @JsonKey(name: 'ParentId')
  final String? parentId;
  @JsonKey(name: 'GrandParentId')
  final String? grandParentId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'Quantity')
  final double? quantity;
  @JsonKey(name: 'Note')
  final String? note;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventorySearchPreviewInventorySearchPreviewFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventorySearchPreviewInventorySearchPreviewToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventorySearchPreviewInventorySearchPreviewToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventorySearchPreviewInventorySearchPreview &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)) &&
            (identical(other.parentId, parentId) ||
                const DeepCollectionEquality()
                    .equals(other.parentId, parentId)) &&
            (identical(other.grandParentId, grandParentId) ||
                const DeepCollectionEquality()
                    .equals(other.grandParentId, grandParentId)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)) &&
            (identical(other.note, note) ||
                const DeepCollectionEquality().equals(other.note, note)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsInventorySearchPreviewInventorySearchPreviewExtension
    on WebApiModulesHomeControlsInventorySearchPreviewInventorySearchPreview {
  WebApiModulesHomeControlsInventorySearchPreviewInventorySearchPreview
      copyWith(
          {String? id,
          String? sessionId,
          String? parentId,
          String? grandParentId,
          String? inventoryId,
          String? warehouseId,
          double? quantity,
          String? note,
          String? recordTitle,
          List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
          List<FwStandardDataFwCustomValue>? custom,
          List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsInventorySearchPreviewInventorySearchPreview(
        id: id ?? this.id,
        sessionId: sessionId ?? this.sessionId,
        parentId: parentId ?? this.parentId,
        grandParentId: grandParentId ?? this.grandParentId,
        inventoryId: inventoryId ?? this.inventoryId,
        warehouseId: warehouseId ?? this.warehouseId,
        quantity: quantity ?? this.quantity,
        note: note ?? this.note,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventorySubstituteInventorySubstitute {
  WebApiModulesHomeControlsInventorySubstituteInventorySubstitute({
    this.inventorySubstituteId,
    this.inventoryId,
    this.substituteInventoryId,
    this.iCode,
    this.description,
    this.manufacturerId,
    this.manufacturer,
    this.rate,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsInventorySubstituteInventorySubstitute.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventorySubstituteInventorySubstituteFromJson(
          json);

  @JsonKey(name: 'InventorySubstituteId')
  final String? inventorySubstituteId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'SubstituteInventoryId')
  final String? substituteInventoryId;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'ManufacturerId')
  final String? manufacturerId;
  @JsonKey(name: 'Manufacturer')
  final String? manufacturer;
  @JsonKey(name: 'Rate')
  final double? rate;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventorySubstituteInventorySubstituteFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventorySubstituteInventorySubstituteToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventorySubstituteInventorySubstituteToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventorySubstituteInventorySubstitute &&
            (identical(other.inventorySubstituteId, inventorySubstituteId) ||
                const DeepCollectionEquality().equals(
                    other.inventorySubstituteId, inventorySubstituteId)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.substituteInventoryId, substituteInventoryId) ||
                const DeepCollectionEquality().equals(
                    other.substituteInventoryId, substituteInventoryId)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.manufacturerId, manufacturerId) ||
                const DeepCollectionEquality()
                    .equals(other.manufacturerId, manufacturerId)) &&
            (identical(other.manufacturer, manufacturer) ||
                const DeepCollectionEquality()
                    .equals(other.manufacturer, manufacturer)) &&
            (identical(other.rate, rate) ||
                const DeepCollectionEquality().equals(other.rate, rate)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsInventorySubstituteInventorySubstituteExtension
    on WebApiModulesHomeControlsInventorySubstituteInventorySubstitute {
  WebApiModulesHomeControlsInventorySubstituteInventorySubstitute copyWith(
      {String? inventorySubstituteId,
      String? inventoryId,
      String? substituteInventoryId,
      String? iCode,
      String? description,
      String? manufacturerId,
      String? manufacturer,
      double? rate,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsInventorySubstituteInventorySubstitute(
        inventorySubstituteId:
            inventorySubstituteId ?? this.inventorySubstituteId,
        inventoryId: inventoryId ?? this.inventoryId,
        substituteInventoryId:
            substituteInventoryId ?? this.substituteInventoryId,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        manufacturerId: manufacturerId ?? this.manufacturerId,
        manufacturer: manufacturer ?? this.manufacturer,
        rate: rate ?? this.rate,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryVendorInventoryVendor {
  WebApiModulesHomeControlsInventoryVendorInventoryVendor({
    this.inventoryVendorId,
    this.inventoryId,
    this.vendorId,
    this.vendor,
    this.contactName,
    this.contactOfficePhone,
    this.contactEmail,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsInventoryVendorInventoryVendor.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryVendorInventoryVendorFromJson(json);

  @JsonKey(name: 'InventoryVendorId')
  final String? inventoryVendorId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'VendorId')
  final String? vendorId;
  @JsonKey(name: 'Vendor')
  final String? vendor;
  @JsonKey(name: 'ContactName')
  final String? contactName;
  @JsonKey(name: 'ContactOfficePhone')
  final String? contactOfficePhone;
  @JsonKey(name: 'ContactEmail')
  final String? contactEmail;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryVendorInventoryVendorFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryVendorInventoryVendorToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryVendorInventoryVendorToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryVendorInventoryVendor &&
            (identical(other.inventoryVendorId, inventoryVendorId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryVendorId, inventoryVendorId)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.vendorId, vendorId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorId, vendorId)) &&
            (identical(other.vendor, vendor) ||
                const DeepCollectionEquality().equals(other.vendor, vendor)) &&
            (identical(other.contactName, contactName) ||
                const DeepCollectionEquality()
                    .equals(other.contactName, contactName)) &&
            (identical(other.contactOfficePhone, contactOfficePhone) ||
                const DeepCollectionEquality()
                    .equals(other.contactOfficePhone, contactOfficePhone)) &&
            (identical(other.contactEmail, contactEmail) ||
                const DeepCollectionEquality()
                    .equals(other.contactEmail, contactEmail)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsInventoryVendorInventoryVendorExtension
    on WebApiModulesHomeControlsInventoryVendorInventoryVendor {
  WebApiModulesHomeControlsInventoryVendorInventoryVendor copyWith(
      {String? inventoryVendorId,
      String? inventoryId,
      String? vendorId,
      String? vendor,
      String? contactName,
      String? contactOfficePhone,
      String? contactEmail,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsInventoryVendorInventoryVendor(
        inventoryVendorId: inventoryVendorId ?? this.inventoryVendorId,
        inventoryId: inventoryId ?? this.inventoryId,
        vendorId: vendorId ?? this.vendorId,
        vendor: vendor ?? this.vendor,
        contactName: contactName ?? this.contactName,
        contactOfficePhone: contactOfficePhone ?? this.contactOfficePhone,
        contactEmail: contactEmail ?? this.contactEmail,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryWarehouseInventoryWarehouse {
  WebApiModulesHomeControlsInventoryWarehouseInventoryWarehouse({
    this.inventoryId,
    this.hourlyRate,
    this.hourlyCost,
    this.dailyRate,
    this.dailyCost,
    this.weeklyRate,
    this.weeklyCost,
    this.week2Rate,
    this.week3Rate,
    this.week4Rate,
    this.monthlyRate,
    this.monthlyCost,
    this.retail,
    this.price,
    this.defaultCost,
    this.averageCost,
    this.markupPercent,
    this.reorderPoint,
    this.reorderQuantity,
    this.maximumDiscount,
    this.minimumDaysPerWeek,
    this.hasTieredCost,
    this.restockingFee,
    this.restockingPercent,
    this.dateOfLastPhysicalInventory,
    this.qty,
    this.qtyConsigned,
    this.qtyIn,
    this.qtyInContainer,
    this.qtyQcRequired,
    this.qtyStaged,
    this.qtyOut,
    this.qtyInRepair,
    this.qtyOnPo,
    this.qtyAllocated,
    this.aisleLocation,
    this.shelfLocation,
    this.availabilityByHour,
    this.availabilityByDeal,
    this.availabilityByAsset,
    this.qcRequired,
    this.availabilityQcDelay,
    this.allowAllUsersAddToOrder,
    this.unitValue,
    this.replacementCost,
    this.markupReplacementCost,
    this.replacementCostMarkupPercent,
    this.isWarehouseSpecific,
    this.itemDescription,
    this.warehouseId,
    this.warehouseCode,
    this.warehouse,
    this.warehouseOrderBy,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsInventoryWarehouseInventoryWarehouse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseFromJson(
          json);

  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'HourlyRate')
  final double? hourlyRate;
  @JsonKey(name: 'HourlyCost')
  final double? hourlyCost;
  @JsonKey(name: 'DailyRate')
  final double? dailyRate;
  @JsonKey(name: 'DailyCost')
  final double? dailyCost;
  @JsonKey(name: 'WeeklyRate')
  final double? weeklyRate;
  @JsonKey(name: 'WeeklyCost')
  final double? weeklyCost;
  @JsonKey(name: 'Week2Rate')
  final double? week2Rate;
  @JsonKey(name: 'Week3Rate')
  final double? week3Rate;
  @JsonKey(name: 'Week4Rate')
  final double? week4Rate;
  @JsonKey(name: 'MonthlyRate')
  final double? monthlyRate;
  @JsonKey(name: 'MonthlyCost')
  final double? monthlyCost;
  @JsonKey(name: 'Retail')
  final double? retail;
  @JsonKey(name: 'Price')
  final double? price;
  @JsonKey(name: 'DefaultCost')
  final double? defaultCost;
  @JsonKey(name: 'AverageCost')
  final double? averageCost;
  @JsonKey(name: 'MarkupPercent')
  final double? markupPercent;
  @JsonKey(name: 'ReorderPoint')
  final int? reorderPoint;
  @JsonKey(name: 'ReorderQuantity')
  final int? reorderQuantity;
  @JsonKey(name: 'MaximumDiscount')
  final double? maximumDiscount;
  @JsonKey(name: 'MinimumDaysPerWeek')
  final double? minimumDaysPerWeek;
  @JsonKey(name: 'HasTieredCost')
  final bool? hasTieredCost;
  @JsonKey(name: 'RestockingFee')
  final double? restockingFee;
  @JsonKey(name: 'RestockingPercent')
  final double? restockingPercent;
  @JsonKey(name: 'DateOfLastPhysicalInventory')
  final String? dateOfLastPhysicalInventory;
  @JsonKey(name: 'Qty')
  final double? qty;
  @JsonKey(name: 'QtyConsigned')
  final double? qtyConsigned;
  @JsonKey(name: 'QtyIn')
  final double? qtyIn;
  @JsonKey(name: 'QtyInContainer')
  final double? qtyInContainer;
  @JsonKey(name: 'QtyQcRequired')
  final int? qtyQcRequired;
  @JsonKey(name: 'QtyStaged')
  final double? qtyStaged;
  @JsonKey(name: 'QtyOut')
  final double? qtyOut;
  @JsonKey(name: 'QtyInRepair')
  final double? qtyInRepair;
  @JsonKey(name: 'QtyOnPo')
  final double? qtyOnPo;
  @JsonKey(name: 'QtyAllocated')
  final double? qtyAllocated;
  @JsonKey(name: 'AisleLocation')
  final String? aisleLocation;
  @JsonKey(name: 'ShelfLocation')
  final String? shelfLocation;
  @JsonKey(name: 'AvailabilityByHour')
  final bool? availabilityByHour;
  @JsonKey(name: 'AvailabilityByDeal')
  final bool? availabilityByDeal;
  @JsonKey(name: 'AvailabilityByAsset')
  final bool? availabilityByAsset;
  @JsonKey(name: 'QcRequired')
  final bool? qcRequired;
  @JsonKey(name: 'AvailabilityQcDelay')
  final int? availabilityQcDelay;
  @JsonKey(name: 'AllowAllUsersAddToOrder')
  final bool? allowAllUsersAddToOrder;
  @JsonKey(name: 'UnitValue')
  final double? unitValue;
  @JsonKey(name: 'ReplacementCost')
  final double? replacementCost;
  @JsonKey(name: 'MarkupReplacementCost')
  final bool? markupReplacementCost;
  @JsonKey(name: 'ReplacementCostMarkupPercent')
  final double? replacementCostMarkupPercent;
  @JsonKey(name: 'IsWarehouseSpecific')
  final bool? isWarehouseSpecific;
  @JsonKey(name: 'ItemDescription')
  final String? itemDescription;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'WarehouseOrderBy')
  final int? warehouseOrderBy;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryWarehouseInventoryWarehouse &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.hourlyRate, hourlyRate) ||
                const DeepCollectionEquality()
                    .equals(other.hourlyRate, hourlyRate)) &&
            (identical(other.hourlyCost, hourlyCost) ||
                const DeepCollectionEquality()
                    .equals(other.hourlyCost, hourlyCost)) &&
            (identical(other.dailyRate, dailyRate) ||
                const DeepCollectionEquality()
                    .equals(other.dailyRate, dailyRate)) &&
            (identical(other.dailyCost, dailyCost) ||
                const DeepCollectionEquality()
                    .equals(other.dailyCost, dailyCost)) &&
            (identical(other.weeklyRate, weeklyRate) ||
                const DeepCollectionEquality()
                    .equals(other.weeklyRate, weeklyRate)) &&
            (identical(other.weeklyCost, weeklyCost) ||
                const DeepCollectionEquality()
                    .equals(other.weeklyCost, weeklyCost)) &&
            (identical(other.week2Rate, week2Rate) ||
                const DeepCollectionEquality()
                    .equals(other.week2Rate, week2Rate)) &&
            (identical(other.week3Rate, week3Rate) ||
                const DeepCollectionEquality()
                    .equals(other.week3Rate, week3Rate)) &&
            (identical(other.week4Rate, week4Rate) ||
                const DeepCollectionEquality()
                    .equals(other.week4Rate, week4Rate)) &&
            (identical(other.monthlyRate, monthlyRate) ||
                const DeepCollectionEquality()
                    .equals(other.monthlyRate, monthlyRate)) &&
            (identical(other.monthlyCost, monthlyCost) ||
                const DeepCollectionEquality()
                    .equals(other.monthlyCost, monthlyCost)) &&
            (identical(other.retail, retail) ||
                const DeepCollectionEquality().equals(other.retail, retail)) &&
            (identical(other.price, price) ||
                const DeepCollectionEquality().equals(other.price, price)) &&
            (identical(other.defaultCost, defaultCost) ||
                const DeepCollectionEquality()
                    .equals(other.defaultCost, defaultCost)) &&
            (identical(other.averageCost, averageCost) ||
                const DeepCollectionEquality()
                    .equals(other.averageCost, averageCost)) &&
            (identical(other.markupPercent, markupPercent) ||
                const DeepCollectionEquality()
                    .equals(other.markupPercent, markupPercent)) &&
            (identical(other.reorderPoint, reorderPoint) || const DeepCollectionEquality().equals(other.reorderPoint, reorderPoint)) &&
            (identical(other.reorderQuantity, reorderQuantity) || const DeepCollectionEquality().equals(other.reorderQuantity, reorderQuantity)) &&
            (identical(other.maximumDiscount, maximumDiscount) || const DeepCollectionEquality().equals(other.maximumDiscount, maximumDiscount)) &&
            (identical(other.minimumDaysPerWeek, minimumDaysPerWeek) || const DeepCollectionEquality().equals(other.minimumDaysPerWeek, minimumDaysPerWeek)) &&
            (identical(other.hasTieredCost, hasTieredCost) || const DeepCollectionEquality().equals(other.hasTieredCost, hasTieredCost)) &&
            (identical(other.restockingFee, restockingFee) || const DeepCollectionEquality().equals(other.restockingFee, restockingFee)) &&
            (identical(other.restockingPercent, restockingPercent) || const DeepCollectionEquality().equals(other.restockingPercent, restockingPercent)) &&
            (identical(other.dateOfLastPhysicalInventory, dateOfLastPhysicalInventory) || const DeepCollectionEquality().equals(other.dateOfLastPhysicalInventory, dateOfLastPhysicalInventory)) &&
            (identical(other.qty, qty) || const DeepCollectionEquality().equals(other.qty, qty)) &&
            (identical(other.qtyConsigned, qtyConsigned) || const DeepCollectionEquality().equals(other.qtyConsigned, qtyConsigned)) &&
            (identical(other.qtyIn, qtyIn) || const DeepCollectionEquality().equals(other.qtyIn, qtyIn)) &&
            (identical(other.qtyInContainer, qtyInContainer) || const DeepCollectionEquality().equals(other.qtyInContainer, qtyInContainer)) &&
            (identical(other.qtyQcRequired, qtyQcRequired) || const DeepCollectionEquality().equals(other.qtyQcRequired, qtyQcRequired)) &&
            (identical(other.qtyStaged, qtyStaged) || const DeepCollectionEquality().equals(other.qtyStaged, qtyStaged)) &&
            (identical(other.qtyOut, qtyOut) || const DeepCollectionEquality().equals(other.qtyOut, qtyOut)) &&
            (identical(other.qtyInRepair, qtyInRepair) || const DeepCollectionEquality().equals(other.qtyInRepair, qtyInRepair)) &&
            (identical(other.qtyOnPo, qtyOnPo) || const DeepCollectionEquality().equals(other.qtyOnPo, qtyOnPo)) &&
            (identical(other.qtyAllocated, qtyAllocated) || const DeepCollectionEquality().equals(other.qtyAllocated, qtyAllocated)) &&
            (identical(other.aisleLocation, aisleLocation) || const DeepCollectionEquality().equals(other.aisleLocation, aisleLocation)) &&
            (identical(other.shelfLocation, shelfLocation) || const DeepCollectionEquality().equals(other.shelfLocation, shelfLocation)) &&
            (identical(other.availabilityByHour, availabilityByHour) || const DeepCollectionEquality().equals(other.availabilityByHour, availabilityByHour)) &&
            (identical(other.availabilityByDeal, availabilityByDeal) || const DeepCollectionEquality().equals(other.availabilityByDeal, availabilityByDeal)) &&
            (identical(other.availabilityByAsset, availabilityByAsset) || const DeepCollectionEquality().equals(other.availabilityByAsset, availabilityByAsset)) &&
            (identical(other.qcRequired, qcRequired) || const DeepCollectionEquality().equals(other.qcRequired, qcRequired)) &&
            (identical(other.availabilityQcDelay, availabilityQcDelay) || const DeepCollectionEquality().equals(other.availabilityQcDelay, availabilityQcDelay)) &&
            (identical(other.allowAllUsersAddToOrder, allowAllUsersAddToOrder) || const DeepCollectionEquality().equals(other.allowAllUsersAddToOrder, allowAllUsersAddToOrder)) &&
            (identical(other.unitValue, unitValue) || const DeepCollectionEquality().equals(other.unitValue, unitValue)) &&
            (identical(other.replacementCost, replacementCost) || const DeepCollectionEquality().equals(other.replacementCost, replacementCost)) &&
            (identical(other.markupReplacementCost, markupReplacementCost) || const DeepCollectionEquality().equals(other.markupReplacementCost, markupReplacementCost)) &&
            (identical(other.replacementCostMarkupPercent, replacementCostMarkupPercent) || const DeepCollectionEquality().equals(other.replacementCostMarkupPercent, replacementCostMarkupPercent)) &&
            (identical(other.isWarehouseSpecific, isWarehouseSpecific) || const DeepCollectionEquality().equals(other.isWarehouseSpecific, isWarehouseSpecific)) &&
            (identical(other.itemDescription, itemDescription) || const DeepCollectionEquality().equals(other.itemDescription, itemDescription)) &&
            (identical(other.warehouseId, warehouseId) || const DeepCollectionEquality().equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouseCode, warehouseCode) || const DeepCollectionEquality().equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.warehouse, warehouse) || const DeepCollectionEquality().equals(other.warehouse, warehouse)) &&
            (identical(other.warehouseOrderBy, warehouseOrderBy) || const DeepCollectionEquality().equals(other.warehouseOrderBy, warehouseOrderBy)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsInventoryWarehouseInventoryWarehouseExtension
    on WebApiModulesHomeControlsInventoryWarehouseInventoryWarehouse {
  WebApiModulesHomeControlsInventoryWarehouseInventoryWarehouse copyWith(
      {String? inventoryId,
      double? hourlyRate,
      double? hourlyCost,
      double? dailyRate,
      double? dailyCost,
      double? weeklyRate,
      double? weeklyCost,
      double? week2Rate,
      double? week3Rate,
      double? week4Rate,
      double? monthlyRate,
      double? monthlyCost,
      double? retail,
      double? price,
      double? defaultCost,
      double? averageCost,
      double? markupPercent,
      int? reorderPoint,
      int? reorderQuantity,
      double? maximumDiscount,
      double? minimumDaysPerWeek,
      bool? hasTieredCost,
      double? restockingFee,
      double? restockingPercent,
      String? dateOfLastPhysicalInventory,
      double? qty,
      double? qtyConsigned,
      double? qtyIn,
      double? qtyInContainer,
      int? qtyQcRequired,
      double? qtyStaged,
      double? qtyOut,
      double? qtyInRepair,
      double? qtyOnPo,
      double? qtyAllocated,
      String? aisleLocation,
      String? shelfLocation,
      bool? availabilityByHour,
      bool? availabilityByDeal,
      bool? availabilityByAsset,
      bool? qcRequired,
      int? availabilityQcDelay,
      bool? allowAllUsersAddToOrder,
      double? unitValue,
      double? replacementCost,
      bool? markupReplacementCost,
      double? replacementCostMarkupPercent,
      bool? isWarehouseSpecific,
      String? itemDescription,
      String? warehouseId,
      String? warehouseCode,
      String? warehouse,
      int? warehouseOrderBy,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsInventoryWarehouseInventoryWarehouse(
        inventoryId: inventoryId ?? this.inventoryId,
        hourlyRate: hourlyRate ?? this.hourlyRate,
        hourlyCost: hourlyCost ?? this.hourlyCost,
        dailyRate: dailyRate ?? this.dailyRate,
        dailyCost: dailyCost ?? this.dailyCost,
        weeklyRate: weeklyRate ?? this.weeklyRate,
        weeklyCost: weeklyCost ?? this.weeklyCost,
        week2Rate: week2Rate ?? this.week2Rate,
        week3Rate: week3Rate ?? this.week3Rate,
        week4Rate: week4Rate ?? this.week4Rate,
        monthlyRate: monthlyRate ?? this.monthlyRate,
        monthlyCost: monthlyCost ?? this.monthlyCost,
        retail: retail ?? this.retail,
        price: price ?? this.price,
        defaultCost: defaultCost ?? this.defaultCost,
        averageCost: averageCost ?? this.averageCost,
        markupPercent: markupPercent ?? this.markupPercent,
        reorderPoint: reorderPoint ?? this.reorderPoint,
        reorderQuantity: reorderQuantity ?? this.reorderQuantity,
        maximumDiscount: maximumDiscount ?? this.maximumDiscount,
        minimumDaysPerWeek: minimumDaysPerWeek ?? this.minimumDaysPerWeek,
        hasTieredCost: hasTieredCost ?? this.hasTieredCost,
        restockingFee: restockingFee ?? this.restockingFee,
        restockingPercent: restockingPercent ?? this.restockingPercent,
        dateOfLastPhysicalInventory:
            dateOfLastPhysicalInventory ?? this.dateOfLastPhysicalInventory,
        qty: qty ?? this.qty,
        qtyConsigned: qtyConsigned ?? this.qtyConsigned,
        qtyIn: qtyIn ?? this.qtyIn,
        qtyInContainer: qtyInContainer ?? this.qtyInContainer,
        qtyQcRequired: qtyQcRequired ?? this.qtyQcRequired,
        qtyStaged: qtyStaged ?? this.qtyStaged,
        qtyOut: qtyOut ?? this.qtyOut,
        qtyInRepair: qtyInRepair ?? this.qtyInRepair,
        qtyOnPo: qtyOnPo ?? this.qtyOnPo,
        qtyAllocated: qtyAllocated ?? this.qtyAllocated,
        aisleLocation: aisleLocation ?? this.aisleLocation,
        shelfLocation: shelfLocation ?? this.shelfLocation,
        availabilityByHour: availabilityByHour ?? this.availabilityByHour,
        availabilityByDeal: availabilityByDeal ?? this.availabilityByDeal,
        availabilityByAsset: availabilityByAsset ?? this.availabilityByAsset,
        qcRequired: qcRequired ?? this.qcRequired,
        availabilityQcDelay: availabilityQcDelay ?? this.availabilityQcDelay,
        allowAllUsersAddToOrder:
            allowAllUsersAddToOrder ?? this.allowAllUsersAddToOrder,
        unitValue: unitValue ?? this.unitValue,
        replacementCost: replacementCost ?? this.replacementCost,
        markupReplacementCost:
            markupReplacementCost ?? this.markupReplacementCost,
        replacementCostMarkupPercent:
            replacementCostMarkupPercent ?? this.replacementCostMarkupPercent,
        isWarehouseSpecific: isWarehouseSpecific ?? this.isWarehouseSpecific,
        itemDescription: itemDescription ?? this.itemDescription,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        warehouse: warehouse ?? this.warehouse,
        warehouseOrderBy: warehouseOrderBy ?? this.warehouseOrderBy,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecific {
  WebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecific({
    this.inventoryId,
    this.warehouseId,
    this.warehouse,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecific.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecificFromJson(
          json);

  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecificFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecificToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecificToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecific &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouse, warehouse) ||
                const DeepCollectionEquality()
                    .equals(other.warehouse, warehouse)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecificExtension
    on WebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecific {
  WebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecific
      copyWith(
          {String? inventoryId,
          String? warehouseId,
          String? warehouse,
          String? recordTitle,
          List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
          List<FwStandardDataFwCustomValue>? custom,
          List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsInventoryWarehouseSpecificInventoryWarehouseSpecific(
        inventoryId: inventoryId ?? this.inventoryId,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouse: warehouse ?? this.warehouse,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatch {
  WebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatch({
    this.invoiceCreationBatchId,
    this.batchNumber,
    this.batchNumberAsString,
    this.batchDate,
    this.batchType,
    this.invoiceCount,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatch.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatchFromJson(
          json);

  @JsonKey(name: 'InvoiceCreationBatchId')
  final String? invoiceCreationBatchId;
  @JsonKey(name: 'BatchNumber')
  final int? batchNumber;
  @JsonKey(name: 'BatchNumberAsString')
  final String? batchNumberAsString;
  @JsonKey(name: 'BatchDate')
  final String? batchDate;
  @JsonKey(name: 'BatchType')
  final String? batchType;
  @JsonKey(name: 'InvoiceCount')
  final int? invoiceCount;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatchFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatchToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatchToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatch &&
            (identical(other.invoiceCreationBatchId, invoiceCreationBatchId) ||
                const DeepCollectionEquality().equals(
                    other.invoiceCreationBatchId, invoiceCreationBatchId)) &&
            (identical(other.batchNumber, batchNumber) ||
                const DeepCollectionEquality()
                    .equals(other.batchNumber, batchNumber)) &&
            (identical(other.batchNumberAsString, batchNumberAsString) ||
                const DeepCollectionEquality()
                    .equals(other.batchNumberAsString, batchNumberAsString)) &&
            (identical(other.batchDate, batchDate) ||
                const DeepCollectionEquality()
                    .equals(other.batchDate, batchDate)) &&
            (identical(other.batchType, batchType) ||
                const DeepCollectionEquality()
                    .equals(other.batchType, batchType)) &&
            (identical(other.invoiceCount, invoiceCount) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceCount, invoiceCount)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatchExtension
    on WebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatch {
  WebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatch copyWith(
      {String? invoiceCreationBatchId,
      int? batchNumber,
      String? batchNumberAsString,
      String? batchDate,
      String? batchType,
      int? invoiceCount,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsInvoiceCreationBatchInvoiceCreationBatch(
        invoiceCreationBatchId:
            invoiceCreationBatchId ?? this.invoiceCreationBatchId,
        batchNumber: batchNumber ?? this.batchNumber,
        batchNumberAsString: batchNumberAsString ?? this.batchNumberAsString,
        batchDate: batchDate ?? this.batchDate,
        batchType: batchType ?? this.batchType,
        invoiceCount: invoiceCount ?? this.invoiceCount,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInvoiceItemInvoiceItem {
  WebApiModulesHomeControlsInvoiceItemInvoiceItem({
    this.invoiceItemId,
    this.invoiceId,
    this.itemId,
    this.itemClass,
    this.itemOrder,
    this.inventoryId,
    this.orderId,
    this.parentId,
    this.repairId,
    this.repairNumber,
    this.recType,
    this.availableFor,
    this.bold,
    this.optionColor,
    this.orderItemId,
    this.nestedOrderItemId,
    this.isAdjusted,
    this.isRecurring,
    this.isManualBill,
    this.voidInvoiceItemId,
    this.isProfitCenter,
    this.profitCenterChargeCode1,
    this.profitCenterChargeCode2,
    this.profitCenterChargeCode,
    this.activity,
    this.activityExportCode,
    this.orderNumber,
    this.iCode,
    this.description,
    this.barCode,
    this.serialNumber,
    this.fromDate,
    this.fromTime,
    this.toDate,
    this.toTime,
    this.days,
    this.billableDays,
    this.quantity,
    this.cost,
    this.rate,
    this.unit,
    this.daysPerWeek,
    this.discountPercent,
    this.discountAmount,
    this.split,
    this.hours,
    this.hoursOvertime,
    this.hoursDoubletime,
    this.crewActualHours,
    this.meterOut,
    this.meterIn,
    this.lineTotalBeforeDiscount,
    this.extended,
    this.lineTotal,
    this.taxable,
    this.tax,
    this.tax2,
    this.lineTotalWithTax,
    this.adjustment,
    this.rebateAmount,
    this.adjustedRevenue,
    this.quikPayExtended,
    this.currencyId,
    this.currencyCode,
    this.currencySymbol,
    this.nestingLevel,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsInvoiceItemInvoiceItem.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInvoiceItemInvoiceItemFromJson(json);

  @JsonKey(name: 'InvoiceItemId')
  final String? invoiceItemId;
  @JsonKey(name: 'InvoiceId')
  final String? invoiceId;
  @JsonKey(name: 'ItemId')
  final String? itemId;
  @JsonKey(name: 'ItemClass')
  final String? itemClass;
  @JsonKey(name: 'ItemOrder')
  final String? itemOrder;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'ParentId')
  final String? parentId;
  @JsonKey(name: 'RepairId')
  final String? repairId;
  @JsonKey(name: 'RepairNumber')
  final String? repairNumber;
  @JsonKey(name: 'RecType')
  final String? recType;
  @JsonKey(name: 'AvailableFor')
  final String? availableFor;
  @JsonKey(name: 'Bold')
  final bool? bold;
  @JsonKey(name: 'OptionColor')
  final String? optionColor;
  @JsonKey(name: 'OrderItemId')
  final String? orderItemId;
  @JsonKey(name: 'NestedOrderItemId')
  final String? nestedOrderItemId;
  @JsonKey(name: 'IsAdjusted')
  final bool? isAdjusted;
  @JsonKey(name: 'IsRecurring')
  final bool? isRecurring;
  @JsonKey(name: 'IsManualBill')
  final bool? isManualBill;
  @JsonKey(name: 'VoidInvoiceItemId')
  final String? voidInvoiceItemId;
  @JsonKey(name: 'IsProfitCenter')
  final bool? isProfitCenter;
  @JsonKey(name: 'ProfitCenterChargeCode1')
  final String? profitCenterChargeCode1;
  @JsonKey(name: 'ProfitCenterChargeCode2')
  final String? profitCenterChargeCode2;
  @JsonKey(name: 'ProfitCenterChargeCode')
  final String? profitCenterChargeCode;
  @JsonKey(name: 'Activity')
  final String? activity;
  @JsonKey(name: 'ActivityExportCode')
  final String? activityExportCode;
  @JsonKey(name: 'OrderNumber')
  final String? orderNumber;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'BarCode')
  final String? barCode;
  @JsonKey(name: 'SerialNumber')
  final String? serialNumber;
  @JsonKey(name: 'FromDate')
  final String? fromDate;
  @JsonKey(name: 'FromTime')
  final String? fromTime;
  @JsonKey(name: 'ToDate')
  final String? toDate;
  @JsonKey(name: 'ToTime')
  final String? toTime;
  @JsonKey(name: 'Days')
  final double? days;
  @JsonKey(name: 'BillableDays')
  final double? billableDays;
  @JsonKey(name: 'Quantity')
  final double? quantity;
  @JsonKey(name: 'Cost')
  final double? cost;
  @JsonKey(name: 'Rate')
  final double? rate;
  @JsonKey(name: 'Unit')
  final String? unit;
  @JsonKey(name: 'DaysPerWeek')
  final double? daysPerWeek;
  @JsonKey(name: 'DiscountPercent')
  final double? discountPercent;
  @JsonKey(name: 'DiscountAmount')
  final double? discountAmount;
  @JsonKey(name: 'Split')
  final int? split;
  @JsonKey(name: 'Hours')
  final double? hours;
  @JsonKey(name: 'HoursOvertime')
  final double? hoursOvertime;
  @JsonKey(name: 'HoursDoubletime')
  final double? hoursDoubletime;
  @JsonKey(name: 'CrewActualHours')
  final bool? crewActualHours;
  @JsonKey(name: 'MeterOut')
  final double? meterOut;
  @JsonKey(name: 'MeterIn')
  final double? meterIn;
  @JsonKey(name: 'LineTotalBeforeDiscount')
  final double? lineTotalBeforeDiscount;
  @JsonKey(name: 'Extended')
  final double? extended;
  @JsonKey(name: 'LineTotal')
  final double? lineTotal;
  @JsonKey(name: 'Taxable')
  final bool? taxable;
  @JsonKey(name: 'Tax')
  final double? tax;
  @JsonKey(name: 'Tax2')
  final double? tax2;
  @JsonKey(name: 'LineTotalWithTax')
  final double? lineTotalWithTax;
  @JsonKey(name: 'Adjustment')
  final double? adjustment;
  @JsonKey(name: 'RebateAmount')
  final double? rebateAmount;
  @JsonKey(name: 'AdjustedRevenue')
  final double? adjustedRevenue;
  @JsonKey(name: 'QuikPayExtended')
  final double? quikPayExtended;
  @JsonKey(name: 'CurrencyId')
  final String? currencyId;
  @JsonKey(name: 'CurrencyCode')
  final String? currencyCode;
  @JsonKey(name: 'CurrencySymbol')
  final String? currencySymbol;
  @JsonKey(name: 'NestingLevel')
  final int? nestingLevel;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInvoiceItemInvoiceItemFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInvoiceItemInvoiceItemToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInvoiceItemInvoiceItemToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInvoiceItemInvoiceItem &&
            (identical(other.invoiceItemId, invoiceItemId) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceItemId, invoiceItemId)) &&
            (identical(other.invoiceId, invoiceId) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceId, invoiceId)) &&
            (identical(other.itemId, itemId) ||
                const DeepCollectionEquality().equals(other.itemId, itemId)) &&
            (identical(other.itemClass, itemClass) ||
                const DeepCollectionEquality()
                    .equals(other.itemClass, itemClass)) &&
            (identical(other.itemOrder, itemOrder) ||
                const DeepCollectionEquality()
                    .equals(other.itemOrder, itemOrder)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.parentId, parentId) ||
                const DeepCollectionEquality()
                    .equals(other.parentId, parentId)) &&
            (identical(other.repairId, repairId) ||
                const DeepCollectionEquality()
                    .equals(other.repairId, repairId)) &&
            (identical(other.repairNumber, repairNumber) ||
                const DeepCollectionEquality()
                    .equals(other.repairNumber, repairNumber)) &&
            (identical(other.recType, recType) ||
                const DeepCollectionEquality()
                    .equals(other.recType, recType)) &&
            (identical(other.availableFor, availableFor) ||
                const DeepCollectionEquality()
                    .equals(other.availableFor, availableFor)) &&
            (identical(other.bold, bold) ||
                const DeepCollectionEquality().equals(other.bold, bold)) &&
            (identical(other.optionColor, optionColor) ||
                const DeepCollectionEquality()
                    .equals(other.optionColor, optionColor)) &&
            (identical(other.orderItemId, orderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.orderItemId, orderItemId)) &&
            (identical(other.nestedOrderItemId, nestedOrderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.nestedOrderItemId, nestedOrderItemId)) &&
            (identical(other.isAdjusted, isAdjusted) ||
                const DeepCollectionEquality()
                    .equals(other.isAdjusted, isAdjusted)) &&
            (identical(other.isRecurring, isRecurring) ||
                const DeepCollectionEquality()
                    .equals(other.isRecurring, isRecurring)) &&
            (identical(other.isManualBill, isManualBill) ||
                const DeepCollectionEquality()
                    .equals(other.isManualBill, isManualBill)) &&
            (identical(other.voidInvoiceItemId, voidInvoiceItemId) ||
                const DeepCollectionEquality()
                    .equals(other.voidInvoiceItemId, voidInvoiceItemId)) &&
            (identical(other.isProfitCenter, isProfitCenter) ||
                const DeepCollectionEquality()
                    .equals(other.isProfitCenter, isProfitCenter)) &&
            (identical(other.profitCenterChargeCode1, profitCenterChargeCode1) ||
                const DeepCollectionEquality().equals(
                    other.profitCenterChargeCode1, profitCenterChargeCode1)) &&
            (identical(other.profitCenterChargeCode2, profitCenterChargeCode2) ||
                const DeepCollectionEquality().equals(other.profitCenterChargeCode2, profitCenterChargeCode2)) &&
            (identical(other.profitCenterChargeCode, profitCenterChargeCode) || const DeepCollectionEquality().equals(other.profitCenterChargeCode, profitCenterChargeCode)) &&
            (identical(other.activity, activity) || const DeepCollectionEquality().equals(other.activity, activity)) &&
            (identical(other.activityExportCode, activityExportCode) || const DeepCollectionEquality().equals(other.activityExportCode, activityExportCode)) &&
            (identical(other.orderNumber, orderNumber) || const DeepCollectionEquality().equals(other.orderNumber, orderNumber)) &&
            (identical(other.iCode, iCode) || const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) || const DeepCollectionEquality().equals(other.description, description)) &&
            (identical(other.barCode, barCode) || const DeepCollectionEquality().equals(other.barCode, barCode)) &&
            (identical(other.serialNumber, serialNumber) || const DeepCollectionEquality().equals(other.serialNumber, serialNumber)) &&
            (identical(other.fromDate, fromDate) || const DeepCollectionEquality().equals(other.fromDate, fromDate)) &&
            (identical(other.fromTime, fromTime) || const DeepCollectionEquality().equals(other.fromTime, fromTime)) &&
            (identical(other.toDate, toDate) || const DeepCollectionEquality().equals(other.toDate, toDate)) &&
            (identical(other.toTime, toTime) || const DeepCollectionEquality().equals(other.toTime, toTime)) &&
            (identical(other.days, days) || const DeepCollectionEquality().equals(other.days, days)) &&
            (identical(other.billableDays, billableDays) || const DeepCollectionEquality().equals(other.billableDays, billableDays)) &&
            (identical(other.quantity, quantity) || const DeepCollectionEquality().equals(other.quantity, quantity)) &&
            (identical(other.cost, cost) || const DeepCollectionEquality().equals(other.cost, cost)) &&
            (identical(other.rate, rate) || const DeepCollectionEquality().equals(other.rate, rate)) &&
            (identical(other.unit, unit) || const DeepCollectionEquality().equals(other.unit, unit)) &&
            (identical(other.daysPerWeek, daysPerWeek) || const DeepCollectionEquality().equals(other.daysPerWeek, daysPerWeek)) &&
            (identical(other.discountPercent, discountPercent) || const DeepCollectionEquality().equals(other.discountPercent, discountPercent)) &&
            (identical(other.discountAmount, discountAmount) || const DeepCollectionEquality().equals(other.discountAmount, discountAmount)) &&
            (identical(other.split, split) || const DeepCollectionEquality().equals(other.split, split)) &&
            (identical(other.hours, hours) || const DeepCollectionEquality().equals(other.hours, hours)) &&
            (identical(other.hoursOvertime, hoursOvertime) || const DeepCollectionEquality().equals(other.hoursOvertime, hoursOvertime)) &&
            (identical(other.hoursDoubletime, hoursDoubletime) || const DeepCollectionEquality().equals(other.hoursDoubletime, hoursDoubletime)) &&
            (identical(other.crewActualHours, crewActualHours) || const DeepCollectionEquality().equals(other.crewActualHours, crewActualHours)) &&
            (identical(other.meterOut, meterOut) || const DeepCollectionEquality().equals(other.meterOut, meterOut)) &&
            (identical(other.meterIn, meterIn) || const DeepCollectionEquality().equals(other.meterIn, meterIn)) &&
            (identical(other.lineTotalBeforeDiscount, lineTotalBeforeDiscount) || const DeepCollectionEquality().equals(other.lineTotalBeforeDiscount, lineTotalBeforeDiscount)) &&
            (identical(other.extended, extended) || const DeepCollectionEquality().equals(other.extended, extended)) &&
            (identical(other.lineTotal, lineTotal) || const DeepCollectionEquality().equals(other.lineTotal, lineTotal)) &&
            (identical(other.taxable, taxable) || const DeepCollectionEquality().equals(other.taxable, taxable)) &&
            (identical(other.tax, tax) || const DeepCollectionEquality().equals(other.tax, tax)) &&
            (identical(other.tax2, tax2) || const DeepCollectionEquality().equals(other.tax2, tax2)) &&
            (identical(other.lineTotalWithTax, lineTotalWithTax) || const DeepCollectionEquality().equals(other.lineTotalWithTax, lineTotalWithTax)) &&
            (identical(other.adjustment, adjustment) || const DeepCollectionEquality().equals(other.adjustment, adjustment)) &&
            (identical(other.rebateAmount, rebateAmount) || const DeepCollectionEquality().equals(other.rebateAmount, rebateAmount)) &&
            (identical(other.adjustedRevenue, adjustedRevenue) || const DeepCollectionEquality().equals(other.adjustedRevenue, adjustedRevenue)) &&
            (identical(other.quikPayExtended, quikPayExtended) || const DeepCollectionEquality().equals(other.quikPayExtended, quikPayExtended)) &&
            (identical(other.currencyId, currencyId) || const DeepCollectionEquality().equals(other.currencyId, currencyId)) &&
            (identical(other.currencyCode, currencyCode) || const DeepCollectionEquality().equals(other.currencyCode, currencyCode)) &&
            (identical(other.currencySymbol, currencySymbol) || const DeepCollectionEquality().equals(other.currencySymbol, currencySymbol)) &&
            (identical(other.nestingLevel, nestingLevel) || const DeepCollectionEquality().equals(other.nestingLevel, nestingLevel)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsInvoiceItemInvoiceItemExtension
    on WebApiModulesHomeControlsInvoiceItemInvoiceItem {
  WebApiModulesHomeControlsInvoiceItemInvoiceItem copyWith(
      {String? invoiceItemId,
      String? invoiceId,
      String? itemId,
      String? itemClass,
      String? itemOrder,
      String? inventoryId,
      String? orderId,
      String? parentId,
      String? repairId,
      String? repairNumber,
      String? recType,
      String? availableFor,
      bool? bold,
      String? optionColor,
      String? orderItemId,
      String? nestedOrderItemId,
      bool? isAdjusted,
      bool? isRecurring,
      bool? isManualBill,
      String? voidInvoiceItemId,
      bool? isProfitCenter,
      String? profitCenterChargeCode1,
      String? profitCenterChargeCode2,
      String? profitCenterChargeCode,
      String? activity,
      String? activityExportCode,
      String? orderNumber,
      String? iCode,
      String? description,
      String? barCode,
      String? serialNumber,
      String? fromDate,
      String? fromTime,
      String? toDate,
      String? toTime,
      double? days,
      double? billableDays,
      double? quantity,
      double? cost,
      double? rate,
      String? unit,
      double? daysPerWeek,
      double? discountPercent,
      double? discountAmount,
      int? split,
      double? hours,
      double? hoursOvertime,
      double? hoursDoubletime,
      bool? crewActualHours,
      double? meterOut,
      double? meterIn,
      double? lineTotalBeforeDiscount,
      double? extended,
      double? lineTotal,
      bool? taxable,
      double? tax,
      double? tax2,
      double? lineTotalWithTax,
      double? adjustment,
      double? rebateAmount,
      double? adjustedRevenue,
      double? quikPayExtended,
      String? currencyId,
      String? currencyCode,
      String? currencySymbol,
      int? nestingLevel,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsInvoiceItemInvoiceItem(
        invoiceItemId: invoiceItemId ?? this.invoiceItemId,
        invoiceId: invoiceId ?? this.invoiceId,
        itemId: itemId ?? this.itemId,
        itemClass: itemClass ?? this.itemClass,
        itemOrder: itemOrder ?? this.itemOrder,
        inventoryId: inventoryId ?? this.inventoryId,
        orderId: orderId ?? this.orderId,
        parentId: parentId ?? this.parentId,
        repairId: repairId ?? this.repairId,
        repairNumber: repairNumber ?? this.repairNumber,
        recType: recType ?? this.recType,
        availableFor: availableFor ?? this.availableFor,
        bold: bold ?? this.bold,
        optionColor: optionColor ?? this.optionColor,
        orderItemId: orderItemId ?? this.orderItemId,
        nestedOrderItemId: nestedOrderItemId ?? this.nestedOrderItemId,
        isAdjusted: isAdjusted ?? this.isAdjusted,
        isRecurring: isRecurring ?? this.isRecurring,
        isManualBill: isManualBill ?? this.isManualBill,
        voidInvoiceItemId: voidInvoiceItemId ?? this.voidInvoiceItemId,
        isProfitCenter: isProfitCenter ?? this.isProfitCenter,
        profitCenterChargeCode1:
            profitCenterChargeCode1 ?? this.profitCenterChargeCode1,
        profitCenterChargeCode2:
            profitCenterChargeCode2 ?? this.profitCenterChargeCode2,
        profitCenterChargeCode:
            profitCenterChargeCode ?? this.profitCenterChargeCode,
        activity: activity ?? this.activity,
        activityExportCode: activityExportCode ?? this.activityExportCode,
        orderNumber: orderNumber ?? this.orderNumber,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        barCode: barCode ?? this.barCode,
        serialNumber: serialNumber ?? this.serialNumber,
        fromDate: fromDate ?? this.fromDate,
        fromTime: fromTime ?? this.fromTime,
        toDate: toDate ?? this.toDate,
        toTime: toTime ?? this.toTime,
        days: days ?? this.days,
        billableDays: billableDays ?? this.billableDays,
        quantity: quantity ?? this.quantity,
        cost: cost ?? this.cost,
        rate: rate ?? this.rate,
        unit: unit ?? this.unit,
        daysPerWeek: daysPerWeek ?? this.daysPerWeek,
        discountPercent: discountPercent ?? this.discountPercent,
        discountAmount: discountAmount ?? this.discountAmount,
        split: split ?? this.split,
        hours: hours ?? this.hours,
        hoursOvertime: hoursOvertime ?? this.hoursOvertime,
        hoursDoubletime: hoursDoubletime ?? this.hoursDoubletime,
        crewActualHours: crewActualHours ?? this.crewActualHours,
        meterOut: meterOut ?? this.meterOut,
        meterIn: meterIn ?? this.meterIn,
        lineTotalBeforeDiscount:
            lineTotalBeforeDiscount ?? this.lineTotalBeforeDiscount,
        extended: extended ?? this.extended,
        lineTotal: lineTotal ?? this.lineTotal,
        taxable: taxable ?? this.taxable,
        tax: tax ?? this.tax,
        tax2: tax2 ?? this.tax2,
        lineTotalWithTax: lineTotalWithTax ?? this.lineTotalWithTax,
        adjustment: adjustment ?? this.adjustment,
        rebateAmount: rebateAmount ?? this.rebateAmount,
        adjustedRevenue: adjustedRevenue ?? this.adjustedRevenue,
        quikPayExtended: quikPayExtended ?? this.quikPayExtended,
        currencyId: currencyId ?? this.currencyId,
        currencyCode: currencyCode ?? this.currencyCode,
        currencySymbol: currencySymbol ?? this.currencySymbol,
        nestingLevel: nestingLevel ?? this.nestingLevel,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInvoiceNoteInvoiceNote {
  WebApiModulesHomeControlsInvoiceNoteInvoiceNote({
    this.invoiceNoteId,
    this.invoiceId,
    this.orderId,
    this.orderNumber,
    this.noteDate,
    this.description,
    this.notesById,
    this.notesBy,
    this.notes,
    this.printOnInvoice,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsInvoiceNoteInvoiceNote.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInvoiceNoteInvoiceNoteFromJson(json);

  @JsonKey(name: 'InvoiceNoteId')
  final String? invoiceNoteId;
  @JsonKey(name: 'InvoiceId')
  final String? invoiceId;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderNumber')
  final String? orderNumber;
  @JsonKey(name: 'NoteDate')
  final String? noteDate;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'NotesById')
  final String? notesById;
  @JsonKey(name: 'NotesBy')
  final String? notesBy;
  @JsonKey(name: 'Notes')
  final String? notes;
  @JsonKey(name: 'PrintOnInvoice')
  final bool? printOnInvoice;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInvoiceNoteInvoiceNoteFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInvoiceNoteInvoiceNoteToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInvoiceNoteInvoiceNoteToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInvoiceNoteInvoiceNote &&
            (identical(other.invoiceNoteId, invoiceNoteId) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceNoteId, invoiceNoteId)) &&
            (identical(other.invoiceId, invoiceId) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceId, invoiceId)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderNumber, orderNumber) ||
                const DeepCollectionEquality()
                    .equals(other.orderNumber, orderNumber)) &&
            (identical(other.noteDate, noteDate) ||
                const DeepCollectionEquality()
                    .equals(other.noteDate, noteDate)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.notesById, notesById) ||
                const DeepCollectionEquality()
                    .equals(other.notesById, notesById)) &&
            (identical(other.notesBy, notesBy) ||
                const DeepCollectionEquality()
                    .equals(other.notesBy, notesBy)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.printOnInvoice, printOnInvoice) ||
                const DeepCollectionEquality()
                    .equals(other.printOnInvoice, printOnInvoice)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsInvoiceNoteInvoiceNoteExtension
    on WebApiModulesHomeControlsInvoiceNoteInvoiceNote {
  WebApiModulesHomeControlsInvoiceNoteInvoiceNote copyWith(
      {String? invoiceNoteId,
      String? invoiceId,
      String? orderId,
      String? orderNumber,
      String? noteDate,
      String? description,
      String? notesById,
      String? notesBy,
      String? notes,
      bool? printOnInvoice,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsInvoiceNoteInvoiceNote(
        invoiceNoteId: invoiceNoteId ?? this.invoiceNoteId,
        invoiceId: invoiceId ?? this.invoiceId,
        orderId: orderId ?? this.orderId,
        orderNumber: orderNumber ?? this.orderNumber,
        noteDate: noteDate ?? this.noteDate,
        description: description ?? this.description,
        notesById: notesById ?? this.notesById,
        notesBy: notesBy ?? this.notesBy,
        notes: notes ?? this.notes,
        printOnInvoice: printOnInvoice ?? this.printOnInvoice,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsInvoiceReceiptInvoiceReceipt {
  WebApiModulesHomeControlsInvoiceReceiptInvoiceReceipt({
    this.invoiceReceiptId,
    this.invoiceId,
    this.receiptId,
    this.receiptDate,
    this.paymentTypeId,
    this.paymentType,
    this.checkNumber,
    this.recType,
    this.paymentBy,
    this.receiptCustomerId,
    this.receiptCustomer,
    this.receiptDealId,
    this.receiptDeal,
    this.invoiceNumber,
    this.invoiceDate,
    this.invoiceDescription,
    this.invoiceDealId,
    this.invoiceDeal,
    this.amount,
    this.appliedById,
    this.appliedBy,
    this.paymentMemo,
    this.currencyId,
    this.currencyCode,
    this.currencySymbol,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsInvoiceReceiptInvoiceReceipt.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsInvoiceReceiptInvoiceReceiptFromJson(json);

  @JsonKey(name: 'InvoiceReceiptId')
  final int? invoiceReceiptId;
  @JsonKey(name: 'InvoiceId')
  final String? invoiceId;
  @JsonKey(name: 'ReceiptId')
  final String? receiptId;
  @JsonKey(name: 'ReceiptDate')
  final String? receiptDate;
  @JsonKey(name: 'PaymentTypeId')
  final String? paymentTypeId;
  @JsonKey(name: 'PaymentType')
  final String? paymentType;
  @JsonKey(name: 'CheckNumber')
  final String? checkNumber;
  @JsonKey(name: 'RecType')
  final bool? recType;
  @JsonKey(name: 'PaymentBy')
  final String? paymentBy;
  @JsonKey(name: 'ReceiptCustomerId')
  final String? receiptCustomerId;
  @JsonKey(name: 'ReceiptCustomer')
  final String? receiptCustomer;
  @JsonKey(name: 'ReceiptDealId')
  final String? receiptDealId;
  @JsonKey(name: 'ReceiptDeal')
  final String? receiptDeal;
  @JsonKey(name: 'InvoiceNumber')
  final String? invoiceNumber;
  @JsonKey(name: 'InvoiceDate')
  final String? invoiceDate;
  @JsonKey(name: 'InvoiceDescription')
  final String? invoiceDescription;
  @JsonKey(name: 'InvoiceDealId')
  final String? invoiceDealId;
  @JsonKey(name: 'InvoiceDeal')
  final String? invoiceDeal;
  @JsonKey(name: 'Amount')
  final double? amount;
  @JsonKey(name: 'AppliedById')
  final String? appliedById;
  @JsonKey(name: 'AppliedBy')
  final String? appliedBy;
  @JsonKey(name: 'PaymentMemo')
  final String? paymentMemo;
  @JsonKey(name: 'CurrencyId')
  final String? currencyId;
  @JsonKey(name: 'CurrencyCode')
  final String? currencyCode;
  @JsonKey(name: 'CurrencySymbol')
  final String? currencySymbol;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsInvoiceReceiptInvoiceReceiptFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsInvoiceReceiptInvoiceReceiptToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsInvoiceReceiptInvoiceReceiptToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsInvoiceReceiptInvoiceReceipt &&
            (identical(other.invoiceReceiptId, invoiceReceiptId) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceReceiptId, invoiceReceiptId)) &&
            (identical(other.invoiceId, invoiceId) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceId, invoiceId)) &&
            (identical(other.receiptId, receiptId) ||
                const DeepCollectionEquality()
                    .equals(other.receiptId, receiptId)) &&
            (identical(other.receiptDate, receiptDate) ||
                const DeepCollectionEquality()
                    .equals(other.receiptDate, receiptDate)) &&
            (identical(other.paymentTypeId, paymentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.paymentTypeId, paymentTypeId)) &&
            (identical(other.paymentType, paymentType) ||
                const DeepCollectionEquality()
                    .equals(other.paymentType, paymentType)) &&
            (identical(other.checkNumber, checkNumber) ||
                const DeepCollectionEquality()
                    .equals(other.checkNumber, checkNumber)) &&
            (identical(other.recType, recType) ||
                const DeepCollectionEquality()
                    .equals(other.recType, recType)) &&
            (identical(other.paymentBy, paymentBy) ||
                const DeepCollectionEquality()
                    .equals(other.paymentBy, paymentBy)) &&
            (identical(other.receiptCustomerId, receiptCustomerId) ||
                const DeepCollectionEquality()
                    .equals(other.receiptCustomerId, receiptCustomerId)) &&
            (identical(other.receiptCustomer, receiptCustomer) ||
                const DeepCollectionEquality()
                    .equals(other.receiptCustomer, receiptCustomer)) &&
            (identical(other.receiptDealId, receiptDealId) ||
                const DeepCollectionEquality()
                    .equals(other.receiptDealId, receiptDealId)) &&
            (identical(other.receiptDeal, receiptDeal) ||
                const DeepCollectionEquality()
                    .equals(other.receiptDeal, receiptDeal)) &&
            (identical(other.invoiceNumber, invoiceNumber) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceNumber, invoiceNumber)) &&
            (identical(other.invoiceDate, invoiceDate) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceDate, invoiceDate)) &&
            (identical(other.invoiceDescription, invoiceDescription) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceDescription, invoiceDescription)) &&
            (identical(other.invoiceDealId, invoiceDealId) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceDealId, invoiceDealId)) &&
            (identical(other.invoiceDeal, invoiceDeal) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceDeal, invoiceDeal)) &&
            (identical(other.amount, amount) ||
                const DeepCollectionEquality().equals(other.amount, amount)) &&
            (identical(other.appliedById, appliedById) ||
                const DeepCollectionEquality()
                    .equals(other.appliedById, appliedById)) &&
            (identical(other.appliedBy, appliedBy) ||
                const DeepCollectionEquality()
                    .equals(other.appliedBy, appliedBy)) &&
            (identical(other.paymentMemo, paymentMemo) ||
                const DeepCollectionEquality()
                    .equals(other.paymentMemo, paymentMemo)) &&
            (identical(other.currencyId, currencyId) || const DeepCollectionEquality().equals(other.currencyId, currencyId)) &&
            (identical(other.currencyCode, currencyCode) || const DeepCollectionEquality().equals(other.currencyCode, currencyCode)) &&
            (identical(other.currencySymbol, currencySymbol) || const DeepCollectionEquality().equals(other.currencySymbol, currencySymbol)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsInvoiceReceiptInvoiceReceiptExtension
    on WebApiModulesHomeControlsInvoiceReceiptInvoiceReceipt {
  WebApiModulesHomeControlsInvoiceReceiptInvoiceReceipt copyWith(
      {int? invoiceReceiptId,
      String? invoiceId,
      String? receiptId,
      String? receiptDate,
      String? paymentTypeId,
      String? paymentType,
      String? checkNumber,
      bool? recType,
      String? paymentBy,
      String? receiptCustomerId,
      String? receiptCustomer,
      String? receiptDealId,
      String? receiptDeal,
      String? invoiceNumber,
      String? invoiceDate,
      String? invoiceDescription,
      String? invoiceDealId,
      String? invoiceDeal,
      double? amount,
      String? appliedById,
      String? appliedBy,
      String? paymentMemo,
      String? currencyId,
      String? currencyCode,
      String? currencySymbol,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsInvoiceReceiptInvoiceReceipt(
        invoiceReceiptId: invoiceReceiptId ?? this.invoiceReceiptId,
        invoiceId: invoiceId ?? this.invoiceId,
        receiptId: receiptId ?? this.receiptId,
        receiptDate: receiptDate ?? this.receiptDate,
        paymentTypeId: paymentTypeId ?? this.paymentTypeId,
        paymentType: paymentType ?? this.paymentType,
        checkNumber: checkNumber ?? this.checkNumber,
        recType: recType ?? this.recType,
        paymentBy: paymentBy ?? this.paymentBy,
        receiptCustomerId: receiptCustomerId ?? this.receiptCustomerId,
        receiptCustomer: receiptCustomer ?? this.receiptCustomer,
        receiptDealId: receiptDealId ?? this.receiptDealId,
        receiptDeal: receiptDeal ?? this.receiptDeal,
        invoiceNumber: invoiceNumber ?? this.invoiceNumber,
        invoiceDate: invoiceDate ?? this.invoiceDate,
        invoiceDescription: invoiceDescription ?? this.invoiceDescription,
        invoiceDealId: invoiceDealId ?? this.invoiceDealId,
        invoiceDeal: invoiceDeal ?? this.invoiceDeal,
        amount: amount ?? this.amount,
        appliedById: appliedById ?? this.appliedById,
        appliedBy: appliedBy ?? this.appliedBy,
        paymentMemo: paymentMemo ?? this.paymentMemo,
        currencyId: currencyId ?? this.currencyId,
        currencyCode: currencyCode ?? this.currencyCode,
        currencySymbol: currencySymbol ?? this.currencySymbol,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsItemAttributeValueItemAttributeValue {
  WebApiModulesHomeControlsItemAttributeValueItemAttributeValue({
    this.itemAttributeValueId,
    this.attributeId,
    this.itemId,
    this.attribute,
    this.attributeValueId,
    this.attributeValue,
    this.numericValue,
    this.numericOnly,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsItemAttributeValueItemAttributeValue.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsItemAttributeValueItemAttributeValueFromJson(
          json);

  @JsonKey(name: 'ItemAttributeValueId')
  final String? itemAttributeValueId;
  @JsonKey(name: 'AttributeId')
  final String? attributeId;
  @JsonKey(name: 'ItemId')
  final String? itemId;
  @JsonKey(name: 'Attribute')
  final String? attribute;
  @JsonKey(name: 'AttributeValueId')
  final String? attributeValueId;
  @JsonKey(name: 'AttributeValue')
  final String? attributeValue;
  @JsonKey(name: 'NumericValue')
  final double? numericValue;
  @JsonKey(name: 'NumericOnly')
  final bool? numericOnly;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsItemAttributeValueItemAttributeValueFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsItemAttributeValueItemAttributeValueToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsItemAttributeValueItemAttributeValueToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsItemAttributeValueItemAttributeValue &&
            (identical(other.itemAttributeValueId, itemAttributeValueId) ||
                const DeepCollectionEquality().equals(
                    other.itemAttributeValueId, itemAttributeValueId)) &&
            (identical(other.attributeId, attributeId) ||
                const DeepCollectionEquality()
                    .equals(other.attributeId, attributeId)) &&
            (identical(other.itemId, itemId) ||
                const DeepCollectionEquality().equals(other.itemId, itemId)) &&
            (identical(other.attribute, attribute) ||
                const DeepCollectionEquality()
                    .equals(other.attribute, attribute)) &&
            (identical(other.attributeValueId, attributeValueId) ||
                const DeepCollectionEquality()
                    .equals(other.attributeValueId, attributeValueId)) &&
            (identical(other.attributeValue, attributeValue) ||
                const DeepCollectionEquality()
                    .equals(other.attributeValue, attributeValue)) &&
            (identical(other.numericValue, numericValue) ||
                const DeepCollectionEquality()
                    .equals(other.numericValue, numericValue)) &&
            (identical(other.numericOnly, numericOnly) ||
                const DeepCollectionEquality()
                    .equals(other.numericOnly, numericOnly)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsItemAttributeValueItemAttributeValueExtension
    on WebApiModulesHomeControlsItemAttributeValueItemAttributeValue {
  WebApiModulesHomeControlsItemAttributeValueItemAttributeValue copyWith(
      {String? itemAttributeValueId,
      String? attributeId,
      String? itemId,
      String? attribute,
      String? attributeValueId,
      String? attributeValue,
      double? numericValue,
      bool? numericOnly,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsItemAttributeValueItemAttributeValue(
        itemAttributeValueId: itemAttributeValueId ?? this.itemAttributeValueId,
        attributeId: attributeId ?? this.attributeId,
        itemId: itemId ?? this.itemId,
        attribute: attribute ?? this.attribute,
        attributeValueId: attributeValueId ?? this.attributeValueId,
        attributeValue: attributeValue ?? this.attributeValue,
        numericValue: numericValue ?? this.numericValue,
        numericOnly: numericOnly ?? this.numericOnly,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsItemQcItemQc {
  WebApiModulesHomeControlsItemQcItemQc({
    this.itemQcId,
    this.itemId,
    this.qcRequiredAsOf,
    this.qcByUsersId,
    this.qcByUser,
    this.qcDateTime,
    this.lastOrderId,
    this.lastOrderNumber,
    this.lastOrderDescription,
    this.lastDealId,
    this.lastDealNumber,
    this.lastDeal,
    this.conditionId,
    this.inContractId,
    this.condition,
    this.note,
    this.hasImage,
    this.qcAppImageId,
    this.datstamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsItemQcItemQc.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsItemQcItemQcFromJson(json);

  @JsonKey(name: 'ItemQcId')
  final String? itemQcId;
  @JsonKey(name: 'ItemId')
  final String? itemId;
  @JsonKey(name: 'QcRequiredAsOf')
  final String? qcRequiredAsOf;
  @JsonKey(name: 'QcByUsersId')
  final String? qcByUsersId;
  @JsonKey(name: 'QcByUser')
  final String? qcByUser;
  @JsonKey(name: 'QcDateTime')
  final String? qcDateTime;
  @JsonKey(name: 'LastOrderId')
  final String? lastOrderId;
  @JsonKey(name: 'LastOrderNumber')
  final String? lastOrderNumber;
  @JsonKey(name: 'LastOrderDescription')
  final String? lastOrderDescription;
  @JsonKey(name: 'LastDealId')
  final String? lastDealId;
  @JsonKey(name: 'LastDealNumber')
  final String? lastDealNumber;
  @JsonKey(name: 'LastDeal')
  final String? lastDeal;
  @JsonKey(name: 'ConditionId')
  final String? conditionId;
  @JsonKey(name: 'InContractId')
  final String? inContractId;
  @JsonKey(name: 'Condition')
  final String? condition;
  @JsonKey(name: 'Note')
  final String? note;
  @JsonKey(name: 'HasImage')
  final bool? hasImage;
  @JsonKey(name: 'QcAppImageId')
  final String? qcAppImageId;
  @JsonKey(name: 'Datstamp')
  final String? datstamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsItemQcItemQcFromJson;
  static const toJsonFactory = _$WebApiModulesHomeControlsItemQcItemQcToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsItemQcItemQcToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsItemQcItemQc &&
            (identical(other.itemQcId, itemQcId) ||
                const DeepCollectionEquality()
                    .equals(other.itemQcId, itemQcId)) &&
            (identical(other.itemId, itemId) ||
                const DeepCollectionEquality().equals(other.itemId, itemId)) &&
            (identical(other.qcRequiredAsOf, qcRequiredAsOf) ||
                const DeepCollectionEquality()
                    .equals(other.qcRequiredAsOf, qcRequiredAsOf)) &&
            (identical(other.qcByUsersId, qcByUsersId) ||
                const DeepCollectionEquality()
                    .equals(other.qcByUsersId, qcByUsersId)) &&
            (identical(other.qcByUser, qcByUser) ||
                const DeepCollectionEquality()
                    .equals(other.qcByUser, qcByUser)) &&
            (identical(other.qcDateTime, qcDateTime) ||
                const DeepCollectionEquality()
                    .equals(other.qcDateTime, qcDateTime)) &&
            (identical(other.lastOrderId, lastOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.lastOrderId, lastOrderId)) &&
            (identical(other.lastOrderNumber, lastOrderNumber) ||
                const DeepCollectionEquality()
                    .equals(other.lastOrderNumber, lastOrderNumber)) &&
            (identical(other.lastOrderDescription, lastOrderDescription) ||
                const DeepCollectionEquality().equals(
                    other.lastOrderDescription, lastOrderDescription)) &&
            (identical(other.lastDealId, lastDealId) ||
                const DeepCollectionEquality()
                    .equals(other.lastDealId, lastDealId)) &&
            (identical(other.lastDealNumber, lastDealNumber) ||
                const DeepCollectionEquality()
                    .equals(other.lastDealNumber, lastDealNumber)) &&
            (identical(other.lastDeal, lastDeal) ||
                const DeepCollectionEquality()
                    .equals(other.lastDeal, lastDeal)) &&
            (identical(other.conditionId, conditionId) ||
                const DeepCollectionEquality()
                    .equals(other.conditionId, conditionId)) &&
            (identical(other.inContractId, inContractId) ||
                const DeepCollectionEquality()
                    .equals(other.inContractId, inContractId)) &&
            (identical(other.condition, condition) ||
                const DeepCollectionEquality()
                    .equals(other.condition, condition)) &&
            (identical(other.note, note) ||
                const DeepCollectionEquality().equals(other.note, note)) &&
            (identical(other.hasImage, hasImage) ||
                const DeepCollectionEquality()
                    .equals(other.hasImage, hasImage)) &&
            (identical(other.qcAppImageId, qcAppImageId) ||
                const DeepCollectionEquality()
                    .equals(other.qcAppImageId, qcAppImageId)) &&
            (identical(other.datstamp, datstamp) ||
                const DeepCollectionEquality()
                    .equals(other.datstamp, datstamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsItemQcItemQcExtension
    on WebApiModulesHomeControlsItemQcItemQc {
  WebApiModulesHomeControlsItemQcItemQc copyWith(
      {String? itemQcId,
      String? itemId,
      String? qcRequiredAsOf,
      String? qcByUsersId,
      String? qcByUser,
      String? qcDateTime,
      String? lastOrderId,
      String? lastOrderNumber,
      String? lastOrderDescription,
      String? lastDealId,
      String? lastDealNumber,
      String? lastDeal,
      String? conditionId,
      String? inContractId,
      String? condition,
      String? note,
      bool? hasImage,
      String? qcAppImageId,
      String? datstamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsItemQcItemQc(
        itemQcId: itemQcId ?? this.itemQcId,
        itemId: itemId ?? this.itemId,
        qcRequiredAsOf: qcRequiredAsOf ?? this.qcRequiredAsOf,
        qcByUsersId: qcByUsersId ?? this.qcByUsersId,
        qcByUser: qcByUser ?? this.qcByUser,
        qcDateTime: qcDateTime ?? this.qcDateTime,
        lastOrderId: lastOrderId ?? this.lastOrderId,
        lastOrderNumber: lastOrderNumber ?? this.lastOrderNumber,
        lastOrderDescription: lastOrderDescription ?? this.lastOrderDescription,
        lastDealId: lastDealId ?? this.lastDealId,
        lastDealNumber: lastDealNumber ?? this.lastDealNumber,
        lastDeal: lastDeal ?? this.lastDeal,
        conditionId: conditionId ?? this.conditionId,
        inContractId: inContractId ?? this.inContractId,
        condition: condition ?? this.condition,
        note: note ?? this.note,
        hasImage: hasImage ?? this.hasImage,
        qcAppImageId: qcAppImageId ?? this.qcAppImageId,
        datstamp: datstamp ?? this.datstamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionRequest {
  WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionRequest({
    this.sourceOrderId,
    this.sessionId,
  });

  factory WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionRequestFromJson(
          json);

  @JsonKey(name: 'SourceOrderId')
  final String? sourceOrderId;
  @JsonKey(name: 'SessionId')
  final String? sessionId;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionRequest &&
            (identical(other.sourceOrderId, sourceOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.sourceOrderId, sourceOrderId)) &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)));
  }
}

extension $WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionRequestExtension
    on WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionRequest {
  WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionRequest
      copyWith({String? sourceOrderId, String? sessionId}) {
    return WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionRequest(
        sourceOrderId: sourceOrderId ?? this.sourceOrderId,
        sessionId: sessionId ?? this.sessionId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionResponse {
  WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionResponseExtension
    on WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionResponse {
  WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionResponse
      copyWith({int? status, bool? success, String? msg}) {
    return WebApiModulesHomeControlsLossAndDamageCompleteLossAndDamageSessionResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsLossAndDamageCreateLossAndDamageOrderFromRepairResponse {
  WebApiModulesHomeControlsLossAndDamageCreateLossAndDamageOrderFromRepairResponse({
    this.status,
    this.success,
    this.msg,
    this.order,
  });

  factory WebApiModulesHomeControlsLossAndDamageCreateLossAndDamageOrderFromRepairResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsLossAndDamageCreateLossAndDamageOrderFromRepairResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'Order')
  final WebApiModulesAgentOrderOrder? order;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsLossAndDamageCreateLossAndDamageOrderFromRepairResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsLossAndDamageCreateLossAndDamageOrderFromRepairResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsLossAndDamageCreateLossAndDamageOrderFromRepairResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsLossAndDamageCreateLossAndDamageOrderFromRepairResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.order, order) ||
                const DeepCollectionEquality().equals(other.order, order)));
  }
}

extension $WebApiModulesHomeControlsLossAndDamageCreateLossAndDamageOrderFromRepairResponseExtension
    on WebApiModulesHomeControlsLossAndDamageCreateLossAndDamageOrderFromRepairResponse {
  WebApiModulesHomeControlsLossAndDamageCreateLossAndDamageOrderFromRepairResponse
      copyWith(
          {int? status,
          bool? success,
          String? msg,
          WebApiModulesAgentOrderOrder? order}) {
    return WebApiModulesHomeControlsLossAndDamageCreateLossAndDamageOrderFromRepairResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        order: order ?? this.order);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemRequest {
  WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemRequest({
    this.orderId,
    this.locationId,
    this.warehouseId,
  });

  factory WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemRequestFromJson(
          json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'LocationId')
  final String? locationId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.locationId, locationId) ||
                const DeepCollectionEquality()
                    .equals(other.locationId, locationId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)));
  }
}

extension $WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemRequestExtension
    on WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemRequest {
  WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemRequest copyWith(
      {String? orderId, String? locationId, String? warehouseId}) {
    return WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemRequest(
        orderId: orderId ?? this.orderId,
        locationId: locationId ?? this.locationId,
        warehouseId: warehouseId ?? this.warehouseId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemResponse {
  WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemResponse({
    this.status,
    this.success,
    this.msg,
    this.contractId,
  });

  factory WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'ContractId')
  final String? contractId;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)));
  }
}

extension $WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemResponseExtension
    on WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemResponse {
  WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemResponse
      copyWith({int? status, bool? success, String? msg, String? contractId}) {
    return WebApiModulesHomeControlsLossAndDamageRetireLossAndDamageItemResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        contractId: contractId ?? this.contractId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemRequest {
  WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemRequest({
    this.sessionId,
  });

  factory WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemRequestFromJson(
          json);

  @JsonKey(name: 'SessionId')
  final String? sessionId;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemRequest &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)));
  }
}

extension $WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemRequestExtension
    on WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemRequest {
  WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemRequest
      copyWith({String? sessionId}) {
    return WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemRequest(
        sessionId: sessionId ?? this.sessionId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemResponse {
  WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemResponseExtension
    on WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemResponse {
  WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemResponse
      copyWith({int? status, bool? success, String? msg}) {
    return WebApiModulesHomeControlsLossAndDamageSelectAllNoneLossAndDamageItemResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionRequest {
  WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionRequest({
    this.dealId,
    this.warehouseId,
    this.orderIds,
  });

  factory WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionRequestFromJson(
          json);

  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'OrderIds')
  final String? orderIds;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionRequest &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.orderIds, orderIds) ||
                const DeepCollectionEquality()
                    .equals(other.orderIds, orderIds)));
  }
}

extension $WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionRequestExtension
    on WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionRequest {
  WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionRequest
      copyWith({String? dealId, String? warehouseId, String? orderIds}) {
    return WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionRequest(
        dealId: dealId ?? this.dealId,
        warehouseId: warehouseId ?? this.warehouseId,
        orderIds: orderIds ?? this.orderIds);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionResponse {
  WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionResponse({
    this.sessionId,
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionResponseFromJson(
          json);

  @JsonKey(name: 'SessionId')
  final String? sessionId;
  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionResponse &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionResponseExtension
    on WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionResponse {
  WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionResponse
      copyWith({String? sessionId, int? status, bool? success, String? msg}) {
    return WebApiModulesHomeControlsLossAndDamageStartLossAndDamageSessionResponse(
        sessionId: sessionId ?? this.sessionId,
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemRequest {
  WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemRequest({
    this.sessionId,
    this.orderId,
    this.orderItemId,
    this.barCode,
    this.quantity,
  });

  factory WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemRequestFromJson(
          json);

  @JsonKey(name: 'SessionId')
  final String? sessionId;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderItemId')
  final String? orderItemId;
  @JsonKey(name: 'BarCode')
  final String? barCode;
  @JsonKey(name: 'Quantity')
  final int? quantity;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemRequest &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderItemId, orderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.orderItemId, orderItemId)) &&
            (identical(other.barCode, barCode) ||
                const DeepCollectionEquality()
                    .equals(other.barCode, barCode)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)));
  }
}

extension $WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemRequestExtension
    on WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemRequest {
  WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemRequest copyWith(
      {String? sessionId,
      String? orderId,
      String? orderItemId,
      String? barCode,
      int? quantity}) {
    return WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemRequest(
        sessionId: sessionId ?? this.sessionId,
        orderId: orderId ?? this.orderId,
        orderItemId: orderItemId ?? this.orderItemId,
        barCode: barCode ?? this.barCode,
        quantity: quantity ?? this.quantity);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemResponse {
  WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemResponse({
    this.newQuantity,
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemResponseFromJson(
          json);

  @JsonKey(name: 'NewQuantity')
  final int? newQuantity;
  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemResponse &&
            (identical(other.newQuantity, newQuantity) ||
                const DeepCollectionEquality()
                    .equals(other.newQuantity, newQuantity)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemResponseExtension
    on WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemResponse {
  WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemResponse
      copyWith({int? newQuantity, int? status, bool? success, String? msg}) {
    return WebApiModulesHomeControlsLossAndDamageUpdateLossAndDamageItemResponse(
        newQuantity: newQuantity ?? this.newQuantity,
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsManifestManifest {
  WebApiModulesHomeControlsManifestManifest({
    this.manifestId,
    this.manifestNumber,
    this.manifestDate,
    this.contractType,
    this.departmentId,
    this.department,
    this.locationId,
    this.location,
    this.locationCode,
    this.nameFirstMiddleLast,
    this.transferId,
    this.transferNumber,
    this.transferDescription,
    this.hasVoid,
    this.rental,
    this.sales,
    this.exchange,
    this.manifestTime,
    this.warehouseId,
    this.warehouse,
    this.warehouseCode,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsManifestManifest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsManifestManifestFromJson(json);

  @JsonKey(name: 'ManifestId')
  final String? manifestId;
  @JsonKey(name: 'ManifestNumber')
  final String? manifestNumber;
  @JsonKey(name: 'ManifestDate')
  final String? manifestDate;
  @JsonKey(name: 'ContractType')
  final String? contractType;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'Department')
  final String? department;
  @JsonKey(name: 'LocationId')
  final String? locationId;
  @JsonKey(name: 'Location')
  final String? location;
  @JsonKey(name: 'LocationCode')
  final String? locationCode;
  @JsonKey(name: 'NameFirstMiddleLast')
  final String? nameFirstMiddleLast;
  @JsonKey(name: 'TransferId')
  final String? transferId;
  @JsonKey(name: 'TransferNumber')
  final String? transferNumber;
  @JsonKey(name: 'TransferDescription')
  final String? transferDescription;
  @JsonKey(name: 'HasVoid')
  final bool? hasVoid;
  @JsonKey(name: 'Rental')
  final bool? rental;
  @JsonKey(name: 'Sales')
  final bool? sales;
  @JsonKey(name: 'Exchange')
  final bool? exchange;
  @JsonKey(name: 'ManifestTime')
  final String? manifestTime;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsManifestManifestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsManifestManifestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsManifestManifestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsManifestManifest &&
            (identical(other.manifestId, manifestId) ||
                const DeepCollectionEquality()
                    .equals(other.manifestId, manifestId)) &&
            (identical(other.manifestNumber, manifestNumber) ||
                const DeepCollectionEquality()
                    .equals(other.manifestNumber, manifestNumber)) &&
            (identical(other.manifestDate, manifestDate) ||
                const DeepCollectionEquality()
                    .equals(other.manifestDate, manifestDate)) &&
            (identical(other.contractType, contractType) ||
                const DeepCollectionEquality()
                    .equals(other.contractType, contractType)) &&
            (identical(other.departmentId, departmentId) ||
                const DeepCollectionEquality()
                    .equals(other.departmentId, departmentId)) &&
            (identical(other.department, department) ||
                const DeepCollectionEquality()
                    .equals(other.department, department)) &&
            (identical(other.locationId, locationId) ||
                const DeepCollectionEquality()
                    .equals(other.locationId, locationId)) &&
            (identical(other.location, location) ||
                const DeepCollectionEquality()
                    .equals(other.location, location)) &&
            (identical(other.locationCode, locationCode) ||
                const DeepCollectionEquality()
                    .equals(other.locationCode, locationCode)) &&
            (identical(other.nameFirstMiddleLast, nameFirstMiddleLast) ||
                const DeepCollectionEquality()
                    .equals(other.nameFirstMiddleLast, nameFirstMiddleLast)) &&
            (identical(other.transferId, transferId) ||
                const DeepCollectionEquality()
                    .equals(other.transferId, transferId)) &&
            (identical(other.transferNumber, transferNumber) ||
                const DeepCollectionEquality()
                    .equals(other.transferNumber, transferNumber)) &&
            (identical(other.transferDescription, transferDescription) ||
                const DeepCollectionEquality()
                    .equals(other.transferDescription, transferDescription)) &&
            (identical(other.hasVoid, hasVoid) ||
                const DeepCollectionEquality()
                    .equals(other.hasVoid, hasVoid)) &&
            (identical(other.rental, rental) ||
                const DeepCollectionEquality().equals(other.rental, rental)) &&
            (identical(other.sales, sales) ||
                const DeepCollectionEquality().equals(other.sales, sales)) &&
            (identical(other.exchange, exchange) ||
                const DeepCollectionEquality()
                    .equals(other.exchange, exchange)) &&
            (identical(other.manifestTime, manifestTime) ||
                const DeepCollectionEquality()
                    .equals(other.manifestTime, manifestTime)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouse, warehouse) ||
                const DeepCollectionEquality()
                    .equals(other.warehouse, warehouse)) &&
            (identical(other.warehouseCode, warehouseCode) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsManifestManifestExtension
    on WebApiModulesHomeControlsManifestManifest {
  WebApiModulesHomeControlsManifestManifest copyWith(
      {String? manifestId,
      String? manifestNumber,
      String? manifestDate,
      String? contractType,
      String? departmentId,
      String? department,
      String? locationId,
      String? location,
      String? locationCode,
      String? nameFirstMiddleLast,
      String? transferId,
      String? transferNumber,
      String? transferDescription,
      bool? hasVoid,
      bool? rental,
      bool? sales,
      bool? exchange,
      String? manifestTime,
      String? warehouseId,
      String? warehouse,
      String? warehouseCode,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsManifestManifest(
        manifestId: manifestId ?? this.manifestId,
        manifestNumber: manifestNumber ?? this.manifestNumber,
        manifestDate: manifestDate ?? this.manifestDate,
        contractType: contractType ?? this.contractType,
        departmentId: departmentId ?? this.departmentId,
        department: department ?? this.department,
        locationId: locationId ?? this.locationId,
        location: location ?? this.location,
        locationCode: locationCode ?? this.locationCode,
        nameFirstMiddleLast: nameFirstMiddleLast ?? this.nameFirstMiddleLast,
        transferId: transferId ?? this.transferId,
        transferNumber: transferNumber ?? this.transferNumber,
        transferDescription: transferDescription ?? this.transferDescription,
        hasVoid: hasVoid ?? this.hasVoid,
        rental: rental ?? this.rental,
        sales: sales ?? this.sales,
        exchange: exchange ?? this.exchange,
        manifestTime: manifestTime ?? this.manifestTime,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouse: warehouse ?? this.warehouse,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsOrderContactOrderContact {
  WebApiModulesHomeControlsOrderContactOrderContact({
    this.orderContactId,
    this.orderId,
    this.contactId,
    this.nameFml,
    this.nameLfm,
    this.person,
    this.personColor,
    this.firstName,
    this.middleInitial,
    this.lastName,
    this.contactTitle,
    this.officePhone,
    this.officeExtension,
    this.mobilePhone,
    this.email,
    this.pager,
    this.pagerPin,
    this.jobTitle,
    this.contactTitleId,
    this.companyContactId,
    this.companyId,
    this.isPrimary,
    this.countryId,
    this.isOrderedBy,
    this.isProductionContact,
    this.isPrintable,
    this.contactOnOrder,
    this.inactive,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsOrderContactOrderContact.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsOrderContactOrderContactFromJson(json);

  @JsonKey(name: 'OrderContactId')
  final int? orderContactId;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'ContactId')
  final String? contactId;
  @JsonKey(name: 'NameFml')
  final String? nameFml;
  @JsonKey(name: 'NameLfm')
  final String? nameLfm;
  @JsonKey(name: 'Person')
  final String? person;
  @JsonKey(name: 'PersonColor')
  final String? personColor;
  @JsonKey(name: 'FirstName')
  final String? firstName;
  @JsonKey(name: 'MiddleInitial')
  final String? middleInitial;
  @JsonKey(name: 'LastName')
  final String? lastName;
  @JsonKey(name: 'ContactTitle')
  final String? contactTitle;
  @JsonKey(name: 'OfficePhone')
  final String? officePhone;
  @JsonKey(name: 'OfficeExtension')
  final String? officeExtension;
  @JsonKey(name: 'MobilePhone')
  final String? mobilePhone;
  @JsonKey(name: 'Email')
  final String? email;
  @JsonKey(name: 'Pager')
  final String? pager;
  @JsonKey(name: 'PagerPin')
  final String? pagerPin;
  @JsonKey(name: 'JobTitle')
  final String? jobTitle;
  @JsonKey(name: 'ContactTitleId')
  final String? contactTitleId;
  @JsonKey(name: 'CompanyContactId')
  final String? companyContactId;
  @JsonKey(name: 'CompanyId')
  final String? companyId;
  @JsonKey(name: 'IsPrimary')
  final bool? isPrimary;
  @JsonKey(name: 'CountryId')
  final String? countryId;
  @JsonKey(name: 'IsOrderedBy')
  final bool? isOrderedBy;
  @JsonKey(name: 'IsProductionContact')
  final bool? isProductionContact;
  @JsonKey(name: 'IsPrintable')
  final bool? isPrintable;
  @JsonKey(name: 'ContactOnOrder')
  final bool? contactOnOrder;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsOrderContactOrderContactFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsOrderContactOrderContactToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsOrderContactOrderContactToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsOrderContactOrderContact &&
            (identical(other.orderContactId, orderContactId) ||
                const DeepCollectionEquality()
                    .equals(other.orderContactId, orderContactId)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.contactId, contactId) ||
                const DeepCollectionEquality()
                    .equals(other.contactId, contactId)) &&
            (identical(other.nameFml, nameFml) ||
                const DeepCollectionEquality()
                    .equals(other.nameFml, nameFml)) &&
            (identical(other.nameLfm, nameLfm) ||
                const DeepCollectionEquality()
                    .equals(other.nameLfm, nameLfm)) &&
            (identical(other.person, person) ||
                const DeepCollectionEquality().equals(other.person, person)) &&
            (identical(other.personColor, personColor) ||
                const DeepCollectionEquality()
                    .equals(other.personColor, personColor)) &&
            (identical(other.firstName, firstName) ||
                const DeepCollectionEquality()
                    .equals(other.firstName, firstName)) &&
            (identical(other.middleInitial, middleInitial) ||
                const DeepCollectionEquality()
                    .equals(other.middleInitial, middleInitial)) &&
            (identical(other.lastName, lastName) ||
                const DeepCollectionEquality()
                    .equals(other.lastName, lastName)) &&
            (identical(other.contactTitle, contactTitle) ||
                const DeepCollectionEquality()
                    .equals(other.contactTitle, contactTitle)) &&
            (identical(other.officePhone, officePhone) ||
                const DeepCollectionEquality()
                    .equals(other.officePhone, officePhone)) &&
            (identical(other.officeExtension, officeExtension) ||
                const DeepCollectionEquality()
                    .equals(other.officeExtension, officeExtension)) &&
            (identical(other.mobilePhone, mobilePhone) ||
                const DeepCollectionEquality()
                    .equals(other.mobilePhone, mobilePhone)) &&
            (identical(other.email, email) ||
                const DeepCollectionEquality().equals(other.email, email)) &&
            (identical(other.pager, pager) ||
                const DeepCollectionEquality().equals(other.pager, pager)) &&
            (identical(other.pagerPin, pagerPin) ||
                const DeepCollectionEquality()
                    .equals(other.pagerPin, pagerPin)) &&
            (identical(other.jobTitle, jobTitle) ||
                const DeepCollectionEquality()
                    .equals(other.jobTitle, jobTitle)) &&
            (identical(other.contactTitleId, contactTitleId) ||
                const DeepCollectionEquality()
                    .equals(other.contactTitleId, contactTitleId)) &&
            (identical(other.companyContactId, companyContactId) ||
                const DeepCollectionEquality()
                    .equals(other.companyContactId, companyContactId)) &&
            (identical(other.companyId, companyId) ||
                const DeepCollectionEquality()
                    .equals(other.companyId, companyId)) &&
            (identical(other.isPrimary, isPrimary) ||
                const DeepCollectionEquality()
                    .equals(other.isPrimary, isPrimary)) &&
            (identical(other.countryId, countryId) ||
                const DeepCollectionEquality()
                    .equals(other.countryId, countryId)) &&
            (identical(other.isOrderedBy, isOrderedBy) || const DeepCollectionEquality().equals(other.isOrderedBy, isOrderedBy)) &&
            (identical(other.isProductionContact, isProductionContact) || const DeepCollectionEquality().equals(other.isProductionContact, isProductionContact)) &&
            (identical(other.isPrintable, isPrintable) || const DeepCollectionEquality().equals(other.isPrintable, isPrintable)) &&
            (identical(other.contactOnOrder, contactOnOrder) || const DeepCollectionEquality().equals(other.contactOnOrder, contactOnOrder)) &&
            (identical(other.inactive, inactive) || const DeepCollectionEquality().equals(other.inactive, inactive)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsOrderContactOrderContactExtension
    on WebApiModulesHomeControlsOrderContactOrderContact {
  WebApiModulesHomeControlsOrderContactOrderContact copyWith(
      {int? orderContactId,
      String? orderId,
      String? contactId,
      String? nameFml,
      String? nameLfm,
      String? person,
      String? personColor,
      String? firstName,
      String? middleInitial,
      String? lastName,
      String? contactTitle,
      String? officePhone,
      String? officeExtension,
      String? mobilePhone,
      String? email,
      String? pager,
      String? pagerPin,
      String? jobTitle,
      String? contactTitleId,
      String? companyContactId,
      String? companyId,
      bool? isPrimary,
      String? countryId,
      bool? isOrderedBy,
      bool? isProductionContact,
      bool? isPrintable,
      bool? contactOnOrder,
      bool? inactive,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsOrderContactOrderContact(
        orderContactId: orderContactId ?? this.orderContactId,
        orderId: orderId ?? this.orderId,
        contactId: contactId ?? this.contactId,
        nameFml: nameFml ?? this.nameFml,
        nameLfm: nameLfm ?? this.nameLfm,
        person: person ?? this.person,
        personColor: personColor ?? this.personColor,
        firstName: firstName ?? this.firstName,
        middleInitial: middleInitial ?? this.middleInitial,
        lastName: lastName ?? this.lastName,
        contactTitle: contactTitle ?? this.contactTitle,
        officePhone: officePhone ?? this.officePhone,
        officeExtension: officeExtension ?? this.officeExtension,
        mobilePhone: mobilePhone ?? this.mobilePhone,
        email: email ?? this.email,
        pager: pager ?? this.pager,
        pagerPin: pagerPin ?? this.pagerPin,
        jobTitle: jobTitle ?? this.jobTitle,
        contactTitleId: contactTitleId ?? this.contactTitleId,
        companyContactId: companyContactId ?? this.companyContactId,
        companyId: companyId ?? this.companyId,
        isPrimary: isPrimary ?? this.isPrimary,
        countryId: countryId ?? this.countryId,
        isOrderedBy: isOrderedBy ?? this.isOrderedBy,
        isProductionContact: isProductionContact ?? this.isProductionContact,
        isPrintable: isPrintable ?? this.isPrintable,
        contactOnOrder: contactOnOrder ?? this.contactOnOrder,
        inactive: inactive ?? this.inactive,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsOrderDatesOrderDates {
  WebApiModulesHomeControlsOrderDatesOrderDates({
    this.orderId,
    this.orderTypeId,
    this.orderTypeDateTypeId,
    this.isSystemType,
    this.activityTypeId,
    this.activityType,
    this.activity,
    this.activityDisplay,
    this.description,
    this.descriptionDisplay,
    this.descriptionDisplayTitleCase,
    this.isEnabled,
    this.date,
    this.time,
    this.dateAndTime,
    this.dayOfWeek,
    this.actualDate,
    this.actualTime,
    this.actualDayOfWeek,
    this.isRequired,
    this.isProductionActivity,
    this.isMilestone,
    this.orderBy,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsOrderDatesOrderDates.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsOrderDatesOrderDatesFromJson(json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderTypeId')
  final String? orderTypeId;
  @JsonKey(name: 'OrderTypeDateTypeId')
  final String? orderTypeDateTypeId;
  @JsonKey(name: 'IsSystemType')
  final bool? isSystemType;
  @JsonKey(name: 'ActivityTypeId')
  final String? activityTypeId;
  @JsonKey(name: 'ActivityType')
  final String? activityType;
  @JsonKey(name: 'Activity')
  final String? activity;
  @JsonKey(name: 'ActivityDisplay')
  final String? activityDisplay;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'DescriptionDisplay')
  final String? descriptionDisplay;
  @JsonKey(name: 'DescriptionDisplayTitleCase')
  final String? descriptionDisplayTitleCase;
  @JsonKey(name: 'IsEnabled')
  final bool? isEnabled;
  @JsonKey(name: 'Date')
  final String? date;
  @JsonKey(name: 'Time')
  final String? time;
  @JsonKey(name: 'DateAndTime')
  final String? dateAndTime;
  @JsonKey(name: 'DayOfWeek')
  final String? dayOfWeek;
  @JsonKey(name: 'ActualDate')
  final String? actualDate;
  @JsonKey(name: 'ActualTime')
  final String? actualTime;
  @JsonKey(name: 'ActualDayOfWeek')
  final String? actualDayOfWeek;
  @JsonKey(name: 'IsRequired')
  final bool? isRequired;
  @JsonKey(name: 'IsProductionActivity')
  final bool? isProductionActivity;
  @JsonKey(name: 'IsMilestone')
  final bool? isMilestone;
  @JsonKey(name: 'OrderBy')
  final double? orderBy;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsOrderDatesOrderDatesFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsOrderDatesOrderDatesToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsOrderDatesOrderDatesToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsOrderDatesOrderDates &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderTypeId, orderTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.orderTypeId, orderTypeId)) &&
            (identical(other.orderTypeDateTypeId, orderTypeDateTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.orderTypeDateTypeId, orderTypeDateTypeId)) &&
            (identical(other.isSystemType, isSystemType) ||
                const DeepCollectionEquality()
                    .equals(other.isSystemType, isSystemType)) &&
            (identical(other.activityTypeId, activityTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.activityTypeId, activityTypeId)) &&
            (identical(other.activityType, activityType) ||
                const DeepCollectionEquality()
                    .equals(other.activityType, activityType)) &&
            (identical(other.activity, activity) ||
                const DeepCollectionEquality()
                    .equals(other.activity, activity)) &&
            (identical(other.activityDisplay, activityDisplay) ||
                const DeepCollectionEquality()
                    .equals(other.activityDisplay, activityDisplay)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.descriptionDisplay, descriptionDisplay) ||
                const DeepCollectionEquality()
                    .equals(other.descriptionDisplay, descriptionDisplay)) &&
            (identical(other.descriptionDisplayTitleCase, descriptionDisplayTitleCase) ||
                const DeepCollectionEquality().equals(
                    other.descriptionDisplayTitleCase,
                    descriptionDisplayTitleCase)) &&
            (identical(other.isEnabled, isEnabled) ||
                const DeepCollectionEquality()
                    .equals(other.isEnabled, isEnabled)) &&
            (identical(other.date, date) ||
                const DeepCollectionEquality().equals(other.date, date)) &&
            (identical(other.time, time) ||
                const DeepCollectionEquality().equals(other.time, time)) &&
            (identical(other.dateAndTime, dateAndTime) ||
                const DeepCollectionEquality()
                    .equals(other.dateAndTime, dateAndTime)) &&
            (identical(other.dayOfWeek, dayOfWeek) ||
                const DeepCollectionEquality()
                    .equals(other.dayOfWeek, dayOfWeek)) &&
            (identical(other.actualDate, actualDate) ||
                const DeepCollectionEquality()
                    .equals(other.actualDate, actualDate)) &&
            (identical(other.actualTime, actualTime) ||
                const DeepCollectionEquality()
                    .equals(other.actualTime, actualTime)) &&
            (identical(other.actualDayOfWeek, actualDayOfWeek) ||
                const DeepCollectionEquality()
                    .equals(other.actualDayOfWeek, actualDayOfWeek)) &&
            (identical(other.isRequired, isRequired) ||
                const DeepCollectionEquality()
                    .equals(other.isRequired, isRequired)) &&
            (identical(other.isProductionActivity, isProductionActivity) ||
                const DeepCollectionEquality().equals(other.isProductionActivity, isProductionActivity)) &&
            (identical(other.isMilestone, isMilestone) || const DeepCollectionEquality().equals(other.isMilestone, isMilestone)) &&
            (identical(other.orderBy, orderBy) || const DeepCollectionEquality().equals(other.orderBy, orderBy)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsOrderDatesOrderDatesExtension
    on WebApiModulesHomeControlsOrderDatesOrderDates {
  WebApiModulesHomeControlsOrderDatesOrderDates copyWith(
      {String? orderId,
      String? orderTypeId,
      String? orderTypeDateTypeId,
      bool? isSystemType,
      String? activityTypeId,
      String? activityType,
      String? activity,
      String? activityDisplay,
      String? description,
      String? descriptionDisplay,
      String? descriptionDisplayTitleCase,
      bool? isEnabled,
      String? date,
      String? time,
      String? dateAndTime,
      String? dayOfWeek,
      String? actualDate,
      String? actualTime,
      String? actualDayOfWeek,
      bool? isRequired,
      bool? isProductionActivity,
      bool? isMilestone,
      double? orderBy,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsOrderDatesOrderDates(
        orderId: orderId ?? this.orderId,
        orderTypeId: orderTypeId ?? this.orderTypeId,
        orderTypeDateTypeId: orderTypeDateTypeId ?? this.orderTypeDateTypeId,
        isSystemType: isSystemType ?? this.isSystemType,
        activityTypeId: activityTypeId ?? this.activityTypeId,
        activityType: activityType ?? this.activityType,
        activity: activity ?? this.activity,
        activityDisplay: activityDisplay ?? this.activityDisplay,
        description: description ?? this.description,
        descriptionDisplay: descriptionDisplay ?? this.descriptionDisplay,
        descriptionDisplayTitleCase:
            descriptionDisplayTitleCase ?? this.descriptionDisplayTitleCase,
        isEnabled: isEnabled ?? this.isEnabled,
        date: date ?? this.date,
        time: time ?? this.time,
        dateAndTime: dateAndTime ?? this.dateAndTime,
        dayOfWeek: dayOfWeek ?? this.dayOfWeek,
        actualDate: actualDate ?? this.actualDate,
        actualTime: actualTime ?? this.actualTime,
        actualDayOfWeek: actualDayOfWeek ?? this.actualDayOfWeek,
        isRequired: isRequired ?? this.isRequired,
        isProductionActivity: isProductionActivity ?? this.isProductionActivity,
        isMilestone: isMilestone ?? this.isMilestone,
        orderBy: orderBy ?? this.orderBy,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsOrderItemCompleteKitOption {
  WebApiModulesHomeControlsOrderItemCompleteKitOption({
    this.inventoryId,
    this.inventoryPackageInventoryId,
    this.quantity,
  });

  factory WebApiModulesHomeControlsOrderItemCompleteKitOption.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsOrderItemCompleteKitOptionFromJson(json);

  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'InventoryPackageInventoryId')
  final String? inventoryPackageInventoryId;
  @JsonKey(name: 'Quantity')
  final int? quantity;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsOrderItemCompleteKitOptionFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsOrderItemCompleteKitOptionToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsOrderItemCompleteKitOptionToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsOrderItemCompleteKitOption &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.inventoryPackageInventoryId,
                    inventoryPackageInventoryId) ||
                const DeepCollectionEquality().equals(
                    other.inventoryPackageInventoryId,
                    inventoryPackageInventoryId)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)));
  }
}

extension $WebApiModulesHomeControlsOrderItemCompleteKitOptionExtension
    on WebApiModulesHomeControlsOrderItemCompleteKitOption {
  WebApiModulesHomeControlsOrderItemCompleteKitOption copyWith(
      {String? inventoryId,
      String? inventoryPackageInventoryId,
      int? quantity}) {
    return WebApiModulesHomeControlsOrderItemCompleteKitOption(
        inventoryId: inventoryId ?? this.inventoryId,
        inventoryPackageInventoryId:
            inventoryPackageInventoryId ?? this.inventoryPackageInventoryId,
        quantity: quantity ?? this.quantity);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsOrderItemInsertLineItemRequest {
  WebApiModulesHomeControlsOrderItemInsertLineItemRequest({
    this.orderId,
    this.belowOrderItemId,
    this.primaryItemId,
  });

  factory WebApiModulesHomeControlsOrderItemInsertLineItemRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsOrderItemInsertLineItemRequestFromJson(json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'BelowOrderItemId')
  final String? belowOrderItemId;
  @JsonKey(name: 'PrimaryItemId')
  final String? primaryItemId;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsOrderItemInsertLineItemRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsOrderItemInsertLineItemRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsOrderItemInsertLineItemRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsOrderItemInsertLineItemRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.belowOrderItemId, belowOrderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.belowOrderItemId, belowOrderItemId)) &&
            (identical(other.primaryItemId, primaryItemId) ||
                const DeepCollectionEquality()
                    .equals(other.primaryItemId, primaryItemId)));
  }
}

extension $WebApiModulesHomeControlsOrderItemInsertLineItemRequestExtension
    on WebApiModulesHomeControlsOrderItemInsertLineItemRequest {
  WebApiModulesHomeControlsOrderItemInsertLineItemRequest copyWith(
      {String? orderId, String? belowOrderItemId, String? primaryItemId}) {
    return WebApiModulesHomeControlsOrderItemInsertLineItemRequest(
        orderId: orderId ?? this.orderId,
        belowOrderItemId: belowOrderItemId ?? this.belowOrderItemId,
        primaryItemId: primaryItemId ?? this.primaryItemId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsOrderItemInsertOptionRequest {
  WebApiModulesHomeControlsOrderItemInsertOptionRequest({
    this.orderId,
    this.parentOrderItemId,
    this.items,
  });

  factory WebApiModulesHomeControlsOrderItemInsertOptionRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsOrderItemInsertOptionRequestFromJson(json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'ParentOrderItemId')
  final String? parentOrderItemId;
  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesHomeControlsOrderItemCompleteKitOption>[])
  final List<WebApiModulesHomeControlsOrderItemCompleteKitOption>? items;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsOrderItemInsertOptionRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsOrderItemInsertOptionRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsOrderItemInsertOptionRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsOrderItemInsertOptionRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.parentOrderItemId, parentOrderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.parentOrderItemId, parentOrderItemId)) &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)));
  }
}

extension $WebApiModulesHomeControlsOrderItemInsertOptionRequestExtension
    on WebApiModulesHomeControlsOrderItemInsertOptionRequest {
  WebApiModulesHomeControlsOrderItemInsertOptionRequest copyWith(
      {String? orderId,
      String? parentOrderItemId,
      List<WebApiModulesHomeControlsOrderItemCompleteKitOption>? items}) {
    return WebApiModulesHomeControlsOrderItemInsertOptionRequest(
        orderId: orderId ?? this.orderId,
        parentOrderItemId: parentOrderItemId ?? this.parentOrderItemId,
        items: items ?? this.items);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsOrderItemOrderItem {
  WebApiModulesHomeControlsOrderItemOrderItem({
    this.orderItemId,
    this.orderId,
    this.rowsRolledUp,
    this.rolledUpIds,
    this.orderType,
    this.recType,
    this.recTypeDisplay,
    this.rowNumber,
    this.inventoryId,
    this.iCode,
    this.iCodeColor,
    this.description,
    this.descriptionColor,
    this.pickDate,
    this.pickTime,
    this.fromDate,
    this.fromTime,
    this.toDate,
    this.toTime,
    this.billablePeriods,
    this.quantityOrdered,
    this.quantityColor,
    this.subQuantity,
    this.subQuantityColor,
    this.consignQuantity,
    this.reservedItemQuantity,
    this.availableQuantity,
    this.availabilityState,
    this.availableAllWarehousesQuantity,
    this.conflictDate,
    this.conflictDateAllWarehouses,
    this.conflictDateConsignment,
    this.unitId,
    this.unit,
    this.unitType,
    this.unitCost,
    this.marginPercent,
    this.markupPercent,
    this.premiumPercent,
    this.crewContactId,
    this.crewName,
    this.hours,
    this.hoursOvertime,
    this.hoursDoubletime,
    this.price,
    this.price2,
    this.price3,
    this.price4,
    this.price5,
    this.daysPerWeek,
    this.discountPercent,
    this.discountPercentDisplay,
    this.unitExtendedNoDiscount,
    this.unitDiscountAmount,
    this.unitExtended,
    this.weeklyExtendedNoDiscount,
    this.weeklyDiscountAmount,
    this.weeklyExtended,
    this.weeklyCostExtended,
    this.weeklyTax,
    this.weeklyTax1,
    this.weeklyTax2,
    this.weeklyTotal,
    this.week2Extended,
    this.week3Extended,
    this.weeks1Through3Extended,
    this.weeks4PlusExtended,
    this.week4Extended,
    this.averageWeekly,
    this.averageWeeklyExtended,
    this.averageWeeklyExtendedNoDiscount,
    this.averageWeeklyDiscountAmount,
    this.averageWeeklyTax,
    this.averageWeeklyTax1,
    this.averageWeeklyTax2,
    this.averageWeeklyTotal,
    this.episodes,
    this.monthlyExtendedNoDiscount,
    this.monthlyDiscountAmount,
    this.monthlyExtended,
    this.monthlyCostExtended,
    this.monthlyTax,
    this.monthlyTax1,
    this.monthlyTax2,
    this.monthlyTotal,
    this.periodExtendedNoDiscount,
    this.periodCostExtended,
    this.periodDiscountAmount,
    this.periodExtended,
    this.periodTax,
    this.periodTax1,
    this.periodTax2,
    this.periodTotal,
    this.periodVarianceExtended,
    this.variancePercent,
    this.minimumDaysPerWeek,
    this.bold,
    this.locked,
    this.taxable,
    this.warehouseId,
    this.warehouseCode,
    this.returnToWarehouseId,
    this.returnToWarehouseCode,
    this.notes,
    this.itemOrder,
    this.parentId,
    this.nestedOrderItemId,
    this.itemClass,
    this.inventoryClass,
    this.retiredReasonId,
    this.retiredReason,
    this.itemId,
    this.barCode,
    this.serialNumber,
    this.manufacturerPartNumber,
    this.poSubOrderId,
    this.poSubOrderItemId,
    this.poSubOrderNumber,
    this.lossAndDamageOrderId,
    this.lossAndDamageOrderItemId,
    this.lossAndDamageOrderNumber,
    this.modifiedAtStaging,
    this.mute,
    this.availabilityByHour,
    this.printNoteOnQuote,
    this.printNoteOnOrder,
    this.printNoteOnPickList,
    this.printNoteOnOutContract,
    this.printNoteOnInContract,
    this.printNoteOnReturnList,
    this.printNoteOnInvoice,
    this.printNoteOnPurchaseOrder,
    this.printNoteOnReceiveContract,
    this.printNoteOnReturnContract,
    this.printNoteOnVendorReceiveList,
    this.printNoteOnVendorReturnList,
    this.defaultHourlyRate,
    this.defaultDailyRate,
    this.defaultWeeklyRate,
    this.defaultMonthlyRate,
    this.nestingLevel,
    this.repairId,
    this.repairNumber,
    this.accessoryRatio,
    this.isOption,
    this.optionColor,
    this.currencySymbol,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsOrderItemOrderItem.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsOrderItemOrderItemFromJson(json);

  @JsonKey(name: 'OrderItemId')
  final String? orderItemId;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'RowsRolledUp')
  final bool? rowsRolledUp;
  @JsonKey(name: 'RolledUpIds')
  final String? rolledUpIds;
  @JsonKey(name: 'OrderType')
  final String? orderType;
  @JsonKey(name: 'RecType')
  final String? recType;
  @JsonKey(name: 'RecTypeDisplay')
  final String? recTypeDisplay;
  @JsonKey(name: 'RowNumber')
  final int? rowNumber;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'ICodeColor')
  final String? iCodeColor;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'DescriptionColor')
  final String? descriptionColor;
  @JsonKey(name: 'PickDate')
  final String? pickDate;
  @JsonKey(name: 'PickTime')
  final String? pickTime;
  @JsonKey(name: 'FromDate')
  final String? fromDate;
  @JsonKey(name: 'FromTime')
  final String? fromTime;
  @JsonKey(name: 'ToDate')
  final String? toDate;
  @JsonKey(name: 'ToTime')
  final String? toTime;
  @JsonKey(name: 'BillablePeriods')
  final double? billablePeriods;
  @JsonKey(name: 'QuantityOrdered')
  final double? quantityOrdered;
  @JsonKey(name: 'QuantityColor')
  final String? quantityColor;
  @JsonKey(name: 'SubQuantity')
  final double? subQuantity;
  @JsonKey(name: 'SubQuantityColor')
  final String? subQuantityColor;
  @JsonKey(name: 'ConsignQuantity')
  final int? consignQuantity;
  @JsonKey(name: 'ReservedItemQuantity')
  final int? reservedItemQuantity;
  @JsonKey(name: 'AvailableQuantity')
  final double? availableQuantity;
  @JsonKey(name: 'AvailabilityState')
  final String? availabilityState;
  @JsonKey(name: 'AvailableAllWarehousesQuantity')
  final double? availableAllWarehousesQuantity;
  @JsonKey(name: 'ConflictDate')
  final String? conflictDate;
  @JsonKey(name: 'ConflictDateAllWarehouses')
  final String? conflictDateAllWarehouses;
  @JsonKey(name: 'ConflictDateConsignment')
  final String? conflictDateConsignment;
  @JsonKey(name: 'UnitId')
  final String? unitId;
  @JsonKey(name: 'Unit')
  final String? unit;
  @JsonKey(name: 'UnitType')
  final String? unitType;
  @JsonKey(name: 'UnitCost')
  final double? unitCost;
  @JsonKey(name: 'MarginPercent')
  final double? marginPercent;
  @JsonKey(name: 'MarkupPercent')
  final double? markupPercent;
  @JsonKey(name: 'PremiumPercent')
  final double? premiumPercent;
  @JsonKey(name: 'CrewContactId')
  final String? crewContactId;
  @JsonKey(name: 'CrewName')
  final String? crewName;
  @JsonKey(name: 'Hours')
  final double? hours;
  @JsonKey(name: 'HoursOvertime')
  final double? hoursOvertime;
  @JsonKey(name: 'HoursDoubletime')
  final double? hoursDoubletime;
  @JsonKey(name: 'Price')
  final double? price;
  @JsonKey(name: 'Price2')
  final double? price2;
  @JsonKey(name: 'Price3')
  final double? price3;
  @JsonKey(name: 'Price4')
  final double? price4;
  @JsonKey(name: 'Price5')
  final double? price5;
  @JsonKey(name: 'DaysPerWeek')
  final double? daysPerWeek;
  @JsonKey(name: 'DiscountPercent')
  final double? discountPercent;
  @JsonKey(name: 'DiscountPercentDisplay')
  final double? discountPercentDisplay;
  @JsonKey(name: 'UnitExtendedNoDiscount')
  final double? unitExtendedNoDiscount;
  @JsonKey(name: 'UnitDiscountAmount')
  final double? unitDiscountAmount;
  @JsonKey(name: 'UnitExtended')
  final double? unitExtended;
  @JsonKey(name: 'WeeklyExtendedNoDiscount')
  final double? weeklyExtendedNoDiscount;
  @JsonKey(name: 'WeeklyDiscountAmount')
  final double? weeklyDiscountAmount;
  @JsonKey(name: 'WeeklyExtended')
  final double? weeklyExtended;
  @JsonKey(name: 'WeeklyCostExtended')
  final double? weeklyCostExtended;
  @JsonKey(name: 'WeeklyTax')
  final double? weeklyTax;
  @JsonKey(name: 'WeeklyTax1')
  final double? weeklyTax1;
  @JsonKey(name: 'WeeklyTax2')
  final double? weeklyTax2;
  @JsonKey(name: 'WeeklyTotal')
  final double? weeklyTotal;
  @JsonKey(name: 'Week2Extended')
  final double? week2Extended;
  @JsonKey(name: 'Week3Extended')
  final double? week3Extended;
  @JsonKey(name: 'Weeks1Through3Extended')
  final double? weeks1Through3Extended;
  @JsonKey(name: 'Weeks4PlusExtended')
  final double? weeks4PlusExtended;
  @JsonKey(name: 'Week4Extended')
  final double? week4Extended;
  @JsonKey(name: 'AverageWeekly')
  final double? averageWeekly;
  @JsonKey(name: 'AverageWeeklyExtended')
  final double? averageWeeklyExtended;
  @JsonKey(name: 'AverageWeeklyExtendedNoDiscount')
  final double? averageWeeklyExtendedNoDiscount;
  @JsonKey(name: 'AverageWeeklyDiscountAmount')
  final double? averageWeeklyDiscountAmount;
  @JsonKey(name: 'AverageWeeklyTax')
  final double? averageWeeklyTax;
  @JsonKey(name: 'AverageWeeklyTax1')
  final double? averageWeeklyTax1;
  @JsonKey(name: 'AverageWeeklyTax2')
  final double? averageWeeklyTax2;
  @JsonKey(name: 'AverageWeeklyTotal')
  final double? averageWeeklyTotal;
  @JsonKey(name: 'Episodes')
  final int? episodes;
  @JsonKey(name: 'MonthlyExtendedNoDiscount')
  final double? monthlyExtendedNoDiscount;
  @JsonKey(name: 'MonthlyDiscountAmount')
  final double? monthlyDiscountAmount;
  @JsonKey(name: 'MonthlyExtended')
  final double? monthlyExtended;
  @JsonKey(name: 'MonthlyCostExtended')
  final double? monthlyCostExtended;
  @JsonKey(name: 'MonthlyTax')
  final double? monthlyTax;
  @JsonKey(name: 'MonthlyTax1')
  final double? monthlyTax1;
  @JsonKey(name: 'MonthlyTax2')
  final double? monthlyTax2;
  @JsonKey(name: 'MonthlyTotal')
  final double? monthlyTotal;
  @JsonKey(name: 'PeriodExtendedNoDiscount')
  final double? periodExtendedNoDiscount;
  @JsonKey(name: 'PeriodCostExtended')
  final double? periodCostExtended;
  @JsonKey(name: 'PeriodDiscountAmount')
  final double? periodDiscountAmount;
  @JsonKey(name: 'PeriodExtended')
  final double? periodExtended;
  @JsonKey(name: 'PeriodTax')
  final double? periodTax;
  @JsonKey(name: 'PeriodTax1')
  final double? periodTax1;
  @JsonKey(name: 'PeriodTax2')
  final double? periodTax2;
  @JsonKey(name: 'PeriodTotal')
  final double? periodTotal;
  @JsonKey(name: 'PeriodVarianceExtended')
  final double? periodVarianceExtended;
  @JsonKey(name: 'VariancePercent')
  final double? variancePercent;
  @JsonKey(name: 'MinimumDaysPerWeek')
  final double? minimumDaysPerWeek;
  @JsonKey(name: 'Bold')
  final bool? bold;
  @JsonKey(name: 'Locked')
  final bool? locked;
  @JsonKey(name: 'Taxable')
  final bool? taxable;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'ReturnToWarehouseId')
  final String? returnToWarehouseId;
  @JsonKey(name: 'ReturnToWarehouseCode')
  final String? returnToWarehouseCode;
  @JsonKey(name: 'Notes')
  final String? notes;
  @JsonKey(name: 'ItemOrder')
  final String? itemOrder;
  @JsonKey(name: 'ParentId')
  final String? parentId;
  @JsonKey(name: 'NestedOrderItemId')
  final String? nestedOrderItemId;
  @JsonKey(name: 'ItemClass')
  final String? itemClass;
  @JsonKey(name: 'InventoryClass')
  final String? inventoryClass;
  @JsonKey(name: 'RetiredReasonId')
  final String? retiredReasonId;
  @JsonKey(name: 'RetiredReason')
  final String? retiredReason;
  @JsonKey(name: 'ItemId')
  final String? itemId;
  @JsonKey(name: 'BarCode')
  final String? barCode;
  @JsonKey(name: 'SerialNumber')
  final String? serialNumber;
  @JsonKey(name: 'ManufacturerPartNumber')
  final String? manufacturerPartNumber;
  @JsonKey(name: 'PoSubOrderId')
  final String? poSubOrderId;
  @JsonKey(name: 'PoSubOrderItemId')
  final String? poSubOrderItemId;
  @JsonKey(name: 'PoSubOrderNumber')
  final String? poSubOrderNumber;
  @JsonKey(name: 'LossAndDamageOrderId')
  final String? lossAndDamageOrderId;
  @JsonKey(name: 'LossAndDamageOrderItemId')
  final String? lossAndDamageOrderItemId;
  @JsonKey(name: 'LossAndDamageOrderNumber')
  final String? lossAndDamageOrderNumber;
  @JsonKey(name: 'ModifiedAtStaging')
  final bool? modifiedAtStaging;
  @JsonKey(name: 'Mute')
  final bool? mute;
  @JsonKey(name: 'AvailabilityByHour')
  final bool? availabilityByHour;
  @JsonKey(name: 'PrintNoteOnQuote')
  final bool? printNoteOnQuote;
  @JsonKey(name: 'PrintNoteOnOrder')
  final bool? printNoteOnOrder;
  @JsonKey(name: 'PrintNoteOnPickList')
  final bool? printNoteOnPickList;
  @JsonKey(name: 'PrintNoteOnOutContract')
  final bool? printNoteOnOutContract;
  @JsonKey(name: 'PrintNoteOnInContract')
  final bool? printNoteOnInContract;
  @JsonKey(name: 'PrintNoteOnReturnList')
  final bool? printNoteOnReturnList;
  @JsonKey(name: 'PrintNoteOnInvoice')
  final bool? printNoteOnInvoice;
  @JsonKey(name: 'PrintNoteOnPurchaseOrder')
  final bool? printNoteOnPurchaseOrder;
  @JsonKey(name: 'PrintNoteOnReceiveContract')
  final bool? printNoteOnReceiveContract;
  @JsonKey(name: 'PrintNoteOnReturnContract')
  final bool? printNoteOnReturnContract;
  @JsonKey(name: 'PrintNoteOnVendorReceiveList')
  final bool? printNoteOnVendorReceiveList;
  @JsonKey(name: 'PrintNoteOnVendorReturnList')
  final bool? printNoteOnVendorReturnList;
  @JsonKey(name: 'DefaultHourlyRate')
  final double? defaultHourlyRate;
  @JsonKey(name: 'DefaultDailyRate')
  final double? defaultDailyRate;
  @JsonKey(name: 'DefaultWeeklyRate')
  final double? defaultWeeklyRate;
  @JsonKey(name: 'DefaultMonthlyRate')
  final double? defaultMonthlyRate;
  @JsonKey(name: 'NestingLevel')
  final int? nestingLevel;
  @JsonKey(name: 'RepairId')
  final String? repairId;
  @JsonKey(name: 'RepairNumber')
  final String? repairNumber;
  @JsonKey(name: 'AccessoryRatio')
  final double? accessoryRatio;
  @JsonKey(name: 'IsOption')
  final bool? isOption;
  @JsonKey(name: 'OptionColor')
  final String? optionColor;
  @JsonKey(name: 'CurrencySymbol')
  final String? currencySymbol;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsOrderItemOrderItemFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsOrderItemOrderItemToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsOrderItemOrderItemToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsOrderItemOrderItem &&
            (identical(other.orderItemId, orderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.orderItemId, orderItemId)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.rowsRolledUp, rowsRolledUp) ||
                const DeepCollectionEquality()
                    .equals(other.rowsRolledUp, rowsRolledUp)) &&
            (identical(other.rolledUpIds, rolledUpIds) ||
                const DeepCollectionEquality()
                    .equals(other.rolledUpIds, rolledUpIds)) &&
            (identical(other.orderType, orderType) ||
                const DeepCollectionEquality()
                    .equals(other.orderType, orderType)) &&
            (identical(other.recType, recType) ||
                const DeepCollectionEquality()
                    .equals(other.recType, recType)) &&
            (identical(other.recTypeDisplay, recTypeDisplay) ||
                const DeepCollectionEquality()
                    .equals(other.recTypeDisplay, recTypeDisplay)) &&
            (identical(other.rowNumber, rowNumber) ||
                const DeepCollectionEquality()
                    .equals(other.rowNumber, rowNumber)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.iCodeColor, iCodeColor) ||
                const DeepCollectionEquality()
                    .equals(other.iCodeColor, iCodeColor)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.descriptionColor, descriptionColor) ||
                const DeepCollectionEquality()
                    .equals(other.descriptionColor, descriptionColor)) &&
            (identical(other.pickDate, pickDate) ||
                const DeepCollectionEquality()
                    .equals(other.pickDate, pickDate)) &&
            (identical(other.pickTime, pickTime) ||
                const DeepCollectionEquality()
                    .equals(other.pickTime, pickTime)) &&
            (identical(other.fromDate, fromDate) ||
                const DeepCollectionEquality()
                    .equals(other.fromDate, fromDate)) &&
            (identical(other.fromTime, fromTime) ||
                const DeepCollectionEquality()
                    .equals(other.fromTime, fromTime)) &&
            (identical(other.toDate, toDate) ||
                const DeepCollectionEquality().equals(other.toDate, toDate)) &&
            (identical(other.toTime, toTime) ||
                const DeepCollectionEquality().equals(other.toTime, toTime)) &&
            (identical(other.billablePeriods, billablePeriods) ||
                const DeepCollectionEquality()
                    .equals(other.billablePeriods, billablePeriods)) &&
            (identical(other.quantityOrdered, quantityOrdered) ||
                const DeepCollectionEquality()
                    .equals(other.quantityOrdered, quantityOrdered)) &&
            (identical(other.quantityColor, quantityColor) ||
                const DeepCollectionEquality()
                    .equals(other.quantityColor, quantityColor)) &&
            (identical(other.subQuantity, subQuantity) ||
                const DeepCollectionEquality()
                    .equals(other.subQuantity, subQuantity)) &&
            (identical(other.subQuantityColor, subQuantityColor) || const DeepCollectionEquality().equals(other.subQuantityColor, subQuantityColor)) &&
            (identical(other.consignQuantity, consignQuantity) || const DeepCollectionEquality().equals(other.consignQuantity, consignQuantity)) &&
            (identical(other.reservedItemQuantity, reservedItemQuantity) || const DeepCollectionEquality().equals(other.reservedItemQuantity, reservedItemQuantity)) &&
            (identical(other.availableQuantity, availableQuantity) || const DeepCollectionEquality().equals(other.availableQuantity, availableQuantity)) &&
            (identical(other.availabilityState, availabilityState) || const DeepCollectionEquality().equals(other.availabilityState, availabilityState)) &&
            (identical(other.availableAllWarehousesQuantity, availableAllWarehousesQuantity) || const DeepCollectionEquality().equals(other.availableAllWarehousesQuantity, availableAllWarehousesQuantity)) &&
            (identical(other.conflictDate, conflictDate) || const DeepCollectionEquality().equals(other.conflictDate, conflictDate)) &&
            (identical(other.conflictDateAllWarehouses, conflictDateAllWarehouses) || const DeepCollectionEquality().equals(other.conflictDateAllWarehouses, conflictDateAllWarehouses)) &&
            (identical(other.conflictDateConsignment, conflictDateConsignment) || const DeepCollectionEquality().equals(other.conflictDateConsignment, conflictDateConsignment)) &&
            (identical(other.unitId, unitId) || const DeepCollectionEquality().equals(other.unitId, unitId)) &&
            (identical(other.unit, unit) || const DeepCollectionEquality().equals(other.unit, unit)) &&
            (identical(other.unitType, unitType) || const DeepCollectionEquality().equals(other.unitType, unitType)) &&
            (identical(other.unitCost, unitCost) || const DeepCollectionEquality().equals(other.unitCost, unitCost)) &&
            (identical(other.marginPercent, marginPercent) || const DeepCollectionEquality().equals(other.marginPercent, marginPercent)) &&
            (identical(other.markupPercent, markupPercent) || const DeepCollectionEquality().equals(other.markupPercent, markupPercent)) &&
            (identical(other.premiumPercent, premiumPercent) || const DeepCollectionEquality().equals(other.premiumPercent, premiumPercent)) &&
            (identical(other.crewContactId, crewContactId) || const DeepCollectionEquality().equals(other.crewContactId, crewContactId)) &&
            (identical(other.crewName, crewName) || const DeepCollectionEquality().equals(other.crewName, crewName)) &&
            (identical(other.hours, hours) || const DeepCollectionEquality().equals(other.hours, hours)) &&
            (identical(other.hoursOvertime, hoursOvertime) || const DeepCollectionEquality().equals(other.hoursOvertime, hoursOvertime)) &&
            (identical(other.hoursDoubletime, hoursDoubletime) || const DeepCollectionEquality().equals(other.hoursDoubletime, hoursDoubletime)) &&
            (identical(other.price, price) || const DeepCollectionEquality().equals(other.price, price)) &&
            (identical(other.price2, price2) || const DeepCollectionEquality().equals(other.price2, price2)) &&
            (identical(other.price3, price3) || const DeepCollectionEquality().equals(other.price3, price3)) &&
            (identical(other.price4, price4) || const DeepCollectionEquality().equals(other.price4, price4)) &&
            (identical(other.price5, price5) || const DeepCollectionEquality().equals(other.price5, price5)) &&
            (identical(other.daysPerWeek, daysPerWeek) || const DeepCollectionEquality().equals(other.daysPerWeek, daysPerWeek)) &&
            (identical(other.discountPercent, discountPercent) || const DeepCollectionEquality().equals(other.discountPercent, discountPercent)) &&
            (identical(other.discountPercentDisplay, discountPercentDisplay) || const DeepCollectionEquality().equals(other.discountPercentDisplay, discountPercentDisplay)) &&
            (identical(other.unitExtendedNoDiscount, unitExtendedNoDiscount) || const DeepCollectionEquality().equals(other.unitExtendedNoDiscount, unitExtendedNoDiscount)) &&
            (identical(other.unitDiscountAmount, unitDiscountAmount) || const DeepCollectionEquality().equals(other.unitDiscountAmount, unitDiscountAmount)) &&
            (identical(other.unitExtended, unitExtended) || const DeepCollectionEquality().equals(other.unitExtended, unitExtended)) &&
            (identical(other.weeklyExtendedNoDiscount, weeklyExtendedNoDiscount) || const DeepCollectionEquality().equals(other.weeklyExtendedNoDiscount, weeklyExtendedNoDiscount)) &&
            (identical(other.weeklyDiscountAmount, weeklyDiscountAmount) || const DeepCollectionEquality().equals(other.weeklyDiscountAmount, weeklyDiscountAmount)) &&
            (identical(other.weeklyExtended, weeklyExtended) || const DeepCollectionEquality().equals(other.weeklyExtended, weeklyExtended)) &&
            (identical(other.weeklyCostExtended, weeklyCostExtended) || const DeepCollectionEquality().equals(other.weeklyCostExtended, weeklyCostExtended)) &&
            (identical(other.weeklyTax, weeklyTax) || const DeepCollectionEquality().equals(other.weeklyTax, weeklyTax)) &&
            (identical(other.weeklyTax1, weeklyTax1) || const DeepCollectionEquality().equals(other.weeklyTax1, weeklyTax1)) &&
            (identical(other.weeklyTax2, weeklyTax2) || const DeepCollectionEquality().equals(other.weeklyTax2, weeklyTax2)) &&
            (identical(other.weeklyTotal, weeklyTotal) || const DeepCollectionEquality().equals(other.weeklyTotal, weeklyTotal)) &&
            (identical(other.week2Extended, week2Extended) || const DeepCollectionEquality().equals(other.week2Extended, week2Extended)) &&
            (identical(other.week3Extended, week3Extended) || const DeepCollectionEquality().equals(other.week3Extended, week3Extended)) &&
            (identical(other.weeks1Through3Extended, weeks1Through3Extended) || const DeepCollectionEquality().equals(other.weeks1Through3Extended, weeks1Through3Extended)) &&
            (identical(other.weeks4PlusExtended, weeks4PlusExtended) || const DeepCollectionEquality().equals(other.weeks4PlusExtended, weeks4PlusExtended)) &&
            (identical(other.week4Extended, week4Extended) || const DeepCollectionEquality().equals(other.week4Extended, week4Extended)) &&
            (identical(other.averageWeekly, averageWeekly) || const DeepCollectionEquality().equals(other.averageWeekly, averageWeekly)) &&
            (identical(other.averageWeeklyExtended, averageWeeklyExtended) || const DeepCollectionEquality().equals(other.averageWeeklyExtended, averageWeeklyExtended)) &&
            (identical(other.averageWeeklyExtendedNoDiscount, averageWeeklyExtendedNoDiscount) || const DeepCollectionEquality().equals(other.averageWeeklyExtendedNoDiscount, averageWeeklyExtendedNoDiscount)) &&
            (identical(other.averageWeeklyDiscountAmount, averageWeeklyDiscountAmount) || const DeepCollectionEquality().equals(other.averageWeeklyDiscountAmount, averageWeeklyDiscountAmount)) &&
            (identical(other.averageWeeklyTax, averageWeeklyTax) || const DeepCollectionEquality().equals(other.averageWeeklyTax, averageWeeklyTax)) &&
            (identical(other.averageWeeklyTax1, averageWeeklyTax1) || const DeepCollectionEquality().equals(other.averageWeeklyTax1, averageWeeklyTax1)) &&
            (identical(other.averageWeeklyTax2, averageWeeklyTax2) || const DeepCollectionEquality().equals(other.averageWeeklyTax2, averageWeeklyTax2)) &&
            (identical(other.averageWeeklyTotal, averageWeeklyTotal) || const DeepCollectionEquality().equals(other.averageWeeklyTotal, averageWeeklyTotal)) &&
            (identical(other.episodes, episodes) || const DeepCollectionEquality().equals(other.episodes, episodes)) &&
            (identical(other.monthlyExtendedNoDiscount, monthlyExtendedNoDiscount) || const DeepCollectionEquality().equals(other.monthlyExtendedNoDiscount, monthlyExtendedNoDiscount)) &&
            (identical(other.monthlyDiscountAmount, monthlyDiscountAmount) || const DeepCollectionEquality().equals(other.monthlyDiscountAmount, monthlyDiscountAmount)) &&
            (identical(other.monthlyExtended, monthlyExtended) || const DeepCollectionEquality().equals(other.monthlyExtended, monthlyExtended)) &&
            (identical(other.monthlyCostExtended, monthlyCostExtended) || const DeepCollectionEquality().equals(other.monthlyCostExtended, monthlyCostExtended)) &&
            (identical(other.monthlyTax, monthlyTax) || const DeepCollectionEquality().equals(other.monthlyTax, monthlyTax)) &&
            (identical(other.monthlyTax1, monthlyTax1) || const DeepCollectionEquality().equals(other.monthlyTax1, monthlyTax1)) &&
            (identical(other.monthlyTax2, monthlyTax2) || const DeepCollectionEquality().equals(other.monthlyTax2, monthlyTax2)) &&
            (identical(other.monthlyTotal, monthlyTotal) || const DeepCollectionEquality().equals(other.monthlyTotal, monthlyTotal)) &&
            (identical(other.periodExtendedNoDiscount, periodExtendedNoDiscount) || const DeepCollectionEquality().equals(other.periodExtendedNoDiscount, periodExtendedNoDiscount)) &&
            (identical(other.periodCostExtended, periodCostExtended) || const DeepCollectionEquality().equals(other.periodCostExtended, periodCostExtended)) &&
            (identical(other.periodDiscountAmount, periodDiscountAmount) || const DeepCollectionEquality().equals(other.periodDiscountAmount, periodDiscountAmount)) &&
            (identical(other.periodExtended, periodExtended) || const DeepCollectionEquality().equals(other.periodExtended, periodExtended)) &&
            (identical(other.periodTax, periodTax) || const DeepCollectionEquality().equals(other.periodTax, periodTax)) &&
            (identical(other.periodTax1, periodTax1) || const DeepCollectionEquality().equals(other.periodTax1, periodTax1)) &&
            (identical(other.periodTax2, periodTax2) || const DeepCollectionEquality().equals(other.periodTax2, periodTax2)) &&
            (identical(other.periodTotal, periodTotal) || const DeepCollectionEquality().equals(other.periodTotal, periodTotal)) &&
            (identical(other.periodVarianceExtended, periodVarianceExtended) || const DeepCollectionEquality().equals(other.periodVarianceExtended, periodVarianceExtended)) &&
            (identical(other.variancePercent, variancePercent) || const DeepCollectionEquality().equals(other.variancePercent, variancePercent)) &&
            (identical(other.minimumDaysPerWeek, minimumDaysPerWeek) || const DeepCollectionEquality().equals(other.minimumDaysPerWeek, minimumDaysPerWeek)) &&
            (identical(other.bold, bold) || const DeepCollectionEquality().equals(other.bold, bold)) &&
            (identical(other.locked, locked) || const DeepCollectionEquality().equals(other.locked, locked)) &&
            (identical(other.taxable, taxable) || const DeepCollectionEquality().equals(other.taxable, taxable)) &&
            (identical(other.warehouseId, warehouseId) || const DeepCollectionEquality().equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouseCode, warehouseCode) || const DeepCollectionEquality().equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.returnToWarehouseId, returnToWarehouseId) || const DeepCollectionEquality().equals(other.returnToWarehouseId, returnToWarehouseId)) &&
            (identical(other.returnToWarehouseCode, returnToWarehouseCode) || const DeepCollectionEquality().equals(other.returnToWarehouseCode, returnToWarehouseCode)) &&
            (identical(other.notes, notes) || const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.itemOrder, itemOrder) || const DeepCollectionEquality().equals(other.itemOrder, itemOrder)) &&
            (identical(other.parentId, parentId) || const DeepCollectionEquality().equals(other.parentId, parentId)) &&
            (identical(other.nestedOrderItemId, nestedOrderItemId) || const DeepCollectionEquality().equals(other.nestedOrderItemId, nestedOrderItemId)) &&
            (identical(other.itemClass, itemClass) || const DeepCollectionEquality().equals(other.itemClass, itemClass)) &&
            (identical(other.inventoryClass, inventoryClass) || const DeepCollectionEquality().equals(other.inventoryClass, inventoryClass)) &&
            (identical(other.retiredReasonId, retiredReasonId) || const DeepCollectionEquality().equals(other.retiredReasonId, retiredReasonId)) &&
            (identical(other.retiredReason, retiredReason) || const DeepCollectionEquality().equals(other.retiredReason, retiredReason)) &&
            (identical(other.itemId, itemId) || const DeepCollectionEquality().equals(other.itemId, itemId)) &&
            (identical(other.barCode, barCode) || const DeepCollectionEquality().equals(other.barCode, barCode)) &&
            (identical(other.serialNumber, serialNumber) || const DeepCollectionEquality().equals(other.serialNumber, serialNumber)) &&
            (identical(other.manufacturerPartNumber, manufacturerPartNumber) || const DeepCollectionEquality().equals(other.manufacturerPartNumber, manufacturerPartNumber)) &&
            (identical(other.poSubOrderId, poSubOrderId) || const DeepCollectionEquality().equals(other.poSubOrderId, poSubOrderId)) &&
            (identical(other.poSubOrderItemId, poSubOrderItemId) || const DeepCollectionEquality().equals(other.poSubOrderItemId, poSubOrderItemId)) &&
            (identical(other.poSubOrderNumber, poSubOrderNumber) || const DeepCollectionEquality().equals(other.poSubOrderNumber, poSubOrderNumber)) &&
            (identical(other.lossAndDamageOrderId, lossAndDamageOrderId) || const DeepCollectionEquality().equals(other.lossAndDamageOrderId, lossAndDamageOrderId)) &&
            (identical(other.lossAndDamageOrderItemId, lossAndDamageOrderItemId) || const DeepCollectionEquality().equals(other.lossAndDamageOrderItemId, lossAndDamageOrderItemId)) &&
            (identical(other.lossAndDamageOrderNumber, lossAndDamageOrderNumber) || const DeepCollectionEquality().equals(other.lossAndDamageOrderNumber, lossAndDamageOrderNumber)) &&
            (identical(other.modifiedAtStaging, modifiedAtStaging) || const DeepCollectionEquality().equals(other.modifiedAtStaging, modifiedAtStaging)) &&
            (identical(other.mute, mute) || const DeepCollectionEquality().equals(other.mute, mute)) &&
            (identical(other.availabilityByHour, availabilityByHour) || const DeepCollectionEquality().equals(other.availabilityByHour, availabilityByHour)) &&
            (identical(other.printNoteOnQuote, printNoteOnQuote) || const DeepCollectionEquality().equals(other.printNoteOnQuote, printNoteOnQuote)) &&
            (identical(other.printNoteOnOrder, printNoteOnOrder) || const DeepCollectionEquality().equals(other.printNoteOnOrder, printNoteOnOrder)) &&
            (identical(other.printNoteOnPickList, printNoteOnPickList) || const DeepCollectionEquality().equals(other.printNoteOnPickList, printNoteOnPickList)) &&
            (identical(other.printNoteOnOutContract, printNoteOnOutContract) || const DeepCollectionEquality().equals(other.printNoteOnOutContract, printNoteOnOutContract)) &&
            (identical(other.printNoteOnInContract, printNoteOnInContract) || const DeepCollectionEquality().equals(other.printNoteOnInContract, printNoteOnInContract)) &&
            (identical(other.printNoteOnReturnList, printNoteOnReturnList) || const DeepCollectionEquality().equals(other.printNoteOnReturnList, printNoteOnReturnList)) &&
            (identical(other.printNoteOnInvoice, printNoteOnInvoice) || const DeepCollectionEquality().equals(other.printNoteOnInvoice, printNoteOnInvoice)) &&
            (identical(other.printNoteOnPurchaseOrder, printNoteOnPurchaseOrder) || const DeepCollectionEquality().equals(other.printNoteOnPurchaseOrder, printNoteOnPurchaseOrder)) &&
            (identical(other.printNoteOnReceiveContract, printNoteOnReceiveContract) || const DeepCollectionEquality().equals(other.printNoteOnReceiveContract, printNoteOnReceiveContract)) &&
            (identical(other.printNoteOnReturnContract, printNoteOnReturnContract) || const DeepCollectionEquality().equals(other.printNoteOnReturnContract, printNoteOnReturnContract)) &&
            (identical(other.printNoteOnVendorReceiveList, printNoteOnVendorReceiveList) || const DeepCollectionEquality().equals(other.printNoteOnVendorReceiveList, printNoteOnVendorReceiveList)) &&
            (identical(other.printNoteOnVendorReturnList, printNoteOnVendorReturnList) || const DeepCollectionEquality().equals(other.printNoteOnVendorReturnList, printNoteOnVendorReturnList)) &&
            (identical(other.defaultHourlyRate, defaultHourlyRate) || const DeepCollectionEquality().equals(other.defaultHourlyRate, defaultHourlyRate)) &&
            (identical(other.defaultDailyRate, defaultDailyRate) || const DeepCollectionEquality().equals(other.defaultDailyRate, defaultDailyRate)) &&
            (identical(other.defaultWeeklyRate, defaultWeeklyRate) || const DeepCollectionEquality().equals(other.defaultWeeklyRate, defaultWeeklyRate)) &&
            (identical(other.defaultMonthlyRate, defaultMonthlyRate) || const DeepCollectionEquality().equals(other.defaultMonthlyRate, defaultMonthlyRate)) &&
            (identical(other.nestingLevel, nestingLevel) || const DeepCollectionEquality().equals(other.nestingLevel, nestingLevel)) &&
            (identical(other.repairId, repairId) || const DeepCollectionEquality().equals(other.repairId, repairId)) &&
            (identical(other.repairNumber, repairNumber) || const DeepCollectionEquality().equals(other.repairNumber, repairNumber)) &&
            (identical(other.accessoryRatio, accessoryRatio) || const DeepCollectionEquality().equals(other.accessoryRatio, accessoryRatio)) &&
            (identical(other.isOption, isOption) || const DeepCollectionEquality().equals(other.isOption, isOption)) &&
            (identical(other.optionColor, optionColor) || const DeepCollectionEquality().equals(other.optionColor, optionColor)) &&
            (identical(other.currencySymbol, currencySymbol) || const DeepCollectionEquality().equals(other.currencySymbol, currencySymbol)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsOrderItemOrderItemExtension
    on WebApiModulesHomeControlsOrderItemOrderItem {
  WebApiModulesHomeControlsOrderItemOrderItem copyWith(
      {String? orderItemId,
      String? orderId,
      bool? rowsRolledUp,
      String? rolledUpIds,
      String? orderType,
      String? recType,
      String? recTypeDisplay,
      int? rowNumber,
      String? inventoryId,
      String? iCode,
      String? iCodeColor,
      String? description,
      String? descriptionColor,
      String? pickDate,
      String? pickTime,
      String? fromDate,
      String? fromTime,
      String? toDate,
      String? toTime,
      double? billablePeriods,
      double? quantityOrdered,
      String? quantityColor,
      double? subQuantity,
      String? subQuantityColor,
      int? consignQuantity,
      int? reservedItemQuantity,
      double? availableQuantity,
      String? availabilityState,
      double? availableAllWarehousesQuantity,
      String? conflictDate,
      String? conflictDateAllWarehouses,
      String? conflictDateConsignment,
      String? unitId,
      String? unit,
      String? unitType,
      double? unitCost,
      double? marginPercent,
      double? markupPercent,
      double? premiumPercent,
      String? crewContactId,
      String? crewName,
      double? hours,
      double? hoursOvertime,
      double? hoursDoubletime,
      double? price,
      double? price2,
      double? price3,
      double? price4,
      double? price5,
      double? daysPerWeek,
      double? discountPercent,
      double? discountPercentDisplay,
      double? unitExtendedNoDiscount,
      double? unitDiscountAmount,
      double? unitExtended,
      double? weeklyExtendedNoDiscount,
      double? weeklyDiscountAmount,
      double? weeklyExtended,
      double? weeklyCostExtended,
      double? weeklyTax,
      double? weeklyTax1,
      double? weeklyTax2,
      double? weeklyTotal,
      double? week2Extended,
      double? week3Extended,
      double? weeks1Through3Extended,
      double? weeks4PlusExtended,
      double? week4Extended,
      double? averageWeekly,
      double? averageWeeklyExtended,
      double? averageWeeklyExtendedNoDiscount,
      double? averageWeeklyDiscountAmount,
      double? averageWeeklyTax,
      double? averageWeeklyTax1,
      double? averageWeeklyTax2,
      double? averageWeeklyTotal,
      int? episodes,
      double? monthlyExtendedNoDiscount,
      double? monthlyDiscountAmount,
      double? monthlyExtended,
      double? monthlyCostExtended,
      double? monthlyTax,
      double? monthlyTax1,
      double? monthlyTax2,
      double? monthlyTotal,
      double? periodExtendedNoDiscount,
      double? periodCostExtended,
      double? periodDiscountAmount,
      double? periodExtended,
      double? periodTax,
      double? periodTax1,
      double? periodTax2,
      double? periodTotal,
      double? periodVarianceExtended,
      double? variancePercent,
      double? minimumDaysPerWeek,
      bool? bold,
      bool? locked,
      bool? taxable,
      String? warehouseId,
      String? warehouseCode,
      String? returnToWarehouseId,
      String? returnToWarehouseCode,
      String? notes,
      String? itemOrder,
      String? parentId,
      String? nestedOrderItemId,
      String? itemClass,
      String? inventoryClass,
      String? retiredReasonId,
      String? retiredReason,
      String? itemId,
      String? barCode,
      String? serialNumber,
      String? manufacturerPartNumber,
      String? poSubOrderId,
      String? poSubOrderItemId,
      String? poSubOrderNumber,
      String? lossAndDamageOrderId,
      String? lossAndDamageOrderItemId,
      String? lossAndDamageOrderNumber,
      bool? modifiedAtStaging,
      bool? mute,
      bool? availabilityByHour,
      bool? printNoteOnQuote,
      bool? printNoteOnOrder,
      bool? printNoteOnPickList,
      bool? printNoteOnOutContract,
      bool? printNoteOnInContract,
      bool? printNoteOnReturnList,
      bool? printNoteOnInvoice,
      bool? printNoteOnPurchaseOrder,
      bool? printNoteOnReceiveContract,
      bool? printNoteOnReturnContract,
      bool? printNoteOnVendorReceiveList,
      bool? printNoteOnVendorReturnList,
      double? defaultHourlyRate,
      double? defaultDailyRate,
      double? defaultWeeklyRate,
      double? defaultMonthlyRate,
      int? nestingLevel,
      String? repairId,
      String? repairNumber,
      double? accessoryRatio,
      bool? isOption,
      String? optionColor,
      String? currencySymbol,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsOrderItemOrderItem(
        orderItemId: orderItemId ?? this.orderItemId,
        orderId: orderId ?? this.orderId,
        rowsRolledUp: rowsRolledUp ?? this.rowsRolledUp,
        rolledUpIds: rolledUpIds ?? this.rolledUpIds,
        orderType: orderType ?? this.orderType,
        recType: recType ?? this.recType,
        recTypeDisplay: recTypeDisplay ?? this.recTypeDisplay,
        rowNumber: rowNumber ?? this.rowNumber,
        inventoryId: inventoryId ?? this.inventoryId,
        iCode: iCode ?? this.iCode,
        iCodeColor: iCodeColor ?? this.iCodeColor,
        description: description ?? this.description,
        descriptionColor: descriptionColor ?? this.descriptionColor,
        pickDate: pickDate ?? this.pickDate,
        pickTime: pickTime ?? this.pickTime,
        fromDate: fromDate ?? this.fromDate,
        fromTime: fromTime ?? this.fromTime,
        toDate: toDate ?? this.toDate,
        toTime: toTime ?? this.toTime,
        billablePeriods: billablePeriods ?? this.billablePeriods,
        quantityOrdered: quantityOrdered ?? this.quantityOrdered,
        quantityColor: quantityColor ?? this.quantityColor,
        subQuantity: subQuantity ?? this.subQuantity,
        subQuantityColor: subQuantityColor ?? this.subQuantityColor,
        consignQuantity: consignQuantity ?? this.consignQuantity,
        reservedItemQuantity: reservedItemQuantity ?? this.reservedItemQuantity,
        availableQuantity: availableQuantity ?? this.availableQuantity,
        availabilityState: availabilityState ?? this.availabilityState,
        availableAllWarehousesQuantity: availableAllWarehousesQuantity ??
            this.availableAllWarehousesQuantity,
        conflictDate: conflictDate ?? this.conflictDate,
        conflictDateAllWarehouses:
            conflictDateAllWarehouses ?? this.conflictDateAllWarehouses,
        conflictDateConsignment:
            conflictDateConsignment ?? this.conflictDateConsignment,
        unitId: unitId ?? this.unitId,
        unit: unit ?? this.unit,
        unitType: unitType ?? this.unitType,
        unitCost: unitCost ?? this.unitCost,
        marginPercent: marginPercent ?? this.marginPercent,
        markupPercent: markupPercent ?? this.markupPercent,
        premiumPercent: premiumPercent ?? this.premiumPercent,
        crewContactId: crewContactId ?? this.crewContactId,
        crewName: crewName ?? this.crewName,
        hours: hours ?? this.hours,
        hoursOvertime: hoursOvertime ?? this.hoursOvertime,
        hoursDoubletime: hoursDoubletime ?? this.hoursDoubletime,
        price: price ?? this.price,
        price2: price2 ?? this.price2,
        price3: price3 ?? this.price3,
        price4: price4 ?? this.price4,
        price5: price5 ?? this.price5,
        daysPerWeek: daysPerWeek ?? this.daysPerWeek,
        discountPercent: discountPercent ?? this.discountPercent,
        discountPercentDisplay:
            discountPercentDisplay ?? this.discountPercentDisplay,
        unitExtendedNoDiscount:
            unitExtendedNoDiscount ?? this.unitExtendedNoDiscount,
        unitDiscountAmount: unitDiscountAmount ?? this.unitDiscountAmount,
        unitExtended: unitExtended ?? this.unitExtended,
        weeklyExtendedNoDiscount:
            weeklyExtendedNoDiscount ?? this.weeklyExtendedNoDiscount,
        weeklyDiscountAmount: weeklyDiscountAmount ?? this.weeklyDiscountAmount,
        weeklyExtended: weeklyExtended ?? this.weeklyExtended,
        weeklyCostExtended: weeklyCostExtended ?? this.weeklyCostExtended,
        weeklyTax: weeklyTax ?? this.weeklyTax,
        weeklyTax1: weeklyTax1 ?? this.weeklyTax1,
        weeklyTax2: weeklyTax2 ?? this.weeklyTax2,
        weeklyTotal: weeklyTotal ?? this.weeklyTotal,
        week2Extended: week2Extended ?? this.week2Extended,
        week3Extended: week3Extended ?? this.week3Extended,
        weeks1Through3Extended:
            weeks1Through3Extended ?? this.weeks1Through3Extended,
        weeks4PlusExtended: weeks4PlusExtended ?? this.weeks4PlusExtended,
        week4Extended: week4Extended ?? this.week4Extended,
        averageWeekly: averageWeekly ?? this.averageWeekly,
        averageWeeklyExtended:
            averageWeeklyExtended ?? this.averageWeeklyExtended,
        averageWeeklyExtendedNoDiscount: averageWeeklyExtendedNoDiscount ??
            this.averageWeeklyExtendedNoDiscount,
        averageWeeklyDiscountAmount:
            averageWeeklyDiscountAmount ?? this.averageWeeklyDiscountAmount,
        averageWeeklyTax: averageWeeklyTax ?? this.averageWeeklyTax,
        averageWeeklyTax1: averageWeeklyTax1 ?? this.averageWeeklyTax1,
        averageWeeklyTax2: averageWeeklyTax2 ?? this.averageWeeklyTax2,
        averageWeeklyTotal: averageWeeklyTotal ?? this.averageWeeklyTotal,
        episodes: episodes ?? this.episodes,
        monthlyExtendedNoDiscount:
            monthlyExtendedNoDiscount ?? this.monthlyExtendedNoDiscount,
        monthlyDiscountAmount:
            monthlyDiscountAmount ?? this.monthlyDiscountAmount,
        monthlyExtended: monthlyExtended ?? this.monthlyExtended,
        monthlyCostExtended: monthlyCostExtended ?? this.monthlyCostExtended,
        monthlyTax: monthlyTax ?? this.monthlyTax,
        monthlyTax1: monthlyTax1 ?? this.monthlyTax1,
        monthlyTax2: monthlyTax2 ?? this.monthlyTax2,
        monthlyTotal: monthlyTotal ?? this.monthlyTotal,
        periodExtendedNoDiscount:
            periodExtendedNoDiscount ?? this.periodExtendedNoDiscount,
        periodCostExtended: periodCostExtended ?? this.periodCostExtended,
        periodDiscountAmount: periodDiscountAmount ?? this.periodDiscountAmount,
        periodExtended: periodExtended ?? this.periodExtended,
        periodTax: periodTax ?? this.periodTax,
        periodTax1: periodTax1 ?? this.periodTax1,
        periodTax2: periodTax2 ?? this.periodTax2,
        periodTotal: periodTotal ?? this.periodTotal,
        periodVarianceExtended:
            periodVarianceExtended ?? this.periodVarianceExtended,
        variancePercent: variancePercent ?? this.variancePercent,
        minimumDaysPerWeek: minimumDaysPerWeek ?? this.minimumDaysPerWeek,
        bold: bold ?? this.bold,
        locked: locked ?? this.locked,
        taxable: taxable ?? this.taxable,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        returnToWarehouseId: returnToWarehouseId ?? this.returnToWarehouseId,
        returnToWarehouseCode:
            returnToWarehouseCode ?? this.returnToWarehouseCode,
        notes: notes ?? this.notes,
        itemOrder: itemOrder ?? this.itemOrder,
        parentId: parentId ?? this.parentId,
        nestedOrderItemId: nestedOrderItemId ?? this.nestedOrderItemId,
        itemClass: itemClass ?? this.itemClass,
        inventoryClass: inventoryClass ?? this.inventoryClass,
        retiredReasonId: retiredReasonId ?? this.retiredReasonId,
        retiredReason: retiredReason ?? this.retiredReason,
        itemId: itemId ?? this.itemId,
        barCode: barCode ?? this.barCode,
        serialNumber: serialNumber ?? this.serialNumber,
        manufacturerPartNumber:
            manufacturerPartNumber ?? this.manufacturerPartNumber,
        poSubOrderId: poSubOrderId ?? this.poSubOrderId,
        poSubOrderItemId: poSubOrderItemId ?? this.poSubOrderItemId,
        poSubOrderNumber: poSubOrderNumber ?? this.poSubOrderNumber,
        lossAndDamageOrderId: lossAndDamageOrderId ?? this.lossAndDamageOrderId,
        lossAndDamageOrderItemId:
            lossAndDamageOrderItemId ?? this.lossAndDamageOrderItemId,
        lossAndDamageOrderNumber:
            lossAndDamageOrderNumber ?? this.lossAndDamageOrderNumber,
        modifiedAtStaging: modifiedAtStaging ?? this.modifiedAtStaging,
        mute: mute ?? this.mute,
        availabilityByHour: availabilityByHour ?? this.availabilityByHour,
        printNoteOnQuote: printNoteOnQuote ?? this.printNoteOnQuote,
        printNoteOnOrder: printNoteOnOrder ?? this.printNoteOnOrder,
        printNoteOnPickList: printNoteOnPickList ?? this.printNoteOnPickList,
        printNoteOnOutContract:
            printNoteOnOutContract ?? this.printNoteOnOutContract,
        printNoteOnInContract:
            printNoteOnInContract ?? this.printNoteOnInContract,
        printNoteOnReturnList:
            printNoteOnReturnList ?? this.printNoteOnReturnList,
        printNoteOnInvoice: printNoteOnInvoice ?? this.printNoteOnInvoice,
        printNoteOnPurchaseOrder:
            printNoteOnPurchaseOrder ?? this.printNoteOnPurchaseOrder,
        printNoteOnReceiveContract:
            printNoteOnReceiveContract ?? this.printNoteOnReceiveContract,
        printNoteOnReturnContract:
            printNoteOnReturnContract ?? this.printNoteOnReturnContract,
        printNoteOnVendorReceiveList:
            printNoteOnVendorReceiveList ?? this.printNoteOnVendorReceiveList,
        printNoteOnVendorReturnList:
            printNoteOnVendorReturnList ?? this.printNoteOnVendorReturnList,
        defaultHourlyRate: defaultHourlyRate ?? this.defaultHourlyRate,
        defaultDailyRate: defaultDailyRate ?? this.defaultDailyRate,
        defaultWeeklyRate: defaultWeeklyRate ?? this.defaultWeeklyRate,
        defaultMonthlyRate: defaultMonthlyRate ?? this.defaultMonthlyRate,
        nestingLevel: nestingLevel ?? this.nestingLevel,
        repairId: repairId ?? this.repairId,
        repairNumber: repairNumber ?? this.repairNumber,
        accessoryRatio: accessoryRatio ?? this.accessoryRatio,
        isOption: isOption ?? this.isOption,
        optionColor: optionColor ?? this.optionColor,
        currencySymbol: currencySymbol ?? this.currencySymbol,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsOrderItemSortOrderItemsRequest {
  WebApiModulesHomeControlsOrderItemSortOrderItemsRequest({
    this.startAtIndex,
    this.orderItemIds,
  });

  factory WebApiModulesHomeControlsOrderItemSortOrderItemsRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsOrderItemSortOrderItemsRequestFromJson(json);

  @JsonKey(name: 'StartAtIndex')
  final int? startAtIndex;
  @JsonKey(name: 'OrderItemIds', defaultValue: <String>[])
  final List<String>? orderItemIds;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsOrderItemSortOrderItemsRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsOrderItemSortOrderItemsRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsOrderItemSortOrderItemsRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsOrderItemSortOrderItemsRequest &&
            (identical(other.startAtIndex, startAtIndex) ||
                const DeepCollectionEquality()
                    .equals(other.startAtIndex, startAtIndex)) &&
            (identical(other.orderItemIds, orderItemIds) ||
                const DeepCollectionEquality()
                    .equals(other.orderItemIds, orderItemIds)));
  }
}

extension $WebApiModulesHomeControlsOrderItemSortOrderItemsRequestExtension
    on WebApiModulesHomeControlsOrderItemSortOrderItemsRequest {
  WebApiModulesHomeControlsOrderItemSortOrderItemsRequest copyWith(
      {int? startAtIndex, List<String>? orderItemIds}) {
    return WebApiModulesHomeControlsOrderItemSortOrderItemsRequest(
        startAtIndex: startAtIndex ?? this.startAtIndex,
        orderItemIds: orderItemIds ?? this.orderItemIds);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsOrderItemSplitOrderItemRequest {
  WebApiModulesHomeControlsOrderItemSplitOrderItemRequest({
    this.orderId,
    this.orderItemId,
    this.splitQuantity,
    this.splitEntirePackage,
    this.stagedOutOnly,
    this.outOnly,
    this.inOnly,
  });

  factory WebApiModulesHomeControlsOrderItemSplitOrderItemRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsOrderItemSplitOrderItemRequestFromJson(json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderItemId')
  final String? orderItemId;
  @JsonKey(name: 'SplitQuantity')
  final double? splitQuantity;
  @JsonKey(name: 'SplitEntirePackage')
  final bool? splitEntirePackage;
  @JsonKey(name: 'StagedOutOnly')
  final bool? stagedOutOnly;
  @JsonKey(name: 'OutOnly')
  final bool? outOnly;
  @JsonKey(name: 'InOnly')
  final bool? inOnly;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsOrderItemSplitOrderItemRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsOrderItemSplitOrderItemRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsOrderItemSplitOrderItemRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsOrderItemSplitOrderItemRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderItemId, orderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.orderItemId, orderItemId)) &&
            (identical(other.splitQuantity, splitQuantity) ||
                const DeepCollectionEquality()
                    .equals(other.splitQuantity, splitQuantity)) &&
            (identical(other.splitEntirePackage, splitEntirePackage) ||
                const DeepCollectionEquality()
                    .equals(other.splitEntirePackage, splitEntirePackage)) &&
            (identical(other.stagedOutOnly, stagedOutOnly) ||
                const DeepCollectionEquality()
                    .equals(other.stagedOutOnly, stagedOutOnly)) &&
            (identical(other.outOnly, outOnly) ||
                const DeepCollectionEquality()
                    .equals(other.outOnly, outOnly)) &&
            (identical(other.inOnly, inOnly) ||
                const DeepCollectionEquality().equals(other.inOnly, inOnly)));
  }
}

extension $WebApiModulesHomeControlsOrderItemSplitOrderItemRequestExtension
    on WebApiModulesHomeControlsOrderItemSplitOrderItemRequest {
  WebApiModulesHomeControlsOrderItemSplitOrderItemRequest copyWith(
      {String? orderId,
      String? orderItemId,
      double? splitQuantity,
      bool? splitEntirePackage,
      bool? stagedOutOnly,
      bool? outOnly,
      bool? inOnly}) {
    return WebApiModulesHomeControlsOrderItemSplitOrderItemRequest(
        orderId: orderId ?? this.orderId,
        orderItemId: orderItemId ?? this.orderItemId,
        splitQuantity: splitQuantity ?? this.splitQuantity,
        splitEntirePackage: splitEntirePackage ?? this.splitEntirePackage,
        stagedOutOnly: stagedOutOnly ?? this.stagedOutOnly,
        outOnly: outOnly ?? this.outOnly,
        inOnly: inOnly ?? this.inOnly);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsOrderItemSplitOrderItemResponse {
  WebApiModulesHomeControlsOrderItemSplitOrderItemResponse({
    this.status,
    this.success,
    this.msg,
    this.orderItemId,
  });

  factory WebApiModulesHomeControlsOrderItemSplitOrderItemResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsOrderItemSplitOrderItemResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'OrderItemId')
  final String? orderItemId;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsOrderItemSplitOrderItemResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsOrderItemSplitOrderItemResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsOrderItemSplitOrderItemResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsOrderItemSplitOrderItemResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.orderItemId, orderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.orderItemId, orderItemId)));
  }
}

extension $WebApiModulesHomeControlsOrderItemSplitOrderItemResponseExtension
    on WebApiModulesHomeControlsOrderItemSplitOrderItemResponse {
  WebApiModulesHomeControlsOrderItemSplitOrderItemResponse copyWith(
      {int? status, bool? success, String? msg, String? orderItemId}) {
    return WebApiModulesHomeControlsOrderItemSplitOrderItemResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        orderItemId: orderItemId ?? this.orderItemId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsOrderNoteOrderNote {
  WebApiModulesHomeControlsOrderNoteOrderNote({
    this.orderNoteId,
    this.orderId,
    this.noteDate,
    this.userId,
    this.notesDescription,
    this.billing,
    this.printOnOrder,
    this.copyToInvoice,
    this.scheduleNote,
    this.scheduleNoteDate,
    this.pickList,
    this.userName,
    this.notes,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsOrderNoteOrderNote.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsOrderNoteOrderNoteFromJson(json);

  @JsonKey(name: 'OrderNoteId')
  final String? orderNoteId;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'NoteDate')
  final String? noteDate;
  @JsonKey(name: 'UserId')
  final String? userId;
  @JsonKey(name: 'NotesDescription')
  final String? notesDescription;
  @JsonKey(name: 'Billing')
  final bool? billing;
  @JsonKey(name: 'PrintOnOrder')
  final bool? printOnOrder;
  @JsonKey(name: 'CopyToInvoice')
  final bool? copyToInvoice;
  @JsonKey(name: 'ScheduleNote')
  final bool? scheduleNote;
  @JsonKey(name: 'ScheduleNoteDate')
  final String? scheduleNoteDate;
  @JsonKey(name: 'PickList')
  final bool? pickList;
  @JsonKey(name: 'UserName')
  final String? userName;
  @JsonKey(name: 'Notes')
  final String? notes;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsOrderNoteOrderNoteFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsOrderNoteOrderNoteToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsOrderNoteOrderNoteToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsOrderNoteOrderNote &&
            (identical(other.orderNoteId, orderNoteId) ||
                const DeepCollectionEquality()
                    .equals(other.orderNoteId, orderNoteId)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.noteDate, noteDate) ||
                const DeepCollectionEquality()
                    .equals(other.noteDate, noteDate)) &&
            (identical(other.userId, userId) ||
                const DeepCollectionEquality().equals(other.userId, userId)) &&
            (identical(other.notesDescription, notesDescription) ||
                const DeepCollectionEquality()
                    .equals(other.notesDescription, notesDescription)) &&
            (identical(other.billing, billing) ||
                const DeepCollectionEquality()
                    .equals(other.billing, billing)) &&
            (identical(other.printOnOrder, printOnOrder) ||
                const DeepCollectionEquality()
                    .equals(other.printOnOrder, printOnOrder)) &&
            (identical(other.copyToInvoice, copyToInvoice) ||
                const DeepCollectionEquality()
                    .equals(other.copyToInvoice, copyToInvoice)) &&
            (identical(other.scheduleNote, scheduleNote) ||
                const DeepCollectionEquality()
                    .equals(other.scheduleNote, scheduleNote)) &&
            (identical(other.scheduleNoteDate, scheduleNoteDate) ||
                const DeepCollectionEquality()
                    .equals(other.scheduleNoteDate, scheduleNoteDate)) &&
            (identical(other.pickList, pickList) ||
                const DeepCollectionEquality()
                    .equals(other.pickList, pickList)) &&
            (identical(other.userName, userName) ||
                const DeepCollectionEquality()
                    .equals(other.userName, userName)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsOrderNoteOrderNoteExtension
    on WebApiModulesHomeControlsOrderNoteOrderNote {
  WebApiModulesHomeControlsOrderNoteOrderNote copyWith(
      {String? orderNoteId,
      String? orderId,
      String? noteDate,
      String? userId,
      String? notesDescription,
      bool? billing,
      bool? printOnOrder,
      bool? copyToInvoice,
      bool? scheduleNote,
      String? scheduleNoteDate,
      bool? pickList,
      String? userName,
      String? notes,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsOrderNoteOrderNote(
        orderNoteId: orderNoteId ?? this.orderNoteId,
        orderId: orderId ?? this.orderId,
        noteDate: noteDate ?? this.noteDate,
        userId: userId ?? this.userId,
        notesDescription: notesDescription ?? this.notesDescription,
        billing: billing ?? this.billing,
        printOnOrder: printOnOrder ?? this.printOnOrder,
        copyToInvoice: copyToInvoice ?? this.copyToInvoice,
        scheduleNote: scheduleNote ?? this.scheduleNote,
        scheduleNoteDate: scheduleNoteDate ?? this.scheduleNoteDate,
        pickList: pickList ?? this.pickList,
        userName: userName ?? this.userName,
        notes: notes ?? this.notes,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistory {
  WebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistory({
    this.id,
    this.internalchar,
    this.orderId,
    this.statusDateTime,
    this.status,
    this.userId,
    this.userFullName,
    this.functionName,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistory.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistoryFromJson(
          json);

  @JsonKey(name: 'Id')
  final int? id;
  @JsonKey(name: 'Internalchar')
  final String? internalchar;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'StatusDateTime')
  final String? statusDateTime;
  @JsonKey(name: 'Status')
  final String? status;
  @JsonKey(name: 'UserId')
  final String? userId;
  @JsonKey(name: 'UserFullName')
  final String? userFullName;
  @JsonKey(name: 'FunctionName')
  final String? functionName;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistoryFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistoryToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistoryToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistory &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.internalchar, internalchar) ||
                const DeepCollectionEquality()
                    .equals(other.internalchar, internalchar)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.statusDateTime, statusDateTime) ||
                const DeepCollectionEquality()
                    .equals(other.statusDateTime, statusDateTime)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.userId, userId) ||
                const DeepCollectionEquality().equals(other.userId, userId)) &&
            (identical(other.userFullName, userFullName) ||
                const DeepCollectionEquality()
                    .equals(other.userFullName, userFullName)) &&
            (identical(other.functionName, functionName) ||
                const DeepCollectionEquality()
                    .equals(other.functionName, functionName)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistoryExtension
    on WebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistory {
  WebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistory copyWith(
      {int? id,
      String? internalchar,
      String? orderId,
      String? statusDateTime,
      String? status,
      String? userId,
      String? userFullName,
      String? functionName,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsOrderStatusHistoryOrderStatusHistory(
        id: id ?? this.id,
        internalchar: internalchar ?? this.internalchar,
        orderId: orderId ?? this.orderId,
        statusDateTime: statusDateTime ?? this.statusDateTime,
        status: status ?? this.status,
        userId: userId ?? this.userId,
        userFullName: userFullName ?? this.userFullName,
        functionName: functionName ?? this.functionName,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsOrderStatusSummaryOrderStatusSummary {
  WebApiModulesHomeControlsOrderStatusSummaryOrderStatusSummary({
    this.orderId,
    this.iCode,
    this.iCodeDisplay,
    this.iCodeColor,
    this.inventoryTypeId,
    this.categoryId,
    this.subCategoryId,
    this.description,
    this.descriptionColor,
    this.inventoryId,
    this.orderItemId,
    this.nestedOrderItemId,
    this.parentId,
    this.outWarehouseId,
    this.outWarehouseCode,
    this.outWarehouse,
    this.inWarehouseId,
    this.inWarehouseCode,
    this.inWarehouse,
    this.quantityOrdered,
    this.quantityOrderedColor,
    this.subQuantity,
    this.stagedQuantity,
    this.stagedQuantityFilter,
    this.stagedQuantityColor,
    this.outQuantity,
    this.outQuantityfilter,
    this.outQuantityColor,
    this.isSuspendOut,
    this.inQuantity,
    this.inQuantityFilter,
    this.inQuantityColor,
    this.isSuspendIn,
    this.returnedQuantity,
    this.activityQuantity,
    this.subActivityQuantity,
    this.quantityReceived,
    this.quantityReturned,
    this.notYetStagedQuantity,
    this.tooManyStagedOut,
    this.notYetStagedQuantityFilter,
    this.stillOutQuantity,
    this.stillOutQuantityColor,
    this.itemOrder,
    this.itemClass,
    this.recType,
    this.isReturn,
    this.poOrderId,
    this.poMasteritemId,
    this.recTypeDisplay,
    this.recTypeColor,
    this.optionColor,
    this.bold,
    this.hasPoItem,
    this.vendorId,
    this.notes,
    this.manufacturerPartNumber,
    this.orderBy,
    this.isWardrobe,
    this.isProps,
    this.unitCost,
    this.stagedOutExtendedCost,
    this.unitPrice,
    this.stagedOutExtendedPrice,
    this.nestingLevel,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsOrderStatusSummaryOrderStatusSummary.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsOrderStatusSummaryOrderStatusSummaryFromJson(
          json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'ICodeDisplay')
  final String? iCodeDisplay;
  @JsonKey(name: 'ICodeColor')
  final String? iCodeColor;
  @JsonKey(name: 'InventoryTypeId')
  final String? inventoryTypeId;
  @JsonKey(name: 'CategoryId')
  final String? categoryId;
  @JsonKey(name: 'SubCategoryId')
  final String? subCategoryId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'DescriptionColor')
  final String? descriptionColor;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'OrderItemId')
  final String? orderItemId;
  @JsonKey(name: 'NestedOrderItemId')
  final String? nestedOrderItemId;
  @JsonKey(name: 'ParentId')
  final String? parentId;
  @JsonKey(name: 'OutWarehouseId')
  final String? outWarehouseId;
  @JsonKey(name: 'OutWarehouseCode')
  final String? outWarehouseCode;
  @JsonKey(name: 'OutWarehouse')
  final String? outWarehouse;
  @JsonKey(name: 'InWarehouseId')
  final String? inWarehouseId;
  @JsonKey(name: 'InWarehouseCode')
  final String? inWarehouseCode;
  @JsonKey(name: 'InWarehouse')
  final String? inWarehouse;
  @JsonKey(name: 'QuantityOrdered')
  final double? quantityOrdered;
  @JsonKey(name: 'QuantityOrderedColor')
  final String? quantityOrderedColor;
  @JsonKey(name: 'SubQuantity')
  final double? subQuantity;
  @JsonKey(name: 'StagedQuantity')
  final double? stagedQuantity;
  @JsonKey(name: 'StagedQuantityFilter')
  final double? stagedQuantityFilter;
  @JsonKey(name: 'StagedQuantityColor')
  final String? stagedQuantityColor;
  @JsonKey(name: 'OutQuantity')
  final double? outQuantity;
  @JsonKey(name: 'OutQuantityfilter')
  final double? outQuantityfilter;
  @JsonKey(name: 'OutQuantityColor')
  final String? outQuantityColor;
  @JsonKey(name: 'IsSuspendOut')
  final bool? isSuspendOut;
  @JsonKey(name: 'InQuantity')
  final double? inQuantity;
  @JsonKey(name: 'InQuantityFilter')
  final double? inQuantityFilter;
  @JsonKey(name: 'InQuantityColor')
  final String? inQuantityColor;
  @JsonKey(name: 'IsSuspendIn')
  final bool? isSuspendIn;
  @JsonKey(name: 'ReturnedQuantity')
  final double? returnedQuantity;
  @JsonKey(name: 'ActivityQuantity')
  final double? activityQuantity;
  @JsonKey(name: 'SubActivityQuantity')
  final double? subActivityQuantity;
  @JsonKey(name: 'QuantityReceived')
  final double? quantityReceived;
  @JsonKey(name: 'QuantityReturned')
  final double? quantityReturned;
  @JsonKey(name: 'NotYetStagedQuantity')
  final double? notYetStagedQuantity;
  @JsonKey(name: 'TooManyStagedOut')
  final bool? tooManyStagedOut;
  @JsonKey(name: 'NotYetStagedQuantityFilter')
  final double? notYetStagedQuantityFilter;
  @JsonKey(name: 'StillOutQuantity')
  final double? stillOutQuantity;
  @JsonKey(name: 'StillOutQuantityColor')
  final String? stillOutQuantityColor;
  @JsonKey(name: 'ItemOrder')
  final String? itemOrder;
  @JsonKey(name: 'ItemClass')
  final String? itemClass;
  @JsonKey(name: 'RecType')
  final String? recType;
  @JsonKey(name: 'IsReturn')
  final String? isReturn;
  @JsonKey(name: 'PoOrderId')
  final String? poOrderId;
  @JsonKey(name: 'PoMasteritemId')
  final String? poMasteritemId;
  @JsonKey(name: 'RecTypeDisplay')
  final String? recTypeDisplay;
  @JsonKey(name: 'RecTypeColor')
  final String? recTypeColor;
  @JsonKey(name: 'OptionColor')
  final String? optionColor;
  @JsonKey(name: 'Bold')
  final bool? bold;
  @JsonKey(name: 'HasPoItem')
  final bool? hasPoItem;
  @JsonKey(name: 'VendorId')
  final String? vendorId;
  @JsonKey(name: 'Notes')
  final String? notes;
  @JsonKey(name: 'ManufacturerPartNumber')
  final String? manufacturerPartNumber;
  @JsonKey(name: 'OrderBy')
  final String? orderBy;
  @JsonKey(name: 'IsWardrobe')
  final bool? isWardrobe;
  @JsonKey(name: 'IsProps')
  final bool? isProps;
  @JsonKey(name: 'UnitCost')
  final double? unitCost;
  @JsonKey(name: 'StagedOutExtendedCost')
  final double? stagedOutExtendedCost;
  @JsonKey(name: 'UnitPrice')
  final double? unitPrice;
  @JsonKey(name: 'StagedOutExtendedPrice')
  final double? stagedOutExtendedPrice;
  @JsonKey(name: 'NestingLevel')
  final int? nestingLevel;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsOrderStatusSummaryOrderStatusSummaryFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsOrderStatusSummaryOrderStatusSummaryToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsOrderStatusSummaryOrderStatusSummaryToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsOrderStatusSummaryOrderStatusSummary &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.iCodeDisplay, iCodeDisplay) ||
                const DeepCollectionEquality()
                    .equals(other.iCodeDisplay, iCodeDisplay)) &&
            (identical(other.iCodeColor, iCodeColor) ||
                const DeepCollectionEquality()
                    .equals(other.iCodeColor, iCodeColor)) &&
            (identical(other.inventoryTypeId, inventoryTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryTypeId, inventoryTypeId)) &&
            (identical(other.categoryId, categoryId) ||
                const DeepCollectionEquality()
                    .equals(other.categoryId, categoryId)) &&
            (identical(other.subCategoryId, subCategoryId) ||
                const DeepCollectionEquality()
                    .equals(other.subCategoryId, subCategoryId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.descriptionColor, descriptionColor) ||
                const DeepCollectionEquality()
                    .equals(other.descriptionColor, descriptionColor)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.orderItemId, orderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.orderItemId, orderItemId)) &&
            (identical(other.nestedOrderItemId, nestedOrderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.nestedOrderItemId, nestedOrderItemId)) &&
            (identical(other.parentId, parentId) ||
                const DeepCollectionEquality()
                    .equals(other.parentId, parentId)) &&
            (identical(other.outWarehouseId, outWarehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.outWarehouseId, outWarehouseId)) &&
            (identical(other.outWarehouseCode, outWarehouseCode) ||
                const DeepCollectionEquality()
                    .equals(other.outWarehouseCode, outWarehouseCode)) &&
            (identical(other.outWarehouse, outWarehouse) ||
                const DeepCollectionEquality()
                    .equals(other.outWarehouse, outWarehouse)) &&
            (identical(other.inWarehouseId, inWarehouseId) ||
                const DeepCollectionEquality().equals(other.inWarehouseId, inWarehouseId)) &&
            (identical(other.inWarehouseCode, inWarehouseCode) || const DeepCollectionEquality().equals(other.inWarehouseCode, inWarehouseCode)) &&
            (identical(other.inWarehouse, inWarehouse) || const DeepCollectionEquality().equals(other.inWarehouse, inWarehouse)) &&
            (identical(other.quantityOrdered, quantityOrdered) || const DeepCollectionEquality().equals(other.quantityOrdered, quantityOrdered)) &&
            (identical(other.quantityOrderedColor, quantityOrderedColor) || const DeepCollectionEquality().equals(other.quantityOrderedColor, quantityOrderedColor)) &&
            (identical(other.subQuantity, subQuantity) || const DeepCollectionEquality().equals(other.subQuantity, subQuantity)) &&
            (identical(other.stagedQuantity, stagedQuantity) || const DeepCollectionEquality().equals(other.stagedQuantity, stagedQuantity)) &&
            (identical(other.stagedQuantityFilter, stagedQuantityFilter) || const DeepCollectionEquality().equals(other.stagedQuantityFilter, stagedQuantityFilter)) &&
            (identical(other.stagedQuantityColor, stagedQuantityColor) || const DeepCollectionEquality().equals(other.stagedQuantityColor, stagedQuantityColor)) &&
            (identical(other.outQuantity, outQuantity) || const DeepCollectionEquality().equals(other.outQuantity, outQuantity)) &&
            (identical(other.outQuantityfilter, outQuantityfilter) || const DeepCollectionEquality().equals(other.outQuantityfilter, outQuantityfilter)) &&
            (identical(other.outQuantityColor, outQuantityColor) || const DeepCollectionEquality().equals(other.outQuantityColor, outQuantityColor)) &&
            (identical(other.isSuspendOut, isSuspendOut) || const DeepCollectionEquality().equals(other.isSuspendOut, isSuspendOut)) &&
            (identical(other.inQuantity, inQuantity) || const DeepCollectionEquality().equals(other.inQuantity, inQuantity)) &&
            (identical(other.inQuantityFilter, inQuantityFilter) || const DeepCollectionEquality().equals(other.inQuantityFilter, inQuantityFilter)) &&
            (identical(other.inQuantityColor, inQuantityColor) || const DeepCollectionEquality().equals(other.inQuantityColor, inQuantityColor)) &&
            (identical(other.isSuspendIn, isSuspendIn) || const DeepCollectionEquality().equals(other.isSuspendIn, isSuspendIn)) &&
            (identical(other.returnedQuantity, returnedQuantity) || const DeepCollectionEquality().equals(other.returnedQuantity, returnedQuantity)) &&
            (identical(other.activityQuantity, activityQuantity) || const DeepCollectionEquality().equals(other.activityQuantity, activityQuantity)) &&
            (identical(other.subActivityQuantity, subActivityQuantity) || const DeepCollectionEquality().equals(other.subActivityQuantity, subActivityQuantity)) &&
            (identical(other.quantityReceived, quantityReceived) || const DeepCollectionEquality().equals(other.quantityReceived, quantityReceived)) &&
            (identical(other.quantityReturned, quantityReturned) || const DeepCollectionEquality().equals(other.quantityReturned, quantityReturned)) &&
            (identical(other.notYetStagedQuantity, notYetStagedQuantity) || const DeepCollectionEquality().equals(other.notYetStagedQuantity, notYetStagedQuantity)) &&
            (identical(other.tooManyStagedOut, tooManyStagedOut) || const DeepCollectionEquality().equals(other.tooManyStagedOut, tooManyStagedOut)) &&
            (identical(other.notYetStagedQuantityFilter, notYetStagedQuantityFilter) || const DeepCollectionEquality().equals(other.notYetStagedQuantityFilter, notYetStagedQuantityFilter)) &&
            (identical(other.stillOutQuantity, stillOutQuantity) || const DeepCollectionEquality().equals(other.stillOutQuantity, stillOutQuantity)) &&
            (identical(other.stillOutQuantityColor, stillOutQuantityColor) || const DeepCollectionEquality().equals(other.stillOutQuantityColor, stillOutQuantityColor)) &&
            (identical(other.itemOrder, itemOrder) || const DeepCollectionEquality().equals(other.itemOrder, itemOrder)) &&
            (identical(other.itemClass, itemClass) || const DeepCollectionEquality().equals(other.itemClass, itemClass)) &&
            (identical(other.recType, recType) || const DeepCollectionEquality().equals(other.recType, recType)) &&
            (identical(other.isReturn, isReturn) || const DeepCollectionEquality().equals(other.isReturn, isReturn)) &&
            (identical(other.poOrderId, poOrderId) || const DeepCollectionEquality().equals(other.poOrderId, poOrderId)) &&
            (identical(other.poMasteritemId, poMasteritemId) || const DeepCollectionEquality().equals(other.poMasteritemId, poMasteritemId)) &&
            (identical(other.recTypeDisplay, recTypeDisplay) || const DeepCollectionEquality().equals(other.recTypeDisplay, recTypeDisplay)) &&
            (identical(other.recTypeColor, recTypeColor) || const DeepCollectionEquality().equals(other.recTypeColor, recTypeColor)) &&
            (identical(other.optionColor, optionColor) || const DeepCollectionEquality().equals(other.optionColor, optionColor)) &&
            (identical(other.bold, bold) || const DeepCollectionEquality().equals(other.bold, bold)) &&
            (identical(other.hasPoItem, hasPoItem) || const DeepCollectionEquality().equals(other.hasPoItem, hasPoItem)) &&
            (identical(other.vendorId, vendorId) || const DeepCollectionEquality().equals(other.vendorId, vendorId)) &&
            (identical(other.notes, notes) || const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.manufacturerPartNumber, manufacturerPartNumber) || const DeepCollectionEquality().equals(other.manufacturerPartNumber, manufacturerPartNumber)) &&
            (identical(other.orderBy, orderBy) || const DeepCollectionEquality().equals(other.orderBy, orderBy)) &&
            (identical(other.isWardrobe, isWardrobe) || const DeepCollectionEquality().equals(other.isWardrobe, isWardrobe)) &&
            (identical(other.isProps, isProps) || const DeepCollectionEquality().equals(other.isProps, isProps)) &&
            (identical(other.unitCost, unitCost) || const DeepCollectionEquality().equals(other.unitCost, unitCost)) &&
            (identical(other.stagedOutExtendedCost, stagedOutExtendedCost) || const DeepCollectionEquality().equals(other.stagedOutExtendedCost, stagedOutExtendedCost)) &&
            (identical(other.unitPrice, unitPrice) || const DeepCollectionEquality().equals(other.unitPrice, unitPrice)) &&
            (identical(other.stagedOutExtendedPrice, stagedOutExtendedPrice) || const DeepCollectionEquality().equals(other.stagedOutExtendedPrice, stagedOutExtendedPrice)) &&
            (identical(other.nestingLevel, nestingLevel) || const DeepCollectionEquality().equals(other.nestingLevel, nestingLevel)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsOrderStatusSummaryOrderStatusSummaryExtension
    on WebApiModulesHomeControlsOrderStatusSummaryOrderStatusSummary {
  WebApiModulesHomeControlsOrderStatusSummaryOrderStatusSummary copyWith(
      {String? orderId,
      String? iCode,
      String? iCodeDisplay,
      String? iCodeColor,
      String? inventoryTypeId,
      String? categoryId,
      String? subCategoryId,
      String? description,
      String? descriptionColor,
      String? inventoryId,
      String? orderItemId,
      String? nestedOrderItemId,
      String? parentId,
      String? outWarehouseId,
      String? outWarehouseCode,
      String? outWarehouse,
      String? inWarehouseId,
      String? inWarehouseCode,
      String? inWarehouse,
      double? quantityOrdered,
      String? quantityOrderedColor,
      double? subQuantity,
      double? stagedQuantity,
      double? stagedQuantityFilter,
      String? stagedQuantityColor,
      double? outQuantity,
      double? outQuantityfilter,
      String? outQuantityColor,
      bool? isSuspendOut,
      double? inQuantity,
      double? inQuantityFilter,
      String? inQuantityColor,
      bool? isSuspendIn,
      double? returnedQuantity,
      double? activityQuantity,
      double? subActivityQuantity,
      double? quantityReceived,
      double? quantityReturned,
      double? notYetStagedQuantity,
      bool? tooManyStagedOut,
      double? notYetStagedQuantityFilter,
      double? stillOutQuantity,
      String? stillOutQuantityColor,
      String? itemOrder,
      String? itemClass,
      String? recType,
      String? isReturn,
      String? poOrderId,
      String? poMasteritemId,
      String? recTypeDisplay,
      String? recTypeColor,
      String? optionColor,
      bool? bold,
      bool? hasPoItem,
      String? vendorId,
      String? notes,
      String? manufacturerPartNumber,
      String? orderBy,
      bool? isWardrobe,
      bool? isProps,
      double? unitCost,
      double? stagedOutExtendedCost,
      double? unitPrice,
      double? stagedOutExtendedPrice,
      int? nestingLevel,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsOrderStatusSummaryOrderStatusSummary(
        orderId: orderId ?? this.orderId,
        iCode: iCode ?? this.iCode,
        iCodeDisplay: iCodeDisplay ?? this.iCodeDisplay,
        iCodeColor: iCodeColor ?? this.iCodeColor,
        inventoryTypeId: inventoryTypeId ?? this.inventoryTypeId,
        categoryId: categoryId ?? this.categoryId,
        subCategoryId: subCategoryId ?? this.subCategoryId,
        description: description ?? this.description,
        descriptionColor: descriptionColor ?? this.descriptionColor,
        inventoryId: inventoryId ?? this.inventoryId,
        orderItemId: orderItemId ?? this.orderItemId,
        nestedOrderItemId: nestedOrderItemId ?? this.nestedOrderItemId,
        parentId: parentId ?? this.parentId,
        outWarehouseId: outWarehouseId ?? this.outWarehouseId,
        outWarehouseCode: outWarehouseCode ?? this.outWarehouseCode,
        outWarehouse: outWarehouse ?? this.outWarehouse,
        inWarehouseId: inWarehouseId ?? this.inWarehouseId,
        inWarehouseCode: inWarehouseCode ?? this.inWarehouseCode,
        inWarehouse: inWarehouse ?? this.inWarehouse,
        quantityOrdered: quantityOrdered ?? this.quantityOrdered,
        quantityOrderedColor: quantityOrderedColor ?? this.quantityOrderedColor,
        subQuantity: subQuantity ?? this.subQuantity,
        stagedQuantity: stagedQuantity ?? this.stagedQuantity,
        stagedQuantityFilter: stagedQuantityFilter ?? this.stagedQuantityFilter,
        stagedQuantityColor: stagedQuantityColor ?? this.stagedQuantityColor,
        outQuantity: outQuantity ?? this.outQuantity,
        outQuantityfilter: outQuantityfilter ?? this.outQuantityfilter,
        outQuantityColor: outQuantityColor ?? this.outQuantityColor,
        isSuspendOut: isSuspendOut ?? this.isSuspendOut,
        inQuantity: inQuantity ?? this.inQuantity,
        inQuantityFilter: inQuantityFilter ?? this.inQuantityFilter,
        inQuantityColor: inQuantityColor ?? this.inQuantityColor,
        isSuspendIn: isSuspendIn ?? this.isSuspendIn,
        returnedQuantity: returnedQuantity ?? this.returnedQuantity,
        activityQuantity: activityQuantity ?? this.activityQuantity,
        subActivityQuantity: subActivityQuantity ?? this.subActivityQuantity,
        quantityReceived: quantityReceived ?? this.quantityReceived,
        quantityReturned: quantityReturned ?? this.quantityReturned,
        notYetStagedQuantity: notYetStagedQuantity ?? this.notYetStagedQuantity,
        tooManyStagedOut: tooManyStagedOut ?? this.tooManyStagedOut,
        notYetStagedQuantityFilter:
            notYetStagedQuantityFilter ?? this.notYetStagedQuantityFilter,
        stillOutQuantity: stillOutQuantity ?? this.stillOutQuantity,
        stillOutQuantityColor:
            stillOutQuantityColor ?? this.stillOutQuantityColor,
        itemOrder: itemOrder ?? this.itemOrder,
        itemClass: itemClass ?? this.itemClass,
        recType: recType ?? this.recType,
        isReturn: isReturn ?? this.isReturn,
        poOrderId: poOrderId ?? this.poOrderId,
        poMasteritemId: poMasteritemId ?? this.poMasteritemId,
        recTypeDisplay: recTypeDisplay ?? this.recTypeDisplay,
        recTypeColor: recTypeColor ?? this.recTypeColor,
        optionColor: optionColor ?? this.optionColor,
        bold: bold ?? this.bold,
        hasPoItem: hasPoItem ?? this.hasPoItem,
        vendorId: vendorId ?? this.vendorId,
        notes: notes ?? this.notes,
        manufacturerPartNumber:
            manufacturerPartNumber ?? this.manufacturerPartNumber,
        orderBy: orderBy ?? this.orderBy,
        isWardrobe: isWardrobe ?? this.isWardrobe,
        isProps: isProps ?? this.isProps,
        unitCost: unitCost ?? this.unitCost,
        stagedOutExtendedCost:
            stagedOutExtendedCost ?? this.stagedOutExtendedCost,
        unitPrice: unitPrice ?? this.unitPrice,
        stagedOutExtendedPrice:
            stagedOutExtendedPrice ?? this.stagedOutExtendedPrice,
        nestingLevel: nestingLevel ?? this.nestingLevel,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsOrderSummaryOrderSummary {
  WebApiModulesHomeControlsOrderSummaryOrderSummary({
    this.orderId,
    this.totalType,
    this.rentalPrice,
    this.rentalDiscount,
    this.rentalCost,
    this.rentalProfit,
    this.rentalMarkup,
    this.rentalMargin,
    this.rentalSubTotal,
    this.rentalTax,
    this.rentalTotal,
    this.salesPrice,
    this.salesDiscount,
    this.salesCost,
    this.salesProfit,
    this.salesMarkup,
    this.salesMargin,
    this.salesSubTotal,
    this.salesTax,
    this.salesTotal,
    this.partsPrice,
    this.partsDiscount,
    this.partsCost,
    this.partsProfit,
    this.partsMarkup,
    this.partsMargin,
    this.partsSubTotal,
    this.partsTax,
    this.partsTotal,
    this.facilitiesPrice,
    this.facilitiesDiscount,
    this.facilitiesCost,
    this.facilitiesProfit,
    this.facilitiesMarkup,
    this.facilitiesMargin,
    this.facilitiesSubTotal,
    this.facilitiesTax,
    this.facilitiesTotal,
    this.transportationPrice,
    this.transportationDiscount,
    this.transportationCost,
    this.transportationProfit,
    this.transportationMarkup,
    this.transportationMargin,
    this.transportationSubTotal,
    this.transportationTax,
    this.transportationTotal,
    this.laborPrice,
    this.laborDiscount,
    this.laborCost,
    this.laborProfit,
    this.laborMarkup,
    this.laborMargin,
    this.laborSubTotal,
    this.laborTax,
    this.laborTotal,
    this.miscPrice,
    this.miscDiscount,
    this.miscCost,
    this.miscProfit,
    this.miscMarkup,
    this.miscMargin,
    this.miscSubTotal,
    this.miscTax,
    this.miscTotal,
    this.rentalSalePrice,
    this.rentalSaleDiscount,
    this.rentalSaleCost,
    this.rentalSaleProfit,
    this.rentalSaleMarkup,
    this.rentalSaleMargin,
    this.rentalSaleSubTotal,
    this.rentalSaleTax,
    this.rentalSaleTotal,
    this.subRentalPrice,
    this.subRentalDiscount,
    this.subRentalSubTotal,
    this.subRentalTotal,
    this.subSalePrice,
    this.subSaleDiscount,
    this.subSaleSubTotal,
    this.subSaleTotal,
    this.subLaborPrice,
    this.subLaborDiscount,
    this.subLaborSubTotal,
    this.subLaborTotal,
    this.subMiscPrice,
    this.subMiscDiscount,
    this.subMiscSubTotal,
    this.subMiscTotal,
    this.totalPrice,
    this.totalDiscount,
    this.totalCost,
    this.totalProfit,
    this.totalMarkup,
    this.totalMargin,
    this.totalSubTotal,
    this.totalTax,
    this.totalTotal,
    this.taxCost,
    this.replacementCostTotal,
    this.valueTotal,
    this.replacementCostOwned,
    this.valueOwned,
    this.replacementCostSubs,
    this.valueSubs,
    this.weightPounds,
    this.weightOunces,
    this.weightKilograms,
    this.weightGrams,
    this.weightInCasePounds,
    this.weightInCaseOunces,
    this.weightInCaseKilograms,
    this.weightInCaseGrams,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsOrderSummaryOrderSummary.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsOrderSummaryOrderSummaryFromJson(json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'TotalType')
  final String? totalType;
  @JsonKey(name: 'RentalPrice')
  final double? rentalPrice;
  @JsonKey(name: 'RentalDiscount')
  final double? rentalDiscount;
  @JsonKey(name: 'RentalCost')
  final double? rentalCost;
  @JsonKey(name: 'RentalProfit')
  final double? rentalProfit;
  @JsonKey(name: 'RentalMarkup')
  final double? rentalMarkup;
  @JsonKey(name: 'RentalMargin')
  final double? rentalMargin;
  @JsonKey(name: 'RentalSubTotal')
  final double? rentalSubTotal;
  @JsonKey(name: 'RentalTax')
  final double? rentalTax;
  @JsonKey(name: 'RentalTotal')
  final double? rentalTotal;
  @JsonKey(name: 'SalesPrice')
  final double? salesPrice;
  @JsonKey(name: 'SalesDiscount')
  final double? salesDiscount;
  @JsonKey(name: 'SalesCost')
  final double? salesCost;
  @JsonKey(name: 'SalesProfit')
  final double? salesProfit;
  @JsonKey(name: 'SalesMarkup')
  final double? salesMarkup;
  @JsonKey(name: 'SalesMargin')
  final double? salesMargin;
  @JsonKey(name: 'SalesSubTotal')
  final double? salesSubTotal;
  @JsonKey(name: 'SalesTax')
  final double? salesTax;
  @JsonKey(name: 'SalesTotal')
  final double? salesTotal;
  @JsonKey(name: 'PartsPrice')
  final double? partsPrice;
  @JsonKey(name: 'PartsDiscount')
  final double? partsDiscount;
  @JsonKey(name: 'PartsCost')
  final double? partsCost;
  @JsonKey(name: 'PartsProfit')
  final double? partsProfit;
  @JsonKey(name: 'PartsMarkup')
  final double? partsMarkup;
  @JsonKey(name: 'PartsMargin')
  final double? partsMargin;
  @JsonKey(name: 'PartsSubTotal')
  final double? partsSubTotal;
  @JsonKey(name: 'PartsTax')
  final double? partsTax;
  @JsonKey(name: 'PartsTotal')
  final double? partsTotal;
  @JsonKey(name: 'FacilitiesPrice')
  final double? facilitiesPrice;
  @JsonKey(name: 'FacilitiesDiscount')
  final double? facilitiesDiscount;
  @JsonKey(name: 'FacilitiesCost')
  final double? facilitiesCost;
  @JsonKey(name: 'FacilitiesProfit')
  final double? facilitiesProfit;
  @JsonKey(name: 'FacilitiesMarkup')
  final double? facilitiesMarkup;
  @JsonKey(name: 'FacilitiesMargin')
  final double? facilitiesMargin;
  @JsonKey(name: 'FacilitiesSubTotal')
  final double? facilitiesSubTotal;
  @JsonKey(name: 'FacilitiesTax')
  final double? facilitiesTax;
  @JsonKey(name: 'FacilitiesTotal')
  final double? facilitiesTotal;
  @JsonKey(name: 'TransportationPrice')
  final double? transportationPrice;
  @JsonKey(name: 'TransportationDiscount')
  final double? transportationDiscount;
  @JsonKey(name: 'TransportationCost')
  final double? transportationCost;
  @JsonKey(name: 'TransportationProfit')
  final double? transportationProfit;
  @JsonKey(name: 'TransportationMarkup')
  final double? transportationMarkup;
  @JsonKey(name: 'TransportationMargin')
  final double? transportationMargin;
  @JsonKey(name: 'TransportationSubTotal')
  final double? transportationSubTotal;
  @JsonKey(name: 'TransportationTax')
  final double? transportationTax;
  @JsonKey(name: 'TransportationTotal')
  final double? transportationTotal;
  @JsonKey(name: 'LaborPrice')
  final double? laborPrice;
  @JsonKey(name: 'LaborDiscount')
  final double? laborDiscount;
  @JsonKey(name: 'LaborCost')
  final double? laborCost;
  @JsonKey(name: 'LaborProfit')
  final double? laborProfit;
  @JsonKey(name: 'LaborMarkup')
  final double? laborMarkup;
  @JsonKey(name: 'LaborMargin')
  final double? laborMargin;
  @JsonKey(name: 'LaborSubTotal')
  final double? laborSubTotal;
  @JsonKey(name: 'LaborTax')
  final double? laborTax;
  @JsonKey(name: 'LaborTotal')
  final double? laborTotal;
  @JsonKey(name: 'MiscPrice')
  final double? miscPrice;
  @JsonKey(name: 'MiscDiscount')
  final double? miscDiscount;
  @JsonKey(name: 'MiscCost')
  final double? miscCost;
  @JsonKey(name: 'MiscProfit')
  final double? miscProfit;
  @JsonKey(name: 'MiscMarkup')
  final double? miscMarkup;
  @JsonKey(name: 'MiscMargin')
  final double? miscMargin;
  @JsonKey(name: 'MiscSubTotal')
  final double? miscSubTotal;
  @JsonKey(name: 'MiscTax')
  final double? miscTax;
  @JsonKey(name: 'MiscTotal')
  final double? miscTotal;
  @JsonKey(name: 'RentalSalePrice')
  final double? rentalSalePrice;
  @JsonKey(name: 'RentalSaleDiscount')
  final double? rentalSaleDiscount;
  @JsonKey(name: 'RentalSaleCost')
  final double? rentalSaleCost;
  @JsonKey(name: 'RentalSaleProfit')
  final double? rentalSaleProfit;
  @JsonKey(name: 'RentalSaleMarkup')
  final double? rentalSaleMarkup;
  @JsonKey(name: 'RentalSaleMargin')
  final double? rentalSaleMargin;
  @JsonKey(name: 'RentalSaleSubTotal')
  final double? rentalSaleSubTotal;
  @JsonKey(name: 'RentalSaleTax')
  final double? rentalSaleTax;
  @JsonKey(name: 'RentalSaleTotal')
  final double? rentalSaleTotal;
  @JsonKey(name: 'SubRentalPrice')
  final double? subRentalPrice;
  @JsonKey(name: 'SubRentalDiscount')
  final double? subRentalDiscount;
  @JsonKey(name: 'SubRentalSubTotal')
  final double? subRentalSubTotal;
  @JsonKey(name: 'SubRentalTotal')
  final double? subRentalTotal;
  @JsonKey(name: 'SubSalePrice')
  final double? subSalePrice;
  @JsonKey(name: 'SubSaleDiscount')
  final double? subSaleDiscount;
  @JsonKey(name: 'SubSaleSubTotal')
  final double? subSaleSubTotal;
  @JsonKey(name: 'SubSaleTotal')
  final double? subSaleTotal;
  @JsonKey(name: 'SubLaborPrice')
  final double? subLaborPrice;
  @JsonKey(name: 'SubLaborDiscount')
  final double? subLaborDiscount;
  @JsonKey(name: 'SubLaborSubTotal')
  final double? subLaborSubTotal;
  @JsonKey(name: 'SubLaborTotal')
  final double? subLaborTotal;
  @JsonKey(name: 'SubMiscPrice')
  final double? subMiscPrice;
  @JsonKey(name: 'SubMiscDiscount')
  final double? subMiscDiscount;
  @JsonKey(name: 'SubMiscSubTotal')
  final double? subMiscSubTotal;
  @JsonKey(name: 'SubMiscTotal')
  final double? subMiscTotal;
  @JsonKey(name: 'TotalPrice')
  final double? totalPrice;
  @JsonKey(name: 'TotalDiscount')
  final double? totalDiscount;
  @JsonKey(name: 'TotalCost')
  final double? totalCost;
  @JsonKey(name: 'TotalProfit')
  final double? totalProfit;
  @JsonKey(name: 'TotalMarkup')
  final double? totalMarkup;
  @JsonKey(name: 'TotalMargin')
  final double? totalMargin;
  @JsonKey(name: 'TotalSubTotal')
  final double? totalSubTotal;
  @JsonKey(name: 'TotalTax')
  final double? totalTax;
  @JsonKey(name: 'TotalTotal')
  final double? totalTotal;
  @JsonKey(name: 'TaxCost')
  final double? taxCost;
  @JsonKey(name: 'ReplacementCostTotal')
  final double? replacementCostTotal;
  @JsonKey(name: 'ValueTotal')
  final double? valueTotal;
  @JsonKey(name: 'ReplacementCostOwned')
  final double? replacementCostOwned;
  @JsonKey(name: 'ValueOwned')
  final double? valueOwned;
  @JsonKey(name: 'ReplacementCostSubs')
  final double? replacementCostSubs;
  @JsonKey(name: 'ValueSubs')
  final double? valueSubs;
  @JsonKey(name: 'WeightPounds')
  final int? weightPounds;
  @JsonKey(name: 'WeightOunces')
  final int? weightOunces;
  @JsonKey(name: 'WeightKilograms')
  final int? weightKilograms;
  @JsonKey(name: 'WeightGrams')
  final int? weightGrams;
  @JsonKey(name: 'WeightInCasePounds')
  final int? weightInCasePounds;
  @JsonKey(name: 'WeightInCaseOunces')
  final int? weightInCaseOunces;
  @JsonKey(name: 'WeightInCaseKilograms')
  final int? weightInCaseKilograms;
  @JsonKey(name: 'WeightInCaseGrams')
  final int? weightInCaseGrams;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsOrderSummaryOrderSummaryFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsOrderSummaryOrderSummaryToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsOrderSummaryOrderSummaryToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsOrderSummaryOrderSummary &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.totalType, totalType) ||
                const DeepCollectionEquality()
                    .equals(other.totalType, totalType)) &&
            (identical(other.rentalPrice, rentalPrice) ||
                const DeepCollectionEquality()
                    .equals(other.rentalPrice, rentalPrice)) &&
            (identical(other.rentalDiscount, rentalDiscount) ||
                const DeepCollectionEquality()
                    .equals(other.rentalDiscount, rentalDiscount)) &&
            (identical(other.rentalCost, rentalCost) ||
                const DeepCollectionEquality()
                    .equals(other.rentalCost, rentalCost)) &&
            (identical(other.rentalProfit, rentalProfit) ||
                const DeepCollectionEquality()
                    .equals(other.rentalProfit, rentalProfit)) &&
            (identical(other.rentalMarkup, rentalMarkup) ||
                const DeepCollectionEquality()
                    .equals(other.rentalMarkup, rentalMarkup)) &&
            (identical(other.rentalMargin, rentalMargin) ||
                const DeepCollectionEquality()
                    .equals(other.rentalMargin, rentalMargin)) &&
            (identical(other.rentalSubTotal, rentalSubTotal) ||
                const DeepCollectionEquality()
                    .equals(other.rentalSubTotal, rentalSubTotal)) &&
            (identical(other.rentalTax, rentalTax) ||
                const DeepCollectionEquality()
                    .equals(other.rentalTax, rentalTax)) &&
            (identical(other.rentalTotal, rentalTotal) ||
                const DeepCollectionEquality()
                    .equals(other.rentalTotal, rentalTotal)) &&
            (identical(other.salesPrice, salesPrice) ||
                const DeepCollectionEquality()
                    .equals(other.salesPrice, salesPrice)) &&
            (identical(other.salesDiscount, salesDiscount) ||
                const DeepCollectionEquality()
                    .equals(other.salesDiscount, salesDiscount)) &&
            (identical(other.salesCost, salesCost) ||
                const DeepCollectionEquality()
                    .equals(other.salesCost, salesCost)) &&
            (identical(other.salesProfit, salesProfit) ||
                const DeepCollectionEquality()
                    .equals(other.salesProfit, salesProfit)) &&
            (identical(other.salesMarkup, salesMarkup) ||
                const DeepCollectionEquality()
                    .equals(other.salesMarkup, salesMarkup)) &&
            (identical(other.salesMargin, salesMargin) ||
                const DeepCollectionEquality()
                    .equals(other.salesMargin, salesMargin)) &&
            (identical(other.salesSubTotal, salesSubTotal) ||
                const DeepCollectionEquality()
                    .equals(other.salesSubTotal, salesSubTotal)) &&
            (identical(other.salesTax, salesTax) ||
                const DeepCollectionEquality()
                    .equals(other.salesTax, salesTax)) &&
            (identical(other.salesTotal, salesTotal) ||
                const DeepCollectionEquality()
                    .equals(other.salesTotal, salesTotal)) &&
            (identical(other.partsPrice, partsPrice) ||
                const DeepCollectionEquality()
                    .equals(other.partsPrice, partsPrice)) &&
            (identical(other.partsDiscount, partsDiscount) ||
                const DeepCollectionEquality().equals(other.partsDiscount, partsDiscount)) &&
            (identical(other.partsCost, partsCost) || const DeepCollectionEquality().equals(other.partsCost, partsCost)) &&
            (identical(other.partsProfit, partsProfit) || const DeepCollectionEquality().equals(other.partsProfit, partsProfit)) &&
            (identical(other.partsMarkup, partsMarkup) || const DeepCollectionEquality().equals(other.partsMarkup, partsMarkup)) &&
            (identical(other.partsMargin, partsMargin) || const DeepCollectionEquality().equals(other.partsMargin, partsMargin)) &&
            (identical(other.partsSubTotal, partsSubTotal) || const DeepCollectionEquality().equals(other.partsSubTotal, partsSubTotal)) &&
            (identical(other.partsTax, partsTax) || const DeepCollectionEquality().equals(other.partsTax, partsTax)) &&
            (identical(other.partsTotal, partsTotal) || const DeepCollectionEquality().equals(other.partsTotal, partsTotal)) &&
            (identical(other.facilitiesPrice, facilitiesPrice) || const DeepCollectionEquality().equals(other.facilitiesPrice, facilitiesPrice)) &&
            (identical(other.facilitiesDiscount, facilitiesDiscount) || const DeepCollectionEquality().equals(other.facilitiesDiscount, facilitiesDiscount)) &&
            (identical(other.facilitiesCost, facilitiesCost) || const DeepCollectionEquality().equals(other.facilitiesCost, facilitiesCost)) &&
            (identical(other.facilitiesProfit, facilitiesProfit) || const DeepCollectionEquality().equals(other.facilitiesProfit, facilitiesProfit)) &&
            (identical(other.facilitiesMarkup, facilitiesMarkup) || const DeepCollectionEquality().equals(other.facilitiesMarkup, facilitiesMarkup)) &&
            (identical(other.facilitiesMargin, facilitiesMargin) || const DeepCollectionEquality().equals(other.facilitiesMargin, facilitiesMargin)) &&
            (identical(other.facilitiesSubTotal, facilitiesSubTotal) || const DeepCollectionEquality().equals(other.facilitiesSubTotal, facilitiesSubTotal)) &&
            (identical(other.facilitiesTax, facilitiesTax) || const DeepCollectionEquality().equals(other.facilitiesTax, facilitiesTax)) &&
            (identical(other.facilitiesTotal, facilitiesTotal) || const DeepCollectionEquality().equals(other.facilitiesTotal, facilitiesTotal)) &&
            (identical(other.transportationPrice, transportationPrice) || const DeepCollectionEquality().equals(other.transportationPrice, transportationPrice)) &&
            (identical(other.transportationDiscount, transportationDiscount) || const DeepCollectionEquality().equals(other.transportationDiscount, transportationDiscount)) &&
            (identical(other.transportationCost, transportationCost) || const DeepCollectionEquality().equals(other.transportationCost, transportationCost)) &&
            (identical(other.transportationProfit, transportationProfit) || const DeepCollectionEquality().equals(other.transportationProfit, transportationProfit)) &&
            (identical(other.transportationMarkup, transportationMarkup) || const DeepCollectionEquality().equals(other.transportationMarkup, transportationMarkup)) &&
            (identical(other.transportationMargin, transportationMargin) || const DeepCollectionEquality().equals(other.transportationMargin, transportationMargin)) &&
            (identical(other.transportationSubTotal, transportationSubTotal) || const DeepCollectionEquality().equals(other.transportationSubTotal, transportationSubTotal)) &&
            (identical(other.transportationTax, transportationTax) || const DeepCollectionEquality().equals(other.transportationTax, transportationTax)) &&
            (identical(other.transportationTotal, transportationTotal) || const DeepCollectionEquality().equals(other.transportationTotal, transportationTotal)) &&
            (identical(other.laborPrice, laborPrice) || const DeepCollectionEquality().equals(other.laborPrice, laborPrice)) &&
            (identical(other.laborDiscount, laborDiscount) || const DeepCollectionEquality().equals(other.laborDiscount, laborDiscount)) &&
            (identical(other.laborCost, laborCost) || const DeepCollectionEquality().equals(other.laborCost, laborCost)) &&
            (identical(other.laborProfit, laborProfit) || const DeepCollectionEquality().equals(other.laborProfit, laborProfit)) &&
            (identical(other.laborMarkup, laborMarkup) || const DeepCollectionEquality().equals(other.laborMarkup, laborMarkup)) &&
            (identical(other.laborMargin, laborMargin) || const DeepCollectionEquality().equals(other.laborMargin, laborMargin)) &&
            (identical(other.laborSubTotal, laborSubTotal) || const DeepCollectionEquality().equals(other.laborSubTotal, laborSubTotal)) &&
            (identical(other.laborTax, laborTax) || const DeepCollectionEquality().equals(other.laborTax, laborTax)) &&
            (identical(other.laborTotal, laborTotal) || const DeepCollectionEquality().equals(other.laborTotal, laborTotal)) &&
            (identical(other.miscPrice, miscPrice) || const DeepCollectionEquality().equals(other.miscPrice, miscPrice)) &&
            (identical(other.miscDiscount, miscDiscount) || const DeepCollectionEquality().equals(other.miscDiscount, miscDiscount)) &&
            (identical(other.miscCost, miscCost) || const DeepCollectionEquality().equals(other.miscCost, miscCost)) &&
            (identical(other.miscProfit, miscProfit) || const DeepCollectionEquality().equals(other.miscProfit, miscProfit)) &&
            (identical(other.miscMarkup, miscMarkup) || const DeepCollectionEquality().equals(other.miscMarkup, miscMarkup)) &&
            (identical(other.miscMargin, miscMargin) || const DeepCollectionEquality().equals(other.miscMargin, miscMargin)) &&
            (identical(other.miscSubTotal, miscSubTotal) || const DeepCollectionEquality().equals(other.miscSubTotal, miscSubTotal)) &&
            (identical(other.miscTax, miscTax) || const DeepCollectionEquality().equals(other.miscTax, miscTax)) &&
            (identical(other.miscTotal, miscTotal) || const DeepCollectionEquality().equals(other.miscTotal, miscTotal)) &&
            (identical(other.rentalSalePrice, rentalSalePrice) || const DeepCollectionEquality().equals(other.rentalSalePrice, rentalSalePrice)) &&
            (identical(other.rentalSaleDiscount, rentalSaleDiscount) || const DeepCollectionEquality().equals(other.rentalSaleDiscount, rentalSaleDiscount)) &&
            (identical(other.rentalSaleCost, rentalSaleCost) || const DeepCollectionEquality().equals(other.rentalSaleCost, rentalSaleCost)) &&
            (identical(other.rentalSaleProfit, rentalSaleProfit) || const DeepCollectionEquality().equals(other.rentalSaleProfit, rentalSaleProfit)) &&
            (identical(other.rentalSaleMarkup, rentalSaleMarkup) || const DeepCollectionEquality().equals(other.rentalSaleMarkup, rentalSaleMarkup)) &&
            (identical(other.rentalSaleMargin, rentalSaleMargin) || const DeepCollectionEquality().equals(other.rentalSaleMargin, rentalSaleMargin)) &&
            (identical(other.rentalSaleSubTotal, rentalSaleSubTotal) || const DeepCollectionEquality().equals(other.rentalSaleSubTotal, rentalSaleSubTotal)) &&
            (identical(other.rentalSaleTax, rentalSaleTax) || const DeepCollectionEquality().equals(other.rentalSaleTax, rentalSaleTax)) &&
            (identical(other.rentalSaleTotal, rentalSaleTotal) || const DeepCollectionEquality().equals(other.rentalSaleTotal, rentalSaleTotal)) &&
            (identical(other.subRentalPrice, subRentalPrice) || const DeepCollectionEquality().equals(other.subRentalPrice, subRentalPrice)) &&
            (identical(other.subRentalDiscount, subRentalDiscount) || const DeepCollectionEquality().equals(other.subRentalDiscount, subRentalDiscount)) &&
            (identical(other.subRentalSubTotal, subRentalSubTotal) || const DeepCollectionEquality().equals(other.subRentalSubTotal, subRentalSubTotal)) &&
            (identical(other.subRentalTotal, subRentalTotal) || const DeepCollectionEquality().equals(other.subRentalTotal, subRentalTotal)) &&
            (identical(other.subSalePrice, subSalePrice) || const DeepCollectionEquality().equals(other.subSalePrice, subSalePrice)) &&
            (identical(other.subSaleDiscount, subSaleDiscount) || const DeepCollectionEquality().equals(other.subSaleDiscount, subSaleDiscount)) &&
            (identical(other.subSaleSubTotal, subSaleSubTotal) || const DeepCollectionEquality().equals(other.subSaleSubTotal, subSaleSubTotal)) &&
            (identical(other.subSaleTotal, subSaleTotal) || const DeepCollectionEquality().equals(other.subSaleTotal, subSaleTotal)) &&
            (identical(other.subLaborPrice, subLaborPrice) || const DeepCollectionEquality().equals(other.subLaborPrice, subLaborPrice)) &&
            (identical(other.subLaborDiscount, subLaborDiscount) || const DeepCollectionEquality().equals(other.subLaborDiscount, subLaborDiscount)) &&
            (identical(other.subLaborSubTotal, subLaborSubTotal) || const DeepCollectionEquality().equals(other.subLaborSubTotal, subLaborSubTotal)) &&
            (identical(other.subLaborTotal, subLaborTotal) || const DeepCollectionEquality().equals(other.subLaborTotal, subLaborTotal)) &&
            (identical(other.subMiscPrice, subMiscPrice) || const DeepCollectionEquality().equals(other.subMiscPrice, subMiscPrice)) &&
            (identical(other.subMiscDiscount, subMiscDiscount) || const DeepCollectionEquality().equals(other.subMiscDiscount, subMiscDiscount)) &&
            (identical(other.subMiscSubTotal, subMiscSubTotal) || const DeepCollectionEquality().equals(other.subMiscSubTotal, subMiscSubTotal)) &&
            (identical(other.subMiscTotal, subMiscTotal) || const DeepCollectionEquality().equals(other.subMiscTotal, subMiscTotal)) &&
            (identical(other.totalPrice, totalPrice) || const DeepCollectionEquality().equals(other.totalPrice, totalPrice)) &&
            (identical(other.totalDiscount, totalDiscount) || const DeepCollectionEquality().equals(other.totalDiscount, totalDiscount)) &&
            (identical(other.totalCost, totalCost) || const DeepCollectionEquality().equals(other.totalCost, totalCost)) &&
            (identical(other.totalProfit, totalProfit) || const DeepCollectionEquality().equals(other.totalProfit, totalProfit)) &&
            (identical(other.totalMarkup, totalMarkup) || const DeepCollectionEquality().equals(other.totalMarkup, totalMarkup)) &&
            (identical(other.totalMargin, totalMargin) || const DeepCollectionEquality().equals(other.totalMargin, totalMargin)) &&
            (identical(other.totalSubTotal, totalSubTotal) || const DeepCollectionEquality().equals(other.totalSubTotal, totalSubTotal)) &&
            (identical(other.totalTax, totalTax) || const DeepCollectionEquality().equals(other.totalTax, totalTax)) &&
            (identical(other.totalTotal, totalTotal) || const DeepCollectionEquality().equals(other.totalTotal, totalTotal)) &&
            (identical(other.taxCost, taxCost) || const DeepCollectionEquality().equals(other.taxCost, taxCost)) &&
            (identical(other.replacementCostTotal, replacementCostTotal) || const DeepCollectionEquality().equals(other.replacementCostTotal, replacementCostTotal)) &&
            (identical(other.valueTotal, valueTotal) || const DeepCollectionEquality().equals(other.valueTotal, valueTotal)) &&
            (identical(other.replacementCostOwned, replacementCostOwned) || const DeepCollectionEquality().equals(other.replacementCostOwned, replacementCostOwned)) &&
            (identical(other.valueOwned, valueOwned) || const DeepCollectionEquality().equals(other.valueOwned, valueOwned)) &&
            (identical(other.replacementCostSubs, replacementCostSubs) || const DeepCollectionEquality().equals(other.replacementCostSubs, replacementCostSubs)) &&
            (identical(other.valueSubs, valueSubs) || const DeepCollectionEquality().equals(other.valueSubs, valueSubs)) &&
            (identical(other.weightPounds, weightPounds) || const DeepCollectionEquality().equals(other.weightPounds, weightPounds)) &&
            (identical(other.weightOunces, weightOunces) || const DeepCollectionEquality().equals(other.weightOunces, weightOunces)) &&
            (identical(other.weightKilograms, weightKilograms) || const DeepCollectionEquality().equals(other.weightKilograms, weightKilograms)) &&
            (identical(other.weightGrams, weightGrams) || const DeepCollectionEquality().equals(other.weightGrams, weightGrams)) &&
            (identical(other.weightInCasePounds, weightInCasePounds) || const DeepCollectionEquality().equals(other.weightInCasePounds, weightInCasePounds)) &&
            (identical(other.weightInCaseOunces, weightInCaseOunces) || const DeepCollectionEquality().equals(other.weightInCaseOunces, weightInCaseOunces)) &&
            (identical(other.weightInCaseKilograms, weightInCaseKilograms) || const DeepCollectionEquality().equals(other.weightInCaseKilograms, weightInCaseKilograms)) &&
            (identical(other.weightInCaseGrams, weightInCaseGrams) || const DeepCollectionEquality().equals(other.weightInCaseGrams, weightInCaseGrams)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsOrderSummaryOrderSummaryExtension
    on WebApiModulesHomeControlsOrderSummaryOrderSummary {
  WebApiModulesHomeControlsOrderSummaryOrderSummary copyWith(
      {String? orderId,
      String? totalType,
      double? rentalPrice,
      double? rentalDiscount,
      double? rentalCost,
      double? rentalProfit,
      double? rentalMarkup,
      double? rentalMargin,
      double? rentalSubTotal,
      double? rentalTax,
      double? rentalTotal,
      double? salesPrice,
      double? salesDiscount,
      double? salesCost,
      double? salesProfit,
      double? salesMarkup,
      double? salesMargin,
      double? salesSubTotal,
      double? salesTax,
      double? salesTotal,
      double? partsPrice,
      double? partsDiscount,
      double? partsCost,
      double? partsProfit,
      double? partsMarkup,
      double? partsMargin,
      double? partsSubTotal,
      double? partsTax,
      double? partsTotal,
      double? facilitiesPrice,
      double? facilitiesDiscount,
      double? facilitiesCost,
      double? facilitiesProfit,
      double? facilitiesMarkup,
      double? facilitiesMargin,
      double? facilitiesSubTotal,
      double? facilitiesTax,
      double? facilitiesTotal,
      double? transportationPrice,
      double? transportationDiscount,
      double? transportationCost,
      double? transportationProfit,
      double? transportationMarkup,
      double? transportationMargin,
      double? transportationSubTotal,
      double? transportationTax,
      double? transportationTotal,
      double? laborPrice,
      double? laborDiscount,
      double? laborCost,
      double? laborProfit,
      double? laborMarkup,
      double? laborMargin,
      double? laborSubTotal,
      double? laborTax,
      double? laborTotal,
      double? miscPrice,
      double? miscDiscount,
      double? miscCost,
      double? miscProfit,
      double? miscMarkup,
      double? miscMargin,
      double? miscSubTotal,
      double? miscTax,
      double? miscTotal,
      double? rentalSalePrice,
      double? rentalSaleDiscount,
      double? rentalSaleCost,
      double? rentalSaleProfit,
      double? rentalSaleMarkup,
      double? rentalSaleMargin,
      double? rentalSaleSubTotal,
      double? rentalSaleTax,
      double? rentalSaleTotal,
      double? subRentalPrice,
      double? subRentalDiscount,
      double? subRentalSubTotal,
      double? subRentalTotal,
      double? subSalePrice,
      double? subSaleDiscount,
      double? subSaleSubTotal,
      double? subSaleTotal,
      double? subLaborPrice,
      double? subLaborDiscount,
      double? subLaborSubTotal,
      double? subLaborTotal,
      double? subMiscPrice,
      double? subMiscDiscount,
      double? subMiscSubTotal,
      double? subMiscTotal,
      double? totalPrice,
      double? totalDiscount,
      double? totalCost,
      double? totalProfit,
      double? totalMarkup,
      double? totalMargin,
      double? totalSubTotal,
      double? totalTax,
      double? totalTotal,
      double? taxCost,
      double? replacementCostTotal,
      double? valueTotal,
      double? replacementCostOwned,
      double? valueOwned,
      double? replacementCostSubs,
      double? valueSubs,
      int? weightPounds,
      int? weightOunces,
      int? weightKilograms,
      int? weightGrams,
      int? weightInCasePounds,
      int? weightInCaseOunces,
      int? weightInCaseKilograms,
      int? weightInCaseGrams,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsOrderSummaryOrderSummary(
        orderId: orderId ?? this.orderId,
        totalType: totalType ?? this.totalType,
        rentalPrice: rentalPrice ?? this.rentalPrice,
        rentalDiscount: rentalDiscount ?? this.rentalDiscount,
        rentalCost: rentalCost ?? this.rentalCost,
        rentalProfit: rentalProfit ?? this.rentalProfit,
        rentalMarkup: rentalMarkup ?? this.rentalMarkup,
        rentalMargin: rentalMargin ?? this.rentalMargin,
        rentalSubTotal: rentalSubTotal ?? this.rentalSubTotal,
        rentalTax: rentalTax ?? this.rentalTax,
        rentalTotal: rentalTotal ?? this.rentalTotal,
        salesPrice: salesPrice ?? this.salesPrice,
        salesDiscount: salesDiscount ?? this.salesDiscount,
        salesCost: salesCost ?? this.salesCost,
        salesProfit: salesProfit ?? this.salesProfit,
        salesMarkup: salesMarkup ?? this.salesMarkup,
        salesMargin: salesMargin ?? this.salesMargin,
        salesSubTotal: salesSubTotal ?? this.salesSubTotal,
        salesTax: salesTax ?? this.salesTax,
        salesTotal: salesTotal ?? this.salesTotal,
        partsPrice: partsPrice ?? this.partsPrice,
        partsDiscount: partsDiscount ?? this.partsDiscount,
        partsCost: partsCost ?? this.partsCost,
        partsProfit: partsProfit ?? this.partsProfit,
        partsMarkup: partsMarkup ?? this.partsMarkup,
        partsMargin: partsMargin ?? this.partsMargin,
        partsSubTotal: partsSubTotal ?? this.partsSubTotal,
        partsTax: partsTax ?? this.partsTax,
        partsTotal: partsTotal ?? this.partsTotal,
        facilitiesPrice: facilitiesPrice ?? this.facilitiesPrice,
        facilitiesDiscount: facilitiesDiscount ?? this.facilitiesDiscount,
        facilitiesCost: facilitiesCost ?? this.facilitiesCost,
        facilitiesProfit: facilitiesProfit ?? this.facilitiesProfit,
        facilitiesMarkup: facilitiesMarkup ?? this.facilitiesMarkup,
        facilitiesMargin: facilitiesMargin ?? this.facilitiesMargin,
        facilitiesSubTotal: facilitiesSubTotal ?? this.facilitiesSubTotal,
        facilitiesTax: facilitiesTax ?? this.facilitiesTax,
        facilitiesTotal: facilitiesTotal ?? this.facilitiesTotal,
        transportationPrice: transportationPrice ?? this.transportationPrice,
        transportationDiscount:
            transportationDiscount ?? this.transportationDiscount,
        transportationCost: transportationCost ?? this.transportationCost,
        transportationProfit: transportationProfit ?? this.transportationProfit,
        transportationMarkup: transportationMarkup ?? this.transportationMarkup,
        transportationMargin: transportationMargin ?? this.transportationMargin,
        transportationSubTotal:
            transportationSubTotal ?? this.transportationSubTotal,
        transportationTax: transportationTax ?? this.transportationTax,
        transportationTotal: transportationTotal ?? this.transportationTotal,
        laborPrice: laborPrice ?? this.laborPrice,
        laborDiscount: laborDiscount ?? this.laborDiscount,
        laborCost: laborCost ?? this.laborCost,
        laborProfit: laborProfit ?? this.laborProfit,
        laborMarkup: laborMarkup ?? this.laborMarkup,
        laborMargin: laborMargin ?? this.laborMargin,
        laborSubTotal: laborSubTotal ?? this.laborSubTotal,
        laborTax: laborTax ?? this.laborTax,
        laborTotal: laborTotal ?? this.laborTotal,
        miscPrice: miscPrice ?? this.miscPrice,
        miscDiscount: miscDiscount ?? this.miscDiscount,
        miscCost: miscCost ?? this.miscCost,
        miscProfit: miscProfit ?? this.miscProfit,
        miscMarkup: miscMarkup ?? this.miscMarkup,
        miscMargin: miscMargin ?? this.miscMargin,
        miscSubTotal: miscSubTotal ?? this.miscSubTotal,
        miscTax: miscTax ?? this.miscTax,
        miscTotal: miscTotal ?? this.miscTotal,
        rentalSalePrice: rentalSalePrice ?? this.rentalSalePrice,
        rentalSaleDiscount: rentalSaleDiscount ?? this.rentalSaleDiscount,
        rentalSaleCost: rentalSaleCost ?? this.rentalSaleCost,
        rentalSaleProfit: rentalSaleProfit ?? this.rentalSaleProfit,
        rentalSaleMarkup: rentalSaleMarkup ?? this.rentalSaleMarkup,
        rentalSaleMargin: rentalSaleMargin ?? this.rentalSaleMargin,
        rentalSaleSubTotal: rentalSaleSubTotal ?? this.rentalSaleSubTotal,
        rentalSaleTax: rentalSaleTax ?? this.rentalSaleTax,
        rentalSaleTotal: rentalSaleTotal ?? this.rentalSaleTotal,
        subRentalPrice: subRentalPrice ?? this.subRentalPrice,
        subRentalDiscount: subRentalDiscount ?? this.subRentalDiscount,
        subRentalSubTotal: subRentalSubTotal ?? this.subRentalSubTotal,
        subRentalTotal: subRentalTotal ?? this.subRentalTotal,
        subSalePrice: subSalePrice ?? this.subSalePrice,
        subSaleDiscount: subSaleDiscount ?? this.subSaleDiscount,
        subSaleSubTotal: subSaleSubTotal ?? this.subSaleSubTotal,
        subSaleTotal: subSaleTotal ?? this.subSaleTotal,
        subLaborPrice: subLaborPrice ?? this.subLaborPrice,
        subLaborDiscount: subLaborDiscount ?? this.subLaborDiscount,
        subLaborSubTotal: subLaborSubTotal ?? this.subLaborSubTotal,
        subLaborTotal: subLaborTotal ?? this.subLaborTotal,
        subMiscPrice: subMiscPrice ?? this.subMiscPrice,
        subMiscDiscount: subMiscDiscount ?? this.subMiscDiscount,
        subMiscSubTotal: subMiscSubTotal ?? this.subMiscSubTotal,
        subMiscTotal: subMiscTotal ?? this.subMiscTotal,
        totalPrice: totalPrice ?? this.totalPrice,
        totalDiscount: totalDiscount ?? this.totalDiscount,
        totalCost: totalCost ?? this.totalCost,
        totalProfit: totalProfit ?? this.totalProfit,
        totalMarkup: totalMarkup ?? this.totalMarkup,
        totalMargin: totalMargin ?? this.totalMargin,
        totalSubTotal: totalSubTotal ?? this.totalSubTotal,
        totalTax: totalTax ?? this.totalTax,
        totalTotal: totalTotal ?? this.totalTotal,
        taxCost: taxCost ?? this.taxCost,
        replacementCostTotal: replacementCostTotal ?? this.replacementCostTotal,
        valueTotal: valueTotal ?? this.valueTotal,
        replacementCostOwned: replacementCostOwned ?? this.replacementCostOwned,
        valueOwned: valueOwned ?? this.valueOwned,
        replacementCostSubs: replacementCostSubs ?? this.replacementCostSubs,
        valueSubs: valueSubs ?? this.valueSubs,
        weightPounds: weightPounds ?? this.weightPounds,
        weightOunces: weightOunces ?? this.weightOunces,
        weightKilograms: weightKilograms ?? this.weightKilograms,
        weightGrams: weightGrams ?? this.weightGrams,
        weightInCasePounds: weightInCasePounds ?? this.weightInCasePounds,
        weightInCaseOunces: weightInCaseOunces ?? this.weightInCaseOunces,
        weightInCaseKilograms:
            weightInCaseKilograms ?? this.weightInCaseKilograms,
        weightInCaseGrams: weightInCaseGrams ?? this.weightInCaseGrams,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsPersonalEventPersonalEvent {
  WebApiModulesHomeControlsPersonalEventPersonalEvent({
    this.personalEventId,
    this.contactId,
    this.person,
    this.contactEventId,
    this.contactEvent,
    this.eventDate,
    this.color,
    this.recurring,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsPersonalEventPersonalEvent.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsPersonalEventPersonalEventFromJson(json);

  @JsonKey(name: 'PersonalEventId')
  final String? personalEventId;
  @JsonKey(name: 'ContactId')
  final String? contactId;
  @JsonKey(name: 'Person')
  final String? person;
  @JsonKey(name: 'ContactEventId')
  final String? contactEventId;
  @JsonKey(name: 'ContactEvent')
  final String? contactEvent;
  @JsonKey(name: 'EventDate')
  final String? eventDate;
  @JsonKey(name: 'Color')
  final String? color;
  @JsonKey(name: 'Recurring')
  final bool? recurring;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsPersonalEventPersonalEventFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsPersonalEventPersonalEventToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsPersonalEventPersonalEventToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsPersonalEventPersonalEvent &&
            (identical(other.personalEventId, personalEventId) ||
                const DeepCollectionEquality()
                    .equals(other.personalEventId, personalEventId)) &&
            (identical(other.contactId, contactId) ||
                const DeepCollectionEquality()
                    .equals(other.contactId, contactId)) &&
            (identical(other.person, person) ||
                const DeepCollectionEquality().equals(other.person, person)) &&
            (identical(other.contactEventId, contactEventId) ||
                const DeepCollectionEquality()
                    .equals(other.contactEventId, contactEventId)) &&
            (identical(other.contactEvent, contactEvent) ||
                const DeepCollectionEquality()
                    .equals(other.contactEvent, contactEvent)) &&
            (identical(other.eventDate, eventDate) ||
                const DeepCollectionEquality()
                    .equals(other.eventDate, eventDate)) &&
            (identical(other.color, color) ||
                const DeepCollectionEquality().equals(other.color, color)) &&
            (identical(other.recurring, recurring) ||
                const DeepCollectionEquality()
                    .equals(other.recurring, recurring)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsPersonalEventPersonalEventExtension
    on WebApiModulesHomeControlsPersonalEventPersonalEvent {
  WebApiModulesHomeControlsPersonalEventPersonalEvent copyWith(
      {String? personalEventId,
      String? contactId,
      String? person,
      String? contactEventId,
      String? contactEvent,
      String? eventDate,
      String? color,
      bool? recurring,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsPersonalEventPersonalEvent(
        personalEventId: personalEventId ?? this.personalEventId,
        contactId: contactId ?? this.contactId,
        person: person ?? this.person,
        contactEventId: contactEventId ?? this.contactEventId,
        contactEvent: contactEvent ?? this.contactEvent,
        eventDate: eventDate ?? this.eventDate,
        color: color ?? this.color,
        recurring: recurring ?? this.recurring,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventory {
  WebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventory({
    this.id,
    this.physicalInventoryId,
    this.inventoryId,
    this.consignorId,
    this.iCode,
    this.description,
    this.availableFor,
    this.availableForDisplay,
    this.trackedBy,
    this.rank,
    this.aisleLocation,
    this.shelfLocation,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventory.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventoryFromJson(
          json);

  @JsonKey(name: 'Id')
  final int? id;
  @JsonKey(name: 'PhysicalInventoryId')
  final String? physicalInventoryId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'ConsignorId')
  final String? consignorId;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AvailableFor')
  final String? availableFor;
  @JsonKey(name: 'AvailableForDisplay')
  final String? availableForDisplay;
  @JsonKey(name: 'TrackedBy')
  final String? trackedBy;
  @JsonKey(name: 'Rank')
  final String? rank;
  @JsonKey(name: 'AisleLocation')
  final String? aisleLocation;
  @JsonKey(name: 'ShelfLocation')
  final String? shelfLocation;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventoryFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventoryToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventoryToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventory &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.physicalInventoryId, physicalInventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.physicalInventoryId, physicalInventoryId)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.consignorId, consignorId) ||
                const DeepCollectionEquality()
                    .equals(other.consignorId, consignorId)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.availableFor, availableFor) ||
                const DeepCollectionEquality()
                    .equals(other.availableFor, availableFor)) &&
            (identical(other.availableForDisplay, availableForDisplay) ||
                const DeepCollectionEquality()
                    .equals(other.availableForDisplay, availableForDisplay)) &&
            (identical(other.trackedBy, trackedBy) ||
                const DeepCollectionEquality()
                    .equals(other.trackedBy, trackedBy)) &&
            (identical(other.rank, rank) ||
                const DeepCollectionEquality().equals(other.rank, rank)) &&
            (identical(other.aisleLocation, aisleLocation) ||
                const DeepCollectionEquality()
                    .equals(other.aisleLocation, aisleLocation)) &&
            (identical(other.shelfLocation, shelfLocation) ||
                const DeepCollectionEquality()
                    .equals(other.shelfLocation, shelfLocation)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventoryExtension
    on WebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventory {
  WebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventory
      copyWith(
          {int? id,
          String? physicalInventoryId,
          String? inventoryId,
          String? consignorId,
          String? iCode,
          String? description,
          String? availableFor,
          String? availableForDisplay,
          String? trackedBy,
          String? rank,
          String? aisleLocation,
          String? shelfLocation,
          String? dateStamp,
          String? recordTitle,
          List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
          List<FwStandardDataFwCustomValue>? custom,
          List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsPhysicalInventoryCycleInventoryPhysicalInventoryCycleInventory(
        id: id ?? this.id,
        physicalInventoryId: physicalInventoryId ?? this.physicalInventoryId,
        inventoryId: inventoryId ?? this.inventoryId,
        consignorId: consignorId ?? this.consignorId,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        availableFor: availableFor ?? this.availableFor,
        availableForDisplay: availableForDisplay ?? this.availableForDisplay,
        trackedBy: trackedBy ?? this.trackedBy,
        rank: rank ?? this.rank,
        aisleLocation: aisleLocation ?? this.aisleLocation,
        shelfLocation: shelfLocation ?? this.shelfLocation,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventory {
  WebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventory({
    this.id,
    this.physicalInventoryId,
    this.inventoryId,
    this.iCode,
    this.description,
    this.availableFor,
    this.availableForDisplay,
    this.quantityOwned,
    this.trackedBy,
    this.unitCost,
    this.isRecount,
    this.aisleLocation,
    this.shelfLocation,
    this.isNegativeInventory,
    this.quantityAdded,
    this.quantityRetired,
    this.lastPurchaseUnitCost,
    this.newUnitCost,
    this.currentSpaceId,
    this.consignorId,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventory.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventoryFromJson(
          json);

  @JsonKey(name: 'Id')
  final int? id;
  @JsonKey(name: 'PhysicalInventoryId')
  final String? physicalInventoryId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AvailableFor')
  final String? availableFor;
  @JsonKey(name: 'AvailableForDisplay')
  final String? availableForDisplay;
  @JsonKey(name: 'QuantityOwned')
  final double? quantityOwned;
  @JsonKey(name: 'TrackedBy')
  final String? trackedBy;
  @JsonKey(name: 'UnitCost')
  final double? unitCost;
  @JsonKey(name: 'IsRecount')
  final bool? isRecount;
  @JsonKey(name: 'AisleLocation')
  final String? aisleLocation;
  @JsonKey(name: 'ShelfLocation')
  final String? shelfLocation;
  @JsonKey(name: 'IsNegativeInventory')
  final int? isNegativeInventory;
  @JsonKey(name: 'QuantityAdded')
  final double? quantityAdded;
  @JsonKey(name: 'QuantityRetired')
  final double? quantityRetired;
  @JsonKey(name: 'LastPurchaseUnitCost')
  final double? lastPurchaseUnitCost;
  @JsonKey(name: 'NewUnitCost')
  final double? newUnitCost;
  @JsonKey(name: 'CurrentSpaceId')
  final String? currentSpaceId;
  @JsonKey(name: 'ConsignorId')
  final String? consignorId;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventoryFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventoryToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventoryToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventory &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.physicalInventoryId, physicalInventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.physicalInventoryId, physicalInventoryId)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.availableFor, availableFor) ||
                const DeepCollectionEquality()
                    .equals(other.availableFor, availableFor)) &&
            (identical(other.availableForDisplay, availableForDisplay) ||
                const DeepCollectionEquality()
                    .equals(other.availableForDisplay, availableForDisplay)) &&
            (identical(other.quantityOwned, quantityOwned) ||
                const DeepCollectionEquality()
                    .equals(other.quantityOwned, quantityOwned)) &&
            (identical(other.trackedBy, trackedBy) ||
                const DeepCollectionEquality()
                    .equals(other.trackedBy, trackedBy)) &&
            (identical(other.unitCost, unitCost) ||
                const DeepCollectionEquality()
                    .equals(other.unitCost, unitCost)) &&
            (identical(other.isRecount, isRecount) ||
                const DeepCollectionEquality()
                    .equals(other.isRecount, isRecount)) &&
            (identical(other.aisleLocation, aisleLocation) ||
                const DeepCollectionEquality()
                    .equals(other.aisleLocation, aisleLocation)) &&
            (identical(other.shelfLocation, shelfLocation) ||
                const DeepCollectionEquality()
                    .equals(other.shelfLocation, shelfLocation)) &&
            (identical(other.isNegativeInventory, isNegativeInventory) ||
                const DeepCollectionEquality()
                    .equals(other.isNegativeInventory, isNegativeInventory)) &&
            (identical(other.quantityAdded, quantityAdded) ||
                const DeepCollectionEquality()
                    .equals(other.quantityAdded, quantityAdded)) &&
            (identical(other.quantityRetired, quantityRetired) ||
                const DeepCollectionEquality()
                    .equals(other.quantityRetired, quantityRetired)) &&
            (identical(other.lastPurchaseUnitCost, lastPurchaseUnitCost) ||
                const DeepCollectionEquality()
                    .equals(other.lastPurchaseUnitCost, lastPurchaseUnitCost)) &&
            (identical(other.newUnitCost, newUnitCost) || const DeepCollectionEquality().equals(other.newUnitCost, newUnitCost)) &&
            (identical(other.currentSpaceId, currentSpaceId) || const DeepCollectionEquality().equals(other.currentSpaceId, currentSpaceId)) &&
            (identical(other.consignorId, consignorId) || const DeepCollectionEquality().equals(other.consignorId, consignorId)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventoryExtension
    on WebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventory {
  WebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventory
      copyWith(
          {int? id,
          String? physicalInventoryId,
          String? inventoryId,
          String? iCode,
          String? description,
          String? availableFor,
          String? availableForDisplay,
          double? quantityOwned,
          String? trackedBy,
          double? unitCost,
          bool? isRecount,
          String? aisleLocation,
          String? shelfLocation,
          int? isNegativeInventory,
          double? quantityAdded,
          double? quantityRetired,
          double? lastPurchaseUnitCost,
          double? newUnitCost,
          String? currentSpaceId,
          String? consignorId,
          String? dateStamp,
          String? recordTitle,
          List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
          List<FwStandardDataFwCustomValue>? custom,
          List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsPhysicalInventoryInventoryPhysicalInventoryInventory(
        id: id ?? this.id,
        physicalInventoryId: physicalInventoryId ?? this.physicalInventoryId,
        inventoryId: inventoryId ?? this.inventoryId,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        availableFor: availableFor ?? this.availableFor,
        availableForDisplay: availableForDisplay ?? this.availableForDisplay,
        quantityOwned: quantityOwned ?? this.quantityOwned,
        trackedBy: trackedBy ?? this.trackedBy,
        unitCost: unitCost ?? this.unitCost,
        isRecount: isRecount ?? this.isRecount,
        aisleLocation: aisleLocation ?? this.aisleLocation,
        shelfLocation: shelfLocation ?? this.shelfLocation,
        isNegativeInventory: isNegativeInventory ?? this.isNegativeInventory,
        quantityAdded: quantityAdded ?? this.quantityAdded,
        quantityRetired: quantityRetired ?? this.quantityRetired,
        lastPurchaseUnitCost: lastPurchaseUnitCost ?? this.lastPurchaseUnitCost,
        newUnitCost: newUnitCost ?? this.newUnitCost,
        currentSpaceId: currentSpaceId ?? this.currentSpaceId,
        consignorId: consignorId ?? this.consignorId,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsPickListItemPickListItem {
  WebApiModulesHomeControlsPickListItemPickListItem({
    this.pickListItemId,
    this.pickListId,
    this.orderId,
    this.orderNumber,
    this.masterItemId,
    this.usersId,
    this.pickQuantity,
    this.quantityOrdered,
    this.consignQuantity,
    this.stagedQuantity,
    this.outQuantity,
    this.inLocationQuantity,
    this.masterId,
    this.iCode,
    this.iCodeColor,
    this.description,
    this.descriptionColor,
    this.optionColor,
    this.itemClass,
    this.itemOrder,
    this.pickDate,
    this.pickTime,
    this.recType,
    this.vendorId,
    this.vendorColor,
    this.inventoryTypeId,
    this.categoryId,
    this.warehouseId,
    this.conflict,
    this.bold,
    this.itemOrderPickList,
    this.notes,
    this.barCode,
    this.serialNumber,
    this.rfId,
    this.nestingLevel,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsPickListItemPickListItem.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsPickListItemPickListItemFromJson(json);

  @JsonKey(name: 'PickListItemId')
  final String? pickListItemId;
  @JsonKey(name: 'PickListId')
  final String? pickListId;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderNumber')
  final String? orderNumber;
  @JsonKey(name: 'MasterItemId')
  final String? masterItemId;
  @JsonKey(name: 'UsersId')
  final String? usersId;
  @JsonKey(name: 'PickQuantity')
  final int? pickQuantity;
  @JsonKey(name: 'QuantityOrdered')
  final int? quantityOrdered;
  @JsonKey(name: 'ConsignQuantity')
  final int? consignQuantity;
  @JsonKey(name: 'StagedQuantity')
  final int? stagedQuantity;
  @JsonKey(name: 'OutQuantity')
  final int? outQuantity;
  @JsonKey(name: 'InLocationQuantity')
  final int? inLocationQuantity;
  @JsonKey(name: 'MasterId')
  final String? masterId;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'ICodeColor')
  final String? iCodeColor;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'DescriptionColor')
  final String? descriptionColor;
  @JsonKey(name: 'OptionColor')
  final String? optionColor;
  @JsonKey(name: 'ItemClass')
  final String? itemClass;
  @JsonKey(name: 'ItemOrder')
  final String? itemOrder;
  @JsonKey(name: 'PickDate')
  final String? pickDate;
  @JsonKey(name: 'PickTime')
  final String? pickTime;
  @JsonKey(name: 'RecType')
  final String? recType;
  @JsonKey(name: 'VendorId')
  final String? vendorId;
  @JsonKey(name: 'VendorColor')
  final String? vendorColor;
  @JsonKey(name: 'InventoryTypeId')
  final String? inventoryTypeId;
  @JsonKey(name: 'CategoryId')
  final String? categoryId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'Conflict')
  final bool? conflict;
  @JsonKey(name: 'Bold')
  final bool? bold;
  @JsonKey(name: 'ItemOrderPickList')
  final String? itemOrderPickList;
  @JsonKey(name: 'Notes')
  final String? notes;
  @JsonKey(name: 'BarCode')
  final String? barCode;
  @JsonKey(name: 'SerialNumber')
  final String? serialNumber;
  @JsonKey(name: 'RfId')
  final String? rfId;
  @JsonKey(name: 'NestingLevel')
  final int? nestingLevel;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsPickListItemPickListItemFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsPickListItemPickListItemToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsPickListItemPickListItemToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsPickListItemPickListItem &&
            (identical(other.pickListItemId, pickListItemId) ||
                const DeepCollectionEquality()
                    .equals(other.pickListItemId, pickListItemId)) &&
            (identical(other.pickListId, pickListId) ||
                const DeepCollectionEquality()
                    .equals(other.pickListId, pickListId)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderNumber, orderNumber) ||
                const DeepCollectionEquality()
                    .equals(other.orderNumber, orderNumber)) &&
            (identical(other.masterItemId, masterItemId) ||
                const DeepCollectionEquality()
                    .equals(other.masterItemId, masterItemId)) &&
            (identical(other.usersId, usersId) ||
                const DeepCollectionEquality()
                    .equals(other.usersId, usersId)) &&
            (identical(other.pickQuantity, pickQuantity) ||
                const DeepCollectionEquality()
                    .equals(other.pickQuantity, pickQuantity)) &&
            (identical(other.quantityOrdered, quantityOrdered) ||
                const DeepCollectionEquality()
                    .equals(other.quantityOrdered, quantityOrdered)) &&
            (identical(other.consignQuantity, consignQuantity) ||
                const DeepCollectionEquality()
                    .equals(other.consignQuantity, consignQuantity)) &&
            (identical(other.stagedQuantity, stagedQuantity) ||
                const DeepCollectionEquality()
                    .equals(other.stagedQuantity, stagedQuantity)) &&
            (identical(other.outQuantity, outQuantity) ||
                const DeepCollectionEquality()
                    .equals(other.outQuantity, outQuantity)) &&
            (identical(other.inLocationQuantity, inLocationQuantity) ||
                const DeepCollectionEquality()
                    .equals(other.inLocationQuantity, inLocationQuantity)) &&
            (identical(other.masterId, masterId) ||
                const DeepCollectionEquality()
                    .equals(other.masterId, masterId)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.iCodeColor, iCodeColor) ||
                const DeepCollectionEquality()
                    .equals(other.iCodeColor, iCodeColor)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.descriptionColor, descriptionColor) ||
                const DeepCollectionEquality()
                    .equals(other.descriptionColor, descriptionColor)) &&
            (identical(other.optionColor, optionColor) ||
                const DeepCollectionEquality()
                    .equals(other.optionColor, optionColor)) &&
            (identical(other.itemClass, itemClass) ||
                const DeepCollectionEquality()
                    .equals(other.itemClass, itemClass)) &&
            (identical(other.itemOrder, itemOrder) ||
                const DeepCollectionEquality()
                    .equals(other.itemOrder, itemOrder)) &&
            (identical(other.pickDate, pickDate) ||
                const DeepCollectionEquality()
                    .equals(other.pickDate, pickDate)) &&
            (identical(other.pickTime, pickTime) ||
                const DeepCollectionEquality()
                    .equals(other.pickTime, pickTime)) &&
            (identical(other.recType, recType) || const DeepCollectionEquality().equals(other.recType, recType)) &&
            (identical(other.vendorId, vendorId) || const DeepCollectionEquality().equals(other.vendorId, vendorId)) &&
            (identical(other.vendorColor, vendorColor) || const DeepCollectionEquality().equals(other.vendorColor, vendorColor)) &&
            (identical(other.inventoryTypeId, inventoryTypeId) || const DeepCollectionEquality().equals(other.inventoryTypeId, inventoryTypeId)) &&
            (identical(other.categoryId, categoryId) || const DeepCollectionEquality().equals(other.categoryId, categoryId)) &&
            (identical(other.warehouseId, warehouseId) || const DeepCollectionEquality().equals(other.warehouseId, warehouseId)) &&
            (identical(other.conflict, conflict) || const DeepCollectionEquality().equals(other.conflict, conflict)) &&
            (identical(other.bold, bold) || const DeepCollectionEquality().equals(other.bold, bold)) &&
            (identical(other.itemOrderPickList, itemOrderPickList) || const DeepCollectionEquality().equals(other.itemOrderPickList, itemOrderPickList)) &&
            (identical(other.notes, notes) || const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.barCode, barCode) || const DeepCollectionEquality().equals(other.barCode, barCode)) &&
            (identical(other.serialNumber, serialNumber) || const DeepCollectionEquality().equals(other.serialNumber, serialNumber)) &&
            (identical(other.rfId, rfId) || const DeepCollectionEquality().equals(other.rfId, rfId)) &&
            (identical(other.nestingLevel, nestingLevel) || const DeepCollectionEquality().equals(other.nestingLevel, nestingLevel)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsPickListItemPickListItemExtension
    on WebApiModulesHomeControlsPickListItemPickListItem {
  WebApiModulesHomeControlsPickListItemPickListItem copyWith(
      {String? pickListItemId,
      String? pickListId,
      String? orderId,
      String? orderNumber,
      String? masterItemId,
      String? usersId,
      int? pickQuantity,
      int? quantityOrdered,
      int? consignQuantity,
      int? stagedQuantity,
      int? outQuantity,
      int? inLocationQuantity,
      String? masterId,
      String? iCode,
      String? iCodeColor,
      String? description,
      String? descriptionColor,
      String? optionColor,
      String? itemClass,
      String? itemOrder,
      String? pickDate,
      String? pickTime,
      String? recType,
      String? vendorId,
      String? vendorColor,
      String? inventoryTypeId,
      String? categoryId,
      String? warehouseId,
      bool? conflict,
      bool? bold,
      String? itemOrderPickList,
      String? notes,
      String? barCode,
      String? serialNumber,
      String? rfId,
      int? nestingLevel,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsPickListItemPickListItem(
        pickListItemId: pickListItemId ?? this.pickListItemId,
        pickListId: pickListId ?? this.pickListId,
        orderId: orderId ?? this.orderId,
        orderNumber: orderNumber ?? this.orderNumber,
        masterItemId: masterItemId ?? this.masterItemId,
        usersId: usersId ?? this.usersId,
        pickQuantity: pickQuantity ?? this.pickQuantity,
        quantityOrdered: quantityOrdered ?? this.quantityOrdered,
        consignQuantity: consignQuantity ?? this.consignQuantity,
        stagedQuantity: stagedQuantity ?? this.stagedQuantity,
        outQuantity: outQuantity ?? this.outQuantity,
        inLocationQuantity: inLocationQuantity ?? this.inLocationQuantity,
        masterId: masterId ?? this.masterId,
        iCode: iCode ?? this.iCode,
        iCodeColor: iCodeColor ?? this.iCodeColor,
        description: description ?? this.description,
        descriptionColor: descriptionColor ?? this.descriptionColor,
        optionColor: optionColor ?? this.optionColor,
        itemClass: itemClass ?? this.itemClass,
        itemOrder: itemOrder ?? this.itemOrder,
        pickDate: pickDate ?? this.pickDate,
        pickTime: pickTime ?? this.pickTime,
        recType: recType ?? this.recType,
        vendorId: vendorId ?? this.vendorId,
        vendorColor: vendorColor ?? this.vendorColor,
        inventoryTypeId: inventoryTypeId ?? this.inventoryTypeId,
        categoryId: categoryId ?? this.categoryId,
        warehouseId: warehouseId ?? this.warehouseId,
        conflict: conflict ?? this.conflict,
        bold: bold ?? this.bold,
        itemOrderPickList: itemOrderPickList ?? this.itemOrderPickList,
        notes: notes ?? this.notes,
        barCode: barCode ?? this.barCode,
        serialNumber: serialNumber ?? this.serialNumber,
        rfId: rfId ?? this.rfId,
        nestingLevel: nestingLevel ?? this.nestingLevel,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsPickListUtilityItemApplyPickListSessionItemsRequest {
  WebApiModulesHomeControlsPickListUtilityItemApplyPickListSessionItemsRequest({
    this.sessionId,
    this.itemsNotYetStaged,
    this.itemsStaged,
    this.itemsOut,
    this.pickDateFrom,
    this.pickDateTo,
    this.rentalItems,
    this.salesItems,
    this.vendorItems,
    this.laborItems,
    this.warehouseId,
    this.completeKitMains,
    this.completeKitAccessories,
    this.completeKitOptions,
    this.standAloneItems,
    this.itemsOnOtherPickLists,
    this.reduceQuantityAlreadyPicked,
    this.summarizeByICode,
    this.summarizeCompleteKitItems,
    this.honorCompleteKitItemTypes,
    this.inventoryTypeId,
    this.selectAll,
    this.selectNone,
  });

  factory WebApiModulesHomeControlsPickListUtilityItemApplyPickListSessionItemsRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsPickListUtilityItemApplyPickListSessionItemsRequestFromJson(
          json);

  @JsonKey(name: 'SessionId')
  final String? sessionId;
  @JsonKey(name: 'ItemsNotYetStaged')
  final bool? itemsNotYetStaged;
  @JsonKey(name: 'ItemsStaged')
  final bool? itemsStaged;
  @JsonKey(name: 'ItemsOut')
  final bool? itemsOut;
  @JsonKey(name: 'PickDateFrom')
  final DateTime? pickDateFrom;
  @JsonKey(name: 'PickDateTo')
  final DateTime? pickDateTo;
  @JsonKey(name: 'RentalItems')
  final bool? rentalItems;
  @JsonKey(name: 'SalesItems')
  final bool? salesItems;
  @JsonKey(name: 'VendorItems')
  final bool? vendorItems;
  @JsonKey(name: 'LaborItems')
  final bool? laborItems;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'CompleteKitMains')
  final bool? completeKitMains;
  @JsonKey(name: 'CompleteKitAccessories')
  final bool? completeKitAccessories;
  @JsonKey(name: 'CompleteKitOptions')
  final bool? completeKitOptions;
  @JsonKey(name: 'StandAloneItems')
  final bool? standAloneItems;
  @JsonKey(name: 'ItemsOnOtherPickLists')
  final bool? itemsOnOtherPickLists;
  @JsonKey(name: 'ReduceQuantityAlreadyPicked')
  final bool? reduceQuantityAlreadyPicked;
  @JsonKey(name: 'SummarizeByICode')
  final bool? summarizeByICode;
  @JsonKey(name: 'SummarizeCompleteKitItems')
  final bool? summarizeCompleteKitItems;
  @JsonKey(name: 'HonorCompleteKitItemTypes')
  final bool? honorCompleteKitItemTypes;
  @JsonKey(name: 'InventoryTypeId')
  final String? inventoryTypeId;
  @JsonKey(name: 'SelectAll')
  final bool? selectAll;
  @JsonKey(name: 'SelectNone')
  final bool? selectNone;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsPickListUtilityItemApplyPickListSessionItemsRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsPickListUtilityItemApplyPickListSessionItemsRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsPickListUtilityItemApplyPickListSessionItemsRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsPickListUtilityItemApplyPickListSessionItemsRequest &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)) &&
            (identical(other.itemsNotYetStaged, itemsNotYetStaged) ||
                const DeepCollectionEquality()
                    .equals(other.itemsNotYetStaged, itemsNotYetStaged)) &&
            (identical(other.itemsStaged, itemsStaged) ||
                const DeepCollectionEquality()
                    .equals(other.itemsStaged, itemsStaged)) &&
            (identical(other.itemsOut, itemsOut) ||
                const DeepCollectionEquality()
                    .equals(other.itemsOut, itemsOut)) &&
            (identical(other.pickDateFrom, pickDateFrom) ||
                const DeepCollectionEquality()
                    .equals(other.pickDateFrom, pickDateFrom)) &&
            (identical(other.pickDateTo, pickDateTo) ||
                const DeepCollectionEquality()
                    .equals(other.pickDateTo, pickDateTo)) &&
            (identical(other.rentalItems, rentalItems) ||
                const DeepCollectionEquality()
                    .equals(other.rentalItems, rentalItems)) &&
            (identical(other.salesItems, salesItems) ||
                const DeepCollectionEquality()
                    .equals(other.salesItems, salesItems)) &&
            (identical(other.vendorItems, vendorItems) ||
                const DeepCollectionEquality()
                    .equals(other.vendorItems, vendorItems)) &&
            (identical(other.laborItems, laborItems) ||
                const DeepCollectionEquality()
                    .equals(other.laborItems, laborItems)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.completeKitMains, completeKitMains) ||
                const DeepCollectionEquality()
                    .equals(other.completeKitMains, completeKitMains)) &&
            (identical(other.completeKitAccessories, completeKitAccessories) ||
                const DeepCollectionEquality().equals(
                    other.completeKitAccessories, completeKitAccessories)) &&
            (identical(other.completeKitOptions, completeKitOptions) ||
                const DeepCollectionEquality()
                    .equals(other.completeKitOptions, completeKitOptions)) &&
            (identical(other.standAloneItems, standAloneItems) ||
                const DeepCollectionEquality()
                    .equals(other.standAloneItems, standAloneItems)) &&
            (identical(other.itemsOnOtherPickLists, itemsOnOtherPickLists) ||
                const DeepCollectionEquality().equals(other.itemsOnOtherPickLists, itemsOnOtherPickLists)) &&
            (identical(other.reduceQuantityAlreadyPicked, reduceQuantityAlreadyPicked) || const DeepCollectionEquality().equals(other.reduceQuantityAlreadyPicked, reduceQuantityAlreadyPicked)) &&
            (identical(other.summarizeByICode, summarizeByICode) || const DeepCollectionEquality().equals(other.summarizeByICode, summarizeByICode)) &&
            (identical(other.summarizeCompleteKitItems, summarizeCompleteKitItems) || const DeepCollectionEquality().equals(other.summarizeCompleteKitItems, summarizeCompleteKitItems)) &&
            (identical(other.honorCompleteKitItemTypes, honorCompleteKitItemTypes) || const DeepCollectionEquality().equals(other.honorCompleteKitItemTypes, honorCompleteKitItemTypes)) &&
            (identical(other.inventoryTypeId, inventoryTypeId) || const DeepCollectionEquality().equals(other.inventoryTypeId, inventoryTypeId)) &&
            (identical(other.selectAll, selectAll) || const DeepCollectionEquality().equals(other.selectAll, selectAll)) &&
            (identical(other.selectNone, selectNone) || const DeepCollectionEquality().equals(other.selectNone, selectNone)));
  }
}

extension $WebApiModulesHomeControlsPickListUtilityItemApplyPickListSessionItemsRequestExtension
    on WebApiModulesHomeControlsPickListUtilityItemApplyPickListSessionItemsRequest {
  WebApiModulesHomeControlsPickListUtilityItemApplyPickListSessionItemsRequest
      copyWith(
          {String? sessionId,
          bool? itemsNotYetStaged,
          bool? itemsStaged,
          bool? itemsOut,
          DateTime? pickDateFrom,
          DateTime? pickDateTo,
          bool? rentalItems,
          bool? salesItems,
          bool? vendorItems,
          bool? laborItems,
          String? warehouseId,
          bool? completeKitMains,
          bool? completeKitAccessories,
          bool? completeKitOptions,
          bool? standAloneItems,
          bool? itemsOnOtherPickLists,
          bool? reduceQuantityAlreadyPicked,
          bool? summarizeByICode,
          bool? summarizeCompleteKitItems,
          bool? honorCompleteKitItemTypes,
          String? inventoryTypeId,
          bool? selectAll,
          bool? selectNone}) {
    return WebApiModulesHomeControlsPickListUtilityItemApplyPickListSessionItemsRequest(
        sessionId: sessionId ?? this.sessionId,
        itemsNotYetStaged: itemsNotYetStaged ?? this.itemsNotYetStaged,
        itemsStaged: itemsStaged ?? this.itemsStaged,
        itemsOut: itemsOut ?? this.itemsOut,
        pickDateFrom: pickDateFrom ?? this.pickDateFrom,
        pickDateTo: pickDateTo ?? this.pickDateTo,
        rentalItems: rentalItems ?? this.rentalItems,
        salesItems: salesItems ?? this.salesItems,
        vendorItems: vendorItems ?? this.vendorItems,
        laborItems: laborItems ?? this.laborItems,
        warehouseId: warehouseId ?? this.warehouseId,
        completeKitMains: completeKitMains ?? this.completeKitMains,
        completeKitAccessories:
            completeKitAccessories ?? this.completeKitAccessories,
        completeKitOptions: completeKitOptions ?? this.completeKitOptions,
        standAloneItems: standAloneItems ?? this.standAloneItems,
        itemsOnOtherPickLists:
            itemsOnOtherPickLists ?? this.itemsOnOtherPickLists,
        reduceQuantityAlreadyPicked:
            reduceQuantityAlreadyPicked ?? this.reduceQuantityAlreadyPicked,
        summarizeByICode: summarizeByICode ?? this.summarizeByICode,
        summarizeCompleteKitItems:
            summarizeCompleteKitItems ?? this.summarizeCompleteKitItems,
        honorCompleteKitItemTypes:
            honorCompleteKitItemTypes ?? this.honorCompleteKitItemTypes,
        inventoryTypeId: inventoryTypeId ?? this.inventoryTypeId,
        selectAll: selectAll ?? this.selectAll,
        selectNone: selectNone ?? this.selectNone);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsPickListUtilityItemCompleteSessionRequest {
  WebApiModulesHomeControlsPickListUtilityItemCompleteSessionRequest({
    this.sessionId,
  });

  factory WebApiModulesHomeControlsPickListUtilityItemCompleteSessionRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsPickListUtilityItemCompleteSessionRequestFromJson(
          json);

  @JsonKey(name: 'SessionId')
  final String? sessionId;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsPickListUtilityItemCompleteSessionRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsPickListUtilityItemCompleteSessionRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsPickListUtilityItemCompleteSessionRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsPickListUtilityItemCompleteSessionRequest &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)));
  }
}

extension $WebApiModulesHomeControlsPickListUtilityItemCompleteSessionRequestExtension
    on WebApiModulesHomeControlsPickListUtilityItemCompleteSessionRequest {
  WebApiModulesHomeControlsPickListUtilityItemCompleteSessionRequest copyWith(
      {String? sessionId}) {
    return WebApiModulesHomeControlsPickListUtilityItemCompleteSessionRequest(
        sessionId: sessionId ?? this.sessionId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsPickListUtilityItemCompleteSessionResponse {
  WebApiModulesHomeControlsPickListUtilityItemCompleteSessionResponse({
    this.pickListId,
    this.pickListNumber,
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesHomeControlsPickListUtilityItemCompleteSessionResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsPickListUtilityItemCompleteSessionResponseFromJson(
          json);

  @JsonKey(name: 'PickListId')
  final String? pickListId;
  @JsonKey(name: 'PickListNumber')
  final String? pickListNumber;
  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsPickListUtilityItemCompleteSessionResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsPickListUtilityItemCompleteSessionResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsPickListUtilityItemCompleteSessionResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsPickListUtilityItemCompleteSessionResponse &&
            (identical(other.pickListId, pickListId) ||
                const DeepCollectionEquality()
                    .equals(other.pickListId, pickListId)) &&
            (identical(other.pickListNumber, pickListNumber) ||
                const DeepCollectionEquality()
                    .equals(other.pickListNumber, pickListNumber)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesHomeControlsPickListUtilityItemCompleteSessionResponseExtension
    on WebApiModulesHomeControlsPickListUtilityItemCompleteSessionResponse {
  WebApiModulesHomeControlsPickListUtilityItemCompleteSessionResponse copyWith(
      {String? pickListId,
      String? pickListNumber,
      int? status,
      bool? success,
      String? msg}) {
    return WebApiModulesHomeControlsPickListUtilityItemCompleteSessionResponse(
        pickListId: pickListId ?? this.pickListId,
        pickListNumber: pickListNumber ?? this.pickListNumber,
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsPickListUtilityItemPickListUtilityItem {
  WebApiModulesHomeControlsPickListUtilityItemPickListUtilityItem({
    this.sessionId,
    this.orderId,
    this.orderItemId,
    this.parentId,
    this.parentParentId,
    this.accessoryRatio,
    this.inventoryTypeId,
    this.inventoryType,
    this.inventoryTypeIdNoParent,
    this.orderNumber,
    this.locationId,
    this.departmentId,
    this.dealId,
    this.orderType,
    this.orderStatus,
    this.iCode,
    this.description,
    this.quantityOrdered,
    this.subQuantity,
    this.consignQuantity,
    this.quantityInLocation,
    this.pickDate,
    this.pickQuantity,
    this.stagedQuantity,
    this.outQuantity,
    this.remainingQuantity,
    this.pickedQuantity,
    this.inventoryId,
    this.warehouseId,
    this.warehouse,
    this.warehouseCode,
    this.recType,
    this.recTypeDisplay,
    this.itemClass,
    this.itemOrder,
    this.optionColor,
    this.itemId,
    this.barCode,
    this.serialNumber,
    this.subVendorId,
    this.consignorId,
    this.vendor,
    this.nestedOrderItemId,
    this.nestingLevel,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsPickListUtilityItemPickListUtilityItem.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsPickListUtilityItemPickListUtilityItemFromJson(
          json);

  @JsonKey(name: 'SessionId')
  final String? sessionId;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderItemId')
  final String? orderItemId;
  @JsonKey(name: 'ParentId')
  final String? parentId;
  @JsonKey(name: 'ParentParentId')
  final String? parentParentId;
  @JsonKey(name: 'AccessoryRatio')
  final double? accessoryRatio;
  @JsonKey(name: 'InventoryTypeId')
  final String? inventoryTypeId;
  @JsonKey(name: 'InventoryType')
  final String? inventoryType;
  @JsonKey(name: 'InventoryTypeIdNoParent')
  final String? inventoryTypeIdNoParent;
  @JsonKey(name: 'OrderNumber')
  final String? orderNumber;
  @JsonKey(name: 'LocationId')
  final String? locationId;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'OrderType')
  final String? orderType;
  @JsonKey(name: 'OrderStatus')
  final String? orderStatus;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'QuantityOrdered')
  final double? quantityOrdered;
  @JsonKey(name: 'SubQuantity')
  final double? subQuantity;
  @JsonKey(name: 'ConsignQuantity')
  final double? consignQuantity;
  @JsonKey(name: 'QuantityInLocation')
  final double? quantityInLocation;
  @JsonKey(name: 'PickDate')
  final String? pickDate;
  @JsonKey(name: 'PickQuantity')
  final double? pickQuantity;
  @JsonKey(name: 'StagedQuantity')
  final double? stagedQuantity;
  @JsonKey(name: 'OutQuantity')
  final double? outQuantity;
  @JsonKey(name: 'RemainingQuantity')
  final double? remainingQuantity;
  @JsonKey(name: 'PickedQuantity')
  final double? pickedQuantity;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'RecType')
  final String? recType;
  @JsonKey(name: 'RecTypeDisplay')
  final String? recTypeDisplay;
  @JsonKey(name: 'ItemClass')
  final String? itemClass;
  @JsonKey(name: 'ItemOrder')
  final String? itemOrder;
  @JsonKey(name: 'OptionColor')
  final bool? optionColor;
  @JsonKey(name: 'ItemId')
  final String? itemId;
  @JsonKey(name: 'BarCode')
  final String? barCode;
  @JsonKey(name: 'SerialNumber')
  final String? serialNumber;
  @JsonKey(name: 'SubVendorId')
  final String? subVendorId;
  @JsonKey(name: 'ConsignorId')
  final String? consignorId;
  @JsonKey(name: 'Vendor')
  final String? vendor;
  @JsonKey(name: 'NestedOrderItemId')
  final String? nestedOrderItemId;
  @JsonKey(name: 'NestingLevel')
  final int? nestingLevel;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsPickListUtilityItemPickListUtilityItemFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsPickListUtilityItemPickListUtilityItemToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsPickListUtilityItemPickListUtilityItemToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsPickListUtilityItemPickListUtilityItem &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderItemId, orderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.orderItemId, orderItemId)) &&
            (identical(other.parentId, parentId) ||
                const DeepCollectionEquality()
                    .equals(other.parentId, parentId)) &&
            (identical(other.parentParentId, parentParentId) ||
                const DeepCollectionEquality()
                    .equals(other.parentParentId, parentParentId)) &&
            (identical(other.accessoryRatio, accessoryRatio) ||
                const DeepCollectionEquality()
                    .equals(other.accessoryRatio, accessoryRatio)) &&
            (identical(other.inventoryTypeId, inventoryTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryTypeId, inventoryTypeId)) &&
            (identical(other.inventoryType, inventoryType) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryType, inventoryType)) &&
            (identical(other.inventoryTypeIdNoParent, inventoryTypeIdNoParent) ||
                const DeepCollectionEquality().equals(
                    other.inventoryTypeIdNoParent, inventoryTypeIdNoParent)) &&
            (identical(other.orderNumber, orderNumber) ||
                const DeepCollectionEquality()
                    .equals(other.orderNumber, orderNumber)) &&
            (identical(other.locationId, locationId) ||
                const DeepCollectionEquality()
                    .equals(other.locationId, locationId)) &&
            (identical(other.departmentId, departmentId) ||
                const DeepCollectionEquality()
                    .equals(other.departmentId, departmentId)) &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.orderType, orderType) ||
                const DeepCollectionEquality()
                    .equals(other.orderType, orderType)) &&
            (identical(other.orderStatus, orderStatus) ||
                const DeepCollectionEquality()
                    .equals(other.orderStatus, orderStatus)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) || const DeepCollectionEquality().equals(other.description, description)) &&
            (identical(other.quantityOrdered, quantityOrdered) || const DeepCollectionEquality().equals(other.quantityOrdered, quantityOrdered)) &&
            (identical(other.subQuantity, subQuantity) || const DeepCollectionEquality().equals(other.subQuantity, subQuantity)) &&
            (identical(other.consignQuantity, consignQuantity) || const DeepCollectionEquality().equals(other.consignQuantity, consignQuantity)) &&
            (identical(other.quantityInLocation, quantityInLocation) || const DeepCollectionEquality().equals(other.quantityInLocation, quantityInLocation)) &&
            (identical(other.pickDate, pickDate) || const DeepCollectionEquality().equals(other.pickDate, pickDate)) &&
            (identical(other.pickQuantity, pickQuantity) || const DeepCollectionEquality().equals(other.pickQuantity, pickQuantity)) &&
            (identical(other.stagedQuantity, stagedQuantity) || const DeepCollectionEquality().equals(other.stagedQuantity, stagedQuantity)) &&
            (identical(other.outQuantity, outQuantity) || const DeepCollectionEquality().equals(other.outQuantity, outQuantity)) &&
            (identical(other.remainingQuantity, remainingQuantity) || const DeepCollectionEquality().equals(other.remainingQuantity, remainingQuantity)) &&
            (identical(other.pickedQuantity, pickedQuantity) || const DeepCollectionEquality().equals(other.pickedQuantity, pickedQuantity)) &&
            (identical(other.inventoryId, inventoryId) || const DeepCollectionEquality().equals(other.inventoryId, inventoryId)) &&
            (identical(other.warehouseId, warehouseId) || const DeepCollectionEquality().equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouse, warehouse) || const DeepCollectionEquality().equals(other.warehouse, warehouse)) &&
            (identical(other.warehouseCode, warehouseCode) || const DeepCollectionEquality().equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.recType, recType) || const DeepCollectionEquality().equals(other.recType, recType)) &&
            (identical(other.recTypeDisplay, recTypeDisplay) || const DeepCollectionEquality().equals(other.recTypeDisplay, recTypeDisplay)) &&
            (identical(other.itemClass, itemClass) || const DeepCollectionEquality().equals(other.itemClass, itemClass)) &&
            (identical(other.itemOrder, itemOrder) || const DeepCollectionEquality().equals(other.itemOrder, itemOrder)) &&
            (identical(other.optionColor, optionColor) || const DeepCollectionEquality().equals(other.optionColor, optionColor)) &&
            (identical(other.itemId, itemId) || const DeepCollectionEquality().equals(other.itemId, itemId)) &&
            (identical(other.barCode, barCode) || const DeepCollectionEquality().equals(other.barCode, barCode)) &&
            (identical(other.serialNumber, serialNumber) || const DeepCollectionEquality().equals(other.serialNumber, serialNumber)) &&
            (identical(other.subVendorId, subVendorId) || const DeepCollectionEquality().equals(other.subVendorId, subVendorId)) &&
            (identical(other.consignorId, consignorId) || const DeepCollectionEquality().equals(other.consignorId, consignorId)) &&
            (identical(other.vendor, vendor) || const DeepCollectionEquality().equals(other.vendor, vendor)) &&
            (identical(other.nestedOrderItemId, nestedOrderItemId) || const DeepCollectionEquality().equals(other.nestedOrderItemId, nestedOrderItemId)) &&
            (identical(other.nestingLevel, nestingLevel) || const DeepCollectionEquality().equals(other.nestingLevel, nestingLevel)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsPickListUtilityItemPickListUtilityItemExtension
    on WebApiModulesHomeControlsPickListUtilityItemPickListUtilityItem {
  WebApiModulesHomeControlsPickListUtilityItemPickListUtilityItem copyWith(
      {String? sessionId,
      String? orderId,
      String? orderItemId,
      String? parentId,
      String? parentParentId,
      double? accessoryRatio,
      String? inventoryTypeId,
      String? inventoryType,
      String? inventoryTypeIdNoParent,
      String? orderNumber,
      String? locationId,
      String? departmentId,
      String? dealId,
      String? orderType,
      String? orderStatus,
      String? iCode,
      String? description,
      double? quantityOrdered,
      double? subQuantity,
      double? consignQuantity,
      double? quantityInLocation,
      String? pickDate,
      double? pickQuantity,
      double? stagedQuantity,
      double? outQuantity,
      double? remainingQuantity,
      double? pickedQuantity,
      String? inventoryId,
      String? warehouseId,
      String? warehouse,
      String? warehouseCode,
      String? recType,
      String? recTypeDisplay,
      String? itemClass,
      String? itemOrder,
      bool? optionColor,
      String? itemId,
      String? barCode,
      String? serialNumber,
      String? subVendorId,
      String? consignorId,
      String? vendor,
      String? nestedOrderItemId,
      int? nestingLevel,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsPickListUtilityItemPickListUtilityItem(
        sessionId: sessionId ?? this.sessionId,
        orderId: orderId ?? this.orderId,
        orderItemId: orderItemId ?? this.orderItemId,
        parentId: parentId ?? this.parentId,
        parentParentId: parentParentId ?? this.parentParentId,
        accessoryRatio: accessoryRatio ?? this.accessoryRatio,
        inventoryTypeId: inventoryTypeId ?? this.inventoryTypeId,
        inventoryType: inventoryType ?? this.inventoryType,
        inventoryTypeIdNoParent:
            inventoryTypeIdNoParent ?? this.inventoryTypeIdNoParent,
        orderNumber: orderNumber ?? this.orderNumber,
        locationId: locationId ?? this.locationId,
        departmentId: departmentId ?? this.departmentId,
        dealId: dealId ?? this.dealId,
        orderType: orderType ?? this.orderType,
        orderStatus: orderStatus ?? this.orderStatus,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        quantityOrdered: quantityOrdered ?? this.quantityOrdered,
        subQuantity: subQuantity ?? this.subQuantity,
        consignQuantity: consignQuantity ?? this.consignQuantity,
        quantityInLocation: quantityInLocation ?? this.quantityInLocation,
        pickDate: pickDate ?? this.pickDate,
        pickQuantity: pickQuantity ?? this.pickQuantity,
        stagedQuantity: stagedQuantity ?? this.stagedQuantity,
        outQuantity: outQuantity ?? this.outQuantity,
        remainingQuantity: remainingQuantity ?? this.remainingQuantity,
        pickedQuantity: pickedQuantity ?? this.pickedQuantity,
        inventoryId: inventoryId ?? this.inventoryId,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouse: warehouse ?? this.warehouse,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        recType: recType ?? this.recType,
        recTypeDisplay: recTypeDisplay ?? this.recTypeDisplay,
        itemClass: itemClass ?? this.itemClass,
        itemOrder: itemOrder ?? this.itemOrder,
        optionColor: optionColor ?? this.optionColor,
        itemId: itemId ?? this.itemId,
        barCode: barCode ?? this.barCode,
        serialNumber: serialNumber ?? this.serialNumber,
        subVendorId: subVendorId ?? this.subVendorId,
        consignorId: consignorId ?? this.consignorId,
        vendor: vendor ?? this.vendor,
        nestedOrderItemId: nestedOrderItemId ?? this.nestedOrderItemId,
        nestingLevel: nestingLevel ?? this.nestingLevel,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsPickListUtilityItemStartSessionRequest {
  WebApiModulesHomeControlsPickListUtilityItemStartSessionRequest({
    this.orderId,
  });

  factory WebApiModulesHomeControlsPickListUtilityItemStartSessionRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsPickListUtilityItemStartSessionRequestFromJson(
          json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsPickListUtilityItemStartSessionRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsPickListUtilityItemStartSessionRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsPickListUtilityItemStartSessionRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsPickListUtilityItemStartSessionRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality().equals(other.orderId, orderId)));
  }
}

extension $WebApiModulesHomeControlsPickListUtilityItemStartSessionRequestExtension
    on WebApiModulesHomeControlsPickListUtilityItemStartSessionRequest {
  WebApiModulesHomeControlsPickListUtilityItemStartSessionRequest copyWith(
      {String? orderId}) {
    return WebApiModulesHomeControlsPickListUtilityItemStartSessionRequest(
        orderId: orderId ?? this.orderId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsPickListUtilityItemStartSessionResponse {
  WebApiModulesHomeControlsPickListUtilityItemStartSessionResponse({
    this.sessionId,
    this.inventoryTypes,
    this.inventoryTypeIds,
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesHomeControlsPickListUtilityItemStartSessionResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsPickListUtilityItemStartSessionResponseFromJson(
          json);

  @JsonKey(name: 'SessionId')
  final String? sessionId;
  @JsonKey(name: 'InventoryTypes')
  final String? inventoryTypes;
  @JsonKey(name: 'InventoryTypeIds')
  final String? inventoryTypeIds;
  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsPickListUtilityItemStartSessionResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsPickListUtilityItemStartSessionResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsPickListUtilityItemStartSessionResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsPickListUtilityItemStartSessionResponse &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)) &&
            (identical(other.inventoryTypes, inventoryTypes) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryTypes, inventoryTypes)) &&
            (identical(other.inventoryTypeIds, inventoryTypeIds) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryTypeIds, inventoryTypeIds)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesHomeControlsPickListUtilityItemStartSessionResponseExtension
    on WebApiModulesHomeControlsPickListUtilityItemStartSessionResponse {
  WebApiModulesHomeControlsPickListUtilityItemStartSessionResponse copyWith(
      {String? sessionId,
      String? inventoryTypes,
      String? inventoryTypeIds,
      int? status,
      bool? success,
      String? msg}) {
    return WebApiModulesHomeControlsPickListUtilityItemStartSessionResponse(
        sessionId: sessionId ?? this.sessionId,
        inventoryTypes: inventoryTypes ?? this.inventoryTypes,
        inventoryTypeIds: inventoryTypeIds ?? this.inventoryTypeIds,
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsPricingPricing {
  WebApiModulesHomeControlsPricingPricing({
    this.inventoryId,
    this.rateId,
    this.warehouseId,
    this.warehouse,
    this.warehouseCode,
    this.warehouseDefaultCurrencyId,
    this.currencyId,
    this.currencyCode,
    this.currencySymbol,
    this.isCurrencyDefined,
    this.defaultPurchaseCurrencyId,
    this.convertFromCurrencyId,
    this.hourlyRate,
    this.dailyRate,
    this.weeklyRate,
    this.week2Rate,
    this.week3Rate,
    this.week4Rate,
    this.week5Rate,
    this.monthlyRate,
    this.seriesRate,
    this.year2LeaseRate,
    this.year3LeaseRate,
    this.year4LeaseRate,
    this.hourlyMarkup,
    this.dailyMarkup,
    this.weeklyMarkup,
    this.monthlyMarkup,
    this.retail,
    this.price,
    this.cost,
    this.hourlyCost,
    this.dailyCost,
    this.weeklyCost,
    this.monthlyCost,
    this.defaultCost,
    this.defaultCostConverted,
    this.markup,
    this.markupCostBasis,
    this.classification,
    this.maximumDiscount,
    this.maxDaysPerWeek,
    this.minimumDaysPerWeek,
    this.availableFor,
    this.defaultRentalRates,
    this.defaultDailyRate,
    this.defaultWeeklyRate,
    this.hours,
    this.hasTieredCost,
    this.replacementCost,
    this.unitValue,
    this.replacementCostConverted,
    this.unitCostConverted,
    this.markupReplacementCost,
    this.replacementCostMarkupPercent,
    this.restockingFee,
    this.restockingPercent,
    this.calculateMonthlyRate,
    this.calculateSeriesWeeklyRate,
    this.calculate2YearLeaseWeeklyRate,
    this.calculate3YearLeaseWeeklyRate,
    this.warehouseOrderBy,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsPricingPricing.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsPricingPricingFromJson(json);

  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'RateId')
  final String? rateId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'WarehouseDefaultCurrencyId')
  final String? warehouseDefaultCurrencyId;
  @JsonKey(name: 'CurrencyId')
  final String? currencyId;
  @JsonKey(name: 'CurrencyCode')
  final String? currencyCode;
  @JsonKey(name: 'CurrencySymbol')
  final String? currencySymbol;
  @JsonKey(name: 'IsCurrencyDefined')
  final bool? isCurrencyDefined;
  @JsonKey(name: 'DefaultPurchaseCurrencyId')
  final String? defaultPurchaseCurrencyId;
  @JsonKey(name: 'ConvertFromCurrencyId')
  final String? convertFromCurrencyId;
  @JsonKey(name: 'HourlyRate')
  final double? hourlyRate;
  @JsonKey(name: 'DailyRate')
  final double? dailyRate;
  @JsonKey(name: 'WeeklyRate')
  final double? weeklyRate;
  @JsonKey(name: 'Week2Rate')
  final double? week2Rate;
  @JsonKey(name: 'Week3Rate')
  final double? week3Rate;
  @JsonKey(name: 'Week4Rate')
  final double? week4Rate;
  @JsonKey(name: 'Week5Rate')
  final double? week5Rate;
  @JsonKey(name: 'MonthlyRate')
  final double? monthlyRate;
  @JsonKey(name: 'SeriesRate')
  final double? seriesRate;
  @JsonKey(name: 'Year2LeaseRate')
  final double? year2LeaseRate;
  @JsonKey(name: 'Year3LeaseRate')
  final double? year3LeaseRate;
  @JsonKey(name: 'Year4LeaseRate')
  final double? year4LeaseRate;
  @JsonKey(name: 'HourlyMarkup')
  final double? hourlyMarkup;
  @JsonKey(name: 'DailyMarkup')
  final double? dailyMarkup;
  @JsonKey(name: 'WeeklyMarkup')
  final double? weeklyMarkup;
  @JsonKey(name: 'MonthlyMarkup')
  final double? monthlyMarkup;
  @JsonKey(name: 'Retail')
  final double? retail;
  @JsonKey(name: 'Price')
  final double? price;
  @JsonKey(name: 'Cost')
  final double? cost;
  @JsonKey(name: 'HourlyCost')
  final double? hourlyCost;
  @JsonKey(name: 'DailyCost')
  final double? dailyCost;
  @JsonKey(name: 'WeeklyCost')
  final double? weeklyCost;
  @JsonKey(name: 'MonthlyCost')
  final double? monthlyCost;
  @JsonKey(name: 'DefaultCost')
  final double? defaultCost;
  @JsonKey(name: 'DefaultCostConverted')
  final double? defaultCostConverted;
  @JsonKey(name: 'Markup')
  final double? markup;
  @JsonKey(name: 'MarkupCostBasis')
  final double? markupCostBasis;
  @JsonKey(name: 'Classification')
  final String? classification;
  @JsonKey(name: 'MaximumDiscount')
  final double? maximumDiscount;
  @JsonKey(name: 'MaxDaysPerWeek')
  final double? maxDaysPerWeek;
  @JsonKey(name: 'MinimumDaysPerWeek')
  final double? minimumDaysPerWeek;
  @JsonKey(name: 'AvailableFor')
  final String? availableFor;
  @JsonKey(name: 'DefaultRentalRates')
  final bool? defaultRentalRates;
  @JsonKey(name: 'DefaultDailyRate')
  final double? defaultDailyRate;
  @JsonKey(name: 'DefaultWeeklyRate')
  final double? defaultWeeklyRate;
  @JsonKey(name: 'Hours')
  final String? hours;
  @JsonKey(name: 'HasTieredCost')
  final bool? hasTieredCost;
  @JsonKey(name: 'ReplacementCost')
  final double? replacementCost;
  @JsonKey(name: 'UnitValue')
  final double? unitValue;
  @JsonKey(name: 'ReplacementCostConverted')
  final double? replacementCostConverted;
  @JsonKey(name: 'UnitCostConverted')
  final double? unitCostConverted;
  @JsonKey(name: 'MarkupReplacementCost')
  final bool? markupReplacementCost;
  @JsonKey(name: 'ReplacementCostMarkupPercent')
  final double? replacementCostMarkupPercent;
  @JsonKey(name: 'RestockingFee')
  final double? restockingFee;
  @JsonKey(name: 'RestockingPercent')
  final double? restockingPercent;
  @JsonKey(name: 'CalculateMonthlyRate')
  final bool? calculateMonthlyRate;
  @JsonKey(name: 'CalculateSeriesWeeklyRate')
  final bool? calculateSeriesWeeklyRate;
  @JsonKey(name: 'Calculate2YearLeaseWeeklyRate')
  final bool? calculate2YearLeaseWeeklyRate;
  @JsonKey(name: 'Calculate3YearLeaseWeeklyRate')
  final bool? calculate3YearLeaseWeeklyRate;
  @JsonKey(name: 'WarehouseOrderBy')
  final int? warehouseOrderBy;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsPricingPricingFromJson;
  static const toJsonFactory = _$WebApiModulesHomeControlsPricingPricingToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsPricingPricingToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsPricingPricing &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.rateId, rateId) ||
                const DeepCollectionEquality().equals(other.rateId, rateId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouse, warehouse) ||
                const DeepCollectionEquality()
                    .equals(other.warehouse, warehouse)) &&
            (identical(other.warehouseCode, warehouseCode) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.warehouseDefaultCurrencyId, warehouseDefaultCurrencyId) ||
                const DeepCollectionEquality().equals(
                    other.warehouseDefaultCurrencyId,
                    warehouseDefaultCurrencyId)) &&
            (identical(other.currencyId, currencyId) ||
                const DeepCollectionEquality()
                    .equals(other.currencyId, currencyId)) &&
            (identical(other.currencyCode, currencyCode) ||
                const DeepCollectionEquality()
                    .equals(other.currencyCode, currencyCode)) &&
            (identical(other.currencySymbol, currencySymbol) ||
                const DeepCollectionEquality()
                    .equals(other.currencySymbol, currencySymbol)) &&
            (identical(other.isCurrencyDefined, isCurrencyDefined) ||
                const DeepCollectionEquality()
                    .equals(other.isCurrencyDefined, isCurrencyDefined)) &&
            (identical(other.defaultPurchaseCurrencyId, defaultPurchaseCurrencyId) ||
                const DeepCollectionEquality().equals(
                    other.defaultPurchaseCurrencyId,
                    defaultPurchaseCurrencyId)) &&
            (identical(other.convertFromCurrencyId, convertFromCurrencyId) ||
                const DeepCollectionEquality().equals(
                    other.convertFromCurrencyId, convertFromCurrencyId)) &&
            (identical(other.hourlyRate, hourlyRate) ||
                const DeepCollectionEquality()
                    .equals(other.hourlyRate, hourlyRate)) &&
            (identical(other.dailyRate, dailyRate) ||
                const DeepCollectionEquality()
                    .equals(other.dailyRate, dailyRate)) &&
            (identical(other.weeklyRate, weeklyRate) ||
                const DeepCollectionEquality()
                    .equals(other.weeklyRate, weeklyRate)) &&
            (identical(other.week2Rate, week2Rate) ||
                const DeepCollectionEquality()
                    .equals(other.week2Rate, week2Rate)) &&
            (identical(other.week3Rate, week3Rate) || const DeepCollectionEquality().equals(other.week3Rate, week3Rate)) &&
            (identical(other.week4Rate, week4Rate) || const DeepCollectionEquality().equals(other.week4Rate, week4Rate)) &&
            (identical(other.week5Rate, week5Rate) || const DeepCollectionEquality().equals(other.week5Rate, week5Rate)) &&
            (identical(other.monthlyRate, monthlyRate) || const DeepCollectionEquality().equals(other.monthlyRate, monthlyRate)) &&
            (identical(other.seriesRate, seriesRate) || const DeepCollectionEquality().equals(other.seriesRate, seriesRate)) &&
            (identical(other.year2LeaseRate, year2LeaseRate) || const DeepCollectionEquality().equals(other.year2LeaseRate, year2LeaseRate)) &&
            (identical(other.year3LeaseRate, year3LeaseRate) || const DeepCollectionEquality().equals(other.year3LeaseRate, year3LeaseRate)) &&
            (identical(other.year4LeaseRate, year4LeaseRate) || const DeepCollectionEquality().equals(other.year4LeaseRate, year4LeaseRate)) &&
            (identical(other.hourlyMarkup, hourlyMarkup) || const DeepCollectionEquality().equals(other.hourlyMarkup, hourlyMarkup)) &&
            (identical(other.dailyMarkup, dailyMarkup) || const DeepCollectionEquality().equals(other.dailyMarkup, dailyMarkup)) &&
            (identical(other.weeklyMarkup, weeklyMarkup) || const DeepCollectionEquality().equals(other.weeklyMarkup, weeklyMarkup)) &&
            (identical(other.monthlyMarkup, monthlyMarkup) || const DeepCollectionEquality().equals(other.monthlyMarkup, monthlyMarkup)) &&
            (identical(other.retail, retail) || const DeepCollectionEquality().equals(other.retail, retail)) &&
            (identical(other.price, price) || const DeepCollectionEquality().equals(other.price, price)) &&
            (identical(other.cost, cost) || const DeepCollectionEquality().equals(other.cost, cost)) &&
            (identical(other.hourlyCost, hourlyCost) || const DeepCollectionEquality().equals(other.hourlyCost, hourlyCost)) &&
            (identical(other.dailyCost, dailyCost) || const DeepCollectionEquality().equals(other.dailyCost, dailyCost)) &&
            (identical(other.weeklyCost, weeklyCost) || const DeepCollectionEquality().equals(other.weeklyCost, weeklyCost)) &&
            (identical(other.monthlyCost, monthlyCost) || const DeepCollectionEquality().equals(other.monthlyCost, monthlyCost)) &&
            (identical(other.defaultCost, defaultCost) || const DeepCollectionEquality().equals(other.defaultCost, defaultCost)) &&
            (identical(other.defaultCostConverted, defaultCostConverted) || const DeepCollectionEquality().equals(other.defaultCostConverted, defaultCostConverted)) &&
            (identical(other.markup, markup) || const DeepCollectionEquality().equals(other.markup, markup)) &&
            (identical(other.markupCostBasis, markupCostBasis) || const DeepCollectionEquality().equals(other.markupCostBasis, markupCostBasis)) &&
            (identical(other.classification, classification) || const DeepCollectionEquality().equals(other.classification, classification)) &&
            (identical(other.maximumDiscount, maximumDiscount) || const DeepCollectionEquality().equals(other.maximumDiscount, maximumDiscount)) &&
            (identical(other.maxDaysPerWeek, maxDaysPerWeek) || const DeepCollectionEquality().equals(other.maxDaysPerWeek, maxDaysPerWeek)) &&
            (identical(other.minimumDaysPerWeek, minimumDaysPerWeek) || const DeepCollectionEquality().equals(other.minimumDaysPerWeek, minimumDaysPerWeek)) &&
            (identical(other.availableFor, availableFor) || const DeepCollectionEquality().equals(other.availableFor, availableFor)) &&
            (identical(other.defaultRentalRates, defaultRentalRates) || const DeepCollectionEquality().equals(other.defaultRentalRates, defaultRentalRates)) &&
            (identical(other.defaultDailyRate, defaultDailyRate) || const DeepCollectionEquality().equals(other.defaultDailyRate, defaultDailyRate)) &&
            (identical(other.defaultWeeklyRate, defaultWeeklyRate) || const DeepCollectionEquality().equals(other.defaultWeeklyRate, defaultWeeklyRate)) &&
            (identical(other.hours, hours) || const DeepCollectionEquality().equals(other.hours, hours)) &&
            (identical(other.hasTieredCost, hasTieredCost) || const DeepCollectionEquality().equals(other.hasTieredCost, hasTieredCost)) &&
            (identical(other.replacementCost, replacementCost) || const DeepCollectionEquality().equals(other.replacementCost, replacementCost)) &&
            (identical(other.unitValue, unitValue) || const DeepCollectionEquality().equals(other.unitValue, unitValue)) &&
            (identical(other.replacementCostConverted, replacementCostConverted) || const DeepCollectionEquality().equals(other.replacementCostConverted, replacementCostConverted)) &&
            (identical(other.unitCostConverted, unitCostConverted) || const DeepCollectionEquality().equals(other.unitCostConverted, unitCostConverted)) &&
            (identical(other.markupReplacementCost, markupReplacementCost) || const DeepCollectionEquality().equals(other.markupReplacementCost, markupReplacementCost)) &&
            (identical(other.replacementCostMarkupPercent, replacementCostMarkupPercent) || const DeepCollectionEquality().equals(other.replacementCostMarkupPercent, replacementCostMarkupPercent)) &&
            (identical(other.restockingFee, restockingFee) || const DeepCollectionEquality().equals(other.restockingFee, restockingFee)) &&
            (identical(other.restockingPercent, restockingPercent) || const DeepCollectionEquality().equals(other.restockingPercent, restockingPercent)) &&
            (identical(other.calculateMonthlyRate, calculateMonthlyRate) || const DeepCollectionEquality().equals(other.calculateMonthlyRate, calculateMonthlyRate)) &&
            (identical(other.calculateSeriesWeeklyRate, calculateSeriesWeeklyRate) || const DeepCollectionEquality().equals(other.calculateSeriesWeeklyRate, calculateSeriesWeeklyRate)) &&
            (identical(other.calculate2YearLeaseWeeklyRate, calculate2YearLeaseWeeklyRate) || const DeepCollectionEquality().equals(other.calculate2YearLeaseWeeklyRate, calculate2YearLeaseWeeklyRate)) &&
            (identical(other.calculate3YearLeaseWeeklyRate, calculate3YearLeaseWeeklyRate) || const DeepCollectionEquality().equals(other.calculate3YearLeaseWeeklyRate, calculate3YearLeaseWeeklyRate)) &&
            (identical(other.warehouseOrderBy, warehouseOrderBy) || const DeepCollectionEquality().equals(other.warehouseOrderBy, warehouseOrderBy)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsPricingPricingExtension
    on WebApiModulesHomeControlsPricingPricing {
  WebApiModulesHomeControlsPricingPricing copyWith(
      {String? inventoryId,
      String? rateId,
      String? warehouseId,
      String? warehouse,
      String? warehouseCode,
      String? warehouseDefaultCurrencyId,
      String? currencyId,
      String? currencyCode,
      String? currencySymbol,
      bool? isCurrencyDefined,
      String? defaultPurchaseCurrencyId,
      String? convertFromCurrencyId,
      double? hourlyRate,
      double? dailyRate,
      double? weeklyRate,
      double? week2Rate,
      double? week3Rate,
      double? week4Rate,
      double? week5Rate,
      double? monthlyRate,
      double? seriesRate,
      double? year2LeaseRate,
      double? year3LeaseRate,
      double? year4LeaseRate,
      double? hourlyMarkup,
      double? dailyMarkup,
      double? weeklyMarkup,
      double? monthlyMarkup,
      double? retail,
      double? price,
      double? cost,
      double? hourlyCost,
      double? dailyCost,
      double? weeklyCost,
      double? monthlyCost,
      double? defaultCost,
      double? defaultCostConverted,
      double? markup,
      double? markupCostBasis,
      String? classification,
      double? maximumDiscount,
      double? maxDaysPerWeek,
      double? minimumDaysPerWeek,
      String? availableFor,
      bool? defaultRentalRates,
      double? defaultDailyRate,
      double? defaultWeeklyRate,
      String? hours,
      bool? hasTieredCost,
      double? replacementCost,
      double? unitValue,
      double? replacementCostConverted,
      double? unitCostConverted,
      bool? markupReplacementCost,
      double? replacementCostMarkupPercent,
      double? restockingFee,
      double? restockingPercent,
      bool? calculateMonthlyRate,
      bool? calculateSeriesWeeklyRate,
      bool? calculate2YearLeaseWeeklyRate,
      bool? calculate3YearLeaseWeeklyRate,
      int? warehouseOrderBy,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsPricingPricing(
        inventoryId: inventoryId ?? this.inventoryId,
        rateId: rateId ?? this.rateId,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouse: warehouse ?? this.warehouse,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        warehouseDefaultCurrencyId:
            warehouseDefaultCurrencyId ?? this.warehouseDefaultCurrencyId,
        currencyId: currencyId ?? this.currencyId,
        currencyCode: currencyCode ?? this.currencyCode,
        currencySymbol: currencySymbol ?? this.currencySymbol,
        isCurrencyDefined: isCurrencyDefined ?? this.isCurrencyDefined,
        defaultPurchaseCurrencyId:
            defaultPurchaseCurrencyId ?? this.defaultPurchaseCurrencyId,
        convertFromCurrencyId:
            convertFromCurrencyId ?? this.convertFromCurrencyId,
        hourlyRate: hourlyRate ?? this.hourlyRate,
        dailyRate: dailyRate ?? this.dailyRate,
        weeklyRate: weeklyRate ?? this.weeklyRate,
        week2Rate: week2Rate ?? this.week2Rate,
        week3Rate: week3Rate ?? this.week3Rate,
        week4Rate: week4Rate ?? this.week4Rate,
        week5Rate: week5Rate ?? this.week5Rate,
        monthlyRate: monthlyRate ?? this.monthlyRate,
        seriesRate: seriesRate ?? this.seriesRate,
        year2LeaseRate: year2LeaseRate ?? this.year2LeaseRate,
        year3LeaseRate: year3LeaseRate ?? this.year3LeaseRate,
        year4LeaseRate: year4LeaseRate ?? this.year4LeaseRate,
        hourlyMarkup: hourlyMarkup ?? this.hourlyMarkup,
        dailyMarkup: dailyMarkup ?? this.dailyMarkup,
        weeklyMarkup: weeklyMarkup ?? this.weeklyMarkup,
        monthlyMarkup: monthlyMarkup ?? this.monthlyMarkup,
        retail: retail ?? this.retail,
        price: price ?? this.price,
        cost: cost ?? this.cost,
        hourlyCost: hourlyCost ?? this.hourlyCost,
        dailyCost: dailyCost ?? this.dailyCost,
        weeklyCost: weeklyCost ?? this.weeklyCost,
        monthlyCost: monthlyCost ?? this.monthlyCost,
        defaultCost: defaultCost ?? this.defaultCost,
        defaultCostConverted: defaultCostConverted ?? this.defaultCostConverted,
        markup: markup ?? this.markup,
        markupCostBasis: markupCostBasis ?? this.markupCostBasis,
        classification: classification ?? this.classification,
        maximumDiscount: maximumDiscount ?? this.maximumDiscount,
        maxDaysPerWeek: maxDaysPerWeek ?? this.maxDaysPerWeek,
        minimumDaysPerWeek: minimumDaysPerWeek ?? this.minimumDaysPerWeek,
        availableFor: availableFor ?? this.availableFor,
        defaultRentalRates: defaultRentalRates ?? this.defaultRentalRates,
        defaultDailyRate: defaultDailyRate ?? this.defaultDailyRate,
        defaultWeeklyRate: defaultWeeklyRate ?? this.defaultWeeklyRate,
        hours: hours ?? this.hours,
        hasTieredCost: hasTieredCost ?? this.hasTieredCost,
        replacementCost: replacementCost ?? this.replacementCost,
        unitValue: unitValue ?? this.unitValue,
        replacementCostConverted:
            replacementCostConverted ?? this.replacementCostConverted,
        unitCostConverted: unitCostConverted ?? this.unitCostConverted,
        markupReplacementCost:
            markupReplacementCost ?? this.markupReplacementCost,
        replacementCostMarkupPercent:
            replacementCostMarkupPercent ?? this.replacementCostMarkupPercent,
        restockingFee: restockingFee ?? this.restockingFee,
        restockingPercent: restockingPercent ?? this.restockingPercent,
        calculateMonthlyRate: calculateMonthlyRate ?? this.calculateMonthlyRate,
        calculateSeriesWeeklyRate:
            calculateSeriesWeeklyRate ?? this.calculateSeriesWeeklyRate,
        calculate2YearLeaseWeeklyRate:
            calculate2YearLeaseWeeklyRate ?? this.calculate2YearLeaseWeeklyRate,
        calculate3YearLeaseWeeklyRate:
            calculate3YearLeaseWeeklyRate ?? this.calculate3YearLeaseWeeklyRate,
        warehouseOrderBy: warehouseOrderBy ?? this.warehouseOrderBy,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsProjectContactProjectContact {
  WebApiModulesHomeControlsProjectContactProjectContact({
    this.projectContactId,
    this.projectId,
    this.contactId,
    this.nameFml,
    this.nameLfm,
    this.person,
    this.personColor,
    this.firstName,
    this.middleInitial,
    this.lastName,
    this.contactTitle,
    this.officePhone,
    this.officeExtension,
    this.mobilePhone,
    this.email,
    this.pager,
    this.pagerPin,
    this.jobTitle,
    this.contactTitleId,
    this.companyContactId,
    this.companyId,
    this.isPrimary,
    this.countryId,
    this.isProjectFor,
    this.isProductionContact,
    this.isPrintable,
    this.contactOnProject,
    this.inactive,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsProjectContactProjectContact.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsProjectContactProjectContactFromJson(json);

  @JsonKey(name: 'ProjectContactId')
  final int? projectContactId;
  @JsonKey(name: 'ProjectId')
  final String? projectId;
  @JsonKey(name: 'ContactId')
  final String? contactId;
  @JsonKey(name: 'NameFml')
  final String? nameFml;
  @JsonKey(name: 'NameLfm')
  final String? nameLfm;
  @JsonKey(name: 'Person')
  final String? person;
  @JsonKey(name: 'PersonColor')
  final String? personColor;
  @JsonKey(name: 'FirstName')
  final String? firstName;
  @JsonKey(name: 'MiddleInitial')
  final String? middleInitial;
  @JsonKey(name: 'LastName')
  final String? lastName;
  @JsonKey(name: 'ContactTitle')
  final String? contactTitle;
  @JsonKey(name: 'OfficePhone')
  final String? officePhone;
  @JsonKey(name: 'OfficeExtension')
  final String? officeExtension;
  @JsonKey(name: 'MobilePhone')
  final String? mobilePhone;
  @JsonKey(name: 'Email')
  final String? email;
  @JsonKey(name: 'Pager')
  final String? pager;
  @JsonKey(name: 'PagerPin')
  final String? pagerPin;
  @JsonKey(name: 'JobTitle')
  final String? jobTitle;
  @JsonKey(name: 'ContactTitleId')
  final String? contactTitleId;
  @JsonKey(name: 'CompanyContactId')
  final String? companyContactId;
  @JsonKey(name: 'CompanyId')
  final String? companyId;
  @JsonKey(name: 'IsPrimary')
  final bool? isPrimary;
  @JsonKey(name: 'CountryId')
  final String? countryId;
  @JsonKey(name: 'IsProjectFor')
  final bool? isProjectFor;
  @JsonKey(name: 'IsProductionContact')
  final bool? isProductionContact;
  @JsonKey(name: 'IsPrintable')
  final bool? isPrintable;
  @JsonKey(name: 'ContactOnProject')
  final bool? contactOnProject;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsProjectContactProjectContactFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsProjectContactProjectContactToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsProjectContactProjectContactToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsProjectContactProjectContact &&
            (identical(other.projectContactId, projectContactId) ||
                const DeepCollectionEquality()
                    .equals(other.projectContactId, projectContactId)) &&
            (identical(other.projectId, projectId) ||
                const DeepCollectionEquality()
                    .equals(other.projectId, projectId)) &&
            (identical(other.contactId, contactId) ||
                const DeepCollectionEquality()
                    .equals(other.contactId, contactId)) &&
            (identical(other.nameFml, nameFml) ||
                const DeepCollectionEquality()
                    .equals(other.nameFml, nameFml)) &&
            (identical(other.nameLfm, nameLfm) ||
                const DeepCollectionEquality()
                    .equals(other.nameLfm, nameLfm)) &&
            (identical(other.person, person) ||
                const DeepCollectionEquality().equals(other.person, person)) &&
            (identical(other.personColor, personColor) ||
                const DeepCollectionEquality()
                    .equals(other.personColor, personColor)) &&
            (identical(other.firstName, firstName) ||
                const DeepCollectionEquality()
                    .equals(other.firstName, firstName)) &&
            (identical(other.middleInitial, middleInitial) ||
                const DeepCollectionEquality()
                    .equals(other.middleInitial, middleInitial)) &&
            (identical(other.lastName, lastName) ||
                const DeepCollectionEquality()
                    .equals(other.lastName, lastName)) &&
            (identical(other.contactTitle, contactTitle) ||
                const DeepCollectionEquality()
                    .equals(other.contactTitle, contactTitle)) &&
            (identical(other.officePhone, officePhone) ||
                const DeepCollectionEquality()
                    .equals(other.officePhone, officePhone)) &&
            (identical(other.officeExtension, officeExtension) ||
                const DeepCollectionEquality()
                    .equals(other.officeExtension, officeExtension)) &&
            (identical(other.mobilePhone, mobilePhone) ||
                const DeepCollectionEquality()
                    .equals(other.mobilePhone, mobilePhone)) &&
            (identical(other.email, email) ||
                const DeepCollectionEquality().equals(other.email, email)) &&
            (identical(other.pager, pager) ||
                const DeepCollectionEquality().equals(other.pager, pager)) &&
            (identical(other.pagerPin, pagerPin) ||
                const DeepCollectionEquality()
                    .equals(other.pagerPin, pagerPin)) &&
            (identical(other.jobTitle, jobTitle) ||
                const DeepCollectionEquality()
                    .equals(other.jobTitle, jobTitle)) &&
            (identical(other.contactTitleId, contactTitleId) ||
                const DeepCollectionEquality()
                    .equals(other.contactTitleId, contactTitleId)) &&
            (identical(other.companyContactId, companyContactId) ||
                const DeepCollectionEquality()
                    .equals(other.companyContactId, companyContactId)) &&
            (identical(other.companyId, companyId) ||
                const DeepCollectionEquality()
                    .equals(other.companyId, companyId)) &&
            (identical(other.isPrimary, isPrimary) ||
                const DeepCollectionEquality()
                    .equals(other.isPrimary, isPrimary)) &&
            (identical(other.countryId, countryId) ||
                const DeepCollectionEquality()
                    .equals(other.countryId, countryId)) &&
            (identical(other.isProjectFor, isProjectFor) || const DeepCollectionEquality().equals(other.isProjectFor, isProjectFor)) &&
            (identical(other.isProductionContact, isProductionContact) || const DeepCollectionEquality().equals(other.isProductionContact, isProductionContact)) &&
            (identical(other.isPrintable, isPrintable) || const DeepCollectionEquality().equals(other.isPrintable, isPrintable)) &&
            (identical(other.contactOnProject, contactOnProject) || const DeepCollectionEquality().equals(other.contactOnProject, contactOnProject)) &&
            (identical(other.inactive, inactive) || const DeepCollectionEquality().equals(other.inactive, inactive)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsProjectContactProjectContactExtension
    on WebApiModulesHomeControlsProjectContactProjectContact {
  WebApiModulesHomeControlsProjectContactProjectContact copyWith(
      {int? projectContactId,
      String? projectId,
      String? contactId,
      String? nameFml,
      String? nameLfm,
      String? person,
      String? personColor,
      String? firstName,
      String? middleInitial,
      String? lastName,
      String? contactTitle,
      String? officePhone,
      String? officeExtension,
      String? mobilePhone,
      String? email,
      String? pager,
      String? pagerPin,
      String? jobTitle,
      String? contactTitleId,
      String? companyContactId,
      String? companyId,
      bool? isPrimary,
      String? countryId,
      bool? isProjectFor,
      bool? isProductionContact,
      bool? isPrintable,
      bool? contactOnProject,
      bool? inactive,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsProjectContactProjectContact(
        projectContactId: projectContactId ?? this.projectContactId,
        projectId: projectId ?? this.projectId,
        contactId: contactId ?? this.contactId,
        nameFml: nameFml ?? this.nameFml,
        nameLfm: nameLfm ?? this.nameLfm,
        person: person ?? this.person,
        personColor: personColor ?? this.personColor,
        firstName: firstName ?? this.firstName,
        middleInitial: middleInitial ?? this.middleInitial,
        lastName: lastName ?? this.lastName,
        contactTitle: contactTitle ?? this.contactTitle,
        officePhone: officePhone ?? this.officePhone,
        officeExtension: officeExtension ?? this.officeExtension,
        mobilePhone: mobilePhone ?? this.mobilePhone,
        email: email ?? this.email,
        pager: pager ?? this.pager,
        pagerPin: pagerPin ?? this.pagerPin,
        jobTitle: jobTitle ?? this.jobTitle,
        contactTitleId: contactTitleId ?? this.contactTitleId,
        companyContactId: companyContactId ?? this.companyContactId,
        companyId: companyId ?? this.companyId,
        isPrimary: isPrimary ?? this.isPrimary,
        countryId: countryId ?? this.countryId,
        isProjectFor: isProjectFor ?? this.isProjectFor,
        isProductionContact: isProductionContact ?? this.isProductionContact,
        isPrintable: isPrintable ?? this.isPrintable,
        contactOnProject: contactOnProject ?? this.contactOnProject,
        inactive: inactive ?? this.inactive,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsProjectNoteProjectNote {
  WebApiModulesHomeControlsProjectNoteProjectNote({
    this.projectNoteId,
    this.projectId,
    this.noteDate,
    this.userId,
    this.notesDescription,
    this.printOnProject,
    this.userName,
    this.notes,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsProjectNoteProjectNote.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsProjectNoteProjectNoteFromJson(json);

  @JsonKey(name: 'ProjectNoteId')
  final String? projectNoteId;
  @JsonKey(name: 'ProjectId')
  final String? projectId;
  @JsonKey(name: 'NoteDate')
  final String? noteDate;
  @JsonKey(name: 'UserId')
  final String? userId;
  @JsonKey(name: 'NotesDescription')
  final String? notesDescription;
  @JsonKey(name: 'PrintOnProject')
  final bool? printOnProject;
  @JsonKey(name: 'UserName')
  final String? userName;
  @JsonKey(name: 'Notes')
  final String? notes;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsProjectNoteProjectNoteFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsProjectNoteProjectNoteToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsProjectNoteProjectNoteToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsProjectNoteProjectNote &&
            (identical(other.projectNoteId, projectNoteId) ||
                const DeepCollectionEquality()
                    .equals(other.projectNoteId, projectNoteId)) &&
            (identical(other.projectId, projectId) ||
                const DeepCollectionEquality()
                    .equals(other.projectId, projectId)) &&
            (identical(other.noteDate, noteDate) ||
                const DeepCollectionEquality()
                    .equals(other.noteDate, noteDate)) &&
            (identical(other.userId, userId) ||
                const DeepCollectionEquality().equals(other.userId, userId)) &&
            (identical(other.notesDescription, notesDescription) ||
                const DeepCollectionEquality()
                    .equals(other.notesDescription, notesDescription)) &&
            (identical(other.printOnProject, printOnProject) ||
                const DeepCollectionEquality()
                    .equals(other.printOnProject, printOnProject)) &&
            (identical(other.userName, userName) ||
                const DeepCollectionEquality()
                    .equals(other.userName, userName)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsProjectNoteProjectNoteExtension
    on WebApiModulesHomeControlsProjectNoteProjectNote {
  WebApiModulesHomeControlsProjectNoteProjectNote copyWith(
      {String? projectNoteId,
      String? projectId,
      String? noteDate,
      String? userId,
      String? notesDescription,
      bool? printOnProject,
      String? userName,
      String? notes,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsProjectNoteProjectNote(
        projectNoteId: projectNoteId ?? this.projectNoteId,
        projectId: projectId ?? this.projectId,
        noteDate: noteDate ?? this.noteDate,
        userId: userId ?? this.userId,
        notesDescription: notesDescription ?? this.notesDescription,
        printOnProject: printOnProject ?? this.printOnProject,
        userName: userName ?? this.userName,
        notes: notes ?? this.notes,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCode {
  WebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCode({
    this.purchaseOrderReceiveBarCodeId,
    this.barCode,
    this.inspectionNumber,
    this.inspectionVendorId,
    this.inspectionVendor,
    this.manufactureDate,
    this.printQuantity,
    this.serialNumber,
    this.rfId,
    this.purchaseOrderItemId,
    this.purchaseOrderId,
    this.orderTranId,
    this.internalChar,
    this.receiveContractId,
    this.receiveContractNumber,
    this.returnContractId,
    this.inventoryId,
    this.scannableBarCode,
    this.iCode,
    this.description,
    this.iCodeDescription,
    this.packingSlipNumber,
    this.warehouseId,
    this.itemId,
    this.purchaseId,
    this.availableFor,
    this.availableForDisplay,
    this.trackedBy,
    this.serialNumberIsMixedCase,
    this.itemOrder,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCode.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCodeFromJson(
          json);

  @JsonKey(name: 'PurchaseOrderReceiveBarCodeId')
  final int? purchaseOrderReceiveBarCodeId;
  @JsonKey(name: 'BarCode')
  final String? barCode;
  @JsonKey(name: 'InspectionNumber')
  final String? inspectionNumber;
  @JsonKey(name: 'InspectionVendorId')
  final String? inspectionVendorId;
  @JsonKey(name: 'InspectionVendor')
  final String? inspectionVendor;
  @JsonKey(name: 'ManufactureDate')
  final String? manufactureDate;
  @JsonKey(name: 'PrintQuantity')
  final int? printQuantity;
  @JsonKey(name: 'SerialNumber')
  final String? serialNumber;
  @JsonKey(name: 'RfId')
  final String? rfId;
  @JsonKey(name: 'PurchaseOrderItemId')
  final String? purchaseOrderItemId;
  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'OrderTranId')
  final int? orderTranId;
  @JsonKey(name: 'InternalChar')
  final String? internalChar;
  @JsonKey(name: 'ReceiveContractId')
  final String? receiveContractId;
  @JsonKey(name: 'ReceiveContractNumber')
  final String? receiveContractNumber;
  @JsonKey(name: 'ReturnContractId')
  final String? returnContractId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'ScannableBarCode')
  final String? scannableBarCode;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'ICodeDescription')
  final String? iCodeDescription;
  @JsonKey(name: 'PackingSlipNumber')
  final String? packingSlipNumber;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'ItemId')
  final String? itemId;
  @JsonKey(name: 'PurchaseId')
  final String? purchaseId;
  @JsonKey(name: 'AvailableFor')
  final String? availableFor;
  @JsonKey(name: 'AvailableForDisplay')
  final String? availableForDisplay;
  @JsonKey(name: 'TrackedBy')
  final String? trackedBy;
  @JsonKey(name: 'SerialNumberIsMixedCase')
  final bool? serialNumberIsMixedCase;
  @JsonKey(name: 'ItemOrder')
  final String? itemOrder;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCodeFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCodeToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCodeToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCode &&
            (identical(other.purchaseOrderReceiveBarCodeId, purchaseOrderReceiveBarCodeId) ||
                const DeepCollectionEquality().equals(
                    other.purchaseOrderReceiveBarCodeId,
                    purchaseOrderReceiveBarCodeId)) &&
            (identical(other.barCode, barCode) ||
                const DeepCollectionEquality()
                    .equals(other.barCode, barCode)) &&
            (identical(other.inspectionNumber, inspectionNumber) ||
                const DeepCollectionEquality()
                    .equals(other.inspectionNumber, inspectionNumber)) &&
            (identical(other.inspectionVendorId, inspectionVendorId) ||
                const DeepCollectionEquality()
                    .equals(other.inspectionVendorId, inspectionVendorId)) &&
            (identical(other.inspectionVendor, inspectionVendor) ||
                const DeepCollectionEquality()
                    .equals(other.inspectionVendor, inspectionVendor)) &&
            (identical(other.manufactureDate, manufactureDate) ||
                const DeepCollectionEquality()
                    .equals(other.manufactureDate, manufactureDate)) &&
            (identical(other.printQuantity, printQuantity) ||
                const DeepCollectionEquality()
                    .equals(other.printQuantity, printQuantity)) &&
            (identical(other.serialNumber, serialNumber) ||
                const DeepCollectionEquality()
                    .equals(other.serialNumber, serialNumber)) &&
            (identical(other.rfId, rfId) ||
                const DeepCollectionEquality().equals(other.rfId, rfId)) &&
            (identical(other.purchaseOrderItemId, purchaseOrderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderItemId, purchaseOrderItemId)) &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.orderTranId, orderTranId) ||
                const DeepCollectionEquality()
                    .equals(other.orderTranId, orderTranId)) &&
            (identical(other.internalChar, internalChar) ||
                const DeepCollectionEquality()
                    .equals(other.internalChar, internalChar)) &&
            (identical(other.receiveContractId, receiveContractId) || const DeepCollectionEquality().equals(other.receiveContractId, receiveContractId)) &&
            (identical(other.receiveContractNumber, receiveContractNumber) || const DeepCollectionEquality().equals(other.receiveContractNumber, receiveContractNumber)) &&
            (identical(other.returnContractId, returnContractId) || const DeepCollectionEquality().equals(other.returnContractId, returnContractId)) &&
            (identical(other.inventoryId, inventoryId) || const DeepCollectionEquality().equals(other.inventoryId, inventoryId)) &&
            (identical(other.scannableBarCode, scannableBarCode) || const DeepCollectionEquality().equals(other.scannableBarCode, scannableBarCode)) &&
            (identical(other.iCode, iCode) || const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) || const DeepCollectionEquality().equals(other.description, description)) &&
            (identical(other.iCodeDescription, iCodeDescription) || const DeepCollectionEquality().equals(other.iCodeDescription, iCodeDescription)) &&
            (identical(other.packingSlipNumber, packingSlipNumber) || const DeepCollectionEquality().equals(other.packingSlipNumber, packingSlipNumber)) &&
            (identical(other.warehouseId, warehouseId) || const DeepCollectionEquality().equals(other.warehouseId, warehouseId)) &&
            (identical(other.itemId, itemId) || const DeepCollectionEquality().equals(other.itemId, itemId)) &&
            (identical(other.purchaseId, purchaseId) || const DeepCollectionEquality().equals(other.purchaseId, purchaseId)) &&
            (identical(other.availableFor, availableFor) || const DeepCollectionEquality().equals(other.availableFor, availableFor)) &&
            (identical(other.availableForDisplay, availableForDisplay) || const DeepCollectionEquality().equals(other.availableForDisplay, availableForDisplay)) &&
            (identical(other.trackedBy, trackedBy) || const DeepCollectionEquality().equals(other.trackedBy, trackedBy)) &&
            (identical(other.serialNumberIsMixedCase, serialNumberIsMixedCase) || const DeepCollectionEquality().equals(other.serialNumberIsMixedCase, serialNumberIsMixedCase)) &&
            (identical(other.itemOrder, itemOrder) || const DeepCollectionEquality().equals(other.itemOrder, itemOrder)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCodeExtension
    on WebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCode {
  WebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCode
      copyWith(
          {int? purchaseOrderReceiveBarCodeId,
          String? barCode,
          String? inspectionNumber,
          String? inspectionVendorId,
          String? inspectionVendor,
          String? manufactureDate,
          int? printQuantity,
          String? serialNumber,
          String? rfId,
          String? purchaseOrderItemId,
          String? purchaseOrderId,
          int? orderTranId,
          String? internalChar,
          String? receiveContractId,
          String? receiveContractNumber,
          String? returnContractId,
          String? inventoryId,
          String? scannableBarCode,
          String? iCode,
          String? description,
          String? iCodeDescription,
          String? packingSlipNumber,
          String? warehouseId,
          String? itemId,
          String? purchaseId,
          String? availableFor,
          String? availableForDisplay,
          String? trackedBy,
          bool? serialNumberIsMixedCase,
          String? itemOrder,
          String? dateStamp,
          String? recordTitle,
          List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
          List<FwStandardDataFwCustomValue>? custom,
          List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsPurchaseOrderReceiveBarCodePurchaseOrderReceiveBarCode(
        purchaseOrderReceiveBarCodeId:
            purchaseOrderReceiveBarCodeId ?? this.purchaseOrderReceiveBarCodeId,
        barCode: barCode ?? this.barCode,
        inspectionNumber: inspectionNumber ?? this.inspectionNumber,
        inspectionVendorId: inspectionVendorId ?? this.inspectionVendorId,
        inspectionVendor: inspectionVendor ?? this.inspectionVendor,
        manufactureDate: manufactureDate ?? this.manufactureDate,
        printQuantity: printQuantity ?? this.printQuantity,
        serialNumber: serialNumber ?? this.serialNumber,
        rfId: rfId ?? this.rfId,
        purchaseOrderItemId: purchaseOrderItemId ?? this.purchaseOrderItemId,
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        orderTranId: orderTranId ?? this.orderTranId,
        internalChar: internalChar ?? this.internalChar,
        receiveContractId: receiveContractId ?? this.receiveContractId,
        receiveContractNumber:
            receiveContractNumber ?? this.receiveContractNumber,
        returnContractId: returnContractId ?? this.returnContractId,
        inventoryId: inventoryId ?? this.inventoryId,
        scannableBarCode: scannableBarCode ?? this.scannableBarCode,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        iCodeDescription: iCodeDescription ?? this.iCodeDescription,
        packingSlipNumber: packingSlipNumber ?? this.packingSlipNumber,
        warehouseId: warehouseId ?? this.warehouseId,
        itemId: itemId ?? this.itemId,
        purchaseId: purchaseId ?? this.purchaseId,
        availableFor: availableFor ?? this.availableFor,
        availableForDisplay: availableForDisplay ?? this.availableForDisplay,
        trackedBy: trackedBy ?? this.trackedBy,
        serialNumberIsMixedCase:
            serialNumberIsMixedCase ?? this.serialNumberIsMixedCase,
        itemOrder: itemOrder ?? this.itemOrder,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCode {
  WebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCode({
    this.purchaseOrderReturnBarCodeId,
    this.barCode,
    this.inspectionNumber,
    this.inspectionVendorId,
    this.inspectionVendor,
    this.manufactureDate,
    this.printQuantity,
    this.serialNumber,
    this.rfId,
    this.purchaseOrderItemId,
    this.purchaseOrderId,
    this.orderTranId,
    this.internalChar,
    this.returnContractId,
    this.inventoryId,
    this.scannableBarCode,
    this.iCode,
    this.description,
    this.iCodeDescription,
    this.packingSlipNumber,
    this.warehouseId,
    this.itemId,
    this.purchaseId,
    this.availableFor,
    this.availableForDisplay,
    this.trackedBy,
    this.serialNumberIsMixedCase,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCode.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCodeFromJson(
          json);

  @JsonKey(name: 'PurchaseOrderReturnBarCodeId')
  final int? purchaseOrderReturnBarCodeId;
  @JsonKey(name: 'BarCode')
  final String? barCode;
  @JsonKey(name: 'InspectionNumber')
  final String? inspectionNumber;
  @JsonKey(name: 'InspectionVendorId')
  final String? inspectionVendorId;
  @JsonKey(name: 'InspectionVendor')
  final String? inspectionVendor;
  @JsonKey(name: 'ManufactureDate')
  final String? manufactureDate;
  @JsonKey(name: 'PrintQuantity')
  final int? printQuantity;
  @JsonKey(name: 'SerialNumber')
  final String? serialNumber;
  @JsonKey(name: 'RfId')
  final String? rfId;
  @JsonKey(name: 'PurchaseOrderItemId')
  final String? purchaseOrderItemId;
  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'OrderTranId')
  final int? orderTranId;
  @JsonKey(name: 'InternalChar')
  final String? internalChar;
  @JsonKey(name: 'ReturnContractId')
  final String? returnContractId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'ScannableBarCode')
  final String? scannableBarCode;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'ICodeDescription')
  final String? iCodeDescription;
  @JsonKey(name: 'PackingSlipNumber')
  final String? packingSlipNumber;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'ItemId')
  final String? itemId;
  @JsonKey(name: 'PurchaseId')
  final String? purchaseId;
  @JsonKey(name: 'AvailableFor')
  final String? availableFor;
  @JsonKey(name: 'AvailableForDisplay')
  final String? availableForDisplay;
  @JsonKey(name: 'TrackedBy')
  final String? trackedBy;
  @JsonKey(name: 'SerialNumberIsMixedCase')
  final bool? serialNumberIsMixedCase;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCodeFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCodeToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCodeToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCode &&
            (identical(other.purchaseOrderReturnBarCodeId, purchaseOrderReturnBarCodeId) ||
                const DeepCollectionEquality().equals(
                    other.purchaseOrderReturnBarCodeId,
                    purchaseOrderReturnBarCodeId)) &&
            (identical(other.barCode, barCode) ||
                const DeepCollectionEquality()
                    .equals(other.barCode, barCode)) &&
            (identical(other.inspectionNumber, inspectionNumber) ||
                const DeepCollectionEquality()
                    .equals(other.inspectionNumber, inspectionNumber)) &&
            (identical(other.inspectionVendorId, inspectionVendorId) ||
                const DeepCollectionEquality()
                    .equals(other.inspectionVendorId, inspectionVendorId)) &&
            (identical(other.inspectionVendor, inspectionVendor) ||
                const DeepCollectionEquality()
                    .equals(other.inspectionVendor, inspectionVendor)) &&
            (identical(other.manufactureDate, manufactureDate) ||
                const DeepCollectionEquality()
                    .equals(other.manufactureDate, manufactureDate)) &&
            (identical(other.printQuantity, printQuantity) ||
                const DeepCollectionEquality()
                    .equals(other.printQuantity, printQuantity)) &&
            (identical(other.serialNumber, serialNumber) ||
                const DeepCollectionEquality()
                    .equals(other.serialNumber, serialNumber)) &&
            (identical(other.rfId, rfId) ||
                const DeepCollectionEquality().equals(other.rfId, rfId)) &&
            (identical(other.purchaseOrderItemId, purchaseOrderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderItemId, purchaseOrderItemId)) &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.orderTranId, orderTranId) ||
                const DeepCollectionEquality()
                    .equals(other.orderTranId, orderTranId)) &&
            (identical(other.internalChar, internalChar) ||
                const DeepCollectionEquality()
                    .equals(other.internalChar, internalChar)) &&
            (identical(other.returnContractId, returnContractId) || const DeepCollectionEquality().equals(other.returnContractId, returnContractId)) &&
            (identical(other.inventoryId, inventoryId) || const DeepCollectionEquality().equals(other.inventoryId, inventoryId)) &&
            (identical(other.scannableBarCode, scannableBarCode) || const DeepCollectionEquality().equals(other.scannableBarCode, scannableBarCode)) &&
            (identical(other.iCode, iCode) || const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) || const DeepCollectionEquality().equals(other.description, description)) &&
            (identical(other.iCodeDescription, iCodeDescription) || const DeepCollectionEquality().equals(other.iCodeDescription, iCodeDescription)) &&
            (identical(other.packingSlipNumber, packingSlipNumber) || const DeepCollectionEquality().equals(other.packingSlipNumber, packingSlipNumber)) &&
            (identical(other.warehouseId, warehouseId) || const DeepCollectionEquality().equals(other.warehouseId, warehouseId)) &&
            (identical(other.itemId, itemId) || const DeepCollectionEquality().equals(other.itemId, itemId)) &&
            (identical(other.purchaseId, purchaseId) || const DeepCollectionEquality().equals(other.purchaseId, purchaseId)) &&
            (identical(other.availableFor, availableFor) || const DeepCollectionEquality().equals(other.availableFor, availableFor)) &&
            (identical(other.availableForDisplay, availableForDisplay) || const DeepCollectionEquality().equals(other.availableForDisplay, availableForDisplay)) &&
            (identical(other.trackedBy, trackedBy) || const DeepCollectionEquality().equals(other.trackedBy, trackedBy)) &&
            (identical(other.serialNumberIsMixedCase, serialNumberIsMixedCase) || const DeepCollectionEquality().equals(other.serialNumberIsMixedCase, serialNumberIsMixedCase)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCodeExtension
    on WebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCode {
  WebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCode
      copyWith(
          {int? purchaseOrderReturnBarCodeId,
          String? barCode,
          String? inspectionNumber,
          String? inspectionVendorId,
          String? inspectionVendor,
          String? manufactureDate,
          int? printQuantity,
          String? serialNumber,
          String? rfId,
          String? purchaseOrderItemId,
          String? purchaseOrderId,
          int? orderTranId,
          String? internalChar,
          String? returnContractId,
          String? inventoryId,
          String? scannableBarCode,
          String? iCode,
          String? description,
          String? iCodeDescription,
          String? packingSlipNumber,
          String? warehouseId,
          String? itemId,
          String? purchaseId,
          String? availableFor,
          String? availableForDisplay,
          String? trackedBy,
          bool? serialNumberIsMixedCase,
          String? dateStamp,
          String? recordTitle,
          List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
          List<FwStandardDataFwCustomValue>? custom,
          List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsPurchaseOrderReturnBarCodePurchaseOrderReturnBarCode(
        purchaseOrderReturnBarCodeId:
            purchaseOrderReturnBarCodeId ?? this.purchaseOrderReturnBarCodeId,
        barCode: barCode ?? this.barCode,
        inspectionNumber: inspectionNumber ?? this.inspectionNumber,
        inspectionVendorId: inspectionVendorId ?? this.inspectionVendorId,
        inspectionVendor: inspectionVendor ?? this.inspectionVendor,
        manufactureDate: manufactureDate ?? this.manufactureDate,
        printQuantity: printQuantity ?? this.printQuantity,
        serialNumber: serialNumber ?? this.serialNumber,
        rfId: rfId ?? this.rfId,
        purchaseOrderItemId: purchaseOrderItemId ?? this.purchaseOrderItemId,
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        orderTranId: orderTranId ?? this.orderTranId,
        internalChar: internalChar ?? this.internalChar,
        returnContractId: returnContractId ?? this.returnContractId,
        inventoryId: inventoryId ?? this.inventoryId,
        scannableBarCode: scannableBarCode ?? this.scannableBarCode,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        iCodeDescription: iCodeDescription ?? this.iCodeDescription,
        packingSlipNumber: packingSlipNumber ?? this.packingSlipNumber,
        warehouseId: warehouseId ?? this.warehouseId,
        itemId: itemId ?? this.itemId,
        purchaseId: purchaseId ?? this.purchaseId,
        availableFor: availableFor ?? this.availableFor,
        availableForDisplay: availableForDisplay ?? this.availableForDisplay,
        trackedBy: trackedBy ?? this.trackedBy,
        serialNumberIsMixedCase:
            serialNumberIsMixedCase ?? this.serialNumberIsMixedCase,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItem {
  WebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItem({
    this.purchaseId,
    this.vendorInvoiceId,
    this.vendorInvoiceItemId,
    this.purchaseOrderId,
    this.purchaseOrderItemId,
    this.invoiceNumber,
    this.invoiceDate,
    this.quantity,
    this.unitCost,
    this.extended,
    this.currencyId,
    this.currency,
    this.currencyCode,
    this.currencySymbol,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItem.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItemFromJson(
          json);

  @JsonKey(name: 'PurchaseId')
  final String? purchaseId;
  @JsonKey(name: 'VendorInvoiceId')
  final String? vendorInvoiceId;
  @JsonKey(name: 'VendorInvoiceItemId')
  final String? vendorInvoiceItemId;
  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'PurchaseOrderItemId')
  final String? purchaseOrderItemId;
  @JsonKey(name: 'InvoiceNumber')
  final String? invoiceNumber;
  @JsonKey(name: 'InvoiceDate')
  final String? invoiceDate;
  @JsonKey(name: 'Quantity')
  final int? quantity;
  @JsonKey(name: 'UnitCost')
  final double? unitCost;
  @JsonKey(name: 'Extended')
  final double? extended;
  @JsonKey(name: 'CurrencyId')
  final String? currencyId;
  @JsonKey(name: 'Currency')
  final String? currency;
  @JsonKey(name: 'CurrencyCode')
  final String? currencyCode;
  @JsonKey(name: 'CurrencySymbol')
  final String? currencySymbol;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItemFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItemToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItemToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItem &&
            (identical(other.purchaseId, purchaseId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseId, purchaseId)) &&
            (identical(other.vendorInvoiceId, vendorInvoiceId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorInvoiceId, vendorInvoiceId)) &&
            (identical(other.vendorInvoiceItemId, vendorInvoiceItemId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorInvoiceItemId, vendorInvoiceItemId)) &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.purchaseOrderItemId, purchaseOrderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderItemId, purchaseOrderItemId)) &&
            (identical(other.invoiceNumber, invoiceNumber) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceNumber, invoiceNumber)) &&
            (identical(other.invoiceDate, invoiceDate) ||
                const DeepCollectionEquality()
                    .equals(other.invoiceDate, invoiceDate)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)) &&
            (identical(other.unitCost, unitCost) ||
                const DeepCollectionEquality()
                    .equals(other.unitCost, unitCost)) &&
            (identical(other.extended, extended) ||
                const DeepCollectionEquality()
                    .equals(other.extended, extended)) &&
            (identical(other.currencyId, currencyId) ||
                const DeepCollectionEquality()
                    .equals(other.currencyId, currencyId)) &&
            (identical(other.currency, currency) ||
                const DeepCollectionEquality()
                    .equals(other.currency, currency)) &&
            (identical(other.currencyCode, currencyCode) ||
                const DeepCollectionEquality()
                    .equals(other.currencyCode, currencyCode)) &&
            (identical(other.currencySymbol, currencySymbol) ||
                const DeepCollectionEquality()
                    .equals(other.currencySymbol, currencySymbol)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItemExtension
    on WebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItem {
  WebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItem
      copyWith(
          {String? purchaseId,
          String? vendorInvoiceId,
          String? vendorInvoiceItemId,
          String? purchaseOrderId,
          String? purchaseOrderItemId,
          String? invoiceNumber,
          String? invoiceDate,
          int? quantity,
          double? unitCost,
          double? extended,
          String? currencyId,
          String? currency,
          String? currencyCode,
          String? currencySymbol,
          String? recordTitle,
          List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
          List<FwStandardDataFwCustomValue>? custom,
          List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsPurchaseVendorInvoiceItemPurchaseVendorInvoiceItem(
        purchaseId: purchaseId ?? this.purchaseId,
        vendorInvoiceId: vendorInvoiceId ?? this.vendorInvoiceId,
        vendorInvoiceItemId: vendorInvoiceItemId ?? this.vendorInvoiceItemId,
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        purchaseOrderItemId: purchaseOrderItemId ?? this.purchaseOrderItemId,
        invoiceNumber: invoiceNumber ?? this.invoiceNumber,
        invoiceDate: invoiceDate ?? this.invoiceDate,
        quantity: quantity ?? this.quantity,
        unitCost: unitCost ?? this.unitCost,
        extended: extended ?? this.extended,
        currencyId: currencyId ?? this.currencyId,
        currency: currency ?? this.currency,
        currencyCode: currencyCode ?? this.currencyCode,
        currencySymbol: currencySymbol ?? this.currencySymbol,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsRepairCostRepairCost {
  WebApiModulesHomeControlsRepairCostRepairCost({
    this.repairCostId,
    this.repairId,
    this.rateId,
    this.iCode,
    this.description,
    this.quantity,
    this.unit,
    this.rate,
    this.grossTotal,
    this.discountAmount,
    this.extended,
    this.taxable,
    this.tax,
    this.total,
    this.billable,
    this.note,
    this.currencySymbol,
    this.orderId,
    this.orderItemId,
    this.orderNumber,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsRepairCostRepairCost.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsRepairCostRepairCostFromJson(json);

  @JsonKey(name: 'RepairCostId')
  final String? repairCostId;
  @JsonKey(name: 'RepairId')
  final String? repairId;
  @JsonKey(name: 'RateId')
  final String? rateId;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'Quantity')
  final double? quantity;
  @JsonKey(name: 'Unit')
  final String? unit;
  @JsonKey(name: 'Rate')
  final double? rate;
  @JsonKey(name: 'GrossTotal')
  final double? grossTotal;
  @JsonKey(name: 'DiscountAmount')
  final double? discountAmount;
  @JsonKey(name: 'Extended')
  final double? extended;
  @JsonKey(name: 'Taxable')
  final bool? taxable;
  @JsonKey(name: 'Tax')
  final double? tax;
  @JsonKey(name: 'Total')
  final double? total;
  @JsonKey(name: 'Billable')
  final bool? billable;
  @JsonKey(name: 'Note')
  final String? note;
  @JsonKey(name: 'CurrencySymbol')
  final String? currencySymbol;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderItemId')
  final String? orderItemId;
  @JsonKey(name: 'OrderNumber')
  final String? orderNumber;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsRepairCostRepairCostFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsRepairCostRepairCostToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsRepairCostRepairCostToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsRepairCostRepairCost &&
            (identical(other.repairCostId, repairCostId) ||
                const DeepCollectionEquality()
                    .equals(other.repairCostId, repairCostId)) &&
            (identical(other.repairId, repairId) ||
                const DeepCollectionEquality()
                    .equals(other.repairId, repairId)) &&
            (identical(other.rateId, rateId) ||
                const DeepCollectionEquality().equals(other.rateId, rateId)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)) &&
            (identical(other.unit, unit) ||
                const DeepCollectionEquality().equals(other.unit, unit)) &&
            (identical(other.rate, rate) ||
                const DeepCollectionEquality().equals(other.rate, rate)) &&
            (identical(other.grossTotal, grossTotal) ||
                const DeepCollectionEquality()
                    .equals(other.grossTotal, grossTotal)) &&
            (identical(other.discountAmount, discountAmount) ||
                const DeepCollectionEquality()
                    .equals(other.discountAmount, discountAmount)) &&
            (identical(other.extended, extended) ||
                const DeepCollectionEquality()
                    .equals(other.extended, extended)) &&
            (identical(other.taxable, taxable) ||
                const DeepCollectionEquality()
                    .equals(other.taxable, taxable)) &&
            (identical(other.tax, tax) ||
                const DeepCollectionEquality().equals(other.tax, tax)) &&
            (identical(other.total, total) ||
                const DeepCollectionEquality().equals(other.total, total)) &&
            (identical(other.billable, billable) ||
                const DeepCollectionEquality()
                    .equals(other.billable, billable)) &&
            (identical(other.note, note) ||
                const DeepCollectionEquality().equals(other.note, note)) &&
            (identical(other.currencySymbol, currencySymbol) ||
                const DeepCollectionEquality()
                    .equals(other.currencySymbol, currencySymbol)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderItemId, orderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.orderItemId, orderItemId)) &&
            (identical(other.orderNumber, orderNumber) ||
                const DeepCollectionEquality()
                    .equals(other.orderNumber, orderNumber)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsRepairCostRepairCostExtension
    on WebApiModulesHomeControlsRepairCostRepairCost {
  WebApiModulesHomeControlsRepairCostRepairCost copyWith(
      {String? repairCostId,
      String? repairId,
      String? rateId,
      String? iCode,
      String? description,
      double? quantity,
      String? unit,
      double? rate,
      double? grossTotal,
      double? discountAmount,
      double? extended,
      bool? taxable,
      double? tax,
      double? total,
      bool? billable,
      String? note,
      String? currencySymbol,
      String? orderId,
      String? orderItemId,
      String? orderNumber,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsRepairCostRepairCost(
        repairCostId: repairCostId ?? this.repairCostId,
        repairId: repairId ?? this.repairId,
        rateId: rateId ?? this.rateId,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        quantity: quantity ?? this.quantity,
        unit: unit ?? this.unit,
        rate: rate ?? this.rate,
        grossTotal: grossTotal ?? this.grossTotal,
        discountAmount: discountAmount ?? this.discountAmount,
        extended: extended ?? this.extended,
        taxable: taxable ?? this.taxable,
        tax: tax ?? this.tax,
        total: total ?? this.total,
        billable: billable ?? this.billable,
        note: note ?? this.note,
        currencySymbol: currencySymbol ?? this.currencySymbol,
        orderId: orderId ?? this.orderId,
        orderItemId: orderItemId ?? this.orderItemId,
        orderNumber: orderNumber ?? this.orderNumber,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsRepairPartRepairPart {
  WebApiModulesHomeControlsRepairPartRepairPart({
    this.repairPartId,
    this.repairId,
    this.inventoryId,
    this.warehouseId,
    this.warehouseCode,
    this.warehouse,
    this.iCode,
    this.iCodeColor,
    this.description,
    this.descriptionColor,
    this.quantity,
    this.unit,
    this.price,
    this.grossTotal,
    this.discountAmount,
    this.extended,
    this.taxable,
    this.tax,
    this.total,
    this.billable,
    this.itemClass,
    this.itemOrder,
    this.currencySymbol,
    this.orderId,
    this.orderItemId,
    this.orderNumber,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsRepairPartRepairPart.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsRepairPartRepairPartFromJson(json);

  @JsonKey(name: 'RepairPartId')
  final String? repairPartId;
  @JsonKey(name: 'RepairId')
  final String? repairId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'ICodeColor')
  final String? iCodeColor;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'DescriptionColor')
  final String? descriptionColor;
  @JsonKey(name: 'Quantity')
  final double? quantity;
  @JsonKey(name: 'Unit')
  final String? unit;
  @JsonKey(name: 'Price')
  final double? price;
  @JsonKey(name: 'GrossTotal')
  final double? grossTotal;
  @JsonKey(name: 'DiscountAmount')
  final double? discountAmount;
  @JsonKey(name: 'Extended')
  final double? extended;
  @JsonKey(name: 'Taxable')
  final bool? taxable;
  @JsonKey(name: 'Tax')
  final double? tax;
  @JsonKey(name: 'Total')
  final double? total;
  @JsonKey(name: 'Billable')
  final bool? billable;
  @JsonKey(name: 'ItemClass')
  final String? itemClass;
  @JsonKey(name: 'ItemOrder')
  final String? itemOrder;
  @JsonKey(name: 'CurrencySymbol')
  final String? currencySymbol;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderItemId')
  final String? orderItemId;
  @JsonKey(name: 'OrderNumber')
  final String? orderNumber;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsRepairPartRepairPartFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsRepairPartRepairPartToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsRepairPartRepairPartToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsRepairPartRepairPart &&
            (identical(other.repairPartId, repairPartId) ||
                const DeepCollectionEquality()
                    .equals(other.repairPartId, repairPartId)) &&
            (identical(other.repairId, repairId) ||
                const DeepCollectionEquality()
                    .equals(other.repairId, repairId)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouseCode, warehouseCode) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.warehouse, warehouse) ||
                const DeepCollectionEquality()
                    .equals(other.warehouse, warehouse)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.iCodeColor, iCodeColor) ||
                const DeepCollectionEquality()
                    .equals(other.iCodeColor, iCodeColor)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.descriptionColor, descriptionColor) ||
                const DeepCollectionEquality()
                    .equals(other.descriptionColor, descriptionColor)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)) &&
            (identical(other.unit, unit) ||
                const DeepCollectionEquality().equals(other.unit, unit)) &&
            (identical(other.price, price) ||
                const DeepCollectionEquality().equals(other.price, price)) &&
            (identical(other.grossTotal, grossTotal) ||
                const DeepCollectionEquality()
                    .equals(other.grossTotal, grossTotal)) &&
            (identical(other.discountAmount, discountAmount) ||
                const DeepCollectionEquality()
                    .equals(other.discountAmount, discountAmount)) &&
            (identical(other.extended, extended) ||
                const DeepCollectionEquality()
                    .equals(other.extended, extended)) &&
            (identical(other.taxable, taxable) ||
                const DeepCollectionEquality()
                    .equals(other.taxable, taxable)) &&
            (identical(other.tax, tax) ||
                const DeepCollectionEquality().equals(other.tax, tax)) &&
            (identical(other.total, total) ||
                const DeepCollectionEquality().equals(other.total, total)) &&
            (identical(other.billable, billable) ||
                const DeepCollectionEquality()
                    .equals(other.billable, billable)) &&
            (identical(other.itemClass, itemClass) ||
                const DeepCollectionEquality()
                    .equals(other.itemClass, itemClass)) &&
            (identical(other.itemOrder, itemOrder) ||
                const DeepCollectionEquality()
                    .equals(other.itemOrder, itemOrder)) &&
            (identical(other.currencySymbol, currencySymbol) ||
                const DeepCollectionEquality()
                    .equals(other.currencySymbol, currencySymbol)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderItemId, orderItemId) || const DeepCollectionEquality().equals(other.orderItemId, orderItemId)) &&
            (identical(other.orderNumber, orderNumber) || const DeepCollectionEquality().equals(other.orderNumber, orderNumber)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsRepairPartRepairPartExtension
    on WebApiModulesHomeControlsRepairPartRepairPart {
  WebApiModulesHomeControlsRepairPartRepairPart copyWith(
      {String? repairPartId,
      String? repairId,
      String? inventoryId,
      String? warehouseId,
      String? warehouseCode,
      String? warehouse,
      String? iCode,
      String? iCodeColor,
      String? description,
      String? descriptionColor,
      double? quantity,
      String? unit,
      double? price,
      double? grossTotal,
      double? discountAmount,
      double? extended,
      bool? taxable,
      double? tax,
      double? total,
      bool? billable,
      String? itemClass,
      String? itemOrder,
      String? currencySymbol,
      String? orderId,
      String? orderItemId,
      String? orderNumber,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsRepairPartRepairPart(
        repairPartId: repairPartId ?? this.repairPartId,
        repairId: repairId ?? this.repairId,
        inventoryId: inventoryId ?? this.inventoryId,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        warehouse: warehouse ?? this.warehouse,
        iCode: iCode ?? this.iCode,
        iCodeColor: iCodeColor ?? this.iCodeColor,
        description: description ?? this.description,
        descriptionColor: descriptionColor ?? this.descriptionColor,
        quantity: quantity ?? this.quantity,
        unit: unit ?? this.unit,
        price: price ?? this.price,
        grossTotal: grossTotal ?? this.grossTotal,
        discountAmount: discountAmount ?? this.discountAmount,
        extended: extended ?? this.extended,
        taxable: taxable ?? this.taxable,
        tax: tax ?? this.tax,
        total: total ?? this.total,
        billable: billable ?? this.billable,
        itemClass: itemClass ?? this.itemClass,
        itemOrder: itemOrder ?? this.itemOrder,
        currencySymbol: currencySymbol ?? this.currencySymbol,
        orderId: orderId ?? this.orderId,
        orderItemId: orderItemId ?? this.orderItemId,
        orderNumber: orderNumber ?? this.orderNumber,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsRepairReleaseRepairRelease {
  WebApiModulesHomeControlsRepairReleaseRepairRelease({
    this.repairReleaseId,
    this.repairId,
    this.releaseDate,
    this.usersId,
    this.releasedBy,
    this.releaseQuantity,
    this.staging,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsRepairReleaseRepairRelease.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsRepairReleaseRepairReleaseFromJson(json);

  @JsonKey(name: 'RepairReleaseId')
  final String? repairReleaseId;
  @JsonKey(name: 'RepairId')
  final String? repairId;
  @JsonKey(name: 'ReleaseDate')
  final String? releaseDate;
  @JsonKey(name: 'UsersId')
  final String? usersId;
  @JsonKey(name: 'ReleasedBy')
  final String? releasedBy;
  @JsonKey(name: 'ReleaseQuantity')
  final double? releaseQuantity;
  @JsonKey(name: 'Staging')
  final bool? staging;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsRepairReleaseRepairReleaseFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsRepairReleaseRepairReleaseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsRepairReleaseRepairReleaseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsRepairReleaseRepairRelease &&
            (identical(other.repairReleaseId, repairReleaseId) ||
                const DeepCollectionEquality()
                    .equals(other.repairReleaseId, repairReleaseId)) &&
            (identical(other.repairId, repairId) ||
                const DeepCollectionEquality()
                    .equals(other.repairId, repairId)) &&
            (identical(other.releaseDate, releaseDate) ||
                const DeepCollectionEquality()
                    .equals(other.releaseDate, releaseDate)) &&
            (identical(other.usersId, usersId) ||
                const DeepCollectionEquality()
                    .equals(other.usersId, usersId)) &&
            (identical(other.releasedBy, releasedBy) ||
                const DeepCollectionEquality()
                    .equals(other.releasedBy, releasedBy)) &&
            (identical(other.releaseQuantity, releaseQuantity) ||
                const DeepCollectionEquality()
                    .equals(other.releaseQuantity, releaseQuantity)) &&
            (identical(other.staging, staging) ||
                const DeepCollectionEquality()
                    .equals(other.staging, staging)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsRepairReleaseRepairReleaseExtension
    on WebApiModulesHomeControlsRepairReleaseRepairRelease {
  WebApiModulesHomeControlsRepairReleaseRepairRelease copyWith(
      {String? repairReleaseId,
      String? repairId,
      String? releaseDate,
      String? usersId,
      String? releasedBy,
      double? releaseQuantity,
      bool? staging,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsRepairReleaseRepairRelease(
        repairReleaseId: repairReleaseId ?? this.repairReleaseId,
        repairId: repairId ?? this.repairId,
        releaseDate: releaseDate ?? this.releaseDate,
        usersId: usersId ?? this.usersId,
        releasedBy: releasedBy ?? this.releasedBy,
        releaseQuantity: releaseQuantity ?? this.releaseQuantity,
        staging: staging ?? this.staging,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionRequest {
  WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionRequest({
    this.sourceOrderId,
    this.sessionId,
  });

  factory WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionRequestFromJson(
          json);

  @JsonKey(name: 'SourceOrderId')
  final String? sourceOrderId;
  @JsonKey(name: 'SessionId')
  final String? sessionId;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionRequest &&
            (identical(other.sourceOrderId, sourceOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.sourceOrderId, sourceOrderId)) &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)));
  }
}

extension $WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionRequestExtension
    on WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionRequest {
  WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionRequest
      copyWith({String? sourceOrderId, String? sessionId}) {
    return WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionRequest(
        sourceOrderId: sourceOrderId ?? this.sourceOrderId,
        sessionId: sessionId ?? this.sessionId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionResponse {
  WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionResponseExtension
    on WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionResponse {
  WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionResponse
      copyWith({int? status, bool? success, String? msg}) {
    return WebApiModulesHomeControlsServiceOrderItemCompleteServiceOrderSessionResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsServiceOrderItemCreateServiceOrderFromRepairResponse {
  WebApiModulesHomeControlsServiceOrderItemCreateServiceOrderFromRepairResponse({
    this.status,
    this.success,
    this.msg,
    this.order,
  });

  factory WebApiModulesHomeControlsServiceOrderItemCreateServiceOrderFromRepairResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsServiceOrderItemCreateServiceOrderFromRepairResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'order')
  final WebApiModulesAgentOrderOrder? order;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsServiceOrderItemCreateServiceOrderFromRepairResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsServiceOrderItemCreateServiceOrderFromRepairResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsServiceOrderItemCreateServiceOrderFromRepairResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsServiceOrderItemCreateServiceOrderFromRepairResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.order, order) ||
                const DeepCollectionEquality().equals(other.order, order)));
  }
}

extension $WebApiModulesHomeControlsServiceOrderItemCreateServiceOrderFromRepairResponseExtension
    on WebApiModulesHomeControlsServiceOrderItemCreateServiceOrderFromRepairResponse {
  WebApiModulesHomeControlsServiceOrderItemCreateServiceOrderFromRepairResponse
      copyWith(
          {int? status,
          bool? success,
          String? msg,
          WebApiModulesAgentOrderOrder? order}) {
    return WebApiModulesHomeControlsServiceOrderItemCreateServiceOrderFromRepairResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        order: order ?? this.order);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsServiceOrderItemServiceOrderItem {
  WebApiModulesHomeControlsServiceOrderItemServiceOrderItem({
    this.serviceOrderItemId,
    this.repairId,
    this.repairNumber,
    this.barCode,
    this.serialNumber,
    this.repairICode,
    this.trackedBy,
    this.repairDescription,
    this.quantity,
    this.repairInventoryId,
    this.warehouseId,
    this.warehouseCode,
    this.warehouse,
    this.repairCostId,
    this.repairPartId,
    this.itemOrder,
    this.notes,
    this.recType,
    this.recTypeDisplay,
    this.consignorId,
    this.consignorAgreementId,
    this.inventoryId,
    this.iCode,
    this.description,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsServiceOrderItemServiceOrderItem.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsServiceOrderItemServiceOrderItemFromJson(json);

  @JsonKey(name: 'ServiceOrderItemId')
  final String? serviceOrderItemId;
  @JsonKey(name: 'RepairId')
  final String? repairId;
  @JsonKey(name: 'RepairNumber')
  final String? repairNumber;
  @JsonKey(name: 'BarCode')
  final String? barCode;
  @JsonKey(name: 'SerialNumber')
  final String? serialNumber;
  @JsonKey(name: 'RepairICode')
  final String? repairICode;
  @JsonKey(name: 'TrackedBy')
  final String? trackedBy;
  @JsonKey(name: 'RepairDescription')
  final String? repairDescription;
  @JsonKey(name: 'Quantity')
  final double? quantity;
  @JsonKey(name: 'RepairInventoryId')
  final String? repairInventoryId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'RepairCostId')
  final String? repairCostId;
  @JsonKey(name: 'RepairPartId')
  final String? repairPartId;
  @JsonKey(name: 'ItemOrder')
  final String? itemOrder;
  @JsonKey(name: 'Notes')
  final String? notes;
  @JsonKey(name: 'RecType')
  final String? recType;
  @JsonKey(name: 'RecTypeDisplay')
  final String? recTypeDisplay;
  @JsonKey(name: 'ConsignorId')
  final String? consignorId;
  @JsonKey(name: 'ConsignorAgreementId')
  final String? consignorAgreementId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsServiceOrderItemServiceOrderItemFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsServiceOrderItemServiceOrderItemToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsServiceOrderItemServiceOrderItemToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsServiceOrderItemServiceOrderItem &&
            (identical(other.serviceOrderItemId, serviceOrderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.serviceOrderItemId, serviceOrderItemId)) &&
            (identical(other.repairId, repairId) ||
                const DeepCollectionEquality()
                    .equals(other.repairId, repairId)) &&
            (identical(other.repairNumber, repairNumber) ||
                const DeepCollectionEquality()
                    .equals(other.repairNumber, repairNumber)) &&
            (identical(other.barCode, barCode) ||
                const DeepCollectionEquality()
                    .equals(other.barCode, barCode)) &&
            (identical(other.serialNumber, serialNumber) ||
                const DeepCollectionEquality()
                    .equals(other.serialNumber, serialNumber)) &&
            (identical(other.repairICode, repairICode) ||
                const DeepCollectionEquality()
                    .equals(other.repairICode, repairICode)) &&
            (identical(other.trackedBy, trackedBy) ||
                const DeepCollectionEquality()
                    .equals(other.trackedBy, trackedBy)) &&
            (identical(other.repairDescription, repairDescription) ||
                const DeepCollectionEquality()
                    .equals(other.repairDescription, repairDescription)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)) &&
            (identical(other.repairInventoryId, repairInventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.repairInventoryId, repairInventoryId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouseCode, warehouseCode) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.warehouse, warehouse) ||
                const DeepCollectionEquality()
                    .equals(other.warehouse, warehouse)) &&
            (identical(other.repairCostId, repairCostId) ||
                const DeepCollectionEquality()
                    .equals(other.repairCostId, repairCostId)) &&
            (identical(other.repairPartId, repairPartId) ||
                const DeepCollectionEquality()
                    .equals(other.repairPartId, repairPartId)) &&
            (identical(other.itemOrder, itemOrder) ||
                const DeepCollectionEquality()
                    .equals(other.itemOrder, itemOrder)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.recType, recType) ||
                const DeepCollectionEquality()
                    .equals(other.recType, recType)) &&
            (identical(other.recTypeDisplay, recTypeDisplay) ||
                const DeepCollectionEquality()
                    .equals(other.recTypeDisplay, recTypeDisplay)) &&
            (identical(other.consignorId, consignorId) ||
                const DeepCollectionEquality()
                    .equals(other.consignorId, consignorId)) &&
            (identical(other.consignorAgreementId, consignorAgreementId) ||
                const DeepCollectionEquality().equals(
                    other.consignorAgreementId, consignorAgreementId)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.iCode, iCode) || const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) || const DeepCollectionEquality().equals(other.description, description)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsServiceOrderItemServiceOrderItemExtension
    on WebApiModulesHomeControlsServiceOrderItemServiceOrderItem {
  WebApiModulesHomeControlsServiceOrderItemServiceOrderItem copyWith(
      {String? serviceOrderItemId,
      String? repairId,
      String? repairNumber,
      String? barCode,
      String? serialNumber,
      String? repairICode,
      String? trackedBy,
      String? repairDescription,
      double? quantity,
      String? repairInventoryId,
      String? warehouseId,
      String? warehouseCode,
      String? warehouse,
      String? repairCostId,
      String? repairPartId,
      String? itemOrder,
      String? notes,
      String? recType,
      String? recTypeDisplay,
      String? consignorId,
      String? consignorAgreementId,
      String? inventoryId,
      String? iCode,
      String? description,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsServiceOrderItemServiceOrderItem(
        serviceOrderItemId: serviceOrderItemId ?? this.serviceOrderItemId,
        repairId: repairId ?? this.repairId,
        repairNumber: repairNumber ?? this.repairNumber,
        barCode: barCode ?? this.barCode,
        serialNumber: serialNumber ?? this.serialNumber,
        repairICode: repairICode ?? this.repairICode,
        trackedBy: trackedBy ?? this.trackedBy,
        repairDescription: repairDescription ?? this.repairDescription,
        quantity: quantity ?? this.quantity,
        repairInventoryId: repairInventoryId ?? this.repairInventoryId,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        warehouse: warehouse ?? this.warehouse,
        repairCostId: repairCostId ?? this.repairCostId,
        repairPartId: repairPartId ?? this.repairPartId,
        itemOrder: itemOrder ?? this.itemOrder,
        notes: notes ?? this.notes,
        recType: recType ?? this.recType,
        recTypeDisplay: recTypeDisplay ?? this.recTypeDisplay,
        consignorId: consignorId ?? this.consignorId,
        consignorAgreementId: consignorAgreementId ?? this.consignorAgreementId,
        inventoryId: inventoryId ?? this.inventoryId,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionRequest {
  WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionRequest({
    this.repairIds,
  });

  factory WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionRequestFromJson(
          json);

  @JsonKey(name: 'RepairIds')
  final String? repairIds;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionRequest &&
            (identical(other.repairIds, repairIds) ||
                const DeepCollectionEquality()
                    .equals(other.repairIds, repairIds)));
  }
}

extension $WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionRequestExtension
    on WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionRequest {
  WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionRequest
      copyWith({String? repairIds}) {
    return WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionRequest(
        repairIds: repairIds ?? this.repairIds);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionResponse {
  WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionResponse({
    this.status,
    this.success,
    this.msg,
    this.sessionId,
    this.items,
  });

  factory WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'SessionId')
  final String? sessionId;
  @JsonKey(name: 'Items')
  final int? items;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)) &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)));
  }
}

extension $WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionResponseExtension
    on WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionResponse {
  WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionResponse
      copyWith(
          {int? status,
          bool? success,
          String? msg,
          String? sessionId,
          int? items}) {
    return WebApiModulesHomeControlsServiceOrderItemStartServiceOrderSessionResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        sessionId: sessionId ?? this.sessionId,
        items: items ?? this.items);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemRequest {
  WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemRequest({
    this.sessionId,
  });

  factory WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemRequestFromJson(
          json);

  @JsonKey(name: 'SessionId')
  final String? sessionId;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemRequest &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)));
  }
}

extension $WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemRequestExtension
    on WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemRequest {
  WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemRequest
      copyWith({String? sessionId}) {
    return WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemRequest(
        sessionId: sessionId ?? this.sessionId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemResponse {
  WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemResponseExtension
    on WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemResponse {
  WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemResponse
      copyWith({int? status, bool? success, String? msg}) {
    return WebApiModulesHomeControlsSubPurchaseOrderItemSelectAllNonePoWorksheetItemResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItem {
  WebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItem({
    this.sessionId,
    this.orderId,
    this.orderItemId,
    this.parentId,
    this.inventoryId,
    this.iCode,
    this.iCodeColor,
    this.description,
    this.descriptionColor,
    this.nonDiscountable,
    this.isRecurring,
    this.prorateWeeks,
    this.prorateMonths,
    this.prorate,
    this.prorateMonthsBy,
    this.recurringRateType,
    this.isCrewPositionHourly,
    this.fromDate,
    this.toDate,
    this.hours,
    this.overTimeHours,
    this.doubleTimeHours,
    this.subQuantity,
    this.quantityOrdered,
    this.vendorRate,
    this.vendorDaysPerWeek,
    this.vendorDiscountPercent,
    this.vendorDiscountPercentDisplay,
    this.vendorBillablePeriods,
    this.vendorWeeklySubTotal,
    this.vendorWeeklyDiscount,
    this.vendorWeeklyExtended,
    this.vendorWeeklyTax,
    this.vendorWeeklyTotal,
    this.vendorMonthlySubTotal,
    this.vendorMonthlyDiscount,
    this.vendorMonthlyExtended,
    this.vendorMonthlyTax,
    this.vendorMonthlyTotal,
    this.vendorPeriodSubTotal,
    this.vendorPeriodDiscount,
    this.vendorPeriodExtended,
    this.vendorPeriodTax,
    this.vendorPeriodTotal,
    this.dealRate,
    this.dealDaysPerWeek,
    this.dealDiscountPercent,
    this.dealDiscountPercentDisplay,
    this.dealBillablePeriods,
    this.dealWeeklySubTotal,
    this.dealWeeklyDiscount,
    this.dealWeeklyExtended,
    this.dealMonthlySubTotal,
    this.dealMonthlyDiscount,
    this.dealMonthlyExtended,
    this.dealPeriodSubTotal,
    this.dealPeriodDiscount,
    this.dealPeriodExtended,
    this.variance,
    this.varianceColor,
    this.markupPercent,
    this.marginPercent,
    this.itemClass,
    this.itemOrder,
    this.optionColor,
    this.recType,
    this.taxable,
    this.unitId,
    this.nestedOrderItemId,
    this.accessoryRatio,
    this.vendorCurrencyId,
    this.vendorCurrencyCode,
    this.vendorCurrencySymbol,
    this.dealCurrencyId,
    this.dealCurrencyCode,
    this.dealCurrencySymbol,
    this.currencyExchangeRate,
    this.currencyConvertedRate,
    this.currencyConvertedWeeklyExtended,
    this.currencyConvertedMonthlyExtended,
    this.currencyConvertedPeriodExtended,
    this.nestingLevel,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItem.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItemFromJson(
          json);

  @JsonKey(name: 'SessionId')
  final String? sessionId;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderItemId')
  final String? orderItemId;
  @JsonKey(name: 'ParentId')
  final String? parentId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'ICodeColor')
  final String? iCodeColor;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'DescriptionColor')
  final String? descriptionColor;
  @JsonKey(name: 'NonDiscountable')
  final bool? nonDiscountable;
  @JsonKey(name: 'IsRecurring')
  final bool? isRecurring;
  @JsonKey(name: 'ProrateWeeks')
  final bool? prorateWeeks;
  @JsonKey(name: 'ProrateMonths')
  final bool? prorateMonths;
  @JsonKey(name: 'Prorate')
  final bool? prorate;
  @JsonKey(name: 'ProrateMonthsBy')
  final String? prorateMonthsBy;
  @JsonKey(name: 'RecurringRateType')
  final bool? recurringRateType;
  @JsonKey(name: 'IsCrewPositionHourly')
  final bool? isCrewPositionHourly;
  @JsonKey(name: 'FromDate')
  final String? fromDate;
  @JsonKey(name: 'ToDate')
  final String? toDate;
  @JsonKey(name: 'Hours')
  final double? hours;
  @JsonKey(name: 'OverTimeHours')
  final double? overTimeHours;
  @JsonKey(name: 'DoubleTimeHours')
  final double? doubleTimeHours;
  @JsonKey(name: 'SubQuantity')
  final double? subQuantity;
  @JsonKey(name: 'QuantityOrdered')
  final double? quantityOrdered;
  @JsonKey(name: 'VendorRate')
  final double? vendorRate;
  @JsonKey(name: 'VendorDaysPerWeek')
  final double? vendorDaysPerWeek;
  @JsonKey(name: 'VendorDiscountPercent')
  final double? vendorDiscountPercent;
  @JsonKey(name: 'VendorDiscountPercentDisplay')
  final double? vendorDiscountPercentDisplay;
  @JsonKey(name: 'VendorBillablePeriods')
  final double? vendorBillablePeriods;
  @JsonKey(name: 'VendorWeeklySubTotal')
  final double? vendorWeeklySubTotal;
  @JsonKey(name: 'VendorWeeklyDiscount')
  final double? vendorWeeklyDiscount;
  @JsonKey(name: 'VendorWeeklyExtended')
  final double? vendorWeeklyExtended;
  @JsonKey(name: 'VendorWeeklyTax')
  final double? vendorWeeklyTax;
  @JsonKey(name: 'VendorWeeklyTotal')
  final double? vendorWeeklyTotal;
  @JsonKey(name: 'VendorMonthlySubTotal')
  final double? vendorMonthlySubTotal;
  @JsonKey(name: 'VendorMonthlyDiscount')
  final double? vendorMonthlyDiscount;
  @JsonKey(name: 'VendorMonthlyExtended')
  final double? vendorMonthlyExtended;
  @JsonKey(name: 'VendorMonthlyTax')
  final double? vendorMonthlyTax;
  @JsonKey(name: 'VendorMonthlyTotal')
  final double? vendorMonthlyTotal;
  @JsonKey(name: 'VendorPeriodSubTotal')
  final double? vendorPeriodSubTotal;
  @JsonKey(name: 'VendorPeriodDiscount')
  final double? vendorPeriodDiscount;
  @JsonKey(name: 'VendorPeriodExtended')
  final double? vendorPeriodExtended;
  @JsonKey(name: 'VendorPeriodTax')
  final double? vendorPeriodTax;
  @JsonKey(name: 'VendorPeriodTotal')
  final double? vendorPeriodTotal;
  @JsonKey(name: 'DealRate')
  final double? dealRate;
  @JsonKey(name: 'DealDaysPerWeek')
  final double? dealDaysPerWeek;
  @JsonKey(name: 'DealDiscountPercent')
  final double? dealDiscountPercent;
  @JsonKey(name: 'DealDiscountPercentDisplay')
  final double? dealDiscountPercentDisplay;
  @JsonKey(name: 'DealBillablePeriods')
  final double? dealBillablePeriods;
  @JsonKey(name: 'DealWeeklySubTotal')
  final double? dealWeeklySubTotal;
  @JsonKey(name: 'DealWeeklyDiscount')
  final double? dealWeeklyDiscount;
  @JsonKey(name: 'DealWeeklyExtended')
  final double? dealWeeklyExtended;
  @JsonKey(name: 'DealMonthlySubTotal')
  final double? dealMonthlySubTotal;
  @JsonKey(name: 'DealMonthlyDiscount')
  final double? dealMonthlyDiscount;
  @JsonKey(name: 'DealMonthlyExtended')
  final double? dealMonthlyExtended;
  @JsonKey(name: 'DealPeriodSubTotal')
  final double? dealPeriodSubTotal;
  @JsonKey(name: 'DealPeriodDiscount')
  final double? dealPeriodDiscount;
  @JsonKey(name: 'DealPeriodExtended')
  final double? dealPeriodExtended;
  @JsonKey(name: 'Variance')
  final double? variance;
  @JsonKey(name: 'VarianceColor')
  final String? varianceColor;
  @JsonKey(name: 'MarkupPercent')
  final double? markupPercent;
  @JsonKey(name: 'MarginPercent')
  final double? marginPercent;
  @JsonKey(name: 'ItemClass')
  final String? itemClass;
  @JsonKey(name: 'ItemOrder')
  final String? itemOrder;
  @JsonKey(name: 'OptionColor')
  final bool? optionColor;
  @JsonKey(name: 'RecType')
  final String? recType;
  @JsonKey(name: 'Taxable')
  final bool? taxable;
  @JsonKey(name: 'UnitId')
  final String? unitId;
  @JsonKey(name: 'NestedOrderItemId')
  final String? nestedOrderItemId;
  @JsonKey(name: 'AccessoryRatio')
  final double? accessoryRatio;
  @JsonKey(name: 'VendorCurrencyId')
  final String? vendorCurrencyId;
  @JsonKey(name: 'VendorCurrencyCode')
  final String? vendorCurrencyCode;
  @JsonKey(name: 'VendorCurrencySymbol')
  final String? vendorCurrencySymbol;
  @JsonKey(name: 'DealCurrencyId')
  final String? dealCurrencyId;
  @JsonKey(name: 'DealCurrencyCode')
  final String? dealCurrencyCode;
  @JsonKey(name: 'DealCurrencySymbol')
  final String? dealCurrencySymbol;
  @JsonKey(name: 'CurrencyExchangeRate')
  final double? currencyExchangeRate;
  @JsonKey(name: 'CurrencyConvertedRate')
  final double? currencyConvertedRate;
  @JsonKey(name: 'CurrencyConvertedWeeklyExtended')
  final double? currencyConvertedWeeklyExtended;
  @JsonKey(name: 'CurrencyConvertedMonthlyExtended')
  final double? currencyConvertedMonthlyExtended;
  @JsonKey(name: 'CurrencyConvertedPeriodExtended')
  final double? currencyConvertedPeriodExtended;
  @JsonKey(name: 'NestingLevel')
  final int? nestingLevel;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItemFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItemToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItemToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItem &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderItemId, orderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.orderItemId, orderItemId)) &&
            (identical(other.parentId, parentId) ||
                const DeepCollectionEquality()
                    .equals(other.parentId, parentId)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.iCodeColor, iCodeColor) ||
                const DeepCollectionEquality()
                    .equals(other.iCodeColor, iCodeColor)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.descriptionColor, descriptionColor) ||
                const DeepCollectionEquality()
                    .equals(other.descriptionColor, descriptionColor)) &&
            (identical(other.nonDiscountable, nonDiscountable) ||
                const DeepCollectionEquality()
                    .equals(other.nonDiscountable, nonDiscountable)) &&
            (identical(other.isRecurring, isRecurring) ||
                const DeepCollectionEquality()
                    .equals(other.isRecurring, isRecurring)) &&
            (identical(other.prorateWeeks, prorateWeeks) ||
                const DeepCollectionEquality()
                    .equals(other.prorateWeeks, prorateWeeks)) &&
            (identical(other.prorateMonths, prorateMonths) ||
                const DeepCollectionEquality()
                    .equals(other.prorateMonths, prorateMonths)) &&
            (identical(other.prorate, prorate) ||
                const DeepCollectionEquality()
                    .equals(other.prorate, prorate)) &&
            (identical(other.prorateMonthsBy, prorateMonthsBy) ||
                const DeepCollectionEquality()
                    .equals(other.prorateMonthsBy, prorateMonthsBy)) &&
            (identical(other.recurringRateType, recurringRateType) ||
                const DeepCollectionEquality()
                    .equals(other.recurringRateType, recurringRateType)) &&
            (identical(other.isCrewPositionHourly, isCrewPositionHourly) ||
                const DeepCollectionEquality().equals(other.isCrewPositionHourly, isCrewPositionHourly)) &&
            (identical(other.fromDate, fromDate) || const DeepCollectionEquality().equals(other.fromDate, fromDate)) &&
            (identical(other.toDate, toDate) || const DeepCollectionEquality().equals(other.toDate, toDate)) &&
            (identical(other.hours, hours) || const DeepCollectionEquality().equals(other.hours, hours)) &&
            (identical(other.overTimeHours, overTimeHours) || const DeepCollectionEquality().equals(other.overTimeHours, overTimeHours)) &&
            (identical(other.doubleTimeHours, doubleTimeHours) || const DeepCollectionEquality().equals(other.doubleTimeHours, doubleTimeHours)) &&
            (identical(other.subQuantity, subQuantity) || const DeepCollectionEquality().equals(other.subQuantity, subQuantity)) &&
            (identical(other.quantityOrdered, quantityOrdered) || const DeepCollectionEquality().equals(other.quantityOrdered, quantityOrdered)) &&
            (identical(other.vendorRate, vendorRate) || const DeepCollectionEquality().equals(other.vendorRate, vendorRate)) &&
            (identical(other.vendorDaysPerWeek, vendorDaysPerWeek) || const DeepCollectionEquality().equals(other.vendorDaysPerWeek, vendorDaysPerWeek)) &&
            (identical(other.vendorDiscountPercent, vendorDiscountPercent) || const DeepCollectionEquality().equals(other.vendorDiscountPercent, vendorDiscountPercent)) &&
            (identical(other.vendorDiscountPercentDisplay, vendorDiscountPercentDisplay) || const DeepCollectionEquality().equals(other.vendorDiscountPercentDisplay, vendorDiscountPercentDisplay)) &&
            (identical(other.vendorBillablePeriods, vendorBillablePeriods) || const DeepCollectionEquality().equals(other.vendorBillablePeriods, vendorBillablePeriods)) &&
            (identical(other.vendorWeeklySubTotal, vendorWeeklySubTotal) || const DeepCollectionEquality().equals(other.vendorWeeklySubTotal, vendorWeeklySubTotal)) &&
            (identical(other.vendorWeeklyDiscount, vendorWeeklyDiscount) || const DeepCollectionEquality().equals(other.vendorWeeklyDiscount, vendorWeeklyDiscount)) &&
            (identical(other.vendorWeeklyExtended, vendorWeeklyExtended) || const DeepCollectionEquality().equals(other.vendorWeeklyExtended, vendorWeeklyExtended)) &&
            (identical(other.vendorWeeklyTax, vendorWeeklyTax) || const DeepCollectionEquality().equals(other.vendorWeeklyTax, vendorWeeklyTax)) &&
            (identical(other.vendorWeeklyTotal, vendorWeeklyTotal) || const DeepCollectionEquality().equals(other.vendorWeeklyTotal, vendorWeeklyTotal)) &&
            (identical(other.vendorMonthlySubTotal, vendorMonthlySubTotal) || const DeepCollectionEquality().equals(other.vendorMonthlySubTotal, vendorMonthlySubTotal)) &&
            (identical(other.vendorMonthlyDiscount, vendorMonthlyDiscount) || const DeepCollectionEquality().equals(other.vendorMonthlyDiscount, vendorMonthlyDiscount)) &&
            (identical(other.vendorMonthlyExtended, vendorMonthlyExtended) || const DeepCollectionEquality().equals(other.vendorMonthlyExtended, vendorMonthlyExtended)) &&
            (identical(other.vendorMonthlyTax, vendorMonthlyTax) || const DeepCollectionEquality().equals(other.vendorMonthlyTax, vendorMonthlyTax)) &&
            (identical(other.vendorMonthlyTotal, vendorMonthlyTotal) || const DeepCollectionEquality().equals(other.vendorMonthlyTotal, vendorMonthlyTotal)) &&
            (identical(other.vendorPeriodSubTotal, vendorPeriodSubTotal) || const DeepCollectionEquality().equals(other.vendorPeriodSubTotal, vendorPeriodSubTotal)) &&
            (identical(other.vendorPeriodDiscount, vendorPeriodDiscount) || const DeepCollectionEquality().equals(other.vendorPeriodDiscount, vendorPeriodDiscount)) &&
            (identical(other.vendorPeriodExtended, vendorPeriodExtended) || const DeepCollectionEquality().equals(other.vendorPeriodExtended, vendorPeriodExtended)) &&
            (identical(other.vendorPeriodTax, vendorPeriodTax) || const DeepCollectionEquality().equals(other.vendorPeriodTax, vendorPeriodTax)) &&
            (identical(other.vendorPeriodTotal, vendorPeriodTotal) || const DeepCollectionEquality().equals(other.vendorPeriodTotal, vendorPeriodTotal)) &&
            (identical(other.dealRate, dealRate) || const DeepCollectionEquality().equals(other.dealRate, dealRate)) &&
            (identical(other.dealDaysPerWeek, dealDaysPerWeek) || const DeepCollectionEquality().equals(other.dealDaysPerWeek, dealDaysPerWeek)) &&
            (identical(other.dealDiscountPercent, dealDiscountPercent) || const DeepCollectionEquality().equals(other.dealDiscountPercent, dealDiscountPercent)) &&
            (identical(other.dealDiscountPercentDisplay, dealDiscountPercentDisplay) || const DeepCollectionEquality().equals(other.dealDiscountPercentDisplay, dealDiscountPercentDisplay)) &&
            (identical(other.dealBillablePeriods, dealBillablePeriods) || const DeepCollectionEquality().equals(other.dealBillablePeriods, dealBillablePeriods)) &&
            (identical(other.dealWeeklySubTotal, dealWeeklySubTotal) || const DeepCollectionEquality().equals(other.dealWeeklySubTotal, dealWeeklySubTotal)) &&
            (identical(other.dealWeeklyDiscount, dealWeeklyDiscount) || const DeepCollectionEquality().equals(other.dealWeeklyDiscount, dealWeeklyDiscount)) &&
            (identical(other.dealWeeklyExtended, dealWeeklyExtended) || const DeepCollectionEquality().equals(other.dealWeeklyExtended, dealWeeklyExtended)) &&
            (identical(other.dealMonthlySubTotal, dealMonthlySubTotal) || const DeepCollectionEquality().equals(other.dealMonthlySubTotal, dealMonthlySubTotal)) &&
            (identical(other.dealMonthlyDiscount, dealMonthlyDiscount) || const DeepCollectionEquality().equals(other.dealMonthlyDiscount, dealMonthlyDiscount)) &&
            (identical(other.dealMonthlyExtended, dealMonthlyExtended) || const DeepCollectionEquality().equals(other.dealMonthlyExtended, dealMonthlyExtended)) &&
            (identical(other.dealPeriodSubTotal, dealPeriodSubTotal) || const DeepCollectionEquality().equals(other.dealPeriodSubTotal, dealPeriodSubTotal)) &&
            (identical(other.dealPeriodDiscount, dealPeriodDiscount) || const DeepCollectionEquality().equals(other.dealPeriodDiscount, dealPeriodDiscount)) &&
            (identical(other.dealPeriodExtended, dealPeriodExtended) || const DeepCollectionEquality().equals(other.dealPeriodExtended, dealPeriodExtended)) &&
            (identical(other.variance, variance) || const DeepCollectionEquality().equals(other.variance, variance)) &&
            (identical(other.varianceColor, varianceColor) || const DeepCollectionEquality().equals(other.varianceColor, varianceColor)) &&
            (identical(other.markupPercent, markupPercent) || const DeepCollectionEquality().equals(other.markupPercent, markupPercent)) &&
            (identical(other.marginPercent, marginPercent) || const DeepCollectionEquality().equals(other.marginPercent, marginPercent)) &&
            (identical(other.itemClass, itemClass) || const DeepCollectionEquality().equals(other.itemClass, itemClass)) &&
            (identical(other.itemOrder, itemOrder) || const DeepCollectionEquality().equals(other.itemOrder, itemOrder)) &&
            (identical(other.optionColor, optionColor) || const DeepCollectionEquality().equals(other.optionColor, optionColor)) &&
            (identical(other.recType, recType) || const DeepCollectionEquality().equals(other.recType, recType)) &&
            (identical(other.taxable, taxable) || const DeepCollectionEquality().equals(other.taxable, taxable)) &&
            (identical(other.unitId, unitId) || const DeepCollectionEquality().equals(other.unitId, unitId)) &&
            (identical(other.nestedOrderItemId, nestedOrderItemId) || const DeepCollectionEquality().equals(other.nestedOrderItemId, nestedOrderItemId)) &&
            (identical(other.accessoryRatio, accessoryRatio) || const DeepCollectionEquality().equals(other.accessoryRatio, accessoryRatio)) &&
            (identical(other.vendorCurrencyId, vendorCurrencyId) || const DeepCollectionEquality().equals(other.vendorCurrencyId, vendorCurrencyId)) &&
            (identical(other.vendorCurrencyCode, vendorCurrencyCode) || const DeepCollectionEquality().equals(other.vendorCurrencyCode, vendorCurrencyCode)) &&
            (identical(other.vendorCurrencySymbol, vendorCurrencySymbol) || const DeepCollectionEquality().equals(other.vendorCurrencySymbol, vendorCurrencySymbol)) &&
            (identical(other.dealCurrencyId, dealCurrencyId) || const DeepCollectionEquality().equals(other.dealCurrencyId, dealCurrencyId)) &&
            (identical(other.dealCurrencyCode, dealCurrencyCode) || const DeepCollectionEquality().equals(other.dealCurrencyCode, dealCurrencyCode)) &&
            (identical(other.dealCurrencySymbol, dealCurrencySymbol) || const DeepCollectionEquality().equals(other.dealCurrencySymbol, dealCurrencySymbol)) &&
            (identical(other.currencyExchangeRate, currencyExchangeRate) || const DeepCollectionEquality().equals(other.currencyExchangeRate, currencyExchangeRate)) &&
            (identical(other.currencyConvertedRate, currencyConvertedRate) || const DeepCollectionEquality().equals(other.currencyConvertedRate, currencyConvertedRate)) &&
            (identical(other.currencyConvertedWeeklyExtended, currencyConvertedWeeklyExtended) || const DeepCollectionEquality().equals(other.currencyConvertedWeeklyExtended, currencyConvertedWeeklyExtended)) &&
            (identical(other.currencyConvertedMonthlyExtended, currencyConvertedMonthlyExtended) || const DeepCollectionEquality().equals(other.currencyConvertedMonthlyExtended, currencyConvertedMonthlyExtended)) &&
            (identical(other.currencyConvertedPeriodExtended, currencyConvertedPeriodExtended) || const DeepCollectionEquality().equals(other.currencyConvertedPeriodExtended, currencyConvertedPeriodExtended)) &&
            (identical(other.nestingLevel, nestingLevel) || const DeepCollectionEquality().equals(other.nestingLevel, nestingLevel)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItemExtension
    on WebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItem {
  WebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItem copyWith(
      {String? sessionId,
      String? orderId,
      String? orderItemId,
      String? parentId,
      String? inventoryId,
      String? iCode,
      String? iCodeColor,
      String? description,
      String? descriptionColor,
      bool? nonDiscountable,
      bool? isRecurring,
      bool? prorateWeeks,
      bool? prorateMonths,
      bool? prorate,
      String? prorateMonthsBy,
      bool? recurringRateType,
      bool? isCrewPositionHourly,
      String? fromDate,
      String? toDate,
      double? hours,
      double? overTimeHours,
      double? doubleTimeHours,
      double? subQuantity,
      double? quantityOrdered,
      double? vendorRate,
      double? vendorDaysPerWeek,
      double? vendorDiscountPercent,
      double? vendorDiscountPercentDisplay,
      double? vendorBillablePeriods,
      double? vendorWeeklySubTotal,
      double? vendorWeeklyDiscount,
      double? vendorWeeklyExtended,
      double? vendorWeeklyTax,
      double? vendorWeeklyTotal,
      double? vendorMonthlySubTotal,
      double? vendorMonthlyDiscount,
      double? vendorMonthlyExtended,
      double? vendorMonthlyTax,
      double? vendorMonthlyTotal,
      double? vendorPeriodSubTotal,
      double? vendorPeriodDiscount,
      double? vendorPeriodExtended,
      double? vendorPeriodTax,
      double? vendorPeriodTotal,
      double? dealRate,
      double? dealDaysPerWeek,
      double? dealDiscountPercent,
      double? dealDiscountPercentDisplay,
      double? dealBillablePeriods,
      double? dealWeeklySubTotal,
      double? dealWeeklyDiscount,
      double? dealWeeklyExtended,
      double? dealMonthlySubTotal,
      double? dealMonthlyDiscount,
      double? dealMonthlyExtended,
      double? dealPeriodSubTotal,
      double? dealPeriodDiscount,
      double? dealPeriodExtended,
      double? variance,
      String? varianceColor,
      double? markupPercent,
      double? marginPercent,
      String? itemClass,
      String? itemOrder,
      bool? optionColor,
      String? recType,
      bool? taxable,
      String? unitId,
      String? nestedOrderItemId,
      double? accessoryRatio,
      String? vendorCurrencyId,
      String? vendorCurrencyCode,
      String? vendorCurrencySymbol,
      String? dealCurrencyId,
      String? dealCurrencyCode,
      String? dealCurrencySymbol,
      double? currencyExchangeRate,
      double? currencyConvertedRate,
      double? currencyConvertedWeeklyExtended,
      double? currencyConvertedMonthlyExtended,
      double? currencyConvertedPeriodExtended,
      int? nestingLevel,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsSubPurchaseOrderItemSubPurchaseOrderItem(
        sessionId: sessionId ?? this.sessionId,
        orderId: orderId ?? this.orderId,
        orderItemId: orderItemId ?? this.orderItemId,
        parentId: parentId ?? this.parentId,
        inventoryId: inventoryId ?? this.inventoryId,
        iCode: iCode ?? this.iCode,
        iCodeColor: iCodeColor ?? this.iCodeColor,
        description: description ?? this.description,
        descriptionColor: descriptionColor ?? this.descriptionColor,
        nonDiscountable: nonDiscountable ?? this.nonDiscountable,
        isRecurring: isRecurring ?? this.isRecurring,
        prorateWeeks: prorateWeeks ?? this.prorateWeeks,
        prorateMonths: prorateMonths ?? this.prorateMonths,
        prorate: prorate ?? this.prorate,
        prorateMonthsBy: prorateMonthsBy ?? this.prorateMonthsBy,
        recurringRateType: recurringRateType ?? this.recurringRateType,
        isCrewPositionHourly: isCrewPositionHourly ?? this.isCrewPositionHourly,
        fromDate: fromDate ?? this.fromDate,
        toDate: toDate ?? this.toDate,
        hours: hours ?? this.hours,
        overTimeHours: overTimeHours ?? this.overTimeHours,
        doubleTimeHours: doubleTimeHours ?? this.doubleTimeHours,
        subQuantity: subQuantity ?? this.subQuantity,
        quantityOrdered: quantityOrdered ?? this.quantityOrdered,
        vendorRate: vendorRate ?? this.vendorRate,
        vendorDaysPerWeek: vendorDaysPerWeek ?? this.vendorDaysPerWeek,
        vendorDiscountPercent:
            vendorDiscountPercent ?? this.vendorDiscountPercent,
        vendorDiscountPercentDisplay:
            vendorDiscountPercentDisplay ?? this.vendorDiscountPercentDisplay,
        vendorBillablePeriods:
            vendorBillablePeriods ?? this.vendorBillablePeriods,
        vendorWeeklySubTotal: vendorWeeklySubTotal ?? this.vendorWeeklySubTotal,
        vendorWeeklyDiscount: vendorWeeklyDiscount ?? this.vendorWeeklyDiscount,
        vendorWeeklyExtended: vendorWeeklyExtended ?? this.vendorWeeklyExtended,
        vendorWeeklyTax: vendorWeeklyTax ?? this.vendorWeeklyTax,
        vendorWeeklyTotal: vendorWeeklyTotal ?? this.vendorWeeklyTotal,
        vendorMonthlySubTotal:
            vendorMonthlySubTotal ?? this.vendorMonthlySubTotal,
        vendorMonthlyDiscount:
            vendorMonthlyDiscount ?? this.vendorMonthlyDiscount,
        vendorMonthlyExtended:
            vendorMonthlyExtended ?? this.vendorMonthlyExtended,
        vendorMonthlyTax: vendorMonthlyTax ?? this.vendorMonthlyTax,
        vendorMonthlyTotal: vendorMonthlyTotal ?? this.vendorMonthlyTotal,
        vendorPeriodSubTotal: vendorPeriodSubTotal ?? this.vendorPeriodSubTotal,
        vendorPeriodDiscount: vendorPeriodDiscount ?? this.vendorPeriodDiscount,
        vendorPeriodExtended: vendorPeriodExtended ?? this.vendorPeriodExtended,
        vendorPeriodTax: vendorPeriodTax ?? this.vendorPeriodTax,
        vendorPeriodTotal: vendorPeriodTotal ?? this.vendorPeriodTotal,
        dealRate: dealRate ?? this.dealRate,
        dealDaysPerWeek: dealDaysPerWeek ?? this.dealDaysPerWeek,
        dealDiscountPercent: dealDiscountPercent ?? this.dealDiscountPercent,
        dealDiscountPercentDisplay:
            dealDiscountPercentDisplay ?? this.dealDiscountPercentDisplay,
        dealBillablePeriods: dealBillablePeriods ?? this.dealBillablePeriods,
        dealWeeklySubTotal: dealWeeklySubTotal ?? this.dealWeeklySubTotal,
        dealWeeklyDiscount: dealWeeklyDiscount ?? this.dealWeeklyDiscount,
        dealWeeklyExtended: dealWeeklyExtended ?? this.dealWeeklyExtended,
        dealMonthlySubTotal: dealMonthlySubTotal ?? this.dealMonthlySubTotal,
        dealMonthlyDiscount: dealMonthlyDiscount ?? this.dealMonthlyDiscount,
        dealMonthlyExtended: dealMonthlyExtended ?? this.dealMonthlyExtended,
        dealPeriodSubTotal: dealPeriodSubTotal ?? this.dealPeriodSubTotal,
        dealPeriodDiscount: dealPeriodDiscount ?? this.dealPeriodDiscount,
        dealPeriodExtended: dealPeriodExtended ?? this.dealPeriodExtended,
        variance: variance ?? this.variance,
        varianceColor: varianceColor ?? this.varianceColor,
        markupPercent: markupPercent ?? this.markupPercent,
        marginPercent: marginPercent ?? this.marginPercent,
        itemClass: itemClass ?? this.itemClass,
        itemOrder: itemOrder ?? this.itemOrder,
        optionColor: optionColor ?? this.optionColor,
        recType: recType ?? this.recType,
        taxable: taxable ?? this.taxable,
        unitId: unitId ?? this.unitId,
        nestedOrderItemId: nestedOrderItemId ?? this.nestedOrderItemId,
        accessoryRatio: accessoryRatio ?? this.accessoryRatio,
        vendorCurrencyId: vendorCurrencyId ?? this.vendorCurrencyId,
        vendorCurrencyCode: vendorCurrencyCode ?? this.vendorCurrencyCode,
        vendorCurrencySymbol: vendorCurrencySymbol ?? this.vendorCurrencySymbol,
        dealCurrencyId: dealCurrencyId ?? this.dealCurrencyId,
        dealCurrencyCode: dealCurrencyCode ?? this.dealCurrencyCode,
        dealCurrencySymbol: dealCurrencySymbol ?? this.dealCurrencySymbol,
        currencyExchangeRate: currencyExchangeRate ?? this.currencyExchangeRate,
        currencyConvertedRate:
            currencyConvertedRate ?? this.currencyConvertedRate,
        currencyConvertedWeeklyExtended: currencyConvertedWeeklyExtended ??
            this.currencyConvertedWeeklyExtended,
        currencyConvertedMonthlyExtended: currencyConvertedMonthlyExtended ??
            this.currencyConvertedMonthlyExtended,
        currencyConvertedPeriodExtended: currencyConvertedPeriodExtended ??
            this.currencyConvertedPeriodExtended,
        nestingLevel: nestingLevel ?? this.nestingLevel,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsSuspendedSessionSuspendedSession {
  WebApiModulesHomeControlsSuspendedSessionSuspendedSession({
    this.contractId,
    this.sessionNumber,
    this.deal,
    this.dealNumber,
    this.dealOrVendor,
    this.orderNumber,
    this.orderDescription,
    this.orderId,
    this.userName,
    this.userNameFirstMiddleLast,
    this.status,
    this.statusDate,
    this.usersId,
    this.contractDate,
    this.contractTime,
    this.dealId,
    this.departmentId,
    this.officeLocationId,
    this.warehouseId,
    this.warehouse,
    this.exchangeContractId,
    this.contractType,
    this.isForcedSuspend,
    this.containerItemId,
    this.containerScannableItemId,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsSuspendedSessionSuspendedSession.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsSuspendedSessionSuspendedSessionFromJson(json);

  @JsonKey(name: 'ContractId')
  final String? contractId;
  @JsonKey(name: 'SessionNumber')
  final int? sessionNumber;
  @JsonKey(name: 'Deal')
  final String? deal;
  @JsonKey(name: 'DealNumber')
  final String? dealNumber;
  @JsonKey(name: 'DealOrVendor')
  final String? dealOrVendor;
  @JsonKey(name: 'OrderNumber')
  final String? orderNumber;
  @JsonKey(name: 'OrderDescription')
  final String? orderDescription;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'UserName')
  final String? userName;
  @JsonKey(name: 'UserNameFirstMiddleLast')
  final String? userNameFirstMiddleLast;
  @JsonKey(name: 'Status')
  final String? status;
  @JsonKey(name: 'StatusDate')
  final String? statusDate;
  @JsonKey(name: 'UsersId')
  final String? usersId;
  @JsonKey(name: 'ContractDate')
  final String? contractDate;
  @JsonKey(name: 'ContractTime')
  final String? contractTime;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'OfficeLocationId')
  final String? officeLocationId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'ExchangeContractId')
  final String? exchangeContractId;
  @JsonKey(name: 'ContractType')
  final String? contractType;
  @JsonKey(name: 'IsForcedSuspend')
  final bool? isForcedSuspend;
  @JsonKey(name: 'ContainerItemId')
  final String? containerItemId;
  @JsonKey(name: 'ContainerScannableItemId')
  final String? containerScannableItemId;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsSuspendedSessionSuspendedSessionFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsSuspendedSessionSuspendedSessionToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsSuspendedSessionSuspendedSessionToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsSuspendedSessionSuspendedSession &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)) &&
            (identical(other.sessionNumber, sessionNumber) ||
                const DeepCollectionEquality()
                    .equals(other.sessionNumber, sessionNumber)) &&
            (identical(other.deal, deal) ||
                const DeepCollectionEquality().equals(other.deal, deal)) &&
            (identical(other.dealNumber, dealNumber) ||
                const DeepCollectionEquality()
                    .equals(other.dealNumber, dealNumber)) &&
            (identical(other.dealOrVendor, dealOrVendor) ||
                const DeepCollectionEquality()
                    .equals(other.dealOrVendor, dealOrVendor)) &&
            (identical(other.orderNumber, orderNumber) ||
                const DeepCollectionEquality()
                    .equals(other.orderNumber, orderNumber)) &&
            (identical(other.orderDescription, orderDescription) ||
                const DeepCollectionEquality()
                    .equals(other.orderDescription, orderDescription)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.userName, userName) ||
                const DeepCollectionEquality()
                    .equals(other.userName, userName)) &&
            (identical(other.userNameFirstMiddleLast, userNameFirstMiddleLast) ||
                const DeepCollectionEquality().equals(
                    other.userNameFirstMiddleLast, userNameFirstMiddleLast)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.statusDate, statusDate) ||
                const DeepCollectionEquality()
                    .equals(other.statusDate, statusDate)) &&
            (identical(other.usersId, usersId) ||
                const DeepCollectionEquality()
                    .equals(other.usersId, usersId)) &&
            (identical(other.contractDate, contractDate) ||
                const DeepCollectionEquality()
                    .equals(other.contractDate, contractDate)) &&
            (identical(other.contractTime, contractTime) ||
                const DeepCollectionEquality()
                    .equals(other.contractTime, contractTime)) &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.departmentId, departmentId) ||
                const DeepCollectionEquality()
                    .equals(other.departmentId, departmentId)) &&
            (identical(other.officeLocationId, officeLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocationId, officeLocationId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouse, warehouse) ||
                const DeepCollectionEquality()
                    .equals(other.warehouse, warehouse)) &&
            (identical(other.exchangeContractId, exchangeContractId) || const DeepCollectionEquality().equals(other.exchangeContractId, exchangeContractId)) &&
            (identical(other.contractType, contractType) || const DeepCollectionEquality().equals(other.contractType, contractType)) &&
            (identical(other.isForcedSuspend, isForcedSuspend) || const DeepCollectionEquality().equals(other.isForcedSuspend, isForcedSuspend)) &&
            (identical(other.containerItemId, containerItemId) || const DeepCollectionEquality().equals(other.containerItemId, containerItemId)) &&
            (identical(other.containerScannableItemId, containerScannableItemId) || const DeepCollectionEquality().equals(other.containerScannableItemId, containerScannableItemId)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsSuspendedSessionSuspendedSessionExtension
    on WebApiModulesHomeControlsSuspendedSessionSuspendedSession {
  WebApiModulesHomeControlsSuspendedSessionSuspendedSession copyWith(
      {String? contractId,
      int? sessionNumber,
      String? deal,
      String? dealNumber,
      String? dealOrVendor,
      String? orderNumber,
      String? orderDescription,
      String? orderId,
      String? userName,
      String? userNameFirstMiddleLast,
      String? status,
      String? statusDate,
      String? usersId,
      String? contractDate,
      String? contractTime,
      String? dealId,
      String? departmentId,
      String? officeLocationId,
      String? warehouseId,
      String? warehouse,
      String? exchangeContractId,
      String? contractType,
      bool? isForcedSuspend,
      String? containerItemId,
      String? containerScannableItemId,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsSuspendedSessionSuspendedSession(
        contractId: contractId ?? this.contractId,
        sessionNumber: sessionNumber ?? this.sessionNumber,
        deal: deal ?? this.deal,
        dealNumber: dealNumber ?? this.dealNumber,
        dealOrVendor: dealOrVendor ?? this.dealOrVendor,
        orderNumber: orderNumber ?? this.orderNumber,
        orderDescription: orderDescription ?? this.orderDescription,
        orderId: orderId ?? this.orderId,
        userName: userName ?? this.userName,
        userNameFirstMiddleLast:
            userNameFirstMiddleLast ?? this.userNameFirstMiddleLast,
        status: status ?? this.status,
        statusDate: statusDate ?? this.statusDate,
        usersId: usersId ?? this.usersId,
        contractDate: contractDate ?? this.contractDate,
        contractTime: contractTime ?? this.contractTime,
        dealId: dealId ?? this.dealId,
        departmentId: departmentId ?? this.departmentId,
        officeLocationId: officeLocationId ?? this.officeLocationId,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouse: warehouse ?? this.warehouse,
        exchangeContractId: exchangeContractId ?? this.exchangeContractId,
        contractType: contractType ?? this.contractType,
        isForcedSuspend: isForcedSuspend ?? this.isForcedSuspend,
        containerItemId: containerItemId ?? this.containerItemId,
        containerScannableItemId:
            containerScannableItemId ?? this.containerScannableItemId,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsTaxableTaxable {
  WebApiModulesHomeControlsTaxableTaxable({
    this.masterId,
    this.locationId,
    this.location,
    this.taxable,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsTaxableTaxable.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsTaxableTaxableFromJson(json);

  @JsonKey(name: 'MasterId')
  final String? masterId;
  @JsonKey(name: 'LocationId')
  final String? locationId;
  @JsonKey(name: 'Location')
  final String? location;
  @JsonKey(name: 'Taxable')
  final bool? taxable;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsTaxableTaxableFromJson;
  static const toJsonFactory = _$WebApiModulesHomeControlsTaxableTaxableToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsTaxableTaxableToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsTaxableTaxable &&
            (identical(other.masterId, masterId) ||
                const DeepCollectionEquality()
                    .equals(other.masterId, masterId)) &&
            (identical(other.locationId, locationId) ||
                const DeepCollectionEquality()
                    .equals(other.locationId, locationId)) &&
            (identical(other.location, location) ||
                const DeepCollectionEquality()
                    .equals(other.location, location)) &&
            (identical(other.taxable, taxable) ||
                const DeepCollectionEquality()
                    .equals(other.taxable, taxable)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsTaxableTaxableExtension
    on WebApiModulesHomeControlsTaxableTaxable {
  WebApiModulesHomeControlsTaxableTaxable copyWith(
      {String? masterId,
      String? locationId,
      String? location,
      bool? taxable,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsTaxableTaxable(
        masterId: masterId ?? this.masterId,
        locationId: locationId ?? this.locationId,
        location: location ?? this.location,
        taxable: taxable ?? this.taxable,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItem {
  WebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItem({
    this.vendorInvoiceItemId,
    this.purchaseOrderId,
    this.orderItemId,
    this.nestedOrderItemId,
    this.inventoryId,
    this.iCode,
    this.iCodeDisplay,
    this.iCodeColor,
    this.categoryId,
    this.description,
    this.descriptionColor,
    this.fromDate,
    this.toDate,
    this.quantity,
    this.quantityApproved,
    this.amountApproved,
    this.unitId,
    this.unit,
    this.cost,
    this.extended,
    this.adjustment,
    this.lineTotal,
    this.lineTotalPerQuantity,
    this.taxableExtended,
    this.taxable,
    this.tax,
    this.tax1,
    this.tax2,
    this.lineTotalWithTax,
    this.note,
    this.itemClass,
    this.recType,
    this.recTypeDisplay,
    this.invoiceNumber,
    this.invoiceType,
    this.invoiceDate,
    this.statusDate,
    this.vendorInvoiceNumber,
    this.inputDate,
    this.glAccountId,
    this.glAccountNo,
    this.incomeAccountId,
    this.dealBilledQuantity,
    this.dealBilledExtended,
    this.orderId,
    this.orderOrderItemId,
    this.purchaseOrderNumber,
    this.orderNumber,
    this.dealId,
    this.deal,
    this.dealTypeId,
    this.orderTypeId,
    this.quantityOrdered,
    this.quantityReceived,
    this.quantityCanceled,
    this.quantityReturned,
    this.purchaseOrderRate,
    this.purchaseOrderDiscountPercent,
    this.purchaseOrderDaysPerWeek,
    this.purchaseOrderPeriodExtended,
    this.itemOrder,
    this.lineType,
    this.warehouseId,
    this.warehouse,
    this.warehouseCode,
    this.chargeType,
    this.poItemBillingStartDate,
    this.poItemBillingEndDate,
    this.vendorInvoiceId,
    this.currencySymbol,
    this.nestingLevel,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItem.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItemFromJson(
          json);

  @JsonKey(name: 'VendorInvoiceItemId')
  final String? vendorInvoiceItemId;
  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'OrderItemId')
  final String? orderItemId;
  @JsonKey(name: 'NestedOrderItemId')
  final String? nestedOrderItemId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'ICodeDisplay')
  final String? iCodeDisplay;
  @JsonKey(name: 'ICodeColor')
  final String? iCodeColor;
  @JsonKey(name: 'CategoryId')
  final String? categoryId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'DescriptionColor')
  final String? descriptionColor;
  @JsonKey(name: 'FromDate')
  final String? fromDate;
  @JsonKey(name: 'ToDate')
  final String? toDate;
  @JsonKey(name: 'Quantity')
  final double? quantity;
  @JsonKey(name: 'QuantityApproved')
  final double? quantityApproved;
  @JsonKey(name: 'AmountApproved')
  final double? amountApproved;
  @JsonKey(name: 'UnitId')
  final String? unitId;
  @JsonKey(name: 'Unit')
  final String? unit;
  @JsonKey(name: 'Cost')
  final double? cost;
  @JsonKey(name: 'Extended')
  final double? extended;
  @JsonKey(name: 'Adjustment')
  final double? adjustment;
  @JsonKey(name: 'LineTotal')
  final double? lineTotal;
  @JsonKey(name: 'LineTotalPerQuantity')
  final double? lineTotalPerQuantity;
  @JsonKey(name: 'TaxableExtended')
  final double? taxableExtended;
  @JsonKey(name: 'Taxable')
  final bool? taxable;
  @JsonKey(name: 'Tax')
  final double? tax;
  @JsonKey(name: 'Tax1')
  final double? tax1;
  @JsonKey(name: 'Tax2')
  final double? tax2;
  @JsonKey(name: 'LineTotalWithTax')
  final double? lineTotalWithTax;
  @JsonKey(name: 'Note')
  final String? note;
  @JsonKey(name: 'ItemClass')
  final String? itemClass;
  @JsonKey(name: 'RecType')
  final String? recType;
  @JsonKey(name: 'RecTypeDisplay')
  final String? recTypeDisplay;
  @JsonKey(name: 'InvoiceNumber')
  final String? invoiceNumber;
  @JsonKey(name: 'InvoiceType')
  final String? invoiceType;
  @JsonKey(name: 'InvoiceDate')
  final String? invoiceDate;
  @JsonKey(name: 'StatusDate')
  final String? statusDate;
  @JsonKey(name: 'VendorInvoiceNumber')
  final int? vendorInvoiceNumber;
  @JsonKey(name: 'InputDate')
  final String? inputDate;
  @JsonKey(name: 'GlAccountId')
  final String? glAccountId;
  @JsonKey(name: 'GlAccountNo')
  final String? glAccountNo;
  @JsonKey(name: 'IncomeAccountId')
  final String? incomeAccountId;
  @JsonKey(name: 'DealBilledQuantity')
  final double? dealBilledQuantity;
  @JsonKey(name: 'DealBilledExtended')
  final double? dealBilledExtended;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderOrderItemId')
  final String? orderOrderItemId;
  @JsonKey(name: 'PurchaseOrderNumber')
  final String? purchaseOrderNumber;
  @JsonKey(name: 'OrderNumber')
  final String? orderNumber;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'Deal')
  final String? deal;
  @JsonKey(name: 'DealTypeId')
  final String? dealTypeId;
  @JsonKey(name: 'OrderTypeId')
  final String? orderTypeId;
  @JsonKey(name: 'QuantityOrdered')
  final double? quantityOrdered;
  @JsonKey(name: 'QuantityReceived')
  final double? quantityReceived;
  @JsonKey(name: 'QuantityCanceled')
  final double? quantityCanceled;
  @JsonKey(name: 'QuantityReturned')
  final double? quantityReturned;
  @JsonKey(name: 'PurchaseOrderRate')
  final double? purchaseOrderRate;
  @JsonKey(name: 'PurchaseOrderDiscountPercent')
  final double? purchaseOrderDiscountPercent;
  @JsonKey(name: 'PurchaseOrderDaysPerWeek')
  final double? purchaseOrderDaysPerWeek;
  @JsonKey(name: 'PurchaseOrderPeriodExtended')
  final double? purchaseOrderPeriodExtended;
  @JsonKey(name: 'ItemOrder')
  final String? itemOrder;
  @JsonKey(name: 'LineType')
  final String? lineType;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'ChargeType')
  final String? chargeType;
  @JsonKey(name: 'PoItemBillingStartDate')
  final String? poItemBillingStartDate;
  @JsonKey(name: 'PoItemBillingEndDate')
  final String? poItemBillingEndDate;
  @JsonKey(name: 'VendorInvoiceId')
  final String? vendorInvoiceId;
  @JsonKey(name: 'CurrencySymbol')
  final String? currencySymbol;
  @JsonKey(name: 'NestingLevel')
  final int? nestingLevel;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItemFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItemToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItemToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItem &&
            (identical(other.vendorInvoiceItemId, vendorInvoiceItemId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorInvoiceItemId, vendorInvoiceItemId)) &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.orderItemId, orderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.orderItemId, orderItemId)) &&
            (identical(other.nestedOrderItemId, nestedOrderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.nestedOrderItemId, nestedOrderItemId)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.iCodeDisplay, iCodeDisplay) ||
                const DeepCollectionEquality()
                    .equals(other.iCodeDisplay, iCodeDisplay)) &&
            (identical(other.iCodeColor, iCodeColor) ||
                const DeepCollectionEquality()
                    .equals(other.iCodeColor, iCodeColor)) &&
            (identical(other.categoryId, categoryId) ||
                const DeepCollectionEquality()
                    .equals(other.categoryId, categoryId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.descriptionColor, descriptionColor) ||
                const DeepCollectionEquality()
                    .equals(other.descriptionColor, descriptionColor)) &&
            (identical(other.fromDate, fromDate) ||
                const DeepCollectionEquality()
                    .equals(other.fromDate, fromDate)) &&
            (identical(other.toDate, toDate) ||
                const DeepCollectionEquality().equals(other.toDate, toDate)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)) &&
            (identical(other.quantityApproved, quantityApproved) ||
                const DeepCollectionEquality()
                    .equals(other.quantityApproved, quantityApproved)) &&
            (identical(other.amountApproved, amountApproved) ||
                const DeepCollectionEquality()
                    .equals(other.amountApproved, amountApproved)) &&
            (identical(other.unitId, unitId) ||
                const DeepCollectionEquality().equals(other.unitId, unitId)) &&
            (identical(other.unit, unit) ||
                const DeepCollectionEquality().equals(other.unit, unit)) &&
            (identical(other.cost, cost) || const DeepCollectionEquality().equals(other.cost, cost)) &&
            (identical(other.extended, extended) || const DeepCollectionEquality().equals(other.extended, extended)) &&
            (identical(other.adjustment, adjustment) || const DeepCollectionEquality().equals(other.adjustment, adjustment)) &&
            (identical(other.lineTotal, lineTotal) || const DeepCollectionEquality().equals(other.lineTotal, lineTotal)) &&
            (identical(other.lineTotalPerQuantity, lineTotalPerQuantity) || const DeepCollectionEquality().equals(other.lineTotalPerQuantity, lineTotalPerQuantity)) &&
            (identical(other.taxableExtended, taxableExtended) || const DeepCollectionEquality().equals(other.taxableExtended, taxableExtended)) &&
            (identical(other.taxable, taxable) || const DeepCollectionEquality().equals(other.taxable, taxable)) &&
            (identical(other.tax, tax) || const DeepCollectionEquality().equals(other.tax, tax)) &&
            (identical(other.tax1, tax1) || const DeepCollectionEquality().equals(other.tax1, tax1)) &&
            (identical(other.tax2, tax2) || const DeepCollectionEquality().equals(other.tax2, tax2)) &&
            (identical(other.lineTotalWithTax, lineTotalWithTax) || const DeepCollectionEquality().equals(other.lineTotalWithTax, lineTotalWithTax)) &&
            (identical(other.note, note) || const DeepCollectionEquality().equals(other.note, note)) &&
            (identical(other.itemClass, itemClass) || const DeepCollectionEquality().equals(other.itemClass, itemClass)) &&
            (identical(other.recType, recType) || const DeepCollectionEquality().equals(other.recType, recType)) &&
            (identical(other.recTypeDisplay, recTypeDisplay) || const DeepCollectionEquality().equals(other.recTypeDisplay, recTypeDisplay)) &&
            (identical(other.invoiceNumber, invoiceNumber) || const DeepCollectionEquality().equals(other.invoiceNumber, invoiceNumber)) &&
            (identical(other.invoiceType, invoiceType) || const DeepCollectionEquality().equals(other.invoiceType, invoiceType)) &&
            (identical(other.invoiceDate, invoiceDate) || const DeepCollectionEquality().equals(other.invoiceDate, invoiceDate)) &&
            (identical(other.statusDate, statusDate) || const DeepCollectionEquality().equals(other.statusDate, statusDate)) &&
            (identical(other.vendorInvoiceNumber, vendorInvoiceNumber) || const DeepCollectionEquality().equals(other.vendorInvoiceNumber, vendorInvoiceNumber)) &&
            (identical(other.inputDate, inputDate) || const DeepCollectionEquality().equals(other.inputDate, inputDate)) &&
            (identical(other.glAccountId, glAccountId) || const DeepCollectionEquality().equals(other.glAccountId, glAccountId)) &&
            (identical(other.glAccountNo, glAccountNo) || const DeepCollectionEquality().equals(other.glAccountNo, glAccountNo)) &&
            (identical(other.incomeAccountId, incomeAccountId) || const DeepCollectionEquality().equals(other.incomeAccountId, incomeAccountId)) &&
            (identical(other.dealBilledQuantity, dealBilledQuantity) || const DeepCollectionEquality().equals(other.dealBilledQuantity, dealBilledQuantity)) &&
            (identical(other.dealBilledExtended, dealBilledExtended) || const DeepCollectionEquality().equals(other.dealBilledExtended, dealBilledExtended)) &&
            (identical(other.orderId, orderId) || const DeepCollectionEquality().equals(other.orderId, orderId)) &&
            (identical(other.orderOrderItemId, orderOrderItemId) || const DeepCollectionEquality().equals(other.orderOrderItemId, orderOrderItemId)) &&
            (identical(other.purchaseOrderNumber, purchaseOrderNumber) || const DeepCollectionEquality().equals(other.purchaseOrderNumber, purchaseOrderNumber)) &&
            (identical(other.orderNumber, orderNumber) || const DeepCollectionEquality().equals(other.orderNumber, orderNumber)) &&
            (identical(other.dealId, dealId) || const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.deal, deal) || const DeepCollectionEquality().equals(other.deal, deal)) &&
            (identical(other.dealTypeId, dealTypeId) || const DeepCollectionEquality().equals(other.dealTypeId, dealTypeId)) &&
            (identical(other.orderTypeId, orderTypeId) || const DeepCollectionEquality().equals(other.orderTypeId, orderTypeId)) &&
            (identical(other.quantityOrdered, quantityOrdered) || const DeepCollectionEquality().equals(other.quantityOrdered, quantityOrdered)) &&
            (identical(other.quantityReceived, quantityReceived) || const DeepCollectionEquality().equals(other.quantityReceived, quantityReceived)) &&
            (identical(other.quantityCanceled, quantityCanceled) || const DeepCollectionEquality().equals(other.quantityCanceled, quantityCanceled)) &&
            (identical(other.quantityReturned, quantityReturned) || const DeepCollectionEquality().equals(other.quantityReturned, quantityReturned)) &&
            (identical(other.purchaseOrderRate, purchaseOrderRate) || const DeepCollectionEquality().equals(other.purchaseOrderRate, purchaseOrderRate)) &&
            (identical(other.purchaseOrderDiscountPercent, purchaseOrderDiscountPercent) || const DeepCollectionEquality().equals(other.purchaseOrderDiscountPercent, purchaseOrderDiscountPercent)) &&
            (identical(other.purchaseOrderDaysPerWeek, purchaseOrderDaysPerWeek) || const DeepCollectionEquality().equals(other.purchaseOrderDaysPerWeek, purchaseOrderDaysPerWeek)) &&
            (identical(other.purchaseOrderPeriodExtended, purchaseOrderPeriodExtended) || const DeepCollectionEquality().equals(other.purchaseOrderPeriodExtended, purchaseOrderPeriodExtended)) &&
            (identical(other.itemOrder, itemOrder) || const DeepCollectionEquality().equals(other.itemOrder, itemOrder)) &&
            (identical(other.lineType, lineType) || const DeepCollectionEquality().equals(other.lineType, lineType)) &&
            (identical(other.warehouseId, warehouseId) || const DeepCollectionEquality().equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouse, warehouse) || const DeepCollectionEquality().equals(other.warehouse, warehouse)) &&
            (identical(other.warehouseCode, warehouseCode) || const DeepCollectionEquality().equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.chargeType, chargeType) || const DeepCollectionEquality().equals(other.chargeType, chargeType)) &&
            (identical(other.poItemBillingStartDate, poItemBillingStartDate) || const DeepCollectionEquality().equals(other.poItemBillingStartDate, poItemBillingStartDate)) &&
            (identical(other.poItemBillingEndDate, poItemBillingEndDate) || const DeepCollectionEquality().equals(other.poItemBillingEndDate, poItemBillingEndDate)) &&
            (identical(other.vendorInvoiceId, vendorInvoiceId) || const DeepCollectionEquality().equals(other.vendorInvoiceId, vendorInvoiceId)) &&
            (identical(other.currencySymbol, currencySymbol) || const DeepCollectionEquality().equals(other.currencySymbol, currencySymbol)) &&
            (identical(other.nestingLevel, nestingLevel) || const DeepCollectionEquality().equals(other.nestingLevel, nestingLevel)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItemExtension
    on WebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItem {
  WebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItem copyWith(
      {String? vendorInvoiceItemId,
      String? purchaseOrderId,
      String? orderItemId,
      String? nestedOrderItemId,
      String? inventoryId,
      String? iCode,
      String? iCodeDisplay,
      String? iCodeColor,
      String? categoryId,
      String? description,
      String? descriptionColor,
      String? fromDate,
      String? toDate,
      double? quantity,
      double? quantityApproved,
      double? amountApproved,
      String? unitId,
      String? unit,
      double? cost,
      double? extended,
      double? adjustment,
      double? lineTotal,
      double? lineTotalPerQuantity,
      double? taxableExtended,
      bool? taxable,
      double? tax,
      double? tax1,
      double? tax2,
      double? lineTotalWithTax,
      String? note,
      String? itemClass,
      String? recType,
      String? recTypeDisplay,
      String? invoiceNumber,
      String? invoiceType,
      String? invoiceDate,
      String? statusDate,
      int? vendorInvoiceNumber,
      String? inputDate,
      String? glAccountId,
      String? glAccountNo,
      String? incomeAccountId,
      double? dealBilledQuantity,
      double? dealBilledExtended,
      String? orderId,
      String? orderOrderItemId,
      String? purchaseOrderNumber,
      String? orderNumber,
      String? dealId,
      String? deal,
      String? dealTypeId,
      String? orderTypeId,
      double? quantityOrdered,
      double? quantityReceived,
      double? quantityCanceled,
      double? quantityReturned,
      double? purchaseOrderRate,
      double? purchaseOrderDiscountPercent,
      double? purchaseOrderDaysPerWeek,
      double? purchaseOrderPeriodExtended,
      String? itemOrder,
      String? lineType,
      String? warehouseId,
      String? warehouse,
      String? warehouseCode,
      String? chargeType,
      String? poItemBillingStartDate,
      String? poItemBillingEndDate,
      String? vendorInvoiceId,
      String? currencySymbol,
      int? nestingLevel,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsVendorInvoiceItemVendorInvoiceItem(
        vendorInvoiceItemId: vendorInvoiceItemId ?? this.vendorInvoiceItemId,
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        orderItemId: orderItemId ?? this.orderItemId,
        nestedOrderItemId: nestedOrderItemId ?? this.nestedOrderItemId,
        inventoryId: inventoryId ?? this.inventoryId,
        iCode: iCode ?? this.iCode,
        iCodeDisplay: iCodeDisplay ?? this.iCodeDisplay,
        iCodeColor: iCodeColor ?? this.iCodeColor,
        categoryId: categoryId ?? this.categoryId,
        description: description ?? this.description,
        descriptionColor: descriptionColor ?? this.descriptionColor,
        fromDate: fromDate ?? this.fromDate,
        toDate: toDate ?? this.toDate,
        quantity: quantity ?? this.quantity,
        quantityApproved: quantityApproved ?? this.quantityApproved,
        amountApproved: amountApproved ?? this.amountApproved,
        unitId: unitId ?? this.unitId,
        unit: unit ?? this.unit,
        cost: cost ?? this.cost,
        extended: extended ?? this.extended,
        adjustment: adjustment ?? this.adjustment,
        lineTotal: lineTotal ?? this.lineTotal,
        lineTotalPerQuantity: lineTotalPerQuantity ?? this.lineTotalPerQuantity,
        taxableExtended: taxableExtended ?? this.taxableExtended,
        taxable: taxable ?? this.taxable,
        tax: tax ?? this.tax,
        tax1: tax1 ?? this.tax1,
        tax2: tax2 ?? this.tax2,
        lineTotalWithTax: lineTotalWithTax ?? this.lineTotalWithTax,
        note: note ?? this.note,
        itemClass: itemClass ?? this.itemClass,
        recType: recType ?? this.recType,
        recTypeDisplay: recTypeDisplay ?? this.recTypeDisplay,
        invoiceNumber: invoiceNumber ?? this.invoiceNumber,
        invoiceType: invoiceType ?? this.invoiceType,
        invoiceDate: invoiceDate ?? this.invoiceDate,
        statusDate: statusDate ?? this.statusDate,
        vendorInvoiceNumber: vendorInvoiceNumber ?? this.vendorInvoiceNumber,
        inputDate: inputDate ?? this.inputDate,
        glAccountId: glAccountId ?? this.glAccountId,
        glAccountNo: glAccountNo ?? this.glAccountNo,
        incomeAccountId: incomeAccountId ?? this.incomeAccountId,
        dealBilledQuantity: dealBilledQuantity ?? this.dealBilledQuantity,
        dealBilledExtended: dealBilledExtended ?? this.dealBilledExtended,
        orderId: orderId ?? this.orderId,
        orderOrderItemId: orderOrderItemId ?? this.orderOrderItemId,
        purchaseOrderNumber: purchaseOrderNumber ?? this.purchaseOrderNumber,
        orderNumber: orderNumber ?? this.orderNumber,
        dealId: dealId ?? this.dealId,
        deal: deal ?? this.deal,
        dealTypeId: dealTypeId ?? this.dealTypeId,
        orderTypeId: orderTypeId ?? this.orderTypeId,
        quantityOrdered: quantityOrdered ?? this.quantityOrdered,
        quantityReceived: quantityReceived ?? this.quantityReceived,
        quantityCanceled: quantityCanceled ?? this.quantityCanceled,
        quantityReturned: quantityReturned ?? this.quantityReturned,
        purchaseOrderRate: purchaseOrderRate ?? this.purchaseOrderRate,
        purchaseOrderDiscountPercent:
            purchaseOrderDiscountPercent ?? this.purchaseOrderDiscountPercent,
        purchaseOrderDaysPerWeek:
            purchaseOrderDaysPerWeek ?? this.purchaseOrderDaysPerWeek,
        purchaseOrderPeriodExtended:
            purchaseOrderPeriodExtended ?? this.purchaseOrderPeriodExtended,
        itemOrder: itemOrder ?? this.itemOrder,
        lineType: lineType ?? this.lineType,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouse: warehouse ?? this.warehouse,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        chargeType: chargeType ?? this.chargeType,
        poItemBillingStartDate:
            poItemBillingStartDate ?? this.poItemBillingStartDate,
        poItemBillingEndDate: poItemBillingEndDate ?? this.poItemBillingEndDate,
        vendorInvoiceId: vendorInvoiceId ?? this.vendorInvoiceId,
        currencySymbol: currencySymbol ?? this.currencySymbol,
        nestingLevel: nestingLevel ?? this.nestingLevel,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNote {
  WebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNote({
    this.vendorInvoiceNoteId,
    this.uniqueId1,
    this.uniqueId2,
    this.notes,
    this.noteDate,
    this.usersId,
    this.name,
    this.noteDescription,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNote.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNoteFromJson(
          json);

  @JsonKey(name: 'VendorInvoiceNoteId')
  final String? vendorInvoiceNoteId;
  @JsonKey(name: 'UniqueId1')
  final String? uniqueId1;
  @JsonKey(name: 'UniqueId2')
  final String? uniqueId2;
  @JsonKey(name: 'Notes')
  final String? notes;
  @JsonKey(name: 'NoteDate')
  final String? noteDate;
  @JsonKey(name: 'UsersId')
  final String? usersId;
  @JsonKey(name: 'Name')
  final String? name;
  @JsonKey(name: 'NoteDescription')
  final String? noteDescription;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNoteFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNoteToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNoteToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNote &&
            (identical(other.vendorInvoiceNoteId, vendorInvoiceNoteId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorInvoiceNoteId, vendorInvoiceNoteId)) &&
            (identical(other.uniqueId1, uniqueId1) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1, uniqueId1)) &&
            (identical(other.uniqueId2, uniqueId2) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId2, uniqueId2)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.noteDate, noteDate) ||
                const DeepCollectionEquality()
                    .equals(other.noteDate, noteDate)) &&
            (identical(other.usersId, usersId) ||
                const DeepCollectionEquality()
                    .equals(other.usersId, usersId)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.noteDescription, noteDescription) ||
                const DeepCollectionEquality()
                    .equals(other.noteDescription, noteDescription)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNoteExtension
    on WebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNote {
  WebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNote copyWith(
      {String? vendorInvoiceNoteId,
      String? uniqueId1,
      String? uniqueId2,
      String? notes,
      String? noteDate,
      String? usersId,
      String? name,
      String? noteDescription,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsVendorInvoiceNoteVendorInvoiceNote(
        vendorInvoiceNoteId: vendorInvoiceNoteId ?? this.vendorInvoiceNoteId,
        uniqueId1: uniqueId1 ?? this.uniqueId1,
        uniqueId2: uniqueId2 ?? this.uniqueId2,
        notes: notes ?? this.notes,
        noteDate: noteDate ?? this.noteDate,
        usersId: usersId ?? this.usersId,
        name: name ?? this.name,
        noteDescription: noteDescription ?? this.noteDescription,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesHomeControlsVendorNoteVendorNote {
  WebApiModulesHomeControlsVendorNoteVendorNote({
    this.vendorNoteId,
    this.vendorId,
    this.noteDate,
    this.description,
    this.notes,
    this.notify,
    this.notesById,
    this.notesBy,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesHomeControlsVendorNoteVendorNote.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesHomeControlsVendorNoteVendorNoteFromJson(json);

  @JsonKey(name: 'VendorNoteId')
  final String? vendorNoteId;
  @JsonKey(name: 'VendorId')
  final String? vendorId;
  @JsonKey(name: 'NoteDate')
  final String? noteDate;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'Notes')
  final String? notes;
  @JsonKey(name: 'Notify')
  final bool? notify;
  @JsonKey(name: 'NotesById')
  final String? notesById;
  @JsonKey(name: 'NotesBy')
  final String? notesBy;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesHomeControlsVendorNoteVendorNoteFromJson;
  static const toJsonFactory =
      _$WebApiModulesHomeControlsVendorNoteVendorNoteToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesHomeControlsVendorNoteVendorNoteToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesHomeControlsVendorNoteVendorNote &&
            (identical(other.vendorNoteId, vendorNoteId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorNoteId, vendorNoteId)) &&
            (identical(other.vendorId, vendorId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorId, vendorId)) &&
            (identical(other.noteDate, noteDate) ||
                const DeepCollectionEquality()
                    .equals(other.noteDate, noteDate)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.notify, notify) ||
                const DeepCollectionEquality().equals(other.notify, notify)) &&
            (identical(other.notesById, notesById) ||
                const DeepCollectionEquality()
                    .equals(other.notesById, notesById)) &&
            (identical(other.notesBy, notesBy) ||
                const DeepCollectionEquality()
                    .equals(other.notesBy, notesBy)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesHomeControlsVendorNoteVendorNoteExtension
    on WebApiModulesHomeControlsVendorNoteVendorNote {
  WebApiModulesHomeControlsVendorNoteVendorNote copyWith(
      {String? vendorNoteId,
      String? vendorId,
      String? noteDate,
      String? description,
      String? notes,
      bool? notify,
      String? notesById,
      String? notesBy,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesHomeControlsVendorNoteVendorNote(
        vendorNoteId: vendorNoteId ?? this.vendorNoteId,
        vendorId: vendorId ?? this.vendorId,
        noteDate: noteDate ?? this.noteDate,
        description: description ?? this.description,
        notes: notes ?? this.notes,
        notify: notify ?? this.notify,
        notesById: notesById ?? this.notesById,
        notesBy: notesBy ?? this.notesBy,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryAssetAssetDocument {
  WebApiModulesInventoryAssetAssetDocument({
    this.itemId,
    this.copying,
    this.documentId,
    this.documentTypeId,
    this.uniqueId1,
    this.uniqueId2,
    this.uniqueId1Int,
    this.description,
    this.inputByUsersId,
    this.attachDate,
    this.attachTime,
    this.attachToEmail,
    this.inactive,
    this.dateStamp,
    this.extension,
    this.documentType,
    this.inputBy,
    this.hasImage,
    this.hasFile,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesInventoryAssetAssetDocument.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryAssetAssetDocumentFromJson(json);

  @JsonKey(name: 'ItemId')
  final String? itemId;
  @JsonKey(name: 'copying')
  final bool? copying;
  @JsonKey(name: 'DocumentId')
  final String? documentId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'UniqueId1')
  final String? uniqueId1;
  @JsonKey(name: 'UniqueId2')
  final String? uniqueId2;
  @JsonKey(name: 'UniqueId1Int')
  final int? uniqueId1Int;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'InputByUsersId')
  final String? inputByUsersId;
  @JsonKey(name: 'AttachDate')
  final String? attachDate;
  @JsonKey(name: 'AttachTime')
  final String? attachTime;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'Extension')
  final String? extension;
  @JsonKey(name: 'DocumentType')
  final String? documentType;
  @JsonKey(name: 'InputBy')
  final String? inputBy;
  @JsonKey(name: 'HasImage')
  final bool? hasImage;
  @JsonKey(name: 'HasFile')
  final bool? hasFile;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesInventoryAssetAssetDocumentFromJson;
  static const toJsonFactory = _$WebApiModulesInventoryAssetAssetDocumentToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryAssetAssetDocumentToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryAssetAssetDocument &&
            (identical(other.itemId, itemId) ||
                const DeepCollectionEquality().equals(other.itemId, itemId)) &&
            (identical(other.copying, copying) ||
                const DeepCollectionEquality()
                    .equals(other.copying, copying)) &&
            (identical(other.documentId, documentId) ||
                const DeepCollectionEquality()
                    .equals(other.documentId, documentId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.uniqueId1, uniqueId1) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1, uniqueId1)) &&
            (identical(other.uniqueId2, uniqueId2) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId2, uniqueId2)) &&
            (identical(other.uniqueId1Int, uniqueId1Int) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1Int, uniqueId1Int)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.inputByUsersId, inputByUsersId) ||
                const DeepCollectionEquality()
                    .equals(other.inputByUsersId, inputByUsersId)) &&
            (identical(other.attachDate, attachDate) ||
                const DeepCollectionEquality()
                    .equals(other.attachDate, attachDate)) &&
            (identical(other.attachTime, attachTime) ||
                const DeepCollectionEquality()
                    .equals(other.attachTime, attachTime)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.extension, extension) ||
                const DeepCollectionEquality()
                    .equals(other.extension, extension)) &&
            (identical(other.documentType, documentType) ||
                const DeepCollectionEquality()
                    .equals(other.documentType, documentType)) &&
            (identical(other.inputBy, inputBy) ||
                const DeepCollectionEquality()
                    .equals(other.inputBy, inputBy)) &&
            (identical(other.hasImage, hasImage) ||
                const DeepCollectionEquality()
                    .equals(other.hasImage, hasImage)) &&
            (identical(other.hasFile, hasFile) ||
                const DeepCollectionEquality()
                    .equals(other.hasFile, hasFile)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesInventoryAssetAssetDocumentExtension
    on WebApiModulesInventoryAssetAssetDocument {
  WebApiModulesInventoryAssetAssetDocument copyWith(
      {String? itemId,
      bool? copying,
      String? documentId,
      String? documentTypeId,
      String? uniqueId1,
      String? uniqueId2,
      int? uniqueId1Int,
      String? description,
      String? inputByUsersId,
      String? attachDate,
      String? attachTime,
      bool? attachToEmail,
      bool? inactive,
      String? dateStamp,
      String? extension,
      String? documentType,
      String? inputBy,
      bool? hasImage,
      bool? hasFile,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesInventoryAssetAssetDocument(
        itemId: itemId ?? this.itemId,
        copying: copying ?? this.copying,
        documentId: documentId ?? this.documentId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        uniqueId1: uniqueId1 ?? this.uniqueId1,
        uniqueId2: uniqueId2 ?? this.uniqueId2,
        uniqueId1Int: uniqueId1Int ?? this.uniqueId1Int,
        description: description ?? this.description,
        inputByUsersId: inputByUsersId ?? this.inputByUsersId,
        attachDate: attachDate ?? this.attachDate,
        attachTime: attachTime ?? this.attachTime,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        dateStamp: dateStamp ?? this.dateStamp,
        extension: extension ?? this.extension,
        documentType: documentType ?? this.documentType,
        inputBy: inputBy ?? this.inputBy,
        hasImage: hasImage ?? this.hasImage,
        hasFile: hasFile ?? this.hasFile,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryAssetAssetDocumentPostRequest {
  WebApiModulesInventoryAssetAssetDocumentPostRequest({
    this.itemId,
    this.documentTypeId,
    this.description,
    this.attachToEmail,
    this.inactive,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
  });

  factory WebApiModulesInventoryAssetAssetDocumentPostRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryAssetAssetDocumentPostRequestFromJson(json);

  @JsonKey(name: 'ItemId')
  final String? itemId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  static const fromJsonFactory =
      _$WebApiModulesInventoryAssetAssetDocumentPostRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryAssetAssetDocumentPostRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryAssetAssetDocumentPostRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryAssetAssetDocumentPostRequest &&
            (identical(other.itemId, itemId) ||
                const DeepCollectionEquality().equals(other.itemId, itemId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)));
  }
}

extension $WebApiModulesInventoryAssetAssetDocumentPostRequestExtension
    on WebApiModulesInventoryAssetAssetDocumentPostRequest {
  WebApiModulesInventoryAssetAssetDocumentPostRequest copyWith(
      {String? itemId,
      String? documentTypeId,
      String? description,
      bool? attachToEmail,
      bool? inactive,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath}) {
    return WebApiModulesInventoryAssetAssetDocumentPostRequest(
        itemId: itemId ?? this.itemId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        description: description ?? this.description,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryAssetAssetDocumentPutRequest {
  WebApiModulesInventoryAssetAssetDocumentPutRequest({
    this.itemId,
    this.documentId,
    this.documentTypeId,
    this.description,
    this.attachToEmail,
    this.inactive,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
  });

  factory WebApiModulesInventoryAssetAssetDocumentPutRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryAssetAssetDocumentPutRequestFromJson(json);

  @JsonKey(name: 'ItemId')
  final String? itemId;
  @JsonKey(name: 'DocumentId')
  final String? documentId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  static const fromJsonFactory =
      _$WebApiModulesInventoryAssetAssetDocumentPutRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryAssetAssetDocumentPutRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryAssetAssetDocumentPutRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryAssetAssetDocumentPutRequest &&
            (identical(other.itemId, itemId) ||
                const DeepCollectionEquality().equals(other.itemId, itemId)) &&
            (identical(other.documentId, documentId) ||
                const DeepCollectionEquality()
                    .equals(other.documentId, documentId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)));
  }
}

extension $WebApiModulesInventoryAssetAssetDocumentPutRequestExtension
    on WebApiModulesInventoryAssetAssetDocumentPutRequest {
  WebApiModulesInventoryAssetAssetDocumentPutRequest copyWith(
      {String? itemId,
      String? documentId,
      String? documentTypeId,
      String? description,
      bool? attachToEmail,
      bool? inactive,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath}) {
    return WebApiModulesInventoryAssetAssetDocumentPutRequest(
        itemId: itemId ?? this.itemId,
        documentId: documentId ?? this.documentId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        description: description ?? this.description,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryAssetItem {
  WebApiModulesInventoryAssetItem({
    this.itemId,
    this.inventoryId,
    this.warehouseId,
    this.iCode,
    this.description,
    this.itemDescription,
    this.trackedBy,
    this.availableFor,
    this.availableForDisplay,
    this.unitValue,
    this.replacementCost,
    this.classification,
    this.isContainer,
    this.containerId,
    this.containerInventoryId,
    this.containerICode,
    this.containerDescription,
    this.containerPackingListBehavior,
    this.containerStatus,
    this.containerStatusColor,
    this.containerItemId,
    this.containerStatusDate,
    this.fixedAsset,
    this.rank,
    this.statusType,
    this.statusDate,
    this.inventoryStatus,
    this.inventoryStatusId,
    this.color,
    this.textColor,
    this.barCode,
    this.barCodeForScanning,
    this.serialNumber,
    this.rfId,
    this.oldBarCode,
    this.oldSerialNumber,
    this.oldRfid,
    this.manufacturerPartNumber,
    this.manufactureDate,
    this.trackedByCode,
    this.availOwnershipSort,
    this.isNegativeInventory,
    this.inspectionNo,
    this.inspectionVendorId,
    this.inspectionVendor,
    this.manufacturerModelNumber,
    this.purchaseId,
    this.aisleLocation,
    this.shelfLocation,
    this.spaceId,
    this.buildingRoom,
    this.itemNotes,
    this.physicalId,
    this.physicalItemId,
    this.physicalDate,
    this.physicalBy,
    this.warehouse,
    this.warehouseCode,
    this.dealId,
    this.orderId,
    this.orderNumber,
    this.orderDescription,
    this.currentLocation,
    this.inventoryTypeId,
    this.inventoryType,
    this.inventoryTypeOrderBy,
    this.categoryId,
    this.category,
    this.categoryOrderBy,
    this.subCategoryId,
    this.subCategory,
    this.subCategoryOrderBy,
    this.ownership,
    this.purchaseVendorId,
    this.purchaseVendor,
    this.outsidePurchaseOrderNumber,
    this.purchasePoId,
    this.purchaseDate,
    this.receiveDate,
    this.receiveContractDate,
    this.purchasePoNumber,
    this.purchaseCost,
    this.invoiceCost,
    this.purchaseInvoiceNumber,
    this.purchaseInvoiceDate,
    this.purchaseCurrencyId,
    this.purchaseCurrencyCode,
    this.purchaseCurrency,
    this.purchaseCurrencySymbol,
    this.warehouseCurrencyId,
    this.warehouseCurrencyCode,
    this.warehouseCurrency,
    this.warehouseCurrencySymbol,
    this.purchaseCurrencyExchangeRate,
    this.unitCost,
    this.unitCostWithTax,
    this.unitCostCurrencyConverted,
    this.unitCostWithTaxCurrencyConverted,
    this.originalEquipmentCost,
    this.depreciation,
    this.bookValue,
    this.salvageValue,
    this.consignorId,
    this.consignor,
    this.consignorAgreementId,
    this.consignorAgreementNumber,
    this.manufacturerId,
    this.manufacturer,
    this.originalShowId,
    this.originalShow,
    this.conditionId,
    this.condition,
    this.surfaceId,
    this.surface,
    this.wallTypeId,
    this.wallType,
    this.openingId,
    this.opening,
    this.responsiblePersonId,
    this.responsiblePerson,
    this.buyerId,
    this.buyer,
    this.receiptNumber,
    this.depreciationMonths,
    this.repairId,
    this.repairNumber,
    this.qcRequired,
    this.widthFt,
    this.widthIn,
    this.heightFt,
    this.heightIn,
    this.lengthFt,
    this.lengthIn,
    this.currentMeter,
    this.trackAssetUsage,
    this.trackLampUsage,
    this.trackStrikes,
    this.trackCandles,
    this.assetHours,
    this.lampCount,
    this.lampHours1,
    this.lampHours2,
    this.lampHours3,
    this.lampHours4,
    this.strikes,
    this.footCandles,
    this.minimumFootCandles,
    this.softwareVersion,
    this.softwareEffectiveDate,
    this.pattern,
    this.gender,
    this.label,
    this.material,
    this.period,
    this.cleaningFeeAmount,
    this.wardrobeSize,
    this.wardrobePieceCount,
    this.inventoryTypeIsProps,
    this.inventoryTypeIsWardrobe,
    this.orderLocationId,
    this.containerNumber,
    this.isWardrobe,
    this.isProps,
    this.dailyRate,
    this.weeklyRate,
    this.monthlyRate,
    this.location,
    this.retiredReason,
    this.warrantyExpiration,
    this.warrantyPeriod,
    this.countryOfOriginId,
    this.countryOfOrigin,
    this.shelfLifeExpirationDate,
    this.currentDealId,
    this.currentDeal,
    this.currentCustomerId,
    this.currentCustomer,
    this.currentOrderId,
    this.currentOrderNumber,
    this.currentOrderType,
    this.currentOrderDescription,
    this.currentOrderDate,
    this.currentOrderPickDate,
    this.currentOrderFromDate,
    this.currentOrderToDate,
    this.currentOrderAgent,
    this.lotNumber,
    this.lastOrderId,
    this.lastOrderNumber,
    this.lastOrderDescription,
    this.lastDealId,
    this.lastDeal,
    this.lastDealNumber,
    this.lastOutContractId,
    this.lastOutContractNumber,
    this.lastOutContractDate,
    this.lastOutUserId,
    this.lastOutUserName,
    this.lastInContractId,
    this.lastInContractNumber,
    this.lastInContractDate,
    this.lastInUserId,
    this.lastInUserName,
    this.depreciationStartDate,
    this.depreciationWarehouseId,
    this.depreciationWarehouse,
    this.depreciationWarehouseCode,
    this.inactive,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesInventoryAssetItem.fromJson(Map<String, dynamic> json) =>
      _$WebApiModulesInventoryAssetItemFromJson(json);

  @JsonKey(name: 'ItemId')
  final String? itemId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'ItemDescription')
  final String? itemDescription;
  @JsonKey(name: 'TrackedBy')
  final String? trackedBy;
  @JsonKey(name: 'AvailableFor')
  final String? availableFor;
  @JsonKey(name: 'AvailableForDisplay')
  final String? availableForDisplay;
  @JsonKey(name: 'UnitValue')
  final double? unitValue;
  @JsonKey(name: 'ReplacementCost')
  final double? replacementCost;
  @JsonKey(name: 'Classification')
  final String? classification;
  @JsonKey(name: 'IsContainer')
  final bool? isContainer;
  @JsonKey(name: 'ContainerId')
  final String? containerId;
  @JsonKey(name: 'ContainerInventoryId')
  final String? containerInventoryId;
  @JsonKey(name: 'ContainerICode')
  final String? containerICode;
  @JsonKey(name: 'ContainerDescription')
  final String? containerDescription;
  @JsonKey(name: 'ContainerPackingListBehavior')
  final String? containerPackingListBehavior;
  @JsonKey(name: 'ContainerStatus')
  final String? containerStatus;
  @JsonKey(name: 'ContainerStatusColor')
  final String? containerStatusColor;
  @JsonKey(name: 'ContainerItemId')
  final String? containerItemId;
  @JsonKey(name: 'ContainerStatusDate')
  final String? containerStatusDate;
  @JsonKey(name: 'FixedAsset')
  final bool? fixedAsset;
  @JsonKey(name: 'Rank')
  final String? rank;
  @JsonKey(name: 'StatusType')
  final String? statusType;
  @JsonKey(name: 'StatusDate')
  final String? statusDate;
  @JsonKey(name: 'InventoryStatus')
  final String? inventoryStatus;
  @JsonKey(name: 'InventoryStatusId')
  final String? inventoryStatusId;
  @JsonKey(name: 'Color')
  final String? color;
  @JsonKey(name: 'TextColor')
  final String? textColor;
  @JsonKey(name: 'BarCode')
  final String? barCode;
  @JsonKey(name: 'BarCodeForScanning')
  final String? barCodeForScanning;
  @JsonKey(name: 'SerialNumber')
  final String? serialNumber;
  @JsonKey(name: 'RfId')
  final String? rfId;
  @JsonKey(name: 'OldBarCode')
  final String? oldBarCode;
  @JsonKey(name: 'OldSerialNumber')
  final String? oldSerialNumber;
  @JsonKey(name: 'OldRfid')
  final String? oldRfid;
  @JsonKey(name: 'ManufacturerPartNumber')
  final String? manufacturerPartNumber;
  @JsonKey(name: 'ManufactureDate')
  final String? manufactureDate;
  @JsonKey(name: 'TrackedByCode')
  final String? trackedByCode;
  @JsonKey(name: 'AvailOwnershipSort')
  final int? availOwnershipSort;
  @JsonKey(name: 'IsNegativeInventory')
  final bool? isNegativeInventory;
  @JsonKey(name: 'InspectionNo')
  final String? inspectionNo;
  @JsonKey(name: 'InspectionVendorId')
  final String? inspectionVendorId;
  @JsonKey(name: 'InspectionVendor')
  final String? inspectionVendor;
  @JsonKey(name: 'ManufacturerModelNumber')
  final String? manufacturerModelNumber;
  @JsonKey(name: 'PurchaseId')
  final String? purchaseId;
  @JsonKey(name: 'AisleLocation')
  final String? aisleLocation;
  @JsonKey(name: 'ShelfLocation')
  final String? shelfLocation;
  @JsonKey(name: 'SpaceId')
  final String? spaceId;
  @JsonKey(name: 'BuildingRoom')
  final String? buildingRoom;
  @JsonKey(name: 'ItemNotes')
  final String? itemNotes;
  @JsonKey(name: 'PhysicalId')
  final String? physicalId;
  @JsonKey(name: 'PhysicalItemId')
  final int? physicalItemId;
  @JsonKey(name: 'PhysicalDate')
  final String? physicalDate;
  @JsonKey(name: 'PhysicalBy')
  final String? physicalBy;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderNumber')
  final String? orderNumber;
  @JsonKey(name: 'OrderDescription')
  final String? orderDescription;
  @JsonKey(name: 'CurrentLocation')
  final String? currentLocation;
  @JsonKey(name: 'InventoryTypeId')
  final String? inventoryTypeId;
  @JsonKey(name: 'InventoryType')
  final String? inventoryType;
  @JsonKey(name: 'InventoryTypeOrderBy')
  final int? inventoryTypeOrderBy;
  @JsonKey(name: 'CategoryId')
  final String? categoryId;
  @JsonKey(name: 'Category')
  final String? category;
  @JsonKey(name: 'CategoryOrderBy')
  final double? categoryOrderBy;
  @JsonKey(name: 'SubCategoryId')
  final String? subCategoryId;
  @JsonKey(name: 'SubCategory')
  final String? subCategory;
  @JsonKey(name: 'SubCategoryOrderBy')
  final double? subCategoryOrderBy;
  @JsonKey(name: 'Ownership')
  final String? ownership;
  @JsonKey(name: 'PurchaseVendorId')
  final String? purchaseVendorId;
  @JsonKey(name: 'PurchaseVendor')
  final String? purchaseVendor;
  @JsonKey(name: 'OutsidePurchaseOrderNumber')
  final String? outsidePurchaseOrderNumber;
  @JsonKey(name: 'PurchasePoId')
  final String? purchasePoId;
  @JsonKey(name: 'PurchaseDate')
  final String? purchaseDate;
  @JsonKey(name: 'ReceiveDate')
  final String? receiveDate;
  @JsonKey(name: 'ReceiveContractDate')
  final String? receiveContractDate;
  @JsonKey(name: 'PurchasePoNumber')
  final String? purchasePoNumber;
  @JsonKey(name: 'PurchaseCost')
  final double? purchaseCost;
  @JsonKey(name: 'InvoiceCost')
  final double? invoiceCost;
  @JsonKey(name: 'PurchaseInvoiceNumber')
  final String? purchaseInvoiceNumber;
  @JsonKey(name: 'PurchaseInvoiceDate')
  final String? purchaseInvoiceDate;
  @JsonKey(name: 'PurchaseCurrencyId')
  final String? purchaseCurrencyId;
  @JsonKey(name: 'PurchaseCurrencyCode')
  final String? purchaseCurrencyCode;
  @JsonKey(name: 'PurchaseCurrency')
  final String? purchaseCurrency;
  @JsonKey(name: 'PurchaseCurrencySymbol')
  final String? purchaseCurrencySymbol;
  @JsonKey(name: 'WarehouseCurrencyId')
  final String? warehouseCurrencyId;
  @JsonKey(name: 'WarehouseCurrencyCode')
  final String? warehouseCurrencyCode;
  @JsonKey(name: 'WarehouseCurrency')
  final String? warehouseCurrency;
  @JsonKey(name: 'WarehouseCurrencySymbol')
  final String? warehouseCurrencySymbol;
  @JsonKey(name: 'PurchaseCurrencyExchangeRate')
  final double? purchaseCurrencyExchangeRate;
  @JsonKey(name: 'UnitCost')
  final double? unitCost;
  @JsonKey(name: 'UnitCostWithTax')
  final double? unitCostWithTax;
  @JsonKey(name: 'UnitCostCurrencyConverted')
  final double? unitCostCurrencyConverted;
  @JsonKey(name: 'UnitCostWithTaxCurrencyConverted')
  final double? unitCostWithTaxCurrencyConverted;
  @JsonKey(name: 'OriginalEquipmentCost')
  final double? originalEquipmentCost;
  @JsonKey(name: 'Depreciation')
  final double? depreciation;
  @JsonKey(name: 'BookValue')
  final double? bookValue;
  @JsonKey(name: 'SalvageValue')
  final double? salvageValue;
  @JsonKey(name: 'ConsignorId')
  final String? consignorId;
  @JsonKey(name: 'Consignor')
  final String? consignor;
  @JsonKey(name: 'ConsignorAgreementId')
  final String? consignorAgreementId;
  @JsonKey(name: 'ConsignorAgreementNumber')
  final String? consignorAgreementNumber;
  @JsonKey(name: 'ManufacturerId')
  final String? manufacturerId;
  @JsonKey(name: 'Manufacturer')
  final String? manufacturer;
  @JsonKey(name: 'OriginalShowId')
  final String? originalShowId;
  @JsonKey(name: 'OriginalShow')
  final String? originalShow;
  @JsonKey(name: 'ConditionId')
  final String? conditionId;
  @JsonKey(name: 'Condition')
  final String? condition;
  @JsonKey(name: 'SurfaceId')
  final String? surfaceId;
  @JsonKey(name: 'Surface')
  final String? surface;
  @JsonKey(name: 'WallTypeId')
  final String? wallTypeId;
  @JsonKey(name: 'WallType')
  final String? wallType;
  @JsonKey(name: 'OpeningId')
  final String? openingId;
  @JsonKey(name: 'Opening')
  final String? opening;
  @JsonKey(name: 'ResponsiblePersonId')
  final String? responsiblePersonId;
  @JsonKey(name: 'ResponsiblePerson')
  final String? responsiblePerson;
  @JsonKey(name: 'BuyerId')
  final String? buyerId;
  @JsonKey(name: 'Buyer')
  final String? buyer;
  @JsonKey(name: 'ReceiptNumber')
  final String? receiptNumber;
  @JsonKey(name: 'DepreciationMonths')
  final int? depreciationMonths;
  @JsonKey(name: 'RepairId')
  final String? repairId;
  @JsonKey(name: 'RepairNumber')
  final String? repairNumber;
  @JsonKey(name: 'QcRequired')
  final bool? qcRequired;
  @JsonKey(name: 'WidthFt')
  final int? widthFt;
  @JsonKey(name: 'WidthIn')
  final int? widthIn;
  @JsonKey(name: 'HeightFt')
  final int? heightFt;
  @JsonKey(name: 'HeightIn')
  final int? heightIn;
  @JsonKey(name: 'LengthFt')
  final int? lengthFt;
  @JsonKey(name: 'LengthIn')
  final int? lengthIn;
  @JsonKey(name: 'CurrentMeter')
  final double? currentMeter;
  @JsonKey(name: 'TrackAssetUsage')
  final bool? trackAssetUsage;
  @JsonKey(name: 'TrackLampUsage')
  final bool? trackLampUsage;
  @JsonKey(name: 'TrackStrikes')
  final bool? trackStrikes;
  @JsonKey(name: 'TrackCandles')
  final bool? trackCandles;
  @JsonKey(name: 'AssetHours')
  final int? assetHours;
  @JsonKey(name: 'LampCount')
  final int? lampCount;
  @JsonKey(name: 'LampHours1')
  final int? lampHours1;
  @JsonKey(name: 'LampHours2')
  final int? lampHours2;
  @JsonKey(name: 'LampHours3')
  final int? lampHours3;
  @JsonKey(name: 'LampHours4')
  final int? lampHours4;
  @JsonKey(name: 'Strikes')
  final int? strikes;
  @JsonKey(name: 'FootCandles')
  final int? footCandles;
  @JsonKey(name: 'MinimumFootCandles')
  final int? minimumFootCandles;
  @JsonKey(name: 'SoftwareVersion')
  final String? softwareVersion;
  @JsonKey(name: 'SoftwareEffectiveDate')
  final String? softwareEffectiveDate;
  @JsonKey(name: 'Pattern')
  final String? pattern;
  @JsonKey(name: 'Gender')
  final String? gender;
  @JsonKey(name: 'Label')
  final String? label;
  @JsonKey(name: 'Material')
  final String? material;
  @JsonKey(name: 'Period')
  final String? period;
  @JsonKey(name: 'CleaningFeeAmount')
  final double? cleaningFeeAmount;
  @JsonKey(name: 'WardrobeSize')
  final String? wardrobeSize;
  @JsonKey(name: 'WardrobePieceCount')
  final int? wardrobePieceCount;
  @JsonKey(name: 'InventoryTypeIsProps')
  final bool? inventoryTypeIsProps;
  @JsonKey(name: 'InventoryTypeIsWardrobe')
  final bool? inventoryTypeIsWardrobe;
  @JsonKey(name: 'OrderLocationId')
  final String? orderLocationId;
  @JsonKey(name: 'ContainerNumber')
  final String? containerNumber;
  @JsonKey(name: 'IsWardrobe')
  final bool? isWardrobe;
  @JsonKey(name: 'IsProps')
  final bool? isProps;
  @JsonKey(name: 'DailyRate')
  final double? dailyRate;
  @JsonKey(name: 'WeeklyRate')
  final double? weeklyRate;
  @JsonKey(name: 'MonthlyRate')
  final double? monthlyRate;
  @JsonKey(name: 'Location')
  final String? location;
  @JsonKey(name: 'RetiredReason')
  final String? retiredReason;
  @JsonKey(name: 'WarrantyExpiration')
  final String? warrantyExpiration;
  @JsonKey(name: 'WarrantyPeriod')
  final int? warrantyPeriod;
  @JsonKey(name: 'CountryOfOriginId')
  final String? countryOfOriginId;
  @JsonKey(name: 'CountryOfOrigin')
  final String? countryOfOrigin;
  @JsonKey(name: 'ShelfLifeExpirationDate')
  final String? shelfLifeExpirationDate;
  @JsonKey(name: 'CurrentDealId')
  final String? currentDealId;
  @JsonKey(name: 'CurrentDeal')
  final String? currentDeal;
  @JsonKey(name: 'CurrentCustomerId')
  final String? currentCustomerId;
  @JsonKey(name: 'CurrentCustomer')
  final String? currentCustomer;
  @JsonKey(name: 'CurrentOrderId')
  final String? currentOrderId;
  @JsonKey(name: 'CurrentOrderNumber')
  final String? currentOrderNumber;
  @JsonKey(name: 'CurrentOrderType')
  final String? currentOrderType;
  @JsonKey(name: 'CurrentOrderDescription')
  final String? currentOrderDescription;
  @JsonKey(name: 'CurrentOrderDate')
  final String? currentOrderDate;
  @JsonKey(name: 'CurrentOrderPickDate')
  final String? currentOrderPickDate;
  @JsonKey(name: 'CurrentOrderFromDate')
  final String? currentOrderFromDate;
  @JsonKey(name: 'CurrentOrderToDate')
  final String? currentOrderToDate;
  @JsonKey(name: 'CurrentOrderAgent')
  final String? currentOrderAgent;
  @JsonKey(name: 'LotNumber')
  final String? lotNumber;
  @JsonKey(name: 'LastOrderId')
  final String? lastOrderId;
  @JsonKey(name: 'LastOrderNumber')
  final String? lastOrderNumber;
  @JsonKey(name: 'LastOrderDescription')
  final String? lastOrderDescription;
  @JsonKey(name: 'LastDealId')
  final String? lastDealId;
  @JsonKey(name: 'LastDeal')
  final String? lastDeal;
  @JsonKey(name: 'LastDealNumber')
  final String? lastDealNumber;
  @JsonKey(name: 'LastOutContractId')
  final String? lastOutContractId;
  @JsonKey(name: 'LastOutContractNumber')
  final String? lastOutContractNumber;
  @JsonKey(name: 'LastOutContractDate')
  final String? lastOutContractDate;
  @JsonKey(name: 'LastOutUserId')
  final String? lastOutUserId;
  @JsonKey(name: 'LastOutUserName')
  final String? lastOutUserName;
  @JsonKey(name: 'LastInContractId')
  final String? lastInContractId;
  @JsonKey(name: 'LastInContractNumber')
  final String? lastInContractNumber;
  @JsonKey(name: 'LastInContractDate')
  final String? lastInContractDate;
  @JsonKey(name: 'LastInUserId')
  final String? lastInUserId;
  @JsonKey(name: 'LastInUserName')
  final String? lastInUserName;
  @JsonKey(name: 'DepreciationStartDate')
  final String? depreciationStartDate;
  @JsonKey(name: 'DepreciationWarehouseId')
  final String? depreciationWarehouseId;
  @JsonKey(name: 'DepreciationWarehouse')
  final String? depreciationWarehouse;
  @JsonKey(name: 'DepreciationWarehouseCode')
  final String? depreciationWarehouseCode;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory = _$WebApiModulesInventoryAssetItemFromJson;
  static const toJsonFactory = _$WebApiModulesInventoryAssetItemToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryAssetItemToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryAssetItem &&
            (identical(other.itemId, itemId) ||
                const DeepCollectionEquality().equals(other.itemId, itemId)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.itemDescription, itemDescription) ||
                const DeepCollectionEquality()
                    .equals(other.itemDescription, itemDescription)) &&
            (identical(other.trackedBy, trackedBy) ||
                const DeepCollectionEquality()
                    .equals(other.trackedBy, trackedBy)) &&
            (identical(other.availableFor, availableFor) ||
                const DeepCollectionEquality()
                    .equals(other.availableFor, availableFor)) &&
            (identical(other.availableForDisplay, availableForDisplay) ||
                const DeepCollectionEquality()
                    .equals(other.availableForDisplay, availableForDisplay)) &&
            (identical(other.unitValue, unitValue) ||
                const DeepCollectionEquality()
                    .equals(other.unitValue, unitValue)) &&
            (identical(other.replacementCost, replacementCost) ||
                const DeepCollectionEquality()
                    .equals(other.replacementCost, replacementCost)) &&
            (identical(other.classification, classification) ||
                const DeepCollectionEquality()
                    .equals(other.classification, classification)) &&
            (identical(other.isContainer, isContainer) ||
                const DeepCollectionEquality()
                    .equals(other.isContainer, isContainer)) &&
            (identical(other.containerId, containerId) ||
                const DeepCollectionEquality()
                    .equals(other.containerId, containerId)) &&
            (identical(other.containerInventoryId, containerInventoryId) ||
                const DeepCollectionEquality().equals(
                    other.containerInventoryId, containerInventoryId)) &&
            (identical(other.containerICode, containerICode) ||
                const DeepCollectionEquality()
                    .equals(other.containerICode, containerICode)) &&
            (identical(other.containerDescription, containerDescription) ||
                const DeepCollectionEquality().equals(
                    other.containerDescription, containerDescription)) &&
            (identical(other.containerPackingListBehavior, containerPackingListBehavior) ||
                const DeepCollectionEquality().equals(
                    other.containerPackingListBehavior,
                    containerPackingListBehavior)) &&
            (identical(other.containerStatus, containerStatus) ||
                const DeepCollectionEquality()
                    .equals(other.containerStatus, containerStatus)) &&
            (identical(other.containerStatusColor, containerStatusColor) ||
                const DeepCollectionEquality().equals(
                    other.containerStatusColor, containerStatusColor)) &&
            (identical(other.containerItemId, containerItemId) ||
                const DeepCollectionEquality()
                    .equals(other.containerItemId, containerItemId)) &&
            (identical(other.containerStatusDate, containerStatusDate) || const DeepCollectionEquality().equals(other.containerStatusDate, containerStatusDate)) &&
            (identical(other.fixedAsset, fixedAsset) || const DeepCollectionEquality().equals(other.fixedAsset, fixedAsset)) &&
            (identical(other.rank, rank) || const DeepCollectionEquality().equals(other.rank, rank)) &&
            (identical(other.statusType, statusType) || const DeepCollectionEquality().equals(other.statusType, statusType)) &&
            (identical(other.statusDate, statusDate) || const DeepCollectionEquality().equals(other.statusDate, statusDate)) &&
            (identical(other.inventoryStatus, inventoryStatus) || const DeepCollectionEquality().equals(other.inventoryStatus, inventoryStatus)) &&
            (identical(other.inventoryStatusId, inventoryStatusId) || const DeepCollectionEquality().equals(other.inventoryStatusId, inventoryStatusId)) &&
            (identical(other.color, color) || const DeepCollectionEquality().equals(other.color, color)) &&
            (identical(other.textColor, textColor) || const DeepCollectionEquality().equals(other.textColor, textColor)) &&
            (identical(other.barCode, barCode) || const DeepCollectionEquality().equals(other.barCode, barCode)) &&
            (identical(other.barCodeForScanning, barCodeForScanning) || const DeepCollectionEquality().equals(other.barCodeForScanning, barCodeForScanning)) &&
            (identical(other.serialNumber, serialNumber) || const DeepCollectionEquality().equals(other.serialNumber, serialNumber)) &&
            (identical(other.rfId, rfId) || const DeepCollectionEquality().equals(other.rfId, rfId)) &&
            (identical(other.oldBarCode, oldBarCode) || const DeepCollectionEquality().equals(other.oldBarCode, oldBarCode)) &&
            (identical(other.oldSerialNumber, oldSerialNumber) || const DeepCollectionEquality().equals(other.oldSerialNumber, oldSerialNumber)) &&
            (identical(other.oldRfid, oldRfid) || const DeepCollectionEquality().equals(other.oldRfid, oldRfid)) &&
            (identical(other.manufacturerPartNumber, manufacturerPartNumber) || const DeepCollectionEquality().equals(other.manufacturerPartNumber, manufacturerPartNumber)) &&
            (identical(other.manufactureDate, manufactureDate) || const DeepCollectionEquality().equals(other.manufactureDate, manufactureDate)) &&
            (identical(other.trackedByCode, trackedByCode) || const DeepCollectionEquality().equals(other.trackedByCode, trackedByCode)) &&
            (identical(other.availOwnershipSort, availOwnershipSort) || const DeepCollectionEquality().equals(other.availOwnershipSort, availOwnershipSort)) &&
            (identical(other.isNegativeInventory, isNegativeInventory) || const DeepCollectionEquality().equals(other.isNegativeInventory, isNegativeInventory)) &&
            (identical(other.inspectionNo, inspectionNo) || const DeepCollectionEquality().equals(other.inspectionNo, inspectionNo)) &&
            (identical(other.inspectionVendorId, inspectionVendorId) || const DeepCollectionEquality().equals(other.inspectionVendorId, inspectionVendorId)) &&
            (identical(other.inspectionVendor, inspectionVendor) || const DeepCollectionEquality().equals(other.inspectionVendor, inspectionVendor)) &&
            (identical(other.manufacturerModelNumber, manufacturerModelNumber) || const DeepCollectionEquality().equals(other.manufacturerModelNumber, manufacturerModelNumber)) &&
            (identical(other.purchaseId, purchaseId) || const DeepCollectionEquality().equals(other.purchaseId, purchaseId)) &&
            (identical(other.aisleLocation, aisleLocation) || const DeepCollectionEquality().equals(other.aisleLocation, aisleLocation)) &&
            (identical(other.shelfLocation, shelfLocation) || const DeepCollectionEquality().equals(other.shelfLocation, shelfLocation)) &&
            (identical(other.spaceId, spaceId) || const DeepCollectionEquality().equals(other.spaceId, spaceId)) &&
            (identical(other.buildingRoom, buildingRoom) || const DeepCollectionEquality().equals(other.buildingRoom, buildingRoom)) &&
            (identical(other.itemNotes, itemNotes) || const DeepCollectionEquality().equals(other.itemNotes, itemNotes)) &&
            (identical(other.physicalId, physicalId) || const DeepCollectionEquality().equals(other.physicalId, physicalId)) &&
            (identical(other.physicalItemId, physicalItemId) || const DeepCollectionEquality().equals(other.physicalItemId, physicalItemId)) &&
            (identical(other.physicalDate, physicalDate) || const DeepCollectionEquality().equals(other.physicalDate, physicalDate)) &&
            (identical(other.physicalBy, physicalBy) || const DeepCollectionEquality().equals(other.physicalBy, physicalBy)) &&
            (identical(other.warehouse, warehouse) || const DeepCollectionEquality().equals(other.warehouse, warehouse)) &&
            (identical(other.warehouseCode, warehouseCode) || const DeepCollectionEquality().equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.dealId, dealId) || const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.orderId, orderId) || const DeepCollectionEquality().equals(other.orderId, orderId)) &&
            (identical(other.orderNumber, orderNumber) || const DeepCollectionEquality().equals(other.orderNumber, orderNumber)) &&
            (identical(other.orderDescription, orderDescription) || const DeepCollectionEquality().equals(other.orderDescription, orderDescription)) &&
            (identical(other.currentLocation, currentLocation) || const DeepCollectionEquality().equals(other.currentLocation, currentLocation)) &&
            (identical(other.inventoryTypeId, inventoryTypeId) || const DeepCollectionEquality().equals(other.inventoryTypeId, inventoryTypeId)) &&
            (identical(other.inventoryType, inventoryType) || const DeepCollectionEquality().equals(other.inventoryType, inventoryType)) &&
            (identical(other.inventoryTypeOrderBy, inventoryTypeOrderBy) || const DeepCollectionEquality().equals(other.inventoryTypeOrderBy, inventoryTypeOrderBy)) &&
            (identical(other.categoryId, categoryId) || const DeepCollectionEquality().equals(other.categoryId, categoryId)) &&
            (identical(other.category, category) || const DeepCollectionEquality().equals(other.category, category)) &&
            (identical(other.categoryOrderBy, categoryOrderBy) || const DeepCollectionEquality().equals(other.categoryOrderBy, categoryOrderBy)) &&
            (identical(other.subCategoryId, subCategoryId) || const DeepCollectionEquality().equals(other.subCategoryId, subCategoryId)) &&
            (identical(other.subCategory, subCategory) || const DeepCollectionEquality().equals(other.subCategory, subCategory)) &&
            (identical(other.subCategoryOrderBy, subCategoryOrderBy) || const DeepCollectionEquality().equals(other.subCategoryOrderBy, subCategoryOrderBy)) &&
            (identical(other.ownership, ownership) || const DeepCollectionEquality().equals(other.ownership, ownership)) &&
            (identical(other.purchaseVendorId, purchaseVendorId) || const DeepCollectionEquality().equals(other.purchaseVendorId, purchaseVendorId)) &&
            (identical(other.purchaseVendor, purchaseVendor) || const DeepCollectionEquality().equals(other.purchaseVendor, purchaseVendor)) &&
            (identical(other.outsidePurchaseOrderNumber, outsidePurchaseOrderNumber) || const DeepCollectionEquality().equals(other.outsidePurchaseOrderNumber, outsidePurchaseOrderNumber)) &&
            (identical(other.purchasePoId, purchasePoId) || const DeepCollectionEquality().equals(other.purchasePoId, purchasePoId)) &&
            (identical(other.purchaseDate, purchaseDate) || const DeepCollectionEquality().equals(other.purchaseDate, purchaseDate)) &&
            (identical(other.receiveDate, receiveDate) || const DeepCollectionEquality().equals(other.receiveDate, receiveDate)) &&
            (identical(other.receiveContractDate, receiveContractDate) || const DeepCollectionEquality().equals(other.receiveContractDate, receiveContractDate)) &&
            (identical(other.purchasePoNumber, purchasePoNumber) || const DeepCollectionEquality().equals(other.purchasePoNumber, purchasePoNumber)) &&
            (identical(other.purchaseCost, purchaseCost) || const DeepCollectionEquality().equals(other.purchaseCost, purchaseCost)) &&
            (identical(other.invoiceCost, invoiceCost) || const DeepCollectionEquality().equals(other.invoiceCost, invoiceCost)) &&
            (identical(other.purchaseInvoiceNumber, purchaseInvoiceNumber) || const DeepCollectionEquality().equals(other.purchaseInvoiceNumber, purchaseInvoiceNumber)) &&
            (identical(other.purchaseInvoiceDate, purchaseInvoiceDate) || const DeepCollectionEquality().equals(other.purchaseInvoiceDate, purchaseInvoiceDate)) &&
            (identical(other.purchaseCurrencyId, purchaseCurrencyId) || const DeepCollectionEquality().equals(other.purchaseCurrencyId, purchaseCurrencyId)) &&
            (identical(other.purchaseCurrencyCode, purchaseCurrencyCode) || const DeepCollectionEquality().equals(other.purchaseCurrencyCode, purchaseCurrencyCode)) &&
            (identical(other.purchaseCurrency, purchaseCurrency) || const DeepCollectionEquality().equals(other.purchaseCurrency, purchaseCurrency)) &&
            (identical(other.purchaseCurrencySymbol, purchaseCurrencySymbol) || const DeepCollectionEquality().equals(other.purchaseCurrencySymbol, purchaseCurrencySymbol)) &&
            (identical(other.warehouseCurrencyId, warehouseCurrencyId) || const DeepCollectionEquality().equals(other.warehouseCurrencyId, warehouseCurrencyId)) &&
            (identical(other.warehouseCurrencyCode, warehouseCurrencyCode) || const DeepCollectionEquality().equals(other.warehouseCurrencyCode, warehouseCurrencyCode)) &&
            (identical(other.warehouseCurrency, warehouseCurrency) || const DeepCollectionEquality().equals(other.warehouseCurrency, warehouseCurrency)) &&
            (identical(other.warehouseCurrencySymbol, warehouseCurrencySymbol) || const DeepCollectionEquality().equals(other.warehouseCurrencySymbol, warehouseCurrencySymbol)) &&
            (identical(other.purchaseCurrencyExchangeRate, purchaseCurrencyExchangeRate) || const DeepCollectionEquality().equals(other.purchaseCurrencyExchangeRate, purchaseCurrencyExchangeRate)) &&
            (identical(other.unitCost, unitCost) || const DeepCollectionEquality().equals(other.unitCost, unitCost)) &&
            (identical(other.unitCostWithTax, unitCostWithTax) || const DeepCollectionEquality().equals(other.unitCostWithTax, unitCostWithTax)) &&
            (identical(other.unitCostCurrencyConverted, unitCostCurrencyConverted) || const DeepCollectionEquality().equals(other.unitCostCurrencyConverted, unitCostCurrencyConverted)) &&
            (identical(other.unitCostWithTaxCurrencyConverted, unitCostWithTaxCurrencyConverted) || const DeepCollectionEquality().equals(other.unitCostWithTaxCurrencyConverted, unitCostWithTaxCurrencyConverted)) &&
            (identical(other.originalEquipmentCost, originalEquipmentCost) || const DeepCollectionEquality().equals(other.originalEquipmentCost, originalEquipmentCost)) &&
            (identical(other.depreciation, depreciation) || const DeepCollectionEquality().equals(other.depreciation, depreciation)) &&
            (identical(other.bookValue, bookValue) || const DeepCollectionEquality().equals(other.bookValue, bookValue)) &&
            (identical(other.salvageValue, salvageValue) || const DeepCollectionEquality().equals(other.salvageValue, salvageValue)) &&
            (identical(other.consignorId, consignorId) || const DeepCollectionEquality().equals(other.consignorId, consignorId)) &&
            (identical(other.consignor, consignor) || const DeepCollectionEquality().equals(other.consignor, consignor)) &&
            (identical(other.consignorAgreementId, consignorAgreementId) || const DeepCollectionEquality().equals(other.consignorAgreementId, consignorAgreementId)) &&
            (identical(other.consignorAgreementNumber, consignorAgreementNumber) || const DeepCollectionEquality().equals(other.consignorAgreementNumber, consignorAgreementNumber)) &&
            (identical(other.manufacturerId, manufacturerId) || const DeepCollectionEquality().equals(other.manufacturerId, manufacturerId)) &&
            (identical(other.manufacturer, manufacturer) || const DeepCollectionEquality().equals(other.manufacturer, manufacturer)) &&
            (identical(other.originalShowId, originalShowId) || const DeepCollectionEquality().equals(other.originalShowId, originalShowId)) &&
            (identical(other.originalShow, originalShow) || const DeepCollectionEquality().equals(other.originalShow, originalShow)) &&
            (identical(other.conditionId, conditionId) || const DeepCollectionEquality().equals(other.conditionId, conditionId)) &&
            (identical(other.condition, condition) || const DeepCollectionEquality().equals(other.condition, condition)) &&
            (identical(other.surfaceId, surfaceId) || const DeepCollectionEquality().equals(other.surfaceId, surfaceId)) &&
            (identical(other.surface, surface) || const DeepCollectionEquality().equals(other.surface, surface)) &&
            (identical(other.wallTypeId, wallTypeId) || const DeepCollectionEquality().equals(other.wallTypeId, wallTypeId)) &&
            (identical(other.wallType, wallType) || const DeepCollectionEquality().equals(other.wallType, wallType)) &&
            (identical(other.openingId, openingId) || const DeepCollectionEquality().equals(other.openingId, openingId)) &&
            (identical(other.opening, opening) || const DeepCollectionEquality().equals(other.opening, opening)) &&
            (identical(other.responsiblePersonId, responsiblePersonId) || const DeepCollectionEquality().equals(other.responsiblePersonId, responsiblePersonId)) &&
            (identical(other.responsiblePerson, responsiblePerson) || const DeepCollectionEquality().equals(other.responsiblePerson, responsiblePerson)) &&
            (identical(other.buyerId, buyerId) || const DeepCollectionEquality().equals(other.buyerId, buyerId)) &&
            (identical(other.buyer, buyer) || const DeepCollectionEquality().equals(other.buyer, buyer)) &&
            (identical(other.receiptNumber, receiptNumber) || const DeepCollectionEquality().equals(other.receiptNumber, receiptNumber)) &&
            (identical(other.depreciationMonths, depreciationMonths) || const DeepCollectionEquality().equals(other.depreciationMonths, depreciationMonths)) &&
            (identical(other.repairId, repairId) || const DeepCollectionEquality().equals(other.repairId, repairId)) &&
            (identical(other.repairNumber, repairNumber) || const DeepCollectionEquality().equals(other.repairNumber, repairNumber)) &&
            (identical(other.qcRequired, qcRequired) || const DeepCollectionEquality().equals(other.qcRequired, qcRequired)) &&
            (identical(other.widthFt, widthFt) || const DeepCollectionEquality().equals(other.widthFt, widthFt)) &&
            (identical(other.widthIn, widthIn) || const DeepCollectionEquality().equals(other.widthIn, widthIn)) &&
            (identical(other.heightFt, heightFt) || const DeepCollectionEquality().equals(other.heightFt, heightFt)) &&
            (identical(other.heightIn, heightIn) || const DeepCollectionEquality().equals(other.heightIn, heightIn)) &&
            (identical(other.lengthFt, lengthFt) || const DeepCollectionEquality().equals(other.lengthFt, lengthFt)) &&
            (identical(other.lengthIn, lengthIn) || const DeepCollectionEquality().equals(other.lengthIn, lengthIn)) &&
            (identical(other.currentMeter, currentMeter) || const DeepCollectionEquality().equals(other.currentMeter, currentMeter)) &&
            (identical(other.trackAssetUsage, trackAssetUsage) || const DeepCollectionEquality().equals(other.trackAssetUsage, trackAssetUsage)) &&
            (identical(other.trackLampUsage, trackLampUsage) || const DeepCollectionEquality().equals(other.trackLampUsage, trackLampUsage)) &&
            (identical(other.trackStrikes, trackStrikes) || const DeepCollectionEquality().equals(other.trackStrikes, trackStrikes)) &&
            (identical(other.trackCandles, trackCandles) || const DeepCollectionEquality().equals(other.trackCandles, trackCandles)) &&
            (identical(other.assetHours, assetHours) || const DeepCollectionEquality().equals(other.assetHours, assetHours)) &&
            (identical(other.lampCount, lampCount) || const DeepCollectionEquality().equals(other.lampCount, lampCount)) &&
            (identical(other.lampHours1, lampHours1) || const DeepCollectionEquality().equals(other.lampHours1, lampHours1)) &&
            (identical(other.lampHours2, lampHours2) || const DeepCollectionEquality().equals(other.lampHours2, lampHours2)) &&
            (identical(other.lampHours3, lampHours3) || const DeepCollectionEquality().equals(other.lampHours3, lampHours3)) &&
            (identical(other.lampHours4, lampHours4) || const DeepCollectionEquality().equals(other.lampHours4, lampHours4)) &&
            (identical(other.strikes, strikes) || const DeepCollectionEquality().equals(other.strikes, strikes)) &&
            (identical(other.footCandles, footCandles) || const DeepCollectionEquality().equals(other.footCandles, footCandles)) &&
            (identical(other.minimumFootCandles, minimumFootCandles) || const DeepCollectionEquality().equals(other.minimumFootCandles, minimumFootCandles)) &&
            (identical(other.softwareVersion, softwareVersion) || const DeepCollectionEquality().equals(other.softwareVersion, softwareVersion)) &&
            (identical(other.softwareEffectiveDate, softwareEffectiveDate) || const DeepCollectionEquality().equals(other.softwareEffectiveDate, softwareEffectiveDate)) &&
            (identical(other.pattern, pattern) || const DeepCollectionEquality().equals(other.pattern, pattern)) &&
            (identical(other.gender, gender) || const DeepCollectionEquality().equals(other.gender, gender)) &&
            (identical(other.label, label) || const DeepCollectionEquality().equals(other.label, label)) &&
            (identical(other.material, material) || const DeepCollectionEquality().equals(other.material, material)) &&
            (identical(other.period, period) || const DeepCollectionEquality().equals(other.period, period)) &&
            (identical(other.cleaningFeeAmount, cleaningFeeAmount) || const DeepCollectionEquality().equals(other.cleaningFeeAmount, cleaningFeeAmount)) &&
            (identical(other.wardrobeSize, wardrobeSize) || const DeepCollectionEquality().equals(other.wardrobeSize, wardrobeSize)) &&
            (identical(other.wardrobePieceCount, wardrobePieceCount) || const DeepCollectionEquality().equals(other.wardrobePieceCount, wardrobePieceCount)) &&
            (identical(other.inventoryTypeIsProps, inventoryTypeIsProps) || const DeepCollectionEquality().equals(other.inventoryTypeIsProps, inventoryTypeIsProps)) &&
            (identical(other.inventoryTypeIsWardrobe, inventoryTypeIsWardrobe) || const DeepCollectionEquality().equals(other.inventoryTypeIsWardrobe, inventoryTypeIsWardrobe)) &&
            (identical(other.orderLocationId, orderLocationId) || const DeepCollectionEquality().equals(other.orderLocationId, orderLocationId)) &&
            (identical(other.containerNumber, containerNumber) || const DeepCollectionEquality().equals(other.containerNumber, containerNumber)) &&
            (identical(other.isWardrobe, isWardrobe) || const DeepCollectionEquality().equals(other.isWardrobe, isWardrobe)) &&
            (identical(other.isProps, isProps) || const DeepCollectionEquality().equals(other.isProps, isProps)) &&
            (identical(other.dailyRate, dailyRate) || const DeepCollectionEquality().equals(other.dailyRate, dailyRate)) &&
            (identical(other.weeklyRate, weeklyRate) || const DeepCollectionEquality().equals(other.weeklyRate, weeklyRate)) &&
            (identical(other.monthlyRate, monthlyRate) || const DeepCollectionEquality().equals(other.monthlyRate, monthlyRate)) &&
            (identical(other.location, location) || const DeepCollectionEquality().equals(other.location, location)) &&
            (identical(other.retiredReason, retiredReason) || const DeepCollectionEquality().equals(other.retiredReason, retiredReason)) &&
            (identical(other.warrantyExpiration, warrantyExpiration) || const DeepCollectionEquality().equals(other.warrantyExpiration, warrantyExpiration)) &&
            (identical(other.warrantyPeriod, warrantyPeriod) || const DeepCollectionEquality().equals(other.warrantyPeriod, warrantyPeriod)) &&
            (identical(other.countryOfOriginId, countryOfOriginId) || const DeepCollectionEquality().equals(other.countryOfOriginId, countryOfOriginId)) &&
            (identical(other.countryOfOrigin, countryOfOrigin) || const DeepCollectionEquality().equals(other.countryOfOrigin, countryOfOrigin)) &&
            (identical(other.shelfLifeExpirationDate, shelfLifeExpirationDate) || const DeepCollectionEquality().equals(other.shelfLifeExpirationDate, shelfLifeExpirationDate)) &&
            (identical(other.currentDealId, currentDealId) || const DeepCollectionEquality().equals(other.currentDealId, currentDealId)) &&
            (identical(other.currentDeal, currentDeal) || const DeepCollectionEquality().equals(other.currentDeal, currentDeal)) &&
            (identical(other.currentCustomerId, currentCustomerId) || const DeepCollectionEquality().equals(other.currentCustomerId, currentCustomerId)) &&
            (identical(other.currentCustomer, currentCustomer) || const DeepCollectionEquality().equals(other.currentCustomer, currentCustomer)) &&
            (identical(other.currentOrderId, currentOrderId) || const DeepCollectionEquality().equals(other.currentOrderId, currentOrderId)) &&
            (identical(other.currentOrderNumber, currentOrderNumber) || const DeepCollectionEquality().equals(other.currentOrderNumber, currentOrderNumber)) &&
            (identical(other.currentOrderType, currentOrderType) || const DeepCollectionEquality().equals(other.currentOrderType, currentOrderType)) &&
            (identical(other.currentOrderDescription, currentOrderDescription) || const DeepCollectionEquality().equals(other.currentOrderDescription, currentOrderDescription)) &&
            (identical(other.currentOrderDate, currentOrderDate) || const DeepCollectionEquality().equals(other.currentOrderDate, currentOrderDate)) &&
            (identical(other.currentOrderPickDate, currentOrderPickDate) || const DeepCollectionEquality().equals(other.currentOrderPickDate, currentOrderPickDate)) &&
            (identical(other.currentOrderFromDate, currentOrderFromDate) || const DeepCollectionEquality().equals(other.currentOrderFromDate, currentOrderFromDate)) &&
            (identical(other.currentOrderToDate, currentOrderToDate) || const DeepCollectionEquality().equals(other.currentOrderToDate, currentOrderToDate)) &&
            (identical(other.currentOrderAgent, currentOrderAgent) || const DeepCollectionEquality().equals(other.currentOrderAgent, currentOrderAgent)) &&
            (identical(other.lotNumber, lotNumber) || const DeepCollectionEquality().equals(other.lotNumber, lotNumber)) &&
            (identical(other.lastOrderId, lastOrderId) || const DeepCollectionEquality().equals(other.lastOrderId, lastOrderId)) &&
            (identical(other.lastOrderNumber, lastOrderNumber) || const DeepCollectionEquality().equals(other.lastOrderNumber, lastOrderNumber)) &&
            (identical(other.lastOrderDescription, lastOrderDescription) || const DeepCollectionEquality().equals(other.lastOrderDescription, lastOrderDescription)) &&
            (identical(other.lastDealId, lastDealId) || const DeepCollectionEquality().equals(other.lastDealId, lastDealId)) &&
            (identical(other.lastDeal, lastDeal) || const DeepCollectionEquality().equals(other.lastDeal, lastDeal)) &&
            (identical(other.lastDealNumber, lastDealNumber) || const DeepCollectionEquality().equals(other.lastDealNumber, lastDealNumber)) &&
            (identical(other.lastOutContractId, lastOutContractId) || const DeepCollectionEquality().equals(other.lastOutContractId, lastOutContractId)) &&
            (identical(other.lastOutContractNumber, lastOutContractNumber) || const DeepCollectionEquality().equals(other.lastOutContractNumber, lastOutContractNumber)) &&
            (identical(other.lastOutContractDate, lastOutContractDate) || const DeepCollectionEquality().equals(other.lastOutContractDate, lastOutContractDate)) &&
            (identical(other.lastOutUserId, lastOutUserId) || const DeepCollectionEquality().equals(other.lastOutUserId, lastOutUserId)) &&
            (identical(other.lastOutUserName, lastOutUserName) || const DeepCollectionEquality().equals(other.lastOutUserName, lastOutUserName)) &&
            (identical(other.lastInContractId, lastInContractId) || const DeepCollectionEquality().equals(other.lastInContractId, lastInContractId)) &&
            (identical(other.lastInContractNumber, lastInContractNumber) || const DeepCollectionEquality().equals(other.lastInContractNumber, lastInContractNumber)) &&
            (identical(other.lastInContractDate, lastInContractDate) || const DeepCollectionEquality().equals(other.lastInContractDate, lastInContractDate)) &&
            (identical(other.lastInUserId, lastInUserId) || const DeepCollectionEquality().equals(other.lastInUserId, lastInUserId)) &&
            (identical(other.lastInUserName, lastInUserName) || const DeepCollectionEquality().equals(other.lastInUserName, lastInUserName)) &&
            (identical(other.depreciationStartDate, depreciationStartDate) || const DeepCollectionEquality().equals(other.depreciationStartDate, depreciationStartDate)) &&
            (identical(other.depreciationWarehouseId, depreciationWarehouseId) || const DeepCollectionEquality().equals(other.depreciationWarehouseId, depreciationWarehouseId)) &&
            (identical(other.depreciationWarehouse, depreciationWarehouse) || const DeepCollectionEquality().equals(other.depreciationWarehouse, depreciationWarehouse)) &&
            (identical(other.depreciationWarehouseCode, depreciationWarehouseCode) || const DeepCollectionEquality().equals(other.depreciationWarehouseCode, depreciationWarehouseCode)) &&
            (identical(other.inactive, inactive) || const DeepCollectionEquality().equals(other.inactive, inactive)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesInventoryAssetItemExtension
    on WebApiModulesInventoryAssetItem {
  WebApiModulesInventoryAssetItem copyWith(
      {String? itemId,
      String? inventoryId,
      String? warehouseId,
      String? iCode,
      String? description,
      String? itemDescription,
      String? trackedBy,
      String? availableFor,
      String? availableForDisplay,
      double? unitValue,
      double? replacementCost,
      String? classification,
      bool? isContainer,
      String? containerId,
      String? containerInventoryId,
      String? containerICode,
      String? containerDescription,
      String? containerPackingListBehavior,
      String? containerStatus,
      String? containerStatusColor,
      String? containerItemId,
      String? containerStatusDate,
      bool? fixedAsset,
      String? rank,
      String? statusType,
      String? statusDate,
      String? inventoryStatus,
      String? inventoryStatusId,
      String? color,
      String? textColor,
      String? barCode,
      String? barCodeForScanning,
      String? serialNumber,
      String? rfId,
      String? oldBarCode,
      String? oldSerialNumber,
      String? oldRfid,
      String? manufacturerPartNumber,
      String? manufactureDate,
      String? trackedByCode,
      int? availOwnershipSort,
      bool? isNegativeInventory,
      String? inspectionNo,
      String? inspectionVendorId,
      String? inspectionVendor,
      String? manufacturerModelNumber,
      String? purchaseId,
      String? aisleLocation,
      String? shelfLocation,
      String? spaceId,
      String? buildingRoom,
      String? itemNotes,
      String? physicalId,
      int? physicalItemId,
      String? physicalDate,
      String? physicalBy,
      String? warehouse,
      String? warehouseCode,
      String? dealId,
      String? orderId,
      String? orderNumber,
      String? orderDescription,
      String? currentLocation,
      String? inventoryTypeId,
      String? inventoryType,
      int? inventoryTypeOrderBy,
      String? categoryId,
      String? category,
      double? categoryOrderBy,
      String? subCategoryId,
      String? subCategory,
      double? subCategoryOrderBy,
      String? ownership,
      String? purchaseVendorId,
      String? purchaseVendor,
      String? outsidePurchaseOrderNumber,
      String? purchasePoId,
      String? purchaseDate,
      String? receiveDate,
      String? receiveContractDate,
      String? purchasePoNumber,
      double? purchaseCost,
      double? invoiceCost,
      String? purchaseInvoiceNumber,
      String? purchaseInvoiceDate,
      String? purchaseCurrencyId,
      String? purchaseCurrencyCode,
      String? purchaseCurrency,
      String? purchaseCurrencySymbol,
      String? warehouseCurrencyId,
      String? warehouseCurrencyCode,
      String? warehouseCurrency,
      String? warehouseCurrencySymbol,
      double? purchaseCurrencyExchangeRate,
      double? unitCost,
      double? unitCostWithTax,
      double? unitCostCurrencyConverted,
      double? unitCostWithTaxCurrencyConverted,
      double? originalEquipmentCost,
      double? depreciation,
      double? bookValue,
      double? salvageValue,
      String? consignorId,
      String? consignor,
      String? consignorAgreementId,
      String? consignorAgreementNumber,
      String? manufacturerId,
      String? manufacturer,
      String? originalShowId,
      String? originalShow,
      String? conditionId,
      String? condition,
      String? surfaceId,
      String? surface,
      String? wallTypeId,
      String? wallType,
      String? openingId,
      String? opening,
      String? responsiblePersonId,
      String? responsiblePerson,
      String? buyerId,
      String? buyer,
      String? receiptNumber,
      int? depreciationMonths,
      String? repairId,
      String? repairNumber,
      bool? qcRequired,
      int? widthFt,
      int? widthIn,
      int? heightFt,
      int? heightIn,
      int? lengthFt,
      int? lengthIn,
      double? currentMeter,
      bool? trackAssetUsage,
      bool? trackLampUsage,
      bool? trackStrikes,
      bool? trackCandles,
      int? assetHours,
      int? lampCount,
      int? lampHours1,
      int? lampHours2,
      int? lampHours3,
      int? lampHours4,
      int? strikes,
      int? footCandles,
      int? minimumFootCandles,
      String? softwareVersion,
      String? softwareEffectiveDate,
      String? pattern,
      String? gender,
      String? label,
      String? material,
      String? period,
      double? cleaningFeeAmount,
      String? wardrobeSize,
      int? wardrobePieceCount,
      bool? inventoryTypeIsProps,
      bool? inventoryTypeIsWardrobe,
      String? orderLocationId,
      String? containerNumber,
      bool? isWardrobe,
      bool? isProps,
      double? dailyRate,
      double? weeklyRate,
      double? monthlyRate,
      String? location,
      String? retiredReason,
      String? warrantyExpiration,
      int? warrantyPeriod,
      String? countryOfOriginId,
      String? countryOfOrigin,
      String? shelfLifeExpirationDate,
      String? currentDealId,
      String? currentDeal,
      String? currentCustomerId,
      String? currentCustomer,
      String? currentOrderId,
      String? currentOrderNumber,
      String? currentOrderType,
      String? currentOrderDescription,
      String? currentOrderDate,
      String? currentOrderPickDate,
      String? currentOrderFromDate,
      String? currentOrderToDate,
      String? currentOrderAgent,
      String? lotNumber,
      String? lastOrderId,
      String? lastOrderNumber,
      String? lastOrderDescription,
      String? lastDealId,
      String? lastDeal,
      String? lastDealNumber,
      String? lastOutContractId,
      String? lastOutContractNumber,
      String? lastOutContractDate,
      String? lastOutUserId,
      String? lastOutUserName,
      String? lastInContractId,
      String? lastInContractNumber,
      String? lastInContractDate,
      String? lastInUserId,
      String? lastInUserName,
      String? depreciationStartDate,
      String? depreciationWarehouseId,
      String? depreciationWarehouse,
      String? depreciationWarehouseCode,
      bool? inactive,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesInventoryAssetItem(
        itemId: itemId ?? this.itemId,
        inventoryId: inventoryId ?? this.inventoryId,
        warehouseId: warehouseId ?? this.warehouseId,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        itemDescription: itemDescription ?? this.itemDescription,
        trackedBy: trackedBy ?? this.trackedBy,
        availableFor: availableFor ?? this.availableFor,
        availableForDisplay: availableForDisplay ?? this.availableForDisplay,
        unitValue: unitValue ?? this.unitValue,
        replacementCost: replacementCost ?? this.replacementCost,
        classification: classification ?? this.classification,
        isContainer: isContainer ?? this.isContainer,
        containerId: containerId ?? this.containerId,
        containerInventoryId: containerInventoryId ?? this.containerInventoryId,
        containerICode: containerICode ?? this.containerICode,
        containerDescription: containerDescription ?? this.containerDescription,
        containerPackingListBehavior:
            containerPackingListBehavior ?? this.containerPackingListBehavior,
        containerStatus: containerStatus ?? this.containerStatus,
        containerStatusColor: containerStatusColor ?? this.containerStatusColor,
        containerItemId: containerItemId ?? this.containerItemId,
        containerStatusDate: containerStatusDate ?? this.containerStatusDate,
        fixedAsset: fixedAsset ?? this.fixedAsset,
        rank: rank ?? this.rank,
        statusType: statusType ?? this.statusType,
        statusDate: statusDate ?? this.statusDate,
        inventoryStatus: inventoryStatus ?? this.inventoryStatus,
        inventoryStatusId: inventoryStatusId ?? this.inventoryStatusId,
        color: color ?? this.color,
        textColor: textColor ?? this.textColor,
        barCode: barCode ?? this.barCode,
        barCodeForScanning: barCodeForScanning ?? this.barCodeForScanning,
        serialNumber: serialNumber ?? this.serialNumber,
        rfId: rfId ?? this.rfId,
        oldBarCode: oldBarCode ?? this.oldBarCode,
        oldSerialNumber: oldSerialNumber ?? this.oldSerialNumber,
        oldRfid: oldRfid ?? this.oldRfid,
        manufacturerPartNumber:
            manufacturerPartNumber ?? this.manufacturerPartNumber,
        manufactureDate: manufactureDate ?? this.manufactureDate,
        trackedByCode: trackedByCode ?? this.trackedByCode,
        availOwnershipSort: availOwnershipSort ?? this.availOwnershipSort,
        isNegativeInventory: isNegativeInventory ?? this.isNegativeInventory,
        inspectionNo: inspectionNo ?? this.inspectionNo,
        inspectionVendorId: inspectionVendorId ?? this.inspectionVendorId,
        inspectionVendor: inspectionVendor ?? this.inspectionVendor,
        manufacturerModelNumber:
            manufacturerModelNumber ?? this.manufacturerModelNumber,
        purchaseId: purchaseId ?? this.purchaseId,
        aisleLocation: aisleLocation ?? this.aisleLocation,
        shelfLocation: shelfLocation ?? this.shelfLocation,
        spaceId: spaceId ?? this.spaceId,
        buildingRoom: buildingRoom ?? this.buildingRoom,
        itemNotes: itemNotes ?? this.itemNotes,
        physicalId: physicalId ?? this.physicalId,
        physicalItemId: physicalItemId ?? this.physicalItemId,
        physicalDate: physicalDate ?? this.physicalDate,
        physicalBy: physicalBy ?? this.physicalBy,
        warehouse: warehouse ?? this.warehouse,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        dealId: dealId ?? this.dealId,
        orderId: orderId ?? this.orderId,
        orderNumber: orderNumber ?? this.orderNumber,
        orderDescription: orderDescription ?? this.orderDescription,
        currentLocation: currentLocation ?? this.currentLocation,
        inventoryTypeId: inventoryTypeId ?? this.inventoryTypeId,
        inventoryType: inventoryType ?? this.inventoryType,
        inventoryTypeOrderBy: inventoryTypeOrderBy ?? this.inventoryTypeOrderBy,
        categoryId: categoryId ?? this.categoryId,
        category: category ?? this.category,
        categoryOrderBy: categoryOrderBy ?? this.categoryOrderBy,
        subCategoryId: subCategoryId ?? this.subCategoryId,
        subCategory: subCategory ?? this.subCategory,
        subCategoryOrderBy: subCategoryOrderBy ?? this.subCategoryOrderBy,
        ownership: ownership ?? this.ownership,
        purchaseVendorId: purchaseVendorId ?? this.purchaseVendorId,
        purchaseVendor: purchaseVendor ?? this.purchaseVendor,
        outsidePurchaseOrderNumber:
            outsidePurchaseOrderNumber ?? this.outsidePurchaseOrderNumber,
        purchasePoId: purchasePoId ?? this.purchasePoId,
        purchaseDate: purchaseDate ?? this.purchaseDate,
        receiveDate: receiveDate ?? this.receiveDate,
        receiveContractDate: receiveContractDate ?? this.receiveContractDate,
        purchasePoNumber: purchasePoNumber ?? this.purchasePoNumber,
        purchaseCost: purchaseCost ?? this.purchaseCost,
        invoiceCost: invoiceCost ?? this.invoiceCost,
        purchaseInvoiceNumber:
            purchaseInvoiceNumber ?? this.purchaseInvoiceNumber,
        purchaseInvoiceDate: purchaseInvoiceDate ?? this.purchaseInvoiceDate,
        purchaseCurrencyId: purchaseCurrencyId ?? this.purchaseCurrencyId,
        purchaseCurrencyCode: purchaseCurrencyCode ?? this.purchaseCurrencyCode,
        purchaseCurrency: purchaseCurrency ?? this.purchaseCurrency,
        purchaseCurrencySymbol:
            purchaseCurrencySymbol ?? this.purchaseCurrencySymbol,
        warehouseCurrencyId: warehouseCurrencyId ?? this.warehouseCurrencyId,
        warehouseCurrencyCode:
            warehouseCurrencyCode ?? this.warehouseCurrencyCode,
        warehouseCurrency: warehouseCurrency ?? this.warehouseCurrency,
        warehouseCurrencySymbol:
            warehouseCurrencySymbol ?? this.warehouseCurrencySymbol,
        purchaseCurrencyExchangeRate:
            purchaseCurrencyExchangeRate ?? this.purchaseCurrencyExchangeRate,
        unitCost: unitCost ?? this.unitCost,
        unitCostWithTax: unitCostWithTax ?? this.unitCostWithTax,
        unitCostCurrencyConverted:
            unitCostCurrencyConverted ?? this.unitCostCurrencyConverted,
        unitCostWithTaxCurrencyConverted: unitCostWithTaxCurrencyConverted ??
            this.unitCostWithTaxCurrencyConverted,
        originalEquipmentCost:
            originalEquipmentCost ?? this.originalEquipmentCost,
        depreciation: depreciation ?? this.depreciation,
        bookValue: bookValue ?? this.bookValue,
        salvageValue: salvageValue ?? this.salvageValue,
        consignorId: consignorId ?? this.consignorId,
        consignor: consignor ?? this.consignor,
        consignorAgreementId: consignorAgreementId ?? this.consignorAgreementId,
        consignorAgreementNumber:
            consignorAgreementNumber ?? this.consignorAgreementNumber,
        manufacturerId: manufacturerId ?? this.manufacturerId,
        manufacturer: manufacturer ?? this.manufacturer,
        originalShowId: originalShowId ?? this.originalShowId,
        originalShow: originalShow ?? this.originalShow,
        conditionId: conditionId ?? this.conditionId,
        condition: condition ?? this.condition,
        surfaceId: surfaceId ?? this.surfaceId,
        surface: surface ?? this.surface,
        wallTypeId: wallTypeId ?? this.wallTypeId,
        wallType: wallType ?? this.wallType,
        openingId: openingId ?? this.openingId,
        opening: opening ?? this.opening,
        responsiblePersonId: responsiblePersonId ?? this.responsiblePersonId,
        responsiblePerson: responsiblePerson ?? this.responsiblePerson,
        buyerId: buyerId ?? this.buyerId,
        buyer: buyer ?? this.buyer,
        receiptNumber: receiptNumber ?? this.receiptNumber,
        depreciationMonths: depreciationMonths ?? this.depreciationMonths,
        repairId: repairId ?? this.repairId,
        repairNumber: repairNumber ?? this.repairNumber,
        qcRequired: qcRequired ?? this.qcRequired,
        widthFt: widthFt ?? this.widthFt,
        widthIn: widthIn ?? this.widthIn,
        heightFt: heightFt ?? this.heightFt,
        heightIn: heightIn ?? this.heightIn,
        lengthFt: lengthFt ?? this.lengthFt,
        lengthIn: lengthIn ?? this.lengthIn,
        currentMeter: currentMeter ?? this.currentMeter,
        trackAssetUsage: trackAssetUsage ?? this.trackAssetUsage,
        trackLampUsage: trackLampUsage ?? this.trackLampUsage,
        trackStrikes: trackStrikes ?? this.trackStrikes,
        trackCandles: trackCandles ?? this.trackCandles,
        assetHours: assetHours ?? this.assetHours,
        lampCount: lampCount ?? this.lampCount,
        lampHours1: lampHours1 ?? this.lampHours1,
        lampHours2: lampHours2 ?? this.lampHours2,
        lampHours3: lampHours3 ?? this.lampHours3,
        lampHours4: lampHours4 ?? this.lampHours4,
        strikes: strikes ?? this.strikes,
        footCandles: footCandles ?? this.footCandles,
        minimumFootCandles: minimumFootCandles ?? this.minimumFootCandles,
        softwareVersion: softwareVersion ?? this.softwareVersion,
        softwareEffectiveDate:
            softwareEffectiveDate ?? this.softwareEffectiveDate,
        pattern: pattern ?? this.pattern,
        gender: gender ?? this.gender,
        label: label ?? this.label,
        material: material ?? this.material,
        period: period ?? this.period,
        cleaningFeeAmount: cleaningFeeAmount ?? this.cleaningFeeAmount,
        wardrobeSize: wardrobeSize ?? this.wardrobeSize,
        wardrobePieceCount: wardrobePieceCount ?? this.wardrobePieceCount,
        inventoryTypeIsProps: inventoryTypeIsProps ?? this.inventoryTypeIsProps,
        inventoryTypeIsWardrobe:
            inventoryTypeIsWardrobe ?? this.inventoryTypeIsWardrobe,
        orderLocationId: orderLocationId ?? this.orderLocationId,
        containerNumber: containerNumber ?? this.containerNumber,
        isWardrobe: isWardrobe ?? this.isWardrobe,
        isProps: isProps ?? this.isProps,
        dailyRate: dailyRate ?? this.dailyRate,
        weeklyRate: weeklyRate ?? this.weeklyRate,
        monthlyRate: monthlyRate ?? this.monthlyRate,
        location: location ?? this.location,
        retiredReason: retiredReason ?? this.retiredReason,
        warrantyExpiration: warrantyExpiration ?? this.warrantyExpiration,
        warrantyPeriod: warrantyPeriod ?? this.warrantyPeriod,
        countryOfOriginId: countryOfOriginId ?? this.countryOfOriginId,
        countryOfOrigin: countryOfOrigin ?? this.countryOfOrigin,
        shelfLifeExpirationDate:
            shelfLifeExpirationDate ?? this.shelfLifeExpirationDate,
        currentDealId: currentDealId ?? this.currentDealId,
        currentDeal: currentDeal ?? this.currentDeal,
        currentCustomerId: currentCustomerId ?? this.currentCustomerId,
        currentCustomer: currentCustomer ?? this.currentCustomer,
        currentOrderId: currentOrderId ?? this.currentOrderId,
        currentOrderNumber: currentOrderNumber ?? this.currentOrderNumber,
        currentOrderType: currentOrderType ?? this.currentOrderType,
        currentOrderDescription:
            currentOrderDescription ?? this.currentOrderDescription,
        currentOrderDate: currentOrderDate ?? this.currentOrderDate,
        currentOrderPickDate: currentOrderPickDate ?? this.currentOrderPickDate,
        currentOrderFromDate: currentOrderFromDate ?? this.currentOrderFromDate,
        currentOrderToDate: currentOrderToDate ?? this.currentOrderToDate,
        currentOrderAgent: currentOrderAgent ?? this.currentOrderAgent,
        lotNumber: lotNumber ?? this.lotNumber,
        lastOrderId: lastOrderId ?? this.lastOrderId,
        lastOrderNumber: lastOrderNumber ?? this.lastOrderNumber,
        lastOrderDescription: lastOrderDescription ?? this.lastOrderDescription,
        lastDealId: lastDealId ?? this.lastDealId,
        lastDeal: lastDeal ?? this.lastDeal,
        lastDealNumber: lastDealNumber ?? this.lastDealNumber,
        lastOutContractId: lastOutContractId ?? this.lastOutContractId,
        lastOutContractNumber:
            lastOutContractNumber ?? this.lastOutContractNumber,
        lastOutContractDate: lastOutContractDate ?? this.lastOutContractDate,
        lastOutUserId: lastOutUserId ?? this.lastOutUserId,
        lastOutUserName: lastOutUserName ?? this.lastOutUserName,
        lastInContractId: lastInContractId ?? this.lastInContractId,
        lastInContractNumber: lastInContractNumber ?? this.lastInContractNumber,
        lastInContractDate: lastInContractDate ?? this.lastInContractDate,
        lastInUserId: lastInUserId ?? this.lastInUserId,
        lastInUserName: lastInUserName ?? this.lastInUserName,
        depreciationStartDate:
            depreciationStartDate ?? this.depreciationStartDate,
        depreciationWarehouseId:
            depreciationWarehouseId ?? this.depreciationWarehouseId,
        depreciationWarehouse:
            depreciationWarehouse ?? this.depreciationWarehouse,
        depreciationWarehouseCode:
            depreciationWarehouseCode ?? this.depreciationWarehouseCode,
        inactive: inactive ?? this.inactive,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryAssetItemByBarCodeResponse {
  WebApiModulesInventoryAssetItemByBarCodeResponse({
    this.status,
    this.success,
    this.msg,
    this.item,
  });

  factory WebApiModulesInventoryAssetItemByBarCodeResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryAssetItemByBarCodeResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'Item')
  final WebApiModulesInventoryAssetItem? item;
  static const fromJsonFactory =
      _$WebApiModulesInventoryAssetItemByBarCodeResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryAssetItemByBarCodeResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryAssetItemByBarCodeResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryAssetItemByBarCodeResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.item, item) ||
                const DeepCollectionEquality().equals(other.item, item)));
  }
}

extension $WebApiModulesInventoryAssetItemByBarCodeResponseExtension
    on WebApiModulesInventoryAssetItemByBarCodeResponse {
  WebApiModulesInventoryAssetItemByBarCodeResponse copyWith(
      {int? status,
      bool? success,
      String? msg,
      WebApiModulesInventoryAssetItem? item}) {
    return WebApiModulesInventoryAssetItemByBarCodeResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        item: item ?? this.item);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryCompleteQcCompleteQcItemRequest {
  WebApiModulesInventoryCompleteQcCompleteQcItemRequest({
    this.code,
    this.qcAnyway,
  });

  factory WebApiModulesInventoryCompleteQcCompleteQcItemRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryCompleteQcCompleteQcItemRequestFromJson(json);

  @JsonKey(name: 'Code')
  final String? code;
  @JsonKey(name: 'QcAnyway')
  final bool? qcAnyway;
  static const fromJsonFactory =
      _$WebApiModulesInventoryCompleteQcCompleteQcItemRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryCompleteQcCompleteQcItemRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryCompleteQcCompleteQcItemRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryCompleteQcCompleteQcItemRequest &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)) &&
            (identical(other.qcAnyway, qcAnyway) ||
                const DeepCollectionEquality()
                    .equals(other.qcAnyway, qcAnyway)));
  }
}

extension $WebApiModulesInventoryCompleteQcCompleteQcItemRequestExtension
    on WebApiModulesInventoryCompleteQcCompleteQcItemRequest {
  WebApiModulesInventoryCompleteQcCompleteQcItemRequest copyWith(
      {String? code, bool? qcAnyway}) {
    return WebApiModulesInventoryCompleteQcCompleteQcItemRequest(
        code: code ?? this.code, qcAnyway: qcAnyway ?? this.qcAnyway);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryCompleteQcCompleteQcItemResponse {
  WebApiModulesInventoryCompleteQcCompleteQcItemResponse({
    this.status,
    this.success,
    this.msg,
    this.inventoryId,
    this.iCode,
    this.description,
    this.conditionId,
    this.condition,
    this.itemId,
    this.itemQcId,
    this.cannotQcItemBecauseOfStatus,
    this.itemDoesNotNeedQc,
    this.showFootCandles,
    this.requiredFootCandles,
    this.showSoftwareVersion,
    this.requiredSoftwareVersion,
    this.showAssetUsage,
    this.showLampUsage,
    this.showStrikes,
    this.lampCount,
  });

  factory WebApiModulesInventoryCompleteQcCompleteQcItemResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryCompleteQcCompleteQcItemResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'ConditionId')
  final String? conditionId;
  @JsonKey(name: 'Condition')
  final String? condition;
  @JsonKey(name: 'ItemId')
  final String? itemId;
  @JsonKey(name: 'ItemQcId')
  final String? itemQcId;
  @JsonKey(name: 'CannotQcItemBecauseOfStatus')
  final bool? cannotQcItemBecauseOfStatus;
  @JsonKey(name: 'ItemDoesNotNeedQc')
  final bool? itemDoesNotNeedQc;
  @JsonKey(name: 'ShowFootCandles')
  final bool? showFootCandles;
  @JsonKey(name: 'RequiredFootCandles')
  final int? requiredFootCandles;
  @JsonKey(name: 'ShowSoftwareVersion')
  final bool? showSoftwareVersion;
  @JsonKey(name: 'RequiredSoftwareVersion')
  final String? requiredSoftwareVersion;
  @JsonKey(name: 'ShowAssetUsage')
  final bool? showAssetUsage;
  @JsonKey(name: 'ShowLampUsage')
  final bool? showLampUsage;
  @JsonKey(name: 'ShowStrikes')
  final bool? showStrikes;
  @JsonKey(name: 'LampCount')
  final int? lampCount;
  static const fromJsonFactory =
      _$WebApiModulesInventoryCompleteQcCompleteQcItemResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryCompleteQcCompleteQcItemResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryCompleteQcCompleteQcItemResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryCompleteQcCompleteQcItemResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.conditionId, conditionId) ||
                const DeepCollectionEquality()
                    .equals(other.conditionId, conditionId)) &&
            (identical(other.condition, condition) ||
                const DeepCollectionEquality()
                    .equals(other.condition, condition)) &&
            (identical(other.itemId, itemId) ||
                const DeepCollectionEquality().equals(other.itemId, itemId)) &&
            (identical(other.itemQcId, itemQcId) ||
                const DeepCollectionEquality()
                    .equals(other.itemQcId, itemQcId)) &&
            (identical(other.cannotQcItemBecauseOfStatus, cannotQcItemBecauseOfStatus) ||
                const DeepCollectionEquality().equals(
                    other.cannotQcItemBecauseOfStatus,
                    cannotQcItemBecauseOfStatus)) &&
            (identical(other.itemDoesNotNeedQc, itemDoesNotNeedQc) ||
                const DeepCollectionEquality()
                    .equals(other.itemDoesNotNeedQc, itemDoesNotNeedQc)) &&
            (identical(other.showFootCandles, showFootCandles) ||
                const DeepCollectionEquality()
                    .equals(other.showFootCandles, showFootCandles)) &&
            (identical(other.requiredFootCandles, requiredFootCandles) ||
                const DeepCollectionEquality()
                    .equals(other.requiredFootCandles, requiredFootCandles)) &&
            (identical(other.showSoftwareVersion, showSoftwareVersion) ||
                const DeepCollectionEquality()
                    .equals(other.showSoftwareVersion, showSoftwareVersion)) &&
            (identical(other.requiredSoftwareVersion, requiredSoftwareVersion) ||
                const DeepCollectionEquality().equals(
                    other.requiredSoftwareVersion, requiredSoftwareVersion)) &&
            (identical(other.showAssetUsage, showAssetUsage) ||
                const DeepCollectionEquality()
                    .equals(other.showAssetUsage, showAssetUsage)) &&
            (identical(other.showLampUsage, showLampUsage) ||
                const DeepCollectionEquality()
                    .equals(other.showLampUsage, showLampUsage)) &&
            (identical(other.showStrikes, showStrikes) ||
                const DeepCollectionEquality()
                    .equals(other.showStrikes, showStrikes)) &&
            (identical(other.lampCount, lampCount) ||
                const DeepCollectionEquality()
                    .equals(other.lampCount, lampCount)));
  }
}

extension $WebApiModulesInventoryCompleteQcCompleteQcItemResponseExtension
    on WebApiModulesInventoryCompleteQcCompleteQcItemResponse {
  WebApiModulesInventoryCompleteQcCompleteQcItemResponse copyWith(
      {int? status,
      bool? success,
      String? msg,
      String? inventoryId,
      String? iCode,
      String? description,
      String? conditionId,
      String? condition,
      String? itemId,
      String? itemQcId,
      bool? cannotQcItemBecauseOfStatus,
      bool? itemDoesNotNeedQc,
      bool? showFootCandles,
      int? requiredFootCandles,
      bool? showSoftwareVersion,
      String? requiredSoftwareVersion,
      bool? showAssetUsage,
      bool? showLampUsage,
      bool? showStrikes,
      int? lampCount}) {
    return WebApiModulesInventoryCompleteQcCompleteQcItemResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        inventoryId: inventoryId ?? this.inventoryId,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        conditionId: conditionId ?? this.conditionId,
        condition: condition ?? this.condition,
        itemId: itemId ?? this.itemId,
        itemQcId: itemQcId ?? this.itemQcId,
        cannotQcItemBecauseOfStatus:
            cannotQcItemBecauseOfStatus ?? this.cannotQcItemBecauseOfStatus,
        itemDoesNotNeedQc: itemDoesNotNeedQc ?? this.itemDoesNotNeedQc,
        showFootCandles: showFootCandles ?? this.showFootCandles,
        requiredFootCandles: requiredFootCandles ?? this.requiredFootCandles,
        showSoftwareVersion: showSoftwareVersion ?? this.showSoftwareVersion,
        requiredSoftwareVersion:
            requiredSoftwareVersion ?? this.requiredSoftwareVersion,
        showAssetUsage: showAssetUsage ?? this.showAssetUsage,
        showLampUsage: showLampUsage ?? this.showLampUsage,
        showStrikes: showStrikes ?? this.showStrikes,
        lampCount: lampCount ?? this.lampCount);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryCompleteQcUpdateQcItemRequest {
  WebApiModulesInventoryCompleteQcUpdateQcItemRequest({
    this.itemId,
    this.itemQcId,
    this.conditionId,
    this.currentFootCandles,
    this.currentSoftwareVersion,
    this.softwareEffectiveDate,
    this.note,
    this.assetHours,
    this.strikes,
    this.lampHours1,
    this.lampHours2,
    this.lampHours3,
    this.lampHours4,
  });

  factory WebApiModulesInventoryCompleteQcUpdateQcItemRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryCompleteQcUpdateQcItemRequestFromJson(json);

  @JsonKey(name: 'ItemId')
  final String? itemId;
  @JsonKey(name: 'ItemQcId')
  final String? itemQcId;
  @JsonKey(name: 'ConditionId')
  final String? conditionId;
  @JsonKey(name: 'CurrentFootCandles')
  final String? currentFootCandles;
  @JsonKey(name: 'CurrentSoftwareVersion')
  final String? currentSoftwareVersion;
  @JsonKey(name: 'SoftwareEffectiveDate')
  final String? softwareEffectiveDate;
  @JsonKey(name: 'Note')
  final String? note;
  @JsonKey(name: 'AssetHours')
  final int? assetHours;
  @JsonKey(name: 'Strikes')
  final int? strikes;
  @JsonKey(name: 'LampHours1')
  final int? lampHours1;
  @JsonKey(name: 'LampHours2')
  final int? lampHours2;
  @JsonKey(name: 'LampHours3')
  final int? lampHours3;
  @JsonKey(name: 'LampHours4')
  final int? lampHours4;
  static const fromJsonFactory =
      _$WebApiModulesInventoryCompleteQcUpdateQcItemRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryCompleteQcUpdateQcItemRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryCompleteQcUpdateQcItemRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryCompleteQcUpdateQcItemRequest &&
            (identical(other.itemId, itemId) ||
                const DeepCollectionEquality().equals(other.itemId, itemId)) &&
            (identical(other.itemQcId, itemQcId) ||
                const DeepCollectionEquality()
                    .equals(other.itemQcId, itemQcId)) &&
            (identical(other.conditionId, conditionId) ||
                const DeepCollectionEquality()
                    .equals(other.conditionId, conditionId)) &&
            (identical(other.currentFootCandles, currentFootCandles) ||
                const DeepCollectionEquality()
                    .equals(other.currentFootCandles, currentFootCandles)) &&
            (identical(other.currentSoftwareVersion, currentSoftwareVersion) ||
                const DeepCollectionEquality().equals(
                    other.currentSoftwareVersion, currentSoftwareVersion)) &&
            (identical(other.softwareEffectiveDate, softwareEffectiveDate) ||
                const DeepCollectionEquality().equals(
                    other.softwareEffectiveDate, softwareEffectiveDate)) &&
            (identical(other.note, note) ||
                const DeepCollectionEquality().equals(other.note, note)) &&
            (identical(other.assetHours, assetHours) ||
                const DeepCollectionEquality()
                    .equals(other.assetHours, assetHours)) &&
            (identical(other.strikes, strikes) ||
                const DeepCollectionEquality()
                    .equals(other.strikes, strikes)) &&
            (identical(other.lampHours1, lampHours1) ||
                const DeepCollectionEquality()
                    .equals(other.lampHours1, lampHours1)) &&
            (identical(other.lampHours2, lampHours2) ||
                const DeepCollectionEquality()
                    .equals(other.lampHours2, lampHours2)) &&
            (identical(other.lampHours3, lampHours3) ||
                const DeepCollectionEquality()
                    .equals(other.lampHours3, lampHours3)) &&
            (identical(other.lampHours4, lampHours4) ||
                const DeepCollectionEquality()
                    .equals(other.lampHours4, lampHours4)));
  }
}

extension $WebApiModulesInventoryCompleteQcUpdateQcItemRequestExtension
    on WebApiModulesInventoryCompleteQcUpdateQcItemRequest {
  WebApiModulesInventoryCompleteQcUpdateQcItemRequest copyWith(
      {String? itemId,
      String? itemQcId,
      String? conditionId,
      String? currentFootCandles,
      String? currentSoftwareVersion,
      String? softwareEffectiveDate,
      String? note,
      int? assetHours,
      int? strikes,
      int? lampHours1,
      int? lampHours2,
      int? lampHours3,
      int? lampHours4}) {
    return WebApiModulesInventoryCompleteQcUpdateQcItemRequest(
        itemId: itemId ?? this.itemId,
        itemQcId: itemQcId ?? this.itemQcId,
        conditionId: conditionId ?? this.conditionId,
        currentFootCandles: currentFootCandles ?? this.currentFootCandles,
        currentSoftwareVersion:
            currentSoftwareVersion ?? this.currentSoftwareVersion,
        softwareEffectiveDate:
            softwareEffectiveDate ?? this.softwareEffectiveDate,
        note: note ?? this.note,
        assetHours: assetHours ?? this.assetHours,
        strikes: strikes ?? this.strikes,
        lampHours1: lampHours1 ?? this.lampHours1,
        lampHours2: lampHours2 ?? this.lampHours2,
        lampHours3: lampHours3 ?? this.lampHours3,
        lampHours4: lampHours4 ?? this.lampHours4);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryCompleteQcUpdateQcItemResponse {
  WebApiModulesInventoryCompleteQcUpdateQcItemResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesInventoryCompleteQcUpdateQcItemResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryCompleteQcUpdateQcItemResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesInventoryCompleteQcUpdateQcItemResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryCompleteQcUpdateQcItemResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryCompleteQcUpdateQcItemResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryCompleteQcUpdateQcItemResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesInventoryCompleteQcUpdateQcItemResponseExtension
    on WebApiModulesInventoryCompleteQcUpdateQcItemResponse {
  WebApiModulesInventoryCompleteQcUpdateQcItemResponse copyWith(
      {int? status, bool? success, String? msg}) {
    return WebApiModulesInventoryCompleteQcUpdateQcItemResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryInventoryCopyInventoryRequest {
  WebApiModulesInventoryInventoryCopyInventoryRequest({
    this.inventoryId,
    this.newICode,
    this.newDescription,
  });

  factory WebApiModulesInventoryInventoryCopyInventoryRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryInventoryCopyInventoryRequestFromJson(json);

  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'NewICode')
  final String? newICode;
  @JsonKey(name: 'NewDescription')
  final String? newDescription;
  static const fromJsonFactory =
      _$WebApiModulesInventoryInventoryCopyInventoryRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryInventoryCopyInventoryRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryInventoryCopyInventoryRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryInventoryCopyInventoryRequest &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.newICode, newICode) ||
                const DeepCollectionEquality()
                    .equals(other.newICode, newICode)) &&
            (identical(other.newDescription, newDescription) ||
                const DeepCollectionEquality()
                    .equals(other.newDescription, newDescription)));
  }
}

extension $WebApiModulesInventoryInventoryCopyInventoryRequestExtension
    on WebApiModulesInventoryInventoryCopyInventoryRequest {
  WebApiModulesInventoryInventoryCopyInventoryRequest copyWith(
      {String? inventoryId, String? newICode, String? newDescription}) {
    return WebApiModulesInventoryInventoryCopyInventoryRequest(
        inventoryId: inventoryId ?? this.inventoryId,
        newICode: newICode ?? this.newICode,
        newDescription: newDescription ?? this.newDescription);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageRequest {
  WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageRequest({
    this.inventoryId,
    this.warehouseId,
    this.isWarehouseSpecific,
  });

  factory WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageRequestFromJson(
          json);

  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'IsWarehouseSpecific')
  final bool? isWarehouseSpecific;
  static const fromJsonFactory =
      _$WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageRequest &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.isWarehouseSpecific, isWarehouseSpecific) ||
                const DeepCollectionEquality()
                    .equals(other.isWarehouseSpecific, isWarehouseSpecific)));
  }
}

extension $WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageRequestExtension
    on WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageRequest {
  WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageRequest
      copyWith(
          {String? inventoryId,
          String? warehouseId,
          bool? isWarehouseSpecific}) {
    return WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageRequest(
        inventoryId: inventoryId ?? this.inventoryId,
        warehouseId: warehouseId ?? this.warehouseId,
        isWarehouseSpecific: isWarehouseSpecific ?? this.isWarehouseSpecific);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageResponse {
  WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageResponseExtension
    on WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageResponse {
  WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageResponse
      copyWith({int? status, bool? success, String? msg}) {
    return WebApiModulesInventoryInventoryInventoryWarehouseSpecificPackageResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesRequest {
  WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesRequest({
    this.inventoryId,
    this.qcRequired,
  });

  factory WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesRequestFromJson(
          json);

  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'QcRequired')
  final bool? qcRequired;
  static const fromJsonFactory =
      _$WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesRequest &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.qcRequired, qcRequired) ||
                const DeepCollectionEquality()
                    .equals(other.qcRequired, qcRequired)));
  }
}

extension $WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesRequestExtension
    on WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesRequest {
  WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesRequest
      copyWith({String? inventoryId, bool? qcRequired}) {
    return WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesRequest(
        inventoryId: inventoryId ?? this.inventoryId,
        qcRequired: qcRequired ?? this.qcRequired);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesResponse {
  WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesResponseExtension
    on WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesResponse {
  WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesResponse
      copyWith({int? status, bool? success, String? msg}) {
    return WebApiModulesInventoryInventoryRentalInventoryQcRequiredAllWarehousesResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPartsInventoryPartsInventory {
  WebApiModulesInventoryPartsInventoryPartsInventory({
    this.price,
    this.defaultCost,
    this.averageCost,
    this.inventoryId,
    this.inventoryTypeId,
    this.inventoryType,
    this.availableFrom,
    this.trackedBy,
    this.confirmTrackedBy,
    this.rank,
    this.manufacturerPartNumber,
    this.manufacturerId,
    this.manufacturer,
    this.manufacturerUrl,
    this.excludeImageFromQuoteOrderPrint,
    this.noAvailabilityCheck,
    this.availabilityManuallyResolveConflicts,
    this.sendAvailabilityAlert,
    this.primaryDimensionUniqueId,
    this.defaultImperialMetric,
    this.primaryDimensionDescription,
    this.primaryDimensionShipWeightLbs,
    this.primaryDimensionShipWeightOz,
    this.primaryDimensionWeightInCaseLbs,
    this.primaryDimensionWeightInCaseOz,
    this.primaryDimensionWidthFt,
    this.primaryDimensionWidthIn,
    this.primaryDimensionHeightFt,
    this.primaryDimensionHeightIn,
    this.primaryDimensionLengthFt,
    this.primaryDimensionLengthIn,
    this.primaryDimensionShipWeightKg,
    this.primaryDimensionShipWeightG,
    this.primaryDimensionWeightInCaseKg,
    this.primaryDimensionWeightInCaseG,
    this.primaryDimensionWidthM,
    this.primaryDimensionWidthCm,
    this.primaryDimensionHeightM,
    this.primaryDimensionHeightCm,
    this.primaryDimensionLengthM,
    this.primaryDimensionLengthCm,
    this.hasSecondaryDimensions,
    this.secondaryDimensionUniqueId,
    this.secondaryDimensionDescription,
    this.secondaryDimensionShipWeightLbs,
    this.secondaryDimensionShipWeightOz,
    this.secondaryDimensionWeightInCaseLbs,
    this.secondaryDimensionWeightInCaseOz,
    this.secondaryDimensionWidthFt,
    this.secondaryDimensionWidthIn,
    this.secondaryDimensionHeightFt,
    this.secondaryDimensionHeightIn,
    this.secondaryDimensionLengthFt,
    this.secondaryDimensionLengthIn,
    this.secondaryDimensionShipWeightKg,
    this.secondaryDimensionShipWeightG,
    this.secondaryDimensionWeightInCaseKg,
    this.secondaryDimensionWeightInCaseG,
    this.secondaryDimensionWidthM,
    this.secondaryDimensionWidthCm,
    this.secondaryDimensionHeightM,
    this.secondaryDimensionHeightCm,
    this.secondaryDimensionLengthM,
    this.secondaryDimensionLengthCm,
    this.countryOfOriginId,
    this.countryOfOrigin,
    this.displayInSummaryModeWhenRateIsZero,
    this.qcRequired,
    this.qcTime,
    this.copyAttributesAsNote,
    this.trackAssetUsage,
    this.trackLampUsage,
    this.trackStrikes,
    this.trackCandles,
    this.lampCount,
    this.minimumFootCandles,
    this.trackSoftware,
    this.softwareVersion,
    this.softwareEffectiveDate,
    this.warehouseSpecificPackage,
    this.completePackagePrice,
    this.kitPackagePrice,
    this.separatePackageOnQuoteOrder,
    this.containerId,
    this.containerScannableInventoryId,
    this.containerScannableICode,
    this.containerScannableDescription,
    this.automaticallyRebuildContainerAtCheckIn,
    this.automaticallyRebuildContainerAtTransferIn,
    this.containerStagingRule,
    this.excludeContainedItemsFromAvailability,
    this.useContainerNumber,
    this.containerPackingListBehavior,
    this.inventoryTypeIsWardrobe,
    this.inventoryTypeIsSets,
    this.patternId,
    this.pattern,
    this.periodId,
    this.period,
    this.materialId,
    this.material,
    this.genderId,
    this.gender,
    this.labelId,
    this.label,
    this.wardrobeSize,
    this.wardrobePieceCount,
    this.dyed,
    this.wardrobeSourceId,
    this.wardrobeSource,
    this.wardrobeCareId,
    this.wardrobeCare,
    this.cleaningFeeAmount,
    this.wardrobeDetailedDescription,
    this.webDetailedDescription,
    this.overrideSystemDefaultRevenueAllocationBehavior,
    this.allocateRevenueForAccessories,
    this.packageRevenueCalculationFormula,
    this.isHazardousMaterial,
    this.descriptionWithAkas,
    this.costCalculation,
    this.quantity,
    this.aisleLocation,
    this.shelfLocation,
    this.taxable,
    this.iCode,
    this.description,
    this.availFor,
    this.categoryId,
    this.category,
    this.subCategoryCount,
    this.subCategoryId,
    this.subCategory,
    this.classification,
    this.classificationDescription,
    this.classificationColor,
    this.unitId,
    this.unit,
    this.unitType,
    this.nonDiscountable,
    this.overrideProfitAndLossCategory,
    this.profitAndLossCategoryId,
    this.profitAndLossCategory,
    this.autoCopyNotesToQuoteOrder,
    this.note,
    this.printNoteOnInContract,
    this.printNoteOnOutContract,
    this.printNoteOnReceiveContract,
    this.printNoteOnReturnContract,
    this.printNoteOnInvoice,
    this.printNoteOnOrder,
    this.printNoteOnPickList,
    this.printNoteOnPO,
    this.printNoteOnQuote,
    this.printNoteOnReturnList,
    this.printNoteOnPoReceiveList,
    this.printNoteOnPoReturnList,
    this.assetAccountId,
    this.assetAccountNo,
    this.assetAccountDescription,
    this.incomeAccountId,
    this.incomeAccountNo,
    this.incomeAccountDescription,
    this.subIncomeAccountId,
    this.subIncomeAccountNo,
    this.subIncomeAccountDescription,
    this.consignmentIncomeAccountId,
    this.consignmentIncomeAccountNo,
    this.consignmentIncomeAccountDescription,
    this.ldIncomeAccountId,
    this.ldIncomeAccountNo,
    this.ldIncomeAccountDescription,
    this.equipmentSaleIncomeAccountId,
    this.equipmentSaleIncomeAccountNo,
    this.equipmentSaleIncomeAccountDescription,
    this.expenseAccountId,
    this.expenseAccountNo,
    this.expenseAccountDescription,
    this.costOfGoodsSoldExpenseAccountId,
    this.costOfGoodsSoldExpenseAccountNo,
    this.costOfGoodsSoldExpenseAccountDescription,
    this.costOfGoodsRentedExpenseAccountId,
    this.costOfGoodsRentedExpenseAccountNo,
    this.costOfGoodsRentedExpenseAccountDescription,
    this.depreciationExpenseAccountId,
    this.depreciationExpenseAccountNo,
    this.depreciationExpenseAccountDescription,
    this.accumulatedDepreciationExpenseAccountId,
    this.accumulatedDepreciationExpenseAccountNo,
    this.accumulatedDepreciationExpenseAccountDescription,
    this.originalShowId,
    this.inactive,
    this.dateStamp,
    this.manifestShippingContainer,
    this.manifestStandAloneItem,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesInventoryPartsInventoryPartsInventory.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPartsInventoryPartsInventoryFromJson(json);

  @JsonKey(name: 'Price')
  final double? price;
  @JsonKey(name: 'DefaultCost')
  final double? defaultCost;
  @JsonKey(name: 'AverageCost')
  final double? averageCost;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'InventoryTypeId')
  final String? inventoryTypeId;
  @JsonKey(name: 'InventoryType')
  final String? inventoryType;
  @JsonKey(name: 'AvailableFrom')
  final String? availableFrom;
  @JsonKey(name: 'TrackedBy')
  final String? trackedBy;
  @JsonKey(name: 'ConfirmTrackedBy')
  final String? confirmTrackedBy;
  @JsonKey(name: 'Rank')
  final String? rank;
  @JsonKey(name: 'ManufacturerPartNumber')
  final String? manufacturerPartNumber;
  @JsonKey(name: 'ManufacturerId')
  final String? manufacturerId;
  @JsonKey(name: 'Manufacturer')
  final String? manufacturer;
  @JsonKey(name: 'ManufacturerUrl')
  final String? manufacturerUrl;
  @JsonKey(name: 'ExcludeImageFromQuoteOrderPrint')
  final bool? excludeImageFromQuoteOrderPrint;
  @JsonKey(name: 'NoAvailabilityCheck')
  final bool? noAvailabilityCheck;
  @JsonKey(name: 'AvailabilityManuallyResolveConflicts')
  final bool? availabilityManuallyResolveConflicts;
  @JsonKey(name: 'SendAvailabilityAlert')
  final bool? sendAvailabilityAlert;
  @JsonKey(name: 'PrimaryDimensionUniqueId')
  final String? primaryDimensionUniqueId;
  @JsonKey(name: 'DefaultImperialMetric')
  final String? defaultImperialMetric;
  @JsonKey(name: 'PrimaryDimensionDescription')
  final String? primaryDimensionDescription;
  @JsonKey(name: 'PrimaryDimensionShipWeightLbs')
  final int? primaryDimensionShipWeightLbs;
  @JsonKey(name: 'PrimaryDimensionShipWeightOz')
  final int? primaryDimensionShipWeightOz;
  @JsonKey(name: 'PrimaryDimensionWeightInCaseLbs')
  final int? primaryDimensionWeightInCaseLbs;
  @JsonKey(name: 'PrimaryDimensionWeightInCaseOz')
  final int? primaryDimensionWeightInCaseOz;
  @JsonKey(name: 'PrimaryDimensionWidthFt')
  final int? primaryDimensionWidthFt;
  @JsonKey(name: 'PrimaryDimensionWidthIn')
  final int? primaryDimensionWidthIn;
  @JsonKey(name: 'PrimaryDimensionHeightFt')
  final int? primaryDimensionHeightFt;
  @JsonKey(name: 'PrimaryDimensionHeightIn')
  final int? primaryDimensionHeightIn;
  @JsonKey(name: 'PrimaryDimensionLengthFt')
  final int? primaryDimensionLengthFt;
  @JsonKey(name: 'PrimaryDimensionLengthIn')
  final int? primaryDimensionLengthIn;
  @JsonKey(name: 'PrimaryDimensionShipWeightKg')
  final int? primaryDimensionShipWeightKg;
  @JsonKey(name: 'PrimaryDimensionShipWeightG')
  final int? primaryDimensionShipWeightG;
  @JsonKey(name: 'PrimaryDimensionWeightInCaseKg')
  final int? primaryDimensionWeightInCaseKg;
  @JsonKey(name: 'PrimaryDimensionWeightInCaseG')
  final int? primaryDimensionWeightInCaseG;
  @JsonKey(name: 'PrimaryDimensionWidthM')
  final int? primaryDimensionWidthM;
  @JsonKey(name: 'PrimaryDimensionWidthCm')
  final int? primaryDimensionWidthCm;
  @JsonKey(name: 'PrimaryDimensionHeightM')
  final int? primaryDimensionHeightM;
  @JsonKey(name: 'PrimaryDimensionHeightCm')
  final int? primaryDimensionHeightCm;
  @JsonKey(name: 'PrimaryDimensionLengthM')
  final int? primaryDimensionLengthM;
  @JsonKey(name: 'PrimaryDimensionLengthCm')
  final int? primaryDimensionLengthCm;
  @JsonKey(name: 'HasSecondaryDimensions')
  final bool? hasSecondaryDimensions;
  @JsonKey(name: 'SecondaryDimensionUniqueId')
  final String? secondaryDimensionUniqueId;
  @JsonKey(name: 'SecondaryDimensionDescription')
  final String? secondaryDimensionDescription;
  @JsonKey(name: 'SecondaryDimensionShipWeightLbs')
  final int? secondaryDimensionShipWeightLbs;
  @JsonKey(name: 'SecondaryDimensionShipWeightOz')
  final int? secondaryDimensionShipWeightOz;
  @JsonKey(name: 'SecondaryDimensionWeightInCaseLbs')
  final int? secondaryDimensionWeightInCaseLbs;
  @JsonKey(name: 'SecondaryDimensionWeightInCaseOz')
  final int? secondaryDimensionWeightInCaseOz;
  @JsonKey(name: 'SecondaryDimensionWidthFt')
  final int? secondaryDimensionWidthFt;
  @JsonKey(name: 'SecondaryDimensionWidthIn')
  final int? secondaryDimensionWidthIn;
  @JsonKey(name: 'SecondaryDimensionHeightFt')
  final int? secondaryDimensionHeightFt;
  @JsonKey(name: 'SecondaryDimensionHeightIn')
  final int? secondaryDimensionHeightIn;
  @JsonKey(name: 'SecondaryDimensionLengthFt')
  final int? secondaryDimensionLengthFt;
  @JsonKey(name: 'SecondaryDimensionLengthIn')
  final int? secondaryDimensionLengthIn;
  @JsonKey(name: 'SecondaryDimensionShipWeightKg')
  final int? secondaryDimensionShipWeightKg;
  @JsonKey(name: 'SecondaryDimensionShipWeightG')
  final int? secondaryDimensionShipWeightG;
  @JsonKey(name: 'SecondaryDimensionWeightInCaseKg')
  final int? secondaryDimensionWeightInCaseKg;
  @JsonKey(name: 'SecondaryDimensionWeightInCaseG')
  final int? secondaryDimensionWeightInCaseG;
  @JsonKey(name: 'SecondaryDimensionWidthM')
  final int? secondaryDimensionWidthM;
  @JsonKey(name: 'SecondaryDimensionWidthCm')
  final int? secondaryDimensionWidthCm;
  @JsonKey(name: 'SecondaryDimensionHeightM')
  final int? secondaryDimensionHeightM;
  @JsonKey(name: 'SecondaryDimensionHeightCm')
  final int? secondaryDimensionHeightCm;
  @JsonKey(name: 'SecondaryDimensionLengthM')
  final int? secondaryDimensionLengthM;
  @JsonKey(name: 'SecondaryDimensionLengthCm')
  final int? secondaryDimensionLengthCm;
  @JsonKey(name: 'CountryOfOriginId')
  final String? countryOfOriginId;
  @JsonKey(name: 'CountryOfOrigin')
  final String? countryOfOrigin;
  @JsonKey(name: 'DisplayInSummaryModeWhenRateIsZero')
  final bool? displayInSummaryModeWhenRateIsZero;
  @JsonKey(name: 'QcRequired')
  final bool? qcRequired;
  @JsonKey(name: 'QcTime')
  final String? qcTime;
  @JsonKey(name: 'CopyAttributesAsNote')
  final bool? copyAttributesAsNote;
  @JsonKey(name: 'TrackAssetUsage')
  final bool? trackAssetUsage;
  @JsonKey(name: 'TrackLampUsage')
  final bool? trackLampUsage;
  @JsonKey(name: 'TrackStrikes')
  final bool? trackStrikes;
  @JsonKey(name: 'TrackCandles')
  final bool? trackCandles;
  @JsonKey(name: 'LampCount')
  final int? lampCount;
  @JsonKey(name: 'MinimumFootCandles')
  final int? minimumFootCandles;
  @JsonKey(name: 'TrackSoftware')
  final bool? trackSoftware;
  @JsonKey(name: 'SoftwareVersion')
  final String? softwareVersion;
  @JsonKey(name: 'SoftwareEffectiveDate')
  final String? softwareEffectiveDate;
  @JsonKey(name: 'WarehouseSpecificPackage')
  final bool? warehouseSpecificPackage;
  @JsonKey(name: 'CompletePackagePrice')
  final String? completePackagePrice;
  @JsonKey(name: 'KitPackagePrice')
  final String? kitPackagePrice;
  @JsonKey(name: 'SeparatePackageOnQuoteOrder')
  final bool? separatePackageOnQuoteOrder;
  @JsonKey(name: 'ContainerId')
  final String? containerId;
  @JsonKey(name: 'ContainerScannableInventoryId')
  final String? containerScannableInventoryId;
  @JsonKey(name: 'ContainerScannableICode')
  final String? containerScannableICode;
  @JsonKey(name: 'ContainerScannableDescription')
  final String? containerScannableDescription;
  @JsonKey(name: 'AutomaticallyRebuildContainerAtCheckIn')
  final bool? automaticallyRebuildContainerAtCheckIn;
  @JsonKey(name: 'AutomaticallyRebuildContainerAtTransferIn')
  final bool? automaticallyRebuildContainerAtTransferIn;
  @JsonKey(name: 'ContainerStagingRule')
  final String? containerStagingRule;
  @JsonKey(name: 'ExcludeContainedItemsFromAvailability')
  final bool? excludeContainedItemsFromAvailability;
  @JsonKey(name: 'UseContainerNumber')
  final bool? useContainerNumber;
  @JsonKey(name: 'ContainerPackingListBehavior')
  final String? containerPackingListBehavior;
  @JsonKey(name: 'InventoryTypeIsWardrobe')
  final bool? inventoryTypeIsWardrobe;
  @JsonKey(name: 'InventoryTypeIsSets')
  final bool? inventoryTypeIsSets;
  @JsonKey(name: 'PatternId')
  final String? patternId;
  @JsonKey(name: 'Pattern')
  final String? pattern;
  @JsonKey(name: 'PeriodId')
  final String? periodId;
  @JsonKey(name: 'Period')
  final String? period;
  @JsonKey(name: 'MaterialId')
  final String? materialId;
  @JsonKey(name: 'Material')
  final String? material;
  @JsonKey(name: 'GenderId')
  final String? genderId;
  @JsonKey(name: 'Gender')
  final String? gender;
  @JsonKey(name: 'LabelId')
  final String? labelId;
  @JsonKey(name: 'Label')
  final String? label;
  @JsonKey(name: 'WardrobeSize')
  final String? wardrobeSize;
  @JsonKey(name: 'WardrobePieceCount')
  final int? wardrobePieceCount;
  @JsonKey(name: 'Dyed')
  final bool? dyed;
  @JsonKey(name: 'WardrobeSourceId')
  final String? wardrobeSourceId;
  @JsonKey(name: 'WardrobeSource')
  final String? wardrobeSource;
  @JsonKey(name: 'WardrobeCareId')
  final String? wardrobeCareId;
  @JsonKey(name: 'WardrobeCare')
  final String? wardrobeCare;
  @JsonKey(name: 'CleaningFeeAmount')
  final double? cleaningFeeAmount;
  @JsonKey(name: 'WardrobeDetailedDescription')
  final String? wardrobeDetailedDescription;
  @JsonKey(name: 'WebDetailedDescription')
  final String? webDetailedDescription;
  @JsonKey(name: 'OverrideSystemDefaultRevenueAllocationBehavior')
  final bool? overrideSystemDefaultRevenueAllocationBehavior;
  @JsonKey(name: 'AllocateRevenueForAccessories')
  final bool? allocateRevenueForAccessories;
  @JsonKey(name: 'PackageRevenueCalculationFormula')
  final String? packageRevenueCalculationFormula;
  @JsonKey(name: 'IsHazardousMaterial')
  final bool? isHazardousMaterial;
  @JsonKey(name: 'DescriptionWithAkas')
  final String? descriptionWithAkas;
  @JsonKey(name: 'CostCalculation')
  final String? costCalculation;
  @JsonKey(name: 'Quantity')
  final double? quantity;
  @JsonKey(name: 'AisleLocation')
  final String? aisleLocation;
  @JsonKey(name: 'ShelfLocation')
  final String? shelfLocation;
  @JsonKey(name: 'Taxable')
  final bool? taxable;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AvailFor')
  final String? availFor;
  @JsonKey(name: 'CategoryId')
  final String? categoryId;
  @JsonKey(name: 'Category')
  final String? category;
  @JsonKey(name: 'SubCategoryCount')
  final int? subCategoryCount;
  @JsonKey(name: 'SubCategoryId')
  final String? subCategoryId;
  @JsonKey(name: 'SubCategory')
  final String? subCategory;
  @JsonKey(name: 'Classification')
  final String? classification;
  @JsonKey(name: 'ClassificationDescription')
  final String? classificationDescription;
  @JsonKey(name: 'ClassificationColor')
  final String? classificationColor;
  @JsonKey(name: 'UnitId')
  final String? unitId;
  @JsonKey(name: 'Unit')
  final String? unit;
  @JsonKey(name: 'UnitType')
  final String? unitType;
  @JsonKey(name: 'NonDiscountable')
  final bool? nonDiscountable;
  @JsonKey(name: 'OverrideProfitAndLossCategory')
  final bool? overrideProfitAndLossCategory;
  @JsonKey(name: 'ProfitAndLossCategoryId')
  final String? profitAndLossCategoryId;
  @JsonKey(name: 'ProfitAndLossCategory')
  final String? profitAndLossCategory;
  @JsonKey(name: 'AutoCopyNotesToQuoteOrder')
  final bool? autoCopyNotesToQuoteOrder;
  @JsonKey(name: 'Note')
  final String? note;
  @JsonKey(name: 'PrintNoteOnInContract')
  final bool? printNoteOnInContract;
  @JsonKey(name: 'PrintNoteOnOutContract')
  final bool? printNoteOnOutContract;
  @JsonKey(name: 'PrintNoteOnReceiveContract')
  final bool? printNoteOnReceiveContract;
  @JsonKey(name: 'PrintNoteOnReturnContract')
  final bool? printNoteOnReturnContract;
  @JsonKey(name: 'PrintNoteOnInvoice')
  final bool? printNoteOnInvoice;
  @JsonKey(name: 'PrintNoteOnOrder')
  final bool? printNoteOnOrder;
  @JsonKey(name: 'PrintNoteOnPickList')
  final bool? printNoteOnPickList;
  @JsonKey(name: 'PrintNoteOnPO')
  final bool? printNoteOnPO;
  @JsonKey(name: 'PrintNoteOnQuote')
  final bool? printNoteOnQuote;
  @JsonKey(name: 'PrintNoteOnReturnList')
  final bool? printNoteOnReturnList;
  @JsonKey(name: 'PrintNoteOnPoReceiveList')
  final bool? printNoteOnPoReceiveList;
  @JsonKey(name: 'PrintNoteOnPoReturnList')
  final bool? printNoteOnPoReturnList;
  @JsonKey(name: 'AssetAccountId')
  final String? assetAccountId;
  @JsonKey(name: 'AssetAccountNo')
  final String? assetAccountNo;
  @JsonKey(name: 'AssetAccountDescription')
  final String? assetAccountDescription;
  @JsonKey(name: 'IncomeAccountId')
  final String? incomeAccountId;
  @JsonKey(name: 'IncomeAccountNo')
  final String? incomeAccountNo;
  @JsonKey(name: 'IncomeAccountDescription')
  final String? incomeAccountDescription;
  @JsonKey(name: 'SubIncomeAccountId')
  final String? subIncomeAccountId;
  @JsonKey(name: 'SubIncomeAccountNo')
  final String? subIncomeAccountNo;
  @JsonKey(name: 'SubIncomeAccountDescription')
  final String? subIncomeAccountDescription;
  @JsonKey(name: 'ConsignmentIncomeAccountId')
  final String? consignmentIncomeAccountId;
  @JsonKey(name: 'ConsignmentIncomeAccountNo')
  final String? consignmentIncomeAccountNo;
  @JsonKey(name: 'ConsignmentIncomeAccountDescription')
  final String? consignmentIncomeAccountDescription;
  @JsonKey(name: 'LdIncomeAccountId')
  final String? ldIncomeAccountId;
  @JsonKey(name: 'LdIncomeAccountNo')
  final String? ldIncomeAccountNo;
  @JsonKey(name: 'LdIncomeAccountDescription')
  final String? ldIncomeAccountDescription;
  @JsonKey(name: 'EquipmentSaleIncomeAccountId')
  final String? equipmentSaleIncomeAccountId;
  @JsonKey(name: 'EquipmentSaleIncomeAccountNo')
  final String? equipmentSaleIncomeAccountNo;
  @JsonKey(name: 'EquipmentSaleIncomeAccountDescription')
  final String? equipmentSaleIncomeAccountDescription;
  @JsonKey(name: 'ExpenseAccountId')
  final String? expenseAccountId;
  @JsonKey(name: 'ExpenseAccountNo')
  final String? expenseAccountNo;
  @JsonKey(name: 'ExpenseAccountDescription')
  final String? expenseAccountDescription;
  @JsonKey(name: 'CostOfGoodsSoldExpenseAccountId')
  final String? costOfGoodsSoldExpenseAccountId;
  @JsonKey(name: 'CostOfGoodsSoldExpenseAccountNo')
  final String? costOfGoodsSoldExpenseAccountNo;
  @JsonKey(name: 'CostOfGoodsSoldExpenseAccountDescription')
  final String? costOfGoodsSoldExpenseAccountDescription;
  @JsonKey(name: 'CostOfGoodsRentedExpenseAccountId')
  final String? costOfGoodsRentedExpenseAccountId;
  @JsonKey(name: 'CostOfGoodsRentedExpenseAccountNo')
  final String? costOfGoodsRentedExpenseAccountNo;
  @JsonKey(name: 'CostOfGoodsRentedExpenseAccountDescription')
  final String? costOfGoodsRentedExpenseAccountDescription;
  @JsonKey(name: 'DepreciationExpenseAccountId')
  final String? depreciationExpenseAccountId;
  @JsonKey(name: 'DepreciationExpenseAccountNo')
  final String? depreciationExpenseAccountNo;
  @JsonKey(name: 'DepreciationExpenseAccountDescription')
  final String? depreciationExpenseAccountDescription;
  @JsonKey(name: 'AccumulatedDepreciationExpenseAccountId')
  final String? accumulatedDepreciationExpenseAccountId;
  @JsonKey(name: 'AccumulatedDepreciationExpenseAccountNo')
  final String? accumulatedDepreciationExpenseAccountNo;
  @JsonKey(name: 'AccumulatedDepreciationExpenseAccountDescription')
  final String? accumulatedDepreciationExpenseAccountDescription;
  @JsonKey(name: 'OriginalShowId')
  final String? originalShowId;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'ManifestShippingContainer')
  final bool? manifestShippingContainer;
  @JsonKey(name: 'ManifestStandAloneItem')
  final bool? manifestStandAloneItem;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPartsInventoryPartsInventoryFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPartsInventoryPartsInventoryToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPartsInventoryPartsInventoryToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPartsInventoryPartsInventory &&
            (identical(other.price, price) ||
                const DeepCollectionEquality().equals(other.price, price)) &&
            (identical(other.defaultCost, defaultCost) ||
                const DeepCollectionEquality()
                    .equals(other.defaultCost, defaultCost)) &&
            (identical(other.averageCost, averageCost) ||
                const DeepCollectionEquality()
                    .equals(other.averageCost, averageCost)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.inventoryTypeId, inventoryTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryTypeId, inventoryTypeId)) &&
            (identical(other.inventoryType, inventoryType) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryType, inventoryType)) &&
            (identical(other.availableFrom, availableFrom) ||
                const DeepCollectionEquality()
                    .equals(other.availableFrom, availableFrom)) &&
            (identical(other.trackedBy, trackedBy) ||
                const DeepCollectionEquality()
                    .equals(other.trackedBy, trackedBy)) &&
            (identical(other.confirmTrackedBy, confirmTrackedBy) ||
                const DeepCollectionEquality()
                    .equals(other.confirmTrackedBy, confirmTrackedBy)) &&
            (identical(other.rank, rank) ||
                const DeepCollectionEquality().equals(other.rank, rank)) &&
            (identical(other.manufacturerPartNumber, manufacturerPartNumber) ||
                const DeepCollectionEquality().equals(
                    other.manufacturerPartNumber, manufacturerPartNumber)) &&
            (identical(other.manufacturerId, manufacturerId) ||
                const DeepCollectionEquality()
                    .equals(other.manufacturerId, manufacturerId)) &&
            (identical(other.manufacturer, manufacturer) ||
                const DeepCollectionEquality()
                    .equals(other.manufacturer, manufacturer)) &&
            (identical(other.manufacturerUrl, manufacturerUrl) ||
                const DeepCollectionEquality()
                    .equals(other.manufacturerUrl, manufacturerUrl)) &&
            (identical(other.excludeImageFromQuoteOrderPrint, excludeImageFromQuoteOrderPrint) ||
                const DeepCollectionEquality().equals(
                    other.excludeImageFromQuoteOrderPrint,
                    excludeImageFromQuoteOrderPrint)) &&
            (identical(other.noAvailabilityCheck, noAvailabilityCheck) ||
                const DeepCollectionEquality()
                    .equals(other.noAvailabilityCheck, noAvailabilityCheck)) &&
            (identical(other.availabilityManuallyResolveConflicts, availabilityManuallyResolveConflicts) ||
                const DeepCollectionEquality().equals(
                    other.availabilityManuallyResolveConflicts,
                    availabilityManuallyResolveConflicts)) &&
            (identical(other.sendAvailabilityAlert, sendAvailabilityAlert) ||
                const DeepCollectionEquality().equals(
                    other.sendAvailabilityAlert, sendAvailabilityAlert)) &&
            (identical(
                    other.primaryDimensionUniqueId, primaryDimensionUniqueId) ||
                const DeepCollectionEquality().equals(
                    other.primaryDimensionUniqueId, primaryDimensionUniqueId)) &&
            (identical(other.defaultImperialMetric, defaultImperialMetric) || const DeepCollectionEquality().equals(other.defaultImperialMetric, defaultImperialMetric)) &&
            (identical(other.primaryDimensionDescription, primaryDimensionDescription) || const DeepCollectionEquality().equals(other.primaryDimensionDescription, primaryDimensionDescription)) &&
            (identical(other.primaryDimensionShipWeightLbs, primaryDimensionShipWeightLbs) || const DeepCollectionEquality().equals(other.primaryDimensionShipWeightLbs, primaryDimensionShipWeightLbs)) &&
            (identical(other.primaryDimensionShipWeightOz, primaryDimensionShipWeightOz) || const DeepCollectionEquality().equals(other.primaryDimensionShipWeightOz, primaryDimensionShipWeightOz)) &&
            (identical(other.primaryDimensionWeightInCaseLbs, primaryDimensionWeightInCaseLbs) || const DeepCollectionEquality().equals(other.primaryDimensionWeightInCaseLbs, primaryDimensionWeightInCaseLbs)) &&
            (identical(other.primaryDimensionWeightInCaseOz, primaryDimensionWeightInCaseOz) || const DeepCollectionEquality().equals(other.primaryDimensionWeightInCaseOz, primaryDimensionWeightInCaseOz)) &&
            (identical(other.primaryDimensionWidthFt, primaryDimensionWidthFt) || const DeepCollectionEquality().equals(other.primaryDimensionWidthFt, primaryDimensionWidthFt)) &&
            (identical(other.primaryDimensionWidthIn, primaryDimensionWidthIn) || const DeepCollectionEquality().equals(other.primaryDimensionWidthIn, primaryDimensionWidthIn)) &&
            (identical(other.primaryDimensionHeightFt, primaryDimensionHeightFt) || const DeepCollectionEquality().equals(other.primaryDimensionHeightFt, primaryDimensionHeightFt)) &&
            (identical(other.primaryDimensionHeightIn, primaryDimensionHeightIn) || const DeepCollectionEquality().equals(other.primaryDimensionHeightIn, primaryDimensionHeightIn)) &&
            (identical(other.primaryDimensionLengthFt, primaryDimensionLengthFt) || const DeepCollectionEquality().equals(other.primaryDimensionLengthFt, primaryDimensionLengthFt)) &&
            (identical(other.primaryDimensionLengthIn, primaryDimensionLengthIn) || const DeepCollectionEquality().equals(other.primaryDimensionLengthIn, primaryDimensionLengthIn)) &&
            (identical(other.primaryDimensionShipWeightKg, primaryDimensionShipWeightKg) || const DeepCollectionEquality().equals(other.primaryDimensionShipWeightKg, primaryDimensionShipWeightKg)) &&
            (identical(other.primaryDimensionShipWeightG, primaryDimensionShipWeightG) || const DeepCollectionEquality().equals(other.primaryDimensionShipWeightG, primaryDimensionShipWeightG)) &&
            (identical(other.primaryDimensionWeightInCaseKg, primaryDimensionWeightInCaseKg) || const DeepCollectionEquality().equals(other.primaryDimensionWeightInCaseKg, primaryDimensionWeightInCaseKg)) &&
            (identical(other.primaryDimensionWeightInCaseG, primaryDimensionWeightInCaseG) || const DeepCollectionEquality().equals(other.primaryDimensionWeightInCaseG, primaryDimensionWeightInCaseG)) &&
            (identical(other.primaryDimensionWidthM, primaryDimensionWidthM) || const DeepCollectionEquality().equals(other.primaryDimensionWidthM, primaryDimensionWidthM)) &&
            (identical(other.primaryDimensionWidthCm, primaryDimensionWidthCm) || const DeepCollectionEquality().equals(other.primaryDimensionWidthCm, primaryDimensionWidthCm)) &&
            (identical(other.primaryDimensionHeightM, primaryDimensionHeightM) || const DeepCollectionEquality().equals(other.primaryDimensionHeightM, primaryDimensionHeightM)) &&
            (identical(other.primaryDimensionHeightCm, primaryDimensionHeightCm) || const DeepCollectionEquality().equals(other.primaryDimensionHeightCm, primaryDimensionHeightCm)) &&
            (identical(other.primaryDimensionLengthM, primaryDimensionLengthM) || const DeepCollectionEquality().equals(other.primaryDimensionLengthM, primaryDimensionLengthM)) &&
            (identical(other.primaryDimensionLengthCm, primaryDimensionLengthCm) || const DeepCollectionEquality().equals(other.primaryDimensionLengthCm, primaryDimensionLengthCm)) &&
            (identical(other.hasSecondaryDimensions, hasSecondaryDimensions) || const DeepCollectionEquality().equals(other.hasSecondaryDimensions, hasSecondaryDimensions)) &&
            (identical(other.secondaryDimensionUniqueId, secondaryDimensionUniqueId) || const DeepCollectionEquality().equals(other.secondaryDimensionUniqueId, secondaryDimensionUniqueId)) &&
            (identical(other.secondaryDimensionDescription, secondaryDimensionDescription) || const DeepCollectionEquality().equals(other.secondaryDimensionDescription, secondaryDimensionDescription)) &&
            (identical(other.secondaryDimensionShipWeightLbs, secondaryDimensionShipWeightLbs) || const DeepCollectionEquality().equals(other.secondaryDimensionShipWeightLbs, secondaryDimensionShipWeightLbs)) &&
            (identical(other.secondaryDimensionShipWeightOz, secondaryDimensionShipWeightOz) || const DeepCollectionEquality().equals(other.secondaryDimensionShipWeightOz, secondaryDimensionShipWeightOz)) &&
            (identical(other.secondaryDimensionWeightInCaseLbs, secondaryDimensionWeightInCaseLbs) || const DeepCollectionEquality().equals(other.secondaryDimensionWeightInCaseLbs, secondaryDimensionWeightInCaseLbs)) &&
            (identical(other.secondaryDimensionWeightInCaseOz, secondaryDimensionWeightInCaseOz) || const DeepCollectionEquality().equals(other.secondaryDimensionWeightInCaseOz, secondaryDimensionWeightInCaseOz)) &&
            (identical(other.secondaryDimensionWidthFt, secondaryDimensionWidthFt) || const DeepCollectionEquality().equals(other.secondaryDimensionWidthFt, secondaryDimensionWidthFt)) &&
            (identical(other.secondaryDimensionWidthIn, secondaryDimensionWidthIn) || const DeepCollectionEquality().equals(other.secondaryDimensionWidthIn, secondaryDimensionWidthIn)) &&
            (identical(other.secondaryDimensionHeightFt, secondaryDimensionHeightFt) || const DeepCollectionEquality().equals(other.secondaryDimensionHeightFt, secondaryDimensionHeightFt)) &&
            (identical(other.secondaryDimensionHeightIn, secondaryDimensionHeightIn) || const DeepCollectionEquality().equals(other.secondaryDimensionHeightIn, secondaryDimensionHeightIn)) &&
            (identical(other.secondaryDimensionLengthFt, secondaryDimensionLengthFt) || const DeepCollectionEquality().equals(other.secondaryDimensionLengthFt, secondaryDimensionLengthFt)) &&
            (identical(other.secondaryDimensionLengthIn, secondaryDimensionLengthIn) || const DeepCollectionEquality().equals(other.secondaryDimensionLengthIn, secondaryDimensionLengthIn)) &&
            (identical(other.secondaryDimensionShipWeightKg, secondaryDimensionShipWeightKg) || const DeepCollectionEquality().equals(other.secondaryDimensionShipWeightKg, secondaryDimensionShipWeightKg)) &&
            (identical(other.secondaryDimensionShipWeightG, secondaryDimensionShipWeightG) || const DeepCollectionEquality().equals(other.secondaryDimensionShipWeightG, secondaryDimensionShipWeightG)) &&
            (identical(other.secondaryDimensionWeightInCaseKg, secondaryDimensionWeightInCaseKg) || const DeepCollectionEquality().equals(other.secondaryDimensionWeightInCaseKg, secondaryDimensionWeightInCaseKg)) &&
            (identical(other.secondaryDimensionWeightInCaseG, secondaryDimensionWeightInCaseG) || const DeepCollectionEquality().equals(other.secondaryDimensionWeightInCaseG, secondaryDimensionWeightInCaseG)) &&
            (identical(other.secondaryDimensionWidthM, secondaryDimensionWidthM) || const DeepCollectionEquality().equals(other.secondaryDimensionWidthM, secondaryDimensionWidthM)) &&
            (identical(other.secondaryDimensionWidthCm, secondaryDimensionWidthCm) || const DeepCollectionEquality().equals(other.secondaryDimensionWidthCm, secondaryDimensionWidthCm)) &&
            (identical(other.secondaryDimensionHeightM, secondaryDimensionHeightM) || const DeepCollectionEquality().equals(other.secondaryDimensionHeightM, secondaryDimensionHeightM)) &&
            (identical(other.secondaryDimensionHeightCm, secondaryDimensionHeightCm) || const DeepCollectionEquality().equals(other.secondaryDimensionHeightCm, secondaryDimensionHeightCm)) &&
            (identical(other.secondaryDimensionLengthM, secondaryDimensionLengthM) || const DeepCollectionEquality().equals(other.secondaryDimensionLengthM, secondaryDimensionLengthM)) &&
            (identical(other.secondaryDimensionLengthCm, secondaryDimensionLengthCm) || const DeepCollectionEquality().equals(other.secondaryDimensionLengthCm, secondaryDimensionLengthCm)) &&
            (identical(other.countryOfOriginId, countryOfOriginId) || const DeepCollectionEquality().equals(other.countryOfOriginId, countryOfOriginId)) &&
            (identical(other.countryOfOrigin, countryOfOrigin) || const DeepCollectionEquality().equals(other.countryOfOrigin, countryOfOrigin)) &&
            (identical(other.displayInSummaryModeWhenRateIsZero, displayInSummaryModeWhenRateIsZero) || const DeepCollectionEquality().equals(other.displayInSummaryModeWhenRateIsZero, displayInSummaryModeWhenRateIsZero)) &&
            (identical(other.qcRequired, qcRequired) || const DeepCollectionEquality().equals(other.qcRequired, qcRequired)) &&
            (identical(other.qcTime, qcTime) || const DeepCollectionEquality().equals(other.qcTime, qcTime)) &&
            (identical(other.copyAttributesAsNote, copyAttributesAsNote) || const DeepCollectionEquality().equals(other.copyAttributesAsNote, copyAttributesAsNote)) &&
            (identical(other.trackAssetUsage, trackAssetUsage) || const DeepCollectionEquality().equals(other.trackAssetUsage, trackAssetUsage)) &&
            (identical(other.trackLampUsage, trackLampUsage) || const DeepCollectionEquality().equals(other.trackLampUsage, trackLampUsage)) &&
            (identical(other.trackStrikes, trackStrikes) || const DeepCollectionEquality().equals(other.trackStrikes, trackStrikes)) &&
            (identical(other.trackCandles, trackCandles) || const DeepCollectionEquality().equals(other.trackCandles, trackCandles)) &&
            (identical(other.lampCount, lampCount) || const DeepCollectionEquality().equals(other.lampCount, lampCount)) &&
            (identical(other.minimumFootCandles, minimumFootCandles) || const DeepCollectionEquality().equals(other.minimumFootCandles, minimumFootCandles)) &&
            (identical(other.trackSoftware, trackSoftware) || const DeepCollectionEquality().equals(other.trackSoftware, trackSoftware)) &&
            (identical(other.softwareVersion, softwareVersion) || const DeepCollectionEquality().equals(other.softwareVersion, softwareVersion)) &&
            (identical(other.softwareEffectiveDate, softwareEffectiveDate) || const DeepCollectionEquality().equals(other.softwareEffectiveDate, softwareEffectiveDate)) &&
            (identical(other.warehouseSpecificPackage, warehouseSpecificPackage) || const DeepCollectionEquality().equals(other.warehouseSpecificPackage, warehouseSpecificPackage)) &&
            (identical(other.completePackagePrice, completePackagePrice) || const DeepCollectionEquality().equals(other.completePackagePrice, completePackagePrice)) &&
            (identical(other.kitPackagePrice, kitPackagePrice) || const DeepCollectionEquality().equals(other.kitPackagePrice, kitPackagePrice)) &&
            (identical(other.separatePackageOnQuoteOrder, separatePackageOnQuoteOrder) || const DeepCollectionEquality().equals(other.separatePackageOnQuoteOrder, separatePackageOnQuoteOrder)) &&
            (identical(other.containerId, containerId) || const DeepCollectionEquality().equals(other.containerId, containerId)) &&
            (identical(other.containerScannableInventoryId, containerScannableInventoryId) || const DeepCollectionEquality().equals(other.containerScannableInventoryId, containerScannableInventoryId)) &&
            (identical(other.containerScannableICode, containerScannableICode) || const DeepCollectionEquality().equals(other.containerScannableICode, containerScannableICode)) &&
            (identical(other.containerScannableDescription, containerScannableDescription) || const DeepCollectionEquality().equals(other.containerScannableDescription, containerScannableDescription)) &&
            (identical(other.automaticallyRebuildContainerAtCheckIn, automaticallyRebuildContainerAtCheckIn) || const DeepCollectionEquality().equals(other.automaticallyRebuildContainerAtCheckIn, automaticallyRebuildContainerAtCheckIn)) &&
            (identical(other.automaticallyRebuildContainerAtTransferIn, automaticallyRebuildContainerAtTransferIn) || const DeepCollectionEquality().equals(other.automaticallyRebuildContainerAtTransferIn, automaticallyRebuildContainerAtTransferIn)) &&
            (identical(other.containerStagingRule, containerStagingRule) || const DeepCollectionEquality().equals(other.containerStagingRule, containerStagingRule)) &&
            (identical(other.excludeContainedItemsFromAvailability, excludeContainedItemsFromAvailability) || const DeepCollectionEquality().equals(other.excludeContainedItemsFromAvailability, excludeContainedItemsFromAvailability)) &&
            (identical(other.useContainerNumber, useContainerNumber) || const DeepCollectionEquality().equals(other.useContainerNumber, useContainerNumber)) &&
            (identical(other.containerPackingListBehavior, containerPackingListBehavior) || const DeepCollectionEquality().equals(other.containerPackingListBehavior, containerPackingListBehavior)) &&
            (identical(other.inventoryTypeIsWardrobe, inventoryTypeIsWardrobe) || const DeepCollectionEquality().equals(other.inventoryTypeIsWardrobe, inventoryTypeIsWardrobe)) &&
            (identical(other.inventoryTypeIsSets, inventoryTypeIsSets) || const DeepCollectionEquality().equals(other.inventoryTypeIsSets, inventoryTypeIsSets)) &&
            (identical(other.patternId, patternId) || const DeepCollectionEquality().equals(other.patternId, patternId)) &&
            (identical(other.pattern, pattern) || const DeepCollectionEquality().equals(other.pattern, pattern)) &&
            (identical(other.periodId, periodId) || const DeepCollectionEquality().equals(other.periodId, periodId)) &&
            (identical(other.period, period) || const DeepCollectionEquality().equals(other.period, period)) &&
            (identical(other.materialId, materialId) || const DeepCollectionEquality().equals(other.materialId, materialId)) &&
            (identical(other.material, material) || const DeepCollectionEquality().equals(other.material, material)) &&
            (identical(other.genderId, genderId) || const DeepCollectionEquality().equals(other.genderId, genderId)) &&
            (identical(other.gender, gender) || const DeepCollectionEquality().equals(other.gender, gender)) &&
            (identical(other.labelId, labelId) || const DeepCollectionEquality().equals(other.labelId, labelId)) &&
            (identical(other.label, label) || const DeepCollectionEquality().equals(other.label, label)) &&
            (identical(other.wardrobeSize, wardrobeSize) || const DeepCollectionEquality().equals(other.wardrobeSize, wardrobeSize)) &&
            (identical(other.wardrobePieceCount, wardrobePieceCount) || const DeepCollectionEquality().equals(other.wardrobePieceCount, wardrobePieceCount)) &&
            (identical(other.dyed, dyed) || const DeepCollectionEquality().equals(other.dyed, dyed)) &&
            (identical(other.wardrobeSourceId, wardrobeSourceId) || const DeepCollectionEquality().equals(other.wardrobeSourceId, wardrobeSourceId)) &&
            (identical(other.wardrobeSource, wardrobeSource) || const DeepCollectionEquality().equals(other.wardrobeSource, wardrobeSource)) &&
            (identical(other.wardrobeCareId, wardrobeCareId) || const DeepCollectionEquality().equals(other.wardrobeCareId, wardrobeCareId)) &&
            (identical(other.wardrobeCare, wardrobeCare) || const DeepCollectionEquality().equals(other.wardrobeCare, wardrobeCare)) &&
            (identical(other.cleaningFeeAmount, cleaningFeeAmount) || const DeepCollectionEquality().equals(other.cleaningFeeAmount, cleaningFeeAmount)) &&
            (identical(other.wardrobeDetailedDescription, wardrobeDetailedDescription) || const DeepCollectionEquality().equals(other.wardrobeDetailedDescription, wardrobeDetailedDescription)) &&
            (identical(other.webDetailedDescription, webDetailedDescription) || const DeepCollectionEquality().equals(other.webDetailedDescription, webDetailedDescription)) &&
            (identical(other.overrideSystemDefaultRevenueAllocationBehavior, overrideSystemDefaultRevenueAllocationBehavior) || const DeepCollectionEquality().equals(other.overrideSystemDefaultRevenueAllocationBehavior, overrideSystemDefaultRevenueAllocationBehavior)) &&
            (identical(other.allocateRevenueForAccessories, allocateRevenueForAccessories) || const DeepCollectionEquality().equals(other.allocateRevenueForAccessories, allocateRevenueForAccessories)) &&
            (identical(other.packageRevenueCalculationFormula, packageRevenueCalculationFormula) || const DeepCollectionEquality().equals(other.packageRevenueCalculationFormula, packageRevenueCalculationFormula)) &&
            (identical(other.isHazardousMaterial, isHazardousMaterial) || const DeepCollectionEquality().equals(other.isHazardousMaterial, isHazardousMaterial)) &&
            (identical(other.descriptionWithAkas, descriptionWithAkas) || const DeepCollectionEquality().equals(other.descriptionWithAkas, descriptionWithAkas)) &&
            (identical(other.costCalculation, costCalculation) || const DeepCollectionEquality().equals(other.costCalculation, costCalculation)) &&
            (identical(other.quantity, quantity) || const DeepCollectionEquality().equals(other.quantity, quantity)) &&
            (identical(other.aisleLocation, aisleLocation) || const DeepCollectionEquality().equals(other.aisleLocation, aisleLocation)) &&
            (identical(other.shelfLocation, shelfLocation) || const DeepCollectionEquality().equals(other.shelfLocation, shelfLocation)) &&
            (identical(other.taxable, taxable) || const DeepCollectionEquality().equals(other.taxable, taxable)) &&
            (identical(other.iCode, iCode) || const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) || const DeepCollectionEquality().equals(other.description, description)) &&
            (identical(other.availFor, availFor) || const DeepCollectionEquality().equals(other.availFor, availFor)) &&
            (identical(other.categoryId, categoryId) || const DeepCollectionEquality().equals(other.categoryId, categoryId)) &&
            (identical(other.category, category) || const DeepCollectionEquality().equals(other.category, category)) &&
            (identical(other.subCategoryCount, subCategoryCount) || const DeepCollectionEquality().equals(other.subCategoryCount, subCategoryCount)) &&
            (identical(other.subCategoryId, subCategoryId) || const DeepCollectionEquality().equals(other.subCategoryId, subCategoryId)) &&
            (identical(other.subCategory, subCategory) || const DeepCollectionEquality().equals(other.subCategory, subCategory)) &&
            (identical(other.classification, classification) || const DeepCollectionEquality().equals(other.classification, classification)) &&
            (identical(other.classificationDescription, classificationDescription) || const DeepCollectionEquality().equals(other.classificationDescription, classificationDescription)) &&
            (identical(other.classificationColor, classificationColor) || const DeepCollectionEquality().equals(other.classificationColor, classificationColor)) &&
            (identical(other.unitId, unitId) || const DeepCollectionEquality().equals(other.unitId, unitId)) &&
            (identical(other.unit, unit) || const DeepCollectionEquality().equals(other.unit, unit)) &&
            (identical(other.unitType, unitType) || const DeepCollectionEquality().equals(other.unitType, unitType)) &&
            (identical(other.nonDiscountable, nonDiscountable) || const DeepCollectionEquality().equals(other.nonDiscountable, nonDiscountable)) &&
            (identical(other.overrideProfitAndLossCategory, overrideProfitAndLossCategory) || const DeepCollectionEquality().equals(other.overrideProfitAndLossCategory, overrideProfitAndLossCategory)) &&
            (identical(other.profitAndLossCategoryId, profitAndLossCategoryId) || const DeepCollectionEquality().equals(other.profitAndLossCategoryId, profitAndLossCategoryId)) &&
            (identical(other.profitAndLossCategory, profitAndLossCategory) || const DeepCollectionEquality().equals(other.profitAndLossCategory, profitAndLossCategory)) &&
            (identical(other.autoCopyNotesToQuoteOrder, autoCopyNotesToQuoteOrder) || const DeepCollectionEquality().equals(other.autoCopyNotesToQuoteOrder, autoCopyNotesToQuoteOrder)) &&
            (identical(other.note, note) || const DeepCollectionEquality().equals(other.note, note)) &&
            (identical(other.printNoteOnInContract, printNoteOnInContract) || const DeepCollectionEquality().equals(other.printNoteOnInContract, printNoteOnInContract)) &&
            (identical(other.printNoteOnOutContract, printNoteOnOutContract) || const DeepCollectionEquality().equals(other.printNoteOnOutContract, printNoteOnOutContract)) &&
            (identical(other.printNoteOnReceiveContract, printNoteOnReceiveContract) || const DeepCollectionEquality().equals(other.printNoteOnReceiveContract, printNoteOnReceiveContract)) &&
            (identical(other.printNoteOnReturnContract, printNoteOnReturnContract) || const DeepCollectionEquality().equals(other.printNoteOnReturnContract, printNoteOnReturnContract)) &&
            (identical(other.printNoteOnInvoice, printNoteOnInvoice) || const DeepCollectionEquality().equals(other.printNoteOnInvoice, printNoteOnInvoice)) &&
            (identical(other.printNoteOnOrder, printNoteOnOrder) || const DeepCollectionEquality().equals(other.printNoteOnOrder, printNoteOnOrder)) &&
            (identical(other.printNoteOnPickList, printNoteOnPickList) || const DeepCollectionEquality().equals(other.printNoteOnPickList, printNoteOnPickList)) &&
            (identical(other.printNoteOnPO, printNoteOnPO) || const DeepCollectionEquality().equals(other.printNoteOnPO, printNoteOnPO)) &&
            (identical(other.printNoteOnQuote, printNoteOnQuote) || const DeepCollectionEquality().equals(other.printNoteOnQuote, printNoteOnQuote)) &&
            (identical(other.printNoteOnReturnList, printNoteOnReturnList) || const DeepCollectionEquality().equals(other.printNoteOnReturnList, printNoteOnReturnList)) &&
            (identical(other.printNoteOnPoReceiveList, printNoteOnPoReceiveList) || const DeepCollectionEquality().equals(other.printNoteOnPoReceiveList, printNoteOnPoReceiveList)) &&
            (identical(other.printNoteOnPoReturnList, printNoteOnPoReturnList) || const DeepCollectionEquality().equals(other.printNoteOnPoReturnList, printNoteOnPoReturnList)) &&
            (identical(other.assetAccountId, assetAccountId) || const DeepCollectionEquality().equals(other.assetAccountId, assetAccountId)) &&
            (identical(other.assetAccountNo, assetAccountNo) || const DeepCollectionEquality().equals(other.assetAccountNo, assetAccountNo)) &&
            (identical(other.assetAccountDescription, assetAccountDescription) || const DeepCollectionEquality().equals(other.assetAccountDescription, assetAccountDescription)) &&
            (identical(other.incomeAccountId, incomeAccountId) || const DeepCollectionEquality().equals(other.incomeAccountId, incomeAccountId)) &&
            (identical(other.incomeAccountNo, incomeAccountNo) || const DeepCollectionEquality().equals(other.incomeAccountNo, incomeAccountNo)) &&
            (identical(other.incomeAccountDescription, incomeAccountDescription) || const DeepCollectionEquality().equals(other.incomeAccountDescription, incomeAccountDescription)) &&
            (identical(other.subIncomeAccountId, subIncomeAccountId) || const DeepCollectionEquality().equals(other.subIncomeAccountId, subIncomeAccountId)) &&
            (identical(other.subIncomeAccountNo, subIncomeAccountNo) || const DeepCollectionEquality().equals(other.subIncomeAccountNo, subIncomeAccountNo)) &&
            (identical(other.subIncomeAccountDescription, subIncomeAccountDescription) || const DeepCollectionEquality().equals(other.subIncomeAccountDescription, subIncomeAccountDescription)) &&
            (identical(other.consignmentIncomeAccountId, consignmentIncomeAccountId) || const DeepCollectionEquality().equals(other.consignmentIncomeAccountId, consignmentIncomeAccountId)) &&
            (identical(other.consignmentIncomeAccountNo, consignmentIncomeAccountNo) || const DeepCollectionEquality().equals(other.consignmentIncomeAccountNo, consignmentIncomeAccountNo)) &&
            (identical(other.consignmentIncomeAccountDescription, consignmentIncomeAccountDescription) || const DeepCollectionEquality().equals(other.consignmentIncomeAccountDescription, consignmentIncomeAccountDescription)) &&
            (identical(other.ldIncomeAccountId, ldIncomeAccountId) || const DeepCollectionEquality().equals(other.ldIncomeAccountId, ldIncomeAccountId)) &&
            (identical(other.ldIncomeAccountNo, ldIncomeAccountNo) || const DeepCollectionEquality().equals(other.ldIncomeAccountNo, ldIncomeAccountNo)) &&
            (identical(other.ldIncomeAccountDescription, ldIncomeAccountDescription) || const DeepCollectionEquality().equals(other.ldIncomeAccountDescription, ldIncomeAccountDescription)) &&
            (identical(other.equipmentSaleIncomeAccountId, equipmentSaleIncomeAccountId) || const DeepCollectionEquality().equals(other.equipmentSaleIncomeAccountId, equipmentSaleIncomeAccountId)) &&
            (identical(other.equipmentSaleIncomeAccountNo, equipmentSaleIncomeAccountNo) || const DeepCollectionEquality().equals(other.equipmentSaleIncomeAccountNo, equipmentSaleIncomeAccountNo)) &&
            (identical(other.equipmentSaleIncomeAccountDescription, equipmentSaleIncomeAccountDescription) || const DeepCollectionEquality().equals(other.equipmentSaleIncomeAccountDescription, equipmentSaleIncomeAccountDescription)) &&
            (identical(other.expenseAccountId, expenseAccountId) || const DeepCollectionEquality().equals(other.expenseAccountId, expenseAccountId)) &&
            (identical(other.expenseAccountNo, expenseAccountNo) || const DeepCollectionEquality().equals(other.expenseAccountNo, expenseAccountNo)) &&
            (identical(other.expenseAccountDescription, expenseAccountDescription) || const DeepCollectionEquality().equals(other.expenseAccountDescription, expenseAccountDescription)) &&
            (identical(other.costOfGoodsSoldExpenseAccountId, costOfGoodsSoldExpenseAccountId) || const DeepCollectionEquality().equals(other.costOfGoodsSoldExpenseAccountId, costOfGoodsSoldExpenseAccountId)) &&
            (identical(other.costOfGoodsSoldExpenseAccountNo, costOfGoodsSoldExpenseAccountNo) || const DeepCollectionEquality().equals(other.costOfGoodsSoldExpenseAccountNo, costOfGoodsSoldExpenseAccountNo)) &&
            (identical(other.costOfGoodsSoldExpenseAccountDescription, costOfGoodsSoldExpenseAccountDescription) || const DeepCollectionEquality().equals(other.costOfGoodsSoldExpenseAccountDescription, costOfGoodsSoldExpenseAccountDescription)) &&
            (identical(other.costOfGoodsRentedExpenseAccountId, costOfGoodsRentedExpenseAccountId) || const DeepCollectionEquality().equals(other.costOfGoodsRentedExpenseAccountId, costOfGoodsRentedExpenseAccountId)) &&
            (identical(other.costOfGoodsRentedExpenseAccountNo, costOfGoodsRentedExpenseAccountNo) || const DeepCollectionEquality().equals(other.costOfGoodsRentedExpenseAccountNo, costOfGoodsRentedExpenseAccountNo)) &&
            (identical(other.costOfGoodsRentedExpenseAccountDescription, costOfGoodsRentedExpenseAccountDescription) || const DeepCollectionEquality().equals(other.costOfGoodsRentedExpenseAccountDescription, costOfGoodsRentedExpenseAccountDescription)) &&
            (identical(other.depreciationExpenseAccountId, depreciationExpenseAccountId) || const DeepCollectionEquality().equals(other.depreciationExpenseAccountId, depreciationExpenseAccountId)) &&
            (identical(other.depreciationExpenseAccountNo, depreciationExpenseAccountNo) || const DeepCollectionEquality().equals(other.depreciationExpenseAccountNo, depreciationExpenseAccountNo)) &&
            (identical(other.depreciationExpenseAccountDescription, depreciationExpenseAccountDescription) || const DeepCollectionEquality().equals(other.depreciationExpenseAccountDescription, depreciationExpenseAccountDescription)) &&
            (identical(other.accumulatedDepreciationExpenseAccountId, accumulatedDepreciationExpenseAccountId) || const DeepCollectionEquality().equals(other.accumulatedDepreciationExpenseAccountId, accumulatedDepreciationExpenseAccountId)) &&
            (identical(other.accumulatedDepreciationExpenseAccountNo, accumulatedDepreciationExpenseAccountNo) || const DeepCollectionEquality().equals(other.accumulatedDepreciationExpenseAccountNo, accumulatedDepreciationExpenseAccountNo)) &&
            (identical(other.accumulatedDepreciationExpenseAccountDescription, accumulatedDepreciationExpenseAccountDescription) || const DeepCollectionEquality().equals(other.accumulatedDepreciationExpenseAccountDescription, accumulatedDepreciationExpenseAccountDescription)) &&
            (identical(other.originalShowId, originalShowId) || const DeepCollectionEquality().equals(other.originalShowId, originalShowId)) &&
            (identical(other.inactive, inactive) || const DeepCollectionEquality().equals(other.inactive, inactive)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.manifestShippingContainer, manifestShippingContainer) || const DeepCollectionEquality().equals(other.manifestShippingContainer, manifestShippingContainer)) &&
            (identical(other.manifestStandAloneItem, manifestStandAloneItem) || const DeepCollectionEquality().equals(other.manifestStandAloneItem, manifestStandAloneItem)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesInventoryPartsInventoryPartsInventoryExtension
    on WebApiModulesInventoryPartsInventoryPartsInventory {
  WebApiModulesInventoryPartsInventoryPartsInventory copyWith(
      {double? price,
      double? defaultCost,
      double? averageCost,
      String? inventoryId,
      String? inventoryTypeId,
      String? inventoryType,
      String? availableFrom,
      String? trackedBy,
      String? confirmTrackedBy,
      String? rank,
      String? manufacturerPartNumber,
      String? manufacturerId,
      String? manufacturer,
      String? manufacturerUrl,
      bool? excludeImageFromQuoteOrderPrint,
      bool? noAvailabilityCheck,
      bool? availabilityManuallyResolveConflicts,
      bool? sendAvailabilityAlert,
      String? primaryDimensionUniqueId,
      String? defaultImperialMetric,
      String? primaryDimensionDescription,
      int? primaryDimensionShipWeightLbs,
      int? primaryDimensionShipWeightOz,
      int? primaryDimensionWeightInCaseLbs,
      int? primaryDimensionWeightInCaseOz,
      int? primaryDimensionWidthFt,
      int? primaryDimensionWidthIn,
      int? primaryDimensionHeightFt,
      int? primaryDimensionHeightIn,
      int? primaryDimensionLengthFt,
      int? primaryDimensionLengthIn,
      int? primaryDimensionShipWeightKg,
      int? primaryDimensionShipWeightG,
      int? primaryDimensionWeightInCaseKg,
      int? primaryDimensionWeightInCaseG,
      int? primaryDimensionWidthM,
      int? primaryDimensionWidthCm,
      int? primaryDimensionHeightM,
      int? primaryDimensionHeightCm,
      int? primaryDimensionLengthM,
      int? primaryDimensionLengthCm,
      bool? hasSecondaryDimensions,
      String? secondaryDimensionUniqueId,
      String? secondaryDimensionDescription,
      int? secondaryDimensionShipWeightLbs,
      int? secondaryDimensionShipWeightOz,
      int? secondaryDimensionWeightInCaseLbs,
      int? secondaryDimensionWeightInCaseOz,
      int? secondaryDimensionWidthFt,
      int? secondaryDimensionWidthIn,
      int? secondaryDimensionHeightFt,
      int? secondaryDimensionHeightIn,
      int? secondaryDimensionLengthFt,
      int? secondaryDimensionLengthIn,
      int? secondaryDimensionShipWeightKg,
      int? secondaryDimensionShipWeightG,
      int? secondaryDimensionWeightInCaseKg,
      int? secondaryDimensionWeightInCaseG,
      int? secondaryDimensionWidthM,
      int? secondaryDimensionWidthCm,
      int? secondaryDimensionHeightM,
      int? secondaryDimensionHeightCm,
      int? secondaryDimensionLengthM,
      int? secondaryDimensionLengthCm,
      String? countryOfOriginId,
      String? countryOfOrigin,
      bool? displayInSummaryModeWhenRateIsZero,
      bool? qcRequired,
      String? qcTime,
      bool? copyAttributesAsNote,
      bool? trackAssetUsage,
      bool? trackLampUsage,
      bool? trackStrikes,
      bool? trackCandles,
      int? lampCount,
      int? minimumFootCandles,
      bool? trackSoftware,
      String? softwareVersion,
      String? softwareEffectiveDate,
      bool? warehouseSpecificPackage,
      String? completePackagePrice,
      String? kitPackagePrice,
      bool? separatePackageOnQuoteOrder,
      String? containerId,
      String? containerScannableInventoryId,
      String? containerScannableICode,
      String? containerScannableDescription,
      bool? automaticallyRebuildContainerAtCheckIn,
      bool? automaticallyRebuildContainerAtTransferIn,
      String? containerStagingRule,
      bool? excludeContainedItemsFromAvailability,
      bool? useContainerNumber,
      String? containerPackingListBehavior,
      bool? inventoryTypeIsWardrobe,
      bool? inventoryTypeIsSets,
      String? patternId,
      String? pattern,
      String? periodId,
      String? period,
      String? materialId,
      String? material,
      String? genderId,
      String? gender,
      String? labelId,
      String? label,
      String? wardrobeSize,
      int? wardrobePieceCount,
      bool? dyed,
      String? wardrobeSourceId,
      String? wardrobeSource,
      String? wardrobeCareId,
      String? wardrobeCare,
      double? cleaningFeeAmount,
      String? wardrobeDetailedDescription,
      String? webDetailedDescription,
      bool? overrideSystemDefaultRevenueAllocationBehavior,
      bool? allocateRevenueForAccessories,
      String? packageRevenueCalculationFormula,
      bool? isHazardousMaterial,
      String? descriptionWithAkas,
      String? costCalculation,
      double? quantity,
      String? aisleLocation,
      String? shelfLocation,
      bool? taxable,
      String? iCode,
      String? description,
      String? availFor,
      String? categoryId,
      String? category,
      int? subCategoryCount,
      String? subCategoryId,
      String? subCategory,
      String? classification,
      String? classificationDescription,
      String? classificationColor,
      String? unitId,
      String? unit,
      String? unitType,
      bool? nonDiscountable,
      bool? overrideProfitAndLossCategory,
      String? profitAndLossCategoryId,
      String? profitAndLossCategory,
      bool? autoCopyNotesToQuoteOrder,
      String? note,
      bool? printNoteOnInContract,
      bool? printNoteOnOutContract,
      bool? printNoteOnReceiveContract,
      bool? printNoteOnReturnContract,
      bool? printNoteOnInvoice,
      bool? printNoteOnOrder,
      bool? printNoteOnPickList,
      bool? printNoteOnPO,
      bool? printNoteOnQuote,
      bool? printNoteOnReturnList,
      bool? printNoteOnPoReceiveList,
      bool? printNoteOnPoReturnList,
      String? assetAccountId,
      String? assetAccountNo,
      String? assetAccountDescription,
      String? incomeAccountId,
      String? incomeAccountNo,
      String? incomeAccountDescription,
      String? subIncomeAccountId,
      String? subIncomeAccountNo,
      String? subIncomeAccountDescription,
      String? consignmentIncomeAccountId,
      String? consignmentIncomeAccountNo,
      String? consignmentIncomeAccountDescription,
      String? ldIncomeAccountId,
      String? ldIncomeAccountNo,
      String? ldIncomeAccountDescription,
      String? equipmentSaleIncomeAccountId,
      String? equipmentSaleIncomeAccountNo,
      String? equipmentSaleIncomeAccountDescription,
      String? expenseAccountId,
      String? expenseAccountNo,
      String? expenseAccountDescription,
      String? costOfGoodsSoldExpenseAccountId,
      String? costOfGoodsSoldExpenseAccountNo,
      String? costOfGoodsSoldExpenseAccountDescription,
      String? costOfGoodsRentedExpenseAccountId,
      String? costOfGoodsRentedExpenseAccountNo,
      String? costOfGoodsRentedExpenseAccountDescription,
      String? depreciationExpenseAccountId,
      String? depreciationExpenseAccountNo,
      String? depreciationExpenseAccountDescription,
      String? accumulatedDepreciationExpenseAccountId,
      String? accumulatedDepreciationExpenseAccountNo,
      String? accumulatedDepreciationExpenseAccountDescription,
      String? originalShowId,
      bool? inactive,
      String? dateStamp,
      bool? manifestShippingContainer,
      bool? manifestStandAloneItem,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesInventoryPartsInventoryPartsInventory(
        price: price ?? this.price,
        defaultCost: defaultCost ?? this.defaultCost,
        averageCost: averageCost ?? this.averageCost,
        inventoryId: inventoryId ?? this.inventoryId,
        inventoryTypeId: inventoryTypeId ?? this.inventoryTypeId,
        inventoryType: inventoryType ?? this.inventoryType,
        availableFrom: availableFrom ?? this.availableFrom,
        trackedBy: trackedBy ?? this.trackedBy,
        confirmTrackedBy: confirmTrackedBy ?? this.confirmTrackedBy,
        rank: rank ?? this.rank,
        manufacturerPartNumber:
            manufacturerPartNumber ?? this.manufacturerPartNumber,
        manufacturerId: manufacturerId ?? this.manufacturerId,
        manufacturer: manufacturer ?? this.manufacturer,
        manufacturerUrl: manufacturerUrl ?? this.manufacturerUrl,
        excludeImageFromQuoteOrderPrint: excludeImageFromQuoteOrderPrint ??
            this.excludeImageFromQuoteOrderPrint,
        noAvailabilityCheck: noAvailabilityCheck ?? this.noAvailabilityCheck,
        availabilityManuallyResolveConflicts: availabilityManuallyResolveConflicts ??
            this.availabilityManuallyResolveConflicts,
        sendAvailabilityAlert:
            sendAvailabilityAlert ?? this.sendAvailabilityAlert,
        primaryDimensionUniqueId:
            primaryDimensionUniqueId ?? this.primaryDimensionUniqueId,
        defaultImperialMetric:
            defaultImperialMetric ?? this.defaultImperialMetric,
        primaryDimensionDescription:
            primaryDimensionDescription ?? this.primaryDimensionDescription,
        primaryDimensionShipWeightLbs:
            primaryDimensionShipWeightLbs ?? this.primaryDimensionShipWeightLbs,
        primaryDimensionShipWeightOz:
            primaryDimensionShipWeightOz ?? this.primaryDimensionShipWeightOz,
        primaryDimensionWeightInCaseLbs: primaryDimensionWeightInCaseLbs ??
            this.primaryDimensionWeightInCaseLbs,
        primaryDimensionWeightInCaseOz: primaryDimensionWeightInCaseOz ??
            this.primaryDimensionWeightInCaseOz,
        primaryDimensionWidthFt:
            primaryDimensionWidthFt ?? this.primaryDimensionWidthFt,
        primaryDimensionWidthIn:
            primaryDimensionWidthIn ?? this.primaryDimensionWidthIn,
        primaryDimensionHeightFt:
            primaryDimensionHeightFt ?? this.primaryDimensionHeightFt,
        primaryDimensionHeightIn:
            primaryDimensionHeightIn ?? this.primaryDimensionHeightIn,
        primaryDimensionLengthFt:
            primaryDimensionLengthFt ?? this.primaryDimensionLengthFt,
        primaryDimensionLengthIn:
            primaryDimensionLengthIn ?? this.primaryDimensionLengthIn,
        primaryDimensionShipWeightKg:
            primaryDimensionShipWeightKg ?? this.primaryDimensionShipWeightKg,
        primaryDimensionShipWeightG:
            primaryDimensionShipWeightG ?? this.primaryDimensionShipWeightG,
        primaryDimensionWeightInCaseKg: primaryDimensionWeightInCaseKg ??
            this.primaryDimensionWeightInCaseKg,
        primaryDimensionWeightInCaseG:
            primaryDimensionWeightInCaseG ?? this.primaryDimensionWeightInCaseG,
        primaryDimensionWidthM:
            primaryDimensionWidthM ?? this.primaryDimensionWidthM,
        primaryDimensionWidthCm:
            primaryDimensionWidthCm ?? this.primaryDimensionWidthCm,
        primaryDimensionHeightM:
            primaryDimensionHeightM ?? this.primaryDimensionHeightM,
        primaryDimensionHeightCm:
            primaryDimensionHeightCm ?? this.primaryDimensionHeightCm,
        primaryDimensionLengthM:
            primaryDimensionLengthM ?? this.primaryDimensionLengthM,
        primaryDimensionLengthCm:
            primaryDimensionLengthCm ?? this.primaryDimensionLengthCm,
        hasSecondaryDimensions:
            hasSecondaryDimensions ?? this.hasSecondaryDimensions,
        secondaryDimensionUniqueId:
            secondaryDimensionUniqueId ?? this.secondaryDimensionUniqueId,
        secondaryDimensionDescription:
            secondaryDimensionDescription ?? this.secondaryDimensionDescription,
        secondaryDimensionShipWeightLbs: secondaryDimensionShipWeightLbs ??
            this.secondaryDimensionShipWeightLbs,
        secondaryDimensionShipWeightOz: secondaryDimensionShipWeightOz ??
            this.secondaryDimensionShipWeightOz,
        secondaryDimensionWeightInCaseLbs: secondaryDimensionWeightInCaseLbs ??
            this.secondaryDimensionWeightInCaseLbs,
        secondaryDimensionWeightInCaseOz: secondaryDimensionWeightInCaseOz ??
            this.secondaryDimensionWeightInCaseOz,
        secondaryDimensionWidthFt:
            secondaryDimensionWidthFt ?? this.secondaryDimensionWidthFt,
        secondaryDimensionWidthIn:
            secondaryDimensionWidthIn ?? this.secondaryDimensionWidthIn,
        secondaryDimensionHeightFt:
            secondaryDimensionHeightFt ?? this.secondaryDimensionHeightFt,
        secondaryDimensionHeightIn:
            secondaryDimensionHeightIn ?? this.secondaryDimensionHeightIn,
        secondaryDimensionLengthFt:
            secondaryDimensionLengthFt ?? this.secondaryDimensionLengthFt,
        secondaryDimensionLengthIn:
            secondaryDimensionLengthIn ?? this.secondaryDimensionLengthIn,
        secondaryDimensionShipWeightKg: secondaryDimensionShipWeightKg ??
            this.secondaryDimensionShipWeightKg,
        secondaryDimensionShipWeightG:
            secondaryDimensionShipWeightG ?? this.secondaryDimensionShipWeightG,
        secondaryDimensionWeightInCaseKg: secondaryDimensionWeightInCaseKg ??
            this.secondaryDimensionWeightInCaseKg,
        secondaryDimensionWeightInCaseG: secondaryDimensionWeightInCaseG ??
            this.secondaryDimensionWeightInCaseG,
        secondaryDimensionWidthM:
            secondaryDimensionWidthM ?? this.secondaryDimensionWidthM,
        secondaryDimensionWidthCm:
            secondaryDimensionWidthCm ?? this.secondaryDimensionWidthCm,
        secondaryDimensionHeightM:
            secondaryDimensionHeightM ?? this.secondaryDimensionHeightM,
        secondaryDimensionHeightCm:
            secondaryDimensionHeightCm ?? this.secondaryDimensionHeightCm,
        secondaryDimensionLengthM:
            secondaryDimensionLengthM ?? this.secondaryDimensionLengthM,
        secondaryDimensionLengthCm:
            secondaryDimensionLengthCm ?? this.secondaryDimensionLengthCm,
        countryOfOriginId: countryOfOriginId ?? this.countryOfOriginId,
        countryOfOrigin: countryOfOrigin ?? this.countryOfOrigin,
        displayInSummaryModeWhenRateIsZero: displayInSummaryModeWhenRateIsZero ??
            this.displayInSummaryModeWhenRateIsZero,
        qcRequired: qcRequired ?? this.qcRequired,
        qcTime: qcTime ?? this.qcTime,
        copyAttributesAsNote: copyAttributesAsNote ?? this.copyAttributesAsNote,
        trackAssetUsage: trackAssetUsage ?? this.trackAssetUsage,
        trackLampUsage: trackLampUsage ?? this.trackLampUsage,
        trackStrikes: trackStrikes ?? this.trackStrikes,
        trackCandles: trackCandles ?? this.trackCandles,
        lampCount: lampCount ?? this.lampCount,
        minimumFootCandles: minimumFootCandles ?? this.minimumFootCandles,
        trackSoftware: trackSoftware ?? this.trackSoftware,
        softwareVersion: softwareVersion ?? this.softwareVersion,
        softwareEffectiveDate:
            softwareEffectiveDate ?? this.softwareEffectiveDate,
        warehouseSpecificPackage:
            warehouseSpecificPackage ?? this.warehouseSpecificPackage,
        completePackagePrice: completePackagePrice ?? this.completePackagePrice,
        kitPackagePrice: kitPackagePrice ?? this.kitPackagePrice,
        separatePackageOnQuoteOrder:
            separatePackageOnQuoteOrder ?? this.separatePackageOnQuoteOrder,
        containerId: containerId ?? this.containerId,
        containerScannableInventoryId:
            containerScannableInventoryId ?? this.containerScannableInventoryId,
        containerScannableICode:
            containerScannableICode ?? this.containerScannableICode,
        containerScannableDescription:
            containerScannableDescription ?? this.containerScannableDescription,
        automaticallyRebuildContainerAtCheckIn: automaticallyRebuildContainerAtCheckIn ??
            this.automaticallyRebuildContainerAtCheckIn,
        automaticallyRebuildContainerAtTransferIn: automaticallyRebuildContainerAtTransferIn ??
            this.automaticallyRebuildContainerAtTransferIn,
        containerStagingRule: containerStagingRule ?? this.containerStagingRule,
        excludeContainedItemsFromAvailability: excludeContainedItemsFromAvailability ?? this.excludeContainedItemsFromAvailability,
        useContainerNumber: useContainerNumber ?? this.useContainerNumber,
        containerPackingListBehavior: containerPackingListBehavior ?? this.containerPackingListBehavior,
        inventoryTypeIsWardrobe: inventoryTypeIsWardrobe ?? this.inventoryTypeIsWardrobe,
        inventoryTypeIsSets: inventoryTypeIsSets ?? this.inventoryTypeIsSets,
        patternId: patternId ?? this.patternId,
        pattern: pattern ?? this.pattern,
        periodId: periodId ?? this.periodId,
        period: period ?? this.period,
        materialId: materialId ?? this.materialId,
        material: material ?? this.material,
        genderId: genderId ?? this.genderId,
        gender: gender ?? this.gender,
        labelId: labelId ?? this.labelId,
        label: label ?? this.label,
        wardrobeSize: wardrobeSize ?? this.wardrobeSize,
        wardrobePieceCount: wardrobePieceCount ?? this.wardrobePieceCount,
        dyed: dyed ?? this.dyed,
        wardrobeSourceId: wardrobeSourceId ?? this.wardrobeSourceId,
        wardrobeSource: wardrobeSource ?? this.wardrobeSource,
        wardrobeCareId: wardrobeCareId ?? this.wardrobeCareId,
        wardrobeCare: wardrobeCare ?? this.wardrobeCare,
        cleaningFeeAmount: cleaningFeeAmount ?? this.cleaningFeeAmount,
        wardrobeDetailedDescription: wardrobeDetailedDescription ?? this.wardrobeDetailedDescription,
        webDetailedDescription: webDetailedDescription ?? this.webDetailedDescription,
        overrideSystemDefaultRevenueAllocationBehavior: overrideSystemDefaultRevenueAllocationBehavior ?? this.overrideSystemDefaultRevenueAllocationBehavior,
        allocateRevenueForAccessories: allocateRevenueForAccessories ?? this.allocateRevenueForAccessories,
        packageRevenueCalculationFormula: packageRevenueCalculationFormula ?? this.packageRevenueCalculationFormula,
        isHazardousMaterial: isHazardousMaterial ?? this.isHazardousMaterial,
        descriptionWithAkas: descriptionWithAkas ?? this.descriptionWithAkas,
        costCalculation: costCalculation ?? this.costCalculation,
        quantity: quantity ?? this.quantity,
        aisleLocation: aisleLocation ?? this.aisleLocation,
        shelfLocation: shelfLocation ?? this.shelfLocation,
        taxable: taxable ?? this.taxable,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        availFor: availFor ?? this.availFor,
        categoryId: categoryId ?? this.categoryId,
        category: category ?? this.category,
        subCategoryCount: subCategoryCount ?? this.subCategoryCount,
        subCategoryId: subCategoryId ?? this.subCategoryId,
        subCategory: subCategory ?? this.subCategory,
        classification: classification ?? this.classification,
        classificationDescription: classificationDescription ?? this.classificationDescription,
        classificationColor: classificationColor ?? this.classificationColor,
        unitId: unitId ?? this.unitId,
        unit: unit ?? this.unit,
        unitType: unitType ?? this.unitType,
        nonDiscountable: nonDiscountable ?? this.nonDiscountable,
        overrideProfitAndLossCategory: overrideProfitAndLossCategory ?? this.overrideProfitAndLossCategory,
        profitAndLossCategoryId: profitAndLossCategoryId ?? this.profitAndLossCategoryId,
        profitAndLossCategory: profitAndLossCategory ?? this.profitAndLossCategory,
        autoCopyNotesToQuoteOrder: autoCopyNotesToQuoteOrder ?? this.autoCopyNotesToQuoteOrder,
        note: note ?? this.note,
        printNoteOnInContract: printNoteOnInContract ?? this.printNoteOnInContract,
        printNoteOnOutContract: printNoteOnOutContract ?? this.printNoteOnOutContract,
        printNoteOnReceiveContract: printNoteOnReceiveContract ?? this.printNoteOnReceiveContract,
        printNoteOnReturnContract: printNoteOnReturnContract ?? this.printNoteOnReturnContract,
        printNoteOnInvoice: printNoteOnInvoice ?? this.printNoteOnInvoice,
        printNoteOnOrder: printNoteOnOrder ?? this.printNoteOnOrder,
        printNoteOnPickList: printNoteOnPickList ?? this.printNoteOnPickList,
        printNoteOnPO: printNoteOnPO ?? this.printNoteOnPO,
        printNoteOnQuote: printNoteOnQuote ?? this.printNoteOnQuote,
        printNoteOnReturnList: printNoteOnReturnList ?? this.printNoteOnReturnList,
        printNoteOnPoReceiveList: printNoteOnPoReceiveList ?? this.printNoteOnPoReceiveList,
        printNoteOnPoReturnList: printNoteOnPoReturnList ?? this.printNoteOnPoReturnList,
        assetAccountId: assetAccountId ?? this.assetAccountId,
        assetAccountNo: assetAccountNo ?? this.assetAccountNo,
        assetAccountDescription: assetAccountDescription ?? this.assetAccountDescription,
        incomeAccountId: incomeAccountId ?? this.incomeAccountId,
        incomeAccountNo: incomeAccountNo ?? this.incomeAccountNo,
        incomeAccountDescription: incomeAccountDescription ?? this.incomeAccountDescription,
        subIncomeAccountId: subIncomeAccountId ?? this.subIncomeAccountId,
        subIncomeAccountNo: subIncomeAccountNo ?? this.subIncomeAccountNo,
        subIncomeAccountDescription: subIncomeAccountDescription ?? this.subIncomeAccountDescription,
        consignmentIncomeAccountId: consignmentIncomeAccountId ?? this.consignmentIncomeAccountId,
        consignmentIncomeAccountNo: consignmentIncomeAccountNo ?? this.consignmentIncomeAccountNo,
        consignmentIncomeAccountDescription: consignmentIncomeAccountDescription ?? this.consignmentIncomeAccountDescription,
        ldIncomeAccountId: ldIncomeAccountId ?? this.ldIncomeAccountId,
        ldIncomeAccountNo: ldIncomeAccountNo ?? this.ldIncomeAccountNo,
        ldIncomeAccountDescription: ldIncomeAccountDescription ?? this.ldIncomeAccountDescription,
        equipmentSaleIncomeAccountId: equipmentSaleIncomeAccountId ?? this.equipmentSaleIncomeAccountId,
        equipmentSaleIncomeAccountNo: equipmentSaleIncomeAccountNo ?? this.equipmentSaleIncomeAccountNo,
        equipmentSaleIncomeAccountDescription: equipmentSaleIncomeAccountDescription ?? this.equipmentSaleIncomeAccountDescription,
        expenseAccountId: expenseAccountId ?? this.expenseAccountId,
        expenseAccountNo: expenseAccountNo ?? this.expenseAccountNo,
        expenseAccountDescription: expenseAccountDescription ?? this.expenseAccountDescription,
        costOfGoodsSoldExpenseAccountId: costOfGoodsSoldExpenseAccountId ?? this.costOfGoodsSoldExpenseAccountId,
        costOfGoodsSoldExpenseAccountNo: costOfGoodsSoldExpenseAccountNo ?? this.costOfGoodsSoldExpenseAccountNo,
        costOfGoodsSoldExpenseAccountDescription: costOfGoodsSoldExpenseAccountDescription ?? this.costOfGoodsSoldExpenseAccountDescription,
        costOfGoodsRentedExpenseAccountId: costOfGoodsRentedExpenseAccountId ?? this.costOfGoodsRentedExpenseAccountId,
        costOfGoodsRentedExpenseAccountNo: costOfGoodsRentedExpenseAccountNo ?? this.costOfGoodsRentedExpenseAccountNo,
        costOfGoodsRentedExpenseAccountDescription: costOfGoodsRentedExpenseAccountDescription ?? this.costOfGoodsRentedExpenseAccountDescription,
        depreciationExpenseAccountId: depreciationExpenseAccountId ?? this.depreciationExpenseAccountId,
        depreciationExpenseAccountNo: depreciationExpenseAccountNo ?? this.depreciationExpenseAccountNo,
        depreciationExpenseAccountDescription: depreciationExpenseAccountDescription ?? this.depreciationExpenseAccountDescription,
        accumulatedDepreciationExpenseAccountId: accumulatedDepreciationExpenseAccountId ?? this.accumulatedDepreciationExpenseAccountId,
        accumulatedDepreciationExpenseAccountNo: accumulatedDepreciationExpenseAccountNo ?? this.accumulatedDepreciationExpenseAccountNo,
        accumulatedDepreciationExpenseAccountDescription: accumulatedDepreciationExpenseAccountDescription ?? this.accumulatedDepreciationExpenseAccountDescription,
        originalShowId: originalShowId ?? this.originalShowId,
        inactive: inactive ?? this.inactive,
        dateStamp: dateStamp ?? this.dateStamp,
        manifestShippingContainer: manifestShippingContainer ?? this.manifestShippingContainer,
        manifestStandAloneItem: manifestStandAloneItem ?? this.manifestStandAloneItem,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes: defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPartsInventoryPartsInventoryDocument {
  WebApiModulesInventoryPartsInventoryPartsInventoryDocument({
    this.inventoryId,
    this.copying,
    this.documentId,
    this.documentTypeId,
    this.uniqueId1,
    this.uniqueId2,
    this.uniqueId1Int,
    this.description,
    this.inputByUsersId,
    this.attachDate,
    this.attachTime,
    this.attachToEmail,
    this.inactive,
    this.dateStamp,
    this.extension,
    this.documentType,
    this.inputBy,
    this.hasImage,
    this.hasFile,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesInventoryPartsInventoryPartsInventoryDocument.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPartsInventoryPartsInventoryDocumentFromJson(
          json);

  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'copying')
  final bool? copying;
  @JsonKey(name: 'DocumentId')
  final String? documentId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'UniqueId1')
  final String? uniqueId1;
  @JsonKey(name: 'UniqueId2')
  final String? uniqueId2;
  @JsonKey(name: 'UniqueId1Int')
  final int? uniqueId1Int;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'InputByUsersId')
  final String? inputByUsersId;
  @JsonKey(name: 'AttachDate')
  final String? attachDate;
  @JsonKey(name: 'AttachTime')
  final String? attachTime;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'Extension')
  final String? extension;
  @JsonKey(name: 'DocumentType')
  final String? documentType;
  @JsonKey(name: 'InputBy')
  final String? inputBy;
  @JsonKey(name: 'HasImage')
  final bool? hasImage;
  @JsonKey(name: 'HasFile')
  final bool? hasFile;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPartsInventoryPartsInventoryDocumentFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPartsInventoryPartsInventoryDocumentToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPartsInventoryPartsInventoryDocumentToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPartsInventoryPartsInventoryDocument &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.copying, copying) ||
                const DeepCollectionEquality()
                    .equals(other.copying, copying)) &&
            (identical(other.documentId, documentId) ||
                const DeepCollectionEquality()
                    .equals(other.documentId, documentId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.uniqueId1, uniqueId1) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1, uniqueId1)) &&
            (identical(other.uniqueId2, uniqueId2) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId2, uniqueId2)) &&
            (identical(other.uniqueId1Int, uniqueId1Int) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1Int, uniqueId1Int)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.inputByUsersId, inputByUsersId) ||
                const DeepCollectionEquality()
                    .equals(other.inputByUsersId, inputByUsersId)) &&
            (identical(other.attachDate, attachDate) ||
                const DeepCollectionEquality()
                    .equals(other.attachDate, attachDate)) &&
            (identical(other.attachTime, attachTime) ||
                const DeepCollectionEquality()
                    .equals(other.attachTime, attachTime)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.extension, extension) ||
                const DeepCollectionEquality()
                    .equals(other.extension, extension)) &&
            (identical(other.documentType, documentType) ||
                const DeepCollectionEquality()
                    .equals(other.documentType, documentType)) &&
            (identical(other.inputBy, inputBy) ||
                const DeepCollectionEquality()
                    .equals(other.inputBy, inputBy)) &&
            (identical(other.hasImage, hasImage) ||
                const DeepCollectionEquality()
                    .equals(other.hasImage, hasImage)) &&
            (identical(other.hasFile, hasFile) ||
                const DeepCollectionEquality()
                    .equals(other.hasFile, hasFile)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality().equals(other.filePath, filePath)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesInventoryPartsInventoryPartsInventoryDocumentExtension
    on WebApiModulesInventoryPartsInventoryPartsInventoryDocument {
  WebApiModulesInventoryPartsInventoryPartsInventoryDocument copyWith(
      {String? inventoryId,
      bool? copying,
      String? documentId,
      String? documentTypeId,
      String? uniqueId1,
      String? uniqueId2,
      int? uniqueId1Int,
      String? description,
      String? inputByUsersId,
      String? attachDate,
      String? attachTime,
      bool? attachToEmail,
      bool? inactive,
      String? dateStamp,
      String? extension,
      String? documentType,
      String? inputBy,
      bool? hasImage,
      bool? hasFile,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesInventoryPartsInventoryPartsInventoryDocument(
        inventoryId: inventoryId ?? this.inventoryId,
        copying: copying ?? this.copying,
        documentId: documentId ?? this.documentId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        uniqueId1: uniqueId1 ?? this.uniqueId1,
        uniqueId2: uniqueId2 ?? this.uniqueId2,
        uniqueId1Int: uniqueId1Int ?? this.uniqueId1Int,
        description: description ?? this.description,
        inputByUsersId: inputByUsersId ?? this.inputByUsersId,
        attachDate: attachDate ?? this.attachDate,
        attachTime: attachTime ?? this.attachTime,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        dateStamp: dateStamp ?? this.dateStamp,
        extension: extension ?? this.extension,
        documentType: documentType ?? this.documentType,
        inputBy: inputBy ?? this.inputBy,
        hasImage: hasImage ?? this.hasImage,
        hasFile: hasFile ?? this.hasFile,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPostRequest {
  WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPostRequest({
    this.inventoryId,
    this.documentTypeId,
    this.description,
    this.attachToEmail,
    this.inactive,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
  });

  factory WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPostRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPostRequestFromJson(
          json);

  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPostRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPostRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPostRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPostRequest &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)));
  }
}

extension $WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPostRequestExtension
    on WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPostRequest {
  WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPostRequest
      copyWith(
          {String? inventoryId,
          String? documentTypeId,
          String? description,
          bool? attachToEmail,
          bool? inactive,
          bool? fileIsModified,
          String? fileDataUrl,
          String? filePath}) {
    return WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPostRequest(
        inventoryId: inventoryId ?? this.inventoryId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        description: description ?? this.description,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPutRequest {
  WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPutRequest({
    this.inventoryId,
    this.documentId,
    this.documentTypeId,
    this.description,
    this.attachToEmail,
    this.inactive,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
  });

  factory WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPutRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPutRequestFromJson(
          json);

  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'DocumentId')
  final String? documentId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPutRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPutRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPutRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPutRequest &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.documentId, documentId) ||
                const DeepCollectionEquality()
                    .equals(other.documentId, documentId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)));
  }
}

extension $WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPutRequestExtension
    on WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPutRequest {
  WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPutRequest copyWith(
      {String? inventoryId,
      String? documentId,
      String? documentTypeId,
      String? description,
      bool? attachToEmail,
      bool? inactive,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath}) {
    return WebApiModulesInventoryPartsInventoryPartsInventoryDocumentPutRequest(
        inventoryId: inventoryId ?? this.inventoryId,
        documentId: documentId ?? this.documentId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        description: description ?? this.description,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventory {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventory({
    this.physicalInventoryId,
    this.officeLocationId,
    this.officeLocation,
    this.officeLocationCode,
    this.dealId,
    this.scheduleDate,
    this.preScanDateTime,
    this.initiateDateTime,
    this.physicalInventoryNumber,
    this.description,
    this.countType,
    this.warehouseId,
    this.warehouseCode,
    this.warehouse,
    this.inventoryTypeId,
    this.inventoryType,
    this.categoryId,
    this.category,
    this.subCategoryId,
    this.subCategory,
    this.recType,
    this.recTypeDisplay,
    this.rank,
    this.cycleRankA,
    this.cycleRankB,
    this.cycleRankC,
    this.cycleRankD,
    this.cycleRankE,
    this.cycleRankF,
    this.cycleRankG,
    this.aFromValue,
    this.aToValue,
    this.bFromValue,
    this.bToValue,
    this.cFromValue,
    this.cToValue,
    this.dFromValue,
    this.dToValue,
    this.eFromValue,
    this.eToValue,
    this.fFromValue,
    this.fToValue,
    this.gFromValue,
    this.gToValue,
    this.stepPreScan,
    this.allowStepPreScan,
    this.stepInitiate,
    this.allowStepInitiate,
    this.stepPrintCountSheets,
    this.allowStepPrintCountSheets,
    this.allowStepPrintPrescanProgress,
    this.stepCount,
    this.allowStepCount,
    this.stepPrintExceptionReport,
    this.allowStepPrintExceptionReport,
    this.stepPrintDiscrepancyReport,
    this.allowStepPrintDiscrepancyReport,
    this.stepRecount,
    this.allowStepRecount,
    this.stepPrintRecountAnalysisReport,
    this.allowStepPrintRecountAnalysisReport,
    this.stepPrintReconciliationReport,
    this.allowStepPrintReconciliationReport,
    this.stepItemsAdded,
    this.allowStepItemsAdded,
    this.stepApproveCounts,
    this.allowStepApproveCounts,
    this.stepClose,
    this.allowStepClose,
    this.stepCloseWithoutAdjustments,
    this.allowStepCloseWithoutAdjustments,
    this.closedWithAdjustments,
    this.closedWithOutAdjustments,
    this.allowStepPrintResults,
    this.status,
    this.cycleLastCounted,
    this.cycleTrackedBy,
    this.cycleAisle,
    this.cycleShelf,
    this.cycleOnlyIncludeInventoryWithNonZeroQuantity,
    this.approvedPurchaseCost,
    this.countInventoryThatIsOut,
    this.facilitiesInventory,
    this.presInitializeAutomaticallyCountInventoryThatIsOut,
    this.cycleIncludeOwned,
    this.cycleIncludeConsigned,
    this.hideConsigned,
    this.selectitemsbyNotUsed,
    this.excludeInventoryWithNoAvailabilityCheck,
    this.approvedByUserId,
    this.approvedByUser,
    this.approveDate,
    this.approveTime,
    this.inputByUserId,
    this.inputDate,
    this.inputTime,
    this.inactive,
    this.replaceCounts,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventory.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryFromJson(json);

  @JsonKey(name: 'PhysicalInventoryId')
  final String? physicalInventoryId;
  @JsonKey(name: 'OfficeLocationId')
  final String? officeLocationId;
  @JsonKey(name: 'OfficeLocation')
  final String? officeLocation;
  @JsonKey(name: 'OfficeLocationCode')
  final String? officeLocationCode;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'ScheduleDate')
  final String? scheduleDate;
  @JsonKey(name: 'PreScanDateTime')
  final String? preScanDateTime;
  @JsonKey(name: 'InitiateDateTime')
  final String? initiateDateTime;
  @JsonKey(name: 'PhysicalInventoryNumber')
  final String? physicalInventoryNumber;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'CountType')
  final String? countType;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'InventoryTypeId')
  final String? inventoryTypeId;
  @JsonKey(name: 'InventoryType')
  final String? inventoryType;
  @JsonKey(name: 'CategoryId')
  final String? categoryId;
  @JsonKey(name: 'Category')
  final String? category;
  @JsonKey(name: 'SubCategoryId')
  final String? subCategoryId;
  @JsonKey(name: 'SubCategory')
  final String? subCategory;
  @JsonKey(name: 'RecType')
  final String? recType;
  @JsonKey(name: 'RecTypeDisplay')
  final String? recTypeDisplay;
  @JsonKey(name: 'Rank')
  final String? rank;
  @JsonKey(name: 'CycleRankA')
  final bool? cycleRankA;
  @JsonKey(name: 'CycleRankB')
  final bool? cycleRankB;
  @JsonKey(name: 'CycleRankC')
  final bool? cycleRankC;
  @JsonKey(name: 'CycleRankD')
  final bool? cycleRankD;
  @JsonKey(name: 'CycleRankE')
  final bool? cycleRankE;
  @JsonKey(name: 'CycleRankF')
  final bool? cycleRankF;
  @JsonKey(name: 'CycleRankG')
  final bool? cycleRankG;
  @JsonKey(name: 'AFromValue')
  final double? aFromValue;
  @JsonKey(name: 'AToValue')
  final double? aToValue;
  @JsonKey(name: 'BFromValue')
  final double? bFromValue;
  @JsonKey(name: 'BToValue')
  final double? bToValue;
  @JsonKey(name: 'CFromValue')
  final double? cFromValue;
  @JsonKey(name: 'CToValue')
  final double? cToValue;
  @JsonKey(name: 'DFromValue')
  final double? dFromValue;
  @JsonKey(name: 'DToValue')
  final double? dToValue;
  @JsonKey(name: 'EFromValue')
  final double? eFromValue;
  @JsonKey(name: 'EToValue')
  final double? eToValue;
  @JsonKey(name: 'FFromValue')
  final double? fFromValue;
  @JsonKey(name: 'FToValue')
  final double? fToValue;
  @JsonKey(name: 'GFromValue')
  final double? gFromValue;
  @JsonKey(name: 'GToValue')
  final double? gToValue;
  @JsonKey(name: 'StepPreScan')
  final int? stepPreScan;
  @JsonKey(name: 'AllowStepPreScan')
  final bool? allowStepPreScan;
  @JsonKey(name: 'StepInitiate')
  final int? stepInitiate;
  @JsonKey(name: 'AllowStepInitiate')
  final bool? allowStepInitiate;
  @JsonKey(name: 'StepPrintCountSheets')
  final int? stepPrintCountSheets;
  @JsonKey(name: 'AllowStepPrintCountSheets')
  final bool? allowStepPrintCountSheets;
  @JsonKey(name: 'AllowStepPrintPrescanProgress')
  final bool? allowStepPrintPrescanProgress;
  @JsonKey(name: 'StepCount')
  final int? stepCount;
  @JsonKey(name: 'AllowStepCount')
  final bool? allowStepCount;
  @JsonKey(name: 'StepPrintExceptionReport')
  final int? stepPrintExceptionReport;
  @JsonKey(name: 'AllowStepPrintExceptionReport')
  final bool? allowStepPrintExceptionReport;
  @JsonKey(name: 'StepPrintDiscrepancyReport')
  final int? stepPrintDiscrepancyReport;
  @JsonKey(name: 'AllowStepPrintDiscrepancyReport')
  final bool? allowStepPrintDiscrepancyReport;
  @JsonKey(name: 'StepRecount')
  final int? stepRecount;
  @JsonKey(name: 'AllowStepRecount')
  final bool? allowStepRecount;
  @JsonKey(name: 'StepPrintRecountAnalysisReport')
  final int? stepPrintRecountAnalysisReport;
  @JsonKey(name: 'AllowStepPrintRecountAnalysisReport')
  final bool? allowStepPrintRecountAnalysisReport;
  @JsonKey(name: 'StepPrintReconciliationReport')
  final int? stepPrintReconciliationReport;
  @JsonKey(name: 'AllowStepPrintReconciliationReport')
  final bool? allowStepPrintReconciliationReport;
  @JsonKey(name: 'StepItemsAdded')
  final int? stepItemsAdded;
  @JsonKey(name: 'AllowStepItemsAdded')
  final bool? allowStepItemsAdded;
  @JsonKey(name: 'StepApproveCounts')
  final int? stepApproveCounts;
  @JsonKey(name: 'AllowStepApproveCounts')
  final bool? allowStepApproveCounts;
  @JsonKey(name: 'StepClose')
  final int? stepClose;
  @JsonKey(name: 'AllowStepClose')
  final bool? allowStepClose;
  @JsonKey(name: 'StepCloseWithoutAdjustments')
  final int? stepCloseWithoutAdjustments;
  @JsonKey(name: 'AllowStepCloseWithoutAdjustments')
  final bool? allowStepCloseWithoutAdjustments;
  @JsonKey(name: 'ClosedWithAdjustments')
  final bool? closedWithAdjustments;
  @JsonKey(name: 'ClosedWithOutAdjustments')
  final bool? closedWithOutAdjustments;
  @JsonKey(name: 'AllowStepPrintResults')
  final bool? allowStepPrintResults;
  @JsonKey(name: 'Status')
  final String? status;
  @JsonKey(name: 'CycleLastCounted')
  final String? cycleLastCounted;
  @JsonKey(name: 'CycleTrackedBy')
  final String? cycleTrackedBy;
  @JsonKey(name: 'CycleAisle')
  final String? cycleAisle;
  @JsonKey(name: 'CycleShelf')
  final String? cycleShelf;
  @JsonKey(name: 'CycleOnlyIncludeInventoryWithNonZeroQuantity')
  final bool? cycleOnlyIncludeInventoryWithNonZeroQuantity;
  @JsonKey(name: 'ApprovedPurchaseCost')
  final bool? approvedPurchaseCost;
  @JsonKey(name: 'CountInventoryThatIsOut')
  final bool? countInventoryThatIsOut;
  @JsonKey(name: 'FacilitiesInventory')
  final bool? facilitiesInventory;
  @JsonKey(name: 'PresInitializeAutomaticallyCountInventoryThatIsOut')
  final bool? presInitializeAutomaticallyCountInventoryThatIsOut;
  @JsonKey(name: 'CycleIncludeOwned')
  final bool? cycleIncludeOwned;
  @JsonKey(name: 'CycleIncludeConsigned')
  final bool? cycleIncludeConsigned;
  @JsonKey(name: 'HideConsigned')
  final bool? hideConsigned;
  @JsonKey(name: 'Selectitemsby_not_used')
  final bool? selectitemsbyNotUsed;
  @JsonKey(name: 'ExcludeInventoryWithNoAvailabilityCheck')
  final bool? excludeInventoryWithNoAvailabilityCheck;
  @JsonKey(name: 'ApprovedByUserId')
  final String? approvedByUserId;
  @JsonKey(name: 'ApprovedByUser')
  final String? approvedByUser;
  @JsonKey(name: 'ApproveDate')
  final String? approveDate;
  @JsonKey(name: 'ApproveTime')
  final String? approveTime;
  @JsonKey(name: 'InputByUserId')
  final String? inputByUserId;
  @JsonKey(name: 'InputDate')
  final String? inputDate;
  @JsonKey(name: 'InputTime')
  final String? inputTime;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'ReplaceCounts')
  final bool? replaceCounts;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventory &&
            (identical(other.physicalInventoryId, physicalInventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.physicalInventoryId, physicalInventoryId)) &&
            (identical(other.officeLocationId, officeLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocationId, officeLocationId)) &&
            (identical(other.officeLocation, officeLocation) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocation, officeLocation)) &&
            (identical(other.officeLocationCode, officeLocationCode) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocationCode, officeLocationCode)) &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.scheduleDate, scheduleDate) ||
                const DeepCollectionEquality()
                    .equals(other.scheduleDate, scheduleDate)) &&
            (identical(other.preScanDateTime, preScanDateTime) ||
                const DeepCollectionEquality()
                    .equals(other.preScanDateTime, preScanDateTime)) &&
            (identical(other.initiateDateTime, initiateDateTime) ||
                const DeepCollectionEquality()
                    .equals(other.initiateDateTime, initiateDateTime)) &&
            (identical(other.physicalInventoryNumber, physicalInventoryNumber) ||
                const DeepCollectionEquality().equals(
                    other.physicalInventoryNumber, physicalInventoryNumber)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.countType, countType) ||
                const DeepCollectionEquality()
                    .equals(other.countType, countType)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouseCode, warehouseCode) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.warehouse, warehouse) ||
                const DeepCollectionEquality()
                    .equals(other.warehouse, warehouse)) &&
            (identical(other.inventoryTypeId, inventoryTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryTypeId, inventoryTypeId)) &&
            (identical(other.inventoryType, inventoryType) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryType, inventoryType)) &&
            (identical(other.categoryId, categoryId) ||
                const DeepCollectionEquality()
                    .equals(other.categoryId, categoryId)) &&
            (identical(other.category, category) ||
                const DeepCollectionEquality()
                    .equals(other.category, category)) &&
            (identical(other.subCategoryId, subCategoryId) ||
                const DeepCollectionEquality()
                    .equals(other.subCategoryId, subCategoryId)) &&
            (identical(other.subCategory, subCategory) || const DeepCollectionEquality().equals(other.subCategory, subCategory)) &&
            (identical(other.recType, recType) || const DeepCollectionEquality().equals(other.recType, recType)) &&
            (identical(other.recTypeDisplay, recTypeDisplay) || const DeepCollectionEquality().equals(other.recTypeDisplay, recTypeDisplay)) &&
            (identical(other.rank, rank) || const DeepCollectionEquality().equals(other.rank, rank)) &&
            (identical(other.cycleRankA, cycleRankA) || const DeepCollectionEquality().equals(other.cycleRankA, cycleRankA)) &&
            (identical(other.cycleRankB, cycleRankB) || const DeepCollectionEquality().equals(other.cycleRankB, cycleRankB)) &&
            (identical(other.cycleRankC, cycleRankC) || const DeepCollectionEquality().equals(other.cycleRankC, cycleRankC)) &&
            (identical(other.cycleRankD, cycleRankD) || const DeepCollectionEquality().equals(other.cycleRankD, cycleRankD)) &&
            (identical(other.cycleRankE, cycleRankE) || const DeepCollectionEquality().equals(other.cycleRankE, cycleRankE)) &&
            (identical(other.cycleRankF, cycleRankF) || const DeepCollectionEquality().equals(other.cycleRankF, cycleRankF)) &&
            (identical(other.cycleRankG, cycleRankG) || const DeepCollectionEquality().equals(other.cycleRankG, cycleRankG)) &&
            (identical(other.aFromValue, aFromValue) || const DeepCollectionEquality().equals(other.aFromValue, aFromValue)) &&
            (identical(other.aToValue, aToValue) || const DeepCollectionEquality().equals(other.aToValue, aToValue)) &&
            (identical(other.bFromValue, bFromValue) || const DeepCollectionEquality().equals(other.bFromValue, bFromValue)) &&
            (identical(other.bToValue, bToValue) || const DeepCollectionEquality().equals(other.bToValue, bToValue)) &&
            (identical(other.cFromValue, cFromValue) || const DeepCollectionEquality().equals(other.cFromValue, cFromValue)) &&
            (identical(other.cToValue, cToValue) || const DeepCollectionEquality().equals(other.cToValue, cToValue)) &&
            (identical(other.dFromValue, dFromValue) || const DeepCollectionEquality().equals(other.dFromValue, dFromValue)) &&
            (identical(other.dToValue, dToValue) || const DeepCollectionEquality().equals(other.dToValue, dToValue)) &&
            (identical(other.eFromValue, eFromValue) || const DeepCollectionEquality().equals(other.eFromValue, eFromValue)) &&
            (identical(other.eToValue, eToValue) || const DeepCollectionEquality().equals(other.eToValue, eToValue)) &&
            (identical(other.fFromValue, fFromValue) || const DeepCollectionEquality().equals(other.fFromValue, fFromValue)) &&
            (identical(other.fToValue, fToValue) || const DeepCollectionEquality().equals(other.fToValue, fToValue)) &&
            (identical(other.gFromValue, gFromValue) || const DeepCollectionEquality().equals(other.gFromValue, gFromValue)) &&
            (identical(other.gToValue, gToValue) || const DeepCollectionEquality().equals(other.gToValue, gToValue)) &&
            (identical(other.stepPreScan, stepPreScan) || const DeepCollectionEquality().equals(other.stepPreScan, stepPreScan)) &&
            (identical(other.allowStepPreScan, allowStepPreScan) || const DeepCollectionEquality().equals(other.allowStepPreScan, allowStepPreScan)) &&
            (identical(other.stepInitiate, stepInitiate) || const DeepCollectionEquality().equals(other.stepInitiate, stepInitiate)) &&
            (identical(other.allowStepInitiate, allowStepInitiate) || const DeepCollectionEquality().equals(other.allowStepInitiate, allowStepInitiate)) &&
            (identical(other.stepPrintCountSheets, stepPrintCountSheets) || const DeepCollectionEquality().equals(other.stepPrintCountSheets, stepPrintCountSheets)) &&
            (identical(other.allowStepPrintCountSheets, allowStepPrintCountSheets) || const DeepCollectionEquality().equals(other.allowStepPrintCountSheets, allowStepPrintCountSheets)) &&
            (identical(other.allowStepPrintPrescanProgress, allowStepPrintPrescanProgress) || const DeepCollectionEquality().equals(other.allowStepPrintPrescanProgress, allowStepPrintPrescanProgress)) &&
            (identical(other.stepCount, stepCount) || const DeepCollectionEquality().equals(other.stepCount, stepCount)) &&
            (identical(other.allowStepCount, allowStepCount) || const DeepCollectionEquality().equals(other.allowStepCount, allowStepCount)) &&
            (identical(other.stepPrintExceptionReport, stepPrintExceptionReport) || const DeepCollectionEquality().equals(other.stepPrintExceptionReport, stepPrintExceptionReport)) &&
            (identical(other.allowStepPrintExceptionReport, allowStepPrintExceptionReport) || const DeepCollectionEquality().equals(other.allowStepPrintExceptionReport, allowStepPrintExceptionReport)) &&
            (identical(other.stepPrintDiscrepancyReport, stepPrintDiscrepancyReport) || const DeepCollectionEquality().equals(other.stepPrintDiscrepancyReport, stepPrintDiscrepancyReport)) &&
            (identical(other.allowStepPrintDiscrepancyReport, allowStepPrintDiscrepancyReport) || const DeepCollectionEquality().equals(other.allowStepPrintDiscrepancyReport, allowStepPrintDiscrepancyReport)) &&
            (identical(other.stepRecount, stepRecount) || const DeepCollectionEquality().equals(other.stepRecount, stepRecount)) &&
            (identical(other.allowStepRecount, allowStepRecount) || const DeepCollectionEquality().equals(other.allowStepRecount, allowStepRecount)) &&
            (identical(other.stepPrintRecountAnalysisReport, stepPrintRecountAnalysisReport) || const DeepCollectionEquality().equals(other.stepPrintRecountAnalysisReport, stepPrintRecountAnalysisReport)) &&
            (identical(other.allowStepPrintRecountAnalysisReport, allowStepPrintRecountAnalysisReport) || const DeepCollectionEquality().equals(other.allowStepPrintRecountAnalysisReport, allowStepPrintRecountAnalysisReport)) &&
            (identical(other.stepPrintReconciliationReport, stepPrintReconciliationReport) || const DeepCollectionEquality().equals(other.stepPrintReconciliationReport, stepPrintReconciliationReport)) &&
            (identical(other.allowStepPrintReconciliationReport, allowStepPrintReconciliationReport) || const DeepCollectionEquality().equals(other.allowStepPrintReconciliationReport, allowStepPrintReconciliationReport)) &&
            (identical(other.stepItemsAdded, stepItemsAdded) || const DeepCollectionEquality().equals(other.stepItemsAdded, stepItemsAdded)) &&
            (identical(other.allowStepItemsAdded, allowStepItemsAdded) || const DeepCollectionEquality().equals(other.allowStepItemsAdded, allowStepItemsAdded)) &&
            (identical(other.stepApproveCounts, stepApproveCounts) || const DeepCollectionEquality().equals(other.stepApproveCounts, stepApproveCounts)) &&
            (identical(other.allowStepApproveCounts, allowStepApproveCounts) || const DeepCollectionEquality().equals(other.allowStepApproveCounts, allowStepApproveCounts)) &&
            (identical(other.stepClose, stepClose) || const DeepCollectionEquality().equals(other.stepClose, stepClose)) &&
            (identical(other.allowStepClose, allowStepClose) || const DeepCollectionEquality().equals(other.allowStepClose, allowStepClose)) &&
            (identical(other.stepCloseWithoutAdjustments, stepCloseWithoutAdjustments) || const DeepCollectionEquality().equals(other.stepCloseWithoutAdjustments, stepCloseWithoutAdjustments)) &&
            (identical(other.allowStepCloseWithoutAdjustments, allowStepCloseWithoutAdjustments) || const DeepCollectionEquality().equals(other.allowStepCloseWithoutAdjustments, allowStepCloseWithoutAdjustments)) &&
            (identical(other.closedWithAdjustments, closedWithAdjustments) || const DeepCollectionEquality().equals(other.closedWithAdjustments, closedWithAdjustments)) &&
            (identical(other.closedWithOutAdjustments, closedWithOutAdjustments) || const DeepCollectionEquality().equals(other.closedWithOutAdjustments, closedWithOutAdjustments)) &&
            (identical(other.allowStepPrintResults, allowStepPrintResults) || const DeepCollectionEquality().equals(other.allowStepPrintResults, allowStepPrintResults)) &&
            (identical(other.status, status) || const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.cycleLastCounted, cycleLastCounted) || const DeepCollectionEquality().equals(other.cycleLastCounted, cycleLastCounted)) &&
            (identical(other.cycleTrackedBy, cycleTrackedBy) || const DeepCollectionEquality().equals(other.cycleTrackedBy, cycleTrackedBy)) &&
            (identical(other.cycleAisle, cycleAisle) || const DeepCollectionEquality().equals(other.cycleAisle, cycleAisle)) &&
            (identical(other.cycleShelf, cycleShelf) || const DeepCollectionEquality().equals(other.cycleShelf, cycleShelf)) &&
            (identical(other.cycleOnlyIncludeInventoryWithNonZeroQuantity, cycleOnlyIncludeInventoryWithNonZeroQuantity) || const DeepCollectionEquality().equals(other.cycleOnlyIncludeInventoryWithNonZeroQuantity, cycleOnlyIncludeInventoryWithNonZeroQuantity)) &&
            (identical(other.approvedPurchaseCost, approvedPurchaseCost) || const DeepCollectionEquality().equals(other.approvedPurchaseCost, approvedPurchaseCost)) &&
            (identical(other.countInventoryThatIsOut, countInventoryThatIsOut) || const DeepCollectionEquality().equals(other.countInventoryThatIsOut, countInventoryThatIsOut)) &&
            (identical(other.facilitiesInventory, facilitiesInventory) || const DeepCollectionEquality().equals(other.facilitiesInventory, facilitiesInventory)) &&
            (identical(other.presInitializeAutomaticallyCountInventoryThatIsOut, presInitializeAutomaticallyCountInventoryThatIsOut) || const DeepCollectionEquality().equals(other.presInitializeAutomaticallyCountInventoryThatIsOut, presInitializeAutomaticallyCountInventoryThatIsOut)) &&
            (identical(other.cycleIncludeOwned, cycleIncludeOwned) || const DeepCollectionEquality().equals(other.cycleIncludeOwned, cycleIncludeOwned)) &&
            (identical(other.cycleIncludeConsigned, cycleIncludeConsigned) || const DeepCollectionEquality().equals(other.cycleIncludeConsigned, cycleIncludeConsigned)) &&
            (identical(other.hideConsigned, hideConsigned) || const DeepCollectionEquality().equals(other.hideConsigned, hideConsigned)) &&
            (identical(other.selectitemsbyNotUsed, selectitemsbyNotUsed) || const DeepCollectionEquality().equals(other.selectitemsbyNotUsed, selectitemsbyNotUsed)) &&
            (identical(other.excludeInventoryWithNoAvailabilityCheck, excludeInventoryWithNoAvailabilityCheck) || const DeepCollectionEquality().equals(other.excludeInventoryWithNoAvailabilityCheck, excludeInventoryWithNoAvailabilityCheck)) &&
            (identical(other.approvedByUserId, approvedByUserId) || const DeepCollectionEquality().equals(other.approvedByUserId, approvedByUserId)) &&
            (identical(other.approvedByUser, approvedByUser) || const DeepCollectionEquality().equals(other.approvedByUser, approvedByUser)) &&
            (identical(other.approveDate, approveDate) || const DeepCollectionEquality().equals(other.approveDate, approveDate)) &&
            (identical(other.approveTime, approveTime) || const DeepCollectionEquality().equals(other.approveTime, approveTime)) &&
            (identical(other.inputByUserId, inputByUserId) || const DeepCollectionEquality().equals(other.inputByUserId, inputByUserId)) &&
            (identical(other.inputDate, inputDate) || const DeepCollectionEquality().equals(other.inputDate, inputDate)) &&
            (identical(other.inputTime, inputTime) || const DeepCollectionEquality().equals(other.inputTime, inputTime)) &&
            (identical(other.inactive, inactive) || const DeepCollectionEquality().equals(other.inactive, inactive)) &&
            (identical(other.replaceCounts, replaceCounts) || const DeepCollectionEquality().equals(other.replaceCounts, replaceCounts)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventory {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventory copyWith(
      {String? physicalInventoryId,
      String? officeLocationId,
      String? officeLocation,
      String? officeLocationCode,
      String? dealId,
      String? scheduleDate,
      String? preScanDateTime,
      String? initiateDateTime,
      String? physicalInventoryNumber,
      String? description,
      String? countType,
      String? warehouseId,
      String? warehouseCode,
      String? warehouse,
      String? inventoryTypeId,
      String? inventoryType,
      String? categoryId,
      String? category,
      String? subCategoryId,
      String? subCategory,
      String? recType,
      String? recTypeDisplay,
      String? rank,
      bool? cycleRankA,
      bool? cycleRankB,
      bool? cycleRankC,
      bool? cycleRankD,
      bool? cycleRankE,
      bool? cycleRankF,
      bool? cycleRankG,
      double? aFromValue,
      double? aToValue,
      double? bFromValue,
      double? bToValue,
      double? cFromValue,
      double? cToValue,
      double? dFromValue,
      double? dToValue,
      double? eFromValue,
      double? eToValue,
      double? fFromValue,
      double? fToValue,
      double? gFromValue,
      double? gToValue,
      int? stepPreScan,
      bool? allowStepPreScan,
      int? stepInitiate,
      bool? allowStepInitiate,
      int? stepPrintCountSheets,
      bool? allowStepPrintCountSheets,
      bool? allowStepPrintPrescanProgress,
      int? stepCount,
      bool? allowStepCount,
      int? stepPrintExceptionReport,
      bool? allowStepPrintExceptionReport,
      int? stepPrintDiscrepancyReport,
      bool? allowStepPrintDiscrepancyReport,
      int? stepRecount,
      bool? allowStepRecount,
      int? stepPrintRecountAnalysisReport,
      bool? allowStepPrintRecountAnalysisReport,
      int? stepPrintReconciliationReport,
      bool? allowStepPrintReconciliationReport,
      int? stepItemsAdded,
      bool? allowStepItemsAdded,
      int? stepApproveCounts,
      bool? allowStepApproveCounts,
      int? stepClose,
      bool? allowStepClose,
      int? stepCloseWithoutAdjustments,
      bool? allowStepCloseWithoutAdjustments,
      bool? closedWithAdjustments,
      bool? closedWithOutAdjustments,
      bool? allowStepPrintResults,
      String? status,
      String? cycleLastCounted,
      String? cycleTrackedBy,
      String? cycleAisle,
      String? cycleShelf,
      bool? cycleOnlyIncludeInventoryWithNonZeroQuantity,
      bool? approvedPurchaseCost,
      bool? countInventoryThatIsOut,
      bool? facilitiesInventory,
      bool? presInitializeAutomaticallyCountInventoryThatIsOut,
      bool? cycleIncludeOwned,
      bool? cycleIncludeConsigned,
      bool? hideConsigned,
      bool? selectitemsbyNotUsed,
      bool? excludeInventoryWithNoAvailabilityCheck,
      String? approvedByUserId,
      String? approvedByUser,
      String? approveDate,
      String? approveTime,
      String? inputByUserId,
      String? inputDate,
      String? inputTime,
      bool? inactive,
      bool? replaceCounts,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventory(
        physicalInventoryId: physicalInventoryId ?? this.physicalInventoryId,
        officeLocationId: officeLocationId ?? this.officeLocationId,
        officeLocation: officeLocation ?? this.officeLocation,
        officeLocationCode: officeLocationCode ?? this.officeLocationCode,
        dealId: dealId ?? this.dealId,
        scheduleDate: scheduleDate ?? this.scheduleDate,
        preScanDateTime: preScanDateTime ?? this.preScanDateTime,
        initiateDateTime: initiateDateTime ?? this.initiateDateTime,
        physicalInventoryNumber:
            physicalInventoryNumber ?? this.physicalInventoryNumber,
        description: description ?? this.description,
        countType: countType ?? this.countType,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        warehouse: warehouse ?? this.warehouse,
        inventoryTypeId: inventoryTypeId ?? this.inventoryTypeId,
        inventoryType: inventoryType ?? this.inventoryType,
        categoryId: categoryId ?? this.categoryId,
        category: category ?? this.category,
        subCategoryId: subCategoryId ?? this.subCategoryId,
        subCategory: subCategory ?? this.subCategory,
        recType: recType ?? this.recType,
        recTypeDisplay: recTypeDisplay ?? this.recTypeDisplay,
        rank: rank ?? this.rank,
        cycleRankA: cycleRankA ?? this.cycleRankA,
        cycleRankB: cycleRankB ?? this.cycleRankB,
        cycleRankC: cycleRankC ?? this.cycleRankC,
        cycleRankD: cycleRankD ?? this.cycleRankD,
        cycleRankE: cycleRankE ?? this.cycleRankE,
        cycleRankF: cycleRankF ?? this.cycleRankF,
        cycleRankG: cycleRankG ?? this.cycleRankG,
        aFromValue: aFromValue ?? this.aFromValue,
        aToValue: aToValue ?? this.aToValue,
        bFromValue: bFromValue ?? this.bFromValue,
        bToValue: bToValue ?? this.bToValue,
        cFromValue: cFromValue ?? this.cFromValue,
        cToValue: cToValue ?? this.cToValue,
        dFromValue: dFromValue ?? this.dFromValue,
        dToValue: dToValue ?? this.dToValue,
        eFromValue: eFromValue ?? this.eFromValue,
        eToValue: eToValue ?? this.eToValue,
        fFromValue: fFromValue ?? this.fFromValue,
        fToValue: fToValue ?? this.fToValue,
        gFromValue: gFromValue ?? this.gFromValue,
        gToValue: gToValue ?? this.gToValue,
        stepPreScan: stepPreScan ?? this.stepPreScan,
        allowStepPreScan: allowStepPreScan ?? this.allowStepPreScan,
        stepInitiate: stepInitiate ?? this.stepInitiate,
        allowStepInitiate: allowStepInitiate ?? this.allowStepInitiate,
        stepPrintCountSheets: stepPrintCountSheets ?? this.stepPrintCountSheets,
        allowStepPrintCountSheets:
            allowStepPrintCountSheets ?? this.allowStepPrintCountSheets,
        allowStepPrintPrescanProgress:
            allowStepPrintPrescanProgress ?? this.allowStepPrintPrescanProgress,
        stepCount: stepCount ?? this.stepCount,
        allowStepCount: allowStepCount ?? this.allowStepCount,
        stepPrintExceptionReport:
            stepPrintExceptionReport ?? this.stepPrintExceptionReport,
        allowStepPrintExceptionReport:
            allowStepPrintExceptionReport ?? this.allowStepPrintExceptionReport,
        stepPrintDiscrepancyReport:
            stepPrintDiscrepancyReport ?? this.stepPrintDiscrepancyReport,
        allowStepPrintDiscrepancyReport: allowStepPrintDiscrepancyReport ??
            this.allowStepPrintDiscrepancyReport,
        stepRecount: stepRecount ?? this.stepRecount,
        allowStepRecount: allowStepRecount ?? this.allowStepRecount,
        stepPrintRecountAnalysisReport: stepPrintRecountAnalysisReport ??
            this.stepPrintRecountAnalysisReport,
        allowStepPrintRecountAnalysisReport:
            allowStepPrintRecountAnalysisReport ??
                this.allowStepPrintRecountAnalysisReport,
        stepPrintReconciliationReport:
            stepPrintReconciliationReport ?? this.stepPrintReconciliationReport,
        allowStepPrintReconciliationReport:
            allowStepPrintReconciliationReport ??
                this.allowStepPrintReconciliationReport,
        stepItemsAdded: stepItemsAdded ?? this.stepItemsAdded,
        allowStepItemsAdded: allowStepItemsAdded ?? this.allowStepItemsAdded,
        stepApproveCounts: stepApproveCounts ?? this.stepApproveCounts,
        allowStepApproveCounts:
            allowStepApproveCounts ?? this.allowStepApproveCounts,
        stepClose: stepClose ?? this.stepClose,
        allowStepClose: allowStepClose ?? this.allowStepClose,
        stepCloseWithoutAdjustments:
            stepCloseWithoutAdjustments ?? this.stepCloseWithoutAdjustments,
        allowStepCloseWithoutAdjustments: allowStepCloseWithoutAdjustments ??
            this.allowStepCloseWithoutAdjustments,
        closedWithAdjustments:
            closedWithAdjustments ?? this.closedWithAdjustments,
        closedWithOutAdjustments:
            closedWithOutAdjustments ?? this.closedWithOutAdjustments,
        allowStepPrintResults:
            allowStepPrintResults ?? this.allowStepPrintResults,
        status: status ?? this.status,
        cycleLastCounted: cycleLastCounted ?? this.cycleLastCounted,
        cycleTrackedBy: cycleTrackedBy ?? this.cycleTrackedBy,
        cycleAisle: cycleAisle ?? this.cycleAisle,
        cycleShelf: cycleShelf ?? this.cycleShelf,
        cycleOnlyIncludeInventoryWithNonZeroQuantity:
            cycleOnlyIncludeInventoryWithNonZeroQuantity ??
                this.cycleOnlyIncludeInventoryWithNonZeroQuantity,
        approvedPurchaseCost: approvedPurchaseCost ?? this.approvedPurchaseCost,
        countInventoryThatIsOut:
            countInventoryThatIsOut ?? this.countInventoryThatIsOut,
        facilitiesInventory: facilitiesInventory ?? this.facilitiesInventory,
        presInitializeAutomaticallyCountInventoryThatIsOut:
            presInitializeAutomaticallyCountInventoryThatIsOut ??
                this.presInitializeAutomaticallyCountInventoryThatIsOut,
        cycleIncludeOwned: cycleIncludeOwned ?? this.cycleIncludeOwned,
        cycleIncludeConsigned:
            cycleIncludeConsigned ?? this.cycleIncludeConsigned,
        hideConsigned: hideConsigned ?? this.hideConsigned,
        selectitemsbyNotUsed: selectitemsbyNotUsed ?? this.selectitemsbyNotUsed,
        excludeInventoryWithNoAvailabilityCheck:
            excludeInventoryWithNoAvailabilityCheck ??
                this.excludeInventoryWithNoAvailabilityCheck,
        approvedByUserId: approvedByUserId ?? this.approvedByUserId,
        approvedByUser: approvedByUser ?? this.approvedByUser,
        approveDate: approveDate ?? this.approveDate,
        approveTime: approveTime ?? this.approveTime,
        inputByUserId: inputByUserId ?? this.inputByUserId,
        inputDate: inputDate ?? this.inputDate,
        inputTime: inputTime ?? this.inputTime,
        inactive: inactive ?? this.inactive,
        replaceCounts: replaceCounts ?? this.replaceCounts,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostRequest {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostRequest({
    this.isGetValueOnly,
    this.physicalInventoryId,
    this.approvedPurchaseCost,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostRequestFromJson(
          json);

  @JsonKey(name: 'IsGetValueOnly')
  final bool? isGetValueOnly;
  @JsonKey(name: 'PhysicalInventoryId')
  final String? physicalInventoryId;
  @JsonKey(name: 'ApprovedPurchaseCost')
  final bool? approvedPurchaseCost;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostRequest &&
            (identical(other.isGetValueOnly, isGetValueOnly) ||
                const DeepCollectionEquality()
                    .equals(other.isGetValueOnly, isGetValueOnly)) &&
            (identical(other.physicalInventoryId, physicalInventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.physicalInventoryId, physicalInventoryId)) &&
            (identical(other.approvedPurchaseCost, approvedPurchaseCost) ||
                const DeepCollectionEquality()
                    .equals(other.approvedPurchaseCost, approvedPurchaseCost)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostRequestExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostRequest {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostRequest
      copyWith(
          {bool? isGetValueOnly,
          String? physicalInventoryId,
          bool? approvedPurchaseCost}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostRequest(
        isGetValueOnly: isGetValueOnly ?? this.isGetValueOnly,
        physicalInventoryId: physicalInventoryId ?? this.physicalInventoryId,
        approvedPurchaseCost:
            approvedPurchaseCost ?? this.approvedPurchaseCost);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostResponse {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostResponse({
    this.approvedPurchaseCost,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostResponseFromJson(
          json);

  @JsonKey(name: 'ApprovedPurchaseCost')
  final bool? approvedPurchaseCost;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostResponse &&
            (identical(other.approvedPurchaseCost, approvedPurchaseCost) ||
                const DeepCollectionEquality()
                    .equals(other.approvedPurchaseCost, approvedPurchaseCost)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostResponseExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostResponse {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostResponse
      copyWith({bool? approvedPurchaseCost}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApprovePurchaseCostResponse(
        approvedPurchaseCost:
            approvedPurchaseCost ?? this.approvedPurchaseCost);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveRequest {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveRequest({
    this.physicalInventoryId,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveRequestFromJson(
          json);

  @JsonKey(name: 'PhysicalInventoryId')
  final String? physicalInventoryId;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveRequest &&
            (identical(other.physicalInventoryId, physicalInventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.physicalInventoryId, physicalInventoryId)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveRequestExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveRequest {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveRequest
      copyWith({String? physicalInventoryId}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveRequest(
        physicalInventoryId: physicalInventoryId ?? this.physicalInventoryId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveResponse {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveResponse({
    this.status,
    this.success,
    this.msg,
    this.approved,
    this.message,
    this.$status,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'Approved')
  final bool? approved;
  @JsonKey(name: 'Message')
  final String? message;
  @JsonKey(name: 'Status')
  final int? $status;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.approved, approved) ||
                const DeepCollectionEquality()
                    .equals(other.approved, approved)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.$status, $status) ||
                const DeepCollectionEquality().equals(other.$status, $status)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveResponseExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveResponse {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveResponse
      copyWith(
          {int? status,
          bool? success,
          String? msg,
          bool? approved,
          String? message,
          int? $status}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryApproveResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        approved: approved ?? this.approved,
        message: message ?? this.message,
        $status: $status ?? this.$status);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseRequest {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseRequest({
    this.physicalInventoryId,
    this.addAndRetireInventory,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseRequestFromJson(
          json);

  @JsonKey(name: 'PhysicalInventoryId')
  final String? physicalInventoryId;
  @JsonKey(name: 'AddAndRetireInventory')
  final bool? addAndRetireInventory;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseRequest &&
            (identical(other.physicalInventoryId, physicalInventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.physicalInventoryId, physicalInventoryId)) &&
            (identical(other.addAndRetireInventory, addAndRetireInventory) ||
                const DeepCollectionEquality().equals(
                    other.addAndRetireInventory, addAndRetireInventory)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseRequestExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseRequest {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseRequest copyWith(
      {String? physicalInventoryId, bool? addAndRetireInventory}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseRequest(
        physicalInventoryId: physicalInventoryId ?? this.physicalInventoryId,
        addAndRetireInventory:
            addAndRetireInventory ?? this.addAndRetireInventory);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseResponse {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseResponse({
    this.status,
    this.success,
    this.msg,
    this.closed,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'Closed')
  final bool? closed;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.closed, closed) ||
                const DeepCollectionEquality().equals(other.closed, closed)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseResponseExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseResponse {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseResponse
      copyWith({int? status, bool? success, String? msg, bool? closed}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCloseResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        closed: closed ?? this.closed);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemRequest {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemRequest({
    this.physicalInventoryId,
    this.code,
    this.quantity,
    this.replace,
    this.consignorId,
    this.countedSpaceId,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemRequestFromJson(
          json);

  @JsonKey(name: 'PhysicalInventoryId')
  final String? physicalInventoryId;
  @JsonKey(name: 'Code')
  final String? code;
  @JsonKey(name: 'Quantity')
  final double? quantity;
  @JsonKey(name: 'Replace')
  final bool? replace;
  @JsonKey(name: 'ConsignorId')
  final String? consignorId;
  @JsonKey(name: 'CountedSpaceId')
  final String? countedSpaceId;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemRequest &&
            (identical(other.physicalInventoryId, physicalInventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.physicalInventoryId, physicalInventoryId)) &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)) &&
            (identical(other.replace, replace) ||
                const DeepCollectionEquality()
                    .equals(other.replace, replace)) &&
            (identical(other.consignorId, consignorId) ||
                const DeepCollectionEquality()
                    .equals(other.consignorId, consignorId)) &&
            (identical(other.countedSpaceId, countedSpaceId) ||
                const DeepCollectionEquality()
                    .equals(other.countedSpaceId, countedSpaceId)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemRequestExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemRequest {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemRequest
      copyWith(
          {String? physicalInventoryId,
          String? code,
          double? quantity,
          bool? replace,
          String? consignorId,
          String? countedSpaceId}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemRequest(
        physicalInventoryId: physicalInventoryId ?? this.physicalInventoryId,
        code: code ?? this.code,
        quantity: quantity ?? this.quantity,
        replace: replace ?? this.replace,
        consignorId: consignorId ?? this.consignorId,
        countedSpaceId: countedSpaceId ?? this.countedSpaceId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemResponse {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemResponse({
    this.status,
    this.success,
    this.msg,
    this.inventoryId,
    this.iCode,
    this.trackedBy,
    this.description,
    this.itemId,
    this.consignor,
    this.showAddReplace,
    this.countedQuantity,
    this.genericMessage,
    this.physicalItemId,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'TrackedBy')
  final String? trackedBy;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'ItemId')
  final String? itemId;
  @JsonKey(name: 'Consignor')
  final String? consignor;
  @JsonKey(name: 'ShowAddReplace')
  final bool? showAddReplace;
  @JsonKey(name: 'CountedQuantity')
  final double? countedQuantity;
  @JsonKey(name: 'GenericMessage')
  final String? genericMessage;
  @JsonKey(name: 'PhysicalItemId')
  final int? physicalItemId;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.trackedBy, trackedBy) ||
                const DeepCollectionEquality()
                    .equals(other.trackedBy, trackedBy)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.itemId, itemId) ||
                const DeepCollectionEquality().equals(other.itemId, itemId)) &&
            (identical(other.consignor, consignor) ||
                const DeepCollectionEquality()
                    .equals(other.consignor, consignor)) &&
            (identical(other.showAddReplace, showAddReplace) ||
                const DeepCollectionEquality()
                    .equals(other.showAddReplace, showAddReplace)) &&
            (identical(other.countedQuantity, countedQuantity) ||
                const DeepCollectionEquality()
                    .equals(other.countedQuantity, countedQuantity)) &&
            (identical(other.genericMessage, genericMessage) ||
                const DeepCollectionEquality()
                    .equals(other.genericMessage, genericMessage)) &&
            (identical(other.physicalItemId, physicalItemId) ||
                const DeepCollectionEquality()
                    .equals(other.physicalItemId, physicalItemId)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemResponseExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemResponse {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemResponse
      copyWith(
          {int? status,
          bool? success,
          String? msg,
          String? inventoryId,
          String? iCode,
          String? trackedBy,
          String? description,
          String? itemId,
          String? consignor,
          bool? showAddReplace,
          double? countedQuantity,
          String? genericMessage,
          int? physicalItemId}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountItemResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        inventoryId: inventoryId ?? this.inventoryId,
        iCode: iCode ?? this.iCode,
        trackedBy: trackedBy ?? this.trackedBy,
        description: description ?? this.description,
        itemId: itemId ?? this.itemId,
        consignor: consignor ?? this.consignor,
        showAddReplace: showAddReplace ?? this.showAddReplace,
        countedQuantity: countedQuantity ?? this.countedQuantity,
        genericMessage: genericMessage ?? this.genericMessage,
        physicalItemId: physicalItemId ?? this.physicalItemId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantity {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantity({
    this.physicalInventoryItemId,
    this.inventoryId,
    this.inventoryType,
    this.category,
    this.iCode,
    this.description,
    this.aisleLocation,
    this.shelfLocation,
    this.categoryId,
    this.categoryOrderBy,
    this.inventoryTypeOrderBy,
    this.inventoryTypeId,
    this.unitId,
    this.weightUnitId,
    this.lengthUnitId,
    this.sessionQuantity,
    this.quantity,
    this.currentQuantity,
    this.weight,
    this.length,
    this.unit,
    this.weightUnit,
    this.lengthUnit,
    this.currentSpaceId,
    this.currentSpace,
    this.isRecount,
    this.consignorId,
    this.consignor,
    this.physicalInventoryId,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantity.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantityFromJson(
          json);

  @JsonKey(name: 'PhysicalInventoryItemId')
  final int? physicalInventoryItemId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'InventoryType')
  final String? inventoryType;
  @JsonKey(name: 'Category')
  final String? category;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AisleLocation')
  final String? aisleLocation;
  @JsonKey(name: 'ShelfLocation')
  final String? shelfLocation;
  @JsonKey(name: 'CategoryId')
  final String? categoryId;
  @JsonKey(name: 'CategoryOrderBy')
  final double? categoryOrderBy;
  @JsonKey(name: 'InventoryTypeOrderBy')
  final int? inventoryTypeOrderBy;
  @JsonKey(name: 'InventoryTypeId')
  final String? inventoryTypeId;
  @JsonKey(name: 'UnitId')
  final String? unitId;
  @JsonKey(name: 'WeightUnitId')
  final String? weightUnitId;
  @JsonKey(name: 'LengthUnitId')
  final String? lengthUnitId;
  @JsonKey(name: 'SessionQuantity')
  final int? sessionQuantity;
  @JsonKey(name: 'Quantity')
  final int? quantity;
  @JsonKey(name: 'CurrentQuantity')
  final int? currentQuantity;
  @JsonKey(name: 'Weight')
  final int? weight;
  @JsonKey(name: 'Length')
  final int? length;
  @JsonKey(name: 'Unit')
  final String? unit;
  @JsonKey(name: 'WeightUnit')
  final String? weightUnit;
  @JsonKey(name: 'LengthUnit')
  final String? lengthUnit;
  @JsonKey(name: 'CurrentSpaceId')
  final String? currentSpaceId;
  @JsonKey(name: 'CurrentSpace')
  final String? currentSpace;
  @JsonKey(name: 'IsRecount')
  final bool? isRecount;
  @JsonKey(name: 'ConsignorId')
  final String? consignorId;
  @JsonKey(name: 'Consignor')
  final String? consignor;
  @JsonKey(name: 'PhysicalInventoryId')
  final String? physicalInventoryId;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantityFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantityToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantityToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantity &&
            (identical(other.physicalInventoryItemId, physicalInventoryItemId) ||
                const DeepCollectionEquality().equals(
                    other.physicalInventoryItemId, physicalInventoryItemId)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.inventoryType, inventoryType) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryType, inventoryType)) &&
            (identical(other.category, category) ||
                const DeepCollectionEquality()
                    .equals(other.category, category)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.aisleLocation, aisleLocation) ||
                const DeepCollectionEquality()
                    .equals(other.aisleLocation, aisleLocation)) &&
            (identical(other.shelfLocation, shelfLocation) ||
                const DeepCollectionEquality()
                    .equals(other.shelfLocation, shelfLocation)) &&
            (identical(other.categoryId, categoryId) ||
                const DeepCollectionEquality()
                    .equals(other.categoryId, categoryId)) &&
            (identical(other.categoryOrderBy, categoryOrderBy) ||
                const DeepCollectionEquality()
                    .equals(other.categoryOrderBy, categoryOrderBy)) &&
            (identical(other.inventoryTypeOrderBy, inventoryTypeOrderBy) ||
                const DeepCollectionEquality().equals(
                    other.inventoryTypeOrderBy, inventoryTypeOrderBy)) &&
            (identical(other.inventoryTypeId, inventoryTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryTypeId, inventoryTypeId)) &&
            (identical(other.unitId, unitId) ||
                const DeepCollectionEquality().equals(other.unitId, unitId)) &&
            (identical(other.weightUnitId, weightUnitId) ||
                const DeepCollectionEquality()
                    .equals(other.weightUnitId, weightUnitId)) &&
            (identical(other.lengthUnitId, lengthUnitId) || const DeepCollectionEquality().equals(other.lengthUnitId, lengthUnitId)) &&
            (identical(other.sessionQuantity, sessionQuantity) || const DeepCollectionEquality().equals(other.sessionQuantity, sessionQuantity)) &&
            (identical(other.quantity, quantity) || const DeepCollectionEquality().equals(other.quantity, quantity)) &&
            (identical(other.currentQuantity, currentQuantity) || const DeepCollectionEquality().equals(other.currentQuantity, currentQuantity)) &&
            (identical(other.weight, weight) || const DeepCollectionEquality().equals(other.weight, weight)) &&
            (identical(other.length, length) || const DeepCollectionEquality().equals(other.length, length)) &&
            (identical(other.unit, unit) || const DeepCollectionEquality().equals(other.unit, unit)) &&
            (identical(other.weightUnit, weightUnit) || const DeepCollectionEquality().equals(other.weightUnit, weightUnit)) &&
            (identical(other.lengthUnit, lengthUnit) || const DeepCollectionEquality().equals(other.lengthUnit, lengthUnit)) &&
            (identical(other.currentSpaceId, currentSpaceId) || const DeepCollectionEquality().equals(other.currentSpaceId, currentSpaceId)) &&
            (identical(other.currentSpace, currentSpace) || const DeepCollectionEquality().equals(other.currentSpace, currentSpace)) &&
            (identical(other.isRecount, isRecount) || const DeepCollectionEquality().equals(other.isRecount, isRecount)) &&
            (identical(other.consignorId, consignorId) || const DeepCollectionEquality().equals(other.consignorId, consignorId)) &&
            (identical(other.consignor, consignor) || const DeepCollectionEquality().equals(other.consignor, consignor)) &&
            (identical(other.physicalInventoryId, physicalInventoryId) || const DeepCollectionEquality().equals(other.physicalInventoryId, physicalInventoryId)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantityExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantity {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantity
      copyWith(
          {int? physicalInventoryItemId,
          String? inventoryId,
          String? inventoryType,
          String? category,
          String? iCode,
          String? description,
          String? aisleLocation,
          String? shelfLocation,
          String? categoryId,
          double? categoryOrderBy,
          int? inventoryTypeOrderBy,
          String? inventoryTypeId,
          String? unitId,
          String? weightUnitId,
          String? lengthUnitId,
          int? sessionQuantity,
          int? quantity,
          int? currentQuantity,
          int? weight,
          int? length,
          String? unit,
          String? weightUnit,
          String? lengthUnit,
          String? currentSpaceId,
          String? currentSpace,
          bool? isRecount,
          String? consignorId,
          String? consignor,
          String? physicalInventoryId,
          String? recordTitle,
          List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
          List<FwStandardDataFwCustomValue>? custom,
          List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountQuantity(
        physicalInventoryItemId:
            physicalInventoryItemId ?? this.physicalInventoryItemId,
        inventoryId: inventoryId ?? this.inventoryId,
        inventoryType: inventoryType ?? this.inventoryType,
        category: category ?? this.category,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        aisleLocation: aisleLocation ?? this.aisleLocation,
        shelfLocation: shelfLocation ?? this.shelfLocation,
        categoryId: categoryId ?? this.categoryId,
        categoryOrderBy: categoryOrderBy ?? this.categoryOrderBy,
        inventoryTypeOrderBy: inventoryTypeOrderBy ?? this.inventoryTypeOrderBy,
        inventoryTypeId: inventoryTypeId ?? this.inventoryTypeId,
        unitId: unitId ?? this.unitId,
        weightUnitId: weightUnitId ?? this.weightUnitId,
        lengthUnitId: lengthUnitId ?? this.lengthUnitId,
        sessionQuantity: sessionQuantity ?? this.sessionQuantity,
        quantity: quantity ?? this.quantity,
        currentQuantity: currentQuantity ?? this.currentQuantity,
        weight: weight ?? this.weight,
        length: length ?? this.length,
        unit: unit ?? this.unit,
        weightUnit: weightUnit ?? this.weightUnit,
        lengthUnit: lengthUnit ?? this.lengthUnit,
        currentSpaceId: currentSpaceId ?? this.currentSpaceId,
        currentSpace: currentSpace ?? this.currentSpace,
        isRecount: isRecount ?? this.isRecount,
        consignorId: consignorId ?? this.consignorId,
        consignor: consignor ?? this.consignor,
        physicalInventoryId: physicalInventoryId ?? this.physicalInventoryId,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerial {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerial({
    this.physicalInventoryId,
    this.inventoryId,
    this.inventoryType,
    this.category,
    this.iCode,
    this.description,
    this.aisleLocation,
    this.shelfLocation,
    this.categoryId,
    this.categoryOrderBy,
    this.inventoryTypeOrderBy,
    this.inventoryTypeId,
    this.unitId,
    this.unit,
    this.currentSpaceId,
    this.currentSpace,
    this.consignorId,
    this.consignor,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerial.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerialFromJson(
          json);

  @JsonKey(name: 'PhysicalInventoryId')
  final String? physicalInventoryId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'InventoryType')
  final String? inventoryType;
  @JsonKey(name: 'Category')
  final String? category;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AisleLocation')
  final String? aisleLocation;
  @JsonKey(name: 'ShelfLocation')
  final String? shelfLocation;
  @JsonKey(name: 'CategoryId')
  final String? categoryId;
  @JsonKey(name: 'CategoryOrderBy')
  final double? categoryOrderBy;
  @JsonKey(name: 'InventoryTypeOrderBy')
  final int? inventoryTypeOrderBy;
  @JsonKey(name: 'InventoryTypeId')
  final String? inventoryTypeId;
  @JsonKey(name: 'UnitId')
  final String? unitId;
  @JsonKey(name: 'Unit')
  final String? unit;
  @JsonKey(name: 'CurrentSpaceId')
  final String? currentSpaceId;
  @JsonKey(name: 'CurrentSpace')
  final String? currentSpace;
  @JsonKey(name: 'ConsignorId')
  final String? consignorId;
  @JsonKey(name: 'Consignor')
  final String? consignor;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerialFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerialToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerialToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerial &&
            (identical(other.physicalInventoryId, physicalInventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.physicalInventoryId, physicalInventoryId)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.inventoryType, inventoryType) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryType, inventoryType)) &&
            (identical(other.category, category) ||
                const DeepCollectionEquality()
                    .equals(other.category, category)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.aisleLocation, aisleLocation) ||
                const DeepCollectionEquality()
                    .equals(other.aisleLocation, aisleLocation)) &&
            (identical(other.shelfLocation, shelfLocation) ||
                const DeepCollectionEquality()
                    .equals(other.shelfLocation, shelfLocation)) &&
            (identical(other.categoryId, categoryId) ||
                const DeepCollectionEquality()
                    .equals(other.categoryId, categoryId)) &&
            (identical(other.categoryOrderBy, categoryOrderBy) ||
                const DeepCollectionEquality()
                    .equals(other.categoryOrderBy, categoryOrderBy)) &&
            (identical(other.inventoryTypeOrderBy, inventoryTypeOrderBy) ||
                const DeepCollectionEquality().equals(
                    other.inventoryTypeOrderBy, inventoryTypeOrderBy)) &&
            (identical(other.inventoryTypeId, inventoryTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryTypeId, inventoryTypeId)) &&
            (identical(other.unitId, unitId) ||
                const DeepCollectionEquality().equals(other.unitId, unitId)) &&
            (identical(other.unit, unit) ||
                const DeepCollectionEquality().equals(other.unit, unit)) &&
            (identical(other.currentSpaceId, currentSpaceId) ||
                const DeepCollectionEquality()
                    .equals(other.currentSpaceId, currentSpaceId)) &&
            (identical(other.currentSpace, currentSpace) ||
                const DeepCollectionEquality()
                    .equals(other.currentSpace, currentSpace)) &&
            (identical(other.consignorId, consignorId) ||
                const DeepCollectionEquality()
                    .equals(other.consignorId, consignorId)) &&
            (identical(other.consignor, consignor) || const DeepCollectionEquality().equals(other.consignor, consignor)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerialExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerial {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerial copyWith(
      {String? physicalInventoryId,
      String? inventoryId,
      String? inventoryType,
      String? category,
      String? iCode,
      String? description,
      String? aisleLocation,
      String? shelfLocation,
      String? categoryId,
      double? categoryOrderBy,
      int? inventoryTypeOrderBy,
      String? inventoryTypeId,
      String? unitId,
      String? unit,
      String? currentSpaceId,
      String? currentSpace,
      String? consignorId,
      String? consignor,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryCountSerial(
        physicalInventoryId: physicalInventoryId ?? this.physicalInventoryId,
        inventoryId: inventoryId ?? this.inventoryId,
        inventoryType: inventoryType ?? this.inventoryType,
        category: category ?? this.category,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        aisleLocation: aisleLocation ?? this.aisleLocation,
        shelfLocation: shelfLocation ?? this.shelfLocation,
        categoryId: categoryId ?? this.categoryId,
        categoryOrderBy: categoryOrderBy ?? this.categoryOrderBy,
        inventoryTypeOrderBy: inventoryTypeOrderBy ?? this.inventoryTypeOrderBy,
        inventoryTypeId: inventoryTypeId ?? this.inventoryTypeId,
        unitId: unitId ?? this.unitId,
        unit: unit ?? this.unit,
        currentSpaceId: currentSpaceId ?? this.currentSpaceId,
        currentSpace: currentSpace ?? this.currentSpace,
        consignorId: consignorId ?? this.consignorId,
        consignor: consignor ?? this.consignor,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptions {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptions({
    this.physicalInventoryId,
    this.scannedCode,
    this.iCode,
    this.description,
    this.exception,
    this.inventoryId,
    this.userName,
    this.date,
    this.time,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptions.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptionsFromJson(
          json);

  @JsonKey(name: 'PhysicalInventoryId')
  final String? physicalInventoryId;
  @JsonKey(name: 'ScannedCode')
  final String? scannedCode;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'Exception')
  final String? exception;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'UserName')
  final String? userName;
  @JsonKey(name: 'Date')
  final String? date;
  @JsonKey(name: 'Time')
  final String? time;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptionsFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptionsToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptionsToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptions &&
            (identical(other.physicalInventoryId, physicalInventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.physicalInventoryId, physicalInventoryId)) &&
            (identical(other.scannedCode, scannedCode) ||
                const DeepCollectionEquality()
                    .equals(other.scannedCode, scannedCode)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.exception, exception) ||
                const DeepCollectionEquality()
                    .equals(other.exception, exception)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.userName, userName) ||
                const DeepCollectionEquality()
                    .equals(other.userName, userName)) &&
            (identical(other.date, date) ||
                const DeepCollectionEquality().equals(other.date, date)) &&
            (identical(other.time, time) ||
                const DeepCollectionEquality().equals(other.time, time)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptionsExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptions {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptions copyWith(
      {String? physicalInventoryId,
      String? scannedCode,
      String? iCode,
      String? description,
      String? exception,
      String? inventoryId,
      String? userName,
      String? date,
      String? time,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryExceptions(
        physicalInventoryId: physicalInventoryId ?? this.physicalInventoryId,
        scannedCode: scannedCode ?? this.scannedCode,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        exception: exception ?? this.exception,
        inventoryId: inventoryId ?? this.inventoryId,
        userName: userName ?? this.userName,
        date: date ?? this.date,
        time: time ?? this.time,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateRequest {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateRequest({
    this.physicalInventoryId,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateRequestFromJson(
          json);

  @JsonKey(name: 'PhysicalInventoryId')
  final String? physicalInventoryId;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateRequest &&
            (identical(other.physicalInventoryId, physicalInventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.physicalInventoryId, physicalInventoryId)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateRequestExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateRequest {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateRequest
      copyWith({String? physicalInventoryId}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateRequest(
        physicalInventoryId: physicalInventoryId ?? this.physicalInventoryId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateResponse {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateResponseExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateResponse {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateResponse
      copyWith({int? status, bool? success, String? msg}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryInitiateResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAdded {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAdded({
    this.physicalInventoryId,
    this.inventoryId,
    this.iCode,
    this.description,
    this.orderBy,
    this.owned,
    this.counted,
    this.qty,
    this.extended,
    this.newPurchaseCost,
    this.lastPurchaseCost,
    this.purchaseCurrencyCode,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAdded.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAddedFromJson(
          json);

  @JsonKey(name: 'PhysicalInventoryId')
  final String? physicalInventoryId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'OrderBy')
  final int? orderBy;
  @JsonKey(name: 'Owned')
  final int? owned;
  @JsonKey(name: 'Counted')
  final int? counted;
  @JsonKey(name: 'Qty')
  final int? qty;
  @JsonKey(name: 'Extended')
  final double? extended;
  @JsonKey(name: 'NewPurchaseCost')
  final double? newPurchaseCost;
  @JsonKey(name: 'LastPurchaseCost')
  final double? lastPurchaseCost;
  @JsonKey(name: 'PurchaseCurrencyCode')
  final String? purchaseCurrencyCode;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAddedFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAddedToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAddedToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAdded &&
            (identical(other.physicalInventoryId, physicalInventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.physicalInventoryId, physicalInventoryId)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.orderBy, orderBy) ||
                const DeepCollectionEquality()
                    .equals(other.orderBy, orderBy)) &&
            (identical(other.owned, owned) ||
                const DeepCollectionEquality().equals(other.owned, owned)) &&
            (identical(other.counted, counted) ||
                const DeepCollectionEquality()
                    .equals(other.counted, counted)) &&
            (identical(other.qty, qty) ||
                const DeepCollectionEquality().equals(other.qty, qty)) &&
            (identical(other.extended, extended) ||
                const DeepCollectionEquality()
                    .equals(other.extended, extended)) &&
            (identical(other.newPurchaseCost, newPurchaseCost) ||
                const DeepCollectionEquality()
                    .equals(other.newPurchaseCost, newPurchaseCost)) &&
            (identical(other.lastPurchaseCost, lastPurchaseCost) ||
                const DeepCollectionEquality()
                    .equals(other.lastPurchaseCost, lastPurchaseCost)) &&
            (identical(other.purchaseCurrencyCode, purchaseCurrencyCode) ||
                const DeepCollectionEquality().equals(
                    other.purchaseCurrencyCode, purchaseCurrencyCode)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAddedExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAdded {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAdded copyWith(
      {String? physicalInventoryId,
      String? inventoryId,
      String? iCode,
      String? description,
      int? orderBy,
      int? owned,
      int? counted,
      int? qty,
      double? extended,
      double? newPurchaseCost,
      double? lastPurchaseCost,
      String? purchaseCurrencyCode,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryItemsAdded(
        physicalInventoryId: physicalInventoryId ?? this.physicalInventoryId,
        inventoryId: inventoryId ?? this.inventoryId,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        orderBy: orderBy ?? this.orderBy,
        owned: owned ?? this.owned,
        counted: counted ?? this.counted,
        qty: qty ?? this.qty,
        extended: extended ?? this.extended,
        newPurchaseCost: newPurchaseCost ?? this.newPurchaseCost,
        lastPurchaseCost: lastPurchaseCost ?? this.lastPurchaseCost,
        purchaseCurrencyCode: purchaseCurrencyCode ?? this.purchaseCurrencyCode,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostRequest {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostRequest({
    this.cost,
    this.physicalInventoryId,
    this.masterId,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostRequestFromJson(
          json);

  @JsonKey(name: 'Cost')
  final String? cost;
  @JsonKey(name: 'PhysicalInventoryId')
  final String? physicalInventoryId;
  @JsonKey(name: 'MasterId')
  final String? masterId;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostRequest &&
            (identical(other.cost, cost) ||
                const DeepCollectionEquality().equals(other.cost, cost)) &&
            (identical(other.physicalInventoryId, physicalInventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.physicalInventoryId, physicalInventoryId)) &&
            (identical(other.masterId, masterId) ||
                const DeepCollectionEquality()
                    .equals(other.masterId, masterId)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostRequestExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostRequest {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostRequest
      copyWith({String? cost, String? physicalInventoryId, String? masterId}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostRequest(
        cost: cost ?? this.cost,
        physicalInventoryId: physicalInventoryId ?? this.physicalInventoryId,
        masterId: masterId ?? this.masterId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostResponse {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostResponseExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostResponse {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostResponse
      copyWith({int? status, bool? success, String? msg}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryNewPurchaseCostResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanRequest {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanRequest({
    this.physicalInventoryId,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanRequestFromJson(
          json);

  @JsonKey(name: 'PhysicalInventoryId')
  final String? physicalInventoryId;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanRequest &&
            (identical(other.physicalInventoryId, physicalInventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.physicalInventoryId, physicalInventoryId)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanRequestExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanRequest {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanRequest
      copyWith({String? physicalInventoryId}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanRequest(
        physicalInventoryId: physicalInventoryId ?? this.physicalInventoryId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanResponse {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanResponseExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanResponse {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanResponse
      copyWith({int? status, bool? success, String? msg}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryPrescanResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecount {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecount({
    this.physicalMasterId,
    this.physicalInventoryId,
    this.inventoryId,
    this.iCode,
    this.description,
    this.categoryId,
    this.category,
    this.categoryOrderBy,
    this.inventoryTypeId,
    this.inventoryType,
    this.inventoryTypeOrderBy,
    this.currentSpaceId,
    this.unitId,
    this.unit,
    this.aisleLocation,
    this.shelfLocation,
    this.isRecount,
    this.owned,
    this.onOrder,
    this.inRepair,
    this.counted,
    this.variance,
    this.consignorId,
    this.consignor,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecount.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountFromJson(
          json);

  @JsonKey(name: 'PhysicalMasterId')
  final int? physicalMasterId;
  @JsonKey(name: 'PhysicalInventoryId')
  final String? physicalInventoryId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'CategoryId')
  final String? categoryId;
  @JsonKey(name: 'Category')
  final String? category;
  @JsonKey(name: 'CategoryOrderBy')
  final double? categoryOrderBy;
  @JsonKey(name: 'InventoryTypeId')
  final String? inventoryTypeId;
  @JsonKey(name: 'InventoryType')
  final String? inventoryType;
  @JsonKey(name: 'InventoryTypeOrderBy')
  final int? inventoryTypeOrderBy;
  @JsonKey(name: 'CurrentSpaceId')
  final String? currentSpaceId;
  @JsonKey(name: 'UnitId')
  final String? unitId;
  @JsonKey(name: 'Unit')
  final String? unit;
  @JsonKey(name: 'AisleLocation')
  final String? aisleLocation;
  @JsonKey(name: 'ShelfLocation')
  final String? shelfLocation;
  @JsonKey(name: 'IsRecount')
  final bool? isRecount;
  @JsonKey(name: 'Owned')
  final int? owned;
  @JsonKey(name: 'OnOrder')
  final int? onOrder;
  @JsonKey(name: 'InRepair')
  final int? inRepair;
  @JsonKey(name: 'Counted')
  final int? counted;
  @JsonKey(name: 'Variance')
  final int? variance;
  @JsonKey(name: 'ConsignorId')
  final String? consignorId;
  @JsonKey(name: 'Consignor')
  final String? consignor;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecount &&
            (identical(other.physicalMasterId, physicalMasterId) ||
                const DeepCollectionEquality()
                    .equals(other.physicalMasterId, physicalMasterId)) &&
            (identical(other.physicalInventoryId, physicalInventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.physicalInventoryId, physicalInventoryId)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.categoryId, categoryId) ||
                const DeepCollectionEquality()
                    .equals(other.categoryId, categoryId)) &&
            (identical(other.category, category) ||
                const DeepCollectionEquality()
                    .equals(other.category, category)) &&
            (identical(other.categoryOrderBy, categoryOrderBy) ||
                const DeepCollectionEquality()
                    .equals(other.categoryOrderBy, categoryOrderBy)) &&
            (identical(other.inventoryTypeId, inventoryTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryTypeId, inventoryTypeId)) &&
            (identical(other.inventoryType, inventoryType) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryType, inventoryType)) &&
            (identical(other.inventoryTypeOrderBy, inventoryTypeOrderBy) ||
                const DeepCollectionEquality().equals(
                    other.inventoryTypeOrderBy, inventoryTypeOrderBy)) &&
            (identical(other.currentSpaceId, currentSpaceId) ||
                const DeepCollectionEquality()
                    .equals(other.currentSpaceId, currentSpaceId)) &&
            (identical(other.unitId, unitId) ||
                const DeepCollectionEquality().equals(other.unitId, unitId)) &&
            (identical(other.unit, unit) ||
                const DeepCollectionEquality().equals(other.unit, unit)) &&
            (identical(other.aisleLocation, aisleLocation) ||
                const DeepCollectionEquality()
                    .equals(other.aisleLocation, aisleLocation)) &&
            (identical(other.shelfLocation, shelfLocation) ||
                const DeepCollectionEquality()
                    .equals(other.shelfLocation, shelfLocation)) &&
            (identical(other.isRecount, isRecount) ||
                const DeepCollectionEquality()
                    .equals(other.isRecount, isRecount)) &&
            (identical(other.owned, owned) || const DeepCollectionEquality().equals(other.owned, owned)) &&
            (identical(other.onOrder, onOrder) || const DeepCollectionEquality().equals(other.onOrder, onOrder)) &&
            (identical(other.inRepair, inRepair) || const DeepCollectionEquality().equals(other.inRepair, inRepair)) &&
            (identical(other.counted, counted) || const DeepCollectionEquality().equals(other.counted, counted)) &&
            (identical(other.variance, variance) || const DeepCollectionEquality().equals(other.variance, variance)) &&
            (identical(other.consignorId, consignorId) || const DeepCollectionEquality().equals(other.consignorId, consignorId)) &&
            (identical(other.consignor, consignor) || const DeepCollectionEquality().equals(other.consignor, consignor)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecount {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecount copyWith(
      {int? physicalMasterId,
      String? physicalInventoryId,
      String? inventoryId,
      String? iCode,
      String? description,
      String? categoryId,
      String? category,
      double? categoryOrderBy,
      String? inventoryTypeId,
      String? inventoryType,
      int? inventoryTypeOrderBy,
      String? currentSpaceId,
      String? unitId,
      String? unit,
      String? aisleLocation,
      String? shelfLocation,
      bool? isRecount,
      int? owned,
      int? onOrder,
      int? inRepair,
      int? counted,
      int? variance,
      String? consignorId,
      String? consignor,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecount(
        physicalMasterId: physicalMasterId ?? this.physicalMasterId,
        physicalInventoryId: physicalInventoryId ?? this.physicalInventoryId,
        inventoryId: inventoryId ?? this.inventoryId,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        categoryId: categoryId ?? this.categoryId,
        category: category ?? this.category,
        categoryOrderBy: categoryOrderBy ?? this.categoryOrderBy,
        inventoryTypeId: inventoryTypeId ?? this.inventoryTypeId,
        inventoryType: inventoryType ?? this.inventoryType,
        inventoryTypeOrderBy: inventoryTypeOrderBy ?? this.inventoryTypeOrderBy,
        currentSpaceId: currentSpaceId ?? this.currentSpaceId,
        unitId: unitId ?? this.unitId,
        unit: unit ?? this.unit,
        aisleLocation: aisleLocation ?? this.aisleLocation,
        shelfLocation: shelfLocation ?? this.shelfLocation,
        isRecount: isRecount ?? this.isRecount,
        owned: owned ?? this.owned,
        onOrder: onOrder ?? this.onOrder,
        inRepair: inRepair ?? this.inRepair,
        counted: counted ?? this.counted,
        variance: variance ?? this.variance,
        consignorId: consignorId ?? this.consignorId,
        consignor: consignor ?? this.consignor,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequest {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequest({
    this.physicalInventoryRecountUpdate,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequestFromJson(
          json);

  @JsonKey(name: 'PhysicalInventoryRecountUpdate', defaultValue: <
      WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequestModel>[])
  final List<
          WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequestModel>?
      physicalInventoryRecountUpdate;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequest &&
            (identical(other.physicalInventoryRecountUpdate,
                    physicalInventoryRecountUpdate) ||
                const DeepCollectionEquality().equals(
                    other.physicalInventoryRecountUpdate,
                    physicalInventoryRecountUpdate)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequestExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequest {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequest
      copyWith(
          {List<WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequestModel>?
              physicalInventoryRecountUpdate}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequest(
        physicalInventoryRecountUpdate: physicalInventoryRecountUpdate ??
            this.physicalInventoryRecountUpdate);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequestModel {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequestModel({
    this.physicalMasterId,
    this.isRecount,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequestModel.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequestModelFromJson(
          json);

  @JsonKey(name: 'PhysicalMasterId')
  final String? physicalMasterId;
  @JsonKey(name: 'IsRecount')
  final bool? isRecount;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequestModelFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequestModelToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequestModelToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequestModel &&
            (identical(other.physicalMasterId, physicalMasterId) ||
                const DeepCollectionEquality()
                    .equals(other.physicalMasterId, physicalMasterId)) &&
            (identical(other.isRecount, isRecount) ||
                const DeepCollectionEquality()
                    .equals(other.isRecount, isRecount)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequestModelExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequestModel {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequestModel
      copyWith({String? physicalMasterId, bool? isRecount}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryRecountUpdateRequestModel(
        physicalMasterId: physicalMasterId ?? this.physicalMasterId,
        isRecount: isRecount ?? this.isRecount);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsRequest {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsRequest({
    this.isGetValue,
    this.physicalInventoryId,
    this.replaceCounts,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsRequestFromJson(
          json);

  @JsonKey(name: 'isGetValue')
  final bool? isGetValue;
  @JsonKey(name: 'PhysicalInventoryId')
  final String? physicalInventoryId;
  @JsonKey(name: 'ReplaceCounts')
  final bool? replaceCounts;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsRequest &&
            (identical(other.isGetValue, isGetValue) ||
                const DeepCollectionEquality()
                    .equals(other.isGetValue, isGetValue)) &&
            (identical(other.physicalInventoryId, physicalInventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.physicalInventoryId, physicalInventoryId)) &&
            (identical(other.replaceCounts, replaceCounts) ||
                const DeepCollectionEquality()
                    .equals(other.replaceCounts, replaceCounts)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsRequestExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsRequest {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsRequest
      copyWith(
          {bool? isGetValue,
          String? physicalInventoryId,
          bool? replaceCounts}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsRequest(
        isGetValue: isGetValue ?? this.isGetValue,
        physicalInventoryId: physicalInventoryId ?? this.physicalInventoryId,
        replaceCounts: replaceCounts ?? this.replaceCounts);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsResponse {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsResponse({
    this.status,
    this.success,
    this.msg,
    this.replaceCounts,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'ReplaceCounts')
  final String? replaceCounts;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.replaceCounts, replaceCounts) ||
                const DeepCollectionEquality()
                    .equals(other.replaceCounts, replaceCounts)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsResponseExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsResponse {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsResponse
      copyWith(
          {int? status, bool? success, String? msg, String? replaceCounts}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryReplaceCountsResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        replaceCounts: replaceCounts ?? this.replaceCounts);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusRequest {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusRequest({
    this.physicalInventoryId,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusRequestFromJson(
          json);

  @JsonKey(name: 'PhysicalInventoryId')
  final String? physicalInventoryId;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusRequest &&
            (identical(other.physicalInventoryId, physicalInventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.physicalInventoryId, physicalInventoryId)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusRequestExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusRequest {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusRequest
      copyWith({String? physicalInventoryId}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusRequest(
        physicalInventoryId: physicalInventoryId ?? this.physicalInventoryId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusResponse {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusResponse({
    this.barcodeToCount,
    this.barcodeCounted,
    this.barcodePercent,
    this.quantityToCount,
    this.quantityCounted,
    this.quantityPercent,
    this.totalToCount,
    this.totalCounted,
    this.totalPercent,
    this.openedOn,
    this.openedBy,
    this.approvedOn,
    this.approvedBy,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusResponseFromJson(
          json);

  @JsonKey(name: 'BarcodeToCount')
  final double? barcodeToCount;
  @JsonKey(name: 'BarcodeCounted')
  final double? barcodeCounted;
  @JsonKey(name: 'BarcodePercent')
  final double? barcodePercent;
  @JsonKey(name: 'QuantityToCount')
  final double? quantityToCount;
  @JsonKey(name: 'QuantityCounted')
  final double? quantityCounted;
  @JsonKey(name: 'QuantityPercent')
  final double? quantityPercent;
  @JsonKey(name: 'TotalToCount')
  final double? totalToCount;
  @JsonKey(name: 'TotalCounted')
  final double? totalCounted;
  @JsonKey(name: 'TotalPercent')
  final double? totalPercent;
  @JsonKey(name: 'OpenedOn')
  final String? openedOn;
  @JsonKey(name: 'OpenedBy')
  final String? openedBy;
  @JsonKey(name: 'ApprovedOn')
  final String? approvedOn;
  @JsonKey(name: 'ApprovedBy')
  final String? approvedBy;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusResponse &&
            (identical(other.barcodeToCount, barcodeToCount) ||
                const DeepCollectionEquality()
                    .equals(other.barcodeToCount, barcodeToCount)) &&
            (identical(other.barcodeCounted, barcodeCounted) ||
                const DeepCollectionEquality()
                    .equals(other.barcodeCounted, barcodeCounted)) &&
            (identical(other.barcodePercent, barcodePercent) ||
                const DeepCollectionEquality()
                    .equals(other.barcodePercent, barcodePercent)) &&
            (identical(other.quantityToCount, quantityToCount) ||
                const DeepCollectionEquality()
                    .equals(other.quantityToCount, quantityToCount)) &&
            (identical(other.quantityCounted, quantityCounted) ||
                const DeepCollectionEquality()
                    .equals(other.quantityCounted, quantityCounted)) &&
            (identical(other.quantityPercent, quantityPercent) ||
                const DeepCollectionEquality()
                    .equals(other.quantityPercent, quantityPercent)) &&
            (identical(other.totalToCount, totalToCount) ||
                const DeepCollectionEquality()
                    .equals(other.totalToCount, totalToCount)) &&
            (identical(other.totalCounted, totalCounted) ||
                const DeepCollectionEquality()
                    .equals(other.totalCounted, totalCounted)) &&
            (identical(other.totalPercent, totalPercent) ||
                const DeepCollectionEquality()
                    .equals(other.totalPercent, totalPercent)) &&
            (identical(other.openedOn, openedOn) ||
                const DeepCollectionEquality()
                    .equals(other.openedOn, openedOn)) &&
            (identical(other.openedBy, openedBy) ||
                const DeepCollectionEquality()
                    .equals(other.openedBy, openedBy)) &&
            (identical(other.approvedOn, approvedOn) ||
                const DeepCollectionEquality()
                    .equals(other.approvedOn, approvedOn)) &&
            (identical(other.approvedBy, approvedBy) ||
                const DeepCollectionEquality()
                    .equals(other.approvedBy, approvedBy)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusResponseExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusResponse {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusResponse
      copyWith(
          {double? barcodeToCount,
          double? barcodeCounted,
          double? barcodePercent,
          double? quantityToCount,
          double? quantityCounted,
          double? quantityPercent,
          double? totalToCount,
          double? totalCounted,
          double? totalPercent,
          String? openedOn,
          String? openedBy,
          String? approvedOn,
          String? approvedBy}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryStatusResponse(
        barcodeToCount: barcodeToCount ?? this.barcodeToCount,
        barcodeCounted: barcodeCounted ?? this.barcodeCounted,
        barcodePercent: barcodePercent ?? this.barcodePercent,
        quantityToCount: quantityToCount ?? this.quantityToCount,
        quantityCounted: quantityCounted ?? this.quantityCounted,
        quantityPercent: quantityPercent ?? this.quantityPercent,
        totalToCount: totalToCount ?? this.totalToCount,
        totalCounted: totalCounted ?? this.totalCounted,
        totalPercent: totalPercent ?? this.totalPercent,
        openedOn: openedOn ?? this.openedOn,
        openedBy: openedBy ?? this.openedBy,
        approvedOn: approvedOn ?? this.approvedOn,
        approvedBy: approvedBy ?? this.approvedBy);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemRequest {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemRequest({
    this.physicalInventoryId,
    this.physicalInventoryItemId,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemRequestFromJson(
          json);

  @JsonKey(name: 'PhysicalInventoryId')
  final String? physicalInventoryId;
  @JsonKey(name: 'PhysicalInventoryItemId')
  final int? physicalInventoryItemId;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemRequest &&
            (identical(other.physicalInventoryId, physicalInventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.physicalInventoryId, physicalInventoryId)) &&
            (identical(
                    other.physicalInventoryItemId, physicalInventoryItemId) ||
                const DeepCollectionEquality().equals(
                    other.physicalInventoryItemId, physicalInventoryItemId)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemRequestExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemRequest {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemRequest
      copyWith({String? physicalInventoryId, int? physicalInventoryItemId}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemRequest(
        physicalInventoryId: physicalInventoryId ?? this.physicalInventoryId,
        physicalInventoryItemId:
            physicalInventoryItemId ?? this.physicalInventoryItemId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemResponse {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemResponse({
    this.success,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemResponseFromJson(
          json);

  @JsonKey(name: 'Success')
  final bool? success;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemResponse &&
            (identical(other.success, success) ||
                const DeepCollectionEquality().equals(other.success, success)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemResponseExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemResponse {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemResponse
      copyWith({bool? success}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUncountSerialItemResponse(
        success: success ?? this.success);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesRequest {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesRequest({
    this.physicalInventoryId,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesRequestFromJson(
          json);

  @JsonKey(name: 'PhysicalInventoryId')
  final String? physicalInventoryId;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesRequest &&
            (identical(other.physicalInventoryId, physicalInventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.physicalInventoryId, physicalInventoryId)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesRequestExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesRequest {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesRequest
      copyWith({String? physicalInventoryId}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesRequest(
        physicalInventoryId: physicalInventoryId ?? this.physicalInventoryId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesResponse {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesResponseExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesResponse {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesResponse
      copyWith({int? status, bool? success, String? msg}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryUpdateICodesResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidRequest {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidRequest({
    this.physicalInventoryId,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidRequestFromJson(
          json);

  @JsonKey(name: 'PhysicalInventoryId')
  final String? physicalInventoryId;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidRequest &&
            (identical(other.physicalInventoryId, physicalInventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.physicalInventoryId, physicalInventoryId)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidRequestExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidRequest {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidRequest copyWith(
      {String? physicalInventoryId}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidRequest(
        physicalInventoryId: physicalInventoryId ?? this.physicalInventoryId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidResponse {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidResponseExtension
    on WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidResponse {
  WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidResponse copyWith(
      {int? status, bool? success, String? msg}) {
    return WebApiModulesInventoryPhysicalInventoryPhysicalInventoryVoidResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryRentalInventoryRentalInventory {
  WebApiModulesInventoryRentalInventoryRentalInventory({
    this.excludeFromReturnOnAsset,
    this.isFixedAsset,
    this.multiAssignRFIDs,
    this.minimumDaysPerWeek,
    this.setOpeningId,
    this.setOpening,
    this.wallTypeId,
    this.wallType,
    this.setSurfaceId,
    this.setSurface,
    this.wallWidthFt,
    this.wallWidthIn,
    this.wallHeightFt,
    this.wallHeightIn,
    this.wallLengthFt,
    this.wallLengthIn,
    this.dailyRate,
    this.weeklyRate,
    this.week2Rate,
    this.week3Rate,
    this.week4Rate,
    this.monthlyRate,
    this.unitValue,
    this.replacementCost,
    this.inventoryId,
    this.inventoryTypeId,
    this.inventoryType,
    this.availableFrom,
    this.trackedBy,
    this.confirmTrackedBy,
    this.rank,
    this.manufacturerPartNumber,
    this.manufacturerId,
    this.manufacturer,
    this.manufacturerUrl,
    this.excludeImageFromQuoteOrderPrint,
    this.noAvailabilityCheck,
    this.availabilityManuallyResolveConflicts,
    this.sendAvailabilityAlert,
    this.primaryDimensionUniqueId,
    this.defaultImperialMetric,
    this.primaryDimensionDescription,
    this.primaryDimensionShipWeightLbs,
    this.primaryDimensionShipWeightOz,
    this.primaryDimensionWeightInCaseLbs,
    this.primaryDimensionWeightInCaseOz,
    this.primaryDimensionWidthFt,
    this.primaryDimensionWidthIn,
    this.primaryDimensionHeightFt,
    this.primaryDimensionHeightIn,
    this.primaryDimensionLengthFt,
    this.primaryDimensionLengthIn,
    this.primaryDimensionShipWeightKg,
    this.primaryDimensionShipWeightG,
    this.primaryDimensionWeightInCaseKg,
    this.primaryDimensionWeightInCaseG,
    this.primaryDimensionWidthM,
    this.primaryDimensionWidthCm,
    this.primaryDimensionHeightM,
    this.primaryDimensionHeightCm,
    this.primaryDimensionLengthM,
    this.primaryDimensionLengthCm,
    this.hasSecondaryDimensions,
    this.secondaryDimensionUniqueId,
    this.secondaryDimensionDescription,
    this.secondaryDimensionShipWeightLbs,
    this.secondaryDimensionShipWeightOz,
    this.secondaryDimensionWeightInCaseLbs,
    this.secondaryDimensionWeightInCaseOz,
    this.secondaryDimensionWidthFt,
    this.secondaryDimensionWidthIn,
    this.secondaryDimensionHeightFt,
    this.secondaryDimensionHeightIn,
    this.secondaryDimensionLengthFt,
    this.secondaryDimensionLengthIn,
    this.secondaryDimensionShipWeightKg,
    this.secondaryDimensionShipWeightG,
    this.secondaryDimensionWeightInCaseKg,
    this.secondaryDimensionWeightInCaseG,
    this.secondaryDimensionWidthM,
    this.secondaryDimensionWidthCm,
    this.secondaryDimensionHeightM,
    this.secondaryDimensionHeightCm,
    this.secondaryDimensionLengthM,
    this.secondaryDimensionLengthCm,
    this.countryOfOriginId,
    this.countryOfOrigin,
    this.displayInSummaryModeWhenRateIsZero,
    this.qcRequired,
    this.qcTime,
    this.copyAttributesAsNote,
    this.trackAssetUsage,
    this.trackLampUsage,
    this.trackStrikes,
    this.trackCandles,
    this.lampCount,
    this.minimumFootCandles,
    this.trackSoftware,
    this.softwareVersion,
    this.softwareEffectiveDate,
    this.warehouseSpecificPackage,
    this.completePackagePrice,
    this.kitPackagePrice,
    this.separatePackageOnQuoteOrder,
    this.containerId,
    this.containerScannableInventoryId,
    this.containerScannableICode,
    this.containerScannableDescription,
    this.automaticallyRebuildContainerAtCheckIn,
    this.automaticallyRebuildContainerAtTransferIn,
    this.containerStagingRule,
    this.excludeContainedItemsFromAvailability,
    this.useContainerNumber,
    this.containerPackingListBehavior,
    this.inventoryTypeIsWardrobe,
    this.inventoryTypeIsSets,
    this.patternId,
    this.pattern,
    this.periodId,
    this.period,
    this.materialId,
    this.material,
    this.genderId,
    this.gender,
    this.labelId,
    this.label,
    this.wardrobeSize,
    this.wardrobePieceCount,
    this.dyed,
    this.wardrobeSourceId,
    this.wardrobeSource,
    this.wardrobeCareId,
    this.wardrobeCare,
    this.cleaningFeeAmount,
    this.wardrobeDetailedDescription,
    this.webDetailedDescription,
    this.overrideSystemDefaultRevenueAllocationBehavior,
    this.allocateRevenueForAccessories,
    this.packageRevenueCalculationFormula,
    this.isHazardousMaterial,
    this.descriptionWithAkas,
    this.costCalculation,
    this.quantity,
    this.aisleLocation,
    this.shelfLocation,
    this.taxable,
    this.iCode,
    this.description,
    this.availFor,
    this.categoryId,
    this.category,
    this.subCategoryCount,
    this.subCategoryId,
    this.subCategory,
    this.classification,
    this.classificationDescription,
    this.classificationColor,
    this.unitId,
    this.unit,
    this.unitType,
    this.nonDiscountable,
    this.overrideProfitAndLossCategory,
    this.profitAndLossCategoryId,
    this.profitAndLossCategory,
    this.autoCopyNotesToQuoteOrder,
    this.note,
    this.printNoteOnInContract,
    this.printNoteOnOutContract,
    this.printNoteOnReceiveContract,
    this.printNoteOnReturnContract,
    this.printNoteOnInvoice,
    this.printNoteOnOrder,
    this.printNoteOnPickList,
    this.printNoteOnPO,
    this.printNoteOnQuote,
    this.printNoteOnReturnList,
    this.printNoteOnPoReceiveList,
    this.printNoteOnPoReturnList,
    this.assetAccountId,
    this.assetAccountNo,
    this.assetAccountDescription,
    this.incomeAccountId,
    this.incomeAccountNo,
    this.incomeAccountDescription,
    this.subIncomeAccountId,
    this.subIncomeAccountNo,
    this.subIncomeAccountDescription,
    this.consignmentIncomeAccountId,
    this.consignmentIncomeAccountNo,
    this.consignmentIncomeAccountDescription,
    this.ldIncomeAccountId,
    this.ldIncomeAccountNo,
    this.ldIncomeAccountDescription,
    this.equipmentSaleIncomeAccountId,
    this.equipmentSaleIncomeAccountNo,
    this.equipmentSaleIncomeAccountDescription,
    this.expenseAccountId,
    this.expenseAccountNo,
    this.expenseAccountDescription,
    this.costOfGoodsSoldExpenseAccountId,
    this.costOfGoodsSoldExpenseAccountNo,
    this.costOfGoodsSoldExpenseAccountDescription,
    this.costOfGoodsRentedExpenseAccountId,
    this.costOfGoodsRentedExpenseAccountNo,
    this.costOfGoodsRentedExpenseAccountDescription,
    this.depreciationExpenseAccountId,
    this.depreciationExpenseAccountNo,
    this.depreciationExpenseAccountDescription,
    this.accumulatedDepreciationExpenseAccountId,
    this.accumulatedDepreciationExpenseAccountNo,
    this.accumulatedDepreciationExpenseAccountDescription,
    this.originalShowId,
    this.inactive,
    this.dateStamp,
    this.manifestShippingContainer,
    this.manifestStandAloneItem,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesInventoryRentalInventoryRentalInventory.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryRentalInventoryRentalInventoryFromJson(json);

  @JsonKey(name: 'ExcludeFromReturnOnAsset')
  final bool? excludeFromReturnOnAsset;
  @JsonKey(name: 'IsFixedAsset')
  final bool? isFixedAsset;
  @JsonKey(name: 'MultiAssignRFIDs')
  final bool? multiAssignRFIDs;
  @JsonKey(name: 'MinimumDaysPerWeek')
  final double? minimumDaysPerWeek;
  @JsonKey(name: 'SetOpeningId')
  final String? setOpeningId;
  @JsonKey(name: 'SetOpening')
  final String? setOpening;
  @JsonKey(name: 'WallTypeId')
  final String? wallTypeId;
  @JsonKey(name: 'WallType')
  final String? wallType;
  @JsonKey(name: 'SetSurfaceId')
  final String? setSurfaceId;
  @JsonKey(name: 'SetSurface')
  final String? setSurface;
  @JsonKey(name: 'WallWidthFt')
  final int? wallWidthFt;
  @JsonKey(name: 'WallWidthIn')
  final int? wallWidthIn;
  @JsonKey(name: 'WallHeightFt')
  final int? wallHeightFt;
  @JsonKey(name: 'WallHeightIn')
  final int? wallHeightIn;
  @JsonKey(name: 'WallLengthFt')
  final int? wallLengthFt;
  @JsonKey(name: 'WallLengthIn')
  final int? wallLengthIn;
  @JsonKey(name: 'DailyRate')
  final double? dailyRate;
  @JsonKey(name: 'WeeklyRate')
  final double? weeklyRate;
  @JsonKey(name: 'Week2Rate')
  final double? week2Rate;
  @JsonKey(name: 'Week3Rate')
  final double? week3Rate;
  @JsonKey(name: 'Week4Rate')
  final double? week4Rate;
  @JsonKey(name: 'MonthlyRate')
  final double? monthlyRate;
  @JsonKey(name: 'UnitValue')
  final double? unitValue;
  @JsonKey(name: 'ReplacementCost')
  final double? replacementCost;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'InventoryTypeId')
  final String? inventoryTypeId;
  @JsonKey(name: 'InventoryType')
  final String? inventoryType;
  @JsonKey(name: 'AvailableFrom')
  final String? availableFrom;
  @JsonKey(name: 'TrackedBy')
  final String? trackedBy;
  @JsonKey(name: 'ConfirmTrackedBy')
  final String? confirmTrackedBy;
  @JsonKey(name: 'Rank')
  final String? rank;
  @JsonKey(name: 'ManufacturerPartNumber')
  final String? manufacturerPartNumber;
  @JsonKey(name: 'ManufacturerId')
  final String? manufacturerId;
  @JsonKey(name: 'Manufacturer')
  final String? manufacturer;
  @JsonKey(name: 'ManufacturerUrl')
  final String? manufacturerUrl;
  @JsonKey(name: 'ExcludeImageFromQuoteOrderPrint')
  final bool? excludeImageFromQuoteOrderPrint;
  @JsonKey(name: 'NoAvailabilityCheck')
  final bool? noAvailabilityCheck;
  @JsonKey(name: 'AvailabilityManuallyResolveConflicts')
  final bool? availabilityManuallyResolveConflicts;
  @JsonKey(name: 'SendAvailabilityAlert')
  final bool? sendAvailabilityAlert;
  @JsonKey(name: 'PrimaryDimensionUniqueId')
  final String? primaryDimensionUniqueId;
  @JsonKey(name: 'DefaultImperialMetric')
  final String? defaultImperialMetric;
  @JsonKey(name: 'PrimaryDimensionDescription')
  final String? primaryDimensionDescription;
  @JsonKey(name: 'PrimaryDimensionShipWeightLbs')
  final int? primaryDimensionShipWeightLbs;
  @JsonKey(name: 'PrimaryDimensionShipWeightOz')
  final int? primaryDimensionShipWeightOz;
  @JsonKey(name: 'PrimaryDimensionWeightInCaseLbs')
  final int? primaryDimensionWeightInCaseLbs;
  @JsonKey(name: 'PrimaryDimensionWeightInCaseOz')
  final int? primaryDimensionWeightInCaseOz;
  @JsonKey(name: 'PrimaryDimensionWidthFt')
  final int? primaryDimensionWidthFt;
  @JsonKey(name: 'PrimaryDimensionWidthIn')
  final int? primaryDimensionWidthIn;
  @JsonKey(name: 'PrimaryDimensionHeightFt')
  final int? primaryDimensionHeightFt;
  @JsonKey(name: 'PrimaryDimensionHeightIn')
  final int? primaryDimensionHeightIn;
  @JsonKey(name: 'PrimaryDimensionLengthFt')
  final int? primaryDimensionLengthFt;
  @JsonKey(name: 'PrimaryDimensionLengthIn')
  final int? primaryDimensionLengthIn;
  @JsonKey(name: 'PrimaryDimensionShipWeightKg')
  final int? primaryDimensionShipWeightKg;
  @JsonKey(name: 'PrimaryDimensionShipWeightG')
  final int? primaryDimensionShipWeightG;
  @JsonKey(name: 'PrimaryDimensionWeightInCaseKg')
  final int? primaryDimensionWeightInCaseKg;
  @JsonKey(name: 'PrimaryDimensionWeightInCaseG')
  final int? primaryDimensionWeightInCaseG;
  @JsonKey(name: 'PrimaryDimensionWidthM')
  final int? primaryDimensionWidthM;
  @JsonKey(name: 'PrimaryDimensionWidthCm')
  final int? primaryDimensionWidthCm;
  @JsonKey(name: 'PrimaryDimensionHeightM')
  final int? primaryDimensionHeightM;
  @JsonKey(name: 'PrimaryDimensionHeightCm')
  final int? primaryDimensionHeightCm;
  @JsonKey(name: 'PrimaryDimensionLengthM')
  final int? primaryDimensionLengthM;
  @JsonKey(name: 'PrimaryDimensionLengthCm')
  final int? primaryDimensionLengthCm;
  @JsonKey(name: 'HasSecondaryDimensions')
  final bool? hasSecondaryDimensions;
  @JsonKey(name: 'SecondaryDimensionUniqueId')
  final String? secondaryDimensionUniqueId;
  @JsonKey(name: 'SecondaryDimensionDescription')
  final String? secondaryDimensionDescription;
  @JsonKey(name: 'SecondaryDimensionShipWeightLbs')
  final int? secondaryDimensionShipWeightLbs;
  @JsonKey(name: 'SecondaryDimensionShipWeightOz')
  final int? secondaryDimensionShipWeightOz;
  @JsonKey(name: 'SecondaryDimensionWeightInCaseLbs')
  final int? secondaryDimensionWeightInCaseLbs;
  @JsonKey(name: 'SecondaryDimensionWeightInCaseOz')
  final int? secondaryDimensionWeightInCaseOz;
  @JsonKey(name: 'SecondaryDimensionWidthFt')
  final int? secondaryDimensionWidthFt;
  @JsonKey(name: 'SecondaryDimensionWidthIn')
  final int? secondaryDimensionWidthIn;
  @JsonKey(name: 'SecondaryDimensionHeightFt')
  final int? secondaryDimensionHeightFt;
  @JsonKey(name: 'SecondaryDimensionHeightIn')
  final int? secondaryDimensionHeightIn;
  @JsonKey(name: 'SecondaryDimensionLengthFt')
  final int? secondaryDimensionLengthFt;
  @JsonKey(name: 'SecondaryDimensionLengthIn')
  final int? secondaryDimensionLengthIn;
  @JsonKey(name: 'SecondaryDimensionShipWeightKg')
  final int? secondaryDimensionShipWeightKg;
  @JsonKey(name: 'SecondaryDimensionShipWeightG')
  final int? secondaryDimensionShipWeightG;
  @JsonKey(name: 'SecondaryDimensionWeightInCaseKg')
  final int? secondaryDimensionWeightInCaseKg;
  @JsonKey(name: 'SecondaryDimensionWeightInCaseG')
  final int? secondaryDimensionWeightInCaseG;
  @JsonKey(name: 'SecondaryDimensionWidthM')
  final int? secondaryDimensionWidthM;
  @JsonKey(name: 'SecondaryDimensionWidthCm')
  final int? secondaryDimensionWidthCm;
  @JsonKey(name: 'SecondaryDimensionHeightM')
  final int? secondaryDimensionHeightM;
  @JsonKey(name: 'SecondaryDimensionHeightCm')
  final int? secondaryDimensionHeightCm;
  @JsonKey(name: 'SecondaryDimensionLengthM')
  final int? secondaryDimensionLengthM;
  @JsonKey(name: 'SecondaryDimensionLengthCm')
  final int? secondaryDimensionLengthCm;
  @JsonKey(name: 'CountryOfOriginId')
  final String? countryOfOriginId;
  @JsonKey(name: 'CountryOfOrigin')
  final String? countryOfOrigin;
  @JsonKey(name: 'DisplayInSummaryModeWhenRateIsZero')
  final bool? displayInSummaryModeWhenRateIsZero;
  @JsonKey(name: 'QcRequired')
  final bool? qcRequired;
  @JsonKey(name: 'QcTime')
  final String? qcTime;
  @JsonKey(name: 'CopyAttributesAsNote')
  final bool? copyAttributesAsNote;
  @JsonKey(name: 'TrackAssetUsage')
  final bool? trackAssetUsage;
  @JsonKey(name: 'TrackLampUsage')
  final bool? trackLampUsage;
  @JsonKey(name: 'TrackStrikes')
  final bool? trackStrikes;
  @JsonKey(name: 'TrackCandles')
  final bool? trackCandles;
  @JsonKey(name: 'LampCount')
  final int? lampCount;
  @JsonKey(name: 'MinimumFootCandles')
  final int? minimumFootCandles;
  @JsonKey(name: 'TrackSoftware')
  final bool? trackSoftware;
  @JsonKey(name: 'SoftwareVersion')
  final String? softwareVersion;
  @JsonKey(name: 'SoftwareEffectiveDate')
  final String? softwareEffectiveDate;
  @JsonKey(name: 'WarehouseSpecificPackage')
  final bool? warehouseSpecificPackage;
  @JsonKey(name: 'CompletePackagePrice')
  final String? completePackagePrice;
  @JsonKey(name: 'KitPackagePrice')
  final String? kitPackagePrice;
  @JsonKey(name: 'SeparatePackageOnQuoteOrder')
  final bool? separatePackageOnQuoteOrder;
  @JsonKey(name: 'ContainerId')
  final String? containerId;
  @JsonKey(name: 'ContainerScannableInventoryId')
  final String? containerScannableInventoryId;
  @JsonKey(name: 'ContainerScannableICode')
  final String? containerScannableICode;
  @JsonKey(name: 'ContainerScannableDescription')
  final String? containerScannableDescription;
  @JsonKey(name: 'AutomaticallyRebuildContainerAtCheckIn')
  final bool? automaticallyRebuildContainerAtCheckIn;
  @JsonKey(name: 'AutomaticallyRebuildContainerAtTransferIn')
  final bool? automaticallyRebuildContainerAtTransferIn;
  @JsonKey(name: 'ContainerStagingRule')
  final String? containerStagingRule;
  @JsonKey(name: 'ExcludeContainedItemsFromAvailability')
  final bool? excludeContainedItemsFromAvailability;
  @JsonKey(name: 'UseContainerNumber')
  final bool? useContainerNumber;
  @JsonKey(name: 'ContainerPackingListBehavior')
  final String? containerPackingListBehavior;
  @JsonKey(name: 'InventoryTypeIsWardrobe')
  final bool? inventoryTypeIsWardrobe;
  @JsonKey(name: 'InventoryTypeIsSets')
  final bool? inventoryTypeIsSets;
  @JsonKey(name: 'PatternId')
  final String? patternId;
  @JsonKey(name: 'Pattern')
  final String? pattern;
  @JsonKey(name: 'PeriodId')
  final String? periodId;
  @JsonKey(name: 'Period')
  final String? period;
  @JsonKey(name: 'MaterialId')
  final String? materialId;
  @JsonKey(name: 'Material')
  final String? material;
  @JsonKey(name: 'GenderId')
  final String? genderId;
  @JsonKey(name: 'Gender')
  final String? gender;
  @JsonKey(name: 'LabelId')
  final String? labelId;
  @JsonKey(name: 'Label')
  final String? label;
  @JsonKey(name: 'WardrobeSize')
  final String? wardrobeSize;
  @JsonKey(name: 'WardrobePieceCount')
  final int? wardrobePieceCount;
  @JsonKey(name: 'Dyed')
  final bool? dyed;
  @JsonKey(name: 'WardrobeSourceId')
  final String? wardrobeSourceId;
  @JsonKey(name: 'WardrobeSource')
  final String? wardrobeSource;
  @JsonKey(name: 'WardrobeCareId')
  final String? wardrobeCareId;
  @JsonKey(name: 'WardrobeCare')
  final String? wardrobeCare;
  @JsonKey(name: 'CleaningFeeAmount')
  final double? cleaningFeeAmount;
  @JsonKey(name: 'WardrobeDetailedDescription')
  final String? wardrobeDetailedDescription;
  @JsonKey(name: 'WebDetailedDescription')
  final String? webDetailedDescription;
  @JsonKey(name: 'OverrideSystemDefaultRevenueAllocationBehavior')
  final bool? overrideSystemDefaultRevenueAllocationBehavior;
  @JsonKey(name: 'AllocateRevenueForAccessories')
  final bool? allocateRevenueForAccessories;
  @JsonKey(name: 'PackageRevenueCalculationFormula')
  final String? packageRevenueCalculationFormula;
  @JsonKey(name: 'IsHazardousMaterial')
  final bool? isHazardousMaterial;
  @JsonKey(name: 'DescriptionWithAkas')
  final String? descriptionWithAkas;
  @JsonKey(name: 'CostCalculation')
  final String? costCalculation;
  @JsonKey(name: 'Quantity')
  final double? quantity;
  @JsonKey(name: 'AisleLocation')
  final String? aisleLocation;
  @JsonKey(name: 'ShelfLocation')
  final String? shelfLocation;
  @JsonKey(name: 'Taxable')
  final bool? taxable;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AvailFor')
  final String? availFor;
  @JsonKey(name: 'CategoryId')
  final String? categoryId;
  @JsonKey(name: 'Category')
  final String? category;
  @JsonKey(name: 'SubCategoryCount')
  final int? subCategoryCount;
  @JsonKey(name: 'SubCategoryId')
  final String? subCategoryId;
  @JsonKey(name: 'SubCategory')
  final String? subCategory;
  @JsonKey(name: 'Classification')
  final String? classification;
  @JsonKey(name: 'ClassificationDescription')
  final String? classificationDescription;
  @JsonKey(name: 'ClassificationColor')
  final String? classificationColor;
  @JsonKey(name: 'UnitId')
  final String? unitId;
  @JsonKey(name: 'Unit')
  final String? unit;
  @JsonKey(name: 'UnitType')
  final String? unitType;
  @JsonKey(name: 'NonDiscountable')
  final bool? nonDiscountable;
  @JsonKey(name: 'OverrideProfitAndLossCategory')
  final bool? overrideProfitAndLossCategory;
  @JsonKey(name: 'ProfitAndLossCategoryId')
  final String? profitAndLossCategoryId;
  @JsonKey(name: 'ProfitAndLossCategory')
  final String? profitAndLossCategory;
  @JsonKey(name: 'AutoCopyNotesToQuoteOrder')
  final bool? autoCopyNotesToQuoteOrder;
  @JsonKey(name: 'Note')
  final String? note;
  @JsonKey(name: 'PrintNoteOnInContract')
  final bool? printNoteOnInContract;
  @JsonKey(name: 'PrintNoteOnOutContract')
  final bool? printNoteOnOutContract;
  @JsonKey(name: 'PrintNoteOnReceiveContract')
  final bool? printNoteOnReceiveContract;
  @JsonKey(name: 'PrintNoteOnReturnContract')
  final bool? printNoteOnReturnContract;
  @JsonKey(name: 'PrintNoteOnInvoice')
  final bool? printNoteOnInvoice;
  @JsonKey(name: 'PrintNoteOnOrder')
  final bool? printNoteOnOrder;
  @JsonKey(name: 'PrintNoteOnPickList')
  final bool? printNoteOnPickList;
  @JsonKey(name: 'PrintNoteOnPO')
  final bool? printNoteOnPO;
  @JsonKey(name: 'PrintNoteOnQuote')
  final bool? printNoteOnQuote;
  @JsonKey(name: 'PrintNoteOnReturnList')
  final bool? printNoteOnReturnList;
  @JsonKey(name: 'PrintNoteOnPoReceiveList')
  final bool? printNoteOnPoReceiveList;
  @JsonKey(name: 'PrintNoteOnPoReturnList')
  final bool? printNoteOnPoReturnList;
  @JsonKey(name: 'AssetAccountId')
  final String? assetAccountId;
  @JsonKey(name: 'AssetAccountNo')
  final String? assetAccountNo;
  @JsonKey(name: 'AssetAccountDescription')
  final String? assetAccountDescription;
  @JsonKey(name: 'IncomeAccountId')
  final String? incomeAccountId;
  @JsonKey(name: 'IncomeAccountNo')
  final String? incomeAccountNo;
  @JsonKey(name: 'IncomeAccountDescription')
  final String? incomeAccountDescription;
  @JsonKey(name: 'SubIncomeAccountId')
  final String? subIncomeAccountId;
  @JsonKey(name: 'SubIncomeAccountNo')
  final String? subIncomeAccountNo;
  @JsonKey(name: 'SubIncomeAccountDescription')
  final String? subIncomeAccountDescription;
  @JsonKey(name: 'ConsignmentIncomeAccountId')
  final String? consignmentIncomeAccountId;
  @JsonKey(name: 'ConsignmentIncomeAccountNo')
  final String? consignmentIncomeAccountNo;
  @JsonKey(name: 'ConsignmentIncomeAccountDescription')
  final String? consignmentIncomeAccountDescription;
  @JsonKey(name: 'LdIncomeAccountId')
  final String? ldIncomeAccountId;
  @JsonKey(name: 'LdIncomeAccountNo')
  final String? ldIncomeAccountNo;
  @JsonKey(name: 'LdIncomeAccountDescription')
  final String? ldIncomeAccountDescription;
  @JsonKey(name: 'EquipmentSaleIncomeAccountId')
  final String? equipmentSaleIncomeAccountId;
  @JsonKey(name: 'EquipmentSaleIncomeAccountNo')
  final String? equipmentSaleIncomeAccountNo;
  @JsonKey(name: 'EquipmentSaleIncomeAccountDescription')
  final String? equipmentSaleIncomeAccountDescription;
  @JsonKey(name: 'ExpenseAccountId')
  final String? expenseAccountId;
  @JsonKey(name: 'ExpenseAccountNo')
  final String? expenseAccountNo;
  @JsonKey(name: 'ExpenseAccountDescription')
  final String? expenseAccountDescription;
  @JsonKey(name: 'CostOfGoodsSoldExpenseAccountId')
  final String? costOfGoodsSoldExpenseAccountId;
  @JsonKey(name: 'CostOfGoodsSoldExpenseAccountNo')
  final String? costOfGoodsSoldExpenseAccountNo;
  @JsonKey(name: 'CostOfGoodsSoldExpenseAccountDescription')
  final String? costOfGoodsSoldExpenseAccountDescription;
  @JsonKey(name: 'CostOfGoodsRentedExpenseAccountId')
  final String? costOfGoodsRentedExpenseAccountId;
  @JsonKey(name: 'CostOfGoodsRentedExpenseAccountNo')
  final String? costOfGoodsRentedExpenseAccountNo;
  @JsonKey(name: 'CostOfGoodsRentedExpenseAccountDescription')
  final String? costOfGoodsRentedExpenseAccountDescription;
  @JsonKey(name: 'DepreciationExpenseAccountId')
  final String? depreciationExpenseAccountId;
  @JsonKey(name: 'DepreciationExpenseAccountNo')
  final String? depreciationExpenseAccountNo;
  @JsonKey(name: 'DepreciationExpenseAccountDescription')
  final String? depreciationExpenseAccountDescription;
  @JsonKey(name: 'AccumulatedDepreciationExpenseAccountId')
  final String? accumulatedDepreciationExpenseAccountId;
  @JsonKey(name: 'AccumulatedDepreciationExpenseAccountNo')
  final String? accumulatedDepreciationExpenseAccountNo;
  @JsonKey(name: 'AccumulatedDepreciationExpenseAccountDescription')
  final String? accumulatedDepreciationExpenseAccountDescription;
  @JsonKey(name: 'OriginalShowId')
  final String? originalShowId;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'ManifestShippingContainer')
  final bool? manifestShippingContainer;
  @JsonKey(name: 'ManifestStandAloneItem')
  final bool? manifestStandAloneItem;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesInventoryRentalInventoryRentalInventoryFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryRentalInventoryRentalInventoryToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryRentalInventoryRentalInventoryToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryRentalInventoryRentalInventory &&
            (identical(other.excludeFromReturnOnAsset, excludeFromReturnOnAsset) ||
                const DeepCollectionEquality().equals(
                    other.excludeFromReturnOnAsset,
                    excludeFromReturnOnAsset)) &&
            (identical(other.isFixedAsset, isFixedAsset) ||
                const DeepCollectionEquality()
                    .equals(other.isFixedAsset, isFixedAsset)) &&
            (identical(other.multiAssignRFIDs, multiAssignRFIDs) ||
                const DeepCollectionEquality()
                    .equals(other.multiAssignRFIDs, multiAssignRFIDs)) &&
            (identical(other.minimumDaysPerWeek, minimumDaysPerWeek) ||
                const DeepCollectionEquality()
                    .equals(other.minimumDaysPerWeek, minimumDaysPerWeek)) &&
            (identical(other.setOpeningId, setOpeningId) ||
                const DeepCollectionEquality()
                    .equals(other.setOpeningId, setOpeningId)) &&
            (identical(other.setOpening, setOpening) ||
                const DeepCollectionEquality()
                    .equals(other.setOpening, setOpening)) &&
            (identical(other.wallTypeId, wallTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.wallTypeId, wallTypeId)) &&
            (identical(other.wallType, wallType) ||
                const DeepCollectionEquality()
                    .equals(other.wallType, wallType)) &&
            (identical(other.setSurfaceId, setSurfaceId) ||
                const DeepCollectionEquality()
                    .equals(other.setSurfaceId, setSurfaceId)) &&
            (identical(other.setSurface, setSurface) ||
                const DeepCollectionEquality()
                    .equals(other.setSurface, setSurface)) &&
            (identical(other.wallWidthFt, wallWidthFt) ||
                const DeepCollectionEquality()
                    .equals(other.wallWidthFt, wallWidthFt)) &&
            (identical(other.wallWidthIn, wallWidthIn) ||
                const DeepCollectionEquality()
                    .equals(other.wallWidthIn, wallWidthIn)) &&
            (identical(other.wallHeightFt, wallHeightFt) ||
                const DeepCollectionEquality()
                    .equals(other.wallHeightFt, wallHeightFt)) &&
            (identical(other.wallHeightIn, wallHeightIn) ||
                const DeepCollectionEquality()
                    .equals(other.wallHeightIn, wallHeightIn)) &&
            (identical(other.wallLengthFt, wallLengthFt) ||
                const DeepCollectionEquality()
                    .equals(other.wallLengthFt, wallLengthFt)) &&
            (identical(other.wallLengthIn, wallLengthIn) ||
                const DeepCollectionEquality()
                    .equals(other.wallLengthIn, wallLengthIn)) &&
            (identical(other.dailyRate, dailyRate) || const DeepCollectionEquality().equals(other.dailyRate, dailyRate)) &&
            (identical(other.weeklyRate, weeklyRate) || const DeepCollectionEquality().equals(other.weeklyRate, weeklyRate)) &&
            (identical(other.week2Rate, week2Rate) || const DeepCollectionEquality().equals(other.week2Rate, week2Rate)) &&
            (identical(other.week3Rate, week3Rate) || const DeepCollectionEquality().equals(other.week3Rate, week3Rate)) &&
            (identical(other.week4Rate, week4Rate) || const DeepCollectionEquality().equals(other.week4Rate, week4Rate)) &&
            (identical(other.monthlyRate, monthlyRate) || const DeepCollectionEquality().equals(other.monthlyRate, monthlyRate)) &&
            (identical(other.unitValue, unitValue) || const DeepCollectionEquality().equals(other.unitValue, unitValue)) &&
            (identical(other.replacementCost, replacementCost) || const DeepCollectionEquality().equals(other.replacementCost, replacementCost)) &&
            (identical(other.inventoryId, inventoryId) || const DeepCollectionEquality().equals(other.inventoryId, inventoryId)) &&
            (identical(other.inventoryTypeId, inventoryTypeId) || const DeepCollectionEquality().equals(other.inventoryTypeId, inventoryTypeId)) &&
            (identical(other.inventoryType, inventoryType) || const DeepCollectionEquality().equals(other.inventoryType, inventoryType)) &&
            (identical(other.availableFrom, availableFrom) || const DeepCollectionEquality().equals(other.availableFrom, availableFrom)) &&
            (identical(other.trackedBy, trackedBy) || const DeepCollectionEquality().equals(other.trackedBy, trackedBy)) &&
            (identical(other.confirmTrackedBy, confirmTrackedBy) || const DeepCollectionEquality().equals(other.confirmTrackedBy, confirmTrackedBy)) &&
            (identical(other.rank, rank) || const DeepCollectionEquality().equals(other.rank, rank)) &&
            (identical(other.manufacturerPartNumber, manufacturerPartNumber) || const DeepCollectionEquality().equals(other.manufacturerPartNumber, manufacturerPartNumber)) &&
            (identical(other.manufacturerId, manufacturerId) || const DeepCollectionEquality().equals(other.manufacturerId, manufacturerId)) &&
            (identical(other.manufacturer, manufacturer) || const DeepCollectionEquality().equals(other.manufacturer, manufacturer)) &&
            (identical(other.manufacturerUrl, manufacturerUrl) || const DeepCollectionEquality().equals(other.manufacturerUrl, manufacturerUrl)) &&
            (identical(other.excludeImageFromQuoteOrderPrint, excludeImageFromQuoteOrderPrint) || const DeepCollectionEquality().equals(other.excludeImageFromQuoteOrderPrint, excludeImageFromQuoteOrderPrint)) &&
            (identical(other.noAvailabilityCheck, noAvailabilityCheck) || const DeepCollectionEquality().equals(other.noAvailabilityCheck, noAvailabilityCheck)) &&
            (identical(other.availabilityManuallyResolveConflicts, availabilityManuallyResolveConflicts) || const DeepCollectionEquality().equals(other.availabilityManuallyResolveConflicts, availabilityManuallyResolveConflicts)) &&
            (identical(other.sendAvailabilityAlert, sendAvailabilityAlert) || const DeepCollectionEquality().equals(other.sendAvailabilityAlert, sendAvailabilityAlert)) &&
            (identical(other.primaryDimensionUniqueId, primaryDimensionUniqueId) || const DeepCollectionEquality().equals(other.primaryDimensionUniqueId, primaryDimensionUniqueId)) &&
            (identical(other.defaultImperialMetric, defaultImperialMetric) || const DeepCollectionEquality().equals(other.defaultImperialMetric, defaultImperialMetric)) &&
            (identical(other.primaryDimensionDescription, primaryDimensionDescription) || const DeepCollectionEquality().equals(other.primaryDimensionDescription, primaryDimensionDescription)) &&
            (identical(other.primaryDimensionShipWeightLbs, primaryDimensionShipWeightLbs) || const DeepCollectionEquality().equals(other.primaryDimensionShipWeightLbs, primaryDimensionShipWeightLbs)) &&
            (identical(other.primaryDimensionShipWeightOz, primaryDimensionShipWeightOz) || const DeepCollectionEquality().equals(other.primaryDimensionShipWeightOz, primaryDimensionShipWeightOz)) &&
            (identical(other.primaryDimensionWeightInCaseLbs, primaryDimensionWeightInCaseLbs) || const DeepCollectionEquality().equals(other.primaryDimensionWeightInCaseLbs, primaryDimensionWeightInCaseLbs)) &&
            (identical(other.primaryDimensionWeightInCaseOz, primaryDimensionWeightInCaseOz) || const DeepCollectionEquality().equals(other.primaryDimensionWeightInCaseOz, primaryDimensionWeightInCaseOz)) &&
            (identical(other.primaryDimensionWidthFt, primaryDimensionWidthFt) || const DeepCollectionEquality().equals(other.primaryDimensionWidthFt, primaryDimensionWidthFt)) &&
            (identical(other.primaryDimensionWidthIn, primaryDimensionWidthIn) || const DeepCollectionEquality().equals(other.primaryDimensionWidthIn, primaryDimensionWidthIn)) &&
            (identical(other.primaryDimensionHeightFt, primaryDimensionHeightFt) || const DeepCollectionEquality().equals(other.primaryDimensionHeightFt, primaryDimensionHeightFt)) &&
            (identical(other.primaryDimensionHeightIn, primaryDimensionHeightIn) || const DeepCollectionEquality().equals(other.primaryDimensionHeightIn, primaryDimensionHeightIn)) &&
            (identical(other.primaryDimensionLengthFt, primaryDimensionLengthFt) || const DeepCollectionEquality().equals(other.primaryDimensionLengthFt, primaryDimensionLengthFt)) &&
            (identical(other.primaryDimensionLengthIn, primaryDimensionLengthIn) || const DeepCollectionEquality().equals(other.primaryDimensionLengthIn, primaryDimensionLengthIn)) &&
            (identical(other.primaryDimensionShipWeightKg, primaryDimensionShipWeightKg) || const DeepCollectionEquality().equals(other.primaryDimensionShipWeightKg, primaryDimensionShipWeightKg)) &&
            (identical(other.primaryDimensionShipWeightG, primaryDimensionShipWeightG) || const DeepCollectionEquality().equals(other.primaryDimensionShipWeightG, primaryDimensionShipWeightG)) &&
            (identical(other.primaryDimensionWeightInCaseKg, primaryDimensionWeightInCaseKg) || const DeepCollectionEquality().equals(other.primaryDimensionWeightInCaseKg, primaryDimensionWeightInCaseKg)) &&
            (identical(other.primaryDimensionWeightInCaseG, primaryDimensionWeightInCaseG) || const DeepCollectionEquality().equals(other.primaryDimensionWeightInCaseG, primaryDimensionWeightInCaseG)) &&
            (identical(other.primaryDimensionWidthM, primaryDimensionWidthM) || const DeepCollectionEquality().equals(other.primaryDimensionWidthM, primaryDimensionWidthM)) &&
            (identical(other.primaryDimensionWidthCm, primaryDimensionWidthCm) || const DeepCollectionEquality().equals(other.primaryDimensionWidthCm, primaryDimensionWidthCm)) &&
            (identical(other.primaryDimensionHeightM, primaryDimensionHeightM) || const DeepCollectionEquality().equals(other.primaryDimensionHeightM, primaryDimensionHeightM)) &&
            (identical(other.primaryDimensionHeightCm, primaryDimensionHeightCm) || const DeepCollectionEquality().equals(other.primaryDimensionHeightCm, primaryDimensionHeightCm)) &&
            (identical(other.primaryDimensionLengthM, primaryDimensionLengthM) || const DeepCollectionEquality().equals(other.primaryDimensionLengthM, primaryDimensionLengthM)) &&
            (identical(other.primaryDimensionLengthCm, primaryDimensionLengthCm) || const DeepCollectionEquality().equals(other.primaryDimensionLengthCm, primaryDimensionLengthCm)) &&
            (identical(other.hasSecondaryDimensions, hasSecondaryDimensions) || const DeepCollectionEquality().equals(other.hasSecondaryDimensions, hasSecondaryDimensions)) &&
            (identical(other.secondaryDimensionUniqueId, secondaryDimensionUniqueId) || const DeepCollectionEquality().equals(other.secondaryDimensionUniqueId, secondaryDimensionUniqueId)) &&
            (identical(other.secondaryDimensionDescription, secondaryDimensionDescription) || const DeepCollectionEquality().equals(other.secondaryDimensionDescription, secondaryDimensionDescription)) &&
            (identical(other.secondaryDimensionShipWeightLbs, secondaryDimensionShipWeightLbs) || const DeepCollectionEquality().equals(other.secondaryDimensionShipWeightLbs, secondaryDimensionShipWeightLbs)) &&
            (identical(other.secondaryDimensionShipWeightOz, secondaryDimensionShipWeightOz) || const DeepCollectionEquality().equals(other.secondaryDimensionShipWeightOz, secondaryDimensionShipWeightOz)) &&
            (identical(other.secondaryDimensionWeightInCaseLbs, secondaryDimensionWeightInCaseLbs) || const DeepCollectionEquality().equals(other.secondaryDimensionWeightInCaseLbs, secondaryDimensionWeightInCaseLbs)) &&
            (identical(other.secondaryDimensionWeightInCaseOz, secondaryDimensionWeightInCaseOz) || const DeepCollectionEquality().equals(other.secondaryDimensionWeightInCaseOz, secondaryDimensionWeightInCaseOz)) &&
            (identical(other.secondaryDimensionWidthFt, secondaryDimensionWidthFt) || const DeepCollectionEquality().equals(other.secondaryDimensionWidthFt, secondaryDimensionWidthFt)) &&
            (identical(other.secondaryDimensionWidthIn, secondaryDimensionWidthIn) || const DeepCollectionEquality().equals(other.secondaryDimensionWidthIn, secondaryDimensionWidthIn)) &&
            (identical(other.secondaryDimensionHeightFt, secondaryDimensionHeightFt) || const DeepCollectionEquality().equals(other.secondaryDimensionHeightFt, secondaryDimensionHeightFt)) &&
            (identical(other.secondaryDimensionHeightIn, secondaryDimensionHeightIn) || const DeepCollectionEquality().equals(other.secondaryDimensionHeightIn, secondaryDimensionHeightIn)) &&
            (identical(other.secondaryDimensionLengthFt, secondaryDimensionLengthFt) || const DeepCollectionEquality().equals(other.secondaryDimensionLengthFt, secondaryDimensionLengthFt)) &&
            (identical(other.secondaryDimensionLengthIn, secondaryDimensionLengthIn) || const DeepCollectionEquality().equals(other.secondaryDimensionLengthIn, secondaryDimensionLengthIn)) &&
            (identical(other.secondaryDimensionShipWeightKg, secondaryDimensionShipWeightKg) || const DeepCollectionEquality().equals(other.secondaryDimensionShipWeightKg, secondaryDimensionShipWeightKg)) &&
            (identical(other.secondaryDimensionShipWeightG, secondaryDimensionShipWeightG) || const DeepCollectionEquality().equals(other.secondaryDimensionShipWeightG, secondaryDimensionShipWeightG)) &&
            (identical(other.secondaryDimensionWeightInCaseKg, secondaryDimensionWeightInCaseKg) || const DeepCollectionEquality().equals(other.secondaryDimensionWeightInCaseKg, secondaryDimensionWeightInCaseKg)) &&
            (identical(other.secondaryDimensionWeightInCaseG, secondaryDimensionWeightInCaseG) || const DeepCollectionEquality().equals(other.secondaryDimensionWeightInCaseG, secondaryDimensionWeightInCaseG)) &&
            (identical(other.secondaryDimensionWidthM, secondaryDimensionWidthM) || const DeepCollectionEquality().equals(other.secondaryDimensionWidthM, secondaryDimensionWidthM)) &&
            (identical(other.secondaryDimensionWidthCm, secondaryDimensionWidthCm) || const DeepCollectionEquality().equals(other.secondaryDimensionWidthCm, secondaryDimensionWidthCm)) &&
            (identical(other.secondaryDimensionHeightM, secondaryDimensionHeightM) || const DeepCollectionEquality().equals(other.secondaryDimensionHeightM, secondaryDimensionHeightM)) &&
            (identical(other.secondaryDimensionHeightCm, secondaryDimensionHeightCm) || const DeepCollectionEquality().equals(other.secondaryDimensionHeightCm, secondaryDimensionHeightCm)) &&
            (identical(other.secondaryDimensionLengthM, secondaryDimensionLengthM) || const DeepCollectionEquality().equals(other.secondaryDimensionLengthM, secondaryDimensionLengthM)) &&
            (identical(other.secondaryDimensionLengthCm, secondaryDimensionLengthCm) || const DeepCollectionEquality().equals(other.secondaryDimensionLengthCm, secondaryDimensionLengthCm)) &&
            (identical(other.countryOfOriginId, countryOfOriginId) || const DeepCollectionEquality().equals(other.countryOfOriginId, countryOfOriginId)) &&
            (identical(other.countryOfOrigin, countryOfOrigin) || const DeepCollectionEquality().equals(other.countryOfOrigin, countryOfOrigin)) &&
            (identical(other.displayInSummaryModeWhenRateIsZero, displayInSummaryModeWhenRateIsZero) || const DeepCollectionEquality().equals(other.displayInSummaryModeWhenRateIsZero, displayInSummaryModeWhenRateIsZero)) &&
            (identical(other.qcRequired, qcRequired) || const DeepCollectionEquality().equals(other.qcRequired, qcRequired)) &&
            (identical(other.qcTime, qcTime) || const DeepCollectionEquality().equals(other.qcTime, qcTime)) &&
            (identical(other.copyAttributesAsNote, copyAttributesAsNote) || const DeepCollectionEquality().equals(other.copyAttributesAsNote, copyAttributesAsNote)) &&
            (identical(other.trackAssetUsage, trackAssetUsage) || const DeepCollectionEquality().equals(other.trackAssetUsage, trackAssetUsage)) &&
            (identical(other.trackLampUsage, trackLampUsage) || const DeepCollectionEquality().equals(other.trackLampUsage, trackLampUsage)) &&
            (identical(other.trackStrikes, trackStrikes) || const DeepCollectionEquality().equals(other.trackStrikes, trackStrikes)) &&
            (identical(other.trackCandles, trackCandles) || const DeepCollectionEquality().equals(other.trackCandles, trackCandles)) &&
            (identical(other.lampCount, lampCount) || const DeepCollectionEquality().equals(other.lampCount, lampCount)) &&
            (identical(other.minimumFootCandles, minimumFootCandles) || const DeepCollectionEquality().equals(other.minimumFootCandles, minimumFootCandles)) &&
            (identical(other.trackSoftware, trackSoftware) || const DeepCollectionEquality().equals(other.trackSoftware, trackSoftware)) &&
            (identical(other.softwareVersion, softwareVersion) || const DeepCollectionEquality().equals(other.softwareVersion, softwareVersion)) &&
            (identical(other.softwareEffectiveDate, softwareEffectiveDate) || const DeepCollectionEquality().equals(other.softwareEffectiveDate, softwareEffectiveDate)) &&
            (identical(other.warehouseSpecificPackage, warehouseSpecificPackage) || const DeepCollectionEquality().equals(other.warehouseSpecificPackage, warehouseSpecificPackage)) &&
            (identical(other.completePackagePrice, completePackagePrice) || const DeepCollectionEquality().equals(other.completePackagePrice, completePackagePrice)) &&
            (identical(other.kitPackagePrice, kitPackagePrice) || const DeepCollectionEquality().equals(other.kitPackagePrice, kitPackagePrice)) &&
            (identical(other.separatePackageOnQuoteOrder, separatePackageOnQuoteOrder) || const DeepCollectionEquality().equals(other.separatePackageOnQuoteOrder, separatePackageOnQuoteOrder)) &&
            (identical(other.containerId, containerId) || const DeepCollectionEquality().equals(other.containerId, containerId)) &&
            (identical(other.containerScannableInventoryId, containerScannableInventoryId) || const DeepCollectionEquality().equals(other.containerScannableInventoryId, containerScannableInventoryId)) &&
            (identical(other.containerScannableICode, containerScannableICode) || const DeepCollectionEquality().equals(other.containerScannableICode, containerScannableICode)) &&
            (identical(other.containerScannableDescription, containerScannableDescription) || const DeepCollectionEquality().equals(other.containerScannableDescription, containerScannableDescription)) &&
            (identical(other.automaticallyRebuildContainerAtCheckIn, automaticallyRebuildContainerAtCheckIn) || const DeepCollectionEquality().equals(other.automaticallyRebuildContainerAtCheckIn, automaticallyRebuildContainerAtCheckIn)) &&
            (identical(other.automaticallyRebuildContainerAtTransferIn, automaticallyRebuildContainerAtTransferIn) || const DeepCollectionEquality().equals(other.automaticallyRebuildContainerAtTransferIn, automaticallyRebuildContainerAtTransferIn)) &&
            (identical(other.containerStagingRule, containerStagingRule) || const DeepCollectionEquality().equals(other.containerStagingRule, containerStagingRule)) &&
            (identical(other.excludeContainedItemsFromAvailability, excludeContainedItemsFromAvailability) || const DeepCollectionEquality().equals(other.excludeContainedItemsFromAvailability, excludeContainedItemsFromAvailability)) &&
            (identical(other.useContainerNumber, useContainerNumber) || const DeepCollectionEquality().equals(other.useContainerNumber, useContainerNumber)) &&
            (identical(other.containerPackingListBehavior, containerPackingListBehavior) || const DeepCollectionEquality().equals(other.containerPackingListBehavior, containerPackingListBehavior)) &&
            (identical(other.inventoryTypeIsWardrobe, inventoryTypeIsWardrobe) || const DeepCollectionEquality().equals(other.inventoryTypeIsWardrobe, inventoryTypeIsWardrobe)) &&
            (identical(other.inventoryTypeIsSets, inventoryTypeIsSets) || const DeepCollectionEquality().equals(other.inventoryTypeIsSets, inventoryTypeIsSets)) &&
            (identical(other.patternId, patternId) || const DeepCollectionEquality().equals(other.patternId, patternId)) &&
            (identical(other.pattern, pattern) || const DeepCollectionEquality().equals(other.pattern, pattern)) &&
            (identical(other.periodId, periodId) || const DeepCollectionEquality().equals(other.periodId, periodId)) &&
            (identical(other.period, period) || const DeepCollectionEquality().equals(other.period, period)) &&
            (identical(other.materialId, materialId) || const DeepCollectionEquality().equals(other.materialId, materialId)) &&
            (identical(other.material, material) || const DeepCollectionEquality().equals(other.material, material)) &&
            (identical(other.genderId, genderId) || const DeepCollectionEquality().equals(other.genderId, genderId)) &&
            (identical(other.gender, gender) || const DeepCollectionEquality().equals(other.gender, gender)) &&
            (identical(other.labelId, labelId) || const DeepCollectionEquality().equals(other.labelId, labelId)) &&
            (identical(other.label, label) || const DeepCollectionEquality().equals(other.label, label)) &&
            (identical(other.wardrobeSize, wardrobeSize) || const DeepCollectionEquality().equals(other.wardrobeSize, wardrobeSize)) &&
            (identical(other.wardrobePieceCount, wardrobePieceCount) || const DeepCollectionEquality().equals(other.wardrobePieceCount, wardrobePieceCount)) &&
            (identical(other.dyed, dyed) || const DeepCollectionEquality().equals(other.dyed, dyed)) &&
            (identical(other.wardrobeSourceId, wardrobeSourceId) || const DeepCollectionEquality().equals(other.wardrobeSourceId, wardrobeSourceId)) &&
            (identical(other.wardrobeSource, wardrobeSource) || const DeepCollectionEquality().equals(other.wardrobeSource, wardrobeSource)) &&
            (identical(other.wardrobeCareId, wardrobeCareId) || const DeepCollectionEquality().equals(other.wardrobeCareId, wardrobeCareId)) &&
            (identical(other.wardrobeCare, wardrobeCare) || const DeepCollectionEquality().equals(other.wardrobeCare, wardrobeCare)) &&
            (identical(other.cleaningFeeAmount, cleaningFeeAmount) || const DeepCollectionEquality().equals(other.cleaningFeeAmount, cleaningFeeAmount)) &&
            (identical(other.wardrobeDetailedDescription, wardrobeDetailedDescription) || const DeepCollectionEquality().equals(other.wardrobeDetailedDescription, wardrobeDetailedDescription)) &&
            (identical(other.webDetailedDescription, webDetailedDescription) || const DeepCollectionEquality().equals(other.webDetailedDescription, webDetailedDescription)) &&
            (identical(other.overrideSystemDefaultRevenueAllocationBehavior, overrideSystemDefaultRevenueAllocationBehavior) || const DeepCollectionEquality().equals(other.overrideSystemDefaultRevenueAllocationBehavior, overrideSystemDefaultRevenueAllocationBehavior)) &&
            (identical(other.allocateRevenueForAccessories, allocateRevenueForAccessories) || const DeepCollectionEquality().equals(other.allocateRevenueForAccessories, allocateRevenueForAccessories)) &&
            (identical(other.packageRevenueCalculationFormula, packageRevenueCalculationFormula) || const DeepCollectionEquality().equals(other.packageRevenueCalculationFormula, packageRevenueCalculationFormula)) &&
            (identical(other.isHazardousMaterial, isHazardousMaterial) || const DeepCollectionEquality().equals(other.isHazardousMaterial, isHazardousMaterial)) &&
            (identical(other.descriptionWithAkas, descriptionWithAkas) || const DeepCollectionEquality().equals(other.descriptionWithAkas, descriptionWithAkas)) &&
            (identical(other.costCalculation, costCalculation) || const DeepCollectionEquality().equals(other.costCalculation, costCalculation)) &&
            (identical(other.quantity, quantity) || const DeepCollectionEquality().equals(other.quantity, quantity)) &&
            (identical(other.aisleLocation, aisleLocation) || const DeepCollectionEquality().equals(other.aisleLocation, aisleLocation)) &&
            (identical(other.shelfLocation, shelfLocation) || const DeepCollectionEquality().equals(other.shelfLocation, shelfLocation)) &&
            (identical(other.taxable, taxable) || const DeepCollectionEquality().equals(other.taxable, taxable)) &&
            (identical(other.iCode, iCode) || const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) || const DeepCollectionEquality().equals(other.description, description)) &&
            (identical(other.availFor, availFor) || const DeepCollectionEquality().equals(other.availFor, availFor)) &&
            (identical(other.categoryId, categoryId) || const DeepCollectionEquality().equals(other.categoryId, categoryId)) &&
            (identical(other.category, category) || const DeepCollectionEquality().equals(other.category, category)) &&
            (identical(other.subCategoryCount, subCategoryCount) || const DeepCollectionEquality().equals(other.subCategoryCount, subCategoryCount)) &&
            (identical(other.subCategoryId, subCategoryId) || const DeepCollectionEquality().equals(other.subCategoryId, subCategoryId)) &&
            (identical(other.subCategory, subCategory) || const DeepCollectionEquality().equals(other.subCategory, subCategory)) &&
            (identical(other.classification, classification) || const DeepCollectionEquality().equals(other.classification, classification)) &&
            (identical(other.classificationDescription, classificationDescription) || const DeepCollectionEquality().equals(other.classificationDescription, classificationDescription)) &&
            (identical(other.classificationColor, classificationColor) || const DeepCollectionEquality().equals(other.classificationColor, classificationColor)) &&
            (identical(other.unitId, unitId) || const DeepCollectionEquality().equals(other.unitId, unitId)) &&
            (identical(other.unit, unit) || const DeepCollectionEquality().equals(other.unit, unit)) &&
            (identical(other.unitType, unitType) || const DeepCollectionEquality().equals(other.unitType, unitType)) &&
            (identical(other.nonDiscountable, nonDiscountable) || const DeepCollectionEquality().equals(other.nonDiscountable, nonDiscountable)) &&
            (identical(other.overrideProfitAndLossCategory, overrideProfitAndLossCategory) || const DeepCollectionEquality().equals(other.overrideProfitAndLossCategory, overrideProfitAndLossCategory)) &&
            (identical(other.profitAndLossCategoryId, profitAndLossCategoryId) || const DeepCollectionEquality().equals(other.profitAndLossCategoryId, profitAndLossCategoryId)) &&
            (identical(other.profitAndLossCategory, profitAndLossCategory) || const DeepCollectionEquality().equals(other.profitAndLossCategory, profitAndLossCategory)) &&
            (identical(other.autoCopyNotesToQuoteOrder, autoCopyNotesToQuoteOrder) || const DeepCollectionEquality().equals(other.autoCopyNotesToQuoteOrder, autoCopyNotesToQuoteOrder)) &&
            (identical(other.note, note) || const DeepCollectionEquality().equals(other.note, note)) &&
            (identical(other.printNoteOnInContract, printNoteOnInContract) || const DeepCollectionEquality().equals(other.printNoteOnInContract, printNoteOnInContract)) &&
            (identical(other.printNoteOnOutContract, printNoteOnOutContract) || const DeepCollectionEquality().equals(other.printNoteOnOutContract, printNoteOnOutContract)) &&
            (identical(other.printNoteOnReceiveContract, printNoteOnReceiveContract) || const DeepCollectionEquality().equals(other.printNoteOnReceiveContract, printNoteOnReceiveContract)) &&
            (identical(other.printNoteOnReturnContract, printNoteOnReturnContract) || const DeepCollectionEquality().equals(other.printNoteOnReturnContract, printNoteOnReturnContract)) &&
            (identical(other.printNoteOnInvoice, printNoteOnInvoice) || const DeepCollectionEquality().equals(other.printNoteOnInvoice, printNoteOnInvoice)) &&
            (identical(other.printNoteOnOrder, printNoteOnOrder) || const DeepCollectionEquality().equals(other.printNoteOnOrder, printNoteOnOrder)) &&
            (identical(other.printNoteOnPickList, printNoteOnPickList) || const DeepCollectionEquality().equals(other.printNoteOnPickList, printNoteOnPickList)) &&
            (identical(other.printNoteOnPO, printNoteOnPO) || const DeepCollectionEquality().equals(other.printNoteOnPO, printNoteOnPO)) &&
            (identical(other.printNoteOnQuote, printNoteOnQuote) || const DeepCollectionEquality().equals(other.printNoteOnQuote, printNoteOnQuote)) &&
            (identical(other.printNoteOnReturnList, printNoteOnReturnList) || const DeepCollectionEquality().equals(other.printNoteOnReturnList, printNoteOnReturnList)) &&
            (identical(other.printNoteOnPoReceiveList, printNoteOnPoReceiveList) || const DeepCollectionEquality().equals(other.printNoteOnPoReceiveList, printNoteOnPoReceiveList)) &&
            (identical(other.printNoteOnPoReturnList, printNoteOnPoReturnList) || const DeepCollectionEquality().equals(other.printNoteOnPoReturnList, printNoteOnPoReturnList)) &&
            (identical(other.assetAccountId, assetAccountId) || const DeepCollectionEquality().equals(other.assetAccountId, assetAccountId)) &&
            (identical(other.assetAccountNo, assetAccountNo) || const DeepCollectionEquality().equals(other.assetAccountNo, assetAccountNo)) &&
            (identical(other.assetAccountDescription, assetAccountDescription) || const DeepCollectionEquality().equals(other.assetAccountDescription, assetAccountDescription)) &&
            (identical(other.incomeAccountId, incomeAccountId) || const DeepCollectionEquality().equals(other.incomeAccountId, incomeAccountId)) &&
            (identical(other.incomeAccountNo, incomeAccountNo) || const DeepCollectionEquality().equals(other.incomeAccountNo, incomeAccountNo)) &&
            (identical(other.incomeAccountDescription, incomeAccountDescription) || const DeepCollectionEquality().equals(other.incomeAccountDescription, incomeAccountDescription)) &&
            (identical(other.subIncomeAccountId, subIncomeAccountId) || const DeepCollectionEquality().equals(other.subIncomeAccountId, subIncomeAccountId)) &&
            (identical(other.subIncomeAccountNo, subIncomeAccountNo) || const DeepCollectionEquality().equals(other.subIncomeAccountNo, subIncomeAccountNo)) &&
            (identical(other.subIncomeAccountDescription, subIncomeAccountDescription) || const DeepCollectionEquality().equals(other.subIncomeAccountDescription, subIncomeAccountDescription)) &&
            (identical(other.consignmentIncomeAccountId, consignmentIncomeAccountId) || const DeepCollectionEquality().equals(other.consignmentIncomeAccountId, consignmentIncomeAccountId)) &&
            (identical(other.consignmentIncomeAccountNo, consignmentIncomeAccountNo) || const DeepCollectionEquality().equals(other.consignmentIncomeAccountNo, consignmentIncomeAccountNo)) &&
            (identical(other.consignmentIncomeAccountDescription, consignmentIncomeAccountDescription) || const DeepCollectionEquality().equals(other.consignmentIncomeAccountDescription, consignmentIncomeAccountDescription)) &&
            (identical(other.ldIncomeAccountId, ldIncomeAccountId) || const DeepCollectionEquality().equals(other.ldIncomeAccountId, ldIncomeAccountId)) &&
            (identical(other.ldIncomeAccountNo, ldIncomeAccountNo) || const DeepCollectionEquality().equals(other.ldIncomeAccountNo, ldIncomeAccountNo)) &&
            (identical(other.ldIncomeAccountDescription, ldIncomeAccountDescription) || const DeepCollectionEquality().equals(other.ldIncomeAccountDescription, ldIncomeAccountDescription)) &&
            (identical(other.equipmentSaleIncomeAccountId, equipmentSaleIncomeAccountId) || const DeepCollectionEquality().equals(other.equipmentSaleIncomeAccountId, equipmentSaleIncomeAccountId)) &&
            (identical(other.equipmentSaleIncomeAccountNo, equipmentSaleIncomeAccountNo) || const DeepCollectionEquality().equals(other.equipmentSaleIncomeAccountNo, equipmentSaleIncomeAccountNo)) &&
            (identical(other.equipmentSaleIncomeAccountDescription, equipmentSaleIncomeAccountDescription) || const DeepCollectionEquality().equals(other.equipmentSaleIncomeAccountDescription, equipmentSaleIncomeAccountDescription)) &&
            (identical(other.expenseAccountId, expenseAccountId) || const DeepCollectionEquality().equals(other.expenseAccountId, expenseAccountId)) &&
            (identical(other.expenseAccountNo, expenseAccountNo) || const DeepCollectionEquality().equals(other.expenseAccountNo, expenseAccountNo)) &&
            (identical(other.expenseAccountDescription, expenseAccountDescription) || const DeepCollectionEquality().equals(other.expenseAccountDescription, expenseAccountDescription)) &&
            (identical(other.costOfGoodsSoldExpenseAccountId, costOfGoodsSoldExpenseAccountId) || const DeepCollectionEquality().equals(other.costOfGoodsSoldExpenseAccountId, costOfGoodsSoldExpenseAccountId)) &&
            (identical(other.costOfGoodsSoldExpenseAccountNo, costOfGoodsSoldExpenseAccountNo) || const DeepCollectionEquality().equals(other.costOfGoodsSoldExpenseAccountNo, costOfGoodsSoldExpenseAccountNo)) &&
            (identical(other.costOfGoodsSoldExpenseAccountDescription, costOfGoodsSoldExpenseAccountDescription) || const DeepCollectionEquality().equals(other.costOfGoodsSoldExpenseAccountDescription, costOfGoodsSoldExpenseAccountDescription)) &&
            (identical(other.costOfGoodsRentedExpenseAccountId, costOfGoodsRentedExpenseAccountId) || const DeepCollectionEquality().equals(other.costOfGoodsRentedExpenseAccountId, costOfGoodsRentedExpenseAccountId)) &&
            (identical(other.costOfGoodsRentedExpenseAccountNo, costOfGoodsRentedExpenseAccountNo) || const DeepCollectionEquality().equals(other.costOfGoodsRentedExpenseAccountNo, costOfGoodsRentedExpenseAccountNo)) &&
            (identical(other.costOfGoodsRentedExpenseAccountDescription, costOfGoodsRentedExpenseAccountDescription) || const DeepCollectionEquality().equals(other.costOfGoodsRentedExpenseAccountDescription, costOfGoodsRentedExpenseAccountDescription)) &&
            (identical(other.depreciationExpenseAccountId, depreciationExpenseAccountId) || const DeepCollectionEquality().equals(other.depreciationExpenseAccountId, depreciationExpenseAccountId)) &&
            (identical(other.depreciationExpenseAccountNo, depreciationExpenseAccountNo) || const DeepCollectionEquality().equals(other.depreciationExpenseAccountNo, depreciationExpenseAccountNo)) &&
            (identical(other.depreciationExpenseAccountDescription, depreciationExpenseAccountDescription) || const DeepCollectionEquality().equals(other.depreciationExpenseAccountDescription, depreciationExpenseAccountDescription)) &&
            (identical(other.accumulatedDepreciationExpenseAccountId, accumulatedDepreciationExpenseAccountId) || const DeepCollectionEquality().equals(other.accumulatedDepreciationExpenseAccountId, accumulatedDepreciationExpenseAccountId)) &&
            (identical(other.accumulatedDepreciationExpenseAccountNo, accumulatedDepreciationExpenseAccountNo) || const DeepCollectionEquality().equals(other.accumulatedDepreciationExpenseAccountNo, accumulatedDepreciationExpenseAccountNo)) &&
            (identical(other.accumulatedDepreciationExpenseAccountDescription, accumulatedDepreciationExpenseAccountDescription) || const DeepCollectionEquality().equals(other.accumulatedDepreciationExpenseAccountDescription, accumulatedDepreciationExpenseAccountDescription)) &&
            (identical(other.originalShowId, originalShowId) || const DeepCollectionEquality().equals(other.originalShowId, originalShowId)) &&
            (identical(other.inactive, inactive) || const DeepCollectionEquality().equals(other.inactive, inactive)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.manifestShippingContainer, manifestShippingContainer) || const DeepCollectionEquality().equals(other.manifestShippingContainer, manifestShippingContainer)) &&
            (identical(other.manifestStandAloneItem, manifestStandAloneItem) || const DeepCollectionEquality().equals(other.manifestStandAloneItem, manifestStandAloneItem)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesInventoryRentalInventoryRentalInventoryExtension
    on WebApiModulesInventoryRentalInventoryRentalInventory {
  WebApiModulesInventoryRentalInventoryRentalInventory copyWith(
      {bool? excludeFromReturnOnAsset,
      bool? isFixedAsset,
      bool? multiAssignRFIDs,
      double? minimumDaysPerWeek,
      String? setOpeningId,
      String? setOpening,
      String? wallTypeId,
      String? wallType,
      String? setSurfaceId,
      String? setSurface,
      int? wallWidthFt,
      int? wallWidthIn,
      int? wallHeightFt,
      int? wallHeightIn,
      int? wallLengthFt,
      int? wallLengthIn,
      double? dailyRate,
      double? weeklyRate,
      double? week2Rate,
      double? week3Rate,
      double? week4Rate,
      double? monthlyRate,
      double? unitValue,
      double? replacementCost,
      String? inventoryId,
      String? inventoryTypeId,
      String? inventoryType,
      String? availableFrom,
      String? trackedBy,
      String? confirmTrackedBy,
      String? rank,
      String? manufacturerPartNumber,
      String? manufacturerId,
      String? manufacturer,
      String? manufacturerUrl,
      bool? excludeImageFromQuoteOrderPrint,
      bool? noAvailabilityCheck,
      bool? availabilityManuallyResolveConflicts,
      bool? sendAvailabilityAlert,
      String? primaryDimensionUniqueId,
      String? defaultImperialMetric,
      String? primaryDimensionDescription,
      int? primaryDimensionShipWeightLbs,
      int? primaryDimensionShipWeightOz,
      int? primaryDimensionWeightInCaseLbs,
      int? primaryDimensionWeightInCaseOz,
      int? primaryDimensionWidthFt,
      int? primaryDimensionWidthIn,
      int? primaryDimensionHeightFt,
      int? primaryDimensionHeightIn,
      int? primaryDimensionLengthFt,
      int? primaryDimensionLengthIn,
      int? primaryDimensionShipWeightKg,
      int? primaryDimensionShipWeightG,
      int? primaryDimensionWeightInCaseKg,
      int? primaryDimensionWeightInCaseG,
      int? primaryDimensionWidthM,
      int? primaryDimensionWidthCm,
      int? primaryDimensionHeightM,
      int? primaryDimensionHeightCm,
      int? primaryDimensionLengthM,
      int? primaryDimensionLengthCm,
      bool? hasSecondaryDimensions,
      String? secondaryDimensionUniqueId,
      String? secondaryDimensionDescription,
      int? secondaryDimensionShipWeightLbs,
      int? secondaryDimensionShipWeightOz,
      int? secondaryDimensionWeightInCaseLbs,
      int? secondaryDimensionWeightInCaseOz,
      int? secondaryDimensionWidthFt,
      int? secondaryDimensionWidthIn,
      int? secondaryDimensionHeightFt,
      int? secondaryDimensionHeightIn,
      int? secondaryDimensionLengthFt,
      int? secondaryDimensionLengthIn,
      int? secondaryDimensionShipWeightKg,
      int? secondaryDimensionShipWeightG,
      int? secondaryDimensionWeightInCaseKg,
      int? secondaryDimensionWeightInCaseG,
      int? secondaryDimensionWidthM,
      int? secondaryDimensionWidthCm,
      int? secondaryDimensionHeightM,
      int? secondaryDimensionHeightCm,
      int? secondaryDimensionLengthM,
      int? secondaryDimensionLengthCm,
      String? countryOfOriginId,
      String? countryOfOrigin,
      bool? displayInSummaryModeWhenRateIsZero,
      bool? qcRequired,
      String? qcTime,
      bool? copyAttributesAsNote,
      bool? trackAssetUsage,
      bool? trackLampUsage,
      bool? trackStrikes,
      bool? trackCandles,
      int? lampCount,
      int? minimumFootCandles,
      bool? trackSoftware,
      String? softwareVersion,
      String? softwareEffectiveDate,
      bool? warehouseSpecificPackage,
      String? completePackagePrice,
      String? kitPackagePrice,
      bool? separatePackageOnQuoteOrder,
      String? containerId,
      String? containerScannableInventoryId,
      String? containerScannableICode,
      String? containerScannableDescription,
      bool? automaticallyRebuildContainerAtCheckIn,
      bool? automaticallyRebuildContainerAtTransferIn,
      String? containerStagingRule,
      bool? excludeContainedItemsFromAvailability,
      bool? useContainerNumber,
      String? containerPackingListBehavior,
      bool? inventoryTypeIsWardrobe,
      bool? inventoryTypeIsSets,
      String? patternId,
      String? pattern,
      String? periodId,
      String? period,
      String? materialId,
      String? material,
      String? genderId,
      String? gender,
      String? labelId,
      String? label,
      String? wardrobeSize,
      int? wardrobePieceCount,
      bool? dyed,
      String? wardrobeSourceId,
      String? wardrobeSource,
      String? wardrobeCareId,
      String? wardrobeCare,
      double? cleaningFeeAmount,
      String? wardrobeDetailedDescription,
      String? webDetailedDescription,
      bool? overrideSystemDefaultRevenueAllocationBehavior,
      bool? allocateRevenueForAccessories,
      String? packageRevenueCalculationFormula,
      bool? isHazardousMaterial,
      String? descriptionWithAkas,
      String? costCalculation,
      double? quantity,
      String? aisleLocation,
      String? shelfLocation,
      bool? taxable,
      String? iCode,
      String? description,
      String? availFor,
      String? categoryId,
      String? category,
      int? subCategoryCount,
      String? subCategoryId,
      String? subCategory,
      String? classification,
      String? classificationDescription,
      String? classificationColor,
      String? unitId,
      String? unit,
      String? unitType,
      bool? nonDiscountable,
      bool? overrideProfitAndLossCategory,
      String? profitAndLossCategoryId,
      String? profitAndLossCategory,
      bool? autoCopyNotesToQuoteOrder,
      String? note,
      bool? printNoteOnInContract,
      bool? printNoteOnOutContract,
      bool? printNoteOnReceiveContract,
      bool? printNoteOnReturnContract,
      bool? printNoteOnInvoice,
      bool? printNoteOnOrder,
      bool? printNoteOnPickList,
      bool? printNoteOnPO,
      bool? printNoteOnQuote,
      bool? printNoteOnReturnList,
      bool? printNoteOnPoReceiveList,
      bool? printNoteOnPoReturnList,
      String? assetAccountId,
      String? assetAccountNo,
      String? assetAccountDescription,
      String? incomeAccountId,
      String? incomeAccountNo,
      String? incomeAccountDescription,
      String? subIncomeAccountId,
      String? subIncomeAccountNo,
      String? subIncomeAccountDescription,
      String? consignmentIncomeAccountId,
      String? consignmentIncomeAccountNo,
      String? consignmentIncomeAccountDescription,
      String? ldIncomeAccountId,
      String? ldIncomeAccountNo,
      String? ldIncomeAccountDescription,
      String? equipmentSaleIncomeAccountId,
      String? equipmentSaleIncomeAccountNo,
      String? equipmentSaleIncomeAccountDescription,
      String? expenseAccountId,
      String? expenseAccountNo,
      String? expenseAccountDescription,
      String? costOfGoodsSoldExpenseAccountId,
      String? costOfGoodsSoldExpenseAccountNo,
      String? costOfGoodsSoldExpenseAccountDescription,
      String? costOfGoodsRentedExpenseAccountId,
      String? costOfGoodsRentedExpenseAccountNo,
      String? costOfGoodsRentedExpenseAccountDescription,
      String? depreciationExpenseAccountId,
      String? depreciationExpenseAccountNo,
      String? depreciationExpenseAccountDescription,
      String? accumulatedDepreciationExpenseAccountId,
      String? accumulatedDepreciationExpenseAccountNo,
      String? accumulatedDepreciationExpenseAccountDescription,
      String? originalShowId,
      bool? inactive,
      String? dateStamp,
      bool? manifestShippingContainer,
      bool? manifestStandAloneItem,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesInventoryRentalInventoryRentalInventory(
        excludeFromReturnOnAsset:
            excludeFromReturnOnAsset ?? this.excludeFromReturnOnAsset,
        isFixedAsset: isFixedAsset ?? this.isFixedAsset,
        multiAssignRFIDs: multiAssignRFIDs ?? this.multiAssignRFIDs,
        minimumDaysPerWeek: minimumDaysPerWeek ?? this.minimumDaysPerWeek,
        setOpeningId: setOpeningId ?? this.setOpeningId,
        setOpening: setOpening ?? this.setOpening,
        wallTypeId: wallTypeId ?? this.wallTypeId,
        wallType: wallType ?? this.wallType,
        setSurfaceId: setSurfaceId ?? this.setSurfaceId,
        setSurface: setSurface ?? this.setSurface,
        wallWidthFt: wallWidthFt ?? this.wallWidthFt,
        wallWidthIn: wallWidthIn ?? this.wallWidthIn,
        wallHeightFt: wallHeightFt ?? this.wallHeightFt,
        wallHeightIn: wallHeightIn ?? this.wallHeightIn,
        wallLengthFt: wallLengthFt ?? this.wallLengthFt,
        wallLengthIn: wallLengthIn ?? this.wallLengthIn,
        dailyRate: dailyRate ?? this.dailyRate,
        weeklyRate: weeklyRate ?? this.weeklyRate,
        week2Rate: week2Rate ?? this.week2Rate,
        week3Rate: week3Rate ?? this.week3Rate,
        week4Rate: week4Rate ?? this.week4Rate,
        monthlyRate: monthlyRate ?? this.monthlyRate,
        unitValue: unitValue ?? this.unitValue,
        replacementCost: replacementCost ?? this.replacementCost,
        inventoryId: inventoryId ?? this.inventoryId,
        inventoryTypeId: inventoryTypeId ?? this.inventoryTypeId,
        inventoryType: inventoryType ?? this.inventoryType,
        availableFrom: availableFrom ?? this.availableFrom,
        trackedBy: trackedBy ?? this.trackedBy,
        confirmTrackedBy: confirmTrackedBy ?? this.confirmTrackedBy,
        rank: rank ?? this.rank,
        manufacturerPartNumber:
            manufacturerPartNumber ?? this.manufacturerPartNumber,
        manufacturerId: manufacturerId ?? this.manufacturerId,
        manufacturer: manufacturer ?? this.manufacturer,
        manufacturerUrl: manufacturerUrl ?? this.manufacturerUrl,
        excludeImageFromQuoteOrderPrint: excludeImageFromQuoteOrderPrint ??
            this.excludeImageFromQuoteOrderPrint,
        noAvailabilityCheck: noAvailabilityCheck ?? this.noAvailabilityCheck,
        availabilityManuallyResolveConflicts: availabilityManuallyResolveConflicts ??
            this.availabilityManuallyResolveConflicts,
        sendAvailabilityAlert:
            sendAvailabilityAlert ?? this.sendAvailabilityAlert,
        primaryDimensionUniqueId:
            primaryDimensionUniqueId ?? this.primaryDimensionUniqueId,
        defaultImperialMetric:
            defaultImperialMetric ?? this.defaultImperialMetric,
        primaryDimensionDescription:
            primaryDimensionDescription ?? this.primaryDimensionDescription,
        primaryDimensionShipWeightLbs:
            primaryDimensionShipWeightLbs ?? this.primaryDimensionShipWeightLbs,
        primaryDimensionShipWeightOz:
            primaryDimensionShipWeightOz ?? this.primaryDimensionShipWeightOz,
        primaryDimensionWeightInCaseLbs: primaryDimensionWeightInCaseLbs ??
            this.primaryDimensionWeightInCaseLbs,
        primaryDimensionWeightInCaseOz: primaryDimensionWeightInCaseOz ??
            this.primaryDimensionWeightInCaseOz,
        primaryDimensionWidthFt:
            primaryDimensionWidthFt ?? this.primaryDimensionWidthFt,
        primaryDimensionWidthIn:
            primaryDimensionWidthIn ?? this.primaryDimensionWidthIn,
        primaryDimensionHeightFt:
            primaryDimensionHeightFt ?? this.primaryDimensionHeightFt,
        primaryDimensionHeightIn:
            primaryDimensionHeightIn ?? this.primaryDimensionHeightIn,
        primaryDimensionLengthFt:
            primaryDimensionLengthFt ?? this.primaryDimensionLengthFt,
        primaryDimensionLengthIn:
            primaryDimensionLengthIn ?? this.primaryDimensionLengthIn,
        primaryDimensionShipWeightKg:
            primaryDimensionShipWeightKg ?? this.primaryDimensionShipWeightKg,
        primaryDimensionShipWeightG:
            primaryDimensionShipWeightG ?? this.primaryDimensionShipWeightG,
        primaryDimensionWeightInCaseKg: primaryDimensionWeightInCaseKg ??
            this.primaryDimensionWeightInCaseKg,
        primaryDimensionWeightInCaseG:
            primaryDimensionWeightInCaseG ?? this.primaryDimensionWeightInCaseG,
        primaryDimensionWidthM:
            primaryDimensionWidthM ?? this.primaryDimensionWidthM,
        primaryDimensionWidthCm:
            primaryDimensionWidthCm ?? this.primaryDimensionWidthCm,
        primaryDimensionHeightM:
            primaryDimensionHeightM ?? this.primaryDimensionHeightM,
        primaryDimensionHeightCm:
            primaryDimensionHeightCm ?? this.primaryDimensionHeightCm,
        primaryDimensionLengthM:
            primaryDimensionLengthM ?? this.primaryDimensionLengthM,
        primaryDimensionLengthCm:
            primaryDimensionLengthCm ?? this.primaryDimensionLengthCm,
        hasSecondaryDimensions:
            hasSecondaryDimensions ?? this.hasSecondaryDimensions,
        secondaryDimensionUniqueId:
            secondaryDimensionUniqueId ?? this.secondaryDimensionUniqueId,
        secondaryDimensionDescription:
            secondaryDimensionDescription ?? this.secondaryDimensionDescription,
        secondaryDimensionShipWeightLbs: secondaryDimensionShipWeightLbs ??
            this.secondaryDimensionShipWeightLbs,
        secondaryDimensionShipWeightOz: secondaryDimensionShipWeightOz ??
            this.secondaryDimensionShipWeightOz,
        secondaryDimensionWeightInCaseLbs: secondaryDimensionWeightInCaseLbs ??
            this.secondaryDimensionWeightInCaseLbs,
        secondaryDimensionWeightInCaseOz: secondaryDimensionWeightInCaseOz ??
            this.secondaryDimensionWeightInCaseOz,
        secondaryDimensionWidthFt:
            secondaryDimensionWidthFt ?? this.secondaryDimensionWidthFt,
        secondaryDimensionWidthIn:
            secondaryDimensionWidthIn ?? this.secondaryDimensionWidthIn,
        secondaryDimensionHeightFt:
            secondaryDimensionHeightFt ?? this.secondaryDimensionHeightFt,
        secondaryDimensionHeightIn:
            secondaryDimensionHeightIn ?? this.secondaryDimensionHeightIn,
        secondaryDimensionLengthFt:
            secondaryDimensionLengthFt ?? this.secondaryDimensionLengthFt,
        secondaryDimensionLengthIn:
            secondaryDimensionLengthIn ?? this.secondaryDimensionLengthIn,
        secondaryDimensionShipWeightKg: secondaryDimensionShipWeightKg ??
            this.secondaryDimensionShipWeightKg,
        secondaryDimensionShipWeightG:
            secondaryDimensionShipWeightG ?? this.secondaryDimensionShipWeightG,
        secondaryDimensionWeightInCaseKg: secondaryDimensionWeightInCaseKg ??
            this.secondaryDimensionWeightInCaseKg,
        secondaryDimensionWeightInCaseG: secondaryDimensionWeightInCaseG ??
            this.secondaryDimensionWeightInCaseG,
        secondaryDimensionWidthM:
            secondaryDimensionWidthM ?? this.secondaryDimensionWidthM,
        secondaryDimensionWidthCm:
            secondaryDimensionWidthCm ?? this.secondaryDimensionWidthCm,
        secondaryDimensionHeightM:
            secondaryDimensionHeightM ?? this.secondaryDimensionHeightM,
        secondaryDimensionHeightCm:
            secondaryDimensionHeightCm ?? this.secondaryDimensionHeightCm,
        secondaryDimensionLengthM:
            secondaryDimensionLengthM ?? this.secondaryDimensionLengthM,
        secondaryDimensionLengthCm:
            secondaryDimensionLengthCm ?? this.secondaryDimensionLengthCm,
        countryOfOriginId: countryOfOriginId ?? this.countryOfOriginId,
        countryOfOrigin: countryOfOrigin ?? this.countryOfOrigin,
        displayInSummaryModeWhenRateIsZero: displayInSummaryModeWhenRateIsZero ??
            this.displayInSummaryModeWhenRateIsZero,
        qcRequired: qcRequired ?? this.qcRequired,
        qcTime: qcTime ?? this.qcTime,
        copyAttributesAsNote: copyAttributesAsNote ?? this.copyAttributesAsNote,
        trackAssetUsage: trackAssetUsage ?? this.trackAssetUsage,
        trackLampUsage: trackLampUsage ?? this.trackLampUsage,
        trackStrikes: trackStrikes ?? this.trackStrikes,
        trackCandles: trackCandles ?? this.trackCandles,
        lampCount: lampCount ?? this.lampCount,
        minimumFootCandles: minimumFootCandles ?? this.minimumFootCandles,
        trackSoftware: trackSoftware ?? this.trackSoftware,
        softwareVersion: softwareVersion ?? this.softwareVersion,
        softwareEffectiveDate:
            softwareEffectiveDate ?? this.softwareEffectiveDate,
        warehouseSpecificPackage:
            warehouseSpecificPackage ?? this.warehouseSpecificPackage,
        completePackagePrice: completePackagePrice ?? this.completePackagePrice,
        kitPackagePrice: kitPackagePrice ?? this.kitPackagePrice,
        separatePackageOnQuoteOrder:
            separatePackageOnQuoteOrder ?? this.separatePackageOnQuoteOrder,
        containerId: containerId ?? this.containerId,
        containerScannableInventoryId:
            containerScannableInventoryId ?? this.containerScannableInventoryId,
        containerScannableICode:
            containerScannableICode ?? this.containerScannableICode,
        containerScannableDescription:
            containerScannableDescription ?? this.containerScannableDescription,
        automaticallyRebuildContainerAtCheckIn: automaticallyRebuildContainerAtCheckIn ??
            this.automaticallyRebuildContainerAtCheckIn,
        automaticallyRebuildContainerAtTransferIn:
            automaticallyRebuildContainerAtTransferIn ?? this.automaticallyRebuildContainerAtTransferIn,
        containerStagingRule: containerStagingRule ?? this.containerStagingRule,
        excludeContainedItemsFromAvailability: excludeContainedItemsFromAvailability ?? this.excludeContainedItemsFromAvailability,
        useContainerNumber: useContainerNumber ?? this.useContainerNumber,
        containerPackingListBehavior: containerPackingListBehavior ?? this.containerPackingListBehavior,
        inventoryTypeIsWardrobe: inventoryTypeIsWardrobe ?? this.inventoryTypeIsWardrobe,
        inventoryTypeIsSets: inventoryTypeIsSets ?? this.inventoryTypeIsSets,
        patternId: patternId ?? this.patternId,
        pattern: pattern ?? this.pattern,
        periodId: periodId ?? this.periodId,
        period: period ?? this.period,
        materialId: materialId ?? this.materialId,
        material: material ?? this.material,
        genderId: genderId ?? this.genderId,
        gender: gender ?? this.gender,
        labelId: labelId ?? this.labelId,
        label: label ?? this.label,
        wardrobeSize: wardrobeSize ?? this.wardrobeSize,
        wardrobePieceCount: wardrobePieceCount ?? this.wardrobePieceCount,
        dyed: dyed ?? this.dyed,
        wardrobeSourceId: wardrobeSourceId ?? this.wardrobeSourceId,
        wardrobeSource: wardrobeSource ?? this.wardrobeSource,
        wardrobeCareId: wardrobeCareId ?? this.wardrobeCareId,
        wardrobeCare: wardrobeCare ?? this.wardrobeCare,
        cleaningFeeAmount: cleaningFeeAmount ?? this.cleaningFeeAmount,
        wardrobeDetailedDescription: wardrobeDetailedDescription ?? this.wardrobeDetailedDescription,
        webDetailedDescription: webDetailedDescription ?? this.webDetailedDescription,
        overrideSystemDefaultRevenueAllocationBehavior: overrideSystemDefaultRevenueAllocationBehavior ?? this.overrideSystemDefaultRevenueAllocationBehavior,
        allocateRevenueForAccessories: allocateRevenueForAccessories ?? this.allocateRevenueForAccessories,
        packageRevenueCalculationFormula: packageRevenueCalculationFormula ?? this.packageRevenueCalculationFormula,
        isHazardousMaterial: isHazardousMaterial ?? this.isHazardousMaterial,
        descriptionWithAkas: descriptionWithAkas ?? this.descriptionWithAkas,
        costCalculation: costCalculation ?? this.costCalculation,
        quantity: quantity ?? this.quantity,
        aisleLocation: aisleLocation ?? this.aisleLocation,
        shelfLocation: shelfLocation ?? this.shelfLocation,
        taxable: taxable ?? this.taxable,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        availFor: availFor ?? this.availFor,
        categoryId: categoryId ?? this.categoryId,
        category: category ?? this.category,
        subCategoryCount: subCategoryCount ?? this.subCategoryCount,
        subCategoryId: subCategoryId ?? this.subCategoryId,
        subCategory: subCategory ?? this.subCategory,
        classification: classification ?? this.classification,
        classificationDescription: classificationDescription ?? this.classificationDescription,
        classificationColor: classificationColor ?? this.classificationColor,
        unitId: unitId ?? this.unitId,
        unit: unit ?? this.unit,
        unitType: unitType ?? this.unitType,
        nonDiscountable: nonDiscountable ?? this.nonDiscountable,
        overrideProfitAndLossCategory: overrideProfitAndLossCategory ?? this.overrideProfitAndLossCategory,
        profitAndLossCategoryId: profitAndLossCategoryId ?? this.profitAndLossCategoryId,
        profitAndLossCategory: profitAndLossCategory ?? this.profitAndLossCategory,
        autoCopyNotesToQuoteOrder: autoCopyNotesToQuoteOrder ?? this.autoCopyNotesToQuoteOrder,
        note: note ?? this.note,
        printNoteOnInContract: printNoteOnInContract ?? this.printNoteOnInContract,
        printNoteOnOutContract: printNoteOnOutContract ?? this.printNoteOnOutContract,
        printNoteOnReceiveContract: printNoteOnReceiveContract ?? this.printNoteOnReceiveContract,
        printNoteOnReturnContract: printNoteOnReturnContract ?? this.printNoteOnReturnContract,
        printNoteOnInvoice: printNoteOnInvoice ?? this.printNoteOnInvoice,
        printNoteOnOrder: printNoteOnOrder ?? this.printNoteOnOrder,
        printNoteOnPickList: printNoteOnPickList ?? this.printNoteOnPickList,
        printNoteOnPO: printNoteOnPO ?? this.printNoteOnPO,
        printNoteOnQuote: printNoteOnQuote ?? this.printNoteOnQuote,
        printNoteOnReturnList: printNoteOnReturnList ?? this.printNoteOnReturnList,
        printNoteOnPoReceiveList: printNoteOnPoReceiveList ?? this.printNoteOnPoReceiveList,
        printNoteOnPoReturnList: printNoteOnPoReturnList ?? this.printNoteOnPoReturnList,
        assetAccountId: assetAccountId ?? this.assetAccountId,
        assetAccountNo: assetAccountNo ?? this.assetAccountNo,
        assetAccountDescription: assetAccountDescription ?? this.assetAccountDescription,
        incomeAccountId: incomeAccountId ?? this.incomeAccountId,
        incomeAccountNo: incomeAccountNo ?? this.incomeAccountNo,
        incomeAccountDescription: incomeAccountDescription ?? this.incomeAccountDescription,
        subIncomeAccountId: subIncomeAccountId ?? this.subIncomeAccountId,
        subIncomeAccountNo: subIncomeAccountNo ?? this.subIncomeAccountNo,
        subIncomeAccountDescription: subIncomeAccountDescription ?? this.subIncomeAccountDescription,
        consignmentIncomeAccountId: consignmentIncomeAccountId ?? this.consignmentIncomeAccountId,
        consignmentIncomeAccountNo: consignmentIncomeAccountNo ?? this.consignmentIncomeAccountNo,
        consignmentIncomeAccountDescription: consignmentIncomeAccountDescription ?? this.consignmentIncomeAccountDescription,
        ldIncomeAccountId: ldIncomeAccountId ?? this.ldIncomeAccountId,
        ldIncomeAccountNo: ldIncomeAccountNo ?? this.ldIncomeAccountNo,
        ldIncomeAccountDescription: ldIncomeAccountDescription ?? this.ldIncomeAccountDescription,
        equipmentSaleIncomeAccountId: equipmentSaleIncomeAccountId ?? this.equipmentSaleIncomeAccountId,
        equipmentSaleIncomeAccountNo: equipmentSaleIncomeAccountNo ?? this.equipmentSaleIncomeAccountNo,
        equipmentSaleIncomeAccountDescription: equipmentSaleIncomeAccountDescription ?? this.equipmentSaleIncomeAccountDescription,
        expenseAccountId: expenseAccountId ?? this.expenseAccountId,
        expenseAccountNo: expenseAccountNo ?? this.expenseAccountNo,
        expenseAccountDescription: expenseAccountDescription ?? this.expenseAccountDescription,
        costOfGoodsSoldExpenseAccountId: costOfGoodsSoldExpenseAccountId ?? this.costOfGoodsSoldExpenseAccountId,
        costOfGoodsSoldExpenseAccountNo: costOfGoodsSoldExpenseAccountNo ?? this.costOfGoodsSoldExpenseAccountNo,
        costOfGoodsSoldExpenseAccountDescription: costOfGoodsSoldExpenseAccountDescription ?? this.costOfGoodsSoldExpenseAccountDescription,
        costOfGoodsRentedExpenseAccountId: costOfGoodsRentedExpenseAccountId ?? this.costOfGoodsRentedExpenseAccountId,
        costOfGoodsRentedExpenseAccountNo: costOfGoodsRentedExpenseAccountNo ?? this.costOfGoodsRentedExpenseAccountNo,
        costOfGoodsRentedExpenseAccountDescription: costOfGoodsRentedExpenseAccountDescription ?? this.costOfGoodsRentedExpenseAccountDescription,
        depreciationExpenseAccountId: depreciationExpenseAccountId ?? this.depreciationExpenseAccountId,
        depreciationExpenseAccountNo: depreciationExpenseAccountNo ?? this.depreciationExpenseAccountNo,
        depreciationExpenseAccountDescription: depreciationExpenseAccountDescription ?? this.depreciationExpenseAccountDescription,
        accumulatedDepreciationExpenseAccountId: accumulatedDepreciationExpenseAccountId ?? this.accumulatedDepreciationExpenseAccountId,
        accumulatedDepreciationExpenseAccountNo: accumulatedDepreciationExpenseAccountNo ?? this.accumulatedDepreciationExpenseAccountNo,
        accumulatedDepreciationExpenseAccountDescription: accumulatedDepreciationExpenseAccountDescription ?? this.accumulatedDepreciationExpenseAccountDescription,
        originalShowId: originalShowId ?? this.originalShowId,
        inactive: inactive ?? this.inactive,
        dateStamp: dateStamp ?? this.dateStamp,
        manifestShippingContainer: manifestShippingContainer ?? this.manifestShippingContainer,
        manifestStandAloneItem: manifestStandAloneItem ?? this.manifestStandAloneItem,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes: defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryRentalInventoryRentalInventoryDetailResponse {
  WebApiModulesInventoryRentalInventoryRentalInventoryDetailResponse({
    this.excludeFromReturnOnAsset,
    this.isFixedAsset,
    this.multiAssignRFIDs,
    this.minimumDaysPerWeek,
    this.setOpeningId,
    this.setOpening,
    this.wallTypeId,
    this.wallType,
    this.setSurfaceId,
    this.setSurface,
    this.wallWidthFt,
    this.wallWidthIn,
    this.wallHeightFt,
    this.wallHeightIn,
    this.wallLengthFt,
    this.wallLengthIn,
    this.dailyRate,
    this.weeklyRate,
    this.week2Rate,
    this.week3Rate,
    this.week4Rate,
    this.monthlyRate,
    this.unitValue,
    this.replacementCost,
    this.inventoryId,
    this.inventoryTypeId,
    this.inventoryType,
    this.availableFrom,
    this.trackedBy,
    this.confirmTrackedBy,
    this.rank,
    this.manufacturerPartNumber,
    this.manufacturerId,
    this.manufacturer,
    this.manufacturerUrl,
    this.excludeImageFromQuoteOrderPrint,
    this.noAvailabilityCheck,
    this.availabilityManuallyResolveConflicts,
    this.sendAvailabilityAlert,
    this.primaryDimensionUniqueId,
    this.defaultImperialMetric,
    this.primaryDimensionDescription,
    this.primaryDimensionShipWeightLbs,
    this.primaryDimensionShipWeightOz,
    this.primaryDimensionWeightInCaseLbs,
    this.primaryDimensionWeightInCaseOz,
    this.primaryDimensionWidthFt,
    this.primaryDimensionWidthIn,
    this.primaryDimensionHeightFt,
    this.primaryDimensionHeightIn,
    this.primaryDimensionLengthFt,
    this.primaryDimensionLengthIn,
    this.primaryDimensionShipWeightKg,
    this.primaryDimensionShipWeightG,
    this.primaryDimensionWeightInCaseKg,
    this.primaryDimensionWeightInCaseG,
    this.primaryDimensionWidthM,
    this.primaryDimensionWidthCm,
    this.primaryDimensionHeightM,
    this.primaryDimensionHeightCm,
    this.primaryDimensionLengthM,
    this.primaryDimensionLengthCm,
    this.hasSecondaryDimensions,
    this.secondaryDimensionUniqueId,
    this.secondaryDimensionDescription,
    this.secondaryDimensionShipWeightLbs,
    this.secondaryDimensionShipWeightOz,
    this.secondaryDimensionWeightInCaseLbs,
    this.secondaryDimensionWeightInCaseOz,
    this.secondaryDimensionWidthFt,
    this.secondaryDimensionWidthIn,
    this.secondaryDimensionHeightFt,
    this.secondaryDimensionHeightIn,
    this.secondaryDimensionLengthFt,
    this.secondaryDimensionLengthIn,
    this.secondaryDimensionShipWeightKg,
    this.secondaryDimensionShipWeightG,
    this.secondaryDimensionWeightInCaseKg,
    this.secondaryDimensionWeightInCaseG,
    this.secondaryDimensionWidthM,
    this.secondaryDimensionWidthCm,
    this.secondaryDimensionHeightM,
    this.secondaryDimensionHeightCm,
    this.secondaryDimensionLengthM,
    this.secondaryDimensionLengthCm,
    this.countryOfOriginId,
    this.countryOfOrigin,
    this.displayInSummaryModeWhenRateIsZero,
    this.qcRequired,
    this.qcTime,
    this.copyAttributesAsNote,
    this.trackAssetUsage,
    this.trackLampUsage,
    this.trackStrikes,
    this.trackCandles,
    this.lampCount,
    this.minimumFootCandles,
    this.trackSoftware,
    this.softwareVersion,
    this.softwareEffectiveDate,
    this.warehouseSpecificPackage,
    this.completePackagePrice,
    this.kitPackagePrice,
    this.separatePackageOnQuoteOrder,
    this.containerId,
    this.containerScannableInventoryId,
    this.containerScannableICode,
    this.containerScannableDescription,
    this.automaticallyRebuildContainerAtCheckIn,
    this.automaticallyRebuildContainerAtTransferIn,
    this.containerStagingRule,
    this.excludeContainedItemsFromAvailability,
    this.useContainerNumber,
    this.containerPackingListBehavior,
    this.inventoryTypeIsWardrobe,
    this.inventoryTypeIsSets,
    this.patternId,
    this.pattern,
    this.periodId,
    this.period,
    this.materialId,
    this.material,
    this.genderId,
    this.gender,
    this.labelId,
    this.label,
    this.wardrobeSize,
    this.wardrobePieceCount,
    this.dyed,
    this.wardrobeSourceId,
    this.wardrobeSource,
    this.wardrobeCareId,
    this.wardrobeCare,
    this.cleaningFeeAmount,
    this.wardrobeDetailedDescription,
    this.webDetailedDescription,
    this.overrideSystemDefaultRevenueAllocationBehavior,
    this.allocateRevenueForAccessories,
    this.packageRevenueCalculationFormula,
    this.isHazardousMaterial,
    this.descriptionWithAkas,
    this.costCalculation,
    this.quantity,
    this.aisleLocation,
    this.shelfLocation,
    this.taxable,
    this.iCode,
    this.description,
    this.availFor,
    this.categoryId,
    this.category,
    this.subCategoryCount,
    this.subCategoryId,
    this.subCategory,
    this.classification,
    this.classificationDescription,
    this.classificationColor,
    this.unitId,
    this.unit,
    this.unitType,
    this.nonDiscountable,
    this.overrideProfitAndLossCategory,
    this.profitAndLossCategoryId,
    this.profitAndLossCategory,
    this.autoCopyNotesToQuoteOrder,
    this.note,
    this.printNoteOnInContract,
    this.printNoteOnOutContract,
    this.printNoteOnReceiveContract,
    this.printNoteOnReturnContract,
    this.printNoteOnInvoice,
    this.printNoteOnOrder,
    this.printNoteOnPickList,
    this.printNoteOnPO,
    this.printNoteOnQuote,
    this.printNoteOnReturnList,
    this.printNoteOnPoReceiveList,
    this.printNoteOnPoReturnList,
    this.assetAccountId,
    this.assetAccountNo,
    this.assetAccountDescription,
    this.incomeAccountId,
    this.incomeAccountNo,
    this.incomeAccountDescription,
    this.subIncomeAccountId,
    this.subIncomeAccountNo,
    this.subIncomeAccountDescription,
    this.consignmentIncomeAccountId,
    this.consignmentIncomeAccountNo,
    this.consignmentIncomeAccountDescription,
    this.ldIncomeAccountId,
    this.ldIncomeAccountNo,
    this.ldIncomeAccountDescription,
    this.equipmentSaleIncomeAccountId,
    this.equipmentSaleIncomeAccountNo,
    this.equipmentSaleIncomeAccountDescription,
    this.expenseAccountId,
    this.expenseAccountNo,
    this.expenseAccountDescription,
    this.costOfGoodsSoldExpenseAccountId,
    this.costOfGoodsSoldExpenseAccountNo,
    this.costOfGoodsSoldExpenseAccountDescription,
    this.costOfGoodsRentedExpenseAccountId,
    this.costOfGoodsRentedExpenseAccountNo,
    this.costOfGoodsRentedExpenseAccountDescription,
    this.depreciationExpenseAccountId,
    this.depreciationExpenseAccountNo,
    this.depreciationExpenseAccountDescription,
    this.accumulatedDepreciationExpenseAccountId,
    this.accumulatedDepreciationExpenseAccountNo,
    this.accumulatedDepreciationExpenseAccountDescription,
    this.originalShowId,
    this.inactive,
    this.dateStamp,
    this.manifestShippingContainer,
    this.manifestStandAloneItem,
    this.recordTitle,
    this.fields,
    this.warehouses,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesInventoryRentalInventoryRentalInventoryDetailResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryRentalInventoryRentalInventoryDetailResponseFromJson(
          json);

  @JsonKey(name: 'ExcludeFromReturnOnAsset')
  final bool? excludeFromReturnOnAsset;
  @JsonKey(name: 'IsFixedAsset')
  final bool? isFixedAsset;
  @JsonKey(name: 'MultiAssignRFIDs')
  final bool? multiAssignRFIDs;
  @JsonKey(name: 'MinimumDaysPerWeek')
  final double? minimumDaysPerWeek;
  @JsonKey(name: 'SetOpeningId')
  final String? setOpeningId;
  @JsonKey(name: 'SetOpening')
  final String? setOpening;
  @JsonKey(name: 'WallTypeId')
  final String? wallTypeId;
  @JsonKey(name: 'WallType')
  final String? wallType;
  @JsonKey(name: 'SetSurfaceId')
  final String? setSurfaceId;
  @JsonKey(name: 'SetSurface')
  final String? setSurface;
  @JsonKey(name: 'WallWidthFt')
  final int? wallWidthFt;
  @JsonKey(name: 'WallWidthIn')
  final int? wallWidthIn;
  @JsonKey(name: 'WallHeightFt')
  final int? wallHeightFt;
  @JsonKey(name: 'WallHeightIn')
  final int? wallHeightIn;
  @JsonKey(name: 'WallLengthFt')
  final int? wallLengthFt;
  @JsonKey(name: 'WallLengthIn')
  final int? wallLengthIn;
  @JsonKey(name: 'DailyRate')
  final double? dailyRate;
  @JsonKey(name: 'WeeklyRate')
  final double? weeklyRate;
  @JsonKey(name: 'Week2Rate')
  final double? week2Rate;
  @JsonKey(name: 'Week3Rate')
  final double? week3Rate;
  @JsonKey(name: 'Week4Rate')
  final double? week4Rate;
  @JsonKey(name: 'MonthlyRate')
  final double? monthlyRate;
  @JsonKey(name: 'UnitValue')
  final double? unitValue;
  @JsonKey(name: 'ReplacementCost')
  final double? replacementCost;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'InventoryTypeId')
  final String? inventoryTypeId;
  @JsonKey(name: 'InventoryType')
  final String? inventoryType;
  @JsonKey(name: 'AvailableFrom')
  final String? availableFrom;
  @JsonKey(name: 'TrackedBy')
  final String? trackedBy;
  @JsonKey(name: 'ConfirmTrackedBy')
  final String? confirmTrackedBy;
  @JsonKey(name: 'Rank')
  final String? rank;
  @JsonKey(name: 'ManufacturerPartNumber')
  final String? manufacturerPartNumber;
  @JsonKey(name: 'ManufacturerId')
  final String? manufacturerId;
  @JsonKey(name: 'Manufacturer')
  final String? manufacturer;
  @JsonKey(name: 'ManufacturerUrl')
  final String? manufacturerUrl;
  @JsonKey(name: 'ExcludeImageFromQuoteOrderPrint')
  final bool? excludeImageFromQuoteOrderPrint;
  @JsonKey(name: 'NoAvailabilityCheck')
  final bool? noAvailabilityCheck;
  @JsonKey(name: 'AvailabilityManuallyResolveConflicts')
  final bool? availabilityManuallyResolveConflicts;
  @JsonKey(name: 'SendAvailabilityAlert')
  final bool? sendAvailabilityAlert;
  @JsonKey(name: 'PrimaryDimensionUniqueId')
  final String? primaryDimensionUniqueId;
  @JsonKey(name: 'DefaultImperialMetric')
  final String? defaultImperialMetric;
  @JsonKey(name: 'PrimaryDimensionDescription')
  final String? primaryDimensionDescription;
  @JsonKey(name: 'PrimaryDimensionShipWeightLbs')
  final int? primaryDimensionShipWeightLbs;
  @JsonKey(name: 'PrimaryDimensionShipWeightOz')
  final int? primaryDimensionShipWeightOz;
  @JsonKey(name: 'PrimaryDimensionWeightInCaseLbs')
  final int? primaryDimensionWeightInCaseLbs;
  @JsonKey(name: 'PrimaryDimensionWeightInCaseOz')
  final int? primaryDimensionWeightInCaseOz;
  @JsonKey(name: 'PrimaryDimensionWidthFt')
  final int? primaryDimensionWidthFt;
  @JsonKey(name: 'PrimaryDimensionWidthIn')
  final int? primaryDimensionWidthIn;
  @JsonKey(name: 'PrimaryDimensionHeightFt')
  final int? primaryDimensionHeightFt;
  @JsonKey(name: 'PrimaryDimensionHeightIn')
  final int? primaryDimensionHeightIn;
  @JsonKey(name: 'PrimaryDimensionLengthFt')
  final int? primaryDimensionLengthFt;
  @JsonKey(name: 'PrimaryDimensionLengthIn')
  final int? primaryDimensionLengthIn;
  @JsonKey(name: 'PrimaryDimensionShipWeightKg')
  final int? primaryDimensionShipWeightKg;
  @JsonKey(name: 'PrimaryDimensionShipWeightG')
  final int? primaryDimensionShipWeightG;
  @JsonKey(name: 'PrimaryDimensionWeightInCaseKg')
  final int? primaryDimensionWeightInCaseKg;
  @JsonKey(name: 'PrimaryDimensionWeightInCaseG')
  final int? primaryDimensionWeightInCaseG;
  @JsonKey(name: 'PrimaryDimensionWidthM')
  final int? primaryDimensionWidthM;
  @JsonKey(name: 'PrimaryDimensionWidthCm')
  final int? primaryDimensionWidthCm;
  @JsonKey(name: 'PrimaryDimensionHeightM')
  final int? primaryDimensionHeightM;
  @JsonKey(name: 'PrimaryDimensionHeightCm')
  final int? primaryDimensionHeightCm;
  @JsonKey(name: 'PrimaryDimensionLengthM')
  final int? primaryDimensionLengthM;
  @JsonKey(name: 'PrimaryDimensionLengthCm')
  final int? primaryDimensionLengthCm;
  @JsonKey(name: 'HasSecondaryDimensions')
  final bool? hasSecondaryDimensions;
  @JsonKey(name: 'SecondaryDimensionUniqueId')
  final String? secondaryDimensionUniqueId;
  @JsonKey(name: 'SecondaryDimensionDescription')
  final String? secondaryDimensionDescription;
  @JsonKey(name: 'SecondaryDimensionShipWeightLbs')
  final int? secondaryDimensionShipWeightLbs;
  @JsonKey(name: 'SecondaryDimensionShipWeightOz')
  final int? secondaryDimensionShipWeightOz;
  @JsonKey(name: 'SecondaryDimensionWeightInCaseLbs')
  final int? secondaryDimensionWeightInCaseLbs;
  @JsonKey(name: 'SecondaryDimensionWeightInCaseOz')
  final int? secondaryDimensionWeightInCaseOz;
  @JsonKey(name: 'SecondaryDimensionWidthFt')
  final int? secondaryDimensionWidthFt;
  @JsonKey(name: 'SecondaryDimensionWidthIn')
  final int? secondaryDimensionWidthIn;
  @JsonKey(name: 'SecondaryDimensionHeightFt')
  final int? secondaryDimensionHeightFt;
  @JsonKey(name: 'SecondaryDimensionHeightIn')
  final int? secondaryDimensionHeightIn;
  @JsonKey(name: 'SecondaryDimensionLengthFt')
  final int? secondaryDimensionLengthFt;
  @JsonKey(name: 'SecondaryDimensionLengthIn')
  final int? secondaryDimensionLengthIn;
  @JsonKey(name: 'SecondaryDimensionShipWeightKg')
  final int? secondaryDimensionShipWeightKg;
  @JsonKey(name: 'SecondaryDimensionShipWeightG')
  final int? secondaryDimensionShipWeightG;
  @JsonKey(name: 'SecondaryDimensionWeightInCaseKg')
  final int? secondaryDimensionWeightInCaseKg;
  @JsonKey(name: 'SecondaryDimensionWeightInCaseG')
  final int? secondaryDimensionWeightInCaseG;
  @JsonKey(name: 'SecondaryDimensionWidthM')
  final int? secondaryDimensionWidthM;
  @JsonKey(name: 'SecondaryDimensionWidthCm')
  final int? secondaryDimensionWidthCm;
  @JsonKey(name: 'SecondaryDimensionHeightM')
  final int? secondaryDimensionHeightM;
  @JsonKey(name: 'SecondaryDimensionHeightCm')
  final int? secondaryDimensionHeightCm;
  @JsonKey(name: 'SecondaryDimensionLengthM')
  final int? secondaryDimensionLengthM;
  @JsonKey(name: 'SecondaryDimensionLengthCm')
  final int? secondaryDimensionLengthCm;
  @JsonKey(name: 'CountryOfOriginId')
  final String? countryOfOriginId;
  @JsonKey(name: 'CountryOfOrigin')
  final String? countryOfOrigin;
  @JsonKey(name: 'DisplayInSummaryModeWhenRateIsZero')
  final bool? displayInSummaryModeWhenRateIsZero;
  @JsonKey(name: 'QcRequired')
  final bool? qcRequired;
  @JsonKey(name: 'QcTime')
  final String? qcTime;
  @JsonKey(name: 'CopyAttributesAsNote')
  final bool? copyAttributesAsNote;
  @JsonKey(name: 'TrackAssetUsage')
  final bool? trackAssetUsage;
  @JsonKey(name: 'TrackLampUsage')
  final bool? trackLampUsage;
  @JsonKey(name: 'TrackStrikes')
  final bool? trackStrikes;
  @JsonKey(name: 'TrackCandles')
  final bool? trackCandles;
  @JsonKey(name: 'LampCount')
  final int? lampCount;
  @JsonKey(name: 'MinimumFootCandles')
  final int? minimumFootCandles;
  @JsonKey(name: 'TrackSoftware')
  final bool? trackSoftware;
  @JsonKey(name: 'SoftwareVersion')
  final String? softwareVersion;
  @JsonKey(name: 'SoftwareEffectiveDate')
  final String? softwareEffectiveDate;
  @JsonKey(name: 'WarehouseSpecificPackage')
  final bool? warehouseSpecificPackage;
  @JsonKey(name: 'CompletePackagePrice')
  final String? completePackagePrice;
  @JsonKey(name: 'KitPackagePrice')
  final String? kitPackagePrice;
  @JsonKey(name: 'SeparatePackageOnQuoteOrder')
  final bool? separatePackageOnQuoteOrder;
  @JsonKey(name: 'ContainerId')
  final String? containerId;
  @JsonKey(name: 'ContainerScannableInventoryId')
  final String? containerScannableInventoryId;
  @JsonKey(name: 'ContainerScannableICode')
  final String? containerScannableICode;
  @JsonKey(name: 'ContainerScannableDescription')
  final String? containerScannableDescription;
  @JsonKey(name: 'AutomaticallyRebuildContainerAtCheckIn')
  final bool? automaticallyRebuildContainerAtCheckIn;
  @JsonKey(name: 'AutomaticallyRebuildContainerAtTransferIn')
  final bool? automaticallyRebuildContainerAtTransferIn;
  @JsonKey(name: 'ContainerStagingRule')
  final String? containerStagingRule;
  @JsonKey(name: 'ExcludeContainedItemsFromAvailability')
  final bool? excludeContainedItemsFromAvailability;
  @JsonKey(name: 'UseContainerNumber')
  final bool? useContainerNumber;
  @JsonKey(name: 'ContainerPackingListBehavior')
  final String? containerPackingListBehavior;
  @JsonKey(name: 'InventoryTypeIsWardrobe')
  final bool? inventoryTypeIsWardrobe;
  @JsonKey(name: 'InventoryTypeIsSets')
  final bool? inventoryTypeIsSets;
  @JsonKey(name: 'PatternId')
  final String? patternId;
  @JsonKey(name: 'Pattern')
  final String? pattern;
  @JsonKey(name: 'PeriodId')
  final String? periodId;
  @JsonKey(name: 'Period')
  final String? period;
  @JsonKey(name: 'MaterialId')
  final String? materialId;
  @JsonKey(name: 'Material')
  final String? material;
  @JsonKey(name: 'GenderId')
  final String? genderId;
  @JsonKey(name: 'Gender')
  final String? gender;
  @JsonKey(name: 'LabelId')
  final String? labelId;
  @JsonKey(name: 'Label')
  final String? label;
  @JsonKey(name: 'WardrobeSize')
  final String? wardrobeSize;
  @JsonKey(name: 'WardrobePieceCount')
  final int? wardrobePieceCount;
  @JsonKey(name: 'Dyed')
  final bool? dyed;
  @JsonKey(name: 'WardrobeSourceId')
  final String? wardrobeSourceId;
  @JsonKey(name: 'WardrobeSource')
  final String? wardrobeSource;
  @JsonKey(name: 'WardrobeCareId')
  final String? wardrobeCareId;
  @JsonKey(name: 'WardrobeCare')
  final String? wardrobeCare;
  @JsonKey(name: 'CleaningFeeAmount')
  final double? cleaningFeeAmount;
  @JsonKey(name: 'WardrobeDetailedDescription')
  final String? wardrobeDetailedDescription;
  @JsonKey(name: 'WebDetailedDescription')
  final String? webDetailedDescription;
  @JsonKey(name: 'OverrideSystemDefaultRevenueAllocationBehavior')
  final bool? overrideSystemDefaultRevenueAllocationBehavior;
  @JsonKey(name: 'AllocateRevenueForAccessories')
  final bool? allocateRevenueForAccessories;
  @JsonKey(name: 'PackageRevenueCalculationFormula')
  final String? packageRevenueCalculationFormula;
  @JsonKey(name: 'IsHazardousMaterial')
  final bool? isHazardousMaterial;
  @JsonKey(name: 'DescriptionWithAkas')
  final String? descriptionWithAkas;
  @JsonKey(name: 'CostCalculation')
  final String? costCalculation;
  @JsonKey(name: 'Quantity')
  final double? quantity;
  @JsonKey(name: 'AisleLocation')
  final String? aisleLocation;
  @JsonKey(name: 'ShelfLocation')
  final String? shelfLocation;
  @JsonKey(name: 'Taxable')
  final bool? taxable;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AvailFor')
  final String? availFor;
  @JsonKey(name: 'CategoryId')
  final String? categoryId;
  @JsonKey(name: 'Category')
  final String? category;
  @JsonKey(name: 'SubCategoryCount')
  final int? subCategoryCount;
  @JsonKey(name: 'SubCategoryId')
  final String? subCategoryId;
  @JsonKey(name: 'SubCategory')
  final String? subCategory;
  @JsonKey(name: 'Classification')
  final String? classification;
  @JsonKey(name: 'ClassificationDescription')
  final String? classificationDescription;
  @JsonKey(name: 'ClassificationColor')
  final String? classificationColor;
  @JsonKey(name: 'UnitId')
  final String? unitId;
  @JsonKey(name: 'Unit')
  final String? unit;
  @JsonKey(name: 'UnitType')
  final String? unitType;
  @JsonKey(name: 'NonDiscountable')
  final bool? nonDiscountable;
  @JsonKey(name: 'OverrideProfitAndLossCategory')
  final bool? overrideProfitAndLossCategory;
  @JsonKey(name: 'ProfitAndLossCategoryId')
  final String? profitAndLossCategoryId;
  @JsonKey(name: 'ProfitAndLossCategory')
  final String? profitAndLossCategory;
  @JsonKey(name: 'AutoCopyNotesToQuoteOrder')
  final bool? autoCopyNotesToQuoteOrder;
  @JsonKey(name: 'Note')
  final String? note;
  @JsonKey(name: 'PrintNoteOnInContract')
  final bool? printNoteOnInContract;
  @JsonKey(name: 'PrintNoteOnOutContract')
  final bool? printNoteOnOutContract;
  @JsonKey(name: 'PrintNoteOnReceiveContract')
  final bool? printNoteOnReceiveContract;
  @JsonKey(name: 'PrintNoteOnReturnContract')
  final bool? printNoteOnReturnContract;
  @JsonKey(name: 'PrintNoteOnInvoice')
  final bool? printNoteOnInvoice;
  @JsonKey(name: 'PrintNoteOnOrder')
  final bool? printNoteOnOrder;
  @JsonKey(name: 'PrintNoteOnPickList')
  final bool? printNoteOnPickList;
  @JsonKey(name: 'PrintNoteOnPO')
  final bool? printNoteOnPO;
  @JsonKey(name: 'PrintNoteOnQuote')
  final bool? printNoteOnQuote;
  @JsonKey(name: 'PrintNoteOnReturnList')
  final bool? printNoteOnReturnList;
  @JsonKey(name: 'PrintNoteOnPoReceiveList')
  final bool? printNoteOnPoReceiveList;
  @JsonKey(name: 'PrintNoteOnPoReturnList')
  final bool? printNoteOnPoReturnList;
  @JsonKey(name: 'AssetAccountId')
  final String? assetAccountId;
  @JsonKey(name: 'AssetAccountNo')
  final String? assetAccountNo;
  @JsonKey(name: 'AssetAccountDescription')
  final String? assetAccountDescription;
  @JsonKey(name: 'IncomeAccountId')
  final String? incomeAccountId;
  @JsonKey(name: 'IncomeAccountNo')
  final String? incomeAccountNo;
  @JsonKey(name: 'IncomeAccountDescription')
  final String? incomeAccountDescription;
  @JsonKey(name: 'SubIncomeAccountId')
  final String? subIncomeAccountId;
  @JsonKey(name: 'SubIncomeAccountNo')
  final String? subIncomeAccountNo;
  @JsonKey(name: 'SubIncomeAccountDescription')
  final String? subIncomeAccountDescription;
  @JsonKey(name: 'ConsignmentIncomeAccountId')
  final String? consignmentIncomeAccountId;
  @JsonKey(name: 'ConsignmentIncomeAccountNo')
  final String? consignmentIncomeAccountNo;
  @JsonKey(name: 'ConsignmentIncomeAccountDescription')
  final String? consignmentIncomeAccountDescription;
  @JsonKey(name: 'LdIncomeAccountId')
  final String? ldIncomeAccountId;
  @JsonKey(name: 'LdIncomeAccountNo')
  final String? ldIncomeAccountNo;
  @JsonKey(name: 'LdIncomeAccountDescription')
  final String? ldIncomeAccountDescription;
  @JsonKey(name: 'EquipmentSaleIncomeAccountId')
  final String? equipmentSaleIncomeAccountId;
  @JsonKey(name: 'EquipmentSaleIncomeAccountNo')
  final String? equipmentSaleIncomeAccountNo;
  @JsonKey(name: 'EquipmentSaleIncomeAccountDescription')
  final String? equipmentSaleIncomeAccountDescription;
  @JsonKey(name: 'ExpenseAccountId')
  final String? expenseAccountId;
  @JsonKey(name: 'ExpenseAccountNo')
  final String? expenseAccountNo;
  @JsonKey(name: 'ExpenseAccountDescription')
  final String? expenseAccountDescription;
  @JsonKey(name: 'CostOfGoodsSoldExpenseAccountId')
  final String? costOfGoodsSoldExpenseAccountId;
  @JsonKey(name: 'CostOfGoodsSoldExpenseAccountNo')
  final String? costOfGoodsSoldExpenseAccountNo;
  @JsonKey(name: 'CostOfGoodsSoldExpenseAccountDescription')
  final String? costOfGoodsSoldExpenseAccountDescription;
  @JsonKey(name: 'CostOfGoodsRentedExpenseAccountId')
  final String? costOfGoodsRentedExpenseAccountId;
  @JsonKey(name: 'CostOfGoodsRentedExpenseAccountNo')
  final String? costOfGoodsRentedExpenseAccountNo;
  @JsonKey(name: 'CostOfGoodsRentedExpenseAccountDescription')
  final String? costOfGoodsRentedExpenseAccountDescription;
  @JsonKey(name: 'DepreciationExpenseAccountId')
  final String? depreciationExpenseAccountId;
  @JsonKey(name: 'DepreciationExpenseAccountNo')
  final String? depreciationExpenseAccountNo;
  @JsonKey(name: 'DepreciationExpenseAccountDescription')
  final String? depreciationExpenseAccountDescription;
  @JsonKey(name: 'AccumulatedDepreciationExpenseAccountId')
  final String? accumulatedDepreciationExpenseAccountId;
  @JsonKey(name: 'AccumulatedDepreciationExpenseAccountNo')
  final String? accumulatedDepreciationExpenseAccountNo;
  @JsonKey(name: 'AccumulatedDepreciationExpenseAccountDescription')
  final String? accumulatedDepreciationExpenseAccountDescription;
  @JsonKey(name: 'OriginalShowId')
  final String? originalShowId;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'ManifestShippingContainer')
  final bool? manifestShippingContainer;
  @JsonKey(name: 'ManifestStandAloneItem')
  final bool? manifestStandAloneItem;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: 'Warehouses', defaultValue: <
      WebApiModulesHomeControlsInventoryWarehouseInventoryWarehouse>[])
  final List<WebApiModulesHomeControlsInventoryWarehouseInventoryWarehouse>?
      warehouses;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesInventoryRentalInventoryRentalInventoryDetailResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryRentalInventoryRentalInventoryDetailResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryRentalInventoryRentalInventoryDetailResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryRentalInventoryRentalInventoryDetailResponse &&
            (identical(other.excludeFromReturnOnAsset, excludeFromReturnOnAsset) ||
                const DeepCollectionEquality().equals(
                    other.excludeFromReturnOnAsset,
                    excludeFromReturnOnAsset)) &&
            (identical(other.isFixedAsset, isFixedAsset) ||
                const DeepCollectionEquality()
                    .equals(other.isFixedAsset, isFixedAsset)) &&
            (identical(other.multiAssignRFIDs, multiAssignRFIDs) ||
                const DeepCollectionEquality()
                    .equals(other.multiAssignRFIDs, multiAssignRFIDs)) &&
            (identical(other.minimumDaysPerWeek, minimumDaysPerWeek) ||
                const DeepCollectionEquality()
                    .equals(other.minimumDaysPerWeek, minimumDaysPerWeek)) &&
            (identical(other.setOpeningId, setOpeningId) ||
                const DeepCollectionEquality()
                    .equals(other.setOpeningId, setOpeningId)) &&
            (identical(other.setOpening, setOpening) ||
                const DeepCollectionEquality()
                    .equals(other.setOpening, setOpening)) &&
            (identical(other.wallTypeId, wallTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.wallTypeId, wallTypeId)) &&
            (identical(other.wallType, wallType) ||
                const DeepCollectionEquality()
                    .equals(other.wallType, wallType)) &&
            (identical(other.setSurfaceId, setSurfaceId) ||
                const DeepCollectionEquality()
                    .equals(other.setSurfaceId, setSurfaceId)) &&
            (identical(other.setSurface, setSurface) ||
                const DeepCollectionEquality()
                    .equals(other.setSurface, setSurface)) &&
            (identical(other.wallWidthFt, wallWidthFt) ||
                const DeepCollectionEquality()
                    .equals(other.wallWidthFt, wallWidthFt)) &&
            (identical(other.wallWidthIn, wallWidthIn) ||
                const DeepCollectionEquality()
                    .equals(other.wallWidthIn, wallWidthIn)) &&
            (identical(other.wallHeightFt, wallHeightFt) || const DeepCollectionEquality().equals(other.wallHeightFt, wallHeightFt)) &&
            (identical(other.wallHeightIn, wallHeightIn) || const DeepCollectionEquality().equals(other.wallHeightIn, wallHeightIn)) &&
            (identical(other.wallLengthFt, wallLengthFt) || const DeepCollectionEquality().equals(other.wallLengthFt, wallLengthFt)) &&
            (identical(other.wallLengthIn, wallLengthIn) || const DeepCollectionEquality().equals(other.wallLengthIn, wallLengthIn)) &&
            (identical(other.dailyRate, dailyRate) || const DeepCollectionEquality().equals(other.dailyRate, dailyRate)) &&
            (identical(other.weeklyRate, weeklyRate) || const DeepCollectionEquality().equals(other.weeklyRate, weeklyRate)) &&
            (identical(other.week2Rate, week2Rate) || const DeepCollectionEquality().equals(other.week2Rate, week2Rate)) &&
            (identical(other.week3Rate, week3Rate) || const DeepCollectionEquality().equals(other.week3Rate, week3Rate)) &&
            (identical(other.week4Rate, week4Rate) || const DeepCollectionEquality().equals(other.week4Rate, week4Rate)) &&
            (identical(other.monthlyRate, monthlyRate) || const DeepCollectionEquality().equals(other.monthlyRate, monthlyRate)) &&
            (identical(other.unitValue, unitValue) || const DeepCollectionEquality().equals(other.unitValue, unitValue)) &&
            (identical(other.replacementCost, replacementCost) || const DeepCollectionEquality().equals(other.replacementCost, replacementCost)) &&
            (identical(other.inventoryId, inventoryId) || const DeepCollectionEquality().equals(other.inventoryId, inventoryId)) &&
            (identical(other.inventoryTypeId, inventoryTypeId) || const DeepCollectionEquality().equals(other.inventoryTypeId, inventoryTypeId)) &&
            (identical(other.inventoryType, inventoryType) || const DeepCollectionEquality().equals(other.inventoryType, inventoryType)) &&
            (identical(other.availableFrom, availableFrom) || const DeepCollectionEquality().equals(other.availableFrom, availableFrom)) &&
            (identical(other.trackedBy, trackedBy) || const DeepCollectionEquality().equals(other.trackedBy, trackedBy)) &&
            (identical(other.confirmTrackedBy, confirmTrackedBy) || const DeepCollectionEquality().equals(other.confirmTrackedBy, confirmTrackedBy)) &&
            (identical(other.rank, rank) || const DeepCollectionEquality().equals(other.rank, rank)) &&
            (identical(other.manufacturerPartNumber, manufacturerPartNumber) || const DeepCollectionEquality().equals(other.manufacturerPartNumber, manufacturerPartNumber)) &&
            (identical(other.manufacturerId, manufacturerId) || const DeepCollectionEquality().equals(other.manufacturerId, manufacturerId)) &&
            (identical(other.manufacturer, manufacturer) || const DeepCollectionEquality().equals(other.manufacturer, manufacturer)) &&
            (identical(other.manufacturerUrl, manufacturerUrl) || const DeepCollectionEquality().equals(other.manufacturerUrl, manufacturerUrl)) &&
            (identical(other.excludeImageFromQuoteOrderPrint, excludeImageFromQuoteOrderPrint) || const DeepCollectionEquality().equals(other.excludeImageFromQuoteOrderPrint, excludeImageFromQuoteOrderPrint)) &&
            (identical(other.noAvailabilityCheck, noAvailabilityCheck) || const DeepCollectionEquality().equals(other.noAvailabilityCheck, noAvailabilityCheck)) &&
            (identical(other.availabilityManuallyResolveConflicts, availabilityManuallyResolveConflicts) || const DeepCollectionEquality().equals(other.availabilityManuallyResolveConflicts, availabilityManuallyResolveConflicts)) &&
            (identical(other.sendAvailabilityAlert, sendAvailabilityAlert) || const DeepCollectionEquality().equals(other.sendAvailabilityAlert, sendAvailabilityAlert)) &&
            (identical(other.primaryDimensionUniqueId, primaryDimensionUniqueId) || const DeepCollectionEquality().equals(other.primaryDimensionUniqueId, primaryDimensionUniqueId)) &&
            (identical(other.defaultImperialMetric, defaultImperialMetric) || const DeepCollectionEquality().equals(other.defaultImperialMetric, defaultImperialMetric)) &&
            (identical(other.primaryDimensionDescription, primaryDimensionDescription) || const DeepCollectionEquality().equals(other.primaryDimensionDescription, primaryDimensionDescription)) &&
            (identical(other.primaryDimensionShipWeightLbs, primaryDimensionShipWeightLbs) || const DeepCollectionEquality().equals(other.primaryDimensionShipWeightLbs, primaryDimensionShipWeightLbs)) &&
            (identical(other.primaryDimensionShipWeightOz, primaryDimensionShipWeightOz) || const DeepCollectionEquality().equals(other.primaryDimensionShipWeightOz, primaryDimensionShipWeightOz)) &&
            (identical(other.primaryDimensionWeightInCaseLbs, primaryDimensionWeightInCaseLbs) || const DeepCollectionEquality().equals(other.primaryDimensionWeightInCaseLbs, primaryDimensionWeightInCaseLbs)) &&
            (identical(other.primaryDimensionWeightInCaseOz, primaryDimensionWeightInCaseOz) || const DeepCollectionEquality().equals(other.primaryDimensionWeightInCaseOz, primaryDimensionWeightInCaseOz)) &&
            (identical(other.primaryDimensionWidthFt, primaryDimensionWidthFt) || const DeepCollectionEquality().equals(other.primaryDimensionWidthFt, primaryDimensionWidthFt)) &&
            (identical(other.primaryDimensionWidthIn, primaryDimensionWidthIn) || const DeepCollectionEquality().equals(other.primaryDimensionWidthIn, primaryDimensionWidthIn)) &&
            (identical(other.primaryDimensionHeightFt, primaryDimensionHeightFt) || const DeepCollectionEquality().equals(other.primaryDimensionHeightFt, primaryDimensionHeightFt)) &&
            (identical(other.primaryDimensionHeightIn, primaryDimensionHeightIn) || const DeepCollectionEquality().equals(other.primaryDimensionHeightIn, primaryDimensionHeightIn)) &&
            (identical(other.primaryDimensionLengthFt, primaryDimensionLengthFt) || const DeepCollectionEquality().equals(other.primaryDimensionLengthFt, primaryDimensionLengthFt)) &&
            (identical(other.primaryDimensionLengthIn, primaryDimensionLengthIn) || const DeepCollectionEquality().equals(other.primaryDimensionLengthIn, primaryDimensionLengthIn)) &&
            (identical(other.primaryDimensionShipWeightKg, primaryDimensionShipWeightKg) || const DeepCollectionEquality().equals(other.primaryDimensionShipWeightKg, primaryDimensionShipWeightKg)) &&
            (identical(other.primaryDimensionShipWeightG, primaryDimensionShipWeightG) || const DeepCollectionEquality().equals(other.primaryDimensionShipWeightG, primaryDimensionShipWeightG)) &&
            (identical(other.primaryDimensionWeightInCaseKg, primaryDimensionWeightInCaseKg) || const DeepCollectionEquality().equals(other.primaryDimensionWeightInCaseKg, primaryDimensionWeightInCaseKg)) &&
            (identical(other.primaryDimensionWeightInCaseG, primaryDimensionWeightInCaseG) || const DeepCollectionEquality().equals(other.primaryDimensionWeightInCaseG, primaryDimensionWeightInCaseG)) &&
            (identical(other.primaryDimensionWidthM, primaryDimensionWidthM) || const DeepCollectionEquality().equals(other.primaryDimensionWidthM, primaryDimensionWidthM)) &&
            (identical(other.primaryDimensionWidthCm, primaryDimensionWidthCm) || const DeepCollectionEquality().equals(other.primaryDimensionWidthCm, primaryDimensionWidthCm)) &&
            (identical(other.primaryDimensionHeightM, primaryDimensionHeightM) || const DeepCollectionEquality().equals(other.primaryDimensionHeightM, primaryDimensionHeightM)) &&
            (identical(other.primaryDimensionHeightCm, primaryDimensionHeightCm) || const DeepCollectionEquality().equals(other.primaryDimensionHeightCm, primaryDimensionHeightCm)) &&
            (identical(other.primaryDimensionLengthM, primaryDimensionLengthM) || const DeepCollectionEquality().equals(other.primaryDimensionLengthM, primaryDimensionLengthM)) &&
            (identical(other.primaryDimensionLengthCm, primaryDimensionLengthCm) || const DeepCollectionEquality().equals(other.primaryDimensionLengthCm, primaryDimensionLengthCm)) &&
            (identical(other.hasSecondaryDimensions, hasSecondaryDimensions) || const DeepCollectionEquality().equals(other.hasSecondaryDimensions, hasSecondaryDimensions)) &&
            (identical(other.secondaryDimensionUniqueId, secondaryDimensionUniqueId) || const DeepCollectionEquality().equals(other.secondaryDimensionUniqueId, secondaryDimensionUniqueId)) &&
            (identical(other.secondaryDimensionDescription, secondaryDimensionDescription) || const DeepCollectionEquality().equals(other.secondaryDimensionDescription, secondaryDimensionDescription)) &&
            (identical(other.secondaryDimensionShipWeightLbs, secondaryDimensionShipWeightLbs) || const DeepCollectionEquality().equals(other.secondaryDimensionShipWeightLbs, secondaryDimensionShipWeightLbs)) &&
            (identical(other.secondaryDimensionShipWeightOz, secondaryDimensionShipWeightOz) || const DeepCollectionEquality().equals(other.secondaryDimensionShipWeightOz, secondaryDimensionShipWeightOz)) &&
            (identical(other.secondaryDimensionWeightInCaseLbs, secondaryDimensionWeightInCaseLbs) || const DeepCollectionEquality().equals(other.secondaryDimensionWeightInCaseLbs, secondaryDimensionWeightInCaseLbs)) &&
            (identical(other.secondaryDimensionWeightInCaseOz, secondaryDimensionWeightInCaseOz) || const DeepCollectionEquality().equals(other.secondaryDimensionWeightInCaseOz, secondaryDimensionWeightInCaseOz)) &&
            (identical(other.secondaryDimensionWidthFt, secondaryDimensionWidthFt) || const DeepCollectionEquality().equals(other.secondaryDimensionWidthFt, secondaryDimensionWidthFt)) &&
            (identical(other.secondaryDimensionWidthIn, secondaryDimensionWidthIn) || const DeepCollectionEquality().equals(other.secondaryDimensionWidthIn, secondaryDimensionWidthIn)) &&
            (identical(other.secondaryDimensionHeightFt, secondaryDimensionHeightFt) || const DeepCollectionEquality().equals(other.secondaryDimensionHeightFt, secondaryDimensionHeightFt)) &&
            (identical(other.secondaryDimensionHeightIn, secondaryDimensionHeightIn) || const DeepCollectionEquality().equals(other.secondaryDimensionHeightIn, secondaryDimensionHeightIn)) &&
            (identical(other.secondaryDimensionLengthFt, secondaryDimensionLengthFt) || const DeepCollectionEquality().equals(other.secondaryDimensionLengthFt, secondaryDimensionLengthFt)) &&
            (identical(other.secondaryDimensionLengthIn, secondaryDimensionLengthIn) || const DeepCollectionEquality().equals(other.secondaryDimensionLengthIn, secondaryDimensionLengthIn)) &&
            (identical(other.secondaryDimensionShipWeightKg, secondaryDimensionShipWeightKg) || const DeepCollectionEquality().equals(other.secondaryDimensionShipWeightKg, secondaryDimensionShipWeightKg)) &&
            (identical(other.secondaryDimensionShipWeightG, secondaryDimensionShipWeightG) || const DeepCollectionEquality().equals(other.secondaryDimensionShipWeightG, secondaryDimensionShipWeightG)) &&
            (identical(other.secondaryDimensionWeightInCaseKg, secondaryDimensionWeightInCaseKg) || const DeepCollectionEquality().equals(other.secondaryDimensionWeightInCaseKg, secondaryDimensionWeightInCaseKg)) &&
            (identical(other.secondaryDimensionWeightInCaseG, secondaryDimensionWeightInCaseG) || const DeepCollectionEquality().equals(other.secondaryDimensionWeightInCaseG, secondaryDimensionWeightInCaseG)) &&
            (identical(other.secondaryDimensionWidthM, secondaryDimensionWidthM) || const DeepCollectionEquality().equals(other.secondaryDimensionWidthM, secondaryDimensionWidthM)) &&
            (identical(other.secondaryDimensionWidthCm, secondaryDimensionWidthCm) || const DeepCollectionEquality().equals(other.secondaryDimensionWidthCm, secondaryDimensionWidthCm)) &&
            (identical(other.secondaryDimensionHeightM, secondaryDimensionHeightM) || const DeepCollectionEquality().equals(other.secondaryDimensionHeightM, secondaryDimensionHeightM)) &&
            (identical(other.secondaryDimensionHeightCm, secondaryDimensionHeightCm) || const DeepCollectionEquality().equals(other.secondaryDimensionHeightCm, secondaryDimensionHeightCm)) &&
            (identical(other.secondaryDimensionLengthM, secondaryDimensionLengthM) || const DeepCollectionEquality().equals(other.secondaryDimensionLengthM, secondaryDimensionLengthM)) &&
            (identical(other.secondaryDimensionLengthCm, secondaryDimensionLengthCm) || const DeepCollectionEquality().equals(other.secondaryDimensionLengthCm, secondaryDimensionLengthCm)) &&
            (identical(other.countryOfOriginId, countryOfOriginId) || const DeepCollectionEquality().equals(other.countryOfOriginId, countryOfOriginId)) &&
            (identical(other.countryOfOrigin, countryOfOrigin) || const DeepCollectionEquality().equals(other.countryOfOrigin, countryOfOrigin)) &&
            (identical(other.displayInSummaryModeWhenRateIsZero, displayInSummaryModeWhenRateIsZero) || const DeepCollectionEquality().equals(other.displayInSummaryModeWhenRateIsZero, displayInSummaryModeWhenRateIsZero)) &&
            (identical(other.qcRequired, qcRequired) || const DeepCollectionEquality().equals(other.qcRequired, qcRequired)) &&
            (identical(other.qcTime, qcTime) || const DeepCollectionEquality().equals(other.qcTime, qcTime)) &&
            (identical(other.copyAttributesAsNote, copyAttributesAsNote) || const DeepCollectionEquality().equals(other.copyAttributesAsNote, copyAttributesAsNote)) &&
            (identical(other.trackAssetUsage, trackAssetUsage) || const DeepCollectionEquality().equals(other.trackAssetUsage, trackAssetUsage)) &&
            (identical(other.trackLampUsage, trackLampUsage) || const DeepCollectionEquality().equals(other.trackLampUsage, trackLampUsage)) &&
            (identical(other.trackStrikes, trackStrikes) || const DeepCollectionEquality().equals(other.trackStrikes, trackStrikes)) &&
            (identical(other.trackCandles, trackCandles) || const DeepCollectionEquality().equals(other.trackCandles, trackCandles)) &&
            (identical(other.lampCount, lampCount) || const DeepCollectionEquality().equals(other.lampCount, lampCount)) &&
            (identical(other.minimumFootCandles, minimumFootCandles) || const DeepCollectionEquality().equals(other.minimumFootCandles, minimumFootCandles)) &&
            (identical(other.trackSoftware, trackSoftware) || const DeepCollectionEquality().equals(other.trackSoftware, trackSoftware)) &&
            (identical(other.softwareVersion, softwareVersion) || const DeepCollectionEquality().equals(other.softwareVersion, softwareVersion)) &&
            (identical(other.softwareEffectiveDate, softwareEffectiveDate) || const DeepCollectionEquality().equals(other.softwareEffectiveDate, softwareEffectiveDate)) &&
            (identical(other.warehouseSpecificPackage, warehouseSpecificPackage) || const DeepCollectionEquality().equals(other.warehouseSpecificPackage, warehouseSpecificPackage)) &&
            (identical(other.completePackagePrice, completePackagePrice) || const DeepCollectionEquality().equals(other.completePackagePrice, completePackagePrice)) &&
            (identical(other.kitPackagePrice, kitPackagePrice) || const DeepCollectionEquality().equals(other.kitPackagePrice, kitPackagePrice)) &&
            (identical(other.separatePackageOnQuoteOrder, separatePackageOnQuoteOrder) || const DeepCollectionEquality().equals(other.separatePackageOnQuoteOrder, separatePackageOnQuoteOrder)) &&
            (identical(other.containerId, containerId) || const DeepCollectionEquality().equals(other.containerId, containerId)) &&
            (identical(other.containerScannableInventoryId, containerScannableInventoryId) || const DeepCollectionEquality().equals(other.containerScannableInventoryId, containerScannableInventoryId)) &&
            (identical(other.containerScannableICode, containerScannableICode) || const DeepCollectionEquality().equals(other.containerScannableICode, containerScannableICode)) &&
            (identical(other.containerScannableDescription, containerScannableDescription) || const DeepCollectionEquality().equals(other.containerScannableDescription, containerScannableDescription)) &&
            (identical(other.automaticallyRebuildContainerAtCheckIn, automaticallyRebuildContainerAtCheckIn) || const DeepCollectionEquality().equals(other.automaticallyRebuildContainerAtCheckIn, automaticallyRebuildContainerAtCheckIn)) &&
            (identical(other.automaticallyRebuildContainerAtTransferIn, automaticallyRebuildContainerAtTransferIn) || const DeepCollectionEquality().equals(other.automaticallyRebuildContainerAtTransferIn, automaticallyRebuildContainerAtTransferIn)) &&
            (identical(other.containerStagingRule, containerStagingRule) || const DeepCollectionEquality().equals(other.containerStagingRule, containerStagingRule)) &&
            (identical(other.excludeContainedItemsFromAvailability, excludeContainedItemsFromAvailability) || const DeepCollectionEquality().equals(other.excludeContainedItemsFromAvailability, excludeContainedItemsFromAvailability)) &&
            (identical(other.useContainerNumber, useContainerNumber) || const DeepCollectionEquality().equals(other.useContainerNumber, useContainerNumber)) &&
            (identical(other.containerPackingListBehavior, containerPackingListBehavior) || const DeepCollectionEquality().equals(other.containerPackingListBehavior, containerPackingListBehavior)) &&
            (identical(other.inventoryTypeIsWardrobe, inventoryTypeIsWardrobe) || const DeepCollectionEquality().equals(other.inventoryTypeIsWardrobe, inventoryTypeIsWardrobe)) &&
            (identical(other.inventoryTypeIsSets, inventoryTypeIsSets) || const DeepCollectionEquality().equals(other.inventoryTypeIsSets, inventoryTypeIsSets)) &&
            (identical(other.patternId, patternId) || const DeepCollectionEquality().equals(other.patternId, patternId)) &&
            (identical(other.pattern, pattern) || const DeepCollectionEquality().equals(other.pattern, pattern)) &&
            (identical(other.periodId, periodId) || const DeepCollectionEquality().equals(other.periodId, periodId)) &&
            (identical(other.period, period) || const DeepCollectionEquality().equals(other.period, period)) &&
            (identical(other.materialId, materialId) || const DeepCollectionEquality().equals(other.materialId, materialId)) &&
            (identical(other.material, material) || const DeepCollectionEquality().equals(other.material, material)) &&
            (identical(other.genderId, genderId) || const DeepCollectionEquality().equals(other.genderId, genderId)) &&
            (identical(other.gender, gender) || const DeepCollectionEquality().equals(other.gender, gender)) &&
            (identical(other.labelId, labelId) || const DeepCollectionEquality().equals(other.labelId, labelId)) &&
            (identical(other.label, label) || const DeepCollectionEquality().equals(other.label, label)) &&
            (identical(other.wardrobeSize, wardrobeSize) || const DeepCollectionEquality().equals(other.wardrobeSize, wardrobeSize)) &&
            (identical(other.wardrobePieceCount, wardrobePieceCount) || const DeepCollectionEquality().equals(other.wardrobePieceCount, wardrobePieceCount)) &&
            (identical(other.dyed, dyed) || const DeepCollectionEquality().equals(other.dyed, dyed)) &&
            (identical(other.wardrobeSourceId, wardrobeSourceId) || const DeepCollectionEquality().equals(other.wardrobeSourceId, wardrobeSourceId)) &&
            (identical(other.wardrobeSource, wardrobeSource) || const DeepCollectionEquality().equals(other.wardrobeSource, wardrobeSource)) &&
            (identical(other.wardrobeCareId, wardrobeCareId) || const DeepCollectionEquality().equals(other.wardrobeCareId, wardrobeCareId)) &&
            (identical(other.wardrobeCare, wardrobeCare) || const DeepCollectionEquality().equals(other.wardrobeCare, wardrobeCare)) &&
            (identical(other.cleaningFeeAmount, cleaningFeeAmount) || const DeepCollectionEquality().equals(other.cleaningFeeAmount, cleaningFeeAmount)) &&
            (identical(other.wardrobeDetailedDescription, wardrobeDetailedDescription) || const DeepCollectionEquality().equals(other.wardrobeDetailedDescription, wardrobeDetailedDescription)) &&
            (identical(other.webDetailedDescription, webDetailedDescription) || const DeepCollectionEquality().equals(other.webDetailedDescription, webDetailedDescription)) &&
            (identical(other.overrideSystemDefaultRevenueAllocationBehavior, overrideSystemDefaultRevenueAllocationBehavior) || const DeepCollectionEquality().equals(other.overrideSystemDefaultRevenueAllocationBehavior, overrideSystemDefaultRevenueAllocationBehavior)) &&
            (identical(other.allocateRevenueForAccessories, allocateRevenueForAccessories) || const DeepCollectionEquality().equals(other.allocateRevenueForAccessories, allocateRevenueForAccessories)) &&
            (identical(other.packageRevenueCalculationFormula, packageRevenueCalculationFormula) || const DeepCollectionEquality().equals(other.packageRevenueCalculationFormula, packageRevenueCalculationFormula)) &&
            (identical(other.isHazardousMaterial, isHazardousMaterial) || const DeepCollectionEquality().equals(other.isHazardousMaterial, isHazardousMaterial)) &&
            (identical(other.descriptionWithAkas, descriptionWithAkas) || const DeepCollectionEquality().equals(other.descriptionWithAkas, descriptionWithAkas)) &&
            (identical(other.costCalculation, costCalculation) || const DeepCollectionEquality().equals(other.costCalculation, costCalculation)) &&
            (identical(other.quantity, quantity) || const DeepCollectionEquality().equals(other.quantity, quantity)) &&
            (identical(other.aisleLocation, aisleLocation) || const DeepCollectionEquality().equals(other.aisleLocation, aisleLocation)) &&
            (identical(other.shelfLocation, shelfLocation) || const DeepCollectionEquality().equals(other.shelfLocation, shelfLocation)) &&
            (identical(other.taxable, taxable) || const DeepCollectionEquality().equals(other.taxable, taxable)) &&
            (identical(other.iCode, iCode) || const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) || const DeepCollectionEquality().equals(other.description, description)) &&
            (identical(other.availFor, availFor) || const DeepCollectionEquality().equals(other.availFor, availFor)) &&
            (identical(other.categoryId, categoryId) || const DeepCollectionEquality().equals(other.categoryId, categoryId)) &&
            (identical(other.category, category) || const DeepCollectionEquality().equals(other.category, category)) &&
            (identical(other.subCategoryCount, subCategoryCount) || const DeepCollectionEquality().equals(other.subCategoryCount, subCategoryCount)) &&
            (identical(other.subCategoryId, subCategoryId) || const DeepCollectionEquality().equals(other.subCategoryId, subCategoryId)) &&
            (identical(other.subCategory, subCategory) || const DeepCollectionEquality().equals(other.subCategory, subCategory)) &&
            (identical(other.classification, classification) || const DeepCollectionEquality().equals(other.classification, classification)) &&
            (identical(other.classificationDescription, classificationDescription) || const DeepCollectionEquality().equals(other.classificationDescription, classificationDescription)) &&
            (identical(other.classificationColor, classificationColor) || const DeepCollectionEquality().equals(other.classificationColor, classificationColor)) &&
            (identical(other.unitId, unitId) || const DeepCollectionEquality().equals(other.unitId, unitId)) &&
            (identical(other.unit, unit) || const DeepCollectionEquality().equals(other.unit, unit)) &&
            (identical(other.unitType, unitType) || const DeepCollectionEquality().equals(other.unitType, unitType)) &&
            (identical(other.nonDiscountable, nonDiscountable) || const DeepCollectionEquality().equals(other.nonDiscountable, nonDiscountable)) &&
            (identical(other.overrideProfitAndLossCategory, overrideProfitAndLossCategory) || const DeepCollectionEquality().equals(other.overrideProfitAndLossCategory, overrideProfitAndLossCategory)) &&
            (identical(other.profitAndLossCategoryId, profitAndLossCategoryId) || const DeepCollectionEquality().equals(other.profitAndLossCategoryId, profitAndLossCategoryId)) &&
            (identical(other.profitAndLossCategory, profitAndLossCategory) || const DeepCollectionEquality().equals(other.profitAndLossCategory, profitAndLossCategory)) &&
            (identical(other.autoCopyNotesToQuoteOrder, autoCopyNotesToQuoteOrder) || const DeepCollectionEquality().equals(other.autoCopyNotesToQuoteOrder, autoCopyNotesToQuoteOrder)) &&
            (identical(other.note, note) || const DeepCollectionEquality().equals(other.note, note)) &&
            (identical(other.printNoteOnInContract, printNoteOnInContract) || const DeepCollectionEquality().equals(other.printNoteOnInContract, printNoteOnInContract)) &&
            (identical(other.printNoteOnOutContract, printNoteOnOutContract) || const DeepCollectionEquality().equals(other.printNoteOnOutContract, printNoteOnOutContract)) &&
            (identical(other.printNoteOnReceiveContract, printNoteOnReceiveContract) || const DeepCollectionEquality().equals(other.printNoteOnReceiveContract, printNoteOnReceiveContract)) &&
            (identical(other.printNoteOnReturnContract, printNoteOnReturnContract) || const DeepCollectionEquality().equals(other.printNoteOnReturnContract, printNoteOnReturnContract)) &&
            (identical(other.printNoteOnInvoice, printNoteOnInvoice) || const DeepCollectionEquality().equals(other.printNoteOnInvoice, printNoteOnInvoice)) &&
            (identical(other.printNoteOnOrder, printNoteOnOrder) || const DeepCollectionEquality().equals(other.printNoteOnOrder, printNoteOnOrder)) &&
            (identical(other.printNoteOnPickList, printNoteOnPickList) || const DeepCollectionEquality().equals(other.printNoteOnPickList, printNoteOnPickList)) &&
            (identical(other.printNoteOnPO, printNoteOnPO) || const DeepCollectionEquality().equals(other.printNoteOnPO, printNoteOnPO)) &&
            (identical(other.printNoteOnQuote, printNoteOnQuote) || const DeepCollectionEquality().equals(other.printNoteOnQuote, printNoteOnQuote)) &&
            (identical(other.printNoteOnReturnList, printNoteOnReturnList) || const DeepCollectionEquality().equals(other.printNoteOnReturnList, printNoteOnReturnList)) &&
            (identical(other.printNoteOnPoReceiveList, printNoteOnPoReceiveList) || const DeepCollectionEquality().equals(other.printNoteOnPoReceiveList, printNoteOnPoReceiveList)) &&
            (identical(other.printNoteOnPoReturnList, printNoteOnPoReturnList) || const DeepCollectionEquality().equals(other.printNoteOnPoReturnList, printNoteOnPoReturnList)) &&
            (identical(other.assetAccountId, assetAccountId) || const DeepCollectionEquality().equals(other.assetAccountId, assetAccountId)) &&
            (identical(other.assetAccountNo, assetAccountNo) || const DeepCollectionEquality().equals(other.assetAccountNo, assetAccountNo)) &&
            (identical(other.assetAccountDescription, assetAccountDescription) || const DeepCollectionEquality().equals(other.assetAccountDescription, assetAccountDescription)) &&
            (identical(other.incomeAccountId, incomeAccountId) || const DeepCollectionEquality().equals(other.incomeAccountId, incomeAccountId)) &&
            (identical(other.incomeAccountNo, incomeAccountNo) || const DeepCollectionEquality().equals(other.incomeAccountNo, incomeAccountNo)) &&
            (identical(other.incomeAccountDescription, incomeAccountDescription) || const DeepCollectionEquality().equals(other.incomeAccountDescription, incomeAccountDescription)) &&
            (identical(other.subIncomeAccountId, subIncomeAccountId) || const DeepCollectionEquality().equals(other.subIncomeAccountId, subIncomeAccountId)) &&
            (identical(other.subIncomeAccountNo, subIncomeAccountNo) || const DeepCollectionEquality().equals(other.subIncomeAccountNo, subIncomeAccountNo)) &&
            (identical(other.subIncomeAccountDescription, subIncomeAccountDescription) || const DeepCollectionEquality().equals(other.subIncomeAccountDescription, subIncomeAccountDescription)) &&
            (identical(other.consignmentIncomeAccountId, consignmentIncomeAccountId) || const DeepCollectionEquality().equals(other.consignmentIncomeAccountId, consignmentIncomeAccountId)) &&
            (identical(other.consignmentIncomeAccountNo, consignmentIncomeAccountNo) || const DeepCollectionEquality().equals(other.consignmentIncomeAccountNo, consignmentIncomeAccountNo)) &&
            (identical(other.consignmentIncomeAccountDescription, consignmentIncomeAccountDescription) || const DeepCollectionEquality().equals(other.consignmentIncomeAccountDescription, consignmentIncomeAccountDescription)) &&
            (identical(other.ldIncomeAccountId, ldIncomeAccountId) || const DeepCollectionEquality().equals(other.ldIncomeAccountId, ldIncomeAccountId)) &&
            (identical(other.ldIncomeAccountNo, ldIncomeAccountNo) || const DeepCollectionEquality().equals(other.ldIncomeAccountNo, ldIncomeAccountNo)) &&
            (identical(other.ldIncomeAccountDescription, ldIncomeAccountDescription) || const DeepCollectionEquality().equals(other.ldIncomeAccountDescription, ldIncomeAccountDescription)) &&
            (identical(other.equipmentSaleIncomeAccountId, equipmentSaleIncomeAccountId) || const DeepCollectionEquality().equals(other.equipmentSaleIncomeAccountId, equipmentSaleIncomeAccountId)) &&
            (identical(other.equipmentSaleIncomeAccountNo, equipmentSaleIncomeAccountNo) || const DeepCollectionEquality().equals(other.equipmentSaleIncomeAccountNo, equipmentSaleIncomeAccountNo)) &&
            (identical(other.equipmentSaleIncomeAccountDescription, equipmentSaleIncomeAccountDescription) || const DeepCollectionEquality().equals(other.equipmentSaleIncomeAccountDescription, equipmentSaleIncomeAccountDescription)) &&
            (identical(other.expenseAccountId, expenseAccountId) || const DeepCollectionEquality().equals(other.expenseAccountId, expenseAccountId)) &&
            (identical(other.expenseAccountNo, expenseAccountNo) || const DeepCollectionEquality().equals(other.expenseAccountNo, expenseAccountNo)) &&
            (identical(other.expenseAccountDescription, expenseAccountDescription) || const DeepCollectionEquality().equals(other.expenseAccountDescription, expenseAccountDescription)) &&
            (identical(other.costOfGoodsSoldExpenseAccountId, costOfGoodsSoldExpenseAccountId) || const DeepCollectionEquality().equals(other.costOfGoodsSoldExpenseAccountId, costOfGoodsSoldExpenseAccountId)) &&
            (identical(other.costOfGoodsSoldExpenseAccountNo, costOfGoodsSoldExpenseAccountNo) || const DeepCollectionEquality().equals(other.costOfGoodsSoldExpenseAccountNo, costOfGoodsSoldExpenseAccountNo)) &&
            (identical(other.costOfGoodsSoldExpenseAccountDescription, costOfGoodsSoldExpenseAccountDescription) || const DeepCollectionEquality().equals(other.costOfGoodsSoldExpenseAccountDescription, costOfGoodsSoldExpenseAccountDescription)) &&
            (identical(other.costOfGoodsRentedExpenseAccountId, costOfGoodsRentedExpenseAccountId) || const DeepCollectionEquality().equals(other.costOfGoodsRentedExpenseAccountId, costOfGoodsRentedExpenseAccountId)) &&
            (identical(other.costOfGoodsRentedExpenseAccountNo, costOfGoodsRentedExpenseAccountNo) || const DeepCollectionEquality().equals(other.costOfGoodsRentedExpenseAccountNo, costOfGoodsRentedExpenseAccountNo)) &&
            (identical(other.costOfGoodsRentedExpenseAccountDescription, costOfGoodsRentedExpenseAccountDescription) || const DeepCollectionEquality().equals(other.costOfGoodsRentedExpenseAccountDescription, costOfGoodsRentedExpenseAccountDescription)) &&
            (identical(other.depreciationExpenseAccountId, depreciationExpenseAccountId) || const DeepCollectionEquality().equals(other.depreciationExpenseAccountId, depreciationExpenseAccountId)) &&
            (identical(other.depreciationExpenseAccountNo, depreciationExpenseAccountNo) || const DeepCollectionEquality().equals(other.depreciationExpenseAccountNo, depreciationExpenseAccountNo)) &&
            (identical(other.depreciationExpenseAccountDescription, depreciationExpenseAccountDescription) || const DeepCollectionEquality().equals(other.depreciationExpenseAccountDescription, depreciationExpenseAccountDescription)) &&
            (identical(other.accumulatedDepreciationExpenseAccountId, accumulatedDepreciationExpenseAccountId) || const DeepCollectionEquality().equals(other.accumulatedDepreciationExpenseAccountId, accumulatedDepreciationExpenseAccountId)) &&
            (identical(other.accumulatedDepreciationExpenseAccountNo, accumulatedDepreciationExpenseAccountNo) || const DeepCollectionEquality().equals(other.accumulatedDepreciationExpenseAccountNo, accumulatedDepreciationExpenseAccountNo)) &&
            (identical(other.accumulatedDepreciationExpenseAccountDescription, accumulatedDepreciationExpenseAccountDescription) || const DeepCollectionEquality().equals(other.accumulatedDepreciationExpenseAccountDescription, accumulatedDepreciationExpenseAccountDescription)) &&
            (identical(other.originalShowId, originalShowId) || const DeepCollectionEquality().equals(other.originalShowId, originalShowId)) &&
            (identical(other.inactive, inactive) || const DeepCollectionEquality().equals(other.inactive, inactive)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.manifestShippingContainer, manifestShippingContainer) || const DeepCollectionEquality().equals(other.manifestShippingContainer, manifestShippingContainer)) &&
            (identical(other.manifestStandAloneItem, manifestStandAloneItem) || const DeepCollectionEquality().equals(other.manifestStandAloneItem, manifestStandAloneItem)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.warehouses, warehouses) || const DeepCollectionEquality().equals(other.warehouses, warehouses)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesInventoryRentalInventoryRentalInventoryDetailResponseExtension
    on WebApiModulesInventoryRentalInventoryRentalInventoryDetailResponse {
  WebApiModulesInventoryRentalInventoryRentalInventoryDetailResponse copyWith(
      {bool? excludeFromReturnOnAsset,
      bool? isFixedAsset,
      bool? multiAssignRFIDs,
      double? minimumDaysPerWeek,
      String? setOpeningId,
      String? setOpening,
      String? wallTypeId,
      String? wallType,
      String? setSurfaceId,
      String? setSurface,
      int? wallWidthFt,
      int? wallWidthIn,
      int? wallHeightFt,
      int? wallHeightIn,
      int? wallLengthFt,
      int? wallLengthIn,
      double? dailyRate,
      double? weeklyRate,
      double? week2Rate,
      double? week3Rate,
      double? week4Rate,
      double? monthlyRate,
      double? unitValue,
      double? replacementCost,
      String? inventoryId,
      String? inventoryTypeId,
      String? inventoryType,
      String? availableFrom,
      String? trackedBy,
      String? confirmTrackedBy,
      String? rank,
      String? manufacturerPartNumber,
      String? manufacturerId,
      String? manufacturer,
      String? manufacturerUrl,
      bool? excludeImageFromQuoteOrderPrint,
      bool? noAvailabilityCheck,
      bool? availabilityManuallyResolveConflicts,
      bool? sendAvailabilityAlert,
      String? primaryDimensionUniqueId,
      String? defaultImperialMetric,
      String? primaryDimensionDescription,
      int? primaryDimensionShipWeightLbs,
      int? primaryDimensionShipWeightOz,
      int? primaryDimensionWeightInCaseLbs,
      int? primaryDimensionWeightInCaseOz,
      int? primaryDimensionWidthFt,
      int? primaryDimensionWidthIn,
      int? primaryDimensionHeightFt,
      int? primaryDimensionHeightIn,
      int? primaryDimensionLengthFt,
      int? primaryDimensionLengthIn,
      int? primaryDimensionShipWeightKg,
      int? primaryDimensionShipWeightG,
      int? primaryDimensionWeightInCaseKg,
      int? primaryDimensionWeightInCaseG,
      int? primaryDimensionWidthM,
      int? primaryDimensionWidthCm,
      int? primaryDimensionHeightM,
      int? primaryDimensionHeightCm,
      int? primaryDimensionLengthM,
      int? primaryDimensionLengthCm,
      bool? hasSecondaryDimensions,
      String? secondaryDimensionUniqueId,
      String? secondaryDimensionDescription,
      int? secondaryDimensionShipWeightLbs,
      int? secondaryDimensionShipWeightOz,
      int? secondaryDimensionWeightInCaseLbs,
      int? secondaryDimensionWeightInCaseOz,
      int? secondaryDimensionWidthFt,
      int? secondaryDimensionWidthIn,
      int? secondaryDimensionHeightFt,
      int? secondaryDimensionHeightIn,
      int? secondaryDimensionLengthFt,
      int? secondaryDimensionLengthIn,
      int? secondaryDimensionShipWeightKg,
      int? secondaryDimensionShipWeightG,
      int? secondaryDimensionWeightInCaseKg,
      int? secondaryDimensionWeightInCaseG,
      int? secondaryDimensionWidthM,
      int? secondaryDimensionWidthCm,
      int? secondaryDimensionHeightM,
      int? secondaryDimensionHeightCm,
      int? secondaryDimensionLengthM,
      int? secondaryDimensionLengthCm,
      String? countryOfOriginId,
      String? countryOfOrigin,
      bool? displayInSummaryModeWhenRateIsZero,
      bool? qcRequired,
      String? qcTime,
      bool? copyAttributesAsNote,
      bool? trackAssetUsage,
      bool? trackLampUsage,
      bool? trackStrikes,
      bool? trackCandles,
      int? lampCount,
      int? minimumFootCandles,
      bool? trackSoftware,
      String? softwareVersion,
      String? softwareEffectiveDate,
      bool? warehouseSpecificPackage,
      String? completePackagePrice,
      String? kitPackagePrice,
      bool? separatePackageOnQuoteOrder,
      String? containerId,
      String? containerScannableInventoryId,
      String? containerScannableICode,
      String? containerScannableDescription,
      bool? automaticallyRebuildContainerAtCheckIn,
      bool? automaticallyRebuildContainerAtTransferIn,
      String? containerStagingRule,
      bool? excludeContainedItemsFromAvailability,
      bool? useContainerNumber,
      String? containerPackingListBehavior,
      bool? inventoryTypeIsWardrobe,
      bool? inventoryTypeIsSets,
      String? patternId,
      String? pattern,
      String? periodId,
      String? period,
      String? materialId,
      String? material,
      String? genderId,
      String? gender,
      String? labelId,
      String? label,
      String? wardrobeSize,
      int? wardrobePieceCount,
      bool? dyed,
      String? wardrobeSourceId,
      String? wardrobeSource,
      String? wardrobeCareId,
      String? wardrobeCare,
      double? cleaningFeeAmount,
      String? wardrobeDetailedDescription,
      String? webDetailedDescription,
      bool? overrideSystemDefaultRevenueAllocationBehavior,
      bool? allocateRevenueForAccessories,
      String? packageRevenueCalculationFormula,
      bool? isHazardousMaterial,
      String? descriptionWithAkas,
      String? costCalculation,
      double? quantity,
      String? aisleLocation,
      String? shelfLocation,
      bool? taxable,
      String? iCode,
      String? description,
      String? availFor,
      String? categoryId,
      String? category,
      int? subCategoryCount,
      String? subCategoryId,
      String? subCategory,
      String? classification,
      String? classificationDescription,
      String? classificationColor,
      String? unitId,
      String? unit,
      String? unitType,
      bool? nonDiscountable,
      bool? overrideProfitAndLossCategory,
      String? profitAndLossCategoryId,
      String? profitAndLossCategory,
      bool? autoCopyNotesToQuoteOrder,
      String? note,
      bool? printNoteOnInContract,
      bool? printNoteOnOutContract,
      bool? printNoteOnReceiveContract,
      bool? printNoteOnReturnContract,
      bool? printNoteOnInvoice,
      bool? printNoteOnOrder,
      bool? printNoteOnPickList,
      bool? printNoteOnPO,
      bool? printNoteOnQuote,
      bool? printNoteOnReturnList,
      bool? printNoteOnPoReceiveList,
      bool? printNoteOnPoReturnList,
      String? assetAccountId,
      String? assetAccountNo,
      String? assetAccountDescription,
      String? incomeAccountId,
      String? incomeAccountNo,
      String? incomeAccountDescription,
      String? subIncomeAccountId,
      String? subIncomeAccountNo,
      String? subIncomeAccountDescription,
      String? consignmentIncomeAccountId,
      String? consignmentIncomeAccountNo,
      String? consignmentIncomeAccountDescription,
      String? ldIncomeAccountId,
      String? ldIncomeAccountNo,
      String? ldIncomeAccountDescription,
      String? equipmentSaleIncomeAccountId,
      String? equipmentSaleIncomeAccountNo,
      String? equipmentSaleIncomeAccountDescription,
      String? expenseAccountId,
      String? expenseAccountNo,
      String? expenseAccountDescription,
      String? costOfGoodsSoldExpenseAccountId,
      String? costOfGoodsSoldExpenseAccountNo,
      String? costOfGoodsSoldExpenseAccountDescription,
      String? costOfGoodsRentedExpenseAccountId,
      String? costOfGoodsRentedExpenseAccountNo,
      String? costOfGoodsRentedExpenseAccountDescription,
      String? depreciationExpenseAccountId,
      String? depreciationExpenseAccountNo,
      String? depreciationExpenseAccountDescription,
      String? accumulatedDepreciationExpenseAccountId,
      String? accumulatedDepreciationExpenseAccountNo,
      String? accumulatedDepreciationExpenseAccountDescription,
      String? originalShowId,
      bool? inactive,
      String? dateStamp,
      bool? manifestShippingContainer,
      bool? manifestStandAloneItem,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<WebApiModulesHomeControlsInventoryWarehouseInventoryWarehouse>?
          warehouses,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesInventoryRentalInventoryRentalInventoryDetailResponse(
        excludeFromReturnOnAsset:
            excludeFromReturnOnAsset ?? this.excludeFromReturnOnAsset,
        isFixedAsset: isFixedAsset ?? this.isFixedAsset,
        multiAssignRFIDs: multiAssignRFIDs ?? this.multiAssignRFIDs,
        minimumDaysPerWeek: minimumDaysPerWeek ?? this.minimumDaysPerWeek,
        setOpeningId: setOpeningId ?? this.setOpeningId,
        setOpening: setOpening ?? this.setOpening,
        wallTypeId: wallTypeId ?? this.wallTypeId,
        wallType: wallType ?? this.wallType,
        setSurfaceId: setSurfaceId ?? this.setSurfaceId,
        setSurface: setSurface ?? this.setSurface,
        wallWidthFt: wallWidthFt ?? this.wallWidthFt,
        wallWidthIn: wallWidthIn ?? this.wallWidthIn,
        wallHeightFt: wallHeightFt ?? this.wallHeightFt,
        wallHeightIn: wallHeightIn ?? this.wallHeightIn,
        wallLengthFt: wallLengthFt ?? this.wallLengthFt,
        wallLengthIn: wallLengthIn ?? this.wallLengthIn,
        dailyRate: dailyRate ?? this.dailyRate,
        weeklyRate: weeklyRate ?? this.weeklyRate,
        week2Rate: week2Rate ?? this.week2Rate,
        week3Rate: week3Rate ?? this.week3Rate,
        week4Rate: week4Rate ?? this.week4Rate,
        monthlyRate: monthlyRate ?? this.monthlyRate,
        unitValue: unitValue ?? this.unitValue,
        replacementCost: replacementCost ?? this.replacementCost,
        inventoryId: inventoryId ?? this.inventoryId,
        inventoryTypeId: inventoryTypeId ?? this.inventoryTypeId,
        inventoryType: inventoryType ?? this.inventoryType,
        availableFrom: availableFrom ?? this.availableFrom,
        trackedBy: trackedBy ?? this.trackedBy,
        confirmTrackedBy: confirmTrackedBy ?? this.confirmTrackedBy,
        rank: rank ?? this.rank,
        manufacturerPartNumber:
            manufacturerPartNumber ?? this.manufacturerPartNumber,
        manufacturerId: manufacturerId ?? this.manufacturerId,
        manufacturer: manufacturer ?? this.manufacturer,
        manufacturerUrl: manufacturerUrl ?? this.manufacturerUrl,
        excludeImageFromQuoteOrderPrint: excludeImageFromQuoteOrderPrint ??
            this.excludeImageFromQuoteOrderPrint,
        noAvailabilityCheck: noAvailabilityCheck ?? this.noAvailabilityCheck,
        availabilityManuallyResolveConflicts: availabilityManuallyResolveConflicts ??
            this.availabilityManuallyResolveConflicts,
        sendAvailabilityAlert:
            sendAvailabilityAlert ?? this.sendAvailabilityAlert,
        primaryDimensionUniqueId:
            primaryDimensionUniqueId ?? this.primaryDimensionUniqueId,
        defaultImperialMetric:
            defaultImperialMetric ?? this.defaultImperialMetric,
        primaryDimensionDescription:
            primaryDimensionDescription ?? this.primaryDimensionDescription,
        primaryDimensionShipWeightLbs:
            primaryDimensionShipWeightLbs ?? this.primaryDimensionShipWeightLbs,
        primaryDimensionShipWeightOz:
            primaryDimensionShipWeightOz ?? this.primaryDimensionShipWeightOz,
        primaryDimensionWeightInCaseLbs: primaryDimensionWeightInCaseLbs ??
            this.primaryDimensionWeightInCaseLbs,
        primaryDimensionWeightInCaseOz: primaryDimensionWeightInCaseOz ??
            this.primaryDimensionWeightInCaseOz,
        primaryDimensionWidthFt:
            primaryDimensionWidthFt ?? this.primaryDimensionWidthFt,
        primaryDimensionWidthIn:
            primaryDimensionWidthIn ?? this.primaryDimensionWidthIn,
        primaryDimensionHeightFt:
            primaryDimensionHeightFt ?? this.primaryDimensionHeightFt,
        primaryDimensionHeightIn:
            primaryDimensionHeightIn ?? this.primaryDimensionHeightIn,
        primaryDimensionLengthFt:
            primaryDimensionLengthFt ?? this.primaryDimensionLengthFt,
        primaryDimensionLengthIn:
            primaryDimensionLengthIn ?? this.primaryDimensionLengthIn,
        primaryDimensionShipWeightKg:
            primaryDimensionShipWeightKg ?? this.primaryDimensionShipWeightKg,
        primaryDimensionShipWeightG:
            primaryDimensionShipWeightG ?? this.primaryDimensionShipWeightG,
        primaryDimensionWeightInCaseKg: primaryDimensionWeightInCaseKg ??
            this.primaryDimensionWeightInCaseKg,
        primaryDimensionWeightInCaseG:
            primaryDimensionWeightInCaseG ?? this.primaryDimensionWeightInCaseG,
        primaryDimensionWidthM:
            primaryDimensionWidthM ?? this.primaryDimensionWidthM,
        primaryDimensionWidthCm:
            primaryDimensionWidthCm ?? this.primaryDimensionWidthCm,
        primaryDimensionHeightM:
            primaryDimensionHeightM ?? this.primaryDimensionHeightM,
        primaryDimensionHeightCm:
            primaryDimensionHeightCm ?? this.primaryDimensionHeightCm,
        primaryDimensionLengthM:
            primaryDimensionLengthM ?? this.primaryDimensionLengthM,
        primaryDimensionLengthCm:
            primaryDimensionLengthCm ?? this.primaryDimensionLengthCm,
        hasSecondaryDimensions:
            hasSecondaryDimensions ?? this.hasSecondaryDimensions,
        secondaryDimensionUniqueId:
            secondaryDimensionUniqueId ?? this.secondaryDimensionUniqueId,
        secondaryDimensionDescription:
            secondaryDimensionDescription ?? this.secondaryDimensionDescription,
        secondaryDimensionShipWeightLbs: secondaryDimensionShipWeightLbs ??
            this.secondaryDimensionShipWeightLbs,
        secondaryDimensionShipWeightOz: secondaryDimensionShipWeightOz ??
            this.secondaryDimensionShipWeightOz,
        secondaryDimensionWeightInCaseLbs: secondaryDimensionWeightInCaseLbs ??
            this.secondaryDimensionWeightInCaseLbs,
        secondaryDimensionWeightInCaseOz: secondaryDimensionWeightInCaseOz ??
            this.secondaryDimensionWeightInCaseOz,
        secondaryDimensionWidthFt:
            secondaryDimensionWidthFt ?? this.secondaryDimensionWidthFt,
        secondaryDimensionWidthIn:
            secondaryDimensionWidthIn ?? this.secondaryDimensionWidthIn,
        secondaryDimensionHeightFt:
            secondaryDimensionHeightFt ?? this.secondaryDimensionHeightFt,
        secondaryDimensionHeightIn:
            secondaryDimensionHeightIn ?? this.secondaryDimensionHeightIn,
        secondaryDimensionLengthFt:
            secondaryDimensionLengthFt ?? this.secondaryDimensionLengthFt,
        secondaryDimensionLengthIn:
            secondaryDimensionLengthIn ?? this.secondaryDimensionLengthIn,
        secondaryDimensionShipWeightKg: secondaryDimensionShipWeightKg ??
            this.secondaryDimensionShipWeightKg,
        secondaryDimensionShipWeightG:
            secondaryDimensionShipWeightG ?? this.secondaryDimensionShipWeightG,
        secondaryDimensionWeightInCaseKg: secondaryDimensionWeightInCaseKg ??
            this.secondaryDimensionWeightInCaseKg,
        secondaryDimensionWeightInCaseG: secondaryDimensionWeightInCaseG ??
            this.secondaryDimensionWeightInCaseG,
        secondaryDimensionWidthM:
            secondaryDimensionWidthM ?? this.secondaryDimensionWidthM,
        secondaryDimensionWidthCm:
            secondaryDimensionWidthCm ?? this.secondaryDimensionWidthCm,
        secondaryDimensionHeightM:
            secondaryDimensionHeightM ?? this.secondaryDimensionHeightM,
        secondaryDimensionHeightCm:
            secondaryDimensionHeightCm ?? this.secondaryDimensionHeightCm,
        secondaryDimensionLengthM:
            secondaryDimensionLengthM ?? this.secondaryDimensionLengthM,
        secondaryDimensionLengthCm:
            secondaryDimensionLengthCm ?? this.secondaryDimensionLengthCm,
        countryOfOriginId: countryOfOriginId ?? this.countryOfOriginId,
        countryOfOrigin: countryOfOrigin ?? this.countryOfOrigin,
        displayInSummaryModeWhenRateIsZero: displayInSummaryModeWhenRateIsZero ??
            this.displayInSummaryModeWhenRateIsZero,
        qcRequired: qcRequired ?? this.qcRequired,
        qcTime: qcTime ?? this.qcTime,
        copyAttributesAsNote: copyAttributesAsNote ?? this.copyAttributesAsNote,
        trackAssetUsage: trackAssetUsage ?? this.trackAssetUsage,
        trackLampUsage: trackLampUsage ?? this.trackLampUsage,
        trackStrikes: trackStrikes ?? this.trackStrikes,
        trackCandles: trackCandles ?? this.trackCandles,
        lampCount: lampCount ?? this.lampCount,
        minimumFootCandles: minimumFootCandles ?? this.minimumFootCandles,
        trackSoftware: trackSoftware ?? this.trackSoftware,
        softwareVersion: softwareVersion ?? this.softwareVersion,
        softwareEffectiveDate:
            softwareEffectiveDate ?? this.softwareEffectiveDate,
        warehouseSpecificPackage:
            warehouseSpecificPackage ?? this.warehouseSpecificPackage,
        completePackagePrice: completePackagePrice ?? this.completePackagePrice,
        kitPackagePrice: kitPackagePrice ?? this.kitPackagePrice,
        separatePackageOnQuoteOrder:
            separatePackageOnQuoteOrder ?? this.separatePackageOnQuoteOrder,
        containerId: containerId ?? this.containerId,
        containerScannableInventoryId:
            containerScannableInventoryId ?? this.containerScannableInventoryId,
        containerScannableICode:
            containerScannableICode ?? this.containerScannableICode,
        containerScannableDescription:
            containerScannableDescription ?? this.containerScannableDescription,
        automaticallyRebuildContainerAtCheckIn: automaticallyRebuildContainerAtCheckIn ??
            this.automaticallyRebuildContainerAtCheckIn,
        automaticallyRebuildContainerAtTransferIn:
            automaticallyRebuildContainerAtTransferIn ?? this.automaticallyRebuildContainerAtTransferIn,
        containerStagingRule: containerStagingRule ?? this.containerStagingRule,
        excludeContainedItemsFromAvailability: excludeContainedItemsFromAvailability ?? this.excludeContainedItemsFromAvailability,
        useContainerNumber: useContainerNumber ?? this.useContainerNumber,
        containerPackingListBehavior: containerPackingListBehavior ?? this.containerPackingListBehavior,
        inventoryTypeIsWardrobe: inventoryTypeIsWardrobe ?? this.inventoryTypeIsWardrobe,
        inventoryTypeIsSets: inventoryTypeIsSets ?? this.inventoryTypeIsSets,
        patternId: patternId ?? this.patternId,
        pattern: pattern ?? this.pattern,
        periodId: periodId ?? this.periodId,
        period: period ?? this.period,
        materialId: materialId ?? this.materialId,
        material: material ?? this.material,
        genderId: genderId ?? this.genderId,
        gender: gender ?? this.gender,
        labelId: labelId ?? this.labelId,
        label: label ?? this.label,
        wardrobeSize: wardrobeSize ?? this.wardrobeSize,
        wardrobePieceCount: wardrobePieceCount ?? this.wardrobePieceCount,
        dyed: dyed ?? this.dyed,
        wardrobeSourceId: wardrobeSourceId ?? this.wardrobeSourceId,
        wardrobeSource: wardrobeSource ?? this.wardrobeSource,
        wardrobeCareId: wardrobeCareId ?? this.wardrobeCareId,
        wardrobeCare: wardrobeCare ?? this.wardrobeCare,
        cleaningFeeAmount: cleaningFeeAmount ?? this.cleaningFeeAmount,
        wardrobeDetailedDescription: wardrobeDetailedDescription ?? this.wardrobeDetailedDescription,
        webDetailedDescription: webDetailedDescription ?? this.webDetailedDescription,
        overrideSystemDefaultRevenueAllocationBehavior: overrideSystemDefaultRevenueAllocationBehavior ?? this.overrideSystemDefaultRevenueAllocationBehavior,
        allocateRevenueForAccessories: allocateRevenueForAccessories ?? this.allocateRevenueForAccessories,
        packageRevenueCalculationFormula: packageRevenueCalculationFormula ?? this.packageRevenueCalculationFormula,
        isHazardousMaterial: isHazardousMaterial ?? this.isHazardousMaterial,
        descriptionWithAkas: descriptionWithAkas ?? this.descriptionWithAkas,
        costCalculation: costCalculation ?? this.costCalculation,
        quantity: quantity ?? this.quantity,
        aisleLocation: aisleLocation ?? this.aisleLocation,
        shelfLocation: shelfLocation ?? this.shelfLocation,
        taxable: taxable ?? this.taxable,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        availFor: availFor ?? this.availFor,
        categoryId: categoryId ?? this.categoryId,
        category: category ?? this.category,
        subCategoryCount: subCategoryCount ?? this.subCategoryCount,
        subCategoryId: subCategoryId ?? this.subCategoryId,
        subCategory: subCategory ?? this.subCategory,
        classification: classification ?? this.classification,
        classificationDescription: classificationDescription ?? this.classificationDescription,
        classificationColor: classificationColor ?? this.classificationColor,
        unitId: unitId ?? this.unitId,
        unit: unit ?? this.unit,
        unitType: unitType ?? this.unitType,
        nonDiscountable: nonDiscountable ?? this.nonDiscountable,
        overrideProfitAndLossCategory: overrideProfitAndLossCategory ?? this.overrideProfitAndLossCategory,
        profitAndLossCategoryId: profitAndLossCategoryId ?? this.profitAndLossCategoryId,
        profitAndLossCategory: profitAndLossCategory ?? this.profitAndLossCategory,
        autoCopyNotesToQuoteOrder: autoCopyNotesToQuoteOrder ?? this.autoCopyNotesToQuoteOrder,
        note: note ?? this.note,
        printNoteOnInContract: printNoteOnInContract ?? this.printNoteOnInContract,
        printNoteOnOutContract: printNoteOnOutContract ?? this.printNoteOnOutContract,
        printNoteOnReceiveContract: printNoteOnReceiveContract ?? this.printNoteOnReceiveContract,
        printNoteOnReturnContract: printNoteOnReturnContract ?? this.printNoteOnReturnContract,
        printNoteOnInvoice: printNoteOnInvoice ?? this.printNoteOnInvoice,
        printNoteOnOrder: printNoteOnOrder ?? this.printNoteOnOrder,
        printNoteOnPickList: printNoteOnPickList ?? this.printNoteOnPickList,
        printNoteOnPO: printNoteOnPO ?? this.printNoteOnPO,
        printNoteOnQuote: printNoteOnQuote ?? this.printNoteOnQuote,
        printNoteOnReturnList: printNoteOnReturnList ?? this.printNoteOnReturnList,
        printNoteOnPoReceiveList: printNoteOnPoReceiveList ?? this.printNoteOnPoReceiveList,
        printNoteOnPoReturnList: printNoteOnPoReturnList ?? this.printNoteOnPoReturnList,
        assetAccountId: assetAccountId ?? this.assetAccountId,
        assetAccountNo: assetAccountNo ?? this.assetAccountNo,
        assetAccountDescription: assetAccountDescription ?? this.assetAccountDescription,
        incomeAccountId: incomeAccountId ?? this.incomeAccountId,
        incomeAccountNo: incomeAccountNo ?? this.incomeAccountNo,
        incomeAccountDescription: incomeAccountDescription ?? this.incomeAccountDescription,
        subIncomeAccountId: subIncomeAccountId ?? this.subIncomeAccountId,
        subIncomeAccountNo: subIncomeAccountNo ?? this.subIncomeAccountNo,
        subIncomeAccountDescription: subIncomeAccountDescription ?? this.subIncomeAccountDescription,
        consignmentIncomeAccountId: consignmentIncomeAccountId ?? this.consignmentIncomeAccountId,
        consignmentIncomeAccountNo: consignmentIncomeAccountNo ?? this.consignmentIncomeAccountNo,
        consignmentIncomeAccountDescription: consignmentIncomeAccountDescription ?? this.consignmentIncomeAccountDescription,
        ldIncomeAccountId: ldIncomeAccountId ?? this.ldIncomeAccountId,
        ldIncomeAccountNo: ldIncomeAccountNo ?? this.ldIncomeAccountNo,
        ldIncomeAccountDescription: ldIncomeAccountDescription ?? this.ldIncomeAccountDescription,
        equipmentSaleIncomeAccountId: equipmentSaleIncomeAccountId ?? this.equipmentSaleIncomeAccountId,
        equipmentSaleIncomeAccountNo: equipmentSaleIncomeAccountNo ?? this.equipmentSaleIncomeAccountNo,
        equipmentSaleIncomeAccountDescription: equipmentSaleIncomeAccountDescription ?? this.equipmentSaleIncomeAccountDescription,
        expenseAccountId: expenseAccountId ?? this.expenseAccountId,
        expenseAccountNo: expenseAccountNo ?? this.expenseAccountNo,
        expenseAccountDescription: expenseAccountDescription ?? this.expenseAccountDescription,
        costOfGoodsSoldExpenseAccountId: costOfGoodsSoldExpenseAccountId ?? this.costOfGoodsSoldExpenseAccountId,
        costOfGoodsSoldExpenseAccountNo: costOfGoodsSoldExpenseAccountNo ?? this.costOfGoodsSoldExpenseAccountNo,
        costOfGoodsSoldExpenseAccountDescription: costOfGoodsSoldExpenseAccountDescription ?? this.costOfGoodsSoldExpenseAccountDescription,
        costOfGoodsRentedExpenseAccountId: costOfGoodsRentedExpenseAccountId ?? this.costOfGoodsRentedExpenseAccountId,
        costOfGoodsRentedExpenseAccountNo: costOfGoodsRentedExpenseAccountNo ?? this.costOfGoodsRentedExpenseAccountNo,
        costOfGoodsRentedExpenseAccountDescription: costOfGoodsRentedExpenseAccountDescription ?? this.costOfGoodsRentedExpenseAccountDescription,
        depreciationExpenseAccountId: depreciationExpenseAccountId ?? this.depreciationExpenseAccountId,
        depreciationExpenseAccountNo: depreciationExpenseAccountNo ?? this.depreciationExpenseAccountNo,
        depreciationExpenseAccountDescription: depreciationExpenseAccountDescription ?? this.depreciationExpenseAccountDescription,
        accumulatedDepreciationExpenseAccountId: accumulatedDepreciationExpenseAccountId ?? this.accumulatedDepreciationExpenseAccountId,
        accumulatedDepreciationExpenseAccountNo: accumulatedDepreciationExpenseAccountNo ?? this.accumulatedDepreciationExpenseAccountNo,
        accumulatedDepreciationExpenseAccountDescription: accumulatedDepreciationExpenseAccountDescription ?? this.accumulatedDepreciationExpenseAccountDescription,
        originalShowId: originalShowId ?? this.originalShowId,
        inactive: inactive ?? this.inactive,
        dateStamp: dateStamp ?? this.dateStamp,
        manifestShippingContainer: manifestShippingContainer ?? this.manifestShippingContainer,
        manifestStandAloneItem: manifestStandAloneItem ?? this.manifestStandAloneItem,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        warehouses: warehouses ?? this.warehouses,
        custom: custom ?? this.custom,
        defaultFieldAttributes: defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryRentalInventoryRentalInventoryDocument {
  WebApiModulesInventoryRentalInventoryRentalInventoryDocument({
    this.inventoryId,
    this.copying,
    this.documentId,
    this.documentTypeId,
    this.uniqueId1,
    this.uniqueId2,
    this.uniqueId1Int,
    this.description,
    this.inputByUsersId,
    this.attachDate,
    this.attachTime,
    this.attachToEmail,
    this.inactive,
    this.dateStamp,
    this.extension,
    this.documentType,
    this.inputBy,
    this.hasImage,
    this.hasFile,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesInventoryRentalInventoryRentalInventoryDocument.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryRentalInventoryRentalInventoryDocumentFromJson(
          json);

  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'copying')
  final bool? copying;
  @JsonKey(name: 'DocumentId')
  final String? documentId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'UniqueId1')
  final String? uniqueId1;
  @JsonKey(name: 'UniqueId2')
  final String? uniqueId2;
  @JsonKey(name: 'UniqueId1Int')
  final int? uniqueId1Int;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'InputByUsersId')
  final String? inputByUsersId;
  @JsonKey(name: 'AttachDate')
  final String? attachDate;
  @JsonKey(name: 'AttachTime')
  final String? attachTime;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'Extension')
  final String? extension;
  @JsonKey(name: 'DocumentType')
  final String? documentType;
  @JsonKey(name: 'InputBy')
  final String? inputBy;
  @JsonKey(name: 'HasImage')
  final bool? hasImage;
  @JsonKey(name: 'HasFile')
  final bool? hasFile;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesInventoryRentalInventoryRentalInventoryDocumentFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryRentalInventoryRentalInventoryDocumentToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryRentalInventoryRentalInventoryDocumentToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryRentalInventoryRentalInventoryDocument &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.copying, copying) ||
                const DeepCollectionEquality()
                    .equals(other.copying, copying)) &&
            (identical(other.documentId, documentId) ||
                const DeepCollectionEquality()
                    .equals(other.documentId, documentId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.uniqueId1, uniqueId1) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1, uniqueId1)) &&
            (identical(other.uniqueId2, uniqueId2) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId2, uniqueId2)) &&
            (identical(other.uniqueId1Int, uniqueId1Int) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1Int, uniqueId1Int)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.inputByUsersId, inputByUsersId) ||
                const DeepCollectionEquality()
                    .equals(other.inputByUsersId, inputByUsersId)) &&
            (identical(other.attachDate, attachDate) ||
                const DeepCollectionEquality()
                    .equals(other.attachDate, attachDate)) &&
            (identical(other.attachTime, attachTime) ||
                const DeepCollectionEquality()
                    .equals(other.attachTime, attachTime)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.extension, extension) ||
                const DeepCollectionEquality()
                    .equals(other.extension, extension)) &&
            (identical(other.documentType, documentType) ||
                const DeepCollectionEquality()
                    .equals(other.documentType, documentType)) &&
            (identical(other.inputBy, inputBy) || const DeepCollectionEquality().equals(other.inputBy, inputBy)) &&
            (identical(other.hasImage, hasImage) || const DeepCollectionEquality().equals(other.hasImage, hasImage)) &&
            (identical(other.hasFile, hasFile) || const DeepCollectionEquality().equals(other.hasFile, hasFile)) &&
            (identical(other.fileIsModified, fileIsModified) || const DeepCollectionEquality().equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) || const DeepCollectionEquality().equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) || const DeepCollectionEquality().equals(other.filePath, filePath)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesInventoryRentalInventoryRentalInventoryDocumentExtension
    on WebApiModulesInventoryRentalInventoryRentalInventoryDocument {
  WebApiModulesInventoryRentalInventoryRentalInventoryDocument copyWith(
      {String? inventoryId,
      bool? copying,
      String? documentId,
      String? documentTypeId,
      String? uniqueId1,
      String? uniqueId2,
      int? uniqueId1Int,
      String? description,
      String? inputByUsersId,
      String? attachDate,
      String? attachTime,
      bool? attachToEmail,
      bool? inactive,
      String? dateStamp,
      String? extension,
      String? documentType,
      String? inputBy,
      bool? hasImage,
      bool? hasFile,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesInventoryRentalInventoryRentalInventoryDocument(
        inventoryId: inventoryId ?? this.inventoryId,
        copying: copying ?? this.copying,
        documentId: documentId ?? this.documentId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        uniqueId1: uniqueId1 ?? this.uniqueId1,
        uniqueId2: uniqueId2 ?? this.uniqueId2,
        uniqueId1Int: uniqueId1Int ?? this.uniqueId1Int,
        description: description ?? this.description,
        inputByUsersId: inputByUsersId ?? this.inputByUsersId,
        attachDate: attachDate ?? this.attachDate,
        attachTime: attachTime ?? this.attachTime,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        dateStamp: dateStamp ?? this.dateStamp,
        extension: extension ?? this.extension,
        documentType: documentType ?? this.documentType,
        inputBy: inputBy ?? this.inputBy,
        hasImage: hasImage ?? this.hasImage,
        hasFile: hasFile ?? this.hasFile,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPostRequest {
  WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPostRequest({
    this.inventoryId,
    this.documentTypeId,
    this.description,
    this.attachToEmail,
    this.inactive,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
  });

  factory WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPostRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPostRequestFromJson(
          json);

  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  static const fromJsonFactory =
      _$WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPostRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPostRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPostRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPostRequest &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)));
  }
}

extension $WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPostRequestExtension
    on WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPostRequest {
  WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPostRequest
      copyWith(
          {String? inventoryId,
          String? documentTypeId,
          String? description,
          bool? attachToEmail,
          bool? inactive,
          bool? fileIsModified,
          String? fileDataUrl,
          String? filePath}) {
    return WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPostRequest(
        inventoryId: inventoryId ?? this.inventoryId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        description: description ?? this.description,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPutRequest {
  WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPutRequest({
    this.inventoryId,
    this.documentId,
    this.documentTypeId,
    this.description,
    this.attachToEmail,
    this.inactive,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
  });

  factory WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPutRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPutRequestFromJson(
          json);

  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'DocumentId')
  final String? documentId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  static const fromJsonFactory =
      _$WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPutRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPutRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPutRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPutRequest &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.documentId, documentId) ||
                const DeepCollectionEquality()
                    .equals(other.documentId, documentId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)));
  }
}

extension $WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPutRequestExtension
    on WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPutRequest {
  WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPutRequest
      copyWith(
          {String? inventoryId,
          String? documentId,
          String? documentTypeId,
          String? description,
          bool? attachToEmail,
          bool? inactive,
          bool? fileIsModified,
          String? fileDataUrl,
          String? filePath}) {
    return WebApiModulesInventoryRentalInventoryRentalInventoryDocumentPutRequest(
        inventoryId: inventoryId ?? this.inventoryId,
        documentId: documentId ?? this.documentId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        description: description ?? this.description,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryRepairRepair {
  WebApiModulesInventoryRepairRepair({
    this.repairId,
    this.locationId,
    this.location,
    this.billingLocationId,
    this.billingLocation,
    this.warehouseId,
    this.itemWarehouseId,
    this.warehouse,
    this.warehouseCode,
    this.billingWarehouseId,
    this.billingWarehouse,
    this.departmentId,
    this.department,
    this.inventoryTypeId,
    this.inventoryType,
    this.pendingRepair,
    this.repairNumber,
    this.repairNumberColor,
    this.repairDate,
    this.outsideRepair,
    this.outsideRepairPoNumber,
    this.itemId,
    this.barCode,
    this.serialNumber,
    this.rfId,
    this.barCodeColor,
    this.inventoryId,
    this.availFor,
    this.availForDisplay,
    this.iCode,
    this.iCodeColor,
    this.itemDescription,
    this.quantity,
    this.quantityColor,
    this.damageDealId,
    this.damageDeal,
    this.damageDealColor,
    this.damageOrderId,
    this.damageOrderNumber,
    this.damageOrderDescription,
    this.damageContractId,
    this.damageContractNumber,
    this.damageContractDate,
    this.damageScannedById,
    this.damageScannedBy,
    this.lossAndDamageOrderId,
    this.lossAndDamageOrderNumber,
    this.lossAndDamageOrderDescription,
    this.chargeOrderId,
    this.chargeOrderNumber,
    this.chargeOrderDescription,
    this.chargeInvoiceId,
    this.chargeInvoiceNumber,
    this.chargeInvoiceDescription,
    this.taxOptionId,
    this.taxOption,
    this.taxId,
    this.rentalTaxRate1,
    this.salesTaxRate1,
    this.laborTaxRate1,
    this.rentalTaxRate2,
    this.salesTaxRate2,
    this.laborTaxRate2,
    this.status,
    this.statusColor,
    this.statusDate,
    this.billable,
    this.billableDisplay,
    this.notBilled,
    this.priority,
    this.priorityDescription,
    this.priorityColor,
    this.repairType,
    this.poPending,
    this.poNumber,
    this.damage,
    this.correction,
    this.released,
    this.releasedQuantity,
    this.transferId,
    this.transferredFromWarehouseId,
    this.dueDate,
    this.estimateByUserId,
    this.estimateBy,
    this.estimateDate,
    this.completeByUserId,
    this.completeBy,
    this.completeDate,
    this.inputDate,
    this.inputByUserId,
    this.repairItemStatusId,
    this.repairItemStatus,
    this.cost,
    this.currencyId,
    this.officeLocationDefaultCurrencyId,
    this.currencyCode,
    this.currencySymbol,
    this.currencyColor,
    this.notes,
    this.inactive,
    this.qcRequired,
    this.autoCompleteQC,
    this.qcNote,
    this.conditionId,
    this.condition,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesInventoryRepairRepair.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryRepairRepairFromJson(json);

  @JsonKey(name: 'RepairId')
  final String? repairId;
  @JsonKey(name: 'LocationId')
  final String? locationId;
  @JsonKey(name: 'Location')
  final String? location;
  @JsonKey(name: 'BillingLocationId')
  final String? billingLocationId;
  @JsonKey(name: 'BillingLocation')
  final String? billingLocation;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'ItemWarehouseId')
  final String? itemWarehouseId;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'BillingWarehouseId')
  final String? billingWarehouseId;
  @JsonKey(name: 'BillingWarehouse')
  final String? billingWarehouse;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'Department')
  final String? department;
  @JsonKey(name: 'InventoryTypeId')
  final String? inventoryTypeId;
  @JsonKey(name: 'InventoryType')
  final String? inventoryType;
  @JsonKey(name: 'PendingRepair')
  final bool? pendingRepair;
  @JsonKey(name: 'RepairNumber')
  final String? repairNumber;
  @JsonKey(name: 'RepairNumberColor')
  final String? repairNumberColor;
  @JsonKey(name: 'RepairDate')
  final String? repairDate;
  @JsonKey(name: 'OutsideRepair')
  final bool? outsideRepair;
  @JsonKey(name: 'OutsideRepairPoNumber')
  final String? outsideRepairPoNumber;
  @JsonKey(name: 'ItemId')
  final String? itemId;
  @JsonKey(name: 'BarCode')
  final String? barCode;
  @JsonKey(name: 'SerialNumber')
  final String? serialNumber;
  @JsonKey(name: 'RfId')
  final String? rfId;
  @JsonKey(name: 'BarCodeColor')
  final String? barCodeColor;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'AvailFor')
  final String? availFor;
  @JsonKey(name: 'AvailForDisplay')
  final String? availForDisplay;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'ICodeColor')
  final String? iCodeColor;
  @JsonKey(name: 'ItemDescription')
  final String? itemDescription;
  @JsonKey(name: 'Quantity')
  final int? quantity;
  @JsonKey(name: 'QuantityColor')
  final String? quantityColor;
  @JsonKey(name: 'DamageDealId')
  final String? damageDealId;
  @JsonKey(name: 'DamageDeal')
  final String? damageDeal;
  @JsonKey(name: 'DamageDealColor')
  final String? damageDealColor;
  @JsonKey(name: 'DamageOrderId')
  final String? damageOrderId;
  @JsonKey(name: 'DamageOrderNumber')
  final String? damageOrderNumber;
  @JsonKey(name: 'DamageOrderDescription')
  final String? damageOrderDescription;
  @JsonKey(name: 'DamageContractId')
  final String? damageContractId;
  @JsonKey(name: 'DamageContractNumber')
  final String? damageContractNumber;
  @JsonKey(name: 'DamageContractDate')
  final String? damageContractDate;
  @JsonKey(name: 'DamageScannedById')
  final String? damageScannedById;
  @JsonKey(name: 'DamageScannedBy')
  final String? damageScannedBy;
  @JsonKey(name: 'LossAndDamageOrderId')
  final String? lossAndDamageOrderId;
  @JsonKey(name: 'LossAndDamageOrderNumber')
  final String? lossAndDamageOrderNumber;
  @JsonKey(name: 'LossAndDamageOrderDescription')
  final String? lossAndDamageOrderDescription;
  @JsonKey(name: 'ChargeOrderId')
  final String? chargeOrderId;
  @JsonKey(name: 'ChargeOrderNumber')
  final String? chargeOrderNumber;
  @JsonKey(name: 'ChargeOrderDescription')
  final String? chargeOrderDescription;
  @JsonKey(name: 'ChargeInvoiceId')
  final String? chargeInvoiceId;
  @JsonKey(name: 'ChargeInvoiceNumber')
  final String? chargeInvoiceNumber;
  @JsonKey(name: 'ChargeInvoiceDescription')
  final String? chargeInvoiceDescription;
  @JsonKey(name: 'TaxOptionId')
  final String? taxOptionId;
  @JsonKey(name: 'TaxOption')
  final String? taxOption;
  @JsonKey(name: 'TaxId')
  final String? taxId;
  @JsonKey(name: 'RentalTaxRate1')
  final double? rentalTaxRate1;
  @JsonKey(name: 'SalesTaxRate1')
  final double? salesTaxRate1;
  @JsonKey(name: 'LaborTaxRate1')
  final double? laborTaxRate1;
  @JsonKey(name: 'RentalTaxRate2')
  final double? rentalTaxRate2;
  @JsonKey(name: 'SalesTaxRate2')
  final double? salesTaxRate2;
  @JsonKey(name: 'LaborTaxRate2')
  final double? laborTaxRate2;
  @JsonKey(name: 'Status')
  final String? status;
  @JsonKey(name: 'StatusColor')
  final String? statusColor;
  @JsonKey(name: 'StatusDate')
  final String? statusDate;
  @JsonKey(name: 'Billable')
  final bool? billable;
  @JsonKey(name: 'BillableDisplay')
  final String? billableDisplay;
  @JsonKey(name: 'NotBilled')
  final bool? notBilled;
  @JsonKey(name: 'Priority')
  final String? priority;
  @JsonKey(name: 'PriorityDescription')
  final String? priorityDescription;
  @JsonKey(name: 'PriorityColor')
  final String? priorityColor;
  @JsonKey(name: 'RepairType')
  final String? repairType;
  @JsonKey(name: 'PoPending')
  final bool? poPending;
  @JsonKey(name: 'PoNumber')
  final String? poNumber;
  @JsonKey(name: 'Damage')
  final String? damage;
  @JsonKey(name: 'Correction')
  final String? correction;
  @JsonKey(name: 'Released')
  final bool? released;
  @JsonKey(name: 'ReleasedQuantity')
  final double? releasedQuantity;
  @JsonKey(name: 'TransferId')
  final String? transferId;
  @JsonKey(name: 'TransferredFromWarehouseId')
  final String? transferredFromWarehouseId;
  @JsonKey(name: 'DueDate')
  final String? dueDate;
  @JsonKey(name: 'EstimateByUserId')
  final String? estimateByUserId;
  @JsonKey(name: 'EstimateBy')
  final String? estimateBy;
  @JsonKey(name: 'EstimateDate')
  final String? estimateDate;
  @JsonKey(name: 'CompleteByUserId')
  final String? completeByUserId;
  @JsonKey(name: 'CompleteBy')
  final String? completeBy;
  @JsonKey(name: 'CompleteDate')
  final String? completeDate;
  @JsonKey(name: 'InputDate')
  final String? inputDate;
  @JsonKey(name: 'InputByUserId')
  final String? inputByUserId;
  @JsonKey(name: 'RepairItemStatusId')
  final String? repairItemStatusId;
  @JsonKey(name: 'RepairItemStatus')
  final String? repairItemStatus;
  @JsonKey(name: 'Cost')
  final double? cost;
  @JsonKey(name: 'CurrencyId')
  final String? currencyId;
  @JsonKey(name: 'OfficeLocationDefaultCurrencyId')
  final String? officeLocationDefaultCurrencyId;
  @JsonKey(name: 'CurrencyCode')
  final String? currencyCode;
  @JsonKey(name: 'CurrencySymbol')
  final String? currencySymbol;
  @JsonKey(name: 'CurrencyColor')
  final String? currencyColor;
  @JsonKey(name: 'Notes')
  final String? notes;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'QcRequired')
  final bool? qcRequired;
  @JsonKey(name: 'AutoCompleteQC')
  final bool? autoCompleteQC;
  @JsonKey(name: 'QcNote')
  final String? qcNote;
  @JsonKey(name: 'ConditionId')
  final String? conditionId;
  @JsonKey(name: 'Condition')
  final String? condition;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory = _$WebApiModulesInventoryRepairRepairFromJson;
  static const toJsonFactory = _$WebApiModulesInventoryRepairRepairToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryRepairRepairToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryRepairRepair &&
            (identical(other.repairId, repairId) ||
                const DeepCollectionEquality()
                    .equals(other.repairId, repairId)) &&
            (identical(other.locationId, locationId) ||
                const DeepCollectionEquality()
                    .equals(other.locationId, locationId)) &&
            (identical(other.location, location) ||
                const DeepCollectionEquality()
                    .equals(other.location, location)) &&
            (identical(other.billingLocationId, billingLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.billingLocationId, billingLocationId)) &&
            (identical(other.billingLocation, billingLocation) ||
                const DeepCollectionEquality()
                    .equals(other.billingLocation, billingLocation)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.itemWarehouseId, itemWarehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.itemWarehouseId, itemWarehouseId)) &&
            (identical(other.warehouse, warehouse) ||
                const DeepCollectionEquality()
                    .equals(other.warehouse, warehouse)) &&
            (identical(other.warehouseCode, warehouseCode) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.billingWarehouseId, billingWarehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.billingWarehouseId, billingWarehouseId)) &&
            (identical(other.billingWarehouse, billingWarehouse) ||
                const DeepCollectionEquality()
                    .equals(other.billingWarehouse, billingWarehouse)) &&
            (identical(other.departmentId, departmentId) ||
                const DeepCollectionEquality()
                    .equals(other.departmentId, departmentId)) &&
            (identical(other.department, department) ||
                const DeepCollectionEquality()
                    .equals(other.department, department)) &&
            (identical(other.inventoryTypeId, inventoryTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryTypeId, inventoryTypeId)) &&
            (identical(other.inventoryType, inventoryType) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryType, inventoryType)) &&
            (identical(other.pendingRepair, pendingRepair) ||
                const DeepCollectionEquality()
                    .equals(other.pendingRepair, pendingRepair)) &&
            (identical(other.repairNumber, repairNumber) ||
                const DeepCollectionEquality()
                    .equals(other.repairNumber, repairNumber)) &&
            (identical(other.repairNumberColor, repairNumberColor) ||
                const DeepCollectionEquality()
                    .equals(other.repairNumberColor, repairNumberColor)) &&
            (identical(other.repairDate, repairDate) ||
                const DeepCollectionEquality()
                    .equals(other.repairDate, repairDate)) &&
            (identical(other.outsideRepair, outsideRepair) ||
                const DeepCollectionEquality()
                    .equals(other.outsideRepair, outsideRepair)) &&
            (identical(other.outsideRepairPoNumber, outsideRepairPoNumber) ||
                const DeepCollectionEquality().equals(
                    other.outsideRepairPoNumber, outsideRepairPoNumber)) &&
            (identical(other.itemId, itemId) ||
                const DeepCollectionEquality().equals(other.itemId, itemId)) &&
            (identical(other.barCode, barCode) || const DeepCollectionEquality().equals(other.barCode, barCode)) &&
            (identical(other.serialNumber, serialNumber) || const DeepCollectionEquality().equals(other.serialNumber, serialNumber)) &&
            (identical(other.rfId, rfId) || const DeepCollectionEquality().equals(other.rfId, rfId)) &&
            (identical(other.barCodeColor, barCodeColor) || const DeepCollectionEquality().equals(other.barCodeColor, barCodeColor)) &&
            (identical(other.inventoryId, inventoryId) || const DeepCollectionEquality().equals(other.inventoryId, inventoryId)) &&
            (identical(other.availFor, availFor) || const DeepCollectionEquality().equals(other.availFor, availFor)) &&
            (identical(other.availForDisplay, availForDisplay) || const DeepCollectionEquality().equals(other.availForDisplay, availForDisplay)) &&
            (identical(other.iCode, iCode) || const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.iCodeColor, iCodeColor) || const DeepCollectionEquality().equals(other.iCodeColor, iCodeColor)) &&
            (identical(other.itemDescription, itemDescription) || const DeepCollectionEquality().equals(other.itemDescription, itemDescription)) &&
            (identical(other.quantity, quantity) || const DeepCollectionEquality().equals(other.quantity, quantity)) &&
            (identical(other.quantityColor, quantityColor) || const DeepCollectionEquality().equals(other.quantityColor, quantityColor)) &&
            (identical(other.damageDealId, damageDealId) || const DeepCollectionEquality().equals(other.damageDealId, damageDealId)) &&
            (identical(other.damageDeal, damageDeal) || const DeepCollectionEquality().equals(other.damageDeal, damageDeal)) &&
            (identical(other.damageDealColor, damageDealColor) || const DeepCollectionEquality().equals(other.damageDealColor, damageDealColor)) &&
            (identical(other.damageOrderId, damageOrderId) || const DeepCollectionEquality().equals(other.damageOrderId, damageOrderId)) &&
            (identical(other.damageOrderNumber, damageOrderNumber) || const DeepCollectionEquality().equals(other.damageOrderNumber, damageOrderNumber)) &&
            (identical(other.damageOrderDescription, damageOrderDescription) || const DeepCollectionEquality().equals(other.damageOrderDescription, damageOrderDescription)) &&
            (identical(other.damageContractId, damageContractId) || const DeepCollectionEquality().equals(other.damageContractId, damageContractId)) &&
            (identical(other.damageContractNumber, damageContractNumber) || const DeepCollectionEquality().equals(other.damageContractNumber, damageContractNumber)) &&
            (identical(other.damageContractDate, damageContractDate) || const DeepCollectionEquality().equals(other.damageContractDate, damageContractDate)) &&
            (identical(other.damageScannedById, damageScannedById) || const DeepCollectionEquality().equals(other.damageScannedById, damageScannedById)) &&
            (identical(other.damageScannedBy, damageScannedBy) || const DeepCollectionEquality().equals(other.damageScannedBy, damageScannedBy)) &&
            (identical(other.lossAndDamageOrderId, lossAndDamageOrderId) || const DeepCollectionEquality().equals(other.lossAndDamageOrderId, lossAndDamageOrderId)) &&
            (identical(other.lossAndDamageOrderNumber, lossAndDamageOrderNumber) || const DeepCollectionEquality().equals(other.lossAndDamageOrderNumber, lossAndDamageOrderNumber)) &&
            (identical(other.lossAndDamageOrderDescription, lossAndDamageOrderDescription) || const DeepCollectionEquality().equals(other.lossAndDamageOrderDescription, lossAndDamageOrderDescription)) &&
            (identical(other.chargeOrderId, chargeOrderId) || const DeepCollectionEquality().equals(other.chargeOrderId, chargeOrderId)) &&
            (identical(other.chargeOrderNumber, chargeOrderNumber) || const DeepCollectionEquality().equals(other.chargeOrderNumber, chargeOrderNumber)) &&
            (identical(other.chargeOrderDescription, chargeOrderDescription) || const DeepCollectionEquality().equals(other.chargeOrderDescription, chargeOrderDescription)) &&
            (identical(other.chargeInvoiceId, chargeInvoiceId) || const DeepCollectionEquality().equals(other.chargeInvoiceId, chargeInvoiceId)) &&
            (identical(other.chargeInvoiceNumber, chargeInvoiceNumber) || const DeepCollectionEquality().equals(other.chargeInvoiceNumber, chargeInvoiceNumber)) &&
            (identical(other.chargeInvoiceDescription, chargeInvoiceDescription) || const DeepCollectionEquality().equals(other.chargeInvoiceDescription, chargeInvoiceDescription)) &&
            (identical(other.taxOptionId, taxOptionId) || const DeepCollectionEquality().equals(other.taxOptionId, taxOptionId)) &&
            (identical(other.taxOption, taxOption) || const DeepCollectionEquality().equals(other.taxOption, taxOption)) &&
            (identical(other.taxId, taxId) || const DeepCollectionEquality().equals(other.taxId, taxId)) &&
            (identical(other.rentalTaxRate1, rentalTaxRate1) || const DeepCollectionEquality().equals(other.rentalTaxRate1, rentalTaxRate1)) &&
            (identical(other.salesTaxRate1, salesTaxRate1) || const DeepCollectionEquality().equals(other.salesTaxRate1, salesTaxRate1)) &&
            (identical(other.laborTaxRate1, laborTaxRate1) || const DeepCollectionEquality().equals(other.laborTaxRate1, laborTaxRate1)) &&
            (identical(other.rentalTaxRate2, rentalTaxRate2) || const DeepCollectionEquality().equals(other.rentalTaxRate2, rentalTaxRate2)) &&
            (identical(other.salesTaxRate2, salesTaxRate2) || const DeepCollectionEquality().equals(other.salesTaxRate2, salesTaxRate2)) &&
            (identical(other.laborTaxRate2, laborTaxRate2) || const DeepCollectionEquality().equals(other.laborTaxRate2, laborTaxRate2)) &&
            (identical(other.status, status) || const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.statusColor, statusColor) || const DeepCollectionEquality().equals(other.statusColor, statusColor)) &&
            (identical(other.statusDate, statusDate) || const DeepCollectionEquality().equals(other.statusDate, statusDate)) &&
            (identical(other.billable, billable) || const DeepCollectionEquality().equals(other.billable, billable)) &&
            (identical(other.billableDisplay, billableDisplay) || const DeepCollectionEquality().equals(other.billableDisplay, billableDisplay)) &&
            (identical(other.notBilled, notBilled) || const DeepCollectionEquality().equals(other.notBilled, notBilled)) &&
            (identical(other.priority, priority) || const DeepCollectionEquality().equals(other.priority, priority)) &&
            (identical(other.priorityDescription, priorityDescription) || const DeepCollectionEquality().equals(other.priorityDescription, priorityDescription)) &&
            (identical(other.priorityColor, priorityColor) || const DeepCollectionEquality().equals(other.priorityColor, priorityColor)) &&
            (identical(other.repairType, repairType) || const DeepCollectionEquality().equals(other.repairType, repairType)) &&
            (identical(other.poPending, poPending) || const DeepCollectionEquality().equals(other.poPending, poPending)) &&
            (identical(other.poNumber, poNumber) || const DeepCollectionEquality().equals(other.poNumber, poNumber)) &&
            (identical(other.damage, damage) || const DeepCollectionEquality().equals(other.damage, damage)) &&
            (identical(other.correction, correction) || const DeepCollectionEquality().equals(other.correction, correction)) &&
            (identical(other.released, released) || const DeepCollectionEquality().equals(other.released, released)) &&
            (identical(other.releasedQuantity, releasedQuantity) || const DeepCollectionEquality().equals(other.releasedQuantity, releasedQuantity)) &&
            (identical(other.transferId, transferId) || const DeepCollectionEquality().equals(other.transferId, transferId)) &&
            (identical(other.transferredFromWarehouseId, transferredFromWarehouseId) || const DeepCollectionEquality().equals(other.transferredFromWarehouseId, transferredFromWarehouseId)) &&
            (identical(other.dueDate, dueDate) || const DeepCollectionEquality().equals(other.dueDate, dueDate)) &&
            (identical(other.estimateByUserId, estimateByUserId) || const DeepCollectionEquality().equals(other.estimateByUserId, estimateByUserId)) &&
            (identical(other.estimateBy, estimateBy) || const DeepCollectionEquality().equals(other.estimateBy, estimateBy)) &&
            (identical(other.estimateDate, estimateDate) || const DeepCollectionEquality().equals(other.estimateDate, estimateDate)) &&
            (identical(other.completeByUserId, completeByUserId) || const DeepCollectionEquality().equals(other.completeByUserId, completeByUserId)) &&
            (identical(other.completeBy, completeBy) || const DeepCollectionEquality().equals(other.completeBy, completeBy)) &&
            (identical(other.completeDate, completeDate) || const DeepCollectionEquality().equals(other.completeDate, completeDate)) &&
            (identical(other.inputDate, inputDate) || const DeepCollectionEquality().equals(other.inputDate, inputDate)) &&
            (identical(other.inputByUserId, inputByUserId) || const DeepCollectionEquality().equals(other.inputByUserId, inputByUserId)) &&
            (identical(other.repairItemStatusId, repairItemStatusId) || const DeepCollectionEquality().equals(other.repairItemStatusId, repairItemStatusId)) &&
            (identical(other.repairItemStatus, repairItemStatus) || const DeepCollectionEquality().equals(other.repairItemStatus, repairItemStatus)) &&
            (identical(other.cost, cost) || const DeepCollectionEquality().equals(other.cost, cost)) &&
            (identical(other.currencyId, currencyId) || const DeepCollectionEquality().equals(other.currencyId, currencyId)) &&
            (identical(other.officeLocationDefaultCurrencyId, officeLocationDefaultCurrencyId) || const DeepCollectionEquality().equals(other.officeLocationDefaultCurrencyId, officeLocationDefaultCurrencyId)) &&
            (identical(other.currencyCode, currencyCode) || const DeepCollectionEquality().equals(other.currencyCode, currencyCode)) &&
            (identical(other.currencySymbol, currencySymbol) || const DeepCollectionEquality().equals(other.currencySymbol, currencySymbol)) &&
            (identical(other.currencyColor, currencyColor) || const DeepCollectionEquality().equals(other.currencyColor, currencyColor)) &&
            (identical(other.notes, notes) || const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.inactive, inactive) || const DeepCollectionEquality().equals(other.inactive, inactive)) &&
            (identical(other.qcRequired, qcRequired) || const DeepCollectionEquality().equals(other.qcRequired, qcRequired)) &&
            (identical(other.autoCompleteQC, autoCompleteQC) || const DeepCollectionEquality().equals(other.autoCompleteQC, autoCompleteQC)) &&
            (identical(other.qcNote, qcNote) || const DeepCollectionEquality().equals(other.qcNote, qcNote)) &&
            (identical(other.conditionId, conditionId) || const DeepCollectionEquality().equals(other.conditionId, conditionId)) &&
            (identical(other.condition, condition) || const DeepCollectionEquality().equals(other.condition, condition)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesInventoryRepairRepairExtension
    on WebApiModulesInventoryRepairRepair {
  WebApiModulesInventoryRepairRepair copyWith(
      {String? repairId,
      String? locationId,
      String? location,
      String? billingLocationId,
      String? billingLocation,
      String? warehouseId,
      String? itemWarehouseId,
      String? warehouse,
      String? warehouseCode,
      String? billingWarehouseId,
      String? billingWarehouse,
      String? departmentId,
      String? department,
      String? inventoryTypeId,
      String? inventoryType,
      bool? pendingRepair,
      String? repairNumber,
      String? repairNumberColor,
      String? repairDate,
      bool? outsideRepair,
      String? outsideRepairPoNumber,
      String? itemId,
      String? barCode,
      String? serialNumber,
      String? rfId,
      String? barCodeColor,
      String? inventoryId,
      String? availFor,
      String? availForDisplay,
      String? iCode,
      String? iCodeColor,
      String? itemDescription,
      int? quantity,
      String? quantityColor,
      String? damageDealId,
      String? damageDeal,
      String? damageDealColor,
      String? damageOrderId,
      String? damageOrderNumber,
      String? damageOrderDescription,
      String? damageContractId,
      String? damageContractNumber,
      String? damageContractDate,
      String? damageScannedById,
      String? damageScannedBy,
      String? lossAndDamageOrderId,
      String? lossAndDamageOrderNumber,
      String? lossAndDamageOrderDescription,
      String? chargeOrderId,
      String? chargeOrderNumber,
      String? chargeOrderDescription,
      String? chargeInvoiceId,
      String? chargeInvoiceNumber,
      String? chargeInvoiceDescription,
      String? taxOptionId,
      String? taxOption,
      String? taxId,
      double? rentalTaxRate1,
      double? salesTaxRate1,
      double? laborTaxRate1,
      double? rentalTaxRate2,
      double? salesTaxRate2,
      double? laborTaxRate2,
      String? status,
      String? statusColor,
      String? statusDate,
      bool? billable,
      String? billableDisplay,
      bool? notBilled,
      String? priority,
      String? priorityDescription,
      String? priorityColor,
      String? repairType,
      bool? poPending,
      String? poNumber,
      String? damage,
      String? correction,
      bool? released,
      double? releasedQuantity,
      String? transferId,
      String? transferredFromWarehouseId,
      String? dueDate,
      String? estimateByUserId,
      String? estimateBy,
      String? estimateDate,
      String? completeByUserId,
      String? completeBy,
      String? completeDate,
      String? inputDate,
      String? inputByUserId,
      String? repairItemStatusId,
      String? repairItemStatus,
      double? cost,
      String? currencyId,
      String? officeLocationDefaultCurrencyId,
      String? currencyCode,
      String? currencySymbol,
      String? currencyColor,
      String? notes,
      bool? inactive,
      bool? qcRequired,
      bool? autoCompleteQC,
      String? qcNote,
      String? conditionId,
      String? condition,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesInventoryRepairRepair(
        repairId: repairId ?? this.repairId,
        locationId: locationId ?? this.locationId,
        location: location ?? this.location,
        billingLocationId: billingLocationId ?? this.billingLocationId,
        billingLocation: billingLocation ?? this.billingLocation,
        warehouseId: warehouseId ?? this.warehouseId,
        itemWarehouseId: itemWarehouseId ?? this.itemWarehouseId,
        warehouse: warehouse ?? this.warehouse,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        billingWarehouseId: billingWarehouseId ?? this.billingWarehouseId,
        billingWarehouse: billingWarehouse ?? this.billingWarehouse,
        departmentId: departmentId ?? this.departmentId,
        department: department ?? this.department,
        inventoryTypeId: inventoryTypeId ?? this.inventoryTypeId,
        inventoryType: inventoryType ?? this.inventoryType,
        pendingRepair: pendingRepair ?? this.pendingRepair,
        repairNumber: repairNumber ?? this.repairNumber,
        repairNumberColor: repairNumberColor ?? this.repairNumberColor,
        repairDate: repairDate ?? this.repairDate,
        outsideRepair: outsideRepair ?? this.outsideRepair,
        outsideRepairPoNumber:
            outsideRepairPoNumber ?? this.outsideRepairPoNumber,
        itemId: itemId ?? this.itemId,
        barCode: barCode ?? this.barCode,
        serialNumber: serialNumber ?? this.serialNumber,
        rfId: rfId ?? this.rfId,
        barCodeColor: barCodeColor ?? this.barCodeColor,
        inventoryId: inventoryId ?? this.inventoryId,
        availFor: availFor ?? this.availFor,
        availForDisplay: availForDisplay ?? this.availForDisplay,
        iCode: iCode ?? this.iCode,
        iCodeColor: iCodeColor ?? this.iCodeColor,
        itemDescription: itemDescription ?? this.itemDescription,
        quantity: quantity ?? this.quantity,
        quantityColor: quantityColor ?? this.quantityColor,
        damageDealId: damageDealId ?? this.damageDealId,
        damageDeal: damageDeal ?? this.damageDeal,
        damageDealColor: damageDealColor ?? this.damageDealColor,
        damageOrderId: damageOrderId ?? this.damageOrderId,
        damageOrderNumber: damageOrderNumber ?? this.damageOrderNumber,
        damageOrderDescription:
            damageOrderDescription ?? this.damageOrderDescription,
        damageContractId: damageContractId ?? this.damageContractId,
        damageContractNumber: damageContractNumber ?? this.damageContractNumber,
        damageContractDate: damageContractDate ?? this.damageContractDate,
        damageScannedById: damageScannedById ?? this.damageScannedById,
        damageScannedBy: damageScannedBy ?? this.damageScannedBy,
        lossAndDamageOrderId: lossAndDamageOrderId ?? this.lossAndDamageOrderId,
        lossAndDamageOrderNumber:
            lossAndDamageOrderNumber ?? this.lossAndDamageOrderNumber,
        lossAndDamageOrderDescription:
            lossAndDamageOrderDescription ?? this.lossAndDamageOrderDescription,
        chargeOrderId: chargeOrderId ?? this.chargeOrderId,
        chargeOrderNumber: chargeOrderNumber ?? this.chargeOrderNumber,
        chargeOrderDescription:
            chargeOrderDescription ?? this.chargeOrderDescription,
        chargeInvoiceId: chargeInvoiceId ?? this.chargeInvoiceId,
        chargeInvoiceNumber: chargeInvoiceNumber ?? this.chargeInvoiceNumber,
        chargeInvoiceDescription:
            chargeInvoiceDescription ?? this.chargeInvoiceDescription,
        taxOptionId: taxOptionId ?? this.taxOptionId,
        taxOption: taxOption ?? this.taxOption,
        taxId: taxId ?? this.taxId,
        rentalTaxRate1: rentalTaxRate1 ?? this.rentalTaxRate1,
        salesTaxRate1: salesTaxRate1 ?? this.salesTaxRate1,
        laborTaxRate1: laborTaxRate1 ?? this.laborTaxRate1,
        rentalTaxRate2: rentalTaxRate2 ?? this.rentalTaxRate2,
        salesTaxRate2: salesTaxRate2 ?? this.salesTaxRate2,
        laborTaxRate2: laborTaxRate2 ?? this.laborTaxRate2,
        status: status ?? this.status,
        statusColor: statusColor ?? this.statusColor,
        statusDate: statusDate ?? this.statusDate,
        billable: billable ?? this.billable,
        billableDisplay: billableDisplay ?? this.billableDisplay,
        notBilled: notBilled ?? this.notBilled,
        priority: priority ?? this.priority,
        priorityDescription: priorityDescription ?? this.priorityDescription,
        priorityColor: priorityColor ?? this.priorityColor,
        repairType: repairType ?? this.repairType,
        poPending: poPending ?? this.poPending,
        poNumber: poNumber ?? this.poNumber,
        damage: damage ?? this.damage,
        correction: correction ?? this.correction,
        released: released ?? this.released,
        releasedQuantity: releasedQuantity ?? this.releasedQuantity,
        transferId: transferId ?? this.transferId,
        transferredFromWarehouseId:
            transferredFromWarehouseId ?? this.transferredFromWarehouseId,
        dueDate: dueDate ?? this.dueDate,
        estimateByUserId: estimateByUserId ?? this.estimateByUserId,
        estimateBy: estimateBy ?? this.estimateBy,
        estimateDate: estimateDate ?? this.estimateDate,
        completeByUserId: completeByUserId ?? this.completeByUserId,
        completeBy: completeBy ?? this.completeBy,
        completeDate: completeDate ?? this.completeDate,
        inputDate: inputDate ?? this.inputDate,
        inputByUserId: inputByUserId ?? this.inputByUserId,
        repairItemStatusId: repairItemStatusId ?? this.repairItemStatusId,
        repairItemStatus: repairItemStatus ?? this.repairItemStatus,
        cost: cost ?? this.cost,
        currencyId: currencyId ?? this.currencyId,
        officeLocationDefaultCurrencyId: officeLocationDefaultCurrencyId ??
            this.officeLocationDefaultCurrencyId,
        currencyCode: currencyCode ?? this.currencyCode,
        currencySymbol: currencySymbol ?? this.currencySymbol,
        currencyColor: currencyColor ?? this.currencyColor,
        notes: notes ?? this.notes,
        inactive: inactive ?? this.inactive,
        qcRequired: qcRequired ?? this.qcRequired,
        autoCompleteQC: autoCompleteQC ?? this.autoCompleteQC,
        qcNote: qcNote ?? this.qcNote,
        conditionId: conditionId ?? this.conditionId,
        condition: condition ?? this.condition,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryRepairRepairDocument {
  WebApiModulesInventoryRepairRepairDocument({
    this.repairId,
    this.copying,
    this.documentId,
    this.documentTypeId,
    this.uniqueId1,
    this.uniqueId2,
    this.uniqueId1Int,
    this.description,
    this.inputByUsersId,
    this.attachDate,
    this.attachTime,
    this.attachToEmail,
    this.inactive,
    this.dateStamp,
    this.extension,
    this.documentType,
    this.inputBy,
    this.hasImage,
    this.hasFile,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesInventoryRepairRepairDocument.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryRepairRepairDocumentFromJson(json);

  @JsonKey(name: 'RepairId')
  final String? repairId;
  @JsonKey(name: 'copying')
  final bool? copying;
  @JsonKey(name: 'DocumentId')
  final String? documentId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'UniqueId1')
  final String? uniqueId1;
  @JsonKey(name: 'UniqueId2')
  final String? uniqueId2;
  @JsonKey(name: 'UniqueId1Int')
  final int? uniqueId1Int;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'InputByUsersId')
  final String? inputByUsersId;
  @JsonKey(name: 'AttachDate')
  final String? attachDate;
  @JsonKey(name: 'AttachTime')
  final String? attachTime;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'Extension')
  final String? extension;
  @JsonKey(name: 'DocumentType')
  final String? documentType;
  @JsonKey(name: 'InputBy')
  final String? inputBy;
  @JsonKey(name: 'HasImage')
  final bool? hasImage;
  @JsonKey(name: 'HasFile')
  final bool? hasFile;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesInventoryRepairRepairDocumentFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryRepairRepairDocumentToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryRepairRepairDocumentToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryRepairRepairDocument &&
            (identical(other.repairId, repairId) ||
                const DeepCollectionEquality()
                    .equals(other.repairId, repairId)) &&
            (identical(other.copying, copying) ||
                const DeepCollectionEquality()
                    .equals(other.copying, copying)) &&
            (identical(other.documentId, documentId) ||
                const DeepCollectionEquality()
                    .equals(other.documentId, documentId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.uniqueId1, uniqueId1) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1, uniqueId1)) &&
            (identical(other.uniqueId2, uniqueId2) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId2, uniqueId2)) &&
            (identical(other.uniqueId1Int, uniqueId1Int) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1Int, uniqueId1Int)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.inputByUsersId, inputByUsersId) ||
                const DeepCollectionEquality()
                    .equals(other.inputByUsersId, inputByUsersId)) &&
            (identical(other.attachDate, attachDate) ||
                const DeepCollectionEquality()
                    .equals(other.attachDate, attachDate)) &&
            (identical(other.attachTime, attachTime) ||
                const DeepCollectionEquality()
                    .equals(other.attachTime, attachTime)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.extension, extension) ||
                const DeepCollectionEquality()
                    .equals(other.extension, extension)) &&
            (identical(other.documentType, documentType) ||
                const DeepCollectionEquality()
                    .equals(other.documentType, documentType)) &&
            (identical(other.inputBy, inputBy) ||
                const DeepCollectionEquality()
                    .equals(other.inputBy, inputBy)) &&
            (identical(other.hasImage, hasImage) ||
                const DeepCollectionEquality()
                    .equals(other.hasImage, hasImage)) &&
            (identical(other.hasFile, hasFile) ||
                const DeepCollectionEquality()
                    .equals(other.hasFile, hasFile)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality().equals(other.filePath, filePath)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesInventoryRepairRepairDocumentExtension
    on WebApiModulesInventoryRepairRepairDocument {
  WebApiModulesInventoryRepairRepairDocument copyWith(
      {String? repairId,
      bool? copying,
      String? documentId,
      String? documentTypeId,
      String? uniqueId1,
      String? uniqueId2,
      int? uniqueId1Int,
      String? description,
      String? inputByUsersId,
      String? attachDate,
      String? attachTime,
      bool? attachToEmail,
      bool? inactive,
      String? dateStamp,
      String? extension,
      String? documentType,
      String? inputBy,
      bool? hasImage,
      bool? hasFile,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesInventoryRepairRepairDocument(
        repairId: repairId ?? this.repairId,
        copying: copying ?? this.copying,
        documentId: documentId ?? this.documentId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        uniqueId1: uniqueId1 ?? this.uniqueId1,
        uniqueId2: uniqueId2 ?? this.uniqueId2,
        uniqueId1Int: uniqueId1Int ?? this.uniqueId1Int,
        description: description ?? this.description,
        inputByUsersId: inputByUsersId ?? this.inputByUsersId,
        attachDate: attachDate ?? this.attachDate,
        attachTime: attachTime ?? this.attachTime,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        dateStamp: dateStamp ?? this.dateStamp,
        extension: extension ?? this.extension,
        documentType: documentType ?? this.documentType,
        inputBy: inputBy ?? this.inputBy,
        hasImage: hasImage ?? this.hasImage,
        hasFile: hasFile ?? this.hasFile,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryRepairRepairDocumentPostRequest {
  WebApiModulesInventoryRepairRepairDocumentPostRequest({
    this.repairId,
    this.documentTypeId,
    this.description,
    this.attachToEmail,
    this.inactive,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
  });

  factory WebApiModulesInventoryRepairRepairDocumentPostRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryRepairRepairDocumentPostRequestFromJson(json);

  @JsonKey(name: 'RepairId')
  final String? repairId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  static const fromJsonFactory =
      _$WebApiModulesInventoryRepairRepairDocumentPostRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryRepairRepairDocumentPostRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryRepairRepairDocumentPostRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryRepairRepairDocumentPostRequest &&
            (identical(other.repairId, repairId) ||
                const DeepCollectionEquality()
                    .equals(other.repairId, repairId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)));
  }
}

extension $WebApiModulesInventoryRepairRepairDocumentPostRequestExtension
    on WebApiModulesInventoryRepairRepairDocumentPostRequest {
  WebApiModulesInventoryRepairRepairDocumentPostRequest copyWith(
      {String? repairId,
      String? documentTypeId,
      String? description,
      bool? attachToEmail,
      bool? inactive,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath}) {
    return WebApiModulesInventoryRepairRepairDocumentPostRequest(
        repairId: repairId ?? this.repairId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        description: description ?? this.description,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryRepairRepairDocumentPutRequest {
  WebApiModulesInventoryRepairRepairDocumentPutRequest({
    this.repairId,
    this.documentId,
    this.documentTypeId,
    this.description,
    this.attachToEmail,
    this.inactive,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
  });

  factory WebApiModulesInventoryRepairRepairDocumentPutRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryRepairRepairDocumentPutRequestFromJson(json);

  @JsonKey(name: 'RepairId')
  final String? repairId;
  @JsonKey(name: 'DocumentId')
  final String? documentId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  static const fromJsonFactory =
      _$WebApiModulesInventoryRepairRepairDocumentPutRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryRepairRepairDocumentPutRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryRepairRepairDocumentPutRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryRepairRepairDocumentPutRequest &&
            (identical(other.repairId, repairId) ||
                const DeepCollectionEquality()
                    .equals(other.repairId, repairId)) &&
            (identical(other.documentId, documentId) ||
                const DeepCollectionEquality()
                    .equals(other.documentId, documentId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)));
  }
}

extension $WebApiModulesInventoryRepairRepairDocumentPutRequestExtension
    on WebApiModulesInventoryRepairRepairDocumentPutRequest {
  WebApiModulesInventoryRepairRepairDocumentPutRequest copyWith(
      {String? repairId,
      String? documentId,
      String? documentTypeId,
      String? description,
      bool? attachToEmail,
      bool? inactive,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath}) {
    return WebApiModulesInventoryRepairRepairDocumentPutRequest(
        repairId: repairId ?? this.repairId,
        documentId: documentId ?? this.documentId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        description: description ?? this.description,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryRepairRepairReleaseItemsResponse {
  WebApiModulesInventoryRepairRepairReleaseItemsResponse({
    this.repair,
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesInventoryRepairRepairReleaseItemsResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryRepairRepairReleaseItemsResponseFromJson(json);

  @JsonKey(name: 'repair')
  final WebApiModulesInventoryRepairRepair? repair;
  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesInventoryRepairRepairReleaseItemsResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryRepairRepairReleaseItemsResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryRepairRepairReleaseItemsResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryRepairRepairReleaseItemsResponse &&
            (identical(other.repair, repair) ||
                const DeepCollectionEquality().equals(other.repair, repair)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesInventoryRepairRepairReleaseItemsResponseExtension
    on WebApiModulesInventoryRepairRepairReleaseItemsResponse {
  WebApiModulesInventoryRepairRepairReleaseItemsResponse copyWith(
      {WebApiModulesInventoryRepairRepair? repair,
      int? status,
      bool? success,
      String? msg}) {
    return WebApiModulesInventoryRepairRepairReleaseItemsResponse(
        repair: repair ?? this.repair,
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryRepairToggleRepairCompleteResponse {
  WebApiModulesInventoryRepairToggleRepairCompleteResponse({
    this.repair,
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesInventoryRepairToggleRepairCompleteResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryRepairToggleRepairCompleteResponseFromJson(json);

  @JsonKey(name: 'repair')
  final WebApiModulesInventoryRepairRepair? repair;
  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesInventoryRepairToggleRepairCompleteResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryRepairToggleRepairCompleteResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryRepairToggleRepairCompleteResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryRepairToggleRepairCompleteResponse &&
            (identical(other.repair, repair) ||
                const DeepCollectionEquality().equals(other.repair, repair)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesInventoryRepairToggleRepairCompleteResponseExtension
    on WebApiModulesInventoryRepairToggleRepairCompleteResponse {
  WebApiModulesInventoryRepairToggleRepairCompleteResponse copyWith(
      {WebApiModulesInventoryRepairRepair? repair,
      int? status,
      bool? success,
      String? msg}) {
    return WebApiModulesInventoryRepairToggleRepairCompleteResponse(
        repair: repair ?? this.repair,
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryRepairToggleRepairEstimateResponse {
  WebApiModulesInventoryRepairToggleRepairEstimateResponse({
    this.repair,
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesInventoryRepairToggleRepairEstimateResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryRepairToggleRepairEstimateResponseFromJson(json);

  @JsonKey(name: 'repair')
  final WebApiModulesInventoryRepairRepair? repair;
  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesInventoryRepairToggleRepairEstimateResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryRepairToggleRepairEstimateResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryRepairToggleRepairEstimateResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryRepairToggleRepairEstimateResponse &&
            (identical(other.repair, repair) ||
                const DeepCollectionEquality().equals(other.repair, repair)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesInventoryRepairToggleRepairEstimateResponseExtension
    on WebApiModulesInventoryRepairToggleRepairEstimateResponse {
  WebApiModulesInventoryRepairToggleRepairEstimateResponse copyWith(
      {WebApiModulesInventoryRepairRepair? repair,
      int? status,
      bool? success,
      String? msg}) {
    return WebApiModulesInventoryRepairToggleRepairEstimateResponse(
        repair: repair ?? this.repair,
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryRepairVoidRepairResponse {
  WebApiModulesInventoryRepairVoidRepairResponse({
    this.repair,
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesInventoryRepairVoidRepairResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryRepairVoidRepairResponseFromJson(json);

  @JsonKey(name: 'repair')
  final WebApiModulesInventoryRepairRepair? repair;
  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesInventoryRepairVoidRepairResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventoryRepairVoidRepairResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryRepairVoidRepairResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryRepairVoidRepairResponse &&
            (identical(other.repair, repair) ||
                const DeepCollectionEquality().equals(other.repair, repair)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesInventoryRepairVoidRepairResponseExtension
    on WebApiModulesInventoryRepairVoidRepairResponse {
  WebApiModulesInventoryRepairVoidRepairResponse copyWith(
      {WebApiModulesInventoryRepairRepair? repair,
      int? status,
      bool? success,
      String? msg}) {
    return WebApiModulesInventoryRepairVoidRepairResponse(
        repair: repair ?? this.repair,
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventoryRetiredRetired {
  WebApiModulesInventoryRetiredRetired({
    this.retiredId,
    this.inventoryId,
    this.iCode,
    this.description,
    this.barCode,
    this.itemId,
    this.serialNumber,
    this.warehouseId,
    this.warehouseCode,
    this.warehouse,
    this.consignorId,
    this.consignor,
    this.consignorAgreementId,
    this.agreementNumber,
    this.retiredDate,
    this.retiredReason,
    this.retiredReasonType,
    this.retiredBy,
    this.retiredReasonId,
    this.retiredByUserId,
    this.retiredNotes,
    this.retiredQuantity,
    this.unretiredQuantity,
    this.lostOrderId,
    this.lostOrderNumber,
    this.lostName,
    this.lostAddress1,
    this.lostAddress2,
    this.lostCity,
    this.lostState,
    this.lostZipCode,
    this.lostPhone,
    this.lostCountryId,
    this.lostCountry,
    this.soldToOrderId,
    this.soldToOrderItemId,
    this.soldToOrderNumber,
    this.soldDate,
    this.soldAmount,
    this.soldToName,
    this.soldToAddress1,
    this.soldToAddress2,
    this.soldToCity,
    this.soldToState,
    this.soldToZipCode,
    this.soldToPhone,
    this.soldToCountryId,
    this.soldToCountry,
    this.soldCurrencyId,
    this.soldCurrency,
    this.soldCurrencyCode,
    this.soldCurrencySymbol,
    this.inventoryTypeId,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesInventoryRetiredRetired.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventoryRetiredRetiredFromJson(json);

  @JsonKey(name: 'RetiredId')
  final String? retiredId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'BarCode')
  final String? barCode;
  @JsonKey(name: 'ItemId')
  final String? itemId;
  @JsonKey(name: 'SerialNumber')
  final String? serialNumber;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'ConsignorId')
  final String? consignorId;
  @JsonKey(name: 'Consignor')
  final String? consignor;
  @JsonKey(name: 'ConsignorAgreementId')
  final String? consignorAgreementId;
  @JsonKey(name: 'AgreementNumber')
  final String? agreementNumber;
  @JsonKey(name: 'RetiredDate')
  final String? retiredDate;
  @JsonKey(name: 'RetiredReason')
  final String? retiredReason;
  @JsonKey(name: 'RetiredReasonType')
  final String? retiredReasonType;
  @JsonKey(name: 'RetiredBy')
  final String? retiredBy;
  @JsonKey(name: 'RetiredReasonId')
  final String? retiredReasonId;
  @JsonKey(name: 'RetiredByUserId')
  final String? retiredByUserId;
  @JsonKey(name: 'RetiredNotes')
  final String? retiredNotes;
  @JsonKey(name: 'RetiredQuantity')
  final double? retiredQuantity;
  @JsonKey(name: 'UnretiredQuantity')
  final double? unretiredQuantity;
  @JsonKey(name: 'LostOrderId')
  final String? lostOrderId;
  @JsonKey(name: 'LostOrderNumber')
  final String? lostOrderNumber;
  @JsonKey(name: 'LostName')
  final String? lostName;
  @JsonKey(name: 'LostAddress1')
  final String? lostAddress1;
  @JsonKey(name: 'LostAddress2')
  final String? lostAddress2;
  @JsonKey(name: 'LostCity')
  final String? lostCity;
  @JsonKey(name: 'LostState')
  final String? lostState;
  @JsonKey(name: 'LostZipCode')
  final String? lostZipCode;
  @JsonKey(name: 'LostPhone')
  final String? lostPhone;
  @JsonKey(name: 'LostCountryId')
  final String? lostCountryId;
  @JsonKey(name: 'LostCountry')
  final String? lostCountry;
  @JsonKey(name: 'SoldToOrderId')
  final String? soldToOrderId;
  @JsonKey(name: 'SoldToOrderItemId')
  final String? soldToOrderItemId;
  @JsonKey(name: 'SoldToOrderNumber')
  final String? soldToOrderNumber;
  @JsonKey(name: 'SoldDate')
  final String? soldDate;
  @JsonKey(name: 'SoldAmount')
  final String? soldAmount;
  @JsonKey(name: 'SoldToName')
  final String? soldToName;
  @JsonKey(name: 'SoldToAddress1')
  final String? soldToAddress1;
  @JsonKey(name: 'SoldToAddress2')
  final String? soldToAddress2;
  @JsonKey(name: 'SoldToCity')
  final String? soldToCity;
  @JsonKey(name: 'SoldToState')
  final String? soldToState;
  @JsonKey(name: 'SoldToZipCode')
  final String? soldToZipCode;
  @JsonKey(name: 'SoldToPhone')
  final String? soldToPhone;
  @JsonKey(name: 'SoldToCountryId')
  final String? soldToCountryId;
  @JsonKey(name: 'SoldToCountry')
  final String? soldToCountry;
  @JsonKey(name: 'SoldCurrencyId')
  final String? soldCurrencyId;
  @JsonKey(name: 'SoldCurrency')
  final String? soldCurrency;
  @JsonKey(name: 'SoldCurrencyCode')
  final String? soldCurrencyCode;
  @JsonKey(name: 'SoldCurrencySymbol')
  final String? soldCurrencySymbol;
  @JsonKey(name: 'InventoryTypeId')
  final String? inventoryTypeId;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory = _$WebApiModulesInventoryRetiredRetiredFromJson;
  static const toJsonFactory = _$WebApiModulesInventoryRetiredRetiredToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventoryRetiredRetiredToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventoryRetiredRetired &&
            (identical(other.retiredId, retiredId) ||
                const DeepCollectionEquality()
                    .equals(other.retiredId, retiredId)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.barCode, barCode) ||
                const DeepCollectionEquality()
                    .equals(other.barCode, barCode)) &&
            (identical(other.itemId, itemId) ||
                const DeepCollectionEquality().equals(other.itemId, itemId)) &&
            (identical(other.serialNumber, serialNumber) ||
                const DeepCollectionEquality()
                    .equals(other.serialNumber, serialNumber)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouseCode, warehouseCode) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.warehouse, warehouse) ||
                const DeepCollectionEquality()
                    .equals(other.warehouse, warehouse)) &&
            (identical(other.consignorId, consignorId) ||
                const DeepCollectionEquality()
                    .equals(other.consignorId, consignorId)) &&
            (identical(other.consignor, consignor) ||
                const DeepCollectionEquality()
                    .equals(other.consignor, consignor)) &&
            (identical(other.consignorAgreementId, consignorAgreementId) ||
                const DeepCollectionEquality().equals(
                    other.consignorAgreementId, consignorAgreementId)) &&
            (identical(other.agreementNumber, agreementNumber) ||
                const DeepCollectionEquality()
                    .equals(other.agreementNumber, agreementNumber)) &&
            (identical(other.retiredDate, retiredDate) ||
                const DeepCollectionEquality()
                    .equals(other.retiredDate, retiredDate)) &&
            (identical(other.retiredReason, retiredReason) ||
                const DeepCollectionEquality()
                    .equals(other.retiredReason, retiredReason)) &&
            (identical(other.retiredReasonType, retiredReasonType) ||
                const DeepCollectionEquality()
                    .equals(other.retiredReasonType, retiredReasonType)) &&
            (identical(other.retiredBy, retiredBy) ||
                const DeepCollectionEquality()
                    .equals(other.retiredBy, retiredBy)) &&
            (identical(other.retiredReasonId, retiredReasonId) ||
                const DeepCollectionEquality()
                    .equals(other.retiredReasonId, retiredReasonId)) &&
            (identical(other.retiredByUserId, retiredByUserId) ||
                const DeepCollectionEquality()
                    .equals(other.retiredByUserId, retiredByUserId)) &&
            (identical(other.retiredNotes, retiredNotes) ||
                const DeepCollectionEquality()
                    .equals(other.retiredNotes, retiredNotes)) &&
            (identical(other.retiredQuantity, retiredQuantity) ||
                const DeepCollectionEquality()
                    .equals(other.retiredQuantity, retiredQuantity)) &&
            (identical(other.unretiredQuantity, unretiredQuantity) ||
                const DeepCollectionEquality().equals(other.unretiredQuantity, unretiredQuantity)) &&
            (identical(other.lostOrderId, lostOrderId) || const DeepCollectionEquality().equals(other.lostOrderId, lostOrderId)) &&
            (identical(other.lostOrderNumber, lostOrderNumber) || const DeepCollectionEquality().equals(other.lostOrderNumber, lostOrderNumber)) &&
            (identical(other.lostName, lostName) || const DeepCollectionEquality().equals(other.lostName, lostName)) &&
            (identical(other.lostAddress1, lostAddress1) || const DeepCollectionEquality().equals(other.lostAddress1, lostAddress1)) &&
            (identical(other.lostAddress2, lostAddress2) || const DeepCollectionEquality().equals(other.lostAddress2, lostAddress2)) &&
            (identical(other.lostCity, lostCity) || const DeepCollectionEquality().equals(other.lostCity, lostCity)) &&
            (identical(other.lostState, lostState) || const DeepCollectionEquality().equals(other.lostState, lostState)) &&
            (identical(other.lostZipCode, lostZipCode) || const DeepCollectionEquality().equals(other.lostZipCode, lostZipCode)) &&
            (identical(other.lostPhone, lostPhone) || const DeepCollectionEquality().equals(other.lostPhone, lostPhone)) &&
            (identical(other.lostCountryId, lostCountryId) || const DeepCollectionEquality().equals(other.lostCountryId, lostCountryId)) &&
            (identical(other.lostCountry, lostCountry) || const DeepCollectionEquality().equals(other.lostCountry, lostCountry)) &&
            (identical(other.soldToOrderId, soldToOrderId) || const DeepCollectionEquality().equals(other.soldToOrderId, soldToOrderId)) &&
            (identical(other.soldToOrderItemId, soldToOrderItemId) || const DeepCollectionEquality().equals(other.soldToOrderItemId, soldToOrderItemId)) &&
            (identical(other.soldToOrderNumber, soldToOrderNumber) || const DeepCollectionEquality().equals(other.soldToOrderNumber, soldToOrderNumber)) &&
            (identical(other.soldDate, soldDate) || const DeepCollectionEquality().equals(other.soldDate, soldDate)) &&
            (identical(other.soldAmount, soldAmount) || const DeepCollectionEquality().equals(other.soldAmount, soldAmount)) &&
            (identical(other.soldToName, soldToName) || const DeepCollectionEquality().equals(other.soldToName, soldToName)) &&
            (identical(other.soldToAddress1, soldToAddress1) || const DeepCollectionEquality().equals(other.soldToAddress1, soldToAddress1)) &&
            (identical(other.soldToAddress2, soldToAddress2) || const DeepCollectionEquality().equals(other.soldToAddress2, soldToAddress2)) &&
            (identical(other.soldToCity, soldToCity) || const DeepCollectionEquality().equals(other.soldToCity, soldToCity)) &&
            (identical(other.soldToState, soldToState) || const DeepCollectionEquality().equals(other.soldToState, soldToState)) &&
            (identical(other.soldToZipCode, soldToZipCode) || const DeepCollectionEquality().equals(other.soldToZipCode, soldToZipCode)) &&
            (identical(other.soldToPhone, soldToPhone) || const DeepCollectionEquality().equals(other.soldToPhone, soldToPhone)) &&
            (identical(other.soldToCountryId, soldToCountryId) || const DeepCollectionEquality().equals(other.soldToCountryId, soldToCountryId)) &&
            (identical(other.soldToCountry, soldToCountry) || const DeepCollectionEquality().equals(other.soldToCountry, soldToCountry)) &&
            (identical(other.soldCurrencyId, soldCurrencyId) || const DeepCollectionEquality().equals(other.soldCurrencyId, soldCurrencyId)) &&
            (identical(other.soldCurrency, soldCurrency) || const DeepCollectionEquality().equals(other.soldCurrency, soldCurrency)) &&
            (identical(other.soldCurrencyCode, soldCurrencyCode) || const DeepCollectionEquality().equals(other.soldCurrencyCode, soldCurrencyCode)) &&
            (identical(other.soldCurrencySymbol, soldCurrencySymbol) || const DeepCollectionEquality().equals(other.soldCurrencySymbol, soldCurrencySymbol)) &&
            (identical(other.inventoryTypeId, inventoryTypeId) || const DeepCollectionEquality().equals(other.inventoryTypeId, inventoryTypeId)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesInventoryRetiredRetiredExtension
    on WebApiModulesInventoryRetiredRetired {
  WebApiModulesInventoryRetiredRetired copyWith(
      {String? retiredId,
      String? inventoryId,
      String? iCode,
      String? description,
      String? barCode,
      String? itemId,
      String? serialNumber,
      String? warehouseId,
      String? warehouseCode,
      String? warehouse,
      String? consignorId,
      String? consignor,
      String? consignorAgreementId,
      String? agreementNumber,
      String? retiredDate,
      String? retiredReason,
      String? retiredReasonType,
      String? retiredBy,
      String? retiredReasonId,
      String? retiredByUserId,
      String? retiredNotes,
      double? retiredQuantity,
      double? unretiredQuantity,
      String? lostOrderId,
      String? lostOrderNumber,
      String? lostName,
      String? lostAddress1,
      String? lostAddress2,
      String? lostCity,
      String? lostState,
      String? lostZipCode,
      String? lostPhone,
      String? lostCountryId,
      String? lostCountry,
      String? soldToOrderId,
      String? soldToOrderItemId,
      String? soldToOrderNumber,
      String? soldDate,
      String? soldAmount,
      String? soldToName,
      String? soldToAddress1,
      String? soldToAddress2,
      String? soldToCity,
      String? soldToState,
      String? soldToZipCode,
      String? soldToPhone,
      String? soldToCountryId,
      String? soldToCountry,
      String? soldCurrencyId,
      String? soldCurrency,
      String? soldCurrencyCode,
      String? soldCurrencySymbol,
      String? inventoryTypeId,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesInventoryRetiredRetired(
        retiredId: retiredId ?? this.retiredId,
        inventoryId: inventoryId ?? this.inventoryId,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        barCode: barCode ?? this.barCode,
        itemId: itemId ?? this.itemId,
        serialNumber: serialNumber ?? this.serialNumber,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        warehouse: warehouse ?? this.warehouse,
        consignorId: consignorId ?? this.consignorId,
        consignor: consignor ?? this.consignor,
        consignorAgreementId: consignorAgreementId ?? this.consignorAgreementId,
        agreementNumber: agreementNumber ?? this.agreementNumber,
        retiredDate: retiredDate ?? this.retiredDate,
        retiredReason: retiredReason ?? this.retiredReason,
        retiredReasonType: retiredReasonType ?? this.retiredReasonType,
        retiredBy: retiredBy ?? this.retiredBy,
        retiredReasonId: retiredReasonId ?? this.retiredReasonId,
        retiredByUserId: retiredByUserId ?? this.retiredByUserId,
        retiredNotes: retiredNotes ?? this.retiredNotes,
        retiredQuantity: retiredQuantity ?? this.retiredQuantity,
        unretiredQuantity: unretiredQuantity ?? this.unretiredQuantity,
        lostOrderId: lostOrderId ?? this.lostOrderId,
        lostOrderNumber: lostOrderNumber ?? this.lostOrderNumber,
        lostName: lostName ?? this.lostName,
        lostAddress1: lostAddress1 ?? this.lostAddress1,
        lostAddress2: lostAddress2 ?? this.lostAddress2,
        lostCity: lostCity ?? this.lostCity,
        lostState: lostState ?? this.lostState,
        lostZipCode: lostZipCode ?? this.lostZipCode,
        lostPhone: lostPhone ?? this.lostPhone,
        lostCountryId: lostCountryId ?? this.lostCountryId,
        lostCountry: lostCountry ?? this.lostCountry,
        soldToOrderId: soldToOrderId ?? this.soldToOrderId,
        soldToOrderItemId: soldToOrderItemId ?? this.soldToOrderItemId,
        soldToOrderNumber: soldToOrderNumber ?? this.soldToOrderNumber,
        soldDate: soldDate ?? this.soldDate,
        soldAmount: soldAmount ?? this.soldAmount,
        soldToName: soldToName ?? this.soldToName,
        soldToAddress1: soldToAddress1 ?? this.soldToAddress1,
        soldToAddress2: soldToAddress2 ?? this.soldToAddress2,
        soldToCity: soldToCity ?? this.soldToCity,
        soldToState: soldToState ?? this.soldToState,
        soldToZipCode: soldToZipCode ?? this.soldToZipCode,
        soldToPhone: soldToPhone ?? this.soldToPhone,
        soldToCountryId: soldToCountryId ?? this.soldToCountryId,
        soldToCountry: soldToCountry ?? this.soldToCountry,
        soldCurrencyId: soldCurrencyId ?? this.soldCurrencyId,
        soldCurrency: soldCurrency ?? this.soldCurrency,
        soldCurrencyCode: soldCurrencyCode ?? this.soldCurrencyCode,
        soldCurrencySymbol: soldCurrencySymbol ?? this.soldCurrencySymbol,
        inventoryTypeId: inventoryTypeId ?? this.inventoryTypeId,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventorySalesInventorySalesInventory {
  WebApiModulesInventorySalesInventorySalesInventory({
    this.price,
    this.defaultCost,
    this.averageCost,
    this.inventoryId,
    this.inventoryTypeId,
    this.inventoryType,
    this.availableFrom,
    this.trackedBy,
    this.confirmTrackedBy,
    this.rank,
    this.manufacturerPartNumber,
    this.manufacturerId,
    this.manufacturer,
    this.manufacturerUrl,
    this.excludeImageFromQuoteOrderPrint,
    this.noAvailabilityCheck,
    this.availabilityManuallyResolveConflicts,
    this.sendAvailabilityAlert,
    this.primaryDimensionUniqueId,
    this.defaultImperialMetric,
    this.primaryDimensionDescription,
    this.primaryDimensionShipWeightLbs,
    this.primaryDimensionShipWeightOz,
    this.primaryDimensionWeightInCaseLbs,
    this.primaryDimensionWeightInCaseOz,
    this.primaryDimensionWidthFt,
    this.primaryDimensionWidthIn,
    this.primaryDimensionHeightFt,
    this.primaryDimensionHeightIn,
    this.primaryDimensionLengthFt,
    this.primaryDimensionLengthIn,
    this.primaryDimensionShipWeightKg,
    this.primaryDimensionShipWeightG,
    this.primaryDimensionWeightInCaseKg,
    this.primaryDimensionWeightInCaseG,
    this.primaryDimensionWidthM,
    this.primaryDimensionWidthCm,
    this.primaryDimensionHeightM,
    this.primaryDimensionHeightCm,
    this.primaryDimensionLengthM,
    this.primaryDimensionLengthCm,
    this.hasSecondaryDimensions,
    this.secondaryDimensionUniqueId,
    this.secondaryDimensionDescription,
    this.secondaryDimensionShipWeightLbs,
    this.secondaryDimensionShipWeightOz,
    this.secondaryDimensionWeightInCaseLbs,
    this.secondaryDimensionWeightInCaseOz,
    this.secondaryDimensionWidthFt,
    this.secondaryDimensionWidthIn,
    this.secondaryDimensionHeightFt,
    this.secondaryDimensionHeightIn,
    this.secondaryDimensionLengthFt,
    this.secondaryDimensionLengthIn,
    this.secondaryDimensionShipWeightKg,
    this.secondaryDimensionShipWeightG,
    this.secondaryDimensionWeightInCaseKg,
    this.secondaryDimensionWeightInCaseG,
    this.secondaryDimensionWidthM,
    this.secondaryDimensionWidthCm,
    this.secondaryDimensionHeightM,
    this.secondaryDimensionHeightCm,
    this.secondaryDimensionLengthM,
    this.secondaryDimensionLengthCm,
    this.countryOfOriginId,
    this.countryOfOrigin,
    this.displayInSummaryModeWhenRateIsZero,
    this.qcRequired,
    this.qcTime,
    this.copyAttributesAsNote,
    this.trackAssetUsage,
    this.trackLampUsage,
    this.trackStrikes,
    this.trackCandles,
    this.lampCount,
    this.minimumFootCandles,
    this.trackSoftware,
    this.softwareVersion,
    this.softwareEffectiveDate,
    this.warehouseSpecificPackage,
    this.completePackagePrice,
    this.kitPackagePrice,
    this.separatePackageOnQuoteOrder,
    this.containerId,
    this.containerScannableInventoryId,
    this.containerScannableICode,
    this.containerScannableDescription,
    this.automaticallyRebuildContainerAtCheckIn,
    this.automaticallyRebuildContainerAtTransferIn,
    this.containerStagingRule,
    this.excludeContainedItemsFromAvailability,
    this.useContainerNumber,
    this.containerPackingListBehavior,
    this.inventoryTypeIsWardrobe,
    this.inventoryTypeIsSets,
    this.patternId,
    this.pattern,
    this.periodId,
    this.period,
    this.materialId,
    this.material,
    this.genderId,
    this.gender,
    this.labelId,
    this.label,
    this.wardrobeSize,
    this.wardrobePieceCount,
    this.dyed,
    this.wardrobeSourceId,
    this.wardrobeSource,
    this.wardrobeCareId,
    this.wardrobeCare,
    this.cleaningFeeAmount,
    this.wardrobeDetailedDescription,
    this.webDetailedDescription,
    this.overrideSystemDefaultRevenueAllocationBehavior,
    this.allocateRevenueForAccessories,
    this.packageRevenueCalculationFormula,
    this.isHazardousMaterial,
    this.descriptionWithAkas,
    this.costCalculation,
    this.quantity,
    this.aisleLocation,
    this.shelfLocation,
    this.taxable,
    this.iCode,
    this.description,
    this.availFor,
    this.categoryId,
    this.category,
    this.subCategoryCount,
    this.subCategoryId,
    this.subCategory,
    this.classification,
    this.classificationDescription,
    this.classificationColor,
    this.unitId,
    this.unit,
    this.unitType,
    this.nonDiscountable,
    this.overrideProfitAndLossCategory,
    this.profitAndLossCategoryId,
    this.profitAndLossCategory,
    this.autoCopyNotesToQuoteOrder,
    this.note,
    this.printNoteOnInContract,
    this.printNoteOnOutContract,
    this.printNoteOnReceiveContract,
    this.printNoteOnReturnContract,
    this.printNoteOnInvoice,
    this.printNoteOnOrder,
    this.printNoteOnPickList,
    this.printNoteOnPO,
    this.printNoteOnQuote,
    this.printNoteOnReturnList,
    this.printNoteOnPoReceiveList,
    this.printNoteOnPoReturnList,
    this.assetAccountId,
    this.assetAccountNo,
    this.assetAccountDescription,
    this.incomeAccountId,
    this.incomeAccountNo,
    this.incomeAccountDescription,
    this.subIncomeAccountId,
    this.subIncomeAccountNo,
    this.subIncomeAccountDescription,
    this.consignmentIncomeAccountId,
    this.consignmentIncomeAccountNo,
    this.consignmentIncomeAccountDescription,
    this.ldIncomeAccountId,
    this.ldIncomeAccountNo,
    this.ldIncomeAccountDescription,
    this.equipmentSaleIncomeAccountId,
    this.equipmentSaleIncomeAccountNo,
    this.equipmentSaleIncomeAccountDescription,
    this.expenseAccountId,
    this.expenseAccountNo,
    this.expenseAccountDescription,
    this.costOfGoodsSoldExpenseAccountId,
    this.costOfGoodsSoldExpenseAccountNo,
    this.costOfGoodsSoldExpenseAccountDescription,
    this.costOfGoodsRentedExpenseAccountId,
    this.costOfGoodsRentedExpenseAccountNo,
    this.costOfGoodsRentedExpenseAccountDescription,
    this.depreciationExpenseAccountId,
    this.depreciationExpenseAccountNo,
    this.depreciationExpenseAccountDescription,
    this.accumulatedDepreciationExpenseAccountId,
    this.accumulatedDepreciationExpenseAccountNo,
    this.accumulatedDepreciationExpenseAccountDescription,
    this.originalShowId,
    this.inactive,
    this.dateStamp,
    this.manifestShippingContainer,
    this.manifestStandAloneItem,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesInventorySalesInventorySalesInventory.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventorySalesInventorySalesInventoryFromJson(json);

  @JsonKey(name: 'Price')
  final double? price;
  @JsonKey(name: 'DefaultCost')
  final double? defaultCost;
  @JsonKey(name: 'AverageCost')
  final double? averageCost;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'InventoryTypeId')
  final String? inventoryTypeId;
  @JsonKey(name: 'InventoryType')
  final String? inventoryType;
  @JsonKey(name: 'AvailableFrom')
  final String? availableFrom;
  @JsonKey(name: 'TrackedBy')
  final String? trackedBy;
  @JsonKey(name: 'ConfirmTrackedBy')
  final String? confirmTrackedBy;
  @JsonKey(name: 'Rank')
  final String? rank;
  @JsonKey(name: 'ManufacturerPartNumber')
  final String? manufacturerPartNumber;
  @JsonKey(name: 'ManufacturerId')
  final String? manufacturerId;
  @JsonKey(name: 'Manufacturer')
  final String? manufacturer;
  @JsonKey(name: 'ManufacturerUrl')
  final String? manufacturerUrl;
  @JsonKey(name: 'ExcludeImageFromQuoteOrderPrint')
  final bool? excludeImageFromQuoteOrderPrint;
  @JsonKey(name: 'NoAvailabilityCheck')
  final bool? noAvailabilityCheck;
  @JsonKey(name: 'AvailabilityManuallyResolveConflicts')
  final bool? availabilityManuallyResolveConflicts;
  @JsonKey(name: 'SendAvailabilityAlert')
  final bool? sendAvailabilityAlert;
  @JsonKey(name: 'PrimaryDimensionUniqueId')
  final String? primaryDimensionUniqueId;
  @JsonKey(name: 'DefaultImperialMetric')
  final String? defaultImperialMetric;
  @JsonKey(name: 'PrimaryDimensionDescription')
  final String? primaryDimensionDescription;
  @JsonKey(name: 'PrimaryDimensionShipWeightLbs')
  final int? primaryDimensionShipWeightLbs;
  @JsonKey(name: 'PrimaryDimensionShipWeightOz')
  final int? primaryDimensionShipWeightOz;
  @JsonKey(name: 'PrimaryDimensionWeightInCaseLbs')
  final int? primaryDimensionWeightInCaseLbs;
  @JsonKey(name: 'PrimaryDimensionWeightInCaseOz')
  final int? primaryDimensionWeightInCaseOz;
  @JsonKey(name: 'PrimaryDimensionWidthFt')
  final int? primaryDimensionWidthFt;
  @JsonKey(name: 'PrimaryDimensionWidthIn')
  final int? primaryDimensionWidthIn;
  @JsonKey(name: 'PrimaryDimensionHeightFt')
  final int? primaryDimensionHeightFt;
  @JsonKey(name: 'PrimaryDimensionHeightIn')
  final int? primaryDimensionHeightIn;
  @JsonKey(name: 'PrimaryDimensionLengthFt')
  final int? primaryDimensionLengthFt;
  @JsonKey(name: 'PrimaryDimensionLengthIn')
  final int? primaryDimensionLengthIn;
  @JsonKey(name: 'PrimaryDimensionShipWeightKg')
  final int? primaryDimensionShipWeightKg;
  @JsonKey(name: 'PrimaryDimensionShipWeightG')
  final int? primaryDimensionShipWeightG;
  @JsonKey(name: 'PrimaryDimensionWeightInCaseKg')
  final int? primaryDimensionWeightInCaseKg;
  @JsonKey(name: 'PrimaryDimensionWeightInCaseG')
  final int? primaryDimensionWeightInCaseG;
  @JsonKey(name: 'PrimaryDimensionWidthM')
  final int? primaryDimensionWidthM;
  @JsonKey(name: 'PrimaryDimensionWidthCm')
  final int? primaryDimensionWidthCm;
  @JsonKey(name: 'PrimaryDimensionHeightM')
  final int? primaryDimensionHeightM;
  @JsonKey(name: 'PrimaryDimensionHeightCm')
  final int? primaryDimensionHeightCm;
  @JsonKey(name: 'PrimaryDimensionLengthM')
  final int? primaryDimensionLengthM;
  @JsonKey(name: 'PrimaryDimensionLengthCm')
  final int? primaryDimensionLengthCm;
  @JsonKey(name: 'HasSecondaryDimensions')
  final bool? hasSecondaryDimensions;
  @JsonKey(name: 'SecondaryDimensionUniqueId')
  final String? secondaryDimensionUniqueId;
  @JsonKey(name: 'SecondaryDimensionDescription')
  final String? secondaryDimensionDescription;
  @JsonKey(name: 'SecondaryDimensionShipWeightLbs')
  final int? secondaryDimensionShipWeightLbs;
  @JsonKey(name: 'SecondaryDimensionShipWeightOz')
  final int? secondaryDimensionShipWeightOz;
  @JsonKey(name: 'SecondaryDimensionWeightInCaseLbs')
  final int? secondaryDimensionWeightInCaseLbs;
  @JsonKey(name: 'SecondaryDimensionWeightInCaseOz')
  final int? secondaryDimensionWeightInCaseOz;
  @JsonKey(name: 'SecondaryDimensionWidthFt')
  final int? secondaryDimensionWidthFt;
  @JsonKey(name: 'SecondaryDimensionWidthIn')
  final int? secondaryDimensionWidthIn;
  @JsonKey(name: 'SecondaryDimensionHeightFt')
  final int? secondaryDimensionHeightFt;
  @JsonKey(name: 'SecondaryDimensionHeightIn')
  final int? secondaryDimensionHeightIn;
  @JsonKey(name: 'SecondaryDimensionLengthFt')
  final int? secondaryDimensionLengthFt;
  @JsonKey(name: 'SecondaryDimensionLengthIn')
  final int? secondaryDimensionLengthIn;
  @JsonKey(name: 'SecondaryDimensionShipWeightKg')
  final int? secondaryDimensionShipWeightKg;
  @JsonKey(name: 'SecondaryDimensionShipWeightG')
  final int? secondaryDimensionShipWeightG;
  @JsonKey(name: 'SecondaryDimensionWeightInCaseKg')
  final int? secondaryDimensionWeightInCaseKg;
  @JsonKey(name: 'SecondaryDimensionWeightInCaseG')
  final int? secondaryDimensionWeightInCaseG;
  @JsonKey(name: 'SecondaryDimensionWidthM')
  final int? secondaryDimensionWidthM;
  @JsonKey(name: 'SecondaryDimensionWidthCm')
  final int? secondaryDimensionWidthCm;
  @JsonKey(name: 'SecondaryDimensionHeightM')
  final int? secondaryDimensionHeightM;
  @JsonKey(name: 'SecondaryDimensionHeightCm')
  final int? secondaryDimensionHeightCm;
  @JsonKey(name: 'SecondaryDimensionLengthM')
  final int? secondaryDimensionLengthM;
  @JsonKey(name: 'SecondaryDimensionLengthCm')
  final int? secondaryDimensionLengthCm;
  @JsonKey(name: 'CountryOfOriginId')
  final String? countryOfOriginId;
  @JsonKey(name: 'CountryOfOrigin')
  final String? countryOfOrigin;
  @JsonKey(name: 'DisplayInSummaryModeWhenRateIsZero')
  final bool? displayInSummaryModeWhenRateIsZero;
  @JsonKey(name: 'QcRequired')
  final bool? qcRequired;
  @JsonKey(name: 'QcTime')
  final String? qcTime;
  @JsonKey(name: 'CopyAttributesAsNote')
  final bool? copyAttributesAsNote;
  @JsonKey(name: 'TrackAssetUsage')
  final bool? trackAssetUsage;
  @JsonKey(name: 'TrackLampUsage')
  final bool? trackLampUsage;
  @JsonKey(name: 'TrackStrikes')
  final bool? trackStrikes;
  @JsonKey(name: 'TrackCandles')
  final bool? trackCandles;
  @JsonKey(name: 'LampCount')
  final int? lampCount;
  @JsonKey(name: 'MinimumFootCandles')
  final int? minimumFootCandles;
  @JsonKey(name: 'TrackSoftware')
  final bool? trackSoftware;
  @JsonKey(name: 'SoftwareVersion')
  final String? softwareVersion;
  @JsonKey(name: 'SoftwareEffectiveDate')
  final String? softwareEffectiveDate;
  @JsonKey(name: 'WarehouseSpecificPackage')
  final bool? warehouseSpecificPackage;
  @JsonKey(name: 'CompletePackagePrice')
  final String? completePackagePrice;
  @JsonKey(name: 'KitPackagePrice')
  final String? kitPackagePrice;
  @JsonKey(name: 'SeparatePackageOnQuoteOrder')
  final bool? separatePackageOnQuoteOrder;
  @JsonKey(name: 'ContainerId')
  final String? containerId;
  @JsonKey(name: 'ContainerScannableInventoryId')
  final String? containerScannableInventoryId;
  @JsonKey(name: 'ContainerScannableICode')
  final String? containerScannableICode;
  @JsonKey(name: 'ContainerScannableDescription')
  final String? containerScannableDescription;
  @JsonKey(name: 'AutomaticallyRebuildContainerAtCheckIn')
  final bool? automaticallyRebuildContainerAtCheckIn;
  @JsonKey(name: 'AutomaticallyRebuildContainerAtTransferIn')
  final bool? automaticallyRebuildContainerAtTransferIn;
  @JsonKey(name: 'ContainerStagingRule')
  final String? containerStagingRule;
  @JsonKey(name: 'ExcludeContainedItemsFromAvailability')
  final bool? excludeContainedItemsFromAvailability;
  @JsonKey(name: 'UseContainerNumber')
  final bool? useContainerNumber;
  @JsonKey(name: 'ContainerPackingListBehavior')
  final String? containerPackingListBehavior;
  @JsonKey(name: 'InventoryTypeIsWardrobe')
  final bool? inventoryTypeIsWardrobe;
  @JsonKey(name: 'InventoryTypeIsSets')
  final bool? inventoryTypeIsSets;
  @JsonKey(name: 'PatternId')
  final String? patternId;
  @JsonKey(name: 'Pattern')
  final String? pattern;
  @JsonKey(name: 'PeriodId')
  final String? periodId;
  @JsonKey(name: 'Period')
  final String? period;
  @JsonKey(name: 'MaterialId')
  final String? materialId;
  @JsonKey(name: 'Material')
  final String? material;
  @JsonKey(name: 'GenderId')
  final String? genderId;
  @JsonKey(name: 'Gender')
  final String? gender;
  @JsonKey(name: 'LabelId')
  final String? labelId;
  @JsonKey(name: 'Label')
  final String? label;
  @JsonKey(name: 'WardrobeSize')
  final String? wardrobeSize;
  @JsonKey(name: 'WardrobePieceCount')
  final int? wardrobePieceCount;
  @JsonKey(name: 'Dyed')
  final bool? dyed;
  @JsonKey(name: 'WardrobeSourceId')
  final String? wardrobeSourceId;
  @JsonKey(name: 'WardrobeSource')
  final String? wardrobeSource;
  @JsonKey(name: 'WardrobeCareId')
  final String? wardrobeCareId;
  @JsonKey(name: 'WardrobeCare')
  final String? wardrobeCare;
  @JsonKey(name: 'CleaningFeeAmount')
  final double? cleaningFeeAmount;
  @JsonKey(name: 'WardrobeDetailedDescription')
  final String? wardrobeDetailedDescription;
  @JsonKey(name: 'WebDetailedDescription')
  final String? webDetailedDescription;
  @JsonKey(name: 'OverrideSystemDefaultRevenueAllocationBehavior')
  final bool? overrideSystemDefaultRevenueAllocationBehavior;
  @JsonKey(name: 'AllocateRevenueForAccessories')
  final bool? allocateRevenueForAccessories;
  @JsonKey(name: 'PackageRevenueCalculationFormula')
  final String? packageRevenueCalculationFormula;
  @JsonKey(name: 'IsHazardousMaterial')
  final bool? isHazardousMaterial;
  @JsonKey(name: 'DescriptionWithAkas')
  final String? descriptionWithAkas;
  @JsonKey(name: 'CostCalculation')
  final String? costCalculation;
  @JsonKey(name: 'Quantity')
  final double? quantity;
  @JsonKey(name: 'AisleLocation')
  final String? aisleLocation;
  @JsonKey(name: 'ShelfLocation')
  final String? shelfLocation;
  @JsonKey(name: 'Taxable')
  final bool? taxable;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AvailFor')
  final String? availFor;
  @JsonKey(name: 'CategoryId')
  final String? categoryId;
  @JsonKey(name: 'Category')
  final String? category;
  @JsonKey(name: 'SubCategoryCount')
  final int? subCategoryCount;
  @JsonKey(name: 'SubCategoryId')
  final String? subCategoryId;
  @JsonKey(name: 'SubCategory')
  final String? subCategory;
  @JsonKey(name: 'Classification')
  final String? classification;
  @JsonKey(name: 'ClassificationDescription')
  final String? classificationDescription;
  @JsonKey(name: 'ClassificationColor')
  final String? classificationColor;
  @JsonKey(name: 'UnitId')
  final String? unitId;
  @JsonKey(name: 'Unit')
  final String? unit;
  @JsonKey(name: 'UnitType')
  final String? unitType;
  @JsonKey(name: 'NonDiscountable')
  final bool? nonDiscountable;
  @JsonKey(name: 'OverrideProfitAndLossCategory')
  final bool? overrideProfitAndLossCategory;
  @JsonKey(name: 'ProfitAndLossCategoryId')
  final String? profitAndLossCategoryId;
  @JsonKey(name: 'ProfitAndLossCategory')
  final String? profitAndLossCategory;
  @JsonKey(name: 'AutoCopyNotesToQuoteOrder')
  final bool? autoCopyNotesToQuoteOrder;
  @JsonKey(name: 'Note')
  final String? note;
  @JsonKey(name: 'PrintNoteOnInContract')
  final bool? printNoteOnInContract;
  @JsonKey(name: 'PrintNoteOnOutContract')
  final bool? printNoteOnOutContract;
  @JsonKey(name: 'PrintNoteOnReceiveContract')
  final bool? printNoteOnReceiveContract;
  @JsonKey(name: 'PrintNoteOnReturnContract')
  final bool? printNoteOnReturnContract;
  @JsonKey(name: 'PrintNoteOnInvoice')
  final bool? printNoteOnInvoice;
  @JsonKey(name: 'PrintNoteOnOrder')
  final bool? printNoteOnOrder;
  @JsonKey(name: 'PrintNoteOnPickList')
  final bool? printNoteOnPickList;
  @JsonKey(name: 'PrintNoteOnPO')
  final bool? printNoteOnPO;
  @JsonKey(name: 'PrintNoteOnQuote')
  final bool? printNoteOnQuote;
  @JsonKey(name: 'PrintNoteOnReturnList')
  final bool? printNoteOnReturnList;
  @JsonKey(name: 'PrintNoteOnPoReceiveList')
  final bool? printNoteOnPoReceiveList;
  @JsonKey(name: 'PrintNoteOnPoReturnList')
  final bool? printNoteOnPoReturnList;
  @JsonKey(name: 'AssetAccountId')
  final String? assetAccountId;
  @JsonKey(name: 'AssetAccountNo')
  final String? assetAccountNo;
  @JsonKey(name: 'AssetAccountDescription')
  final String? assetAccountDescription;
  @JsonKey(name: 'IncomeAccountId')
  final String? incomeAccountId;
  @JsonKey(name: 'IncomeAccountNo')
  final String? incomeAccountNo;
  @JsonKey(name: 'IncomeAccountDescription')
  final String? incomeAccountDescription;
  @JsonKey(name: 'SubIncomeAccountId')
  final String? subIncomeAccountId;
  @JsonKey(name: 'SubIncomeAccountNo')
  final String? subIncomeAccountNo;
  @JsonKey(name: 'SubIncomeAccountDescription')
  final String? subIncomeAccountDescription;
  @JsonKey(name: 'ConsignmentIncomeAccountId')
  final String? consignmentIncomeAccountId;
  @JsonKey(name: 'ConsignmentIncomeAccountNo')
  final String? consignmentIncomeAccountNo;
  @JsonKey(name: 'ConsignmentIncomeAccountDescription')
  final String? consignmentIncomeAccountDescription;
  @JsonKey(name: 'LdIncomeAccountId')
  final String? ldIncomeAccountId;
  @JsonKey(name: 'LdIncomeAccountNo')
  final String? ldIncomeAccountNo;
  @JsonKey(name: 'LdIncomeAccountDescription')
  final String? ldIncomeAccountDescription;
  @JsonKey(name: 'EquipmentSaleIncomeAccountId')
  final String? equipmentSaleIncomeAccountId;
  @JsonKey(name: 'EquipmentSaleIncomeAccountNo')
  final String? equipmentSaleIncomeAccountNo;
  @JsonKey(name: 'EquipmentSaleIncomeAccountDescription')
  final String? equipmentSaleIncomeAccountDescription;
  @JsonKey(name: 'ExpenseAccountId')
  final String? expenseAccountId;
  @JsonKey(name: 'ExpenseAccountNo')
  final String? expenseAccountNo;
  @JsonKey(name: 'ExpenseAccountDescription')
  final String? expenseAccountDescription;
  @JsonKey(name: 'CostOfGoodsSoldExpenseAccountId')
  final String? costOfGoodsSoldExpenseAccountId;
  @JsonKey(name: 'CostOfGoodsSoldExpenseAccountNo')
  final String? costOfGoodsSoldExpenseAccountNo;
  @JsonKey(name: 'CostOfGoodsSoldExpenseAccountDescription')
  final String? costOfGoodsSoldExpenseAccountDescription;
  @JsonKey(name: 'CostOfGoodsRentedExpenseAccountId')
  final String? costOfGoodsRentedExpenseAccountId;
  @JsonKey(name: 'CostOfGoodsRentedExpenseAccountNo')
  final String? costOfGoodsRentedExpenseAccountNo;
  @JsonKey(name: 'CostOfGoodsRentedExpenseAccountDescription')
  final String? costOfGoodsRentedExpenseAccountDescription;
  @JsonKey(name: 'DepreciationExpenseAccountId')
  final String? depreciationExpenseAccountId;
  @JsonKey(name: 'DepreciationExpenseAccountNo')
  final String? depreciationExpenseAccountNo;
  @JsonKey(name: 'DepreciationExpenseAccountDescription')
  final String? depreciationExpenseAccountDescription;
  @JsonKey(name: 'AccumulatedDepreciationExpenseAccountId')
  final String? accumulatedDepreciationExpenseAccountId;
  @JsonKey(name: 'AccumulatedDepreciationExpenseAccountNo')
  final String? accumulatedDepreciationExpenseAccountNo;
  @JsonKey(name: 'AccumulatedDepreciationExpenseAccountDescription')
  final String? accumulatedDepreciationExpenseAccountDescription;
  @JsonKey(name: 'OriginalShowId')
  final String? originalShowId;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'ManifestShippingContainer')
  final bool? manifestShippingContainer;
  @JsonKey(name: 'ManifestStandAloneItem')
  final bool? manifestStandAloneItem;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesInventorySalesInventorySalesInventoryFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventorySalesInventorySalesInventoryToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventorySalesInventorySalesInventoryToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventorySalesInventorySalesInventory &&
            (identical(other.price, price) ||
                const DeepCollectionEquality().equals(other.price, price)) &&
            (identical(other.defaultCost, defaultCost) ||
                const DeepCollectionEquality()
                    .equals(other.defaultCost, defaultCost)) &&
            (identical(other.averageCost, averageCost) ||
                const DeepCollectionEquality()
                    .equals(other.averageCost, averageCost)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.inventoryTypeId, inventoryTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryTypeId, inventoryTypeId)) &&
            (identical(other.inventoryType, inventoryType) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryType, inventoryType)) &&
            (identical(other.availableFrom, availableFrom) ||
                const DeepCollectionEquality()
                    .equals(other.availableFrom, availableFrom)) &&
            (identical(other.trackedBy, trackedBy) ||
                const DeepCollectionEquality()
                    .equals(other.trackedBy, trackedBy)) &&
            (identical(other.confirmTrackedBy, confirmTrackedBy) ||
                const DeepCollectionEquality()
                    .equals(other.confirmTrackedBy, confirmTrackedBy)) &&
            (identical(other.rank, rank) ||
                const DeepCollectionEquality().equals(other.rank, rank)) &&
            (identical(other.manufacturerPartNumber, manufacturerPartNumber) ||
                const DeepCollectionEquality().equals(
                    other.manufacturerPartNumber, manufacturerPartNumber)) &&
            (identical(other.manufacturerId, manufacturerId) ||
                const DeepCollectionEquality()
                    .equals(other.manufacturerId, manufacturerId)) &&
            (identical(other.manufacturer, manufacturer) ||
                const DeepCollectionEquality()
                    .equals(other.manufacturer, manufacturer)) &&
            (identical(other.manufacturerUrl, manufacturerUrl) ||
                const DeepCollectionEquality()
                    .equals(other.manufacturerUrl, manufacturerUrl)) &&
            (identical(other.excludeImageFromQuoteOrderPrint, excludeImageFromQuoteOrderPrint) ||
                const DeepCollectionEquality().equals(
                    other.excludeImageFromQuoteOrderPrint,
                    excludeImageFromQuoteOrderPrint)) &&
            (identical(other.noAvailabilityCheck, noAvailabilityCheck) ||
                const DeepCollectionEquality()
                    .equals(other.noAvailabilityCheck, noAvailabilityCheck)) &&
            (identical(other.availabilityManuallyResolveConflicts, availabilityManuallyResolveConflicts) ||
                const DeepCollectionEquality().equals(
                    other.availabilityManuallyResolveConflicts,
                    availabilityManuallyResolveConflicts)) &&
            (identical(other.sendAvailabilityAlert, sendAvailabilityAlert) ||
                const DeepCollectionEquality().equals(
                    other.sendAvailabilityAlert, sendAvailabilityAlert)) &&
            (identical(
                    other.primaryDimensionUniqueId, primaryDimensionUniqueId) ||
                const DeepCollectionEquality().equals(
                    other.primaryDimensionUniqueId, primaryDimensionUniqueId)) &&
            (identical(other.defaultImperialMetric, defaultImperialMetric) || const DeepCollectionEquality().equals(other.defaultImperialMetric, defaultImperialMetric)) &&
            (identical(other.primaryDimensionDescription, primaryDimensionDescription) || const DeepCollectionEquality().equals(other.primaryDimensionDescription, primaryDimensionDescription)) &&
            (identical(other.primaryDimensionShipWeightLbs, primaryDimensionShipWeightLbs) || const DeepCollectionEquality().equals(other.primaryDimensionShipWeightLbs, primaryDimensionShipWeightLbs)) &&
            (identical(other.primaryDimensionShipWeightOz, primaryDimensionShipWeightOz) || const DeepCollectionEquality().equals(other.primaryDimensionShipWeightOz, primaryDimensionShipWeightOz)) &&
            (identical(other.primaryDimensionWeightInCaseLbs, primaryDimensionWeightInCaseLbs) || const DeepCollectionEquality().equals(other.primaryDimensionWeightInCaseLbs, primaryDimensionWeightInCaseLbs)) &&
            (identical(other.primaryDimensionWeightInCaseOz, primaryDimensionWeightInCaseOz) || const DeepCollectionEquality().equals(other.primaryDimensionWeightInCaseOz, primaryDimensionWeightInCaseOz)) &&
            (identical(other.primaryDimensionWidthFt, primaryDimensionWidthFt) || const DeepCollectionEquality().equals(other.primaryDimensionWidthFt, primaryDimensionWidthFt)) &&
            (identical(other.primaryDimensionWidthIn, primaryDimensionWidthIn) || const DeepCollectionEquality().equals(other.primaryDimensionWidthIn, primaryDimensionWidthIn)) &&
            (identical(other.primaryDimensionHeightFt, primaryDimensionHeightFt) || const DeepCollectionEquality().equals(other.primaryDimensionHeightFt, primaryDimensionHeightFt)) &&
            (identical(other.primaryDimensionHeightIn, primaryDimensionHeightIn) || const DeepCollectionEquality().equals(other.primaryDimensionHeightIn, primaryDimensionHeightIn)) &&
            (identical(other.primaryDimensionLengthFt, primaryDimensionLengthFt) || const DeepCollectionEquality().equals(other.primaryDimensionLengthFt, primaryDimensionLengthFt)) &&
            (identical(other.primaryDimensionLengthIn, primaryDimensionLengthIn) || const DeepCollectionEquality().equals(other.primaryDimensionLengthIn, primaryDimensionLengthIn)) &&
            (identical(other.primaryDimensionShipWeightKg, primaryDimensionShipWeightKg) || const DeepCollectionEquality().equals(other.primaryDimensionShipWeightKg, primaryDimensionShipWeightKg)) &&
            (identical(other.primaryDimensionShipWeightG, primaryDimensionShipWeightG) || const DeepCollectionEquality().equals(other.primaryDimensionShipWeightG, primaryDimensionShipWeightG)) &&
            (identical(other.primaryDimensionWeightInCaseKg, primaryDimensionWeightInCaseKg) || const DeepCollectionEquality().equals(other.primaryDimensionWeightInCaseKg, primaryDimensionWeightInCaseKg)) &&
            (identical(other.primaryDimensionWeightInCaseG, primaryDimensionWeightInCaseG) || const DeepCollectionEquality().equals(other.primaryDimensionWeightInCaseG, primaryDimensionWeightInCaseG)) &&
            (identical(other.primaryDimensionWidthM, primaryDimensionWidthM) || const DeepCollectionEquality().equals(other.primaryDimensionWidthM, primaryDimensionWidthM)) &&
            (identical(other.primaryDimensionWidthCm, primaryDimensionWidthCm) || const DeepCollectionEquality().equals(other.primaryDimensionWidthCm, primaryDimensionWidthCm)) &&
            (identical(other.primaryDimensionHeightM, primaryDimensionHeightM) || const DeepCollectionEquality().equals(other.primaryDimensionHeightM, primaryDimensionHeightM)) &&
            (identical(other.primaryDimensionHeightCm, primaryDimensionHeightCm) || const DeepCollectionEquality().equals(other.primaryDimensionHeightCm, primaryDimensionHeightCm)) &&
            (identical(other.primaryDimensionLengthM, primaryDimensionLengthM) || const DeepCollectionEquality().equals(other.primaryDimensionLengthM, primaryDimensionLengthM)) &&
            (identical(other.primaryDimensionLengthCm, primaryDimensionLengthCm) || const DeepCollectionEquality().equals(other.primaryDimensionLengthCm, primaryDimensionLengthCm)) &&
            (identical(other.hasSecondaryDimensions, hasSecondaryDimensions) || const DeepCollectionEquality().equals(other.hasSecondaryDimensions, hasSecondaryDimensions)) &&
            (identical(other.secondaryDimensionUniqueId, secondaryDimensionUniqueId) || const DeepCollectionEquality().equals(other.secondaryDimensionUniqueId, secondaryDimensionUniqueId)) &&
            (identical(other.secondaryDimensionDescription, secondaryDimensionDescription) || const DeepCollectionEquality().equals(other.secondaryDimensionDescription, secondaryDimensionDescription)) &&
            (identical(other.secondaryDimensionShipWeightLbs, secondaryDimensionShipWeightLbs) || const DeepCollectionEquality().equals(other.secondaryDimensionShipWeightLbs, secondaryDimensionShipWeightLbs)) &&
            (identical(other.secondaryDimensionShipWeightOz, secondaryDimensionShipWeightOz) || const DeepCollectionEquality().equals(other.secondaryDimensionShipWeightOz, secondaryDimensionShipWeightOz)) &&
            (identical(other.secondaryDimensionWeightInCaseLbs, secondaryDimensionWeightInCaseLbs) || const DeepCollectionEquality().equals(other.secondaryDimensionWeightInCaseLbs, secondaryDimensionWeightInCaseLbs)) &&
            (identical(other.secondaryDimensionWeightInCaseOz, secondaryDimensionWeightInCaseOz) || const DeepCollectionEquality().equals(other.secondaryDimensionWeightInCaseOz, secondaryDimensionWeightInCaseOz)) &&
            (identical(other.secondaryDimensionWidthFt, secondaryDimensionWidthFt) || const DeepCollectionEquality().equals(other.secondaryDimensionWidthFt, secondaryDimensionWidthFt)) &&
            (identical(other.secondaryDimensionWidthIn, secondaryDimensionWidthIn) || const DeepCollectionEquality().equals(other.secondaryDimensionWidthIn, secondaryDimensionWidthIn)) &&
            (identical(other.secondaryDimensionHeightFt, secondaryDimensionHeightFt) || const DeepCollectionEquality().equals(other.secondaryDimensionHeightFt, secondaryDimensionHeightFt)) &&
            (identical(other.secondaryDimensionHeightIn, secondaryDimensionHeightIn) || const DeepCollectionEquality().equals(other.secondaryDimensionHeightIn, secondaryDimensionHeightIn)) &&
            (identical(other.secondaryDimensionLengthFt, secondaryDimensionLengthFt) || const DeepCollectionEquality().equals(other.secondaryDimensionLengthFt, secondaryDimensionLengthFt)) &&
            (identical(other.secondaryDimensionLengthIn, secondaryDimensionLengthIn) || const DeepCollectionEquality().equals(other.secondaryDimensionLengthIn, secondaryDimensionLengthIn)) &&
            (identical(other.secondaryDimensionShipWeightKg, secondaryDimensionShipWeightKg) || const DeepCollectionEquality().equals(other.secondaryDimensionShipWeightKg, secondaryDimensionShipWeightKg)) &&
            (identical(other.secondaryDimensionShipWeightG, secondaryDimensionShipWeightG) || const DeepCollectionEquality().equals(other.secondaryDimensionShipWeightG, secondaryDimensionShipWeightG)) &&
            (identical(other.secondaryDimensionWeightInCaseKg, secondaryDimensionWeightInCaseKg) || const DeepCollectionEquality().equals(other.secondaryDimensionWeightInCaseKg, secondaryDimensionWeightInCaseKg)) &&
            (identical(other.secondaryDimensionWeightInCaseG, secondaryDimensionWeightInCaseG) || const DeepCollectionEquality().equals(other.secondaryDimensionWeightInCaseG, secondaryDimensionWeightInCaseG)) &&
            (identical(other.secondaryDimensionWidthM, secondaryDimensionWidthM) || const DeepCollectionEquality().equals(other.secondaryDimensionWidthM, secondaryDimensionWidthM)) &&
            (identical(other.secondaryDimensionWidthCm, secondaryDimensionWidthCm) || const DeepCollectionEquality().equals(other.secondaryDimensionWidthCm, secondaryDimensionWidthCm)) &&
            (identical(other.secondaryDimensionHeightM, secondaryDimensionHeightM) || const DeepCollectionEquality().equals(other.secondaryDimensionHeightM, secondaryDimensionHeightM)) &&
            (identical(other.secondaryDimensionHeightCm, secondaryDimensionHeightCm) || const DeepCollectionEquality().equals(other.secondaryDimensionHeightCm, secondaryDimensionHeightCm)) &&
            (identical(other.secondaryDimensionLengthM, secondaryDimensionLengthM) || const DeepCollectionEquality().equals(other.secondaryDimensionLengthM, secondaryDimensionLengthM)) &&
            (identical(other.secondaryDimensionLengthCm, secondaryDimensionLengthCm) || const DeepCollectionEquality().equals(other.secondaryDimensionLengthCm, secondaryDimensionLengthCm)) &&
            (identical(other.countryOfOriginId, countryOfOriginId) || const DeepCollectionEquality().equals(other.countryOfOriginId, countryOfOriginId)) &&
            (identical(other.countryOfOrigin, countryOfOrigin) || const DeepCollectionEquality().equals(other.countryOfOrigin, countryOfOrigin)) &&
            (identical(other.displayInSummaryModeWhenRateIsZero, displayInSummaryModeWhenRateIsZero) || const DeepCollectionEquality().equals(other.displayInSummaryModeWhenRateIsZero, displayInSummaryModeWhenRateIsZero)) &&
            (identical(other.qcRequired, qcRequired) || const DeepCollectionEquality().equals(other.qcRequired, qcRequired)) &&
            (identical(other.qcTime, qcTime) || const DeepCollectionEquality().equals(other.qcTime, qcTime)) &&
            (identical(other.copyAttributesAsNote, copyAttributesAsNote) || const DeepCollectionEquality().equals(other.copyAttributesAsNote, copyAttributesAsNote)) &&
            (identical(other.trackAssetUsage, trackAssetUsage) || const DeepCollectionEquality().equals(other.trackAssetUsage, trackAssetUsage)) &&
            (identical(other.trackLampUsage, trackLampUsage) || const DeepCollectionEquality().equals(other.trackLampUsage, trackLampUsage)) &&
            (identical(other.trackStrikes, trackStrikes) || const DeepCollectionEquality().equals(other.trackStrikes, trackStrikes)) &&
            (identical(other.trackCandles, trackCandles) || const DeepCollectionEquality().equals(other.trackCandles, trackCandles)) &&
            (identical(other.lampCount, lampCount) || const DeepCollectionEquality().equals(other.lampCount, lampCount)) &&
            (identical(other.minimumFootCandles, minimumFootCandles) || const DeepCollectionEquality().equals(other.minimumFootCandles, minimumFootCandles)) &&
            (identical(other.trackSoftware, trackSoftware) || const DeepCollectionEquality().equals(other.trackSoftware, trackSoftware)) &&
            (identical(other.softwareVersion, softwareVersion) || const DeepCollectionEquality().equals(other.softwareVersion, softwareVersion)) &&
            (identical(other.softwareEffectiveDate, softwareEffectiveDate) || const DeepCollectionEquality().equals(other.softwareEffectiveDate, softwareEffectiveDate)) &&
            (identical(other.warehouseSpecificPackage, warehouseSpecificPackage) || const DeepCollectionEquality().equals(other.warehouseSpecificPackage, warehouseSpecificPackage)) &&
            (identical(other.completePackagePrice, completePackagePrice) || const DeepCollectionEquality().equals(other.completePackagePrice, completePackagePrice)) &&
            (identical(other.kitPackagePrice, kitPackagePrice) || const DeepCollectionEquality().equals(other.kitPackagePrice, kitPackagePrice)) &&
            (identical(other.separatePackageOnQuoteOrder, separatePackageOnQuoteOrder) || const DeepCollectionEquality().equals(other.separatePackageOnQuoteOrder, separatePackageOnQuoteOrder)) &&
            (identical(other.containerId, containerId) || const DeepCollectionEquality().equals(other.containerId, containerId)) &&
            (identical(other.containerScannableInventoryId, containerScannableInventoryId) || const DeepCollectionEquality().equals(other.containerScannableInventoryId, containerScannableInventoryId)) &&
            (identical(other.containerScannableICode, containerScannableICode) || const DeepCollectionEquality().equals(other.containerScannableICode, containerScannableICode)) &&
            (identical(other.containerScannableDescription, containerScannableDescription) || const DeepCollectionEquality().equals(other.containerScannableDescription, containerScannableDescription)) &&
            (identical(other.automaticallyRebuildContainerAtCheckIn, automaticallyRebuildContainerAtCheckIn) || const DeepCollectionEquality().equals(other.automaticallyRebuildContainerAtCheckIn, automaticallyRebuildContainerAtCheckIn)) &&
            (identical(other.automaticallyRebuildContainerAtTransferIn, automaticallyRebuildContainerAtTransferIn) || const DeepCollectionEquality().equals(other.automaticallyRebuildContainerAtTransferIn, automaticallyRebuildContainerAtTransferIn)) &&
            (identical(other.containerStagingRule, containerStagingRule) || const DeepCollectionEquality().equals(other.containerStagingRule, containerStagingRule)) &&
            (identical(other.excludeContainedItemsFromAvailability, excludeContainedItemsFromAvailability) || const DeepCollectionEquality().equals(other.excludeContainedItemsFromAvailability, excludeContainedItemsFromAvailability)) &&
            (identical(other.useContainerNumber, useContainerNumber) || const DeepCollectionEquality().equals(other.useContainerNumber, useContainerNumber)) &&
            (identical(other.containerPackingListBehavior, containerPackingListBehavior) || const DeepCollectionEquality().equals(other.containerPackingListBehavior, containerPackingListBehavior)) &&
            (identical(other.inventoryTypeIsWardrobe, inventoryTypeIsWardrobe) || const DeepCollectionEquality().equals(other.inventoryTypeIsWardrobe, inventoryTypeIsWardrobe)) &&
            (identical(other.inventoryTypeIsSets, inventoryTypeIsSets) || const DeepCollectionEquality().equals(other.inventoryTypeIsSets, inventoryTypeIsSets)) &&
            (identical(other.patternId, patternId) || const DeepCollectionEquality().equals(other.patternId, patternId)) &&
            (identical(other.pattern, pattern) || const DeepCollectionEquality().equals(other.pattern, pattern)) &&
            (identical(other.periodId, periodId) || const DeepCollectionEquality().equals(other.periodId, periodId)) &&
            (identical(other.period, period) || const DeepCollectionEquality().equals(other.period, period)) &&
            (identical(other.materialId, materialId) || const DeepCollectionEquality().equals(other.materialId, materialId)) &&
            (identical(other.material, material) || const DeepCollectionEquality().equals(other.material, material)) &&
            (identical(other.genderId, genderId) || const DeepCollectionEquality().equals(other.genderId, genderId)) &&
            (identical(other.gender, gender) || const DeepCollectionEquality().equals(other.gender, gender)) &&
            (identical(other.labelId, labelId) || const DeepCollectionEquality().equals(other.labelId, labelId)) &&
            (identical(other.label, label) || const DeepCollectionEquality().equals(other.label, label)) &&
            (identical(other.wardrobeSize, wardrobeSize) || const DeepCollectionEquality().equals(other.wardrobeSize, wardrobeSize)) &&
            (identical(other.wardrobePieceCount, wardrobePieceCount) || const DeepCollectionEquality().equals(other.wardrobePieceCount, wardrobePieceCount)) &&
            (identical(other.dyed, dyed) || const DeepCollectionEquality().equals(other.dyed, dyed)) &&
            (identical(other.wardrobeSourceId, wardrobeSourceId) || const DeepCollectionEquality().equals(other.wardrobeSourceId, wardrobeSourceId)) &&
            (identical(other.wardrobeSource, wardrobeSource) || const DeepCollectionEquality().equals(other.wardrobeSource, wardrobeSource)) &&
            (identical(other.wardrobeCareId, wardrobeCareId) || const DeepCollectionEquality().equals(other.wardrobeCareId, wardrobeCareId)) &&
            (identical(other.wardrobeCare, wardrobeCare) || const DeepCollectionEquality().equals(other.wardrobeCare, wardrobeCare)) &&
            (identical(other.cleaningFeeAmount, cleaningFeeAmount) || const DeepCollectionEquality().equals(other.cleaningFeeAmount, cleaningFeeAmount)) &&
            (identical(other.wardrobeDetailedDescription, wardrobeDetailedDescription) || const DeepCollectionEquality().equals(other.wardrobeDetailedDescription, wardrobeDetailedDescription)) &&
            (identical(other.webDetailedDescription, webDetailedDescription) || const DeepCollectionEquality().equals(other.webDetailedDescription, webDetailedDescription)) &&
            (identical(other.overrideSystemDefaultRevenueAllocationBehavior, overrideSystemDefaultRevenueAllocationBehavior) || const DeepCollectionEquality().equals(other.overrideSystemDefaultRevenueAllocationBehavior, overrideSystemDefaultRevenueAllocationBehavior)) &&
            (identical(other.allocateRevenueForAccessories, allocateRevenueForAccessories) || const DeepCollectionEquality().equals(other.allocateRevenueForAccessories, allocateRevenueForAccessories)) &&
            (identical(other.packageRevenueCalculationFormula, packageRevenueCalculationFormula) || const DeepCollectionEquality().equals(other.packageRevenueCalculationFormula, packageRevenueCalculationFormula)) &&
            (identical(other.isHazardousMaterial, isHazardousMaterial) || const DeepCollectionEquality().equals(other.isHazardousMaterial, isHazardousMaterial)) &&
            (identical(other.descriptionWithAkas, descriptionWithAkas) || const DeepCollectionEquality().equals(other.descriptionWithAkas, descriptionWithAkas)) &&
            (identical(other.costCalculation, costCalculation) || const DeepCollectionEquality().equals(other.costCalculation, costCalculation)) &&
            (identical(other.quantity, quantity) || const DeepCollectionEquality().equals(other.quantity, quantity)) &&
            (identical(other.aisleLocation, aisleLocation) || const DeepCollectionEquality().equals(other.aisleLocation, aisleLocation)) &&
            (identical(other.shelfLocation, shelfLocation) || const DeepCollectionEquality().equals(other.shelfLocation, shelfLocation)) &&
            (identical(other.taxable, taxable) || const DeepCollectionEquality().equals(other.taxable, taxable)) &&
            (identical(other.iCode, iCode) || const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) || const DeepCollectionEquality().equals(other.description, description)) &&
            (identical(other.availFor, availFor) || const DeepCollectionEquality().equals(other.availFor, availFor)) &&
            (identical(other.categoryId, categoryId) || const DeepCollectionEquality().equals(other.categoryId, categoryId)) &&
            (identical(other.category, category) || const DeepCollectionEquality().equals(other.category, category)) &&
            (identical(other.subCategoryCount, subCategoryCount) || const DeepCollectionEquality().equals(other.subCategoryCount, subCategoryCount)) &&
            (identical(other.subCategoryId, subCategoryId) || const DeepCollectionEquality().equals(other.subCategoryId, subCategoryId)) &&
            (identical(other.subCategory, subCategory) || const DeepCollectionEquality().equals(other.subCategory, subCategory)) &&
            (identical(other.classification, classification) || const DeepCollectionEquality().equals(other.classification, classification)) &&
            (identical(other.classificationDescription, classificationDescription) || const DeepCollectionEquality().equals(other.classificationDescription, classificationDescription)) &&
            (identical(other.classificationColor, classificationColor) || const DeepCollectionEquality().equals(other.classificationColor, classificationColor)) &&
            (identical(other.unitId, unitId) || const DeepCollectionEquality().equals(other.unitId, unitId)) &&
            (identical(other.unit, unit) || const DeepCollectionEquality().equals(other.unit, unit)) &&
            (identical(other.unitType, unitType) || const DeepCollectionEquality().equals(other.unitType, unitType)) &&
            (identical(other.nonDiscountable, nonDiscountable) || const DeepCollectionEquality().equals(other.nonDiscountable, nonDiscountable)) &&
            (identical(other.overrideProfitAndLossCategory, overrideProfitAndLossCategory) || const DeepCollectionEquality().equals(other.overrideProfitAndLossCategory, overrideProfitAndLossCategory)) &&
            (identical(other.profitAndLossCategoryId, profitAndLossCategoryId) || const DeepCollectionEquality().equals(other.profitAndLossCategoryId, profitAndLossCategoryId)) &&
            (identical(other.profitAndLossCategory, profitAndLossCategory) || const DeepCollectionEquality().equals(other.profitAndLossCategory, profitAndLossCategory)) &&
            (identical(other.autoCopyNotesToQuoteOrder, autoCopyNotesToQuoteOrder) || const DeepCollectionEquality().equals(other.autoCopyNotesToQuoteOrder, autoCopyNotesToQuoteOrder)) &&
            (identical(other.note, note) || const DeepCollectionEquality().equals(other.note, note)) &&
            (identical(other.printNoteOnInContract, printNoteOnInContract) || const DeepCollectionEquality().equals(other.printNoteOnInContract, printNoteOnInContract)) &&
            (identical(other.printNoteOnOutContract, printNoteOnOutContract) || const DeepCollectionEquality().equals(other.printNoteOnOutContract, printNoteOnOutContract)) &&
            (identical(other.printNoteOnReceiveContract, printNoteOnReceiveContract) || const DeepCollectionEquality().equals(other.printNoteOnReceiveContract, printNoteOnReceiveContract)) &&
            (identical(other.printNoteOnReturnContract, printNoteOnReturnContract) || const DeepCollectionEquality().equals(other.printNoteOnReturnContract, printNoteOnReturnContract)) &&
            (identical(other.printNoteOnInvoice, printNoteOnInvoice) || const DeepCollectionEquality().equals(other.printNoteOnInvoice, printNoteOnInvoice)) &&
            (identical(other.printNoteOnOrder, printNoteOnOrder) || const DeepCollectionEquality().equals(other.printNoteOnOrder, printNoteOnOrder)) &&
            (identical(other.printNoteOnPickList, printNoteOnPickList) || const DeepCollectionEquality().equals(other.printNoteOnPickList, printNoteOnPickList)) &&
            (identical(other.printNoteOnPO, printNoteOnPO) || const DeepCollectionEquality().equals(other.printNoteOnPO, printNoteOnPO)) &&
            (identical(other.printNoteOnQuote, printNoteOnQuote) || const DeepCollectionEquality().equals(other.printNoteOnQuote, printNoteOnQuote)) &&
            (identical(other.printNoteOnReturnList, printNoteOnReturnList) || const DeepCollectionEquality().equals(other.printNoteOnReturnList, printNoteOnReturnList)) &&
            (identical(other.printNoteOnPoReceiveList, printNoteOnPoReceiveList) || const DeepCollectionEquality().equals(other.printNoteOnPoReceiveList, printNoteOnPoReceiveList)) &&
            (identical(other.printNoteOnPoReturnList, printNoteOnPoReturnList) || const DeepCollectionEquality().equals(other.printNoteOnPoReturnList, printNoteOnPoReturnList)) &&
            (identical(other.assetAccountId, assetAccountId) || const DeepCollectionEquality().equals(other.assetAccountId, assetAccountId)) &&
            (identical(other.assetAccountNo, assetAccountNo) || const DeepCollectionEquality().equals(other.assetAccountNo, assetAccountNo)) &&
            (identical(other.assetAccountDescription, assetAccountDescription) || const DeepCollectionEquality().equals(other.assetAccountDescription, assetAccountDescription)) &&
            (identical(other.incomeAccountId, incomeAccountId) || const DeepCollectionEquality().equals(other.incomeAccountId, incomeAccountId)) &&
            (identical(other.incomeAccountNo, incomeAccountNo) || const DeepCollectionEquality().equals(other.incomeAccountNo, incomeAccountNo)) &&
            (identical(other.incomeAccountDescription, incomeAccountDescription) || const DeepCollectionEquality().equals(other.incomeAccountDescription, incomeAccountDescription)) &&
            (identical(other.subIncomeAccountId, subIncomeAccountId) || const DeepCollectionEquality().equals(other.subIncomeAccountId, subIncomeAccountId)) &&
            (identical(other.subIncomeAccountNo, subIncomeAccountNo) || const DeepCollectionEquality().equals(other.subIncomeAccountNo, subIncomeAccountNo)) &&
            (identical(other.subIncomeAccountDescription, subIncomeAccountDescription) || const DeepCollectionEquality().equals(other.subIncomeAccountDescription, subIncomeAccountDescription)) &&
            (identical(other.consignmentIncomeAccountId, consignmentIncomeAccountId) || const DeepCollectionEquality().equals(other.consignmentIncomeAccountId, consignmentIncomeAccountId)) &&
            (identical(other.consignmentIncomeAccountNo, consignmentIncomeAccountNo) || const DeepCollectionEquality().equals(other.consignmentIncomeAccountNo, consignmentIncomeAccountNo)) &&
            (identical(other.consignmentIncomeAccountDescription, consignmentIncomeAccountDescription) || const DeepCollectionEquality().equals(other.consignmentIncomeAccountDescription, consignmentIncomeAccountDescription)) &&
            (identical(other.ldIncomeAccountId, ldIncomeAccountId) || const DeepCollectionEquality().equals(other.ldIncomeAccountId, ldIncomeAccountId)) &&
            (identical(other.ldIncomeAccountNo, ldIncomeAccountNo) || const DeepCollectionEquality().equals(other.ldIncomeAccountNo, ldIncomeAccountNo)) &&
            (identical(other.ldIncomeAccountDescription, ldIncomeAccountDescription) || const DeepCollectionEquality().equals(other.ldIncomeAccountDescription, ldIncomeAccountDescription)) &&
            (identical(other.equipmentSaleIncomeAccountId, equipmentSaleIncomeAccountId) || const DeepCollectionEquality().equals(other.equipmentSaleIncomeAccountId, equipmentSaleIncomeAccountId)) &&
            (identical(other.equipmentSaleIncomeAccountNo, equipmentSaleIncomeAccountNo) || const DeepCollectionEquality().equals(other.equipmentSaleIncomeAccountNo, equipmentSaleIncomeAccountNo)) &&
            (identical(other.equipmentSaleIncomeAccountDescription, equipmentSaleIncomeAccountDescription) || const DeepCollectionEquality().equals(other.equipmentSaleIncomeAccountDescription, equipmentSaleIncomeAccountDescription)) &&
            (identical(other.expenseAccountId, expenseAccountId) || const DeepCollectionEquality().equals(other.expenseAccountId, expenseAccountId)) &&
            (identical(other.expenseAccountNo, expenseAccountNo) || const DeepCollectionEquality().equals(other.expenseAccountNo, expenseAccountNo)) &&
            (identical(other.expenseAccountDescription, expenseAccountDescription) || const DeepCollectionEquality().equals(other.expenseAccountDescription, expenseAccountDescription)) &&
            (identical(other.costOfGoodsSoldExpenseAccountId, costOfGoodsSoldExpenseAccountId) || const DeepCollectionEquality().equals(other.costOfGoodsSoldExpenseAccountId, costOfGoodsSoldExpenseAccountId)) &&
            (identical(other.costOfGoodsSoldExpenseAccountNo, costOfGoodsSoldExpenseAccountNo) || const DeepCollectionEquality().equals(other.costOfGoodsSoldExpenseAccountNo, costOfGoodsSoldExpenseAccountNo)) &&
            (identical(other.costOfGoodsSoldExpenseAccountDescription, costOfGoodsSoldExpenseAccountDescription) || const DeepCollectionEquality().equals(other.costOfGoodsSoldExpenseAccountDescription, costOfGoodsSoldExpenseAccountDescription)) &&
            (identical(other.costOfGoodsRentedExpenseAccountId, costOfGoodsRentedExpenseAccountId) || const DeepCollectionEquality().equals(other.costOfGoodsRentedExpenseAccountId, costOfGoodsRentedExpenseAccountId)) &&
            (identical(other.costOfGoodsRentedExpenseAccountNo, costOfGoodsRentedExpenseAccountNo) || const DeepCollectionEquality().equals(other.costOfGoodsRentedExpenseAccountNo, costOfGoodsRentedExpenseAccountNo)) &&
            (identical(other.costOfGoodsRentedExpenseAccountDescription, costOfGoodsRentedExpenseAccountDescription) || const DeepCollectionEquality().equals(other.costOfGoodsRentedExpenseAccountDescription, costOfGoodsRentedExpenseAccountDescription)) &&
            (identical(other.depreciationExpenseAccountId, depreciationExpenseAccountId) || const DeepCollectionEquality().equals(other.depreciationExpenseAccountId, depreciationExpenseAccountId)) &&
            (identical(other.depreciationExpenseAccountNo, depreciationExpenseAccountNo) || const DeepCollectionEquality().equals(other.depreciationExpenseAccountNo, depreciationExpenseAccountNo)) &&
            (identical(other.depreciationExpenseAccountDescription, depreciationExpenseAccountDescription) || const DeepCollectionEquality().equals(other.depreciationExpenseAccountDescription, depreciationExpenseAccountDescription)) &&
            (identical(other.accumulatedDepreciationExpenseAccountId, accumulatedDepreciationExpenseAccountId) || const DeepCollectionEquality().equals(other.accumulatedDepreciationExpenseAccountId, accumulatedDepreciationExpenseAccountId)) &&
            (identical(other.accumulatedDepreciationExpenseAccountNo, accumulatedDepreciationExpenseAccountNo) || const DeepCollectionEquality().equals(other.accumulatedDepreciationExpenseAccountNo, accumulatedDepreciationExpenseAccountNo)) &&
            (identical(other.accumulatedDepreciationExpenseAccountDescription, accumulatedDepreciationExpenseAccountDescription) || const DeepCollectionEquality().equals(other.accumulatedDepreciationExpenseAccountDescription, accumulatedDepreciationExpenseAccountDescription)) &&
            (identical(other.originalShowId, originalShowId) || const DeepCollectionEquality().equals(other.originalShowId, originalShowId)) &&
            (identical(other.inactive, inactive) || const DeepCollectionEquality().equals(other.inactive, inactive)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.manifestShippingContainer, manifestShippingContainer) || const DeepCollectionEquality().equals(other.manifestShippingContainer, manifestShippingContainer)) &&
            (identical(other.manifestStandAloneItem, manifestStandAloneItem) || const DeepCollectionEquality().equals(other.manifestStandAloneItem, manifestStandAloneItem)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesInventorySalesInventorySalesInventoryExtension
    on WebApiModulesInventorySalesInventorySalesInventory {
  WebApiModulesInventorySalesInventorySalesInventory copyWith(
      {double? price,
      double? defaultCost,
      double? averageCost,
      String? inventoryId,
      String? inventoryTypeId,
      String? inventoryType,
      String? availableFrom,
      String? trackedBy,
      String? confirmTrackedBy,
      String? rank,
      String? manufacturerPartNumber,
      String? manufacturerId,
      String? manufacturer,
      String? manufacturerUrl,
      bool? excludeImageFromQuoteOrderPrint,
      bool? noAvailabilityCheck,
      bool? availabilityManuallyResolveConflicts,
      bool? sendAvailabilityAlert,
      String? primaryDimensionUniqueId,
      String? defaultImperialMetric,
      String? primaryDimensionDescription,
      int? primaryDimensionShipWeightLbs,
      int? primaryDimensionShipWeightOz,
      int? primaryDimensionWeightInCaseLbs,
      int? primaryDimensionWeightInCaseOz,
      int? primaryDimensionWidthFt,
      int? primaryDimensionWidthIn,
      int? primaryDimensionHeightFt,
      int? primaryDimensionHeightIn,
      int? primaryDimensionLengthFt,
      int? primaryDimensionLengthIn,
      int? primaryDimensionShipWeightKg,
      int? primaryDimensionShipWeightG,
      int? primaryDimensionWeightInCaseKg,
      int? primaryDimensionWeightInCaseG,
      int? primaryDimensionWidthM,
      int? primaryDimensionWidthCm,
      int? primaryDimensionHeightM,
      int? primaryDimensionHeightCm,
      int? primaryDimensionLengthM,
      int? primaryDimensionLengthCm,
      bool? hasSecondaryDimensions,
      String? secondaryDimensionUniqueId,
      String? secondaryDimensionDescription,
      int? secondaryDimensionShipWeightLbs,
      int? secondaryDimensionShipWeightOz,
      int? secondaryDimensionWeightInCaseLbs,
      int? secondaryDimensionWeightInCaseOz,
      int? secondaryDimensionWidthFt,
      int? secondaryDimensionWidthIn,
      int? secondaryDimensionHeightFt,
      int? secondaryDimensionHeightIn,
      int? secondaryDimensionLengthFt,
      int? secondaryDimensionLengthIn,
      int? secondaryDimensionShipWeightKg,
      int? secondaryDimensionShipWeightG,
      int? secondaryDimensionWeightInCaseKg,
      int? secondaryDimensionWeightInCaseG,
      int? secondaryDimensionWidthM,
      int? secondaryDimensionWidthCm,
      int? secondaryDimensionHeightM,
      int? secondaryDimensionHeightCm,
      int? secondaryDimensionLengthM,
      int? secondaryDimensionLengthCm,
      String? countryOfOriginId,
      String? countryOfOrigin,
      bool? displayInSummaryModeWhenRateIsZero,
      bool? qcRequired,
      String? qcTime,
      bool? copyAttributesAsNote,
      bool? trackAssetUsage,
      bool? trackLampUsage,
      bool? trackStrikes,
      bool? trackCandles,
      int? lampCount,
      int? minimumFootCandles,
      bool? trackSoftware,
      String? softwareVersion,
      String? softwareEffectiveDate,
      bool? warehouseSpecificPackage,
      String? completePackagePrice,
      String? kitPackagePrice,
      bool? separatePackageOnQuoteOrder,
      String? containerId,
      String? containerScannableInventoryId,
      String? containerScannableICode,
      String? containerScannableDescription,
      bool? automaticallyRebuildContainerAtCheckIn,
      bool? automaticallyRebuildContainerAtTransferIn,
      String? containerStagingRule,
      bool? excludeContainedItemsFromAvailability,
      bool? useContainerNumber,
      String? containerPackingListBehavior,
      bool? inventoryTypeIsWardrobe,
      bool? inventoryTypeIsSets,
      String? patternId,
      String? pattern,
      String? periodId,
      String? period,
      String? materialId,
      String? material,
      String? genderId,
      String? gender,
      String? labelId,
      String? label,
      String? wardrobeSize,
      int? wardrobePieceCount,
      bool? dyed,
      String? wardrobeSourceId,
      String? wardrobeSource,
      String? wardrobeCareId,
      String? wardrobeCare,
      double? cleaningFeeAmount,
      String? wardrobeDetailedDescription,
      String? webDetailedDescription,
      bool? overrideSystemDefaultRevenueAllocationBehavior,
      bool? allocateRevenueForAccessories,
      String? packageRevenueCalculationFormula,
      bool? isHazardousMaterial,
      String? descriptionWithAkas,
      String? costCalculation,
      double? quantity,
      String? aisleLocation,
      String? shelfLocation,
      bool? taxable,
      String? iCode,
      String? description,
      String? availFor,
      String? categoryId,
      String? category,
      int? subCategoryCount,
      String? subCategoryId,
      String? subCategory,
      String? classification,
      String? classificationDescription,
      String? classificationColor,
      String? unitId,
      String? unit,
      String? unitType,
      bool? nonDiscountable,
      bool? overrideProfitAndLossCategory,
      String? profitAndLossCategoryId,
      String? profitAndLossCategory,
      bool? autoCopyNotesToQuoteOrder,
      String? note,
      bool? printNoteOnInContract,
      bool? printNoteOnOutContract,
      bool? printNoteOnReceiveContract,
      bool? printNoteOnReturnContract,
      bool? printNoteOnInvoice,
      bool? printNoteOnOrder,
      bool? printNoteOnPickList,
      bool? printNoteOnPO,
      bool? printNoteOnQuote,
      bool? printNoteOnReturnList,
      bool? printNoteOnPoReceiveList,
      bool? printNoteOnPoReturnList,
      String? assetAccountId,
      String? assetAccountNo,
      String? assetAccountDescription,
      String? incomeAccountId,
      String? incomeAccountNo,
      String? incomeAccountDescription,
      String? subIncomeAccountId,
      String? subIncomeAccountNo,
      String? subIncomeAccountDescription,
      String? consignmentIncomeAccountId,
      String? consignmentIncomeAccountNo,
      String? consignmentIncomeAccountDescription,
      String? ldIncomeAccountId,
      String? ldIncomeAccountNo,
      String? ldIncomeAccountDescription,
      String? equipmentSaleIncomeAccountId,
      String? equipmentSaleIncomeAccountNo,
      String? equipmentSaleIncomeAccountDescription,
      String? expenseAccountId,
      String? expenseAccountNo,
      String? expenseAccountDescription,
      String? costOfGoodsSoldExpenseAccountId,
      String? costOfGoodsSoldExpenseAccountNo,
      String? costOfGoodsSoldExpenseAccountDescription,
      String? costOfGoodsRentedExpenseAccountId,
      String? costOfGoodsRentedExpenseAccountNo,
      String? costOfGoodsRentedExpenseAccountDescription,
      String? depreciationExpenseAccountId,
      String? depreciationExpenseAccountNo,
      String? depreciationExpenseAccountDescription,
      String? accumulatedDepreciationExpenseAccountId,
      String? accumulatedDepreciationExpenseAccountNo,
      String? accumulatedDepreciationExpenseAccountDescription,
      String? originalShowId,
      bool? inactive,
      String? dateStamp,
      bool? manifestShippingContainer,
      bool? manifestStandAloneItem,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesInventorySalesInventorySalesInventory(
        price: price ?? this.price,
        defaultCost: defaultCost ?? this.defaultCost,
        averageCost: averageCost ?? this.averageCost,
        inventoryId: inventoryId ?? this.inventoryId,
        inventoryTypeId: inventoryTypeId ?? this.inventoryTypeId,
        inventoryType: inventoryType ?? this.inventoryType,
        availableFrom: availableFrom ?? this.availableFrom,
        trackedBy: trackedBy ?? this.trackedBy,
        confirmTrackedBy: confirmTrackedBy ?? this.confirmTrackedBy,
        rank: rank ?? this.rank,
        manufacturerPartNumber:
            manufacturerPartNumber ?? this.manufacturerPartNumber,
        manufacturerId: manufacturerId ?? this.manufacturerId,
        manufacturer: manufacturer ?? this.manufacturer,
        manufacturerUrl: manufacturerUrl ?? this.manufacturerUrl,
        excludeImageFromQuoteOrderPrint: excludeImageFromQuoteOrderPrint ??
            this.excludeImageFromQuoteOrderPrint,
        noAvailabilityCheck: noAvailabilityCheck ?? this.noAvailabilityCheck,
        availabilityManuallyResolveConflicts: availabilityManuallyResolveConflicts ??
            this.availabilityManuallyResolveConflicts,
        sendAvailabilityAlert:
            sendAvailabilityAlert ?? this.sendAvailabilityAlert,
        primaryDimensionUniqueId:
            primaryDimensionUniqueId ?? this.primaryDimensionUniqueId,
        defaultImperialMetric:
            defaultImperialMetric ?? this.defaultImperialMetric,
        primaryDimensionDescription:
            primaryDimensionDescription ?? this.primaryDimensionDescription,
        primaryDimensionShipWeightLbs:
            primaryDimensionShipWeightLbs ?? this.primaryDimensionShipWeightLbs,
        primaryDimensionShipWeightOz:
            primaryDimensionShipWeightOz ?? this.primaryDimensionShipWeightOz,
        primaryDimensionWeightInCaseLbs: primaryDimensionWeightInCaseLbs ??
            this.primaryDimensionWeightInCaseLbs,
        primaryDimensionWeightInCaseOz: primaryDimensionWeightInCaseOz ??
            this.primaryDimensionWeightInCaseOz,
        primaryDimensionWidthFt:
            primaryDimensionWidthFt ?? this.primaryDimensionWidthFt,
        primaryDimensionWidthIn:
            primaryDimensionWidthIn ?? this.primaryDimensionWidthIn,
        primaryDimensionHeightFt:
            primaryDimensionHeightFt ?? this.primaryDimensionHeightFt,
        primaryDimensionHeightIn:
            primaryDimensionHeightIn ?? this.primaryDimensionHeightIn,
        primaryDimensionLengthFt:
            primaryDimensionLengthFt ?? this.primaryDimensionLengthFt,
        primaryDimensionLengthIn:
            primaryDimensionLengthIn ?? this.primaryDimensionLengthIn,
        primaryDimensionShipWeightKg:
            primaryDimensionShipWeightKg ?? this.primaryDimensionShipWeightKg,
        primaryDimensionShipWeightG:
            primaryDimensionShipWeightG ?? this.primaryDimensionShipWeightG,
        primaryDimensionWeightInCaseKg: primaryDimensionWeightInCaseKg ??
            this.primaryDimensionWeightInCaseKg,
        primaryDimensionWeightInCaseG:
            primaryDimensionWeightInCaseG ?? this.primaryDimensionWeightInCaseG,
        primaryDimensionWidthM:
            primaryDimensionWidthM ?? this.primaryDimensionWidthM,
        primaryDimensionWidthCm:
            primaryDimensionWidthCm ?? this.primaryDimensionWidthCm,
        primaryDimensionHeightM:
            primaryDimensionHeightM ?? this.primaryDimensionHeightM,
        primaryDimensionHeightCm:
            primaryDimensionHeightCm ?? this.primaryDimensionHeightCm,
        primaryDimensionLengthM:
            primaryDimensionLengthM ?? this.primaryDimensionLengthM,
        primaryDimensionLengthCm:
            primaryDimensionLengthCm ?? this.primaryDimensionLengthCm,
        hasSecondaryDimensions:
            hasSecondaryDimensions ?? this.hasSecondaryDimensions,
        secondaryDimensionUniqueId:
            secondaryDimensionUniqueId ?? this.secondaryDimensionUniqueId,
        secondaryDimensionDescription:
            secondaryDimensionDescription ?? this.secondaryDimensionDescription,
        secondaryDimensionShipWeightLbs: secondaryDimensionShipWeightLbs ??
            this.secondaryDimensionShipWeightLbs,
        secondaryDimensionShipWeightOz: secondaryDimensionShipWeightOz ??
            this.secondaryDimensionShipWeightOz,
        secondaryDimensionWeightInCaseLbs: secondaryDimensionWeightInCaseLbs ??
            this.secondaryDimensionWeightInCaseLbs,
        secondaryDimensionWeightInCaseOz: secondaryDimensionWeightInCaseOz ??
            this.secondaryDimensionWeightInCaseOz,
        secondaryDimensionWidthFt:
            secondaryDimensionWidthFt ?? this.secondaryDimensionWidthFt,
        secondaryDimensionWidthIn:
            secondaryDimensionWidthIn ?? this.secondaryDimensionWidthIn,
        secondaryDimensionHeightFt:
            secondaryDimensionHeightFt ?? this.secondaryDimensionHeightFt,
        secondaryDimensionHeightIn:
            secondaryDimensionHeightIn ?? this.secondaryDimensionHeightIn,
        secondaryDimensionLengthFt:
            secondaryDimensionLengthFt ?? this.secondaryDimensionLengthFt,
        secondaryDimensionLengthIn:
            secondaryDimensionLengthIn ?? this.secondaryDimensionLengthIn,
        secondaryDimensionShipWeightKg: secondaryDimensionShipWeightKg ??
            this.secondaryDimensionShipWeightKg,
        secondaryDimensionShipWeightG:
            secondaryDimensionShipWeightG ?? this.secondaryDimensionShipWeightG,
        secondaryDimensionWeightInCaseKg: secondaryDimensionWeightInCaseKg ??
            this.secondaryDimensionWeightInCaseKg,
        secondaryDimensionWeightInCaseG: secondaryDimensionWeightInCaseG ??
            this.secondaryDimensionWeightInCaseG,
        secondaryDimensionWidthM:
            secondaryDimensionWidthM ?? this.secondaryDimensionWidthM,
        secondaryDimensionWidthCm:
            secondaryDimensionWidthCm ?? this.secondaryDimensionWidthCm,
        secondaryDimensionHeightM:
            secondaryDimensionHeightM ?? this.secondaryDimensionHeightM,
        secondaryDimensionHeightCm:
            secondaryDimensionHeightCm ?? this.secondaryDimensionHeightCm,
        secondaryDimensionLengthM:
            secondaryDimensionLengthM ?? this.secondaryDimensionLengthM,
        secondaryDimensionLengthCm:
            secondaryDimensionLengthCm ?? this.secondaryDimensionLengthCm,
        countryOfOriginId: countryOfOriginId ?? this.countryOfOriginId,
        countryOfOrigin: countryOfOrigin ?? this.countryOfOrigin,
        displayInSummaryModeWhenRateIsZero: displayInSummaryModeWhenRateIsZero ??
            this.displayInSummaryModeWhenRateIsZero,
        qcRequired: qcRequired ?? this.qcRequired,
        qcTime: qcTime ?? this.qcTime,
        copyAttributesAsNote: copyAttributesAsNote ?? this.copyAttributesAsNote,
        trackAssetUsage: trackAssetUsage ?? this.trackAssetUsage,
        trackLampUsage: trackLampUsage ?? this.trackLampUsage,
        trackStrikes: trackStrikes ?? this.trackStrikes,
        trackCandles: trackCandles ?? this.trackCandles,
        lampCount: lampCount ?? this.lampCount,
        minimumFootCandles: minimumFootCandles ?? this.minimumFootCandles,
        trackSoftware: trackSoftware ?? this.trackSoftware,
        softwareVersion: softwareVersion ?? this.softwareVersion,
        softwareEffectiveDate:
            softwareEffectiveDate ?? this.softwareEffectiveDate,
        warehouseSpecificPackage:
            warehouseSpecificPackage ?? this.warehouseSpecificPackage,
        completePackagePrice: completePackagePrice ?? this.completePackagePrice,
        kitPackagePrice: kitPackagePrice ?? this.kitPackagePrice,
        separatePackageOnQuoteOrder:
            separatePackageOnQuoteOrder ?? this.separatePackageOnQuoteOrder,
        containerId: containerId ?? this.containerId,
        containerScannableInventoryId:
            containerScannableInventoryId ?? this.containerScannableInventoryId,
        containerScannableICode:
            containerScannableICode ?? this.containerScannableICode,
        containerScannableDescription:
            containerScannableDescription ?? this.containerScannableDescription,
        automaticallyRebuildContainerAtCheckIn: automaticallyRebuildContainerAtCheckIn ??
            this.automaticallyRebuildContainerAtCheckIn,
        automaticallyRebuildContainerAtTransferIn: automaticallyRebuildContainerAtTransferIn ??
            this.automaticallyRebuildContainerAtTransferIn,
        containerStagingRule: containerStagingRule ?? this.containerStagingRule,
        excludeContainedItemsFromAvailability: excludeContainedItemsFromAvailability ?? this.excludeContainedItemsFromAvailability,
        useContainerNumber: useContainerNumber ?? this.useContainerNumber,
        containerPackingListBehavior: containerPackingListBehavior ?? this.containerPackingListBehavior,
        inventoryTypeIsWardrobe: inventoryTypeIsWardrobe ?? this.inventoryTypeIsWardrobe,
        inventoryTypeIsSets: inventoryTypeIsSets ?? this.inventoryTypeIsSets,
        patternId: patternId ?? this.patternId,
        pattern: pattern ?? this.pattern,
        periodId: periodId ?? this.periodId,
        period: period ?? this.period,
        materialId: materialId ?? this.materialId,
        material: material ?? this.material,
        genderId: genderId ?? this.genderId,
        gender: gender ?? this.gender,
        labelId: labelId ?? this.labelId,
        label: label ?? this.label,
        wardrobeSize: wardrobeSize ?? this.wardrobeSize,
        wardrobePieceCount: wardrobePieceCount ?? this.wardrobePieceCount,
        dyed: dyed ?? this.dyed,
        wardrobeSourceId: wardrobeSourceId ?? this.wardrobeSourceId,
        wardrobeSource: wardrobeSource ?? this.wardrobeSource,
        wardrobeCareId: wardrobeCareId ?? this.wardrobeCareId,
        wardrobeCare: wardrobeCare ?? this.wardrobeCare,
        cleaningFeeAmount: cleaningFeeAmount ?? this.cleaningFeeAmount,
        wardrobeDetailedDescription: wardrobeDetailedDescription ?? this.wardrobeDetailedDescription,
        webDetailedDescription: webDetailedDescription ?? this.webDetailedDescription,
        overrideSystemDefaultRevenueAllocationBehavior: overrideSystemDefaultRevenueAllocationBehavior ?? this.overrideSystemDefaultRevenueAllocationBehavior,
        allocateRevenueForAccessories: allocateRevenueForAccessories ?? this.allocateRevenueForAccessories,
        packageRevenueCalculationFormula: packageRevenueCalculationFormula ?? this.packageRevenueCalculationFormula,
        isHazardousMaterial: isHazardousMaterial ?? this.isHazardousMaterial,
        descriptionWithAkas: descriptionWithAkas ?? this.descriptionWithAkas,
        costCalculation: costCalculation ?? this.costCalculation,
        quantity: quantity ?? this.quantity,
        aisleLocation: aisleLocation ?? this.aisleLocation,
        shelfLocation: shelfLocation ?? this.shelfLocation,
        taxable: taxable ?? this.taxable,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        availFor: availFor ?? this.availFor,
        categoryId: categoryId ?? this.categoryId,
        category: category ?? this.category,
        subCategoryCount: subCategoryCount ?? this.subCategoryCount,
        subCategoryId: subCategoryId ?? this.subCategoryId,
        subCategory: subCategory ?? this.subCategory,
        classification: classification ?? this.classification,
        classificationDescription: classificationDescription ?? this.classificationDescription,
        classificationColor: classificationColor ?? this.classificationColor,
        unitId: unitId ?? this.unitId,
        unit: unit ?? this.unit,
        unitType: unitType ?? this.unitType,
        nonDiscountable: nonDiscountable ?? this.nonDiscountable,
        overrideProfitAndLossCategory: overrideProfitAndLossCategory ?? this.overrideProfitAndLossCategory,
        profitAndLossCategoryId: profitAndLossCategoryId ?? this.profitAndLossCategoryId,
        profitAndLossCategory: profitAndLossCategory ?? this.profitAndLossCategory,
        autoCopyNotesToQuoteOrder: autoCopyNotesToQuoteOrder ?? this.autoCopyNotesToQuoteOrder,
        note: note ?? this.note,
        printNoteOnInContract: printNoteOnInContract ?? this.printNoteOnInContract,
        printNoteOnOutContract: printNoteOnOutContract ?? this.printNoteOnOutContract,
        printNoteOnReceiveContract: printNoteOnReceiveContract ?? this.printNoteOnReceiveContract,
        printNoteOnReturnContract: printNoteOnReturnContract ?? this.printNoteOnReturnContract,
        printNoteOnInvoice: printNoteOnInvoice ?? this.printNoteOnInvoice,
        printNoteOnOrder: printNoteOnOrder ?? this.printNoteOnOrder,
        printNoteOnPickList: printNoteOnPickList ?? this.printNoteOnPickList,
        printNoteOnPO: printNoteOnPO ?? this.printNoteOnPO,
        printNoteOnQuote: printNoteOnQuote ?? this.printNoteOnQuote,
        printNoteOnReturnList: printNoteOnReturnList ?? this.printNoteOnReturnList,
        printNoteOnPoReceiveList: printNoteOnPoReceiveList ?? this.printNoteOnPoReceiveList,
        printNoteOnPoReturnList: printNoteOnPoReturnList ?? this.printNoteOnPoReturnList,
        assetAccountId: assetAccountId ?? this.assetAccountId,
        assetAccountNo: assetAccountNo ?? this.assetAccountNo,
        assetAccountDescription: assetAccountDescription ?? this.assetAccountDescription,
        incomeAccountId: incomeAccountId ?? this.incomeAccountId,
        incomeAccountNo: incomeAccountNo ?? this.incomeAccountNo,
        incomeAccountDescription: incomeAccountDescription ?? this.incomeAccountDescription,
        subIncomeAccountId: subIncomeAccountId ?? this.subIncomeAccountId,
        subIncomeAccountNo: subIncomeAccountNo ?? this.subIncomeAccountNo,
        subIncomeAccountDescription: subIncomeAccountDescription ?? this.subIncomeAccountDescription,
        consignmentIncomeAccountId: consignmentIncomeAccountId ?? this.consignmentIncomeAccountId,
        consignmentIncomeAccountNo: consignmentIncomeAccountNo ?? this.consignmentIncomeAccountNo,
        consignmentIncomeAccountDescription: consignmentIncomeAccountDescription ?? this.consignmentIncomeAccountDescription,
        ldIncomeAccountId: ldIncomeAccountId ?? this.ldIncomeAccountId,
        ldIncomeAccountNo: ldIncomeAccountNo ?? this.ldIncomeAccountNo,
        ldIncomeAccountDescription: ldIncomeAccountDescription ?? this.ldIncomeAccountDescription,
        equipmentSaleIncomeAccountId: equipmentSaleIncomeAccountId ?? this.equipmentSaleIncomeAccountId,
        equipmentSaleIncomeAccountNo: equipmentSaleIncomeAccountNo ?? this.equipmentSaleIncomeAccountNo,
        equipmentSaleIncomeAccountDescription: equipmentSaleIncomeAccountDescription ?? this.equipmentSaleIncomeAccountDescription,
        expenseAccountId: expenseAccountId ?? this.expenseAccountId,
        expenseAccountNo: expenseAccountNo ?? this.expenseAccountNo,
        expenseAccountDescription: expenseAccountDescription ?? this.expenseAccountDescription,
        costOfGoodsSoldExpenseAccountId: costOfGoodsSoldExpenseAccountId ?? this.costOfGoodsSoldExpenseAccountId,
        costOfGoodsSoldExpenseAccountNo: costOfGoodsSoldExpenseAccountNo ?? this.costOfGoodsSoldExpenseAccountNo,
        costOfGoodsSoldExpenseAccountDescription: costOfGoodsSoldExpenseAccountDescription ?? this.costOfGoodsSoldExpenseAccountDescription,
        costOfGoodsRentedExpenseAccountId: costOfGoodsRentedExpenseAccountId ?? this.costOfGoodsRentedExpenseAccountId,
        costOfGoodsRentedExpenseAccountNo: costOfGoodsRentedExpenseAccountNo ?? this.costOfGoodsRentedExpenseAccountNo,
        costOfGoodsRentedExpenseAccountDescription: costOfGoodsRentedExpenseAccountDescription ?? this.costOfGoodsRentedExpenseAccountDescription,
        depreciationExpenseAccountId: depreciationExpenseAccountId ?? this.depreciationExpenseAccountId,
        depreciationExpenseAccountNo: depreciationExpenseAccountNo ?? this.depreciationExpenseAccountNo,
        depreciationExpenseAccountDescription: depreciationExpenseAccountDescription ?? this.depreciationExpenseAccountDescription,
        accumulatedDepreciationExpenseAccountId: accumulatedDepreciationExpenseAccountId ?? this.accumulatedDepreciationExpenseAccountId,
        accumulatedDepreciationExpenseAccountNo: accumulatedDepreciationExpenseAccountNo ?? this.accumulatedDepreciationExpenseAccountNo,
        accumulatedDepreciationExpenseAccountDescription: accumulatedDepreciationExpenseAccountDescription ?? this.accumulatedDepreciationExpenseAccountDescription,
        originalShowId: originalShowId ?? this.originalShowId,
        inactive: inactive ?? this.inactive,
        dateStamp: dateStamp ?? this.dateStamp,
        manifestShippingContainer: manifestShippingContainer ?? this.manifestShippingContainer,
        manifestStandAloneItem: manifestStandAloneItem ?? this.manifestStandAloneItem,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes: defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventorySalesInventorySalesInventoryDocument {
  WebApiModulesInventorySalesInventorySalesInventoryDocument({
    this.inventoryId,
    this.copying,
    this.documentId,
    this.documentTypeId,
    this.uniqueId1,
    this.uniqueId2,
    this.uniqueId1Int,
    this.description,
    this.inputByUsersId,
    this.attachDate,
    this.attachTime,
    this.attachToEmail,
    this.inactive,
    this.dateStamp,
    this.extension,
    this.documentType,
    this.inputBy,
    this.hasImage,
    this.hasFile,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesInventorySalesInventorySalesInventoryDocument.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventorySalesInventorySalesInventoryDocumentFromJson(
          json);

  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'copying')
  final bool? copying;
  @JsonKey(name: 'DocumentId')
  final String? documentId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'UniqueId1')
  final String? uniqueId1;
  @JsonKey(name: 'UniqueId2')
  final String? uniqueId2;
  @JsonKey(name: 'UniqueId1Int')
  final int? uniqueId1Int;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'InputByUsersId')
  final String? inputByUsersId;
  @JsonKey(name: 'AttachDate')
  final String? attachDate;
  @JsonKey(name: 'AttachTime')
  final String? attachTime;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'Extension')
  final String? extension;
  @JsonKey(name: 'DocumentType')
  final String? documentType;
  @JsonKey(name: 'InputBy')
  final String? inputBy;
  @JsonKey(name: 'HasImage')
  final bool? hasImage;
  @JsonKey(name: 'HasFile')
  final bool? hasFile;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesInventorySalesInventorySalesInventoryDocumentFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventorySalesInventorySalesInventoryDocumentToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventorySalesInventorySalesInventoryDocumentToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventorySalesInventorySalesInventoryDocument &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.copying, copying) ||
                const DeepCollectionEquality()
                    .equals(other.copying, copying)) &&
            (identical(other.documentId, documentId) ||
                const DeepCollectionEquality()
                    .equals(other.documentId, documentId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.uniqueId1, uniqueId1) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1, uniqueId1)) &&
            (identical(other.uniqueId2, uniqueId2) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId2, uniqueId2)) &&
            (identical(other.uniqueId1Int, uniqueId1Int) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1Int, uniqueId1Int)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.inputByUsersId, inputByUsersId) ||
                const DeepCollectionEquality()
                    .equals(other.inputByUsersId, inputByUsersId)) &&
            (identical(other.attachDate, attachDate) ||
                const DeepCollectionEquality()
                    .equals(other.attachDate, attachDate)) &&
            (identical(other.attachTime, attachTime) ||
                const DeepCollectionEquality()
                    .equals(other.attachTime, attachTime)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.extension, extension) ||
                const DeepCollectionEquality()
                    .equals(other.extension, extension)) &&
            (identical(other.documentType, documentType) ||
                const DeepCollectionEquality()
                    .equals(other.documentType, documentType)) &&
            (identical(other.inputBy, inputBy) ||
                const DeepCollectionEquality()
                    .equals(other.inputBy, inputBy)) &&
            (identical(other.hasImage, hasImage) ||
                const DeepCollectionEquality()
                    .equals(other.hasImage, hasImage)) &&
            (identical(other.hasFile, hasFile) ||
                const DeepCollectionEquality()
                    .equals(other.hasFile, hasFile)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality().equals(other.filePath, filePath)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesInventorySalesInventorySalesInventoryDocumentExtension
    on WebApiModulesInventorySalesInventorySalesInventoryDocument {
  WebApiModulesInventorySalesInventorySalesInventoryDocument copyWith(
      {String? inventoryId,
      bool? copying,
      String? documentId,
      String? documentTypeId,
      String? uniqueId1,
      String? uniqueId2,
      int? uniqueId1Int,
      String? description,
      String? inputByUsersId,
      String? attachDate,
      String? attachTime,
      bool? attachToEmail,
      bool? inactive,
      String? dateStamp,
      String? extension,
      String? documentType,
      String? inputBy,
      bool? hasImage,
      bool? hasFile,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesInventorySalesInventorySalesInventoryDocument(
        inventoryId: inventoryId ?? this.inventoryId,
        copying: copying ?? this.copying,
        documentId: documentId ?? this.documentId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        uniqueId1: uniqueId1 ?? this.uniqueId1,
        uniqueId2: uniqueId2 ?? this.uniqueId2,
        uniqueId1Int: uniqueId1Int ?? this.uniqueId1Int,
        description: description ?? this.description,
        inputByUsersId: inputByUsersId ?? this.inputByUsersId,
        attachDate: attachDate ?? this.attachDate,
        attachTime: attachTime ?? this.attachTime,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        dateStamp: dateStamp ?? this.dateStamp,
        extension: extension ?? this.extension,
        documentType: documentType ?? this.documentType,
        inputBy: inputBy ?? this.inputBy,
        hasImage: hasImage ?? this.hasImage,
        hasFile: hasFile ?? this.hasFile,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventorySalesInventorySalesInventoryDocumentPostRequest {
  WebApiModulesInventorySalesInventorySalesInventoryDocumentPostRequest({
    this.inventoryId,
    this.documentTypeId,
    this.description,
    this.attachToEmail,
    this.inactive,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
  });

  factory WebApiModulesInventorySalesInventorySalesInventoryDocumentPostRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventorySalesInventorySalesInventoryDocumentPostRequestFromJson(
          json);

  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  static const fromJsonFactory =
      _$WebApiModulesInventorySalesInventorySalesInventoryDocumentPostRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventorySalesInventorySalesInventoryDocumentPostRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventorySalesInventorySalesInventoryDocumentPostRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventorySalesInventorySalesInventoryDocumentPostRequest &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)));
  }
}

extension $WebApiModulesInventorySalesInventorySalesInventoryDocumentPostRequestExtension
    on WebApiModulesInventorySalesInventorySalesInventoryDocumentPostRequest {
  WebApiModulesInventorySalesInventorySalesInventoryDocumentPostRequest
      copyWith(
          {String? inventoryId,
          String? documentTypeId,
          String? description,
          bool? attachToEmail,
          bool? inactive,
          bool? fileIsModified,
          String? fileDataUrl,
          String? filePath}) {
    return WebApiModulesInventorySalesInventorySalesInventoryDocumentPostRequest(
        inventoryId: inventoryId ?? this.inventoryId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        description: description ?? this.description,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesInventorySalesInventorySalesInventoryDocumentPutRequest {
  WebApiModulesInventorySalesInventorySalesInventoryDocumentPutRequest({
    this.inventoryId,
    this.documentId,
    this.documentTypeId,
    this.description,
    this.attachToEmail,
    this.inactive,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
  });

  factory WebApiModulesInventorySalesInventorySalesInventoryDocumentPutRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesInventorySalesInventorySalesInventoryDocumentPutRequestFromJson(
          json);

  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'DocumentId')
  final String? documentId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  static const fromJsonFactory =
      _$WebApiModulesInventorySalesInventorySalesInventoryDocumentPutRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesInventorySalesInventorySalesInventoryDocumentPutRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesInventorySalesInventorySalesInventoryDocumentPutRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesInventorySalesInventorySalesInventoryDocumentPutRequest &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.documentId, documentId) ||
                const DeepCollectionEquality()
                    .equals(other.documentId, documentId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)));
  }
}

extension $WebApiModulesInventorySalesInventorySalesInventoryDocumentPutRequestExtension
    on WebApiModulesInventorySalesInventorySalesInventoryDocumentPutRequest {
  WebApiModulesInventorySalesInventorySalesInventoryDocumentPutRequest copyWith(
      {String? inventoryId,
      String? documentId,
      String? documentTypeId,
      String? description,
      bool? attachToEmail,
      bool? inactive,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath}) {
    return WebApiModulesInventorySalesInventorySalesInventoryDocumentPutRequest(
        inventoryId: inventoryId ?? this.inventoryId,
        documentId: documentId ?? this.documentId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        description: description ?? this.description,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesPluginsProcessCreditCardProcessCreditCardInfo {
  WebApiModulesPluginsProcessCreditCardProcessCreditCardInfo({
    this.recordTitle,
    this.orderId,
    this.orderNumber,
    this.orderDescription,
    this.dealId,
    this.dealNumber,
    this.deal,
    this.customerNumber,
    this.customer,
    this.pINPadType,
    this.totalsWeeklyGrossTotal,
    this.totalsWeeklyDiscount,
    this.totalsWeeklySubTotal,
    this.totalsWeeklyTax,
    this.totalsWeeklyGrandTotal,
    this.totalsPeriodGrossTotal,
    this.totalsPeriodDiscount,
    this.totalsPeriodSubTotal,
    this.totalsPeriodTax,
    this.totalsPeriodGrandTotal,
    this.totalsReplacementReplacementCost,
    this.totalsReplacementDepositPercentage,
    this.totalsReplacementDepositDue,
    this.paymentTotalAmount,
    this.paymentAmountToPay,
    this.pINPadCode,
    this.pINPadDescription,
    this.locationCode,
    this.agentBarcode,
    this.currencyId,
    this.locationId,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesPluginsProcessCreditCardProcessCreditCardInfo.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesPluginsProcessCreditCardProcessCreditCardInfoFromJson(
          json);

  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderNumber')
  final String? orderNumber;
  @JsonKey(name: 'OrderDescription')
  final String? orderDescription;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'DealNumber')
  final String? dealNumber;
  @JsonKey(name: 'Deal')
  final String? deal;
  @JsonKey(name: 'CustomerNumber')
  final String? customerNumber;
  @JsonKey(name: 'Customer')
  final String? customer;
  @JsonKey(name: 'PINPad_Type')
  final String? pINPadType;
  @JsonKey(name: 'Totals_Weekly_GrossTotal')
  final double? totalsWeeklyGrossTotal;
  @JsonKey(name: 'Totals_Weekly_Discount')
  final double? totalsWeeklyDiscount;
  @JsonKey(name: 'Totals_Weekly_SubTotal')
  final double? totalsWeeklySubTotal;
  @JsonKey(name: 'Totals_Weekly_Tax')
  final double? totalsWeeklyTax;
  @JsonKey(name: 'Totals_Weekly_GrandTotal')
  final double? totalsWeeklyGrandTotal;
  @JsonKey(name: 'Totals_Period_GrossTotal')
  final double? totalsPeriodGrossTotal;
  @JsonKey(name: 'Totals_Period_Discount')
  final double? totalsPeriodDiscount;
  @JsonKey(name: 'Totals_Period_SubTotal')
  final double? totalsPeriodSubTotal;
  @JsonKey(name: 'Totals_Period_Tax')
  final double? totalsPeriodTax;
  @JsonKey(name: 'Totals_Period_GrandTotal')
  final double? totalsPeriodGrandTotal;
  @JsonKey(name: 'Totals_Replacement_ReplacementCost')
  final double? totalsReplacementReplacementCost;
  @JsonKey(name: 'Totals_Replacement_DepositPercentage')
  final double? totalsReplacementDepositPercentage;
  @JsonKey(name: 'Totals_Replacement_DepositDue')
  final double? totalsReplacementDepositDue;
  @JsonKey(name: 'Payment_TotalAmount')
  final double? paymentTotalAmount;
  @JsonKey(name: 'Payment_AmountToPay')
  final double? paymentAmountToPay;
  @JsonKey(name: 'PINPad_Code')
  final String? pINPadCode;
  @JsonKey(name: 'PINPad_Description')
  final String? pINPadDescription;
  @JsonKey(name: 'LocationCode')
  final String? locationCode;
  @JsonKey(name: 'AgentBarcode')
  final String? agentBarcode;
  @JsonKey(name: 'CurrencyId')
  final String? currencyId;
  @JsonKey(name: 'LocationId')
  final String? locationId;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesPluginsProcessCreditCardProcessCreditCardInfoFromJson;
  static const toJsonFactory =
      _$WebApiModulesPluginsProcessCreditCardProcessCreditCardInfoToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesPluginsProcessCreditCardProcessCreditCardInfoToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesPluginsProcessCreditCardProcessCreditCardInfo &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderNumber, orderNumber) ||
                const DeepCollectionEquality()
                    .equals(other.orderNumber, orderNumber)) &&
            (identical(other.orderDescription, orderDescription) ||
                const DeepCollectionEquality()
                    .equals(other.orderDescription, orderDescription)) &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.dealNumber, dealNumber) ||
                const DeepCollectionEquality()
                    .equals(other.dealNumber, dealNumber)) &&
            (identical(other.deal, deal) ||
                const DeepCollectionEquality().equals(other.deal, deal)) &&
            (identical(other.customerNumber, customerNumber) ||
                const DeepCollectionEquality()
                    .equals(other.customerNumber, customerNumber)) &&
            (identical(other.customer, customer) ||
                const DeepCollectionEquality()
                    .equals(other.customer, customer)) &&
            (identical(other.pINPadType, pINPadType) ||
                const DeepCollectionEquality()
                    .equals(other.pINPadType, pINPadType)) &&
            (identical(other.totalsWeeklyGrossTotal, totalsWeeklyGrossTotal) ||
                const DeepCollectionEquality().equals(
                    other.totalsWeeklyGrossTotal, totalsWeeklyGrossTotal)) &&
            (identical(other.totalsWeeklyDiscount, totalsWeeklyDiscount) ||
                const DeepCollectionEquality().equals(
                    other.totalsWeeklyDiscount, totalsWeeklyDiscount)) &&
            (identical(other.totalsWeeklySubTotal, totalsWeeklySubTotal) ||
                const DeepCollectionEquality().equals(
                    other.totalsWeeklySubTotal, totalsWeeklySubTotal)) &&
            (identical(other.totalsWeeklyTax, totalsWeeklyTax) ||
                const DeepCollectionEquality()
                    .equals(other.totalsWeeklyTax, totalsWeeklyTax)) &&
            (identical(other.totalsWeeklyGrandTotal, totalsWeeklyGrandTotal) ||
                const DeepCollectionEquality().equals(
                    other.totalsWeeklyGrandTotal, totalsWeeklyGrandTotal)) &&
            (identical(other.totalsPeriodGrossTotal, totalsPeriodGrossTotal) ||
                const DeepCollectionEquality().equals(
                    other.totalsPeriodGrossTotal, totalsPeriodGrossTotal)) &&
            (identical(other.totalsPeriodDiscount, totalsPeriodDiscount) ||
                const DeepCollectionEquality().equals(
                    other.totalsPeriodDiscount, totalsPeriodDiscount)) &&
            (identical(other.totalsPeriodSubTotal, totalsPeriodSubTotal) ||
                const DeepCollectionEquality().equals(
                    other.totalsPeriodSubTotal, totalsPeriodSubTotal)) &&
            (identical(other.totalsPeriodTax, totalsPeriodTax) ||
                const DeepCollectionEquality()
                    .equals(other.totalsPeriodTax, totalsPeriodTax)) &&
            (identical(other.totalsPeriodGrandTotal, totalsPeriodGrandTotal) ||
                const DeepCollectionEquality().equals(
                    other.totalsPeriodGrandTotal, totalsPeriodGrandTotal)) &&
            (identical(other.totalsReplacementReplacementCost, totalsReplacementReplacementCost) ||
                const DeepCollectionEquality()
                    .equals(other.totalsReplacementReplacementCost, totalsReplacementReplacementCost)) &&
            (identical(other.totalsReplacementDepositPercentage, totalsReplacementDepositPercentage) || const DeepCollectionEquality().equals(other.totalsReplacementDepositPercentage, totalsReplacementDepositPercentage)) &&
            (identical(other.totalsReplacementDepositDue, totalsReplacementDepositDue) || const DeepCollectionEquality().equals(other.totalsReplacementDepositDue, totalsReplacementDepositDue)) &&
            (identical(other.paymentTotalAmount, paymentTotalAmount) || const DeepCollectionEquality().equals(other.paymentTotalAmount, paymentTotalAmount)) &&
            (identical(other.paymentAmountToPay, paymentAmountToPay) || const DeepCollectionEquality().equals(other.paymentAmountToPay, paymentAmountToPay)) &&
            (identical(other.pINPadCode, pINPadCode) || const DeepCollectionEquality().equals(other.pINPadCode, pINPadCode)) &&
            (identical(other.pINPadDescription, pINPadDescription) || const DeepCollectionEquality().equals(other.pINPadDescription, pINPadDescription)) &&
            (identical(other.locationCode, locationCode) || const DeepCollectionEquality().equals(other.locationCode, locationCode)) &&
            (identical(other.agentBarcode, agentBarcode) || const DeepCollectionEquality().equals(other.agentBarcode, agentBarcode)) &&
            (identical(other.currencyId, currencyId) || const DeepCollectionEquality().equals(other.currencyId, currencyId)) &&
            (identical(other.locationId, locationId) || const DeepCollectionEquality().equals(other.locationId, locationId)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesPluginsProcessCreditCardProcessCreditCardInfoExtension
    on WebApiModulesPluginsProcessCreditCardProcessCreditCardInfo {
  WebApiModulesPluginsProcessCreditCardProcessCreditCardInfo copyWith(
      {String? recordTitle,
      String? orderId,
      String? orderNumber,
      String? orderDescription,
      String? dealId,
      String? dealNumber,
      String? deal,
      String? customerNumber,
      String? customer,
      String? pINPadType,
      double? totalsWeeklyGrossTotal,
      double? totalsWeeklyDiscount,
      double? totalsWeeklySubTotal,
      double? totalsWeeklyTax,
      double? totalsWeeklyGrandTotal,
      double? totalsPeriodGrossTotal,
      double? totalsPeriodDiscount,
      double? totalsPeriodSubTotal,
      double? totalsPeriodTax,
      double? totalsPeriodGrandTotal,
      double? totalsReplacementReplacementCost,
      double? totalsReplacementDepositPercentage,
      double? totalsReplacementDepositDue,
      double? paymentTotalAmount,
      double? paymentAmountToPay,
      String? pINPadCode,
      String? pINPadDescription,
      String? locationCode,
      String? agentBarcode,
      String? currencyId,
      String? locationId,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesPluginsProcessCreditCardProcessCreditCardInfo(
        recordTitle: recordTitle ?? this.recordTitle,
        orderId: orderId ?? this.orderId,
        orderNumber: orderNumber ?? this.orderNumber,
        orderDescription: orderDescription ?? this.orderDescription,
        dealId: dealId ?? this.dealId,
        dealNumber: dealNumber ?? this.dealNumber,
        deal: deal ?? this.deal,
        customerNumber: customerNumber ?? this.customerNumber,
        customer: customer ?? this.customer,
        pINPadType: pINPadType ?? this.pINPadType,
        totalsWeeklyGrossTotal:
            totalsWeeklyGrossTotal ?? this.totalsWeeklyGrossTotal,
        totalsWeeklyDiscount: totalsWeeklyDiscount ?? this.totalsWeeklyDiscount,
        totalsWeeklySubTotal: totalsWeeklySubTotal ?? this.totalsWeeklySubTotal,
        totalsWeeklyTax: totalsWeeklyTax ?? this.totalsWeeklyTax,
        totalsWeeklyGrandTotal:
            totalsWeeklyGrandTotal ?? this.totalsWeeklyGrandTotal,
        totalsPeriodGrossTotal:
            totalsPeriodGrossTotal ?? this.totalsPeriodGrossTotal,
        totalsPeriodDiscount: totalsPeriodDiscount ?? this.totalsPeriodDiscount,
        totalsPeriodSubTotal: totalsPeriodSubTotal ?? this.totalsPeriodSubTotal,
        totalsPeriodTax: totalsPeriodTax ?? this.totalsPeriodTax,
        totalsPeriodGrandTotal:
            totalsPeriodGrandTotal ?? this.totalsPeriodGrandTotal,
        totalsReplacementReplacementCost: totalsReplacementReplacementCost ??
            this.totalsReplacementReplacementCost,
        totalsReplacementDepositPercentage:
            totalsReplacementDepositPercentage ??
                this.totalsReplacementDepositPercentage,
        totalsReplacementDepositDue:
            totalsReplacementDepositDue ?? this.totalsReplacementDepositDue,
        paymentTotalAmount: paymentTotalAmount ?? this.paymentTotalAmount,
        paymentAmountToPay: paymentAmountToPay ?? this.paymentAmountToPay,
        pINPadCode: pINPadCode ?? this.pINPadCode,
        pINPadDescription: pINPadDescription ?? this.pINPadDescription,
        locationCode: locationCode ?? this.locationCode,
        agentBarcode: agentBarcode ?? this.agentBarcode,
        currencyId: currencyId ?? this.currencyId,
        locationId: locationId ?? this.locationId,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesPluginsProcessCreditCardProcessCreditCardPaymentResponse {
  WebApiModulesPluginsProcessCreditCardProcessCreditCardPaymentResponse({
    this.status,
    this.statusText,
    this.cardEntryMode,
    this.cardType,
    this.authorizationCode,
    this.amount,
    this.receipt,
  });

  factory WebApiModulesPluginsProcessCreditCardProcessCreditCardPaymentResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesPluginsProcessCreditCardProcessCreditCardPaymentResponseFromJson(
          json);

  @JsonKey(name: 'Status')
  final String? status;
  @JsonKey(name: 'StatusText')
  final String? statusText;
  @JsonKey(name: 'CardEntryMode')
  final String? cardEntryMode;
  @JsonKey(
      name: 'CardType',
      toJson:
          webApiModulesPluginsProcessCreditCardProcessCreditCardPaymentCardTypesToJson,
      fromJson:
          webApiModulesPluginsProcessCreditCardProcessCreditCardPaymentCardTypesFromJson)
  final enums
          .WebApiModulesPluginsProcessCreditCardProcessCreditCardPaymentCardTypes?
      cardType;
  @JsonKey(name: 'AuthorizationCode')
  final String? authorizationCode;
  @JsonKey(name: 'Amount')
  final double? amount;
  @JsonKey(name: 'Receipt')
  final WebApiModulesBillingReceiptReceipt? receipt;
  static const fromJsonFactory =
      _$WebApiModulesPluginsProcessCreditCardProcessCreditCardPaymentResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesPluginsProcessCreditCardProcessCreditCardPaymentResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesPluginsProcessCreditCardProcessCreditCardPaymentResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesPluginsProcessCreditCardProcessCreditCardPaymentResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.statusText, statusText) ||
                const DeepCollectionEquality()
                    .equals(other.statusText, statusText)) &&
            (identical(other.cardEntryMode, cardEntryMode) ||
                const DeepCollectionEquality()
                    .equals(other.cardEntryMode, cardEntryMode)) &&
            (identical(other.cardType, cardType) ||
                const DeepCollectionEquality()
                    .equals(other.cardType, cardType)) &&
            (identical(other.authorizationCode, authorizationCode) ||
                const DeepCollectionEquality()
                    .equals(other.authorizationCode, authorizationCode)) &&
            (identical(other.amount, amount) ||
                const DeepCollectionEquality().equals(other.amount, amount)) &&
            (identical(other.receipt, receipt) ||
                const DeepCollectionEquality().equals(other.receipt, receipt)));
  }
}

extension $WebApiModulesPluginsProcessCreditCardProcessCreditCardPaymentResponseExtension
    on WebApiModulesPluginsProcessCreditCardProcessCreditCardPaymentResponse {
  WebApiModulesPluginsProcessCreditCardProcessCreditCardPaymentResponse copyWith(
      {String? status,
      String? statusText,
      String? cardEntryMode,
      enums.WebApiModulesPluginsProcessCreditCardProcessCreditCardPaymentCardTypes?
          cardType,
      String? authorizationCode,
      double? amount,
      WebApiModulesBillingReceiptReceipt? receipt}) {
    return WebApiModulesPluginsProcessCreditCardProcessCreditCardPaymentResponse(
        status: status ?? this.status,
        statusText: statusText ?? this.statusText,
        cardEntryMode: cardEntryMode ?? this.cardEntryMode,
        cardType: cardType ?? this.cardType,
        authorizationCode: authorizationCode ?? this.authorizationCode,
        amount: amount ?? this.amount,
        receipt: receipt ?? this.receipt);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesSettingsDepartmentLocationDepartmentLocation {
  WebApiModulesSettingsDepartmentLocationDepartmentLocation({
    this.departmentId,
    this.locationId,
    this.department,
    this.location,
    this.defaultOrderTypeId,
    this.defaultOrderType,
    this.inactive,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesSettingsDepartmentLocationDepartmentLocation.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesSettingsDepartmentLocationDepartmentLocationFromJson(json);

  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'LocationId')
  final String? locationId;
  @JsonKey(name: 'Department')
  final String? department;
  @JsonKey(name: 'Location')
  final String? location;
  @JsonKey(name: 'DefaultOrderTypeId')
  final String? defaultOrderTypeId;
  @JsonKey(name: 'DefaultOrderType')
  final String? defaultOrderType;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesSettingsDepartmentLocationDepartmentLocationFromJson;
  static const toJsonFactory =
      _$WebApiModulesSettingsDepartmentLocationDepartmentLocationToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesSettingsDepartmentLocationDepartmentLocationToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesSettingsDepartmentLocationDepartmentLocation &&
            (identical(other.departmentId, departmentId) ||
                const DeepCollectionEquality()
                    .equals(other.departmentId, departmentId)) &&
            (identical(other.locationId, locationId) ||
                const DeepCollectionEquality()
                    .equals(other.locationId, locationId)) &&
            (identical(other.department, department) ||
                const DeepCollectionEquality()
                    .equals(other.department, department)) &&
            (identical(other.location, location) ||
                const DeepCollectionEquality()
                    .equals(other.location, location)) &&
            (identical(other.defaultOrderTypeId, defaultOrderTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.defaultOrderTypeId, defaultOrderTypeId)) &&
            (identical(other.defaultOrderType, defaultOrderType) ||
                const DeepCollectionEquality()
                    .equals(other.defaultOrderType, defaultOrderType)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesSettingsDepartmentLocationDepartmentLocationExtension
    on WebApiModulesSettingsDepartmentLocationDepartmentLocation {
  WebApiModulesSettingsDepartmentLocationDepartmentLocation copyWith(
      {String? departmentId,
      String? locationId,
      String? department,
      String? location,
      String? defaultOrderTypeId,
      String? defaultOrderType,
      bool? inactive,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesSettingsDepartmentLocationDepartmentLocation(
        departmentId: departmentId ?? this.departmentId,
        locationId: locationId ?? this.locationId,
        department: department ?? this.department,
        location: location ?? this.location,
        defaultOrderTypeId: defaultOrderTypeId ?? this.defaultOrderTypeId,
        defaultOrderType: defaultOrderType ?? this.defaultOrderType,
        inactive: inactive ?? this.inactive,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatus {
  WebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatus({
    this.inventoryStatusId,
    this.inventoryStatus,
    this.statusType,
    this.color,
    this.textColor,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatus.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatusFromJson(
          json);

  @JsonKey(name: 'InventoryStatusId')
  final String? inventoryStatusId;
  @JsonKey(name: 'InventoryStatus')
  final String? inventoryStatus;
  @JsonKey(name: 'StatusType')
  final String? statusType;
  @JsonKey(name: 'Color')
  final String? color;
  @JsonKey(name: 'TextColor')
  final String? textColor;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatusFromJson;
  static const toJsonFactory =
      _$WebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatusToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatusToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatus &&
            (identical(other.inventoryStatusId, inventoryStatusId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryStatusId, inventoryStatusId)) &&
            (identical(other.inventoryStatus, inventoryStatus) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryStatus, inventoryStatus)) &&
            (identical(other.statusType, statusType) ||
                const DeepCollectionEquality()
                    .equals(other.statusType, statusType)) &&
            (identical(other.color, color) ||
                const DeepCollectionEquality().equals(other.color, color)) &&
            (identical(other.textColor, textColor) ||
                const DeepCollectionEquality()
                    .equals(other.textColor, textColor)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatusExtension
    on WebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatus {
  WebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatus copyWith(
      {String? inventoryStatusId,
      String? inventoryStatus,
      String? statusType,
      String? color,
      String? textColor,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesSettingsInventorySettingsInventoryStatusInventoryStatus(
        inventoryStatusId: inventoryStatusId ?? this.inventoryStatusId,
        inventoryStatus: inventoryStatus ?? this.inventoryStatus,
        statusType: statusType ?? this.statusType,
        color: color ?? this.color,
        textColor: textColor ?? this.textColor,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModel {
  WebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModel({
    this.locationId,
    this.location,
  });

  factory WebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModel.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModelFromJson(
          json);

  @JsonKey(name: 'LocationId')
  final String? locationId;
  @JsonKey(name: 'Location')
  final String? location;
  static const fromJsonFactory =
      _$WebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModelFromJson;
  static const toJsonFactory =
      _$WebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModelToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModelToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModel &&
            (identical(other.locationId, locationId) ||
                const DeepCollectionEquality()
                    .equals(other.locationId, locationId)) &&
            (identical(other.location, location) ||
                const DeepCollectionEquality()
                    .equals(other.location, location)));
  }
}

extension $WebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModelExtension
    on WebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModel {
  WebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModel
      copyWith({String? locationId, String? location}) {
    return WebApiModulesSettingsOfficeLocationSettingsOfficeLocationGetManyOfficeLocationModel(
        locationId: locationId ?? this.locationId,
        location: location ?? this.location);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesSettingsOfficeLocationSettingsOfficeLocationOfficeLocation {
  WebApiModulesSettingsOfficeLocationSettingsOfficeLocationOfficeLocation({
    this.locationId,
    this.location,
    this.locationCode,
    this.companyName,
    this.federalId,
    this.address1,
    this.address2,
    this.city,
    this.zipCode,
    this.state,
    this.countryId,
    this.country,
    this.phone,
    this.fax,
    this.email,
    this.webAddress,
    this.remitToCompanyName,
    this.remitToAddress1,
    this.remitToAddress2,
    this.remitToCity,
    this.remitToZip,
    this.remitToState,
    this.remitToCountryId,
    this.remitToCountry,
    this.remitToPhone,
    this.remitToFax,
    this.remitToEmail,
    this.rateType,
    this.rateTypeDisplay,
    this.color,
    this.defaultPurchasePoTypeId,
    this.defaultPurchasePoType,
    this.glPrefix,
    this.glSuffix,
    this.useNumberPrefix,
    this.numberPrefix,
    this.useRequisitionNumbers,
    this.useSameNumberForQuoteAndOrder,
    this.useSameNumberForAllExportBatches,
    this.userOrderNumberAndSuffixForInvoice,
    this.useHInHiatusInvoiceNumbers,
    this.defaultCurrencyId,
    this.defaultCurrencyCode,
    this.defaultCurrency,
    this.defaultCurrencySymbol,
    this.tax1ReferenceName,
    this.tax1ReferenceNumber,
    this.tax2ReferenceName,
    this.tax2ReferenceNumber,
    this.disableCreditStatusMessages,
    this.disableCreditThroughDateMessages,
    this.disableInsuranceStatusMessages,
    this.disableInsuranceThroughDateMessages,
    this.warnIfTermsAndConditionsNotOnFile,
    this.autoApplyDepletingDepositToInvoice,
    this.depositReplacmentValuePercent,
    this.invoiceMessage,
    this.taxable,
    this.useOrderLocationByDefault,
    this.inactive,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesSettingsOfficeLocationSettingsOfficeLocationOfficeLocation.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesSettingsOfficeLocationSettingsOfficeLocationOfficeLocationFromJson(
          json);

  @JsonKey(name: 'LocationId')
  final String? locationId;
  @JsonKey(name: 'Location')
  final String? location;
  @JsonKey(name: 'LocationCode')
  final String? locationCode;
  @JsonKey(name: 'CompanyName')
  final String? companyName;
  @JsonKey(name: 'FederalId')
  final String? federalId;
  @JsonKey(name: 'Address1')
  final String? address1;
  @JsonKey(name: 'Address2')
  final String? address2;
  @JsonKey(name: 'City')
  final String? city;
  @JsonKey(name: 'ZipCode')
  final String? zipCode;
  @JsonKey(name: 'State')
  final String? state;
  @JsonKey(name: 'CountryId')
  final String? countryId;
  @JsonKey(name: 'Country')
  final String? country;
  @JsonKey(name: 'Phone')
  final String? phone;
  @JsonKey(name: 'Fax')
  final String? fax;
  @JsonKey(name: 'Email')
  final String? email;
  @JsonKey(name: 'WebAddress')
  final String? webAddress;
  @JsonKey(name: 'RemitToCompanyName')
  final String? remitToCompanyName;
  @JsonKey(name: 'RemitToAddress1')
  final String? remitToAddress1;
  @JsonKey(name: 'RemitToAddress2')
  final String? remitToAddress2;
  @JsonKey(name: 'RemitToCity')
  final String? remitToCity;
  @JsonKey(name: 'RemitToZip')
  final String? remitToZip;
  @JsonKey(name: 'RemitToState')
  final String? remitToState;
  @JsonKey(name: 'RemitToCountryId')
  final String? remitToCountryId;
  @JsonKey(name: 'RemitToCountry')
  final String? remitToCountry;
  @JsonKey(name: 'RemitToPhone')
  final String? remitToPhone;
  @JsonKey(name: 'RemitToFax')
  final String? remitToFax;
  @JsonKey(name: 'RemitToEmail')
  final String? remitToEmail;
  @JsonKey(name: 'RateType')
  final String? rateType;
  @JsonKey(name: 'RateTypeDisplay')
  final String? rateTypeDisplay;
  @JsonKey(name: 'Color')
  final String? color;
  @JsonKey(name: 'DefaultPurchasePoTypeId')
  final String? defaultPurchasePoTypeId;
  @JsonKey(name: 'DefaultPurchasePoType')
  final String? defaultPurchasePoType;
  @JsonKey(name: 'GlPrefix')
  final String? glPrefix;
  @JsonKey(name: 'GlSuffix')
  final String? glSuffix;
  @JsonKey(name: 'UseNumberPrefix')
  final bool? useNumberPrefix;
  @JsonKey(name: 'NumberPrefix')
  final String? numberPrefix;
  @JsonKey(name: 'UseRequisitionNumbers')
  final bool? useRequisitionNumbers;
  @JsonKey(name: 'UseSameNumberForQuoteAndOrder')
  final bool? useSameNumberForQuoteAndOrder;
  @JsonKey(name: 'UseSameNumberForAllExportBatches')
  final bool? useSameNumberForAllExportBatches;
  @JsonKey(name: 'UserOrderNumberAndSuffixForInvoice')
  final bool? userOrderNumberAndSuffixForInvoice;
  @JsonKey(name: 'UseHInHiatusInvoiceNumbers')
  final bool? useHInHiatusInvoiceNumbers;
  @JsonKey(name: 'DefaultCurrencyId')
  final String? defaultCurrencyId;
  @JsonKey(name: 'DefaultCurrencyCode')
  final String? defaultCurrencyCode;
  @JsonKey(name: 'DefaultCurrency')
  final String? defaultCurrency;
  @JsonKey(name: 'DefaultCurrencySymbol')
  final String? defaultCurrencySymbol;
  @JsonKey(name: 'Tax1ReferenceName')
  final String? tax1ReferenceName;
  @JsonKey(name: 'Tax1ReferenceNumber')
  final String? tax1ReferenceNumber;
  @JsonKey(name: 'Tax2ReferenceName')
  final String? tax2ReferenceName;
  @JsonKey(name: 'Tax2ReferenceNumber')
  final String? tax2ReferenceNumber;
  @JsonKey(name: 'DisableCreditStatusMessages')
  final bool? disableCreditStatusMessages;
  @JsonKey(name: 'DisableCreditThroughDateMessages')
  final bool? disableCreditThroughDateMessages;
  @JsonKey(name: 'DisableInsuranceStatusMessages')
  final bool? disableInsuranceStatusMessages;
  @JsonKey(name: 'DisableInsuranceThroughDateMessages')
  final bool? disableInsuranceThroughDateMessages;
  @JsonKey(name: 'WarnIfTermsAndConditionsNotOnFile')
  final bool? warnIfTermsAndConditionsNotOnFile;
  @JsonKey(name: 'AutoApplyDepletingDepositToInvoice')
  final bool? autoApplyDepletingDepositToInvoice;
  @JsonKey(name: 'DepositReplacmentValuePercent')
  final double? depositReplacmentValuePercent;
  @JsonKey(name: 'InvoiceMessage')
  final String? invoiceMessage;
  @JsonKey(name: 'Taxable')
  final bool? taxable;
  @JsonKey(name: 'UseOrderLocationByDefault')
  final bool? useOrderLocationByDefault;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesSettingsOfficeLocationSettingsOfficeLocationOfficeLocationFromJson;
  static const toJsonFactory =
      _$WebApiModulesSettingsOfficeLocationSettingsOfficeLocationOfficeLocationToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesSettingsOfficeLocationSettingsOfficeLocationOfficeLocationToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesSettingsOfficeLocationSettingsOfficeLocationOfficeLocation &&
            (identical(other.locationId, locationId) ||
                const DeepCollectionEquality()
                    .equals(other.locationId, locationId)) &&
            (identical(other.location, location) ||
                const DeepCollectionEquality()
                    .equals(other.location, location)) &&
            (identical(other.locationCode, locationCode) ||
                const DeepCollectionEquality()
                    .equals(other.locationCode, locationCode)) &&
            (identical(other.companyName, companyName) ||
                const DeepCollectionEquality()
                    .equals(other.companyName, companyName)) &&
            (identical(other.federalId, federalId) ||
                const DeepCollectionEquality()
                    .equals(other.federalId, federalId)) &&
            (identical(other.address1, address1) ||
                const DeepCollectionEquality()
                    .equals(other.address1, address1)) &&
            (identical(other.address2, address2) ||
                const DeepCollectionEquality()
                    .equals(other.address2, address2)) &&
            (identical(other.city, city) ||
                const DeepCollectionEquality().equals(other.city, city)) &&
            (identical(other.zipCode, zipCode) ||
                const DeepCollectionEquality()
                    .equals(other.zipCode, zipCode)) &&
            (identical(other.state, state) ||
                const DeepCollectionEquality().equals(other.state, state)) &&
            (identical(other.countryId, countryId) ||
                const DeepCollectionEquality()
                    .equals(other.countryId, countryId)) &&
            (identical(other.country, country) ||
                const DeepCollectionEquality()
                    .equals(other.country, country)) &&
            (identical(other.phone, phone) ||
                const DeepCollectionEquality().equals(other.phone, phone)) &&
            (identical(other.fax, fax) ||
                const DeepCollectionEquality().equals(other.fax, fax)) &&
            (identical(other.email, email) ||
                const DeepCollectionEquality().equals(other.email, email)) &&
            (identical(other.webAddress, webAddress) ||
                const DeepCollectionEquality()
                    .equals(other.webAddress, webAddress)) &&
            (identical(other.remitToCompanyName, remitToCompanyName) ||
                const DeepCollectionEquality()
                    .equals(other.remitToCompanyName, remitToCompanyName)) &&
            (identical(other.remitToAddress1, remitToAddress1) ||
                const DeepCollectionEquality()
                    .equals(other.remitToAddress1, remitToAddress1)) &&
            (identical(other.remitToAddress2, remitToAddress2) ||
                const DeepCollectionEquality().equals(other.remitToAddress2, remitToAddress2)) &&
            (identical(other.remitToCity, remitToCity) || const DeepCollectionEquality().equals(other.remitToCity, remitToCity)) &&
            (identical(other.remitToZip, remitToZip) || const DeepCollectionEquality().equals(other.remitToZip, remitToZip)) &&
            (identical(other.remitToState, remitToState) || const DeepCollectionEquality().equals(other.remitToState, remitToState)) &&
            (identical(other.remitToCountryId, remitToCountryId) || const DeepCollectionEquality().equals(other.remitToCountryId, remitToCountryId)) &&
            (identical(other.remitToCountry, remitToCountry) || const DeepCollectionEquality().equals(other.remitToCountry, remitToCountry)) &&
            (identical(other.remitToPhone, remitToPhone) || const DeepCollectionEquality().equals(other.remitToPhone, remitToPhone)) &&
            (identical(other.remitToFax, remitToFax) || const DeepCollectionEquality().equals(other.remitToFax, remitToFax)) &&
            (identical(other.remitToEmail, remitToEmail) || const DeepCollectionEquality().equals(other.remitToEmail, remitToEmail)) &&
            (identical(other.rateType, rateType) || const DeepCollectionEquality().equals(other.rateType, rateType)) &&
            (identical(other.rateTypeDisplay, rateTypeDisplay) || const DeepCollectionEquality().equals(other.rateTypeDisplay, rateTypeDisplay)) &&
            (identical(other.color, color) || const DeepCollectionEquality().equals(other.color, color)) &&
            (identical(other.defaultPurchasePoTypeId, defaultPurchasePoTypeId) || const DeepCollectionEquality().equals(other.defaultPurchasePoTypeId, defaultPurchasePoTypeId)) &&
            (identical(other.defaultPurchasePoType, defaultPurchasePoType) || const DeepCollectionEquality().equals(other.defaultPurchasePoType, defaultPurchasePoType)) &&
            (identical(other.glPrefix, glPrefix) || const DeepCollectionEquality().equals(other.glPrefix, glPrefix)) &&
            (identical(other.glSuffix, glSuffix) || const DeepCollectionEquality().equals(other.glSuffix, glSuffix)) &&
            (identical(other.useNumberPrefix, useNumberPrefix) || const DeepCollectionEquality().equals(other.useNumberPrefix, useNumberPrefix)) &&
            (identical(other.numberPrefix, numberPrefix) || const DeepCollectionEquality().equals(other.numberPrefix, numberPrefix)) &&
            (identical(other.useRequisitionNumbers, useRequisitionNumbers) || const DeepCollectionEquality().equals(other.useRequisitionNumbers, useRequisitionNumbers)) &&
            (identical(other.useSameNumberForQuoteAndOrder, useSameNumberForQuoteAndOrder) || const DeepCollectionEquality().equals(other.useSameNumberForQuoteAndOrder, useSameNumberForQuoteAndOrder)) &&
            (identical(other.useSameNumberForAllExportBatches, useSameNumberForAllExportBatches) || const DeepCollectionEquality().equals(other.useSameNumberForAllExportBatches, useSameNumberForAllExportBatches)) &&
            (identical(other.userOrderNumberAndSuffixForInvoice, userOrderNumberAndSuffixForInvoice) || const DeepCollectionEquality().equals(other.userOrderNumberAndSuffixForInvoice, userOrderNumberAndSuffixForInvoice)) &&
            (identical(other.useHInHiatusInvoiceNumbers, useHInHiatusInvoiceNumbers) || const DeepCollectionEquality().equals(other.useHInHiatusInvoiceNumbers, useHInHiatusInvoiceNumbers)) &&
            (identical(other.defaultCurrencyId, defaultCurrencyId) || const DeepCollectionEquality().equals(other.defaultCurrencyId, defaultCurrencyId)) &&
            (identical(other.defaultCurrencyCode, defaultCurrencyCode) || const DeepCollectionEquality().equals(other.defaultCurrencyCode, defaultCurrencyCode)) &&
            (identical(other.defaultCurrency, defaultCurrency) || const DeepCollectionEquality().equals(other.defaultCurrency, defaultCurrency)) &&
            (identical(other.defaultCurrencySymbol, defaultCurrencySymbol) || const DeepCollectionEquality().equals(other.defaultCurrencySymbol, defaultCurrencySymbol)) &&
            (identical(other.tax1ReferenceName, tax1ReferenceName) || const DeepCollectionEquality().equals(other.tax1ReferenceName, tax1ReferenceName)) &&
            (identical(other.tax1ReferenceNumber, tax1ReferenceNumber) || const DeepCollectionEquality().equals(other.tax1ReferenceNumber, tax1ReferenceNumber)) &&
            (identical(other.tax2ReferenceName, tax2ReferenceName) || const DeepCollectionEquality().equals(other.tax2ReferenceName, tax2ReferenceName)) &&
            (identical(other.tax2ReferenceNumber, tax2ReferenceNumber) || const DeepCollectionEquality().equals(other.tax2ReferenceNumber, tax2ReferenceNumber)) &&
            (identical(other.disableCreditStatusMessages, disableCreditStatusMessages) || const DeepCollectionEquality().equals(other.disableCreditStatusMessages, disableCreditStatusMessages)) &&
            (identical(other.disableCreditThroughDateMessages, disableCreditThroughDateMessages) || const DeepCollectionEquality().equals(other.disableCreditThroughDateMessages, disableCreditThroughDateMessages)) &&
            (identical(other.disableInsuranceStatusMessages, disableInsuranceStatusMessages) || const DeepCollectionEquality().equals(other.disableInsuranceStatusMessages, disableInsuranceStatusMessages)) &&
            (identical(other.disableInsuranceThroughDateMessages, disableInsuranceThroughDateMessages) || const DeepCollectionEquality().equals(other.disableInsuranceThroughDateMessages, disableInsuranceThroughDateMessages)) &&
            (identical(other.warnIfTermsAndConditionsNotOnFile, warnIfTermsAndConditionsNotOnFile) || const DeepCollectionEquality().equals(other.warnIfTermsAndConditionsNotOnFile, warnIfTermsAndConditionsNotOnFile)) &&
            (identical(other.autoApplyDepletingDepositToInvoice, autoApplyDepletingDepositToInvoice) || const DeepCollectionEquality().equals(other.autoApplyDepletingDepositToInvoice, autoApplyDepletingDepositToInvoice)) &&
            (identical(other.depositReplacmentValuePercent, depositReplacmentValuePercent) || const DeepCollectionEquality().equals(other.depositReplacmentValuePercent, depositReplacmentValuePercent)) &&
            (identical(other.invoiceMessage, invoiceMessage) || const DeepCollectionEquality().equals(other.invoiceMessage, invoiceMessage)) &&
            (identical(other.taxable, taxable) || const DeepCollectionEquality().equals(other.taxable, taxable)) &&
            (identical(other.useOrderLocationByDefault, useOrderLocationByDefault) || const DeepCollectionEquality().equals(other.useOrderLocationByDefault, useOrderLocationByDefault)) &&
            (identical(other.inactive, inactive) || const DeepCollectionEquality().equals(other.inactive, inactive)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesSettingsOfficeLocationSettingsOfficeLocationOfficeLocationExtension
    on WebApiModulesSettingsOfficeLocationSettingsOfficeLocationOfficeLocation {
  WebApiModulesSettingsOfficeLocationSettingsOfficeLocationOfficeLocation
      copyWith(
          {String? locationId,
          String? location,
          String? locationCode,
          String? companyName,
          String? federalId,
          String? address1,
          String? address2,
          String? city,
          String? zipCode,
          String? state,
          String? countryId,
          String? country,
          String? phone,
          String? fax,
          String? email,
          String? webAddress,
          String? remitToCompanyName,
          String? remitToAddress1,
          String? remitToAddress2,
          String? remitToCity,
          String? remitToZip,
          String? remitToState,
          String? remitToCountryId,
          String? remitToCountry,
          String? remitToPhone,
          String? remitToFax,
          String? remitToEmail,
          String? rateType,
          String? rateTypeDisplay,
          String? color,
          String? defaultPurchasePoTypeId,
          String? defaultPurchasePoType,
          String? glPrefix,
          String? glSuffix,
          bool? useNumberPrefix,
          String? numberPrefix,
          bool? useRequisitionNumbers,
          bool? useSameNumberForQuoteAndOrder,
          bool? useSameNumberForAllExportBatches,
          bool? userOrderNumberAndSuffixForInvoice,
          bool? useHInHiatusInvoiceNumbers,
          String? defaultCurrencyId,
          String? defaultCurrencyCode,
          String? defaultCurrency,
          String? defaultCurrencySymbol,
          String? tax1ReferenceName,
          String? tax1ReferenceNumber,
          String? tax2ReferenceName,
          String? tax2ReferenceNumber,
          bool? disableCreditStatusMessages,
          bool? disableCreditThroughDateMessages,
          bool? disableInsuranceStatusMessages,
          bool? disableInsuranceThroughDateMessages,
          bool? warnIfTermsAndConditionsNotOnFile,
          bool? autoApplyDepletingDepositToInvoice,
          double? depositReplacmentValuePercent,
          String? invoiceMessage,
          bool? taxable,
          bool? useOrderLocationByDefault,
          bool? inactive,
          String? dateStamp,
          String? recordTitle,
          List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
          List<FwStandardDataFwCustomValue>? custom,
          List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesSettingsOfficeLocationSettingsOfficeLocationOfficeLocation(
        locationId: locationId ?? this.locationId,
        location: location ?? this.location,
        locationCode: locationCode ?? this.locationCode,
        companyName: companyName ?? this.companyName,
        federalId: federalId ?? this.federalId,
        address1: address1 ?? this.address1,
        address2: address2 ?? this.address2,
        city: city ?? this.city,
        zipCode: zipCode ?? this.zipCode,
        state: state ?? this.state,
        countryId: countryId ?? this.countryId,
        country: country ?? this.country,
        phone: phone ?? this.phone,
        fax: fax ?? this.fax,
        email: email ?? this.email,
        webAddress: webAddress ?? this.webAddress,
        remitToCompanyName: remitToCompanyName ?? this.remitToCompanyName,
        remitToAddress1: remitToAddress1 ?? this.remitToAddress1,
        remitToAddress2: remitToAddress2 ?? this.remitToAddress2,
        remitToCity: remitToCity ?? this.remitToCity,
        remitToZip: remitToZip ?? this.remitToZip,
        remitToState: remitToState ?? this.remitToState,
        remitToCountryId: remitToCountryId ?? this.remitToCountryId,
        remitToCountry: remitToCountry ?? this.remitToCountry,
        remitToPhone: remitToPhone ?? this.remitToPhone,
        remitToFax: remitToFax ?? this.remitToFax,
        remitToEmail: remitToEmail ?? this.remitToEmail,
        rateType: rateType ?? this.rateType,
        rateTypeDisplay: rateTypeDisplay ?? this.rateTypeDisplay,
        color: color ?? this.color,
        defaultPurchasePoTypeId:
            defaultPurchasePoTypeId ?? this.defaultPurchasePoTypeId,
        defaultPurchasePoType:
            defaultPurchasePoType ?? this.defaultPurchasePoType,
        glPrefix: glPrefix ?? this.glPrefix,
        glSuffix: glSuffix ?? this.glSuffix,
        useNumberPrefix: useNumberPrefix ?? this.useNumberPrefix,
        numberPrefix: numberPrefix ?? this.numberPrefix,
        useRequisitionNumbers:
            useRequisitionNumbers ?? this.useRequisitionNumbers,
        useSameNumberForQuoteAndOrder:
            useSameNumberForQuoteAndOrder ?? this.useSameNumberForQuoteAndOrder,
        useSameNumberForAllExportBatches: useSameNumberForAllExportBatches ??
            this.useSameNumberForAllExportBatches,
        userOrderNumberAndSuffixForInvoice:
            userOrderNumberAndSuffixForInvoice ??
                this.userOrderNumberAndSuffixForInvoice,
        useHInHiatusInvoiceNumbers:
            useHInHiatusInvoiceNumbers ?? this.useHInHiatusInvoiceNumbers,
        defaultCurrencyId: defaultCurrencyId ?? this.defaultCurrencyId,
        defaultCurrencyCode: defaultCurrencyCode ?? this.defaultCurrencyCode,
        defaultCurrency: defaultCurrency ?? this.defaultCurrency,
        defaultCurrencySymbol:
            defaultCurrencySymbol ?? this.defaultCurrencySymbol,
        tax1ReferenceName: tax1ReferenceName ?? this.tax1ReferenceName,
        tax1ReferenceNumber: tax1ReferenceNumber ?? this.tax1ReferenceNumber,
        tax2ReferenceName: tax2ReferenceName ?? this.tax2ReferenceName,
        tax2ReferenceNumber: tax2ReferenceNumber ?? this.tax2ReferenceNumber,
        disableCreditStatusMessages:
            disableCreditStatusMessages ?? this.disableCreditStatusMessages,
        disableCreditThroughDateMessages: disableCreditThroughDateMessages ??
            this.disableCreditThroughDateMessages,
        disableInsuranceStatusMessages: disableInsuranceStatusMessages ??
            this.disableInsuranceStatusMessages,
        disableInsuranceThroughDateMessages:
            disableInsuranceThroughDateMessages ??
                this.disableInsuranceThroughDateMessages,
        warnIfTermsAndConditionsNotOnFile: warnIfTermsAndConditionsNotOnFile ??
            this.warnIfTermsAndConditionsNotOnFile,
        autoApplyDepletingDepositToInvoice:
            autoApplyDepletingDepositToInvoice ??
                this.autoApplyDepletingDepositToInvoice,
        depositReplacmentValuePercent:
            depositReplacmentValuePercent ?? this.depositReplacmentValuePercent,
        invoiceMessage: invoiceMessage ?? this.invoiceMessage,
        taxable: taxable ?? this.taxable,
        useOrderLocationByDefault:
            useOrderLocationByDefault ?? this.useOrderLocationByDefault,
        inactive: inactive ?? this.inactive,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesSettingsOrderSettingsOrderTypeOrderType {
  WebApiModulesSettingsOrderSettingsOrderTypeOrderType({
    this.orderTypeId,
    this.orderType,
    this.ordType,
    this.defaultPickTime,
    this.defaultFromTime,
    this.defaultToTime,
    this.dailyScheduleDefaultStartTime,
    this.dailyScheduleDefaultStopTime,
    this.isMasterSubOrderType,
    this.combineActivityTabs,
    this.defaultManualSort,
    this.determineQuantitiesToBillBasedOn,
    this.allowNesting,
    this.rentalShowICode,
    this.rentalICodeWidth,
    this.rentalShowDescription,
    this.rentalDescriptionWidth,
    this.rentalShowPickDate,
    this.rentalShowPickTime,
    this.rentalShowFromDate,
    this.rentalShowFromTime,
    this.rentalShowToDate,
    this.rentalShowToTime,
    this.rentalShowBillablePeriods,
    this.rentalShowEpisodes,
    this.rentalShowSubQuantity,
    this.rentalShowAvailableQuantity,
    this.rentalShowConflictDate,
    this.rentalShowAvailableQuantityRegion,
    this.rentalShowConflictDateRegion,
    this.rentalShowAvailableQuantityAllWarehouses,
    this.rentalShowConflictDateAllWarehouses,
    this.rentalShowReservedItems,
    this.rentalShowConsignmentQuantity,
    this.rentalShowConsignmentAvailableQuantity,
    this.rentalShowConsignmentConflictDate,
    this.rentalShowRate,
    this.rentalShowDaysPerWeek,
    this.rentalShowPremiumPercent,
    this.rentalShowUnit,
    this.rentalShowCost,
    this.rentalShowPeriodCostExtended,
    this.rentalShowDiscountPercent,
    this.rentalShowMarkupPercent,
    this.rentalShowMarginPercent,
    this.rentalShowUnitDiscountAmount,
    this.rentalShowUnitExtended,
    this.rentalShowWeeklyDiscountAmount,
    this.rentalShowWeeklyExtended,
    this.rentalShowEpisodeExtended,
    this.rentalShowEpisodeDiscountAmount,
    this.rentalShowMonthlyDiscountAmount,
    this.rentalShowMonthlyExtended,
    this.rentalShowPeriodDiscountAmount,
    this.rentalShowPeriodExtended,
    this.rentalShowWarehouse,
    this.rentalShowTaxable,
    this.rentalShowNotes,
    this.rentalShowReturnToWarehouse,
    this.rentalDateStamp,
    this.allowRoundTripRentals,
    this.salesShowICode,
    this.salesICodeWidth,
    this.salesShowDescription,
    this.salesDescriptionWidth,
    this.salesShowManufacturerPartNumber,
    this.salesManufacturerPartNumberWidth,
    this.salesShowPickDate,
    this.salesShowPickTime,
    this.salesShowFromDate,
    this.salesShowFromTime,
    this.salesShowSubQuantity,
    this.salesShowCost,
    this.salesShowRate,
    this.salesShowAvailableQuantity,
    this.salesShowConflictDate,
    this.salesShowAvailableQuantityRegion,
    this.salesShowConflictDateRegion,
    this.salesShowAvailableQuantityAllWarehouses,
    this.salesShowConflictDateAllWarehouses,
    this.salesShowMarkupPercent,
    this.salesShowMarginPercent,
    this.salesShowUnit,
    this.salesShowPeriodCostExtended,
    this.salesShowDiscountPercent,
    this.salesShowUnitDiscountAmount,
    this.salesShowUnitExtended,
    this.salesShowPeriodDiscountAmount,
    this.salesShowPeriodExtended,
    this.salesShowVariancePercent,
    this.salesShowVarianceExtended,
    this.salesShowWarehouse,
    this.salesShowTaxable,
    this.salesShowNotes,
    this.salesDateStamp,
    this.salesInventoryPrice,
    this.salesInventoryCost,
    this.facilityShowDescription,
    this.facilityDescriptionWidth,
    this.facilityShowFromDate,
    this.facilityShowFromTime,
    this.facilityShowToDate,
    this.facilityShowToTime,
    this.facilityShowWeeksAndDays,
    this.facilityShowMonthsAndDays,
    this.facilityShowBillablePeriods,
    this.facilityShowRate,
    this.facilityShowDaysPerWeek,
    this.facilityShowDiscountPercent,
    this.facilityShowSplit,
    this.facilityShowUnit,
    this.facilityShowUnitDiscountAmount,
    this.facilityShowUnitExtended,
    this.facilityShowWeeklyDiscountAmount,
    this.facilityShowWeeklyExtended,
    this.facilityShowMonthlyDiscountAmount,
    this.facilityShowMonthlyExtended,
    this.facilityShowPeriodDiscountAmount,
    this.facilityShowPeriodExtended,
    this.facilityShowTaxable,
    this.facilityShowNotes,
    this.facilityDateStamp,
    this.facilityDescription,
    this.vehicleShowDescription,
    this.vehicleDescriptionWidth,
    this.vehicleShowVehicleNumber,
    this.vehicleShowPickDate,
    this.vehicleShowPickTime,
    this.vehicleShowFromDate,
    this.vehicleShowFromTime,
    this.vehicleShowToDate,
    this.vehicleShowToTime,
    this.vehicleShowBillablePeriods,
    this.vehicleShowSubQuantity,
    this.vehicleShowAvailableQuantity,
    this.vehicleShowConflictDate,
    this.vehicleShowUnit,
    this.vehicleShowRate,
    this.vehicleShowDaysPerWeek,
    this.vehicleShowCost,
    this.vehicleShowWeeklyCostExtended,
    this.vehicleShowMonthlyCostExtended,
    this.vehicleShowPeriodCostExtended,
    this.vehicleShowDiscountPercent,
    this.vehicleShowUnitDiscountAmount,
    this.vehicleShowUnitExtended,
    this.vehicleShowWeeklyDiscountAmount,
    this.vehicleShowWeeklyExtended,
    this.vehicleShowMonthlyDiscountAmount,
    this.vehicleShowMonthlyExtended,
    this.vehicleShowPeriodDiscountAmount,
    this.vehicleShowPeriodExtended,
    this.vehicleShowWarehouse,
    this.vehicleShowReturnToWarehouse,
    this.vehicleShowTaxable,
    this.vehicleShowNotes,
    this.vehicleDateStamp,
    this.laborShowICode,
    this.laborICodeWidth,
    this.laborShowDescription,
    this.laborDescriptionWidth,
    this.laborShowOrderActivity,
    this.laborShowCrewName,
    this.laborShowFromDate,
    this.laborShowFromTime,
    this.laborShowToDate,
    this.laborShowToTime,
    this.laborShowBillablePeriods,
    this.laborShowHours,
    this.laborShowSubQuantity,
    this.laborShowCost,
    this.laborShowRate,
    this.laborShowPeriodCostExtended,
    this.laborShowDiscountPercent,
    this.laborShowUnit,
    this.laborShowUnitDiscountAmount,
    this.laborShowUnitExtended,
    this.laborShowWeeklyDiscountAmount,
    this.laborShowWeeklyExtended,
    this.laborShowMonthlyDiscountAmount,
    this.laborShowMonthlyExtended,
    this.laborShowPeriodDiscountAmount,
    this.laborShowPeriodExtended,
    this.laborShowWarehouse,
    this.laborShowTaxable,
    this.laborShowNotes,
    this.laborDateStamp,
    this.hideCrewBreaks,
    this.break1Paid,
    this.break2Paid,
    this.break3Paid,
    this.miscShowICode,
    this.miscICodeWidth,
    this.miscShowDescription,
    this.miscDescriptionWidth,
    this.miscShowFromDate,
    this.miscShowFromTime,
    this.miscShowToDate,
    this.miscShowToTime,
    this.miscShowBillablePeriods,
    this.miscShowSubQuantity,
    this.miscShowWeeksAndDays,
    this.miscShowMonthsAndDays,
    this.miscShowUnit,
    this.miscShowRate,
    this.miscShowCost,
    this.miscShowPeriodCostExtended,
    this.miscShowDiscountPercent,
    this.miscShowUnitDiscountAmount,
    this.miscShowUnitExtended,
    this.miscShowWeeklyDiscountAmount,
    this.miscShowWeeklyExtended,
    this.miscShowMonthlyDiscountAmount,
    this.miscShowMonthlyExtended,
    this.miscShowPeriodDiscountAmount,
    this.miscShowPeriodExtended,
    this.miscShowWarehouse,
    this.miscShowTaxable,
    this.miscShowNotes,
    this.miscDateStamp,
    this.rentalSaleShowBarCode,
    this.rentalSaleShowSerialNumber,
    this.rentalSaleShowICode,
    this.rentalSaleICodeWidth,
    this.rentalSaleShowDescription,
    this.rentalSaleDescriptionWidth,
    this.rentalSaleShowPickDate,
    this.rentalSaleShowPickTime,
    this.rentalSaleShowAvailableQuantity,
    this.rentalSaleShowConflictDate,
    this.rentalSaleShowUnit,
    this.rentalSaleShowRate,
    this.rentalSaleShowCost,
    this.rentalSaleShowPeriodCostExtended,
    this.rentalSaleShowDiscountPercent,
    this.rentalSaleShowUnitDiscountAmount,
    this.rentalSaleShowUnitExtended,
    this.rentalSaleShowPeriodDiscountAmount,
    this.rentalSaleShowPeriodExtended,
    this.rentalSaleShowWarehouse,
    this.rentalSaleShowTaxable,
    this.rentalSaleShowNotes,
    this.rentalSaleDateStamp,
    this.lossAndDamageShowOrderNumber,
    this.lossAndDamageShowRepairOrderNumber,
    this.lossAndDamageShowBarCode,
    this.lossAndDamageShowSerialNumber,
    this.lossAndDamageShowICode,
    this.lossAndDamageICodeWidth,
    this.lossAndDamageShowDescription,
    this.lossAndDamageDescriptionWidth,
    this.lossAndDamageShowUnit,
    this.lossAndDamageShowRate,
    this.lossAndDamageShowCost,
    this.lossAndDamageShowDiscountPercent,
    this.lossAndDamageShowUnitDiscountAmount,
    this.lossAndDamageShowUnitExtended,
    this.lossAndDamageShowPeriodDiscountAmount,
    this.lossAndDamageShowPeriodExtended,
    this.lossAndDamageShowWarehouse,
    this.lossAndDamageShowTaxable,
    this.lossAndDamageShowNotes,
    this.lossAndDamageDateStamp,
    this.addInstallationAndStrikeFee,
    this.installationAndStrikeFeeRateId,
    this.installationAndStrikeFeeICode,
    this.installationAndStrikeFeeDescription,
    this.installationAndStrikeFeePercent,
    this.installationAndStrikeFeeBasedOn,
    this.addManagementAndServiceFee,
    this.managementAndServiceFeeRateId,
    this.managementAndServiceFeeICode,
    this.managementAndServiceFeeDescription,
    this.managementAndServiceFeePercent,
    this.managementAndServiceFeeBasedOn,
    this.defaultRentalSalePrice,
    this.quikPayDiscount,
    this.quikPayDiscountType,
    this.quikPayDiscountDays,
    this.quikPayDiscountPercent,
    this.quikPayDiscountExcludeSubs,
    this.quikConfirmDiscount,
    this.quikConfirmDiscountPercent,
    this.quikConfirmDiscountDays,
    this.disableCostGl,
    this.excludeFromTopSalesDashboard,
    this.separatePackageOnQuoteOrder,
    this.orderby,
    this.subAllShortagesSubMiscellaneous,
    this.inactive,
    this.combinedShowFields,
    this.rentalShowFields,
    this.salesShowFields,
    this.miscShowFields,
    this.laborShowFields,
    this.rentalSaleShowFields,
    this.lossAndDamageShowFields,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesSettingsOrderSettingsOrderTypeOrderType.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesSettingsOrderSettingsOrderTypeOrderTypeFromJson(json);

  @JsonKey(name: 'OrderTypeId')
  final String? orderTypeId;
  @JsonKey(name: 'OrderType')
  final String? orderType;
  @JsonKey(name: 'OrdType')
  final String? ordType;
  @JsonKey(name: 'DefaultPickTime')
  final String? defaultPickTime;
  @JsonKey(name: 'DefaultFromTime')
  final String? defaultFromTime;
  @JsonKey(name: 'DefaultToTime')
  final String? defaultToTime;
  @JsonKey(name: 'DailyScheduleDefaultStartTime')
  final String? dailyScheduleDefaultStartTime;
  @JsonKey(name: 'DailyScheduleDefaultStopTime')
  final String? dailyScheduleDefaultStopTime;
  @JsonKey(name: 'IsMasterSubOrderType')
  final bool? isMasterSubOrderType;
  @JsonKey(name: 'CombineActivityTabs')
  final bool? combineActivityTabs;
  @JsonKey(name: 'DefaultManualSort')
  final bool? defaultManualSort;
  @JsonKey(name: 'DetermineQuantitiesToBillBasedOn')
  final String? determineQuantitiesToBillBasedOn;
  @JsonKey(name: 'AllowNesting')
  final bool? allowNesting;
  @JsonKey(name: 'RentalShowICode')
  final bool? rentalShowICode;
  @JsonKey(name: 'RentalICodeWidth')
  final int? rentalICodeWidth;
  @JsonKey(name: 'RentalShowDescription')
  final bool? rentalShowDescription;
  @JsonKey(name: 'RentalDescriptionWidth')
  final int? rentalDescriptionWidth;
  @JsonKey(name: 'RentalShowPickDate')
  final bool? rentalShowPickDate;
  @JsonKey(name: 'RentalShowPickTime')
  final bool? rentalShowPickTime;
  @JsonKey(name: 'RentalShowFromDate')
  final bool? rentalShowFromDate;
  @JsonKey(name: 'RentalShowFromTime')
  final bool? rentalShowFromTime;
  @JsonKey(name: 'RentalShowToDate')
  final bool? rentalShowToDate;
  @JsonKey(name: 'RentalShowToTime')
  final bool? rentalShowToTime;
  @JsonKey(name: 'RentalShowBillablePeriods')
  final bool? rentalShowBillablePeriods;
  @JsonKey(name: 'RentalShowEpisodes')
  final bool? rentalShowEpisodes;
  @JsonKey(name: 'RentalShowSubQuantity')
  final bool? rentalShowSubQuantity;
  @JsonKey(name: 'RentalShowAvailableQuantity')
  final bool? rentalShowAvailableQuantity;
  @JsonKey(name: 'RentalShowConflictDate')
  final bool? rentalShowConflictDate;
  @JsonKey(name: 'RentalShowAvailableQuantityRegion')
  final bool? rentalShowAvailableQuantityRegion;
  @JsonKey(name: 'RentalShowConflictDateRegion')
  final bool? rentalShowConflictDateRegion;
  @JsonKey(name: 'RentalShowAvailableQuantityAllWarehouses')
  final bool? rentalShowAvailableQuantityAllWarehouses;
  @JsonKey(name: 'RentalShowConflictDateAllWarehouses')
  final bool? rentalShowConflictDateAllWarehouses;
  @JsonKey(name: 'RentalShowReservedItems')
  final bool? rentalShowReservedItems;
  @JsonKey(name: 'RentalShowConsignmentQuantity')
  final bool? rentalShowConsignmentQuantity;
  @JsonKey(name: 'RentalShowConsignmentAvailableQuantity')
  final bool? rentalShowConsignmentAvailableQuantity;
  @JsonKey(name: 'RentalShowConsignmentConflictDate')
  final bool? rentalShowConsignmentConflictDate;
  @JsonKey(name: 'RentalShowRate')
  final bool? rentalShowRate;
  @JsonKey(name: 'RentalShowDaysPerWeek')
  final bool? rentalShowDaysPerWeek;
  @JsonKey(name: 'RentalShowPremiumPercent')
  final bool? rentalShowPremiumPercent;
  @JsonKey(name: 'RentalShowUnit')
  final bool? rentalShowUnit;
  @JsonKey(name: 'RentalShowCost')
  final bool? rentalShowCost;
  @JsonKey(name: 'RentalShowPeriodCostExtended')
  final bool? rentalShowPeriodCostExtended;
  @JsonKey(name: 'RentalShowDiscountPercent')
  final bool? rentalShowDiscountPercent;
  @JsonKey(name: 'RentalShowMarkupPercent')
  final bool? rentalShowMarkupPercent;
  @JsonKey(name: 'RentalShowMarginPercent')
  final bool? rentalShowMarginPercent;
  @JsonKey(name: 'RentalShowUnitDiscountAmount')
  final bool? rentalShowUnitDiscountAmount;
  @JsonKey(name: 'RentalShowUnitExtended')
  final bool? rentalShowUnitExtended;
  @JsonKey(name: 'RentalShowWeeklyDiscountAmount')
  final bool? rentalShowWeeklyDiscountAmount;
  @JsonKey(name: 'RentalShowWeeklyExtended')
  final bool? rentalShowWeeklyExtended;
  @JsonKey(name: 'RentalShowEpisodeExtended')
  final bool? rentalShowEpisodeExtended;
  @JsonKey(name: 'RentalShowEpisodeDiscountAmount')
  final bool? rentalShowEpisodeDiscountAmount;
  @JsonKey(name: 'RentalShowMonthlyDiscountAmount')
  final bool? rentalShowMonthlyDiscountAmount;
  @JsonKey(name: 'RentalShowMonthlyExtended')
  final bool? rentalShowMonthlyExtended;
  @JsonKey(name: 'RentalShowPeriodDiscountAmount')
  final bool? rentalShowPeriodDiscountAmount;
  @JsonKey(name: 'RentalShowPeriodExtended')
  final bool? rentalShowPeriodExtended;
  @JsonKey(name: 'RentalShowWarehouse')
  final bool? rentalShowWarehouse;
  @JsonKey(name: 'RentalShowTaxable')
  final bool? rentalShowTaxable;
  @JsonKey(name: 'RentalShowNotes')
  final bool? rentalShowNotes;
  @JsonKey(name: 'RentalShowReturnToWarehouse')
  final bool? rentalShowReturnToWarehouse;
  @JsonKey(name: 'RentalDateStamp')
  final String? rentalDateStamp;
  @JsonKey(name: 'AllowRoundTripRentals')
  final bool? allowRoundTripRentals;
  @JsonKey(name: 'SalesShowICode')
  final bool? salesShowICode;
  @JsonKey(name: 'SalesICodeWidth')
  final int? salesICodeWidth;
  @JsonKey(name: 'SalesShowDescription')
  final bool? salesShowDescription;
  @JsonKey(name: 'SalesDescriptionWidth')
  final int? salesDescriptionWidth;
  @JsonKey(name: 'SalesShowManufacturerPartNumber')
  final bool? salesShowManufacturerPartNumber;
  @JsonKey(name: 'SalesManufacturerPartNumberWidth')
  final int? salesManufacturerPartNumberWidth;
  @JsonKey(name: 'SalesShowPickDate')
  final bool? salesShowPickDate;
  @JsonKey(name: 'SalesShowPickTime')
  final bool? salesShowPickTime;
  @JsonKey(name: 'SalesShowFromDate')
  final bool? salesShowFromDate;
  @JsonKey(name: 'SalesShowFromTime')
  final bool? salesShowFromTime;
  @JsonKey(name: 'SalesShowSubQuantity')
  final bool? salesShowSubQuantity;
  @JsonKey(name: 'SalesShowCost')
  final bool? salesShowCost;
  @JsonKey(name: 'SalesShowRate')
  final bool? salesShowRate;
  @JsonKey(name: 'SalesShowAvailableQuantity')
  final bool? salesShowAvailableQuantity;
  @JsonKey(name: 'SalesShowConflictDate')
  final bool? salesShowConflictDate;
  @JsonKey(name: 'SalesShowAvailableQuantityRegion')
  final bool? salesShowAvailableQuantityRegion;
  @JsonKey(name: 'SalesShowConflictDateRegion')
  final bool? salesShowConflictDateRegion;
  @JsonKey(name: 'SalesShowAvailableQuantityAllWarehouses')
  final bool? salesShowAvailableQuantityAllWarehouses;
  @JsonKey(name: 'SalesShowConflictDateAllWarehouses')
  final bool? salesShowConflictDateAllWarehouses;
  @JsonKey(name: 'SalesShowMarkupPercent')
  final bool? salesShowMarkupPercent;
  @JsonKey(name: 'SalesShowMarginPercent')
  final bool? salesShowMarginPercent;
  @JsonKey(name: 'SalesShowUnit')
  final bool? salesShowUnit;
  @JsonKey(name: 'SalesShowPeriodCostExtended')
  final bool? salesShowPeriodCostExtended;
  @JsonKey(name: 'SalesShowDiscountPercent')
  final bool? salesShowDiscountPercent;
  @JsonKey(name: 'SalesShowUnitDiscountAmount')
  final bool? salesShowUnitDiscountAmount;
  @JsonKey(name: 'SalesShowUnitExtended')
  final bool? salesShowUnitExtended;
  @JsonKey(name: 'SalesShowPeriodDiscountAmount')
  final bool? salesShowPeriodDiscountAmount;
  @JsonKey(name: 'SalesShowPeriodExtended')
  final bool? salesShowPeriodExtended;
  @JsonKey(name: 'SalesShowVariancePercent')
  final bool? salesShowVariancePercent;
  @JsonKey(name: 'SalesShowVarianceExtended')
  final bool? salesShowVarianceExtended;
  @JsonKey(name: 'SalesShowWarehouse')
  final bool? salesShowWarehouse;
  @JsonKey(name: 'SalesShowTaxable')
  final bool? salesShowTaxable;
  @JsonKey(name: 'SalesShowNotes')
  final bool? salesShowNotes;
  @JsonKey(name: 'SalesDateStamp')
  final String? salesDateStamp;
  @JsonKey(name: 'SalesInventoryPrice')
  final String? salesInventoryPrice;
  @JsonKey(name: 'SalesInventoryCost')
  final String? salesInventoryCost;
  @JsonKey(name: 'FacilityShowDescription')
  final bool? facilityShowDescription;
  @JsonKey(name: 'FacilityDescriptionWidth')
  final int? facilityDescriptionWidth;
  @JsonKey(name: 'FacilityShowFromDate')
  final bool? facilityShowFromDate;
  @JsonKey(name: 'FacilityShowFromTime')
  final bool? facilityShowFromTime;
  @JsonKey(name: 'FacilityShowToDate')
  final bool? facilityShowToDate;
  @JsonKey(name: 'FacilityShowToTime')
  final bool? facilityShowToTime;
  @JsonKey(name: 'FacilityShowWeeksAndDays')
  final bool? facilityShowWeeksAndDays;
  @JsonKey(name: 'FacilityShowMonthsAndDays')
  final bool? facilityShowMonthsAndDays;
  @JsonKey(name: 'FacilityShowBillablePeriods')
  final bool? facilityShowBillablePeriods;
  @JsonKey(name: 'FacilityShowRate')
  final bool? facilityShowRate;
  @JsonKey(name: 'FacilityShowDaysPerWeek')
  final bool? facilityShowDaysPerWeek;
  @JsonKey(name: 'FacilityShowDiscountPercent')
  final bool? facilityShowDiscountPercent;
  @JsonKey(name: 'FacilityShowSplit')
  final bool? facilityShowSplit;
  @JsonKey(name: 'FacilityShowUnit')
  final bool? facilityShowUnit;
  @JsonKey(name: 'FacilityShowUnitDiscountAmount')
  final bool? facilityShowUnitDiscountAmount;
  @JsonKey(name: 'FacilityShowUnitExtended')
  final bool? facilityShowUnitExtended;
  @JsonKey(name: 'FacilityShowWeeklyDiscountAmount')
  final bool? facilityShowWeeklyDiscountAmount;
  @JsonKey(name: 'FacilityShowWeeklyExtended')
  final bool? facilityShowWeeklyExtended;
  @JsonKey(name: 'FacilityShowMonthlyDiscountAmount')
  final bool? facilityShowMonthlyDiscountAmount;
  @JsonKey(name: 'FacilityShowMonthlyExtended')
  final bool? facilityShowMonthlyExtended;
  @JsonKey(name: 'FacilityShowPeriodDiscountAmount')
  final bool? facilityShowPeriodDiscountAmount;
  @JsonKey(name: 'FacilityShowPeriodExtended')
  final bool? facilityShowPeriodExtended;
  @JsonKey(name: 'FacilityShowTaxable')
  final bool? facilityShowTaxable;
  @JsonKey(name: 'FacilityShowNotes')
  final bool? facilityShowNotes;
  @JsonKey(name: 'FacilityDateStamp')
  final String? facilityDateStamp;
  @JsonKey(name: 'FacilityDescription')
  final String? facilityDescription;
  @JsonKey(name: 'VehicleShowDescription')
  final bool? vehicleShowDescription;
  @JsonKey(name: 'VehicleDescriptionWidth')
  final int? vehicleDescriptionWidth;
  @JsonKey(name: 'VehicleShowVehicleNumber')
  final bool? vehicleShowVehicleNumber;
  @JsonKey(name: 'VehicleShowPickDate')
  final bool? vehicleShowPickDate;
  @JsonKey(name: 'VehicleShowPickTime')
  final bool? vehicleShowPickTime;
  @JsonKey(name: 'VehicleShowFromDate')
  final bool? vehicleShowFromDate;
  @JsonKey(name: 'VehicleShowFromTime')
  final bool? vehicleShowFromTime;
  @JsonKey(name: 'VehicleShowToDate')
  final bool? vehicleShowToDate;
  @JsonKey(name: 'VehicleShowToTime')
  final bool? vehicleShowToTime;
  @JsonKey(name: 'VehicleShowBillablePeriods')
  final bool? vehicleShowBillablePeriods;
  @JsonKey(name: 'VehicleShowSubQuantity')
  final bool? vehicleShowSubQuantity;
  @JsonKey(name: 'VehicleShowAvailableQuantity')
  final bool? vehicleShowAvailableQuantity;
  @JsonKey(name: 'VehicleShowConflictDate')
  final bool? vehicleShowConflictDate;
  @JsonKey(name: 'VehicleShowUnit')
  final bool? vehicleShowUnit;
  @JsonKey(name: 'VehicleShowRate')
  final bool? vehicleShowRate;
  @JsonKey(name: 'VehicleShowDaysPerWeek')
  final bool? vehicleShowDaysPerWeek;
  @JsonKey(name: 'VehicleShowCost')
  final bool? vehicleShowCost;
  @JsonKey(name: 'VehicleShowWeeklyCostExtended')
  final bool? vehicleShowWeeklyCostExtended;
  @JsonKey(name: 'VehicleShowMonthlyCostExtended')
  final bool? vehicleShowMonthlyCostExtended;
  @JsonKey(name: 'VehicleShowPeriodCostExtended')
  final bool? vehicleShowPeriodCostExtended;
  @JsonKey(name: 'VehicleShowDiscountPercent')
  final bool? vehicleShowDiscountPercent;
  @JsonKey(name: 'VehicleShowUnitDiscountAmount')
  final bool? vehicleShowUnitDiscountAmount;
  @JsonKey(name: 'VehicleShowUnitExtended')
  final bool? vehicleShowUnitExtended;
  @JsonKey(name: 'VehicleShowWeeklyDiscountAmount')
  final bool? vehicleShowWeeklyDiscountAmount;
  @JsonKey(name: 'VehicleShowWeeklyExtended')
  final bool? vehicleShowWeeklyExtended;
  @JsonKey(name: 'VehicleShowMonthlyDiscountAmount')
  final bool? vehicleShowMonthlyDiscountAmount;
  @JsonKey(name: 'VehicleShowMonthlyExtended')
  final bool? vehicleShowMonthlyExtended;
  @JsonKey(name: 'VehicleShowPeriodDiscountAmount')
  final bool? vehicleShowPeriodDiscountAmount;
  @JsonKey(name: 'VehicleShowPeriodExtended')
  final bool? vehicleShowPeriodExtended;
  @JsonKey(name: 'VehicleShowWarehouse')
  final bool? vehicleShowWarehouse;
  @JsonKey(name: 'VehicleShowReturnToWarehouse')
  final bool? vehicleShowReturnToWarehouse;
  @JsonKey(name: 'VehicleShowTaxable')
  final bool? vehicleShowTaxable;
  @JsonKey(name: 'VehicleShowNotes')
  final bool? vehicleShowNotes;
  @JsonKey(name: 'VehicleDateStamp')
  final String? vehicleDateStamp;
  @JsonKey(name: 'LaborShowICode')
  final bool? laborShowICode;
  @JsonKey(name: 'LaborICodeWidth')
  final int? laborICodeWidth;
  @JsonKey(name: 'LaborShowDescription')
  final bool? laborShowDescription;
  @JsonKey(name: 'LaborDescriptionWidth')
  final int? laborDescriptionWidth;
  @JsonKey(name: 'LaborShowOrderActivity')
  final bool? laborShowOrderActivity;
  @JsonKey(name: 'LaborShowCrewName')
  final bool? laborShowCrewName;
  @JsonKey(name: 'LaborShowFromDate')
  final bool? laborShowFromDate;
  @JsonKey(name: 'LaborShowFromTime')
  final bool? laborShowFromTime;
  @JsonKey(name: 'LaborShowToDate')
  final bool? laborShowToDate;
  @JsonKey(name: 'LaborShowToTime')
  final bool? laborShowToTime;
  @JsonKey(name: 'LaborShowBillablePeriods')
  final bool? laborShowBillablePeriods;
  @JsonKey(name: 'LaborShowHours')
  final bool? laborShowHours;
  @JsonKey(name: 'LaborShowSubQuantity')
  final bool? laborShowSubQuantity;
  @JsonKey(name: 'LaborShowCost')
  final bool? laborShowCost;
  @JsonKey(name: 'LaborShowRate')
  final bool? laborShowRate;
  @JsonKey(name: 'LaborShowPeriodCostExtended')
  final bool? laborShowPeriodCostExtended;
  @JsonKey(name: 'LaborShowDiscountPercent')
  final bool? laborShowDiscountPercent;
  @JsonKey(name: 'LaborShowUnit')
  final bool? laborShowUnit;
  @JsonKey(name: 'LaborShowUnitDiscountAmount')
  final bool? laborShowUnitDiscountAmount;
  @JsonKey(name: 'LaborShowUnitExtended')
  final bool? laborShowUnitExtended;
  @JsonKey(name: 'LaborShowWeeklyDiscountAmount')
  final bool? laborShowWeeklyDiscountAmount;
  @JsonKey(name: 'LaborShowWeeklyExtended')
  final bool? laborShowWeeklyExtended;
  @JsonKey(name: 'LaborShowMonthlyDiscountAmount')
  final bool? laborShowMonthlyDiscountAmount;
  @JsonKey(name: 'LaborShowMonthlyExtended')
  final bool? laborShowMonthlyExtended;
  @JsonKey(name: 'LaborShowPeriodDiscountAmount')
  final bool? laborShowPeriodDiscountAmount;
  @JsonKey(name: 'LaborShowPeriodExtended')
  final bool? laborShowPeriodExtended;
  @JsonKey(name: 'LaborShowWarehouse')
  final bool? laborShowWarehouse;
  @JsonKey(name: 'LaborShowTaxable')
  final bool? laborShowTaxable;
  @JsonKey(name: 'LaborShowNotes')
  final bool? laborShowNotes;
  @JsonKey(name: 'LaborDateStamp')
  final String? laborDateStamp;
  @JsonKey(name: 'HideCrewBreaks')
  final bool? hideCrewBreaks;
  @JsonKey(name: 'Break1Paid')
  final bool? break1Paid;
  @JsonKey(name: 'Break2Paid')
  final bool? break2Paid;
  @JsonKey(name: 'Break3Paid')
  final bool? break3Paid;
  @JsonKey(name: 'MiscShowICode')
  final bool? miscShowICode;
  @JsonKey(name: 'MiscICodeWidth')
  final int? miscICodeWidth;
  @JsonKey(name: 'MiscShowDescription')
  final bool? miscShowDescription;
  @JsonKey(name: 'MiscDescriptionWidth')
  final int? miscDescriptionWidth;
  @JsonKey(name: 'MiscShowFromDate')
  final bool? miscShowFromDate;
  @JsonKey(name: 'MiscShowFromTime')
  final bool? miscShowFromTime;
  @JsonKey(name: 'MiscShowToDate')
  final bool? miscShowToDate;
  @JsonKey(name: 'MiscShowToTime')
  final bool? miscShowToTime;
  @JsonKey(name: 'MiscShowBillablePeriods')
  final bool? miscShowBillablePeriods;
  @JsonKey(name: 'MiscShowSubQuantity')
  final bool? miscShowSubQuantity;
  @JsonKey(name: 'MiscShowWeeksAndDays')
  final bool? miscShowWeeksAndDays;
  @JsonKey(name: 'MiscShowMonthsAndDays')
  final bool? miscShowMonthsAndDays;
  @JsonKey(name: 'MiscShowUnit')
  final bool? miscShowUnit;
  @JsonKey(name: 'MiscShowRate')
  final bool? miscShowRate;
  @JsonKey(name: 'MiscShowCost')
  final bool? miscShowCost;
  @JsonKey(name: 'MiscShowPeriodCostExtended')
  final bool? miscShowPeriodCostExtended;
  @JsonKey(name: 'MiscShowDiscountPercent')
  final bool? miscShowDiscountPercent;
  @JsonKey(name: 'MiscShowUnitDiscountAmount')
  final bool? miscShowUnitDiscountAmount;
  @JsonKey(name: 'MiscShowUnitExtended')
  final bool? miscShowUnitExtended;
  @JsonKey(name: 'MiscShowWeeklyDiscountAmount')
  final bool? miscShowWeeklyDiscountAmount;
  @JsonKey(name: 'MiscShowWeeklyExtended')
  final bool? miscShowWeeklyExtended;
  @JsonKey(name: 'MiscShowMonthlyDiscountAmount')
  final bool? miscShowMonthlyDiscountAmount;
  @JsonKey(name: 'MiscShowMonthlyExtended')
  final bool? miscShowMonthlyExtended;
  @JsonKey(name: 'MiscShowPeriodDiscountAmount')
  final bool? miscShowPeriodDiscountAmount;
  @JsonKey(name: 'MiscShowPeriodExtended')
  final bool? miscShowPeriodExtended;
  @JsonKey(name: 'MiscShowWarehouse')
  final bool? miscShowWarehouse;
  @JsonKey(name: 'MiscShowTaxable')
  final bool? miscShowTaxable;
  @JsonKey(name: 'MiscShowNotes')
  final bool? miscShowNotes;
  @JsonKey(name: 'MiscDateStamp')
  final String? miscDateStamp;
  @JsonKey(name: 'RentalSaleShowBarCode')
  final bool? rentalSaleShowBarCode;
  @JsonKey(name: 'RentalSaleShowSerialNumber')
  final bool? rentalSaleShowSerialNumber;
  @JsonKey(name: 'RentalSaleShowICode')
  final bool? rentalSaleShowICode;
  @JsonKey(name: 'RentalSaleICodeWidth')
  final int? rentalSaleICodeWidth;
  @JsonKey(name: 'RentalSaleShowDescription')
  final bool? rentalSaleShowDescription;
  @JsonKey(name: 'RentalSaleDescriptionWidth')
  final int? rentalSaleDescriptionWidth;
  @JsonKey(name: 'RentalSaleShowPickDate')
  final bool? rentalSaleShowPickDate;
  @JsonKey(name: 'RentalSaleShowPickTime')
  final bool? rentalSaleShowPickTime;
  @JsonKey(name: 'RentalSaleShowAvailableQuantity')
  final bool? rentalSaleShowAvailableQuantity;
  @JsonKey(name: 'RentalSaleShowConflictDate')
  final bool? rentalSaleShowConflictDate;
  @JsonKey(name: 'RentalSaleShowUnit')
  final bool? rentalSaleShowUnit;
  @JsonKey(name: 'RentalSaleShowRate')
  final bool? rentalSaleShowRate;
  @JsonKey(name: 'RentalSaleShowCost')
  final bool? rentalSaleShowCost;
  @JsonKey(name: 'RentalSaleShowPeriodCostExtended')
  final bool? rentalSaleShowPeriodCostExtended;
  @JsonKey(name: 'RentalSaleShowDiscountPercent')
  final bool? rentalSaleShowDiscountPercent;
  @JsonKey(name: 'RentalSaleShowUnitDiscountAmount')
  final bool? rentalSaleShowUnitDiscountAmount;
  @JsonKey(name: 'RentalSaleShowUnitExtended')
  final bool? rentalSaleShowUnitExtended;
  @JsonKey(name: 'RentalSaleShowPeriodDiscountAmount')
  final bool? rentalSaleShowPeriodDiscountAmount;
  @JsonKey(name: 'RentalSaleShowPeriodExtended')
  final bool? rentalSaleShowPeriodExtended;
  @JsonKey(name: 'RentalSaleShowWarehouse')
  final bool? rentalSaleShowWarehouse;
  @JsonKey(name: 'RentalSaleShowTaxable')
  final bool? rentalSaleShowTaxable;
  @JsonKey(name: 'RentalSaleShowNotes')
  final bool? rentalSaleShowNotes;
  @JsonKey(name: 'RentalSaleDateStamp')
  final String? rentalSaleDateStamp;
  @JsonKey(name: 'LossAndDamageShowOrderNumber')
  final bool? lossAndDamageShowOrderNumber;
  @JsonKey(name: 'LossAndDamageShowRepairOrderNumber')
  final bool? lossAndDamageShowRepairOrderNumber;
  @JsonKey(name: 'LossAndDamageShowBarCode')
  final bool? lossAndDamageShowBarCode;
  @JsonKey(name: 'LossAndDamageShowSerialNumber')
  final bool? lossAndDamageShowSerialNumber;
  @JsonKey(name: 'LossAndDamageShowICode')
  final bool? lossAndDamageShowICode;
  @JsonKey(name: 'LossAndDamageICodeWidth')
  final int? lossAndDamageICodeWidth;
  @JsonKey(name: 'LossAndDamageShowDescription')
  final bool? lossAndDamageShowDescription;
  @JsonKey(name: 'LossAndDamageDescriptionWidth')
  final int? lossAndDamageDescriptionWidth;
  @JsonKey(name: 'LossAndDamageShowUnit')
  final bool? lossAndDamageShowUnit;
  @JsonKey(name: 'LossAndDamageShowRate')
  final bool? lossAndDamageShowRate;
  @JsonKey(name: 'LossAndDamageShowCost')
  final bool? lossAndDamageShowCost;
  @JsonKey(name: 'LossAndDamageShowDiscountPercent')
  final bool? lossAndDamageShowDiscountPercent;
  @JsonKey(name: 'LossAndDamageShowUnitDiscountAmount')
  final bool? lossAndDamageShowUnitDiscountAmount;
  @JsonKey(name: 'LossAndDamageShowUnitExtended')
  final bool? lossAndDamageShowUnitExtended;
  @JsonKey(name: 'LossAndDamageShowPeriodDiscountAmount')
  final bool? lossAndDamageShowPeriodDiscountAmount;
  @JsonKey(name: 'LossAndDamageShowPeriodExtended')
  final bool? lossAndDamageShowPeriodExtended;
  @JsonKey(name: 'LossAndDamageShowWarehouse')
  final bool? lossAndDamageShowWarehouse;
  @JsonKey(name: 'LossAndDamageShowTaxable')
  final bool? lossAndDamageShowTaxable;
  @JsonKey(name: 'LossAndDamageShowNotes')
  final bool? lossAndDamageShowNotes;
  @JsonKey(name: 'LossAndDamageDateStamp')
  final String? lossAndDamageDateStamp;
  @JsonKey(name: 'AddInstallationAndStrikeFee')
  final bool? addInstallationAndStrikeFee;
  @JsonKey(name: 'InstallationAndStrikeFeeRateId')
  final String? installationAndStrikeFeeRateId;
  @JsonKey(name: 'InstallationAndStrikeFeeICode')
  final String? installationAndStrikeFeeICode;
  @JsonKey(name: 'InstallationAndStrikeFeeDescription')
  final String? installationAndStrikeFeeDescription;
  @JsonKey(name: 'InstallationAndStrikeFeePercent')
  final double? installationAndStrikeFeePercent;
  @JsonKey(name: 'InstallationAndStrikeFeeBasedOn')
  final String? installationAndStrikeFeeBasedOn;
  @JsonKey(name: 'AddManagementAndServiceFee')
  final bool? addManagementAndServiceFee;
  @JsonKey(name: 'ManagementAndServiceFeeRateId')
  final String? managementAndServiceFeeRateId;
  @JsonKey(name: 'ManagementAndServiceFeeICode')
  final String? managementAndServiceFeeICode;
  @JsonKey(name: 'ManagementAndServiceFeeDescription')
  final String? managementAndServiceFeeDescription;
  @JsonKey(name: 'ManagementAndServiceFeePercent')
  final double? managementAndServiceFeePercent;
  @JsonKey(name: 'ManagementAndServiceFeeBasedOn')
  final String? managementAndServiceFeeBasedOn;
  @JsonKey(name: 'DefaultRentalSalePrice')
  final String? defaultRentalSalePrice;
  @JsonKey(name: 'QuikPayDiscount')
  final bool? quikPayDiscount;
  @JsonKey(name: 'QuikPayDiscountType')
  final String? quikPayDiscountType;
  @JsonKey(name: 'QuikPayDiscountDays')
  final int? quikPayDiscountDays;
  @JsonKey(name: 'QuikPayDiscountPercent')
  final double? quikPayDiscountPercent;
  @JsonKey(name: 'QuikPayDiscountExcludeSubs')
  final bool? quikPayDiscountExcludeSubs;
  @JsonKey(name: 'QuikConfirmDiscount')
  final bool? quikConfirmDiscount;
  @JsonKey(name: 'QuikConfirmDiscountPercent')
  final double? quikConfirmDiscountPercent;
  @JsonKey(name: 'QuikConfirmDiscountDays')
  final int? quikConfirmDiscountDays;
  @JsonKey(name: 'DisableCostGl')
  final bool? disableCostGl;
  @JsonKey(name: 'ExcludeFromTopSalesDashboard')
  final bool? excludeFromTopSalesDashboard;
  @JsonKey(name: 'SeparatePackageOnQuoteOrder')
  final bool? separatePackageOnQuoteOrder;
  @JsonKey(name: 'Orderby')
  final double? orderby;
  @JsonKey(name: 'SubAllShortagesSubMiscellaneous')
  final bool? subAllShortagesSubMiscellaneous;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'CombinedShowFields', defaultValue: <String>[])
  final List<String>? combinedShowFields;
  @JsonKey(name: 'RentalShowFields', defaultValue: <String>[])
  final List<String>? rentalShowFields;
  @JsonKey(name: 'SalesShowFields', defaultValue: <String>[])
  final List<String>? salesShowFields;
  @JsonKey(name: 'MiscShowFields', defaultValue: <String>[])
  final List<String>? miscShowFields;
  @JsonKey(name: 'LaborShowFields', defaultValue: <String>[])
  final List<String>? laborShowFields;
  @JsonKey(name: 'RentalSaleShowFields', defaultValue: <String>[])
  final List<String>? rentalSaleShowFields;
  @JsonKey(name: 'LossAndDamageShowFields', defaultValue: <String>[])
  final List<String>? lossAndDamageShowFields;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesSettingsOrderSettingsOrderTypeOrderTypeFromJson;
  static const toJsonFactory =
      _$WebApiModulesSettingsOrderSettingsOrderTypeOrderTypeToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesSettingsOrderSettingsOrderTypeOrderTypeToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesSettingsOrderSettingsOrderTypeOrderType &&
            (identical(other.orderTypeId, orderTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.orderTypeId, orderTypeId)) &&
            (identical(other.orderType, orderType) ||
                const DeepCollectionEquality()
                    .equals(other.orderType, orderType)) &&
            (identical(other.ordType, ordType) ||
                const DeepCollectionEquality()
                    .equals(other.ordType, ordType)) &&
            (identical(other.defaultPickTime, defaultPickTime) ||
                const DeepCollectionEquality()
                    .equals(other.defaultPickTime, defaultPickTime)) &&
            (identical(other.defaultFromTime, defaultFromTime) ||
                const DeepCollectionEquality()
                    .equals(other.defaultFromTime, defaultFromTime)) &&
            (identical(other.defaultToTime, defaultToTime) ||
                const DeepCollectionEquality()
                    .equals(other.defaultToTime, defaultToTime)) &&
            (identical(other.dailyScheduleDefaultStartTime, dailyScheduleDefaultStartTime) ||
                const DeepCollectionEquality().equals(
                    other.dailyScheduleDefaultStartTime,
                    dailyScheduleDefaultStartTime)) &&
            (identical(other.dailyScheduleDefaultStopTime, dailyScheduleDefaultStopTime) ||
                const DeepCollectionEquality().equals(
                    other.dailyScheduleDefaultStopTime,
                    dailyScheduleDefaultStopTime)) &&
            (identical(other.isMasterSubOrderType, isMasterSubOrderType) ||
                const DeepCollectionEquality().equals(
                    other.isMasterSubOrderType, isMasterSubOrderType)) &&
            (identical(other.combineActivityTabs, combineActivityTabs) ||
                const DeepCollectionEquality()
                    .equals(other.combineActivityTabs, combineActivityTabs)) &&
            (identical(other.defaultManualSort, defaultManualSort) ||
                const DeepCollectionEquality()
                    .equals(other.defaultManualSort, defaultManualSort)) &&
            (identical(other.determineQuantitiesToBillBasedOn, determineQuantitiesToBillBasedOn) ||
                const DeepCollectionEquality().equals(
                    other.determineQuantitiesToBillBasedOn,
                    determineQuantitiesToBillBasedOn)) &&
            (identical(other.allowNesting, allowNesting) ||
                const DeepCollectionEquality()
                    .equals(other.allowNesting, allowNesting)) &&
            (identical(other.rentalShowICode, rentalShowICode) ||
                const DeepCollectionEquality()
                    .equals(other.rentalShowICode, rentalShowICode)) &&
            (identical(other.rentalICodeWidth, rentalICodeWidth) ||
                const DeepCollectionEquality().equals(other.rentalICodeWidth, rentalICodeWidth)) &&
            (identical(other.rentalShowDescription, rentalShowDescription) || const DeepCollectionEquality().equals(other.rentalShowDescription, rentalShowDescription)) &&
            (identical(other.rentalDescriptionWidth, rentalDescriptionWidth) || const DeepCollectionEquality().equals(other.rentalDescriptionWidth, rentalDescriptionWidth)) &&
            (identical(other.rentalShowPickDate, rentalShowPickDate) || const DeepCollectionEquality().equals(other.rentalShowPickDate, rentalShowPickDate)) &&
            (identical(other.rentalShowPickTime, rentalShowPickTime) || const DeepCollectionEquality().equals(other.rentalShowPickTime, rentalShowPickTime)) &&
            (identical(other.rentalShowFromDate, rentalShowFromDate) || const DeepCollectionEquality().equals(other.rentalShowFromDate, rentalShowFromDate)) &&
            (identical(other.rentalShowFromTime, rentalShowFromTime) || const DeepCollectionEquality().equals(other.rentalShowFromTime, rentalShowFromTime)) &&
            (identical(other.rentalShowToDate, rentalShowToDate) || const DeepCollectionEquality().equals(other.rentalShowToDate, rentalShowToDate)) &&
            (identical(other.rentalShowToTime, rentalShowToTime) || const DeepCollectionEquality().equals(other.rentalShowToTime, rentalShowToTime)) &&
            (identical(other.rentalShowBillablePeriods, rentalShowBillablePeriods) || const DeepCollectionEquality().equals(other.rentalShowBillablePeriods, rentalShowBillablePeriods)) &&
            (identical(other.rentalShowEpisodes, rentalShowEpisodes) || const DeepCollectionEquality().equals(other.rentalShowEpisodes, rentalShowEpisodes)) &&
            (identical(other.rentalShowSubQuantity, rentalShowSubQuantity) || const DeepCollectionEquality().equals(other.rentalShowSubQuantity, rentalShowSubQuantity)) &&
            (identical(other.rentalShowAvailableQuantity, rentalShowAvailableQuantity) || const DeepCollectionEquality().equals(other.rentalShowAvailableQuantity, rentalShowAvailableQuantity)) &&
            (identical(other.rentalShowConflictDate, rentalShowConflictDate) || const DeepCollectionEquality().equals(other.rentalShowConflictDate, rentalShowConflictDate)) &&
            (identical(other.rentalShowAvailableQuantityRegion, rentalShowAvailableQuantityRegion) || const DeepCollectionEquality().equals(other.rentalShowAvailableQuantityRegion, rentalShowAvailableQuantityRegion)) &&
            (identical(other.rentalShowConflictDateRegion, rentalShowConflictDateRegion) || const DeepCollectionEquality().equals(other.rentalShowConflictDateRegion, rentalShowConflictDateRegion)) &&
            (identical(other.rentalShowAvailableQuantityAllWarehouses, rentalShowAvailableQuantityAllWarehouses) || const DeepCollectionEquality().equals(other.rentalShowAvailableQuantityAllWarehouses, rentalShowAvailableQuantityAllWarehouses)) &&
            (identical(other.rentalShowConflictDateAllWarehouses, rentalShowConflictDateAllWarehouses) || const DeepCollectionEquality().equals(other.rentalShowConflictDateAllWarehouses, rentalShowConflictDateAllWarehouses)) &&
            (identical(other.rentalShowReservedItems, rentalShowReservedItems) || const DeepCollectionEquality().equals(other.rentalShowReservedItems, rentalShowReservedItems)) &&
            (identical(other.rentalShowConsignmentQuantity, rentalShowConsignmentQuantity) || const DeepCollectionEquality().equals(other.rentalShowConsignmentQuantity, rentalShowConsignmentQuantity)) &&
            (identical(other.rentalShowConsignmentAvailableQuantity, rentalShowConsignmentAvailableQuantity) || const DeepCollectionEquality().equals(other.rentalShowConsignmentAvailableQuantity, rentalShowConsignmentAvailableQuantity)) &&
            (identical(other.rentalShowConsignmentConflictDate, rentalShowConsignmentConflictDate) || const DeepCollectionEquality().equals(other.rentalShowConsignmentConflictDate, rentalShowConsignmentConflictDate)) &&
            (identical(other.rentalShowRate, rentalShowRate) || const DeepCollectionEquality().equals(other.rentalShowRate, rentalShowRate)) &&
            (identical(other.rentalShowDaysPerWeek, rentalShowDaysPerWeek) || const DeepCollectionEquality().equals(other.rentalShowDaysPerWeek, rentalShowDaysPerWeek)) &&
            (identical(other.rentalShowPremiumPercent, rentalShowPremiumPercent) || const DeepCollectionEquality().equals(other.rentalShowPremiumPercent, rentalShowPremiumPercent)) &&
            (identical(other.rentalShowUnit, rentalShowUnit) || const DeepCollectionEquality().equals(other.rentalShowUnit, rentalShowUnit)) &&
            (identical(other.rentalShowCost, rentalShowCost) || const DeepCollectionEquality().equals(other.rentalShowCost, rentalShowCost)) &&
            (identical(other.rentalShowPeriodCostExtended, rentalShowPeriodCostExtended) || const DeepCollectionEquality().equals(other.rentalShowPeriodCostExtended, rentalShowPeriodCostExtended)) &&
            (identical(other.rentalShowDiscountPercent, rentalShowDiscountPercent) || const DeepCollectionEquality().equals(other.rentalShowDiscountPercent, rentalShowDiscountPercent)) &&
            (identical(other.rentalShowMarkupPercent, rentalShowMarkupPercent) || const DeepCollectionEquality().equals(other.rentalShowMarkupPercent, rentalShowMarkupPercent)) &&
            (identical(other.rentalShowMarginPercent, rentalShowMarginPercent) || const DeepCollectionEquality().equals(other.rentalShowMarginPercent, rentalShowMarginPercent)) &&
            (identical(other.rentalShowUnitDiscountAmount, rentalShowUnitDiscountAmount) || const DeepCollectionEquality().equals(other.rentalShowUnitDiscountAmount, rentalShowUnitDiscountAmount)) &&
            (identical(other.rentalShowUnitExtended, rentalShowUnitExtended) || const DeepCollectionEquality().equals(other.rentalShowUnitExtended, rentalShowUnitExtended)) &&
            (identical(other.rentalShowWeeklyDiscountAmount, rentalShowWeeklyDiscountAmount) || const DeepCollectionEquality().equals(other.rentalShowWeeklyDiscountAmount, rentalShowWeeklyDiscountAmount)) &&
            (identical(other.rentalShowWeeklyExtended, rentalShowWeeklyExtended) || const DeepCollectionEquality().equals(other.rentalShowWeeklyExtended, rentalShowWeeklyExtended)) &&
            (identical(other.rentalShowEpisodeExtended, rentalShowEpisodeExtended) || const DeepCollectionEquality().equals(other.rentalShowEpisodeExtended, rentalShowEpisodeExtended)) &&
            (identical(other.rentalShowEpisodeDiscountAmount, rentalShowEpisodeDiscountAmount) || const DeepCollectionEquality().equals(other.rentalShowEpisodeDiscountAmount, rentalShowEpisodeDiscountAmount)) &&
            (identical(other.rentalShowMonthlyDiscountAmount, rentalShowMonthlyDiscountAmount) || const DeepCollectionEquality().equals(other.rentalShowMonthlyDiscountAmount, rentalShowMonthlyDiscountAmount)) &&
            (identical(other.rentalShowMonthlyExtended, rentalShowMonthlyExtended) || const DeepCollectionEquality().equals(other.rentalShowMonthlyExtended, rentalShowMonthlyExtended)) &&
            (identical(other.rentalShowPeriodDiscountAmount, rentalShowPeriodDiscountAmount) || const DeepCollectionEquality().equals(other.rentalShowPeriodDiscountAmount, rentalShowPeriodDiscountAmount)) &&
            (identical(other.rentalShowPeriodExtended, rentalShowPeriodExtended) || const DeepCollectionEquality().equals(other.rentalShowPeriodExtended, rentalShowPeriodExtended)) &&
            (identical(other.rentalShowWarehouse, rentalShowWarehouse) || const DeepCollectionEquality().equals(other.rentalShowWarehouse, rentalShowWarehouse)) &&
            (identical(other.rentalShowTaxable, rentalShowTaxable) || const DeepCollectionEquality().equals(other.rentalShowTaxable, rentalShowTaxable)) &&
            (identical(other.rentalShowNotes, rentalShowNotes) || const DeepCollectionEquality().equals(other.rentalShowNotes, rentalShowNotes)) &&
            (identical(other.rentalShowReturnToWarehouse, rentalShowReturnToWarehouse) || const DeepCollectionEquality().equals(other.rentalShowReturnToWarehouse, rentalShowReturnToWarehouse)) &&
            (identical(other.rentalDateStamp, rentalDateStamp) || const DeepCollectionEquality().equals(other.rentalDateStamp, rentalDateStamp)) &&
            (identical(other.allowRoundTripRentals, allowRoundTripRentals) || const DeepCollectionEquality().equals(other.allowRoundTripRentals, allowRoundTripRentals)) &&
            (identical(other.salesShowICode, salesShowICode) || const DeepCollectionEquality().equals(other.salesShowICode, salesShowICode)) &&
            (identical(other.salesICodeWidth, salesICodeWidth) || const DeepCollectionEquality().equals(other.salesICodeWidth, salesICodeWidth)) &&
            (identical(other.salesShowDescription, salesShowDescription) || const DeepCollectionEquality().equals(other.salesShowDescription, salesShowDescription)) &&
            (identical(other.salesDescriptionWidth, salesDescriptionWidth) || const DeepCollectionEquality().equals(other.salesDescriptionWidth, salesDescriptionWidth)) &&
            (identical(other.salesShowManufacturerPartNumber, salesShowManufacturerPartNumber) || const DeepCollectionEquality().equals(other.salesShowManufacturerPartNumber, salesShowManufacturerPartNumber)) &&
            (identical(other.salesManufacturerPartNumberWidth, salesManufacturerPartNumberWidth) || const DeepCollectionEquality().equals(other.salesManufacturerPartNumberWidth, salesManufacturerPartNumberWidth)) &&
            (identical(other.salesShowPickDate, salesShowPickDate) || const DeepCollectionEquality().equals(other.salesShowPickDate, salesShowPickDate)) &&
            (identical(other.salesShowPickTime, salesShowPickTime) || const DeepCollectionEquality().equals(other.salesShowPickTime, salesShowPickTime)) &&
            (identical(other.salesShowFromDate, salesShowFromDate) || const DeepCollectionEquality().equals(other.salesShowFromDate, salesShowFromDate)) &&
            (identical(other.salesShowFromTime, salesShowFromTime) || const DeepCollectionEquality().equals(other.salesShowFromTime, salesShowFromTime)) &&
            (identical(other.salesShowSubQuantity, salesShowSubQuantity) || const DeepCollectionEquality().equals(other.salesShowSubQuantity, salesShowSubQuantity)) &&
            (identical(other.salesShowCost, salesShowCost) || const DeepCollectionEquality().equals(other.salesShowCost, salesShowCost)) &&
            (identical(other.salesShowRate, salesShowRate) || const DeepCollectionEquality().equals(other.salesShowRate, salesShowRate)) &&
            (identical(other.salesShowAvailableQuantity, salesShowAvailableQuantity) || const DeepCollectionEquality().equals(other.salesShowAvailableQuantity, salesShowAvailableQuantity)) &&
            (identical(other.salesShowConflictDate, salesShowConflictDate) || const DeepCollectionEquality().equals(other.salesShowConflictDate, salesShowConflictDate)) &&
            (identical(other.salesShowAvailableQuantityRegion, salesShowAvailableQuantityRegion) || const DeepCollectionEquality().equals(other.salesShowAvailableQuantityRegion, salesShowAvailableQuantityRegion)) &&
            (identical(other.salesShowConflictDateRegion, salesShowConflictDateRegion) || const DeepCollectionEquality().equals(other.salesShowConflictDateRegion, salesShowConflictDateRegion)) &&
            (identical(other.salesShowAvailableQuantityAllWarehouses, salesShowAvailableQuantityAllWarehouses) || const DeepCollectionEquality().equals(other.salesShowAvailableQuantityAllWarehouses, salesShowAvailableQuantityAllWarehouses)) &&
            (identical(other.salesShowConflictDateAllWarehouses, salesShowConflictDateAllWarehouses) || const DeepCollectionEquality().equals(other.salesShowConflictDateAllWarehouses, salesShowConflictDateAllWarehouses)) &&
            (identical(other.salesShowMarkupPercent, salesShowMarkupPercent) || const DeepCollectionEquality().equals(other.salesShowMarkupPercent, salesShowMarkupPercent)) &&
            (identical(other.salesShowMarginPercent, salesShowMarginPercent) || const DeepCollectionEquality().equals(other.salesShowMarginPercent, salesShowMarginPercent)) &&
            (identical(other.salesShowUnit, salesShowUnit) || const DeepCollectionEquality().equals(other.salesShowUnit, salesShowUnit)) &&
            (identical(other.salesShowPeriodCostExtended, salesShowPeriodCostExtended) || const DeepCollectionEquality().equals(other.salesShowPeriodCostExtended, salesShowPeriodCostExtended)) &&
            (identical(other.salesShowDiscountPercent, salesShowDiscountPercent) || const DeepCollectionEquality().equals(other.salesShowDiscountPercent, salesShowDiscountPercent)) &&
            (identical(other.salesShowUnitDiscountAmount, salesShowUnitDiscountAmount) || const DeepCollectionEquality().equals(other.salesShowUnitDiscountAmount, salesShowUnitDiscountAmount)) &&
            (identical(other.salesShowUnitExtended, salesShowUnitExtended) || const DeepCollectionEquality().equals(other.salesShowUnitExtended, salesShowUnitExtended)) &&
            (identical(other.salesShowPeriodDiscountAmount, salesShowPeriodDiscountAmount) || const DeepCollectionEquality().equals(other.salesShowPeriodDiscountAmount, salesShowPeriodDiscountAmount)) &&
            (identical(other.salesShowPeriodExtended, salesShowPeriodExtended) || const DeepCollectionEquality().equals(other.salesShowPeriodExtended, salesShowPeriodExtended)) &&
            (identical(other.salesShowVariancePercent, salesShowVariancePercent) || const DeepCollectionEquality().equals(other.salesShowVariancePercent, salesShowVariancePercent)) &&
            (identical(other.salesShowVarianceExtended, salesShowVarianceExtended) || const DeepCollectionEquality().equals(other.salesShowVarianceExtended, salesShowVarianceExtended)) &&
            (identical(other.salesShowWarehouse, salesShowWarehouse) || const DeepCollectionEquality().equals(other.salesShowWarehouse, salesShowWarehouse)) &&
            (identical(other.salesShowTaxable, salesShowTaxable) || const DeepCollectionEquality().equals(other.salesShowTaxable, salesShowTaxable)) &&
            (identical(other.salesShowNotes, salesShowNotes) || const DeepCollectionEquality().equals(other.salesShowNotes, salesShowNotes)) &&
            (identical(other.salesDateStamp, salesDateStamp) || const DeepCollectionEquality().equals(other.salesDateStamp, salesDateStamp)) &&
            (identical(other.salesInventoryPrice, salesInventoryPrice) || const DeepCollectionEquality().equals(other.salesInventoryPrice, salesInventoryPrice)) &&
            (identical(other.salesInventoryCost, salesInventoryCost) || const DeepCollectionEquality().equals(other.salesInventoryCost, salesInventoryCost)) &&
            (identical(other.facilityShowDescription, facilityShowDescription) || const DeepCollectionEquality().equals(other.facilityShowDescription, facilityShowDescription)) &&
            (identical(other.facilityDescriptionWidth, facilityDescriptionWidth) || const DeepCollectionEquality().equals(other.facilityDescriptionWidth, facilityDescriptionWidth)) &&
            (identical(other.facilityShowFromDate, facilityShowFromDate) || const DeepCollectionEquality().equals(other.facilityShowFromDate, facilityShowFromDate)) &&
            (identical(other.facilityShowFromTime, facilityShowFromTime) || const DeepCollectionEquality().equals(other.facilityShowFromTime, facilityShowFromTime)) &&
            (identical(other.facilityShowToDate, facilityShowToDate) || const DeepCollectionEquality().equals(other.facilityShowToDate, facilityShowToDate)) &&
            (identical(other.facilityShowToTime, facilityShowToTime) || const DeepCollectionEquality().equals(other.facilityShowToTime, facilityShowToTime)) &&
            (identical(other.facilityShowWeeksAndDays, facilityShowWeeksAndDays) || const DeepCollectionEquality().equals(other.facilityShowWeeksAndDays, facilityShowWeeksAndDays)) &&
            (identical(other.facilityShowMonthsAndDays, facilityShowMonthsAndDays) || const DeepCollectionEquality().equals(other.facilityShowMonthsAndDays, facilityShowMonthsAndDays)) &&
            (identical(other.facilityShowBillablePeriods, facilityShowBillablePeriods) || const DeepCollectionEquality().equals(other.facilityShowBillablePeriods, facilityShowBillablePeriods)) &&
            (identical(other.facilityShowRate, facilityShowRate) || const DeepCollectionEquality().equals(other.facilityShowRate, facilityShowRate)) &&
            (identical(other.facilityShowDaysPerWeek, facilityShowDaysPerWeek) || const DeepCollectionEquality().equals(other.facilityShowDaysPerWeek, facilityShowDaysPerWeek)) &&
            (identical(other.facilityShowDiscountPercent, facilityShowDiscountPercent) || const DeepCollectionEquality().equals(other.facilityShowDiscountPercent, facilityShowDiscountPercent)) &&
            (identical(other.facilityShowSplit, facilityShowSplit) || const DeepCollectionEquality().equals(other.facilityShowSplit, facilityShowSplit)) &&
            (identical(other.facilityShowUnit, facilityShowUnit) || const DeepCollectionEquality().equals(other.facilityShowUnit, facilityShowUnit)) &&
            (identical(other.facilityShowUnitDiscountAmount, facilityShowUnitDiscountAmount) || const DeepCollectionEquality().equals(other.facilityShowUnitDiscountAmount, facilityShowUnitDiscountAmount)) &&
            (identical(other.facilityShowUnitExtended, facilityShowUnitExtended) || const DeepCollectionEquality().equals(other.facilityShowUnitExtended, facilityShowUnitExtended)) &&
            (identical(other.facilityShowWeeklyDiscountAmount, facilityShowWeeklyDiscountAmount) || const DeepCollectionEquality().equals(other.facilityShowWeeklyDiscountAmount, facilityShowWeeklyDiscountAmount)) &&
            (identical(other.facilityShowWeeklyExtended, facilityShowWeeklyExtended) || const DeepCollectionEquality().equals(other.facilityShowWeeklyExtended, facilityShowWeeklyExtended)) &&
            (identical(other.facilityShowMonthlyDiscountAmount, facilityShowMonthlyDiscountAmount) || const DeepCollectionEquality().equals(other.facilityShowMonthlyDiscountAmount, facilityShowMonthlyDiscountAmount)) &&
            (identical(other.facilityShowMonthlyExtended, facilityShowMonthlyExtended) || const DeepCollectionEquality().equals(other.facilityShowMonthlyExtended, facilityShowMonthlyExtended)) &&
            (identical(other.facilityShowPeriodDiscountAmount, facilityShowPeriodDiscountAmount) || const DeepCollectionEquality().equals(other.facilityShowPeriodDiscountAmount, facilityShowPeriodDiscountAmount)) &&
            (identical(other.facilityShowPeriodExtended, facilityShowPeriodExtended) || const DeepCollectionEquality().equals(other.facilityShowPeriodExtended, facilityShowPeriodExtended)) &&
            (identical(other.facilityShowTaxable, facilityShowTaxable) || const DeepCollectionEquality().equals(other.facilityShowTaxable, facilityShowTaxable)) &&
            (identical(other.facilityShowNotes, facilityShowNotes) || const DeepCollectionEquality().equals(other.facilityShowNotes, facilityShowNotes)) &&
            (identical(other.facilityDateStamp, facilityDateStamp) || const DeepCollectionEquality().equals(other.facilityDateStamp, facilityDateStamp)) &&
            (identical(other.facilityDescription, facilityDescription) || const DeepCollectionEquality().equals(other.facilityDescription, facilityDescription)) &&
            (identical(other.vehicleShowDescription, vehicleShowDescription) || const DeepCollectionEquality().equals(other.vehicleShowDescription, vehicleShowDescription)) &&
            (identical(other.vehicleDescriptionWidth, vehicleDescriptionWidth) || const DeepCollectionEquality().equals(other.vehicleDescriptionWidth, vehicleDescriptionWidth)) &&
            (identical(other.vehicleShowVehicleNumber, vehicleShowVehicleNumber) || const DeepCollectionEquality().equals(other.vehicleShowVehicleNumber, vehicleShowVehicleNumber)) &&
            (identical(other.vehicleShowPickDate, vehicleShowPickDate) || const DeepCollectionEquality().equals(other.vehicleShowPickDate, vehicleShowPickDate)) &&
            (identical(other.vehicleShowPickTime, vehicleShowPickTime) || const DeepCollectionEquality().equals(other.vehicleShowPickTime, vehicleShowPickTime)) &&
            (identical(other.vehicleShowFromDate, vehicleShowFromDate) || const DeepCollectionEquality().equals(other.vehicleShowFromDate, vehicleShowFromDate)) &&
            (identical(other.vehicleShowFromTime, vehicleShowFromTime) || const DeepCollectionEquality().equals(other.vehicleShowFromTime, vehicleShowFromTime)) &&
            (identical(other.vehicleShowToDate, vehicleShowToDate) || const DeepCollectionEquality().equals(other.vehicleShowToDate, vehicleShowToDate)) &&
            (identical(other.vehicleShowToTime, vehicleShowToTime) || const DeepCollectionEquality().equals(other.vehicleShowToTime, vehicleShowToTime)) &&
            (identical(other.vehicleShowBillablePeriods, vehicleShowBillablePeriods) || const DeepCollectionEquality().equals(other.vehicleShowBillablePeriods, vehicleShowBillablePeriods)) &&
            (identical(other.vehicleShowSubQuantity, vehicleShowSubQuantity) || const DeepCollectionEquality().equals(other.vehicleShowSubQuantity, vehicleShowSubQuantity)) &&
            (identical(other.vehicleShowAvailableQuantity, vehicleShowAvailableQuantity) || const DeepCollectionEquality().equals(other.vehicleShowAvailableQuantity, vehicleShowAvailableQuantity)) &&
            (identical(other.vehicleShowConflictDate, vehicleShowConflictDate) || const DeepCollectionEquality().equals(other.vehicleShowConflictDate, vehicleShowConflictDate)) &&
            (identical(other.vehicleShowUnit, vehicleShowUnit) || const DeepCollectionEquality().equals(other.vehicleShowUnit, vehicleShowUnit)) &&
            (identical(other.vehicleShowRate, vehicleShowRate) || const DeepCollectionEquality().equals(other.vehicleShowRate, vehicleShowRate)) &&
            (identical(other.vehicleShowDaysPerWeek, vehicleShowDaysPerWeek) || const DeepCollectionEquality().equals(other.vehicleShowDaysPerWeek, vehicleShowDaysPerWeek)) &&
            (identical(other.vehicleShowCost, vehicleShowCost) || const DeepCollectionEquality().equals(other.vehicleShowCost, vehicleShowCost)) &&
            (identical(other.vehicleShowWeeklyCostExtended, vehicleShowWeeklyCostExtended) || const DeepCollectionEquality().equals(other.vehicleShowWeeklyCostExtended, vehicleShowWeeklyCostExtended)) &&
            (identical(other.vehicleShowMonthlyCostExtended, vehicleShowMonthlyCostExtended) || const DeepCollectionEquality().equals(other.vehicleShowMonthlyCostExtended, vehicleShowMonthlyCostExtended)) &&
            (identical(other.vehicleShowPeriodCostExtended, vehicleShowPeriodCostExtended) || const DeepCollectionEquality().equals(other.vehicleShowPeriodCostExtended, vehicleShowPeriodCostExtended)) &&
            (identical(other.vehicleShowDiscountPercent, vehicleShowDiscountPercent) || const DeepCollectionEquality().equals(other.vehicleShowDiscountPercent, vehicleShowDiscountPercent)) &&
            (identical(other.vehicleShowUnitDiscountAmount, vehicleShowUnitDiscountAmount) || const DeepCollectionEquality().equals(other.vehicleShowUnitDiscountAmount, vehicleShowUnitDiscountAmount)) &&
            (identical(other.vehicleShowUnitExtended, vehicleShowUnitExtended) || const DeepCollectionEquality().equals(other.vehicleShowUnitExtended, vehicleShowUnitExtended)) &&
            (identical(other.vehicleShowWeeklyDiscountAmount, vehicleShowWeeklyDiscountAmount) || const DeepCollectionEquality().equals(other.vehicleShowWeeklyDiscountAmount, vehicleShowWeeklyDiscountAmount)) &&
            (identical(other.vehicleShowWeeklyExtended, vehicleShowWeeklyExtended) || const DeepCollectionEquality().equals(other.vehicleShowWeeklyExtended, vehicleShowWeeklyExtended)) &&
            (identical(other.vehicleShowMonthlyDiscountAmount, vehicleShowMonthlyDiscountAmount) || const DeepCollectionEquality().equals(other.vehicleShowMonthlyDiscountAmount, vehicleShowMonthlyDiscountAmount)) &&
            (identical(other.vehicleShowMonthlyExtended, vehicleShowMonthlyExtended) || const DeepCollectionEquality().equals(other.vehicleShowMonthlyExtended, vehicleShowMonthlyExtended)) &&
            (identical(other.vehicleShowPeriodDiscountAmount, vehicleShowPeriodDiscountAmount) || const DeepCollectionEquality().equals(other.vehicleShowPeriodDiscountAmount, vehicleShowPeriodDiscountAmount)) &&
            (identical(other.vehicleShowPeriodExtended, vehicleShowPeriodExtended) || const DeepCollectionEquality().equals(other.vehicleShowPeriodExtended, vehicleShowPeriodExtended)) &&
            (identical(other.vehicleShowWarehouse, vehicleShowWarehouse) || const DeepCollectionEquality().equals(other.vehicleShowWarehouse, vehicleShowWarehouse)) &&
            (identical(other.vehicleShowReturnToWarehouse, vehicleShowReturnToWarehouse) || const DeepCollectionEquality().equals(other.vehicleShowReturnToWarehouse, vehicleShowReturnToWarehouse)) &&
            (identical(other.vehicleShowTaxable, vehicleShowTaxable) || const DeepCollectionEquality().equals(other.vehicleShowTaxable, vehicleShowTaxable)) &&
            (identical(other.vehicleShowNotes, vehicleShowNotes) || const DeepCollectionEquality().equals(other.vehicleShowNotes, vehicleShowNotes)) &&
            (identical(other.vehicleDateStamp, vehicleDateStamp) || const DeepCollectionEquality().equals(other.vehicleDateStamp, vehicleDateStamp)) &&
            (identical(other.laborShowICode, laborShowICode) || const DeepCollectionEquality().equals(other.laborShowICode, laborShowICode)) &&
            (identical(other.laborICodeWidth, laborICodeWidth) || const DeepCollectionEquality().equals(other.laborICodeWidth, laborICodeWidth)) &&
            (identical(other.laborShowDescription, laborShowDescription) || const DeepCollectionEquality().equals(other.laborShowDescription, laborShowDescription)) &&
            (identical(other.laborDescriptionWidth, laborDescriptionWidth) || const DeepCollectionEquality().equals(other.laborDescriptionWidth, laborDescriptionWidth)) &&
            (identical(other.laborShowOrderActivity, laborShowOrderActivity) || const DeepCollectionEquality().equals(other.laborShowOrderActivity, laborShowOrderActivity)) &&
            (identical(other.laborShowCrewName, laborShowCrewName) || const DeepCollectionEquality().equals(other.laborShowCrewName, laborShowCrewName)) &&
            (identical(other.laborShowFromDate, laborShowFromDate) || const DeepCollectionEquality().equals(other.laborShowFromDate, laborShowFromDate)) &&
            (identical(other.laborShowFromTime, laborShowFromTime) || const DeepCollectionEquality().equals(other.laborShowFromTime, laborShowFromTime)) &&
            (identical(other.laborShowToDate, laborShowToDate) || const DeepCollectionEquality().equals(other.laborShowToDate, laborShowToDate)) &&
            (identical(other.laborShowToTime, laborShowToTime) || const DeepCollectionEquality().equals(other.laborShowToTime, laborShowToTime)) &&
            (identical(other.laborShowBillablePeriods, laborShowBillablePeriods) || const DeepCollectionEquality().equals(other.laborShowBillablePeriods, laborShowBillablePeriods)) &&
            (identical(other.laborShowHours, laborShowHours) || const DeepCollectionEquality().equals(other.laborShowHours, laborShowHours)) &&
            (identical(other.laborShowSubQuantity, laborShowSubQuantity) || const DeepCollectionEquality().equals(other.laborShowSubQuantity, laborShowSubQuantity)) &&
            (identical(other.laborShowCost, laborShowCost) || const DeepCollectionEquality().equals(other.laborShowCost, laborShowCost)) &&
            (identical(other.laborShowRate, laborShowRate) || const DeepCollectionEquality().equals(other.laborShowRate, laborShowRate)) &&
            (identical(other.laborShowPeriodCostExtended, laborShowPeriodCostExtended) || const DeepCollectionEquality().equals(other.laborShowPeriodCostExtended, laborShowPeriodCostExtended)) &&
            (identical(other.laborShowDiscountPercent, laborShowDiscountPercent) || const DeepCollectionEquality().equals(other.laborShowDiscountPercent, laborShowDiscountPercent)) &&
            (identical(other.laborShowUnit, laborShowUnit) || const DeepCollectionEquality().equals(other.laborShowUnit, laborShowUnit)) &&
            (identical(other.laborShowUnitDiscountAmount, laborShowUnitDiscountAmount) || const DeepCollectionEquality().equals(other.laborShowUnitDiscountAmount, laborShowUnitDiscountAmount)) &&
            (identical(other.laborShowUnitExtended, laborShowUnitExtended) || const DeepCollectionEquality().equals(other.laborShowUnitExtended, laborShowUnitExtended)) &&
            (identical(other.laborShowWeeklyDiscountAmount, laborShowWeeklyDiscountAmount) || const DeepCollectionEquality().equals(other.laborShowWeeklyDiscountAmount, laborShowWeeklyDiscountAmount)) &&
            (identical(other.laborShowWeeklyExtended, laborShowWeeklyExtended) || const DeepCollectionEquality().equals(other.laborShowWeeklyExtended, laborShowWeeklyExtended)) &&
            (identical(other.laborShowMonthlyDiscountAmount, laborShowMonthlyDiscountAmount) || const DeepCollectionEquality().equals(other.laborShowMonthlyDiscountAmount, laborShowMonthlyDiscountAmount)) &&
            (identical(other.laborShowMonthlyExtended, laborShowMonthlyExtended) || const DeepCollectionEquality().equals(other.laborShowMonthlyExtended, laborShowMonthlyExtended)) &&
            (identical(other.laborShowPeriodDiscountAmount, laborShowPeriodDiscountAmount) || const DeepCollectionEquality().equals(other.laborShowPeriodDiscountAmount, laborShowPeriodDiscountAmount)) &&
            (identical(other.laborShowPeriodExtended, laborShowPeriodExtended) || const DeepCollectionEquality().equals(other.laborShowPeriodExtended, laborShowPeriodExtended)) &&
            (identical(other.laborShowWarehouse, laborShowWarehouse) || const DeepCollectionEquality().equals(other.laborShowWarehouse, laborShowWarehouse)) &&
            (identical(other.laborShowTaxable, laborShowTaxable) || const DeepCollectionEquality().equals(other.laborShowTaxable, laborShowTaxable)) &&
            (identical(other.laborShowNotes, laborShowNotes) || const DeepCollectionEquality().equals(other.laborShowNotes, laborShowNotes)) &&
            (identical(other.laborDateStamp, laborDateStamp) || const DeepCollectionEquality().equals(other.laborDateStamp, laborDateStamp)) &&
            (identical(other.hideCrewBreaks, hideCrewBreaks) || const DeepCollectionEquality().equals(other.hideCrewBreaks, hideCrewBreaks)) &&
            (identical(other.break1Paid, break1Paid) || const DeepCollectionEquality().equals(other.break1Paid, break1Paid)) &&
            (identical(other.break2Paid, break2Paid) || const DeepCollectionEquality().equals(other.break2Paid, break2Paid)) &&
            (identical(other.break3Paid, break3Paid) || const DeepCollectionEquality().equals(other.break3Paid, break3Paid)) &&
            (identical(other.miscShowICode, miscShowICode) || const DeepCollectionEquality().equals(other.miscShowICode, miscShowICode)) &&
            (identical(other.miscICodeWidth, miscICodeWidth) || const DeepCollectionEquality().equals(other.miscICodeWidth, miscICodeWidth)) &&
            (identical(other.miscShowDescription, miscShowDescription) || const DeepCollectionEquality().equals(other.miscShowDescription, miscShowDescription)) &&
            (identical(other.miscDescriptionWidth, miscDescriptionWidth) || const DeepCollectionEquality().equals(other.miscDescriptionWidth, miscDescriptionWidth)) &&
            (identical(other.miscShowFromDate, miscShowFromDate) || const DeepCollectionEquality().equals(other.miscShowFromDate, miscShowFromDate)) &&
            (identical(other.miscShowFromTime, miscShowFromTime) || const DeepCollectionEquality().equals(other.miscShowFromTime, miscShowFromTime)) &&
            (identical(other.miscShowToDate, miscShowToDate) || const DeepCollectionEquality().equals(other.miscShowToDate, miscShowToDate)) &&
            (identical(other.miscShowToTime, miscShowToTime) || const DeepCollectionEquality().equals(other.miscShowToTime, miscShowToTime)) &&
            (identical(other.miscShowBillablePeriods, miscShowBillablePeriods) || const DeepCollectionEquality().equals(other.miscShowBillablePeriods, miscShowBillablePeriods)) &&
            (identical(other.miscShowSubQuantity, miscShowSubQuantity) || const DeepCollectionEquality().equals(other.miscShowSubQuantity, miscShowSubQuantity)) &&
            (identical(other.miscShowWeeksAndDays, miscShowWeeksAndDays) || const DeepCollectionEquality().equals(other.miscShowWeeksAndDays, miscShowWeeksAndDays)) &&
            (identical(other.miscShowMonthsAndDays, miscShowMonthsAndDays) || const DeepCollectionEquality().equals(other.miscShowMonthsAndDays, miscShowMonthsAndDays)) &&
            (identical(other.miscShowUnit, miscShowUnit) || const DeepCollectionEquality().equals(other.miscShowUnit, miscShowUnit)) &&
            (identical(other.miscShowRate, miscShowRate) || const DeepCollectionEquality().equals(other.miscShowRate, miscShowRate)) &&
            (identical(other.miscShowCost, miscShowCost) || const DeepCollectionEquality().equals(other.miscShowCost, miscShowCost)) &&
            (identical(other.miscShowPeriodCostExtended, miscShowPeriodCostExtended) || const DeepCollectionEquality().equals(other.miscShowPeriodCostExtended, miscShowPeriodCostExtended)) &&
            (identical(other.miscShowDiscountPercent, miscShowDiscountPercent) || const DeepCollectionEquality().equals(other.miscShowDiscountPercent, miscShowDiscountPercent)) &&
            (identical(other.miscShowUnitDiscountAmount, miscShowUnitDiscountAmount) || const DeepCollectionEquality().equals(other.miscShowUnitDiscountAmount, miscShowUnitDiscountAmount)) &&
            (identical(other.miscShowUnitExtended, miscShowUnitExtended) || const DeepCollectionEquality().equals(other.miscShowUnitExtended, miscShowUnitExtended)) &&
            (identical(other.miscShowWeeklyDiscountAmount, miscShowWeeklyDiscountAmount) || const DeepCollectionEquality().equals(other.miscShowWeeklyDiscountAmount, miscShowWeeklyDiscountAmount)) &&
            (identical(other.miscShowWeeklyExtended, miscShowWeeklyExtended) || const DeepCollectionEquality().equals(other.miscShowWeeklyExtended, miscShowWeeklyExtended)) &&
            (identical(other.miscShowMonthlyDiscountAmount, miscShowMonthlyDiscountAmount) || const DeepCollectionEquality().equals(other.miscShowMonthlyDiscountAmount, miscShowMonthlyDiscountAmount)) &&
            (identical(other.miscShowMonthlyExtended, miscShowMonthlyExtended) || const DeepCollectionEquality().equals(other.miscShowMonthlyExtended, miscShowMonthlyExtended)) &&
            (identical(other.miscShowPeriodDiscountAmount, miscShowPeriodDiscountAmount) || const DeepCollectionEquality().equals(other.miscShowPeriodDiscountAmount, miscShowPeriodDiscountAmount)) &&
            (identical(other.miscShowPeriodExtended, miscShowPeriodExtended) || const DeepCollectionEquality().equals(other.miscShowPeriodExtended, miscShowPeriodExtended)) &&
            (identical(other.miscShowWarehouse, miscShowWarehouse) || const DeepCollectionEquality().equals(other.miscShowWarehouse, miscShowWarehouse)) &&
            (identical(other.miscShowTaxable, miscShowTaxable) || const DeepCollectionEquality().equals(other.miscShowTaxable, miscShowTaxable)) &&
            (identical(other.miscShowNotes, miscShowNotes) || const DeepCollectionEquality().equals(other.miscShowNotes, miscShowNotes)) &&
            (identical(other.miscDateStamp, miscDateStamp) || const DeepCollectionEquality().equals(other.miscDateStamp, miscDateStamp)) &&
            (identical(other.rentalSaleShowBarCode, rentalSaleShowBarCode) || const DeepCollectionEquality().equals(other.rentalSaleShowBarCode, rentalSaleShowBarCode)) &&
            (identical(other.rentalSaleShowSerialNumber, rentalSaleShowSerialNumber) || const DeepCollectionEquality().equals(other.rentalSaleShowSerialNumber, rentalSaleShowSerialNumber)) &&
            (identical(other.rentalSaleShowICode, rentalSaleShowICode) || const DeepCollectionEquality().equals(other.rentalSaleShowICode, rentalSaleShowICode)) &&
            (identical(other.rentalSaleICodeWidth, rentalSaleICodeWidth) || const DeepCollectionEquality().equals(other.rentalSaleICodeWidth, rentalSaleICodeWidth)) &&
            (identical(other.rentalSaleShowDescription, rentalSaleShowDescription) || const DeepCollectionEquality().equals(other.rentalSaleShowDescription, rentalSaleShowDescription)) &&
            (identical(other.rentalSaleDescriptionWidth, rentalSaleDescriptionWidth) || const DeepCollectionEquality().equals(other.rentalSaleDescriptionWidth, rentalSaleDescriptionWidth)) &&
            (identical(other.rentalSaleShowPickDate, rentalSaleShowPickDate) || const DeepCollectionEquality().equals(other.rentalSaleShowPickDate, rentalSaleShowPickDate)) &&
            (identical(other.rentalSaleShowPickTime, rentalSaleShowPickTime) || const DeepCollectionEquality().equals(other.rentalSaleShowPickTime, rentalSaleShowPickTime)) &&
            (identical(other.rentalSaleShowAvailableQuantity, rentalSaleShowAvailableQuantity) || const DeepCollectionEquality().equals(other.rentalSaleShowAvailableQuantity, rentalSaleShowAvailableQuantity)) &&
            (identical(other.rentalSaleShowConflictDate, rentalSaleShowConflictDate) || const DeepCollectionEquality().equals(other.rentalSaleShowConflictDate, rentalSaleShowConflictDate)) &&
            (identical(other.rentalSaleShowUnit, rentalSaleShowUnit) || const DeepCollectionEquality().equals(other.rentalSaleShowUnit, rentalSaleShowUnit)) &&
            (identical(other.rentalSaleShowRate, rentalSaleShowRate) || const DeepCollectionEquality().equals(other.rentalSaleShowRate, rentalSaleShowRate)) &&
            (identical(other.rentalSaleShowCost, rentalSaleShowCost) || const DeepCollectionEquality().equals(other.rentalSaleShowCost, rentalSaleShowCost)) &&
            (identical(other.rentalSaleShowPeriodCostExtended, rentalSaleShowPeriodCostExtended) || const DeepCollectionEquality().equals(other.rentalSaleShowPeriodCostExtended, rentalSaleShowPeriodCostExtended)) &&
            (identical(other.rentalSaleShowDiscountPercent, rentalSaleShowDiscountPercent) || const DeepCollectionEquality().equals(other.rentalSaleShowDiscountPercent, rentalSaleShowDiscountPercent)) &&
            (identical(other.rentalSaleShowUnitDiscountAmount, rentalSaleShowUnitDiscountAmount) || const DeepCollectionEquality().equals(other.rentalSaleShowUnitDiscountAmount, rentalSaleShowUnitDiscountAmount)) &&
            (identical(other.rentalSaleShowUnitExtended, rentalSaleShowUnitExtended) || const DeepCollectionEquality().equals(other.rentalSaleShowUnitExtended, rentalSaleShowUnitExtended)) &&
            (identical(other.rentalSaleShowPeriodDiscountAmount, rentalSaleShowPeriodDiscountAmount) || const DeepCollectionEquality().equals(other.rentalSaleShowPeriodDiscountAmount, rentalSaleShowPeriodDiscountAmount)) &&
            (identical(other.rentalSaleShowPeriodExtended, rentalSaleShowPeriodExtended) || const DeepCollectionEquality().equals(other.rentalSaleShowPeriodExtended, rentalSaleShowPeriodExtended)) &&
            (identical(other.rentalSaleShowWarehouse, rentalSaleShowWarehouse) || const DeepCollectionEquality().equals(other.rentalSaleShowWarehouse, rentalSaleShowWarehouse)) &&
            (identical(other.rentalSaleShowTaxable, rentalSaleShowTaxable) || const DeepCollectionEquality().equals(other.rentalSaleShowTaxable, rentalSaleShowTaxable)) &&
            (identical(other.rentalSaleShowNotes, rentalSaleShowNotes) || const DeepCollectionEquality().equals(other.rentalSaleShowNotes, rentalSaleShowNotes)) &&
            (identical(other.rentalSaleDateStamp, rentalSaleDateStamp) || const DeepCollectionEquality().equals(other.rentalSaleDateStamp, rentalSaleDateStamp)) &&
            (identical(other.lossAndDamageShowOrderNumber, lossAndDamageShowOrderNumber) || const DeepCollectionEquality().equals(other.lossAndDamageShowOrderNumber, lossAndDamageShowOrderNumber)) &&
            (identical(other.lossAndDamageShowRepairOrderNumber, lossAndDamageShowRepairOrderNumber) || const DeepCollectionEquality().equals(other.lossAndDamageShowRepairOrderNumber, lossAndDamageShowRepairOrderNumber)) &&
            (identical(other.lossAndDamageShowBarCode, lossAndDamageShowBarCode) || const DeepCollectionEquality().equals(other.lossAndDamageShowBarCode, lossAndDamageShowBarCode)) &&
            (identical(other.lossAndDamageShowSerialNumber, lossAndDamageShowSerialNumber) || const DeepCollectionEquality().equals(other.lossAndDamageShowSerialNumber, lossAndDamageShowSerialNumber)) &&
            (identical(other.lossAndDamageShowICode, lossAndDamageShowICode) || const DeepCollectionEquality().equals(other.lossAndDamageShowICode, lossAndDamageShowICode)) &&
            (identical(other.lossAndDamageICodeWidth, lossAndDamageICodeWidth) || const DeepCollectionEquality().equals(other.lossAndDamageICodeWidth, lossAndDamageICodeWidth)) &&
            (identical(other.lossAndDamageShowDescription, lossAndDamageShowDescription) || const DeepCollectionEquality().equals(other.lossAndDamageShowDescription, lossAndDamageShowDescription)) &&
            (identical(other.lossAndDamageDescriptionWidth, lossAndDamageDescriptionWidth) || const DeepCollectionEquality().equals(other.lossAndDamageDescriptionWidth, lossAndDamageDescriptionWidth)) &&
            (identical(other.lossAndDamageShowUnit, lossAndDamageShowUnit) || const DeepCollectionEquality().equals(other.lossAndDamageShowUnit, lossAndDamageShowUnit)) &&
            (identical(other.lossAndDamageShowRate, lossAndDamageShowRate) || const DeepCollectionEquality().equals(other.lossAndDamageShowRate, lossAndDamageShowRate)) &&
            (identical(other.lossAndDamageShowCost, lossAndDamageShowCost) || const DeepCollectionEquality().equals(other.lossAndDamageShowCost, lossAndDamageShowCost)) &&
            (identical(other.lossAndDamageShowDiscountPercent, lossAndDamageShowDiscountPercent) || const DeepCollectionEquality().equals(other.lossAndDamageShowDiscountPercent, lossAndDamageShowDiscountPercent)) &&
            (identical(other.lossAndDamageShowUnitDiscountAmount, lossAndDamageShowUnitDiscountAmount) || const DeepCollectionEquality().equals(other.lossAndDamageShowUnitDiscountAmount, lossAndDamageShowUnitDiscountAmount)) &&
            (identical(other.lossAndDamageShowUnitExtended, lossAndDamageShowUnitExtended) || const DeepCollectionEquality().equals(other.lossAndDamageShowUnitExtended, lossAndDamageShowUnitExtended)) &&
            (identical(other.lossAndDamageShowPeriodDiscountAmount, lossAndDamageShowPeriodDiscountAmount) || const DeepCollectionEquality().equals(other.lossAndDamageShowPeriodDiscountAmount, lossAndDamageShowPeriodDiscountAmount)) &&
            (identical(other.lossAndDamageShowPeriodExtended, lossAndDamageShowPeriodExtended) || const DeepCollectionEquality().equals(other.lossAndDamageShowPeriodExtended, lossAndDamageShowPeriodExtended)) &&
            (identical(other.lossAndDamageShowWarehouse, lossAndDamageShowWarehouse) || const DeepCollectionEquality().equals(other.lossAndDamageShowWarehouse, lossAndDamageShowWarehouse)) &&
            (identical(other.lossAndDamageShowTaxable, lossAndDamageShowTaxable) || const DeepCollectionEquality().equals(other.lossAndDamageShowTaxable, lossAndDamageShowTaxable)) &&
            (identical(other.lossAndDamageShowNotes, lossAndDamageShowNotes) || const DeepCollectionEquality().equals(other.lossAndDamageShowNotes, lossAndDamageShowNotes)) &&
            (identical(other.lossAndDamageDateStamp, lossAndDamageDateStamp) || const DeepCollectionEquality().equals(other.lossAndDamageDateStamp, lossAndDamageDateStamp)) &&
            (identical(other.addInstallationAndStrikeFee, addInstallationAndStrikeFee) || const DeepCollectionEquality().equals(other.addInstallationAndStrikeFee, addInstallationAndStrikeFee)) &&
            (identical(other.installationAndStrikeFeeRateId, installationAndStrikeFeeRateId) || const DeepCollectionEquality().equals(other.installationAndStrikeFeeRateId, installationAndStrikeFeeRateId)) &&
            (identical(other.installationAndStrikeFeeICode, installationAndStrikeFeeICode) || const DeepCollectionEquality().equals(other.installationAndStrikeFeeICode, installationAndStrikeFeeICode)) &&
            (identical(other.installationAndStrikeFeeDescription, installationAndStrikeFeeDescription) || const DeepCollectionEquality().equals(other.installationAndStrikeFeeDescription, installationAndStrikeFeeDescription)) &&
            (identical(other.installationAndStrikeFeePercent, installationAndStrikeFeePercent) || const DeepCollectionEquality().equals(other.installationAndStrikeFeePercent, installationAndStrikeFeePercent)) &&
            (identical(other.installationAndStrikeFeeBasedOn, installationAndStrikeFeeBasedOn) || const DeepCollectionEquality().equals(other.installationAndStrikeFeeBasedOn, installationAndStrikeFeeBasedOn)) &&
            (identical(other.addManagementAndServiceFee, addManagementAndServiceFee) || const DeepCollectionEquality().equals(other.addManagementAndServiceFee, addManagementAndServiceFee)) &&
            (identical(other.managementAndServiceFeeRateId, managementAndServiceFeeRateId) || const DeepCollectionEquality().equals(other.managementAndServiceFeeRateId, managementAndServiceFeeRateId)) &&
            (identical(other.managementAndServiceFeeICode, managementAndServiceFeeICode) || const DeepCollectionEquality().equals(other.managementAndServiceFeeICode, managementAndServiceFeeICode)) &&
            (identical(other.managementAndServiceFeeDescription, managementAndServiceFeeDescription) || const DeepCollectionEquality().equals(other.managementAndServiceFeeDescription, managementAndServiceFeeDescription)) &&
            (identical(other.managementAndServiceFeePercent, managementAndServiceFeePercent) || const DeepCollectionEquality().equals(other.managementAndServiceFeePercent, managementAndServiceFeePercent)) &&
            (identical(other.managementAndServiceFeeBasedOn, managementAndServiceFeeBasedOn) || const DeepCollectionEquality().equals(other.managementAndServiceFeeBasedOn, managementAndServiceFeeBasedOn)) &&
            (identical(other.defaultRentalSalePrice, defaultRentalSalePrice) || const DeepCollectionEquality().equals(other.defaultRentalSalePrice, defaultRentalSalePrice)) &&
            (identical(other.quikPayDiscount, quikPayDiscount) || const DeepCollectionEquality().equals(other.quikPayDiscount, quikPayDiscount)) &&
            (identical(other.quikPayDiscountType, quikPayDiscountType) || const DeepCollectionEquality().equals(other.quikPayDiscountType, quikPayDiscountType)) &&
            (identical(other.quikPayDiscountDays, quikPayDiscountDays) || const DeepCollectionEquality().equals(other.quikPayDiscountDays, quikPayDiscountDays)) &&
            (identical(other.quikPayDiscountPercent, quikPayDiscountPercent) || const DeepCollectionEquality().equals(other.quikPayDiscountPercent, quikPayDiscountPercent)) &&
            (identical(other.quikPayDiscountExcludeSubs, quikPayDiscountExcludeSubs) || const DeepCollectionEquality().equals(other.quikPayDiscountExcludeSubs, quikPayDiscountExcludeSubs)) &&
            (identical(other.quikConfirmDiscount, quikConfirmDiscount) || const DeepCollectionEquality().equals(other.quikConfirmDiscount, quikConfirmDiscount)) &&
            (identical(other.quikConfirmDiscountPercent, quikConfirmDiscountPercent) || const DeepCollectionEquality().equals(other.quikConfirmDiscountPercent, quikConfirmDiscountPercent)) &&
            (identical(other.quikConfirmDiscountDays, quikConfirmDiscountDays) || const DeepCollectionEquality().equals(other.quikConfirmDiscountDays, quikConfirmDiscountDays)) &&
            (identical(other.disableCostGl, disableCostGl) || const DeepCollectionEquality().equals(other.disableCostGl, disableCostGl)) &&
            (identical(other.excludeFromTopSalesDashboard, excludeFromTopSalesDashboard) || const DeepCollectionEquality().equals(other.excludeFromTopSalesDashboard, excludeFromTopSalesDashboard)) &&
            (identical(other.separatePackageOnQuoteOrder, separatePackageOnQuoteOrder) || const DeepCollectionEquality().equals(other.separatePackageOnQuoteOrder, separatePackageOnQuoteOrder)) &&
            (identical(other.orderby, orderby) || const DeepCollectionEquality().equals(other.orderby, orderby)) &&
            (identical(other.subAllShortagesSubMiscellaneous, subAllShortagesSubMiscellaneous) || const DeepCollectionEquality().equals(other.subAllShortagesSubMiscellaneous, subAllShortagesSubMiscellaneous)) &&
            (identical(other.inactive, inactive) || const DeepCollectionEquality().equals(other.inactive, inactive)) &&
            (identical(other.combinedShowFields, combinedShowFields) || const DeepCollectionEquality().equals(other.combinedShowFields, combinedShowFields)) &&
            (identical(other.rentalShowFields, rentalShowFields) || const DeepCollectionEquality().equals(other.rentalShowFields, rentalShowFields)) &&
            (identical(other.salesShowFields, salesShowFields) || const DeepCollectionEquality().equals(other.salesShowFields, salesShowFields)) &&
            (identical(other.miscShowFields, miscShowFields) || const DeepCollectionEquality().equals(other.miscShowFields, miscShowFields)) &&
            (identical(other.laborShowFields, laborShowFields) || const DeepCollectionEquality().equals(other.laborShowFields, laborShowFields)) &&
            (identical(other.rentalSaleShowFields, rentalSaleShowFields) || const DeepCollectionEquality().equals(other.rentalSaleShowFields, rentalSaleShowFields)) &&
            (identical(other.lossAndDamageShowFields, lossAndDamageShowFields) || const DeepCollectionEquality().equals(other.lossAndDamageShowFields, lossAndDamageShowFields)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesSettingsOrderSettingsOrderTypeOrderTypeExtension
    on WebApiModulesSettingsOrderSettingsOrderTypeOrderType {
  WebApiModulesSettingsOrderSettingsOrderTypeOrderType copyWith(
      {String? orderTypeId,
      String? orderType,
      String? ordType,
      String? defaultPickTime,
      String? defaultFromTime,
      String? defaultToTime,
      String? dailyScheduleDefaultStartTime,
      String? dailyScheduleDefaultStopTime,
      bool? isMasterSubOrderType,
      bool? combineActivityTabs,
      bool? defaultManualSort,
      String? determineQuantitiesToBillBasedOn,
      bool? allowNesting,
      bool? rentalShowICode,
      int? rentalICodeWidth,
      bool? rentalShowDescription,
      int? rentalDescriptionWidth,
      bool? rentalShowPickDate,
      bool? rentalShowPickTime,
      bool? rentalShowFromDate,
      bool? rentalShowFromTime,
      bool? rentalShowToDate,
      bool? rentalShowToTime,
      bool? rentalShowBillablePeriods,
      bool? rentalShowEpisodes,
      bool? rentalShowSubQuantity,
      bool? rentalShowAvailableQuantity,
      bool? rentalShowConflictDate,
      bool? rentalShowAvailableQuantityRegion,
      bool? rentalShowConflictDateRegion,
      bool? rentalShowAvailableQuantityAllWarehouses,
      bool? rentalShowConflictDateAllWarehouses,
      bool? rentalShowReservedItems,
      bool? rentalShowConsignmentQuantity,
      bool? rentalShowConsignmentAvailableQuantity,
      bool? rentalShowConsignmentConflictDate,
      bool? rentalShowRate,
      bool? rentalShowDaysPerWeek,
      bool? rentalShowPremiumPercent,
      bool? rentalShowUnit,
      bool? rentalShowCost,
      bool? rentalShowPeriodCostExtended,
      bool? rentalShowDiscountPercent,
      bool? rentalShowMarkupPercent,
      bool? rentalShowMarginPercent,
      bool? rentalShowUnitDiscountAmount,
      bool? rentalShowUnitExtended,
      bool? rentalShowWeeklyDiscountAmount,
      bool? rentalShowWeeklyExtended,
      bool? rentalShowEpisodeExtended,
      bool? rentalShowEpisodeDiscountAmount,
      bool? rentalShowMonthlyDiscountAmount,
      bool? rentalShowMonthlyExtended,
      bool? rentalShowPeriodDiscountAmount,
      bool? rentalShowPeriodExtended,
      bool? rentalShowWarehouse,
      bool? rentalShowTaxable,
      bool? rentalShowNotes,
      bool? rentalShowReturnToWarehouse,
      String? rentalDateStamp,
      bool? allowRoundTripRentals,
      bool? salesShowICode,
      int? salesICodeWidth,
      bool? salesShowDescription,
      int? salesDescriptionWidth,
      bool? salesShowManufacturerPartNumber,
      int? salesManufacturerPartNumberWidth,
      bool? salesShowPickDate,
      bool? salesShowPickTime,
      bool? salesShowFromDate,
      bool? salesShowFromTime,
      bool? salesShowSubQuantity,
      bool? salesShowCost,
      bool? salesShowRate,
      bool? salesShowAvailableQuantity,
      bool? salesShowConflictDate,
      bool? salesShowAvailableQuantityRegion,
      bool? salesShowConflictDateRegion,
      bool? salesShowAvailableQuantityAllWarehouses,
      bool? salesShowConflictDateAllWarehouses,
      bool? salesShowMarkupPercent,
      bool? salesShowMarginPercent,
      bool? salesShowUnit,
      bool? salesShowPeriodCostExtended,
      bool? salesShowDiscountPercent,
      bool? salesShowUnitDiscountAmount,
      bool? salesShowUnitExtended,
      bool? salesShowPeriodDiscountAmount,
      bool? salesShowPeriodExtended,
      bool? salesShowVariancePercent,
      bool? salesShowVarianceExtended,
      bool? salesShowWarehouse,
      bool? salesShowTaxable,
      bool? salesShowNotes,
      String? salesDateStamp,
      String? salesInventoryPrice,
      String? salesInventoryCost,
      bool? facilityShowDescription,
      int? facilityDescriptionWidth,
      bool? facilityShowFromDate,
      bool? facilityShowFromTime,
      bool? facilityShowToDate,
      bool? facilityShowToTime,
      bool? facilityShowWeeksAndDays,
      bool? facilityShowMonthsAndDays,
      bool? facilityShowBillablePeriods,
      bool? facilityShowRate,
      bool? facilityShowDaysPerWeek,
      bool? facilityShowDiscountPercent,
      bool? facilityShowSplit,
      bool? facilityShowUnit,
      bool? facilityShowUnitDiscountAmount,
      bool? facilityShowUnitExtended,
      bool? facilityShowWeeklyDiscountAmount,
      bool? facilityShowWeeklyExtended,
      bool? facilityShowMonthlyDiscountAmount,
      bool? facilityShowMonthlyExtended,
      bool? facilityShowPeriodDiscountAmount,
      bool? facilityShowPeriodExtended,
      bool? facilityShowTaxable,
      bool? facilityShowNotes,
      String? facilityDateStamp,
      String? facilityDescription,
      bool? vehicleShowDescription,
      int? vehicleDescriptionWidth,
      bool? vehicleShowVehicleNumber,
      bool? vehicleShowPickDate,
      bool? vehicleShowPickTime,
      bool? vehicleShowFromDate,
      bool? vehicleShowFromTime,
      bool? vehicleShowToDate,
      bool? vehicleShowToTime,
      bool? vehicleShowBillablePeriods,
      bool? vehicleShowSubQuantity,
      bool? vehicleShowAvailableQuantity,
      bool? vehicleShowConflictDate,
      bool? vehicleShowUnit,
      bool? vehicleShowRate,
      bool? vehicleShowDaysPerWeek,
      bool? vehicleShowCost,
      bool? vehicleShowWeeklyCostExtended,
      bool? vehicleShowMonthlyCostExtended,
      bool? vehicleShowPeriodCostExtended,
      bool? vehicleShowDiscountPercent,
      bool? vehicleShowUnitDiscountAmount,
      bool? vehicleShowUnitExtended,
      bool? vehicleShowWeeklyDiscountAmount,
      bool? vehicleShowWeeklyExtended,
      bool? vehicleShowMonthlyDiscountAmount,
      bool? vehicleShowMonthlyExtended,
      bool? vehicleShowPeriodDiscountAmount,
      bool? vehicleShowPeriodExtended,
      bool? vehicleShowWarehouse,
      bool? vehicleShowReturnToWarehouse,
      bool? vehicleShowTaxable,
      bool? vehicleShowNotes,
      String? vehicleDateStamp,
      bool? laborShowICode,
      int? laborICodeWidth,
      bool? laborShowDescription,
      int? laborDescriptionWidth,
      bool? laborShowOrderActivity,
      bool? laborShowCrewName,
      bool? laborShowFromDate,
      bool? laborShowFromTime,
      bool? laborShowToDate,
      bool? laborShowToTime,
      bool? laborShowBillablePeriods,
      bool? laborShowHours,
      bool? laborShowSubQuantity,
      bool? laborShowCost,
      bool? laborShowRate,
      bool? laborShowPeriodCostExtended,
      bool? laborShowDiscountPercent,
      bool? laborShowUnit,
      bool? laborShowUnitDiscountAmount,
      bool? laborShowUnitExtended,
      bool? laborShowWeeklyDiscountAmount,
      bool? laborShowWeeklyExtended,
      bool? laborShowMonthlyDiscountAmount,
      bool? laborShowMonthlyExtended,
      bool? laborShowPeriodDiscountAmount,
      bool? laborShowPeriodExtended,
      bool? laborShowWarehouse,
      bool? laborShowTaxable,
      bool? laborShowNotes,
      String? laborDateStamp,
      bool? hideCrewBreaks,
      bool? break1Paid,
      bool? break2Paid,
      bool? break3Paid,
      bool? miscShowICode,
      int? miscICodeWidth,
      bool? miscShowDescription,
      int? miscDescriptionWidth,
      bool? miscShowFromDate,
      bool? miscShowFromTime,
      bool? miscShowToDate,
      bool? miscShowToTime,
      bool? miscShowBillablePeriods,
      bool? miscShowSubQuantity,
      bool? miscShowWeeksAndDays,
      bool? miscShowMonthsAndDays,
      bool? miscShowUnit,
      bool? miscShowRate,
      bool? miscShowCost,
      bool? miscShowPeriodCostExtended,
      bool? miscShowDiscountPercent,
      bool? miscShowUnitDiscountAmount,
      bool? miscShowUnitExtended,
      bool? miscShowWeeklyDiscountAmount,
      bool? miscShowWeeklyExtended,
      bool? miscShowMonthlyDiscountAmount,
      bool? miscShowMonthlyExtended,
      bool? miscShowPeriodDiscountAmount,
      bool? miscShowPeriodExtended,
      bool? miscShowWarehouse,
      bool? miscShowTaxable,
      bool? miscShowNotes,
      String? miscDateStamp,
      bool? rentalSaleShowBarCode,
      bool? rentalSaleShowSerialNumber,
      bool? rentalSaleShowICode,
      int? rentalSaleICodeWidth,
      bool? rentalSaleShowDescription,
      int? rentalSaleDescriptionWidth,
      bool? rentalSaleShowPickDate,
      bool? rentalSaleShowPickTime,
      bool? rentalSaleShowAvailableQuantity,
      bool? rentalSaleShowConflictDate,
      bool? rentalSaleShowUnit,
      bool? rentalSaleShowRate,
      bool? rentalSaleShowCost,
      bool? rentalSaleShowPeriodCostExtended,
      bool? rentalSaleShowDiscountPercent,
      bool? rentalSaleShowUnitDiscountAmount,
      bool? rentalSaleShowUnitExtended,
      bool? rentalSaleShowPeriodDiscountAmount,
      bool? rentalSaleShowPeriodExtended,
      bool? rentalSaleShowWarehouse,
      bool? rentalSaleShowTaxable,
      bool? rentalSaleShowNotes,
      String? rentalSaleDateStamp,
      bool? lossAndDamageShowOrderNumber,
      bool? lossAndDamageShowRepairOrderNumber,
      bool? lossAndDamageShowBarCode,
      bool? lossAndDamageShowSerialNumber,
      bool? lossAndDamageShowICode,
      int? lossAndDamageICodeWidth,
      bool? lossAndDamageShowDescription,
      int? lossAndDamageDescriptionWidth,
      bool? lossAndDamageShowUnit,
      bool? lossAndDamageShowRate,
      bool? lossAndDamageShowCost,
      bool? lossAndDamageShowDiscountPercent,
      bool? lossAndDamageShowUnitDiscountAmount,
      bool? lossAndDamageShowUnitExtended,
      bool? lossAndDamageShowPeriodDiscountAmount,
      bool? lossAndDamageShowPeriodExtended,
      bool? lossAndDamageShowWarehouse,
      bool? lossAndDamageShowTaxable,
      bool? lossAndDamageShowNotes,
      String? lossAndDamageDateStamp,
      bool? addInstallationAndStrikeFee,
      String? installationAndStrikeFeeRateId,
      String? installationAndStrikeFeeICode,
      String? installationAndStrikeFeeDescription,
      double? installationAndStrikeFeePercent,
      String? installationAndStrikeFeeBasedOn,
      bool? addManagementAndServiceFee,
      String? managementAndServiceFeeRateId,
      String? managementAndServiceFeeICode,
      String? managementAndServiceFeeDescription,
      double? managementAndServiceFeePercent,
      String? managementAndServiceFeeBasedOn,
      String? defaultRentalSalePrice,
      bool? quikPayDiscount,
      String? quikPayDiscountType,
      int? quikPayDiscountDays,
      double? quikPayDiscountPercent,
      bool? quikPayDiscountExcludeSubs,
      bool? quikConfirmDiscount,
      double? quikConfirmDiscountPercent,
      int? quikConfirmDiscountDays,
      bool? disableCostGl,
      bool? excludeFromTopSalesDashboard,
      bool? separatePackageOnQuoteOrder,
      double? orderby,
      bool? subAllShortagesSubMiscellaneous,
      bool? inactive,
      List<String>? combinedShowFields,
      List<String>? rentalShowFields,
      List<String>? salesShowFields,
      List<String>? miscShowFields,
      List<String>? laborShowFields,
      List<String>? rentalSaleShowFields,
      List<String>? lossAndDamageShowFields,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesSettingsOrderSettingsOrderTypeOrderType(
        orderTypeId: orderTypeId ?? this.orderTypeId,
        orderType: orderType ?? this.orderType,
        ordType: ordType ?? this.ordType,
        defaultPickTime: defaultPickTime ?? this.defaultPickTime,
        defaultFromTime: defaultFromTime ?? this.defaultFromTime,
        defaultToTime: defaultToTime ?? this.defaultToTime,
        dailyScheduleDefaultStartTime:
            dailyScheduleDefaultStartTime ?? this.dailyScheduleDefaultStartTime,
        dailyScheduleDefaultStopTime:
            dailyScheduleDefaultStopTime ?? this.dailyScheduleDefaultStopTime,
        isMasterSubOrderType: isMasterSubOrderType ?? this.isMasterSubOrderType,
        combineActivityTabs: combineActivityTabs ?? this.combineActivityTabs,
        defaultManualSort: defaultManualSort ?? this.defaultManualSort,
        determineQuantitiesToBillBasedOn: determineQuantitiesToBillBasedOn ??
            this.determineQuantitiesToBillBasedOn,
        allowNesting: allowNesting ?? this.allowNesting,
        rentalShowICode: rentalShowICode ?? this.rentalShowICode,
        rentalICodeWidth: rentalICodeWidth ?? this.rentalICodeWidth,
        rentalShowDescription:
            rentalShowDescription ?? this.rentalShowDescription,
        rentalDescriptionWidth:
            rentalDescriptionWidth ?? this.rentalDescriptionWidth,
        rentalShowPickDate: rentalShowPickDate ?? this.rentalShowPickDate,
        rentalShowPickTime: rentalShowPickTime ?? this.rentalShowPickTime,
        rentalShowFromDate: rentalShowFromDate ?? this.rentalShowFromDate,
        rentalShowFromTime: rentalShowFromTime ?? this.rentalShowFromTime,
        rentalShowToDate: rentalShowToDate ?? this.rentalShowToDate,
        rentalShowToTime: rentalShowToTime ?? this.rentalShowToTime,
        rentalShowBillablePeriods:
            rentalShowBillablePeriods ?? this.rentalShowBillablePeriods,
        rentalShowEpisodes: rentalShowEpisodes ?? this.rentalShowEpisodes,
        rentalShowSubQuantity:
            rentalShowSubQuantity ?? this.rentalShowSubQuantity,
        rentalShowAvailableQuantity:
            rentalShowAvailableQuantity ?? this.rentalShowAvailableQuantity,
        rentalShowConflictDate:
            rentalShowConflictDate ?? this.rentalShowConflictDate,
        rentalShowAvailableQuantityRegion: rentalShowAvailableQuantityRegion ??
            this.rentalShowAvailableQuantityRegion,
        rentalShowConflictDateRegion:
            rentalShowConflictDateRegion ?? this.rentalShowConflictDateRegion,
        rentalShowAvailableQuantityAllWarehouses:
            rentalShowAvailableQuantityAllWarehouses ??
                this.rentalShowAvailableQuantityAllWarehouses,
        rentalShowConflictDateAllWarehouses:
            rentalShowConflictDateAllWarehouses ??
                this.rentalShowConflictDateAllWarehouses,
        rentalShowReservedItems:
            rentalShowReservedItems ?? this.rentalShowReservedItems,
        rentalShowConsignmentQuantity:
            rentalShowConsignmentQuantity ?? this.rentalShowConsignmentQuantity,
        rentalShowConsignmentAvailableQuantity:
            rentalShowConsignmentAvailableQuantity ??
                this.rentalShowConsignmentAvailableQuantity,
        rentalShowConsignmentConflictDate: rentalShowConsignmentConflictDate ??
            this.rentalShowConsignmentConflictDate,
        rentalShowRate: rentalShowRate ?? this.rentalShowRate,
        rentalShowDaysPerWeek:
            rentalShowDaysPerWeek ?? this.rentalShowDaysPerWeek,
        rentalShowPremiumPercent:
            rentalShowPremiumPercent ?? this.rentalShowPremiumPercent,
        rentalShowUnit: rentalShowUnit ?? this.rentalShowUnit,
        rentalShowCost: rentalShowCost ?? this.rentalShowCost,
        rentalShowPeriodCostExtended:
            rentalShowPeriodCostExtended ?? this.rentalShowPeriodCostExtended,
        rentalShowDiscountPercent:
            rentalShowDiscountPercent ?? this.rentalShowDiscountPercent,
        rentalShowMarkupPercent:
            rentalShowMarkupPercent ?? this.rentalShowMarkupPercent,
        rentalShowMarginPercent:
            rentalShowMarginPercent ?? this.rentalShowMarginPercent,
        rentalShowUnitDiscountAmount:
            rentalShowUnitDiscountAmount ?? this.rentalShowUnitDiscountAmount,
        rentalShowUnitExtended:
            rentalShowUnitExtended ?? this.rentalShowUnitExtended,
        rentalShowWeeklyDiscountAmount: rentalShowWeeklyDiscountAmount ??
            this.rentalShowWeeklyDiscountAmount,
        rentalShowWeeklyExtended:
            rentalShowWeeklyExtended ?? this.rentalShowWeeklyExtended,
        rentalShowEpisodeExtended:
            rentalShowEpisodeExtended ?? this.rentalShowEpisodeExtended,
        rentalShowEpisodeDiscountAmount: rentalShowEpisodeDiscountAmount ??
            this.rentalShowEpisodeDiscountAmount,
        rentalShowMonthlyDiscountAmount: rentalShowMonthlyDiscountAmount ??
            this.rentalShowMonthlyDiscountAmount,
        rentalShowMonthlyExtended:
            rentalShowMonthlyExtended ?? this.rentalShowMonthlyExtended,
        rentalShowPeriodDiscountAmount: rentalShowPeriodDiscountAmount ??
            this.rentalShowPeriodDiscountAmount,
        rentalShowPeriodExtended:
            rentalShowPeriodExtended ?? this.rentalShowPeriodExtended,
        rentalShowWarehouse: rentalShowWarehouse ?? this.rentalShowWarehouse,
        rentalShowTaxable: rentalShowTaxable ?? this.rentalShowTaxable,
        rentalShowNotes: rentalShowNotes ?? this.rentalShowNotes,
        rentalShowReturnToWarehouse:
            rentalShowReturnToWarehouse ?? this.rentalShowReturnToWarehouse,
        rentalDateStamp: rentalDateStamp ?? this.rentalDateStamp,
        allowRoundTripRentals: allowRoundTripRentals ?? this.allowRoundTripRentals,
        salesShowICode: salesShowICode ?? this.salesShowICode,
        salesICodeWidth: salesICodeWidth ?? this.salesICodeWidth,
        salesShowDescription: salesShowDescription ?? this.salesShowDescription,
        salesDescriptionWidth: salesDescriptionWidth ?? this.salesDescriptionWidth,
        salesShowManufacturerPartNumber: salesShowManufacturerPartNumber ?? this.salesShowManufacturerPartNumber,
        salesManufacturerPartNumberWidth: salesManufacturerPartNumberWidth ?? this.salesManufacturerPartNumberWidth,
        salesShowPickDate: salesShowPickDate ?? this.salesShowPickDate,
        salesShowPickTime: salesShowPickTime ?? this.salesShowPickTime,
        salesShowFromDate: salesShowFromDate ?? this.salesShowFromDate,
        salesShowFromTime: salesShowFromTime ?? this.salesShowFromTime,
        salesShowSubQuantity: salesShowSubQuantity ?? this.salesShowSubQuantity,
        salesShowCost: salesShowCost ?? this.salesShowCost,
        salesShowRate: salesShowRate ?? this.salesShowRate,
        salesShowAvailableQuantity: salesShowAvailableQuantity ?? this.salesShowAvailableQuantity,
        salesShowConflictDate: salesShowConflictDate ?? this.salesShowConflictDate,
        salesShowAvailableQuantityRegion: salesShowAvailableQuantityRegion ?? this.salesShowAvailableQuantityRegion,
        salesShowConflictDateRegion: salesShowConflictDateRegion ?? this.salesShowConflictDateRegion,
        salesShowAvailableQuantityAllWarehouses: salesShowAvailableQuantityAllWarehouses ?? this.salesShowAvailableQuantityAllWarehouses,
        salesShowConflictDateAllWarehouses: salesShowConflictDateAllWarehouses ?? this.salesShowConflictDateAllWarehouses,
        salesShowMarkupPercent: salesShowMarkupPercent ?? this.salesShowMarkupPercent,
        salesShowMarginPercent: salesShowMarginPercent ?? this.salesShowMarginPercent,
        salesShowUnit: salesShowUnit ?? this.salesShowUnit,
        salesShowPeriodCostExtended: salesShowPeriodCostExtended ?? this.salesShowPeriodCostExtended,
        salesShowDiscountPercent: salesShowDiscountPercent ?? this.salesShowDiscountPercent,
        salesShowUnitDiscountAmount: salesShowUnitDiscountAmount ?? this.salesShowUnitDiscountAmount,
        salesShowUnitExtended: salesShowUnitExtended ?? this.salesShowUnitExtended,
        salesShowPeriodDiscountAmount: salesShowPeriodDiscountAmount ?? this.salesShowPeriodDiscountAmount,
        salesShowPeriodExtended: salesShowPeriodExtended ?? this.salesShowPeriodExtended,
        salesShowVariancePercent: salesShowVariancePercent ?? this.salesShowVariancePercent,
        salesShowVarianceExtended: salesShowVarianceExtended ?? this.salesShowVarianceExtended,
        salesShowWarehouse: salesShowWarehouse ?? this.salesShowWarehouse,
        salesShowTaxable: salesShowTaxable ?? this.salesShowTaxable,
        salesShowNotes: salesShowNotes ?? this.salesShowNotes,
        salesDateStamp: salesDateStamp ?? this.salesDateStamp,
        salesInventoryPrice: salesInventoryPrice ?? this.salesInventoryPrice,
        salesInventoryCost: salesInventoryCost ?? this.salesInventoryCost,
        facilityShowDescription: facilityShowDescription ?? this.facilityShowDescription,
        facilityDescriptionWidth: facilityDescriptionWidth ?? this.facilityDescriptionWidth,
        facilityShowFromDate: facilityShowFromDate ?? this.facilityShowFromDate,
        facilityShowFromTime: facilityShowFromTime ?? this.facilityShowFromTime,
        facilityShowToDate: facilityShowToDate ?? this.facilityShowToDate,
        facilityShowToTime: facilityShowToTime ?? this.facilityShowToTime,
        facilityShowWeeksAndDays: facilityShowWeeksAndDays ?? this.facilityShowWeeksAndDays,
        facilityShowMonthsAndDays: facilityShowMonthsAndDays ?? this.facilityShowMonthsAndDays,
        facilityShowBillablePeriods: facilityShowBillablePeriods ?? this.facilityShowBillablePeriods,
        facilityShowRate: facilityShowRate ?? this.facilityShowRate,
        facilityShowDaysPerWeek: facilityShowDaysPerWeek ?? this.facilityShowDaysPerWeek,
        facilityShowDiscountPercent: facilityShowDiscountPercent ?? this.facilityShowDiscountPercent,
        facilityShowSplit: facilityShowSplit ?? this.facilityShowSplit,
        facilityShowUnit: facilityShowUnit ?? this.facilityShowUnit,
        facilityShowUnitDiscountAmount: facilityShowUnitDiscountAmount ?? this.facilityShowUnitDiscountAmount,
        facilityShowUnitExtended: facilityShowUnitExtended ?? this.facilityShowUnitExtended,
        facilityShowWeeklyDiscountAmount: facilityShowWeeklyDiscountAmount ?? this.facilityShowWeeklyDiscountAmount,
        facilityShowWeeklyExtended: facilityShowWeeklyExtended ?? this.facilityShowWeeklyExtended,
        facilityShowMonthlyDiscountAmount: facilityShowMonthlyDiscountAmount ?? this.facilityShowMonthlyDiscountAmount,
        facilityShowMonthlyExtended: facilityShowMonthlyExtended ?? this.facilityShowMonthlyExtended,
        facilityShowPeriodDiscountAmount: facilityShowPeriodDiscountAmount ?? this.facilityShowPeriodDiscountAmount,
        facilityShowPeriodExtended: facilityShowPeriodExtended ?? this.facilityShowPeriodExtended,
        facilityShowTaxable: facilityShowTaxable ?? this.facilityShowTaxable,
        facilityShowNotes: facilityShowNotes ?? this.facilityShowNotes,
        facilityDateStamp: facilityDateStamp ?? this.facilityDateStamp,
        facilityDescription: facilityDescription ?? this.facilityDescription,
        vehicleShowDescription: vehicleShowDescription ?? this.vehicleShowDescription,
        vehicleDescriptionWidth: vehicleDescriptionWidth ?? this.vehicleDescriptionWidth,
        vehicleShowVehicleNumber: vehicleShowVehicleNumber ?? this.vehicleShowVehicleNumber,
        vehicleShowPickDate: vehicleShowPickDate ?? this.vehicleShowPickDate,
        vehicleShowPickTime: vehicleShowPickTime ?? this.vehicleShowPickTime,
        vehicleShowFromDate: vehicleShowFromDate ?? this.vehicleShowFromDate,
        vehicleShowFromTime: vehicleShowFromTime ?? this.vehicleShowFromTime,
        vehicleShowToDate: vehicleShowToDate ?? this.vehicleShowToDate,
        vehicleShowToTime: vehicleShowToTime ?? this.vehicleShowToTime,
        vehicleShowBillablePeriods: vehicleShowBillablePeriods ?? this.vehicleShowBillablePeriods,
        vehicleShowSubQuantity: vehicleShowSubQuantity ?? this.vehicleShowSubQuantity,
        vehicleShowAvailableQuantity: vehicleShowAvailableQuantity ?? this.vehicleShowAvailableQuantity,
        vehicleShowConflictDate: vehicleShowConflictDate ?? this.vehicleShowConflictDate,
        vehicleShowUnit: vehicleShowUnit ?? this.vehicleShowUnit,
        vehicleShowRate: vehicleShowRate ?? this.vehicleShowRate,
        vehicleShowDaysPerWeek: vehicleShowDaysPerWeek ?? this.vehicleShowDaysPerWeek,
        vehicleShowCost: vehicleShowCost ?? this.vehicleShowCost,
        vehicleShowWeeklyCostExtended: vehicleShowWeeklyCostExtended ?? this.vehicleShowWeeklyCostExtended,
        vehicleShowMonthlyCostExtended: vehicleShowMonthlyCostExtended ?? this.vehicleShowMonthlyCostExtended,
        vehicleShowPeriodCostExtended: vehicleShowPeriodCostExtended ?? this.vehicleShowPeriodCostExtended,
        vehicleShowDiscountPercent: vehicleShowDiscountPercent ?? this.vehicleShowDiscountPercent,
        vehicleShowUnitDiscountAmount: vehicleShowUnitDiscountAmount ?? this.vehicleShowUnitDiscountAmount,
        vehicleShowUnitExtended: vehicleShowUnitExtended ?? this.vehicleShowUnitExtended,
        vehicleShowWeeklyDiscountAmount: vehicleShowWeeklyDiscountAmount ?? this.vehicleShowWeeklyDiscountAmount,
        vehicleShowWeeklyExtended: vehicleShowWeeklyExtended ?? this.vehicleShowWeeklyExtended,
        vehicleShowMonthlyDiscountAmount: vehicleShowMonthlyDiscountAmount ?? this.vehicleShowMonthlyDiscountAmount,
        vehicleShowMonthlyExtended: vehicleShowMonthlyExtended ?? this.vehicleShowMonthlyExtended,
        vehicleShowPeriodDiscountAmount: vehicleShowPeriodDiscountAmount ?? this.vehicleShowPeriodDiscountAmount,
        vehicleShowPeriodExtended: vehicleShowPeriodExtended ?? this.vehicleShowPeriodExtended,
        vehicleShowWarehouse: vehicleShowWarehouse ?? this.vehicleShowWarehouse,
        vehicleShowReturnToWarehouse: vehicleShowReturnToWarehouse ?? this.vehicleShowReturnToWarehouse,
        vehicleShowTaxable: vehicleShowTaxable ?? this.vehicleShowTaxable,
        vehicleShowNotes: vehicleShowNotes ?? this.vehicleShowNotes,
        vehicleDateStamp: vehicleDateStamp ?? this.vehicleDateStamp,
        laborShowICode: laborShowICode ?? this.laborShowICode,
        laborICodeWidth: laborICodeWidth ?? this.laborICodeWidth,
        laborShowDescription: laborShowDescription ?? this.laborShowDescription,
        laborDescriptionWidth: laborDescriptionWidth ?? this.laborDescriptionWidth,
        laborShowOrderActivity: laborShowOrderActivity ?? this.laborShowOrderActivity,
        laborShowCrewName: laborShowCrewName ?? this.laborShowCrewName,
        laborShowFromDate: laborShowFromDate ?? this.laborShowFromDate,
        laborShowFromTime: laborShowFromTime ?? this.laborShowFromTime,
        laborShowToDate: laborShowToDate ?? this.laborShowToDate,
        laborShowToTime: laborShowToTime ?? this.laborShowToTime,
        laborShowBillablePeriods: laborShowBillablePeriods ?? this.laborShowBillablePeriods,
        laborShowHours: laborShowHours ?? this.laborShowHours,
        laborShowSubQuantity: laborShowSubQuantity ?? this.laborShowSubQuantity,
        laborShowCost: laborShowCost ?? this.laborShowCost,
        laborShowRate: laborShowRate ?? this.laborShowRate,
        laborShowPeriodCostExtended: laborShowPeriodCostExtended ?? this.laborShowPeriodCostExtended,
        laborShowDiscountPercent: laborShowDiscountPercent ?? this.laborShowDiscountPercent,
        laborShowUnit: laborShowUnit ?? this.laborShowUnit,
        laborShowUnitDiscountAmount: laborShowUnitDiscountAmount ?? this.laborShowUnitDiscountAmount,
        laborShowUnitExtended: laborShowUnitExtended ?? this.laborShowUnitExtended,
        laborShowWeeklyDiscountAmount: laborShowWeeklyDiscountAmount ?? this.laborShowWeeklyDiscountAmount,
        laborShowWeeklyExtended: laborShowWeeklyExtended ?? this.laborShowWeeklyExtended,
        laborShowMonthlyDiscountAmount: laborShowMonthlyDiscountAmount ?? this.laborShowMonthlyDiscountAmount,
        laborShowMonthlyExtended: laborShowMonthlyExtended ?? this.laborShowMonthlyExtended,
        laborShowPeriodDiscountAmount: laborShowPeriodDiscountAmount ?? this.laborShowPeriodDiscountAmount,
        laborShowPeriodExtended: laborShowPeriodExtended ?? this.laborShowPeriodExtended,
        laborShowWarehouse: laborShowWarehouse ?? this.laborShowWarehouse,
        laborShowTaxable: laborShowTaxable ?? this.laborShowTaxable,
        laborShowNotes: laborShowNotes ?? this.laborShowNotes,
        laborDateStamp: laborDateStamp ?? this.laborDateStamp,
        hideCrewBreaks: hideCrewBreaks ?? this.hideCrewBreaks,
        break1Paid: break1Paid ?? this.break1Paid,
        break2Paid: break2Paid ?? this.break2Paid,
        break3Paid: break3Paid ?? this.break3Paid,
        miscShowICode: miscShowICode ?? this.miscShowICode,
        miscICodeWidth: miscICodeWidth ?? this.miscICodeWidth,
        miscShowDescription: miscShowDescription ?? this.miscShowDescription,
        miscDescriptionWidth: miscDescriptionWidth ?? this.miscDescriptionWidth,
        miscShowFromDate: miscShowFromDate ?? this.miscShowFromDate,
        miscShowFromTime: miscShowFromTime ?? this.miscShowFromTime,
        miscShowToDate: miscShowToDate ?? this.miscShowToDate,
        miscShowToTime: miscShowToTime ?? this.miscShowToTime,
        miscShowBillablePeriods: miscShowBillablePeriods ?? this.miscShowBillablePeriods,
        miscShowSubQuantity: miscShowSubQuantity ?? this.miscShowSubQuantity,
        miscShowWeeksAndDays: miscShowWeeksAndDays ?? this.miscShowWeeksAndDays,
        miscShowMonthsAndDays: miscShowMonthsAndDays ?? this.miscShowMonthsAndDays,
        miscShowUnit: miscShowUnit ?? this.miscShowUnit,
        miscShowRate: miscShowRate ?? this.miscShowRate,
        miscShowCost: miscShowCost ?? this.miscShowCost,
        miscShowPeriodCostExtended: miscShowPeriodCostExtended ?? this.miscShowPeriodCostExtended,
        miscShowDiscountPercent: miscShowDiscountPercent ?? this.miscShowDiscountPercent,
        miscShowUnitDiscountAmount: miscShowUnitDiscountAmount ?? this.miscShowUnitDiscountAmount,
        miscShowUnitExtended: miscShowUnitExtended ?? this.miscShowUnitExtended,
        miscShowWeeklyDiscountAmount: miscShowWeeklyDiscountAmount ?? this.miscShowWeeklyDiscountAmount,
        miscShowWeeklyExtended: miscShowWeeklyExtended ?? this.miscShowWeeklyExtended,
        miscShowMonthlyDiscountAmount: miscShowMonthlyDiscountAmount ?? this.miscShowMonthlyDiscountAmount,
        miscShowMonthlyExtended: miscShowMonthlyExtended ?? this.miscShowMonthlyExtended,
        miscShowPeriodDiscountAmount: miscShowPeriodDiscountAmount ?? this.miscShowPeriodDiscountAmount,
        miscShowPeriodExtended: miscShowPeriodExtended ?? this.miscShowPeriodExtended,
        miscShowWarehouse: miscShowWarehouse ?? this.miscShowWarehouse,
        miscShowTaxable: miscShowTaxable ?? this.miscShowTaxable,
        miscShowNotes: miscShowNotes ?? this.miscShowNotes,
        miscDateStamp: miscDateStamp ?? this.miscDateStamp,
        rentalSaleShowBarCode: rentalSaleShowBarCode ?? this.rentalSaleShowBarCode,
        rentalSaleShowSerialNumber: rentalSaleShowSerialNumber ?? this.rentalSaleShowSerialNumber,
        rentalSaleShowICode: rentalSaleShowICode ?? this.rentalSaleShowICode,
        rentalSaleICodeWidth: rentalSaleICodeWidth ?? this.rentalSaleICodeWidth,
        rentalSaleShowDescription: rentalSaleShowDescription ?? this.rentalSaleShowDescription,
        rentalSaleDescriptionWidth: rentalSaleDescriptionWidth ?? this.rentalSaleDescriptionWidth,
        rentalSaleShowPickDate: rentalSaleShowPickDate ?? this.rentalSaleShowPickDate,
        rentalSaleShowPickTime: rentalSaleShowPickTime ?? this.rentalSaleShowPickTime,
        rentalSaleShowAvailableQuantity: rentalSaleShowAvailableQuantity ?? this.rentalSaleShowAvailableQuantity,
        rentalSaleShowConflictDate: rentalSaleShowConflictDate ?? this.rentalSaleShowConflictDate,
        rentalSaleShowUnit: rentalSaleShowUnit ?? this.rentalSaleShowUnit,
        rentalSaleShowRate: rentalSaleShowRate ?? this.rentalSaleShowRate,
        rentalSaleShowCost: rentalSaleShowCost ?? this.rentalSaleShowCost,
        rentalSaleShowPeriodCostExtended: rentalSaleShowPeriodCostExtended ?? this.rentalSaleShowPeriodCostExtended,
        rentalSaleShowDiscountPercent: rentalSaleShowDiscountPercent ?? this.rentalSaleShowDiscountPercent,
        rentalSaleShowUnitDiscountAmount: rentalSaleShowUnitDiscountAmount ?? this.rentalSaleShowUnitDiscountAmount,
        rentalSaleShowUnitExtended: rentalSaleShowUnitExtended ?? this.rentalSaleShowUnitExtended,
        rentalSaleShowPeriodDiscountAmount: rentalSaleShowPeriodDiscountAmount ?? this.rentalSaleShowPeriodDiscountAmount,
        rentalSaleShowPeriodExtended: rentalSaleShowPeriodExtended ?? this.rentalSaleShowPeriodExtended,
        rentalSaleShowWarehouse: rentalSaleShowWarehouse ?? this.rentalSaleShowWarehouse,
        rentalSaleShowTaxable: rentalSaleShowTaxable ?? this.rentalSaleShowTaxable,
        rentalSaleShowNotes: rentalSaleShowNotes ?? this.rentalSaleShowNotes,
        rentalSaleDateStamp: rentalSaleDateStamp ?? this.rentalSaleDateStamp,
        lossAndDamageShowOrderNumber: lossAndDamageShowOrderNumber ?? this.lossAndDamageShowOrderNumber,
        lossAndDamageShowRepairOrderNumber: lossAndDamageShowRepairOrderNumber ?? this.lossAndDamageShowRepairOrderNumber,
        lossAndDamageShowBarCode: lossAndDamageShowBarCode ?? this.lossAndDamageShowBarCode,
        lossAndDamageShowSerialNumber: lossAndDamageShowSerialNumber ?? this.lossAndDamageShowSerialNumber,
        lossAndDamageShowICode: lossAndDamageShowICode ?? this.lossAndDamageShowICode,
        lossAndDamageICodeWidth: lossAndDamageICodeWidth ?? this.lossAndDamageICodeWidth,
        lossAndDamageShowDescription: lossAndDamageShowDescription ?? this.lossAndDamageShowDescription,
        lossAndDamageDescriptionWidth: lossAndDamageDescriptionWidth ?? this.lossAndDamageDescriptionWidth,
        lossAndDamageShowUnit: lossAndDamageShowUnit ?? this.lossAndDamageShowUnit,
        lossAndDamageShowRate: lossAndDamageShowRate ?? this.lossAndDamageShowRate,
        lossAndDamageShowCost: lossAndDamageShowCost ?? this.lossAndDamageShowCost,
        lossAndDamageShowDiscountPercent: lossAndDamageShowDiscountPercent ?? this.lossAndDamageShowDiscountPercent,
        lossAndDamageShowUnitDiscountAmount: lossAndDamageShowUnitDiscountAmount ?? this.lossAndDamageShowUnitDiscountAmount,
        lossAndDamageShowUnitExtended: lossAndDamageShowUnitExtended ?? this.lossAndDamageShowUnitExtended,
        lossAndDamageShowPeriodDiscountAmount: lossAndDamageShowPeriodDiscountAmount ?? this.lossAndDamageShowPeriodDiscountAmount,
        lossAndDamageShowPeriodExtended: lossAndDamageShowPeriodExtended ?? this.lossAndDamageShowPeriodExtended,
        lossAndDamageShowWarehouse: lossAndDamageShowWarehouse ?? this.lossAndDamageShowWarehouse,
        lossAndDamageShowTaxable: lossAndDamageShowTaxable ?? this.lossAndDamageShowTaxable,
        lossAndDamageShowNotes: lossAndDamageShowNotes ?? this.lossAndDamageShowNotes,
        lossAndDamageDateStamp: lossAndDamageDateStamp ?? this.lossAndDamageDateStamp,
        addInstallationAndStrikeFee: addInstallationAndStrikeFee ?? this.addInstallationAndStrikeFee,
        installationAndStrikeFeeRateId: installationAndStrikeFeeRateId ?? this.installationAndStrikeFeeRateId,
        installationAndStrikeFeeICode: installationAndStrikeFeeICode ?? this.installationAndStrikeFeeICode,
        installationAndStrikeFeeDescription: installationAndStrikeFeeDescription ?? this.installationAndStrikeFeeDescription,
        installationAndStrikeFeePercent: installationAndStrikeFeePercent ?? this.installationAndStrikeFeePercent,
        installationAndStrikeFeeBasedOn: installationAndStrikeFeeBasedOn ?? this.installationAndStrikeFeeBasedOn,
        addManagementAndServiceFee: addManagementAndServiceFee ?? this.addManagementAndServiceFee,
        managementAndServiceFeeRateId: managementAndServiceFeeRateId ?? this.managementAndServiceFeeRateId,
        managementAndServiceFeeICode: managementAndServiceFeeICode ?? this.managementAndServiceFeeICode,
        managementAndServiceFeeDescription: managementAndServiceFeeDescription ?? this.managementAndServiceFeeDescription,
        managementAndServiceFeePercent: managementAndServiceFeePercent ?? this.managementAndServiceFeePercent,
        managementAndServiceFeeBasedOn: managementAndServiceFeeBasedOn ?? this.managementAndServiceFeeBasedOn,
        defaultRentalSalePrice: defaultRentalSalePrice ?? this.defaultRentalSalePrice,
        quikPayDiscount: quikPayDiscount ?? this.quikPayDiscount,
        quikPayDiscountType: quikPayDiscountType ?? this.quikPayDiscountType,
        quikPayDiscountDays: quikPayDiscountDays ?? this.quikPayDiscountDays,
        quikPayDiscountPercent: quikPayDiscountPercent ?? this.quikPayDiscountPercent,
        quikPayDiscountExcludeSubs: quikPayDiscountExcludeSubs ?? this.quikPayDiscountExcludeSubs,
        quikConfirmDiscount: quikConfirmDiscount ?? this.quikConfirmDiscount,
        quikConfirmDiscountPercent: quikConfirmDiscountPercent ?? this.quikConfirmDiscountPercent,
        quikConfirmDiscountDays: quikConfirmDiscountDays ?? this.quikConfirmDiscountDays,
        disableCostGl: disableCostGl ?? this.disableCostGl,
        excludeFromTopSalesDashboard: excludeFromTopSalesDashboard ?? this.excludeFromTopSalesDashboard,
        separatePackageOnQuoteOrder: separatePackageOnQuoteOrder ?? this.separatePackageOnQuoteOrder,
        orderby: orderby ?? this.orderby,
        subAllShortagesSubMiscellaneous: subAllShortagesSubMiscellaneous ?? this.subAllShortagesSubMiscellaneous,
        inactive: inactive ?? this.inactive,
        combinedShowFields: combinedShowFields ?? this.combinedShowFields,
        rentalShowFields: rentalShowFields ?? this.rentalShowFields,
        salesShowFields: salesShowFields ?? this.salesShowFields,
        miscShowFields: miscShowFields ?? this.miscShowFields,
        laborShowFields: laborShowFields ?? this.laborShowFields,
        rentalSaleShowFields: rentalSaleShowFields ?? this.rentalSaleShowFields,
        lossAndDamageShowFields: lossAndDamageShowFields ?? this.lossAndDamageShowFields,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes: defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesTransfersTransferOrderTransferOrder {
  WebApiModulesTransfersTransferOrderTransferOrder({
    this.transferId,
    this.transferNumber,
    this.transferDate,
    this.description,
    this.status,
    this.statusDate,
    this.fromWarehouseId,
    this.fromWarehouse,
    this.fromWarehouseCode,
    this.toWarehouseId,
    this.toWarehouse,
    this.toWarehouseCode,
    this.departmentId,
    this.department,
    this.rental,
    this.sales,
    this.hasRentalItem,
    this.hasSalesItem,
    this.agentId,
    this.agent,
    this.relatedToOrderId,
    this.relatedToOrderNumber,
    this.officeLocationId,
    this.officeLocation,
    this.isReturnTransferOrder,
    this.pickDate,
    this.pickTime,
    this.shipDate,
    this.shipTime,
    this.requiredDate,
    this.requiredTime,
    this.outDeliveryId,
    this.outDeliveryDeliveryType,
    this.outDeliveryRequiredDate,
    this.outDeliveryRequiredTime,
    this.outDeliveryTargetShipDate,
    this.outDeliveryTargetShipTime,
    this.outDeliveryDirection,
    this.outDeliveryAddressType,
    this.outDeliveryFromLocation,
    this.outDeliveryFromContact,
    this.outDeliveryFromContactPhone,
    this.outDeliveryFromAlternateContact,
    this.outDeliveryFromAlternateContactPhone,
    this.outDeliveryFromAttention,
    this.outDeliveryFromAddress1,
    this.outDeliveryFromAdd2ress,
    this.outDeliveryFromCity,
    this.outDeliveryFromState,
    this.outDeliveryFromZipCode,
    this.outDeliveryFromCountry,
    this.outDeliveryFromCountryId,
    this.outDeliveryFromCrossStreets,
    this.outDeliveryToLocation,
    this.outDeliveryToContact,
    this.outDeliveryToContactPhone,
    this.outDeliveryToAlternateContact,
    this.outDeliveryToAlternateContactPhone,
    this.outDeliveryToAttention,
    this.outDeliveryToAddress1,
    this.outDeliveryToAddress2,
    this.outDeliveryToCity,
    this.outDeliveryToState,
    this.outDeliveryToZipCode,
    this.outDeliveryToCountryId,
    this.outDeliveryToCountry,
    this.outDeliveryToContactFax,
    this.outDeliveryToCrossStreets,
    this.outDeliveryDeliveryNotes,
    this.outDeliveryCarrierId,
    this.outDeliveryCarrier,
    this.outDeliveryCarrierAccount,
    this.outDeliveryShipViaId,
    this.outDeliveryShipVia,
    this.outDeliveryInvoiceId,
    this.outDeliveryVendorInvoiceId,
    this.outDeliveryEstimatedFreight,
    this.outDeliveryFreightInvoiceAmount,
    this.outDeliveryChargeType,
    this.outDeliveryFreightTrackingNumber,
    this.outDeliveryDropShip,
    this.outDeliveryPackageCode,
    this.outDeliveryBillPoFreightOnOrder,
    this.outDeliveryOnlineOrderNumber,
    this.outDeliveryDateStamp,
    this.inDeliveryId,
    this.inDeliveryDeliveryType,
    this.inDeliveryRequiredDate,
    this.inDeliveryRequiredTime,
    this.inDeliveryTargetShipDate,
    this.inDeliveryTargetShipTime,
    this.inDeliveryDirection,
    this.inDeliveryAddressType,
    this.inDeliveryFromLocation,
    this.inDeliveryFromContact,
    this.inDeliveryFromContactPhone,
    this.inDeliveryFromAlternateContact,
    this.inDeliveryFromAlternateContactPhone,
    this.inDeliveryFromAttention,
    this.inDeliveryFromAddress1,
    this.inDeliveryFromAdd2ress,
    this.inDeliveryFromCity,
    this.inDeliveryFromState,
    this.inDeliveryFromZipCode,
    this.inDeliveryFromCountry,
    this.inDeliveryFromCountryId,
    this.inDeliveryFromCrossStreets,
    this.inDeliveryToLocation,
    this.inDeliveryToContact,
    this.inDeliveryToContactPhone,
    this.inDeliveryToAlternateContact,
    this.inDeliveryToAlternateContactPhone,
    this.inDeliveryToAttention,
    this.inDeliveryToAddress1,
    this.inDeliveryToAddress2,
    this.inDeliveryToCity,
    this.inDeliveryToState,
    this.inDeliveryToZipCode,
    this.inDeliveryToCountryId,
    this.inDeliveryToCountry,
    this.inDeliveryToContactFax,
    this.inDeliveryToCrossStreets,
    this.inDeliveryDeliveryNotes,
    this.inDeliveryCarrierId,
    this.inDeliveryCarrier,
    this.inDeliveryCarrierAccount,
    this.inDeliveryShipViaId,
    this.inDeliveryShipVia,
    this.inDeliveryInvoiceId,
    this.inDeliveryVendorInvoiceId,
    this.inDeliveryEstimatedFreight,
    this.inDeliveryFreightInvoiceAmount,
    this.inDeliveryChargeType,
    this.inDeliveryFreightTrackingNumber,
    this.inDeliveryDropShip,
    this.inDeliveryPackageCode,
    this.inDeliveryBillPoFreightOnOrder,
    this.inDeliveryOnlineOrderNumber,
    this.inDeliveryOnlineOrderStatus,
    this.inDeliveryDateStamp,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesTransfersTransferOrderTransferOrder.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesTransfersTransferOrderTransferOrderFromJson(json);

  @JsonKey(name: 'TransferId')
  final String? transferId;
  @JsonKey(name: 'TransferNumber')
  final String? transferNumber;
  @JsonKey(name: 'TransferDate')
  final String? transferDate;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'Status')
  final String? status;
  @JsonKey(name: 'StatusDate')
  final String? statusDate;
  @JsonKey(name: 'FromWarehouseId')
  final String? fromWarehouseId;
  @JsonKey(name: 'FromWarehouse')
  final String? fromWarehouse;
  @JsonKey(name: 'FromWarehouseCode')
  final String? fromWarehouseCode;
  @JsonKey(name: 'ToWarehouseId')
  final String? toWarehouseId;
  @JsonKey(name: 'ToWarehouse')
  final String? toWarehouse;
  @JsonKey(name: 'ToWarehouseCode')
  final String? toWarehouseCode;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'Department')
  final String? department;
  @JsonKey(name: 'Rental')
  final bool? rental;
  @JsonKey(name: 'Sales')
  final bool? sales;
  @JsonKey(name: 'HasRentalItem')
  final bool? hasRentalItem;
  @JsonKey(name: 'HasSalesItem')
  final bool? hasSalesItem;
  @JsonKey(name: 'AgentId')
  final String? agentId;
  @JsonKey(name: 'Agent')
  final String? agent;
  @JsonKey(name: 'RelatedToOrderId')
  final String? relatedToOrderId;
  @JsonKey(name: 'RelatedToOrderNumber')
  final String? relatedToOrderNumber;
  @JsonKey(name: 'OfficeLocationId')
  final String? officeLocationId;
  @JsonKey(name: 'OfficeLocation')
  final String? officeLocation;
  @JsonKey(name: 'IsReturnTransferOrder')
  final bool? isReturnTransferOrder;
  @JsonKey(name: 'PickDate')
  final String? pickDate;
  @JsonKey(name: 'PickTime')
  final String? pickTime;
  @JsonKey(name: 'ShipDate')
  final String? shipDate;
  @JsonKey(name: 'ShipTime')
  final String? shipTime;
  @JsonKey(name: 'RequiredDate')
  final String? requiredDate;
  @JsonKey(name: 'RequiredTime')
  final String? requiredTime;
  @JsonKey(name: 'OutDeliveryId')
  final String? outDeliveryId;
  @JsonKey(name: 'OutDeliveryDeliveryType')
  final String? outDeliveryDeliveryType;
  @JsonKey(name: 'OutDeliveryRequiredDate')
  final String? outDeliveryRequiredDate;
  @JsonKey(name: 'OutDeliveryRequiredTime')
  final String? outDeliveryRequiredTime;
  @JsonKey(name: 'OutDeliveryTargetShipDate')
  final String? outDeliveryTargetShipDate;
  @JsonKey(name: 'OutDeliveryTargetShipTime')
  final String? outDeliveryTargetShipTime;
  @JsonKey(name: 'OutDeliveryDirection')
  final String? outDeliveryDirection;
  @JsonKey(name: 'OutDeliveryAddressType')
  final String? outDeliveryAddressType;
  @JsonKey(name: 'OutDeliveryFromLocation')
  final String? outDeliveryFromLocation;
  @JsonKey(name: 'OutDeliveryFromContact')
  final String? outDeliveryFromContact;
  @JsonKey(name: 'OutDeliveryFromContactPhone')
  final String? outDeliveryFromContactPhone;
  @JsonKey(name: 'OutDeliveryFromAlternateContact')
  final String? outDeliveryFromAlternateContact;
  @JsonKey(name: 'OutDeliveryFromAlternateContactPhone')
  final String? outDeliveryFromAlternateContactPhone;
  @JsonKey(name: 'OutDeliveryFromAttention')
  final String? outDeliveryFromAttention;
  @JsonKey(name: 'OutDeliveryFromAddress1')
  final String? outDeliveryFromAddress1;
  @JsonKey(name: 'OutDeliveryFromAdd2ress')
  final String? outDeliveryFromAdd2ress;
  @JsonKey(name: 'OutDeliveryFromCity')
  final String? outDeliveryFromCity;
  @JsonKey(name: 'OutDeliveryFromState')
  final String? outDeliveryFromState;
  @JsonKey(name: 'OutDeliveryFromZipCode')
  final String? outDeliveryFromZipCode;
  @JsonKey(name: 'OutDeliveryFromCountry')
  final String? outDeliveryFromCountry;
  @JsonKey(name: 'OutDeliveryFromCountryId')
  final String? outDeliveryFromCountryId;
  @JsonKey(name: 'OutDeliveryFromCrossStreets')
  final String? outDeliveryFromCrossStreets;
  @JsonKey(name: 'OutDeliveryToLocation')
  final String? outDeliveryToLocation;
  @JsonKey(name: 'OutDeliveryToContact')
  final String? outDeliveryToContact;
  @JsonKey(name: 'OutDeliveryToContactPhone')
  final String? outDeliveryToContactPhone;
  @JsonKey(name: 'OutDeliveryToAlternateContact')
  final String? outDeliveryToAlternateContact;
  @JsonKey(name: 'OutDeliveryToAlternateContactPhone')
  final String? outDeliveryToAlternateContactPhone;
  @JsonKey(name: 'OutDeliveryToAttention')
  final String? outDeliveryToAttention;
  @JsonKey(name: 'OutDeliveryToAddress1')
  final String? outDeliveryToAddress1;
  @JsonKey(name: 'OutDeliveryToAddress2')
  final String? outDeliveryToAddress2;
  @JsonKey(name: 'OutDeliveryToCity')
  final String? outDeliveryToCity;
  @JsonKey(name: 'OutDeliveryToState')
  final String? outDeliveryToState;
  @JsonKey(name: 'OutDeliveryToZipCode')
  final String? outDeliveryToZipCode;
  @JsonKey(name: 'OutDeliveryToCountryId')
  final String? outDeliveryToCountryId;
  @JsonKey(name: 'OutDeliveryToCountry')
  final String? outDeliveryToCountry;
  @JsonKey(name: 'OutDeliveryToContactFax')
  final String? outDeliveryToContactFax;
  @JsonKey(name: 'OutDeliveryToCrossStreets')
  final String? outDeliveryToCrossStreets;
  @JsonKey(name: 'OutDeliveryDeliveryNotes')
  final String? outDeliveryDeliveryNotes;
  @JsonKey(name: 'OutDeliveryCarrierId')
  final String? outDeliveryCarrierId;
  @JsonKey(name: 'OutDeliveryCarrier')
  final String? outDeliveryCarrier;
  @JsonKey(name: 'OutDeliveryCarrierAccount')
  final String? outDeliveryCarrierAccount;
  @JsonKey(name: 'OutDeliveryShipViaId')
  final String? outDeliveryShipViaId;
  @JsonKey(name: 'OutDeliveryShipVia')
  final String? outDeliveryShipVia;
  @JsonKey(name: 'OutDeliveryInvoiceId')
  final String? outDeliveryInvoiceId;
  @JsonKey(name: 'OutDeliveryVendorInvoiceId')
  final String? outDeliveryVendorInvoiceId;
  @JsonKey(name: 'OutDeliveryEstimatedFreight')
  final double? outDeliveryEstimatedFreight;
  @JsonKey(name: 'OutDeliveryFreightInvoiceAmount')
  final double? outDeliveryFreightInvoiceAmount;
  @JsonKey(name: 'OutDeliveryChargeType')
  final String? outDeliveryChargeType;
  @JsonKey(name: 'OutDeliveryFreightTrackingNumber')
  final String? outDeliveryFreightTrackingNumber;
  @JsonKey(name: 'OutDeliveryDropShip')
  final bool? outDeliveryDropShip;
  @JsonKey(name: 'OutDeliveryPackageCode')
  final String? outDeliveryPackageCode;
  @JsonKey(name: 'OutDeliveryBillPoFreightOnOrder')
  final bool? outDeliveryBillPoFreightOnOrder;
  @JsonKey(name: 'OutDeliveryOnlineOrderNumber')
  final String? outDeliveryOnlineOrderNumber;
  @JsonKey(name: 'OutDeliveryDateStamp')
  final String? outDeliveryDateStamp;
  @JsonKey(name: 'InDeliveryId')
  final String? inDeliveryId;
  @JsonKey(name: 'InDeliveryDeliveryType')
  final String? inDeliveryDeliveryType;
  @JsonKey(name: 'InDeliveryRequiredDate')
  final String? inDeliveryRequiredDate;
  @JsonKey(name: 'InDeliveryRequiredTime')
  final String? inDeliveryRequiredTime;
  @JsonKey(name: 'InDeliveryTargetShipDate')
  final String? inDeliveryTargetShipDate;
  @JsonKey(name: 'InDeliveryTargetShipTime')
  final String? inDeliveryTargetShipTime;
  @JsonKey(name: 'InDeliveryDirection')
  final String? inDeliveryDirection;
  @JsonKey(name: 'InDeliveryAddressType')
  final String? inDeliveryAddressType;
  @JsonKey(name: 'InDeliveryFromLocation')
  final String? inDeliveryFromLocation;
  @JsonKey(name: 'InDeliveryFromContact')
  final String? inDeliveryFromContact;
  @JsonKey(name: 'InDeliveryFromContactPhone')
  final String? inDeliveryFromContactPhone;
  @JsonKey(name: 'InDeliveryFromAlternateContact')
  final String? inDeliveryFromAlternateContact;
  @JsonKey(name: 'InDeliveryFromAlternateContactPhone')
  final String? inDeliveryFromAlternateContactPhone;
  @JsonKey(name: 'InDeliveryFromAttention')
  final String? inDeliveryFromAttention;
  @JsonKey(name: 'InDeliveryFromAddress1')
  final String? inDeliveryFromAddress1;
  @JsonKey(name: 'InDeliveryFromAdd2ress')
  final String? inDeliveryFromAdd2ress;
  @JsonKey(name: 'InDeliveryFromCity')
  final String? inDeliveryFromCity;
  @JsonKey(name: 'InDeliveryFromState')
  final String? inDeliveryFromState;
  @JsonKey(name: 'InDeliveryFromZipCode')
  final String? inDeliveryFromZipCode;
  @JsonKey(name: 'InDeliveryFromCountry')
  final String? inDeliveryFromCountry;
  @JsonKey(name: 'InDeliveryFromCountryId')
  final String? inDeliveryFromCountryId;
  @JsonKey(name: 'InDeliveryFromCrossStreets')
  final String? inDeliveryFromCrossStreets;
  @JsonKey(name: 'InDeliveryToLocation')
  final String? inDeliveryToLocation;
  @JsonKey(name: 'InDeliveryToContact')
  final String? inDeliveryToContact;
  @JsonKey(name: 'InDeliveryToContactPhone')
  final String? inDeliveryToContactPhone;
  @JsonKey(name: 'InDeliveryToAlternateContact')
  final String? inDeliveryToAlternateContact;
  @JsonKey(name: 'InDeliveryToAlternateContactPhone')
  final String? inDeliveryToAlternateContactPhone;
  @JsonKey(name: 'InDeliveryToAttention')
  final String? inDeliveryToAttention;
  @JsonKey(name: 'InDeliveryToAddress1')
  final String? inDeliveryToAddress1;
  @JsonKey(name: 'InDeliveryToAddress2')
  final String? inDeliveryToAddress2;
  @JsonKey(name: 'InDeliveryToCity')
  final String? inDeliveryToCity;
  @JsonKey(name: 'InDeliveryToState')
  final String? inDeliveryToState;
  @JsonKey(name: 'InDeliveryToZipCode')
  final String? inDeliveryToZipCode;
  @JsonKey(name: 'InDeliveryToCountryId')
  final String? inDeliveryToCountryId;
  @JsonKey(name: 'InDeliveryToCountry')
  final String? inDeliveryToCountry;
  @JsonKey(name: 'InDeliveryToContactFax')
  final String? inDeliveryToContactFax;
  @JsonKey(name: 'InDeliveryToCrossStreets')
  final String? inDeliveryToCrossStreets;
  @JsonKey(name: 'InDeliveryDeliveryNotes')
  final String? inDeliveryDeliveryNotes;
  @JsonKey(name: 'InDeliveryCarrierId')
  final String? inDeliveryCarrierId;
  @JsonKey(name: 'InDeliveryCarrier')
  final String? inDeliveryCarrier;
  @JsonKey(name: 'InDeliveryCarrierAccount')
  final String? inDeliveryCarrierAccount;
  @JsonKey(name: 'InDeliveryShipViaId')
  final String? inDeliveryShipViaId;
  @JsonKey(name: 'InDeliveryShipVia')
  final String? inDeliveryShipVia;
  @JsonKey(name: 'InDeliveryInvoiceId')
  final String? inDeliveryInvoiceId;
  @JsonKey(name: 'InDeliveryVendorInvoiceId')
  final String? inDeliveryVendorInvoiceId;
  @JsonKey(name: 'InDeliveryEstimatedFreight')
  final double? inDeliveryEstimatedFreight;
  @JsonKey(name: 'InDeliveryFreightInvoiceAmount')
  final double? inDeliveryFreightInvoiceAmount;
  @JsonKey(name: 'InDeliveryChargeType')
  final String? inDeliveryChargeType;
  @JsonKey(name: 'InDeliveryFreightTrackingNumber')
  final String? inDeliveryFreightTrackingNumber;
  @JsonKey(name: 'InDeliveryDropShip')
  final bool? inDeliveryDropShip;
  @JsonKey(name: 'InDeliveryPackageCode')
  final String? inDeliveryPackageCode;
  @JsonKey(name: 'InDeliveryBillPoFreightOnOrder')
  final bool? inDeliveryBillPoFreightOnOrder;
  @JsonKey(name: 'InDeliveryOnlineOrderNumber')
  final String? inDeliveryOnlineOrderNumber;
  @JsonKey(name: 'InDeliveryOnlineOrderStatus')
  final String? inDeliveryOnlineOrderStatus;
  @JsonKey(name: 'InDeliveryDateStamp')
  final String? inDeliveryDateStamp;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesTransfersTransferOrderTransferOrderFromJson;
  static const toJsonFactory =
      _$WebApiModulesTransfersTransferOrderTransferOrderToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesTransfersTransferOrderTransferOrderToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesTransfersTransferOrderTransferOrder &&
            (identical(other.transferId, transferId) ||
                const DeepCollectionEquality()
                    .equals(other.transferId, transferId)) &&
            (identical(other.transferNumber, transferNumber) ||
                const DeepCollectionEquality()
                    .equals(other.transferNumber, transferNumber)) &&
            (identical(other.transferDate, transferDate) ||
                const DeepCollectionEquality()
                    .equals(other.transferDate, transferDate)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.statusDate, statusDate) ||
                const DeepCollectionEquality()
                    .equals(other.statusDate, statusDate)) &&
            (identical(other.fromWarehouseId, fromWarehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.fromWarehouseId, fromWarehouseId)) &&
            (identical(other.fromWarehouse, fromWarehouse) ||
                const DeepCollectionEquality()
                    .equals(other.fromWarehouse, fromWarehouse)) &&
            (identical(other.fromWarehouseCode, fromWarehouseCode) ||
                const DeepCollectionEquality()
                    .equals(other.fromWarehouseCode, fromWarehouseCode)) &&
            (identical(other.toWarehouseId, toWarehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.toWarehouseId, toWarehouseId)) &&
            (identical(other.toWarehouse, toWarehouse) ||
                const DeepCollectionEquality()
                    .equals(other.toWarehouse, toWarehouse)) &&
            (identical(other.toWarehouseCode, toWarehouseCode) ||
                const DeepCollectionEquality()
                    .equals(other.toWarehouseCode, toWarehouseCode)) &&
            (identical(other.departmentId, departmentId) ||
                const DeepCollectionEquality()
                    .equals(other.departmentId, departmentId)) &&
            (identical(other.department, department) ||
                const DeepCollectionEquality()
                    .equals(other.department, department)) &&
            (identical(other.rental, rental) ||
                const DeepCollectionEquality().equals(other.rental, rental)) &&
            (identical(other.sales, sales) ||
                const DeepCollectionEquality().equals(other.sales, sales)) &&
            (identical(other.hasRentalItem, hasRentalItem) ||
                const DeepCollectionEquality()
                    .equals(other.hasRentalItem, hasRentalItem)) &&
            (identical(other.hasSalesItem, hasSalesItem) ||
                const DeepCollectionEquality()
                    .equals(other.hasSalesItem, hasSalesItem)) &&
            (identical(other.agentId, agentId) ||
                const DeepCollectionEquality()
                    .equals(other.agentId, agentId)) &&
            (identical(other.agent, agent) ||
                const DeepCollectionEquality().equals(other.agent, agent)) &&
            (identical(other.relatedToOrderId, relatedToOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.relatedToOrderId, relatedToOrderId)) &&
            (identical(other.relatedToOrderNumber, relatedToOrderNumber) ||
                const DeepCollectionEquality().equals(
                    other.relatedToOrderNumber, relatedToOrderNumber)) &&
            (identical(other.officeLocationId, officeLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocationId, officeLocationId)) &&
            (identical(other.officeLocation, officeLocation) ||
                const DeepCollectionEquality().equals(other.officeLocation, officeLocation)) &&
            (identical(other.isReturnTransferOrder, isReturnTransferOrder) || const DeepCollectionEquality().equals(other.isReturnTransferOrder, isReturnTransferOrder)) &&
            (identical(other.pickDate, pickDate) || const DeepCollectionEquality().equals(other.pickDate, pickDate)) &&
            (identical(other.pickTime, pickTime) || const DeepCollectionEquality().equals(other.pickTime, pickTime)) &&
            (identical(other.shipDate, shipDate) || const DeepCollectionEquality().equals(other.shipDate, shipDate)) &&
            (identical(other.shipTime, shipTime) || const DeepCollectionEquality().equals(other.shipTime, shipTime)) &&
            (identical(other.requiredDate, requiredDate) || const DeepCollectionEquality().equals(other.requiredDate, requiredDate)) &&
            (identical(other.requiredTime, requiredTime) || const DeepCollectionEquality().equals(other.requiredTime, requiredTime)) &&
            (identical(other.outDeliveryId, outDeliveryId) || const DeepCollectionEquality().equals(other.outDeliveryId, outDeliveryId)) &&
            (identical(other.outDeliveryDeliveryType, outDeliveryDeliveryType) || const DeepCollectionEquality().equals(other.outDeliveryDeliveryType, outDeliveryDeliveryType)) &&
            (identical(other.outDeliveryRequiredDate, outDeliveryRequiredDate) || const DeepCollectionEquality().equals(other.outDeliveryRequiredDate, outDeliveryRequiredDate)) &&
            (identical(other.outDeliveryRequiredTime, outDeliveryRequiredTime) || const DeepCollectionEquality().equals(other.outDeliveryRequiredTime, outDeliveryRequiredTime)) &&
            (identical(other.outDeliveryTargetShipDate, outDeliveryTargetShipDate) || const DeepCollectionEquality().equals(other.outDeliveryTargetShipDate, outDeliveryTargetShipDate)) &&
            (identical(other.outDeliveryTargetShipTime, outDeliveryTargetShipTime) || const DeepCollectionEquality().equals(other.outDeliveryTargetShipTime, outDeliveryTargetShipTime)) &&
            (identical(other.outDeliveryDirection, outDeliveryDirection) || const DeepCollectionEquality().equals(other.outDeliveryDirection, outDeliveryDirection)) &&
            (identical(other.outDeliveryAddressType, outDeliveryAddressType) || const DeepCollectionEquality().equals(other.outDeliveryAddressType, outDeliveryAddressType)) &&
            (identical(other.outDeliveryFromLocation, outDeliveryFromLocation) || const DeepCollectionEquality().equals(other.outDeliveryFromLocation, outDeliveryFromLocation)) &&
            (identical(other.outDeliveryFromContact, outDeliveryFromContact) || const DeepCollectionEquality().equals(other.outDeliveryFromContact, outDeliveryFromContact)) &&
            (identical(other.outDeliveryFromContactPhone, outDeliveryFromContactPhone) || const DeepCollectionEquality().equals(other.outDeliveryFromContactPhone, outDeliveryFromContactPhone)) &&
            (identical(other.outDeliveryFromAlternateContact, outDeliveryFromAlternateContact) || const DeepCollectionEquality().equals(other.outDeliveryFromAlternateContact, outDeliveryFromAlternateContact)) &&
            (identical(other.outDeliveryFromAlternateContactPhone, outDeliveryFromAlternateContactPhone) || const DeepCollectionEquality().equals(other.outDeliveryFromAlternateContactPhone, outDeliveryFromAlternateContactPhone)) &&
            (identical(other.outDeliveryFromAttention, outDeliveryFromAttention) || const DeepCollectionEquality().equals(other.outDeliveryFromAttention, outDeliveryFromAttention)) &&
            (identical(other.outDeliveryFromAddress1, outDeliveryFromAddress1) || const DeepCollectionEquality().equals(other.outDeliveryFromAddress1, outDeliveryFromAddress1)) &&
            (identical(other.outDeliveryFromAdd2ress, outDeliveryFromAdd2ress) || const DeepCollectionEquality().equals(other.outDeliveryFromAdd2ress, outDeliveryFromAdd2ress)) &&
            (identical(other.outDeliveryFromCity, outDeliveryFromCity) || const DeepCollectionEquality().equals(other.outDeliveryFromCity, outDeliveryFromCity)) &&
            (identical(other.outDeliveryFromState, outDeliveryFromState) || const DeepCollectionEquality().equals(other.outDeliveryFromState, outDeliveryFromState)) &&
            (identical(other.outDeliveryFromZipCode, outDeliveryFromZipCode) || const DeepCollectionEquality().equals(other.outDeliveryFromZipCode, outDeliveryFromZipCode)) &&
            (identical(other.outDeliveryFromCountry, outDeliveryFromCountry) || const DeepCollectionEquality().equals(other.outDeliveryFromCountry, outDeliveryFromCountry)) &&
            (identical(other.outDeliveryFromCountryId, outDeliveryFromCountryId) || const DeepCollectionEquality().equals(other.outDeliveryFromCountryId, outDeliveryFromCountryId)) &&
            (identical(other.outDeliveryFromCrossStreets, outDeliveryFromCrossStreets) || const DeepCollectionEquality().equals(other.outDeliveryFromCrossStreets, outDeliveryFromCrossStreets)) &&
            (identical(other.outDeliveryToLocation, outDeliveryToLocation) || const DeepCollectionEquality().equals(other.outDeliveryToLocation, outDeliveryToLocation)) &&
            (identical(other.outDeliveryToContact, outDeliveryToContact) || const DeepCollectionEquality().equals(other.outDeliveryToContact, outDeliveryToContact)) &&
            (identical(other.outDeliveryToContactPhone, outDeliveryToContactPhone) || const DeepCollectionEquality().equals(other.outDeliveryToContactPhone, outDeliveryToContactPhone)) &&
            (identical(other.outDeliveryToAlternateContact, outDeliveryToAlternateContact) || const DeepCollectionEquality().equals(other.outDeliveryToAlternateContact, outDeliveryToAlternateContact)) &&
            (identical(other.outDeliveryToAlternateContactPhone, outDeliveryToAlternateContactPhone) || const DeepCollectionEquality().equals(other.outDeliveryToAlternateContactPhone, outDeliveryToAlternateContactPhone)) &&
            (identical(other.outDeliveryToAttention, outDeliveryToAttention) || const DeepCollectionEquality().equals(other.outDeliveryToAttention, outDeliveryToAttention)) &&
            (identical(other.outDeliveryToAddress1, outDeliveryToAddress1) || const DeepCollectionEquality().equals(other.outDeliveryToAddress1, outDeliveryToAddress1)) &&
            (identical(other.outDeliveryToAddress2, outDeliveryToAddress2) || const DeepCollectionEquality().equals(other.outDeliveryToAddress2, outDeliveryToAddress2)) &&
            (identical(other.outDeliveryToCity, outDeliveryToCity) || const DeepCollectionEquality().equals(other.outDeliveryToCity, outDeliveryToCity)) &&
            (identical(other.outDeliveryToState, outDeliveryToState) || const DeepCollectionEquality().equals(other.outDeliveryToState, outDeliveryToState)) &&
            (identical(other.outDeliveryToZipCode, outDeliveryToZipCode) || const DeepCollectionEquality().equals(other.outDeliveryToZipCode, outDeliveryToZipCode)) &&
            (identical(other.outDeliveryToCountryId, outDeliveryToCountryId) || const DeepCollectionEquality().equals(other.outDeliveryToCountryId, outDeliveryToCountryId)) &&
            (identical(other.outDeliveryToCountry, outDeliveryToCountry) || const DeepCollectionEquality().equals(other.outDeliveryToCountry, outDeliveryToCountry)) &&
            (identical(other.outDeliveryToContactFax, outDeliveryToContactFax) || const DeepCollectionEquality().equals(other.outDeliveryToContactFax, outDeliveryToContactFax)) &&
            (identical(other.outDeliveryToCrossStreets, outDeliveryToCrossStreets) || const DeepCollectionEquality().equals(other.outDeliveryToCrossStreets, outDeliveryToCrossStreets)) &&
            (identical(other.outDeliveryDeliveryNotes, outDeliveryDeliveryNotes) || const DeepCollectionEquality().equals(other.outDeliveryDeliveryNotes, outDeliveryDeliveryNotes)) &&
            (identical(other.outDeliveryCarrierId, outDeliveryCarrierId) || const DeepCollectionEquality().equals(other.outDeliveryCarrierId, outDeliveryCarrierId)) &&
            (identical(other.outDeliveryCarrier, outDeliveryCarrier) || const DeepCollectionEquality().equals(other.outDeliveryCarrier, outDeliveryCarrier)) &&
            (identical(other.outDeliveryCarrierAccount, outDeliveryCarrierAccount) || const DeepCollectionEquality().equals(other.outDeliveryCarrierAccount, outDeliveryCarrierAccount)) &&
            (identical(other.outDeliveryShipViaId, outDeliveryShipViaId) || const DeepCollectionEquality().equals(other.outDeliveryShipViaId, outDeliveryShipViaId)) &&
            (identical(other.outDeliveryShipVia, outDeliveryShipVia) || const DeepCollectionEquality().equals(other.outDeliveryShipVia, outDeliveryShipVia)) &&
            (identical(other.outDeliveryInvoiceId, outDeliveryInvoiceId) || const DeepCollectionEquality().equals(other.outDeliveryInvoiceId, outDeliveryInvoiceId)) &&
            (identical(other.outDeliveryVendorInvoiceId, outDeliveryVendorInvoiceId) || const DeepCollectionEquality().equals(other.outDeliveryVendorInvoiceId, outDeliveryVendorInvoiceId)) &&
            (identical(other.outDeliveryEstimatedFreight, outDeliveryEstimatedFreight) || const DeepCollectionEquality().equals(other.outDeliveryEstimatedFreight, outDeliveryEstimatedFreight)) &&
            (identical(other.outDeliveryFreightInvoiceAmount, outDeliveryFreightInvoiceAmount) || const DeepCollectionEquality().equals(other.outDeliveryFreightInvoiceAmount, outDeliveryFreightInvoiceAmount)) &&
            (identical(other.outDeliveryChargeType, outDeliveryChargeType) || const DeepCollectionEquality().equals(other.outDeliveryChargeType, outDeliveryChargeType)) &&
            (identical(other.outDeliveryFreightTrackingNumber, outDeliveryFreightTrackingNumber) || const DeepCollectionEquality().equals(other.outDeliveryFreightTrackingNumber, outDeliveryFreightTrackingNumber)) &&
            (identical(other.outDeliveryDropShip, outDeliveryDropShip) || const DeepCollectionEquality().equals(other.outDeliveryDropShip, outDeliveryDropShip)) &&
            (identical(other.outDeliveryPackageCode, outDeliveryPackageCode) || const DeepCollectionEquality().equals(other.outDeliveryPackageCode, outDeliveryPackageCode)) &&
            (identical(other.outDeliveryBillPoFreightOnOrder, outDeliveryBillPoFreightOnOrder) || const DeepCollectionEquality().equals(other.outDeliveryBillPoFreightOnOrder, outDeliveryBillPoFreightOnOrder)) &&
            (identical(other.outDeliveryOnlineOrderNumber, outDeliveryOnlineOrderNumber) || const DeepCollectionEquality().equals(other.outDeliveryOnlineOrderNumber, outDeliveryOnlineOrderNumber)) &&
            (identical(other.outDeliveryDateStamp, outDeliveryDateStamp) || const DeepCollectionEquality().equals(other.outDeliveryDateStamp, outDeliveryDateStamp)) &&
            (identical(other.inDeliveryId, inDeliveryId) || const DeepCollectionEquality().equals(other.inDeliveryId, inDeliveryId)) &&
            (identical(other.inDeliveryDeliveryType, inDeliveryDeliveryType) || const DeepCollectionEquality().equals(other.inDeliveryDeliveryType, inDeliveryDeliveryType)) &&
            (identical(other.inDeliveryRequiredDate, inDeliveryRequiredDate) || const DeepCollectionEquality().equals(other.inDeliveryRequiredDate, inDeliveryRequiredDate)) &&
            (identical(other.inDeliveryRequiredTime, inDeliveryRequiredTime) || const DeepCollectionEquality().equals(other.inDeliveryRequiredTime, inDeliveryRequiredTime)) &&
            (identical(other.inDeliveryTargetShipDate, inDeliveryTargetShipDate) || const DeepCollectionEquality().equals(other.inDeliveryTargetShipDate, inDeliveryTargetShipDate)) &&
            (identical(other.inDeliveryTargetShipTime, inDeliveryTargetShipTime) || const DeepCollectionEquality().equals(other.inDeliveryTargetShipTime, inDeliveryTargetShipTime)) &&
            (identical(other.inDeliveryDirection, inDeliveryDirection) || const DeepCollectionEquality().equals(other.inDeliveryDirection, inDeliveryDirection)) &&
            (identical(other.inDeliveryAddressType, inDeliveryAddressType) || const DeepCollectionEquality().equals(other.inDeliveryAddressType, inDeliveryAddressType)) &&
            (identical(other.inDeliveryFromLocation, inDeliveryFromLocation) || const DeepCollectionEquality().equals(other.inDeliveryFromLocation, inDeliveryFromLocation)) &&
            (identical(other.inDeliveryFromContact, inDeliveryFromContact) || const DeepCollectionEquality().equals(other.inDeliveryFromContact, inDeliveryFromContact)) &&
            (identical(other.inDeliveryFromContactPhone, inDeliveryFromContactPhone) || const DeepCollectionEquality().equals(other.inDeliveryFromContactPhone, inDeliveryFromContactPhone)) &&
            (identical(other.inDeliveryFromAlternateContact, inDeliveryFromAlternateContact) || const DeepCollectionEquality().equals(other.inDeliveryFromAlternateContact, inDeliveryFromAlternateContact)) &&
            (identical(other.inDeliveryFromAlternateContactPhone, inDeliveryFromAlternateContactPhone) || const DeepCollectionEquality().equals(other.inDeliveryFromAlternateContactPhone, inDeliveryFromAlternateContactPhone)) &&
            (identical(other.inDeliveryFromAttention, inDeliveryFromAttention) || const DeepCollectionEquality().equals(other.inDeliveryFromAttention, inDeliveryFromAttention)) &&
            (identical(other.inDeliveryFromAddress1, inDeliveryFromAddress1) || const DeepCollectionEquality().equals(other.inDeliveryFromAddress1, inDeliveryFromAddress1)) &&
            (identical(other.inDeliveryFromAdd2ress, inDeliveryFromAdd2ress) || const DeepCollectionEquality().equals(other.inDeliveryFromAdd2ress, inDeliveryFromAdd2ress)) &&
            (identical(other.inDeliveryFromCity, inDeliveryFromCity) || const DeepCollectionEquality().equals(other.inDeliveryFromCity, inDeliveryFromCity)) &&
            (identical(other.inDeliveryFromState, inDeliveryFromState) || const DeepCollectionEquality().equals(other.inDeliveryFromState, inDeliveryFromState)) &&
            (identical(other.inDeliveryFromZipCode, inDeliveryFromZipCode) || const DeepCollectionEquality().equals(other.inDeliveryFromZipCode, inDeliveryFromZipCode)) &&
            (identical(other.inDeliveryFromCountry, inDeliveryFromCountry) || const DeepCollectionEquality().equals(other.inDeliveryFromCountry, inDeliveryFromCountry)) &&
            (identical(other.inDeliveryFromCountryId, inDeliveryFromCountryId) || const DeepCollectionEquality().equals(other.inDeliveryFromCountryId, inDeliveryFromCountryId)) &&
            (identical(other.inDeliveryFromCrossStreets, inDeliveryFromCrossStreets) || const DeepCollectionEquality().equals(other.inDeliveryFromCrossStreets, inDeliveryFromCrossStreets)) &&
            (identical(other.inDeliveryToLocation, inDeliveryToLocation) || const DeepCollectionEquality().equals(other.inDeliveryToLocation, inDeliveryToLocation)) &&
            (identical(other.inDeliveryToContact, inDeliveryToContact) || const DeepCollectionEquality().equals(other.inDeliveryToContact, inDeliveryToContact)) &&
            (identical(other.inDeliveryToContactPhone, inDeliveryToContactPhone) || const DeepCollectionEquality().equals(other.inDeliveryToContactPhone, inDeliveryToContactPhone)) &&
            (identical(other.inDeliveryToAlternateContact, inDeliveryToAlternateContact) || const DeepCollectionEquality().equals(other.inDeliveryToAlternateContact, inDeliveryToAlternateContact)) &&
            (identical(other.inDeliveryToAlternateContactPhone, inDeliveryToAlternateContactPhone) || const DeepCollectionEquality().equals(other.inDeliveryToAlternateContactPhone, inDeliveryToAlternateContactPhone)) &&
            (identical(other.inDeliveryToAttention, inDeliveryToAttention) || const DeepCollectionEquality().equals(other.inDeliveryToAttention, inDeliveryToAttention)) &&
            (identical(other.inDeliveryToAddress1, inDeliveryToAddress1) || const DeepCollectionEquality().equals(other.inDeliveryToAddress1, inDeliveryToAddress1)) &&
            (identical(other.inDeliveryToAddress2, inDeliveryToAddress2) || const DeepCollectionEquality().equals(other.inDeliveryToAddress2, inDeliveryToAddress2)) &&
            (identical(other.inDeliveryToCity, inDeliveryToCity) || const DeepCollectionEquality().equals(other.inDeliveryToCity, inDeliveryToCity)) &&
            (identical(other.inDeliveryToState, inDeliveryToState) || const DeepCollectionEquality().equals(other.inDeliveryToState, inDeliveryToState)) &&
            (identical(other.inDeliveryToZipCode, inDeliveryToZipCode) || const DeepCollectionEquality().equals(other.inDeliveryToZipCode, inDeliveryToZipCode)) &&
            (identical(other.inDeliveryToCountryId, inDeliveryToCountryId) || const DeepCollectionEquality().equals(other.inDeliveryToCountryId, inDeliveryToCountryId)) &&
            (identical(other.inDeliveryToCountry, inDeliveryToCountry) || const DeepCollectionEquality().equals(other.inDeliveryToCountry, inDeliveryToCountry)) &&
            (identical(other.inDeliveryToContactFax, inDeliveryToContactFax) || const DeepCollectionEquality().equals(other.inDeliveryToContactFax, inDeliveryToContactFax)) &&
            (identical(other.inDeliveryToCrossStreets, inDeliveryToCrossStreets) || const DeepCollectionEquality().equals(other.inDeliveryToCrossStreets, inDeliveryToCrossStreets)) &&
            (identical(other.inDeliveryDeliveryNotes, inDeliveryDeliveryNotes) || const DeepCollectionEquality().equals(other.inDeliveryDeliveryNotes, inDeliveryDeliveryNotes)) &&
            (identical(other.inDeliveryCarrierId, inDeliveryCarrierId) || const DeepCollectionEquality().equals(other.inDeliveryCarrierId, inDeliveryCarrierId)) &&
            (identical(other.inDeliveryCarrier, inDeliveryCarrier) || const DeepCollectionEquality().equals(other.inDeliveryCarrier, inDeliveryCarrier)) &&
            (identical(other.inDeliveryCarrierAccount, inDeliveryCarrierAccount) || const DeepCollectionEquality().equals(other.inDeliveryCarrierAccount, inDeliveryCarrierAccount)) &&
            (identical(other.inDeliveryShipViaId, inDeliveryShipViaId) || const DeepCollectionEquality().equals(other.inDeliveryShipViaId, inDeliveryShipViaId)) &&
            (identical(other.inDeliveryShipVia, inDeliveryShipVia) || const DeepCollectionEquality().equals(other.inDeliveryShipVia, inDeliveryShipVia)) &&
            (identical(other.inDeliveryInvoiceId, inDeliveryInvoiceId) || const DeepCollectionEquality().equals(other.inDeliveryInvoiceId, inDeliveryInvoiceId)) &&
            (identical(other.inDeliveryVendorInvoiceId, inDeliveryVendorInvoiceId) || const DeepCollectionEquality().equals(other.inDeliveryVendorInvoiceId, inDeliveryVendorInvoiceId)) &&
            (identical(other.inDeliveryEstimatedFreight, inDeliveryEstimatedFreight) || const DeepCollectionEquality().equals(other.inDeliveryEstimatedFreight, inDeliveryEstimatedFreight)) &&
            (identical(other.inDeliveryFreightInvoiceAmount, inDeliveryFreightInvoiceAmount) || const DeepCollectionEquality().equals(other.inDeliveryFreightInvoiceAmount, inDeliveryFreightInvoiceAmount)) &&
            (identical(other.inDeliveryChargeType, inDeliveryChargeType) || const DeepCollectionEquality().equals(other.inDeliveryChargeType, inDeliveryChargeType)) &&
            (identical(other.inDeliveryFreightTrackingNumber, inDeliveryFreightTrackingNumber) || const DeepCollectionEquality().equals(other.inDeliveryFreightTrackingNumber, inDeliveryFreightTrackingNumber)) &&
            (identical(other.inDeliveryDropShip, inDeliveryDropShip) || const DeepCollectionEquality().equals(other.inDeliveryDropShip, inDeliveryDropShip)) &&
            (identical(other.inDeliveryPackageCode, inDeliveryPackageCode) || const DeepCollectionEquality().equals(other.inDeliveryPackageCode, inDeliveryPackageCode)) &&
            (identical(other.inDeliveryBillPoFreightOnOrder, inDeliveryBillPoFreightOnOrder) || const DeepCollectionEquality().equals(other.inDeliveryBillPoFreightOnOrder, inDeliveryBillPoFreightOnOrder)) &&
            (identical(other.inDeliveryOnlineOrderNumber, inDeliveryOnlineOrderNumber) || const DeepCollectionEquality().equals(other.inDeliveryOnlineOrderNumber, inDeliveryOnlineOrderNumber)) &&
            (identical(other.inDeliveryOnlineOrderStatus, inDeliveryOnlineOrderStatus) || const DeepCollectionEquality().equals(other.inDeliveryOnlineOrderStatus, inDeliveryOnlineOrderStatus)) &&
            (identical(other.inDeliveryDateStamp, inDeliveryDateStamp) || const DeepCollectionEquality().equals(other.inDeliveryDateStamp, inDeliveryDateStamp)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesTransfersTransferOrderTransferOrderExtension
    on WebApiModulesTransfersTransferOrderTransferOrder {
  WebApiModulesTransfersTransferOrderTransferOrder copyWith(
      {String? transferId,
      String? transferNumber,
      String? transferDate,
      String? description,
      String? status,
      String? statusDate,
      String? fromWarehouseId,
      String? fromWarehouse,
      String? fromWarehouseCode,
      String? toWarehouseId,
      String? toWarehouse,
      String? toWarehouseCode,
      String? departmentId,
      String? department,
      bool? rental,
      bool? sales,
      bool? hasRentalItem,
      bool? hasSalesItem,
      String? agentId,
      String? agent,
      String? relatedToOrderId,
      String? relatedToOrderNumber,
      String? officeLocationId,
      String? officeLocation,
      bool? isReturnTransferOrder,
      String? pickDate,
      String? pickTime,
      String? shipDate,
      String? shipTime,
      String? requiredDate,
      String? requiredTime,
      String? outDeliveryId,
      String? outDeliveryDeliveryType,
      String? outDeliveryRequiredDate,
      String? outDeliveryRequiredTime,
      String? outDeliveryTargetShipDate,
      String? outDeliveryTargetShipTime,
      String? outDeliveryDirection,
      String? outDeliveryAddressType,
      String? outDeliveryFromLocation,
      String? outDeliveryFromContact,
      String? outDeliveryFromContactPhone,
      String? outDeliveryFromAlternateContact,
      String? outDeliveryFromAlternateContactPhone,
      String? outDeliveryFromAttention,
      String? outDeliveryFromAddress1,
      String? outDeliveryFromAdd2ress,
      String? outDeliveryFromCity,
      String? outDeliveryFromState,
      String? outDeliveryFromZipCode,
      String? outDeliveryFromCountry,
      String? outDeliveryFromCountryId,
      String? outDeliveryFromCrossStreets,
      String? outDeliveryToLocation,
      String? outDeliveryToContact,
      String? outDeliveryToContactPhone,
      String? outDeliveryToAlternateContact,
      String? outDeliveryToAlternateContactPhone,
      String? outDeliveryToAttention,
      String? outDeliveryToAddress1,
      String? outDeliveryToAddress2,
      String? outDeliveryToCity,
      String? outDeliveryToState,
      String? outDeliveryToZipCode,
      String? outDeliveryToCountryId,
      String? outDeliveryToCountry,
      String? outDeliveryToContactFax,
      String? outDeliveryToCrossStreets,
      String? outDeliveryDeliveryNotes,
      String? outDeliveryCarrierId,
      String? outDeliveryCarrier,
      String? outDeliveryCarrierAccount,
      String? outDeliveryShipViaId,
      String? outDeliveryShipVia,
      String? outDeliveryInvoiceId,
      String? outDeliveryVendorInvoiceId,
      double? outDeliveryEstimatedFreight,
      double? outDeliveryFreightInvoiceAmount,
      String? outDeliveryChargeType,
      String? outDeliveryFreightTrackingNumber,
      bool? outDeliveryDropShip,
      String? outDeliveryPackageCode,
      bool? outDeliveryBillPoFreightOnOrder,
      String? outDeliveryOnlineOrderNumber,
      String? outDeliveryDateStamp,
      String? inDeliveryId,
      String? inDeliveryDeliveryType,
      String? inDeliveryRequiredDate,
      String? inDeliveryRequiredTime,
      String? inDeliveryTargetShipDate,
      String? inDeliveryTargetShipTime,
      String? inDeliveryDirection,
      String? inDeliveryAddressType,
      String? inDeliveryFromLocation,
      String? inDeliveryFromContact,
      String? inDeliveryFromContactPhone,
      String? inDeliveryFromAlternateContact,
      String? inDeliveryFromAlternateContactPhone,
      String? inDeliveryFromAttention,
      String? inDeliveryFromAddress1,
      String? inDeliveryFromAdd2ress,
      String? inDeliveryFromCity,
      String? inDeliveryFromState,
      String? inDeliveryFromZipCode,
      String? inDeliveryFromCountry,
      String? inDeliveryFromCountryId,
      String? inDeliveryFromCrossStreets,
      String? inDeliveryToLocation,
      String? inDeliveryToContact,
      String? inDeliveryToContactPhone,
      String? inDeliveryToAlternateContact,
      String? inDeliveryToAlternateContactPhone,
      String? inDeliveryToAttention,
      String? inDeliveryToAddress1,
      String? inDeliveryToAddress2,
      String? inDeliveryToCity,
      String? inDeliveryToState,
      String? inDeliveryToZipCode,
      String? inDeliveryToCountryId,
      String? inDeliveryToCountry,
      String? inDeliveryToContactFax,
      String? inDeliveryToCrossStreets,
      String? inDeliveryDeliveryNotes,
      String? inDeliveryCarrierId,
      String? inDeliveryCarrier,
      String? inDeliveryCarrierAccount,
      String? inDeliveryShipViaId,
      String? inDeliveryShipVia,
      String? inDeliveryInvoiceId,
      String? inDeliveryVendorInvoiceId,
      double? inDeliveryEstimatedFreight,
      double? inDeliveryFreightInvoiceAmount,
      String? inDeliveryChargeType,
      String? inDeliveryFreightTrackingNumber,
      bool? inDeliveryDropShip,
      String? inDeliveryPackageCode,
      bool? inDeliveryBillPoFreightOnOrder,
      String? inDeliveryOnlineOrderNumber,
      String? inDeliveryOnlineOrderStatus,
      String? inDeliveryDateStamp,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesTransfersTransferOrderTransferOrder(
        transferId: transferId ?? this.transferId,
        transferNumber: transferNumber ?? this.transferNumber,
        transferDate: transferDate ?? this.transferDate,
        description: description ?? this.description,
        status: status ?? this.status,
        statusDate: statusDate ?? this.statusDate,
        fromWarehouseId: fromWarehouseId ?? this.fromWarehouseId,
        fromWarehouse: fromWarehouse ?? this.fromWarehouse,
        fromWarehouseCode: fromWarehouseCode ?? this.fromWarehouseCode,
        toWarehouseId: toWarehouseId ?? this.toWarehouseId,
        toWarehouse: toWarehouse ?? this.toWarehouse,
        toWarehouseCode: toWarehouseCode ?? this.toWarehouseCode,
        departmentId: departmentId ?? this.departmentId,
        department: department ?? this.department,
        rental: rental ?? this.rental,
        sales: sales ?? this.sales,
        hasRentalItem: hasRentalItem ?? this.hasRentalItem,
        hasSalesItem: hasSalesItem ?? this.hasSalesItem,
        agentId: agentId ?? this.agentId,
        agent: agent ?? this.agent,
        relatedToOrderId: relatedToOrderId ?? this.relatedToOrderId,
        relatedToOrderNumber: relatedToOrderNumber ?? this.relatedToOrderNumber,
        officeLocationId: officeLocationId ?? this.officeLocationId,
        officeLocation: officeLocation ?? this.officeLocation,
        isReturnTransferOrder:
            isReturnTransferOrder ?? this.isReturnTransferOrder,
        pickDate: pickDate ?? this.pickDate,
        pickTime: pickTime ?? this.pickTime,
        shipDate: shipDate ?? this.shipDate,
        shipTime: shipTime ?? this.shipTime,
        requiredDate: requiredDate ?? this.requiredDate,
        requiredTime: requiredTime ?? this.requiredTime,
        outDeliveryId: outDeliveryId ?? this.outDeliveryId,
        outDeliveryDeliveryType:
            outDeliveryDeliveryType ?? this.outDeliveryDeliveryType,
        outDeliveryRequiredDate:
            outDeliveryRequiredDate ?? this.outDeliveryRequiredDate,
        outDeliveryRequiredTime:
            outDeliveryRequiredTime ?? this.outDeliveryRequiredTime,
        outDeliveryTargetShipDate:
            outDeliveryTargetShipDate ?? this.outDeliveryTargetShipDate,
        outDeliveryTargetShipTime:
            outDeliveryTargetShipTime ?? this.outDeliveryTargetShipTime,
        outDeliveryDirection: outDeliveryDirection ?? this.outDeliveryDirection,
        outDeliveryAddressType:
            outDeliveryAddressType ?? this.outDeliveryAddressType,
        outDeliveryFromLocation:
            outDeliveryFromLocation ?? this.outDeliveryFromLocation,
        outDeliveryFromContact:
            outDeliveryFromContact ?? this.outDeliveryFromContact,
        outDeliveryFromContactPhone:
            outDeliveryFromContactPhone ?? this.outDeliveryFromContactPhone,
        outDeliveryFromAlternateContact: outDeliveryFromAlternateContact ??
            this.outDeliveryFromAlternateContact,
        outDeliveryFromAlternateContactPhone: outDeliveryFromAlternateContactPhone ??
            this.outDeliveryFromAlternateContactPhone,
        outDeliveryFromAttention:
            outDeliveryFromAttention ?? this.outDeliveryFromAttention,
        outDeliveryFromAddress1:
            outDeliveryFromAddress1 ?? this.outDeliveryFromAddress1,
        outDeliveryFromAdd2ress:
            outDeliveryFromAdd2ress ?? this.outDeliveryFromAdd2ress,
        outDeliveryFromCity: outDeliveryFromCity ?? this.outDeliveryFromCity,
        outDeliveryFromState: outDeliveryFromState ?? this.outDeliveryFromState,
        outDeliveryFromZipCode:
            outDeliveryFromZipCode ?? this.outDeliveryFromZipCode,
        outDeliveryFromCountry:
            outDeliveryFromCountry ?? this.outDeliveryFromCountry,
        outDeliveryFromCountryId:
            outDeliveryFromCountryId ?? this.outDeliveryFromCountryId,
        outDeliveryFromCrossStreets:
            outDeliveryFromCrossStreets ?? this.outDeliveryFromCrossStreets,
        outDeliveryToLocation:
            outDeliveryToLocation ?? this.outDeliveryToLocation,
        outDeliveryToContact: outDeliveryToContact ?? this.outDeliveryToContact,
        outDeliveryToContactPhone:
            outDeliveryToContactPhone ?? this.outDeliveryToContactPhone,
        outDeliveryToAlternateContact:
            outDeliveryToAlternateContact ?? this.outDeliveryToAlternateContact,
        outDeliveryToAlternateContactPhone: outDeliveryToAlternateContactPhone ??
            this.outDeliveryToAlternateContactPhone,
        outDeliveryToAttention:
            outDeliveryToAttention ?? this.outDeliveryToAttention,
        outDeliveryToAddress1:
            outDeliveryToAddress1 ?? this.outDeliveryToAddress1,
        outDeliveryToAddress2:
            outDeliveryToAddress2 ?? this.outDeliveryToAddress2,
        outDeliveryToCity: outDeliveryToCity ?? this.outDeliveryToCity,
        outDeliveryToState: outDeliveryToState ?? this.outDeliveryToState,
        outDeliveryToZipCode: outDeliveryToZipCode ?? this.outDeliveryToZipCode,
        outDeliveryToCountryId:
            outDeliveryToCountryId ?? this.outDeliveryToCountryId,
        outDeliveryToCountry: outDeliveryToCountry ?? this.outDeliveryToCountry,
        outDeliveryToContactFax:
            outDeliveryToContactFax ?? this.outDeliveryToContactFax,
        outDeliveryToCrossStreets:
            outDeliveryToCrossStreets ?? this.outDeliveryToCrossStreets,
        outDeliveryDeliveryNotes:
            outDeliveryDeliveryNotes ?? this.outDeliveryDeliveryNotes,
        outDeliveryCarrierId: outDeliveryCarrierId ?? this.outDeliveryCarrierId,
        outDeliveryCarrier: outDeliveryCarrier ?? this.outDeliveryCarrier,
        outDeliveryCarrierAccount:
            outDeliveryCarrierAccount ?? this.outDeliveryCarrierAccount,
        outDeliveryShipViaId: outDeliveryShipViaId ?? this.outDeliveryShipViaId,
        outDeliveryShipVia: outDeliveryShipVia ?? this.outDeliveryShipVia,
        outDeliveryInvoiceId: outDeliveryInvoiceId ?? this.outDeliveryInvoiceId,
        outDeliveryVendorInvoiceId:
            outDeliveryVendorInvoiceId ?? this.outDeliveryVendorInvoiceId,
        outDeliveryEstimatedFreight:
            outDeliveryEstimatedFreight ?? this.outDeliveryEstimatedFreight,
        outDeliveryFreightInvoiceAmount: outDeliveryFreightInvoiceAmount ??
            this.outDeliveryFreightInvoiceAmount,
        outDeliveryChargeType:
            outDeliveryChargeType ?? this.outDeliveryChargeType,
        outDeliveryFreightTrackingNumber: outDeliveryFreightTrackingNumber ??
            this.outDeliveryFreightTrackingNumber,
        outDeliveryDropShip: outDeliveryDropShip ?? this.outDeliveryDropShip,
        outDeliveryPackageCode:
            outDeliveryPackageCode ?? this.outDeliveryPackageCode,
        outDeliveryBillPoFreightOnOrder: outDeliveryBillPoFreightOnOrder ??
            this.outDeliveryBillPoFreightOnOrder,
        outDeliveryOnlineOrderNumber:
            outDeliveryOnlineOrderNumber ?? this.outDeliveryOnlineOrderNumber,
        outDeliveryDateStamp: outDeliveryDateStamp ?? this.outDeliveryDateStamp,
        inDeliveryId: inDeliveryId ?? this.inDeliveryId,
        inDeliveryDeliveryType:
            inDeliveryDeliveryType ?? this.inDeliveryDeliveryType,
        inDeliveryRequiredDate:
            inDeliveryRequiredDate ?? this.inDeliveryRequiredDate,
        inDeliveryRequiredTime:
            inDeliveryRequiredTime ?? this.inDeliveryRequiredTime,
        inDeliveryTargetShipDate:
            inDeliveryTargetShipDate ?? this.inDeliveryTargetShipDate,
        inDeliveryTargetShipTime:
            inDeliveryTargetShipTime ?? this.inDeliveryTargetShipTime,
        inDeliveryDirection: inDeliveryDirection ?? this.inDeliveryDirection,
        inDeliveryAddressType:
            inDeliveryAddressType ?? this.inDeliveryAddressType,
        inDeliveryFromLocation:
            inDeliveryFromLocation ?? this.inDeliveryFromLocation,
        inDeliveryFromContact:
            inDeliveryFromContact ?? this.inDeliveryFromContact,
        inDeliveryFromContactPhone:
            inDeliveryFromContactPhone ?? this.inDeliveryFromContactPhone,
        inDeliveryFromAlternateContact:
            inDeliveryFromAlternateContact ?? this.inDeliveryFromAlternateContact,
        inDeliveryFromAlternateContactPhone: inDeliveryFromAlternateContactPhone ?? this.inDeliveryFromAlternateContactPhone,
        inDeliveryFromAttention: inDeliveryFromAttention ?? this.inDeliveryFromAttention,
        inDeliveryFromAddress1: inDeliveryFromAddress1 ?? this.inDeliveryFromAddress1,
        inDeliveryFromAdd2ress: inDeliveryFromAdd2ress ?? this.inDeliveryFromAdd2ress,
        inDeliveryFromCity: inDeliveryFromCity ?? this.inDeliveryFromCity,
        inDeliveryFromState: inDeliveryFromState ?? this.inDeliveryFromState,
        inDeliveryFromZipCode: inDeliveryFromZipCode ?? this.inDeliveryFromZipCode,
        inDeliveryFromCountry: inDeliveryFromCountry ?? this.inDeliveryFromCountry,
        inDeliveryFromCountryId: inDeliveryFromCountryId ?? this.inDeliveryFromCountryId,
        inDeliveryFromCrossStreets: inDeliveryFromCrossStreets ?? this.inDeliveryFromCrossStreets,
        inDeliveryToLocation: inDeliveryToLocation ?? this.inDeliveryToLocation,
        inDeliveryToContact: inDeliveryToContact ?? this.inDeliveryToContact,
        inDeliveryToContactPhone: inDeliveryToContactPhone ?? this.inDeliveryToContactPhone,
        inDeliveryToAlternateContact: inDeliveryToAlternateContact ?? this.inDeliveryToAlternateContact,
        inDeliveryToAlternateContactPhone: inDeliveryToAlternateContactPhone ?? this.inDeliveryToAlternateContactPhone,
        inDeliveryToAttention: inDeliveryToAttention ?? this.inDeliveryToAttention,
        inDeliveryToAddress1: inDeliveryToAddress1 ?? this.inDeliveryToAddress1,
        inDeliveryToAddress2: inDeliveryToAddress2 ?? this.inDeliveryToAddress2,
        inDeliveryToCity: inDeliveryToCity ?? this.inDeliveryToCity,
        inDeliveryToState: inDeliveryToState ?? this.inDeliveryToState,
        inDeliveryToZipCode: inDeliveryToZipCode ?? this.inDeliveryToZipCode,
        inDeliveryToCountryId: inDeliveryToCountryId ?? this.inDeliveryToCountryId,
        inDeliveryToCountry: inDeliveryToCountry ?? this.inDeliveryToCountry,
        inDeliveryToContactFax: inDeliveryToContactFax ?? this.inDeliveryToContactFax,
        inDeliveryToCrossStreets: inDeliveryToCrossStreets ?? this.inDeliveryToCrossStreets,
        inDeliveryDeliveryNotes: inDeliveryDeliveryNotes ?? this.inDeliveryDeliveryNotes,
        inDeliveryCarrierId: inDeliveryCarrierId ?? this.inDeliveryCarrierId,
        inDeliveryCarrier: inDeliveryCarrier ?? this.inDeliveryCarrier,
        inDeliveryCarrierAccount: inDeliveryCarrierAccount ?? this.inDeliveryCarrierAccount,
        inDeliveryShipViaId: inDeliveryShipViaId ?? this.inDeliveryShipViaId,
        inDeliveryShipVia: inDeliveryShipVia ?? this.inDeliveryShipVia,
        inDeliveryInvoiceId: inDeliveryInvoiceId ?? this.inDeliveryInvoiceId,
        inDeliveryVendorInvoiceId: inDeliveryVendorInvoiceId ?? this.inDeliveryVendorInvoiceId,
        inDeliveryEstimatedFreight: inDeliveryEstimatedFreight ?? this.inDeliveryEstimatedFreight,
        inDeliveryFreightInvoiceAmount: inDeliveryFreightInvoiceAmount ?? this.inDeliveryFreightInvoiceAmount,
        inDeliveryChargeType: inDeliveryChargeType ?? this.inDeliveryChargeType,
        inDeliveryFreightTrackingNumber: inDeliveryFreightTrackingNumber ?? this.inDeliveryFreightTrackingNumber,
        inDeliveryDropShip: inDeliveryDropShip ?? this.inDeliveryDropShip,
        inDeliveryPackageCode: inDeliveryPackageCode ?? this.inDeliveryPackageCode,
        inDeliveryBillPoFreightOnOrder: inDeliveryBillPoFreightOnOrder ?? this.inDeliveryBillPoFreightOnOrder,
        inDeliveryOnlineOrderNumber: inDeliveryOnlineOrderNumber ?? this.inDeliveryOnlineOrderNumber,
        inDeliveryOnlineOrderStatus: inDeliveryOnlineOrderStatus ?? this.inDeliveryOnlineOrderStatus,
        inDeliveryDateStamp: inDeliveryDateStamp ?? this.inDeliveryDateStamp,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes: defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesUtilitiesGLDistributionRefreshGLHistoryRequest {
  WebApiModulesUtilitiesGLDistributionRefreshGLHistoryRequest({
    this.fromDate,
    this.toDate,
  });

  factory WebApiModulesUtilitiesGLDistributionRefreshGLHistoryRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesUtilitiesGLDistributionRefreshGLHistoryRequestFromJson(
          json);

  @JsonKey(name: 'FromDate')
  final DateTime? fromDate;
  @JsonKey(name: 'ToDate')
  final DateTime? toDate;
  static const fromJsonFactory =
      _$WebApiModulesUtilitiesGLDistributionRefreshGLHistoryRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesUtilitiesGLDistributionRefreshGLHistoryRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesUtilitiesGLDistributionRefreshGLHistoryRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesUtilitiesGLDistributionRefreshGLHistoryRequest &&
            (identical(other.fromDate, fromDate) ||
                const DeepCollectionEquality()
                    .equals(other.fromDate, fromDate)) &&
            (identical(other.toDate, toDate) ||
                const DeepCollectionEquality().equals(other.toDate, toDate)));
  }
}

extension $WebApiModulesUtilitiesGLDistributionRefreshGLHistoryRequestExtension
    on WebApiModulesUtilitiesGLDistributionRefreshGLHistoryRequest {
  WebApiModulesUtilitiesGLDistributionRefreshGLHistoryRequest copyWith(
      {DateTime? fromDate, DateTime? toDate}) {
    return WebApiModulesUtilitiesGLDistributionRefreshGLHistoryRequest(
        fromDate: fromDate ?? this.fromDate, toDate: toDate ?? this.toDate);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesUtilitiesGLDistributionRefreshGLHistoryResponse {
  WebApiModulesUtilitiesGLDistributionRefreshGLHistoryResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesUtilitiesGLDistributionRefreshGLHistoryResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesUtilitiesGLDistributionRefreshGLHistoryResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesUtilitiesGLDistributionRefreshGLHistoryResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesUtilitiesGLDistributionRefreshGLHistoryResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesUtilitiesGLDistributionRefreshGLHistoryResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesUtilitiesGLDistributionRefreshGLHistoryResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesUtilitiesGLDistributionRefreshGLHistoryResponseExtension
    on WebApiModulesUtilitiesGLDistributionRefreshGLHistoryResponse {
  WebApiModulesUtilitiesGLDistributionRefreshGLHistoryResponse copyWith(
      {int? status, bool? success, String? msg}) {
    return WebApiModulesUtilitiesGLDistributionRefreshGLHistoryResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckInCancelCheckInItemRequest {
  WebApiModulesWarehouseCheckInCancelCheckInItemRequest({
    this.orderTranId,
    this.internalChar,
    this.contractId,
    this.orderId,
    this.orderItemId,
    this.inventoryId,
    this.vendorId,
    this.description,
    this.quantity,
  });

  factory WebApiModulesWarehouseCheckInCancelCheckInItemRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckInCancelCheckInItemRequestFromJson(json);

  @JsonKey(name: 'OrderTranId')
  final int? orderTranId;
  @JsonKey(name: 'InternalChar')
  final String? internalChar;
  @JsonKey(name: 'ContractId')
  final String? contractId;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderItemId')
  final String? orderItemId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'VendorId')
  final String? vendorId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'Quantity')
  final int? quantity;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckInCancelCheckInItemRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckInCancelCheckInItemRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckInCancelCheckInItemRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckInCancelCheckInItemRequest &&
            (identical(other.orderTranId, orderTranId) ||
                const DeepCollectionEquality()
                    .equals(other.orderTranId, orderTranId)) &&
            (identical(other.internalChar, internalChar) ||
                const DeepCollectionEquality()
                    .equals(other.internalChar, internalChar)) &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderItemId, orderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.orderItemId, orderItemId)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.vendorId, vendorId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorId, vendorId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)));
  }
}

extension $WebApiModulesWarehouseCheckInCancelCheckInItemRequestExtension
    on WebApiModulesWarehouseCheckInCancelCheckInItemRequest {
  WebApiModulesWarehouseCheckInCancelCheckInItemRequest copyWith(
      {int? orderTranId,
      String? internalChar,
      String? contractId,
      String? orderId,
      String? orderItemId,
      String? inventoryId,
      String? vendorId,
      String? description,
      int? quantity}) {
    return WebApiModulesWarehouseCheckInCancelCheckInItemRequest(
        orderTranId: orderTranId ?? this.orderTranId,
        internalChar: internalChar ?? this.internalChar,
        contractId: contractId ?? this.contractId,
        orderId: orderId ?? this.orderId,
        orderItemId: orderItemId ?? this.orderItemId,
        inventoryId: inventoryId ?? this.inventoryId,
        vendorId: vendorId ?? this.vendorId,
        description: description ?? this.description,
        quantity: quantity ?? this.quantity);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckInCancelCheckInItemResponse {
  WebApiModulesWarehouseCheckInCancelCheckInItemResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesWarehouseCheckInCancelCheckInItemResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckInCancelCheckInItemResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckInCancelCheckInItemResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckInCancelCheckInItemResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckInCancelCheckInItemResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckInCancelCheckInItemResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesWarehouseCheckInCancelCheckInItemResponseExtension
    on WebApiModulesWarehouseCheckInCancelCheckInItemResponse {
  WebApiModulesWarehouseCheckInCancelCheckInItemResponse copyWith(
      {int? status, bool? success, String? msg}) {
    return WebApiModulesWarehouseCheckInCancelCheckInItemResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckInCheckInContractRequest {
  WebApiModulesWarehouseCheckInCheckInContractRequest({
    this.orderId,
    this.dealId,
    this.departmentId,
    this.officeLocationId,
    this.warehouseId,
  });

  factory WebApiModulesWarehouseCheckInCheckInContractRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckInCheckInContractRequestFromJson(json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'OfficeLocationId')
  final String? officeLocationId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckInCheckInContractRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckInCheckInContractRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckInCheckInContractRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckInCheckInContractRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.departmentId, departmentId) ||
                const DeepCollectionEquality()
                    .equals(other.departmentId, departmentId)) &&
            (identical(other.officeLocationId, officeLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocationId, officeLocationId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)));
  }
}

extension $WebApiModulesWarehouseCheckInCheckInContractRequestExtension
    on WebApiModulesWarehouseCheckInCheckInContractRequest {
  WebApiModulesWarehouseCheckInCheckInContractRequest copyWith(
      {String? orderId,
      String? dealId,
      String? departmentId,
      String? officeLocationId,
      String? warehouseId}) {
    return WebApiModulesWarehouseCheckInCheckInContractRequest(
        orderId: orderId ?? this.orderId,
        dealId: dealId ?? this.dealId,
        departmentId: departmentId ?? this.departmentId,
        officeLocationId: officeLocationId ?? this.officeLocationId,
        warehouseId: warehouseId ?? this.warehouseId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckInCheckInContractResponse {
  WebApiModulesWarehouseCheckInCheckInContractResponse({
    this.contractId,
  });

  factory WebApiModulesWarehouseCheckInCheckInContractResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckInCheckInContractResponseFromJson(json);

  @JsonKey(name: 'ContractId')
  final String? contractId;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckInCheckInContractResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckInCheckInContractResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckInCheckInContractResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckInCheckInContractResponse &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)));
  }
}

extension $WebApiModulesWarehouseCheckInCheckInContractResponseExtension
    on WebApiModulesWarehouseCheckInCheckInContractResponse {
  WebApiModulesWarehouseCheckInCheckInContractResponse copyWith(
      {String? contractId}) {
    return WebApiModulesWarehouseCheckInCheckInContractResponse(
        contractId: contractId ?? this.contractId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckInCheckInItemRequest {
  WebApiModulesWarehouseCheckInCheckInItemRequest({
    this.moduleType,
    this.contractId,
    this.code,
    this.orderId,
    this.orderItemId,
    this.vendorId,
    this.warehouseId,
    this.quantity,
    this.addOrderToContract,
    this.swapItem,
  });

  factory WebApiModulesWarehouseCheckInCheckInItemRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckInCheckInItemRequestFromJson(json);

  @JsonKey(name: 'ModuleType')
  final String? moduleType;
  @JsonKey(name: 'ContractId')
  final String? contractId;
  @JsonKey(name: 'Code')
  final String? code;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderItemId')
  final String? orderItemId;
  @JsonKey(name: 'VendorId')
  final String? vendorId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'Quantity')
  final int? quantity;
  @JsonKey(name: 'AddOrderToContract')
  final bool? addOrderToContract;
  @JsonKey(name: 'SwapItem')
  final bool? swapItem;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckInCheckInItemRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckInCheckInItemRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckInCheckInItemRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckInCheckInItemRequest &&
            (identical(other.moduleType, moduleType) ||
                const DeepCollectionEquality()
                    .equals(other.moduleType, moduleType)) &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)) &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderItemId, orderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.orderItemId, orderItemId)) &&
            (identical(other.vendorId, vendorId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorId, vendorId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)) &&
            (identical(other.addOrderToContract, addOrderToContract) ||
                const DeepCollectionEquality()
                    .equals(other.addOrderToContract, addOrderToContract)) &&
            (identical(other.swapItem, swapItem) ||
                const DeepCollectionEquality()
                    .equals(other.swapItem, swapItem)));
  }
}

extension $WebApiModulesWarehouseCheckInCheckInItemRequestExtension
    on WebApiModulesWarehouseCheckInCheckInItemRequest {
  WebApiModulesWarehouseCheckInCheckInItemRequest copyWith(
      {String? moduleType,
      String? contractId,
      String? code,
      String? orderId,
      String? orderItemId,
      String? vendorId,
      String? warehouseId,
      int? quantity,
      bool? addOrderToContract,
      bool? swapItem}) {
    return WebApiModulesWarehouseCheckInCheckInItemRequest(
        moduleType: moduleType ?? this.moduleType,
        contractId: contractId ?? this.contractId,
        code: code ?? this.code,
        orderId: orderId ?? this.orderId,
        orderItemId: orderItemId ?? this.orderItemId,
        vendorId: vendorId ?? this.vendorId,
        warehouseId: warehouseId ?? this.warehouseId,
        quantity: quantity ?? this.quantity,
        addOrderToContract: addOrderToContract ?? this.addOrderToContract,
        swapItem: swapItem ?? this.swapItem);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckInHasQuikReceiptRequest {
  WebApiModulesWarehouseCheckInHasQuikReceiptRequest({
    this.contractId,
  });

  factory WebApiModulesWarehouseCheckInHasQuikReceiptRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckInHasQuikReceiptRequestFromJson(json);

  @JsonKey(name: 'ContractId')
  final String? contractId;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckInHasQuikReceiptRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckInHasQuikReceiptRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckInHasQuikReceiptRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckInHasQuikReceiptRequest &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)));
  }
}

extension $WebApiModulesWarehouseCheckInHasQuikReceiptRequestExtension
    on WebApiModulesWarehouseCheckInHasQuikReceiptRequest {
  WebApiModulesWarehouseCheckInHasQuikReceiptRequest copyWith(
      {String? contractId}) {
    return WebApiModulesWarehouseCheckInHasQuikReceiptRequest(
        contractId: contractId ?? this.contractId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckInOrderInventoryStatusCheckIn {
  WebApiModulesWarehouseCheckInOrderInventoryStatusCheckIn({
    this.iCode,
    this.description,
    this.quantityOrdered,
    this.quantitySub,
    this.quantityStaged,
    this.quantityOut,
    this.quantityIn,
    this.quantityRemaining,
  });

  factory WebApiModulesWarehouseCheckInOrderInventoryStatusCheckIn.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckInOrderInventoryStatusCheckInFromJson(json);

  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'QuantityOrdered')
  final int? quantityOrdered;
  @JsonKey(name: 'QuantitySub')
  final int? quantitySub;
  @JsonKey(name: 'QuantityStaged')
  final int? quantityStaged;
  @JsonKey(name: 'QuantityOut')
  final int? quantityOut;
  @JsonKey(name: 'QuantityIn')
  final int? quantityIn;
  @JsonKey(name: 'QuantityRemaining')
  final int? quantityRemaining;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckInOrderInventoryStatusCheckInFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckInOrderInventoryStatusCheckInToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckInOrderInventoryStatusCheckInToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckInOrderInventoryStatusCheckIn &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.quantityOrdered, quantityOrdered) ||
                const DeepCollectionEquality()
                    .equals(other.quantityOrdered, quantityOrdered)) &&
            (identical(other.quantitySub, quantitySub) ||
                const DeepCollectionEquality()
                    .equals(other.quantitySub, quantitySub)) &&
            (identical(other.quantityStaged, quantityStaged) ||
                const DeepCollectionEquality()
                    .equals(other.quantityStaged, quantityStaged)) &&
            (identical(other.quantityOut, quantityOut) ||
                const DeepCollectionEquality()
                    .equals(other.quantityOut, quantityOut)) &&
            (identical(other.quantityIn, quantityIn) ||
                const DeepCollectionEquality()
                    .equals(other.quantityIn, quantityIn)) &&
            (identical(other.quantityRemaining, quantityRemaining) ||
                const DeepCollectionEquality()
                    .equals(other.quantityRemaining, quantityRemaining)));
  }
}

extension $WebApiModulesWarehouseCheckInOrderInventoryStatusCheckInExtension
    on WebApiModulesWarehouseCheckInOrderInventoryStatusCheckIn {
  WebApiModulesWarehouseCheckInOrderInventoryStatusCheckIn copyWith(
      {String? iCode,
      String? description,
      int? quantityOrdered,
      int? quantitySub,
      int? quantityStaged,
      int? quantityOut,
      int? quantityIn,
      int? quantityRemaining}) {
    return WebApiModulesWarehouseCheckInOrderInventoryStatusCheckIn(
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        quantityOrdered: quantityOrdered ?? this.quantityOrdered,
        quantitySub: quantitySub ?? this.quantitySub,
        quantityStaged: quantityStaged ?? this.quantityStaged,
        quantityOut: quantityOut ?? this.quantityOut,
        quantityIn: quantityIn ?? this.quantityIn,
        quantityRemaining: quantityRemaining ?? this.quantityRemaining);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckInTCheckInItemResponse {
  WebApiModulesWarehouseCheckInTCheckInItemResponse({
    this.contractId,
    this.orderId,
    this.orderNumber,
    this.orderDescription,
    this.dealId,
    this.deal,
    this.departmentId,
    this.department,
    this.inventoryId,
    this.inventoryClass,
    this.warehouseId,
    this.orderItemId,
    this.vendorId,
    this.inventoryStatus,
    this.showNewOrder,
    this.showSwap,
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesWarehouseCheckInTCheckInItemResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckInTCheckInItemResponseFromJson(json);

  @JsonKey(name: 'ContractId')
  final String? contractId;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderNumber')
  final String? orderNumber;
  @JsonKey(name: 'OrderDescription')
  final String? orderDescription;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'Deal')
  final String? deal;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'Department')
  final String? department;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'InventoryClass')
  final String? inventoryClass;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'OrderItemId')
  final String? orderItemId;
  @JsonKey(name: 'VendorId')
  final String? vendorId;
  @JsonKey(name: 'InventoryStatus')
  final WebApiModulesWarehouseCheckInOrderInventoryStatusCheckIn?
      inventoryStatus;
  @JsonKey(name: 'ShowNewOrder')
  final bool? showNewOrder;
  @JsonKey(name: 'ShowSwap')
  final bool? showSwap;
  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckInTCheckInItemResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckInTCheckInItemResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckInTCheckInItemResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckInTCheckInItemResponse &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderNumber, orderNumber) ||
                const DeepCollectionEquality()
                    .equals(other.orderNumber, orderNumber)) &&
            (identical(other.orderDescription, orderDescription) ||
                const DeepCollectionEquality()
                    .equals(other.orderDescription, orderDescription)) &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.deal, deal) ||
                const DeepCollectionEquality().equals(other.deal, deal)) &&
            (identical(other.departmentId, departmentId) ||
                const DeepCollectionEquality()
                    .equals(other.departmentId, departmentId)) &&
            (identical(other.department, department) ||
                const DeepCollectionEquality()
                    .equals(other.department, department)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.inventoryClass, inventoryClass) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryClass, inventoryClass)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.orderItemId, orderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.orderItemId, orderItemId)) &&
            (identical(other.vendorId, vendorId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorId, vendorId)) &&
            (identical(other.inventoryStatus, inventoryStatus) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryStatus, inventoryStatus)) &&
            (identical(other.showNewOrder, showNewOrder) ||
                const DeepCollectionEquality()
                    .equals(other.showNewOrder, showNewOrder)) &&
            (identical(other.showSwap, showSwap) ||
                const DeepCollectionEquality()
                    .equals(other.showSwap, showSwap)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesWarehouseCheckInTCheckInItemResponseExtension
    on WebApiModulesWarehouseCheckInTCheckInItemResponse {
  WebApiModulesWarehouseCheckInTCheckInItemResponse copyWith(
      {String? contractId,
      String? orderId,
      String? orderNumber,
      String? orderDescription,
      String? dealId,
      String? deal,
      String? departmentId,
      String? department,
      String? inventoryId,
      String? inventoryClass,
      String? warehouseId,
      String? orderItemId,
      String? vendorId,
      WebApiModulesWarehouseCheckInOrderInventoryStatusCheckIn? inventoryStatus,
      bool? showNewOrder,
      bool? showSwap,
      int? status,
      bool? success,
      String? msg}) {
    return WebApiModulesWarehouseCheckInTCheckInItemResponse(
        contractId: contractId ?? this.contractId,
        orderId: orderId ?? this.orderId,
        orderNumber: orderNumber ?? this.orderNumber,
        orderDescription: orderDescription ?? this.orderDescription,
        dealId: dealId ?? this.dealId,
        deal: deal ?? this.deal,
        departmentId: departmentId ?? this.departmentId,
        department: department ?? this.department,
        inventoryId: inventoryId ?? this.inventoryId,
        inventoryClass: inventoryClass ?? this.inventoryClass,
        warehouseId: warehouseId ?? this.warehouseId,
        orderItemId: orderItemId ?? this.orderItemId,
        vendorId: vendorId ?? this.vendorId,
        inventoryStatus: inventoryStatus ?? this.inventoryStatus,
        showNewOrder: showNewOrder ?? this.showNewOrder,
        showSwap: showSwap ?? this.showSwap,
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutCheckOutAllStagedRequest {
  WebApiModulesWarehouseCheckOutCheckOutAllStagedRequest({
    this.orderId,
    this.officeLocationId,
    this.warehouseId,
  });

  factory WebApiModulesWarehouseCheckOutCheckOutAllStagedRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutCheckOutAllStagedRequestFromJson(json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OfficeLocationId')
  final String? officeLocationId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutCheckOutAllStagedRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutCheckOutAllStagedRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutCheckOutAllStagedRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutCheckOutAllStagedRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.officeLocationId, officeLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocationId, officeLocationId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)));
  }
}

extension $WebApiModulesWarehouseCheckOutCheckOutAllStagedRequestExtension
    on WebApiModulesWarehouseCheckOutCheckOutAllStagedRequest {
  WebApiModulesWarehouseCheckOutCheckOutAllStagedRequest copyWith(
      {String? orderId, String? officeLocationId, String? warehouseId}) {
    return WebApiModulesWarehouseCheckOutCheckOutAllStagedRequest(
        orderId: orderId ?? this.orderId,
        officeLocationId: officeLocationId ?? this.officeLocationId,
        warehouseId: warehouseId ?? this.warehouseId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutCheckOutAllStagedResponse {
  WebApiModulesWarehouseCheckOutCheckOutAllStagedResponse({
    this.status,
    this.success,
    this.msg,
    this.contractId,
  });

  factory WebApiModulesWarehouseCheckOutCheckOutAllStagedResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutCheckOutAllStagedResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'ContractId')
  final String? contractId;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutCheckOutAllStagedResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutCheckOutAllStagedResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutCheckOutAllStagedResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutCheckOutAllStagedResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)));
  }
}

extension $WebApiModulesWarehouseCheckOutCheckOutAllStagedResponseExtension
    on WebApiModulesWarehouseCheckOutCheckOutAllStagedResponse {
  WebApiModulesWarehouseCheckOutCheckOutAllStagedResponse copyWith(
      {int? status, bool? success, String? msg, String? contractId}) {
    return WebApiModulesWarehouseCheckOutCheckOutAllStagedResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        contractId: contractId ?? this.contractId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutCreateOutContractRequest {
  WebApiModulesWarehouseCheckOutCreateOutContractRequest({
    this.orderId,
    this.officeLocationId,
    this.warehouseId,
  });

  factory WebApiModulesWarehouseCheckOutCreateOutContractRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutCreateOutContractRequestFromJson(json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OfficeLocationId')
  final String? officeLocationId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutCreateOutContractRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutCreateOutContractRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutCreateOutContractRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutCreateOutContractRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.officeLocationId, officeLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocationId, officeLocationId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)));
  }
}

extension $WebApiModulesWarehouseCheckOutCreateOutContractRequestExtension
    on WebApiModulesWarehouseCheckOutCreateOutContractRequest {
  WebApiModulesWarehouseCheckOutCreateOutContractRequest copyWith(
      {String? orderId, String? officeLocationId, String? warehouseId}) {
    return WebApiModulesWarehouseCheckOutCreateOutContractRequest(
        orderId: orderId ?? this.orderId,
        officeLocationId: officeLocationId ?? this.officeLocationId,
        warehouseId: warehouseId ?? this.warehouseId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutCreateOutContractResponse {
  WebApiModulesWarehouseCheckOutCreateOutContractResponse({
    this.status,
    this.success,
    this.msg,
    this.contractId,
  });

  factory WebApiModulesWarehouseCheckOutCreateOutContractResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutCreateOutContractResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'ContractId')
  final String? contractId;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutCreateOutContractResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutCreateOutContractResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutCreateOutContractResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutCreateOutContractResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)));
  }
}

extension $WebApiModulesWarehouseCheckOutCreateOutContractResponseExtension
    on WebApiModulesWarehouseCheckOutCreateOutContractResponse {
  WebApiModulesWarehouseCheckOutCreateOutContractResponse copyWith(
      {int? status, bool? success, String? msg, String? contractId}) {
    return WebApiModulesWarehouseCheckOutCreateOutContractResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        contractId: contractId ?? this.contractId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutDecreaseOrderQuantityRequest {
  WebApiModulesWarehouseCheckOutDecreaseOrderQuantityRequest({
    this.orderId,
    this.orderItemId,
    this.inventoryId,
    this.warehouseId,
    this.quantity,
  });

  factory WebApiModulesWarehouseCheckOutDecreaseOrderQuantityRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutDecreaseOrderQuantityRequestFromJson(
          json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderItemId')
  final String? orderItemId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'Quantity')
  final int? quantity;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutDecreaseOrderQuantityRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutDecreaseOrderQuantityRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutDecreaseOrderQuantityRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutDecreaseOrderQuantityRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderItemId, orderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.orderItemId, orderItemId)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)));
  }
}

extension $WebApiModulesWarehouseCheckOutDecreaseOrderQuantityRequestExtension
    on WebApiModulesWarehouseCheckOutDecreaseOrderQuantityRequest {
  WebApiModulesWarehouseCheckOutDecreaseOrderQuantityRequest copyWith(
      {String? orderId,
      String? orderItemId,
      String? inventoryId,
      String? warehouseId,
      int? quantity}) {
    return WebApiModulesWarehouseCheckOutDecreaseOrderQuantityRequest(
        orderId: orderId ?? this.orderId,
        orderItemId: orderItemId ?? this.orderItemId,
        inventoryId: inventoryId ?? this.inventoryId,
        warehouseId: warehouseId ?? this.warehouseId,
        quantity: quantity ?? this.quantity);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutDecreaseOrderQuantityResponse {
  WebApiModulesWarehouseCheckOutDecreaseOrderQuantityResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesWarehouseCheckOutDecreaseOrderQuantityResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutDecreaseOrderQuantityResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutDecreaseOrderQuantityResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutDecreaseOrderQuantityResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutDecreaseOrderQuantityResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutDecreaseOrderQuantityResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesWarehouseCheckOutDecreaseOrderQuantityResponseExtension
    on WebApiModulesWarehouseCheckOutDecreaseOrderQuantityResponse {
  WebApiModulesWarehouseCheckOutDecreaseOrderQuantityResponse copyWith(
      {int? status, bool? success, String? msg}) {
    return WebApiModulesWarehouseCheckOutDecreaseOrderQuantityResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutGetPickupLocationsRequest {
  WebApiModulesWarehouseCheckOutGetPickupLocationsRequest({
    this.warehouseId,
  });

  factory WebApiModulesWarehouseCheckOutGetPickupLocationsRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutGetPickupLocationsRequestFromJson(json);

  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutGetPickupLocationsRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutGetPickupLocationsRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutGetPickupLocationsRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutGetPickupLocationsRequest &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)));
  }
}

extension $WebApiModulesWarehouseCheckOutGetPickupLocationsRequestExtension
    on WebApiModulesWarehouseCheckOutGetPickupLocationsRequest {
  WebApiModulesWarehouseCheckOutGetPickupLocationsRequest copyWith(
      {String? warehouseId}) {
    return WebApiModulesWarehouseCheckOutGetPickupLocationsRequest(
        warehouseId: warehouseId ?? this.warehouseId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutGetPickupLocationsResponse {
  WebApiModulesWarehouseCheckOutGetPickupLocationsResponse({
    this.pickupLocations,
  });

  factory WebApiModulesWarehouseCheckOutGetPickupLocationsResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutGetPickupLocationsResponseFromJson(json);

  @JsonKey(
      name: 'PickupLocations',
      defaultValue: <WebApiModulesWarehouseCheckOutPickupLocation>[])
  final List<WebApiModulesWarehouseCheckOutPickupLocation>? pickupLocations;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutGetPickupLocationsResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutGetPickupLocationsResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutGetPickupLocationsResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutGetPickupLocationsResponse &&
            (identical(other.pickupLocations, pickupLocations) ||
                const DeepCollectionEquality()
                    .equals(other.pickupLocations, pickupLocations)));
  }
}

extension $WebApiModulesWarehouseCheckOutGetPickupLocationsResponseExtension
    on WebApiModulesWarehouseCheckOutGetPickupLocationsResponse {
  WebApiModulesWarehouseCheckOutGetPickupLocationsResponse copyWith(
      {List<WebApiModulesWarehouseCheckOutPickupLocation>? pickupLocations}) {
    return WebApiModulesWarehouseCheckOutGetPickupLocationsResponse(
        pickupLocations: pickupLocations ?? this.pickupLocations);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutIsValidStorageContainerRequest {
  WebApiModulesWarehouseCheckOutIsValidStorageContainerRequest({
    this.barcode,
    this.warehouseId,
    this.orderId,
  });

  factory WebApiModulesWarehouseCheckOutIsValidStorageContainerRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutIsValidStorageContainerRequestFromJson(
          json);

  @JsonKey(name: 'Barcode')
  final String? barcode;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutIsValidStorageContainerRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutIsValidStorageContainerRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutIsValidStorageContainerRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutIsValidStorageContainerRequest &&
            (identical(other.barcode, barcode) ||
                const DeepCollectionEquality()
                    .equals(other.barcode, barcode)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality().equals(other.orderId, orderId)));
  }
}

extension $WebApiModulesWarehouseCheckOutIsValidStorageContainerRequestExtension
    on WebApiModulesWarehouseCheckOutIsValidStorageContainerRequest {
  WebApiModulesWarehouseCheckOutIsValidStorageContainerRequest copyWith(
      {String? barcode, String? warehouseId, String? orderId}) {
    return WebApiModulesWarehouseCheckOutIsValidStorageContainerRequest(
        barcode: barcode ?? this.barcode,
        warehouseId: warehouseId ?? this.warehouseId,
        orderId: orderId ?? this.orderId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutIsValidStorageContainerResponse {
  WebApiModulesWarehouseCheckOutIsValidStorageContainerResponse({
    this.barcode,
    this.warehouseId,
    this.storageContainerItemId,
    this.status,
    this.message,
    this.description,
    this.pickupLocationDescription,
    this.pickupLocationId,
  });

  factory WebApiModulesWarehouseCheckOutIsValidStorageContainerResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutIsValidStorageContainerResponseFromJson(
          json);

  @JsonKey(name: 'Barcode')
  final String? barcode;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'StorageContainerItemId')
  final int? storageContainerItemId;
  @JsonKey(name: 'Status')
  final int? status;
  @JsonKey(name: 'Message')
  final String? message;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'PickupLocationDescription')
  final String? pickupLocationDescription;
  @JsonKey(name: 'PickupLocationId')
  final String? pickupLocationId;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutIsValidStorageContainerResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutIsValidStorageContainerResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutIsValidStorageContainerResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutIsValidStorageContainerResponse &&
            (identical(other.barcode, barcode) ||
                const DeepCollectionEquality()
                    .equals(other.barcode, barcode)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.storageContainerItemId, storageContainerItemId) ||
                const DeepCollectionEquality().equals(
                    other.storageContainerItemId, storageContainerItemId)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality()
                    .equals(other.message, message)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.pickupLocationDescription,
                    pickupLocationDescription) ||
                const DeepCollectionEquality().equals(
                    other.pickupLocationDescription,
                    pickupLocationDescription)) &&
            (identical(other.pickupLocationId, pickupLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.pickupLocationId, pickupLocationId)));
  }
}

extension $WebApiModulesWarehouseCheckOutIsValidStorageContainerResponseExtension
    on WebApiModulesWarehouseCheckOutIsValidStorageContainerResponse {
  WebApiModulesWarehouseCheckOutIsValidStorageContainerResponse copyWith(
      {String? barcode,
      String? warehouseId,
      int? storageContainerItemId,
      int? status,
      String? message,
      String? description,
      String? pickupLocationDescription,
      String? pickupLocationId}) {
    return WebApiModulesWarehouseCheckOutIsValidStorageContainerResponse(
        barcode: barcode ?? this.barcode,
        warehouseId: warehouseId ?? this.warehouseId,
        storageContainerItemId:
            storageContainerItemId ?? this.storageContainerItemId,
        status: status ?? this.status,
        message: message ?? this.message,
        description: description ?? this.description,
        pickupLocationDescription:
            pickupLocationDescription ?? this.pickupLocationDescription,
        pickupLocationId: pickupLocationId ?? this.pickupLocationId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutMoveStagedItemRequest {
  WebApiModulesWarehouseCheckOutMoveStagedItemRequest({
    this.orderId,
    this.orderItemId,
    this.vendorId,
    this.contractId,
    this.code,
    this.quantity,
  });

  factory WebApiModulesWarehouseCheckOutMoveStagedItemRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutMoveStagedItemRequestFromJson(json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderItemId')
  final String? orderItemId;
  @JsonKey(name: 'VendorId')
  final String? vendorId;
  @JsonKey(name: 'ContractId')
  final String? contractId;
  @JsonKey(name: 'Code')
  final String? code;
  @JsonKey(name: 'Quantity')
  final double? quantity;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutMoveStagedItemRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutMoveStagedItemRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutMoveStagedItemRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutMoveStagedItemRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderItemId, orderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.orderItemId, orderItemId)) &&
            (identical(other.vendorId, vendorId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorId, vendorId)) &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)) &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)));
  }
}

extension $WebApiModulesWarehouseCheckOutMoveStagedItemRequestExtension
    on WebApiModulesWarehouseCheckOutMoveStagedItemRequest {
  WebApiModulesWarehouseCheckOutMoveStagedItemRequest copyWith(
      {String? orderId,
      String? orderItemId,
      String? vendorId,
      String? contractId,
      String? code,
      double? quantity}) {
    return WebApiModulesWarehouseCheckOutMoveStagedItemRequest(
        orderId: orderId ?? this.orderId,
        orderItemId: orderItemId ?? this.orderItemId,
        vendorId: vendorId ?? this.vendorId,
        contractId: contractId ?? this.contractId,
        code: code ?? this.code,
        quantity: quantity ?? this.quantity);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutMoveStagedItemResponse {
  WebApiModulesWarehouseCheckOutMoveStagedItemResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesWarehouseCheckOutMoveStagedItemResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutMoveStagedItemResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutMoveStagedItemResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutMoveStagedItemResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutMoveStagedItemResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutMoveStagedItemResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesWarehouseCheckOutMoveStagedItemResponseExtension
    on WebApiModulesWarehouseCheckOutMoveStagedItemResponse {
  WebApiModulesWarehouseCheckOutMoveStagedItemResponse copyWith(
      {int? status, bool? success, String? msg}) {
    return WebApiModulesWarehouseCheckOutMoveStagedItemResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutOrderHasStorageContainerRequest {
  WebApiModulesWarehouseCheckOutOrderHasStorageContainerRequest({
    this.orderId,
  });

  factory WebApiModulesWarehouseCheckOutOrderHasStorageContainerRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutOrderHasStorageContainerRequestFromJson(
          json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutOrderHasStorageContainerRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutOrderHasStorageContainerRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutOrderHasStorageContainerRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutOrderHasStorageContainerRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality().equals(other.orderId, orderId)));
  }
}

extension $WebApiModulesWarehouseCheckOutOrderHasStorageContainerRequestExtension
    on WebApiModulesWarehouseCheckOutOrderHasStorageContainerRequest {
  WebApiModulesWarehouseCheckOutOrderHasStorageContainerRequest copyWith(
      {String? orderId}) {
    return WebApiModulesWarehouseCheckOutOrderHasStorageContainerRequest(
        orderId: orderId ?? this.orderId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutOrderHasStorageContainerResponse {
  WebApiModulesWarehouseCheckOutOrderHasStorageContainerResponse({
    this.orderHasStorageContainer,
  });

  factory WebApiModulesWarehouseCheckOutOrderHasStorageContainerResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutOrderHasStorageContainerResponseFromJson(
          json);

  @JsonKey(name: 'OrderHasStorageContainer')
  final bool? orderHasStorageContainer;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutOrderHasStorageContainerResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutOrderHasStorageContainerResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutOrderHasStorageContainerResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutOrderHasStorageContainerResponse &&
            (identical(
                    other.orderHasStorageContainer, orderHasStorageContainer) ||
                const DeepCollectionEquality().equals(
                    other.orderHasStorageContainer, orderHasStorageContainer)));
  }
}

extension $WebApiModulesWarehouseCheckOutOrderHasStorageContainerResponseExtension
    on WebApiModulesWarehouseCheckOutOrderHasStorageContainerResponse {
  WebApiModulesWarehouseCheckOutOrderHasStorageContainerResponse copyWith(
      {bool? orderHasStorageContainer}) {
    return WebApiModulesWarehouseCheckOutOrderHasStorageContainerResponse(
        orderHasStorageContainer:
            orderHasStorageContainer ?? this.orderHasStorageContainer);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutOrderInventoryStatusCheckOut {
  WebApiModulesWarehouseCheckOutOrderInventoryStatusCheckOut({
    this.iCode,
    this.description,
    this.classification,
    this.quantityOrdered,
    this.quantitySub,
    this.quantityStaged,
    this.quantityOut,
    this.quantityIn,
    this.quantityRemaining,
  });

  factory WebApiModulesWarehouseCheckOutOrderInventoryStatusCheckOut.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutOrderInventoryStatusCheckOutFromJson(
          json);

  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'Classification')
  final String? classification;
  @JsonKey(name: 'QuantityOrdered')
  final int? quantityOrdered;
  @JsonKey(name: 'QuantitySub')
  final int? quantitySub;
  @JsonKey(name: 'QuantityStaged')
  final int? quantityStaged;
  @JsonKey(name: 'QuantityOut')
  final int? quantityOut;
  @JsonKey(name: 'QuantityIn')
  final int? quantityIn;
  @JsonKey(name: 'QuantityRemaining')
  final int? quantityRemaining;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutOrderInventoryStatusCheckOutFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutOrderInventoryStatusCheckOutToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutOrderInventoryStatusCheckOutToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutOrderInventoryStatusCheckOut &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.classification, classification) ||
                const DeepCollectionEquality()
                    .equals(other.classification, classification)) &&
            (identical(other.quantityOrdered, quantityOrdered) ||
                const DeepCollectionEquality()
                    .equals(other.quantityOrdered, quantityOrdered)) &&
            (identical(other.quantitySub, quantitySub) ||
                const DeepCollectionEquality()
                    .equals(other.quantitySub, quantitySub)) &&
            (identical(other.quantityStaged, quantityStaged) ||
                const DeepCollectionEquality()
                    .equals(other.quantityStaged, quantityStaged)) &&
            (identical(other.quantityOut, quantityOut) ||
                const DeepCollectionEquality()
                    .equals(other.quantityOut, quantityOut)) &&
            (identical(other.quantityIn, quantityIn) ||
                const DeepCollectionEquality()
                    .equals(other.quantityIn, quantityIn)) &&
            (identical(other.quantityRemaining, quantityRemaining) ||
                const DeepCollectionEquality()
                    .equals(other.quantityRemaining, quantityRemaining)));
  }
}

extension $WebApiModulesWarehouseCheckOutOrderInventoryStatusCheckOutExtension
    on WebApiModulesWarehouseCheckOutOrderInventoryStatusCheckOut {
  WebApiModulesWarehouseCheckOutOrderInventoryStatusCheckOut copyWith(
      {String? iCode,
      String? description,
      String? classification,
      int? quantityOrdered,
      int? quantitySub,
      int? quantityStaged,
      int? quantityOut,
      int? quantityIn,
      int? quantityRemaining}) {
    return WebApiModulesWarehouseCheckOutOrderInventoryStatusCheckOut(
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        classification: classification ?? this.classification,
        quantityOrdered: quantityOrdered ?? this.quantityOrdered,
        quantitySub: quantitySub ?? this.quantitySub,
        quantityStaged: quantityStaged ?? this.quantityStaged,
        quantityOut: quantityOut ?? this.quantityOut,
        quantityIn: quantityIn ?? this.quantityIn,
        quantityRemaining: quantityRemaining ?? this.quantityRemaining);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutPickupLocation {
  WebApiModulesWarehouseCheckOutPickupLocation({
    this.pickupLocationId,
    this.description,
  });

  factory WebApiModulesWarehouseCheckOutPickupLocation.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutPickupLocationFromJson(json);

  @JsonKey(name: 'PickupLocationId')
  final int? pickupLocationId;
  @JsonKey(name: 'Description')
  final String? description;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutPickupLocationFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutPickupLocationToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutPickupLocationToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutPickupLocation &&
            (identical(other.pickupLocationId, pickupLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.pickupLocationId, pickupLocationId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)));
  }
}

extension $WebApiModulesWarehouseCheckOutPickupLocationExtension
    on WebApiModulesWarehouseCheckOutPickupLocation {
  WebApiModulesWarehouseCheckOutPickupLocation copyWith(
      {int? pickupLocationId, String? description}) {
    return WebApiModulesWarehouseCheckOutPickupLocation(
        pickupLocationId: pickupLocationId ?? this.pickupLocationId,
        description: description ?? this.description);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemRequest {
  WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemRequest({
    this.orderId,
    this.warehouseId,
  });

  factory WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemRequestFromJson(
          json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)));
  }
}

extension $WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemRequestExtension
    on WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemRequest {
  WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemRequest copyWith(
      {String? orderId, String? warehouseId}) {
    return WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemRequest(
        orderId: orderId ?? this.orderId,
        warehouseId: warehouseId ?? this.warehouseId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemResponse {
  WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemResponseExtension
    on WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemResponse {
  WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemResponse copyWith(
      {int? status, bool? success, String? msg}) {
    return WebApiModulesWarehouseCheckOutSelectAllNoneStageHoldingItemResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemRequest {
  WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemRequest({
    this.orderId,
    this.warehouseId,
  });

  factory WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemRequestFromJson(
          json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)));
  }
}

extension $WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemRequestExtension
    on WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemRequest {
  WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemRequest copyWith(
      {String? orderId, String? warehouseId}) {
    return WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemRequest(
        orderId: orderId ?? this.orderId,
        warehouseId: warehouseId ?? this.warehouseId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemResponse {
  WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemResponseExtension
    on WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemResponse {
  WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemResponse copyWith(
      {int? status, bool? success, String? msg}) {
    return WebApiModulesWarehouseCheckOutSelectAllNoneStageQuantityItemResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutStageItemRequest {
  WebApiModulesWarehouseCheckOutStageItemRequest({
    this.orderId,
    this.orderItemId,
    this.vendorId,
    this.code,
    this.warehouseId,
    this.quantity,
    this.unstageItem,
    this.addItemToOrder,
    this.addCompleteToOrder,
    this.stageIncompleteContainer,
    this.transferRepair,
    this.releaseFromRepair,
  });

  factory WebApiModulesWarehouseCheckOutStageItemRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutStageItemRequestFromJson(json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderItemId')
  final String? orderItemId;
  @JsonKey(name: 'VendorId')
  final String? vendorId;
  @JsonKey(name: 'Code')
  final String? code;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'Quantity')
  final int? quantity;
  @JsonKey(name: 'UnstageItem')
  final bool? unstageItem;
  @JsonKey(name: 'AddItemToOrder')
  final bool? addItemToOrder;
  @JsonKey(name: 'AddCompleteToOrder')
  final bool? addCompleteToOrder;
  @JsonKey(name: 'StageIncompleteContainer')
  final bool? stageIncompleteContainer;
  @JsonKey(name: 'TransferRepair')
  final bool? transferRepair;
  @JsonKey(name: 'ReleaseFromRepair')
  final bool? releaseFromRepair;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutStageItemRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutStageItemRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutStageItemRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutStageItemRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderItemId, orderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.orderItemId, orderItemId)) &&
            (identical(other.vendorId, vendorId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorId, vendorId)) &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)) &&
            (identical(other.unstageItem, unstageItem) ||
                const DeepCollectionEquality()
                    .equals(other.unstageItem, unstageItem)) &&
            (identical(other.addItemToOrder, addItemToOrder) ||
                const DeepCollectionEquality()
                    .equals(other.addItemToOrder, addItemToOrder)) &&
            (identical(other.addCompleteToOrder, addCompleteToOrder) ||
                const DeepCollectionEquality()
                    .equals(other.addCompleteToOrder, addCompleteToOrder)) &&
            (identical(
                    other.stageIncompleteContainer, stageIncompleteContainer) ||
                const DeepCollectionEquality().equals(
                    other.stageIncompleteContainer,
                    stageIncompleteContainer)) &&
            (identical(other.transferRepair, transferRepair) ||
                const DeepCollectionEquality()
                    .equals(other.transferRepair, transferRepair)) &&
            (identical(other.releaseFromRepair, releaseFromRepair) ||
                const DeepCollectionEquality()
                    .equals(other.releaseFromRepair, releaseFromRepair)));
  }
}

extension $WebApiModulesWarehouseCheckOutStageItemRequestExtension
    on WebApiModulesWarehouseCheckOutStageItemRequest {
  WebApiModulesWarehouseCheckOutStageItemRequest copyWith(
      {String? orderId,
      String? orderItemId,
      String? vendorId,
      String? code,
      String? warehouseId,
      int? quantity,
      bool? unstageItem,
      bool? addItemToOrder,
      bool? addCompleteToOrder,
      bool? stageIncompleteContainer,
      bool? transferRepair,
      bool? releaseFromRepair}) {
    return WebApiModulesWarehouseCheckOutStageItemRequest(
        orderId: orderId ?? this.orderId,
        orderItemId: orderItemId ?? this.orderItemId,
        vendorId: vendorId ?? this.vendorId,
        code: code ?? this.code,
        warehouseId: warehouseId ?? this.warehouseId,
        quantity: quantity ?? this.quantity,
        unstageItem: unstageItem ?? this.unstageItem,
        addItemToOrder: addItemToOrder ?? this.addItemToOrder,
        addCompleteToOrder: addCompleteToOrder ?? this.addCompleteToOrder,
        stageIncompleteContainer:
            stageIncompleteContainer ?? this.stageIncompleteContainer,
        transferRepair: transferRepair ?? this.transferRepair,
        releaseFromRepair: releaseFromRepair ?? this.releaseFromRepair);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutStageItemResponse {
  WebApiModulesWarehouseCheckOutStageItemResponse({
    this.inventoryStatus,
    this.status,
    this.success,
    this.msg,
    this.inventoryId,
    this.orderItemId,
    this.quantityStaged,
    this.showAddItemToOrder,
    this.showTransferRepair,
    this.showAddCompleteToOrder,
    this.showUnstage,
    this.showStageIncompleteContainer,
    this.showReleaseFromRepair,
  });

  factory WebApiModulesWarehouseCheckOutStageItemResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutStageItemResponseFromJson(json);

  @JsonKey(name: 'InventoryStatus')
  final WebApiModulesWarehouseCheckOutOrderInventoryStatusCheckOut?
      inventoryStatus;
  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'OrderItemId')
  final String? orderItemId;
  @JsonKey(name: 'QuantityStaged')
  final int? quantityStaged;
  @JsonKey(name: 'ShowAddItemToOrder')
  final bool? showAddItemToOrder;
  @JsonKey(name: 'ShowTransferRepair')
  final bool? showTransferRepair;
  @JsonKey(name: 'ShowAddCompleteToOrder')
  final bool? showAddCompleteToOrder;
  @JsonKey(name: 'ShowUnstage')
  final bool? showUnstage;
  @JsonKey(name: 'ShowStageIncompleteContainer')
  final bool? showStageIncompleteContainer;
  @JsonKey(name: 'ShowReleaseFromRepair')
  final bool? showReleaseFromRepair;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutStageItemResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutStageItemResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutStageItemResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutStageItemResponse &&
            (identical(other.inventoryStatus, inventoryStatus) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryStatus, inventoryStatus)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.orderItemId, orderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.orderItemId, orderItemId)) &&
            (identical(other.quantityStaged, quantityStaged) ||
                const DeepCollectionEquality()
                    .equals(other.quantityStaged, quantityStaged)) &&
            (identical(other.showAddItemToOrder, showAddItemToOrder) ||
                const DeepCollectionEquality()
                    .equals(other.showAddItemToOrder, showAddItemToOrder)) &&
            (identical(other.showTransferRepair, showTransferRepair) ||
                const DeepCollectionEquality()
                    .equals(other.showTransferRepair, showTransferRepair)) &&
            (identical(other.showAddCompleteToOrder, showAddCompleteToOrder) ||
                const DeepCollectionEquality().equals(
                    other.showAddCompleteToOrder, showAddCompleteToOrder)) &&
            (identical(other.showUnstage, showUnstage) ||
                const DeepCollectionEquality()
                    .equals(other.showUnstage, showUnstage)) &&
            (identical(other.showStageIncompleteContainer,
                    showStageIncompleteContainer) ||
                const DeepCollectionEquality().equals(
                    other.showStageIncompleteContainer,
                    showStageIncompleteContainer)) &&
            (identical(other.showReleaseFromRepair, showReleaseFromRepair) ||
                const DeepCollectionEquality().equals(
                    other.showReleaseFromRepair, showReleaseFromRepair)));
  }
}

extension $WebApiModulesWarehouseCheckOutStageItemResponseExtension
    on WebApiModulesWarehouseCheckOutStageItemResponse {
  WebApiModulesWarehouseCheckOutStageItemResponse copyWith(
      {WebApiModulesWarehouseCheckOutOrderInventoryStatusCheckOut?
          inventoryStatus,
      int? status,
      bool? success,
      String? msg,
      String? inventoryId,
      String? orderItemId,
      int? quantityStaged,
      bool? showAddItemToOrder,
      bool? showTransferRepair,
      bool? showAddCompleteToOrder,
      bool? showUnstage,
      bool? showStageIncompleteContainer,
      bool? showReleaseFromRepair}) {
    return WebApiModulesWarehouseCheckOutStageItemResponse(
        inventoryStatus: inventoryStatus ?? this.inventoryStatus,
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        inventoryId: inventoryId ?? this.inventoryId,
        orderItemId: orderItemId ?? this.orderItemId,
        quantityStaged: quantityStaged ?? this.quantityStaged,
        showAddItemToOrder: showAddItemToOrder ?? this.showAddItemToOrder,
        showTransferRepair: showTransferRepair ?? this.showTransferRepair,
        showAddCompleteToOrder:
            showAddCompleteToOrder ?? this.showAddCompleteToOrder,
        showUnstage: showUnstage ?? this.showUnstage,
        showStageIncompleteContainer:
            showStageIncompleteContainer ?? this.showStageIncompleteContainer,
        showReleaseFromRepair:
            showReleaseFromRepair ?? this.showReleaseFromRepair);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutStageSerialNumber {
  WebApiModulesWarehouseCheckOutStageSerialNumber({
    this.orderId,
    this.orderItemId,
    this.inventoryId,
    this.rentalItemId,
    this.warehouseId,
    this.serialNumber,
    this.currentMeter,
    this.inventoryStatus,
    this.statusType,
    this.isStaged,
    this.color,
    this.textColor,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesWarehouseCheckOutStageSerialNumber.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutStageSerialNumberFromJson(json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderItemId')
  final String? orderItemId;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'RentalItemId')
  final String? rentalItemId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'SerialNumber')
  final String? serialNumber;
  @JsonKey(name: 'CurrentMeter')
  final double? currentMeter;
  @JsonKey(name: 'InventoryStatus')
  final String? inventoryStatus;
  @JsonKey(name: 'StatusType')
  final String? statusType;
  @JsonKey(name: 'IsStaged')
  final bool? isStaged;
  @JsonKey(name: 'Color')
  final String? color;
  @JsonKey(name: 'TextColor')
  final String? textColor;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutStageSerialNumberFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutStageSerialNumberToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutStageSerialNumberToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutStageSerialNumber &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderItemId, orderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.orderItemId, orderItemId)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.rentalItemId, rentalItemId) ||
                const DeepCollectionEquality()
                    .equals(other.rentalItemId, rentalItemId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.serialNumber, serialNumber) ||
                const DeepCollectionEquality()
                    .equals(other.serialNumber, serialNumber)) &&
            (identical(other.currentMeter, currentMeter) ||
                const DeepCollectionEquality()
                    .equals(other.currentMeter, currentMeter)) &&
            (identical(other.inventoryStatus, inventoryStatus) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryStatus, inventoryStatus)) &&
            (identical(other.statusType, statusType) ||
                const DeepCollectionEquality()
                    .equals(other.statusType, statusType)) &&
            (identical(other.isStaged, isStaged) ||
                const DeepCollectionEquality()
                    .equals(other.isStaged, isStaged)) &&
            (identical(other.color, color) ||
                const DeepCollectionEquality().equals(other.color, color)) &&
            (identical(other.textColor, textColor) ||
                const DeepCollectionEquality()
                    .equals(other.textColor, textColor)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesWarehouseCheckOutStageSerialNumberExtension
    on WebApiModulesWarehouseCheckOutStageSerialNumber {
  WebApiModulesWarehouseCheckOutStageSerialNumber copyWith(
      {String? orderId,
      String? orderItemId,
      String? inventoryId,
      String? rentalItemId,
      String? warehouseId,
      String? serialNumber,
      double? currentMeter,
      String? inventoryStatus,
      String? statusType,
      bool? isStaged,
      String? color,
      String? textColor,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesWarehouseCheckOutStageSerialNumber(
        orderId: orderId ?? this.orderId,
        orderItemId: orderItemId ?? this.orderItemId,
        inventoryId: inventoryId ?? this.inventoryId,
        rentalItemId: rentalItemId ?? this.rentalItemId,
        warehouseId: warehouseId ?? this.warehouseId,
        serialNumber: serialNumber ?? this.serialNumber,
        currentMeter: currentMeter ?? this.currentMeter,
        inventoryStatus: inventoryStatus ?? this.inventoryStatus,
        statusType: statusType ?? this.statusType,
        isStaged: isStaged ?? this.isStaged,
        color: color ?? this.color,
        textColor: textColor ?? this.textColor,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionRequest {
  WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionRequest({
    this.sessionId,
    this.code,
    this.warehouseId,
    this.quantity,
  });

  factory WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionRequestFromJson(
          json);

  @JsonKey(name: 'SessionId')
  final String? sessionId;
  @JsonKey(name: 'Code')
  final String? code;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'Quantity')
  final int? quantity;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionRequest &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)) &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)));
  }
}

extension $WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionRequestExtension
    on WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionRequest {
  WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionRequest
      copyWith(
          {String? sessionId,
          String? code,
          String? warehouseId,
          int? quantity}) {
    return WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionRequest(
        sessionId: sessionId ?? this.sessionId,
        code: code ?? this.code,
        warehouseId: warehouseId ?? this.warehouseId,
        quantity: quantity ?? this.quantity);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionResponse {
  WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionResponse({
    this.status,
    this.success,
    this.msg,
    this.iCode,
    this.description,
  });

  factory WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)));
  }
}

extension $WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionResponseExtension
    on WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionResponse {
  WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionResponse
      copyWith(
          {int? status,
          bool? success,
          String? msg,
          String? iCode,
          String? description}) {
    return WebApiModulesWarehouseCheckOutStagingAddSubstituteItemToSessionResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionRequest {
  WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionRequest({
    this.sessionId,
    this.quantity,
  });

  factory WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionRequestFromJson(
          json);

  @JsonKey(name: 'SessionId')
  final String? sessionId;
  @JsonKey(name: 'Quantity')
  final int? quantity;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionRequest &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)));
  }
}

extension $WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionRequestExtension
    on WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionRequest {
  WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionRequest copyWith(
      {String? sessionId, int? quantity}) {
    return WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionRequest(
        sessionId: sessionId ?? this.sessionId,
        quantity: quantity ?? this.quantity);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionResponse {
  WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionResponse({
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionResponseExtension
    on WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionResponse {
  WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionResponse copyWith(
      {int? status, bool? success, String? msg}) {
    return WebApiModulesWarehouseCheckOutStagingApplySubstituteSessionResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionRequest {
  WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionRequest({
    this.orderId,
    this.orderItemId,
  });

  factory WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionRequestFromJson(
          json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderItemId')
  final String? orderItemId;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderItemId, orderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.orderItemId, orderItemId)));
  }
}

extension $WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionRequestExtension
    on WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionRequest {
  WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionRequest copyWith(
      {String? orderId, String? orderItemId}) {
    return WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionRequest(
        orderId: orderId ?? this.orderId,
        orderItemId: orderItemId ?? this.orderItemId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionResponse {
  WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionResponse({
    this.status,
    this.success,
    this.msg,
    this.sessionId,
    this.orderId,
    this.orderItemId,
    this.iCode,
    this.description,
    this.quantityOrdered,
    this.quantityRemaining,
  });

  factory WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionResponseFromJson(
          json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'SessionId')
  final String? sessionId;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderItemId')
  final String? orderItemId;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'QuantityOrdered')
  final double? quantityOrdered;
  @JsonKey(name: 'QuantityRemaining')
  final double? quantityRemaining;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.sessionId, sessionId) ||
                const DeepCollectionEquality()
                    .equals(other.sessionId, sessionId)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderItemId, orderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.orderItemId, orderItemId)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.quantityOrdered, quantityOrdered) ||
                const DeepCollectionEquality()
                    .equals(other.quantityOrdered, quantityOrdered)) &&
            (identical(other.quantityRemaining, quantityRemaining) ||
                const DeepCollectionEquality()
                    .equals(other.quantityRemaining, quantityRemaining)));
  }
}

extension $WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionResponseExtension
    on WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionResponse {
  WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionResponse copyWith(
      {int? status,
      bool? success,
      String? msg,
      String? sessionId,
      String? orderId,
      String? orderItemId,
      String? iCode,
      String? description,
      double? quantityOrdered,
      double? quantityRemaining}) {
    return WebApiModulesWarehouseCheckOutStagingStartSubstituteSessionResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        sessionId: sessionId ?? this.sessionId,
        orderId: orderId ?? this.orderId,
        orderItemId: orderItemId ?? this.orderItemId,
        iCode: iCode ?? this.iCode,
        description: description ?? this.description,
        quantityOrdered: quantityOrdered ?? this.quantityOrdered,
        quantityRemaining: quantityRemaining ?? this.quantityRemaining);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutStagingTabsResponse {
  WebApiModulesWarehouseCheckOutStagingTabsResponse({
    this.status,
    this.success,
    this.msg,
    this.quantityTab,
    this.holdingTab,
    this.serialTab,
    this.usageTab,
    this.consignmentTab,
  });

  factory WebApiModulesWarehouseCheckOutStagingTabsResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutStagingTabsResponseFromJson(json);

  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'QuantityTab')
  final bool? quantityTab;
  @JsonKey(name: 'HoldingTab')
  final bool? holdingTab;
  @JsonKey(name: 'SerialTab')
  final bool? serialTab;
  @JsonKey(name: 'UsageTab')
  final bool? usageTab;
  @JsonKey(name: 'ConsignmentTab')
  final bool? consignmentTab;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutStagingTabsResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutStagingTabsResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutStagingTabsResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutStagingTabsResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.quantityTab, quantityTab) ||
                const DeepCollectionEquality()
                    .equals(other.quantityTab, quantityTab)) &&
            (identical(other.holdingTab, holdingTab) ||
                const DeepCollectionEquality()
                    .equals(other.holdingTab, holdingTab)) &&
            (identical(other.serialTab, serialTab) ||
                const DeepCollectionEquality()
                    .equals(other.serialTab, serialTab)) &&
            (identical(other.usageTab, usageTab) ||
                const DeepCollectionEquality()
                    .equals(other.usageTab, usageTab)) &&
            (identical(other.consignmentTab, consignmentTab) ||
                const DeepCollectionEquality()
                    .equals(other.consignmentTab, consignmentTab)));
  }
}

extension $WebApiModulesWarehouseCheckOutStagingTabsResponseExtension
    on WebApiModulesWarehouseCheckOutStagingTabsResponse {
  WebApiModulesWarehouseCheckOutStagingTabsResponse copyWith(
      {int? status,
      bool? success,
      String? msg,
      bool? quantityTab,
      bool? holdingTab,
      bool? serialTab,
      bool? usageTab,
      bool? consignmentTab}) {
    return WebApiModulesWarehouseCheckOutStagingTabsResponse(
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        quantityTab: quantityTab ?? this.quantityTab,
        holdingTab: holdingTab ?? this.holdingTab,
        serialTab: serialTab ?? this.serialTab,
        usageTab: usageTab ?? this.usageTab,
        consignmentTab: consignmentTab ?? this.consignmentTab);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutStorageContainerGrid {
  WebApiModulesWarehouseCheckOutStorageContainerGrid({
    this.storageContainerId,
    this.storageContainerItemId,
    this.description,
    this.pickUpLocation,
    this.storageContainerBarcode,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesWarehouseCheckOutStorageContainerGrid.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutStorageContainerGridFromJson(json);

  @JsonKey(name: 'StorageContainerId')
  final int? storageContainerId;
  @JsonKey(name: 'StorageContainerItemId')
  final int? storageContainerItemId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'PickUpLocation')
  final String? pickUpLocation;
  @JsonKey(name: 'StorageContainerBarcode')
  final String? storageContainerBarcode;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutStorageContainerGridFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutStorageContainerGridToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutStorageContainerGridToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutStorageContainerGrid &&
            (identical(other.storageContainerId, storageContainerId) ||
                const DeepCollectionEquality()
                    .equals(other.storageContainerId, storageContainerId)) &&
            (identical(other.storageContainerItemId, storageContainerItemId) ||
                const DeepCollectionEquality().equals(
                    other.storageContainerItemId, storageContainerItemId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.pickUpLocation, pickUpLocation) ||
                const DeepCollectionEquality()
                    .equals(other.pickUpLocation, pickUpLocation)) &&
            (identical(
                    other.storageContainerBarcode, storageContainerBarcode) ||
                const DeepCollectionEquality().equals(
                    other.storageContainerBarcode, storageContainerBarcode)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesWarehouseCheckOutStorageContainerGridExtension
    on WebApiModulesWarehouseCheckOutStorageContainerGrid {
  WebApiModulesWarehouseCheckOutStorageContainerGrid copyWith(
      {int? storageContainerId,
      int? storageContainerItemId,
      String? description,
      String? pickUpLocation,
      String? storageContainerBarcode,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesWarehouseCheckOutStorageContainerGrid(
        storageContainerId: storageContainerId ?? this.storageContainerId,
        storageContainerItemId:
            storageContainerItemId ?? this.storageContainerItemId,
        description: description ?? this.description,
        pickUpLocation: pickUpLocation ?? this.pickUpLocation,
        storageContainerBarcode:
            storageContainerBarcode ?? this.storageContainerBarcode,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutStorageContainerItemsGrid {
  WebApiModulesWarehouseCheckOutStorageContainerItemsGrid({
    this.storageContainerItemId,
    this.iCode,
    this.stagedBarcode,
    this.quantityOrdered,
    this.staged,
    this.orderBy,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesWarehouseCheckOutStorageContainerItemsGrid.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutStorageContainerItemsGridFromJson(json);

  @JsonKey(name: 'StorageContainerItemId')
  final int? storageContainerItemId;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'StagedBarcode')
  final String? stagedBarcode;
  @JsonKey(name: 'QuantityOrdered')
  final int? quantityOrdered;
  @JsonKey(name: 'Staged')
  final int? staged;
  @JsonKey(name: 'OrderBy')
  final String? orderBy;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutStorageContainerItemsGridFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutStorageContainerItemsGridToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutStorageContainerItemsGridToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutStorageContainerItemsGrid &&
            (identical(other.storageContainerItemId, storageContainerItemId) ||
                const DeepCollectionEquality().equals(
                    other.storageContainerItemId, storageContainerItemId)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.stagedBarcode, stagedBarcode) ||
                const DeepCollectionEquality()
                    .equals(other.stagedBarcode, stagedBarcode)) &&
            (identical(other.quantityOrdered, quantityOrdered) ||
                const DeepCollectionEquality()
                    .equals(other.quantityOrdered, quantityOrdered)) &&
            (identical(other.staged, staged) ||
                const DeepCollectionEquality().equals(other.staged, staged)) &&
            (identical(other.orderBy, orderBy) ||
                const DeepCollectionEquality()
                    .equals(other.orderBy, orderBy)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesWarehouseCheckOutStorageContainerItemsGridExtension
    on WebApiModulesWarehouseCheckOutStorageContainerItemsGrid {
  WebApiModulesWarehouseCheckOutStorageContainerItemsGrid copyWith(
      {int? storageContainerItemId,
      String? iCode,
      String? stagedBarcode,
      int? quantityOrdered,
      int? staged,
      String? orderBy,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesWarehouseCheckOutStorageContainerItemsGrid(
        storageContainerItemId:
            storageContainerItemId ?? this.storageContainerItemId,
        iCode: iCode ?? this.iCode,
        stagedBarcode: stagedBarcode ?? this.stagedBarcode,
        quantityOrdered: quantityOrdered ?? this.quantityOrdered,
        staged: staged ?? this.staged,
        orderBy: orderBy ?? this.orderBy,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutStorageContainerStagedItemModel {
  WebApiModulesWarehouseCheckOutStorageContainerStagedItemModel({
    this.storageContainerBarcode,
    this.storageContainerDescription,
    this.pickupLocation,
    this.iCode,
    this.iCodeDescription,
    this.stagedBarcode,
    this.ordered,
    this.staged,
  });

  factory WebApiModulesWarehouseCheckOutStorageContainerStagedItemModel.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutStorageContainerStagedItemModelFromJson(
          json);

  @JsonKey(name: 'StorageContainerBarcode')
  final String? storageContainerBarcode;
  @JsonKey(name: 'StorageContainerDescription')
  final String? storageContainerDescription;
  @JsonKey(name: 'PickupLocation')
  final String? pickupLocation;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'ICodeDescription')
  final String? iCodeDescription;
  @JsonKey(name: 'StagedBarcode')
  final String? stagedBarcode;
  @JsonKey(name: 'Ordered')
  final double? ordered;
  @JsonKey(name: 'Staged')
  final double? staged;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutStorageContainerStagedItemModelFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutStorageContainerStagedItemModelToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutStorageContainerStagedItemModelToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutStorageContainerStagedItemModel &&
            (identical(
                    other.storageContainerBarcode, storageContainerBarcode) ||
                const DeepCollectionEquality().equals(
                    other.storageContainerBarcode, storageContainerBarcode)) &&
            (identical(other.storageContainerDescription,
                    storageContainerDescription) ||
                const DeepCollectionEquality().equals(
                    other.storageContainerDescription,
                    storageContainerDescription)) &&
            (identical(other.pickupLocation, pickupLocation) ||
                const DeepCollectionEquality()
                    .equals(other.pickupLocation, pickupLocation)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.iCodeDescription, iCodeDescription) ||
                const DeepCollectionEquality()
                    .equals(other.iCodeDescription, iCodeDescription)) &&
            (identical(other.stagedBarcode, stagedBarcode) ||
                const DeepCollectionEquality()
                    .equals(other.stagedBarcode, stagedBarcode)) &&
            (identical(other.ordered, ordered) ||
                const DeepCollectionEquality()
                    .equals(other.ordered, ordered)) &&
            (identical(other.staged, staged) ||
                const DeepCollectionEquality().equals(other.staged, staged)));
  }
}

extension $WebApiModulesWarehouseCheckOutStorageContainerStagedItemModelExtension
    on WebApiModulesWarehouseCheckOutStorageContainerStagedItemModel {
  WebApiModulesWarehouseCheckOutStorageContainerStagedItemModel copyWith(
      {String? storageContainerBarcode,
      String? storageContainerDescription,
      String? pickupLocation,
      String? iCode,
      String? iCodeDescription,
      String? stagedBarcode,
      double? ordered,
      double? staged}) {
    return WebApiModulesWarehouseCheckOutStorageContainerStagedItemModel(
        storageContainerBarcode:
            storageContainerBarcode ?? this.storageContainerBarcode,
        storageContainerDescription:
            storageContainerDescription ?? this.storageContainerDescription,
        pickupLocation: pickupLocation ?? this.pickupLocation,
        iCode: iCode ?? this.iCode,
        iCodeDescription: iCodeDescription ?? this.iCodeDescription,
        stagedBarcode: stagedBarcode ?? this.stagedBarcode,
        ordered: ordered ?? this.ordered,
        staged: staged ?? this.staged);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutStorageContainerStagedItemsRequest {
  WebApiModulesWarehouseCheckOutStorageContainerStagedItemsRequest({
    this.orderId,
    this.storageContainerBarcodesOnly,
  });

  factory WebApiModulesWarehouseCheckOutStorageContainerStagedItemsRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutStorageContainerStagedItemsRequestFromJson(
          json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'StorageContainerBarcodesOnly')
  final bool? storageContainerBarcodesOnly;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutStorageContainerStagedItemsRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutStorageContainerStagedItemsRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutStorageContainerStagedItemsRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutStorageContainerStagedItemsRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.storageContainerBarcodesOnly,
                    storageContainerBarcodesOnly) ||
                const DeepCollectionEquality().equals(
                    other.storageContainerBarcodesOnly,
                    storageContainerBarcodesOnly)));
  }
}

extension $WebApiModulesWarehouseCheckOutStorageContainerStagedItemsRequestExtension
    on WebApiModulesWarehouseCheckOutStorageContainerStagedItemsRequest {
  WebApiModulesWarehouseCheckOutStorageContainerStagedItemsRequest copyWith(
      {String? orderId, bool? storageContainerBarcodesOnly}) {
    return WebApiModulesWarehouseCheckOutStorageContainerStagedItemsRequest(
        orderId: orderId ?? this.orderId,
        storageContainerBarcodesOnly:
            storageContainerBarcodesOnly ?? this.storageContainerBarcodesOnly);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutStorageContainerStagedItemsResponse {
  WebApiModulesWarehouseCheckOutStorageContainerStagedItemsResponse({
    this.items,
  });

  factory WebApiModulesWarehouseCheckOutStorageContainerStagedItemsResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutStorageContainerStagedItemsResponseFromJson(
          json);

  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesWarehouseCheckOutStorageContainerStagedItemModel>[])
  final List<WebApiModulesWarehouseCheckOutStorageContainerStagedItemModel>?
      items;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutStorageContainerStagedItemsResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutStorageContainerStagedItemsResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutStorageContainerStagedItemsResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutStorageContainerStagedItemsResponse &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)));
  }
}

extension $WebApiModulesWarehouseCheckOutStorageContainerStagedItemsResponseExtension
    on WebApiModulesWarehouseCheckOutStorageContainerStagedItemsResponse {
  WebApiModulesWarehouseCheckOutStorageContainerStagedItemsResponse copyWith(
      {List<WebApiModulesWarehouseCheckOutStorageContainerStagedItemModel>?
          items}) {
    return WebApiModulesWarehouseCheckOutStorageContainerStagedItemsResponse(
        items: items ?? this.items);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutUnstageItemRequest {
  WebApiModulesWarehouseCheckOutUnstageItemRequest({
    this.orderId,
    this.orderItemId,
    this.vendorId,
    this.warehouseId,
    this.consignorAgreementId,
    this.code,
    this.quantity,
  });

  factory WebApiModulesWarehouseCheckOutUnstageItemRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutUnstageItemRequestFromJson(json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderItemId')
  final String? orderItemId;
  @JsonKey(name: 'VendorId')
  final String? vendorId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'ConsignorAgreementId')
  final String? consignorAgreementId;
  @JsonKey(name: 'Code')
  final String? code;
  @JsonKey(name: 'Quantity')
  final int? quantity;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutUnstageItemRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutUnstageItemRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutUnstageItemRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutUnstageItemRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderItemId, orderItemId) ||
                const DeepCollectionEquality()
                    .equals(other.orderItemId, orderItemId)) &&
            (identical(other.vendorId, vendorId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorId, vendorId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.consignorAgreementId, consignorAgreementId) ||
                const DeepCollectionEquality().equals(
                    other.consignorAgreementId, consignorAgreementId)) &&
            (identical(other.code, code) ||
                const DeepCollectionEquality().equals(other.code, code)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)));
  }
}

extension $WebApiModulesWarehouseCheckOutUnstageItemRequestExtension
    on WebApiModulesWarehouseCheckOutUnstageItemRequest {
  WebApiModulesWarehouseCheckOutUnstageItemRequest copyWith(
      {String? orderId,
      String? orderItemId,
      String? vendorId,
      String? warehouseId,
      String? consignorAgreementId,
      String? code,
      int? quantity}) {
    return WebApiModulesWarehouseCheckOutUnstageItemRequest(
        orderId: orderId ?? this.orderId,
        orderItemId: orderItemId ?? this.orderItemId,
        vendorId: vendorId ?? this.vendorId,
        warehouseId: warehouseId ?? this.warehouseId,
        consignorAgreementId: consignorAgreementId ?? this.consignorAgreementId,
        code: code ?? this.code,
        quantity: quantity ?? this.quantity);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutUnstageItemResponse {
  WebApiModulesWarehouseCheckOutUnstageItemResponse({
    this.inventoryStatus,
    this.status,
    this.success,
    this.msg,
    this.inventoryId,
    this.itemId,
    this.consignorId,
    this.consignorAgreementId,
  });

  factory WebApiModulesWarehouseCheckOutUnstageItemResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutUnstageItemResponseFromJson(json);

  @JsonKey(name: 'InventoryStatus')
  final WebApiModulesWarehouseCheckOutOrderInventoryStatusCheckOut?
      inventoryStatus;
  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'ItemId')
  final String? itemId;
  @JsonKey(name: 'ConsignorId')
  final String? consignorId;
  @JsonKey(name: 'ConsignorAgreementId')
  final String? consignorAgreementId;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutUnstageItemResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutUnstageItemResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutUnstageItemResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutUnstageItemResponse &&
            (identical(other.inventoryStatus, inventoryStatus) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryStatus, inventoryStatus)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)) &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.itemId, itemId) ||
                const DeepCollectionEquality().equals(other.itemId, itemId)) &&
            (identical(other.consignorId, consignorId) ||
                const DeepCollectionEquality()
                    .equals(other.consignorId, consignorId)) &&
            (identical(other.consignorAgreementId, consignorAgreementId) ||
                const DeepCollectionEquality()
                    .equals(other.consignorAgreementId, consignorAgreementId)));
  }
}

extension $WebApiModulesWarehouseCheckOutUnstageItemResponseExtension
    on WebApiModulesWarehouseCheckOutUnstageItemResponse {
  WebApiModulesWarehouseCheckOutUnstageItemResponse copyWith(
      {WebApiModulesWarehouseCheckOutOrderInventoryStatusCheckOut?
          inventoryStatus,
      int? status,
      bool? success,
      String? msg,
      String? inventoryId,
      String? itemId,
      String? consignorId,
      String? consignorAgreementId}) {
    return WebApiModulesWarehouseCheckOutUnstageItemResponse(
        inventoryStatus: inventoryStatus ?? this.inventoryStatus,
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg,
        inventoryId: inventoryId ?? this.inventoryId,
        itemId: itemId ?? this.itemId,
        consignorId: consignorId ?? this.consignorId,
        consignorAgreementId:
            consignorAgreementId ?? this.consignorAgreementId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutUpdatePickupLocationRequest {
  WebApiModulesWarehouseCheckOutUpdatePickupLocationRequest({
    this.storageContainerItemId,
    this.pickupLocationId,
  });

  factory WebApiModulesWarehouseCheckOutUpdatePickupLocationRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutUpdatePickupLocationRequestFromJson(json);

  @JsonKey(name: 'StorageContainerItemId')
  final String? storageContainerItemId;
  @JsonKey(name: 'PickupLocationId')
  final String? pickupLocationId;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutUpdatePickupLocationRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutUpdatePickupLocationRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutUpdatePickupLocationRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutUpdatePickupLocationRequest &&
            (identical(other.storageContainerItemId, storageContainerItemId) ||
                const DeepCollectionEquality().equals(
                    other.storageContainerItemId, storageContainerItemId)) &&
            (identical(other.pickupLocationId, pickupLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.pickupLocationId, pickupLocationId)));
  }
}

extension $WebApiModulesWarehouseCheckOutUpdatePickupLocationRequestExtension
    on WebApiModulesWarehouseCheckOutUpdatePickupLocationRequest {
  WebApiModulesWarehouseCheckOutUpdatePickupLocationRequest copyWith(
      {String? storageContainerItemId, String? pickupLocationId}) {
    return WebApiModulesWarehouseCheckOutUpdatePickupLocationRequest(
        storageContainerItemId:
            storageContainerItemId ?? this.storageContainerItemId,
        pickupLocationId: pickupLocationId ?? this.pickupLocationId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseCheckOutUpdatePickupLocationResponse {
  WebApiModulesWarehouseCheckOutUpdatePickupLocationResponse({
    this.message,
  });

  factory WebApiModulesWarehouseCheckOutUpdatePickupLocationResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseCheckOutUpdatePickupLocationResponseFromJson(
          json);

  @JsonKey(name: 'Message')
  final String? message;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseCheckOutUpdatePickupLocationResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseCheckOutUpdatePickupLocationResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseCheckOutUpdatePickupLocationResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseCheckOutUpdatePickupLocationResponse &&
            (identical(other.message, message) ||
                const DeepCollectionEquality().equals(other.message, message)));
  }
}

extension $WebApiModulesWarehouseCheckOutUpdatePickupLocationResponseExtension
    on WebApiModulesWarehouseCheckOutUpdatePickupLocationResponse {
  WebApiModulesWarehouseCheckOutUpdatePickupLocationResponse copyWith(
      {String? message}) {
    return WebApiModulesWarehouseCheckOutUpdatePickupLocationResponse(
        message: message ?? this.message);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseContractCancelContractRequest {
  WebApiModulesWarehouseContractCancelContractRequest({
    this.contractId,
  });

  factory WebApiModulesWarehouseContractCancelContractRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseContractCancelContractRequestFromJson(json);

  @JsonKey(name: 'ContractId')
  final String? contractId;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseContractCancelContractRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseContractCancelContractRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseContractCancelContractRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseContractCancelContractRequest &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)));
  }
}

extension $WebApiModulesWarehouseContractCancelContractRequestExtension
    on WebApiModulesWarehouseContractCancelContractRequest {
  WebApiModulesWarehouseContractCancelContractRequest copyWith(
      {String? contractId}) {
    return WebApiModulesWarehouseContractCancelContractRequest(
        contractId: contractId ?? this.contractId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseContractContract {
  WebApiModulesWarehouseContractContract({
    this.contractId,
    this.contractNumber,
    this.contractType,
    this.contractDate,
    this.contractTime,
    this.locationId,
    this.locationCode,
    this.location,
    this.warehouseId,
    this.warehouseCode,
    this.warehouse,
    this.customerId,
    this.customer,
    this.dealId,
    this.deal,
    this.departmentId,
    this.department,
    this.purchaseOrderId,
    this.purchaseOrderNumber,
    this.requisitionNumber,
    this.vendorId,
    this.vendor,
    this.isMigrated,
    this.needReconcile,
    this.pendingExchange,
    this.exchangeContractId,
    this.rental,
    this.sales,
    this.exchange,
    this.inputByUserId,
    this.inputByUser,
    this.dealInactive,
    this.truck,
    this.billingDate,
    this.billingDateChangeReason,
    this.lastBillingDateChangeReason,
    this.billingDateAdjusted,
    this.hasVoId,
    this.sessionId,
    this.orderDescription,
    this.poOrderDescription,
    this.deliveryId,
    this.deliveryDeliveryType,
    this.deliveryRequiredDate,
    this.deliveryRequiredTime,
    this.deliveryTargetShipDate,
    this.deliveryTargetShipTime,
    this.deliveryDirection,
    this.deliveryAddressType,
    this.deliveryFromLocation,
    this.deliveryFromContact,
    this.deliveryFromContactPhone,
    this.deliveryFromAlternateContact,
    this.deliveryFromAlternateContactPhone,
    this.deliveryFromAttention,
    this.deliveryFromAddress1,
    this.deliveryFromAdd2ress,
    this.deliveryFromCity,
    this.deliveryFromState,
    this.deliveryFromZipCode,
    this.deliveryFromCountry,
    this.deliveryFromCountryId,
    this.deliveryFromCrossStreets,
    this.deliveryToLocation,
    this.deliveryToContact,
    this.deliveryToContactPhone,
    this.deliveryToAlternateContact,
    this.deliveryToAlternateContactPhone,
    this.deliveryToAttention,
    this.deliveryToAddress1,
    this.deliveryToAddress2,
    this.deliveryToCity,
    this.deliveryToState,
    this.deliveryToZipCode,
    this.deliveryToCountryId,
    this.deliveryToCountry,
    this.deliveryToContactFax,
    this.deliveryToCrossStreets,
    this.deliveryDeliveryNotes,
    this.deliveryCarrierId,
    this.deliveryCarrier,
    this.deliveryCarrierAccount,
    this.deliveryShipViaId,
    this.deliveryShipVia,
    this.deliveryInvoiceId,
    this.deliveryVendorInvoiceId,
    this.deliveryEstimatedFreight,
    this.deliveryFreightInvoiceAmount,
    this.deliveryChargeType,
    this.deliveryFreightTrackingNumber,
    this.deliveryFreightTrackingUrl,
    this.deliveryDropShip,
    this.deliveryPackageCode,
    this.deliveryBillPoFreightOnOrder,
    this.deliveryOnlineOrderNumber,
    this.deliveryOnlineOrderStatus,
    this.deliveryToVenue,
    this.deliveryToVenueId,
    this.deliveryDateStamp,
    this.note,
    this.printNoteOnOrder,
    this.termsConditionsId,
    this.quikReceiptTermsConditionsId,
    this.quikReceiptTermsConditions,
    this.termsConditions,
    this.containerId,
    this.containerItemId,
    this.containerDescription,
    this.containerScannableBarCode,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesWarehouseContractContract.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseContractContractFromJson(json);

  @JsonKey(name: 'ContractId')
  final String? contractId;
  @JsonKey(name: 'ContractNumber')
  final String? contractNumber;
  @JsonKey(name: 'ContractType')
  final String? contractType;
  @JsonKey(name: 'ContractDate')
  final String? contractDate;
  @JsonKey(name: 'ContractTime')
  final String? contractTime;
  @JsonKey(name: 'LocationId')
  final String? locationId;
  @JsonKey(name: 'LocationCode')
  final String? locationCode;
  @JsonKey(name: 'Location')
  final String? location;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'CustomerId')
  final String? customerId;
  @JsonKey(name: 'Customer')
  final String? customer;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'Deal')
  final String? deal;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'Department')
  final String? department;
  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'PurchaseOrderNumber')
  final String? purchaseOrderNumber;
  @JsonKey(name: 'RequisitionNumber')
  final String? requisitionNumber;
  @JsonKey(name: 'VendorId')
  final String? vendorId;
  @JsonKey(name: 'Vendor')
  final String? vendor;
  @JsonKey(name: 'IsMigrated')
  final bool? isMigrated;
  @JsonKey(name: 'NeedReconcile')
  final bool? needReconcile;
  @JsonKey(name: 'PendingExchange')
  final bool? pendingExchange;
  @JsonKey(name: 'ExchangeContractId')
  final String? exchangeContractId;
  @JsonKey(name: 'Rental')
  final bool? rental;
  @JsonKey(name: 'Sales')
  final bool? sales;
  @JsonKey(name: 'Exchange')
  final bool? exchange;
  @JsonKey(name: 'InputByUserId')
  final String? inputByUserId;
  @JsonKey(name: 'InputByUser')
  final String? inputByUser;
  @JsonKey(name: 'DealInactive')
  final bool? dealInactive;
  @JsonKey(name: 'Truck')
  final bool? truck;
  @JsonKey(name: 'BillingDate')
  final String? billingDate;
  @JsonKey(name: 'BillingDateChangeReason')
  final String? billingDateChangeReason;
  @JsonKey(name: 'LastBillingDateChangeReason')
  final String? lastBillingDateChangeReason;
  @JsonKey(name: 'BillingDateAdjusted')
  final bool? billingDateAdjusted;
  @JsonKey(name: 'HasVoId')
  final bool? hasVoId;
  @JsonKey(name: 'SessionId')
  final String? sessionId;
  @JsonKey(name: 'OrderDescription')
  final String? orderDescription;
  @JsonKey(name: 'PoOrderDescription')
  final String? poOrderDescription;
  @JsonKey(name: 'DeliveryId')
  final String? deliveryId;
  @JsonKey(name: 'DeliveryDeliveryType')
  final String? deliveryDeliveryType;
  @JsonKey(name: 'DeliveryRequiredDate')
  final String? deliveryRequiredDate;
  @JsonKey(name: 'DeliveryRequiredTime')
  final String? deliveryRequiredTime;
  @JsonKey(name: 'DeliveryTargetShipDate')
  final String? deliveryTargetShipDate;
  @JsonKey(name: 'DeliveryTargetShipTime')
  final String? deliveryTargetShipTime;
  @JsonKey(name: 'DeliveryDirection')
  final String? deliveryDirection;
  @JsonKey(name: 'DeliveryAddressType')
  final String? deliveryAddressType;
  @JsonKey(name: 'DeliveryFromLocation')
  final String? deliveryFromLocation;
  @JsonKey(name: 'DeliveryFromContact')
  final String? deliveryFromContact;
  @JsonKey(name: 'DeliveryFromContactPhone')
  final String? deliveryFromContactPhone;
  @JsonKey(name: 'DeliveryFromAlternateContact')
  final String? deliveryFromAlternateContact;
  @JsonKey(name: 'DeliveryFromAlternateContactPhone')
  final String? deliveryFromAlternateContactPhone;
  @JsonKey(name: 'DeliveryFromAttention')
  final String? deliveryFromAttention;
  @JsonKey(name: 'DeliveryFromAddress1')
  final String? deliveryFromAddress1;
  @JsonKey(name: 'DeliveryFromAdd2ress')
  final String? deliveryFromAdd2ress;
  @JsonKey(name: 'DeliveryFromCity')
  final String? deliveryFromCity;
  @JsonKey(name: 'DeliveryFromState')
  final String? deliveryFromState;
  @JsonKey(name: 'DeliveryFromZipCode')
  final String? deliveryFromZipCode;
  @JsonKey(name: 'DeliveryFromCountry')
  final String? deliveryFromCountry;
  @JsonKey(name: 'DeliveryFromCountryId')
  final String? deliveryFromCountryId;
  @JsonKey(name: 'DeliveryFromCrossStreets')
  final String? deliveryFromCrossStreets;
  @JsonKey(name: 'DeliveryToLocation')
  final String? deliveryToLocation;
  @JsonKey(name: 'DeliveryToContact')
  final String? deliveryToContact;
  @JsonKey(name: 'DeliveryToContactPhone')
  final String? deliveryToContactPhone;
  @JsonKey(name: 'DeliveryToAlternateContact')
  final String? deliveryToAlternateContact;
  @JsonKey(name: 'DeliveryToAlternateContactPhone')
  final String? deliveryToAlternateContactPhone;
  @JsonKey(name: 'DeliveryToAttention')
  final String? deliveryToAttention;
  @JsonKey(name: 'DeliveryToAddress1')
  final String? deliveryToAddress1;
  @JsonKey(name: 'DeliveryToAddress2')
  final String? deliveryToAddress2;
  @JsonKey(name: 'DeliveryToCity')
  final String? deliveryToCity;
  @JsonKey(name: 'DeliveryToState')
  final String? deliveryToState;
  @JsonKey(name: 'DeliveryToZipCode')
  final String? deliveryToZipCode;
  @JsonKey(name: 'DeliveryToCountryId')
  final String? deliveryToCountryId;
  @JsonKey(name: 'DeliveryToCountry')
  final String? deliveryToCountry;
  @JsonKey(name: 'DeliveryToContactFax')
  final String? deliveryToContactFax;
  @JsonKey(name: 'DeliveryToCrossStreets')
  final String? deliveryToCrossStreets;
  @JsonKey(name: 'DeliveryDeliveryNotes')
  final String? deliveryDeliveryNotes;
  @JsonKey(name: 'DeliveryCarrierId')
  final String? deliveryCarrierId;
  @JsonKey(name: 'DeliveryCarrier')
  final String? deliveryCarrier;
  @JsonKey(name: 'DeliveryCarrierAccount')
  final String? deliveryCarrierAccount;
  @JsonKey(name: 'DeliveryShipViaId')
  final String? deliveryShipViaId;
  @JsonKey(name: 'DeliveryShipVia')
  final String? deliveryShipVia;
  @JsonKey(name: 'DeliveryInvoiceId')
  final String? deliveryInvoiceId;
  @JsonKey(name: 'DeliveryVendorInvoiceId')
  final String? deliveryVendorInvoiceId;
  @JsonKey(name: 'DeliveryEstimatedFreight')
  final double? deliveryEstimatedFreight;
  @JsonKey(name: 'DeliveryFreightInvoiceAmount')
  final double? deliveryFreightInvoiceAmount;
  @JsonKey(name: 'DeliveryChargeType')
  final String? deliveryChargeType;
  @JsonKey(name: 'DeliveryFreightTrackingNumber')
  final String? deliveryFreightTrackingNumber;
  @JsonKey(name: 'DeliveryFreightTrackingUrl')
  final String? deliveryFreightTrackingUrl;
  @JsonKey(name: 'DeliveryDropShip')
  final bool? deliveryDropShip;
  @JsonKey(name: 'DeliveryPackageCode')
  final String? deliveryPackageCode;
  @JsonKey(name: 'DeliveryBillPoFreightOnOrder')
  final bool? deliveryBillPoFreightOnOrder;
  @JsonKey(name: 'DeliveryOnlineOrderNumber')
  final String? deliveryOnlineOrderNumber;
  @JsonKey(name: 'DeliveryOnlineOrderStatus')
  final String? deliveryOnlineOrderStatus;
  @JsonKey(name: 'DeliveryToVenue')
  final String? deliveryToVenue;
  @JsonKey(name: 'DeliveryToVenueId')
  final String? deliveryToVenueId;
  @JsonKey(name: 'DeliveryDateStamp')
  final String? deliveryDateStamp;
  @JsonKey(name: 'Note')
  final String? note;
  @JsonKey(name: 'PrintNoteOnOrder')
  final bool? printNoteOnOrder;
  @JsonKey(name: 'TermsConditionsId')
  final String? termsConditionsId;
  @JsonKey(name: 'QuikReceiptTermsConditionsId')
  final String? quikReceiptTermsConditionsId;
  @JsonKey(name: 'QuikReceiptTermsConditions')
  final String? quikReceiptTermsConditions;
  @JsonKey(name: 'TermsConditions')
  final String? termsConditions;
  @JsonKey(name: 'ContainerId')
  final String? containerId;
  @JsonKey(name: 'ContainerItemId')
  final String? containerItemId;
  @JsonKey(name: 'ContainerDescription')
  final String? containerDescription;
  @JsonKey(name: 'ContainerScannableBarCode')
  final String? containerScannableBarCode;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseContractContractFromJson;
  static const toJsonFactory = _$WebApiModulesWarehouseContractContractToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseContractContractToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseContractContract &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)) &&
            (identical(other.contractNumber, contractNumber) ||
                const DeepCollectionEquality()
                    .equals(other.contractNumber, contractNumber)) &&
            (identical(other.contractType, contractType) ||
                const DeepCollectionEquality()
                    .equals(other.contractType, contractType)) &&
            (identical(other.contractDate, contractDate) ||
                const DeepCollectionEquality()
                    .equals(other.contractDate, contractDate)) &&
            (identical(other.contractTime, contractTime) ||
                const DeepCollectionEquality()
                    .equals(other.contractTime, contractTime)) &&
            (identical(other.locationId, locationId) ||
                const DeepCollectionEquality()
                    .equals(other.locationId, locationId)) &&
            (identical(other.locationCode, locationCode) ||
                const DeepCollectionEquality()
                    .equals(other.locationCode, locationCode)) &&
            (identical(other.location, location) ||
                const DeepCollectionEquality()
                    .equals(other.location, location)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouseCode, warehouseCode) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.warehouse, warehouse) ||
                const DeepCollectionEquality()
                    .equals(other.warehouse, warehouse)) &&
            (identical(other.customerId, customerId) ||
                const DeepCollectionEquality()
                    .equals(other.customerId, customerId)) &&
            (identical(other.customer, customer) ||
                const DeepCollectionEquality()
                    .equals(other.customer, customer)) &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.deal, deal) ||
                const DeepCollectionEquality().equals(other.deal, deal)) &&
            (identical(other.departmentId, departmentId) ||
                const DeepCollectionEquality()
                    .equals(other.departmentId, departmentId)) &&
            (identical(other.department, department) ||
                const DeepCollectionEquality()
                    .equals(other.department, department)) &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.purchaseOrderNumber, purchaseOrderNumber) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderNumber, purchaseOrderNumber)) &&
            (identical(other.requisitionNumber, requisitionNumber) ||
                const DeepCollectionEquality()
                    .equals(other.requisitionNumber, requisitionNumber)) &&
            (identical(other.vendorId, vendorId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorId, vendorId)) &&
            (identical(other.vendor, vendor) ||
                const DeepCollectionEquality().equals(other.vendor, vendor)) &&
            (identical(other.isMigrated, isMigrated) ||
                const DeepCollectionEquality()
                    .equals(other.isMigrated, isMigrated)) &&
            (identical(other.needReconcile, needReconcile) || const DeepCollectionEquality().equals(other.needReconcile, needReconcile)) &&
            (identical(other.pendingExchange, pendingExchange) || const DeepCollectionEquality().equals(other.pendingExchange, pendingExchange)) &&
            (identical(other.exchangeContractId, exchangeContractId) || const DeepCollectionEquality().equals(other.exchangeContractId, exchangeContractId)) &&
            (identical(other.rental, rental) || const DeepCollectionEquality().equals(other.rental, rental)) &&
            (identical(other.sales, sales) || const DeepCollectionEquality().equals(other.sales, sales)) &&
            (identical(other.exchange, exchange) || const DeepCollectionEquality().equals(other.exchange, exchange)) &&
            (identical(other.inputByUserId, inputByUserId) || const DeepCollectionEquality().equals(other.inputByUserId, inputByUserId)) &&
            (identical(other.inputByUser, inputByUser) || const DeepCollectionEquality().equals(other.inputByUser, inputByUser)) &&
            (identical(other.dealInactive, dealInactive) || const DeepCollectionEquality().equals(other.dealInactive, dealInactive)) &&
            (identical(other.truck, truck) || const DeepCollectionEquality().equals(other.truck, truck)) &&
            (identical(other.billingDate, billingDate) || const DeepCollectionEquality().equals(other.billingDate, billingDate)) &&
            (identical(other.billingDateChangeReason, billingDateChangeReason) || const DeepCollectionEquality().equals(other.billingDateChangeReason, billingDateChangeReason)) &&
            (identical(other.lastBillingDateChangeReason, lastBillingDateChangeReason) || const DeepCollectionEquality().equals(other.lastBillingDateChangeReason, lastBillingDateChangeReason)) &&
            (identical(other.billingDateAdjusted, billingDateAdjusted) || const DeepCollectionEquality().equals(other.billingDateAdjusted, billingDateAdjusted)) &&
            (identical(other.hasVoId, hasVoId) || const DeepCollectionEquality().equals(other.hasVoId, hasVoId)) &&
            (identical(other.sessionId, sessionId) || const DeepCollectionEquality().equals(other.sessionId, sessionId)) &&
            (identical(other.orderDescription, orderDescription) || const DeepCollectionEquality().equals(other.orderDescription, orderDescription)) &&
            (identical(other.poOrderDescription, poOrderDescription) || const DeepCollectionEquality().equals(other.poOrderDescription, poOrderDescription)) &&
            (identical(other.deliveryId, deliveryId) || const DeepCollectionEquality().equals(other.deliveryId, deliveryId)) &&
            (identical(other.deliveryDeliveryType, deliveryDeliveryType) || const DeepCollectionEquality().equals(other.deliveryDeliveryType, deliveryDeliveryType)) &&
            (identical(other.deliveryRequiredDate, deliveryRequiredDate) || const DeepCollectionEquality().equals(other.deliveryRequiredDate, deliveryRequiredDate)) &&
            (identical(other.deliveryRequiredTime, deliveryRequiredTime) || const DeepCollectionEquality().equals(other.deliveryRequiredTime, deliveryRequiredTime)) &&
            (identical(other.deliveryTargetShipDate, deliveryTargetShipDate) || const DeepCollectionEquality().equals(other.deliveryTargetShipDate, deliveryTargetShipDate)) &&
            (identical(other.deliveryTargetShipTime, deliveryTargetShipTime) || const DeepCollectionEquality().equals(other.deliveryTargetShipTime, deliveryTargetShipTime)) &&
            (identical(other.deliveryDirection, deliveryDirection) || const DeepCollectionEquality().equals(other.deliveryDirection, deliveryDirection)) &&
            (identical(other.deliveryAddressType, deliveryAddressType) || const DeepCollectionEquality().equals(other.deliveryAddressType, deliveryAddressType)) &&
            (identical(other.deliveryFromLocation, deliveryFromLocation) || const DeepCollectionEquality().equals(other.deliveryFromLocation, deliveryFromLocation)) &&
            (identical(other.deliveryFromContact, deliveryFromContact) || const DeepCollectionEquality().equals(other.deliveryFromContact, deliveryFromContact)) &&
            (identical(other.deliveryFromContactPhone, deliveryFromContactPhone) || const DeepCollectionEquality().equals(other.deliveryFromContactPhone, deliveryFromContactPhone)) &&
            (identical(other.deliveryFromAlternateContact, deliveryFromAlternateContact) || const DeepCollectionEquality().equals(other.deliveryFromAlternateContact, deliveryFromAlternateContact)) &&
            (identical(other.deliveryFromAlternateContactPhone, deliveryFromAlternateContactPhone) || const DeepCollectionEquality().equals(other.deliveryFromAlternateContactPhone, deliveryFromAlternateContactPhone)) &&
            (identical(other.deliveryFromAttention, deliveryFromAttention) || const DeepCollectionEquality().equals(other.deliveryFromAttention, deliveryFromAttention)) &&
            (identical(other.deliveryFromAddress1, deliveryFromAddress1) || const DeepCollectionEquality().equals(other.deliveryFromAddress1, deliveryFromAddress1)) &&
            (identical(other.deliveryFromAdd2ress, deliveryFromAdd2ress) || const DeepCollectionEquality().equals(other.deliveryFromAdd2ress, deliveryFromAdd2ress)) &&
            (identical(other.deliveryFromCity, deliveryFromCity) || const DeepCollectionEquality().equals(other.deliveryFromCity, deliveryFromCity)) &&
            (identical(other.deliveryFromState, deliveryFromState) || const DeepCollectionEquality().equals(other.deliveryFromState, deliveryFromState)) &&
            (identical(other.deliveryFromZipCode, deliveryFromZipCode) || const DeepCollectionEquality().equals(other.deliveryFromZipCode, deliveryFromZipCode)) &&
            (identical(other.deliveryFromCountry, deliveryFromCountry) || const DeepCollectionEquality().equals(other.deliveryFromCountry, deliveryFromCountry)) &&
            (identical(other.deliveryFromCountryId, deliveryFromCountryId) || const DeepCollectionEquality().equals(other.deliveryFromCountryId, deliveryFromCountryId)) &&
            (identical(other.deliveryFromCrossStreets, deliveryFromCrossStreets) || const DeepCollectionEquality().equals(other.deliveryFromCrossStreets, deliveryFromCrossStreets)) &&
            (identical(other.deliveryToLocation, deliveryToLocation) || const DeepCollectionEquality().equals(other.deliveryToLocation, deliveryToLocation)) &&
            (identical(other.deliveryToContact, deliveryToContact) || const DeepCollectionEquality().equals(other.deliveryToContact, deliveryToContact)) &&
            (identical(other.deliveryToContactPhone, deliveryToContactPhone) || const DeepCollectionEquality().equals(other.deliveryToContactPhone, deliveryToContactPhone)) &&
            (identical(other.deliveryToAlternateContact, deliveryToAlternateContact) || const DeepCollectionEquality().equals(other.deliveryToAlternateContact, deliveryToAlternateContact)) &&
            (identical(other.deliveryToAlternateContactPhone, deliveryToAlternateContactPhone) || const DeepCollectionEquality().equals(other.deliveryToAlternateContactPhone, deliveryToAlternateContactPhone)) &&
            (identical(other.deliveryToAttention, deliveryToAttention) || const DeepCollectionEquality().equals(other.deliveryToAttention, deliveryToAttention)) &&
            (identical(other.deliveryToAddress1, deliveryToAddress1) || const DeepCollectionEquality().equals(other.deliveryToAddress1, deliveryToAddress1)) &&
            (identical(other.deliveryToAddress2, deliveryToAddress2) || const DeepCollectionEquality().equals(other.deliveryToAddress2, deliveryToAddress2)) &&
            (identical(other.deliveryToCity, deliveryToCity) || const DeepCollectionEquality().equals(other.deliveryToCity, deliveryToCity)) &&
            (identical(other.deliveryToState, deliveryToState) || const DeepCollectionEquality().equals(other.deliveryToState, deliveryToState)) &&
            (identical(other.deliveryToZipCode, deliveryToZipCode) || const DeepCollectionEquality().equals(other.deliveryToZipCode, deliveryToZipCode)) &&
            (identical(other.deliveryToCountryId, deliveryToCountryId) || const DeepCollectionEquality().equals(other.deliveryToCountryId, deliveryToCountryId)) &&
            (identical(other.deliveryToCountry, deliveryToCountry) || const DeepCollectionEquality().equals(other.deliveryToCountry, deliveryToCountry)) &&
            (identical(other.deliveryToContactFax, deliveryToContactFax) || const DeepCollectionEquality().equals(other.deliveryToContactFax, deliveryToContactFax)) &&
            (identical(other.deliveryToCrossStreets, deliveryToCrossStreets) || const DeepCollectionEquality().equals(other.deliveryToCrossStreets, deliveryToCrossStreets)) &&
            (identical(other.deliveryDeliveryNotes, deliveryDeliveryNotes) || const DeepCollectionEquality().equals(other.deliveryDeliveryNotes, deliveryDeliveryNotes)) &&
            (identical(other.deliveryCarrierId, deliveryCarrierId) || const DeepCollectionEquality().equals(other.deliveryCarrierId, deliveryCarrierId)) &&
            (identical(other.deliveryCarrier, deliveryCarrier) || const DeepCollectionEquality().equals(other.deliveryCarrier, deliveryCarrier)) &&
            (identical(other.deliveryCarrierAccount, deliveryCarrierAccount) || const DeepCollectionEquality().equals(other.deliveryCarrierAccount, deliveryCarrierAccount)) &&
            (identical(other.deliveryShipViaId, deliveryShipViaId) || const DeepCollectionEquality().equals(other.deliveryShipViaId, deliveryShipViaId)) &&
            (identical(other.deliveryShipVia, deliveryShipVia) || const DeepCollectionEquality().equals(other.deliveryShipVia, deliveryShipVia)) &&
            (identical(other.deliveryInvoiceId, deliveryInvoiceId) || const DeepCollectionEquality().equals(other.deliveryInvoiceId, deliveryInvoiceId)) &&
            (identical(other.deliveryVendorInvoiceId, deliveryVendorInvoiceId) || const DeepCollectionEquality().equals(other.deliveryVendorInvoiceId, deliveryVendorInvoiceId)) &&
            (identical(other.deliveryEstimatedFreight, deliveryEstimatedFreight) || const DeepCollectionEquality().equals(other.deliveryEstimatedFreight, deliveryEstimatedFreight)) &&
            (identical(other.deliveryFreightInvoiceAmount, deliveryFreightInvoiceAmount) || const DeepCollectionEquality().equals(other.deliveryFreightInvoiceAmount, deliveryFreightInvoiceAmount)) &&
            (identical(other.deliveryChargeType, deliveryChargeType) || const DeepCollectionEquality().equals(other.deliveryChargeType, deliveryChargeType)) &&
            (identical(other.deliveryFreightTrackingNumber, deliveryFreightTrackingNumber) || const DeepCollectionEquality().equals(other.deliveryFreightTrackingNumber, deliveryFreightTrackingNumber)) &&
            (identical(other.deliveryFreightTrackingUrl, deliveryFreightTrackingUrl) || const DeepCollectionEquality().equals(other.deliveryFreightTrackingUrl, deliveryFreightTrackingUrl)) &&
            (identical(other.deliveryDropShip, deliveryDropShip) || const DeepCollectionEquality().equals(other.deliveryDropShip, deliveryDropShip)) &&
            (identical(other.deliveryPackageCode, deliveryPackageCode) || const DeepCollectionEquality().equals(other.deliveryPackageCode, deliveryPackageCode)) &&
            (identical(other.deliveryBillPoFreightOnOrder, deliveryBillPoFreightOnOrder) || const DeepCollectionEquality().equals(other.deliveryBillPoFreightOnOrder, deliveryBillPoFreightOnOrder)) &&
            (identical(other.deliveryOnlineOrderNumber, deliveryOnlineOrderNumber) || const DeepCollectionEquality().equals(other.deliveryOnlineOrderNumber, deliveryOnlineOrderNumber)) &&
            (identical(other.deliveryOnlineOrderStatus, deliveryOnlineOrderStatus) || const DeepCollectionEquality().equals(other.deliveryOnlineOrderStatus, deliveryOnlineOrderStatus)) &&
            (identical(other.deliveryToVenue, deliveryToVenue) || const DeepCollectionEquality().equals(other.deliveryToVenue, deliveryToVenue)) &&
            (identical(other.deliveryToVenueId, deliveryToVenueId) || const DeepCollectionEquality().equals(other.deliveryToVenueId, deliveryToVenueId)) &&
            (identical(other.deliveryDateStamp, deliveryDateStamp) || const DeepCollectionEquality().equals(other.deliveryDateStamp, deliveryDateStamp)) &&
            (identical(other.note, note) || const DeepCollectionEquality().equals(other.note, note)) &&
            (identical(other.printNoteOnOrder, printNoteOnOrder) || const DeepCollectionEquality().equals(other.printNoteOnOrder, printNoteOnOrder)) &&
            (identical(other.termsConditionsId, termsConditionsId) || const DeepCollectionEquality().equals(other.termsConditionsId, termsConditionsId)) &&
            (identical(other.quikReceiptTermsConditionsId, quikReceiptTermsConditionsId) || const DeepCollectionEquality().equals(other.quikReceiptTermsConditionsId, quikReceiptTermsConditionsId)) &&
            (identical(other.quikReceiptTermsConditions, quikReceiptTermsConditions) || const DeepCollectionEquality().equals(other.quikReceiptTermsConditions, quikReceiptTermsConditions)) &&
            (identical(other.termsConditions, termsConditions) || const DeepCollectionEquality().equals(other.termsConditions, termsConditions)) &&
            (identical(other.containerId, containerId) || const DeepCollectionEquality().equals(other.containerId, containerId)) &&
            (identical(other.containerItemId, containerItemId) || const DeepCollectionEquality().equals(other.containerItemId, containerItemId)) &&
            (identical(other.containerDescription, containerDescription) || const DeepCollectionEquality().equals(other.containerDescription, containerDescription)) &&
            (identical(other.containerScannableBarCode, containerScannableBarCode) || const DeepCollectionEquality().equals(other.containerScannableBarCode, containerScannableBarCode)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesWarehouseContractContractExtension
    on WebApiModulesWarehouseContractContract {
  WebApiModulesWarehouseContractContract copyWith(
      {String? contractId,
      String? contractNumber,
      String? contractType,
      String? contractDate,
      String? contractTime,
      String? locationId,
      String? locationCode,
      String? location,
      String? warehouseId,
      String? warehouseCode,
      String? warehouse,
      String? customerId,
      String? customer,
      String? dealId,
      String? deal,
      String? departmentId,
      String? department,
      String? purchaseOrderId,
      String? purchaseOrderNumber,
      String? requisitionNumber,
      String? vendorId,
      String? vendor,
      bool? isMigrated,
      bool? needReconcile,
      bool? pendingExchange,
      String? exchangeContractId,
      bool? rental,
      bool? sales,
      bool? exchange,
      String? inputByUserId,
      String? inputByUser,
      bool? dealInactive,
      bool? truck,
      String? billingDate,
      String? billingDateChangeReason,
      String? lastBillingDateChangeReason,
      bool? billingDateAdjusted,
      bool? hasVoId,
      String? sessionId,
      String? orderDescription,
      String? poOrderDescription,
      String? deliveryId,
      String? deliveryDeliveryType,
      String? deliveryRequiredDate,
      String? deliveryRequiredTime,
      String? deliveryTargetShipDate,
      String? deliveryTargetShipTime,
      String? deliveryDirection,
      String? deliveryAddressType,
      String? deliveryFromLocation,
      String? deliveryFromContact,
      String? deliveryFromContactPhone,
      String? deliveryFromAlternateContact,
      String? deliveryFromAlternateContactPhone,
      String? deliveryFromAttention,
      String? deliveryFromAddress1,
      String? deliveryFromAdd2ress,
      String? deliveryFromCity,
      String? deliveryFromState,
      String? deliveryFromZipCode,
      String? deliveryFromCountry,
      String? deliveryFromCountryId,
      String? deliveryFromCrossStreets,
      String? deliveryToLocation,
      String? deliveryToContact,
      String? deliveryToContactPhone,
      String? deliveryToAlternateContact,
      String? deliveryToAlternateContactPhone,
      String? deliveryToAttention,
      String? deliveryToAddress1,
      String? deliveryToAddress2,
      String? deliveryToCity,
      String? deliveryToState,
      String? deliveryToZipCode,
      String? deliveryToCountryId,
      String? deliveryToCountry,
      String? deliveryToContactFax,
      String? deliveryToCrossStreets,
      String? deliveryDeliveryNotes,
      String? deliveryCarrierId,
      String? deliveryCarrier,
      String? deliveryCarrierAccount,
      String? deliveryShipViaId,
      String? deliveryShipVia,
      String? deliveryInvoiceId,
      String? deliveryVendorInvoiceId,
      double? deliveryEstimatedFreight,
      double? deliveryFreightInvoiceAmount,
      String? deliveryChargeType,
      String? deliveryFreightTrackingNumber,
      String? deliveryFreightTrackingUrl,
      bool? deliveryDropShip,
      String? deliveryPackageCode,
      bool? deliveryBillPoFreightOnOrder,
      String? deliveryOnlineOrderNumber,
      String? deliveryOnlineOrderStatus,
      String? deliveryToVenue,
      String? deliveryToVenueId,
      String? deliveryDateStamp,
      String? note,
      bool? printNoteOnOrder,
      String? termsConditionsId,
      String? quikReceiptTermsConditionsId,
      String? quikReceiptTermsConditions,
      String? termsConditions,
      String? containerId,
      String? containerItemId,
      String? containerDescription,
      String? containerScannableBarCode,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesWarehouseContractContract(
        contractId: contractId ?? this.contractId,
        contractNumber: contractNumber ?? this.contractNumber,
        contractType: contractType ?? this.contractType,
        contractDate: contractDate ?? this.contractDate,
        contractTime: contractTime ?? this.contractTime,
        locationId: locationId ?? this.locationId,
        locationCode: locationCode ?? this.locationCode,
        location: location ?? this.location,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        warehouse: warehouse ?? this.warehouse,
        customerId: customerId ?? this.customerId,
        customer: customer ?? this.customer,
        dealId: dealId ?? this.dealId,
        deal: deal ?? this.deal,
        departmentId: departmentId ?? this.departmentId,
        department: department ?? this.department,
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        purchaseOrderNumber: purchaseOrderNumber ?? this.purchaseOrderNumber,
        requisitionNumber: requisitionNumber ?? this.requisitionNumber,
        vendorId: vendorId ?? this.vendorId,
        vendor: vendor ?? this.vendor,
        isMigrated: isMigrated ?? this.isMigrated,
        needReconcile: needReconcile ?? this.needReconcile,
        pendingExchange: pendingExchange ?? this.pendingExchange,
        exchangeContractId: exchangeContractId ?? this.exchangeContractId,
        rental: rental ?? this.rental,
        sales: sales ?? this.sales,
        exchange: exchange ?? this.exchange,
        inputByUserId: inputByUserId ?? this.inputByUserId,
        inputByUser: inputByUser ?? this.inputByUser,
        dealInactive: dealInactive ?? this.dealInactive,
        truck: truck ?? this.truck,
        billingDate: billingDate ?? this.billingDate,
        billingDateChangeReason:
            billingDateChangeReason ?? this.billingDateChangeReason,
        lastBillingDateChangeReason:
            lastBillingDateChangeReason ?? this.lastBillingDateChangeReason,
        billingDateAdjusted: billingDateAdjusted ?? this.billingDateAdjusted,
        hasVoId: hasVoId ?? this.hasVoId,
        sessionId: sessionId ?? this.sessionId,
        orderDescription: orderDescription ?? this.orderDescription,
        poOrderDescription: poOrderDescription ?? this.poOrderDescription,
        deliveryId: deliveryId ?? this.deliveryId,
        deliveryDeliveryType: deliveryDeliveryType ?? this.deliveryDeliveryType,
        deliveryRequiredDate: deliveryRequiredDate ?? this.deliveryRequiredDate,
        deliveryRequiredTime: deliveryRequiredTime ?? this.deliveryRequiredTime,
        deliveryTargetShipDate:
            deliveryTargetShipDate ?? this.deliveryTargetShipDate,
        deliveryTargetShipTime:
            deliveryTargetShipTime ?? this.deliveryTargetShipTime,
        deliveryDirection: deliveryDirection ?? this.deliveryDirection,
        deliveryAddressType: deliveryAddressType ?? this.deliveryAddressType,
        deliveryFromLocation: deliveryFromLocation ?? this.deliveryFromLocation,
        deliveryFromContact: deliveryFromContact ?? this.deliveryFromContact,
        deliveryFromContactPhone:
            deliveryFromContactPhone ?? this.deliveryFromContactPhone,
        deliveryFromAlternateContact:
            deliveryFromAlternateContact ?? this.deliveryFromAlternateContact,
        deliveryFromAlternateContactPhone: deliveryFromAlternateContactPhone ??
            this.deliveryFromAlternateContactPhone,
        deliveryFromAttention:
            deliveryFromAttention ?? this.deliveryFromAttention,
        deliveryFromAddress1: deliveryFromAddress1 ?? this.deliveryFromAddress1,
        deliveryFromAdd2ress: deliveryFromAdd2ress ?? this.deliveryFromAdd2ress,
        deliveryFromCity: deliveryFromCity ?? this.deliveryFromCity,
        deliveryFromState: deliveryFromState ?? this.deliveryFromState,
        deliveryFromZipCode: deliveryFromZipCode ?? this.deliveryFromZipCode,
        deliveryFromCountry: deliveryFromCountry ?? this.deliveryFromCountry,
        deliveryFromCountryId:
            deliveryFromCountryId ?? this.deliveryFromCountryId,
        deliveryFromCrossStreets:
            deliveryFromCrossStreets ?? this.deliveryFromCrossStreets,
        deliveryToLocation: deliveryToLocation ?? this.deliveryToLocation,
        deliveryToContact: deliveryToContact ?? this.deliveryToContact,
        deliveryToContactPhone:
            deliveryToContactPhone ?? this.deliveryToContactPhone,
        deliveryToAlternateContact:
            deliveryToAlternateContact ?? this.deliveryToAlternateContact,
        deliveryToAlternateContactPhone: deliveryToAlternateContactPhone ??
            this.deliveryToAlternateContactPhone,
        deliveryToAttention: deliveryToAttention ?? this.deliveryToAttention,
        deliveryToAddress1: deliveryToAddress1 ?? this.deliveryToAddress1,
        deliveryToAddress2: deliveryToAddress2 ?? this.deliveryToAddress2,
        deliveryToCity: deliveryToCity ?? this.deliveryToCity,
        deliveryToState: deliveryToState ?? this.deliveryToState,
        deliveryToZipCode: deliveryToZipCode ?? this.deliveryToZipCode,
        deliveryToCountryId: deliveryToCountryId ?? this.deliveryToCountryId,
        deliveryToCountry: deliveryToCountry ?? this.deliveryToCountry,
        deliveryToContactFax: deliveryToContactFax ?? this.deliveryToContactFax,
        deliveryToCrossStreets:
            deliveryToCrossStreets ?? this.deliveryToCrossStreets,
        deliveryDeliveryNotes:
            deliveryDeliveryNotes ?? this.deliveryDeliveryNotes,
        deliveryCarrierId: deliveryCarrierId ?? this.deliveryCarrierId,
        deliveryCarrier: deliveryCarrier ?? this.deliveryCarrier,
        deliveryCarrierAccount:
            deliveryCarrierAccount ?? this.deliveryCarrierAccount,
        deliveryShipViaId: deliveryShipViaId ?? this.deliveryShipViaId,
        deliveryShipVia: deliveryShipVia ?? this.deliveryShipVia,
        deliveryInvoiceId: deliveryInvoiceId ?? this.deliveryInvoiceId,
        deliveryVendorInvoiceId:
            deliveryVendorInvoiceId ?? this.deliveryVendorInvoiceId,
        deliveryEstimatedFreight:
            deliveryEstimatedFreight ?? this.deliveryEstimatedFreight,
        deliveryFreightInvoiceAmount:
            deliveryFreightInvoiceAmount ?? this.deliveryFreightInvoiceAmount,
        deliveryChargeType: deliveryChargeType ?? this.deliveryChargeType,
        deliveryFreightTrackingNumber:
            deliveryFreightTrackingNumber ?? this.deliveryFreightTrackingNumber,
        deliveryFreightTrackingUrl:
            deliveryFreightTrackingUrl ?? this.deliveryFreightTrackingUrl,
        deliveryDropShip: deliveryDropShip ?? this.deliveryDropShip,
        deliveryPackageCode: deliveryPackageCode ?? this.deliveryPackageCode,
        deliveryBillPoFreightOnOrder:
            deliveryBillPoFreightOnOrder ?? this.deliveryBillPoFreightOnOrder,
        deliveryOnlineOrderNumber:
            deliveryOnlineOrderNumber ?? this.deliveryOnlineOrderNumber,
        deliveryOnlineOrderStatus:
            deliveryOnlineOrderStatus ?? this.deliveryOnlineOrderStatus,
        deliveryToVenue: deliveryToVenue ?? this.deliveryToVenue,
        deliveryToVenueId: deliveryToVenueId ?? this.deliveryToVenueId,
        deliveryDateStamp: deliveryDateStamp ?? this.deliveryDateStamp,
        note: note ?? this.note,
        printNoteOnOrder: printNoteOnOrder ?? this.printNoteOnOrder,
        termsConditionsId: termsConditionsId ?? this.termsConditionsId,
        quikReceiptTermsConditionsId:
            quikReceiptTermsConditionsId ?? this.quikReceiptTermsConditionsId,
        quikReceiptTermsConditions:
            quikReceiptTermsConditions ?? this.quikReceiptTermsConditions,
        termsConditions: termsConditions ?? this.termsConditions,
        containerId: containerId ?? this.containerId,
        containerItemId: containerItemId ?? this.containerItemId,
        containerDescription: containerDescription ?? this.containerDescription,
        containerScannableBarCode:
            containerScannableBarCode ?? this.containerScannableBarCode,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseContractContractDetailResponse {
  WebApiModulesWarehouseContractContractDetailResponse({
    this.contractId,
    this.contractNumber,
    this.contractType,
    this.contractDate,
    this.contractTime,
    this.locationId,
    this.locationCode,
    this.location,
    this.warehouseId,
    this.warehouseCode,
    this.warehouse,
    this.customerId,
    this.customer,
    this.dealId,
    this.deal,
    this.departmentId,
    this.department,
    this.purchaseOrderId,
    this.purchaseOrderNumber,
    this.requisitionNumber,
    this.vendorId,
    this.vendor,
    this.isMigrated,
    this.needReconcile,
    this.pendingExchange,
    this.exchangeContractId,
    this.rental,
    this.sales,
    this.exchange,
    this.inputByUserId,
    this.inputByUser,
    this.dealInactive,
    this.truck,
    this.billingDate,
    this.billingDateChangeReason,
    this.lastBillingDateChangeReason,
    this.billingDateAdjusted,
    this.hasVoId,
    this.sessionId,
    this.orderDescription,
    this.poOrderDescription,
    this.deliveryId,
    this.deliveryDeliveryType,
    this.deliveryRequiredDate,
    this.deliveryRequiredTime,
    this.deliveryTargetShipDate,
    this.deliveryTargetShipTime,
    this.deliveryDirection,
    this.deliveryAddressType,
    this.deliveryFromLocation,
    this.deliveryFromContact,
    this.deliveryFromContactPhone,
    this.deliveryFromAlternateContact,
    this.deliveryFromAlternateContactPhone,
    this.deliveryFromAttention,
    this.deliveryFromAddress1,
    this.deliveryFromAdd2ress,
    this.deliveryFromCity,
    this.deliveryFromState,
    this.deliveryFromZipCode,
    this.deliveryFromCountry,
    this.deliveryFromCountryId,
    this.deliveryFromCrossStreets,
    this.deliveryToLocation,
    this.deliveryToContact,
    this.deliveryToContactPhone,
    this.deliveryToAlternateContact,
    this.deliveryToAlternateContactPhone,
    this.deliveryToAttention,
    this.deliveryToAddress1,
    this.deliveryToAddress2,
    this.deliveryToCity,
    this.deliveryToState,
    this.deliveryToZipCode,
    this.deliveryToCountryId,
    this.deliveryToCountry,
    this.deliveryToContactFax,
    this.deliveryToCrossStreets,
    this.deliveryDeliveryNotes,
    this.deliveryCarrierId,
    this.deliveryCarrier,
    this.deliveryCarrierAccount,
    this.deliveryShipViaId,
    this.deliveryShipVia,
    this.deliveryInvoiceId,
    this.deliveryVendorInvoiceId,
    this.deliveryEstimatedFreight,
    this.deliveryFreightInvoiceAmount,
    this.deliveryChargeType,
    this.deliveryFreightTrackingNumber,
    this.deliveryFreightTrackingUrl,
    this.deliveryDropShip,
    this.deliveryPackageCode,
    this.deliveryBillPoFreightOnOrder,
    this.deliveryOnlineOrderNumber,
    this.deliveryOnlineOrderStatus,
    this.deliveryToVenue,
    this.deliveryToVenueId,
    this.deliveryDateStamp,
    this.note,
    this.printNoteOnOrder,
    this.termsConditionsId,
    this.quikReceiptTermsConditionsId,
    this.quikReceiptTermsConditions,
    this.termsConditions,
    this.containerId,
    this.containerItemId,
    this.containerDescription,
    this.containerScannableBarCode,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.items,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesWarehouseContractContractDetailResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseContractContractDetailResponseFromJson(json);

  @JsonKey(name: 'ContractId')
  final String? contractId;
  @JsonKey(name: 'ContractNumber')
  final String? contractNumber;
  @JsonKey(name: 'ContractType')
  final String? contractType;
  @JsonKey(name: 'ContractDate')
  final String? contractDate;
  @JsonKey(name: 'ContractTime')
  final String? contractTime;
  @JsonKey(name: 'LocationId')
  final String? locationId;
  @JsonKey(name: 'LocationCode')
  final String? locationCode;
  @JsonKey(name: 'Location')
  final String? location;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'CustomerId')
  final String? customerId;
  @JsonKey(name: 'Customer')
  final String? customer;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'Deal')
  final String? deal;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'Department')
  final String? department;
  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'PurchaseOrderNumber')
  final String? purchaseOrderNumber;
  @JsonKey(name: 'RequisitionNumber')
  final String? requisitionNumber;
  @JsonKey(name: 'VendorId')
  final String? vendorId;
  @JsonKey(name: 'Vendor')
  final String? vendor;
  @JsonKey(name: 'IsMigrated')
  final bool? isMigrated;
  @JsonKey(name: 'NeedReconcile')
  final bool? needReconcile;
  @JsonKey(name: 'PendingExchange')
  final bool? pendingExchange;
  @JsonKey(name: 'ExchangeContractId')
  final String? exchangeContractId;
  @JsonKey(name: 'Rental')
  final bool? rental;
  @JsonKey(name: 'Sales')
  final bool? sales;
  @JsonKey(name: 'Exchange')
  final bool? exchange;
  @JsonKey(name: 'InputByUserId')
  final String? inputByUserId;
  @JsonKey(name: 'InputByUser')
  final String? inputByUser;
  @JsonKey(name: 'DealInactive')
  final bool? dealInactive;
  @JsonKey(name: 'Truck')
  final bool? truck;
  @JsonKey(name: 'BillingDate')
  final String? billingDate;
  @JsonKey(name: 'BillingDateChangeReason')
  final String? billingDateChangeReason;
  @JsonKey(name: 'LastBillingDateChangeReason')
  final String? lastBillingDateChangeReason;
  @JsonKey(name: 'BillingDateAdjusted')
  final bool? billingDateAdjusted;
  @JsonKey(name: 'HasVoId')
  final bool? hasVoId;
  @JsonKey(name: 'SessionId')
  final String? sessionId;
  @JsonKey(name: 'OrderDescription')
  final String? orderDescription;
  @JsonKey(name: 'PoOrderDescription')
  final String? poOrderDescription;
  @JsonKey(name: 'DeliveryId')
  final String? deliveryId;
  @JsonKey(name: 'DeliveryDeliveryType')
  final String? deliveryDeliveryType;
  @JsonKey(name: 'DeliveryRequiredDate')
  final String? deliveryRequiredDate;
  @JsonKey(name: 'DeliveryRequiredTime')
  final String? deliveryRequiredTime;
  @JsonKey(name: 'DeliveryTargetShipDate')
  final String? deliveryTargetShipDate;
  @JsonKey(name: 'DeliveryTargetShipTime')
  final String? deliveryTargetShipTime;
  @JsonKey(name: 'DeliveryDirection')
  final String? deliveryDirection;
  @JsonKey(name: 'DeliveryAddressType')
  final String? deliveryAddressType;
  @JsonKey(name: 'DeliveryFromLocation')
  final String? deliveryFromLocation;
  @JsonKey(name: 'DeliveryFromContact')
  final String? deliveryFromContact;
  @JsonKey(name: 'DeliveryFromContactPhone')
  final String? deliveryFromContactPhone;
  @JsonKey(name: 'DeliveryFromAlternateContact')
  final String? deliveryFromAlternateContact;
  @JsonKey(name: 'DeliveryFromAlternateContactPhone')
  final String? deliveryFromAlternateContactPhone;
  @JsonKey(name: 'DeliveryFromAttention')
  final String? deliveryFromAttention;
  @JsonKey(name: 'DeliveryFromAddress1')
  final String? deliveryFromAddress1;
  @JsonKey(name: 'DeliveryFromAdd2ress')
  final String? deliveryFromAdd2ress;
  @JsonKey(name: 'DeliveryFromCity')
  final String? deliveryFromCity;
  @JsonKey(name: 'DeliveryFromState')
  final String? deliveryFromState;
  @JsonKey(name: 'DeliveryFromZipCode')
  final String? deliveryFromZipCode;
  @JsonKey(name: 'DeliveryFromCountry')
  final String? deliveryFromCountry;
  @JsonKey(name: 'DeliveryFromCountryId')
  final String? deliveryFromCountryId;
  @JsonKey(name: 'DeliveryFromCrossStreets')
  final String? deliveryFromCrossStreets;
  @JsonKey(name: 'DeliveryToLocation')
  final String? deliveryToLocation;
  @JsonKey(name: 'DeliveryToContact')
  final String? deliveryToContact;
  @JsonKey(name: 'DeliveryToContactPhone')
  final String? deliveryToContactPhone;
  @JsonKey(name: 'DeliveryToAlternateContact')
  final String? deliveryToAlternateContact;
  @JsonKey(name: 'DeliveryToAlternateContactPhone')
  final String? deliveryToAlternateContactPhone;
  @JsonKey(name: 'DeliveryToAttention')
  final String? deliveryToAttention;
  @JsonKey(name: 'DeliveryToAddress1')
  final String? deliveryToAddress1;
  @JsonKey(name: 'DeliveryToAddress2')
  final String? deliveryToAddress2;
  @JsonKey(name: 'DeliveryToCity')
  final String? deliveryToCity;
  @JsonKey(name: 'DeliveryToState')
  final String? deliveryToState;
  @JsonKey(name: 'DeliveryToZipCode')
  final String? deliveryToZipCode;
  @JsonKey(name: 'DeliveryToCountryId')
  final String? deliveryToCountryId;
  @JsonKey(name: 'DeliveryToCountry')
  final String? deliveryToCountry;
  @JsonKey(name: 'DeliveryToContactFax')
  final String? deliveryToContactFax;
  @JsonKey(name: 'DeliveryToCrossStreets')
  final String? deliveryToCrossStreets;
  @JsonKey(name: 'DeliveryDeliveryNotes')
  final String? deliveryDeliveryNotes;
  @JsonKey(name: 'DeliveryCarrierId')
  final String? deliveryCarrierId;
  @JsonKey(name: 'DeliveryCarrier')
  final String? deliveryCarrier;
  @JsonKey(name: 'DeliveryCarrierAccount')
  final String? deliveryCarrierAccount;
  @JsonKey(name: 'DeliveryShipViaId')
  final String? deliveryShipViaId;
  @JsonKey(name: 'DeliveryShipVia')
  final String? deliveryShipVia;
  @JsonKey(name: 'DeliveryInvoiceId')
  final String? deliveryInvoiceId;
  @JsonKey(name: 'DeliveryVendorInvoiceId')
  final String? deliveryVendorInvoiceId;
  @JsonKey(name: 'DeliveryEstimatedFreight')
  final double? deliveryEstimatedFreight;
  @JsonKey(name: 'DeliveryFreightInvoiceAmount')
  final double? deliveryFreightInvoiceAmount;
  @JsonKey(name: 'DeliveryChargeType')
  final String? deliveryChargeType;
  @JsonKey(name: 'DeliveryFreightTrackingNumber')
  final String? deliveryFreightTrackingNumber;
  @JsonKey(name: 'DeliveryFreightTrackingUrl')
  final String? deliveryFreightTrackingUrl;
  @JsonKey(name: 'DeliveryDropShip')
  final bool? deliveryDropShip;
  @JsonKey(name: 'DeliveryPackageCode')
  final String? deliveryPackageCode;
  @JsonKey(name: 'DeliveryBillPoFreightOnOrder')
  final bool? deliveryBillPoFreightOnOrder;
  @JsonKey(name: 'DeliveryOnlineOrderNumber')
  final String? deliveryOnlineOrderNumber;
  @JsonKey(name: 'DeliveryOnlineOrderStatus')
  final String? deliveryOnlineOrderStatus;
  @JsonKey(name: 'DeliveryToVenue')
  final String? deliveryToVenue;
  @JsonKey(name: 'DeliveryToVenueId')
  final String? deliveryToVenueId;
  @JsonKey(name: 'DeliveryDateStamp')
  final String? deliveryDateStamp;
  @JsonKey(name: 'Note')
  final String? note;
  @JsonKey(name: 'PrintNoteOnOrder')
  final bool? printNoteOnOrder;
  @JsonKey(name: 'TermsConditionsId')
  final String? termsConditionsId;
  @JsonKey(name: 'QuikReceiptTermsConditionsId')
  final String? quikReceiptTermsConditionsId;
  @JsonKey(name: 'QuikReceiptTermsConditions')
  final String? quikReceiptTermsConditions;
  @JsonKey(name: 'TermsConditions')
  final String? termsConditions;
  @JsonKey(name: 'ContainerId')
  final String? containerId;
  @JsonKey(name: 'ContainerItemId')
  final String? containerItemId;
  @JsonKey(name: 'ContainerDescription')
  final String? containerDescription;
  @JsonKey(name: 'ContainerScannableBarCode')
  final String? containerScannableBarCode;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: 'Items', defaultValue: <
      WebApiModulesHomeControlsContractItemDetailContractItemDetail>[])
  final List<WebApiModulesHomeControlsContractItemDetailContractItemDetail>?
      items;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseContractContractDetailResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseContractContractDetailResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseContractContractDetailResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseContractContractDetailResponse &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)) &&
            (identical(other.contractNumber, contractNumber) ||
                const DeepCollectionEquality()
                    .equals(other.contractNumber, contractNumber)) &&
            (identical(other.contractType, contractType) ||
                const DeepCollectionEquality()
                    .equals(other.contractType, contractType)) &&
            (identical(other.contractDate, contractDate) ||
                const DeepCollectionEquality()
                    .equals(other.contractDate, contractDate)) &&
            (identical(other.contractTime, contractTime) ||
                const DeepCollectionEquality()
                    .equals(other.contractTime, contractTime)) &&
            (identical(other.locationId, locationId) ||
                const DeepCollectionEquality()
                    .equals(other.locationId, locationId)) &&
            (identical(other.locationCode, locationCode) ||
                const DeepCollectionEquality()
                    .equals(other.locationCode, locationCode)) &&
            (identical(other.location, location) ||
                const DeepCollectionEquality()
                    .equals(other.location, location)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouseCode, warehouseCode) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.warehouse, warehouse) ||
                const DeepCollectionEquality()
                    .equals(other.warehouse, warehouse)) &&
            (identical(other.customerId, customerId) ||
                const DeepCollectionEquality()
                    .equals(other.customerId, customerId)) &&
            (identical(other.customer, customer) ||
                const DeepCollectionEquality()
                    .equals(other.customer, customer)) &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.deal, deal) ||
                const DeepCollectionEquality().equals(other.deal, deal)) &&
            (identical(other.departmentId, departmentId) ||
                const DeepCollectionEquality()
                    .equals(other.departmentId, departmentId)) &&
            (identical(other.department, department) ||
                const DeepCollectionEquality()
                    .equals(other.department, department)) &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.purchaseOrderNumber, purchaseOrderNumber) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderNumber, purchaseOrderNumber)) &&
            (identical(other.requisitionNumber, requisitionNumber) ||
                const DeepCollectionEquality()
                    .equals(other.requisitionNumber, requisitionNumber)) &&
            (identical(other.vendorId, vendorId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorId, vendorId)) &&
            (identical(other.vendor, vendor) ||
                const DeepCollectionEquality().equals(other.vendor, vendor)) &&
            (identical(other.isMigrated, isMigrated) ||
                const DeepCollectionEquality()
                    .equals(other.isMigrated, isMigrated)) &&
            (identical(other.needReconcile, needReconcile) || const DeepCollectionEquality().equals(other.needReconcile, needReconcile)) &&
            (identical(other.pendingExchange, pendingExchange) || const DeepCollectionEquality().equals(other.pendingExchange, pendingExchange)) &&
            (identical(other.exchangeContractId, exchangeContractId) || const DeepCollectionEquality().equals(other.exchangeContractId, exchangeContractId)) &&
            (identical(other.rental, rental) || const DeepCollectionEquality().equals(other.rental, rental)) &&
            (identical(other.sales, sales) || const DeepCollectionEquality().equals(other.sales, sales)) &&
            (identical(other.exchange, exchange) || const DeepCollectionEquality().equals(other.exchange, exchange)) &&
            (identical(other.inputByUserId, inputByUserId) || const DeepCollectionEquality().equals(other.inputByUserId, inputByUserId)) &&
            (identical(other.inputByUser, inputByUser) || const DeepCollectionEquality().equals(other.inputByUser, inputByUser)) &&
            (identical(other.dealInactive, dealInactive) || const DeepCollectionEquality().equals(other.dealInactive, dealInactive)) &&
            (identical(other.truck, truck) || const DeepCollectionEquality().equals(other.truck, truck)) &&
            (identical(other.billingDate, billingDate) || const DeepCollectionEquality().equals(other.billingDate, billingDate)) &&
            (identical(other.billingDateChangeReason, billingDateChangeReason) || const DeepCollectionEquality().equals(other.billingDateChangeReason, billingDateChangeReason)) &&
            (identical(other.lastBillingDateChangeReason, lastBillingDateChangeReason) || const DeepCollectionEquality().equals(other.lastBillingDateChangeReason, lastBillingDateChangeReason)) &&
            (identical(other.billingDateAdjusted, billingDateAdjusted) || const DeepCollectionEquality().equals(other.billingDateAdjusted, billingDateAdjusted)) &&
            (identical(other.hasVoId, hasVoId) || const DeepCollectionEquality().equals(other.hasVoId, hasVoId)) &&
            (identical(other.sessionId, sessionId) || const DeepCollectionEquality().equals(other.sessionId, sessionId)) &&
            (identical(other.orderDescription, orderDescription) || const DeepCollectionEquality().equals(other.orderDescription, orderDescription)) &&
            (identical(other.poOrderDescription, poOrderDescription) || const DeepCollectionEquality().equals(other.poOrderDescription, poOrderDescription)) &&
            (identical(other.deliveryId, deliveryId) || const DeepCollectionEquality().equals(other.deliveryId, deliveryId)) &&
            (identical(other.deliveryDeliveryType, deliveryDeliveryType) || const DeepCollectionEquality().equals(other.deliveryDeliveryType, deliveryDeliveryType)) &&
            (identical(other.deliveryRequiredDate, deliveryRequiredDate) || const DeepCollectionEquality().equals(other.deliveryRequiredDate, deliveryRequiredDate)) &&
            (identical(other.deliveryRequiredTime, deliveryRequiredTime) || const DeepCollectionEquality().equals(other.deliveryRequiredTime, deliveryRequiredTime)) &&
            (identical(other.deliveryTargetShipDate, deliveryTargetShipDate) || const DeepCollectionEquality().equals(other.deliveryTargetShipDate, deliveryTargetShipDate)) &&
            (identical(other.deliveryTargetShipTime, deliveryTargetShipTime) || const DeepCollectionEquality().equals(other.deliveryTargetShipTime, deliveryTargetShipTime)) &&
            (identical(other.deliveryDirection, deliveryDirection) || const DeepCollectionEquality().equals(other.deliveryDirection, deliveryDirection)) &&
            (identical(other.deliveryAddressType, deliveryAddressType) || const DeepCollectionEquality().equals(other.deliveryAddressType, deliveryAddressType)) &&
            (identical(other.deliveryFromLocation, deliveryFromLocation) || const DeepCollectionEquality().equals(other.deliveryFromLocation, deliveryFromLocation)) &&
            (identical(other.deliveryFromContact, deliveryFromContact) || const DeepCollectionEquality().equals(other.deliveryFromContact, deliveryFromContact)) &&
            (identical(other.deliveryFromContactPhone, deliveryFromContactPhone) || const DeepCollectionEquality().equals(other.deliveryFromContactPhone, deliveryFromContactPhone)) &&
            (identical(other.deliveryFromAlternateContact, deliveryFromAlternateContact) || const DeepCollectionEquality().equals(other.deliveryFromAlternateContact, deliveryFromAlternateContact)) &&
            (identical(other.deliveryFromAlternateContactPhone, deliveryFromAlternateContactPhone) || const DeepCollectionEquality().equals(other.deliveryFromAlternateContactPhone, deliveryFromAlternateContactPhone)) &&
            (identical(other.deliveryFromAttention, deliveryFromAttention) || const DeepCollectionEquality().equals(other.deliveryFromAttention, deliveryFromAttention)) &&
            (identical(other.deliveryFromAddress1, deliveryFromAddress1) || const DeepCollectionEquality().equals(other.deliveryFromAddress1, deliveryFromAddress1)) &&
            (identical(other.deliveryFromAdd2ress, deliveryFromAdd2ress) || const DeepCollectionEquality().equals(other.deliveryFromAdd2ress, deliveryFromAdd2ress)) &&
            (identical(other.deliveryFromCity, deliveryFromCity) || const DeepCollectionEquality().equals(other.deliveryFromCity, deliveryFromCity)) &&
            (identical(other.deliveryFromState, deliveryFromState) || const DeepCollectionEquality().equals(other.deliveryFromState, deliveryFromState)) &&
            (identical(other.deliveryFromZipCode, deliveryFromZipCode) || const DeepCollectionEquality().equals(other.deliveryFromZipCode, deliveryFromZipCode)) &&
            (identical(other.deliveryFromCountry, deliveryFromCountry) || const DeepCollectionEquality().equals(other.deliveryFromCountry, deliveryFromCountry)) &&
            (identical(other.deliveryFromCountryId, deliveryFromCountryId) || const DeepCollectionEquality().equals(other.deliveryFromCountryId, deliveryFromCountryId)) &&
            (identical(other.deliveryFromCrossStreets, deliveryFromCrossStreets) || const DeepCollectionEquality().equals(other.deliveryFromCrossStreets, deliveryFromCrossStreets)) &&
            (identical(other.deliveryToLocation, deliveryToLocation) || const DeepCollectionEquality().equals(other.deliveryToLocation, deliveryToLocation)) &&
            (identical(other.deliveryToContact, deliveryToContact) || const DeepCollectionEquality().equals(other.deliveryToContact, deliveryToContact)) &&
            (identical(other.deliveryToContactPhone, deliveryToContactPhone) || const DeepCollectionEquality().equals(other.deliveryToContactPhone, deliveryToContactPhone)) &&
            (identical(other.deliveryToAlternateContact, deliveryToAlternateContact) || const DeepCollectionEquality().equals(other.deliveryToAlternateContact, deliveryToAlternateContact)) &&
            (identical(other.deliveryToAlternateContactPhone, deliveryToAlternateContactPhone) || const DeepCollectionEquality().equals(other.deliveryToAlternateContactPhone, deliveryToAlternateContactPhone)) &&
            (identical(other.deliveryToAttention, deliveryToAttention) || const DeepCollectionEquality().equals(other.deliveryToAttention, deliveryToAttention)) &&
            (identical(other.deliveryToAddress1, deliveryToAddress1) || const DeepCollectionEquality().equals(other.deliveryToAddress1, deliveryToAddress1)) &&
            (identical(other.deliveryToAddress2, deliveryToAddress2) || const DeepCollectionEquality().equals(other.deliveryToAddress2, deliveryToAddress2)) &&
            (identical(other.deliveryToCity, deliveryToCity) || const DeepCollectionEquality().equals(other.deliveryToCity, deliveryToCity)) &&
            (identical(other.deliveryToState, deliveryToState) || const DeepCollectionEquality().equals(other.deliveryToState, deliveryToState)) &&
            (identical(other.deliveryToZipCode, deliveryToZipCode) || const DeepCollectionEquality().equals(other.deliveryToZipCode, deliveryToZipCode)) &&
            (identical(other.deliveryToCountryId, deliveryToCountryId) || const DeepCollectionEquality().equals(other.deliveryToCountryId, deliveryToCountryId)) &&
            (identical(other.deliveryToCountry, deliveryToCountry) || const DeepCollectionEquality().equals(other.deliveryToCountry, deliveryToCountry)) &&
            (identical(other.deliveryToContactFax, deliveryToContactFax) || const DeepCollectionEquality().equals(other.deliveryToContactFax, deliveryToContactFax)) &&
            (identical(other.deliveryToCrossStreets, deliveryToCrossStreets) || const DeepCollectionEquality().equals(other.deliveryToCrossStreets, deliveryToCrossStreets)) &&
            (identical(other.deliveryDeliveryNotes, deliveryDeliveryNotes) || const DeepCollectionEquality().equals(other.deliveryDeliveryNotes, deliveryDeliveryNotes)) &&
            (identical(other.deliveryCarrierId, deliveryCarrierId) || const DeepCollectionEquality().equals(other.deliveryCarrierId, deliveryCarrierId)) &&
            (identical(other.deliveryCarrier, deliveryCarrier) || const DeepCollectionEquality().equals(other.deliveryCarrier, deliveryCarrier)) &&
            (identical(other.deliveryCarrierAccount, deliveryCarrierAccount) || const DeepCollectionEquality().equals(other.deliveryCarrierAccount, deliveryCarrierAccount)) &&
            (identical(other.deliveryShipViaId, deliveryShipViaId) || const DeepCollectionEquality().equals(other.deliveryShipViaId, deliveryShipViaId)) &&
            (identical(other.deliveryShipVia, deliveryShipVia) || const DeepCollectionEquality().equals(other.deliveryShipVia, deliveryShipVia)) &&
            (identical(other.deliveryInvoiceId, deliveryInvoiceId) || const DeepCollectionEquality().equals(other.deliveryInvoiceId, deliveryInvoiceId)) &&
            (identical(other.deliveryVendorInvoiceId, deliveryVendorInvoiceId) || const DeepCollectionEquality().equals(other.deliveryVendorInvoiceId, deliveryVendorInvoiceId)) &&
            (identical(other.deliveryEstimatedFreight, deliveryEstimatedFreight) || const DeepCollectionEquality().equals(other.deliveryEstimatedFreight, deliveryEstimatedFreight)) &&
            (identical(other.deliveryFreightInvoiceAmount, deliveryFreightInvoiceAmount) || const DeepCollectionEquality().equals(other.deliveryFreightInvoiceAmount, deliveryFreightInvoiceAmount)) &&
            (identical(other.deliveryChargeType, deliveryChargeType) || const DeepCollectionEquality().equals(other.deliveryChargeType, deliveryChargeType)) &&
            (identical(other.deliveryFreightTrackingNumber, deliveryFreightTrackingNumber) || const DeepCollectionEquality().equals(other.deliveryFreightTrackingNumber, deliveryFreightTrackingNumber)) &&
            (identical(other.deliveryFreightTrackingUrl, deliveryFreightTrackingUrl) || const DeepCollectionEquality().equals(other.deliveryFreightTrackingUrl, deliveryFreightTrackingUrl)) &&
            (identical(other.deliveryDropShip, deliveryDropShip) || const DeepCollectionEquality().equals(other.deliveryDropShip, deliveryDropShip)) &&
            (identical(other.deliveryPackageCode, deliveryPackageCode) || const DeepCollectionEquality().equals(other.deliveryPackageCode, deliveryPackageCode)) &&
            (identical(other.deliveryBillPoFreightOnOrder, deliveryBillPoFreightOnOrder) || const DeepCollectionEquality().equals(other.deliveryBillPoFreightOnOrder, deliveryBillPoFreightOnOrder)) &&
            (identical(other.deliveryOnlineOrderNumber, deliveryOnlineOrderNumber) || const DeepCollectionEquality().equals(other.deliveryOnlineOrderNumber, deliveryOnlineOrderNumber)) &&
            (identical(other.deliveryOnlineOrderStatus, deliveryOnlineOrderStatus) || const DeepCollectionEquality().equals(other.deliveryOnlineOrderStatus, deliveryOnlineOrderStatus)) &&
            (identical(other.deliveryToVenue, deliveryToVenue) || const DeepCollectionEquality().equals(other.deliveryToVenue, deliveryToVenue)) &&
            (identical(other.deliveryToVenueId, deliveryToVenueId) || const DeepCollectionEquality().equals(other.deliveryToVenueId, deliveryToVenueId)) &&
            (identical(other.deliveryDateStamp, deliveryDateStamp) || const DeepCollectionEquality().equals(other.deliveryDateStamp, deliveryDateStamp)) &&
            (identical(other.note, note) || const DeepCollectionEquality().equals(other.note, note)) &&
            (identical(other.printNoteOnOrder, printNoteOnOrder) || const DeepCollectionEquality().equals(other.printNoteOnOrder, printNoteOnOrder)) &&
            (identical(other.termsConditionsId, termsConditionsId) || const DeepCollectionEquality().equals(other.termsConditionsId, termsConditionsId)) &&
            (identical(other.quikReceiptTermsConditionsId, quikReceiptTermsConditionsId) || const DeepCollectionEquality().equals(other.quikReceiptTermsConditionsId, quikReceiptTermsConditionsId)) &&
            (identical(other.quikReceiptTermsConditions, quikReceiptTermsConditions) || const DeepCollectionEquality().equals(other.quikReceiptTermsConditions, quikReceiptTermsConditions)) &&
            (identical(other.termsConditions, termsConditions) || const DeepCollectionEquality().equals(other.termsConditions, termsConditions)) &&
            (identical(other.containerId, containerId) || const DeepCollectionEquality().equals(other.containerId, containerId)) &&
            (identical(other.containerItemId, containerItemId) || const DeepCollectionEquality().equals(other.containerItemId, containerItemId)) &&
            (identical(other.containerDescription, containerDescription) || const DeepCollectionEquality().equals(other.containerDescription, containerDescription)) &&
            (identical(other.containerScannableBarCode, containerScannableBarCode) || const DeepCollectionEquality().equals(other.containerScannableBarCode, containerScannableBarCode)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.items, items) || const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesWarehouseContractContractDetailResponseExtension
    on WebApiModulesWarehouseContractContractDetailResponse {
  WebApiModulesWarehouseContractContractDetailResponse copyWith(
      {String? contractId,
      String? contractNumber,
      String? contractType,
      String? contractDate,
      String? contractTime,
      String? locationId,
      String? locationCode,
      String? location,
      String? warehouseId,
      String? warehouseCode,
      String? warehouse,
      String? customerId,
      String? customer,
      String? dealId,
      String? deal,
      String? departmentId,
      String? department,
      String? purchaseOrderId,
      String? purchaseOrderNumber,
      String? requisitionNumber,
      String? vendorId,
      String? vendor,
      bool? isMigrated,
      bool? needReconcile,
      bool? pendingExchange,
      String? exchangeContractId,
      bool? rental,
      bool? sales,
      bool? exchange,
      String? inputByUserId,
      String? inputByUser,
      bool? dealInactive,
      bool? truck,
      String? billingDate,
      String? billingDateChangeReason,
      String? lastBillingDateChangeReason,
      bool? billingDateAdjusted,
      bool? hasVoId,
      String? sessionId,
      String? orderDescription,
      String? poOrderDescription,
      String? deliveryId,
      String? deliveryDeliveryType,
      String? deliveryRequiredDate,
      String? deliveryRequiredTime,
      String? deliveryTargetShipDate,
      String? deliveryTargetShipTime,
      String? deliveryDirection,
      String? deliveryAddressType,
      String? deliveryFromLocation,
      String? deliveryFromContact,
      String? deliveryFromContactPhone,
      String? deliveryFromAlternateContact,
      String? deliveryFromAlternateContactPhone,
      String? deliveryFromAttention,
      String? deliveryFromAddress1,
      String? deliveryFromAdd2ress,
      String? deliveryFromCity,
      String? deliveryFromState,
      String? deliveryFromZipCode,
      String? deliveryFromCountry,
      String? deliveryFromCountryId,
      String? deliveryFromCrossStreets,
      String? deliveryToLocation,
      String? deliveryToContact,
      String? deliveryToContactPhone,
      String? deliveryToAlternateContact,
      String? deliveryToAlternateContactPhone,
      String? deliveryToAttention,
      String? deliveryToAddress1,
      String? deliveryToAddress2,
      String? deliveryToCity,
      String? deliveryToState,
      String? deliveryToZipCode,
      String? deliveryToCountryId,
      String? deliveryToCountry,
      String? deliveryToContactFax,
      String? deliveryToCrossStreets,
      String? deliveryDeliveryNotes,
      String? deliveryCarrierId,
      String? deliveryCarrier,
      String? deliveryCarrierAccount,
      String? deliveryShipViaId,
      String? deliveryShipVia,
      String? deliveryInvoiceId,
      String? deliveryVendorInvoiceId,
      double? deliveryEstimatedFreight,
      double? deliveryFreightInvoiceAmount,
      String? deliveryChargeType,
      String? deliveryFreightTrackingNumber,
      String? deliveryFreightTrackingUrl,
      bool? deliveryDropShip,
      String? deliveryPackageCode,
      bool? deliveryBillPoFreightOnOrder,
      String? deliveryOnlineOrderNumber,
      String? deliveryOnlineOrderStatus,
      String? deliveryToVenue,
      String? deliveryToVenueId,
      String? deliveryDateStamp,
      String? note,
      bool? printNoteOnOrder,
      String? termsConditionsId,
      String? quikReceiptTermsConditionsId,
      String? quikReceiptTermsConditions,
      String? termsConditions,
      String? containerId,
      String? containerItemId,
      String? containerDescription,
      String? containerScannableBarCode,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<WebApiModulesHomeControlsContractItemDetailContractItemDetail>?
          items,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesWarehouseContractContractDetailResponse(
        contractId: contractId ?? this.contractId,
        contractNumber: contractNumber ?? this.contractNumber,
        contractType: contractType ?? this.contractType,
        contractDate: contractDate ?? this.contractDate,
        contractTime: contractTime ?? this.contractTime,
        locationId: locationId ?? this.locationId,
        locationCode: locationCode ?? this.locationCode,
        location: location ?? this.location,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        warehouse: warehouse ?? this.warehouse,
        customerId: customerId ?? this.customerId,
        customer: customer ?? this.customer,
        dealId: dealId ?? this.dealId,
        deal: deal ?? this.deal,
        departmentId: departmentId ?? this.departmentId,
        department: department ?? this.department,
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        purchaseOrderNumber: purchaseOrderNumber ?? this.purchaseOrderNumber,
        requisitionNumber: requisitionNumber ?? this.requisitionNumber,
        vendorId: vendorId ?? this.vendorId,
        vendor: vendor ?? this.vendor,
        isMigrated: isMigrated ?? this.isMigrated,
        needReconcile: needReconcile ?? this.needReconcile,
        pendingExchange: pendingExchange ?? this.pendingExchange,
        exchangeContractId: exchangeContractId ?? this.exchangeContractId,
        rental: rental ?? this.rental,
        sales: sales ?? this.sales,
        exchange: exchange ?? this.exchange,
        inputByUserId: inputByUserId ?? this.inputByUserId,
        inputByUser: inputByUser ?? this.inputByUser,
        dealInactive: dealInactive ?? this.dealInactive,
        truck: truck ?? this.truck,
        billingDate: billingDate ?? this.billingDate,
        billingDateChangeReason:
            billingDateChangeReason ?? this.billingDateChangeReason,
        lastBillingDateChangeReason:
            lastBillingDateChangeReason ?? this.lastBillingDateChangeReason,
        billingDateAdjusted: billingDateAdjusted ?? this.billingDateAdjusted,
        hasVoId: hasVoId ?? this.hasVoId,
        sessionId: sessionId ?? this.sessionId,
        orderDescription: orderDescription ?? this.orderDescription,
        poOrderDescription: poOrderDescription ?? this.poOrderDescription,
        deliveryId: deliveryId ?? this.deliveryId,
        deliveryDeliveryType: deliveryDeliveryType ?? this.deliveryDeliveryType,
        deliveryRequiredDate: deliveryRequiredDate ?? this.deliveryRequiredDate,
        deliveryRequiredTime: deliveryRequiredTime ?? this.deliveryRequiredTime,
        deliveryTargetShipDate:
            deliveryTargetShipDate ?? this.deliveryTargetShipDate,
        deliveryTargetShipTime:
            deliveryTargetShipTime ?? this.deliveryTargetShipTime,
        deliveryDirection: deliveryDirection ?? this.deliveryDirection,
        deliveryAddressType: deliveryAddressType ?? this.deliveryAddressType,
        deliveryFromLocation: deliveryFromLocation ?? this.deliveryFromLocation,
        deliveryFromContact: deliveryFromContact ?? this.deliveryFromContact,
        deliveryFromContactPhone:
            deliveryFromContactPhone ?? this.deliveryFromContactPhone,
        deliveryFromAlternateContact:
            deliveryFromAlternateContact ?? this.deliveryFromAlternateContact,
        deliveryFromAlternateContactPhone: deliveryFromAlternateContactPhone ??
            this.deliveryFromAlternateContactPhone,
        deliveryFromAttention:
            deliveryFromAttention ?? this.deliveryFromAttention,
        deliveryFromAddress1: deliveryFromAddress1 ?? this.deliveryFromAddress1,
        deliveryFromAdd2ress: deliveryFromAdd2ress ?? this.deliveryFromAdd2ress,
        deliveryFromCity: deliveryFromCity ?? this.deliveryFromCity,
        deliveryFromState: deliveryFromState ?? this.deliveryFromState,
        deliveryFromZipCode: deliveryFromZipCode ?? this.deliveryFromZipCode,
        deliveryFromCountry: deliveryFromCountry ?? this.deliveryFromCountry,
        deliveryFromCountryId:
            deliveryFromCountryId ?? this.deliveryFromCountryId,
        deliveryFromCrossStreets:
            deliveryFromCrossStreets ?? this.deliveryFromCrossStreets,
        deliveryToLocation: deliveryToLocation ?? this.deliveryToLocation,
        deliveryToContact: deliveryToContact ?? this.deliveryToContact,
        deliveryToContactPhone:
            deliveryToContactPhone ?? this.deliveryToContactPhone,
        deliveryToAlternateContact:
            deliveryToAlternateContact ?? this.deliveryToAlternateContact,
        deliveryToAlternateContactPhone: deliveryToAlternateContactPhone ??
            this.deliveryToAlternateContactPhone,
        deliveryToAttention: deliveryToAttention ?? this.deliveryToAttention,
        deliveryToAddress1: deliveryToAddress1 ?? this.deliveryToAddress1,
        deliveryToAddress2: deliveryToAddress2 ?? this.deliveryToAddress2,
        deliveryToCity: deliveryToCity ?? this.deliveryToCity,
        deliveryToState: deliveryToState ?? this.deliveryToState,
        deliveryToZipCode: deliveryToZipCode ?? this.deliveryToZipCode,
        deliveryToCountryId: deliveryToCountryId ?? this.deliveryToCountryId,
        deliveryToCountry: deliveryToCountry ?? this.deliveryToCountry,
        deliveryToContactFax: deliveryToContactFax ?? this.deliveryToContactFax,
        deliveryToCrossStreets:
            deliveryToCrossStreets ?? this.deliveryToCrossStreets,
        deliveryDeliveryNotes:
            deliveryDeliveryNotes ?? this.deliveryDeliveryNotes,
        deliveryCarrierId: deliveryCarrierId ?? this.deliveryCarrierId,
        deliveryCarrier: deliveryCarrier ?? this.deliveryCarrier,
        deliveryCarrierAccount:
            deliveryCarrierAccount ?? this.deliveryCarrierAccount,
        deliveryShipViaId: deliveryShipViaId ?? this.deliveryShipViaId,
        deliveryShipVia: deliveryShipVia ?? this.deliveryShipVia,
        deliveryInvoiceId: deliveryInvoiceId ?? this.deliveryInvoiceId,
        deliveryVendorInvoiceId:
            deliveryVendorInvoiceId ?? this.deliveryVendorInvoiceId,
        deliveryEstimatedFreight:
            deliveryEstimatedFreight ?? this.deliveryEstimatedFreight,
        deliveryFreightInvoiceAmount:
            deliveryFreightInvoiceAmount ?? this.deliveryFreightInvoiceAmount,
        deliveryChargeType: deliveryChargeType ?? this.deliveryChargeType,
        deliveryFreightTrackingNumber:
            deliveryFreightTrackingNumber ?? this.deliveryFreightTrackingNumber,
        deliveryFreightTrackingUrl:
            deliveryFreightTrackingUrl ?? this.deliveryFreightTrackingUrl,
        deliveryDropShip: deliveryDropShip ?? this.deliveryDropShip,
        deliveryPackageCode: deliveryPackageCode ?? this.deliveryPackageCode,
        deliveryBillPoFreightOnOrder:
            deliveryBillPoFreightOnOrder ?? this.deliveryBillPoFreightOnOrder,
        deliveryOnlineOrderNumber:
            deliveryOnlineOrderNumber ?? this.deliveryOnlineOrderNumber,
        deliveryOnlineOrderStatus:
            deliveryOnlineOrderStatus ?? this.deliveryOnlineOrderStatus,
        deliveryToVenue: deliveryToVenue ?? this.deliveryToVenue,
        deliveryToVenueId: deliveryToVenueId ?? this.deliveryToVenueId,
        deliveryDateStamp: deliveryDateStamp ?? this.deliveryDateStamp,
        note: note ?? this.note,
        printNoteOnOrder: printNoteOnOrder ?? this.printNoteOnOrder,
        termsConditionsId: termsConditionsId ?? this.termsConditionsId,
        quikReceiptTermsConditionsId:
            quikReceiptTermsConditionsId ?? this.quikReceiptTermsConditionsId,
        quikReceiptTermsConditions:
            quikReceiptTermsConditions ?? this.quikReceiptTermsConditions,
        termsConditions: termsConditions ?? this.termsConditions,
        containerId: containerId ?? this.containerId,
        containerItemId: containerItemId ?? this.containerItemId,
        containerDescription: containerDescription ?? this.containerDescription,
        containerScannableBarCode:
            containerScannableBarCode ?? this.containerScannableBarCode,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        items: items ?? this.items,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseContractContractDocument {
  WebApiModulesWarehouseContractContractDocument({
    this.contractId,
    this.copying,
    this.documentId,
    this.documentTypeId,
    this.uniqueId1,
    this.uniqueId2,
    this.uniqueId1Int,
    this.description,
    this.inputByUsersId,
    this.attachDate,
    this.attachTime,
    this.attachToEmail,
    this.inactive,
    this.dateStamp,
    this.extension,
    this.documentType,
    this.inputBy,
    this.hasImage,
    this.hasFile,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesWarehouseContractContractDocument.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseContractContractDocumentFromJson(json);

  @JsonKey(name: 'ContractId')
  final String? contractId;
  @JsonKey(name: 'copying')
  final bool? copying;
  @JsonKey(name: 'DocumentId')
  final String? documentId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'UniqueId1')
  final String? uniqueId1;
  @JsonKey(name: 'UniqueId2')
  final String? uniqueId2;
  @JsonKey(name: 'UniqueId1Int')
  final int? uniqueId1Int;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'InputByUsersId')
  final String? inputByUsersId;
  @JsonKey(name: 'AttachDate')
  final String? attachDate;
  @JsonKey(name: 'AttachTime')
  final String? attachTime;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'Extension')
  final String? extension;
  @JsonKey(name: 'DocumentType')
  final String? documentType;
  @JsonKey(name: 'InputBy')
  final String? inputBy;
  @JsonKey(name: 'HasImage')
  final bool? hasImage;
  @JsonKey(name: 'HasFile')
  final bool? hasFile;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseContractContractDocumentFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseContractContractDocumentToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseContractContractDocumentToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseContractContractDocument &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)) &&
            (identical(other.copying, copying) ||
                const DeepCollectionEquality()
                    .equals(other.copying, copying)) &&
            (identical(other.documentId, documentId) ||
                const DeepCollectionEquality()
                    .equals(other.documentId, documentId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.uniqueId1, uniqueId1) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1, uniqueId1)) &&
            (identical(other.uniqueId2, uniqueId2) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId2, uniqueId2)) &&
            (identical(other.uniqueId1Int, uniqueId1Int) ||
                const DeepCollectionEquality()
                    .equals(other.uniqueId1Int, uniqueId1Int)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.inputByUsersId, inputByUsersId) ||
                const DeepCollectionEquality()
                    .equals(other.inputByUsersId, inputByUsersId)) &&
            (identical(other.attachDate, attachDate) ||
                const DeepCollectionEquality()
                    .equals(other.attachDate, attachDate)) &&
            (identical(other.attachTime, attachTime) ||
                const DeepCollectionEquality()
                    .equals(other.attachTime, attachTime)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.dateStamp, dateStamp) ||
                const DeepCollectionEquality()
                    .equals(other.dateStamp, dateStamp)) &&
            (identical(other.extension, extension) ||
                const DeepCollectionEquality()
                    .equals(other.extension, extension)) &&
            (identical(other.documentType, documentType) ||
                const DeepCollectionEquality()
                    .equals(other.documentType, documentType)) &&
            (identical(other.inputBy, inputBy) ||
                const DeepCollectionEquality()
                    .equals(other.inputBy, inputBy)) &&
            (identical(other.hasImage, hasImage) ||
                const DeepCollectionEquality()
                    .equals(other.hasImage, hasImage)) &&
            (identical(other.hasFile, hasFile) ||
                const DeepCollectionEquality()
                    .equals(other.hasFile, hasFile)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality().equals(other.filePath, filePath)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesWarehouseContractContractDocumentExtension
    on WebApiModulesWarehouseContractContractDocument {
  WebApiModulesWarehouseContractContractDocument copyWith(
      {String? contractId,
      bool? copying,
      String? documentId,
      String? documentTypeId,
      String? uniqueId1,
      String? uniqueId2,
      int? uniqueId1Int,
      String? description,
      String? inputByUsersId,
      String? attachDate,
      String? attachTime,
      bool? attachToEmail,
      bool? inactive,
      String? dateStamp,
      String? extension,
      String? documentType,
      String? inputBy,
      bool? hasImage,
      bool? hasFile,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesWarehouseContractContractDocument(
        contractId: contractId ?? this.contractId,
        copying: copying ?? this.copying,
        documentId: documentId ?? this.documentId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        uniqueId1: uniqueId1 ?? this.uniqueId1,
        uniqueId2: uniqueId2 ?? this.uniqueId2,
        uniqueId1Int: uniqueId1Int ?? this.uniqueId1Int,
        description: description ?? this.description,
        inputByUsersId: inputByUsersId ?? this.inputByUsersId,
        attachDate: attachDate ?? this.attachDate,
        attachTime: attachTime ?? this.attachTime,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        dateStamp: dateStamp ?? this.dateStamp,
        extension: extension ?? this.extension,
        documentType: documentType ?? this.documentType,
        inputBy: inputBy ?? this.inputBy,
        hasImage: hasImage ?? this.hasImage,
        hasFile: hasFile ?? this.hasFile,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseContractContractDocumentPostRequest {
  WebApiModulesWarehouseContractContractDocumentPostRequest({
    this.contractId,
    this.documentTypeId,
    this.description,
    this.attachToEmail,
    this.inactive,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
  });

  factory WebApiModulesWarehouseContractContractDocumentPostRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseContractContractDocumentPostRequestFromJson(json);

  @JsonKey(name: 'ContractId')
  final String? contractId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseContractContractDocumentPostRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseContractContractDocumentPostRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseContractContractDocumentPostRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseContractContractDocumentPostRequest &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)));
  }
}

extension $WebApiModulesWarehouseContractContractDocumentPostRequestExtension
    on WebApiModulesWarehouseContractContractDocumentPostRequest {
  WebApiModulesWarehouseContractContractDocumentPostRequest copyWith(
      {String? contractId,
      String? documentTypeId,
      String? description,
      bool? attachToEmail,
      bool? inactive,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath}) {
    return WebApiModulesWarehouseContractContractDocumentPostRequest(
        contractId: contractId ?? this.contractId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        description: description ?? this.description,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseContractContractDocumentPutRequest {
  WebApiModulesWarehouseContractContractDocumentPutRequest({
    this.contractId,
    this.documentId,
    this.documentTypeId,
    this.description,
    this.attachToEmail,
    this.inactive,
    this.fileIsModified,
    this.fileDataUrl,
    this.filePath,
  });

  factory WebApiModulesWarehouseContractContractDocumentPutRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseContractContractDocumentPutRequestFromJson(json);

  @JsonKey(name: 'ContractId')
  final String? contractId;
  @JsonKey(name: 'DocumentId')
  final String? documentId;
  @JsonKey(name: 'DocumentTypeId')
  final String? documentTypeId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'AttachToEmail')
  final bool? attachToEmail;
  @JsonKey(name: 'Inactive')
  final bool? inactive;
  @JsonKey(name: 'FileIsModified')
  final bool? fileIsModified;
  @JsonKey(name: 'FileDataUrl')
  final String? fileDataUrl;
  @JsonKey(name: 'FilePath')
  final String? filePath;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseContractContractDocumentPutRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseContractContractDocumentPutRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseContractContractDocumentPutRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseContractContractDocumentPutRequest &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)) &&
            (identical(other.documentId, documentId) ||
                const DeepCollectionEquality()
                    .equals(other.documentId, documentId)) &&
            (identical(other.documentTypeId, documentTypeId) ||
                const DeepCollectionEquality()
                    .equals(other.documentTypeId, documentTypeId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.attachToEmail, attachToEmail) ||
                const DeepCollectionEquality()
                    .equals(other.attachToEmail, attachToEmail)) &&
            (identical(other.inactive, inactive) ||
                const DeepCollectionEquality()
                    .equals(other.inactive, inactive)) &&
            (identical(other.fileIsModified, fileIsModified) ||
                const DeepCollectionEquality()
                    .equals(other.fileIsModified, fileIsModified)) &&
            (identical(other.fileDataUrl, fileDataUrl) ||
                const DeepCollectionEquality()
                    .equals(other.fileDataUrl, fileDataUrl)) &&
            (identical(other.filePath, filePath) ||
                const DeepCollectionEquality()
                    .equals(other.filePath, filePath)));
  }
}

extension $WebApiModulesWarehouseContractContractDocumentPutRequestExtension
    on WebApiModulesWarehouseContractContractDocumentPutRequest {
  WebApiModulesWarehouseContractContractDocumentPutRequest copyWith(
      {String? contractId,
      String? documentId,
      String? documentTypeId,
      String? description,
      bool? attachToEmail,
      bool? inactive,
      bool? fileIsModified,
      String? fileDataUrl,
      String? filePath}) {
    return WebApiModulesWarehouseContractContractDocumentPutRequest(
        contractId: contractId ?? this.contractId,
        documentId: documentId ?? this.documentId,
        documentTypeId: documentTypeId ?? this.documentTypeId,
        description: description ?? this.description,
        attachToEmail: attachToEmail ?? this.attachToEmail,
        inactive: inactive ?? this.inactive,
        fileIsModified: fileIsModified ?? this.fileIsModified,
        fileDataUrl: fileDataUrl ?? this.fileDataUrl,
        filePath: filePath ?? this.filePath);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseContractHasQuikReceiptRequest {
  WebApiModulesWarehouseContractHasQuikReceiptRequest({
    this.contractId,
  });

  factory WebApiModulesWarehouseContractHasQuikReceiptRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseContractHasQuikReceiptRequestFromJson(json);

  @JsonKey(name: 'ContractId')
  final String? contractId;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseContractHasQuikReceiptRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseContractHasQuikReceiptRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseContractHasQuikReceiptRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseContractHasQuikReceiptRequest &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)));
  }
}

extension $WebApiModulesWarehouseContractHasQuikReceiptRequestExtension
    on WebApiModulesWarehouseContractHasQuikReceiptRequest {
  WebApiModulesWarehouseContractHasQuikReceiptRequest copyWith(
      {String? contractId}) {
    return WebApiModulesWarehouseContractHasQuikReceiptRequest(
        contractId: contractId ?? this.contractId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseContractVoidContractRequest {
  WebApiModulesWarehouseContractVoidContractRequest({
    this.contractId,
  });

  factory WebApiModulesWarehouseContractVoidContractRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseContractVoidContractRequestFromJson(json);

  @JsonKey(name: 'ContractId')
  final String? contractId;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseContractVoidContractRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseContractVoidContractRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseContractVoidContractRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseContractVoidContractRequest &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)));
  }
}

extension $WebApiModulesWarehouseContractVoidContractRequestExtension
    on WebApiModulesWarehouseContractVoidContractRequest {
  WebApiModulesWarehouseContractVoidContractRequest copyWith(
      {String? contractId}) {
    return WebApiModulesWarehouseContractVoidContractRequest(
        contractId: contractId ?? this.contractId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseExchangeExchangeContractRequest {
  WebApiModulesWarehouseExchangeExchangeContractRequest({
    this.orderId,
    this.dealId,
    this.departmentId,
    this.warehouseId,
  });

  factory WebApiModulesWarehouseExchangeExchangeContractRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseExchangeExchangeContractRequestFromJson(json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseExchangeExchangeContractRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseExchangeExchangeContractRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseExchangeExchangeContractRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseExchangeExchangeContractRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.departmentId, departmentId) ||
                const DeepCollectionEquality()
                    .equals(other.departmentId, departmentId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)));
  }
}

extension $WebApiModulesWarehouseExchangeExchangeContractRequestExtension
    on WebApiModulesWarehouseExchangeExchangeContractRequest {
  WebApiModulesWarehouseExchangeExchangeContractRequest copyWith(
      {String? orderId,
      String? dealId,
      String? departmentId,
      String? warehouseId}) {
    return WebApiModulesWarehouseExchangeExchangeContractRequest(
        orderId: orderId ?? this.orderId,
        dealId: dealId ?? this.dealId,
        departmentId: departmentId ?? this.departmentId,
        warehouseId: warehouseId ?? this.warehouseId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseExchangeExchangeContractResponse {
  WebApiModulesWarehouseExchangeExchangeContractResponse({
    this.contractId,
  });

  factory WebApiModulesWarehouseExchangeExchangeContractResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseExchangeExchangeContractResponseFromJson(json);

  @JsonKey(name: 'ContractId')
  final String? contractId;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseExchangeExchangeContractResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseExchangeExchangeContractResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseExchangeExchangeContractResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseExchangeExchangeContractResponse &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)));
  }
}

extension $WebApiModulesWarehouseExchangeExchangeContractResponseExtension
    on WebApiModulesWarehouseExchangeExchangeContractResponse {
  WebApiModulesWarehouseExchangeExchangeContractResponse copyWith(
      {String? contractId}) {
    return WebApiModulesWarehouseExchangeExchangeContractResponse(
        contractId: contractId ?? this.contractId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseExchangeExchangeItemInResponse {
  WebApiModulesWarehouseExchangeExchangeItemInResponse({
    this.contractId,
    this.inCode,
    this.quantity,
    this.orderId,
    this.orderNumber,
    this.orderDescription,
    this.dealId,
    this.deal,
    this.departmentId,
    this.itemStatus,
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesWarehouseExchangeExchangeItemInResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseExchangeExchangeItemInResponseFromJson(json);

  @JsonKey(name: 'ContractId')
  final String? contractId;
  @JsonKey(name: 'InCode')
  final String? inCode;
  @JsonKey(name: 'Quantity')
  final int? quantity;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderNumber')
  final String? orderNumber;
  @JsonKey(name: 'OrderDescription')
  final String? orderDescription;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'Deal')
  final String? deal;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'ItemStatus')
  final WebApiModulesWarehouseExchangeExchangeItemStatus? itemStatus;
  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseExchangeExchangeItemInResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseExchangeExchangeItemInResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseExchangeExchangeItemInResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseExchangeExchangeItemInResponse &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)) &&
            (identical(other.inCode, inCode) ||
                const DeepCollectionEquality().equals(other.inCode, inCode)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderNumber, orderNumber) ||
                const DeepCollectionEquality()
                    .equals(other.orderNumber, orderNumber)) &&
            (identical(other.orderDescription, orderDescription) ||
                const DeepCollectionEquality()
                    .equals(other.orderDescription, orderDescription)) &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.deal, deal) ||
                const DeepCollectionEquality().equals(other.deal, deal)) &&
            (identical(other.departmentId, departmentId) ||
                const DeepCollectionEquality()
                    .equals(other.departmentId, departmentId)) &&
            (identical(other.itemStatus, itemStatus) ||
                const DeepCollectionEquality()
                    .equals(other.itemStatus, itemStatus)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesWarehouseExchangeExchangeItemInResponseExtension
    on WebApiModulesWarehouseExchangeExchangeItemInResponse {
  WebApiModulesWarehouseExchangeExchangeItemInResponse copyWith(
      {String? contractId,
      String? inCode,
      int? quantity,
      String? orderId,
      String? orderNumber,
      String? orderDescription,
      String? dealId,
      String? deal,
      String? departmentId,
      WebApiModulesWarehouseExchangeExchangeItemStatus? itemStatus,
      int? status,
      bool? success,
      String? msg}) {
    return WebApiModulesWarehouseExchangeExchangeItemInResponse(
        contractId: contractId ?? this.contractId,
        inCode: inCode ?? this.inCode,
        quantity: quantity ?? this.quantity,
        orderId: orderId ?? this.orderId,
        orderNumber: orderNumber ?? this.orderNumber,
        orderDescription: orderDescription ?? this.orderDescription,
        dealId: dealId ?? this.dealId,
        deal: deal ?? this.deal,
        departmentId: departmentId ?? this.departmentId,
        itemStatus: itemStatus ?? this.itemStatus,
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseExchangeExchangeItemOutResponse {
  WebApiModulesWarehouseExchangeExchangeItemOutResponse({
    this.contractId,
    this.inCode,
    this.quantity,
    this.outCode,
    this.orderId,
    this.orderNumber,
    this.orderDescription,
    this.dealId,
    this.deal,
    this.departmentId,
    this.itemStatus,
    this.status,
    this.success,
    this.msg,
  });

  factory WebApiModulesWarehouseExchangeExchangeItemOutResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseExchangeExchangeItemOutResponseFromJson(json);

  @JsonKey(name: 'ContractId')
  final String? contractId;
  @JsonKey(name: 'InCode')
  final String? inCode;
  @JsonKey(name: 'Quantity')
  final int? quantity;
  @JsonKey(name: 'OutCode')
  final String? outCode;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderNumber')
  final String? orderNumber;
  @JsonKey(name: 'OrderDescription')
  final String? orderDescription;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'Deal')
  final String? deal;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'ItemStatus')
  final WebApiModulesWarehouseExchangeExchangeItemStatus? itemStatus;
  @JsonKey(name: 'status')
  final int? status;
  @JsonKey(name: 'success')
  final bool? success;
  @JsonKey(name: 'msg')
  final String? msg;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseExchangeExchangeItemOutResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseExchangeExchangeItemOutResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseExchangeExchangeItemOutResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseExchangeExchangeItemOutResponse &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)) &&
            (identical(other.inCode, inCode) ||
                const DeepCollectionEquality().equals(other.inCode, inCode)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)) &&
            (identical(other.outCode, outCode) ||
                const DeepCollectionEquality()
                    .equals(other.outCode, outCode)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderNumber, orderNumber) ||
                const DeepCollectionEquality()
                    .equals(other.orderNumber, orderNumber)) &&
            (identical(other.orderDescription, orderDescription) ||
                const DeepCollectionEquality()
                    .equals(other.orderDescription, orderDescription)) &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.deal, deal) ||
                const DeepCollectionEquality().equals(other.deal, deal)) &&
            (identical(other.departmentId, departmentId) ||
                const DeepCollectionEquality()
                    .equals(other.departmentId, departmentId)) &&
            (identical(other.itemStatus, itemStatus) ||
                const DeepCollectionEquality()
                    .equals(other.itemStatus, itemStatus)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.success, success) ||
                const DeepCollectionEquality()
                    .equals(other.success, success)) &&
            (identical(other.msg, msg) ||
                const DeepCollectionEquality().equals(other.msg, msg)));
  }
}

extension $WebApiModulesWarehouseExchangeExchangeItemOutResponseExtension
    on WebApiModulesWarehouseExchangeExchangeItemOutResponse {
  WebApiModulesWarehouseExchangeExchangeItemOutResponse copyWith(
      {String? contractId,
      String? inCode,
      int? quantity,
      String? outCode,
      String? orderId,
      String? orderNumber,
      String? orderDescription,
      String? dealId,
      String? deal,
      String? departmentId,
      WebApiModulesWarehouseExchangeExchangeItemStatus? itemStatus,
      int? status,
      bool? success,
      String? msg}) {
    return WebApiModulesWarehouseExchangeExchangeItemOutResponse(
        contractId: contractId ?? this.contractId,
        inCode: inCode ?? this.inCode,
        quantity: quantity ?? this.quantity,
        outCode: outCode ?? this.outCode,
        orderId: orderId ?? this.orderId,
        orderNumber: orderNumber ?? this.orderNumber,
        orderDescription: orderDescription ?? this.orderDescription,
        dealId: dealId ?? this.dealId,
        deal: deal ?? this.deal,
        departmentId: departmentId ?? this.departmentId,
        itemStatus: itemStatus ?? this.itemStatus,
        status: status ?? this.status,
        success: success ?? this.success,
        msg: msg ?? this.msg);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseExchangeExchangeItemRequest {
  WebApiModulesWarehouseExchangeExchangeItemRequest({
    this.contractId,
    this.orderId,
    this.dealId,
    this.departmentId,
    this.warehouseId,
    this.inCode,
    this.quantity,
    this.outCode,
    this.allowCrossICode,
    this.completingPending,
  });

  factory WebApiModulesWarehouseExchangeExchangeItemRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseExchangeExchangeItemRequestFromJson(json);

  @JsonKey(name: 'ContractId')
  final String? contractId;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'InCode')
  final String? inCode;
  @JsonKey(name: 'Quantity')
  final int? quantity;
  @JsonKey(name: 'OutCode')
  final String? outCode;
  @JsonKey(name: 'AllowCrossICode')
  final bool? allowCrossICode;
  @JsonKey(name: 'CompletingPending')
  final bool? completingPending;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseExchangeExchangeItemRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseExchangeExchangeItemRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseExchangeExchangeItemRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseExchangeExchangeItemRequest &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.dealId, dealId) ||
                const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.departmentId, departmentId) ||
                const DeepCollectionEquality()
                    .equals(other.departmentId, departmentId)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.inCode, inCode) ||
                const DeepCollectionEquality().equals(other.inCode, inCode)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)) &&
            (identical(other.outCode, outCode) ||
                const DeepCollectionEquality()
                    .equals(other.outCode, outCode)) &&
            (identical(other.allowCrossICode, allowCrossICode) ||
                const DeepCollectionEquality()
                    .equals(other.allowCrossICode, allowCrossICode)) &&
            (identical(other.completingPending, completingPending) ||
                const DeepCollectionEquality()
                    .equals(other.completingPending, completingPending)));
  }
}

extension $WebApiModulesWarehouseExchangeExchangeItemRequestExtension
    on WebApiModulesWarehouseExchangeExchangeItemRequest {
  WebApiModulesWarehouseExchangeExchangeItemRequest copyWith(
      {String? contractId,
      String? orderId,
      String? dealId,
      String? departmentId,
      String? warehouseId,
      String? inCode,
      int? quantity,
      String? outCode,
      bool? allowCrossICode,
      bool? completingPending}) {
    return WebApiModulesWarehouseExchangeExchangeItemRequest(
        contractId: contractId ?? this.contractId,
        orderId: orderId ?? this.orderId,
        dealId: dealId ?? this.dealId,
        departmentId: departmentId ?? this.departmentId,
        warehouseId: warehouseId ?? this.warehouseId,
        inCode: inCode ?? this.inCode,
        quantity: quantity ?? this.quantity,
        outCode: outCode ?? this.outCode,
        allowCrossICode: allowCrossICode ?? this.allowCrossICode,
        completingPending: completingPending ?? this.completingPending);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseExchangeExchangeItemStatus {
  WebApiModulesWarehouseExchangeExchangeItemStatus({
    this.inventoryId,
    this.iCode,
    this.availableFor,
    this.inventoryClass,
    this.description,
    this.warehouseId,
    this.warehouse,
    this.vendorId,
    this.vendor,
    this.purchaseOrderId,
    this.purchaseOrderNumber,
    this.consignorId,
    this.consignor,
  });

  factory WebApiModulesWarehouseExchangeExchangeItemStatus.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseExchangeExchangeItemStatusFromJson(json);

  @JsonKey(name: 'InventoryId')
  final String? inventoryId;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'AvailableFor')
  final String? availableFor;
  @JsonKey(name: 'InventoryClass')
  final String? inventoryClass;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'VendorId')
  final String? vendorId;
  @JsonKey(name: 'Vendor')
  final String? vendor;
  @JsonKey(name: 'PurchaseOrderId')
  final String? purchaseOrderId;
  @JsonKey(name: 'PurchaseOrderNumber')
  final String? purchaseOrderNumber;
  @JsonKey(name: 'ConsignorId')
  final String? consignorId;
  @JsonKey(name: 'Consignor')
  final String? consignor;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseExchangeExchangeItemStatusFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseExchangeExchangeItemStatusToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseExchangeExchangeItemStatusToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseExchangeExchangeItemStatus &&
            (identical(other.inventoryId, inventoryId) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryId, inventoryId)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.availableFor, availableFor) ||
                const DeepCollectionEquality()
                    .equals(other.availableFor, availableFor)) &&
            (identical(other.inventoryClass, inventoryClass) ||
                const DeepCollectionEquality()
                    .equals(other.inventoryClass, inventoryClass)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouse, warehouse) ||
                const DeepCollectionEquality()
                    .equals(other.warehouse, warehouse)) &&
            (identical(other.vendorId, vendorId) ||
                const DeepCollectionEquality()
                    .equals(other.vendorId, vendorId)) &&
            (identical(other.vendor, vendor) ||
                const DeepCollectionEquality().equals(other.vendor, vendor)) &&
            (identical(other.purchaseOrderId, purchaseOrderId) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderId, purchaseOrderId)) &&
            (identical(other.purchaseOrderNumber, purchaseOrderNumber) ||
                const DeepCollectionEquality()
                    .equals(other.purchaseOrderNumber, purchaseOrderNumber)) &&
            (identical(other.consignorId, consignorId) ||
                const DeepCollectionEquality()
                    .equals(other.consignorId, consignorId)) &&
            (identical(other.consignor, consignor) ||
                const DeepCollectionEquality()
                    .equals(other.consignor, consignor)));
  }
}

extension $WebApiModulesWarehouseExchangeExchangeItemStatusExtension
    on WebApiModulesWarehouseExchangeExchangeItemStatus {
  WebApiModulesWarehouseExchangeExchangeItemStatus copyWith(
      {String? inventoryId,
      String? iCode,
      String? availableFor,
      String? inventoryClass,
      String? description,
      String? warehouseId,
      String? warehouse,
      String? vendorId,
      String? vendor,
      String? purchaseOrderId,
      String? purchaseOrderNumber,
      String? consignorId,
      String? consignor}) {
    return WebApiModulesWarehouseExchangeExchangeItemStatus(
        inventoryId: inventoryId ?? this.inventoryId,
        iCode: iCode ?? this.iCode,
        availableFor: availableFor ?? this.availableFor,
        inventoryClass: inventoryClass ?? this.inventoryClass,
        description: description ?? this.description,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouse: warehouse ?? this.warehouse,
        vendorId: vendorId ?? this.vendorId,
        vendor: vendor ?? this.vendor,
        purchaseOrderId: purchaseOrderId ?? this.purchaseOrderId,
        purchaseOrderNumber: purchaseOrderNumber ?? this.purchaseOrderNumber,
        consignorId: consignorId ?? this.consignorId,
        consignor: consignor ?? this.consignor);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseOrderStatusStorageContainerGrid {
  WebApiModulesWarehouseOrderStatusStorageContainerGrid({
    this.storageContainerId,
    this.storageContainerItemId,
    this.description,
    this.pickUpLocation,
    this.storageContainerBarcode,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesWarehouseOrderStatusStorageContainerGrid.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseOrderStatusStorageContainerGridFromJson(json);

  @JsonKey(name: 'StorageContainerId')
  final int? storageContainerId;
  @JsonKey(name: 'StorageContainerItemId')
  final int? storageContainerItemId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'PickUpLocation')
  final String? pickUpLocation;
  @JsonKey(name: 'StorageContainerBarcode')
  final String? storageContainerBarcode;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseOrderStatusStorageContainerGridFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseOrderStatusStorageContainerGridToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseOrderStatusStorageContainerGridToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseOrderStatusStorageContainerGrid &&
            (identical(other.storageContainerId, storageContainerId) ||
                const DeepCollectionEquality()
                    .equals(other.storageContainerId, storageContainerId)) &&
            (identical(other.storageContainerItemId, storageContainerItemId) ||
                const DeepCollectionEquality().equals(
                    other.storageContainerItemId, storageContainerItemId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.pickUpLocation, pickUpLocation) ||
                const DeepCollectionEquality()
                    .equals(other.pickUpLocation, pickUpLocation)) &&
            (identical(
                    other.storageContainerBarcode, storageContainerBarcode) ||
                const DeepCollectionEquality().equals(
                    other.storageContainerBarcode, storageContainerBarcode)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesWarehouseOrderStatusStorageContainerGridExtension
    on WebApiModulesWarehouseOrderStatusStorageContainerGrid {
  WebApiModulesWarehouseOrderStatusStorageContainerGrid copyWith(
      {int? storageContainerId,
      int? storageContainerItemId,
      String? description,
      String? pickUpLocation,
      String? storageContainerBarcode,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesWarehouseOrderStatusStorageContainerGrid(
        storageContainerId: storageContainerId ?? this.storageContainerId,
        storageContainerItemId:
            storageContainerItemId ?? this.storageContainerItemId,
        description: description ?? this.description,
        pickUpLocation: pickUpLocation ?? this.pickUpLocation,
        storageContainerBarcode:
            storageContainerBarcode ?? this.storageContainerBarcode,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseOrderStatusStorageContainerItemsGrid {
  WebApiModulesWarehouseOrderStatusStorageContainerItemsGrid({
    this.storageContainerItemId,
    this.iCode,
    this.stagedBarcode,
    this.quantityOrdered,
    this.staged,
    this.orderBy,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesWarehouseOrderStatusStorageContainerItemsGrid.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseOrderStatusStorageContainerItemsGridFromJson(
          json);

  @JsonKey(name: 'StorageContainerItemId')
  final int? storageContainerItemId;
  @JsonKey(name: 'ICode')
  final String? iCode;
  @JsonKey(name: 'StagedBarcode')
  final String? stagedBarcode;
  @JsonKey(name: 'QuantityOrdered')
  final int? quantityOrdered;
  @JsonKey(name: 'Staged')
  final int? staged;
  @JsonKey(name: 'OrderBy')
  final String? orderBy;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseOrderStatusStorageContainerItemsGridFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseOrderStatusStorageContainerItemsGridToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseOrderStatusStorageContainerItemsGridToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseOrderStatusStorageContainerItemsGrid &&
            (identical(other.storageContainerItemId, storageContainerItemId) ||
                const DeepCollectionEquality().equals(
                    other.storageContainerItemId, storageContainerItemId)) &&
            (identical(other.iCode, iCode) ||
                const DeepCollectionEquality().equals(other.iCode, iCode)) &&
            (identical(other.stagedBarcode, stagedBarcode) ||
                const DeepCollectionEquality()
                    .equals(other.stagedBarcode, stagedBarcode)) &&
            (identical(other.quantityOrdered, quantityOrdered) ||
                const DeepCollectionEquality()
                    .equals(other.quantityOrdered, quantityOrdered)) &&
            (identical(other.staged, staged) ||
                const DeepCollectionEquality().equals(other.staged, staged)) &&
            (identical(other.orderBy, orderBy) ||
                const DeepCollectionEquality()
                    .equals(other.orderBy, orderBy)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesWarehouseOrderStatusStorageContainerItemsGridExtension
    on WebApiModulesWarehouseOrderStatusStorageContainerItemsGrid {
  WebApiModulesWarehouseOrderStatusStorageContainerItemsGrid copyWith(
      {int? storageContainerItemId,
      String? iCode,
      String? stagedBarcode,
      int? quantityOrdered,
      int? staged,
      String? orderBy,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesWarehouseOrderStatusStorageContainerItemsGrid(
        storageContainerItemId:
            storageContainerItemId ?? this.storageContainerItemId,
        iCode: iCode ?? this.iCode,
        stagedBarcode: stagedBarcode ?? this.stagedBarcode,
        quantityOrdered: quantityOrdered ?? this.quantityOrdered,
        staged: staged ?? this.staged,
        orderBy: orderBy ?? this.orderBy,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehousePickListPickList {
  WebApiModulesWarehousePickListPickList({
    this.pickListId,
    this.pickListNumber,
    this.pickType,
    this.pickDate,
    this.pickTime,
    this.status,
    this.completed,
    this.officeLocationId,
    this.departmentId,
    this.department,
    this.warehouseId,
    this.warehouseCode,
    this.warehouse,
    this.deliverType,
    this.deliverDate,
    this.deliverTime,
    this.orderId,
    this.orderNumber,
    this.orderDescription,
    this.orderType,
    this.submittedDate,
    this.submittedTime,
    this.submittedDateTime,
    this.orderedBy,
    this.orderedById,
    this.requestedBy,
    this.inputDate,
    this.inputTime,
    this.inputDateTime,
    this.totalItemQuantity,
    this.dealId,
    this.deal,
    this.agentId,
    this.agent,
    this.assignedToId,
    this.assignedTo,
    this.dueDate,
    this.dueTime,
    this.note,
    this.dateStamp,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesWarehousePickListPickList.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehousePickListPickListFromJson(json);

  @JsonKey(name: 'PickListId')
  final String? pickListId;
  @JsonKey(name: 'PickListNumber')
  final String? pickListNumber;
  @JsonKey(name: 'PickType')
  final String? pickType;
  @JsonKey(name: 'PickDate')
  final String? pickDate;
  @JsonKey(name: 'PickTime')
  final String? pickTime;
  @JsonKey(name: 'Status')
  final String? status;
  @JsonKey(name: 'Completed')
  final bool? completed;
  @JsonKey(name: 'OfficeLocationId')
  final String? officeLocationId;
  @JsonKey(name: 'DepartmentId')
  final String? departmentId;
  @JsonKey(name: 'Department')
  final String? department;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  @JsonKey(name: 'WarehouseCode')
  final String? warehouseCode;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'DeliverType')
  final String? deliverType;
  @JsonKey(name: 'DeliverDate')
  final String? deliverDate;
  @JsonKey(name: 'DeliverTime')
  final String? deliverTime;
  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'OrderNumber')
  final String? orderNumber;
  @JsonKey(name: 'OrderDescription')
  final String? orderDescription;
  @JsonKey(name: 'OrderType')
  final String? orderType;
  @JsonKey(name: 'SubmittedDate')
  final String? submittedDate;
  @JsonKey(name: 'SubmittedTime')
  final String? submittedTime;
  @JsonKey(name: 'SubmittedDateTime')
  final String? submittedDateTime;
  @JsonKey(name: 'OrderedBy')
  final String? orderedBy;
  @JsonKey(name: 'OrderedById')
  final String? orderedById;
  @JsonKey(name: 'RequestedBy')
  final String? requestedBy;
  @JsonKey(name: 'InputDate')
  final String? inputDate;
  @JsonKey(name: 'InputTime')
  final String? inputTime;
  @JsonKey(name: 'InputDateTime')
  final String? inputDateTime;
  @JsonKey(name: 'TotalItemQuantity')
  final int? totalItemQuantity;
  @JsonKey(name: 'DealId')
  final String? dealId;
  @JsonKey(name: 'Deal')
  final String? deal;
  @JsonKey(name: 'AgentId')
  final String? agentId;
  @JsonKey(name: 'Agent')
  final String? agent;
  @JsonKey(name: 'AssignedToId')
  final String? assignedToId;
  @JsonKey(name: 'AssignedTo')
  final String? assignedTo;
  @JsonKey(name: 'DueDate')
  final String? dueDate;
  @JsonKey(name: 'DueTime')
  final String? dueTime;
  @JsonKey(name: 'Note')
  final String? note;
  @JsonKey(name: 'DateStamp')
  final String? dateStamp;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesWarehousePickListPickListFromJson;
  static const toJsonFactory = _$WebApiModulesWarehousePickListPickListToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehousePickListPickListToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehousePickListPickList &&
            (identical(other.pickListId, pickListId) ||
                const DeepCollectionEquality()
                    .equals(other.pickListId, pickListId)) &&
            (identical(other.pickListNumber, pickListNumber) ||
                const DeepCollectionEquality()
                    .equals(other.pickListNumber, pickListNumber)) &&
            (identical(other.pickType, pickType) ||
                const DeepCollectionEquality()
                    .equals(other.pickType, pickType)) &&
            (identical(other.pickDate, pickDate) ||
                const DeepCollectionEquality()
                    .equals(other.pickDate, pickDate)) &&
            (identical(other.pickTime, pickTime) ||
                const DeepCollectionEquality()
                    .equals(other.pickTime, pickTime)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.completed, completed) ||
                const DeepCollectionEquality()
                    .equals(other.completed, completed)) &&
            (identical(other.officeLocationId, officeLocationId) ||
                const DeepCollectionEquality()
                    .equals(other.officeLocationId, officeLocationId)) &&
            (identical(other.departmentId, departmentId) ||
                const DeepCollectionEquality()
                    .equals(other.departmentId, departmentId)) &&
            (identical(other.department, department) ||
                const DeepCollectionEquality()
                    .equals(other.department, department)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)) &&
            (identical(other.warehouseCode, warehouseCode) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseCode, warehouseCode)) &&
            (identical(other.warehouse, warehouse) ||
                const DeepCollectionEquality()
                    .equals(other.warehouse, warehouse)) &&
            (identical(other.deliverType, deliverType) ||
                const DeepCollectionEquality()
                    .equals(other.deliverType, deliverType)) &&
            (identical(other.deliverDate, deliverDate) ||
                const DeepCollectionEquality()
                    .equals(other.deliverDate, deliverDate)) &&
            (identical(other.deliverTime, deliverTime) ||
                const DeepCollectionEquality()
                    .equals(other.deliverTime, deliverTime)) &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderNumber, orderNumber) ||
                const DeepCollectionEquality()
                    .equals(other.orderNumber, orderNumber)) &&
            (identical(other.orderDescription, orderDescription) ||
                const DeepCollectionEquality()
                    .equals(other.orderDescription, orderDescription)) &&
            (identical(other.orderType, orderType) ||
                const DeepCollectionEquality()
                    .equals(other.orderType, orderType)) &&
            (identical(other.submittedDate, submittedDate) ||
                const DeepCollectionEquality()
                    .equals(other.submittedDate, submittedDate)) &&
            (identical(other.submittedTime, submittedTime) ||
                const DeepCollectionEquality()
                    .equals(other.submittedTime, submittedTime)) &&
            (identical(other.submittedDateTime, submittedDateTime) || const DeepCollectionEquality().equals(other.submittedDateTime, submittedDateTime)) &&
            (identical(other.orderedBy, orderedBy) || const DeepCollectionEquality().equals(other.orderedBy, orderedBy)) &&
            (identical(other.orderedById, orderedById) || const DeepCollectionEquality().equals(other.orderedById, orderedById)) &&
            (identical(other.requestedBy, requestedBy) || const DeepCollectionEquality().equals(other.requestedBy, requestedBy)) &&
            (identical(other.inputDate, inputDate) || const DeepCollectionEquality().equals(other.inputDate, inputDate)) &&
            (identical(other.inputTime, inputTime) || const DeepCollectionEquality().equals(other.inputTime, inputTime)) &&
            (identical(other.inputDateTime, inputDateTime) || const DeepCollectionEquality().equals(other.inputDateTime, inputDateTime)) &&
            (identical(other.totalItemQuantity, totalItemQuantity) || const DeepCollectionEquality().equals(other.totalItemQuantity, totalItemQuantity)) &&
            (identical(other.dealId, dealId) || const DeepCollectionEquality().equals(other.dealId, dealId)) &&
            (identical(other.deal, deal) || const DeepCollectionEquality().equals(other.deal, deal)) &&
            (identical(other.agentId, agentId) || const DeepCollectionEquality().equals(other.agentId, agentId)) &&
            (identical(other.agent, agent) || const DeepCollectionEquality().equals(other.agent, agent)) &&
            (identical(other.assignedToId, assignedToId) || const DeepCollectionEquality().equals(other.assignedToId, assignedToId)) &&
            (identical(other.assignedTo, assignedTo) || const DeepCollectionEquality().equals(other.assignedTo, assignedTo)) &&
            (identical(other.dueDate, dueDate) || const DeepCollectionEquality().equals(other.dueDate, dueDate)) &&
            (identical(other.dueTime, dueTime) || const DeepCollectionEquality().equals(other.dueTime, dueTime)) &&
            (identical(other.note, note) || const DeepCollectionEquality().equals(other.note, note)) &&
            (identical(other.dateStamp, dateStamp) || const DeepCollectionEquality().equals(other.dateStamp, dateStamp)) &&
            (identical(other.recordTitle, recordTitle) || const DeepCollectionEquality().equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) || const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) || const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) || const DeepCollectionEquality().equals(other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesWarehousePickListPickListExtension
    on WebApiModulesWarehousePickListPickList {
  WebApiModulesWarehousePickListPickList copyWith(
      {String? pickListId,
      String? pickListNumber,
      String? pickType,
      String? pickDate,
      String? pickTime,
      String? status,
      bool? completed,
      String? officeLocationId,
      String? departmentId,
      String? department,
      String? warehouseId,
      String? warehouseCode,
      String? warehouse,
      String? deliverType,
      String? deliverDate,
      String? deliverTime,
      String? orderId,
      String? orderNumber,
      String? orderDescription,
      String? orderType,
      String? submittedDate,
      String? submittedTime,
      String? submittedDateTime,
      String? orderedBy,
      String? orderedById,
      String? requestedBy,
      String? inputDate,
      String? inputTime,
      String? inputDateTime,
      int? totalItemQuantity,
      String? dealId,
      String? deal,
      String? agentId,
      String? agent,
      String? assignedToId,
      String? assignedTo,
      String? dueDate,
      String? dueTime,
      String? note,
      String? dateStamp,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesWarehousePickListPickList(
        pickListId: pickListId ?? this.pickListId,
        pickListNumber: pickListNumber ?? this.pickListNumber,
        pickType: pickType ?? this.pickType,
        pickDate: pickDate ?? this.pickDate,
        pickTime: pickTime ?? this.pickTime,
        status: status ?? this.status,
        completed: completed ?? this.completed,
        officeLocationId: officeLocationId ?? this.officeLocationId,
        departmentId: departmentId ?? this.departmentId,
        department: department ?? this.department,
        warehouseId: warehouseId ?? this.warehouseId,
        warehouseCode: warehouseCode ?? this.warehouseCode,
        warehouse: warehouse ?? this.warehouse,
        deliverType: deliverType ?? this.deliverType,
        deliverDate: deliverDate ?? this.deliverDate,
        deliverTime: deliverTime ?? this.deliverTime,
        orderId: orderId ?? this.orderId,
        orderNumber: orderNumber ?? this.orderNumber,
        orderDescription: orderDescription ?? this.orderDescription,
        orderType: orderType ?? this.orderType,
        submittedDate: submittedDate ?? this.submittedDate,
        submittedTime: submittedTime ?? this.submittedTime,
        submittedDateTime: submittedDateTime ?? this.submittedDateTime,
        orderedBy: orderedBy ?? this.orderedBy,
        orderedById: orderedById ?? this.orderedById,
        requestedBy: requestedBy ?? this.requestedBy,
        inputDate: inputDate ?? this.inputDate,
        inputTime: inputTime ?? this.inputTime,
        inputDateTime: inputDateTime ?? this.inputDateTime,
        totalItemQuantity: totalItemQuantity ?? this.totalItemQuantity,
        dealId: dealId ?? this.dealId,
        deal: deal ?? this.deal,
        agentId: agentId ?? this.agentId,
        agent: agent ?? this.agent,
        assignedToId: assignedToId ?? this.assignedToId,
        assignedTo: assignedTo ?? this.assignedTo,
        dueDate: dueDate ?? this.dueDate,
        dueTime: dueTime ?? this.dueTime,
        note: note ?? this.note,
        dateStamp: dateStamp ?? this.dateStamp,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseQuikReceiptQuikReceiptGrid {
  WebApiModulesWarehouseQuikReceiptQuikReceiptGrid({
    this.quikReceiptId,
    this.receiptNumber,
    this.receiptStatus,
    this.receiptAsOfDate,
    this.receiptAsOfTime,
    this.note,
    this.recordTitle,
    this.fields,
    this.custom,
    this.defaultFieldAttributes,
  });

  factory WebApiModulesWarehouseQuikReceiptQuikReceiptGrid.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptGridFromJson(json);

  @JsonKey(name: 'QuikReceiptId')
  final int? quikReceiptId;
  @JsonKey(name: 'ReceiptNumber')
  final String? receiptNumber;
  @JsonKey(name: 'ReceiptStatus')
  final String? receiptStatus;
  @JsonKey(name: 'ReceiptAsOfDate')
  final FwStandardSqlServerFwDateTime? receiptAsOfDate;
  @JsonKey(name: 'ReceiptAsOfTime')
  final String? receiptAsOfTime;
  @JsonKey(name: 'Note')
  final String? note;
  @JsonKey(name: 'RecordTitle')
  final String? recordTitle;
  @JsonKey(
      name: '_Fields',
      defaultValue: <FwStandardBusinessLogicFwBusinessLogicFieldDefinition>[])
  final List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields;
  @JsonKey(name: '_Custom', defaultValue: <FwStandardDataFwCustomValue>[])
  final List<FwStandardDataFwCustomValue>? custom;
  @JsonKey(
      name: '_DefaultFieldAttributes',
      defaultValue: <FwStandardDataFwDefaultAttribute>[])
  final List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptGridFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptGridToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptGridToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseQuikReceiptQuikReceiptGrid &&
            (identical(other.quikReceiptId, quikReceiptId) ||
                const DeepCollectionEquality()
                    .equals(other.quikReceiptId, quikReceiptId)) &&
            (identical(other.receiptNumber, receiptNumber) ||
                const DeepCollectionEquality()
                    .equals(other.receiptNumber, receiptNumber)) &&
            (identical(other.receiptStatus, receiptStatus) ||
                const DeepCollectionEquality()
                    .equals(other.receiptStatus, receiptStatus)) &&
            (identical(other.receiptAsOfDate, receiptAsOfDate) ||
                const DeepCollectionEquality()
                    .equals(other.receiptAsOfDate, receiptAsOfDate)) &&
            (identical(other.receiptAsOfTime, receiptAsOfTime) ||
                const DeepCollectionEquality()
                    .equals(other.receiptAsOfTime, receiptAsOfTime)) &&
            (identical(other.note, note) ||
                const DeepCollectionEquality().equals(other.note, note)) &&
            (identical(other.recordTitle, recordTitle) ||
                const DeepCollectionEquality()
                    .equals(other.recordTitle, recordTitle)) &&
            (identical(other.fields, fields) ||
                const DeepCollectionEquality().equals(other.fields, fields)) &&
            (identical(other.custom, custom) ||
                const DeepCollectionEquality().equals(other.custom, custom)) &&
            (identical(other.defaultFieldAttributes, defaultFieldAttributes) ||
                const DeepCollectionEquality().equals(
                    other.defaultFieldAttributes, defaultFieldAttributes)));
  }
}

extension $WebApiModulesWarehouseQuikReceiptQuikReceiptGridExtension
    on WebApiModulesWarehouseQuikReceiptQuikReceiptGrid {
  WebApiModulesWarehouseQuikReceiptQuikReceiptGrid copyWith(
      {int? quikReceiptId,
      String? receiptNumber,
      String? receiptStatus,
      FwStandardSqlServerFwDateTime? receiptAsOfDate,
      String? receiptAsOfTime,
      String? note,
      String? recordTitle,
      List<FwStandardBusinessLogicFwBusinessLogicFieldDefinition>? fields,
      List<FwStandardDataFwCustomValue>? custom,
      List<FwStandardDataFwDefaultAttribute>? defaultFieldAttributes}) {
    return WebApiModulesWarehouseQuikReceiptQuikReceiptGrid(
        quikReceiptId: quikReceiptId ?? this.quikReceiptId,
        receiptNumber: receiptNumber ?? this.receiptNumber,
        receiptStatus: receiptStatus ?? this.receiptStatus,
        receiptAsOfDate: receiptAsOfDate ?? this.receiptAsOfDate,
        receiptAsOfTime: receiptAsOfTime ?? this.receiptAsOfTime,
        note: note ?? this.note,
        recordTitle: recordTitle ?? this.recordTitle,
        fields: fields ?? this.fields,
        custom: custom ?? this.custom,
        defaultFieldAttributes:
            defaultFieldAttributes ?? this.defaultFieldAttributes);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseQuikReceiptQuikReceiptItemRecord {
  WebApiModulesWarehouseQuikReceiptQuikReceiptItemRecord({
    this.quikReceiptItemId,
    this.description,
    this.quantity,
    this.originalValue,
  });

  factory WebApiModulesWarehouseQuikReceiptQuikReceiptItemRecord.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptItemRecordFromJson(json);

  @JsonKey(name: 'QuikReceiptItemId')
  final String? quikReceiptItemId;
  @JsonKey(name: 'Description')
  final String? description;
  @JsonKey(name: 'Quantity')
  final String? quantity;
  @JsonKey(name: 'OriginalValue')
  final String? originalValue;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptItemRecordFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptItemRecordToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptItemRecordToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseQuikReceiptQuikReceiptItemRecord &&
            (identical(other.quikReceiptItemId, quikReceiptItemId) ||
                const DeepCollectionEquality()
                    .equals(other.quikReceiptItemId, quikReceiptItemId)) &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)) &&
            (identical(other.originalValue, originalValue) ||
                const DeepCollectionEquality()
                    .equals(other.originalValue, originalValue)));
  }
}

extension $WebApiModulesWarehouseQuikReceiptQuikReceiptItemRecordExtension
    on WebApiModulesWarehouseQuikReceiptQuikReceiptItemRecord {
  WebApiModulesWarehouseQuikReceiptQuikReceiptItemRecord copyWith(
      {String? quikReceiptItemId,
      String? description,
      String? quantity,
      String? originalValue}) {
    return WebApiModulesWarehouseQuikReceiptQuikReceiptItemRecord(
        quikReceiptItemId: quikReceiptItemId ?? this.quikReceiptItemId,
        description: description ?? this.description,
        quantity: quantity ?? this.quantity,
        originalValue: originalValue ?? this.originalValue);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseQuikReceiptQuikReceiptItemRequest {
  WebApiModulesWarehouseQuikReceiptQuikReceiptItemRequest({
    this.quikReceiptId,
  });

  factory WebApiModulesWarehouseQuikReceiptQuikReceiptItemRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptItemRequestFromJson(json);

  @JsonKey(name: 'QuikReceiptId')
  final int? quikReceiptId;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptItemRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptItemRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptItemRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseQuikReceiptQuikReceiptItemRequest &&
            (identical(other.quikReceiptId, quikReceiptId) ||
                const DeepCollectionEquality()
                    .equals(other.quikReceiptId, quikReceiptId)));
  }
}

extension $WebApiModulesWarehouseQuikReceiptQuikReceiptItemRequestExtension
    on WebApiModulesWarehouseQuikReceiptQuikReceiptItemRequest {
  WebApiModulesWarehouseQuikReceiptQuikReceiptItemRequest copyWith(
      {int? quikReceiptId}) {
    return WebApiModulesWarehouseQuikReceiptQuikReceiptItemRequest(
        quikReceiptId: quikReceiptId ?? this.quikReceiptId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseQuikReceiptQuikReceiptItemResponse {
  WebApiModulesWarehouseQuikReceiptQuikReceiptItemResponse({
    this.items,
  });

  factory WebApiModulesWarehouseQuikReceiptQuikReceiptItemResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptItemResponseFromJson(json);

  @JsonKey(
      name: 'Items',
      defaultValue: <WebApiModulesWarehouseQuikReceiptQuikReceiptItemRecord>[])
  final List<WebApiModulesWarehouseQuikReceiptQuikReceiptItemRecord>? items;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptItemResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptItemResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptItemResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseQuikReceiptQuikReceiptItemResponse &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)));
  }
}

extension $WebApiModulesWarehouseQuikReceiptQuikReceiptItemResponseExtension
    on WebApiModulesWarehouseQuikReceiptQuikReceiptItemResponse {
  WebApiModulesWarehouseQuikReceiptQuikReceiptItemResponse copyWith(
      {List<WebApiModulesWarehouseQuikReceiptQuikReceiptItemRecord>? items}) {
    return WebApiModulesWarehouseQuikReceiptQuikReceiptItemResponse(
        items: items ?? this.items);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseQuikReceiptQuikReceiptSaveRequest {
  WebApiModulesWarehouseQuikReceiptQuikReceiptSaveRequest({
    this.quikReceiptId,
    this.note,
    this.personPrintName,
    this.quikReceiptItems,
  });

  factory WebApiModulesWarehouseQuikReceiptQuikReceiptSaveRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSaveRequestFromJson(json);

  @JsonKey(name: 'QuikReceiptId')
  final int? quikReceiptId;
  @JsonKey(name: 'Note')
  final String? note;
  @JsonKey(name: 'PersonPrintName')
  final String? personPrintName;
  @JsonKey(
      name: 'QuikReceiptItems',
      defaultValue: <WebApiModulesWarehouseQuikReceiptQuikReceiptItemRecord>[])
  final List<WebApiModulesWarehouseQuikReceiptQuikReceiptItemRecord>?
      quikReceiptItems;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSaveRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSaveRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSaveRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseQuikReceiptQuikReceiptSaveRequest &&
            (identical(other.quikReceiptId, quikReceiptId) ||
                const DeepCollectionEquality()
                    .equals(other.quikReceiptId, quikReceiptId)) &&
            (identical(other.note, note) ||
                const DeepCollectionEquality().equals(other.note, note)) &&
            (identical(other.personPrintName, personPrintName) ||
                const DeepCollectionEquality()
                    .equals(other.personPrintName, personPrintName)) &&
            (identical(other.quikReceiptItems, quikReceiptItems) ||
                const DeepCollectionEquality()
                    .equals(other.quikReceiptItems, quikReceiptItems)));
  }
}

extension $WebApiModulesWarehouseQuikReceiptQuikReceiptSaveRequestExtension
    on WebApiModulesWarehouseQuikReceiptQuikReceiptSaveRequest {
  WebApiModulesWarehouseQuikReceiptQuikReceiptSaveRequest copyWith(
      {int? quikReceiptId,
      String? note,
      String? personPrintName,
      List<WebApiModulesWarehouseQuikReceiptQuikReceiptItemRecord>?
          quikReceiptItems}) {
    return WebApiModulesWarehouseQuikReceiptQuikReceiptSaveRequest(
        quikReceiptId: quikReceiptId ?? this.quikReceiptId,
        note: note ?? this.note,
        personPrintName: personPrintName ?? this.personPrintName,
        quikReceiptItems: quikReceiptItems ?? this.quikReceiptItems);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseQuikReceiptQuikReceiptSaveResponse {
  WebApiModulesWarehouseQuikReceiptQuikReceiptSaveResponse({
    this.status,
    this.message,
  });

  factory WebApiModulesWarehouseQuikReceiptQuikReceiptSaveResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSaveResponseFromJson(json);

  @JsonKey(name: 'Status')
  final int? status;
  @JsonKey(name: 'Message')
  final String? message;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSaveResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSaveResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSaveResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseQuikReceiptQuikReceiptSaveResponse &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality().equals(other.message, message)));
  }
}

extension $WebApiModulesWarehouseQuikReceiptQuikReceiptSaveResponseExtension
    on WebApiModulesWarehouseQuikReceiptQuikReceiptSaveResponse {
  WebApiModulesWarehouseQuikReceiptQuikReceiptSaveResponse copyWith(
      {int? status, String? message}) {
    return WebApiModulesWarehouseQuikReceiptQuikReceiptSaveResponse(
        status: status ?? this.status, message: message ?? this.message);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseQuikReceiptQuikReceiptSessionRequest {
  WebApiModulesWarehouseQuikReceiptQuikReceiptSessionRequest({
    this.barcode,
    this.sessionJoinNew,
    this.contractId,
  });

  factory WebApiModulesWarehouseQuikReceiptQuikReceiptSessionRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSessionRequestFromJson(
          json);

  @JsonKey(name: 'Barcode')
  final String? barcode;
  @JsonKey(name: 'SessionJoinNew')
  final String? sessionJoinNew;
  @JsonKey(name: 'ContractId')
  final String? contractId;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSessionRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSessionRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSessionRequestToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseQuikReceiptQuikReceiptSessionRequest &&
            (identical(other.barcode, barcode) ||
                const DeepCollectionEquality()
                    .equals(other.barcode, barcode)) &&
            (identical(other.sessionJoinNew, sessionJoinNew) ||
                const DeepCollectionEquality()
                    .equals(other.sessionJoinNew, sessionJoinNew)) &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)));
  }
}

extension $WebApiModulesWarehouseQuikReceiptQuikReceiptSessionRequestExtension
    on WebApiModulesWarehouseQuikReceiptQuikReceiptSessionRequest {
  WebApiModulesWarehouseQuikReceiptQuikReceiptSessionRequest copyWith(
      {String? barcode, String? sessionJoinNew, String? contractId}) {
    return WebApiModulesWarehouseQuikReceiptQuikReceiptSessionRequest(
        barcode: barcode ?? this.barcode,
        sessionJoinNew: sessionJoinNew ?? this.sessionJoinNew,
        contractId: contractId ?? this.contractId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseQuikReceiptQuikReceiptSessionResponse {
  WebApiModulesWarehouseQuikReceiptQuikReceiptSessionResponse({
    this.orderId,
    this.orderdescription,
    this.contractId,
    this.inSessionNumber,
    this.qrSessionNumber,
    this.quikReceiptId,
    this.status,
    this.message,
  });

  factory WebApiModulesWarehouseQuikReceiptQuikReceiptSessionResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSessionResponseFromJson(
          json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'Orderdescription')
  final String? orderdescription;
  @JsonKey(name: 'ContractId')
  final String? contractId;
  @JsonKey(name: 'InSessionNumber')
  final int? inSessionNumber;
  @JsonKey(name: 'QrSessionNumber')
  final int? qrSessionNumber;
  @JsonKey(name: 'QuikReceiptId')
  final int? quikReceiptId;
  @JsonKey(name: 'Status')
  final int? status;
  @JsonKey(name: 'Message')
  final String? message;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSessionResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSessionResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSessionResponseToJson(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseQuikReceiptQuikReceiptSessionResponse &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.orderdescription, orderdescription) ||
                const DeepCollectionEquality()
                    .equals(other.orderdescription, orderdescription)) &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)) &&
            (identical(other.inSessionNumber, inSessionNumber) ||
                const DeepCollectionEquality()
                    .equals(other.inSessionNumber, inSessionNumber)) &&
            (identical(other.qrSessionNumber, qrSessionNumber) ||
                const DeepCollectionEquality()
                    .equals(other.qrSessionNumber, qrSessionNumber)) &&
            (identical(other.quikReceiptId, quikReceiptId) ||
                const DeepCollectionEquality()
                    .equals(other.quikReceiptId, quikReceiptId)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.message, message) ||
                const DeepCollectionEquality().equals(other.message, message)));
  }
}

extension $WebApiModulesWarehouseQuikReceiptQuikReceiptSessionResponseExtension
    on WebApiModulesWarehouseQuikReceiptQuikReceiptSessionResponse {
  WebApiModulesWarehouseQuikReceiptQuikReceiptSessionResponse copyWith(
      {String? orderId,
      String? orderdescription,
      String? contractId,
      int? inSessionNumber,
      int? qrSessionNumber,
      int? quikReceiptId,
      int? status,
      String? message}) {
    return WebApiModulesWarehouseQuikReceiptQuikReceiptSessionResponse(
        orderId: orderId ?? this.orderId,
        orderdescription: orderdescription ?? this.orderdescription,
        contractId: contractId ?? this.contractId,
        inSessionNumber: inSessionNumber ?? this.inSessionNumber,
        qrSessionNumber: qrSessionNumber ?? this.qrSessionNumber,
        quikReceiptId: quikReceiptId ?? this.quikReceiptId,
        status: status ?? this.status,
        message: message ?? this.message);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveRequest {
  WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveRequest({
    this.quikReceiptId,
    this.signatureImage,
  });

  factory WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveRequestFromJson(
          json);

  @JsonKey(name: 'QuikReceiptId')
  final String? quikReceiptId;
  @JsonKey(name: 'SignatureImage')
  final String? signatureImage;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveRequest &&
            (identical(other.quikReceiptId, quikReceiptId) ||
                const DeepCollectionEquality()
                    .equals(other.quikReceiptId, quikReceiptId)) &&
            (identical(other.signatureImage, signatureImage) ||
                const DeepCollectionEquality()
                    .equals(other.signatureImage, signatureImage)));
  }
}

extension $WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveRequestExtension
    on WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveRequest {
  WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveRequest copyWith(
      {String? quikReceiptId, String? signatureImage}) {
    return WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveRequest(
        quikReceiptId: quikReceiptId ?? this.quikReceiptId,
        signatureImage: signatureImage ?? this.signatureImage);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveResponse {
  WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveResponse({
    this.appImageId,
    this.status,
  });

  factory WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveResponseFromJson(
          json);

  @JsonKey(name: 'AppImageId')
  final String? appImageId;
  @JsonKey(name: 'Status')
  final int? status;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveResponse &&
            (identical(other.appImageId, appImageId) ||
                const DeepCollectionEquality()
                    .equals(other.appImageId, appImageId)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)));
  }
}

extension $WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveResponseExtension
    on WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveResponse {
  WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveResponse copyWith(
      {String? appImageId, int? status}) {
    return WebApiModulesWarehouseQuikReceiptQuikReceiptSignatureSaveResponse(
        appImageId: appImageId ?? this.appImageId,
        status: status ?? this.status);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRecord {
  WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRecord({
    this.orderNo,
    this.deal,
    this.warehouse,
    this.receiptNumber,
    this.receiptStatus,
    this.contractId,
    this.checkinSessionDate,
    this.asOfDate,
    this.asOfTime,
    this.checkinSessionStatus,
    this.checkinSessionNo,
    this.owner,
    this.orderDescription,
    this.note,
    this.quikReceiptId,
  });

  factory WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRecord.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRecordFromJson(
          json);

  @JsonKey(name: 'OrderNo')
  final String? orderNo;
  @JsonKey(name: 'Deal')
  final String? deal;
  @JsonKey(name: 'Warehouse')
  final String? warehouse;
  @JsonKey(name: 'ReceiptNumber')
  final int? receiptNumber;
  @JsonKey(name: 'ReceiptStatus')
  final String? receiptStatus;
  @JsonKey(name: 'ContractId')
  final String? contractId;
  @JsonKey(name: 'CheckinSessionDate')
  final String? checkinSessionDate;
  @JsonKey(name: 'AsOfDate')
  final String? asOfDate;
  @JsonKey(name: 'AsOfTime')
  final String? asOfTime;
  @JsonKey(name: 'CheckinSessionStatus')
  final String? checkinSessionStatus;
  @JsonKey(name: 'CheckinSessionNo')
  final int? checkinSessionNo;
  @JsonKey(name: 'Owner')
  final String? owner;
  @JsonKey(name: 'OrderDescription')
  final String? orderDescription;
  @JsonKey(name: 'Note')
  final String? note;
  @JsonKey(name: 'QuikReceiptId')
  final int? quikReceiptId;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRecordFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRecordToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRecordToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRecord &&
            (identical(other.orderNo, orderNo) ||
                const DeepCollectionEquality()
                    .equals(other.orderNo, orderNo)) &&
            (identical(other.deal, deal) ||
                const DeepCollectionEquality().equals(other.deal, deal)) &&
            (identical(other.warehouse, warehouse) ||
                const DeepCollectionEquality()
                    .equals(other.warehouse, warehouse)) &&
            (identical(other.receiptNumber, receiptNumber) ||
                const DeepCollectionEquality()
                    .equals(other.receiptNumber, receiptNumber)) &&
            (identical(other.receiptStatus, receiptStatus) ||
                const DeepCollectionEquality()
                    .equals(other.receiptStatus, receiptStatus)) &&
            (identical(other.contractId, contractId) ||
                const DeepCollectionEquality()
                    .equals(other.contractId, contractId)) &&
            (identical(other.checkinSessionDate, checkinSessionDate) ||
                const DeepCollectionEquality()
                    .equals(other.checkinSessionDate, checkinSessionDate)) &&
            (identical(other.asOfDate, asOfDate) ||
                const DeepCollectionEquality()
                    .equals(other.asOfDate, asOfDate)) &&
            (identical(other.asOfTime, asOfTime) ||
                const DeepCollectionEquality()
                    .equals(other.asOfTime, asOfTime)) &&
            (identical(other.checkinSessionStatus, checkinSessionStatus) ||
                const DeepCollectionEquality().equals(
                    other.checkinSessionStatus, checkinSessionStatus)) &&
            (identical(other.checkinSessionNo, checkinSessionNo) ||
                const DeepCollectionEquality()
                    .equals(other.checkinSessionNo, checkinSessionNo)) &&
            (identical(other.owner, owner) ||
                const DeepCollectionEquality().equals(other.owner, owner)) &&
            (identical(other.orderDescription, orderDescription) ||
                const DeepCollectionEquality()
                    .equals(other.orderDescription, orderDescription)) &&
            (identical(other.note, note) ||
                const DeepCollectionEquality().equals(other.note, note)) &&
            (identical(other.quikReceiptId, quikReceiptId) ||
                const DeepCollectionEquality()
                    .equals(other.quikReceiptId, quikReceiptId)));
  }
}

extension $WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRecordExtension
    on WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRecord {
  WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRecord copyWith(
      {String? orderNo,
      String? deal,
      String? warehouse,
      int? receiptNumber,
      String? receiptStatus,
      String? contractId,
      String? checkinSessionDate,
      String? asOfDate,
      String? asOfTime,
      String? checkinSessionStatus,
      int? checkinSessionNo,
      String? owner,
      String? orderDescription,
      String? note,
      int? quikReceiptId}) {
    return WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRecord(
        orderNo: orderNo ?? this.orderNo,
        deal: deal ?? this.deal,
        warehouse: warehouse ?? this.warehouse,
        receiptNumber: receiptNumber ?? this.receiptNumber,
        receiptStatus: receiptStatus ?? this.receiptStatus,
        contractId: contractId ?? this.contractId,
        checkinSessionDate: checkinSessionDate ?? this.checkinSessionDate,
        asOfDate: asOfDate ?? this.asOfDate,
        asOfTime: asOfTime ?? this.asOfTime,
        checkinSessionStatus: checkinSessionStatus ?? this.checkinSessionStatus,
        checkinSessionNo: checkinSessionNo ?? this.checkinSessionNo,
        owner: owner ?? this.owner,
        orderDescription: orderDescription ?? this.orderDescription,
        note: note ?? this.note,
        quikReceiptId: quikReceiptId ?? this.quikReceiptId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRequest {
  WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRequest({
    this.orderId,
    this.receiptsOnly,
    this.warehouseId,
  });

  factory WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRequest.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRequestFromJson(
          json);

  @JsonKey(name: 'OrderId')
  final String? orderId;
  @JsonKey(name: 'ReceiptsOnly')
  final bool? receiptsOnly;
  @JsonKey(name: 'WarehouseId')
  final String? warehouseId;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRequestFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRequestToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRequestToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRequest &&
            (identical(other.orderId, orderId) ||
                const DeepCollectionEquality()
                    .equals(other.orderId, orderId)) &&
            (identical(other.receiptsOnly, receiptsOnly) ||
                const DeepCollectionEquality()
                    .equals(other.receiptsOnly, receiptsOnly)) &&
            (identical(other.warehouseId, warehouseId) ||
                const DeepCollectionEquality()
                    .equals(other.warehouseId, warehouseId)));
  }
}

extension $WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRequestExtension
    on WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRequest {
  WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRequest copyWith(
      {String? orderId, bool? receiptsOnly, String? warehouseId}) {
    return WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRequest(
        orderId: orderId ?? this.orderId,
        receiptsOnly: receiptsOnly ?? this.receiptsOnly,
        warehouseId: warehouseId ?? this.warehouseId);
  }
}

@JsonSerializable(explicitToJson: true)
class WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionsResponse {
  WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionsResponse({
    this.sessions,
  });

  factory WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionsResponse.fromJson(
          Map<String, dynamic> json) =>
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionsResponseFromJson(
          json);

  @JsonKey(name: 'Sessions', defaultValue: <
      WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRecord>[])
  final List<
          WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRecord>?
      sessions;
  static const fromJsonFactory =
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionsResponseFromJson;
  static const toJsonFactory =
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionsResponseToJson;
  Map<String, dynamic> toJson() =>
      _$WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionsResponseToJson(
          this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionsResponse &&
            (identical(other.sessions, sessions) ||
                const DeepCollectionEquality()
                    .equals(other.sessions, sessions)));
  }
}

extension $WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionsResponseExtension
    on WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionsResponse {
  WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionsResponse copyWith(
      {List<WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionRecord>?
          sessions}) {
    return WebApiModulesWarehouseQuikReceiptQuikReceiptSuspendedSessionsResponse(
        sessions: sessions ?? this.sessions);
  }
}

String? fwStandardSqlServerFwDataTypesToJson(
    enums.FwStandardSqlServerFwDataTypes? fwStandardSqlServerFwDataTypes) {
  return enums
      .$FwStandardSqlServerFwDataTypesMap[fwStandardSqlServerFwDataTypes];
}

enums.FwStandardSqlServerFwDataTypes fwStandardSqlServerFwDataTypesFromJson(
    String? fwStandardSqlServerFwDataTypes) {
  if (fwStandardSqlServerFwDataTypes == null) {
    return enums.FwStandardSqlServerFwDataTypes.swaggerGeneratedUnknown;
  }

  return enums.$FwStandardSqlServerFwDataTypesMap.entries
      .firstWhere(
          (element) =>
              element.value.toLowerCase() ==
              fwStandardSqlServerFwDataTypes.toLowerCase(),
          orElse: () => const MapEntry(
              enums.FwStandardSqlServerFwDataTypes.swaggerGeneratedUnknown, ''))
      .key;
}

List<String> fwStandardSqlServerFwDataTypesListToJson(
    List<enums.FwStandardSqlServerFwDataTypes>?
        fwStandardSqlServerFwDataTypes) {
  if (fwStandardSqlServerFwDataTypes == null) {
    return [];
  }

  return fwStandardSqlServerFwDataTypes
      .map((e) => enums.$FwStandardSqlServerFwDataTypesMap[e]!)
      .toList();
}

List<enums.FwStandardSqlServerFwDataTypes>
    fwStandardSqlServerFwDataTypesListFromJson(
        List? fwStandardSqlServerFwDataTypes) {
  if (fwStandardSqlServerFwDataTypes == null) {
    return [];
  }

  return fwStandardSqlServerFwDataTypes
      .map((e) => fwStandardSqlServerFwDataTypesFromJson(e.toString()))
      .toList();
}

String? webApiModulesPluginsProcessCreditCardProcessCreditCardPaymentCardTypesToJson(
    enums.WebApiModulesPluginsProcessCreditCardProcessCreditCardPaymentCardTypes?
        webApiModulesPluginsProcessCreditCardProcessCreditCardPaymentCardTypes) {
  return enums
          .$WebApiModulesPluginsProcessCreditCardProcessCreditCardPaymentCardTypesMap[
      webApiModulesPluginsProcessCreditCardProcessCreditCardPaymentCardTypes];
}

enums.WebApiModulesPluginsProcessCreditCardProcessCreditCardPaymentCardTypes
    webApiModulesPluginsProcessCreditCardProcessCreditCardPaymentCardTypesFromJson(
        String?
            webApiModulesPluginsProcessCreditCardProcessCreditCardPaymentCardTypes) {
  if (webApiModulesPluginsProcessCreditCardProcessCreditCardPaymentCardTypes ==
      null) {
    return enums
        .WebApiModulesPluginsProcessCreditCardProcessCreditCardPaymentCardTypes
        .swaggerGeneratedUnknown;
  }

  return enums
      .$WebApiModulesPluginsProcessCreditCardProcessCreditCardPaymentCardTypesMap
      .entries
      .firstWhere(
          (element) =>
              element.value.toLowerCase() ==
              webApiModulesPluginsProcessCreditCardProcessCreditCardPaymentCardTypes
                  .toLowerCase(),
          orElse: () => const MapEntry(
              enums
                  .WebApiModulesPluginsProcessCreditCardProcessCreditCardPaymentCardTypes
                  .swaggerGeneratedUnknown,
              ''))
      .key;
}

List<String>
    webApiModulesPluginsProcessCreditCardProcessCreditCardPaymentCardTypesListToJson(
        List<enums.WebApiModulesPluginsProcessCreditCardProcessCreditCardPaymentCardTypes>?
            webApiModulesPluginsProcessCreditCardProcessCreditCardPaymentCardTypes) {
  if (webApiModulesPluginsProcessCreditCardProcessCreditCardPaymentCardTypes ==
      null) {
    return [];
  }

  return webApiModulesPluginsProcessCreditCardProcessCreditCardPaymentCardTypes
      .map((e) => enums
          .$WebApiModulesPluginsProcessCreditCardProcessCreditCardPaymentCardTypesMap[e]!)
      .toList();
}

List<enums.WebApiModulesPluginsProcessCreditCardProcessCreditCardPaymentCardTypes>
    webApiModulesPluginsProcessCreditCardProcessCreditCardPaymentCardTypesListFromJson(
        List?
            webApiModulesPluginsProcessCreditCardProcessCreditCardPaymentCardTypes) {
  if (webApiModulesPluginsProcessCreditCardProcessCreditCardPaymentCardTypes ==
      null) {
    return [];
  }

  return webApiModulesPluginsProcessCreditCardProcessCreditCardPaymentCardTypes
      .map((e) =>
          webApiModulesPluginsProcessCreditCardProcessCreditCardPaymentCardTypesFromJson(
              e.toString()))
      .toList();
}

typedef JsonFactory<T> = T Function(Map<String, dynamic> json);

class CustomJsonDecoder {
  CustomJsonDecoder(this.factories);

  final Map<Type, JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class JsonSerializableConverter extends chopper.JsonConverter {
  @override
  chopper.Response<ResultType> convertResponse<ResultType, Item>(
      chopper.Response response) {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final jsonDecoder = CustomJsonDecoder(HomeJsonDecoderMappings);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}
